// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.


// Take the name prefix into account.
#define yylex   XyceDevicelex

// First part of user prologue.
#line 25 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"


#include <Xyce_config.h>

#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdlib>
#include <string>
#include <map>
#include <vector>
#include "location.hh"
#include "position.hh"
#include <N_ERH_Message.h>
#include <N_DEV_Specie.h>
#include <N_DEV_ReactionNetwork.h>

namespace Xyce {
namespace Device {
class ReactionLexer;
}}

#line 66 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"


#include "N_DEV_ReactionParser.hxx"

// Second part of user prologue.
#line 71 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"

  // WARNING!!!!  The stuff in this block is the "post-prologue" that
  // in versions of Bison prior to 2.3 used to be placed into the .hxx
  // file generated by bison, and which we could therefore just include
  // to get the right stuff.
  // In version 2.3 they stopped doing that and started putting the
  // post-prologue code directly into the generated .cxx file, which means
  // that we need to DUPLICATE this block of code in N_DEV_ReactionNetwork.C.
  // If you change *ANYTHING* in this post-prologue, you MUST edit
  // N_DEV_ReactionNetwork.C and keep it in sync with the changes in this
  // block!
  // Note also that this was absolutely critical to do in Bison 2.3, and
  // somehow didn't seem to matter much just a few releases of bison later.
  // Careless hacking of this block *could* break compatibility of Xyce with
  // older versions of Bison and go unnoticed in testing.  Please be careful.
#undef yyFlexLexer
  /* CAREFUL watch continuations! */
#define YY_DECL \
int ReactionLexer::getToken(ReactionParser::semantic_type *lvalp,  \
                            location *llocp, \
                            std::map<std::string, int> &theSpeciesIDs)

  // YECH!  Work around very stupid way that multiple parsers/lexers are 
  // handled.
  // Bison's "%name-prefix" is implemented as a #define yylex "prefix"lex
  // which BREAKS flex's C++ lexer: it contains a method "yylex" in the
  // yyFlexLexer class.  Unless we do this kludge, that method gets renamed
  // with the define as well, and the result is a broken set of classes
#undef yylex
#include <FlexLexer.h>
#include <N_DEV_ReactionLexer.h>
  // undo that kludge.  Note that because of this stupidity, if the 
  // "%name-prefix" is changed, this line needs to be changed, too.
#define yylex XyceDevicelex


int XyceDevicelex(XyceDevice::ReactionParser::semantic_type *lvalp, XyceDevice::location *locp,
             Xyce::Device::ReactionLexer *theLexer, std::map<std::string, int> &theSpeciesIDs);


#line 113 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"



#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if XYCEDEVICEDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !XYCEDEVICEDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !XYCEDEVICEDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace XyceDevice {
#line 206 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"

  /// Build a parser object.
  ReactionParser::ReactionParser (Xyce::Device::ReactionLexer *theLexer_yyarg, std::map<std::string, int> &theSpeciesIDs_yyarg, Xyce::Device::ReactionNetwork &theReactionNetwork_yyarg)
#if XYCEDEVICEDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      theLexer (theLexer_yyarg),
      theSpeciesIDs (theSpeciesIDs_yyarg),
      theReactionNetwork (theReactionNetwork_yyarg)
  {}

  ReactionParser::~ReactionParser ()
  {}

  ReactionParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  ReactionParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  ReactionParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  ReactionParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (value_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}


  template <typename Base>
  ReactionParser::symbol_kind_type
  ReactionParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  ReactionParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  ReactionParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  ReactionParser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  ReactionParser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  ReactionParser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  ReactionParser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  ReactionParser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  ReactionParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  ReactionParser::symbol_kind_type
  ReactionParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  ReactionParser::symbol_kind_type
  ReactionParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  ReactionParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  ReactionParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  ReactionParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  ReactionParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  ReactionParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  ReactionParser::symbol_kind_type
  ReactionParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  ReactionParser::stack_symbol_type::stack_symbol_type ()
  {}

  ReactionParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  ReactionParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  ReactionParser::stack_symbol_type&
  ReactionParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  ReactionParser::stack_symbol_type&
  ReactionParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  ReactionParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    switch (yysym.kind ())
    {
      case symbol_kind::S_SPECIE: // "specie"
#line 146 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                    {delete (yysym.value.sval);}
#line 420 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
        break;

      case symbol_kind::S_IDENTIFIER: // "identifier"
#line 147 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                    {delete (yysym.value.sval);}
#line 426 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
        break;

      default:
        break;
    }
  }

#if XYCEDEVICEDEBUG
  template <typename Base>
  void
  ReactionParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  ReactionParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  ReactionParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  ReactionParser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if XYCEDEVICEDEBUG
  std::ostream&
  ReactionParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  ReactionParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  ReactionParser::debug_level_type
  ReactionParser::debug_level () const
  {
    return yydebug_;
  }

  void
  ReactionParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // XYCEDEVICEDEBUG

  ReactionParser::state_type
  ReactionParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  ReactionParser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  ReactionParser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  ReactionParser::operator() ()
  {
    return parse ();
  }

  int
  ReactionParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, theLexer, theSpeciesIDs));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 4: // network_spec: species_spec enhancement_net_spec reaction_net_spec sources_spec initial_conditions_spec
#line 154 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                    { 
                      if (yynerrs_ != 0)
                      {
                        YYABORT;
                      }
                      else
                      {
                        YYACCEPT;
                      }
                    }
#line 706 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 8: // species_list: species_list error
#line 172 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                    {
                      error(yystack_[1].location, "Invalid specie specification");
                    }
#line 714 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 11: // variable_specie_spec: simple_specie_spec
#line 182 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             {
               theReactionNetwork.addSpecie(*((yystack_[0].value.specievalp)));
               delete (yystack_[0].value.specievalp);
             }
#line 723 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 12: // constant_specie_spec: simple_specie_spec "const"
#line 189 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             {
               theReactionNetwork.addConstant(*((yystack_[1].value.specievalp)));
               delete (yystack_[1].value.specievalp);
             }
#line 732 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 13: // simple_specie_spec: "specie" "float" "float" RXN_INT
#line 197 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             {
               theSpeciesIDs[*((yystack_[3].value.sval))]=theSpeciesIDs.size();
               (yylhs.value.specievalp) = new Xyce::Device::Specie(*((yystack_[3].value.sval)),(yystack_[2].value.dval),(yystack_[1].value.dval),(yystack_[0].value.ival),theSpeciesIDs.size());
               delete (yystack_[3].value.sval);
             }
#line 742 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 17: // reaction_spec: reaction "simple" '(' "float" ')'
#line 212 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 theReactionNetwork.setSimpleCalc(*(yystack_[4].value.sval),(yystack_[1].value.dval));
                 delete (yystack_[4].value.sval);
               }
#line 751 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 18: // reaction_spec: reaction "capture" '(' "float" ',' "float" ')'
#line 217 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setCaptureCalc(*(yystack_[6].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[6].value.sval);
               }
#line 760 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 19: // reaction_spec: reaction "electron_capture" '(' "float" ')'
#line 222 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setElectronCaptureCalc(*(yystack_[4].value.sval),(yystack_[1].value.dval));
                 delete (yystack_[4].value.sval);
               }
#line 769 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 20: // reaction_spec: reaction "hole_capture" '(' "float" ')'
#line 227 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setHoleCaptureCalc(*(yystack_[4].value.sval),(yystack_[1].value.dval));
                 delete (yystack_[4].value.sval);
               }
#line 778 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 21: // reaction_spec: reaction "emission" '(' "float" ',' "float" ',' "float" ',' "float" ')'
#line 232 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setEmissionCalc(*(yystack_[10].value.sval),(yystack_[7].value.dval),(yystack_[5].value.dval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[10].value.sval);
               }
#line 787 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 22: // reaction_spec: reaction "electron_emission" '(' "float" ',' "float" ')'
#line 237 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setElectronEmissionCalc(*(yystack_[6].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[6].value.sval);
               }
#line 796 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 23: // reaction_spec: reaction "fdelectron_emission" '(' "float" ',' "float" ')'
#line 242 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setFDElectronEmissionCalc(*(yystack_[6].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[6].value.sval);
               }
#line 805 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 24: // reaction_spec: reaction "hole_emission" '(' "float" ',' "float" ')'
#line 247 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setHoleEmissionCalc(*(yystack_[6].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[6].value.sval);
               }
#line 814 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 25: // reaction_spec: reaction "fdhole_emission" '(' "float" ',' "float" ')'
#line 252 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 theReactionNetwork.setFDHoleEmissionCalc(*(yystack_[6].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[6].value.sval);
               }
#line 823 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 26: // reaction_spec: reaction "complex"
#line 257 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 theReactionNetwork.setComplexCalc(*(yystack_[1].value.sval));
                 delete (yystack_[1].value.sval);
               }
#line 832 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 27: // reaction_spec: reaction "complexmultiplier" '(' "float" ')'
#line 262 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 theReactionNetwork.setComplexMultiplierCalc(*(yystack_[4].value.sval),(yystack_[1].value.dval));
                 delete (yystack_[4].value.sval);
               }
#line 841 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 28: // reaction_spec: reaction "decomplex" '(' "float" ',' "float" ',' "float" ',' "float" ',' "float" ')'
#line 267 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 theReactionNetwork.setDecomplexCalc(*(yystack_[12].value.sval),(yystack_[9].value.dval),(yystack_[7].value.dval),(yystack_[5].value.dval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                 delete (yystack_[12].value.sval);
               }
#line 850 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 29: // reaction_spec: reaction "bourgoin_corbett_hole" '(' "float" ')'
#line 272 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 theReactionNetwork.setBourgoinCorbettHoleCalc(*(yystack_[4].value.sval),(yystack_[1].value.dval));
                 delete (yystack_[4].value.sval);
               }
#line 859 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 30: // reaction_spec: reaction "identifier" '(' num_list ')'
#line 277 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             { 
               error(yystack_[3].location, std::string("Invalid rate type \"")+ *(yystack_[3].value.sval) +"\"");
               delete (yystack_[4].value.sval);
               delete (yystack_[3].value.sval);
               YYERROR;
             }
#line 870 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 31: // reaction_spec: reaction error
#line 284 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             {
               error(yystack_[1].location, "Invalid rate spec");
               delete (yystack_[1].value.sval);
             }
#line 879 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 32: // reaction: species_expr "->" species_expr ';'
#line 292 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
        { 
          std::ostringstream ost;
          bool electron_react=false;
          bool electron_prod=false;
          bool hole_react=false;
          bool hole_prod=false;
          int nl=(yystack_[3].value.spev_p)->size();
          int nr=(yystack_[1].value.spev_p)->size();

          {
            int i;
            for (i=0;i<nl;i++)
            {
              if (i>0)
              {
                ost << "+";
              }
              if (((*(yystack_[3].value.spev_p))[i].second!=1.0))
              {
                ost << (int)(*(yystack_[3].value.spev_p))[i].second;
              }
              ost << (*(yystack_[3].value.spev_p))[i].first;
              if ((*(yystack_[3].value.spev_p))[i].first == "E") 
                electron_react=true;
              else if ((*(yystack_[3].value.spev_p))[i].first == "H") 
                hole_react=true;
            }
            ost << "->";
            for (i=0;i<nr;i++)
            {
              if (i>0)
              {
                ost << "+";
              }
              if (((*(yystack_[1].value.spev_p))[i].second!=1.0))
              {
                ost << (int)(*(yystack_[1].value.spev_p))[i].second;
              }
              ost << (*(yystack_[1].value.spev_p))[i].first;
              if ((*(yystack_[1].value.spev_p))[i].first == "E") 
                electron_prod=true;
              else if ((*(yystack_[1].value.spev_p))[i].first == "H") 
                hole_prod=true;
            }
          }

          if (nl == 2 && nr==1 && electron_react)
            ost << "_ELECTRON_CAPTURE";
          else if (nl == 2 && nr==1 && hole_react)
            ost << "_HOLE_CAPTURE";
          else  if (nl == 1 && nr==2 && electron_prod)
            ost << "_ELECTRON_EMISSION";
          else if (nl == 1 && nr==2 && hole_prod)
            ost << "_HOLE_EMISSION";



          (yylhs.value.sval) = new std::string(ost.str());

          // now go through it again and make the reaction object:
          theReactionNetwork.addReaction(*(yylhs.value.sval));
          {
            int i;
            for (i=0;i<nl;i++)
            {
              theReactionNetwork.addReactant(*(yylhs.value.sval),(*(yystack_[3].value.spev_p))[i].first,
                                       (*(yystack_[3].value.spev_p))[i].second);
            }
            for (i=0;i<nr;i++)
            {
              theReactionNetwork.addProduct(*(yylhs.value.sval),(*(yystack_[1].value.spev_p))[i].first,
                                       (*(yystack_[1].value.spev_p))[i].second);
            }
          }
          delete (yystack_[3].value.spev_p);
          delete (yystack_[1].value.spev_p);
        }
#line 961 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 36: // enhancement_spec: enhancement "bourgoin_corbett" '(' "specie" ',' "float" ',' "float" ')'
#line 380 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                  {
                    theReactionNetwork.setBourgoinCorbettCalc(*(yystack_[8].value.sval),*(yystack_[5].value.sval),(yystack_[3].value.dval),(yystack_[1].value.dval));
                    delete (yystack_[8].value.sval);
                    delete (yystack_[5].value.sval);
                  }
#line 971 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 37: // enhancement_spec: enhancement "identifier" '(' num_list ')'
#line 386 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                  { 
                    error(yystack_[3].location, std::string("Invalid enhancement type \"")+ *(yystack_[3].value.sval) +"\"");
                    delete (yystack_[4].value.sval);
                    delete (yystack_[3].value.sval);
                    YYERROR;
                  }
#line 982 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 38: // enhancement_spec: enhancement error
#line 393 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                  {
                    error(yystack_[1].location, "Invalid enhancement spec");
                    delete (yystack_[1].value.sval);
                  }
#line 991 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 39: // enhancement: "specie" ';'
#line 399 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             { (yylhs.value.sval) = (yystack_[1].value.sval); }
#line 997 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 40: // enhancement: "identifier" ';'
#line 401 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
        {
          error(yystack_[1].location, std::string("Invalid specie \"")+*(yystack_[1].value.sval)+"\"");
          delete (yystack_[1].value.sval);
          YYERROR;
        }
#line 1007 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 45: // species_expr: %empty
#line 416 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                {
                  (yylhs.value.spev_p) = new std::vector< std::pair<std::string,double> >;
                }
#line 1015 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 46: // species_expr: specie_expr
#line 420 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                { 
                  (yylhs.value.spev_p) = new std::vector< std::pair<std::string,double> >;
                  (yylhs.value.spev_p)->push_back(*((yystack_[0].value.spe_p)));
                  delete (yystack_[0].value.spe_p);
                }
#line 1025 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 47: // species_expr: species_expr '+' specie_expr
#line 427 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               { 
                 (yystack_[2].value.spev_p)->push_back(*((yystack_[0].value.spe_p)));
                 (yylhs.value.spev_p)=(yystack_[2].value.spev_p);
                 delete (yystack_[0].value.spe_p);
               }
#line 1035 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 48: // species_expr: species_expr "identifier"
#line 433 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
               {
                 error(yystack_[0].location,std::string("Unrecognized species \"") + *(yystack_[0].value.sval) + "\"");
                 YYERROR;
               }
#line 1044 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 49: // species_expr: species_expr error
#line 438 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
             { 
               error(yystack_[1].location, " Invalid species expression");
               (yylhs.value.spev_p)=(yystack_[1].value.spev_p);
             }
#line 1053 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 50: // specie_expr: "specie"
#line 445 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
              {
                (yylhs.value.spe_p) = new std::pair<std::string,double>(*((yystack_[0].value.sval)),1.0);
                delete (yystack_[0].value.sval);
              }
#line 1062 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 51: // specie_expr: RXN_INT "specie"
#line 450 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
              { 
                (yylhs.value.spe_p) = new std::pair<std::string,double>(*((yystack_[0].value.sval)),(double)(yystack_[1].value.ival));
                delete (yystack_[0].value.sval);
              }
#line 1071 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 56: // source_expr: "specie" "xyce_expression"
#line 466 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                       {
                         theReactionNetwork.addSourceTerm(*(yystack_[1].value.sval),*(yystack_[0].value.sval));
                         delete (yystack_[1].value.sval);
                         delete (yystack_[0].value.sval);
                           }
#line 1081 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 57: // source_expr: "identifier" "xyce_expression"
#line 472 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                       { 
                         error(yystack_[1].location,std::string("Unrecognized species \"") + *(yystack_[1].value.sval) + "\" in source specification");
                         delete (yystack_[1].value.sval);
                         delete (yystack_[0].value.sval);
                         YYERROR;
                       }
#line 1092 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 58: // source_expr: "specie" error
#line 479 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                       { 
                         error(yystack_[1].location, "Invalid expression in source specification --- missing braces?");
                         delete (yystack_[1].value.sval);
                         YYERROR;
                       }
#line 1102 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 59: // source_expr: "identifier" error
#line 485 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
                       { 
                         error(yystack_[1].location, "Invalid expression and unrecognized specie (" + *(yystack_[1].value.sval) + ") in source specification?");
                         delete (yystack_[1].value.sval);
                         YYERROR;
                       }
#line 1112 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 64: // ics_expr: "specie" "float"
#line 502 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
          {
              theReactionNetwork.addInitialCondition(*(yystack_[1].value.sval),(yystack_[0].value.dval));
              delete (yystack_[1].value.sval);
          }
#line 1121 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;

  case 65: // ics_expr: "identifier" "float"
#line 507 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"
          { 
              error(yystack_[1].location,std::string("Unrecognized species \"") + *(yystack_[1].value.sval) + "\" in initial condition specification");
              delete (yystack_[1].value.sval);
              YYERROR;
          }
#line 1131 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"
    break;


#line 1135 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  ReactionParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if XYCEDEVICEDEBUG || 0
  const char *
  ReactionParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if XYCEDEVICEDEBUG || 0









  const signed char ReactionParser::yypact_ninf_ = -33;

  const signed char ReactionParser::yytable_ninf_ = -1;

  const short
  ReactionParser::yypact_[] =
  {
       6,   -33,    29,    47,    27,   -33,     7,   -33,    55,    23,
      28,    42,   -33,    62,   -33,   -33,   -33,   -33,    40,    64,
     -33,    36,   -33,     1,     0,   -33,    37,    34,    38,    39,
     -33,     4,    42,    23,   -33,   -33,    66,   -33,   -33,   -33,
     -33,   -33,    43,    44,    45,    46,    49,    50,    52,    53,
      54,    56,   -33,    57,    58,    59,   -33,     7,   -33,     7,
      48,    51,   -33,   -33,   -33,   -33,   -33,   -33,   -33,    60,
      61,   -33,    42,    41,    70,     9,    73,    74,    77,    81,
      88,    89,    90,    91,    92,    93,    94,    95,     2,   -33,
     -33,   -33,   -33,   -33,     9,    96,   -33,    98,    99,   -33,
     -33,   -33,   -33,   -33,    31,   -33,    69,    72,    75,    78,
      76,    79,    82,    80,    83,    84,    86,    87,   -33,    33,
      97,   -33,   -33,   -33,     9,   -33,   101,   102,   -33,   106,
     110,   -33,   115,   116,   117,   -33,   -33,   -33,   118,   -33,
     100,   103,   105,   107,   108,   109,   111,   112,   -33,   119,
     -33,   -33,   -33,   -33,   120,   121,   113,   114,   122,   123,
     124,   -33,   125,   126,   -33,   128,   129,   -33
  };

  const signed char
  ReactionParser::yydefact_[] =
  {
       0,     6,     0,    52,     0,     1,    45,    54,     0,    52,
       0,    60,     8,     0,     5,     7,     9,    10,    11,     0,
      50,    45,    15,     0,     0,    46,     0,     0,     0,     0,
      34,     0,    60,    52,    62,     2,     0,    12,    51,    14,
      16,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    49,    45,    48,     0,
       0,     0,    53,    55,    39,    40,    33,    35,    38,     0,
       0,     3,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    47,
      58,    56,    59,    57,     0,     0,     4,     0,     0,    61,
      63,    13,    44,    43,     0,    41,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    32,     0,
       0,    64,    65,    30,     0,    17,     0,     0,    19,     0,
       0,    20,     0,     0,     0,    29,    27,    37,     0,    42,
       0,     0,     0,     0,     0,     0,     0,     0,    18,     0,
      22,    23,    24,    25,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,    21,     0,     0,    28
  };

  const short
  ReactionParser::yypgoto_[] =
  {
     -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   132,   -33,
     127,   -33,   -33,   -33,   131,   -33,    68,     3,   130,   104,
      -3,   -33,   -33,   -32,   -33,   -33
  };

  const signed char
  ReactionParser::yydefgoto_[] =
  {
       0,     2,     3,     4,    15,    16,    17,    18,     9,    21,
      22,    23,    10,    29,    30,    31,   104,   105,    24,    25,
      11,    26,    63,    35,    73,   100
  };

  const unsigned char
  ReactionParser::yytable_[] =
  {
      71,    56,    41,    56,    57,    68,    32,    58,    42,    58,
      19,    69,   102,    20,   103,     1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    12,     5,
      72,    55,    70,    13,     7,    59,   118,    59,     6,    19,
      96,    14,    20,    60,    61,    27,    28,    97,    98,    90,
      39,    62,    92,    66,    34,    99,    91,     6,     7,    93,
       8,    27,    28,   123,   124,   137,   124,    36,    64,    37,
      38,    74,    65,   101,    75,    76,    77,    78,   106,   107,
      79,    80,   108,    81,    82,    83,   109,    84,    85,    86,
      87,    94,    95,   110,   111,   112,   113,   114,   115,   116,
     117,   125,   120,   121,   122,   126,   140,   141,   127,   129,
     128,   142,   130,   132,   131,   143,   133,   134,   135,   136,
     144,   145,   146,   147,   156,   157,   158,   139,   162,   163,
     138,     0,   148,   166,     0,     0,   149,   150,     0,   151,
     152,   153,    33,     0,   154,   155,   159,   160,    40,     0,
       0,     0,     0,     0,   161,     0,     0,   164,     0,   165,
      67,   167,   119,    89,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    88
  };

  const signed char
  ReactionParser::yycheck_[] =
  {
      32,     1,     1,     1,     4,     1,     9,     7,     7,     7,
       3,     7,     3,     6,     5,     9,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,     1,     0,
      33,    30,    28,     6,    11,    35,    34,    35,    10,     3,
      72,    14,     6,     6,     7,     6,     7,     6,     7,     1,
      14,    14,     1,    14,    12,    14,     8,    10,    11,     8,
      13,     6,     7,    32,    33,    32,    33,     5,    34,    29,
       6,     5,    34,     3,    31,    31,    31,    31,     5,     5,
      31,    31,     5,    31,    31,    31,     5,    31,    31,    31,
      31,    31,    31,     5,     5,     5,     5,     5,     5,     5,
       5,    32,     6,     5,     5,    33,     5,     5,    33,    33,
      32,     5,    33,    33,    32,     5,    33,    33,    32,    32,
       5,     5,     5,     5,     5,     5,     5,   124,     5,     5,
      33,    -1,    32,     5,    -1,    -1,    33,    32,    -1,    32,
      32,    32,    10,    -1,    33,    33,    33,    33,    21,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    32,    -1,    33,
      29,    32,    94,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    57
  };

  const signed char
  ReactionParser::yystos_[] =
  {
       0,     9,    37,    38,    39,     0,    10,    11,    13,    44,
      48,    56,     1,     6,    14,    40,    41,    42,    43,     3,
       6,    45,    46,    47,    54,    55,    57,     6,     7,    49,
      50,    51,    56,    44,    12,    59,     5,    29,     6,    14,
      46,     1,     7,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    30,     1,     4,     7,    35,
       6,     7,    14,    58,    34,    34,    14,    50,     1,     7,
      28,    59,    56,    60,     5,    31,    31,    31,    31,    31,
      31,    31,    31,    31,    31,    31,    31,    31,    54,    55,
       1,     8,     1,     8,    31,    31,    59,     6,     7,    14,
      61,     3,     3,     5,    52,    53,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,    34,    52,
       6,     5,     5,    32,    33,    32,    33,    33,    32,    33,
      33,    32,    33,    33,    33,    32,    32,    32,    33,    53,
       5,     5,     5,     5,     5,     5,     5,     5,    32,    33,
      32,    32,    32,    32,    33,    33,     5,     5,     5,    33,
      33,    32,     5,     5,    32,    33,     5,    32
  };

  const signed char
  ReactionParser::yyr1_[] =
  {
       0,    36,    37,    37,    37,    38,    39,    39,    39,    40,
      40,    41,    42,    43,    44,    45,    45,    46,    46,    46,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    47,    48,    49,    49,    50,    50,    50,    51,
      51,    52,    52,    53,    53,    54,    54,    54,    54,    54,
      55,    55,    56,    56,    57,    57,    58,    58,    58,    58,
      59,    59,    60,    60,    61,    61
  };

  const signed char
  ReactionParser::yyr2_[] =
  {
       0,     2,     3,     4,     5,     3,     0,     2,     2,     1,
       1,     1,     2,     4,     3,     1,     2,     5,     7,     5,
       5,    11,     7,     7,     7,     7,     2,     5,    13,     5,
       5,     2,     4,     3,     1,     2,     9,     5,     2,     2,
       2,     1,     3,     1,     1,     0,     1,     3,     2,     2,
       1,     2,     0,     3,     0,     2,     2,     2,     2,     2,
       0,     3,     0,     2,     2,     2
  };


#if XYCEDEVICEDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const ReactionParser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "RXN_INT", "\"->\"",
  "\"float\"", "\"specie\"", "\"identifier\"", "\"xyce_expression\"",
  "\"species\"", "\"reactions\"", "\"sources\"", "\"initial_conditions\"",
  "\"enhancements\"", "\"end\"", "\"simple\"", "\"capture\"",
  "\"emission\"", "\"electron_capture\"", "\"electron_emission\"",
  "\"fdelectron_emission\"", "\"hole_capture\"", "\"hole_emission\"",
  "\"fdhole_emission\"", "\"complex\"", "\"decomplex\"",
  "\"bourgoin_corbett_hole\"", "\"bourgoin_corbett_electron\"",
  "\"bourgoin_corbett\"", "\"const\"", "\"complexmultiplier\"", "'('",
  "')'", "','", "';'", "'+'", "$accept", "network_spec", "species_spec",
  "species_list", "specie_spec", "variable_specie_spec",
  "constant_specie_spec", "simple_specie_spec", "reaction_net_spec",
  "reaction_network", "reaction_spec", "reaction", "enhancement_net_spec",
  "enhancement_network", "enhancement_spec", "enhancement", "num_list",
  "num", "species_expr", "specie_expr", "sources_spec", "source_list",
  "source_expr", "initial_conditions_spec", "ics_list", "ics_expr", YY_NULLPTR
  };
#endif


#if XYCEDEVICEDEBUG
  const short
  ReactionParser::yyrline_[] =
  {
       0,   151,   151,   152,   153,   166,   169,   170,   171,   177,
     178,   181,   188,   195,   204,   207,   208,   211,   216,   221,
     226,   231,   236,   241,   246,   251,   256,   261,   266,   271,
     276,   283,   291,   372,   375,   376,   379,   385,   392,   399,
     400,   408,   409,   412,   412,   416,   419,   426,   432,   437,
     444,   449,   457,   458,   461,   462,   465,   471,   478,   484,
     493,   494,   497,   498,   501,   506
  };

  void
  ReactionParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  ReactionParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // XYCEDEVICEDEBUG

  ReactionParser::symbol_kind_type
  ReactionParser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      31,    32,     2,    35,    33,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    34,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30
    };
    // Last valid token kind.
    const int code_max = 285;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

} // XyceDevice
#line 1604 "/builddir/build/BUILD/xyce/build/src/DeviceModelPKG/Core/N_DEV_ReactionParser.cxx"

#line 514 "DeviceModelPKG/Core/N_DEV_ReactionParser.yxx"



int XyceDevicelex(XyceDevice::ReactionParser::semantic_type *lvalp, XyceDevice::location *locp, 
                  Xyce::Device::ReactionLexer *theLexer, 
                  std::map<std::string, int> &theSpeciesIDs)
{
        return(theLexer->getToken(lvalp,locp,theSpeciesIDs));
}

void
XyceDevice::ReactionParser::error(
  const XyceDevice::ReactionParser::location_type & l,
  const std::string &                               message)
{
  Xyce::Report::UserError().at(theLexer->netlistLocation_)
    << "in file " << theLexer->reactionFilename_ << " at line " << l << "\n"
    << message;
}
