
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file diode_cmc.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSDIODE_CMC.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSDIODE_CMC {


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_A;
    const int Instance::admsNodeID_K;
    const int Instance::admsNodeID_AIK;
    const int Instance::admsNodeID_charge_A;
    const int Instance::admsNodeID_charge_K;
    const int Instance::admsNodeID_depl_A;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSDIODE_CMC::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSDIODE_CMC::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("AB", static_cast<double>(1E-12), &ADMSDIODE_CMC::Instance::AB)
    .setUnit(U_METER2)
    .setDescription("Junction area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AREA", static_cast<double>(1E-12), &ADMSDIODE_CMC::Instance::AB)
    .setUnit(U_METER2)
    .setDescription(" Alias for AB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LS", static_cast<double>(1e-6), &ADMSDIODE_CMC::Instance::LS)
    .setUnit(U_METER)
    .setDescription("STI-edge part of junction perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PJ", static_cast<double>(1e-6), &ADMSDIODE_CMC::Instance::LS)
    .setUnit(U_METER)
    .setDescription(" Alias for LS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PERIM", static_cast<double>(1e-6), &ADMSDIODE_CMC::Instance::LS)
    .setUnit(U_METER)
    .setDescription(" Alias for LS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LG", static_cast<double>(0), &ADMSDIODE_CMC::Instance::LG)
    .setUnit(U_METER)
    .setDescription("Gate-edge part of junction perimeter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MULT", static_cast<double>(1), &ADMSDIODE_CMC::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSDIODE_CMC::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSDIODE_CMC::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("VERSION", static_cast<double>(2), &ADMSDIODE_CMC::Model::VERSION)
    .setUnit(U_UNKNOWN)
    .setDescription("Model version")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SUBVERSION", static_cast<double>(0), &ADMSDIODE_CMC::Model::SUBVERSION)
    .setUnit(U_UNKNOWN)
    .setDescription("Model subversion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("REVISION", static_cast<double>(0), &ADMSDIODE_CMC::Model::REVISION)
    .setUnit(U_UNKNOWN)
    .setDescription("Model revision")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TYPE", static_cast<double>(1), &ADMSDIODE_CMC::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Type parameter, in output value 1 reflects n-type, -1 reflects p-type")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTA", static_cast<double>(0), &ADMSDIODE_CMC::Model::DTA)
    .setUnit(U_COULOMB)
    .setDescription("Temperature offset with respect to ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IMAX", static_cast<double>(1000), &ADMSDIODE_CMC::Model::IMAX)
    .setUnit(U_AMP)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRJ", static_cast<double>(21), &ADMSDIODE_CMC::Model::TRJ)
    .setUnit(U_COULOMB)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORBOT", static_cast<double>(1E-3), &ADMSDIODE_CMC::Model::CJORBOT)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORSTI", static_cast<double>(1E-9), &ADMSDIODE_CMC::Model::CJORSTI)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORGAT", static_cast<double>(1E-9), &ADMSDIODE_CMC::Model::CJORGAT)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRBOT", static_cast<double>(1), &ADMSDIODE_CMC::Model::VBIRBOT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRSTI", static_cast<double>(1), &ADMSDIODE_CMC::Model::VBIRSTI)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRGAT", static_cast<double>(1), &ADMSDIODE_CMC::Model::VBIRGAT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSDIODE_CMC::Model::PBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSDIODE_CMC::Model::PSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSDIODE_CMC::Model::PGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSDIODE_CMC::Model::PHIGBOT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSDIODE_CMC::Model::PHIGSTI)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSDIODE_CMC::Model::PHIGGAT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRBOT", static_cast<double>(1E-12), &ADMSDIODE_CMC::Model::IDSATRBOT)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRSTI", static_cast<double>(1E-18), &ADMSDIODE_CMC::Model::IDSATRSTI)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRGAT", static_cast<double>(1E-18), &ADMSDIODE_CMC::Model::IDSATRGAT)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHBOT", static_cast<double>(1E2), &ADMSDIODE_CMC::Model::CSRHBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHSTI", static_cast<double>(1E-4), &ADMSDIODE_CMC::Model::CSRHSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHGAT", static_cast<double>(1E-4), &ADMSDIODE_CMC::Model::CSRHGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNSTI", static_cast<double>(100E-9), &ADMSDIODE_CMC::Model::XJUNSTI)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNGAT", static_cast<double>(100E-9), &ADMSDIODE_CMC::Model::XJUNGAT)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATBOT", static_cast<double>(1E2), &ADMSDIODE_CMC::Model::CTATBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATSTI", static_cast<double>(1E-4), &ADMSDIODE_CMC::Model::CTATSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATGAT", static_cast<double>(1E-4), &ADMSDIODE_CMC::Model::CTATGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSDIODE_CMC::Model::MEFFTATBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSDIODE_CMC::Model::MEFFTATSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSDIODE_CMC::Model::MEFFTATGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTBOT", static_cast<double>(1E-12), &ADMSDIODE_CMC::Model::CBBTBOT)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTSTI", static_cast<double>(1E-18), &ADMSDIODE_CMC::Model::CBBTSTI)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTGAT", static_cast<double>(1E-18), &ADMSDIODE_CMC::Model::CBBTGAT)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRBOT", static_cast<double>(1E9), &ADMSDIODE_CMC::Model::FBBTRBOT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRSTI", static_cast<double>(1E9), &ADMSDIODE_CMC::Model::FBBTRSTI)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRGAT", static_cast<double>(1E9), &ADMSDIODE_CMC::Model::FBBTRGAT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTBOT", static_cast<double>((-1E-3)), &ADMSDIODE_CMC::Model::STFBBTBOT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTSTI", static_cast<double>((-1E-3)), &ADMSDIODE_CMC::Model::STFBBTSTI)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTGAT", static_cast<double>((-1E-3)), &ADMSDIODE_CMC::Model::STFBBTGAT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRBOT", static_cast<double>(10), &ADMSDIODE_CMC::Model::VBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRSTI", static_cast<double>(10), &ADMSDIODE_CMC::Model::VBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRGAT", static_cast<double>(10), &ADMSDIODE_CMC::Model::VBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRBOT", static_cast<double>(4), &ADMSDIODE_CMC::Model::PBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRSTI", static_cast<double>(4), &ADMSDIODE_CMC::Model::PBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRGAT", static_cast<double>(4), &ADMSDIODE_CMC::Model::PBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FREV", static_cast<double>(1E3), &ADMSDIODE_CMC::Model::FREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Additional parameter for current after breakdown")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSBOT", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::RSBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Series resistance per unit-of-area of bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSSTI", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::RSSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Series resistance per unit-of-length of STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSGAT", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::RSGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Series resistance per unit-of-length of gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSCOM", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::RSCOM)
    .setUnit(U_UNKNOWN)
    .setDescription("Common series resistance, no scaling ")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRS", static_cast<double>(0), &ADMSDIODE_CMC::Model::STRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature scaling parameter for series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KF", static_cast<double>(0), &ADMSDIODE_CMC::Model::KF)
    .setUnit(U_UNKNOWN)
    .setDescription("KF parameter for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AF", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::AF)
    .setUnit(U_UNKNOWN)
    .setDescription("AF parameter for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TT", static_cast<double>(0), &ADMSDIODE_CMC::Model::TT)
    .setUnit(U_SECOND)
    .setDescription("Transit time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRBOT1", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRBOT1)
    .setUnit(U_DEGKM1)
    .setDescription("Temp. co of breakdown voltage bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRBOT2", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRBOT2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of breakdown voltage bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRSTI1", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRSTI1)
    .setUnit(U_DEGKM1)
    .setDescription("Temp. co of breakdown voltage STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRSTI2", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRSTI2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of breakdown voltage STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRGAT1", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRGAT1)
    .setUnit(U_DEGKM1)
    .setDescription("Temp. co of breakdown voltage gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVBRGAT2", static_cast<double>(0), &ADMSDIODE_CMC::Model::STVBRGAT2)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of breakdown voltage gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFABOT", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::NFABOT)
    .setUnit(U_UNKNOWN)
    .setDescription("ideality factor bottom component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFASTI", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::NFASTI)
    .setUnit(U_UNKNOWN)
    .setDescription("ideality factor STI-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFAGAT", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::NFAGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("ideality factor gate-edge component")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABMIN", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::ABMIN)
    .setUnit(U_METER2)
    .setDescription("minimum allowed junction area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABMAX", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::ABMAX)
    .setUnit(U_METER2)
    .setDescription("maximum allowed junction area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSMIN", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::LSMIN)
    .setUnit(U_METER)
    .setDescription("minimum allowed junction STI-edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSMAX", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::LSMAX)
    .setUnit(U_METER)
    .setDescription("maximum allowed junction STI-edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGMIN", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::LGMIN)
    .setUnit(U_METER)
    .setDescription("minimum allowed junction gate-edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGMAX", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::LGMAX)
    .setUnit(U_METER)
    .setDescription("maximum allowed junction gate-edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TEMPMIN", static_cast<double>((-55)), &ADMSDIODE_CMC::Model::TEMPMIN)
    .setUnit(U_COULOMB)
    .setDescription("minimum allowed junction temp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TEMPMAX", static_cast<double>(155), &ADMSDIODE_CMC::Model::TEMPMAX)
    .setUnit(U_COULOMB)
    .setDescription("maximum allowed junction temp")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFMAX", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::VFMAX)
    .setUnit(U_VOLT)
    .setDescription("maximum allowed forward junction bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VRMAX", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::VRMAX)
    .setUnit(U_VOLT)
    .setDescription("maximum allowed reverse junction bias")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XTI", static_cast<double>(3), &ADMSDIODE_CMC::Model::XTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of saturation current")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PT", static_cast<double>(3), &ADMSDIODE_CMC::Model::XTI)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for XTI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCALE", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::SCALE)
    .setUnit(U_UNKNOWN)
    .setDescription("Scale parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SHRINK", static_cast<double>(0), &ADMSDIODE_CMC::Model::SHRINK)
    .setUnit(U_UNKNOWN)
    .setDescription("Scale parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::SWJUNEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSDIODE_CMC::Model::VJUNREF)
    .setUnit(U_UNKNOWN)
    .setDescription("Typical maximum junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSDIODE_CMC::Model::FJUNQ)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CORECOVERY", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::CORECOVERY)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for recovery equations; 0=original, 1=Hiroshima")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJH", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::NJH)
    .setUnit(U_UNKNOWN)
    .setDescription("High-injection emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NJDV", static_cast<double>(0.1), &ADMSDIODE_CMC::Model::NJDV)
    .setUnit(U_UNKNOWN)
    .setDescription("Transition slope of emission coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDIBOT", static_cast<double>(1e16), &ADMSDIODE_CMC::Model::NDIBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Doping concentration of drift region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDIGAT", static_cast<double>(1e16), &ADMSDIODE_CMC::Model::NDIGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Doping concentration of drift region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NDISTI", static_cast<double>(1e16), &ADMSDIODE_CMC::Model::NDISTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Doping concentration of drift region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("INJ1", static_cast<double>(1.0), &ADMSDIODE_CMC::Model::INJ1)
    .setUnit(U_UNKNOWN)
    .setDescription("For carrier density")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("INJ2", static_cast<double>(10.0), &ADMSDIODE_CMC::Model::INJ2)
    .setUnit(U_UNKNOWN)
    .setDescription("For carrier density in high-injection condition")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NQS", static_cast<double>(5e-9), &ADMSDIODE_CMC::Model::NQS)
    .setUnit(U_UNKNOWN)
    .setDescription("Carrier delay time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TAU", static_cast<double>(2e-7), &ADMSDIODE_CMC::Model::TAU)
    .setUnit(U_UNKNOWN)
    .setDescription("Carrier lifetime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WI", static_cast<double>(5e-6), &ADMSDIODE_CMC::Model::WI)
    .setUnit(U_METER)
    .setDescription("Length of drift region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DEPNQS", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::DEPNQS)
    .setUnit(U_UNKNOWN)
    .setDescription("Depletion delay time")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TNOM", static_cast<double>(21), &ADMSDIODE_CMC::Model::TNOM)
    .setUnit(U_COULOMB)
    .setDescription("Alias reference temperature")
   .setAutoConvertTemperature(false)
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TAUT", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::TAUT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of carrier lifetime")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("INJT", static_cast<double>(0.0), &ADMSDIODE_CMC::Model::INJT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temp. co of carrier density in high-injection condition")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter AB : [ 0,  (+inf) [
  if ( (!((AB >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter AB value " << AB << " out of range [ 0,  (+inf) [";
  }

//    Parameter LS : [ 0,  (+inf) [
  if ( (!((LS >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LS value " << LS << " out of range [ 0,  (+inf) [";
  }

//    Parameter LG : [ 0,  (+inf) [
  if ( (!((LG >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LG value " << LG << " out of range [ 0,  (+inf) [";
  }

//    Parameter MULT : [ 0,  (+inf) [
  if ( (!((MULT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter MULT value " << MULT << " out of range [ 0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5=0.0;
  double I4=0.0;
  double I3=0.0;
  double I2=0.0;
  double I1=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
  double V2=0.0;
  double V1=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double restotal=0.0;
  double alphaje=0.0;
  double zfrac=0.0;
  double tt2=0.0;
  double tt1=0.0;
  double tt0=0.0;
  double I5_cor=0.0;
  double I4_cor=0.0;
  double I3_cor=0.0;
  double I2_cor=0.0;
  double I1_cor=0.0;
  double mcor_rev=0.0;
  double m0_rev=0.0;
  double pmax=0.0;
  double vbigat2r=0.0;
  double vbisti2r=0.0;
  double vbibot2r=0.0;
  double pgat2=0.0;
  double psti2=0.0;
  double pbot2=0.0;
  double vbigat2=0.0;
  double vbisti2=0.0;
  double vbibot2=0.0;
  double vmaxgat=0.0;
  double vmaxsti=0.0;
  double vmaxbot=0.0;
//Begin block initial_instance
{
AB_i = ((((((AB>0)?AB:0)*(model_.SCALE_i))*(model_.SCALE_i))*(model_.shrinkL))*(model_.shrinkL));
LS_i = ((((LS>0)?LS:0)*(model_.SCALE_i))*(model_.shrinkL));
LG_i = ((((LG>0)?LG:0)*(model_.SCALE_i))*(model_.shrinkL));
MULT_i = ((MULT>0)?MULT:0);
exp_VMAX_over_phitd = 0.0;

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = 0.0;

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = 0.0;

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = 0.0;
if ((((model_.idsatbot)*AB_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot)*AB_i))+1));
vmaxbot = (((model_.phitd)*value_log_0)*(model_.NFABOT_i));
}
}
else
{
vmaxbot = 1E8;
}
if ((((model_.idsatsti)*LS_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti)*LS_i))+1));
vmaxsti = (((model_.phitd)*value_log_0)*(model_.NFASTI_i));
}
}
else
{
vmaxsti = 1E8;
}
if ((((model_.idsatgat)*LG_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat)*LG_i))+1));
vmaxgat = (((model_.phitd)*value_log_0)*(model_.NFAGAT_i));
}
}
else
{
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
VMAX = value_min_1;
}
if ((fabs((VMAX*(model_.phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((VMAX*(model_.phitdinv)));
exp_VMAX_over_phitd = value_exp_0;
}
}
else
{
if (((VMAX*(model_.phitdinv))<(-2.3025850929940458e+02)))
{
exp_VMAX_over_phitd = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX*(model_.phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
exp_VMAX_over_phitd = (1.0e100*(1.0+(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
vbibot2 = (model_.vbibot);
vbisti2 = (model_.vbisti);
vbigat2 = (model_.vbigat);
pbot2 = (model_.PBOT_i);
psti2 = (model_.PSTI_i);
pgat2 = (model_.PGAT_i);
vbibot2r = (model_.VBIRBOT_i);
vbisti2r = (model_.VBIRSTI_i);
vbigat2r = (model_.VBIRGAT_i);
if ((AB_i==0))
{
vbibot2 = ((model_.vbisti)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PSTI_i),(model_.PGAT_i));
pbot2 = (0.9*value_min_0);
}
vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
}
if ((LS_i==0))
{
vbisti2 = ((model_.vbibot)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PGAT_i));
psti2 = (0.9*value_min_0);
}
vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
}
if ((LG_i==0))
{
vbigat2 = ((model_.vbibot)+(model_.vbisti));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PSTI_i));
pgat2 = (0.9*value_min_0);
}
vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
vbimin = value_min_1;
}
vch = (vbimin*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
vfmin = (vbimin*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
vbbtlim = (value_min_1-0.050);
}
if (((AB_i>(model_.ABMAX_i))&&((model_.ABMAX_i)>1e-18)))
{
UserInfo(*this)  << "WARNING: Diode area is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((AB_i<(model_.ABMIN_i)))
{
UserInfo(*this)  << "WARNING: Diode area is less than minimum allowed value \n" << " " <<  std::endl; 
}
if (((LS_i>(model_.LSMAX_i))&&((model_.LSMAX_i)>1e-12)))
{
UserInfo(*this)  << "WARNING: Diode STI-edge perimeter is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((LS_i<(model_.LSMIN_i)))
{
UserInfo(*this)  << "WARNING: Diode STI-edge perimeter is less than minimum allowed value \n" << " " <<  std::endl; 
}
if (((LG_i>(model_.LGMAX_i))&&((model_.LGMAX_i)>1e-12)))
{
UserInfo(*this)  << "WARNING: Diode gate-edge perimeter is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((LG_i<(model_.LGMIN_i)))
{
UserInfo(*this)  << "WARNING: Diode gate-edge perimeter is less than minimum allowed value \n" << " " <<  std::endl; 
}
if (((model_.tkd)>((model_.TEMPMAX_i)+273.15)))
{
UserInfo(*this)  << "WARNING: Junction temperature is higher than maximum allowed value \n" << " " <<  std::endl; 
}
if (((model_.tkd)<((model_.TEMPMIN_i)+273.15)))
{
UserInfo(*this)  << "WARNING: Junction temperature is lower than minimum allowed value \n" << " " <<  std::endl; 
}
isattotal = (((AB_i*(model_.idsatbot))+(LS_i*(model_.idsatsti)))+(LG_i*(model_.idsatgat)));
ISATFOR1 = 0.0;
MFOR1 = 1.0;
MFOR2 = 1.0;
ISATFOR2 = 0.0;
MREV = 1.0;
ISATREV = 0.0;
m0flag = 0.0;
xhighf1 = 0.0;
expxhf1 = 0.0;
xhighf2 = 0.0;
expxhf2 = 0.0;
xhighr = 0.0;
expxhr = 0.0;
m0_rev = 0.0;
mcor_rev = 0.0;
I1_cor = 0.0;
I2_cor = 0.0;
I3_cor = 0.0;
I4_cor = 0.0;
I5_cor = 0.0;
tt0 = 0.0;
tt1 = 0.0;
tt2 = 0.0;
zfrac = 0.0;
zflagbot = 1.0;
zflagsti = 1.0;
zflaggat = 1.0;
alphaje = 0.0;

d_tmpv_dV_A_AIK =  0.0;
tmpv = 0.0;

d_vjv_dV_A_AIK =  0.0;
vjv = 0.0;
rnode = 1;
restotal = 0.0;
conducts = (1.0/1.0e-13);
if (((AB_i*(model_.resbot))>0))
{
conducts = (AB_i/(model_.resbot));
}
if (((LS_i*(model_.ressti))>0))
{
conducts = ((LS_i/(model_.ressti))+conducts);
}
if (((LG_i*(model_.resgat))>0))
{
conducts = ((LG_i/(model_.resgat))+conducts);
}
restotal = ((1.0/conducts)+(model_.rescom));
if ((restotal>(1.0e-13*1.4)))
{
conducts = (1.0/restotal);
rnode = 1;
}
else
{
rnode = 0;
}
if ((((((AB_i>0)&&(((model_.resbot)/AB_i)<1.0e-13))||((LS_i>0)&&(((model_.ressti)/LS_i)<1.0e-13)))||((LG_i>0)&&(((model_.resgat)/LG_i)<1.0e-13)))&&((model_.rescom)<1.0e-13)))
{
rnode = 0;
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0.0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0.0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0.0;

d_IWnqs0_A_dV_depl_A_GND = d_IWnqs0_A_dV_A_AIK =  0.0;
IWnqs0_A = 0.0;

d_Inqs0_A_dV_charge_A_GND = d_Inqs0_A_dV_A_AIK =  0.0;
Inqs0_A = 0.0;

d_Inqs0_K_dV_charge_K_GND = d_Inqs0_K_dV_A_AIK =  0.0;
Inqs0_K = 0.0;

d_Q_nqs_A_dV_charge_A_GND =  0.0;
Q_nqs_A = 0.0;

d_Q_nqs_K_dV_charge_K_GND =  0.0;
Q_nqs_K = 0.0;

d_W_nqs_A_dV_depl_A_GND =  0.0;
W_nqs_A = 0.0;
if (((model_.SWJUNEXP_i)>0.9))
{
if ((((((fabs(((model_.NFABOT_i)-(model_.NFAGAT_i)))>1.0e-6)&&(AB_i>0))&&(LG_i>0))||(((fabs(((model_.NFABOT_i)-(model_.NFASTI_i)))>1.0e-6)&&(AB_i>0))&&(LS_i>0)))||(((fabs(((model_.NFAGAT_i)-(model_.NFASTI_i)))>1.0e-6)&&(LG_i>0))&&(LS_i>0))))
{
UserInfo(*this)  << "WARNING: The ideality factors are not the same. JUNCAP Express will not be used \n" << " " <<  std::endl; 
UserInfo(*this)  << "WARNING: The full diode_cmc is executed. \n" << " " <<  std::endl; 
(model_.SWJUNEXP_i) = 0;
}
else
{
if ((AB_i>0))
{
MFOR1 = (model_.NFABOT_i);
}
if ((LG_i>0))
{
MFOR1 = (model_.NFAGAT_i);
}
if ((LS_i>0))
{
MFOR1 = (model_.NFASTI_i);
}
UserInfo(*this)  << "WARNING: JUNCAP Express will not simulate breakdown behavior of diode. \n" << " " <<  std::endl; 
}
}
if (((model_.SWJUNEXP_i)==1.0))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double terfc=0.0;
double erfcpos=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double h2=0.0;
double h2d=0.0;
double h3=0.0;
double h4=0.0;
double h5=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double vj=0.0;
double z=0.0;
double zinv=0.0;
double two_psistar=0.0;
double vjlim=0.0;
double vjsrh=0.0;
double vbbt=0.0;
double vav=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double id=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double vbi_minus_vjsrh=0.0;
double wsrhstep=0.0;
double dwsrh=0.0;
double wsrh=0.0;
double wdep=0.0;
double asrh=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double btat=0.0;
double twoatatoverthreebtat=0.0;
double umaxbeforelimiting=0.0;
double umax=0.0;
double sqrtumax=0.0;
double umaxpoweronepointfive=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double wtat=0.0;
double ktat=0.0;
double ltat=0.0;
double mtat=0.0;
double xerfc=0.0;
double erfctimesexpmtat=0.0;
double gammamax=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double Fmaxr=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
//End of Block-local variables
ysq = 0.0;
terfc = 0.0;
erfcpos = 0.0;
h1 = 0.0;
h2 = 0.0;
h2d = 0.0;
h3 = 0.0;
h4 = 0.0;
h5 = 0.0;

d_VAK_dV_A_AIK =  0.0;
VAK = 0.0;
DQAbot = 0.0;
DQAsti = 0.0;
DQAgat = 0.0;
vj = 0.0;
z = 0.0;
zinv = 0.0;
two_psistar = 0.0;
vjlim = 0.0;
vjsrh = 0.0;
vbbt = 0.0;
vav = 0.0;
tmp = 0.0;
id = 0.0;
isrh = 0.0;
vbi_minus_vjsrh = 0.0;
wsrhstep = 0.0;
dwsrh = 0.0;
wsrh = 0.0;
wdep = 0.0;
asrh = 0.0;
itat = 0.0;
btat = 0.0;
twoatatoverthreebtat = 0.0;
umaxbeforelimiting = 0.0;
umax = 0.0;
sqrtumax = 0.0;
umaxpoweronepointfive = 0.0;
wgamma = 0.0;
wtat = 0.0;
ktat = 0.0;
ltat = 0.0;
mtat = 0.0;
xerfc = 0.0;
erfctimesexpmtat = 0.0;
gammamax = 0.0;
ibbt = 0.0;
Fmaxr = 0.0;
fbreakdown = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
V1 = ((-FRACNA)*(model_.VJUNREF_i));
V2 = ((-FRACNB)*(model_.VJUNREF_i));
V3 = ((-FRACI)*(model_.VJUNREF_i));
V4 = 0.1;
V5 = 0.2;
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);
h2d = (V1+(vch*h2));
h3 = (vfmin+h2d);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V1*vfmin)/(h3+h5)));
if ((V1<VMAX))
{
if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V1-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V1-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V1-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V1/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V1-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = ((1+((V1-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = ((1+((V1-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = ((1+((V1-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (idmultbot-1.0);

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (idmultsti-1.0);

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (idmultgat-1.0);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-vbbtlim)*(V1-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V1+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
vav = (0.5*(V1-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;
two_psistar = 0;
vj = 0;
zinv = 0;
vjsrh = 0;
vbbt = 0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V1-vj)));
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V1-vj)));
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK =  0.0;
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V1-vj)));
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK =  0.0;
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
I1 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);
h2d = (V2+(vch*h2));
h3 = (vfmin+h2d);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V2*vfmin)/(h3+h5)));
if ((V2<VMAX))
{
if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V2-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V2-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V2-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V2/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V2-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = ((1+((V2-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = ((1+((V2-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = ((1+((V2-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (idmultbot-1.0);

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (idmultsti-1.0);

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (idmultgat-1.0);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-vbbtlim)*(V2-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V2+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
vav = (0.5*(V2-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;
two_psistar = 0;
vj = 0;
zinv = 0;
vjsrh = 0;
vbbt = 0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V2-vj)));
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V2-vj)));
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK =  0.0;
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V2-vj)));
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK =  0.0;
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
I2 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);
h2d = (V3+(vch*h2));
h3 = (vfmin+h2d);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V3*vfmin)/(h3+h5)));
if ((V3<VMAX))
{
if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V3-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V3-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V3-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V3/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V3-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = ((1+((V3-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = ((1+((V3-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = ((1+((V3-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (idmultbot-1.0);

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (idmultsti-1.0);

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (idmultgat-1.0);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-vbbtlim)*(V3-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V3+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
vav = (0.5*(V3-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;
two_psistar = 0;
vj = 0;
zinv = 0;
vjsrh = 0;
vbbt = 0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V3-vj)));
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V3-vj)));
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK =  0.0;
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V3-vj)));
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK =  0.0;
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
I3 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);
h2d = (V4+(vch*h2));
h3 = (vfmin+h2d);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V4*vfmin)/(h3+h5)));
if ((V4<VMAX))
{
if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V4-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V4-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V4-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V4/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V4-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = ((1+((V4-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = ((1+((V4-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = ((1+((V4-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (idmultbot-1.0);

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (idmultsti-1.0);

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (idmultgat-1.0);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-vbbtlim)*(V4-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V4+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
vav = (0.5*(V4-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;
two_psistar = 0;
vj = 0;
zinv = 0;
vjsrh = 0;
vbbt = 0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V4-vj)));
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V4-vj)));
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK =  0.0;
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V4-vj)));
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK =  0.0;
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
I4 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);
h2d = (V5+(vch*h2));
h3 = (vfmin+h2d);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V5*vfmin)/(h3+h5)));
if ((V5<VMAX))
{
if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V5-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V5-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(V5-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((V5/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V5-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = ((1+((V5-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = ((1+((V5-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK =  0.0;
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK =  0.0;
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK =  0.0;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));

d_TMF2_dV_A_AIK =  0.0;
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK =  0.0;
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK =  0.0;
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK =  0.0;
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK =  0.0;
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = ((1+((V5-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = (idmultbot-1.0);

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = (idmultsti-1.0);

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = (idmultgat-1.0);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-vbbtlim)*(V5-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V5+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
vav = (0.5*(V5-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;
two_psistar = 0;
vj = 0;
zinv = 0;
vjsrh = 0;
vbbt = 0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V5-vj)));
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V5-vj)));
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK =  0.0;
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V5-vj)));
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
vbi_minus_vjsrh = 0;
wsrh = 0;
wdep = 0;
asrh = 0;
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK =  0.0;
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
I5 = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));
ISATFOR1 = isattotal;
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1));
I4_cor = (I4-(ISATFOR1*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1));
I5_cor = (I5-(ISATFOR1*(value_exp_0-1.0)));
}
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
MFOR2 = (((model_.phitd)*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2));
ISATFOR2 = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1));
double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2));
I1_cor = ((I1-(ISATFOR1*(value_exp_0-1.0)))-(ISATFOR2*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1));
double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2));
I2_cor = ((I2-(ISATFOR1*(value_exp_0-1.0)))-(ISATFOR2*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1));
double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2));
I3_cor = ((I3-(ISATFOR1*(value_exp_0-1.0)))-(ISATFOR2*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
}
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
tt1 = (((model_.phitd)*(alphaje-1))*(value_pow_0-1));
}
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
mcor_rev = (tt1/tt2);
MREV = (m0_rev+mcor_rev);
if ((fabs(((V3*(model_.phitdinv))*MREV))<1e-6))
{
m0flag = 1.0;
ISATREV = (I3_cor*((1/V3)+((0.5*(model_.phitdinv))*MREV)));
MREV = (((((-0.5)*I3_cor)*MREV)*(model_.phitdinv))/V3);
}
else
{
m0flag = 0.0;
{
double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV));
ISATREV = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
zfrac = ((model_.FJUNQ_i)*(((AB_i*(model_.cjobot))+(LS_i*(model_.cjosti)))+(LG_i*(model_.cjogat))));
if (((AB_i*(model_.cjobot))<=zfrac))
{
zflagbot = 0.0;
}
if (((LS_i*(model_.cjosti))<=zfrac))
{
zflagsti = 0.0;
}
if (((LG_i*(model_.cjogat))<=zfrac))
{
zflaggat = 0.0;
}
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1+1e-21)));
xhighf1 = value_log_0;
}
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2+1e-21)));
xhighf2 = value_log_0;
}
{
double value_fabs_0 = fabs(ISATREV);
double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1e-21)));
xhighr = value_log_1;
}
}
{
double value_min_0 = std::min(xhighf1,static_cast<double>(2.3025850929940458e+02));
xhighf1 = value_min_0;
}
{
double value_exp_0 = exp(xhighf1);
expxhf1 = value_exp_0;
}
{
double value_min_0 = std::min(xhighf2,static_cast<double>(2.3025850929940458e+02));
xhighf2 = value_min_0;
}
{
double value_exp_0 = exp(xhighf2);
expxhf2 = value_exp_0;
}
{
double value_min_0 = std::min(xhighr,static_cast<double>(2.3025850929940458e+02));
xhighr = value_min_0;
}
{
double value_exp_0 = exp(xhighr);
expxhr = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    AB(1E-12),
    LS(1e-6),
    LG(0),
    MULT(1),
    MULT_i(0.0),
    rnode(0),
    tmpv(0.0),
d_tmpv_dV_A_AIK(0.0),
    vjv(0.0),
d_vjv_dV_A_AIK(0.0),
    AB_i(0.0),
    LS_i(0.0),
    LG_i(0.0),
    zflagbot(0.0),
    zflagsti(0.0),
    zflaggat(0.0),
    VMAX(0.0),
    exp_VMAX_over_phitd(0.0),
    vbimin(0.0),
    vch(0.0),
    vfmin(0.0),
    vbbtlim(0.0),
    ijunbot(0.0),
d_ijunbot_dV_A_AIK(0.0),
    qjunbot(0.0),
d_qjunbot_dV_A_AIK(0.0),
    ijunsti(0.0),
d_ijunsti_dV_A_AIK(0.0),
    qjunsti(0.0),
d_qjunsti_dV_A_AIK(0.0),
    ijungat(0.0),
d_ijungat_dV_A_AIK(0.0),
    qjungat(0.0),
d_qjungat_dV_A_AIK(0.0),
    ijun(0.0),
d_ijun_dV_A_AIK(0.0),
    jnoise(0.0),
    VAK(0.0),
d_VAK_dV_A_AIK(0.0),
    DQAbot(0.0),
    DQAsti(0.0),
    DQAgat(0.0),
    exp_VMAX_over_phitd_bot(0.0),
d_exp_VMAX_over_phitd_bot_dV_A_AIK(0.0),
    exp_VMAX_over_phitd_sti(0.0),
d_exp_VMAX_over_phitd_sti_dV_A_AIK(0.0),
    exp_VMAX_over_phitd_gat(0.0),
d_exp_VMAX_over_phitd_gat_dV_A_AIK(0.0),
    conducts(0.0),
    jfnoise(0.0),
    jtnoise(0.0),
    isattotal(0.0),
    ijnon(0.0),
d_ijnon_dV_A_AIK(0.0),
    ijnonbot(0.0),
d_ijnonbot_dV_A_AIK(0.0),
    ijnonsti(0.0),
d_ijnonsti_dV_A_AIK(0.0),
    ijnongat(0.0),
d_ijnongat_dV_A_AIK(0.0),
    xhighf1(0.0),
    expxhf1(0.0),
    xhighf2(0.0),
    expxhf2(0.0),
    xhighr(0.0),
    expxhr(0.0),
    ISATFOR1(0.0),
    MFOR1(0.0),
    ISATFOR2(0.0),
    MFOR2(0.0),
    ISATREV(0.0),
    MREV(0.0),
    m0flag(0.0),
    TMF1(0.0),
d_TMF1_dV_A_AIK(0.0),
    TMF2(0.0),
d_TMF2_dV_A_AIK(0.0),
    Q_nqs_A(0.0),
d_Q_nqs_A_dV_charge_A_GND(0.0),
    Q_nqs_K(0.0),
d_Q_nqs_K_dV_charge_K_GND(0.0),
    Inqs0_A(0.0),
d_Inqs0_A_dV_charge_A_GND(0.0),
d_Inqs0_A_dV_A_AIK(0.0),
    Inqs0_K(0.0),
d_Inqs0_K_dV_charge_K_GND(0.0),
d_Inqs0_K_dV_A_AIK(0.0),
    W_nqs_A(0.0),
d_W_nqs_A_dV_depl_A_GND(0.0),
    IWnqs0_A(0.0),
d_IWnqs0_A_dV_depl_A_GND(0.0),
d_IWnqs0_A_dV_A_AIK(0.0),
    nj1(0.0),
d_nj1_dV_A_AIK(0.0),
    nja10(0.0),
d_nja10_dV_A_AIK(0.0),
    nja11(0.0),
d_nja11_dV_A_AIK(0.0),
    vha1(0.0),
    pnn0(0.0),
    dFn_SU(0.0),
d_dFn_SU_dV_A_AIK(0.0),
    dFn_SL(0.0),
d_dFn_SL_dV_A_AIK(0.0),
    dnj1_dV(0.0),
d_dnj1_dV_dV_A_AIK(0.0),
    dVMAX_over_phitd_dV(0.0),
d_dVMAX_over_phitd_dV_dV_A_AIK(0.0),
    idmultbot(0.0),
d_idmultbot_dV_A_AIK(0.0),
    idmultsti(0.0),
d_idmultsti_dV_A_AIK(0.0),
    idmultgat(0.0),
d_idmultgat_dV_A_AIK(0.0),
    vak(0.0),
    cj(0.0),
    cjbot(0.0),
    cjgat(0.0),
    cjsti(0.0),
    ij(0.0),
    ijbot(0.0),
    ijgat(0.0),
    ijsti(0.0),
    si(0.0),
    vrs(0.0),
    sf(0.0),
    sr(0.0),
    rseries(0.0),
    qrr(0.0),
    li_A(-1),
    li_K(-1),
    li_AIK(-1),
    li_charge_A(-1),
    li_charge_K(-1),
    li_depl_A(-1),
    li_branch_iA(-1),
    f_A_Equ_A_Node_Ptr(0),
    f_A_Equ_AIK_Node_Ptr(0),
    f_AIK_Equ_A_Node_Ptr(0),
    f_AIK_Equ_AIK_Node_Ptr(0),
    f_AIK_Equ_K_Node_Ptr(0),
    f_K_Equ_AIK_Node_Ptr(0),
    f_K_Equ_K_Node_Ptr(0),
    f_charge_A_Equ_A_Node_Ptr(0),
    f_charge_A_Equ_AIK_Node_Ptr(0),
    f_charge_A_Equ_charge_A_Node_Ptr(0),
    f_charge_K_Equ_A_Node_Ptr(0),
    f_charge_K_Equ_AIK_Node_Ptr(0),
    f_charge_K_Equ_charge_K_Node_Ptr(0),
    f_depl_A_Equ_A_Node_Ptr(0),
    f_depl_A_Equ_AIK_Node_Ptr(0),
    f_depl_A_Equ_depl_A_Node_Ptr(0),
    f_A_Equ_charge_K_Node_Ptr(0),
    f_AIK_Equ_charge_K_Node_Ptr(0),
    f_A_Equ_depl_A_Node_Ptr(0),
    f_AIK_Equ_depl_A_Node_Ptr(0),
    f_A_Equ_charge_A_Node_Ptr(0),
    f_AIK_Equ_charge_A_Node_Ptr(0),
    q_A_Equ_A_Node_Ptr(0),
    q_A_Equ_AIK_Node_Ptr(0),
    q_AIK_Equ_A_Node_Ptr(0),
    q_AIK_Equ_AIK_Node_Ptr(0),
    q_AIK_Equ_K_Node_Ptr(0),
    q_K_Equ_AIK_Node_Ptr(0),
    q_K_Equ_K_Node_Ptr(0),
    q_charge_A_Equ_A_Node_Ptr(0),
    q_charge_A_Equ_AIK_Node_Ptr(0),
    q_charge_A_Equ_charge_A_Node_Ptr(0),
    q_charge_K_Equ_A_Node_Ptr(0),
    q_charge_K_Equ_AIK_Node_Ptr(0),
    q_charge_K_Equ_charge_K_Node_Ptr(0),
    q_depl_A_Equ_A_Node_Ptr(0),
    q_depl_A_Equ_AIK_Node_Ptr(0),
    q_depl_A_Equ_depl_A_Node_Ptr(0),
    q_A_Equ_charge_K_Node_Ptr(0),
    q_AIK_Equ_charge_K_Node_Ptr(0),
    q_A_Equ_depl_A_Node_Ptr(0),
    q_AIK_Equ_depl_A_Node_Ptr(0),
    q_A_Equ_charge_A_Node_Ptr(0),
    q_AIK_Equ_charge_A_Node_Ptr(0),
    A_A_Equ_A_NodeOffset(-1),
    A_A_Equ_AIK_NodeOffset(-1),
    A_AIK_Equ_A_NodeOffset(-1),
    A_AIK_Equ_AIK_NodeOffset(-1),
    A_AIK_Equ_K_NodeOffset(-1),
    A_K_Equ_AIK_NodeOffset(-1),
    A_K_Equ_K_NodeOffset(-1),
    A_charge_A_Equ_A_NodeOffset(-1),
    A_charge_A_Equ_AIK_NodeOffset(-1),
    A_charge_A_Equ_charge_A_NodeOffset(-1),
    A_charge_K_Equ_A_NodeOffset(-1),
    A_charge_K_Equ_AIK_NodeOffset(-1),
    A_charge_K_Equ_charge_K_NodeOffset(-1),
    A_depl_A_Equ_A_NodeOffset(-1),
    A_depl_A_Equ_AIK_NodeOffset(-1),
    A_depl_A_Equ_depl_A_NodeOffset(-1),
    A_A_Equ_charge_K_NodeOffset(-1),
    A_AIK_Equ_charge_K_NodeOffset(-1),
    A_A_Equ_depl_A_NodeOffset(-1),
    A_AIK_Equ_depl_A_NodeOffset(-1),
    A_A_Equ_charge_A_NodeOffset(-1),
    A_AIK_Equ_charge_A_NodeOffset(-1),
    li_store_vak(-1),
    li_store_cj(-1),
    li_store_cjbot(-1),
    li_store_cjgat(-1),
    li_store_cjsti(-1),
    li_store_ij(-1),
    li_store_ijbot(-1),
    li_store_ijgat(-1),
    li_store_ijsti(-1),
    li_store_si(-1),
    li_store_vrs(-1),
    li_store_sf(-1),
    li_store_sr(-1),
    li_store_rseries(-1),
    li_store_qrr(-1),
    collapseNode_AIK(false),
    collapseNode_charge_A(false),
    collapseNode_charge_K(false),
    collapseNode_depl_A(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 4 + 0;
    numExtVars = 2;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+15);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 1;

  leadCurrentF.resize(2);
  leadCurrentQ.resize(2);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_A));
    jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_charge_K));
    jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_depl_A));
    jacobianElements.push_back(IntPair(admsNodeID_A,admsNodeID_charge_A));
    jacobianElements.push_back(IntPair(admsNodeID_K,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_K,admsNodeID_K));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_A));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_K));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_charge_K));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_depl_A));
    jacobianElements.push_back(IntPair(admsNodeID_AIK,admsNodeID_charge_A));
    jacobianElements.push_back(IntPair(admsNodeID_charge_A,admsNodeID_A));
    jacobianElements.push_back(IntPair(admsNodeID_charge_A,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_charge_A,admsNodeID_charge_A));
    jacobianElements.push_back(IntPair(admsNodeID_charge_K,admsNodeID_A));
    jacobianElements.push_back(IntPair(admsNodeID_charge_K,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_charge_K,admsNodeID_charge_K));
    jacobianElements.push_back(IntPair(admsNodeID_depl_A,admsNodeID_A));
    jacobianElements.push_back(IntPair(admsNodeID_depl_A,admsNodeID_AIK));
    jacobianElements.push_back(IntPair(admsNodeID_depl_A,admsNodeID_depl_A));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_AIK)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_AIK,admsNodeID_K));
  }
  if (collapseNode_charge_A)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_charge_A,admsNodeID_GND));
  }
  if (collapseNode_charge_K)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_charge_K,admsNodeID_GND));
  }
  if (collapseNode_depl_A)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_depl_A,admsNodeID_GND));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 6+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_AIK = false;
collapseNode_charge_A = false;
collapseNode_charge_K = false;
collapseNode_depl_A = false;
// begin block named loadStatic

if (!((rnode==1)))
{

collapseNode_AIK = true;

}

// end block  named loadStatic

// begin block named loadRecovery

if (!((((model_.CORECOVERY)>0)&&((model_.NQS)>0.0))))
{

collapseNode_charge_A = true;

collapseNode_charge_K = true;

}

if (!((((model_.CORECOVERY)>0)&&((model_.DEPNQS)>0.0))))
{

collapseNode_depl_A = true;

}

// end block  named loadRecovery


  if (collapseNode_AIK)
  {
    numIntVars--;
  }
  if (collapseNode_charge_A)
  {
    numIntVars--;
  }
  if (collapseNode_charge_K)
  {
    numIntVars--;
  }
  if (collapseNode_depl_A)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSDIODE_CMC::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_A = localLIDVec[nodeMap[admsNodeID_A]];
  li_K = localLIDVec[nodeMap[admsNodeID_K]];
  li_AIK = localLIDVec[nodeMap[admsNodeID_AIK]];
  if (collapseNode_charge_A)
      {
    li_charge_A = -1;
    }
  else
    {
  li_charge_A = localLIDVec[nodeMap[admsNodeID_charge_A]];
    }
  if (collapseNode_charge_K)
      {
    li_charge_K = -1;
    }
  else
    {
  li_charge_K = localLIDVec[nodeMap[admsNodeID_charge_K]];
    }
  if (collapseNode_depl_A)
      {
    li_depl_A = -1;
    }
  else
    {
  li_depl_A = localLIDVec[nodeMap[admsNodeID_depl_A]];
    }


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_A = " << li_A << std::endl;
      Xyce::dout() << "\nli_K = " << li_K << std::endl;
      Xyce::dout() << "\nli_AIK = " << li_AIK << std::endl;
      Xyce::dout() << "\nli_charge_A = " << li_charge_A << std::endl;
      Xyce::dout() << "\nli_charge_K = " << li_charge_K << std::endl;
      Xyce::dout() << "\nli_depl_A = " << li_depl_A << std::endl;

    Xyce::dout() << "\nEnd of ADMSDIODE_CMC::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    if (!collapseNode_AIK)
    {
    addInternalNode(symbol_table, li_AIK, getName(), "AIK");
    }
    if (!collapseNode_charge_A)
    {
    addInternalNode(symbol_table, li_charge_A, getName(), "charge_A");
    }
    if (!collapseNode_charge_K)
    {
    addInternalNode(symbol_table, li_charge_K, getName(), "charge_K");
    }
    if (!collapseNode_depl_A)
    {
    addInternalNode(symbol_table, li_depl_A, getName(), "depl_A");
    }
    addStoreNode(symbol_table, li_store_vak, getName().getEncodedName() + ":vak");
    addStoreNode(symbol_table, li_store_cj, getName().getEncodedName() + ":cj");
    addStoreNode(symbol_table, li_store_cjbot, getName().getEncodedName() + ":cjbot");
    addStoreNode(symbol_table, li_store_cjgat, getName().getEncodedName() + ":cjgat");
    addStoreNode(symbol_table, li_store_cjsti, getName().getEncodedName() + ":cjsti");
    addStoreNode(symbol_table, li_store_ij, getName().getEncodedName() + ":ij");
    addStoreNode(symbol_table, li_store_ijbot, getName().getEncodedName() + ":ijbot");
    addStoreNode(symbol_table, li_store_ijgat, getName().getEncodedName() + ":ijgat");
    addStoreNode(symbol_table, li_store_ijsti, getName().getEncodedName() + ":ijsti");
    addStoreNode(symbol_table, li_store_si, getName().getEncodedName() + ":si");
    addStoreNode(symbol_table, li_store_vrs, getName().getEncodedName() + ":vrs");
    addStoreNode(symbol_table, li_store_sf, getName().getEncodedName() + ":sf");
    addStoreNode(symbol_table, li_store_sr, getName().getEncodedName() + ":sr");
    addStoreNode(symbol_table, li_store_rseries, getName().getEncodedName() + ":rseries");
    addStoreNode(symbol_table, li_store_qrr, getName().getEncodedName() + ":qrr");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iA, getName(), "BRANCH_D");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_vak= stoLIDVec[i++];
      li_store_cj= stoLIDVec[i++];
      li_store_cjbot= stoLIDVec[i++];
      li_store_cjgat= stoLIDVec[i++];
      li_store_cjsti= stoLIDVec[i++];
      li_store_ij= stoLIDVec[i++];
      li_store_ijbot= stoLIDVec[i++];
      li_store_ijgat= stoLIDVec[i++];
      li_store_ijsti= stoLIDVec[i++];
      li_store_si= stoLIDVec[i++];
      li_store_vrs= stoLIDVec[i++];
      li_store_sf= stoLIDVec[i++];
      li_store_sr= stoLIDVec[i++];
      li_store_rseries= stoLIDVec[i++];
      li_store_qrr= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    li_branch_iA = branchLIDVecRef[0];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_A)];
    A_A_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_AIK)];
    A_A_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_charge_K)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_charge_K)];
    A_A_Equ_charge_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_depl_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_depl_A)];
    A_A_Equ_depl_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_A,admsNodeID_charge_A)];
    A_A_Equ_charge_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_K,admsNodeID_AIK)];
    A_K_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_K,admsNodeID_K)];
    A_K_Equ_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_A)];
    A_AIK_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_AIK)];
    A_AIK_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_K)];
    A_AIK_Equ_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
if (!collapseNode_charge_K)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_charge_K)];
    A_AIK_Equ_charge_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_depl_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_depl_A)];
    A_AIK_Equ_depl_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_AIK,admsNodeID_charge_A)];
    A_AIK_Equ_charge_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_A,admsNodeID_A)];
    A_charge_A_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_A,admsNodeID_AIK)];
    A_charge_A_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_A,admsNodeID_charge_A)];
    A_charge_A_Equ_charge_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_K)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_K,admsNodeID_A)];
    A_charge_K_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_K)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_K,admsNodeID_AIK)];
    A_charge_K_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_charge_K)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_charge_K,admsNodeID_charge_K)];
    A_charge_K_Equ_charge_K_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_depl_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_depl_A,admsNodeID_A)];
    A_depl_A_Equ_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_depl_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_depl_A,admsNodeID_AIK)];
    A_depl_A_Equ_AIK_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}
if (!collapseNode_depl_A)
{
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_depl_A,admsNodeID_depl_A)];
    A_depl_A_Equ_depl_A_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
}


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_A_Equ_A_Node_Ptr = &(dFdx[li_A][A_A_Equ_A_NodeOffset]);
    q_A_Equ_A_Node_Ptr = &(dQdx[li_A][A_A_Equ_A_NodeOffset]);
    f_A_Equ_AIK_Node_Ptr = &(dFdx[li_A][A_A_Equ_AIK_NodeOffset]);
    q_A_Equ_AIK_Node_Ptr = &(dQdx[li_A][A_A_Equ_AIK_NodeOffset]);
if (!collapseNode_charge_K)
{
    f_A_Equ_charge_K_Node_Ptr = &(dFdx[li_A][A_A_Equ_charge_K_NodeOffset]);
    q_A_Equ_charge_K_Node_Ptr = &(dQdx[li_A][A_A_Equ_charge_K_NodeOffset]);
}
if (!collapseNode_depl_A)
{
    f_A_Equ_depl_A_Node_Ptr = &(dFdx[li_A][A_A_Equ_depl_A_NodeOffset]);
    q_A_Equ_depl_A_Node_Ptr = &(dQdx[li_A][A_A_Equ_depl_A_NodeOffset]);
}
if (!collapseNode_charge_A)
{
    f_A_Equ_charge_A_Node_Ptr = &(dFdx[li_A][A_A_Equ_charge_A_NodeOffset]);
    q_A_Equ_charge_A_Node_Ptr = &(dQdx[li_A][A_A_Equ_charge_A_NodeOffset]);
}
    f_K_Equ_AIK_Node_Ptr = &(dFdx[li_K][A_K_Equ_AIK_NodeOffset]);
    q_K_Equ_AIK_Node_Ptr = &(dQdx[li_K][A_K_Equ_AIK_NodeOffset]);
    f_K_Equ_K_Node_Ptr = &(dFdx[li_K][A_K_Equ_K_NodeOffset]);
    q_K_Equ_K_Node_Ptr = &(dQdx[li_K][A_K_Equ_K_NodeOffset]);
    f_AIK_Equ_A_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_A_NodeOffset]);
    q_AIK_Equ_A_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_A_NodeOffset]);
    f_AIK_Equ_AIK_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_AIK_NodeOffset]);
    q_AIK_Equ_AIK_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_AIK_NodeOffset]);
    f_AIK_Equ_K_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_K_NodeOffset]);
    q_AIK_Equ_K_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_K_NodeOffset]);
if (!collapseNode_charge_K)
{
    f_AIK_Equ_charge_K_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_charge_K_NodeOffset]);
    q_AIK_Equ_charge_K_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_charge_K_NodeOffset]);
}
if (!collapseNode_depl_A)
{
    f_AIK_Equ_depl_A_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_depl_A_NodeOffset]);
    q_AIK_Equ_depl_A_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_depl_A_NodeOffset]);
}
if (!collapseNode_charge_A)
{
    f_AIK_Equ_charge_A_Node_Ptr = &(dFdx[li_AIK][A_AIK_Equ_charge_A_NodeOffset]);
    q_AIK_Equ_charge_A_Node_Ptr = &(dQdx[li_AIK][A_AIK_Equ_charge_A_NodeOffset]);
}
if (!collapseNode_charge_A)
{
    f_charge_A_Equ_A_Node_Ptr = &(dFdx[li_charge_A][A_charge_A_Equ_A_NodeOffset]);
    q_charge_A_Equ_A_Node_Ptr = &(dQdx[li_charge_A][A_charge_A_Equ_A_NodeOffset]);
}
if (!collapseNode_charge_A)
{
    f_charge_A_Equ_AIK_Node_Ptr = &(dFdx[li_charge_A][A_charge_A_Equ_AIK_NodeOffset]);
    q_charge_A_Equ_AIK_Node_Ptr = &(dQdx[li_charge_A][A_charge_A_Equ_AIK_NodeOffset]);
}
if (!collapseNode_charge_A)
{
    f_charge_A_Equ_charge_A_Node_Ptr = &(dFdx[li_charge_A][A_charge_A_Equ_charge_A_NodeOffset]);
    q_charge_A_Equ_charge_A_Node_Ptr = &(dQdx[li_charge_A][A_charge_A_Equ_charge_A_NodeOffset]);
}
if (!collapseNode_charge_K)
{
    f_charge_K_Equ_A_Node_Ptr = &(dFdx[li_charge_K][A_charge_K_Equ_A_NodeOffset]);
    q_charge_K_Equ_A_Node_Ptr = &(dQdx[li_charge_K][A_charge_K_Equ_A_NodeOffset]);
}
if (!collapseNode_charge_K)
{
    f_charge_K_Equ_AIK_Node_Ptr = &(dFdx[li_charge_K][A_charge_K_Equ_AIK_NodeOffset]);
    q_charge_K_Equ_AIK_Node_Ptr = &(dQdx[li_charge_K][A_charge_K_Equ_AIK_NodeOffset]);
}
if (!collapseNode_charge_K)
{
    f_charge_K_Equ_charge_K_Node_Ptr = &(dFdx[li_charge_K][A_charge_K_Equ_charge_K_NodeOffset]);
    q_charge_K_Equ_charge_K_Node_Ptr = &(dQdx[li_charge_K][A_charge_K_Equ_charge_K_NodeOffset]);
}
if (!collapseNode_depl_A)
{
    f_depl_A_Equ_A_Node_Ptr = &(dFdx[li_depl_A][A_depl_A_Equ_A_NodeOffset]);
    q_depl_A_Equ_A_Node_Ptr = &(dQdx[li_depl_A][A_depl_A_Equ_A_NodeOffset]);
}
if (!collapseNode_depl_A)
{
    f_depl_A_Equ_AIK_Node_Ptr = &(dFdx[li_depl_A][A_depl_A_Equ_AIK_NodeOffset]);
    q_depl_A_Equ_AIK_Node_Ptr = &(dQdx[li_depl_A][A_depl_A_Equ_AIK_NodeOffset]);
}
if (!collapseNode_depl_A)
{
    f_depl_A_Equ_depl_A_Node_Ptr = &(dFdx[li_depl_A][A_depl_A_Equ_depl_A_NodeOffset]);
    q_depl_A_Equ_depl_A_Node_Ptr = &(dQdx[li_depl_A][A_depl_A_Equ_depl_A_NodeOffset]);
}


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_A] += staticContributions[admsNodeID_A];
(*extData.daeFVectorPtr)[li_K] += staticContributions[admsNodeID_K];
(*extData.daeFVectorPtr)[li_AIK] += staticContributions[admsNodeID_AIK];
if (!collapseNode_charge_A)
  (*extData.daeFVectorPtr)[li_charge_A] += staticContributions[admsNodeID_charge_A];
if (!collapseNode_charge_K)
  (*extData.daeFVectorPtr)[li_charge_K] += staticContributions[admsNodeID_charge_K];
if (!collapseNode_depl_A)
  (*extData.daeFVectorPtr)[li_depl_A] += staticContributions[admsNodeID_depl_A];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_iA] = leadCurrentF[0];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_iA] = solVec[li_A] - solVec[li_K];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_A] += dynamicContributions[admsNodeID_A];
(*extData.daeQVectorPtr)[li_K] += dynamicContributions[admsNodeID_K];
(*extData.daeQVectorPtr)[li_AIK] += dynamicContributions[admsNodeID_AIK];
if (!collapseNode_charge_A)
  (*extData.daeQVectorPtr)[li_charge_A] += dynamicContributions[admsNodeID_charge_A];
if (!collapseNode_charge_K)
  (*extData.daeQVectorPtr)[li_charge_K] += dynamicContributions[admsNodeID_charge_K];
if (!collapseNode_depl_A)
  (*extData.daeQVectorPtr)[li_depl_A] += dynamicContributions[admsNodeID_depl_A];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_iA] = leadCurrentQ[0];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_vak] = vak;
  stoVec[li_store_cj] = cj;
  stoVec[li_store_cjbot] = cjbot;
  stoVec[li_store_cjgat] = cjgat;
  stoVec[li_store_cjsti] = cjsti;
  stoVec[li_store_ij] = ij;
  stoVec[li_store_ijbot] = ijbot;
  stoVec[li_store_ijgat] = ijgat;
  stoVec[li_store_ijsti] = ijsti;
  stoVec[li_store_si] = si;
  stoVec[li_store_vrs] = vrs;
  stoVec[li_store_sf] = sf;
  stoVec[li_store_sr] = sr;
  stoVec[li_store_rseries] = rseries;
  stoVec[li_store_qrr] = qrr;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one DIODE_CMC instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSDIODE_CMC::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double nj_K0=0.0;
     double d_nj_K0_dV_A_AIK=0.0;
  double nj_K1=0.0;
     double d_nj_K1_dV_A_AIK=0.0;
  double nj_K=0.0;
     double d_nj_K_dV_A_AIK=0.0;
  double exp_A=0.0;
     double d_exp_A_dV_A_AIK=0.0;
  double exp_K=0.0;
     double d_exp_K_dV_A_AIK=0.0;
  double exp_A2=0.0;
     double d_exp_A2_dV_A_AIK=0.0;
  double p_nA=0.0;
     double d_p_nA_dV_A_AIK=0.0;
  double q_pexA=0.0;
     double d_q_pexA_dV_A_AIK=0.0;
  double Q_qs_A=0.0;
     double d_Q_qs_A_dV_A_AIK=0.0;
  double q_pexA_nqs=0.0;
     double d_q_pexA_nqs_dV_A_AIK=0.0;
     double d_q_pexA_nqs_dV_charge_A_GND=0.0;
  double exp_K2=0.0;
     double d_exp_K2_dV_A_AIK=0.0;
  double p_nK=0.0;
     double d_p_nK_dV_A_AIK=0.0;
  double q_pexK=0.0;
     double d_q_pexK_dV_A_AIK=0.0;
  double Q_qs_K=0.0;
     double d_Q_qs_K_dV_A_AIK=0.0;
  double q_pexK_nqs=0.0;
     double d_q_pexK_nqs_dV_A_AIK=0.0;
     double d_q_pexK_nqs_dV_charge_K_GND=0.0;
  double Vjunc_A=0.0;
     double d_Vjunc_A_dV_A_AIK=0.0;
  double W_depA=0.0;
     double d_W_depA_dV_A_AIK=0.0;
  double W_qs_A=0.0;
     double d_W_qs_A_dV_A_AIK=0.0;
  double W_depA_nqs=0.0;
     double d_W_depA_nqs_dV_A_AIK=0.0;
     double d_W_depA_nqs_dV_depl_A_GND=0.0;
  double Q_n0=0.0;
  double Q_nexA_nqs=0.0;
     double d_Q_nexA_nqs_dV_A_AIK=0.0;
     double d_Q_nexA_nqs_dV_charge_A_GND=0.0;
     double d_Q_nexA_nqs_dV_depl_A_GND=0.0;
  double Q_nexK_nqs=0.0;
     double d_Q_nexK_nqs_dV_A_AIK=0.0;
     double d_Q_nexK_nqs_dV_charge_K_GND=0.0;
     double d_Q_nexK_nqs_dV_depl_A_GND=0.0;
  double Qrr=0.0;
     double d_Qrr_dV_A_AIK=0.0;
     double d_Qrr_dV_charge_A_GND=0.0;
     double d_Qrr_dV_depl_A_GND=0.0;
     double d_Qrr_dV_charge_K_GND=0.0;
  double vj=0.0;
     double d_vj_dV_A_AIK=0.0;
  double zinv=0.0;
     double d_zinv_dV_A_AIK=0.0;
  double z=0.0;
     double d_z_dV_A_AIK=0.0;
  double two_psistar=0.0;
     double d_two_psistar_dV_A_AIK=0.0;
  double vjlim=0.0;
     double d_vjlim_dV_A_AIK=0.0;
  double vjsrh=0.0;
     double d_vjsrh_dV_A_AIK=0.0;
  double vbbt=0.0;
     double d_vbbt_dV_A_AIK=0.0;
  double vav=0.0;
     double d_vav_dV_A_AIK=0.0;
  double tmp=0.0;
     double d_tmp_dV_A_AIK=0.0;
  double id=0.0;
     double d_id_dV_A_AIK=0.0;
  double wsrhstep=0.0;
     double d_wsrhstep_dV_A_AIK=0.0;
  double dwsrh=0.0;
     double d_dwsrh_dV_A_AIK=0.0;
  double vbi_minus_vjsrh=0.0;
     double d_vbi_minus_vjsrh_dV_A_AIK=0.0;
  double wsrh=0.0;
     double d_wsrh_dV_A_AIK=0.0;
  double wdep=0.0;
     double d_wdep_dV_A_AIK=0.0;
  double asrh=0.0;
     double d_asrh_dV_A_AIK=0.0;
  double isrh=0.0;
     double d_isrh_dV_A_AIK=0.0;
  double btat=0.0;
     double d_btat_dV_A_AIK=0.0;
  double twoatatoverthreebtat=0.0;
     double d_twoatatoverthreebtat_dV_A_AIK=0.0;
  double umaxbeforelimiting=0.0;
     double d_umaxbeforelimiting_dV_A_AIK=0.0;
  double umax=0.0;
     double d_umax_dV_A_AIK=0.0;
  double sqrtumax=0.0;
     double d_sqrtumax_dV_A_AIK=0.0;
  double umaxpoweronepointfive=0.0;
     double d_umaxpoweronepointfive_dV_A_AIK=0.0;
  double wgamma=0.0;
     double d_wgamma_dV_A_AIK=0.0;
  double wtat=0.0;
     double d_wtat_dV_A_AIK=0.0;
  double ktat=0.0;
     double d_ktat_dV_A_AIK=0.0;
  double ltat=0.0;
     double d_ltat_dV_A_AIK=0.0;
  double mtat=0.0;
     double d_mtat_dV_A_AIK=0.0;
  double xerfc=0.0;
     double d_xerfc_dV_A_AIK=0.0;
  double ysq=0.0;
     double d_ysq_dV_A_AIK=0.0;
  double terfc=0.0;
     double d_terfc_dV_A_AIK=0.0;
  double erfcpos=0.0;
     double d_erfcpos_dV_A_AIK=0.0;
  double erfctimesexpmtat=0.0;
     double d_erfctimesexpmtat_dV_A_AIK=0.0;
  double gammamax=0.0;
     double d_gammamax_dV_A_AIK=0.0;
  double itat=0.0;
     double d_itat_dV_A_AIK=0.0;
  double Fmaxr=0.0;
     double d_Fmaxr_dV_A_AIK=0.0;
  double ibbt=0.0;
     double d_ibbt_dV_A_AIK=0.0;
  double fbreakdown=0.0;
     double d_fbreakdown_dV_A_AIK=0.0;
  double tm0=0.0;
     double d_tm0_dV_A_AIK=0.0;
  double tm1=0.0;
     double d_tm1_dV_A_AIK=0.0;
  double ijunfor1=0.0;
     double d_ijunfor1_dV_A_AIK=0.0;
  double ijunfor2=0.0;
     double d_ijunfor2_dV_A_AIK=0.0;
  double ijunrev=0.0;
     double d_ijunrev_dV_A_AIK=0.0;
  double h5=0.0;
     double d_h5_dV_A_AIK=0.0;
  double h4=0.0;
     double d_h4_dV_A_AIK=0.0;
  double h3=0.0;
     double d_h3_dV_A_AIK=0.0;
  double h2d=0.0;
     double d_h2d_dV_A_AIK=0.0;
  double h2=0.0;
  double h1=0.0;
  double qjun=0.0;
     double d_qjun_dV_charge_A_GND=0.0;
     double d_qjun_dV_depl_A_GND=0.0;
     double d_qjun_dV_charge_K_GND=0.0;
     double d_qjun_dV_A_AIK=0.0;
  double VRS=0.0;
     double d_VRS_dV_AIK_K=0.0;
  double Vtotal=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (7))
  {
    probeVars.resize(7);
    d_probeVars.resize(7);
    for (int i=0;i<7;i++)
    {
      d_probeVars[i].resize(7);
      for (int j=0;j<7;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(6+0);
    d_staticContributions.resize(6+0);
    for (int i=0;i<6+0;i++)
      d_staticContributions[i].resize(7);
    dynamicContributions.resize(6+0);
    d_dynamicContributions.resize(6+0);
    for (int i=0;i<6+0;i++)
      d_dynamicContributions[i].resize(7);
  }

    noiseContribsPower.resize(3);
    noiseContribsExponent.resize(3);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<7;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<7;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_A_GND] = (*solVectorPtr)[li_A];
d_probeVars[admsProbeID_V_A_GND][admsProbeID_V_A_GND] = 1.0;
probeVars[admsProbeID_V_depl_A_GND] = ((collapseNode_depl_A)?(0):((*solVectorPtr)[li_depl_A]));
d_probeVars[admsProbeID_V_depl_A_GND][admsProbeID_V_depl_A_GND] = 1.0;
probeVars[admsProbeID_V_charge_K_GND] = ((collapseNode_charge_K)?(0):((*solVectorPtr)[li_charge_K]));
d_probeVars[admsProbeID_V_charge_K_GND][admsProbeID_V_charge_K_GND] = 1.0;
probeVars[admsProbeID_V_charge_A_GND] = ((collapseNode_charge_A)?(0):((*solVectorPtr)[li_charge_A]));
d_probeVars[admsProbeID_V_charge_A_GND][admsProbeID_V_charge_A_GND] = 1.0;
probeVars[admsProbeID_V_A_K] = (*solVectorPtr)[li_A] - (*solVectorPtr)[li_K];
d_probeVars[admsProbeID_V_A_K][admsProbeID_V_A_K] = 1.0;
probeVars[admsProbeID_V_AIK_K] = (*solVectorPtr)[li_AIK] - (*solVectorPtr)[li_K];
d_probeVars[admsProbeID_V_AIK_K][admsProbeID_V_AIK_K] = 1.0;
probeVars[admsProbeID_V_A_AIK] = (*solVectorPtr)[li_A] - (*solVectorPtr)[li_AIK];
d_probeVars[admsProbeID_V_A_AIK][admsProbeID_V_A_AIK] = 1.0;
// -- code converted from analog/code block
//Begin block evaluateStaticDynamic
{
if (((model_.TYPE)==(-1)))
{

d_VAK_dV_A_AIK = (-d_probeVars[admsProbeID_V_A_AIK][admsProbeID_V_A_AIK]);
VAK = (-(probeVars[admsProbeID_V_A_AIK]));
}
else
{

d_VAK_dV_A_AIK = d_probeVars[admsProbeID_V_A_AIK][admsProbeID_V_A_AIK];
VAK = (probeVars[admsProbeID_V_A_AIK]);
}
if (((model_.SWJUNEXP_i)==1.0))
{

d_tm0_dV_A_AIK = d_VAK_dV_A_AIK*(model_.phitdinv)*MFOR1;
tm0 = ((VAK*(model_.phitdinv))*MFOR1);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_A_AIK = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_A_AIK)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1)?expxhf1*d_tm0_dV_A_AIK:(deriv_exp_0_d0*(d_tm0_dV_A_AIK))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1)?(expxhf1*((tm0-xhighf1)+1)):value_exp_0));
}

d_ijunfor1_dV_A_AIK = ISATFOR1*d_tm1_dV_A_AIK;
ijunfor1 = (ISATFOR1*(tm1-1.0));

d_tm0_dV_A_AIK = d_VAK_dV_A_AIK*(model_.phitdinv)*MFOR2;
tm0 = ((VAK*(model_.phitdinv))*MFOR2);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_A_AIK = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_A_AIK)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2)?expxhf2*d_tm0_dV_A_AIK:(deriv_exp_0_d0*(d_tm0_dV_A_AIK))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2)?(expxhf2*((tm0-xhighf2)+1)):value_exp_0));
}

d_ijunfor2_dV_A_AIK = ISATFOR2*d_tm1_dV_A_AIK;
ijunfor2 = (ISATFOR2*(tm1-1.0));

d_ijunrev_dV_A_AIK =  0.0;
ijunrev = 0.0;
if ((m0flag>0))
{

d_ijunrev_dV_A_AIK = (VAK*d_VAK_dV_A_AIK*MREV+d_VAK_dV_A_AIK*(ISATREV+(VAK*MREV)));
ijunrev = (VAK*(ISATREV+(VAK*MREV)));
}
else
{

d_tm0_dV_A_AIK = (-d_VAK_dV_A_AIK)*(model_.phitdinv)*MREV;
tm0 = (((-VAK)*(model_.phitdinv))*MREV);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_A_AIK = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_A_AIK)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr)?expxhr*d_tm0_dV_A_AIK:(deriv_exp_0_d0*(d_tm0_dV_A_AIK))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr)?(expxhr*((tm0-xhighr)+1)):value_exp_0));
}

d_ijunrev_dV_A_AIK = (-ISATREV)*d_tm1_dV_A_AIK;
ijunrev = ((-ISATREV)*(tm1-1.0));
}

d_ijun_dV_A_AIK = ((d_ijunfor1_dV_A_AIK+d_ijunfor2_dV_A_AIK)+d_ijunrev_dV_A_AIK);
ijun = ((ijunfor1+ijunfor2)+ijunrev);

d_ijnon_dV_A_AIK = (d_ijunfor2_dV_A_AIK+d_ijunrev_dV_A_AIK);
ijnon = (ijunfor2+ijunrev);

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;
//Begin block evaluateDynamic
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);

d_h2d_dV_A_AIK = d_VAK_dV_A_AIK;
h2d = (VAK+(vch*h2));

d_h3_dV_A_AIK = d_h2d_dV_A_AIK;
h3 = (vfmin+h2d);

d_h4_dV_A_AIK = (-d_h2d_dV_A_AIK);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_A_AIK = (deriv_sqrt_0_d0*((h4*d_h4_dV_A_AIK+d_h4_dV_A_AIK*h4)));
h5 = value_sqrt_0;
}

d_vjv_dV_A_AIK = 2.0*(((h3+h5)*d_VAK_dV_A_AIK*vfmin-(VAK*vfmin)*(d_h3_dV_A_AIK+d_h5_dV_A_AIK))/(h3+h5)/(h3+h5));
vjv = (2.0*((VAK*vfmin)/(h3+h5)));
if ((zflagbot>0.5))
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvbot))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vjv*(model_.vbiinvbot)))));

d_tmpv_dV_A_AIK = (deriv_pow_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvbot))));
tmpv = value_pow_0;
}
}

d_qjunbot_dV_A_AIK = ((model_.qprefbot)*(-d_tmpv_dV_A_AIK)+(model_.qpref2bot)*(d_VAK_dV_A_AIK-d_vjv_dV_A_AIK));
qjunbot = (((model_.qprefbot)*(1-tmpv))+((model_.qpref2bot)*(VAK-vjv)));
}
else
{

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
if ((zflagsti>0.5))
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvsti))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vjv*(model_.vbiinvsti)))));

d_tmpv_dV_A_AIK = (deriv_pow_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvsti))));
tmpv = value_pow_0;
}
}

d_qjunsti_dV_A_AIK = ((model_.qprefsti)*(-d_tmpv_dV_A_AIK)+(model_.qpref2sti)*(d_VAK_dV_A_AIK-d_vjv_dV_A_AIK));
qjunsti = (((model_.qprefsti)*(1-tmpv))+((model_.qpref2sti)*(VAK-vjv)));
}
else
{

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
if ((zflaggat>0.5))
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvgat))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vjv*(model_.vbiinvgat)))));

d_tmpv_dV_A_AIK = (deriv_pow_0_d0*((-d_vjv_dV_A_AIK*(model_.vbiinvgat))));
tmpv = value_pow_0;
}
}

d_qjungat_dV_A_AIK = ((model_.qprefgat)*(-d_tmpv_dV_A_AIK)+(model_.qpref2gat)*(d_VAK_dV_A_AIK-d_vjv_dV_A_AIK));
qjungat = (((model_.qprefgat)*(1-tmpv))+((model_.qpref2gat)*(VAK-vjv)));
}
else
{

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
}
// End block evaluateDynamic
}
else
{
if ((!(((AB_i==0)&&(LS_i==0))&&(LG_i==0))))
{
h1 = ((4.0*vch)*vch);
h2 = (vch/vfmin);

d_h2d_dV_A_AIK = d_VAK_dV_A_AIK;
h2d = (VAK+(vch*h2));

d_h3_dV_A_AIK = d_h2d_dV_A_AIK;
h3 = (vfmin+h2d);

d_h4_dV_A_AIK = (-d_h2d_dV_A_AIK);
h4 = (vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_A_AIK = (deriv_sqrt_0_d0*((h4*d_h4_dV_A_AIK+d_h4_dV_A_AIK*h4)));
h5 = value_sqrt_0;
}

d_vj_dV_A_AIK = 2.0*(((h3+h5)*d_VAK_dV_A_AIK*vfmin-(VAK*vfmin)*(d_h3_dV_A_AIK+d_h5_dV_A_AIK))/(h3+h5)/(h3+h5));
vj = (2.0*((VAK*vfmin)/(h3+h5)));
if ((VAK<VMAX))
{
if ((fabs((0.5*(VAK*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(VAK*(model_.phitdinv))));
double  deriv_exp_0_d0 = value_exp_0;

d_zinv_dV_A_AIK = (deriv_exp_0_d0*(0.5*d_VAK_dV_A_AIK*(model_.phitdinv)));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(VAK*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{

d_zinv_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(-0.5*d_VAK_dV_A_AIK*(model_.phitdinv))*3.3333333333333333e-01+(-0.5*d_VAK_dV_A_AIK*(model_.phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01)))+(-0.5*d_VAK_dV_A_AIK*(model_.phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(VAK*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{

d_zinv_dV_A_AIK = 1.0e100*(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*d_VAK_dV_A_AIK*(model_.phitdinv)*3.3333333333333333e-01+0.5*d_VAK_dV_A_AIK*(model_.phitdinv)*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*d_VAK_dV_A_AIK*(model_.phitdinv)*(1.0+(0.5*(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(VAK*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK = (model_.NJDV)*d_VAK_dV_A_AIK;
nja10 = (((model_.NJDV)*(VAK-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);
}
}
if ((fabs(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_idmultbot_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))));
idmultbot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultbot_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultbot_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
idmultbot = (1.0e100*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK = (model_.NJDV)*d_VAK_dV_A_AIK;
nja10 = (((model_.NJDV)*(VAK-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);
}
}
if ((fabs(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_idmultsti_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))));
idmultsti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultsti_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultsti_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
idmultsti = (1.0e100*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK = (model_.NJDV)*d_VAK_dV_A_AIK;
nja10 = (((model_.NJDV)*(VAK-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);
}
}
if ((fabs(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_idmultgat_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))));
idmultgat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_idmultgat_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_idmultgat_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*(((nj1*d_VAK_dV_A_AIK-VAK*d_nj1_dV_A_AIK)/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
idmultgat = (1.0e100*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VAK/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((VAK-VMAX)*(model_.phitdinv)))*exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zinv_dV_A_AIK = (deriv_sqrt_0_d0*(d_VAK_dV_A_AIK*(model_.phitdinv)*exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIBOT_i));
{
double value_log_0 = log(((model_.NDIBOT_i)/pnn0));
vha1 = (((model_.NFABOT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFABOT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFABOT_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFABOT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFABOT_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFABOT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK = (((model_.NJDV)*dFn_SU)*d_dFn_SL_dV_A_AIK+(model_.NJDV)*d_dFn_SU_dV_A_AIK*dFn_SL);
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFABOT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_exp_VMAX_over_phitd_bot_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))));
exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_bot_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
exp_VMAX_over_phitd_bot = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFABOT_i)))/((model_.NFABOT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK = (model_.phitdinv)*((((nj1*nj1)*(d_nj1_dV_A_AIK-VMAX*d_dnj1_dV_dV_A_AIK)-(nj1-(VMAX*dnj1_dV))*(nj1*d_nj1_dV_A_AIK+d_nj1_dV_A_AIK*nj1))/(nj1*nj1)/(nj1*nj1))+(vha1*d_dnj1_dV_dV_A_AIK/((model_.NFABOT_i)*(model_.NJH))));
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFABOT_i)*(model_.NJH)))));

d_idmultbot_dV_A_AIK = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*d_exp_VMAX_over_phitd_bot_dV_A_AIK+((VAK-VMAX)*d_dVMAX_over_phitd_dV_dV_A_AIK+d_VAK_dV_A_AIK*dVMAX_over_phitd_dV)*exp_VMAX_over_phitd_bot);
idmultbot = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_bot);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDISTI_i));
{
double value_log_0 = log(((model_.NDISTI_i)/pnn0));
vha1 = (((model_.NFASTI_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFASTI_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFASTI_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFASTI_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFASTI_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFASTI_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK = (((model_.NJDV)*dFn_SU)*d_dFn_SL_dV_A_AIK+(model_.NJDV)*d_dFn_SU_dV_A_AIK*dFn_SL);
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFASTI_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_exp_VMAX_over_phitd_sti_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))));
exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_sti_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
exp_VMAX_over_phitd_sti = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFASTI_i)))/((model_.NFASTI_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK = (model_.phitdinv)*((((nj1*nj1)*(d_nj1_dV_A_AIK-VMAX*d_dnj1_dV_dV_A_AIK)-(nj1-(VMAX*dnj1_dV))*(nj1*d_nj1_dV_A_AIK+d_nj1_dV_A_AIK*nj1))/(nj1*nj1)/(nj1*nj1))+(vha1*d_dnj1_dV_dV_A_AIK/((model_.NFASTI_i)*(model_.NJH))));
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFASTI_i)*(model_.NJH)))));

d_idmultsti_dV_A_AIK = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*d_exp_VMAX_over_phitd_sti_dV_A_AIK+((VAK-VMAX)*d_dVMAX_over_phitd_dV_dV_A_AIK+d_VAK_dV_A_AIK*dVMAX_over_phitd_dV)*exp_VMAX_over_phitd_sti);
idmultsti = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_sti);
{
pnn0 = (((model_.Nin)*(model_.Nin))/(model_.NDIGAT_i));
{
double value_log_0 = log(((model_.NDIGAT_i)/pnn0));
vha1 = (((model_.NFAGAT_i)/(model_.phitdinv))*value_log_0);
}
if (((model_.NFAGAT_i)<(model_.NJH)))
{

d_nja10_dV_A_AIK =  0.0;
nja10 = (((model_.NJDV)*(VMAX-vha1))+(model_.NFAGAT_i));
{

d_TMF1_dV_A_AIK = (-d_nja10_dV_A_AIK);
TMF1 = (((model_.NJH)-nja10)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SU_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SU = (0.5*(1.0+(TMF1/TMF2)));

d_nja11_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nja11 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nja11_dV_A_AIK;
TMF1 = ((nja11-(model_.NFAGAT_i))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NFAGAT_i))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_dFn_SL_dV_A_AIK = 0.5*((TMF2*d_TMF1_dV_A_AIK-TMF1*d_TMF2_dV_A_AIK)/TMF2/TMF2);
dFn_SL = (0.5*(1.0+(TMF1/TMF2)));

d_nj1_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj1 = ((model_.NFAGAT_i)+(0.5*(TMF1+TMF2)));
}

d_dnj1_dV_dV_A_AIK = (((model_.NJDV)*dFn_SU)*d_dFn_SL_dV_A_AIK+(model_.NJDV)*d_dFn_SU_dV_A_AIK*dFn_SL);
dnj1_dV = (((model_.NJDV)*dFn_SU)*dFn_SL);
}
else
{

d_nj1_dV_A_AIK =  0.0;
nj1 = (model_.NFAGAT_i);

d_dnj1_dV_dV_A_AIK =  0.0;
dnj1_dV = 0.0;
}
}
if ((fabs(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_exp_VMAX_over_phitd_gat_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))));
exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_VMAX_over_phitd_gat_dV_A_AIK = 1.0e100*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*((-VMAX*d_nj1_dV_A_AIK/nj1/nj1)+(vha1*d_nj1_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
exp_VMAX_over_phitd_gat = (1.0e100*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*((VMAX/nj1)+((vha1*(nj1-(model_.NFAGAT_i)))/((model_.NFAGAT_i)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_dVMAX_over_phitd_dV_dV_A_AIK = (model_.phitdinv)*((((nj1*nj1)*(d_nj1_dV_A_AIK-VMAX*d_dnj1_dV_dV_A_AIK)-(nj1-(VMAX*dnj1_dV))*(nj1*d_nj1_dV_A_AIK+d_nj1_dV_A_AIK*nj1))/(nj1*nj1)/(nj1*nj1))+(vha1*d_dnj1_dV_dV_A_AIK/((model_.NFAGAT_i)*(model_.NJH))));
dVMAX_over_phitd_dV = ((model_.phitdinv)*(((nj1-(VMAX*dnj1_dV))/(nj1*nj1))+((vha1*dnj1_dV)/((model_.NFAGAT_i)*(model_.NJH)))));

d_idmultgat_dV_A_AIK = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*d_exp_VMAX_over_phitd_gat_dV_A_AIK+((VAK-VMAX)*d_dVMAX_over_phitd_dV_dV_A_AIK+d_VAK_dV_A_AIK*dVMAX_over_phitd_dV)*exp_VMAX_over_phitd_gat);
idmultgat = ((1+((VAK-VMAX)*dVMAX_over_phitd_dV))*exp_VMAX_over_phitd_gat);
}

idmultbot = (idmultbot-1.0);

idmultsti = (idmultsti-1.0);

idmultgat = (idmultgat-1.0);

d_z_dV_A_AIK = (-1*d_zinv_dV_A_AIK/zinv/zinv);
z = (1/zinv);
if ((VAK>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

d_two_psistar_dV_A_AIK = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_A_AIK+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_A_AIK+d_z_dV_A_AIK*(z+3.0)))))));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));

d_two_psistar_dV_A_AIK = ((-d_VAK_dV_A_AIK)+2.0*(model_.phitd)*(deriv_log_1_d0*((2*d_zinv_dV_A_AIK+(deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dV_A_AIK+d_zinv_dV_A_AIK*(1+(3*zinv)))))))));
two_psistar = ((-VAK)+(2.0*((model_.phitd)*value_log_1)));
}
}

d_vjlim_dV_A_AIK = (-d_two_psistar_dV_A_AIK);
vjlim = (vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((VAK-vjlim)*(VAK-vjlim))+((4*(model_.phitd))*(model_.phitd))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vjsrh_dV_A_AIK = 0.5*((d_VAK_dV_A_AIK+d_vjlim_dV_A_AIK)-(deriv_sqrt_0_d0*(((VAK-vjlim)*(d_VAK_dV_A_AIK-d_vjlim_dV_A_AIK)+(d_VAK_dV_A_AIK-d_vjlim_dV_A_AIK)*(VAK-vjlim)))));
vjsrh = (0.5*((VAK+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((VAK-vbbtlim)*(VAK-vbbtlim))+((4*(model_.phitr))*(model_.phitr))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vbbt_dV_A_AIK = 0.5*(d_VAK_dV_A_AIK-(deriv_sqrt_0_d0*(((VAK-vbbtlim)*d_VAK_dV_A_AIK+d_VAK_dV_A_AIK*(VAK-vbbtlim)))));
vbbt = (0.5*((VAK+vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((VAK)*(VAK))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vav_dV_A_AIK = 0.5*(d_VAK_dV_A_AIK-(deriv_sqrt_0_d0*(((VAK)*d_VAK_dV_A_AIK+d_VAK_dV_A_AIK*(VAK)))));
vav = (0.5*(VAK-value_sqrt_0));
}
}
else
{

d_idmultbot_dV_A_AIK =  0.0;
idmultbot = 0;

d_idmultsti_dV_A_AIK =  0.0;
idmultsti = 0;

d_idmultgat_dV_A_AIK =  0.0;
idmultgat = 0;

d_two_psistar_dV_A_AIK =  0.0;
two_psistar = 0;

d_vj_dV_A_AIK =  0.0;
vj = 0;

d_zinv_dV_A_AIK =  0.0;
zinv = 0;

d_vjsrh_dV_A_AIK =  0.0;
vjsrh = 0;

d_vbbt_dV_A_AIK =  0.0;
vbbt = 0;

d_vav_dV_A_AIK =  0.0;
vav = 0;
}
if ((AB_i==0))
{

d_ijunbot_dV_A_AIK =  0.0;
ijunbot = 0;

d_ijnonbot_dV_A_AIK =  0.0;
ijnonbot = 0;

d_qjunbot_dV_A_AIK =  0.0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vj*(model_.vbiinvbot)))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvbot))));
tmp = value_pow_0;
}
}

d_qjunbot_dV_A_AIK = ((model_.qprefbot)*(-d_tmp_dV_A_AIK)+(model_.qpref2bot)*(d_VAK_dV_A_AIK-d_vj_dV_A_AIK));
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(VAK-vj)));

d_id_dV_A_AIK = (model_.idsatbot)*d_idmultbot_dV_A_AIK;
id = ((model_.idsatbot)*idmultbot);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{

d_vbi_minus_vjsrh_dV_A_AIK =  0.0;
vbi_minus_vjsrh = 0;

d_wsrh_dV_A_AIK =  0.0;
wsrh = 0;

d_wdep_dV_A_AIK =  0.0;
wdep = 0;

d_asrh_dV_A_AIK =  0.0;
asrh = 0;

d_isrh_dV_A_AIK =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_A_AIK = (-d_vjsrh_dV_A_AIK);
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_A_AIK = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_A_AIK-two_psistar*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{

d_dwsrh_dV_A_AIK =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_A_AIK = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_A_AIK))+(wsrhstep*d_wsrhstep_dV_A_AIK+d_wsrhstep_dV_A_AIK*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_A_AIK))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_A_AIK)*(1-(2*(model_.PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}

d_wsrh_dV_A_AIK = (d_wsrhstep_dV_A_AIK+d_dwsrh_dV_A_AIK);
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_A_AIK = (model_.wdepnulrbot)*d_tmp_dV_A_AIK;
wdep = ((model_.wdepnulrbot)*tmp);

d_asrh_dV_A_AIK = (model_.ftdbot)*((zinv-1)*d_wdep_dV_A_AIK+d_zinv_dV_A_AIK*wdep);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));

d_isrh_dV_A_AIK = (model_.CSRHBOT_i)*(asrh*d_wsrh_dV_A_AIK+d_asrh_dV_A_AIK*wsrh);
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{

d_itat_dV_A_AIK =  0.0;
itat = 0;
}
else
{

d_btat_dV_A_AIK = (model_.btatpartbot)*((vbi_minus_vjsrh*d_wdep_dV_A_AIK*(model_.one_minus_PBOT)-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_A_AIK = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_A_AIK/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);

d_umaxbeforelimiting_dV_A_AIK = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_A_AIK = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_A_AIK = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_A_AIK))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_A_AIK = (umax*d_sqrtumax_dV_A_AIK+d_umax_dV_A_AIK*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{

d_wgamma_dV_A_AIK = (-1*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_A_AIK = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_A_AIK = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_A_AIK+d_wsrh_dV_A_AIK*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_A_AIK+d_wgamma_dV_A_AIK))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_A_AIK = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_A_AIK-btat*d_sqrtumax_dV_A_AIK)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_A_AIK = (2*(twoatatoverthreebtat*d_sqrtumax_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-d_umax_dV_A_AIK);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_A_AIK = (((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_A_AIK+(model_.atatbot)*d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-(model_.atatbot)*d_umax_dV_A_AIK)+0.5*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive));
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_A_AIK = ((ltat-1)*d_ktat_dV_A_AIK+d_ltat_dV_A_AIK*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_A_AIK = (xerfc*d_xerfc_dV_A_AIK+d_xerfc_dV_A_AIK*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_A_AIK = (-1*(model_.perfc)*d_xerfc_dV_A_AIK/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_A_AIK = (-1*(-(model_.perfc)*d_xerfc_dV_A_AIK)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*3.3333333333333333e-01+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_A_AIK = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_A_AIK+((0.29214664*d_terfc_dV_A_AIK+(model_.berfc)*(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_A_AIK+(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_A_AIK = d_erfcpos_dV_A_AIK;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(d_mtat_dV_A_AIK));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_A_AIK)*3.3333333333333333e-01+(-d_mtat_dV_A_AIK)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_A_AIK)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_A_AIK = (2*d_tmp_dV_A_AIK-d_erfcpos_dV_A_AIK);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_A_AIK = (1.77245385090551603*0.5)*((ktat*(model_.atatbot)*d_erfctimesexpmtat_dV_A_AIK-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_A_AIK)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));

d_itat_dV_A_AIK = (model_.CTATBOT_i)*((asrh*gammamax)*d_wtat_dV_A_AIK+(asrh*d_gammamax_dV_A_AIK+d_asrh_dV_A_AIK*gammamax)*wtat);
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{

d_ibbt_dV_A_AIK =  0.0;
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_A_AIK = (model_.one_over_one_minus_PBOT)*((tmp*(-d_vbbt_dV_A_AIK)*(model_.wdepnulrinvbot)-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_A_AIK)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_A_AIK = 1.0e100*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_A_AIK = (model_.CBBTBOT_i)*(((VAK*Fmaxr)*Fmaxr)*d_tmp_dV_A_AIK+((VAK*Fmaxr)*d_Fmaxr_dV_A_AIK+(VAK*d_Fmaxr_dV_A_AIK+d_VAK_dV_A_AIK*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTBOT_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{

d_fbreakdown_dV_A_AIK =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));

d_tmp_dV_A_AIK = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_A_AIK*(model_.VBRinvbot)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_A_AIK*(model_.VBRinvbot)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_A_AIK*(model_.VBRinvbot)))+(deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvbot)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOT_i)/value_fabs_0));

d_tmp_dV_A_AIK = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvbot)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_A_AIK = (-1*(-d_tmp_dV_A_AIK)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_A_AIK = d_vav_dV_A_AIK*(model_.slopebot);
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_dV_A_AIK = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_A_AIK+(((d_id_dV_A_AIK+d_isrh_dV_A_AIK)+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonbot_dV_A_AIK = (((isrh+itat)+ibbt)*d_fbreakdown_dV_A_AIK+((d_isrh_dV_A_AIK+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LS_i==0))
{

d_ijunsti_dV_A_AIK =  0.0;
ijunsti = 0;

d_ijnonsti_dV_A_AIK =  0.0;
ijnonsti = 0;

d_qjunsti_dV_A_AIK =  0.0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vj*(model_.vbiinvsti)))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvsti))));
tmp = value_pow_0;
}
}

d_qjunsti_dV_A_AIK = ((model_.qprefsti)*(-d_tmp_dV_A_AIK)+(model_.qpref2sti)*(d_VAK_dV_A_AIK-d_vj_dV_A_AIK));
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(VAK-vj)));

d_id_dV_A_AIK = (model_.idsatsti)*d_idmultsti_dV_A_AIK;
id = ((model_.idsatsti)*idmultsti);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{

d_vbi_minus_vjsrh_dV_A_AIK =  0.0;
vbi_minus_vjsrh = 0;

d_wsrh_dV_A_AIK =  0.0;
wsrh = 0;

d_wdep_dV_A_AIK =  0.0;
wdep = 0;

d_asrh_dV_A_AIK =  0.0;
asrh = 0;

d_isrh_dV_A_AIK =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_A_AIK = (-d_vjsrh_dV_A_AIK);
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_A_AIK = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_A_AIK-two_psistar*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{

d_dwsrh_dV_A_AIK =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_A_AIK = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_A_AIK))+(wsrhstep*d_wsrhstep_dV_A_AIK+d_wsrhstep_dV_A_AIK*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_A_AIK))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_A_AIK)*(1-(2*(model_.PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}

d_wsrh_dV_A_AIK = (d_wsrhstep_dV_A_AIK+d_dwsrh_dV_A_AIK);
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_A_AIK = (model_.wdepnulrsti)*d_tmp_dV_A_AIK;
wdep = ((model_.wdepnulrsti)*tmp);

d_asrh_dV_A_AIK = (model_.ftdsti)*((zinv-1)*d_wdep_dV_A_AIK+d_zinv_dV_A_AIK*wdep);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));

d_isrh_dV_A_AIK = (model_.CSRHSTI_i)*(asrh*d_wsrh_dV_A_AIK+d_asrh_dV_A_AIK*wsrh);
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{

d_itat_dV_A_AIK =  0.0;
itat = 0;
}
else
{

d_btat_dV_A_AIK = (model_.btatpartsti)*((vbi_minus_vjsrh*d_wdep_dV_A_AIK*(model_.one_minus_PSTI)-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_A_AIK = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_A_AIK/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);

d_umaxbeforelimiting_dV_A_AIK = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_A_AIK = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_A_AIK = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_A_AIK))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_A_AIK = (umax*d_sqrtumax_dV_A_AIK+d_umax_dV_A_AIK*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{

d_wgamma_dV_A_AIK = (-1*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_A_AIK = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_A_AIK = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_A_AIK+d_wsrh_dV_A_AIK*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_A_AIK+d_wgamma_dV_A_AIK))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_A_AIK = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_A_AIK-btat*d_sqrtumax_dV_A_AIK)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_A_AIK = (2*(twoatatoverthreebtat*d_sqrtumax_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-d_umax_dV_A_AIK);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_A_AIK = (((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_A_AIK+(model_.atatsti)*d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-(model_.atatsti)*d_umax_dV_A_AIK)+0.5*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive));
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_A_AIK = ((ltat-1)*d_ktat_dV_A_AIK+d_ltat_dV_A_AIK*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_A_AIK = (xerfc*d_xerfc_dV_A_AIK+d_xerfc_dV_A_AIK*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_A_AIK = (-1*(model_.perfc)*d_xerfc_dV_A_AIK/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_A_AIK = (-1*(-(model_.perfc)*d_xerfc_dV_A_AIK)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*3.3333333333333333e-01+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_A_AIK = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_A_AIK+((0.29214664*d_terfc_dV_A_AIK+(model_.berfc)*(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_A_AIK+(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_A_AIK = d_erfcpos_dV_A_AIK;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(d_mtat_dV_A_AIK));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_A_AIK)*3.3333333333333333e-01+(-d_mtat_dV_A_AIK)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_A_AIK)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_A_AIK = (2*d_tmp_dV_A_AIK-d_erfcpos_dV_A_AIK);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_A_AIK = (1.77245385090551603*0.5)*((ktat*(model_.atatsti)*d_erfctimesexpmtat_dV_A_AIK-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_A_AIK)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));

d_itat_dV_A_AIK = (model_.CTATSTI_i)*((asrh*gammamax)*d_wtat_dV_A_AIK+(asrh*d_gammamax_dV_A_AIK+d_asrh_dV_A_AIK*gammamax)*wtat);
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{

d_ibbt_dV_A_AIK =  0.0;
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_A_AIK = (model_.one_over_one_minus_PSTI)*((tmp*(-d_vbbt_dV_A_AIK)*(model_.wdepnulrinvsti)-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_A_AIK)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_A_AIK = 1.0e100*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_A_AIK = (model_.CBBTSTI_i)*(((VAK*Fmaxr)*Fmaxr)*d_tmp_dV_A_AIK+((VAK*Fmaxr)*d_Fmaxr_dV_A_AIK+(VAK*d_Fmaxr_dV_A_AIK+d_VAK_dV_A_AIK*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTSTI_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{

d_fbreakdown_dV_A_AIK =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));

d_tmp_dV_A_AIK = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_A_AIK*(model_.VBRinvsti)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_A_AIK*(model_.VBRinvsti)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_A_AIK*(model_.VBRinvsti)))+(deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvsti)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTI_i)/value_fabs_0));

d_tmp_dV_A_AIK = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvsti)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_A_AIK = (-1*(-d_tmp_dV_A_AIK)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_A_AIK = d_vav_dV_A_AIK*(model_.slopesti);
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_dV_A_AIK = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_A_AIK+(((d_id_dV_A_AIK+d_isrh_dV_A_AIK)+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnonsti_dV_A_AIK = (((isrh+itat)+ibbt)*d_fbreakdown_dV_A_AIK+((d_isrh_dV_A_AIK+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((LG_i==0))
{

d_ijungat_dV_A_AIK =  0.0;
ijungat = 0;

d_ijnongat_dV_A_AIK =  0.0;
ijnongat = 0;

d_qjungat_dV_A_AIK =  0.0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vj*(model_.vbiinvgat)))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vj_dV_A_AIK*(model_.vbiinvgat))));
tmp = value_pow_0;
}
}

d_qjungat_dV_A_AIK = ((model_.qprefgat)*(-d_tmp_dV_A_AIK)+(model_.qpref2gat)*(d_VAK_dV_A_AIK-d_vj_dV_A_AIK));
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(VAK-vj)));

d_id_dV_A_AIK = (model_.idsatgat)*d_idmultgat_dV_A_AIK;
id = ((model_.idsatgat)*idmultgat);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{

d_vbi_minus_vjsrh_dV_A_AIK =  0.0;
vbi_minus_vjsrh = 0;

d_wsrh_dV_A_AIK =  0.0;
wsrh = 0;

d_wdep_dV_A_AIK =  0.0;
wdep = 0;

d_asrh_dV_A_AIK =  0.0;
asrh = 0;

d_isrh_dV_A_AIK =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_A_AIK = (-d_vjsrh_dV_A_AIK);
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_A_AIK = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_A_AIK-two_psistar*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{

d_dwsrh_dV_A_AIK =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_A_AIK = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_A_AIK))+(wsrhstep*d_wsrhstep_dV_A_AIK+d_wsrhstep_dV_A_AIK*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_A_AIK))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_A_AIK)*(1-(2*(model_.PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}

d_wsrh_dV_A_AIK = (d_wsrhstep_dV_A_AIK+d_dwsrh_dV_A_AIK);
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_A_AIK*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_A_AIK = (model_.wdepnulrgat)*d_tmp_dV_A_AIK;
wdep = ((model_.wdepnulrgat)*tmp);

d_asrh_dV_A_AIK = (model_.ftdgat)*((zinv-1)*d_wdep_dV_A_AIK+d_zinv_dV_A_AIK*wdep);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));

d_isrh_dV_A_AIK = (model_.CSRHGAT_i)*(asrh*d_wsrh_dV_A_AIK+d_asrh_dV_A_AIK*wsrh);
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{

d_itat_dV_A_AIK =  0.0;
itat = 0;
}
else
{

d_btat_dV_A_AIK = (model_.btatpartgat)*((vbi_minus_vjsrh*d_wdep_dV_A_AIK*(model_.one_minus_PGAT)-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_A_AIK)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_A_AIK = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_A_AIK/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);

d_umaxbeforelimiting_dV_A_AIK = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_A_AIK = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_A_AIK+d_umaxbeforelimiting_dV_A_AIK*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_A_AIK = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_A_AIK))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_A_AIK = (umax*d_sqrtumax_dV_A_AIK+d_umax_dV_A_AIK*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{

d_wgamma_dV_A_AIK = (-1*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_A_AIK = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_A_AIK = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_A_AIK+d_wsrh_dV_A_AIK*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_A_AIK+d_wgamma_dV_A_AIK))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_A_AIK = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_A_AIK-btat*d_sqrtumax_dV_A_AIK)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_A_AIK = (2*(twoatatoverthreebtat*d_sqrtumax_dV_A_AIK+d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-d_umax_dV_A_AIK);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_A_AIK = (((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_A_AIK+(model_.atatgat)*d_twoatatoverthreebtat_dV_A_AIK*sqrtumax)-(model_.atatgat)*d_umax_dV_A_AIK)+0.5*(btat*d_umaxpoweronepointfive_dV_A_AIK+d_btat_dV_A_AIK*umaxpoweronepointfive));
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_A_AIK = ((ltat-1)*d_ktat_dV_A_AIK+d_ltat_dV_A_AIK*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_A_AIK = (xerfc*d_xerfc_dV_A_AIK+d_xerfc_dV_A_AIK*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_A_AIK = (-1*(model_.perfc)*d_xerfc_dV_A_AIK/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_A_AIK = (-1*(-(model_.perfc)*d_xerfc_dV_A_AIK)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*3.3333333333333333e-01+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_A_AIK)+d_mtat_dV_A_AIK))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_A_AIK = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_A_AIK+((0.29214664*d_terfc_dV_A_AIK+(model_.berfc)*(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_A_AIK+(terfc*d_terfc_dV_A_AIK+d_terfc_dV_A_AIK*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_A_AIK = d_erfcpos_dV_A_AIK;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*(d_mtat_dV_A_AIK));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_A_AIK)*3.3333333333333333e-01+(-d_mtat_dV_A_AIK)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_A_AIK)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_A_AIK = (2*d_tmp_dV_A_AIK-d_erfcpos_dV_A_AIK);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_A_AIK = (1.77245385090551603*0.5)*((ktat*(model_.atatgat)*d_erfctimesexpmtat_dV_A_AIK-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_A_AIK)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));

d_itat_dV_A_AIK = (model_.CTATGAT_i)*((asrh*gammamax)*d_wtat_dV_A_AIK+(asrh*d_gammamax_dV_A_AIK+d_asrh_dV_A_AIK*gammamax)*wtat);
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{

d_ibbt_dV_A_AIK =  0.0;
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_A_AIK = (deriv_sqrt_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv))));

d_tmp_dV_A_AIK = (deriv_pow_0_d0*((-d_vbbt_dV_A_AIK)*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_A_AIK = (model_.one_over_one_minus_PGAT)*((tmp*(-d_vbbt_dV_A_AIK)*(model_.wdepnulrinvgat)-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_A_AIK)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_A_AIK = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_A_AIK = 1.0e100*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat))*d_Fmaxr_dV_A_AIK/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_A_AIK = (model_.CBBTGAT_i)*(((VAK*Fmaxr)*Fmaxr)*d_tmp_dV_A_AIK+((VAK*Fmaxr)*d_Fmaxr_dV_A_AIK+(VAK*d_Fmaxr_dV_A_AIK+d_VAK_dV_A_AIK*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTGAT_i)*(((VAK*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{

d_fbreakdown_dV_A_AIK =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));

d_tmp_dV_A_AIK = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_A_AIK*(model_.VBRinvgat)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_A_AIK*(model_.VBRinvgat)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_A_AIK*(model_.VBRinvgat)))+(deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvgat)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGAT_i)/value_fabs_0));

d_tmp_dV_A_AIK = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_A_AIK*(model_.VBRinvgat)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_A_AIK = (-1*(-d_tmp_dV_A_AIK)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_A_AIK = d_vav_dV_A_AIK*(model_.slopegat);
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_dV_A_AIK = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_A_AIK+(((d_id_dV_A_AIK+d_isrh_dV_A_AIK)+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);

d_ijnongat_dV_A_AIK = (((isrh+itat)+ibbt)*d_fbreakdown_dV_A_AIK+((d_isrh_dV_A_AIK+d_itat_dV_A_AIK)+d_ibbt_dV_A_AIK)*fbreakdown);
ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}

d_ijun_dV_A_AIK = ((AB_i*d_ijunbot_dV_A_AIK+LS_i*d_ijunsti_dV_A_AIK)+LG_i*d_ijungat_dV_A_AIK);
ijun = (((AB_i*ijunbot)+(LS_i*ijunsti))+(LG_i*ijungat));

d_ijnon_dV_A_AIK = ((AB_i*d_ijnonbot_dV_A_AIK+LS_i*d_ijnonsti_dV_A_AIK)+LG_i*d_ijnongat_dV_A_AIK);
ijnon = (((AB_i*ijnonbot)+(LS_i*ijnonsti))+(LG_i*ijnongat));
}

d_qjun_dV_charge_A_GND = d_qjun_dV_depl_A_GND = d_qjun_dV_charge_K_GND =  0.0;
d_qjun_dV_A_AIK = ((AB_i*d_qjunbot_dV_A_AIK+LS_i*d_qjunsti_dV_A_AIK)+LG_i*d_qjungat_dV_A_AIK);
qjun = (((AB_i*qjunbot)+(LS_i*qjunsti))+(LG_i*qjungat));

d_VRS_dV_AIK_K = d_probeVars[admsProbeID_V_AIK_K][admsProbeID_V_AIK_K];
VRS = (probeVars[admsProbeID_V_AIK_K]);
Vtotal = (probeVars[admsProbeID_V_A_K]);
}
// End block evaluateStaticDynamic
if (((Vtotal>(model_.VFMAX_i))&&((model_.VFMAX_i)>1e-12)))
{
UserInfo(*this)  << "WARNING: Diode forward bias voltage is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if (((Vtotal<((-1.0)*(model_.VRMAX_i)))&&((model_.VRMAX_i)>1e-12)))
{
UserInfo(*this)  << "WARNING: Diode reverse bias voltage is less than maximum allowed value \n" << " " <<  std::endl; 
}
//Begin block evaluateRecoveryCharge
{
if (((model_.CORECOVERY)>0))
{
if (((model_.NJL)<(model_.NJH)))
{

d_nj_K0_dV_A_AIK = (model_.NJDV)*d_VAK_dV_A_AIK;
nj_K0 = (((model_.NJDV)*(VAK-(model_.V_HK)))+(model_.NJL));
{

d_TMF1_dV_A_AIK = (-d_nj_K0_dV_A_AIK);
TMF1 = (((model_.NJH)-nj_K0)-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJH))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nj_K1_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
nj_K1 = ((model_.NJH)-(0.5*(TMF1+TMF2)));
}
{

d_TMF1_dV_A_AIK = d_nj_K1_dV_A_AIK;
TMF1 = ((nj_K1-(model_.NJL))-1.0e-2);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.NJL))*1.0e-2);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_nj_K_dV_A_AIK = 0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK);
nj_K = ((model_.NJL)+(0.5*(TMF1+TMF2)));
}
}
else
{

d_nj_K_dV_A_AIK =  0.0;
nj_K = (model_.NJL);
}

d_exp_A_dV_A_AIK = d_idmultbot_dV_A_AIK;
exp_A = idmultbot;
if (((VAK-((model_.V_HK)-(model_.V_HA)))>0))
{
if ((fabs(((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))));
double  deriv_exp_0_d0 = value_exp_0;

d_exp_K_dV_A_AIK = (deriv_exp_0_d0*((model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH))))));
exp_K = value_exp_0;
}
}
else
{
if ((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))<(-2.3025850929940458e+02)))
{

d_exp_K_dV_A_AIK = (-1.0e-100*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(-(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH)))))*3.3333333333333333e-01+(-(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH)))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*3.3333333333333333e-01)))+(-(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*3.3333333333333333e-01))))))));
exp_K = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(0.5*(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*(1.0+(((-2.3025850929940458e+02)-((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH))))))*3.3333333333333333e-01))))))));
}
else
{

d_exp_K_dV_A_AIK = 1.0e100*((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*0.5*((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH))))*3.3333333333333333e-01+(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH))))*(1.0+((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(model_.phitdinv)*((((nj_K*d_VAK_dV_A_AIK-VAK*d_nj_K_dV_A_AIK)/nj_K/nj_K)-(-((model_.V_HK)-(model_.V_HA))*d_nj_K_dV_A_AIK/nj_K/nj_K))+((model_.V_HK)*d_nj_K_dV_A_AIK/((model_.NJL)*(model_.NJH))))*(1.0+(0.5*((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
exp_K = (1.0e100*(1.0+((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+(0.5*((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*(1.0+((((model_.phitdinv)*(((VAK/nj_K)-(((model_.V_HK)-(model_.V_HA))/nj_K))+(((model_.V_HK)*(nj_K-(model_.NJL)))/((model_.NJL)*(model_.NJH)))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{

d_exp_K_dV_A_AIK =  0.0;
exp_K = 1;
}
if ((((model_.INJ2)==0)||(VAK<(model_.V_HA))))
{

d_exp_A2_dV_A_AIK = d_exp_A_dV_A_AIK*(model_.INJ1);
exp_A2 = (exp_A*(model_.INJ1));
}
else
{
{
double value_log_0 = log(((model_.tkr)/(model_.tkd)));
double value_exp_1 = exp(((model_.INJT)*value_log_0));
double value_exp_2 = exp(((((-(model_.INJ2))*(VAK-(model_.V_HA)))*(VAK-(model_.V_HA)))*value_exp_1));
double  deriv_exp_2_d0 = value_exp_2;

d_exp_A2_dV_A_AIK = ((exp_A*(model_.INJ1))*(deriv_exp_2_d0*((((-(model_.INJ2))*(VAK-(model_.V_HA)))*d_VAK_dV_A_AIK+(-(model_.INJ2))*d_VAK_dV_A_AIK*(VAK-(model_.V_HA)))*value_exp_1))+d_exp_A_dV_A_AIK*(model_.INJ1)*value_exp_2);
exp_A2 = ((exp_A*(model_.INJ1))*value_exp_2);
}
}

d_exp_A2_dV_A_AIK = ((exp_A2>1e20)?0.0:d_exp_A2_dV_A_AIK);
exp_A2 = ((exp_A2>1e20)?1e20:exp_A2);

d_p_nA_dV_A_AIK = (model_.Pn0)*d_exp_A2_dV_A_AIK;
p_nA = ((model_.Pn0)*exp_A2);

d_q_pexA_dV_A_AIK = (1.6021918E-19*AB_i)*d_p_nA_dV_A_AIK;
q_pexA = ((1.6021918E-19*AB_i)*(p_nA-(model_.Pn0)));
if (((model_.NQS)>0.0))
{

d_Q_qs_A_dV_A_AIK = d_q_pexA_dV_A_AIK*(model_.NQS);
Q_qs_A = (q_pexA*(model_.NQS));

d_Q_nqs_A_dV_charge_A_GND = (model_.NQS)*d_probeVars[admsProbeID_V_charge_A_GND][admsProbeID_V_charge_A_GND];
Q_nqs_A = ((model_.NQS)*(probeVars[admsProbeID_V_charge_A_GND]));

d_Inqs0_A_dV_A_AIK = ((-d_Q_qs_A_dV_A_AIK)/(model_.NQS));
d_Inqs0_A_dV_charge_A_GND = (d_Q_nqs_A_dV_charge_A_GND/(model_.NQS));
Inqs0_A = ((Q_nqs_A-Q_qs_A)/(model_.NQS));

d_q_pexA_nqs_dV_A_AIK =  0.0;
d_q_pexA_nqs_dV_charge_A_GND = (d_Q_nqs_A_dV_charge_A_GND/(model_.NQS));
q_pexA_nqs = (Q_nqs_A/(model_.NQS));
}
else
{

d_Q_qs_A_dV_A_AIK = d_q_pexA_dV_A_AIK;
Q_qs_A = q_pexA;

d_q_pexA_nqs_dV_charge_A_GND =  0.0;
d_q_pexA_nqs_dV_A_AIK = d_Q_qs_A_dV_A_AIK;
q_pexA_nqs = Q_qs_A;
}
if ((((model_.INJ2)==0)||(VAK<(model_.V_HK))))
{

d_exp_K2_dV_A_AIK = d_exp_K_dV_A_AIK*(model_.INJ1);
exp_K2 = (exp_K*(model_.INJ1));
}
else
{
{
double value_log_0 = log(((model_.tkr)/(model_.tkd)));
double value_exp_1 = exp(((model_.INJT)*value_log_0));
double value_exp_2 = exp(((((-(model_.INJ2))*(VAK-(model_.V_HK)))*(VAK-(model_.V_HK)))*value_exp_1));
double  deriv_exp_2_d0 = value_exp_2;

d_exp_K2_dV_A_AIK = ((exp_K*(model_.INJ1))*(deriv_exp_2_d0*((((-(model_.INJ2))*(VAK-(model_.V_HK)))*d_VAK_dV_A_AIK+(-(model_.INJ2))*d_VAK_dV_A_AIK*(VAK-(model_.V_HK)))*value_exp_1))+d_exp_K_dV_A_AIK*(model_.INJ1)*value_exp_2);
exp_K2 = ((exp_K*(model_.INJ1))*value_exp_2);
}
}

d_exp_K2_dV_A_AIK = ((exp_K2>1e20)?0.0:d_exp_K2_dV_A_AIK);
exp_K2 = ((exp_K2>1e20)?1e20:exp_K2);

d_p_nK_dV_A_AIK = (model_.Pn0)*d_exp_K2_dV_A_AIK;
p_nK = ((model_.Pn0)*exp_K2);

d_q_pexK_dV_A_AIK = (1.6021918E-19*AB_i)*d_p_nK_dV_A_AIK;
q_pexK = ((1.6021918E-19*AB_i)*(p_nK-(model_.Pn0)));
if (((model_.NQS)>0.0))
{

d_Q_qs_K_dV_A_AIK = d_q_pexK_dV_A_AIK*(model_.NQS);
Q_qs_K = (q_pexK*(model_.NQS));

d_Q_nqs_K_dV_charge_K_GND = (model_.NQS)*d_probeVars[admsProbeID_V_charge_K_GND][admsProbeID_V_charge_K_GND];
Q_nqs_K = ((model_.NQS)*(probeVars[admsProbeID_V_charge_K_GND]));

d_Inqs0_K_dV_A_AIK = ((-d_Q_qs_K_dV_A_AIK)/(model_.NQS));
d_Inqs0_K_dV_charge_K_GND = (d_Q_nqs_K_dV_charge_K_GND/(model_.NQS));
Inqs0_K = ((Q_nqs_K-Q_qs_K)/(model_.NQS));

d_q_pexK_nqs_dV_A_AIK =  0.0;
d_q_pexK_nqs_dV_charge_K_GND = (d_Q_nqs_K_dV_charge_K_GND/(model_.NQS));
q_pexK_nqs = (Q_nqs_K/(model_.NQS));
}
else
{

d_Q_qs_K_dV_A_AIK = d_q_pexK_dV_A_AIK;
Q_qs_K = q_pexK;

d_q_pexK_nqs_dV_charge_K_GND =  0.0;
d_q_pexK_nqs_dV_A_AIK = d_Q_qs_K_dV_A_AIK;
q_pexK_nqs = Q_qs_K;
}

d_Vjunc_A_dV_A_AIK = (-d_VAK_dV_A_AIK);
Vjunc_A = ((model_.PB)-VAK);
{
{
double value_sqrt_0 = sqrt(((Vjunc_A*Vjunc_A)+((4.0*(model_.JUNCDLT))*(model_.JUNCDLT))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*((Vjunc_A*d_Vjunc_A_dV_A_AIK+d_Vjunc_A_dV_A_AIK*Vjunc_A)));
TMF2 = value_sqrt_0;
}

d_Vjunc_A_dV_A_AIK = 0.5*(d_Vjunc_A_dV_A_AIK+d_TMF2_dV_A_AIK);
Vjunc_A = (0.5*(Vjunc_A+TMF2));
if ((Vjunc_A<0.0))
{

d_Vjunc_A_dV_A_AIK =  0.0;
Vjunc_A = 0.0;
}
}
{
double value_sqrt_0 = sqrt((((2*1.034943e-10)*Vjunc_A)/(1.6021918E-19*(model_.NDI_i))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_W_depA_dV_A_AIK = (deriv_sqrt_0_d0*(((2*1.034943e-10)*d_Vjunc_A_dV_A_AIK/(1.6021918E-19*(model_.NDI_i)))));
W_depA = value_sqrt_0;
}
{

d_TMF1_dV_A_AIK = (-d_W_depA_dV_A_AIK);
TMF1 = (((model_.WI)-W_depA)-1.0e-7);

d_TMF2_dV_A_AIK =  0.0;
TMF2 = ((4.0*(model_.WI))*1.0e-7);

d_TMF2_dV_A_AIK = ((TMF2>0.0)?d_TMF2_dV_A_AIK:(-d_TMF2_dV_A_AIK));
TMF2 = ((TMF2>0.0)?TMF2:(-TMF2));
{
double value_sqrt_0 = sqrt(((TMF1*TMF1)+TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_TMF2_dV_A_AIK = (deriv_sqrt_0_d0*(((TMF1*d_TMF1_dV_A_AIK+d_TMF1_dV_A_AIK*TMF1)+d_TMF2_dV_A_AIK)));
TMF2 = value_sqrt_0;
}

d_W_depA_dV_A_AIK = (-0.5*(d_TMF1_dV_A_AIK+d_TMF2_dV_A_AIK));
W_depA = ((model_.WI)-(0.5*(TMF1+TMF2)));
}
if (((model_.DEPNQS)>0.0))
{

d_W_qs_A_dV_A_AIK = d_W_depA_dV_A_AIK*(model_.DEPNQS);
W_qs_A = (W_depA*(model_.DEPNQS));

d_W_nqs_A_dV_depl_A_GND = (model_.DEPNQS)*d_probeVars[admsProbeID_V_depl_A_GND][admsProbeID_V_depl_A_GND];
W_nqs_A = ((model_.DEPNQS)*(probeVars[admsProbeID_V_depl_A_GND]));

d_IWnqs0_A_dV_A_AIK = ((-d_W_qs_A_dV_A_AIK)/(model_.DEPNQS));
d_IWnqs0_A_dV_depl_A_GND = (d_W_nqs_A_dV_depl_A_GND/(model_.DEPNQS));
IWnqs0_A = ((W_nqs_A-W_qs_A)/(model_.DEPNQS));

d_W_depA_nqs_dV_A_AIK =  0.0;
d_W_depA_nqs_dV_depl_A_GND = (d_W_nqs_A_dV_depl_A_GND/(model_.DEPNQS));
W_depA_nqs = (W_nqs_A/(model_.DEPNQS));
}
else
{

d_W_qs_A_dV_A_AIK = d_W_depA_dV_A_AIK;
W_qs_A = W_depA;

d_W_depA_nqs_dV_depl_A_GND =  0.0;
d_W_depA_nqs_dV_A_AIK = d_W_qs_A_dV_A_AIK;
W_depA_nqs = W_qs_A;
}
Q_n0 = ((-(((model_.NDI_i)*AB_i)*1.6021918E-19))*(model_.WI));
{
double value_exp_0 = exp(((-(model_.WI))/(model_.La)));
double value_exp_1 = exp(((-W_depA_nqs)/(model_.La)));
double  deriv_exp_1_d0 = value_exp_1;

d_Q_nexA_nqs_dV_depl_A_GND = ((model_.La)*q_pexA_nqs)*(-(deriv_exp_1_d0*(((-d_W_depA_nqs_dV_depl_A_GND)/(model_.La)))));
d_Q_nexA_nqs_dV_charge_A_GND = (model_.La)*d_q_pexA_nqs_dV_charge_A_GND*(value_exp_0-value_exp_1);
d_Q_nexA_nqs_dV_A_AIK = (((model_.La)*q_pexA_nqs)*(-(deriv_exp_1_d0*(((-d_W_depA_nqs_dV_A_AIK)/(model_.La)))))+(model_.La)*d_q_pexA_nqs_dV_A_AIK*(value_exp_0-value_exp_1));
Q_nexA_nqs = (((model_.La)*q_pexA_nqs)*(value_exp_0-value_exp_1));
}
{
double value_exp_0 = exp(((-((model_.WI)-W_depA_nqs))/(model_.La)));
double  deriv_exp_0_d0 = value_exp_0;

d_Q_nexK_nqs_dV_depl_A_GND = ((model_.La)*q_pexK_nqs)*(deriv_exp_0_d0*(((-(-d_W_depA_nqs_dV_depl_A_GND))/(model_.La))));
d_Q_nexK_nqs_dV_charge_K_GND = (model_.La)*d_q_pexK_nqs_dV_charge_K_GND*(value_exp_0-1.0);
d_Q_nexK_nqs_dV_A_AIK = (((model_.La)*q_pexK_nqs)*(deriv_exp_0_d0*(((-(-d_W_depA_nqs_dV_A_AIK))/(model_.La))))+(model_.La)*d_q_pexK_nqs_dV_A_AIK*(value_exp_0-1.0));
Q_nexK_nqs = (((model_.La)*q_pexK_nqs)*(value_exp_0-1.0));
}

d_Qrr_dV_charge_K_GND = (-d_Q_nexK_nqs_dV_charge_K_GND);
d_Qrr_dV_depl_A_GND = (-(d_Q_nexA_nqs_dV_depl_A_GND+d_Q_nexK_nqs_dV_depl_A_GND));
d_Qrr_dV_charge_A_GND = (-d_Q_nexA_nqs_dV_charge_A_GND);
d_Qrr_dV_A_AIK = (-(d_Q_nexA_nqs_dV_A_AIK+d_Q_nexK_nqs_dV_A_AIK));
Qrr = (-((Q_n0+Q_nexA_nqs)+Q_nexK_nqs));

d_qjun_dV_charge_K_GND = (d_qjun_dV_charge_K_GND+d_Qrr_dV_charge_K_GND);
d_qjun_dV_depl_A_GND = (d_qjun_dV_depl_A_GND+d_Qrr_dV_depl_A_GND);
d_qjun_dV_charge_A_GND = (d_qjun_dV_charge_A_GND+d_Qrr_dV_charge_A_GND);
d_qjun_dV_A_AIK = (d_qjun_dV_A_AIK+d_Qrr_dV_A_AIK);
qjun = (qjun+Qrr);
(model_.TT_i) = 0.0;
}
else
{

d_Qrr_dV_charge_A_GND = d_Qrr_dV_depl_A_GND = d_Qrr_dV_charge_K_GND =  0.0;
d_Qrr_dV_A_AIK = (model_.TT_i)*(d_ijun_dV_A_AIK-d_ijnon_dV_A_AIK);
Qrr = ((model_.TT_i)*(ijun-ijnon));
}
}
// End block evaluateRecoveryCharge
//Begin block noise
{
{
double value_fabs_0 = fabs(ijnon);
double  deriv_fabs_0_d0 = (((ijnon)>=0)?(+1.0):(-1.0));
jnoise = (((2*1.6021918E-19)*MULT_i)*(((ijun-ijnon)+(2*isattotal))+value_fabs_0));
}
// I(A,AIK) <+ (white_noise(jnoise,"shot"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= jnoise;
}
{
double value_fabs_0 = fabs(ijun);
double value_pow_1 = pow((value_fabs_0*MULT_i),(model_.AF_i));
double  deriv_fabs_0_d0 = (((ijun)>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = (((value_fabs_0*MULT_i) == 0.0)?0.0:(value_pow_1*(model_.AF_i)/(value_fabs_0*MULT_i)));
jfnoise = ((model_.KF_i)*value_pow_1);
}
// I(A,AIK) <+ (flicker_noise(jfnoise,1.0,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= jfnoise;
  noiseContribsExponent[1]= 1.0;
}
jtnoise = (((((4*1.3806505E-23)*(model_.tkd))*conducts)*MULT_i)*rnode);
// I(AIK,K) <+ (white_noise(jtnoise,"thermal"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= jtnoise;
}
}
// End block noise
//Begin block loadStatic
{
// I(A,AIK) <+ (((TYPE*MULT_i)*ijun))
staticContributions[admsNodeID_A] += (((model_.TYPE)*MULT_i)*ijun);
d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK] += ((model_.TYPE)*MULT_i)*d_ijun_dV_A_AIK;
staticContributions[admsNodeID_AIK] -= (((model_.TYPE)*MULT_i)*ijun);
d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK] -= ((model_.TYPE)*MULT_i)*d_ijun_dV_A_AIK;
if ((rnode==1))
{
// I(AIK,K) <+ (((MULT_i*VRS)*conducts))
staticContributions[admsNodeID_AIK] += ((MULT_i*VRS)*conducts);
d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K] += MULT_i*d_VRS_dV_AIK_K*conducts;
staticContributions[admsNodeID_K] -= ((MULT_i*VRS)*conducts);
d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K] -= MULT_i*d_VRS_dV_AIK_K*conducts;
}
else
{
// V(AIK,K) <+ (0)
// do nothing at all
}
}
// End block loadStatic
//Begin block loadRecovery
{
if ((((model_.CORECOVERY)>0)&&((model_.NQS)>0.0)))
{
// I(charge_A,GND) <+ ((Inqs0_A+ddt(Q_nqs_A)))
dynamicContributions[admsNodeID_charge_A] += (Inqs0_A+(Q_nqs_A));
d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK] += (d_Inqs0_A_dV_A_AIK+(0.0));
d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_charge_A_GND] += (d_Inqs0_A_dV_charge_A_GND+(d_Q_nqs_A_dV_charge_A_GND));
// I(charge_K,GND) <+ ((Inqs0_K+ddt(Q_nqs_K)))
dynamicContributions[admsNodeID_charge_K] += (Inqs0_K+(Q_nqs_K));
d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK] += (d_Inqs0_K_dV_A_AIK+(0.0));
d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_charge_K_GND] += (d_Inqs0_K_dV_charge_K_GND+(d_Q_nqs_K_dV_charge_K_GND));
}
else
{
// V(charge_A,GND) <+ (0.0)
// do nothing at all
// V(charge_K,GND) <+ (0.0)
// do nothing at all
}
if ((((model_.CORECOVERY)>0)&&((model_.DEPNQS)>0.0)))
{
// I(depl_A,GND) <+ ((IWnqs0_A+ddt(W_nqs_A)))
dynamicContributions[admsNodeID_depl_A] += (IWnqs0_A+(W_nqs_A));
d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK] += (d_IWnqs0_A_dV_A_AIK+(0.0));
d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_depl_A_GND] += (d_IWnqs0_A_dV_depl_A_GND+(d_W_nqs_A_dV_depl_A_GND));
}
else
{
// V(depl_A,GND) <+ (0.0)
// do nothing at all
}
}
// End block loadRecovery
//Begin block loadDynamic
{
// I(A,AIK) <+ (ddt(((TYPE*MULT_i)*qjun)))
dynamicContributions[admsNodeID_A] += ((((model_.TYPE)*MULT_i)*qjun));
d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK] += (((model_.TYPE)*MULT_i)*d_qjun_dV_A_AIK);
d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_K_GND] += (((model_.TYPE)*MULT_i)*d_qjun_dV_charge_K_GND);
d_dynamicContributions[admsNodeID_A][admsProbeID_V_depl_A_GND] += (((model_.TYPE)*MULT_i)*d_qjun_dV_depl_A_GND);
d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_A_GND] += (((model_.TYPE)*MULT_i)*d_qjun_dV_charge_A_GND);
dynamicContributions[admsNodeID_AIK] -= ((((model_.TYPE)*MULT_i)*qjun));
d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK] -= (((model_.TYPE)*MULT_i)*d_qjun_dV_A_AIK);
d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_K_GND] -= (((model_.TYPE)*MULT_i)*d_qjun_dV_charge_K_GND);
d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_depl_A_GND] -= (((model_.TYPE)*MULT_i)*d_qjun_dV_depl_A_GND);
d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_A_GND] -= (((model_.TYPE)*MULT_i)*d_qjun_dV_charge_A_GND);
// I(A,AIK) <+ (ddt((((TYPE*MULT_i)*TT_i)*(ijun-ijnon))))
dynamicContributions[admsNodeID_A] += (((((model_.TYPE)*MULT_i)*(model_.TT_i))*(ijun-ijnon)));
d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK] += ((((model_.TYPE)*MULT_i)*(model_.TT_i))*(d_ijun_dV_A_AIK-d_ijnon_dV_A_AIK));
dynamicContributions[admsNodeID_AIK] -= (((((model_.TYPE)*MULT_i)*(model_.TT_i))*(ijun-ijnon)));
d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK] -= ((((model_.TYPE)*MULT_i)*(model_.TT_i))*(d_ijun_dV_A_AIK-d_ijnon_dV_A_AIK));
}
// End block loadDynamic
//Begin block OPinfo
{
vak = VAK;
DQAbot = (+d_qjunbot_dV_A_AIK);
DQAgat = (+d_qjungat_dV_A_AIK);
DQAsti = (+d_qjunsti_dV_A_AIK);
cjbot = ((((model_.TYPE)*MULT_i)*AB_i)*DQAbot);
cjgat = ((((model_.TYPE)*MULT_i)*LG_i)*DQAgat);
cjsti = ((((model_.TYPE)*MULT_i)*LS_i)*DQAsti);
cj = ((cjbot+cjgat)+cjsti);
if (((model_.SWJUNEXP_i)==1.0))
{
ijbot = 0.0;
ijgat = 0.0;
ijsti = 0.0;
}
else
{
ijbot = ((MULT_i*AB_i)*ijunbot);
ijgat = ((MULT_i*LG_i)*ijungat);
ijsti = ((MULT_i*LS_i)*ijunsti);
}
ij = (MULT_i*ijun);
si = jnoise;
sf = jfnoise;
if ((rnode==1))
{
sr = jtnoise;
rseries = (1.0/(MULT_i*conducts));
vrs = ((model_.TYPE)*VRS);
}
else
{
sr = 0.0;
rseries = 0.0;
vrs = 0.0;
}
qrr = Qrr;
}
// End block OPinfo


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_A_GND] =  "
         <<probeVars[admsProbeID_V_A_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_depl_A_GND] =  "
         <<probeVars[admsProbeID_V_depl_A_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_charge_K_GND] =  "
         <<probeVars[admsProbeID_V_charge_K_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_charge_A_GND] =  "
         <<probeVars[admsProbeID_V_charge_A_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_A_K] =  "
         <<probeVars[admsProbeID_V_A_K] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_AIK_K] =  "
         <<probeVars[admsProbeID_V_AIK_K] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_A_AIK] =  "
         <<probeVars[admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_A] =  "
         <<staticContributions[admsNodeID_A] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_A].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_A] =  "
         <<dynamicContributions[admsNodeID_A] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_A].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_K] =  "
         <<staticContributions[admsNodeID_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_K].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_K][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_K] =  "
         <<dynamicContributions[admsNodeID_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_K].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_K][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_AIK] =  "
         <<staticContributions[admsNodeID_AIK] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_AIK].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_AIK] =  "
         <<dynamicContributions[admsNodeID_AIK] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_AIK].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_charge_A] =  "
         <<staticContributions[admsNodeID_charge_A] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_charge_A] =  "
         <<dynamicContributions[admsNodeID_charge_A] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_A].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_charge_K] =  "
         <<staticContributions[admsNodeID_charge_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_charge_K] =  "
         <<dynamicContributions[admsNodeID_charge_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_charge_K].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_depl_A] =  "
         <<staticContributions[admsNodeID_depl_A] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_GND) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_K) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_AIK_K) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_AIK) =  " <<d_staticContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_depl_A] =  "
         <<dynamicContributions[admsNodeID_depl_A] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_GND) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_depl_A_GND) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_depl_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_charge_K_GND) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_charge_K_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_charge_A_GND) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_charge_A_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_K) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_AIK_K) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_AIK_K] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_depl_A].dx(admsProbeID_V_A_AIK) =  " <<d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 2 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 6; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 2 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 3;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_A_AIK")+std::string("_")+std::string("shot");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_A;
noiseData.li_Neg[0]=li_AIK;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_A_AIK")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_A;
noiseData.li_Neg[1]=li_AIK;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_AIK_K")+std::string("_")+std::string("thermal");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_AIK;
noiseData.li_Neg[2]=li_K;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];

      noiseData.noiseDens[1] /= pow(noiseData.freq,noiseContribsExponent[1]);noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_A_Equ_A_Node_Ptr) +=  +d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  (*f_A_Equ_AIK_Node_Ptr) +=  -d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  (*f_AIK_Equ_A_Node_Ptr) +=  +d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  (*f_AIK_Equ_AIK_Node_Ptr) +=  +d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K] -d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  (*f_AIK_Equ_K_Node_Ptr) +=  -d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K];
  (*f_K_Equ_AIK_Node_Ptr) +=  +d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K];
  (*f_K_Equ_K_Node_Ptr) +=  -d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K];

#else
  //use the offsets instead of pointers
  dFdx[li_A][A_A_Equ_A_NodeOffset] +=  +d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  dFdx[li_A][A_A_Equ_AIK_NodeOffset] +=  -d_staticContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  dFdx[li_AIK][A_AIK_Equ_A_NodeOffset] +=  +d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  dFdx[li_AIK][A_AIK_Equ_AIK_NodeOffset] +=  +d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K] -d_staticContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  dFdx[li_AIK][A_AIK_Equ_K_NodeOffset] +=  -d_staticContributions[admsNodeID_AIK][admsProbeID_V_AIK_K];
  dFdx[li_K][A_K_Equ_AIK_NodeOffset] +=  +d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K];
  dFdx[li_K][A_K_Equ_K_NodeOffset] +=  -d_staticContributions[admsNodeID_K][admsProbeID_V_AIK_K];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_A_Equ_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  (*q_A_Equ_AIK_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  (*q_AIK_Equ_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  (*q_AIK_Equ_AIK_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
if (!collapseNode_charge_A)
{
  (*q_charge_A_Equ_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_A)
{
  (*q_charge_A_Equ_AIK_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_A)
{
  (*q_charge_A_Equ_charge_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_charge_A_GND];
}
if (!collapseNode_charge_K)
{
  (*q_charge_K_Equ_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_K)
{
  (*q_charge_K_Equ_AIK_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_K)
{
  (*q_charge_K_Equ_charge_K_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_depl_A)
{
  (*q_depl_A_Equ_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_depl_A)
{
  (*q_depl_A_Equ_AIK_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_depl_A)
{
  (*q_depl_A_Equ_depl_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_charge_K)
{
  (*q_A_Equ_charge_K_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_charge_K)
{
  (*q_AIK_Equ_charge_K_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_depl_A)
{
  (*q_A_Equ_depl_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_depl_A)
{
  (*q_AIK_Equ_depl_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_charge_A)
{
  (*q_A_Equ_charge_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_A_GND];
}
if (!collapseNode_charge_A)
{
  (*q_AIK_Equ_charge_A_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_A_GND];
}

#else
  //use the offsets instead of pointers
  dQdx[li_A][A_A_Equ_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  dQdx[li_A][A_A_Equ_AIK_NodeOffset] +=  -d_dynamicContributions[admsNodeID_A][admsProbeID_V_A_AIK];
  dQdx[li_AIK][A_AIK_Equ_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
  dQdx[li_AIK][A_AIK_Equ_AIK_NodeOffset] +=  -d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_A_AIK];
if (!collapseNode_charge_A)
{
  dQdx[li_charge_A][A_charge_A_Equ_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_A)
{
  dQdx[li_charge_A][A_charge_A_Equ_AIK_NodeOffset] +=  -d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_A)
{
  dQdx[li_charge_A][A_charge_A_Equ_charge_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_charge_A][admsProbeID_V_charge_A_GND];
}
if (!collapseNode_charge_K)
{
  dQdx[li_charge_K][A_charge_K_Equ_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_K)
{
  dQdx[li_charge_K][A_charge_K_Equ_AIK_NodeOffset] +=  -d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_A_AIK];
}
if (!collapseNode_charge_K)
{
  dQdx[li_charge_K][A_charge_K_Equ_charge_K_NodeOffset] +=  +d_dynamicContributions[admsNodeID_charge_K][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_depl_A)
{
  dQdx[li_depl_A][A_depl_A_Equ_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_depl_A)
{
  dQdx[li_depl_A][A_depl_A_Equ_AIK_NodeOffset] +=  -d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_A_AIK];
}
if (!collapseNode_depl_A)
{
  dQdx[li_depl_A][A_depl_A_Equ_depl_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_depl_A][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_charge_K)
{
  dQdx[li_A][A_A_Equ_charge_K_NodeOffset] +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_charge_K)
{
  dQdx[li_AIK][A_AIK_Equ_charge_K_NodeOffset] +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_K_GND];
}
if (!collapseNode_depl_A)
{
  dQdx[li_A][A_A_Equ_depl_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_depl_A)
{
  dQdx[li_AIK][A_AIK_Equ_depl_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_depl_A_GND];
}
if (!collapseNode_charge_A)
{
  dQdx[li_A][A_A_Equ_charge_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_A][admsProbeID_V_charge_A_GND];
}
if (!collapseNode_charge_A)
{
  dQdx[li_AIK][A_AIK_Equ_charge_A_NodeOffset] +=  +d_dynamicContributions[admsNodeID_AIK][admsProbeID_V_charge_A_GND];
}


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter TYPE : [ (-1.0), 1.0 ]
  if ( (!((TYPE >=(-1.0) && TYPE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TYPE value " << TYPE << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter IMAX : [ 1E-12,  (+inf) [
  if ( (!((IMAX >=1E-12))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter IMAX value " << IMAX << " out of range [ 1E-12,  (+inf) [";
  }

//    Parameter TRJ : [ (-250),  (+inf) [
  if ( (!((TRJ >=(-250)))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TRJ value " << TRJ << " out of range [ (-250),  (+inf) [";
  }

//    Parameter CJORBOT : [ 1E-12,  (+inf) [
  if ( (!((CJORBOT >=1E-12))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CJORBOT value " << CJORBOT << " out of range [ 1E-12,  (+inf) [";
  }

//    Parameter CJORSTI : [ 1E-18,  (+inf) [
  if ( (!((CJORSTI >=1E-18))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CJORSTI value " << CJORSTI << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter CJORGAT : [ 1E-18,  (+inf) [
  if ( (!((CJORGAT >=1E-18))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CJORGAT value " << CJORGAT << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter VBIRBOT : [ 0.050,  (+inf) [
  if ( (!((VBIRBOT >=0.050))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRSTI : [ 0.050,  (+inf) [
  if ( (!((VBIRSTI >=0.050))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRGAT : [ 0.050,  (+inf) [
  if ( (!((VBIRGAT >=0.050))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter PBOT : [ 0.05, 0.95 ]
  if ( (!((PBOT >=0.05 && PBOT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PBOT value " << PBOT << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PSTI : [ 0.05, 0.95 ]
  if ( (!((PSTI >=0.05 && PSTI <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PSTI value " << PSTI << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PGAT : [ 0.05, 0.95 ]
  if ( (!((PGAT >=0.05 && PGAT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PGAT value " << PGAT << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter IDSATRBOT : [ 0,  (+inf) [
  if ( (!((IDSATRBOT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRSTI : [ 0,  (+inf) [
  if ( (!((IDSATRSTI >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRGAT : [ 0,  (+inf) [
  if ( (!((IDSATRGAT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHBOT : [ 0,  (+inf) [
  if ( (!((CSRHBOT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHSTI : [ 0,  (+inf) [
  if ( (!((CSRHSTI >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHGAT : [ 0,  (+inf) [
  if ( (!((CSRHGAT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter XJUNSTI : [ 1E-9,  (+inf) [
  if ( (!((XJUNSTI >=1E-9))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter XJUNGAT : [ 1E-9,  (+inf) [
  if ( (!((XJUNGAT >=1E-9))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter CTATBOT : [ 0,  (+inf) [
  if ( (!((CTATBOT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CTATBOT value " << CTATBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATSTI : [ 0,  (+inf) [
  if ( (!((CTATSTI >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CTATSTI value " << CTATSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATGAT : [ 0,  (+inf) [
  if ( (!((CTATGAT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CTATGAT value " << CTATGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter MEFFTATBOT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATBOT >=0.01))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATSTI : [ 0.01,  (+inf) [
  if ( (!((MEFFTATSTI >=0.01))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATGAT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATGAT >=0.01))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter CBBTBOT : [ 0,  (+inf) [
  if ( (!((CBBTBOT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTSTI : [ 0,  (+inf) [
  if ( (!((CBBTSTI >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTGAT : [ 0,  (+inf) [
  if ( (!((CBBTGAT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter FREV : [ 1E3, 1E10 ]
  if ( (!((FREV >=1E3 && FREV <=1E10 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter FREV value " << FREV << " out of range [ 1E3, 1E10 ]";
  }

//    Parameter RSBOT : [ 0.0,  (+inf) [
  if ( (!((RSBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter RSBOT value " << RSBOT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RSSTI : [ 0.0,  (+inf) [
  if ( (!((RSSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter RSSTI value " << RSSTI << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RSGAT : [ 0.0,  (+inf) [
  if ( (!((RSGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter RSGAT value " << RSGAT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RSCOM : [ 0.0,  (+inf) [
  if ( (!((RSCOM >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter RSCOM value " << RSCOM << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter STRS : [ 0.0,  (+inf) [
  if ( (!((STRS >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter STRS value " << STRS << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter KF : [ 0.0,  (+inf) [
  if ( (!((KF >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter KF value " << KF << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter AF : [ 0.1,  (+inf) [
  if ( (!((AF >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter AF value " << AF << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter TT : [ 0,  (+inf) [
  if ( (!((TT >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TT value " << TT << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFABOT : [ 0.1,  (+inf) [
  if ( (!((NFABOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NFABOT value " << NFABOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter NFASTI : [ 0.1,  (+inf) [
  if ( (!((NFASTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NFASTI value " << NFASTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter NFAGAT : [ 0.1,  (+inf) [
  if ( (!((NFAGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NFAGAT value " << NFAGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter ABMIN : [ 0,  (+inf) [
  if ( (!((ABMIN >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter ABMIN value " << ABMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter ABMAX : [ 0,  (+inf) [
  if ( (!((ABMAX >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter ABMAX value " << ABMAX << " out of range [ 0,  (+inf) [";
  }

//    Parameter LSMIN : [ 0,  (+inf) [
  if ( (!((LSMIN >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LSMIN value " << LSMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter LSMAX : [ 0,  (+inf) [
  if ( (!((LSMAX >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LSMAX value " << LSMAX << " out of range [ 0,  (+inf) [";
  }

//    Parameter LGMIN : [ 0,  (+inf) [
  if ( (!((LGMIN >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LGMIN value " << LGMIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter LGMAX : [ 0,  (+inf) [
  if ( (!((LGMAX >=0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter LGMAX value " << LGMAX << " out of range [ 0,  (+inf) [";
  }

//    Parameter TEMPMIN : [ (-250),  (+inf) [
  if ( (!((TEMPMIN >=(-250)))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TEMPMIN value " << TEMPMIN << " out of range [ (-250),  (+inf) [";
  }

//    Parameter TEMPMAX : [ (-250),  (+inf) [
  if ( (!((TEMPMAX >=(-250)))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TEMPMAX value " << TEMPMAX << " out of range [ (-250),  (+inf) [";
  }

//    Parameter VFMAX : [ 0.0,  (+inf) [
  if ( (!((VFMAX >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VFMAX value " << VFMAX << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter VRMAX : [ 0.0,  (+inf) [
  if ( (!((VRMAX >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VRMAX value " << VRMAX << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter XTI : [ 0.1,  (+inf) [
  if ( (!((XTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter XTI value " << XTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter SCALE : [ 0, 1.0 ]
  if ( (!((SCALE >=0 && SCALE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter SCALE value " << SCALE << " out of range [ 0, 1.0 ]";
  }

//    Parameter SHRINK : [ 0, 100 ]
  if ( (!((SHRINK >=0 && SHRINK <=100 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter SHRINK value " << SHRINK << " out of range [ 0, 100 ]";
  }

//    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

//    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CORECOVERY : [ 0.0, 1.0 ]
  if ( (!((CORECOVERY >=0.0 && CORECOVERY <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter CORECOVERY value " << CORECOVERY << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter NJH : [ 0.5, 5 ]
  if ( (!((NJH >=0.5 && NJH <=5 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NJH value " << NJH << " out of range [ 0.5, 5 ]";
  }

//    Parameter NJDV : [ 0, 1e6 ]
  if ( (!((NJDV >=0 && NJDV <=1e6 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NJDV value " << NJDV << " out of range [ 0, 1e6 ]";
  }

//    Parameter NDIBOT : [ 1, 1e23 ]
  if ( (!((NDIBOT >=1 && NDIBOT <=1e23 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NDIBOT value " << NDIBOT << " out of range [ 1, 1e23 ]";
  }

//    Parameter NDIGAT : [ 1, 1e23 ]
  if ( (!((NDIGAT >=1 && NDIGAT <=1e23 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NDIGAT value " << NDIGAT << " out of range [ 1, 1e23 ]";
  }

//    Parameter NDISTI : [ 1, 1e23 ]
  if ( (!((NDISTI >=1 && NDISTI <=1e23 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NDISTI value " << NDISTI << " out of range [ 1, 1e23 ]";
  }

//    Parameter INJ1 : [ 0, 3 ]
  if ( (!((INJ1 >=0 && INJ1 <=3 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter INJ1 value " << INJ1 << " out of range [ 0, 3 ]";
  }

//    Parameter INJ2 : [ 0, 20 ]
  if ( (!((INJ2 >=0 && INJ2 <=20 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter INJ2 value " << INJ2 << " out of range [ 0, 20 ]";
  }

//    Parameter NQS : [ 0, 1e-3 ]
  if ( (!((NQS >=0 && NQS <=1e-3 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter NQS value " << NQS << " out of range [ 0, 1e-3 ]";
  }

//    Parameter TAU : [ 0, 1e-3 ]
  if ( (!((TAU >=0 && TAU <=1e-3 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TAU value " << TAU << " out of range [ 0, 1e-3 ]";
  }

//    Parameter WI : [ 0, 1.0 ]
  if ( (!((WI >=0 && WI <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter WI value " << WI << " out of range [ 0, 1.0 ]";
  }

//    Parameter DEPNQS : [ 0, 1e-3 ]
  if ( (!((DEPNQS >=0 && DEPNQS <=1e-3 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter DEPNQS value " << DEPNQS << " out of range [ 0, 1e-3 ]";
  }

//    Parameter TNOM : [ (-250),  (+inf) [
  if ( (!((TNOM >=(-250)))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TNOM value " << TNOM << " out of range [ (-250),  (+inf) [";
  }

//    Parameter TAUT : [ 0.0, 1.0e2 ]
  if ( (!((TAUT >=0.0 && TAUT <=1.0e2 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter TAUT value " << TAUT << " out of range [ 0.0, 1.0e2 ]";
  }

//    Parameter INJT : [ 0, 20 ]
  if ( (!((INJT >=0 && INJT <=20 ))) )
  {
    UserWarning(*this) << "ADMSDIODE_CMC: Parameter INJT value " << INJT << " out of range [ 0, 20 ]";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double tau_HL=0.0;
  double T2=0.0;
  double Da=0.0;
  double Dp=0.0;
  double Dn=0.0;
  double T1=0.0;
  double MUEP_i=0.0;
  double MUEN_i=0.0;
  double deltaEgat=0.0;
  double deltaEsti=0.0;
  double deltaEbot=0.0;
  double ubigat=0.0;
  double ubisti=0.0;
  double ubibot=0.0;
  double ftdgat2=0.0;
  double ftdsti2=0.0;
  double ftdbot2=0.0;
  double phigdgat=0.0;
  double phigdsti=0.0;
  double phigdbot=0.0;
  double deltaphigd=0.0;
  double phigrgat=0.0;
  double phigrsti=0.0;
  double phigrbot=0.0;
  double deltaphigr=0.0;
  double phitrinv=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
  double SHRINK_i=0.0;
  double XTI_i=0.0;
  double STVBRGAT2_i=0.0;
  double STVBRGAT1_i=0.0;
  double STVBRSTI2_i=0.0;
  double STVBRSTI1_i=0.0;
  double STVBRBOT2_i=0.0;
  double STVBRBOT1_i=0.0;
  double STRS_i=0.0;
  double RSCOM_i=0.0;
  double RSGAT_i=0.0;
  double RSSTI_i=0.0;
  double RSBOT_i=0.0;
  double FREV_i=0.0;
  double STFBBTGAT_i=0.0;
  double STFBBTSTI_i=0.0;
  double STFBBTBOT_i=0.0;
  double FBBTRGAT_i=0.0;
  double FBBTRSTI_i=0.0;
  double FBBTRBOT_i=0.0;
  double MEFFTATGAT_i=0.0;
  double MEFFTATSTI_i=0.0;
  double MEFFTATBOT_i=0.0;
  double XJUNGAT_i=0.0;
  double XJUNSTI_i=0.0;
  double IDSATRGAT_i=0.0;
  double IDSATRSTI_i=0.0;
  double IDSATRBOT_i=0.0;
  double PHIGGAT_i=0.0;
  double PHIGSTI_i=0.0;
  double PHIGBOT_i=0.0;
  double CJORGAT_i=0.0;
  double CJORSTI_i=0.0;
  double CJORBOT_i=0.0;
  double TRJ_i=0.0;
  double EPSSI=0.0;
//Begin block initial_model
{
EPSSI = (8.8541878176E-12*11.8);
TRJ_i = ((TRJ>(-250))?TRJ:(-250));
if (((!given("TRJ"))&&given("TNOM")))
{
TRJ_i = ((TNOM>(-250))?TNOM:(-250));
}
IMAX_i = ((IMAX>1E-12)?IMAX:1E-12);
CJORBOT_i = ((CJORBOT>1E-12)?CJORBOT:1E-12);
CJORSTI_i = ((CJORSTI>1E-18)?CJORSTI:1E-18);
CJORGAT_i = ((CJORGAT>1E-18)?CJORGAT:1E-18);
VBIRBOT_i = ((VBIRBOT>0.050)?VBIRBOT:0.050);
VBIRSTI_i = ((VBIRSTI>0.050)?VBIRSTI:0.050);
VBIRGAT_i = ((VBIRGAT>0.050)?VBIRGAT:0.050);
PBOT_i = ((PBOT>0.05)?((PBOT<0.95)?PBOT:0.95):0.05);
PSTI_i = ((PSTI>0.05)?((PSTI<0.95)?PSTI:0.95):0.05);
PGAT_i = ((PGAT>0.05)?((PGAT<0.95)?PGAT:0.95):0.05);
PHIGBOT_i = PHIGBOT;
PHIGSTI_i = PHIGSTI;
PHIGGAT_i = PHIGGAT;
IDSATRBOT_i = ((IDSATRBOT>0)?IDSATRBOT:0);
IDSATRSTI_i = ((IDSATRSTI>0)?IDSATRSTI:0);
IDSATRGAT_i = ((IDSATRGAT>0)?IDSATRGAT:0);
CSRHBOT_i = ((CSRHBOT>0)?CSRHBOT:0);
CSRHSTI_i = ((CSRHSTI>0)?CSRHSTI:0);
CSRHGAT_i = ((CSRHGAT>0)?CSRHGAT:0);
XJUNSTI_i = ((XJUNSTI>1E-9)?XJUNSTI:1E-9);
XJUNGAT_i = ((XJUNGAT>1E-9)?XJUNGAT:1E-9);
CTATBOT_i = ((CTATBOT>0)?CTATBOT:0);
CTATSTI_i = ((CTATSTI>0)?CTATSTI:0);
CTATGAT_i = ((CTATGAT>0)?CTATGAT:0);
MEFFTATBOT_i = ((MEFFTATBOT>0.01)?MEFFTATBOT:0.01);
MEFFTATSTI_i = ((MEFFTATSTI>0.01)?MEFFTATSTI:0.01);
MEFFTATGAT_i = ((MEFFTATGAT>0.01)?MEFFTATGAT:0.01);
CBBTBOT_i = ((CBBTBOT>0)?CBBTBOT:0);
CBBTSTI_i = ((CBBTSTI>0)?CBBTSTI:0);
CBBTGAT_i = ((CBBTGAT>0)?CBBTGAT:0);
FBBTRBOT_i = FBBTRBOT;
FBBTRSTI_i = FBBTRSTI;
FBBTRGAT_i = FBBTRGAT;
STFBBTBOT_i = STFBBTBOT;
STFBBTSTI_i = STFBBTSTI;
STFBBTGAT_i = STFBBTGAT;
VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
FREV_i = FREV;
RSBOT_i = ((RSBOT>0.0)?RSBOT:0.0);
RSSTI_i = ((RSSTI>0.0)?RSSTI:0.0);
RSGAT_i = ((RSGAT>0.0)?RSGAT:0.0);
RSCOM_i = ((RSCOM>0.0)?RSCOM:0.0);
STRS_i = ((STRS>0.0)?STRS:0.0);
AF_i = ((AF>0.1)?AF:0.1);
KF_i = ((KF>0.0)?KF:0.0);
TT_i = ((TT>0)?TT:0);
STVBRBOT1_i = STVBRBOT1;
STVBRBOT2_i = STVBRBOT2;
STVBRSTI1_i = STVBRSTI1;
STVBRSTI2_i = STVBRSTI2;
STVBRGAT1_i = STVBRGAT1;
STVBRGAT2_i = STVBRGAT2;
NFABOT_i = ((NFABOT>0.1)?NFABOT:0.1);
NFASTI_i = ((NFASTI>0.1)?NFASTI:0.1);
NFAGAT_i = ((NFAGAT>0.1)?NFAGAT:0.1);
ABMIN_i = ((ABMIN>0)?ABMIN:0);
ABMAX_i = ((ABMAX>0)?ABMAX:0);
LSMIN_i = ((LSMIN>0)?LSMIN:0);
LSMAX_i = ((LSMAX>0)?LSMAX:0);
LGMIN_i = ((LGMIN>0)?LGMIN:0);
LGMAX_i = ((LGMAX>0)?LGMAX:0);
TEMPMIN_i = ((TEMPMIN>(-250))?TEMPMIN:(-250));
TEMPMAX_i = ((TEMPMAX>(-250))?TEMPMAX:(-250));
VFMAX_i = ((VFMAX>0.0)?VFMAX:0.0);
VRMAX_i = ((VRMAX>0.0)?VRMAX:0.0);
XTI_i = ((XTI>0.1)?XTI:0.1);
SCALE_i = ((SCALE>0)?SCALE:0);
SHRINK_i = ((SHRINK>0)?SHRINK:0);
SWJUNEXP_i = 0.0;
if ((SWJUNEXP>0.5))
{
SWJUNEXP_i = 1.0;
}
else
{
SWJUNEXP_i = 0.0;
}
VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsModTemp+DTA),(273.15+(-250)));
tkd = value_max_0;
}
auxt = (tkd/tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
phitr = (KBOL_over_QELE*tkr);
phitrinv = (1.0/phitr);
phitd = (KBOL_over_QELE*tkd);
phitdinv = (1.0/phitd);
deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
phigrbot = (PHIGBOT_i+deltaphigr);
phigrsti = (PHIGSTI_i+deltaphigr);
phigrgat = (PHIGGAT_i+deltaphigr);
deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
phigdbot = (PHIGBOT_i+deltaphigd);
phigdsti = (PHIGSTI_i+deltaphigd);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv))));
ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv))));
ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv))));
ftdgat = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/NFABOT_i));
double value_exp_1 = exp(((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv)))/NFABOT_i));
ftdbot2 = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/NFASTI_i));
double value_exp_1 = exp(((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv)))/NFASTI_i));
ftdsti2 = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/NFAGAT_i));
double value_exp_1 = exp(((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv)))/NFAGAT_i));
ftdgat2 = (value_pow_0*value_exp_1);
}
idsatbot = ((IDSATRBOT_i*ftdbot2)*ftdbot2);
idsatsti = ((IDSATRSTI_i*ftdsti2)*ftdsti2);
idsatgat = ((IDSATRGAT_i*ftdgat2)*ftdgat2);
{
double value_log_0 = log(ftdbot);
ubibot = ((VBIRBOT_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdsti);
ubisti = ((VBIRSTI_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdgat);
ubigat = ((VBIRGAT_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbibot = (ubibot+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbisti = (ubisti+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbigat = (ubigat+(phitd*value_log_1));
}
vbiinvbot = (1.0/vbibot);
vbiinvsti = (1.0/vbisti);
vbiinvgat = (1.0/vbigat);
one_minus_PBOT = (1-PBOT_i);
one_minus_PSTI = (1-PSTI_i);
one_minus_PGAT = (1-PGAT_i);
one_over_one_minus_PBOT = (1/one_minus_PBOT);
one_over_one_minus_PSTI = (1/one_minus_PSTI);
one_over_one_minus_PGAT = (1/one_minus_PGAT);
{
double value_pow_0 = pow((VBIRBOT_i*vbiinvbot),PBOT_i);
cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRSTI_i*vbiinvsti),PSTI_i);
cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRGAT_i*vbiinvgat),PGAT_i);
cjogat = (CJORGAT_i*value_pow_0);
}
qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
qpref2bot = (2*cjobot);
qpref2sti = (2*cjosti);
qpref2gat = (2*cjogat);
wdepnulrbot = (EPSSI/CJORBOT_i);
wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
wdepnulrinvbot = (1/wdepnulrbot);
wdepnulrinvsti = (1/wdepnulrsti);
wdepnulrinvgat = (1/wdepnulrgat);
VBIRBOTinv = (1/VBIRBOT_i);
VBIRSTIinv = (1/VBIRSTI_i);
VBIRGATinv = (1/VBIRGAT_i);
perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(perfc,(-2));
berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3);
}
cerfc = ((1.0-0.29214664)-berfc);
{
double value_max_0 = std::max((0.5*phigdbot),phitd);
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),phitd);
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),phitd);
deltaEgat = value_max_0;
}
atatbot = (deltaEbot*phitdinv);
atatsti = (deltaEsti*phitdinv);
atatgat = (deltaEgat*phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
}
fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(tkd-tkr))));
fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(tkd-tkr))));
fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(tkd-tkr))));
fbbtbot = ((fbbtbot>0)?fbbtbot:0);
fbbtsti = ((fbbtsti>0)?fbbtsti:0);
fbbtgat = ((fbbtgat>0)?fbbtgat:0);
alphaav = ((FREV_i-1)/FREV_i);
{
double value_pow_0 = pow(alphaav,PBRBOT_i);
fstopbot = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRSTI_i);
fstopsti = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRGAT_i);
fstopgat = (1/(1-value_pow_0));
}
VBRBOT_i = (VBRBOT_i*(1+((tkd-tkr)*(STVBRBOT1_i+((tkd-tkr)*STVBRBOT2_i)))));
VBRSTI_i = (VBRSTI_i*(1+((tkd-tkr)*(STVBRSTI1_i+((tkd-tkr)*STVBRSTI2_i)))));
VBRGAT_i = (VBRGAT_i*(1+((tkd-tkr)*(STVBRGAT1_i+((tkd-tkr)*STVBRGAT2_i)))));
if ((VBRBOT_i<=0.1))
{
VBRBOT_i = 0.1;
VBRinvbot = 10.0;
}
else
{
VBRinvbot = (1.0/VBRBOT_i);
}
if ((VBRSTI_i<=0.1))
{
VBRSTI_i = 0.1;
VBRinvsti = 10.0;
}
else
{
VBRinvsti = (1.0/VBRSTI_i);
}
if ((VBRGAT_i<=0.1))
{
VBRGAT_i = 0.1;
VBRinvgat = 10.0;
}
else
{
VBRinvgat = (1.0/VBRGAT_i);
}
shrinkL = (1.0-(0.01*SHRINK_i));
{
double value_pow_0 = pow(alphaav,(PBRBOT_i-1));
slopebot = (((-((fstopbot*fstopbot)*value_pow_0))*PBRBOT_i)*VBRinvbot);
}
{
double value_pow_0 = pow(alphaav,(PBRSTI_i-1));
slopesti = (((-((fstopsti*fstopsti)*value_pow_0))*PBRSTI_i)*VBRinvsti);
}
{
double value_pow_0 = pow(alphaav,(PBRGAT_i-1));
slopegat = (((-((fstopgat*fstopgat)*value_pow_0))*PBRGAT_i)*VBRinvgat);
}
{
double value_pow_0 = pow(auxt,STRS_i);
resbot = (RSBOT_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
resgat = (RSGAT_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
ressti = (RSSTI_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
rescom = (RSCOM_i*value_pow_0);
}
NDIBOT_i = (NDIBOT*1.0e6);
NDISTI_i = (NDISTI*1.0e6);
NDIGAT_i = (NDIGAT*1.0e6);
NDI_i = NDIBOT_i;
NJL = NFABOT_i;
MUEN_i = (1450*1.0e-4);
MUEP_i = (500*1.0e-4);
PB = 0.6;
JUNCDLT = 1e-3;
Nin = (1.45e+16*ftdbot2);
Pn0 = ((Nin*Nin)/NDI_i);
{
double value_pow_0 = pow(auxt,(-1.5));
T1 = value_pow_0;
}
Dn = ((MUEN_i*T1)/phitdinv);
Dp = ((MUEP_i*T1)/phitdinv);
Da = (((2*Dn)*Dp)/(Dn+Dp));
{
double value_pow_0 = pow(auxt,TAUT);
T2 = value_pow_0;
}
tau_HL = (TAU*T2);
{
double value_sqrt_0 = sqrt((tau_HL*Da));
La = value_sqrt_0;
}
{
double value_log_0 = log((NDI_i/Pn0));
V_HA = ((NJL/phitdinv)*value_log_0);
}
{
double value_log_0 = log((NDI_i/Pn0));
V_HK = ((NJL/phitdinv)*(value_log_0+(WI/La)));
}
}
// End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    VERSION(2),
    SUBVERSION(0),
    REVISION(0),
    TYPE(1),
    DTA(0),
    IMAX(1000),
    TRJ(21),
    CJORBOT(1E-3),
    CJORSTI(1E-9),
    CJORGAT(1E-9),
    VBIRBOT(1),
    VBIRSTI(1),
    VBIRGAT(1),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1E-12),
    IDSATRSTI(1E-18),
    IDSATRGAT(1E-18),
    CSRHBOT(1E2),
    CSRHSTI(1E-4),
    CSRHGAT(1E-4),
    XJUNSTI(100E-9),
    XJUNGAT(100E-9),
    CTATBOT(1E2),
    CTATSTI(1E-4),
    CTATGAT(1E-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1E-12),
    CBBTSTI(1E-18),
    CBBTGAT(1E-18),
    FBBTRBOT(1E9),
    FBBTRSTI(1E9),
    FBBTRGAT(1E9),
    STFBBTBOT((-1E-3)),
    STFBBTSTI((-1E-3)),
    STFBBTGAT((-1E-3)),
    VBRBOT(10),
    VBRSTI(10),
    VBRGAT(10),
    PBRBOT(4),
    PBRSTI(4),
    PBRGAT(4),
    FREV(1E3),
    RSBOT(0.0),
    RSSTI(0.0),
    RSGAT(0.0),
    RSCOM(0.0),
    STRS(0),
    KF(0),
    AF(1.0),
    TT(0),
    STVBRBOT1(0),
    STVBRBOT2(0),
    STVBRSTI1(0),
    STVBRSTI2(0),
    STVBRGAT1(0),
    STVBRGAT2(0),
    NFABOT(1.0),
    NFASTI(1.0),
    NFAGAT(1.0),
    ABMIN(0.0),
    ABMAX(1.0),
    LSMIN(0.0),
    LSMAX(1.0),
    LGMIN(0.0),
    LGMAX(1.0),
    TEMPMIN((-55)),
    TEMPMAX(155),
    VFMAX(0.0),
    VRMAX(0.0),
    XTI(3),
    SCALE(1.0),
    SHRINK(0),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    CORECOVERY(0.0),
    NJH(1.0),
    NJDV(0.1),
    NDIBOT(1e16),
    NDIGAT(1e16),
    NDISTI(1e16),
    INJ1(1.0),
    INJ2(10.0),
    NQS(5e-9),
    TAU(2e-7),
    WI(5e-6),
    DEPNQS(0.0),
    TNOM(21),
    TAUT(0.0),
    INJT(0.0),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    KF_i(0.0),
    AF_i(0.0),
    TT_i(0.0),
    NFABOT_i(0.0),
    NFAGAT_i(0.0),
    NFASTI_i(0.0),
    ABMIN_i(0.0),
    ABMAX_i(0.0),
    LGMAX_i(0.0),
    LGMIN_i(0.0),
    LSMAX_i(0.0),
    LSMIN_i(0.0),
    TEMPMIN_i(0.0),
    TEMPMAX_i(0.0),
    VFMAX_i(0.0),
    VRMAX_i(0.0),
    SCALE_i(0.0),
    tkr(0.0),
    tkd(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    alphaav(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0),
    rescom(0.0),
    resbot(0.0),
    ressti(0.0),
    resgat(0.0),
    shrinkL(0.0),
    NDI_i(0.0),
    NDIBOT_i(0.0),
    NDIGAT_i(0.0),
    NDISTI_i(0.0),
    NJL(0.0),
    Nin(0.0),
    Pn0(0.0),
    La(0.0),
    V_HA(0.0),
    V_HK(0.0),
    PB(0.0),
    JUNCDLT(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "AB  =  " << (*iter)->AB << std::endl;
      os << "LS  =  " << (*iter)->LS << std::endl;
      os << "LG  =  " << (*iter)->LG << std::endl;
      os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("D") != deviceMap.end() && (levelSet.find(2002)!=levelSet.end()))))
{
Diode::registerDevice();

  Config<Traits>::addConfiguration()
    .registerDevice("d", 2002)
    .registerModelType("d", 2002);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double I5=0.0;
double d_I5_dX=0.0;
  double I4=0.0;
double d_I4_dX=0.0;
  double I3=0.0;
double d_I3_dX=0.0;
  double I2=0.0;
double d_I2_dX=0.0;
  double I1=0.0;
double d_I1_dX=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
double d_V3_dX=0.0;
  double V2=0.0;
double d_V2_dX=0.0;
  double V1=0.0;
double d_V1_dX=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double restotal=0.0;
double d_restotal_dX=0.0;
  double alphaje=0.0;
double d_alphaje_dX=0.0;
  double zfrac=0.0;
double d_zfrac_dX=0.0;
  double tt2=0.0;
double d_tt2_dX=0.0;
  double tt1=0.0;
double d_tt1_dX=0.0;
  double tt0=0.0;
double d_tt0_dX=0.0;
  double I5_cor=0.0;
double d_I5_cor_dX=0.0;
  double I4_cor=0.0;
double d_I4_cor_dX=0.0;
  double I3_cor=0.0;
double d_I3_cor_dX=0.0;
  double I2_cor=0.0;
double d_I2_cor_dX=0.0;
  double I1_cor=0.0;
double d_I1_cor_dX=0.0;
  double mcor_rev=0.0;
double d_mcor_rev_dX=0.0;
  double m0_rev=0.0;
double d_m0_rev_dX=0.0;
  double pmax=0.0;
double d_pmax_dX=0.0;
  double vbigat2r=0.0;
double d_vbigat2r_dX=0.0;
  double vbisti2r=0.0;
double d_vbisti2r_dX=0.0;
  double vbibot2r=0.0;
double d_vbibot2r_dX=0.0;
  double pgat2=0.0;
double d_pgat2_dX=0.0;
  double psti2=0.0;
double d_psti2_dX=0.0;
  double pbot2=0.0;
double d_pbot2_dX=0.0;
  double vbigat2=0.0;
double d_vbigat2_dX=0.0;
  double vbisti2=0.0;
double d_vbisti2_dX=0.0;
  double vbibot2=0.0;
double d_vbibot2_dX=0.0;
  double vmaxgat=0.0;
double d_vmaxgat_dX=0.0;
  double vmaxsti=0.0;
double d_vmaxsti_dX=0.0;
  double vmaxbot=0.0;
double d_vmaxbot_dX=0.0;
//Begin block initial_instance
{
instanceStruct.d_instanceVar_AB_i_dX = ((((((instanceStruct.instancePar_AB>0)?instanceStruct.instancePar_AB:0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL)*modelStruct.d_modelVar_shrinkL_dX+(((((instanceStruct.instancePar_AB>0)?instanceStruct.instancePar_AB:0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_SCALE_i)*modelStruct.d_modelVar_shrinkL_dX+((((instanceStruct.instancePar_AB>0)?instanceStruct.instancePar_AB:0)*modelStruct.modelVar_SCALE_i)*modelStruct.d_modelVar_SCALE_i_dX+(((instanceStruct.instancePar_AB>0)?instanceStruct.instancePar_AB:0)*modelStruct.d_modelVar_SCALE_i_dX+((instanceStruct.instancePar_AB>0)?instanceStruct.d_instancePar_AB_dX:0.0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL)*modelStruct.modelVar_shrinkL);
instanceStruct.instanceVar_AB_i = ((((((instanceStruct.instancePar_AB>0)?instanceStruct.instancePar_AB:0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL)*modelStruct.modelVar_shrinkL);
instanceStruct.d_instanceVar_LS_i_dX = ((((instanceStruct.instancePar_LS>0)?instanceStruct.instancePar_LS:0)*modelStruct.modelVar_SCALE_i)*modelStruct.d_modelVar_shrinkL_dX+(((instanceStruct.instancePar_LS>0)?instanceStruct.instancePar_LS:0)*modelStruct.d_modelVar_SCALE_i_dX+((instanceStruct.instancePar_LS>0)?instanceStruct.d_instancePar_LS_dX:0.0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL);
instanceStruct.instanceVar_LS_i = ((((instanceStruct.instancePar_LS>0)?instanceStruct.instancePar_LS:0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL);
instanceStruct.d_instanceVar_LG_i_dX = ((((instanceStruct.instancePar_LG>0)?instanceStruct.instancePar_LG:0)*modelStruct.modelVar_SCALE_i)*modelStruct.d_modelVar_shrinkL_dX+(((instanceStruct.instancePar_LG>0)?instanceStruct.instancePar_LG:0)*modelStruct.d_modelVar_SCALE_i_dX+((instanceStruct.instancePar_LG>0)?instanceStruct.d_instancePar_LG_dX:0.0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL);
instanceStruct.instanceVar_LG_i = ((((instanceStruct.instancePar_LG>0)?instanceStruct.instancePar_LG:0)*modelStruct.modelVar_SCALE_i)*modelStruct.modelVar_shrinkL);
instanceStruct.d_instanceVar_MULT_i_dX = ((instanceStruct.instancePar_MULT>0)?instanceStruct.d_instancePar_MULT_dX:0.0);
instanceStruct.instanceVar_MULT_i = ((instanceStruct.instancePar_MULT>0)?instanceStruct.instancePar_MULT:0);
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = 0.0;
if (((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i))+1));
d_vmaxbot_dX = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.d_modelVar_NFABOT_i_dX+(modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_AB_i_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_AB_i))/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i)/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_AB_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0)*modelStruct.modelVar_NFABOT_i);
vmaxbot = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.modelVar_NFABOT_i);
}
}
else
{
d_vmaxbot_dX = 0.0;
vmaxbot = 1E8;
}
if (((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i))+1));
d_vmaxsti_dX = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.d_modelVar_NFASTI_i_dX+(modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_LS_i_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_LS_i))/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i)/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LS_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0)*modelStruct.modelVar_NFASTI_i);
vmaxsti = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.modelVar_NFASTI_i);
}
}
else
{
d_vmaxsti_dX = 0.0;
vmaxsti = 1E8;
}
if (((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i))+1));
d_vmaxgat_dX = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.d_modelVar_NFAGAT_i_dX+(modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_LG_i_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_LG_i))/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i)/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LG_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0)*modelStruct.modelVar_NFAGAT_i);
vmaxgat = ((modelStruct.modelVar_phitd*value_log_0)*modelStruct.modelVar_NFAGAT_i);
}
}
else
{
d_vmaxgat_dX = 0.0;
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
double  deriv_min_0_d0 = ((vmaxbot<=vmaxsti)?1.0:0.0);
double  deriv_min_0_d1 = ((vmaxbot<=vmaxsti)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vmaxgat)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vmaxgat)?0.0:1.0);
instanceStruct.d_instanceVar_VMAX_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vmaxbot_dX))+(deriv_min_0_d1*(d_vmaxsti_dX)))))+(deriv_min_1_d1*(d_vmaxgat_dX)));
instanceStruct.instanceVar_VMAX = value_min_1;
}
if ((fabs((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv));
instanceStruct.instanceVar_exp_VMAX_over_phitd = value_exp_0;
}
}
else
{
if (((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(-(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))+(-(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX = 1.0e100*(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*0.5*(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv)*(1.0+(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(instanceStruct.instanceVar_VMAX*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd = (1.0e100*(1.0+(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_vbibot2_dX = modelStruct.d_modelVar_vbibot_dX;
vbibot2 = modelStruct.modelVar_vbibot;
d_vbisti2_dX = modelStruct.d_modelVar_vbisti_dX;
vbisti2 = modelStruct.modelVar_vbisti;
d_vbigat2_dX = modelStruct.d_modelVar_vbigat_dX;
vbigat2 = modelStruct.modelVar_vbigat;
d_pbot2_dX = modelStruct.d_modelVar_PBOT_i_dX;
pbot2 = modelStruct.modelVar_PBOT_i;
d_psti2_dX = modelStruct.d_modelVar_PSTI_i_dX;
psti2 = modelStruct.modelVar_PSTI_i;
d_pgat2_dX = modelStruct.d_modelVar_PGAT_i_dX;
pgat2 = modelStruct.modelVar_PGAT_i;
d_vbibot2r_dX = modelStruct.d_modelVar_VBIRBOT_i_dX;
vbibot2r = modelStruct.modelVar_VBIRBOT_i;
d_vbisti2r_dX = modelStruct.d_modelVar_VBIRSTI_i_dX;
vbisti2r = modelStruct.modelVar_VBIRSTI_i;
d_vbigat2r_dX = modelStruct.d_modelVar_VBIRGAT_i_dX;
vbigat2r = modelStruct.modelVar_VBIRGAT_i;
if ((instanceStruct.instanceVar_AB_i==0))
{
d_vbibot2_dX = (modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_vbigat_dX);
vbibot2 = (modelStruct.modelVar_vbisti+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PSTI_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_pbot2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PSTI_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
pbot2 = (0.9*value_min_0);
}
d_vbibot2r_dX = (modelStruct.d_modelVar_VBIRSTI_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbibot2r = (modelStruct.modelVar_VBIRSTI_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
d_vbisti2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbigat_dX);
vbisti2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_psti2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
psti2 = (0.9*value_min_0);
}
d_vbisti2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbisti2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
d_vbigat2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbisti_dX);
vbigat2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbisti);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PSTI_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?0.0:1.0);
d_pgat2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
pgat2 = (0.9*value_min_0);
}
d_vbigat2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRSTI_i_dX);
vbigat2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRSTI_i);
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
double  deriv_min_0_d0 = ((vbibot2<=vbisti2)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2<=vbisti2)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2)?0.0:1.0);
instanceStruct.d_instanceVar_vbimin_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2_dX))+(deriv_min_0_d1*(d_vbisti2_dX)))))+(deriv_min_1_d1*(d_vbigat2_dX)));
instanceStruct.instanceVar_vbimin = value_min_1;
}
instanceStruct.d_instanceVar_vch_dX = instanceStruct.d_instanceVar_vbimin_dX*0.1;
instanceStruct.instanceVar_vch = (instanceStruct.instanceVar_vbimin*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
double  deriv_max_0_d0 = ((pbot2>=psti2)?1.0:0.0);
double  deriv_max_0_d1 = ((pbot2>=psti2)?0.0:1.0);
double  deriv_max_1_d0 = ((value_max_0>=pgat2)?1.0:0.0);
double  deriv_max_1_d1 = ((value_max_0>=pgat2)?0.0:1.0);
d_pmax_dX = ((deriv_max_1_d0*(((deriv_max_0_d0*(d_pbot2_dX))+(deriv_max_0_d1*(d_psti2_dX)))))+(deriv_max_1_d1*(d_pgat2_dX)));
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
double  deriv_pow_0_d1 = (2 == 0.0)?0.0:(log(2)*value_pow_0);
instanceStruct.d_instanceVar_vfmin_dX = (instanceStruct.instanceVar_vbimin*(-(deriv_pow_0_d1*((-(-1.0)*d_pmax_dX/pmax/pmax))))+instanceStruct.d_instanceVar_vbimin_dX*(1-value_pow_0));
instanceStruct.instanceVar_vfmin = (instanceStruct.instanceVar_vbimin*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
double  deriv_min_0_d0 = ((vbibot2r<=vbisti2r)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2r<=vbisti2r)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2r)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2r)?0.0:1.0);
instanceStruct.d_instanceVar_vbbtlim_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2r_dX))+(deriv_min_0_d1*(d_vbisti2r_dX)))))+(deriv_min_1_d1*(d_vbigat2r_dX)));
instanceStruct.instanceVar_vbbtlim = (value_min_1-0.050);
}
if (((instanceStruct.instanceVar_AB_i>modelStruct.modelVar_ABMAX_i)&&(modelStruct.modelVar_ABMAX_i>1e-18)))
{
UserInfo(theInstance)  << "WARNING: Diode area is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((instanceStruct.instanceVar_AB_i<modelStruct.modelVar_ABMIN_i))
{
UserInfo(theInstance)  << "WARNING: Diode area is less than minimum allowed value \n" << " " <<  std::endl; 
}
if (((instanceStruct.instanceVar_LS_i>modelStruct.modelVar_LSMAX_i)&&(modelStruct.modelVar_LSMAX_i>1e-12)))
{
UserInfo(theInstance)  << "WARNING: Diode STI-edge perimeter is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((instanceStruct.instanceVar_LS_i<modelStruct.modelVar_LSMIN_i))
{
UserInfo(theInstance)  << "WARNING: Diode STI-edge perimeter is less than minimum allowed value \n" << " " <<  std::endl; 
}
if (((instanceStruct.instanceVar_LG_i>modelStruct.modelVar_LGMAX_i)&&(modelStruct.modelVar_LGMAX_i>1e-12)))
{
UserInfo(theInstance)  << "WARNING: Diode gate-edge perimeter is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if ((instanceStruct.instanceVar_LG_i<modelStruct.modelVar_LGMIN_i))
{
UserInfo(theInstance)  << "WARNING: Diode gate-edge perimeter is less than minimum allowed value \n" << " " <<  std::endl; 
}
if ((modelStruct.modelVar_tkd>(modelStruct.modelVar_TEMPMAX_i+273.15)))
{
UserInfo(theInstance)  << "WARNING: Junction temperature is higher than maximum allowed value \n" << " " <<  std::endl; 
}
if ((modelStruct.modelVar_tkd<(modelStruct.modelVar_TEMPMIN_i+273.15)))
{
UserInfo(theInstance)  << "WARNING: Junction temperature is lower than minimum allowed value \n" << " " <<  std::endl; 
}
instanceStruct.d_instanceVar_isattotal_dX = (((instanceStruct.instanceVar_AB_i*modelStruct.d_modelVar_idsatbot_dX+instanceStruct.d_instanceVar_AB_i_dX*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LS_i*modelStruct.d_modelVar_idsatsti_dX+instanceStruct.d_instanceVar_LS_i_dX*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LG_i*modelStruct.d_modelVar_idsatgat_dX+instanceStruct.d_instanceVar_LG_i_dX*modelStruct.modelVar_idsatgat));
instanceStruct.instanceVar_isattotal = (((instanceStruct.instanceVar_AB_i*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LS_i*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LG_i*modelStruct.modelVar_idsatgat));
instanceStruct.d_instanceVar_ISATFOR1_dX = 0.0;
instanceStruct.instanceVar_ISATFOR1 = 0.0;
instanceStruct.d_instanceVar_MFOR1_dX = 0.0;
instanceStruct.instanceVar_MFOR1 = 1.0;
instanceStruct.d_instanceVar_MFOR2_dX = 0.0;
instanceStruct.instanceVar_MFOR2 = 1.0;
instanceStruct.d_instanceVar_ISATFOR2_dX = 0.0;
instanceStruct.instanceVar_ISATFOR2 = 0.0;
instanceStruct.d_instanceVar_MREV_dX = 0.0;
instanceStruct.instanceVar_MREV = 1.0;
instanceStruct.d_instanceVar_ISATREV_dX = 0.0;
instanceStruct.instanceVar_ISATREV = 0.0;
instanceStruct.instanceVar_m0flag = 0.0;
instanceStruct.d_instanceVar_xhighf1_dX = 0.0;
instanceStruct.instanceVar_xhighf1 = 0.0;
instanceStruct.d_instanceVar_expxhf1_dX = 0.0;
instanceStruct.instanceVar_expxhf1 = 0.0;
instanceStruct.d_instanceVar_xhighf2_dX = 0.0;
instanceStruct.instanceVar_xhighf2 = 0.0;
instanceStruct.d_instanceVar_expxhf2_dX = 0.0;
instanceStruct.instanceVar_expxhf2 = 0.0;
instanceStruct.d_instanceVar_xhighr_dX = 0.0;
instanceStruct.instanceVar_xhighr = 0.0;
instanceStruct.d_instanceVar_expxhr_dX = 0.0;
instanceStruct.instanceVar_expxhr = 0.0;
d_m0_rev_dX = 0.0;
m0_rev = 0.0;
d_mcor_rev_dX = 0.0;
mcor_rev = 0.0;
d_I1_cor_dX = 0.0;
I1_cor = 0.0;
d_I2_cor_dX = 0.0;
I2_cor = 0.0;
d_I3_cor_dX = 0.0;
I3_cor = 0.0;
d_I4_cor_dX = 0.0;
I4_cor = 0.0;
d_I5_cor_dX = 0.0;
I5_cor = 0.0;
d_tt0_dX = 0.0;
tt0 = 0.0;
d_tt1_dX = 0.0;
tt1 = 0.0;
d_tt2_dX = 0.0;
tt2 = 0.0;
d_zfrac_dX = 0.0;
zfrac = 0.0;
instanceStruct.instanceVar_zflagbot = 1.0;
instanceStruct.instanceVar_zflagsti = 1.0;
instanceStruct.instanceVar_zflaggat = 1.0;
d_alphaje_dX = 0.0;
alphaje = 0.0;
instanceStruct.d_instanceVar_tmpv_dX = 0.0;
instanceStruct.instanceVar_tmpv = 0.0;
instanceStruct.d_instanceVar_vjv_dX = 0.0;
instanceStruct.instanceVar_vjv = 0.0;
instanceStruct.instanceVar_rnode = 1;
d_restotal_dX = 0.0;
restotal = 0.0;
instanceStruct.d_instanceVar_conducts_dX = 0.0;
instanceStruct.instanceVar_conducts = (1.0/1.0e-13);
if (((instanceStruct.instanceVar_AB_i*modelStruct.modelVar_resbot)>0))
{
instanceStruct.d_instanceVar_conducts_dX = ((modelStruct.modelVar_resbot*instanceStruct.d_instanceVar_AB_i_dX-instanceStruct.instanceVar_AB_i*modelStruct.d_modelVar_resbot_dX)/modelStruct.modelVar_resbot/modelStruct.modelVar_resbot);
instanceStruct.instanceVar_conducts = (instanceStruct.instanceVar_AB_i/modelStruct.modelVar_resbot);
}
if (((instanceStruct.instanceVar_LS_i*modelStruct.modelVar_ressti)>0))
{
instanceStruct.d_instanceVar_conducts_dX = (((modelStruct.modelVar_ressti*instanceStruct.d_instanceVar_LS_i_dX-instanceStruct.instanceVar_LS_i*modelStruct.d_modelVar_ressti_dX)/modelStruct.modelVar_ressti/modelStruct.modelVar_ressti)+instanceStruct.d_instanceVar_conducts_dX);
instanceStruct.instanceVar_conducts = ((instanceStruct.instanceVar_LS_i/modelStruct.modelVar_ressti)+instanceStruct.instanceVar_conducts);
}
if (((instanceStruct.instanceVar_LG_i*modelStruct.modelVar_resgat)>0))
{
instanceStruct.d_instanceVar_conducts_dX = (((modelStruct.modelVar_resgat*instanceStruct.d_instanceVar_LG_i_dX-instanceStruct.instanceVar_LG_i*modelStruct.d_modelVar_resgat_dX)/modelStruct.modelVar_resgat/modelStruct.modelVar_resgat)+instanceStruct.d_instanceVar_conducts_dX);
instanceStruct.instanceVar_conducts = ((instanceStruct.instanceVar_LG_i/modelStruct.modelVar_resgat)+instanceStruct.instanceVar_conducts);
}
d_restotal_dX = ((-instanceStruct.d_instanceVar_conducts_dX/instanceStruct.instanceVar_conducts/instanceStruct.instanceVar_conducts)+modelStruct.d_modelVar_rescom_dX);
restotal = ((1.0/instanceStruct.instanceVar_conducts)+modelStruct.modelVar_rescom);
if ((restotal>(1.0e-13*1.4)))
{
instanceStruct.d_instanceVar_conducts_dX = (-d_restotal_dX/restotal/restotal);
instanceStruct.instanceVar_conducts = (1.0/restotal);
instanceStruct.instanceVar_rnode = 1;
}
else
{
instanceStruct.instanceVar_rnode = 0;
}
if ((((((instanceStruct.instanceVar_AB_i>0)&&((modelStruct.modelVar_resbot/instanceStruct.instanceVar_AB_i)<1.0e-13))||((instanceStruct.instanceVar_LS_i>0)&&((modelStruct.modelVar_ressti/instanceStruct.instanceVar_LS_i)<1.0e-13)))||((instanceStruct.instanceVar_LG_i>0)&&((modelStruct.modelVar_resgat/instanceStruct.instanceVar_LG_i)<1.0e-13)))&&(modelStruct.modelVar_rescom<1.0e-13)))
{
instanceStruct.instanceVar_rnode = 0;
}
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0.0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0.0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0.0;
instanceStruct.d_instanceVar_IWnqs0_A_dX = 0.0;
instanceStruct.instanceVar_IWnqs0_A = 0.0;
instanceStruct.d_instanceVar_Inqs0_A_dX = 0.0;
instanceStruct.instanceVar_Inqs0_A = 0.0;
instanceStruct.d_instanceVar_Inqs0_K_dX = 0.0;
instanceStruct.instanceVar_Inqs0_K = 0.0;
instanceStruct.d_instanceVar_Q_nqs_A_dX = 0.0;
instanceStruct.instanceVar_Q_nqs_A = 0.0;
instanceStruct.d_instanceVar_Q_nqs_K_dX = 0.0;
instanceStruct.instanceVar_Q_nqs_K = 0.0;
instanceStruct.d_instanceVar_W_nqs_A_dX = 0.0;
instanceStruct.instanceVar_W_nqs_A = 0.0;
if ((modelStruct.modelVar_SWJUNEXP_i>0.9))
{
if ((((((fabs((modelStruct.modelVar_NFABOT_i-modelStruct.modelVar_NFAGAT_i))>1.0e-6)&&(instanceStruct.instanceVar_AB_i>0))&&(instanceStruct.instanceVar_LG_i>0))||(((fabs((modelStruct.modelVar_NFABOT_i-modelStruct.modelVar_NFASTI_i))>1.0e-6)&&(instanceStruct.instanceVar_AB_i>0))&&(instanceStruct.instanceVar_LS_i>0)))||(((fabs((modelStruct.modelVar_NFAGAT_i-modelStruct.modelVar_NFASTI_i))>1.0e-6)&&(instanceStruct.instanceVar_LG_i>0))&&(instanceStruct.instanceVar_LS_i>0))))
{
UserInfo(theInstance)  << "WARNING: The ideality factors are not the same. JUNCAP Express will not be used \n" << " " <<  std::endl; 
UserInfo(theInstance)  << "WARNING: The full diode_cmc is executed. \n" << " " <<  std::endl; 
modelStruct.modelVar_SWJUNEXP_i = 0;
}
else
{
if ((instanceStruct.instanceVar_AB_i>0))
{
instanceStruct.d_instanceVar_MFOR1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_MFOR1 = modelStruct.modelVar_NFABOT_i;
}
if ((instanceStruct.instanceVar_LG_i>0))
{
instanceStruct.d_instanceVar_MFOR1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_MFOR1 = modelStruct.modelVar_NFAGAT_i;
}
if ((instanceStruct.instanceVar_LS_i>0))
{
instanceStruct.d_instanceVar_MFOR1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_MFOR1 = modelStruct.modelVar_NFASTI_i;
}
UserInfo(theInstance)  << "WARNING: JUNCAP Express will not simulate breakdown behavior of diode. \n" << " " <<  std::endl; 
}
}
if ((modelStruct.modelVar_SWJUNEXP_i==1.0))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double d_ysq_dX=0.0;
double terfc=0.0;
double d_terfc_dX=0.0;
double erfcpos=0.0;
double d_erfcpos_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double d_h1_dX=0.0;
double h2=0.0;
double d_h2_dX=0.0;
double h2d=0.0;
double d_h2d_dX=0.0;
double h3=0.0;
double d_h3_dX=0.0;
double h4=0.0;
double d_h4_dX=0.0;
double h5=0.0;
double d_h5_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double vj=0.0;
double d_vj_dX=0.0;
double z=0.0;
double d_z_dX=0.0;
double zinv=0.0;
double d_zinv_dX=0.0;
double two_psistar=0.0;
double d_two_psistar_dX=0.0;
double vjlim=0.0;
double d_vjlim_dX=0.0;
double vjsrh=0.0;
double d_vjsrh_dX=0.0;
double vbbt=0.0;
double d_vbbt_dX=0.0;
double vav=0.0;
double d_vav_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double d_tmp_dX=0.0;
double id=0.0;
double d_id_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double d_isrh_dX=0.0;
double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
double dwsrh=0.0;
double d_dwsrh_dX=0.0;
double wsrh=0.0;
double d_wsrh_dX=0.0;
double wdep=0.0;
double d_wdep_dX=0.0;
double asrh=0.0;
double d_asrh_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double d_itat_dX=0.0;
double btat=0.0;
double d_btat_dX=0.0;
double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
double umax=0.0;
double d_umax_dX=0.0;
double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double d_wgamma_dX=0.0;
double wtat=0.0;
double d_wtat_dX=0.0;
double ktat=0.0;
double d_ktat_dX=0.0;
double ltat=0.0;
double d_ltat_dX=0.0;
double mtat=0.0;
double d_mtat_dX=0.0;
double xerfc=0.0;
double d_xerfc_dX=0.0;
double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
double gammamax=0.0;
double d_gammamax_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double d_ibbt_dX=0.0;
double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
//End of Block-local variables
d_ysq_dX = 0.0;
ysq = 0.0;
d_terfc_dX = 0.0;
terfc = 0.0;
d_erfcpos_dX = 0.0;
erfcpos = 0.0;
d_h1_dX = 0.0;
h1 = 0.0;
d_h2_dX = 0.0;
h2 = 0.0;
d_h2d_dX = 0.0;
h2d = 0.0;
d_h3_dX = 0.0;
h3 = 0.0;
d_h4_dX = 0.0;
h4 = 0.0;
d_h5_dX = 0.0;
h5 = 0.0;
instanceStruct.instanceVar_VAK = 0.0;
instanceStruct.d_instanceVar_DQAbot_dX = 0.0;
instanceStruct.instanceVar_DQAbot = 0.0;
instanceStruct.d_instanceVar_DQAsti_dX = 0.0;
instanceStruct.instanceVar_DQAsti = 0.0;
instanceStruct.d_instanceVar_DQAgat_dX = 0.0;
instanceStruct.instanceVar_DQAgat = 0.0;
d_vj_dX = 0.0;
vj = 0.0;
d_z_dX = 0.0;
z = 0.0;
d_zinv_dX = 0.0;
zinv = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
d_vjlim_dX = 0.0;
vjlim = 0.0;
d_vjsrh_dX = 0.0;
vjsrh = 0.0;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_vav_dX = 0.0;
vav = 0.0;
d_tmp_dX = 0.0;
tmp = 0.0;
d_id_dX = 0.0;
id = 0.0;
d_isrh_dX = 0.0;
isrh = 0.0;
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0.0;
d_wsrhstep_dX = 0.0;
wsrhstep = 0.0;
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
d_wsrh_dX = 0.0;
wsrh = 0.0;
d_wdep_dX = 0.0;
wdep = 0.0;
d_asrh_dX = 0.0;
asrh = 0.0;
d_itat_dX = 0.0;
itat = 0.0;
d_btat_dX = 0.0;
btat = 0.0;
d_twoatatoverthreebtat_dX = 0.0;
twoatatoverthreebtat = 0.0;
d_umaxbeforelimiting_dX = 0.0;
umaxbeforelimiting = 0.0;
d_umax_dX = 0.0;
umax = 0.0;
d_sqrtumax_dX = 0.0;
sqrtumax = 0.0;
d_umaxpoweronepointfive_dX = 0.0;
umaxpoweronepointfive = 0.0;
d_wgamma_dX = 0.0;
wgamma = 0.0;
d_wtat_dX = 0.0;
wtat = 0.0;
d_ktat_dX = 0.0;
ktat = 0.0;
d_ltat_dX = 0.0;
ltat = 0.0;
d_mtat_dX = 0.0;
mtat = 0.0;
d_xerfc_dX = 0.0;
xerfc = 0.0;
d_erfctimesexpmtat_dX = 0.0;
erfctimesexpmtat = 0.0;
d_gammamax_dX = 0.0;
gammamax = 0.0;
d_ibbt_dX = 0.0;
ibbt = 0.0;
d_Fmaxr_dX = 0.0;
Fmaxr = 0.0;
d_fbreakdown_dX = 0.0;
fbreakdown = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
d_V1_dX = (-FRACNA)*modelStruct.d_modelVar_VJUNREF_i_dX;
V1 = ((-FRACNA)*modelStruct.modelVar_VJUNREF_i);
d_V2_dX = (-FRACNB)*modelStruct.d_modelVar_VJUNREF_i_dX;
V2 = ((-FRACNB)*modelStruct.modelVar_VJUNREF_i);
d_V3_dX = (-FRACI)*modelStruct.d_modelVar_VJUNREF_i_dX;
V3 = ((-FRACI)*modelStruct.modelVar_VJUNREF_i);
V4 = 0.1;
V5 = 0.2;
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (d_V1_dX+(instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2));
h2d = (V1+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V1*instanceStruct.d_instanceVar_vfmin_dX+d_V1_dX*instanceStruct.instanceVar_vfmin)-(V1*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V1*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((V1<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(V1*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V1_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V1-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V1-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V1_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V1-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V1-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V1_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V1-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V1-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V1_dX-V1*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V1/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V1-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((V1-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((V1-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((V1-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V1_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V1)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V1_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V1-vjlim)*(d_V1_dX-d_vjlim_dX)+(d_V1_dX-d_vjlim_dX)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-instanceStruct.instanceVar_vbbtlim)*(V1-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V1_dX+instanceStruct.d_instanceVar_vbbtlim_dX)-deriv_sqrt_0_d0*((((V1-instanceStruct.instanceVar_vbbtlim)*(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_dX)+(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_dX)*(V1-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V1+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V1_dX-deriv_sqrt_0_d0*(((V1)*d_V1_dX+d_V1_dX*(V1))));
vav = (0.5*(V1-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
d_vav_dX = 0.0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V1-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V1-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V1-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
d_I1_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
I1 = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (d_V2_dX+(instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2));
h2d = (V2+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V2*instanceStruct.d_instanceVar_vfmin_dX+d_V2_dX*instanceStruct.instanceVar_vfmin)-(V2*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V2*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((V2<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(V2*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V2_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V2-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V2-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V2_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V2-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V2-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V2_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V2-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V2-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V2_dX-V2*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V2/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V2-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((V2-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((V2-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((V2-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V2_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V2)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V2_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V2-vjlim)*(d_V2_dX-d_vjlim_dX)+(d_V2_dX-d_vjlim_dX)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-instanceStruct.instanceVar_vbbtlim)*(V2-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V2_dX+instanceStruct.d_instanceVar_vbbtlim_dX)-deriv_sqrt_0_d0*((((V2-instanceStruct.instanceVar_vbbtlim)*(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_dX)+(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_dX)*(V2-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V2+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V2_dX-deriv_sqrt_0_d0*(((V2)*d_V2_dX+d_V2_dX*(V2))));
vav = (0.5*(V2-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
d_vav_dX = 0.0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V2-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V2-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V2-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
d_I2_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
I2 = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (d_V3_dX+(instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2));
h2d = (V3+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V3*instanceStruct.d_instanceVar_vfmin_dX+d_V3_dX*instanceStruct.instanceVar_vfmin)-(V3*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V3*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((V3<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(V3*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V3_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V3-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V3-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V3_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V3-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V3-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(d_V3_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V3-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V3-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*d_V3_dX-V3*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V3/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V3-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((V3-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((V3-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((V3-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V3_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V3)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V3_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V3-vjlim)*(d_V3_dX-d_vjlim_dX)+(d_V3_dX-d_vjlim_dX)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-instanceStruct.instanceVar_vbbtlim)*(V3-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V3_dX+instanceStruct.d_instanceVar_vbbtlim_dX)-deriv_sqrt_0_d0*((((V3-instanceStruct.instanceVar_vbbtlim)*(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_dX)+(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_dX)*(V3-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V3+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V3_dX-deriv_sqrt_0_d0*(((V3)*d_V3_dX+d_V3_dX*(V3))));
vav = (0.5*(V3-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
d_vav_dX = 0.0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V3-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V3-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V3-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
d_I3_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
I3 = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2);
h2d = (V4+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V4*instanceStruct.d_instanceVar_vfmin_dX-(V4*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V4*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((V4<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(V4*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V4*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V4*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V4-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V4-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V4-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V4-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V4-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V4-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V4*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V4/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V4-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((V4-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((V4-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((V4-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V4)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V4-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-instanceStruct.instanceVar_vbbtlim)*(V4-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_dX-deriv_sqrt_0_d0*((((V4-instanceStruct.instanceVar_vbbtlim)*(-instanceStruct.d_instanceVar_vbbtlim_dX)+(-instanceStruct.d_instanceVar_vbbtlim_dX)*(V4-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V4+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V4-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
d_vav_dX = 0.0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V4-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V4-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V4-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
d_I4_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
I4 = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2);
h2d = (V5+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V5*instanceStruct.d_instanceVar_vfmin_dX-(V5*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V5*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((V5<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(V5*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V5*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V5*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V5-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V5-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V5-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V5-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(V5-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(V5-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-V5*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((V5/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((V5-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((V5-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((V5-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((V5-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V5)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V5-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-instanceStruct.instanceVar_vbbtlim)*(V5-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_dX-deriv_sqrt_0_d0*((((V5-instanceStruct.instanceVar_vbbtlim)*(-instanceStruct.d_instanceVar_vbbtlim_dX)+(-instanceStruct.d_instanceVar_vbbtlim_dX)*(V5-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V5+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V5-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
d_vav_dX = 0.0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V5-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V5-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V5-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
d_I5_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
I5 = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
instanceStruct.d_instanceVar_ISATFOR1_dX = instanceStruct.d_instanceVar_isattotal_dX;
instanceStruct.instanceVar_ISATFOR1 = instanceStruct.instanceVar_isattotal;
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1));
double  deriv_exp_0_d0 = value_exp_0;
d_I4_cor_dX = (d_I4_dX-(instanceStruct.instanceVar_ISATFOR1*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1))+instanceStruct.d_instanceVar_ISATFOR1_dX*(value_exp_0-1.0)));
I4_cor = (I4-(instanceStruct.instanceVar_ISATFOR1*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1));
double  deriv_exp_0_d0 = value_exp_0;
d_I5_cor_dX = (d_I5_dX-(instanceStruct.instanceVar_ISATFOR1*deriv_exp_0_d0*(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+V5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1))+instanceStruct.d_instanceVar_ISATFOR1_dX*(value_exp_0-1.0)));
I5_cor = (I5-(instanceStruct.instanceVar_ISATFOR1*(value_exp_0-1.0)));
}
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
d_alphaje_dX = ((I5_cor*d_I4_cor_dX-I4_cor*d_I5_cor_dX)/I5_cor/I5_cor);
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
instanceStruct.d_instanceVar_MFOR2_dX = ((modelStruct.modelVar_phitd*deriv_log_0_d0*(d_alphaje_dX)+modelStruct.d_modelVar_phitd_dX*value_log_0)/(V4-V5));
instanceStruct.instanceVar_MFOR2 = ((modelStruct.modelVar_phitd*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATFOR2_dX = (((value_exp_0-1)*d_I4_cor_dX-I4_cor*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATFOR2 = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1));
double value_exp_1 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I1_cor_dX = ((d_I1_dX-(instanceStruct.instanceVar_ISATFOR1*deriv_exp_0_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1))+instanceStruct.d_instanceVar_ISATFOR1_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*deriv_exp_1_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2))+instanceStruct.d_instanceVar_ISATFOR2_dX*(value_exp_1-1.0)));
I1_cor = ((I1-(instanceStruct.instanceVar_ISATFOR1*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1));
double value_exp_1 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I2_cor_dX = ((d_I2_dX-(instanceStruct.instanceVar_ISATFOR1*deriv_exp_0_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1))+instanceStruct.d_instanceVar_ISATFOR1_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*deriv_exp_1_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2))+instanceStruct.d_instanceVar_ISATFOR2_dX*(value_exp_1-1.0)));
I2_cor = ((I2-(instanceStruct.instanceVar_ISATFOR1*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1));
double value_exp_1 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I3_cor_dX = ((d_I3_dX-(instanceStruct.instanceVar_ISATFOR1*deriv_exp_0_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1))+instanceStruct.d_instanceVar_ISATFOR1_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*deriv_exp_1_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2))+instanceStruct.d_instanceVar_ISATFOR2_dX*(value_exp_1-1.0)));
I3_cor = ((I3-(instanceStruct.instanceVar_ISATFOR1*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
d_alphaje_dX = ((I2_cor*d_I1_cor_dX-I1_cor*d_I2_cor_dX)/I2_cor/I2_cor);
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
d_m0_rev_dX = (((V1-V2)*((-modelStruct.modelVar_phitd)*deriv_log_0_d0*(d_alphaje_dX)+(-modelStruct.d_modelVar_phitd_dX)*value_log_0)-((-modelStruct.modelVar_phitd)*value_log_0)*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
m0_rev = (((-modelStruct.modelVar_phitd)*value_log_0)/(V1-V2));
}
d_tt0_dX = (((V2-V1)*d_V2_dX-V2*(d_V2_dX-d_V1_dX))/(V2-V1)/(V2-V1));
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt1_dX = ((modelStruct.modelVar_phitd*(alphaje-1))*((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))+(modelStruct.modelVar_phitd*d_alphaje_dX+modelStruct.d_modelVar_phitd_dX*(alphaje-1))*(value_pow_0-1));
tt1 = ((modelStruct.modelVar_phitd*(alphaje-1))*(value_pow_0-1));
}
d_tt0_dX = (((V1-V2)*d_V1_dX-V1*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt2_dX = (((value_pow_0*(d_V2_dX-d_V1_dX)+((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))*(V2-V1))+(alphaje*d_V1_dX+d_alphaje_dX*V1))-d_V2_dX);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
d_mcor_rev_dX = ((tt2*d_tt1_dX-tt1*d_tt2_dX)/tt2/tt2);
mcor_rev = (tt1/tt2);
instanceStruct.d_instanceVar_MREV_dX = (d_m0_rev_dX+d_mcor_rev_dX);
instanceStruct.instanceVar_MREV = (m0_rev+mcor_rev);
if ((fabs(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV))<1e-6))
{
instanceStruct.instanceVar_m0flag = 1.0;
instanceStruct.d_instanceVar_ISATREV_dX = (I3_cor*((-1*d_V3_dX/V3/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_dX+0.5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV))+d_I3_cor_dX*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV)));
instanceStruct.instanceVar_ISATREV = (I3_cor*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV)));
instanceStruct.d_instanceVar_MREV_dX = ((V3*((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV)*modelStruct.d_modelVar_phitdinv_dX+(((-0.5)*I3_cor)*instanceStruct.d_instanceVar_MREV_dX+(-0.5)*d_I3_cor_dX*instanceStruct.instanceVar_MREV)*modelStruct.modelVar_phitdinv)-((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV)*modelStruct.modelVar_phitdinv)*d_V3_dX)/V3/V3);
instanceStruct.instanceVar_MREV = (((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV)*modelStruct.modelVar_phitdinv)/V3);
}
else
{
instanceStruct.instanceVar_m0flag = 0.0;
{
double value_exp_0 = exp((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATREV_dX = (((value_exp_0-1)*(-d_I3_cor_dX)-(-I3_cor)*deriv_exp_0_d0*((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_dX+((-V3)*modelStruct.d_modelVar_phitdinv_dX+(-d_V3_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATREV = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
d_zfrac_dX = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_AB_i*modelStruct.d_modelVar_cjobot_dX+instanceStruct.d_instanceVar_AB_i_dX*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LS_i*modelStruct.d_modelVar_cjosti_dX+instanceStruct.d_instanceVar_LS_i_dX*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LG_i*modelStruct.d_modelVar_cjogat_dX+instanceStruct.d_instanceVar_LG_i_dX*modelStruct.modelVar_cjogat))+modelStruct.d_modelVar_FJUNQ_i_dX*(((instanceStruct.instanceVar_AB_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LS_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LG_i*modelStruct.modelVar_cjogat)));
zfrac = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_AB_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LS_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LG_i*modelStruct.modelVar_cjogat)));
if (((instanceStruct.instanceVar_AB_i*modelStruct.modelVar_cjobot)<=zfrac))
{
instanceStruct.instanceVar_zflagbot = 0.0;
}
if (((instanceStruct.instanceVar_LS_i*modelStruct.modelVar_cjosti)<=zfrac))
{
instanceStruct.instanceVar_zflagsti = 0.0;
}
if (((instanceStruct.instanceVar_LG_i*modelStruct.modelVar_cjogat)<=zfrac))
{
instanceStruct.instanceVar_zflaggat = 0.0;
}
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1+1e-21)));
instanceStruct.d_instanceVar_xhighf1_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR1+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR1_dX)/(instanceStruct.instanceVar_ISATFOR1+1e-21)/(instanceStruct.instanceVar_ISATFOR1+1e-21)));
instanceStruct.instanceVar_xhighf1 = value_log_0;
}
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2+1e-21)));
instanceStruct.d_instanceVar_xhighf2_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR2+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR2_dX)/(instanceStruct.instanceVar_ISATFOR2+1e-21)/(instanceStruct.instanceVar_ISATFOR2+1e-21)));
instanceStruct.instanceVar_xhighf2 = value_log_0;
}
{
double value_fabs_0 = fabs(instanceStruct.instanceVar_ISATREV);
double value_log_1 = log(((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
double  deriv_fabs_0_d0 = (((instanceStruct.instanceVar_ISATREV)>=0)?(+1.0):(-1.0));
double  deriv_log_1_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
instanceStruct.d_instanceVar_xhighr_dX = deriv_log_1_d0*((((value_fabs_0+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*deriv_fabs_0_d0*(instanceStruct.d_instanceVar_ISATREV_dX))/(value_fabs_0+1e-21)/(value_fabs_0+1e-21)));
instanceStruct.instanceVar_xhighr = value_log_1;
}
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf1,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf1<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf1_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf1_dX));
instanceStruct.instanceVar_xhighf1 = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf1);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf1_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf1_dX);
instanceStruct.instanceVar_expxhf1 = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf2,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf2<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf2_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf2_dX));
instanceStruct.instanceVar_xhighf2 = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf2);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf2_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf2_dX);
instanceStruct.instanceVar_expxhf2 = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighr,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighr<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighr_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighr_dX));
instanceStruct.instanceVar_xhighr = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighr);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhr_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighr_dX);
instanceStruct.instanceVar_expxhr = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
  double tau_HL=0.0;
double d_tau_HL_dX=0.0;
  double T2=0.0;
double d_T2_dX=0.0;
  double Da=0.0;
double d_Da_dX=0.0;
  double Dp=0.0;
double d_Dp_dX=0.0;
  double Dn=0.0;
double d_Dn_dX=0.0;
  double T1=0.0;
double d_T1_dX=0.0;
  double MUEP_i=0.0;
  double MUEN_i=0.0;
  double deltaEgat=0.0;
double d_deltaEgat_dX=0.0;
  double deltaEsti=0.0;
double d_deltaEsti_dX=0.0;
  double deltaEbot=0.0;
double d_deltaEbot_dX=0.0;
  double ubigat=0.0;
double d_ubigat_dX=0.0;
  double ubisti=0.0;
double d_ubisti_dX=0.0;
  double ubibot=0.0;
double d_ubibot_dX=0.0;
  double ftdgat2=0.0;
double d_ftdgat2_dX=0.0;
  double ftdsti2=0.0;
double d_ftdsti2_dX=0.0;
  double ftdbot2=0.0;
double d_ftdbot2_dX=0.0;
  double phigdgat=0.0;
double d_phigdgat_dX=0.0;
  double phigdsti=0.0;
double d_phigdsti_dX=0.0;
  double phigdbot=0.0;
double d_phigdbot_dX=0.0;
  double deltaphigd=0.0;
double d_deltaphigd_dX=0.0;
  double phigrgat=0.0;
double d_phigrgat_dX=0.0;
  double phigrsti=0.0;
double d_phigrsti_dX=0.0;
  double phigrbot=0.0;
double d_phigrbot_dX=0.0;
  double deltaphigr=0.0;
double d_deltaphigr_dX=0.0;
  double phitrinv=0.0;
double d_phitrinv_dX=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
double d_auxt_dX=0.0;
  double SHRINK_i=0.0;
double d_SHRINK_i_dX=0.0;
  double XTI_i=0.0;
double d_XTI_i_dX=0.0;
  double STVBRGAT2_i=0.0;
double d_STVBRGAT2_i_dX=0.0;
  double STVBRGAT1_i=0.0;
double d_STVBRGAT1_i_dX=0.0;
  double STVBRSTI2_i=0.0;
double d_STVBRSTI2_i_dX=0.0;
  double STVBRSTI1_i=0.0;
double d_STVBRSTI1_i_dX=0.0;
  double STVBRBOT2_i=0.0;
double d_STVBRBOT2_i_dX=0.0;
  double STVBRBOT1_i=0.0;
double d_STVBRBOT1_i_dX=0.0;
  double STRS_i=0.0;
double d_STRS_i_dX=0.0;
  double RSCOM_i=0.0;
double d_RSCOM_i_dX=0.0;
  double RSGAT_i=0.0;
double d_RSGAT_i_dX=0.0;
  double RSSTI_i=0.0;
double d_RSSTI_i_dX=0.0;
  double RSBOT_i=0.0;
double d_RSBOT_i_dX=0.0;
  double FREV_i=0.0;
double d_FREV_i_dX=0.0;
  double STFBBTGAT_i=0.0;
double d_STFBBTGAT_i_dX=0.0;
  double STFBBTSTI_i=0.0;
double d_STFBBTSTI_i_dX=0.0;
  double STFBBTBOT_i=0.0;
double d_STFBBTBOT_i_dX=0.0;
  double FBBTRGAT_i=0.0;
double d_FBBTRGAT_i_dX=0.0;
  double FBBTRSTI_i=0.0;
double d_FBBTRSTI_i_dX=0.0;
  double FBBTRBOT_i=0.0;
double d_FBBTRBOT_i_dX=0.0;
  double MEFFTATGAT_i=0.0;
double d_MEFFTATGAT_i_dX=0.0;
  double MEFFTATSTI_i=0.0;
double d_MEFFTATSTI_i_dX=0.0;
  double MEFFTATBOT_i=0.0;
double d_MEFFTATBOT_i_dX=0.0;
  double XJUNGAT_i=0.0;
double d_XJUNGAT_i_dX=0.0;
  double XJUNSTI_i=0.0;
double d_XJUNSTI_i_dX=0.0;
  double IDSATRGAT_i=0.0;
double d_IDSATRGAT_i_dX=0.0;
  double IDSATRSTI_i=0.0;
double d_IDSATRSTI_i_dX=0.0;
  double IDSATRBOT_i=0.0;
double d_IDSATRBOT_i_dX=0.0;
  double PHIGGAT_i=0.0;
double d_PHIGGAT_i_dX=0.0;
  double PHIGSTI_i=0.0;
double d_PHIGSTI_i_dX=0.0;
  double PHIGBOT_i=0.0;
double d_PHIGBOT_i_dX=0.0;
  double CJORGAT_i=0.0;
double d_CJORGAT_i_dX=0.0;
  double CJORSTI_i=0.0;
double d_CJORSTI_i_dX=0.0;
  double CJORBOT_i=0.0;
double d_CJORBOT_i_dX=0.0;
  double TRJ_i=0.0;
double d_TRJ_i_dX=0.0;
  double EPSSI=0.0;
//Begin block initial_model
{
EPSSI = (8.8541878176E-12*11.8);
d_TRJ_i_dX = ((modelStruct.modelPar_TRJ>(-250))?modelStruct.d_modelPar_TRJ_dX:0.0);
TRJ_i = ((modelStruct.modelPar_TRJ>(-250))?modelStruct.modelPar_TRJ:(-250));
if (((!modelStruct.modelPar_given_TRJ)&&modelStruct.modelPar_given_TNOM))
{
d_TRJ_i_dX = ((modelStruct.modelPar_TNOM>(-250))?modelStruct.d_modelPar_TNOM_dX:0.0);
TRJ_i = ((modelStruct.modelPar_TNOM>(-250))?modelStruct.modelPar_TNOM:(-250));
}
modelStruct.d_modelVar_IMAX_i_dX = ((modelStruct.modelPar_IMAX>1E-12)?modelStruct.d_modelPar_IMAX_dX:0.0);
modelStruct.modelVar_IMAX_i = ((modelStruct.modelPar_IMAX>1E-12)?modelStruct.modelPar_IMAX:1E-12);
d_CJORBOT_i_dX = ((modelStruct.modelPar_CJORBOT>1E-12)?modelStruct.d_modelPar_CJORBOT_dX:0.0);
CJORBOT_i = ((modelStruct.modelPar_CJORBOT>1E-12)?modelStruct.modelPar_CJORBOT:1E-12);
d_CJORSTI_i_dX = ((modelStruct.modelPar_CJORSTI>1E-18)?modelStruct.d_modelPar_CJORSTI_dX:0.0);
CJORSTI_i = ((modelStruct.modelPar_CJORSTI>1E-18)?modelStruct.modelPar_CJORSTI:1E-18);
d_CJORGAT_i_dX = ((modelStruct.modelPar_CJORGAT>1E-18)?modelStruct.d_modelPar_CJORGAT_dX:0.0);
CJORGAT_i = ((modelStruct.modelPar_CJORGAT>1E-18)?modelStruct.modelPar_CJORGAT:1E-18);
modelStruct.d_modelVar_VBIRBOT_i_dX = ((modelStruct.modelPar_VBIRBOT>0.050)?modelStruct.d_modelPar_VBIRBOT_dX:0.0);
modelStruct.modelVar_VBIRBOT_i = ((modelStruct.modelPar_VBIRBOT>0.050)?modelStruct.modelPar_VBIRBOT:0.050);
modelStruct.d_modelVar_VBIRSTI_i_dX = ((modelStruct.modelPar_VBIRSTI>0.050)?modelStruct.d_modelPar_VBIRSTI_dX:0.0);
modelStruct.modelVar_VBIRSTI_i = ((modelStruct.modelPar_VBIRSTI>0.050)?modelStruct.modelPar_VBIRSTI:0.050);
modelStruct.d_modelVar_VBIRGAT_i_dX = ((modelStruct.modelPar_VBIRGAT>0.050)?modelStruct.d_modelPar_VBIRGAT_dX:0.0);
modelStruct.modelVar_VBIRGAT_i = ((modelStruct.modelPar_VBIRGAT>0.050)?modelStruct.modelPar_VBIRGAT:0.050);
modelStruct.d_modelVar_PBOT_i_dX = ((modelStruct.modelPar_PBOT>0.05)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.d_modelPar_PBOT_dX:0.0):0.0);
modelStruct.modelVar_PBOT_i = ((modelStruct.modelPar_PBOT>0.05)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.modelPar_PBOT:0.95):0.05);
modelStruct.d_modelVar_PSTI_i_dX = ((modelStruct.modelPar_PSTI>0.05)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.d_modelPar_PSTI_dX:0.0):0.0);
modelStruct.modelVar_PSTI_i = ((modelStruct.modelPar_PSTI>0.05)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.modelPar_PSTI:0.95):0.05);
modelStruct.d_modelVar_PGAT_i_dX = ((modelStruct.modelPar_PGAT>0.05)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.d_modelPar_PGAT_dX:0.0):0.0);
modelStruct.modelVar_PGAT_i = ((modelStruct.modelPar_PGAT>0.05)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.modelPar_PGAT:0.95):0.05);
d_PHIGBOT_i_dX = modelStruct.d_modelPar_PHIGBOT_dX;
PHIGBOT_i = modelStruct.modelPar_PHIGBOT;
d_PHIGSTI_i_dX = modelStruct.d_modelPar_PHIGSTI_dX;
PHIGSTI_i = modelStruct.modelPar_PHIGSTI;
d_PHIGGAT_i_dX = modelStruct.d_modelPar_PHIGGAT_dX;
PHIGGAT_i = modelStruct.modelPar_PHIGGAT;
d_IDSATRBOT_i_dX = ((modelStruct.modelPar_IDSATRBOT>0)?modelStruct.d_modelPar_IDSATRBOT_dX:0.0);
IDSATRBOT_i = ((modelStruct.modelPar_IDSATRBOT>0)?modelStruct.modelPar_IDSATRBOT:0);
d_IDSATRSTI_i_dX = ((modelStruct.modelPar_IDSATRSTI>0)?modelStruct.d_modelPar_IDSATRSTI_dX:0.0);
IDSATRSTI_i = ((modelStruct.modelPar_IDSATRSTI>0)?modelStruct.modelPar_IDSATRSTI:0);
d_IDSATRGAT_i_dX = ((modelStruct.modelPar_IDSATRGAT>0)?modelStruct.d_modelPar_IDSATRGAT_dX:0.0);
IDSATRGAT_i = ((modelStruct.modelPar_IDSATRGAT>0)?modelStruct.modelPar_IDSATRGAT:0);
modelStruct.d_modelVar_CSRHBOT_i_dX = ((modelStruct.modelPar_CSRHBOT>0)?modelStruct.d_modelPar_CSRHBOT_dX:0.0);
modelStruct.modelVar_CSRHBOT_i = ((modelStruct.modelPar_CSRHBOT>0)?modelStruct.modelPar_CSRHBOT:0);
modelStruct.d_modelVar_CSRHSTI_i_dX = ((modelStruct.modelPar_CSRHSTI>0)?modelStruct.d_modelPar_CSRHSTI_dX:0.0);
modelStruct.modelVar_CSRHSTI_i = ((modelStruct.modelPar_CSRHSTI>0)?modelStruct.modelPar_CSRHSTI:0);
modelStruct.d_modelVar_CSRHGAT_i_dX = ((modelStruct.modelPar_CSRHGAT>0)?modelStruct.d_modelPar_CSRHGAT_dX:0.0);
modelStruct.modelVar_CSRHGAT_i = ((modelStruct.modelPar_CSRHGAT>0)?modelStruct.modelPar_CSRHGAT:0);
d_XJUNSTI_i_dX = ((modelStruct.modelPar_XJUNSTI>1E-9)?modelStruct.d_modelPar_XJUNSTI_dX:0.0);
XJUNSTI_i = ((modelStruct.modelPar_XJUNSTI>1E-9)?modelStruct.modelPar_XJUNSTI:1E-9);
d_XJUNGAT_i_dX = ((modelStruct.modelPar_XJUNGAT>1E-9)?modelStruct.d_modelPar_XJUNGAT_dX:0.0);
XJUNGAT_i = ((modelStruct.modelPar_XJUNGAT>1E-9)?modelStruct.modelPar_XJUNGAT:1E-9);
modelStruct.d_modelVar_CTATBOT_i_dX = ((modelStruct.modelPar_CTATBOT>0)?modelStruct.d_modelPar_CTATBOT_dX:0.0);
modelStruct.modelVar_CTATBOT_i = ((modelStruct.modelPar_CTATBOT>0)?modelStruct.modelPar_CTATBOT:0);
modelStruct.d_modelVar_CTATSTI_i_dX = ((modelStruct.modelPar_CTATSTI>0)?modelStruct.d_modelPar_CTATSTI_dX:0.0);
modelStruct.modelVar_CTATSTI_i = ((modelStruct.modelPar_CTATSTI>0)?modelStruct.modelPar_CTATSTI:0);
modelStruct.d_modelVar_CTATGAT_i_dX = ((modelStruct.modelPar_CTATGAT>0)?modelStruct.d_modelPar_CTATGAT_dX:0.0);
modelStruct.modelVar_CTATGAT_i = ((modelStruct.modelPar_CTATGAT>0)?modelStruct.modelPar_CTATGAT:0);
d_MEFFTATBOT_i_dX = ((modelStruct.modelPar_MEFFTATBOT>0.01)?modelStruct.d_modelPar_MEFFTATBOT_dX:0.0);
MEFFTATBOT_i = ((modelStruct.modelPar_MEFFTATBOT>0.01)?modelStruct.modelPar_MEFFTATBOT:0.01);
d_MEFFTATSTI_i_dX = ((modelStruct.modelPar_MEFFTATSTI>0.01)?modelStruct.d_modelPar_MEFFTATSTI_dX:0.0);
MEFFTATSTI_i = ((modelStruct.modelPar_MEFFTATSTI>0.01)?modelStruct.modelPar_MEFFTATSTI:0.01);
d_MEFFTATGAT_i_dX = ((modelStruct.modelPar_MEFFTATGAT>0.01)?modelStruct.d_modelPar_MEFFTATGAT_dX:0.0);
MEFFTATGAT_i = ((modelStruct.modelPar_MEFFTATGAT>0.01)?modelStruct.modelPar_MEFFTATGAT:0.01);
modelStruct.d_modelVar_CBBTBOT_i_dX = ((modelStruct.modelPar_CBBTBOT>0)?modelStruct.d_modelPar_CBBTBOT_dX:0.0);
modelStruct.modelVar_CBBTBOT_i = ((modelStruct.modelPar_CBBTBOT>0)?modelStruct.modelPar_CBBTBOT:0);
modelStruct.d_modelVar_CBBTSTI_i_dX = ((modelStruct.modelPar_CBBTSTI>0)?modelStruct.d_modelPar_CBBTSTI_dX:0.0);
modelStruct.modelVar_CBBTSTI_i = ((modelStruct.modelPar_CBBTSTI>0)?modelStruct.modelPar_CBBTSTI:0);
modelStruct.d_modelVar_CBBTGAT_i_dX = ((modelStruct.modelPar_CBBTGAT>0)?modelStruct.d_modelPar_CBBTGAT_dX:0.0);
modelStruct.modelVar_CBBTGAT_i = ((modelStruct.modelPar_CBBTGAT>0)?modelStruct.modelPar_CBBTGAT:0);
d_FBBTRBOT_i_dX = modelStruct.d_modelPar_FBBTRBOT_dX;
FBBTRBOT_i = modelStruct.modelPar_FBBTRBOT;
d_FBBTRSTI_i_dX = modelStruct.d_modelPar_FBBTRSTI_dX;
FBBTRSTI_i = modelStruct.modelPar_FBBTRSTI;
d_FBBTRGAT_i_dX = modelStruct.d_modelPar_FBBTRGAT_dX;
FBBTRGAT_i = modelStruct.modelPar_FBBTRGAT;
d_STFBBTBOT_i_dX = modelStruct.d_modelPar_STFBBTBOT_dX;
STFBBTBOT_i = modelStruct.modelPar_STFBBTBOT;
d_STFBBTSTI_i_dX = modelStruct.d_modelPar_STFBBTSTI_dX;
STFBBTSTI_i = modelStruct.modelPar_STFBBTSTI;
d_STFBBTGAT_i_dX = modelStruct.d_modelPar_STFBBTGAT_dX;
STFBBTGAT_i = modelStruct.modelPar_STFBBTGAT;
modelStruct.d_modelVar_VBRBOT_i_dX = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.d_modelPar_VBRBOT_dX:0.0);
modelStruct.modelVar_VBRBOT_i = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.modelPar_VBRBOT:0.1);
modelStruct.d_modelVar_VBRSTI_i_dX = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.d_modelPar_VBRSTI_dX:0.0);
modelStruct.modelVar_VBRSTI_i = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.modelPar_VBRSTI:0.1);
modelStruct.d_modelVar_VBRGAT_i_dX = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.d_modelPar_VBRGAT_dX:0.0);
modelStruct.modelVar_VBRGAT_i = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.modelPar_VBRGAT:0.1);
modelStruct.d_modelVar_PBRBOT_i_dX = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.d_modelPar_PBRBOT_dX:0.0);
modelStruct.modelVar_PBRBOT_i = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.modelPar_PBRBOT:0.1);
modelStruct.d_modelVar_PBRSTI_i_dX = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.d_modelPar_PBRSTI_dX:0.0);
modelStruct.modelVar_PBRSTI_i = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.modelPar_PBRSTI:0.1);
modelStruct.d_modelVar_PBRGAT_i_dX = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.d_modelPar_PBRGAT_dX:0.0);
modelStruct.modelVar_PBRGAT_i = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.modelPar_PBRGAT:0.1);
d_FREV_i_dX = modelStruct.d_modelPar_FREV_dX;
FREV_i = modelStruct.modelPar_FREV;
d_RSBOT_i_dX = ((modelStruct.modelPar_RSBOT>0.0)?modelStruct.d_modelPar_RSBOT_dX:0.0);
RSBOT_i = ((modelStruct.modelPar_RSBOT>0.0)?modelStruct.modelPar_RSBOT:0.0);
d_RSSTI_i_dX = ((modelStruct.modelPar_RSSTI>0.0)?modelStruct.d_modelPar_RSSTI_dX:0.0);
RSSTI_i = ((modelStruct.modelPar_RSSTI>0.0)?modelStruct.modelPar_RSSTI:0.0);
d_RSGAT_i_dX = ((modelStruct.modelPar_RSGAT>0.0)?modelStruct.d_modelPar_RSGAT_dX:0.0);
RSGAT_i = ((modelStruct.modelPar_RSGAT>0.0)?modelStruct.modelPar_RSGAT:0.0);
d_RSCOM_i_dX = ((modelStruct.modelPar_RSCOM>0.0)?modelStruct.d_modelPar_RSCOM_dX:0.0);
RSCOM_i = ((modelStruct.modelPar_RSCOM>0.0)?modelStruct.modelPar_RSCOM:0.0);
d_STRS_i_dX = ((modelStruct.modelPar_STRS>0.0)?modelStruct.d_modelPar_STRS_dX:0.0);
STRS_i = ((modelStruct.modelPar_STRS>0.0)?modelStruct.modelPar_STRS:0.0);
modelStruct.d_modelVar_AF_i_dX = ((modelStruct.modelPar_AF>0.1)?modelStruct.d_modelPar_AF_dX:0.0);
modelStruct.modelVar_AF_i = ((modelStruct.modelPar_AF>0.1)?modelStruct.modelPar_AF:0.1);
modelStruct.d_modelVar_KF_i_dX = ((modelStruct.modelPar_KF>0.0)?modelStruct.d_modelPar_KF_dX:0.0);
modelStruct.modelVar_KF_i = ((modelStruct.modelPar_KF>0.0)?modelStruct.modelPar_KF:0.0);
modelStruct.d_modelVar_TT_i_dX = ((modelStruct.modelPar_TT>0)?modelStruct.d_modelPar_TT_dX:0.0);
modelStruct.modelVar_TT_i = ((modelStruct.modelPar_TT>0)?modelStruct.modelPar_TT:0);
d_STVBRBOT1_i_dX = modelStruct.d_modelPar_STVBRBOT1_dX;
STVBRBOT1_i = modelStruct.modelPar_STVBRBOT1;
d_STVBRBOT2_i_dX = modelStruct.d_modelPar_STVBRBOT2_dX;
STVBRBOT2_i = modelStruct.modelPar_STVBRBOT2;
d_STVBRSTI1_i_dX = modelStruct.d_modelPar_STVBRSTI1_dX;
STVBRSTI1_i = modelStruct.modelPar_STVBRSTI1;
d_STVBRSTI2_i_dX = modelStruct.d_modelPar_STVBRSTI2_dX;
STVBRSTI2_i = modelStruct.modelPar_STVBRSTI2;
d_STVBRGAT1_i_dX = modelStruct.d_modelPar_STVBRGAT1_dX;
STVBRGAT1_i = modelStruct.modelPar_STVBRGAT1;
d_STVBRGAT2_i_dX = modelStruct.d_modelPar_STVBRGAT2_dX;
STVBRGAT2_i = modelStruct.modelPar_STVBRGAT2;
modelStruct.d_modelVar_NFABOT_i_dX = ((modelStruct.modelPar_NFABOT>0.1)?modelStruct.d_modelPar_NFABOT_dX:0.0);
modelStruct.modelVar_NFABOT_i = ((modelStruct.modelPar_NFABOT>0.1)?modelStruct.modelPar_NFABOT:0.1);
modelStruct.d_modelVar_NFASTI_i_dX = ((modelStruct.modelPar_NFASTI>0.1)?modelStruct.d_modelPar_NFASTI_dX:0.0);
modelStruct.modelVar_NFASTI_i = ((modelStruct.modelPar_NFASTI>0.1)?modelStruct.modelPar_NFASTI:0.1);
modelStruct.d_modelVar_NFAGAT_i_dX = ((modelStruct.modelPar_NFAGAT>0.1)?modelStruct.d_modelPar_NFAGAT_dX:0.0);
modelStruct.modelVar_NFAGAT_i = ((modelStruct.modelPar_NFAGAT>0.1)?modelStruct.modelPar_NFAGAT:0.1);
modelStruct.d_modelVar_ABMIN_i_dX = ((modelStruct.modelPar_ABMIN>0)?modelStruct.d_modelPar_ABMIN_dX:0.0);
modelStruct.modelVar_ABMIN_i = ((modelStruct.modelPar_ABMIN>0)?modelStruct.modelPar_ABMIN:0);
modelStruct.d_modelVar_ABMAX_i_dX = ((modelStruct.modelPar_ABMAX>0)?modelStruct.d_modelPar_ABMAX_dX:0.0);
modelStruct.modelVar_ABMAX_i = ((modelStruct.modelPar_ABMAX>0)?modelStruct.modelPar_ABMAX:0);
modelStruct.d_modelVar_LSMIN_i_dX = ((modelStruct.modelPar_LSMIN>0)?modelStruct.d_modelPar_LSMIN_dX:0.0);
modelStruct.modelVar_LSMIN_i = ((modelStruct.modelPar_LSMIN>0)?modelStruct.modelPar_LSMIN:0);
modelStruct.d_modelVar_LSMAX_i_dX = ((modelStruct.modelPar_LSMAX>0)?modelStruct.d_modelPar_LSMAX_dX:0.0);
modelStruct.modelVar_LSMAX_i = ((modelStruct.modelPar_LSMAX>0)?modelStruct.modelPar_LSMAX:0);
modelStruct.d_modelVar_LGMIN_i_dX = ((modelStruct.modelPar_LGMIN>0)?modelStruct.d_modelPar_LGMIN_dX:0.0);
modelStruct.modelVar_LGMIN_i = ((modelStruct.modelPar_LGMIN>0)?modelStruct.modelPar_LGMIN:0);
modelStruct.d_modelVar_LGMAX_i_dX = ((modelStruct.modelPar_LGMAX>0)?modelStruct.d_modelPar_LGMAX_dX:0.0);
modelStruct.modelVar_LGMAX_i = ((modelStruct.modelPar_LGMAX>0)?modelStruct.modelPar_LGMAX:0);
modelStruct.d_modelVar_TEMPMIN_i_dX = ((modelStruct.modelPar_TEMPMIN>(-250))?modelStruct.d_modelPar_TEMPMIN_dX:0.0);
modelStruct.modelVar_TEMPMIN_i = ((modelStruct.modelPar_TEMPMIN>(-250))?modelStruct.modelPar_TEMPMIN:(-250));
modelStruct.d_modelVar_TEMPMAX_i_dX = ((modelStruct.modelPar_TEMPMAX>(-250))?modelStruct.d_modelPar_TEMPMAX_dX:0.0);
modelStruct.modelVar_TEMPMAX_i = ((modelStruct.modelPar_TEMPMAX>(-250))?modelStruct.modelPar_TEMPMAX:(-250));
modelStruct.d_modelVar_VFMAX_i_dX = ((modelStruct.modelPar_VFMAX>0.0)?modelStruct.d_modelPar_VFMAX_dX:0.0);
modelStruct.modelVar_VFMAX_i = ((modelStruct.modelPar_VFMAX>0.0)?modelStruct.modelPar_VFMAX:0.0);
modelStruct.d_modelVar_VRMAX_i_dX = ((modelStruct.modelPar_VRMAX>0.0)?modelStruct.d_modelPar_VRMAX_dX:0.0);
modelStruct.modelVar_VRMAX_i = ((modelStruct.modelPar_VRMAX>0.0)?modelStruct.modelPar_VRMAX:0.0);
d_XTI_i_dX = ((modelStruct.modelPar_XTI>0.1)?modelStruct.d_modelPar_XTI_dX:0.0);
XTI_i = ((modelStruct.modelPar_XTI>0.1)?modelStruct.modelPar_XTI:0.1);
modelStruct.d_modelVar_SCALE_i_dX = ((modelStruct.modelPar_SCALE>0)?modelStruct.d_modelPar_SCALE_dX:0.0);
modelStruct.modelVar_SCALE_i = ((modelStruct.modelPar_SCALE>0)?modelStruct.modelPar_SCALE:0);
d_SHRINK_i_dX = ((modelStruct.modelPar_SHRINK>0)?modelStruct.d_modelPar_SHRINK_dX:0.0);
SHRINK_i = ((modelStruct.modelPar_SHRINK>0)?modelStruct.modelPar_SHRINK:0);
modelStruct.modelVar_SWJUNEXP_i = 0.0;
if ((modelStruct.modelPar_SWJUNEXP>0.5))
{
modelStruct.modelVar_SWJUNEXP_i = 1.0;
}
else
{
modelStruct.modelVar_SWJUNEXP_i = 0.0;
}
modelStruct.d_modelVar_VJUNREF_i_dX = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.d_modelPar_VJUNREF_dX:0.0);
modelStruct.modelVar_VJUNREF_i = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.modelPar_VJUNREF:0.5);
modelStruct.d_modelVar_FJUNQ_i_dX = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.d_modelPar_FJUNQ_dX:0.0);
modelStruct.modelVar_FJUNQ_i = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.modelPar_FJUNQ:0.0);
modelStruct.d_modelVar_tkr_dX = d_TRJ_i_dX;
modelStruct.modelVar_tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsTemperature+modelStruct.modelPar_DTA),(273.15+(-250)));
double  deriv_max_0_d0 = (((admsTemperature+modelStruct.modelPar_DTA)>=(273.15+(-250)))?1.0:0.0);
modelStruct.d_modelVar_tkd_dX = (deriv_max_0_d0*(modelStruct.d_modelPar_DTA_dX));
modelStruct.modelVar_tkd = value_max_0;
}
d_auxt_dX = ((modelStruct.modelVar_tkr*modelStruct.d_modelVar_tkd_dX-modelStruct.modelVar_tkd*modelStruct.d_modelVar_tkr_dX)/modelStruct.modelVar_tkr/modelStruct.modelVar_tkr);
auxt = (modelStruct.modelVar_tkd/modelStruct.modelVar_tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
modelStruct.d_modelVar_phitr_dX = KBOL_over_QELE*modelStruct.d_modelVar_tkr_dX;
modelStruct.modelVar_phitr = (KBOL_over_QELE*modelStruct.modelVar_tkr);
d_phitrinv_dX = (-modelStruct.d_modelVar_phitr_dX/modelStruct.modelVar_phitr/modelStruct.modelVar_phitr);
phitrinv = (1.0/modelStruct.modelVar_phitr);
modelStruct.d_modelVar_phitd_dX = KBOL_over_QELE*modelStruct.d_modelVar_tkd_dX;
modelStruct.modelVar_phitd = (KBOL_over_QELE*modelStruct.modelVar_tkd);
modelStruct.d_modelVar_phitdinv_dX = (-modelStruct.d_modelVar_phitd_dX/modelStruct.modelVar_phitd/modelStruct.modelVar_phitd);
modelStruct.modelVar_phitdinv = (1.0/modelStruct.modelVar_phitd);
d_deltaphigr_dX = (((1108.0+modelStruct.modelVar_tkr)*(-((7.02e-4*modelStruct.modelVar_tkr)*modelStruct.d_modelVar_tkr_dX+7.02e-4*modelStruct.d_modelVar_tkr_dX*modelStruct.modelVar_tkr))-(-((7.02e-4*modelStruct.modelVar_tkr)*modelStruct.modelVar_tkr))*modelStruct.d_modelVar_tkr_dX)/(1108.0+modelStruct.modelVar_tkr)/(1108.0+modelStruct.modelVar_tkr));
deltaphigr = ((-((7.02e-4*modelStruct.modelVar_tkr)*modelStruct.modelVar_tkr))/(1108.0+modelStruct.modelVar_tkr));
d_phigrbot_dX = (d_PHIGBOT_i_dX+d_deltaphigr_dX);
phigrbot = (PHIGBOT_i+deltaphigr);
d_phigrsti_dX = (d_PHIGSTI_i_dX+d_deltaphigr_dX);
phigrsti = (PHIGSTI_i+deltaphigr);
d_phigrgat_dX = (d_PHIGGAT_i_dX+d_deltaphigr_dX);
phigrgat = (PHIGGAT_i+deltaphigr);
d_deltaphigd_dX = (((1108.0+modelStruct.modelVar_tkd)*(-((7.02e-4*modelStruct.modelVar_tkd)*modelStruct.d_modelVar_tkd_dX+7.02e-4*modelStruct.d_modelVar_tkd_dX*modelStruct.modelVar_tkd))-(-((7.02e-4*modelStruct.modelVar_tkd)*modelStruct.modelVar_tkd))*modelStruct.d_modelVar_tkd_dX)/(1108.0+modelStruct.modelVar_tkd)/(1108.0+modelStruct.modelVar_tkd));
deltaphigd = ((-((7.02e-4*modelStruct.modelVar_tkd)*modelStruct.modelVar_tkd))/(1108.0+modelStruct.modelVar_tkd));
d_phigdbot_dX = (d_PHIGBOT_i_dX+d_deltaphigd_dX);
phigdbot = (PHIGBOT_i+deltaphigd);
d_phigdsti_dX = (d_PHIGSTI_i_dX+d_deltaphigd_dX);
phigdsti = (PHIGSTI_i+deltaphigd);
d_phigdgat_dX = (d_PHIGGAT_i_dX+d_deltaphigd_dX);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*(XTI_i/2.0)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdbot_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrbot*d_phitrinv_dX+d_phigrbot_dX*phitrinv)-(phigdbot*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_dX*modelStruct.modelVar_phitdinv)))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*((d_XTI_i_dX/2.0))))*value_exp_1);
modelStruct.modelVar_ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*(XTI_i/2.0)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdsti_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrsti*d_phitrinv_dX+d_phigrsti_dX*phitrinv)-(phigdsti*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_dX*modelStruct.modelVar_phitdinv)))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*((d_XTI_i_dX/2.0))))*value_exp_1);
modelStruct.modelVar_ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,(XTI_i/2.0));
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*(XTI_i/2.0)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdgat_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrgat*d_phitrinv_dX+d_phigrgat_dX*phitrinv)-(phigdgat*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_dX*modelStruct.modelVar_phitdinv)))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*((d_XTI_i_dX/2.0))))*value_exp_1);
modelStruct.modelVar_ftdgat = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/modelStruct.modelVar_NFABOT_i));
double value_exp_1 = exp(((0.5*((phigrbot*phitrinv)-(phigdbot*modelStruct.modelVar_phitdinv)))/modelStruct.modelVar_NFABOT_i));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*((XTI_i/2.0)/modelStruct.modelVar_NFABOT_i)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
d_ftdbot2_dX = (value_pow_0*deriv_exp_1_d0*(((modelStruct.modelVar_NFABOT_i*0.5*((phigrbot*d_phitrinv_dX+d_phigrbot_dX*phitrinv)-(phigdbot*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_dX*modelStruct.modelVar_phitdinv))-(0.5*((phigrbot*phitrinv)-(phigdbot*modelStruct.modelVar_phitdinv)))*modelStruct.d_modelVar_NFABOT_i_dX)/modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_NFABOT_i))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(((modelStruct.modelVar_NFABOT_i*(d_XTI_i_dX/2.0)-(XTI_i/2.0)*modelStruct.d_modelVar_NFABOT_i_dX)/modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_NFABOT_i))))*value_exp_1);
ftdbot2 = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/modelStruct.modelVar_NFASTI_i));
double value_exp_1 = exp(((0.5*((phigrsti*phitrinv)-(phigdsti*modelStruct.modelVar_phitdinv)))/modelStruct.modelVar_NFASTI_i));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*((XTI_i/2.0)/modelStruct.modelVar_NFASTI_i)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
d_ftdsti2_dX = (value_pow_0*deriv_exp_1_d0*(((modelStruct.modelVar_NFASTI_i*0.5*((phigrsti*d_phitrinv_dX+d_phigrsti_dX*phitrinv)-(phigdsti*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_dX*modelStruct.modelVar_phitdinv))-(0.5*((phigrsti*phitrinv)-(phigdsti*modelStruct.modelVar_phitdinv)))*modelStruct.d_modelVar_NFASTI_i_dX)/modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_NFASTI_i))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(((modelStruct.modelVar_NFASTI_i*(d_XTI_i_dX/2.0)-(XTI_i/2.0)*modelStruct.d_modelVar_NFASTI_i_dX)/modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_NFASTI_i))))*value_exp_1);
ftdsti2 = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,((XTI_i/2.0)/modelStruct.modelVar_NFAGAT_i));
double value_exp_1 = exp(((0.5*((phigrgat*phitrinv)-(phigdgat*modelStruct.modelVar_phitdinv)))/modelStruct.modelVar_NFAGAT_i));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*((XTI_i/2.0)/modelStruct.modelVar_NFAGAT_i)/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
double  deriv_exp_1_d0 = value_exp_1;
d_ftdgat2_dX = (value_pow_0*deriv_exp_1_d0*(((modelStruct.modelVar_NFAGAT_i*0.5*((phigrgat*d_phitrinv_dX+d_phigrgat_dX*phitrinv)-(phigdgat*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_dX*modelStruct.modelVar_phitdinv))-(0.5*((phigrgat*phitrinv)-(phigdgat*modelStruct.modelVar_phitdinv)))*modelStruct.d_modelVar_NFAGAT_i_dX)/modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_NFAGAT_i))+((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(((modelStruct.modelVar_NFAGAT_i*(d_XTI_i_dX/2.0)-(XTI_i/2.0)*modelStruct.d_modelVar_NFAGAT_i_dX)/modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_NFAGAT_i))))*value_exp_1);
ftdgat2 = (value_pow_0*value_exp_1);
}
modelStruct.d_modelVar_idsatbot_dX = ((IDSATRBOT_i*ftdbot2)*d_ftdbot2_dX+(IDSATRBOT_i*d_ftdbot2_dX+d_IDSATRBOT_i_dX*ftdbot2)*ftdbot2);
modelStruct.modelVar_idsatbot = ((IDSATRBOT_i*ftdbot2)*ftdbot2);
modelStruct.d_modelVar_idsatsti_dX = ((IDSATRSTI_i*ftdsti2)*d_ftdsti2_dX+(IDSATRSTI_i*d_ftdsti2_dX+d_IDSATRSTI_i_dX*ftdsti2)*ftdsti2);
modelStruct.modelVar_idsatsti = ((IDSATRSTI_i*ftdsti2)*ftdsti2);
modelStruct.d_modelVar_idsatgat_dX = ((IDSATRGAT_i*ftdgat2)*d_ftdgat2_dX+(IDSATRGAT_i*d_ftdgat2_dX+d_IDSATRGAT_i_dX*ftdgat2)*ftdgat2);
modelStruct.modelVar_idsatgat = ((IDSATRGAT_i*ftdgat2)*ftdgat2);
{
double value_log_0 = log(modelStruct.modelVar_ftdbot);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdbot);
d_ubibot_dX = ((modelStruct.modelVar_VBIRBOT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdbot_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubibot = ((modelStruct.modelVar_VBIRBOT_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdsti);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdsti);
d_ubisti_dX = ((modelStruct.modelVar_VBIRSTI_i*d_auxt_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdsti_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubisti = ((modelStruct.modelVar_VBIRSTI_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdgat);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdgat);
d_ubigat_dX = ((modelStruct.modelVar_VBIRGAT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdgat_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubigat = ((modelStruct.modelVar_VBIRGAT_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbibot_dX = (d_ubibot_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubibot)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubibot_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbibot = (ubibot+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbisti_dX = (d_ubisti_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubisti)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubisti_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbisti = (ubisti+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbigat_dX = (d_ubigat_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubigat)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubigat_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbigat = (ubigat+(modelStruct.modelVar_phitd*value_log_1));
}
modelStruct.d_modelVar_vbiinvbot_dX = (-modelStruct.d_modelVar_vbibot_dX/modelStruct.modelVar_vbibot/modelStruct.modelVar_vbibot);
modelStruct.modelVar_vbiinvbot = (1.0/modelStruct.modelVar_vbibot);
modelStruct.d_modelVar_vbiinvsti_dX = (-modelStruct.d_modelVar_vbisti_dX/modelStruct.modelVar_vbisti/modelStruct.modelVar_vbisti);
modelStruct.modelVar_vbiinvsti = (1.0/modelStruct.modelVar_vbisti);
modelStruct.d_modelVar_vbiinvgat_dX = (-modelStruct.d_modelVar_vbigat_dX/modelStruct.modelVar_vbigat/modelStruct.modelVar_vbigat);
modelStruct.modelVar_vbiinvgat = (1.0/modelStruct.modelVar_vbigat);
modelStruct.d_modelVar_one_minus_PBOT_dX = (-modelStruct.d_modelVar_PBOT_i_dX);
modelStruct.modelVar_one_minus_PBOT = (1-modelStruct.modelVar_PBOT_i);
modelStruct.d_modelVar_one_minus_PSTI_dX = (-modelStruct.d_modelVar_PSTI_i_dX);
modelStruct.modelVar_one_minus_PSTI = (1-modelStruct.modelVar_PSTI_i);
modelStruct.d_modelVar_one_minus_PGAT_dX = (-modelStruct.d_modelVar_PGAT_i_dX);
modelStruct.modelVar_one_minus_PGAT = (1-modelStruct.modelVar_PGAT_i);
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX = (-1*modelStruct.d_modelVar_one_minus_PBOT_dX/modelStruct.modelVar_one_minus_PBOT/modelStruct.modelVar_one_minus_PBOT);
modelStruct.modelVar_one_over_one_minus_PBOT = (1/modelStruct.modelVar_one_minus_PBOT);
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX = (-1*modelStruct.d_modelVar_one_minus_PSTI_dX/modelStruct.modelVar_one_minus_PSTI/modelStruct.modelVar_one_minus_PSTI);
modelStruct.modelVar_one_over_one_minus_PSTI = (1/modelStruct.modelVar_one_minus_PSTI);
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX = (-1*modelStruct.d_modelVar_one_minus_PGAT_dX/modelStruct.modelVar_one_minus_PGAT/modelStruct.modelVar_one_minus_PGAT);
modelStruct.modelVar_one_over_one_minus_PGAT = (1/modelStruct.modelVar_one_minus_PGAT);
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot))*value_pow_0);
modelStruct.d_modelVar_cjobot_dX = (CJORBOT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRBOT_i*modelStruct.d_modelVar_vbiinvbot_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*modelStruct.modelVar_vbiinvbot)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)))+d_CJORBOT_i_dX*value_pow_0);
modelStruct.modelVar_cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti))*value_pow_0);
modelStruct.d_modelVar_cjosti_dX = (CJORSTI_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRSTI_i*modelStruct.d_modelVar_vbiinvsti_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*modelStruct.modelVar_vbiinvsti)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)))+d_CJORSTI_i_dX*value_pow_0);
modelStruct.modelVar_cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat))*value_pow_0);
modelStruct.d_modelVar_cjogat_dX = (CJORGAT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRGAT_i*modelStruct.d_modelVar_vbiinvgat_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*modelStruct.modelVar_vbiinvgat)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)))+d_CJORGAT_i_dX*value_pow_0);
modelStruct.modelVar_cjogat = (CJORGAT_i*value_pow_0);
}
modelStruct.d_modelVar_qprefbot_dX = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(modelStruct.modelVar_cjobot*modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_cjobot_dX*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.modelVar_qprefbot = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.d_modelVar_qprefsti_dX = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(modelStruct.modelVar_cjosti*modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_cjosti_dX*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.modelVar_qprefsti = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.d_modelVar_qprefgat_dX = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(modelStruct.modelVar_cjogat*modelStruct.d_modelVar_vbigat_dX+modelStruct.d_modelVar_cjogat_dX*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.modelVar_qprefgat = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.d_modelVar_qpref2bot_dX = 2*modelStruct.d_modelVar_cjobot_dX;
modelStruct.modelVar_qpref2bot = (2*modelStruct.modelVar_cjobot);
modelStruct.d_modelVar_qpref2sti_dX = 2*modelStruct.d_modelVar_cjosti_dX;
modelStruct.modelVar_qpref2sti = (2*modelStruct.modelVar_cjosti);
modelStruct.d_modelVar_qpref2gat_dX = 2*modelStruct.d_modelVar_cjogat_dX;
modelStruct.modelVar_qpref2gat = (2*modelStruct.modelVar_cjogat);
modelStruct.d_modelVar_wdepnulrbot_dX = (-EPSSI*d_CJORBOT_i_dX/CJORBOT_i/CJORBOT_i);
modelStruct.modelVar_wdepnulrbot = (EPSSI/CJORBOT_i);
modelStruct.d_modelVar_wdepnulrsti_dX = ((CJORSTI_i*d_XJUNSTI_i_dX*EPSSI-(XJUNSTI_i*EPSSI)*d_CJORSTI_i_dX)/CJORSTI_i/CJORSTI_i);
modelStruct.modelVar_wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
modelStruct.d_modelVar_wdepnulrgat_dX = ((CJORGAT_i*d_XJUNGAT_i_dX*EPSSI-(XJUNGAT_i*EPSSI)*d_CJORGAT_i_dX)/CJORGAT_i/CJORGAT_i);
modelStruct.modelVar_wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
modelStruct.d_modelVar_wdepnulrinvbot_dX = (-1*modelStruct.d_modelVar_wdepnulrbot_dX/modelStruct.modelVar_wdepnulrbot/modelStruct.modelVar_wdepnulrbot);
modelStruct.modelVar_wdepnulrinvbot = (1/modelStruct.modelVar_wdepnulrbot);
modelStruct.d_modelVar_wdepnulrinvsti_dX = (-1*modelStruct.d_modelVar_wdepnulrsti_dX/modelStruct.modelVar_wdepnulrsti/modelStruct.modelVar_wdepnulrsti);
modelStruct.modelVar_wdepnulrinvsti = (1/modelStruct.modelVar_wdepnulrsti);
modelStruct.d_modelVar_wdepnulrinvgat_dX = (-1*modelStruct.d_modelVar_wdepnulrgat_dX/modelStruct.modelVar_wdepnulrgat/modelStruct.modelVar_wdepnulrgat);
modelStruct.modelVar_wdepnulrinvgat = (1/modelStruct.modelVar_wdepnulrgat);
modelStruct.d_modelVar_VBIRBOTinv_dX = (-1*modelStruct.d_modelVar_VBIRBOT_i_dX/modelStruct.modelVar_VBIRBOT_i/modelStruct.modelVar_VBIRBOT_i);
modelStruct.modelVar_VBIRBOTinv = (1/modelStruct.modelVar_VBIRBOT_i);
modelStruct.d_modelVar_VBIRSTIinv_dX = (-1*modelStruct.d_modelVar_VBIRSTI_i_dX/modelStruct.modelVar_VBIRSTI_i/modelStruct.modelVar_VBIRSTI_i);
modelStruct.modelVar_VBIRSTIinv = (1/modelStruct.modelVar_VBIRSTI_i);
modelStruct.d_modelVar_VBIRGATinv_dX = (-1*modelStruct.d_modelVar_VBIRGAT_i_dX/modelStruct.modelVar_VBIRGAT_i/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_VBIRGATinv = (1/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(modelStruct.modelVar_perfc,(-2));
modelStruct.modelVar_berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3);
}
modelStruct.modelVar_cerfc = ((1.0-0.29214664)-modelStruct.modelVar_berfc);
{
double value_max_0 = std::max((0.5*phigdbot),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEbot_dX = ((deriv_max_0_d0*(0.5*d_phigdbot_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEsti_dX = ((deriv_max_0_d0*(0.5*d_phigdsti_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEgat_dX = ((deriv_max_0_d0*(0.5*d_phigdgat_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEgat = value_max_0;
}
modelStruct.d_modelVar_atatbot_dX = (deltaEbot*modelStruct.d_modelVar_phitdinv_dX+d_deltaEbot_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatbot = (deltaEbot*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatsti_dX = (deltaEsti*modelStruct.d_modelVar_phitdinv_dX+d_deltaEsti_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatsti = (deltaEsti*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatgat_dX = (deltaEgat*modelStruct.d_modelVar_phitdinv_dX+d_deltaEgat_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatgat = (deltaEgat*modelStruct.modelVar_phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartbot_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*d_deltaEbot_dX+(deltaEbot*d_deltaEbot_dX+d_deltaEbot_dX*deltaEbot)*deltaEbot)+32*d_MEFFTATBOT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEbot*deltaEbot)*deltaEbot)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartsti_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*d_deltaEsti_dX+(deltaEsti*d_deltaEsti_dX+d_deltaEsti_dX*deltaEsti)*deltaEsti)+32*d_MEFFTATSTI_i_dX*9.1093826E-31*1.6021918E-19*((deltaEsti*deltaEsti)*deltaEsti)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartgat_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*d_deltaEgat_dX+(deltaEgat*d_deltaEgat_dX+d_deltaEgat_dX*deltaEgat)*deltaEgat)+32*d_MEFFTATGAT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEgat*deltaEgat)*deltaEgat)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
}
modelStruct.d_modelVar_fbbtbot_dX = (FBBTRBOT_i*(STFBBTBOT_i*(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)+d_STFBBTBOT_i_dX*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))+d_FBBTRBOT_i_dX*(1+(STFBBTBOT_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.modelVar_fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.d_modelVar_fbbtsti_dX = (FBBTRSTI_i*(STFBBTSTI_i*(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)+d_STFBBTSTI_i_dX*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))+d_FBBTRSTI_i_dX*(1+(STFBBTSTI_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.modelVar_fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.d_modelVar_fbbtgat_dX = (FBBTRGAT_i*(STFBBTGAT_i*(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)+d_STFBBTGAT_i_dX*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))+d_FBBTRGAT_i_dX*(1+(STFBBTGAT_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.modelVar_fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(modelStruct.modelVar_tkd-modelStruct.modelVar_tkr))));
modelStruct.d_modelVar_fbbtbot_dX = ((modelStruct.modelVar_fbbtbot>0)?modelStruct.d_modelVar_fbbtbot_dX:0.0);
modelStruct.modelVar_fbbtbot = ((modelStruct.modelVar_fbbtbot>0)?modelStruct.modelVar_fbbtbot:0);
modelStruct.d_modelVar_fbbtsti_dX = ((modelStruct.modelVar_fbbtsti>0)?modelStruct.d_modelVar_fbbtsti_dX:0.0);
modelStruct.modelVar_fbbtsti = ((modelStruct.modelVar_fbbtsti>0)?modelStruct.modelVar_fbbtsti:0);
modelStruct.d_modelVar_fbbtgat_dX = ((modelStruct.modelVar_fbbtgat>0)?modelStruct.d_modelVar_fbbtgat_dX:0.0);
modelStruct.modelVar_fbbtgat = ((modelStruct.modelVar_fbbtgat>0)?modelStruct.modelVar_fbbtgat:0);
modelStruct.d_modelVar_alphaav_dX = ((FREV_i*d_FREV_i_dX-(FREV_i-1)*d_FREV_i_dX)/FREV_i/FREV_i);
modelStruct.modelVar_alphaav = ((FREV_i-1)/FREV_i);
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRBOT_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRBOT_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopbot_dX = (-1*(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX))))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopbot = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRSTI_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRSTI_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopsti_dX = (-1*(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX))))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopsti = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRGAT_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRGAT_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopgat_dX = (-1*(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX))))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopgat = (1/(1-value_pow_0));
}
modelStruct.d_modelVar_VBRBOT_i_dX = (modelStruct.modelVar_VBRBOT_i*((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(d_STVBRBOT1_i_dX+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*d_STVBRBOT2_i_dX+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*STVBRBOT2_i))+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*(STVBRBOT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRBOT2_i)))+modelStruct.d_modelVar_VBRBOT_i_dX*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRBOT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRBOT2_i)))));
modelStruct.modelVar_VBRBOT_i = (modelStruct.modelVar_VBRBOT_i*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRBOT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRBOT2_i)))));
modelStruct.d_modelVar_VBRSTI_i_dX = (modelStruct.modelVar_VBRSTI_i*((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(d_STVBRSTI1_i_dX+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*d_STVBRSTI2_i_dX+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*STVBRSTI2_i))+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*(STVBRSTI1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRSTI2_i)))+modelStruct.d_modelVar_VBRSTI_i_dX*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRSTI1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRSTI2_i)))));
modelStruct.modelVar_VBRSTI_i = (modelStruct.modelVar_VBRSTI_i*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRSTI1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRSTI2_i)))));
modelStruct.d_modelVar_VBRGAT_i_dX = (modelStruct.modelVar_VBRGAT_i*((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(d_STVBRGAT1_i_dX+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*d_STVBRGAT2_i_dX+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*STVBRGAT2_i))+(modelStruct.d_modelVar_tkd_dX-modelStruct.d_modelVar_tkr_dX)*(STVBRGAT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRGAT2_i)))+modelStruct.d_modelVar_VBRGAT_i_dX*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRGAT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRGAT2_i)))));
modelStruct.modelVar_VBRGAT_i = (modelStruct.modelVar_VBRGAT_i*(1+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*(STVBRGAT1_i+((modelStruct.modelVar_tkd-modelStruct.modelVar_tkr)*STVBRGAT2_i)))));
if ((modelStruct.modelVar_VBRBOT_i<=0.1))
{
modelStruct.d_modelVar_VBRBOT_i_dX = 0.0;
modelStruct.modelVar_VBRBOT_i = 0.1;
modelStruct.d_modelVar_VBRinvbot_dX = 0.0;
modelStruct.modelVar_VBRinvbot = 10.0;
}
else
{
modelStruct.d_modelVar_VBRinvbot_dX = (-modelStruct.d_modelVar_VBRBOT_i_dX/modelStruct.modelVar_VBRBOT_i/modelStruct.modelVar_VBRBOT_i);
modelStruct.modelVar_VBRinvbot = (1.0/modelStruct.modelVar_VBRBOT_i);
}
if ((modelStruct.modelVar_VBRSTI_i<=0.1))
{
modelStruct.d_modelVar_VBRSTI_i_dX = 0.0;
modelStruct.modelVar_VBRSTI_i = 0.1;
modelStruct.d_modelVar_VBRinvsti_dX = 0.0;
modelStruct.modelVar_VBRinvsti = 10.0;
}
else
{
modelStruct.d_modelVar_VBRinvsti_dX = (-modelStruct.d_modelVar_VBRSTI_i_dX/modelStruct.modelVar_VBRSTI_i/modelStruct.modelVar_VBRSTI_i);
modelStruct.modelVar_VBRinvsti = (1.0/modelStruct.modelVar_VBRSTI_i);
}
if ((modelStruct.modelVar_VBRGAT_i<=0.1))
{
modelStruct.d_modelVar_VBRGAT_i_dX = 0.0;
modelStruct.modelVar_VBRGAT_i = 0.1;
modelStruct.d_modelVar_VBRinvgat_dX = 0.0;
modelStruct.modelVar_VBRinvgat = 10.0;
}
else
{
modelStruct.d_modelVar_VBRinvgat_dX = (-modelStruct.d_modelVar_VBRGAT_i_dX/modelStruct.modelVar_VBRGAT_i/modelStruct.modelVar_VBRGAT_i);
modelStruct.modelVar_VBRinvgat = (1.0/modelStruct.modelVar_VBRGAT_i);
}
modelStruct.d_modelVar_shrinkL_dX = (-0.01*d_SHRINK_i_dX);
modelStruct.modelVar_shrinkL = (1.0-(0.01*SHRINK_i));
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRBOT_i-1));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRBOT_i-1)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopebot_dX = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.d_modelVar_VBRinvbot_dX+((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.d_modelVar_PBRBOT_i_dX+(-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)))+(modelStruct.modelVar_fstopbot*modelStruct.d_modelVar_fstopbot_dX+modelStruct.d_modelVar_fstopbot_dX*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
modelStruct.modelVar_slopebot = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRSTI_i-1));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRSTI_i-1)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopesti_dX = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.d_modelVar_VBRinvsti_dX+((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.d_modelVar_PBRSTI_i_dX+(-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)))+(modelStruct.modelVar_fstopsti*modelStruct.d_modelVar_fstopsti_dX+modelStruct.d_modelVar_fstopsti_dX*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
modelStruct.modelVar_slopesti = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRGAT_i-1));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRGAT_i-1)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopegat_dX = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.d_modelVar_VBRinvgat_dX+((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.d_modelVar_PBRGAT_i_dX+(-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)))+(modelStruct.modelVar_fstopgat*modelStruct.d_modelVar_fstopgat_dX+modelStruct.d_modelVar_fstopgat_dX*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
modelStruct.modelVar_slopegat = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
}
{
double value_pow_0 = pow(auxt,STRS_i);
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*STRS_i/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
modelStruct.d_modelVar_resbot_dX = (RSBOT_i*((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(d_STRS_i_dX)))+d_RSBOT_i_dX*value_pow_0);
modelStruct.modelVar_resbot = (RSBOT_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*STRS_i/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
modelStruct.d_modelVar_resgat_dX = (RSGAT_i*((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(d_STRS_i_dX)))+d_RSGAT_i_dX*value_pow_0);
modelStruct.modelVar_resgat = (RSGAT_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*STRS_i/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
modelStruct.d_modelVar_ressti_dX = (RSSTI_i*((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(d_STRS_i_dX)))+d_RSSTI_i_dX*value_pow_0);
modelStruct.modelVar_ressti = (RSSTI_i*value_pow_0);
}
{
double value_pow_0 = pow(auxt,STRS_i);
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*STRS_i/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
modelStruct.d_modelVar_rescom_dX = (RSCOM_i*((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(d_STRS_i_dX)))+d_RSCOM_i_dX*value_pow_0);
modelStruct.modelVar_rescom = (RSCOM_i*value_pow_0);
}
modelStruct.d_modelVar_NDIBOT_i_dX = modelStruct.d_modelPar_NDIBOT_dX*1.0e6;
modelStruct.modelVar_NDIBOT_i = (modelStruct.modelPar_NDIBOT*1.0e6);
modelStruct.d_modelVar_NDISTI_i_dX = modelStruct.d_modelPar_NDISTI_dX*1.0e6;
modelStruct.modelVar_NDISTI_i = (modelStruct.modelPar_NDISTI*1.0e6);
modelStruct.d_modelVar_NDIGAT_i_dX = modelStruct.d_modelPar_NDIGAT_dX*1.0e6;
modelStruct.modelVar_NDIGAT_i = (modelStruct.modelPar_NDIGAT*1.0e6);
modelStruct.d_modelVar_NDI_i_dX = modelStruct.d_modelVar_NDIBOT_i_dX;
modelStruct.modelVar_NDI_i = modelStruct.modelVar_NDIBOT_i;
modelStruct.d_modelVar_NJL_dX = modelStruct.d_modelVar_NFABOT_i_dX;
modelStruct.modelVar_NJL = modelStruct.modelVar_NFABOT_i;
MUEN_i = (1450*1.0e-4);
MUEP_i = (500*1.0e-4);
modelStruct.modelVar_PB = 0.6;
modelStruct.modelVar_JUNCDLT = 1e-3;
modelStruct.d_modelVar_Nin_dX = 1.45e+16*d_ftdbot2_dX;
modelStruct.modelVar_Nin = (1.45e+16*ftdbot2);
modelStruct.d_modelVar_Pn0_dX = ((modelStruct.modelVar_NDI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDI_i_dX)/modelStruct.modelVar_NDI_i/modelStruct.modelVar_NDI_i);
modelStruct.modelVar_Pn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDI_i);
{
double value_pow_0 = pow(auxt,(-1.5));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*(-1.5)/auxt));
d_T1_dX = (deriv_pow_0_d0*(d_auxt_dX));
T1 = value_pow_0;
}
d_Dn_dX = ((modelStruct.modelVar_phitdinv*MUEN_i*d_T1_dX-(MUEN_i*T1)*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv);
Dn = ((MUEN_i*T1)/modelStruct.modelVar_phitdinv);
d_Dp_dX = ((modelStruct.modelVar_phitdinv*MUEP_i*d_T1_dX-(MUEP_i*T1)*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv);
Dp = ((MUEP_i*T1)/modelStruct.modelVar_phitdinv);
d_Da_dX = (((Dn+Dp)*((2*Dn)*d_Dp_dX+2*d_Dn_dX*Dp)-((2*Dn)*Dp)*(d_Dn_dX+d_Dp_dX))/(Dn+Dp)/(Dn+Dp));
Da = (((2*Dn)*Dp)/(Dn+Dp));
{
double value_pow_0 = pow(auxt,modelStruct.modelPar_TAUT);
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_TAUT/auxt));
double  deriv_pow_0_d1 = (auxt == 0.0)?0.0:(log(auxt)*value_pow_0);
d_T2_dX = ((deriv_pow_0_d0*(d_auxt_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_TAUT_dX)));
T2 = value_pow_0;
}
d_tau_HL_dX = (modelStruct.modelPar_TAU*d_T2_dX+modelStruct.d_modelPar_TAU_dX*T2);
tau_HL = (modelStruct.modelPar_TAU*T2);
{
double value_sqrt_0 = sqrt((tau_HL*Da));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_La_dX = deriv_sqrt_0_d0*((tau_HL*d_Da_dX+d_tau_HL_dX*Da));
modelStruct.modelVar_La = value_sqrt_0;
}
{
double value_log_0 = log((modelStruct.modelVar_NDI_i/modelStruct.modelVar_Pn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDI_i/modelStruct.modelVar_Pn0));
modelStruct.d_modelVar_V_HA_dX = ((modelStruct.modelVar_NJL/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((modelStruct.modelVar_Pn0*modelStruct.d_modelVar_NDI_i_dX-modelStruct.modelVar_NDI_i*modelStruct.d_modelVar_Pn0_dX)/modelStruct.modelVar_Pn0/modelStruct.modelVar_Pn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NJL_dX-modelStruct.modelVar_NJL*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
modelStruct.modelVar_V_HA = ((modelStruct.modelVar_NJL/modelStruct.modelVar_phitdinv)*value_log_0);
}
{
double value_log_0 = log((modelStruct.modelVar_NDI_i/modelStruct.modelVar_Pn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDI_i/modelStruct.modelVar_Pn0));
modelStruct.d_modelVar_V_HK_dX = ((modelStruct.modelVar_NJL/modelStruct.modelVar_phitdinv)*(deriv_log_0_d0*(((modelStruct.modelVar_Pn0*modelStruct.d_modelVar_NDI_i_dX-modelStruct.modelVar_NDI_i*modelStruct.d_modelVar_Pn0_dX)/modelStruct.modelVar_Pn0/modelStruct.modelVar_Pn0))+((modelStruct.modelVar_La*modelStruct.d_modelPar_WI_dX-modelStruct.modelPar_WI*modelStruct.d_modelVar_La_dX)/modelStruct.modelVar_La/modelStruct.modelVar_La))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NJL_dX-modelStruct.modelVar_NJL*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*(value_log_0+(modelStruct.modelPar_WI/modelStruct.modelVar_La)));
modelStruct.modelVar_V_HK = ((modelStruct.modelVar_NJL/modelStruct.modelVar_phitdinv)*(value_log_0+(modelStruct.modelPar_WI/modelStruct.modelVar_La)));
}
}
// End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_A_GND,
const int admsProbeID_V_depl_A_GND,
const int admsProbeID_V_charge_K_GND,
const int admsProbeID_V_charge_A_GND,
const int admsProbeID_V_A_K,
const int admsProbeID_V_AIK_K,
const int admsProbeID_V_A_AIK,
// node constants
const int admsNodeID_A,
const int admsNodeID_K,
const int admsNodeID_AIK,
const int admsNodeID_charge_A,
const int admsNodeID_charge_K,
const int admsNodeID_depl_A,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double nj_K0=0.0;
double d_nj_K0_dX=0.0;
  double nj_K1=0.0;
double d_nj_K1_dX=0.0;
  double nj_K=0.0;
double d_nj_K_dX=0.0;
  double exp_A=0.0;
double d_exp_A_dX=0.0;
  double exp_K=0.0;
double d_exp_K_dX=0.0;
  double exp_A2=0.0;
double d_exp_A2_dX=0.0;
  double p_nA=0.0;
double d_p_nA_dX=0.0;
  double q_pexA=0.0;
double d_q_pexA_dX=0.0;
  double Q_qs_A=0.0;
double d_Q_qs_A_dX=0.0;
  double q_pexA_nqs=0.0;
double d_q_pexA_nqs_dX=0.0;
  double exp_K2=0.0;
double d_exp_K2_dX=0.0;
  double p_nK=0.0;
double d_p_nK_dX=0.0;
  double q_pexK=0.0;
double d_q_pexK_dX=0.0;
  double Q_qs_K=0.0;
double d_Q_qs_K_dX=0.0;
  double q_pexK_nqs=0.0;
double d_q_pexK_nqs_dX=0.0;
  double Vjunc_A=0.0;
double d_Vjunc_A_dX=0.0;
  double W_depA=0.0;
double d_W_depA_dX=0.0;
  double W_qs_A=0.0;
double d_W_qs_A_dX=0.0;
  double W_depA_nqs=0.0;
double d_W_depA_nqs_dX=0.0;
  double Q_n0=0.0;
double d_Q_n0_dX=0.0;
  double Q_nexA_nqs=0.0;
double d_Q_nexA_nqs_dX=0.0;
  double Q_nexK_nqs=0.0;
double d_Q_nexK_nqs_dX=0.0;
  double Qrr=0.0;
double d_Qrr_dX=0.0;
  double vj=0.0;
double d_vj_dX=0.0;
  double zinv=0.0;
double d_zinv_dX=0.0;
  double z=0.0;
double d_z_dX=0.0;
  double two_psistar=0.0;
double d_two_psistar_dX=0.0;
  double vjlim=0.0;
double d_vjlim_dX=0.0;
  double vjsrh=0.0;
double d_vjsrh_dX=0.0;
  double vbbt=0.0;
double d_vbbt_dX=0.0;
  double vav=0.0;
  double tmp=0.0;
double d_tmp_dX=0.0;
  double id=0.0;
double d_id_dX=0.0;
  double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
  double dwsrh=0.0;
double d_dwsrh_dX=0.0;
  double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
  double wsrh=0.0;
double d_wsrh_dX=0.0;
  double wdep=0.0;
double d_wdep_dX=0.0;
  double asrh=0.0;
double d_asrh_dX=0.0;
  double isrh=0.0;
double d_isrh_dX=0.0;
  double btat=0.0;
double d_btat_dX=0.0;
  double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
  double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
  double umax=0.0;
double d_umax_dX=0.0;
  double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
  double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
  double wgamma=0.0;
double d_wgamma_dX=0.0;
  double wtat=0.0;
double d_wtat_dX=0.0;
  double ktat=0.0;
double d_ktat_dX=0.0;
  double ltat=0.0;
double d_ltat_dX=0.0;
  double mtat=0.0;
double d_mtat_dX=0.0;
  double xerfc=0.0;
double d_xerfc_dX=0.0;
  double ysq=0.0;
double d_ysq_dX=0.0;
  double terfc=0.0;
double d_terfc_dX=0.0;
  double erfcpos=0.0;
double d_erfcpos_dX=0.0;
  double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
  double gammamax=0.0;
double d_gammamax_dX=0.0;
  double itat=0.0;
double d_itat_dX=0.0;
  double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
  double ibbt=0.0;
double d_ibbt_dX=0.0;
  double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
  double tm0=0.0;
double d_tm0_dX=0.0;
  double tm1=0.0;
double d_tm1_dX=0.0;
  double ijunfor1=0.0;
double d_ijunfor1_dX=0.0;
  double ijunfor2=0.0;
double d_ijunfor2_dX=0.0;
  double ijunrev=0.0;
double d_ijunrev_dX=0.0;
  double h5=0.0;
double d_h5_dX=0.0;
  double h4=0.0;
double d_h4_dX=0.0;
  double h3=0.0;
double d_h3_dX=0.0;
  double h2d=0.0;
double d_h2d_dX=0.0;
  double h2=0.0;
double d_h2_dX=0.0;
  double h1=0.0;
double d_h1_dX=0.0;
  double qjun=0.0;
double d_qjun_dX=0.0;
  double VRS=0.0;
  double Vtotal=0.0;


  // -- code converted from analog/code block
//Begin block evaluateStaticDynamic
{
if ((modelStruct.modelPar_TYPE==(-1)))
{
instanceStruct.instanceVar_VAK = (-(probeVars[admsProbeID_V_A_AIK]));
}
else
{
instanceStruct.instanceVar_VAK = (probeVars[admsProbeID_V_A_AIK]);
}
if ((modelStruct.modelVar_SWJUNEXP_i==1.0))
{
d_tm0_dX = ((instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR1_dX+instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1);
tm0 = ((instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1)?(instanceStruct.instanceVar_expxhf1*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf1_dX)+instanceStruct.d_instanceVar_expxhf1_dX*((tm0-instanceStruct.instanceVar_xhighf1)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1)?(instanceStruct.instanceVar_expxhf1*((tm0-instanceStruct.instanceVar_xhighf1)+1)):value_exp_0));
}
d_ijunfor1_dX = (instanceStruct.instanceVar_ISATFOR1*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR1_dX*(tm1-1.0));
ijunfor1 = (instanceStruct.instanceVar_ISATFOR1*(tm1-1.0));
d_tm0_dX = ((instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_dX+instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2);
tm0 = ((instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2)?(instanceStruct.instanceVar_expxhf2*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf2_dX)+instanceStruct.d_instanceVar_expxhf2_dX*((tm0-instanceStruct.instanceVar_xhighf2)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2)?(instanceStruct.instanceVar_expxhf2*((tm0-instanceStruct.instanceVar_xhighf2)+1)):value_exp_0));
}
d_ijunfor2_dX = (instanceStruct.instanceVar_ISATFOR2*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR2_dX*(tm1-1.0));
ijunfor2 = (instanceStruct.instanceVar_ISATFOR2*(tm1-1.0));
d_ijunrev_dX = 0.0;
ijunrev = 0.0;
if ((instanceStruct.instanceVar_m0flag>0))
{
d_ijunrev_dX = instanceStruct.instanceVar_VAK*(instanceStruct.d_instanceVar_ISATREV_dX+instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_MREV_dX);
ijunrev = (instanceStruct.instanceVar_VAK*(instanceStruct.instanceVar_ISATREV+(instanceStruct.instanceVar_VAK*instanceStruct.instanceVar_MREV)));
}
else
{
d_tm0_dX = (((-instanceStruct.instanceVar_VAK)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_dX+(-instanceStruct.instanceVar_VAK)*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV);
tm0 = (((-instanceStruct.instanceVar_VAK)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr)?(instanceStruct.instanceVar_expxhr*(d_tm0_dX-instanceStruct.d_instanceVar_xhighr_dX)+instanceStruct.d_instanceVar_expxhr_dX*((tm0-instanceStruct.instanceVar_xhighr)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr)?(instanceStruct.instanceVar_expxhr*((tm0-instanceStruct.instanceVar_xhighr)+1)):value_exp_0));
}
d_ijunrev_dX = ((-instanceStruct.instanceVar_ISATREV)*d_tm1_dX+(-instanceStruct.d_instanceVar_ISATREV_dX)*(tm1-1.0));
ijunrev = ((-instanceStruct.instanceVar_ISATREV)*(tm1-1.0));
}
instanceStruct.d_instanceVar_ijun_dX = ((d_ijunfor1_dX+d_ijunfor2_dX)+d_ijunrev_dX);
instanceStruct.instanceVar_ijun = ((ijunfor1+ijunfor2)+ijunrev);
instanceStruct.d_instanceVar_ijnon_dX = (d_ijunfor2_dX+d_ijunrev_dX);
instanceStruct.instanceVar_ijnon = (ijunfor2+ijunrev);
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
//Begin block evaluateDynamic
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2);
h2d = (instanceStruct.instanceVar_VAK+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
instanceStruct.d_instanceVar_vjv_dX = 2.0*(((h3+h5)*instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_vfmin_dX-(instanceStruct.instanceVar_VAK*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
instanceStruct.instanceVar_vjv = (2.0*((instanceStruct.instanceVar_VAK*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((instanceStruct.instanceVar_zflagbot>0.5))
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tmpv_dX = deriv_sqrt_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvbot_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvbot)));
instanceStruct.instanceVar_tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
instanceStruct.d_instanceVar_tmpv_dX = ((deriv_pow_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvbot_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
instanceStruct.instanceVar_tmpv = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-instanceStruct.d_instanceVar_tmpv_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2bot*(-instanceStruct.d_instanceVar_vjv_dX)+modelStruct.d_modelVar_qpref2bot_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2bot*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
}
else
{
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
if ((instanceStruct.instanceVar_zflagsti>0.5))
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tmpv_dX = deriv_sqrt_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvsti_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvsti)));
instanceStruct.instanceVar_tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
instanceStruct.d_instanceVar_tmpv_dX = ((deriv_pow_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvsti_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
instanceStruct.instanceVar_tmpv = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-instanceStruct.d_instanceVar_tmpv_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2sti*(-instanceStruct.d_instanceVar_vjv_dX)+modelStruct.d_modelVar_qpref2sti_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2sti*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
}
else
{
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
if ((instanceStruct.instanceVar_zflaggat>0.5))
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_tmpv_dX = deriv_sqrt_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvgat_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvgat)));
instanceStruct.instanceVar_tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(instanceStruct.instanceVar_vjv*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
instanceStruct.d_instanceVar_tmpv_dX = ((deriv_pow_0_d0*((-(instanceStruct.instanceVar_vjv*modelStruct.d_modelVar_vbiinvgat_dX+instanceStruct.d_instanceVar_vjv_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
instanceStruct.instanceVar_tmpv = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-instanceStruct.d_instanceVar_tmpv_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2gat*(-instanceStruct.d_instanceVar_vjv_dX)+modelStruct.d_modelVar_qpref2gat_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-instanceStruct.instanceVar_tmpv))+(modelStruct.modelVar_qpref2gat*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vjv)));
}
else
{
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
}
// End block evaluateDynamic
}
else
{
if ((!(((instanceStruct.instanceVar_AB_i==0)&&(instanceStruct.instanceVar_LS_i==0))&&(instanceStruct.instanceVar_LG_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.d_instanceVar_vch_dX+4.0*instanceStruct.d_instanceVar_vch_dX*instanceStruct.instanceVar_vch);
h1 = ((4.0*instanceStruct.instanceVar_vch)*instanceStruct.instanceVar_vch);
d_h2_dX = ((instanceStruct.instanceVar_vfmin*instanceStruct.d_instanceVar_vch_dX-instanceStruct.instanceVar_vch*instanceStruct.d_instanceVar_vfmin_dX)/instanceStruct.instanceVar_vfmin/instanceStruct.instanceVar_vfmin);
h2 = (instanceStruct.instanceVar_vch/instanceStruct.instanceVar_vfmin);
d_h2d_dX = (instanceStruct.instanceVar_vch*d_h2_dX+instanceStruct.d_instanceVar_vch_dX*h2);
h2d = (instanceStruct.instanceVar_VAK+(instanceStruct.instanceVar_vch*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_vfmin_dX-(instanceStruct.instanceVar_VAK*instanceStruct.instanceVar_vfmin)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((instanceStruct.instanceVar_VAK*instanceStruct.instanceVar_vfmin)/(h3+h5)));
if ((instanceStruct.instanceVar_VAK<instanceStruct.instanceVar_VMAX))
{
if ((fabs((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(-0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*instanceStruct.instanceVar_VAK*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(instanceStruct.instanceVar_VAK*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultbot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultbot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultbot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultbot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultbot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultsti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultsti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultsti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultsti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultsti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultsti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_idmultgat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_idmultgat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_idmultgat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_idmultgat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_idmultgat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*((-instanceStruct.instanceVar_VAK*instanceStruct.d_instanceVar_nj1_dX/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_idmultgat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VAK/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd));
zinv = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIBOT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIBOT_i_dX)/modelStruct.modelVar_NDIBOT_i/modelStruct.modelVar_NDIBOT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIBOT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIBOT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIBOT_i_dX-modelStruct.modelVar_NDIBOT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFABOT_i_dX-modelStruct.modelVar_NFABOT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFABOT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFABOT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFABOT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFABOT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFABOT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFABOT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFABOT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFABOT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFABOT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFABOT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFABOT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFABOT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFABOT_i))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFABOT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFABOT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFABOT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultbot_dX = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
instanceStruct.instanceVar_idmultbot = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_bot);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDISTI_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDISTI_i_dX)/modelStruct.modelVar_NDISTI_i/modelStruct.modelVar_NDISTI_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDISTI_i);
{
double value_log_0 = log((modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDISTI_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDISTI_i_dX-modelStruct.modelVar_NDISTI_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFASTI_i_dX-modelStruct.modelVar_NFASTI_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFASTI_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFASTI_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFASTI_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFASTI_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFASTI_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFASTI_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFASTI_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFASTI_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFASTI_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFASTI_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFASTI_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFASTI_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFASTI_i))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFASTI_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFASTI_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFASTI_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultsti_dX = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
instanceStruct.instanceVar_idmultsti = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_sti);
{
instanceStruct.d_instanceVar_pnn0_dX = ((modelStruct.modelVar_NDIGAT_i*(modelStruct.modelVar_Nin*modelStruct.d_modelVar_Nin_dX+modelStruct.d_modelVar_Nin_dX*modelStruct.modelVar_Nin)-(modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)*modelStruct.d_modelVar_NDIGAT_i_dX)/modelStruct.modelVar_NDIGAT_i/modelStruct.modelVar_NDIGAT_i);
instanceStruct.instanceVar_pnn0 = ((modelStruct.modelVar_Nin*modelStruct.modelVar_Nin)/modelStruct.modelVar_NDIGAT_i);
{
double value_log_0 = log((modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_NDIGAT_i/instanceStruct.instanceVar_pnn0));
instanceStruct.d_instanceVar_vha1_dX = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*deriv_log_0_d0*(((instanceStruct.instanceVar_pnn0*modelStruct.d_modelVar_NDIGAT_i_dX-modelStruct.modelVar_NDIGAT_i*instanceStruct.d_instanceVar_pnn0_dX)/instanceStruct.instanceVar_pnn0/instanceStruct.instanceVar_pnn0))+((modelStruct.modelVar_phitdinv*modelStruct.d_modelVar_NFAGAT_i_dX-modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelVar_phitdinv_dX)/modelStruct.modelVar_phitdinv/modelStruct.modelVar_phitdinv)*value_log_0);
instanceStruct.instanceVar_vha1 = ((modelStruct.modelVar_NFAGAT_i/modelStruct.modelVar_phitdinv)*value_log_0);
}
if ((modelStruct.modelVar_NFAGAT_i<modelStruct.modelPar_NJH))
{
instanceStruct.d_instanceVar_nja10_dX = ((modelStruct.modelPar_NJDV*(instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.d_instanceVar_vha1_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_nja10 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VMAX-instanceStruct.instanceVar_vha1))+modelStruct.modelVar_NFAGAT_i);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-instanceStruct.d_instanceVar_nja10_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-instanceStruct.instanceVar_nja10)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SU_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SU = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nja11_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nja11 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (instanceStruct.d_instanceVar_nja11_dX-modelStruct.d_modelVar_NFAGAT_i_dX);
instanceStruct.instanceVar_TMF1 = ((instanceStruct.instanceVar_nja11-modelStruct.modelVar_NFAGAT_i)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NFAGAT_i_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NFAGAT_i)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
instanceStruct.d_instanceVar_dFn_SL_dX = 0.5*((instanceStruct.instanceVar_TMF2*instanceStruct.d_instanceVar_TMF1_dX-instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF2_dX)/instanceStruct.instanceVar_TMF2/instanceStruct.instanceVar_TMF2);
instanceStruct.instanceVar_dFn_SL = (0.5*(1.0+(instanceStruct.instanceVar_TMF1/instanceStruct.instanceVar_TMF2)));
instanceStruct.d_instanceVar_nj1_dX = (modelStruct.d_modelVar_NFAGAT_i_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_nj1 = (modelStruct.modelVar_NFAGAT_i+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
instanceStruct.d_instanceVar_dnj1_dV_dX = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.d_instanceVar_dFn_SL_dX+(modelStruct.modelPar_NJDV*instanceStruct.d_instanceVar_dFn_SU_dX+modelStruct.d_modelPar_NJDV_dX*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
instanceStruct.instanceVar_dnj1_dV = ((modelStruct.modelPar_NJDV*instanceStruct.instanceVar_dFn_SU)*instanceStruct.instanceVar_dFn_SL);
}
else
{
instanceStruct.d_instanceVar_nj1_dX = modelStruct.d_modelVar_NFAGAT_i_dX;
instanceStruct.instanceVar_nj1 = modelStruct.modelVar_NFAGAT_i;
instanceStruct.d_instanceVar_dnj1_dV_dX = 0.0;
instanceStruct.instanceVar_dnj1_dV = 0.0;
}
}
if ((fabs((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_VMAX_dX-instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_nj1_dX)/instanceStruct.instanceVar_nj1/instanceStruct.instanceVar_nj1)+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*(instanceStruct.d_instanceVar_nj1_dX-modelStruct.d_modelVar_NFAGAT_i_dX)+instanceStruct.d_instanceVar_vha1_dX*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))-(instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*((instanceStruct.instanceVar_VMAX/instanceStruct.instanceVar_nj1)+((instanceStruct.instanceVar_vha1*(instanceStruct.instanceVar_nj1-modelStruct.modelVar_NFAGAT_i))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX = (modelStruct.modelVar_phitdinv*((((instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)*(instanceStruct.d_instanceVar_nj1_dX-(instanceStruct.instanceVar_VMAX*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_VMAX_dX*instanceStruct.instanceVar_dnj1_dV))-(instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))*(instanceStruct.instanceVar_nj1*instanceStruct.d_instanceVar_nj1_dX+instanceStruct.d_instanceVar_nj1_dX*instanceStruct.instanceVar_nj1))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1)/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+(((modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)*(instanceStruct.instanceVar_vha1*instanceStruct.d_instanceVar_dnj1_dV_dX+instanceStruct.d_instanceVar_vha1_dX*instanceStruct.instanceVar_dnj1_dV)-(instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)*(modelStruct.modelVar_NFAGAT_i*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NFAGAT_i_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.instanceVar_dVMAX_over_phitd_dV = (modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_nj1-(instanceStruct.instanceVar_VMAX*instanceStruct.instanceVar_dnj1_dV))/(instanceStruct.instanceVar_nj1*instanceStruct.instanceVar_nj1))+((instanceStruct.instanceVar_vha1*instanceStruct.instanceVar_dnj1_dV)/(modelStruct.modelVar_NFAGAT_i*modelStruct.modelPar_NJH))));
instanceStruct.d_instanceVar_idmultgat_dX = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX+(-instanceStruct.d_instanceVar_VMAX_dX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV)*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
instanceStruct.instanceVar_idmultgat = ((1+((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_VMAX)*instanceStruct.instanceVar_dVMAX_over_phitd_dV))*instanceStruct.instanceVar_exp_VMAX_over_phitd_gat);
}
instanceStruct.instanceVar_idmultbot = (instanceStruct.instanceVar_idmultbot-1.0);
instanceStruct.instanceVar_idmultsti = (instanceStruct.instanceVar_idmultsti-1.0);
instanceStruct.instanceVar_idmultgat = (instanceStruct.instanceVar_idmultgat-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((instanceStruct.instanceVar_VAK>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-instanceStruct.instanceVar_VAK)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin-two_psistar);
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_VAK-vjlim)*(instanceStruct.instanceVar_VAK-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((instanceStruct.instanceVar_VAK-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(instanceStruct.instanceVar_VAK-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((instanceStruct.instanceVar_VAK+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vbbtlim)*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_dX-deriv_sqrt_0_d0*((((instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vbbtlim)*(-instanceStruct.d_instanceVar_vbbtlim_dX)+(-instanceStruct.d_instanceVar_vbbtlim_dX)*(instanceStruct.instanceVar_VAK-instanceStruct.instanceVar_vbbtlim))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((instanceStruct.instanceVar_VAK+instanceStruct.instanceVar_vbbtlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((instanceStruct.instanceVar_VAK)*(instanceStruct.instanceVar_VAK))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vav = (0.5*(instanceStruct.instanceVar_VAK-value_sqrt_0));
}
}
else
{
instanceStruct.d_instanceVar_idmultbot_dX = 0.0;
instanceStruct.instanceVar_idmultbot = 0;
instanceStruct.d_instanceVar_idmultsti_dX = 0.0;
instanceStruct.instanceVar_idmultsti = 0;
instanceStruct.d_instanceVar_idmultgat_dX = 0.0;
instanceStruct.instanceVar_idmultgat = 0;
d_two_psistar_dX = 0.0;
two_psistar = 0;
d_vj_dX = 0.0;
vj = 0;
d_zinv_dX = 0.0;
zinv = 0;
d_vjsrh_dX = 0.0;
vjsrh = 0;
d_vbbt_dX = 0.0;
vbbt = 0;
vav = 0;
}
if ((instanceStruct.instanceVar_AB_i==0))
{
instanceStruct.d_instanceVar_ijunbot_dX = 0.0;
instanceStruct.instanceVar_ijunbot = 0;
instanceStruct.d_instanceVar_ijnonbot_dX = 0.0;
instanceStruct.instanceVar_ijnonbot = 0;
instanceStruct.d_instanceVar_qjunbot_dX = 0.0;
instanceStruct.instanceVar_qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(instanceStruct.instanceVar_VAK-vj)));
instanceStruct.instanceVar_qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(instanceStruct.instanceVar_VAK-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_idmultbot_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_idmultbot);
id = (modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_idmultbot);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*d_tmp_dX+((instanceStruct.instanceVar_VAK*Fmaxr)*d_Fmaxr_dX+instanceStruct.instanceVar_VAK*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
instanceStruct.d_instanceVar_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonbot_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonbot = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LS_i==0))
{
instanceStruct.d_instanceVar_ijunsti_dX = 0.0;
instanceStruct.instanceVar_ijunsti = 0;
instanceStruct.d_instanceVar_ijnonsti_dX = 0.0;
instanceStruct.instanceVar_ijnonsti = 0;
instanceStruct.d_instanceVar_qjunsti_dX = 0.0;
instanceStruct.instanceVar_qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(instanceStruct.instanceVar_VAK-vj)));
instanceStruct.instanceVar_qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(instanceStruct.instanceVar_VAK-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_idmultsti_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_idmultsti);
id = (modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_idmultsti);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*d_tmp_dX+((instanceStruct.instanceVar_VAK*Fmaxr)*d_Fmaxr_dX+instanceStruct.instanceVar_VAK*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
instanceStruct.d_instanceVar_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnonsti_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnonsti = (((isrh+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LG_i==0))
{
instanceStruct.d_instanceVar_ijungat_dX = 0.0;
instanceStruct.instanceVar_ijungat = 0;
instanceStruct.d_instanceVar_ijnongat_dX = 0.0;
instanceStruct.instanceVar_ijnongat = 0;
instanceStruct.d_instanceVar_qjungat_dX = 0.0;
instanceStruct.instanceVar_qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
instanceStruct.d_instanceVar_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(instanceStruct.instanceVar_VAK-vj)));
instanceStruct.instanceVar_qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(instanceStruct.instanceVar_VAK-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_idmultgat_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_idmultgat);
id = (modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_idmultgat);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0;
d_wsrh_dX = 0.0;
wsrh = 0;
d_wdep_dX = 0.0;
wdep = 0;
d_asrh_dX = 0.0;
asrh = 0;
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*d_tmp_dX+((instanceStruct.instanceVar_VAK*Fmaxr)*d_Fmaxr_dX+instanceStruct.instanceVar_VAK*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((instanceStruct.instanceVar_VAK*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
instanceStruct.d_instanceVar_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
instanceStruct.d_instanceVar_ijnongat_dX = (((isrh+itat)+ibbt)*d_fbreakdown_dX+((d_isrh_dX+d_itat_dX)+d_ibbt_dX)*fbreakdown);
instanceStruct.instanceVar_ijnongat = (((isrh+itat)+ibbt)*fbreakdown);
}
instanceStruct.d_instanceVar_ijun_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijungat));
instanceStruct.instanceVar_ijun = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijungat));
instanceStruct.d_instanceVar_ijnon_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_ijnonbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_ijnonbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_ijnonsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_ijnonsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_ijnongat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_ijnongat));
instanceStruct.instanceVar_ijnon = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_ijnonbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_ijnonsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_ijnongat));
}
d_qjun_dX = (((instanceStruct.instanceVar_AB_i*instanceStruct.d_instanceVar_qjunbot_dX+instanceStruct.d_instanceVar_AB_i_dX*instanceStruct.instanceVar_qjunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.d_instanceVar_qjunsti_dX+instanceStruct.d_instanceVar_LS_i_dX*instanceStruct.instanceVar_qjunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.d_instanceVar_qjungat_dX+instanceStruct.d_instanceVar_LG_i_dX*instanceStruct.instanceVar_qjungat));
qjun = (((instanceStruct.instanceVar_AB_i*instanceStruct.instanceVar_qjunbot)+(instanceStruct.instanceVar_LS_i*instanceStruct.instanceVar_qjunsti))+(instanceStruct.instanceVar_LG_i*instanceStruct.instanceVar_qjungat));
VRS = (probeVars[admsProbeID_V_AIK_K]);
Vtotal = (probeVars[admsProbeID_V_A_K]);
}
// End block evaluateStaticDynamic
if (((Vtotal>modelStruct.modelVar_VFMAX_i)&&(modelStruct.modelVar_VFMAX_i>1e-12)))
{
UserInfo(theInstance)  << "WARNING: Diode forward bias voltage is larger than maximum allowed value \n" << " " <<  std::endl; 
}
if (((Vtotal<((-1.0)*modelStruct.modelVar_VRMAX_i))&&(modelStruct.modelVar_VRMAX_i>1e-12)))
{
UserInfo(theInstance)  << "WARNING: Diode reverse bias voltage is less than maximum allowed value \n" << " " <<  std::endl; 
}
//Begin block evaluateRecoveryCharge
{
if ((modelStruct.modelPar_CORECOVERY>0))
{
if ((modelStruct.modelVar_NJL<modelStruct.modelPar_NJH))
{
d_nj_K0_dX = ((modelStruct.modelPar_NJDV*(-modelStruct.d_modelVar_V_HK_dX)+modelStruct.d_modelPar_NJDV_dX*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))+modelStruct.d_modelVar_NJL_dX);
nj_K0 = ((modelStruct.modelPar_NJDV*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))+modelStruct.modelVar_NJL);
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_NJH_dX-d_nj_K0_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_NJH-nj_K0)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_NJH_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_NJH)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
d_nj_K1_dX = (modelStruct.d_modelPar_NJH_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
nj_K1 = (modelStruct.modelPar_NJH-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
{
instanceStruct.d_instanceVar_TMF1_dX = (d_nj_K1_dX-modelStruct.d_modelVar_NJL_dX);
instanceStruct.instanceVar_TMF1 = ((nj_K1-modelStruct.modelVar_NJL)-1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelVar_NJL_dX*1.0e-2;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelVar_NJL)*1.0e-2);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
d_nj_K_dX = (modelStruct.d_modelVar_NJL_dX+0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
nj_K = (modelStruct.modelVar_NJL+(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
}
else
{
d_nj_K_dX = modelStruct.d_modelVar_NJL_dX;
nj_K = modelStruct.modelVar_NJL;
}
d_exp_A_dX = instanceStruct.d_instanceVar_idmultbot_dX;
exp_A = instanceStruct.instanceVar_idmultbot;
if (((instanceStruct.instanceVar_VAK-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA))>0))
{
if ((fabs((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))));
double  deriv_exp_0_d0 = value_exp_0;
d_exp_K_dX = deriv_exp_0_d0*((modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))));
exp_K = value_exp_0;
}
}
else
{
if (((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))<(-2.3025850929940458e+02)))
{
d_exp_K_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(-(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01+(-(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))+(-(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
exp_K = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*(1.0+(((-2.3025850929940458e+02)-(modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))))*3.3333333333333333e-01))))))));
}
else
{
d_exp_K_dX = 1.0e100*(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*0.5*(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))*3.3333333333333333e-01+(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))*(1.0+(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01)))+(modelStruct.modelVar_phitdinv*(((-instanceStruct.instanceVar_VAK*d_nj_K_dX/nj_K/nj_K)-((nj_K*(modelStruct.d_modelVar_V_HK_dX-modelStruct.d_modelVar_V_HA_dX)-(modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)*d_nj_K_dX)/nj_K/nj_K))+(((modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)*(modelStruct.modelVar_V_HK*(d_nj_K_dX-modelStruct.d_modelVar_NJL_dX)+modelStruct.d_modelVar_V_HK_dX*(nj_K-modelStruct.modelVar_NJL))-(modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))*(modelStruct.modelVar_NJL*modelStruct.d_modelPar_NJH_dX+modelStruct.d_modelVar_NJL_dX*modelStruct.modelPar_NJH))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH)))+modelStruct.d_modelVar_phitdinv_dX*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
exp_K = (1.0e100*(1.0+(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(0.5*(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*(1.0+(((modelStruct.modelVar_phitdinv*(((instanceStruct.instanceVar_VAK/nj_K)-((modelStruct.modelVar_V_HK-modelStruct.modelVar_V_HA)/nj_K))+((modelStruct.modelVar_V_HK*(nj_K-modelStruct.modelVar_NJL))/(modelStruct.modelVar_NJL*modelStruct.modelPar_NJH))))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
}
else
{
d_exp_K_dX = 0.0;
exp_K = 1;
}
if (((modelStruct.modelPar_INJ2==0)||(instanceStruct.instanceVar_VAK<modelStruct.modelVar_V_HA)))
{
d_exp_A2_dX = (exp_A*modelStruct.d_modelPar_INJ1_dX+d_exp_A_dX*modelStruct.modelPar_INJ1);
exp_A2 = (exp_A*modelStruct.modelPar_INJ1);
}
else
{
{
double value_log_0 = log((modelStruct.modelVar_tkr/modelStruct.modelVar_tkd));
double value_exp_1 = exp((modelStruct.modelPar_INJT*value_log_0));
double value_exp_2 = exp(((((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*value_exp_1));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_tkr/modelStruct.modelVar_tkd));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_exp_2_d0 = value_exp_2;
d_exp_A2_dX = ((exp_A*modelStruct.modelPar_INJ1)*deriv_exp_2_d0*(((((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*deriv_exp_1_d0*((modelStruct.modelPar_INJT*deriv_log_0_d0*(((modelStruct.modelVar_tkd*modelStruct.d_modelVar_tkr_dX-modelStruct.modelVar_tkr*modelStruct.d_modelVar_tkd_dX)/modelStruct.modelVar_tkd/modelStruct.modelVar_tkd))+modelStruct.d_modelPar_INJT_dX*value_log_0))+(((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*(-modelStruct.d_modelVar_V_HA_dX)+((-modelStruct.modelPar_INJ2)*(-modelStruct.d_modelVar_V_HA_dX)+(-modelStruct.d_modelPar_INJ2_dX)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HA))*value_exp_1))+(exp_A*modelStruct.d_modelPar_INJ1_dX+d_exp_A_dX*modelStruct.modelPar_INJ1)*value_exp_2);
exp_A2 = ((exp_A*modelStruct.modelPar_INJ1)*value_exp_2);
}
}
d_exp_A2_dX = ((exp_A2>1e20)?0.0:d_exp_A2_dX);
exp_A2 = ((exp_A2>1e20)?1e20:exp_A2);
d_p_nA_dX = (modelStruct.modelVar_Pn0*d_exp_A2_dX+modelStruct.d_modelVar_Pn0_dX*exp_A2);
p_nA = (modelStruct.modelVar_Pn0*exp_A2);
d_q_pexA_dX = ((1.6021918E-19*instanceStruct.instanceVar_AB_i)*(d_p_nA_dX-modelStruct.d_modelVar_Pn0_dX)+1.6021918E-19*instanceStruct.d_instanceVar_AB_i_dX*(p_nA-modelStruct.modelVar_Pn0));
q_pexA = ((1.6021918E-19*instanceStruct.instanceVar_AB_i)*(p_nA-modelStruct.modelVar_Pn0));
if ((modelStruct.modelPar_NQS>0.0))
{
d_Q_qs_A_dX = (q_pexA*modelStruct.d_modelPar_NQS_dX+d_q_pexA_dX*modelStruct.modelPar_NQS);
Q_qs_A = (q_pexA*modelStruct.modelPar_NQS);
instanceStruct.d_instanceVar_Q_nqs_A_dX = modelStruct.d_modelPar_NQS_dX*(probeVars[admsProbeID_V_charge_A_GND]);
instanceStruct.instanceVar_Q_nqs_A = (modelStruct.modelPar_NQS*(probeVars[admsProbeID_V_charge_A_GND]));
instanceStruct.d_instanceVar_Inqs0_A_dX = ((modelStruct.modelPar_NQS*(instanceStruct.d_instanceVar_Q_nqs_A_dX-d_Q_qs_A_dX)-(instanceStruct.instanceVar_Q_nqs_A-Q_qs_A)*modelStruct.d_modelPar_NQS_dX)/modelStruct.modelPar_NQS/modelStruct.modelPar_NQS);
instanceStruct.instanceVar_Inqs0_A = ((instanceStruct.instanceVar_Q_nqs_A-Q_qs_A)/modelStruct.modelPar_NQS);
d_q_pexA_nqs_dX = ((modelStruct.modelPar_NQS*instanceStruct.d_instanceVar_Q_nqs_A_dX-instanceStruct.instanceVar_Q_nqs_A*modelStruct.d_modelPar_NQS_dX)/modelStruct.modelPar_NQS/modelStruct.modelPar_NQS);
q_pexA_nqs = (instanceStruct.instanceVar_Q_nqs_A/modelStruct.modelPar_NQS);
}
else
{
d_Q_qs_A_dX = d_q_pexA_dX;
Q_qs_A = q_pexA;
d_q_pexA_nqs_dX = d_Q_qs_A_dX;
q_pexA_nqs = Q_qs_A;
}
if (((modelStruct.modelPar_INJ2==0)||(instanceStruct.instanceVar_VAK<modelStruct.modelVar_V_HK)))
{
d_exp_K2_dX = (exp_K*modelStruct.d_modelPar_INJ1_dX+d_exp_K_dX*modelStruct.modelPar_INJ1);
exp_K2 = (exp_K*modelStruct.modelPar_INJ1);
}
else
{
{
double value_log_0 = log((modelStruct.modelVar_tkr/modelStruct.modelVar_tkd));
double value_exp_1 = exp((modelStruct.modelPar_INJT*value_log_0));
double value_exp_2 = exp(((((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*value_exp_1));
double  deriv_log_0_d0 = (1.0/(modelStruct.modelVar_tkr/modelStruct.modelVar_tkd));
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_exp_2_d0 = value_exp_2;
d_exp_K2_dX = ((exp_K*modelStruct.modelPar_INJ1)*deriv_exp_2_d0*(((((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*deriv_exp_1_d0*((modelStruct.modelPar_INJT*deriv_log_0_d0*(((modelStruct.modelVar_tkd*modelStruct.d_modelVar_tkr_dX-modelStruct.modelVar_tkr*modelStruct.d_modelVar_tkd_dX)/modelStruct.modelVar_tkd/modelStruct.modelVar_tkd))+modelStruct.d_modelPar_INJT_dX*value_log_0))+(((-modelStruct.modelPar_INJ2)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*(-modelStruct.d_modelVar_V_HK_dX)+((-modelStruct.modelPar_INJ2)*(-modelStruct.d_modelVar_V_HK_dX)+(-modelStruct.d_modelPar_INJ2_dX)*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*(instanceStruct.instanceVar_VAK-modelStruct.modelVar_V_HK))*value_exp_1))+(exp_K*modelStruct.d_modelPar_INJ1_dX+d_exp_K_dX*modelStruct.modelPar_INJ1)*value_exp_2);
exp_K2 = ((exp_K*modelStruct.modelPar_INJ1)*value_exp_2);
}
}
d_exp_K2_dX = ((exp_K2>1e20)?0.0:d_exp_K2_dX);
exp_K2 = ((exp_K2>1e20)?1e20:exp_K2);
d_p_nK_dX = (modelStruct.modelVar_Pn0*d_exp_K2_dX+modelStruct.d_modelVar_Pn0_dX*exp_K2);
p_nK = (modelStruct.modelVar_Pn0*exp_K2);
d_q_pexK_dX = ((1.6021918E-19*instanceStruct.instanceVar_AB_i)*(d_p_nK_dX-modelStruct.d_modelVar_Pn0_dX)+1.6021918E-19*instanceStruct.d_instanceVar_AB_i_dX*(p_nK-modelStruct.modelVar_Pn0));
q_pexK = ((1.6021918E-19*instanceStruct.instanceVar_AB_i)*(p_nK-modelStruct.modelVar_Pn0));
if ((modelStruct.modelPar_NQS>0.0))
{
d_Q_qs_K_dX = (q_pexK*modelStruct.d_modelPar_NQS_dX+d_q_pexK_dX*modelStruct.modelPar_NQS);
Q_qs_K = (q_pexK*modelStruct.modelPar_NQS);
instanceStruct.d_instanceVar_Q_nqs_K_dX = modelStruct.d_modelPar_NQS_dX*(probeVars[admsProbeID_V_charge_K_GND]);
instanceStruct.instanceVar_Q_nqs_K = (modelStruct.modelPar_NQS*(probeVars[admsProbeID_V_charge_K_GND]));
instanceStruct.d_instanceVar_Inqs0_K_dX = ((modelStruct.modelPar_NQS*(instanceStruct.d_instanceVar_Q_nqs_K_dX-d_Q_qs_K_dX)-(instanceStruct.instanceVar_Q_nqs_K-Q_qs_K)*modelStruct.d_modelPar_NQS_dX)/modelStruct.modelPar_NQS/modelStruct.modelPar_NQS);
instanceStruct.instanceVar_Inqs0_K = ((instanceStruct.instanceVar_Q_nqs_K-Q_qs_K)/modelStruct.modelPar_NQS);
d_q_pexK_nqs_dX = ((modelStruct.modelPar_NQS*instanceStruct.d_instanceVar_Q_nqs_K_dX-instanceStruct.instanceVar_Q_nqs_K*modelStruct.d_modelPar_NQS_dX)/modelStruct.modelPar_NQS/modelStruct.modelPar_NQS);
q_pexK_nqs = (instanceStruct.instanceVar_Q_nqs_K/modelStruct.modelPar_NQS);
}
else
{
d_Q_qs_K_dX = d_q_pexK_dX;
Q_qs_K = q_pexK;
d_q_pexK_nqs_dX = d_Q_qs_K_dX;
q_pexK_nqs = Q_qs_K;
}
d_Vjunc_A_dX = 0.0;
Vjunc_A = (modelStruct.modelVar_PB-instanceStruct.instanceVar_VAK);
{
{
double value_sqrt_0 = sqrt(((Vjunc_A*Vjunc_A)+((4.0*modelStruct.modelVar_JUNCDLT)*modelStruct.modelVar_JUNCDLT)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*((Vjunc_A*d_Vjunc_A_dX+d_Vjunc_A_dX*Vjunc_A));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
d_Vjunc_A_dX = 0.5*(d_Vjunc_A_dX+instanceStruct.d_instanceVar_TMF2_dX);
Vjunc_A = (0.5*(Vjunc_A+instanceStruct.instanceVar_TMF2));
if ((Vjunc_A<0.0))
{
d_Vjunc_A_dX = 0.0;
Vjunc_A = 0.0;
}
}
{
double value_sqrt_0 = sqrt((((2*1.034943e-10)*Vjunc_A)/(1.6021918E-19*modelStruct.modelVar_NDI_i)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_W_depA_dX = deriv_sqrt_0_d0*((((1.6021918E-19*modelStruct.modelVar_NDI_i)*(2*1.034943e-10)*d_Vjunc_A_dX-((2*1.034943e-10)*Vjunc_A)*1.6021918E-19*modelStruct.d_modelVar_NDI_i_dX)/(1.6021918E-19*modelStruct.modelVar_NDI_i)/(1.6021918E-19*modelStruct.modelVar_NDI_i)));
W_depA = value_sqrt_0;
}
{
instanceStruct.d_instanceVar_TMF1_dX = (modelStruct.d_modelPar_WI_dX-d_W_depA_dX);
instanceStruct.instanceVar_TMF1 = ((modelStruct.modelPar_WI-W_depA)-1.0e-7);
instanceStruct.d_instanceVar_TMF2_dX = 4.0*modelStruct.d_modelPar_WI_dX*1.0e-7;
instanceStruct.instanceVar_TMF2 = ((4.0*modelStruct.modelPar_WI)*1.0e-7);
instanceStruct.d_instanceVar_TMF2_dX = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.d_instanceVar_TMF2_dX:(-instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = ((instanceStruct.instanceVar_TMF2>0.0)?instanceStruct.instanceVar_TMF2:(-instanceStruct.instanceVar_TMF2));
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_TMF1*instanceStruct.instanceVar_TMF1)+instanceStruct.instanceVar_TMF2));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_TMF2_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_TMF1*instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF1_dX*instanceStruct.instanceVar_TMF1)+instanceStruct.d_instanceVar_TMF2_dX));
instanceStruct.instanceVar_TMF2 = value_sqrt_0;
}
d_W_depA_dX = (modelStruct.d_modelPar_WI_dX-0.5*(instanceStruct.d_instanceVar_TMF1_dX+instanceStruct.d_instanceVar_TMF2_dX));
W_depA = (modelStruct.modelPar_WI-(0.5*(instanceStruct.instanceVar_TMF1+instanceStruct.instanceVar_TMF2)));
}
if ((modelStruct.modelPar_DEPNQS>0.0))
{
d_W_qs_A_dX = (W_depA*modelStruct.d_modelPar_DEPNQS_dX+d_W_depA_dX*modelStruct.modelPar_DEPNQS);
W_qs_A = (W_depA*modelStruct.modelPar_DEPNQS);
instanceStruct.d_instanceVar_W_nqs_A_dX = modelStruct.d_modelPar_DEPNQS_dX*(probeVars[admsProbeID_V_depl_A_GND]);
instanceStruct.instanceVar_W_nqs_A = (modelStruct.modelPar_DEPNQS*(probeVars[admsProbeID_V_depl_A_GND]));
instanceStruct.d_instanceVar_IWnqs0_A_dX = ((modelStruct.modelPar_DEPNQS*(instanceStruct.d_instanceVar_W_nqs_A_dX-d_W_qs_A_dX)-(instanceStruct.instanceVar_W_nqs_A-W_qs_A)*modelStruct.d_modelPar_DEPNQS_dX)/modelStruct.modelPar_DEPNQS/modelStruct.modelPar_DEPNQS);
instanceStruct.instanceVar_IWnqs0_A = ((instanceStruct.instanceVar_W_nqs_A-W_qs_A)/modelStruct.modelPar_DEPNQS);
d_W_depA_nqs_dX = ((modelStruct.modelPar_DEPNQS*instanceStruct.d_instanceVar_W_nqs_A_dX-instanceStruct.instanceVar_W_nqs_A*modelStruct.d_modelPar_DEPNQS_dX)/modelStruct.modelPar_DEPNQS/modelStruct.modelPar_DEPNQS);
W_depA_nqs = (instanceStruct.instanceVar_W_nqs_A/modelStruct.modelPar_DEPNQS);
}
else
{
d_W_qs_A_dX = d_W_depA_dX;
W_qs_A = W_depA;
d_W_depA_nqs_dX = d_W_qs_A_dX;
W_depA_nqs = W_qs_A;
}
d_Q_n0_dX = ((-((modelStruct.modelVar_NDI_i*instanceStruct.instanceVar_AB_i)*1.6021918E-19))*modelStruct.d_modelPar_WI_dX+(-(modelStruct.modelVar_NDI_i*instanceStruct.d_instanceVar_AB_i_dX+modelStruct.d_modelVar_NDI_i_dX*instanceStruct.instanceVar_AB_i)*1.6021918E-19)*modelStruct.modelPar_WI);
Q_n0 = ((-((modelStruct.modelVar_NDI_i*instanceStruct.instanceVar_AB_i)*1.6021918E-19))*modelStruct.modelPar_WI);
{
double value_exp_0 = exp(((-modelStruct.modelPar_WI)/modelStruct.modelVar_La));
double value_exp_1 = exp(((-W_depA_nqs)/modelStruct.modelVar_La));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_Q_nexA_nqs_dX = ((modelStruct.modelVar_La*q_pexA_nqs)*(deriv_exp_0_d0*(((modelStruct.modelVar_La*(-modelStruct.d_modelPar_WI_dX)-(-modelStruct.modelPar_WI)*modelStruct.d_modelVar_La_dX)/modelStruct.modelVar_La/modelStruct.modelVar_La))-deriv_exp_1_d0*(((modelStruct.modelVar_La*(-d_W_depA_nqs_dX)-(-W_depA_nqs)*modelStruct.d_modelVar_La_dX)/modelStruct.modelVar_La/modelStruct.modelVar_La)))+(modelStruct.modelVar_La*d_q_pexA_nqs_dX+modelStruct.d_modelVar_La_dX*q_pexA_nqs)*(value_exp_0-value_exp_1));
Q_nexA_nqs = ((modelStruct.modelVar_La*q_pexA_nqs)*(value_exp_0-value_exp_1));
}
{
double value_exp_0 = exp(((-(modelStruct.modelPar_WI-W_depA_nqs))/modelStruct.modelVar_La));
double  deriv_exp_0_d0 = value_exp_0;
d_Q_nexK_nqs_dX = ((modelStruct.modelVar_La*q_pexK_nqs)*deriv_exp_0_d0*(((modelStruct.modelVar_La*(-(modelStruct.d_modelPar_WI_dX-d_W_depA_nqs_dX))-(-(modelStruct.modelPar_WI-W_depA_nqs))*modelStruct.d_modelVar_La_dX)/modelStruct.modelVar_La/modelStruct.modelVar_La))+(modelStruct.modelVar_La*d_q_pexK_nqs_dX+modelStruct.d_modelVar_La_dX*q_pexK_nqs)*(value_exp_0-1.0));
Q_nexK_nqs = ((modelStruct.modelVar_La*q_pexK_nqs)*(value_exp_0-1.0));
}
d_Qrr_dX = (-((d_Q_n0_dX+d_Q_nexA_nqs_dX)+d_Q_nexK_nqs_dX));
Qrr = (-((Q_n0+Q_nexA_nqs)+Q_nexK_nqs));
d_qjun_dX = (d_qjun_dX+d_Qrr_dX);
qjun = (qjun+Qrr);
modelStruct.d_modelVar_TT_i_dX = 0.0;
modelStruct.modelVar_TT_i = 0.0;
}
else
{
d_Qrr_dX = (modelStruct.modelVar_TT_i*(instanceStruct.d_instanceVar_ijun_dX-instanceStruct.d_instanceVar_ijnon_dX)+modelStruct.d_modelVar_TT_i_dX*(instanceStruct.instanceVar_ijun-instanceStruct.instanceVar_ijnon));
Qrr = (modelStruct.modelVar_TT_i*(instanceStruct.instanceVar_ijun-instanceStruct.instanceVar_ijnon));
}
}
// End block evaluateRecoveryCharge
//Begin block loadStatic
{
// I(A,AIK) <+ (((TYPE*MULT_i)*ijun))
d_staticContributions_dX[admsNodeID_A]+= ((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*instanceStruct.d_instanceVar_ijun_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*instanceStruct.instanceVar_ijun);
d_staticContributions_dX[(admsNodeID_AIK)]-= ((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*instanceStruct.d_instanceVar_ijun_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*instanceStruct.instanceVar_ijun);
if ((instanceStruct.instanceVar_rnode==1))
{
// I(AIK,K) <+ (((MULT_i*VRS)*conducts))
d_staticContributions_dX[admsNodeID_AIK]+= ((instanceStruct.instanceVar_MULT_i*VRS)*instanceStruct.d_instanceVar_conducts_dX+instanceStruct.d_instanceVar_MULT_i_dX*VRS*instanceStruct.instanceVar_conducts);
d_staticContributions_dX[(admsNodeID_K)]-= ((instanceStruct.instanceVar_MULT_i*VRS)*instanceStruct.d_instanceVar_conducts_dX+instanceStruct.d_instanceVar_MULT_i_dX*VRS*instanceStruct.instanceVar_conducts);
}
else
{
// V(AIK,K) <+ (0)
// do nothing at all
}
}
// End block loadStatic
//Begin block loadRecovery
{
if (((modelStruct.modelPar_CORECOVERY>0)&&(modelStruct.modelPar_NQS>0.0)))
{
// I(charge_A,GND) <+ ((Inqs0_A+ddt(Q_nqs_A)))
d_dynamicContributions_dX[admsNodeID_charge_A]+= (instanceStruct.d_instanceVar_Inqs0_A_dX+(instanceStruct.d_instanceVar_Q_nqs_A_dX));
// I(charge_K,GND) <+ ((Inqs0_K+ddt(Q_nqs_K)))
d_dynamicContributions_dX[admsNodeID_charge_K]+= (instanceStruct.d_instanceVar_Inqs0_K_dX+(instanceStruct.d_instanceVar_Q_nqs_K_dX));
}
else
{
// V(charge_A,GND) <+ (0.0)
// do nothing at all
// V(charge_K,GND) <+ (0.0)
// do nothing at all
}
if (((modelStruct.modelPar_CORECOVERY>0)&&(modelStruct.modelPar_DEPNQS>0.0)))
{
// I(depl_A,GND) <+ ((IWnqs0_A+ddt(W_nqs_A)))
d_dynamicContributions_dX[admsNodeID_depl_A]+= (instanceStruct.d_instanceVar_IWnqs0_A_dX+(instanceStruct.d_instanceVar_W_nqs_A_dX));
}
else
{
// V(depl_A,GND) <+ (0.0)
// do nothing at all
}
}
// End block loadRecovery
//Begin block loadDynamic
{
// I(A,AIK) <+ (ddt(((TYPE*MULT_i)*qjun)))
d_dynamicContributions_dX[admsNodeID_A]+= (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*qjun));
d_dynamicContributions_dX[(admsNodeID_AIK)]-= (((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*qjun));
// I(A,AIK) <+ (ddt((((TYPE*MULT_i)*TT_i)*(ijun-ijnon))))
d_dynamicContributions_dX[admsNodeID_A]+= ((((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*modelStruct.modelVar_TT_i)*(instanceStruct.d_instanceVar_ijun_dX-instanceStruct.d_instanceVar_ijnon_dX)+((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*modelStruct.d_modelVar_TT_i_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*modelStruct.modelVar_TT_i)*(instanceStruct.instanceVar_ijun-instanceStruct.instanceVar_ijnon)));
d_dynamicContributions_dX[(admsNodeID_AIK)]-= ((((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*modelStruct.modelVar_TT_i)*(instanceStruct.d_instanceVar_ijun_dX-instanceStruct.d_instanceVar_ijnon_dX)+((modelStruct.modelPar_TYPE*instanceStruct.instanceVar_MULT_i)*modelStruct.d_modelVar_TT_i_dX+(modelStruct.modelPar_TYPE*instanceStruct.d_instanceVar_MULT_i_dX+modelStruct.d_modelPar_TYPE_dX*instanceStruct.instanceVar_MULT_i)*modelStruct.modelVar_TT_i)*(instanceStruct.instanceVar_ijun-instanceStruct.instanceVar_ijnon)));
}
// End block loadDynamic
//Begin block OPinfo
{
instanceStruct.d_instanceVar_DQAbot_dX = 0.0;
instanceStruct.instanceVar_DQAbot = 0.0 /*FIXME: ddx(qjunbot,V(A,GND)) not implemented in sensitivity context */;
instanceStruct.d_instanceVar_DQAgat_dX = 0.0;
instanceStruct.instanceVar_DQAgat = 0.0 /*FIXME: ddx(qjungat,V(A,GND)) not implemented in sensitivity context */;
instanceStruct.d_instanceVar_DQAsti_dX = 0.0;
instanceStruct.instanceVar_DQAsti = 0.0 /*FIXME: ddx(qjunsti,V(A,GND)) not implemented in sensitivity context */;
if ((modelStruct.modelVar_SWJUNEXP_i==1.0))
{
}
else
{
}
if ((instanceStruct.instanceVar_rnode==1))
{
}
else
{
}
}
// End block OPinfo
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(6+0);
dqdp.resize(6+0);
Findices.resize(6+0);
Qindices.resize(6+0);

std::vector <double> probeVars(7);
std::vector <double> d_staticContributions_dX(6+0);
std::vector <double> d_dynamicContributions_dX(6+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 6+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_VERSION=mod.VERSION;
modelStruct.d_modelPar_VERSION_dX=0.0;
modelStruct.modelPar_given_VERSION=mod.given("VERSION");
modelStruct.modelPar_SUBVERSION=mod.SUBVERSION;
modelStruct.d_modelPar_SUBVERSION_dX=0.0;
modelStruct.modelPar_given_SUBVERSION=mod.given("SUBVERSION");
modelStruct.modelPar_REVISION=mod.REVISION;
modelStruct.d_modelPar_REVISION_dX=0.0;
modelStruct.modelPar_given_REVISION=mod.given("REVISION");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.d_modelPar_TYPE_dX=0.0;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modelStruct.modelPar_FREV=mod.FREV;
modelStruct.d_modelPar_FREV_dX=0.0;
modelStruct.modelPar_given_FREV=mod.given("FREV");
modelStruct.modelPar_RSBOT=mod.RSBOT;
modelStruct.d_modelPar_RSBOT_dX=0.0;
modelStruct.modelPar_given_RSBOT=mod.given("RSBOT");
modelStruct.modelPar_RSSTI=mod.RSSTI;
modelStruct.d_modelPar_RSSTI_dX=0.0;
modelStruct.modelPar_given_RSSTI=mod.given("RSSTI");
modelStruct.modelPar_RSGAT=mod.RSGAT;
modelStruct.d_modelPar_RSGAT_dX=0.0;
modelStruct.modelPar_given_RSGAT=mod.given("RSGAT");
modelStruct.modelPar_RSCOM=mod.RSCOM;
modelStruct.d_modelPar_RSCOM_dX=0.0;
modelStruct.modelPar_given_RSCOM=mod.given("RSCOM");
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modelStruct.modelPar_KF=mod.KF;
modelStruct.d_modelPar_KF_dX=0.0;
modelStruct.modelPar_given_KF=mod.given("KF");
modelStruct.modelPar_AF=mod.AF;
modelStruct.d_modelPar_AF_dX=0.0;
modelStruct.modelPar_given_AF=mod.given("AF");
modelStruct.modelPar_TT=mod.TT;
modelStruct.d_modelPar_TT_dX=0.0;
modelStruct.modelPar_given_TT=mod.given("TT");
modelStruct.modelPar_STVBRBOT1=mod.STVBRBOT1;
modelStruct.d_modelPar_STVBRBOT1_dX=0.0;
modelStruct.modelPar_given_STVBRBOT1=mod.given("STVBRBOT1");
modelStruct.modelPar_STVBRBOT2=mod.STVBRBOT2;
modelStruct.d_modelPar_STVBRBOT2_dX=0.0;
modelStruct.modelPar_given_STVBRBOT2=mod.given("STVBRBOT2");
modelStruct.modelPar_STVBRSTI1=mod.STVBRSTI1;
modelStruct.d_modelPar_STVBRSTI1_dX=0.0;
modelStruct.modelPar_given_STVBRSTI1=mod.given("STVBRSTI1");
modelStruct.modelPar_STVBRSTI2=mod.STVBRSTI2;
modelStruct.d_modelPar_STVBRSTI2_dX=0.0;
modelStruct.modelPar_given_STVBRSTI2=mod.given("STVBRSTI2");
modelStruct.modelPar_STVBRGAT1=mod.STVBRGAT1;
modelStruct.d_modelPar_STVBRGAT1_dX=0.0;
modelStruct.modelPar_given_STVBRGAT1=mod.given("STVBRGAT1");
modelStruct.modelPar_STVBRGAT2=mod.STVBRGAT2;
modelStruct.d_modelPar_STVBRGAT2_dX=0.0;
modelStruct.modelPar_given_STVBRGAT2=mod.given("STVBRGAT2");
modelStruct.modelPar_NFABOT=mod.NFABOT;
modelStruct.d_modelPar_NFABOT_dX=0.0;
modelStruct.modelPar_given_NFABOT=mod.given("NFABOT");
modelStruct.modelPar_NFASTI=mod.NFASTI;
modelStruct.d_modelPar_NFASTI_dX=0.0;
modelStruct.modelPar_given_NFASTI=mod.given("NFASTI");
modelStruct.modelPar_NFAGAT=mod.NFAGAT;
modelStruct.d_modelPar_NFAGAT_dX=0.0;
modelStruct.modelPar_given_NFAGAT=mod.given("NFAGAT");
modelStruct.modelPar_ABMIN=mod.ABMIN;
modelStruct.d_modelPar_ABMIN_dX=0.0;
modelStruct.modelPar_given_ABMIN=mod.given("ABMIN");
modelStruct.modelPar_ABMAX=mod.ABMAX;
modelStruct.d_modelPar_ABMAX_dX=0.0;
modelStruct.modelPar_given_ABMAX=mod.given("ABMAX");
modelStruct.modelPar_LSMIN=mod.LSMIN;
modelStruct.d_modelPar_LSMIN_dX=0.0;
modelStruct.modelPar_given_LSMIN=mod.given("LSMIN");
modelStruct.modelPar_LSMAX=mod.LSMAX;
modelStruct.d_modelPar_LSMAX_dX=0.0;
modelStruct.modelPar_given_LSMAX=mod.given("LSMAX");
modelStruct.modelPar_LGMIN=mod.LGMIN;
modelStruct.d_modelPar_LGMIN_dX=0.0;
modelStruct.modelPar_given_LGMIN=mod.given("LGMIN");
modelStruct.modelPar_LGMAX=mod.LGMAX;
modelStruct.d_modelPar_LGMAX_dX=0.0;
modelStruct.modelPar_given_LGMAX=mod.given("LGMAX");
modelStruct.modelPar_TEMPMIN=mod.TEMPMIN;
modelStruct.d_modelPar_TEMPMIN_dX=0.0;
modelStruct.modelPar_given_TEMPMIN=mod.given("TEMPMIN");
modelStruct.modelPar_TEMPMAX=mod.TEMPMAX;
modelStruct.d_modelPar_TEMPMAX_dX=0.0;
modelStruct.modelPar_given_TEMPMAX=mod.given("TEMPMAX");
modelStruct.modelPar_VFMAX=mod.VFMAX;
modelStruct.d_modelPar_VFMAX_dX=0.0;
modelStruct.modelPar_given_VFMAX=mod.given("VFMAX");
modelStruct.modelPar_VRMAX=mod.VRMAX;
modelStruct.d_modelPar_VRMAX_dX=0.0;
modelStruct.modelPar_given_VRMAX=mod.given("VRMAX");
modelStruct.modelPar_XTI=mod.XTI;
modelStruct.d_modelPar_XTI_dX=0.0;
modelStruct.modelPar_given_XTI=mod.given("XTI");
modelStruct.modelPar_SCALE=mod.SCALE;
modelStruct.d_modelPar_SCALE_dX=0.0;
modelStruct.modelPar_given_SCALE=mod.given("SCALE");
modelStruct.modelPar_SHRINK=mod.SHRINK;
modelStruct.d_modelPar_SHRINK_dX=0.0;
modelStruct.modelPar_given_SHRINK=mod.given("SHRINK");
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modelStruct.modelPar_CORECOVERY=mod.CORECOVERY;
modelStruct.d_modelPar_CORECOVERY_dX=0.0;
modelStruct.modelPar_given_CORECOVERY=mod.given("CORECOVERY");
modelStruct.modelPar_NJH=mod.NJH;
modelStruct.d_modelPar_NJH_dX=0.0;
modelStruct.modelPar_given_NJH=mod.given("NJH");
modelStruct.modelPar_NJDV=mod.NJDV;
modelStruct.d_modelPar_NJDV_dX=0.0;
modelStruct.modelPar_given_NJDV=mod.given("NJDV");
modelStruct.modelPar_NDIBOT=mod.NDIBOT;
modelStruct.d_modelPar_NDIBOT_dX=0.0;
modelStruct.modelPar_given_NDIBOT=mod.given("NDIBOT");
modelStruct.modelPar_NDIGAT=mod.NDIGAT;
modelStruct.d_modelPar_NDIGAT_dX=0.0;
modelStruct.modelPar_given_NDIGAT=mod.given("NDIGAT");
modelStruct.modelPar_NDISTI=mod.NDISTI;
modelStruct.d_modelPar_NDISTI_dX=0.0;
modelStruct.modelPar_given_NDISTI=mod.given("NDISTI");
modelStruct.modelPar_INJ1=mod.INJ1;
modelStruct.d_modelPar_INJ1_dX=0.0;
modelStruct.modelPar_given_INJ1=mod.given("INJ1");
modelStruct.modelPar_INJ2=mod.INJ2;
modelStruct.d_modelPar_INJ2_dX=0.0;
modelStruct.modelPar_given_INJ2=mod.given("INJ2");
modelStruct.modelPar_NQS=mod.NQS;
modelStruct.d_modelPar_NQS_dX=0.0;
modelStruct.modelPar_given_NQS=mod.given("NQS");
modelStruct.modelPar_TAU=mod.TAU;
modelStruct.d_modelPar_TAU_dX=0.0;
modelStruct.modelPar_given_TAU=mod.given("TAU");
modelStruct.modelPar_WI=mod.WI;
modelStruct.d_modelPar_WI_dX=0.0;
modelStruct.modelPar_given_WI=mod.given("WI");
modelStruct.modelPar_DEPNQS=mod.DEPNQS;
modelStruct.d_modelPar_DEPNQS_dX=0.0;
modelStruct.modelPar_given_DEPNQS=mod.given("DEPNQS");
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modelStruct.modelPar_TAUT=mod.TAUT;
modelStruct.d_modelPar_TAUT_dX=0.0;
modelStruct.modelPar_given_TAUT=mod.given("TAUT");
modelStruct.modelPar_INJT=mod.INJT;
modelStruct.d_modelPar_INJT_dX=0.0;
modelStruct.modelPar_given_INJT=mod.given("INJT");


// hidden reals


// non-reals (including hiddens)



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_AB=in.AB;
instanceStruct.d_instancePar_AB_dX=0.0;
instanceStruct.instancePar_given_AB=in.given("AB");
inParamMap["AB"] = &(instanceStruct.d_instancePar_AB_dX);
instanceStruct.instancePar_LS=in.LS;
instanceStruct.d_instancePar_LS_dX=0.0;
instanceStruct.instancePar_given_LS=in.given("LS");
inParamMap["LS"] = &(instanceStruct.d_instancePar_LS_dX);
instanceStruct.instancePar_LG=in.LG;
instanceStruct.d_instancePar_LG_dX=0.0;
instanceStruct.instancePar_given_LG=in.given("LG");
inParamMap["LG"] = &(instanceStruct.d_instancePar_LG_dX);
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");
inParamMap["MULT"] = &(instanceStruct.d_instancePar_MULT_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_tmpv=in.tmpv;
instanceStruct.d_instanceVar_tmpv_dX=0.0;
instanceStruct.instanceVar_vjv=in.vjv;
instanceStruct.d_instanceVar_vjv_dX=0.0;
instanceStruct.instanceVar_AB_i=in.AB_i;
instanceStruct.d_instanceVar_AB_i_dX=0.0;
instanceStruct.instanceVar_LS_i=in.LS_i;
instanceStruct.d_instanceVar_LS_i_dX=0.0;
instanceStruct.instanceVar_LG_i=in.LG_i;
instanceStruct.d_instanceVar_LG_i_dX=0.0;
instanceStruct.instanceVar_zflagbot=in.zflagbot;
instanceStruct.instanceVar_zflagsti=in.zflagsti;
instanceStruct.instanceVar_zflaggat=in.zflaggat;
instanceStruct.instanceVar_VMAX=in.VMAX;
instanceStruct.d_instanceVar_VMAX_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd=in.exp_VMAX_over_phitd;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX=0.0;
instanceStruct.instanceVar_vbimin=in.vbimin;
instanceStruct.d_instanceVar_vbimin_dX=0.0;
instanceStruct.instanceVar_vch=in.vch;
instanceStruct.d_instanceVar_vch_dX=0.0;
instanceStruct.instanceVar_vfmin=in.vfmin;
instanceStruct.d_instanceVar_vfmin_dX=0.0;
instanceStruct.instanceVar_vbbtlim=in.vbbtlim;
instanceStruct.d_instanceVar_vbbtlim_dX=0.0;
instanceStruct.instanceVar_ijunbot=in.ijunbot;
instanceStruct.d_instanceVar_ijunbot_dX=0.0;
instanceStruct.instanceVar_qjunbot=in.qjunbot;
instanceStruct.d_instanceVar_qjunbot_dX=0.0;
instanceStruct.instanceVar_ijunsti=in.ijunsti;
instanceStruct.d_instanceVar_ijunsti_dX=0.0;
instanceStruct.instanceVar_qjunsti=in.qjunsti;
instanceStruct.d_instanceVar_qjunsti_dX=0.0;
instanceStruct.instanceVar_ijungat=in.ijungat;
instanceStruct.d_instanceVar_ijungat_dX=0.0;
instanceStruct.instanceVar_qjungat=in.qjungat;
instanceStruct.d_instanceVar_qjungat_dX=0.0;
instanceStruct.instanceVar_ijun=in.ijun;
instanceStruct.d_instanceVar_ijun_dX=0.0;
instanceStruct.instanceVar_jnoise=in.jnoise;
instanceStruct.d_instanceVar_jnoise_dX=0.0;
instanceStruct.instanceVar_VAK=in.VAK;
instanceStruct.instanceVar_DQAbot=in.DQAbot;
instanceStruct.d_instanceVar_DQAbot_dX=0.0;
instanceStruct.instanceVar_DQAsti=in.DQAsti;
instanceStruct.d_instanceVar_DQAsti_dX=0.0;
instanceStruct.instanceVar_DQAgat=in.DQAgat;
instanceStruct.d_instanceVar_DQAgat_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot=in.exp_VMAX_over_phitd_bot;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti=in.exp_VMAX_over_phitd_sti;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat=in.exp_VMAX_over_phitd_gat;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX=0.0;
instanceStruct.instanceVar_conducts=in.conducts;
instanceStruct.d_instanceVar_conducts_dX=0.0;
instanceStruct.instanceVar_jfnoise=in.jfnoise;
instanceStruct.d_instanceVar_jfnoise_dX=0.0;
instanceStruct.instanceVar_jtnoise=in.jtnoise;
instanceStruct.d_instanceVar_jtnoise_dX=0.0;
instanceStruct.instanceVar_isattotal=in.isattotal;
instanceStruct.d_instanceVar_isattotal_dX=0.0;
instanceStruct.instanceVar_ijnon=in.ijnon;
instanceStruct.d_instanceVar_ijnon_dX=0.0;
instanceStruct.instanceVar_ijnonbot=in.ijnonbot;
instanceStruct.d_instanceVar_ijnonbot_dX=0.0;
instanceStruct.instanceVar_ijnonsti=in.ijnonsti;
instanceStruct.d_instanceVar_ijnonsti_dX=0.0;
instanceStruct.instanceVar_ijnongat=in.ijnongat;
instanceStruct.d_instanceVar_ijnongat_dX=0.0;
instanceStruct.instanceVar_xhighf1=in.xhighf1;
instanceStruct.d_instanceVar_xhighf1_dX=0.0;
instanceStruct.instanceVar_expxhf1=in.expxhf1;
instanceStruct.d_instanceVar_expxhf1_dX=0.0;
instanceStruct.instanceVar_xhighf2=in.xhighf2;
instanceStruct.d_instanceVar_xhighf2_dX=0.0;
instanceStruct.instanceVar_expxhf2=in.expxhf2;
instanceStruct.d_instanceVar_expxhf2_dX=0.0;
instanceStruct.instanceVar_xhighr=in.xhighr;
instanceStruct.d_instanceVar_xhighr_dX=0.0;
instanceStruct.instanceVar_expxhr=in.expxhr;
instanceStruct.d_instanceVar_expxhr_dX=0.0;
instanceStruct.instanceVar_ISATFOR1=in.ISATFOR1;
instanceStruct.d_instanceVar_ISATFOR1_dX=0.0;
instanceStruct.instanceVar_MFOR1=in.MFOR1;
instanceStruct.d_instanceVar_MFOR1_dX=0.0;
instanceStruct.instanceVar_ISATFOR2=in.ISATFOR2;
instanceStruct.d_instanceVar_ISATFOR2_dX=0.0;
instanceStruct.instanceVar_MFOR2=in.MFOR2;
instanceStruct.d_instanceVar_MFOR2_dX=0.0;
instanceStruct.instanceVar_ISATREV=in.ISATREV;
instanceStruct.d_instanceVar_ISATREV_dX=0.0;
instanceStruct.instanceVar_MREV=in.MREV;
instanceStruct.d_instanceVar_MREV_dX=0.0;
instanceStruct.instanceVar_m0flag=in.m0flag;
instanceStruct.instanceVar_TMF1=in.TMF1;
instanceStruct.d_instanceVar_TMF1_dX=0.0;
instanceStruct.instanceVar_TMF2=in.TMF2;
instanceStruct.d_instanceVar_TMF2_dX=0.0;
instanceStruct.instanceVar_Q_nqs_A=in.Q_nqs_A;
instanceStruct.d_instanceVar_Q_nqs_A_dX=0.0;
instanceStruct.instanceVar_Q_nqs_K=in.Q_nqs_K;
instanceStruct.d_instanceVar_Q_nqs_K_dX=0.0;
instanceStruct.instanceVar_Inqs0_A=in.Inqs0_A;
instanceStruct.d_instanceVar_Inqs0_A_dX=0.0;
instanceStruct.instanceVar_Inqs0_K=in.Inqs0_K;
instanceStruct.d_instanceVar_Inqs0_K_dX=0.0;
instanceStruct.instanceVar_W_nqs_A=in.W_nqs_A;
instanceStruct.d_instanceVar_W_nqs_A_dX=0.0;
instanceStruct.instanceVar_IWnqs0_A=in.IWnqs0_A;
instanceStruct.d_instanceVar_IWnqs0_A_dX=0.0;
instanceStruct.instanceVar_nj1=in.nj1;
instanceStruct.d_instanceVar_nj1_dX=0.0;
instanceStruct.instanceVar_nja10=in.nja10;
instanceStruct.d_instanceVar_nja10_dX=0.0;
instanceStruct.instanceVar_nja11=in.nja11;
instanceStruct.d_instanceVar_nja11_dX=0.0;
instanceStruct.instanceVar_vha1=in.vha1;
instanceStruct.d_instanceVar_vha1_dX=0.0;
instanceStruct.instanceVar_pnn0=in.pnn0;
instanceStruct.d_instanceVar_pnn0_dX=0.0;
instanceStruct.instanceVar_dFn_SU=in.dFn_SU;
instanceStruct.d_instanceVar_dFn_SU_dX=0.0;
instanceStruct.instanceVar_dFn_SL=in.dFn_SL;
instanceStruct.d_instanceVar_dFn_SL_dX=0.0;
instanceStruct.instanceVar_dnj1_dV=in.dnj1_dV;
instanceStruct.d_instanceVar_dnj1_dV_dX=0.0;
instanceStruct.instanceVar_dVMAX_over_phitd_dV=in.dVMAX_over_phitd_dV;
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX=0.0;
instanceStruct.instanceVar_idmultbot=in.idmultbot;
instanceStruct.d_instanceVar_idmultbot_dX=0.0;
instanceStruct.instanceVar_idmultsti=in.idmultsti;
instanceStruct.d_instanceVar_idmultsti_dX=0.0;
instanceStruct.instanceVar_idmultgat=in.idmultgat;
instanceStruct.d_instanceVar_idmultgat_dX=0.0;


//non-reals
instanceStruct.instanceVar_rnode=in.rnode;


//make local copies of all model vars
//reals
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_KF_i=mod.KF_i;
modelStruct.d_modelVar_KF_i_dX=0.0;
modelStruct.modelVar_AF_i=mod.AF_i;
modelStruct.d_modelVar_AF_i_dX=0.0;
modelStruct.modelVar_TT_i=mod.TT_i;
modelStruct.d_modelVar_TT_i_dX=0.0;
modelStruct.modelVar_NFABOT_i=mod.NFABOT_i;
modelStruct.d_modelVar_NFABOT_i_dX=0.0;
modelStruct.modelVar_NFAGAT_i=mod.NFAGAT_i;
modelStruct.d_modelVar_NFAGAT_i_dX=0.0;
modelStruct.modelVar_NFASTI_i=mod.NFASTI_i;
modelStruct.d_modelVar_NFASTI_i_dX=0.0;
modelStruct.modelVar_ABMIN_i=mod.ABMIN_i;
modelStruct.d_modelVar_ABMIN_i_dX=0.0;
modelStruct.modelVar_ABMAX_i=mod.ABMAX_i;
modelStruct.d_modelVar_ABMAX_i_dX=0.0;
modelStruct.modelVar_LGMAX_i=mod.LGMAX_i;
modelStruct.d_modelVar_LGMAX_i_dX=0.0;
modelStruct.modelVar_LGMIN_i=mod.LGMIN_i;
modelStruct.d_modelVar_LGMIN_i_dX=0.0;
modelStruct.modelVar_LSMAX_i=mod.LSMAX_i;
modelStruct.d_modelVar_LSMAX_i_dX=0.0;
modelStruct.modelVar_LSMIN_i=mod.LSMIN_i;
modelStruct.d_modelVar_LSMIN_i_dX=0.0;
modelStruct.modelVar_TEMPMIN_i=mod.TEMPMIN_i;
modelStruct.d_modelVar_TEMPMIN_i_dX=0.0;
modelStruct.modelVar_TEMPMAX_i=mod.TEMPMAX_i;
modelStruct.d_modelVar_TEMPMAX_i_dX=0.0;
modelStruct.modelVar_VFMAX_i=mod.VFMAX_i;
modelStruct.d_modelVar_VFMAX_i_dX=0.0;
modelStruct.modelVar_VRMAX_i=mod.VRMAX_i;
modelStruct.d_modelVar_VRMAX_i_dX=0.0;
modelStruct.modelVar_SCALE_i=mod.SCALE_i;
modelStruct.d_modelVar_SCALE_i_dX=0.0;
modelStruct.modelVar_tkr=mod.tkr;
modelStruct.d_modelVar_tkr_dX=0.0;
modelStruct.modelVar_tkd=mod.tkd;
modelStruct.d_modelVar_tkd_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_alphaav=mod.alphaav;
modelStruct.d_modelVar_alphaav_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_rescom=mod.rescom;
modelStruct.d_modelVar_rescom_dX=0.0;
modelStruct.modelVar_resbot=mod.resbot;
modelStruct.d_modelVar_resbot_dX=0.0;
modelStruct.modelVar_ressti=mod.ressti;
modelStruct.d_modelVar_ressti_dX=0.0;
modelStruct.modelVar_resgat=mod.resgat;
modelStruct.d_modelVar_resgat_dX=0.0;
modelStruct.modelVar_shrinkL=mod.shrinkL;
modelStruct.d_modelVar_shrinkL_dX=0.0;
modelStruct.modelVar_NDI_i=mod.NDI_i;
modelStruct.d_modelVar_NDI_i_dX=0.0;
modelStruct.modelVar_NDIBOT_i=mod.NDIBOT_i;
modelStruct.d_modelVar_NDIBOT_i_dX=0.0;
modelStruct.modelVar_NDIGAT_i=mod.NDIGAT_i;
modelStruct.d_modelVar_NDIGAT_i_dX=0.0;
modelStruct.modelVar_NDISTI_i=mod.NDISTI_i;
modelStruct.d_modelVar_NDISTI_i_dX=0.0;
modelStruct.modelVar_NJL=mod.NJL;
modelStruct.d_modelVar_NJL_dX=0.0;
modelStruct.modelVar_Nin=mod.Nin;
modelStruct.d_modelVar_Nin_dX=0.0;
modelStruct.modelVar_Pn0=mod.Pn0;
modelStruct.d_modelVar_Pn0_dX=0.0;
modelStruct.modelVar_La=mod.La;
modelStruct.d_modelVar_La_dX=0.0;
modelStruct.modelVar_V_HA=mod.V_HA;
modelStruct.d_modelVar_V_HA_dX=0.0;
modelStruct.modelVar_V_HK=mod.V_HK;
modelStruct.d_modelVar_V_HK_dX=0.0;
modelStruct.modelVar_PB=mod.PB;
modelStruct.modelVar_JUNCDLT=mod.JUNCDLT;


// non-reals



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_A_GND] = (*solVectorPtr)[in.li_A];
probeVars[in.admsProbeID_V_depl_A_GND] = (in.collapseNode_depl_A)?(0):((*solVectorPtr)[in.li_depl_A]);
probeVars[in.admsProbeID_V_charge_K_GND] = (in.collapseNode_charge_K)?(0):((*solVectorPtr)[in.li_charge_K]);
probeVars[in.admsProbeID_V_charge_A_GND] = (in.collapseNode_charge_A)?(0):((*solVectorPtr)[in.li_charge_A]);
probeVars[in.admsProbeID_V_A_K] = (*solVectorPtr)[in.li_A]- (*solVectorPtr)[in.li_K];
probeVars[in.admsProbeID_V_AIK_K] = (*solVectorPtr)[in.li_AIK]- (*solVectorPtr)[in.li_K];
probeVars[in.admsProbeID_V_A_AIK] = (*solVectorPtr)[in.li_A]- (*solVectorPtr)[in.li_AIK];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_A_GND,
in.admsProbeID_V_depl_A_GND,
in.admsProbeID_V_charge_K_GND,
in.admsProbeID_V_charge_A_GND,
in.admsProbeID_V_A_K,
in.admsProbeID_V_AIK_K,
in.admsProbeID_V_A_AIK,

// node constants
in.admsNodeID_A,
in.admsNodeID_K,
in.admsNodeID_AIK,
in.admsNodeID_charge_A,
in.admsNodeID_charge_K,
in.admsNodeID_depl_A,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_A] += d_staticContributions_dX[in.admsNodeID_A];
    dqdp[in.admsNodeID_A] += d_dynamicContributions_dX[in.admsNodeID_A];
    Findices[in.admsNodeID_A] = in.li_A;
    Qindices[in.admsNodeID_A] = in.li_A;
    dfdp[in.admsNodeID_K] += d_staticContributions_dX[in.admsNodeID_K];
    dqdp[in.admsNodeID_K] += d_dynamicContributions_dX[in.admsNodeID_K];
    Findices[in.admsNodeID_K] = in.li_K;
    Qindices[in.admsNodeID_K] = in.li_K;
    dfdp[in.admsNodeID_AIK] += d_staticContributions_dX[in.admsNodeID_AIK];
    dqdp[in.admsNodeID_AIK] += d_dynamicContributions_dX[in.admsNodeID_AIK];
    Findices[in.admsNodeID_AIK] = in.li_AIK;
    Qindices[in.admsNodeID_AIK] = in.li_AIK;
    dfdp[in.admsNodeID_charge_A] += d_staticContributions_dX[in.admsNodeID_charge_A];
    dqdp[in.admsNodeID_charge_A] += d_dynamicContributions_dX[in.admsNodeID_charge_A];
    Findices[in.admsNodeID_charge_A] = in.li_charge_A;
    Qindices[in.admsNodeID_charge_A] = in.li_charge_A;
    dfdp[in.admsNodeID_charge_K] += d_staticContributions_dX[in.admsNodeID_charge_K];
    dqdp[in.admsNodeID_charge_K] += d_dynamicContributions_dX[in.admsNodeID_charge_K];
    Findices[in.admsNodeID_charge_K] = in.li_charge_K;
    Qindices[in.admsNodeID_charge_K] = in.li_charge_K;
    dfdp[in.admsNodeID_depl_A] += d_staticContributions_dX[in.admsNodeID_depl_A];
    dqdp[in.admsNodeID_depl_A] += d_dynamicContributions_dX[in.admsNodeID_depl_A];
    Findices[in.admsNodeID_depl_A] = in.li_depl_A;
    Qindices[in.admsNodeID_depl_A] = in.li_depl_A;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((6+0)*sizeInstance);
dqdp.resize((6+0)*sizeInstance);
Findices.resize((6+0)*sizeInstance);
Qindices.resize((6+0)*sizeInstance);

std::vector <double> probeVars(7);
std::vector <double> d_staticContributions_dX(6+0);
std::vector <double> d_dynamicContributions_dX(6+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_VERSION=mod.VERSION;
modelStruct.d_modelPar_VERSION_dX=0.0;
modelStruct.modelPar_given_VERSION=mod.given("VERSION");
modParamMap["VERSION"] = &(modelStruct.d_modelPar_VERSION_dX);
modelStruct.modelPar_SUBVERSION=mod.SUBVERSION;
modelStruct.d_modelPar_SUBVERSION_dX=0.0;
modelStruct.modelPar_given_SUBVERSION=mod.given("SUBVERSION");
modParamMap["SUBVERSION"] = &(modelStruct.d_modelPar_SUBVERSION_dX);
modelStruct.modelPar_REVISION=mod.REVISION;
modelStruct.d_modelPar_REVISION_dX=0.0;
modelStruct.modelPar_given_REVISION=mod.given("REVISION");
modParamMap["REVISION"] = &(modelStruct.d_modelPar_REVISION_dX);
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.d_modelPar_TYPE_dX=0.0;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modParamMap["TYPE"] = &(modelStruct.d_modelPar_TYPE_dX);
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");
modParamMap["DTA"] = &(modelStruct.d_modelPar_DTA_dX);
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modParamMap["IMAX"] = &(modelStruct.d_modelPar_IMAX_dX);
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modParamMap["TRJ"] = &(modelStruct.d_modelPar_TRJ_dX);
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modParamMap["CJORBOT"] = &(modelStruct.d_modelPar_CJORBOT_dX);
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modParamMap["CJORSTI"] = &(modelStruct.d_modelPar_CJORSTI_dX);
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modParamMap["CJORGAT"] = &(modelStruct.d_modelPar_CJORGAT_dX);
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modParamMap["VBIRBOT"] = &(modelStruct.d_modelPar_VBIRBOT_dX);
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modParamMap["VBIRSTI"] = &(modelStruct.d_modelPar_VBIRSTI_dX);
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modParamMap["VBIRGAT"] = &(modelStruct.d_modelPar_VBIRGAT_dX);
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modParamMap["PBOT"] = &(modelStruct.d_modelPar_PBOT_dX);
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modParamMap["PSTI"] = &(modelStruct.d_modelPar_PSTI_dX);
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modParamMap["PGAT"] = &(modelStruct.d_modelPar_PGAT_dX);
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modParamMap["PHIGBOT"] = &(modelStruct.d_modelPar_PHIGBOT_dX);
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modParamMap["PHIGSTI"] = &(modelStruct.d_modelPar_PHIGSTI_dX);
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modParamMap["PHIGGAT"] = &(modelStruct.d_modelPar_PHIGGAT_dX);
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modParamMap["IDSATRBOT"] = &(modelStruct.d_modelPar_IDSATRBOT_dX);
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modParamMap["IDSATRSTI"] = &(modelStruct.d_modelPar_IDSATRSTI_dX);
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modParamMap["IDSATRGAT"] = &(modelStruct.d_modelPar_IDSATRGAT_dX);
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modParamMap["CSRHBOT"] = &(modelStruct.d_modelPar_CSRHBOT_dX);
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modParamMap["CSRHSTI"] = &(modelStruct.d_modelPar_CSRHSTI_dX);
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modParamMap["CSRHGAT"] = &(modelStruct.d_modelPar_CSRHGAT_dX);
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modParamMap["XJUNSTI"] = &(modelStruct.d_modelPar_XJUNSTI_dX);
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modParamMap["XJUNGAT"] = &(modelStruct.d_modelPar_XJUNGAT_dX);
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modParamMap["CTATBOT"] = &(modelStruct.d_modelPar_CTATBOT_dX);
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modParamMap["CTATSTI"] = &(modelStruct.d_modelPar_CTATSTI_dX);
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modParamMap["CTATGAT"] = &(modelStruct.d_modelPar_CTATGAT_dX);
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modParamMap["MEFFTATBOT"] = &(modelStruct.d_modelPar_MEFFTATBOT_dX);
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modParamMap["MEFFTATSTI"] = &(modelStruct.d_modelPar_MEFFTATSTI_dX);
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modParamMap["MEFFTATGAT"] = &(modelStruct.d_modelPar_MEFFTATGAT_dX);
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modParamMap["CBBTBOT"] = &(modelStruct.d_modelPar_CBBTBOT_dX);
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modParamMap["CBBTSTI"] = &(modelStruct.d_modelPar_CBBTSTI_dX);
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modParamMap["CBBTGAT"] = &(modelStruct.d_modelPar_CBBTGAT_dX);
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modParamMap["FBBTRBOT"] = &(modelStruct.d_modelPar_FBBTRBOT_dX);
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modParamMap["FBBTRSTI"] = &(modelStruct.d_modelPar_FBBTRSTI_dX);
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modParamMap["FBBTRGAT"] = &(modelStruct.d_modelPar_FBBTRGAT_dX);
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modParamMap["STFBBTBOT"] = &(modelStruct.d_modelPar_STFBBTBOT_dX);
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modParamMap["STFBBTSTI"] = &(modelStruct.d_modelPar_STFBBTSTI_dX);
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modParamMap["STFBBTGAT"] = &(modelStruct.d_modelPar_STFBBTGAT_dX);
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modParamMap["VBRBOT"] = &(modelStruct.d_modelPar_VBRBOT_dX);
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modParamMap["VBRSTI"] = &(modelStruct.d_modelPar_VBRSTI_dX);
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modParamMap["VBRGAT"] = &(modelStruct.d_modelPar_VBRGAT_dX);
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modParamMap["PBRBOT"] = &(modelStruct.d_modelPar_PBRBOT_dX);
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modParamMap["PBRSTI"] = &(modelStruct.d_modelPar_PBRSTI_dX);
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modParamMap["PBRGAT"] = &(modelStruct.d_modelPar_PBRGAT_dX);
modelStruct.modelPar_FREV=mod.FREV;
modelStruct.d_modelPar_FREV_dX=0.0;
modelStruct.modelPar_given_FREV=mod.given("FREV");
modParamMap["FREV"] = &(modelStruct.d_modelPar_FREV_dX);
modelStruct.modelPar_RSBOT=mod.RSBOT;
modelStruct.d_modelPar_RSBOT_dX=0.0;
modelStruct.modelPar_given_RSBOT=mod.given("RSBOT");
modParamMap["RSBOT"] = &(modelStruct.d_modelPar_RSBOT_dX);
modelStruct.modelPar_RSSTI=mod.RSSTI;
modelStruct.d_modelPar_RSSTI_dX=0.0;
modelStruct.modelPar_given_RSSTI=mod.given("RSSTI");
modParamMap["RSSTI"] = &(modelStruct.d_modelPar_RSSTI_dX);
modelStruct.modelPar_RSGAT=mod.RSGAT;
modelStruct.d_modelPar_RSGAT_dX=0.0;
modelStruct.modelPar_given_RSGAT=mod.given("RSGAT");
modParamMap["RSGAT"] = &(modelStruct.d_modelPar_RSGAT_dX);
modelStruct.modelPar_RSCOM=mod.RSCOM;
modelStruct.d_modelPar_RSCOM_dX=0.0;
modelStruct.modelPar_given_RSCOM=mod.given("RSCOM");
modParamMap["RSCOM"] = &(modelStruct.d_modelPar_RSCOM_dX);
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modParamMap["STRS"] = &(modelStruct.d_modelPar_STRS_dX);
modelStruct.modelPar_KF=mod.KF;
modelStruct.d_modelPar_KF_dX=0.0;
modelStruct.modelPar_given_KF=mod.given("KF");
modParamMap["KF"] = &(modelStruct.d_modelPar_KF_dX);
modelStruct.modelPar_AF=mod.AF;
modelStruct.d_modelPar_AF_dX=0.0;
modelStruct.modelPar_given_AF=mod.given("AF");
modParamMap["AF"] = &(modelStruct.d_modelPar_AF_dX);
modelStruct.modelPar_TT=mod.TT;
modelStruct.d_modelPar_TT_dX=0.0;
modelStruct.modelPar_given_TT=mod.given("TT");
modParamMap["TT"] = &(modelStruct.d_modelPar_TT_dX);
modelStruct.modelPar_STVBRBOT1=mod.STVBRBOT1;
modelStruct.d_modelPar_STVBRBOT1_dX=0.0;
modelStruct.modelPar_given_STVBRBOT1=mod.given("STVBRBOT1");
modParamMap["STVBRBOT1"] = &(modelStruct.d_modelPar_STVBRBOT1_dX);
modelStruct.modelPar_STVBRBOT2=mod.STVBRBOT2;
modelStruct.d_modelPar_STVBRBOT2_dX=0.0;
modelStruct.modelPar_given_STVBRBOT2=mod.given("STVBRBOT2");
modParamMap["STVBRBOT2"] = &(modelStruct.d_modelPar_STVBRBOT2_dX);
modelStruct.modelPar_STVBRSTI1=mod.STVBRSTI1;
modelStruct.d_modelPar_STVBRSTI1_dX=0.0;
modelStruct.modelPar_given_STVBRSTI1=mod.given("STVBRSTI1");
modParamMap["STVBRSTI1"] = &(modelStruct.d_modelPar_STVBRSTI1_dX);
modelStruct.modelPar_STVBRSTI2=mod.STVBRSTI2;
modelStruct.d_modelPar_STVBRSTI2_dX=0.0;
modelStruct.modelPar_given_STVBRSTI2=mod.given("STVBRSTI2");
modParamMap["STVBRSTI2"] = &(modelStruct.d_modelPar_STVBRSTI2_dX);
modelStruct.modelPar_STVBRGAT1=mod.STVBRGAT1;
modelStruct.d_modelPar_STVBRGAT1_dX=0.0;
modelStruct.modelPar_given_STVBRGAT1=mod.given("STVBRGAT1");
modParamMap["STVBRGAT1"] = &(modelStruct.d_modelPar_STVBRGAT1_dX);
modelStruct.modelPar_STVBRGAT2=mod.STVBRGAT2;
modelStruct.d_modelPar_STVBRGAT2_dX=0.0;
modelStruct.modelPar_given_STVBRGAT2=mod.given("STVBRGAT2");
modParamMap["STVBRGAT2"] = &(modelStruct.d_modelPar_STVBRGAT2_dX);
modelStruct.modelPar_NFABOT=mod.NFABOT;
modelStruct.d_modelPar_NFABOT_dX=0.0;
modelStruct.modelPar_given_NFABOT=mod.given("NFABOT");
modParamMap["NFABOT"] = &(modelStruct.d_modelPar_NFABOT_dX);
modelStruct.modelPar_NFASTI=mod.NFASTI;
modelStruct.d_modelPar_NFASTI_dX=0.0;
modelStruct.modelPar_given_NFASTI=mod.given("NFASTI");
modParamMap["NFASTI"] = &(modelStruct.d_modelPar_NFASTI_dX);
modelStruct.modelPar_NFAGAT=mod.NFAGAT;
modelStruct.d_modelPar_NFAGAT_dX=0.0;
modelStruct.modelPar_given_NFAGAT=mod.given("NFAGAT");
modParamMap["NFAGAT"] = &(modelStruct.d_modelPar_NFAGAT_dX);
modelStruct.modelPar_ABMIN=mod.ABMIN;
modelStruct.d_modelPar_ABMIN_dX=0.0;
modelStruct.modelPar_given_ABMIN=mod.given("ABMIN");
modParamMap["ABMIN"] = &(modelStruct.d_modelPar_ABMIN_dX);
modelStruct.modelPar_ABMAX=mod.ABMAX;
modelStruct.d_modelPar_ABMAX_dX=0.0;
modelStruct.modelPar_given_ABMAX=mod.given("ABMAX");
modParamMap["ABMAX"] = &(modelStruct.d_modelPar_ABMAX_dX);
modelStruct.modelPar_LSMIN=mod.LSMIN;
modelStruct.d_modelPar_LSMIN_dX=0.0;
modelStruct.modelPar_given_LSMIN=mod.given("LSMIN");
modParamMap["LSMIN"] = &(modelStruct.d_modelPar_LSMIN_dX);
modelStruct.modelPar_LSMAX=mod.LSMAX;
modelStruct.d_modelPar_LSMAX_dX=0.0;
modelStruct.modelPar_given_LSMAX=mod.given("LSMAX");
modParamMap["LSMAX"] = &(modelStruct.d_modelPar_LSMAX_dX);
modelStruct.modelPar_LGMIN=mod.LGMIN;
modelStruct.d_modelPar_LGMIN_dX=0.0;
modelStruct.modelPar_given_LGMIN=mod.given("LGMIN");
modParamMap["LGMIN"] = &(modelStruct.d_modelPar_LGMIN_dX);
modelStruct.modelPar_LGMAX=mod.LGMAX;
modelStruct.d_modelPar_LGMAX_dX=0.0;
modelStruct.modelPar_given_LGMAX=mod.given("LGMAX");
modParamMap["LGMAX"] = &(modelStruct.d_modelPar_LGMAX_dX);
modelStruct.modelPar_TEMPMIN=mod.TEMPMIN;
modelStruct.d_modelPar_TEMPMIN_dX=0.0;
modelStruct.modelPar_given_TEMPMIN=mod.given("TEMPMIN");
modParamMap["TEMPMIN"] = &(modelStruct.d_modelPar_TEMPMIN_dX);
modelStruct.modelPar_TEMPMAX=mod.TEMPMAX;
modelStruct.d_modelPar_TEMPMAX_dX=0.0;
modelStruct.modelPar_given_TEMPMAX=mod.given("TEMPMAX");
modParamMap["TEMPMAX"] = &(modelStruct.d_modelPar_TEMPMAX_dX);
modelStruct.modelPar_VFMAX=mod.VFMAX;
modelStruct.d_modelPar_VFMAX_dX=0.0;
modelStruct.modelPar_given_VFMAX=mod.given("VFMAX");
modParamMap["VFMAX"] = &(modelStruct.d_modelPar_VFMAX_dX);
modelStruct.modelPar_VRMAX=mod.VRMAX;
modelStruct.d_modelPar_VRMAX_dX=0.0;
modelStruct.modelPar_given_VRMAX=mod.given("VRMAX");
modParamMap["VRMAX"] = &(modelStruct.d_modelPar_VRMAX_dX);
modelStruct.modelPar_XTI=mod.XTI;
modelStruct.d_modelPar_XTI_dX=0.0;
modelStruct.modelPar_given_XTI=mod.given("XTI");
modParamMap["XTI"] = &(modelStruct.d_modelPar_XTI_dX);
modelStruct.modelPar_SCALE=mod.SCALE;
modelStruct.d_modelPar_SCALE_dX=0.0;
modelStruct.modelPar_given_SCALE=mod.given("SCALE");
modParamMap["SCALE"] = &(modelStruct.d_modelPar_SCALE_dX);
modelStruct.modelPar_SHRINK=mod.SHRINK;
modelStruct.d_modelPar_SHRINK_dX=0.0;
modelStruct.modelPar_given_SHRINK=mod.given("SHRINK");
modParamMap["SHRINK"] = &(modelStruct.d_modelPar_SHRINK_dX);
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modParamMap["SWJUNEXP"] = &(modelStruct.d_modelPar_SWJUNEXP_dX);
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modParamMap["VJUNREF"] = &(modelStruct.d_modelPar_VJUNREF_dX);
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modParamMap["FJUNQ"] = &(modelStruct.d_modelPar_FJUNQ_dX);
modelStruct.modelPar_CORECOVERY=mod.CORECOVERY;
modelStruct.d_modelPar_CORECOVERY_dX=0.0;
modelStruct.modelPar_given_CORECOVERY=mod.given("CORECOVERY");
modParamMap["CORECOVERY"] = &(modelStruct.d_modelPar_CORECOVERY_dX);
modelStruct.modelPar_NJH=mod.NJH;
modelStruct.d_modelPar_NJH_dX=0.0;
modelStruct.modelPar_given_NJH=mod.given("NJH");
modParamMap["NJH"] = &(modelStruct.d_modelPar_NJH_dX);
modelStruct.modelPar_NJDV=mod.NJDV;
modelStruct.d_modelPar_NJDV_dX=0.0;
modelStruct.modelPar_given_NJDV=mod.given("NJDV");
modParamMap["NJDV"] = &(modelStruct.d_modelPar_NJDV_dX);
modelStruct.modelPar_NDIBOT=mod.NDIBOT;
modelStruct.d_modelPar_NDIBOT_dX=0.0;
modelStruct.modelPar_given_NDIBOT=mod.given("NDIBOT");
modParamMap["NDIBOT"] = &(modelStruct.d_modelPar_NDIBOT_dX);
modelStruct.modelPar_NDIGAT=mod.NDIGAT;
modelStruct.d_modelPar_NDIGAT_dX=0.0;
modelStruct.modelPar_given_NDIGAT=mod.given("NDIGAT");
modParamMap["NDIGAT"] = &(modelStruct.d_modelPar_NDIGAT_dX);
modelStruct.modelPar_NDISTI=mod.NDISTI;
modelStruct.d_modelPar_NDISTI_dX=0.0;
modelStruct.modelPar_given_NDISTI=mod.given("NDISTI");
modParamMap["NDISTI"] = &(modelStruct.d_modelPar_NDISTI_dX);
modelStruct.modelPar_INJ1=mod.INJ1;
modelStruct.d_modelPar_INJ1_dX=0.0;
modelStruct.modelPar_given_INJ1=mod.given("INJ1");
modParamMap["INJ1"] = &(modelStruct.d_modelPar_INJ1_dX);
modelStruct.modelPar_INJ2=mod.INJ2;
modelStruct.d_modelPar_INJ2_dX=0.0;
modelStruct.modelPar_given_INJ2=mod.given("INJ2");
modParamMap["INJ2"] = &(modelStruct.d_modelPar_INJ2_dX);
modelStruct.modelPar_NQS=mod.NQS;
modelStruct.d_modelPar_NQS_dX=0.0;
modelStruct.modelPar_given_NQS=mod.given("NQS");
modParamMap["NQS"] = &(modelStruct.d_modelPar_NQS_dX);
modelStruct.modelPar_TAU=mod.TAU;
modelStruct.d_modelPar_TAU_dX=0.0;
modelStruct.modelPar_given_TAU=mod.given("TAU");
modParamMap["TAU"] = &(modelStruct.d_modelPar_TAU_dX);
modelStruct.modelPar_WI=mod.WI;
modelStruct.d_modelPar_WI_dX=0.0;
modelStruct.modelPar_given_WI=mod.given("WI");
modParamMap["WI"] = &(modelStruct.d_modelPar_WI_dX);
modelStruct.modelPar_DEPNQS=mod.DEPNQS;
modelStruct.d_modelPar_DEPNQS_dX=0.0;
modelStruct.modelPar_given_DEPNQS=mod.given("DEPNQS");
modParamMap["DEPNQS"] = &(modelStruct.d_modelPar_DEPNQS_dX);
modelStruct.modelPar_TNOM=mod.TNOM;
modelStruct.d_modelPar_TNOM_dX=0.0;
modelStruct.modelPar_given_TNOM=mod.given("TNOM");
modParamMap["TNOM"] = &(modelStruct.d_modelPar_TNOM_dX);
modelStruct.modelPar_TAUT=mod.TAUT;
modelStruct.d_modelPar_TAUT_dX=0.0;
modelStruct.modelPar_given_TAUT=mod.given("TAUT");
modParamMap["TAUT"] = &(modelStruct.d_modelPar_TAUT_dX);
modelStruct.modelPar_INJT=mod.INJT;
modelStruct.d_modelPar_INJT_dX=0.0;
modelStruct.modelPar_given_INJT=mod.given("INJT");
modParamMap["INJT"] = &(modelStruct.d_modelPar_INJT_dX);


// hidden reals


// non-reals (including hiddens)


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_KF_i=mod.KF_i;
modelStruct.d_modelVar_KF_i_dX=0.0;
modelStruct.modelVar_AF_i=mod.AF_i;
modelStruct.d_modelVar_AF_i_dX=0.0;
modelStruct.modelVar_TT_i=mod.TT_i;
modelStruct.d_modelVar_TT_i_dX=0.0;
modelStruct.modelVar_NFABOT_i=mod.NFABOT_i;
modelStruct.d_modelVar_NFABOT_i_dX=0.0;
modelStruct.modelVar_NFAGAT_i=mod.NFAGAT_i;
modelStruct.d_modelVar_NFAGAT_i_dX=0.0;
modelStruct.modelVar_NFASTI_i=mod.NFASTI_i;
modelStruct.d_modelVar_NFASTI_i_dX=0.0;
modelStruct.modelVar_ABMIN_i=mod.ABMIN_i;
modelStruct.d_modelVar_ABMIN_i_dX=0.0;
modelStruct.modelVar_ABMAX_i=mod.ABMAX_i;
modelStruct.d_modelVar_ABMAX_i_dX=0.0;
modelStruct.modelVar_LGMAX_i=mod.LGMAX_i;
modelStruct.d_modelVar_LGMAX_i_dX=0.0;
modelStruct.modelVar_LGMIN_i=mod.LGMIN_i;
modelStruct.d_modelVar_LGMIN_i_dX=0.0;
modelStruct.modelVar_LSMAX_i=mod.LSMAX_i;
modelStruct.d_modelVar_LSMAX_i_dX=0.0;
modelStruct.modelVar_LSMIN_i=mod.LSMIN_i;
modelStruct.d_modelVar_LSMIN_i_dX=0.0;
modelStruct.modelVar_TEMPMIN_i=mod.TEMPMIN_i;
modelStruct.d_modelVar_TEMPMIN_i_dX=0.0;
modelStruct.modelVar_TEMPMAX_i=mod.TEMPMAX_i;
modelStruct.d_modelVar_TEMPMAX_i_dX=0.0;
modelStruct.modelVar_VFMAX_i=mod.VFMAX_i;
modelStruct.d_modelVar_VFMAX_i_dX=0.0;
modelStruct.modelVar_VRMAX_i=mod.VRMAX_i;
modelStruct.d_modelVar_VRMAX_i_dX=0.0;
modelStruct.modelVar_SCALE_i=mod.SCALE_i;
modelStruct.d_modelVar_SCALE_i_dX=0.0;
modelStruct.modelVar_tkr=mod.tkr;
modelStruct.d_modelVar_tkr_dX=0.0;
modelStruct.modelVar_tkd=mod.tkd;
modelStruct.d_modelVar_tkd_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_alphaav=mod.alphaav;
modelStruct.d_modelVar_alphaav_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_rescom=mod.rescom;
modelStruct.d_modelVar_rescom_dX=0.0;
modelStruct.modelVar_resbot=mod.resbot;
modelStruct.d_modelVar_resbot_dX=0.0;
modelStruct.modelVar_ressti=mod.ressti;
modelStruct.d_modelVar_ressti_dX=0.0;
modelStruct.modelVar_resgat=mod.resgat;
modelStruct.d_modelVar_resgat_dX=0.0;
modelStruct.modelVar_shrinkL=mod.shrinkL;
modelStruct.d_modelVar_shrinkL_dX=0.0;
modelStruct.modelVar_NDI_i=mod.NDI_i;
modelStruct.d_modelVar_NDI_i_dX=0.0;
modelStruct.modelVar_NDIBOT_i=mod.NDIBOT_i;
modelStruct.d_modelVar_NDIBOT_i_dX=0.0;
modelStruct.modelVar_NDIGAT_i=mod.NDIGAT_i;
modelStruct.d_modelVar_NDIGAT_i_dX=0.0;
modelStruct.modelVar_NDISTI_i=mod.NDISTI_i;
modelStruct.d_modelVar_NDISTI_i_dX=0.0;
modelStruct.modelVar_NJL=mod.NJL;
modelStruct.d_modelVar_NJL_dX=0.0;
modelStruct.modelVar_Nin=mod.Nin;
modelStruct.d_modelVar_Nin_dX=0.0;
modelStruct.modelVar_Pn0=mod.Pn0;
modelStruct.d_modelVar_Pn0_dX=0.0;
modelStruct.modelVar_La=mod.La;
modelStruct.d_modelVar_La_dX=0.0;
modelStruct.modelVar_V_HA=mod.V_HA;
modelStruct.d_modelVar_V_HA_dX=0.0;
modelStruct.modelVar_V_HK=mod.V_HK;
modelStruct.d_modelVar_V_HK_dX=0.0;
modelStruct.modelVar_PB=mod.PB;
modelStruct.modelVar_JUNCDLT=mod.JUNCDLT;


// non-reals



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 6+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_AB=in.AB;
instanceStruct.d_instancePar_AB_dX=0.0;
instanceStruct.instancePar_given_AB=in.given("AB");
instanceStruct.instancePar_LS=in.LS;
instanceStruct.d_instancePar_LS_dX=0.0;
instanceStruct.instancePar_given_LS=in.given("LS");
instanceStruct.instancePar_LG=in.LG;
instanceStruct.d_instancePar_LG_dX=0.0;
instanceStruct.instancePar_given_LG=in.given("LG");
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_tmpv=in.tmpv;
instanceStruct.d_instanceVar_tmpv_dX=0.0;
instanceStruct.instanceVar_vjv=in.vjv;
instanceStruct.d_instanceVar_vjv_dX=0.0;
instanceStruct.instanceVar_AB_i=in.AB_i;
instanceStruct.d_instanceVar_AB_i_dX=0.0;
instanceStruct.instanceVar_LS_i=in.LS_i;
instanceStruct.d_instanceVar_LS_i_dX=0.0;
instanceStruct.instanceVar_LG_i=in.LG_i;
instanceStruct.d_instanceVar_LG_i_dX=0.0;
instanceStruct.instanceVar_zflagbot=in.zflagbot;
instanceStruct.instanceVar_zflagsti=in.zflagsti;
instanceStruct.instanceVar_zflaggat=in.zflaggat;
instanceStruct.instanceVar_VMAX=in.VMAX;
instanceStruct.d_instanceVar_VMAX_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd=in.exp_VMAX_over_phitd;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_dX=0.0;
instanceStruct.instanceVar_vbimin=in.vbimin;
instanceStruct.d_instanceVar_vbimin_dX=0.0;
instanceStruct.instanceVar_vch=in.vch;
instanceStruct.d_instanceVar_vch_dX=0.0;
instanceStruct.instanceVar_vfmin=in.vfmin;
instanceStruct.d_instanceVar_vfmin_dX=0.0;
instanceStruct.instanceVar_vbbtlim=in.vbbtlim;
instanceStruct.d_instanceVar_vbbtlim_dX=0.0;
instanceStruct.instanceVar_ijunbot=in.ijunbot;
instanceStruct.d_instanceVar_ijunbot_dX=0.0;
instanceStruct.instanceVar_qjunbot=in.qjunbot;
instanceStruct.d_instanceVar_qjunbot_dX=0.0;
instanceStruct.instanceVar_ijunsti=in.ijunsti;
instanceStruct.d_instanceVar_ijunsti_dX=0.0;
instanceStruct.instanceVar_qjunsti=in.qjunsti;
instanceStruct.d_instanceVar_qjunsti_dX=0.0;
instanceStruct.instanceVar_ijungat=in.ijungat;
instanceStruct.d_instanceVar_ijungat_dX=0.0;
instanceStruct.instanceVar_qjungat=in.qjungat;
instanceStruct.d_instanceVar_qjungat_dX=0.0;
instanceStruct.instanceVar_ijun=in.ijun;
instanceStruct.d_instanceVar_ijun_dX=0.0;
instanceStruct.instanceVar_jnoise=in.jnoise;
instanceStruct.d_instanceVar_jnoise_dX=0.0;
instanceStruct.instanceVar_VAK=in.VAK;
instanceStruct.instanceVar_DQAbot=in.DQAbot;
instanceStruct.d_instanceVar_DQAbot_dX=0.0;
instanceStruct.instanceVar_DQAsti=in.DQAsti;
instanceStruct.d_instanceVar_DQAsti_dX=0.0;
instanceStruct.instanceVar_DQAgat=in.DQAgat;
instanceStruct.d_instanceVar_DQAgat_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_bot=in.exp_VMAX_over_phitd_bot;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_bot_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_sti=in.exp_VMAX_over_phitd_sti;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_sti_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_gat=in.exp_VMAX_over_phitd_gat;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_gat_dX=0.0;
instanceStruct.instanceVar_conducts=in.conducts;
instanceStruct.d_instanceVar_conducts_dX=0.0;
instanceStruct.instanceVar_jfnoise=in.jfnoise;
instanceStruct.d_instanceVar_jfnoise_dX=0.0;
instanceStruct.instanceVar_jtnoise=in.jtnoise;
instanceStruct.d_instanceVar_jtnoise_dX=0.0;
instanceStruct.instanceVar_isattotal=in.isattotal;
instanceStruct.d_instanceVar_isattotal_dX=0.0;
instanceStruct.instanceVar_ijnon=in.ijnon;
instanceStruct.d_instanceVar_ijnon_dX=0.0;
instanceStruct.instanceVar_ijnonbot=in.ijnonbot;
instanceStruct.d_instanceVar_ijnonbot_dX=0.0;
instanceStruct.instanceVar_ijnonsti=in.ijnonsti;
instanceStruct.d_instanceVar_ijnonsti_dX=0.0;
instanceStruct.instanceVar_ijnongat=in.ijnongat;
instanceStruct.d_instanceVar_ijnongat_dX=0.0;
instanceStruct.instanceVar_xhighf1=in.xhighf1;
instanceStruct.d_instanceVar_xhighf1_dX=0.0;
instanceStruct.instanceVar_expxhf1=in.expxhf1;
instanceStruct.d_instanceVar_expxhf1_dX=0.0;
instanceStruct.instanceVar_xhighf2=in.xhighf2;
instanceStruct.d_instanceVar_xhighf2_dX=0.0;
instanceStruct.instanceVar_expxhf2=in.expxhf2;
instanceStruct.d_instanceVar_expxhf2_dX=0.0;
instanceStruct.instanceVar_xhighr=in.xhighr;
instanceStruct.d_instanceVar_xhighr_dX=0.0;
instanceStruct.instanceVar_expxhr=in.expxhr;
instanceStruct.d_instanceVar_expxhr_dX=0.0;
instanceStruct.instanceVar_ISATFOR1=in.ISATFOR1;
instanceStruct.d_instanceVar_ISATFOR1_dX=0.0;
instanceStruct.instanceVar_MFOR1=in.MFOR1;
instanceStruct.d_instanceVar_MFOR1_dX=0.0;
instanceStruct.instanceVar_ISATFOR2=in.ISATFOR2;
instanceStruct.d_instanceVar_ISATFOR2_dX=0.0;
instanceStruct.instanceVar_MFOR2=in.MFOR2;
instanceStruct.d_instanceVar_MFOR2_dX=0.0;
instanceStruct.instanceVar_ISATREV=in.ISATREV;
instanceStruct.d_instanceVar_ISATREV_dX=0.0;
instanceStruct.instanceVar_MREV=in.MREV;
instanceStruct.d_instanceVar_MREV_dX=0.0;
instanceStruct.instanceVar_m0flag=in.m0flag;
instanceStruct.instanceVar_TMF1=in.TMF1;
instanceStruct.d_instanceVar_TMF1_dX=0.0;
instanceStruct.instanceVar_TMF2=in.TMF2;
instanceStruct.d_instanceVar_TMF2_dX=0.0;
instanceStruct.instanceVar_Q_nqs_A=in.Q_nqs_A;
instanceStruct.d_instanceVar_Q_nqs_A_dX=0.0;
instanceStruct.instanceVar_Q_nqs_K=in.Q_nqs_K;
instanceStruct.d_instanceVar_Q_nqs_K_dX=0.0;
instanceStruct.instanceVar_Inqs0_A=in.Inqs0_A;
instanceStruct.d_instanceVar_Inqs0_A_dX=0.0;
instanceStruct.instanceVar_Inqs0_K=in.Inqs0_K;
instanceStruct.d_instanceVar_Inqs0_K_dX=0.0;
instanceStruct.instanceVar_W_nqs_A=in.W_nqs_A;
instanceStruct.d_instanceVar_W_nqs_A_dX=0.0;
instanceStruct.instanceVar_IWnqs0_A=in.IWnqs0_A;
instanceStruct.d_instanceVar_IWnqs0_A_dX=0.0;
instanceStruct.instanceVar_nj1=in.nj1;
instanceStruct.d_instanceVar_nj1_dX=0.0;
instanceStruct.instanceVar_nja10=in.nja10;
instanceStruct.d_instanceVar_nja10_dX=0.0;
instanceStruct.instanceVar_nja11=in.nja11;
instanceStruct.d_instanceVar_nja11_dX=0.0;
instanceStruct.instanceVar_vha1=in.vha1;
instanceStruct.d_instanceVar_vha1_dX=0.0;
instanceStruct.instanceVar_pnn0=in.pnn0;
instanceStruct.d_instanceVar_pnn0_dX=0.0;
instanceStruct.instanceVar_dFn_SU=in.dFn_SU;
instanceStruct.d_instanceVar_dFn_SU_dX=0.0;
instanceStruct.instanceVar_dFn_SL=in.dFn_SL;
instanceStruct.d_instanceVar_dFn_SL_dX=0.0;
instanceStruct.instanceVar_dnj1_dV=in.dnj1_dV;
instanceStruct.d_instanceVar_dnj1_dV_dX=0.0;
instanceStruct.instanceVar_dVMAX_over_phitd_dV=in.dVMAX_over_phitd_dV;
instanceStruct.d_instanceVar_dVMAX_over_phitd_dV_dX=0.0;
instanceStruct.instanceVar_idmultbot=in.idmultbot;
instanceStruct.d_instanceVar_idmultbot_dX=0.0;
instanceStruct.instanceVar_idmultsti=in.idmultsti;
instanceStruct.d_instanceVar_idmultsti_dX=0.0;
instanceStruct.instanceVar_idmultgat=in.idmultgat;
instanceStruct.d_instanceVar_idmultgat_dX=0.0;


  //non-reals
instanceStruct.instanceVar_rnode=in.rnode;



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_A_GND] = (*solVectorPtr)[in.li_A];
probeVars[in.admsProbeID_V_depl_A_GND] = (in.collapseNode_depl_A)?(0):((*solVectorPtr)[in.li_depl_A]);
probeVars[in.admsProbeID_V_charge_K_GND] = (in.collapseNode_charge_K)?(0):((*solVectorPtr)[in.li_charge_K]);
probeVars[in.admsProbeID_V_charge_A_GND] = (in.collapseNode_charge_A)?(0):((*solVectorPtr)[in.li_charge_A]);
probeVars[in.admsProbeID_V_A_K] = (*solVectorPtr)[in.li_A] - (*solVectorPtr)[in.li_K];
probeVars[in.admsProbeID_V_AIK_K] = (*solVectorPtr)[in.li_AIK] - (*solVectorPtr)[in.li_K];
probeVars[in.admsProbeID_V_A_AIK] = (*solVectorPtr)[in.li_A] - (*solVectorPtr)[in.li_AIK];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_A_GND,
in.admsProbeID_V_depl_A_GND,
in.admsProbeID_V_charge_K_GND,
in.admsProbeID_V_charge_A_GND,
in.admsProbeID_V_A_K,
in.admsProbeID_V_AIK_K,
in.admsProbeID_V_A_AIK,

// node constants
in.admsNodeID_A,
in.admsNodeID_K,
in.admsNodeID_AIK,
in.admsNodeID_charge_A,
in.admsNodeID_charge_K,
in.admsNodeID_depl_A,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_A+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_A];
    dqdp[in.admsNodeID_A+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_A];
    Findices[in.admsNodeID_A+inst*(6+0)] = in.li_A;
    Qindices[in.admsNodeID_A+inst*(6+0)] = in.li_A;
    dfdp[in.admsNodeID_K+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_K];
    dqdp[in.admsNodeID_K+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_K];
    Findices[in.admsNodeID_K+inst*(6+0)] = in.li_K;
    Qindices[in.admsNodeID_K+inst*(6+0)] = in.li_K;
    dfdp[in.admsNodeID_AIK+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_AIK];
    dqdp[in.admsNodeID_AIK+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_AIK];
    Findices[in.admsNodeID_AIK+inst*(6+0)] = in.li_AIK;
    Qindices[in.admsNodeID_AIK+inst*(6+0)] = in.li_AIK;
    dfdp[in.admsNodeID_charge_A+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_charge_A];
    dqdp[in.admsNodeID_charge_A+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_charge_A];
    Findices[in.admsNodeID_charge_A+inst*(6+0)] = in.li_charge_A;
    Qindices[in.admsNodeID_charge_A+inst*(6+0)] = in.li_charge_A;
    dfdp[in.admsNodeID_charge_K+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_charge_K];
    dqdp[in.admsNodeID_charge_K+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_charge_K];
    Findices[in.admsNodeID_charge_K+inst*(6+0)] = in.li_charge_K;
    Qindices[in.admsNodeID_charge_K+inst*(6+0)] = in.li_charge_K;
    dfdp[in.admsNodeID_depl_A+inst*(6+0)] += d_staticContributions_dX[in.admsNodeID_depl_A];
    dqdp[in.admsNodeID_depl_A+inst*(6+0)] += d_dynamicContributions_dX[in.admsNodeID_depl_A];
    Findices[in.admsNodeID_depl_A+inst*(6+0)] = in.li_depl_A;
    Qindices[in.admsNodeID_depl_A+inst*(6+0)] = in.li_depl_A;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSDIODE_CMC
} // namespace Device
} // namespace Xyce
