
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file psp102.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:28
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSPSP102VA.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSPSP102VA {


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_D;
    const int Instance::admsNodeID_G;
    const int Instance::admsNodeID_S;
    const int Instance::admsNodeID_B;
    const int Instance::admsNodeID_NOI;
    const int Instance::admsNodeID_NOI2;
    const int Instance::admsNodeID_GP;
    const int Instance::admsNodeID_BP;
    const int Instance::admsNodeID_BI;
    const int Instance::admsNodeID_BS;
    const int Instance::admsNodeID_BD;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSPSP102VA::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSPSP102VA::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(10e-6), &ADMSPSP102VA::Instance::L)
    .setDescription("Design length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("W", static_cast<double>(10e-6), &ADMSPSP102VA::Instance::W)
    .setDescription("Design width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SA", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SA)
    .setDescription("Distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SB", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SB)
    .setDescription("Distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SD", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SD)
    .setDescription("Distance between neighbouring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCA", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCA)
    .setDescription("Integral of the first distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCB", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCB)
    .setDescription("Integral of the second distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCC", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SCC)
    .setDescription("Integral of the third distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SC", static_cast<double>(0.0), &ADMSPSP102VA::Instance::SC)
    .setDescription("Distance between OD-edge and nearest well edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTO", static_cast<double>(0.0), &ADMSPSP102VA::Instance::DELVTO)
    .setDescription("Threshold voltage shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACTUO", static_cast<double>(1.0), &ADMSPSP102VA::Instance::FACTUO)
    .setDescription("Zero-field mobility pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABSOURCE", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::ABSOURCE)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSSOURCE", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LSSOURCE)
    .setDescription("STI-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGSOURCE", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LGSOURCE)
    .setDescription("Gate-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABDRAIN", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::ABDRAIN)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSDRAIN", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LSDRAIN)
    .setDescription("STI-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGDRAIN", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::LGDRAIN)
    .setDescription("Gate-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AS", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::AS)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PS", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::PS)
    .setDescription("Perimeter of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AD", static_cast<double>(1E-12), &ADMSPSP102VA::Instance::AD)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PD", static_cast<double>(1E-6), &ADMSPSP102VA::Instance::PD)
    .setDescription("Perimeter of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSPSP102VA::Instance::MULT)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("M", static_cast<double>(1.0), &ADMSPSP102VA::Instance::MULT)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NF", static_cast<double>(1.0), &ADMSPSP102VA::Instance::NF)
    .setDescription("Number of fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<double>(1.0), &ADMSPSP102VA::Instance::NGCON)
    .setDescription("Number of gate contacts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGW", static_cast<double>(1.0E-7), &ADMSPSP102VA::Instance::XGW)
    .setDescription("Distance from the gate contact to the channel edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSPSP102VA::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSPSP102VA::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<double>(1020), &ADMSPSP102VA::Model::LEVEL)
    .setDescription("Model level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TYPE", static_cast<double>(1.0), &ADMSPSP102VA::Model::TYPE)
    .setDescription("Channel type parameter, +1=NMOS -1=PMOS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TR", static_cast<double>(21.0), &ADMSPSP102VA::Model::TR)
    .setDescription("nominal (reference) temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWIGATE", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWIGATE)
    .setDescription("Flag for gate current, 0=turn off IG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWIMPACT", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWIMPACT)
    .setDescription("Flag for impact ionization current, 0=turn off II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWGIDL", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWGIDL)
    .setDescription("Flag for GIDL current, 0=turn off IGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWJUNCAP", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNCAP)
    .setDescription("Flag for juncap, 0=turn off juncap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWJUNASYM", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNASYM)
    .setDescription("Flag for asymmetric junctions; 0=symmetric, 1=asymmetric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("QMC", static_cast<double>(1.0), &ADMSPSP102VA::Model::QMC)
    .setDescription("Quantum-mechanical correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARO", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARO)
    .setDescription("Geom. independent difference between actual and programmed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARL", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARL)
    .setDescription("Length dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARW", static_cast<double>(0.0), &ADMSPSP102VA::Model::LVARW)
    .setDescription("Width dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAP", static_cast<double>(0.0), &ADMSPSP102VA::Model::LAP)
    .setDescription("Effective channel length reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARO", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARO)
    .setDescription("Geom. independent difference between actual and programmed field-oxide opening")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARL", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARL)
    .setDescription("Length dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARW", static_cast<double>(0.0), &ADMSPSP102VA::Model::WVARW)
    .setDescription("Width dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WOT", static_cast<double>(0.0), &ADMSPSP102VA::Model::WOT)
    .setDescription("Effective channel width reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLQ", static_cast<double>(0.0), &ADMSPSP102VA::Model::DLQ)
    .setDescription("Effective channel length reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DWQ", static_cast<double>(0.0), &ADMSPSP102VA::Model::DWQ)
    .setDescription("Effective channel width reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBO", static_cast<double>((-1.0)), &ADMSPSP102VA::Model::VFBO)
    .setDescription("Geometry-independent flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBL)
    .setDescription("Length dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBW)
    .setDescription("Width dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::VFBLW)
    .setDescription("Area dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBO", static_cast<double>(5e-4), &ADMSPSP102VA::Model::STVFBO)
    .setDescription("Geometry-independent temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBL)
    .setDescription("Length dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBW)
    .setDescription("Width dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STVFBLW)
    .setDescription("Area dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXO)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSROXO", static_cast<double>(3.9), &ADMSPSP102VA::Model::EPSROXO)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBO", static_cast<double>(3e23), &ADMSPSP102VA::Model::NSUBO)
    .setDescription("Geometry independent substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NSUBW)
    .setDescription("Width dependence of background doping NSUBO due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WSEG", static_cast<double>(1e-8), &ADMSPSP102VA::Model::WSEG)
    .setDescription("Char. length of segregation of background doping NSUBO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCK", static_cast<double>(1e24), &ADMSPSP102VA::Model::NPCK)
    .setDescription("Pocket doping level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCKW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NPCKW)
    .setDescription("Width dependence of pocket doping NPCK due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WSEGP", static_cast<double>(1e-8), &ADMSPSP102VA::Model::WSEGP)
    .setDescription("Char. length of segregation of pocket doping NPCK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCK", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LPCK)
    .setDescription("Char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCKW", static_cast<double>(0.0), &ADMSPSP102VA::Model::LPCKW)
    .setDescription("Width dependence of char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FOL1", static_cast<double>(0.0), &ADMSPSP102VA::Model::FOL1)
    .setDescription("First length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FOL2", static_cast<double>(0.0), &ADMSPSP102VA::Model::FOL2)
    .setDescription("Second length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VNSUBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::VNSUBO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSLPO", static_cast<double>(0.05), &ADMSPSP102VA::Model::NSLPO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DNSUBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::DNSUBO)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBO)
    .setDescription("Geometry independent offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBL", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBL)
    .setDescription("Length dependence offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::DPHIBLEXP)
    .setDescription("Exponent for length dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBW", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBW)
    .setDescription("Width dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::DPHIBLW)
    .setDescription("Area dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPO", static_cast<double>(1e26), &ADMSPSP102VA::Model::NPO)
    .setDescription("Geometry-independent gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPL", static_cast<double>(0.0), &ADMSPSP102VA::Model::NPL)
    .setDescription("Length dependence of gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTO)
    .setDescription("Geometry-independent interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTL)
    .setDescription("Length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::CTLEXP)
    .setDescription("Exponent for length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTW)
    .setDescription("Width dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CTLW)
    .setDescription("Area dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOVO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXOVO)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOVDO", static_cast<double>(2e-9), &ADMSPSP102VA::Model::TOXOVDO)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOV", static_cast<double>(0), &ADMSPSP102VA::Model::LOV)
    .setDescription("Overlap length for gate/drain and gate/source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOVD", static_cast<double>(0), &ADMSPSP102VA::Model::LOVD)
    .setDescription("Overlap length for gate/drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVO", static_cast<double>(5e25), &ADMSPSP102VA::Model::NOVO)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVDO", static_cast<double>(5e25), &ADMSPSP102VA::Model::NOVDO)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFL)
    .setDescription("Length dependence of DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFLEXP", static_cast<double>(2.0), &ADMSPSP102VA::Model::CFLEXP)
    .setDescription("Exponent for length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFW)
    .setDescription("Width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFBO)
    .setDescription("Back-bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UO", static_cast<double>(5e-2), &ADMSPSP102VA::Model::UO)
    .setDescription("Zero-field mobility at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET1)
    .setDescription("Relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET1W)
    .setDescription("Width dependence of relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LP1)
    .setDescription("Mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::LP1W)
    .setDescription("Width dependence of mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET2", static_cast<double>(0.0), &ADMSPSP102VA::Model::FBET2)
    .setDescription("Relative mobility decrease due to second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP2", static_cast<double>(1e-8), &ADMSPSP102VA::Model::LP2)
    .setDescription("Mobility-related characteristic length of second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW1", static_cast<double>(0.0), &ADMSPSP102VA::Model::BETW1)
    .setDescription("First higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW2", static_cast<double>(0.0), &ADMSPSP102VA::Model::BETW2)
    .setDescription("Second higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBET", static_cast<double>(1e-9), &ADMSPSP102VA::Model::WBET)
    .setDescription("Characteristic width for width scaling of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STBETO)
    .setDescription("Geometry independent temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETL)
    .setDescription("Length dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETW)
    .setDescription("Width dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBETLW)
    .setDescription("Area dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUEO", static_cast<double>(0.5), &ADMSPSP102VA::Model::MUEO)
    .setDescription("Geometry independent mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUEW", static_cast<double>(0.0), &ADMSPSP102VA::Model::MUEW)
    .setDescription("Width dependence of mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STMUEO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STMUEO)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THEMUO", static_cast<double>(1.5), &ADMSPSP102VA::Model::THEMUO)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHEMUO", static_cast<double>(1.5), &ADMSPSP102VA::Model::STTHEMUO)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSO)
    .setDescription("Geometry independent coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSL)
    .setDescription("Length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLEXP", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSLEXP)
    .setDescription("Exponent for length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSW)
    .setDescription("Width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CSLW)
    .setDescription("Area dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STCSO)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORO", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORO)
    .setDescription("Geometry independent non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORL", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORL)
    .setDescription("Length dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORW", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORW)
    .setDescription("Width dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::XCORLW)
    .setDescription("Area dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STXCORO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STXCORO)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FETAO", static_cast<double>(1.0), &ADMSPSP102VA::Model::FETAO)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW1", static_cast<double>(2.5e3), &ADMSPSP102VA::Model::RSW1)
    .setDescription("Source/drain series resistance for 1 um wide channel at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW2", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSW2)
    .setDescription("Higher-order width scaling of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRSO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STRSO)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSBO)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSGO)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATO)
    .setDescription("Geometry independent velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATL", static_cast<double>(0.05), &ADMSPSP102VA::Model::THESATL)
    .setDescription("Length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::THESATLEXP)
    .setDescription("Exponent for length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATW", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATW)
    .setDescription("Width dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATLW)
    .setDescription("Area dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATO", static_cast<double>(1.0), &ADMSPSP102VA::Model::STTHESATO)
    .setDescription("Geometry independent temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATL", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATL)
    .setDescription("Length dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATW)
    .setDescription("Width dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::STTHESATLW)
    .setDescription("Area dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATBO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATBO)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::THESATGO)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXO", static_cast<double>(18), &ADMSPSP102VA::Model::AXO)
    .setDescription("Geometry independent linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXL", static_cast<double>(0.4), &ADMSPSP102VA::Model::AXL)
    .setDescription("Length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPL", static_cast<double>(5e-4), &ADMSPSP102VA::Model::ALPL)
    .setDescription("Length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPLEXP", static_cast<double>(1.0), &ADMSPSP102VA::Model::ALPLEXP)
    .setDescription("Exponent for length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPW", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALPW)
    .setDescription("Width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L1", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1L1)
    .setDescription("Length dependence of CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1LEXP", static_cast<double>(0.5), &ADMSPSP102VA::Model::ALP1LEXP)
    .setDescription("Exponent for length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L2", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1L2)
    .setDescription("Second_order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP1W)
    .setDescription("Width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2L1", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2L1)
    .setDescription("Length dependence of CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2LEXP", static_cast<double>(0.5), &ADMSPSP102VA::Model::ALP2LEXP)
    .setDescription("Exponent for length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2L2", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2L2)
    .setDescription("Second_order length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2W", static_cast<double>(0.0), &ADMSPSP102VA::Model::ALP2W)
    .setDescription("Width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPO", static_cast<double>(0.05), &ADMSPSP102VA::Model::VPO)
    .setDescription("CLM logarithmic dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1O", static_cast<double>(1.0), &ADMSPSP102VA::Model::A1O)
    .setDescription("Geometry independent impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A1L)
    .setDescription("Length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A1W)
    .setDescription("Width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2O", static_cast<double>(10), &ADMSPSP102VA::Model::A2O)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STA2O", static_cast<double>(0.0), &ADMSPSP102VA::Model::STA2O)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3O", static_cast<double>(1.0), &ADMSPSP102VA::Model::A3O)
    .setDescription("Geometry independent saturation-voltage dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A3L)
    .setDescription("Length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A3W)
    .setDescription("Width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4O", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4O)
    .setDescription("Geometry independent back-bias dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4L", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4L)
    .setDescription("Length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4W", static_cast<double>(0.0), &ADMSPSP102VA::Model::A4W)
    .setDescription("Width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCOO", static_cast<double>(0.0), &ADMSPSP102VA::Model::GCOO)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGINVLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGINVLW)
    .setDescription("Gate channel current pre-factor for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGOVW)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::IGOVDW)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIGO", static_cast<double>(2.0), &ADMSPSP102VA::Model::STIGO)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2O", static_cast<double>(0.375), &ADMSPSP102VA::Model::GC2O)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3O", static_cast<double>(0.063), &ADMSPSP102VA::Model::GC3O)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHIBO", static_cast<double>(3.1), &ADMSPSP102VA::Model::CHIBO)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::AGIDLW)
    .setDescription("Width dependence of GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::AGIDLDW)
    .setDescription("Width dependence of GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLO", static_cast<double>(41), &ADMSPSP102VA::Model::BGIDLO)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLDO", static_cast<double>(41), &ADMSPSP102VA::Model::BGIDLDO)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBGIDLO)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::STBGIDLDO)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGIDLO)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGIDLDO)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOVL", static_cast<double>(0.0), &ADMSPSP102VA::Model::CGBOVL)
    .setDescription("Oxide capacitance for gate-bulk overlap for 1 um long channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFRW)
    .setDescription("Outer fringe capacitance for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRDW", static_cast<double>(0.0), &ADMSPSP102VA::Model::CFRDW)
    .setDescription("Outer fringe capacitance for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTO", static_cast<double>(1.0), &ADMSPSP102VA::Model::FNTO)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXCL", static_cast<double>(0.0), &ADMSPSP102VA::Model::FNTEXCL)
    .setDescription("Length dependence coefficient of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFALW", static_cast<double>(8e22), &ADMSPSP102VA::Model::NFALW)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFBLW", static_cast<double>(3e7), &ADMSPSP102VA::Model::NFBLW)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFCLW", static_cast<double>(0.0), &ADMSPSP102VA::Model::NFCLW)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EFO", static_cast<double>(1.0), &ADMSPSP102VA::Model::EFO)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSPSP102VA::Model::LINTNOI)
    .setDescription("Length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPNOI", static_cast<double>(2.0), &ADMSPSP102VA::Model::ALPNOI)
    .setDescription("Exponent for length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTA", static_cast<double>(0), &ADMSPSP102VA::Model::DTA)
    .setDescription("Temperature offset w.r.t. ambient circuit temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEO", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEO)
    .setDescription("Geometrical independent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEL", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEL)
    .setDescription("Length dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEW", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWEW)
    .setDescription("Width dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWELW", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHOWELW)
    .setDescription("Area dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEO", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEO)
    .setDescription("Geometrical independent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEL", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEL)
    .setDescription("Length dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEW", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWEW)
    .setDescription("Width dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWELW", static_cast<double>(0), &ADMSPSP102VA::Model::KUOWELW)
    .setDescription("Area dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMIN", static_cast<double>(0), &ADMSPSP102VA::Model::LMIN)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMAX", static_cast<double>(1.0), &ADMSPSP102VA::Model::LMAX)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMIN", static_cast<double>(0), &ADMSPSP102VA::Model::WMIN)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMAX", static_cast<double>(1.0), &ADMSPSP102VA::Model::WMAX)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RGO)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBULKO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RBULKO)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RWELLO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RWELLO)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUNSO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RJUNSO)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUNDO", static_cast<double>(0.0), &ADMSPSP102VA::Model::RJUNDO)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RINT", static_cast<double>(0.0), &ADMSPSP102VA::Model::RINT)
    .setDescription("Contact resistance between silicide and ploy")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RVPOLY", static_cast<double>(0.0), &ADMSPSP102VA::Model::RVPOLY)
    .setDescription("Vertical poly resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHG", static_cast<double>(0.0), &ADMSPSP102VA::Model::RSHG)
    .setDescription("Gate electrode diffusion sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLSIL", static_cast<double>(0.0), &ADMSPSP102VA::Model::DLSIL)
    .setDescription("Silicide extension over the physical gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSPSP102VA::Model::SAREF)
    .setDescription("Reference distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSPSP102VA::Model::SBREF)
    .setDescription("Reference distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLOD", static_cast<double>(0), &ADMSPSP102VA::Model::WLOD)
    .setDescription("Width parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUO", static_cast<double>(0), &ADMSPSP102VA::Model::KUO)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVSAT", static_cast<double>(0), &ADMSPSP102VA::Model::KVSAT)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TKUO", static_cast<double>(0), &ADMSPSP102VA::Model::TKUO)
    .setDescription("Temperature dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKUO", static_cast<double>(0), &ADMSPSP102VA::Model::LKUO)
    .setDescription("Length dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKUO", static_cast<double>(0), &ADMSPSP102VA::Model::WKUO)
    .setDescription("Width dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKUO", static_cast<double>(0), &ADMSPSP102VA::Model::PKUO)
    .setDescription("Cross-term dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODKUO", static_cast<double>(0), &ADMSPSP102VA::Model::LLODKUO)
    .setDescription("Length parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODKUO", static_cast<double>(0), &ADMSPSP102VA::Model::WLODKUO)
    .setDescription("Width parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::KVTHO)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::LKVTHO)
    .setDescription("Length dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::WKVTHO)
    .setDescription("Width dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKVTHO", static_cast<double>(0), &ADMSPSP102VA::Model::PKVTHO)
    .setDescription("Cross-term dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODVTH", static_cast<double>(0), &ADMSPSP102VA::Model::LLODVTH)
    .setDescription("Length parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODVTH", static_cast<double>(0), &ADMSPSP102VA::Model::WLODVTH)
    .setDescription("Width parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STETAO", static_cast<double>(0), &ADMSPSP102VA::Model::STETAO)
    .setDescription("eta0 shift factor related to VTHO change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LODETAO", static_cast<double>(1.0), &ADMSPSP102VA::Model::LODETAO)
    .setDescription("eta0 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCREF", static_cast<double>(1e-6), &ADMSPSP102VA::Model::SCREF)
    .setDescription("Distance between OD-edge and well edge of a reference device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEB", static_cast<double>(0), &ADMSPSP102VA::Model::WEB)
    .setDescription("Coefficient for SCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEC", static_cast<double>(0), &ADMSPSP102VA::Model::WEC)
    .setDescription("Coefficient for SCC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IMAX", static_cast<double>(1000), &ADMSPSP102VA::Model::IMAX)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRJ", static_cast<double>(21), &ADMSPSP102VA::Model::TRJ)
    .setDescription("reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORBOT", static_cast<double>(1E-3), &ADMSPSP102VA::Model::CJORBOT)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORSTI", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORSTI)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORGAT", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORGAT)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRBOT", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRBOT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRSTI", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRSTI)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRGAT", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRGAT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSPSP102VA::Model::PBOT)
    .setDescription("Grading coefficient of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSPSP102VA::Model::PSTI)
    .setDescription("Grading coefficient of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSPSP102VA::Model::PGAT)
    .setDescription("Grading coefficient of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGBOT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGSTI)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGGAT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRBOT", static_cast<double>(1E-12), &ADMSPSP102VA::Model::IDSATRBOT)
    .setDescription("Saturation current density at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRSTI", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRSTI)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRGAT", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRGAT)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHBOT", static_cast<double>(1E2), &ADMSPSP102VA::Model::CSRHBOT)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHSTI", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHSTI)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHGAT", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHGAT)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNSTI", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNSTI)
    .setDescription("Junction depth of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNGAT", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNGAT)
    .setDescription("Junction depth of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATBOT", static_cast<double>(1E2), &ADMSPSP102VA::Model::CTATBOT)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATSTI", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATSTI)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATGAT", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATGAT)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATBOT)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATSTI)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATGAT)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTBOT", static_cast<double>(1E-12), &ADMSPSP102VA::Model::CBBTBOT)
    .setDescription("Band-to-band tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTSTI", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTSTI)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTGAT", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTGAT)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRBOT", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRBOT)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRSTI", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRSTI)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRGAT", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRGAT)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTBOT", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTBOT)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTSTI", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTSTI)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTGAT", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTGAT)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRBOT", static_cast<double>(10), &ADMSPSP102VA::Model::VBRBOT)
    .setDescription("Breakdown voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRSTI", static_cast<double>(10), &ADMSPSP102VA::Model::VBRSTI)
    .setDescription("Breakdown voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRGAT", static_cast<double>(10), &ADMSPSP102VA::Model::VBRGAT)
    .setDescription("Breakdown voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRBOT", static_cast<double>(4), &ADMSPSP102VA::Model::PBRBOT)
    .setDescription("Breakdown onset tuning parameter of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRSTI", static_cast<double>(4), &ADMSPSP102VA::Model::PBRSTI)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRGAT", static_cast<double>(4), &ADMSPSP102VA::Model::PBRGAT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORBOTD", static_cast<double>(1E-3), &ADMSPSP102VA::Model::CJORBOTD)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORSTID", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORSTID)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORGATD", static_cast<double>(1E-9), &ADMSPSP102VA::Model::CJORGATD)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRBOTD", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRBOTD)
    .setDescription("Built-in voltage at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRSTID", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRSTID)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRGATD", static_cast<double>(1), &ADMSPSP102VA::Model::VBIRGATD)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBOTD", static_cast<double>(0.5), &ADMSPSP102VA::Model::PBOTD)
    .setDescription("Grading coefficient of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTID", static_cast<double>(0.5), &ADMSPSP102VA::Model::PSTID)
    .setDescription("Grading coefficient of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGATD", static_cast<double>(0.5), &ADMSPSP102VA::Model::PGATD)
    .setDescription("Grading coefficient of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGBOTD", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGBOTD)
    .setDescription("Zero-temperature bandgap voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGSTID", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGSTID)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGGATD", static_cast<double>(1.16), &ADMSPSP102VA::Model::PHIGGATD)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRBOTD", static_cast<double>(1E-12), &ADMSPSP102VA::Model::IDSATRBOTD)
    .setDescription("Saturation current density at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRSTID", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRSTID)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRGATD", static_cast<double>(1E-18), &ADMSPSP102VA::Model::IDSATRGATD)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHBOTD", static_cast<double>(1E2), &ADMSPSP102VA::Model::CSRHBOTD)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHSTID", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHSTID)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHGATD", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CSRHGATD)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNSTID", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNSTID)
    .setDescription("Junction depth of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNGATD", static_cast<double>(100E-9), &ADMSPSP102VA::Model::XJUNGATD)
    .setDescription("Junction depth of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATBOTD", static_cast<double>(1E2), &ADMSPSP102VA::Model::CTATBOTD)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATSTID", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATSTID)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATGATD", static_cast<double>(1E-4), &ADMSPSP102VA::Model::CTATGATD)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATBOTD", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATBOTD)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATSTID", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATSTID)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATGATD", static_cast<double>(0.25), &ADMSPSP102VA::Model::MEFFTATGATD)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTBOTD", static_cast<double>(1E-12), &ADMSPSP102VA::Model::CBBTBOTD)
    .setDescription("Band-to-band tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTSTID", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTSTID)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTGATD", static_cast<double>(1E-18), &ADMSPSP102VA::Model::CBBTGATD)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRBOTD", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRBOTD)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRSTID", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRSTID)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRGATD", static_cast<double>(1E9), &ADMSPSP102VA::Model::FBBTRGATD)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTBOTD", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTBOTD)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTSTID", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTSTID)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTGATD", static_cast<double>((-1E-3)), &ADMSPSP102VA::Model::STFBBTGATD)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRBOTD", static_cast<double>(10), &ADMSPSP102VA::Model::VBRBOTD)
    .setDescription("Breakdown voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRSTID", static_cast<double>(10), &ADMSPSP102VA::Model::VBRSTID)
    .setDescription("Breakdown voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRGATD", static_cast<double>(10), &ADMSPSP102VA::Model::VBRGATD)
    .setDescription("Breakdown voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRBOTD", static_cast<double>(4), &ADMSPSP102VA::Model::PBRBOTD)
    .setDescription("Breakdown onset tuning parameter of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRSTID", static_cast<double>(4), &ADMSPSP102VA::Model::PBRSTID)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRGATD", static_cast<double>(4), &ADMSPSP102VA::Model::PBRGATD)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSPSP102VA::Model::SWJUNEXP)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSPSP102VA::Model::VJUNREF)
    .setDescription("Typical maximum source-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSPSP102VA::Model::FJUNQ)
    .setDescription("Fraction below which source-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJUNREFD", static_cast<double>(2.5), &ADMSPSP102VA::Model::VJUNREFD)
    .setDescription("Typical maximum drain-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FJUNQD", static_cast<double>(0.03), &ADMSPSP102VA::Model::FJUNQD)
    .setDescription("Fraction below which drain-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : [ 1e-9,  (+inf) [
  if ( (!((L >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter L value " << L << " out of range [ 1e-9,  (+inf) [";
  }

//    Parameter W : [ 1e-9,  (+inf) [
  if ( (!((W >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter W value " << W << " out of range [ 1e-9,  (+inf) [";
  }

//    Parameter SCA : [ 0.0,  (+inf) [
  if ( (!((SCA >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCA value " << SCA << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter SCB : [ 0.0,  (+inf) [
  if ( (!((SCB >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCB value " << SCB << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter SCC : [ 0.0,  (+inf) [
  if ( (!((SCC >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCC value " << SCC << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter FACTUO : [ 0.0,  (+inf) [
  if ( (!((FACTUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FACTUO value " << FACTUO << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter ABSOURCE : [ 0,  (+inf) [
  if ( (!((ABSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ABSOURCE value " << ABSOURCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter LSSOURCE : [ 0,  (+inf) [
  if ( (!((LSSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LSSOURCE value " << LSSOURCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter LGSOURCE : [ 0,  (+inf) [
  if ( (!((LGSOURCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LGSOURCE value " << LGSOURCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter ABDRAIN : [ 0,  (+inf) [
  if ( (!((ABDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ABDRAIN value " << ABDRAIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter LSDRAIN : [ 0,  (+inf) [
  if ( (!((LSDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LSDRAIN value " << LSDRAIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter LGDRAIN : [ 0,  (+inf) [
  if ( (!((LGDRAIN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LGDRAIN value " << LGDRAIN << " out of range [ 0,  (+inf) [";
  }

//    Parameter AS : [ 0,  (+inf) [
  if ( (!((AS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AS value " << AS << " out of range [ 0,  (+inf) [";
  }

//    Parameter PS : [ 0,  (+inf) [
  if ( (!((PS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PS value " << PS << " out of range [ 0,  (+inf) [";
  }

//    Parameter AD : [ 0,  (+inf) [
  if ( (!((AD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AD value " << AD << " out of range [ 0,  (+inf) [";
  }

//    Parameter PD : [ 0,  (+inf) [
  if ( (!((PD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PD value " << PD << " out of range [ 0,  (+inf) [";
  }

//    Parameter MULT : [ 0.0,  (+inf) [
  if ( (!((MULT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MULT value " << MULT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter NF : [ 1.0,  (+inf) [
  if ( (!((NF >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NF value " << NF << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NGCON : [ 1.0, 2.0 ]
  if ( (!((NGCON >=1.0 && NGCON <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NGCON value " << NGCON << " out of range [ 1.0, 2.0 ]";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5=0.0;
  double I4=0.0;
  double I3=0.0;
  double I2=0.0;
  double I1=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
  double V2=0.0;
  double V1=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double pmax=0.0;
  double vbigat2r=0.0;
  double vbisti2r=0.0;
  double vbibot2r=0.0;
  double pgat2=0.0;
  double psti2=0.0;
  double pbot2=0.0;
  double vbigat2=0.0;
  double vbisti2=0.0;
  double vbibot2=0.0;
  double vmaxgat=0.0;
  double vmaxsti=0.0;
  double vmaxbot=0.0;
  double alphaje=0.0;
  double zfrac=0.0;
  double tt2=0.0;
  double tt1=0.0;
  double tt0=0.0;
  double I5_cor=0.0;
  double I4_cor=0.0;
  double I3_cor=0.0;
  double I2_cor=0.0;
  double I1_cor=0.0;
  double mcor_rev=0.0;
  double m0_rev=0.0;
  double tempM=0.0;
  double tf_ig=0.0;
  double tf_thesat=0.0;
  double tf_ther=0.0;
  double tf_xcor=0.0;
  double tf_cs=0.0;
  double tf_mue=0.0;
  double tf_bet=0.0;
  double CoxovPrime_d=0.0;
  double CoxovPrime=0.0;
  double phix2=0.0;
  double dphibq=0.0;
  double qb0=0.0;
  double np=0.0;
  double arg2max=0.0;
  double tox_sq=0.0;
  double CoxPrime=0.0;
  double EPSOX=0.0;
  double DELVTO_i=0.0;
  double FACTUO_i=0.0;
  double BGIDLD_i=0.0;
  double BGIDL_i=0.0;
  double QMC_i=0.0;
  double temp00=0.0;
  double Kstressvth0=0.0;
  double rhobetaref=0.0;
  double rhobeta=0.0;
  double Kstressu0=0.0;
  double tempw=0.0;
  double templ=0.0;
  double Wx=0.0;
  double Lx=0.0;
  double Invsbref=0.0;
  double Invsaref=0.0;
  double Invsb=0.0;
  double Invsa=0.0;
  double loop=0.0;
  double tmpb=0.0;
  double tmpa=0.0;
  double RJUND=0.0;
  double RJUNS=0.0;
  double RBULK=0.0;
  double RWELL=0.0;
  double RG=0.0;
  double KUOWE=0.0;
  double KVTHOWE=0.0;
  double EF=0.0;
  double NFC=0.0;
  double NFB=0.0;
  double NFA=0.0;
  double FNTEXC=0.0;
  double FNT=0.0;
  double Lred=0.0;
  double Lnoi=0.0;
  double temp0=0.0;
  double CFRD=0.0;
  double CFR=0.0;
  double CGBOV=0.0;
  double CGOVD=0.0;
  double CGOV=0.0;
  double COX=0.0;
  double CGIDLD=0.0;
  double CGIDL=0.0;
  double STBGIDLD=0.0;
  double STBGIDL=0.0;
  double BGIDLD=0.0;
  double BGIDL=0.0;
  double AGIDLD=0.0;
  double AGIDL=0.0;
  double CHIB=0.0;
  double GC3=0.0;
  double GC2=0.0;
  double STIG=0.0;
  double IGOVD=0.0;
  double IGOV=0.0;
  double IGINV=0.0;
  double GCO=0.0;
  double A4=0.0;
  double A3=0.0;
  double STA2=0.0;
  double A2=0.0;
  double A1=0.0;
  double VP=0.0;
  double ALP2=0.0;
  double ALP1=0.0;
  double tmpx=0.0;
  double ALP=0.0;
  double AX=0.0;
  double THESATG=0.0;
  double THESATB=0.0;
  double STTHESAT=0.0;
  double THESAT=0.0;
  double RSG=0.0;
  double RSB=0.0;
  double STRS=0.0;
  double RS=0.0;
  double FETA=0.0;
  double STXCOR=0.0;
  double XCOR=0.0;
  double STCS=0.0;
  double CS=0.0;
  double STTHEMU=0.0;
  double THEMU=0.0;
  double STMUE=0.0;
  double MUE=0.0;
  double STBET=0.0;
  double BETN=0.0;
  double GWE=0.0;
  double GPE=0.0;
  double LP1e=0.0;
  double FBET1e=0.0;
  double CFB=0.0;
  double CF=0.0;
  double NOVD=0.0;
  double NOV=0.0;
  double TOXOVD=0.0;
  double TOXOV=0.0;
  double CT=0.0;
  double NP=0.0;
  double DPHIB=0.0;
  double DNSUB=0.0;
  double NSLP=0.0;
  double VNSUB=0.0;
  double NEFF=0.0;
  double NSUB=0.0;
  double BB=0.0;
  double AA=0.0;
  double LPCKe=0.0;
  double NPCKe=0.0;
  double NSUB0e=0.0;
  double EPSROX=0.0;
  double TOX=0.0;
  double STVFB=0.0;
  double VFB=0.0;
  double XGWE=0.0;
  double W_f=0.0;
  double L_slif=0.0;
  double L_f=0.0;
  double LGD_i=0.0;
  double LSD_i=0.0;
  double ABD_i=0.0;
  double LGS_i=0.0;
  double LSS_i=0.0;
  double ABS_i=0.0;
  double jwcorr=0.0;
  double iWE=0.0;
  double iLE=0.0;
  double Wcv=0.0;
  double Lcv=0.0;
  double WEcv=0.0;
  double LEcv=0.0;
  double delWOD=0.0;
  double delLPS=0.0;
  double iW=0.0;
  double iL=0.0;
  double WEN=0.0;
  double LEN=0.0;
  double NGCON_i=0.0;
  double RSHG_i=0.0;
  double SCC_i=0.0;
  double SCB_i=0.0;
  double SCA_i=0.0;
  double invNF=0.0;
  double NF_i=0.0;
  double XGW_i=0.0;
  double SC_i=0.0;
  double SD_i=0.0;
  double SB_i=0.0;
  double SA_i=0.0;
  double W_i=0.0;
  double L_i=0.0;
  double PD_i=0.0;
  double AD_i=0.0;
  double PS_i=0.0;
  double AS_i=0.0;
//Begin block initial_instance
{
ABSOURCE_i = ABSOURCE;
LSSOURCE_i = LSSOURCE;
LGSOURCE_i = LGSOURCE;
ABDRAIN_i = ABDRAIN;
LSDRAIN_i = LSDRAIN;
LGDRAIN_i = LGDRAIN;
AS_i = AS;
PS_i = PS;
AD_i = AD;
PD_i = PD;
L_i = L;
W_i = W;
SA_i = SA;
SB_i = SB;
SD_i = SD;
SC_i = SC;
XGW_i = XGW;
NF_i = ((NF>1.0)?NF:1.0);
{
double value_floor_0 = floor((NF_i+0.5));
NF_i = floor((NF_i+0.5));
}
invNF = (1.0/NF_i);
L_i = ((L_i>1e-9)?L_i:1e-9);
W_i = (((W_i*invNF)>1e-9)?(W_i*invNF):1e-9);
SCA_i = ((SCA>0.0)?SCA:0.0);
SCB_i = ((SCB>0.0)?SCB:0.0);
SCC_i = ((SCC>0.0)?SCC:0.0);
RSHG_i = (((model_.RSHG)>0.0)?(model_.RSHG):0.0);
NGCON_i = ((NGCON<1.5)?1.0:2.0);
LEN = 1e-6;
WEN = 1e-6;
iL = (LEN/L_i);
iW = (WEN/W_i);
delLPS = (((model_.LVARO)*(1.0+((model_.LVARL)*iL)))*(1.0+((model_.LVARW)*iW)));
delWOD = (((model_.WVARO)*(1.0+((model_.WVARL)*iL)))*(1.0+((model_.WVARW)*iW)));
LE = ((((L_i+delLPS)-(2.0*(model_.LAP)))>1e-9)?((L_i+delLPS)-(2.0*(model_.LAP))):1e-9);
WE = ((((W_i+delWOD)-(2.0*(model_.WOT)))>1e-9)?((W_i+delWOD)-(2.0*(model_.WOT))):1e-9);
LEcv = (((((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ))>1e-9)?(((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ)):1e-9);
WEcv = (((((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ))>1e-9)?(((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ)):1e-9);
Lcv = ((((L_i+delLPS)+(model_.DLQ))>1e-9)?((L_i+delLPS)+(model_.DLQ)):1e-9);
Wcv = ((((W_i+delWOD)+(model_.DWQ))>1e-9)?((W_i+delWOD)+(model_.DWQ)):1e-9);
iLE = (LEN/LE);
iWE = (WEN/WE);
jwcorr = 0.0;
ABS_i = 0.0;
LSS_i = 0.0;
LGS_i = 0.0;
ABD_i = 0.0;
LSD_i = 0.0;
LGD_i = 0.0;
if (((model_.SWJUNCAP)==3.0))
{
jwcorr = WE;
}
if ((((model_.SWJUNCAP)==2.0)||((model_.SWJUNCAP)==3.0)))
{
ABS_i = (AS_i*invNF);
LSS_i = ((PS_i*invNF)-jwcorr);
LGS_i = WE;
ABD_i = (AD_i*invNF);
LSD_i = ((PD_i*invNF)-jwcorr);
LGD_i = WE;
}
else
{
ABS_i = (ABSOURCE_i*invNF);
LSS_i = (LSSOURCE_i*invNF);
LGS_i = (LGSOURCE_i*invNF);
ABD_i = (ABDRAIN_i*invNF);
LSD_i = (LSDRAIN_i*invNF);
LGD_i = (LGDRAIN_i*invNF);
}
L_f = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
L_slif = (((L_f+(model_.DLSIL))>1e-9)?(L_f+(model_.DLSIL)):1e-9);
W_f = (((W_i+delWOD)>1e-9)?(W_i+delWOD):1e-9);
XGWE = (((XGW_i-(0.5*delWOD))>1e-9)?(XGW_i-(0.5*delWOD)):1e-9);
VFB = ((((model_.VFBO)*(1.0+((model_.VFBL)*iLE)))*(1.0+((model_.VFBW)*iWE)))*(1.0+(((model_.VFBLW)*iLE)*iWE)));
STVFB = ((((model_.STVFBO)*(1.0+((model_.STVFBL)*iLE)))*(1.0+((model_.STVFBW)*iWE)))*(1.0+(((model_.STVFBLW)*iLE)*iWE)));
TOX = (model_.TOXO);
EPSROX = (model_.EPSROXO);
{
double value_log_0 = log((1.0+(WE/(model_.WSEG_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEG_i))));
NSUB0e = ((model_.NSUBO_i)*(((1.0+(((model_.NSUBW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.NSUBW)*iWE)*value_log_1)):1.0E-03));
}
{
double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
NPCKe = ((model_.NPCK_i)*(((1.0+(((model_.NPCKW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.NPCKW)*iWE)*value_log_1)):1.0E-03));
}
{
double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
LPCKe = ((model_.LPCK_i)*(((1.0+(((model_.LPCKW)*iWE)*value_log_0))>1.0E-03)?(1.0+(((model_.LPCKW)*iWE)*value_log_1)):1.0E-03));
}
if ((LE>(2*LPCKe)))
{
AA = 7.5e10;
{
double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
double value_sqrt_1 = sqrt(NSUB0e);
BB = (value_sqrt_0-value_sqrt_1);
}
{
double value_sqrt_0 = sqrt(NSUB0e);
double value_exp_1 = exp((BB/AA));
double value_log_2 = log((1+(((2*LPCKe)/LE)*(value_exp_1-1))));
NSUB = (value_sqrt_0+(AA*value_log_2));
}
NSUB = (NSUB*NSUB);
}
else
{
if ((LE>=LPCKe))
{
NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
}
else
{
NSUB = (NSUB0e+(NPCKe*(2-(LE/LPCKe))));
}
}
NEFF = (NSUB*((1-((model_.FOL1)*iLE))-(((model_.FOL2)*iLE)*iLE)));
VNSUB = (model_.VNSUBO);
NSLP = (model_.NSLPO);
DNSUB = (model_.DNSUBO);
{
double value_pow_0 = pow(iLE,(model_.DPHIBLEXP));
DPHIB = ((((model_.DPHIBO)+((model_.DPHIBL)*value_pow_0))*(1.0+((model_.DPHIBW)*iWE)))*(1.0+(((model_.DPHIBLW)*iLE)*iWE)));
}
NP = ((model_.NPO)*((1e-6>(1.0+((model_.NPL)*iLE)))?1e-6:(1.0+((model_.NPL)*iLE))));
{
double value_pow_0 = pow(iLE,(model_.CTLEXP));
CT = ((((model_.CTO)+((model_.CTL)*value_pow_0))*(1.0+((model_.CTW)*iWE)))*(1.0+(((model_.CTLW)*iLE)*iWE)));
}
TOXOV = (model_.TOXOVO);
TOXOVD = (model_.TOXOVDO);
NOV = (model_.NOVO);
NOVD = (model_.NOVDO);
{
double value_pow_0 = pow(iLE,(model_.CFLEXP));
CF = (((model_.CFL)*value_pow_0)*(1.0+((model_.CFW)*iWE)));
}
CFB = (model_.CFBO);
FBET1e = ((model_.FBET1)*(1.0+((model_.FBET1W)*iWE)));
LP1e = ((model_.LP1_i)*(((1.0+((model_.LP1W)*iWE))>1.0E-03)?(1.0+((model_.LP1W)*iWE)):1.0E-03));
{
double value_exp_0 = exp(((-LE)/LP1e));
double value_exp_1 = exp(((-LE)/(model_.LP2_i)));
GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+((((model_.FBET2)*(model_.LP2_i))/LE)*(1.0-value_exp_1)));
}
GPE = ((GPE>1e-15)?GPE:1e-15);
{
double value_log_0 = log((1.0+(WE/(model_.WBET_i))));
GWE = ((1.0+((model_.BETW1)*iWE))+(((model_.BETW2)*iWE)*value_log_0));
}
BETN = ((((model_.UO)*WE)/(GPE*LE))*GWE);
STBET = ((((model_.STBETO)*(1.0+((model_.STBETL)*iLE)))*(1.0+((model_.STBETW)*iWE)))*(1.0+(((model_.STBETLW)*iLE)*iWE)));
MUE = ((model_.MUEO)*(1.0+((model_.MUEW)*iWE)));
STMUE = (model_.STMUEO);
THEMU = (model_.THEMUO);
STTHEMU = (model_.STTHEMUO);
{
double value_pow_0 = pow(iLE,(model_.CSLEXP));
CS = ((((model_.CSO)+((model_.CSL)*value_pow_0))*(1.0+((model_.CSW)*iWE)))*(1.0+(((model_.CSLW)*iLE)*iWE)));
}
STCS = (model_.STCSO);
XCOR = ((((model_.XCORO)*(1.0+((model_.XCORL)*iLE)))*(1.0+((model_.XCORW)*iWE)))*(1.0+(((model_.XCORLW)*iLE)*iWE)));
STXCOR = (model_.STXCORO);
FETA = (model_.FETAO);
RS = (((model_.RSW1)*iWE)*(1.0+((model_.RSW2)*iWE)));
STRS = (model_.STRSO);
RSB = (model_.RSBO);
RSG = (model_.RSGO);
{
double value_pow_0 = pow(iLE,(model_.THESATLEXP));
THESAT = ((((model_.THESATO)+((((model_.THESATL)*GWE)/GPE)*value_pow_0))*(1.0+((model_.THESATW)*iWE)))*(1.0+(((model_.THESATLW)*iLE)*iWE)));
}
STTHESAT = ((((model_.STTHESATO)*(1.0+((model_.STTHESATL)*iLE)))*(1.0+((model_.STTHESATW)*iWE)))*(1.0+(((model_.STTHESATLW)*iLE)*iWE)));
THESATB = (model_.THESATBO);
THESATG = (model_.THESATGO);
AX = ((model_.AXO)/(1.0+((model_.AXL_i)*iLE)));
{
double value_pow_0 = pow(iLE,(model_.ALPLEXP));
ALP = (((model_.ALPL)*value_pow_0)*(1.0+((model_.ALPW)*iWE)));
}
{
double value_pow_0 = pow(iLE,(model_.ALP1LEXP));
tmpx = value_pow_0;
}
ALP1 = ((((model_.ALP1L1)*tmpx)*(1.0+((model_.ALP1W)*iWE)))/(1.0+(((model_.ALP1L2_i)*iLE)*tmpx)));
{
double value_pow_0 = pow(iLE,(model_.ALP2LEXP));
tmpx = value_pow_0;
}
ALP2 = ((((model_.ALP2L1)*tmpx)*(1.0+((model_.ALP2W)*iWE)))/(1.0+(((model_.ALP2L2_i)*iLE)*tmpx)));
VP = (model_.VPO);
A1 = (((model_.A1O)*(1.0+((model_.A1L)*iLE)))*(1.0+((model_.A1W)*iWE)));
A2 = (model_.A2O);
STA2 = (model_.STA2O);
A3 = (((model_.A3O)*(1.0+((model_.A3L)*iLE)))*(1.0+((model_.A3W)*iWE)));
A4 = (((model_.A4O)*(1.0+((model_.A4L)*iLE)))*(1.0+((model_.A4W)*iWE)));
GCO = (model_.GCOO);
IGINV = ((model_.IGINVLW)/(iWE*iLE));
IGOV = (((model_.IGOVW)*(model_.LOV_i))/(LEN*iWE));
IGOVD = (((model_.IGOVDW)*(model_.LOVD_i))/(LEN*iWE));
STIG = (model_.STIGO);
GC2 = (model_.GC2O);
GC3 = (model_.GC3O);
CHIB = (model_.CHIBO);
AGIDL = (((model_.AGIDLW)*(model_.LOV_i))/(LEN*iWE));
AGIDLD = (((model_.AGIDLDW)*(model_.LOVD_i))/(LEN*iWE));
BGIDL = (model_.BGIDLO);
BGIDLD = (model_.BGIDLDO);
STBGIDL = (model_.STBGIDLO);
STBGIDLD = (model_.STBGIDLDO);
CGIDL = (model_.CGIDLO);
CGIDLD = (model_.CGIDLDO);
COX = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*LEcv)/(model_.TOX_i));
CGOV = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*(model_.LOV_i))/(model_.TOXOV_i));
CGOVD = ((((8.8541878176E-12*(model_.EPSROX_i))*WEcv)*(model_.LOVD_i))/(model_.TOXOVD_i));
CGBOV = (((model_.CGBOVL)*Lcv)/LEN);
CFR = (((model_.CFRW)*Wcv)/WEN);
CFRD = (((model_.CFRDW)*Wcv)/WEN);
temp0 = (1.0-(((2.0*(model_.LINTNOI))*iLE)/LEN));
Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
{
double value_pow_0 = pow(Lnoi,(model_.ALPNOI));
Lred = (1.0/value_pow_0);
}
FNT = (model_.FNTO);
FNTEXC = (((((model_.FNTEXCL)*BETN)*BETN)*iWE)*iWE);
NFA = (((Lred*iWE)*iLE)*(model_.NFALW));
NFB = (((Lred*iWE)*iLE)*(model_.NFBLW));
NFC = (((Lred*iWE)*iLE)*(model_.NFCLW));
EF = (model_.EFO);
KVTHOWE = ((((model_.KVTHOWEO)+((model_.KVTHOWEL)*iLE))+((model_.KVTHOWEW)*iWE))+(((model_.KVTHOWELW)*iLE)*iWE));
KUOWE = ((((model_.KUOWEO)+((model_.KUOWEL)*iLE))+((model_.KUOWEW)*iWE))+(((model_.KUOWELW)*iLE)*iWE));
RG = ((((RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+(((model_.RINT_i)+(model_.RVPOLY_i))/(W_f*L_f)))+(NF_i*(model_.RGO)));
RWELL = (NF_i*(model_.RWELLO));
RBULK = (NF_i*(model_.RBULKO));
RJUNS = (NF_i*(model_.RJUNSO));
RJUND = (NF_i*(model_.RJUNDO));
tmpa = 0.0;
tmpb = 0.0;
loop = 0.0;
if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
{
while ((loop<(NF_i-0.5)))
{
tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
loop = (loop+1.0);
}
Invsa = (tmpa*invNF);
Invsb = (tmpb*invNF);
Invsaref = (1.0/((model_.SAREF_i)+(0.5*L_i)));
Invsbref = (1.0/((model_.SBREF_i)+(0.5*L_i)));
Lx = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
Wx = ((((W_i+delWOD)+(model_.WLOD))>1e-9)?((W_i+delWOD)+(model_.WLOD)):1e-9);
{
double value_pow_0 = pow(Lx,(model_.LLODKUO_i));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODKUO_i));
tempw = (1.0/value_pow_0);
}
Kstressu0 = ((((1.0+((model_.LKUO)*templ))+((model_.WKUO)*tempw))+(((model_.PKUO)*templ)*tempw))*(1.0+((model_.TKUO)*((model_.rT)-1.0))));
rhobeta = (((model_.KUO)*(Invsa+Invsb))/Kstressu0);
rhobetaref = (((model_.KUO)*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,(model_.LLODVTH_i));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODVTH_i));
tempw = (1.0/value_pow_0);
}
Kstressvth0 = (((1.0+((model_.LKVTHO)*templ))+((model_.WKVTHO)*tempw))+(((model_.PKVTHO)*templ)*tempw));
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
BETN = ((BETN*(1.0+rhobeta))/(1.0+rhobetaref));
THESAT = (((THESAT*(1.0+rhobeta))*(1.0+((model_.KVSAT_i)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.KVSAT_i)*rhobeta))));
VFB = (VFB+(((model_.KVTHO)*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
CF = (CF+(((model_.STETAO)*temp0)/value_pow_0));
}
}
if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
{
if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
{
temp0 = (SC_i+W_i);
temp00 = (1.0/(model_.SCREF_i));
SCA_i = (((model_.SCREF_i)*(model_.SCREF_i))/(SC_i*temp0));
{
double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
double value_exp_1 = exp((((-10.0)*temp0)*temp00));
SCB_i = (((((0.1*SC_i)+(0.01*(model_.SCREF_i)))*value_exp_0)-(((0.1*temp0)+(0.01*(model_.SCREF_i)))*value_exp_1))/W_i);
}
{
double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
double value_exp_1 = exp((((-20.0)*temp0)*temp00));
SCC_i = (((((0.05*SC_i)+(0.0025*(model_.SCREF_i)))*value_exp_0)-(((0.05*temp0)+(0.0025*(model_.SCREF_i)))*value_exp_1))/W_i);
}
}
temp0 = ((SCA_i+((model_.WEB_i)*SCB_i))+((model_.WEC_i)*SCC_i));
VFB = (VFB+(KVTHOWE*temp0));
BETN = (BETN*(1.0+(KUOWE*temp0)));
}
VFB_i = VFB;
STVFB_i = STVFB;
(model_.TOX_i) = ((TOX>1e-10)?TOX:1e-10);
(model_.EPSROX_i) = ((EPSROX>1.0)?EPSROX:1.0);
NEFF_i = ((NEFF>1e20)?((NEFF<1e26)?NEFF:1e26):1e20);
VNSUB_i = VNSUB;
NSLP_i = ((NSLP>1e-3)?NSLP:1e-3);
DNSUB_i = ((DNSUB>0.0)?((DNSUB<1.0)?DNSUB:1.0):0.0);
DPHIB_i = DPHIB;
NP_i = ((NP>0.0)?NP:0.0);
QMC_i = (((model_.QMC)>0.0)?(model_.QMC):0.0);
CT_i = ((CT>0.0)?CT:0.0);
(model_.TOXOV_i) = ((TOXOV>1e-10)?TOXOV:1e-10);
(model_.TOXOVD_i) = ((TOXOVD>1e-10)?TOXOVD:1e-10);
NOV_i = ((NOV>1e20)?((NOV<1e27)?NOV:1e27):1e20);
NOVD_i = ((NOVD>1e20)?((NOVD<1e27)?NOVD:1e27):1e20);
CF_i = ((CF>0.0)?CF:0.0);
CFB_i = ((CFB>0.0)?((CFB<1.0)?CFB:1.0):0.0);
BETN_i = ((BETN>0.0)?BETN:0.0);
STBET_i = STBET;
MUE_i = ((MUE>0.0)?MUE:0.0);
STMUE_i = STMUE;
THEMU_i = ((THEMU>0.0)?THEMU:0.0);
STTHEMU_i = STTHEMU;
CS_i = ((CS>0.0)?CS:0.0);
STCS_i = STCS;
XCOR_i = ((XCOR>0.0)?XCOR:0.0);
STXCOR_i = STXCOR;
FETA_i = ((FETA>0.0)?FETA:0.0);
RS_i = ((RS>0.0)?RS:0.0);
STRS_i = STRS;
RSB_i = ((RSB>(-0.5))?((RSB<1.0)?RSB:1.0):(-0.5));
RSG_i = ((RSG>(-0.5))?RSG:(-0.5));
THESAT_i = ((THESAT>0.0)?THESAT:0.0);
STTHESAT_i = STTHESAT;
THESATB_i = ((THESATB>(-0.5))?((THESATB<1.0)?THESATB:1.0):(-0.5));
THESATG_i = ((THESATG>(-0.5))?THESATG:(-0.5));
AX_i = ((AX>2.0)?AX:2.0);
ALP_i = ((ALP>0.0)?ALP:0.0);
ALP1_i = ((ALP1>0.0)?ALP1:0.0);
ALP2_i = ((ALP2>0.0)?ALP2:0.0);
VP_i = ((VP>1.0e-10)?VP:1.0e-10);
A1_i = ((A1>0.0)?A1:0.0);
A2_i = ((A2>0.0)?A2:0.0);
STA2_i = STA2;
A3_i = ((A3>0.0)?A3:0.0);
A4_i = ((A4>0.0)?A4:0.0);
GCO_i = ((GCO>(-10.0))?((GCO<10.0)?GCO:10.0):(-10.0));
IGINV_i = ((IGINV>0.0)?IGINV:0.0);
IGOV_i = ((IGOV>0.0)?IGOV:0.0);
IGOVD_i = ((IGOVD>0.0)?IGOVD:0.0);
STIG_i = STIG;
GC2_i = ((GC2>0.0)?((GC2<10.0)?GC2:10.0):0.0);
GC3_i = ((GC3>(-10.0))?((GC3<10.0)?GC3:10.0):(-10.0));
CHIB_i = ((CHIB>1.0)?CHIB:1.0);
AGIDL_i = ((AGIDL>0.0)?AGIDL:0.0);
AGIDLD_i = ((AGIDLD>0.0)?AGIDLD:0.0);
BGIDL_i = ((BGIDL>0.0)?BGIDL:0.0);
BGIDLD_i = ((BGIDLD>0.0)?BGIDLD:0.0);
STBGIDL_i = STBGIDL;
STBGIDLD_i = STBGIDLD;
CGIDL_i = CGIDL;
CGIDLD_i = CGIDLD;
COX_i = ((COX>0.0)?COX:0.0);
CGOV_i = ((CGOV>0.0)?CGOV:0.0);
CGOVD_i = ((CGOVD>0.0)?CGOVD:0.0);
CGBOV_i = ((CGBOV>0.0)?CGBOV:0.0);
CFR_i = ((CFR>0.0)?CFR:0.0);
CFRD_i = ((CFRD>0.0)?CFRD:0.0);
FNT_i = ((FNT>0.0)?FNT:0.0);
FNTEXC_i = ((FNTEXC>0.0)?FNTEXC:0.0);
NFA_i = ((NFA>0.0)?NFA:0.0);
NFB_i = ((NFB>0.0)?NFB:0.0);
NFC_i = ((NFC>0.0)?NFC:0.0);
EF_i = ((EF>0.0)?EF:0.0);
FACTUO_i = ((FACTUO>0.0)?FACTUO:0.0);
DELVTO_i = DELVTO;
RG_i = ((RG>0.0)?RG:0.0);
RBULK_i = ((RBULK>0.0)?RBULK:0.0);
RJUNS_i = ((RJUNS>0.0)?RJUNS:0.0);
RJUND_i = ((RJUND>0.0)?RJUND:0.0);
RWELL_i = ((RWELL>0.0)?RWELL:0.0);
MULT_i = (((MULT*NF_i)>0.0)?(MULT*NF_i):0.0);
if (((model_.SWJUNASYM)==0.0))
{
(model_.TOXOVD_i) = (model_.TOXOV_i);
NOVD_i = NOV_i;
AGIDLD_i = AGIDL_i;
BGIDLD_i = BGIDL_i;
STBGIDLD_i = STBGIDL_i;
CGIDLD_i = CGIDL_i;
IGOVD_i = IGOV_i;
CGOVD_i = CGOV_i;
CFRD_i = CFR_i;
}
if (((((model_.SWJUNCAP)==1.0)||((model_.SWJUNCAP)==2.0))||((model_.SWJUNCAP)==3.0)))
{
ABSOURCE_i = ((ABS_i>0)?ABS_i:0);
LSSOURCE_i = ((LSS_i>0)?LSS_i:0);
LGSOURCE_i = ((LGS_i>0)?LGS_i:0);
ABDRAIN_i = ((ABD_i>0)?ABD_i:0);
LSDRAIN_i = ((LSD_i>0)?LSD_i:0);
LGDRAIN_i = ((LGD_i>0)?LGD_i:0);
}
else
{
ABSOURCE_i = 0.0;
LSSOURCE_i = 0.0;
LGSOURCE_i = 0.0;
ABDRAIN_i = 0.0;
LSDRAIN_i = 0.0;
LGDRAIN_i = 0.0;
}
EPSOX = (8.8541878176E-12*(model_.EPSROX_i));
phit1 = ((model_.phit)*(1.0+(CT_i*(model_.rTn))));
inv_phit1 = (1.0/phit1);
VFB_i = ((VFB_i+(STVFB_i*(model_.dT)))+DELVTO_i);
{
double value_pow_0 = pow((model_.phibFac),(-0.75));
double value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
phib = (((model_.Eg)+DPHIB_i)+((2.0*(model_.phit))*value_log_1));
}
phib = ((phib>5.0E-2)?phib:5.0E-2);
CoxPrime = (EPSOX/(model_.TOX_i));
tox_sq = ((model_.TOX_i)*(model_.TOX_i));
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*(model_.EPSSI))*(model_.inv_phit)));
G_0 = (value_sqrt_0/CoxPrime);
}
kp = 0.0;
if ((NP_i>0.0))
{
arg2max = (8.0e7/tox_sq);
np = ((NP_i>arg2max)?NP_i:arg2max);
np = ((5.0e24>np)?5.0e24:np);
kp = ((((2.0*CoxPrime)*CoxPrime)*(model_.phit))/((1.6021918E-19*np)*(model_.EPSSI)));
}
qlim2 = ((100.0*(model_.phit))*(model_.phit));
qq = 0.0;
if ((QMC_i>0.0))
{
{
double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
qq = (((0.4*5.951993)*QMC_i)*value_pow_0);
}
if (((model_.CHNL_TYPE)==(-1)))
{
qq = ((7.448711/5.951993)*qq);
}
{
double value_sqrt_0 = sqrt(((((model_.phit)*G_0)*G_0)*phib));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
dphibq = ((0.75*qq)*value_pow_0);
}
phib = (phib+dphibq);
G_0 = (G_0*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
{
double value_sqrt_0 = sqrt(phib);
sqrt_phib = value_sqrt_0;
}
phix = (0.95*phib);
aphi = ((0.0025*phib)*phib);
bphi = aphi;
{
double value_sqrt_0 = sqrt(bphi);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((phix-phix2))*((phix-phix2)))+aphi));
phix1 = (0.5*((phix-phix2)-value_sqrt_0));
}
CoxovPrime = (EPSOX/(model_.TOXOV_i));
CoxovPrime_d = (EPSOX/(model_.TOXOVD_i));
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*(model_.EPSSI))*(model_.inv_phit)));
GOV_s = (value_sqrt_0/CoxovPrime);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*(model_.EPSSI))*(model_.inv_phit)));
GOV_d = (value_sqrt_0/CoxovPrime_d);
}
GOV2_s = (GOV_s*GOV_s);
GOV2_d = (GOV_d*GOV_d);
xi_ov_s = (1.0+(GOV_s*7.0710678118654746e-01));
xi_ov_d = (1.0+(GOV_d*7.0710678118654746e-01));
inv_xi_ov_s = (1.0/xi_ov_s);
inv_xi_ov_d = (1.0/xi_ov_d);
x_mrg_ov_s = (1.0e-5*xi_ov_s);
x_mrg_ov_d = (1.0e-5*xi_ov_d);
{
double value_pow_0 = pow((model_.rTn),STBET_i);
tf_bet = value_pow_0;
}
BET_i = (((FACTUO_i*BETN_i)*CoxPrime)*tf_bet);
BETN_i = (BETN_i*tf_bet);
{
double value_pow_0 = pow((model_.rTn),STTHEMU_i);
THEMU_i = (THEMU_i*value_pow_0);
}
{
double value_pow_0 = pow((model_.rTn),STMUE_i);
tf_mue = value_pow_0;
}
MUE_i = (MUE_i*tf_mue);
{
double value_pow_0 = pow((model_.rTn),STCS_i);
tf_cs = value_pow_0;
}
CS_i = (CS_i*tf_cs);
{
double value_pow_0 = pow((model_.rTn),STXCOR_i);
tf_xcor = value_pow_0;
}
XCOR_i = (XCOR_i*tf_xcor);
E_eff0 = ((1.0e-8*CoxPrime)/(model_.EPSSI));
eta_mu = (0.5*FETA_i);
if (((model_.CHNL_TYPE)==(-1)))
{
eta_mu = (3.3333333333333333e-01*FETA_i);
}
{
double value_pow_0 = pow((model_.rTn),STRS_i);
tf_ther = value_pow_0;
}
RS_i = (RS_i*tf_ther);
THER_i = ((2*BET_i)*RS_i);
{
double value_pow_0 = pow((model_.rTn),STTHESAT_i);
tf_thesat = value_pow_0;
}
THESAT_i = (THESAT_i*tf_thesat);
Vdsat_lim = (3.912023005*phit1);
inv_AX = (1.0/AX_i);
inv_VP = (1.0/VP_i);
{
double value_pow_0 = pow((model_.rT),STA2_i);
A2_i = (A2_i*value_pow_0);
}
{
double value_pow_0 = pow((model_.rT),STIG_i);
tf_ig = value_pow_0;
}
IGINV_i = (IGINV_i*tf_ig);
IGOV_i = (IGOV_i*tf_ig);
IGOVD_i = (IGOVD_i*tf_ig);
inv_CHIB = (1.0/CHIB_i);
{
double value_sqrt_0 = sqrt((((2*1.6021918E-19)*9.1093826E-31)*CHIB_i));
tempM = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
}
BCH = (tempM*(model_.TOX_i));
BOV = (tempM*(model_.TOXOV_i));
BOV_d = (tempM*(model_.TOXOVD_i));
GCQ = 0;
if ((GC3_i<0))
{
GCQ = (((-0.495)*GC2_i)/GC3_i);
}
alpha_b = (0.5*(phib+(model_.Eg)));
Dch = (GCO_i*phit1);
Dov = (GCO_i*(model_.phit));
AGIDLs = ((AGIDL_i*4e-18)/((model_.TOXOV_i)*(model_.TOXOV_i)));
AGIDLDs = ((AGIDLD_i*4e-18)/((model_.TOXOVD_i)*(model_.TOXOVD_i)));
tempM = (((1.0+(STBGIDL_i*(model_.dT)))>0)?(1.0+(STBGIDL_i*(model_.dT))):0);
BGIDL_T = (BGIDL_i*tempM);
BGIDLs = ((BGIDL_T*(model_.TOXOV_i))*5e8);
tempM = (((1.0+(STBGIDLD_i*(model_.dT)))>0)?(1.0+(STBGIDLD_i*(model_.dT))):0);
BGIDLD_T = (BGIDLD_i*tempM);
BGIDLDs = ((BGIDLD_T*(model_.TOXOVD_i))*5e8);
nt = (((FNT_i*4)*1.3806505E-23)*(model_.TKD));
Cox_over_q = (CoxPrime/1.6021918E-19);
Sfl_prefac = ((((model_.phit)*(model_.phit))*BET_i)/Cox_over_q);
fac_exc = ((9.1093826E-31*1e9)*FNTEXC_i);
x1 = 1.25;
inv_xg1_s = (1.0/(x1+(GOV_s*7.324648775608221e-1)));
inv_xg1_d = (1.0/(x1+(GOV_d*7.324648775608221e-1)));
if ((RG_i>0.0))
{
ggate = (1.0/RG_i);
}
else
{
ggate = 0.0;
}
if ((RBULK_i>0.0))
{
gbulk = (1.0/RBULK_i);
}
else
{
gbulk = 0.0;
}
if ((RJUNS_i>0.0))
{
gjuns = (1.0/RJUNS_i);
}
else
{
gjuns = 0.0;
}
if ((RJUND_i>0.0))
{
gjund = (1.0/RJUND_i);
}
else
{
gjund = 0.0;
}
if ((RWELL_i>0.0))
{
gwell = (1.0/RWELL_i);
}
else
{
gwell = 0.0;
}
vbimin_s = 0.0;
vbimin_d = 0.0;
vfmin_s = 0.0;
vfmin_d = 0.0;
vch_s = 0.0;
vch_d = 0.0;
vbbtlim_s = 0.0;
vbbtlim_d = 0.0;
VMAX_s = 0.0;
VMAX_d = 0.0;
exp_VMAX_over_phitd_s = 0.0;
exp_VMAX_over_phitd_d = 0.0;
ISATFOR1_s = 0.0;
ISATFOR1_d = 0.0;
MFOR1_s = 1.0;
MFOR1_d = 1.0;
ISATFOR2_s = 0.0;
ISATFOR2_d = 0.0;
MFOR2_s = 1.0;
MFOR2_d = 1.0;
ISATREV_s = 0.0;
ISATREV_d = 0.0;
MREV_s = 1.0;
MREV_d = 1.0;
m0flag_s = 0.0;
m0flag_d = 0.0;
xhighf1_s = 0.0;
xhighf1_d = 0.0;
expxhf1_s = 0.0;
expxhf1_d = 0.0;
xhighf2_s = 0.0;
xhighf2_d = 0.0;
expxhf2_s = 0.0;
expxhf2_d = 0.0;
xhighr_s = 0.0;
xhighr_d = 0.0;
expxhr_s = 0.0;
expxhr_d = 0.0;
zflagbot_s = 1.0;
zflagbot_d = 1.0;
zflagsti_s = 1.0;
zflagsti_d = 1.0;
zflaggat_s = 1.0;
zflaggat_d = 1.0;
m0_rev = 0.0;
mcor_rev = 0.0;
I1_cor = 0.0;
I2_cor = 0.0;
I3_cor = 0.0;
I4_cor = 0.0;
I5_cor = 0.0;
tt0 = 0.0;
tt1 = 0.0;
tt2 = 0.0;
zfrac = 0.0;
alphaje = 0.0;
if (((model_.SWJUNCAP)>0))
{
if ((((model_.idsatbot)*ABSOURCE_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot)*ABSOURCE_i))+1));
vmaxbot = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxbot = 1E8;
}
if ((((model_.idsatsti)*LSSOURCE_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti)*LSSOURCE_i))+1));
vmaxsti = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxsti = 1E8;
}
if ((((model_.idsatgat)*LGSOURCE_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat)*LGSOURCE_i))+1));
vmaxgat = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
VMAX_s = value_min_1;
}
if ((fabs((VMAX_s*(model_.phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((VMAX_s*(model_.phitdinv)));
exp_VMAX_over_phitd_s = value_exp_0;
}
}
else
{
if (((VMAX_s*(model_.phitdinv))<(-2.3025850929940458e+02)))
{
exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
vbibot2 = (model_.vbibot);
vbisti2 = (model_.vbisti);
vbigat2 = (model_.vbigat);
pbot2 = (model_.PBOT_i);
psti2 = (model_.PSTI_i);
pgat2 = (model_.PGAT_i);
vbibot2r = (model_.VBIRBOT_i);
vbisti2r = (model_.VBIRSTI_i);
vbigat2r = (model_.VBIRGAT_i);
if ((ABSOURCE_i==0))
{
vbibot2 = ((model_.vbisti)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PSTI_i),(model_.PGAT_i));
pbot2 = (0.9*value_min_0);
}
vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
}
if ((LSSOURCE_i==0))
{
vbisti2 = ((model_.vbibot)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PGAT_i));
psti2 = (0.9*value_min_0);
}
vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
}
if ((LGSOURCE_i==0))
{
vbigat2 = ((model_.vbibot)+(model_.vbisti));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PSTI_i));
pgat2 = (0.9*value_min_0);
}
vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
vbimin_s = value_min_1;
}
vch_s = (vbimin_s*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
vfmin_s = (vbimin_s*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
vbbtlim_s = (value_min_1-0.050);
}
if ((((model_.idsatbot_d)*ABDRAIN_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot_d)*ABDRAIN_i))+1));
vmaxbot = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxbot = 1E8;
}
if ((((model_.idsatsti_d)*LSDRAIN_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti_d)*LSDRAIN_i))+1));
vmaxsti = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxsti = 1E8;
}
if ((((model_.idsatgat_d)*LGDRAIN_i)>0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat_d)*LGDRAIN_i))+1));
vmaxgat = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
VMAX_d = value_min_1;
}
if ((fabs((VMAX_d*(model_.phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((VMAX_d*(model_.phitdinv)));
exp_VMAX_over_phitd_d = value_exp_0;
}
}
else
{
if (((VMAX_d*(model_.phitdinv))<(-2.3025850929940458e+02)))
{
exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
vbibot2 = (model_.vbibot_d);
vbisti2 = (model_.vbisti_d);
vbigat2 = (model_.vbigat_d);
pbot2 = (model_.PBOTD_i);
psti2 = (model_.PSTID_i);
pgat2 = (model_.PGATD_i);
vbibot2r = (model_.VBIRBOTD_i);
vbisti2r = (model_.VBIRSTID_i);
vbigat2r = (model_.VBIRGATD_i);
if ((ABDRAIN_i==0))
{
vbibot2 = ((model_.vbisti_d)+(model_.vbigat_d));
{
double value_min_0 = std::min((model_.PSTID_i),(model_.PGATD_i));
pbot2 = (0.9*value_min_0);
}
vbibot2r = ((model_.VBIRSTID_i)+(model_.VBIRGATD_i));
}
if ((LSDRAIN_i==0))
{
vbisti2 = ((model_.vbibot_d)+(model_.vbigat_d));
{
double value_min_0 = std::min((model_.PBOTD_i),(model_.PGATD_i));
psti2 = (0.9*value_min_0);
}
vbisti2r = ((model_.VBIRBOTD_i)+(model_.VBIRGATD_i));
}
if ((LGDRAIN_i==0))
{
vbigat2 = ((model_.vbibot_d)+(model_.vbisti_d));
{
double value_min_0 = std::min((model_.PBOTD_i),(model_.PSTID_i));
pgat2 = (0.9*value_min_0);
}
vbigat2r = ((model_.VBIRBOTD_i)+(model_.VBIRSTID_i));
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
vbimin_d = value_min_1;
}
vch_d = (vbimin_d*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
vfmin_d = (vbimin_d*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
vbbtlim_d = (value_min_1-0.050);
}
if (((model_.SWJUNEXP_i)==1.0))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double terfc=0.0;
double erfcpos=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double h2=0.0;
double h2d=0.0;
double h3=0.0;
double h4=0.0;
double h5=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double idmult=0.0;
double vj=0.0;
double z=0.0;
double zinv=0.0;
double two_psistar=0.0;
double vjlim=0.0;
double vjsrh=0.0;
double vbbt=0.0;
double vav=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double id=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double vbi_minus_vjsrh=0.0;
double wsrhstep=0.0;
double dwsrh=0.0;
double wsrh=0.0;
double wdep=0.0;
double asrh=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double btat=0.0;
double twoatatoverthreebtat=0.0;
double umaxbeforelimiting=0.0;
double umax=0.0;
double sqrtumax=0.0;
double umaxpoweronepointfive=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double wtat=0.0;
double ktat=0.0;
double ltat=0.0;
double mtat=0.0;
double xerfc=0.0;
double erfctimesexpmtat=0.0;
double gammamax=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double Fmaxr=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ijunbot=0.0;
double ijunsti=0.0;
double ijungat=0.0;
double qjunbot=0.0;
double qjunsti=0.0;
double qjungat=0.0;
//End of Block-local variables
ysq = 0.0;
terfc = 0.0;
erfcpos = 0.0;
h1 = 0.0;
h2 = 0.0;
h2d = 0.0;
h3 = 0.0;
h4 = 0.0;
h5 = 0.0;
idmult = 0.0;
vj = 0.0;
z = 0.0;
zinv = 0.0;
two_psistar = 0.0;
vjlim = 0.0;
vjsrh = 0.0;
vbbt = 0.0;
vav = 0.0;
tmp = 0.0;
id = 0.0;
isrh = 0.0;
vbi_minus_vjsrh = 0.0;
wsrhstep = 0.0;
dwsrh = 0.0;
wsrh = 0.0;
wdep = 0.0;
asrh = 0.0;
itat = 0.0;
btat = 0.0;
twoatatoverthreebtat = 0.0;
umaxbeforelimiting = 0.0;
umax = 0.0;
sqrtumax = 0.0;
umaxpoweronepointfive = 0.0;
wgamma = 0.0;
wtat = 0.0;
ktat = 0.0;
ltat = 0.0;
mtat = 0.0;
xerfc = 0.0;
erfctimesexpmtat = 0.0;
gammamax = 0.0;
ibbt = 0.0;
Fmaxr = 0.0;
fbreakdown = 0.0;
qjunbot = 0.0;
qjunsti = 0.0;
qjungat = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
V1 = ((-FRACNA)*(model_.VJUNREF_i));
V2 = ((-FRACNB)*(model_.VJUNREF_i));
V3 = ((-FRACI)*(model_.VJUNREF_i));
V4 = 0.1;
V5 = 0.2;
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V1+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V1*vfmin_s)/(h3+h5)));
if ((V1<VMAX_s))
{
if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V1-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-vbbtlim_s)*(V1-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V1+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V1-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V1-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V1-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I1 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V2+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V2*vfmin_s)/(h3+h5)));
if ((V2<VMAX_s))
{
if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V2-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-vbbtlim_s)*(V2-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V2+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V2-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V2-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V2-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I2 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V3+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V3*vfmin_s)/(h3+h5)));
if ((V3<VMAX_s))
{
if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V3-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-vbbtlim_s)*(V3-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V3+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V3-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V3-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V3-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I3 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V4+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V4*vfmin_s)/(h3+h5)));
if ((V4<VMAX_s))
{
if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V4-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-vbbtlim_s)*(V4-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V4+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V4-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V4-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V4-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I4 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V5+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V5*vfmin_s)/(h3+h5)));
if ((V5<VMAX_s))
{
if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V5-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-vbbtlim_s)*(V5-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V5+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(V5-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(V5-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(V5-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I5 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
ISATFOR1_s = (((ABSOURCE_i*(model_.idsatbot))+(LSSOURCE_i*(model_.idsatsti)))+(LGSOURCE_i*(model_.idsatgat)));
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_s));
I4_cor = (I4-(ISATFOR1_s*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_s));
I5_cor = (I5-(ISATFOR1_s*(value_exp_0-1.0)));
}
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
MFOR2_s = (((model_.phitd)*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_s));
ISATFOR2_s = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_s));
I1_cor = ((I1-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_s));
I2_cor = ((I2-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_s));
I3_cor = ((I3-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
}
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
tt1 = (((model_.phitd)*(alphaje-1))*(value_pow_0-1));
}
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
mcor_rev = (tt1/tt2);
MREV_s = (m0_rev+mcor_rev);
if ((fabs(((V3*(model_.phitdinv))*MREV_s))<1e-6))
{
m0flag_s = 1.0;
ISATREV_s = (I3_cor*((1/V3)+((0.5*(model_.phitdinv))*MREV_s)));
MREV_s = (((((-0.5)*I3_cor)*MREV_s)*(model_.phitdinv))/V3);
}
else
{
m0flag_s = 0.0;
{
double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_s));
ISATREV_s = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
zfrac = ((model_.FJUNQ_i)*(((ABSOURCE_i*(model_.cjobot))+(LSSOURCE_i*(model_.cjosti)))+(LGSOURCE_i*(model_.cjogat))));
if (((ABSOURCE_i*(model_.cjobot))<=zfrac))
{
zflagbot_s = 0.0;
}
if (((LSSOURCE_i*(model_.cjosti))<=zfrac))
{
zflagsti_s = 0.0;
}
if (((LGSOURCE_i*(model_.cjogat))<=zfrac))
{
zflaggat_s = 0.0;
}
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_s+1e-21)));
xhighf1_s = value_log_0;
}
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_s+1e-21)));
xhighf2_s = value_log_0;
}
{
double value_fabs_0 = fabs(ISATREV_s);
double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1e-21)));
xhighr_s = value_log_1;
}
}
{
double value_min_0 = std::min(xhighf1_s,static_cast<double>(2.3025850929940458e+02));
xhighf1_s = value_min_0;
}
{
double value_exp_0 = exp(xhighf1_s);
expxhf1_s = value_exp_0;
}
{
double value_min_0 = std::min(xhighf2_s,static_cast<double>(2.3025850929940458e+02));
xhighf2_s = value_min_0;
}
{
double value_exp_0 = exp(xhighf2_s);
expxhf2_s = value_exp_0;
}
{
double value_min_0 = std::min(xhighr_s,static_cast<double>(2.3025850929940458e+02));
xhighr_s = value_min_0;
}
{
double value_exp_0 = exp(xhighr_s);
expxhr_s = value_exp_0;
}
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
V1 = ((-FRACNA)*(model_.VJUNREFD_i));
V2 = ((-FRACNB)*(model_.VJUNREFD_i));
V3 = ((-FRACI)*(model_.VJUNREFD_i));
V4 = 0.1;
V5 = 0.2;
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V1+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V1*vfmin_d)/(h3+h5)));
if ((V1<VMAX_d))
{
if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V1-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-vbbtlim_d)*(V1-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V1+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V1-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V1-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V1-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I1 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V2+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V2*vfmin_d)/(h3+h5)));
if ((V2<VMAX_d))
{
if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V2-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-vbbtlim_d)*(V2-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V2+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V2-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V2-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V2-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I2 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V3+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V3*vfmin_d)/(h3+h5)));
if ((V3<VMAX_d))
{
if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V3-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-vbbtlim_d)*(V3-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V3+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V3-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V3-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V3-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I3 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V4+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V4*vfmin_d)/(h3+h5)));
if ((V4<VMAX_d))
{
if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V4-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-vbbtlim_d)*(V4-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V4+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V4-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V4-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V4-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I4 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V5+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V5*vfmin_d)/(h3+h5)));
if ((V5<VMAX_d))
{
if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1+((V5-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-vbbtlim_d)*(V5-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V5+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{
ijunbot = 0;
qjunbot = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(V5-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{
ijunsti = 0;
qjunsti = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(V5-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{
ijungat = 0;
qjungat = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(V5-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{
isrh = 0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{
itat = 0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1/(1-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I5 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
ISATFOR1_d = (((ABDRAIN_i*(model_.idsatbot_d))+(LSDRAIN_i*(model_.idsatsti_d)))+(LGDRAIN_i*(model_.idsatgat_d)));
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_d));
I4_cor = (I4-(ISATFOR1_d*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_d));
I5_cor = (I5-(ISATFOR1_d*(value_exp_0-1.0)));
}
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
MFOR2_d = (((model_.phitd)*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_d));
ISATFOR2_d = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_d));
I1_cor = ((I1-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_d));
I2_cor = ((I2-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_d));
I3_cor = ((I3-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
}
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
tt1 = (((model_.phitd)*(alphaje-1))*(value_pow_0-1));
}
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
mcor_rev = (tt1/tt2);
MREV_d = (m0_rev+mcor_rev);
if ((fabs(((V3*(model_.phitdinv))*MREV_d))<1e-6))
{
m0flag_d = 1.0;
ISATREV_d = (I3_cor*((1/V3)+((0.5*(model_.phitdinv))*MREV_d)));
MREV_d = (((((-0.5)*I3_cor)*MREV_d)*(model_.phitdinv))/V3);
}
else
{
m0flag_d = 0.0;
{
double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_d));
ISATREV_d = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
zfrac = ((model_.FJUNQD_i)*(((ABDRAIN_i*(model_.cjobot_d))+(LSDRAIN_i*(model_.cjosti_d)))+(LGDRAIN_i*(model_.cjogat_d))));
if (((ABDRAIN_i*(model_.cjobot_d))<=zfrac))
{
zflagbot_d = 0.0;
}
if (((LSDRAIN_i*(model_.cjosti_d))<=zfrac))
{
zflagsti_d = 0.0;
}
if (((LGDRAIN_i*(model_.cjogat_d))<=zfrac))
{
zflaggat_d = 0.0;
}
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_d+1e-21)));
xhighf1_d = value_log_0;
}
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_d+1e-21)));
xhighf2_d = value_log_0;
}
{
double value_fabs_0 = fabs(ISATREV_d);
double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1e-21)));
xhighr_d = value_log_1;
}
}
{
double value_min_0 = std::min(xhighf1_d,static_cast<double>(2.3025850929940458e+02));
xhighf1_d = value_min_0;
}
{
double value_exp_0 = exp(xhighf1_d);
expxhf1_d = value_exp_0;
}
{
double value_min_0 = std::min(xhighf2_d,static_cast<double>(2.3025850929940458e+02));
xhighf2_d = value_min_0;
}
{
double value_exp_0 = exp(xhighf2_d);
expxhf2_d = value_exp_0;
}
{
double value_min_0 = std::min(xhighr_d,static_cast<double>(2.3025850929940458e+02));
xhighr_d = value_min_0;
}
{
double value_exp_0 = exp(xhighr_d);
expxhr_d = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(10e-6),
    W(10e-6),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    DELVTO(0.0),
    FACTUO(1.0),
    ABSOURCE(1E-12),
    LSSOURCE(1E-6),
    LGSOURCE(1E-6),
    ABDRAIN(1E-12),
    LSDRAIN(1E-6),
    LGDRAIN(1E-6),
    AS(1E-12),
    PS(1E-6),
    AD(1E-12),
    PD(1E-6),
    MULT(1.0),
    NF(1.0),
    NGCON(1.0),
    XGW(1.0E-7),
    LE(0.0),
    WE(0.0),
    VFB_i(0.0),
    STVFB_i(0.0),
    NEFF_i(0.0),
    VNSUB_i(0.0),
    NSLP_i(0.0),
    DNSUB_i(0.0),
    NP_i(0.0),
    CT_i(0.0),
    NOV_i(0.0),
    NOVD_i(0.0),
    CF_i(0.0),
    CFB_i(0.0),
    DPHIB_i(0.0),
    BETN_i(0.0),
    STBET_i(0.0),
    MUE_i(0.0),
    STMUE_i(0.0),
    THEMU_i(0.0),
    STTHEMU_i(0.0),
    CS_i(0.0),
    STCS_i(0.0),
    XCOR_i(0.0),
    STXCOR_i(0.0),
    FETA_i(0.0),
    RS_i(0.0),
    THER_i(0.0),
    STRS_i(0.0),
    RSB_i(0.0),
    RSG_i(0.0),
    THESAT_i(0.0),
    STTHESAT_i(0.0),
    THESATB_i(0.0),
    THESATG_i(0.0),
    AX_i(0.0),
    ALP_i(0.0),
    ALP1_i(0.0),
    ALP2_i(0.0),
    VP_i(0.0),
    A1_i(0.0),
    A2_i(0.0),
    STA2_i(0.0),
    A3_i(0.0),
    A4_i(0.0),
    GCO_i(0.0),
    IGINV_i(0.0),
    IGOV_i(0.0),
    IGOVD_i(0.0),
    STIG_i(0.0),
    GC2_i(0.0),
    GC3_i(0.0),
    CHIB_i(0.0),
    AGIDL_i(0.0),
    STBGIDL_i(0.0),
    CGIDL_i(0.0),
    AGIDLD_i(0.0),
    STBGIDLD_i(0.0),
    CGIDLD_i(0.0),
    COX_i(0.0),
    CGOV_i(0.0),
    CGOVD_i(0.0),
    CGBOV_i(0.0),
    CFR_i(0.0),
    CFRD_i(0.0),
    FNT_i(0.0),
    NFA_i(0.0),
    NFB_i(0.0),
    NFC_i(0.0),
    EF_i(0.0),
    FNTEXC_i(0.0),
    MULT_i(0.0),
    BET_i(0.0),
    kp(0.0),
    qq(0.0),
    qlim2(0.0),
    E_eff0(0.0),
    eta_mu(0.0),
    BCH(0.0),
    BOV(0.0),
    inv_CHIB(0.0),
    GCQ(0.0),
    Dch(0.0),
    Dov(0.0),
    x1(0.0),
    Vdsat_lim(0.0),
    nt(0.0),
    Cox_over_q(0.0),
    GOV_s(0.0),
    GOV_d(0.0),
    GOV2_s(0.0),
    GOV2_d(0.0),
    BOV_d(0.0),
    xi_ov_s(0.0),
    xi_ov_d(0.0),
    inv_xi_ov_s(0.0),
    inv_xi_ov_d(0.0),
    x_mrg_ov_s(0.0),
    x_mrg_ov_d(0.0),
    inv_xg1_s(0.0),
    inv_xg1_d(0.0),
    AGIDLs(0.0),
    AGIDLDs(0.0),
    BGIDLs(0.0),
    BGIDLDs(0.0),
    BGIDL_T(0.0),
    BGIDLD_T(0.0),
    phib(0.0),
    sqrt_phib(0.0),
    phix(0.0),
    aphi(0.0),
    bphi(0.0),
    phix1(0.0),
    G_0(0.0),
    phit1(0.0),
    inv_phit1(0.0),
    alpha_b(0.0),
    inv_VP(0.0),
    inv_AX(0.0),
    Sfl_prefac(0.0),
    Sfl(0.0),
    CGeff(0.0),
d_CGeff_dV_D_S(0.0),
d_CGeff_dV_GP_S(0.0),
d_CGeff_dV_S_BP(0.0),
    mig(0.0),
d_mig_dV_D_S(0.0),
d_mig_dV_GP_S(0.0),
d_mig_dV_S_BP(0.0),
    c_igid(0.0),
    sqid(0.0),
    fac_exc(0.0),
    shot_iavl(0.0),
    shot_igcsx(0.0),
    shot_igcdx(0.0),
    shot_igsov(0.0),
    shot_igdov(0.0),
    RG_i(0.0),
    RBULK_i(0.0),
    RWELL_i(0.0),
    RJUNS_i(0.0),
    RJUND_i(0.0),
    ggate(0.0),
    gbulk(0.0),
    gwell(0.0),
    gjund(0.0),
    gjuns(0.0),
    ABSOURCE_i(0.0),
    LSSOURCE_i(0.0),
    LGSOURCE_i(0.0),
    zflagbot_s(0.0),
    zflagsti_s(0.0),
    zflaggat_s(0.0),
    VMAX_s(0.0),
    exp_VMAX_over_phitd_s(0.0),
    vbimin_s(0.0),
    vch_s(0.0),
    vfmin_s(0.0),
    vbbtlim_s(0.0),
    xhighf1_s(0.0),
    expxhf1_s(0.0),
    xhighf2_s(0.0),
    expxhf2_s(0.0),
    xhighr_s(0.0),
    expxhr_s(0.0),
    m0flag_s(0.0),
    ISATFOR1_s(0.0),
    MFOR1_s(0.0),
    ISATFOR2_s(0.0),
    MFOR2_s(0.0),
    ISATREV_s(0.0),
    MREV_s(0.0),
    ABDRAIN_i(0.0),
    LSDRAIN_i(0.0),
    LGDRAIN_i(0.0),
    zflagbot_d(0.0),
    zflagsti_d(0.0),
    zflaggat_d(0.0),
    VMAX_d(0.0),
    exp_VMAX_over_phitd_d(0.0),
    vbimin_d(0.0),
    vch_d(0.0),
    vfmin_d(0.0),
    vbbtlim_d(0.0),
    xhighf1_d(0.0),
    expxhf1_d(0.0),
    xhighf2_d(0.0),
    expxhf2_d(0.0),
    xhighr_d(0.0),
    expxhr_d(0.0),
    m0flag_d(0.0),
    ISATFOR1_d(0.0),
    MFOR1_d(0.0),
    ISATFOR2_d(0.0),
    MFOR2_d(0.0),
    ISATREV_d(0.0),
    MREV_d(0.0),
    jnoisex_s(0.0),
    jnoisex_d(0.0),
    ctype(0.0),
    sdint(0.0),
    ise(0.0),
    ige(0.0),
    ide(0.0),
    ibe(0.0),
    ids(0.0),
    idb(0.0),
    isb(0.0),
    igs(0.0),
    igd(0.0),
    igb(0.0),
    igcs(0.0),
    igcd(0.0),
    iavl(0.0),
    igisl(0.0),
    igidl(0.0),
    ijs(0.0),
    ijsbot(0.0),
    ijsgat(0.0),
    ijssti(0.0),
    ijd(0.0),
    ijdbot(0.0),
    ijdgat(0.0),
    ijdsti(0.0),
    vds(0.0),
    vgs(0.0),
    vsb(0.0),
    vto(0.0),
    vts(0.0),
    vth(0.0),
    vgt(0.0),
    vdss(0.0),
    vsat(0.0),
    gm(0.0),
    gmb(0.0),
    gds(0.0),
    gjs(0.0),
    gjd(0.0),
    cdd(0.0),
    cdg(0.0),
    cds(0.0),
    cdb(0.0),
    cgd(0.0),
    cgg(0.0),
    cgs(0.0),
    cgb(0.0),
    csd(0.0),
    csg(0.0),
    css(0.0),
    csb(0.0),
    cbd(0.0),
    cbg(0.0),
    cbs(0.0),
    cbb(0.0),
    cgsol(0.0),
    cgdol(0.0),
    cjs(0.0),
    cjsbot(0.0),
    cjsgat(0.0),
    cjssti(0.0),
    cjd(0.0),
    cjdbot(0.0),
    cjdgat(0.0),
    cjdsti(0.0),
    weff(0.0),
    leff(0.0),
    u(0.0),
    rout(0.0),
    vearly(0.0),
    beff(0.0),
    fug(0.0),
    rg(0.0),
    sfl(0.0),
    sqrtsff(0.0),
    sqrtsfw(0.0),
    sid(0.0),
    sig(0.0),
    cigid(0.0),
    fknee(0.0),
    sigs(0.0),
    sigd(0.0),
    siavl(0.0),
    ssi(0.0),
    sdi(0.0),
    lp_vfb(0.0),
    lp_stvfb(0.0),
    lp_tox(0.0),
    lp_epsrox(0.0),
    lp_neff(0.0),
    lp_vnsub(0.0),
    lp_nslp(0.0),
    lp_dnsub(0.0),
    lp_dphib(0.0),
    lp_np(0.0),
    lp_ct(0.0),
    lp_toxov(0.0),
    lp_toxovd(0.0),
    lp_nov(0.0),
    lp_novd(0.0),
    lp_cf(0.0),
    lp_cfb(0.0),
    lp_betn(0.0),
    lp_stbet(0.0),
    lp_mue(0.0),
    lp_stmue(0.0),
    lp_themu(0.0),
    lp_stthemu(0.0),
    lp_cs(0.0),
    lp_stcs(0.0),
    lp_xcor(0.0),
    lp_stxcor(0.0),
    lp_feta(0.0),
    lp_rs(0.0),
    lp_strs(0.0),
    lp_rsb(0.0),
    lp_rsg(0.0),
    lp_thesat(0.0),
    lp_stthesat(0.0),
    lp_thesatb(0.0),
    lp_thesatg(0.0),
    lp_ax(0.0),
    lp_alp(0.0),
    lp_alp1(0.0),
    lp_alp2(0.0),
    lp_vp(0.0),
    lp_a1(0.0),
    lp_a2(0.0),
    lp_sta2(0.0),
    lp_a3(0.0),
    lp_a4(0.0),
    lp_gco(0.0),
    lp_iginv(0.0),
    lp_igov(0.0),
    lp_igovd(0.0),
    lp_stig(0.0),
    lp_gc2(0.0),
    lp_gc3(0.0),
    lp_chib(0.0),
    lp_agidl(0.0),
    lp_agidld(0.0),
    lp_bgidl(0.0),
    lp_bgidld(0.0),
    lp_stbgidl(0.0),
    lp_stbgidld(0.0),
    lp_cgidl(0.0),
    lp_cgidld(0.0),
    lp_cox(0.0),
    lp_cgov(0.0),
    lp_cgovd(0.0),
    lp_cgbov(0.0),
    lp_cfr(0.0),
    lp_cfrd(0.0),
    lp_fnt(0.0),
    lp_fntexc(0.0),
    lp_nfa(0.0),
    lp_nfb(0.0),
    lp_nfc(0.0),
    lp_ef(0.0),
    lp_rg(0.0),
    lp_rbulk(0.0),
    lp_rwell(0.0),
    lp_rjuns(0.0),
    lp_rjund(0.0),
    tk(0.0),
    cjosbot(0.0),
    cjossti(0.0),
    cjosgat(0.0),
    vbisbot(0.0),
    vbissti(0.0),
    vbisgat(0.0),
    idsatsbot(0.0),
    idsatssti(0.0),
    idsatsgat(0.0),
    cjosbotd(0.0),
    cjosstid(0.0),
    cjosgatd(0.0),
    vbisbotd(0.0),
    vbisstid(0.0),
    vbisgatd(0.0),
    idsatsbotd(0.0),
    idsatsstid(0.0),
    idsatsgatd(0.0),
    li_D(-1),
    li_G(-1),
    li_S(-1),
    li_B(-1),
    li_NOI(-1),
    li_NOI2(-1),
    li_GP(-1),
    li_BP(-1),
    li_BI(-1),
    li_BS(-1),
    li_BD(-1),
    li_branch_iD(-1),
    li_branch_iG(-1),
    li_branch_iS(-1),
    li_branch_iB(-1),
    f_D_Equ_S_Node_Ptr(0),
    f_D_Equ_BP_Node_Ptr(0),
    f_BP_Equ_S_Node_Ptr(0),
    f_BP_Equ_BP_Node_Ptr(0),
    f_D_Equ_D_Node_Ptr(0),
    f_BP_Equ_D_Node_Ptr(0),
    f_D_Equ_GP_Node_Ptr(0),
    f_BP_Equ_GP_Node_Ptr(0),
    f_S_Equ_S_Node_Ptr(0),
    f_S_Equ_BP_Node_Ptr(0),
    f_S_Equ_D_Node_Ptr(0),
    f_S_Equ_GP_Node_Ptr(0),
    f_GP_Equ_S_Node_Ptr(0),
    f_GP_Equ_BP_Node_Ptr(0),
    f_GP_Equ_D_Node_Ptr(0),
    f_GP_Equ_GP_Node_Ptr(0),
    f_BS_Equ_S_Node_Ptr(0),
    f_BS_Equ_BS_Node_Ptr(0),
    f_S_Equ_BS_Node_Ptr(0),
    f_BS_Equ_D_Node_Ptr(0),
    f_BS_Equ_BD_Node_Ptr(0),
    f_S_Equ_BD_Node_Ptr(0),
    f_BD_Equ_S_Node_Ptr(0),
    f_BD_Equ_BS_Node_Ptr(0),
    f_D_Equ_BS_Node_Ptr(0),
    f_BD_Equ_D_Node_Ptr(0),
    f_BD_Equ_BD_Node_Ptr(0),
    f_D_Equ_BD_Node_Ptr(0),
    f_G_Equ_G_Node_Ptr(0),
    f_G_Equ_GP_Node_Ptr(0),
    f_GP_Equ_G_Node_Ptr(0),
    f_BP_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BP_Node_Ptr(0),
    f_BI_Equ_BI_Node_Ptr(0),
    f_BS_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BD_Node_Ptr(0),
    f_B_Equ_B_Node_Ptr(0),
    f_B_Equ_BI_Node_Ptr(0),
    f_BI_Equ_B_Node_Ptr(0),
    f_NOI2_Equ_NOI2_Node_Ptr(0),
    f_NOI2_Equ_S_Node_Ptr(0),
    f_NOI2_Equ_BP_Node_Ptr(0),
    f_NOI2_Equ_GP_Node_Ptr(0),
    f_NOI2_Equ_D_Node_Ptr(0),
    f_NOI_Equ_S_Node_Ptr(0),
    f_NOI_Equ_BP_Node_Ptr(0),
    f_NOI_Equ_GP_Node_Ptr(0),
    f_NOI_Equ_D_Node_Ptr(0),
    f_NOI_Equ_NOI2_Node_Ptr(0),
    f_NOI_Equ_NOI_Node_Ptr(0),
    f_D_Equ_NOI2_Node_Ptr(0),
    f_S_Equ_NOI2_Node_Ptr(0),
    f_GP_Equ_NOI_Node_Ptr(0),
    f_S_Equ_NOI_Node_Ptr(0),
    f_D_Equ_NOI_Node_Ptr(0),
    f_BS_Equ_BP_Node_Ptr(0),
    f_BS_Equ_GP_Node_Ptr(0),
    f_BD_Equ_BP_Node_Ptr(0),
    f_BD_Equ_GP_Node_Ptr(0),
    q_D_Equ_S_Node_Ptr(0),
    q_D_Equ_BP_Node_Ptr(0),
    q_BP_Equ_S_Node_Ptr(0),
    q_BP_Equ_BP_Node_Ptr(0),
    q_D_Equ_D_Node_Ptr(0),
    q_BP_Equ_D_Node_Ptr(0),
    q_D_Equ_GP_Node_Ptr(0),
    q_BP_Equ_GP_Node_Ptr(0),
    q_S_Equ_S_Node_Ptr(0),
    q_S_Equ_BP_Node_Ptr(0),
    q_S_Equ_D_Node_Ptr(0),
    q_S_Equ_GP_Node_Ptr(0),
    q_GP_Equ_S_Node_Ptr(0),
    q_GP_Equ_BP_Node_Ptr(0),
    q_GP_Equ_D_Node_Ptr(0),
    q_GP_Equ_GP_Node_Ptr(0),
    q_BS_Equ_S_Node_Ptr(0),
    q_BS_Equ_BS_Node_Ptr(0),
    q_S_Equ_BS_Node_Ptr(0),
    q_BS_Equ_D_Node_Ptr(0),
    q_BS_Equ_BD_Node_Ptr(0),
    q_S_Equ_BD_Node_Ptr(0),
    q_BD_Equ_S_Node_Ptr(0),
    q_BD_Equ_BS_Node_Ptr(0),
    q_D_Equ_BS_Node_Ptr(0),
    q_BD_Equ_D_Node_Ptr(0),
    q_BD_Equ_BD_Node_Ptr(0),
    q_D_Equ_BD_Node_Ptr(0),
    q_G_Equ_G_Node_Ptr(0),
    q_G_Equ_GP_Node_Ptr(0),
    q_GP_Equ_G_Node_Ptr(0),
    q_BP_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BP_Node_Ptr(0),
    q_BI_Equ_BI_Node_Ptr(0),
    q_BS_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BD_Node_Ptr(0),
    q_B_Equ_B_Node_Ptr(0),
    q_B_Equ_BI_Node_Ptr(0),
    q_BI_Equ_B_Node_Ptr(0),
    q_NOI2_Equ_NOI2_Node_Ptr(0),
    q_NOI2_Equ_S_Node_Ptr(0),
    q_NOI2_Equ_BP_Node_Ptr(0),
    q_NOI2_Equ_GP_Node_Ptr(0),
    q_NOI2_Equ_D_Node_Ptr(0),
    q_NOI_Equ_S_Node_Ptr(0),
    q_NOI_Equ_BP_Node_Ptr(0),
    q_NOI_Equ_GP_Node_Ptr(0),
    q_NOI_Equ_D_Node_Ptr(0),
    q_NOI_Equ_NOI2_Node_Ptr(0),
    q_NOI_Equ_NOI_Node_Ptr(0),
    q_D_Equ_NOI2_Node_Ptr(0),
    q_S_Equ_NOI2_Node_Ptr(0),
    q_GP_Equ_NOI_Node_Ptr(0),
    q_S_Equ_NOI_Node_Ptr(0),
    q_D_Equ_NOI_Node_Ptr(0),
    q_BS_Equ_BP_Node_Ptr(0),
    q_BS_Equ_GP_Node_Ptr(0),
    q_BD_Equ_BP_Node_Ptr(0),
    q_BD_Equ_GP_Node_Ptr(0),
    A_D_Equ_S_NodeOffset(-1),
    A_D_Equ_BP_NodeOffset(-1),
    A_BP_Equ_S_NodeOffset(-1),
    A_BP_Equ_BP_NodeOffset(-1),
    A_D_Equ_D_NodeOffset(-1),
    A_BP_Equ_D_NodeOffset(-1),
    A_D_Equ_GP_NodeOffset(-1),
    A_BP_Equ_GP_NodeOffset(-1),
    A_S_Equ_S_NodeOffset(-1),
    A_S_Equ_BP_NodeOffset(-1),
    A_S_Equ_D_NodeOffset(-1),
    A_S_Equ_GP_NodeOffset(-1),
    A_GP_Equ_S_NodeOffset(-1),
    A_GP_Equ_BP_NodeOffset(-1),
    A_GP_Equ_D_NodeOffset(-1),
    A_GP_Equ_GP_NodeOffset(-1),
    A_BS_Equ_S_NodeOffset(-1),
    A_BS_Equ_BS_NodeOffset(-1),
    A_S_Equ_BS_NodeOffset(-1),
    A_BS_Equ_D_NodeOffset(-1),
    A_BS_Equ_BD_NodeOffset(-1),
    A_S_Equ_BD_NodeOffset(-1),
    A_BD_Equ_S_NodeOffset(-1),
    A_BD_Equ_BS_NodeOffset(-1),
    A_D_Equ_BS_NodeOffset(-1),
    A_BD_Equ_D_NodeOffset(-1),
    A_BD_Equ_BD_NodeOffset(-1),
    A_D_Equ_BD_NodeOffset(-1),
    A_G_Equ_G_NodeOffset(-1),
    A_G_Equ_GP_NodeOffset(-1),
    A_GP_Equ_G_NodeOffset(-1),
    A_BP_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BP_NodeOffset(-1),
    A_BI_Equ_BI_NodeOffset(-1),
    A_BS_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BD_NodeOffset(-1),
    A_B_Equ_B_NodeOffset(-1),
    A_B_Equ_BI_NodeOffset(-1),
    A_BI_Equ_B_NodeOffset(-1),
    A_NOI2_Equ_NOI2_NodeOffset(-1),
    A_NOI2_Equ_S_NodeOffset(-1),
    A_NOI2_Equ_BP_NodeOffset(-1),
    A_NOI2_Equ_GP_NodeOffset(-1),
    A_NOI2_Equ_D_NodeOffset(-1),
    A_NOI_Equ_S_NodeOffset(-1),
    A_NOI_Equ_BP_NodeOffset(-1),
    A_NOI_Equ_GP_NodeOffset(-1),
    A_NOI_Equ_D_NodeOffset(-1),
    A_NOI_Equ_NOI2_NodeOffset(-1),
    A_NOI_Equ_NOI_NodeOffset(-1),
    A_D_Equ_NOI2_NodeOffset(-1),
    A_S_Equ_NOI2_NodeOffset(-1),
    A_GP_Equ_NOI_NodeOffset(-1),
    A_S_Equ_NOI_NodeOffset(-1),
    A_D_Equ_NOI_NodeOffset(-1),
    A_BS_Equ_BP_NodeOffset(-1),
    A_BS_Equ_GP_NodeOffset(-1),
    A_BD_Equ_BP_NodeOffset(-1),
    A_BD_Equ_GP_NodeOffset(-1),
    li_store_ctype(-1),
    li_store_sdint(-1),
    li_store_ise(-1),
    li_store_ige(-1),
    li_store_ide(-1),
    li_store_ibe(-1),
    li_store_ids(-1),
    li_store_idb(-1),
    li_store_isb(-1),
    li_store_igs(-1),
    li_store_igd(-1),
    li_store_igb(-1),
    li_store_igcs(-1),
    li_store_igcd(-1),
    li_store_iavl(-1),
    li_store_igisl(-1),
    li_store_igidl(-1),
    li_store_ijs(-1),
    li_store_ijsbot(-1),
    li_store_ijsgat(-1),
    li_store_ijssti(-1),
    li_store_ijd(-1),
    li_store_ijdbot(-1),
    li_store_ijdgat(-1),
    li_store_ijdsti(-1),
    li_store_vds(-1),
    li_store_vgs(-1),
    li_store_vsb(-1),
    li_store_vto(-1),
    li_store_vts(-1),
    li_store_vth(-1),
    li_store_vgt(-1),
    li_store_vdss(-1),
    li_store_vsat(-1),
    li_store_gm(-1),
    li_store_gmb(-1),
    li_store_gds(-1),
    li_store_gjs(-1),
    li_store_gjd(-1),
    li_store_cdd(-1),
    li_store_cdg(-1),
    li_store_cds(-1),
    li_store_cdb(-1),
    li_store_cgd(-1),
    li_store_cgg(-1),
    li_store_cgs(-1),
    li_store_cgb(-1),
    li_store_csd(-1),
    li_store_csg(-1),
    li_store_css(-1),
    li_store_csb(-1),
    li_store_cbd(-1),
    li_store_cbg(-1),
    li_store_cbs(-1),
    li_store_cbb(-1),
    li_store_cgsol(-1),
    li_store_cgdol(-1),
    li_store_cjs(-1),
    li_store_cjsbot(-1),
    li_store_cjsgat(-1),
    li_store_cjssti(-1),
    li_store_cjd(-1),
    li_store_cjdbot(-1),
    li_store_cjdgat(-1),
    li_store_cjdsti(-1),
    li_store_weff(-1),
    li_store_leff(-1),
    li_store_u(-1),
    li_store_rout(-1),
    li_store_vearly(-1),
    li_store_beff(-1),
    li_store_fug(-1),
    li_store_rg(-1),
    li_store_sfl(-1),
    li_store_sqrtsff(-1),
    li_store_sqrtsfw(-1),
    li_store_sid(-1),
    li_store_sig(-1),
    li_store_cigid(-1),
    li_store_fknee(-1),
    li_store_sigs(-1),
    li_store_sigd(-1),
    li_store_siavl(-1),
    li_store_ssi(-1),
    li_store_sdi(-1),
    li_store_lp_vfb(-1),
    li_store_lp_stvfb(-1),
    li_store_lp_tox(-1),
    li_store_lp_epsrox(-1),
    li_store_lp_neff(-1),
    li_store_lp_vnsub(-1),
    li_store_lp_nslp(-1),
    li_store_lp_dnsub(-1),
    li_store_lp_dphib(-1),
    li_store_lp_np(-1),
    li_store_lp_ct(-1),
    li_store_lp_toxov(-1),
    li_store_lp_toxovd(-1),
    li_store_lp_nov(-1),
    li_store_lp_novd(-1),
    li_store_lp_cf(-1),
    li_store_lp_cfb(-1),
    li_store_lp_betn(-1),
    li_store_lp_stbet(-1),
    li_store_lp_mue(-1),
    li_store_lp_stmue(-1),
    li_store_lp_themu(-1),
    li_store_lp_stthemu(-1),
    li_store_lp_cs(-1),
    li_store_lp_stcs(-1),
    li_store_lp_xcor(-1),
    li_store_lp_stxcor(-1),
    li_store_lp_feta(-1),
    li_store_lp_rs(-1),
    li_store_lp_strs(-1),
    li_store_lp_rsb(-1),
    li_store_lp_rsg(-1),
    li_store_lp_thesat(-1),
    li_store_lp_stthesat(-1),
    li_store_lp_thesatb(-1),
    li_store_lp_thesatg(-1),
    li_store_lp_ax(-1),
    li_store_lp_alp(-1),
    li_store_lp_alp1(-1),
    li_store_lp_alp2(-1),
    li_store_lp_vp(-1),
    li_store_lp_a1(-1),
    li_store_lp_a2(-1),
    li_store_lp_sta2(-1),
    li_store_lp_a3(-1),
    li_store_lp_a4(-1),
    li_store_lp_gco(-1),
    li_store_lp_iginv(-1),
    li_store_lp_igov(-1),
    li_store_lp_igovd(-1),
    li_store_lp_stig(-1),
    li_store_lp_gc2(-1),
    li_store_lp_gc3(-1),
    li_store_lp_chib(-1),
    li_store_lp_agidl(-1),
    li_store_lp_agidld(-1),
    li_store_lp_bgidl(-1),
    li_store_lp_bgidld(-1),
    li_store_lp_stbgidl(-1),
    li_store_lp_stbgidld(-1),
    li_store_lp_cgidl(-1),
    li_store_lp_cgidld(-1),
    li_store_lp_cox(-1),
    li_store_lp_cgov(-1),
    li_store_lp_cgovd(-1),
    li_store_lp_cgbov(-1),
    li_store_lp_cfr(-1),
    li_store_lp_cfrd(-1),
    li_store_lp_fnt(-1),
    li_store_lp_fntexc(-1),
    li_store_lp_nfa(-1),
    li_store_lp_nfb(-1),
    li_store_lp_nfc(-1),
    li_store_lp_ef(-1),
    li_store_lp_rg(-1),
    li_store_lp_rbulk(-1),
    li_store_lp_rwell(-1),
    li_store_lp_rjuns(-1),
    li_store_lp_rjund(-1),
    li_store_tk(-1),
    li_store_cjosbot(-1),
    li_store_cjossti(-1),
    li_store_cjosgat(-1),
    li_store_vbisbot(-1),
    li_store_vbissti(-1),
    li_store_vbisgat(-1),
    li_store_idsatsbot(-1),
    li_store_idsatssti(-1),
    li_store_idsatsgat(-1),
    li_store_cjosbotd(-1),
    li_store_cjosstid(-1),
    li_store_cjosgatd(-1),
    li_store_vbisbotd(-1),
    li_store_vbisstid(-1),
    li_store_vbisgatd(-1),
    li_store_idsatsbotd(-1),
    li_store_idsatsstid(-1),
    li_store_idsatsgatd(-1),
    collapseNode_GP(false),
    collapseNode_BP(false),
    collapseNode_BI(false),
    collapseNode_BS(false),
    collapseNode_BD(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 7 + 0;
    numExtVars = 4;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+183);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_GP));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_GP)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  }
  if (collapseNode_BP)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  }
  if (collapseNode_BI)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  }
  if (collapseNode_BS)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  }
  if (collapseNode_BD)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 11+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_GP = false;
collapseNode_BP = false;
collapseNode_BI = false;
collapseNode_BS = false;
collapseNode_BD = false;
// begin block named evaluateblock

// begin block named loadStatic

if (!((RG_i>0.0)))
{

collapseNode_GP = true;

}

if (!((RBULK_i>0.0)))
{

collapseNode_BP = true;

}

if (!((RJUNS_i>0.0)))
{

collapseNode_BS = true;

}

if (!((RJUND_i>0.0)))
{

collapseNode_BD = true;

}

if (!((RWELL_i>0.0)))
{

collapseNode_BI = true;

}

// end block  named loadStatic

// end block  named evaluateblock


  if (collapseNode_GP)
  {
    numIntVars--;
  }
  if (collapseNode_BP)
  {
    numIntVars--;
  }
  if (collapseNode_BI)
  {
    numIntVars--;
  }
  if (collapseNode_BS)
  {
    numIntVars--;
  }
  if (collapseNode_BD)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSPSP102VA::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_D = localLIDVec[nodeMap[admsNodeID_D]];
  li_G = localLIDVec[nodeMap[admsNodeID_G]];
  li_S = localLIDVec[nodeMap[admsNodeID_S]];
  li_B = localLIDVec[nodeMap[admsNodeID_B]];
  li_NOI = localLIDVec[nodeMap[admsNodeID_NOI]];
  li_NOI2 = localLIDVec[nodeMap[admsNodeID_NOI2]];
  li_GP = localLIDVec[nodeMap[admsNodeID_GP]];
  li_BP = localLIDVec[nodeMap[admsNodeID_BP]];
  li_BI = localLIDVec[nodeMap[admsNodeID_BI]];
  li_BS = localLIDVec[nodeMap[admsNodeID_BS]];
  li_BD = localLIDVec[nodeMap[admsNodeID_BD]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_D = " << li_D << std::endl;
      Xyce::dout() << "\nli_G = " << li_G << std::endl;
      Xyce::dout() << "\nli_S = " << li_S << std::endl;
      Xyce::dout() << "\nli_B = " << li_B << std::endl;
      Xyce::dout() << "\nli_NOI = " << li_NOI << std::endl;
      Xyce::dout() << "\nli_NOI2 = " << li_NOI2 << std::endl;
      Xyce::dout() << "\nli_GP = " << li_GP << std::endl;
      Xyce::dout() << "\nli_BP = " << li_BP << std::endl;
      Xyce::dout() << "\nli_BI = " << li_BI << std::endl;
      Xyce::dout() << "\nli_BS = " << li_BS << std::endl;
      Xyce::dout() << "\nli_BD = " << li_BD << std::endl;

    Xyce::dout() << "\nEnd of ADMSPSP102VA::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    addInternalNode(symbol_table, li_NOI, getName(), "NOI");
    addInternalNode(symbol_table, li_NOI2, getName(), "NOI2");
    if (!collapseNode_GP)
    {
    addInternalNode(symbol_table, li_GP, getName(), "GP");
    }
    if (!collapseNode_BP)
    {
    addInternalNode(symbol_table, li_BP, getName(), "BP");
    }
    if (!collapseNode_BI)
    {
    addInternalNode(symbol_table, li_BI, getName(), "BI");
    }
    if (!collapseNode_BS)
    {
    addInternalNode(symbol_table, li_BS, getName(), "BS");
    }
    if (!collapseNode_BD)
    {
    addInternalNode(symbol_table, li_BD, getName(), "BD");
    }
    addStoreNode(symbol_table, li_store_ctype, getName().getEncodedName() + ":ctype");
    addStoreNode(symbol_table, li_store_sdint, getName().getEncodedName() + ":sdint");
    addStoreNode(symbol_table, li_store_ise, getName().getEncodedName() + ":ise");
    addStoreNode(symbol_table, li_store_ige, getName().getEncodedName() + ":ige");
    addStoreNode(symbol_table, li_store_ide, getName().getEncodedName() + ":ide");
    addStoreNode(symbol_table, li_store_ibe, getName().getEncodedName() + ":ibe");
    addStoreNode(symbol_table, li_store_ids, getName().getEncodedName() + ":ids");
    addStoreNode(symbol_table, li_store_idb, getName().getEncodedName() + ":idb");
    addStoreNode(symbol_table, li_store_isb, getName().getEncodedName() + ":isb");
    addStoreNode(symbol_table, li_store_igs, getName().getEncodedName() + ":igs");
    addStoreNode(symbol_table, li_store_igd, getName().getEncodedName() + ":igd");
    addStoreNode(symbol_table, li_store_igb, getName().getEncodedName() + ":igb");
    addStoreNode(symbol_table, li_store_igcs, getName().getEncodedName() + ":igcs");
    addStoreNode(symbol_table, li_store_igcd, getName().getEncodedName() + ":igcd");
    addStoreNode(symbol_table, li_store_iavl, getName().getEncodedName() + ":iavl");
    addStoreNode(symbol_table, li_store_igisl, getName().getEncodedName() + ":igisl");
    addStoreNode(symbol_table, li_store_igidl, getName().getEncodedName() + ":igidl");
    addStoreNode(symbol_table, li_store_ijs, getName().getEncodedName() + ":ijs");
    addStoreNode(symbol_table, li_store_ijsbot, getName().getEncodedName() + ":ijsbot");
    addStoreNode(symbol_table, li_store_ijsgat, getName().getEncodedName() + ":ijsgat");
    addStoreNode(symbol_table, li_store_ijssti, getName().getEncodedName() + ":ijssti");
    addStoreNode(symbol_table, li_store_ijd, getName().getEncodedName() + ":ijd");
    addStoreNode(symbol_table, li_store_ijdbot, getName().getEncodedName() + ":ijdbot");
    addStoreNode(symbol_table, li_store_ijdgat, getName().getEncodedName() + ":ijdgat");
    addStoreNode(symbol_table, li_store_ijdsti, getName().getEncodedName() + ":ijdsti");
    addStoreNode(symbol_table, li_store_vds, getName().getEncodedName() + ":vds");
    addStoreNode(symbol_table, li_store_vgs, getName().getEncodedName() + ":vgs");
    addStoreNode(symbol_table, li_store_vsb, getName().getEncodedName() + ":vsb");
    addStoreNode(symbol_table, li_store_vto, getName().getEncodedName() + ":vto");
    addStoreNode(symbol_table, li_store_vts, getName().getEncodedName() + ":vts");
    addStoreNode(symbol_table, li_store_vth, getName().getEncodedName() + ":vth");
    addStoreNode(symbol_table, li_store_vgt, getName().getEncodedName() + ":vgt");
    addStoreNode(symbol_table, li_store_vdss, getName().getEncodedName() + ":vdss");
    addStoreNode(symbol_table, li_store_vsat, getName().getEncodedName() + ":vsat");
    addStoreNode(symbol_table, li_store_gm, getName().getEncodedName() + ":gm");
    addStoreNode(symbol_table, li_store_gmb, getName().getEncodedName() + ":gmb");
    addStoreNode(symbol_table, li_store_gds, getName().getEncodedName() + ":gds");
    addStoreNode(symbol_table, li_store_gjs, getName().getEncodedName() + ":gjs");
    addStoreNode(symbol_table, li_store_gjd, getName().getEncodedName() + ":gjd");
    addStoreNode(symbol_table, li_store_cdd, getName().getEncodedName() + ":cdd");
    addStoreNode(symbol_table, li_store_cdg, getName().getEncodedName() + ":cdg");
    addStoreNode(symbol_table, li_store_cds, getName().getEncodedName() + ":cds");
    addStoreNode(symbol_table, li_store_cdb, getName().getEncodedName() + ":cdb");
    addStoreNode(symbol_table, li_store_cgd, getName().getEncodedName() + ":cgd");
    addStoreNode(symbol_table, li_store_cgg, getName().getEncodedName() + ":cgg");
    addStoreNode(symbol_table, li_store_cgs, getName().getEncodedName() + ":cgs");
    addStoreNode(symbol_table, li_store_cgb, getName().getEncodedName() + ":cgb");
    addStoreNode(symbol_table, li_store_csd, getName().getEncodedName() + ":csd");
    addStoreNode(symbol_table, li_store_csg, getName().getEncodedName() + ":csg");
    addStoreNode(symbol_table, li_store_css, getName().getEncodedName() + ":css");
    addStoreNode(symbol_table, li_store_csb, getName().getEncodedName() + ":csb");
    addStoreNode(symbol_table, li_store_cbd, getName().getEncodedName() + ":cbd");
    addStoreNode(symbol_table, li_store_cbg, getName().getEncodedName() + ":cbg");
    addStoreNode(symbol_table, li_store_cbs, getName().getEncodedName() + ":cbs");
    addStoreNode(symbol_table, li_store_cbb, getName().getEncodedName() + ":cbb");
    addStoreNode(symbol_table, li_store_cgsol, getName().getEncodedName() + ":cgsol");
    addStoreNode(symbol_table, li_store_cgdol, getName().getEncodedName() + ":cgdol");
    addStoreNode(symbol_table, li_store_cjs, getName().getEncodedName() + ":cjs");
    addStoreNode(symbol_table, li_store_cjsbot, getName().getEncodedName() + ":cjsbot");
    addStoreNode(symbol_table, li_store_cjsgat, getName().getEncodedName() + ":cjsgat");
    addStoreNode(symbol_table, li_store_cjssti, getName().getEncodedName() + ":cjssti");
    addStoreNode(symbol_table, li_store_cjd, getName().getEncodedName() + ":cjd");
    addStoreNode(symbol_table, li_store_cjdbot, getName().getEncodedName() + ":cjdbot");
    addStoreNode(symbol_table, li_store_cjdgat, getName().getEncodedName() + ":cjdgat");
    addStoreNode(symbol_table, li_store_cjdsti, getName().getEncodedName() + ":cjdsti");
    addStoreNode(symbol_table, li_store_weff, getName().getEncodedName() + ":weff");
    addStoreNode(symbol_table, li_store_leff, getName().getEncodedName() + ":leff");
    addStoreNode(symbol_table, li_store_u, getName().getEncodedName() + ":u");
    addStoreNode(symbol_table, li_store_rout, getName().getEncodedName() + ":rout");
    addStoreNode(symbol_table, li_store_vearly, getName().getEncodedName() + ":vearly");
    addStoreNode(symbol_table, li_store_beff, getName().getEncodedName() + ":beff");
    addStoreNode(symbol_table, li_store_fug, getName().getEncodedName() + ":fug");
    addStoreNode(symbol_table, li_store_rg, getName().getEncodedName() + ":rg");
    addStoreNode(symbol_table, li_store_sfl, getName().getEncodedName() + ":sfl");
    addStoreNode(symbol_table, li_store_sqrtsff, getName().getEncodedName() + ":sqrtsff");
    addStoreNode(symbol_table, li_store_sqrtsfw, getName().getEncodedName() + ":sqrtsfw");
    addStoreNode(symbol_table, li_store_sid, getName().getEncodedName() + ":sid");
    addStoreNode(symbol_table, li_store_sig, getName().getEncodedName() + ":sig");
    addStoreNode(symbol_table, li_store_cigid, getName().getEncodedName() + ":cigid");
    addStoreNode(symbol_table, li_store_fknee, getName().getEncodedName() + ":fknee");
    addStoreNode(symbol_table, li_store_sigs, getName().getEncodedName() + ":sigs");
    addStoreNode(symbol_table, li_store_sigd, getName().getEncodedName() + ":sigd");
    addStoreNode(symbol_table, li_store_siavl, getName().getEncodedName() + ":siavl");
    addStoreNode(symbol_table, li_store_ssi, getName().getEncodedName() + ":ssi");
    addStoreNode(symbol_table, li_store_sdi, getName().getEncodedName() + ":sdi");
    addStoreNode(symbol_table, li_store_lp_vfb, getName().getEncodedName() + ":lp_vfb");
    addStoreNode(symbol_table, li_store_lp_stvfb, getName().getEncodedName() + ":lp_stvfb");
    addStoreNode(symbol_table, li_store_lp_tox, getName().getEncodedName() + ":lp_tox");
    addStoreNode(symbol_table, li_store_lp_epsrox, getName().getEncodedName() + ":lp_epsrox");
    addStoreNode(symbol_table, li_store_lp_neff, getName().getEncodedName() + ":lp_neff");
    addStoreNode(symbol_table, li_store_lp_vnsub, getName().getEncodedName() + ":lp_vnsub");
    addStoreNode(symbol_table, li_store_lp_nslp, getName().getEncodedName() + ":lp_nslp");
    addStoreNode(symbol_table, li_store_lp_dnsub, getName().getEncodedName() + ":lp_dnsub");
    addStoreNode(symbol_table, li_store_lp_dphib, getName().getEncodedName() + ":lp_dphib");
    addStoreNode(symbol_table, li_store_lp_np, getName().getEncodedName() + ":lp_np");
    addStoreNode(symbol_table, li_store_lp_ct, getName().getEncodedName() + ":lp_ct");
    addStoreNode(symbol_table, li_store_lp_toxov, getName().getEncodedName() + ":lp_toxov");
    addStoreNode(symbol_table, li_store_lp_toxovd, getName().getEncodedName() + ":lp_toxovd");
    addStoreNode(symbol_table, li_store_lp_nov, getName().getEncodedName() + ":lp_nov");
    addStoreNode(symbol_table, li_store_lp_novd, getName().getEncodedName() + ":lp_novd");
    addStoreNode(symbol_table, li_store_lp_cf, getName().getEncodedName() + ":lp_cf");
    addStoreNode(symbol_table, li_store_lp_cfb, getName().getEncodedName() + ":lp_cfb");
    addStoreNode(symbol_table, li_store_lp_betn, getName().getEncodedName() + ":lp_betn");
    addStoreNode(symbol_table, li_store_lp_stbet, getName().getEncodedName() + ":lp_stbet");
    addStoreNode(symbol_table, li_store_lp_mue, getName().getEncodedName() + ":lp_mue");
    addStoreNode(symbol_table, li_store_lp_stmue, getName().getEncodedName() + ":lp_stmue");
    addStoreNode(symbol_table, li_store_lp_themu, getName().getEncodedName() + ":lp_themu");
    addStoreNode(symbol_table, li_store_lp_stthemu, getName().getEncodedName() + ":lp_stthemu");
    addStoreNode(symbol_table, li_store_lp_cs, getName().getEncodedName() + ":lp_cs");
    addStoreNode(symbol_table, li_store_lp_stcs, getName().getEncodedName() + ":lp_stcs");
    addStoreNode(symbol_table, li_store_lp_xcor, getName().getEncodedName() + ":lp_xcor");
    addStoreNode(symbol_table, li_store_lp_stxcor, getName().getEncodedName() + ":lp_stxcor");
    addStoreNode(symbol_table, li_store_lp_feta, getName().getEncodedName() + ":lp_feta");
    addStoreNode(symbol_table, li_store_lp_rs, getName().getEncodedName() + ":lp_rs");
    addStoreNode(symbol_table, li_store_lp_strs, getName().getEncodedName() + ":lp_strs");
    addStoreNode(symbol_table, li_store_lp_rsb, getName().getEncodedName() + ":lp_rsb");
    addStoreNode(symbol_table, li_store_lp_rsg, getName().getEncodedName() + ":lp_rsg");
    addStoreNode(symbol_table, li_store_lp_thesat, getName().getEncodedName() + ":lp_thesat");
    addStoreNode(symbol_table, li_store_lp_stthesat, getName().getEncodedName() + ":lp_stthesat");
    addStoreNode(symbol_table, li_store_lp_thesatb, getName().getEncodedName() + ":lp_thesatb");
    addStoreNode(symbol_table, li_store_lp_thesatg, getName().getEncodedName() + ":lp_thesatg");
    addStoreNode(symbol_table, li_store_lp_ax, getName().getEncodedName() + ":lp_ax");
    addStoreNode(symbol_table, li_store_lp_alp, getName().getEncodedName() + ":lp_alp");
    addStoreNode(symbol_table, li_store_lp_alp1, getName().getEncodedName() + ":lp_alp1");
    addStoreNode(symbol_table, li_store_lp_alp2, getName().getEncodedName() + ":lp_alp2");
    addStoreNode(symbol_table, li_store_lp_vp, getName().getEncodedName() + ":lp_vp");
    addStoreNode(symbol_table, li_store_lp_a1, getName().getEncodedName() + ":lp_a1");
    addStoreNode(symbol_table, li_store_lp_a2, getName().getEncodedName() + ":lp_a2");
    addStoreNode(symbol_table, li_store_lp_sta2, getName().getEncodedName() + ":lp_sta2");
    addStoreNode(symbol_table, li_store_lp_a3, getName().getEncodedName() + ":lp_a3");
    addStoreNode(symbol_table, li_store_lp_a4, getName().getEncodedName() + ":lp_a4");
    addStoreNode(symbol_table, li_store_lp_gco, getName().getEncodedName() + ":lp_gco");
    addStoreNode(symbol_table, li_store_lp_iginv, getName().getEncodedName() + ":lp_iginv");
    addStoreNode(symbol_table, li_store_lp_igov, getName().getEncodedName() + ":lp_igov");
    addStoreNode(symbol_table, li_store_lp_igovd, getName().getEncodedName() + ":lp_igovd");
    addStoreNode(symbol_table, li_store_lp_stig, getName().getEncodedName() + ":lp_stig");
    addStoreNode(symbol_table, li_store_lp_gc2, getName().getEncodedName() + ":lp_gc2");
    addStoreNode(symbol_table, li_store_lp_gc3, getName().getEncodedName() + ":lp_gc3");
    addStoreNode(symbol_table, li_store_lp_chib, getName().getEncodedName() + ":lp_chib");
    addStoreNode(symbol_table, li_store_lp_agidl, getName().getEncodedName() + ":lp_agidl");
    addStoreNode(symbol_table, li_store_lp_agidld, getName().getEncodedName() + ":lp_agidld");
    addStoreNode(symbol_table, li_store_lp_bgidl, getName().getEncodedName() + ":lp_bgidl");
    addStoreNode(symbol_table, li_store_lp_bgidld, getName().getEncodedName() + ":lp_bgidld");
    addStoreNode(symbol_table, li_store_lp_stbgidl, getName().getEncodedName() + ":lp_stbgidl");
    addStoreNode(symbol_table, li_store_lp_stbgidld, getName().getEncodedName() + ":lp_stbgidld");
    addStoreNode(symbol_table, li_store_lp_cgidl, getName().getEncodedName() + ":lp_cgidl");
    addStoreNode(symbol_table, li_store_lp_cgidld, getName().getEncodedName() + ":lp_cgidld");
    addStoreNode(symbol_table, li_store_lp_cox, getName().getEncodedName() + ":lp_cox");
    addStoreNode(symbol_table, li_store_lp_cgov, getName().getEncodedName() + ":lp_cgov");
    addStoreNode(symbol_table, li_store_lp_cgovd, getName().getEncodedName() + ":lp_cgovd");
    addStoreNode(symbol_table, li_store_lp_cgbov, getName().getEncodedName() + ":lp_cgbov");
    addStoreNode(symbol_table, li_store_lp_cfr, getName().getEncodedName() + ":lp_cfr");
    addStoreNode(symbol_table, li_store_lp_cfrd, getName().getEncodedName() + ":lp_cfrd");
    addStoreNode(symbol_table, li_store_lp_fnt, getName().getEncodedName() + ":lp_fnt");
    addStoreNode(symbol_table, li_store_lp_fntexc, getName().getEncodedName() + ":lp_fntexc");
    addStoreNode(symbol_table, li_store_lp_nfa, getName().getEncodedName() + ":lp_nfa");
    addStoreNode(symbol_table, li_store_lp_nfb, getName().getEncodedName() + ":lp_nfb");
    addStoreNode(symbol_table, li_store_lp_nfc, getName().getEncodedName() + ":lp_nfc");
    addStoreNode(symbol_table, li_store_lp_ef, getName().getEncodedName() + ":lp_ef");
    addStoreNode(symbol_table, li_store_lp_rg, getName().getEncodedName() + ":lp_rg");
    addStoreNode(symbol_table, li_store_lp_rbulk, getName().getEncodedName() + ":lp_rbulk");
    addStoreNode(symbol_table, li_store_lp_rwell, getName().getEncodedName() + ":lp_rwell");
    addStoreNode(symbol_table, li_store_lp_rjuns, getName().getEncodedName() + ":lp_rjuns");
    addStoreNode(symbol_table, li_store_lp_rjund, getName().getEncodedName() + ":lp_rjund");
    addStoreNode(symbol_table, li_store_tk, getName().getEncodedName() + ":tk");
    addStoreNode(symbol_table, li_store_cjosbot, getName().getEncodedName() + ":cjosbot");
    addStoreNode(symbol_table, li_store_cjossti, getName().getEncodedName() + ":cjossti");
    addStoreNode(symbol_table, li_store_cjosgat, getName().getEncodedName() + ":cjosgat");
    addStoreNode(symbol_table, li_store_vbisbot, getName().getEncodedName() + ":vbisbot");
    addStoreNode(symbol_table, li_store_vbissti, getName().getEncodedName() + ":vbissti");
    addStoreNode(symbol_table, li_store_vbisgat, getName().getEncodedName() + ":vbisgat");
    addStoreNode(symbol_table, li_store_idsatsbot, getName().getEncodedName() + ":idsatsbot");
    addStoreNode(symbol_table, li_store_idsatssti, getName().getEncodedName() + ":idsatssti");
    addStoreNode(symbol_table, li_store_idsatsgat, getName().getEncodedName() + ":idsatsgat");
    addStoreNode(symbol_table, li_store_cjosbotd, getName().getEncodedName() + ":cjosbotd");
    addStoreNode(symbol_table, li_store_cjosstid, getName().getEncodedName() + ":cjosstid");
    addStoreNode(symbol_table, li_store_cjosgatd, getName().getEncodedName() + ":cjosgatd");
    addStoreNode(symbol_table, li_store_vbisbotd, getName().getEncodedName() + ":vbisbotd");
    addStoreNode(symbol_table, li_store_vbisstid, getName().getEncodedName() + ":vbisstid");
    addStoreNode(symbol_table, li_store_vbisgatd, getName().getEncodedName() + ":vbisgatd");
    addStoreNode(symbol_table, li_store_idsatsbotd, getName().getEncodedName() + ":idsatsbotd");
    addStoreNode(symbol_table, li_store_idsatsstid, getName().getEncodedName() + ":idsatsstid");
    addStoreNode(symbol_table, li_store_idsatsgatd, getName().getEncodedName() + ":idsatsgatd");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iD, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_iG, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_iS, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_iB, getName(), "BRANCH_D4");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_ctype= stoLIDVec[i++];
      li_store_sdint= stoLIDVec[i++];
      li_store_ise= stoLIDVec[i++];
      li_store_ige= stoLIDVec[i++];
      li_store_ide= stoLIDVec[i++];
      li_store_ibe= stoLIDVec[i++];
      li_store_ids= stoLIDVec[i++];
      li_store_idb= stoLIDVec[i++];
      li_store_isb= stoLIDVec[i++];
      li_store_igs= stoLIDVec[i++];
      li_store_igd= stoLIDVec[i++];
      li_store_igb= stoLIDVec[i++];
      li_store_igcs= stoLIDVec[i++];
      li_store_igcd= stoLIDVec[i++];
      li_store_iavl= stoLIDVec[i++];
      li_store_igisl= stoLIDVec[i++];
      li_store_igidl= stoLIDVec[i++];
      li_store_ijs= stoLIDVec[i++];
      li_store_ijsbot= stoLIDVec[i++];
      li_store_ijsgat= stoLIDVec[i++];
      li_store_ijssti= stoLIDVec[i++];
      li_store_ijd= stoLIDVec[i++];
      li_store_ijdbot= stoLIDVec[i++];
      li_store_ijdgat= stoLIDVec[i++];
      li_store_ijdsti= stoLIDVec[i++];
      li_store_vds= stoLIDVec[i++];
      li_store_vgs= stoLIDVec[i++];
      li_store_vsb= stoLIDVec[i++];
      li_store_vto= stoLIDVec[i++];
      li_store_vts= stoLIDVec[i++];
      li_store_vth= stoLIDVec[i++];
      li_store_vgt= stoLIDVec[i++];
      li_store_vdss= stoLIDVec[i++];
      li_store_vsat= stoLIDVec[i++];
      li_store_gm= stoLIDVec[i++];
      li_store_gmb= stoLIDVec[i++];
      li_store_gds= stoLIDVec[i++];
      li_store_gjs= stoLIDVec[i++];
      li_store_gjd= stoLIDVec[i++];
      li_store_cdd= stoLIDVec[i++];
      li_store_cdg= stoLIDVec[i++];
      li_store_cds= stoLIDVec[i++];
      li_store_cdb= stoLIDVec[i++];
      li_store_cgd= stoLIDVec[i++];
      li_store_cgg= stoLIDVec[i++];
      li_store_cgs= stoLIDVec[i++];
      li_store_cgb= stoLIDVec[i++];
      li_store_csd= stoLIDVec[i++];
      li_store_csg= stoLIDVec[i++];
      li_store_css= stoLIDVec[i++];
      li_store_csb= stoLIDVec[i++];
      li_store_cbd= stoLIDVec[i++];
      li_store_cbg= stoLIDVec[i++];
      li_store_cbs= stoLIDVec[i++];
      li_store_cbb= stoLIDVec[i++];
      li_store_cgsol= stoLIDVec[i++];
      li_store_cgdol= stoLIDVec[i++];
      li_store_cjs= stoLIDVec[i++];
      li_store_cjsbot= stoLIDVec[i++];
      li_store_cjsgat= stoLIDVec[i++];
      li_store_cjssti= stoLIDVec[i++];
      li_store_cjd= stoLIDVec[i++];
      li_store_cjdbot= stoLIDVec[i++];
      li_store_cjdgat= stoLIDVec[i++];
      li_store_cjdsti= stoLIDVec[i++];
      li_store_weff= stoLIDVec[i++];
      li_store_leff= stoLIDVec[i++];
      li_store_u= stoLIDVec[i++];
      li_store_rout= stoLIDVec[i++];
      li_store_vearly= stoLIDVec[i++];
      li_store_beff= stoLIDVec[i++];
      li_store_fug= stoLIDVec[i++];
      li_store_rg= stoLIDVec[i++];
      li_store_sfl= stoLIDVec[i++];
      li_store_sqrtsff= stoLIDVec[i++];
      li_store_sqrtsfw= stoLIDVec[i++];
      li_store_sid= stoLIDVec[i++];
      li_store_sig= stoLIDVec[i++];
      li_store_cigid= stoLIDVec[i++];
      li_store_fknee= stoLIDVec[i++];
      li_store_sigs= stoLIDVec[i++];
      li_store_sigd= stoLIDVec[i++];
      li_store_siavl= stoLIDVec[i++];
      li_store_ssi= stoLIDVec[i++];
      li_store_sdi= stoLIDVec[i++];
      li_store_lp_vfb= stoLIDVec[i++];
      li_store_lp_stvfb= stoLIDVec[i++];
      li_store_lp_tox= stoLIDVec[i++];
      li_store_lp_epsrox= stoLIDVec[i++];
      li_store_lp_neff= stoLIDVec[i++];
      li_store_lp_vnsub= stoLIDVec[i++];
      li_store_lp_nslp= stoLIDVec[i++];
      li_store_lp_dnsub= stoLIDVec[i++];
      li_store_lp_dphib= stoLIDVec[i++];
      li_store_lp_np= stoLIDVec[i++];
      li_store_lp_ct= stoLIDVec[i++];
      li_store_lp_toxov= stoLIDVec[i++];
      li_store_lp_toxovd= stoLIDVec[i++];
      li_store_lp_nov= stoLIDVec[i++];
      li_store_lp_novd= stoLIDVec[i++];
      li_store_lp_cf= stoLIDVec[i++];
      li_store_lp_cfb= stoLIDVec[i++];
      li_store_lp_betn= stoLIDVec[i++];
      li_store_lp_stbet= stoLIDVec[i++];
      li_store_lp_mue= stoLIDVec[i++];
      li_store_lp_stmue= stoLIDVec[i++];
      li_store_lp_themu= stoLIDVec[i++];
      li_store_lp_stthemu= stoLIDVec[i++];
      li_store_lp_cs= stoLIDVec[i++];
      li_store_lp_stcs= stoLIDVec[i++];
      li_store_lp_xcor= stoLIDVec[i++];
      li_store_lp_stxcor= stoLIDVec[i++];
      li_store_lp_feta= stoLIDVec[i++];
      li_store_lp_rs= stoLIDVec[i++];
      li_store_lp_strs= stoLIDVec[i++];
      li_store_lp_rsb= stoLIDVec[i++];
      li_store_lp_rsg= stoLIDVec[i++];
      li_store_lp_thesat= stoLIDVec[i++];
      li_store_lp_stthesat= stoLIDVec[i++];
      li_store_lp_thesatb= stoLIDVec[i++];
      li_store_lp_thesatg= stoLIDVec[i++];
      li_store_lp_ax= stoLIDVec[i++];
      li_store_lp_alp= stoLIDVec[i++];
      li_store_lp_alp1= stoLIDVec[i++];
      li_store_lp_alp2= stoLIDVec[i++];
      li_store_lp_vp= stoLIDVec[i++];
      li_store_lp_a1= stoLIDVec[i++];
      li_store_lp_a2= stoLIDVec[i++];
      li_store_lp_sta2= stoLIDVec[i++];
      li_store_lp_a3= stoLIDVec[i++];
      li_store_lp_a4= stoLIDVec[i++];
      li_store_lp_gco= stoLIDVec[i++];
      li_store_lp_iginv= stoLIDVec[i++];
      li_store_lp_igov= stoLIDVec[i++];
      li_store_lp_igovd= stoLIDVec[i++];
      li_store_lp_stig= stoLIDVec[i++];
      li_store_lp_gc2= stoLIDVec[i++];
      li_store_lp_gc3= stoLIDVec[i++];
      li_store_lp_chib= stoLIDVec[i++];
      li_store_lp_agidl= stoLIDVec[i++];
      li_store_lp_agidld= stoLIDVec[i++];
      li_store_lp_bgidl= stoLIDVec[i++];
      li_store_lp_bgidld= stoLIDVec[i++];
      li_store_lp_stbgidl= stoLIDVec[i++];
      li_store_lp_stbgidld= stoLIDVec[i++];
      li_store_lp_cgidl= stoLIDVec[i++];
      li_store_lp_cgidld= stoLIDVec[i++];
      li_store_lp_cox= stoLIDVec[i++];
      li_store_lp_cgov= stoLIDVec[i++];
      li_store_lp_cgovd= stoLIDVec[i++];
      li_store_lp_cgbov= stoLIDVec[i++];
      li_store_lp_cfr= stoLIDVec[i++];
      li_store_lp_cfrd= stoLIDVec[i++];
      li_store_lp_fnt= stoLIDVec[i++];
      li_store_lp_fntexc= stoLIDVec[i++];
      li_store_lp_nfa= stoLIDVec[i++];
      li_store_lp_nfb= stoLIDVec[i++];
      li_store_lp_nfc= stoLIDVec[i++];
      li_store_lp_ef= stoLIDVec[i++];
      li_store_lp_rg= stoLIDVec[i++];
      li_store_lp_rbulk= stoLIDVec[i++];
      li_store_lp_rwell= stoLIDVec[i++];
      li_store_lp_rjuns= stoLIDVec[i++];
      li_store_lp_rjund= stoLIDVec[i++];
      li_store_tk= stoLIDVec[i++];
      li_store_cjosbot= stoLIDVec[i++];
      li_store_cjossti= stoLIDVec[i++];
      li_store_cjosgat= stoLIDVec[i++];
      li_store_vbisbot= stoLIDVec[i++];
      li_store_vbissti= stoLIDVec[i++];
      li_store_vbisgat= stoLIDVec[i++];
      li_store_idsatsbot= stoLIDVec[i++];
      li_store_idsatssti= stoLIDVec[i++];
      li_store_idsatsgat= stoLIDVec[i++];
      li_store_cjosbotd= stoLIDVec[i++];
      li_store_cjosstid= stoLIDVec[i++];
      li_store_cjosgatd= stoLIDVec[i++];
      li_store_vbisbotd= stoLIDVec[i++];
      li_store_vbisstid= stoLIDVec[i++];
      li_store_vbisgatd= stoLIDVec[i++];
      li_store_idsatsbotd= stoLIDVec[i++];
      li_store_idsatsstid= stoLIDVec[i++];
      li_store_idsatsgatd= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_iD = branchLIDVecRef[i++];
    li_branch_iG = branchLIDVecRef[i++];
    li_branch_iS = branchLIDVecRef[i++];
    li_branch_iB = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_S)];
    A_D_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BP)];
    A_D_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_D)];
    A_D_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_GP)];
    A_D_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BS)];
    A_D_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_BD)];
    A_D_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_NOI2)];
    A_D_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_NOI)];
    A_D_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_G)];
    A_G_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_GP)];
    A_G_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_S)];
    A_S_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BP)];
    A_S_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_D)];
    A_S_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_GP)];
    A_S_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BS)];
    A_S_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_BD)];
    A_S_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_NOI2)];
    A_S_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_NOI)];
    A_S_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_B)];
    A_B_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_BI)];
    A_B_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_S)];
    A_NOI_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_BP)];
    A_NOI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_GP)];
    A_NOI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_D)];
    A_NOI_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI2)];
    A_NOI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI)];
    A_NOI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_NOI2)];
    A_NOI2_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_S)];
    A_NOI2_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_BP)];
    A_NOI2_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_GP)];
    A_NOI2_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_D)];
    A_NOI2_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_S)];
    A_GP_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_BP)];
    A_GP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_D)];
    A_GP_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_GP)];
    A_GP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_G)];
    A_GP_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_NOI)];
    A_GP_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_S)];
    A_BP_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BP)];
    A_BP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_D)];
    A_BP_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_GP)];
    A_BP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BI)];
    A_BP_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BP)];
    A_BI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BI)];
    A_BI_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BS)];
    A_BI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BD)];
    A_BI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_B)];
    A_BI_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_S)];
    A_BS_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BS)];
    A_BS_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_D)];
    A_BS_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BD)];
    A_BS_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BI)];
    A_BS_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BP)];
    A_BS_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_GP)];
    A_BS_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_S)];
    A_BD_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BS)];
    A_BD_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_D)];
    A_BD_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BD)];
    A_BD_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BI)];
    A_BD_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BP)];
    A_BD_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_GP)];
    A_BD_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_D_Equ_S_Node_Ptr = &(dFdx[li_D][A_D_Equ_S_NodeOffset]);
    q_D_Equ_S_Node_Ptr = &(dQdx[li_D][A_D_Equ_S_NodeOffset]);
    f_D_Equ_BP_Node_Ptr = &(dFdx[li_D][A_D_Equ_BP_NodeOffset]);
    q_D_Equ_BP_Node_Ptr = &(dQdx[li_D][A_D_Equ_BP_NodeOffset]);
    f_D_Equ_D_Node_Ptr = &(dFdx[li_D][A_D_Equ_D_NodeOffset]);
    q_D_Equ_D_Node_Ptr = &(dQdx[li_D][A_D_Equ_D_NodeOffset]);
    f_D_Equ_GP_Node_Ptr = &(dFdx[li_D][A_D_Equ_GP_NodeOffset]);
    q_D_Equ_GP_Node_Ptr = &(dQdx[li_D][A_D_Equ_GP_NodeOffset]);
    f_D_Equ_BS_Node_Ptr = &(dFdx[li_D][A_D_Equ_BS_NodeOffset]);
    q_D_Equ_BS_Node_Ptr = &(dQdx[li_D][A_D_Equ_BS_NodeOffset]);
    f_D_Equ_BD_Node_Ptr = &(dFdx[li_D][A_D_Equ_BD_NodeOffset]);
    q_D_Equ_BD_Node_Ptr = &(dQdx[li_D][A_D_Equ_BD_NodeOffset]);
    f_D_Equ_NOI2_Node_Ptr = &(dFdx[li_D][A_D_Equ_NOI2_NodeOffset]);
    q_D_Equ_NOI2_Node_Ptr = &(dQdx[li_D][A_D_Equ_NOI2_NodeOffset]);
    f_D_Equ_NOI_Node_Ptr = &(dFdx[li_D][A_D_Equ_NOI_NodeOffset]);
    q_D_Equ_NOI_Node_Ptr = &(dQdx[li_D][A_D_Equ_NOI_NodeOffset]);
    f_G_Equ_G_Node_Ptr = &(dFdx[li_G][A_G_Equ_G_NodeOffset]);
    q_G_Equ_G_Node_Ptr = &(dQdx[li_G][A_G_Equ_G_NodeOffset]);
    f_G_Equ_GP_Node_Ptr = &(dFdx[li_G][A_G_Equ_GP_NodeOffset]);
    q_G_Equ_GP_Node_Ptr = &(dQdx[li_G][A_G_Equ_GP_NodeOffset]);
    f_S_Equ_S_Node_Ptr = &(dFdx[li_S][A_S_Equ_S_NodeOffset]);
    q_S_Equ_S_Node_Ptr = &(dQdx[li_S][A_S_Equ_S_NodeOffset]);
    f_S_Equ_BP_Node_Ptr = &(dFdx[li_S][A_S_Equ_BP_NodeOffset]);
    q_S_Equ_BP_Node_Ptr = &(dQdx[li_S][A_S_Equ_BP_NodeOffset]);
    f_S_Equ_D_Node_Ptr = &(dFdx[li_S][A_S_Equ_D_NodeOffset]);
    q_S_Equ_D_Node_Ptr = &(dQdx[li_S][A_S_Equ_D_NodeOffset]);
    f_S_Equ_GP_Node_Ptr = &(dFdx[li_S][A_S_Equ_GP_NodeOffset]);
    q_S_Equ_GP_Node_Ptr = &(dQdx[li_S][A_S_Equ_GP_NodeOffset]);
    f_S_Equ_BS_Node_Ptr = &(dFdx[li_S][A_S_Equ_BS_NodeOffset]);
    q_S_Equ_BS_Node_Ptr = &(dQdx[li_S][A_S_Equ_BS_NodeOffset]);
    f_S_Equ_BD_Node_Ptr = &(dFdx[li_S][A_S_Equ_BD_NodeOffset]);
    q_S_Equ_BD_Node_Ptr = &(dQdx[li_S][A_S_Equ_BD_NodeOffset]);
    f_S_Equ_NOI2_Node_Ptr = &(dFdx[li_S][A_S_Equ_NOI2_NodeOffset]);
    q_S_Equ_NOI2_Node_Ptr = &(dQdx[li_S][A_S_Equ_NOI2_NodeOffset]);
    f_S_Equ_NOI_Node_Ptr = &(dFdx[li_S][A_S_Equ_NOI_NodeOffset]);
    q_S_Equ_NOI_Node_Ptr = &(dQdx[li_S][A_S_Equ_NOI_NodeOffset]);
    f_B_Equ_B_Node_Ptr = &(dFdx[li_B][A_B_Equ_B_NodeOffset]);
    q_B_Equ_B_Node_Ptr = &(dQdx[li_B][A_B_Equ_B_NodeOffset]);
    f_B_Equ_BI_Node_Ptr = &(dFdx[li_B][A_B_Equ_BI_NodeOffset]);
    q_B_Equ_BI_Node_Ptr = &(dQdx[li_B][A_B_Equ_BI_NodeOffset]);
    f_NOI_Equ_S_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_S_NodeOffset]);
    q_NOI_Equ_S_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_S_NodeOffset]);
    f_NOI_Equ_BP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
    q_NOI_Equ_BP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
    f_NOI_Equ_GP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
    q_NOI_Equ_GP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
    f_NOI_Equ_D_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_D_NodeOffset]);
    q_NOI_Equ_D_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_D_NodeOffset]);
    f_NOI_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
    q_NOI_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
    f_NOI_Equ_NOI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
    q_NOI_Equ_NOI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
    f_NOI2_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
    q_NOI2_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
    f_NOI2_Equ_S_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_S_NodeOffset]);
    q_NOI2_Equ_S_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_S_NodeOffset]);
    f_NOI2_Equ_BP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
    q_NOI2_Equ_BP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
    f_NOI2_Equ_GP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
    q_NOI2_Equ_GP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
    f_NOI2_Equ_D_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_D_NodeOffset]);
    q_NOI2_Equ_D_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_D_NodeOffset]);
    f_GP_Equ_S_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_S_NodeOffset]);
    q_GP_Equ_S_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_S_NodeOffset]);
    f_GP_Equ_BP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_BP_NodeOffset]);
    q_GP_Equ_BP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_BP_NodeOffset]);
    f_GP_Equ_D_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_D_NodeOffset]);
    q_GP_Equ_D_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_D_NodeOffset]);
    f_GP_Equ_GP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_GP_NodeOffset]);
    q_GP_Equ_GP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_GP_NodeOffset]);
    f_GP_Equ_G_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_G_NodeOffset]);
    q_GP_Equ_G_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_G_NodeOffset]);
    f_GP_Equ_NOI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
    q_GP_Equ_NOI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
    f_BP_Equ_S_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_S_NodeOffset]);
    q_BP_Equ_S_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_S_NodeOffset]);
    f_BP_Equ_BP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BP_NodeOffset]);
    q_BP_Equ_BP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BP_NodeOffset]);
    f_BP_Equ_D_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_D_NodeOffset]);
    q_BP_Equ_D_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_D_NodeOffset]);
    f_BP_Equ_GP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_GP_NodeOffset]);
    q_BP_Equ_GP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_GP_NodeOffset]);
    f_BP_Equ_BI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BI_NodeOffset]);
    q_BP_Equ_BI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BI_NodeOffset]);
    f_BI_Equ_BP_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BP_NodeOffset]);
    q_BI_Equ_BP_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BP_NodeOffset]);
    f_BI_Equ_BI_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BI_NodeOffset]);
    q_BI_Equ_BI_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BI_NodeOffset]);
    f_BI_Equ_BS_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BS_NodeOffset]);
    q_BI_Equ_BS_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BS_NodeOffset]);
    f_BI_Equ_BD_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BD_NodeOffset]);
    q_BI_Equ_BD_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BD_NodeOffset]);
    f_BI_Equ_B_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_B_NodeOffset]);
    q_BI_Equ_B_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_B_NodeOffset]);
    f_BS_Equ_S_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_S_NodeOffset]);
    q_BS_Equ_S_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_S_NodeOffset]);
    f_BS_Equ_BS_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BS_NodeOffset]);
    q_BS_Equ_BS_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BS_NodeOffset]);
    f_BS_Equ_D_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_D_NodeOffset]);
    q_BS_Equ_D_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_D_NodeOffset]);
    f_BS_Equ_BD_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BD_NodeOffset]);
    q_BS_Equ_BD_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BD_NodeOffset]);
    f_BS_Equ_BI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BI_NodeOffset]);
    q_BS_Equ_BI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BI_NodeOffset]);
    f_BS_Equ_BP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BP_NodeOffset]);
    q_BS_Equ_BP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BP_NodeOffset]);
    f_BS_Equ_GP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_GP_NodeOffset]);
    q_BS_Equ_GP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_GP_NodeOffset]);
    f_BD_Equ_S_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_S_NodeOffset]);
    q_BD_Equ_S_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_S_NodeOffset]);
    f_BD_Equ_BS_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BS_NodeOffset]);
    q_BD_Equ_BS_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BS_NodeOffset]);
    f_BD_Equ_D_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_D_NodeOffset]);
    q_BD_Equ_D_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_D_NodeOffset]);
    f_BD_Equ_BD_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BD_NodeOffset]);
    q_BD_Equ_BD_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BD_NodeOffset]);
    f_BD_Equ_BI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BI_NodeOffset]);
    q_BD_Equ_BI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BI_NodeOffset]);
    f_BD_Equ_BP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BP_NodeOffset]);
    q_BD_Equ_BP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BP_NodeOffset]);
    f_BD_Equ_GP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_GP_NodeOffset]);
    q_BD_Equ_GP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_GP_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_D] += staticContributions[admsNodeID_D];
(*extData.daeFVectorPtr)[li_G] += staticContributions[admsNodeID_G];
(*extData.daeFVectorPtr)[li_S] += staticContributions[admsNodeID_S];
(*extData.daeFVectorPtr)[li_B] += staticContributions[admsNodeID_B];
(*extData.daeFVectorPtr)[li_NOI] += staticContributions[admsNodeID_NOI];
(*extData.daeFVectorPtr)[li_NOI2] += staticContributions[admsNodeID_NOI2];
(*extData.daeFVectorPtr)[li_GP] += staticContributions[admsNodeID_GP];
(*extData.daeFVectorPtr)[li_BP] += staticContributions[admsNodeID_BP];
(*extData.daeFVectorPtr)[li_BI] += staticContributions[admsNodeID_BI];
(*extData.daeFVectorPtr)[li_BS] += staticContributions[admsNodeID_BS];
(*extData.daeFVectorPtr)[li_BD] += staticContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_iD] = leadCurrentF[admsNodeID_D];
    leadF[li_branch_iG] = leadCurrentF[admsNodeID_G];
    leadF[li_branch_iS] = leadCurrentF[admsNodeID_S];
    leadF[li_branch_iB] = leadCurrentF[admsNodeID_B];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_iD] = solVec[li_D] - solVec[li_S];
        junctionV[li_branch_iG] = solVec[li_G] - solVec[li_S];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_D] += dynamicContributions[admsNodeID_D];
(*extData.daeQVectorPtr)[li_G] += dynamicContributions[admsNodeID_G];
(*extData.daeQVectorPtr)[li_S] += dynamicContributions[admsNodeID_S];
(*extData.daeQVectorPtr)[li_B] += dynamicContributions[admsNodeID_B];
(*extData.daeQVectorPtr)[li_NOI] += dynamicContributions[admsNodeID_NOI];
(*extData.daeQVectorPtr)[li_NOI2] += dynamicContributions[admsNodeID_NOI2];
(*extData.daeQVectorPtr)[li_GP] += dynamicContributions[admsNodeID_GP];
(*extData.daeQVectorPtr)[li_BP] += dynamicContributions[admsNodeID_BP];
(*extData.daeQVectorPtr)[li_BI] += dynamicContributions[admsNodeID_BI];
(*extData.daeQVectorPtr)[li_BS] += dynamicContributions[admsNodeID_BS];
(*extData.daeQVectorPtr)[li_BD] += dynamicContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_iD] = leadCurrentQ[admsNodeID_D];
    leadQ[li_branch_iG] = leadCurrentQ[admsNodeID_G];
    leadQ[li_branch_iS] = leadCurrentQ[admsNodeID_S];
    leadQ[li_branch_iB] = leadCurrentQ[admsNodeID_B];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_ctype] = ctype;
  stoVec[li_store_sdint] = sdint;
  stoVec[li_store_ise] = ise;
  stoVec[li_store_ige] = ige;
  stoVec[li_store_ide] = ide;
  stoVec[li_store_ibe] = ibe;
  stoVec[li_store_ids] = ids;
  stoVec[li_store_idb] = idb;
  stoVec[li_store_isb] = isb;
  stoVec[li_store_igs] = igs;
  stoVec[li_store_igd] = igd;
  stoVec[li_store_igb] = igb;
  stoVec[li_store_igcs] = igcs;
  stoVec[li_store_igcd] = igcd;
  stoVec[li_store_iavl] = iavl;
  stoVec[li_store_igisl] = igisl;
  stoVec[li_store_igidl] = igidl;
  stoVec[li_store_ijs] = ijs;
  stoVec[li_store_ijsbot] = ijsbot;
  stoVec[li_store_ijsgat] = ijsgat;
  stoVec[li_store_ijssti] = ijssti;
  stoVec[li_store_ijd] = ijd;
  stoVec[li_store_ijdbot] = ijdbot;
  stoVec[li_store_ijdgat] = ijdgat;
  stoVec[li_store_ijdsti] = ijdsti;
  stoVec[li_store_vds] = vds;
  stoVec[li_store_vgs] = vgs;
  stoVec[li_store_vsb] = vsb;
  stoVec[li_store_vto] = vto;
  stoVec[li_store_vts] = vts;
  stoVec[li_store_vth] = vth;
  stoVec[li_store_vgt] = vgt;
  stoVec[li_store_vdss] = vdss;
  stoVec[li_store_vsat] = vsat;
  stoVec[li_store_gm] = gm;
  stoVec[li_store_gmb] = gmb;
  stoVec[li_store_gds] = gds;
  stoVec[li_store_gjs] = gjs;
  stoVec[li_store_gjd] = gjd;
  stoVec[li_store_cdd] = cdd;
  stoVec[li_store_cdg] = cdg;
  stoVec[li_store_cds] = cds;
  stoVec[li_store_cdb] = cdb;
  stoVec[li_store_cgd] = cgd;
  stoVec[li_store_cgg] = cgg;
  stoVec[li_store_cgs] = cgs;
  stoVec[li_store_cgb] = cgb;
  stoVec[li_store_csd] = csd;
  stoVec[li_store_csg] = csg;
  stoVec[li_store_css] = css;
  stoVec[li_store_csb] = csb;
  stoVec[li_store_cbd] = cbd;
  stoVec[li_store_cbg] = cbg;
  stoVec[li_store_cbs] = cbs;
  stoVec[li_store_cbb] = cbb;
  stoVec[li_store_cgsol] = cgsol;
  stoVec[li_store_cgdol] = cgdol;
  stoVec[li_store_cjs] = cjs;
  stoVec[li_store_cjsbot] = cjsbot;
  stoVec[li_store_cjsgat] = cjsgat;
  stoVec[li_store_cjssti] = cjssti;
  stoVec[li_store_cjd] = cjd;
  stoVec[li_store_cjdbot] = cjdbot;
  stoVec[li_store_cjdgat] = cjdgat;
  stoVec[li_store_cjdsti] = cjdsti;
  stoVec[li_store_weff] = weff;
  stoVec[li_store_leff] = leff;
  stoVec[li_store_u] = u;
  stoVec[li_store_rout] = rout;
  stoVec[li_store_vearly] = vearly;
  stoVec[li_store_beff] = beff;
  stoVec[li_store_fug] = fug;
  stoVec[li_store_rg] = rg;
  stoVec[li_store_sfl] = sfl;
  stoVec[li_store_sqrtsff] = sqrtsff;
  stoVec[li_store_sqrtsfw] = sqrtsfw;
  stoVec[li_store_sid] = sid;
  stoVec[li_store_sig] = sig;
  stoVec[li_store_cigid] = cigid;
  stoVec[li_store_fknee] = fknee;
  stoVec[li_store_sigs] = sigs;
  stoVec[li_store_sigd] = sigd;
  stoVec[li_store_siavl] = siavl;
  stoVec[li_store_ssi] = ssi;
  stoVec[li_store_sdi] = sdi;
  stoVec[li_store_lp_vfb] = lp_vfb;
  stoVec[li_store_lp_stvfb] = lp_stvfb;
  stoVec[li_store_lp_tox] = lp_tox;
  stoVec[li_store_lp_epsrox] = lp_epsrox;
  stoVec[li_store_lp_neff] = lp_neff;
  stoVec[li_store_lp_vnsub] = lp_vnsub;
  stoVec[li_store_lp_nslp] = lp_nslp;
  stoVec[li_store_lp_dnsub] = lp_dnsub;
  stoVec[li_store_lp_dphib] = lp_dphib;
  stoVec[li_store_lp_np] = lp_np;
  stoVec[li_store_lp_ct] = lp_ct;
  stoVec[li_store_lp_toxov] = lp_toxov;
  stoVec[li_store_lp_toxovd] = lp_toxovd;
  stoVec[li_store_lp_nov] = lp_nov;
  stoVec[li_store_lp_novd] = lp_novd;
  stoVec[li_store_lp_cf] = lp_cf;
  stoVec[li_store_lp_cfb] = lp_cfb;
  stoVec[li_store_lp_betn] = lp_betn;
  stoVec[li_store_lp_stbet] = lp_stbet;
  stoVec[li_store_lp_mue] = lp_mue;
  stoVec[li_store_lp_stmue] = lp_stmue;
  stoVec[li_store_lp_themu] = lp_themu;
  stoVec[li_store_lp_stthemu] = lp_stthemu;
  stoVec[li_store_lp_cs] = lp_cs;
  stoVec[li_store_lp_stcs] = lp_stcs;
  stoVec[li_store_lp_xcor] = lp_xcor;
  stoVec[li_store_lp_stxcor] = lp_stxcor;
  stoVec[li_store_lp_feta] = lp_feta;
  stoVec[li_store_lp_rs] = lp_rs;
  stoVec[li_store_lp_strs] = lp_strs;
  stoVec[li_store_lp_rsb] = lp_rsb;
  stoVec[li_store_lp_rsg] = lp_rsg;
  stoVec[li_store_lp_thesat] = lp_thesat;
  stoVec[li_store_lp_stthesat] = lp_stthesat;
  stoVec[li_store_lp_thesatb] = lp_thesatb;
  stoVec[li_store_lp_thesatg] = lp_thesatg;
  stoVec[li_store_lp_ax] = lp_ax;
  stoVec[li_store_lp_alp] = lp_alp;
  stoVec[li_store_lp_alp1] = lp_alp1;
  stoVec[li_store_lp_alp2] = lp_alp2;
  stoVec[li_store_lp_vp] = lp_vp;
  stoVec[li_store_lp_a1] = lp_a1;
  stoVec[li_store_lp_a2] = lp_a2;
  stoVec[li_store_lp_sta2] = lp_sta2;
  stoVec[li_store_lp_a3] = lp_a3;
  stoVec[li_store_lp_a4] = lp_a4;
  stoVec[li_store_lp_gco] = lp_gco;
  stoVec[li_store_lp_iginv] = lp_iginv;
  stoVec[li_store_lp_igov] = lp_igov;
  stoVec[li_store_lp_igovd] = lp_igovd;
  stoVec[li_store_lp_stig] = lp_stig;
  stoVec[li_store_lp_gc2] = lp_gc2;
  stoVec[li_store_lp_gc3] = lp_gc3;
  stoVec[li_store_lp_chib] = lp_chib;
  stoVec[li_store_lp_agidl] = lp_agidl;
  stoVec[li_store_lp_agidld] = lp_agidld;
  stoVec[li_store_lp_bgidl] = lp_bgidl;
  stoVec[li_store_lp_bgidld] = lp_bgidld;
  stoVec[li_store_lp_stbgidl] = lp_stbgidl;
  stoVec[li_store_lp_stbgidld] = lp_stbgidld;
  stoVec[li_store_lp_cgidl] = lp_cgidl;
  stoVec[li_store_lp_cgidld] = lp_cgidld;
  stoVec[li_store_lp_cox] = lp_cox;
  stoVec[li_store_lp_cgov] = lp_cgov;
  stoVec[li_store_lp_cgovd] = lp_cgovd;
  stoVec[li_store_lp_cgbov] = lp_cgbov;
  stoVec[li_store_lp_cfr] = lp_cfr;
  stoVec[li_store_lp_cfrd] = lp_cfrd;
  stoVec[li_store_lp_fnt] = lp_fnt;
  stoVec[li_store_lp_fntexc] = lp_fntexc;
  stoVec[li_store_lp_nfa] = lp_nfa;
  stoVec[li_store_lp_nfb] = lp_nfb;
  stoVec[li_store_lp_nfc] = lp_nfc;
  stoVec[li_store_lp_ef] = lp_ef;
  stoVec[li_store_lp_rg] = lp_rg;
  stoVec[li_store_lp_rbulk] = lp_rbulk;
  stoVec[li_store_lp_rwell] = lp_rwell;
  stoVec[li_store_lp_rjuns] = lp_rjuns;
  stoVec[li_store_lp_rjund] = lp_rjund;
  stoVec[li_store_tk] = tk;
  stoVec[li_store_cjosbot] = cjosbot;
  stoVec[li_store_cjossti] = cjossti;
  stoVec[li_store_cjosgat] = cjosgat;
  stoVec[li_store_vbisbot] = vbisbot;
  stoVec[li_store_vbissti] = vbissti;
  stoVec[li_store_vbisgat] = vbisgat;
  stoVec[li_store_idsatsbot] = idsatsbot;
  stoVec[li_store_idsatssti] = idsatssti;
  stoVec[li_store_idsatsgat] = idsatsgat;
  stoVec[li_store_cjosbotd] = cjosbotd;
  stoVec[li_store_cjosstid] = cjosstid;
  stoVec[li_store_cjosgatd] = cjosgatd;
  stoVec[li_store_vbisbotd] = vbisbotd;
  stoVec[li_store_vbisstid] = vbisstid;
  stoVec[li_store_vbisgatd] = vbisgatd;
  stoVec[li_store_idsatsbotd] = idsatsbotd;
  stoVec[li_store_idsatsstid] = idsatsstid;
  stoVec[li_store_idsatsgatd] = idsatsgatd;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one PSP102VA instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSPSP102VA::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double vth_i=0.0;
  double vts_i=0.0;
  double facvsb=0.0;
  double facvsb0=0.0;
  double P_D=0.0;
  double Vtovs=0.0;
     double d_Vtovs_dV_GP_S=0.0;
     double d_Vtovs_dV_D_S=0.0;
     double d_Vtovs_dV_S_BP=0.0;
  double Vtovd=0.0;
     double d_Vtovd_dV_GP_S=0.0;
     double d_Vtovd_dV_D_S=0.0;
     double d_Vtovd_dV_S_BP=0.0;
  double Igisl=0.0;
     double d_Igisl_dV_S_BP=0.0;
     double d_Igisl_dV_GP_S=0.0;
     double d_Igisl_dV_D_S=0.0;
  double Igidl=0.0;
     double d_Igidl_dV_D_S=0.0;
     double d_Igidl_dV_S_BP=0.0;
     double d_Igidl_dV_GP_S=0.0;
  double Sg=0.0;
     double d_Sg_dV_D_S=0.0;
     double d_Sg_dV_GP_S=0.0;
     double d_Sg_dV_S_BP=0.0;
  double igcd_h=0.0;
     double d_igcd_h_dV_D_S=0.0;
     double d_igcd_h_dV_GP_S=0.0;
     double d_igcd_h_dV_S_BP=0.0;
  double igc=0.0;
     double d_igc_dV_D_S=0.0;
     double d_igc_dV_GP_S=0.0;
     double d_igc_dV_S_BP=0.0;
  double xsq=0.0;
     double d_xsq_dV_D_S=0.0;
     double d_xsq_dV_GP_S=0.0;
     double d_xsq_dV_S_BP=0.0;
  double inv_ex=0.0;
     double d_inv_ex_dV_D_S=0.0;
     double d_inv_ex_dV_GP_S=0.0;
     double d_inv_ex_dV_S_BP=0.0;
  double ex=0.0;
     double d_ex_dV_D_S=0.0;
     double d_ex_dV_GP_S=0.0;
     double d_ex_dV_S_BP=0.0;
  double inv_x=0.0;
     double d_inv_x_dV_D_S=0.0;
     double d_inv_x_dV_GP_S=0.0;
     double d_inv_x_dV_S_BP=0.0;
  double Ag=0.0;
     double d_Ag_dV_GP_S=0.0;
     double d_Ag_dV_D_S=0.0;
     double d_Ag_dV_S_BP=0.0;
  double Bg=0.0;
     double d_Bg_dV_GP_S=0.0;
     double d_Bg_dV_D_S=0.0;
     double d_Bg_dV_S_BP=0.0;
  double u0_div_H=0.0;
     double d_u0_div_H_dV_GP_S=0.0;
     double d_u0_div_H_dV_D_S=0.0;
     double d_u0_div_H_dV_S_BP=0.0;
  double x=0.0;
     double d_x_dV_D_S=0.0;
     double d_x_dV_GP_S=0.0;
     double d_x_dV_S_BP=0.0;
  double u0=0.0;
     double d_u0_dV_GP_S=0.0;
     double d_u0_dV_D_S=0.0;
     double d_u0_dV_S_BP=0.0;
  double Igc0=0.0;
     double d_Igc0_dV_GP_S=0.0;
     double d_Igc0_dV_D_S=0.0;
     double d_Igc0_dV_S_BP=0.0;
  double Vm=0.0;
     double d_Vm_dV_D_S=0.0;
     double d_Vm_dV_S_BP=0.0;
     double d_Vm_dV_GP_S=0.0;
  double TP=0.0;
     double d_TP_dV_GP_S=0.0;
     double d_TP_dV_D_S=0.0;
     double d_TP_dV_S_BP=0.0;
  double Dgate=0.0;
     double d_Dgate_dV_D_S=0.0;
     double d_Dgate_dV_S_BP=0.0;
     double d_Dgate_dV_GP_S=0.0;
  double Dsi=0.0;
     double d_Dsi_dV_D_S=0.0;
     double d_Dsi_dV_S_BP=0.0;
     double d_Dsi_dV_GP_S=0.0;
  double arg1=0.0;
     double d_arg1_dV_D_S=0.0;
     double d_arg1_dV_S_BP=0.0;
     double d_arg1_dV_GP_S=0.0;
  double zg=0.0;
     double d_zg_dV_GP_S=0.0;
     double d_zg_dV_D_S=0.0;
     double d_zg_dV_S_BP=0.0;
  double psi_t=0.0;
     double d_psi_t_dV_GP_S=0.0;
     double d_psi_t_dV_D_S=0.0;
     double d_psi_t_dV_S_BP=0.0;
  double arg2mina=0.0;
     double d_arg2mina_dV_GP_S=0.0;
     double d_arg2mina_dV_D_S=0.0;
     double d_arg2mina_dV_S_BP=0.0;
  double Igb=0.0;
     double d_Igb_dV_GP_S=0.0;
     double d_Igb_dV_D_S=0.0;
     double d_Igb_dV_S_BP=0.0;
  double Igc=0.0;
     double d_Igc_dV_GP_S=0.0;
     double d_Igc_dV_D_S=0.0;
     double d_Igc_dV_S_BP=0.0;
  double SP_OV_w=0.0;
     double d_SP_OV_w_dV_GP_S=0.0;
     double d_SP_OV_w_dV_D_S=0.0;
     double d_SP_OV_w_dV_S_BP=0.0;
  double SP_OV_xi=0.0;
     double d_SP_OV_xi_dV_GP_S=0.0;
     double d_SP_OV_xi_dV_D_S=0.0;
     double d_SP_OV_xi_dV_S_BP=0.0;
  double SP_OV_q=0.0;
     double d_SP_OV_q_dV_GP_S=0.0;
     double d_SP_OV_q_dV_D_S=0.0;
     double d_SP_OV_q_dV_S_BP=0.0;
  double SP_OV_p=0.0;
     double d_SP_OV_p_dV_GP_S=0.0;
     double d_SP_OV_p_dV_D_S=0.0;
     double d_SP_OV_p_dV_S_BP=0.0;
  double SP_OV_temp=0.0;
     double d_SP_OV_temp_dV_GP_S=0.0;
     double d_SP_OV_temp_dV_D_S=0.0;
     double d_SP_OV_temp_dV_S_BP=0.0;
  double SP_OV_D0=0.0;
     double d_SP_OV_D0_dV_GP_S=0.0;
     double d_SP_OV_D0_dV_D_S=0.0;
     double d_SP_OV_D0_dV_S_BP=0.0;
  double SP_OV_y0=0.0;
     double d_SP_OV_y0_dV_GP_S=0.0;
     double d_SP_OV_y0_dV_D_S=0.0;
     double d_SP_OV_y0_dV_S_BP=0.0;
  double SP_OV_tau=0.0;
     double d_SP_OV_tau_dV_D_S=0.0;
     double d_SP_OV_tau_dV_GP_S=0.0;
  double SP_OV_c=0.0;
     double d_SP_OV_c_dV_D_S=0.0;
     double d_SP_OV_c_dV_GP_S=0.0;
  double SP_OV_a=0.0;
     double d_SP_OV_a_dV_D_S=0.0;
     double d_SP_OV_a_dV_GP_S=0.0;
  double SP_OV_eta=0.0;
     double d_SP_OV_eta_dV_D_S=0.0;
     double d_SP_OV_eta_dV_GP_S=0.0;
  double SP_OV_z=0.0;
     double d_SP_OV_z_dV_D_S=0.0;
     double d_SP_OV_z_dV_GP_S=0.0;
  double SP_OV_yg=0.0;
     double d_SP_OV_yg_dV_D_S=0.0;
     double d_SP_OV_yg_dV_GP_S=0.0;
  double SP_OV_u=0.0;
     double d_SP_OV_u_dV_GP_S=0.0;
     double d_SP_OV_u_dV_D_S=0.0;
     double d_SP_OV_u_dV_S_BP=0.0;
  double SP_OV_x0=0.0;
     double d_SP_OV_x0_dV_GP_S=0.0;
     double d_SP_OV_x0_dV_D_S=0.0;
     double d_SP_OV_x0_dV_S_BP=0.0;
  double SP_OV_xbar=0.0;
     double d_SP_OV_xbar_dV_D_S=0.0;
     double d_SP_OV_xbar_dV_GP_S=0.0;
  double SP_OV_Afac=0.0;
  double inv_xg1=0.0;
  double x_mrg_ov=0.0;
  double inv_xi_ov=0.0;
  double xi_ov=0.0;
  double GOV2=0.0;
  double GOV=0.0;
  double Vdsat=0.0;
     double d_Vdsat_dV_D_S=0.0;
     double d_Vdsat_dV_GP_S=0.0;
     double d_Vdsat_dV_S_BP=0.0;
  double qeff=0.0;
     double d_qeff_dV_D_S=0.0;
     double d_qeff_dV_GP_S=0.0;
     double d_qeff_dV_S_BP=0.0;
  double Voxm=0.0;
     double d_Voxm_dV_D_S=0.0;
     double d_Voxm_dV_GP_S=0.0;
     double d_Voxm_dV_S_BP=0.0;
  double qis=0.0;
     double d_qis_dV_D_S=0.0;
     double d_qis_dV_GP_S=0.0;
     double d_qis_dV_S_BP=0.0;
  double delVsat=0.0;
     double d_delVsat_dV_D_S=0.0;
     double d_delVsat_dV_GP_S=0.0;
     double d_delVsat_dV_S_BP=0.0;
  double alpha1=0.0;
     double d_alpha1_dV_D_S=0.0;
     double d_alpha1_dV_GP_S=0.0;
     double d_alpha1_dV_S_BP=0.0;
  double zsat=0.0;
     double d_zsat_dV_GP_S=0.0;
     double d_zsat_dV_D_S=0.0;
     double d_zsat_dV_S_BP=0.0;
  double dL1=0.0;
     double d_dL1_dV_GP_S=0.0;
     double d_dL1_dV_D_S=0.0;
     double d_dL1_dV_S_BP=0.0;
  double dL=0.0;
     double d_dL_dV_GP_S=0.0;
     double d_dL_dV_D_S=0.0;
     double d_dL_dV_S_BP=0.0;
  double r2=0.0;
     double d_r2_dV_D_S=0.0;
     double d_r2_dV_GP_S=0.0;
     double d_r2_dV_S_BP=0.0;
  double r1=0.0;
     double d_r1_dV_D_S=0.0;
     double d_r1_dV_GP_S=0.0;
     double d_r1_dV_S_BP=0.0;
  double qbm=0.0;
     double d_qbm_dV_D_S=0.0;
     double d_qbm_dV_GP_S=0.0;
     double d_qbm_dV_S_BP=0.0;
  double qim1_1=0.0;
     double d_qim1_1_dV_D_S=0.0;
     double d_qim1_1_dV_GP_S=0.0;
     double d_qim1_1_dV_S_BP=0.0;
  double Pm=0.0;
     double d_Pm_dV_D_S=0.0;
     double d_Pm_dV_GP_S=0.0;
     double d_Pm_dV_S_BP=0.0;
  double help=0.0;
     double d_help_dV_D_S=0.0;
     double d_help_dV_GP_S=0.0;
     double d_help_dV_S_BP=0.0;
  double km=0.0;
     double d_km_dV_GP_S=0.0;
     double d_km_dV_D_S=0.0;
     double d_km_dV_S_BP=0.0;
  double u_pd=0.0;
     double d_u_pd_dV_GP_S=0.0;
     double d_u_pd_dV_D_S=0.0;
     double d_u_pd_dV_S_BP=0.0;
  double xi_pd=0.0;
     double d_xi_pd_dV_D_S=0.0;
     double d_xi_pd_dV_GP_S=0.0;
     double d_xi_pd_dV_S_BP=0.0;
  double q_pd=0.0;
     double d_q_pd_dV_GP_S=0.0;
     double d_q_pd_dV_D_S=0.0;
     double d_q_pd_dV_S_BP=0.0;
  double p_pd=0.0;
     double d_p_pd_dV_D_S=0.0;
     double d_p_pd_dV_GP_S=0.0;
     double d_p_pd_dV_S_BP=0.0;
  double x_pm=0.0;
     double d_x_pm_dV_GP_S=0.0;
     double d_x_pm_dV_D_S=0.0;
     double d_x_pm_dV_S_BP=0.0;
  double d0=0.0;
     double d_d0_dV_D_S=0.0;
     double d_d0_dV_GP_S=0.0;
     double d_d0_dV_S_BP=0.0;
  double D_bar=0.0;
     double d_D_bar_dV_D_S=0.0;
     double d_D_bar_dV_GP_S=0.0;
     double d_D_bar_dV_S_BP=0.0;
  double xi0d=0.0;
     double d_xi0d_dV_D_S=0.0;
     double d_xi0d_dV_GP_S=0.0;
     double d_xi0d_dV_S_BP=0.0;
  double qC=0.0;
     double d_qC_dV_D_S=0.0;
     double d_qC_dV_GP_S=0.0;
     double d_qC_dV_S_BP=0.0;
  double pC=0.0;
     double d_pC_dV_D_S=0.0;
     double d_pC_dV_GP_S=0.0;
     double d_pC_dV_S_BP=0.0;
  double delta_nd=0.0;
     double d_delta_nd_dV_D_S=0.0;
     double d_delta_nd_dV_S_BP=0.0;
     double d_delta_nd_dV_GP_S=0.0;
  double k_ds=0.0;
     double d_k_ds_dV_GP_S=0.0;
     double d_k_ds_dV_S_BP=0.0;
     double d_k_ds_dV_D_S=0.0;
  double xn_d=0.0;
     double d_xn_d_dV_D_S=0.0;
     double d_xn_d_dV_S_BP=0.0;
     double d_xn_d_dV_GP_S=0.0;
  double Phi_sat=0.0;
     double d_Phi_sat_dV_D_S=0.0;
     double d_Phi_sat_dV_GP_S=0.0;
     double d_Phi_sat_dV_S_BP=0.0;
  double Phi0_Phi2=0.0;
     double d_Phi0_Phi2_dV_D_S=0.0;
     double d_Phi0_Phi2_dV_GP_S=0.0;
     double d_Phi0_Phi2_dV_S_BP=0.0;
  double Phi_0_2=0.0;
     double d_Phi_0_2_dV_D_S=0.0;
     double d_Phi_0_2_dV_GP_S=0.0;
     double d_Phi_0_2_dV_S_BP=0.0;
  double Phi_2=0.0;
     double d_Phi_2_dV_D_S=0.0;
     double d_Phi_2_dV_GP_S=0.0;
     double d_Phi_2_dV_S_BP=0.0;
  double asat=0.0;
     double d_asat_dV_D_S=0.0;
     double d_asat_dV_GP_S=0.0;
     double d_asat_dV_S_BP=0.0;
  double Phi_0=0.0;
     double d_Phi_0_dV_D_S=0.0;
     double d_Phi_0_dV_GP_S=0.0;
     double d_Phi_0_dV_S_BP=0.0;
  double temp1=0.0;
     double d_temp1_dV_GP_S=0.0;
     double d_temp1_dV_D_S=0.0;
     double d_temp1_dV_S_BP=0.0;
  double za=0.0;
     double d_za_dV_GP_S=0.0;
     double d_za_dV_D_S=0.0;
     double d_za_dV_S_BP=0.0;
  double ysat=0.0;
     double d_ysat_dV_GP_S=0.0;
     double d_ysat_dV_D_S=0.0;
     double d_ysat_dV_S_BP=0.0;
  double phi_inf=0.0;
     double d_phi_inf_dV_D_S=0.0;
     double d_phi_inf_dV_GP_S=0.0;
     double d_phi_inf_dV_S_BP=0.0;
  double wsat=0.0;
     double d_wsat_dV_D_S=0.0;
     double d_wsat_dV_GP_S=0.0;
     double d_wsat_dV_S_BP=0.0;
  double temp2=0.0;
     double d_temp2_dV_D_S=0.0;
     double d_temp2_dV_GP_S=0.0;
     double d_temp2_dV_S_BP=0.0;
  double Mutmp=0.0;
     double d_Mutmp_dV_D_S=0.0;
     double d_Mutmp_dV_GP_S=0.0;
     double d_Mutmp_dV_S_BP=0.0;
  double Eeffm=0.0;
     double d_Eeffm_dV_D_S=0.0;
     double d_Eeffm_dV_GP_S=0.0;
     double d_Eeffm_dV_S_BP=0.0;
  double GR=0.0;
     double d_GR_dV_D_S=0.0;
     double d_GR_dV_S_BP=0.0;
     double d_GR_dV_GP_S=0.0;
  double qbs=0.0;
     double d_qbs_dV_D_S=0.0;
     double d_qbs_dV_GP_S=0.0;
     double d_qbs_dV_S_BP=0.0;
  double xgs=0.0;
     double d_xgs_dV_D_S=0.0;
     double d_xgs_dV_GP_S=0.0;
     double d_xgs_dV_S_BP=0.0;
  double Rxcor=0.0;
     double d_Rxcor_dV_D_S=0.0;
     double d_Rxcor_dV_S_BP=0.0;
  double Dd=0.0;
     double d_Dd_dV_D_S=0.0;
     double d_Dd_dV_GP_S=0.0;
     double d_Dd_dV_S_BP=0.0;
  double Dm=0.0;
     double d_Dm_dV_D_S=0.0;
     double d_Dm_dV_GP_S=0.0;
     double d_Dm_dV_S_BP=0.0;
  double Ed=0.0;
     double d_Ed_dV_D_S=0.0;
     double d_Ed_dV_GP_S=0.0;
     double d_Ed_dV_S_BP=0.0;
  double Em=0.0;
     double d_Em_dV_D_S=0.0;
     double d_Em_dV_GP_S=0.0;
     double d_Em_dV_S_BP=0.0;
  double Ps=0.0;
     double d_Ps_dV_D_S=0.0;
     double d_Ps_dV_GP_S=0.0;
     double d_Ps_dV_S_BP=0.0;
  double Ds=0.0;
     double d_Ds_dV_D_S=0.0;
     double d_Ds_dV_GP_S=0.0;
     double d_Ds_dV_S_BP=0.0;
  double Es=0.0;
     double d_Es_dV_D_S=0.0;
     double d_Es_dV_GP_S=0.0;
     double d_Es_dV_S_BP=0.0;
  double xi2s=0.0;
     double d_xi2s_dV_GP_S=0.0;
     double d_xi2s_dV_D_S=0.0;
     double d_xi2s_dV_S_BP=0.0;
  double xi1s=0.0;
     double d_xi1s_dV_D_S=0.0;
     double d_xi1s_dV_GP_S=0.0;
     double d_xi1s_dV_S_BP=0.0;
  double xi0s=0.0;
     double d_xi0s_dV_D_S=0.0;
     double d_xi0s_dV_GP_S=0.0;
     double d_xi0s_dV_S_BP=0.0;
  double delta_1s=0.0;
     double d_delta_1s_dV_D_S=0.0;
     double d_delta_1s_dV_GP_S=0.0;
     double d_delta_1s_dV_S_BP=0.0;
  double x_ds=0.0;
     double d_x_ds_dV_D_S=0.0;
     double d_x_ds_dV_GP_S=0.0;
     double d_x_ds_dV_S_BP=0.0;
  double x_m=0.0;
     double d_x_m_dV_D_S=0.0;
     double d_x_m_dV_GP_S=0.0;
     double d_x_m_dV_S_BP=0.0;
  double x_d=0.0;
     double d_x_d_dV_D_S=0.0;
     double d_x_d_dV_GP_S=0.0;
     double d_x_d_dV_S_BP=0.0;
  double SP_S_temp1=0.0;
     double d_SP_S_temp1_dV_D_S=0.0;
     double d_SP_S_temp1_dV_GP_S=0.0;
     double d_SP_S_temp1_dV_S_BP=0.0;
  double SP_S_qC=0.0;
     double d_SP_S_qC_dV_D_S=0.0;
     double d_SP_S_qC_dV_GP_S=0.0;
     double d_SP_S_qC_dV_S_BP=0.0;
  double SP_S_pC=0.0;
     double d_SP_S_pC_dV_D_S=0.0;
     double d_SP_S_pC_dV_GP_S=0.0;
     double d_SP_S_pC_dV_S_BP=0.0;
  double SP_S_xi2=0.0;
     double d_SP_S_xi2_dV_D_S=0.0;
     double d_SP_S_xi2_dV_GP_S=0.0;
     double d_SP_S_xi2_dV_S_BP=0.0;
  double SP_S_xi1=0.0;
     double d_SP_S_xi1_dV_D_S=0.0;
     double d_SP_S_xi1_dV_GP_S=0.0;
     double d_SP_S_xi1_dV_S_BP=0.0;
  double SP_S_xi0=0.0;
     double d_SP_S_xi0_dV_D_S=0.0;
     double d_SP_S_xi0_dV_GP_S=0.0;
     double d_SP_S_xi0_dV_S_BP=0.0;
  double SP_S_delta1=0.0;
     double d_SP_S_delta1_dV_D_S=0.0;
     double d_SP_S_delta1_dV_GP_S=0.0;
     double d_SP_S_delta1_dV_S_BP=0.0;
  double SP_S_delta0=0.0;
     double d_SP_S_delta0_dV_D_S=0.0;
     double d_SP_S_delta0_dV_GP_S=0.0;
     double d_SP_S_delta0_dV_S_BP=0.0;
  double SP_S_y0=0.0;
     double d_SP_S_y0_dV_D_S=0.0;
     double d_SP_S_y0_dV_GP_S=0.0;
     double d_SP_S_y0_dV_S_BP=0.0;
  double mutau=0.0;
     double d_mutau_dV_D_S=0.0;
     double d_mutau_dV_GP_S=0.0;
     double d_mutau_dV_S_BP=0.0;
  double nu=0.0;
     double d_nu_dV_D_S=0.0;
     double d_nu_dV_GP_S=0.0;
     double d_nu_dV_S_BP=0.0;
  double SP_S_tau=0.0;
     double d_SP_S_tau_dV_D_S=0.0;
     double d_SP_S_tau_dV_GP_S=0.0;
     double d_SP_S_tau_dV_S_BP=0.0;
  double SP_S_c=0.0;
     double d_SP_S_c_dV_D_S=0.0;
     double d_SP_S_c_dV_GP_S=0.0;
     double d_SP_S_c_dV_S_BP=0.0;
  double SP_S_a=0.0;
     double d_SP_S_a_dV_D_S=0.0;
     double d_SP_S_a_dV_GP_S=0.0;
     double d_SP_S_a_dV_S_BP=0.0;
  double SP_S_temp=0.0;
     double d_SP_S_temp_dV_D_S=0.0;
     double d_SP_S_temp_dV_GP_S=0.0;
     double d_SP_S_temp_dV_S_BP=0.0;
  double SP_S_eta=0.0;
     double d_SP_S_eta_dV_D_S=0.0;
     double d_SP_S_eta_dV_GP_S=0.0;
     double d_SP_S_eta_dV_S_BP=0.0;
  double SP_S_ysub=0.0;
     double d_SP_S_ysub_dV_D_S=0.0;
     double d_SP_S_ysub_dV_GP_S=0.0;
     double d_SP_S_ysub_dV_S_BP=0.0;
  double SP_S_yg=0.0;
     double d_SP_S_yg_dV_D_S=0.0;
     double d_SP_S_yg_dV_GP_S=0.0;
     double d_SP_S_yg_dV_S_BP=0.0;
  double SP_S_x0=0.0;
     double d_SP_S_x0_dV_D_S=0.0;
     double d_SP_S_x0_dV_GP_S=0.0;
     double d_SP_S_x0_dV_S_BP=0.0;
  double SP_S_b=0.0;
     double d_SP_S_b_dV_D_S=0.0;
     double d_SP_S_b_dV_GP_S=0.0;
     double d_SP_S_b_dV_S_BP=0.0;
  double SP_S_temp2=0.0;
     double d_SP_S_temp2_dV_D_S=0.0;
     double d_SP_S_temp2_dV_GP_S=0.0;
     double d_SP_S_temp2_dV_S_BP=0.0;
  double SP_S_bx=0.0;
     double d_SP_S_bx_dV_GP_S=0.0;
     double d_SP_S_bx_dV_D_S=0.0;
     double d_SP_S_bx_dV_S_BP=0.0;
  double SP_S_w=0.0;
     double d_SP_S_w_dV_D_S=0.0;
     double d_SP_S_w_dV_GP_S=0.0;
     double d_SP_S_w_dV_S_BP=0.0;
  double SP_S_xbar=0.0;
     double d_SP_S_xbar_dV_D_S=0.0;
     double d_SP_S_xbar_dV_GP_S=0.0;
     double d_SP_S_xbar_dV_S_BP=0.0;
  double SP_S_A_fac=0.0;
     double d_SP_S_A_fac_dV_D_S=0.0;
     double d_SP_S_A_fac_dV_GP_S=0.0;
     double d_SP_S_A_fac_dV_S_BP=0.0;
  double SP_xg1=0.0;
     double d_SP_xg1_dV_D_S=0.0;
     double d_SP_xg1_dV_GP_S=0.0;
     double d_SP_xg1_dV_S_BP=0.0;
  double margin=0.0;
     double d_margin_dV_D_S=0.0;
     double d_margin_dV_GP_S=0.0;
     double d_margin_dV_S_BP=0.0;
  double delta_ns=0.0;
     double d_delta_ns_dV_D_S=0.0;
     double d_delta_ns_dV_S_BP=0.0;
  double xn_s=0.0;
     double d_xn_s_dV_D_S=0.0;
     double d_xn_s_dV_S_BP=0.0;
  double Ux=0.0;
     double d_Ux_dV_D_S=0.0;
     double d_Ux_dV_S_BP=0.0;
  double inv_xi=0.0;
     double d_inv_xi_dV_D_S=0.0;
     double d_inv_xi_dV_GP_S=0.0;
     double d_inv_xi_dV_S_BP=0.0;
  double xi=0.0;
     double d_xi_dV_D_S=0.0;
     double d_xi_dV_GP_S=0.0;
     double d_xi_dV_S_BP=0.0;
  double inv_Gf2=0.0;
     double d_inv_Gf2_dV_D_S=0.0;
     double d_inv_Gf2_dV_GP_S=0.0;
     double d_inv_Gf2_dV_S_BP=0.0;
  double Gf2=0.0;
     double d_Gf2_dV_D_S=0.0;
     double d_Gf2_dV_GP_S=0.0;
     double d_Gf2_dV_S_BP=0.0;
  double Gf=0.0;
     double d_Gf_dV_D_S=0.0;
     double d_Gf_dV_GP_S=0.0;
     double d_Gf_dV_S_BP=0.0;
  double Dnsub=0.0;
     double d_Dnsub_dV_D_S=0.0;
     double d_Dnsub_dV_GP_S=0.0;
     double d_Dnsub_dV_S_BP=0.0;
  double delVg=0.0;
     double d_delVg_dV_D_S=0.0;
     double d_delVg_dV_S_BP=0.0;
  double Vsbx=0.0;
     double d_Vsbx_dV_D_S=0.0;
     double d_Vsbx_dV_S_BP=0.0;
  double Vdsx=0.0;
     double d_Vdsx_dV_D_S=0.0;
  double Vgb1=0.0;
     double d_Vgb1_dV_D_S=0.0;
     double d_Vgb1_dV_GP_S=0.0;
     double d_Vgb1_dV_S_BP=0.0;
  double Vgbstar=0.0;
     double d_Vgbstar_dV_D_S=0.0;
     double d_Vgbstar_dV_GP_S=0.0;
     double d_Vgbstar_dV_S_BP=0.0;
  double Vdbstar=0.0;
  double Vsbstar=0.0;
     double d_Vsbstar_dV_D_S=0.0;
     double d_Vsbstar_dV_S_BP=0.0;
  double temp=0.0;
     double d_temp_dV_GP_S=0.0;
     double d_temp_dV_D_S=0.0;
     double d_temp_dV_S_BP=0.0;
  double Vdb=0.0;
     double d_Vdb_dV_D_S=0.0;
     double d_Vdb_dV_S_BP=0.0;
  double Vgd=0.0;
  double xgd_ov=0.0;
     double d_xgd_ov_dV_GP_S=0.0;
     double d_xgd_ov_dV_D_S=0.0;
  double xgs_ov=0.0;
     double d_xgs_ov_dV_GP_S=0.0;
  double VgdPrime=0.0;
     double d_VgdPrime_dV_GP_S=0.0;
     double d_VgdPrime_dV_D_S=0.0;
  double VdbPrime=0.0;
     double d_VdbPrime_dV_D_S=0.0;
     double d_VdbPrime_dV_S_BP=0.0;
  double VsbPrime=0.0;
     double d_VsbPrime_dV_S_BP=0.0;
  double VgsPrime=0.0;
     double d_VgsPrime_dV_GP_S=0.0;
  double Vjun_d=0.0;
     double d_Vjun_d_dV_D_BD=0.0;
  double Vjun_s=0.0;
     double d_Vjun_s_dV_S_BS=0.0;
  double Vsb=0.0;
     double d_Vsb_dV_D_S=0.0;
     double d_Vsb_dV_S_BP=0.0;
  double Vds=0.0;
     double d_Vds_dV_D_S=0.0;
  double Vgs=0.0;
     double d_Vgs_dV_D_S=0.0;
     double d_Vgs_dV_GP_S=0.0;
  double Vrwell=0.0;
  double Vrbulk=0.0;
  double Vrjund=0.0;
  double Vrjuns=0.0;
  double Vrg=0.0;
  double Vovd=0.0;
     double d_Vovd_dV_GP_S=0.0;
     double d_Vovd_dV_D_S=0.0;
     double d_Vovd_dV_S_BP=0.0;
  double Vovs=0.0;
     double d_Vovs_dV_GP_S=0.0;
     double d_Vovs_dV_D_S=0.0;
     double d_Vovs_dV_S_BP=0.0;
  double xd_ov=0.0;
     double d_xd_ov_dV_S_BP=0.0;
     double d_xd_ov_dV_GP_S=0.0;
     double d_xd_ov_dV_D_S=0.0;
  double xs_ov=0.0;
     double d_xs_ov_dV_D_S=0.0;
     double d_xs_ov_dV_S_BP=0.0;
     double d_xs_ov_dV_GP_S=0.0;
  double xgm=0.0;
     double d_xgm_dV_D_S=0.0;
     double d_xgm_dV_GP_S=0.0;
     double d_xgm_dV_S_BP=0.0;
  double thesat1=0.0;
     double d_thesat1_dV_GP_S=0.0;
     double d_thesat1_dV_D_S=0.0;
     double d_thesat1_dV_S_BP=0.0;
  double QCLM=0.0;
     double d_QCLM_dV_GP_S=0.0;
     double d_QCLM_dV_D_S=0.0;
     double d_QCLM_dV_S_BP=0.0;
  double Udse=0.0;
     double d_Udse_dV_GP_S=0.0;
     double d_Udse_dV_S_BP=0.0;
     double d_Udse_dV_D_S=0.0;
  double GdL=0.0;
     double d_GdL_dV_GP_S=0.0;
     double d_GdL_dV_D_S=0.0;
     double d_GdL_dV_S_BP=0.0;
  double rhob=0.0;
     double d_rhob_dV_D_S=0.0;
     double d_rhob_dV_S_BP=0.0;
  double sqm=0.0;
     double d_sqm_dV_D_S=0.0;
     double d_sqm_dV_GP_S=0.0;
     double d_sqm_dV_S_BP=0.0;
  double x_s=0.0;
     double d_x_s_dV_D_S=0.0;
     double d_x_s_dV_GP_S=0.0;
     double d_x_s_dV_S_BP=0.0;
  double SP_S_x1=0.0;
     double d_SP_S_x1_dV_D_S=0.0;
     double d_SP_S_x1_dV_GP_S=0.0;
     double d_SP_S_x1_dV_S_BP=0.0;
  double Qfgd=0.0;
     double d_Qfgd_dV_S_BP=0.0;
     double d_Qfgd_dV_GP_S=0.0;
     double d_Qfgd_dV_D_S=0.0;
  double Qfgs=0.0;
     double d_Qfgs_dV_D_S=0.0;
     double d_Qfgs_dV_S_BP=0.0;
     double d_Qfgs_dV_GP_S=0.0;
  double Qgb_ov=0.0;
     double d_Qgb_ov_dV_D_S=0.0;
     double d_Qgb_ov_dV_GP_S=0.0;
     double d_Qgb_ov_dV_S_BP=0.0;
  double Qgd_ov=0.0;
     double d_Qgd_ov_dV_GP_S=0.0;
     double d_Qgd_ov_dV_D_S=0.0;
     double d_Qgd_ov_dV_S_BP=0.0;
  double Qgs_ov=0.0;
     double d_Qgs_ov_dV_GP_S=0.0;
     double d_Qgs_ov_dV_D_S=0.0;
     double d_Qgs_ov_dV_S_BP=0.0;
  double Qb=0.0;
     double d_Qb_dV_D_S=0.0;
     double d_Qb_dV_GP_S=0.0;
     double d_Qb_dV_S_BP=0.0;
  double Qd=0.0;
     double d_Qd_dV_GP_S=0.0;
     double d_Qd_dV_D_S=0.0;
     double d_Qd_dV_S_BP=0.0;
  double Qg=0.0;
     double d_Qg_dV_D_S=0.0;
     double d_Qg_dV_GP_S=0.0;
     double d_Qg_dV_S_BP=0.0;
  double QB=0.0;
     double d_QB_dV_D_S=0.0;
     double d_QB_dV_GP_S=0.0;
     double d_QB_dV_S_BP=0.0;
  double QD=0.0;
     double d_QD_dV_GP_S=0.0;
     double d_QD_dV_D_S=0.0;
     double d_QD_dV_S_BP=0.0;
  double QI=0.0;
     double d_QI_dV_GP_S=0.0;
     double d_QI_dV_D_S=0.0;
     double d_QI_dV_S_BP=0.0;
  double QG=0.0;
     double d_QG_dV_D_S=0.0;
     double d_QG_dV_GP_S=0.0;
     double d_QG_dV_S_BP=0.0;
  double Fj2=0.0;
     double d_Fj2_dV_D_S=0.0;
     double d_Fj2_dV_GP_S=0.0;
     double d_Fj2_dV_S_BP=0.0;
  double Fj=0.0;
     double d_Fj_dV_D_S=0.0;
     double d_Fj_dV_GP_S=0.0;
     double d_Fj_dV_S_BP=0.0;
  double Vgb=0.0;
     double d_Vgb_dV_D_S=0.0;
     double d_Vgb_dV_GP_S=0.0;
     double d_Vgb_dV_S_BP=0.0;
  double rwellnoise=0.0;
  double rjundnoise=0.0;
  double rjunsnoise=0.0;
  double rbulknoise=0.0;
  double rgatenoise=0.0;
  double h1=0.0;
  double h2=0.0;
  double h2d=0.0;
     double d_h2d_dV_D_BD=0.0;
     double d_h2d_dV_S_BS=0.0;
  double h3=0.0;
     double d_h3_dV_D_BD=0.0;
     double d_h3_dV_S_BS=0.0;
  double h4=0.0;
     double d_h4_dV_D_BD=0.0;
     double d_h4_dV_S_BS=0.0;
  double h5=0.0;
     double d_h5_dV_D_BD=0.0;
     double d_h5_dV_S_BS=0.0;
  double ijunrev=0.0;
     double d_ijunrev_dV_D_BD=0.0;
     double d_ijunrev_dV_S_BS=0.0;
  double ijunfor2=0.0;
     double d_ijunfor2_dV_D_BD=0.0;
     double d_ijunfor2_dV_S_BS=0.0;
  double ijunfor1=0.0;
     double d_ijunfor1_dV_D_BD=0.0;
     double d_ijunfor1_dV_S_BS=0.0;
  double tm1=0.0;
     double d_tm1_dV_D_BD=0.0;
     double d_tm1_dV_S_BS=0.0;
  double tm0=0.0;
     double d_tm0_dV_D_BD=0.0;
     double d_tm0_dV_S_BS=0.0;
  double fbreakdown=0.0;
     double d_fbreakdown_dV_S_BS=0.0;
     double d_fbreakdown_dV_D_BD=0.0;
  double ibbt=0.0;
     double d_ibbt_dV_S_BS=0.0;
     double d_ibbt_dV_D_BD=0.0;
  double Fmaxr=0.0;
     double d_Fmaxr_dV_S_BS=0.0;
     double d_Fmaxr_dV_D_BD=0.0;
  double itat=0.0;
     double d_itat_dV_S_BS=0.0;
     double d_itat_dV_D_BD=0.0;
  double gammamax=0.0;
     double d_gammamax_dV_S_BS=0.0;
     double d_gammamax_dV_D_BD=0.0;
  double erfctimesexpmtat=0.0;
     double d_erfctimesexpmtat_dV_S_BS=0.0;
     double d_erfctimesexpmtat_dV_D_BD=0.0;
  double erfcpos=0.0;
     double d_erfcpos_dV_S_BS=0.0;
     double d_erfcpos_dV_D_BD=0.0;
  double terfc=0.0;
     double d_terfc_dV_S_BS=0.0;
     double d_terfc_dV_D_BD=0.0;
  double ysq=0.0;
     double d_ysq_dV_S_BS=0.0;
     double d_ysq_dV_D_BD=0.0;
  double xerfc=0.0;
     double d_xerfc_dV_S_BS=0.0;
     double d_xerfc_dV_D_BD=0.0;
  double mtat=0.0;
     double d_mtat_dV_S_BS=0.0;
     double d_mtat_dV_D_BD=0.0;
  double ltat=0.0;
     double d_ltat_dV_S_BS=0.0;
     double d_ltat_dV_D_BD=0.0;
  double ktat=0.0;
     double d_ktat_dV_S_BS=0.0;
     double d_ktat_dV_D_BD=0.0;
  double wtat=0.0;
     double d_wtat_dV_S_BS=0.0;
     double d_wtat_dV_D_BD=0.0;
  double wgamma=0.0;
     double d_wgamma_dV_S_BS=0.0;
     double d_wgamma_dV_D_BD=0.0;
  double umaxpoweronepointfive=0.0;
     double d_umaxpoweronepointfive_dV_S_BS=0.0;
     double d_umaxpoweronepointfive_dV_D_BD=0.0;
  double sqrtumax=0.0;
     double d_sqrtumax_dV_S_BS=0.0;
     double d_sqrtumax_dV_D_BD=0.0;
  double umax=0.0;
     double d_umax_dV_S_BS=0.0;
     double d_umax_dV_D_BD=0.0;
  double umaxbeforelimiting=0.0;
     double d_umaxbeforelimiting_dV_S_BS=0.0;
     double d_umaxbeforelimiting_dV_D_BD=0.0;
  double twoatatoverthreebtat=0.0;
     double d_twoatatoverthreebtat_dV_S_BS=0.0;
     double d_twoatatoverthreebtat_dV_D_BD=0.0;
  double btat=0.0;
     double d_btat_dV_S_BS=0.0;
     double d_btat_dV_D_BD=0.0;
  double isrh=0.0;
     double d_isrh_dV_S_BS=0.0;
     double d_isrh_dV_D_BD=0.0;
  double asrh=0.0;
     double d_asrh_dV_S_BS=0.0;
     double d_asrh_dV_D_BD=0.0;
  double wdep=0.0;
     double d_wdep_dV_S_BS=0.0;
     double d_wdep_dV_D_BD=0.0;
  double wsrh=0.0;
     double d_wsrh_dV_D_BD=0.0;
     double d_wsrh_dV_S_BS=0.0;
  double dwsrh=0.0;
     double d_dwsrh_dV_D_BD=0.0;
     double d_dwsrh_dV_S_BS=0.0;
  double wsrhstep=0.0;
     double d_wsrhstep_dV_D_BD=0.0;
     double d_wsrhstep_dV_S_BS=0.0;
  double vbi_minus_vjsrh=0.0;
     double d_vbi_minus_vjsrh_dV_D_BD=0.0;
     double d_vbi_minus_vjsrh_dV_S_BS=0.0;
  double id=0.0;
     double d_id_dV_D_BD=0.0;
     double d_id_dV_S_BS=0.0;
  double tmp=0.0;
     double d_tmp_dV_S_BS=0.0;
     double d_tmp_dV_D_BD=0.0;
  double vav=0.0;
     double d_vav_dV_D_BD=0.0;
     double d_vav_dV_S_BS=0.0;
  double vjsrh=0.0;
     double d_vjsrh_dV_D_BD=0.0;
     double d_vjsrh_dV_S_BS=0.0;
  double vjlim=0.0;
     double d_vjlim_dV_D_BD=0.0;
     double d_vjlim_dV_S_BS=0.0;
  double z=0.0;
     double d_z_dV_D_BD=0.0;
     double d_z_dV_S_BS=0.0;
  double idmult=0.0;
     double d_idmult_dV_D_BD=0.0;
     double d_idmult_dV_S_BS=0.0;
  double zinv=0.0;
     double d_zinv_dV_D_BD=0.0;
     double d_zinv_dV_S_BS=0.0;
  double vj=0.0;
     double d_vj_dV_S_BS=0.0;
     double d_vj_dV_D_BD=0.0;
  double two_psistar=0.0;
     double d_two_psistar_dV_D_BD=0.0;
     double d_two_psistar_dV_S_BS=0.0;
  double vbbt=0.0;
     double d_vbbt_dV_D_BD=0.0;
     double d_vbbt_dV_S_BS=0.0;
  double Qs=0.0;
     double d_Qs_dV_D_S=0.0;
     double d_Qs_dV_GP_S=0.0;
     double d_Qs_dV_S_BP=0.0;
  double shot_igd=0.0;
  double shot_igs=0.0;
  double Sidexc=0.0;
     double d_Sidexc_dV_GP_S=0.0;
     double d_Sidexc_dV_D_S=0.0;
     double d_Sidexc_dV_S_BP=0.0;
  double gfac=0.0;
     double d_gfac_dV_D_S=0.0;
     double d_gfac_dV_GP_S=0.0;
     double d_gfac_dV_S_BP=0.0;
  double Gvsat_exc=0.0;
     double d_Gvsat_exc_dV_D_S=0.0;
     double d_Gvsat_exc_dV_GP_S=0.0;
     double d_Gvsat_exc_dV_S_BP=0.0;
  double zsat_exc=0.0;
     double d_zsat_exc_dV_D_S=0.0;
     double d_zsat_exc_dV_GP_S=0.0;
     double d_zsat_exc_dV_S_BP=0.0;
  double thesat1_exc=0.0;
     double d_thesat1_exc_dV_D_S=0.0;
     double d_thesat1_exc_dV_GP_S=0.0;
     double d_thesat1_exc_dV_S_BP=0.0;
  double temp_exc=0.0;
     double d_temp_exc_dV_D_S=0.0;
     double d_temp_exc_dV_GP_S=0.0;
     double d_temp_exc_dV_S_BP=0.0;
  double wsat_exc=0.0;
     double d_wsat_exc_dV_D_S=0.0;
     double d_wsat_exc_dV_GP_S=0.0;
     double d_wsat_exc_dV_S_BP=0.0;
  double temp2_exc=0.0;
     double d_temp2_exc_dV_D_S=0.0;
     double d_temp2_exc_dV_GP_S=0.0;
     double d_temp2_exc_dV_S_BP=0.0;
  double g_ideal=0.0;
     double d_g_ideal_dV_GP_S=0.0;
     double d_g_ideal_dV_D_S=0.0;
     double d_g_ideal_dV_S_BP=0.0;
  double lcinv2=0.0;
     double d_lcinv2_dV_D_S=0.0;
     double d_lcinv2_dV_GP_S=0.0;
     double d_lcinv2_dV_S_BP=0.0;
  double lc=0.0;
     double d_lc_dV_D_S=0.0;
     double d_lc_dV_GP_S=0.0;
     double d_lc_dV_S_BP=0.0;
  double r=0.0;
     double d_r_dV_D_S=0.0;
     double d_r_dV_GP_S=0.0;
     double d_r_dV_S_BP=0.0;
  double t2=0.0;
     double d_t2_dV_D_S=0.0;
     double d_t2_dV_GP_S=0.0;
     double d_t2_dV_S_BP=0.0;
  double sqt2=0.0;
     double d_sqt2_dV_D_S=0.0;
     double d_sqt2_dV_GP_S=0.0;
     double d_sqt2_dV_S_BP=0.0;
  double t1=0.0;
     double d_t1_dV_D_S=0.0;
     double d_t1_dV_GP_S=0.0;
     double d_t1_dV_S_BP=0.0;
  double H0=0.0;
     double d_H0_dV_D_S=0.0;
     double d_H0_dV_GP_S=0.0;
     double d_H0_dV_S_BP=0.0;
  double Delta_N1=0.0;
  double Nm1=0.0;
  double N1=0.0;
  double sqig=0.0;
  double migid=0.0;
     double d_migid_dV_D_S=0.0;
     double d_migid_dV_GP_S=0.0;
     double d_migid_dV_S_BP=0.0;
  double mid=0.0;
  double sig1k=0.0;
  double ib=0.0;
  double ig=0.0;
  double is=0.0;
  double id_op=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (18))
  {
    probeVars.resize(18);
    d_probeVars.resize(18);
    for (int i=0;i<18;i++)
    {
      d_probeVars[i].resize(18);
      for (int j=0;j<18;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(11+0);
    d_staticContributions.resize(11+0);
    for (int i=0;i<11+0;i++)
      d_staticContributions[i].resize(18);
    dynamicContributions.resize(11+0);
    d_dynamicContributions.resize(11+0);
    for (int i=0;i<11+0;i++)
      d_dynamicContributions[i].resize(18);
  }

    noiseContribsPower.resize(12);
    noiseContribsExponent.resize(12);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<18;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<18;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_D_GND] = (*solVectorPtr)[li_D];
d_probeVars[admsProbeID_V_D_GND][admsProbeID_V_D_GND] = 1.0;
probeVars[admsProbeID_V_BS_GND] = (*solVectorPtr)[li_BS];
d_probeVars[admsProbeID_V_BS_GND][admsProbeID_V_BS_GND] = 1.0;
probeVars[admsProbeID_V_BD_GND] = (*solVectorPtr)[li_BD];
d_probeVars[admsProbeID_V_BD_GND][admsProbeID_V_BD_GND] = 1.0;
probeVars[admsProbeID_V_S_GND] = (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_S_GND][admsProbeID_V_S_GND] = 1.0;
probeVars[admsProbeID_V_BP_GND] = (*solVectorPtr)[li_BP];
d_probeVars[admsProbeID_V_BP_GND][admsProbeID_V_BP_GND] = 1.0;
probeVars[admsProbeID_V_GP_GND] = (*solVectorPtr)[li_GP];
d_probeVars[admsProbeID_V_GP_GND][admsProbeID_V_GP_GND] = 1.0;
probeVars[admsProbeID_V_NOI_GND] = (*solVectorPtr)[li_NOI];
d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND] = 1.0;
probeVars[admsProbeID_V_NOI2_GND] = (*solVectorPtr)[li_NOI2];
d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND] = 1.0;
probeVars[admsProbeID_V_D_BD] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_BD];
d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD] = 1.0;
probeVars[admsProbeID_V_S_BS] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_BS];
d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS] = 1.0;
probeVars[admsProbeID_V_S_BP] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_BP];
d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP] = 1.0;
probeVars[admsProbeID_V_D_S] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S] = 1.0;
probeVars[admsProbeID_V_GP_S] = (*solVectorPtr)[li_GP] - (*solVectorPtr)[li_S];
d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S] = 1.0;
probeVars[admsProbeID_V_B_BI] = (*solVectorPtr)[li_B] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI] = 1.0;
probeVars[admsProbeID_V_BP_BI] = (*solVectorPtr)[li_BP] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI] = 1.0;
probeVars[admsProbeID_V_BD_BI] = (*solVectorPtr)[li_BD] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI] = 1.0;
probeVars[admsProbeID_V_BS_BI] = (*solVectorPtr)[li_BS] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI] = 1.0;
probeVars[admsProbeID_V_G_GP] = (*solVectorPtr)[li_G] - (*solVectorPtr)[li_GP];
d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP] = 1.0;
// -- code converted from analog/code block
//Begin block evaluateblock
{
//Block-local variables for block evaluateblock
double alpha=0.0;
     double d_alpha_dV_D_S=0.0;
     double d_alpha_dV_GP_S=0.0;
     double d_alpha_dV_S_BP=0.0;
double eta_p=0.0;
     double d_eta_p_dV_D_S=0.0;
     double d_eta_p_dV_GP_S=0.0;
     double d_eta_p_dV_S_BP=0.0;
double xitsb=0.0;
     double d_xitsb_dV_D_S=0.0;
     double d_xitsb_dV_S_BP=0.0;
double FdL=0.0;
     double d_FdL_dV_GP_S=0.0;
     double d_FdL_dV_D_S=0.0;
     double d_FdL_dV_S_BP=0.0;
double Gmob=0.0;
     double d_Gmob_dV_D_S=0.0;
     double d_Gmob_dV_GP_S=0.0;
     double d_Gmob_dV_S_BP=0.0;
double Gmob_dL=0.0;
     double d_Gmob_dL_dV_D_S=0.0;
     double d_Gmob_dL_dV_GP_S=0.0;
     double d_Gmob_dL_dV_S_BP=0.0;
double Gvsat=0.0;
     double d_Gvsat_dV_D_S=0.0;
     double d_Gvsat_dV_GP_S=0.0;
     double d_Gvsat_dV_S_BP=0.0;
double Gvsatinv=0.0;
     double d_Gvsatinv_dV_D_S=0.0;
     double d_Gvsatinv_dV_GP_S=0.0;
     double d_Gvsatinv_dV_S_BP=0.0;
double dps=0.0;
     double d_dps_dV_D_S=0.0;
     double d_dps_dV_GP_S=0.0;
     double d_dps_dV_S_BP=0.0;
double qim=0.0;
     double d_qim_dV_D_S=0.0;
     double d_qim_dV_GP_S=0.0;
     double d_qim_dV_S_BP=0.0;
double qim1=0.0;
     double d_qim1_dV_D_S=0.0;
     double d_qim1_dV_GP_S=0.0;
     double d_qim1_dV_S_BP=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double H=0.0;
     double d_H_dV_GP_S=0.0;
     double d_H_dV_D_S=0.0;
     double d_H_dV_S_BP=0.0;
double Iimpact=0.0;
     double d_Iimpact_dV_GP_S=0.0;
     double d_Iimpact_dV_D_S=0.0;
     double d_Iimpact_dV_S_BP=0.0;
double mavl=0.0;
     double d_mavl_dV_D_S=0.0;
     double d_mavl_dV_GP_S=0.0;
     double d_mavl_dV_S_BP=0.0;
double Ids=0.0;
     double d_Ids_dV_GP_S=0.0;
     double d_Ids_dV_D_S=0.0;
     double d_Ids_dV_S_BP=0.0;
double Vdse=0.0;
     double d_Vdse_dV_GP_S=0.0;
     double d_Vdse_dV_S_BP=0.0;
     double d_Vdse_dV_D_S=0.0;
double Igsov=0.0;
     double d_Igsov_dV_GP_S=0.0;
     double d_Igsov_dV_D_S=0.0;
     double d_Igsov_dV_S_BP=0.0;
double Igdov=0.0;
     double d_Igdov_dV_GP_S=0.0;
     double d_Igdov_dV_D_S=0.0;
     double d_Igdov_dV_S_BP=0.0;
double Igcs=0.0;
     double d_Igcs_dV_GP_S=0.0;
     double d_Igcs_dV_D_S=0.0;
     double d_Igcs_dV_S_BP=0.0;
double Igcd=0.0;
     double d_Igcd_dV_GP_S=0.0;
     double d_Igcd_dV_D_S=0.0;
     double d_Igcd_dV_S_BP=0.0;
double xg=0.0;
     double d_xg_dV_D_S=0.0;
     double d_xg_dV_GP_S=0.0;
     double d_xg_dV_S_BP=0.0;
double sigVds=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double COX_qm=0.0;
     double d_COX_qm_dV_D_S=0.0;
     double d_COX_qm_dV_GP_S=0.0;
     double d_COX_qm_dV_S_BP=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_s=0.0;
     double d_ijun_s_dV_D_BD=0.0;
     double d_ijun_s_dV_S_BS=0.0;
double ijunbot_s=0.0;
     double d_ijunbot_s_dV_S_BS=0.0;
     double d_ijunbot_s_dV_D_BD=0.0;
double ijunsti_s=0.0;
     double d_ijunsti_s_dV_S_BS=0.0;
     double d_ijunsti_s_dV_D_BD=0.0;
double ijungat_s=0.0;
     double d_ijungat_s_dV_S_BS=0.0;
     double d_ijungat_s_dV_D_BD=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_d=0.0;
     double d_ijun_d_dV_D_BD=0.0;
     double d_ijun_d_dV_S_BS=0.0;
double ijunbot_d=0.0;
     double d_ijunbot_d_dV_D_BD=0.0;
     double d_ijunbot_d_dV_S_BS=0.0;
double ijunsti_d=0.0;
     double d_ijunsti_d_dV_D_BD=0.0;
     double d_ijunsti_d_dV_S_BS=0.0;
double ijungat_d=0.0;
     double d_ijungat_d_dV_D_BD=0.0;
     double d_ijungat_d_dV_S_BS=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjun_s=0.0;
     double d_qjun_s_dV_D_BD=0.0;
     double d_qjun_s_dV_S_BS=0.0;
double qjunbot_s=0.0;
     double d_qjunbot_s_dV_D_BD=0.0;
     double d_qjunbot_s_dV_S_BS=0.0;
double qjunsti_s=0.0;
     double d_qjunsti_s_dV_D_BD=0.0;
     double d_qjunsti_s_dV_S_BS=0.0;
double qjungat_s=0.0;
     double d_qjungat_s_dV_D_BD=0.0;
     double d_qjungat_s_dV_S_BS=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjun_d=0.0;
     double d_qjun_d_dV_D_BD=0.0;
     double d_qjun_d_dV_S_BS=0.0;
double qjunbot_d=0.0;
     double d_qjunbot_d_dV_D_BD=0.0;
     double d_qjunbot_d_dV_S_BS=0.0;
double qjunsti_d=0.0;
     double d_qjunsti_d_dV_D_BD=0.0;
     double d_qjunsti_d_dV_S_BS=0.0;
double qjungat_d=0.0;
     double d_qjungat_d_dV_D_BD=0.0;
     double d_qjungat_d_dV_S_BS=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double jnoise_s=0.0;
double jnoise_d=0.0;
//End of Block-local variables
//Begin block evaluateStatic
{

d_SP_S_x1_dV_D_S = d_SP_S_x1_dV_GP_S = d_SP_S_x1_dV_S_BP =  0.0;
SP_S_x1 = 0.0;

d_x_s_dV_D_S = d_x_s_dV_GP_S = d_x_s_dV_S_BP =  0.0;
x_s = 0.0;

d_sqm_dV_D_S = d_sqm_dV_GP_S = d_sqm_dV_S_BP =  0.0;
sqm = 0.0;

d_alpha_dV_D_S = d_alpha_dV_GP_S = d_alpha_dV_S_BP =  0.0;
alpha = 0.0;

d_eta_p_dV_D_S = d_eta_p_dV_GP_S = d_eta_p_dV_S_BP =  0.0;
eta_p = 1.0;

d_xitsb_dV_D_S = d_xitsb_dV_S_BP =  0.0;
xitsb = 0.0;

d_rhob_dV_D_S = d_rhob_dV_S_BP =  0.0;
rhob = 0.0;

d_GdL_dV_GP_S = d_GdL_dV_D_S = d_GdL_dV_S_BP =  0.0;
GdL = 1.0;

d_FdL_dV_GP_S = d_FdL_dV_D_S = d_FdL_dV_S_BP =  0.0;
FdL = 1.0;

d_Gmob_dV_D_S = d_Gmob_dV_GP_S = d_Gmob_dV_S_BP =  0.0;
Gmob = 1.0;

d_Gmob_dL_dV_D_S = d_Gmob_dL_dV_GP_S = d_Gmob_dL_dV_S_BP =  0.0;
Gmob_dL = 1.0;

d_Udse_dV_GP_S = d_Udse_dV_S_BP = d_Udse_dV_D_S =  0.0;
Udse = 0.0;

d_QCLM_dV_GP_S = d_QCLM_dV_D_S = d_QCLM_dV_S_BP =  0.0;
QCLM = 0.0;

d_thesat1_dV_GP_S = d_thesat1_dV_D_S = d_thesat1_dV_S_BP =  0.0;
thesat1 = 0.0;

d_Gvsat_dV_D_S = d_Gvsat_dV_GP_S = d_Gvsat_dV_S_BP =  0.0;
Gvsat = 1.0;

d_Gvsatinv_dV_D_S = d_Gvsatinv_dV_GP_S = d_Gvsatinv_dV_S_BP =  0.0;
Gvsatinv = 1.0;

d_xgm_dV_D_S = d_xgm_dV_GP_S = d_xgm_dV_S_BP =  0.0;
xgm = 0.0;

d_dps_dV_D_S = d_dps_dV_GP_S = d_dps_dV_S_BP =  0.0;
dps = 0.0;

d_qim_dV_D_S = d_qim_dV_GP_S = d_qim_dV_S_BP =  0.0;
qim = 0.0;

d_qim1_dV_D_S = d_qim1_dV_GP_S = d_qim1_dV_S_BP =  0.0;
qim1 = 0.0;

d_H_dV_GP_S = d_H_dV_D_S = d_H_dV_S_BP =  0.0;
H = 1.0;

d_xs_ov_dV_D_S = d_xs_ov_dV_S_BP = d_xs_ov_dV_GP_S =  0.0;
xs_ov = 0.0;

d_xd_ov_dV_S_BP = d_xd_ov_dV_GP_S = d_xd_ov_dV_D_S =  0.0;
xd_ov = 0.0;

d_Vovs_dV_GP_S = d_Vovs_dV_D_S = d_Vovs_dV_S_BP =  0.0;
Vovs = 0.0;

d_Vovd_dV_GP_S = d_Vovd_dV_D_S = d_Vovd_dV_S_BP =  0.0;
Vovd = 0.0;

d_Iimpact_dV_GP_S = d_Iimpact_dV_D_S = d_Iimpact_dV_S_BP =  0.0;
Iimpact = 0.0;

d_mavl_dV_D_S = d_mavl_dV_GP_S = d_mavl_dV_S_BP =  0.0;
mavl = 0.0;
Vrg = (probeVars[admsProbeID_V_G_GP]);
Vrjuns = (probeVars[admsProbeID_V_BS_BI]);
Vrjund = (probeVars[admsProbeID_V_BD_BI]);
Vrbulk = (probeVars[admsProbeID_V_BP_BI]);
Vrwell = (probeVars[admsProbeID_V_B_BI]);
if (((model_.CHNL_TYPE)==(+1)))
{

d_Vgs_dV_D_S =  0.0;
d_Vgs_dV_GP_S = d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S];
Vgs = (probeVars[admsProbeID_V_GP_S]);

d_Vds_dV_D_S = d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
Vds = (probeVars[admsProbeID_V_D_S]);

d_Vsb_dV_D_S =  0.0;
d_Vsb_dV_S_BP = d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP];
Vsb = (probeVars[admsProbeID_V_S_BP]);

d_Vjun_s_dV_S_BS = (-d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS]);
Vjun_s = (-(probeVars[admsProbeID_V_S_BS]));

d_Vjun_d_dV_D_BD = (-d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD]);
Vjun_d = (-(probeVars[admsProbeID_V_D_BD]));
}
else
{

d_Vgs_dV_D_S =  0.0;
d_Vgs_dV_GP_S = (-d_probeVars[admsProbeID_V_GP_S][admsProbeID_V_GP_S]);
Vgs = (-(probeVars[admsProbeID_V_GP_S]));

d_Vds_dV_D_S = (-d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S]);
Vds = (-(probeVars[admsProbeID_V_D_S]));

d_Vsb_dV_D_S =  0.0;
d_Vsb_dV_S_BP = (-d_probeVars[admsProbeID_V_S_BP][admsProbeID_V_S_BP]);
Vsb = (-(probeVars[admsProbeID_V_S_BP]));

d_Vjun_s_dV_S_BS = d_probeVars[admsProbeID_V_S_BS][admsProbeID_V_S_BS];
Vjun_s = (probeVars[admsProbeID_V_S_BS]);

d_Vjun_d_dV_D_BD = d_probeVars[admsProbeID_V_D_BD][admsProbeID_V_D_BD];
Vjun_d = (probeVars[admsProbeID_V_D_BD]);
}

d_VgsPrime_dV_GP_S = d_Vgs_dV_GP_S;
VgsPrime = Vgs;

d_VsbPrime_dV_S_BP = d_Vsb_dV_S_BP;
VsbPrime = Vsb;

d_VdbPrime_dV_S_BP = d_Vsb_dV_S_BP;
d_VdbPrime_dV_D_S = (d_Vds_dV_D_S+d_Vsb_dV_D_S);
VdbPrime = (Vds+Vsb);

d_VgdPrime_dV_D_S = (d_Vgs_dV_D_S-d_Vds_dV_D_S);
d_VgdPrime_dV_GP_S = d_Vgs_dV_GP_S;
VgdPrime = (Vgs-Vds);

d_xgs_ov_dV_GP_S = (-d_VgsPrime_dV_GP_S)*(model_.inv_phit);
xgs_ov = ((-VgsPrime)*(model_.inv_phit));

d_xgd_ov_dV_D_S = (-d_VgdPrime_dV_D_S)*(model_.inv_phit);
d_xgd_ov_dV_GP_S = (-d_VgdPrime_dV_GP_S)*(model_.inv_phit);
xgd_ov = ((-VgdPrime)*(model_.inv_phit));
sigVds = 1.0;
if ((Vds<0.0))
{
sigVds = (-1.0);

d_Vgs_dV_D_S = (d_Vgs_dV_D_S-d_Vds_dV_D_S);
Vgs = (Vgs-Vds);

d_Vsb_dV_D_S = (d_Vsb_dV_D_S+d_Vds_dV_D_S);
Vsb = (Vsb+Vds);

d_Vds_dV_D_S = (-d_Vds_dV_D_S);
Vds = (-Vds);
}
Vgd = (Vgs-Vds);

d_Vdb_dV_S_BP = d_Vsb_dV_S_BP;
d_Vdb_dV_D_S = (d_Vds_dV_D_S+d_Vsb_dV_D_S);
Vdb = (Vds+Vsb);
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_GP_S =  0.0;
d_temp_dV_S_BP = 0.5*((d_Vdb_dV_S_BP+d_Vsb_dV_S_BP)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_S_BP-d_Vsb_dV_S_BP)+(d_Vdb_dV_S_BP-d_Vsb_dV_S_BP)*(Vdb-Vsb)))));
d_temp_dV_D_S = 0.5*((d_Vdb_dV_D_S+d_Vsb_dV_D_S)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_D_S-d_Vsb_dV_D_S)+(d_Vdb_dV_D_S-d_Vsb_dV_D_S)*(Vdb-Vsb)))));
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+aphi));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vsbstar_dV_S_BP = (d_Vsb_dV_S_BP-0.5*(d_temp_dV_S_BP-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_S_BP+d_temp_dV_S_BP*(temp))))));
d_Vsbstar_dV_D_S = (d_Vsb_dV_D_S-0.5*(d_temp_dV_D_S-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_D_S+d_temp_dV_D_S*(temp))))));
Vsbstar = ((Vsb-(0.5*(temp-value_sqrt_0)))+phix1);
}
Vdbstar = (Vds+Vsbstar);

d_Vgbstar_dV_S_BP = d_Vsbstar_dV_S_BP;
d_Vgbstar_dV_GP_S = d_Vgs_dV_GP_S;
d_Vgbstar_dV_D_S = (d_Vgs_dV_D_S+d_Vsbstar_dV_D_S);
Vgbstar = (Vgs+Vsbstar);

d_Vgb1_dV_S_BP = d_Vgbstar_dV_S_BP;
d_Vgb1_dV_GP_S = d_Vgbstar_dV_GP_S;
d_Vgb1_dV_D_S = d_Vgbstar_dV_D_S;
Vgb1 = (Vgbstar-VFB_i);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsx_dV_D_S = (deriv_sqrt_0_d0*((Vds*d_Vds_dV_D_S+d_Vds_dV_D_S*Vds)));
Vdsx = (value_sqrt_0-0.1);
}

d_Vsbx_dV_S_BP = d_Vsbstar_dV_S_BP;
d_Vsbx_dV_D_S = (d_Vsbstar_dV_D_S+0.5*(d_Vds_dV_D_S-d_Vdsx_dV_D_S));
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));

d_delVg_dV_S_BP = CF_i*Vdsx*CFB_i*d_Vsbx_dV_S_BP;
d_delVg_dV_D_S = CF_i*(Vdsx*CFB_i*d_Vsbx_dV_D_S+d_Vdsx_dV_D_S*(1+(CFB_i*Vsbx)));
delVg = (CF_i*(Vdsx*(1+(CFB_i*Vsbx))));

d_Vgb1_dV_S_BP = (d_Vgb1_dV_S_BP+d_delVg_dV_S_BP);
d_Vgb1_dV_D_S = (d_Vgb1_dV_D_S+d_delVg_dV_D_S);
Vgb1 = (Vgb1+delVg);

d_xg_dV_S_BP = d_Vgb1_dV_S_BP*inv_phit1;
d_xg_dV_GP_S = d_Vgb1_dV_GP_S*inv_phit1;
d_xg_dV_D_S = d_Vgb1_dV_D_S*inv_phit1;
xg = (Vgb1*inv_phit1);
if ((DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dnsub_dV_S_BP = (DNSUB_i*0.5)*(d_Vsb_dV_S_BP+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_S_BP)+(-d_Vsb_dV_S_BP)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_GP_S = (DNSUB_i*0.5)*(d_Vgs_dV_GP_S+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_S)+(-d_Vgs_dV_GP_S)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_D_S = (DNSUB_i*0.5)*((d_Vgs_dV_D_S+d_Vsb_dV_D_S)+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_D_S+d_Vsb_dV_D_S))+(-(d_Vgs_dV_D_S+d_Vsb_dV_D_S))*(-((Vgs+Vsb)-VNSUB_i))))));
Dnsub = ((DNSUB_i*0.5)*(((Vgs+Vsb)-VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gf_dV_S_BP = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_S_BP));
d_Gf_dV_GP_S = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_S));
d_Gf_dV_D_S = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_D_S));
Gf = (G_0*value_sqrt_0);
}
}
else
{

d_Gf_dV_D_S = d_Gf_dV_GP_S = d_Gf_dV_S_BP =  0.0;
Gf = G_0;
}

d_Gf2_dV_S_BP = (Gf*d_Gf_dV_S_BP+d_Gf_dV_S_BP*Gf);
d_Gf2_dV_GP_S = (Gf*d_Gf_dV_GP_S+d_Gf_dV_GP_S*Gf);
d_Gf2_dV_D_S = (Gf*d_Gf_dV_D_S+d_Gf_dV_D_S*Gf);
Gf2 = (Gf*Gf);

d_inv_Gf2_dV_S_BP = (-d_Gf2_dV_S_BP/Gf2/Gf2);
d_inv_Gf2_dV_GP_S = (-d_Gf2_dV_GP_S/Gf2/Gf2);
d_inv_Gf2_dV_D_S = (-d_Gf2_dV_D_S/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);

d_xi_dV_S_BP = d_Gf_dV_S_BP*7.0710678118654746e-01;
d_xi_dV_GP_S = d_Gf_dV_GP_S*7.0710678118654746e-01;
d_xi_dV_D_S = d_Gf_dV_D_S*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));

d_inv_xi_dV_S_BP = (-d_xi_dV_S_BP/xi/xi);
d_inv_xi_dV_GP_S = (-d_xi_dV_GP_S/xi/xi);
d_inv_xi_dV_D_S = (-d_xi_dV_D_S/xi/xi);
inv_xi = (1.0/xi);

d_Ux_dV_S_BP = d_Vsbstar_dV_S_BP*inv_phit1;
d_Ux_dV_D_S = d_Vsbstar_dV_D_S*inv_phit1;
Ux = (Vsbstar*inv_phit1);

d_xn_s_dV_S_BP = d_Ux_dV_S_BP;
d_xn_s_dV_D_S = d_Ux_dV_D_S;
xn_s = ((phib*inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_ns_dV_S_BP = (deriv_exp_0_d0*((-d_xn_s_dV_S_BP)));
d_delta_ns_dV_D_S = (deriv_exp_0_d0*((-d_xn_s_dV_D_S)));
delta_ns = value_exp_0;
}
}
else
{

d_delta_ns_dV_S_BP = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_S_BP*3.3333333333333333e-01+d_xn_s_dV_S_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_S_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_delta_ns_dV_D_S = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_D_S*3.3333333333333333e-01+d_xn_s_dV_D_S*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_D_S*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_margin_dV_S_BP = 1e-5*d_xi_dV_S_BP;
d_margin_dV_GP_S = 1e-5*d_xi_dV_GP_S;
d_margin_dV_D_S = 1e-5*d_xi_dV_D_S;
margin = (1e-5*xi);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_S_BP = (inv_xi*d_inv_xi_dV_S_BP+d_inv_xi_dV_S_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_S = (inv_xi*d_inv_xi_dV_GP_S+d_inv_xi_dV_GP_S*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_D_S = (inv_xi*d_inv_xi_dV_D_S+d_inv_xi_dV_D_S*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_s_dV_S_BP = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_S_BP+((xg*(1.0-delta_ns))*d_Gf_dV_S_BP+(xg*(-d_delta_ns_dV_S_BP)+d_xg_dV_S_BP*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_S_BP+d_xg_dV_S_BP*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_GP_S = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_S+((xg*(1.0-delta_ns))*d_Gf_dV_GP_S+d_xg_dV_GP_S*(1.0-delta_ns)*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_S+d_xg_dV_GP_S*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_D_S = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_D_S+((xg*(1.0-delta_ns))*d_Gf_dV_D_S+(xg*(-d_delta_ns_dV_D_S)+d_xg_dV_D_S*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_D_S+d_xg_dV_D_S*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{

d_SP_S_yg_dV_S_BP = (-d_xg_dV_S_BP);
d_SP_S_yg_dV_GP_S = (-d_xg_dV_GP_S);
d_SP_S_yg_dV_D_S = (-d_xg_dV_D_S);
SP_S_yg = (-xg);

d_SP_S_ysub_dV_S_BP = 1.25*(SP_S_yg*d_inv_xi_dV_S_BP+d_SP_S_yg_dV_S_BP*inv_xi);
d_SP_S_ysub_dV_GP_S = 1.25*(SP_S_yg*d_inv_xi_dV_GP_S+d_SP_S_yg_dV_GP_S*inv_xi);
d_SP_S_ysub_dV_D_S = 1.25*(SP_S_yg*d_inv_xi_dV_D_S+d_SP_S_yg_dV_D_S*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_eta_dV_S_BP = 0.5*(d_SP_S_ysub_dV_S_BP-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_S_BP+d_SP_S_ysub_dV_S_BP*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_GP_S = 0.5*(d_SP_S_ysub_dV_GP_S-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_S+d_SP_S_ysub_dV_GP_S*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_D_S = 0.5*(d_SP_S_ysub_dV_D_S-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_D_S+d_SP_S_ysub_dV_D_S*(SP_S_ysub-6.0)))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}

d_SP_S_temp_dV_S_BP = (d_SP_S_yg_dV_S_BP-d_SP_S_eta_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_SP_S_yg_dV_GP_S-d_SP_S_eta_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_SP_S_yg_dV_D_S-d_SP_S_eta_dV_D_S);
SP_S_temp = (SP_S_yg-SP_S_eta);

d_SP_S_a_dV_S_BP = ((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)+(Gf2*d_SP_S_eta_dV_S_BP+d_Gf2_dV_S_BP*(SP_S_eta+1.0)));
d_SP_S_a_dV_GP_S = ((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)+(Gf2*d_SP_S_eta_dV_GP_S+d_Gf2_dV_GP_S*(SP_S_eta+1.0)));
d_SP_S_a_dV_D_S = ((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)+(Gf2*d_SP_S_eta_dV_D_S+d_Gf2_dV_D_S*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

d_SP_S_c_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP-d_Gf2_dV_S_BP);
d_SP_S_c_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S-d_Gf2_dV_GP_S);
d_SP_S_c_dV_D_S = (2.0*d_SP_S_temp_dV_D_S-d_Gf2_dV_D_S);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

d_SP_S_tau_dV_S_BP = ((-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_S_BP+d_SP_S_a_dV_S_BP*inv_Gf2))));
d_SP_S_tau_dV_GP_S = ((-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_GP_S+d_SP_S_a_dV_GP_S*inv_Gf2))));
d_SP_S_tau_dV_D_S = ((-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_D_S+d_SP_S_a_dV_D_S*inv_Gf2))));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}

d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_S_BP = ((nu*d_nu_dV_S_BP+d_nu_dV_S_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)-d_SP_S_a_dV_S_BP)+d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_GP_S = ((nu*d_nu_dV_GP_S+d_nu_dV_GP_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)-d_SP_S_a_dV_GP_S)+d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)-d_SP_S_a_dV_D_S)+d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

d_SP_S_y0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_S_BP+(SP_S_a*d_nu_dV_S_BP+d_SP_S_a_dV_S_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_S_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP+((nu/mutau)*d_SP_S_tau_dV_S_BP+((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_S+(SP_S_a*d_nu_dV_GP_S+d_SP_S_a_dV_GP_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_GP_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S+((nu/mutau)*d_SP_S_tau_dV_GP_S+((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_D_S+(SP_S_a*d_nu_dV_D_S+d_SP_S_a_dV_D_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_D_S)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S+((nu/mutau)*d_SP_S_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_S_BP));
d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_S));
d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_y0_dV_D_S));
SP_S_delta0 = value_exp_0;
}
}
else
{

d_SP_S_delta0_dV_S_BP = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_S_BP*3.3333333333333333e-01+d_SP_S_y0_dV_S_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_S_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_GP_S = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_GP_S*3.3333333333333333e-01+d_SP_S_y0_dV_GP_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_GP_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_D_S = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_D_S*3.3333333333333333e-01+d_SP_S_y0_dV_D_S*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_D_S*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}

d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_temp_dV_S_BP = (-(SP_S_y0*d_SP_S_y0_dV_S_BP+d_SP_S_y0_dV_S_BP*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_GP_S = (-(SP_S_y0*d_SP_S_y0_dV_GP_S+d_SP_S_y0_dV_GP_S*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_D_S = (-(SP_S_y0*d_SP_S_y0_dV_D_S+d_SP_S_y0_dV_D_S*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

d_SP_S_xi0_dV_S_BP = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_S_BP+(SP_S_y0*d_SP_S_y0_dV_S_BP+d_SP_S_y0_dV_S_BP*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_GP_S = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_S+(SP_S_y0*d_SP_S_y0_dV_GP_S+d_SP_S_y0_dV_GP_S*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_D_S = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_D_S+(SP_S_y0*d_SP_S_y0_dV_D_S+d_SP_S_y0_dV_D_S*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

d_SP_S_xi1_dV_S_BP = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_S_BP+(SP_S_y0*d_SP_S_temp_dV_S_BP+d_SP_S_y0_dV_S_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_S = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_S+(SP_S_y0*d_SP_S_temp_dV_GP_S+d_SP_S_y0_dV_GP_S*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_D_S = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_D_S+(SP_S_y0*d_SP_S_temp_dV_D_S+d_SP_S_y0_dV_D_S*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_S_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP+(8.0*d_SP_S_temp_dV_S_BP-12.0*d_SP_S_xi0_dV_S_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S+(8.0*d_SP_S_temp_dV_GP_S-12.0*d_SP_S_xi0_dV_GP_S)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_D_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S+(8.0*d_SP_S_temp_dV_D_S-12.0*d_SP_S_xi0_dV_D_S)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_S_BP = (d_SP_S_yg_dV_S_BP-d_SP_S_y0_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_SP_S_yg_dV_GP_S-d_SP_S_y0_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_SP_S_yg_dV_D_S-d_SP_S_y0_dV_D_S);
SP_S_temp = (SP_S_yg-SP_S_y0);

d_SP_S_temp1_dV_GP_S = delta_ns*d_SP_S_delta1_dV_GP_S;
d_SP_S_temp1_dV_S_BP = (delta_ns*d_SP_S_delta1_dV_S_BP+d_delta_ns_dV_S_BP*SP_S_delta1);
d_SP_S_temp1_dV_D_S = (delta_ns*d_SP_S_delta1_dV_D_S+d_delta_ns_dV_D_S*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);

d_SP_S_pC_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP+(Gf2*((d_SP_S_delta0_dV_S_BP-d_SP_S_temp1_dV_S_BP)+(delta_ns*(-d_SP_S_xi1_dV_S_BP)+d_delta_ns_dV_S_BP*(1.0-SP_S_xi1)))+d_Gf2_dV_S_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S+(Gf2*((d_SP_S_delta0_dV_GP_S-d_SP_S_temp1_dV_GP_S)+delta_ns*(-d_SP_S_xi1_dV_GP_S))+d_Gf2_dV_GP_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_D_S = (2.0*d_SP_S_temp_dV_D_S+(Gf2*((d_SP_S_delta0_dV_D_S-d_SP_S_temp1_dV_D_S)+(delta_ns*(-d_SP_S_xi1_dV_D_S)+d_delta_ns_dV_D_S*(1.0-SP_S_xi1)))+d_Gf2_dV_D_S*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

d_SP_S_qC_dV_S_BP = ((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_S_BP-d_SP_S_y0_dV_S_BP)+d_SP_S_temp1_dV_S_BP)+(delta_ns*(d_SP_S_y0_dV_S_BP-d_SP_S_xi0_dV_S_BP)+d_delta_ns_dV_S_BP*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_S_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_GP_S = ((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_GP_S-d_SP_S_y0_dV_GP_S)+d_SP_S_temp1_dV_GP_S)+delta_ns*(d_SP_S_y0_dV_GP_S-d_SP_S_xi0_dV_GP_S))+d_Gf2_dV_GP_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_D_S = ((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_D_S-d_SP_S_y0_dV_D_S)+d_SP_S_temp1_dV_D_S)+(delta_ns*(d_SP_S_y0_dV_D_S-d_SP_S_xi0_dV_D_S)+d_delta_ns_dV_D_S*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_D_S*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

d_SP_S_temp_dV_S_BP = (-(Gf2*((d_SP_S_delta0_dV_S_BP+d_SP_S_temp1_dV_S_BP)-(delta_ns*d_SP_S_xi2_dV_S_BP+d_delta_ns_dV_S_BP*SP_S_xi2))+d_Gf2_dV_S_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_S = (-(Gf2*((d_SP_S_delta0_dV_GP_S+d_SP_S_temp1_dV_GP_S)-delta_ns*d_SP_S_xi2_dV_GP_S)+d_Gf2_dV_GP_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_D_S = (-(Gf2*((d_SP_S_delta0_dV_D_S+d_SP_S_temp1_dV_D_S)-(delta_ns*d_SP_S_xi2_dV_D_S+d_delta_ns_dV_D_S*SP_S_xi2))+d_Gf2_dV_D_S*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_S_BP = ((SP_S_pC*d_SP_S_pC_dV_S_BP+d_SP_S_pC_dV_S_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_S_BP+d_SP_S_qC_dV_S_BP*SP_S_temp));
d_SP_S_temp_dV_GP_S = ((SP_S_pC*d_SP_S_pC_dV_GP_S+d_SP_S_pC_dV_GP_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_S+d_SP_S_qC_dV_GP_S*SP_S_temp));
d_SP_S_temp_dV_D_S = ((SP_S_pC*d_SP_S_pC_dV_D_S+d_SP_S_pC_dV_D_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_D_S+d_SP_S_qC_dV_D_S*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_S_BP = ((-d_SP_S_y0_dV_S_BP)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_S = ((-d_SP_S_y0_dV_GP_S)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_D_S = ((-d_SP_S_y0_dV_D_S)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{

d_SP_xg1_dV_S_BP = (-d_Gf_dV_S_BP*7.324648775608221e-001/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_GP_S = (-d_Gf_dV_GP_S*7.324648775608221e-001/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_D_S = (-d_Gf_dV_D_S*7.324648775608221e-001/(x1+(Gf*7.324648775608221e-001))/(x1+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(x1+(Gf*7.324648775608221e-001)));

d_SP_S_A_fac_dV_S_BP = ((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_S_BP+((xi*x1)*d_SP_xg1_dV_S_BP+d_xi_dV_S_BP*x1*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_GP_S = ((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_S+((xi*x1)*d_SP_xg1_dV_GP_S+d_xi_dV_GP_S*x1*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_D_S = ((((xi*x1)*SP_xg1)-1.0)*d_SP_xg1_dV_D_S+((xi*x1)*d_SP_xg1_dV_D_S+d_xi_dV_D_S*x1*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*x1)*SP_xg1)-1.0)*SP_xg1);

d_SP_S_xbar_dV_S_BP = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_S_BP+d_SP_S_A_fac_dV_S_BP*xg)+(xg*d_inv_xi_dV_S_BP+d_xg_dV_S_BP*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_GP_S = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_GP_S+d_SP_S_A_fac_dV_GP_S*xg)+(xg*d_inv_xi_dV_GP_S+d_xg_dV_GP_S*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_D_S = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_D_S+d_SP_S_A_fac_dV_D_S*xg)+(xg*d_inv_xi_dV_D_S+d_xg_dV_D_S*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_S_BP)));
d_SP_S_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_S)));
d_SP_S_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_D_S)));
SP_S_temp = value_exp_0;
}
}
else
{

d_SP_S_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_S_BP))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_GP_S))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_D_S))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}

d_SP_S_w_dV_S_BP = (-d_SP_S_temp_dV_S_BP);
d_SP_S_w_dV_GP_S = (-d_SP_S_temp_dV_GP_S);
d_SP_S_w_dV_D_S = (-d_SP_S_temp_dV_D_S);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_x1_dV_S_BP = ((d_xg_dV_S_BP+d_Gf2_dV_S_BP*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_S_BP+d_Gf2_dV_S_BP*0.25)-d_SP_S_w_dV_S_BP)))+d_Gf_dV_S_BP*value_sqrt_0));
d_SP_S_x1_dV_GP_S = ((d_xg_dV_GP_S+d_Gf2_dV_GP_S*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_S+d_Gf2_dV_GP_S*0.25)-d_SP_S_w_dV_GP_S)))+d_Gf_dV_GP_S*value_sqrt_0));
d_SP_S_x1_dV_D_S = ((d_xg_dV_D_S+d_Gf2_dV_D_S*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_D_S+d_Gf2_dV_D_S*0.25)-d_SP_S_w_dV_D_S)))+d_Gf_dV_D_S*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}

d_SP_S_bx_dV_GP_S =  0.0;
d_SP_S_bx_dV_S_BP = d_xn_s_dV_S_BP;
d_SP_S_bx_dV_D_S = d_xn_s_dV_D_S;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_S_BP = (0.5*((d_SP_S_x1_dV_S_BP+d_SP_S_bx_dV_S_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)+(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_S_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_S_BP+d_SP_S_bx_dV_S_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_S = (0.5*((d_SP_S_x1_dV_GP_S+d_SP_S_bx_dV_GP_S)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)+(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_S-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_S+d_SP_S_bx_dV_GP_S*SP_S_bx)))));
d_SP_S_eta_dV_D_S = (0.5*((d_SP_S_x1_dV_D_S+d_SP_S_bx_dV_D_S)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)+(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_D_S-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_D_S+d_SP_S_bx_dV_D_S*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_eta_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_eta_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_eta_dV_D_S);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_S_BP)));
d_SP_S_temp1_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_S)));
d_SP_S_temp1_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_D_S)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_S_BP = (-(SP_S_eta*d_SP_S_eta_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_S = (-(SP_S_eta*d_SP_S_eta_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_D_S = (-(SP_S_eta*d_SP_S_eta_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_S_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_S_BP+(SP_S_eta*d_SP_S_eta_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_S = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_S+(SP_S_eta*d_SP_S_eta_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_D_S = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_D_S+(SP_S_eta*d_SP_S_eta_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_S_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_S_BP+(SP_S_eta*d_SP_S_temp2_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_S = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_S+(SP_S_eta*d_SP_S_temp2_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_D_S = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_D_S+(SP_S_eta*d_SP_S_temp2_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_S_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_S_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_S_BP+(8.0*d_SP_S_temp2_dV_S_BP-12.0*d_SP_S_xi0_dV_S_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_S = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_S+(8.0*d_SP_S_temp2_dV_GP_S-12.0*d_SP_S_xi0_dV_GP_S)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_D_S = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_D_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_D_S+(8.0*d_SP_S_temp2_dV_D_S-12.0*d_SP_S_xi0_dV_D_S)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_S_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_S_BP+d_SP_S_eta_dV_S_BP)-(delta_ns*(d_SP_S_eta_dV_S_BP+d_SP_S_xi0_dV_S_BP)+d_delta_ns_dV_S_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_S_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_S = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_S+d_SP_S_eta_dV_GP_S)-delta_ns*(d_SP_S_eta_dV_GP_S+d_SP_S_xi0_dV_GP_S))+d_Gf2_dV_GP_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_D_S = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_D_S+d_SP_S_eta_dV_D_S)-(delta_ns*(d_SP_S_eta_dV_D_S+d_SP_S_xi0_dV_D_S)+d_delta_ns_dV_D_S*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_D_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_S_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_S_BP-(delta_ns*d_SP_S_xi2_dV_S_BP+d_delta_ns_dV_S_BP*SP_S_xi2))+d_Gf2_dV_S_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_GP_S = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_S-delta_ns*d_SP_S_xi2_dV_GP_S)+d_Gf2_dV_GP_S*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_D_S = (-0.5*(Gf2*(d_SP_S_temp1_dV_D_S-(delta_ns*d_SP_S_xi2_dV_D_S+d_delta_ns_dV_D_S*SP_S_xi2))+d_Gf2_dV_D_S*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

d_SP_S_c_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP+(Gf2*((-d_SP_S_temp1_dV_S_BP)-(delta_ns*d_SP_S_xi1_dV_S_BP+d_delta_ns_dV_S_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_S_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S+(Gf2*((-d_SP_S_temp1_dV_GP_S)-delta_ns*d_SP_S_xi1_dV_GP_S)+d_Gf2_dV_GP_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_D_S = (2.0*d_SP_S_temp_dV_D_S+(Gf2*((-d_SP_S_temp1_dV_D_S)-(delta_ns*d_SP_S_xi1_dV_D_S+d_delta_ns_dV_D_S*(1.0+SP_S_xi1)))+d_Gf2_dV_D_S*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_GP_S = ((-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_S-SP_S_a*d_Gf2_dV_GP_S)/Gf2/Gf2))));
d_SP_S_tau_dV_S_BP = ((d_xn_s_dV_S_BP-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_S_BP-SP_S_a*d_Gf2_dV_S_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_D_S = ((d_xn_s_dV_D_S-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_D_S-SP_S_a*d_Gf2_dV_D_S)/Gf2/Gf2))));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}

d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_S_BP = ((nu*d_nu_dV_S_BP+d_nu_dV_S_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_S_BP+d_SP_S_a_dV_S_BP*SP_S_b))+d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_S = ((nu*d_nu_dV_GP_S+d_nu_dV_GP_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_S+d_SP_S_a_dV_GP_S*SP_S_b))+d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)-(SP_S_a*d_SP_S_b_dV_D_S+d_SP_S_a_dV_D_S*SP_S_b))+d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_S_BP+(SP_S_a*d_nu_dV_S_BP+d_SP_S_a_dV_S_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_S_BP+d_SP_S_a_dV_S_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP+((nu/mutau)*d_SP_S_tau_dV_S_BP+((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_S+(SP_S_a*d_nu_dV_GP_S+d_SP_S_a_dV_GP_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_S+d_SP_S_a_dV_GP_S*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S+((nu/mutau)*d_SP_S_tau_dV_GP_S+((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_D_S+(SP_S_a*d_nu_dV_D_S+d_SP_S_a_dV_D_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_D_S+d_SP_S_a_dV_D_S*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S+((nu/mutau)*d_SP_S_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_S_BP));
d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_D_S));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_GP_S = delta_ns*d_SP_S_delta0_dV_GP_S;
d_SP_S_delta0_dV_S_BP = (delta_ns*d_SP_S_delta0_dV_S_BP+d_delta_ns_dV_S_BP*SP_S_delta0);
d_SP_S_delta0_dV_D_S = (delta_ns*d_SP_S_delta0_dV_D_S+d_delta_ns_dV_D_S*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_S_BP-d_xn_s_dV_S_BP)));
d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_D_S-d_xn_s_dV_D_S)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_GP_S = (-delta_ns*d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_S_BP = ((SP_S_delta0*d_delta_ns_dV_S_BP-delta_ns*d_SP_S_delta0_dV_S_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_D_S = ((SP_S_delta0*d_delta_ns_dV_D_S-delta_ns*d_SP_S_delta0_dV_D_S)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_GP_S = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-d_SP_S_x0_dV_GP_S)*3.3333333333333333e-01+(-d_SP_S_x0_dV_GP_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_SP_S_x0_dV_GP_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_S_BP = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*3.3333333333333333e-01+(d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_D_S = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*3.3333333333333333e-01+(d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_S_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_S_BP*3.3333333333333333e-01+d_SP_S_x0_dV_S_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_S_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_S = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_S*3.3333333333333333e-01+d_SP_S_x0_dV_GP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_D_S = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_D_S*3.3333333333333333e-01+d_SP_S_x0_dV_D_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_D_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_S_BP = (-(SP_S_x0*d_SP_S_x0_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_S = (-(SP_S_x0*d_SP_S_x0_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_D_S = (-(SP_S_x0*d_SP_S_x0_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_S_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_S_BP+(SP_S_x0*d_SP_S_x0_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_S = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_S+(SP_S_x0*d_SP_S_x0_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_D_S = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_D_S+(SP_S_x0*d_SP_S_x0_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_S_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_S_BP+(SP_S_x0*d_SP_S_temp_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_S = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_S+(SP_S_x0*d_SP_S_temp_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_D_S = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_D_S+(SP_S_x0*d_SP_S_temp_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_S_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP+(8.0*d_SP_S_temp_dV_S_BP-12.0*d_SP_S_xi0_dV_S_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S+(8.0*d_SP_S_temp_dV_GP_S-12.0*d_SP_S_xi0_dV_GP_S)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_D_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S+(8.0*d_SP_S_temp_dV_D_S-12.0*d_SP_S_xi0_dV_D_S)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_x0_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_x0_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_x0_dV_D_S);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP+(Gf2*(((-d_SP_S_delta1_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-(delta_ns*d_SP_S_xi1_dV_S_BP+d_delta_ns_dV_S_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_S_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S+(Gf2*(((-d_SP_S_delta1_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-delta_ns*d_SP_S_xi1_dV_GP_S)+d_Gf2_dV_GP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_D_S = (2.0*d_SP_S_temp_dV_D_S+(Gf2*(((-d_SP_S_delta1_dV_D_S)+d_SP_S_delta0_dV_D_S)-(delta_ns*d_SP_S_xi1_dV_D_S+d_delta_ns_dV_D_S*(1.0+SP_S_xi1)))+d_Gf2_dV_D_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_S_BP = ((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_S_BP+d_SP_S_x0_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-(delta_ns*(d_SP_S_x0_dV_S_BP+d_SP_S_xi0_dV_S_BP)+d_delta_ns_dV_S_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_S_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_S = ((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_S+d_SP_S_x0_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-delta_ns*(d_SP_S_x0_dV_GP_S+d_SP_S_xi0_dV_GP_S))+d_Gf2_dV_GP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_D_S = ((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_D_S+d_SP_S_x0_dV_D_S)+d_SP_S_delta0_dV_D_S)-(delta_ns*(d_SP_S_x0_dV_D_S+d_SP_S_xi0_dV_D_S)+d_delta_ns_dV_D_S*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_D_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_S_BP = (-(Gf2*((d_SP_S_delta1_dV_S_BP+d_SP_S_delta0_dV_S_BP)-(delta_ns*d_SP_S_xi2_dV_S_BP+d_delta_ns_dV_S_BP*SP_S_xi2))+d_Gf2_dV_S_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_S = (-(Gf2*((d_SP_S_delta1_dV_GP_S+d_SP_S_delta0_dV_GP_S)-delta_ns*d_SP_S_xi2_dV_GP_S)+d_Gf2_dV_GP_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_D_S = (-(Gf2*((d_SP_S_delta1_dV_D_S+d_SP_S_delta0_dV_D_S)-(delta_ns*d_SP_S_xi2_dV_D_S+d_delta_ns_dV_D_S*SP_S_xi2))+d_Gf2_dV_D_S*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_S_BP = ((SP_S_pC*d_SP_S_pC_dV_S_BP+d_SP_S_pC_dV_S_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_S_BP+d_SP_S_qC_dV_S_BP*SP_S_temp));
d_SP_S_temp_dV_GP_S = ((SP_S_pC*d_SP_S_pC_dV_GP_S+d_SP_S_pC_dV_GP_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_S+d_SP_S_qC_dV_GP_S*SP_S_temp));
d_SP_S_temp_dV_D_S = ((SP_S_pC*d_SP_S_pC_dV_D_S+d_SP_S_pC_dV_D_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_D_S+d_SP_S_qC_dV_D_S*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_S_BP = (d_SP_S_x0_dV_S_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_S = (d_SP_S_x0_dV_GP_S+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_D_S = (d_SP_S_x0_dV_D_S+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}

d_x_d_dV_S_BP = d_x_s_dV_S_BP;
d_x_d_dV_GP_S = d_x_s_dV_GP_S;
d_x_d_dV_D_S = d_x_s_dV_D_S;
x_d = x_s;

d_x_m_dV_S_BP = d_x_s_dV_S_BP;
d_x_m_dV_GP_S = d_x_s_dV_GP_S;
d_x_m_dV_D_S = d_x_s_dV_D_S;
x_m = x_s;

d_x_ds_dV_D_S = d_x_ds_dV_GP_S = d_x_ds_dV_S_BP =  0.0;
x_ds = 0.0;
if ((xg<=0.0))
{

d_qis_dV_D_S = d_qis_dV_GP_S = d_qis_dV_S_BP =  0.0;
qis = 0.0;

d_Ids_dV_GP_S = d_Ids_dV_D_S = d_Ids_dV_S_BP =  0.0;
Ids = 0.0;

d_xgm_dV_S_BP = (d_xg_dV_S_BP-d_x_s_dV_S_BP);
d_xgm_dV_GP_S = (d_xg_dV_GP_S-d_x_s_dV_GP_S);
d_xgm_dV_D_S = (d_xg_dV_D_S-d_x_s_dV_D_S);
xgm = (xg-x_s);

d_Voxm_dV_S_BP = d_xgm_dV_S_BP*phit1;
d_Voxm_dV_GP_S = d_xgm_dV_GP_S*phit1;
d_Voxm_dV_D_S = d_xgm_dV_D_S*phit1;
Voxm = (xgm*phit1);

d_qeff_dV_S_BP = d_Voxm_dV_S_BP;
d_qeff_dV_GP_S = d_Voxm_dV_GP_S;
d_qeff_dV_D_S = d_Voxm_dV_D_S;
qeff = Voxm;

d_Vdsat_dV_D_S = d_Vdsat_dV_GP_S = d_Vdsat_dV_S_BP =  0.0;
Vdsat = Vdsat_lim;

d_Vdse_dV_GP_S = d_Vdse_dV_S_BP =  0.0;
d_Vdse_dV_D_S = d_Vds_dV_D_S;
Vdse = Vds;
}
else
{

d_delta_1s_dV_D_S = d_delta_1s_dV_GP_S = d_delta_1s_dV_S_BP =  0.0;
delta_1s = 0.0;

d_temp_dV_S_BP = (-(x_s*d_x_s_dV_S_BP+d_x_s_dV_S_BP*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_GP_S = (-(x_s*d_x_s_dV_GP_S+d_x_s_dV_GP_S*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_D_S = (-(x_s*d_x_s_dV_D_S+d_x_s_dV_D_S*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));

d_xi0s_dV_S_BP = ((x_s*x_s)*d_temp_dV_S_BP+(x_s*d_x_s_dV_S_BP+d_x_s_dV_S_BP*x_s)*temp);
d_xi0s_dV_GP_S = ((x_s*x_s)*d_temp_dV_GP_S+(x_s*d_x_s_dV_GP_S+d_x_s_dV_GP_S*x_s)*temp);
d_xi0s_dV_D_S = ((x_s*x_s)*d_temp_dV_D_S+(x_s*d_x_s_dV_D_S+d_x_s_dV_D_S*x_s)*temp);
xi0s = ((x_s*x_s)*temp);

d_xi1s_dV_S_BP = 4.0*((x_s*temp)*d_temp_dV_S_BP+(x_s*d_temp_dV_S_BP+d_x_s_dV_S_BP*temp)*temp);
d_xi1s_dV_GP_S = 4.0*((x_s*temp)*d_temp_dV_GP_S+(x_s*d_temp_dV_GP_S+d_x_s_dV_GP_S*temp)*temp);
d_xi1s_dV_D_S = 4.0*((x_s*temp)*d_temp_dV_D_S+(x_s*d_temp_dV_D_S+d_x_s_dV_D_S*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));

d_xi2s_dV_S_BP = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_S_BP+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_S_BP+(8.0*d_temp_dV_S_BP-12.0*d_xi0s_dV_S_BP)*temp)*temp);
d_xi2s_dV_D_S = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_D_S+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_D_S+(8.0*d_temp_dV_D_S-12.0*d_xi0s_dV_D_S)*temp)*temp);
d_xi2s_dV_GP_S = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_S+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_S+(8.0*d_temp_dV_GP_S-12.0*d_xi0s_dV_GP_S)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_S_BP = (deriv_exp_0_d0*(d_x_s_dV_S_BP));
d_delta_1s_dV_GP_S = (deriv_exp_0_d0*(d_x_s_dV_GP_S));
d_delta_1s_dV_D_S = (deriv_exp_0_d0*(d_x_s_dV_D_S));
delta_1s = value_exp_0;
}

d_Es_dV_S_BP = (-d_delta_1s_dV_S_BP/delta_1s/delta_1s);
d_Es_dV_GP_S = (-d_delta_1s_dV_GP_S/delta_1s/delta_1s);
d_Es_dV_D_S = (-d_delta_1s_dV_D_S/delta_1s/delta_1s);
Es = (1.0/delta_1s);

d_delta_1s_dV_GP_S = delta_ns*d_delta_1s_dV_GP_S;
d_delta_1s_dV_S_BP = (delta_ns*d_delta_1s_dV_S_BP+d_delta_ns_dV_S_BP*delta_1s);
d_delta_1s_dV_D_S = (delta_ns*d_delta_1s_dV_D_S+d_delta_ns_dV_D_S*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_S_BP = (deriv_exp_0_d0*((d_x_s_dV_S_BP-d_xn_s_dV_S_BP)));
d_delta_1s_dV_GP_S = (deriv_exp_0_d0*(d_x_s_dV_GP_S));
d_delta_1s_dV_D_S = (deriv_exp_0_d0*((d_x_s_dV_D_S-d_xn_s_dV_D_S)));
delta_1s = value_exp_0;
}

d_Es_dV_GP_S = (-delta_ns*d_delta_1s_dV_GP_S/delta_1s/delta_1s);
d_Es_dV_S_BP = ((delta_1s*d_delta_ns_dV_S_BP-delta_ns*d_delta_1s_dV_S_BP)/delta_1s/delta_1s);
d_Es_dV_D_S = ((delta_1s*d_delta_ns_dV_D_S-delta_ns*d_delta_1s_dV_D_S)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{

d_delta_1s_dV_GP_S = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(-d_x_s_dV_GP_S)*3.3333333333333333e-01+(-d_x_s_dV_GP_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_x_s_dV_GP_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_S_BP = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*3.3333333333333333e-01+(d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_S_BP-d_x_s_dV_S_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_D_S = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_D_S-d_x_s_dV_D_S)*3.3333333333333333e-01+(d_xn_s_dV_D_S-d_x_s_dV_D_S)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_D_S-d_x_s_dV_D_S)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Es_dV_S_BP = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_S_BP*3.3333333333333333e-01+d_x_s_dV_S_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_S_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_GP_S = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_GP_S*3.3333333333333333e-01+d_x_s_dV_GP_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_GP_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_D_S = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_D_S*3.3333333333333333e-01+d_x_s_dV_D_S*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_D_S*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Ds_dV_S_BP = (d_delta_1s_dV_S_BP-(delta_ns*(d_x_s_dV_S_BP+d_xi0s_dV_S_BP)+d_delta_ns_dV_S_BP*((x_s+1.0)+xi0s)));
d_Ds_dV_GP_S = (d_delta_1s_dV_GP_S-delta_ns*(d_x_s_dV_GP_S+d_xi0s_dV_GP_S));
d_Ds_dV_D_S = (d_delta_1s_dV_D_S-(delta_ns*(d_x_s_dV_D_S+d_xi0s_dV_D_S)+d_delta_ns_dV_D_S*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{

d_Ps_dV_S_BP = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_S_BP)+d_x_s_dV_S_BP*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_S_BP+d_x_s_dV_S_BP*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_GP_S = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_S)+d_x_s_dV_GP_S*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_GP_S+d_x_s_dV_GP_S*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_D_S = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_D_S)+d_x_s_dV_D_S*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_D_S+d_x_s_dV_D_S*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

d_Ds_dV_GP_S = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_GP_S+(((delta_ns*x_s)*x_s)*d_x_s_dV_GP_S+((delta_ns*x_s)*d_x_s_dV_GP_S+delta_ns*d_x_s_dV_GP_S*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_S_BP = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_S_BP+(((delta_ns*x_s)*x_s)*d_x_s_dV_S_BP+((delta_ns*x_s)*d_x_s_dV_S_BP+(delta_ns*d_x_s_dV_S_BP+d_delta_ns_dV_S_BP*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_D_S = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_D_S+(((delta_ns*x_s)*x_s)*d_x_s_dV_D_S+((delta_ns*x_s)*d_x_s_dV_D_S+(delta_ns*d_x_s_dV_D_S+d_delta_ns_dV_D_S*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_S_BP)+d_x_s_dV_S_BP*(1.0-(0.25*x_s))))));
d_temp_dV_GP_S = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_S)+d_x_s_dV_GP_S*(1.0-(0.25*x_s))))));
d_temp_dV_D_S = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_D_S)+d_x_s_dV_D_S*(1.0-(0.25*x_s))))));
temp = value_sqrt_0;
}

d_sqm_dV_S_BP = 7.0710678118654746e-01*(x_s*d_temp_dV_S_BP+d_x_s_dV_S_BP*temp);
d_sqm_dV_GP_S = 7.0710678118654746e-01*(x_s*d_temp_dV_GP_S+d_x_s_dV_GP_S*temp);
d_sqm_dV_D_S = 7.0710678118654746e-01*(x_s*d_temp_dV_D_S+d_x_s_dV_D_S*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));

d_alpha_dV_S_BP = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_S_BP)+1.6666666666666667e-01*(x_s*d_x_s_dV_S_BP+d_x_s_dV_S_BP*x_s))+d_Gf_dV_S_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_S_BP)/temp/temp);
d_alpha_dV_GP_S = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_GP_S)+1.6666666666666667e-01*(x_s*d_x_s_dV_GP_S+d_x_s_dV_GP_S*x_s))+d_Gf_dV_GP_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_S)/temp/temp);
d_alpha_dV_D_S = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_D_S)+1.6666666666666667e-01*(x_s*d_x_s_dV_D_S+d_x_s_dV_D_S*x_s))+d_Gf_dV_D_S*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_D_S)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{

d_Ps_dV_S_BP = (d_x_s_dV_S_BP+d_Es_dV_S_BP);
d_Ps_dV_GP_S = (d_x_s_dV_GP_S+d_Es_dV_GP_S);
d_Ps_dV_D_S = (d_x_s_dV_D_S+d_Es_dV_D_S);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_S_BP = (deriv_sqrt_0_d0*(d_Ps_dV_S_BP));
d_sqm_dV_GP_S = (deriv_sqrt_0_d0*(d_Ps_dV_GP_S));
d_sqm_dV_D_S = (deriv_sqrt_0_d0*(d_Ps_dV_D_S));
sqm = value_sqrt_0;
}

d_alpha_dV_S_BP = 0.5*((sqm*(Gf*(-d_Es_dV_S_BP)+d_Gf_dV_S_BP*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_S_BP)/sqm/sqm);
d_alpha_dV_GP_S = 0.5*((sqm*(Gf*(-d_Es_dV_GP_S)+d_Gf_dV_GP_S*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_GP_S)/sqm/sqm);
d_alpha_dV_D_S = 0.5*((sqm*(Gf*(-d_Es_dV_D_S)+d_Gf_dV_D_S*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_D_S)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}

d_Em_dV_S_BP = d_Es_dV_S_BP;
d_Em_dV_GP_S = d_Es_dV_GP_S;
d_Em_dV_D_S = d_Es_dV_D_S;
Em = Es;

d_Ed_dV_S_BP = d_Em_dV_S_BP;
d_Ed_dV_GP_S = d_Em_dV_GP_S;
d_Ed_dV_D_S = d_Em_dV_D_S;
Ed = Em;

d_Dm_dV_S_BP = d_Ds_dV_S_BP;
d_Dm_dV_GP_S = d_Ds_dV_GP_S;
d_Dm_dV_D_S = d_Ds_dV_D_S;
Dm = Ds;

d_Dd_dV_S_BP = d_Dm_dV_S_BP;
d_Dd_dV_GP_S = d_Dm_dV_GP_S;
d_Dd_dV_D_S = d_Dm_dV_D_S;
Dd = Dm;

d_Rxcor_dV_S_BP = (((1.0+(XCOR_i*Vsbx))*(0.2*XCOR_i)*d_Vsbx_dV_S_BP-(1.0+((0.2*XCOR_i)*Vsbx))*XCOR_i*d_Vsbx_dV_S_BP)/(1.0+(XCOR_i*Vsbx))/(1.0+(XCOR_i*Vsbx)));
d_Rxcor_dV_D_S = (((1.0+(XCOR_i*Vsbx))*(0.2*XCOR_i)*d_Vsbx_dV_D_S-(1.0+((0.2*XCOR_i)*Vsbx))*XCOR_i*d_Vsbx_dV_D_S)/(1.0+(XCOR_i*Vsbx))/(1.0+(XCOR_i*Vsbx)));
Rxcor = ((1.0+((0.2*XCOR_i)*Vsbx))/(1.0+(XCOR_i*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgs_dV_S_BP = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_S_BP+d_Ds_dV_S_BP)))+d_Gf_dV_S_BP*value_sqrt_0);
d_xgs_dV_GP_S = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_S+d_Ds_dV_GP_S)))+d_Gf_dV_GP_S*value_sqrt_0);
d_xgs_dV_D_S = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_D_S+d_Ds_dV_D_S)))+d_Gf_dV_D_S*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}

d_qis_dV_S_BP = (((xgs+(Gf*sqm))*(Gf2*d_Ds_dV_S_BP+d_Gf2_dV_S_BP*Ds)*phit1-((Gf2*Ds)*phit1)*(d_xgs_dV_S_BP+(Gf*d_sqm_dV_S_BP+d_Gf_dV_S_BP*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_GP_S = (((xgs+(Gf*sqm))*(Gf2*d_Ds_dV_GP_S+d_Gf2_dV_GP_S*Ds)*phit1-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_S+(Gf*d_sqm_dV_GP_S+d_Gf_dV_GP_S*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_D_S = (((xgs+(Gf*sqm))*(Gf2*d_Ds_dV_D_S+d_Gf2_dV_D_S*Ds)*phit1-((Gf2*Ds)*phit1)*(d_xgs_dV_D_S+(Gf*d_sqm_dV_D_S+d_Gf_dV_D_S*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

d_qbs_dV_S_BP = (sqm*d_Gf_dV_S_BP+d_sqm_dV_S_BP*Gf)*phit1;
d_qbs_dV_GP_S = (sqm*d_Gf_dV_GP_S+d_sqm_dV_GP_S*Gf)*phit1;
d_qbs_dV_D_S = (sqm*d_Gf_dV_D_S+d_sqm_dV_D_S*Gf)*phit1;
qbs = ((sqm*Gf)*phit1);
if ((RSB_i<0))
{

d_rhob_dV_S_BP = (-(-RSB_i*d_Vsbx_dV_S_BP)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
d_rhob_dV_D_S = (-(-RSB_i*d_Vsbx_dV_D_S)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
rhob = (1.0/(1.0-(RSB_i*Vsbx)));
}
else
{

d_rhob_dV_S_BP = RSB_i*d_Vsbx_dV_S_BP;
d_rhob_dV_D_S = RSB_i*d_Vsbx_dV_D_S;
rhob = (1.0+(RSB_i*Vsbx));
}
if ((RSG_i<0))
{

d_temp_dV_S_BP = (-RSG_i*d_qis_dV_S_BP);
d_temp_dV_GP_S = (-RSG_i*d_qis_dV_GP_S);
d_temp_dV_D_S = (-RSG_i*d_qis_dV_D_S);
temp = (1.0-(RSG_i*qis));
}
else
{

d_temp_dV_S_BP = (-RSG_i*d_qis_dV_S_BP/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_GP_S = (-RSG_i*d_qis_dV_GP_S/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_D_S = (-RSG_i*d_qis_dV_D_S/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
temp = (1.0/(1.0+(RSG_i*qis)));
}

d_GR_dV_GP_S = THER_i*((rhob*temp)*d_qis_dV_GP_S+rhob*d_temp_dV_GP_S*qis);
d_GR_dV_S_BP = THER_i*((rhob*temp)*d_qis_dV_S_BP+(rhob*d_temp_dV_S_BP+d_rhob_dV_S_BP*temp)*qis);
d_GR_dV_D_S = THER_i*((rhob*temp)*d_qis_dV_D_S+(rhob*d_temp_dV_D_S+d_rhob_dV_D_S*temp)*qis);
GR = (THER_i*((rhob*temp)*qis));

d_Eeffm_dV_S_BP = E_eff0*(d_qbs_dV_S_BP+eta_mu*d_qis_dV_S_BP);
d_Eeffm_dV_GP_S = E_eff0*(d_qbs_dV_GP_S+eta_mu*d_qis_dV_GP_S);
d_Eeffm_dV_D_S = E_eff0*(d_qbs_dV_D_S+eta_mu*d_qis_dV_D_S);
Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*MUE_i),THEMU_i);
double  deriv_pow_0_d0 = (((Eeffm*MUE_i) == 0.0)?0.0:(value_pow_0*THEMU_i/(Eeffm*MUE_i)));

d_Mutmp_dV_S_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_S_BP*MUE_i))+CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_S_BP-Ps*(d_Ps_dV_S_BP+d_Ds_dV_S_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_GP_S = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_S*MUE_i))+CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_S-Ps*(d_Ps_dV_GP_S+d_Ds_dV_GP_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_D_S = ((deriv_pow_0_d0*(d_Eeffm_dV_D_S*MUE_i))+CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dV_D_S-Ps*(d_Ps_dV_D_S+d_Ds_dV_D_S))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
Mutmp = (value_pow_0+(CS_i*(Ps/((Ps+Ds)+1.0e-14))));
}

d_Gmob_dV_S_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_S_BP+(d_Mutmp_dV_S_BP+d_GR_dV_S_BP)*Rxcor);
d_Gmob_dV_GP_S = (d_Mutmp_dV_GP_S+d_GR_dV_GP_S)*Rxcor;
d_Gmob_dV_D_S = (((1.0+Mutmp)+GR)*d_Rxcor_dV_D_S+(d_Mutmp_dV_D_S+d_GR_dV_D_S)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((THESATB_i<0))
{

d_xitsb_dV_S_BP = (-(-THESATB_i*d_Vsbx_dV_S_BP)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
d_xitsb_dV_D_S = (-(-THESATB_i*d_Vsbx_dV_D_S)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
}
else
{

d_xitsb_dV_S_BP = THESATB_i*d_Vsbx_dV_S_BP;
d_xitsb_dV_D_S = THESATB_i*d_Vsbx_dV_D_S;
xitsb = (1.0+(THESATB_i*Vsbx));
}

d_temp2_dV_S_BP = (qis*d_xitsb_dV_S_BP+d_qis_dV_S_BP*xitsb);
d_temp2_dV_GP_S = d_qis_dV_GP_S*xitsb;
d_temp2_dV_D_S = (qis*d_xitsb_dV_D_S+d_qis_dV_D_S*xitsb);
temp2 = (qis*xitsb);

d_wsat_dV_S_BP = 100.0*(((100.0+temp2)*d_temp2_dV_S_BP-temp2*d_temp2_dV_S_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_S = 100.0*(((100.0+temp2)*d_temp2_dV_GP_S-temp2*d_temp2_dV_GP_S)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_D_S = 100.0*(((100.0+temp2)*d_temp2_dV_D_S-temp2*d_temp2_dV_D_S)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((THESATG_i<0))
{

d_temp_dV_S_BP = (-1*(-THESATG_i*d_wsat_dV_S_BP)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
d_temp_dV_GP_S = (-1*(-THESATG_i*d_wsat_dV_GP_S)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
d_temp_dV_D_S = (-1*(-THESATG_i*d_wsat_dV_D_S)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
temp = (1/(1-(THESATG_i*wsat)));
}
else
{

d_temp_dV_S_BP = THESATG_i*d_wsat_dV_S_BP;
d_temp_dV_GP_S = THESATG_i*d_wsat_dV_GP_S;
d_temp_dV_D_S = THESATG_i*d_wsat_dV_D_S;
temp = (1+(THESATG_i*wsat));
}

d_thesat1_dV_S_BP = THESAT_i*((Gmob*d_temp_dV_S_BP-temp*d_Gmob_dV_S_BP)/Gmob/Gmob);
d_thesat1_dV_D_S = THESAT_i*((Gmob*d_temp_dV_D_S-temp*d_Gmob_dV_D_S)/Gmob/Gmob);
d_thesat1_dV_GP_S = THESAT_i*((Gmob*d_temp_dV_GP_S-temp*d_Gmob_dV_GP_S)/Gmob/Gmob);
thesat1 = (THESAT_i*(temp/Gmob));

d_phi_inf_dV_S_BP = ((alpha*d_qis_dV_S_BP-qis*d_alpha_dV_S_BP)/alpha/alpha);
d_phi_inf_dV_GP_S = ((alpha*d_qis_dV_GP_S-qis*d_alpha_dV_GP_S)/alpha/alpha);
d_phi_inf_dV_D_S = ((alpha*d_qis_dV_D_S-qis*d_alpha_dV_D_S)/alpha/alpha);
phi_inf = ((qis/alpha)+phit1);

d_ysat_dV_S_BP = (thesat1*d_phi_inf_dV_S_BP+d_thesat1_dV_S_BP*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_D_S = (thesat1*d_phi_inf_dV_D_S+d_thesat1_dV_D_S*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_GP_S = (thesat1*d_phi_inf_dV_GP_S+d_thesat1_dV_GP_S*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if (((model_.CHNL_TYPE)==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ysat_dV_S_BP = ((value_sqrt_0*d_ysat_dV_S_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_S_BP)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_D_S = ((value_sqrt_0*d_ysat_dV_D_S-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_D_S)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_GP_S = ((value_sqrt_0*d_ysat_dV_GP_S-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_S)))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_za_dV_S_BP = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_S_BP))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_D_S = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_D_S))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_GP_S = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_GP_S))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}

d_temp1_dV_S_BP = (za*d_ysat_dV_S_BP+d_za_dV_S_BP*ysat);
d_temp1_dV_D_S = (za*d_ysat_dV_D_S+d_za_dV_D_S*ysat);
d_temp1_dV_GP_S = (za*d_ysat_dV_GP_S+d_za_dV_GP_S*ysat);
temp1 = (za*ysat);

d_Phi_0_dV_S_BP = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_S_BP+d_temp1_dV_S_BP*za))+d_temp1_dV_S_BP*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_S_BP+(temp1*d_temp1_dV_S_BP+d_temp1_dV_S_BP*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_S_BP+d_phi_inf_dV_S_BP*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_GP_S = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_GP_S+d_temp1_dV_GP_S*za))+d_temp1_dV_GP_S*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_GP_S+(temp1*d_temp1_dV_GP_S+d_temp1_dV_GP_S*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_GP_S+d_phi_inf_dV_GP_S*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_D_S = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_D_S+d_temp1_dV_D_S*za))+d_temp1_dV_D_S*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_D_S+(temp1*d_temp1_dV_D_S+d_temp1_dV_D_S*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_D_S+d_phi_inf_dV_D_S*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

d_asat_dV_S_BP = (d_xgs_dV_S_BP+0.5*d_Gf2_dV_S_BP);
d_asat_dV_GP_S = (d_xgs_dV_GP_S+0.5*d_Gf2_dV_GP_S);
d_asat_dV_D_S = (d_xgs_dV_D_S+0.5*d_Gf2_dV_D_S);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_2_dV_S_BP = 0.98*(((asat+value_sqrt_0)*(Gf2*d_Ds_dV_S_BP+d_Gf2_dV_S_BP*Ds)*phit1-((Gf2*Ds)*phit1)*(d_asat_dV_S_BP+(deriv_sqrt_0_d0*(((asat*d_asat_dV_S_BP+d_asat_dV_S_BP*asat)-(Gf2*d_Ds_dV_S_BP+d_Gf2_dV_S_BP*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_GP_S = 0.98*(((asat+value_sqrt_0)*(Gf2*d_Ds_dV_GP_S+d_Gf2_dV_GP_S*Ds)*phit1-((Gf2*Ds)*phit1)*(d_asat_dV_GP_S+(deriv_sqrt_0_d0*(((asat*d_asat_dV_GP_S+d_asat_dV_GP_S*asat)-(Gf2*d_Ds_dV_GP_S+d_Gf2_dV_GP_S*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_D_S = 0.98*(((asat+value_sqrt_0)*(Gf2*d_Ds_dV_D_S+d_Gf2_dV_D_S*Ds)*phit1-((Gf2*Ds)*phit1)*(d_asat_dV_D_S+(deriv_sqrt_0_d0*(((asat*d_asat_dV_D_S+d_asat_dV_D_S*asat)-(Gf2*d_Ds_dV_D_S+d_Gf2_dV_D_S*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
}

d_Phi_0_2_dV_S_BP = (d_Phi_0_dV_S_BP+d_Phi_2_dV_S_BP);
d_Phi_0_2_dV_GP_S = (d_Phi_0_dV_GP_S+d_Phi_2_dV_GP_S);
d_Phi_0_2_dV_D_S = (d_Phi_0_dV_D_S+d_Phi_2_dV_D_S);
Phi_0_2 = (Phi_0+Phi_2);

d_Phi0_Phi2_dV_S_BP = 2.0*(Phi_0*d_Phi_2_dV_S_BP+d_Phi_0_dV_S_BP*Phi_2);
d_Phi0_Phi2_dV_GP_S = 2.0*(Phi_0*d_Phi_2_dV_GP_S+d_Phi_0_dV_GP_S*Phi_2);
d_Phi0_Phi2_dV_D_S = 2.0*(Phi_0*d_Phi_2_dV_D_S+d_Phi_0_dV_D_S*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_sat_dV_S_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_S_BP-Phi0_Phi2*(d_Phi_0_2_dV_S_BP+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_S_BP+d_Phi_0_2_dV_S_BP*Phi_0_2)-1.98*d_Phi0_Phi2_dV_S_BP)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_GP_S = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_S-Phi0_Phi2*(d_Phi_0_2_dV_GP_S+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_GP_S+d_Phi_0_2_dV_GP_S*Phi_0_2)-1.98*d_Phi0_Phi2_dV_GP_S)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_D_S = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_D_S-Phi0_Phi2*(d_Phi_0_2_dV_D_S+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_D_S+d_Phi_0_2_dV_D_S*Phi_0_2)-1.98*d_Phi0_Phi2_dV_D_S)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

d_Vdsat_dV_S_BP = (d_Phi_sat_dV_S_BP-phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_S_BP+(Phi_sat*(d_Phi_sat_dV_S_BP-2.0*d_asat_dV_S_BP*phit1)+d_Phi_sat_dV_S_BP*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(phit1*phit1)*d_Ds_dV_S_BP)/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))));
d_Vdsat_dV_GP_S = (d_Phi_sat_dV_GP_S-phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_S+(Phi_sat*(d_Phi_sat_dV_GP_S-2.0*d_asat_dV_GP_S*phit1)+d_Phi_sat_dV_GP_S*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(phit1*phit1)*d_Ds_dV_GP_S)/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))));
d_Vdsat_dV_D_S = (d_Phi_sat_dV_D_S-phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_D_S+(Phi_sat*(d_Phi_sat_dV_D_S-2.0*d_asat_dV_D_S*phit1)+d_Phi_sat_dV_D_S*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*(phit1*phit1)*d_Ds_dV_D_S)/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))));
Vdsat = (Phi_sat-(phit1*value_log_0));
}
}
else
{

d_Vdsat_dV_D_S = d_Vdsat_dV_GP_S = d_Vdsat_dV_S_BP =  0.0;
Vdsat = Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

d_temp_dV_S_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_S_BP/Vdsat/Vdsat)));
d_temp_dV_GP_S = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_S/Vdsat/Vdsat)));
d_temp_dV_D_S = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_D_S-Vds*d_Vdsat_dV_D_S)/Vdsat/Vdsat)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

d_Vdse_dV_S_BP = Vds*(deriv_pow_0_d0*(d_temp_dV_S_BP));
d_Vdse_dV_GP_S = Vds*(deriv_pow_0_d0*(d_temp_dV_GP_S));
d_Vdse_dV_D_S = (Vds*(deriv_pow_0_d0*(d_temp_dV_D_S))+d_Vds_dV_D_S*value_pow_0);
Vdse = (Vds*value_pow_0);
}

d_Udse_dV_D_S = d_Vdse_dV_D_S*inv_phit1;
d_Udse_dV_S_BP = d_Vdse_dV_S_BP*inv_phit1;
d_Udse_dV_GP_S = d_Vdse_dV_GP_S*inv_phit1;
Udse = (Vdse*inv_phit1);

d_xn_d_dV_GP_S = d_Udse_dV_GP_S;
d_xn_d_dV_S_BP = (d_xn_s_dV_S_BP+d_Udse_dV_S_BP);
d_xn_d_dV_D_S = (d_xn_s_dV_D_S+d_Udse_dV_D_S);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;

d_k_ds_dV_D_S = (deriv_exp_0_d0*((-d_Udse_dV_D_S)));
d_k_ds_dV_S_BP = (deriv_exp_0_d0*((-d_Udse_dV_S_BP)));
d_k_ds_dV_GP_S = (deriv_exp_0_d0*((-d_Udse_dV_GP_S)));
k_ds = value_exp_0;
}
}
else
{

d_k_ds_dV_D_S = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_D_S*3.3333333333333333e-01+d_Udse_dV_D_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_D_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_S_BP = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_S_BP*3.3333333333333333e-01+d_Udse_dV_S_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_S_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_GP_S = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_GP_S*3.3333333333333333e-01+d_Udse_dV_GP_S*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_GP_S*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_delta_nd_dV_GP_S = delta_ns*d_k_ds_dV_GP_S;
d_delta_nd_dV_S_BP = (delta_ns*d_k_ds_dV_S_BP+d_delta_ns_dV_S_BP*k_ds);
d_delta_nd_dV_D_S = (delta_ns*d_k_ds_dV_D_S+d_delta_ns_dV_D_S*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_S_BP = (inv_xi*d_inv_xi_dV_S_BP+d_inv_xi_dV_S_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_S = (inv_xi*d_inv_xi_dV_GP_S+d_inv_xi_dV_GP_S*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_D_S = (inv_xi*d_inv_xi_dV_D_S+d_inv_xi_dV_D_S*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_d_dV_S_BP = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_S_BP+((xg*(1.0-delta_nd))*d_Gf_dV_S_BP+(xg*(-d_delta_nd_dV_S_BP)+d_xg_dV_S_BP*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_S_BP+d_xg_dV_S_BP*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_GP_S = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_S+((xg*(1.0-delta_nd))*d_Gf_dV_GP_S+(xg*(-d_delta_nd_dV_GP_S)+d_xg_dV_GP_S*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_S+d_xg_dV_GP_S*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_D_S = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_D_S+((xg*(1.0-delta_nd))*d_Gf_dV_D_S+(xg*(-d_delta_nd_dV_D_S)+d_xg_dV_D_S*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_D_S+d_xg_dV_D_S*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{

d_SP_S_bx_dV_GP_S = d_xn_d_dV_GP_S;
d_SP_S_bx_dV_S_BP = d_xn_d_dV_S_BP;
d_SP_S_bx_dV_D_S = d_xn_d_dV_D_S;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_S_BP = (0.5*((d_SP_S_x1_dV_S_BP+d_SP_S_bx_dV_S_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)+(d_SP_S_x1_dV_S_BP-d_SP_S_bx_dV_S_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_S_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_S_BP+d_SP_S_bx_dV_S_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_S = (0.5*((d_SP_S_x1_dV_GP_S+d_SP_S_bx_dV_GP_S)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)+(d_SP_S_x1_dV_GP_S-d_SP_S_bx_dV_GP_S)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_S-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_S+d_SP_S_bx_dV_GP_S*SP_S_bx)))));
d_SP_S_eta_dV_D_S = (0.5*((d_SP_S_x1_dV_D_S+d_SP_S_bx_dV_D_S)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)+(d_SP_S_x1_dV_D_S-d_SP_S_bx_dV_D_S)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_D_S-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_D_S+d_SP_S_bx_dV_D_S*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_eta_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_eta_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_eta_dV_D_S);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_S_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_S_BP)));
d_SP_S_temp1_dV_GP_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_S)));
d_SP_S_temp1_dV_D_S = (deriv_exp_0_d0*((-d_SP_S_eta_dV_D_S)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_S_BP = (-(SP_S_eta*d_SP_S_eta_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_S = (-(SP_S_eta*d_SP_S_eta_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_D_S = (-(SP_S_eta*d_SP_S_eta_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_S_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_S_BP+(SP_S_eta*d_SP_S_eta_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_S = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_S+(SP_S_eta*d_SP_S_eta_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_D_S = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_D_S+(SP_S_eta*d_SP_S_eta_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_S_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_S_BP+(SP_S_eta*d_SP_S_temp2_dV_S_BP+d_SP_S_eta_dV_S_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_S = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_S+(SP_S_eta*d_SP_S_temp2_dV_GP_S+d_SP_S_eta_dV_GP_S*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_D_S = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_D_S+(SP_S_eta*d_SP_S_temp2_dV_D_S+d_SP_S_eta_dV_D_S*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_S_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_S_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_S_BP+(8.0*d_SP_S_temp2_dV_S_BP-12.0*d_SP_S_xi0_dV_S_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_S = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_S+(8.0*d_SP_S_temp2_dV_GP_S-12.0*d_SP_S_xi0_dV_GP_S)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_D_S = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_D_S+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_D_S+(8.0*d_SP_S_temp2_dV_D_S-12.0*d_SP_S_xi0_dV_D_S)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_S_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_S_BP+d_SP_S_eta_dV_S_BP)-(delta_nd*(d_SP_S_eta_dV_S_BP+d_SP_S_xi0_dV_S_BP)+d_delta_nd_dV_S_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_S_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_S = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_S+d_SP_S_eta_dV_GP_S)-(delta_nd*(d_SP_S_eta_dV_GP_S+d_SP_S_xi0_dV_GP_S)+d_delta_nd_dV_GP_S*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_D_S = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_D_S+d_SP_S_eta_dV_D_S)-(delta_nd*(d_SP_S_eta_dV_D_S+d_SP_S_xi0_dV_D_S)+d_delta_nd_dV_D_S*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_D_S*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_S_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_S_BP-(delta_nd*d_SP_S_xi2_dV_S_BP+d_delta_nd_dV_S_BP*SP_S_xi2))+d_Gf2_dV_S_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_GP_S = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_S-(delta_nd*d_SP_S_xi2_dV_GP_S+d_delta_nd_dV_GP_S*SP_S_xi2))+d_Gf2_dV_GP_S*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_D_S = (-0.5*(Gf2*(d_SP_S_temp1_dV_D_S-(delta_nd*d_SP_S_xi2_dV_D_S+d_delta_nd_dV_D_S*SP_S_xi2))+d_Gf2_dV_D_S*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

d_SP_S_c_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP+(Gf2*((-d_SP_S_temp1_dV_S_BP)-(delta_nd*d_SP_S_xi1_dV_S_BP+d_delta_nd_dV_S_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_S_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S+(Gf2*((-d_SP_S_temp1_dV_GP_S)-(delta_nd*d_SP_S_xi1_dV_GP_S+d_delta_nd_dV_GP_S*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_D_S = (2.0*d_SP_S_temp_dV_D_S+(Gf2*((-d_SP_S_temp1_dV_D_S)-(delta_nd*d_SP_S_xi1_dV_D_S+d_delta_nd_dV_D_S*(1.0+SP_S_xi1)))+d_Gf2_dV_D_S*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_GP_S = ((d_xn_d_dV_GP_S-d_SP_S_eta_dV_GP_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_S-SP_S_a*d_Gf2_dV_GP_S)/Gf2/Gf2))));
d_SP_S_tau_dV_S_BP = ((d_xn_d_dV_S_BP-d_SP_S_eta_dV_S_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_S_BP-SP_S_a*d_Gf2_dV_S_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_D_S = ((d_xn_d_dV_D_S-d_SP_S_eta_dV_D_S)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_D_S-SP_S_a*d_Gf2_dV_D_S)/Gf2/Gf2))));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}

d_nu_dV_S_BP = (d_SP_S_a_dV_S_BP+d_SP_S_c_dV_S_BP);
d_nu_dV_GP_S = (d_SP_S_a_dV_GP_S+d_SP_S_c_dV_GP_S);
d_nu_dV_D_S = (d_SP_S_a_dV_D_S+d_SP_S_c_dV_D_S);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_S_BP = ((nu*d_nu_dV_S_BP+d_nu_dV_S_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_S_BP+d_SP_S_a_dV_S_BP*SP_S_b))+d_SP_S_tau_dV_S_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_S = ((nu*d_nu_dV_GP_S+d_nu_dV_GP_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_S+d_SP_S_a_dV_GP_S*SP_S_b))+d_SP_S_tau_dV_GP_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)-(SP_S_a*d_SP_S_b_dV_D_S+d_SP_S_a_dV_D_S*SP_S_b))+d_SP_S_tau_dV_D_S*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_S_BP = (d_SP_S_eta_dV_S_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_S_BP+(SP_S_a*d_nu_dV_S_BP+d_SP_S_a_dV_S_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_S_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_S_BP+d_SP_S_c_dV_S_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_S_BP+d_SP_S_a_dV_S_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_S_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_S_BP+((nu/mutau)*d_SP_S_tau_dV_S_BP+((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_S = (d_SP_S_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_S+(SP_S_a*d_nu_dV_GP_S+d_SP_S_a_dV_GP_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_S+d_SP_S_c_dV_GP_S*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_S+d_SP_S_a_dV_GP_S*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_S+((nu/mutau)*d_SP_S_tau_dV_GP_S+((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_D_S = (d_SP_S_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_D_S+(SP_S_a*d_nu_dV_D_S+d_SP_S_a_dV_D_S*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_D_S+d_SP_S_c_dV_D_S*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_D_S+d_SP_S_a_dV_D_S*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_D_S+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_D_S+((nu/mutau)*d_SP_S_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_S_BP));
d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_S));
d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*(d_SP_S_x0_dV_D_S));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_S_BP = (-d_SP_S_delta0_dV_S_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_S = (-d_SP_S_delta0_dV_GP_S/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_D_S = (-d_SP_S_delta0_dV_D_S/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_GP_S = (delta_nd*d_SP_S_delta0_dV_GP_S+d_delta_nd_dV_GP_S*SP_S_delta0);
d_SP_S_delta0_dV_S_BP = (delta_nd*d_SP_S_delta0_dV_S_BP+d_delta_nd_dV_S_BP*SP_S_delta0);
d_SP_S_delta0_dV_D_S = (delta_nd*d_SP_S_delta0_dV_D_S+d_delta_nd_dV_D_S*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_S_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_S_BP-d_xn_d_dV_S_BP)));
d_SP_S_delta0_dV_GP_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_S-d_xn_d_dV_GP_S)));
d_SP_S_delta0_dV_D_S = (deriv_exp_0_d0*((d_SP_S_x0_dV_D_S-d_xn_d_dV_D_S)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_GP_S = ((SP_S_delta0*d_delta_nd_dV_GP_S-delta_nd*d_SP_S_delta0_dV_GP_S)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_S_BP = ((SP_S_delta0*d_delta_nd_dV_S_BP-delta_nd*d_SP_S_delta0_dV_S_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_D_S = ((SP_S_delta0*d_delta_nd_dV_D_S-delta_nd*d_SP_S_delta0_dV_D_S)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_GP_S = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*3.3333333333333333e-01+(d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_S-d_SP_S_x0_dV_GP_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_S_BP = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*3.3333333333333333e-01+(d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_S_BP-d_SP_S_x0_dV_S_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_D_S = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*3.3333333333333333e-01+(d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_D_S-d_SP_S_x0_dV_D_S)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_S_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_S_BP*3.3333333333333333e-01+d_SP_S_x0_dV_S_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_S_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_S = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_S*3.3333333333333333e-01+d_SP_S_x0_dV_GP_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_D_S = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_D_S*3.3333333333333333e-01+d_SP_S_x0_dV_D_S*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_D_S*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_S_BP = (-(SP_S_x0*d_SP_S_x0_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_S = (-(SP_S_x0*d_SP_S_x0_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_D_S = (-(SP_S_x0*d_SP_S_x0_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_S_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_S_BP+(SP_S_x0*d_SP_S_x0_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_S = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_S+(SP_S_x0*d_SP_S_x0_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_D_S = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_D_S+(SP_S_x0*d_SP_S_x0_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_S_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_S_BP+(SP_S_x0*d_SP_S_temp_dV_S_BP+d_SP_S_x0_dV_S_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_S = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_S+(SP_S_x0*d_SP_S_temp_dV_GP_S+d_SP_S_x0_dV_GP_S*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_D_S = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_D_S+(SP_S_x0*d_SP_S_temp_dV_D_S+d_SP_S_x0_dV_D_S*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_S_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_S_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_S_BP+(8.0*d_SP_S_temp_dV_S_BP-12.0*d_SP_S_xi0_dV_S_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_S+(8.0*d_SP_S_temp_dV_GP_S-12.0*d_SP_S_xi0_dV_GP_S)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_D_S = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_D_S+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_D_S+(8.0*d_SP_S_temp_dV_D_S-12.0*d_SP_S_xi0_dV_D_S)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_S_BP = (d_xg_dV_S_BP-d_SP_S_x0_dV_S_BP);
d_SP_S_temp_dV_GP_S = (d_xg_dV_GP_S-d_SP_S_x0_dV_GP_S);
d_SP_S_temp_dV_D_S = (d_xg_dV_D_S-d_SP_S_x0_dV_D_S);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_S_BP = (2.0*d_SP_S_temp_dV_S_BP+(Gf2*(((-d_SP_S_delta1_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-(delta_nd*d_SP_S_xi1_dV_S_BP+d_delta_nd_dV_S_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_S_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_S = (2.0*d_SP_S_temp_dV_GP_S+(Gf2*(((-d_SP_S_delta1_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-(delta_nd*d_SP_S_xi1_dV_GP_S+d_delta_nd_dV_GP_S*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_D_S = (2.0*d_SP_S_temp_dV_D_S+(Gf2*(((-d_SP_S_delta1_dV_D_S)+d_SP_S_delta0_dV_D_S)-(delta_nd*d_SP_S_xi1_dV_D_S+d_delta_nd_dV_D_S*(1.0+SP_S_xi1)))+d_Gf2_dV_D_S*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_S_BP = ((SP_S_temp*d_SP_S_temp_dV_S_BP+d_SP_S_temp_dV_S_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_S_BP+d_SP_S_x0_dV_S_BP)+d_SP_S_delta0_dV_S_BP)-(delta_nd*(d_SP_S_x0_dV_S_BP+d_SP_S_xi0_dV_S_BP)+d_delta_nd_dV_S_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_S_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_S = ((SP_S_temp*d_SP_S_temp_dV_GP_S+d_SP_S_temp_dV_GP_S*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_S+d_SP_S_x0_dV_GP_S)+d_SP_S_delta0_dV_GP_S)-(delta_nd*(d_SP_S_x0_dV_GP_S+d_SP_S_xi0_dV_GP_S)+d_delta_nd_dV_GP_S*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_D_S = ((SP_S_temp*d_SP_S_temp_dV_D_S+d_SP_S_temp_dV_D_S*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_D_S+d_SP_S_x0_dV_D_S)+d_SP_S_delta0_dV_D_S)-(delta_nd*(d_SP_S_x0_dV_D_S+d_SP_S_xi0_dV_D_S)+d_delta_nd_dV_D_S*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_D_S*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_S_BP = (-(Gf2*((d_SP_S_delta1_dV_S_BP+d_SP_S_delta0_dV_S_BP)-(delta_nd*d_SP_S_xi2_dV_S_BP+d_delta_nd_dV_S_BP*SP_S_xi2))+d_Gf2_dV_S_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_GP_S = (-(Gf2*((d_SP_S_delta1_dV_GP_S+d_SP_S_delta0_dV_GP_S)-(delta_nd*d_SP_S_xi2_dV_GP_S+d_delta_nd_dV_GP_S*SP_S_xi2))+d_Gf2_dV_GP_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_D_S = (-(Gf2*((d_SP_S_delta1_dV_D_S+d_SP_S_delta0_dV_D_S)-(delta_nd*d_SP_S_xi2_dV_D_S+d_delta_nd_dV_D_S*SP_S_xi2))+d_Gf2_dV_D_S*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

d_SP_S_temp_dV_S_BP = ((SP_S_pC*d_SP_S_pC_dV_S_BP+d_SP_S_pC_dV_S_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_S_BP+d_SP_S_qC_dV_S_BP*SP_S_temp));
d_SP_S_temp_dV_GP_S = ((SP_S_pC*d_SP_S_pC_dV_GP_S+d_SP_S_pC_dV_GP_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_S+d_SP_S_qC_dV_GP_S*SP_S_temp));
d_SP_S_temp_dV_D_S = ((SP_S_pC*d_SP_S_pC_dV_D_S+d_SP_S_pC_dV_D_S*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_D_S+d_SP_S_qC_dV_D_S*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_d_dV_S_BP = (d_SP_S_x0_dV_S_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_S_BP-SP_S_qC*(d_SP_S_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_S_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_GP_S = (d_SP_S_x0_dV_GP_S+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_S-SP_S_qC*(d_SP_S_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_D_S = (d_SP_S_x0_dV_D_S+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_D_S-SP_S_qC*(d_SP_S_pC_dV_D_S+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_D_S))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}

d_x_ds_dV_S_BP = (d_x_d_dV_S_BP-d_x_s_dV_S_BP);
d_x_ds_dV_GP_S = (d_x_d_dV_GP_S-d_x_s_dV_GP_S);
d_x_ds_dV_D_S = (d_x_d_dV_D_S-d_x_s_dV_D_S);
x_ds = (x_d-x_s);
if ((x_ds<1.0E-10))
{

d_pC_dV_S_BP = (2.0*(d_xg_dV_S_BP-d_x_s_dV_S_BP)+(Gf2*(((-d_Es_dV_S_BP)+(delta_1s*d_k_ds_dV_S_BP+d_delta_1s_dV_S_BP*k_ds))-(delta_nd*d_xi1s_dV_S_BP+d_delta_nd_dV_S_BP*(1.0+xi1s)))+d_Gf2_dV_S_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_GP_S = (2.0*(d_xg_dV_GP_S-d_x_s_dV_GP_S)+(Gf2*(((-d_Es_dV_GP_S)+(delta_1s*d_k_ds_dV_GP_S+d_delta_1s_dV_GP_S*k_ds))-(delta_nd*d_xi1s_dV_GP_S+d_delta_nd_dV_GP_S*(1.0+xi1s)))+d_Gf2_dV_GP_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_D_S = (2.0*(d_xg_dV_D_S-d_x_s_dV_D_S)+(Gf2*(((-d_Es_dV_D_S)+(delta_1s*d_k_ds_dV_D_S+d_delta_1s_dV_D_S*k_ds))-(delta_nd*d_xi1s_dV_D_S+d_delta_nd_dV_D_S*(1.0+xi1s)))+d_Gf2_dV_D_S*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

d_qC_dV_S_BP = ((Gf2*(1.0-k_ds))*d_Ds_dV_S_BP+(Gf2*(-d_k_ds_dV_S_BP)+d_Gf2_dV_S_BP*(1.0-k_ds))*Ds);
d_qC_dV_GP_S = ((Gf2*(1.0-k_ds))*d_Ds_dV_GP_S+(Gf2*(-d_k_ds_dV_GP_S)+d_Gf2_dV_GP_S*(1.0-k_ds))*Ds);
d_qC_dV_D_S = ((Gf2*(1.0-k_ds))*d_Ds_dV_D_S+(Gf2*(-d_k_ds_dV_D_S)+d_Gf2_dV_D_S*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);

d_temp_dV_S_BP = (-(Gf2*((d_Es_dV_S_BP+(delta_1s*d_k_ds_dV_S_BP+d_delta_1s_dV_S_BP*k_ds))-(delta_nd*d_xi2s_dV_S_BP+d_delta_nd_dV_S_BP*xi2s))+d_Gf2_dV_S_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_GP_S = (-(Gf2*((d_Es_dV_GP_S+(delta_1s*d_k_ds_dV_GP_S+d_delta_1s_dV_GP_S*k_ds))-(delta_nd*d_xi2s_dV_GP_S+d_delta_nd_dV_GP_S*xi2s))+d_Gf2_dV_GP_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_D_S = (-(Gf2*((d_Es_dV_D_S+(delta_1s*d_k_ds_dV_D_S+d_delta_1s_dV_D_S*k_ds))-(delta_nd*d_xi2s_dV_D_S+d_delta_nd_dV_D_S*xi2s))+d_Gf2_dV_D_S*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

d_temp_dV_S_BP = ((pC*d_pC_dV_S_BP+d_pC_dV_S_BP*pC)-2.0*(temp*d_qC_dV_S_BP+d_temp_dV_S_BP*qC));
d_temp_dV_GP_S = ((pC*d_pC_dV_GP_S+d_pC_dV_GP_S*pC)-2.0*(temp*d_qC_dV_GP_S+d_temp_dV_GP_S*qC));
d_temp_dV_D_S = ((pC*d_pC_dV_D_S+d_pC_dV_D_S*pC)-2.0*(temp*d_qC_dV_D_S+d_temp_dV_D_S*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_ds_dV_S_BP = 2.0*(((pC+value_sqrt_0)*d_qC_dV_S_BP-qC*(d_pC_dV_S_BP+(deriv_sqrt_0_d0*(d_temp_dV_S_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_GP_S = 2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_S-qC*(d_pC_dV_GP_S+(deriv_sqrt_0_d0*(d_temp_dV_GP_S))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_D_S = 2.0*(((pC+value_sqrt_0)*d_qC_dV_D_S-qC*(d_pC_dV_D_S+(deriv_sqrt_0_d0*(d_temp_dV_D_S))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}

d_x_d_dV_S_BP = (d_x_s_dV_S_BP+d_x_ds_dV_S_BP);
d_x_d_dV_GP_S = (d_x_s_dV_GP_S+d_x_ds_dV_GP_S);
d_x_d_dV_D_S = (d_x_s_dV_D_S+d_x_ds_dV_D_S);
x_d = (x_s+x_ds);
}

d_dps_dV_S_BP = d_x_ds_dV_S_BP*phit1;
d_dps_dV_GP_S = d_x_ds_dV_GP_S*phit1;
d_dps_dV_D_S = d_x_ds_dV_D_S*phit1;
dps = (x_ds*phit1);

d_xi0d_dV_S_BP = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_S_BP+d_x_d_dV_S_BP*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_S_BP+d_x_d_dV_S_BP*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_GP_S = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_GP_S+d_x_d_dV_GP_S*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_GP_S+d_x_d_dV_GP_S*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_D_S = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_D_S+d_x_d_dV_D_S*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_D_S+d_x_d_dV_D_S*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;

d_Ed_dV_S_BP = (deriv_exp_0_d0*((-d_x_d_dV_S_BP)));
d_Ed_dV_GP_S = (deriv_exp_0_d0*((-d_x_d_dV_GP_S)));
d_Ed_dV_D_S = (deriv_exp_0_d0*((-d_x_d_dV_D_S)));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{

d_Dd_dV_GP_S = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_GP_S+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_S+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_S+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_S+1.6666666666666667e-01*d_delta_nd_dV_GP_S*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_S_BP = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_S_BP+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_S_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_S_BP+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_S_BP+1.6666666666666667e-01*d_delta_nd_dV_S_BP*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_D_S = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_D_S+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_D_S+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_D_S+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_D_S+1.6666666666666667e-01*d_delta_nd_dV_D_S*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{

d_Dd_dV_GP_S = (delta_nd*(((-d_Ed_dV_GP_S/Ed/Ed)-d_x_d_dV_GP_S)-d_xi0d_dV_GP_S)+d_delta_nd_dV_GP_S*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_S_BP = (delta_nd*(((-d_Ed_dV_S_BP/Ed/Ed)-d_x_d_dV_S_BP)-d_xi0d_dV_S_BP)+d_delta_nd_dV_S_BP*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_D_S = (delta_nd*(((-d_Ed_dV_D_S/Ed/Ed)-d_x_d_dV_D_S)-d_xi0d_dV_D_S)+d_delta_nd_dV_D_S*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_BP = (deriv_exp_0_d0*((d_x_d_dV_S_BP-d_xn_d_dV_S_BP)));
d_temp_dV_GP_S = (deriv_exp_0_d0*((d_x_d_dV_GP_S-d_xn_d_dV_GP_S)));
d_temp_dV_D_S = (deriv_exp_0_d0*((d_x_d_dV_D_S-d_xn_d_dV_D_S)));
temp = value_exp_0;
}

d_Ed_dV_GP_S = ((temp*d_delta_nd_dV_GP_S-delta_nd*d_temp_dV_GP_S)/temp/temp);
d_Ed_dV_S_BP = ((temp*d_delta_nd_dV_S_BP-delta_nd*d_temp_dV_S_BP)/temp/temp);
d_Ed_dV_D_S = ((temp*d_delta_nd_dV_D_S-delta_nd*d_temp_dV_D_S)/temp/temp);
Ed = (delta_nd/temp);

d_Dd_dV_S_BP = (d_temp_dV_S_BP-(delta_nd*(d_x_d_dV_S_BP+d_xi0d_dV_S_BP)+d_delta_nd_dV_S_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_D_S = (d_temp_dV_D_S-(delta_nd*(d_x_d_dV_D_S+d_xi0d_dV_D_S)+d_delta_nd_dV_D_S*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_S = (d_temp_dV_GP_S-(delta_nd*(d_x_d_dV_GP_S+d_xi0d_dV_GP_S)+d_delta_nd_dV_GP_S*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{

d_Ed_dV_S_BP = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_S_BP*3.3333333333333333e-01+d_x_d_dV_S_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_S_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_GP_S = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_GP_S*3.3333333333333333e-01+d_x_d_dV_GP_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_GP_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_D_S = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_D_S*3.3333333333333333e-01+d_x_d_dV_D_S*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_D_S*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_temp_dV_GP_S = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*3.3333333333333333e-01+(d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_S-d_x_d_dV_GP_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_S_BP = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*3.3333333333333333e-01+(d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_S_BP-d_x_d_dV_S_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_D_S-d_x_d_dV_D_S)*3.3333333333333333e-01+(d_xn_d_dV_D_S-d_x_d_dV_D_S)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_D_S-d_x_d_dV_D_S)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Dd_dV_S_BP = (d_temp_dV_S_BP-(delta_nd*(d_x_d_dV_S_BP+d_xi0d_dV_S_BP)+d_delta_nd_dV_S_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_D_S = (d_temp_dV_D_S-(delta_nd*(d_x_d_dV_D_S+d_xi0d_dV_D_S)+d_delta_nd_dV_D_S*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_S = (d_temp_dV_GP_S-(delta_nd*(d_x_d_dV_GP_S+d_xi0d_dV_GP_S)+d_delta_nd_dV_GP_S*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}

d_x_m_dV_S_BP = 0.5*(d_x_s_dV_S_BP+d_x_d_dV_S_BP);
d_x_m_dV_GP_S = 0.5*(d_x_s_dV_GP_S+d_x_d_dV_GP_S);
d_x_m_dV_D_S = 0.5*(d_x_s_dV_D_S+d_x_d_dV_D_S);
x_m = (0.5*(x_s+x_d));

d_Em_dV_D_S = d_Em_dV_GP_S = d_Em_dV_S_BP =  0.0;
Em = 0.0;

d_temp_dV_S_BP = (Ed*d_Es_dV_S_BP+d_Ed_dV_S_BP*Es);
d_temp_dV_GP_S = (Ed*d_Es_dV_GP_S+d_Ed_dV_GP_S*Es);
d_temp_dV_D_S = (Ed*d_Es_dV_D_S+d_Ed_dV_D_S*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Em_dV_S_BP = (deriv_sqrt_0_d0*(d_temp_dV_S_BP));
d_Em_dV_D_S = (deriv_sqrt_0_d0*(d_temp_dV_D_S));
d_Em_dV_GP_S = (deriv_sqrt_0_d0*(d_temp_dV_GP_S));
Em = value_sqrt_0;
}
}

d_D_bar_dV_S_BP = 0.5*(d_Ds_dV_S_BP+d_Dd_dV_S_BP);
d_D_bar_dV_GP_S = 0.5*(d_Ds_dV_GP_S+d_Dd_dV_GP_S);
d_D_bar_dV_D_S = 0.5*(d_Ds_dV_D_S+d_Dd_dV_D_S);
D_bar = (0.5*(Ds+Dd));

d_Dm_dV_S_BP = (d_D_bar_dV_S_BP+0.125*((x_ds*x_ds)*(d_Em_dV_S_BP-2.0*d_inv_Gf2_dV_S_BP)+(x_ds*d_x_ds_dV_S_BP+d_x_ds_dV_S_BP*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_GP_S = (d_D_bar_dV_GP_S+0.125*((x_ds*x_ds)*(d_Em_dV_GP_S-2.0*d_inv_Gf2_dV_GP_S)+(x_ds*d_x_ds_dV_GP_S+d_x_ds_dV_GP_S*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_D_S = (d_D_bar_dV_D_S+0.125*((x_ds*x_ds)*(d_Em_dV_D_S-2.0*d_inv_Gf2_dV_D_S)+(x_ds*d_x_ds_dV_D_S+d_x_ds_dV_D_S*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{

d_Pm_dV_S_BP = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_S_BP)+d_x_m_dV_S_BP*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_S_BP+d_x_m_dV_S_BP*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_GP_S = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_S)+d_x_m_dV_GP_S*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_GP_S+d_x_m_dV_GP_S*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_D_S = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_D_S)+d_x_m_dV_D_S*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_D_S+d_x_m_dV_D_S*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_S_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP)))+d_Gf_dV_S_BP*value_sqrt_0);
d_xgm_dV_GP_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S)))+d_Gf_dV_GP_S*value_sqrt_0);
d_xgm_dV_D_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S)))+d_Gf_dV_D_S*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_S_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_S_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_S = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_S))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_D_S = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_D_S))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_S_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_S_BP)+d_x_m_dV_S_BP*(1.0-(0.25*x_m))))));
d_temp_dV_GP_S = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_S)+d_x_m_dV_GP_S*(1.0-(0.25*x_m))))));
d_temp_dV_D_S = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_D_S)+d_x_m_dV_D_S*(1.0-(0.25*x_m))))));
temp = value_sqrt_0;
}

d_sqm_dV_S_BP = 7.0710678118654746e-01*(x_m*d_temp_dV_S_BP+d_x_m_dV_S_BP*temp);
d_sqm_dV_GP_S = 7.0710678118654746e-01*(x_m*d_temp_dV_GP_S+d_x_m_dV_GP_S*temp);
d_sqm_dV_D_S = 7.0710678118654746e-01*(x_m*d_temp_dV_D_S+d_x_m_dV_D_S*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));

d_alpha_dV_S_BP = (d_eta_p_dV_S_BP+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_S_BP)+1.6666666666666667e-01*(x_m*d_x_m_dV_S_BP+d_x_m_dV_S_BP*x_m))+d_Gf_dV_S_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_S_BP)/temp/temp));
d_alpha_dV_GP_S = (d_eta_p_dV_GP_S+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_GP_S)+1.6666666666666667e-01*(x_m*d_x_m_dV_GP_S+d_x_m_dV_GP_S*x_m))+d_Gf_dV_GP_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_S)/temp/temp));
d_alpha_dV_D_S = (d_eta_p_dV_D_S+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_D_S)+1.6666666666666667e-01*(x_m*d_x_m_dV_D_S+d_x_m_dV_D_S*x_m))+d_Gf_dV_D_S*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_D_S)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{

d_Pm_dV_S_BP = (d_x_m_dV_S_BP+d_Em_dV_S_BP);
d_Pm_dV_GP_S = (d_x_m_dV_GP_S+d_Em_dV_GP_S);
d_Pm_dV_D_S = (d_x_m_dV_D_S+d_Em_dV_D_S);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_S_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP)))+d_Gf_dV_S_BP*value_sqrt_0);
d_xgm_dV_GP_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S)))+d_Gf_dV_GP_S*value_sqrt_0);
d_xgm_dV_D_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S)))+d_Gf_dV_D_S*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{

d_d0_dV_S_BP = ((-d_Em_dV_S_BP)+2.0*(xgm*d_inv_Gf2_dV_S_BP+d_xgm_dV_S_BP*inv_Gf2));
d_d0_dV_GP_S = ((-d_Em_dV_GP_S)+2.0*(xgm*d_inv_Gf2_dV_GP_S+d_xgm_dV_GP_S*inv_Gf2));
d_d0_dV_D_S = ((-d_Em_dV_D_S)+2.0*(xgm*d_inv_Gf2_dV_D_S+d_xgm_dV_D_S*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_S_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_S_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_S = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_S))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_D_S = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_D_S))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}

d_temp_dV_S_BP = (((eta_p+1.0)*d_eta_p_dV_S_BP-eta_p*d_eta_p_dV_S_BP)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_GP_S = (((eta_p+1.0)*d_eta_p_dV_GP_S-eta_p*d_eta_p_dV_GP_S)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_D_S = (((eta_p+1.0)*d_eta_p_dV_D_S-eta_p*d_eta_p_dV_D_S)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));

d_x_pm_dV_S_BP = kp*(((temp*temp)*Gf2)*d_Dm_dV_S_BP+((temp*temp)*d_Gf2_dV_S_BP+(temp*d_temp_dV_S_BP+d_temp_dV_S_BP*temp)*Gf2)*Dm);
d_x_pm_dV_D_S = kp*(((temp*temp)*Gf2)*d_Dm_dV_D_S+((temp*temp)*d_Gf2_dV_D_S+(temp*d_temp_dV_D_S+d_temp_dV_D_S*temp)*Gf2)*Dm);
d_x_pm_dV_GP_S = kp*(((temp*temp)*Gf2)*d_Dm_dV_GP_S+((temp*temp)*d_Gf2_dV_GP_S+(temp*d_temp_dV_GP_S+d_temp_dV_GP_S*temp)*Gf2)*Dm);
x_pm = (kp*(((temp*temp)*Gf2)*Dm));

d_p_pd_dV_S_BP = (2.0*(d_xgm_dV_S_BP-d_x_pm_dV_S_BP)+(Gf2*((-d_Em_dV_S_BP)+d_Dm_dV_S_BP)+d_Gf2_dV_S_BP*((1.0-Em)+Dm)));
d_p_pd_dV_GP_S = (2.0*(d_xgm_dV_GP_S-d_x_pm_dV_GP_S)+(Gf2*((-d_Em_dV_GP_S)+d_Dm_dV_GP_S)+d_Gf2_dV_GP_S*((1.0-Em)+Dm)));
d_p_pd_dV_D_S = (2.0*(d_xgm_dV_D_S-d_x_pm_dV_D_S)+(Gf2*((-d_Em_dV_D_S)+d_Dm_dV_D_S)+d_Gf2_dV_D_S*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

d_q_pd_dV_S_BP = (x_pm*(d_x_pm_dV_S_BP-2.0*d_xgm_dV_S_BP)+d_x_pm_dV_S_BP*(x_pm-(2.0*xgm)));
d_q_pd_dV_D_S = (x_pm*(d_x_pm_dV_D_S-2.0*d_xgm_dV_D_S)+d_x_pm_dV_D_S*(x_pm-(2.0*xgm)));
d_q_pd_dV_GP_S = (x_pm*(d_x_pm_dV_GP_S-2.0*d_xgm_dV_GP_S)+d_x_pm_dV_GP_S*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));

d_xi_pd_dV_S_BP = (-0.5*(Gf2*(d_Em_dV_S_BP+d_Dm_dV_S_BP)+d_Gf2_dV_S_BP*(Em+Dm)));
d_xi_pd_dV_GP_S = (-0.5*(Gf2*(d_Em_dV_GP_S+d_Dm_dV_GP_S)+d_Gf2_dV_GP_S*(Em+Dm)));
d_xi_pd_dV_D_S = (-0.5*(Gf2*(d_Em_dV_D_S+d_Dm_dV_D_S)+d_Gf2_dV_D_S*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

d_u_pd_dV_S_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_S_BP+d_q_pd_dV_S_BP*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_S_BP+d_p_pd_dV_S_BP*p_pd)-(xi_pd*d_q_pd_dV_S_BP+d_xi_pd_dV_S_BP*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_D_S = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_D_S+d_q_pd_dV_D_S*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_D_S+d_p_pd_dV_D_S*p_pd)-(xi_pd*d_q_pd_dV_D_S+d_xi_pd_dV_D_S*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_GP_S = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_GP_S+d_q_pd_dV_GP_S*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_GP_S+d_p_pd_dV_GP_S*p_pd)-(xi_pd*d_q_pd_dV_GP_S+d_xi_pd_dV_GP_S*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

d_x_m_dV_S_BP = (d_x_m_dV_S_BP+d_u_pd_dV_S_BP);
d_x_m_dV_GP_S = (d_x_m_dV_GP_S+d_u_pd_dV_GP_S);
d_x_m_dV_D_S = (d_x_m_dV_D_S+d_u_pd_dV_D_S);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;

d_km_dV_S_BP = (deriv_exp_0_d0*(d_u_pd_dV_S_BP));
d_km_dV_D_S = (deriv_exp_0_d0*(d_u_pd_dV_D_S));
d_km_dV_GP_S = (deriv_exp_0_d0*(d_u_pd_dV_GP_S));
km = value_exp_0;
}

d_Em_dV_S_BP = ((km*d_Em_dV_S_BP-Em*d_km_dV_S_BP)/km/km);
d_Em_dV_GP_S = ((km*d_Em_dV_GP_S-Em*d_km_dV_GP_S)/km/km);
d_Em_dV_D_S = ((km*d_Em_dV_D_S-Em*d_km_dV_D_S)/km/km);
Em = (Em/km);

d_Dm_dV_S_BP = (Dm*d_km_dV_S_BP+d_Dm_dV_S_BP*km);
d_Dm_dV_GP_S = (Dm*d_km_dV_GP_S+d_Dm_dV_GP_S*km);
d_Dm_dV_D_S = (Dm*d_km_dV_D_S+d_Dm_dV_D_S*km);
Dm = (Dm*km);

d_Pm_dV_S_BP = (d_x_m_dV_S_BP+d_Em_dV_S_BP);
d_Pm_dV_GP_S = (d_x_m_dV_GP_S+d_Em_dV_GP_S);
d_Pm_dV_D_S = (d_x_m_dV_D_S+d_Em_dV_D_S);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_S_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_S_BP+d_Pm_dV_S_BP)))+d_Gf_dV_S_BP*value_sqrt_0);
d_xgm_dV_GP_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_S+d_Pm_dV_GP_S)))+d_Gf_dV_GP_S*value_sqrt_0);
d_xgm_dV_D_S = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_D_S+d_Pm_dV_D_S)))+d_Gf_dV_D_S*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}

d_help_dV_S_BP = ((-d_Em_dV_S_BP)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_S_BP+(xgm*d_eta_p_dV_S_BP+d_xgm_dV_S_BP*eta_p)*inv_Gf2));
d_help_dV_GP_S = ((-d_Em_dV_GP_S)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_GP_S+(xgm*d_eta_p_dV_GP_S+d_xgm_dV_GP_S*eta_p)*inv_Gf2));
d_help_dV_D_S = ((-d_Em_dV_D_S)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_D_S+(xgm*d_eta_p_dV_D_S+d_xgm_dV_D_S*eta_p)*inv_Gf2));
help = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

d_x_ds_dV_S_BP = (((help+(km*D_bar))*((x_ds*km)*(d_d0_dV_S_BP+d_D_bar_dV_S_BP)+(x_ds*d_km_dV_S_BP+d_x_ds_dV_S_BP*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_help_dV_S_BP+(km*d_D_bar_dV_S_BP+d_km_dV_S_BP*D_bar)))/(help+(km*D_bar))/(help+(km*D_bar)));
d_x_ds_dV_GP_S = (((help+(km*D_bar))*((x_ds*km)*(d_d0_dV_GP_S+d_D_bar_dV_GP_S)+(x_ds*d_km_dV_GP_S+d_x_ds_dV_GP_S*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_help_dV_GP_S+(km*d_D_bar_dV_GP_S+d_km_dV_GP_S*D_bar)))/(help+(km*D_bar))/(help+(km*D_bar)));
d_x_ds_dV_D_S = (((help+(km*D_bar))*((x_ds*km)*(d_d0_dV_D_S+d_D_bar_dV_D_S)+(x_ds*d_km_dV_D_S+d_x_ds_dV_D_S*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_help_dV_D_S+(km*d_D_bar_dV_D_S+d_km_dV_D_S*D_bar)))/(help+(km*D_bar))/(help+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(help+(km*D_bar)));

d_dps_dV_S_BP = d_x_ds_dV_S_BP*phit1;
d_dps_dV_GP_S = d_x_ds_dV_GP_S*phit1;
d_dps_dV_D_S = d_x_ds_dV_D_S*phit1;
dps = (x_ds*phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_S_BP = (deriv_sqrt_0_d0*(d_Pm_dV_S_BP));
d_sqm_dV_GP_S = (deriv_sqrt_0_d0*(d_Pm_dV_GP_S));
d_sqm_dV_D_S = (deriv_sqrt_0_d0*(d_Pm_dV_D_S));
sqm = value_sqrt_0;
}

d_alpha_dV_S_BP = (d_eta_p_dV_S_BP+0.5*((sqm*(Gf*(-d_Em_dV_S_BP)+d_Gf_dV_S_BP*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_S_BP)/sqm/sqm));
d_alpha_dV_GP_S = (d_eta_p_dV_GP_S+0.5*((sqm*(Gf*(-d_Em_dV_GP_S)+d_Gf_dV_GP_S*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_GP_S)/sqm/sqm));
d_alpha_dV_D_S = (d_eta_p_dV_D_S+0.5*((sqm*(Gf*(-d_Em_dV_D_S)+d_Gf_dV_D_S*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_D_S)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}

d_qim_dV_S_BP = phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_S_BP+d_Gf2_dV_S_BP*Dm)-(Gf2*Dm)*(d_xgm_dV_S_BP+(Gf*d_sqm_dV_S_BP+d_Gf_dV_S_BP*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)));
d_qim_dV_GP_S = phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_GP_S+d_Gf2_dV_GP_S*Dm)-(Gf2*Dm)*(d_xgm_dV_GP_S+(Gf*d_sqm_dV_GP_S+d_Gf_dV_GP_S*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)));
d_qim_dV_D_S = phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_D_S+d_Gf2_dV_D_S*Dm)-(Gf2*Dm)*(d_xgm_dV_D_S+(Gf*d_sqm_dV_D_S+d_Gf_dV_D_S*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)));
qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

d_qim1_dV_S_BP = (d_qim_dV_S_BP+phit1*d_alpha_dV_S_BP);
d_qim1_dV_GP_S = (d_qim_dV_GP_S+phit1*d_alpha_dV_GP_S);
d_qim1_dV_D_S = (d_qim_dV_D_S+phit1*d_alpha_dV_D_S);
qim1 = (qim+(phit1*alpha));

d_qim1_1_dV_S_BP = (-d_qim1_dV_S_BP/qim1/qim1);
d_qim1_1_dV_GP_S = (-d_qim1_dV_GP_S/qim1/qim1);
d_qim1_1_dV_D_S = (-d_qim1_dV_D_S/qim1/qim1);
qim1_1 = (1.0/qim1);

d_qbm_dV_S_BP = (sqm*d_Gf_dV_S_BP+d_sqm_dV_S_BP*Gf)*phit1;
d_qbm_dV_GP_S = (sqm*d_Gf_dV_GP_S+d_sqm_dV_GP_S*Gf)*phit1;
d_qbm_dV_D_S = (sqm*d_Gf_dV_D_S+d_sqm_dV_D_S*Gf)*phit1;
qbm = ((sqm*Gf)*phit1);
if ((RSG_i<0))
{

d_temp_dV_S_BP = (-RSG_i*d_qim_dV_S_BP);
d_temp_dV_GP_S = (-RSG_i*d_qim_dV_GP_S);
d_temp_dV_D_S = (-RSG_i*d_qim_dV_D_S);
temp = (1.0-(RSG_i*qim));
}
else
{

d_temp_dV_S_BP = (-RSG_i*d_qim_dV_S_BP/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_GP_S = (-RSG_i*d_qim_dV_GP_S/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_D_S = (-RSG_i*d_qim_dV_D_S/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
temp = (1.0/(1.0+(RSG_i*qim)));
}

d_GR_dV_GP_S = THER_i*((rhob*temp)*d_qim_dV_GP_S+rhob*d_temp_dV_GP_S*qim);
d_GR_dV_S_BP = THER_i*((rhob*temp)*d_qim_dV_S_BP+(rhob*d_temp_dV_S_BP+d_rhob_dV_S_BP*temp)*qim);
d_GR_dV_D_S = THER_i*((rhob*temp)*d_qim_dV_D_S+(rhob*d_temp_dV_D_S+d_rhob_dV_D_S*temp)*qim);
GR = (THER_i*((rhob*temp)*qim));

d_qeff_dV_S_BP = (d_qbm_dV_S_BP+eta_mu*d_qim_dV_S_BP);
d_qeff_dV_GP_S = (d_qbm_dV_GP_S+eta_mu*d_qim_dV_GP_S);
d_qeff_dV_D_S = (d_qbm_dV_D_S+eta_mu*d_qim_dV_D_S);
qeff = (qbm+(eta_mu*qim));

d_Eeffm_dV_S_BP = E_eff0*d_qeff_dV_S_BP;
d_Eeffm_dV_GP_S = E_eff0*d_qeff_dV_GP_S;
d_Eeffm_dV_D_S = E_eff0*d_qeff_dV_D_S;
Eeffm = (E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*MUE_i),THEMU_i);
double  deriv_pow_0_d0 = (((Eeffm*MUE_i) == 0.0)?0.0:(value_pow_0*THEMU_i/(Eeffm*MUE_i)));

d_Mutmp_dV_S_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_S_BP*MUE_i))+CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_S_BP-Pm*(d_Pm_dV_S_BP+d_Dm_dV_S_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_GP_S = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_S*MUE_i))+CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_S-Pm*(d_Pm_dV_GP_S+d_Dm_dV_GP_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_D_S = ((deriv_pow_0_d0*(d_Eeffm_dV_D_S*MUE_i))+CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dV_D_S-Pm*(d_Pm_dV_D_S+d_Dm_dV_D_S))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
Mutmp = (value_pow_0+(CS_i*(Pm/((Pm+Dm)+1.0e-14))));
}

d_Gmob_dV_S_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_S_BP+(d_Mutmp_dV_S_BP+d_GR_dV_S_BP)*Rxcor);
d_Gmob_dV_GP_S = (d_Mutmp_dV_GP_S+d_GR_dV_GP_S)*Rxcor;
d_Gmob_dV_D_S = (((1.0+Mutmp)+GR)*d_Rxcor_dV_D_S+(d_Mutmp_dV_D_S+d_GR_dV_D_S)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);

d_r1_dV_S_BP = (qim*d_qim1_1_dV_S_BP+d_qim_dV_S_BP*qim1_1);
d_r1_dV_GP_S = (qim*d_qim1_1_dV_GP_S+d_qim_dV_GP_S*qim1_1);
d_r1_dV_D_S = (qim*d_qim1_1_dV_D_S+d_qim_dV_D_S*qim1_1);
r1 = (qim*qim1_1);

d_r2_dV_S_BP = phit1*(alpha*d_qim1_1_dV_S_BP+d_alpha_dV_S_BP*qim1_1);
d_r2_dV_GP_S = phit1*(alpha*d_qim1_1_dV_GP_S+d_alpha_dV_GP_S*qim1_1);
d_r2_dV_D_S = phit1*(alpha*d_qim1_1_dV_D_S+d_alpha_dV_D_S*qim1_1);
r2 = (phit1*(alpha*qim1_1));
{
double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

d_temp_dV_S_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_S_BP)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_S_BP-d_dps_dV_S_BP)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_temp_dV_GP_S = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_GP_S)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_GP_S-d_dps_dV_GP_S)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_temp_dV_D_S = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(d_Vds_dV_D_S-d_dps_dV_D_S)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_D_S-d_dps_dV_D_S)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
temp = value_log_0;
}
{
double value_log_0 = log((1.0+(Vdsx*inv_VP)));
double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*inv_VP)));

d_temp1_dV_GP_S = d_temp1_dV_S_BP =  0.0;
d_temp1_dV_D_S = (deriv_log_0_d0*(d_Vdsx_dV_D_S*inv_VP));
temp1 = value_log_0;
}

d_dL_dV_S_BP = ALP_i*d_temp_dV_S_BP;
d_dL_dV_D_S = ALP_i*d_temp_dV_D_S;
d_dL_dV_GP_S = ALP_i*d_temp_dV_GP_S;
dL = (ALP_i*temp);

d_GdL_dV_S_BP = (-(d_dL_dV_S_BP+(dL*d_dL_dV_S_BP+d_dL_dV_S_BP*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_D_S = (-(d_dL_dV_D_S+(dL*d_dL_dV_D_S+d_dL_dV_D_S*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_GP_S = (-(d_dL_dV_GP_S+(dL*d_dL_dV_GP_S+d_dL_dV_GP_S*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));

d_dL1_dV_S_BP = ((d_dL_dV_S_BP+ALP1_i*((qim1_1*r1)*d_temp_dV_S_BP+(qim1_1*d_r1_dV_S_BP+d_qim1_1_dV_S_BP*r1)*temp))+ALP2_i*(((qbm*r2)*r2)*d_temp1_dV_S_BP+((qbm*r2)*d_r2_dV_S_BP+(qbm*d_r2_dV_S_BP+d_qbm_dV_S_BP*r2)*r2)*temp1));
d_dL1_dV_D_S = ((d_dL_dV_D_S+ALP1_i*((qim1_1*r1)*d_temp_dV_D_S+(qim1_1*d_r1_dV_D_S+d_qim1_1_dV_D_S*r1)*temp))+ALP2_i*(((qbm*r2)*r2)*d_temp1_dV_D_S+((qbm*r2)*d_r2_dV_D_S+(qbm*d_r2_dV_D_S+d_qbm_dV_D_S*r2)*r2)*temp1));
d_dL1_dV_GP_S = ((d_dL_dV_GP_S+ALP1_i*((qim1_1*r1)*d_temp_dV_GP_S+(qim1_1*d_r1_dV_GP_S+d_qim1_1_dV_GP_S*r1)*temp))+ALP2_i*(((qbm*r2)*r2)*d_temp1_dV_GP_S+((qbm*r2)*d_r2_dV_GP_S+(qbm*d_r2_dV_GP_S+d_qbm_dV_GP_S*r2)*r2)*temp1));
dL1 = ((dL+(ALP1_i*((qim1_1*r1)*temp)))+(ALP2_i*(((qbm*r2)*r2)*temp1)));

d_FdL_dV_S_BP = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_S_BP+(d_dL1_dV_S_BP+(dL1*d_dL1_dV_S_BP+d_dL1_dV_S_BP*dL1))*GdL);
d_FdL_dV_D_S = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_D_S+(d_dL1_dV_D_S+(dL1*d_dL1_dV_D_S+d_dL1_dV_D_S*dL1))*GdL);
d_FdL_dV_GP_S = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_GP_S+(d_dL1_dV_GP_S+(dL1*d_dL1_dV_GP_S+d_dL1_dV_GP_S*dL1))*GdL);
FdL = (((1.0+dL1)+(dL1*dL1))*GdL);

d_temp2_dV_S_BP = (qim*d_xitsb_dV_S_BP+d_qim_dV_S_BP*xitsb);
d_temp2_dV_GP_S = d_qim_dV_GP_S*xitsb;
d_temp2_dV_D_S = (qim*d_xitsb_dV_D_S+d_qim_dV_D_S*xitsb);
temp2 = (qim*xitsb);

d_wsat_dV_S_BP = 100.0*(((100.0+temp2)*d_temp2_dV_S_BP-temp2*d_temp2_dV_S_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_S = 100.0*(((100.0+temp2)*d_temp2_dV_GP_S-temp2*d_temp2_dV_GP_S)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_D_S = 100.0*(((100.0+temp2)*d_temp2_dV_D_S-temp2*d_temp2_dV_D_S)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));

d_Gmob_dL_dV_S_BP = (Gmob*d_GdL_dV_S_BP+d_Gmob_dV_S_BP*GdL);
d_Gmob_dL_dV_GP_S = (Gmob*d_GdL_dV_GP_S+d_Gmob_dV_GP_S*GdL);
d_Gmob_dL_dV_D_S = (Gmob*d_GdL_dV_D_S+d_Gmob_dV_D_S*GdL);
Gmob_dL = (Gmob*GdL);
if ((THESATG_i<0))
{

d_temp_dV_S_BP = (-1*(-THESATG_i*d_wsat_dV_S_BP)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
d_temp_dV_GP_S = (-1*(-THESATG_i*d_wsat_dV_GP_S)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
d_temp_dV_D_S = (-1*(-THESATG_i*d_wsat_dV_D_S)/(1-(THESATG_i*wsat))/(1-(THESATG_i*wsat)));
temp = (1/(1-(THESATG_i*wsat)));
}
else
{

d_temp_dV_S_BP = THESATG_i*d_wsat_dV_S_BP;
d_temp_dV_GP_S = THESATG_i*d_wsat_dV_GP_S;
d_temp_dV_D_S = THESATG_i*d_wsat_dV_D_S;
temp = (1+(THESATG_i*wsat));
}

d_thesat1_dV_S_BP = THESAT_i*((Gmob_dL*d_temp_dV_S_BP-temp*d_Gmob_dL_dV_S_BP)/Gmob_dL/Gmob_dL);
d_thesat1_dV_D_S = THESAT_i*((Gmob_dL*d_temp_dV_D_S-temp*d_Gmob_dL_dV_D_S)/Gmob_dL/Gmob_dL);
d_thesat1_dV_GP_S = THESAT_i*((Gmob_dL*d_temp_dV_GP_S-temp*d_Gmob_dL_dV_GP_S)/Gmob_dL/Gmob_dL);
thesat1 = (THESAT_i*(temp/Gmob_dL));

d_zsat_dV_S_BP = (((thesat1*thesat1)*dps)*d_dps_dV_S_BP+((thesat1*thesat1)*d_dps_dV_S_BP+(thesat1*d_thesat1_dV_S_BP+d_thesat1_dV_S_BP*thesat1)*dps)*dps);
d_zsat_dV_D_S = (((thesat1*thesat1)*dps)*d_dps_dV_D_S+((thesat1*thesat1)*d_dps_dV_D_S+(thesat1*d_thesat1_dV_D_S+d_thesat1_dV_D_S*thesat1)*dps)*dps);
d_zsat_dV_GP_S = (((thesat1*thesat1)*dps)*d_dps_dV_GP_S+((thesat1*thesat1)*d_dps_dV_GP_S+(thesat1*d_thesat1_dV_GP_S+d_thesat1_dV_GP_S*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if (((model_.CHNL_TYPE)==(-1)))
{

d_zsat_dV_S_BP = (((1.0+(thesat1*dps))*d_zsat_dV_S_BP-zsat*(thesat1*d_dps_dV_S_BP+d_thesat1_dV_S_BP*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_D_S = (((1.0+(thesat1*dps))*d_zsat_dV_D_S-zsat*(thesat1*d_dps_dV_D_S+d_thesat1_dV_D_S*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_GP_S = (((1.0+(thesat1*dps))*d_zsat_dV_GP_S-zsat*(thesat1*d_dps_dV_GP_S+d_thesat1_dV_GP_S*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gvsat_dV_S_BP = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_S_BP))+d_Gmob_dL_dV_S_BP*(1.0+value_sqrt_0));
d_Gvsat_dV_GP_S = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_GP_S))+d_Gmob_dL_dV_GP_S*(1.0+value_sqrt_0));
d_Gvsat_dV_D_S = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_D_S))+d_Gmob_dL_dV_D_S*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}

d_Gvsatinv_dV_S_BP = (-d_Gvsat_dV_S_BP/Gvsat/Gvsat);
d_Gvsatinv_dV_GP_S = (-d_Gvsat_dV_GP_S/Gvsat/Gvsat);
d_Gvsatinv_dV_D_S = (-d_Gvsat_dV_D_S/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);

d_Ids_dV_S_BP = BET_i*(((FdL*qim1)*dps)*d_Gvsatinv_dV_S_BP+((FdL*qim1)*d_dps_dV_S_BP+(FdL*d_qim1_dV_S_BP+d_FdL_dV_S_BP*qim1)*dps)*Gvsatinv);
d_Ids_dV_D_S = BET_i*(((FdL*qim1)*dps)*d_Gvsatinv_dV_D_S+((FdL*qim1)*d_dps_dV_D_S+(FdL*d_qim1_dV_D_S+d_FdL_dV_D_S*qim1)*dps)*Gvsatinv);
d_Ids_dV_GP_S = BET_i*(((FdL*qim1)*dps)*d_Gvsatinv_dV_GP_S+((FdL*qim1)*d_dps_dV_GP_S+(FdL*d_qim1_dV_GP_S+d_FdL_dV_GP_S*qim1)*dps)*Gvsatinv);
Ids = (BET_i*(((FdL*qim1)*dps)*Gvsatinv));

d_Voxm_dV_S_BP = d_xgm_dV_S_BP*phit1;
d_Voxm_dV_GP_S = d_xgm_dV_GP_S*phit1;
d_Voxm_dV_D_S = d_xgm_dV_D_S*phit1;
Voxm = (xgm*phit1);

d_temp_dV_S_BP = (Gmob_dL*d_Gvsatinv_dV_S_BP+d_Gmob_dL_dV_S_BP*Gvsatinv);
d_temp_dV_GP_S = (Gmob_dL*d_Gvsatinv_dV_GP_S+d_Gmob_dL_dV_GP_S*Gvsatinv);
d_temp_dV_D_S = (Gmob_dL*d_Gvsatinv_dV_D_S+d_Gmob_dL_dV_D_S*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);

d_alpha1_dV_S_BP = (alpha*0.5*((zsat*temp)*d_temp_dV_S_BP+(zsat*d_temp_dV_S_BP+d_zsat_dV_S_BP*temp)*temp)+d_alpha_dV_S_BP*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_GP_S = (alpha*0.5*((zsat*temp)*d_temp_dV_GP_S+(zsat*d_temp_dV_GP_S+d_zsat_dV_GP_S*temp)*temp)+d_alpha_dV_GP_S*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_D_S = (alpha*0.5*((zsat*temp)*d_temp_dV_D_S+(zsat*d_temp_dV_D_S+d_zsat_dV_D_S*temp)*temp)+d_alpha_dV_D_S*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

d_H_dV_S_BP = ((alpha1*(temp*d_qim1_dV_S_BP+d_temp_dV_S_BP*qim1)-(temp*qim1)*d_alpha1_dV_S_BP)/alpha1/alpha1);
d_H_dV_D_S = ((alpha1*(temp*d_qim1_dV_D_S+d_temp_dV_D_S*qim1)-(temp*qim1)*d_alpha1_dV_D_S)/alpha1/alpha1);
d_H_dV_GP_S = ((alpha1*(temp*d_qim1_dV_GP_S+d_temp_dV_GP_S*qim1)-(temp*qim1)*d_alpha1_dV_GP_S)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
if (((model_.SWIMPACT)!=0))
{

d_delVsat_dV_S_BP = (-A3_i*d_dps_dV_S_BP);
d_delVsat_dV_GP_S = (-A3_i*d_dps_dV_GP_S);
d_delVsat_dV_D_S = (d_Vds_dV_D_S-A3_i*d_dps_dV_D_S);
delVsat = (Vds-(A3_i*dps));
if ((delVsat>0))
{
{
double value_sqrt_0 = sqrt((phib+Vsbstar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp2_dV_GP_S = A2_i*(-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_GP_S/(delVsat+1e-30)/(delVsat+1e-30));
d_temp2_dV_S_BP = A2_i*(((delVsat+1e-30)*A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dV_S_BP))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_S_BP)/(delVsat+1e-30)/(delVsat+1e-30));
d_temp2_dV_D_S = A2_i*(((delVsat+1e-30)*A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dV_D_S))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib)))*d_delVsat_dV_D_S)/(delVsat+1e-30)/(delVsat+1e-30));
temp2 = (A2_i*((1.0+(A4_i*(value_sqrt_0-sqrt_phib)))/(delVsat+1e-30)));
}
if ((fabs((-temp2))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-temp2));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_BP = (deriv_exp_0_d0*((-d_temp2_dV_S_BP)));
d_temp_dV_GP_S = (deriv_exp_0_d0*((-d_temp2_dV_GP_S)));
d_temp_dV_D_S = (deriv_exp_0_d0*((-d_temp2_dV_D_S)));
temp = value_exp_0;
}
}
else
{
if (((-temp2)<(-2.3025850929940458e+02)))
{

d_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_S_BP))*3.3333333333333333e-01+(-(-d_temp2_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
d_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_GP_S))*3.3333333333333333e-01+(-(-d_temp2_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_D_S))*3.3333333333333333e-01+(-(-d_temp2_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_S_BP = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_S_BP)*3.3333333333333333e-01+(-d_temp2_dV_S_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_S_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_GP_S = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_GP_S)*3.3333333333333333e-01+(-d_temp2_dV_GP_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_GP_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_D_S = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_D_S)*3.3333333333333333e-01+(-d_temp2_dV_D_S)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_D_S)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_mavl_dV_S_BP = A1_i*(delVsat*d_temp_dV_S_BP+d_delVsat_dV_S_BP*temp);
d_mavl_dV_GP_S = A1_i*(delVsat*d_temp_dV_GP_S+d_delVsat_dV_GP_S*temp);
d_mavl_dV_D_S = A1_i*(delVsat*d_temp_dV_D_S+d_delVsat_dV_D_S*temp);
mavl = (A1_i*(delVsat*temp));

d_Iimpact_dV_S_BP = (Ids*d_mavl_dV_S_BP+d_Ids_dV_S_BP*mavl);
d_Iimpact_dV_D_S = (Ids*d_mavl_dV_D_S+d_Ids_dV_D_S*mavl);
d_Iimpact_dV_GP_S = (Ids*d_mavl_dV_GP_S+d_Ids_dV_GP_S*mavl);
Iimpact = (Ids*mavl);
}
}
}
if (((((((model_.SWIGATE)!=0)&&((IGOV_i>0)||(IGOVD_i>0)))||(((model_.SWGIDL)!=0)&&((AGIDL_i>0)||(AGIDLD_i>0))))||(CGOV_i>0))||(CGOVD_i>0)))
{
GOV = GOV_s;
GOV2 = GOV2_s;
xi_ov = xi_ov_s;
inv_xi_ov = inv_xi_ov_s;
x_mrg_ov = x_mrg_ov_s;
inv_xg1 = inv_xg1_s;
if ((fabs(xgs_ov)<=x_mrg_ov))
{

d_xs_ov_dV_D_S = d_xs_ov_dV_S_BP =  0.0;
d_xs_ov_dV_GP_S = (-d_xgs_ov_dV_GP_S)*inv_xi_ov;
xs_ov = ((-xgs_ov)*inv_xi_ov);
}
else
{
if ((xgs_ov<(-x_mrg_ov)))
{

d_SP_OV_yg_dV_D_S =  0.0;
d_SP_OV_yg_dV_GP_S = (-d_xgs_ov_dV_GP_S);
SP_OV_yg = (-xgs_ov);

d_SP_OV_z_dV_D_S =  0.0;
d_SP_OV_z_dV_GP_S = x1*d_SP_OV_yg_dV_GP_S*inv_xi_ov;
SP_OV_z = ((x1*SP_OV_yg)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dV_D_S =  0.0;
d_SP_OV_eta_dV_GP_S = 0.5*(d_SP_OV_z_dV_GP_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_GP_S+d_SP_OV_z_dV_GP_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dV_D_S =  0.0;
d_SP_OV_a_dV_GP_S = (((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)+(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)*(SP_OV_yg-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_GP_S);
SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dV_D_S =  0.0;
d_SP_OV_c_dV_GP_S = 2.0*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S);
SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dV_D_S =  0.0;
d_SP_OV_tau_dV_GP_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_GP_S/GOV2)))-d_SP_OV_eta_dV_GP_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_nu_dV_D_S = d_nu_dV_S_BP =  0.0;
d_nu_dV_GP_S = (d_SP_OV_a_dV_GP_S+d_SP_OV_c_dV_GP_S);
nu = (SP_OV_a+SP_OV_c);

d_mutau_dV_S_BP = (nu*d_nu_dV_S_BP+d_nu_dV_S_BP*nu);
d_mutau_dV_GP_S = ((nu*d_nu_dV_GP_S+d_nu_dV_GP_S*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dV_GP_S+d_SP_OV_c_dV_GP_S*SP_OV_c)-d_SP_OV_a_dV_GP_S)+d_SP_OV_tau_dV_GP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)-d_SP_OV_a_dV_D_S)+d_SP_OV_tau_dV_D_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));

d_SP_OV_y0_dV_S_BP = (((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*SP_OV_a*d_nu_dV_S_BP*SP_OV_tau-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_S_BP+((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dV_D_S+(SP_OV_a*d_nu_dV_D_S+d_SP_OV_a_dV_D_S*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dV_D_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S+((nu/mutau)*d_SP_OV_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
d_SP_OV_y0_dV_GP_S = (d_SP_OV_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dV_GP_S+(SP_OV_a*d_nu_dV_GP_S+d_SP_OV_a_dV_GP_S*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_GP_S+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_GP_S+d_SP_OV_c_dV_GP_S*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dV_GP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_GP_S+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_GP_S+((nu/mutau)*d_SP_OV_tau_dV_GP_S+((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*(d_SP_OV_y0_dV_S_BP));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_GP_S));
SP_OV_D0 = value_exp_0;
}

d_SP_OV_temp_dV_S_BP = (-d_SP_OV_y0_dV_S_BP);
d_SP_OV_temp_dV_D_S = (d_SP_OV_yg_dV_D_S-d_SP_OV_y0_dV_D_S);
d_SP_OV_temp_dV_GP_S = (d_SP_OV_yg_dV_GP_S-d_SP_OV_y0_dV_GP_S);
SP_OV_temp = (SP_OV_yg-SP_OV_y0);

d_SP_OV_p_dV_S_BP = (2.0*d_SP_OV_temp_dV_S_BP+GOV2*d_SP_OV_D0_dV_S_BP);
d_SP_OV_p_dV_D_S = (2.0*d_SP_OV_temp_dV_D_S+GOV2*d_SP_OV_D0_dV_D_S);
d_SP_OV_p_dV_GP_S = (2.0*d_SP_OV_temp_dV_GP_S+GOV2*d_SP_OV_D0_dV_GP_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dV_S_BP = ((SP_OV_temp*d_SP_OV_temp_dV_S_BP+d_SP_OV_temp_dV_S_BP*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_S_BP-d_SP_OV_D0_dV_S_BP));
d_SP_OV_q_dV_D_S = ((SP_OV_temp*d_SP_OV_temp_dV_D_S+d_SP_OV_temp_dV_D_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_GP_S = ((SP_OV_temp*d_SP_OV_temp_dV_GP_S+d_SP_OV_temp_dV_GP_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_GP_S-d_SP_OV_D0_dV_GP_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_S_BP = (-(GOV2*0.5)*d_SP_OV_D0_dV_S_BP);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dV_GP_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_GP_S);
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_S_BP = ((SP_OV_p*d_SP_OV_p_dV_S_BP+d_SP_OV_p_dV_S_BP*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_S_BP+d_SP_OV_xi_dV_S_BP*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
d_SP_OV_temp_dV_GP_S = ((SP_OV_p*d_SP_OV_p_dV_GP_S+d_SP_OV_p_dV_GP_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_GP_S+d_SP_OV_xi_dV_GP_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dV_S_BP = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_D_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_GP_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}

d_xs_ov_dV_S_BP = (-(d_SP_OV_y0_dV_S_BP+d_SP_OV_w_dV_S_BP));
d_xs_ov_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
d_xs_ov_dV_GP_S = (-(d_SP_OV_y0_dV_GP_S+d_SP_OV_w_dV_GP_S));
xs_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
SP_OV_Afac = ((((xi_ov*x1)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dV_D_S =  0.0;
d_SP_OV_xbar_dV_GP_S = ((xgs_ov*inv_xi_ov)*SP_OV_Afac*d_xgs_ov_dV_GP_S+d_xgs_ov_dV_GP_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgs_ov)));
SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dV_D_S = d_SP_OV_temp_dV_S_BP =  0.0;
d_SP_OV_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_GP_S)));
SP_OV_temp = value_exp_0;
}
}
else
{

d_SP_OV_temp_dV_D_S = d_SP_OV_temp_dV_S_BP =  0.0;
d_SP_OV_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-d_SP_OV_xbar_dV_GP_S))*3.3333333333333333e-01+(-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
}

d_SP_OV_w_dV_S_BP = (-d_SP_OV_temp_dV_S_BP);
d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
d_SP_OV_w_dV_GP_S = (-d_SP_OV_temp_dV_GP_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dV_S_BP = (-GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_S_BP))));
d_SP_OV_x0_dV_D_S = (-GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_D_S))));
d_SP_OV_x0_dV_GP_S = (d_xgs_ov_dV_GP_S-GOV*(deriv_sqrt_0_d0*((d_xgs_ov_dV_GP_S-d_SP_OV_w_dV_GP_S))));
SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_S_BP)));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_GP_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{

d_SP_OV_D0_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_S_BP))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
d_SP_OV_D0_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_D_S))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
d_SP_OV_D0_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_GP_S))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
}

d_SP_OV_p_dV_S_BP = (2.0*(-d_SP_OV_x0_dV_S_BP)+GOV2*(-d_SP_OV_D0_dV_S_BP));
d_SP_OV_p_dV_D_S = (2.0*(-d_SP_OV_x0_dV_D_S)+GOV2*(-d_SP_OV_D0_dV_D_S));
d_SP_OV_p_dV_GP_S = (2.0*(d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)+GOV2*(-d_SP_OV_D0_dV_GP_S));
SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dV_S_BP = (((xgs_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_S_BP)+(-d_SP_OV_x0_dV_S_BP)*(xgs_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_S_BP+d_SP_OV_D0_dV_S_BP));
d_SP_OV_q_dV_D_S = (((xgs_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_D_S)+(-d_SP_OV_x0_dV_D_S)*(xgs_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_GP_S = (((xgs_ov-SP_OV_x0)*(d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)+(d_xgs_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)*(xgs_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_GP_S+d_SP_OV_D0_dV_GP_S));
SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_S_BP = (-(GOV2*0.5)*d_SP_OV_D0_dV_S_BP);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dV_GP_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_GP_S);
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_S_BP = ((SP_OV_p*d_SP_OV_p_dV_S_BP+d_SP_OV_p_dV_S_BP*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_S_BP+d_SP_OV_xi_dV_S_BP*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
d_SP_OV_temp_dV_GP_S = ((SP_OV_p*d_SP_OV_p_dV_GP_S+d_SP_OV_p_dV_GP_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_GP_S+d_SP_OV_xi_dV_GP_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dV_S_BP = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_D_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_GP_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}

d_xs_ov_dV_S_BP = (d_SP_OV_x0_dV_S_BP+d_SP_OV_u_dV_S_BP);
d_xs_ov_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
d_xs_ov_dV_GP_S = (d_SP_OV_x0_dV_GP_S+d_SP_OV_u_dV_GP_S);
xs_ov = (SP_OV_x0+SP_OV_u);
}

d_xs_ov_dV_GP_S = (-d_xs_ov_dV_GP_S);
d_xs_ov_dV_S_BP = (-d_xs_ov_dV_S_BP);
d_xs_ov_dV_D_S = (-d_xs_ov_dV_D_S);
xs_ov = (-xs_ov);
}
GOV = GOV_d;
GOV2 = GOV2_d;
xi_ov = xi_ov_d;
inv_xi_ov = inv_xi_ov_d;
x_mrg_ov = x_mrg_ov_d;
inv_xg1 = inv_xg1_d;
if ((fabs(xgd_ov)<=x_mrg_ov))
{

d_xd_ov_dV_S_BP =  0.0;
d_xd_ov_dV_D_S = (-d_xgd_ov_dV_D_S)*inv_xi_ov;
d_xd_ov_dV_GP_S = (-d_xgd_ov_dV_GP_S)*inv_xi_ov;
xd_ov = ((-xgd_ov)*inv_xi_ov);
}
else
{
if ((xgd_ov<(-x_mrg_ov)))
{

d_SP_OV_yg_dV_D_S = (-d_xgd_ov_dV_D_S);
d_SP_OV_yg_dV_GP_S = (-d_xgd_ov_dV_GP_S);
SP_OV_yg = (-xgd_ov);

d_SP_OV_z_dV_GP_S = x1*d_SP_OV_yg_dV_GP_S*inv_xi_ov;
d_SP_OV_z_dV_D_S = x1*d_SP_OV_yg_dV_D_S*inv_xi_ov;
SP_OV_z = ((x1*SP_OV_yg)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_eta_dV_GP_S = 0.5*(d_SP_OV_z_dV_GP_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_GP_S+d_SP_OV_z_dV_GP_S*(SP_OV_z-6.0)))));
d_SP_OV_eta_dV_D_S = 0.5*(d_SP_OV_z_dV_D_S-(deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dV_D_S+d_SP_OV_z_dV_D_S*(SP_OV_z-6.0)))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}

d_SP_OV_a_dV_GP_S = (((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)+(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S)*(SP_OV_yg-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_GP_S);
d_SP_OV_a_dV_D_S = (((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S)+(d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S)*(SP_OV_yg-SP_OV_eta))+GOV2*d_SP_OV_eta_dV_D_S);
SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));

d_SP_OV_c_dV_GP_S = 2.0*(d_SP_OV_yg_dV_GP_S-d_SP_OV_eta_dV_GP_S);
d_SP_OV_c_dV_D_S = 2.0*(d_SP_OV_yg_dV_D_S-d_SP_OV_eta_dV_D_S);
SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));

d_SP_OV_tau_dV_GP_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_GP_S/GOV2)))-d_SP_OV_eta_dV_GP_S);
d_SP_OV_tau_dV_D_S = ((deriv_log_0_d0*((d_SP_OV_a_dV_D_S/GOV2)))-d_SP_OV_eta_dV_D_S);
SP_OV_tau = (value_log_0-SP_OV_eta);
}

d_nu_dV_S_BP =  0.0;
d_nu_dV_GP_S = (d_SP_OV_a_dV_GP_S+d_SP_OV_c_dV_GP_S);
d_nu_dV_D_S = (d_SP_OV_a_dV_D_S+d_SP_OV_c_dV_D_S);
nu = (SP_OV_a+SP_OV_c);

d_mutau_dV_S_BP = (nu*d_nu_dV_S_BP+d_nu_dV_S_BP*nu);
d_mutau_dV_GP_S = ((nu*d_nu_dV_GP_S+d_nu_dV_GP_S*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dV_GP_S+d_SP_OV_c_dV_GP_S*SP_OV_c)-d_SP_OV_a_dV_GP_S)+d_SP_OV_tau_dV_GP_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
d_mutau_dV_D_S = ((nu*d_nu_dV_D_S+d_nu_dV_D_S*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)-d_SP_OV_a_dV_D_S)+d_SP_OV_tau_dV_D_S*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));

d_SP_OV_y0_dV_S_BP = (((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*SP_OV_a*d_nu_dV_S_BP*SP_OV_tau-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_S_BP+((mutau*d_nu_dV_S_BP-nu*d_mutau_dV_S_BP)/mutau/mutau)*SP_OV_tau*SP_OV_tau*SP_OV_c*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))));
d_SP_OV_y0_dV_GP_S = (d_SP_OV_eta_dV_GP_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dV_GP_S+(SP_OV_a*d_nu_dV_GP_S+d_SP_OV_a_dV_GP_S*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_GP_S+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_GP_S+d_SP_OV_c_dV_GP_S*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dV_GP_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_GP_S+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_GP_S+((nu/mutau)*d_SP_OV_tau_dV_GP_S+((mutau*d_nu_dV_GP_S-nu*d_mutau_dV_GP_S)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
d_SP_OV_y0_dV_D_S = (d_SP_OV_eta_dV_D_S+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dV_D_S+(SP_OV_a*d_nu_dV_D_S+d_SP_OV_a_dV_D_S*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dV_D_S+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dV_D_S+d_SP_OV_c_dV_D_S*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dV_D_S)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dV_D_S+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dV_D_S+((nu/mutau)*d_SP_OV_tau_dV_D_S+((mutau*d_nu_dV_D_S-nu*d_mutau_dV_D_S)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*(d_SP_OV_y0_dV_S_BP));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_D_S));
d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*(d_SP_OV_y0_dV_GP_S));
SP_OV_D0 = value_exp_0;
}

d_SP_OV_temp_dV_S_BP = (-d_SP_OV_y0_dV_S_BP);
d_SP_OV_temp_dV_GP_S = (d_SP_OV_yg_dV_GP_S-d_SP_OV_y0_dV_GP_S);
d_SP_OV_temp_dV_D_S = (d_SP_OV_yg_dV_D_S-d_SP_OV_y0_dV_D_S);
SP_OV_temp = (SP_OV_yg-SP_OV_y0);

d_SP_OV_p_dV_S_BP = (2.0*d_SP_OV_temp_dV_S_BP+GOV2*d_SP_OV_D0_dV_S_BP);
d_SP_OV_p_dV_D_S = (2.0*d_SP_OV_temp_dV_D_S+GOV2*d_SP_OV_D0_dV_D_S);
d_SP_OV_p_dV_GP_S = (2.0*d_SP_OV_temp_dV_GP_S+GOV2*d_SP_OV_D0_dV_GP_S);
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));

d_SP_OV_q_dV_S_BP = ((SP_OV_temp*d_SP_OV_temp_dV_S_BP+d_SP_OV_temp_dV_S_BP*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_S_BP-d_SP_OV_D0_dV_S_BP));
d_SP_OV_q_dV_D_S = ((SP_OV_temp*d_SP_OV_temp_dV_D_S+d_SP_OV_temp_dV_D_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_D_S-d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_GP_S = ((SP_OV_temp*d_SP_OV_temp_dV_GP_S+d_SP_OV_temp_dV_GP_S*SP_OV_temp)+GOV2*(d_SP_OV_y0_dV_GP_S-d_SP_OV_D0_dV_GP_S));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));

d_SP_OV_xi_dV_S_BP = (-(GOV2*0.5)*d_SP_OV_D0_dV_S_BP);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dV_GP_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_GP_S);
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_S_BP = ((SP_OV_p*d_SP_OV_p_dV_S_BP+d_SP_OV_p_dV_S_BP*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_S_BP+d_SP_OV_xi_dV_S_BP*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
d_SP_OV_temp_dV_GP_S = ((SP_OV_p*d_SP_OV_p_dV_GP_S+d_SP_OV_p_dV_GP_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_GP_S+d_SP_OV_xi_dV_GP_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_w_dV_S_BP = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_D_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_w_dV_GP_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}

d_xd_ov_dV_S_BP = (-(d_SP_OV_y0_dV_S_BP+d_SP_OV_w_dV_S_BP));
d_xd_ov_dV_D_S = (-(d_SP_OV_y0_dV_D_S+d_SP_OV_w_dV_D_S));
d_xd_ov_dV_GP_S = (-(d_SP_OV_y0_dV_GP_S+d_SP_OV_w_dV_GP_S));
xd_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
SP_OV_Afac = ((((xi_ov*x1)*inv_xg1)-1.0)*inv_xg1);

d_SP_OV_xbar_dV_D_S = ((xgd_ov*inv_xi_ov)*SP_OV_Afac*d_xgd_ov_dV_D_S+d_xgd_ov_dV_D_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)));
d_SP_OV_xbar_dV_GP_S = ((xgd_ov*inv_xi_ov)*SP_OV_Afac*d_xgd_ov_dV_GP_S+d_xgd_ov_dV_GP_S*inv_xi_ov*(1.0+(SP_OV_Afac*xgd_ov)));
SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_temp_dV_S_BP =  0.0;
d_SP_OV_temp_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_GP_S)));
d_SP_OV_temp_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_xbar_dV_D_S)));
SP_OV_temp = value_exp_0;
}
}
else
{

d_SP_OV_temp_dV_S_BP =  0.0;
d_SP_OV_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-d_SP_OV_xbar_dV_GP_S))*3.3333333333333333e-01+(-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(-(-d_SP_OV_xbar_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
d_SP_OV_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-d_SP_OV_xbar_dV_D_S))*3.3333333333333333e-01+(-(-d_SP_OV_xbar_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(-(-d_SP_OV_xbar_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
}

d_SP_OV_w_dV_S_BP = (-d_SP_OV_temp_dV_S_BP);
d_SP_OV_w_dV_D_S = (-d_SP_OV_temp_dV_D_S);
d_SP_OV_w_dV_GP_S = (-d_SP_OV_temp_dV_GP_S);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_x0_dV_S_BP = (-GOV*(deriv_sqrt_0_d0*((-d_SP_OV_w_dV_S_BP))));
d_SP_OV_x0_dV_D_S = (d_xgd_ov_dV_D_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_D_S-d_SP_OV_w_dV_D_S))));
d_SP_OV_x0_dV_GP_S = (d_xgd_ov_dV_GP_S-GOV*(deriv_sqrt_0_d0*((d_xgd_ov_dV_GP_S-d_SP_OV_w_dV_GP_S))));
SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_OV_D0_dV_S_BP = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_S_BP)));
d_SP_OV_D0_dV_D_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_D_S)));
d_SP_OV_D0_dV_GP_S = (deriv_exp_0_d0*((-d_SP_OV_x0_dV_GP_S)));
SP_OV_D0 = value_exp_0;
}
}
else
{

d_SP_OV_D0_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_S_BP))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
d_SP_OV_D0_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_D_S))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
d_SP_OV_D0_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dV_GP_S))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
}

d_SP_OV_p_dV_S_BP = (2.0*(-d_SP_OV_x0_dV_S_BP)+GOV2*(-d_SP_OV_D0_dV_S_BP));
d_SP_OV_p_dV_D_S = (2.0*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)+GOV2*(-d_SP_OV_D0_dV_D_S));
d_SP_OV_p_dV_GP_S = (2.0*(d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)+GOV2*(-d_SP_OV_D0_dV_GP_S));
SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));

d_SP_OV_q_dV_S_BP = (((xgd_ov-SP_OV_x0)*(-d_SP_OV_x0_dV_S_BP)+(-d_SP_OV_x0_dV_S_BP)*(xgd_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_S_BP+d_SP_OV_D0_dV_S_BP));
d_SP_OV_q_dV_D_S = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)+(d_xgd_ov_dV_D_S-d_SP_OV_x0_dV_D_S)*(xgd_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_D_S+d_SP_OV_D0_dV_D_S));
d_SP_OV_q_dV_GP_S = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)+(d_xgd_ov_dV_GP_S-d_SP_OV_x0_dV_GP_S)*(xgd_ov-SP_OV_x0))-GOV2*(d_SP_OV_x0_dV_GP_S+d_SP_OV_D0_dV_GP_S));
SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));

d_SP_OV_xi_dV_S_BP = (-(GOV2*0.5)*d_SP_OV_D0_dV_S_BP);
d_SP_OV_xi_dV_D_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_D_S);
d_SP_OV_xi_dV_GP_S = (-(GOV2*0.5)*d_SP_OV_D0_dV_GP_S);
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));

d_SP_OV_temp_dV_S_BP = ((SP_OV_p*d_SP_OV_p_dV_S_BP+d_SP_OV_p_dV_S_BP*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_S_BP+d_SP_OV_xi_dV_S_BP*SP_OV_q));
d_SP_OV_temp_dV_D_S = ((SP_OV_p*d_SP_OV_p_dV_D_S+d_SP_OV_p_dV_D_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_D_S+d_SP_OV_xi_dV_D_S*SP_OV_q));
d_SP_OV_temp_dV_GP_S = ((SP_OV_p*d_SP_OV_p_dV_GP_S+d_SP_OV_p_dV_GP_S*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dV_GP_S+d_SP_OV_xi_dV_GP_S*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_u_dV_S_BP = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_S_BP-SP_OV_q*(d_SP_OV_p_dV_S_BP+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_S_BP))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_D_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_D_S-SP_OV_q*(d_SP_OV_p_dV_D_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_D_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
d_SP_OV_u_dV_GP_S = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dV_GP_S-SP_OV_q*(d_SP_OV_p_dV_GP_S+(deriv_sqrt_0_d0*(d_SP_OV_temp_dV_GP_S))))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}

d_xd_ov_dV_S_BP = (d_SP_OV_x0_dV_S_BP+d_SP_OV_u_dV_S_BP);
d_xd_ov_dV_D_S = (d_SP_OV_x0_dV_D_S+d_SP_OV_u_dV_D_S);
d_xd_ov_dV_GP_S = (d_SP_OV_x0_dV_GP_S+d_SP_OV_u_dV_GP_S);
xd_ov = (SP_OV_x0+SP_OV_u);
}

d_xd_ov_dV_D_S = (-d_xd_ov_dV_D_S);
d_xd_ov_dV_GP_S = (-d_xd_ov_dV_GP_S);
d_xd_ov_dV_S_BP = (-d_xd_ov_dV_S_BP);
xd_ov = (-xd_ov);
}

d_Vovs_dV_S_BP = (-(model_.phit))*d_xs_ov_dV_S_BP;
d_Vovs_dV_D_S = (-(model_.phit))*d_xs_ov_dV_D_S;
d_Vovs_dV_GP_S = (-(model_.phit))*(d_xgs_ov_dV_GP_S+d_xs_ov_dV_GP_S);
Vovs = ((-(model_.phit))*(xgs_ov+xs_ov));

d_Vovd_dV_S_BP = (-(model_.phit))*d_xd_ov_dV_S_BP;
d_Vovd_dV_D_S = (-(model_.phit))*(d_xgd_ov_dV_D_S+d_xd_ov_dV_D_S);
d_Vovd_dV_GP_S = (-(model_.phit))*(d_xgd_ov_dV_GP_S+d_xd_ov_dV_GP_S);
Vovd = ((-(model_.phit))*(xgd_ov+xd_ov));
}

d_Igsov_dV_GP_S = d_Igsov_dV_D_S = d_Igsov_dV_S_BP =  0.0;
Igsov = 0.0;

d_Igdov_dV_GP_S = d_Igdov_dV_D_S = d_Igdov_dV_S_BP =  0.0;
Igdov = 0.0;

d_Igc_dV_GP_S = d_Igc_dV_D_S = d_Igc_dV_S_BP =  0.0;
Igc = 0.0;

d_Igb_dV_GP_S = d_Igb_dV_D_S = d_Igb_dV_S_BP =  0.0;
Igb = 0.0;

d_Igcs_dV_GP_S = d_Igcs_dV_D_S = d_Igcs_dV_S_BP =  0.0;
Igcs = 0.0;

d_Igcd_dV_GP_S = d_Igcd_dV_D_S = d_Igcd_dV_S_BP =  0.0;
Igcd = 0.0;
if (((model_.SWIGATE)!=0))
{
if ((IGOV_i>0))
{

d_arg2mina_dV_S_BP = d_Vovs_dV_S_BP;
d_arg2mina_dV_D_S = d_Vovs_dV_D_S;
d_arg2mina_dV_GP_S = d_Vovs_dV_GP_S;
arg2mina = (Vovs+Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_S_BP = 0.5*(d_arg2mina_dV_S_BP-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_S_BP)+(-d_arg2mina_dV_S_BP)*(-arg2mina)))));
d_psi_t_dV_D_S = 0.5*(d_arg2mina_dV_D_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_D_S)+(-d_arg2mina_dV_D_S)*(-arg2mina)))));
d_psi_t_dV_GP_S = 0.5*(d_arg2mina_dV_GP_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_GP_S)+(-d_arg2mina_dV_GP_S)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_S_BP+d_Vovs_dV_S_BP*Vovs)))*inv_CHIB;
d_zg_dV_D_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_D_S+d_Vovs_dV_D_S*Vovs)))*inv_CHIB;
d_zg_dV_GP_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_GP_S+d_Vovs_dV_GP_S*Vovs)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = 0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_S_BP+d_zg_dV_S_BP*(zg-GCQ)))));
d_zg_dV_D_S = 0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_D_S+d_zg_dV_D_S*(zg-GCQ)))));
d_zg_dV_GP_S = 0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_S+d_zg_dV_GP_S*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_arg1_dV_GP_S = (d_xs_ov_dV_GP_S+d_psi_t_dV_GP_S*(model_.inv_phit));
d_arg1_dV_S_BP = (d_xs_ov_dV_S_BP+d_psi_t_dV_S_BP*(model_.inv_phit));
d_arg1_dV_D_S = (d_xs_ov_dV_D_S+d_psi_t_dV_D_S*(model_.inv_phit));
arg1 = ((3.0+xs_ov)+(psi_t*(model_.inv_phit)));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_Dsi_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_Dsi_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_arg1_dV_D_S = d_arg1_dV_S_BP =  0.0;
d_arg1_dV_GP_S = (-d_VgsPrime_dV_GP_S)*(model_.inv_phit);
arg1 = ((-VgsPrime)*(model_.inv_phit));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Dgate_dV_GP_S = (Dsi*d_temp_dV_GP_S+d_Dsi_dV_GP_S*temp);
d_Dgate_dV_S_BP = (Dsi*d_temp_dV_S_BP+d_Dsi_dV_S_BP*temp);
d_Dgate_dV_D_S = (Dsi*d_temp_dV_D_S+d_Dsi_dV_D_S*temp);
Dgate = (Dsi*temp);

d_temp_dV_S_BP = BOV*(zg*GC3_i*d_zg_dV_S_BP+d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)));
d_temp_dV_D_S = BOV*(zg*GC3_i*d_zg_dV_D_S+d_zg_dV_D_S*(GC2_i+(GC3_i*zg)));
d_temp_dV_GP_S = BOV*(zg*GC3_i*d_zg_dV_GP_S+d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)));
temp = (BOV*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0))
{

d_TP_dV_S_BP = (temp*0.5*(temp*d_temp_dV_S_BP*3.3333333333333333e-01+d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_D_S = (temp*0.5*(temp*d_temp_dV_D_S*3.3333333333333333e-01+d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_S = (temp*0.5*(temp*d_temp_dV_GP_S*3.3333333333333333e-01+d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
TP = value_exp_0;
}
}
else
{

d_TP_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_S_BP)*3.3333333333333333e-01+(-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_D_S)*3.3333333333333333e-01+(-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_S)*3.3333333333333333e-01+(-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

d_Igsov_dV_S_BP = IGOV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_S_BP*value_log_0);
d_Igsov_dV_D_S = IGOV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_D_S*value_log_0);
d_Igsov_dV_GP_S = IGOV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_GP_S*value_log_0);
Igsov = (IGOV_i*(TP*value_log_0));
}
}
if ((IGOVD_i>0))
{

d_arg2mina_dV_S_BP = d_Vovd_dV_S_BP;
d_arg2mina_dV_D_S = d_Vovd_dV_D_S;
d_arg2mina_dV_GP_S = d_Vovd_dV_GP_S;
arg2mina = (Vovd+Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_S_BP = 0.5*(d_arg2mina_dV_S_BP-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_S_BP)+(-d_arg2mina_dV_S_BP)*(-arg2mina)))));
d_psi_t_dV_D_S = 0.5*(d_arg2mina_dV_D_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_D_S)+(-d_arg2mina_dV_D_S)*(-arg2mina)))));
d_psi_t_dV_GP_S = 0.5*(d_arg2mina_dV_GP_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_GP_S)+(-d_arg2mina_dV_GP_S)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_S_BP+d_Vovd_dV_S_BP*Vovd)))*inv_CHIB;
d_zg_dV_D_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_D_S+d_Vovd_dV_D_S*Vovd)))*inv_CHIB;
d_zg_dV_GP_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_GP_S+d_Vovd_dV_GP_S*Vovd)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = 0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_S_BP+d_zg_dV_S_BP*(zg-GCQ)))));
d_zg_dV_D_S = 0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_D_S+d_zg_dV_D_S*(zg-GCQ)))));
d_zg_dV_GP_S = 0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_S+d_zg_dV_GP_S*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_arg1_dV_D_S = (d_xd_ov_dV_D_S+d_psi_t_dV_D_S*(model_.inv_phit));
d_arg1_dV_GP_S = (d_xd_ov_dV_GP_S+d_psi_t_dV_GP_S*(model_.inv_phit));
d_arg1_dV_S_BP = (d_xd_ov_dV_S_BP+d_psi_t_dV_S_BP*(model_.inv_phit));
arg1 = ((3.0+xd_ov)+(psi_t*(model_.inv_phit)));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_Dsi_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_Dsi_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_arg1_dV_S_BP =  0.0;
d_arg1_dV_D_S = (-d_VgdPrime_dV_D_S)*(model_.inv_phit);
d_arg1_dV_GP_S = (-d_VgdPrime_dV_GP_S)*(model_.inv_phit);
arg1 = ((-VgdPrime)*(model_.inv_phit));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Dgate_dV_GP_S = (Dsi*d_temp_dV_GP_S+d_Dsi_dV_GP_S*temp);
d_Dgate_dV_S_BP = (Dsi*d_temp_dV_S_BP+d_Dsi_dV_S_BP*temp);
d_Dgate_dV_D_S = (Dsi*d_temp_dV_D_S+d_Dsi_dV_D_S*temp);
Dgate = (Dsi*temp);

d_temp_dV_S_BP = BOV_d*(zg*GC3_i*d_zg_dV_S_BP+d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)));
d_temp_dV_D_S = BOV_d*(zg*GC3_i*d_zg_dV_D_S+d_zg_dV_D_S*(GC2_i+(GC3_i*zg)));
d_temp_dV_GP_S = BOV_d*(zg*GC3_i*d_zg_dV_GP_S+d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)));
temp = (BOV_d*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0))
{

d_TP_dV_S_BP = (temp*0.5*(temp*d_temp_dV_S_BP*3.3333333333333333e-01+d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_D_S = (temp*0.5*(temp*d_temp_dV_D_S*3.3333333333333333e-01+d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_S = (temp*0.5*(temp*d_temp_dV_GP_S*3.3333333333333333e-01+d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
TP = value_exp_0;
}
}
else
{

d_TP_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_S_BP)*3.3333333333333333e-01+(-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_D_S)*3.3333333333333333e-01+(-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_S)*3.3333333333333333e-01+(-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

d_Igdov_dV_S_BP = IGOVD_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_S_BP*value_log_0);
d_Igdov_dV_D_S = IGOVD_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_D_S*value_log_0);
d_Igdov_dV_GP_S = IGOVD_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_GP_S*value_log_0);
Igdov = (IGOVD_i*(TP*value_log_0));
}
}
if ((IGINV_i>0))
{
if ((xg<=0.0))
{
{
double value_pow_0 = pow((Vds/Vdsat_lim),AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat_lim) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat_lim)));

d_temp_dV_GP_S = d_temp_dV_S_BP =  0.0;
d_temp_dV_D_S = (deriv_pow_0_d0*((d_Vds_dV_D_S/Vdsat_lim)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

d_Udse_dV_S_BP = Vds*(deriv_pow_0_d0*(d_temp_dV_S_BP))*inv_phit1;
d_Udse_dV_GP_S = Vds*(deriv_pow_0_d0*(d_temp_dV_GP_S))*inv_phit1;
d_Udse_dV_D_S = (Vds*(deriv_pow_0_d0*(d_temp_dV_D_S))+d_Vds_dV_D_S*value_pow_0)*inv_phit1;
Udse = ((Vds*value_pow_0)*inv_phit1);
}
}
if (((x_ds-Udse)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_ds-Udse));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_S_BP = (deriv_exp_0_d0*((d_x_ds_dV_S_BP-d_Udse_dV_S_BP)));
d_temp_dV_GP_S = (deriv_exp_0_d0*((d_x_ds_dV_GP_S-d_Udse_dV_GP_S)));
d_temp_dV_D_S = (deriv_exp_0_d0*((d_x_ds_dV_D_S-d_Udse_dV_D_S)));
temp = value_exp_0;
}
}
else
{

d_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds-Udse))*0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*3.3333333333333333e-01+(-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(-(d_x_ds_dV_S_BP-d_Udse_dV_S_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
d_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds-Udse))*0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*3.3333333333333333e-01+(-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(-(d_x_ds_dV_GP_S-d_Udse_dV_GP_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds-Udse))*0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*3.3333333333333333e-01+(-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(-(d_x_ds_dV_D_S-d_Udse_dV_D_S))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
}
{
double value_log_0 = log((0.5*(1.0+temp)));
double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));

d_Vm_dV_GP_S = phit1*(0.5*d_x_ds_dV_GP_S-(deriv_log_0_d0*(0.5*d_temp_dV_GP_S)));
d_Vm_dV_S_BP = (d_Vsbstar_dV_S_BP+phit1*(0.5*d_x_ds_dV_S_BP-(deriv_log_0_d0*(0.5*d_temp_dV_S_BP))));
d_Vm_dV_D_S = (d_Vsbstar_dV_D_S+phit1*(0.5*d_x_ds_dV_D_S-(deriv_log_0_d0*(0.5*d_temp_dV_D_S))));
Vm = (Vsbstar+(phit1*((0.5*x_ds)-value_log_0)));
}

d_arg2mina_dV_S_BP = d_Voxm_dV_S_BP;
d_arg2mina_dV_GP_S = d_Voxm_dV_GP_S;
d_arg2mina_dV_D_S = d_Voxm_dV_D_S;
arg2mina = (Voxm+Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_S_BP = 0.5*(d_arg2mina_dV_S_BP-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_S_BP)+(-d_arg2mina_dV_S_BP)*(-arg2mina)))));
d_psi_t_dV_D_S = 0.5*(d_arg2mina_dV_D_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_D_S)+(-d_arg2mina_dV_D_S)*(-arg2mina)))));
d_psi_t_dV_GP_S = 0.5*(d_arg2mina_dV_GP_S-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_GP_S)+(-d_arg2mina_dV_GP_S)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_S_BP+d_Voxm_dV_S_BP*Voxm)))*inv_CHIB;
d_zg_dV_GP_S = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_GP_S+d_Voxm_dV_GP_S*Voxm)))*inv_CHIB;
d_zg_dV_D_S = (deriv_sqrt_0_d0*((Voxm*d_Voxm_dV_D_S+d_Voxm_dV_D_S*Voxm)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_S_BP = 0.5*(d_zg_dV_S_BP-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_S_BP+d_zg_dV_S_BP*(zg-GCQ)))));
d_zg_dV_D_S = 0.5*(d_zg_dV_D_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_D_S+d_zg_dV_D_S*(zg-GCQ)))));
d_zg_dV_GP_S = 0.5*(d_zg_dV_GP_S-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_S+d_zg_dV_GP_S*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_arg1_dV_S_BP = (d_x_m_dV_S_BP+(d_psi_t_dV_S_BP-d_Vm_dV_S_BP)*inv_phit1);
d_arg1_dV_GP_S = (d_x_m_dV_GP_S+(d_psi_t_dV_GP_S-d_Vm_dV_GP_S)*inv_phit1);
d_arg1_dV_D_S = (d_x_m_dV_D_S+(d_psi_t_dV_D_S-d_Vm_dV_D_S)*inv_phit1);
arg1 = (x_m+(((psi_t-alpha_b)-Vm)*inv_phit1));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_Dsi_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_Dsi_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_Dsi_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_Dsi_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_arg1_dV_S_BP = (-(d_Vsbstar_dV_S_BP-d_Vm_dV_S_BP))*inv_phit1;
d_arg1_dV_GP_S = (-(d_Vgs_dV_GP_S-d_Vm_dV_GP_S))*inv_phit1;
d_arg1_dV_D_S = (-((d_Vgs_dV_D_S+d_Vsbstar_dV_D_S)-d_Vm_dV_D_S))*inv_phit1;
arg1 = ((-((Vgs+Vsbstar)-Vm))*inv_phit1);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_GP_S = (deriv_exp_0_d0*(d_arg1_dV_GP_S));
d_temp_dV_S_BP = (deriv_exp_0_d0*(d_arg1_dV_S_BP));
d_temp_dV_D_S = (deriv_exp_0_d0*(d_arg1_dV_D_S));
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{

d_temp_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_S)*3.3333333333333333e-01+(-d_arg1_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_S_BP)*3.3333333333333333e-01+(-d_arg1_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_D_S)*3.3333333333333333e-01+(-d_arg1_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_GP_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_S*3.3333333333333333e-01+d_arg1_dV_GP_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_S_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_S_BP*3.3333333333333333e-01+d_arg1_dV_S_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_S_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_D_S = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_D_S*3.3333333333333333e-01+d_arg1_dV_D_S*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_D_S*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Dgate_dV_GP_S = (Dsi*d_temp_dV_GP_S+d_Dsi_dV_GP_S*temp);
d_Dgate_dV_S_BP = (Dsi*d_temp_dV_S_BP+d_Dsi_dV_S_BP*temp);
d_Dgate_dV_D_S = (Dsi*d_temp_dV_D_S+d_Dsi_dV_D_S*temp);
Dgate = (Dsi*temp);

d_temp_dV_S_BP = BCH*(zg*GC3_i*d_zg_dV_S_BP+d_zg_dV_S_BP*(GC2_i+(GC3_i*zg)));
d_temp_dV_D_S = BCH*(zg*GC3_i*d_zg_dV_D_S+d_zg_dV_D_S*(GC2_i+(GC3_i*zg)));
d_temp_dV_GP_S = BCH*(zg*GC3_i*d_zg_dV_GP_S+d_zg_dV_GP_S*(GC2_i+(GC3_i*zg)));
temp = (BCH*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0))
{

d_TP_dV_S_BP = (temp*0.5*(temp*d_temp_dV_S_BP*3.3333333333333333e-01+d_temp_dV_S_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_S_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_D_S = (temp*0.5*(temp*d_temp_dV_D_S*3.3333333333333333e-01+d_temp_dV_D_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_D_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_S = (temp*0.5*(temp*d_temp_dV_GP_S*3.3333333333333333e-01+d_temp_dV_GP_S*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_S*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
d_TP_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_TP_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
TP = value_exp_0;
}
}
else
{

d_TP_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_S_BP)*3.3333333333333333e-01+(-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_D_S)*3.3333333333333333e-01+(-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_S)*3.3333333333333333e-01+(-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

d_Igc0_dV_S_BP = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_S_BP-(1.0+Dsi)*d_Dgate_dV_S_BP)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_S_BP*value_log_0);
d_Igc0_dV_D_S = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_D_S-(1.0+Dsi)*d_Dgate_dV_D_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_D_S*value_log_0);
d_Igc0_dV_GP_S = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_S-(1.0+Dsi)*d_Dgate_dV_GP_S)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_GP_S*value_log_0);
Igc0 = (IGINV_i*(TP*value_log_0));
}
if (((xg<=0)||((GC2_i==0)&&(GC3_i==0))))
{

d_igc_dV_D_S = d_igc_dV_GP_S = d_igc_dV_S_BP =  0.0;
igc = 1.0;

d_igcd_h_dV_D_S = d_igcd_h_dV_GP_S = d_igcd_h_dV_S_BP =  0.0;
igcd_h = 0.5;
}
else
{

d_temp_dV_S_BP = (2.0*GC3_i)*d_zg_dV_S_BP;
d_temp_dV_D_S = (2.0*GC3_i)*d_zg_dV_D_S;
d_temp_dV_GP_S = (2.0*GC3_i)*d_zg_dV_GP_S;
temp = (GC2_i+((2.0*GC3_i)*zg));

d_u0_dV_S_BP = (-CHIB_i*d_temp_dV_S_BP*BCH/(temp*BCH)/(temp*BCH));
d_u0_dV_D_S = (-CHIB_i*d_temp_dV_D_S*BCH/(temp*BCH)/(temp*BCH));
d_u0_dV_GP_S = (-CHIB_i*d_temp_dV_GP_S*BCH/(temp*BCH)/(temp*BCH));
u0 = (CHIB_i/(temp*BCH));

d_x_dV_S_BP = 0.5*((u0*d_dps_dV_S_BP-dps*d_u0_dV_S_BP)/u0/u0);
d_x_dV_GP_S = 0.5*((u0*d_dps_dV_GP_S-dps*d_u0_dV_GP_S)/u0/u0);
d_x_dV_D_S = 0.5*((u0*d_dps_dV_D_S-dps*d_u0_dV_D_S)/u0/u0);
x = (0.5*(dps/u0));

d_u0_div_H_dV_S_BP = ((H*d_u0_dV_S_BP-u0*d_H_dV_S_BP)/H/H);
d_u0_div_H_dV_D_S = ((H*d_u0_dV_D_S-u0*d_H_dV_D_S)/H/H);
d_u0_div_H_dV_GP_S = ((H*d_u0_dV_GP_S-u0*d_H_dV_GP_S)/H/H);
u0_div_H = (u0/H);

d_Bg_dV_S_BP = (u0_div_H*(-d_u0_div_H_dV_S_BP)+d_u0_div_H_dV_S_BP*(1.0-u0_div_H))*0.5;
d_Bg_dV_D_S = (u0_div_H*(-d_u0_div_H_dV_D_S)+d_u0_div_H_dV_D_S*(1.0-u0_div_H))*0.5;
d_Bg_dV_GP_S = (u0_div_H*(-d_u0_div_H_dV_GP_S)+d_u0_div_H_dV_GP_S*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);

d_Ag_dV_S_BP = (-3.0*d_Bg_dV_S_BP);
d_Ag_dV_D_S = (-3.0*d_Bg_dV_D_S);
d_Ag_dV_GP_S = (-3.0*d_Bg_dV_GP_S);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{

d_xsq_dV_S_BP = (x*d_x_dV_S_BP+d_x_dV_S_BP*x);
d_xsq_dV_GP_S = (x*d_x_dV_GP_S+d_x_dV_GP_S*x);
d_xsq_dV_D_S = (x*d_x_dV_D_S+d_x_dV_D_S*x);
xsq = (x*x);

d_igc_dV_S_BP = (xsq*(d_u0_div_H_dV_S_BP*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_S_BP+d_xsq_dV_S_BP*(0.05+(0.2*u0_div_H))))+d_xsq_dV_S_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
d_igc_dV_GP_S = (xsq*(d_u0_div_H_dV_GP_S*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_GP_S+d_xsq_dV_GP_S*(0.05+(0.2*u0_div_H))))+d_xsq_dV_GP_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
d_igc_dV_D_S = (xsq*(d_u0_div_H_dV_D_S*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_D_S+d_xsq_dV_D_S*(0.05+(0.2*u0_div_H))))+d_xsq_dV_D_S*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));

d_igcd_h_dV_S_BP = (0.5*d_igc_dV_S_BP-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_S_BP+0.0285714285714*(xsq*d_Bg_dV_S_BP+d_xsq_dV_S_BP*(0.125+Bg)))+d_xsq_dV_S_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_S_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
d_igcd_h_dV_GP_S = (0.5*d_igc_dV_GP_S-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_GP_S+0.0285714285714*(xsq*d_Bg_dV_GP_S+d_xsq_dV_GP_S*(0.125+Bg)))+d_xsq_dV_GP_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_GP_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
d_igcd_h_dV_D_S = (0.5*d_igc_dV_D_S-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_D_S+0.0285714285714*(xsq*d_Bg_dV_D_S+d_xsq_dV_D_S*(0.125+Bg)))+d_xsq_dV_D_S*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_D_S*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
}
else
{

d_inv_x_dV_S_BP = (-d_x_dV_S_BP/x/x);
d_inv_x_dV_GP_S = (-d_x_dV_GP_S/x/x);
d_inv_x_dV_D_S = (-d_x_dV_D_S/x/x);
inv_x = (1.0/x);
if ((fabs(x)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;

d_ex_dV_S_BP = (deriv_exp_0_d0*(d_x_dV_S_BP));
d_ex_dV_GP_S = (deriv_exp_0_d0*(d_x_dV_GP_S));
d_ex_dV_D_S = (deriv_exp_0_d0*(d_x_dV_D_S));
ex = value_exp_0;
}
}
else
{
if ((x<(-2.3025850929940458e+02)))
{

d_ex_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_S_BP)*3.3333333333333333e-01+(-d_x_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
d_ex_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_GP_S)*3.3333333333333333e-01+(-d_x_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
d_ex_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_D_S)*3.3333333333333333e-01+(-d_x_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
}
else
{

d_ex_dV_S_BP = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_S_BP*3.3333333333333333e-01+d_x_dV_S_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_S_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_ex_dV_GP_S = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_GP_S*3.3333333333333333e-01+d_x_dV_GP_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_GP_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_ex_dV_D_S = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_D_S*3.3333333333333333e-01+d_x_dV_D_S*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_D_S*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_inv_ex_dV_S_BP = (-d_ex_dV_S_BP/ex/ex);
d_inv_ex_dV_GP_S = (-d_ex_dV_GP_S/ex/ex);
d_inv_ex_dV_D_S = (-d_ex_dV_D_S/ex/ex);
inv_ex = (1.0/ex);

d_temp_dV_S_BP = (d_ex_dV_S_BP-d_inv_ex_dV_S_BP);
d_temp_dV_GP_S = (d_ex_dV_GP_S-d_inv_ex_dV_GP_S);
d_temp_dV_D_S = (d_ex_dV_D_S-d_inv_ex_dV_D_S);
temp = (ex-inv_ex);

d_temp2_dV_S_BP = (d_ex_dV_S_BP+d_inv_ex_dV_S_BP);
d_temp2_dV_GP_S = (d_ex_dV_GP_S+d_inv_ex_dV_GP_S);
d_temp2_dV_D_S = (d_ex_dV_D_S+d_inv_ex_dV_D_S);
temp2 = (ex+inv_ex);

d_igc_dV_S_BP = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_S_BP+((1.0-u0_div_H)*d_temp_dV_S_BP+(-d_u0_div_H_dV_S_BP)*temp)*inv_x)+(u0_div_H*d_temp2_dV_S_BP+d_u0_div_H_dV_S_BP*temp2));
d_igc_dV_D_S = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_D_S+((1.0-u0_div_H)*d_temp_dV_D_S+(-d_u0_div_H_dV_D_S)*temp)*inv_x)+(u0_div_H*d_temp2_dV_D_S+d_u0_div_H_dV_D_S*temp2));
d_igc_dV_GP_S = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_GP_S+((1.0-u0_div_H)*d_temp_dV_GP_S+(-d_u0_div_H_dV_GP_S)*temp)*inv_x)+(u0_div_H*d_temp2_dV_GP_S+d_u0_div_H_dV_GP_S*temp2));
igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));

d_igcd_h_dV_S_BP = 0.5*((d_igc_dV_S_BP-(temp*(d_Bg_dV_S_BP-((Ag*inv_x)*d_inv_x_dV_S_BP+(Ag*d_inv_x_dV_S_BP+d_Ag_dV_S_BP*inv_x)*inv_x))+d_temp_dV_S_BP*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_S_BP+(Ag*d_temp2_dV_S_BP+d_Ag_dV_S_BP*temp2)*inv_x));
d_igcd_h_dV_GP_S = 0.5*((d_igc_dV_GP_S-(temp*(d_Bg_dV_GP_S-((Ag*inv_x)*d_inv_x_dV_GP_S+(Ag*d_inv_x_dV_GP_S+d_Ag_dV_GP_S*inv_x)*inv_x))+d_temp_dV_GP_S*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_GP_S+(Ag*d_temp2_dV_GP_S+d_Ag_dV_GP_S*temp2)*inv_x));
d_igcd_h_dV_D_S = 0.5*((d_igc_dV_D_S-(temp*(d_Bg_dV_D_S-((Ag*inv_x)*d_inv_x_dV_D_S+(Ag*d_inv_x_dV_D_S+d_Ag_dV_D_S*inv_x)*inv_x))+d_temp_dV_D_S*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_D_S+(Ag*d_temp2_dV_D_S+d_Ag_dV_D_S*temp2)*inv_x));
igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
}
}
{
double value_sqrt_0 = sqrt(((xg*xg)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Sg_dV_S_BP = 0.5*((value_sqrt_0*d_xg_dV_S_BP-xg*(deriv_sqrt_0_d0*((xg*d_xg_dV_S_BP+d_xg_dV_S_BP*xg))))/value_sqrt_0/value_sqrt_0);
d_Sg_dV_GP_S = 0.5*((value_sqrt_0*d_xg_dV_GP_S-xg*(deriv_sqrt_0_d0*((xg*d_xg_dV_GP_S+d_xg_dV_GP_S*xg))))/value_sqrt_0/value_sqrt_0);
d_Sg_dV_D_S = 0.5*((value_sqrt_0*d_xg_dV_D_S-xg*(deriv_sqrt_0_d0*((xg*d_xg_dV_D_S+d_xg_dV_D_S*xg))))/value_sqrt_0/value_sqrt_0);
Sg = (0.5*(1.0+(xg/value_sqrt_0)));
}

d_Igc_dV_S_BP = ((Igc0*igc)*d_Sg_dV_S_BP+(Igc0*d_igc_dV_S_BP+d_Igc0_dV_S_BP*igc)*Sg);
d_Igc_dV_D_S = ((Igc0*igc)*d_Sg_dV_D_S+(Igc0*d_igc_dV_D_S+d_Igc0_dV_D_S*igc)*Sg);
d_Igc_dV_GP_S = ((Igc0*igc)*d_Sg_dV_GP_S+(Igc0*d_igc_dV_GP_S+d_Igc0_dV_GP_S*igc)*Sg);
Igc = ((Igc0*igc)*Sg);

d_Igcd_dV_S_BP = ((Igc0*igcd_h)*d_Sg_dV_S_BP+(Igc0*d_igcd_h_dV_S_BP+d_Igc0_dV_S_BP*igcd_h)*Sg);
d_Igcd_dV_D_S = ((Igc0*igcd_h)*d_Sg_dV_D_S+(Igc0*d_igcd_h_dV_D_S+d_Igc0_dV_D_S*igcd_h)*Sg);
d_Igcd_dV_GP_S = ((Igc0*igcd_h)*d_Sg_dV_GP_S+(Igc0*d_igcd_h_dV_GP_S+d_Igc0_dV_GP_S*igcd_h)*Sg);
Igcd = ((Igc0*igcd_h)*Sg);

d_Igcs_dV_S_BP = (d_Igc_dV_S_BP-d_Igcd_dV_S_BP);
d_Igcs_dV_D_S = (d_Igc_dV_D_S-d_Igcd_dV_D_S);
d_Igcs_dV_GP_S = (d_Igc_dV_GP_S-d_Igcd_dV_GP_S);
Igcs = (Igc-Igcd);

d_Igb_dV_S_BP = ((Igc0*igc)*(-d_Sg_dV_S_BP)+(Igc0*d_igc_dV_S_BP+d_Igc0_dV_S_BP*igc)*(1.0-Sg));
d_Igb_dV_D_S = ((Igc0*igc)*(-d_Sg_dV_D_S)+(Igc0*d_igc_dV_D_S+d_Igc0_dV_D_S*igc)*(1.0-Sg));
d_Igb_dV_GP_S = ((Igc0*igc)*(-d_Sg_dV_GP_S)+(Igc0*d_igc_dV_GP_S+d_Igc0_dV_GP_S*igc)*(1.0-Sg));
Igb = ((Igc0*igc)*(1.0-Sg));
}
}

d_Igidl_dV_D_S = d_Igidl_dV_S_BP = d_Igidl_dV_GP_S =  0.0;
Igidl = 0.0;

d_Igisl_dV_S_BP = d_Igisl_dV_GP_S = d_Igisl_dV_D_S =  0.0;
Igisl = 0.0;
if (((model_.SWGIDL)!=0))
{
if (((AGIDLD_i>0)&&(Vovd<0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+((CGIDLD_i*CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovd_dV_S_BP = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_S_BP+d_Vovd_dV_S_BP*Vovd)+(CGIDLD_i*CGIDLD_i)*(VdbPrime*d_VdbPrime_dV_S_BP+d_VdbPrime_dV_S_BP*VdbPrime))));
d_Vtovd_dV_D_S = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_D_S+d_Vovd_dV_D_S*Vovd)+(CGIDLD_i*CGIDLD_i)*(VdbPrime*d_VdbPrime_dV_D_S+d_VdbPrime_dV_D_S*VdbPrime))));
d_Vtovd_dV_GP_S = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_GP_S+d_Vovd_dV_GP_S*Vovd)));
Vtovd = value_sqrt_0;
}

d_temp_dV_S_BP = (-(-BGIDLDs)*d_Vtovd_dV_S_BP/Vtovd/Vtovd);
d_temp_dV_D_S = (-(-BGIDLDs)*d_Vtovd_dV_D_S/Vtovd/Vtovd);
d_temp_dV_GP_S = (-(-BGIDLDs)*d_Vtovd_dV_GP_S/Vtovd/Vtovd);
temp = ((-BGIDLDs)/Vtovd);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_temp2_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_S_BP)*3.3333333333333333e-01+(-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_D_S)*3.3333333333333333e-01+(-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_S)*3.3333333333333333e-01+(-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}

d_Igidl_dV_GP_S = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_GP_S+((VdbPrime*Vovd)*d_Vtovd_dV_GP_S+VdbPrime*d_Vovd_dV_GP_S*Vtovd)*temp2);
d_Igidl_dV_S_BP = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_S_BP+((VdbPrime*Vovd)*d_Vtovd_dV_S_BP+(VdbPrime*d_Vovd_dV_S_BP+d_VdbPrime_dV_S_BP*Vovd)*Vtovd)*temp2);
d_Igidl_dV_D_S = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_D_S+((VdbPrime*Vovd)*d_Vtovd_dV_D_S+(VdbPrime*d_Vovd_dV_D_S+d_VdbPrime_dV_D_S*Vovd)*Vtovd)*temp2);
Igidl = ((-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
}
if (((AGIDL_i>0)&&(Vovs<0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+((CGIDL_i*CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovs_dV_S_BP = (deriv_sqrt_0_d0*(((Vovs*d_Vovs_dV_S_BP+d_Vovs_dV_S_BP*Vovs)+(CGIDL_i*CGIDL_i)*(VsbPrime*d_VsbPrime_dV_S_BP+d_VsbPrime_dV_S_BP*VsbPrime))));
d_Vtovs_dV_D_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_D_S+d_Vovs_dV_D_S*Vovs)));
d_Vtovs_dV_GP_S = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_GP_S+d_Vovs_dV_GP_S*Vovs)));
Vtovs = value_sqrt_0;
}

d_temp_dV_S_BP = (-(-BGIDLs)*d_Vtovs_dV_S_BP/Vtovs/Vtovs);
d_temp_dV_D_S = (-(-BGIDLs)*d_Vtovs_dV_D_S/Vtovs/Vtovs);
d_temp_dV_GP_S = (-(-BGIDLs)*d_Vtovs_dV_GP_S/Vtovs/Vtovs);
temp = ((-BGIDLs)/Vtovs);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dV_S_BP = (deriv_exp_0_d0*(d_temp_dV_S_BP));
d_temp2_dV_D_S = (deriv_exp_0_d0*(d_temp_dV_D_S));
d_temp2_dV_GP_S = (deriv_exp_0_d0*(d_temp_dV_GP_S));
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_S_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_S_BP)*3.3333333333333333e-01+(-d_temp_dV_S_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_S_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_D_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_D_S)*3.3333333333333333e-01+(-d_temp_dV_D_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_D_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_GP_S = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_S)*3.3333333333333333e-01+(-d_temp_dV_GP_S)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_S)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}

d_Igisl_dV_D_S = (-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_D_S+((VsbPrime*Vovs)*d_Vtovs_dV_D_S+VsbPrime*d_Vovs_dV_D_S*Vtovs)*temp2);
d_Igisl_dV_GP_S = (-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_GP_S+((VsbPrime*Vovs)*d_Vtovs_dV_GP_S+VsbPrime*d_Vovs_dV_GP_S*Vtovs)*temp2);
d_Igisl_dV_S_BP = (-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_S_BP+((VsbPrime*Vovs)*d_Vtovs_dV_S_BP+(VsbPrime*d_Vovs_dV_S_BP+d_VsbPrime_dV_S_BP*Vovs)*Vtovs)*temp2);
Igisl = ((-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
}
}
P_D = (1+(0.25*(Gf*kp)));
facvsb0 = (phib+(2*phit1));
facvsb = (Vsbstar+facvsb0);
{
double value_sqrt_0 = sqrt((phit1*facvsb));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vts_i = (((VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*value_sqrt_0));
}
vth_i = (vts_i-delVg);
}
// End block evaluateStatic
//Begin block evaluateDynamic
{

d_Vgb_dV_S_BP = d_Vsb_dV_S_BP;
d_Vgb_dV_GP_S = d_Vgs_dV_GP_S;
d_Vgb_dV_D_S = (d_Vgs_dV_D_S+d_Vsb_dV_D_S);
Vgb = (Vgs+Vsb);

d_COX_qm_dV_D_S = d_COX_qm_dV_GP_S = d_COX_qm_dV_S_BP =  0.0;
COX_qm = COX_i;
if ((qq>0.0))
{
{
double value_pow_0 = pow(((qeff*qeff)+qlim2),((-1.0)*1.6666666666666667e-01));
double  deriv_pow_0_d0 = ((((qeff*qeff)+qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff*qeff)+qlim2)));

d_COX_qm_dV_S_BP = (-COX_i*qq*(deriv_pow_0_d0*((qeff*d_qeff_dV_S_BP+d_qeff_dV_S_BP*qeff)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
d_COX_qm_dV_GP_S = (-COX_i*qq*(deriv_pow_0_d0*((qeff*d_qeff_dV_GP_S+d_qeff_dV_GP_S*qeff)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
d_COX_qm_dV_D_S = (-COX_i*qq*(deriv_pow_0_d0*((qeff*d_qeff_dV_D_S+d_qeff_dV_D_S*qeff)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
COX_qm = (COX_i/(1.0+(qq*value_pow_0)));
}
}
if ((xg<=0.0))
{

d_QG_dV_S_BP = d_Voxm_dV_S_BP;
d_QG_dV_GP_S = d_Voxm_dV_GP_S;
d_QG_dV_D_S = d_Voxm_dV_D_S;
QG = Voxm;

d_QI_dV_GP_S = d_QI_dV_D_S = d_QI_dV_S_BP =  0.0;
QI = 0.0;

d_QD_dV_GP_S = d_QD_dV_D_S = d_QD_dV_S_BP =  0.0;
QD = 0.0;

d_QB_dV_S_BP = d_QG_dV_S_BP;
d_QB_dV_GP_S = d_QG_dV_GP_S;
d_QB_dV_D_S = d_QG_dV_D_S;
QB = QG;
}
else
{

d_Fj_dV_S_BP = 0.5*((H*d_dps_dV_S_BP-dps*d_H_dV_S_BP)/H/H);
d_Fj_dV_GP_S = 0.5*((H*d_dps_dV_GP_S-dps*d_H_dV_GP_S)/H/H);
d_Fj_dV_D_S = 0.5*((H*d_dps_dV_D_S-dps*d_H_dV_D_S)/H/H);
Fj = (0.5*(dps/H));

d_Fj2_dV_S_BP = (Fj*d_Fj_dV_S_BP+d_Fj_dV_S_BP*Fj);
d_Fj2_dV_GP_S = (Fj*d_Fj_dV_GP_S+d_Fj_dV_GP_S*Fj);
d_Fj2_dV_D_S = (Fj*d_Fj_dV_D_S+d_Fj_dV_D_S*Fj);
Fj2 = (Fj*Fj);

d_QCLM_dV_S_BP = ((1.0-GdL)*(d_qim_dV_S_BP-0.5*(alpha*d_dps_dV_S_BP+d_alpha_dV_S_BP*dps))+(-d_GdL_dV_S_BP)*(qim-(0.5*(alpha*dps))));
d_QCLM_dV_D_S = ((1.0-GdL)*(d_qim_dV_D_S-0.5*(alpha*d_dps_dV_D_S+d_alpha_dV_D_S*dps))+(-d_GdL_dV_D_S)*(qim-(0.5*(alpha*dps))));
d_QCLM_dV_GP_S = ((1.0-GdL)*(d_qim_dV_GP_S-0.5*(alpha*d_dps_dV_GP_S+d_alpha_dV_GP_S*dps))+(-d_GdL_dV_GP_S)*(qim-(0.5*(alpha*dps))));
QCLM = ((1.0-GdL)*(qim-(0.5*(alpha*dps))));

d_QG_dV_S_BP = (d_Voxm_dV_S_BP+0.5*((eta_p*dps)*((Fj*d_GdL_dV_S_BP+d_Fj_dV_S_BP*GdL)*3.3333333333333333e-01+d_GdL_dV_S_BP)+(eta_p*d_dps_dV_S_BP+d_eta_p_dV_S_BP*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)));
d_QG_dV_GP_S = (d_Voxm_dV_GP_S+0.5*((eta_p*dps)*((Fj*d_GdL_dV_GP_S+d_Fj_dV_GP_S*GdL)*3.3333333333333333e-01+d_GdL_dV_GP_S)+(eta_p*d_dps_dV_GP_S+d_eta_p_dV_GP_S*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)));
d_QG_dV_D_S = (d_Voxm_dV_D_S+0.5*((eta_p*dps)*((Fj*d_GdL_dV_D_S+d_Fj_dV_D_S*GdL)*3.3333333333333333e-01+d_GdL_dV_D_S)+(eta_p*d_dps_dV_D_S+d_eta_p_dV_D_S*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)));
QG = (Voxm+(0.5*((eta_p*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))));

d_temp_dV_S_BP = (alpha*d_dps_dV_S_BP+d_alpha_dV_S_BP*dps)*1.6666666666666667e-01;
d_temp_dV_GP_S = (alpha*d_dps_dV_GP_S+d_alpha_dV_GP_S*dps)*1.6666666666666667e-01;
d_temp_dV_D_S = (alpha*d_dps_dV_D_S+d_alpha_dV_D_S*dps)*1.6666666666666667e-01;
temp = ((alpha*dps)*1.6666666666666667e-01);

d_QI_dV_S_BP = ((GdL*(d_qim_dV_S_BP+(temp*d_Fj_dV_S_BP+d_temp_dV_S_BP*Fj))+d_GdL_dV_S_BP*(qim+(temp*Fj)))+d_QCLM_dV_S_BP);
d_QI_dV_D_S = ((GdL*(d_qim_dV_D_S+(temp*d_Fj_dV_D_S+d_temp_dV_D_S*Fj))+d_GdL_dV_D_S*(qim+(temp*Fj)))+d_QCLM_dV_D_S);
d_QI_dV_GP_S = ((GdL*(d_qim_dV_GP_S+(temp*d_Fj_dV_GP_S+d_temp_dV_GP_S*Fj))+d_GdL_dV_GP_S*(qim+(temp*Fj)))+d_QCLM_dV_GP_S);
QI = ((GdL*(qim+(temp*Fj)))+QCLM);

d_QD_dV_S_BP = 0.5*(((GdL*GdL)*(d_qim_dV_S_BP-(temp*((-d_Fj_dV_S_BP)-0.2*d_Fj2_dV_S_BP)+d_temp_dV_S_BP*((1.0-Fj)-(0.2*Fj2))))+(GdL*d_GdL_dV_S_BP+d_GdL_dV_S_BP*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_dV_S_BP+d_QCLM_dV_S_BP*(1.0+GdL)));
d_QD_dV_D_S = 0.5*(((GdL*GdL)*(d_qim_dV_D_S-(temp*((-d_Fj_dV_D_S)-0.2*d_Fj2_dV_D_S)+d_temp_dV_D_S*((1.0-Fj)-(0.2*Fj2))))+(GdL*d_GdL_dV_D_S+d_GdL_dV_D_S*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_dV_D_S+d_QCLM_dV_D_S*(1.0+GdL)));
d_QD_dV_GP_S = 0.5*(((GdL*GdL)*(d_qim_dV_GP_S-(temp*((-d_Fj_dV_GP_S)-0.2*d_Fj2_dV_GP_S)+d_temp_dV_GP_S*((1.0-Fj)-(0.2*Fj2))))+(GdL*d_GdL_dV_GP_S+d_GdL_dV_GP_S*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_dV_GP_S+d_QCLM_dV_GP_S*(1.0+GdL)));
QD = (0.5*(((GdL*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL))));

d_QB_dV_S_BP = (d_QG_dV_S_BP-d_QI_dV_S_BP);
d_QB_dV_GP_S = (d_QG_dV_GP_S-d_QI_dV_GP_S);
d_QB_dV_D_S = (d_QG_dV_D_S-d_QI_dV_D_S);
QB = (QG-QI);
}

d_Qg_dV_S_BP = (QG*d_COX_qm_dV_S_BP+d_QG_dV_S_BP*COX_qm);
d_Qg_dV_GP_S = (QG*d_COX_qm_dV_GP_S+d_QG_dV_GP_S*COX_qm);
d_Qg_dV_D_S = (QG*d_COX_qm_dV_D_S+d_QG_dV_D_S*COX_qm);
Qg = (QG*COX_qm);

d_Qd_dV_S_BP = ((-QD)*d_COX_qm_dV_S_BP+(-d_QD_dV_S_BP)*COX_qm);
d_Qd_dV_D_S = ((-QD)*d_COX_qm_dV_D_S+(-d_QD_dV_D_S)*COX_qm);
d_Qd_dV_GP_S = ((-QD)*d_COX_qm_dV_GP_S+(-d_QD_dV_GP_S)*COX_qm);
Qd = ((-QD)*COX_qm);

d_Qb_dV_S_BP = ((-QB)*d_COX_qm_dV_S_BP+(-d_QB_dV_S_BP)*COX_qm);
d_Qb_dV_GP_S = ((-QB)*d_COX_qm_dV_GP_S+(-d_QB_dV_GP_S)*COX_qm);
d_Qb_dV_D_S = ((-QB)*d_COX_qm_dV_D_S+(-d_QB_dV_D_S)*COX_qm);
Qb = ((-QB)*COX_qm);

d_Qgs_ov_dV_S_BP = CGOV_i*d_Vovs_dV_S_BP;
d_Qgs_ov_dV_D_S = CGOV_i*d_Vovs_dV_D_S;
d_Qgs_ov_dV_GP_S = CGOV_i*d_Vovs_dV_GP_S;
Qgs_ov = (CGOV_i*Vovs);

d_Qgd_ov_dV_S_BP = CGOVD_i*d_Vovd_dV_S_BP;
d_Qgd_ov_dV_D_S = CGOVD_i*d_Vovd_dV_D_S;
d_Qgd_ov_dV_GP_S = CGOVD_i*d_Vovd_dV_GP_S;
Qgd_ov = (CGOVD_i*Vovd);

d_Qgb_ov_dV_S_BP = CGBOV_i*d_Vgb_dV_S_BP;
d_Qgb_ov_dV_GP_S = CGBOV_i*d_Vgb_dV_GP_S;
d_Qgb_ov_dV_D_S = CGBOV_i*d_Vgb_dV_D_S;
Qgb_ov = (CGBOV_i*Vgb);

d_Qfgs_dV_D_S = d_Qfgs_dV_S_BP =  0.0;
d_Qfgs_dV_GP_S = CFR_i*d_VgsPrime_dV_GP_S;
Qfgs = (CFR_i*VgsPrime);

d_Qfgd_dV_S_BP =  0.0;
d_Qfgd_dV_D_S = CFRD_i*d_VgdPrime_dV_D_S;
d_Qfgd_dV_GP_S = CFRD_i*d_VgdPrime_dV_GP_S;
Qfgd = (CFRD_i*VgdPrime);
}
// End block evaluateDynamic

d_ijun_s_dV_D_BD = d_ijun_s_dV_S_BS =  0.0;
ijun_s = 0.0;

d_ijunbot_s_dV_S_BS = d_ijunbot_s_dV_D_BD =  0.0;
ijunbot_s = 0.0;

d_ijunsti_s_dV_S_BS = d_ijunsti_s_dV_D_BD =  0.0;
ijunsti_s = 0.0;

d_ijungat_s_dV_S_BS = d_ijungat_s_dV_D_BD =  0.0;
ijungat_s = 0.0;

d_ijun_d_dV_D_BD = d_ijun_d_dV_S_BS =  0.0;
ijun_d = 0.0;

d_ijunbot_d_dV_D_BD = d_ijunbot_d_dV_S_BS =  0.0;
ijunbot_d = 0.0;

d_ijunsti_d_dV_D_BD = d_ijunsti_d_dV_S_BS =  0.0;
ijunsti_d = 0.0;

d_ijungat_d_dV_D_BD = d_ijungat_d_dV_S_BS =  0.0;
ijungat_d = 0.0;

d_qjun_s_dV_D_BD = d_qjun_s_dV_S_BS =  0.0;
qjun_s = 0.0;

d_qjunbot_s_dV_D_BD = d_qjunbot_s_dV_S_BS =  0.0;
qjunbot_s = 0.0;

d_qjunsti_s_dV_D_BD = d_qjunsti_s_dV_S_BS =  0.0;
qjunsti_s = 0.0;

d_qjungat_s_dV_D_BD = d_qjungat_s_dV_S_BS =  0.0;
qjungat_s = 0.0;

d_qjun_d_dV_D_BD = d_qjun_d_dV_S_BS =  0.0;
qjun_d = 0.0;

d_qjunbot_d_dV_D_BD = d_qjunbot_d_dV_S_BS =  0.0;
qjunbot_d = 0.0;

d_qjunsti_d_dV_D_BD = d_qjunsti_d_dV_S_BS =  0.0;
qjunsti_d = 0.0;

d_qjungat_d_dV_D_BD = d_qjungat_d_dV_S_BS =  0.0;
qjungat_d = 0.0;
//Begin block evaluateStaticDynamic
{
if (((model_.SWJUNCAP)>0.0))
{
if (((model_.SWJUNEXP_i)==1.0))
{

d_tm0_dV_D_BD =  0.0;
d_tm0_dV_S_BS = d_Vjun_s_dV_S_BS*(model_.phitdinv)*MFOR1_s;
tm0 = ((Vjun_s*(model_.phitdinv))*MFOR1_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_D_BD =  0.0;
d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_s)?expxhf1_s*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_s)?(expxhf1_s*((tm0-xhighf1_s)+1)):value_exp_0));
}

d_ijunfor1_dV_D_BD =  0.0;
d_ijunfor1_dV_S_BS = ISATFOR1_s*d_tm1_dV_S_BS;
ijunfor1 = (ISATFOR1_s*(tm1-1.0));

d_tm0_dV_D_BD =  0.0;
d_tm0_dV_S_BS = d_Vjun_s_dV_S_BS*(model_.phitdinv)*MFOR2_s;
tm0 = ((Vjun_s*(model_.phitdinv))*MFOR2_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_D_BD =  0.0;
d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_s)?expxhf2_s*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_s)?(expxhf2_s*((tm0-xhighf2_s)+1)):value_exp_0));
}

d_ijunfor2_dV_D_BD =  0.0;
d_ijunfor2_dV_S_BS = ISATFOR2_s*d_tm1_dV_S_BS;
ijunfor2 = (ISATFOR2_s*(tm1-1.0));

d_ijunrev_dV_D_BD = d_ijunrev_dV_S_BS =  0.0;
ijunrev = 0.0;
if ((m0flag_s>0))
{

d_ijunrev_dV_D_BD =  0.0;
d_ijunrev_dV_S_BS = (Vjun_s*d_Vjun_s_dV_S_BS*MREV_s+d_Vjun_s_dV_S_BS*(ISATREV_s+(Vjun_s*MREV_s)));
ijunrev = (Vjun_s*(ISATREV_s+(Vjun_s*MREV_s)));
}
else
{

d_tm0_dV_D_BD =  0.0;
d_tm0_dV_S_BS = (-d_Vjun_s_dV_S_BS)*(model_.phitdinv)*MREV_s;
tm0 = (((-Vjun_s)*(model_.phitdinv))*MREV_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_D_BD =  0.0;
d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_s)?expxhr_s*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_s)?(expxhr_s*((tm0-xhighr_s)+1)):value_exp_0));
}

d_ijunrev_dV_D_BD =  0.0;
d_ijunrev_dV_S_BS = (-ISATREV_s)*d_tm1_dV_S_BS;
ijunrev = ((-ISATREV_s)*(tm1-1.0));
}

d_ijun_s_dV_D_BD =  0.0;
d_ijun_s_dV_S_BS = ((d_ijunfor1_dV_S_BS+d_ijunfor2_dV_S_BS)+d_ijunrev_dV_S_BS);
ijun_s = ((ijunfor1+ijunfor2)+ijunrev);

d_tm0_dV_S_BS =  0.0;
d_tm0_dV_D_BD = d_Vjun_d_dV_D_BD*(model_.phitdinv)*MFOR1_d;
tm0 = ((Vjun_d*(model_.phitdinv))*MFOR1_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?expxhf1_d*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?expxhf1_d*d_tm0_dV_D_BD:(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf1_d)?(expxhf1_d*((tm0-xhighf1_d)+1)):value_exp_0));
}

d_ijunfor1_dV_S_BS = ISATFOR1_d*d_tm1_dV_S_BS;
d_ijunfor1_dV_D_BD = ISATFOR1_d*d_tm1_dV_D_BD;
ijunfor1 = (ISATFOR1_d*(tm1-1.0));

d_tm0_dV_S_BS =  0.0;
d_tm0_dV_D_BD = d_Vjun_d_dV_D_BD*(model_.phitdinv)*MFOR2_d;
tm0 = ((Vjun_d*(model_.phitdinv))*MFOR2_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?expxhf2_d*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?expxhf2_d*d_tm0_dV_D_BD:(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighf2_d)?(expxhf2_d*((tm0-xhighf2_d)+1)):value_exp_0));
}

d_ijunfor2_dV_S_BS = ISATFOR2_d*d_tm1_dV_S_BS;
d_ijunfor2_dV_D_BD = ISATFOR2_d*d_tm1_dV_D_BD;
ijunfor2 = (ISATFOR2_d*(tm1-1.0));

d_ijunrev_dV_D_BD = d_ijunrev_dV_S_BS =  0.0;
ijunrev = 0.0;
if ((m0flag_d>0))
{

d_ijunrev_dV_S_BS =  0.0;
d_ijunrev_dV_D_BD = (Vjun_d*d_Vjun_d_dV_D_BD*MREV_d+d_Vjun_d_dV_D_BD*(ISATREV_d+(Vjun_d*MREV_d)));
ijunrev = (Vjun_d*(ISATREV_d+(Vjun_d*MREV_d)));
}
else
{

d_tm0_dV_S_BS =  0.0;
d_tm0_dV_D_BD = (-d_Vjun_d_dV_D_BD)*(model_.phitdinv)*MREV_d;
tm0 = (((-Vjun_d)*(model_.phitdinv))*MREV_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_S_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_S_BS)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?expxhr_d*d_tm0_dV_S_BS:(deriv_exp_0_d0*(d_tm0_dV_S_BS))));
d_tm1_dV_D_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_D_BD)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?expxhr_d*d_tm0_dV_D_BD:(deriv_exp_0_d0*(d_tm0_dV_D_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>xhighr_d)?(expxhr_d*((tm0-xhighr_d)+1)):value_exp_0));
}

d_ijunrev_dV_S_BS = (-ISATREV_d)*d_tm1_dV_S_BS;
d_ijunrev_dV_D_BD = (-ISATREV_d)*d_tm1_dV_D_BD;
ijunrev = ((-ISATREV_d)*(tm1-1.0));
}

d_ijun_d_dV_S_BS = ((d_ijunfor1_dV_S_BS+d_ijunfor2_dV_S_BS)+d_ijunrev_dV_S_BS);
d_ijun_d_dV_D_BD = ((d_ijunfor1_dV_D_BD+d_ijunfor2_dV_D_BD)+d_ijunrev_dV_D_BD);
ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
//Begin block evaluateDynamic
{
//Block-local variables for block evaluateDynamic
double tmpv=0.0;
     double d_tmpv_dV_D_BD=0.0;
     double d_tmpv_dV_S_BS=0.0;
double vjv=0.0;
     double d_vjv_dV_D_BD=0.0;
     double d_vjv_dV_S_BS=0.0;
//End of Block-local variables

d_tmpv_dV_D_BD = d_tmpv_dV_S_BS =  0.0;
tmpv = 0.0;

d_vjv_dV_D_BD = d_vjv_dV_S_BS =  0.0;
vjv = 0.0;
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);

d_h2d_dV_D_BD =  0.0;
d_h2d_dV_S_BS = d_Vjun_s_dV_S_BS;
h2d = (Vjun_s+(vch_s*h2));

d_h3_dV_D_BD =  0.0;
d_h3_dV_S_BS = d_h2d_dV_S_BS;
h3 = (vfmin_s+h2d);

d_h4_dV_D_BD =  0.0;
d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_D_BD =  0.0;
d_h5_dV_S_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_S_BS+d_h4_dV_S_BS*h4)));
h5 = value_sqrt_0;
}

d_vjv_dV_D_BD =  0.0;
d_vjv_dV_S_BS = 2.0*(((h3+h5)*d_Vjun_s_dV_S_BS*vfmin_s-(Vjun_s*vfmin_s)*(d_h3_dV_S_BS+d_h5_dV_S_BS))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
if ((zflagbot_s>0.5))
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvbot))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vjv*(model_.vbiinvbot)))));

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvbot))));
tmpv = value_pow_0;
}
}

d_qjunbot_s_dV_D_BD =  0.0;
d_qjunbot_s_dV_S_BS = ((model_.qprefbot)*(-d_tmpv_dV_S_BS)+(model_.qpref2bot)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS));
qjunbot_s = (((model_.qprefbot)*(1-tmpv))+((model_.qpref2bot)*(Vjun_s-vjv)));
}
if ((zflagsti_s>0.5))
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvsti))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vjv*(model_.vbiinvsti)))));

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvsti))));
tmpv = value_pow_0;
}
}

d_qjunsti_s_dV_D_BD =  0.0;
d_qjunsti_s_dV_S_BS = ((model_.qprefsti)*(-d_tmpv_dV_S_BS)+(model_.qpref2sti)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS));
qjunsti_s = (((model_.qprefsti)*(1-tmpv))+((model_.qpref2sti)*(Vjun_s-vjv)));
}
if ((zflaggat_s>0.5))
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvgat))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vjv*(model_.vbiinvgat)))));

d_tmpv_dV_D_BD =  0.0;
d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvgat))));
tmpv = value_pow_0;
}
}

d_qjungat_s_dV_D_BD =  0.0;
d_qjungat_s_dV_S_BS = ((model_.qprefgat)*(-d_tmpv_dV_S_BS)+(model_.qpref2gat)*(d_Vjun_s_dV_S_BS-d_vjv_dV_S_BS));
qjungat_s = (((model_.qprefgat)*(1-tmpv))+((model_.qpref2gat)*(Vjun_s-vjv)));
}

d_tmpv_dV_D_BD = d_tmpv_dV_S_BS =  0.0;
tmpv = 0.0;

d_vjv_dV_D_BD = d_vjv_dV_S_BS =  0.0;
vjv = 0.0;
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);

d_h2d_dV_S_BS =  0.0;
d_h2d_dV_D_BD = d_Vjun_d_dV_D_BD;
h2d = (Vjun_d+(vch_d*h2));

d_h3_dV_S_BS = d_h2d_dV_S_BS;
d_h3_dV_D_BD = d_h2d_dV_D_BD;
h3 = (vfmin_d+h2d);

d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_S_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_S_BS+d_h4_dV_S_BS*h4)));
d_h5_dV_D_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_D_BD+d_h4_dV_D_BD*h4)));
h5 = value_sqrt_0;
}

d_vjv_dV_S_BS = 2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_S_BS+d_h5_dV_S_BS)/(h3+h5)/(h3+h5));
d_vjv_dV_D_BD = 2.0*(((h3+h5)*d_Vjun_d_dV_D_BD*vfmin_d-(Vjun_d*vfmin_d)*(d_h3_dV_D_BD+d_h5_dV_D_BD))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
if ((zflagbot_d>0.5))
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvbot_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvbot_d))));
d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvbot_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1-(vjv*(model_.vbiinvbot_d)))));

d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvbot_d))));
d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvbot_d))));
tmpv = value_pow_0;
}
}

d_qjunbot_d_dV_S_BS = ((model_.qprefbot_d)*(-d_tmpv_dV_S_BS)+(model_.qpref2bot_d)*(-d_vjv_dV_S_BS));
d_qjunbot_d_dV_D_BD = ((model_.qprefbot_d)*(-d_tmpv_dV_D_BD)+(model_.qpref2bot_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD));
qjunbot_d = (((model_.qprefbot_d)*(1-tmpv))+((model_.qpref2bot_d)*(Vjun_d-vjv)));
}
if ((zflagsti_d>0.5))
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvsti_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvsti_d))));
d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvsti_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1-(vjv*(model_.vbiinvsti_d)))));

d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvsti_d))));
d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvsti_d))));
tmpv = value_pow_0;
}
}

d_qjunsti_d_dV_S_BS = ((model_.qprefsti_d)*(-d_tmpv_dV_S_BS)+(model_.qpref2sti_d)*(-d_vjv_dV_S_BS));
d_qjunsti_d_dV_D_BD = ((model_.qprefsti_d)*(-d_tmpv_dV_D_BD)+(model_.qpref2sti_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD));
qjunsti_d = (((model_.qprefsti_d)*(1-tmpv))+((model_.qpref2sti_d)*(Vjun_d-vjv)));
}
if ((zflaggat_d>0.5))
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*(model_.vbiinvgat_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_S_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvgat_d))));
d_tmpv_dV_D_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvgat_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1-(vjv*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1-(vjv*(model_.vbiinvgat_d)))));

d_tmpv_dV_S_BS = (deriv_pow_0_d0*((-d_vjv_dV_S_BS*(model_.vbiinvgat_d))));
d_tmpv_dV_D_BD = (deriv_pow_0_d0*((-d_vjv_dV_D_BD*(model_.vbiinvgat_d))));
tmpv = value_pow_0;
}
}

d_qjungat_d_dV_S_BS = ((model_.qprefgat_d)*(-d_tmpv_dV_S_BS)+(model_.qpref2gat_d)*(-d_vjv_dV_S_BS));
d_qjungat_d_dV_D_BD = ((model_.qprefgat_d)*(-d_tmpv_dV_D_BD)+(model_.qpref2gat_d)*(d_Vjun_d_dV_D_BD-d_vjv_dV_D_BD));
qjungat_d = (((model_.qprefgat_d)*(1-tmpv))+((model_.qpref2gat_d)*(Vjun_d-vjv)));
}
}
// End block evaluateDynamic
}
else
{

d_vbbt_dV_D_BD = d_vbbt_dV_S_BS =  0.0;
vbbt = 0.0;

d_two_psistar_dV_D_BD = d_two_psistar_dV_S_BS =  0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0)&&(LSSOURCE_i==0))&&(LGSOURCE_i==0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);

d_h2d_dV_D_BD =  0.0;
d_h2d_dV_S_BS = d_Vjun_s_dV_S_BS;
h2d = (Vjun_s+(vch_s*h2));

d_h3_dV_S_BS = d_h2d_dV_S_BS;
d_h3_dV_D_BD = d_h2d_dV_D_BD;
h3 = (vfmin_s+h2d);

d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_S_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_S_BS+d_h4_dV_S_BS*h4)));
d_h5_dV_D_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_D_BD+d_h4_dV_D_BD*h4)));
h5 = value_sqrt_0;
}

d_vj_dV_D_BD = 2.0*(-(Vjun_s*vfmin_s)*(d_h3_dV_D_BD+d_h5_dV_D_BD)/(h3+h5)/(h3+h5));
d_vj_dV_S_BS = 2.0*(((h3+h5)*d_Vjun_s_dV_S_BS*vfmin_s-(Vjun_s*vfmin_s)*(d_h3_dV_S_BS+d_h5_dV_S_BS))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
if ((Vjun_s<VMAX_s))
{
if ((fabs((0.5*(Vjun_s*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_s*(model_.phitdinv))));
double  deriv_exp_0_d0 = value_exp_0;

d_zinv_dV_D_BD =  0.0;
d_zinv_dV_S_BS = (deriv_exp_0_d0*(0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv)));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_s*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{

d_zinv_dV_D_BD =  0.0;
d_zinv_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(-0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv))*3.3333333333333333e-01+(-0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))+(-0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{

d_zinv_dV_D_BD =  0.0;
d_zinv_dV_S_BS = 1.0e100*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv)*3.3333333333333333e-01+0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*d_Vjun_s_dV_S_BS*(model_.phitdinv)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_idmult_dV_D_BD =  0.0;
d_idmult_dV_S_BS = (zinv*d_zinv_dV_S_BS+d_zinv_dV_S_BS*zinv);
idmult = (zinv*zinv);
}
else
{

d_idmult_dV_D_BD =  0.0;
d_idmult_dV_S_BS = d_Vjun_s_dV_S_BS*(model_.phitdinv)*exp_VMAX_over_phitd_s;
idmult = ((1+((Vjun_s-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zinv_dV_D_BD =  0.0;
d_zinv_dV_S_BS = (deriv_sqrt_0_d0*(d_idmult_dV_S_BS));
zinv = value_sqrt_0;
}
}

d_idmult_dV_D_BD =  0.0;
idmult = (idmult-1.0);

d_z_dV_D_BD =  0.0;
d_z_dV_S_BS = (-1*d_zinv_dV_S_BS/zinv/zinv);
z = (1/zinv);
if ((Vjun_s>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

d_two_psistar_dV_D_BD =  0.0;
d_two_psistar_dV_S_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_S_BS+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_S_BS+d_z_dV_S_BS*(z+3.0)))))));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));

d_two_psistar_dV_D_BD =  0.0;
d_two_psistar_dV_S_BS = ((-d_Vjun_s_dV_S_BS)+2.0*(model_.phitd)*(deriv_log_1_d0*((2*d_zinv_dV_S_BS+(deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dV_S_BS+d_zinv_dV_S_BS*(1+(3*zinv)))))))));
two_psistar = ((-Vjun_s)+(2.0*((model_.phitd)*value_log_1)));
}
}

d_vjlim_dV_D_BD =  0.0;
d_vjlim_dV_S_BS = (-d_two_psistar_dV_S_BS);
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4*(model_.phitd))*(model_.phitd))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vjsrh_dV_D_BD =  0.0;
d_vjsrh_dV_S_BS = 0.5*((d_Vjun_s_dV_S_BS+d_vjlim_dV_S_BS)-(deriv_sqrt_0_d0*(((Vjun_s-vjlim)*(d_Vjun_s_dV_S_BS-d_vjlim_dV_S_BS)+(d_Vjun_s_dV_S_BS-d_vjlim_dV_S_BS)*(Vjun_s-vjlim)))));
vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s-vbbtlim_s)*(Vjun_s-vbbtlim_s))+((4*(model_.phitr))*(model_.phitr))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vbbt_dV_D_BD =  0.0;
d_vbbt_dV_S_BS = 0.5*(d_Vjun_s_dV_S_BS-(deriv_sqrt_0_d0*(((Vjun_s-vbbtlim_s)*d_Vjun_s_dV_S_BS+d_Vjun_s_dV_S_BS*(Vjun_s-vbbtlim_s)))));
vbbt = (0.5*((Vjun_s+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vav_dV_D_BD =  0.0;
d_vav_dV_S_BS = 0.5*(d_Vjun_s_dV_S_BS-(deriv_sqrt_0_d0*(((Vjun_s)*d_Vjun_s_dV_S_BS+d_Vjun_s_dV_S_BS*(Vjun_s)))));
vav = (0.5*(Vjun_s-value_sqrt_0));
}
}
if ((ABSOURCE_i==0))
{

d_ijunbot_s_dV_S_BS = d_ijunbot_s_dV_D_BD =  0.0;
ijunbot_s = 0;

d_qjunbot_s_dV_D_BD = d_qjunbot_s_dV_S_BS =  0.0;
qjunbot_s = 0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvbot))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1-(vj*(model_.vbiinvbot)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvbot))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvbot))));
tmp = value_pow_0;
}
}

d_qjunbot_s_dV_D_BD = ((model_.qprefbot)*(-d_tmp_dV_D_BD)+(model_.qpref2bot)*(-d_vj_dV_D_BD));
d_qjunbot_s_dV_S_BS = ((model_.qprefbot)*(-d_tmp_dV_S_BS)+(model_.qpref2bot)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS));
qjunbot_s = (((model_.qprefbot)*(1-tmp))+((model_.qpref2bot)*(Vjun_s-vj)));

d_id_dV_D_BD =  0.0;
d_id_dV_S_BS = (model_.idsatbot)*d_idmult_dV_S_BS;
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0)&&((model_.CTATBOT_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_D_BD =  0.0;
d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_D_BD =  0.0;
d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_D_BD =  0.0;
d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOT_i))));
}
}

d_wsrh_dV_D_BD =  0.0;
d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrbot)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrbot)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrbot)*tmp);

d_asrh_dV_D_BD = (model_.ftdbot)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
d_asrh_dV_S_BS = (model_.ftdbot)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
asrh = ((model_.ftdbot)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHBOT_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHBOT_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartbot)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PBOT)-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartbot)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PBOT)-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatbot)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatbot)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatbot)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatbot)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatbot)*d_erfctimesexpmtat_dV_D_BD-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatbot)*d_erfctimesexpmtat_dV_S_BS-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATBOT_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATBOT_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PBOT)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvbot)-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_D_BD)/tmp/tmp);
d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PBOT)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvbot)-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_S_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_D_BD = (model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD+Vjun_s*d_Fmaxr_dV_D_BD*Fmaxr)*tmp);
d_ibbt_dV_S_BS = (model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS+(Vjun_s*d_Fmaxr_dV_S_BS+d_Vjun_s_dV_S_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvbot)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvbot)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvbot)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvbot)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOT_i)/value_fabs_0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvbot)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_D_BD =  0.0;
d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopebot);
fbreakdown = ((model_.fstopbot)+((vav+(0.999*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_s_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
d_ijunbot_s_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0))
{

d_ijunsti_s_dV_S_BS = d_ijunsti_s_dV_D_BD =  0.0;
ijunsti_s = 0;

d_qjunsti_s_dV_D_BD = d_qjunsti_s_dV_S_BS =  0.0;
qjunsti_s = 0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvsti))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1-(vj*(model_.vbiinvsti)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvsti))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvsti))));
tmp = value_pow_0;
}
}

d_qjunsti_s_dV_D_BD = ((model_.qprefsti)*(-d_tmp_dV_D_BD)+(model_.qpref2sti)*(-d_vj_dV_D_BD));
d_qjunsti_s_dV_S_BS = ((model_.qprefsti)*(-d_tmp_dV_S_BS)+(model_.qpref2sti)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS));
qjunsti_s = (((model_.qprefsti)*(1-tmp))+((model_.qpref2sti)*(Vjun_s-vj)));

d_id_dV_D_BD =  0.0;
d_id_dV_S_BS = (model_.idsatsti)*d_idmult_dV_S_BS;
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0)&&((model_.CTATSTI_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_D_BD =  0.0;
d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_D_BD =  0.0;
d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_D_BD =  0.0;
d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTI_i))));
}
}

d_wsrh_dV_D_BD =  0.0;
d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrsti)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrsti)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrsti)*tmp);

d_asrh_dV_D_BD = (model_.ftdsti)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
d_asrh_dV_S_BS = (model_.ftdsti)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
asrh = ((model_.ftdsti)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHSTI_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHSTI_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartsti)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PSTI)-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartsti)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PSTI)-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatsti)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatsti)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatsti)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatsti)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatsti)*d_erfctimesexpmtat_dV_D_BD-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatsti)*d_erfctimesexpmtat_dV_S_BS-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATSTI_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATSTI_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PSTI)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvsti)-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_D_BD)/tmp/tmp);
d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PSTI)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvsti)-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_S_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_D_BD = (model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD+Vjun_s*d_Fmaxr_dV_D_BD*Fmaxr)*tmp);
d_ibbt_dV_S_BS = (model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS+(Vjun_s*d_Fmaxr_dV_S_BS+d_Vjun_s_dV_S_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvsti)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvsti)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvsti)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvsti)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTI_i)/value_fabs_0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvsti)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_D_BD =  0.0;
d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopesti);
fbreakdown = ((model_.fstopsti)+((vav+(0.999*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_s_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
d_ijunsti_s_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0))
{

d_ijungat_s_dV_S_BS = d_ijungat_s_dV_D_BD =  0.0;
ijungat_s = 0;

d_qjungat_s_dV_D_BD = d_qjungat_s_dV_S_BS =  0.0;
qjungat_s = 0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvgat))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1-(vj*(model_.vbiinvgat)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvgat))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvgat))));
tmp = value_pow_0;
}
}

d_qjungat_s_dV_D_BD = ((model_.qprefgat)*(-d_tmp_dV_D_BD)+(model_.qpref2gat)*(-d_vj_dV_D_BD));
d_qjungat_s_dV_S_BS = ((model_.qprefgat)*(-d_tmp_dV_S_BS)+(model_.qpref2gat)*(d_Vjun_s_dV_S_BS-d_vj_dV_S_BS));
qjungat_s = (((model_.qprefgat)*(1-tmp))+((model_.qpref2gat)*(Vjun_s-vj)));

d_id_dV_D_BD =  0.0;
d_id_dV_S_BS = (model_.idsatgat)*d_idmult_dV_S_BS;
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0)&&((model_.CTATGAT_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_D_BD =  0.0;
d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_D_BD =  0.0;
d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_D_BD =  0.0;
d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGAT_i))));
}
}

d_wsrh_dV_D_BD =  0.0;
d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrgat)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrgat)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrgat)*tmp);

d_asrh_dV_D_BD = (model_.ftdgat)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
d_asrh_dV_S_BS = (model_.ftdgat)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
asrh = ((model_.ftdgat)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHGAT_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHGAT_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartgat)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PGAT)-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartgat)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PGAT)-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatgat)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatgat)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatgat)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatgat)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatgat)*d_erfctimesexpmtat_dV_D_BD-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatgat)*d_erfctimesexpmtat_dV_S_BS-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATGAT_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATGAT_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv))));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PGAT)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvgat)-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_D_BD)/tmp/tmp);
d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PGAT)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvgat)-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_S_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_D_BD = (model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_D_BD+Vjun_s*d_Fmaxr_dV_D_BD*Fmaxr)*tmp);
d_ibbt_dV_S_BS = (model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_S_BS+(Vjun_s*d_Fmaxr_dV_S_BS+d_Vjun_s_dV_S_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvgat)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvgat)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvgat)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvgat)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGAT_i)/value_fabs_0));

d_tmp_dV_D_BD =  0.0;
d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvgat)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_D_BD =  0.0;
d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopegat);
fbreakdown = ((model_.fstopgat)+((vav+(0.999*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_s_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
d_ijungat_s_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}

d_ijun_s_dV_D_BD = ((ABSOURCE_i*d_ijunbot_s_dV_D_BD+LSSOURCE_i*d_ijunsti_s_dV_D_BD)+LGSOURCE_i*d_ijungat_s_dV_D_BD);
d_ijun_s_dV_S_BS = ((ABSOURCE_i*d_ijunbot_s_dV_S_BS+LSSOURCE_i*d_ijunsti_s_dV_S_BS)+LGSOURCE_i*d_ijungat_s_dV_S_BS);
ijun_s = (((ABSOURCE_i*ijunbot_s)+(LSSOURCE_i*ijunsti_s))+(LGSOURCE_i*ijungat_s));

d_vbbt_dV_D_BD = d_vbbt_dV_S_BS =  0.0;
vbbt = 0.0;

d_two_psistar_dV_D_BD = d_two_psistar_dV_S_BS =  0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0)&&(LSDRAIN_i==0))&&(LGDRAIN_i==0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);

d_h2d_dV_S_BS =  0.0;
d_h2d_dV_D_BD = d_Vjun_d_dV_D_BD;
h2d = (Vjun_d+(vch_d*h2));

d_h3_dV_S_BS = d_h2d_dV_S_BS;
d_h3_dV_D_BD = d_h2d_dV_D_BD;
h3 = (vfmin_d+h2d);

d_h4_dV_S_BS = (-d_h2d_dV_S_BS);
d_h4_dV_D_BD = (-d_h2d_dV_D_BD);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_S_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_S_BS+d_h4_dV_S_BS*h4)));
d_h5_dV_D_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_D_BD+d_h4_dV_D_BD*h4)));
h5 = value_sqrt_0;
}

d_vj_dV_S_BS = 2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_S_BS+d_h5_dV_S_BS)/(h3+h5)/(h3+h5));
d_vj_dV_D_BD = 2.0*(((h3+h5)*d_Vjun_d_dV_D_BD*vfmin_d-(Vjun_d*vfmin_d)*(d_h3_dV_D_BD+d_h5_dV_D_BD))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
if ((Vjun_d<VMAX_d))
{
if ((fabs((0.5*(Vjun_d*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_d*(model_.phitdinv))));
double  deriv_exp_0_d0 = value_exp_0;

d_zinv_dV_S_BS =  0.0;
d_zinv_dV_D_BD = (deriv_exp_0_d0*(0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv)));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_d*(model_.phitdinv)))<(-2.3025850929940458e+02)))
{

d_zinv_dV_S_BS =  0.0;
d_zinv_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(-0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv))*3.3333333333333333e-01+(-0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))+(-0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{

d_zinv_dV_S_BS =  0.0;
d_zinv_dV_D_BD = 1.0e100*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv)*3.3333333333333333e-01+0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*d_Vjun_d_dV_D_BD*(model_.phitdinv)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_idmult_dV_S_BS = (zinv*d_zinv_dV_S_BS+d_zinv_dV_S_BS*zinv);
d_idmult_dV_D_BD = (zinv*d_zinv_dV_D_BD+d_zinv_dV_D_BD*zinv);
idmult = (zinv*zinv);
}
else
{

d_idmult_dV_S_BS =  0.0;
d_idmult_dV_D_BD = d_Vjun_d_dV_D_BD*(model_.phitdinv)*exp_VMAX_over_phitd_d;
idmult = ((1+((Vjun_d-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zinv_dV_S_BS = (deriv_sqrt_0_d0*(d_idmult_dV_S_BS));
d_zinv_dV_D_BD = (deriv_sqrt_0_d0*(d_idmult_dV_D_BD));
zinv = value_sqrt_0;
}
}

idmult = (idmult-1.0);

d_z_dV_S_BS = (-1*d_zinv_dV_S_BS/zinv/zinv);
d_z_dV_D_BD = (-1*d_zinv_dV_D_BD/zinv/zinv);
z = (1/zinv);
if ((Vjun_d>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

d_two_psistar_dV_S_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_S_BS+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_S_BS+d_z_dV_S_BS*(z+3.0)))))));
d_two_psistar_dV_D_BD = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_D_BD+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_D_BD+d_z_dV_D_BD*(z+3.0)))))));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));

d_two_psistar_dV_S_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((2*d_zinv_dV_S_BS+(deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dV_S_BS+d_zinv_dV_S_BS*(1+(3*zinv))))))));
d_two_psistar_dV_D_BD = ((-d_Vjun_d_dV_D_BD)+2.0*(model_.phitd)*(deriv_log_1_d0*((2*d_zinv_dV_D_BD+(deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dV_D_BD+d_zinv_dV_D_BD*(1+(3*zinv)))))))));
two_psistar = ((-Vjun_d)+(2.0*((model_.phitd)*value_log_1)));
}
}

d_vjlim_dV_S_BS = (-d_two_psistar_dV_S_BS);
d_vjlim_dV_D_BD = (-d_two_psistar_dV_D_BD);
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4*(model_.phitd))*(model_.phitd))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vjsrh_dV_S_BS = 0.5*(d_vjlim_dV_S_BS-(deriv_sqrt_0_d0*(((Vjun_d-vjlim)*(-d_vjlim_dV_S_BS)+(-d_vjlim_dV_S_BS)*(Vjun_d-vjlim)))));
d_vjsrh_dV_D_BD = 0.5*((d_Vjun_d_dV_D_BD+d_vjlim_dV_D_BD)-(deriv_sqrt_0_d0*(((Vjun_d-vjlim)*(d_Vjun_d_dV_D_BD-d_vjlim_dV_D_BD)+(d_Vjun_d_dV_D_BD-d_vjlim_dV_D_BD)*(Vjun_d-vjlim)))));
vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d-vbbtlim_d)*(Vjun_d-vbbtlim_d))+((4*(model_.phitr))*(model_.phitr))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vbbt_dV_S_BS =  0.0;
d_vbbt_dV_D_BD = 0.5*(d_Vjun_d_dV_D_BD-(deriv_sqrt_0_d0*(((Vjun_d-vbbtlim_d)*d_Vjun_d_dV_D_BD+d_Vjun_d_dV_D_BD*(Vjun_d-vbbtlim_d)))));
vbbt = (0.5*((Vjun_d+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vav_dV_S_BS =  0.0;
d_vav_dV_D_BD = 0.5*(d_Vjun_d_dV_D_BD-(deriv_sqrt_0_d0*(((Vjun_d)*d_Vjun_d_dV_D_BD+d_Vjun_d_dV_D_BD*(Vjun_d)))));
vav = (0.5*(Vjun_d-value_sqrt_0));
}
}
if ((ABDRAIN_i==0))
{

d_ijunbot_d_dV_D_BD = d_ijunbot_d_dV_S_BS =  0.0;
ijunbot_d = 0;

d_qjunbot_d_dV_D_BD = d_qjunbot_d_dV_S_BS =  0.0;
qjunbot_d = 0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvbot_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvbot_d))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1-(vj*(model_.vbiinvbot_d)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvbot_d))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvbot_d))));
tmp = value_pow_0;
}
}

d_qjunbot_d_dV_D_BD = ((model_.qprefbot_d)*(-d_tmp_dV_D_BD)+(model_.qpref2bot_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD));
d_qjunbot_d_dV_S_BS = ((model_.qprefbot_d)*(-d_tmp_dV_S_BS)+(model_.qpref2bot_d)*(-d_vj_dV_S_BS));
qjunbot_d = (((model_.qprefbot_d)*(1-tmp))+((model_.qpref2bot_d)*(Vjun_d-vj)));

d_id_dV_S_BS = (model_.idsatbot_d)*d_idmult_dV_S_BS;
d_id_dV_D_BD = (model_.idsatbot_d)*d_idmult_dV_D_BD;
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0)&&((model_.CTATBOTD_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PBOTD_i)));
d_dwsrh_dV_D_BD = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD))+(wsrhstep*d_wsrhstep_dV_D_BD+d_wsrhstep_dV_D_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PBOTD_i))));
}
}

d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRBOTinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRBOTinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrbot_d)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrbot_d)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrbot_d)*tmp);

d_asrh_dV_S_BS = (model_.ftdbot_d)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
d_asrh_dV_D_BD = (model_.ftdbot_d)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
asrh = ((model_.ftdbot_d)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHBOTD_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHBOTD_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartbot_d)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PBOT_d)-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartbot_d)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PBOT_d)-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatbot_d)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatbot_d)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatbot_d)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatbot_d)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatbot_d)*d_erfctimesexpmtat_dV_D_BD-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatbot_d)*d_erfctimesexpmtat_dV_S_BS-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATBOTD_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATBOTD_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
double  deriv_pow_0_d0 = (((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRBOTinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRBOTinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PBOT_d)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvbot_d)-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_S_BS)/tmp/tmp);
d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PBOT_d)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvbot_d)-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_D_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_S_BS = (model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS+Vjun_d*d_Fmaxr_dV_S_BS*Fmaxr)*tmp);
d_ibbt_dV_D_BD = (model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD+(Vjun_d*d_Fmaxr_dV_D_BD+d_Vjun_d_dV_D_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvbot_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvbot_d)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));

d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvbot_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvbot_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvbot_d)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvbot_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
d_tmp_dV_D_BD = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_D_BD*(model_.VBRinvbot_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_D_BD*(model_.VBRinvbot_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_D_BD*(model_.VBRinvbot_d)))+(deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvbot_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOTD_i)/value_fabs_0));

d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvbot_d)))));
d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvbot_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopebot_d);
d_fbreakdown_dV_D_BD = d_vav_dV_D_BD*(model_.slopebot_d);
fbreakdown = ((model_.fstopbot_d)+((vav+(0.999*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}

d_ijunbot_d_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
d_ijunbot_d_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0))
{

d_ijunsti_d_dV_D_BD = d_ijunsti_d_dV_S_BS =  0.0;
ijunsti_d = 0;

d_qjunsti_d_dV_D_BD = d_qjunsti_d_dV_S_BS =  0.0;
qjunsti_d = 0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvsti_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvsti_d))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1-(vj*(model_.vbiinvsti_d)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvsti_d))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvsti_d))));
tmp = value_pow_0;
}
}

d_qjunsti_d_dV_D_BD = ((model_.qprefsti_d)*(-d_tmp_dV_D_BD)+(model_.qpref2sti_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD));
d_qjunsti_d_dV_S_BS = ((model_.qprefsti_d)*(-d_tmp_dV_S_BS)+(model_.qpref2sti_d)*(-d_vj_dV_S_BS));
qjunsti_d = (((model_.qprefsti_d)*(1-tmp))+((model_.qpref2sti_d)*(Vjun_d-vj)));

d_id_dV_S_BS = (model_.idsatsti_d)*d_idmult_dV_S_BS;
d_id_dV_D_BD = (model_.idsatsti_d)*d_idmult_dV_D_BD;
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0)&&((model_.CTATSTID_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PSTID_i)));
d_dwsrh_dV_D_BD = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD))+(wsrhstep*d_wsrhstep_dV_D_BD+d_wsrhstep_dV_D_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PSTID_i))));
}
}

d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRSTIinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRSTIinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrsti_d)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrsti_d)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrsti_d)*tmp);

d_asrh_dV_S_BS = (model_.ftdsti_d)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
d_asrh_dV_D_BD = (model_.ftdsti_d)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
asrh = ((model_.ftdsti_d)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHSTID_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHSTID_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartsti_d)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PSTI_d)-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartsti_d)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PSTI_d)-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatsti_d)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatsti_d)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatsti_d)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatsti_d)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatsti_d)*d_erfctimesexpmtat_dV_D_BD-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatsti_d)*d_erfctimesexpmtat_dV_S_BS-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATSTID_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATSTID_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
double  deriv_pow_0_d0 = (((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRSTIinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRSTIinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PSTI_d)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvsti_d)-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_S_BS)/tmp/tmp);
d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PSTI_d)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvsti_d)-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_D_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_S_BS = (model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS+Vjun_d*d_Fmaxr_dV_S_BS*Fmaxr)*tmp);
d_ibbt_dV_D_BD = (model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD+(Vjun_d*d_Fmaxr_dV_D_BD+d_Vjun_d_dV_D_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvsti_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvsti_d)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));

d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvsti_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvsti_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvsti_d)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvsti_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
d_tmp_dV_D_BD = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_D_BD*(model_.VBRinvsti_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_D_BD*(model_.VBRinvsti_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_D_BD*(model_.VBRinvsti_d)))+(deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvsti_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTID_i)/value_fabs_0));

d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvsti_d)))));
d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvsti_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopesti_d);
d_fbreakdown_dV_D_BD = d_vav_dV_D_BD*(model_.slopesti_d);
fbreakdown = ((model_.fstopsti_d)+((vav+(0.999*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}

d_ijunsti_d_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
d_ijunsti_d_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0))
{

d_ijungat_d_dV_D_BD = d_ijungat_d_dV_S_BS =  0.0;
ijungat_d = 0;

d_qjungat_d_dV_D_BD = d_qjungat_d_dV_S_BS =  0.0;
qjungat_d = 0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*(model_.vbiinvgat_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvgat_d))));
d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1-(vj*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1-(vj*(model_.vbiinvgat_d)))));

d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vj_dV_D_BD*(model_.vbiinvgat_d))));
d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vj_dV_S_BS*(model_.vbiinvgat_d))));
tmp = value_pow_0;
}
}

d_qjungat_d_dV_D_BD = ((model_.qprefgat_d)*(-d_tmp_dV_D_BD)+(model_.qpref2gat_d)*(d_Vjun_d_dV_D_BD-d_vj_dV_D_BD));
d_qjungat_d_dV_S_BS = ((model_.qprefgat_d)*(-d_tmp_dV_S_BS)+(model_.qpref2gat_d)*(-d_vj_dV_S_BS));
qjungat_d = (((model_.qprefgat_d)*(1-tmp))+((model_.qpref2gat_d)*(Vjun_d-vj)));

d_id_dV_S_BS = (model_.idsatgat_d)*d_idmult_dV_S_BS;
d_id_dV_D_BD = (model_.idsatgat_d)*d_idmult_dV_D_BD;
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0)&&((model_.CTATGATD_i)==0)))
{

d_isrh_dV_S_BS = d_isrh_dV_D_BD =  0.0;
isrh = 0;
}
else
{

d_vbi_minus_vjsrh_dV_S_BS = (-d_vjsrh_dV_S_BS);
d_vbi_minus_vjsrh_dV_D_BD = (-d_vjsrh_dV_D_BD);
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_S_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_S_BS-two_psistar*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_D_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_D_BD-two_psistar*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{

d_dwsrh_dV_D_BD = d_dwsrh_dV_S_BS =  0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_S_BS = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_S_BS))+(wsrhstep*d_wsrhstep_dV_S_BS+d_wsrhstep_dV_S_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_S_BS))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_S_BS)*(1-(2*(model_.PGATD_i)));
d_dwsrh_dV_D_BD = ((((1-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_D_BD))+(wsrhstep*d_wsrhstep_dV_D_BD+d_wsrhstep_dV_D_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_D_BD))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dV_D_BD)*(1-(2*(model_.PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*(model_.PGATD_i))));
}
}

d_wsrh_dV_S_BS = (d_wsrhstep_dV_S_BS+d_dwsrh_dV_S_BS);
d_wsrh_dV_D_BD = (d_wsrhstep_dV_D_BD+d_dwsrh_dV_D_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_S_BS*(model_.VBIRGATinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_D_BD*(model_.VBIRGATinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_D_BD = (model_.wdepnulrgat_d)*d_tmp_dV_D_BD;
d_wdep_dV_S_BS = (model_.wdepnulrgat_d)*d_tmp_dV_S_BS;
wdep = ((model_.wdepnulrgat_d)*tmp);

d_asrh_dV_S_BS = (model_.ftdgat_d)*((zinv-1)*d_wdep_dV_S_BS+d_zinv_dV_S_BS*wdep);
d_asrh_dV_D_BD = (model_.ftdgat_d)*((zinv-1)*d_wdep_dV_D_BD+d_zinv_dV_D_BD*wdep);
asrh = ((model_.ftdgat_d)*((zinv-1)*wdep));

d_isrh_dV_D_BD = (model_.CSRHGATD_i)*(asrh*d_wsrh_dV_D_BD+d_asrh_dV_D_BD*wsrh);
d_isrh_dV_S_BS = (model_.CSRHGATD_i)*(asrh*d_wsrh_dV_S_BS+d_asrh_dV_S_BS*wsrh);
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0))
{

d_itat_dV_S_BS = d_itat_dV_D_BD =  0.0;
itat = 0;
}
else
{

d_btat_dV_D_BD = (model_.btatpartgat_d)*((vbi_minus_vjsrh*d_wdep_dV_D_BD*(model_.one_minus_PGAT_d)-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_D_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_S_BS = (model_.btatpartgat_d)*((vbi_minus_vjsrh*d_wdep_dV_S_BS*(model_.one_minus_PGAT_d)-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_S_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_D_BD = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_D_BD/btat/btat);
d_twoatatoverthreebtat_dV_S_BS = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_S_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);

d_umaxbeforelimiting_dV_D_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_S_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_D_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_D_BD+d_umaxbeforelimiting_dV_D_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
d_umax_dV_S_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_S_BS+d_umaxbeforelimiting_dV_S_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_D_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_D_BD))));
d_sqrtumax_dV_S_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_S_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_D_BD = (umax*d_sqrtumax_dV_D_BD+d_umax_dV_D_BD*sqrtumax);
d_umaxpoweronepointfive_dV_S_BS = (umax*d_sqrtumax_dV_S_BS+d_umax_dV_S_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1)))
{

d_wgamma_dV_D_BD = (-1*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (-1*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))/(1+(btat*umaxpoweronepointfive))));

d_wgamma_dV_D_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive)));
d_wgamma_dV_S_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_S_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_S_BS+d_wsrh_dV_S_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_S_BS+d_wgamma_dV_S_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_D_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_D_BD+d_wsrh_dV_D_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_D_BD+d_wgamma_dV_D_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_D_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_D_BD-btat*d_sqrtumax_dV_D_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_S_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_S_BS-btat*d_sqrtumax_dV_S_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_D_BD = (2*(twoatatoverthreebtat*d_sqrtumax_dV_D_BD+d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-d_umax_dV_D_BD);
d_ltat_dV_S_BS = (2*(twoatatoverthreebtat*d_sqrtumax_dV_S_BS+d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-d_umax_dV_S_BS);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_D_BD = (((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_D_BD+(model_.atatgat_d)*d_twoatatoverthreebtat_dV_D_BD*sqrtumax)-(model_.atatgat_d)*d_umax_dV_D_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_D_BD+d_btat_dV_D_BD*umaxpoweronepointfive));
d_mtat_dV_S_BS = (((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_S_BS+(model_.atatgat_d)*d_twoatatoverthreebtat_dV_S_BS*sqrtumax)-(model_.atatgat_d)*d_umax_dV_S_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_S_BS+d_btat_dV_S_BS*umaxpoweronepointfive));
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_D_BD = ((ltat-1)*d_ktat_dV_D_BD+d_ltat_dV_D_BD*ktat);
d_xerfc_dV_S_BS = ((ltat-1)*d_ktat_dV_S_BS+d_ltat_dV_S_BS*ktat);
xerfc = ((ltat-1)*ktat);

d_ysq_dV_D_BD = (xerfc*d_xerfc_dV_D_BD+d_xerfc_dV_D_BD*xerfc);
d_ysq_dV_S_BS = (xerfc*d_xerfc_dV_S_BS+d_xerfc_dV_S_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{

d_terfc_dV_D_BD = (-1*(model_.perfc)*d_xerfc_dV_D_BD/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(model_.perfc)*d_xerfc_dV_S_BS/(1+((model_.perfc)*xerfc))/(1+((model_.perfc)*xerfc)));
terfc = (1/(1+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_D_BD = (-1*(-(model_.perfc)*d_xerfc_dV_D_BD)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
d_terfc_dV_S_BS = (-1*(-(model_.perfc)*d_xerfc_dV_S_BS)/(1-((model_.perfc)*xerfc))/(1-((model_.perfc)*xerfc)));
terfc = (1/(1-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_D_BD)+d_mtat_dV_D_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_S_BS)+d_mtat_dV_S_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_D_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_D_BD+((0.29214664*d_terfc_dV_D_BD+(model_.berfc)*(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_D_BD+(terfc*d_terfc_dV_D_BD+d_terfc_dV_D_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_S_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_S_BS+((0.29214664*d_terfc_dV_S_BS+(model_.berfc)*(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_S_BS+(terfc*d_terfc_dV_S_BS+d_terfc_dV_S_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{

d_erfctimesexpmtat_dV_D_BD = d_erfcpos_dV_D_BD;
d_erfctimesexpmtat_dV_S_BS = d_erfcpos_dV_S_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*(d_mtat_dV_D_BD));
d_tmp_dV_S_BS = (deriv_exp_0_d0*(d_mtat_dV_S_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_D_BD)*3.3333333333333333e-01+(-d_mtat_dV_D_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_D_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_S_BS)*3.3333333333333333e-01+(-d_mtat_dV_S_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_S_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_D_BD = (2*d_tmp_dV_D_BD-d_erfcpos_dV_D_BD);
d_erfctimesexpmtat_dV_S_BS = (2*d_tmp_dV_S_BS-d_erfcpos_dV_S_BS);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}

d_gammamax_dV_D_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatgat_d)*d_erfctimesexpmtat_dV_D_BD-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_D_BD)/ktat/ktat);
d_gammamax_dV_S_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatgat_d)*d_erfctimesexpmtat_dV_S_BS-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_S_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));

d_itat_dV_D_BD = (model_.CTATGATD_i)*((asrh*gammamax)*d_wtat_dV_D_BD+(asrh*d_gammamax_dV_D_BD+d_asrh_dV_D_BD*gammamax)*wtat);
d_itat_dV_S_BS = (model_.CTATGATD_i)*((asrh*gammamax)*d_wtat_dV_S_BS+(asrh*d_gammamax_dV_S_BS+d_asrh_dV_S_BS*gammamax)*wtat);
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0))
{

d_ibbt_dV_S_BS = d_ibbt_dV_D_BD =  0.0;
ibbt = 0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_S_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv_d)));
d_tmp_dV_D_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
double  deriv_pow_0_d0 = (((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d))));

d_tmp_dV_S_BS = (deriv_pow_0_d0*((-d_vbbt_dV_S_BS)*(model_.VBIRGATinv_d)));
d_tmp_dV_D_BD = (deriv_pow_0_d0*((-d_vbbt_dV_D_BD)*(model_.VBIRGATinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_S_BS = (model_.one_over_one_minus_PGAT_d)*((tmp*(-d_vbbt_dV_S_BS)*(model_.wdepnulrinvgat_d)-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_S_BS)/tmp/tmp);
d_Fmaxr_dV_D_BD = (model_.one_over_one_minus_PGAT_d)*((tmp*(-d_vbbt_dV_D_BD)*(model_.wdepnulrinvgat_d)-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_D_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_D_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)));
d_tmp_dV_S_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<(-2.3025850929940458e+02)))
{

d_tmp_dV_D_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_S_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_D_BD = 1.0e100*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_D_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_S_BS = 1.0e100*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_S_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_S_BS = (model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_S_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_S_BS+Vjun_d*d_Fmaxr_dV_S_BS*Fmaxr)*tmp);
d_ibbt_dV_D_BD = (model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_D_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_D_BD+(Vjun_d*d_Fmaxr_dV_D_BD+d_Vjun_d_dV_D_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1000))
{

d_fbreakdown_dV_S_BS = d_fbreakdown_dV_D_BD =  0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4))
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_1 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_2 = fabs((vav*(model_.VBRinvgat_d)));
double value_fabs_3 = fabs((vav*(model_.VBRinvgat_d)));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));

d_tmp_dV_S_BS = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_S_BS*(model_.VBRinvgat_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_S_BS*(model_.VBRinvgat_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_S_BS*(model_.VBRinvgat_d)))+(deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvgat_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
d_tmp_dV_D_BD = (((value_fabs_0*value_fabs_1)*value_fabs_2)*(deriv_fabs_3_d0*(d_vav_dV_D_BD*(model_.VBRinvgat_d)))+((value_fabs_0*value_fabs_1)*(deriv_fabs_2_d0*(d_vav_dV_D_BD*(model_.VBRinvgat_d)))+(value_fabs_0*(deriv_fabs_1_d0*(d_vav_dV_D_BD*(model_.VBRinvgat_d)))+(deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvgat_d)))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGATD_i)/value_fabs_0));

d_tmp_dV_S_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_S_BS*(model_.VBRinvgat_d)))));
d_tmp_dV_D_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_D_BD*(model_.VBRinvgat_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_D_BD = (-1*(-d_tmp_dV_D_BD)/(1-tmp)/(1-tmp));
d_fbreakdown_dV_S_BS = (-1*(-d_tmp_dV_S_BS)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{

d_fbreakdown_dV_S_BS = d_vav_dV_S_BS*(model_.slopegat_d);
d_fbreakdown_dV_D_BD = d_vav_dV_D_BD*(model_.slopegat_d);
fbreakdown = ((model_.fstopgat_d)+((vav+(0.999*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}

d_ijungat_d_dV_S_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_S_BS+(((d_id_dV_S_BS+d_isrh_dV_S_BS)+d_itat_dV_S_BS)+d_ibbt_dV_S_BS)*fbreakdown);
d_ijungat_d_dV_D_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_D_BD+(((d_id_dV_D_BD+d_isrh_dV_D_BD)+d_itat_dV_D_BD)+d_ibbt_dV_D_BD)*fbreakdown);
ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}

d_ijun_d_dV_S_BS = ((ABDRAIN_i*d_ijunbot_d_dV_S_BS+LSDRAIN_i*d_ijunsti_d_dV_S_BS)+LGDRAIN_i*d_ijungat_d_dV_S_BS);
d_ijun_d_dV_D_BD = ((ABDRAIN_i*d_ijunbot_d_dV_D_BD+LSDRAIN_i*d_ijunsti_d_dV_D_BD)+LGDRAIN_i*d_ijungat_d_dV_D_BD);
ijun_d = (((ABDRAIN_i*ijunbot_d)+(LSDRAIN_i*ijunsti_d))+(LGDRAIN_i*ijungat_d));
}
}
rgatenoise = ((model_.nt0)*ggate);
rbulknoise = ((model_.nt0)*gbulk);
rjunsnoise = ((model_.nt0)*gjuns);
rjundnoise = ((model_.nt0)*gjund);
rwellnoise = ((model_.nt0)*gwell);
}
// End block evaluateStaticDynamic
//Begin block loadStatic
{
if ((sigVds>0))
{
// I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S;
// I(D,S) <+ (((CHNL_TYPE*MULT_i)*Ids))
staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Ids);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S;
staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Ids);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S;
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcs))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S;
staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S;
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcd))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S;
staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S;
}
else
{
// I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_S_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_D_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_S;
// I(S,D) <+ (((CHNL_TYPE*MULT_i)*Ids))
staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Ids);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S;
staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Ids);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Ids_dV_GP_S;
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcs))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S;
staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_S;
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcd))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S;
staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_S;
}
// I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igb);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_S;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igb);
d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_S_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_D_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_S;
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igsov))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igsov);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_S;
staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*Igsov);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_S_BP;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_S;
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igdov))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igdov);
d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_S_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_D_S;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_S;
staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*Igdov);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_D_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_S;
// I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
staticContributions[admsNodeID_S] += (((model_.CHNL_TYPE)*MULT_i)*Igisl);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_D_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_S;
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_S_BP;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igisl);
d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_D_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_S_BP;
// I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
staticContributions[admsNodeID_D] += (((model_.CHNL_TYPE)*MULT_i)*Igidl);
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_S;
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_S_BP;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_D_S;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igidl);
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_S;
d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_S_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_D_S;
// I(BS,S) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
staticContributions[admsNodeID_BS] += (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_S_BS;
d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_D_BD;
staticContributions[admsNodeID_S] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_S_BS;
d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_D_BD;
// I(BD,D) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
staticContributions[admsNodeID_BD] += (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_S_BS;
d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_D_BD;
staticContributions[admsNodeID_D] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_S_BS;
d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_D_BD;
if ((RG_i>0.0))
{
// I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
staticContributions[admsNodeID_G] += ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] += (MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP];
staticContributions[admsNodeID_GP] -= ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] -= (MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP];
// I(G,GP) <+ (white_noise((MULT_i*rgatenoise)))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= (MULT_i*rgatenoise);
}
}
else
{
// V(G,GP) <+ (0.0)
// do nothing at all
}
if ((RBULK_i>0.0))
{
// I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
staticContributions[admsNodeID_BP] += ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] += (MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] -= (MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI];
// I(BP,BI) <+ (white_noise((MULT_i*rbulknoise)))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (MULT_i*rbulknoise);
}
}
else
{
// V(BP,BI) <+ (0.0)
// do nothing at all
}
if ((RJUNS_i>0.0))
{
// I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
staticContributions[admsNodeID_BS] += ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] += (MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -= (MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI];
// I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise)))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (MULT_i*rjunsnoise);
}
}
else
{
// V(BS,BI) <+ (0.0)
// do nothing at all
}
if ((RJUND_i>0.0))
{
// I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
staticContributions[admsNodeID_BD] += ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] += (MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -= (MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI];
// I(BD,BI) <+ (white_noise((MULT_i*rjundnoise)))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= (MULT_i*rjundnoise);
}
}
else
{
// V(BD,BI) <+ (0.0)
// do nothing at all
}
if ((RWELL_i>0.0))
{
// I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
staticContributions[admsNodeID_B] += ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] += (MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -= (MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI];
// I(B,BI) <+ (white_noise((MULT_i*rwellnoise)))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[4]= (MULT_i*rwellnoise);
}
}
else
{
// V(B,BI) <+ (0.0)
// do nothing at all
}
// I(D,S) <+ ((1E-15*V(D,S)))
staticContributions[admsNodeID_D] += (1E-15*(probeVars[admsProbeID_V_D_S]));
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += 1E-15*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
staticContributions[admsNodeID_S] -= (1E-15*(probeVars[admsProbeID_V_D_S]));
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= 1E-15*d_probeVars[admsProbeID_V_D_S][admsProbeID_V_D_S];
}
// End block loadStatic
//Begin block loadDynamic
{

d_Qs_dV_S_BP = (-((d_Qg_dV_S_BP+d_Qb_dV_S_BP)+d_Qd_dV_S_BP));
d_Qs_dV_GP_S = (-((d_Qg_dV_GP_S+d_Qb_dV_GP_S)+d_Qd_dV_GP_S));
d_Qs_dV_D_S = (-((d_Qg_dV_D_S+d_Qb_dV_D_S)+d_Qd_dV_D_S));
Qs = (-((Qg+Qb)+Qd));

d_Qfgs_dV_S_BP = (d_Qfgs_dV_S_BP+d_Qgs_ov_dV_S_BP);
d_Qfgs_dV_D_S = (d_Qfgs_dV_D_S+d_Qgs_ov_dV_D_S);
d_Qfgs_dV_GP_S = (d_Qfgs_dV_GP_S+d_Qgs_ov_dV_GP_S);
Qfgs = (Qfgs+Qgs_ov);

d_Qfgd_dV_S_BP = (d_Qfgd_dV_S_BP+d_Qgd_ov_dV_S_BP);
d_Qfgd_dV_D_S = (d_Qfgd_dV_D_S+d_Qgd_ov_dV_D_S);
d_Qfgd_dV_GP_S = (d_Qfgd_dV_GP_S+d_Qgd_ov_dV_GP_S);
Qfgd = (Qfgd+Qgd_ov);

d_qjun_s_dV_S_BS = ((ABSOURCE_i*d_qjunbot_s_dV_S_BS+LSSOURCE_i*d_qjunsti_s_dV_S_BS)+LGSOURCE_i*d_qjungat_s_dV_S_BS);
d_qjun_s_dV_D_BD = ((ABSOURCE_i*d_qjunbot_s_dV_D_BD+LSSOURCE_i*d_qjunsti_s_dV_D_BD)+LGSOURCE_i*d_qjungat_s_dV_D_BD);
qjun_s = (((ABSOURCE_i*qjunbot_s)+(LSSOURCE_i*qjunsti_s))+(LGSOURCE_i*qjungat_s));

d_qjun_d_dV_S_BS = ((ABDRAIN_i*d_qjunbot_d_dV_S_BS+LSDRAIN_i*d_qjunsti_d_dV_S_BS)+LGDRAIN_i*d_qjungat_d_dV_S_BS);
d_qjun_d_dV_D_BD = ((ABDRAIN_i*d_qjunbot_d_dV_D_BD+LSDRAIN_i*d_qjunsti_d_dV_D_BD)+LGDRAIN_i*d_qjungat_d_dV_D_BD);
qjun_d = (((ABDRAIN_i*qjunbot_d)+(LSDRAIN_i*qjunsti_d))+(LGDRAIN_i*qjungat_d));
if ((sigVds<0))
{

d_temp_dV_S_BP = d_Qd_dV_S_BP;
d_temp_dV_D_S = d_Qd_dV_D_S;
d_temp_dV_GP_S = d_Qd_dV_GP_S;
temp = Qd;

d_Qd_dV_S_BP = d_Qs_dV_S_BP;
d_Qd_dV_GP_S = d_Qs_dV_GP_S;
d_Qd_dV_D_S = d_Qs_dV_D_S;
Qd = Qs;

d_Qs_dV_S_BP = d_temp_dV_S_BP;
d_Qs_dV_D_S = d_temp_dV_D_S;
d_Qs_dV_GP_S = d_temp_dV_GP_S;
Qs = temp;
}
// I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qg));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_S_BP);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_S);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_D_S);
dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qg));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_S_BP);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_S);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_D_S);
// I(BP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
dynamicContributions[admsNodeID_BP] += ((((model_.CHNL_TYPE)*MULT_i)*Qb));
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_S_BP);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_S);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_D_S);
dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qb));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_S_BP);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_S);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_D_S);
// I(D,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
dynamicContributions[admsNodeID_D] += ((((model_.CHNL_TYPE)*MULT_i)*Qd));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_S_BP);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_D_S);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_S);
dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qd));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_S_BP);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_D_S);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_S);
// I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_S);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_S_BP);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_D_S);
dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_S);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_S_BP);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_D_S);
// I(GP,D) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_D_S);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_S);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_S_BP);
dynamicContributions[admsNodeID_D] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_D_S);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_S);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_S_BP);
// I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_S_BP);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_S);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_D_S);
dynamicContributions[admsNodeID_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_S_BP);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_S);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_D_S);
// I(BS,S) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
dynamicContributions[admsNodeID_BS] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_S_BS);
d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_D_BD);
dynamicContributions[admsNodeID_S] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_S_BS);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_D_BD);
// I(BD,D) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
dynamicContributions[admsNodeID_BD] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_S_BS);
d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_D_BD);
dynamicContributions[admsNodeID_D] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_S_BS);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_D_BD);
}
// End block loadDynamic
//Begin block noise
{
//Block-local variables for block noise
double sf=0.0;
     double d_sf_dV_D_S=0.0;
     double d_sf_dV_GP_S=0.0;
     double d_sf_dV_S_BP=0.0;
//End of Block-local variables
Sfl = 0.0;
mid = 0.0;

d_mig_dV_D_S = d_mig_dV_GP_S = d_mig_dV_S_BP =  0.0;
mig = 0.0;

d_migid_dV_D_S = d_migid_dV_GP_S = d_migid_dV_S_BP =  0.0;
migid = 0.0;
c_igid = 0.0;

d_CGeff_dV_S_BP = (COX_qm*d_eta_p_dV_S_BP+d_COX_qm_dV_S_BP*eta_p);
d_CGeff_dV_GP_S = (COX_qm*d_eta_p_dV_GP_S+d_COX_qm_dV_GP_S*eta_p);
d_CGeff_dV_D_S = (COX_qm*d_eta_p_dV_D_S+d_COX_qm_dV_D_S*eta_p);
CGeff = (COX_qm*eta_p);
sqid = 0.0;
sqig = 0.0;
if ((((xg>0.0)&&(MULT_i>0.0))&&(BET_i>0.0)))
{
N1 = ((Cox_over_q*alpha)*(model_.phit));
Nm1 = (Cox_over_q*qim1);
Delta_N1 = (Cox_over_q*(alpha*dps));
{
double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
Sfl = (((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*value_log_0);
}
Sfl = (Sfl+((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
Sfl = ((((Sfl_prefac*Ids)*Gvsatinv)*Sfl)/N1);
Sfl = ((Sfl>0.0)?Sfl:0.0);

d_H0_dV_S_BP = ((alpha*d_qim1_dV_S_BP-qim1*d_alpha_dV_S_BP)/alpha/alpha);
d_H0_dV_GP_S = ((alpha*d_qim1_dV_GP_S-qim1*d_alpha_dV_GP_S)/alpha/alpha);
d_H0_dV_D_S = ((alpha*d_qim1_dV_D_S-qim1*d_alpha_dV_D_S)/alpha/alpha);
H0 = (qim1/alpha);

d_t1_dV_S_BP = ((qim1*d_qim_dV_S_BP-qim*d_qim1_dV_S_BP)/qim1/qim1);
d_t1_dV_GP_S = ((qim1*d_qim_dV_GP_S-qim*d_qim1_dV_GP_S)/qim1/qim1);
d_t1_dV_D_S = ((qim1*d_qim_dV_D_S-qim*d_qim1_dV_D_S)/qim1/qim1);
t1 = (qim/qim1);

d_sqt2_dV_S_BP = (0.5*1.6666666666666667e-01)*((H0*d_dps_dV_S_BP-dps*d_H0_dV_S_BP)/H0/H0);
d_sqt2_dV_GP_S = (0.5*1.6666666666666667e-01)*((H0*d_dps_dV_GP_S-dps*d_H0_dV_GP_S)/H0/H0);
d_sqt2_dV_D_S = (0.5*1.6666666666666667e-01)*((H0*d_dps_dV_D_S-dps*d_H0_dV_D_S)/H0/H0);
sqt2 = ((0.5*1.6666666666666667e-01)*(dps/H0));

d_t2_dV_S_BP = (sqt2*d_sqt2_dV_S_BP+d_sqt2_dV_S_BP*sqt2);
d_t2_dV_GP_S = (sqt2*d_sqt2_dV_GP_S+d_sqt2_dV_GP_S*sqt2);
d_t2_dV_D_S = (sqt2*d_sqt2_dV_D_S+d_sqt2_dV_D_S*sqt2);
t2 = (sqt2*sqt2);

d_r_dV_S_BP = ((H*d_H0_dV_S_BP-H0*d_H_dV_S_BP)/H/H);
d_r_dV_GP_S = ((H*d_H0_dV_GP_S-H0*d_H_dV_GP_S)/H/H);
d_r_dV_D_S = ((H*d_H0_dV_D_S-H0*d_H_dV_D_S)/H/H);
r = ((H0/H)-1.0);

d_lc_dV_S_BP = (((1.0-(12*(r*t2)))>1e-20)?(-12*(r*d_t2_dV_S_BP+d_r_dV_S_BP*t2)):0.0);
d_lc_dV_GP_S = (((1.0-(12*(r*t2)))>1e-20)?(-12*(r*d_t2_dV_GP_S+d_r_dV_GP_S*t2)):0.0);
d_lc_dV_D_S = (((1.0-(12*(r*t2)))>1e-20)?(-12*(r*d_t2_dV_D_S+d_r_dV_D_S*t2)):0.0);
lc = (((1.0-(12*(r*t2)))>1e-20)?(1.0-(12*(r*t2))):1e-20);

d_lcinv2_dV_S_BP = (-1*(lc*d_lc_dV_S_BP+d_lc_dV_S_BP*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_GP_S = (-1*(lc*d_lc_dV_GP_S+d_lc_dV_GP_S*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_D_S = (-1*(lc*d_lc_dV_D_S+d_lc_dV_D_S*lc)/(lc*lc)/(lc*lc));
lcinv2 = (1/(lc*lc));

d_g_ideal_dV_S_BP = BET_i*((FdL*qim1)*d_Gvsatinv_dV_S_BP+(FdL*d_qim1_dV_S_BP+d_FdL_dV_S_BP*qim1)*Gvsatinv);
d_g_ideal_dV_D_S = BET_i*((FdL*qim1)*d_Gvsatinv_dV_D_S+(FdL*d_qim1_dV_D_S+d_FdL_dV_D_S*qim1)*Gvsatinv);
d_g_ideal_dV_GP_S = BET_i*((FdL*qim1)*d_Gvsatinv_dV_GP_S+(FdL*d_qim1_dV_GP_S+d_FdL_dV_GP_S*qim1)*Gvsatinv);
g_ideal = (BET_i*((FdL*qim1)*Gvsatinv));

d_CGeff_dV_S_BP = (((Gmob_dL*Gmob_dL)*(((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_S_BP+((Gvsat*Gvsat)*d_COX_qm_dV_S_BP+(Gvsat*d_Gvsat_dV_S_BP+d_Gvsat_dV_S_BP*Gvsat)*COX_qm)*eta_p)-(((Gvsat*Gvsat)*COX_qm)*eta_p)*(Gmob_dL*d_Gmob_dL_dV_S_BP+d_Gmob_dL_dV_S_BP*Gmob_dL))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
d_CGeff_dV_GP_S = (((Gmob_dL*Gmob_dL)*(((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_GP_S+((Gvsat*Gvsat)*d_COX_qm_dV_GP_S+(Gvsat*d_Gvsat_dV_GP_S+d_Gvsat_dV_GP_S*Gvsat)*COX_qm)*eta_p)-(((Gvsat*Gvsat)*COX_qm)*eta_p)*(Gmob_dL*d_Gmob_dL_dV_GP_S+d_Gmob_dL_dV_GP_S*Gmob_dL))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
d_CGeff_dV_D_S = (((Gmob_dL*Gmob_dL)*(((Gvsat*Gvsat)*COX_qm)*d_eta_p_dV_D_S+((Gvsat*Gvsat)*d_COX_qm_dV_D_S+(Gvsat*d_Gvsat_dV_D_S+d_Gvsat_dV_D_S*Gvsat)*COX_qm)*eta_p)-(((Gvsat*Gvsat)*COX_qm)*eta_p)*(Gmob_dL*d_Gmob_dL_dV_D_S+d_Gmob_dL_dV_D_S*Gmob_dL))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
CGeff = ((((Gvsat*Gvsat)*COX_qm)*eta_p)/(Gmob_dL*Gmob_dL));
mid = ((t1+(12*t2))-(24*(((1.0+t1)*t2)*r)));
mid = ((mid>1e-40)?mid:1e-40);
mid = ((g_ideal*lcinv2)*mid);

d_mig_dV_S_BP = (((d_t1_dV_S_BP/12.0)-(t2*(d_t1_dV_S_BP-12*d_t2_dV_S_BP)+d_t2_dV_S_BP*((t1+0.2)-(12*t2))))-1.6*((t2*((t1+1.0)-(12*t2)))*d_r_dV_S_BP+(t2*(d_t1_dV_S_BP-12*d_t2_dV_S_BP)+d_t2_dV_S_BP*((t1+1.0)-(12*t2)))*r));
d_mig_dV_GP_S = (((d_t1_dV_GP_S/12.0)-(t2*(d_t1_dV_GP_S-12*d_t2_dV_GP_S)+d_t2_dV_GP_S*((t1+0.2)-(12*t2))))-1.6*((t2*((t1+1.0)-(12*t2)))*d_r_dV_GP_S+(t2*(d_t1_dV_GP_S-12*d_t2_dV_GP_S)+d_t2_dV_GP_S*((t1+1.0)-(12*t2)))*r));
d_mig_dV_D_S = (((d_t1_dV_D_S/12.0)-(t2*(d_t1_dV_D_S-12*d_t2_dV_D_S)+d_t2_dV_D_S*((t1+0.2)-(12*t2))))-1.6*((t2*((t1+1.0)-(12*t2)))*d_r_dV_D_S+(t2*(d_t1_dV_D_S-12*d_t2_dV_D_S)+d_t2_dV_D_S*((t1+1.0)-(12*t2)))*r));
mig = (((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r)));

d_mig_dV_S_BP = ((mig>1e-40)?d_mig_dV_S_BP:0.0);
d_mig_dV_GP_S = ((mig>1e-40)?d_mig_dV_GP_S:0.0);
d_mig_dV_D_S = ((mig>1e-40)?d_mig_dV_D_S:0.0);
mig = ((mig>1e-40)?mig:1e-40);

d_mig_dV_S_BP = ((lcinv2/g_ideal)*d_mig_dV_S_BP+((g_ideal*d_lcinv2_dV_S_BP-lcinv2*d_g_ideal_dV_S_BP)/g_ideal/g_ideal)*mig);
d_mig_dV_GP_S = ((lcinv2/g_ideal)*d_mig_dV_GP_S+((g_ideal*d_lcinv2_dV_GP_S-lcinv2*d_g_ideal_dV_GP_S)/g_ideal/g_ideal)*mig);
d_mig_dV_D_S = ((lcinv2/g_ideal)*d_mig_dV_D_S+((g_ideal*d_lcinv2_dV_D_S-lcinv2*d_g_ideal_dV_D_S)/g_ideal/g_ideal)*mig);
mig = ((lcinv2/g_ideal)*mig);

d_migid_dV_S_BP = ((lcinv2*sqt2)*((-12*d_t2_dV_S_BP)-(((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_S_BP+((d_t1_dV_S_BP+19.2*d_t2_dV_S_BP)-12*(t1*d_t2_dV_S_BP+d_t1_dV_S_BP*t2))*r))+(lcinv2*d_sqt2_dV_S_BP+d_lcinv2_dV_S_BP*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
d_migid_dV_GP_S = ((lcinv2*sqt2)*((-12*d_t2_dV_GP_S)-(((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_GP_S+((d_t1_dV_GP_S+19.2*d_t2_dV_GP_S)-12*(t1*d_t2_dV_GP_S+d_t1_dV_GP_S*t2))*r))+(lcinv2*d_sqt2_dV_GP_S+d_lcinv2_dV_GP_S*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
d_migid_dV_D_S = ((lcinv2*sqt2)*((-12*d_t2_dV_D_S)-(((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dV_D_S+((d_t1_dV_D_S+19.2*d_t2_dV_D_S)-12*(t1*d_t2_dV_D_S+d_t1_dV_D_S*t2))*r))+(lcinv2*d_sqt2_dV_D_S+d_lcinv2_dV_D_S*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
migid = ((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
if ((FNTEXC_i>0))
{

d_temp2_exc_dV_S_BP = (qim*d_xitsb_dV_S_BP+d_qim_dV_S_BP*xitsb);
d_temp2_exc_dV_GP_S = d_qim_dV_GP_S*xitsb;
d_temp2_exc_dV_D_S = (qim*d_xitsb_dV_D_S+d_qim_dV_D_S*xitsb);
temp2_exc = (qim*xitsb);

d_wsat_exc_dV_S_BP = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_S_BP-temp2_exc*d_temp2_exc_dV_S_BP)/(100.0+temp2_exc)/(100.0+temp2_exc));
d_wsat_exc_dV_GP_S = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_GP_S-temp2_exc*d_temp2_exc_dV_GP_S)/(100.0+temp2_exc)/(100.0+temp2_exc));
d_wsat_exc_dV_D_S = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_D_S-temp2_exc*d_temp2_exc_dV_D_S)/(100.0+temp2_exc)/(100.0+temp2_exc));
wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
if ((THESATG_i<0))
{

d_temp_exc_dV_S_BP = (-1*(-THESATG_i*d_wsat_exc_dV_S_BP)/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
d_temp_exc_dV_GP_S = (-1*(-THESATG_i*d_wsat_exc_dV_GP_S)/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
d_temp_exc_dV_D_S = (-1*(-THESATG_i*d_wsat_exc_dV_D_S)/(1-(THESATG_i*wsat_exc))/(1-(THESATG_i*wsat_exc)));
temp_exc = (1/(1-(THESATG_i*wsat_exc)));
}
else
{

d_temp_exc_dV_S_BP = THESATG_i*d_wsat_exc_dV_S_BP;
d_temp_exc_dV_GP_S = THESATG_i*d_wsat_exc_dV_GP_S;
d_temp_exc_dV_D_S = THESATG_i*d_wsat_exc_dV_D_S;
temp_exc = (1+(THESATG_i*wsat_exc));
}

d_thesat1_exc_dV_S_BP = THESAT_i*((Gmob*d_temp_exc_dV_S_BP-temp_exc*d_Gmob_dV_S_BP)/Gmob/Gmob);
d_thesat1_exc_dV_GP_S = THESAT_i*((Gmob*d_temp_exc_dV_GP_S-temp_exc*d_Gmob_dV_GP_S)/Gmob/Gmob);
d_thesat1_exc_dV_D_S = THESAT_i*((Gmob*d_temp_exc_dV_D_S-temp_exc*d_Gmob_dV_D_S)/Gmob/Gmob);
thesat1_exc = (THESAT_i*(temp_exc/Gmob));

d_zsat_exc_dV_S_BP = (((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_S_BP+((thesat1_exc*thesat1_exc)*d_dps_dV_S_BP+(thesat1_exc*d_thesat1_exc_dV_S_BP+d_thesat1_exc_dV_S_BP*thesat1_exc)*dps)*dps);
d_zsat_exc_dV_GP_S = (((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_GP_S+((thesat1_exc*thesat1_exc)*d_dps_dV_GP_S+(thesat1_exc*d_thesat1_exc_dV_GP_S+d_thesat1_exc_dV_GP_S*thesat1_exc)*dps)*dps);
d_zsat_exc_dV_D_S = (((thesat1_exc*thesat1_exc)*dps)*d_dps_dV_D_S+((thesat1_exc*thesat1_exc)*d_dps_dV_D_S+(thesat1_exc*d_thesat1_exc_dV_D_S+d_thesat1_exc_dV_D_S*thesat1_exc)*dps)*dps);
zsat_exc = (((thesat1_exc*thesat1_exc)*dps)*dps);
if (((model_.CHNL_TYPE)==(-1)))
{

d_zsat_exc_dV_S_BP = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_S_BP-zsat_exc*(thesat1_exc*d_dps_dV_S_BP+d_thesat1_exc_dV_S_BP*dps))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
d_zsat_exc_dV_GP_S = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_GP_S-zsat_exc*(thesat1_exc*d_dps_dV_GP_S+d_thesat1_exc_dV_GP_S*dps))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
d_zsat_exc_dV_D_S = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dV_D_S-zsat_exc*(thesat1_exc*d_dps_dV_D_S+d_thesat1_exc_dV_D_S*dps))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gvsat_exc_dV_S_BP = 0.5*(Gmob*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_S_BP))+d_Gmob_dV_S_BP*(1.0+value_sqrt_0));
d_Gvsat_exc_dV_GP_S = 0.5*(Gmob*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_GP_S))+d_Gmob_dV_GP_S*(1.0+value_sqrt_0));
d_Gvsat_exc_dV_D_S = 0.5*(Gmob*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_D_S))+d_Gmob_dV_D_S*(1.0+value_sqrt_0));
Gvsat_exc = (0.5*(Gmob*(1.0+value_sqrt_0)));
}

d_gfac_dV_S_BP = (((Gvsat_exc*lc)*d_Gmob_dV_S_BP-Gmob*(Gvsat_exc*d_lc_dV_S_BP+d_Gvsat_exc_dV_S_BP*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
d_gfac_dV_GP_S = (((Gvsat_exc*lc)*d_Gmob_dV_GP_S-Gmob*(Gvsat_exc*d_lc_dV_GP_S+d_Gvsat_exc_dV_GP_S*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
d_gfac_dV_D_S = (((Gvsat_exc*lc)*d_Gmob_dV_D_S-Gmob*(Gvsat_exc*d_lc_dV_D_S+d_Gvsat_exc_dV_D_S*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac = (Gmob/(Gvsat_exc*lc));

d_Sidexc_dV_S_BP = ((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_S_BP+(((fac_exc*Ids)*Vdse)*d_gfac_dV_S_BP+((fac_exc*Ids)*d_Vdse_dV_S_BP+fac_exc*d_Ids_dV_S_BP*Vdse)*gfac)*gfac);
d_Sidexc_dV_D_S = ((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_D_S+(((fac_exc*Ids)*Vdse)*d_gfac_dV_D_S+((fac_exc*Ids)*d_Vdse_dV_D_S+fac_exc*d_Ids_dV_D_S*Vdse)*gfac)*gfac);
d_Sidexc_dV_GP_S = ((((fac_exc*Ids)*Vdse)*gfac)*d_gfac_dV_GP_S+(((fac_exc*Ids)*Vdse)*d_gfac_dV_GP_S+((fac_exc*Ids)*d_Vdse_dV_GP_S+fac_exc*d_Ids_dV_GP_S*Vdse)*gfac)*gfac);
Sidexc = ((((fac_exc*Ids)*Vdse)*gfac)*gfac);
mid = (mid+(Sidexc/(model_.nt0)));

d_mig_dV_S_BP = (d_mig_dV_S_BP+(((((12*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12*d_t2_dV_S_BP+d_Sidexc_dV_S_BP*(1+(12*t2)))-(Sidexc*(1+(12*t2)))*((12*g_ideal)*d_g_ideal_dV_S_BP+12*d_g_ideal_dV_S_BP*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
d_mig_dV_GP_S = (d_mig_dV_GP_S+(((((12*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12*d_t2_dV_GP_S+d_Sidexc_dV_GP_S*(1+(12*t2)))-(Sidexc*(1+(12*t2)))*((12*g_ideal)*d_g_ideal_dV_GP_S+12*d_g_ideal_dV_GP_S*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
d_mig_dV_D_S = (d_mig_dV_D_S+(((((12*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12*d_t2_dV_D_S+d_Sidexc_dV_D_S*(1+(12*t2)))-(Sidexc*(1+(12*t2)))*((12*g_ideal)*d_g_ideal_dV_D_S+12*d_g_ideal_dV_D_S*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))/(((12*g_ideal)*g_ideal)*(model_.nt0))));
mig = (mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*(model_.nt0))));

d_migid_dV_S_BP = (d_migid_dV_S_BP-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_S_BP+(Sidexc*d_sqt2_dV_S_BP+d_Sidexc_dV_S_BP*sqt2)*(1+r))-((Sidexc*sqt2)*(1+r))*d_g_ideal_dV_S_BP*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
d_migid_dV_GP_S = (d_migid_dV_GP_S-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_GP_S+(Sidexc*d_sqt2_dV_GP_S+d_Sidexc_dV_GP_S*sqt2)*(1+r))-((Sidexc*sqt2)*(1+r))*d_g_ideal_dV_GP_S*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
d_migid_dV_D_S = (d_migid_dV_D_S-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_D_S+(Sidexc*d_sqt2_dV_D_S+d_Sidexc_dV_D_S*sqt2)*(1+r))-((Sidexc*sqt2)*(1+r))*d_g_ideal_dV_D_S*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
migid = (migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*(model_.nt0))));
}
{
double value_sqrt_0 = sqrt((nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqid = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((nt/mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqig = value_sqrt_0;
}
if ((sqid==0))
{
c_igid = 0.0;
}
else
{
c_igid = ((migid*sqig)/sqid);
}
c_igid = ((c_igid>0.0)?((c_igid<1.0)?c_igid:1.0):0.0);
}
{
double value_fabs_0 = fabs(Igcs);
double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));
shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igcd);
double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));
shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igsov);
double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));
shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igdov);
double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));
shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Iimpact);
double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));
shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
}
{
double value_fabs_0 = fabs(ijun_s);
double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));
jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(ijun_d);
double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));
jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
}
if ((sigVds>0))
{
shot_igs = (shot_igcsx+shot_igsov);
shot_igd = (shot_igcdx+shot_igdov);
jnoise_s = jnoisex_s;
jnoise_d = (jnoisex_d+shot_iavl);
}
else
{
shot_igs = (shot_igcdx+shot_igsov);
shot_igd = (shot_igcsx+shot_igdov);
jnoise_s = (jnoisex_s+shot_iavl);
jnoise_d = jnoisex_d;
}

d_sf_dV_S_BP = ((1e6*CGeff)*d_mig_dV_S_BP+1e6*d_CGeff_dV_S_BP*mig);
d_sf_dV_GP_S = ((1e6*CGeff)*d_mig_dV_GP_S+1e6*d_CGeff_dV_GP_S*mig);
d_sf_dV_D_S = ((1e6*CGeff)*d_mig_dV_D_S+1e6*d_CGeff_dV_D_S*mig);
sf = ((1e6*CGeff)*mig);
// I(NOI2,GND) <+ (V(NOI2,GND))
staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] += d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND];
// I(NOI2,GND) <+ (white_noise((((sqig*sqig)*sf)*sf),"igig"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[5]= (((sqig*sqig)*sf)*sf);
}
// I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] += ((-d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
// I(NOI,GND) <+ ((V(NOI,GND)/mig))
staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_S_BP/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_GP_S/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_D_S/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]/mig);
// I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (CGeff*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP] += (d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] += (d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] += (d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND]));
// I(D,S) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[6]= (MULT_i*Sfl);
  noiseContribsExponent[6]= EF_i;
}
// I(D,S) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[7]= (((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid)));
}
// I(D,S) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
{
double value_sqrt_0 = sqrt(MULT_i);
staticContributions[admsNodeID_D] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] += (((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND]/sf);
d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_S_BP*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP)/sf/sf);
d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_GP_S*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S)/sf/sf);
d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_D_S*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S)/sf/sf);
staticContributions[admsNodeID_S] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] -= (((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND]/sf);
d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_S_BP*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_S_BP)/sf/sf);
d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_GP_S*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_S)/sf/sf);
d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_D_S*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_D_S)/sf/sf);
}
// I(GP,S) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
{
double value_sqrt_0 = sqrt(MULT_i);
dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((value_sqrt_0*0.5)*d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((value_sqrt_0*0.5)*d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((value_sqrt_0*0.5)*d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND]));
dynamicContributions[admsNodeID_S] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] -= (((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] -= ((value_sqrt_0*0.5)*d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] -= ((value_sqrt_0*0.5)*d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -= ((value_sqrt_0*0.5)*d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND]));
}
// I(GP,D) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
{
double value_sqrt_0 = sqrt(MULT_i);
dynamicContributions[admsNodeID_GP] += ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] += ((value_sqrt_0*0.5)*d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] += ((value_sqrt_0*0.5)*d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] += ((value_sqrt_0*0.5)*d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND]));
dynamicContributions[admsNodeID_D] -= ((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] -= (((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] -= ((value_sqrt_0*0.5)*d_CGeff_dV_S_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -= ((value_sqrt_0*0.5)*d_CGeff_dV_GP_S*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] -= ((value_sqrt_0*0.5)*d_CGeff_dV_D_S*(probeVars[admsProbeID_V_NOI_GND]));
}
// I(GP,S) <+ (white_noise((MULT_i*shot_igs),"igs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[8]= (MULT_i*shot_igs);
}
// I(GP,D) <+ (white_noise((MULT_i*shot_igd),"igd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[9]= (MULT_i*shot_igd);
}
// I(BS,S) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[10]= (MULT_i*jnoise_s);
}
// I(BD,D) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[11]= (MULT_i*jnoise_d);
}
}
// End block noise
//Begin block OPinfo
{
//Block-local variables for block OPinfo
double temp=0.0;
     double d_temp_dV_GP_S=0.0;
     double d_temp_dV_D_S=0.0;
     double d_temp_dV_S_BP=0.0;
     double d_temp_dV_D_BD=0.0;
     double d_temp_dV_S_BS=0.0;
//End of Block-local variables
id_op = ((Ids+Iimpact)-Igcd);
is = ((-Ids)-Igcs);
ig = ((((Igcs+Igcd)+Igsov)+Igdov)+Igb);
ib = ((((-Iimpact)-Igb)-Igidl)-Igisl);
sig1k = (((2*3.1415926535897931)*1000)*CGeff);
sig1k = ((sig1k*sig1k)*mig);
sdint = sigVds;
ctype = (model_.CHNL_TYPE);
if ((sigVds<0))
{
ise = (MULT_i*(((is-Igdov)+Igidl)-ijun_d));
ige = (MULT_i*ig);
ide = (MULT_i*(((id_op-Igsov)+Igisl)-ijun_s));
ibe = (MULT_i*((ib+ijun_s)+ijun_d));
ids = (MULT_i*Ids);
idb = (MULT_i*((Iimpact+Igisl)-ijun_s));
isb = (MULT_i*(Igidl-ijun_d));
igs = (MULT_i*(Igcs+Igdov));
igd = (MULT_i*(Igcd+Igsov));
igb = (MULT_i*Igb);
igcs = (MULT_i*Igcs);
igcd = (MULT_i*Igcd);
iavl = (MULT_i*Iimpact);
igisl = (MULT_i*Igidl);
igidl = (MULT_i*Igisl);
if (((model_.SWJUNEXP_i)==1))
{
ijsbot = 0.0;
ijsgat = 0.0;
ijssti = 0.0;
ijdbot = 0.0;
ijdgat = 0.0;
ijdsti = 0.0;
idsatsbot = 0.0;
idsatssti = 0.0;
idsatsgat = 0.0;
idsatsbotd = 0.0;
idsatsstid = 0.0;
idsatsgatd = 0.0;
}
else
{
ijsbot = ((MULT_i*ABDRAIN_i)*ijunbot_d);
ijsgat = ((MULT_i*LGDRAIN_i)*ijungat_d);
ijssti = ((MULT_i*LSDRAIN_i)*ijunsti_d);
ijdbot = ((MULT_i*ABSOURCE_i)*ijunbot_s);
ijdgat = ((MULT_i*LGSOURCE_i)*ijungat_s);
ijdsti = ((MULT_i*LSSOURCE_i)*ijunsti_s);
idsatsbot = ((MULT_i*ABSOURCE_i)*(model_.idsatbot));
idsatssti = ((MULT_i*LSSOURCE_i)*(model_.idsatsti));
idsatsgat = ((MULT_i*LGSOURCE_i)*(model_.idsatgat));
idsatsbotd = ((MULT_i*ABDRAIN_i)*(model_.idsatbot_d));
idsatsstid = ((MULT_i*LSDRAIN_i)*(model_.idsatsti_d));
idsatsgatd = ((MULT_i*LGDRAIN_i)*(model_.idsatgat_d));
}
ijs = (MULT_i*ijun_d);
ijd = (MULT_i*ijun_s);
vds = Vds;
vgs = Vgs;
vsb = Vsb;
{
double value_sqrt_0 = sqrt((phit1*facvsb0));
vto = ((VFB_i+(P_D*facvsb0))+(Gf*value_sqrt_0));
}
vts = vts_i;
vth = vth_i;
vgt = (vgs-vth);
vdss = Vdsat;
vsat = (Vds-vdss);

d_temp_dV_S_BS = (-d_ijun_s_dV_S_BS);
d_temp_dV_D_BD = (-d_ijun_s_dV_D_BD);
d_temp_dV_S_BP = ((((d_Ids_dV_S_BP+d_Iimpact_dV_S_BP)+d_Igisl_dV_S_BP)-d_Igcd_dV_S_BP)-d_Igsov_dV_S_BP);
d_temp_dV_D_S = ((((d_Ids_dV_D_S+d_Iimpact_dV_D_S)+d_Igisl_dV_D_S)-d_Igcd_dV_D_S)-d_Igsov_dV_D_S);
d_temp_dV_GP_S = ((((d_Ids_dV_GP_S+d_Iimpact_dV_GP_S)+d_Igisl_dV_GP_S)-d_Igcd_dV_GP_S)-d_Igsov_dV_GP_S);
temp = (((((Ids+Iimpact)+Igisl)-Igcd)-Igsov)-ijun_s);
gm = (((model_.CHNL_TYPE)*MULT_i)*(+d_temp_dV_GP_S));
gmb = (((model_.CHNL_TYPE)*MULT_i)*(-d_temp_dV_S_BP));
gds = (((model_.CHNL_TYPE)*MULT_i)*(+d_temp_dV_S_BS+d_temp_dV_S_BP-d_temp_dV_D_S-d_temp_dV_GP_S));
gjs = (MULT_i*(-d_ijun_d_dV_D_BD));
gjd = (MULT_i*(-d_ijun_s_dV_S_BS));
css = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qd_dV_D_S));
csg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qd_dV_GP_S));
csb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qd_dV_S_BP));
csd = ((css-csg)-csb);
cgs = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qg_dV_D_S));
cgg = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qg_dV_GP_S));
cgb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qg_dV_S_BP));
cgd = ((cgg-cgs)-cgb);
cds = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_D_S));
cdg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_GP_S));
cdb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qs_dV_S_BP));
cdd = ((cdg+cds)+cdb);
cbs = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_D_S));
cbg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_GP_S));
cbb = (((model_.CHNL_TYPE)*MULT_i)*(-d_Qb_dV_S_BP));
cbd = ((cbb-cbs)-cbg);
cgsol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgd_dV_GP_S));
cgdol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgs_dV_GP_S));
cjsbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABDRAIN_i)*(+d_qjunbot_d_dV_D_BD));
cjsgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGDRAIN_i)*(+d_qjungat_d_dV_D_BD));
cjssti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSDRAIN_i)*(+d_qjunsti_d_dV_D_BD));
cjs = ((cjsbot+cjsgat)+cjssti);
cjdbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABSOURCE_i)*(+d_qjunbot_s_dV_S_BS));
cjdgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGSOURCE_i)*(+d_qjungat_s_dV_S_BS));
cjdsti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSSOURCE_i)*(+d_qjunsti_s_dV_S_BS));
cjd = ((cjdbot+cjdgat)+cjdsti);
}
else
{
ise = (MULT_i*(((is-Igsov)+Igisl)-ijun_s));
ige = (MULT_i*ig);
ide = (MULT_i*(((id_op-Igdov)+Igidl)-ijun_d));
ibe = (MULT_i*((ib+ijun_s)+ijun_d));
ids = (MULT_i*Ids);
idb = (MULT_i*((Iimpact+Igidl)-ijun_d));
isb = (MULT_i*(Igisl-ijun_s));
igs = (MULT_i*(Igcs+Igsov));
igd = (MULT_i*(Igcd+Igdov));
igb = (MULT_i*Igb);
igcs = (MULT_i*Igcs);
igcd = (MULT_i*Igcd);
iavl = (MULT_i*Iimpact);
igisl = (MULT_i*Igisl);
igidl = (MULT_i*Igidl);
if (((model_.SWJUNEXP_i)==1))
{
ijsbot = 0.0;
ijsgat = 0.0;
ijssti = 0.0;
ijdbot = 0.0;
ijdgat = 0.0;
ijdsti = 0.0;
idsatsbot = 0.0;
idsatssti = 0.0;
idsatsgat = 0.0;
idsatsbotd = 0.0;
idsatsstid = 0.0;
idsatsgatd = 0.0;
}
else
{
ijsbot = ((MULT_i*ABSOURCE_i)*ijunbot_s);
ijsgat = ((MULT_i*LGSOURCE_i)*ijungat_s);
ijssti = ((MULT_i*LSSOURCE_i)*ijunsti_s);
ijdbot = ((MULT_i*ABDRAIN_i)*ijunbot_d);
ijdgat = ((MULT_i*LGDRAIN_i)*ijungat_d);
ijdsti = ((MULT_i*LSDRAIN_i)*ijunsti_d);
idsatsbot = ((MULT_i*ABSOURCE_i)*(model_.idsatbot));
idsatssti = ((MULT_i*LSSOURCE_i)*(model_.idsatsti));
idsatsgat = ((MULT_i*LGSOURCE_i)*(model_.idsatgat));
idsatsbotd = ((MULT_i*ABDRAIN_i)*(model_.idsatbot_d));
idsatsstid = ((MULT_i*LSDRAIN_i)*(model_.idsatsti_d));
idsatsgatd = ((MULT_i*LGDRAIN_i)*(model_.idsatgat_d));
}
ijs = (MULT_i*ijun_s);
ijd = (MULT_i*ijun_d);
vds = Vds;
vgs = Vgs;
vsb = Vsb;
{
double value_sqrt_0 = sqrt((phit1*facvsb0));
vto = ((VFB_i+(P_D*facvsb0))+(Gf*value_sqrt_0));
}
vts = vts_i;
vth = vth_i;
vgt = (vgs-vth);
vdss = Vdsat;
vsat = (Vds-vdss);

d_temp_dV_S_BS = (-d_ijun_d_dV_S_BS);
d_temp_dV_D_BD = (-d_ijun_d_dV_D_BD);
d_temp_dV_S_BP = ((((d_Ids_dV_S_BP+d_Iimpact_dV_S_BP)+d_Igidl_dV_S_BP)-d_Igcd_dV_S_BP)-d_Igdov_dV_S_BP);
d_temp_dV_D_S = ((((d_Ids_dV_D_S+d_Iimpact_dV_D_S)+d_Igidl_dV_D_S)-d_Igcd_dV_D_S)-d_Igdov_dV_D_S);
d_temp_dV_GP_S = ((((d_Ids_dV_GP_S+d_Iimpact_dV_GP_S)+d_Igidl_dV_GP_S)-d_Igcd_dV_GP_S)-d_Igdov_dV_GP_S);
temp = (((((Ids+Iimpact)+Igidl)-Igcd)-Igdov)-ijun_d);
gm = (((model_.CHNL_TYPE)*MULT_i)*(+d_temp_dV_GP_S));
gmb = (((model_.CHNL_TYPE)*MULT_i)*(-d_temp_dV_S_BP));
gds = (((model_.CHNL_TYPE)*MULT_i)*(+d_temp_dV_D_BD+d_temp_dV_D_S));
gjs = ((-MULT_i)*(+d_ijun_s_dV_S_BS));
gjd = ((-MULT_i)*(+d_ijun_d_dV_D_BD));
cdd = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qd_dV_D_S));
cdg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qd_dV_GP_S));
cdb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qd_dV_S_BP));
cds = ((cdd-cdg)-cdb);
cgd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qg_dV_D_S));
cgg = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qg_dV_GP_S));
cgb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qg_dV_S_BP));
cgs = ((cgg-cgd)-cgb);
csd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_D_S));
csg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_GP_S));
csb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qs_dV_S_BP));
css = ((csg+csd)+csb);
cbd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_D_S));
cbg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_GP_S));
cbb = (((model_.CHNL_TYPE)*MULT_i)*(-d_Qb_dV_S_BP));
cbs = ((cbb-cbd)-cbg);
cgsol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgs_dV_GP_S));
cgdol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgd_dV_GP_S));
cjsbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABSOURCE_i)*(+d_qjunbot_s_dV_S_BS));
cjsgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGSOURCE_i)*(+d_qjungat_s_dV_S_BS));
cjssti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSSOURCE_i)*(+d_qjunsti_s_dV_S_BS));
cjs = ((cjsbot+cjsgat)+cjssti);
cjdbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABDRAIN_i)*(+d_qjunbot_d_dV_D_BD));
cjdgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGDRAIN_i)*(+d_qjungat_d_dV_D_BD));
cjdsti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSDRAIN_i)*(+d_qjunsti_d_dV_D_BD));
cjd = ((cjdbot+cjdgat)+cjdsti);
}
weff = WE;
leff = LE;
if ((fabs(gds)<1e-18))
{
u = 0;
rout = 0;
vearly = 0;
}
else
{
u = (gm/gds);
rout = (1.0/gds);
vearly = (ide/gds);
}
if ((fabs(vgt)<1e-12))
{
beff = 0;
}
else
{
{
double value_fabs_0 = fabs(ide);
double  deriv_fabs_0_d0 = (((ide)>=0)?(+1.0):(-1.0));
beff = ((2*value_fabs_0)/(vgt*vgt));
}
}
if ((fabs(((cgg+cgsol)+cgdol))<1e-30))
{
fug = 0.0;
}
else
{
fug = (gm/((2*3.1415926535897931)*((cgg+cgsol)+cgdol)));
}
rg = (RG_i/MULT_i);
sfl = (MULT_i*Sfl);
if ((fabs(gm)<1e-18))
{
sqrtsff = 0;
sqrtsfw = 0;
}
else
{
{
double value_sqrt_0 = sqrt(((MULT_i*Sfl)/1000.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqrtsff = (value_sqrt_0/gm);
}
{
double value_sqrt_0 = sqrt(MULT_i);
sqrtsfw = ((value_sqrt_0*sqid)/gm);
}
}
sid = ((MULT_i*sqid)*sqid);
sig = (((MULT_i*nt)*sig1k)/(1+(sig1k*mig)));
cigid = c_igid;
if ((sid==0))
{
fknee = 0;
}
else
{
fknee = (sfl/sid);
}
siavl = (MULT_i*shot_iavl);
if ((sigVds<0))
{
sigs = (MULT_i*(shot_igcsx+shot_igdov));
sigd = (MULT_i*(shot_igcdx+shot_igsov));
ssi = (MULT_i*jnoisex_d);
sdi = (MULT_i*jnoisex_s);
}
else
{
sigs = (MULT_i*(shot_igcsx+shot_igsov));
sigd = (MULT_i*(shot_igcdx+shot_igdov));
ssi = (MULT_i*jnoisex_s);
sdi = (MULT_i*jnoisex_d);
}
lp_vfb = VFB_i;
lp_stvfb = STVFB_i;
lp_tox = (model_.TOX_i);
lp_epsrox = (model_.EPSROX_i);
lp_neff = NEFF_i;
lp_vnsub = VNSUB_i;
lp_nslp = NSLP_i;
lp_dnsub = DNSUB_i;
lp_dphib = DPHIB_i;
lp_np = NP_i;
lp_ct = CT_i;
lp_toxov = (model_.TOXOV_i);
lp_toxovd = (model_.TOXOVD_i);
lp_nov = NOV_i;
lp_novd = NOVD_i;
lp_cf = CF_i;
lp_cfb = CFB_i;
lp_betn = BETN_i;
lp_stbet = STBET_i;
lp_mue = MUE_i;
lp_stmue = STMUE_i;
lp_themu = THEMU_i;
lp_stthemu = STTHEMU_i;
lp_cs = CS_i;
lp_stcs = STCS_i;
lp_xcor = XCOR_i;
lp_stxcor = STXCOR_i;
lp_feta = FETA_i;
lp_rs = RS_i;
lp_strs = STRS_i;
lp_rsb = RSB_i;
lp_rsg = RSG_i;
lp_thesat = THESAT_i;
lp_stthesat = STTHESAT_i;
lp_thesatb = THESATB_i;
lp_thesatg = THESATG_i;
lp_ax = AX_i;
lp_alp = ALP_i;
lp_alp1 = ALP1_i;
lp_alp2 = ALP2_i;
lp_vp = VP_i;
lp_a1 = A1_i;
lp_a2 = A2_i;
lp_sta2 = STA2_i;
lp_a3 = A3_i;
lp_a4 = A4_i;
lp_gco = GCO_i;
lp_iginv = IGINV_i;
lp_igov = IGOV_i;
lp_igovd = IGOVD_i;
lp_stig = STIG_i;
lp_gc2 = GC2_i;
lp_gc3 = GC3_i;
lp_chib = CHIB_i;
lp_agidl = AGIDL_i;
lp_agidld = AGIDLD_i;
lp_bgidl = BGIDL_T;
lp_bgidld = BGIDLD_T;
lp_stbgidl = STBGIDL_i;
lp_stbgidld = STBGIDLD_i;
lp_cgidl = CGIDL_i;
lp_cgidld = CGIDLD_i;
lp_cox = COX_i;
lp_cgov = CGOV_i;
lp_cgovd = CGOVD_i;
lp_cgbov = CGBOV_i;
lp_cfr = CFR_i;
lp_cfrd = CFRD_i;
lp_fnt = FNT_i;
lp_fntexc = FNTEXC_i;
lp_nfa = NFA_i;
lp_nfb = NFB_i;
lp_nfc = NFC_i;
lp_ef = EF_i;
lp_rg = RG_i;
lp_rbulk = RBULK_i;
lp_rwell = RWELL_i;
lp_rjuns = RJUNS_i;
lp_rjund = RJUND_i;
tk = (model_.TKD);
cjosbot = ((MULT_i*ABSOURCE_i)*(model_.cjobot));
cjossti = ((MULT_i*LSSOURCE_i)*(model_.cjosti));
cjosgat = ((MULT_i*LGSOURCE_i)*(model_.cjogat));
vbisbot = (model_.vbibot);
vbissti = (model_.vbisti);
vbisgat = (model_.vbigat);
cjosbotd = ((MULT_i*ABDRAIN_i)*(model_.cjobot_d));
cjosstid = ((MULT_i*LSDRAIN_i)*(model_.cjosti_d));
cjosgatd = ((MULT_i*LGDRAIN_i)*(model_.cjogat_d));
vbisbotd = (model_.vbibot_d);
vbisstid = (model_.vbisti_d);
vbisgatd = (model_.vbigat_d);
}
// End block OPinfo
}
// End block evaluateblock


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_D_GND] =  "
         <<probeVars[admsProbeID_V_D_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_GND] =  "
         <<probeVars[admsProbeID_V_BS_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_GND] =  "
         <<probeVars[admsProbeID_V_BD_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_GND] =  "
         <<probeVars[admsProbeID_V_S_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_GND] =  "
         <<probeVars[admsProbeID_V_BP_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_GND] =  "
         <<probeVars[admsProbeID_V_GP_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI_GND] =  "
         <<probeVars[admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI2_GND] =  "
         <<probeVars[admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_BD] =  "
         <<probeVars[admsProbeID_V_D_BD] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_BS] =  "
         <<probeVars[admsProbeID_V_S_BS] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_BP] =  "
         <<probeVars[admsProbeID_V_S_BP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_S] =  "
         <<probeVars[admsProbeID_V_D_S] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_S] =  "
         <<probeVars[admsProbeID_V_GP_S] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_B_BI] =  "
         <<probeVars[admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_BI] =  "
         <<probeVars[admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_BI] =  "
         <<probeVars[admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_BI] =  "
         <<probeVars[admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_GP] =  "
         <<probeVars[admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_D] =  "
         <<staticContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_D] =  "
         <<dynamicContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_G] =  "
         <<staticContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_G] =  "
         <<dynamicContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_S] =  "
         <<staticContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_S] =  "
         <<dynamicContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_B] =  "
         <<staticContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_B] =  "
         <<dynamicContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI] =  "
         <<staticContributions[admsNodeID_NOI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI] =  "
         <<dynamicContributions[admsNodeID_NOI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI2] =  "
         <<staticContributions[admsNodeID_NOI2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI2] =  "
         <<dynamicContributions[admsNodeID_NOI2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_GP] =  "
         <<staticContributions[admsNodeID_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_GP] =  "
         <<dynamicContributions[admsNodeID_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BP] =  "
         <<staticContributions[admsNodeID_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BP] =  "
         <<dynamicContributions[admsNodeID_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BI] =  "
         <<staticContributions[admsNodeID_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BI] =  "
         <<dynamicContributions[admsNodeID_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BS] =  "
         <<staticContributions[admsNodeID_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BS] =  "
         <<dynamicContributions[admsNodeID_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BD] =  "
         <<staticContributions[admsNodeID_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_BD) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_BS) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_BP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_S) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_S) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BD] =  "
         <<dynamicContributions[admsNodeID_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_BD) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_BS) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_BP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_S) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_S) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 11; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 12;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_GP");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_G;
noiseData.li_Neg[0]=li_GP;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BP_BI");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_BP;
noiseData.li_Neg[1]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_BI");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_BS;
noiseData.li_Neg[2]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_BI");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_BD;
noiseData.li_Neg[3]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_B_BI");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_B;
noiseData.li_Neg[4]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_NOI2_GND")+std::string("_")+std::string("igig");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_NOI2;
noiseData.li_Neg[5]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_D_S")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[6]=theNoiseName;
noiseData.li_Pos[6]=li_D;
noiseData.li_Neg[6]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_S")+std::string("_")+std::string("idid");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[7]=theNoiseName;
noiseData.li_Pos[7]=li_D;
noiseData.li_Neg[7]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_S")+std::string("_")+std::string("igs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[8]=theNoiseName;
noiseData.li_Pos[8]=li_GP;
noiseData.li_Neg[8]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_D")+std::string("_")+std::string("igd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[9]=theNoiseName;
noiseData.li_Pos[9]=li_GP;
noiseData.li_Neg[9]=li_D;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_S")+std::string("_")+std::string("ibs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[10]=theNoiseName;
noiseData.li_Pos[10]=li_BS;
noiseData.li_Neg[10]=li_S;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_D")+std::string("_")+std::string("ibd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[11]=theNoiseName;
noiseData.li_Pos[11]=li_BD;
noiseData.li_Neg[11]=li_D;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];
noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
noiseData.noiseDens[6] = noiseContribsPower[6];

      noiseData.noiseDens[6] /= pow(noiseData.freq,noiseContribsExponent[6]);noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
noiseData.noiseDens[7] = noiseContribsPower[7];
noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
noiseData.noiseDens[8] = noiseContribsPower[8];
noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
noiseData.noiseDens[9] = noiseContribsPower[9];
noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
noiseData.noiseDens[10] = noiseContribsPower[10];
noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
noiseData.noiseDens[11] = noiseContribsPower[11];
noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_D_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*f_D_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*f_BP_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*f_BP_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*f_D_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*f_BP_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S];
  (*f_D_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S];
  (*f_BP_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  (*f_S_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*f_S_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*f_S_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*f_S_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S];
  (*f_GP_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*f_GP_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*f_GP_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S];
  (*f_GP_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  (*f_BS_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*f_BS_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*f_S_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS];
  (*f_BS_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*f_BS_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*f_S_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD];
  (*f_BD_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*f_BD_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*f_D_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS];
  (*f_BD_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*f_BD_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*f_D_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD];
  (*f_G_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_G_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_GP_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  (*f_BP_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BS_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  (*f_BI_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  (*f_BD_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  (*f_BI_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  (*f_B_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_B_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_BI_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  (*f_NOI2_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  (*f_NOI2_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  (*f_NOI2_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  (*f_NOI2_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S];
  (*f_NOI2_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S];
  (*f_NOI_Equ_S_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*f_NOI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*f_NOI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  (*f_NOI_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  (*f_NOI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  (*f_NOI_Equ_NOI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*f_D_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND];
  (*f_S_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND];
  (*f_BS_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP];
  (*f_BS_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S];
  (*f_BD_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP];
  (*f_BD_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S];

#else
  //use the offsets instead of pointers
  dFdx[li_D][A_D_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_D][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dFdx[li_D][A_D_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dFdx[li_BP][A_BP_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dFdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dFdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_D][admsProbeID_V_D_S];
  dFdx[li_BP][A_BP_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_D_S];
  dFdx[li_D][A_D_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_GP_S];
  dFdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  dFdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_S][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dFdx[li_S][A_S_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dFdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_staticContributions[admsNodeID_S][admsProbeID_V_D_S];
  dFdx[li_S][A_S_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_GP_S];
  dFdx[li_GP][A_GP_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S] -d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dFdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dFdx[li_GP][A_GP_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_D_S];
  dFdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  dFdx[li_BS][A_BS_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dFdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dFdx[li_S][A_S_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_BS];
  dFdx[li_BS][A_BS_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dFdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dFdx[li_S][A_S_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_D_BD];
  dFdx[li_BD][A_BD_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dFdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dFdx[li_D][A_D_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_S_BS];
  dFdx[li_BD][A_BD_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_S] +d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dFdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dFdx[li_D][A_D_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_BD];
  dFdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_G][A_G_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_GP][A_GP_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  dFdx[li_BP][A_BP_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BS][A_BS_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  dFdx[li_BI][A_BI_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  dFdx[li_BD][A_BD_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  dFdx[li_BI][A_BI_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  dFdx[li_B][A_B_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_B][A_B_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_BI][A_BI_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI2][A_NOI2_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_BP];
  dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_S];
  dFdx[li_NOI2][A_NOI2_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_S];
  dFdx[li_NOI][A_NOI_Equ_S_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  dFdx[li_NOI][A_NOI_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dFdx[li_D][A_D_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND];
  dFdx[li_S][A_S_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND];
  dFdx[li_BS][A_BS_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_S_BP];
  dFdx[li_BS][A_BS_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_S];
  dFdx[li_BD][A_BD_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_S_BP];
  dFdx[li_BD][A_BD_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_S];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_D_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*q_D_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  (*q_BP_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*q_BP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  (*q_D_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  (*q_BP_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S];
  (*q_D_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S];
  (*q_BP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  (*q_S_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*q_S_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  (*q_S_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  (*q_S_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S];
  (*q_GP_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*q_GP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  (*q_GP_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S];
  (*q_GP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  (*q_BS_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*q_BS_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  (*q_S_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS];
  (*q_BS_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*q_BS_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  (*q_S_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD];
  (*q_BD_Equ_S_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*q_BD_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  (*q_D_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS];
  (*q_BD_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*q_BD_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  (*q_D_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD];
  (*q_NOI_Equ_S_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*q_NOI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  (*q_NOI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  (*q_NOI_Equ_D_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  (*q_NOI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*q_GP_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  (*q_S_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND];
  (*q_D_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_D][A_D_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S] -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dQdx[li_D][A_D_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BP];
  dQdx[li_BP][A_BP_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dQdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_BP];
  dQdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_S];
  dQdx[li_BP][A_BP_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_S];
  dQdx[li_D][A_D_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_S];
  dQdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_S];
  dQdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dQdx[li_S][A_S_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BP];
  dQdx[li_S][A_S_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD] +d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_S];
  dQdx[li_S][A_S_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_S];
  dQdx[li_GP][A_GP_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dQdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_BP];
  dQdx[li_GP][A_GP_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_S];
  dQdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_S];
  dQdx[li_BS][A_BS_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dQdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_BS];
  dQdx[li_S][A_S_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_BS];
  dQdx[li_BS][A_BS_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dQdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_BD];
  dQdx[li_S][A_S_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_BD];
  dQdx[li_BD][A_BD_Equ_S_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dQdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_BS];
  dQdx[li_D][A_D_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_BS];
  dQdx[li_BD][A_BD_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dQdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_BD];
  dQdx[li_D][A_D_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_BD];
  dQdx[li_NOI][A_NOI_Equ_S_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_BP];
  dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_S];
  dQdx[li_NOI][A_NOI_Equ_D_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_S];
  dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dQdx[li_GP][A_GP_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  dQdx[li_S][A_S_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND];
  dQdx[li_D][A_D_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter TYPE : [ (-1), 1 ]
  if ( (!((TYPE >=(-1) && TYPE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ]";
  }

//    Parameter TR : [ (-273.0),  (+inf) [
  if ( (!((TR >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TR value " << TR << " out of range [ (-273.0),  (+inf) [";
  }

//    Parameter SWIGATE : [ 0.0, 1.0 ]
  if ( (!((SWIGATE >=0.0 && SWIGATE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWIGATE value " << SWIGATE << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter SWIMPACT : [ 0.0, 1.0 ]
  if ( (!((SWIMPACT >=0.0 && SWIMPACT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWIMPACT value " << SWIMPACT << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter SWGIDL : [ 0.0, 1.0 ]
  if ( (!((SWGIDL >=0.0 && SWGIDL <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWGIDL value " << SWGIDL << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter SWJUNCAP : [ 0.0, 3.0 ]
  if ( (!((SWJUNCAP >=0.0 && SWJUNCAP <=3.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWJUNCAP value " << SWJUNCAP << " out of range [ 0.0, 3.0 ]";
  }

//    Parameter QMC : [ 0.0,  (+inf) [
  if ( (!((QMC >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter QMC value " << QMC << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter TOXO : [ 1e-10,  (+inf) [
  if ( (!((TOXO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXO value " << TOXO << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter EPSROXO : [ 1.0,  (+inf) [
  if ( (!((EPSROXO >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter EPSROXO value " << EPSROXO << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NSUBO : [ 1e20,  (+inf) [
  if ( (!((NSUBO >=1e20))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NSUBO value " << NSUBO << " out of range [ 1e20,  (+inf) [";
  }

//    Parameter WSEG : [ 1e-10,  (+inf) [
  if ( (!((WSEG >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WSEG value " << WSEG << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter NPCK : [ 0.0,  (+inf) [
  if ( (!((NPCK >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter NPCK value " << NPCK << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter WSEGP : [ 1e-10,  (+inf) [
  if ( (!((WSEGP >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WSEGP value " << WSEGP << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter LPCK : [ 1e-10,  (+inf) [
  if ( (!((LPCK >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LPCK value " << LPCK << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter TOXOVO : [ 1e-10,  (+inf) [
  if ( (!((TOXOVO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXOVO value " << TOXOVO << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter TOXOVDO : [ 1e-10,  (+inf) [
  if ( (!((TOXOVDO >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TOXOVDO value " << TOXOVDO << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter LOV : [ 0.0,  (+inf) [
  if ( (!((LOV >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LOV value " << LOV << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LOVD : [ 0.0,  (+inf) [
  if ( (!((LOVD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LOVD value " << LOVD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LP1 : [ 1e-10,  (+inf) [
  if ( (!((LP1 >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LP1 value " << LP1 << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter LP2 : [ 1e-10,  (+inf) [
  if ( (!((LP2 >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LP2 value " << LP2 << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter WBET : [ 1e-10,  (+inf) [
  if ( (!((WBET >=1e-10))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WBET value " << WBET << " out of range [ 1e-10,  (+inf) [";
  }

//    Parameter AXL : [ 0.0,  (+inf) [
  if ( (!((AXL >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter AXL value " << AXL << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter ALP1L2 : [ 0.0,  (+inf) [
  if ( (!((ALP1L2 >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ALP1L2 value " << ALP1L2 << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter ALP2L2 : [ 0.0,  (+inf) [
  if ( (!((ALP2L2 >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter ALP2L2 value " << ALP2L2 << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter FNTEXCL : [ 0.0,  (+inf) [
  if ( (!((FNTEXCL >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FNTEXCL value " << FNTEXCL << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RINT : [ 0.0,  (+inf) [
  if ( (!((RINT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RINT value " << RINT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RVPOLY : [ 0.0,  (+inf) [
  if ( (!((RVPOLY >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RVPOLY value " << RVPOLY << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter RSHG : [ 0.0,  (+inf) [
  if ( (!((RSHG >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter RSHG value " << RSHG << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter SAREF : [ 1e-9,  (+inf) [
  if ( (!((SAREF >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SAREF value " << SAREF << " out of range [ 1e-9,  (+inf) [";
  }

//    Parameter SBREF : [ 1e-9,  (+inf) [
  if ( (!((SBREF >=1e-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SBREF value " << SBREF << " out of range [ 1e-9,  (+inf) [";
  }

//    Parameter KVSAT : [ (-1.0), 1.0 ]
  if ( (!((KVSAT >=(-1.0) && KVSAT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter KVSAT value " << KVSAT << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter LLODKUO : [ 0.0,  (+inf) [
  if ( (!((LLODKUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LLODKUO value " << LLODKUO << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter WLODKUO : [ 0.0,  (+inf) [
  if ( (!((WLODKUO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WLODKUO value " << WLODKUO << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LLODVTH : [ 0.0,  (+inf) [
  if ( (!((LLODVTH >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LLODVTH value " << LLODVTH << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter WLODVTH : [ 0.0,  (+inf) [
  if ( (!((WLODVTH >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter WLODVTH value " << WLODVTH << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LODETAO : [ 0.0,  (+inf) [
  if ( (!((LODETAO >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter LODETAO value " << LODETAO << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter SCREF : [ 0.0,  (+inf) [
  if ( (!((SCREF >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SCREF value " << SCREF << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter IMAX : [ 1E-12,  (+inf) [
  if ( (!((IMAX >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IMAX value " << IMAX << " out of range [ 1E-12,  (+inf) [";
  }

//    Parameter TRJ : [ (-250),  (+inf) [
  if ( (!((TRJ >=(-250)))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter TRJ value " << TRJ << " out of range [ (-250),  (+inf) [";
  }

//    Parameter CJORBOT : [ 1E-12,  (+inf) [
  if ( (!((CJORBOT >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORBOT value " << CJORBOT << " out of range [ 1E-12,  (+inf) [";
  }

//    Parameter CJORSTI : [ 1E-18,  (+inf) [
  if ( (!((CJORSTI >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORSTI value " << CJORSTI << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter CJORGAT : [ 1E-18,  (+inf) [
  if ( (!((CJORGAT >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORGAT value " << CJORGAT << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter VBIRBOT : [ 0.050,  (+inf) [
  if ( (!((VBIRBOT >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRSTI : [ 0.050,  (+inf) [
  if ( (!((VBIRSTI >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRGAT : [ 0.050,  (+inf) [
  if ( (!((VBIRGAT >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter PBOT : [ 0.05, 0.95 ]
  if ( (!((PBOT >=0.05 && PBOT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBOT value " << PBOT << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PSTI : [ 0.05, 0.95 ]
  if ( (!((PSTI >=0.05 && PSTI <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PSTI value " << PSTI << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PGAT : [ 0.05, 0.95 ]
  if ( (!((PGAT >=0.05 && PGAT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PGAT value " << PGAT << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter IDSATRBOT : [ 0,  (+inf) [
  if ( (!((IDSATRBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRSTI : [ 0,  (+inf) [
  if ( (!((IDSATRSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRGAT : [ 0,  (+inf) [
  if ( (!((IDSATRGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHBOT : [ 0,  (+inf) [
  if ( (!((CSRHBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHSTI : [ 0,  (+inf) [
  if ( (!((CSRHSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHGAT : [ 0,  (+inf) [
  if ( (!((CSRHGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter XJUNSTI : [ 1E-9,  (+inf) [
  if ( (!((XJUNSTI >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter XJUNGAT : [ 1E-9,  (+inf) [
  if ( (!((XJUNGAT >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter CTATBOT : [ 0,  (+inf) [
  if ( (!((CTATBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATBOT value " << CTATBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATSTI : [ 0,  (+inf) [
  if ( (!((CTATSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATSTI value " << CTATSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATGAT : [ 0,  (+inf) [
  if ( (!((CTATGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATGAT value " << CTATGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter MEFFTATBOT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATBOT >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATSTI : [ 0.01,  (+inf) [
  if ( (!((MEFFTATSTI >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATGAT : [ 0.01,  (+inf) [
  if ( (!((MEFFTATGAT >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter CBBTBOT : [ 0,  (+inf) [
  if ( (!((CBBTBOT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTSTI : [ 0,  (+inf) [
  if ( (!((CBBTSTI >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTGAT : [ 0,  (+inf) [
  if ( (!((CBBTGAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter CJORBOTD : [ 1E-12,  (+inf) [
  if ( (!((CJORBOTD >=1E-12))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORBOTD value " << CJORBOTD << " out of range [ 1E-12,  (+inf) [";
  }

//    Parameter CJORSTID : [ 1E-18,  (+inf) [
  if ( (!((CJORSTID >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORSTID value " << CJORSTID << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter CJORGATD : [ 1E-18,  (+inf) [
  if ( (!((CJORGATD >=1E-18))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CJORGATD value " << CJORGATD << " out of range [ 1E-18,  (+inf) [";
  }

//    Parameter VBIRBOTD : [ 0.050,  (+inf) [
  if ( (!((VBIRBOTD >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRBOTD value " << VBIRBOTD << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRSTID : [ 0.050,  (+inf) [
  if ( (!((VBIRSTID >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRSTID value " << VBIRSTID << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter VBIRGATD : [ 0.050,  (+inf) [
  if ( (!((VBIRGATD >=0.050))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBIRGATD value " << VBIRGATD << " out of range [ 0.050,  (+inf) [";
  }

//    Parameter PBOTD : [ 0.05, 0.95 ]
  if ( (!((PBOTD >=0.05 && PBOTD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBOTD value " << PBOTD << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PSTID : [ 0.05, 0.95 ]
  if ( (!((PSTID >=0.05 && PSTID <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PSTID value " << PSTID << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter PGATD : [ 0.05, 0.95 ]
  if ( (!((PGATD >=0.05 && PGATD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PGATD value " << PGATD << " out of range [ 0.05, 0.95 ]";
  }

//    Parameter IDSATRBOTD : [ 0,  (+inf) [
  if ( (!((IDSATRBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRBOTD value " << IDSATRBOTD << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRSTID : [ 0,  (+inf) [
  if ( (!((IDSATRSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRSTID value " << IDSATRSTID << " out of range [ 0,  (+inf) [";
  }

//    Parameter IDSATRGATD : [ 0,  (+inf) [
  if ( (!((IDSATRGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter IDSATRGATD value " << IDSATRGATD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHBOTD : [ 0,  (+inf) [
  if ( (!((CSRHBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHBOTD value " << CSRHBOTD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHSTID : [ 0,  (+inf) [
  if ( (!((CSRHSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHSTID value " << CSRHSTID << " out of range [ 0,  (+inf) [";
  }

//    Parameter CSRHGATD : [ 0,  (+inf) [
  if ( (!((CSRHGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CSRHGATD value " << CSRHGATD << " out of range [ 0,  (+inf) [";
  }

//    Parameter XJUNSTID : [ 1E-9,  (+inf) [
  if ( (!((XJUNSTID >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNSTID value " << XJUNSTID << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter XJUNGATD : [ 1E-9,  (+inf) [
  if ( (!((XJUNGATD >=1E-9))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter XJUNGATD value " << XJUNGATD << " out of range [ 1E-9,  (+inf) [";
  }

//    Parameter CTATBOTD : [ 0,  (+inf) [
  if ( (!((CTATBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATBOTD value " << CTATBOTD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATSTID : [ 0,  (+inf) [
  if ( (!((CTATSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATSTID value " << CTATSTID << " out of range [ 0,  (+inf) [";
  }

//    Parameter CTATGATD : [ 0,  (+inf) [
  if ( (!((CTATGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CTATGATD value " << CTATGATD << " out of range [ 0,  (+inf) [";
  }

//    Parameter MEFFTATBOTD : [ 0.01,  (+inf) [
  if ( (!((MEFFTATBOTD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATBOTD value " << MEFFTATBOTD << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATSTID : [ 0.01,  (+inf) [
  if ( (!((MEFFTATSTID >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATSTID value " << MEFFTATSTID << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter MEFFTATGATD : [ 0.01,  (+inf) [
  if ( (!((MEFFTATGATD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter MEFFTATGATD value " << MEFFTATGATD << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter CBBTBOTD : [ 0,  (+inf) [
  if ( (!((CBBTBOTD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTBOTD value " << CBBTBOTD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTSTID : [ 0,  (+inf) [
  if ( (!((CBBTSTID >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTSTID value " << CBBTSTID << " out of range [ 0,  (+inf) [";
  }

//    Parameter CBBTGATD : [ 0,  (+inf) [
  if ( (!((CBBTGATD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter CBBTGATD value " << CBBTGATD << " out of range [ 0,  (+inf) [";
  }

//    Parameter VBRBOTD : [ 0.1,  (+inf) [
  if ( (!((VBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRBOTD value " << VBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRSTID : [ 0.1,  (+inf) [
  if ( (!((VBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRSTID value " << VBRSTID << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRGATD : [ 0.1,  (+inf) [
  if ( (!((VBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VBRGATD value " << VBRGATD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRBOTD : [ 0.1,  (+inf) [
  if ( (!((PBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRBOTD value " << PBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRSTID : [ 0.1,  (+inf) [
  if ( (!((PBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRSTID value " << PBRSTID << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRGATD : [ 0.1,  (+inf) [
  if ( (!((PBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter PBRGATD value " << PBRGATD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

//    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter VJUNREFD : [ 0.5,  (+inf) [
  if ( (!((VJUNREFD >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter VJUNREFD value " << VJUNREFD << " out of range [ 0.5,  (+inf) [";
  }

//    Parameter FJUNQD : [ 0.0,  (+inf) [
  if ( (!((FJUNQD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP102VA: Parameter FJUNQD value " << FJUNQD << " out of range [ 0.0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double deltaEgat_d=0.0;
  double deltaEsti_d=0.0;
  double deltaEbot_d=0.0;
  double ubigat_d=0.0;
  double ubisti_d=0.0;
  double ubibot_d=0.0;
  double phigdgat_d=0.0;
  double phigdsti_d=0.0;
  double phigdbot_d=0.0;
  double phigrgat_d=0.0;
  double phigrsti_d=0.0;
  double phigrbot_d=0.0;
  double deltaEgat=0.0;
  double deltaEsti=0.0;
  double deltaEbot=0.0;
  double ubigat=0.0;
  double ubisti=0.0;
  double ubibot=0.0;
  double phigdgat=0.0;
  double phigdsti=0.0;
  double phigdbot=0.0;
  double deltaphigd=0.0;
  double phigrgat=0.0;
  double phigrsti=0.0;
  double phigrbot=0.0;
  double deltaphigr=0.0;
  double phitrinv=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
  double tkd=0.0;
  double tkr=0.0;
  double STFBBTGATD_i=0.0;
  double STFBBTSTID_i=0.0;
  double STFBBTBOTD_i=0.0;
  double FBBTRGATD_i=0.0;
  double FBBTRSTID_i=0.0;
  double FBBTRBOTD_i=0.0;
  double MEFFTATGATD_i=0.0;
  double MEFFTATSTID_i=0.0;
  double MEFFTATBOTD_i=0.0;
  double XJUNGATD_i=0.0;
  double XJUNSTID_i=0.0;
  double IDSATRGATD_i=0.0;
  double IDSATRSTID_i=0.0;
  double IDSATRBOTD_i=0.0;
  double PHIGGATD_i=0.0;
  double PHIGSTID_i=0.0;
  double PHIGBOTD_i=0.0;
  double CJORGATD_i=0.0;
  double CJORSTID_i=0.0;
  double CJORBOTD_i=0.0;
  double STFBBTGAT_i=0.0;
  double STFBBTSTI_i=0.0;
  double STFBBTBOT_i=0.0;
  double FBBTRGAT_i=0.0;
  double FBBTRSTI_i=0.0;
  double FBBTRBOT_i=0.0;
  double MEFFTATGAT_i=0.0;
  double MEFFTATSTI_i=0.0;
  double MEFFTATBOT_i=0.0;
  double XJUNGAT_i=0.0;
  double XJUNSTI_i=0.0;
  double IDSATRGAT_i=0.0;
  double IDSATRSTI_i=0.0;
  double IDSATRBOT_i=0.0;
  double PHIGGAT_i=0.0;
  double PHIGSTI_i=0.0;
  double PHIGBOT_i=0.0;
  double CJORGAT_i=0.0;
  double CJORSTI_i=0.0;
  double CJORBOT_i=0.0;
  double TRJ_i=0.0;
  double TKD_sq=0.0;
  double TKR=0.0;
  double TR_i=0.0;
//Begin block initial_model
{
TOX_i = ((TOXO>1e-10)?TOXO:1e-10);
TOXOVD_i = ((TOXOVDO>1e-10)?TOXOVDO:1e-10);
EPSROX_i = ((EPSROXO>1.0)?EPSROXO:1.0);
NSUBO_i = ((NSUBO>1e20)?NSUBO:1e20);
WSEG_i = ((WSEG>1e-10)?WSEG:1e-10);
NPCK_i = ((NPCK>0.0)?NPCK:0.0);
WSEGP_i = ((WSEGP>1e-10)?WSEGP:1e-10);
LPCK_i = ((LPCK>1e-10)?LPCK:1e-10);
TOXOV_i = ((TOXOVO>1e-10)?TOXOVO:1e-10);
LOV_i = ((LOV>0.0)?LOV:0.0);
LOVD_i = ((LOVD>0.0)?LOVD:0.0);
LP1_i = ((LP1>1e-10)?LP1:1e-10);
LP2_i = ((LP2>1e-10)?LP2:1e-10);
WBET_i = ((WBET>1e-10)?WBET:1e-10);
AXL_i = ((AXL>0.0)?AXL:0.0);
ALP1L2_i = ((ALP1L2>0.0)?ALP1L2:0.0);
ALP2L2_i = ((ALP2L2>0.0)?ALP2L2:0.0);
SAREF_i = ((SAREF>1e-9)?SAREF:1e-9);
SBREF_i = ((SBREF>1e-9)?SBREF:1e-9);
KVSAT_i = ((KVSAT>(-1.0))?((KVSAT<1.0)?KVSAT:1.0):(-1.0));
LLODKUO_i = ((LLODKUO>0.0)?LLODKUO:0.0);
WLODKUO_i = ((WLODKUO>0.0)?WLODKUO:0.0);
LLODVTH_i = ((LLODVTH>0.0)?LLODVTH:0.0);
WLODVTH_i = ((WLODVTH>0.0)?WLODVTH:0.0);
LODETAO_i = ((LODETAO>0.0)?LODETAO:0.0);
SCREF_i = ((SCREF>0.0)?SCREF:0.0);
WEB_i = WEB;
WEC_i = WEC;
RINT_i = ((RINT>0.0)?RINT:0.0);
RVPOLY_i = ((RVPOLY>0.0)?RVPOLY:0.0);
if ((TYPE>=0))
{
CHNL_TYPE = (+1);
}
else
{
CHNL_TYPE = (-1);
}
TR_i = ((TR>(-273))?TR:(-273));
TKR = (273.15+TR_i);
TKD = (admsModTemp+DTA);
TKD_sq = (TKD*TKD);
dT = (TKD-TKR);
rT = (TKD/TKR);
rTn = (TKR/TKD);
phit = ((TKD*1.3806505E-23)/1.6021918E-19);
inv_phit = (1.0/phit);
Eg = ((1.179-(9.025e-5*TKD))-(3.05e-7*TKD_sq));
phibFac = ((((1.045+(4.5e-4*TKD))*((0.523+(1.4e-3*TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
phibFac = ((phibFac>1.0E-3)?phibFac:1.0E-3);
EPSSI = (8.8541878176E-12*11.8);
nt0 = ((4*1.3806505E-23)*TKD);
TRJ_i = ((TRJ>(-250))?TRJ:(-250));
IMAX_i = ((IMAX>1E-12)?IMAX:1E-12);
CJORBOT_i = ((CJORBOT>1E-12)?CJORBOT:1E-12);
CJORSTI_i = ((CJORSTI>1E-18)?CJORSTI:1E-18);
CJORGAT_i = ((CJORGAT>1E-18)?CJORGAT:1E-18);
VBIRBOT_i = ((VBIRBOT>0.050)?VBIRBOT:0.050);
VBIRSTI_i = ((VBIRSTI>0.050)?VBIRSTI:0.050);
VBIRGAT_i = ((VBIRGAT>0.050)?VBIRGAT:0.050);
PBOT_i = ((PBOT>0.05)?((PBOT<0.95)?PBOT:0.95):0.05);
PSTI_i = ((PSTI>0.05)?((PSTI<0.95)?PSTI:0.95):0.05);
PGAT_i = ((PGAT>0.05)?((PGAT<0.95)?PGAT:0.95):0.05);
PHIGBOT_i = PHIGBOT;
PHIGSTI_i = PHIGSTI;
PHIGGAT_i = PHIGGAT;
IDSATRBOT_i = ((IDSATRBOT>0)?IDSATRBOT:0);
IDSATRSTI_i = ((IDSATRSTI>0)?IDSATRSTI:0);
IDSATRGAT_i = ((IDSATRGAT>0)?IDSATRGAT:0);
CSRHBOT_i = ((CSRHBOT>0)?CSRHBOT:0);
CSRHSTI_i = ((CSRHSTI>0)?CSRHSTI:0);
CSRHGAT_i = ((CSRHGAT>0)?CSRHGAT:0);
XJUNSTI_i = ((XJUNSTI>1E-9)?XJUNSTI:1E-9);
XJUNGAT_i = ((XJUNGAT>1E-9)?XJUNGAT:1E-9);
CTATBOT_i = ((CTATBOT>0)?CTATBOT:0);
CTATSTI_i = ((CTATSTI>0)?CTATSTI:0);
CTATGAT_i = ((CTATGAT>0)?CTATGAT:0);
MEFFTATBOT_i = ((MEFFTATBOT>0.01)?MEFFTATBOT:0.01);
MEFFTATSTI_i = ((MEFFTATSTI>0.01)?MEFFTATSTI:0.01);
MEFFTATGAT_i = ((MEFFTATGAT>0.01)?MEFFTATGAT:0.01);
CBBTBOT_i = ((CBBTBOT>0)?CBBTBOT:0);
CBBTSTI_i = ((CBBTSTI>0)?CBBTSTI:0);
CBBTGAT_i = ((CBBTGAT>0)?CBBTGAT:0);
FBBTRBOT_i = FBBTRBOT;
FBBTRSTI_i = FBBTRSTI;
FBBTRGAT_i = FBBTRGAT;
STFBBTBOT_i = STFBBTBOT;
STFBBTSTI_i = STFBBTSTI;
STFBBTGAT_i = STFBBTGAT;
VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
SWJUNEXP_i = 0.0;
if ((SWJUNEXP>0.5))
{
SWJUNEXP_i = 1.0;
}
else
{
SWJUNEXP_i = 0.0;
}
VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
if ((SWJUNASYM==0.0))
{
CJORBOTD_i = CJORBOT_i;
CJORSTID_i = CJORSTI_i;
CJORGATD_i = CJORGAT_i;
VBIRBOTD_i = VBIRBOT_i;
VBIRSTID_i = VBIRSTI_i;
VBIRGATD_i = VBIRGAT_i;
PBOTD_i = PBOT_i;
PSTID_i = PSTI_i;
PGATD_i = PGAT_i;
PHIGBOTD_i = PHIGBOT_i;
PHIGSTID_i = PHIGSTI_i;
PHIGGATD_i = PHIGGAT_i;
IDSATRBOTD_i = IDSATRBOT_i;
IDSATRSTID_i = IDSATRSTI_i;
IDSATRGATD_i = IDSATRGAT_i;
CSRHBOTD_i = CSRHBOT_i;
CSRHSTID_i = CSRHSTI_i;
CSRHGATD_i = CSRHGAT_i;
XJUNSTID_i = XJUNSTI_i;
XJUNGATD_i = XJUNGAT_i;
CTATBOTD_i = CTATBOT_i;
CTATSTID_i = CTATSTI_i;
CTATGATD_i = CTATGAT_i;
MEFFTATBOTD_i = MEFFTATBOT_i;
MEFFTATSTID_i = MEFFTATSTI_i;
MEFFTATGATD_i = MEFFTATGAT_i;
CBBTBOTD_i = CBBTBOT_i;
CBBTSTID_i = CBBTSTI_i;
CBBTGATD_i = CBBTGAT_i;
FBBTRBOTD_i = FBBTRBOT_i;
FBBTRSTID_i = FBBTRSTI_i;
FBBTRGATD_i = FBBTRGAT_i;
STFBBTBOTD_i = STFBBTBOT_i;
STFBBTSTID_i = STFBBTSTI_i;
STFBBTGATD_i = STFBBTGAT_i;
VBRBOTD_i = VBRBOT_i;
VBRSTID_i = VBRSTI_i;
VBRGATD_i = VBRGAT_i;
PBRBOTD_i = PBRBOT_i;
PBRSTID_i = PBRSTI_i;
PBRGATD_i = PBRGAT_i;
VJUNREFD_i = VJUNREF_i;
FJUNQD_i = FJUNQ_i;
}
else
{
CJORBOTD_i = ((CJORBOTD>1E-12)?CJORBOTD:1E-12);
CJORSTID_i = ((CJORSTID>1E-18)?CJORSTID:1E-18);
CJORGATD_i = ((CJORGATD>1E-18)?CJORGATD:1E-18);
VBIRBOTD_i = ((VBIRBOTD>0.050)?VBIRBOTD:0.050);
VBIRSTID_i = ((VBIRSTID>0.050)?VBIRSTID:0.050);
VBIRGATD_i = ((VBIRGATD>0.050)?VBIRGATD:0.050);
PBOTD_i = ((PBOTD>0.05)?((PBOTD<0.95)?PBOTD:0.95):0.05);
PSTID_i = ((PSTID>0.05)?((PSTID<0.95)?PSTID:0.95):0.05);
PGATD_i = ((PGATD>0.05)?((PGATD<0.95)?PGATD:0.95):0.05);
PHIGBOTD_i = PHIGBOTD;
PHIGSTID_i = PHIGSTID;
PHIGGATD_i = PHIGGATD;
IDSATRBOTD_i = ((IDSATRBOTD>0)?IDSATRBOTD:0);
IDSATRSTID_i = ((IDSATRSTID>0)?IDSATRSTID:0);
IDSATRGATD_i = ((IDSATRGATD>0)?IDSATRGATD:0);
CSRHBOTD_i = ((CSRHBOTD>0)?CSRHBOTD:0);
CSRHSTID_i = ((CSRHSTID>0)?CSRHSTID:0);
CSRHGATD_i = ((CSRHGATD>0)?CSRHGATD:0);
XJUNSTID_i = ((XJUNSTID>1E-9)?XJUNSTID:1E-9);
XJUNGATD_i = ((XJUNGATD>1E-9)?XJUNGATD:1E-9);
CTATBOTD_i = ((CTATBOTD>0)?CTATBOTD:0);
CTATSTID_i = ((CTATSTID>0)?CTATSTID:0);
CTATGATD_i = ((CTATGATD>0)?CTATGATD:0);
MEFFTATBOTD_i = ((MEFFTATBOTD>0.01)?MEFFTATBOTD:0.01);
MEFFTATSTID_i = ((MEFFTATSTID>0.01)?MEFFTATSTID:0.01);
MEFFTATGATD_i = ((MEFFTATGATD>0.01)?MEFFTATGATD:0.01);
CBBTBOTD_i = ((CBBTBOTD>0)?CBBTBOTD:0);
CBBTSTID_i = ((CBBTSTID>0)?CBBTSTID:0);
CBBTGATD_i = ((CBBTGATD>0)?CBBTGATD:0);
FBBTRBOTD_i = FBBTRBOTD;
FBBTRSTID_i = FBBTRSTID;
FBBTRGATD_i = FBBTRGATD;
STFBBTBOTD_i = STFBBTBOTD;
STFBBTSTID_i = STFBBTSTID;
STFBBTGATD_i = STFBBTGATD;
VBRBOTD_i = ((VBRBOTD>0.1)?VBRBOTD:0.1);
VBRSTID_i = ((VBRSTID>0.1)?VBRSTID:0.1);
VBRGATD_i = ((VBRGATD>0.1)?VBRGATD:0.1);
PBRBOTD_i = ((PBRBOTD>0.1)?PBRBOTD:0.1);
PBRSTID_i = ((PBRSTID>0.1)?PBRSTID:0.1);
PBRGATD_i = ((PBRGATD>0.1)?PBRGATD:0.1);
VJUNREFD_i = ((VJUNREFD>0.5)?VJUNREFD:0.5);
FJUNQD_i = ((FJUNQD>0.0)?FJUNQD:0.0);
}
tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsModTemp+DTA),(273.15+(-250)));
tkd = value_max_0;
}
auxt = (tkd/tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
phitr = (KBOL_over_QELE*tkr);
phitrinv = (1.0/phitr);
phitd = (KBOL_over_QELE*tkd);
phitdinv = (1.0/phitd);
deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
phigrbot = (PHIGBOT_i+deltaphigr);
phigrsti = (PHIGSTI_i+deltaphigr);
phigrgat = (PHIGGAT_i+deltaphigr);
deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
phigdbot = (PHIGBOT_i+deltaphigd);
phigdsti = (PHIGSTI_i+deltaphigd);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv))));
ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv))));
ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv))));
ftdgat = (value_pow_0*value_exp_1);
}
idsatbot = ((IDSATRBOT_i*ftdbot)*ftdbot);
idsatsti = ((IDSATRSTI_i*ftdsti)*ftdsti);
idsatgat = ((IDSATRGAT_i*ftdgat)*ftdgat);
{
double value_log_0 = log(ftdbot);
ubibot = ((VBIRBOT_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdsti);
ubisti = ((VBIRSTI_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdgat);
ubigat = ((VBIRGAT_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbibot = (ubibot+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbisti = (ubisti+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbigat = (ubigat+(phitd*value_log_1));
}
vbiinvbot = (1.0/vbibot);
vbiinvsti = (1.0/vbisti);
vbiinvgat = (1.0/vbigat);
one_minus_PBOT = (1-PBOT_i);
one_minus_PSTI = (1-PSTI_i);
one_minus_PGAT = (1-PGAT_i);
one_over_one_minus_PBOT = (1/one_minus_PBOT);
one_over_one_minus_PSTI = (1/one_minus_PSTI);
one_over_one_minus_PGAT = (1/one_minus_PGAT);
{
double value_pow_0 = pow((VBIRBOT_i*vbiinvbot),PBOT_i);
cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRSTI_i*vbiinvsti),PSTI_i);
cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRGAT_i*vbiinvgat),PGAT_i);
cjogat = (CJORGAT_i*value_pow_0);
}
qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
qpref2bot = (2*cjobot);
qpref2sti = (2*cjosti);
qpref2gat = (2*cjogat);
wdepnulrbot = (EPSSI/CJORBOT_i);
wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
wdepnulrinvbot = (1/wdepnulrbot);
wdepnulrinvsti = (1/wdepnulrsti);
wdepnulrinvgat = (1/wdepnulrgat);
VBIRBOTinv = (1/VBIRBOT_i);
VBIRSTIinv = (1/VBIRSTI_i);
VBIRGATinv = (1/VBIRGAT_i);
perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(perfc,(-2));
berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3.0);
}
cerfc = ((1.0-0.29214664)-berfc);
{
double value_max_0 = std::max((0.5*phigdbot),phitd);
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),phitd);
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),phitd);
deltaEgat = value_max_0;
}
atatbot = (deltaEbot*phitdinv);
atatsti = (deltaEsti*phitdinv);
atatgat = (deltaEgat*phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
}
fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(tkd-tkr))));
fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(tkd-tkr))));
fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(tkd-tkr))));
fbbtbot = ((fbbtbot>0)?fbbtbot:0);
fbbtsti = ((fbbtsti>0)?fbbtsti:0);
fbbtgat = ((fbbtgat>0)?fbbtgat:0);
{
double value_pow_0 = pow(0.999,PBRBOT_i);
fstopbot = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,PBRSTI_i);
fstopsti = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,PBRGAT_i);
fstopgat = (1/(1-value_pow_0));
}
VBRinvbot = (1/VBRBOT_i);
VBRinvsti = (1/VBRSTI_i);
VBRinvgat = (1/VBRGAT_i);
{
double value_pow_0 = pow(0.999,(PBRBOT_i-1));
slopebot = (((-((fstopbot*fstopbot)*value_pow_0))*PBRBOT_i)*VBRinvbot);
}
{
double value_pow_0 = pow(0.999,(PBRSTI_i-1));
slopesti = (((-((fstopsti*fstopsti)*value_pow_0))*PBRSTI_i)*VBRinvsti);
}
{
double value_pow_0 = pow(0.999,(PBRGAT_i-1));
slopegat = (((-((fstopgat*fstopgat)*value_pow_0))*PBRGAT_i)*VBRinvgat);
}
phigrbot_d = (PHIGBOTD_i+deltaphigr);
phigrsti_d = (PHIGSTID_i+deltaphigr);
phigrgat_d = (PHIGGATD_i+deltaphigr);
phigdbot_d = (PHIGBOTD_i+deltaphigd);
phigdsti_d = (PHIGSTID_i+deltaphigd);
phigdgat_d = (PHIGGATD_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*phitdinv))));
ftdbot_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*phitdinv))));
ftdsti_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*phitdinv))));
ftdgat_d = (value_pow_0*value_exp_1);
}
idsatbot_d = ((IDSATRBOTD_i*ftdbot_d)*ftdbot_d);
idsatsti_d = ((IDSATRSTID_i*ftdsti_d)*ftdsti_d);
idsatgat_d = ((IDSATRGATD_i*ftdgat_d)*ftdgat_d);
{
double value_log_0 = log(ftdbot_d);
ubibot_d = ((VBIRBOTD_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdsti_d);
ubisti_d = ((VBIRSTID_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdgat_d);
ubigat_d = ((VBIRGATD_i*auxt)-((2*phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot_d)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbibot_d = (ubibot_d+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti_d)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbisti_d = (ubisti_d+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat_d)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbigat_d = (ubigat_d+(phitd*value_log_1));
}
vbiinvbot_d = (1.0/vbibot_d);
vbiinvsti_d = (1.0/vbisti_d);
vbiinvgat_d = (1.0/vbigat_d);
one_minus_PBOT_d = (1-PBOTD_i);
one_minus_PSTI_d = (1-PSTID_i);
one_minus_PGAT_d = (1-PGATD_i);
one_over_one_minus_PBOT_d = (1/one_minus_PBOT_d);
one_over_one_minus_PSTI_d = (1/one_minus_PSTI_d);
one_over_one_minus_PGAT_d = (1/one_minus_PGAT_d);
{
double value_pow_0 = pow((VBIRBOTD_i*vbiinvbot_d),PBOTD_i);
cjobot_d = (CJORBOTD_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRSTID_i*vbiinvsti_d),PSTID_i);
cjosti_d = (CJORSTID_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRGATD_i*vbiinvgat_d),PGATD_i);
cjogat_d = (CJORGATD_i*value_pow_0);
}
qprefbot_d = ((cjobot_d*vbibot_d)*one_over_one_minus_PBOT_d);
qprefsti_d = ((cjosti_d*vbisti_d)*one_over_one_minus_PSTI_d);
qprefgat_d = ((cjogat_d*vbigat_d)*one_over_one_minus_PGAT_d);
qpref2bot_d = (2*cjobot_d);
qpref2sti_d = (2*cjosti_d);
qpref2gat_d = (2*cjogat_d);
wdepnulrbot_d = (EPSSI/CJORBOTD_i);
wdepnulrsti_d = ((XJUNSTID_i*EPSSI)/CJORSTID_i);
wdepnulrgat_d = ((XJUNGATD_i*EPSSI)/CJORGATD_i);
wdepnulrinvbot_d = (1/wdepnulrbot_d);
wdepnulrinvsti_d = (1/wdepnulrsti_d);
wdepnulrinvgat_d = (1/wdepnulrgat_d);
VBIRBOTinv_d = (1/VBIRBOTD_i);
VBIRSTIinv_d = (1/VBIRSTID_i);
VBIRGATinv_d = (1/VBIRGATD_i);
{
double value_max_0 = std::max((0.5*phigdbot_d),phitd);
deltaEbot_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti_d),phitd);
deltaEsti_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat_d),phitd);
deltaEgat_d = value_max_0;
}
atatbot_d = (deltaEbot_d*phitdinv);
atatsti_d = (deltaEsti_d*phitdinv);
atatgat_d = (deltaEgat_d*phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
btatpartbot_d = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
btatpartsti_d = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
btatpartgat_d = (value_sqrt_0/(3*1.05457168E-34));
}
fbbtbot_d = (FBBTRBOTD_i*(1+(STFBBTBOTD_i*(tkd-tkr))));
fbbtsti_d = (FBBTRSTID_i*(1+(STFBBTSTID_i*(tkd-tkr))));
fbbtgat_d = (FBBTRGATD_i*(1+(STFBBTGATD_i*(tkd-tkr))));
fbbtbot_d = ((fbbtbot_d>0)?fbbtbot_d:0);
fbbtsti_d = ((fbbtsti_d>0)?fbbtsti_d:0);
fbbtgat_d = ((fbbtgat_d>0)?fbbtgat_d:0);
{
double value_pow_0 = pow(0.999,PBRBOTD_i);
fstopbot_d = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,PBRSTID_i);
fstopsti_d = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,PBRGATD_i);
fstopgat_d = (1/(1-value_pow_0));
}
VBRinvbot_d = (1/VBRBOTD_i);
VBRinvsti_d = (1/VBRSTID_i);
VBRinvgat_d = (1/VBRGATD_i);
{
double value_pow_0 = pow(0.999,(PBRBOTD_i-1));
slopebot_d = (((-((fstopbot_d*fstopbot_d)*value_pow_0))*PBRBOTD_i)*VBRinvbot_d);
}
{
double value_pow_0 = pow(0.999,(PBRSTID_i-1));
slopesti_d = (((-((fstopsti_d*fstopsti_d)*value_pow_0))*PBRSTID_i)*VBRinvsti_d);
}
{
double value_pow_0 = pow(0.999,(PBRGATD_i-1));
slopegat_d = (((-((fstopgat_d*fstopgat_d)*value_pow_0))*PBRGATD_i)*VBRinvgat_d);
}
}
// End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(1020),
    TYPE(1.0),
    TR(21.0),
    SWIGATE(0.0),
    SWIMPACT(0.0),
    SWGIDL(0.0),
    SWJUNCAP(0.0),
    SWJUNASYM(0.0),
    QMC(1.0),
    LVARO(0.0),
    LVARL(0.0),
    LVARW(0.0),
    LAP(0.0),
    WVARO(0.0),
    WVARL(0.0),
    WVARW(0.0),
    WOT(0.0),
    DLQ(0.0),
    DWQ(0.0),
    VFBO((-1.0)),
    VFBL(0.0),
    VFBW(0.0),
    VFBLW(0.0),
    STVFBO(5e-4),
    STVFBL(0.0),
    STVFBW(0.0),
    STVFBLW(0.0),
    TOXO(2e-9),
    EPSROXO(3.9),
    NSUBO(3e23),
    NSUBW(0.0),
    WSEG(1e-8),
    NPCK(1e24),
    NPCKW(0.0),
    WSEGP(1e-8),
    LPCK(1e-8),
    LPCKW(0.0),
    FOL1(0.0),
    FOL2(0.0),
    VNSUBO(0.0),
    NSLPO(0.05),
    DNSUBO(0.0),
    DPHIBO(0.0),
    DPHIBL(0.0),
    DPHIBLEXP(1.0),
    DPHIBW(0.0),
    DPHIBLW(0.0),
    NPO(1e26),
    NPL(0.0),
    CTO(0.0),
    CTL(0.0),
    CTLEXP(1.0),
    CTW(0.0),
    CTLW(0.0),
    TOXOVO(2e-9),
    TOXOVDO(2e-9),
    LOV(0),
    LOVD(0),
    NOVO(5e25),
    NOVDO(5e25),
    CFL(0.0),
    CFLEXP(2.0),
    CFW(0.0),
    CFBO(0.0),
    UO(5e-2),
    FBET1(0.0),
    FBET1W(0.0),
    LP1(1e-8),
    LP1W(0.0),
    FBET2(0.0),
    LP2(1e-8),
    BETW1(0.0),
    BETW2(0.0),
    WBET(1e-9),
    STBETO(1.0),
    STBETL(0.0),
    STBETW(0.0),
    STBETLW(0.0),
    MUEO(0.5),
    MUEW(0.0),
    STMUEO(0.0),
    THEMUO(1.5),
    STTHEMUO(1.5),
    CSO(0.0),
    CSL(0.0),
    CSLEXP(0.0),
    CSW(0.0),
    CSLW(0.0),
    STCSO(0.0),
    XCORO(0.0),
    XCORL(0.0),
    XCORW(0.0),
    XCORLW(0.0),
    STXCORO(0.0),
    FETAO(1.0),
    RSW1(2.5e3),
    RSW2(0.0),
    STRSO(1.0),
    RSBO(0.0),
    RSGO(0.0),
    THESATO(0.0),
    THESATL(0.05),
    THESATLEXP(1.0),
    THESATW(0.0),
    THESATLW(0.0),
    STTHESATO(1.0),
    STTHESATL(0.0),
    STTHESATW(0.0),
    STTHESATLW(0.0),
    THESATBO(0.0),
    THESATGO(0.0),
    AXO(18),
    AXL(0.4),
    ALPL(5e-4),
    ALPLEXP(1.0),
    ALPW(0.0),
    ALP1L1(0.0),
    ALP1LEXP(0.5),
    ALP1L2(0.0),
    ALP1W(0.0),
    ALP2L1(0.0),
    ALP2LEXP(0.5),
    ALP2L2(0.0),
    ALP2W(0.0),
    VPO(0.05),
    A1O(1.0),
    A1L(0.0),
    A1W(0.0),
    A2O(10),
    STA2O(0.0),
    A3O(1.0),
    A3L(0.0),
    A3W(0.0),
    A4O(0.0),
    A4L(0.0),
    A4W(0.0),
    GCOO(0.0),
    IGINVLW(0.0),
    IGOVW(0.0),
    IGOVDW(0.0),
    STIGO(2.0),
    GC2O(0.375),
    GC3O(0.063),
    CHIBO(3.1),
    AGIDLW(0.0),
    AGIDLDW(0.0),
    BGIDLO(41),
    BGIDLDO(41),
    STBGIDLO(0.0),
    STBGIDLDO(0.0),
    CGIDLO(0.0),
    CGIDLDO(0.0),
    CGBOVL(0.0),
    CFRW(0.0),
    CFRDW(0.0),
    FNTO(1.0),
    FNTEXCL(0.0),
    NFALW(8e22),
    NFBLW(3e7),
    NFCLW(0.0),
    EFO(1.0),
    LINTNOI(0.0),
    ALPNOI(2.0),
    DTA(0),
    KVTHOWEO(0),
    KVTHOWEL(0),
    KVTHOWEW(0),
    KVTHOWELW(0),
    KUOWEO(0),
    KUOWEL(0),
    KUOWEW(0),
    KUOWELW(0),
    LMIN(0),
    LMAX(1.0),
    WMIN(0),
    WMAX(1.0),
    RGO(0.0),
    RBULKO(0.0),
    RWELLO(0.0),
    RJUNSO(0.0),
    RJUNDO(0.0),
    RINT(0.0),
    RVPOLY(0.0),
    RSHG(0.0),
    DLSIL(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0),
    KUO(0),
    KVSAT(0),
    TKUO(0),
    LKUO(0),
    WKUO(0),
    PKUO(0),
    LLODKUO(0),
    WLODKUO(0),
    KVTHO(0),
    LKVTHO(0),
    WKVTHO(0),
    PKVTHO(0),
    LLODVTH(0),
    WLODVTH(0),
    STETAO(0),
    LODETAO(1.0),
    SCREF(1e-6),
    WEB(0),
    WEC(0),
    IMAX(1000),
    TRJ(21),
    CJORBOT(1E-3),
    CJORSTI(1E-9),
    CJORGAT(1E-9),
    VBIRBOT(1),
    VBIRSTI(1),
    VBIRGAT(1),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1E-12),
    IDSATRSTI(1E-18),
    IDSATRGAT(1E-18),
    CSRHBOT(1E2),
    CSRHSTI(1E-4),
    CSRHGAT(1E-4),
    XJUNSTI(100E-9),
    XJUNGAT(100E-9),
    CTATBOT(1E2),
    CTATSTI(1E-4),
    CTATGAT(1E-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1E-12),
    CBBTSTI(1E-18),
    CBBTGAT(1E-18),
    FBBTRBOT(1E9),
    FBBTRSTI(1E9),
    FBBTRGAT(1E9),
    STFBBTBOT((-1E-3)),
    STFBBTSTI((-1E-3)),
    STFBBTGAT((-1E-3)),
    VBRBOT(10),
    VBRSTI(10),
    VBRGAT(10),
    PBRBOT(4),
    PBRSTI(4),
    PBRGAT(4),
    CJORBOTD(1E-3),
    CJORSTID(1E-9),
    CJORGATD(1E-9),
    VBIRBOTD(1),
    VBIRSTID(1),
    VBIRGATD(1),
    PBOTD(0.5),
    PSTID(0.5),
    PGATD(0.5),
    PHIGBOTD(1.16),
    PHIGSTID(1.16),
    PHIGGATD(1.16),
    IDSATRBOTD(1E-12),
    IDSATRSTID(1E-18),
    IDSATRGATD(1E-18),
    CSRHBOTD(1E2),
    CSRHSTID(1E-4),
    CSRHGATD(1E-4),
    XJUNSTID(100E-9),
    XJUNGATD(100E-9),
    CTATBOTD(1E2),
    CTATSTID(1E-4),
    CTATGATD(1E-4),
    MEFFTATBOTD(0.25),
    MEFFTATSTID(0.25),
    MEFFTATGATD(0.25),
    CBBTBOTD(1E-12),
    CBBTSTID(1E-18),
    CBBTGATD(1E-18),
    FBBTRBOTD(1E9),
    FBBTRSTID(1E9),
    FBBTRGATD(1E9),
    STFBBTBOTD((-1E-3)),
    STFBBTSTID((-1E-3)),
    STFBBTGATD((-1E-3)),
    VBRBOTD(10),
    VBRSTID(10),
    VBRGATD(10),
    PBRBOTD(4),
    PBRSTID(4),
    PBRGATD(4),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    VJUNREFD(2.5),
    FJUNQD(0.03),
    NSUBO_i(0.0),
    WSEG_i(0.0),
    NPCK_i(0.0),
    WSEGP_i(0.0),
    LPCK_i(0.0),
    LOV_i(0.0),
    LOVD_i(0.0),
    LP1_i(0.0),
    LP2_i(0.0),
    WBET_i(0.0),
    AXL_i(0.0),
    ALP1L2_i(0.0),
    ALP2L2_i(0.0),
    RINT_i(0.0),
    RVPOLY_i(0.0),
    SAREF_i(0.0),
    SBREF_i(0.0),
    KVSAT_i(0.0),
    LLODKUO_i(0.0),
    WLODKUO_i(0.0),
    LLODVTH_i(0.0),
    WLODVTH_i(0.0),
    LODETAO_i(0.0),
    SCREF_i(0.0),
    WEB_i(0.0),
    WEC_i(0.0),
    TOX_i(0.0),
    EPSROX_i(0.0),
    TOXOV_i(0.0),
    TOXOVD_i(0.0),
    TKD(0.0),
    dT(0.0),
    rT(0.0),
    rTn(0.0),
    EPSSI(0.0),
    phit(0.0),
    inv_phit(0.0),
    Eg(0.0),
    phibFac(0.0),
    nt0(0.0),
    CHNL_TYPE(0),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0),
    VBIRBOTD_i(0.0),
    VBIRSTID_i(0.0),
    VBIRGATD_i(0.0),
    PBOTD_i(0.0),
    PSTID_i(0.0),
    PGATD_i(0.0),
    CSRHBOTD_i(0.0),
    CSRHSTID_i(0.0),
    CSRHGATD_i(0.0),
    CTATBOTD_i(0.0),
    CTATSTID_i(0.0),
    CTATGATD_i(0.0),
    CBBTBOTD_i(0.0),
    CBBTSTID_i(0.0),
    CBBTGATD_i(0.0),
    VBRBOTD_i(0.0),
    VBRSTID_i(0.0),
    VBRGATD_i(0.0),
    PBRBOTD_i(0.0),
    PBRSTID_i(0.0),
    PBRGATD_i(0.0),
    VJUNREFD_i(0.0),
    FJUNQD_i(0.0),
    ftdbot_d(0.0),
    ftdsti_d(0.0),
    ftdgat_d(0.0),
    idsatbot_d(0.0),
    idsatsti_d(0.0),
    idsatgat_d(0.0),
    vbibot_d(0.0),
    vbisti_d(0.0),
    vbigat_d(0.0),
    vbiinvbot_d(0.0),
    vbiinvsti_d(0.0),
    vbiinvgat_d(0.0),
    one_minus_PBOT_d(0.0),
    one_minus_PSTI_d(0.0),
    one_minus_PGAT_d(0.0),
    one_over_one_minus_PBOT_d(0.0),
    one_over_one_minus_PSTI_d(0.0),
    one_over_one_minus_PGAT_d(0.0),
    cjobot_d(0.0),
    cjosti_d(0.0),
    cjogat_d(0.0),
    qprefbot_d(0.0),
    qprefsti_d(0.0),
    qprefgat_d(0.0),
    qpref2bot_d(0.0),
    qpref2sti_d(0.0),
    qpref2gat_d(0.0),
    wdepnulrbot_d(0.0),
    wdepnulrsti_d(0.0),
    wdepnulrgat_d(0.0),
    wdepnulrinvbot_d(0.0),
    wdepnulrinvsti_d(0.0),
    wdepnulrinvgat_d(0.0),
    VBIRBOTinv_d(0.0),
    VBIRSTIinv_d(0.0),
    VBIRGATinv_d(0.0),
    atatbot_d(0.0),
    atatsti_d(0.0),
    atatgat_d(0.0),
    btatpartbot_d(0.0),
    btatpartsti_d(0.0),
    btatpartgat_d(0.0),
    fbbtbot_d(0.0),
    fbbtsti_d(0.0),
    fbbtgat_d(0.0),
    fstopbot_d(0.0),
    fstopsti_d(0.0),
    fstopgat_d(0.0),
    VBRinvbot_d(0.0),
    VBRinvsti_d(0.0),
    VBRinvgat_d(0.0),
    slopebot_d(0.0),
    slopesti_d(0.0),
    slopegat_d(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "L  =  " << (*iter)->L << std::endl;
      os << "W  =  " << (*iter)->W << std::endl;
      os << "SA  =  " << (*iter)->SA << std::endl;
      os << "SB  =  " << (*iter)->SB << std::endl;
      os << "SD  =  " << (*iter)->SD << std::endl;
      os << "SCA  =  " << (*iter)->SCA << std::endl;
      os << "SCB  =  " << (*iter)->SCB << std::endl;
      os << "SCC  =  " << (*iter)->SCC << std::endl;
      os << "SC  =  " << (*iter)->SC << std::endl;
      os << "DELVTO  =  " << (*iter)->DELVTO << std::endl;
      os << "FACTUO  =  " << (*iter)->FACTUO << std::endl;
      os << "ABSOURCE  =  " << (*iter)->ABSOURCE << std::endl;
      os << "LSSOURCE  =  " << (*iter)->LSSOURCE << std::endl;
      os << "LGSOURCE  =  " << (*iter)->LGSOURCE << std::endl;
      os << "ABDRAIN  =  " << (*iter)->ABDRAIN << std::endl;
      os << "LSDRAIN  =  " << (*iter)->LSDRAIN << std::endl;
      os << "LGDRAIN  =  " << (*iter)->LGDRAIN << std::endl;
      os << "AS  =  " << (*iter)->AS << std::endl;
      os << "PS  =  " << (*iter)->PS << std::endl;
      os << "AD  =  " << (*iter)->AD << std::endl;
      os << "PD  =  " << (*iter)->PD << std::endl;
      os << "MULT  =  " << (*iter)->MULT << std::endl;
      os << "NF  =  " << (*iter)->NF << std::endl;
      os << "NGCON  =  " << (*iter)->NGCON << std::endl;
      os << "XGW  =  " << (*iter)->XGW << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(102)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 102)
    .registerModelType("nmos", 102)
    .registerModelType("pmos", 102);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double I5=0.0;
double d_I5_dX=0.0;
  double I4=0.0;
double d_I4_dX=0.0;
  double I3=0.0;
double d_I3_dX=0.0;
  double I2=0.0;
double d_I2_dX=0.0;
  double I1=0.0;
double d_I1_dX=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
double d_V3_dX=0.0;
  double V2=0.0;
double d_V2_dX=0.0;
  double V1=0.0;
double d_V1_dX=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double pmax=0.0;
double d_pmax_dX=0.0;
  double vbigat2r=0.0;
double d_vbigat2r_dX=0.0;
  double vbisti2r=0.0;
double d_vbisti2r_dX=0.0;
  double vbibot2r=0.0;
double d_vbibot2r_dX=0.0;
  double pgat2=0.0;
double d_pgat2_dX=0.0;
  double psti2=0.0;
double d_psti2_dX=0.0;
  double pbot2=0.0;
double d_pbot2_dX=0.0;
  double vbigat2=0.0;
double d_vbigat2_dX=0.0;
  double vbisti2=0.0;
double d_vbisti2_dX=0.0;
  double vbibot2=0.0;
double d_vbibot2_dX=0.0;
  double vmaxgat=0.0;
double d_vmaxgat_dX=0.0;
  double vmaxsti=0.0;
double d_vmaxsti_dX=0.0;
  double vmaxbot=0.0;
double d_vmaxbot_dX=0.0;
  double alphaje=0.0;
double d_alphaje_dX=0.0;
  double zfrac=0.0;
double d_zfrac_dX=0.0;
  double tt2=0.0;
double d_tt2_dX=0.0;
  double tt1=0.0;
double d_tt1_dX=0.0;
  double tt0=0.0;
double d_tt0_dX=0.0;
  double I5_cor=0.0;
double d_I5_cor_dX=0.0;
  double I4_cor=0.0;
double d_I4_cor_dX=0.0;
  double I3_cor=0.0;
double d_I3_cor_dX=0.0;
  double I2_cor=0.0;
double d_I2_cor_dX=0.0;
  double I1_cor=0.0;
double d_I1_cor_dX=0.0;
  double mcor_rev=0.0;
double d_mcor_rev_dX=0.0;
  double m0_rev=0.0;
double d_m0_rev_dX=0.0;
  double tempM=0.0;
double d_tempM_dX=0.0;
  double tf_ig=0.0;
double d_tf_ig_dX=0.0;
  double tf_thesat=0.0;
double d_tf_thesat_dX=0.0;
  double tf_ther=0.0;
double d_tf_ther_dX=0.0;
  double tf_xcor=0.0;
double d_tf_xcor_dX=0.0;
  double tf_cs=0.0;
double d_tf_cs_dX=0.0;
  double tf_mue=0.0;
double d_tf_mue_dX=0.0;
  double tf_bet=0.0;
double d_tf_bet_dX=0.0;
  double CoxovPrime_d=0.0;
double d_CoxovPrime_d_dX=0.0;
  double CoxovPrime=0.0;
double d_CoxovPrime_dX=0.0;
  double phix2=0.0;
double d_phix2_dX=0.0;
  double dphibq=0.0;
double d_dphibq_dX=0.0;
  double qb0=0.0;
double d_qb0_dX=0.0;
  double np=0.0;
double d_np_dX=0.0;
  double arg2max=0.0;
double d_arg2max_dX=0.0;
  double tox_sq=0.0;
double d_tox_sq_dX=0.0;
  double CoxPrime=0.0;
double d_CoxPrime_dX=0.0;
  double EPSOX=0.0;
double d_EPSOX_dX=0.0;
  double DELVTO_i=0.0;
double d_DELVTO_i_dX=0.0;
  double FACTUO_i=0.0;
double d_FACTUO_i_dX=0.0;
  double BGIDLD_i=0.0;
double d_BGIDLD_i_dX=0.0;
  double BGIDL_i=0.0;
double d_BGIDL_i_dX=0.0;
  double QMC_i=0.0;
double d_QMC_i_dX=0.0;
  double temp00=0.0;
double d_temp00_dX=0.0;
  double Kstressvth0=0.0;
double d_Kstressvth0_dX=0.0;
  double rhobetaref=0.0;
double d_rhobetaref_dX=0.0;
  double rhobeta=0.0;
double d_rhobeta_dX=0.0;
  double Kstressu0=0.0;
double d_Kstressu0_dX=0.0;
  double tempw=0.0;
double d_tempw_dX=0.0;
  double templ=0.0;
double d_templ_dX=0.0;
  double Wx=0.0;
double d_Wx_dX=0.0;
  double Lx=0.0;
double d_Lx_dX=0.0;
  double Invsbref=0.0;
double d_Invsbref_dX=0.0;
  double Invsaref=0.0;
double d_Invsaref_dX=0.0;
  double Invsb=0.0;
double d_Invsb_dX=0.0;
  double Invsa=0.0;
double d_Invsa_dX=0.0;
  double loop=0.0;
  double tmpb=0.0;
double d_tmpb_dX=0.0;
  double tmpa=0.0;
double d_tmpa_dX=0.0;
  double RJUND=0.0;
double d_RJUND_dX=0.0;
  double RJUNS=0.0;
double d_RJUNS_dX=0.0;
  double RBULK=0.0;
double d_RBULK_dX=0.0;
  double RWELL=0.0;
double d_RWELL_dX=0.0;
  double RG=0.0;
double d_RG_dX=0.0;
  double KUOWE=0.0;
double d_KUOWE_dX=0.0;
  double KVTHOWE=0.0;
double d_KVTHOWE_dX=0.0;
  double EF=0.0;
double d_EF_dX=0.0;
  double NFC=0.0;
double d_NFC_dX=0.0;
  double NFB=0.0;
double d_NFB_dX=0.0;
  double NFA=0.0;
double d_NFA_dX=0.0;
  double FNTEXC=0.0;
double d_FNTEXC_dX=0.0;
  double FNT=0.0;
double d_FNT_dX=0.0;
  double Lred=0.0;
double d_Lred_dX=0.0;
  double Lnoi=0.0;
double d_Lnoi_dX=0.0;
  double temp0=0.0;
double d_temp0_dX=0.0;
  double CFRD=0.0;
double d_CFRD_dX=0.0;
  double CFR=0.0;
double d_CFR_dX=0.0;
  double CGBOV=0.0;
double d_CGBOV_dX=0.0;
  double CGOVD=0.0;
double d_CGOVD_dX=0.0;
  double CGOV=0.0;
double d_CGOV_dX=0.0;
  double COX=0.0;
double d_COX_dX=0.0;
  double CGIDLD=0.0;
double d_CGIDLD_dX=0.0;
  double CGIDL=0.0;
double d_CGIDL_dX=0.0;
  double STBGIDLD=0.0;
double d_STBGIDLD_dX=0.0;
  double STBGIDL=0.0;
double d_STBGIDL_dX=0.0;
  double BGIDLD=0.0;
double d_BGIDLD_dX=0.0;
  double BGIDL=0.0;
double d_BGIDL_dX=0.0;
  double AGIDLD=0.0;
double d_AGIDLD_dX=0.0;
  double AGIDL=0.0;
double d_AGIDL_dX=0.0;
  double CHIB=0.0;
double d_CHIB_dX=0.0;
  double GC3=0.0;
double d_GC3_dX=0.0;
  double GC2=0.0;
double d_GC2_dX=0.0;
  double STIG=0.0;
double d_STIG_dX=0.0;
  double IGOVD=0.0;
double d_IGOVD_dX=0.0;
  double IGOV=0.0;
double d_IGOV_dX=0.0;
  double IGINV=0.0;
double d_IGINV_dX=0.0;
  double GCO=0.0;
double d_GCO_dX=0.0;
  double A4=0.0;
double d_A4_dX=0.0;
  double A3=0.0;
double d_A3_dX=0.0;
  double STA2=0.0;
double d_STA2_dX=0.0;
  double A2=0.0;
double d_A2_dX=0.0;
  double A1=0.0;
double d_A1_dX=0.0;
  double VP=0.0;
double d_VP_dX=0.0;
  double ALP2=0.0;
double d_ALP2_dX=0.0;
  double ALP1=0.0;
double d_ALP1_dX=0.0;
  double tmpx=0.0;
double d_tmpx_dX=0.0;
  double ALP=0.0;
double d_ALP_dX=0.0;
  double AX=0.0;
double d_AX_dX=0.0;
  double THESATG=0.0;
double d_THESATG_dX=0.0;
  double THESATB=0.0;
double d_THESATB_dX=0.0;
  double STTHESAT=0.0;
double d_STTHESAT_dX=0.0;
  double THESAT=0.0;
double d_THESAT_dX=0.0;
  double RSG=0.0;
double d_RSG_dX=0.0;
  double RSB=0.0;
double d_RSB_dX=0.0;
  double STRS=0.0;
double d_STRS_dX=0.0;
  double RS=0.0;
double d_RS_dX=0.0;
  double FETA=0.0;
double d_FETA_dX=0.0;
  double STXCOR=0.0;
double d_STXCOR_dX=0.0;
  double XCOR=0.0;
double d_XCOR_dX=0.0;
  double STCS=0.0;
double d_STCS_dX=0.0;
  double CS=0.0;
double d_CS_dX=0.0;
  double STTHEMU=0.0;
double d_STTHEMU_dX=0.0;
  double THEMU=0.0;
double d_THEMU_dX=0.0;
  double STMUE=0.0;
double d_STMUE_dX=0.0;
  double MUE=0.0;
double d_MUE_dX=0.0;
  double STBET=0.0;
double d_STBET_dX=0.0;
  double BETN=0.0;
double d_BETN_dX=0.0;
  double GWE=0.0;
double d_GWE_dX=0.0;
  double GPE=0.0;
double d_GPE_dX=0.0;
  double LP1e=0.0;
double d_LP1e_dX=0.0;
  double FBET1e=0.0;
double d_FBET1e_dX=0.0;
  double CFB=0.0;
double d_CFB_dX=0.0;
  double CF=0.0;
double d_CF_dX=0.0;
  double NOVD=0.0;
double d_NOVD_dX=0.0;
  double NOV=0.0;
double d_NOV_dX=0.0;
  double TOXOVD=0.0;
double d_TOXOVD_dX=0.0;
  double TOXOV=0.0;
double d_TOXOV_dX=0.0;
  double CT=0.0;
double d_CT_dX=0.0;
  double NP=0.0;
double d_NP_dX=0.0;
  double DPHIB=0.0;
double d_DPHIB_dX=0.0;
  double DNSUB=0.0;
double d_DNSUB_dX=0.0;
  double NSLP=0.0;
double d_NSLP_dX=0.0;
  double VNSUB=0.0;
double d_VNSUB_dX=0.0;
  double NEFF=0.0;
double d_NEFF_dX=0.0;
  double NSUB=0.0;
double d_NSUB_dX=0.0;
  double BB=0.0;
double d_BB_dX=0.0;
  double AA=0.0;
  double LPCKe=0.0;
double d_LPCKe_dX=0.0;
  double NPCKe=0.0;
double d_NPCKe_dX=0.0;
  double NSUB0e=0.0;
double d_NSUB0e_dX=0.0;
  double EPSROX=0.0;
double d_EPSROX_dX=0.0;
  double TOX=0.0;
double d_TOX_dX=0.0;
  double STVFB=0.0;
double d_STVFB_dX=0.0;
  double VFB=0.0;
double d_VFB_dX=0.0;
  double XGWE=0.0;
double d_XGWE_dX=0.0;
  double W_f=0.0;
double d_W_f_dX=0.0;
  double L_slif=0.0;
double d_L_slif_dX=0.0;
  double L_f=0.0;
double d_L_f_dX=0.0;
  double LGD_i=0.0;
double d_LGD_i_dX=0.0;
  double LSD_i=0.0;
double d_LSD_i_dX=0.0;
  double ABD_i=0.0;
double d_ABD_i_dX=0.0;
  double LGS_i=0.0;
double d_LGS_i_dX=0.0;
  double LSS_i=0.0;
double d_LSS_i_dX=0.0;
  double ABS_i=0.0;
double d_ABS_i_dX=0.0;
  double jwcorr=0.0;
double d_jwcorr_dX=0.0;
  double iWE=0.0;
double d_iWE_dX=0.0;
  double iLE=0.0;
double d_iLE_dX=0.0;
  double Wcv=0.0;
double d_Wcv_dX=0.0;
  double Lcv=0.0;
double d_Lcv_dX=0.0;
  double WEcv=0.0;
double d_WEcv_dX=0.0;
  double LEcv=0.0;
double d_LEcv_dX=0.0;
  double delWOD=0.0;
double d_delWOD_dX=0.0;
  double delLPS=0.0;
double d_delLPS_dX=0.0;
  double iW=0.0;
double d_iW_dX=0.0;
  double iL=0.0;
double d_iL_dX=0.0;
  double WEN=0.0;
  double LEN=0.0;
  double NGCON_i=0.0;
double d_NGCON_i_dX=0.0;
  double RSHG_i=0.0;
double d_RSHG_i_dX=0.0;
  double SCC_i=0.0;
double d_SCC_i_dX=0.0;
  double SCB_i=0.0;
double d_SCB_i_dX=0.0;
  double SCA_i=0.0;
double d_SCA_i_dX=0.0;
  double invNF=0.0;
double d_invNF_dX=0.0;
  double NF_i=0.0;
double d_NF_i_dX=0.0;
  double XGW_i=0.0;
double d_XGW_i_dX=0.0;
  double SC_i=0.0;
double d_SC_i_dX=0.0;
  double SD_i=0.0;
double d_SD_i_dX=0.0;
  double SB_i=0.0;
double d_SB_i_dX=0.0;
  double SA_i=0.0;
double d_SA_i_dX=0.0;
  double W_i=0.0;
double d_W_i_dX=0.0;
  double L_i=0.0;
double d_L_i_dX=0.0;
  double PD_i=0.0;
double d_PD_i_dX=0.0;
  double AD_i=0.0;
double d_AD_i_dX=0.0;
  double PS_i=0.0;
double d_PS_i_dX=0.0;
  double AS_i=0.0;
double d_AS_i_dX=0.0;
//Begin block initial_instance
{
instanceStruct.d_instanceVar_ABSOURCE_i_dX = instanceStruct.d_instancePar_ABSOURCE_dX;
instanceStruct.instanceVar_ABSOURCE_i = instanceStruct.instancePar_ABSOURCE;
instanceStruct.d_instanceVar_LSSOURCE_i_dX = instanceStruct.d_instancePar_LSSOURCE_dX;
instanceStruct.instanceVar_LSSOURCE_i = instanceStruct.instancePar_LSSOURCE;
instanceStruct.d_instanceVar_LGSOURCE_i_dX = instanceStruct.d_instancePar_LGSOURCE_dX;
instanceStruct.instanceVar_LGSOURCE_i = instanceStruct.instancePar_LGSOURCE;
instanceStruct.d_instanceVar_ABDRAIN_i_dX = instanceStruct.d_instancePar_ABDRAIN_dX;
instanceStruct.instanceVar_ABDRAIN_i = instanceStruct.instancePar_ABDRAIN;
instanceStruct.d_instanceVar_LSDRAIN_i_dX = instanceStruct.d_instancePar_LSDRAIN_dX;
instanceStruct.instanceVar_LSDRAIN_i = instanceStruct.instancePar_LSDRAIN;
instanceStruct.d_instanceVar_LGDRAIN_i_dX = instanceStruct.d_instancePar_LGDRAIN_dX;
instanceStruct.instanceVar_LGDRAIN_i = instanceStruct.instancePar_LGDRAIN;
d_AS_i_dX = instanceStruct.d_instancePar_AS_dX;
AS_i = instanceStruct.instancePar_AS;
d_PS_i_dX = instanceStruct.d_instancePar_PS_dX;
PS_i = instanceStruct.instancePar_PS;
d_AD_i_dX = instanceStruct.d_instancePar_AD_dX;
AD_i = instanceStruct.instancePar_AD;
d_PD_i_dX = instanceStruct.d_instancePar_PD_dX;
PD_i = instanceStruct.instancePar_PD;
d_L_i_dX = instanceStruct.d_instancePar_L_dX;
L_i = instanceStruct.instancePar_L;
d_W_i_dX = instanceStruct.d_instancePar_W_dX;
W_i = instanceStruct.instancePar_W;
d_SA_i_dX = instanceStruct.d_instancePar_SA_dX;
SA_i = instanceStruct.instancePar_SA;
d_SB_i_dX = instanceStruct.d_instancePar_SB_dX;
SB_i = instanceStruct.instancePar_SB;
d_SD_i_dX = instanceStruct.d_instancePar_SD_dX;
SD_i = instanceStruct.instancePar_SD;
d_SC_i_dX = instanceStruct.d_instancePar_SC_dX;
SC_i = instanceStruct.instancePar_SC;
d_XGW_i_dX = instanceStruct.d_instancePar_XGW_dX;
XGW_i = instanceStruct.instancePar_XGW;
d_NF_i_dX = ((instanceStruct.instancePar_NF>1.0)?instanceStruct.d_instancePar_NF_dX:0.0);
NF_i = ((instanceStruct.instancePar_NF>1.0)?instanceStruct.instancePar_NF:1.0);
{
double value_floor_0 = floor((NF_i+0.5));
d_NF_i_dX = 0.0;
NF_i = floor((NF_i+0.5));
}
d_invNF_dX = (-d_NF_i_dX/NF_i/NF_i);
invNF = (1.0/NF_i);
d_L_i_dX = ((L_i>1e-9)?d_L_i_dX:0.0);
L_i = ((L_i>1e-9)?L_i:1e-9);
d_W_i_dX = (((W_i*invNF)>1e-9)?(W_i*d_invNF_dX+d_W_i_dX*invNF):0.0);
W_i = (((W_i*invNF)>1e-9)?(W_i*invNF):1e-9);
d_SCA_i_dX = ((instanceStruct.instancePar_SCA>0.0)?instanceStruct.d_instancePar_SCA_dX:0.0);
SCA_i = ((instanceStruct.instancePar_SCA>0.0)?instanceStruct.instancePar_SCA:0.0);
d_SCB_i_dX = ((instanceStruct.instancePar_SCB>0.0)?instanceStruct.d_instancePar_SCB_dX:0.0);
SCB_i = ((instanceStruct.instancePar_SCB>0.0)?instanceStruct.instancePar_SCB:0.0);
d_SCC_i_dX = ((instanceStruct.instancePar_SCC>0.0)?instanceStruct.d_instancePar_SCC_dX:0.0);
SCC_i = ((instanceStruct.instancePar_SCC>0.0)?instanceStruct.instancePar_SCC:0.0);
d_RSHG_i_dX = ((modelStruct.modelPar_RSHG>0.0)?modelStruct.d_modelPar_RSHG_dX:0.0);
RSHG_i = ((modelStruct.modelPar_RSHG>0.0)?modelStruct.modelPar_RSHG:0.0);
d_NGCON_i_dX = 0.0;
NGCON_i = ((instanceStruct.instancePar_NGCON<1.5)?1.0:2.0);
LEN = 1e-6;
WEN = 1e-6;
d_iL_dX = (-LEN*d_L_i_dX/L_i/L_i);
iL = (LEN/L_i);
d_iW_dX = (-WEN*d_W_i_dX/W_i/W_i);
iW = (WEN/W_i);
d_delLPS_dX = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(modelStruct.modelPar_LVARW*d_iW_dX+modelStruct.d_modelPar_LVARW_dX*iW)+(modelStruct.modelPar_LVARO*(modelStruct.modelPar_LVARL*d_iL_dX+modelStruct.d_modelPar_LVARL_dX*iL)+modelStruct.d_modelPar_LVARO_dX*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
delLPS = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
d_delWOD_dX = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARL*iL)))*(modelStruct.modelPar_WVARW*d_iW_dX+modelStruct.d_modelPar_WVARW_dX*iW)+(modelStruct.modelPar_WVARO*(modelStruct.modelPar_WVARL*d_iL_dX+modelStruct.d_modelPar_WVARL_dX*iL)+modelStruct.d_modelPar_WVARO_dX*(1.0+(modelStruct.modelPar_WVARL*iL)))*(1.0+(modelStruct.modelPar_WVARW*iW)));
delWOD = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARL*iL)))*(1.0+(modelStruct.modelPar_WVARW*iW)));
instanceStruct.d_instanceVar_LE_dX = ((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))>1e-9)?((d_L_i_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX):0.0);
instanceStruct.instanceVar_LE = ((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))>1e-9)?((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP)):1e-9);
instanceStruct.d_instanceVar_WE_dX = ((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))>1e-9)?((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX):0.0);
instanceStruct.instanceVar_WE = ((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))>1e-9)?((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT)):1e-9);
d_LEcv_dX = (((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ)>1e-9)?(((d_L_i_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX)+modelStruct.d_modelPar_DLQ_dX):0.0);
LEcv = (((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ)>1e-9)?(((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ):1e-9);
d_WEcv_dX = (((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ)>1e-9)?(((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX)+modelStruct.d_modelPar_DWQ_dX):0.0);
WEcv = (((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ)>1e-9)?(((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ):1e-9);
d_Lcv_dX = ((((L_i+delLPS)+modelStruct.modelPar_DLQ)>1e-9)?((d_L_i_dX+d_delLPS_dX)+modelStruct.d_modelPar_DLQ_dX):0.0);
Lcv = ((((L_i+delLPS)+modelStruct.modelPar_DLQ)>1e-9)?((L_i+delLPS)+modelStruct.modelPar_DLQ):1e-9);
d_Wcv_dX = ((((W_i+delWOD)+modelStruct.modelPar_DWQ)>1e-9)?((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_DWQ_dX):0.0);
Wcv = ((((W_i+delWOD)+modelStruct.modelPar_DWQ)>1e-9)?((W_i+delWOD)+modelStruct.modelPar_DWQ):1e-9);
d_iLE_dX = (-LEN*instanceStruct.d_instanceVar_LE_dX/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE);
iLE = (LEN/instanceStruct.instanceVar_LE);
d_iWE_dX = (-WEN*instanceStruct.d_instanceVar_WE_dX/instanceStruct.instanceVar_WE/instanceStruct.instanceVar_WE);
iWE = (WEN/instanceStruct.instanceVar_WE);
d_jwcorr_dX = 0.0;
jwcorr = 0.0;
d_ABS_i_dX = 0.0;
ABS_i = 0.0;
d_LSS_i_dX = 0.0;
LSS_i = 0.0;
d_LGS_i_dX = 0.0;
LGS_i = 0.0;
d_ABD_i_dX = 0.0;
ABD_i = 0.0;
d_LSD_i_dX = 0.0;
LSD_i = 0.0;
d_LGD_i_dX = 0.0;
LGD_i = 0.0;
if ((modelStruct.modelPar_SWJUNCAP==3.0))
{
d_jwcorr_dX = instanceStruct.d_instanceVar_WE_dX;
jwcorr = instanceStruct.instanceVar_WE;
}
if (((modelStruct.modelPar_SWJUNCAP==2.0)||(modelStruct.modelPar_SWJUNCAP==3.0)))
{
d_ABS_i_dX = (AS_i*d_invNF_dX+d_AS_i_dX*invNF);
ABS_i = (AS_i*invNF);
d_LSS_i_dX = ((PS_i*d_invNF_dX+d_PS_i_dX*invNF)-d_jwcorr_dX);
LSS_i = ((PS_i*invNF)-jwcorr);
d_LGS_i_dX = instanceStruct.d_instanceVar_WE_dX;
LGS_i = instanceStruct.instanceVar_WE;
d_ABD_i_dX = (AD_i*d_invNF_dX+d_AD_i_dX*invNF);
ABD_i = (AD_i*invNF);
d_LSD_i_dX = ((PD_i*d_invNF_dX+d_PD_i_dX*invNF)-d_jwcorr_dX);
LSD_i = ((PD_i*invNF)-jwcorr);
d_LGD_i_dX = instanceStruct.d_instanceVar_WE_dX;
LGD_i = instanceStruct.instanceVar_WE;
}
else
{
d_ABS_i_dX = (instanceStruct.instanceVar_ABSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*invNF);
ABS_i = (instanceStruct.instanceVar_ABSOURCE_i*invNF);
d_LSS_i_dX = (instanceStruct.instanceVar_LSSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*invNF);
LSS_i = (instanceStruct.instanceVar_LSSOURCE_i*invNF);
d_LGS_i_dX = (instanceStruct.instanceVar_LGSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*invNF);
LGS_i = (instanceStruct.instanceVar_LGSOURCE_i*invNF);
d_ABD_i_dX = (instanceStruct.instanceVar_ABDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*invNF);
ABD_i = (instanceStruct.instanceVar_ABDRAIN_i*invNF);
d_LSD_i_dX = (instanceStruct.instanceVar_LSDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*invNF);
LSD_i = (instanceStruct.instanceVar_LSDRAIN_i*invNF);
d_LGD_i_dX = (instanceStruct.instanceVar_LGDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*invNF);
LGD_i = (instanceStruct.instanceVar_LGDRAIN_i*invNF);
}
d_L_f_dX = (((L_i+delLPS)>1e-9)?(d_L_i_dX+d_delLPS_dX):0.0);
L_f = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
d_L_slif_dX = (((L_f+modelStruct.modelPar_DLSIL)>1e-9)?(d_L_f_dX+modelStruct.d_modelPar_DLSIL_dX):0.0);
L_slif = (((L_f+modelStruct.modelPar_DLSIL)>1e-9)?(L_f+modelStruct.modelPar_DLSIL):1e-9);
d_W_f_dX = (((W_i+delWOD)>1e-9)?(d_W_i_dX+d_delWOD_dX):0.0);
W_f = (((W_i+delWOD)>1e-9)?(W_i+delWOD):1e-9);
d_XGWE_dX = (((XGW_i-(0.5*delWOD))>1e-9)?(d_XGW_i_dX-0.5*d_delWOD_dX):0.0);
XGWE = (((XGW_i-(0.5*delWOD))>1e-9)?(XGW_i-(0.5*delWOD)):1e-9);
d_VFB_dX = (((modelStruct.modelPar_VFBO*(1.0+(modelStruct.modelPar_VFBL*iLE)))*(1.0+(modelStruct.modelPar_VFBW*iWE)))*((modelStruct.modelPar_VFBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_VFBLW*d_iLE_dX+modelStruct.d_modelPar_VFBLW_dX*iLE)*iWE)+((modelStruct.modelPar_VFBO*(1.0+(modelStruct.modelPar_VFBL*iLE)))*(modelStruct.modelPar_VFBW*d_iWE_dX+modelStruct.d_modelPar_VFBW_dX*iWE)+(modelStruct.modelPar_VFBO*(modelStruct.modelPar_VFBL*d_iLE_dX+modelStruct.d_modelPar_VFBL_dX*iLE)+modelStruct.d_modelPar_VFBO_dX*(1.0+(modelStruct.modelPar_VFBL*iLE)))*(1.0+(modelStruct.modelPar_VFBW*iWE)))*(1.0+((modelStruct.modelPar_VFBLW*iLE)*iWE)));
VFB = (((modelStruct.modelPar_VFBO*(1.0+(modelStruct.modelPar_VFBL*iLE)))*(1.0+(modelStruct.modelPar_VFBW*iWE)))*(1.0+((modelStruct.modelPar_VFBLW*iLE)*iWE)));
d_STVFB_dX = (((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*((modelStruct.modelPar_STVFBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STVFBLW*d_iLE_dX+modelStruct.d_modelPar_STVFBLW_dX*iLE)*iWE)+((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(modelStruct.modelPar_STVFBW*d_iWE_dX+modelStruct.d_modelPar_STVFBW_dX*iWE)+(modelStruct.modelPar_STVFBO*(modelStruct.modelPar_STVFBL*d_iLE_dX+modelStruct.d_modelPar_STVFBL_dX*iLE)+modelStruct.d_modelPar_STVFBO_dX*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*(1.0+((modelStruct.modelPar_STVFBLW*iLE)*iWE)));
STVFB = (((modelStruct.modelPar_STVFBO*(1.0+(modelStruct.modelPar_STVFBL*iLE)))*(1.0+(modelStruct.modelPar_STVFBW*iWE)))*(1.0+((modelStruct.modelPar_STVFBLW*iLE)*iWE)));
d_TOX_dX = modelStruct.d_modelPar_TOXO_dX;
TOX = modelStruct.modelPar_TOXO;
d_EPSROX_dX = modelStruct.d_modelPar_EPSROXO_dX;
EPSROX = modelStruct.modelPar_EPSROXO;
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
d_NSUB0e_dX = (modelStruct.modelVar_NSUBO_i*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0E-03)?((modelStruct.modelPar_NSUBW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEG_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEG_i_dX)/modelStruct.modelVar_WSEG_i/modelStruct.modelVar_WSEG_i))+(modelStruct.modelPar_NSUBW*d_iWE_dX+modelStruct.d_modelPar_NSUBW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_NSUBO_i_dX*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_1)):1.0E-03));
NSUB0e = (modelStruct.modelVar_NSUBO_i*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_1)):1.0E-03));
}
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
d_NPCKe_dX = (modelStruct.modelVar_NPCK_i*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0E-03)?((modelStruct.modelPar_NPCKW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEGP_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEGP_i_dX)/modelStruct.modelVar_WSEGP_i/modelStruct.modelVar_WSEGP_i))+(modelStruct.modelPar_NPCKW*d_iWE_dX+modelStruct.d_modelPar_NPCKW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_NPCK_i_dX*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_1)):1.0E-03));
NPCKe = (modelStruct.modelVar_NPCK_i*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_1)):1.0E-03));
}
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
d_LPCKe_dX = (modelStruct.modelVar_LPCK_i*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0E-03)?((modelStruct.modelPar_LPCKW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEGP_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEGP_i_dX)/modelStruct.modelVar_WSEGP_i/modelStruct.modelVar_WSEGP_i))+(modelStruct.modelPar_LPCKW*d_iWE_dX+modelStruct.d_modelPar_LPCKW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_LPCK_i_dX*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_1)):1.0E-03));
LPCKe = (modelStruct.modelVar_LPCK_i*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0E-03)?(1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_1)):1.0E-03));
}
if ((instanceStruct.instanceVar_LE>(2*LPCKe)))
{
AA = 7.5e10;
{
double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
double value_sqrt_1 = sqrt(NSUB0e);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_BB_dX = (deriv_sqrt_0_d0*((d_NSUB0e_dX+0.5*d_NPCKe_dX))-deriv_sqrt_1_d0*(d_NSUB0e_dX));
BB = (value_sqrt_0-value_sqrt_1);
}
{
double value_sqrt_0 = sqrt(NSUB0e);
double value_exp_1 = exp((BB/AA));
double value_log_2 = log((1+(((2*LPCKe)/instanceStruct.instanceVar_LE)*(value_exp_1-1))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(1+(((2*LPCKe)/instanceStruct.instanceVar_LE)*(value_exp_1-1))));
d_NSUB_dX = (deriv_sqrt_0_d0*(d_NSUB0e_dX)+AA*deriv_log_2_d0*((((2*LPCKe)/instanceStruct.instanceVar_LE)*deriv_exp_1_d0*((d_BB_dX/AA))+((instanceStruct.instanceVar_LE*2*d_LPCKe_dX-(2*LPCKe)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(value_exp_1-1))));
NSUB = (value_sqrt_0+(AA*value_log_2));
}
d_NSUB_dX = (NSUB*d_NSUB_dX+d_NSUB_dX*NSUB);
NSUB = (NSUB*NSUB);
}
else
{
if ((instanceStruct.instanceVar_LE>=LPCKe))
{
d_NSUB_dX = (d_NSUB0e_dX+((instanceStruct.instanceVar_LE*(NPCKe*d_LPCKe_dX+d_NPCKe_dX*LPCKe)-(NPCKe*LPCKe)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE));
NSUB = (NSUB0e+((NPCKe*LPCKe)/instanceStruct.instanceVar_LE));
}
else
{
d_NSUB_dX = (d_NSUB0e_dX+(NPCKe*(-((LPCKe*instanceStruct.d_instanceVar_LE_dX-instanceStruct.instanceVar_LE*d_LPCKe_dX)/LPCKe/LPCKe))+d_NPCKe_dX*(2-(instanceStruct.instanceVar_LE/LPCKe))));
NSUB = (NSUB0e+(NPCKe*(2-(instanceStruct.instanceVar_LE/LPCKe))));
}
}
d_NEFF_dX = (NSUB*((-(modelStruct.modelPar_FOL1*d_iLE_dX+modelStruct.d_modelPar_FOL1_dX*iLE))-((modelStruct.modelPar_FOL2*iLE)*d_iLE_dX+(modelStruct.modelPar_FOL2*d_iLE_dX+modelStruct.d_modelPar_FOL2_dX*iLE)*iLE))+d_NSUB_dX*((1-(modelStruct.modelPar_FOL1*iLE))-((modelStruct.modelPar_FOL2*iLE)*iLE)));
NEFF = (NSUB*((1-(modelStruct.modelPar_FOL1*iLE))-((modelStruct.modelPar_FOL2*iLE)*iLE)));
d_VNSUB_dX = modelStruct.d_modelPar_VNSUBO_dX;
VNSUB = modelStruct.modelPar_VNSUBO;
d_NSLP_dX = modelStruct.d_modelPar_NSLPO_dX;
NSLP = modelStruct.modelPar_NSLPO;
d_DNSUB_dX = modelStruct.d_modelPar_DNSUBO_dX;
DNSUB = modelStruct.modelPar_DNSUBO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_DPHIBLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DPHIBLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_DPHIB_dX = (((modelStruct.modelPar_DPHIBO+(modelStruct.modelPar_DPHIBL*value_pow_0))*(1.0+(modelStruct.modelPar_DPHIBW*iWE)))*((modelStruct.modelPar_DPHIBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_DPHIBLW*d_iLE_dX+modelStruct.d_modelPar_DPHIBLW_dX*iLE)*iWE)+((modelStruct.modelPar_DPHIBO+(modelStruct.modelPar_DPHIBL*value_pow_0))*(modelStruct.modelPar_DPHIBW*d_iWE_dX+modelStruct.d_modelPar_DPHIBW_dX*iWE)+(modelStruct.d_modelPar_DPHIBO_dX+(modelStruct.modelPar_DPHIBL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DPHIBLEXP_dX)))+modelStruct.d_modelPar_DPHIBL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_DPHIBW*iWE)))*(1.0+((modelStruct.modelPar_DPHIBLW*iLE)*iWE)));
DPHIB = (((modelStruct.modelPar_DPHIBO+(modelStruct.modelPar_DPHIBL*value_pow_0))*(1.0+(modelStruct.modelPar_DPHIBW*iWE)))*(1.0+((modelStruct.modelPar_DPHIBLW*iLE)*iWE)));
}
d_NP_dX = (modelStruct.modelPar_NPO*((1e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?0.0:(modelStruct.modelPar_NPL*d_iLE_dX+modelStruct.d_modelPar_NPL_dX*iLE))+modelStruct.d_modelPar_NPO_dX*((1e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?1e-6:(1.0+(modelStruct.modelPar_NPL*iLE))));
NP = (modelStruct.modelPar_NPO*((1e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?1e-6:(1.0+(modelStruct.modelPar_NPL*iLE))));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CTLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CTLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CT_dX = (((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*((modelStruct.modelPar_CTLW*iLE)*d_iWE_dX+(modelStruct.modelPar_CTLW*d_iLE_dX+modelStruct.d_modelPar_CTLW_dX*iLE)*iWE)+((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(modelStruct.modelPar_CTW*d_iWE_dX+modelStruct.d_modelPar_CTW_dX*iWE)+(modelStruct.d_modelPar_CTO_dX+(modelStruct.modelPar_CTL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CTLEXP_dX)))+modelStruct.d_modelPar_CTL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*(1.0+((modelStruct.modelPar_CTLW*iLE)*iWE)));
CT = (((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*(1.0+((modelStruct.modelPar_CTLW*iLE)*iWE)));
}
d_TOXOV_dX = modelStruct.d_modelPar_TOXOVO_dX;
TOXOV = modelStruct.modelPar_TOXOVO;
d_TOXOVD_dX = modelStruct.d_modelPar_TOXOVDO_dX;
TOXOVD = modelStruct.modelPar_TOXOVDO;
d_NOV_dX = modelStruct.d_modelPar_NOVO_dX;
NOV = modelStruct.modelPar_NOVO;
d_NOVD_dX = modelStruct.d_modelPar_NOVDO_dX;
NOVD = modelStruct.modelPar_NOVDO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CFLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CFLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CF_dX = ((modelStruct.modelPar_CFL*value_pow_0)*(modelStruct.modelPar_CFW*d_iWE_dX+modelStruct.d_modelPar_CFW_dX*iWE)+(modelStruct.modelPar_CFL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CFLEXP_dX)))+modelStruct.d_modelPar_CFL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE)));
CF = ((modelStruct.modelPar_CFL*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE)));
}
d_CFB_dX = modelStruct.d_modelPar_CFBO_dX;
CFB = modelStruct.modelPar_CFBO;
d_FBET1e_dX = (modelStruct.modelPar_FBET1*(modelStruct.modelPar_FBET1W*d_iWE_dX+modelStruct.d_modelPar_FBET1W_dX*iWE)+modelStruct.d_modelPar_FBET1_dX*(1.0+(modelStruct.modelPar_FBET1W*iWE)));
FBET1e = (modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)));
d_LP1e_dX = (modelStruct.modelVar_LP1_i*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0E-03)?(modelStruct.modelPar_LP1W*d_iWE_dX+modelStruct.d_modelPar_LP1W_dX*iWE):0.0)+modelStruct.d_modelVar_LP1_i_dX*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0E-03)?(1.0+(modelStruct.modelPar_LP1W*iWE)):1.0E-03));
LP1e = (modelStruct.modelVar_LP1_i*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0E-03)?(1.0+(modelStruct.modelPar_LP1W*iWE)):1.0E-03));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_LE)/LP1e));
double value_exp_1 = exp(((-instanceStruct.instanceVar_LE)/modelStruct.modelVar_LP2_i));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_GPE_dX = ((((FBET1e*LP1e)/instanceStruct.instanceVar_LE)*(-deriv_exp_0_d0*(((LP1e*(-instanceStruct.d_instanceVar_LE_dX)-(-instanceStruct.instanceVar_LE)*d_LP1e_dX)/LP1e/LP1e)))+((instanceStruct.instanceVar_LE*(FBET1e*d_LP1e_dX+d_FBET1e_dX*LP1e)-(FBET1e*LP1e)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(1.0-value_exp_0))+(((modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)/instanceStruct.instanceVar_LE)*(-deriv_exp_1_d0*(((modelStruct.modelVar_LP2_i*(-instanceStruct.d_instanceVar_LE_dX)-(-instanceStruct.instanceVar_LE)*modelStruct.d_modelVar_LP2_i_dX)/modelStruct.modelVar_LP2_i/modelStruct.modelVar_LP2_i)))+((instanceStruct.instanceVar_LE*(modelStruct.modelPar_FBET2*modelStruct.d_modelVar_LP2_i_dX+modelStruct.d_modelPar_FBET2_dX*modelStruct.modelVar_LP2_i)-(modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(1.0-value_exp_1)));
GPE = ((1.0+(((FBET1e*LP1e)/instanceStruct.instanceVar_LE)*(1.0-value_exp_0)))+(((modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)/instanceStruct.instanceVar_LE)*(1.0-value_exp_1)));
}
d_GPE_dX = ((GPE>1e-15)?d_GPE_dX:0.0);
GPE = ((GPE>1e-15)?GPE:1e-15);
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WBET_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WBET_i)));
d_GWE_dX = ((modelStruct.modelPar_BETW1*d_iWE_dX+modelStruct.d_modelPar_BETW1_dX*iWE)+((modelStruct.modelPar_BETW2*iWE)*deriv_log_0_d0*(((modelStruct.modelVar_WBET_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WBET_i_dX)/modelStruct.modelVar_WBET_i/modelStruct.modelVar_WBET_i))+(modelStruct.modelPar_BETW2*d_iWE_dX+modelStruct.d_modelPar_BETW2_dX*iWE)*value_log_0));
GWE = ((1.0+(modelStruct.modelPar_BETW1*iWE))+((modelStruct.modelPar_BETW2*iWE)*value_log_0));
}
d_BETN_dX = (((modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)/(GPE*instanceStruct.instanceVar_LE))*d_GWE_dX+(((GPE*instanceStruct.instanceVar_LE)*(modelStruct.modelPar_UO*instanceStruct.d_instanceVar_WE_dX+modelStruct.d_modelPar_UO_dX*instanceStruct.instanceVar_WE)-(modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)*(GPE*instanceStruct.d_instanceVar_LE_dX+d_GPE_dX*instanceStruct.instanceVar_LE))/(GPE*instanceStruct.instanceVar_LE)/(GPE*instanceStruct.instanceVar_LE))*GWE);
BETN = (((modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)/(GPE*instanceStruct.instanceVar_LE))*GWE);
d_STBET_dX = (((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*((modelStruct.modelPar_STBETLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STBETLW*d_iLE_dX+modelStruct.d_modelPar_STBETLW_dX*iLE)*iWE)+((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(modelStruct.modelPar_STBETW*d_iWE_dX+modelStruct.d_modelPar_STBETW_dX*iWE)+(modelStruct.modelPar_STBETO*(modelStruct.modelPar_STBETL*d_iLE_dX+modelStruct.d_modelPar_STBETL_dX*iLE)+modelStruct.d_modelPar_STBETO_dX*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*(1.0+((modelStruct.modelPar_STBETLW*iLE)*iWE)));
STBET = (((modelStruct.modelPar_STBETO*(1.0+(modelStruct.modelPar_STBETL*iLE)))*(1.0+(modelStruct.modelPar_STBETW*iWE)))*(1.0+((modelStruct.modelPar_STBETLW*iLE)*iWE)));
d_MUE_dX = (modelStruct.modelPar_MUEO*(modelStruct.modelPar_MUEW*d_iWE_dX+modelStruct.d_modelPar_MUEW_dX*iWE)+modelStruct.d_modelPar_MUEO_dX*(1.0+(modelStruct.modelPar_MUEW*iWE)));
MUE = (modelStruct.modelPar_MUEO*(1.0+(modelStruct.modelPar_MUEW*iWE)));
d_STMUE_dX = modelStruct.d_modelPar_STMUEO_dX;
STMUE = modelStruct.modelPar_STMUEO;
d_THEMU_dX = modelStruct.d_modelPar_THEMUO_dX;
THEMU = modelStruct.modelPar_THEMUO;
d_STTHEMU_dX = modelStruct.d_modelPar_STTHEMUO_dX;
STTHEMU = modelStruct.modelPar_STTHEMUO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CSLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CSLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CS_dX = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*((modelStruct.modelPar_CSLW*iLE)*d_iWE_dX+(modelStruct.modelPar_CSLW*d_iLE_dX+modelStruct.d_modelPar_CSLW_dX*iLE)*iWE)+((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(modelStruct.modelPar_CSW*d_iWE_dX+modelStruct.d_modelPar_CSW_dX*iWE)+(modelStruct.d_modelPar_CSO_dX+(modelStruct.modelPar_CSL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CSLEXP_dX)))+modelStruct.d_modelPar_CSL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+((modelStruct.modelPar_CSLW*iLE)*iWE)));
CS = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+((modelStruct.modelPar_CSLW*iLE)*iWE)));
}
d_STCS_dX = modelStruct.d_modelPar_STCSO_dX;
STCS = modelStruct.modelPar_STCSO;
d_XCOR_dX = (((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*((modelStruct.modelPar_XCORLW*iLE)*d_iWE_dX+(modelStruct.modelPar_XCORLW*d_iLE_dX+modelStruct.d_modelPar_XCORLW_dX*iLE)*iWE)+((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(modelStruct.modelPar_XCORW*d_iWE_dX+modelStruct.d_modelPar_XCORW_dX*iWE)+(modelStruct.modelPar_XCORO*(modelStruct.modelPar_XCORL*d_iLE_dX+modelStruct.d_modelPar_XCORL_dX*iLE)+modelStruct.d_modelPar_XCORO_dX*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+((modelStruct.modelPar_XCORLW*iLE)*iWE)));
XCOR = (((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+((modelStruct.modelPar_XCORLW*iLE)*iWE)));
d_STXCOR_dX = modelStruct.d_modelPar_STXCORO_dX;
STXCOR = modelStruct.modelPar_STXCORO;
d_FETA_dX = modelStruct.d_modelPar_FETAO_dX;
FETA = modelStruct.modelPar_FETAO;
d_RS_dX = ((modelStruct.modelPar_RSW1*iWE)*(modelStruct.modelPar_RSW2*d_iWE_dX+modelStruct.d_modelPar_RSW2_dX*iWE)+(modelStruct.modelPar_RSW1*d_iWE_dX+modelStruct.d_modelPar_RSW1_dX*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
RS = ((modelStruct.modelPar_RSW1*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
d_STRS_dX = modelStruct.d_modelPar_STRSO_dX;
STRS = modelStruct.modelPar_STRSO;
d_RSB_dX = modelStruct.d_modelPar_RSBO_dX;
RSB = modelStruct.modelPar_RSBO;
d_RSG_dX = modelStruct.d_modelPar_RSGO_dX;
RSG = modelStruct.modelPar_RSGO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_THESATLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_THESATLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_THESAT_dX = (((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*((modelStruct.modelPar_THESATLW*iLE)*d_iWE_dX+(modelStruct.modelPar_THESATLW*d_iLE_dX+modelStruct.d_modelPar_THESATLW_dX*iLE)*iWE)+((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(modelStruct.modelPar_THESATW*d_iWE_dX+modelStruct.d_modelPar_THESATW_dX*iWE)+(modelStruct.d_modelPar_THESATO_dX+(((modelStruct.modelPar_THESATL*GWE)/GPE)*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_THESATLEXP_dX)))+((GPE*(modelStruct.modelPar_THESATL*d_GWE_dX+modelStruct.d_modelPar_THESATL_dX*GWE)-(modelStruct.modelPar_THESATL*GWE)*d_GPE_dX)/GPE/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+((modelStruct.modelPar_THESATLW*iLE)*iWE)));
THESAT = (((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+((modelStruct.modelPar_THESATLW*iLE)*iWE)));
}
d_STTHESAT_dX = (((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*((modelStruct.modelPar_STTHESATLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STTHESATLW*d_iLE_dX+modelStruct.d_modelPar_STTHESATLW_dX*iLE)*iWE)+((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(modelStruct.modelPar_STTHESATW*d_iWE_dX+modelStruct.d_modelPar_STTHESATW_dX*iWE)+(modelStruct.modelPar_STTHESATO*(modelStruct.modelPar_STTHESATL*d_iLE_dX+modelStruct.d_modelPar_STTHESATL_dX*iLE)+modelStruct.d_modelPar_STTHESATO_dX*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*(1.0+((modelStruct.modelPar_STTHESATLW*iLE)*iWE)));
STTHESAT = (((modelStruct.modelPar_STTHESATO*(1.0+(modelStruct.modelPar_STTHESATL*iLE)))*(1.0+(modelStruct.modelPar_STTHESATW*iWE)))*(1.0+((modelStruct.modelPar_STTHESATLW*iLE)*iWE)));
d_THESATB_dX = modelStruct.d_modelPar_THESATBO_dX;
THESATB = modelStruct.modelPar_THESATBO;
d_THESATG_dX = modelStruct.d_modelPar_THESATGO_dX;
THESATG = modelStruct.modelPar_THESATGO;
d_AX_dX = (((1.0+(modelStruct.modelVar_AXL_i*iLE))*modelStruct.d_modelPar_AXO_dX-modelStruct.modelPar_AXO*(modelStruct.modelVar_AXL_i*d_iLE_dX+modelStruct.d_modelVar_AXL_i_dX*iLE))/(1.0+(modelStruct.modelVar_AXL_i*iLE))/(1.0+(modelStruct.modelVar_AXL_i*iLE)));
AX = (modelStruct.modelPar_AXO/(1.0+(modelStruct.modelVar_AXL_i*iLE)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALPLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_ALP_dX = ((modelStruct.modelPar_ALPL*value_pow_0)*(modelStruct.modelPar_ALPW*d_iWE_dX+modelStruct.d_modelPar_ALPW_dX*iWE)+(modelStruct.modelPar_ALPL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPLEXP_dX)))+modelStruct.d_modelPar_ALPL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)));
ALP = ((modelStruct.modelPar_ALPL*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)));
}
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALP1LEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALP1LEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_tmpx_dX = ((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALP1LEXP_dX)));
tmpx = value_pow_0;
}
d_ALP1_dX = (((1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx))*((modelStruct.modelPar_ALP1L1*tmpx)*(modelStruct.modelPar_ALP1W*d_iWE_dX+modelStruct.d_modelPar_ALP1W_dX*iWE)+(modelStruct.modelPar_ALP1L1*d_tmpx_dX+modelStruct.d_modelPar_ALP1L1_dX*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))-((modelStruct.modelPar_ALP1L1*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))*((modelStruct.modelVar_ALP1L2_i*iLE)*d_tmpx_dX+(modelStruct.modelVar_ALP1L2_i*d_iLE_dX+modelStruct.d_modelVar_ALP1L2_i_dX*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx)));
ALP1 = (((modelStruct.modelPar_ALP1L1*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALP2LEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALP2LEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_tmpx_dX = ((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALP2LEXP_dX)));
tmpx = value_pow_0;
}
d_ALP2_dX = (((1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx))*((modelStruct.modelPar_ALP2L1*tmpx)*(modelStruct.modelPar_ALP2W*d_iWE_dX+modelStruct.d_modelPar_ALP2W_dX*iWE)+(modelStruct.modelPar_ALP2L1*d_tmpx_dX+modelStruct.d_modelPar_ALP2L1_dX*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))-((modelStruct.modelPar_ALP2L1*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))*((modelStruct.modelVar_ALP2L2_i*iLE)*d_tmpx_dX+(modelStruct.modelVar_ALP2L2_i*d_iLE_dX+modelStruct.d_modelVar_ALP2L2_i_dX*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx)));
ALP2 = (((modelStruct.modelPar_ALP2L1*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx)));
d_VP_dX = modelStruct.d_modelPar_VPO_dX;
VP = modelStruct.modelPar_VPO;
d_A1_dX = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(modelStruct.modelPar_A1W*d_iWE_dX+modelStruct.d_modelPar_A1W_dX*iWE)+(modelStruct.modelPar_A1O*(modelStruct.modelPar_A1L*d_iLE_dX+modelStruct.d_modelPar_A1L_dX*iLE)+modelStruct.d_modelPar_A1O_dX*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
A1 = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
d_A2_dX = modelStruct.d_modelPar_A2O_dX;
A2 = modelStruct.modelPar_A2O;
d_STA2_dX = modelStruct.d_modelPar_STA2O_dX;
STA2 = modelStruct.modelPar_STA2O;
d_A3_dX = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(modelStruct.modelPar_A3W*d_iWE_dX+modelStruct.d_modelPar_A3W_dX*iWE)+(modelStruct.modelPar_A3O*(modelStruct.modelPar_A3L*d_iLE_dX+modelStruct.d_modelPar_A3L_dX*iLE)+modelStruct.d_modelPar_A3O_dX*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
A3 = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
d_A4_dX = ((modelStruct.modelPar_A4O*(1.0+(modelStruct.modelPar_A4L*iLE)))*(modelStruct.modelPar_A4W*d_iWE_dX+modelStruct.d_modelPar_A4W_dX*iWE)+(modelStruct.modelPar_A4O*(modelStruct.modelPar_A4L*d_iLE_dX+modelStruct.d_modelPar_A4L_dX*iLE)+modelStruct.d_modelPar_A4O_dX*(1.0+(modelStruct.modelPar_A4L*iLE)))*(1.0+(modelStruct.modelPar_A4W*iWE)));
A4 = ((modelStruct.modelPar_A4O*(1.0+(modelStruct.modelPar_A4L*iLE)))*(1.0+(modelStruct.modelPar_A4W*iWE)));
d_GCO_dX = modelStruct.d_modelPar_GCOO_dX;
GCO = modelStruct.modelPar_GCOO;
d_IGINV_dX = (((iWE*iLE)*modelStruct.d_modelPar_IGINVLW_dX-modelStruct.modelPar_IGINVLW*(iWE*d_iLE_dX+d_iWE_dX*iLE))/(iWE*iLE)/(iWE*iLE));
IGINV = (modelStruct.modelPar_IGINVLW/(iWE*iLE));
d_IGOV_dX = (((LEN*iWE)*(modelStruct.modelPar_IGOVW*modelStruct.d_modelVar_LOV_i_dX+modelStruct.d_modelPar_IGOVW_dX*modelStruct.modelVar_LOV_i)-(modelStruct.modelPar_IGOVW*modelStruct.modelVar_LOV_i)*LEN*d_iWE_dX)/(LEN*iWE)/(LEN*iWE));
IGOV = ((modelStruct.modelPar_IGOVW*modelStruct.modelVar_LOV_i)/(LEN*iWE));
d_IGOVD_dX = (((LEN*iWE)*(modelStruct.modelPar_IGOVDW*modelStruct.d_modelVar_LOVD_i_dX+modelStruct.d_modelPar_IGOVDW_dX*modelStruct.modelVar_LOVD_i)-(modelStruct.modelPar_IGOVDW*modelStruct.modelVar_LOVD_i)*LEN*d_iWE_dX)/(LEN*iWE)/(LEN*iWE));
IGOVD = ((modelStruct.modelPar_IGOVDW*modelStruct.modelVar_LOVD_i)/(LEN*iWE));
d_STIG_dX = modelStruct.d_modelPar_STIGO_dX;
STIG = modelStruct.modelPar_STIGO;
d_GC2_dX = modelStruct.d_modelPar_GC2O_dX;
GC2 = modelStruct.modelPar_GC2O;
d_GC3_dX = modelStruct.d_modelPar_GC3O_dX;
GC3 = modelStruct.modelPar_GC3O;
d_CHIB_dX = modelStruct.d_modelPar_CHIBO_dX;
CHIB = modelStruct.modelPar_CHIBO;
d_AGIDL_dX = (((LEN*iWE)*(modelStruct.modelPar_AGIDLW*modelStruct.d_modelVar_LOV_i_dX+modelStruct.d_modelPar_AGIDLW_dX*modelStruct.modelVar_LOV_i)-(modelStruct.modelPar_AGIDLW*modelStruct.modelVar_LOV_i)*LEN*d_iWE_dX)/(LEN*iWE)/(LEN*iWE));
AGIDL = ((modelStruct.modelPar_AGIDLW*modelStruct.modelVar_LOV_i)/(LEN*iWE));
d_AGIDLD_dX = (((LEN*iWE)*(modelStruct.modelPar_AGIDLDW*modelStruct.d_modelVar_LOVD_i_dX+modelStruct.d_modelPar_AGIDLDW_dX*modelStruct.modelVar_LOVD_i)-(modelStruct.modelPar_AGIDLDW*modelStruct.modelVar_LOVD_i)*LEN*d_iWE_dX)/(LEN*iWE)/(LEN*iWE));
AGIDLD = ((modelStruct.modelPar_AGIDLDW*modelStruct.modelVar_LOVD_i)/(LEN*iWE));
d_BGIDL_dX = modelStruct.d_modelPar_BGIDLO_dX;
BGIDL = modelStruct.modelPar_BGIDLO;
d_BGIDLD_dX = modelStruct.d_modelPar_BGIDLDO_dX;
BGIDLD = modelStruct.modelPar_BGIDLDO;
d_STBGIDL_dX = modelStruct.d_modelPar_STBGIDLO_dX;
STBGIDL = modelStruct.modelPar_STBGIDLO;
d_STBGIDLD_dX = modelStruct.d_modelPar_STBGIDLDO_dX;
STBGIDLD = modelStruct.modelPar_STBGIDLDO;
d_CGIDL_dX = modelStruct.d_modelPar_CGIDLO_dX;
CGIDL = modelStruct.modelPar_CGIDLO;
d_CGIDLD_dX = modelStruct.d_modelPar_CGIDLDO_dX;
CGIDLD = modelStruct.modelPar_CGIDLDO;
d_COX_dX = ((modelStruct.modelVar_TOX_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*d_LEcv_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROX_i_dX*WEcv)*LEcv)-(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*LEcv)*modelStruct.d_modelVar_TOX_i_dX)/modelStruct.modelVar_TOX_i/modelStruct.modelVar_TOX_i);
COX = ((((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*LEcv)/modelStruct.modelVar_TOX_i);
d_CGOV_dX = ((modelStruct.modelVar_TOXOV_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.d_modelVar_LOV_i_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROX_i_dX*WEcv)*modelStruct.modelVar_LOV_i)-(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.modelVar_LOV_i)*modelStruct.d_modelVar_TOXOV_i_dX)/modelStruct.modelVar_TOXOV_i/modelStruct.modelVar_TOXOV_i);
CGOV = ((((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.modelVar_LOV_i)/modelStruct.modelVar_TOXOV_i);
d_CGOVD_dX = ((modelStruct.modelVar_TOXOVD_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.d_modelVar_LOVD_i_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROX_i_dX*WEcv)*modelStruct.modelVar_LOVD_i)-(((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.modelVar_LOVD_i)*modelStruct.d_modelVar_TOXOVD_i_dX)/modelStruct.modelVar_TOXOVD_i/modelStruct.modelVar_TOXOVD_i);
CGOVD = ((((8.8541878176E-12*modelStruct.modelVar_EPSROX_i)*WEcv)*modelStruct.modelVar_LOVD_i)/modelStruct.modelVar_TOXOVD_i);
d_CGBOV_dX = ((modelStruct.modelPar_CGBOVL*d_Lcv_dX+modelStruct.d_modelPar_CGBOVL_dX*Lcv)/LEN);
CGBOV = ((modelStruct.modelPar_CGBOVL*Lcv)/LEN);
d_CFR_dX = ((modelStruct.modelPar_CFRW*d_Wcv_dX+modelStruct.d_modelPar_CFRW_dX*Wcv)/WEN);
CFR = ((modelStruct.modelPar_CFRW*Wcv)/WEN);
d_CFRD_dX = ((modelStruct.modelPar_CFRDW*d_Wcv_dX+modelStruct.d_modelPar_CFRDW_dX*Wcv)/WEN);
CFRD = ((modelStruct.modelPar_CFRDW*Wcv)/WEN);
d_temp0_dX = (-(((2.0*modelStruct.modelPar_LINTNOI)*d_iLE_dX+2.0*modelStruct.d_modelPar_LINTNOI_dX*iLE)/LEN));
temp0 = (1.0-(((2.0*modelStruct.modelPar_LINTNOI)*iLE)/LEN));
d_Lnoi_dX = ((temp0>1.0e-3)?d_temp0_dX:0.0);
Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
{
double value_pow_0 = pow(Lnoi,modelStruct.modelPar_ALPNOI);
double  deriv_pow_0_d0 = ((Lnoi == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPNOI/Lnoi));
double  deriv_pow_0_d1 = (Lnoi == 0.0)?0.0:(log(Lnoi)*value_pow_0);
d_Lred_dX = (-((deriv_pow_0_d0*(d_Lnoi_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPNOI_dX)))/value_pow_0/value_pow_0);
Lred = (1.0/value_pow_0);
}
d_FNT_dX = modelStruct.d_modelPar_FNTO_dX;
FNT = modelStruct.modelPar_FNTO;
d_FNTEXC_dX = ((((modelStruct.modelPar_FNTEXCL*BETN)*BETN)*iWE)*d_iWE_dX+(((modelStruct.modelPar_FNTEXCL*BETN)*BETN)*d_iWE_dX+((modelStruct.modelPar_FNTEXCL*BETN)*d_BETN_dX+(modelStruct.modelPar_FNTEXCL*d_BETN_dX+modelStruct.d_modelPar_FNTEXCL_dX*BETN)*BETN)*iWE)*iWE);
FNTEXC = ((((modelStruct.modelPar_FNTEXCL*BETN)*BETN)*iWE)*iWE);
d_NFA_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFALW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFALW);
NFA = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFALW);
d_NFB_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFBLW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFBLW);
NFB = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFBLW);
d_NFC_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFCLW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFCLW);
NFC = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFCLW);
d_EF_dX = modelStruct.d_modelPar_EFO_dX;
EF = modelStruct.modelPar_EFO;
d_KVTHOWE_dX = (((modelStruct.d_modelPar_KVTHOWEO_dX+(modelStruct.modelPar_KVTHOWEL*d_iLE_dX+modelStruct.d_modelPar_KVTHOWEL_dX*iLE))+(modelStruct.modelPar_KVTHOWEW*d_iWE_dX+modelStruct.d_modelPar_KVTHOWEW_dX*iWE))+((modelStruct.modelPar_KVTHOWELW*iLE)*d_iWE_dX+(modelStruct.modelPar_KVTHOWELW*d_iLE_dX+modelStruct.d_modelPar_KVTHOWELW_dX*iLE)*iWE));
KVTHOWE = (((modelStruct.modelPar_KVTHOWEO+(modelStruct.modelPar_KVTHOWEL*iLE))+(modelStruct.modelPar_KVTHOWEW*iWE))+((modelStruct.modelPar_KVTHOWELW*iLE)*iWE));
d_KUOWE_dX = (((modelStruct.d_modelPar_KUOWEO_dX+(modelStruct.modelPar_KUOWEL*d_iLE_dX+modelStruct.d_modelPar_KUOWEL_dX*iLE))+(modelStruct.modelPar_KUOWEW*d_iWE_dX+modelStruct.d_modelPar_KUOWEW_dX*iWE))+((modelStruct.modelPar_KUOWELW*iLE)*d_iWE_dX+(modelStruct.modelPar_KUOWELW*d_iLE_dX+modelStruct.d_modelPar_KUOWELW_dX*iLE)*iWE));
KUOWE = (((modelStruct.modelPar_KUOWEO+(modelStruct.modelPar_KUOWEL*iLE))+(modelStruct.modelPar_KUOWEW*iWE))+((modelStruct.modelPar_KUOWELW*iLE)*iWE));
d_RG_dX = (((((NGCON_i*L_slif)*(RSHG_i*(((NGCON_i*3.3333333333333333e-01*d_W_f_dX-(3.3333333333333333e-01*W_f)*d_NGCON_i_dX)/NGCON_i/NGCON_i)+d_XGWE_dX)+d_RSHG_i_dX*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))-(RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))*(NGCON_i*d_L_slif_dX+d_NGCON_i_dX*L_slif))/(NGCON_i*L_slif)/(NGCON_i*L_slif))+(((W_f*L_f)*(modelStruct.d_modelVar_RINT_i_dX+modelStruct.d_modelVar_RVPOLY_i_dX)-(modelStruct.modelVar_RINT_i+modelStruct.modelVar_RVPOLY_i)*(W_f*d_L_f_dX+d_W_f_dX*L_f))/(W_f*L_f)/(W_f*L_f)))+(NF_i*modelStruct.d_modelPar_RGO_dX+d_NF_i_dX*modelStruct.modelPar_RGO));
RG = ((((RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+((modelStruct.modelVar_RINT_i+modelStruct.modelVar_RVPOLY_i)/(W_f*L_f)))+(NF_i*modelStruct.modelPar_RGO));
d_RWELL_dX = (NF_i*modelStruct.d_modelPar_RWELLO_dX+d_NF_i_dX*modelStruct.modelPar_RWELLO);
RWELL = (NF_i*modelStruct.modelPar_RWELLO);
d_RBULK_dX = (NF_i*modelStruct.d_modelPar_RBULKO_dX+d_NF_i_dX*modelStruct.modelPar_RBULKO);
RBULK = (NF_i*modelStruct.modelPar_RBULKO);
d_RJUNS_dX = (NF_i*modelStruct.d_modelPar_RJUNSO_dX+d_NF_i_dX*modelStruct.modelPar_RJUNSO);
RJUNS = (NF_i*modelStruct.modelPar_RJUNSO);
d_RJUND_dX = (NF_i*modelStruct.d_modelPar_RJUNDO_dX+d_NF_i_dX*modelStruct.modelPar_RJUNDO);
RJUND = (NF_i*modelStruct.modelPar_RJUNDO);
d_tmpa_dX = 0.0;
tmpa = 0.0;
d_tmpb_dX = 0.0;
tmpb = 0.0;
loop = 0.0;
if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
{
while ((loop<(NF_i-0.5)))
{
d_tmpa_dX = (d_tmpa_dX+(-((d_SA_i_dX+0.5*d_L_i_dX)+loop*(d_SD_i_dX+d_L_i_dX))/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
d_tmpb_dX = (d_tmpb_dX+(-((d_SB_i_dX+0.5*d_L_i_dX)+loop*(d_SD_i_dX+d_L_i_dX))/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
loop = (loop+1.0);
}
d_Invsa_dX = (tmpa*d_invNF_dX+d_tmpa_dX*invNF);
Invsa = (tmpa*invNF);
d_Invsb_dX = (tmpb*d_invNF_dX+d_tmpb_dX*invNF);
Invsb = (tmpb*invNF);
d_Invsaref_dX = (-(modelStruct.d_modelVar_SAREF_i_dX+0.5*d_L_i_dX)/(modelStruct.modelVar_SAREF_i+(0.5*L_i))/(modelStruct.modelVar_SAREF_i+(0.5*L_i)));
Invsaref = (1.0/(modelStruct.modelVar_SAREF_i+(0.5*L_i)));
d_Invsbref_dX = (-(modelStruct.d_modelVar_SBREF_i_dX+0.5*d_L_i_dX)/(modelStruct.modelVar_SBREF_i+(0.5*L_i))/(modelStruct.modelVar_SBREF_i+(0.5*L_i)));
Invsbref = (1.0/(modelStruct.modelVar_SBREF_i+(0.5*L_i)));
d_Lx_dX = (((L_i+delLPS)>1e-9)?(d_L_i_dX+d_delLPS_dX):0.0);
Lx = (((L_i+delLPS)>1e-9)?(L_i+delLPS):1e-9);
d_Wx_dX = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>1e-9)?((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_WLOD_dX):0.0);
Wx = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>1e-9)?((W_i+delWOD)+modelStruct.modelPar_WLOD):1e-9);
{
double value_pow_0 = pow(Lx,modelStruct.modelVar_LLODKUO_i);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LLODKUO_i/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LLODKUO_i_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelVar_WLODKUO_i);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_WLODKUO_i/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_WLODKUO_i_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
d_Kstressu0_dX = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(modelStruct.modelPar_TKUO*modelStruct.d_modelVar_rT_dX+modelStruct.d_modelPar_TKUO_dX*(modelStruct.modelVar_rT-1.0))+(((modelStruct.modelPar_LKUO*d_templ_dX+modelStruct.d_modelPar_LKUO_dX*templ)+(modelStruct.modelPar_WKUO*d_tempw_dX+modelStruct.d_modelPar_WKUO_dX*tempw))+((modelStruct.modelPar_PKUO*templ)*d_tempw_dX+(modelStruct.modelPar_PKUO*d_templ_dX+modelStruct.d_modelPar_PKUO_dX*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(modelStruct.modelVar_rT-1.0))));
Kstressu0 = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(modelStruct.modelVar_rT-1.0))));
d_rhobeta_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsa_dX+d_Invsb_dX)+modelStruct.d_modelPar_KUO_dX*(Invsa+Invsb))-(modelStruct.modelPar_KUO*(Invsa+Invsb))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobeta = ((modelStruct.modelPar_KUO*(Invsa+Invsb))/Kstressu0);
d_rhobetaref_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsaref_dX+d_Invsbref_dX)+modelStruct.d_modelPar_KUO_dX*(Invsaref+Invsbref))-(modelStruct.modelPar_KUO*(Invsaref+Invsbref))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobetaref = ((modelStruct.modelPar_KUO*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,modelStruct.modelVar_LLODVTH_i);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LLODVTH_i/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LLODVTH_i_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelVar_WLODVTH_i);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_WLODVTH_i/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_WLODVTH_i_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
d_Kstressvth0_dX = (((modelStruct.modelPar_LKVTHO*d_templ_dX+modelStruct.d_modelPar_LKVTHO_dX*templ)+(modelStruct.modelPar_WKVTHO*d_tempw_dX+modelStruct.d_modelPar_WKVTHO_dX*tempw))+((modelStruct.modelPar_PKVTHO*templ)*d_tempw_dX+(modelStruct.modelPar_PKVTHO*d_templ_dX+modelStruct.d_modelPar_PKVTHO_dX*templ)*tempw));
Kstressvth0 = (((1.0+(modelStruct.modelPar_LKVTHO*templ))+(modelStruct.modelPar_WKVTHO*tempw))+((modelStruct.modelPar_PKVTHO*templ)*tempw));
d_temp0_dX = (((d_Invsa_dX+d_Invsb_dX)-d_Invsaref_dX)-d_Invsbref_dX);
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
d_BETN_dX = (((1.0+rhobetaref)*(BETN*d_rhobeta_dX+d_BETN_dX*(1.0+rhobeta))-(BETN*(1.0+rhobeta))*d_rhobetaref_dX)/(1.0+rhobetaref)/(1.0+rhobetaref));
BETN = ((BETN*(1.0+rhobeta))/(1.0+rhobetaref));
d_THESAT_dX = ((((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta)))*((THESAT*(1.0+rhobeta))*(modelStruct.modelVar_KVSAT_i*d_rhobetaref_dX+modelStruct.d_modelVar_KVSAT_i_dX*rhobetaref)+(THESAT*d_rhobeta_dX+d_THESAT_dX*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))-((THESAT*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))*((1.0+rhobetaref)*(modelStruct.modelVar_KVSAT_i*d_rhobeta_dX+modelStruct.d_modelVar_KVSAT_i_dX*rhobeta)+d_rhobetaref_dX*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))));
THESAT = (((THESAT*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))));
d_VFB_dX = (d_VFB_dX+((Kstressvth0*(modelStruct.modelPar_KVTHO*d_temp0_dX+modelStruct.d_modelPar_KVTHO_dX*temp0)-(modelStruct.modelPar_KVTHO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
VFB = (VFB+((modelStruct.modelPar_KVTHO*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,modelStruct.modelVar_LODETAO_i);
double  deriv_pow_0_d0 = ((Kstressvth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LODETAO_i/Kstressvth0));
double  deriv_pow_0_d1 = (Kstressvth0 == 0.0)?0.0:(log(Kstressvth0)*value_pow_0);
d_CF_dX = (d_CF_dX+((value_pow_0*(modelStruct.modelPar_STETAO*d_temp0_dX+modelStruct.d_modelPar_STETAO_dX*temp0)-(modelStruct.modelPar_STETAO*temp0)*((deriv_pow_0_d0*(d_Kstressvth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LODETAO_i_dX))))/value_pow_0/value_pow_0));
CF = (CF+((modelStruct.modelPar_STETAO*temp0)/value_pow_0));
}
}
if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
{
if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
{
d_temp0_dX = (d_SC_i_dX+d_W_i_dX);
temp0 = (SC_i+W_i);
d_temp00_dX = (-modelStruct.d_modelVar_SCREF_i_dX/modelStruct.modelVar_SCREF_i/modelStruct.modelVar_SCREF_i);
temp00 = (1.0/modelStruct.modelVar_SCREF_i);
d_SCA_i_dX = (((SC_i*temp0)*(modelStruct.modelVar_SCREF_i*modelStruct.d_modelVar_SCREF_i_dX+modelStruct.d_modelVar_SCREF_i_dX*modelStruct.modelVar_SCREF_i)-(modelStruct.modelVar_SCREF_i*modelStruct.modelVar_SCREF_i)*(SC_i*d_temp0_dX+d_SC_i_dX*temp0))/(SC_i*temp0)/(SC_i*temp0));
SCA_i = ((modelStruct.modelVar_SCREF_i*modelStruct.modelVar_SCREF_i)/(SC_i*temp0));
{
double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
double value_exp_1 = exp((((-10.0)*temp0)*temp00));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_SCB_i_dX = ((W_i*((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*deriv_exp_0_d0*((((-10.0)*SC_i)*d_temp00_dX+(-10.0)*d_SC_i_dX*temp00))+(0.1*d_SC_i_dX+0.01*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*deriv_exp_1_d0*((((-10.0)*temp0)*d_temp00_dX+(-10.0)*d_temp0_dX*temp00))+(0.1*d_temp0_dX+0.01*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_1))-((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_1))*d_W_i_dX)/W_i/W_i);
SCB_i = (((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_1))/W_i);
}
{
double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
double value_exp_1 = exp((((-20.0)*temp0)*temp00));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_SCC_i_dX = ((W_i*((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*deriv_exp_0_d0*((((-20.0)*SC_i)*d_temp00_dX+(-20.0)*d_SC_i_dX*temp00))+(0.05*d_SC_i_dX+0.0025*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*deriv_exp_1_d0*((((-20.0)*temp0)*d_temp00_dX+(-20.0)*d_temp0_dX*temp00))+(0.05*d_temp0_dX+0.0025*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_1))-((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_1))*d_W_i_dX)/W_i/W_i);
SCC_i = (((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_1))/W_i);
}
}
d_temp0_dX = ((d_SCA_i_dX+(modelStruct.modelVar_WEB_i*d_SCB_i_dX+modelStruct.d_modelVar_WEB_i_dX*SCB_i))+(modelStruct.modelVar_WEC_i*d_SCC_i_dX+modelStruct.d_modelVar_WEC_i_dX*SCC_i));
temp0 = ((SCA_i+(modelStruct.modelVar_WEB_i*SCB_i))+(modelStruct.modelVar_WEC_i*SCC_i));
d_VFB_dX = (d_VFB_dX+(KVTHOWE*d_temp0_dX+d_KVTHOWE_dX*temp0));
VFB = (VFB+(KVTHOWE*temp0));
d_BETN_dX = (BETN*(KUOWE*d_temp0_dX+d_KUOWE_dX*temp0)+d_BETN_dX*(1.0+(KUOWE*temp0)));
BETN = (BETN*(1.0+(KUOWE*temp0)));
}
instanceStruct.d_instanceVar_VFB_i_dX = d_VFB_dX;
instanceStruct.instanceVar_VFB_i = VFB;
instanceStruct.d_instanceVar_STVFB_i_dX = d_STVFB_dX;
instanceStruct.instanceVar_STVFB_i = STVFB;
modelStruct.d_modelVar_TOX_i_dX = ((TOX>1e-10)?d_TOX_dX:0.0);
modelStruct.modelVar_TOX_i = ((TOX>1e-10)?TOX:1e-10);
modelStruct.d_modelVar_EPSROX_i_dX = ((EPSROX>1.0)?d_EPSROX_dX:0.0);
modelStruct.modelVar_EPSROX_i = ((EPSROX>1.0)?EPSROX:1.0);
instanceStruct.d_instanceVar_NEFF_i_dX = ((NEFF>1e20)?((NEFF<1e26)?d_NEFF_dX:0.0):0.0);
instanceStruct.instanceVar_NEFF_i = ((NEFF>1e20)?((NEFF<1e26)?NEFF:1e26):1e20);
instanceStruct.d_instanceVar_VNSUB_i_dX = d_VNSUB_dX;
instanceStruct.instanceVar_VNSUB_i = VNSUB;
instanceStruct.d_instanceVar_NSLP_i_dX = ((NSLP>1e-3)?d_NSLP_dX:0.0);
instanceStruct.instanceVar_NSLP_i = ((NSLP>1e-3)?NSLP:1e-3);
instanceStruct.d_instanceVar_DNSUB_i_dX = ((DNSUB>0.0)?((DNSUB<1.0)?d_DNSUB_dX:0.0):0.0);
instanceStruct.instanceVar_DNSUB_i = ((DNSUB>0.0)?((DNSUB<1.0)?DNSUB:1.0):0.0);
instanceStruct.d_instanceVar_DPHIB_i_dX = d_DPHIB_dX;
instanceStruct.instanceVar_DPHIB_i = DPHIB;
instanceStruct.d_instanceVar_NP_i_dX = ((NP>0.0)?d_NP_dX:0.0);
instanceStruct.instanceVar_NP_i = ((NP>0.0)?NP:0.0);
d_QMC_i_dX = ((modelStruct.modelPar_QMC>0.0)?modelStruct.d_modelPar_QMC_dX:0.0);
QMC_i = ((modelStruct.modelPar_QMC>0.0)?modelStruct.modelPar_QMC:0.0);
instanceStruct.d_instanceVar_CT_i_dX = ((CT>0.0)?d_CT_dX:0.0);
instanceStruct.instanceVar_CT_i = ((CT>0.0)?CT:0.0);
modelStruct.d_modelVar_TOXOV_i_dX = ((TOXOV>1e-10)?d_TOXOV_dX:0.0);
modelStruct.modelVar_TOXOV_i = ((TOXOV>1e-10)?TOXOV:1e-10);
modelStruct.d_modelVar_TOXOVD_i_dX = ((TOXOVD>1e-10)?d_TOXOVD_dX:0.0);
modelStruct.modelVar_TOXOVD_i = ((TOXOVD>1e-10)?TOXOVD:1e-10);
instanceStruct.d_instanceVar_NOV_i_dX = ((NOV>1e20)?((NOV<1e27)?d_NOV_dX:0.0):0.0);
instanceStruct.instanceVar_NOV_i = ((NOV>1e20)?((NOV<1e27)?NOV:1e27):1e20);
instanceStruct.d_instanceVar_NOVD_i_dX = ((NOVD>1e20)?((NOVD<1e27)?d_NOVD_dX:0.0):0.0);
instanceStruct.instanceVar_NOVD_i = ((NOVD>1e20)?((NOVD<1e27)?NOVD:1e27):1e20);
instanceStruct.d_instanceVar_CF_i_dX = ((CF>0.0)?d_CF_dX:0.0);
instanceStruct.instanceVar_CF_i = ((CF>0.0)?CF:0.0);
instanceStruct.d_instanceVar_CFB_i_dX = ((CFB>0.0)?((CFB<1.0)?d_CFB_dX:0.0):0.0);
instanceStruct.instanceVar_CFB_i = ((CFB>0.0)?((CFB<1.0)?CFB:1.0):0.0);
instanceStruct.d_instanceVar_BETN_i_dX = ((BETN>0.0)?d_BETN_dX:0.0);
instanceStruct.instanceVar_BETN_i = ((BETN>0.0)?BETN:0.0);
instanceStruct.d_instanceVar_STBET_i_dX = d_STBET_dX;
instanceStruct.instanceVar_STBET_i = STBET;
instanceStruct.d_instanceVar_MUE_i_dX = ((MUE>0.0)?d_MUE_dX:0.0);
instanceStruct.instanceVar_MUE_i = ((MUE>0.0)?MUE:0.0);
instanceStruct.d_instanceVar_STMUE_i_dX = d_STMUE_dX;
instanceStruct.instanceVar_STMUE_i = STMUE;
instanceStruct.d_instanceVar_THEMU_i_dX = ((THEMU>0.0)?d_THEMU_dX:0.0);
instanceStruct.instanceVar_THEMU_i = ((THEMU>0.0)?THEMU:0.0);
instanceStruct.d_instanceVar_STTHEMU_i_dX = d_STTHEMU_dX;
instanceStruct.instanceVar_STTHEMU_i = STTHEMU;
instanceStruct.d_instanceVar_CS_i_dX = ((CS>0.0)?d_CS_dX:0.0);
instanceStruct.instanceVar_CS_i = ((CS>0.0)?CS:0.0);
instanceStruct.d_instanceVar_STCS_i_dX = d_STCS_dX;
instanceStruct.instanceVar_STCS_i = STCS;
instanceStruct.d_instanceVar_XCOR_i_dX = ((XCOR>0.0)?d_XCOR_dX:0.0);
instanceStruct.instanceVar_XCOR_i = ((XCOR>0.0)?XCOR:0.0);
instanceStruct.d_instanceVar_STXCOR_i_dX = d_STXCOR_dX;
instanceStruct.instanceVar_STXCOR_i = STXCOR;
instanceStruct.d_instanceVar_FETA_i_dX = ((FETA>0.0)?d_FETA_dX:0.0);
instanceStruct.instanceVar_FETA_i = ((FETA>0.0)?FETA:0.0);
instanceStruct.d_instanceVar_RS_i_dX = ((RS>0.0)?d_RS_dX:0.0);
instanceStruct.instanceVar_RS_i = ((RS>0.0)?RS:0.0);
instanceStruct.d_instanceVar_STRS_i_dX = d_STRS_dX;
instanceStruct.instanceVar_STRS_i = STRS;
instanceStruct.d_instanceVar_RSB_i_dX = ((RSB>(-0.5))?((RSB<1.0)?d_RSB_dX:0.0):0.0);
instanceStruct.instanceVar_RSB_i = ((RSB>(-0.5))?((RSB<1.0)?RSB:1.0):(-0.5));
instanceStruct.d_instanceVar_RSG_i_dX = ((RSG>(-0.5))?d_RSG_dX:0.0);
instanceStruct.instanceVar_RSG_i = ((RSG>(-0.5))?RSG:(-0.5));
instanceStruct.d_instanceVar_THESAT_i_dX = ((THESAT>0.0)?d_THESAT_dX:0.0);
instanceStruct.instanceVar_THESAT_i = ((THESAT>0.0)?THESAT:0.0);
instanceStruct.d_instanceVar_STTHESAT_i_dX = d_STTHESAT_dX;
instanceStruct.instanceVar_STTHESAT_i = STTHESAT;
instanceStruct.d_instanceVar_THESATB_i_dX = ((THESATB>(-0.5))?((THESATB<1.0)?d_THESATB_dX:0.0):0.0);
instanceStruct.instanceVar_THESATB_i = ((THESATB>(-0.5))?((THESATB<1.0)?THESATB:1.0):(-0.5));
instanceStruct.d_instanceVar_THESATG_i_dX = ((THESATG>(-0.5))?d_THESATG_dX:0.0);
instanceStruct.instanceVar_THESATG_i = ((THESATG>(-0.5))?THESATG:(-0.5));
instanceStruct.d_instanceVar_AX_i_dX = ((AX>2.0)?d_AX_dX:0.0);
instanceStruct.instanceVar_AX_i = ((AX>2.0)?AX:2.0);
instanceStruct.d_instanceVar_ALP_i_dX = ((ALP>0.0)?d_ALP_dX:0.0);
instanceStruct.instanceVar_ALP_i = ((ALP>0.0)?ALP:0.0);
instanceStruct.d_instanceVar_ALP1_i_dX = ((ALP1>0.0)?d_ALP1_dX:0.0);
instanceStruct.instanceVar_ALP1_i = ((ALP1>0.0)?ALP1:0.0);
instanceStruct.d_instanceVar_ALP2_i_dX = ((ALP2>0.0)?d_ALP2_dX:0.0);
instanceStruct.instanceVar_ALP2_i = ((ALP2>0.0)?ALP2:0.0);
instanceStruct.d_instanceVar_VP_i_dX = ((VP>1.0e-10)?d_VP_dX:0.0);
instanceStruct.instanceVar_VP_i = ((VP>1.0e-10)?VP:1.0e-10);
instanceStruct.d_instanceVar_A1_i_dX = ((A1>0.0)?d_A1_dX:0.0);
instanceStruct.instanceVar_A1_i = ((A1>0.0)?A1:0.0);
instanceStruct.d_instanceVar_A2_i_dX = ((A2>0.0)?d_A2_dX:0.0);
instanceStruct.instanceVar_A2_i = ((A2>0.0)?A2:0.0);
instanceStruct.d_instanceVar_STA2_i_dX = d_STA2_dX;
instanceStruct.instanceVar_STA2_i = STA2;
instanceStruct.d_instanceVar_A3_i_dX = ((A3>0.0)?d_A3_dX:0.0);
instanceStruct.instanceVar_A3_i = ((A3>0.0)?A3:0.0);
instanceStruct.d_instanceVar_A4_i_dX = ((A4>0.0)?d_A4_dX:0.0);
instanceStruct.instanceVar_A4_i = ((A4>0.0)?A4:0.0);
instanceStruct.d_instanceVar_GCO_i_dX = ((GCO>(-10.0))?((GCO<10.0)?d_GCO_dX:0.0):0.0);
instanceStruct.instanceVar_GCO_i = ((GCO>(-10.0))?((GCO<10.0)?GCO:10.0):(-10.0));
instanceStruct.d_instanceVar_IGINV_i_dX = ((IGINV>0.0)?d_IGINV_dX:0.0);
instanceStruct.instanceVar_IGINV_i = ((IGINV>0.0)?IGINV:0.0);
instanceStruct.d_instanceVar_IGOV_i_dX = ((IGOV>0.0)?d_IGOV_dX:0.0);
instanceStruct.instanceVar_IGOV_i = ((IGOV>0.0)?IGOV:0.0);
instanceStruct.d_instanceVar_IGOVD_i_dX = ((IGOVD>0.0)?d_IGOVD_dX:0.0);
instanceStruct.instanceVar_IGOVD_i = ((IGOVD>0.0)?IGOVD:0.0);
instanceStruct.d_instanceVar_STIG_i_dX = d_STIG_dX;
instanceStruct.instanceVar_STIG_i = STIG;
instanceStruct.d_instanceVar_GC2_i_dX = ((GC2>0.0)?((GC2<10.0)?d_GC2_dX:0.0):0.0);
instanceStruct.instanceVar_GC2_i = ((GC2>0.0)?((GC2<10.0)?GC2:10.0):0.0);
instanceStruct.d_instanceVar_GC3_i_dX = ((GC3>(-10.0))?((GC3<10.0)?d_GC3_dX:0.0):0.0);
instanceStruct.instanceVar_GC3_i = ((GC3>(-10.0))?((GC3<10.0)?GC3:10.0):(-10.0));
instanceStruct.d_instanceVar_CHIB_i_dX = ((CHIB>1.0)?d_CHIB_dX:0.0);
instanceStruct.instanceVar_CHIB_i = ((CHIB>1.0)?CHIB:1.0);
instanceStruct.d_instanceVar_AGIDL_i_dX = ((AGIDL>0.0)?d_AGIDL_dX:0.0);
instanceStruct.instanceVar_AGIDL_i = ((AGIDL>0.0)?AGIDL:0.0);
instanceStruct.d_instanceVar_AGIDLD_i_dX = ((AGIDLD>0.0)?d_AGIDLD_dX:0.0);
instanceStruct.instanceVar_AGIDLD_i = ((AGIDLD>0.0)?AGIDLD:0.0);
d_BGIDL_i_dX = ((BGIDL>0.0)?d_BGIDL_dX:0.0);
BGIDL_i = ((BGIDL>0.0)?BGIDL:0.0);
d_BGIDLD_i_dX = ((BGIDLD>0.0)?d_BGIDLD_dX:0.0);
BGIDLD_i = ((BGIDLD>0.0)?BGIDLD:0.0);
instanceStruct.d_instanceVar_STBGIDL_i_dX = d_STBGIDL_dX;
instanceStruct.instanceVar_STBGIDL_i = STBGIDL;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = d_STBGIDLD_dX;
instanceStruct.instanceVar_STBGIDLD_i = STBGIDLD;
instanceStruct.d_instanceVar_CGIDL_i_dX = d_CGIDL_dX;
instanceStruct.instanceVar_CGIDL_i = CGIDL;
instanceStruct.d_instanceVar_CGIDLD_i_dX = d_CGIDLD_dX;
instanceStruct.instanceVar_CGIDLD_i = CGIDLD;
instanceStruct.d_instanceVar_COX_i_dX = ((COX>0.0)?d_COX_dX:0.0);
instanceStruct.instanceVar_COX_i = ((COX>0.0)?COX:0.0);
instanceStruct.d_instanceVar_CGOV_i_dX = ((CGOV>0.0)?d_CGOV_dX:0.0);
instanceStruct.instanceVar_CGOV_i = ((CGOV>0.0)?CGOV:0.0);
instanceStruct.d_instanceVar_CGOVD_i_dX = ((CGOVD>0.0)?d_CGOVD_dX:0.0);
instanceStruct.instanceVar_CGOVD_i = ((CGOVD>0.0)?CGOVD:0.0);
instanceStruct.d_instanceVar_CGBOV_i_dX = ((CGBOV>0.0)?d_CGBOV_dX:0.0);
instanceStruct.instanceVar_CGBOV_i = ((CGBOV>0.0)?CGBOV:0.0);
instanceStruct.d_instanceVar_CFR_i_dX = ((CFR>0.0)?d_CFR_dX:0.0);
instanceStruct.instanceVar_CFR_i = ((CFR>0.0)?CFR:0.0);
instanceStruct.d_instanceVar_CFRD_i_dX = ((CFRD>0.0)?d_CFRD_dX:0.0);
instanceStruct.instanceVar_CFRD_i = ((CFRD>0.0)?CFRD:0.0);
instanceStruct.d_instanceVar_FNT_i_dX = ((FNT>0.0)?d_FNT_dX:0.0);
instanceStruct.instanceVar_FNT_i = ((FNT>0.0)?FNT:0.0);
instanceStruct.d_instanceVar_FNTEXC_i_dX = ((FNTEXC>0.0)?d_FNTEXC_dX:0.0);
instanceStruct.instanceVar_FNTEXC_i = ((FNTEXC>0.0)?FNTEXC:0.0);
instanceStruct.d_instanceVar_NFA_i_dX = ((NFA>0.0)?d_NFA_dX:0.0);
instanceStruct.instanceVar_NFA_i = ((NFA>0.0)?NFA:0.0);
instanceStruct.d_instanceVar_NFB_i_dX = ((NFB>0.0)?d_NFB_dX:0.0);
instanceStruct.instanceVar_NFB_i = ((NFB>0.0)?NFB:0.0);
instanceStruct.d_instanceVar_NFC_i_dX = ((NFC>0.0)?d_NFC_dX:0.0);
instanceStruct.instanceVar_NFC_i = ((NFC>0.0)?NFC:0.0);
instanceStruct.d_instanceVar_EF_i_dX = ((EF>0.0)?d_EF_dX:0.0);
instanceStruct.instanceVar_EF_i = ((EF>0.0)?EF:0.0);
d_FACTUO_i_dX = ((instanceStruct.instancePar_FACTUO>0.0)?instanceStruct.d_instancePar_FACTUO_dX:0.0);
FACTUO_i = ((instanceStruct.instancePar_FACTUO>0.0)?instanceStruct.instancePar_FACTUO:0.0);
d_DELVTO_i_dX = instanceStruct.d_instancePar_DELVTO_dX;
DELVTO_i = instanceStruct.instancePar_DELVTO;
instanceStruct.d_instanceVar_RG_i_dX = ((RG>0.0)?d_RG_dX:0.0);
instanceStruct.instanceVar_RG_i = ((RG>0.0)?RG:0.0);
instanceStruct.d_instanceVar_RBULK_i_dX = ((RBULK>0.0)?d_RBULK_dX:0.0);
instanceStruct.instanceVar_RBULK_i = ((RBULK>0.0)?RBULK:0.0);
instanceStruct.d_instanceVar_RJUNS_i_dX = ((RJUNS>0.0)?d_RJUNS_dX:0.0);
instanceStruct.instanceVar_RJUNS_i = ((RJUNS>0.0)?RJUNS:0.0);
instanceStruct.d_instanceVar_RJUND_i_dX = ((RJUND>0.0)?d_RJUND_dX:0.0);
instanceStruct.instanceVar_RJUND_i = ((RJUND>0.0)?RJUND:0.0);
instanceStruct.d_instanceVar_RWELL_i_dX = ((RWELL>0.0)?d_RWELL_dX:0.0);
instanceStruct.instanceVar_RWELL_i = ((RWELL>0.0)?RWELL:0.0);
instanceStruct.d_instanceVar_MULT_i_dX = (((instanceStruct.instancePar_MULT*NF_i)>0.0)?(instanceStruct.instancePar_MULT*d_NF_i_dX+instanceStruct.d_instancePar_MULT_dX*NF_i):0.0);
instanceStruct.instanceVar_MULT_i = (((instanceStruct.instancePar_MULT*NF_i)>0.0)?(instanceStruct.instancePar_MULT*NF_i):0.0);
if ((modelStruct.modelPar_SWJUNASYM==0.0))
{
modelStruct.d_modelVar_TOXOVD_i_dX = modelStruct.d_modelVar_TOXOV_i_dX;
modelStruct.modelVar_TOXOVD_i = modelStruct.modelVar_TOXOV_i;
instanceStruct.d_instanceVar_NOVD_i_dX = instanceStruct.d_instanceVar_NOV_i_dX;
instanceStruct.instanceVar_NOVD_i = instanceStruct.instanceVar_NOV_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX = instanceStruct.d_instanceVar_AGIDL_i_dX;
instanceStruct.instanceVar_AGIDLD_i = instanceStruct.instanceVar_AGIDL_i;
d_BGIDLD_i_dX = d_BGIDL_i_dX;
BGIDLD_i = BGIDL_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = instanceStruct.d_instanceVar_STBGIDL_i_dX;
instanceStruct.instanceVar_STBGIDLD_i = instanceStruct.instanceVar_STBGIDL_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX = instanceStruct.d_instanceVar_CGIDL_i_dX;
instanceStruct.instanceVar_CGIDLD_i = instanceStruct.instanceVar_CGIDL_i;
instanceStruct.d_instanceVar_IGOVD_i_dX = instanceStruct.d_instanceVar_IGOV_i_dX;
instanceStruct.instanceVar_IGOVD_i = instanceStruct.instanceVar_IGOV_i;
instanceStruct.d_instanceVar_CGOVD_i_dX = instanceStruct.d_instanceVar_CGOV_i_dX;
instanceStruct.instanceVar_CGOVD_i = instanceStruct.instanceVar_CGOV_i;
instanceStruct.d_instanceVar_CFRD_i_dX = instanceStruct.d_instanceVar_CFR_i_dX;
instanceStruct.instanceVar_CFRD_i = instanceStruct.instanceVar_CFR_i;
}
if ((((modelStruct.modelPar_SWJUNCAP==1.0)||(modelStruct.modelPar_SWJUNCAP==2.0))||(modelStruct.modelPar_SWJUNCAP==3.0)))
{
instanceStruct.d_instanceVar_ABSOURCE_i_dX = ((ABS_i>0)?d_ABS_i_dX:0.0);
instanceStruct.instanceVar_ABSOURCE_i = ((ABS_i>0)?ABS_i:0);
instanceStruct.d_instanceVar_LSSOURCE_i_dX = ((LSS_i>0)?d_LSS_i_dX:0.0);
instanceStruct.instanceVar_LSSOURCE_i = ((LSS_i>0)?LSS_i:0);
instanceStruct.d_instanceVar_LGSOURCE_i_dX = ((LGS_i>0)?d_LGS_i_dX:0.0);
instanceStruct.instanceVar_LGSOURCE_i = ((LGS_i>0)?LGS_i:0);
instanceStruct.d_instanceVar_ABDRAIN_i_dX = ((ABD_i>0)?d_ABD_i_dX:0.0);
instanceStruct.instanceVar_ABDRAIN_i = ((ABD_i>0)?ABD_i:0);
instanceStruct.d_instanceVar_LSDRAIN_i_dX = ((LSD_i>0)?d_LSD_i_dX:0.0);
instanceStruct.instanceVar_LSDRAIN_i = ((LSD_i>0)?LSD_i:0);
instanceStruct.d_instanceVar_LGDRAIN_i_dX = ((LGD_i>0)?d_LGD_i_dX:0.0);
instanceStruct.instanceVar_LGDRAIN_i = ((LGD_i>0)?LGD_i:0);
}
else
{
instanceStruct.d_instanceVar_ABSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_ABSOURCE_i = 0.0;
instanceStruct.d_instanceVar_LSSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_LSSOURCE_i = 0.0;
instanceStruct.d_instanceVar_LGSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_LGSOURCE_i = 0.0;
instanceStruct.d_instanceVar_ABDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_ABDRAIN_i = 0.0;
instanceStruct.d_instanceVar_LSDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_LSDRAIN_i = 0.0;
instanceStruct.d_instanceVar_LGDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_LGDRAIN_i = 0.0;
}
d_EPSOX_dX = 8.8541878176E-12*modelStruct.d_modelVar_EPSROX_i_dX;
EPSOX = (8.8541878176E-12*modelStruct.modelVar_EPSROX_i);
instanceStruct.d_instanceVar_phit1_dX = (modelStruct.modelVar_phit*(instanceStruct.instanceVar_CT_i*modelStruct.d_modelVar_rTn_dX+instanceStruct.d_instanceVar_CT_i_dX*modelStruct.modelVar_rTn)+modelStruct.d_modelVar_phit_dX*(1.0+(instanceStruct.instanceVar_CT_i*modelStruct.modelVar_rTn)));
instanceStruct.instanceVar_phit1 = (modelStruct.modelVar_phit*(1.0+(instanceStruct.instanceVar_CT_i*modelStruct.modelVar_rTn)));
instanceStruct.d_instanceVar_inv_phit1_dX = (-instanceStruct.d_instanceVar_phit1_dX/instanceStruct.instanceVar_phit1/instanceStruct.instanceVar_phit1);
instanceStruct.instanceVar_inv_phit1 = (1.0/instanceStruct.instanceVar_phit1);
instanceStruct.d_instanceVar_VFB_i_dX = ((instanceStruct.d_instanceVar_VFB_i_dX+(instanceStruct.instanceVar_STVFB_i*modelStruct.d_modelVar_dT_dX+instanceStruct.d_instanceVar_STVFB_i_dX*modelStruct.modelVar_dT))+d_DELVTO_i_dX);
instanceStruct.instanceVar_VFB_i = ((instanceStruct.instanceVar_VFB_i+(instanceStruct.instanceVar_STVFB_i*modelStruct.modelVar_dT))+DELVTO_i);
{
double value_pow_0 = pow(modelStruct.modelVar_phibFac,(-0.75));
double value_log_1 = log(((instanceStruct.instanceVar_NEFF_i*value_pow_0)*4.0e-26));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_phibFac == 0.0)?0.0:(value_pow_0*(-0.75)/modelStruct.modelVar_phibFac));
double  deriv_log_1_d0 = (1.0/((instanceStruct.instanceVar_NEFF_i*value_pow_0)*4.0e-26));
instanceStruct.d_instanceVar_phib_dX = ((modelStruct.d_modelVar_Eg_dX+instanceStruct.d_instanceVar_DPHIB_i_dX)+((2.0*modelStruct.modelVar_phit)*deriv_log_1_d0*((instanceStruct.instanceVar_NEFF_i*(deriv_pow_0_d0*(modelStruct.d_modelVar_phibFac_dX))+instanceStruct.d_instanceVar_NEFF_i_dX*value_pow_0)*4.0e-26)+2.0*modelStruct.d_modelVar_phit_dX*value_log_1));
instanceStruct.instanceVar_phib = ((modelStruct.modelVar_Eg+instanceStruct.instanceVar_DPHIB_i)+((2.0*modelStruct.modelVar_phit)*value_log_1));
}
instanceStruct.d_instanceVar_phib_dX = ((instanceStruct.instanceVar_phib>5.0E-2)?instanceStruct.d_instanceVar_phib_dX:0.0);
instanceStruct.instanceVar_phib = ((instanceStruct.instanceVar_phib>5.0E-2)?instanceStruct.instanceVar_phib:5.0E-2);
d_CoxPrime_dX = ((modelStruct.modelVar_TOX_i*d_EPSOX_dX-EPSOX*modelStruct.d_modelVar_TOX_i_dX)/modelStruct.modelVar_TOX_i/modelStruct.modelVar_TOX_i);
CoxPrime = (EPSOX/modelStruct.modelVar_TOX_i);
d_tox_sq_dX = (modelStruct.modelVar_TOX_i*modelStruct.d_modelVar_TOX_i_dX+modelStruct.d_modelVar_TOX_i_dX*modelStruct.modelVar_TOX_i);
tox_sq = (modelStruct.modelVar_TOX_i*modelStruct.modelVar_TOX_i);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFF_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_G_0_dX = ((CoxPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFF_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NEFF_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxPrime_dX)/CoxPrime/CoxPrime);
instanceStruct.instanceVar_G_0 = (value_sqrt_0/CoxPrime);
}
instanceStruct.d_instanceVar_kp_dX = 0.0;
instanceStruct.instanceVar_kp = 0.0;
if ((instanceStruct.instanceVar_NP_i>0.0))
{
d_arg2max_dX = (-8.0e7*d_tox_sq_dX/tox_sq/tox_sq);
arg2max = (8.0e7/tox_sq);
d_np_dX = ((instanceStruct.instanceVar_NP_i>arg2max)?instanceStruct.d_instanceVar_NP_i_dX:d_arg2max_dX);
np = ((instanceStruct.instanceVar_NP_i>arg2max)?instanceStruct.instanceVar_NP_i:arg2max);
d_np_dX = ((5.0e24>np)?0.0:d_np_dX);
np = ((5.0e24>np)?5.0e24:np);
instanceStruct.d_instanceVar_kp_dX = ((((1.6021918E-19*np)*modelStruct.modelVar_EPSSI)*(((2.0*CoxPrime)*CoxPrime)*modelStruct.d_modelVar_phit_dX+((2.0*CoxPrime)*d_CoxPrime_dX+2.0*d_CoxPrime_dX*CoxPrime)*modelStruct.modelVar_phit)-(((2.0*CoxPrime)*CoxPrime)*modelStruct.modelVar_phit)*1.6021918E-19*d_np_dX*modelStruct.modelVar_EPSSI)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI));
instanceStruct.instanceVar_kp = ((((2.0*CoxPrime)*CoxPrime)*modelStruct.modelVar_phit)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI));
}
instanceStruct.d_instanceVar_qlim2_dX = ((100.0*modelStruct.modelVar_phit)*modelStruct.d_modelVar_phit_dX+100.0*modelStruct.d_modelVar_phit_dX*modelStruct.modelVar_phit);
instanceStruct.instanceVar_qlim2 = ((100.0*modelStruct.modelVar_phit)*modelStruct.modelVar_phit);
instanceStruct.d_instanceVar_qq_dX = 0.0;
instanceStruct.instanceVar_qq = 0.0;
if ((QMC_i>0.0))
{
{
double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
double  deriv_pow_0_d0 = ((CoxPrime == 0.0)?0.0:(value_pow_0*6.6666666666666667e-01/CoxPrime));
instanceStruct.d_instanceVar_qq_dX = (((0.4*5.951993)*QMC_i)*(deriv_pow_0_d0*(d_CoxPrime_dX))+(0.4*5.951993)*d_QMC_i_dX*value_pow_0);
instanceStruct.instanceVar_qq = (((0.4*5.951993)*QMC_i)*value_pow_0);
}
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
instanceStruct.d_instanceVar_qq_dX = (7.448711/5.951993)*instanceStruct.d_instanceVar_qq_dX;
instanceStruct.instanceVar_qq = ((7.448711/5.951993)*instanceStruct.instanceVar_qq);
}
{
double value_sqrt_0 = sqrt((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0)*instanceStruct.instanceVar_G_0)*instanceStruct.instanceVar_phib));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qb0_dX = deriv_sqrt_0_d0*((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0)*instanceStruct.instanceVar_G_0)*instanceStruct.d_instanceVar_phib_dX+((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0)*instanceStruct.d_instanceVar_G_0_dX+(modelStruct.modelVar_phit*instanceStruct.d_instanceVar_G_0_dX+modelStruct.d_modelVar_phit_dX*instanceStruct.instanceVar_G_0)*instanceStruct.instanceVar_G_0)*instanceStruct.instanceVar_phib));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
double  deriv_pow_0_d0 = ((qb0 == 0.0)?0.0:(value_pow_0*6.6666666666666667e-01/qb0));
d_dphibq_dX = ((0.75*instanceStruct.instanceVar_qq)*(deriv_pow_0_d0*(d_qb0_dX))+0.75*instanceStruct.d_instanceVar_qq_dX*value_pow_0);
dphibq = ((0.75*instanceStruct.instanceVar_qq)*value_pow_0);
}
instanceStruct.d_instanceVar_phib_dX = (instanceStruct.d_instanceVar_phib_dX+d_dphibq_dX);
instanceStruct.instanceVar_phib = (instanceStruct.instanceVar_phib+dphibq);
instanceStruct.d_instanceVar_G_0_dX = (instanceStruct.instanceVar_G_0*((qb0*(2.0*6.6666666666666667e-01)*d_dphibq_dX-((2.0*6.6666666666666667e-01)*dphibq)*d_qb0_dX)/qb0/qb0)+instanceStruct.d_instanceVar_G_0_dX*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
instanceStruct.instanceVar_G_0 = (instanceStruct.instanceVar_G_0*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_phib);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_sqrt_phib_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_phib_dX);
instanceStruct.instanceVar_sqrt_phib = value_sqrt_0;
}
instanceStruct.d_instanceVar_phix_dX = 0.95*instanceStruct.d_instanceVar_phib_dX;
instanceStruct.instanceVar_phix = (0.95*instanceStruct.instanceVar_phib);
instanceStruct.d_instanceVar_aphi_dX = ((0.0025*instanceStruct.instanceVar_phib)*instanceStruct.d_instanceVar_phib_dX+0.0025*instanceStruct.d_instanceVar_phib_dX*instanceStruct.instanceVar_phib);
instanceStruct.instanceVar_aphi = ((0.0025*instanceStruct.instanceVar_phib)*instanceStruct.instanceVar_phib);
instanceStruct.d_instanceVar_bphi_dX = instanceStruct.d_instanceVar_aphi_dX;
instanceStruct.instanceVar_bphi = instanceStruct.instanceVar_aphi;
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_bphi);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_phix2_dX = 0.5*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_dX);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((instanceStruct.instanceVar_phix-phix2))*((instanceStruct.instanceVar_phix-phix2)))+instanceStruct.instanceVar_aphi));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_phix1_dX = 0.5*((instanceStruct.d_instanceVar_phix_dX-d_phix2_dX)-deriv_sqrt_0_d0*(((((instanceStruct.instanceVar_phix-phix2))*(instanceStruct.d_instanceVar_phix_dX-d_phix2_dX)+(instanceStruct.d_instanceVar_phix_dX-d_phix2_dX)*((instanceStruct.instanceVar_phix-phix2)))+instanceStruct.d_instanceVar_aphi_dX)));
instanceStruct.instanceVar_phix1 = (0.5*((instanceStruct.instanceVar_phix-phix2)-value_sqrt_0));
}
d_CoxovPrime_dX = ((modelStruct.modelVar_TOXOV_i*d_EPSOX_dX-EPSOX*modelStruct.d_modelVar_TOXOV_i_dX)/modelStruct.modelVar_TOXOV_i/modelStruct.modelVar_TOXOV_i);
CoxovPrime = (EPSOX/modelStruct.modelVar_TOXOV_i);
d_CoxovPrime_d_dX = ((modelStruct.modelVar_TOXOVD_i*d_EPSOX_dX-EPSOX*modelStruct.d_modelVar_TOXOVD_i_dX)/modelStruct.modelVar_TOXOVD_i/modelStruct.modelVar_TOXOVD_i);
CoxovPrime_d = (EPSOX/modelStruct.modelVar_TOXOVD_i);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOV_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_GOV_s_dX = ((CoxovPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOV_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NOV_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxovPrime_dX)/CoxovPrime/CoxovPrime);
instanceStruct.instanceVar_GOV_s = (value_sqrt_0/CoxovPrime);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOVD_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_GOV_d_dX = ((CoxovPrime_d*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOVD_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NOVD_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxovPrime_d_dX)/CoxovPrime_d/CoxovPrime_d);
instanceStruct.instanceVar_GOV_d = (value_sqrt_0/CoxovPrime_d);
}
instanceStruct.d_instanceVar_GOV2_s_dX = (instanceStruct.instanceVar_GOV_s*instanceStruct.d_instanceVar_GOV_s_dX+instanceStruct.d_instanceVar_GOV_s_dX*instanceStruct.instanceVar_GOV_s);
instanceStruct.instanceVar_GOV2_s = (instanceStruct.instanceVar_GOV_s*instanceStruct.instanceVar_GOV_s);
instanceStruct.d_instanceVar_GOV2_d_dX = (instanceStruct.instanceVar_GOV_d*instanceStruct.d_instanceVar_GOV_d_dX+instanceStruct.d_instanceVar_GOV_d_dX*instanceStruct.instanceVar_GOV_d);
instanceStruct.instanceVar_GOV2_d = (instanceStruct.instanceVar_GOV_d*instanceStruct.instanceVar_GOV_d);
instanceStruct.d_instanceVar_xi_ov_s_dX = instanceStruct.d_instanceVar_GOV_s_dX*7.0710678118654746e-01;
instanceStruct.instanceVar_xi_ov_s = (1.0+(instanceStruct.instanceVar_GOV_s*7.0710678118654746e-01));
instanceStruct.d_instanceVar_xi_ov_d_dX = instanceStruct.d_instanceVar_GOV_d_dX*7.0710678118654746e-01;
instanceStruct.instanceVar_xi_ov_d = (1.0+(instanceStruct.instanceVar_GOV_d*7.0710678118654746e-01));
instanceStruct.d_instanceVar_inv_xi_ov_s_dX = (-instanceStruct.d_instanceVar_xi_ov_s_dX/instanceStruct.instanceVar_xi_ov_s/instanceStruct.instanceVar_xi_ov_s);
instanceStruct.instanceVar_inv_xi_ov_s = (1.0/instanceStruct.instanceVar_xi_ov_s);
instanceStruct.d_instanceVar_inv_xi_ov_d_dX = (-instanceStruct.d_instanceVar_xi_ov_d_dX/instanceStruct.instanceVar_xi_ov_d/instanceStruct.instanceVar_xi_ov_d);
instanceStruct.instanceVar_inv_xi_ov_d = (1.0/instanceStruct.instanceVar_xi_ov_d);
instanceStruct.d_instanceVar_x_mrg_ov_s_dX = 1.0e-5*instanceStruct.d_instanceVar_xi_ov_s_dX;
instanceStruct.instanceVar_x_mrg_ov_s = (1.0e-5*instanceStruct.instanceVar_xi_ov_s);
instanceStruct.d_instanceVar_x_mrg_ov_d_dX = 1.0e-5*instanceStruct.d_instanceVar_xi_ov_d_dX;
instanceStruct.instanceVar_x_mrg_ov_d = (1.0e-5*instanceStruct.instanceVar_xi_ov_d);
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STBET_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STBET_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_bet_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STBET_i_dX)));
tf_bet = value_pow_0;
}
instanceStruct.d_instanceVar_BET_i_dX = (((FACTUO_i*instanceStruct.instanceVar_BETN_i)*CoxPrime)*d_tf_bet_dX+((FACTUO_i*instanceStruct.instanceVar_BETN_i)*d_CoxPrime_dX+(FACTUO_i*instanceStruct.d_instanceVar_BETN_i_dX+d_FACTUO_i_dX*instanceStruct.instanceVar_BETN_i)*CoxPrime)*tf_bet);
instanceStruct.instanceVar_BET_i = (((FACTUO_i*instanceStruct.instanceVar_BETN_i)*CoxPrime)*tf_bet);
instanceStruct.d_instanceVar_BETN_i_dX = (instanceStruct.instanceVar_BETN_i*d_tf_bet_dX+instanceStruct.d_instanceVar_BETN_i_dX*tf_bet);
instanceStruct.instanceVar_BETN_i = (instanceStruct.instanceVar_BETN_i*tf_bet);
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STTHEMU_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STTHEMU_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
instanceStruct.d_instanceVar_THEMU_i_dX = (instanceStruct.instanceVar_THEMU_i*((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STTHEMU_i_dX)))+instanceStruct.d_instanceVar_THEMU_i_dX*value_pow_0);
instanceStruct.instanceVar_THEMU_i = (instanceStruct.instanceVar_THEMU_i*value_pow_0);
}
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STMUE_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STMUE_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_mue_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STMUE_i_dX)));
tf_mue = value_pow_0;
}
instanceStruct.d_instanceVar_MUE_i_dX = (instanceStruct.instanceVar_MUE_i*d_tf_mue_dX+instanceStruct.d_instanceVar_MUE_i_dX*tf_mue);
instanceStruct.instanceVar_MUE_i = (instanceStruct.instanceVar_MUE_i*tf_mue);
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STCS_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STCS_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_cs_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STCS_i_dX)));
tf_cs = value_pow_0;
}
instanceStruct.d_instanceVar_CS_i_dX = (instanceStruct.instanceVar_CS_i*d_tf_cs_dX+instanceStruct.d_instanceVar_CS_i_dX*tf_cs);
instanceStruct.instanceVar_CS_i = (instanceStruct.instanceVar_CS_i*tf_cs);
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STXCOR_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STXCOR_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_xcor_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STXCOR_i_dX)));
tf_xcor = value_pow_0;
}
instanceStruct.d_instanceVar_XCOR_i_dX = (instanceStruct.instanceVar_XCOR_i*d_tf_xcor_dX+instanceStruct.d_instanceVar_XCOR_i_dX*tf_xcor);
instanceStruct.instanceVar_XCOR_i = (instanceStruct.instanceVar_XCOR_i*tf_xcor);
instanceStruct.d_instanceVar_E_eff0_dX = (1.0e-8*d_CoxPrime_dX/modelStruct.modelVar_EPSSI);
instanceStruct.instanceVar_E_eff0 = ((1.0e-8*CoxPrime)/modelStruct.modelVar_EPSSI);
instanceStruct.d_instanceVar_eta_mu_dX = 0.5*instanceStruct.d_instanceVar_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (0.5*instanceStruct.instanceVar_FETA_i);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
instanceStruct.d_instanceVar_eta_mu_dX = 3.3333333333333333e-01*instanceStruct.d_instanceVar_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (3.3333333333333333e-01*instanceStruct.instanceVar_FETA_i);
}
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STRS_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STRS_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_ther_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STRS_i_dX)));
tf_ther = value_pow_0;
}
instanceStruct.d_instanceVar_RS_i_dX = (instanceStruct.instanceVar_RS_i*d_tf_ther_dX+instanceStruct.d_instanceVar_RS_i_dX*tf_ther);
instanceStruct.instanceVar_RS_i = (instanceStruct.instanceVar_RS_i*tf_ther);
instanceStruct.d_instanceVar_THER_i_dX = ((2*instanceStruct.instanceVar_BET_i)*instanceStruct.d_instanceVar_RS_i_dX+2*instanceStruct.d_instanceVar_BET_i_dX*instanceStruct.instanceVar_RS_i);
instanceStruct.instanceVar_THER_i = ((2*instanceStruct.instanceVar_BET_i)*instanceStruct.instanceVar_RS_i);
{
double value_pow_0 = pow(modelStruct.modelVar_rTn,instanceStruct.instanceVar_STTHESAT_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTn == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STTHESAT_i/modelStruct.modelVar_rTn));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTn == 0.0)?0.0:(log(modelStruct.modelVar_rTn)*value_pow_0);
d_tf_thesat_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTn_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STTHESAT_i_dX)));
tf_thesat = value_pow_0;
}
instanceStruct.d_instanceVar_THESAT_i_dX = (instanceStruct.instanceVar_THESAT_i*d_tf_thesat_dX+instanceStruct.d_instanceVar_THESAT_i_dX*tf_thesat);
instanceStruct.instanceVar_THESAT_i = (instanceStruct.instanceVar_THESAT_i*tf_thesat);
instanceStruct.d_instanceVar_Vdsat_lim_dX = 3.912023005*instanceStruct.d_instanceVar_phit1_dX;
instanceStruct.instanceVar_Vdsat_lim = (3.912023005*instanceStruct.instanceVar_phit1);
instanceStruct.d_instanceVar_inv_AX_dX = (-instanceStruct.d_instanceVar_AX_i_dX/instanceStruct.instanceVar_AX_i/instanceStruct.instanceVar_AX_i);
instanceStruct.instanceVar_inv_AX = (1.0/instanceStruct.instanceVar_AX_i);
instanceStruct.d_instanceVar_inv_VP_dX = (-instanceStruct.d_instanceVar_VP_i_dX/instanceStruct.instanceVar_VP_i/instanceStruct.instanceVar_VP_i);
instanceStruct.instanceVar_inv_VP = (1.0/instanceStruct.instanceVar_VP_i);
{
double value_pow_0 = pow(modelStruct.modelVar_rT,instanceStruct.instanceVar_STA2_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rT == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STA2_i/modelStruct.modelVar_rT));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rT == 0.0)?0.0:(log(modelStruct.modelVar_rT)*value_pow_0);
instanceStruct.d_instanceVar_A2_i_dX = (instanceStruct.instanceVar_A2_i*((deriv_pow_0_d0*(modelStruct.d_modelVar_rT_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STA2_i_dX)))+instanceStruct.d_instanceVar_A2_i_dX*value_pow_0);
instanceStruct.instanceVar_A2_i = (instanceStruct.instanceVar_A2_i*value_pow_0);
}
{
double value_pow_0 = pow(modelStruct.modelVar_rT,instanceStruct.instanceVar_STIG_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rT == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STIG_i/modelStruct.modelVar_rT));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rT == 0.0)?0.0:(log(modelStruct.modelVar_rT)*value_pow_0);
d_tf_ig_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rT_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STIG_i_dX)));
tf_ig = value_pow_0;
}
instanceStruct.d_instanceVar_IGINV_i_dX = (instanceStruct.instanceVar_IGINV_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGINV_i_dX*tf_ig);
instanceStruct.instanceVar_IGINV_i = (instanceStruct.instanceVar_IGINV_i*tf_ig);
instanceStruct.d_instanceVar_IGOV_i_dX = (instanceStruct.instanceVar_IGOV_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGOV_i_dX*tf_ig);
instanceStruct.instanceVar_IGOV_i = (instanceStruct.instanceVar_IGOV_i*tf_ig);
instanceStruct.d_instanceVar_IGOVD_i_dX = (instanceStruct.instanceVar_IGOVD_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGOVD_i_dX*tf_ig);
instanceStruct.instanceVar_IGOVD_i = (instanceStruct.instanceVar_IGOVD_i*tf_ig);
instanceStruct.d_instanceVar_inv_CHIB_dX = (-instanceStruct.d_instanceVar_CHIB_i_dX/instanceStruct.instanceVar_CHIB_i/instanceStruct.instanceVar_CHIB_i);
instanceStruct.instanceVar_inv_CHIB = (1.0/instanceStruct.instanceVar_CHIB_i);
{
double value_sqrt_0 = sqrt((((2*1.6021918E-19)*9.1093826E-31)*instanceStruct.instanceVar_CHIB_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tempM_dX = ((4.0*3.3333333333333333e-01)*deriv_sqrt_0_d0*(((2*1.6021918E-19)*9.1093826E-31)*instanceStruct.d_instanceVar_CHIB_i_dX)/1.05457168E-34);
tempM = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
}
instanceStruct.d_instanceVar_BCH_dX = (tempM*modelStruct.d_modelVar_TOX_i_dX+d_tempM_dX*modelStruct.modelVar_TOX_i);
instanceStruct.instanceVar_BCH = (tempM*modelStruct.modelVar_TOX_i);
instanceStruct.d_instanceVar_BOV_dX = (tempM*modelStruct.d_modelVar_TOXOV_i_dX+d_tempM_dX*modelStruct.modelVar_TOXOV_i);
instanceStruct.instanceVar_BOV = (tempM*modelStruct.modelVar_TOXOV_i);
instanceStruct.d_instanceVar_BOV_d_dX = (tempM*modelStruct.d_modelVar_TOXOVD_i_dX+d_tempM_dX*modelStruct.modelVar_TOXOVD_i);
instanceStruct.instanceVar_BOV_d = (tempM*modelStruct.modelVar_TOXOVD_i);
instanceStruct.d_instanceVar_GCQ_dX = 0.0;
instanceStruct.instanceVar_GCQ = 0;
if ((instanceStruct.instanceVar_GC3_i<0))
{
instanceStruct.d_instanceVar_GCQ_dX = ((instanceStruct.instanceVar_GC3_i*(-0.495)*instanceStruct.d_instanceVar_GC2_i_dX-((-0.495)*instanceStruct.instanceVar_GC2_i)*instanceStruct.d_instanceVar_GC3_i_dX)/instanceStruct.instanceVar_GC3_i/instanceStruct.instanceVar_GC3_i);
instanceStruct.instanceVar_GCQ = (((-0.495)*instanceStruct.instanceVar_GC2_i)/instanceStruct.instanceVar_GC3_i);
}
instanceStruct.d_instanceVar_alpha_b_dX = 0.5*(instanceStruct.d_instanceVar_phib_dX+modelStruct.d_modelVar_Eg_dX);
instanceStruct.instanceVar_alpha_b = (0.5*(instanceStruct.instanceVar_phib+modelStruct.modelVar_Eg));
instanceStruct.d_instanceVar_Dch_dX = (instanceStruct.instanceVar_GCO_i*instanceStruct.d_instanceVar_phit1_dX+instanceStruct.d_instanceVar_GCO_i_dX*instanceStruct.instanceVar_phit1);
instanceStruct.instanceVar_Dch = (instanceStruct.instanceVar_GCO_i*instanceStruct.instanceVar_phit1);
instanceStruct.d_instanceVar_Dov_dX = (instanceStruct.instanceVar_GCO_i*modelStruct.d_modelVar_phit_dX+instanceStruct.d_instanceVar_GCO_i_dX*modelStruct.modelVar_phit);
instanceStruct.instanceVar_Dov = (instanceStruct.instanceVar_GCO_i*modelStruct.modelVar_phit);
instanceStruct.d_instanceVar_AGIDLs_dX = (((modelStruct.modelVar_TOXOV_i*modelStruct.modelVar_TOXOV_i)*instanceStruct.d_instanceVar_AGIDL_i_dX*4e-18-(instanceStruct.instanceVar_AGIDL_i*4e-18)*(modelStruct.modelVar_TOXOV_i*modelStruct.d_modelVar_TOXOV_i_dX+modelStruct.d_modelVar_TOXOV_i_dX*modelStruct.modelVar_TOXOV_i))/(modelStruct.modelVar_TOXOV_i*modelStruct.modelVar_TOXOV_i)/(modelStruct.modelVar_TOXOV_i*modelStruct.modelVar_TOXOV_i));
instanceStruct.instanceVar_AGIDLs = ((instanceStruct.instanceVar_AGIDL_i*4e-18)/(modelStruct.modelVar_TOXOV_i*modelStruct.modelVar_TOXOV_i));
instanceStruct.d_instanceVar_AGIDLDs_dX = (((modelStruct.modelVar_TOXOVD_i*modelStruct.modelVar_TOXOVD_i)*instanceStruct.d_instanceVar_AGIDLD_i_dX*4e-18-(instanceStruct.instanceVar_AGIDLD_i*4e-18)*(modelStruct.modelVar_TOXOVD_i*modelStruct.d_modelVar_TOXOVD_i_dX+modelStruct.d_modelVar_TOXOVD_i_dX*modelStruct.modelVar_TOXOVD_i))/(modelStruct.modelVar_TOXOVD_i*modelStruct.modelVar_TOXOVD_i)/(modelStruct.modelVar_TOXOVD_i*modelStruct.modelVar_TOXOVD_i));
instanceStruct.instanceVar_AGIDLDs = ((instanceStruct.instanceVar_AGIDLD_i*4e-18)/(modelStruct.modelVar_TOXOVD_i*modelStruct.modelVar_TOXOVD_i));
d_tempM_dX = (((1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_dT))>0)?(instanceStruct.instanceVar_STBGIDL_i*modelStruct.d_modelVar_dT_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*modelStruct.modelVar_dT):0.0);
tempM = (((1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_dT))>0)?(1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_dT)):0);
instanceStruct.d_instanceVar_BGIDL_T_dX = (BGIDL_i*d_tempM_dX+d_BGIDL_i_dX*tempM);
instanceStruct.instanceVar_BGIDL_T = (BGIDL_i*tempM);
instanceStruct.d_instanceVar_BGIDLs_dX = (instanceStruct.instanceVar_BGIDL_T*modelStruct.d_modelVar_TOXOV_i_dX+instanceStruct.d_instanceVar_BGIDL_T_dX*modelStruct.modelVar_TOXOV_i)*5e8;
instanceStruct.instanceVar_BGIDLs = ((instanceStruct.instanceVar_BGIDL_T*modelStruct.modelVar_TOXOV_i)*5e8);
d_tempM_dX = (((1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_dT))>0)?(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.d_modelVar_dT_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*modelStruct.modelVar_dT):0.0);
tempM = (((1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_dT))>0)?(1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_dT)):0);
instanceStruct.d_instanceVar_BGIDLD_T_dX = (BGIDLD_i*d_tempM_dX+d_BGIDLD_i_dX*tempM);
instanceStruct.instanceVar_BGIDLD_T = (BGIDLD_i*tempM);
instanceStruct.d_instanceVar_BGIDLDs_dX = (instanceStruct.instanceVar_BGIDLD_T*modelStruct.d_modelVar_TOXOVD_i_dX+instanceStruct.d_instanceVar_BGIDLD_T_dX*modelStruct.modelVar_TOXOVD_i)*5e8;
instanceStruct.instanceVar_BGIDLDs = ((instanceStruct.instanceVar_BGIDLD_T*modelStruct.modelVar_TOXOVD_i)*5e8);
instanceStruct.d_instanceVar_nt_dX = (((instanceStruct.instanceVar_FNT_i*4)*1.3806505E-23)*modelStruct.d_modelVar_TKD_dX+instanceStruct.d_instanceVar_FNT_i_dX*4*1.3806505E-23*modelStruct.modelVar_TKD);
instanceStruct.instanceVar_nt = (((instanceStruct.instanceVar_FNT_i*4)*1.3806505E-23)*modelStruct.modelVar_TKD);
instanceStruct.d_instanceVar_Cox_over_q_dX = (d_CoxPrime_dX/1.6021918E-19);
instanceStruct.instanceVar_Cox_over_q = (CoxPrime/1.6021918E-19);
instanceStruct.d_instanceVar_Sfl_prefac_dX = ((instanceStruct.instanceVar_Cox_over_q*((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.d_instanceVar_BET_i_dX+(modelStruct.modelVar_phit*modelStruct.d_modelVar_phit_dX+modelStruct.d_modelVar_phit_dX*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)-((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)*instanceStruct.d_instanceVar_Cox_over_q_dX)/instanceStruct.instanceVar_Cox_over_q/instanceStruct.instanceVar_Cox_over_q);
instanceStruct.instanceVar_Sfl_prefac = (((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)/instanceStruct.instanceVar_Cox_over_q);
instanceStruct.d_instanceVar_fac_exc_dX = (9.1093826E-31*1e9)*instanceStruct.d_instanceVar_FNTEXC_i_dX;
instanceStruct.instanceVar_fac_exc = ((9.1093826E-31*1e9)*instanceStruct.instanceVar_FNTEXC_i);
instanceStruct.instanceVar_x1 = 1.25;
instanceStruct.d_instanceVar_inv_xg1_s_dX = (-instanceStruct.d_instanceVar_GOV_s_dX*7.324648775608221e-1/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_s*7.324648775608221e-1))/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_s*7.324648775608221e-1)));
instanceStruct.instanceVar_inv_xg1_s = (1.0/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_s*7.324648775608221e-1)));
instanceStruct.d_instanceVar_inv_xg1_d_dX = (-instanceStruct.d_instanceVar_GOV_d_dX*7.324648775608221e-1/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_d*7.324648775608221e-1))/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_d*7.324648775608221e-1)));
instanceStruct.instanceVar_inv_xg1_d = (1.0/(instanceStruct.instanceVar_x1+(instanceStruct.instanceVar_GOV_d*7.324648775608221e-1)));
if ((instanceStruct.instanceVar_RG_i>0.0))
{
instanceStruct.d_instanceVar_ggate_dX = (-instanceStruct.d_instanceVar_RG_i_dX/instanceStruct.instanceVar_RG_i/instanceStruct.instanceVar_RG_i);
instanceStruct.instanceVar_ggate = (1.0/instanceStruct.instanceVar_RG_i);
}
else
{
instanceStruct.d_instanceVar_ggate_dX = 0.0;
instanceStruct.instanceVar_ggate = 0.0;
}
if ((instanceStruct.instanceVar_RBULK_i>0.0))
{
instanceStruct.d_instanceVar_gbulk_dX = (-instanceStruct.d_instanceVar_RBULK_i_dX/instanceStruct.instanceVar_RBULK_i/instanceStruct.instanceVar_RBULK_i);
instanceStruct.instanceVar_gbulk = (1.0/instanceStruct.instanceVar_RBULK_i);
}
else
{
instanceStruct.d_instanceVar_gbulk_dX = 0.0;
instanceStruct.instanceVar_gbulk = 0.0;
}
if ((instanceStruct.instanceVar_RJUNS_i>0.0))
{
instanceStruct.d_instanceVar_gjuns_dX = (-instanceStruct.d_instanceVar_RJUNS_i_dX/instanceStruct.instanceVar_RJUNS_i/instanceStruct.instanceVar_RJUNS_i);
instanceStruct.instanceVar_gjuns = (1.0/instanceStruct.instanceVar_RJUNS_i);
}
else
{
instanceStruct.d_instanceVar_gjuns_dX = 0.0;
instanceStruct.instanceVar_gjuns = 0.0;
}
if ((instanceStruct.instanceVar_RJUND_i>0.0))
{
instanceStruct.d_instanceVar_gjund_dX = (-instanceStruct.d_instanceVar_RJUND_i_dX/instanceStruct.instanceVar_RJUND_i/instanceStruct.instanceVar_RJUND_i);
instanceStruct.instanceVar_gjund = (1.0/instanceStruct.instanceVar_RJUND_i);
}
else
{
instanceStruct.d_instanceVar_gjund_dX = 0.0;
instanceStruct.instanceVar_gjund = 0.0;
}
if ((instanceStruct.instanceVar_RWELL_i>0.0))
{
instanceStruct.d_instanceVar_gwell_dX = (-instanceStruct.d_instanceVar_RWELL_i_dX/instanceStruct.instanceVar_RWELL_i/instanceStruct.instanceVar_RWELL_i);
instanceStruct.instanceVar_gwell = (1.0/instanceStruct.instanceVar_RWELL_i);
}
else
{
instanceStruct.d_instanceVar_gwell_dX = 0.0;
instanceStruct.instanceVar_gwell = 0.0;
}
instanceStruct.d_instanceVar_vbimin_s_dX = 0.0;
instanceStruct.instanceVar_vbimin_s = 0.0;
instanceStruct.d_instanceVar_vbimin_d_dX = 0.0;
instanceStruct.instanceVar_vbimin_d = 0.0;
instanceStruct.d_instanceVar_vfmin_s_dX = 0.0;
instanceStruct.instanceVar_vfmin_s = 0.0;
instanceStruct.d_instanceVar_vfmin_d_dX = 0.0;
instanceStruct.instanceVar_vfmin_d = 0.0;
instanceStruct.d_instanceVar_vch_s_dX = 0.0;
instanceStruct.instanceVar_vch_s = 0.0;
instanceStruct.d_instanceVar_vch_d_dX = 0.0;
instanceStruct.instanceVar_vch_d = 0.0;
instanceStruct.d_instanceVar_vbbtlim_s_dX = 0.0;
instanceStruct.instanceVar_vbbtlim_s = 0.0;
instanceStruct.d_instanceVar_vbbtlim_d_dX = 0.0;
instanceStruct.instanceVar_vbbtlim_d = 0.0;
instanceStruct.d_instanceVar_VMAX_s_dX = 0.0;
instanceStruct.instanceVar_VMAX_s = 0.0;
instanceStruct.d_instanceVar_VMAX_d_dX = 0.0;
instanceStruct.instanceVar_VMAX_d = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = 0.0;
instanceStruct.d_instanceVar_ISATFOR1_s_dX = 0.0;
instanceStruct.instanceVar_ISATFOR1_s = 0.0;
instanceStruct.d_instanceVar_ISATFOR1_d_dX = 0.0;
instanceStruct.instanceVar_ISATFOR1_d = 0.0;
instanceStruct.instanceVar_MFOR1_s = 1.0;
instanceStruct.instanceVar_MFOR1_d = 1.0;
instanceStruct.d_instanceVar_ISATFOR2_s_dX = 0.0;
instanceStruct.instanceVar_ISATFOR2_s = 0.0;
instanceStruct.d_instanceVar_ISATFOR2_d_dX = 0.0;
instanceStruct.instanceVar_ISATFOR2_d = 0.0;
instanceStruct.d_instanceVar_MFOR2_s_dX = 0.0;
instanceStruct.instanceVar_MFOR2_s = 1.0;
instanceStruct.d_instanceVar_MFOR2_d_dX = 0.0;
instanceStruct.instanceVar_MFOR2_d = 1.0;
instanceStruct.d_instanceVar_ISATREV_s_dX = 0.0;
instanceStruct.instanceVar_ISATREV_s = 0.0;
instanceStruct.d_instanceVar_ISATREV_d_dX = 0.0;
instanceStruct.instanceVar_ISATREV_d = 0.0;
instanceStruct.d_instanceVar_MREV_s_dX = 0.0;
instanceStruct.instanceVar_MREV_s = 1.0;
instanceStruct.d_instanceVar_MREV_d_dX = 0.0;
instanceStruct.instanceVar_MREV_d = 1.0;
instanceStruct.instanceVar_m0flag_s = 0.0;
instanceStruct.instanceVar_m0flag_d = 0.0;
instanceStruct.d_instanceVar_xhighf1_s_dX = 0.0;
instanceStruct.instanceVar_xhighf1_s = 0.0;
instanceStruct.d_instanceVar_xhighf1_d_dX = 0.0;
instanceStruct.instanceVar_xhighf1_d = 0.0;
instanceStruct.d_instanceVar_expxhf1_s_dX = 0.0;
instanceStruct.instanceVar_expxhf1_s = 0.0;
instanceStruct.d_instanceVar_expxhf1_d_dX = 0.0;
instanceStruct.instanceVar_expxhf1_d = 0.0;
instanceStruct.d_instanceVar_xhighf2_s_dX = 0.0;
instanceStruct.instanceVar_xhighf2_s = 0.0;
instanceStruct.d_instanceVar_xhighf2_d_dX = 0.0;
instanceStruct.instanceVar_xhighf2_d = 0.0;
instanceStruct.d_instanceVar_expxhf2_s_dX = 0.0;
instanceStruct.instanceVar_expxhf2_s = 0.0;
instanceStruct.d_instanceVar_expxhf2_d_dX = 0.0;
instanceStruct.instanceVar_expxhf2_d = 0.0;
instanceStruct.d_instanceVar_xhighr_s_dX = 0.0;
instanceStruct.instanceVar_xhighr_s = 0.0;
instanceStruct.d_instanceVar_xhighr_d_dX = 0.0;
instanceStruct.instanceVar_xhighr_d = 0.0;
instanceStruct.d_instanceVar_expxhr_s_dX = 0.0;
instanceStruct.instanceVar_expxhr_s = 0.0;
instanceStruct.d_instanceVar_expxhr_d_dX = 0.0;
instanceStruct.instanceVar_expxhr_d = 0.0;
instanceStruct.instanceVar_zflagbot_s = 1.0;
instanceStruct.instanceVar_zflagbot_d = 1.0;
instanceStruct.instanceVar_zflagsti_s = 1.0;
instanceStruct.instanceVar_zflagsti_d = 1.0;
instanceStruct.instanceVar_zflaggat_s = 1.0;
instanceStruct.instanceVar_zflaggat_d = 1.0;
d_m0_rev_dX = 0.0;
m0_rev = 0.0;
d_mcor_rev_dX = 0.0;
mcor_rev = 0.0;
d_I1_cor_dX = 0.0;
I1_cor = 0.0;
d_I2_cor_dX = 0.0;
I2_cor = 0.0;
d_I3_cor_dX = 0.0;
I3_cor = 0.0;
d_I4_cor_dX = 0.0;
I4_cor = 0.0;
d_I5_cor_dX = 0.0;
I5_cor = 0.0;
d_tt0_dX = 0.0;
tt0 = 0.0;
d_tt1_dX = 0.0;
tt1 = 0.0;
d_tt2_dX = 0.0;
tt2 = 0.0;
d_zfrac_dX = 0.0;
zfrac = 0.0;
d_alphaje_dX = 0.0;
alphaje = 0.0;
if ((modelStruct.modelPar_SWJUNCAP>0))
{
if (((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i))+1));
d_vmaxbot_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_ABSOURCE_i_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_ABSOURCE_i))/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxbot = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxbot_dX = 0.0;
vmaxbot = 1E8;
}
if (((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i))+1));
d_vmaxsti_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_LSSOURCE_i_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_LSSOURCE_i))/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxsti = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxsti_dX = 0.0;
vmaxsti = 1E8;
}
if (((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i))+1));
d_vmaxgat_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_LGSOURCE_i_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_LGSOURCE_i))/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxgat = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxgat_dX = 0.0;
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
double  deriv_min_0_d0 = ((vmaxbot<=vmaxsti)?1.0:0.0);
double  deriv_min_0_d1 = ((vmaxbot<=vmaxsti)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vmaxgat)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vmaxgat)?0.0:1.0);
instanceStruct.d_instanceVar_VMAX_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vmaxbot_dX))+(deriv_min_0_d1*(d_vmaxsti_dX)))))+(deriv_min_1_d1*(d_vmaxgat_dX)));
instanceStruct.instanceVar_VMAX_s = value_min_1;
}
if ((fabs((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = value_exp_0;
}
}
else
{
if (((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))+(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = 1.0e100*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_vbibot2_dX = modelStruct.d_modelVar_vbibot_dX;
vbibot2 = modelStruct.modelVar_vbibot;
d_vbisti2_dX = modelStruct.d_modelVar_vbisti_dX;
vbisti2 = modelStruct.modelVar_vbisti;
d_vbigat2_dX = modelStruct.d_modelVar_vbigat_dX;
vbigat2 = modelStruct.modelVar_vbigat;
d_pbot2_dX = modelStruct.d_modelVar_PBOT_i_dX;
pbot2 = modelStruct.modelVar_PBOT_i;
d_psti2_dX = modelStruct.d_modelVar_PSTI_i_dX;
psti2 = modelStruct.modelVar_PSTI_i;
d_pgat2_dX = modelStruct.d_modelVar_PGAT_i_dX;
pgat2 = modelStruct.modelVar_PGAT_i;
d_vbibot2r_dX = modelStruct.d_modelVar_VBIRBOT_i_dX;
vbibot2r = modelStruct.modelVar_VBIRBOT_i;
d_vbisti2r_dX = modelStruct.d_modelVar_VBIRSTI_i_dX;
vbisti2r = modelStruct.modelVar_VBIRSTI_i;
d_vbigat2r_dX = modelStruct.d_modelVar_VBIRGAT_i_dX;
vbigat2r = modelStruct.modelVar_VBIRGAT_i;
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_vbibot2_dX = (modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_vbigat_dX);
vbibot2 = (modelStruct.modelVar_vbisti+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PSTI_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_pbot2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PSTI_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
pbot2 = (0.9*value_min_0);
}
d_vbibot2r_dX = (modelStruct.d_modelVar_VBIRSTI_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbibot2r = (modelStruct.modelVar_VBIRSTI_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_vbisti2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbigat_dX);
vbisti2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_psti2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
psti2 = (0.9*value_min_0);
}
d_vbisti2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbisti2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_vbigat2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbisti_dX);
vbigat2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbisti);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PSTI_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?0.0:1.0);
d_pgat2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
pgat2 = (0.9*value_min_0);
}
d_vbigat2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRSTI_i_dX);
vbigat2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRSTI_i);
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
double  deriv_min_0_d0 = ((vbibot2<=vbisti2)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2<=vbisti2)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2)?0.0:1.0);
instanceStruct.d_instanceVar_vbimin_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2_dX))+(deriv_min_0_d1*(d_vbisti2_dX)))))+(deriv_min_1_d1*(d_vbigat2_dX)));
instanceStruct.instanceVar_vbimin_s = value_min_1;
}
instanceStruct.d_instanceVar_vch_s_dX = instanceStruct.d_instanceVar_vbimin_s_dX*0.1;
instanceStruct.instanceVar_vch_s = (instanceStruct.instanceVar_vbimin_s*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
double  deriv_max_0_d0 = ((pbot2>=psti2)?1.0:0.0);
double  deriv_max_0_d1 = ((pbot2>=psti2)?0.0:1.0);
double  deriv_max_1_d0 = ((value_max_0>=pgat2)?1.0:0.0);
double  deriv_max_1_d1 = ((value_max_0>=pgat2)?0.0:1.0);
d_pmax_dX = ((deriv_max_1_d0*(((deriv_max_0_d0*(d_pbot2_dX))+(deriv_max_0_d1*(d_psti2_dX)))))+(deriv_max_1_d1*(d_pgat2_dX)));
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
double  deriv_pow_0_d1 = (2 == 0.0)?0.0:(log(2)*value_pow_0);
instanceStruct.d_instanceVar_vfmin_s_dX = (instanceStruct.instanceVar_vbimin_s*(-(deriv_pow_0_d1*((-(-1.0)*d_pmax_dX/pmax/pmax))))+instanceStruct.d_instanceVar_vbimin_s_dX*(1-value_pow_0));
instanceStruct.instanceVar_vfmin_s = (instanceStruct.instanceVar_vbimin_s*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
double  deriv_min_0_d0 = ((vbibot2r<=vbisti2r)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2r<=vbisti2r)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2r)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2r)?0.0:1.0);
instanceStruct.d_instanceVar_vbbtlim_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2r_dX))+(deriv_min_0_d1*(d_vbisti2r_dX)))))+(deriv_min_1_d1*(d_vbigat2r_dX)));
instanceStruct.instanceVar_vbbtlim_s = (value_min_1-0.050);
}
if (((modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i))+1));
d_vmaxbot_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatbot_d*instanceStruct.d_instanceVar_ABDRAIN_i_dX+modelStruct.d_modelVar_idsatbot_d_dX*instanceStruct.instanceVar_ABDRAIN_i))/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxbot = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxbot_dX = 0.0;
vmaxbot = 1E8;
}
if (((modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i))+1));
d_vmaxsti_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatsti_d*instanceStruct.d_instanceVar_LSDRAIN_i_dX+modelStruct.d_modelVar_idsatsti_d_dX*instanceStruct.instanceVar_LSDRAIN_i))/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxsti = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxsti_dX = 0.0;
vmaxsti = 1E8;
}
if (((modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)>0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i))+1));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i))+1));
d_vmaxgat_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatgat_d*instanceStruct.d_instanceVar_LGDRAIN_i_dX+modelStruct.d_modelVar_idsatgat_d_dX*instanceStruct.instanceVar_LGDRAIN_i))/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxgat = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxgat_dX = 0.0;
vmaxgat = 1E8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
double  deriv_min_0_d0 = ((vmaxbot<=vmaxsti)?1.0:0.0);
double  deriv_min_0_d1 = ((vmaxbot<=vmaxsti)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vmaxgat)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vmaxgat)?0.0:1.0);
instanceStruct.d_instanceVar_VMAX_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vmaxbot_dX))+(deriv_min_0_d1*(d_vmaxsti_dX)))))+(deriv_min_1_d1*(d_vmaxgat_dX)));
instanceStruct.instanceVar_VMAX_d = value_min_1;
}
if ((fabs((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = value_exp_0;
}
}
else
{
if (((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)<(-2.3025850929940458e+02)))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))+(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = 1.0e100*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_vbibot2_dX = modelStruct.d_modelVar_vbibot_d_dX;
vbibot2 = modelStruct.modelVar_vbibot_d;
d_vbisti2_dX = modelStruct.d_modelVar_vbisti_d_dX;
vbisti2 = modelStruct.modelVar_vbisti_d;
d_vbigat2_dX = modelStruct.d_modelVar_vbigat_d_dX;
vbigat2 = modelStruct.modelVar_vbigat_d;
d_pbot2_dX = modelStruct.d_modelVar_PBOTD_i_dX;
pbot2 = modelStruct.modelVar_PBOTD_i;
d_psti2_dX = modelStruct.d_modelVar_PSTID_i_dX;
psti2 = modelStruct.modelVar_PSTID_i;
d_pgat2_dX = modelStruct.d_modelVar_PGATD_i_dX;
pgat2 = modelStruct.modelVar_PGATD_i;
d_vbibot2r_dX = modelStruct.d_modelVar_VBIRBOTD_i_dX;
vbibot2r = modelStruct.modelVar_VBIRBOTD_i;
d_vbisti2r_dX = modelStruct.d_modelVar_VBIRSTID_i_dX;
vbisti2r = modelStruct.modelVar_VBIRSTID_i;
d_vbigat2r_dX = modelStruct.d_modelVar_VBIRGATD_i_dX;
vbigat2r = modelStruct.modelVar_VBIRGATD_i;
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_vbibot2_dX = (modelStruct.d_modelVar_vbisti_d_dX+modelStruct.d_modelVar_vbigat_d_dX);
vbibot2 = (modelStruct.modelVar_vbisti_d+modelStruct.modelVar_vbigat_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PSTID_i,modelStruct.modelVar_PGATD_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PSTID_i<=modelStruct.modelVar_PGATD_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PSTID_i<=modelStruct.modelVar_PGATD_i)?0.0:1.0);
d_pbot2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PSTID_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
pbot2 = (0.9*value_min_0);
}
d_vbibot2r_dX = (modelStruct.d_modelVar_VBIRSTID_i_dX+modelStruct.d_modelVar_VBIRGATD_i_dX);
vbibot2r = (modelStruct.modelVar_VBIRSTID_i+modelStruct.modelVar_VBIRGATD_i);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_vbisti2_dX = (modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_vbigat_d_dX);
vbisti2 = (modelStruct.modelVar_vbibot_d+modelStruct.modelVar_vbigat_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOTD_i,modelStruct.modelVar_PGATD_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PGATD_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PGATD_i)?0.0:1.0);
d_psti2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOTD_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
psti2 = (0.9*value_min_0);
}
d_vbisti2r_dX = (modelStruct.d_modelVar_VBIRBOTD_i_dX+modelStruct.d_modelVar_VBIRGATD_i_dX);
vbisti2r = (modelStruct.modelVar_VBIRBOTD_i+modelStruct.modelVar_VBIRGATD_i);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_vbigat2_dX = (modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_vbisti_d_dX);
vbigat2 = (modelStruct.modelVar_vbibot_d+modelStruct.modelVar_vbisti_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOTD_i,modelStruct.modelVar_PSTID_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PSTID_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PSTID_i)?0.0:1.0);
d_pgat2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOTD_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
pgat2 = (0.9*value_min_0);
}
d_vbigat2r_dX = (modelStruct.d_modelVar_VBIRBOTD_i_dX+modelStruct.d_modelVar_VBIRSTID_i_dX);
vbigat2r = (modelStruct.modelVar_VBIRBOTD_i+modelStruct.modelVar_VBIRSTID_i);
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
double  deriv_min_0_d0 = ((vbibot2<=vbisti2)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2<=vbisti2)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2)?0.0:1.0);
instanceStruct.d_instanceVar_vbimin_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2_dX))+(deriv_min_0_d1*(d_vbisti2_dX)))))+(deriv_min_1_d1*(d_vbigat2_dX)));
instanceStruct.instanceVar_vbimin_d = value_min_1;
}
instanceStruct.d_instanceVar_vch_d_dX = instanceStruct.d_instanceVar_vbimin_d_dX*0.1;
instanceStruct.instanceVar_vch_d = (instanceStruct.instanceVar_vbimin_d*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
double  deriv_max_0_d0 = ((pbot2>=psti2)?1.0:0.0);
double  deriv_max_0_d1 = ((pbot2>=psti2)?0.0:1.0);
double  deriv_max_1_d0 = ((value_max_0>=pgat2)?1.0:0.0);
double  deriv_max_1_d1 = ((value_max_0>=pgat2)?0.0:1.0);
d_pmax_dX = ((deriv_max_1_d0*(((deriv_max_0_d0*(d_pbot2_dX))+(deriv_max_0_d1*(d_psti2_dX)))))+(deriv_max_1_d1*(d_pgat2_dX)));
pmax = value_max_1;
}
{
double value_pow_0 = pow(2,((-1.0)/pmax));
double  deriv_pow_0_d1 = (2 == 0.0)?0.0:(log(2)*value_pow_0);
instanceStruct.d_instanceVar_vfmin_d_dX = (instanceStruct.instanceVar_vbimin_d*(-(deriv_pow_0_d1*((-(-1.0)*d_pmax_dX/pmax/pmax))))+instanceStruct.d_instanceVar_vbimin_d_dX*(1-value_pow_0));
instanceStruct.instanceVar_vfmin_d = (instanceStruct.instanceVar_vbimin_d*(1-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
double  deriv_min_0_d0 = ((vbibot2r<=vbisti2r)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2r<=vbisti2r)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2r)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2r)?0.0:1.0);
instanceStruct.d_instanceVar_vbbtlim_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2r_dX))+(deriv_min_0_d1*(d_vbisti2r_dX)))))+(deriv_min_1_d1*(d_vbigat2r_dX)));
instanceStruct.instanceVar_vbbtlim_d = (value_min_1-0.050);
}
if ((modelStruct.modelVar_SWJUNEXP_i==1.0))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double d_ysq_dX=0.0;
double terfc=0.0;
double d_terfc_dX=0.0;
double erfcpos=0.0;
double d_erfcpos_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double d_h1_dX=0.0;
double h2=0.0;
double d_h2_dX=0.0;
double h2d=0.0;
double d_h2d_dX=0.0;
double h3=0.0;
double d_h3_dX=0.0;
double h4=0.0;
double d_h4_dX=0.0;
double h5=0.0;
double d_h5_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double idmult=0.0;
double d_idmult_dX=0.0;
double vj=0.0;
double d_vj_dX=0.0;
double z=0.0;
double d_z_dX=0.0;
double zinv=0.0;
double d_zinv_dX=0.0;
double two_psistar=0.0;
double d_two_psistar_dX=0.0;
double vjlim=0.0;
double d_vjlim_dX=0.0;
double vjsrh=0.0;
double d_vjsrh_dX=0.0;
double vbbt=0.0;
double d_vbbt_dX=0.0;
double vav=0.0;
double d_vav_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double d_tmp_dX=0.0;
double id=0.0;
double d_id_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double d_isrh_dX=0.0;
double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
double dwsrh=0.0;
double d_dwsrh_dX=0.0;
double wsrh=0.0;
double d_wsrh_dX=0.0;
double wdep=0.0;
double d_wdep_dX=0.0;
double asrh=0.0;
double d_asrh_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double d_itat_dX=0.0;
double btat=0.0;
double d_btat_dX=0.0;
double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
double umax=0.0;
double d_umax_dX=0.0;
double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double d_wgamma_dX=0.0;
double wtat=0.0;
double d_wtat_dX=0.0;
double ktat=0.0;
double d_ktat_dX=0.0;
double ltat=0.0;
double d_ltat_dX=0.0;
double mtat=0.0;
double d_mtat_dX=0.0;
double xerfc=0.0;
double d_xerfc_dX=0.0;
double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
double gammamax=0.0;
double d_gammamax_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double d_ibbt_dX=0.0;
double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ijunbot=0.0;
double d_ijunbot_dX=0.0;
double ijunsti=0.0;
double d_ijunsti_dX=0.0;
double ijungat=0.0;
double d_ijungat_dX=0.0;
double qjunbot=0.0;
double d_qjunbot_dX=0.0;
double qjunsti=0.0;
double d_qjunsti_dX=0.0;
double qjungat=0.0;
double d_qjungat_dX=0.0;
//End of Block-local variables
d_ysq_dX = 0.0;
ysq = 0.0;
d_terfc_dX = 0.0;
terfc = 0.0;
d_erfcpos_dX = 0.0;
erfcpos = 0.0;
d_h1_dX = 0.0;
h1 = 0.0;
d_h2_dX = 0.0;
h2 = 0.0;
d_h2d_dX = 0.0;
h2d = 0.0;
d_h3_dX = 0.0;
h3 = 0.0;
d_h4_dX = 0.0;
h4 = 0.0;
d_h5_dX = 0.0;
h5 = 0.0;
d_idmult_dX = 0.0;
idmult = 0.0;
d_vj_dX = 0.0;
vj = 0.0;
d_z_dX = 0.0;
z = 0.0;
d_zinv_dX = 0.0;
zinv = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
d_vjlim_dX = 0.0;
vjlim = 0.0;
d_vjsrh_dX = 0.0;
vjsrh = 0.0;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_vav_dX = 0.0;
vav = 0.0;
d_tmp_dX = 0.0;
tmp = 0.0;
d_id_dX = 0.0;
id = 0.0;
d_isrh_dX = 0.0;
isrh = 0.0;
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0.0;
d_wsrhstep_dX = 0.0;
wsrhstep = 0.0;
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
d_wsrh_dX = 0.0;
wsrh = 0.0;
d_wdep_dX = 0.0;
wdep = 0.0;
d_asrh_dX = 0.0;
asrh = 0.0;
d_itat_dX = 0.0;
itat = 0.0;
d_btat_dX = 0.0;
btat = 0.0;
d_twoatatoverthreebtat_dX = 0.0;
twoatatoverthreebtat = 0.0;
d_umaxbeforelimiting_dX = 0.0;
umaxbeforelimiting = 0.0;
d_umax_dX = 0.0;
umax = 0.0;
d_sqrtumax_dX = 0.0;
sqrtumax = 0.0;
d_umaxpoweronepointfive_dX = 0.0;
umaxpoweronepointfive = 0.0;
d_wgamma_dX = 0.0;
wgamma = 0.0;
d_wtat_dX = 0.0;
wtat = 0.0;
d_ktat_dX = 0.0;
ktat = 0.0;
d_ltat_dX = 0.0;
ltat = 0.0;
d_mtat_dX = 0.0;
mtat = 0.0;
d_xerfc_dX = 0.0;
xerfc = 0.0;
d_erfctimesexpmtat_dX = 0.0;
erfctimesexpmtat = 0.0;
d_gammamax_dX = 0.0;
gammamax = 0.0;
d_ibbt_dX = 0.0;
ibbt = 0.0;
d_Fmaxr_dX = 0.0;
Fmaxr = 0.0;
d_fbreakdown_dX = 0.0;
fbreakdown = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
d_V1_dX = (-FRACNA)*modelStruct.d_modelVar_VJUNREF_i_dX;
V1 = ((-FRACNA)*modelStruct.modelVar_VJUNREF_i);
d_V2_dX = (-FRACNB)*modelStruct.d_modelVar_VJUNREF_i_dX;
V2 = ((-FRACNB)*modelStruct.modelVar_VJUNREF_i);
d_V3_dX = (-FRACI)*modelStruct.d_modelVar_VJUNREF_i_dX;
V3 = ((-FRACI)*modelStruct.modelVar_VJUNREF_i);
V4 = 0.1;
V5 = 0.2;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V1_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V1+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V1*instanceStruct.d_instanceVar_vfmin_s_dX+d_V1_dX*instanceStruct.instanceVar_vfmin_s)-(V1*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V1*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V1<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V1*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V1_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V1)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V1_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V1-vjlim)*(d_V1_dX-d_vjlim_dX)+(d_V1_dX-d_vjlim_dX)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-instanceStruct.instanceVar_vbbtlim_s)*(V1-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V1_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V1-instanceStruct.instanceVar_vbbtlim_s)*(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V1-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V1+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V1_dX-deriv_sqrt_0_d0*(((V1)*d_V1_dX+d_V1_dX*(V1))));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V1-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V1-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V1-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I1_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I1 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V2_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V2+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V2*instanceStruct.d_instanceVar_vfmin_s_dX+d_V2_dX*instanceStruct.instanceVar_vfmin_s)-(V2*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V2*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V2<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V2*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V2_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V2)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V2_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V2-vjlim)*(d_V2_dX-d_vjlim_dX)+(d_V2_dX-d_vjlim_dX)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-instanceStruct.instanceVar_vbbtlim_s)*(V2-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V2_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V2-instanceStruct.instanceVar_vbbtlim_s)*(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V2-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V2+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V2_dX-deriv_sqrt_0_d0*(((V2)*d_V2_dX+d_V2_dX*(V2))));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V2-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V2-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V2-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I2_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I2 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V3_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V3+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V3*instanceStruct.d_instanceVar_vfmin_s_dX+d_V3_dX*instanceStruct.instanceVar_vfmin_s)-(V3*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V3*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V3<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V3*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V3_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V3)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V3_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V3-vjlim)*(d_V3_dX-d_vjlim_dX)+(d_V3_dX-d_vjlim_dX)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-instanceStruct.instanceVar_vbbtlim_s)*(V3-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V3_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V3-instanceStruct.instanceVar_vbbtlim_s)*(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V3-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V3+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V3_dX-deriv_sqrt_0_d0*(((V3)*d_V3_dX+d_V3_dX*(V3))));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V3-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V3-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V3-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I3_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I3 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (V4+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V4*instanceStruct.d_instanceVar_vfmin_s_dX-(V4*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V4*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V4<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V4*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V4*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V4*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V4)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V4-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-instanceStruct.instanceVar_vbbtlim_s)*(V4-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((V4-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V4-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V4+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V4-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V4-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V4-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I4_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I4 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (V5+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V5*instanceStruct.d_instanceVar_vfmin_s_dX-(V5*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V5*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V5<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V5*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V5*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V5*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V5)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V5-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-instanceStruct.instanceVar_vbbtlim_s)*(V5-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((V5-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V5-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V5+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V5-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V5-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V5-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I5_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I5 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
instanceStruct.d_instanceVar_ISATFOR1_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.d_modelVar_idsatbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.d_modelVar_idsatsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.d_modelVar_idsatgat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*modelStruct.modelVar_idsatgat));
instanceStruct.instanceVar_ISATFOR1_s = (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_idsatgat));
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double  deriv_exp_0_d0 = value_exp_0;
d_I4_cor_dX = (d_I4_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*(V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)));
I4_cor = (I4-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double  deriv_exp_0_d0 = value_exp_0;
d_I5_cor_dX = (d_I5_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*(V5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)));
I5_cor = (I5-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
}
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
d_alphaje_dX = ((I5_cor*d_I4_cor_dX-I4_cor*d_I5_cor_dX)/I5_cor/I5_cor);
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
instanceStruct.d_instanceVar_MFOR2_s_dX = ((modelStruct.modelVar_phitd*deriv_log_0_d0*(d_alphaje_dX)+modelStruct.d_modelVar_phitd_dX*value_log_0)/(V4-V5));
instanceStruct.instanceVar_MFOR2_s = ((modelStruct.modelVar_phitd*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATFOR2_s_dX = (((value_exp_0-1)*d_I4_cor_dX-I4_cor*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_s)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATFOR2_s = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I1_cor_dX = ((d_I1_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I1_cor = ((I1-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I2_cor_dX = ((d_I2_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I2_cor = ((I2-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I3_cor_dX = ((d_I3_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I3_cor = ((I3-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
d_alphaje_dX = ((I2_cor*d_I1_cor_dX-I1_cor*d_I2_cor_dX)/I2_cor/I2_cor);
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
d_m0_rev_dX = (((V1-V2)*((-modelStruct.modelVar_phitd)*deriv_log_0_d0*(d_alphaje_dX)+(-modelStruct.d_modelVar_phitd_dX)*value_log_0)-((-modelStruct.modelVar_phitd)*value_log_0)*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
m0_rev = (((-modelStruct.modelVar_phitd)*value_log_0)/(V1-V2));
}
d_tt0_dX = (((V2-V1)*d_V2_dX-V2*(d_V2_dX-d_V1_dX))/(V2-V1)/(V2-V1));
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt1_dX = ((modelStruct.modelVar_phitd*(alphaje-1))*((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))+(modelStruct.modelVar_phitd*d_alphaje_dX+modelStruct.d_modelVar_phitd_dX*(alphaje-1))*(value_pow_0-1));
tt1 = ((modelStruct.modelVar_phitd*(alphaje-1))*(value_pow_0-1));
}
d_tt0_dX = (((V1-V2)*d_V1_dX-V1*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt2_dX = (((value_pow_0*(d_V2_dX-d_V1_dX)+((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))*(V2-V1))+(alphaje*d_V1_dX+d_alphaje_dX*V1))-d_V2_dX);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
d_mcor_rev_dX = ((tt2*d_tt1_dX-tt1*d_tt2_dX)/tt2/tt2);
mcor_rev = (tt1/tt2);
instanceStruct.d_instanceVar_MREV_s_dX = (d_m0_rev_dX+d_mcor_rev_dX);
instanceStruct.instanceVar_MREV_s = (m0_rev+mcor_rev);
if ((fabs(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s))<1e-6))
{
instanceStruct.instanceVar_m0flag_s = 1.0;
instanceStruct.d_instanceVar_ISATREV_s_dX = (I3_cor*((-1*d_V3_dX/V3/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+0.5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_s))+d_I3_cor_dX*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)));
instanceStruct.instanceVar_ISATREV_s = (I3_cor*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)));
instanceStruct.d_instanceVar_MREV_s_dX = ((V3*((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.d_modelVar_phitdinv_dX+(((-0.5)*I3_cor)*instanceStruct.d_instanceVar_MREV_s_dX+(-0.5)*d_I3_cor_dX*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)-((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)*d_V3_dX)/V3/V3);
instanceStruct.instanceVar_MREV_s = (((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)/V3);
}
else
{
instanceStruct.instanceVar_m0flag_s = 0.0;
{
double value_exp_0 = exp((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATREV_s_dX = (((value_exp_0-1)*(-d_I3_cor_dX)-(-I3_cor)*deriv_exp_0_d0*((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+((-V3)*modelStruct.d_modelVar_phitdinv_dX+(-d_V3_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATREV_s = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
d_zfrac_dX = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.d_modelVar_cjobot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.d_modelVar_cjosti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.d_modelVar_cjogat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*modelStruct.modelVar_cjogat))+modelStruct.d_modelVar_FJUNQ_i_dX*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)));
zfrac = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)));
if (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)<=zfrac))
{
instanceStruct.instanceVar_zflagbot_s = 0.0;
}
if (((instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti)<=zfrac))
{
instanceStruct.instanceVar_zflagsti_s = 0.0;
}
if (((instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)<=zfrac))
{
instanceStruct.instanceVar_zflaggat_s = 0.0;
}
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_s+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_s+1e-21)));
instanceStruct.d_instanceVar_xhighf1_s_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR1_s+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR1_s_dX)/(instanceStruct.instanceVar_ISATFOR1_s+1e-21)/(instanceStruct.instanceVar_ISATFOR1_s+1e-21)));
instanceStruct.instanceVar_xhighf1_s = value_log_0;
}
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_s+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_s+1e-21)));
instanceStruct.d_instanceVar_xhighf2_s_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR2_s+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR2_s_dX)/(instanceStruct.instanceVar_ISATFOR2_s+1e-21)/(instanceStruct.instanceVar_ISATFOR2_s+1e-21)));
instanceStruct.instanceVar_xhighf2_s = value_log_0;
}
{
double value_fabs_0 = fabs(instanceStruct.instanceVar_ISATREV_s);
double value_log_1 = log(((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
double  deriv_fabs_0_d0 = (((instanceStruct.instanceVar_ISATREV_s)>=0)?(+1.0):(-1.0));
double  deriv_log_1_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
instanceStruct.d_instanceVar_xhighr_s_dX = deriv_log_1_d0*((((value_fabs_0+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*deriv_fabs_0_d0*(instanceStruct.d_instanceVar_ISATREV_s_dX))/(value_fabs_0+1e-21)/(value_fabs_0+1e-21)));
instanceStruct.instanceVar_xhighr_s = value_log_1;
}
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf1_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf1_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf1_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf1_s_dX));
instanceStruct.instanceVar_xhighf1_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf1_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf1_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf1_s_dX);
instanceStruct.instanceVar_expxhf1_s = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf2_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf2_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf2_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf2_s_dX));
instanceStruct.instanceVar_xhighf2_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf2_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf2_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf2_s_dX);
instanceStruct.instanceVar_expxhf2_s = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighr_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighr_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighr_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighr_s_dX));
instanceStruct.instanceVar_xhighr_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighr_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhr_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighr_s_dX);
instanceStruct.instanceVar_expxhr_s = value_exp_0;
}
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
d_V1_dX = (-FRACNA)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V1 = ((-FRACNA)*modelStruct.modelVar_VJUNREFD_i);
d_V2_dX = (-FRACNB)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V2 = ((-FRACNB)*modelStruct.modelVar_VJUNREFD_i);
d_V3_dX = (-FRACI)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V3 = ((-FRACI)*modelStruct.modelVar_VJUNREFD_i);
V4 = 0.1;
V5 = 0.2;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V1_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V1+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V1*instanceStruct.d_instanceVar_vfmin_d_dX+d_V1_dX*instanceStruct.instanceVar_vfmin_d)-(V1*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V1*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V1<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V1*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V1>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V1_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V1)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V1_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V1-vjlim)*(d_V1_dX-d_vjlim_dX)+(d_V1_dX-d_vjlim_dX)*(V1-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-instanceStruct.instanceVar_vbbtlim_d)*(V1-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V1_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V1-instanceStruct.instanceVar_vbbtlim_d)*(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V1-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V1+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V1_dX-deriv_sqrt_0_d0*(((V1)*d_V1_dX+d_V1_dX*(V1))));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V1-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V1-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V1-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I1_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I1 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V2_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V2+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V2*instanceStruct.d_instanceVar_vfmin_d_dX+d_V2_dX*instanceStruct.instanceVar_vfmin_d)-(V2*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V2*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V2<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V2*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V2>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V2_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V2)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V2_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V2-vjlim)*(d_V2_dX-d_vjlim_dX)+(d_V2_dX-d_vjlim_dX)*(V2-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-instanceStruct.instanceVar_vbbtlim_d)*(V2-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V2_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V2-instanceStruct.instanceVar_vbbtlim_d)*(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V2-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V2+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V2_dX-deriv_sqrt_0_d0*(((V2)*d_V2_dX+d_V2_dX*(V2))));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V2-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V2-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V2-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I2_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I2 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V3_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V3+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V3*instanceStruct.d_instanceVar_vfmin_d_dX+d_V3_dX*instanceStruct.instanceVar_vfmin_d)-(V3*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V3*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V3<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V3*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V3>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = ((-d_V3_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V3)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V3_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V3-vjlim)*(d_V3_dX-d_vjlim_dX)+(d_V3_dX-d_vjlim_dX)*(V3-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-instanceStruct.instanceVar_vbbtlim_d)*(V3-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V3_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V3-instanceStruct.instanceVar_vbbtlim_d)*(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V3-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V3+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V3_dX-deriv_sqrt_0_d0*(((V3)*d_V3_dX+d_V3_dX*(V3))));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V3-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V3-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V3-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I3_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I3 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (V4+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V4*instanceStruct.d_instanceVar_vfmin_d_dX-(V4*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V4*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V4<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V4*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V4*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V4*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V4>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V4)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V4-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V4-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-instanceStruct.instanceVar_vbbtlim_d)*(V4-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((V4-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V4-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V4+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V4-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V4-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V4-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I4_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I4 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (V5+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V5*instanceStruct.d_instanceVar_vfmin_d_dX-(V5*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V5*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V5<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V5*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V5*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V5*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((V5>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V5)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V5-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V5-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-instanceStruct.instanceVar_vbbtlim_d)*(V5-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((V5-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V5-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V5+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4*1E-6)*1E-6)));
d_vav_dX = 0.0;
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0;
d_qjunbot_dX = 0.0;
qjunbot = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V5-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0;
d_qjunsti_dX = 0.0;
qjunsti = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V5-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_dX = 0.0;
ijungat = 0;
d_qjungat_dX = 0.0;
qjungat = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V5-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+(value_fabs_0*deriv_fabs_1_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))+deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I5_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I5 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
instanceStruct.d_instanceVar_ISATFOR1_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.d_modelVar_idsatbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*modelStruct.modelVar_idsatbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.d_modelVar_idsatsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*modelStruct.modelVar_idsatsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.d_modelVar_idsatgat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*modelStruct.modelVar_idsatgat_d));
instanceStruct.instanceVar_ISATFOR1_d = (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_idsatbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_idsatsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_idsatgat_d));
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double  deriv_exp_0_d0 = value_exp_0;
d_I4_cor_dX = (d_I4_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*(V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)));
I4_cor = (I4-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double  deriv_exp_0_d0 = value_exp_0;
d_I5_cor_dX = (d_I5_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*(V5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)));
I5_cor = (I5-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
}
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
if (((I4>0)&&(I5>0)))
{
if ((((((I4_cor/I4)>0.001)||((I5_cor/I5)>0.001))&&(I4_cor>0))&&(I5_cor>0)))
{
d_alphaje_dX = ((I5_cor*d_I4_cor_dX-I4_cor*d_I5_cor_dX)/I5_cor/I5_cor);
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
instanceStruct.d_instanceVar_MFOR2_d_dX = ((modelStruct.modelVar_phitd*deriv_log_0_d0*(d_alphaje_dX)+modelStruct.d_modelVar_phitd_dX*value_log_0)/(V4-V5));
instanceStruct.instanceVar_MFOR2_d = ((modelStruct.modelVar_phitd*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATFOR2_d_dX = (((value_exp_0-1)*d_I4_cor_dX-I4_cor*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_d)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATFOR2_d = (I4_cor/(value_exp_0-1));
}
}
}
{
double value_exp_0 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I1_cor_dX = ((d_I1_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I1_cor = ((I1-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I2_cor_dX = ((d_I2_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I2_cor = ((I2-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I3_cor_dX = ((d_I3_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I3_cor = ((I3-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
if ((((I1<0)&&(I2<0))&&(I3<0)))
{
if ((((((((I1_cor/I1)>0.001)||((I2_cor/I2)>0.001))||((I3_cor/I3)>0.001))&&(I1_cor<0))&&(I2_cor<0))&&(I3_cor<0)))
{
d_alphaje_dX = ((I2_cor*d_I1_cor_dX-I1_cor*d_I2_cor_dX)/I2_cor/I2_cor);
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
d_m0_rev_dX = (((V1-V2)*((-modelStruct.modelVar_phitd)*deriv_log_0_d0*(d_alphaje_dX)+(-modelStruct.d_modelVar_phitd_dX)*value_log_0)-((-modelStruct.modelVar_phitd)*value_log_0)*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
m0_rev = (((-modelStruct.modelVar_phitd)*value_log_0)/(V1-V2));
}
d_tt0_dX = (((V2-V1)*d_V2_dX-V2*(d_V2_dX-d_V1_dX))/(V2-V1)/(V2-V1));
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt1_dX = ((modelStruct.modelVar_phitd*(alphaje-1))*((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))+(modelStruct.modelVar_phitd*d_alphaje_dX+modelStruct.d_modelVar_phitd_dX*(alphaje-1))*(value_pow_0-1));
tt1 = ((modelStruct.modelVar_phitd*(alphaje-1))*(value_pow_0-1));
}
d_tt0_dX = (((V1-V2)*d_V1_dX-V1*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt2_dX = (((value_pow_0*(d_V2_dX-d_V1_dX)+((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))*(V2-V1))+(alphaje*d_V1_dX+d_alphaje_dX*V1))-d_V2_dX);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
d_mcor_rev_dX = ((tt2*d_tt1_dX-tt1*d_tt2_dX)/tt2/tt2);
mcor_rev = (tt1/tt2);
instanceStruct.d_instanceVar_MREV_d_dX = (d_m0_rev_dX+d_mcor_rev_dX);
instanceStruct.instanceVar_MREV_d = (m0_rev+mcor_rev);
if ((fabs(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d))<1e-6))
{
instanceStruct.instanceVar_m0flag_d = 1.0;
instanceStruct.d_instanceVar_ISATREV_d_dX = (I3_cor*((-1*d_V3_dX/V3/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+0.5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_d))+d_I3_cor_dX*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)));
instanceStruct.instanceVar_ISATREV_d = (I3_cor*((1/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)));
instanceStruct.d_instanceVar_MREV_d_dX = ((V3*((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.d_modelVar_phitdinv_dX+(((-0.5)*I3_cor)*instanceStruct.d_instanceVar_MREV_d_dX+(-0.5)*d_I3_cor_dX*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)-((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)*d_V3_dX)/V3/V3);
instanceStruct.instanceVar_MREV_d = (((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)/V3);
}
else
{
instanceStruct.instanceVar_m0flag_d = 0.0;
{
double value_exp_0 = exp((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATREV_d_dX = (((value_exp_0-1)*(-d_I3_cor_dX)-(-I3_cor)*deriv_exp_0_d0*((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+((-V3)*modelStruct.d_modelVar_phitdinv_dX+(-d_V3_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)))/(value_exp_0-1)/(value_exp_0-1));
instanceStruct.instanceVar_ISATREV_d = ((-I3_cor)/(value_exp_0-1));
}
}
}
}
}
d_zfrac_dX = (modelStruct.modelVar_FJUNQD_i*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.d_modelVar_cjobot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.d_modelVar_cjosti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.d_modelVar_cjogat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*modelStruct.modelVar_cjogat_d))+modelStruct.d_modelVar_FJUNQD_i_dX*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)));
zfrac = (modelStruct.modelVar_FJUNQD_i*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)));
if (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)<=zfrac))
{
instanceStruct.instanceVar_zflagbot_d = 0.0;
}
if (((instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d)<=zfrac))
{
instanceStruct.instanceVar_zflagsti_d = 0.0;
}
if (((instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)<=zfrac))
{
instanceStruct.instanceVar_zflaggat_d = 0.0;
}
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_d+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_d+1e-21)));
instanceStruct.d_instanceVar_xhighf1_d_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR1_d+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR1_d_dX)/(instanceStruct.instanceVar_ISATFOR1_d+1e-21)/(instanceStruct.instanceVar_ISATFOR1_d+1e-21)));
instanceStruct.instanceVar_xhighf1_d = value_log_0;
}
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_d+1e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_d+1e-21)));
instanceStruct.d_instanceVar_xhighf2_d_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR2_d+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR2_d_dX)/(instanceStruct.instanceVar_ISATFOR2_d+1e-21)/(instanceStruct.instanceVar_ISATFOR2_d+1e-21)));
instanceStruct.instanceVar_xhighf2_d = value_log_0;
}
{
double value_fabs_0 = fabs(instanceStruct.instanceVar_ISATREV_d);
double value_log_1 = log(((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
double  deriv_fabs_0_d0 = (((instanceStruct.instanceVar_ISATREV_d)>=0)?(+1.0):(-1.0));
double  deriv_log_1_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1e-21)));
instanceStruct.d_instanceVar_xhighr_d_dX = deriv_log_1_d0*((((value_fabs_0+1e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*deriv_fabs_0_d0*(instanceStruct.d_instanceVar_ISATREV_d_dX))/(value_fabs_0+1e-21)/(value_fabs_0+1e-21)));
instanceStruct.instanceVar_xhighr_d = value_log_1;
}
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf1_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf1_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf1_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf1_d_dX));
instanceStruct.instanceVar_xhighf1_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf1_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf1_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf1_d_dX);
instanceStruct.instanceVar_expxhf1_d = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf2_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf2_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf2_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf2_d_dX));
instanceStruct.instanceVar_xhighf2_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf2_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf2_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf2_d_dX);
instanceStruct.instanceVar_expxhf2_d = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighr_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighr_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighr_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighr_d_dX));
instanceStruct.instanceVar_xhighr_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighr_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhr_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighr_d_dX);
instanceStruct.instanceVar_expxhr_d = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
  double deltaEgat_d=0.0;
double d_deltaEgat_d_dX=0.0;
  double deltaEsti_d=0.0;
double d_deltaEsti_d_dX=0.0;
  double deltaEbot_d=0.0;
double d_deltaEbot_d_dX=0.0;
  double ubigat_d=0.0;
double d_ubigat_d_dX=0.0;
  double ubisti_d=0.0;
double d_ubisti_d_dX=0.0;
  double ubibot_d=0.0;
double d_ubibot_d_dX=0.0;
  double phigdgat_d=0.0;
double d_phigdgat_d_dX=0.0;
  double phigdsti_d=0.0;
double d_phigdsti_d_dX=0.0;
  double phigdbot_d=0.0;
double d_phigdbot_d_dX=0.0;
  double phigrgat_d=0.0;
double d_phigrgat_d_dX=0.0;
  double phigrsti_d=0.0;
double d_phigrsti_d_dX=0.0;
  double phigrbot_d=0.0;
double d_phigrbot_d_dX=0.0;
  double deltaEgat=0.0;
double d_deltaEgat_dX=0.0;
  double deltaEsti=0.0;
double d_deltaEsti_dX=0.0;
  double deltaEbot=0.0;
double d_deltaEbot_dX=0.0;
  double ubigat=0.0;
double d_ubigat_dX=0.0;
  double ubisti=0.0;
double d_ubisti_dX=0.0;
  double ubibot=0.0;
double d_ubibot_dX=0.0;
  double phigdgat=0.0;
double d_phigdgat_dX=0.0;
  double phigdsti=0.0;
double d_phigdsti_dX=0.0;
  double phigdbot=0.0;
double d_phigdbot_dX=0.0;
  double deltaphigd=0.0;
double d_deltaphigd_dX=0.0;
  double phigrgat=0.0;
double d_phigrgat_dX=0.0;
  double phigrsti=0.0;
double d_phigrsti_dX=0.0;
  double phigrbot=0.0;
double d_phigrbot_dX=0.0;
  double deltaphigr=0.0;
double d_deltaphigr_dX=0.0;
  double phitrinv=0.0;
double d_phitrinv_dX=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
double d_auxt_dX=0.0;
  double tkd=0.0;
double d_tkd_dX=0.0;
  double tkr=0.0;
double d_tkr_dX=0.0;
  double STFBBTGATD_i=0.0;
double d_STFBBTGATD_i_dX=0.0;
  double STFBBTSTID_i=0.0;
double d_STFBBTSTID_i_dX=0.0;
  double STFBBTBOTD_i=0.0;
double d_STFBBTBOTD_i_dX=0.0;
  double FBBTRGATD_i=0.0;
double d_FBBTRGATD_i_dX=0.0;
  double FBBTRSTID_i=0.0;
double d_FBBTRSTID_i_dX=0.0;
  double FBBTRBOTD_i=0.0;
double d_FBBTRBOTD_i_dX=0.0;
  double MEFFTATGATD_i=0.0;
double d_MEFFTATGATD_i_dX=0.0;
  double MEFFTATSTID_i=0.0;
double d_MEFFTATSTID_i_dX=0.0;
  double MEFFTATBOTD_i=0.0;
double d_MEFFTATBOTD_i_dX=0.0;
  double XJUNGATD_i=0.0;
double d_XJUNGATD_i_dX=0.0;
  double XJUNSTID_i=0.0;
double d_XJUNSTID_i_dX=0.0;
  double IDSATRGATD_i=0.0;
double d_IDSATRGATD_i_dX=0.0;
  double IDSATRSTID_i=0.0;
double d_IDSATRSTID_i_dX=0.0;
  double IDSATRBOTD_i=0.0;
double d_IDSATRBOTD_i_dX=0.0;
  double PHIGGATD_i=0.0;
double d_PHIGGATD_i_dX=0.0;
  double PHIGSTID_i=0.0;
double d_PHIGSTID_i_dX=0.0;
  double PHIGBOTD_i=0.0;
double d_PHIGBOTD_i_dX=0.0;
  double CJORGATD_i=0.0;
double d_CJORGATD_i_dX=0.0;
  double CJORSTID_i=0.0;
double d_CJORSTID_i_dX=0.0;
  double CJORBOTD_i=0.0;
double d_CJORBOTD_i_dX=0.0;
  double STFBBTGAT_i=0.0;
double d_STFBBTGAT_i_dX=0.0;
  double STFBBTSTI_i=0.0;
double d_STFBBTSTI_i_dX=0.0;
  double STFBBTBOT_i=0.0;
double d_STFBBTBOT_i_dX=0.0;
  double FBBTRGAT_i=0.0;
double d_FBBTRGAT_i_dX=0.0;
  double FBBTRSTI_i=0.0;
double d_FBBTRSTI_i_dX=0.0;
  double FBBTRBOT_i=0.0;
double d_FBBTRBOT_i_dX=0.0;
  double MEFFTATGAT_i=0.0;
double d_MEFFTATGAT_i_dX=0.0;
  double MEFFTATSTI_i=0.0;
double d_MEFFTATSTI_i_dX=0.0;
  double MEFFTATBOT_i=0.0;
double d_MEFFTATBOT_i_dX=0.0;
  double XJUNGAT_i=0.0;
double d_XJUNGAT_i_dX=0.0;
  double XJUNSTI_i=0.0;
double d_XJUNSTI_i_dX=0.0;
  double IDSATRGAT_i=0.0;
double d_IDSATRGAT_i_dX=0.0;
  double IDSATRSTI_i=0.0;
double d_IDSATRSTI_i_dX=0.0;
  double IDSATRBOT_i=0.0;
double d_IDSATRBOT_i_dX=0.0;
  double PHIGGAT_i=0.0;
double d_PHIGGAT_i_dX=0.0;
  double PHIGSTI_i=0.0;
double d_PHIGSTI_i_dX=0.0;
  double PHIGBOT_i=0.0;
double d_PHIGBOT_i_dX=0.0;
  double CJORGAT_i=0.0;
double d_CJORGAT_i_dX=0.0;
  double CJORSTI_i=0.0;
double d_CJORSTI_i_dX=0.0;
  double CJORBOT_i=0.0;
double d_CJORBOT_i_dX=0.0;
  double TRJ_i=0.0;
double d_TRJ_i_dX=0.0;
  double TKD_sq=0.0;
double d_TKD_sq_dX=0.0;
  double TKR=0.0;
double d_TKR_dX=0.0;
  double TR_i=0.0;
double d_TR_i_dX=0.0;
//Begin block initial_model
{
modelStruct.d_modelVar_TOX_i_dX = ((modelStruct.modelPar_TOXO>1e-10)?modelStruct.d_modelPar_TOXO_dX:0.0);
modelStruct.modelVar_TOX_i = ((modelStruct.modelPar_TOXO>1e-10)?modelStruct.modelPar_TOXO:1e-10);
modelStruct.d_modelVar_TOXOVD_i_dX = ((modelStruct.modelPar_TOXOVDO>1e-10)?modelStruct.d_modelPar_TOXOVDO_dX:0.0);
modelStruct.modelVar_TOXOVD_i = ((modelStruct.modelPar_TOXOVDO>1e-10)?modelStruct.modelPar_TOXOVDO:1e-10);
modelStruct.d_modelVar_EPSROX_i_dX = ((modelStruct.modelPar_EPSROXO>1.0)?modelStruct.d_modelPar_EPSROXO_dX:0.0);
modelStruct.modelVar_EPSROX_i = ((modelStruct.modelPar_EPSROXO>1.0)?modelStruct.modelPar_EPSROXO:1.0);
modelStruct.d_modelVar_NSUBO_i_dX = ((modelStruct.modelPar_NSUBO>1e20)?modelStruct.d_modelPar_NSUBO_dX:0.0);
modelStruct.modelVar_NSUBO_i = ((modelStruct.modelPar_NSUBO>1e20)?modelStruct.modelPar_NSUBO:1e20);
modelStruct.d_modelVar_WSEG_i_dX = ((modelStruct.modelPar_WSEG>1e-10)?modelStruct.d_modelPar_WSEG_dX:0.0);
modelStruct.modelVar_WSEG_i = ((modelStruct.modelPar_WSEG>1e-10)?modelStruct.modelPar_WSEG:1e-10);
modelStruct.d_modelVar_NPCK_i_dX = ((modelStruct.modelPar_NPCK>0.0)?modelStruct.d_modelPar_NPCK_dX:0.0);
modelStruct.modelVar_NPCK_i = ((modelStruct.modelPar_NPCK>0.0)?modelStruct.modelPar_NPCK:0.0);
modelStruct.d_modelVar_WSEGP_i_dX = ((modelStruct.modelPar_WSEGP>1e-10)?modelStruct.d_modelPar_WSEGP_dX:0.0);
modelStruct.modelVar_WSEGP_i = ((modelStruct.modelPar_WSEGP>1e-10)?modelStruct.modelPar_WSEGP:1e-10);
modelStruct.d_modelVar_LPCK_i_dX = ((modelStruct.modelPar_LPCK>1e-10)?modelStruct.d_modelPar_LPCK_dX:0.0);
modelStruct.modelVar_LPCK_i = ((modelStruct.modelPar_LPCK>1e-10)?modelStruct.modelPar_LPCK:1e-10);
modelStruct.d_modelVar_TOXOV_i_dX = ((modelStruct.modelPar_TOXOVO>1e-10)?modelStruct.d_modelPar_TOXOVO_dX:0.0);
modelStruct.modelVar_TOXOV_i = ((modelStruct.modelPar_TOXOVO>1e-10)?modelStruct.modelPar_TOXOVO:1e-10);
modelStruct.d_modelVar_LOV_i_dX = ((modelStruct.modelPar_LOV>0.0)?modelStruct.d_modelPar_LOV_dX:0.0);
modelStruct.modelVar_LOV_i = ((modelStruct.modelPar_LOV>0.0)?modelStruct.modelPar_LOV:0.0);
modelStruct.d_modelVar_LOVD_i_dX = ((modelStruct.modelPar_LOVD>0.0)?modelStruct.d_modelPar_LOVD_dX:0.0);
modelStruct.modelVar_LOVD_i = ((modelStruct.modelPar_LOVD>0.0)?modelStruct.modelPar_LOVD:0.0);
modelStruct.d_modelVar_LP1_i_dX = ((modelStruct.modelPar_LP1>1e-10)?modelStruct.d_modelPar_LP1_dX:0.0);
modelStruct.modelVar_LP1_i = ((modelStruct.modelPar_LP1>1e-10)?modelStruct.modelPar_LP1:1e-10);
modelStruct.d_modelVar_LP2_i_dX = ((modelStruct.modelPar_LP2>1e-10)?modelStruct.d_modelPar_LP2_dX:0.0);
modelStruct.modelVar_LP2_i = ((modelStruct.modelPar_LP2>1e-10)?modelStruct.modelPar_LP2:1e-10);
modelStruct.d_modelVar_WBET_i_dX = ((modelStruct.modelPar_WBET>1e-10)?modelStruct.d_modelPar_WBET_dX:0.0);
modelStruct.modelVar_WBET_i = ((modelStruct.modelPar_WBET>1e-10)?modelStruct.modelPar_WBET:1e-10);
modelStruct.d_modelVar_AXL_i_dX = ((modelStruct.modelPar_AXL>0.0)?modelStruct.d_modelPar_AXL_dX:0.0);
modelStruct.modelVar_AXL_i = ((modelStruct.modelPar_AXL>0.0)?modelStruct.modelPar_AXL:0.0);
modelStruct.d_modelVar_ALP1L2_i_dX = ((modelStruct.modelPar_ALP1L2>0.0)?modelStruct.d_modelPar_ALP1L2_dX:0.0);
modelStruct.modelVar_ALP1L2_i = ((modelStruct.modelPar_ALP1L2>0.0)?modelStruct.modelPar_ALP1L2:0.0);
modelStruct.d_modelVar_ALP2L2_i_dX = ((modelStruct.modelPar_ALP2L2>0.0)?modelStruct.d_modelPar_ALP2L2_dX:0.0);
modelStruct.modelVar_ALP2L2_i = ((modelStruct.modelPar_ALP2L2>0.0)?modelStruct.modelPar_ALP2L2:0.0);
modelStruct.d_modelVar_SAREF_i_dX = ((modelStruct.modelPar_SAREF>1e-9)?modelStruct.d_modelPar_SAREF_dX:0.0);
modelStruct.modelVar_SAREF_i = ((modelStruct.modelPar_SAREF>1e-9)?modelStruct.modelPar_SAREF:1e-9);
modelStruct.d_modelVar_SBREF_i_dX = ((modelStruct.modelPar_SBREF>1e-9)?modelStruct.d_modelPar_SBREF_dX:0.0);
modelStruct.modelVar_SBREF_i = ((modelStruct.modelPar_SBREF>1e-9)?modelStruct.modelPar_SBREF:1e-9);
modelStruct.d_modelVar_KVSAT_i_dX = ((modelStruct.modelPar_KVSAT>(-1.0))?((modelStruct.modelPar_KVSAT<1.0)?modelStruct.d_modelPar_KVSAT_dX:0.0):0.0);
modelStruct.modelVar_KVSAT_i = ((modelStruct.modelPar_KVSAT>(-1.0))?((modelStruct.modelPar_KVSAT<1.0)?modelStruct.modelPar_KVSAT:1.0):(-1.0));
modelStruct.d_modelVar_LLODKUO_i_dX = ((modelStruct.modelPar_LLODKUO>0.0)?modelStruct.d_modelPar_LLODKUO_dX:0.0);
modelStruct.modelVar_LLODKUO_i = ((modelStruct.modelPar_LLODKUO>0.0)?modelStruct.modelPar_LLODKUO:0.0);
modelStruct.d_modelVar_WLODKUO_i_dX = ((modelStruct.modelPar_WLODKUO>0.0)?modelStruct.d_modelPar_WLODKUO_dX:0.0);
modelStruct.modelVar_WLODKUO_i = ((modelStruct.modelPar_WLODKUO>0.0)?modelStruct.modelPar_WLODKUO:0.0);
modelStruct.d_modelVar_LLODVTH_i_dX = ((modelStruct.modelPar_LLODVTH>0.0)?modelStruct.d_modelPar_LLODVTH_dX:0.0);
modelStruct.modelVar_LLODVTH_i = ((modelStruct.modelPar_LLODVTH>0.0)?modelStruct.modelPar_LLODVTH:0.0);
modelStruct.d_modelVar_WLODVTH_i_dX = ((modelStruct.modelPar_WLODVTH>0.0)?modelStruct.d_modelPar_WLODVTH_dX:0.0);
modelStruct.modelVar_WLODVTH_i = ((modelStruct.modelPar_WLODVTH>0.0)?modelStruct.modelPar_WLODVTH:0.0);
modelStruct.d_modelVar_LODETAO_i_dX = ((modelStruct.modelPar_LODETAO>0.0)?modelStruct.d_modelPar_LODETAO_dX:0.0);
modelStruct.modelVar_LODETAO_i = ((modelStruct.modelPar_LODETAO>0.0)?modelStruct.modelPar_LODETAO:0.0);
modelStruct.d_modelVar_SCREF_i_dX = ((modelStruct.modelPar_SCREF>0.0)?modelStruct.d_modelPar_SCREF_dX:0.0);
modelStruct.modelVar_SCREF_i = ((modelStruct.modelPar_SCREF>0.0)?modelStruct.modelPar_SCREF:0.0);
modelStruct.d_modelVar_WEB_i_dX = modelStruct.d_modelPar_WEB_dX;
modelStruct.modelVar_WEB_i = modelStruct.modelPar_WEB;
modelStruct.d_modelVar_WEC_i_dX = modelStruct.d_modelPar_WEC_dX;
modelStruct.modelVar_WEC_i = modelStruct.modelPar_WEC;
modelStruct.d_modelVar_RINT_i_dX = ((modelStruct.modelPar_RINT>0.0)?modelStruct.d_modelPar_RINT_dX:0.0);
modelStruct.modelVar_RINT_i = ((modelStruct.modelPar_RINT>0.0)?modelStruct.modelPar_RINT:0.0);
modelStruct.d_modelVar_RVPOLY_i_dX = ((modelStruct.modelPar_RVPOLY>0.0)?modelStruct.d_modelPar_RVPOLY_dX:0.0);
modelStruct.modelVar_RVPOLY_i = ((modelStruct.modelPar_RVPOLY>0.0)?modelStruct.modelPar_RVPOLY:0.0);
if ((modelStruct.modelPar_TYPE>=0))
{
modelStruct.modelVar_CHNL_TYPE = (+1);
}
else
{
modelStruct.modelVar_CHNL_TYPE = (-1);
}
d_TR_i_dX = ((modelStruct.modelPar_TR>(-273))?modelStruct.d_modelPar_TR_dX:0.0);
TR_i = ((modelStruct.modelPar_TR>(-273))?modelStruct.modelPar_TR:(-273));
d_TKR_dX = d_TR_i_dX;
TKR = (273.15+TR_i);
modelStruct.d_modelVar_TKD_dX = modelStruct.d_modelPar_DTA_dX;
modelStruct.modelVar_TKD = (admsTemperature+modelStruct.modelPar_DTA);
d_TKD_sq_dX = (modelStruct.modelVar_TKD*modelStruct.d_modelVar_TKD_dX+modelStruct.d_modelVar_TKD_dX*modelStruct.modelVar_TKD);
TKD_sq = (modelStruct.modelVar_TKD*modelStruct.modelVar_TKD);
modelStruct.d_modelVar_dT_dX = (modelStruct.d_modelVar_TKD_dX-d_TKR_dX);
modelStruct.modelVar_dT = (modelStruct.modelVar_TKD-TKR);
modelStruct.d_modelVar_rT_dX = ((TKR*modelStruct.d_modelVar_TKD_dX-modelStruct.modelVar_TKD*d_TKR_dX)/TKR/TKR);
modelStruct.modelVar_rT = (modelStruct.modelVar_TKD/TKR);
modelStruct.d_modelVar_rTn_dX = ((modelStruct.modelVar_TKD*d_TKR_dX-TKR*modelStruct.d_modelVar_TKD_dX)/modelStruct.modelVar_TKD/modelStruct.modelVar_TKD);
modelStruct.modelVar_rTn = (TKR/modelStruct.modelVar_TKD);
modelStruct.d_modelVar_phit_dX = (modelStruct.d_modelVar_TKD_dX*1.3806505E-23/1.6021918E-19);
modelStruct.modelVar_phit = ((modelStruct.modelVar_TKD*1.3806505E-23)/1.6021918E-19);
modelStruct.d_modelVar_inv_phit_dX = (-modelStruct.d_modelVar_phit_dX/modelStruct.modelVar_phit/modelStruct.modelVar_phit);
modelStruct.modelVar_inv_phit = (1.0/modelStruct.modelVar_phit);
modelStruct.d_modelVar_Eg_dX = ((-9.025e-5*modelStruct.d_modelVar_TKD_dX)-3.05e-7*d_TKD_sq_dX);
modelStruct.modelVar_Eg = ((1.179-(9.025e-5*modelStruct.modelVar_TKD))-(3.05e-7*TKD_sq));
modelStruct.d_modelVar_phibFac_dX = ((((1.045+(4.5e-4*modelStruct.modelVar_TKD))*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*d_TKD_sq_dX+((1.045+(4.5e-4*modelStruct.modelVar_TKD))*(1.4e-3*modelStruct.d_modelVar_TKD_dX-1.48e-6*d_TKD_sq_dX)+4.5e-4*modelStruct.d_modelVar_TKD_dX*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
modelStruct.modelVar_phibFac = ((((1.045+(4.5e-4*modelStruct.modelVar_TKD))*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
modelStruct.d_modelVar_phibFac_dX = ((modelStruct.modelVar_phibFac>1.0E-3)?modelStruct.d_modelVar_phibFac_dX:0.0);
modelStruct.modelVar_phibFac = ((modelStruct.modelVar_phibFac>1.0E-3)?modelStruct.modelVar_phibFac:1.0E-3);
modelStruct.modelVar_EPSSI = (8.8541878176E-12*11.8);
modelStruct.d_modelVar_nt0_dX = (4*1.3806505E-23)*modelStruct.d_modelVar_TKD_dX;
modelStruct.modelVar_nt0 = ((4*1.3806505E-23)*modelStruct.modelVar_TKD);
d_TRJ_i_dX = ((modelStruct.modelPar_TRJ>(-250))?modelStruct.d_modelPar_TRJ_dX:0.0);
TRJ_i = ((modelStruct.modelPar_TRJ>(-250))?modelStruct.modelPar_TRJ:(-250));
modelStruct.d_modelVar_IMAX_i_dX = ((modelStruct.modelPar_IMAX>1E-12)?modelStruct.d_modelPar_IMAX_dX:0.0);
modelStruct.modelVar_IMAX_i = ((modelStruct.modelPar_IMAX>1E-12)?modelStruct.modelPar_IMAX:1E-12);
d_CJORBOT_i_dX = ((modelStruct.modelPar_CJORBOT>1E-12)?modelStruct.d_modelPar_CJORBOT_dX:0.0);
CJORBOT_i = ((modelStruct.modelPar_CJORBOT>1E-12)?modelStruct.modelPar_CJORBOT:1E-12);
d_CJORSTI_i_dX = ((modelStruct.modelPar_CJORSTI>1E-18)?modelStruct.d_modelPar_CJORSTI_dX:0.0);
CJORSTI_i = ((modelStruct.modelPar_CJORSTI>1E-18)?modelStruct.modelPar_CJORSTI:1E-18);
d_CJORGAT_i_dX = ((modelStruct.modelPar_CJORGAT>1E-18)?modelStruct.d_modelPar_CJORGAT_dX:0.0);
CJORGAT_i = ((modelStruct.modelPar_CJORGAT>1E-18)?modelStruct.modelPar_CJORGAT:1E-18);
modelStruct.d_modelVar_VBIRBOT_i_dX = ((modelStruct.modelPar_VBIRBOT>0.050)?modelStruct.d_modelPar_VBIRBOT_dX:0.0);
modelStruct.modelVar_VBIRBOT_i = ((modelStruct.modelPar_VBIRBOT>0.050)?modelStruct.modelPar_VBIRBOT:0.050);
modelStruct.d_modelVar_VBIRSTI_i_dX = ((modelStruct.modelPar_VBIRSTI>0.050)?modelStruct.d_modelPar_VBIRSTI_dX:0.0);
modelStruct.modelVar_VBIRSTI_i = ((modelStruct.modelPar_VBIRSTI>0.050)?modelStruct.modelPar_VBIRSTI:0.050);
modelStruct.d_modelVar_VBIRGAT_i_dX = ((modelStruct.modelPar_VBIRGAT>0.050)?modelStruct.d_modelPar_VBIRGAT_dX:0.0);
modelStruct.modelVar_VBIRGAT_i = ((modelStruct.modelPar_VBIRGAT>0.050)?modelStruct.modelPar_VBIRGAT:0.050);
modelStruct.d_modelVar_PBOT_i_dX = ((modelStruct.modelPar_PBOT>0.05)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.d_modelPar_PBOT_dX:0.0):0.0);
modelStruct.modelVar_PBOT_i = ((modelStruct.modelPar_PBOT>0.05)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.modelPar_PBOT:0.95):0.05);
modelStruct.d_modelVar_PSTI_i_dX = ((modelStruct.modelPar_PSTI>0.05)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.d_modelPar_PSTI_dX:0.0):0.0);
modelStruct.modelVar_PSTI_i = ((modelStruct.modelPar_PSTI>0.05)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.modelPar_PSTI:0.95):0.05);
modelStruct.d_modelVar_PGAT_i_dX = ((modelStruct.modelPar_PGAT>0.05)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.d_modelPar_PGAT_dX:0.0):0.0);
modelStruct.modelVar_PGAT_i = ((modelStruct.modelPar_PGAT>0.05)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.modelPar_PGAT:0.95):0.05);
d_PHIGBOT_i_dX = modelStruct.d_modelPar_PHIGBOT_dX;
PHIGBOT_i = modelStruct.modelPar_PHIGBOT;
d_PHIGSTI_i_dX = modelStruct.d_modelPar_PHIGSTI_dX;
PHIGSTI_i = modelStruct.modelPar_PHIGSTI;
d_PHIGGAT_i_dX = modelStruct.d_modelPar_PHIGGAT_dX;
PHIGGAT_i = modelStruct.modelPar_PHIGGAT;
d_IDSATRBOT_i_dX = ((modelStruct.modelPar_IDSATRBOT>0)?modelStruct.d_modelPar_IDSATRBOT_dX:0.0);
IDSATRBOT_i = ((modelStruct.modelPar_IDSATRBOT>0)?modelStruct.modelPar_IDSATRBOT:0);
d_IDSATRSTI_i_dX = ((modelStruct.modelPar_IDSATRSTI>0)?modelStruct.d_modelPar_IDSATRSTI_dX:0.0);
IDSATRSTI_i = ((modelStruct.modelPar_IDSATRSTI>0)?modelStruct.modelPar_IDSATRSTI:0);
d_IDSATRGAT_i_dX = ((modelStruct.modelPar_IDSATRGAT>0)?modelStruct.d_modelPar_IDSATRGAT_dX:0.0);
IDSATRGAT_i = ((modelStruct.modelPar_IDSATRGAT>0)?modelStruct.modelPar_IDSATRGAT:0);
modelStruct.d_modelVar_CSRHBOT_i_dX = ((modelStruct.modelPar_CSRHBOT>0)?modelStruct.d_modelPar_CSRHBOT_dX:0.0);
modelStruct.modelVar_CSRHBOT_i = ((modelStruct.modelPar_CSRHBOT>0)?modelStruct.modelPar_CSRHBOT:0);
modelStruct.d_modelVar_CSRHSTI_i_dX = ((modelStruct.modelPar_CSRHSTI>0)?modelStruct.d_modelPar_CSRHSTI_dX:0.0);
modelStruct.modelVar_CSRHSTI_i = ((modelStruct.modelPar_CSRHSTI>0)?modelStruct.modelPar_CSRHSTI:0);
modelStruct.d_modelVar_CSRHGAT_i_dX = ((modelStruct.modelPar_CSRHGAT>0)?modelStruct.d_modelPar_CSRHGAT_dX:0.0);
modelStruct.modelVar_CSRHGAT_i = ((modelStruct.modelPar_CSRHGAT>0)?modelStruct.modelPar_CSRHGAT:0);
d_XJUNSTI_i_dX = ((modelStruct.modelPar_XJUNSTI>1E-9)?modelStruct.d_modelPar_XJUNSTI_dX:0.0);
XJUNSTI_i = ((modelStruct.modelPar_XJUNSTI>1E-9)?modelStruct.modelPar_XJUNSTI:1E-9);
d_XJUNGAT_i_dX = ((modelStruct.modelPar_XJUNGAT>1E-9)?modelStruct.d_modelPar_XJUNGAT_dX:0.0);
XJUNGAT_i = ((modelStruct.modelPar_XJUNGAT>1E-9)?modelStruct.modelPar_XJUNGAT:1E-9);
modelStruct.d_modelVar_CTATBOT_i_dX = ((modelStruct.modelPar_CTATBOT>0)?modelStruct.d_modelPar_CTATBOT_dX:0.0);
modelStruct.modelVar_CTATBOT_i = ((modelStruct.modelPar_CTATBOT>0)?modelStruct.modelPar_CTATBOT:0);
modelStruct.d_modelVar_CTATSTI_i_dX = ((modelStruct.modelPar_CTATSTI>0)?modelStruct.d_modelPar_CTATSTI_dX:0.0);
modelStruct.modelVar_CTATSTI_i = ((modelStruct.modelPar_CTATSTI>0)?modelStruct.modelPar_CTATSTI:0);
modelStruct.d_modelVar_CTATGAT_i_dX = ((modelStruct.modelPar_CTATGAT>0)?modelStruct.d_modelPar_CTATGAT_dX:0.0);
modelStruct.modelVar_CTATGAT_i = ((modelStruct.modelPar_CTATGAT>0)?modelStruct.modelPar_CTATGAT:0);
d_MEFFTATBOT_i_dX = ((modelStruct.modelPar_MEFFTATBOT>0.01)?modelStruct.d_modelPar_MEFFTATBOT_dX:0.0);
MEFFTATBOT_i = ((modelStruct.modelPar_MEFFTATBOT>0.01)?modelStruct.modelPar_MEFFTATBOT:0.01);
d_MEFFTATSTI_i_dX = ((modelStruct.modelPar_MEFFTATSTI>0.01)?modelStruct.d_modelPar_MEFFTATSTI_dX:0.0);
MEFFTATSTI_i = ((modelStruct.modelPar_MEFFTATSTI>0.01)?modelStruct.modelPar_MEFFTATSTI:0.01);
d_MEFFTATGAT_i_dX = ((modelStruct.modelPar_MEFFTATGAT>0.01)?modelStruct.d_modelPar_MEFFTATGAT_dX:0.0);
MEFFTATGAT_i = ((modelStruct.modelPar_MEFFTATGAT>0.01)?modelStruct.modelPar_MEFFTATGAT:0.01);
modelStruct.d_modelVar_CBBTBOT_i_dX = ((modelStruct.modelPar_CBBTBOT>0)?modelStruct.d_modelPar_CBBTBOT_dX:0.0);
modelStruct.modelVar_CBBTBOT_i = ((modelStruct.modelPar_CBBTBOT>0)?modelStruct.modelPar_CBBTBOT:0);
modelStruct.d_modelVar_CBBTSTI_i_dX = ((modelStruct.modelPar_CBBTSTI>0)?modelStruct.d_modelPar_CBBTSTI_dX:0.0);
modelStruct.modelVar_CBBTSTI_i = ((modelStruct.modelPar_CBBTSTI>0)?modelStruct.modelPar_CBBTSTI:0);
modelStruct.d_modelVar_CBBTGAT_i_dX = ((modelStruct.modelPar_CBBTGAT>0)?modelStruct.d_modelPar_CBBTGAT_dX:0.0);
modelStruct.modelVar_CBBTGAT_i = ((modelStruct.modelPar_CBBTGAT>0)?modelStruct.modelPar_CBBTGAT:0);
d_FBBTRBOT_i_dX = modelStruct.d_modelPar_FBBTRBOT_dX;
FBBTRBOT_i = modelStruct.modelPar_FBBTRBOT;
d_FBBTRSTI_i_dX = modelStruct.d_modelPar_FBBTRSTI_dX;
FBBTRSTI_i = modelStruct.modelPar_FBBTRSTI;
d_FBBTRGAT_i_dX = modelStruct.d_modelPar_FBBTRGAT_dX;
FBBTRGAT_i = modelStruct.modelPar_FBBTRGAT;
d_STFBBTBOT_i_dX = modelStruct.d_modelPar_STFBBTBOT_dX;
STFBBTBOT_i = modelStruct.modelPar_STFBBTBOT;
d_STFBBTSTI_i_dX = modelStruct.d_modelPar_STFBBTSTI_dX;
STFBBTSTI_i = modelStruct.modelPar_STFBBTSTI;
d_STFBBTGAT_i_dX = modelStruct.d_modelPar_STFBBTGAT_dX;
STFBBTGAT_i = modelStruct.modelPar_STFBBTGAT;
modelStruct.d_modelVar_VBRBOT_i_dX = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.d_modelPar_VBRBOT_dX:0.0);
modelStruct.modelVar_VBRBOT_i = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.modelPar_VBRBOT:0.1);
modelStruct.d_modelVar_VBRSTI_i_dX = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.d_modelPar_VBRSTI_dX:0.0);
modelStruct.modelVar_VBRSTI_i = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.modelPar_VBRSTI:0.1);
modelStruct.d_modelVar_VBRGAT_i_dX = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.d_modelPar_VBRGAT_dX:0.0);
modelStruct.modelVar_VBRGAT_i = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.modelPar_VBRGAT:0.1);
modelStruct.d_modelVar_PBRBOT_i_dX = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.d_modelPar_PBRBOT_dX:0.0);
modelStruct.modelVar_PBRBOT_i = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.modelPar_PBRBOT:0.1);
modelStruct.d_modelVar_PBRSTI_i_dX = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.d_modelPar_PBRSTI_dX:0.0);
modelStruct.modelVar_PBRSTI_i = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.modelPar_PBRSTI:0.1);
modelStruct.d_modelVar_PBRGAT_i_dX = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.d_modelPar_PBRGAT_dX:0.0);
modelStruct.modelVar_PBRGAT_i = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.modelPar_PBRGAT:0.1);
modelStruct.modelVar_SWJUNEXP_i = 0.0;
if ((modelStruct.modelPar_SWJUNEXP>0.5))
{
modelStruct.modelVar_SWJUNEXP_i = 1.0;
}
else
{
modelStruct.modelVar_SWJUNEXP_i = 0.0;
}
modelStruct.d_modelVar_VJUNREF_i_dX = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.d_modelPar_VJUNREF_dX:0.0);
modelStruct.modelVar_VJUNREF_i = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.modelPar_VJUNREF:0.5);
modelStruct.d_modelVar_FJUNQ_i_dX = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.d_modelPar_FJUNQ_dX:0.0);
modelStruct.modelVar_FJUNQ_i = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.modelPar_FJUNQ:0.0);
if ((modelStruct.modelPar_SWJUNASYM==0.0))
{
d_CJORBOTD_i_dX = d_CJORBOT_i_dX;
CJORBOTD_i = CJORBOT_i;
d_CJORSTID_i_dX = d_CJORSTI_i_dX;
CJORSTID_i = CJORSTI_i;
d_CJORGATD_i_dX = d_CJORGAT_i_dX;
CJORGATD_i = CJORGAT_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX = modelStruct.d_modelVar_VBIRBOT_i_dX;
modelStruct.modelVar_VBIRBOTD_i = modelStruct.modelVar_VBIRBOT_i;
modelStruct.d_modelVar_VBIRSTID_i_dX = modelStruct.d_modelVar_VBIRSTI_i_dX;
modelStruct.modelVar_VBIRSTID_i = modelStruct.modelVar_VBIRSTI_i;
modelStruct.d_modelVar_VBIRGATD_i_dX = modelStruct.d_modelVar_VBIRGAT_i_dX;
modelStruct.modelVar_VBIRGATD_i = modelStruct.modelVar_VBIRGAT_i;
modelStruct.d_modelVar_PBOTD_i_dX = modelStruct.d_modelVar_PBOT_i_dX;
modelStruct.modelVar_PBOTD_i = modelStruct.modelVar_PBOT_i;
modelStruct.d_modelVar_PSTID_i_dX = modelStruct.d_modelVar_PSTI_i_dX;
modelStruct.modelVar_PSTID_i = modelStruct.modelVar_PSTI_i;
modelStruct.d_modelVar_PGATD_i_dX = modelStruct.d_modelVar_PGAT_i_dX;
modelStruct.modelVar_PGATD_i = modelStruct.modelVar_PGAT_i;
d_PHIGBOTD_i_dX = d_PHIGBOT_i_dX;
PHIGBOTD_i = PHIGBOT_i;
d_PHIGSTID_i_dX = d_PHIGSTI_i_dX;
PHIGSTID_i = PHIGSTI_i;
d_PHIGGATD_i_dX = d_PHIGGAT_i_dX;
PHIGGATD_i = PHIGGAT_i;
d_IDSATRBOTD_i_dX = d_IDSATRBOT_i_dX;
IDSATRBOTD_i = IDSATRBOT_i;
d_IDSATRSTID_i_dX = d_IDSATRSTI_i_dX;
IDSATRSTID_i = IDSATRSTI_i;
d_IDSATRGATD_i_dX = d_IDSATRGAT_i_dX;
IDSATRGATD_i = IDSATRGAT_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX = modelStruct.d_modelVar_CSRHBOT_i_dX;
modelStruct.modelVar_CSRHBOTD_i = modelStruct.modelVar_CSRHBOT_i;
modelStruct.d_modelVar_CSRHSTID_i_dX = modelStruct.d_modelVar_CSRHSTI_i_dX;
modelStruct.modelVar_CSRHSTID_i = modelStruct.modelVar_CSRHSTI_i;
modelStruct.d_modelVar_CSRHGATD_i_dX = modelStruct.d_modelVar_CSRHGAT_i_dX;
modelStruct.modelVar_CSRHGATD_i = modelStruct.modelVar_CSRHGAT_i;
d_XJUNSTID_i_dX = d_XJUNSTI_i_dX;
XJUNSTID_i = XJUNSTI_i;
d_XJUNGATD_i_dX = d_XJUNGAT_i_dX;
XJUNGATD_i = XJUNGAT_i;
modelStruct.d_modelVar_CTATBOTD_i_dX = modelStruct.d_modelVar_CTATBOT_i_dX;
modelStruct.modelVar_CTATBOTD_i = modelStruct.modelVar_CTATBOT_i;
modelStruct.d_modelVar_CTATSTID_i_dX = modelStruct.d_modelVar_CTATSTI_i_dX;
modelStruct.modelVar_CTATSTID_i = modelStruct.modelVar_CTATSTI_i;
modelStruct.d_modelVar_CTATGATD_i_dX = modelStruct.d_modelVar_CTATGAT_i_dX;
modelStruct.modelVar_CTATGATD_i = modelStruct.modelVar_CTATGAT_i;
d_MEFFTATBOTD_i_dX = d_MEFFTATBOT_i_dX;
MEFFTATBOTD_i = MEFFTATBOT_i;
d_MEFFTATSTID_i_dX = d_MEFFTATSTI_i_dX;
MEFFTATSTID_i = MEFFTATSTI_i;
d_MEFFTATGATD_i_dX = d_MEFFTATGAT_i_dX;
MEFFTATGATD_i = MEFFTATGAT_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX = modelStruct.d_modelVar_CBBTBOT_i_dX;
modelStruct.modelVar_CBBTBOTD_i = modelStruct.modelVar_CBBTBOT_i;
modelStruct.d_modelVar_CBBTSTID_i_dX = modelStruct.d_modelVar_CBBTSTI_i_dX;
modelStruct.modelVar_CBBTSTID_i = modelStruct.modelVar_CBBTSTI_i;
modelStruct.d_modelVar_CBBTGATD_i_dX = modelStruct.d_modelVar_CBBTGAT_i_dX;
modelStruct.modelVar_CBBTGATD_i = modelStruct.modelVar_CBBTGAT_i;
d_FBBTRBOTD_i_dX = d_FBBTRBOT_i_dX;
FBBTRBOTD_i = FBBTRBOT_i;
d_FBBTRSTID_i_dX = d_FBBTRSTI_i_dX;
FBBTRSTID_i = FBBTRSTI_i;
d_FBBTRGATD_i_dX = d_FBBTRGAT_i_dX;
FBBTRGATD_i = FBBTRGAT_i;
d_STFBBTBOTD_i_dX = d_STFBBTBOT_i_dX;
STFBBTBOTD_i = STFBBTBOT_i;
d_STFBBTSTID_i_dX = d_STFBBTSTI_i_dX;
STFBBTSTID_i = STFBBTSTI_i;
d_STFBBTGATD_i_dX = d_STFBBTGAT_i_dX;
STFBBTGATD_i = STFBBTGAT_i;
modelStruct.d_modelVar_VBRBOTD_i_dX = modelStruct.d_modelVar_VBRBOT_i_dX;
modelStruct.modelVar_VBRBOTD_i = modelStruct.modelVar_VBRBOT_i;
modelStruct.d_modelVar_VBRSTID_i_dX = modelStruct.d_modelVar_VBRSTI_i_dX;
modelStruct.modelVar_VBRSTID_i = modelStruct.modelVar_VBRSTI_i;
modelStruct.d_modelVar_VBRGATD_i_dX = modelStruct.d_modelVar_VBRGAT_i_dX;
modelStruct.modelVar_VBRGATD_i = modelStruct.modelVar_VBRGAT_i;
modelStruct.d_modelVar_PBRBOTD_i_dX = modelStruct.d_modelVar_PBRBOT_i_dX;
modelStruct.modelVar_PBRBOTD_i = modelStruct.modelVar_PBRBOT_i;
modelStruct.d_modelVar_PBRSTID_i_dX = modelStruct.d_modelVar_PBRSTI_i_dX;
modelStruct.modelVar_PBRSTID_i = modelStruct.modelVar_PBRSTI_i;
modelStruct.d_modelVar_PBRGATD_i_dX = modelStruct.d_modelVar_PBRGAT_i_dX;
modelStruct.modelVar_PBRGATD_i = modelStruct.modelVar_PBRGAT_i;
modelStruct.d_modelVar_VJUNREFD_i_dX = modelStruct.d_modelVar_VJUNREF_i_dX;
modelStruct.modelVar_VJUNREFD_i = modelStruct.modelVar_VJUNREF_i;
modelStruct.d_modelVar_FJUNQD_i_dX = modelStruct.d_modelVar_FJUNQ_i_dX;
modelStruct.modelVar_FJUNQD_i = modelStruct.modelVar_FJUNQ_i;
}
else
{
d_CJORBOTD_i_dX = ((modelStruct.modelPar_CJORBOTD>1E-12)?modelStruct.d_modelPar_CJORBOTD_dX:0.0);
CJORBOTD_i = ((modelStruct.modelPar_CJORBOTD>1E-12)?modelStruct.modelPar_CJORBOTD:1E-12);
d_CJORSTID_i_dX = ((modelStruct.modelPar_CJORSTID>1E-18)?modelStruct.d_modelPar_CJORSTID_dX:0.0);
CJORSTID_i = ((modelStruct.modelPar_CJORSTID>1E-18)?modelStruct.modelPar_CJORSTID:1E-18);
d_CJORGATD_i_dX = ((modelStruct.modelPar_CJORGATD>1E-18)?modelStruct.d_modelPar_CJORGATD_dX:0.0);
CJORGATD_i = ((modelStruct.modelPar_CJORGATD>1E-18)?modelStruct.modelPar_CJORGATD:1E-18);
modelStruct.d_modelVar_VBIRBOTD_i_dX = ((modelStruct.modelPar_VBIRBOTD>0.050)?modelStruct.d_modelPar_VBIRBOTD_dX:0.0);
modelStruct.modelVar_VBIRBOTD_i = ((modelStruct.modelPar_VBIRBOTD>0.050)?modelStruct.modelPar_VBIRBOTD:0.050);
modelStruct.d_modelVar_VBIRSTID_i_dX = ((modelStruct.modelPar_VBIRSTID>0.050)?modelStruct.d_modelPar_VBIRSTID_dX:0.0);
modelStruct.modelVar_VBIRSTID_i = ((modelStruct.modelPar_VBIRSTID>0.050)?modelStruct.modelPar_VBIRSTID:0.050);
modelStruct.d_modelVar_VBIRGATD_i_dX = ((modelStruct.modelPar_VBIRGATD>0.050)?modelStruct.d_modelPar_VBIRGATD_dX:0.0);
modelStruct.modelVar_VBIRGATD_i = ((modelStruct.modelPar_VBIRGATD>0.050)?modelStruct.modelPar_VBIRGATD:0.050);
modelStruct.d_modelVar_PBOTD_i_dX = ((modelStruct.modelPar_PBOTD>0.05)?((modelStruct.modelPar_PBOTD<0.95)?modelStruct.d_modelPar_PBOTD_dX:0.0):0.0);
modelStruct.modelVar_PBOTD_i = ((modelStruct.modelPar_PBOTD>0.05)?((modelStruct.modelPar_PBOTD<0.95)?modelStruct.modelPar_PBOTD:0.95):0.05);
modelStruct.d_modelVar_PSTID_i_dX = ((modelStruct.modelPar_PSTID>0.05)?((modelStruct.modelPar_PSTID<0.95)?modelStruct.d_modelPar_PSTID_dX:0.0):0.0);
modelStruct.modelVar_PSTID_i = ((modelStruct.modelPar_PSTID>0.05)?((modelStruct.modelPar_PSTID<0.95)?modelStruct.modelPar_PSTID:0.95):0.05);
modelStruct.d_modelVar_PGATD_i_dX = ((modelStruct.modelPar_PGATD>0.05)?((modelStruct.modelPar_PGATD<0.95)?modelStruct.d_modelPar_PGATD_dX:0.0):0.0);
modelStruct.modelVar_PGATD_i = ((modelStruct.modelPar_PGATD>0.05)?((modelStruct.modelPar_PGATD<0.95)?modelStruct.modelPar_PGATD:0.95):0.05);
d_PHIGBOTD_i_dX = modelStruct.d_modelPar_PHIGBOTD_dX;
PHIGBOTD_i = modelStruct.modelPar_PHIGBOTD;
d_PHIGSTID_i_dX = modelStruct.d_modelPar_PHIGSTID_dX;
PHIGSTID_i = modelStruct.modelPar_PHIGSTID;
d_PHIGGATD_i_dX = modelStruct.d_modelPar_PHIGGATD_dX;
PHIGGATD_i = modelStruct.modelPar_PHIGGATD;
d_IDSATRBOTD_i_dX = ((modelStruct.modelPar_IDSATRBOTD>0)?modelStruct.d_modelPar_IDSATRBOTD_dX:0.0);
IDSATRBOTD_i = ((modelStruct.modelPar_IDSATRBOTD>0)?modelStruct.modelPar_IDSATRBOTD:0);
d_IDSATRSTID_i_dX = ((modelStruct.modelPar_IDSATRSTID>0)?modelStruct.d_modelPar_IDSATRSTID_dX:0.0);
IDSATRSTID_i = ((modelStruct.modelPar_IDSATRSTID>0)?modelStruct.modelPar_IDSATRSTID:0);
d_IDSATRGATD_i_dX = ((modelStruct.modelPar_IDSATRGATD>0)?modelStruct.d_modelPar_IDSATRGATD_dX:0.0);
IDSATRGATD_i = ((modelStruct.modelPar_IDSATRGATD>0)?modelStruct.modelPar_IDSATRGATD:0);
modelStruct.d_modelVar_CSRHBOTD_i_dX = ((modelStruct.modelPar_CSRHBOTD>0)?modelStruct.d_modelPar_CSRHBOTD_dX:0.0);
modelStruct.modelVar_CSRHBOTD_i = ((modelStruct.modelPar_CSRHBOTD>0)?modelStruct.modelPar_CSRHBOTD:0);
modelStruct.d_modelVar_CSRHSTID_i_dX = ((modelStruct.modelPar_CSRHSTID>0)?modelStruct.d_modelPar_CSRHSTID_dX:0.0);
modelStruct.modelVar_CSRHSTID_i = ((modelStruct.modelPar_CSRHSTID>0)?modelStruct.modelPar_CSRHSTID:0);
modelStruct.d_modelVar_CSRHGATD_i_dX = ((modelStruct.modelPar_CSRHGATD>0)?modelStruct.d_modelPar_CSRHGATD_dX:0.0);
modelStruct.modelVar_CSRHGATD_i = ((modelStruct.modelPar_CSRHGATD>0)?modelStruct.modelPar_CSRHGATD:0);
d_XJUNSTID_i_dX = ((modelStruct.modelPar_XJUNSTID>1E-9)?modelStruct.d_modelPar_XJUNSTID_dX:0.0);
XJUNSTID_i = ((modelStruct.modelPar_XJUNSTID>1E-9)?modelStruct.modelPar_XJUNSTID:1E-9);
d_XJUNGATD_i_dX = ((modelStruct.modelPar_XJUNGATD>1E-9)?modelStruct.d_modelPar_XJUNGATD_dX:0.0);
XJUNGATD_i = ((modelStruct.modelPar_XJUNGATD>1E-9)?modelStruct.modelPar_XJUNGATD:1E-9);
modelStruct.d_modelVar_CTATBOTD_i_dX = ((modelStruct.modelPar_CTATBOTD>0)?modelStruct.d_modelPar_CTATBOTD_dX:0.0);
modelStruct.modelVar_CTATBOTD_i = ((modelStruct.modelPar_CTATBOTD>0)?modelStruct.modelPar_CTATBOTD:0);
modelStruct.d_modelVar_CTATSTID_i_dX = ((modelStruct.modelPar_CTATSTID>0)?modelStruct.d_modelPar_CTATSTID_dX:0.0);
modelStruct.modelVar_CTATSTID_i = ((modelStruct.modelPar_CTATSTID>0)?modelStruct.modelPar_CTATSTID:0);
modelStruct.d_modelVar_CTATGATD_i_dX = ((modelStruct.modelPar_CTATGATD>0)?modelStruct.d_modelPar_CTATGATD_dX:0.0);
modelStruct.modelVar_CTATGATD_i = ((modelStruct.modelPar_CTATGATD>0)?modelStruct.modelPar_CTATGATD:0);
d_MEFFTATBOTD_i_dX = ((modelStruct.modelPar_MEFFTATBOTD>0.01)?modelStruct.d_modelPar_MEFFTATBOTD_dX:0.0);
MEFFTATBOTD_i = ((modelStruct.modelPar_MEFFTATBOTD>0.01)?modelStruct.modelPar_MEFFTATBOTD:0.01);
d_MEFFTATSTID_i_dX = ((modelStruct.modelPar_MEFFTATSTID>0.01)?modelStruct.d_modelPar_MEFFTATSTID_dX:0.0);
MEFFTATSTID_i = ((modelStruct.modelPar_MEFFTATSTID>0.01)?modelStruct.modelPar_MEFFTATSTID:0.01);
d_MEFFTATGATD_i_dX = ((modelStruct.modelPar_MEFFTATGATD>0.01)?modelStruct.d_modelPar_MEFFTATGATD_dX:0.0);
MEFFTATGATD_i = ((modelStruct.modelPar_MEFFTATGATD>0.01)?modelStruct.modelPar_MEFFTATGATD:0.01);
modelStruct.d_modelVar_CBBTBOTD_i_dX = ((modelStruct.modelPar_CBBTBOTD>0)?modelStruct.d_modelPar_CBBTBOTD_dX:0.0);
modelStruct.modelVar_CBBTBOTD_i = ((modelStruct.modelPar_CBBTBOTD>0)?modelStruct.modelPar_CBBTBOTD:0);
modelStruct.d_modelVar_CBBTSTID_i_dX = ((modelStruct.modelPar_CBBTSTID>0)?modelStruct.d_modelPar_CBBTSTID_dX:0.0);
modelStruct.modelVar_CBBTSTID_i = ((modelStruct.modelPar_CBBTSTID>0)?modelStruct.modelPar_CBBTSTID:0);
modelStruct.d_modelVar_CBBTGATD_i_dX = ((modelStruct.modelPar_CBBTGATD>0)?modelStruct.d_modelPar_CBBTGATD_dX:0.0);
modelStruct.modelVar_CBBTGATD_i = ((modelStruct.modelPar_CBBTGATD>0)?modelStruct.modelPar_CBBTGATD:0);
d_FBBTRBOTD_i_dX = modelStruct.d_modelPar_FBBTRBOTD_dX;
FBBTRBOTD_i = modelStruct.modelPar_FBBTRBOTD;
d_FBBTRSTID_i_dX = modelStruct.d_modelPar_FBBTRSTID_dX;
FBBTRSTID_i = modelStruct.modelPar_FBBTRSTID;
d_FBBTRGATD_i_dX = modelStruct.d_modelPar_FBBTRGATD_dX;
FBBTRGATD_i = modelStruct.modelPar_FBBTRGATD;
d_STFBBTBOTD_i_dX = modelStruct.d_modelPar_STFBBTBOTD_dX;
STFBBTBOTD_i = modelStruct.modelPar_STFBBTBOTD;
d_STFBBTSTID_i_dX = modelStruct.d_modelPar_STFBBTSTID_dX;
STFBBTSTID_i = modelStruct.modelPar_STFBBTSTID;
d_STFBBTGATD_i_dX = modelStruct.d_modelPar_STFBBTGATD_dX;
STFBBTGATD_i = modelStruct.modelPar_STFBBTGATD;
modelStruct.d_modelVar_VBRBOTD_i_dX = ((modelStruct.modelPar_VBRBOTD>0.1)?modelStruct.d_modelPar_VBRBOTD_dX:0.0);
modelStruct.modelVar_VBRBOTD_i = ((modelStruct.modelPar_VBRBOTD>0.1)?modelStruct.modelPar_VBRBOTD:0.1);
modelStruct.d_modelVar_VBRSTID_i_dX = ((modelStruct.modelPar_VBRSTID>0.1)?modelStruct.d_modelPar_VBRSTID_dX:0.0);
modelStruct.modelVar_VBRSTID_i = ((modelStruct.modelPar_VBRSTID>0.1)?modelStruct.modelPar_VBRSTID:0.1);
modelStruct.d_modelVar_VBRGATD_i_dX = ((modelStruct.modelPar_VBRGATD>0.1)?modelStruct.d_modelPar_VBRGATD_dX:0.0);
modelStruct.modelVar_VBRGATD_i = ((modelStruct.modelPar_VBRGATD>0.1)?modelStruct.modelPar_VBRGATD:0.1);
modelStruct.d_modelVar_PBRBOTD_i_dX = ((modelStruct.modelPar_PBRBOTD>0.1)?modelStruct.d_modelPar_PBRBOTD_dX:0.0);
modelStruct.modelVar_PBRBOTD_i = ((modelStruct.modelPar_PBRBOTD>0.1)?modelStruct.modelPar_PBRBOTD:0.1);
modelStruct.d_modelVar_PBRSTID_i_dX = ((modelStruct.modelPar_PBRSTID>0.1)?modelStruct.d_modelPar_PBRSTID_dX:0.0);
modelStruct.modelVar_PBRSTID_i = ((modelStruct.modelPar_PBRSTID>0.1)?modelStruct.modelPar_PBRSTID:0.1);
modelStruct.d_modelVar_PBRGATD_i_dX = ((modelStruct.modelPar_PBRGATD>0.1)?modelStruct.d_modelPar_PBRGATD_dX:0.0);
modelStruct.modelVar_PBRGATD_i = ((modelStruct.modelPar_PBRGATD>0.1)?modelStruct.modelPar_PBRGATD:0.1);
modelStruct.d_modelVar_VJUNREFD_i_dX = ((modelStruct.modelPar_VJUNREFD>0.5)?modelStruct.d_modelPar_VJUNREFD_dX:0.0);
modelStruct.modelVar_VJUNREFD_i = ((modelStruct.modelPar_VJUNREFD>0.5)?modelStruct.modelPar_VJUNREFD:0.5);
modelStruct.d_modelVar_FJUNQD_i_dX = ((modelStruct.modelPar_FJUNQD>0.0)?modelStruct.d_modelPar_FJUNQD_dX:0.0);
modelStruct.modelVar_FJUNQD_i = ((modelStruct.modelPar_FJUNQD>0.0)?modelStruct.modelPar_FJUNQD:0.0);
}
d_tkr_dX = d_TRJ_i_dX;
tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsTemperature+modelStruct.modelPar_DTA),(273.15+(-250)));
double  deriv_max_0_d0 = (((admsTemperature+modelStruct.modelPar_DTA)>=(273.15+(-250)))?1.0:0.0);
d_tkd_dX = (deriv_max_0_d0*(modelStruct.d_modelPar_DTA_dX));
tkd = value_max_0;
}
d_auxt_dX = ((tkr*d_tkd_dX-tkd*d_tkr_dX)/tkr/tkr);
auxt = (tkd/tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
modelStruct.d_modelVar_phitr_dX = KBOL_over_QELE*d_tkr_dX;
modelStruct.modelVar_phitr = (KBOL_over_QELE*tkr);
d_phitrinv_dX = (-modelStruct.d_modelVar_phitr_dX/modelStruct.modelVar_phitr/modelStruct.modelVar_phitr);
phitrinv = (1.0/modelStruct.modelVar_phitr);
modelStruct.d_modelVar_phitd_dX = KBOL_over_QELE*d_tkd_dX;
modelStruct.modelVar_phitd = (KBOL_over_QELE*tkd);
modelStruct.d_modelVar_phitdinv_dX = (-modelStruct.d_modelVar_phitd_dX/modelStruct.modelVar_phitd/modelStruct.modelVar_phitd);
modelStruct.modelVar_phitdinv = (1.0/modelStruct.modelVar_phitd);
d_deltaphigr_dX = (((1108.0+tkr)*(-((7.02e-4*tkr)*d_tkr_dX+7.02e-4*d_tkr_dX*tkr))-(-((7.02e-4*tkr)*tkr))*d_tkr_dX)/(1108.0+tkr)/(1108.0+tkr));
deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
d_phigrbot_dX = (d_PHIGBOT_i_dX+d_deltaphigr_dX);
phigrbot = (PHIGBOT_i+deltaphigr);
d_phigrsti_dX = (d_PHIGSTI_i_dX+d_deltaphigr_dX);
phigrsti = (PHIGSTI_i+deltaphigr);
d_phigrgat_dX = (d_PHIGGAT_i_dX+d_deltaphigr_dX);
phigrgat = (PHIGGAT_i+deltaphigr);
d_deltaphigd_dX = (((1108.0+tkd)*(-((7.02e-4*tkd)*d_tkd_dX+7.02e-4*d_tkd_dX*tkd))-(-((7.02e-4*tkd)*tkd))*d_tkd_dX)/(1108.0+tkd)/(1108.0+tkd));
deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
d_phigdbot_dX = (d_PHIGBOT_i_dX+d_deltaphigd_dX);
phigdbot = (PHIGBOT_i+deltaphigd);
d_phigdsti_dX = (d_PHIGSTI_i_dX+d_deltaphigd_dX);
phigdsti = (PHIGSTI_i+deltaphigd);
d_phigdgat_dX = (d_PHIGGAT_i_dX+d_deltaphigd_dX);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdbot_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrbot*d_phitrinv_dX+d_phigrbot_dX*phitrinv)-(phigdbot*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdsti_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrsti*d_phitrinv_dX+d_phigrsti_dX*phitrinv)-(phigdsti*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdgat_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrgat*d_phitrinv_dX+d_phigrgat_dX*phitrinv)-(phigdgat*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdgat = (value_pow_0*value_exp_1);
}
modelStruct.d_modelVar_idsatbot_dX = ((IDSATRBOT_i*modelStruct.modelVar_ftdbot)*modelStruct.d_modelVar_ftdbot_dX+(IDSATRBOT_i*modelStruct.d_modelVar_ftdbot_dX+d_IDSATRBOT_i_dX*modelStruct.modelVar_ftdbot)*modelStruct.modelVar_ftdbot);
modelStruct.modelVar_idsatbot = ((IDSATRBOT_i*modelStruct.modelVar_ftdbot)*modelStruct.modelVar_ftdbot);
modelStruct.d_modelVar_idsatsti_dX = ((IDSATRSTI_i*modelStruct.modelVar_ftdsti)*modelStruct.d_modelVar_ftdsti_dX+(IDSATRSTI_i*modelStruct.d_modelVar_ftdsti_dX+d_IDSATRSTI_i_dX*modelStruct.modelVar_ftdsti)*modelStruct.modelVar_ftdsti);
modelStruct.modelVar_idsatsti = ((IDSATRSTI_i*modelStruct.modelVar_ftdsti)*modelStruct.modelVar_ftdsti);
modelStruct.d_modelVar_idsatgat_dX = ((IDSATRGAT_i*modelStruct.modelVar_ftdgat)*modelStruct.d_modelVar_ftdgat_dX+(IDSATRGAT_i*modelStruct.d_modelVar_ftdgat_dX+d_IDSATRGAT_i_dX*modelStruct.modelVar_ftdgat)*modelStruct.modelVar_ftdgat);
modelStruct.modelVar_idsatgat = ((IDSATRGAT_i*modelStruct.modelVar_ftdgat)*modelStruct.modelVar_ftdgat);
{
double value_log_0 = log(modelStruct.modelVar_ftdbot);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdbot);
d_ubibot_dX = ((modelStruct.modelVar_VBIRBOT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdbot_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubibot = ((modelStruct.modelVar_VBIRBOT_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdsti);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdsti);
d_ubisti_dX = ((modelStruct.modelVar_VBIRSTI_i*d_auxt_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdsti_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubisti = ((modelStruct.modelVar_VBIRSTI_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdgat);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdgat);
d_ubigat_dX = ((modelStruct.modelVar_VBIRGAT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdgat_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubigat = ((modelStruct.modelVar_VBIRGAT_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbibot_dX = (d_ubibot_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubibot)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubibot_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbibot = (ubibot+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbisti_dX = (d_ubisti_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubisti)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubisti_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbisti = (ubisti+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbigat_dX = (d_ubigat_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubigat)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubigat_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbigat = (ubigat+(modelStruct.modelVar_phitd*value_log_1));
}
modelStruct.d_modelVar_vbiinvbot_dX = (-modelStruct.d_modelVar_vbibot_dX/modelStruct.modelVar_vbibot/modelStruct.modelVar_vbibot);
modelStruct.modelVar_vbiinvbot = (1.0/modelStruct.modelVar_vbibot);
modelStruct.d_modelVar_vbiinvsti_dX = (-modelStruct.d_modelVar_vbisti_dX/modelStruct.modelVar_vbisti/modelStruct.modelVar_vbisti);
modelStruct.modelVar_vbiinvsti = (1.0/modelStruct.modelVar_vbisti);
modelStruct.d_modelVar_vbiinvgat_dX = (-modelStruct.d_modelVar_vbigat_dX/modelStruct.modelVar_vbigat/modelStruct.modelVar_vbigat);
modelStruct.modelVar_vbiinvgat = (1.0/modelStruct.modelVar_vbigat);
modelStruct.d_modelVar_one_minus_PBOT_dX = (-modelStruct.d_modelVar_PBOT_i_dX);
modelStruct.modelVar_one_minus_PBOT = (1-modelStruct.modelVar_PBOT_i);
modelStruct.d_modelVar_one_minus_PSTI_dX = (-modelStruct.d_modelVar_PSTI_i_dX);
modelStruct.modelVar_one_minus_PSTI = (1-modelStruct.modelVar_PSTI_i);
modelStruct.d_modelVar_one_minus_PGAT_dX = (-modelStruct.d_modelVar_PGAT_i_dX);
modelStruct.modelVar_one_minus_PGAT = (1-modelStruct.modelVar_PGAT_i);
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX = (-1*modelStruct.d_modelVar_one_minus_PBOT_dX/modelStruct.modelVar_one_minus_PBOT/modelStruct.modelVar_one_minus_PBOT);
modelStruct.modelVar_one_over_one_minus_PBOT = (1/modelStruct.modelVar_one_minus_PBOT);
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX = (-1*modelStruct.d_modelVar_one_minus_PSTI_dX/modelStruct.modelVar_one_minus_PSTI/modelStruct.modelVar_one_minus_PSTI);
modelStruct.modelVar_one_over_one_minus_PSTI = (1/modelStruct.modelVar_one_minus_PSTI);
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX = (-1*modelStruct.d_modelVar_one_minus_PGAT_dX/modelStruct.modelVar_one_minus_PGAT/modelStruct.modelVar_one_minus_PGAT);
modelStruct.modelVar_one_over_one_minus_PGAT = (1/modelStruct.modelVar_one_minus_PGAT);
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot))*value_pow_0);
modelStruct.d_modelVar_cjobot_dX = (CJORBOT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRBOT_i*modelStruct.d_modelVar_vbiinvbot_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*modelStruct.modelVar_vbiinvbot)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)))+d_CJORBOT_i_dX*value_pow_0);
modelStruct.modelVar_cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti))*value_pow_0);
modelStruct.d_modelVar_cjosti_dX = (CJORSTI_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRSTI_i*modelStruct.d_modelVar_vbiinvsti_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*modelStruct.modelVar_vbiinvsti)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)))+d_CJORSTI_i_dX*value_pow_0);
modelStruct.modelVar_cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat))*value_pow_0);
modelStruct.d_modelVar_cjogat_dX = (CJORGAT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRGAT_i*modelStruct.d_modelVar_vbiinvgat_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*modelStruct.modelVar_vbiinvgat)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)))+d_CJORGAT_i_dX*value_pow_0);
modelStruct.modelVar_cjogat = (CJORGAT_i*value_pow_0);
}
modelStruct.d_modelVar_qprefbot_dX = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(modelStruct.modelVar_cjobot*modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_cjobot_dX*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.modelVar_qprefbot = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.d_modelVar_qprefsti_dX = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(modelStruct.modelVar_cjosti*modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_cjosti_dX*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.modelVar_qprefsti = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.d_modelVar_qprefgat_dX = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(modelStruct.modelVar_cjogat*modelStruct.d_modelVar_vbigat_dX+modelStruct.d_modelVar_cjogat_dX*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.modelVar_qprefgat = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.d_modelVar_qpref2bot_dX = 2*modelStruct.d_modelVar_cjobot_dX;
modelStruct.modelVar_qpref2bot = (2*modelStruct.modelVar_cjobot);
modelStruct.d_modelVar_qpref2sti_dX = 2*modelStruct.d_modelVar_cjosti_dX;
modelStruct.modelVar_qpref2sti = (2*modelStruct.modelVar_cjosti);
modelStruct.d_modelVar_qpref2gat_dX = 2*modelStruct.d_modelVar_cjogat_dX;
modelStruct.modelVar_qpref2gat = (2*modelStruct.modelVar_cjogat);
modelStruct.d_modelVar_wdepnulrbot_dX = (-modelStruct.modelVar_EPSSI*d_CJORBOT_i_dX/CJORBOT_i/CJORBOT_i);
modelStruct.modelVar_wdepnulrbot = (modelStruct.modelVar_EPSSI/CJORBOT_i);
modelStruct.d_modelVar_wdepnulrsti_dX = ((CJORSTI_i*d_XJUNSTI_i_dX*modelStruct.modelVar_EPSSI-(XJUNSTI_i*modelStruct.modelVar_EPSSI)*d_CJORSTI_i_dX)/CJORSTI_i/CJORSTI_i);
modelStruct.modelVar_wdepnulrsti = ((XJUNSTI_i*modelStruct.modelVar_EPSSI)/CJORSTI_i);
modelStruct.d_modelVar_wdepnulrgat_dX = ((CJORGAT_i*d_XJUNGAT_i_dX*modelStruct.modelVar_EPSSI-(XJUNGAT_i*modelStruct.modelVar_EPSSI)*d_CJORGAT_i_dX)/CJORGAT_i/CJORGAT_i);
modelStruct.modelVar_wdepnulrgat = ((XJUNGAT_i*modelStruct.modelVar_EPSSI)/CJORGAT_i);
modelStruct.d_modelVar_wdepnulrinvbot_dX = (-1*modelStruct.d_modelVar_wdepnulrbot_dX/modelStruct.modelVar_wdepnulrbot/modelStruct.modelVar_wdepnulrbot);
modelStruct.modelVar_wdepnulrinvbot = (1/modelStruct.modelVar_wdepnulrbot);
modelStruct.d_modelVar_wdepnulrinvsti_dX = (-1*modelStruct.d_modelVar_wdepnulrsti_dX/modelStruct.modelVar_wdepnulrsti/modelStruct.modelVar_wdepnulrsti);
modelStruct.modelVar_wdepnulrinvsti = (1/modelStruct.modelVar_wdepnulrsti);
modelStruct.d_modelVar_wdepnulrinvgat_dX = (-1*modelStruct.d_modelVar_wdepnulrgat_dX/modelStruct.modelVar_wdepnulrgat/modelStruct.modelVar_wdepnulrgat);
modelStruct.modelVar_wdepnulrinvgat = (1/modelStruct.modelVar_wdepnulrgat);
modelStruct.d_modelVar_VBIRBOTinv_dX = (-1*modelStruct.d_modelVar_VBIRBOT_i_dX/modelStruct.modelVar_VBIRBOT_i/modelStruct.modelVar_VBIRBOT_i);
modelStruct.modelVar_VBIRBOTinv = (1/modelStruct.modelVar_VBIRBOT_i);
modelStruct.d_modelVar_VBIRSTIinv_dX = (-1*modelStruct.d_modelVar_VBIRSTI_i_dX/modelStruct.modelVar_VBIRSTI_i/modelStruct.modelVar_VBIRSTI_i);
modelStruct.modelVar_VBIRSTIinv = (1/modelStruct.modelVar_VBIRSTI_i);
modelStruct.d_modelVar_VBIRGATinv_dX = (-1*modelStruct.d_modelVar_VBIRGAT_i_dX/modelStruct.modelVar_VBIRGAT_i/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_VBIRGATinv = (1/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(modelStruct.modelVar_perfc,(-2));
modelStruct.modelVar_berfc = (((((-5)*0.29214664)+6)-value_pow_0)/3.0);
}
modelStruct.modelVar_cerfc = ((1.0-0.29214664)-modelStruct.modelVar_berfc);
{
double value_max_0 = std::max((0.5*phigdbot),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEbot_dX = ((deriv_max_0_d0*(0.5*d_phigdbot_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEsti_dX = ((deriv_max_0_d0*(0.5*d_phigdsti_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEgat_dX = ((deriv_max_0_d0*(0.5*d_phigdgat_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEgat = value_max_0;
}
modelStruct.d_modelVar_atatbot_dX = (deltaEbot*modelStruct.d_modelVar_phitdinv_dX+d_deltaEbot_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatbot = (deltaEbot*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatsti_dX = (deltaEsti*modelStruct.d_modelVar_phitdinv_dX+d_deltaEsti_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatsti = (deltaEsti*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatgat_dX = (deltaEgat*modelStruct.d_modelVar_phitdinv_dX+d_deltaEgat_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatgat = (deltaEgat*modelStruct.modelVar_phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartbot_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*d_deltaEbot_dX+(deltaEbot*d_deltaEbot_dX+d_deltaEbot_dX*deltaEbot)*deltaEbot)+32*d_MEFFTATBOT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEbot*deltaEbot)*deltaEbot)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartbot = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartsti_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*d_deltaEsti_dX+(deltaEsti*d_deltaEsti_dX+d_deltaEsti_dX*deltaEsti)*deltaEsti)+32*d_MEFFTATSTI_i_dX*9.1093826E-31*1.6021918E-19*((deltaEsti*deltaEsti)*deltaEsti)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartsti = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartgat_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*d_deltaEgat_dX+(deltaEgat*d_deltaEgat_dX+d_deltaEgat_dX*deltaEgat)*deltaEgat)+32*d_MEFFTATGAT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEgat*deltaEgat)*deltaEgat)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartgat = (value_sqrt_0/(3*1.05457168E-34));
}
modelStruct.d_modelVar_fbbtbot_dX = (FBBTRBOT_i*(STFBBTBOT_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTBOT_i_dX*(tkd-tkr))+d_FBBTRBOT_i_dX*(1+(STFBBTBOT_i*(tkd-tkr))));
modelStruct.modelVar_fbbtbot = (FBBTRBOT_i*(1+(STFBBTBOT_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtsti_dX = (FBBTRSTI_i*(STFBBTSTI_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTSTI_i_dX*(tkd-tkr))+d_FBBTRSTI_i_dX*(1+(STFBBTSTI_i*(tkd-tkr))));
modelStruct.modelVar_fbbtsti = (FBBTRSTI_i*(1+(STFBBTSTI_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtgat_dX = (FBBTRGAT_i*(STFBBTGAT_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTGAT_i_dX*(tkd-tkr))+d_FBBTRGAT_i_dX*(1+(STFBBTGAT_i*(tkd-tkr))));
modelStruct.modelVar_fbbtgat = (FBBTRGAT_i*(1+(STFBBTGAT_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtbot_dX = ((modelStruct.modelVar_fbbtbot>0)?modelStruct.d_modelVar_fbbtbot_dX:0.0);
modelStruct.modelVar_fbbtbot = ((modelStruct.modelVar_fbbtbot>0)?modelStruct.modelVar_fbbtbot:0);
modelStruct.d_modelVar_fbbtsti_dX = ((modelStruct.modelVar_fbbtsti>0)?modelStruct.d_modelVar_fbbtsti_dX:0.0);
modelStruct.modelVar_fbbtsti = ((modelStruct.modelVar_fbbtsti>0)?modelStruct.modelVar_fbbtsti:0);
modelStruct.d_modelVar_fbbtgat_dX = ((modelStruct.modelVar_fbbtgat>0)?modelStruct.d_modelVar_fbbtgat_dX:0.0);
modelStruct.modelVar_fbbtgat = ((modelStruct.modelVar_fbbtgat>0)?modelStruct.modelVar_fbbtgat:0);
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRBOT_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopbot_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopbot = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRSTI_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopsti_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopsti = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRGAT_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopgat_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopgat = (1/(1-value_pow_0));
}
modelStruct.d_modelVar_VBRinvbot_dX = (-1*modelStruct.d_modelVar_VBRBOT_i_dX/modelStruct.modelVar_VBRBOT_i/modelStruct.modelVar_VBRBOT_i);
modelStruct.modelVar_VBRinvbot = (1/modelStruct.modelVar_VBRBOT_i);
modelStruct.d_modelVar_VBRinvsti_dX = (-1*modelStruct.d_modelVar_VBRSTI_i_dX/modelStruct.modelVar_VBRSTI_i/modelStruct.modelVar_VBRSTI_i);
modelStruct.modelVar_VBRinvsti = (1/modelStruct.modelVar_VBRSTI_i);
modelStruct.d_modelVar_VBRinvgat_dX = (-1*modelStruct.d_modelVar_VBRGAT_i_dX/modelStruct.modelVar_VBRGAT_i/modelStruct.modelVar_VBRGAT_i);
modelStruct.modelVar_VBRinvgat = (1/modelStruct.modelVar_VBRGAT_i);
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRBOT_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopebot_dX = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.d_modelVar_VBRinvbot_dX+((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.d_modelVar_PBRBOT_i_dX+(-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX))+(modelStruct.modelVar_fstopbot*modelStruct.d_modelVar_fstopbot_dX+modelStruct.d_modelVar_fstopbot_dX*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
modelStruct.modelVar_slopebot = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
}
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRSTI_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopesti_dX = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.d_modelVar_VBRinvsti_dX+((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.d_modelVar_PBRSTI_i_dX+(-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX))+(modelStruct.modelVar_fstopsti*modelStruct.d_modelVar_fstopsti_dX+modelStruct.d_modelVar_fstopsti_dX*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
modelStruct.modelVar_slopesti = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
}
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRGAT_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopegat_dX = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.d_modelVar_VBRinvgat_dX+((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.d_modelVar_PBRGAT_i_dX+(-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX))+(modelStruct.modelVar_fstopgat*modelStruct.d_modelVar_fstopgat_dX+modelStruct.d_modelVar_fstopgat_dX*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
modelStruct.modelVar_slopegat = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
}
d_phigrbot_d_dX = (d_PHIGBOTD_i_dX+d_deltaphigr_dX);
phigrbot_d = (PHIGBOTD_i+deltaphigr);
d_phigrsti_d_dX = (d_PHIGSTID_i_dX+d_deltaphigr_dX);
phigrsti_d = (PHIGSTID_i+deltaphigr);
d_phigrgat_d_dX = (d_PHIGGATD_i_dX+d_deltaphigr_dX);
phigrgat_d = (PHIGGATD_i+deltaphigr);
d_phigdbot_d_dX = (d_PHIGBOTD_i_dX+d_deltaphigd_dX);
phigdbot_d = (PHIGBOTD_i+deltaphigd);
d_phigdsti_d_dX = (d_PHIGSTID_i_dX+d_deltaphigd_dX);
phigdsti_d = (PHIGSTID_i+deltaphigd);
d_phigdgat_d_dX = (d_PHIGGATD_i_dX+d_deltaphigd_dX);
phigdgat_d = (PHIGGATD_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdbot_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrbot_d*d_phitrinv_dX+d_phigrbot_d_dX*phitrinv)-(phigdbot_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdbot_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdsti_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrsti_d*d_phitrinv_dX+d_phigrsti_d_dX*phitrinv)-(phigdsti_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdsti_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdgat_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrgat_d*d_phitrinv_dX+d_phigrgat_d_dX*phitrinv)-(phigdgat_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdgat_d = (value_pow_0*value_exp_1);
}
modelStruct.d_modelVar_idsatbot_d_dX = ((IDSATRBOTD_i*modelStruct.modelVar_ftdbot_d)*modelStruct.d_modelVar_ftdbot_d_dX+(IDSATRBOTD_i*modelStruct.d_modelVar_ftdbot_d_dX+d_IDSATRBOTD_i_dX*modelStruct.modelVar_ftdbot_d)*modelStruct.modelVar_ftdbot_d);
modelStruct.modelVar_idsatbot_d = ((IDSATRBOTD_i*modelStruct.modelVar_ftdbot_d)*modelStruct.modelVar_ftdbot_d);
modelStruct.d_modelVar_idsatsti_d_dX = ((IDSATRSTID_i*modelStruct.modelVar_ftdsti_d)*modelStruct.d_modelVar_ftdsti_d_dX+(IDSATRSTID_i*modelStruct.d_modelVar_ftdsti_d_dX+d_IDSATRSTID_i_dX*modelStruct.modelVar_ftdsti_d)*modelStruct.modelVar_ftdsti_d);
modelStruct.modelVar_idsatsti_d = ((IDSATRSTID_i*modelStruct.modelVar_ftdsti_d)*modelStruct.modelVar_ftdsti_d);
modelStruct.d_modelVar_idsatgat_d_dX = ((IDSATRGATD_i*modelStruct.modelVar_ftdgat_d)*modelStruct.d_modelVar_ftdgat_d_dX+(IDSATRGATD_i*modelStruct.d_modelVar_ftdgat_d_dX+d_IDSATRGATD_i_dX*modelStruct.modelVar_ftdgat_d)*modelStruct.modelVar_ftdgat_d);
modelStruct.modelVar_idsatgat_d = ((IDSATRGATD_i*modelStruct.modelVar_ftdgat_d)*modelStruct.modelVar_ftdgat_d);
{
double value_log_0 = log(modelStruct.modelVar_ftdbot_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdbot_d);
d_ubibot_d_dX = ((modelStruct.modelVar_VBIRBOTD_i*d_auxt_dX+modelStruct.d_modelVar_VBIRBOTD_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdbot_d_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubibot_d = ((modelStruct.modelVar_VBIRBOTD_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdsti_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdsti_d);
d_ubisti_d_dX = ((modelStruct.modelVar_VBIRSTID_i*d_auxt_dX+modelStruct.d_modelVar_VBIRSTID_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdsti_d_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubisti_d = ((modelStruct.modelVar_VBIRSTID_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdgat_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdgat_d);
d_ubigat_d_dX = ((modelStruct.modelVar_VBIRGATD_i*d_auxt_dX+modelStruct.d_modelVar_VBIRGATD_i_dX*auxt)-((2*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdgat_d_dX)+2*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubigat_d = ((modelStruct.modelVar_VBIRGATD_i*auxt)-((2*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_exp_0 = exp(((0.050-ubibot_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbibot_d_dX = (d_ubibot_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubibot_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubibot_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbibot_d = (ubibot_d+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubisti_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbisti_d_dX = (d_ubisti_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubisti_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubisti_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbisti_d = (ubisti_d+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((0.050-ubigat_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbigat_d_dX = (d_ubigat_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((0.050-ubigat_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubigat_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbigat_d = (ubigat_d+(modelStruct.modelVar_phitd*value_log_1));
}
modelStruct.d_modelVar_vbiinvbot_d_dX = (-modelStruct.d_modelVar_vbibot_d_dX/modelStruct.modelVar_vbibot_d/modelStruct.modelVar_vbibot_d);
modelStruct.modelVar_vbiinvbot_d = (1.0/modelStruct.modelVar_vbibot_d);
modelStruct.d_modelVar_vbiinvsti_d_dX = (-modelStruct.d_modelVar_vbisti_d_dX/modelStruct.modelVar_vbisti_d/modelStruct.modelVar_vbisti_d);
modelStruct.modelVar_vbiinvsti_d = (1.0/modelStruct.modelVar_vbisti_d);
modelStruct.d_modelVar_vbiinvgat_d_dX = (-modelStruct.d_modelVar_vbigat_d_dX/modelStruct.modelVar_vbigat_d/modelStruct.modelVar_vbigat_d);
modelStruct.modelVar_vbiinvgat_d = (1.0/modelStruct.modelVar_vbigat_d);
modelStruct.d_modelVar_one_minus_PBOT_d_dX = (-modelStruct.d_modelVar_PBOTD_i_dX);
modelStruct.modelVar_one_minus_PBOT_d = (1-modelStruct.modelVar_PBOTD_i);
modelStruct.d_modelVar_one_minus_PSTI_d_dX = (-modelStruct.d_modelVar_PSTID_i_dX);
modelStruct.modelVar_one_minus_PSTI_d = (1-modelStruct.modelVar_PSTID_i);
modelStruct.d_modelVar_one_minus_PGAT_d_dX = (-modelStruct.d_modelVar_PGATD_i_dX);
modelStruct.modelVar_one_minus_PGAT_d = (1-modelStruct.modelVar_PGATD_i);
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX = (-1*modelStruct.d_modelVar_one_minus_PBOT_d_dX/modelStruct.modelVar_one_minus_PBOT_d/modelStruct.modelVar_one_minus_PBOT_d);
modelStruct.modelVar_one_over_one_minus_PBOT_d = (1/modelStruct.modelVar_one_minus_PBOT_d);
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX = (-1*modelStruct.d_modelVar_one_minus_PSTI_d_dX/modelStruct.modelVar_one_minus_PSTI_d/modelStruct.modelVar_one_minus_PSTI_d);
modelStruct.modelVar_one_over_one_minus_PSTI_d = (1/modelStruct.modelVar_one_minus_PSTI_d);
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX = (-1*modelStruct.d_modelVar_one_minus_PGAT_d_dX/modelStruct.modelVar_one_minus_PGAT_d/modelStruct.modelVar_one_minus_PGAT_d);
modelStruct.modelVar_one_over_one_minus_PGAT_d = (1/modelStruct.modelVar_one_minus_PGAT_d);
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d))*value_pow_0);
modelStruct.d_modelVar_cjobot_d_dX = (CJORBOTD_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRBOTD_i*modelStruct.d_modelVar_vbiinvbot_d_dX+modelStruct.d_modelVar_VBIRBOTD_i_dX*modelStruct.modelVar_vbiinvbot_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)))+d_CJORBOTD_i_dX*value_pow_0);
modelStruct.modelVar_cjobot_d = (CJORBOTD_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d))*value_pow_0);
modelStruct.d_modelVar_cjosti_d_dX = (CJORSTID_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRSTID_i*modelStruct.d_modelVar_vbiinvsti_d_dX+modelStruct.d_modelVar_VBIRSTID_i_dX*modelStruct.modelVar_vbiinvsti_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)))+d_CJORSTID_i_dX*value_pow_0);
modelStruct.modelVar_cjosti_d = (CJORSTID_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d))*value_pow_0);
modelStruct.d_modelVar_cjogat_d_dX = (CJORGATD_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRGATD_i*modelStruct.d_modelVar_vbiinvgat_d_dX+modelStruct.d_modelVar_VBIRGATD_i_dX*modelStruct.modelVar_vbiinvgat_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)))+d_CJORGATD_i_dX*value_pow_0);
modelStruct.modelVar_cjogat_d = (CJORGATD_i*value_pow_0);
}
modelStruct.d_modelVar_qprefbot_d_dX = ((modelStruct.modelVar_cjobot_d*modelStruct.modelVar_vbibot_d)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(modelStruct.modelVar_cjobot_d*modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_cjobot_d_dX*modelStruct.modelVar_vbibot_d)*modelStruct.modelVar_one_over_one_minus_PBOT_d);
modelStruct.modelVar_qprefbot_d = ((modelStruct.modelVar_cjobot_d*modelStruct.modelVar_vbibot_d)*modelStruct.modelVar_one_over_one_minus_PBOT_d);
modelStruct.d_modelVar_qprefsti_d_dX = ((modelStruct.modelVar_cjosti_d*modelStruct.modelVar_vbisti_d)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(modelStruct.modelVar_cjosti_d*modelStruct.d_modelVar_vbisti_d_dX+modelStruct.d_modelVar_cjosti_d_dX*modelStruct.modelVar_vbisti_d)*modelStruct.modelVar_one_over_one_minus_PSTI_d);
modelStruct.modelVar_qprefsti_d = ((modelStruct.modelVar_cjosti_d*modelStruct.modelVar_vbisti_d)*modelStruct.modelVar_one_over_one_minus_PSTI_d);
modelStruct.d_modelVar_qprefgat_d_dX = ((modelStruct.modelVar_cjogat_d*modelStruct.modelVar_vbigat_d)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(modelStruct.modelVar_cjogat_d*modelStruct.d_modelVar_vbigat_d_dX+modelStruct.d_modelVar_cjogat_d_dX*modelStruct.modelVar_vbigat_d)*modelStruct.modelVar_one_over_one_minus_PGAT_d);
modelStruct.modelVar_qprefgat_d = ((modelStruct.modelVar_cjogat_d*modelStruct.modelVar_vbigat_d)*modelStruct.modelVar_one_over_one_minus_PGAT_d);
modelStruct.d_modelVar_qpref2bot_d_dX = 2*modelStruct.d_modelVar_cjobot_d_dX;
modelStruct.modelVar_qpref2bot_d = (2*modelStruct.modelVar_cjobot_d);
modelStruct.d_modelVar_qpref2sti_d_dX = 2*modelStruct.d_modelVar_cjosti_d_dX;
modelStruct.modelVar_qpref2sti_d = (2*modelStruct.modelVar_cjosti_d);
modelStruct.d_modelVar_qpref2gat_d_dX = 2*modelStruct.d_modelVar_cjogat_d_dX;
modelStruct.modelVar_qpref2gat_d = (2*modelStruct.modelVar_cjogat_d);
modelStruct.d_modelVar_wdepnulrbot_d_dX = (-modelStruct.modelVar_EPSSI*d_CJORBOTD_i_dX/CJORBOTD_i/CJORBOTD_i);
modelStruct.modelVar_wdepnulrbot_d = (modelStruct.modelVar_EPSSI/CJORBOTD_i);
modelStruct.d_modelVar_wdepnulrsti_d_dX = ((CJORSTID_i*d_XJUNSTID_i_dX*modelStruct.modelVar_EPSSI-(XJUNSTID_i*modelStruct.modelVar_EPSSI)*d_CJORSTID_i_dX)/CJORSTID_i/CJORSTID_i);
modelStruct.modelVar_wdepnulrsti_d = ((XJUNSTID_i*modelStruct.modelVar_EPSSI)/CJORSTID_i);
modelStruct.d_modelVar_wdepnulrgat_d_dX = ((CJORGATD_i*d_XJUNGATD_i_dX*modelStruct.modelVar_EPSSI-(XJUNGATD_i*modelStruct.modelVar_EPSSI)*d_CJORGATD_i_dX)/CJORGATD_i/CJORGATD_i);
modelStruct.modelVar_wdepnulrgat_d = ((XJUNGATD_i*modelStruct.modelVar_EPSSI)/CJORGATD_i);
modelStruct.d_modelVar_wdepnulrinvbot_d_dX = (-1*modelStruct.d_modelVar_wdepnulrbot_d_dX/modelStruct.modelVar_wdepnulrbot_d/modelStruct.modelVar_wdepnulrbot_d);
modelStruct.modelVar_wdepnulrinvbot_d = (1/modelStruct.modelVar_wdepnulrbot_d);
modelStruct.d_modelVar_wdepnulrinvsti_d_dX = (-1*modelStruct.d_modelVar_wdepnulrsti_d_dX/modelStruct.modelVar_wdepnulrsti_d/modelStruct.modelVar_wdepnulrsti_d);
modelStruct.modelVar_wdepnulrinvsti_d = (1/modelStruct.modelVar_wdepnulrsti_d);
modelStruct.d_modelVar_wdepnulrinvgat_d_dX = (-1*modelStruct.d_modelVar_wdepnulrgat_d_dX/modelStruct.modelVar_wdepnulrgat_d/modelStruct.modelVar_wdepnulrgat_d);
modelStruct.modelVar_wdepnulrinvgat_d = (1/modelStruct.modelVar_wdepnulrgat_d);
modelStruct.d_modelVar_VBIRBOTinv_d_dX = (-1*modelStruct.d_modelVar_VBIRBOTD_i_dX/modelStruct.modelVar_VBIRBOTD_i/modelStruct.modelVar_VBIRBOTD_i);
modelStruct.modelVar_VBIRBOTinv_d = (1/modelStruct.modelVar_VBIRBOTD_i);
modelStruct.d_modelVar_VBIRSTIinv_d_dX = (-1*modelStruct.d_modelVar_VBIRSTID_i_dX/modelStruct.modelVar_VBIRSTID_i/modelStruct.modelVar_VBIRSTID_i);
modelStruct.modelVar_VBIRSTIinv_d = (1/modelStruct.modelVar_VBIRSTID_i);
modelStruct.d_modelVar_VBIRGATinv_d_dX = (-1*modelStruct.d_modelVar_VBIRGATD_i_dX/modelStruct.modelVar_VBIRGATD_i/modelStruct.modelVar_VBIRGATD_i);
modelStruct.modelVar_VBIRGATinv_d = (1/modelStruct.modelVar_VBIRGATD_i);
{
double value_max_0 = std::max((0.5*phigdbot_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdbot_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdbot_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEbot_d_dX = ((deriv_max_0_d0*(0.5*d_phigdbot_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEbot_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdsti_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdsti_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEsti_d_dX = ((deriv_max_0_d0*(0.5*d_phigdsti_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEsti_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdgat_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdgat_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEgat_d_dX = ((deriv_max_0_d0*(0.5*d_phigdgat_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEgat_d = value_max_0;
}
modelStruct.d_modelVar_atatbot_d_dX = (deltaEbot_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEbot_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatbot_d = (deltaEbot_d*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatsti_d_dX = (deltaEsti_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEsti_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatsti_d = (deltaEsti_d*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatgat_d_dX = (deltaEgat_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEgat_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatgat_d = (deltaEgat_d*modelStruct.modelVar_phitdinv);
{
double value_sqrt_0 = sqrt(((((32*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartbot_d_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*d_deltaEbot_d_dX+(deltaEbot_d*d_deltaEbot_d_dX+d_deltaEbot_d_dX*deltaEbot_d)*deltaEbot_d)+32*d_MEFFTATBOTD_i_dX*9.1093826E-31*1.6021918E-19*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartbot_d = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartsti_d_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*d_deltaEsti_d_dX+(deltaEsti_d*d_deltaEsti_d_dX+d_deltaEsti_d_dX*deltaEsti_d)*deltaEsti_d)+32*d_MEFFTATSTID_i_dX*9.1093826E-31*1.6021918E-19*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartsti_d = (value_sqrt_0/(3*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartgat_d_dX = (deriv_sqrt_0_d0*(((((32*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*d_deltaEgat_d_dX+(deltaEgat_d*d_deltaEgat_d_dX+d_deltaEgat_d_dX*deltaEgat_d)*deltaEgat_d)+32*d_MEFFTATGATD_i_dX*9.1093826E-31*1.6021918E-19*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)))/(3*1.05457168E-34));
modelStruct.modelVar_btatpartgat_d = (value_sqrt_0/(3*1.05457168E-34));
}
modelStruct.d_modelVar_fbbtbot_d_dX = (FBBTRBOTD_i*(STFBBTBOTD_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTBOTD_i_dX*(tkd-tkr))+d_FBBTRBOTD_i_dX*(1+(STFBBTBOTD_i*(tkd-tkr))));
modelStruct.modelVar_fbbtbot_d = (FBBTRBOTD_i*(1+(STFBBTBOTD_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtsti_d_dX = (FBBTRSTID_i*(STFBBTSTID_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTSTID_i_dX*(tkd-tkr))+d_FBBTRSTID_i_dX*(1+(STFBBTSTID_i*(tkd-tkr))));
modelStruct.modelVar_fbbtsti_d = (FBBTRSTID_i*(1+(STFBBTSTID_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtgat_d_dX = (FBBTRGATD_i*(STFBBTGATD_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTGATD_i_dX*(tkd-tkr))+d_FBBTRGATD_i_dX*(1+(STFBBTGATD_i*(tkd-tkr))));
modelStruct.modelVar_fbbtgat_d = (FBBTRGATD_i*(1+(STFBBTGATD_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtbot_d_dX = ((modelStruct.modelVar_fbbtbot_d>0)?modelStruct.d_modelVar_fbbtbot_d_dX:0.0);
modelStruct.modelVar_fbbtbot_d = ((modelStruct.modelVar_fbbtbot_d>0)?modelStruct.modelVar_fbbtbot_d:0);
modelStruct.d_modelVar_fbbtsti_d_dX = ((modelStruct.modelVar_fbbtsti_d>0)?modelStruct.d_modelVar_fbbtsti_d_dX:0.0);
modelStruct.modelVar_fbbtsti_d = ((modelStruct.modelVar_fbbtsti_d>0)?modelStruct.modelVar_fbbtsti_d:0);
modelStruct.d_modelVar_fbbtgat_d_dX = ((modelStruct.modelVar_fbbtgat_d>0)?modelStruct.d_modelVar_fbbtgat_d_dX:0.0);
modelStruct.modelVar_fbbtgat_d = ((modelStruct.modelVar_fbbtgat_d>0)?modelStruct.modelVar_fbbtgat_d:0);
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRBOTD_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopbot_d_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopbot_d = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRSTID_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopsti_d_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopsti_d = (1/(1-value_pow_0));
}
{
double value_pow_0 = pow(0.999,modelStruct.modelVar_PBRGATD_i);
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_fstopgat_d_dX = (-1*(-(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)))/(1-value_pow_0)/(1-value_pow_0));
modelStruct.modelVar_fstopgat_d = (1/(1-value_pow_0));
}
modelStruct.d_modelVar_VBRinvbot_d_dX = (-1*modelStruct.d_modelVar_VBRBOTD_i_dX/modelStruct.modelVar_VBRBOTD_i/modelStruct.modelVar_VBRBOTD_i);
modelStruct.modelVar_VBRinvbot_d = (1/modelStruct.modelVar_VBRBOTD_i);
modelStruct.d_modelVar_VBRinvsti_d_dX = (-1*modelStruct.d_modelVar_VBRSTID_i_dX/modelStruct.modelVar_VBRSTID_i/modelStruct.modelVar_VBRSTID_i);
modelStruct.modelVar_VBRinvsti_d = (1/modelStruct.modelVar_VBRSTID_i);
modelStruct.d_modelVar_VBRinvgat_d_dX = (-1*modelStruct.d_modelVar_VBRGATD_i_dX/modelStruct.modelVar_VBRGATD_i/modelStruct.modelVar_VBRGATD_i);
modelStruct.modelVar_VBRinvgat_d = (1/modelStruct.modelVar_VBRGATD_i);
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRBOTD_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopebot_d_dX = (((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.d_modelVar_VBRinvbot_d_dX+((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.d_modelVar_PBRBOTD_i_dX+(-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX))+(modelStruct.modelVar_fstopbot_d*modelStruct.d_modelVar_fstopbot_d_dX+modelStruct.d_modelVar_fstopbot_d_dX*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.modelVar_VBRinvbot_d);
modelStruct.modelVar_slopebot_d = (((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.modelVar_VBRinvbot_d);
}
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRSTID_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopesti_d_dX = (((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.d_modelVar_VBRinvsti_d_dX+((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.d_modelVar_PBRSTID_i_dX+(-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTID_i_dX))+(modelStruct.modelVar_fstopsti_d*modelStruct.d_modelVar_fstopsti_d_dX+modelStruct.d_modelVar_fstopsti_d_dX*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.modelVar_VBRinvsti_d);
modelStruct.modelVar_slopesti_d = (((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.modelVar_VBRinvsti_d);
}
{
double value_pow_0 = pow(0.999,(modelStruct.modelVar_PBRGATD_i-1));
double  deriv_pow_0_d1 = (0.999 == 0.0)?0.0:(log(0.999)*value_pow_0);
modelStruct.d_modelVar_slopegat_d_dX = (((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.d_modelVar_VBRinvgat_d_dX+((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.d_modelVar_PBRGATD_i_dX+(-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGATD_i_dX))+(modelStruct.modelVar_fstopgat_d*modelStruct.d_modelVar_fstopgat_d_dX+modelStruct.d_modelVar_fstopgat_d_dX*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.modelVar_VBRinvgat_d);
modelStruct.modelVar_slopegat_d = (((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.modelVar_VBRinvgat_d);
}
}
// End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_D_GND,
const int admsProbeID_V_BS_GND,
const int admsProbeID_V_BD_GND,
const int admsProbeID_V_S_GND,
const int admsProbeID_V_BP_GND,
const int admsProbeID_V_GP_GND,
const int admsProbeID_V_NOI_GND,
const int admsProbeID_V_NOI2_GND,
const int admsProbeID_V_D_BD,
const int admsProbeID_V_S_BS,
const int admsProbeID_V_S_BP,
const int admsProbeID_V_D_S,
const int admsProbeID_V_GP_S,
const int admsProbeID_V_B_BI,
const int admsProbeID_V_BP_BI,
const int admsProbeID_V_BD_BI,
const int admsProbeID_V_BS_BI,
const int admsProbeID_V_G_GP,
// node constants
const int admsNodeID_D,
const int admsNodeID_G,
const int admsNodeID_S,
const int admsNodeID_B,
const int admsNodeID_NOI,
const int admsNodeID_NOI2,
const int admsNodeID_GP,
const int admsNodeID_BP,
const int admsNodeID_BI,
const int admsNodeID_BS,
const int admsNodeID_BD,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double vth_i=0.0;
double d_vth_i_dX=0.0;
  double vts_i=0.0;
double d_vts_i_dX=0.0;
  double facvsb=0.0;
double d_facvsb_dX=0.0;
  double facvsb0=0.0;
double d_facvsb0_dX=0.0;
  double P_D=0.0;
double d_P_D_dX=0.0;
  double Vtovs=0.0;
double d_Vtovs_dX=0.0;
  double Vtovd=0.0;
double d_Vtovd_dX=0.0;
  double Igisl=0.0;
double d_Igisl_dX=0.0;
  double Igidl=0.0;
double d_Igidl_dX=0.0;
  double Sg=0.0;
double d_Sg_dX=0.0;
  double igcd_h=0.0;
double d_igcd_h_dX=0.0;
  double igc=0.0;
double d_igc_dX=0.0;
  double xsq=0.0;
double d_xsq_dX=0.0;
  double inv_ex=0.0;
double d_inv_ex_dX=0.0;
  double ex=0.0;
double d_ex_dX=0.0;
  double inv_x=0.0;
double d_inv_x_dX=0.0;
  double Ag=0.0;
double d_Ag_dX=0.0;
  double Bg=0.0;
double d_Bg_dX=0.0;
  double u0_div_H=0.0;
double d_u0_div_H_dX=0.0;
  double x=0.0;
double d_x_dX=0.0;
  double u0=0.0;
double d_u0_dX=0.0;
  double Igc0=0.0;
double d_Igc0_dX=0.0;
  double Vm=0.0;
double d_Vm_dX=0.0;
  double TP=0.0;
double d_TP_dX=0.0;
  double Dgate=0.0;
double d_Dgate_dX=0.0;
  double Dsi=0.0;
double d_Dsi_dX=0.0;
  double arg1=0.0;
double d_arg1_dX=0.0;
  double zg=0.0;
double d_zg_dX=0.0;
  double psi_t=0.0;
double d_psi_t_dX=0.0;
  double arg2mina=0.0;
double d_arg2mina_dX=0.0;
  double Igb=0.0;
double d_Igb_dX=0.0;
  double Igc=0.0;
double d_Igc_dX=0.0;
  double SP_OV_w=0.0;
double d_SP_OV_w_dX=0.0;
  double SP_OV_xi=0.0;
double d_SP_OV_xi_dX=0.0;
  double SP_OV_q=0.0;
double d_SP_OV_q_dX=0.0;
  double SP_OV_p=0.0;
double d_SP_OV_p_dX=0.0;
  double SP_OV_temp=0.0;
double d_SP_OV_temp_dX=0.0;
  double SP_OV_D0=0.0;
double d_SP_OV_D0_dX=0.0;
  double SP_OV_y0=0.0;
double d_SP_OV_y0_dX=0.0;
  double SP_OV_tau=0.0;
double d_SP_OV_tau_dX=0.0;
  double SP_OV_c=0.0;
double d_SP_OV_c_dX=0.0;
  double SP_OV_a=0.0;
double d_SP_OV_a_dX=0.0;
  double SP_OV_eta=0.0;
double d_SP_OV_eta_dX=0.0;
  double SP_OV_z=0.0;
double d_SP_OV_z_dX=0.0;
  double SP_OV_yg=0.0;
double d_SP_OV_yg_dX=0.0;
  double SP_OV_u=0.0;
double d_SP_OV_u_dX=0.0;
  double SP_OV_x0=0.0;
double d_SP_OV_x0_dX=0.0;
  double SP_OV_xbar=0.0;
double d_SP_OV_xbar_dX=0.0;
  double SP_OV_Afac=0.0;
double d_SP_OV_Afac_dX=0.0;
  double inv_xg1=0.0;
double d_inv_xg1_dX=0.0;
  double x_mrg_ov=0.0;
double d_x_mrg_ov_dX=0.0;
  double inv_xi_ov=0.0;
double d_inv_xi_ov_dX=0.0;
  double xi_ov=0.0;
double d_xi_ov_dX=0.0;
  double GOV2=0.0;
double d_GOV2_dX=0.0;
  double GOV=0.0;
double d_GOV_dX=0.0;
  double Vdsat=0.0;
double d_Vdsat_dX=0.0;
  double qeff=0.0;
double d_qeff_dX=0.0;
  double Voxm=0.0;
double d_Voxm_dX=0.0;
  double qis=0.0;
double d_qis_dX=0.0;
  double delVsat=0.0;
double d_delVsat_dX=0.0;
  double alpha1=0.0;
double d_alpha1_dX=0.0;
  double zsat=0.0;
double d_zsat_dX=0.0;
  double dL1=0.0;
double d_dL1_dX=0.0;
  double dL=0.0;
double d_dL_dX=0.0;
  double r2=0.0;
double d_r2_dX=0.0;
  double r1=0.0;
double d_r1_dX=0.0;
  double qbm=0.0;
double d_qbm_dX=0.0;
  double qim1_1=0.0;
double d_qim1_1_dX=0.0;
  double Pm=0.0;
double d_Pm_dX=0.0;
  double help=0.0;
double d_help_dX=0.0;
  double km=0.0;
double d_km_dX=0.0;
  double u_pd=0.0;
double d_u_pd_dX=0.0;
  double xi_pd=0.0;
double d_xi_pd_dX=0.0;
  double q_pd=0.0;
double d_q_pd_dX=0.0;
  double p_pd=0.0;
double d_p_pd_dX=0.0;
  double x_pm=0.0;
double d_x_pm_dX=0.0;
  double d0=0.0;
double d_d0_dX=0.0;
  double D_bar=0.0;
double d_D_bar_dX=0.0;
  double xi0d=0.0;
double d_xi0d_dX=0.0;
  double qC=0.0;
double d_qC_dX=0.0;
  double pC=0.0;
double d_pC_dX=0.0;
  double delta_nd=0.0;
double d_delta_nd_dX=0.0;
  double k_ds=0.0;
double d_k_ds_dX=0.0;
  double xn_d=0.0;
double d_xn_d_dX=0.0;
  double Phi_sat=0.0;
double d_Phi_sat_dX=0.0;
  double Phi0_Phi2=0.0;
double d_Phi0_Phi2_dX=0.0;
  double Phi_0_2=0.0;
double d_Phi_0_2_dX=0.0;
  double Phi_2=0.0;
double d_Phi_2_dX=0.0;
  double asat=0.0;
double d_asat_dX=0.0;
  double Phi_0=0.0;
double d_Phi_0_dX=0.0;
  double temp1=0.0;
double d_temp1_dX=0.0;
  double za=0.0;
double d_za_dX=0.0;
  double ysat=0.0;
double d_ysat_dX=0.0;
  double phi_inf=0.0;
double d_phi_inf_dX=0.0;
  double wsat=0.0;
double d_wsat_dX=0.0;
  double temp2=0.0;
double d_temp2_dX=0.0;
  double Mutmp=0.0;
double d_Mutmp_dX=0.0;
  double Eeffm=0.0;
double d_Eeffm_dX=0.0;
  double GR=0.0;
double d_GR_dX=0.0;
  double qbs=0.0;
double d_qbs_dX=0.0;
  double xgs=0.0;
double d_xgs_dX=0.0;
  double Rxcor=0.0;
double d_Rxcor_dX=0.0;
  double Dd=0.0;
double d_Dd_dX=0.0;
  double Dm=0.0;
double d_Dm_dX=0.0;
  double Ed=0.0;
double d_Ed_dX=0.0;
  double Em=0.0;
double d_Em_dX=0.0;
  double Ps=0.0;
double d_Ps_dX=0.0;
  double Ds=0.0;
double d_Ds_dX=0.0;
  double Es=0.0;
double d_Es_dX=0.0;
  double xi2s=0.0;
double d_xi2s_dX=0.0;
  double xi1s=0.0;
double d_xi1s_dX=0.0;
  double xi0s=0.0;
double d_xi0s_dX=0.0;
  double delta_1s=0.0;
double d_delta_1s_dX=0.0;
  double x_ds=0.0;
double d_x_ds_dX=0.0;
  double x_m=0.0;
double d_x_m_dX=0.0;
  double x_d=0.0;
double d_x_d_dX=0.0;
  double SP_S_temp1=0.0;
double d_SP_S_temp1_dX=0.0;
  double SP_S_qC=0.0;
double d_SP_S_qC_dX=0.0;
  double SP_S_pC=0.0;
double d_SP_S_pC_dX=0.0;
  double SP_S_xi2=0.0;
double d_SP_S_xi2_dX=0.0;
  double SP_S_xi1=0.0;
double d_SP_S_xi1_dX=0.0;
  double SP_S_xi0=0.0;
double d_SP_S_xi0_dX=0.0;
  double SP_S_delta1=0.0;
double d_SP_S_delta1_dX=0.0;
  double SP_S_delta0=0.0;
double d_SP_S_delta0_dX=0.0;
  double SP_S_y0=0.0;
double d_SP_S_y0_dX=0.0;
  double mutau=0.0;
double d_mutau_dX=0.0;
  double nu=0.0;
double d_nu_dX=0.0;
  double SP_S_tau=0.0;
double d_SP_S_tau_dX=0.0;
  double SP_S_c=0.0;
double d_SP_S_c_dX=0.0;
  double SP_S_a=0.0;
double d_SP_S_a_dX=0.0;
  double SP_S_temp=0.0;
double d_SP_S_temp_dX=0.0;
  double SP_S_eta=0.0;
double d_SP_S_eta_dX=0.0;
  double SP_S_ysub=0.0;
double d_SP_S_ysub_dX=0.0;
  double SP_S_yg=0.0;
double d_SP_S_yg_dX=0.0;
  double SP_S_x0=0.0;
double d_SP_S_x0_dX=0.0;
  double SP_S_b=0.0;
double d_SP_S_b_dX=0.0;
  double SP_S_temp2=0.0;
double d_SP_S_temp2_dX=0.0;
  double SP_S_bx=0.0;
double d_SP_S_bx_dX=0.0;
  double SP_S_w=0.0;
double d_SP_S_w_dX=0.0;
  double SP_S_xbar=0.0;
double d_SP_S_xbar_dX=0.0;
  double SP_S_A_fac=0.0;
double d_SP_S_A_fac_dX=0.0;
  double SP_xg1=0.0;
double d_SP_xg1_dX=0.0;
  double margin=0.0;
double d_margin_dX=0.0;
  double delta_ns=0.0;
double d_delta_ns_dX=0.0;
  double xn_s=0.0;
double d_xn_s_dX=0.0;
  double Ux=0.0;
double d_Ux_dX=0.0;
  double inv_xi=0.0;
double d_inv_xi_dX=0.0;
  double xi=0.0;
double d_xi_dX=0.0;
  double inv_Gf2=0.0;
double d_inv_Gf2_dX=0.0;
  double Gf2=0.0;
double d_Gf2_dX=0.0;
  double Gf=0.0;
double d_Gf_dX=0.0;
  double Dnsub=0.0;
double d_Dnsub_dX=0.0;
  double delVg=0.0;
double d_delVg_dX=0.0;
  double Vsbx=0.0;
double d_Vsbx_dX=0.0;
  double Vdsx=0.0;
  double Vgb1=0.0;
double d_Vgb1_dX=0.0;
  double Vgbstar=0.0;
double d_Vgbstar_dX=0.0;
  double Vdbstar=0.0;
double d_Vdbstar_dX=0.0;
  double Vsbstar=0.0;
double d_Vsbstar_dX=0.0;
  double temp=0.0;
double d_temp_dX=0.0;
  double Vdb=0.0;
  double Vgd=0.0;
  double xgd_ov=0.0;
double d_xgd_ov_dX=0.0;
  double xgs_ov=0.0;
double d_xgs_ov_dX=0.0;
  double VgdPrime=0.0;
  double VdbPrime=0.0;
  double VsbPrime=0.0;
  double VgsPrime=0.0;
  double Vjun_d=0.0;
  double Vjun_s=0.0;
  double Vsb=0.0;
  double Vds=0.0;
  double Vgs=0.0;
  double Vrwell=0.0;
  double Vrbulk=0.0;
  double Vrjund=0.0;
  double Vrjuns=0.0;
  double Vrg=0.0;
  double Vovd=0.0;
double d_Vovd_dX=0.0;
  double Vovs=0.0;
double d_Vovs_dX=0.0;
  double xd_ov=0.0;
double d_xd_ov_dX=0.0;
  double xs_ov=0.0;
double d_xs_ov_dX=0.0;
  double xgm=0.0;
double d_xgm_dX=0.0;
  double thesat1=0.0;
double d_thesat1_dX=0.0;
  double QCLM=0.0;
double d_QCLM_dX=0.0;
  double Udse=0.0;
double d_Udse_dX=0.0;
  double GdL=0.0;
double d_GdL_dX=0.0;
  double rhob=0.0;
double d_rhob_dX=0.0;
  double sqm=0.0;
double d_sqm_dX=0.0;
  double x_s=0.0;
double d_x_s_dX=0.0;
  double SP_S_x1=0.0;
double d_SP_S_x1_dX=0.0;
  double Qfgd=0.0;
double d_Qfgd_dX=0.0;
  double Qfgs=0.0;
double d_Qfgs_dX=0.0;
  double Qgb_ov=0.0;
double d_Qgb_ov_dX=0.0;
  double Qgd_ov=0.0;
double d_Qgd_ov_dX=0.0;
  double Qgs_ov=0.0;
double d_Qgs_ov_dX=0.0;
  double Qb=0.0;
double d_Qb_dX=0.0;
  double Qd=0.0;
double d_Qd_dX=0.0;
  double Qg=0.0;
double d_Qg_dX=0.0;
  double QB=0.0;
double d_QB_dX=0.0;
  double QD=0.0;
double d_QD_dX=0.0;
  double QI=0.0;
double d_QI_dX=0.0;
  double QG=0.0;
double d_QG_dX=0.0;
  double Fj2=0.0;
double d_Fj2_dX=0.0;
  double Fj=0.0;
double d_Fj_dX=0.0;
  double Vgb=0.0;
  double rwellnoise=0.0;
double d_rwellnoise_dX=0.0;
  double rjundnoise=0.0;
double d_rjundnoise_dX=0.0;
  double rjunsnoise=0.0;
double d_rjunsnoise_dX=0.0;
  double rbulknoise=0.0;
double d_rbulknoise_dX=0.0;
  double rgatenoise=0.0;
double d_rgatenoise_dX=0.0;
  double h1=0.0;
double d_h1_dX=0.0;
  double h2=0.0;
double d_h2_dX=0.0;
  double h2d=0.0;
double d_h2d_dX=0.0;
  double h3=0.0;
double d_h3_dX=0.0;
  double h4=0.0;
double d_h4_dX=0.0;
  double h5=0.0;
double d_h5_dX=0.0;
  double ijunrev=0.0;
double d_ijunrev_dX=0.0;
  double ijunfor2=0.0;
double d_ijunfor2_dX=0.0;
  double ijunfor1=0.0;
double d_ijunfor1_dX=0.0;
  double tm1=0.0;
double d_tm1_dX=0.0;
  double tm0=0.0;
double d_tm0_dX=0.0;
  double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
  double ibbt=0.0;
double d_ibbt_dX=0.0;
  double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
  double itat=0.0;
double d_itat_dX=0.0;
  double gammamax=0.0;
double d_gammamax_dX=0.0;
  double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
  double erfcpos=0.0;
double d_erfcpos_dX=0.0;
  double terfc=0.0;
double d_terfc_dX=0.0;
  double ysq=0.0;
double d_ysq_dX=0.0;
  double xerfc=0.0;
double d_xerfc_dX=0.0;
  double mtat=0.0;
double d_mtat_dX=0.0;
  double ltat=0.0;
double d_ltat_dX=0.0;
  double ktat=0.0;
double d_ktat_dX=0.0;
  double wtat=0.0;
double d_wtat_dX=0.0;
  double wgamma=0.0;
double d_wgamma_dX=0.0;
  double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
  double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
  double umax=0.0;
double d_umax_dX=0.0;
  double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
  double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
  double btat=0.0;
double d_btat_dX=0.0;
  double isrh=0.0;
double d_isrh_dX=0.0;
  double asrh=0.0;
double d_asrh_dX=0.0;
  double wdep=0.0;
double d_wdep_dX=0.0;
  double wsrh=0.0;
double d_wsrh_dX=0.0;
  double dwsrh=0.0;
double d_dwsrh_dX=0.0;
  double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
  double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
  double id=0.0;
double d_id_dX=0.0;
  double tmp=0.0;
double d_tmp_dX=0.0;
  double vav=0.0;
  double vjsrh=0.0;
double d_vjsrh_dX=0.0;
  double vjlim=0.0;
double d_vjlim_dX=0.0;
  double z=0.0;
double d_z_dX=0.0;
  double idmult=0.0;
double d_idmult_dX=0.0;
  double zinv=0.0;
double d_zinv_dX=0.0;
  double vj=0.0;
double d_vj_dX=0.0;
  double two_psistar=0.0;
double d_two_psistar_dX=0.0;
  double vbbt=0.0;
double d_vbbt_dX=0.0;
  double Qs=0.0;
double d_Qs_dX=0.0;
  double shot_igd=0.0;
double d_shot_igd_dX=0.0;
  double shot_igs=0.0;
double d_shot_igs_dX=0.0;
  double Sidexc=0.0;
double d_Sidexc_dX=0.0;
  double gfac=0.0;
double d_gfac_dX=0.0;
  double Gvsat_exc=0.0;
double d_Gvsat_exc_dX=0.0;
  double zsat_exc=0.0;
double d_zsat_exc_dX=0.0;
  double thesat1_exc=0.0;
double d_thesat1_exc_dX=0.0;
  double temp_exc=0.0;
double d_temp_exc_dX=0.0;
  double wsat_exc=0.0;
double d_wsat_exc_dX=0.0;
  double temp2_exc=0.0;
double d_temp2_exc_dX=0.0;
  double g_ideal=0.0;
double d_g_ideal_dX=0.0;
  double lcinv2=0.0;
double d_lcinv2_dX=0.0;
  double lc=0.0;
double d_lc_dX=0.0;
  double r=0.0;
double d_r_dX=0.0;
  double t2=0.0;
double d_t2_dX=0.0;
  double sqt2=0.0;
double d_sqt2_dX=0.0;
  double t1=0.0;
double d_t1_dX=0.0;
  double H0=0.0;
double d_H0_dX=0.0;
  double Delta_N1=0.0;
double d_Delta_N1_dX=0.0;
  double Nm1=0.0;
double d_Nm1_dX=0.0;
  double N1=0.0;
double d_N1_dX=0.0;
  double sqig=0.0;
double d_sqig_dX=0.0;
  double migid=0.0;
double d_migid_dX=0.0;
  double mid=0.0;
double d_mid_dX=0.0;
  double sig1k=0.0;
double d_sig1k_dX=0.0;
  double ib=0.0;
double d_ib_dX=0.0;
  double ig=0.0;
double d_ig_dX=0.0;
  double is=0.0;
double d_is_dX=0.0;
  double id_op=0.0;
double d_id_op_dX=0.0;


  // -- code converted from analog/code block
//Begin block evaluateblock
{
//Block-local variables for block evaluateblock
double alpha=0.0;
double d_alpha_dX=0.0;
double eta_p=0.0;
double d_eta_p_dX=0.0;
double xitsb=0.0;
double d_xitsb_dX=0.0;
double FdL=0.0;
double d_FdL_dX=0.0;
double Gmob=0.0;
double d_Gmob_dX=0.0;
double Gmob_dL=0.0;
double d_Gmob_dL_dX=0.0;
double Gvsat=0.0;
double d_Gvsat_dX=0.0;
double Gvsatinv=0.0;
double d_Gvsatinv_dX=0.0;
double dps=0.0;
double d_dps_dX=0.0;
double qim=0.0;
double d_qim_dX=0.0;
double qim1=0.0;
double d_qim1_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double H=0.0;
double d_H_dX=0.0;
double Iimpact=0.0;
double d_Iimpact_dX=0.0;
double mavl=0.0;
double d_mavl_dX=0.0;
double Ids=0.0;
double d_Ids_dX=0.0;
double Vdse=0.0;
double d_Vdse_dX=0.0;
double Igsov=0.0;
double d_Igsov_dX=0.0;
double Igdov=0.0;
double d_Igdov_dX=0.0;
double Igcs=0.0;
double d_Igcs_dX=0.0;
double Igcd=0.0;
double d_Igcd_dX=0.0;
double xg=0.0;
double d_xg_dX=0.0;
double sigVds=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double COX_qm=0.0;
double d_COX_qm_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_s=0.0;
double d_ijun_s_dX=0.0;
double ijunbot_s=0.0;
double d_ijunbot_s_dX=0.0;
double ijunsti_s=0.0;
double d_ijunsti_s_dX=0.0;
double ijungat_s=0.0;
double d_ijungat_s_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_d=0.0;
double d_ijun_d_dX=0.0;
double ijunbot_d=0.0;
double d_ijunbot_d_dX=0.0;
double ijunsti_d=0.0;
double d_ijunsti_d_dX=0.0;
double ijungat_d=0.0;
double d_ijungat_d_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjun_s=0.0;
double d_qjun_s_dX=0.0;
double qjunbot_s=0.0;
double d_qjunbot_s_dX=0.0;
double qjunsti_s=0.0;
double d_qjunsti_s_dX=0.0;
double qjungat_s=0.0;
double d_qjungat_s_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjun_d=0.0;
double d_qjun_d_dX=0.0;
double qjunbot_d=0.0;
double d_qjunbot_d_dX=0.0;
double qjunsti_d=0.0;
double d_qjunsti_d_dX=0.0;
double qjungat_d=0.0;
double d_qjungat_d_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double jnoise_s=0.0;
double d_jnoise_s_dX=0.0;
double jnoise_d=0.0;
double d_jnoise_d_dX=0.0;
//End of Block-local variables
//Begin block evaluateStatic
{
d_SP_S_x1_dX = 0.0;
SP_S_x1 = 0.0;
d_x_s_dX = 0.0;
x_s = 0.0;
d_sqm_dX = 0.0;
sqm = 0.0;
d_alpha_dX = 0.0;
alpha = 0.0;
d_eta_p_dX = 0.0;
eta_p = 1.0;
d_xitsb_dX = 0.0;
xitsb = 0.0;
d_rhob_dX = 0.0;
rhob = 0.0;
d_GdL_dX = 0.0;
GdL = 1.0;
d_FdL_dX = 0.0;
FdL = 1.0;
d_Gmob_dX = 0.0;
Gmob = 1.0;
d_Gmob_dL_dX = 0.0;
Gmob_dL = 1.0;
d_Udse_dX = 0.0;
Udse = 0.0;
d_QCLM_dX = 0.0;
QCLM = 0.0;
d_thesat1_dX = 0.0;
thesat1 = 0.0;
d_Gvsat_dX = 0.0;
Gvsat = 1.0;
d_Gvsatinv_dX = 0.0;
Gvsatinv = 1.0;
d_xgm_dX = 0.0;
xgm = 0.0;
d_dps_dX = 0.0;
dps = 0.0;
d_qim_dX = 0.0;
qim = 0.0;
d_qim1_dX = 0.0;
qim1 = 0.0;
d_H_dX = 0.0;
H = 1.0;
d_xs_ov_dX = 0.0;
xs_ov = 0.0;
d_xd_ov_dX = 0.0;
xd_ov = 0.0;
d_Vovs_dX = 0.0;
Vovs = 0.0;
d_Vovd_dX = 0.0;
Vovd = 0.0;
d_Iimpact_dX = 0.0;
Iimpact = 0.0;
d_mavl_dX = 0.0;
mavl = 0.0;
Vrg = (probeVars[admsProbeID_V_G_GP]);
Vrjuns = (probeVars[admsProbeID_V_BS_BI]);
Vrjund = (probeVars[admsProbeID_V_BD_BI]);
Vrbulk = (probeVars[admsProbeID_V_BP_BI]);
Vrwell = (probeVars[admsProbeID_V_B_BI]);
if ((modelStruct.modelVar_CHNL_TYPE==(+1)))
{
Vgs = (probeVars[admsProbeID_V_GP_S]);
Vds = (probeVars[admsProbeID_V_D_S]);
Vsb = (probeVars[admsProbeID_V_S_BP]);
Vjun_s = (-(probeVars[admsProbeID_V_S_BS]));
Vjun_d = (-(probeVars[admsProbeID_V_D_BD]));
}
else
{
Vgs = (-(probeVars[admsProbeID_V_GP_S]));
Vds = (-(probeVars[admsProbeID_V_D_S]));
Vsb = (-(probeVars[admsProbeID_V_S_BP]));
Vjun_s = (probeVars[admsProbeID_V_S_BS]);
Vjun_d = (probeVars[admsProbeID_V_D_BD]);
}
VgsPrime = Vgs;
VsbPrime = Vsb;
VdbPrime = (Vds+Vsb);
VgdPrime = (Vgs-Vds);
d_xgs_ov_dX = (-VgsPrime)*modelStruct.d_modelVar_inv_phit_dX;
xgs_ov = ((-VgsPrime)*modelStruct.modelVar_inv_phit);
d_xgd_ov_dX = (-VgdPrime)*modelStruct.d_modelVar_inv_phit_dX;
xgd_ov = ((-VgdPrime)*modelStruct.modelVar_inv_phit);
sigVds = 1.0;
if ((Vds<0.0))
{
sigVds = (-1.0);
Vgs = (Vgs-Vds);
Vsb = (Vsb+Vds);
Vds = (-Vds);
}
Vgd = (Vgs-Vds);
Vdb = (Vds+Vsb);
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceStruct.instanceVar_bphi));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (0.5*(-deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_dX))+instanceStruct.d_instanceVar_phix_dX);
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceStruct.instanceVar_phix);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+instanceStruct.instanceVar_aphi));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vsbstar_dX = ((-0.5*(d_temp_dX-deriv_sqrt_0_d0*((((temp)*d_temp_dX+d_temp_dX*(temp))+instanceStruct.d_instanceVar_aphi_dX))))+instanceStruct.d_instanceVar_phix1_dX);
Vsbstar = ((Vsb-(0.5*(temp-value_sqrt_0)))+instanceStruct.instanceVar_phix1);
}
d_Vdbstar_dX = d_Vsbstar_dX;
Vdbstar = (Vds+Vsbstar);
d_Vgbstar_dX = d_Vsbstar_dX;
Vgbstar = (Vgs+Vsbstar);
d_Vgb1_dX = (d_Vgbstar_dX-instanceStruct.d_instanceVar_VFB_i_dX);
Vgb1 = (Vgbstar-instanceStruct.instanceVar_VFB_i);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
Vdsx = (value_sqrt_0-0.1);
}
d_Vsbx_dX = d_Vsbstar_dX;
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
d_delVg_dX = (instanceStruct.instanceVar_CF_i*Vdsx*(instanceStruct.instanceVar_CFB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_CFB_i_dX*Vsbx)+instanceStruct.d_instanceVar_CF_i_dX*(Vdsx*(1+(instanceStruct.instanceVar_CFB_i*Vsbx))));
delVg = (instanceStruct.instanceVar_CF_i*(Vdsx*(1+(instanceStruct.instanceVar_CFB_i*Vsbx))));
d_Vgb1_dX = (d_Vgb1_dX+d_delVg_dX);
Vgb1 = (Vgb1+delVg);
d_xg_dX = (Vgb1*instanceStruct.d_instanceVar_inv_phit1_dX+d_Vgb1_dX*instanceStruct.instanceVar_inv_phit1);
xg = (Vgb1*instanceStruct.instanceVar_inv_phit1);
if ((instanceStruct.instanceVar_DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.instanceVar_NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dnsub_dX = ((instanceStruct.instanceVar_DNSUB_i*0.5)*((-instanceStruct.d_instanceVar_VNSUB_i_dX)+deriv_sqrt_0_d0*((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))+(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.d_instanceVar_NSLP_i_dX)))+instanceStruct.d_instanceVar_DNSUB_i_dX*0.5*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
Dnsub = ((instanceStruct.instanceVar_DNSUB_i*0.5)*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gf_dX = (instanceStruct.instanceVar_G_0*deriv_sqrt_0_d0*(d_Dnsub_dX)+instanceStruct.d_instanceVar_G_0_dX*value_sqrt_0);
Gf = (instanceStruct.instanceVar_G_0*value_sqrt_0);
}
}
else
{
d_Gf_dX = instanceStruct.d_instanceVar_G_0_dX;
Gf = instanceStruct.instanceVar_G_0;
}
d_Gf2_dX = (Gf*d_Gf_dX+d_Gf_dX*Gf);
Gf2 = (Gf*Gf);
d_inv_Gf2_dX = (-d_Gf2_dX/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);
d_xi_dX = d_Gf_dX*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));
d_inv_xi_dX = (-d_xi_dX/xi/xi);
inv_xi = (1.0/xi);
d_Ux_dX = (Vsbstar*instanceStruct.d_instanceVar_inv_phit1_dX+d_Vsbstar_dX*instanceStruct.instanceVar_inv_phit1);
Ux = (Vsbstar*instanceStruct.instanceVar_inv_phit1);
d_xn_s_dX = ((instanceStruct.instanceVar_phib*instanceStruct.d_instanceVar_inv_phit1_dX+instanceStruct.d_instanceVar_phib_dX*instanceStruct.instanceVar_inv_phit1)+d_Ux_dX);
xn_s = ((instanceStruct.instanceVar_phib*instanceStruct.instanceVar_inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_ns_dX = deriv_exp_0_d0*((-d_xn_s_dX));
delta_ns = value_exp_0;
}
}
else
{
d_delta_ns_dX = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dX*3.3333333333333333e-01+d_xn_s_dX*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dX*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_margin_dX = 1e-5*d_xi_dX;
margin = (1e-5*xi);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_s_dX = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_ns))*d_Gf_dX+(xg*(-d_delta_ns_dX)+d_xg_dX*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{
d_SP_S_yg_dX = (-d_xg_dX);
SP_S_yg = (-xg);
d_SP_S_ysub_dX = 1.25*(SP_S_yg*d_inv_xi_dX+d_SP_S_yg_dX*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_eta_dX = 0.5*(d_SP_S_ysub_dX-deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dX+d_SP_S_ysub_dX*(SP_S_ysub-6.0))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_eta_dX);
SP_S_temp = (SP_S_yg-SP_S_eta);
d_SP_S_a_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)+(Gf2*d_SP_S_eta_dX+d_Gf2_dX*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX-d_Gf2_dX);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));
d_SP_S_tau_dX = ((-d_SP_S_eta_dX)+deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dX+d_SP_S_a_dX*inv_Gf2)));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-d_SP_S_a_dX)+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_SP_S_y0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dX)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_y0_dX);
SP_S_delta0 = value_exp_0;
}
}
else
{
d_SP_S_delta0_dX = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dX*3.3333333333333333e-01+d_SP_S_y0_dX*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dX*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_temp_dX = (-(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_xi0_dX = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_temp_dX+d_SP_S_y0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_y0_dX);
SP_S_temp = (SP_S_yg-SP_S_y0);
d_SP_S_temp1_dX = (delta_ns*d_SP_S_delta1_dX+d_delta_ns_dX*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*((d_SP_S_delta0_dX-d_SP_S_temp1_dX)+(delta_ns*(-d_SP_S_xi1_dX)+d_delta_ns_dX*(1.0-SP_S_xi1)))+d_Gf2_dX*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dX-d_SP_S_y0_dX)+d_SP_S_temp1_dX)+(delta_ns*(d_SP_S_y0_dX-d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta0_dX+d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = ((-d_SP_S_y0_dX)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{
d_SP_xg1_dX = (-d_Gf_dX*7.324648775608221e-001/(instanceStruct.instanceVar_x1+(Gf*7.324648775608221e-001))/(instanceStruct.instanceVar_x1+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(instanceStruct.instanceVar_x1+(Gf*7.324648775608221e-001)));
d_SP_S_A_fac_dX = ((((xi*instanceStruct.instanceVar_x1)*SP_xg1)-1.0)*d_SP_xg1_dX+((xi*instanceStruct.instanceVar_x1)*d_SP_xg1_dX+d_xi_dX*instanceStruct.instanceVar_x1*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*instanceStruct.instanceVar_x1)*SP_xg1)-1.0)*SP_xg1);
d_SP_S_xbar_dX = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dX+d_SP_S_A_fac_dX*xg)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp_dX = deriv_exp_0_d0*((-d_SP_S_xbar_dX));
SP_S_temp = value_exp_0;
}
}
else
{
d_SP_S_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dX))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}
d_SP_S_w_dX = (-d_SP_S_temp_dX);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_x1_dX = ((d_xg_dX+d_Gf2_dX*0.5)-(Gf*deriv_sqrt_0_d0*(((d_xg_dX+d_Gf2_dX*0.25)-d_SP_S_w_dX))+d_Gf_dX*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}
d_SP_S_bx_dX = d_xn_s_dX;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_ns*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_s_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_ns*d_SP_S_delta0_dX+d_delta_ns_dX*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_s_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_ns_dX-delta_ns*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_ns*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}
d_x_d_dX = d_x_s_dX;
x_d = x_s;
d_x_m_dX = d_x_s_dX;
x_m = x_s;
d_x_ds_dX = 0.0;
x_ds = 0.0;
if ((xg<=0.0))
{
d_qis_dX = 0.0;
qis = 0.0;
d_Ids_dX = 0.0;
Ids = 0.0;
d_xgm_dX = (d_xg_dX-d_x_s_dX);
xgm = (xg-x_s);
d_Voxm_dX = (xgm*instanceStruct.d_instanceVar_phit1_dX+d_xgm_dX*instanceStruct.instanceVar_phit1);
Voxm = (xgm*instanceStruct.instanceVar_phit1);
d_qeff_dX = d_Voxm_dX;
qeff = Voxm;
d_Vdsat_dX = instanceStruct.d_instanceVar_Vdsat_lim_dX;
Vdsat = instanceStruct.instanceVar_Vdsat_lim;
d_Vdse_dX = 0.0;
Vdse = Vds;
}
else
{
d_delta_1s_dX = 0.0;
delta_1s = 0.0;
d_temp_dX = (-(x_s*d_x_s_dX+d_x_s_dX*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));
d_xi0s_dX = ((x_s*x_s)*d_temp_dX+(x_s*d_x_s_dX+d_x_s_dX*x_s)*temp);
xi0s = ((x_s*x_s)*temp);
d_xi1s_dX = 4.0*((x_s*temp)*d_temp_dX+(x_s*d_temp_dX+d_x_s_dX*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));
d_xi2s_dX = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dX+(((8.0*temp)-(12.0*xi0s))*d_temp_dX+(8.0*d_temp_dX-12.0*d_xi0s_dX)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*(d_x_s_dX);
delta_1s = value_exp_0;
}
d_Es_dX = (-d_delta_1s_dX/delta_1s/delta_1s);
Es = (1.0/delta_1s);
d_delta_1s_dX = (delta_ns*d_delta_1s_dX+d_delta_ns_dX*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*((d_x_s_dX-d_xn_s_dX));
delta_1s = value_exp_0;
}
d_Es_dX = ((delta_1s*d_delta_ns_dX-delta_ns*d_delta_1s_dX)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{
d_delta_1s_dX = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dX-d_x_s_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_x_s_dX)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_x_s_dX)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dX = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dX*3.3333333333333333e-01+d_x_s_dX*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dX*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Ds_dX = (d_delta_1s_dX-(delta_ns*(d_x_s_dX+d_xi0s_dX)+d_delta_ns_dX*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{
d_Ps_dX = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s))))+(x_s*d_x_s_dX+d_x_s_dX*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
d_Ds_dX = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dX+(((delta_ns*x_s)*x_s)*d_x_s_dX+((delta_ns*x_s)*d_x_s_dX+(delta_ns*d_x_s_dX+d_delta_ns_dX*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_s*d_temp_dX+d_x_s_dX*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));
d_alpha_dX = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dX)+1.6666666666666667e-01*(x_s*d_x_s_dX+d_x_s_dX*x_s))+d_Gf_dX*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dX)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{
d_Ps_dX = (d_x_s_dX+d_Es_dX);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Ps_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = 0.5*((sqm*(Gf*(-d_Es_dX)+d_Gf_dX*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dX)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}
d_Em_dX = d_Es_dX;
Em = Es;
d_Ed_dX = d_Em_dX;
Ed = Em;
d_Dm_dX = d_Ds_dX;
Dm = Ds;
d_Dd_dX = d_Dm_dX;
Dd = Dm;
d_Rxcor_dX = (((1.0+(instanceStruct.instanceVar_XCOR_i*Vsbx))*((0.2*instanceStruct.instanceVar_XCOR_i)*d_Vsbx_dX+0.2*instanceStruct.d_instanceVar_XCOR_i_dX*Vsbx)-(1.0+((0.2*instanceStruct.instanceVar_XCOR_i)*Vsbx))*(instanceStruct.instanceVar_XCOR_i*d_Vsbx_dX+instanceStruct.d_instanceVar_XCOR_i_dX*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_i*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_i*Vsbx)));
Rxcor = ((1.0+((0.2*instanceStruct.instanceVar_XCOR_i)*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_i*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgs_dX = (Gf*deriv_sqrt_0_d0*((d_Ps_dX+d_Ds_dX))+d_Gf_dX*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}
d_qis_dX = (((xgs+(Gf*sqm))*((Gf2*Ds)*instanceStruct.d_instanceVar_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*instanceStruct.instanceVar_phit1)-((Gf2*Ds)*instanceStruct.instanceVar_phit1)*(d_xgs_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*instanceStruct.instanceVar_phit1)/(xgs+(Gf*sqm)));
d_qbs_dX = ((sqm*Gf)*instanceStruct.d_instanceVar_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*instanceStruct.instanceVar_phit1);
qbs = ((sqm*Gf)*instanceStruct.instanceVar_phit1);
if ((instanceStruct.instanceVar_RSB_i<0))
{
d_rhob_dX = (-(-(instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
rhob = (1.0/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
}
else
{
d_rhob_dX = (instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx);
rhob = (1.0+(instanceStruct.instanceVar_RSB_i*Vsbx));
}
if ((instanceStruct.instanceVar_RSG_i<0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qis));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis)/(1.0+(instanceStruct.instanceVar_RSG_i*qis))/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qis_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qis)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qis));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qis));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*(d_qbs_dX+(instanceStruct.instanceVar_eta_mu*d_qis_dX+instanceStruct.d_instanceVar_eta_mu_dX*qis))+instanceStruct.d_instanceVar_E_eff0_dX*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
Eeffm = (instanceStruct.instanceVar_E_eff0*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_i),instanceStruct.instanceVar_THEMU_i);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_i) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_i/(Eeffm*instanceStruct.instanceVar_MUE_i)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_i) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_i))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_i_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_i)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_i_dX)))+(instanceStruct.instanceVar_CS_i*((((Ps+Ds)+1.0e-14)*d_Ps_dX-Ps*(d_Ps_dX+d_Ds_dX))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+instanceStruct.d_instanceVar_CS_i_dX*(Ps/((Ps+Ds)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_i*(Ps/((Ps+Ds)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((instanceStruct.instanceVar_THESATB_i<0))
{
d_xitsb_dX = (-(-(instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
}
else
{
d_xitsb_dX = (instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx);
xitsb = (1.0+(instanceStruct.instanceVar_THESATB_i*Vsbx));
}
d_temp2_dX = (qis*d_xitsb_dX+d_qis_dX*xitsb);
temp2 = (qis*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((instanceStruct.instanceVar_THESATG_i<0))
{
d_temp_dX = (-1*(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1-(instanceStruct.instanceVar_THESATG_i*wsat))/(1-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1/(1-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_i*((Gmob*d_temp_dX-temp*d_Gmob_dX)/Gmob/Gmob)+instanceStruct.d_instanceVar_THESAT_i_dX*(temp/Gmob));
thesat1 = (instanceStruct.instanceVar_THESAT_i*(temp/Gmob));
d_phi_inf_dX = (((alpha*d_qis_dX-qis*d_alpha_dX)/alpha/alpha)+instanceStruct.d_instanceVar_phit1_dX);
phi_inf = ((qis/alpha)+instanceStruct.instanceVar_phit1);
d_ysat_dX = (thesat1*d_phi_inf_dX+d_thesat1_dX*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ysat_dX = ((value_sqrt_0*d_ysat_dX-ysat*deriv_sqrt_0_d0*(d_ysat_dX))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_za_dX = (-2.0*deriv_sqrt_0_d0*(4.0*d_ysat_dX)/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}
d_temp1_dX = (za*d_ysat_dX+d_za_dX*ysat);
temp1 = (za*ysat);
d_Phi_0_dX = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dX+d_temp1_dX*za))+d_temp1_dX*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dX+(temp1*d_temp1_dX+d_temp1_dX*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dX+d_phi_inf_dX*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_asat_dX = (d_xgs_dX+0.5*d_Gf2_dX);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_2_dX = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*instanceStruct.d_instanceVar_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*instanceStruct.instanceVar_phit1)-((Gf2*Ds)*instanceStruct.instanceVar_phit1)*(d_asat_dX+deriv_sqrt_0_d0*(((asat*d_asat_dX+d_asat_dX*asat)-(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*0.98))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*instanceStruct.instanceVar_phit1)/(asat+value_sqrt_0)));
}
d_Phi_0_2_dX = (d_Phi_0_dX+d_Phi_2_dX);
Phi_0_2 = (Phi_0+Phi_2);
d_Phi0_Phi2_dX = 2.0*(Phi_0*d_Phi_2_dX+d_Phi_0_dX*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_sat_dX = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dX-Phi0_Phi2*(d_Phi_0_2_dX+deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dX+d_Phi_0_2_dX*Phi_0_2)-1.98*d_Phi0_Phi2_dX))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*instanceStruct.instanceVar_phit1)))*inv_Gf2)/((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*instanceStruct.instanceVar_phit1)))*inv_Gf2)/((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*Ds))));
d_Vdsat_dX = (d_Phi_sat_dX-(instanceStruct.instanceVar_phit1*deriv_log_0_d0*(((((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*instanceStruct.instanceVar_phit1)))*d_inv_Gf2_dX+(Phi_sat*(d_Phi_sat_dX-((2.0*asat)*instanceStruct.d_instanceVar_phit1_dX+2.0*d_asat_dX*instanceStruct.instanceVar_phit1))+d_Phi_sat_dX*(Phi_sat-((2.0*asat)*instanceStruct.instanceVar_phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*instanceStruct.instanceVar_phit1)))*inv_Gf2)*((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*d_Ds_dX+(instanceStruct.instanceVar_phit1*instanceStruct.d_instanceVar_phit1_dX+instanceStruct.d_instanceVar_phit1_dX*instanceStruct.instanceVar_phit1)*Ds))/((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*Ds)/((instanceStruct.instanceVar_phit1*instanceStruct.instanceVar_phit1)*Ds)))+instanceStruct.d_instanceVar_phit1_dX*value_log_0));
Vdsat = (Phi_sat-(instanceStruct.instanceVar_phit1*value_log_0));
}
}
else
{
d_Vdsat_dX = instanceStruct.d_instanceVar_Vdsat_lim_dX;
Vdsat = instanceStruct.instanceVar_Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),instanceStruct.instanceVar_AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_AX_i/(Vds/Vdsat)));
double  deriv_pow_0_d1 = ((Vds/Vdsat) == 0.0)?0.0:(log((Vds/Vdsat))*value_pow_0);
d_temp_dX = ((deriv_pow_0_d0*((-Vds*d_Vdsat_dX/Vdsat/Vdsat)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_AX_i_dX)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-instanceStruct.instanceVar_inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_inv_AX)/(1.0+temp)));
double  deriv_pow_0_d1 = ((1.0+temp) == 0.0)?0.0:(log((1.0+temp))*value_pow_0);
d_Vdse_dX = Vds*((deriv_pow_0_d0*(d_temp_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_inv_AX_dX))));
Vdse = (Vds*value_pow_0);
}
d_Udse_dX = (Vdse*instanceStruct.d_instanceVar_inv_phit1_dX+d_Vdse_dX*instanceStruct.instanceVar_inv_phit1);
Udse = (Vdse*instanceStruct.instanceVar_inv_phit1);
d_xn_d_dX = (d_xn_s_dX+d_Udse_dX);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;
d_k_ds_dX = deriv_exp_0_d0*((-d_Udse_dX));
k_ds = value_exp_0;
}
}
else
{
d_k_ds_dX = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dX*3.3333333333333333e-01+d_Udse_dX*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dX*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_delta_nd_dX = (delta_ns*d_k_ds_dX+d_delta_ns_dX*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_d_dX = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_nd))*d_Gf_dX+(xg*(-d_delta_nd_dX)+d_xg_dX*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{
d_SP_S_bx_dX = d_xn_d_dX;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_nd*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_d_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_nd*d_SP_S_delta0_dX+d_delta_nd_dX*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_d_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_nd_dX-delta_nd*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_nd*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_d_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
d_x_ds_dX = (d_x_d_dX-d_x_s_dX);
x_ds = (x_d-x_s);
if ((x_ds<1.0E-10))
{
d_pC_dX = (2.0*(d_xg_dX-d_x_s_dX)+(Gf2*(((-d_Es_dX)+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi1s_dX+d_delta_nd_dX*(1.0+xi1s)))+d_Gf2_dX*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_qC_dX = ((Gf2*(1.0-k_ds))*d_Ds_dX+(Gf2*(-d_k_ds_dX)+d_Gf2_dX*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);
d_temp_dX = (-(Gf2*((d_Es_dX+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi2s_dX+d_delta_nd_dX*xi2s))+d_Gf2_dX*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dX = ((pC*d_pC_dX+d_pC_dX*pC)-2.0*(temp*d_qC_dX+d_temp_dX*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_ds_dX = 2.0*(((pC+value_sqrt_0)*d_qC_dX-qC*(d_pC_dX+deriv_sqrt_0_d0*(d_temp_dX)))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}
d_x_d_dX = (d_x_s_dX+d_x_ds_dX);
x_d = (x_s+x_ds);
}
d_dps_dX = (x_ds*instanceStruct.d_instanceVar_phit1_dX+d_x_ds_dX*instanceStruct.instanceVar_phit1);
dps = (x_ds*instanceStruct.instanceVar_phit1);
d_xi0d_dX = (((2.0+(x_d*x_d))*(x_d*d_x_d_dX+d_x_d_dX*x_d)-(x_d*x_d)*(x_d*d_x_d_dX+d_x_d_dX*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;
d_Ed_dX = deriv_exp_0_d0*((-d_x_d_dX));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{
d_Dd_dX = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dX+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dX+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dX+((1.6666666666666667e-01*delta_nd)*d_x_d_dX+1.6666666666666667e-01*d_delta_nd_dX*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{
d_Dd_dX = (delta_nd*(((-d_Ed_dX/Ed/Ed)-d_x_d_dX)-d_xi0d_dX)+d_delta_nd_dX*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((d_x_d_dX-d_xn_d_dX));
temp = value_exp_0;
}
d_Ed_dX = ((temp*d_delta_nd_dX-delta_nd*d_temp_dX)/temp/temp);
Ed = (delta_nd/temp);
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{
d_Ed_dX = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dX*3.3333333333333333e-01+d_x_d_dX*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dX*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dX = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dX-d_x_d_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_x_d_dX)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_x_d_dX)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}
d_x_m_dX = 0.5*(d_x_s_dX+d_x_d_dX);
x_m = (0.5*(x_s+x_d));
d_Em_dX = 0.0;
Em = 0.0;
d_temp_dX = (Ed*d_Es_dX+d_Ed_dX*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Em_dX = deriv_sqrt_0_d0*(d_temp_dX);
Em = value_sqrt_0;
}
}
d_D_bar_dX = 0.5*(d_Ds_dX+d_Dd_dX);
D_bar = (0.5*(Ds+Dd));
d_Dm_dX = (d_D_bar_dX+0.125*((x_ds*x_ds)*(d_Em_dX-2.0*d_inv_Gf2_dX)+(x_ds*d_x_ds_dX+d_x_ds_dX*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{
d_Pm_dX = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m))))+(x_m*d_x_m_dX+d_x_m_dX*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_m*d_temp_dX+d_x_m_dX*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));
d_alpha_dX = (d_eta_p_dX+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dX)+1.6666666666666667e-01*(x_m*d_x_m_dX+d_x_m_dX*x_m))+d_Gf_dX*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dX)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
d_d0_dX = ((-d_Em_dX)+2.0*(xgm*d_inv_Gf2_dX+d_xgm_dX*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
d_temp_dX = (((eta_p+1.0)*d_eta_p_dX-eta_p*d_eta_p_dX)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));
d_x_pm_dX = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*d_Dm_dX+((temp*temp)*d_Gf2_dX+(temp*d_temp_dX+d_temp_dX*temp)*Gf2)*Dm)+instanceStruct.d_instanceVar_kp_dX*(((temp*temp)*Gf2)*Dm));
x_pm = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*Dm));
d_p_pd_dX = (2.0*(d_xgm_dX-d_x_pm_dX)+(Gf2*((-d_Em_dX)+d_Dm_dX)+d_Gf2_dX*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
d_q_pd_dX = (x_pm*(d_x_pm_dX-2.0*d_xgm_dX)+d_x_pm_dX*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));
d_xi_pd_dX = (-0.5*(Gf2*(d_Em_dX+d_Dm_dX)+d_Gf2_dX*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
d_u_pd_dX = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dX+d_q_pd_dX*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dX+d_p_pd_dX*p_pd)-(xi_pd*d_q_pd_dX+d_xi_pd_dX*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
d_x_m_dX = (d_x_m_dX+d_u_pd_dX);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;
d_km_dX = deriv_exp_0_d0*(d_u_pd_dX);
km = value_exp_0;
}
d_Em_dX = ((km*d_Em_dX-Em*d_km_dX)/km/km);
Em = (Em/km);
d_Dm_dX = (Dm*d_km_dX+d_Dm_dX*km);
Dm = (Dm*km);
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
d_help_dX = ((-d_Em_dX)+2.0*((xgm*eta_p)*d_inv_Gf2_dX+(xgm*d_eta_p_dX+d_xgm_dX*eta_p)*inv_Gf2));
help = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
d_x_ds_dX = (((help+(km*D_bar))*((x_ds*km)*(d_d0_dX+d_D_bar_dX)+(x_ds*d_km_dX+d_x_ds_dX*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_help_dX+(km*d_D_bar_dX+d_km_dX*D_bar)))/(help+(km*D_bar))/(help+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(help+(km*D_bar)));
d_dps_dX = (x_ds*instanceStruct.d_instanceVar_phit1_dX+d_x_ds_dX*instanceStruct.instanceVar_phit1);
dps = (x_ds*instanceStruct.instanceVar_phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Pm_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = (d_eta_p_dX+0.5*((sqm*(Gf*(-d_Em_dX)+d_Gf_dX*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dX)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}
d_qim_dX = (instanceStruct.instanceVar_phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dX+d_Gf2_dX*Dm)-(Gf2*Dm)*(d_xgm_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+instanceStruct.d_instanceVar_phit1_dX*((Gf2*Dm)/(xgm+(Gf*sqm))));
qim = (instanceStruct.instanceVar_phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim1_dX = (d_qim_dX+(instanceStruct.instanceVar_phit1*d_alpha_dX+instanceStruct.d_instanceVar_phit1_dX*alpha));
qim1 = (qim+(instanceStruct.instanceVar_phit1*alpha));
d_qim1_1_dX = (-d_qim1_dX/qim1/qim1);
qim1_1 = (1.0/qim1);
d_qbm_dX = ((sqm*Gf)*instanceStruct.d_instanceVar_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*instanceStruct.instanceVar_phit1);
qbm = ((sqm*Gf)*instanceStruct.instanceVar_phit1);
if ((instanceStruct.instanceVar_RSG_i<0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qim));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim)/(1.0+(instanceStruct.instanceVar_RSG_i*qim))/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qim_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qim)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qim));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qim));
d_qeff_dX = (d_qbm_dX+(instanceStruct.instanceVar_eta_mu*d_qim_dX+instanceStruct.d_instanceVar_eta_mu_dX*qim));
qeff = (qbm+(instanceStruct.instanceVar_eta_mu*qim));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*d_qeff_dX+instanceStruct.d_instanceVar_E_eff0_dX*qeff);
Eeffm = (instanceStruct.instanceVar_E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_i),instanceStruct.instanceVar_THEMU_i);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_i) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_i/(Eeffm*instanceStruct.instanceVar_MUE_i)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_i) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_i))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_i_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_i)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_i_dX)))+(instanceStruct.instanceVar_CS_i*((((Pm+Dm)+1.0e-14)*d_Pm_dX-Pm*(d_Pm_dX+d_Dm_dX))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+instanceStruct.d_instanceVar_CS_i_dX*(Pm/((Pm+Dm)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_i*(Pm/((Pm+Dm)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
d_r1_dX = (qim*d_qim1_1_dX+d_qim_dX*qim1_1);
r1 = (qim*qim1_1);
d_r2_dX = (instanceStruct.instanceVar_phit1*(alpha*d_qim1_1_dX+d_alpha_dX*qim1_1)+instanceStruct.d_instanceVar_phit1_dX*(alpha*qim1_1));
r2 = (instanceStruct.instanceVar_phit1*(alpha*qim1_1));
{
double value_log_0 = log(((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
d_temp_dX = deriv_log_0_d0*((((1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))*((Vds-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(-d_dps_dX)*instanceStruct.instanceVar_inv_VP)-(1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))*((Vdse-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(d_Vdse_dX-d_dps_dX)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
temp = value_log_0;
}
{
double value_log_0 = log((1.0+(Vdsx*instanceStruct.instanceVar_inv_VP)));
double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*instanceStruct.instanceVar_inv_VP)));
d_temp1_dX = deriv_log_0_d0*(Vdsx*instanceStruct.d_instanceVar_inv_VP_dX);
temp1 = value_log_0;
}
d_dL_dX = (instanceStruct.instanceVar_ALP_i*d_temp_dX+instanceStruct.d_instanceVar_ALP_i_dX*temp);
dL = (instanceStruct.instanceVar_ALP_i*temp);
d_GdL_dX = (-(d_dL_dX+(dL*d_dL_dX+d_dL_dX*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));
d_dL1_dX = ((d_dL_dX+(instanceStruct.instanceVar_ALP1_i*((qim1_1*r1)*d_temp_dX+(qim1_1*d_r1_dX+d_qim1_1_dX*r1)*temp)+instanceStruct.d_instanceVar_ALP1_i_dX*((qim1_1*r1)*temp)))+(instanceStruct.instanceVar_ALP2_i*(((qbm*r2)*r2)*d_temp1_dX+((qbm*r2)*d_r2_dX+(qbm*d_r2_dX+d_qbm_dX*r2)*r2)*temp1)+instanceStruct.d_instanceVar_ALP2_i_dX*(((qbm*r2)*r2)*temp1)));
dL1 = ((dL+(instanceStruct.instanceVar_ALP1_i*((qim1_1*r1)*temp)))+(instanceStruct.instanceVar_ALP2_i*(((qbm*r2)*r2)*temp1)));
d_FdL_dX = (((1.0+dL1)+(dL1*dL1))*d_GdL_dX+(d_dL1_dX+(dL1*d_dL1_dX+d_dL1_dX*dL1))*GdL);
FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
d_temp2_dX = (qim*d_xitsb_dX+d_qim_dX*xitsb);
temp2 = (qim*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
d_Gmob_dL_dX = (Gmob*d_GdL_dX+d_Gmob_dX*GdL);
Gmob_dL = (Gmob*GdL);
if ((instanceStruct.instanceVar_THESATG_i<0))
{
d_temp_dX = (-1*(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1-(instanceStruct.instanceVar_THESATG_i*wsat))/(1-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1/(1-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_i*((Gmob_dL*d_temp_dX-temp*d_Gmob_dL_dX)/Gmob_dL/Gmob_dL)+instanceStruct.d_instanceVar_THESAT_i_dX*(temp/Gmob_dL));
thesat1 = (instanceStruct.instanceVar_THESAT_i*(temp/Gmob_dL));
d_zsat_dX = (((thesat1*thesat1)*dps)*d_dps_dX+((thesat1*thesat1)*d_dps_dX+(thesat1*d_thesat1_dX+d_thesat1_dX*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
d_zsat_dX = (((1.0+(thesat1*dps))*d_zsat_dX-zsat*(thesat1*d_dps_dX+d_thesat1_dX*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gvsat_dX = 0.5*(Gmob_dL*deriv_sqrt_0_d0*(2.0*d_zsat_dX)+d_Gmob_dL_dX*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}
d_Gvsatinv_dX = (-d_Gvsat_dX/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);
d_Ids_dX = (instanceStruct.instanceVar_BET_i*(((FdL*qim1)*dps)*d_Gvsatinv_dX+((FdL*qim1)*d_dps_dX+(FdL*d_qim1_dX+d_FdL_dX*qim1)*dps)*Gvsatinv)+instanceStruct.d_instanceVar_BET_i_dX*(((FdL*qim1)*dps)*Gvsatinv));
Ids = (instanceStruct.instanceVar_BET_i*(((FdL*qim1)*dps)*Gvsatinv));
d_Voxm_dX = (xgm*instanceStruct.d_instanceVar_phit1_dX+d_xgm_dX*instanceStruct.instanceVar_phit1);
Voxm = (xgm*instanceStruct.instanceVar_phit1);
d_temp_dX = (Gmob_dL*d_Gvsatinv_dX+d_Gmob_dL_dX*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);
d_alpha1_dX = (alpha*0.5*((zsat*temp)*d_temp_dX+(zsat*d_temp_dX+d_zsat_dX*temp)*temp)+d_alpha_dX*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
d_H_dX = ((alpha1*(temp*d_qim1_dX+d_temp_dX*qim1)-(temp*qim1)*d_alpha1_dX)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
if ((modelStruct.modelPar_SWIMPACT!=0))
{
d_delVsat_dX = (-(instanceStruct.instanceVar_A3_i*d_dps_dX+instanceStruct.d_instanceVar_A3_i_dX*dps));
delVsat = (Vds-(instanceStruct.instanceVar_A3_i*dps));
if ((delVsat>0))
{
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_phib+Vsbstar));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp2_dX = (instanceStruct.instanceVar_A2_i*(((delVsat+1e-30)*(instanceStruct.instanceVar_A4_i*(deriv_sqrt_0_d0*((instanceStruct.d_instanceVar_phib_dX+d_Vsbstar_dX))-instanceStruct.d_instanceVar_sqrt_phib_dX)+instanceStruct.d_instanceVar_A4_i_dX*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib))-(1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib)))*d_delVsat_dX)/(delVsat+1e-30)/(delVsat+1e-30))+instanceStruct.d_instanceVar_A2_i_dX*((1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib)))/(delVsat+1e-30)));
temp2 = (instanceStruct.instanceVar_A2_i*((1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib)))/(delVsat+1e-30)));
}
if ((fabs((-temp2))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-temp2));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((-d_temp2_dX));
temp = value_exp_0;
}
}
else
{
if (((-temp2)<(-2.3025850929940458e+02)))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dX))*3.3333333333333333e-01+(-(-d_temp2_dX))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dX)*3.3333333333333333e-01+(-d_temp2_dX)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dX)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_mavl_dX = (instanceStruct.instanceVar_A1_i*(delVsat*d_temp_dX+d_delVsat_dX*temp)+instanceStruct.d_instanceVar_A1_i_dX*(delVsat*temp));
mavl = (instanceStruct.instanceVar_A1_i*(delVsat*temp));
d_Iimpact_dX = (Ids*d_mavl_dX+d_Ids_dX*mavl);
Iimpact = (Ids*mavl);
}
}
}
if ((((((modelStruct.modelPar_SWIGATE!=0)&&((instanceStruct.instanceVar_IGOV_i>0)||(instanceStruct.instanceVar_IGOVD_i>0)))||((modelStruct.modelPar_SWGIDL!=0)&&((instanceStruct.instanceVar_AGIDL_i>0)||(instanceStruct.instanceVar_AGIDLD_i>0))))||(instanceStruct.instanceVar_CGOV_i>0))||(instanceStruct.instanceVar_CGOVD_i>0)))
{
d_GOV_dX = instanceStruct.d_instanceVar_GOV_s_dX;
GOV = instanceStruct.instanceVar_GOV_s;
d_GOV2_dX = instanceStruct.d_instanceVar_GOV2_s_dX;
GOV2 = instanceStruct.instanceVar_GOV2_s;
d_xi_ov_dX = instanceStruct.d_instanceVar_xi_ov_s_dX;
xi_ov = instanceStruct.instanceVar_xi_ov_s;
d_inv_xi_ov_dX = instanceStruct.d_instanceVar_inv_xi_ov_s_dX;
inv_xi_ov = instanceStruct.instanceVar_inv_xi_ov_s;
d_x_mrg_ov_dX = instanceStruct.d_instanceVar_x_mrg_ov_s_dX;
x_mrg_ov = instanceStruct.instanceVar_x_mrg_ov_s;
d_inv_xg1_dX = instanceStruct.d_instanceVar_inv_xg1_s_dX;
inv_xg1 = instanceStruct.instanceVar_inv_xg1_s;
if ((fabs(xgs_ov)<=x_mrg_ov))
{
d_xs_ov_dX = ((-xgs_ov)*d_inv_xi_ov_dX+(-d_xgs_ov_dX)*inv_xi_ov);
xs_ov = ((-xgs_ov)*inv_xi_ov);
}
else
{
if ((xgs_ov<(-x_mrg_ov)))
{
d_SP_OV_yg_dX = (-d_xgs_ov_dX);
SP_OV_yg = (-xgs_ov);
d_SP_OV_z_dX = ((instanceStruct.instanceVar_x1*SP_OV_yg)*d_inv_xi_ov_dX+instanceStruct.instanceVar_x1*d_SP_OV_yg_dX*inv_xi_ov);
SP_OV_z = ((instanceStruct.instanceVar_x1*SP_OV_yg)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dX-d_SP_OV_eta_dX)+(d_SP_OV_yg_dX-d_SP_OV_eta_dX)*(SP_OV_yg-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_yg_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
nu = (SP_OV_a+SP_OV_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dX+(SP_OV_a*d_nu_dX+d_SP_OV_a_dX*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dX+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dX)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((nu/mutau)*d_SP_OV_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
d_SP_OV_temp_dX = (d_SP_OV_yg_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_yg-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dX-SP_OV_q*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}
d_xs_ov_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xs_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*instanceStruct.instanceVar_x1)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*instanceStruct.instanceVar_x1)*d_inv_xg1_dX+d_xi_ov_dX*instanceStruct.instanceVar_x1*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*instanceStruct.instanceVar_x1)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgs_ov*inv_xi_ov)*(SP_OV_Afac*d_xgs_ov_dX+d_SP_OV_Afac_dX*xgs_ov)+(xgs_ov*d_inv_xi_ov_dX+d_xgs_ov_dX*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
SP_OV_xbar = ((xgs_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgs_ov)));
if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
d_SP_OV_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-d_SP_OV_xbar_dX))*3.3333333333333333e-01+(-(-d_SP_OV_xbar_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(-(-d_SP_OV_xbar_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgs_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = ((d_xgs_ov_dX+d_GOV2_dX*0.5)-(GOV*deriv_sqrt_0_d0*(((d_xgs_ov_dX+d_GOV2_dX*0.25)-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgs_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
d_SP_OV_D0_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dX))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
}
d_SP_OV_p_dX = (2.0*(d_xgs_ov_dX-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgs_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgs_ov-SP_OV_x0)*(d_xgs_ov_dX-d_SP_OV_x0_dX)+(d_xgs_ov_dX-d_SP_OV_x0_dX)*(xgs_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgs_ov-SP_OV_x0)*(xgs_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dX-SP_OV_q*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}
d_xs_ov_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xs_ov = (SP_OV_x0+SP_OV_u);
}
d_xs_ov_dX = (-d_xs_ov_dX);
xs_ov = (-xs_ov);
}
d_GOV_dX = instanceStruct.d_instanceVar_GOV_d_dX;
GOV = instanceStruct.instanceVar_GOV_d;
d_GOV2_dX = instanceStruct.d_instanceVar_GOV2_d_dX;
GOV2 = instanceStruct.instanceVar_GOV2_d;
d_xi_ov_dX = instanceStruct.d_instanceVar_xi_ov_d_dX;
xi_ov = instanceStruct.instanceVar_xi_ov_d;
d_inv_xi_ov_dX = instanceStruct.d_instanceVar_inv_xi_ov_d_dX;
inv_xi_ov = instanceStruct.instanceVar_inv_xi_ov_d;
d_x_mrg_ov_dX = instanceStruct.d_instanceVar_x_mrg_ov_d_dX;
x_mrg_ov = instanceStruct.instanceVar_x_mrg_ov_d;
d_inv_xg1_dX = instanceStruct.d_instanceVar_inv_xg1_d_dX;
inv_xg1 = instanceStruct.instanceVar_inv_xg1_d;
if ((fabs(xgd_ov)<=x_mrg_ov))
{
d_xd_ov_dX = ((-xgd_ov)*d_inv_xi_ov_dX+(-d_xgd_ov_dX)*inv_xi_ov);
xd_ov = ((-xgd_ov)*inv_xi_ov);
}
else
{
if ((xgd_ov<(-x_mrg_ov)))
{
d_SP_OV_yg_dX = (-d_xgd_ov_dX);
SP_OV_yg = (-xgd_ov);
d_SP_OV_z_dX = ((instanceStruct.instanceVar_x1*SP_OV_yg)*d_inv_xi_ov_dX+instanceStruct.instanceVar_x1*d_SP_OV_yg_dX*inv_xi_ov);
SP_OV_z = ((instanceStruct.instanceVar_x1*SP_OV_yg)*inv_xi_ov);
{
double value_sqrt_0 = sqrt((((SP_OV_z-6.0)*(SP_OV_z-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_eta_dX = 0.5*(d_SP_OV_z_dX-deriv_sqrt_0_d0*(((SP_OV_z-6.0)*d_SP_OV_z_dX+d_SP_OV_z_dX*(SP_OV_z-6.0))));
SP_OV_eta = (0.5*((SP_OV_z+10.0)-value_sqrt_0));
}
d_SP_OV_a_dX = (((SP_OV_yg-SP_OV_eta)*(d_SP_OV_yg_dX-d_SP_OV_eta_dX)+(d_SP_OV_yg_dX-d_SP_OV_eta_dX)*(SP_OV_yg-SP_OV_eta))+(GOV2*d_SP_OV_eta_dX+d_GOV2_dX*(SP_OV_eta+1.0)));
SP_OV_a = (((SP_OV_yg-SP_OV_eta)*(SP_OV_yg-SP_OV_eta))+(GOV2*(SP_OV_eta+1.0)));
d_SP_OV_c_dX = (2.0*(d_SP_OV_yg_dX-d_SP_OV_eta_dX)-d_GOV2_dX);
SP_OV_c = ((2.0*(SP_OV_yg-SP_OV_eta))-GOV2);
{
double value_log_0 = log((SP_OV_a/GOV2));
double  deriv_log_0_d0 = (1.0/(SP_OV_a/GOV2));
d_SP_OV_tau_dX = (deriv_log_0_d0*(((GOV2*d_SP_OV_a_dX-SP_OV_a*d_GOV2_dX)/GOV2/GOV2))-d_SP_OV_eta_dX);
SP_OV_tau = (value_log_0-SP_OV_eta);
}
d_nu_dX = (d_SP_OV_a_dX+d_SP_OV_c_dX);
nu = (SP_OV_a+SP_OV_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_OV_tau*(0.5*(SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)-d_SP_OV_a_dX)+d_SP_OV_tau_dX*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
mutau = ((nu*nu)+(SP_OV_tau*((0.5*(SP_OV_c*SP_OV_c))-SP_OV_a)));
d_SP_OV_y0_dX = (d_SP_OV_eta_dX+(((mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))*((SP_OV_a*nu)*d_SP_OV_tau_dX+(SP_OV_a*d_nu_dX+d_SP_OV_a_dX*nu)*SP_OV_tau)-((SP_OV_a*nu)*SP_OV_tau)*(d_mutau_dX+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*((SP_OV_c*d_SP_OV_c_dX+d_SP_OV_c_dX*SP_OV_c)*3.3333333333333333e-01-d_SP_OV_a_dX)+((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*d_SP_OV_c_dX+(((nu/mutau)*SP_OV_tau)*d_SP_OV_tau_dX+((nu/mutau)*d_SP_OV_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a))))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
SP_OV_y0 = (SP_OV_eta+(((SP_OV_a*nu)*SP_OV_tau)/(mutau+(((((nu/mutau)*SP_OV_tau)*SP_OV_tau)*SP_OV_c)*(((SP_OV_c*SP_OV_c)*3.3333333333333333e-01)-SP_OV_a)))));
{
double value_exp_0 = exp(SP_OV_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*(d_SP_OV_y0_dX);
SP_OV_D0 = value_exp_0;
}
d_SP_OV_temp_dX = (d_SP_OV_yg_dX-d_SP_OV_y0_dX);
SP_OV_temp = (SP_OV_yg-SP_OV_y0);
d_SP_OV_p_dX = (2.0*d_SP_OV_temp_dX+(GOV2*d_SP_OV_D0_dX+d_GOV2_dX*(SP_OV_D0-1.0)));
SP_OV_p = ((2.0*SP_OV_temp)+(GOV2*(SP_OV_D0-1.0)));
d_SP_OV_q_dX = ((SP_OV_temp*d_SP_OV_temp_dX+d_SP_OV_temp_dX*SP_OV_temp)+(GOV2*(d_SP_OV_y0_dX-d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_y0+1.0)-SP_OV_D0)));
SP_OV_q = ((SP_OV_temp*SP_OV_temp)+(GOV2*((SP_OV_y0+1.0)-SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_w_dX = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dX-SP_OV_q*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_w = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}
d_xd_ov_dX = (-(d_SP_OV_y0_dX+d_SP_OV_w_dX));
xd_ov = (-(SP_OV_y0+SP_OV_w));
}
else
{
d_SP_OV_Afac_dX = ((((xi_ov*instanceStruct.instanceVar_x1)*inv_xg1)-1.0)*d_inv_xg1_dX+((xi_ov*instanceStruct.instanceVar_x1)*d_inv_xg1_dX+d_xi_ov_dX*instanceStruct.instanceVar_x1*inv_xg1)*inv_xg1);
SP_OV_Afac = ((((xi_ov*instanceStruct.instanceVar_x1)*inv_xg1)-1.0)*inv_xg1);
d_SP_OV_xbar_dX = ((xgd_ov*inv_xi_ov)*(SP_OV_Afac*d_xgd_ov_dX+d_SP_OV_Afac_dX*xgd_ov)+(xgd_ov*d_inv_xi_ov_dX+d_xgd_ov_dX*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
SP_OV_xbar = ((xgd_ov*inv_xi_ov)*(1.0+(SP_OV_Afac*xgd_ov)));
if (((-SP_OV_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_temp_dX = deriv_exp_0_d0*((-d_SP_OV_xbar_dX));
SP_OV_temp = value_exp_0;
}
}
else
{
d_SP_OV_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(-(-d_SP_OV_xbar_dX))*3.3333333333333333e-01+(-(-d_SP_OV_xbar_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))+(-(-d_SP_OV_xbar_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
SP_OV_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_xbar))*3.3333333333333333e-01))))))));
}
d_SP_OV_w_dX = (-d_SP_OV_temp_dX);
SP_OV_w = (1.0-SP_OV_temp);
{
double value_sqrt_0 = sqrt(((xgd_ov+(GOV2*0.25))-SP_OV_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_x0_dX = ((d_xgd_ov_dX+d_GOV2_dX*0.5)-(GOV*deriv_sqrt_0_d0*(((d_xgd_ov_dX+d_GOV2_dX*0.25)-d_SP_OV_w_dX))+d_GOV_dX*value_sqrt_0));
SP_OV_x0 = ((xgd_ov+(GOV2*0.5))-(GOV*value_sqrt_0));
}
if (((-SP_OV_x0)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_OV_x0));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_OV_D0_dX = deriv_exp_0_d0*((-d_SP_OV_x0_dX));
SP_OV_D0 = value_exp_0;
}
}
else
{
d_SP_OV_D0_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_OV_x0))*0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(-(-d_SP_OV_x0_dX))*3.3333333333333333e-01+(-(-d_SP_OV_x0_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))+(-(-d_SP_OV_x0_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
SP_OV_D0 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_OV_x0))*(1.0+(((-2.3025850929940458e+02)-(-SP_OV_x0))*3.3333333333333333e-01))))))));
}
d_SP_OV_p_dX = (2.0*(d_xgd_ov_dX-d_SP_OV_x0_dX)+(GOV2*(-d_SP_OV_D0_dX)+d_GOV2_dX*(1-SP_OV_D0)));
SP_OV_p = ((2.0*(xgd_ov-SP_OV_x0))+(GOV2*(1-SP_OV_D0)));
d_SP_OV_q_dX = (((xgd_ov-SP_OV_x0)*(d_xgd_ov_dX-d_SP_OV_x0_dX)+(d_xgd_ov_dX-d_SP_OV_x0_dX)*(xgd_ov-SP_OV_x0))-(GOV2*(d_SP_OV_x0_dX+d_SP_OV_D0_dX)+d_GOV2_dX*((SP_OV_x0-1.0)+SP_OV_D0)));
SP_OV_q = (((xgd_ov-SP_OV_x0)*(xgd_ov-SP_OV_x0))-(GOV2*((SP_OV_x0-1.0)+SP_OV_D0)));
d_SP_OV_xi_dX = (-((GOV2*0.5)*d_SP_OV_D0_dX+d_GOV2_dX*0.5*SP_OV_D0));
SP_OV_xi = (1.0-((GOV2*0.5)*SP_OV_D0));
d_SP_OV_temp_dX = ((SP_OV_p*d_SP_OV_p_dX+d_SP_OV_p_dX*SP_OV_p)-4.0*(SP_OV_xi*d_SP_OV_q_dX+d_SP_OV_xi_dX*SP_OV_q));
SP_OV_temp = ((SP_OV_p*SP_OV_p)-(4.0*(SP_OV_xi*SP_OV_q)));
{
double value_sqrt_0 = sqrt(SP_OV_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_u_dX = 2.0*(((SP_OV_p+value_sqrt_0)*d_SP_OV_q_dX-SP_OV_q*(d_SP_OV_p_dX+deriv_sqrt_0_d0*(d_SP_OV_temp_dX)))/(SP_OV_p+value_sqrt_0)/(SP_OV_p+value_sqrt_0));
SP_OV_u = (2.0*(SP_OV_q/(SP_OV_p+value_sqrt_0)));
}
d_xd_ov_dX = (d_SP_OV_x0_dX+d_SP_OV_u_dX);
xd_ov = (SP_OV_x0+SP_OV_u);
}
d_xd_ov_dX = (-d_xd_ov_dX);
xd_ov = (-xd_ov);
}
d_Vovs_dX = ((-modelStruct.modelVar_phit)*(d_xgs_ov_dX+d_xs_ov_dX)+(-modelStruct.d_modelVar_phit_dX)*(xgs_ov+xs_ov));
Vovs = ((-modelStruct.modelVar_phit)*(xgs_ov+xs_ov));
d_Vovd_dX = ((-modelStruct.modelVar_phit)*(d_xgd_ov_dX+d_xd_ov_dX)+(-modelStruct.d_modelVar_phit_dX)*(xgd_ov+xd_ov));
Vovd = ((-modelStruct.modelVar_phit)*(xgd_ov+xd_ov));
}
d_Igsov_dX = 0.0;
Igsov = 0.0;
d_Igdov_dX = 0.0;
Igdov = 0.0;
d_Igc_dX = 0.0;
Igc = 0.0;
d_Igb_dX = 0.0;
Igb = 0.0;
d_Igcs_dX = 0.0;
Igcs = 0.0;
d_Igcd_dX = 0.0;
Igcd = 0.0;
if ((modelStruct.modelPar_SWIGATE!=0))
{
if ((instanceStruct.instanceVar_IGOV_i>0))
{
d_arg2mina_dX = (d_Vovs_dX+instanceStruct.d_instanceVar_Dov_dX);
arg2mina = (Vovs+instanceStruct.instanceVar_Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_arg1_dX = (d_xs_ov_dX+(psi_t*modelStruct.d_modelVar_inv_phit_dX+d_psi_t_dX*modelStruct.modelVar_inv_phit));
arg1 = ((3.0+xs_ov)+(psi_t*modelStruct.modelVar_inv_phit));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_Dsi_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_Dsi_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_arg1_dX = (-VgsPrime)*modelStruct.d_modelVar_inv_phit_dX;
arg1 = ((-VgsPrime)*modelStruct.modelVar_inv_phit);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*(d_arg1_dX);
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Dgate_dX = (Dsi*d_temp_dX+d_Dsi_dX*temp);
Dgate = (Dsi*temp);
d_temp_dX = (instanceStruct.instanceVar_BOV*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BOV_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BOV*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));
d_Igsov_dX = (instanceStruct.instanceVar_IGOV_i*(TP*deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate)))+d_TP_dX*value_log_0)+instanceStruct.d_instanceVar_IGOV_i_dX*(TP*value_log_0));
Igsov = (instanceStruct.instanceVar_IGOV_i*(TP*value_log_0));
}
}
if ((instanceStruct.instanceVar_IGOVD_i>0))
{
d_arg2mina_dX = (d_Vovd_dX+instanceStruct.d_instanceVar_Dov_dX);
arg2mina = (Vovd+instanceStruct.instanceVar_Dov);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_arg1_dX = (d_xd_ov_dX+(psi_t*modelStruct.d_modelVar_inv_phit_dX+d_psi_t_dX*modelStruct.modelVar_inv_phit));
arg1 = ((3.0+xd_ov)+(psi_t*modelStruct.modelVar_inv_phit));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_Dsi_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_Dsi_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_arg1_dX = (-VgdPrime)*modelStruct.d_modelVar_inv_phit_dX;
arg1 = ((-VgdPrime)*modelStruct.modelVar_inv_phit);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*(d_arg1_dX);
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Dgate_dX = (Dsi*d_temp_dX+d_Dsi_dX*temp);
Dgate = (Dsi*temp);
d_temp_dX = (instanceStruct.instanceVar_BOV_d*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BOV_d_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BOV_d*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));
d_Igdov_dX = (instanceStruct.instanceVar_IGOVD_i*(TP*deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate)))+d_TP_dX*value_log_0)+instanceStruct.d_instanceVar_IGOVD_i_dX*(TP*value_log_0));
Igdov = (instanceStruct.instanceVar_IGOVD_i*(TP*value_log_0));
}
}
if ((instanceStruct.instanceVar_IGINV_i>0))
{
if ((xg<=0.0))
{
{
double value_pow_0 = pow((Vds/instanceStruct.instanceVar_Vdsat_lim),instanceStruct.instanceVar_AX_i);
double  deriv_pow_0_d0 = (((Vds/instanceStruct.instanceVar_Vdsat_lim) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_AX_i/(Vds/instanceStruct.instanceVar_Vdsat_lim)));
double  deriv_pow_0_d1 = ((Vds/instanceStruct.instanceVar_Vdsat_lim) == 0.0)?0.0:(log((Vds/instanceStruct.instanceVar_Vdsat_lim))*value_pow_0);
d_temp_dX = ((deriv_pow_0_d0*((-Vds*instanceStruct.d_instanceVar_Vdsat_lim_dX/instanceStruct.instanceVar_Vdsat_lim/instanceStruct.instanceVar_Vdsat_lim)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_AX_i_dX)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-instanceStruct.instanceVar_inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_inv_AX)/(1.0+temp)));
double  deriv_pow_0_d1 = ((1.0+temp) == 0.0)?0.0:(log((1.0+temp))*value_pow_0);
d_Udse_dX = ((Vds*value_pow_0)*instanceStruct.d_instanceVar_inv_phit1_dX+Vds*((deriv_pow_0_d0*(d_temp_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_inv_AX_dX))))*instanceStruct.instanceVar_inv_phit1);
Udse = ((Vds*value_pow_0)*instanceStruct.instanceVar_inv_phit1);
}
}
if (((x_ds-Udse)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_ds-Udse));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((d_x_ds_dX-d_Udse_dX));
temp = value_exp_0;
}
}
else
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds-Udse))*0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(-(d_x_ds_dX-d_Udse_dX))*3.3333333333333333e-01+(-(d_x_ds_dX-d_Udse_dX))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))+(-(d_x_ds_dX-d_Udse_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds-Udse))*(1.0+(((-2.3025850929940458e+02)-(x_ds-Udse))*3.3333333333333333e-01))))))));
}
{
double value_log_0 = log((0.5*(1.0+temp)));
double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));
d_Vm_dX = (d_Vsbstar_dX+(instanceStruct.instanceVar_phit1*(0.5*d_x_ds_dX-deriv_log_0_d0*(0.5*d_temp_dX))+instanceStruct.d_instanceVar_phit1_dX*((0.5*x_ds)-value_log_0)));
Vm = (Vsbstar+(instanceStruct.instanceVar_phit1*((0.5*x_ds)-value_log_0)));
}
d_arg2mina_dX = (d_Voxm_dX+instanceStruct.d_instanceVar_Dch_dX);
arg2mina = (Voxm+instanceStruct.instanceVar_Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm*Voxm)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Voxm*d_Voxm_dX+d_Voxm_dX*Voxm))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_arg1_dX = (d_x_m_dX+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*instanceStruct.d_instanceVar_inv_phit1_dX+((d_psi_t_dX-instanceStruct.d_instanceVar_alpha_b_dX)-d_Vm_dX)*instanceStruct.instanceVar_inv_phit1));
arg1 = (x_m+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*instanceStruct.instanceVar_inv_phit1));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_Dsi_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_Dsi_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_arg1_dX = ((-((Vgs+Vsbstar)-Vm))*instanceStruct.d_instanceVar_inv_phit1_dX+(-(d_Vsbstar_dX-d_Vm_dX))*instanceStruct.instanceVar_inv_phit1);
arg1 = ((-((Vgs+Vsbstar)-Vm))*instanceStruct.instanceVar_inv_phit1);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*(d_arg1_dX);
temp = value_exp_0;
}
}
else
{
if ((arg1<(-2.3025850929940458e+02)))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Dgate_dX = (Dsi*d_temp_dX+d_Dsi_dX*temp);
Dgate = (Dsi*temp);
d_temp_dX = (instanceStruct.instanceVar_BCH*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BCH_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BCH*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));
d_Igc0_dX = (instanceStruct.instanceVar_IGINV_i*(TP*deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate)))+d_TP_dX*value_log_0)+instanceStruct.d_instanceVar_IGINV_i_dX*(TP*value_log_0));
Igc0 = (instanceStruct.instanceVar_IGINV_i*(TP*value_log_0));
}
if (((xg<=0)||((instanceStruct.instanceVar_GC2_i==0)&&(instanceStruct.instanceVar_GC3_i==0))))
{
d_igc_dX = 0.0;
igc = 1.0;
d_igcd_h_dX = 0.0;
igcd_h = 0.5;
}
else
{
d_temp_dX = (instanceStruct.d_instanceVar_GC2_i_dX+((2.0*instanceStruct.instanceVar_GC3_i)*d_zg_dX+2.0*instanceStruct.d_instanceVar_GC3_i_dX*zg));
temp = (instanceStruct.instanceVar_GC2_i+((2.0*instanceStruct.instanceVar_GC3_i)*zg));
d_u0_dX = (((temp*instanceStruct.instanceVar_BCH)*instanceStruct.d_instanceVar_CHIB_i_dX-instanceStruct.instanceVar_CHIB_i*(temp*instanceStruct.d_instanceVar_BCH_dX+d_temp_dX*instanceStruct.instanceVar_BCH))/(temp*instanceStruct.instanceVar_BCH)/(temp*instanceStruct.instanceVar_BCH));
u0 = (instanceStruct.instanceVar_CHIB_i/(temp*instanceStruct.instanceVar_BCH));
d_x_dX = 0.5*((u0*d_dps_dX-dps*d_u0_dX)/u0/u0);
x = (0.5*(dps/u0));
d_u0_div_H_dX = ((H*d_u0_dX-u0*d_H_dX)/H/H);
u0_div_H = (u0/H);
d_Bg_dX = (u0_div_H*(-d_u0_div_H_dX)+d_u0_div_H_dX*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);
d_Ag_dX = (-3.0*d_Bg_dX);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{
d_xsq_dX = (x*d_x_dX+d_x_dX*x);
xsq = (x*x);
d_igc_dX = (xsq*(d_u0_div_H_dX*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dX+d_xsq_dX*(0.05+(0.2*u0_div_H))))+d_xsq_dX*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
d_igcd_h_dX = (0.5*d_igc_dX-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dX+0.0285714285714*(xsq*d_Bg_dX+d_xsq_dX*(0.125+Bg)))+d_xsq_dX*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dX*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
}
else
{
d_inv_x_dX = (-d_x_dX/x/x);
inv_x = (1.0/x);
if ((fabs(x)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;
d_ex_dX = deriv_exp_0_d0*(d_x_dX);
ex = value_exp_0;
}
}
else
{
if ((x<(-2.3025850929940458e+02)))
{
d_ex_dX = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dX)*3.3333333333333333e-01+(-d_x_dX)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
}
else
{
d_ex_dX = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dX*3.3333333333333333e-01+d_x_dX*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dX*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_inv_ex_dX = (-d_ex_dX/ex/ex);
inv_ex = (1.0/ex);
d_temp_dX = (d_ex_dX-d_inv_ex_dX);
temp = (ex-inv_ex);
d_temp2_dX = (d_ex_dX+d_inv_ex_dX);
temp2 = (ex+inv_ex);
d_igc_dX = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dX+((1.0-u0_div_H)*d_temp_dX+(-d_u0_div_H_dX)*temp)*inv_x)+(u0_div_H*d_temp2_dX+d_u0_div_H_dX*temp2));
igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));
d_igcd_h_dX = 0.5*((d_igc_dX-(temp*(d_Bg_dX-((Ag*inv_x)*d_inv_x_dX+(Ag*d_inv_x_dX+d_Ag_dX*inv_x)*inv_x))+d_temp_dX*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dX+(Ag*d_temp2_dX+d_Ag_dX*temp2)*inv_x));
igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
}
}
{
double value_sqrt_0 = sqrt(((xg*xg)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Sg_dX = 0.5*((value_sqrt_0*d_xg_dX-xg*deriv_sqrt_0_d0*((xg*d_xg_dX+d_xg_dX*xg)))/value_sqrt_0/value_sqrt_0);
Sg = (0.5*(1.0+(xg/value_sqrt_0)));
}
d_Igc_dX = ((Igc0*igc)*d_Sg_dX+(Igc0*d_igc_dX+d_Igc0_dX*igc)*Sg);
Igc = ((Igc0*igc)*Sg);
d_Igcd_dX = ((Igc0*igcd_h)*d_Sg_dX+(Igc0*d_igcd_h_dX+d_Igc0_dX*igcd_h)*Sg);
Igcd = ((Igc0*igcd_h)*Sg);
d_Igcs_dX = (d_Igc_dX-d_Igcd_dX);
Igcs = (Igc-Igcd);
d_Igb_dX = ((Igc0*igc)*(-d_Sg_dX)+(Igc0*d_igc_dX+d_Igc0_dX*igc)*(1.0-Sg));
Igb = ((Igc0*igc)*(1.0-Sg));
}
}
d_Igidl_dX = 0.0;
Igidl = 0.0;
d_Igisl_dX = 0.0;
Igisl = 0.0;
if ((modelStruct.modelPar_SWGIDL!=0))
{
if (((instanceStruct.instanceVar_AGIDLD_i>0)&&(Vovd<0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+((instanceStruct.instanceVar_CGIDLD_i*instanceStruct.instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovd_dX = deriv_sqrt_0_d0*(((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd)+(instanceStruct.instanceVar_CGIDLD_i*instanceStruct.d_instanceVar_CGIDLD_i_dX+instanceStruct.d_instanceVar_CGIDLD_i_dX*instanceStruct.instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)));
Vtovd = value_sqrt_0;
}
d_temp_dX = ((Vtovd*(-instanceStruct.d_instanceVar_BGIDLDs_dX)-(-instanceStruct.instanceVar_BGIDLDs)*d_Vtovd_dX)/Vtovd/Vtovd);
temp = ((-instanceStruct.instanceVar_BGIDLDs)/Vtovd);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_temp2_dX = deriv_exp_0_d0*(d_temp_dX);
temp2 = value_exp_0;
}
}
else
{
d_temp2_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
d_Igidl_dX = ((-instanceStruct.instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dX+((VdbPrime*Vovd)*d_Vtovd_dX+VdbPrime*d_Vovd_dX*Vtovd)*temp2)+(-instanceStruct.d_instanceVar_AGIDLDs_dX)*(((VdbPrime*Vovd)*Vtovd)*temp2));
Igidl = ((-instanceStruct.instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
}
if (((instanceStruct.instanceVar_AGIDL_i>0)&&(Vovs<0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+((instanceStruct.instanceVar_CGIDL_i*instanceStruct.instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovs_dX = deriv_sqrt_0_d0*(((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs)+(instanceStruct.instanceVar_CGIDL_i*instanceStruct.d_instanceVar_CGIDL_i_dX+instanceStruct.d_instanceVar_CGIDL_i_dX*instanceStruct.instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)));
Vtovs = value_sqrt_0;
}
d_temp_dX = ((Vtovs*(-instanceStruct.d_instanceVar_BGIDLs_dX)-(-instanceStruct.instanceVar_BGIDLs)*d_Vtovs_dX)/Vtovs/Vtovs);
temp = ((-instanceStruct.instanceVar_BGIDLs)/Vtovs);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_temp2_dX = deriv_exp_0_d0*(d_temp_dX);
temp2 = value_exp_0;
}
}
else
{
d_temp2_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
d_Igisl_dX = ((-instanceStruct.instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dX+((VsbPrime*Vovs)*d_Vtovs_dX+VsbPrime*d_Vovs_dX*Vtovs)*temp2)+(-instanceStruct.d_instanceVar_AGIDLs_dX)*(((VsbPrime*Vovs)*Vtovs)*temp2));
Igisl = ((-instanceStruct.instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
}
}
d_P_D_dX = 0.25*(Gf*instanceStruct.d_instanceVar_kp_dX+d_Gf_dX*instanceStruct.instanceVar_kp);
P_D = (1+(0.25*(Gf*instanceStruct.instanceVar_kp)));
d_facvsb0_dX = (instanceStruct.d_instanceVar_phib_dX+2*instanceStruct.d_instanceVar_phit1_dX);
facvsb0 = (instanceStruct.instanceVar_phib+(2*instanceStruct.instanceVar_phit1));
d_facvsb_dX = (d_Vsbstar_dX+d_facvsb0_dX);
facvsb = (Vsbstar+facvsb0);
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_phit1*facvsb));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vts_i_dX = (((instanceStruct.d_instanceVar_VFB_i_dX+(P_D*d_facvsb_dX+d_P_D_dX*facvsb))-d_Vsbstar_dX)+(Gf*deriv_sqrt_0_d0*((instanceStruct.instanceVar_phit1*d_facvsb_dX+instanceStruct.d_instanceVar_phit1_dX*facvsb))+d_Gf_dX*value_sqrt_0));
vts_i = (((instanceStruct.instanceVar_VFB_i+(P_D*facvsb))-Vsbstar)+(Gf*value_sqrt_0));
}
d_vth_i_dX = (d_vts_i_dX-d_delVg_dX);
vth_i = (vts_i-delVg);
}
// End block evaluateStatic
//Begin block evaluateDynamic
{
Vgb = (Vgs+Vsb);
d_COX_qm_dX = instanceStruct.d_instanceVar_COX_i_dX;
COX_qm = instanceStruct.instanceVar_COX_i;
if ((instanceStruct.instanceVar_qq>0.0))
{
{
double value_pow_0 = pow(((qeff*qeff)+instanceStruct.instanceVar_qlim2),((-1.0)*1.6666666666666667e-01));
double  deriv_pow_0_d0 = ((((qeff*qeff)+instanceStruct.instanceVar_qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff*qeff)+instanceStruct.instanceVar_qlim2)));
d_COX_qm_dX = (((1.0+(instanceStruct.instanceVar_qq*value_pow_0))*instanceStruct.d_instanceVar_COX_i_dX-instanceStruct.instanceVar_COX_i*(instanceStruct.instanceVar_qq*(deriv_pow_0_d0*(((qeff*d_qeff_dX+d_qeff_dX*qeff)+instanceStruct.d_instanceVar_qlim2_dX)))+instanceStruct.d_instanceVar_qq_dX*value_pow_0))/(1.0+(instanceStruct.instanceVar_qq*value_pow_0))/(1.0+(instanceStruct.instanceVar_qq*value_pow_0)));
COX_qm = (instanceStruct.instanceVar_COX_i/(1.0+(instanceStruct.instanceVar_qq*value_pow_0)));
}
}
if ((xg<=0.0))
{
d_QG_dX = d_Voxm_dX;
QG = Voxm;
d_QI_dX = 0.0;
QI = 0.0;
d_QD_dX = 0.0;
QD = 0.0;
d_QB_dX = d_QG_dX;
QB = QG;
}
else
{
d_Fj_dX = 0.5*((H*d_dps_dX-dps*d_H_dX)/H/H);
Fj = (0.5*(dps/H));
d_Fj2_dX = (Fj*d_Fj_dX+d_Fj_dX*Fj);
Fj2 = (Fj*Fj);
d_QCLM_dX = ((1.0-GdL)*(d_qim_dX-0.5*(alpha*d_dps_dX+d_alpha_dX*dps))+(-d_GdL_dX)*(qim-(0.5*(alpha*dps))));
QCLM = ((1.0-GdL)*(qim-(0.5*(alpha*dps))));
d_QG_dX = (d_Voxm_dX+0.5*((eta_p*dps)*((Fj*d_GdL_dX+d_Fj_dX*GdL)*3.3333333333333333e-01+d_GdL_dX)+(eta_p*d_dps_dX+d_eta_p_dX*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL)));
QG = (Voxm+(0.5*((eta_p*dps)*((((Fj*GdL)*3.3333333333333333e-01)-1.0)+GdL))));
d_temp_dX = (alpha*d_dps_dX+d_alpha_dX*dps)*1.6666666666666667e-01;
temp = ((alpha*dps)*1.6666666666666667e-01);
d_QI_dX = ((GdL*(d_qim_dX+(temp*d_Fj_dX+d_temp_dX*Fj))+d_GdL_dX*(qim+(temp*Fj)))+d_QCLM_dX);
QI = ((GdL*(qim+(temp*Fj)))+QCLM);
d_QD_dX = 0.5*(((GdL*GdL)*(d_qim_dX-(temp*((-d_Fj_dX)-0.2*d_Fj2_dX)+d_temp_dX*((1.0-Fj)-(0.2*Fj2))))+(GdL*d_GdL_dX+d_GdL_dX*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_dX+d_QCLM_dX*(1.0+GdL)));
QD = (0.5*(((GdL*GdL)*(qim-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL))));
d_QB_dX = (d_QG_dX-d_QI_dX);
QB = (QG-QI);
}
d_Qg_dX = (QG*d_COX_qm_dX+d_QG_dX*COX_qm);
Qg = (QG*COX_qm);
d_Qd_dX = ((-QD)*d_COX_qm_dX+(-d_QD_dX)*COX_qm);
Qd = ((-QD)*COX_qm);
d_Qb_dX = ((-QB)*d_COX_qm_dX+(-d_QB_dX)*COX_qm);
Qb = ((-QB)*COX_qm);
d_Qgs_ov_dX = (instanceStruct.instanceVar_CGOV_i*d_Vovs_dX+instanceStruct.d_instanceVar_CGOV_i_dX*Vovs);
Qgs_ov = (instanceStruct.instanceVar_CGOV_i*Vovs);
d_Qgd_ov_dX = (instanceStruct.instanceVar_CGOVD_i*d_Vovd_dX+instanceStruct.d_instanceVar_CGOVD_i_dX*Vovd);
Qgd_ov = (instanceStruct.instanceVar_CGOVD_i*Vovd);
d_Qgb_ov_dX = instanceStruct.d_instanceVar_CGBOV_i_dX*Vgb;
Qgb_ov = (instanceStruct.instanceVar_CGBOV_i*Vgb);
d_Qfgs_dX = instanceStruct.d_instanceVar_CFR_i_dX*VgsPrime;
Qfgs = (instanceStruct.instanceVar_CFR_i*VgsPrime);
d_Qfgd_dX = instanceStruct.d_instanceVar_CFRD_i_dX*VgdPrime;
Qfgd = (instanceStruct.instanceVar_CFRD_i*VgdPrime);
}
// End block evaluateDynamic
d_ijun_s_dX = 0.0;
ijun_s = 0.0;
d_ijunbot_s_dX = 0.0;
ijunbot_s = 0.0;
d_ijunsti_s_dX = 0.0;
ijunsti_s = 0.0;
d_ijungat_s_dX = 0.0;
ijungat_s = 0.0;
d_ijun_d_dX = 0.0;
ijun_d = 0.0;
d_ijunbot_d_dX = 0.0;
ijunbot_d = 0.0;
d_ijunsti_d_dX = 0.0;
ijunsti_d = 0.0;
d_ijungat_d_dX = 0.0;
ijungat_d = 0.0;
d_qjun_s_dX = 0.0;
qjun_s = 0.0;
d_qjunbot_s_dX = 0.0;
qjunbot_s = 0.0;
d_qjunsti_s_dX = 0.0;
qjunsti_s = 0.0;
d_qjungat_s_dX = 0.0;
qjungat_s = 0.0;
d_qjun_d_dX = 0.0;
qjun_d = 0.0;
d_qjunbot_d_dX = 0.0;
qjunbot_d = 0.0;
d_qjunsti_d_dX = 0.0;
qjunsti_d = 0.0;
d_qjungat_d_dX = 0.0;
qjungat_d = 0.0;
//Begin block evaluateStaticDynamic
{
if ((modelStruct.modelPar_SWJUNCAP>0.0))
{
if ((modelStruct.modelVar_SWJUNEXP_i==1.0))
{
d_tm0_dX = Vjun_s*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s;
tm0 = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1_s)?(instanceStruct.instanceVar_expxhf1_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf1_s_dX)+instanceStruct.d_instanceVar_expxhf1_s_dX*((tm0-instanceStruct.instanceVar_xhighf1_s)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1_s)?(instanceStruct.instanceVar_expxhf1_s*((tm0-instanceStruct.instanceVar_xhighf1_s)+1)):value_exp_0));
}
d_ijunfor1_dX = (instanceStruct.instanceVar_ISATFOR1_s*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(tm1-1.0));
ijunfor1 = (instanceStruct.instanceVar_ISATFOR1_s*(tm1-1.0));
d_tm0_dX = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+Vjun_s*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_s);
tm0 = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2_s)?(instanceStruct.instanceVar_expxhf2_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf2_s_dX)+instanceStruct.d_instanceVar_expxhf2_s_dX*((tm0-instanceStruct.instanceVar_xhighf2_s)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2_s)?(instanceStruct.instanceVar_expxhf2_s*((tm0-instanceStruct.instanceVar_xhighf2_s)+1)):value_exp_0));
}
d_ijunfor2_dX = (instanceStruct.instanceVar_ISATFOR2_s*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(tm1-1.0));
ijunfor2 = (instanceStruct.instanceVar_ISATFOR2_s*(tm1-1.0));
d_ijunrev_dX = 0.0;
ijunrev = 0.0;
if ((instanceStruct.instanceVar_m0flag_s>0))
{
d_ijunrev_dX = Vjun_s*(instanceStruct.d_instanceVar_ISATREV_s_dX+Vjun_s*instanceStruct.d_instanceVar_MREV_s_dX);
ijunrev = (Vjun_s*(instanceStruct.instanceVar_ISATREV_s+(Vjun_s*instanceStruct.instanceVar_MREV_s)));
}
else
{
d_tm0_dX = (((-Vjun_s)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+(-Vjun_s)*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_s);
tm0 = (((-Vjun_s)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr_s)?(instanceStruct.instanceVar_expxhr_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighr_s_dX)+instanceStruct.d_instanceVar_expxhr_s_dX*((tm0-instanceStruct.instanceVar_xhighr_s)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr_s)?(instanceStruct.instanceVar_expxhr_s*((tm0-instanceStruct.instanceVar_xhighr_s)+1)):value_exp_0));
}
d_ijunrev_dX = ((-instanceStruct.instanceVar_ISATREV_s)*d_tm1_dX+(-instanceStruct.d_instanceVar_ISATREV_s_dX)*(tm1-1.0));
ijunrev = ((-instanceStruct.instanceVar_ISATREV_s)*(tm1-1.0));
}
d_ijun_s_dX = ((d_ijunfor1_dX+d_ijunfor2_dX)+d_ijunrev_dX);
ijun_s = ((ijunfor1+ijunfor2)+ijunrev);
d_tm0_dX = Vjun_d*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d;
tm0 = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1_d)?(instanceStruct.instanceVar_expxhf1_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf1_d_dX)+instanceStruct.d_instanceVar_expxhf1_d_dX*((tm0-instanceStruct.instanceVar_xhighf1_d)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf1_d)?(instanceStruct.instanceVar_expxhf1_d*((tm0-instanceStruct.instanceVar_xhighf1_d)+1)):value_exp_0));
}
d_ijunfor1_dX = (instanceStruct.instanceVar_ISATFOR1_d*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(tm1-1.0));
ijunfor1 = (instanceStruct.instanceVar_ISATFOR1_d*(tm1-1.0));
d_tm0_dX = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+Vjun_d*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_d);
tm0 = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2_d)?(instanceStruct.instanceVar_expxhf2_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf2_d_dX)+instanceStruct.d_instanceVar_expxhf2_d_dX*((tm0-instanceStruct.instanceVar_xhighf2_d)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighf2_d)?(instanceStruct.instanceVar_expxhf2_d*((tm0-instanceStruct.instanceVar_xhighf2_d)+1)):value_exp_0));
}
d_ijunfor2_dX = (instanceStruct.instanceVar_ISATFOR2_d*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(tm1-1.0));
ijunfor2 = (instanceStruct.instanceVar_ISATFOR2_d*(tm1-1.0));
d_ijunrev_dX = 0.0;
ijunrev = 0.0;
if ((instanceStruct.instanceVar_m0flag_d>0))
{
d_ijunrev_dX = Vjun_d*(instanceStruct.d_instanceVar_ISATREV_d_dX+Vjun_d*instanceStruct.d_instanceVar_MREV_d_dX);
ijunrev = (Vjun_d*(instanceStruct.instanceVar_ISATREV_d+(Vjun_d*instanceStruct.instanceVar_MREV_d)));
}
else
{
d_tm0_dX = (((-Vjun_d)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+(-Vjun_d)*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_d);
tm0 = (((-Vjun_d)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1)/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr_d)?(instanceStruct.instanceVar_expxhr_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighr_d_dX)+instanceStruct.d_instanceVar_expxhr_d_dX*((tm0-instanceStruct.instanceVar_xhighr_d)+1)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1)):((tm0>instanceStruct.instanceVar_xhighr_d)?(instanceStruct.instanceVar_expxhr_d*((tm0-instanceStruct.instanceVar_xhighr_d)+1)):value_exp_0));
}
d_ijunrev_dX = ((-instanceStruct.instanceVar_ISATREV_d)*d_tm1_dX+(-instanceStruct.d_instanceVar_ISATREV_d_dX)*(tm1-1.0));
ijunrev = ((-instanceStruct.instanceVar_ISATREV_d)*(tm1-1.0));
}
d_ijun_d_dX = ((d_ijunfor1_dX+d_ijunfor2_dX)+d_ijunrev_dX);
ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
//Begin block evaluateDynamic
{
//Block-local variables for block evaluateDynamic
double tmpv=0.0;
double d_tmpv_dX=0.0;
double vjv=0.0;
double d_vjv_dX=0.0;
//End of Block-local variables
d_tmpv_dX = 0.0;
tmpv = 0.0;
d_vjv_dX = 0.0;
vjv = 0.0;
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (Vjun_s+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vjv_dX = 2.0*(((h3+h5)*Vjun_s*instanceStruct.d_instanceVar_vfmin_s_dX-(Vjun_s*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_s*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((instanceStruct.instanceVar_zflagbot_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vjv*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmpv = value_pow_0;
}
}
d_qjunbot_s_dX = ((modelStruct.modelVar_qprefbot*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmpv))+(modelStruct.modelVar_qpref2bot*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2bot_dX*(Vjun_s-vjv)));
qjunbot_s = ((modelStruct.modelVar_qprefbot*(1-tmpv))+(modelStruct.modelVar_qpref2bot*(Vjun_s-vjv)));
}
if ((instanceStruct.instanceVar_zflagsti_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vjv*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmpv = value_pow_0;
}
}
d_qjunsti_s_dX = ((modelStruct.modelVar_qprefsti*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmpv))+(modelStruct.modelVar_qpref2sti*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2sti_dX*(Vjun_s-vjv)));
qjunsti_s = ((modelStruct.modelVar_qprefsti*(1-tmpv))+(modelStruct.modelVar_qpref2sti*(Vjun_s-vjv)));
}
if ((instanceStruct.instanceVar_zflaggat_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vjv*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmpv = value_pow_0;
}
}
d_qjungat_s_dX = ((modelStruct.modelVar_qprefgat*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmpv))+(modelStruct.modelVar_qpref2gat*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2gat_dX*(Vjun_s-vjv)));
qjungat_s = ((modelStruct.modelVar_qprefgat*(1-tmpv))+(modelStruct.modelVar_qpref2gat*(Vjun_s-vjv)));
}
d_tmpv_dX = 0.0;
tmpv = 0.0;
d_vjv_dX = 0.0;
vjv = 0.0;
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (Vjun_d+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vjv_dX = 2.0*(((h3+h5)*Vjun_d*instanceStruct.d_instanceVar_vfmin_d_dX-(Vjun_d*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_d*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((instanceStruct.instanceVar_zflagbot_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vjv*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmpv = value_pow_0;
}
}
d_qjunbot_d_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmpv))+(modelStruct.modelVar_qpref2bot_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(Vjun_d-vjv)));
qjunbot_d = ((modelStruct.modelVar_qprefbot_d*(1-tmpv))+(modelStruct.modelVar_qpref2bot_d*(Vjun_d-vjv)));
}
if ((instanceStruct.instanceVar_zflagsti_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vjv*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmpv = value_pow_0;
}
}
d_qjunsti_d_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmpv))+(modelStruct.modelVar_qpref2sti_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(Vjun_d-vjv)));
qjunsti_d = ((modelStruct.modelVar_qprefsti_d*(1-tmpv))+(modelStruct.modelVar_qpref2sti_d*(Vjun_d-vjv)));
}
if ((instanceStruct.instanceVar_zflaggat_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vjv*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vjv*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vjv*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vjv*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vjv*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vjv*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmpv = value_pow_0;
}
}
d_qjungat_d_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmpv))+(modelStruct.modelVar_qpref2gat_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(Vjun_d-vjv)));
qjungat_d = ((modelStruct.modelVar_qprefgat_d*(1-tmpv))+(modelStruct.modelVar_qpref2gat_d*(Vjun_d-vjv)));
}
}
// End block evaluateDynamic
}
else
{
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0)&&(instanceStruct.instanceVar_LSSOURCE_i==0))&&(instanceStruct.instanceVar_LGSOURCE_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (Vjun_s+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*Vjun_s*instanceStruct.d_instanceVar_vfmin_s_dX-(Vjun_s*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_s*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((Vjun_s<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_s*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((Vjun_s>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-Vjun_s)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((Vjun_s-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(Vjun_s-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s-instanceStruct.instanceVar_vbbtlim_s)*(Vjun_s-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((Vjun_s-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(Vjun_s-instanceStruct.instanceVar_vbbtlim_s))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((Vjun_s+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vav = (0.5*(Vjun_s-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0))
{
d_ijunbot_s_dX = 0.0;
ijunbot_s = 0;
d_qjunbot_s_dX = 0.0;
qjunbot_s = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_s_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(Vjun_s-vj)));
qjunbot_s = ((modelStruct.modelVar_qprefbot*(1-tmp))+(modelStruct.modelVar_qpref2bot*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0)&&(modelStruct.modelVar_CTATBOT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+0.999*modelStruct.d_modelVar_VBRBOT_i_dX*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(0.999*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0))
{
d_ijunsti_s_dX = 0.0;
ijunsti_s = 0;
d_qjunsti_s_dX = 0.0;
qjunsti_s = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_s_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(Vjun_s-vj)));
qjunsti_s = ((modelStruct.modelVar_qprefsti*(1-tmp))+(modelStruct.modelVar_qpref2sti*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0)&&(modelStruct.modelVar_CTATSTI_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTI_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+0.999*modelStruct.d_modelVar_VBRSTI_i_dX*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(0.999*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0))
{
d_ijungat_s_dX = 0.0;
ijungat_s = 0;
d_qjungat_s_dX = 0.0;
qjungat_s = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_s_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(Vjun_s-vj)));
qjungat_s = ((modelStruct.modelVar_qprefgat*(1-tmp))+(modelStruct.modelVar_qpref2gat*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0)&&(modelStruct.modelVar_CTATGAT_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGAT_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+0.999*modelStruct.d_modelVar_VBRGAT_i_dX*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(0.999*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_ijun_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_s_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_s_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_s_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat_s));
ijun_s = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat_s));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0)&&(instanceStruct.instanceVar_LSDRAIN_i==0))&&(instanceStruct.instanceVar_LGDRAIN_i==0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (Vjun_d+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*Vjun_d*instanceStruct.d_instanceVar_vfmin_d_dX-(Vjun_d*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_d*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((Vjun_d<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_d*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))<(-2.3025850929940458e+02)))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-1*d_zinv_dX/zinv/zinv);
z = (1/zinv);
if ((Vjun_d>0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1+zinv)*(1+(3*zinv))));
double value_log_1 = log((((2*zinv)+1)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2*zinv)+1)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2*d_zinv_dX+deriv_sqrt_0_d0*(((1+zinv)*3*d_zinv_dX+d_zinv_dX*(1+(3*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-Vjun_d)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(Vjun_d-vjlim))+((4*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d-instanceStruct.instanceVar_vbbtlim_d)*(Vjun_d-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((Vjun_d-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(Vjun_d-instanceStruct.instanceVar_vbbtlim_d))+((4*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((Vjun_d+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4*1E-6)*1E-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vav = (0.5*(Vjun_d-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0))
{
d_ijunbot_d_dX = 0.0;
ijunbot_d = 0;
d_qjunbot_d_dX = 0.0;
qjunbot_d = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_d_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(Vjun_d-vj)));
qjunbot_d = ((modelStruct.modelVar_qprefbot_d*(1-tmp))+(modelStruct.modelVar_qpref2bot_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0)&&(modelStruct.modelVar_CTATBOTD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PBOTD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+0.999*modelStruct.d_modelVar_VBRBOTD_i_dX*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(0.999*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0))
{
d_ijunsti_d_dX = 0.0;
ijunsti_d = 0;
d_qjunsti_d_dX = 0.0;
qjunsti_d = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_d_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(Vjun_d-vj)));
qjunsti_d = ((modelStruct.modelVar_qprefsti_d*(1-tmp))+(modelStruct.modelVar_qpref2sti_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0)&&(modelStruct.modelVar_CTATSTID_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PSTID_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+0.999*modelStruct.d_modelVar_VBRSTID_i_dX*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(0.999*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0))
{
d_ijungat_d_dX = 0.0;
ijungat_d = 0;
d_qjungat_d_dX = 0.0;
qjungat_d = 0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_d_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(Vjun_d-vj)));
qjungat_d = ((modelStruct.modelVar_qprefgat_d*(1-tmp))+(modelStruct.modelVar_qpref2gat_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0)&&(modelStruct.modelVar_CTATGATD_i==0)))
{
d_isrh_dX = 0.0;
isrh = 0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(-2*modelStruct.d_modelVar_PGATD_i_dX)+((((1-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1-wsrhstep)/(1-wsrhstep))+d_wsrhstep_dX)*(1-(2*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1-wsrhstep))+wsrhstep)*(1-(2*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0))
{
d_itat_dX = 0.0;
itat = 0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1)/((umaxbeforelimiting*umaxbeforelimiting)+1)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1)))
{
d_wgamma_dX = (-1*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1+(btat*umaxpoweronepointfive))/(1+(btat*umaxpoweronepointfive)));
wgamma = (1/(1+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0))
{
d_terfc_dX = (-1*modelStruct.modelVar_perfc*d_xerfc_dX/(1+(modelStruct.modelVar_perfc*xerfc))/(1+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-1*(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1-(modelStruct.modelVar_perfc*xerfc))/(1-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1/(1-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0))
{
d_ibbt_dX = 0.0;
ibbt = 0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<(-2.3025850929940458e+02)))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1000))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1;
}
else
{
if ((vav>((-0.999)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4))
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_1 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_2 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_fabs_3 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_1_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_2_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_fabs_3_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
d_tmp_dX = (((value_fabs_0*value_fabs_1)*value_fabs_2)*deriv_fabs_3_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)+((value_fabs_0*value_fabs_1)*deriv_fabs_2_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)+(value_fabs_0*deriv_fabs_1_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)+deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)*value_fabs_1)*value_fabs_2)*value_fabs_3);
tmp = (((value_fabs_0*value_fabs_1)*value_fabs_2)*value_fabs_3);
}
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-1*(-d_tmp_dX)/(1-tmp)/(1-tmp));
fbreakdown = (1/(1-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+0.999*modelStruct.d_modelVar_VBRGATD_i_dX*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(0.999*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_ijun_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat_d));
ijun_d = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat_d));
}
}
d_rgatenoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_ggate_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_ggate);
rgatenoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_ggate);
d_rbulknoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gbulk_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gbulk);
rbulknoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gbulk);
d_rjunsnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gjuns_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gjuns);
rjunsnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gjuns);
d_rjundnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gjund_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gjund);
rjundnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gjund);
d_rwellnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gwell_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gwell);
rwellnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gwell);
}
// End block evaluateStaticDynamic
//Begin block loadStatic
{
if ((sigVds>0))
{
// I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
d_staticContributions_dX[admsNodeID_D]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
// I(D,S) <+ (((CHNL_TYPE*MULT_i)*Ids))
d_staticContributions_dX[admsNodeID_D]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Ids_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Ids);
d_staticContributions_dX[(admsNodeID_S)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Ids_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Ids);
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcs))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
d_staticContributions_dX[(admsNodeID_S)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcd))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
d_staticContributions_dX[(admsNodeID_D)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
}
else
{
// I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
d_staticContributions_dX[admsNodeID_S]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
// I(S,D) <+ (((CHNL_TYPE*MULT_i)*Ids))
d_staticContributions_dX[admsNodeID_S]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Ids_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Ids);
d_staticContributions_dX[(admsNodeID_D)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Ids_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Ids);
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igcs))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
d_staticContributions_dX[(admsNodeID_D)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igcd))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
d_staticContributions_dX[(admsNodeID_S)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
}
// I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igb);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igb);
// I(GP,S) <+ (((CHNL_TYPE*MULT_i)*Igsov))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igsov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igsov);
d_staticContributions_dX[(admsNodeID_S)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igsov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igsov);
// I(GP,D) <+ (((CHNL_TYPE*MULT_i)*Igdov))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igdov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igdov);
d_staticContributions_dX[(admsNodeID_D)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igdov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igdov);
// I(S,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
d_staticContributions_dX[admsNodeID_S]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igisl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igisl);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igisl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igisl);
// I(D,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
d_staticContributions_dX[admsNodeID_D]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igidl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igidl);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igidl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igidl);
// I(BS,S) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
d_staticContributions_dX[admsNodeID_BS]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_s);
d_staticContributions_dX[(admsNodeID_S)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_s);
// I(BD,D) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
d_staticContributions_dX[admsNodeID_BD]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_d);
d_staticContributions_dX[(admsNodeID_D)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_d);
if ((instanceStruct.instanceVar_RG_i>0.0))
{
// I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
d_staticContributions_dX[admsNodeID_G]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_ggate_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]);
d_staticContributions_dX[(admsNodeID_GP)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_ggate_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]);
// I(G,GP) <+ (white_noise((MULT_i*rgatenoise)))
}
else
{
// V(G,GP) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RBULK_i>0.0))
{
// I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
d_staticContributions_dX[admsNodeID_BP]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gbulk_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gbulk_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]);
// I(BP,BI) <+ (white_noise((MULT_i*rbulknoise)))
}
else
{
// V(BP,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RJUNS_i>0.0))
{
// I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
d_staticContributions_dX[admsNodeID_BS]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjuns_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjuns_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]);
// I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise)))
}
else
{
// V(BS,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RJUND_i>0.0))
{
// I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
d_staticContributions_dX[admsNodeID_BD]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjund_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjund_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]);
// I(BD,BI) <+ (white_noise((MULT_i*rjundnoise)))
}
else
{
// V(BD,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RWELL_i>0.0))
{
// I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
d_staticContributions_dX[admsNodeID_B]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gwell_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gwell_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]);
// I(B,BI) <+ (white_noise((MULT_i*rwellnoise)))
}
else
{
// V(B,BI) <+ (0.0)
// do nothing at all
}
// I(D,S) <+ ((1E-15*V(D,S)))
d_staticContributions_dX[admsNodeID_D]+= 0.0;
d_staticContributions_dX[(admsNodeID_S)]-= 0.0;
}
// End block loadStatic
//Begin block loadDynamic
{
d_Qs_dX = (-((d_Qg_dX+d_Qb_dX)+d_Qd_dX));
Qs = (-((Qg+Qb)+Qd));
d_Qfgs_dX = (d_Qfgs_dX+d_Qgs_ov_dX);
Qfgs = (Qfgs+Qgs_ov);
d_Qfgd_dX = (d_Qfgd_dX+d_Qgd_ov_dX);
Qfgd = (Qfgd+Qgd_ov);
d_qjun_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_qjunbot_s_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*qjunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*d_qjunsti_s_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*qjunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*d_qjungat_s_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*qjungat_s));
qjun_s = (((instanceStruct.instanceVar_ABSOURCE_i*qjunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*qjunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*qjungat_s));
d_qjun_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_qjunbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*qjunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*d_qjunsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*qjunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*d_qjungat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*qjungat_d));
qjun_d = (((instanceStruct.instanceVar_ABDRAIN_i*qjunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*qjunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*qjungat_d));
if ((sigVds<0))
{
d_temp_dX = d_Qd_dX;
temp = Qd;
d_Qd_dX = d_Qs_dX;
Qd = Qs;
d_Qs_dX = d_temp_dX;
Qs = temp;
}
// I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qg_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qg));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qg_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qg));
// I(BP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
d_dynamicContributions_dX[admsNodeID_BP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qb));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qb));
// I(D,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
d_dynamicContributions_dX[admsNodeID_D]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qd));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qd));
// I(GP,S) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgs));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgs));
// I(GP,D) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgd));
d_dynamicContributions_dX[(admsNodeID_D)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgd));
// I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qgb_ov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qgb_ov));
d_dynamicContributions_dX[(admsNodeID_BP)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qgb_ov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qgb_ov));
// I(BS,S) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
d_dynamicContributions_dX[admsNodeID_BS]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_s));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_s));
// I(BD,D) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
d_dynamicContributions_dX[admsNodeID_BD]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_d));
d_dynamicContributions_dX[(admsNodeID_D)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_d));
}
// End block loadDynamic
//Begin block noise
{
//Block-local variables for block noise
double sf=0.0;
double d_sf_dX=0.0;
//End of Block-local variables
instanceStruct.d_instanceVar_Sfl_dX = 0.0;
instanceStruct.instanceVar_Sfl = 0.0;
d_mid_dX = 0.0;
mid = 0.0;
instanceStruct.d_instanceVar_mig_dX = 0.0;
instanceStruct.instanceVar_mig = 0.0;
d_migid_dX = 0.0;
migid = 0.0;
instanceStruct.d_instanceVar_c_igid_dX = 0.0;
instanceStruct.instanceVar_c_igid = 0.0;
instanceStruct.d_instanceVar_CGeff_dX = (COX_qm*d_eta_p_dX+d_COX_qm_dX*eta_p);
instanceStruct.instanceVar_CGeff = (COX_qm*eta_p);
instanceStruct.d_instanceVar_sqid_dX = 0.0;
instanceStruct.instanceVar_sqid = 0.0;
d_sqig_dX = 0.0;
sqig = 0.0;
if ((((xg>0.0)&&(instanceStruct.instanceVar_MULT_i>0.0))&&(instanceStruct.instanceVar_BET_i>0.0)))
{
d_N1_dX = ((instanceStruct.instanceVar_Cox_over_q*alpha)*modelStruct.d_modelVar_phit_dX+(instanceStruct.instanceVar_Cox_over_q*d_alpha_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*alpha)*modelStruct.modelVar_phit);
N1 = ((instanceStruct.instanceVar_Cox_over_q*alpha)*modelStruct.modelVar_phit);
d_Nm1_dX = (instanceStruct.instanceVar_Cox_over_q*d_qim1_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*qim1);
Nm1 = (instanceStruct.instanceVar_Cox_over_q*qim1);
d_Delta_N1_dX = (instanceStruct.instanceVar_Cox_over_q*(alpha*d_dps_dX+d_alpha_dX*dps)+instanceStruct.d_instanceVar_Cox_over_q_dX*(alpha*dps));
Delta_N1 = (instanceStruct.instanceVar_Cox_over_q*(alpha*dps));
{
double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
instanceStruct.d_instanceVar_Sfl_dX = (((instanceStruct.instanceVar_NFA_i-(instanceStruct.instanceVar_NFB_i*N1))+(instanceStruct.instanceVar_NFC_i*(N1*N1)))*deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dX+0.5*d_Delta_N1_dX)-(Nm1+(0.5*Delta_N1))*(d_Nm1_dX-0.5*d_Delta_N1_dX))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))+((instanceStruct.d_instanceVar_NFA_i_dX-(instanceStruct.instanceVar_NFB_i*d_N1_dX+instanceStruct.d_instanceVar_NFB_i_dX*N1))+(instanceStruct.instanceVar_NFC_i*(N1*d_N1_dX+d_N1_dX*N1)+instanceStruct.d_instanceVar_NFC_i_dX*(N1*N1)))*value_log_0);
instanceStruct.instanceVar_Sfl = (((instanceStruct.instanceVar_NFA_i-(instanceStruct.instanceVar_NFB_i*N1))+(instanceStruct.instanceVar_NFC_i*(N1*N1)))*value_log_0);
}
instanceStruct.d_instanceVar_Sfl_dX = (instanceStruct.d_instanceVar_Sfl_dX+((instanceStruct.instanceVar_NFB_i+(instanceStruct.instanceVar_NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dX+(instanceStruct.d_instanceVar_NFB_i_dX+(instanceStruct.instanceVar_NFC_i*(d_Nm1_dX-2.0*d_N1_dX)+instanceStruct.d_instanceVar_NFC_i_dX*(Nm1-(2.0*N1))))*Delta_N1));
instanceStruct.instanceVar_Sfl = (instanceStruct.instanceVar_Sfl+((instanceStruct.instanceVar_NFB_i+(instanceStruct.instanceVar_NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
instanceStruct.d_instanceVar_Sfl_dX = ((N1*(((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv)*instanceStruct.d_instanceVar_Sfl_dX+((instanceStruct.instanceVar_Sfl_prefac*Ids)*d_Gvsatinv_dX+(instanceStruct.instanceVar_Sfl_prefac*d_Ids_dX+instanceStruct.d_instanceVar_Sfl_prefac_dX*Ids)*Gvsatinv)*instanceStruct.instanceVar_Sfl)-(((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv)*instanceStruct.instanceVar_Sfl)*d_N1_dX)/N1/N1);
instanceStruct.instanceVar_Sfl = ((((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv)*instanceStruct.instanceVar_Sfl)/N1);
instanceStruct.d_instanceVar_Sfl_dX = ((instanceStruct.instanceVar_Sfl>0.0)?instanceStruct.d_instanceVar_Sfl_dX:0.0);
instanceStruct.instanceVar_Sfl = ((instanceStruct.instanceVar_Sfl>0.0)?instanceStruct.instanceVar_Sfl:0.0);
d_H0_dX = ((alpha*d_qim1_dX-qim1*d_alpha_dX)/alpha/alpha);
H0 = (qim1/alpha);
d_t1_dX = ((qim1*d_qim_dX-qim*d_qim1_dX)/qim1/qim1);
t1 = (qim/qim1);
d_sqt2_dX = (0.5*1.6666666666666667e-01)*((H0*d_dps_dX-dps*d_H0_dX)/H0/H0);
sqt2 = ((0.5*1.6666666666666667e-01)*(dps/H0));
d_t2_dX = (sqt2*d_sqt2_dX+d_sqt2_dX*sqt2);
t2 = (sqt2*sqt2);
d_r_dX = ((H*d_H0_dX-H0*d_H_dX)/H/H);
r = ((H0/H)-1.0);
d_lc_dX = (((1.0-(12*(r*t2)))>1e-20)?(-12*(r*d_t2_dX+d_r_dX*t2)):0.0);
lc = (((1.0-(12*(r*t2)))>1e-20)?(1.0-(12*(r*t2))):1e-20);
d_lcinv2_dX = (-1*(lc*d_lc_dX+d_lc_dX*lc)/(lc*lc)/(lc*lc));
lcinv2 = (1/(lc*lc));
d_g_ideal_dX = (instanceStruct.instanceVar_BET_i*((FdL*qim1)*d_Gvsatinv_dX+(FdL*d_qim1_dX+d_FdL_dX*qim1)*Gvsatinv)+instanceStruct.d_instanceVar_BET_i_dX*((FdL*qim1)*Gvsatinv));
g_ideal = (instanceStruct.instanceVar_BET_i*((FdL*qim1)*Gvsatinv));
instanceStruct.d_instanceVar_CGeff_dX = (((Gmob_dL*Gmob_dL)*(((Gvsat*Gvsat)*COX_qm)*d_eta_p_dX+((Gvsat*Gvsat)*d_COX_qm_dX+(Gvsat*d_Gvsat_dX+d_Gvsat_dX*Gvsat)*COX_qm)*eta_p)-(((Gvsat*Gvsat)*COX_qm)*eta_p)*(Gmob_dL*d_Gmob_dL_dX+d_Gmob_dL_dX*Gmob_dL))/(Gmob_dL*Gmob_dL)/(Gmob_dL*Gmob_dL));
instanceStruct.instanceVar_CGeff = ((((Gvsat*Gvsat)*COX_qm)*eta_p)/(Gmob_dL*Gmob_dL));
d_mid_dX = ((d_t1_dX+12*d_t2_dX)-24*(((1.0+t1)*t2)*d_r_dX+((1.0+t1)*d_t2_dX+d_t1_dX*t2)*r));
mid = ((t1+(12*t2))-(24*(((1.0+t1)*t2)*r)));
d_mid_dX = ((mid>1e-40)?d_mid_dX:0.0);
mid = ((mid>1e-40)?mid:1e-40);
d_mid_dX = ((g_ideal*lcinv2)*d_mid_dX+(g_ideal*d_lcinv2_dX+d_g_ideal_dX*lcinv2)*mid);
mid = ((g_ideal*lcinv2)*mid);
instanceStruct.d_instanceVar_mig_dX = (((d_t1_dX/12.0)-(t2*(d_t1_dX-12*d_t2_dX)+d_t2_dX*((t1+0.2)-(12*t2))))-1.6*((t2*((t1+1.0)-(12*t2)))*d_r_dX+(t2*(d_t1_dX-12*d_t2_dX)+d_t2_dX*((t1+1.0)-(12*t2)))*r));
instanceStruct.instanceVar_mig = (((t1/12.0)-(t2*((t1+0.2)-(12*t2))))-(1.6*((t2*((t1+1.0)-(12*t2)))*r)));
instanceStruct.d_instanceVar_mig_dX = ((instanceStruct.instanceVar_mig>1e-40)?instanceStruct.d_instanceVar_mig_dX:0.0);
instanceStruct.instanceVar_mig = ((instanceStruct.instanceVar_mig>1e-40)?instanceStruct.instanceVar_mig:1e-40);
instanceStruct.d_instanceVar_mig_dX = ((lcinv2/g_ideal)*instanceStruct.d_instanceVar_mig_dX+((g_ideal*d_lcinv2_dX-lcinv2*d_g_ideal_dX)/g_ideal/g_ideal)*instanceStruct.instanceVar_mig);
instanceStruct.instanceVar_mig = ((lcinv2/g_ideal)*instanceStruct.instanceVar_mig);
d_migid_dX = ((lcinv2*sqt2)*((-12*d_t2_dX)-(((t1+(19.2*t2))-(12*(t1*t2)))*d_r_dX+((d_t1_dX+19.2*d_t2_dX)-12*(t1*d_t2_dX+d_t1_dX*t2))*r))+(lcinv2*d_sqt2_dX+d_lcinv2_dX*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
migid = ((lcinv2*sqt2)*((1.0-(12*t2))-(((t1+(19.2*t2))-(12*(t1*t2)))*r)));
if ((instanceStruct.instanceVar_FNTEXC_i>0))
{
d_temp2_exc_dX = (qim*d_xitsb_dX+d_qim_dX*xitsb);
temp2_exc = (qim*xitsb);
d_wsat_exc_dX = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dX-temp2_exc*d_temp2_exc_dX)/(100.0+temp2_exc)/(100.0+temp2_exc));
wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
if ((instanceStruct.instanceVar_THESATG_i<0))
{
d_temp_exc_dX = (-1*(-(instanceStruct.instanceVar_THESATG_i*d_wsat_exc_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat_exc))/(1-(instanceStruct.instanceVar_THESATG_i*wsat_exc))/(1-(instanceStruct.instanceVar_THESATG_i*wsat_exc)));
temp_exc = (1/(1-(instanceStruct.instanceVar_THESATG_i*wsat_exc)));
}
else
{
d_temp_exc_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_exc_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat_exc);
temp_exc = (1+(instanceStruct.instanceVar_THESATG_i*wsat_exc));
}
d_thesat1_exc_dX = (instanceStruct.instanceVar_THESAT_i*((Gmob*d_temp_exc_dX-temp_exc*d_Gmob_dX)/Gmob/Gmob)+instanceStruct.d_instanceVar_THESAT_i_dX*(temp_exc/Gmob));
thesat1_exc = (instanceStruct.instanceVar_THESAT_i*(temp_exc/Gmob));
d_zsat_exc_dX = (((thesat1_exc*thesat1_exc)*dps)*d_dps_dX+((thesat1_exc*thesat1_exc)*d_dps_dX+(thesat1_exc*d_thesat1_exc_dX+d_thesat1_exc_dX*thesat1_exc)*dps)*dps);
zsat_exc = (((thesat1_exc*thesat1_exc)*dps)*dps);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
d_zsat_exc_dX = (((1.0+(thesat1_exc*dps))*d_zsat_exc_dX-zsat_exc*(thesat1_exc*d_dps_dX+d_thesat1_exc_dX*dps))/(1.0+(thesat1_exc*dps))/(1.0+(thesat1_exc*dps)));
zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gvsat_exc_dX = 0.5*(Gmob*deriv_sqrt_0_d0*(2.0*d_zsat_exc_dX)+d_Gmob_dX*(1.0+value_sqrt_0));
Gvsat_exc = (0.5*(Gmob*(1.0+value_sqrt_0)));
}
d_gfac_dX = (((Gvsat_exc*lc)*d_Gmob_dX-Gmob*(Gvsat_exc*d_lc_dX+d_Gvsat_exc_dX*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac = (Gmob/(Gvsat_exc*lc));
d_Sidexc_dX = ((((instanceStruct.instanceVar_fac_exc*Ids)*Vdse)*gfac)*d_gfac_dX+(((instanceStruct.instanceVar_fac_exc*Ids)*Vdse)*d_gfac_dX+((instanceStruct.instanceVar_fac_exc*Ids)*d_Vdse_dX+(instanceStruct.instanceVar_fac_exc*d_Ids_dX+instanceStruct.d_instanceVar_fac_exc_dX*Ids)*Vdse)*gfac)*gfac);
Sidexc = ((((instanceStruct.instanceVar_fac_exc*Ids)*Vdse)*gfac)*gfac);
d_mid_dX = (d_mid_dX+((modelStruct.modelVar_nt0*d_Sidexc_dX-Sidexc*modelStruct.d_modelVar_nt0_dX)/modelStruct.modelVar_nt0/modelStruct.modelVar_nt0));
mid = (mid+(Sidexc/modelStruct.modelVar_nt0));
instanceStruct.d_instanceVar_mig_dX = (instanceStruct.d_instanceVar_mig_dX+(((((12*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)*(Sidexc*12*d_t2_dX+d_Sidexc_dX*(1+(12*t2)))-(Sidexc*(1+(12*t2)))*(((12*g_ideal)*g_ideal)*modelStruct.d_modelVar_nt0_dX+((12*g_ideal)*d_g_ideal_dX+12*d_g_ideal_dX*g_ideal)*modelStruct.modelVar_nt0))/(((12*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)/(((12*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)));
instanceStruct.instanceVar_mig = (instanceStruct.instanceVar_mig+((Sidexc*(1+(12*t2)))/(((12*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)));
d_migid_dX = (d_migid_dX-(((g_ideal*modelStruct.modelVar_nt0)*((Sidexc*sqt2)*d_r_dX+(Sidexc*d_sqt2_dX+d_Sidexc_dX*sqt2)*(1+r))-((Sidexc*sqt2)*(1+r))*(g_ideal*modelStruct.d_modelVar_nt0_dX+d_g_ideal_dX*modelStruct.modelVar_nt0))/(g_ideal*modelStruct.modelVar_nt0)/(g_ideal*modelStruct.modelVar_nt0)));
migid = (migid-(((Sidexc*sqt2)*(1+r))/(g_ideal*modelStruct.modelVar_nt0)));
}
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_sqid_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_nt*d_mid_dX+instanceStruct.d_instanceVar_nt_dX*mid));
instanceStruct.instanceVar_sqid = value_sqrt_0;
}
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_nt/instanceStruct.instanceVar_mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqig_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_mig*instanceStruct.d_instanceVar_nt_dX-instanceStruct.instanceVar_nt*instanceStruct.d_instanceVar_mig_dX)/instanceStruct.instanceVar_mig/instanceStruct.instanceVar_mig));
sqig = value_sqrt_0;
}
if ((instanceStruct.instanceVar_sqid==0))
{
instanceStruct.d_instanceVar_c_igid_dX = 0.0;
instanceStruct.instanceVar_c_igid = 0.0;
}
else
{
instanceStruct.d_instanceVar_c_igid_dX = ((instanceStruct.instanceVar_sqid*(migid*d_sqig_dX+d_migid_dX*sqig)-(migid*sqig)*instanceStruct.d_instanceVar_sqid_dX)/instanceStruct.instanceVar_sqid/instanceStruct.instanceVar_sqid);
instanceStruct.instanceVar_c_igid = ((migid*sqig)/instanceStruct.instanceVar_sqid);
}
instanceStruct.d_instanceVar_c_igid_dX = ((instanceStruct.instanceVar_c_igid>0.0)?((instanceStruct.instanceVar_c_igid<1.0)?instanceStruct.d_instanceVar_c_igid_dX:0.0):0.0);
instanceStruct.instanceVar_c_igid = ((instanceStruct.instanceVar_c_igid>0.0)?((instanceStruct.instanceVar_c_igid<1.0)?instanceStruct.instanceVar_c_igid:1.0):0.0);
}
{
double value_fabs_0 = fabs(Igcs);
double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igcsx_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igcs_dX);
instanceStruct.instanceVar_shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igcd);
double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igcdx_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igcd_dX);
instanceStruct.instanceVar_shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igsov);
double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igsov_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igsov_dX);
instanceStruct.instanceVar_shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igdov);
double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igdov_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igdov_dX);
instanceStruct.instanceVar_shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Iimpact);
double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_iavl_dX = (2.0*1.6021918E-19)*((mavl+1)*deriv_fabs_0_d0*(d_Iimpact_dX)+d_mavl_dX*value_fabs_0);
instanceStruct.instanceVar_shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
}
{
double value_fabs_0 = fabs(ijun_s);
double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_jnoisex_s_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_ijun_s_dX);
instanceStruct.instanceVar_jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(ijun_d);
double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_jnoisex_d_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_ijun_d_dX);
instanceStruct.instanceVar_jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
}
if ((sigVds>0))
{
d_shot_igs_dX = (instanceStruct.d_instanceVar_shot_igcsx_dX+instanceStruct.d_instanceVar_shot_igsov_dX);
shot_igs = (instanceStruct.instanceVar_shot_igcsx+instanceStruct.instanceVar_shot_igsov);
d_shot_igd_dX = (instanceStruct.d_instanceVar_shot_igcdx_dX+instanceStruct.d_instanceVar_shot_igdov_dX);
shot_igd = (instanceStruct.instanceVar_shot_igcdx+instanceStruct.instanceVar_shot_igdov);
d_jnoise_s_dX = instanceStruct.d_instanceVar_jnoisex_s_dX;
jnoise_s = instanceStruct.instanceVar_jnoisex_s;
d_jnoise_d_dX = (instanceStruct.d_instanceVar_jnoisex_d_dX+instanceStruct.d_instanceVar_shot_iavl_dX);
jnoise_d = (instanceStruct.instanceVar_jnoisex_d+instanceStruct.instanceVar_shot_iavl);
}
else
{
d_shot_igs_dX = (instanceStruct.d_instanceVar_shot_igcdx_dX+instanceStruct.d_instanceVar_shot_igsov_dX);
shot_igs = (instanceStruct.instanceVar_shot_igcdx+instanceStruct.instanceVar_shot_igsov);
d_shot_igd_dX = (instanceStruct.d_instanceVar_shot_igcsx_dX+instanceStruct.d_instanceVar_shot_igdov_dX);
shot_igd = (instanceStruct.instanceVar_shot_igcsx+instanceStruct.instanceVar_shot_igdov);
d_jnoise_s_dX = (instanceStruct.d_instanceVar_jnoisex_s_dX+instanceStruct.d_instanceVar_shot_iavl_dX);
jnoise_s = (instanceStruct.instanceVar_jnoisex_s+instanceStruct.instanceVar_shot_iavl);
d_jnoise_d_dX = instanceStruct.d_instanceVar_jnoisex_d_dX;
jnoise_d = instanceStruct.instanceVar_jnoisex_d;
}
d_sf_dX = ((1e6*instanceStruct.instanceVar_CGeff)*instanceStruct.d_instanceVar_mig_dX+1e6*instanceStruct.d_instanceVar_CGeff_dX*instanceStruct.instanceVar_mig);
sf = ((1e6*instanceStruct.instanceVar_CGeff)*instanceStruct.instanceVar_mig);
// I(NOI2,GND) <+ (V(NOI2,GND))
d_staticContributions_dX[admsNodeID_NOI2]+= 0.0;
// I(NOI2,GND) <+ (white_noise((((sqig*sqig)*sf)*sf),"igig"))
// I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
d_staticContributions_dX[admsNodeID_NOI]+= (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX/sf/sf);
// I(NOI,GND) <+ ((V(NOI,GND)/mig))
d_staticContributions_dX[admsNodeID_NOI]+= (-(probeVars[admsProbeID_V_NOI_GND])*instanceStruct.d_instanceVar_mig_dX/instanceStruct.instanceVar_mig/instanceStruct.instanceVar_mig);
// I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
d_dynamicContributions_dX[admsNodeID_NOI]+= (instanceStruct.d_instanceVar_CGeff_dX*(probeVars[admsProbeID_V_NOI_GND]));
// I(D,S) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
// I(D,S) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
// I(D,S) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_staticContributions_dX[admsNodeID_D]+= ((sf*((sigVds*value_sqrt_0)*d_migid_dX+sigVds*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*migid)*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX)/sf/sf);
d_staticContributions_dX[(admsNodeID_S)]-= ((sf*((sigVds*value_sqrt_0)*d_migid_dX+sigVds*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*migid)*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX)/sf/sf);
}
// I(GP,S) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dynamicContributions_dX[admsNodeID_GP]+= (((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions_dX[(admsNodeID_S)]-= (((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND]));
}
// I(GP,D) <+ (ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND))))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dynamicContributions_dX[admsNodeID_GP]+= (((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions_dX[(admsNodeID_D)]-= (((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND]));
}
// I(GP,S) <+ (white_noise((MULT_i*shot_igs),"igs"))
// I(GP,D) <+ (white_noise((MULT_i*shot_igd),"igd"))
// I(BS,S) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
// I(BD,D) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
}
// End block noise
//Begin block OPinfo
{
//Block-local variables for block OPinfo
double temp=0.0;
double d_temp_dX=0.0;
//End of Block-local variables
d_id_op_dX = ((d_Ids_dX+d_Iimpact_dX)-d_Igcd_dX);
id_op = ((Ids+Iimpact)-Igcd);
d_is_dX = ((-d_Ids_dX)-d_Igcs_dX);
is = ((-Ids)-Igcs);
d_ig_dX = ((((d_Igcs_dX+d_Igcd_dX)+d_Igsov_dX)+d_Igdov_dX)+d_Igb_dX);
ig = ((((Igcs+Igcd)+Igsov)+Igdov)+Igb);
d_ib_dX = ((((-d_Iimpact_dX)-d_Igb_dX)-d_Igidl_dX)-d_Igisl_dX);
ib = ((((-Iimpact)-Igb)-Igidl)-Igisl);
d_sig1k_dX = ((2*3.1415926535897931)*1000)*instanceStruct.d_instanceVar_CGeff_dX;
sig1k = (((2*3.1415926535897931)*1000)*instanceStruct.instanceVar_CGeff);
d_sig1k_dX = ((sig1k*sig1k)*instanceStruct.d_instanceVar_mig_dX+(sig1k*d_sig1k_dX+d_sig1k_dX*sig1k)*instanceStruct.instanceVar_mig);
sig1k = ((sig1k*sig1k)*instanceStruct.instanceVar_mig);
if ((sigVds<0))
{
if ((modelStruct.modelVar_SWJUNEXP_i==1))
{
}
else
{
}
d_temp_dX = (((((d_Ids_dX+d_Iimpact_dX)+d_Igisl_dX)-d_Igcd_dX)-d_Igsov_dX)-d_ijun_s_dX);
temp = (((((Ids+Iimpact)+Igisl)-Igcd)-Igsov)-ijun_s);
}
else
{
if ((modelStruct.modelVar_SWJUNEXP_i==1))
{
}
else
{
}
d_temp_dX = (((((d_Ids_dX+d_Iimpact_dX)+d_Igidl_dX)-d_Igcd_dX)-d_Igdov_dX)-d_ijun_d_dX);
temp = (((((Ids+Iimpact)+Igidl)-Igcd)-Igdov)-ijun_d);
}
if ((fabs(1.0)<1e-18))
{
}
else
{
}
if ((fabs(1.0)<1e-12))
{
}
else
{
}
if ((fabs(((1.0+1.0)+1.0))<1e-30))
{
}
else
{
}
if ((fabs(1.0)<1e-18))
{
}
else
{
}
if ((1.0==0))
{
}
else
{
}
if ((sigVds<0))
{
}
else
{
}
}
// End block OPinfo
}
// End block evaluateblock
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(11+0);
dqdp.resize(11+0);
Findices.resize(11+0);
Qindices.resize(11+0);

std::vector <double> probeVars(18);
std::vector <double> d_staticContributions_dX(11+0);
std::vector <double> d_dynamicContributions_dX(11+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 11+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_LEVEL=mod.LEVEL;
modelStruct.d_modelPar_LEVEL_dX=0.0;
modelStruct.modelPar_given_LEVEL=mod.given("LEVEL");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.d_modelPar_TYPE_dX=0.0;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.d_modelPar_SWIGATE_dX=0.0;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.d_modelPar_SWIMPACT_dX=0.0;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.d_modelPar_SWGIDL_dX=0.0;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modelStruct.modelPar_SWJUNCAP=mod.SWJUNCAP;
modelStruct.d_modelPar_SWJUNCAP_dX=0.0;
modelStruct.modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.d_modelPar_SWJUNASYM_dX=0.0;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modelStruct.modelPar_TOXO=mod.TOXO;
modelStruct.d_modelPar_TOXO_dX=0.0;
modelStruct.modelPar_given_TOXO=mod.given("TOXO");
modelStruct.modelPar_EPSROXO=mod.EPSROXO;
modelStruct.d_modelPar_EPSROXO_dX=0.0;
modelStruct.modelPar_given_EPSROXO=mod.given("EPSROXO");
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modelStruct.modelPar_NSUBW=mod.NSUBW;
modelStruct.d_modelPar_NSUBW_dX=0.0;
modelStruct.modelPar_given_NSUBW=mod.given("NSUBW");
modelStruct.modelPar_WSEG=mod.WSEG;
modelStruct.d_modelPar_WSEG_dX=0.0;
modelStruct.modelPar_given_WSEG=mod.given("WSEG");
modelStruct.modelPar_NPCK=mod.NPCK;
modelStruct.d_modelPar_NPCK_dX=0.0;
modelStruct.modelPar_given_NPCK=mod.given("NPCK");
modelStruct.modelPar_NPCKW=mod.NPCKW;
modelStruct.d_modelPar_NPCKW_dX=0.0;
modelStruct.modelPar_given_NPCKW=mod.given("NPCKW");
modelStruct.modelPar_WSEGP=mod.WSEGP;
modelStruct.d_modelPar_WSEGP_dX=0.0;
modelStruct.modelPar_given_WSEGP=mod.given("WSEGP");
modelStruct.modelPar_LPCK=mod.LPCK;
modelStruct.d_modelPar_LPCK_dX=0.0;
modelStruct.modelPar_given_LPCK=mod.given("LPCK");
modelStruct.modelPar_LPCKW=mod.LPCKW;
modelStruct.d_modelPar_LPCKW_dX=0.0;
modelStruct.modelPar_given_LPCKW=mod.given("LPCKW");
modelStruct.modelPar_FOL1=mod.FOL1;
modelStruct.d_modelPar_FOL1_dX=0.0;
modelStruct.modelPar_given_FOL1=mod.given("FOL1");
modelStruct.modelPar_FOL2=mod.FOL2;
modelStruct.d_modelPar_FOL2_dX=0.0;
modelStruct.modelPar_given_FOL2=mod.given("FOL2");
modelStruct.modelPar_VNSUBO=mod.VNSUBO;
modelStruct.d_modelPar_VNSUBO_dX=0.0;
modelStruct.modelPar_given_VNSUBO=mod.given("VNSUBO");
modelStruct.modelPar_NSLPO=mod.NSLPO;
modelStruct.d_modelPar_NSLPO_dX=0.0;
modelStruct.modelPar_given_NSLPO=mod.given("NSLPO");
modelStruct.modelPar_DNSUBO=mod.DNSUBO;
modelStruct.d_modelPar_DNSUBO_dX=0.0;
modelStruct.modelPar_given_DNSUBO=mod.given("DNSUBO");
modelStruct.modelPar_DPHIBO=mod.DPHIBO;
modelStruct.d_modelPar_DPHIBO_dX=0.0;
modelStruct.modelPar_given_DPHIBO=mod.given("DPHIBO");
modelStruct.modelPar_DPHIBL=mod.DPHIBL;
modelStruct.d_modelPar_DPHIBL_dX=0.0;
modelStruct.modelPar_given_DPHIBL=mod.given("DPHIBL");
modelStruct.modelPar_DPHIBLEXP=mod.DPHIBLEXP;
modelStruct.d_modelPar_DPHIBLEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
modelStruct.modelPar_DPHIBW=mod.DPHIBW;
modelStruct.d_modelPar_DPHIBW_dX=0.0;
modelStruct.modelPar_given_DPHIBW=mod.given("DPHIBW");
modelStruct.modelPar_DPHIBLW=mod.DPHIBLW;
modelStruct.d_modelPar_DPHIBLW_dX=0.0;
modelStruct.modelPar_given_DPHIBLW=mod.given("DPHIBLW");
modelStruct.modelPar_NPO=mod.NPO;
modelStruct.d_modelPar_NPO_dX=0.0;
modelStruct.modelPar_given_NPO=mod.given("NPO");
modelStruct.modelPar_NPL=mod.NPL;
modelStruct.d_modelPar_NPL_dX=0.0;
modelStruct.modelPar_given_NPL=mod.given("NPL");
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modelStruct.modelPar_CTL=mod.CTL;
modelStruct.d_modelPar_CTL_dX=0.0;
modelStruct.modelPar_given_CTL=mod.given("CTL");
modelStruct.modelPar_CTLEXP=mod.CTLEXP;
modelStruct.d_modelPar_CTLEXP_dX=0.0;
modelStruct.modelPar_given_CTLEXP=mod.given("CTLEXP");
modelStruct.modelPar_CTW=mod.CTW;
modelStruct.d_modelPar_CTW_dX=0.0;
modelStruct.modelPar_given_CTW=mod.given("CTW");
modelStruct.modelPar_CTLW=mod.CTLW;
modelStruct.d_modelPar_CTLW_dX=0.0;
modelStruct.modelPar_given_CTLW=mod.given("CTLW");
modelStruct.modelPar_TOXOVO=mod.TOXOVO;
modelStruct.d_modelPar_TOXOVO_dX=0.0;
modelStruct.modelPar_given_TOXOVO=mod.given("TOXOVO");
modelStruct.modelPar_TOXOVDO=mod.TOXOVDO;
modelStruct.d_modelPar_TOXOVDO_dX=0.0;
modelStruct.modelPar_given_TOXOVDO=mod.given("TOXOVDO");
modelStruct.modelPar_LOV=mod.LOV;
modelStruct.d_modelPar_LOV_dX=0.0;
modelStruct.modelPar_given_LOV=mod.given("LOV");
modelStruct.modelPar_LOVD=mod.LOVD;
modelStruct.d_modelPar_LOVD_dX=0.0;
modelStruct.modelPar_given_LOVD=mod.given("LOVD");
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modelStruct.modelPar_MUEW=mod.MUEW;
modelStruct.d_modelPar_MUEW_dX=0.0;
modelStruct.modelPar_given_MUEW=mod.given("MUEW");
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modelStruct.modelPar_ALPL=mod.ALPL;
modelStruct.d_modelPar_ALPL_dX=0.0;
modelStruct.modelPar_given_ALPL=mod.given("ALPL");
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modelStruct.modelPar_ALP2L1=mod.ALP2L1;
modelStruct.d_modelPar_ALP2L1_dX=0.0;
modelStruct.modelPar_given_ALP2L1=mod.given("ALP2L1");
modelStruct.modelPar_ALP2LEXP=mod.ALP2LEXP;
modelStruct.d_modelPar_ALP2LEXP_dX=0.0;
modelStruct.modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
modelStruct.modelPar_ALP2L2=mod.ALP2L2;
modelStruct.d_modelPar_ALP2L2_dX=0.0;
modelStruct.modelPar_given_ALP2L2=mod.given("ALP2L2");
modelStruct.modelPar_ALP2W=mod.ALP2W;
modelStruct.d_modelPar_ALP2W_dX=0.0;
modelStruct.modelPar_given_ALP2W=mod.given("ALP2W");
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modelStruct.modelPar_A4O=mod.A4O;
modelStruct.d_modelPar_A4O_dX=0.0;
modelStruct.modelPar_given_A4O=mod.given("A4O");
modelStruct.modelPar_A4L=mod.A4L;
modelStruct.d_modelPar_A4L_dX=0.0;
modelStruct.modelPar_given_A4L=mod.given("A4L");
modelStruct.modelPar_A4W=mod.A4W;
modelStruct.d_modelPar_A4W_dX=0.0;
modelStruct.modelPar_given_A4W=mod.given("A4W");
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modelStruct.modelPar_IGOVW=mod.IGOVW;
modelStruct.d_modelPar_IGOVW_dX=0.0;
modelStruct.modelPar_given_IGOVW=mod.given("IGOVW");
modelStruct.modelPar_IGOVDW=mod.IGOVDW;
modelStruct.d_modelPar_IGOVDW_dX=0.0;
modelStruct.modelPar_given_IGOVDW=mod.given("IGOVDW");
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modelStruct.modelPar_GC2O=mod.GC2O;
modelStruct.d_modelPar_GC2O_dX=0.0;
modelStruct.modelPar_given_GC2O=mod.given("GC2O");
modelStruct.modelPar_GC3O=mod.GC3O;
modelStruct.d_modelPar_GC3O_dX=0.0;
modelStruct.modelPar_given_GC3O=mod.given("GC3O");
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modelStruct.modelPar_ALPNOI=mod.ALPNOI;
modelStruct.d_modelPar_ALPNOI_dX=0.0;
modelStruct.modelPar_given_ALPNOI=mod.given("ALPNOI");
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");
modelStruct.modelPar_KVTHOWEO=mod.KVTHOWEO;
modelStruct.d_modelPar_KVTHOWEO_dX=0.0;
modelStruct.modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
modelStruct.modelPar_KVTHOWEL=mod.KVTHOWEL;
modelStruct.d_modelPar_KVTHOWEL_dX=0.0;
modelStruct.modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
modelStruct.modelPar_KVTHOWEW=mod.KVTHOWEW;
modelStruct.d_modelPar_KVTHOWEW_dX=0.0;
modelStruct.modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
modelStruct.modelPar_KVTHOWELW=mod.KVTHOWELW;
modelStruct.d_modelPar_KVTHOWELW_dX=0.0;
modelStruct.modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
modelStruct.modelPar_KUOWEO=mod.KUOWEO;
modelStruct.d_modelPar_KUOWEO_dX=0.0;
modelStruct.modelPar_given_KUOWEO=mod.given("KUOWEO");
modelStruct.modelPar_KUOWEL=mod.KUOWEL;
modelStruct.d_modelPar_KUOWEL_dX=0.0;
modelStruct.modelPar_given_KUOWEL=mod.given("KUOWEL");
modelStruct.modelPar_KUOWEW=mod.KUOWEW;
modelStruct.d_modelPar_KUOWEW_dX=0.0;
modelStruct.modelPar_given_KUOWEW=mod.given("KUOWEW");
modelStruct.modelPar_KUOWELW=mod.KUOWELW;
modelStruct.d_modelPar_KUOWELW_dX=0.0;
modelStruct.modelPar_given_KUOWELW=mod.given("KUOWELW");
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modelStruct.modelPar_RGO=mod.RGO;
modelStruct.d_modelPar_RGO_dX=0.0;
modelStruct.modelPar_given_RGO=mod.given("RGO");
modelStruct.modelPar_RBULKO=mod.RBULKO;
modelStruct.d_modelPar_RBULKO_dX=0.0;
modelStruct.modelPar_given_RBULKO=mod.given("RBULKO");
modelStruct.modelPar_RWELLO=mod.RWELLO;
modelStruct.d_modelPar_RWELLO_dX=0.0;
modelStruct.modelPar_given_RWELLO=mod.given("RWELLO");
modelStruct.modelPar_RJUNSO=mod.RJUNSO;
modelStruct.d_modelPar_RJUNSO_dX=0.0;
modelStruct.modelPar_given_RJUNSO=mod.given("RJUNSO");
modelStruct.modelPar_RJUNDO=mod.RJUNDO;
modelStruct.d_modelPar_RJUNDO_dX=0.0;
modelStruct.modelPar_given_RJUNDO=mod.given("RJUNDO");
modelStruct.modelPar_RINT=mod.RINT;
modelStruct.d_modelPar_RINT_dX=0.0;
modelStruct.modelPar_given_RINT=mod.given("RINT");
modelStruct.modelPar_RVPOLY=mod.RVPOLY;
modelStruct.d_modelPar_RVPOLY_dX=0.0;
modelStruct.modelPar_given_RVPOLY=mod.given("RVPOLY");
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modelStruct.modelPar_DLSIL=mod.DLSIL;
modelStruct.d_modelPar_DLSIL_dX=0.0;
modelStruct.modelPar_given_DLSIL=mod.given("DLSIL");
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modelStruct.modelPar_CJORBOTD=mod.CJORBOTD;
modelStruct.d_modelPar_CJORBOTD_dX=0.0;
modelStruct.modelPar_given_CJORBOTD=mod.given("CJORBOTD");
modelStruct.modelPar_CJORSTID=mod.CJORSTID;
modelStruct.d_modelPar_CJORSTID_dX=0.0;
modelStruct.modelPar_given_CJORSTID=mod.given("CJORSTID");
modelStruct.modelPar_CJORGATD=mod.CJORGATD;
modelStruct.d_modelPar_CJORGATD_dX=0.0;
modelStruct.modelPar_given_CJORGATD=mod.given("CJORGATD");
modelStruct.modelPar_VBIRBOTD=mod.VBIRBOTD;
modelStruct.d_modelPar_VBIRBOTD_dX=0.0;
modelStruct.modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
modelStruct.modelPar_VBIRSTID=mod.VBIRSTID;
modelStruct.d_modelPar_VBIRSTID_dX=0.0;
modelStruct.modelPar_given_VBIRSTID=mod.given("VBIRSTID");
modelStruct.modelPar_VBIRGATD=mod.VBIRGATD;
modelStruct.d_modelPar_VBIRGATD_dX=0.0;
modelStruct.modelPar_given_VBIRGATD=mod.given("VBIRGATD");
modelStruct.modelPar_PBOTD=mod.PBOTD;
modelStruct.d_modelPar_PBOTD_dX=0.0;
modelStruct.modelPar_given_PBOTD=mod.given("PBOTD");
modelStruct.modelPar_PSTID=mod.PSTID;
modelStruct.d_modelPar_PSTID_dX=0.0;
modelStruct.modelPar_given_PSTID=mod.given("PSTID");
modelStruct.modelPar_PGATD=mod.PGATD;
modelStruct.d_modelPar_PGATD_dX=0.0;
modelStruct.modelPar_given_PGATD=mod.given("PGATD");
modelStruct.modelPar_PHIGBOTD=mod.PHIGBOTD;
modelStruct.d_modelPar_PHIGBOTD_dX=0.0;
modelStruct.modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
modelStruct.modelPar_PHIGSTID=mod.PHIGSTID;
modelStruct.d_modelPar_PHIGSTID_dX=0.0;
modelStruct.modelPar_given_PHIGSTID=mod.given("PHIGSTID");
modelStruct.modelPar_PHIGGATD=mod.PHIGGATD;
modelStruct.d_modelPar_PHIGGATD_dX=0.0;
modelStruct.modelPar_given_PHIGGATD=mod.given("PHIGGATD");
modelStruct.modelPar_IDSATRBOTD=mod.IDSATRBOTD;
modelStruct.d_modelPar_IDSATRBOTD_dX=0.0;
modelStruct.modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
modelStruct.modelPar_IDSATRSTID=mod.IDSATRSTID;
modelStruct.d_modelPar_IDSATRSTID_dX=0.0;
modelStruct.modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
modelStruct.modelPar_IDSATRGATD=mod.IDSATRGATD;
modelStruct.d_modelPar_IDSATRGATD_dX=0.0;
modelStruct.modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
modelStruct.modelPar_CSRHBOTD=mod.CSRHBOTD;
modelStruct.d_modelPar_CSRHBOTD_dX=0.0;
modelStruct.modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
modelStruct.modelPar_CSRHSTID=mod.CSRHSTID;
modelStruct.d_modelPar_CSRHSTID_dX=0.0;
modelStruct.modelPar_given_CSRHSTID=mod.given("CSRHSTID");
modelStruct.modelPar_CSRHGATD=mod.CSRHGATD;
modelStruct.d_modelPar_CSRHGATD_dX=0.0;
modelStruct.modelPar_given_CSRHGATD=mod.given("CSRHGATD");
modelStruct.modelPar_XJUNSTID=mod.XJUNSTID;
modelStruct.d_modelPar_XJUNSTID_dX=0.0;
modelStruct.modelPar_given_XJUNSTID=mod.given("XJUNSTID");
modelStruct.modelPar_XJUNGATD=mod.XJUNGATD;
modelStruct.d_modelPar_XJUNGATD_dX=0.0;
modelStruct.modelPar_given_XJUNGATD=mod.given("XJUNGATD");
modelStruct.modelPar_CTATBOTD=mod.CTATBOTD;
modelStruct.d_modelPar_CTATBOTD_dX=0.0;
modelStruct.modelPar_given_CTATBOTD=mod.given("CTATBOTD");
modelStruct.modelPar_CTATSTID=mod.CTATSTID;
modelStruct.d_modelPar_CTATSTID_dX=0.0;
modelStruct.modelPar_given_CTATSTID=mod.given("CTATSTID");
modelStruct.modelPar_CTATGATD=mod.CTATGATD;
modelStruct.d_modelPar_CTATGATD_dX=0.0;
modelStruct.modelPar_given_CTATGATD=mod.given("CTATGATD");
modelStruct.modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
modelStruct.d_modelPar_MEFFTATBOTD_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
modelStruct.modelPar_MEFFTATSTID=mod.MEFFTATSTID;
modelStruct.d_modelPar_MEFFTATSTID_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
modelStruct.modelPar_MEFFTATGATD=mod.MEFFTATGATD;
modelStruct.d_modelPar_MEFFTATGATD_dX=0.0;
modelStruct.modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
modelStruct.modelPar_CBBTBOTD=mod.CBBTBOTD;
modelStruct.d_modelPar_CBBTBOTD_dX=0.0;
modelStruct.modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
modelStruct.modelPar_CBBTSTID=mod.CBBTSTID;
modelStruct.d_modelPar_CBBTSTID_dX=0.0;
modelStruct.modelPar_given_CBBTSTID=mod.given("CBBTSTID");
modelStruct.modelPar_CBBTGATD=mod.CBBTGATD;
modelStruct.d_modelPar_CBBTGATD_dX=0.0;
modelStruct.modelPar_given_CBBTGATD=mod.given("CBBTGATD");
modelStruct.modelPar_FBBTRBOTD=mod.FBBTRBOTD;
modelStruct.d_modelPar_FBBTRBOTD_dX=0.0;
modelStruct.modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
modelStruct.modelPar_FBBTRSTID=mod.FBBTRSTID;
modelStruct.d_modelPar_FBBTRSTID_dX=0.0;
modelStruct.modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
modelStruct.modelPar_FBBTRGATD=mod.FBBTRGATD;
modelStruct.d_modelPar_FBBTRGATD_dX=0.0;
modelStruct.modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
modelStruct.modelPar_STFBBTBOTD=mod.STFBBTBOTD;
modelStruct.d_modelPar_STFBBTBOTD_dX=0.0;
modelStruct.modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
modelStruct.modelPar_STFBBTSTID=mod.STFBBTSTID;
modelStruct.d_modelPar_STFBBTSTID_dX=0.0;
modelStruct.modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
modelStruct.modelPar_STFBBTGATD=mod.STFBBTGATD;
modelStruct.d_modelPar_STFBBTGATD_dX=0.0;
modelStruct.modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
modelStruct.modelPar_VBRBOTD=mod.VBRBOTD;
modelStruct.d_modelPar_VBRBOTD_dX=0.0;
modelStruct.modelPar_given_VBRBOTD=mod.given("VBRBOTD");
modelStruct.modelPar_VBRSTID=mod.VBRSTID;
modelStruct.d_modelPar_VBRSTID_dX=0.0;
modelStruct.modelPar_given_VBRSTID=mod.given("VBRSTID");
modelStruct.modelPar_VBRGATD=mod.VBRGATD;
modelStruct.d_modelPar_VBRGATD_dX=0.0;
modelStruct.modelPar_given_VBRGATD=mod.given("VBRGATD");
modelStruct.modelPar_PBRBOTD=mod.PBRBOTD;
modelStruct.d_modelPar_PBRBOTD_dX=0.0;
modelStruct.modelPar_given_PBRBOTD=mod.given("PBRBOTD");
modelStruct.modelPar_PBRSTID=mod.PBRSTID;
modelStruct.d_modelPar_PBRSTID_dX=0.0;
modelStruct.modelPar_given_PBRSTID=mod.given("PBRSTID");
modelStruct.modelPar_PBRGATD=mod.PBRGATD;
modelStruct.d_modelPar_PBRGATD_dX=0.0;
modelStruct.modelPar_given_PBRGATD=mod.given("PBRGATD");
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modelStruct.modelPar_VJUNREFD=mod.VJUNREFD;
modelStruct.d_modelPar_VJUNREFD_dX=0.0;
modelStruct.modelPar_given_VJUNREFD=mod.given("VJUNREFD");
modelStruct.modelPar_FJUNQD=mod.FJUNQD;
modelStruct.d_modelPar_FJUNQD_dX=0.0;
modelStruct.modelPar_given_FJUNQD=mod.given("FJUNQD");


// hidden reals


// non-reals (including hiddens)



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
inParamMap["L"] = &(instanceStruct.d_instancePar_L_dX);
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
inParamMap["W"] = &(instanceStruct.d_instancePar_W_dX);
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
inParamMap["SA"] = &(instanceStruct.d_instancePar_SA_dX);
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
inParamMap["SB"] = &(instanceStruct.d_instancePar_SB_dX);
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
inParamMap["SD"] = &(instanceStruct.d_instancePar_SD_dX);
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.d_instancePar_SCA_dX=0.0;
instanceStruct.instancePar_given_SCA=in.given("SCA");
inParamMap["SCA"] = &(instanceStruct.d_instancePar_SCA_dX);
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.d_instancePar_SCB_dX=0.0;
instanceStruct.instancePar_given_SCB=in.given("SCB");
inParamMap["SCB"] = &(instanceStruct.d_instancePar_SCB_dX);
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.d_instancePar_SCC_dX=0.0;
instanceStruct.instancePar_given_SCC=in.given("SCC");
inParamMap["SCC"] = &(instanceStruct.d_instancePar_SCC_dX);
instanceStruct.instancePar_SC=in.SC;
instanceStruct.d_instancePar_SC_dX=0.0;
instanceStruct.instancePar_given_SC=in.given("SC");
inParamMap["SC"] = &(instanceStruct.d_instancePar_SC_dX);
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
inParamMap["DELVTO"] = &(instanceStruct.d_instancePar_DELVTO_dX);
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");
inParamMap["FACTUO"] = &(instanceStruct.d_instancePar_FACTUO_dX);
instanceStruct.instancePar_ABSOURCE=in.ABSOURCE;
instanceStruct.d_instancePar_ABSOURCE_dX=0.0;
instanceStruct.instancePar_given_ABSOURCE=in.given("ABSOURCE");
inParamMap["ABSOURCE"] = &(instanceStruct.d_instancePar_ABSOURCE_dX);
instanceStruct.instancePar_LSSOURCE=in.LSSOURCE;
instanceStruct.d_instancePar_LSSOURCE_dX=0.0;
instanceStruct.instancePar_given_LSSOURCE=in.given("LSSOURCE");
inParamMap["LSSOURCE"] = &(instanceStruct.d_instancePar_LSSOURCE_dX);
instanceStruct.instancePar_LGSOURCE=in.LGSOURCE;
instanceStruct.d_instancePar_LGSOURCE_dX=0.0;
instanceStruct.instancePar_given_LGSOURCE=in.given("LGSOURCE");
inParamMap["LGSOURCE"] = &(instanceStruct.d_instancePar_LGSOURCE_dX);
instanceStruct.instancePar_ABDRAIN=in.ABDRAIN;
instanceStruct.d_instancePar_ABDRAIN_dX=0.0;
instanceStruct.instancePar_given_ABDRAIN=in.given("ABDRAIN");
inParamMap["ABDRAIN"] = &(instanceStruct.d_instancePar_ABDRAIN_dX);
instanceStruct.instancePar_LSDRAIN=in.LSDRAIN;
instanceStruct.d_instancePar_LSDRAIN_dX=0.0;
instanceStruct.instancePar_given_LSDRAIN=in.given("LSDRAIN");
inParamMap["LSDRAIN"] = &(instanceStruct.d_instancePar_LSDRAIN_dX);
instanceStruct.instancePar_LGDRAIN=in.LGDRAIN;
instanceStruct.d_instancePar_LGDRAIN_dX=0.0;
instanceStruct.instancePar_given_LGDRAIN=in.given("LGDRAIN");
inParamMap["LGDRAIN"] = &(instanceStruct.d_instancePar_LGDRAIN_dX);
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
inParamMap["AS"] = &(instanceStruct.d_instancePar_AS_dX);
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
inParamMap["PS"] = &(instanceStruct.d_instancePar_PS_dX);
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
inParamMap["AD"] = &(instanceStruct.d_instancePar_AD_dX);
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
inParamMap["PD"] = &(instanceStruct.d_instancePar_PD_dX);
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");
inParamMap["MULT"] = &(instanceStruct.d_instancePar_MULT_dX);
instanceStruct.instancePar_NF=in.NF;
instanceStruct.d_instancePar_NF_dX=0.0;
instanceStruct.instancePar_given_NF=in.given("NF");
inParamMap["NF"] = &(instanceStruct.d_instancePar_NF_dX);
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.d_instancePar_NGCON_dX=0.0;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
inParamMap["NGCON"] = &(instanceStruct.d_instancePar_NGCON_dX);
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");
inParamMap["XGW"] = &(instanceStruct.d_instancePar_XGW_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_LE=in.LE;
instanceStruct.d_instanceVar_LE_dX=0.0;
instanceStruct.instanceVar_WE=in.WE;
instanceStruct.d_instanceVar_WE_dX=0.0;
instanceStruct.instanceVar_VFB_i=in.VFB_i;
instanceStruct.d_instanceVar_VFB_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_NEFF_i=in.NEFF_i;
instanceStruct.d_instanceVar_NEFF_i_dX=0.0;
instanceStruct.instanceVar_VNSUB_i=in.VNSUB_i;
instanceStruct.d_instanceVar_VNSUB_i_dX=0.0;
instanceStruct.instanceVar_NSLP_i=in.NSLP_i;
instanceStruct.d_instanceVar_NSLP_i_dX=0.0;
instanceStruct.instanceVar_DNSUB_i=in.DNSUB_i;
instanceStruct.d_instanceVar_DNSUB_i_dX=0.0;
instanceStruct.instanceVar_NP_i=in.NP_i;
instanceStruct.d_instanceVar_NP_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CFB_i=in.CFB_i;
instanceStruct.d_instanceVar_CFB_i_dX=0.0;
instanceStruct.instanceVar_DPHIB_i=in.DPHIB_i;
instanceStruct.d_instanceVar_DPHIB_i_dX=0.0;
instanceStruct.instanceVar_BETN_i=in.BETN_i;
instanceStruct.d_instanceVar_BETN_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_MUE_i=in.MUE_i;
instanceStruct.d_instanceVar_MUE_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_THEMU_i=in.THEMU_i;
instanceStruct.d_instanceVar_THEMU_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_CS_i=in.CS_i;
instanceStruct.d_instanceVar_CS_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_XCOR_i=in.XCOR_i;
instanceStruct.d_instanceVar_XCOR_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_FETA_i=in.FETA_i;
instanceStruct.d_instanceVar_FETA_i_dX=0.0;
instanceStruct.instanceVar_RS_i=in.RS_i;
instanceStruct.d_instanceVar_RS_i_dX=0.0;
instanceStruct.instanceVar_THER_i=in.THER_i;
instanceStruct.d_instanceVar_THER_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_THESAT_i=in.THESAT_i;
instanceStruct.d_instanceVar_THESAT_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_THESATB_i=in.THESATB_i;
instanceStruct.d_instanceVar_THESATB_i_dX=0.0;
instanceStruct.instanceVar_THESATG_i=in.THESATG_i;
instanceStruct.d_instanceVar_THESATG_i_dX=0.0;
instanceStruct.instanceVar_AX_i=in.AX_i;
instanceStruct.d_instanceVar_AX_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALP2_i=in.ALP2_i;
instanceStruct.d_instanceVar_ALP2_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_A4_i=in.A4_i;
instanceStruct.d_instanceVar_A4_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOV_i=in.IGOV_i;
instanceStruct.d_instanceVar_IGOV_i_dX=0.0;
instanceStruct.instanceVar_IGOVD_i=in.IGOVD_i;
instanceStruct.d_instanceVar_IGOVD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_GC2_i=in.GC2_i;
instanceStruct.d_instanceVar_GC2_i_dX=0.0;
instanceStruct.instanceVar_GC3_i=in.GC3_i;
instanceStruct.d_instanceVar_GC3_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_COX_i=in.COX_i;
instanceStruct.d_instanceVar_COX_i_dX=0.0;
instanceStruct.instanceVar_CGOV_i=in.CGOV_i;
instanceStruct.d_instanceVar_CGOV_i_dX=0.0;
instanceStruct.instanceVar_CGOVD_i=in.CGOVD_i;
instanceStruct.d_instanceVar_CGOVD_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_BET_i=in.BET_i;
instanceStruct.d_instanceVar_BET_i_dX=0.0;
instanceStruct.instanceVar_kp=in.kp;
instanceStruct.d_instanceVar_kp_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_qlim2=in.qlim2;
instanceStruct.d_instanceVar_qlim2_dX=0.0;
instanceStruct.instanceVar_E_eff0=in.E_eff0;
instanceStruct.d_instanceVar_E_eff0_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_GCQ=in.GCQ;
instanceStruct.d_instanceVar_GCQ_dX=0.0;
instanceStruct.instanceVar_Dch=in.Dch;
instanceStruct.d_instanceVar_Dch_dX=0.0;
instanceStruct.instanceVar_Dov=in.Dov;
instanceStruct.d_instanceVar_Dov_dX=0.0;
instanceStruct.instanceVar_x1=in.x1;
instanceStruct.instanceVar_Vdsat_lim=in.Vdsat_lim;
instanceStruct.d_instanceVar_Vdsat_lim_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_Cox_over_q=in.Cox_over_q;
instanceStruct.d_instanceVar_Cox_over_q_dX=0.0;
instanceStruct.instanceVar_GOV_s=in.GOV_s;
instanceStruct.d_instanceVar_GOV_s_dX=0.0;
instanceStruct.instanceVar_GOV_d=in.GOV_d;
instanceStruct.d_instanceVar_GOV_d_dX=0.0;
instanceStruct.instanceVar_GOV2_s=in.GOV2_s;
instanceStruct.d_instanceVar_GOV2_s_dX=0.0;
instanceStruct.instanceVar_GOV2_d=in.GOV2_d;
instanceStruct.d_instanceVar_GOV2_d_dX=0.0;
instanceStruct.instanceVar_BOV_d=in.BOV_d;
instanceStruct.d_instanceVar_BOV_d_dX=0.0;
instanceStruct.instanceVar_xi_ov_s=in.xi_ov_s;
instanceStruct.d_instanceVar_xi_ov_s_dX=0.0;
instanceStruct.instanceVar_xi_ov_d=in.xi_ov_d;
instanceStruct.d_instanceVar_xi_ov_d_dX=0.0;
instanceStruct.instanceVar_inv_xi_ov_s=in.inv_xi_ov_s;
instanceStruct.d_instanceVar_inv_xi_ov_s_dX=0.0;
instanceStruct.instanceVar_inv_xi_ov_d=in.inv_xi_ov_d;
instanceStruct.d_instanceVar_inv_xi_ov_d_dX=0.0;
instanceStruct.instanceVar_x_mrg_ov_s=in.x_mrg_ov_s;
instanceStruct.d_instanceVar_x_mrg_ov_s_dX=0.0;
instanceStruct.instanceVar_x_mrg_ov_d=in.x_mrg_ov_d;
instanceStruct.d_instanceVar_x_mrg_ov_d_dX=0.0;
instanceStruct.instanceVar_inv_xg1_s=in.inv_xg1_s;
instanceStruct.d_instanceVar_inv_xg1_s_dX=0.0;
instanceStruct.instanceVar_inv_xg1_d=in.inv_xg1_d;
instanceStruct.d_instanceVar_inv_xg1_d_dX=0.0;
instanceStruct.instanceVar_AGIDLs=in.AGIDLs;
instanceStruct.d_instanceVar_AGIDLs_dX=0.0;
instanceStruct.instanceVar_AGIDLDs=in.AGIDLDs;
instanceStruct.d_instanceVar_AGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDLs=in.BGIDLs;
instanceStruct.d_instanceVar_BGIDLs_dX=0.0;
instanceStruct.instanceVar_BGIDLDs=in.BGIDLDs;
instanceStruct.d_instanceVar_BGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDL_T=in.BGIDL_T;
instanceStruct.d_instanceVar_BGIDL_T_dX=0.0;
instanceStruct.instanceVar_BGIDLD_T=in.BGIDLD_T;
instanceStruct.d_instanceVar_BGIDLD_T_dX=0.0;
instanceStruct.instanceVar_phib=in.phib;
instanceStruct.d_instanceVar_phib_dX=0.0;
instanceStruct.instanceVar_sqrt_phib=in.sqrt_phib;
instanceStruct.d_instanceVar_sqrt_phib_dX=0.0;
instanceStruct.instanceVar_phix=in.phix;
instanceStruct.d_instanceVar_phix_dX=0.0;
instanceStruct.instanceVar_aphi=in.aphi;
instanceStruct.d_instanceVar_aphi_dX=0.0;
instanceStruct.instanceVar_bphi=in.bphi;
instanceStruct.d_instanceVar_bphi_dX=0.0;
instanceStruct.instanceVar_phix1=in.phix1;
instanceStruct.d_instanceVar_phix1_dX=0.0;
instanceStruct.instanceVar_G_0=in.G_0;
instanceStruct.d_instanceVar_G_0_dX=0.0;
instanceStruct.instanceVar_phit1=in.phit1;
instanceStruct.d_instanceVar_phit1_dX=0.0;
instanceStruct.instanceVar_inv_phit1=in.inv_phit1;
instanceStruct.d_instanceVar_inv_phit1_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_inv_VP=in.inv_VP;
instanceStruct.d_instanceVar_inv_VP_dX=0.0;
instanceStruct.instanceVar_inv_AX=in.inv_AX;
instanceStruct.d_instanceVar_inv_AX_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac=in.Sfl_prefac;
instanceStruct.d_instanceVar_Sfl_prefac_dX=0.0;
instanceStruct.instanceVar_Sfl=in.Sfl;
instanceStruct.d_instanceVar_Sfl_dX=0.0;
instanceStruct.instanceVar_CGeff=in.CGeff;
instanceStruct.d_instanceVar_CGeff_dX=0.0;
instanceStruct.instanceVar_mig=in.mig;
instanceStruct.d_instanceVar_mig_dX=0.0;
instanceStruct.instanceVar_c_igid=in.c_igid;
instanceStruct.d_instanceVar_c_igid_dX=0.0;
instanceStruct.instanceVar_sqid=in.sqid;
instanceStruct.d_instanceVar_sqid_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_shot_iavl=in.shot_iavl;
instanceStruct.d_instanceVar_shot_iavl_dX=0.0;
instanceStruct.instanceVar_shot_igcsx=in.shot_igcsx;
instanceStruct.d_instanceVar_shot_igcsx_dX=0.0;
instanceStruct.instanceVar_shot_igcdx=in.shot_igcdx;
instanceStruct.d_instanceVar_shot_igcdx_dX=0.0;
instanceStruct.instanceVar_shot_igsov=in.shot_igsov;
instanceStruct.d_instanceVar_shot_igsov_dX=0.0;
instanceStruct.instanceVar_shot_igdov=in.shot_igdov;
instanceStruct.d_instanceVar_shot_igdov_dX=0.0;
instanceStruct.instanceVar_RG_i=in.RG_i;
instanceStruct.d_instanceVar_RG_i_dX=0.0;
instanceStruct.instanceVar_RBULK_i=in.RBULK_i;
instanceStruct.d_instanceVar_RBULK_i_dX=0.0;
instanceStruct.instanceVar_RWELL_i=in.RWELL_i;
instanceStruct.d_instanceVar_RWELL_i_dX=0.0;
instanceStruct.instanceVar_RJUNS_i=in.RJUNS_i;
instanceStruct.d_instanceVar_RJUNS_i_dX=0.0;
instanceStruct.instanceVar_RJUND_i=in.RJUND_i;
instanceStruct.d_instanceVar_RJUND_i_dX=0.0;
instanceStruct.instanceVar_ggate=in.ggate;
instanceStruct.d_instanceVar_ggate_dX=0.0;
instanceStruct.instanceVar_gbulk=in.gbulk;
instanceStruct.d_instanceVar_gbulk_dX=0.0;
instanceStruct.instanceVar_gwell=in.gwell;
instanceStruct.d_instanceVar_gwell_dX=0.0;
instanceStruct.instanceVar_gjund=in.gjund;
instanceStruct.d_instanceVar_gjund_dX=0.0;
instanceStruct.instanceVar_gjuns=in.gjuns;
instanceStruct.d_instanceVar_gjuns_dX=0.0;
instanceStruct.instanceVar_ABSOURCE_i=in.ABSOURCE_i;
instanceStruct.d_instanceVar_ABSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LSSOURCE_i=in.LSSOURCE_i;
instanceStruct.d_instanceVar_LSSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LGSOURCE_i=in.LGSOURCE_i;
instanceStruct.d_instanceVar_LGSOURCE_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_s=in.zflagbot_s;
instanceStruct.instanceVar_zflagsti_s=in.zflagsti_s;
instanceStruct.instanceVar_zflaggat_s=in.zflaggat_s;
instanceStruct.instanceVar_VMAX_s=in.VMAX_s;
instanceStruct.d_instanceVar_VMAX_s_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX=0.0;
instanceStruct.instanceVar_vbimin_s=in.vbimin_s;
instanceStruct.d_instanceVar_vbimin_s_dX=0.0;
instanceStruct.instanceVar_vch_s=in.vch_s;
instanceStruct.d_instanceVar_vch_s_dX=0.0;
instanceStruct.instanceVar_vfmin_s=in.vfmin_s;
instanceStruct.d_instanceVar_vfmin_s_dX=0.0;
instanceStruct.instanceVar_vbbtlim_s=in.vbbtlim_s;
instanceStruct.d_instanceVar_vbbtlim_s_dX=0.0;
instanceStruct.instanceVar_xhighf1_s=in.xhighf1_s;
instanceStruct.d_instanceVar_xhighf1_s_dX=0.0;
instanceStruct.instanceVar_expxhf1_s=in.expxhf1_s;
instanceStruct.d_instanceVar_expxhf1_s_dX=0.0;
instanceStruct.instanceVar_xhighf2_s=in.xhighf2_s;
instanceStruct.d_instanceVar_xhighf2_s_dX=0.0;
instanceStruct.instanceVar_expxhf2_s=in.expxhf2_s;
instanceStruct.d_instanceVar_expxhf2_s_dX=0.0;
instanceStruct.instanceVar_xhighr_s=in.xhighr_s;
instanceStruct.d_instanceVar_xhighr_s_dX=0.0;
instanceStruct.instanceVar_expxhr_s=in.expxhr_s;
instanceStruct.d_instanceVar_expxhr_s_dX=0.0;
instanceStruct.instanceVar_m0flag_s=in.m0flag_s;
instanceStruct.instanceVar_ISATFOR1_s=in.ISATFOR1_s;
instanceStruct.d_instanceVar_ISATFOR1_s_dX=0.0;
instanceStruct.instanceVar_MFOR1_s=in.MFOR1_s;
instanceStruct.instanceVar_ISATFOR2_s=in.ISATFOR2_s;
instanceStruct.d_instanceVar_ISATFOR2_s_dX=0.0;
instanceStruct.instanceVar_MFOR2_s=in.MFOR2_s;
instanceStruct.d_instanceVar_MFOR2_s_dX=0.0;
instanceStruct.instanceVar_ISATREV_s=in.ISATREV_s;
instanceStruct.d_instanceVar_ISATREV_s_dX=0.0;
instanceStruct.instanceVar_MREV_s=in.MREV_s;
instanceStruct.d_instanceVar_MREV_s_dX=0.0;
instanceStruct.instanceVar_ABDRAIN_i=in.ABDRAIN_i;
instanceStruct.d_instanceVar_ABDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LSDRAIN_i=in.LSDRAIN_i;
instanceStruct.d_instanceVar_LSDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LGDRAIN_i=in.LGDRAIN_i;
instanceStruct.d_instanceVar_LGDRAIN_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_d=in.zflagbot_d;
instanceStruct.instanceVar_zflagsti_d=in.zflagsti_d;
instanceStruct.instanceVar_zflaggat_d=in.zflaggat_d;
instanceStruct.instanceVar_VMAX_d=in.VMAX_d;
instanceStruct.d_instanceVar_VMAX_d_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX=0.0;
instanceStruct.instanceVar_vbimin_d=in.vbimin_d;
instanceStruct.d_instanceVar_vbimin_d_dX=0.0;
instanceStruct.instanceVar_vch_d=in.vch_d;
instanceStruct.d_instanceVar_vch_d_dX=0.0;
instanceStruct.instanceVar_vfmin_d=in.vfmin_d;
instanceStruct.d_instanceVar_vfmin_d_dX=0.0;
instanceStruct.instanceVar_vbbtlim_d=in.vbbtlim_d;
instanceStruct.d_instanceVar_vbbtlim_d_dX=0.0;
instanceStruct.instanceVar_xhighf1_d=in.xhighf1_d;
instanceStruct.d_instanceVar_xhighf1_d_dX=0.0;
instanceStruct.instanceVar_expxhf1_d=in.expxhf1_d;
instanceStruct.d_instanceVar_expxhf1_d_dX=0.0;
instanceStruct.instanceVar_xhighf2_d=in.xhighf2_d;
instanceStruct.d_instanceVar_xhighf2_d_dX=0.0;
instanceStruct.instanceVar_expxhf2_d=in.expxhf2_d;
instanceStruct.d_instanceVar_expxhf2_d_dX=0.0;
instanceStruct.instanceVar_xhighr_d=in.xhighr_d;
instanceStruct.d_instanceVar_xhighr_d_dX=0.0;
instanceStruct.instanceVar_expxhr_d=in.expxhr_d;
instanceStruct.d_instanceVar_expxhr_d_dX=0.0;
instanceStruct.instanceVar_m0flag_d=in.m0flag_d;
instanceStruct.instanceVar_ISATFOR1_d=in.ISATFOR1_d;
instanceStruct.d_instanceVar_ISATFOR1_d_dX=0.0;
instanceStruct.instanceVar_MFOR1_d=in.MFOR1_d;
instanceStruct.instanceVar_ISATFOR2_d=in.ISATFOR2_d;
instanceStruct.d_instanceVar_ISATFOR2_d_dX=0.0;
instanceStruct.instanceVar_MFOR2_d=in.MFOR2_d;
instanceStruct.d_instanceVar_MFOR2_d_dX=0.0;
instanceStruct.instanceVar_ISATREV_d=in.ISATREV_d;
instanceStruct.d_instanceVar_ISATREV_d_dX=0.0;
instanceStruct.instanceVar_MREV_d=in.MREV_d;
instanceStruct.d_instanceVar_MREV_d_dX=0.0;
instanceStruct.instanceVar_jnoisex_s=in.jnoisex_s;
instanceStruct.d_instanceVar_jnoisex_s_dX=0.0;
instanceStruct.instanceVar_jnoisex_d=in.jnoisex_d;
instanceStruct.d_instanceVar_jnoisex_d_dX=0.0;


//non-reals


//make local copies of all model vars
//reals
modelStruct.modelVar_NSUBO_i=mod.NSUBO_i;
modelStruct.d_modelVar_NSUBO_i_dX=0.0;
modelStruct.modelVar_WSEG_i=mod.WSEG_i;
modelStruct.d_modelVar_WSEG_i_dX=0.0;
modelStruct.modelVar_NPCK_i=mod.NPCK_i;
modelStruct.d_modelVar_NPCK_i_dX=0.0;
modelStruct.modelVar_WSEGP_i=mod.WSEGP_i;
modelStruct.d_modelVar_WSEGP_i_dX=0.0;
modelStruct.modelVar_LPCK_i=mod.LPCK_i;
modelStruct.d_modelVar_LPCK_i_dX=0.0;
modelStruct.modelVar_LOV_i=mod.LOV_i;
modelStruct.d_modelVar_LOV_i_dX=0.0;
modelStruct.modelVar_LOVD_i=mod.LOVD_i;
modelStruct.d_modelVar_LOVD_i_dX=0.0;
modelStruct.modelVar_LP1_i=mod.LP1_i;
modelStruct.d_modelVar_LP1_i_dX=0.0;
modelStruct.modelVar_LP2_i=mod.LP2_i;
modelStruct.d_modelVar_LP2_i_dX=0.0;
modelStruct.modelVar_WBET_i=mod.WBET_i;
modelStruct.d_modelVar_WBET_i_dX=0.0;
modelStruct.modelVar_AXL_i=mod.AXL_i;
modelStruct.d_modelVar_AXL_i_dX=0.0;
modelStruct.modelVar_ALP1L2_i=mod.ALP1L2_i;
modelStruct.d_modelVar_ALP1L2_i_dX=0.0;
modelStruct.modelVar_ALP2L2_i=mod.ALP2L2_i;
modelStruct.d_modelVar_ALP2L2_i_dX=0.0;
modelStruct.modelVar_RINT_i=mod.RINT_i;
modelStruct.d_modelVar_RINT_i_dX=0.0;
modelStruct.modelVar_RVPOLY_i=mod.RVPOLY_i;
modelStruct.d_modelVar_RVPOLY_i_dX=0.0;
modelStruct.modelVar_SAREF_i=mod.SAREF_i;
modelStruct.d_modelVar_SAREF_i_dX=0.0;
modelStruct.modelVar_SBREF_i=mod.SBREF_i;
modelStruct.d_modelVar_SBREF_i_dX=0.0;
modelStruct.modelVar_KVSAT_i=mod.KVSAT_i;
modelStruct.d_modelVar_KVSAT_i_dX=0.0;
modelStruct.modelVar_LLODKUO_i=mod.LLODKUO_i;
modelStruct.d_modelVar_LLODKUO_i_dX=0.0;
modelStruct.modelVar_WLODKUO_i=mod.WLODKUO_i;
modelStruct.d_modelVar_WLODKUO_i_dX=0.0;
modelStruct.modelVar_LLODVTH_i=mod.LLODVTH_i;
modelStruct.d_modelVar_LLODVTH_i_dX=0.0;
modelStruct.modelVar_WLODVTH_i=mod.WLODVTH_i;
modelStruct.d_modelVar_WLODVTH_i_dX=0.0;
modelStruct.modelVar_LODETAO_i=mod.LODETAO_i;
modelStruct.d_modelVar_LODETAO_i_dX=0.0;
modelStruct.modelVar_SCREF_i=mod.SCREF_i;
modelStruct.d_modelVar_SCREF_i_dX=0.0;
modelStruct.modelVar_WEB_i=mod.WEB_i;
modelStruct.d_modelVar_WEB_i_dX=0.0;
modelStruct.modelVar_WEC_i=mod.WEC_i;
modelStruct.d_modelVar_WEC_i_dX=0.0;
modelStruct.modelVar_TOX_i=mod.TOX_i;
modelStruct.d_modelVar_TOX_i_dX=0.0;
modelStruct.modelVar_EPSROX_i=mod.EPSROX_i;
modelStruct.d_modelVar_EPSROX_i_dX=0.0;
modelStruct.modelVar_TOXOV_i=mod.TOXOV_i;
modelStruct.d_modelVar_TOXOV_i_dX=0.0;
modelStruct.modelVar_TOXOVD_i=mod.TOXOVD_i;
modelStruct.d_modelVar_TOXOVD_i_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.d_modelVar_TKD_dX=0.0;
modelStruct.modelVar_dT=mod.dT;
modelStruct.d_modelVar_dT_dX=0.0;
modelStruct.modelVar_rT=mod.rT;
modelStruct.d_modelVar_rT_dX=0.0;
modelStruct.modelVar_rTn=mod.rTn;
modelStruct.d_modelVar_rTn_dX=0.0;
modelStruct.modelVar_EPSSI=mod.EPSSI;
modelStruct.modelVar_phit=mod.phit;
modelStruct.d_modelVar_phit_dX=0.0;
modelStruct.modelVar_inv_phit=mod.inv_phit;
modelStruct.d_modelVar_inv_phit_dX=0.0;
modelStruct.modelVar_Eg=mod.Eg;
modelStruct.d_modelVar_Eg_dX=0.0;
modelStruct.modelVar_phibFac=mod.phibFac;
modelStruct.d_modelVar_phibFac_dX=0.0;
modelStruct.modelVar_nt0=mod.nt0;
modelStruct.d_modelVar_nt0_dX=0.0;
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX=0.0;
modelStruct.modelVar_VBIRSTID_i=mod.VBIRSTID_i;
modelStruct.d_modelVar_VBIRSTID_i_dX=0.0;
modelStruct.modelVar_VBIRGATD_i=mod.VBIRGATD_i;
modelStruct.d_modelVar_VBIRGATD_i_dX=0.0;
modelStruct.modelVar_PBOTD_i=mod.PBOTD_i;
modelStruct.d_modelVar_PBOTD_i_dX=0.0;
modelStruct.modelVar_PSTID_i=mod.PSTID_i;
modelStruct.d_modelVar_PSTID_i_dX=0.0;
modelStruct.modelVar_PGATD_i=mod.PGATD_i;
modelStruct.d_modelVar_PGATD_i_dX=0.0;
modelStruct.modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX=0.0;
modelStruct.modelVar_CSRHSTID_i=mod.CSRHSTID_i;
modelStruct.d_modelVar_CSRHSTID_i_dX=0.0;
modelStruct.modelVar_CSRHGATD_i=mod.CSRHGATD_i;
modelStruct.d_modelVar_CSRHGATD_i_dX=0.0;
modelStruct.modelVar_CTATBOTD_i=mod.CTATBOTD_i;
modelStruct.d_modelVar_CTATBOTD_i_dX=0.0;
modelStruct.modelVar_CTATSTID_i=mod.CTATSTID_i;
modelStruct.d_modelVar_CTATSTID_i_dX=0.0;
modelStruct.modelVar_CTATGATD_i=mod.CTATGATD_i;
modelStruct.d_modelVar_CTATGATD_i_dX=0.0;
modelStruct.modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX=0.0;
modelStruct.modelVar_CBBTSTID_i=mod.CBBTSTID_i;
modelStruct.d_modelVar_CBBTSTID_i_dX=0.0;
modelStruct.modelVar_CBBTGATD_i=mod.CBBTGATD_i;
modelStruct.d_modelVar_CBBTGATD_i_dX=0.0;
modelStruct.modelVar_VBRBOTD_i=mod.VBRBOTD_i;
modelStruct.d_modelVar_VBRBOTD_i_dX=0.0;
modelStruct.modelVar_VBRSTID_i=mod.VBRSTID_i;
modelStruct.d_modelVar_VBRSTID_i_dX=0.0;
modelStruct.modelVar_VBRGATD_i=mod.VBRGATD_i;
modelStruct.d_modelVar_VBRGATD_i_dX=0.0;
modelStruct.modelVar_PBRBOTD_i=mod.PBRBOTD_i;
modelStruct.d_modelVar_PBRBOTD_i_dX=0.0;
modelStruct.modelVar_PBRSTID_i=mod.PBRSTID_i;
modelStruct.d_modelVar_PBRSTID_i_dX=0.0;
modelStruct.modelVar_PBRGATD_i=mod.PBRGATD_i;
modelStruct.d_modelVar_PBRGATD_i_dX=0.0;
modelStruct.modelVar_VJUNREFD_i=mod.VJUNREFD_i;
modelStruct.d_modelVar_VJUNREFD_i_dX=0.0;
modelStruct.modelVar_FJUNQD_i=mod.FJUNQD_i;
modelStruct.d_modelVar_FJUNQD_i_dX=0.0;
modelStruct.modelVar_ftdbot_d=mod.ftdbot_d;
modelStruct.d_modelVar_ftdbot_d_dX=0.0;
modelStruct.modelVar_ftdsti_d=mod.ftdsti_d;
modelStruct.d_modelVar_ftdsti_d_dX=0.0;
modelStruct.modelVar_ftdgat_d=mod.ftdgat_d;
modelStruct.d_modelVar_ftdgat_d_dX=0.0;
modelStruct.modelVar_idsatbot_d=mod.idsatbot_d;
modelStruct.d_modelVar_idsatbot_d_dX=0.0;
modelStruct.modelVar_idsatsti_d=mod.idsatsti_d;
modelStruct.d_modelVar_idsatsti_d_dX=0.0;
modelStruct.modelVar_idsatgat_d=mod.idsatgat_d;
modelStruct.d_modelVar_idsatgat_d_dX=0.0;
modelStruct.modelVar_vbibot_d=mod.vbibot_d;
modelStruct.d_modelVar_vbibot_d_dX=0.0;
modelStruct.modelVar_vbisti_d=mod.vbisti_d;
modelStruct.d_modelVar_vbisti_d_dX=0.0;
modelStruct.modelVar_vbigat_d=mod.vbigat_d;
modelStruct.d_modelVar_vbigat_d_dX=0.0;
modelStruct.modelVar_vbiinvbot_d=mod.vbiinvbot_d;
modelStruct.d_modelVar_vbiinvbot_d_dX=0.0;
modelStruct.modelVar_vbiinvsti_d=mod.vbiinvsti_d;
modelStruct.d_modelVar_vbiinvsti_d_dX=0.0;
modelStruct.modelVar_vbiinvgat_d=mod.vbiinvgat_d;
modelStruct.d_modelVar_vbiinvgat_d_dX=0.0;
modelStruct.modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
modelStruct.d_modelVar_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
modelStruct.d_modelVar_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
modelStruct.d_modelVar_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_cjobot_d=mod.cjobot_d;
modelStruct.d_modelVar_cjobot_d_dX=0.0;
modelStruct.modelVar_cjosti_d=mod.cjosti_d;
modelStruct.d_modelVar_cjosti_d_dX=0.0;
modelStruct.modelVar_cjogat_d=mod.cjogat_d;
modelStruct.d_modelVar_cjogat_d_dX=0.0;
modelStruct.modelVar_qprefbot_d=mod.qprefbot_d;
modelStruct.d_modelVar_qprefbot_d_dX=0.0;
modelStruct.modelVar_qprefsti_d=mod.qprefsti_d;
modelStruct.d_modelVar_qprefsti_d_dX=0.0;
modelStruct.modelVar_qprefgat_d=mod.qprefgat_d;
modelStruct.d_modelVar_qprefgat_d_dX=0.0;
modelStruct.modelVar_qpref2bot_d=mod.qpref2bot_d;
modelStruct.d_modelVar_qpref2bot_d_dX=0.0;
modelStruct.modelVar_qpref2sti_d=mod.qpref2sti_d;
modelStruct.d_modelVar_qpref2sti_d_dX=0.0;
modelStruct.modelVar_qpref2gat_d=mod.qpref2gat_d;
modelStruct.d_modelVar_qpref2gat_d_dX=0.0;
modelStruct.modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
modelStruct.d_modelVar_wdepnulrbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
modelStruct.d_modelVar_wdepnulrsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
modelStruct.d_modelVar_wdepnulrgat_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
modelStruct.d_modelVar_wdepnulrinvbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
modelStruct.d_modelVar_wdepnulrinvsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
modelStruct.d_modelVar_wdepnulrinvgat_d_dX=0.0;
modelStruct.modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
modelStruct.d_modelVar_VBIRBOTinv_d_dX=0.0;
modelStruct.modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
modelStruct.d_modelVar_VBIRSTIinv_d_dX=0.0;
modelStruct.modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
modelStruct.d_modelVar_VBIRGATinv_d_dX=0.0;
modelStruct.modelVar_atatbot_d=mod.atatbot_d;
modelStruct.d_modelVar_atatbot_d_dX=0.0;
modelStruct.modelVar_atatsti_d=mod.atatsti_d;
modelStruct.d_modelVar_atatsti_d_dX=0.0;
modelStruct.modelVar_atatgat_d=mod.atatgat_d;
modelStruct.d_modelVar_atatgat_d_dX=0.0;
modelStruct.modelVar_btatpartbot_d=mod.btatpartbot_d;
modelStruct.d_modelVar_btatpartbot_d_dX=0.0;
modelStruct.modelVar_btatpartsti_d=mod.btatpartsti_d;
modelStruct.d_modelVar_btatpartsti_d_dX=0.0;
modelStruct.modelVar_btatpartgat_d=mod.btatpartgat_d;
modelStruct.d_modelVar_btatpartgat_d_dX=0.0;
modelStruct.modelVar_fbbtbot_d=mod.fbbtbot_d;
modelStruct.d_modelVar_fbbtbot_d_dX=0.0;
modelStruct.modelVar_fbbtsti_d=mod.fbbtsti_d;
modelStruct.d_modelVar_fbbtsti_d_dX=0.0;
modelStruct.modelVar_fbbtgat_d=mod.fbbtgat_d;
modelStruct.d_modelVar_fbbtgat_d_dX=0.0;
modelStruct.modelVar_fstopbot_d=mod.fstopbot_d;
modelStruct.d_modelVar_fstopbot_d_dX=0.0;
modelStruct.modelVar_fstopsti_d=mod.fstopsti_d;
modelStruct.d_modelVar_fstopsti_d_dX=0.0;
modelStruct.modelVar_fstopgat_d=mod.fstopgat_d;
modelStruct.d_modelVar_fstopgat_d_dX=0.0;
modelStruct.modelVar_VBRinvbot_d=mod.VBRinvbot_d;
modelStruct.d_modelVar_VBRinvbot_d_dX=0.0;
modelStruct.modelVar_VBRinvsti_d=mod.VBRinvsti_d;
modelStruct.d_modelVar_VBRinvsti_d_dX=0.0;
modelStruct.modelVar_VBRinvgat_d=mod.VBRinvgat_d;
modelStruct.d_modelVar_VBRinvgat_d_dX=0.0;
modelStruct.modelVar_slopebot_d=mod.slopebot_d;
modelStruct.d_modelVar_slopebot_d_dX=0.0;
modelStruct.modelVar_slopesti_d=mod.slopesti_d;
modelStruct.d_modelVar_slopesti_d_dX=0.0;
modelStruct.modelVar_slopegat_d=mod.slopegat_d;
modelStruct.d_modelVar_slopegat_d_dX=0.0;


// non-reals
modelStruct.modelVar_CHNL_TYPE=mod.CHNL_TYPE;



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_D_GND] = (*solVectorPtr)[in.li_D];
probeVars[in.admsProbeID_V_BS_GND] = (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_BD_GND] = (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_S_GND] = (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_BP_GND] = (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_GP_GND] = (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
probeVars[in.admsProbeID_V_D_BD] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_S_BS] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_S_BP] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_GP_S] = (*solVectorPtr)[in.li_GP]- (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G]- (*solVectorPtr)[in.li_GP];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_D_GND,
in.admsProbeID_V_BS_GND,
in.admsProbeID_V_BD_GND,
in.admsProbeID_V_S_GND,
in.admsProbeID_V_BP_GND,
in.admsProbeID_V_GP_GND,
in.admsProbeID_V_NOI_GND,
in.admsProbeID_V_NOI2_GND,
in.admsProbeID_V_D_BD,
in.admsProbeID_V_S_BS,
in.admsProbeID_V_S_BP,
in.admsProbeID_V_D_S,
in.admsProbeID_V_GP_S,
in.admsProbeID_V_B_BI,
in.admsProbeID_V_BP_BI,
in.admsProbeID_V_BD_BI,
in.admsProbeID_V_BS_BI,
in.admsProbeID_V_G_GP,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_NOI,
in.admsNodeID_NOI2,
in.admsNodeID_GP,
in.admsNodeID_BP,
in.admsNodeID_BI,
in.admsNodeID_BS,
in.admsNodeID_BD,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D] = in.li_D;
    Qindices[in.admsNodeID_D] = in.li_D;
    dfdp[in.admsNodeID_G] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G] = in.li_G;
    Qindices[in.admsNodeID_G] = in.li_G;
    dfdp[in.admsNodeID_S] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S] = in.li_S;
    Qindices[in.admsNodeID_S] = in.li_S;
    dfdp[in.admsNodeID_B] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B] = in.li_B;
    Qindices[in.admsNodeID_B] = in.li_B;
    dfdp[in.admsNodeID_NOI] += d_staticContributions_dX[in.admsNodeID_NOI];
    dqdp[in.admsNodeID_NOI] += d_dynamicContributions_dX[in.admsNodeID_NOI];
    Findices[in.admsNodeID_NOI] = in.li_NOI;
    Qindices[in.admsNodeID_NOI] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2] += d_staticContributions_dX[in.admsNodeID_NOI2];
    dqdp[in.admsNodeID_NOI2] += d_dynamicContributions_dX[in.admsNodeID_NOI2];
    Findices[in.admsNodeID_NOI2] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2] = in.li_NOI2;
    dfdp[in.admsNodeID_GP] += d_staticContributions_dX[in.admsNodeID_GP];
    dqdp[in.admsNodeID_GP] += d_dynamicContributions_dX[in.admsNodeID_GP];
    Findices[in.admsNodeID_GP] = in.li_GP;
    Qindices[in.admsNodeID_GP] = in.li_GP;
    dfdp[in.admsNodeID_BP] += d_staticContributions_dX[in.admsNodeID_BP];
    dqdp[in.admsNodeID_BP] += d_dynamicContributions_dX[in.admsNodeID_BP];
    Findices[in.admsNodeID_BP] = in.li_BP;
    Qindices[in.admsNodeID_BP] = in.li_BP;
    dfdp[in.admsNodeID_BI] += d_staticContributions_dX[in.admsNodeID_BI];
    dqdp[in.admsNodeID_BI] += d_dynamicContributions_dX[in.admsNodeID_BI];
    Findices[in.admsNodeID_BI] = in.li_BI;
    Qindices[in.admsNodeID_BI] = in.li_BI;
    dfdp[in.admsNodeID_BS] += d_staticContributions_dX[in.admsNodeID_BS];
    dqdp[in.admsNodeID_BS] += d_dynamicContributions_dX[in.admsNodeID_BS];
    Findices[in.admsNodeID_BS] = in.li_BS;
    Qindices[in.admsNodeID_BS] = in.li_BS;
    dfdp[in.admsNodeID_BD] += d_staticContributions_dX[in.admsNodeID_BD];
    dqdp[in.admsNodeID_BD] += d_dynamicContributions_dX[in.admsNodeID_BD];
    Findices[in.admsNodeID_BD] = in.li_BD;
    Qindices[in.admsNodeID_BD] = in.li_BD;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((11+0)*sizeInstance);
dqdp.resize((11+0)*sizeInstance);
Findices.resize((11+0)*sizeInstance);
Qindices.resize((11+0)*sizeInstance);

std::vector <double> probeVars(18);
std::vector <double> d_staticContributions_dX(11+0);
std::vector <double> d_dynamicContributions_dX(11+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_LEVEL=mod.LEVEL;
modelStruct.d_modelPar_LEVEL_dX=0.0;
modelStruct.modelPar_given_LEVEL=mod.given("LEVEL");
modParamMap["LEVEL"] = &(modelStruct.d_modelPar_LEVEL_dX);
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.d_modelPar_TYPE_dX=0.0;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modParamMap["TYPE"] = &(modelStruct.d_modelPar_TYPE_dX);
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modParamMap["TR"] = &(modelStruct.d_modelPar_TR_dX);
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.d_modelPar_SWIGATE_dX=0.0;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modParamMap["SWIGATE"] = &(modelStruct.d_modelPar_SWIGATE_dX);
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.d_modelPar_SWIMPACT_dX=0.0;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modParamMap["SWIMPACT"] = &(modelStruct.d_modelPar_SWIMPACT_dX);
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.d_modelPar_SWGIDL_dX=0.0;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modParamMap["SWGIDL"] = &(modelStruct.d_modelPar_SWGIDL_dX);
modelStruct.modelPar_SWJUNCAP=mod.SWJUNCAP;
modelStruct.d_modelPar_SWJUNCAP_dX=0.0;
modelStruct.modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
modParamMap["SWJUNCAP"] = &(modelStruct.d_modelPar_SWJUNCAP_dX);
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.d_modelPar_SWJUNASYM_dX=0.0;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modParamMap["SWJUNASYM"] = &(modelStruct.d_modelPar_SWJUNASYM_dX);
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modParamMap["QMC"] = &(modelStruct.d_modelPar_QMC_dX);
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modParamMap["LVARO"] = &(modelStruct.d_modelPar_LVARO_dX);
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modParamMap["LVARL"] = &(modelStruct.d_modelPar_LVARL_dX);
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modParamMap["LVARW"] = &(modelStruct.d_modelPar_LVARW_dX);
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modParamMap["LAP"] = &(modelStruct.d_modelPar_LAP_dX);
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modParamMap["WVARO"] = &(modelStruct.d_modelPar_WVARO_dX);
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modParamMap["WVARL"] = &(modelStruct.d_modelPar_WVARL_dX);
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modParamMap["WVARW"] = &(modelStruct.d_modelPar_WVARW_dX);
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modParamMap["WOT"] = &(modelStruct.d_modelPar_WOT_dX);
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modParamMap["DLQ"] = &(modelStruct.d_modelPar_DLQ_dX);
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modParamMap["DWQ"] = &(modelStruct.d_modelPar_DWQ_dX);
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modParamMap["VFBO"] = &(modelStruct.d_modelPar_VFBO_dX);
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modParamMap["VFBL"] = &(modelStruct.d_modelPar_VFBL_dX);
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modParamMap["VFBW"] = &(modelStruct.d_modelPar_VFBW_dX);
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modParamMap["VFBLW"] = &(modelStruct.d_modelPar_VFBLW_dX);
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modParamMap["STVFBO"] = &(modelStruct.d_modelPar_STVFBO_dX);
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modParamMap["STVFBL"] = &(modelStruct.d_modelPar_STVFBL_dX);
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modParamMap["STVFBW"] = &(modelStruct.d_modelPar_STVFBW_dX);
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modParamMap["STVFBLW"] = &(modelStruct.d_modelPar_STVFBLW_dX);
modelStruct.modelPar_TOXO=mod.TOXO;
modelStruct.d_modelPar_TOXO_dX=0.0;
modelStruct.modelPar_given_TOXO=mod.given("TOXO");
modParamMap["TOXO"] = &(modelStruct.d_modelPar_TOXO_dX);
modelStruct.modelPar_EPSROXO=mod.EPSROXO;
modelStruct.d_modelPar_EPSROXO_dX=0.0;
modelStruct.modelPar_given_EPSROXO=mod.given("EPSROXO");
modParamMap["EPSROXO"] = &(modelStruct.d_modelPar_EPSROXO_dX);
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modParamMap["NSUBO"] = &(modelStruct.d_modelPar_NSUBO_dX);
modelStruct.modelPar_NSUBW=mod.NSUBW;
modelStruct.d_modelPar_NSUBW_dX=0.0;
modelStruct.modelPar_given_NSUBW=mod.given("NSUBW");
modParamMap["NSUBW"] = &(modelStruct.d_modelPar_NSUBW_dX);
modelStruct.modelPar_WSEG=mod.WSEG;
modelStruct.d_modelPar_WSEG_dX=0.0;
modelStruct.modelPar_given_WSEG=mod.given("WSEG");
modParamMap["WSEG"] = &(modelStruct.d_modelPar_WSEG_dX);
modelStruct.modelPar_NPCK=mod.NPCK;
modelStruct.d_modelPar_NPCK_dX=0.0;
modelStruct.modelPar_given_NPCK=mod.given("NPCK");
modParamMap["NPCK"] = &(modelStruct.d_modelPar_NPCK_dX);
modelStruct.modelPar_NPCKW=mod.NPCKW;
modelStruct.d_modelPar_NPCKW_dX=0.0;
modelStruct.modelPar_given_NPCKW=mod.given("NPCKW");
modParamMap["NPCKW"] = &(modelStruct.d_modelPar_NPCKW_dX);
modelStruct.modelPar_WSEGP=mod.WSEGP;
modelStruct.d_modelPar_WSEGP_dX=0.0;
modelStruct.modelPar_given_WSEGP=mod.given("WSEGP");
modParamMap["WSEGP"] = &(modelStruct.d_modelPar_WSEGP_dX);
modelStruct.modelPar_LPCK=mod.LPCK;
modelStruct.d_modelPar_LPCK_dX=0.0;
modelStruct.modelPar_given_LPCK=mod.given("LPCK");
modParamMap["LPCK"] = &(modelStruct.d_modelPar_LPCK_dX);
modelStruct.modelPar_LPCKW=mod.LPCKW;
modelStruct.d_modelPar_LPCKW_dX=0.0;
modelStruct.modelPar_given_LPCKW=mod.given("LPCKW");
modParamMap["LPCKW"] = &(modelStruct.d_modelPar_LPCKW_dX);
modelStruct.modelPar_FOL1=mod.FOL1;
modelStruct.d_modelPar_FOL1_dX=0.0;
modelStruct.modelPar_given_FOL1=mod.given("FOL1");
modParamMap["FOL1"] = &(modelStruct.d_modelPar_FOL1_dX);
modelStruct.modelPar_FOL2=mod.FOL2;
modelStruct.d_modelPar_FOL2_dX=0.0;
modelStruct.modelPar_given_FOL2=mod.given("FOL2");
modParamMap["FOL2"] = &(modelStruct.d_modelPar_FOL2_dX);
modelStruct.modelPar_VNSUBO=mod.VNSUBO;
modelStruct.d_modelPar_VNSUBO_dX=0.0;
modelStruct.modelPar_given_VNSUBO=mod.given("VNSUBO");
modParamMap["VNSUBO"] = &(modelStruct.d_modelPar_VNSUBO_dX);
modelStruct.modelPar_NSLPO=mod.NSLPO;
modelStruct.d_modelPar_NSLPO_dX=0.0;
modelStruct.modelPar_given_NSLPO=mod.given("NSLPO");
modParamMap["NSLPO"] = &(modelStruct.d_modelPar_NSLPO_dX);
modelStruct.modelPar_DNSUBO=mod.DNSUBO;
modelStruct.d_modelPar_DNSUBO_dX=0.0;
modelStruct.modelPar_given_DNSUBO=mod.given("DNSUBO");
modParamMap["DNSUBO"] = &(modelStruct.d_modelPar_DNSUBO_dX);
modelStruct.modelPar_DPHIBO=mod.DPHIBO;
modelStruct.d_modelPar_DPHIBO_dX=0.0;
modelStruct.modelPar_given_DPHIBO=mod.given("DPHIBO");
modParamMap["DPHIBO"] = &(modelStruct.d_modelPar_DPHIBO_dX);
modelStruct.modelPar_DPHIBL=mod.DPHIBL;
modelStruct.d_modelPar_DPHIBL_dX=0.0;
modelStruct.modelPar_given_DPHIBL=mod.given("DPHIBL");
modParamMap["DPHIBL"] = &(modelStruct.d_modelPar_DPHIBL_dX);
modelStruct.modelPar_DPHIBLEXP=mod.DPHIBLEXP;
modelStruct.d_modelPar_DPHIBLEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
modParamMap["DPHIBLEXP"] = &(modelStruct.d_modelPar_DPHIBLEXP_dX);
modelStruct.modelPar_DPHIBW=mod.DPHIBW;
modelStruct.d_modelPar_DPHIBW_dX=0.0;
modelStruct.modelPar_given_DPHIBW=mod.given("DPHIBW");
modParamMap["DPHIBW"] = &(modelStruct.d_modelPar_DPHIBW_dX);
modelStruct.modelPar_DPHIBLW=mod.DPHIBLW;
modelStruct.d_modelPar_DPHIBLW_dX=0.0;
modelStruct.modelPar_given_DPHIBLW=mod.given("DPHIBLW");
modParamMap["DPHIBLW"] = &(modelStruct.d_modelPar_DPHIBLW_dX);
modelStruct.modelPar_NPO=mod.NPO;
modelStruct.d_modelPar_NPO_dX=0.0;
modelStruct.modelPar_given_NPO=mod.given("NPO");
modParamMap["NPO"] = &(modelStruct.d_modelPar_NPO_dX);
modelStruct.modelPar_NPL=mod.NPL;
modelStruct.d_modelPar_NPL_dX=0.0;
modelStruct.modelPar_given_NPL=mod.given("NPL");
modParamMap["NPL"] = &(modelStruct.d_modelPar_NPL_dX);
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modParamMap["CTO"] = &(modelStruct.d_modelPar_CTO_dX);
modelStruct.modelPar_CTL=mod.CTL;
modelStruct.d_modelPar_CTL_dX=0.0;
modelStruct.modelPar_given_CTL=mod.given("CTL");
modParamMap["CTL"] = &(modelStruct.d_modelPar_CTL_dX);
modelStruct.modelPar_CTLEXP=mod.CTLEXP;
modelStruct.d_modelPar_CTLEXP_dX=0.0;
modelStruct.modelPar_given_CTLEXP=mod.given("CTLEXP");
modParamMap["CTLEXP"] = &(modelStruct.d_modelPar_CTLEXP_dX);
modelStruct.modelPar_CTW=mod.CTW;
modelStruct.d_modelPar_CTW_dX=0.0;
modelStruct.modelPar_given_CTW=mod.given("CTW");
modParamMap["CTW"] = &(modelStruct.d_modelPar_CTW_dX);
modelStruct.modelPar_CTLW=mod.CTLW;
modelStruct.d_modelPar_CTLW_dX=0.0;
modelStruct.modelPar_given_CTLW=mod.given("CTLW");
modParamMap["CTLW"] = &(modelStruct.d_modelPar_CTLW_dX);
modelStruct.modelPar_TOXOVO=mod.TOXOVO;
modelStruct.d_modelPar_TOXOVO_dX=0.0;
modelStruct.modelPar_given_TOXOVO=mod.given("TOXOVO");
modParamMap["TOXOVO"] = &(modelStruct.d_modelPar_TOXOVO_dX);
modelStruct.modelPar_TOXOVDO=mod.TOXOVDO;
modelStruct.d_modelPar_TOXOVDO_dX=0.0;
modelStruct.modelPar_given_TOXOVDO=mod.given("TOXOVDO");
modParamMap["TOXOVDO"] = &(modelStruct.d_modelPar_TOXOVDO_dX);
modelStruct.modelPar_LOV=mod.LOV;
modelStruct.d_modelPar_LOV_dX=0.0;
modelStruct.modelPar_given_LOV=mod.given("LOV");
modParamMap["LOV"] = &(modelStruct.d_modelPar_LOV_dX);
modelStruct.modelPar_LOVD=mod.LOVD;
modelStruct.d_modelPar_LOVD_dX=0.0;
modelStruct.modelPar_given_LOVD=mod.given("LOVD");
modParamMap["LOVD"] = &(modelStruct.d_modelPar_LOVD_dX);
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modParamMap["NOVO"] = &(modelStruct.d_modelPar_NOVO_dX);
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modParamMap["NOVDO"] = &(modelStruct.d_modelPar_NOVDO_dX);
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modParamMap["CFL"] = &(modelStruct.d_modelPar_CFL_dX);
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modParamMap["CFLEXP"] = &(modelStruct.d_modelPar_CFLEXP_dX);
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modParamMap["CFW"] = &(modelStruct.d_modelPar_CFW_dX);
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modParamMap["CFBO"] = &(modelStruct.d_modelPar_CFBO_dX);
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modParamMap["UO"] = &(modelStruct.d_modelPar_UO_dX);
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modParamMap["FBET1"] = &(modelStruct.d_modelPar_FBET1_dX);
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modParamMap["FBET1W"] = &(modelStruct.d_modelPar_FBET1W_dX);
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modParamMap["LP1"] = &(modelStruct.d_modelPar_LP1_dX);
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modParamMap["LP1W"] = &(modelStruct.d_modelPar_LP1W_dX);
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modParamMap["FBET2"] = &(modelStruct.d_modelPar_FBET2_dX);
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modParamMap["LP2"] = &(modelStruct.d_modelPar_LP2_dX);
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modParamMap["BETW1"] = &(modelStruct.d_modelPar_BETW1_dX);
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modParamMap["BETW2"] = &(modelStruct.d_modelPar_BETW2_dX);
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modParamMap["WBET"] = &(modelStruct.d_modelPar_WBET_dX);
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modParamMap["STBETO"] = &(modelStruct.d_modelPar_STBETO_dX);
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modParamMap["STBETL"] = &(modelStruct.d_modelPar_STBETL_dX);
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modParamMap["STBETW"] = &(modelStruct.d_modelPar_STBETW_dX);
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modParamMap["STBETLW"] = &(modelStruct.d_modelPar_STBETLW_dX);
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modParamMap["MUEO"] = &(modelStruct.d_modelPar_MUEO_dX);
modelStruct.modelPar_MUEW=mod.MUEW;
modelStruct.d_modelPar_MUEW_dX=0.0;
modelStruct.modelPar_given_MUEW=mod.given("MUEW");
modParamMap["MUEW"] = &(modelStruct.d_modelPar_MUEW_dX);
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modParamMap["STMUEO"] = &(modelStruct.d_modelPar_STMUEO_dX);
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modParamMap["THEMUO"] = &(modelStruct.d_modelPar_THEMUO_dX);
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modParamMap["STTHEMUO"] = &(modelStruct.d_modelPar_STTHEMUO_dX);
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modParamMap["CSO"] = &(modelStruct.d_modelPar_CSO_dX);
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modParamMap["CSL"] = &(modelStruct.d_modelPar_CSL_dX);
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modParamMap["CSLEXP"] = &(modelStruct.d_modelPar_CSLEXP_dX);
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modParamMap["CSW"] = &(modelStruct.d_modelPar_CSW_dX);
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modParamMap["CSLW"] = &(modelStruct.d_modelPar_CSLW_dX);
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modParamMap["STCSO"] = &(modelStruct.d_modelPar_STCSO_dX);
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modParamMap["XCORO"] = &(modelStruct.d_modelPar_XCORO_dX);
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modParamMap["XCORL"] = &(modelStruct.d_modelPar_XCORL_dX);
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modParamMap["XCORW"] = &(modelStruct.d_modelPar_XCORW_dX);
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modParamMap["XCORLW"] = &(modelStruct.d_modelPar_XCORLW_dX);
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modParamMap["STXCORO"] = &(modelStruct.d_modelPar_STXCORO_dX);
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modParamMap["FETAO"] = &(modelStruct.d_modelPar_FETAO_dX);
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modParamMap["RSW1"] = &(modelStruct.d_modelPar_RSW1_dX);
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modParamMap["RSW2"] = &(modelStruct.d_modelPar_RSW2_dX);
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modParamMap["STRSO"] = &(modelStruct.d_modelPar_STRSO_dX);
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modParamMap["RSBO"] = &(modelStruct.d_modelPar_RSBO_dX);
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modParamMap["RSGO"] = &(modelStruct.d_modelPar_RSGO_dX);
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modParamMap["THESATO"] = &(modelStruct.d_modelPar_THESATO_dX);
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modParamMap["THESATL"] = &(modelStruct.d_modelPar_THESATL_dX);
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modParamMap["THESATLEXP"] = &(modelStruct.d_modelPar_THESATLEXP_dX);
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modParamMap["THESATW"] = &(modelStruct.d_modelPar_THESATW_dX);
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modParamMap["THESATLW"] = &(modelStruct.d_modelPar_THESATLW_dX);
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modParamMap["STTHESATO"] = &(modelStruct.d_modelPar_STTHESATO_dX);
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modParamMap["STTHESATL"] = &(modelStruct.d_modelPar_STTHESATL_dX);
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modParamMap["STTHESATW"] = &(modelStruct.d_modelPar_STTHESATW_dX);
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modParamMap["STTHESATLW"] = &(modelStruct.d_modelPar_STTHESATLW_dX);
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modParamMap["THESATBO"] = &(modelStruct.d_modelPar_THESATBO_dX);
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modParamMap["THESATGO"] = &(modelStruct.d_modelPar_THESATGO_dX);
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modParamMap["AXO"] = &(modelStruct.d_modelPar_AXO_dX);
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modParamMap["AXL"] = &(modelStruct.d_modelPar_AXL_dX);
modelStruct.modelPar_ALPL=mod.ALPL;
modelStruct.d_modelPar_ALPL_dX=0.0;
modelStruct.modelPar_given_ALPL=mod.given("ALPL");
modParamMap["ALPL"] = &(modelStruct.d_modelPar_ALPL_dX);
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modParamMap["ALPLEXP"] = &(modelStruct.d_modelPar_ALPLEXP_dX);
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modParamMap["ALPW"] = &(modelStruct.d_modelPar_ALPW_dX);
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modParamMap["ALP1L1"] = &(modelStruct.d_modelPar_ALP1L1_dX);
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modParamMap["ALP1LEXP"] = &(modelStruct.d_modelPar_ALP1LEXP_dX);
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modParamMap["ALP1L2"] = &(modelStruct.d_modelPar_ALP1L2_dX);
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modParamMap["ALP1W"] = &(modelStruct.d_modelPar_ALP1W_dX);
modelStruct.modelPar_ALP2L1=mod.ALP2L1;
modelStruct.d_modelPar_ALP2L1_dX=0.0;
modelStruct.modelPar_given_ALP2L1=mod.given("ALP2L1");
modParamMap["ALP2L1"] = &(modelStruct.d_modelPar_ALP2L1_dX);
modelStruct.modelPar_ALP2LEXP=mod.ALP2LEXP;
modelStruct.d_modelPar_ALP2LEXP_dX=0.0;
modelStruct.modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
modParamMap["ALP2LEXP"] = &(modelStruct.d_modelPar_ALP2LEXP_dX);
modelStruct.modelPar_ALP2L2=mod.ALP2L2;
modelStruct.d_modelPar_ALP2L2_dX=0.0;
modelStruct.modelPar_given_ALP2L2=mod.given("ALP2L2");
modParamMap["ALP2L2"] = &(modelStruct.d_modelPar_ALP2L2_dX);
modelStruct.modelPar_ALP2W=mod.ALP2W;
modelStruct.d_modelPar_ALP2W_dX=0.0;
modelStruct.modelPar_given_ALP2W=mod.given("ALP2W");
modParamMap["ALP2W"] = &(modelStruct.d_modelPar_ALP2W_dX);
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modParamMap["VPO"] = &(modelStruct.d_modelPar_VPO_dX);
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modParamMap["A1O"] = &(modelStruct.d_modelPar_A1O_dX);
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modParamMap["A1L"] = &(modelStruct.d_modelPar_A1L_dX);
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modParamMap["A1W"] = &(modelStruct.d_modelPar_A1W_dX);
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modParamMap["A2O"] = &(modelStruct.d_modelPar_A2O_dX);
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modParamMap["STA2O"] = &(modelStruct.d_modelPar_STA2O_dX);
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modParamMap["A3O"] = &(modelStruct.d_modelPar_A3O_dX);
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modParamMap["A3L"] = &(modelStruct.d_modelPar_A3L_dX);
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modParamMap["A3W"] = &(modelStruct.d_modelPar_A3W_dX);
modelStruct.modelPar_A4O=mod.A4O;
modelStruct.d_modelPar_A4O_dX=0.0;
modelStruct.modelPar_given_A4O=mod.given("A4O");
modParamMap["A4O"] = &(modelStruct.d_modelPar_A4O_dX);
modelStruct.modelPar_A4L=mod.A4L;
modelStruct.d_modelPar_A4L_dX=0.0;
modelStruct.modelPar_given_A4L=mod.given("A4L");
modParamMap["A4L"] = &(modelStruct.d_modelPar_A4L_dX);
modelStruct.modelPar_A4W=mod.A4W;
modelStruct.d_modelPar_A4W_dX=0.0;
modelStruct.modelPar_given_A4W=mod.given("A4W");
modParamMap["A4W"] = &(modelStruct.d_modelPar_A4W_dX);
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modParamMap["GCOO"] = &(modelStruct.d_modelPar_GCOO_dX);
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modParamMap["IGINVLW"] = &(modelStruct.d_modelPar_IGINVLW_dX);
modelStruct.modelPar_IGOVW=mod.IGOVW;
modelStruct.d_modelPar_IGOVW_dX=0.0;
modelStruct.modelPar_given_IGOVW=mod.given("IGOVW");
modParamMap["IGOVW"] = &(modelStruct.d_modelPar_IGOVW_dX);
modelStruct.modelPar_IGOVDW=mod.IGOVDW;
modelStruct.d_modelPar_IGOVDW_dX=0.0;
modelStruct.modelPar_given_IGOVDW=mod.given("IGOVDW");
modParamMap["IGOVDW"] = &(modelStruct.d_modelPar_IGOVDW_dX);
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modParamMap["STIGO"] = &(modelStruct.d_modelPar_STIGO_dX);
modelStruct.modelPar_GC2O=mod.GC2O;
modelStruct.d_modelPar_GC2O_dX=0.0;
modelStruct.modelPar_given_GC2O=mod.given("GC2O");
modParamMap["GC2O"] = &(modelStruct.d_modelPar_GC2O_dX);
modelStruct.modelPar_GC3O=mod.GC3O;
modelStruct.d_modelPar_GC3O_dX=0.0;
modelStruct.modelPar_given_GC3O=mod.given("GC3O");
modParamMap["GC3O"] = &(modelStruct.d_modelPar_GC3O_dX);
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modParamMap["CHIBO"] = &(modelStruct.d_modelPar_CHIBO_dX);
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modParamMap["AGIDLW"] = &(modelStruct.d_modelPar_AGIDLW_dX);
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modParamMap["AGIDLDW"] = &(modelStruct.d_modelPar_AGIDLDW_dX);
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modParamMap["BGIDLO"] = &(modelStruct.d_modelPar_BGIDLO_dX);
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modParamMap["BGIDLDO"] = &(modelStruct.d_modelPar_BGIDLDO_dX);
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modParamMap["STBGIDLO"] = &(modelStruct.d_modelPar_STBGIDLO_dX);
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modParamMap["STBGIDLDO"] = &(modelStruct.d_modelPar_STBGIDLDO_dX);
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modParamMap["CGIDLO"] = &(modelStruct.d_modelPar_CGIDLO_dX);
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modParamMap["CGIDLDO"] = &(modelStruct.d_modelPar_CGIDLDO_dX);
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modParamMap["CGBOVL"] = &(modelStruct.d_modelPar_CGBOVL_dX);
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modParamMap["CFRW"] = &(modelStruct.d_modelPar_CFRW_dX);
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modParamMap["CFRDW"] = &(modelStruct.d_modelPar_CFRDW_dX);
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modParamMap["FNTO"] = &(modelStruct.d_modelPar_FNTO_dX);
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modParamMap["FNTEXCL"] = &(modelStruct.d_modelPar_FNTEXCL_dX);
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modParamMap["NFALW"] = &(modelStruct.d_modelPar_NFALW_dX);
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modParamMap["NFBLW"] = &(modelStruct.d_modelPar_NFBLW_dX);
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modParamMap["NFCLW"] = &(modelStruct.d_modelPar_NFCLW_dX);
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modParamMap["EFO"] = &(modelStruct.d_modelPar_EFO_dX);
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modParamMap["LINTNOI"] = &(modelStruct.d_modelPar_LINTNOI_dX);
modelStruct.modelPar_ALPNOI=mod.ALPNOI;
modelStruct.d_modelPar_ALPNOI_dX=0.0;
modelStruct.modelPar_given_ALPNOI=mod.given("ALPNOI");
modParamMap["ALPNOI"] = &(modelStruct.d_modelPar_ALPNOI_dX);
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");
modParamMap["DTA"] = &(modelStruct.d_modelPar_DTA_dX);
modelStruct.modelPar_KVTHOWEO=mod.KVTHOWEO;
modelStruct.d_modelPar_KVTHOWEO_dX=0.0;
modelStruct.modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
modParamMap["KVTHOWEO"] = &(modelStruct.d_modelPar_KVTHOWEO_dX);
modelStruct.modelPar_KVTHOWEL=mod.KVTHOWEL;
modelStruct.d_modelPar_KVTHOWEL_dX=0.0;
modelStruct.modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
modParamMap["KVTHOWEL"] = &(modelStruct.d_modelPar_KVTHOWEL_dX);
modelStruct.modelPar_KVTHOWEW=mod.KVTHOWEW;
modelStruct.d_modelPar_KVTHOWEW_dX=0.0;
modelStruct.modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
modParamMap["KVTHOWEW"] = &(modelStruct.d_modelPar_KVTHOWEW_dX);
modelStruct.modelPar_KVTHOWELW=mod.KVTHOWELW;
modelStruct.d_modelPar_KVTHOWELW_dX=0.0;
modelStruct.modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
modParamMap["KVTHOWELW"] = &(modelStruct.d_modelPar_KVTHOWELW_dX);
modelStruct.modelPar_KUOWEO=mod.KUOWEO;
modelStruct.d_modelPar_KUOWEO_dX=0.0;
modelStruct.modelPar_given_KUOWEO=mod.given("KUOWEO");
modParamMap["KUOWEO"] = &(modelStruct.d_modelPar_KUOWEO_dX);
modelStruct.modelPar_KUOWEL=mod.KUOWEL;
modelStruct.d_modelPar_KUOWEL_dX=0.0;
modelStruct.modelPar_given_KUOWEL=mod.given("KUOWEL");
modParamMap["KUOWEL"] = &(modelStruct.d_modelPar_KUOWEL_dX);
modelStruct.modelPar_KUOWEW=mod.KUOWEW;
modelStruct.d_modelPar_KUOWEW_dX=0.0;
modelStruct.modelPar_given_KUOWEW=mod.given("KUOWEW");
modParamMap["KUOWEW"] = &(modelStruct.d_modelPar_KUOWEW_dX);
modelStruct.modelPar_KUOWELW=mod.KUOWELW;
modelStruct.d_modelPar_KUOWELW_dX=0.0;
modelStruct.modelPar_given_KUOWELW=mod.given("KUOWELW");
modParamMap["KUOWELW"] = &(modelStruct.d_modelPar_KUOWELW_dX);
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modParamMap["LMIN"] = &(modelStruct.d_modelPar_LMIN_dX);
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modParamMap["LMAX"] = &(modelStruct.d_modelPar_LMAX_dX);
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modParamMap["WMIN"] = &(modelStruct.d_modelPar_WMIN_dX);
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modParamMap["WMAX"] = &(modelStruct.d_modelPar_WMAX_dX);
modelStruct.modelPar_RGO=mod.RGO;
modelStruct.d_modelPar_RGO_dX=0.0;
modelStruct.modelPar_given_RGO=mod.given("RGO");
modParamMap["RGO"] = &(modelStruct.d_modelPar_RGO_dX);
modelStruct.modelPar_RBULKO=mod.RBULKO;
modelStruct.d_modelPar_RBULKO_dX=0.0;
modelStruct.modelPar_given_RBULKO=mod.given("RBULKO");
modParamMap["RBULKO"] = &(modelStruct.d_modelPar_RBULKO_dX);
modelStruct.modelPar_RWELLO=mod.RWELLO;
modelStruct.d_modelPar_RWELLO_dX=0.0;
modelStruct.modelPar_given_RWELLO=mod.given("RWELLO");
modParamMap["RWELLO"] = &(modelStruct.d_modelPar_RWELLO_dX);
modelStruct.modelPar_RJUNSO=mod.RJUNSO;
modelStruct.d_modelPar_RJUNSO_dX=0.0;
modelStruct.modelPar_given_RJUNSO=mod.given("RJUNSO");
modParamMap["RJUNSO"] = &(modelStruct.d_modelPar_RJUNSO_dX);
modelStruct.modelPar_RJUNDO=mod.RJUNDO;
modelStruct.d_modelPar_RJUNDO_dX=0.0;
modelStruct.modelPar_given_RJUNDO=mod.given("RJUNDO");
modParamMap["RJUNDO"] = &(modelStruct.d_modelPar_RJUNDO_dX);
modelStruct.modelPar_RINT=mod.RINT;
modelStruct.d_modelPar_RINT_dX=0.0;
modelStruct.modelPar_given_RINT=mod.given("RINT");
modParamMap["RINT"] = &(modelStruct.d_modelPar_RINT_dX);
modelStruct.modelPar_RVPOLY=mod.RVPOLY;
modelStruct.d_modelPar_RVPOLY_dX=0.0;
modelStruct.modelPar_given_RVPOLY=mod.given("RVPOLY");
modParamMap["RVPOLY"] = &(modelStruct.d_modelPar_RVPOLY_dX);
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modParamMap["RSHG"] = &(modelStruct.d_modelPar_RSHG_dX);
modelStruct.modelPar_DLSIL=mod.DLSIL;
modelStruct.d_modelPar_DLSIL_dX=0.0;
modelStruct.modelPar_given_DLSIL=mod.given("DLSIL");
modParamMap["DLSIL"] = &(modelStruct.d_modelPar_DLSIL_dX);
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modParamMap["SAREF"] = &(modelStruct.d_modelPar_SAREF_dX);
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modParamMap["SBREF"] = &(modelStruct.d_modelPar_SBREF_dX);
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modParamMap["WLOD"] = &(modelStruct.d_modelPar_WLOD_dX);
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modParamMap["KUO"] = &(modelStruct.d_modelPar_KUO_dX);
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modParamMap["KVSAT"] = &(modelStruct.d_modelPar_KVSAT_dX);
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modParamMap["TKUO"] = &(modelStruct.d_modelPar_TKUO_dX);
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modParamMap["LKUO"] = &(modelStruct.d_modelPar_LKUO_dX);
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modParamMap["WKUO"] = &(modelStruct.d_modelPar_WKUO_dX);
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modParamMap["PKUO"] = &(modelStruct.d_modelPar_PKUO_dX);
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modParamMap["LLODKUO"] = &(modelStruct.d_modelPar_LLODKUO_dX);
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modParamMap["WLODKUO"] = &(modelStruct.d_modelPar_WLODKUO_dX);
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modParamMap["KVTHO"] = &(modelStruct.d_modelPar_KVTHO_dX);
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modParamMap["LKVTHO"] = &(modelStruct.d_modelPar_LKVTHO_dX);
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modParamMap["WKVTHO"] = &(modelStruct.d_modelPar_WKVTHO_dX);
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modParamMap["PKVTHO"] = &(modelStruct.d_modelPar_PKVTHO_dX);
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modParamMap["LLODVTH"] = &(modelStruct.d_modelPar_LLODVTH_dX);
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modParamMap["WLODVTH"] = &(modelStruct.d_modelPar_WLODVTH_dX);
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modParamMap["STETAO"] = &(modelStruct.d_modelPar_STETAO_dX);
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modParamMap["LODETAO"] = &(modelStruct.d_modelPar_LODETAO_dX);
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modParamMap["SCREF"] = &(modelStruct.d_modelPar_SCREF_dX);
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modParamMap["WEB"] = &(modelStruct.d_modelPar_WEB_dX);
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modParamMap["WEC"] = &(modelStruct.d_modelPar_WEC_dX);
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modParamMap["IMAX"] = &(modelStruct.d_modelPar_IMAX_dX);
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modParamMap["TRJ"] = &(modelStruct.d_modelPar_TRJ_dX);
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modParamMap["CJORBOT"] = &(modelStruct.d_modelPar_CJORBOT_dX);
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modParamMap["CJORSTI"] = &(modelStruct.d_modelPar_CJORSTI_dX);
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modParamMap["CJORGAT"] = &(modelStruct.d_modelPar_CJORGAT_dX);
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modParamMap["VBIRBOT"] = &(modelStruct.d_modelPar_VBIRBOT_dX);
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modParamMap["VBIRSTI"] = &(modelStruct.d_modelPar_VBIRSTI_dX);
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modParamMap["VBIRGAT"] = &(modelStruct.d_modelPar_VBIRGAT_dX);
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modParamMap["PBOT"] = &(modelStruct.d_modelPar_PBOT_dX);
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modParamMap["PSTI"] = &(modelStruct.d_modelPar_PSTI_dX);
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modParamMap["PGAT"] = &(modelStruct.d_modelPar_PGAT_dX);
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modParamMap["PHIGBOT"] = &(modelStruct.d_modelPar_PHIGBOT_dX);
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modParamMap["PHIGSTI"] = &(modelStruct.d_modelPar_PHIGSTI_dX);
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modParamMap["PHIGGAT"] = &(modelStruct.d_modelPar_PHIGGAT_dX);
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modParamMap["IDSATRBOT"] = &(modelStruct.d_modelPar_IDSATRBOT_dX);
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modParamMap["IDSATRSTI"] = &(modelStruct.d_modelPar_IDSATRSTI_dX);
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modParamMap["IDSATRGAT"] = &(modelStruct.d_modelPar_IDSATRGAT_dX);
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modParamMap["CSRHBOT"] = &(modelStruct.d_modelPar_CSRHBOT_dX);
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modParamMap["CSRHSTI"] = &(modelStruct.d_modelPar_CSRHSTI_dX);
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modParamMap["CSRHGAT"] = &(modelStruct.d_modelPar_CSRHGAT_dX);
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modParamMap["XJUNSTI"] = &(modelStruct.d_modelPar_XJUNSTI_dX);
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modParamMap["XJUNGAT"] = &(modelStruct.d_modelPar_XJUNGAT_dX);
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modParamMap["CTATBOT"] = &(modelStruct.d_modelPar_CTATBOT_dX);
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modParamMap["CTATSTI"] = &(modelStruct.d_modelPar_CTATSTI_dX);
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modParamMap["CTATGAT"] = &(modelStruct.d_modelPar_CTATGAT_dX);
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modParamMap["MEFFTATBOT"] = &(modelStruct.d_modelPar_MEFFTATBOT_dX);
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modParamMap["MEFFTATSTI"] = &(modelStruct.d_modelPar_MEFFTATSTI_dX);
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modParamMap["MEFFTATGAT"] = &(modelStruct.d_modelPar_MEFFTATGAT_dX);
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modParamMap["CBBTBOT"] = &(modelStruct.d_modelPar_CBBTBOT_dX);
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modParamMap["CBBTSTI"] = &(modelStruct.d_modelPar_CBBTSTI_dX);
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modParamMap["CBBTGAT"] = &(modelStruct.d_modelPar_CBBTGAT_dX);
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modParamMap["FBBTRBOT"] = &(modelStruct.d_modelPar_FBBTRBOT_dX);
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modParamMap["FBBTRSTI"] = &(modelStruct.d_modelPar_FBBTRSTI_dX);
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modParamMap["FBBTRGAT"] = &(modelStruct.d_modelPar_FBBTRGAT_dX);
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modParamMap["STFBBTBOT"] = &(modelStruct.d_modelPar_STFBBTBOT_dX);
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modParamMap["STFBBTSTI"] = &(modelStruct.d_modelPar_STFBBTSTI_dX);
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modParamMap["STFBBTGAT"] = &(modelStruct.d_modelPar_STFBBTGAT_dX);
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modParamMap["VBRBOT"] = &(modelStruct.d_modelPar_VBRBOT_dX);
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modParamMap["VBRSTI"] = &(modelStruct.d_modelPar_VBRSTI_dX);
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modParamMap["VBRGAT"] = &(modelStruct.d_modelPar_VBRGAT_dX);
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modParamMap["PBRBOT"] = &(modelStruct.d_modelPar_PBRBOT_dX);
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modParamMap["PBRSTI"] = &(modelStruct.d_modelPar_PBRSTI_dX);
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modParamMap["PBRGAT"] = &(modelStruct.d_modelPar_PBRGAT_dX);
modelStruct.modelPar_CJORBOTD=mod.CJORBOTD;
modelStruct.d_modelPar_CJORBOTD_dX=0.0;
modelStruct.modelPar_given_CJORBOTD=mod.given("CJORBOTD");
modParamMap["CJORBOTD"] = &(modelStruct.d_modelPar_CJORBOTD_dX);
modelStruct.modelPar_CJORSTID=mod.CJORSTID;
modelStruct.d_modelPar_CJORSTID_dX=0.0;
modelStruct.modelPar_given_CJORSTID=mod.given("CJORSTID");
modParamMap["CJORSTID"] = &(modelStruct.d_modelPar_CJORSTID_dX);
modelStruct.modelPar_CJORGATD=mod.CJORGATD;
modelStruct.d_modelPar_CJORGATD_dX=0.0;
modelStruct.modelPar_given_CJORGATD=mod.given("CJORGATD");
modParamMap["CJORGATD"] = &(modelStruct.d_modelPar_CJORGATD_dX);
modelStruct.modelPar_VBIRBOTD=mod.VBIRBOTD;
modelStruct.d_modelPar_VBIRBOTD_dX=0.0;
modelStruct.modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
modParamMap["VBIRBOTD"] = &(modelStruct.d_modelPar_VBIRBOTD_dX);
modelStruct.modelPar_VBIRSTID=mod.VBIRSTID;
modelStruct.d_modelPar_VBIRSTID_dX=0.0;
modelStruct.modelPar_given_VBIRSTID=mod.given("VBIRSTID");
modParamMap["VBIRSTID"] = &(modelStruct.d_modelPar_VBIRSTID_dX);
modelStruct.modelPar_VBIRGATD=mod.VBIRGATD;
modelStruct.d_modelPar_VBIRGATD_dX=0.0;
modelStruct.modelPar_given_VBIRGATD=mod.given("VBIRGATD");
modParamMap["VBIRGATD"] = &(modelStruct.d_modelPar_VBIRGATD_dX);
modelStruct.modelPar_PBOTD=mod.PBOTD;
modelStruct.d_modelPar_PBOTD_dX=0.0;
modelStruct.modelPar_given_PBOTD=mod.given("PBOTD");
modParamMap["PBOTD"] = &(modelStruct.d_modelPar_PBOTD_dX);
modelStruct.modelPar_PSTID=mod.PSTID;
modelStruct.d_modelPar_PSTID_dX=0.0;
modelStruct.modelPar_given_PSTID=mod.given("PSTID");
modParamMap["PSTID"] = &(modelStruct.d_modelPar_PSTID_dX);
modelStruct.modelPar_PGATD=mod.PGATD;
modelStruct.d_modelPar_PGATD_dX=0.0;
modelStruct.modelPar_given_PGATD=mod.given("PGATD");
modParamMap["PGATD"] = &(modelStruct.d_modelPar_PGATD_dX);
modelStruct.modelPar_PHIGBOTD=mod.PHIGBOTD;
modelStruct.d_modelPar_PHIGBOTD_dX=0.0;
modelStruct.modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
modParamMap["PHIGBOTD"] = &(modelStruct.d_modelPar_PHIGBOTD_dX);
modelStruct.modelPar_PHIGSTID=mod.PHIGSTID;
modelStruct.d_modelPar_PHIGSTID_dX=0.0;
modelStruct.modelPar_given_PHIGSTID=mod.given("PHIGSTID");
modParamMap["PHIGSTID"] = &(modelStruct.d_modelPar_PHIGSTID_dX);
modelStruct.modelPar_PHIGGATD=mod.PHIGGATD;
modelStruct.d_modelPar_PHIGGATD_dX=0.0;
modelStruct.modelPar_given_PHIGGATD=mod.given("PHIGGATD");
modParamMap["PHIGGATD"] = &(modelStruct.d_modelPar_PHIGGATD_dX);
modelStruct.modelPar_IDSATRBOTD=mod.IDSATRBOTD;
modelStruct.d_modelPar_IDSATRBOTD_dX=0.0;
modelStruct.modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
modParamMap["IDSATRBOTD"] = &(modelStruct.d_modelPar_IDSATRBOTD_dX);
modelStruct.modelPar_IDSATRSTID=mod.IDSATRSTID;
modelStruct.d_modelPar_IDSATRSTID_dX=0.0;
modelStruct.modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
modParamMap["IDSATRSTID"] = &(modelStruct.d_modelPar_IDSATRSTID_dX);
modelStruct.modelPar_IDSATRGATD=mod.IDSATRGATD;
modelStruct.d_modelPar_IDSATRGATD_dX=0.0;
modelStruct.modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
modParamMap["IDSATRGATD"] = &(modelStruct.d_modelPar_IDSATRGATD_dX);
modelStruct.modelPar_CSRHBOTD=mod.CSRHBOTD;
modelStruct.d_modelPar_CSRHBOTD_dX=0.0;
modelStruct.modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
modParamMap["CSRHBOTD"] = &(modelStruct.d_modelPar_CSRHBOTD_dX);
modelStruct.modelPar_CSRHSTID=mod.CSRHSTID;
modelStruct.d_modelPar_CSRHSTID_dX=0.0;
modelStruct.modelPar_given_CSRHSTID=mod.given("CSRHSTID");
modParamMap["CSRHSTID"] = &(modelStruct.d_modelPar_CSRHSTID_dX);
modelStruct.modelPar_CSRHGATD=mod.CSRHGATD;
modelStruct.d_modelPar_CSRHGATD_dX=0.0;
modelStruct.modelPar_given_CSRHGATD=mod.given("CSRHGATD");
modParamMap["CSRHGATD"] = &(modelStruct.d_modelPar_CSRHGATD_dX);
modelStruct.modelPar_XJUNSTID=mod.XJUNSTID;
modelStruct.d_modelPar_XJUNSTID_dX=0.0;
modelStruct.modelPar_given_XJUNSTID=mod.given("XJUNSTID");
modParamMap["XJUNSTID"] = &(modelStruct.d_modelPar_XJUNSTID_dX);
modelStruct.modelPar_XJUNGATD=mod.XJUNGATD;
modelStruct.d_modelPar_XJUNGATD_dX=0.0;
modelStruct.modelPar_given_XJUNGATD=mod.given("XJUNGATD");
modParamMap["XJUNGATD"] = &(modelStruct.d_modelPar_XJUNGATD_dX);
modelStruct.modelPar_CTATBOTD=mod.CTATBOTD;
modelStruct.d_modelPar_CTATBOTD_dX=0.0;
modelStruct.modelPar_given_CTATBOTD=mod.given("CTATBOTD");
modParamMap["CTATBOTD"] = &(modelStruct.d_modelPar_CTATBOTD_dX);
modelStruct.modelPar_CTATSTID=mod.CTATSTID;
modelStruct.d_modelPar_CTATSTID_dX=0.0;
modelStruct.modelPar_given_CTATSTID=mod.given("CTATSTID");
modParamMap["CTATSTID"] = &(modelStruct.d_modelPar_CTATSTID_dX);
modelStruct.modelPar_CTATGATD=mod.CTATGATD;
modelStruct.d_modelPar_CTATGATD_dX=0.0;
modelStruct.modelPar_given_CTATGATD=mod.given("CTATGATD");
modParamMap["CTATGATD"] = &(modelStruct.d_modelPar_CTATGATD_dX);
modelStruct.modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
modelStruct.d_modelPar_MEFFTATBOTD_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
modParamMap["MEFFTATBOTD"] = &(modelStruct.d_modelPar_MEFFTATBOTD_dX);
modelStruct.modelPar_MEFFTATSTID=mod.MEFFTATSTID;
modelStruct.d_modelPar_MEFFTATSTID_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
modParamMap["MEFFTATSTID"] = &(modelStruct.d_modelPar_MEFFTATSTID_dX);
modelStruct.modelPar_MEFFTATGATD=mod.MEFFTATGATD;
modelStruct.d_modelPar_MEFFTATGATD_dX=0.0;
modelStruct.modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
modParamMap["MEFFTATGATD"] = &(modelStruct.d_modelPar_MEFFTATGATD_dX);
modelStruct.modelPar_CBBTBOTD=mod.CBBTBOTD;
modelStruct.d_modelPar_CBBTBOTD_dX=0.0;
modelStruct.modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
modParamMap["CBBTBOTD"] = &(modelStruct.d_modelPar_CBBTBOTD_dX);
modelStruct.modelPar_CBBTSTID=mod.CBBTSTID;
modelStruct.d_modelPar_CBBTSTID_dX=0.0;
modelStruct.modelPar_given_CBBTSTID=mod.given("CBBTSTID");
modParamMap["CBBTSTID"] = &(modelStruct.d_modelPar_CBBTSTID_dX);
modelStruct.modelPar_CBBTGATD=mod.CBBTGATD;
modelStruct.d_modelPar_CBBTGATD_dX=0.0;
modelStruct.modelPar_given_CBBTGATD=mod.given("CBBTGATD");
modParamMap["CBBTGATD"] = &(modelStruct.d_modelPar_CBBTGATD_dX);
modelStruct.modelPar_FBBTRBOTD=mod.FBBTRBOTD;
modelStruct.d_modelPar_FBBTRBOTD_dX=0.0;
modelStruct.modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
modParamMap["FBBTRBOTD"] = &(modelStruct.d_modelPar_FBBTRBOTD_dX);
modelStruct.modelPar_FBBTRSTID=mod.FBBTRSTID;
modelStruct.d_modelPar_FBBTRSTID_dX=0.0;
modelStruct.modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
modParamMap["FBBTRSTID"] = &(modelStruct.d_modelPar_FBBTRSTID_dX);
modelStruct.modelPar_FBBTRGATD=mod.FBBTRGATD;
modelStruct.d_modelPar_FBBTRGATD_dX=0.0;
modelStruct.modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
modParamMap["FBBTRGATD"] = &(modelStruct.d_modelPar_FBBTRGATD_dX);
modelStruct.modelPar_STFBBTBOTD=mod.STFBBTBOTD;
modelStruct.d_modelPar_STFBBTBOTD_dX=0.0;
modelStruct.modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
modParamMap["STFBBTBOTD"] = &(modelStruct.d_modelPar_STFBBTBOTD_dX);
modelStruct.modelPar_STFBBTSTID=mod.STFBBTSTID;
modelStruct.d_modelPar_STFBBTSTID_dX=0.0;
modelStruct.modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
modParamMap["STFBBTSTID"] = &(modelStruct.d_modelPar_STFBBTSTID_dX);
modelStruct.modelPar_STFBBTGATD=mod.STFBBTGATD;
modelStruct.d_modelPar_STFBBTGATD_dX=0.0;
modelStruct.modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
modParamMap["STFBBTGATD"] = &(modelStruct.d_modelPar_STFBBTGATD_dX);
modelStruct.modelPar_VBRBOTD=mod.VBRBOTD;
modelStruct.d_modelPar_VBRBOTD_dX=0.0;
modelStruct.modelPar_given_VBRBOTD=mod.given("VBRBOTD");
modParamMap["VBRBOTD"] = &(modelStruct.d_modelPar_VBRBOTD_dX);
modelStruct.modelPar_VBRSTID=mod.VBRSTID;
modelStruct.d_modelPar_VBRSTID_dX=0.0;
modelStruct.modelPar_given_VBRSTID=mod.given("VBRSTID");
modParamMap["VBRSTID"] = &(modelStruct.d_modelPar_VBRSTID_dX);
modelStruct.modelPar_VBRGATD=mod.VBRGATD;
modelStruct.d_modelPar_VBRGATD_dX=0.0;
modelStruct.modelPar_given_VBRGATD=mod.given("VBRGATD");
modParamMap["VBRGATD"] = &(modelStruct.d_modelPar_VBRGATD_dX);
modelStruct.modelPar_PBRBOTD=mod.PBRBOTD;
modelStruct.d_modelPar_PBRBOTD_dX=0.0;
modelStruct.modelPar_given_PBRBOTD=mod.given("PBRBOTD");
modParamMap["PBRBOTD"] = &(modelStruct.d_modelPar_PBRBOTD_dX);
modelStruct.modelPar_PBRSTID=mod.PBRSTID;
modelStruct.d_modelPar_PBRSTID_dX=0.0;
modelStruct.modelPar_given_PBRSTID=mod.given("PBRSTID");
modParamMap["PBRSTID"] = &(modelStruct.d_modelPar_PBRSTID_dX);
modelStruct.modelPar_PBRGATD=mod.PBRGATD;
modelStruct.d_modelPar_PBRGATD_dX=0.0;
modelStruct.modelPar_given_PBRGATD=mod.given("PBRGATD");
modParamMap["PBRGATD"] = &(modelStruct.d_modelPar_PBRGATD_dX);
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modParamMap["SWJUNEXP"] = &(modelStruct.d_modelPar_SWJUNEXP_dX);
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modParamMap["VJUNREF"] = &(modelStruct.d_modelPar_VJUNREF_dX);
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modParamMap["FJUNQ"] = &(modelStruct.d_modelPar_FJUNQ_dX);
modelStruct.modelPar_VJUNREFD=mod.VJUNREFD;
modelStruct.d_modelPar_VJUNREFD_dX=0.0;
modelStruct.modelPar_given_VJUNREFD=mod.given("VJUNREFD");
modParamMap["VJUNREFD"] = &(modelStruct.d_modelPar_VJUNREFD_dX);
modelStruct.modelPar_FJUNQD=mod.FJUNQD;
modelStruct.d_modelPar_FJUNQD_dX=0.0;
modelStruct.modelPar_given_FJUNQD=mod.given("FJUNQD");
modParamMap["FJUNQD"] = &(modelStruct.d_modelPar_FJUNQD_dX);


// hidden reals


// non-reals (including hiddens)


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals
modelStruct.modelVar_NSUBO_i=mod.NSUBO_i;
modelStruct.d_modelVar_NSUBO_i_dX=0.0;
modelStruct.modelVar_WSEG_i=mod.WSEG_i;
modelStruct.d_modelVar_WSEG_i_dX=0.0;
modelStruct.modelVar_NPCK_i=mod.NPCK_i;
modelStruct.d_modelVar_NPCK_i_dX=0.0;
modelStruct.modelVar_WSEGP_i=mod.WSEGP_i;
modelStruct.d_modelVar_WSEGP_i_dX=0.0;
modelStruct.modelVar_LPCK_i=mod.LPCK_i;
modelStruct.d_modelVar_LPCK_i_dX=0.0;
modelStruct.modelVar_LOV_i=mod.LOV_i;
modelStruct.d_modelVar_LOV_i_dX=0.0;
modelStruct.modelVar_LOVD_i=mod.LOVD_i;
modelStruct.d_modelVar_LOVD_i_dX=0.0;
modelStruct.modelVar_LP1_i=mod.LP1_i;
modelStruct.d_modelVar_LP1_i_dX=0.0;
modelStruct.modelVar_LP2_i=mod.LP2_i;
modelStruct.d_modelVar_LP2_i_dX=0.0;
modelStruct.modelVar_WBET_i=mod.WBET_i;
modelStruct.d_modelVar_WBET_i_dX=0.0;
modelStruct.modelVar_AXL_i=mod.AXL_i;
modelStruct.d_modelVar_AXL_i_dX=0.0;
modelStruct.modelVar_ALP1L2_i=mod.ALP1L2_i;
modelStruct.d_modelVar_ALP1L2_i_dX=0.0;
modelStruct.modelVar_ALP2L2_i=mod.ALP2L2_i;
modelStruct.d_modelVar_ALP2L2_i_dX=0.0;
modelStruct.modelVar_RINT_i=mod.RINT_i;
modelStruct.d_modelVar_RINT_i_dX=0.0;
modelStruct.modelVar_RVPOLY_i=mod.RVPOLY_i;
modelStruct.d_modelVar_RVPOLY_i_dX=0.0;
modelStruct.modelVar_SAREF_i=mod.SAREF_i;
modelStruct.d_modelVar_SAREF_i_dX=0.0;
modelStruct.modelVar_SBREF_i=mod.SBREF_i;
modelStruct.d_modelVar_SBREF_i_dX=0.0;
modelStruct.modelVar_KVSAT_i=mod.KVSAT_i;
modelStruct.d_modelVar_KVSAT_i_dX=0.0;
modelStruct.modelVar_LLODKUO_i=mod.LLODKUO_i;
modelStruct.d_modelVar_LLODKUO_i_dX=0.0;
modelStruct.modelVar_WLODKUO_i=mod.WLODKUO_i;
modelStruct.d_modelVar_WLODKUO_i_dX=0.0;
modelStruct.modelVar_LLODVTH_i=mod.LLODVTH_i;
modelStruct.d_modelVar_LLODVTH_i_dX=0.0;
modelStruct.modelVar_WLODVTH_i=mod.WLODVTH_i;
modelStruct.d_modelVar_WLODVTH_i_dX=0.0;
modelStruct.modelVar_LODETAO_i=mod.LODETAO_i;
modelStruct.d_modelVar_LODETAO_i_dX=0.0;
modelStruct.modelVar_SCREF_i=mod.SCREF_i;
modelStruct.d_modelVar_SCREF_i_dX=0.0;
modelStruct.modelVar_WEB_i=mod.WEB_i;
modelStruct.d_modelVar_WEB_i_dX=0.0;
modelStruct.modelVar_WEC_i=mod.WEC_i;
modelStruct.d_modelVar_WEC_i_dX=0.0;
modelStruct.modelVar_TOX_i=mod.TOX_i;
modelStruct.d_modelVar_TOX_i_dX=0.0;
modelStruct.modelVar_EPSROX_i=mod.EPSROX_i;
modelStruct.d_modelVar_EPSROX_i_dX=0.0;
modelStruct.modelVar_TOXOV_i=mod.TOXOV_i;
modelStruct.d_modelVar_TOXOV_i_dX=0.0;
modelStruct.modelVar_TOXOVD_i=mod.TOXOVD_i;
modelStruct.d_modelVar_TOXOVD_i_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.d_modelVar_TKD_dX=0.0;
modelStruct.modelVar_dT=mod.dT;
modelStruct.d_modelVar_dT_dX=0.0;
modelStruct.modelVar_rT=mod.rT;
modelStruct.d_modelVar_rT_dX=0.0;
modelStruct.modelVar_rTn=mod.rTn;
modelStruct.d_modelVar_rTn_dX=0.0;
modelStruct.modelVar_EPSSI=mod.EPSSI;
modelStruct.modelVar_phit=mod.phit;
modelStruct.d_modelVar_phit_dX=0.0;
modelStruct.modelVar_inv_phit=mod.inv_phit;
modelStruct.d_modelVar_inv_phit_dX=0.0;
modelStruct.modelVar_Eg=mod.Eg;
modelStruct.d_modelVar_Eg_dX=0.0;
modelStruct.modelVar_phibFac=mod.phibFac;
modelStruct.d_modelVar_phibFac_dX=0.0;
modelStruct.modelVar_nt0=mod.nt0;
modelStruct.d_modelVar_nt0_dX=0.0;
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX=0.0;
modelStruct.modelVar_VBIRSTID_i=mod.VBIRSTID_i;
modelStruct.d_modelVar_VBIRSTID_i_dX=0.0;
modelStruct.modelVar_VBIRGATD_i=mod.VBIRGATD_i;
modelStruct.d_modelVar_VBIRGATD_i_dX=0.0;
modelStruct.modelVar_PBOTD_i=mod.PBOTD_i;
modelStruct.d_modelVar_PBOTD_i_dX=0.0;
modelStruct.modelVar_PSTID_i=mod.PSTID_i;
modelStruct.d_modelVar_PSTID_i_dX=0.0;
modelStruct.modelVar_PGATD_i=mod.PGATD_i;
modelStruct.d_modelVar_PGATD_i_dX=0.0;
modelStruct.modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX=0.0;
modelStruct.modelVar_CSRHSTID_i=mod.CSRHSTID_i;
modelStruct.d_modelVar_CSRHSTID_i_dX=0.0;
modelStruct.modelVar_CSRHGATD_i=mod.CSRHGATD_i;
modelStruct.d_modelVar_CSRHGATD_i_dX=0.0;
modelStruct.modelVar_CTATBOTD_i=mod.CTATBOTD_i;
modelStruct.d_modelVar_CTATBOTD_i_dX=0.0;
modelStruct.modelVar_CTATSTID_i=mod.CTATSTID_i;
modelStruct.d_modelVar_CTATSTID_i_dX=0.0;
modelStruct.modelVar_CTATGATD_i=mod.CTATGATD_i;
modelStruct.d_modelVar_CTATGATD_i_dX=0.0;
modelStruct.modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX=0.0;
modelStruct.modelVar_CBBTSTID_i=mod.CBBTSTID_i;
modelStruct.d_modelVar_CBBTSTID_i_dX=0.0;
modelStruct.modelVar_CBBTGATD_i=mod.CBBTGATD_i;
modelStruct.d_modelVar_CBBTGATD_i_dX=0.0;
modelStruct.modelVar_VBRBOTD_i=mod.VBRBOTD_i;
modelStruct.d_modelVar_VBRBOTD_i_dX=0.0;
modelStruct.modelVar_VBRSTID_i=mod.VBRSTID_i;
modelStruct.d_modelVar_VBRSTID_i_dX=0.0;
modelStruct.modelVar_VBRGATD_i=mod.VBRGATD_i;
modelStruct.d_modelVar_VBRGATD_i_dX=0.0;
modelStruct.modelVar_PBRBOTD_i=mod.PBRBOTD_i;
modelStruct.d_modelVar_PBRBOTD_i_dX=0.0;
modelStruct.modelVar_PBRSTID_i=mod.PBRSTID_i;
modelStruct.d_modelVar_PBRSTID_i_dX=0.0;
modelStruct.modelVar_PBRGATD_i=mod.PBRGATD_i;
modelStruct.d_modelVar_PBRGATD_i_dX=0.0;
modelStruct.modelVar_VJUNREFD_i=mod.VJUNREFD_i;
modelStruct.d_modelVar_VJUNREFD_i_dX=0.0;
modelStruct.modelVar_FJUNQD_i=mod.FJUNQD_i;
modelStruct.d_modelVar_FJUNQD_i_dX=0.0;
modelStruct.modelVar_ftdbot_d=mod.ftdbot_d;
modelStruct.d_modelVar_ftdbot_d_dX=0.0;
modelStruct.modelVar_ftdsti_d=mod.ftdsti_d;
modelStruct.d_modelVar_ftdsti_d_dX=0.0;
modelStruct.modelVar_ftdgat_d=mod.ftdgat_d;
modelStruct.d_modelVar_ftdgat_d_dX=0.0;
modelStruct.modelVar_idsatbot_d=mod.idsatbot_d;
modelStruct.d_modelVar_idsatbot_d_dX=0.0;
modelStruct.modelVar_idsatsti_d=mod.idsatsti_d;
modelStruct.d_modelVar_idsatsti_d_dX=0.0;
modelStruct.modelVar_idsatgat_d=mod.idsatgat_d;
modelStruct.d_modelVar_idsatgat_d_dX=0.0;
modelStruct.modelVar_vbibot_d=mod.vbibot_d;
modelStruct.d_modelVar_vbibot_d_dX=0.0;
modelStruct.modelVar_vbisti_d=mod.vbisti_d;
modelStruct.d_modelVar_vbisti_d_dX=0.0;
modelStruct.modelVar_vbigat_d=mod.vbigat_d;
modelStruct.d_modelVar_vbigat_d_dX=0.0;
modelStruct.modelVar_vbiinvbot_d=mod.vbiinvbot_d;
modelStruct.d_modelVar_vbiinvbot_d_dX=0.0;
modelStruct.modelVar_vbiinvsti_d=mod.vbiinvsti_d;
modelStruct.d_modelVar_vbiinvsti_d_dX=0.0;
modelStruct.modelVar_vbiinvgat_d=mod.vbiinvgat_d;
modelStruct.d_modelVar_vbiinvgat_d_dX=0.0;
modelStruct.modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
modelStruct.d_modelVar_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
modelStruct.d_modelVar_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
modelStruct.d_modelVar_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_cjobot_d=mod.cjobot_d;
modelStruct.d_modelVar_cjobot_d_dX=0.0;
modelStruct.modelVar_cjosti_d=mod.cjosti_d;
modelStruct.d_modelVar_cjosti_d_dX=0.0;
modelStruct.modelVar_cjogat_d=mod.cjogat_d;
modelStruct.d_modelVar_cjogat_d_dX=0.0;
modelStruct.modelVar_qprefbot_d=mod.qprefbot_d;
modelStruct.d_modelVar_qprefbot_d_dX=0.0;
modelStruct.modelVar_qprefsti_d=mod.qprefsti_d;
modelStruct.d_modelVar_qprefsti_d_dX=0.0;
modelStruct.modelVar_qprefgat_d=mod.qprefgat_d;
modelStruct.d_modelVar_qprefgat_d_dX=0.0;
modelStruct.modelVar_qpref2bot_d=mod.qpref2bot_d;
modelStruct.d_modelVar_qpref2bot_d_dX=0.0;
modelStruct.modelVar_qpref2sti_d=mod.qpref2sti_d;
modelStruct.d_modelVar_qpref2sti_d_dX=0.0;
modelStruct.modelVar_qpref2gat_d=mod.qpref2gat_d;
modelStruct.d_modelVar_qpref2gat_d_dX=0.0;
modelStruct.modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
modelStruct.d_modelVar_wdepnulrbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
modelStruct.d_modelVar_wdepnulrsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
modelStruct.d_modelVar_wdepnulrgat_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
modelStruct.d_modelVar_wdepnulrinvbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
modelStruct.d_modelVar_wdepnulrinvsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
modelStruct.d_modelVar_wdepnulrinvgat_d_dX=0.0;
modelStruct.modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
modelStruct.d_modelVar_VBIRBOTinv_d_dX=0.0;
modelStruct.modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
modelStruct.d_modelVar_VBIRSTIinv_d_dX=0.0;
modelStruct.modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
modelStruct.d_modelVar_VBIRGATinv_d_dX=0.0;
modelStruct.modelVar_atatbot_d=mod.atatbot_d;
modelStruct.d_modelVar_atatbot_d_dX=0.0;
modelStruct.modelVar_atatsti_d=mod.atatsti_d;
modelStruct.d_modelVar_atatsti_d_dX=0.0;
modelStruct.modelVar_atatgat_d=mod.atatgat_d;
modelStruct.d_modelVar_atatgat_d_dX=0.0;
modelStruct.modelVar_btatpartbot_d=mod.btatpartbot_d;
modelStruct.d_modelVar_btatpartbot_d_dX=0.0;
modelStruct.modelVar_btatpartsti_d=mod.btatpartsti_d;
modelStruct.d_modelVar_btatpartsti_d_dX=0.0;
modelStruct.modelVar_btatpartgat_d=mod.btatpartgat_d;
modelStruct.d_modelVar_btatpartgat_d_dX=0.0;
modelStruct.modelVar_fbbtbot_d=mod.fbbtbot_d;
modelStruct.d_modelVar_fbbtbot_d_dX=0.0;
modelStruct.modelVar_fbbtsti_d=mod.fbbtsti_d;
modelStruct.d_modelVar_fbbtsti_d_dX=0.0;
modelStruct.modelVar_fbbtgat_d=mod.fbbtgat_d;
modelStruct.d_modelVar_fbbtgat_d_dX=0.0;
modelStruct.modelVar_fstopbot_d=mod.fstopbot_d;
modelStruct.d_modelVar_fstopbot_d_dX=0.0;
modelStruct.modelVar_fstopsti_d=mod.fstopsti_d;
modelStruct.d_modelVar_fstopsti_d_dX=0.0;
modelStruct.modelVar_fstopgat_d=mod.fstopgat_d;
modelStruct.d_modelVar_fstopgat_d_dX=0.0;
modelStruct.modelVar_VBRinvbot_d=mod.VBRinvbot_d;
modelStruct.d_modelVar_VBRinvbot_d_dX=0.0;
modelStruct.modelVar_VBRinvsti_d=mod.VBRinvsti_d;
modelStruct.d_modelVar_VBRinvsti_d_dX=0.0;
modelStruct.modelVar_VBRinvgat_d=mod.VBRinvgat_d;
modelStruct.d_modelVar_VBRinvgat_d_dX=0.0;
modelStruct.modelVar_slopebot_d=mod.slopebot_d;
modelStruct.d_modelVar_slopebot_d_dX=0.0;
modelStruct.modelVar_slopesti_d=mod.slopesti_d;
modelStruct.d_modelVar_slopesti_d_dX=0.0;
modelStruct.modelVar_slopegat_d=mod.slopegat_d;
modelStruct.d_modelVar_slopegat_d_dX=0.0;


// non-reals
modelStruct.modelVar_CHNL_TYPE=mod.CHNL_TYPE;



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 11+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.d_instancePar_SCA_dX=0.0;
instanceStruct.instancePar_given_SCA=in.given("SCA");
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.d_instancePar_SCB_dX=0.0;
instanceStruct.instancePar_given_SCB=in.given("SCB");
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.d_instancePar_SCC_dX=0.0;
instanceStruct.instancePar_given_SCC=in.given("SCC");
instanceStruct.instancePar_SC=in.SC;
instanceStruct.d_instancePar_SC_dX=0.0;
instanceStruct.instancePar_given_SC=in.given("SC");
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");
instanceStruct.instancePar_ABSOURCE=in.ABSOURCE;
instanceStruct.d_instancePar_ABSOURCE_dX=0.0;
instanceStruct.instancePar_given_ABSOURCE=in.given("ABSOURCE");
instanceStruct.instancePar_LSSOURCE=in.LSSOURCE;
instanceStruct.d_instancePar_LSSOURCE_dX=0.0;
instanceStruct.instancePar_given_LSSOURCE=in.given("LSSOURCE");
instanceStruct.instancePar_LGSOURCE=in.LGSOURCE;
instanceStruct.d_instancePar_LGSOURCE_dX=0.0;
instanceStruct.instancePar_given_LGSOURCE=in.given("LGSOURCE");
instanceStruct.instancePar_ABDRAIN=in.ABDRAIN;
instanceStruct.d_instancePar_ABDRAIN_dX=0.0;
instanceStruct.instancePar_given_ABDRAIN=in.given("ABDRAIN");
instanceStruct.instancePar_LSDRAIN=in.LSDRAIN;
instanceStruct.d_instancePar_LSDRAIN_dX=0.0;
instanceStruct.instancePar_given_LSDRAIN=in.given("LSDRAIN");
instanceStruct.instancePar_LGDRAIN=in.LGDRAIN;
instanceStruct.d_instancePar_LGDRAIN_dX=0.0;
instanceStruct.instancePar_given_LGDRAIN=in.given("LGDRAIN");
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");
instanceStruct.instancePar_NF=in.NF;
instanceStruct.d_instancePar_NF_dX=0.0;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.d_instancePar_NGCON_dX=0.0;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_LE=in.LE;
instanceStruct.d_instanceVar_LE_dX=0.0;
instanceStruct.instanceVar_WE=in.WE;
instanceStruct.d_instanceVar_WE_dX=0.0;
instanceStruct.instanceVar_VFB_i=in.VFB_i;
instanceStruct.d_instanceVar_VFB_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_NEFF_i=in.NEFF_i;
instanceStruct.d_instanceVar_NEFF_i_dX=0.0;
instanceStruct.instanceVar_VNSUB_i=in.VNSUB_i;
instanceStruct.d_instanceVar_VNSUB_i_dX=0.0;
instanceStruct.instanceVar_NSLP_i=in.NSLP_i;
instanceStruct.d_instanceVar_NSLP_i_dX=0.0;
instanceStruct.instanceVar_DNSUB_i=in.DNSUB_i;
instanceStruct.d_instanceVar_DNSUB_i_dX=0.0;
instanceStruct.instanceVar_NP_i=in.NP_i;
instanceStruct.d_instanceVar_NP_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CFB_i=in.CFB_i;
instanceStruct.d_instanceVar_CFB_i_dX=0.0;
instanceStruct.instanceVar_DPHIB_i=in.DPHIB_i;
instanceStruct.d_instanceVar_DPHIB_i_dX=0.0;
instanceStruct.instanceVar_BETN_i=in.BETN_i;
instanceStruct.d_instanceVar_BETN_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_MUE_i=in.MUE_i;
instanceStruct.d_instanceVar_MUE_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_THEMU_i=in.THEMU_i;
instanceStruct.d_instanceVar_THEMU_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_CS_i=in.CS_i;
instanceStruct.d_instanceVar_CS_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_XCOR_i=in.XCOR_i;
instanceStruct.d_instanceVar_XCOR_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_FETA_i=in.FETA_i;
instanceStruct.d_instanceVar_FETA_i_dX=0.0;
instanceStruct.instanceVar_RS_i=in.RS_i;
instanceStruct.d_instanceVar_RS_i_dX=0.0;
instanceStruct.instanceVar_THER_i=in.THER_i;
instanceStruct.d_instanceVar_THER_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_THESAT_i=in.THESAT_i;
instanceStruct.d_instanceVar_THESAT_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_THESATB_i=in.THESATB_i;
instanceStruct.d_instanceVar_THESATB_i_dX=0.0;
instanceStruct.instanceVar_THESATG_i=in.THESATG_i;
instanceStruct.d_instanceVar_THESATG_i_dX=0.0;
instanceStruct.instanceVar_AX_i=in.AX_i;
instanceStruct.d_instanceVar_AX_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALP2_i=in.ALP2_i;
instanceStruct.d_instanceVar_ALP2_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_A2_i=in.A2_i;
instanceStruct.d_instanceVar_A2_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_A4_i=in.A4_i;
instanceStruct.d_instanceVar_A4_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOV_i=in.IGOV_i;
instanceStruct.d_instanceVar_IGOV_i_dX=0.0;
instanceStruct.instanceVar_IGOVD_i=in.IGOVD_i;
instanceStruct.d_instanceVar_IGOVD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_GC2_i=in.GC2_i;
instanceStruct.d_instanceVar_GC2_i_dX=0.0;
instanceStruct.instanceVar_GC3_i=in.GC3_i;
instanceStruct.d_instanceVar_GC3_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_COX_i=in.COX_i;
instanceStruct.d_instanceVar_COX_i_dX=0.0;
instanceStruct.instanceVar_CGOV_i=in.CGOV_i;
instanceStruct.d_instanceVar_CGOV_i_dX=0.0;
instanceStruct.instanceVar_CGOVD_i=in.CGOVD_i;
instanceStruct.d_instanceVar_CGOVD_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_BET_i=in.BET_i;
instanceStruct.d_instanceVar_BET_i_dX=0.0;
instanceStruct.instanceVar_kp=in.kp;
instanceStruct.d_instanceVar_kp_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_qlim2=in.qlim2;
instanceStruct.d_instanceVar_qlim2_dX=0.0;
instanceStruct.instanceVar_E_eff0=in.E_eff0;
instanceStruct.d_instanceVar_E_eff0_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_GCQ=in.GCQ;
instanceStruct.d_instanceVar_GCQ_dX=0.0;
instanceStruct.instanceVar_Dch=in.Dch;
instanceStruct.d_instanceVar_Dch_dX=0.0;
instanceStruct.instanceVar_Dov=in.Dov;
instanceStruct.d_instanceVar_Dov_dX=0.0;
instanceStruct.instanceVar_x1=in.x1;
instanceStruct.instanceVar_Vdsat_lim=in.Vdsat_lim;
instanceStruct.d_instanceVar_Vdsat_lim_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_Cox_over_q=in.Cox_over_q;
instanceStruct.d_instanceVar_Cox_over_q_dX=0.0;
instanceStruct.instanceVar_GOV_s=in.GOV_s;
instanceStruct.d_instanceVar_GOV_s_dX=0.0;
instanceStruct.instanceVar_GOV_d=in.GOV_d;
instanceStruct.d_instanceVar_GOV_d_dX=0.0;
instanceStruct.instanceVar_GOV2_s=in.GOV2_s;
instanceStruct.d_instanceVar_GOV2_s_dX=0.0;
instanceStruct.instanceVar_GOV2_d=in.GOV2_d;
instanceStruct.d_instanceVar_GOV2_d_dX=0.0;
instanceStruct.instanceVar_BOV_d=in.BOV_d;
instanceStruct.d_instanceVar_BOV_d_dX=0.0;
instanceStruct.instanceVar_xi_ov_s=in.xi_ov_s;
instanceStruct.d_instanceVar_xi_ov_s_dX=0.0;
instanceStruct.instanceVar_xi_ov_d=in.xi_ov_d;
instanceStruct.d_instanceVar_xi_ov_d_dX=0.0;
instanceStruct.instanceVar_inv_xi_ov_s=in.inv_xi_ov_s;
instanceStruct.d_instanceVar_inv_xi_ov_s_dX=0.0;
instanceStruct.instanceVar_inv_xi_ov_d=in.inv_xi_ov_d;
instanceStruct.d_instanceVar_inv_xi_ov_d_dX=0.0;
instanceStruct.instanceVar_x_mrg_ov_s=in.x_mrg_ov_s;
instanceStruct.d_instanceVar_x_mrg_ov_s_dX=0.0;
instanceStruct.instanceVar_x_mrg_ov_d=in.x_mrg_ov_d;
instanceStruct.d_instanceVar_x_mrg_ov_d_dX=0.0;
instanceStruct.instanceVar_inv_xg1_s=in.inv_xg1_s;
instanceStruct.d_instanceVar_inv_xg1_s_dX=0.0;
instanceStruct.instanceVar_inv_xg1_d=in.inv_xg1_d;
instanceStruct.d_instanceVar_inv_xg1_d_dX=0.0;
instanceStruct.instanceVar_AGIDLs=in.AGIDLs;
instanceStruct.d_instanceVar_AGIDLs_dX=0.0;
instanceStruct.instanceVar_AGIDLDs=in.AGIDLDs;
instanceStruct.d_instanceVar_AGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDLs=in.BGIDLs;
instanceStruct.d_instanceVar_BGIDLs_dX=0.0;
instanceStruct.instanceVar_BGIDLDs=in.BGIDLDs;
instanceStruct.d_instanceVar_BGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDL_T=in.BGIDL_T;
instanceStruct.d_instanceVar_BGIDL_T_dX=0.0;
instanceStruct.instanceVar_BGIDLD_T=in.BGIDLD_T;
instanceStruct.d_instanceVar_BGIDLD_T_dX=0.0;
instanceStruct.instanceVar_phib=in.phib;
instanceStruct.d_instanceVar_phib_dX=0.0;
instanceStruct.instanceVar_sqrt_phib=in.sqrt_phib;
instanceStruct.d_instanceVar_sqrt_phib_dX=0.0;
instanceStruct.instanceVar_phix=in.phix;
instanceStruct.d_instanceVar_phix_dX=0.0;
instanceStruct.instanceVar_aphi=in.aphi;
instanceStruct.d_instanceVar_aphi_dX=0.0;
instanceStruct.instanceVar_bphi=in.bphi;
instanceStruct.d_instanceVar_bphi_dX=0.0;
instanceStruct.instanceVar_phix1=in.phix1;
instanceStruct.d_instanceVar_phix1_dX=0.0;
instanceStruct.instanceVar_G_0=in.G_0;
instanceStruct.d_instanceVar_G_0_dX=0.0;
instanceStruct.instanceVar_phit1=in.phit1;
instanceStruct.d_instanceVar_phit1_dX=0.0;
instanceStruct.instanceVar_inv_phit1=in.inv_phit1;
instanceStruct.d_instanceVar_inv_phit1_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_inv_VP=in.inv_VP;
instanceStruct.d_instanceVar_inv_VP_dX=0.0;
instanceStruct.instanceVar_inv_AX=in.inv_AX;
instanceStruct.d_instanceVar_inv_AX_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac=in.Sfl_prefac;
instanceStruct.d_instanceVar_Sfl_prefac_dX=0.0;
instanceStruct.instanceVar_Sfl=in.Sfl;
instanceStruct.d_instanceVar_Sfl_dX=0.0;
instanceStruct.instanceVar_CGeff=in.CGeff;
instanceStruct.d_instanceVar_CGeff_dX=0.0;
instanceStruct.instanceVar_mig=in.mig;
instanceStruct.d_instanceVar_mig_dX=0.0;
instanceStruct.instanceVar_c_igid=in.c_igid;
instanceStruct.d_instanceVar_c_igid_dX=0.0;
instanceStruct.instanceVar_sqid=in.sqid;
instanceStruct.d_instanceVar_sqid_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_shot_iavl=in.shot_iavl;
instanceStruct.d_instanceVar_shot_iavl_dX=0.0;
instanceStruct.instanceVar_shot_igcsx=in.shot_igcsx;
instanceStruct.d_instanceVar_shot_igcsx_dX=0.0;
instanceStruct.instanceVar_shot_igcdx=in.shot_igcdx;
instanceStruct.d_instanceVar_shot_igcdx_dX=0.0;
instanceStruct.instanceVar_shot_igsov=in.shot_igsov;
instanceStruct.d_instanceVar_shot_igsov_dX=0.0;
instanceStruct.instanceVar_shot_igdov=in.shot_igdov;
instanceStruct.d_instanceVar_shot_igdov_dX=0.0;
instanceStruct.instanceVar_RG_i=in.RG_i;
instanceStruct.d_instanceVar_RG_i_dX=0.0;
instanceStruct.instanceVar_RBULK_i=in.RBULK_i;
instanceStruct.d_instanceVar_RBULK_i_dX=0.0;
instanceStruct.instanceVar_RWELL_i=in.RWELL_i;
instanceStruct.d_instanceVar_RWELL_i_dX=0.0;
instanceStruct.instanceVar_RJUNS_i=in.RJUNS_i;
instanceStruct.d_instanceVar_RJUNS_i_dX=0.0;
instanceStruct.instanceVar_RJUND_i=in.RJUND_i;
instanceStruct.d_instanceVar_RJUND_i_dX=0.0;
instanceStruct.instanceVar_ggate=in.ggate;
instanceStruct.d_instanceVar_ggate_dX=0.0;
instanceStruct.instanceVar_gbulk=in.gbulk;
instanceStruct.d_instanceVar_gbulk_dX=0.0;
instanceStruct.instanceVar_gwell=in.gwell;
instanceStruct.d_instanceVar_gwell_dX=0.0;
instanceStruct.instanceVar_gjund=in.gjund;
instanceStruct.d_instanceVar_gjund_dX=0.0;
instanceStruct.instanceVar_gjuns=in.gjuns;
instanceStruct.d_instanceVar_gjuns_dX=0.0;
instanceStruct.instanceVar_ABSOURCE_i=in.ABSOURCE_i;
instanceStruct.d_instanceVar_ABSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LSSOURCE_i=in.LSSOURCE_i;
instanceStruct.d_instanceVar_LSSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LGSOURCE_i=in.LGSOURCE_i;
instanceStruct.d_instanceVar_LGSOURCE_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_s=in.zflagbot_s;
instanceStruct.instanceVar_zflagsti_s=in.zflagsti_s;
instanceStruct.instanceVar_zflaggat_s=in.zflaggat_s;
instanceStruct.instanceVar_VMAX_s=in.VMAX_s;
instanceStruct.d_instanceVar_VMAX_s_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX=0.0;
instanceStruct.instanceVar_vbimin_s=in.vbimin_s;
instanceStruct.d_instanceVar_vbimin_s_dX=0.0;
instanceStruct.instanceVar_vch_s=in.vch_s;
instanceStruct.d_instanceVar_vch_s_dX=0.0;
instanceStruct.instanceVar_vfmin_s=in.vfmin_s;
instanceStruct.d_instanceVar_vfmin_s_dX=0.0;
instanceStruct.instanceVar_vbbtlim_s=in.vbbtlim_s;
instanceStruct.d_instanceVar_vbbtlim_s_dX=0.0;
instanceStruct.instanceVar_xhighf1_s=in.xhighf1_s;
instanceStruct.d_instanceVar_xhighf1_s_dX=0.0;
instanceStruct.instanceVar_expxhf1_s=in.expxhf1_s;
instanceStruct.d_instanceVar_expxhf1_s_dX=0.0;
instanceStruct.instanceVar_xhighf2_s=in.xhighf2_s;
instanceStruct.d_instanceVar_xhighf2_s_dX=0.0;
instanceStruct.instanceVar_expxhf2_s=in.expxhf2_s;
instanceStruct.d_instanceVar_expxhf2_s_dX=0.0;
instanceStruct.instanceVar_xhighr_s=in.xhighr_s;
instanceStruct.d_instanceVar_xhighr_s_dX=0.0;
instanceStruct.instanceVar_expxhr_s=in.expxhr_s;
instanceStruct.d_instanceVar_expxhr_s_dX=0.0;
instanceStruct.instanceVar_m0flag_s=in.m0flag_s;
instanceStruct.instanceVar_ISATFOR1_s=in.ISATFOR1_s;
instanceStruct.d_instanceVar_ISATFOR1_s_dX=0.0;
instanceStruct.instanceVar_MFOR1_s=in.MFOR1_s;
instanceStruct.instanceVar_ISATFOR2_s=in.ISATFOR2_s;
instanceStruct.d_instanceVar_ISATFOR2_s_dX=0.0;
instanceStruct.instanceVar_MFOR2_s=in.MFOR2_s;
instanceStruct.d_instanceVar_MFOR2_s_dX=0.0;
instanceStruct.instanceVar_ISATREV_s=in.ISATREV_s;
instanceStruct.d_instanceVar_ISATREV_s_dX=0.0;
instanceStruct.instanceVar_MREV_s=in.MREV_s;
instanceStruct.d_instanceVar_MREV_s_dX=0.0;
instanceStruct.instanceVar_ABDRAIN_i=in.ABDRAIN_i;
instanceStruct.d_instanceVar_ABDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LSDRAIN_i=in.LSDRAIN_i;
instanceStruct.d_instanceVar_LSDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LGDRAIN_i=in.LGDRAIN_i;
instanceStruct.d_instanceVar_LGDRAIN_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_d=in.zflagbot_d;
instanceStruct.instanceVar_zflagsti_d=in.zflagsti_d;
instanceStruct.instanceVar_zflaggat_d=in.zflaggat_d;
instanceStruct.instanceVar_VMAX_d=in.VMAX_d;
instanceStruct.d_instanceVar_VMAX_d_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX=0.0;
instanceStruct.instanceVar_vbimin_d=in.vbimin_d;
instanceStruct.d_instanceVar_vbimin_d_dX=0.0;
instanceStruct.instanceVar_vch_d=in.vch_d;
instanceStruct.d_instanceVar_vch_d_dX=0.0;
instanceStruct.instanceVar_vfmin_d=in.vfmin_d;
instanceStruct.d_instanceVar_vfmin_d_dX=0.0;
instanceStruct.instanceVar_vbbtlim_d=in.vbbtlim_d;
instanceStruct.d_instanceVar_vbbtlim_d_dX=0.0;
instanceStruct.instanceVar_xhighf1_d=in.xhighf1_d;
instanceStruct.d_instanceVar_xhighf1_d_dX=0.0;
instanceStruct.instanceVar_expxhf1_d=in.expxhf1_d;
instanceStruct.d_instanceVar_expxhf1_d_dX=0.0;
instanceStruct.instanceVar_xhighf2_d=in.xhighf2_d;
instanceStruct.d_instanceVar_xhighf2_d_dX=0.0;
instanceStruct.instanceVar_expxhf2_d=in.expxhf2_d;
instanceStruct.d_instanceVar_expxhf2_d_dX=0.0;
instanceStruct.instanceVar_xhighr_d=in.xhighr_d;
instanceStruct.d_instanceVar_xhighr_d_dX=0.0;
instanceStruct.instanceVar_expxhr_d=in.expxhr_d;
instanceStruct.d_instanceVar_expxhr_d_dX=0.0;
instanceStruct.instanceVar_m0flag_d=in.m0flag_d;
instanceStruct.instanceVar_ISATFOR1_d=in.ISATFOR1_d;
instanceStruct.d_instanceVar_ISATFOR1_d_dX=0.0;
instanceStruct.instanceVar_MFOR1_d=in.MFOR1_d;
instanceStruct.instanceVar_ISATFOR2_d=in.ISATFOR2_d;
instanceStruct.d_instanceVar_ISATFOR2_d_dX=0.0;
instanceStruct.instanceVar_MFOR2_d=in.MFOR2_d;
instanceStruct.d_instanceVar_MFOR2_d_dX=0.0;
instanceStruct.instanceVar_ISATREV_d=in.ISATREV_d;
instanceStruct.d_instanceVar_ISATREV_d_dX=0.0;
instanceStruct.instanceVar_MREV_d=in.MREV_d;
instanceStruct.d_instanceVar_MREV_d_dX=0.0;
instanceStruct.instanceVar_jnoisex_s=in.jnoisex_s;
instanceStruct.d_instanceVar_jnoisex_s_dX=0.0;
instanceStruct.instanceVar_jnoisex_d=in.jnoisex_d;
instanceStruct.d_instanceVar_jnoisex_d_dX=0.0;


  //non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_D_GND] = (*solVectorPtr)[in.li_D];
probeVars[in.admsProbeID_V_BS_GND] = (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_BD_GND] = (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_S_GND] = (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_BP_GND] = (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_GP_GND] = (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
probeVars[in.admsProbeID_V_D_BD] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_S_BS] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_S_BP] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_D_S] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_GP_S] = (*solVectorPtr)[in.li_GP] - (*solVectorPtr)[in.li_S];
probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G] - (*solVectorPtr)[in.li_GP];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_D_GND,
in.admsProbeID_V_BS_GND,
in.admsProbeID_V_BD_GND,
in.admsProbeID_V_S_GND,
in.admsProbeID_V_BP_GND,
in.admsProbeID_V_GP_GND,
in.admsProbeID_V_NOI_GND,
in.admsProbeID_V_NOI2_GND,
in.admsProbeID_V_D_BD,
in.admsProbeID_V_S_BS,
in.admsProbeID_V_S_BP,
in.admsProbeID_V_D_S,
in.admsProbeID_V_GP_S,
in.admsProbeID_V_B_BI,
in.admsProbeID_V_BP_BI,
in.admsProbeID_V_BD_BI,
in.admsProbeID_V_BS_BI,
in.admsProbeID_V_G_GP,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_NOI,
in.admsNodeID_NOI2,
in.admsNodeID_GP,
in.admsNodeID_BP,
in.admsNodeID_BI,
in.admsNodeID_BS,
in.admsNodeID_BD,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D+inst*(11+0)] = in.li_D;
    Qindices[in.admsNodeID_D+inst*(11+0)] = in.li_D;
    dfdp[in.admsNodeID_G+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G+inst*(11+0)] = in.li_G;
    Qindices[in.admsNodeID_G+inst*(11+0)] = in.li_G;
    dfdp[in.admsNodeID_S+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S+inst*(11+0)] = in.li_S;
    Qindices[in.admsNodeID_S+inst*(11+0)] = in.li_S;
    dfdp[in.admsNodeID_B+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B+inst*(11+0)] = in.li_B;
    Qindices[in.admsNodeID_B+inst*(11+0)] = in.li_B;
    dfdp[in.admsNodeID_NOI+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_NOI];
    dqdp[in.admsNodeID_NOI+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_NOI];
    Findices[in.admsNodeID_NOI+inst*(11+0)] = in.li_NOI;
    Qindices[in.admsNodeID_NOI+inst*(11+0)] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_NOI2];
    dqdp[in.admsNodeID_NOI2+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_NOI2];
    Findices[in.admsNodeID_NOI2+inst*(11+0)] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2+inst*(11+0)] = in.li_NOI2;
    dfdp[in.admsNodeID_GP+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_GP];
    dqdp[in.admsNodeID_GP+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_GP];
    Findices[in.admsNodeID_GP+inst*(11+0)] = in.li_GP;
    Qindices[in.admsNodeID_GP+inst*(11+0)] = in.li_GP;
    dfdp[in.admsNodeID_BP+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_BP];
    dqdp[in.admsNodeID_BP+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_BP];
    Findices[in.admsNodeID_BP+inst*(11+0)] = in.li_BP;
    Qindices[in.admsNodeID_BP+inst*(11+0)] = in.li_BP;
    dfdp[in.admsNodeID_BI+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_BI];
    dqdp[in.admsNodeID_BI+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_BI];
    Findices[in.admsNodeID_BI+inst*(11+0)] = in.li_BI;
    Qindices[in.admsNodeID_BI+inst*(11+0)] = in.li_BI;
    dfdp[in.admsNodeID_BS+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_BS];
    dqdp[in.admsNodeID_BS+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_BS];
    Findices[in.admsNodeID_BS+inst*(11+0)] = in.li_BS;
    Qindices[in.admsNodeID_BS+inst*(11+0)] = in.li_BS;
    dfdp[in.admsNodeID_BD+inst*(11+0)] += d_staticContributions_dX[in.admsNodeID_BD];
    dqdp[in.admsNodeID_BD+inst*(11+0)] += d_dynamicContributions_dX[in.admsNodeID_BD];
    Findices[in.admsNodeID_BD+inst*(11+0)] = in.li_BD;
    Qindices[in.admsNodeID_BD+inst*(11+0)] = in.li_BD;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSPSP102VA
} // namespace Device
} // namespace Xyce
