
//-------------------------------------------------------------------------
//   Copyright 2002-2022 National Technology & Engineering Solutions of
//   Sandia, LLC (NTESS).  Under the terms of Contract DE-NA0003525 with
//   NTESS, the U.S. Government retains certain rights in this software.
//
//   This file is part of the Xyce(TM) Parallel Electrical Simulator.
//
//   Xyce(TM) is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Xyce(TM) is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Xyce(TM).
//   If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------


//-------------------------------------------------------------------------
//
// Purpose        :
//
// Special Notes  : Generated from verilog file psp103.va with ADMS
//                  interface for Xyce 7.6.0
//                  DO NOT EDIT THIS FILE DIRECTLY!  It may be overwritten!
//
// Creator        : admsXml-2.3.7
//
// Creation Date  : Tue, 18 Oct 2022 17:52:39
//
//-------------------------------------------------------------------------
// Shut up clang's warnings about extraneous parentheses
#ifdef __clang__
#  pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include <Xyce_config.h>
#include <N_DEV_ADMSPSP103VA.h>


#include <N_DEV_Const.h>
#include <N_DEV_DeviceOptions.h>
#include <N_DEV_DeviceMaster.h>
#include <N_DEV_ExternData.h>
#include <N_DEV_SolverState.h>
#include <N_DEV_Message.h>

#include <N_LAS_Matrix.h>
#include <N_LAS_Vector.h>

  #include <N_ANP_NoiseData.h>

#include <N_UTL_FeatureTest.h>
#include <unordered_map>
using std::unordered_map;

#include <algorithm>

// Xyce_config.h contains a VERSION macro from autoconf, and some
// Verilog-A models like to define a variable of that name.  This can be
// a serious problem, and we don't need the VERSION macro.  Get rid of it.
// This must happen *after* all includes of Xyce headers, each of which
// includes Xyce_config.h!
#ifdef VERSION
#undef VERSION
#endif

namespace Xyce {
namespace Device {
namespace ADMSPSP103VA {


//This is necessary because the IntPair usage can trip undefined references
    const int Instance::admsNodeID_D;
    const int Instance::admsNodeID_G;
    const int Instance::admsNodeID_S;
    const int Instance::admsNodeID_B;
    const int Instance::admsNodeID_NOI;
    const int Instance::admsNodeID_NOI2;
    const int Instance::admsNodeID_GP;
    const int Instance::admsNodeID_SI;
    const int Instance::admsNodeID_DI;
    const int Instance::admsNodeID_BP;
    const int Instance::admsNodeID_BI;
    const int Instance::admsNodeID_BS;
    const int Instance::admsNodeID_BD;
     const int Instance::admsNodeID_GND;
   // Additional IDs for branch equations


void
Traits::loadInstanceParameters(ParametricData<ADMSPSP103VA::Instance> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have an instance parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSINSTTEMP", 0.0, &ADMSPSP103VA::Instance::admsInstTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device instance temperature");
  p.addPar("L", static_cast<double>(1.0e-5), &ADMSPSP103VA::Instance::L)
    .setUnit(U_METER)
    .setDescription("Design length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("W", static_cast<double>(1.0e-5), &ADMSPSP103VA::Instance::W)
    .setUnit(U_METER)
    .setDescription("Design width")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SA", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SA)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SB", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SB)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SD", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SD)
    .setUnit(U_METER)
    .setDescription("Distance between neighbouring fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCA", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCA)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the first distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCB", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCB)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the second distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCC", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SCC)
    .setUnit(U_UNKNOWN)
    .setDescription("Integral of the third distribution function for scattered well dopants")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SC", static_cast<double>(0.0), &ADMSPSP103VA::Instance::SC)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and nearest well edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NF", static_cast<double>(1.0), &ADMSPSP103VA::Instance::NF)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of fingers")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NGCON", static_cast<double>(1.0), &ADMSPSP103VA::Instance::NGCON)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of gate contacts")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XGW", static_cast<double>(1.0e-7), &ADMSPSP103VA::Instance::XGW)
    .setUnit(U_METER)
    .setDescription("Distance from the gate contact to the channel edge")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRS", static_cast<double>(0.0), &ADMSPSP103VA::Instance::NRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares of source diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NRD", static_cast<double>(0.0), &ADMSPSP103VA::Instance::NRD)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of squares of drain diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("JW", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::JW)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of source/drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTO", static_cast<double>(0.0), &ADMSPSP103VA::Instance::DELVTO)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACTUO", static_cast<double>(1.0), &ADMSPSP103VA::Instance::FACTUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-field mobility pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTOEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Instance::DELVTOEDGE)
    .setUnit(U_VOLT)
    .setDescription("Threshold voltage shift parameter of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACTUOEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Instance::FACTUOEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Zero-field mobility pre-factor of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABSOURCE", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::ABSOURCE)
    .setUnit(U_METER2)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSSOURCE", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LSSOURCE)
    .setUnit(U_METER)
    .setDescription("STI-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGSOURCE", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LGSOURCE)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ABDRAIN", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::ABDRAIN)
    .setUnit(U_METER2)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LSDRAIN", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LSDRAIN)
    .setUnit(U_METER)
    .setDescription("STI-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LGDRAIN", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::LGDRAIN)
    .setUnit(U_METER)
    .setDescription("Gate-edge length of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AS", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::AS)
    .setUnit(U_METER2)
    .setDescription("Bottom area of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PS", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::PS)
    .setUnit(U_METER)
    .setDescription("Perimeter of source junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Instance::AD)
    .setUnit(U_METER2)
    .setDescription("Bottom area of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PD", static_cast<double>(1.0e-6), &ADMSPSP103VA::Instance::PD)
    .setUnit(U_METER)
    .setDescription("Perimeter of drain junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MULT", static_cast<double>(1.0), &ADMSPSP103VA::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription("Number of devices in parallel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("M", static_cast<double>(1.0), &ADMSPSP103VA::Instance::MULT)
    .setUnit(U_UNKNOWN)
    .setDescription(" Alias for MULT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&instSens)
#endif // Xyce_ADMS_SENSITIVITIES
;


}

void Traits::loadModelParameters(ParametricData<ADMSPSP103VA::Model> &p)
{
  // Set up each parameter directly, using the up-cased variable name
  // as the tag.

  // This kludge is to force us always to have a model parameter
  // that the device manager can set to the temperature, even if we have
  // no "TEMP".
  p.addPar("XYCEADMSMODTEMP", 0.0, &ADMSPSP103VA::Model::admsModTemp)
    .setExpressionAccess(NO_DOC)
    .setUnit(U_DEGK)
    .setCategory(CAT_TEMP)
    .setDescription("Internal-use parameter for setting device model temperature");
  p.addPar("LEVEL", static_cast<int>(103), &ADMSPSP103VA::Model::LEVEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Model level");
  p.addPar("TYPE", static_cast<int>(1), &ADMSPSP103VA::Model::TYPE)
    .setUnit(U_UNKNOWN)
    .setDescription("Channel type parameter, +1=NMOS -1=PMOS");
  p.addPar("TR", static_cast<double>(21.0), &ADMSPSP103VA::Model::TR)
    .setUnit(U_DEGC)
    .setDescription("nominal (reference) temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWGEO", static_cast<int>(1), &ADMSPSP103VA::Model::SWGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for geometrical model, 0=local, 1=global, 2=binning");
  p.addPar("SWIGATE", static_cast<int>(0), &ADMSPSP103VA::Model::SWIGATE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for gate current, 0=turn off IG");
  p.addPar("SWIMPACT", static_cast<int>(0), &ADMSPSP103VA::Model::SWIMPACT)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for impact ionization current, 0=turn off II");
  p.addPar("SWGIDL", static_cast<int>(0), &ADMSPSP103VA::Model::SWGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for GIDL current, 0=turn off IGIDL");
  p.addPar("SWJUNCAP", static_cast<int>(0), &ADMSPSP103VA::Model::SWJUNCAP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for juncap, 0=turn off juncap");
  p.addPar("SWJUNASYM", static_cast<int>(0), &ADMSPSP103VA::Model::SWJUNASYM)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for asymmetric junctions; 0=symmetric, 1=asymmetric");
  p.addPar("SWNUD", static_cast<int>(0), &ADMSPSP103VA::Model::SWNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for NUD-effect; 0=off, 1=on, 2=on+CV-correction");
  p.addPar("SWEDGE", static_cast<int>(0), &ADMSPSP103VA::Model::SWEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for drain current of edge transistors; 0=off, 1=on");
  p.addPar("SWDELVTAC", static_cast<int>(0), &ADMSPSP103VA::Model::SWDELVTAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for separate capacitance calculation; 0=off, 1=on");
  p.addPar("SWIGN", static_cast<int>(1), &ADMSPSP103VA::Model::SWIGN)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for induced gate noise; 0=off, 1=on");
  p.addPar("QMC", static_cast<double>(1.0), &ADMSPSP103VA::Model::QMC)
    .setUnit(U_UNKNOWN)
    .setDescription("Quantum-mechanical correction factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFB", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFB)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFB", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFB)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOX", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOX)
    .setUnit(U_METER)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSROX", static_cast<double>(3.9), &ADMSPSP103VA::Model::EPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEFF", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NEFF)
    .setUnit(U_METERM3)
    .setDescription("Effective substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACNEFFAC", static_cast<double>(1.0), &ADMSPSP103VA::Model::FACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Pre-factor for effective substrate doping in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Body-factor change due to NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSBNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::VSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Lower Vsb value for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVSBNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::DVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Vsb-range for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::VNSUB)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSLP", static_cast<double>(0.05), &ADMSPSP103VA::Model::NSLP)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::DNSUB)
    .setUnit(U_VOLTM1)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIB)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NP", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::NP)
    .setUnit(U_METERM3)
    .setDescription("Gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CT", static_cast<double>(0.0), &ADMSPSP103VA::Model::CT)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOV", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOXOV)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOVD", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::TOXOVD)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOV", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::NOV)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVD", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::NOVD)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CF", static_cast<double>(0.0), &ADMSPSP103VA::Model::CF)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFD)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFB)
    .setUnit(U_VOLTM1)
    .setDescription("Back bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEB)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCED", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCED)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETN", static_cast<double>(7.0e-2), &ADMSPSP103VA::Model::BETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Channel aspect ratio times zero-field mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBET", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUE", static_cast<double>(0.5), &ADMSPSP103VA::Model::MUE)
    .setUnit(U_MVM1)
    .setDescription("Mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::STMUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::THEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::STTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CS", static_cast<double>(0.0), &ADMSPSP103VA::Model::CS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::STCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Non-universality factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::STXCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FETA", static_cast<double>(1.0), &ADMSPSP103VA::Model::FETA)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RS", static_cast<double>(30.0), &ADMSPSP103VA::Model::RS)
    .setUnit(U_OHM)
    .setDescription("Series resistance at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRS", static_cast<double>(1.0), &ADMSPSP103VA::Model::STRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSB", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSB)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSG)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::THESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::STTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AX", static_cast<double>(3.0), &ADMSPSP103VA::Model::AX)
    .setUnit(U_UNKNOWN)
    .setDescription("Linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP", static_cast<double>(0.01), &ADMSPSP103VA::Model::ALP)
    .setUnit(U_UNKNOWN)
    .setDescription("CLM pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1)
    .setUnit(U_VOLT)
    .setDescription("CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2)
    .setUnit(U_VOLTM1)
    .setDescription("CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VP", static_cast<double>(0.05), &ADMSPSP103VA::Model::VP)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithm dependence factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1", static_cast<double>(1.0), &ADMSPSP103VA::Model::A1)
    .setUnit(U_UNKNOWN)
    .setDescription("Impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2", static_cast<double>(10.0), &ADMSPSP103VA::Model::A2)
    .setUnit(U_VOLT)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STA2", static_cast<double>(0.0), &ADMSPSP103VA::Model::STA2)
    .setUnit(U_VOLT)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3", static_cast<double>(1.0), &ADMSPSP103VA::Model::A3)
    .setUnit(U_UNKNOWN)
    .setDescription("Saturation-voltage dependence of impact-ionization")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4)
    .setUnit(U_VOLTMH)
    .setDescription("Back-bias dependence of impact-ionization")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCO", static_cast<double>(0.0), &ADMSPSP103VA::Model::GCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGINV)
    .setUnit(U_AMP)
    .setDescription("Gate channel current pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOV)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVD)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIG", static_cast<double>(2.0), &ADMSPSP103VA::Model::STIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2", static_cast<double>(0.375), &ADMSPSP103VA::Model::GC2)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3", static_cast<double>(0.063), &ADMSPSP103VA::Model::GC3)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHIB", static_cast<double>(3.1), &ADMSPSP103VA::Model::CHIB)
    .setUnit(U_VOLT)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDL", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDL)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLD", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLD)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDL)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLD)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLD)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("COX", static_cast<double>(1.0e-14), &ADMSPSP103VA::Model::COX)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for intrinsic channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGOV", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::CGOV)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-drain/source overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGOVD", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::CGOVD)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-drain overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGBOV)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-bulk overlap")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFR)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRD)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNT", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNT)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::FNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Excess noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFA", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFA)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFB", static_cast<double>(3.0e07), &ADMSPSP103VA::Model::NFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFC)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EF", static_cast<double>(1.0), &ADMSPSP103VA::Model::EF)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBEDGE", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Flat band voltage of edge transistors at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Offset parameter for PHIB of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NEFFEDGE", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Effective substrate doping of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETNEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::BETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Channel aspect ratio times zero-field mobility of edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("DIBL parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFAEDGE", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFBEDGE", static_cast<double>(3.0e07), &ADMSPSP103VA::Model::NFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EFEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RG)
    .setUnit(U_OHM)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSE", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSE)
    .setUnit(U_OHM)
    .setDescription("External source resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RDE", static_cast<double>(0.0), &ADMSPSP103VA::Model::RDE)
    .setUnit(U_OHM)
    .setDescription("External drain resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBULK", static_cast<double>(0.0), &ADMSPSP103VA::Model::RBULK)
    .setUnit(U_OHM)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RWELL", static_cast<double>(0.0), &ADMSPSP103VA::Model::RWELL)
    .setUnit(U_OHM)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUNS", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNS)
    .setUnit(U_OHM)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUND", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUND)
    .setUnit(U_OHM)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POVFB", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::POVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWVFB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTVFB", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::POSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the width dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWSTVFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTVFB)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length times width dependence of STVFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTOX", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::POTOX)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POEPSROX", static_cast<double>(3.9), &ADMSPSP103VA::Model::POEPSROX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of EPSOX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONEFF", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::PONEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNEFF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNEFF)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NEFF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POFACNEFFAC", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWFACNEFFAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWFACNEFFAC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POGFACNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::POGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWGFACNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWGFACNUD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POVSBNUD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VSBNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PODVSBNUD", static_cast<double>(1.0), &ADMSPSP103VA::Model::PODVSBNUD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DVSBNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POVNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POVNSUB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VNSUB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONSLP", static_cast<double>(0.05), &ADMSPSP103VA::Model::PONSLP)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of NSLP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PODNSUB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODNSUB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of DNSUB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PODPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWDPHIB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDPHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DPHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PODELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWDELVTAC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDELVTAC)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONP", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::PONP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNP)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTOXOV", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::POTOXOV)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOXOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTOXOVD", static_cast<double>(2.0e-09), &ADMSPSP103VA::Model::POTOXOVD)
    .setUnit(U_METER)
    .setDescription("Coefficient for the geometry independent part of TOXOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONOV", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::PONOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNOV)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONOVD", static_cast<double>(5.0e25), &ADMSPSP103VA::Model::PONOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNOVD)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCF", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFD)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWPSCE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWPSCE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of PSCE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCED", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCED)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCED")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POBETN", static_cast<double>(7.0e-2), &ADMSPSP103VA::Model::POBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the geometry independent part of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the width dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWBETN", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWBETN)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length times width dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTBET", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWSTBET", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTBET)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STBET")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POMUE", static_cast<double>(0.5), &ADMSPSP103VA::Model::POMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the geometry independent part of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the length dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the width dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWMUE)
    .setUnit(U_MVM1)
    .setDescription("Coefficient for the length times width dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTMUE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTMUE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STMUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::POTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTTHEMU", static_cast<double>(1.5), &ADMSPSP103VA::Model::POSTTHEMU)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STTHEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTCS", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTCS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STCS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWXCOR)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTXCOR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTXCOR)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STXCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POFETA", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFETA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FETA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PORS", static_cast<double>(30.0), &ADMSPSP103VA::Model::PORS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the geometry independent part of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the length dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the width dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWRS", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWRS)
    .setUnit(U_OHM)
    .setDescription("Coefficient for the length times width dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTRS", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTRS)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STRS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PORSB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PORSB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of RSB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PORSG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PORSG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of RSG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESAT)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTTHESAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWSTTHESAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTTHESAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STTHESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::POTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWTHESATB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESATB)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESATB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::POTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWTHESATG", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWTHESATG)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of THESATG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POAX", static_cast<double>(3.0), &ADMSPSP103VA::Model::POAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWAX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAX)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POALP", static_cast<double>(1.0e-2), &ADMSPSP103VA::Model::POALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWALP", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::POALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWALP1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP1)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::POALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWALP2", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWALP2)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POVP", static_cast<double>(0.05), &ADMSPSP103VA::Model::POVP)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POA1", static_cast<double>(1.0), &ADMSPSP103VA::Model::POA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWA1", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA1)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POA2", static_cast<double>(10.0), &ADMSPSP103VA::Model::POA2)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTA2", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTA2)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of STA2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POA3", static_cast<double>(1.0), &ADMSPSP103VA::Model::POA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWA3", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::POA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the geometry independent part of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWA4", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWA4)
    .setUnit(U_VOLTMH)
    .setDescription("Coefficient for the length times width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POGCO", static_cast<double>(0.0), &ADMSPSP103VA::Model::POGCO)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GCO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWIGINV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGINV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGINV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWIGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGOV)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the geometry independent part of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the width dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWIGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWIGOVD)
    .setUnit(U_AMP)
    .setDescription("Coefficient for the length times width dependence of IGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTIG", static_cast<double>(2.0), &ADMSPSP103VA::Model::POSTIG)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STIG")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POGC2", static_cast<double>(0.375), &ADMSPSP103VA::Model::POGC2)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GC2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POGC3", static_cast<double>(0.063), &ADMSPSP103VA::Model::POGC3)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of GC3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCHIB", static_cast<double>(3.1), &ADMSPSP103VA::Model::POCHIB)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of CHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the geometry independent part of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the width dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWAGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAGIDL)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length times width dependence of AGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the geometry independent part of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the width dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWAGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWAGIDLD)
    .setUnit(U_AMPVM3)
    .setDescription("Coefficient for the length times width dependence of AGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POBGIDL", static_cast<double>(41.0), &ADMSPSP103VA::Model::POBGIDL)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POBGIDLD", static_cast<double>(41.0), &ADMSPSP103VA::Model::POBGIDLD)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTBGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTBGIDL)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STBGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTBGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTBGIDLD)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STBGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCGIDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGIDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCGIDLD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGIDLD)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCOX", static_cast<double>(1.0e-14), &ADMSPSP103VA::Model::POCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCOX", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCOX)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of COX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCGOV", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::POCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCGOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCGOVD", static_cast<double>(1.0e-15), &ADMSPSP103VA::Model::POCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCGOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGOVD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGOV for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCGBOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCGBOV)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CGBOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCFR", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFR)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CFR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the geometry independent part of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the width dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCFRD", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFRD)
    .setUnit(U_FARAD)
    .setDescription("Coefficient for the length times width dependence of CFR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POFNT", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFNT)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::POFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWFNTEXC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWFNTEXC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of FNTEXC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFA", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::PONFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFA", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFA)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFA")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFB", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::PONFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFB", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PONFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFC", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFC)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of NFC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POEF", static_cast<double>(1.0), &ADMSPSP103VA::Model::POEF)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POVFBEDGE", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::POVFBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the geometry independent part of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the width dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWSTVFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTVFBEDGE)
    .setUnit(U_VKM1)
    .setDescription("Coefficient for the length times width dependence of STVFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PODPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PODPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the geometry independent part of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the width dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWDPHIBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWDPHIBEDGE)
    .setUnit(U_VOLT)
    .setDescription("Coefficient for the length times width dependence of DPHIBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONEFFEDGE", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::PONEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the geometry independent part of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the width dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNEFFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNEFFEDGE)
    .setUnit(U_METERM3)
    .setDescription("Coefficient for the length times width dependence of NEFFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCTEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POBETNEDGE", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::POBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the geometry independent part of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the width dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWBETNEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWBETNEDGE)
    .setUnit(U_M2VM1SM1)
    .setDescription("Coefficient for the length times width dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POSTBETEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWSTBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWSTBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of STBETEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWPSCEEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWPSCEEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of PSCEEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCEBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POPSCEDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POPSCEDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of PSCEDEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWCFEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWCFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of CFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFDEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFDEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFDEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POCFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POCFBEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of CFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POFNTEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POFNTEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of FNTEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFAEDGE", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::PONFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFAEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFAEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFAEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFBEDGE", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::PONFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFBEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFBEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence of NFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PONFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PONFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the geometry independent part of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the width dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWNFCEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWNFCEDGE)
    .setUnit(U_VOLTM1)
    .setDescription("Coefficient for the length times width dependence of NFCEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POEFEDGE", static_cast<double>(1.0), &ADMSPSP103VA::Model::POEFEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of EFEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWKVTHOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWKVTHOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence part of KVTHOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("POKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::POKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the geometry independent part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PWKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PWKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the width dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PLWKUOWE", static_cast<double>(0.0), &ADMSPSP103VA::Model::PLWKUOWE)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for the length times width dependence part of KUOWE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMIN", static_cast<double>(0), &ADMSPSP103VA::Model::LMIN)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LMAX", static_cast<double>(1.0), &ADMSPSP103VA::Model::LMAX)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMIN", static_cast<double>(0.0), &ADMSPSP103VA::Model::WMIN)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WMAX", static_cast<double>(1.0), &ADMSPSP103VA::Model::WMAX)
    .setUnit(U_METER)
    .setDescription("Dummy parameter to label binning set")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARO)
    .setUnit(U_METER)
    .setDescription("Geom. independent difference between actual and programmed gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARL", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LVARW", static_cast<double>(0.0), &ADMSPSP103VA::Model::LVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of LVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LAP", static_cast<double>(0.0), &ADMSPSP103VA::Model::LAP)
    .setUnit(U_METER)
    .setDescription("Effective channel length reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARO)
    .setUnit(U_METER)
    .setDescription("Geom. independent difference between actual and programmed field-oxide opening")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARL", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WVARW", static_cast<double>(0.0), &ADMSPSP103VA::Model::WVARW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of WVAR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WOT", static_cast<double>(0.0), &ADMSPSP103VA::Model::WOT)
    .setUnit(U_METER)
    .setDescription("Effective channel width reduction per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLQ", static_cast<double>(0.0), &ADMSPSP103VA::Model::DLQ)
    .setUnit(U_METER)
    .setDescription("Effective channel length reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DWQ", static_cast<double>(0.0), &ADMSPSP103VA::Model::DWQ)
    .setUnit(U_METER)
    .setDescription("Effective channel width reduction for CV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBO", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent flat-band voltage at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::VFBLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of flat-band voltage")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBO", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBO)
    .setUnit(U_VKM1)
    .setDescription("Geometry-independent temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBL)
    .setUnit(U_VKM1)
    .setDescription("Length dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBW)
    .setUnit(U_VKM1)
    .setDescription("Width dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBLW)
    .setUnit(U_VKM1)
    .setDescription("Area dependence of temperature dependence of VFB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXO)
    .setUnit(U_METER)
    .setDescription("Gate oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EPSROXO", static_cast<double>(3.9), &ADMSPSP103VA::Model::EPSROXO)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative permittivity of gate dielectric")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBO", static_cast<double>(3.0e23), &ADMSPSP103VA::Model::NSUBO)
    .setUnit(U_METERM3)
    .setDescription("Geometry independent substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of background doping NSUBO due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WSEG", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WSEG)
    .setUnit(U_METER)
    .setDescription("Char. length of segregation of background doping NSUBO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCK", static_cast<double>(1.0e24), &ADMSPSP103VA::Model::NPCK)
    .setUnit(U_METERM3)
    .setDescription("Pocket doping level")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPCKW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NPCKW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of pocket doping NPCK due to segregation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WSEGP", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WSEGP)
    .setUnit(U_METER)
    .setDescription("Char. length of segregation of pocket doping NPCK")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCK", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LPCK)
    .setUnit(U_METER)
    .setDescription("Char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPCKW", static_cast<double>(0.0), &ADMSPSP103VA::Model::LPCKW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of char. length of lateral doping profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FOL1", static_cast<double>(0.0), &ADMSPSP103VA::Model::FOL1)
    .setUnit(U_UNKNOWN)
    .setDescription("First length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FOL2", static_cast<double>(0.0), &ADMSPSP103VA::Model::FOL2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second length dependence coefficient for short channel body effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACNEFFACO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FACNEFFACO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geom. independent pre-factor for effective substrate doping in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACNEFFACL", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACNEFFACW", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FACNEFFACLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::FACNEFFACLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of FACNEFFAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUDO", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geom. independent body-factor change due to NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUDL", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUDLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::GFACNUDLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GFACNUDLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::GFACNUDLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of GFACNUD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VSBNUDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::VSBNUDO)
    .setUnit(U_VOLT)
    .setDescription("Lower Vsb value for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DVSBNUDO", static_cast<double>(1.0), &ADMSPSP103VA::Model::DVSBNUDO)
    .setUnit(U_VOLT)
    .setDescription("Vsb range for NUD-effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VNSUBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::VNSUBO)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSLPO", static_cast<double>(0.05), &ADMSPSP103VA::Model::NSLPO)
    .setUnit(U_VOLT)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DNSUBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DNSUBO)
    .setUnit(U_VOLTM1)
    .setDescription("Effective doping bias-dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBO)
    .setUnit(U_VOLT)
    .setDescription("Geometry independent offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DPHIBLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of offset of PHIB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTACO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACO)
    .setUnit(U_VOLT)
    .setDescription("Geom. independent offset parameter for PHIB in separate charge calculation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTACL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTACLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DELVTACLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of offset of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTACW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DELVTACLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DELVTACLW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of DELVTAC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPO", static_cast<double>(1.0e26), &ADMSPSP103VA::Model::NPO)
    .setUnit(U_METERM3)
    .setDescription("Geometry-independent gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NPL", static_cast<double>(0.0), &ADMSPSP103VA::Model::NPL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of gate poly-silicon doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-independent interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CTLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of interface states factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOVO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXOVO)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TOXOVDO", static_cast<double>(2.0e-9), &ADMSPSP103VA::Model::TOXOVDO)
    .setUnit(U_METER)
    .setDescription("Overlap oxide thickness for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOV", static_cast<double>(0.0), &ADMSPSP103VA::Model::LOV)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/drain and gate/source overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LOVD", static_cast<double>(0.0), &ADMSPSP103VA::Model::LOVD)
    .setUnit(U_METER)
    .setDescription("Overlap length for gate/drain overlap capacitance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVO", static_cast<double>(5e25), &ADMSPSP103VA::Model::NOVO)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NOVDO", static_cast<double>(5e25), &ADMSPSP103VA::Model::NOVDO)
    .setUnit(U_METERM3)
    .setDescription("Effective doping of overlap region for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of DIBL-parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFLEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::CFLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of CF")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::PSCELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("UO", static_cast<double>(5.0e-2), &ADMSPSP103VA::Model::UO)
    .setUnit(U_M2VM1SM1)
    .setDescription("Zero-field mobility at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET1)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of relative mobility decrease due to first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LP1)
    .setUnit(U_METER)
    .setDescription("Mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::LP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of mobility-related characteristic length of first lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBET2", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBET2)
    .setUnit(U_UNKNOWN)
    .setDescription("Relative mobility decrease due to second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LP2", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LP2)
    .setUnit(U_METER)
    .setDescription("Mobility-related characteristic length of second lateral profile")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW1", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETW1)
    .setUnit(U_UNKNOWN)
    .setDescription("First higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETW2", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second higher-order width scaling coefficient of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WBET", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::WBET)
    .setUnit(U_METER)
    .setDescription("Characteristic width for width scaling of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of BETN")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUEO", static_cast<double>(0.5), &ADMSPSP103VA::Model::MUEO)
    .setUnit(U_MVM1)
    .setDescription("Geometry independent mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MUEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::MUEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of mobility reduction coefficient at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STMUEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STMUEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of MUE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THEMUO", static_cast<double>(1.5), &ADMSPSP103VA::Model::THEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Mobility reduction exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHEMUO", static_cast<double>(1.5), &ADMSPSP103VA::Model::STTHEMUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of THEMU")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent coulomb scattering parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CSLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CSLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STCSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STCSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of CS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORO", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORO)
    .setUnit(U_VOLTM1)
    .setDescription("Geometry independent non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORL", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORW", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XCORLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::XCORLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of non-universality parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STXCORO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STXCORO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of XCOR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FETAO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective field parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW1", static_cast<double>(50.0), &ADMSPSP103VA::Model::RSW1)
    .setUnit(U_OHM)
    .setDescription("Source/drain series resistance for 1 um wide channel at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSW2", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSW2)
    .setUnit(U_UNKNOWN)
    .setDescription("Higher-order width scaling of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STRSO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STRSO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of RS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSGO)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of series resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATO)
    .setUnit(U_VOLTM1)
    .setDescription("Geometry independent velocity saturation parameter at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATL", static_cast<double>(0.05), &ADMSPSP103VA::Model::THESATL)
    .setUnit(U_VOLTM1)
    .setDescription("Length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::THESATLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATW", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of velocity saturation parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STTHESATO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STTHESATLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STTHESATLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of THESAT")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATBO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATBO)
    .setUnit(U_VOLTM1)
    .setDescription("Back-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("THESATGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::THESATGO)
    .setUnit(U_VOLTM1)
    .setDescription("Gate-bias dependence of velocity saturation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXO", static_cast<double>(18.0), &ADMSPSP103VA::Model::AXO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent linear/saturation transition factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AXL", static_cast<double>(0.4), &ADMSPSP103VA::Model::AXL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of AX")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPL", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::ALPL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPLEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::ALPLEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPW", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALPW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1L1)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of CLM enhancement factor above threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1LEXP", static_cast<double>(0.5), &ADMSPSP103VA::Model::ALP1LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1L2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1L2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second_order length dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2L1", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2L1)
    .setUnit(U_VOLTM1)
    .setDescription("Length dependence of CLM enhancement factor below threshold")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2LEXP", static_cast<double>(0.5), &ADMSPSP103VA::Model::ALP2LEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2L2", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2L2)
    .setUnit(U_UNKNOWN)
    .setDescription("Second_order length dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALP2W", static_cast<double>(0.0), &ADMSPSP103VA::Model::ALP2W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of ALP2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VPO", static_cast<double>(0.05), &ADMSPSP103VA::Model::VPO)
    .setUnit(U_VOLT)
    .setDescription("CLM logarithmic dependence parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1O", static_cast<double>(1.0), &ADMSPSP103VA::Model::A1O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent impact-ionization pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A1L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A1W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A1W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A1")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A2O", static_cast<double>(10.0), &ADMSPSP103VA::Model::A2O)
    .setUnit(U_VOLT)
    .setDescription("Impact-ionization exponent at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STA2O", static_cast<double>(0.0), &ADMSPSP103VA::Model::STA2O)
    .setUnit(U_VOLT)
    .setDescription("Temperature dependence of A2")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3O", static_cast<double>(1.0), &ADMSPSP103VA::Model::A3O)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent saturation-voltage dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A3L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A3W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A3W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A3")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4O", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4O)
    .setUnit(U_VOLTMH)
    .setDescription("Geometry independent back-bias dependence of II")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4L", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4L)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("A4W", static_cast<double>(0.0), &ADMSPSP103VA::Model::A4W)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of A4")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GCOO", static_cast<double>(0.0), &ADMSPSP103VA::Model::GCOO)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate tunnelling energy adjustment")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGINVLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGINVLW)
    .setUnit(U_AMP)
    .setDescription("Gate channel current pre-factor for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVW)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IGOVDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::IGOVDW)
    .setUnit(U_AMP)
    .setDescription("Gate overlap current pre-factor for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STIGO", static_cast<double>(2.0), &ADMSPSP103VA::Model::STIGO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of IGINV and IGOV")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC2O", static_cast<double>(0.375), &ADMSPSP103VA::Model::GC2O)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current slope factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("GC3O", static_cast<double>(0.063), &ADMSPSP103VA::Model::GC3O)
    .setUnit(U_UNKNOWN)
    .setDescription("Gate current curvature factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CHIBO", static_cast<double>(3.1), &ADMSPSP103VA::Model::CHIBO)
    .setUnit(U_VOLT)
    .setDescription("Tunnelling barrier height")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLW)
    .setUnit(U_AMPVM3)
    .setDescription("Width dependence of GIDL pre-factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("AGIDLDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::AGIDLDW)
    .setUnit(U_AMPVM3)
    .setDescription("Width dependence of GIDL pre-factor for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLO", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BGIDLDO", static_cast<double>(41.0), &ADMSPSP103VA::Model::BGIDLDO)
    .setUnit(U_VOLT)
    .setDescription("GIDL probability factor at TR for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBGIDLDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBGIDLDO)
    .setUnit(U_VKM1)
    .setDescription("Temperature dependence of BGIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGIDLDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGIDLDO)
    .setUnit(U_UNKNOWN)
    .setDescription("Back-bias dependence of GIDL for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CGBOVL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CGBOVL)
    .setUnit(U_FARAD)
    .setDescription("Oxide capacitance for gate-bulk overlap for 1 um long channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for 1 um wide channel")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFRDW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFRDW)
    .setUnit(U_FARAD)
    .setDescription("Outer fringe capacitance for 1 um wide channel for drain side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEXCL", static_cast<double>(0.0), &ADMSPSP103VA::Model::FNTEXCL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence coefficient of excess noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFALW", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFALW)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFBLW", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::NFBLW)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFCLW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCLW)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EFO", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LINTNOI", static_cast<double>(0.0), &ADMSPSP103VA::Model::LINTNOI)
    .setUnit(U_METER)
    .setDescription("Length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("ALPNOI", static_cast<double>(2.0), &ADMSPSP103VA::Model::ALPNOI)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length offset for flicker noise")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEDGE", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::WEDGE)
    .setUnit(U_METER)
    .setDescription("Electrical width of edge transistor per side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of edge WEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VFBEDGEO", static_cast<double>((-1.0)), &ADMSPSP103VA::Model::VFBEDGEO)
    .setUnit(U_VOLT)
    .setDescription("Geometry-independent flat-band voltage of edge transistors at TR")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBEDGEO", static_cast<double>(5.0e-4), &ADMSPSP103VA::Model::STVFBEDGEO)
    .setUnit(U_VKM1)
    .setDescription("Geometry-independent temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGEL)
    .setUnit(U_VKM1)
    .setDescription("Length dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGEW)
    .setUnit(U_VKM1)
    .setDescription("Width dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STVFBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STVFBEDGELW)
    .setUnit(U_VKM1)
    .setDescription("Area dependence of temperature dependence of VFBEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEO)
    .setUnit(U_VOLT)
    .setDescription("Geometry independent of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEL)
    .setUnit(U_VOLT)
    .setDescription("Length dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGELEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::DPHIBEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGEW)
    .setUnit(U_VOLT)
    .setDescription("Width dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DPHIBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::DPHIBEDGELW)
    .setUnit(U_VOLT)
    .setDescription("Area dependence of edge transistor PHIB offset")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBEDGEO", static_cast<double>(5.0e23), &ADMSPSP103VA::Model::NSUBEDGEO)
    .setUnit(U_METERM3)
    .setDescription("Geometry independent substrate doping of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NSUBEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NSUBEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of edge transistor substrate doping")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry-independent interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CTEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTEDGELEXP", static_cast<double>(1.0), &ADMSPSP103VA::Model::CTEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of interface states factor of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBETEDGE", static_cast<double>(0.0), &ADMSPSP103VA::Model::FBETEDGE)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LPEDGE", static_cast<double>(1.0e-8), &ADMSPSP103VA::Model::LPEDGE)
    .setUnit(U_METER)
    .setDescription("Exponent for length dependence of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("BETEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::BETEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width scaling coefficient of edge transistor mobility")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::STBETEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometry independent temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STBETEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::STBETEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependence of temperature dependence of BETNEDGE")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEEDGELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::PSCEEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of subthreshold slope coefficient for short channel edge transistor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEBEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSCEDEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PSCEDEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of subthreshold slope coefficient for short channel edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFEDGEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFEDGELEXP", static_cast<double>(2.0), &ADMSPSP103VA::Model::CFEDGELEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Exponent for length dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFEDGEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFEDGEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFDEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFDEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Drain voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CFBEDGEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::CFBEDGEO)
    .setUnit(U_VOLTM1)
    .setDescription("Bulk voltage dependence parameter of DIBL-parameter of edge transistors")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FNTEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::FNTEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Thermal noise coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFAEDGELW", static_cast<double>(8.0e22), &ADMSPSP103VA::Model::NFAEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("First coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFBEDGELW", static_cast<double>(3.0e7), &ADMSPSP103VA::Model::NFBEDGELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Second coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("NFCEDGELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::NFCEDGELW)
    .setUnit(U_VOLTM1)
    .setDescription("Third coefficient of flicker noise for 1 um**2 channel area")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("EFEDGEO", static_cast<double>(1.0), &ADMSPSP103VA::Model::EFEDGEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Flicker noise frequency exponent")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical independent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHOWELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHOWELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependent threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEO)
    .setUnit(U_UNKNOWN)
    .setDescription("Geometrical independent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEL", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEL)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWEW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWEW)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUOWELW", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUOWELW)
    .setUnit(U_UNKNOWN)
    .setDescription("Area dependent mobility degradation factor")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RGO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RGO)
    .setUnit(U_OHM)
    .setDescription("Gate resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RINT", static_cast<double>(0.0), &ADMSPSP103VA::Model::RINT)
    .setUnit(U_OHMM2)
    .setDescription("Contact resistance between silicide and ploy")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RVPOLY", static_cast<double>(0.0), &ADMSPSP103VA::Model::RVPOLY)
    .setUnit(U_OHMM2)
    .setDescription("Vertical poly resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHG", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSHG)
    .setUnit(U_OSQM1)
    .setDescription("Gate electrode diffusion sheet resistance")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DLSIL", static_cast<double>(0.0), &ADMSPSP103VA::Model::DLSIL)
    .setUnit(U_METER)
    .setDescription("Silicide extension over the physical gate length")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSH", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSH)
    .setUnit(U_OSQM1)
    .setDescription("Sheet resistance of source diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RSHD", static_cast<double>(0.0), &ADMSPSP103VA::Model::RSHD)
    .setUnit(U_OSQM1)
    .setDescription("Sheet resistance of drain diffusion")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RBULKO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RBULKO)
    .setUnit(U_OHM)
    .setDescription("Bulk resistance between node BP and BI")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RWELLO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RWELLO)
    .setUnit(U_OHM)
    .setDescription("Well resistance between node BI and B")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUNSO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNSO)
    .setUnit(U_OHM)
    .setDescription("Source-side bulk resistance between node BI and BS")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("RJUNDO", static_cast<double>(0.0), &ADMSPSP103VA::Model::RJUNDO)
    .setUnit(U_OHM)
    .setDescription("Drain-side bulk resistance between node BI and BD")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SAREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SAREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from one side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SBREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SBREF)
    .setUnit(U_METER)
    .setDescription("Reference distance between OD-edge and poly from other side")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLOD", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLOD)
    .setUnit(U_METER)
    .setDescription("Width parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KUO)
    .setUnit(U_METER)
    .setDescription("Mobility degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVSAT", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVSAT)
    .setUnit(U_METER)
    .setDescription("Saturation velocity degradation/enhancement coefficient")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::TKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Temperature dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KUO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODKUO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLODKUO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for UO stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("KVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::KVTHO)
    .setUnit(U_VM)
    .setDescription("Threshold shift parameter")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::LKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Length dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::WKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Width dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PKVTHO", static_cast<double>(0.0), &ADMSPSP103VA::Model::PKVTHO)
    .setUnit(U_UNKNOWN)
    .setDescription("Cross-term dependence of KVTHO")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LLODVTH", static_cast<double>(0.0), &ADMSPSP103VA::Model::LLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Length parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WLODVTH", static_cast<double>(0.0), &ADMSPSP103VA::Model::WLODVTH)
    .setUnit(U_UNKNOWN)
    .setDescription("Width parameter for VTH-stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STETAO", static_cast<double>(0.0), &ADMSPSP103VA::Model::STETAO)
    .setUnit(U_METER)
    .setDescription("Eta0 shift factor related to VTHO change")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("LODETAO", static_cast<double>(1.0), &ADMSPSP103VA::Model::LODETAO)
    .setUnit(U_UNKNOWN)
    .setDescription("Eta0 shift modification factor for stress effect")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SCREF", static_cast<double>(1.0e-6), &ADMSPSP103VA::Model::SCREF)
    .setUnit(U_METER)
    .setDescription("Distance between OD-edge and well edge of a reference device")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEB", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEB)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for SCB")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("WEC", static_cast<double>(0.0), &ADMSPSP103VA::Model::WEC)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for SCC")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IMAX", static_cast<double>(1000.0), &ADMSPSP103VA::Model::IMAX)
    .setUnit(U_AMP)
    .setDescription("Maximum current up to which forward current behaves exponentially")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("TRJ", static_cast<double>(21.0), &ADMSPSP103VA::Model::TRJ)
    .setUnit(U_DEGC)
    .setDescription("Reference temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FREV", static_cast<double>(1.0e3), &ADMSPSP103VA::Model::FREV)
    .setUnit(U_UNKNOWN)
    .setDescription("Coefficient for reverse breakdown current limitation")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORBOT", static_cast<double>(1.0e-3), &ADMSPSP103VA::Model::CJORBOT)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORSTI", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORSTI)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORGAT", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORGAT)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRBOT", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRBOT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRSTI", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRSTI)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRGAT", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRGAT)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBOT", static_cast<double>(0.5), &ADMSPSP103VA::Model::PBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTI", static_cast<double>(0.5), &ADMSPSP103VA::Model::PSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGAT", static_cast<double>(0.5), &ADMSPSP103VA::Model::PGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGBOT", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGBOT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGSTI", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGSTI)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGGAT", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGGAT)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRBOT", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::IDSATRBOT)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRSTI", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRSTI)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRGAT", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRGAT)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHBOT", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CSRHBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHSTI", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHGAT", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNSTI", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNSTI)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNGAT", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNGAT)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATBOT", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CTATBOT)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATSTI", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATSTI)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATGAT", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATGAT)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATBOT", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATBOT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATSTI", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATSTI)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATGAT", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATGAT)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTBOT", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::CBBTBOT)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTSTI", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTSTI)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTGAT", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTGAT)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRBOT", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRBOT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRSTI", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRSTI)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRGAT", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRGAT)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTBOT", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTBOT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTSTI", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTSTI)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTGAT", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTGAT)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRBOT", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRSTI", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRGAT", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRBOT", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRBOT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRSTI", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRSTI)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRGAT", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRGAT)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for source-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORBOTD", static_cast<double>(1.0e-3), &ADMSPSP103VA::Model::CJORBOTD)
    .setUnit(U_FARADMM2)
    .setDescription("Zero-bias capacitance per unit-of-area of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORSTID", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORSTID)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CJORGATD", static_cast<double>(1.0e-9), &ADMSPSP103VA::Model::CJORGATD)
    .setUnit(U_FARADMM1)
    .setDescription("Zero-bias capacitance per unit-of-length of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRBOTD", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRSTID", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRSTID)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBIRGATD", static_cast<double>(1.0), &ADMSPSP103VA::Model::VBIRGATD)
    .setUnit(U_VOLT)
    .setDescription("Built-in voltage at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBOTD", static_cast<double>(0.5), &ADMSPSP103VA::Model::PBOTD)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PSTID", static_cast<double>(0.5), &ADMSPSP103VA::Model::PSTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PGATD", static_cast<double>(0.5), &ADMSPSP103VA::Model::PGATD)
    .setUnit(U_UNKNOWN)
    .setDescription("Grading coefficient of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGBOTD", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGBOTD)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGSTID", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGSTID)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PHIGGATD", static_cast<double>(1.16), &ADMSPSP103VA::Model::PHIGGATD)
    .setUnit(U_VOLT)
    .setDescription("Zero-temperature bandgap voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRBOTD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::IDSATRBOTD)
    .setUnit(U_AMPMM2)
    .setDescription("Saturation current density at the reference temperature of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRSTID", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRSTID)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("IDSATRGATD", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::IDSATRGATD)
    .setUnit(U_AMPMM1)
    .setDescription("Saturation current density at the reference temperature of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHBOTD", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CSRHBOTD)
    .setUnit(U_AMPMM3)
    .setDescription("Shockley-Read-Hall prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHSTID", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHSTID)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CSRHGATD", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CSRHGATD)
    .setUnit(U_AMPMM2)
    .setDescription("Shockley-Read-Hall prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNSTID", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNSTID)
    .setUnit(U_METER)
    .setDescription("Junction depth of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("XJUNGATD", static_cast<double>(1.0e-7), &ADMSPSP103VA::Model::XJUNGATD)
    .setUnit(U_METER)
    .setDescription("Junction depth of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATBOTD", static_cast<double>(1.0e2), &ADMSPSP103VA::Model::CTATBOTD)
    .setUnit(U_AMPMM3)
    .setDescription("Trap-assisted tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATSTID", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATSTID)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CTATGATD", static_cast<double>(1.0e-4), &ADMSPSP103VA::Model::CTATGATD)
    .setUnit(U_AMPMM2)
    .setDescription("Trap-assisted tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATBOTD", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATBOTD)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATSTID", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATSTID)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("MEFFTATGATD", static_cast<double>(0.25), &ADMSPSP103VA::Model::MEFFTATGATD)
    .setUnit(U_UNKNOWN)
    .setDescription("Effective mass (in units of m0) for trap-assisted tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTBOTD", static_cast<double>(1.0e-12), &ADMSPSP103VA::Model::CBBTBOTD)
    .setUnit(U_AMPVM3)
    .setDescription("Band-to-band tunneling prefactor of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTSTID", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTSTID)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("CBBTGATD", static_cast<double>(1.0e-18), &ADMSPSP103VA::Model::CBBTGATD)
    .setUnit(U_AMPVM3M)
    .setDescription("Band-to-band tunneling prefactor of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRBOTD", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRBOTD)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRSTID", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRSTID)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FBBTRGATD", static_cast<double>(1.0e9), &ADMSPSP103VA::Model::FBBTRGATD)
    .setUnit(U_VMM1)
    .setDescription("Normalization field at the reference temperature for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTBOTD", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTBOTD)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTSTID", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTSTID)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("STFBBTGATD", static_cast<double>((-1.0e-3)), &ADMSPSP103VA::Model::STFBBTGATD)
    .setUnit(U_DEGKM1)
    .setDescription("Temperature scaling parameter for band-to-band tunneling of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRBOTD", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRSTID", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRSTID)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VBRGATD", static_cast<double>(10.0), &ADMSPSP103VA::Model::VBRGATD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown voltage of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRBOTD", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRBOTD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of bottom component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRSTID", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRSTID)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of STI-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("PBRGATD", static_cast<double>(4.0), &ADMSPSP103VA::Model::PBRGATD)
    .setUnit(U_VOLT)
    .setDescription("Breakdown onset tuning parameter of gate-edge component for drain-bulk junction")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("SWJUNEXP", static_cast<double>(0.0), &ADMSPSP103VA::Model::SWJUNEXP)
    .setUnit(U_UNKNOWN)
    .setDescription("Flag for JUNCAP-express; 0=full model, 1=express model")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJUNREF", static_cast<double>(2.5), &ADMSPSP103VA::Model::VJUNREF)
    .setUnit(U_VOLT)
    .setDescription("Typical maximum source-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FJUNQ", static_cast<double>(0.03), &ADMSPSP103VA::Model::FJUNQ)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which source-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("VJUNREFD", static_cast<double>(2.5), &ADMSPSP103VA::Model::VJUNREFD)
    .setUnit(U_VOLT)
    .setDescription("Typical maximum drain-bulk junction voltage; usually about 2*VSUP")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("FJUNQD", static_cast<double>(0.03), &ADMSPSP103VA::Model::FJUNQD)
    .setUnit(U_UNKNOWN)
    .setDescription("Fraction below which drain-bulk junction capacitance components are considered negligible")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;
  p.addPar("DTA", static_cast<double>(0.0), &ADMSPSP103VA::Model::DTA)
    .setUnit(U_DEGK)
    .setDescription("Temperature offset w.r.t. ambient temperature")
#ifdef Xyce_ADMS_SENSITIVITIES
    .setAnalyticSensitivityAvailable(true)
    .setSensitivityFunctor(&modSens)
#endif // Xyce_ADMS_SENSITIVITIES
;

}

//-----------------------------------------------------------------------------
// Function      : Instance::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::processParams()
{
  // set any non-constant parameter defaults

  // copy any model variables that have associated instance variables, but
  // are only given in the model card:



  // Set any parameters that were not given and whose defaults depend on other
  // parameters:


// Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter L : [ 1.0e-9,  (+inf) [
  if ( (!((L >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter L value " << L << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter W : [ 1.0e-9,  (+inf) [
  if ( (!((W >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter W value " << W << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter SCA : [ 0,  (+inf) [
  if ( (!((SCA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCA value " << SCA << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCB : [ 0,  (+inf) [
  if ( (!((SCB >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCB value " << SCB << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCC : [ 0,  (+inf) [
  if ( (!((SCC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCC value " << SCC << " out of range [ 0,  (+inf) [";
  }

//    Parameter NF : [ 1.0,  (+inf) [
  if ( (!((NF >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NF value " << NF << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NGCON : [ 1.0, 2.0 ]
  if ( (!((NGCON >=1.0 && NGCON <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NGCON value " << NGCON << " out of range [ 1.0, 2.0 ]";
  }

//    Parameter JW : [ 0.0,  (+inf) [
  if ( (!((JW >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter JW value " << JW << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter FACTUO : [ 0,  (+inf) [
  if ( (!((FACTUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACTUO value " << FACTUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter FACTUOEDGE : [ 0,  (+inf) [
  if ( (!((FACTUOEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACTUOEDGE value " << FACTUOEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter ABSOURCE : [ 0.0,  (+inf) [
  if ( (!((ABSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ABSOURCE value " << ABSOURCE << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LSSOURCE : [ 0.0,  (+inf) [
  if ( (!((LSSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LSSOURCE value " << LSSOURCE << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LGSOURCE : [ 0.0,  (+inf) [
  if ( (!((LGSOURCE >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LGSOURCE value " << LGSOURCE << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter ABDRAIN : [ 0.0,  (+inf) [
  if ( (!((ABDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ABDRAIN value " << ABDRAIN << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LSDRAIN : [ 0.0,  (+inf) [
  if ( (!((LSDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LSDRAIN value " << LSDRAIN << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter LGDRAIN : [ 0.0,  (+inf) [
  if ( (!((LGDRAIN >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LGDRAIN value " << LGDRAIN << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter AS : [ 0.0,  (+inf) [
  if ( (!((AS >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AS value " << AS << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter PS : [ 0.0,  (+inf) [
  if ( (!((PS >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PS value " << PS << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter AD : [ 0.0,  (+inf) [
  if ( (!((AD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AD value " << AD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter PD : [ 0.0,  (+inf) [
  if ( (!((PD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PD value " << PD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter MULT : [ 0.0,  (+inf) [
  if ( (!((MULT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MULT value " << MULT << " out of range [ 0.0,  (+inf) [";
  }


  // this seems a little stupid, but verilog models that use $temperature
  // don't also use a defined parameter "Temp", and count on $temperature
  // to be the one the simulator wants:

  updateTemperature(admsInstTemp);

  // and of course, this routine is where we should put the initial_instance
  // stuff
  double I5=0.0;
  double I4=0.0;
  double I3=0.0;
  double I2=0.0;
  double I1=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
  double V2=0.0;
  double V1=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double pmax=0.0;
  double vbigat2r=0.0;
  double vbisti2r=0.0;
  double vbibot2r=0.0;
  double pgat2=0.0;
  double psti2=0.0;
  double pbot2=0.0;
  double vbigat2=0.0;
  double vbisti2=0.0;
  double vbibot2=0.0;
  double vmaxgat=0.0;
  double vmaxsti=0.0;
  double vmaxbot=0.0;
  double alphaje=0.0;
  double zfrac=0.0;
  double tt2=0.0;
  double tt1=0.0;
  double tt0=0.0;
  double I5_cor=0.0;
  double I4_cor=0.0;
  double I3_cor=0.0;
  double I2_cor=0.0;
  double I1_cor=0.0;
  double mcor_rev=0.0;
  double m0_rev=0.0;
  double jww=0.0;
  double jwcorr=0.0;
  double LGD_i=0.0;
  double LSD_i=0.0;
  double ABD_i=0.0;
  double LGS_i=0.0;
  double LSS_i=0.0;
  double ABS_i=0.0;
  double tf_ig=0.0;
  double B_fact=0.0;
  double phix2edge=0.0;
  double tf_betedge=0.0;
  double tf_thesat=0.0;
  double tf_ther=0.0;
  double tf_xcor=0.0;
  double tf_cs=0.0;
  double tf_mue=0.0;
  double tf_bet=0.0;
  double phix2=0.0;
  double dphibq=0.0;
  double qb0=0.0;
  double arg2max=0.0;
  double np=0.0;
  double SP_OV_delta=0.0;
  double SP_OV_eps=0.0;
  double inv_GOV=0.0;
  double CoxovPrime_d=0.0;
  double CoxovPrime=0.0;
  double NEFFAC_i=0.0;
  double tox_sq=0.0;
  double CoxPrime=0.0;
  double EPSOX=0.0;
  double DELVTOEDGE_i=0.0;
  double FACTUOEDGE_i=0.0;
  double DELVTO_i=0.0;
  double FACTUO_i=0.0;
  double VFBEDGE_i=0.0;
  double BGIDLD_i=0.0;
  double BGIDL_i=0.0;
  double A2_i=0.0;
  double THESAT_i=0.0;
  double RS_i=0.0;
  double XCOR_i=0.0;
  double CS_i=0.0;
  double THEMU_i=0.0;
  double MUE_i=0.0;
  double BETN_i=0.0;
  double VFB_i=0.0;
  double temp00=0.0;
  double Kstressvth0=0.0;
  double rhobetaref=0.0;
  double rhobeta=0.0;
  double Kstressu0=0.0;
  double tempw=0.0;
  double templ=0.0;
  double Wx=0.0;
  double Lx=0.0;
  double Invsbref=0.0;
  double Invsaref=0.0;
  double Invsb=0.0;
  double Invsa=0.0;
  double loop=0.0;
  double tmpb=0.0;
  double tmpa=0.0;
  double iiiLWcv=0.0;
  double iLcv=0.0;
  double iiLWcv=0.0;
  double iiWcv=0.0;
  double iiLcv=0.0;
  double iiiLEWEcv=0.0;
  double iLEcv=0.0;
  double iiLEWEcv=0.0;
  double iiWEcv=0.0;
  double iiLEcv=0.0;
  double iiiLEWE=0.0;
  double iiLEWE=0.0;
  double iiWE=0.0;
  double iiLE=0.0;
  double iLEWE=0.0;
  double KUOWE=0.0;
  double KVTHOWE=0.0;
  double GPE_edge=0.0;
  double iWE_edge=0.0;
  double WE_edge=0.0;
  double Lred=0.0;
  double Lnoi=0.0;
  double temp0=0.0;
  double tmpx=0.0;
  double GWE=0.0;
  double GPE=0.0;
  double LP1e=0.0;
  double FBET1e=0.0;
  double NSUB=0.0;
  double BB=0.0;
  double AA=0.0;
  double LPCKe=0.0;
  double NPCKe=0.0;
  double NSUB0e=0.0;
  double RJUND_p=0.0;
  double RJUNS_p=0.0;
  double RBULK_p=0.0;
  double RWELL_p=0.0;
  double RDE_p=0.0;
  double RSE_p=0.0;
  double RG_p=0.0;
  double EFEDGE_p=0.0;
  double NFCEDGE_p=0.0;
  double NFBEDGE_p=0.0;
  double NFAEDGE_p=0.0;
  double FNTEDGE_p=0.0;
  double CFBEDGE_p=0.0;
  double CFDEDGE_p=0.0;
  double CFEDGE_p=0.0;
  double PSCEDEDGE_p=0.0;
  double PSCEBEDGE_p=0.0;
  double PSCEEDGE_p=0.0;
  double STBETEDGE_p=0.0;
  double BETNEDGE_p=0.0;
  double CTEDGE_p=0.0;
  double NEFFEDGE_p=0.0;
  double DPHIBEDGE_p=0.0;
  double STVFBEDGE_p=0.0;
  double VFBEDGE_p=0.0;
  double EF_p=0.0;
  double NFC_p=0.0;
  double NFB_p=0.0;
  double NFA_p=0.0;
  double FNTEXC_p=0.0;
  double FNT_p=0.0;
  double CFRD_p=0.0;
  double CFR_p=0.0;
  double CGBOV_p=0.0;
  double CGOVD_p=0.0;
  double CGOV_p=0.0;
  double COX_p=0.0;
  double CGIDLD_p=0.0;
  double CGIDL_p=0.0;
  double STBGIDLD_p=0.0;
  double STBGIDL_p=0.0;
  double BGIDLD_p=0.0;
  double BGIDL_p=0.0;
  double AGIDLD_p=0.0;
  double AGIDL_p=0.0;
  double CHIB_p=0.0;
  double GC3_p=0.0;
  double GC2_p=0.0;
  double STIG_p=0.0;
  double IGOVD_p=0.0;
  double IGOV_p=0.0;
  double IGINV_p=0.0;
  double GCO_p=0.0;
  double A4_p=0.0;
  double A3_p=0.0;
  double STA2_p=0.0;
  double A2_p=0.0;
  double A1_p=0.0;
  double VP_p=0.0;
  double ALP2_p=0.0;
  double ALP1_p=0.0;
  double ALP_p=0.0;
  double AX_p=0.0;
  double THESATG_p=0.0;
  double THESATB_p=0.0;
  double STTHESAT_p=0.0;
  double THESAT_p=0.0;
  double RSG_p=0.0;
  double RSB_p=0.0;
  double STRS_p=0.0;
  double RS_p=0.0;
  double FETA_p=0.0;
  double STXCOR_p=0.0;
  double XCOR_p=0.0;
  double STCS_p=0.0;
  double CS_p=0.0;
  double STTHEMU_p=0.0;
  double THEMU_p=0.0;
  double STMUE_p=0.0;
  double MUE_p=0.0;
  double STBET_p=0.0;
  double BETN_p=0.0;
  double CFB_p=0.0;
  double CFD_p=0.0;
  double CF_p=0.0;
  double PSCEB_p=0.0;
  double PSCED_p=0.0;
  double PSCE_p=0.0;
  double NOVD_p=0.0;
  double NOV_p=0.0;
  double TOXOVD_p=0.0;
  double TOXOV_p=0.0;
  double CT_p=0.0;
  double NP_p=0.0;
  double DELVTAC_p=0.0;
  double DPHIB_p=0.0;
  double DNSUB_p=0.0;
  double NSLP_p=0.0;
  double VNSUB_p=0.0;
  double DVSBNUD_p=0.0;
  double VSBNUD_p=0.0;
  double GFACNUD_p=0.0;
  double FACNEFFAC_p=0.0;
  double NEFF_p=0.0;
  double EPSROX_p=0.0;
  double TOX_p=0.0;
  double STVFB_p=0.0;
  double VFB_p=0.0;
  double XGWE=0.0;
  double W_f=0.0;
  double L_slif=0.0;
  double L_f=0.0;
  double iWE=0.0;
  double iLE=0.0;
  double Wcv=0.0;
  double Lcv=0.0;
  double WEcv=0.0;
  double LEcv=0.0;
  double delWOD=0.0;
  double delLPS=0.0;
  double iW=0.0;
  double iL=0.0;
  double NGCON_i=0.0;
  double SCC_i=0.0;
  double SCB_i=0.0;
  double SCA_i=0.0;
  double JW_i=0.0;
  double PD_i=0.0;
  double AD_i=0.0;
  double PS_i=0.0;
  double AS_i=0.0;
  double XGW_i=0.0;
  double SC_i=0.0;
  double SD_i=0.0;
  double SB_i=0.0;
  double SA_i=0.0;
  double W_i=0.0;
  double L_i=0.0;
  double invNF=0.0;
  double NF_i=0.0;
//Begin block initial_instance
{
//Block-local variables for block initial_instance
double Invsa=0.0;
double Invsb=0.0;
double Invsaref=0.0;
double Invsbref=0.0;
double Kstressu0=0.0;
double rhobeta=0.0;
double rhobetaref=0.0;
double Kstressvth0=0.0;
//End of Block-local variables
//Block-local variables for block initial_instance
double temp0=0.0;
double temp00=0.0;
double templ=0.0;
double tempw=0.0;
double Lx=0.0;
double Wx=0.0;
double loop=0.0;
double tmpa=0.0;
double tmpb=0.0;
//End of Block-local variables
NF_i = 1.0;
invNF = 1.0;
LE = 0.0;
WE = 0.0;
L_i = L;
W_i = W;
SA_i = SA;
SB_i = SB;
SD_i = SD;
SC_i = SC;
XGW_i = XGW;
ABSOURCE_i = ABSOURCE;
LSSOURCE_i = LSSOURCE;
LGSOURCE_i = LGSOURCE;
ABDRAIN_i = ABDRAIN;
LSDRAIN_i = LSDRAIN;
LGDRAIN_i = LGDRAIN;
AS_i = AS;
PS_i = PS;
AD_i = AD;
PD_i = PD;
JW_i = JW;
if ((((model_.SWGEO_i)==1)||((model_.SWGEO_i)==2)))
{
NF_i = ((NF>1.0)?NF:1.0);
{
double value_floor_0 = floor((NF_i+0.5));
NF_i = floor((NF_i+0.5));
}
invNF = (1.0/NF_i);
}
L_i = ((L_i>1.0e-9)?L_i:1.0e-9);
W_i = (((W_i*invNF)>1.0e-9)?(W_i*invNF):1.0e-9);
SCA_i = ((SCA>0.0)?SCA:0.0);
SCB_i = ((SCB>0.0)?SCB:0.0);
SCC_i = ((SCC>0.0)?SCC:0.0);
NGCON_i = ((NGCON<1.5)?1.0:2.0);
iL = (1.0e-6/L_i);
iW = (1.0e-6/W_i);
delLPS = (((model_.LVARO)*(1.0+((model_.LVARL)*iL)))*(1.0+((model_.LVARW)*iW)));
delWOD = (((model_.WVARO)*(1.0+((model_.WVARL)*iL)))*(1.0+((model_.WVARW)*iW)));
if (((model_.SWGEO_i)==2))
{
delLPS = ((model_.LVARO)*(1.0+((model_.LVARL)*iL)));
delWOD = ((model_.WVARO)*(1.0+((model_.WVARW)*iW)));
}
LE = ((((L_i+delLPS)-(2.0*(model_.LAP)))>1.0e-9)?((L_i+delLPS)-(2.0*(model_.LAP))):1.0e-9);
WE = ((((W_i+delWOD)-(2.0*(model_.WOT)))>1.0e-9)?((W_i+delWOD)-(2.0*(model_.WOT))):1.0e-9);
LEcv = (((((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ))>1.0e-9)?(((L_i+delLPS)-(2.0*(model_.LAP)))+(model_.DLQ)):1.0e-9);
WEcv = (((((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ))>1.0e-9)?(((W_i+delWOD)-(2.0*(model_.WOT)))+(model_.DWQ)):1.0e-9);
Lcv = ((((L_i+delLPS)+(model_.DLQ))>1.0e-9)?((L_i+delLPS)+(model_.DLQ)):1.0e-9);
Wcv = ((((W_i+delWOD)+(model_.DWQ))>1.0e-9)?((W_i+delWOD)+(model_.DWQ)):1.0e-9);
iLE = (1.0e-6/LE);
iWE = (1.0e-6/WE);
L_f = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
L_slif = (((L_f+(model_.DLSIL))>1.0e-9)?(L_f+(model_.DLSIL)):1.0e-9);
W_f = (((W_i+delWOD)>1.0e-9)?(W_i+delWOD):1.0e-9);
XGWE = (((XGW_i-(0.5*delWOD))>1.0e-9)?(XGW_i-(0.5*delWOD)):1.0e-9);
VFB_p = (model_.VFB);
STVFB_p = (model_.STVFB);
TOX_p = (model_.TOX);
EPSROX_p = (model_.EPSROX);
NEFF_p = (model_.NEFF);
FACNEFFAC_p = (model_.FACNEFFAC);
GFACNUD_p = (model_.GFACNUD);
VSBNUD_p = (model_.VSBNUD);
DVSBNUD_p = (model_.DVSBNUD);
VNSUB_p = (model_.VNSUB);
NSLP_p = (model_.NSLP);
DNSUB_p = (model_.DNSUB);
DPHIB_p = (model_.DPHIB);
DELVTAC_p = (model_.DELVTAC);
NP_p = (model_.NP);
CT_p = (model_.CT);
TOXOV_p = (model_.TOXOV);
TOXOVD_p = (model_.TOXOVD);
NOV_p = (model_.NOV);
NOVD_p = (model_.NOVD);
PSCE_p = (model_.PSCE);
PSCED_p = (model_.PSCED);
PSCEB_p = (model_.PSCEB);
CF_p = (model_.CF);
CFD_p = (model_.CFD);
CFB_p = (model_.CFB);
BETN_p = (model_.BETN);
STBET_p = (model_.STBET);
MUE_p = (model_.MUE);
STMUE_p = (model_.STMUE);
THEMU_p = (model_.THEMU);
STTHEMU_p = (model_.STTHEMU);
CS_p = (model_.CS);
STCS_p = (model_.STCS);
XCOR_p = (model_.XCOR);
STXCOR_p = (model_.STXCOR);
FETA_p = (model_.FETA);
RS_p = (model_.RS);
STRS_p = (model_.STRS);
RSB_p = (model_.RSB);
RSG_p = (model_.RSG);
THESAT_p = (model_.THESAT);
STTHESAT_p = (model_.STTHESAT);
THESATB_p = (model_.THESATB);
THESATG_p = (model_.THESATG);
AX_p = (model_.AX);
ALP_p = (model_.ALP);
ALP1_p = (model_.ALP1);
ALP2_p = (model_.ALP2);
VP_p = (model_.VP);
A1_p = (model_.A1);
A2_p = (model_.A2);
STA2_p = (model_.STA2);
A3_p = (model_.A3);
A4_p = (model_.A4);
GCO_p = (model_.GCO);
IGINV_p = (model_.IGINV);
IGOV_p = (model_.IGOV);
IGOVD_p = (model_.IGOVD);
STIG_p = (model_.STIG);
GC2_p = (model_.GC2);
GC3_p = (model_.GC3);
CHIB_p = (model_.CHIB);
AGIDL_p = (model_.AGIDL);
AGIDLD_p = (model_.AGIDLD);
BGIDL_p = (model_.BGIDL);
BGIDLD_p = (model_.BGIDLD);
STBGIDL_p = (model_.STBGIDL);
STBGIDLD_p = (model_.STBGIDLD);
CGIDL_p = (model_.CGIDL);
CGIDLD_p = (model_.CGIDLD);
COX_p = (model_.COX);
CGOV_p = (model_.CGOV);
CGOVD_p = (model_.CGOVD);
CGBOV_p = (model_.CGBOV);
CFR_p = (model_.CFR);
CFRD_p = (model_.CFRD);
FNT_p = (model_.FNT);
FNTEXC_p = (model_.FNTEXC);
NFA_p = (model_.NFA);
NFB_p = (model_.NFB);
NFC_p = (model_.NFC);
EF_p = (model_.EF);
VFBEDGE_p = (model_.VFBEDGE);
STVFBEDGE_p = (model_.STVFBEDGE);
DPHIBEDGE_p = (model_.DPHIBEDGE);
NEFFEDGE_p = (model_.NEFFEDGE);
CTEDGE_p = (model_.CTEDGE);
BETNEDGE_p = (model_.BETNEDGE);
STBETEDGE_p = (model_.STBETEDGE);
PSCEEDGE_p = (model_.PSCEEDGE);
PSCEBEDGE_p = (model_.PSCEBEDGE);
PSCEDEDGE_p = (model_.PSCEDEDGE);
CFEDGE_p = (model_.CFEDGE);
CFDEDGE_p = (model_.CFDEDGE);
CFBEDGE_p = (model_.CFBEDGE);
FNTEDGE_p = (model_.FNTEDGE);
NFAEDGE_p = (model_.NFAEDGE);
NFBEDGE_p = (model_.NFBEDGE);
NFCEDGE_p = (model_.NFCEDGE);
EFEDGE_p = (model_.EFEDGE);
RG_p = (model_.RG);
RSE_p = (model_.RSE);
RDE_p = (model_.RDE);
RWELL_p = (model_.RWELL);
RBULK_p = (model_.RBULK);
RJUNS_p = (model_.RJUNS);
RJUND_p = (model_.RJUND);
if (((model_.SWGEO_i)==1))
{
VFB_p = ((((model_.VFBO)+((model_.VFBL)*iLE))+((model_.VFBW)*iWE))+(((model_.VFBLW)*iLE)*iWE));
STVFB_p = ((((model_.STVFBO)+((model_.STVFBL)*iLE))+((model_.STVFBW)*iWE))+(((model_.STVFBLW)*iLE)*iWE));
TOX_p = (model_.TOXO);
EPSROX_p = (model_.EPSROXO);
{
double value_log_0 = log((1.0+(WE/(model_.WSEG_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEG_i))));
NSUB0e = ((model_.NSUBO_i)*(((1.0+(((model_.NSUBW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.NSUBW)*iWE)*value_log_1)):1.0e-03));
}
{
double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
NPCKe = ((model_.NPCK_i)*(((1.0+(((model_.NPCKW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.NPCKW)*iWE)*value_log_1)):1.0e-03));
}
{
double value_log_0 = log((1.0+(WE/(model_.WSEGP_i))));
double value_log_1 = log((1.0+(WE/(model_.WSEGP_i))));
LPCKe = ((model_.LPCK_i)*(((1.0+(((model_.LPCKW)*iWE)*value_log_0))>1.0e-03)?(1.0+(((model_.LPCKW)*iWE)*value_log_1)):1.0e-03));
}
if ((LE>(2.0*LPCKe)))
{
AA = 7.5e10;
{
double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
double value_sqrt_1 = sqrt(NSUB0e);
BB = (value_sqrt_0-value_sqrt_1);
}
{
double value_sqrt_0 = sqrt(NSUB0e);
double value_exp_1 = exp((BB/AA));
double value_log_2 = log((1.0+(((2.0*LPCKe)/LE)*(value_exp_1-1.0))));
NSUB = (value_sqrt_0+(AA*value_log_2));
}
NSUB = (NSUB*NSUB);
}
else
{
if ((LE>=LPCKe))
{
NSUB = (NSUB0e+((NPCKe*LPCKe)/LE));
}
else
{
NSUB = (NSUB0e+(NPCKe*(2.0-(LE/LPCKe))));
}
}
NEFF_p = (NSUB*((1.0-((model_.FOL1)*iLE))-(((model_.FOL2)*iLE)*iLE)));
FACNEFFAC_p = ((((model_.FACNEFFACO)+((model_.FACNEFFACL)*iLE))+((model_.FACNEFFACW)*iWE))+(((model_.FACNEFFACLW)*iLE)*iWE));
{
double value_pow_0 = pow(iLE,(model_.GFACNUDLEXP));
GFACNUD_p = ((((model_.GFACNUDO)+((model_.GFACNUDL)*value_pow_0))+((model_.GFACNUDW)*iWE))+(((model_.GFACNUDLW)*iLE)*iWE));
}
VSBNUD_p = (model_.VSBNUDO);
DVSBNUD_p = (model_.DVSBNUDO);
VNSUB_p = (model_.VNSUBO);
NSLP_p = (model_.NSLPO);
DNSUB_p = (model_.DNSUBO);
{
double value_pow_0 = pow(iLE,(model_.DPHIBLEXP));
DPHIB_p = ((((model_.DPHIBO)+((model_.DPHIBL)*value_pow_0))+((model_.DPHIBW)*iWE))+(((model_.DPHIBLW)*iLE)*iWE));
}
{
double value_pow_0 = pow(iLE,(model_.DELVTACLEXP));
DELVTAC_p = ((((model_.DELVTACO)+((model_.DELVTACL)*value_pow_0))+((model_.DELVTACW)*iWE))+(((model_.DELVTACLW)*iLE)*iWE));
}
NP_p = ((model_.NPO)*((1.0e-6>(1.0+((model_.NPL)*iLE)))?1.0e-6:(1.0+((model_.NPL)*iLE))));
{
double value_pow_0 = pow(iLE,(model_.CTLEXP));
CT_p = ((((model_.CTO)+((model_.CTL)*value_pow_0))*(1.0+((model_.CTW)*iWE)))*(1.0+(((model_.CTLW)*iLE)*iWE)));
}
TOXOV_p = (model_.TOXOVO);
TOXOVD_p = (model_.TOXOVDO);
NOV_p = (model_.NOVO);
NOVD_p = (model_.NOVDO);
{
double value_pow_0 = pow(iLE,(model_.CFLEXP));
CF_p = (((model_.CFL)*value_pow_0)*(1.0+((model_.CFW)*iWE)));
}
CFD_p = (model_.CFDO);
CFB_p = (model_.CFBO);
{
double value_pow_0 = pow(iLE,(model_.PSCELEXP));
PSCE_p = (((model_.PSCEL)*value_pow_0)*(1.0+((model_.PSCEW)*iWE)));
}
PSCED_p = (model_.PSCEDO);
PSCEB_p = (model_.PSCEBO);
FBET1e = ((model_.FBET1)*(1.0+((model_.FBET1W)*iWE)));
LP1e = ((model_.LP1_i)*(((1.0+((model_.LP1W)*iWE))>1.0e-03)?(1.0+((model_.LP1W)*iWE)):1.0e-03));
{
double value_exp_0 = exp(((-LE)/LP1e));
double value_exp_1 = exp(((-LE)/(model_.LP2_i)));
GPE = ((1.0+(((FBET1e*LP1e)/LE)*(1.0-value_exp_0)))+((((model_.FBET2)*(model_.LP2_i))/LE)*(1.0-value_exp_1)));
}
GPE = ((GPE>1.0e-15)?GPE:1.0e-15);
{
double value_log_0 = log((1.0+(WE/(model_.WBET_i))));
GWE = ((1.0+((model_.BETW1)*iWE))+(((model_.BETW2)*iWE)*value_log_0));
}
BETN_p = ((((model_.UO)*WE)/(GPE*LE))*GWE);
STBET_p = ((((model_.STBETO)+((model_.STBETL)*iLE))+((model_.STBETW)*iWE))+(((model_.STBETLW)*iLE)*iWE));
MUE_p = ((model_.MUEO)*(1.0+((model_.MUEW)*iWE)));
STMUE_p = (model_.STMUEO);
THEMU_p = (model_.THEMUO);
STTHEMU_p = (model_.STTHEMUO);
{
double value_pow_0 = pow(iLE,(model_.CSLEXP));
CS_p = ((((model_.CSO)+((model_.CSL)*value_pow_0))*(1.0+((model_.CSW)*iWE)))*(1.0+(((model_.CSLW)*iLE)*iWE)));
}
STCS_p = (model_.STCSO);
XCOR_p = ((((model_.XCORO)*(1.0+((model_.XCORL)*iLE)))*(1.0+((model_.XCORW)*iWE)))*(1.0+(((model_.XCORLW)*iLE)*iWE)));
STXCOR_p = (model_.STXCORO);
FETA_p = (model_.FETAO);
RS_p = (((model_.RSW1)*iWE)*(1.0+((model_.RSW2)*iWE)));
STRS_p = (model_.STRSO);
RSB_p = (model_.RSBO);
RSG_p = (model_.RSGO);
{
double value_pow_0 = pow(iLE,(model_.THESATLEXP));
THESAT_p = ((((model_.THESATO)+((((model_.THESATL)*GWE)/GPE)*value_pow_0))*(1.0+((model_.THESATW)*iWE)))*(1.0+(((model_.THESATLW)*iLE)*iWE)));
}
STTHESAT_p = ((((model_.STTHESATO)+((model_.STTHESATL)*iLE))+((model_.STTHESATW)*iWE))+(((model_.STTHESATLW)*iLE)*iWE));
THESATB_p = (model_.THESATBO);
THESATG_p = (model_.THESATGO);
AX_p = ((model_.AXO)/(1.0+((model_.AXL_i)*iLE)));
{
double value_pow_0 = pow(iLE,(model_.ALPLEXP));
ALP_p = (((model_.ALPL)*value_pow_0)*(1.0+((model_.ALPW)*iWE)));
}
{
double value_pow_0 = pow(iLE,(model_.ALP1LEXP));
tmpx = value_pow_0;
}
ALP1_p = ((((model_.ALP1L1)*tmpx)*(1.0+((model_.ALP1W)*iWE)))/(1.0+(((model_.ALP1L2_i)*iLE)*tmpx)));
{
double value_pow_0 = pow(iLE,(model_.ALP2LEXP));
tmpx = value_pow_0;
}
ALP2_p = ((((model_.ALP2L1)*tmpx)*(1.0+((model_.ALP2W)*iWE)))/(1.0+(((model_.ALP2L2_i)*iLE)*tmpx)));
VP_p = (model_.VPO);
A1_p = (((model_.A1O)*(1.0+((model_.A1L)*iLE)))*(1.0+((model_.A1W)*iWE)));
A2_p = (model_.A2O);
STA2_p = (model_.STA2O);
A3_p = (((model_.A3O)*(1.0+((model_.A3L)*iLE)))*(1.0+((model_.A3W)*iWE)));
A4_p = (((model_.A4O)*(1.0+((model_.A4L)*iLE)))*(1.0+((model_.A4W)*iWE)));
GCO_p = (model_.GCOO);
IGINV_p = ((model_.IGINVLW)/(iWE*iLE));
IGOV_p = (((model_.IGOVW)*(model_.LOV_i))/(1.0e-6*iWE));
IGOVD_p = (((model_.IGOVDW)*(model_.LOVD_i))/(1.0e-6*iWE));
STIG_p = (model_.STIGO);
GC2_p = (model_.GC2O);
GC3_p = (model_.GC3O);
CHIB_p = (model_.CHIBO);
AGIDL_p = (((model_.AGIDLW)*(model_.LOV_i))/(1.0e-6*iWE));
AGIDLD_p = (((model_.AGIDLDW)*(model_.LOVD_i))/(1.0e-6*iWE));
BGIDL_p = (model_.BGIDLO);
BGIDLD_p = (model_.BGIDLDO);
STBGIDL_p = (model_.STBGIDLO);
STBGIDLD_p = (model_.STBGIDLDO);
CGIDL_p = (model_.CGIDLO);
CGIDLD_p = (model_.CGIDLDO);
COX_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*LEcv)/(model_.TOXO_i));
CGOV_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*(model_.LOV_i))/(model_.TOXOVO_i));
CGOVD_p = ((((8.8541878176E-12*(model_.EPSROXO_i))*WEcv)*(model_.LOVD_i))/(model_.TOXOVDO_i));
CGBOV_p = (((model_.CGBOVL)*Lcv)/1.0e-6);
CFR_p = (((model_.CFRW)*Wcv)/1.0e-6);
CFRD_p = (((model_.CFRDW)*Wcv)/1.0e-6);
temp0 = (1.0-(((2.0*(model_.LINTNOI))*iLE)/1.0e-6));
Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
{
double value_pow_0 = pow(Lnoi,(model_.ALPNOI));
Lred = (1.0/value_pow_0);
}
FNT_p = (model_.FNTO);
FNTEXC_p = (((((model_.FNTEXCL)*BETN_p)*BETN_p)*iWE)*iWE);
NFA_p = (((Lred*iWE)*iLE)*(model_.NFALW));
NFB_p = (((Lred*iWE)*iLE)*(model_.NFBLW));
NFC_p = (((Lred*iWE)*iLE)*(model_.NFCLW));
EF_p = (model_.EFO);
WE_edge = ((2.0*(model_.WEDGE))+((model_.WEDGEW)*WE));
iWE_edge = (1.0e-6/WE_edge);
VFBEDGE_p = (model_.VFBEDGEO);
STVFBEDGE_p = ((((model_.STVFBEDGEO)+((model_.STVFBEDGEL)*iLE))+((model_.STVFBEDGEW)*iWE))+(((model_.STVFBEDGELW)*iLE)*iWE));
{
double value_pow_0 = pow(iLE,(model_.DPHIBEDGELEXP));
DPHIBEDGE_p = ((((model_.DPHIBEDGEO)+((model_.DPHIBEDGEL)*value_pow_0))+((model_.DPHIBEDGEW)*iWE))+(((model_.DPHIBEDGELW)*iLE)*iWE));
}
NEFFEDGE_p = ((((model_.NSUBEDGEO_i)*(1.0+((model_.NSUBEDGEL)*iLE)))*(1.0+((model_.NSUBEDGEW)*iWE)))*(1.0+(((model_.NSUBEDGELW)*iLE)*iWE)));
{
double value_pow_0 = pow(iLE,(model_.CTEDGELEXP));
CTEDGE_p = ((model_.CTEDGEO)+((model_.CTEDGEL)*value_pow_0));
}
{
double value_exp_0 = exp(((-LE)/(model_.LPEDGE_i)));
GPE_edge = (1.0+((((model_.FBETEDGE)*(model_.LPEDGE_i))/LE)*(1.0-value_exp_0)));
}
GPE_edge = ((GPE_edge>1.0e-15)?GPE_edge:1.0e-15);
BETNEDGE_p = ((((model_.UO)*WE_edge)/(GPE_edge*LE))*(1.0+((model_.BETEDGEW)*iWE)));
STBETEDGE_p = ((((model_.STBETEDGEO)+((model_.STBETEDGEL)*iLE))+((model_.STBETEDGEW)*iWE))+(((model_.STBETEDGELW)*iLE)*iWE));
{
double value_pow_0 = pow(iLE,(model_.PSCEEDGELEXP));
PSCEEDGE_p = (((model_.PSCEEDGEL)*value_pow_0)*(1.0+((model_.PSCEEDGEW)*iWE)));
}
PSCEBEDGE_p = (model_.PSCEBEDGEO);
PSCEDEDGE_p = (model_.PSCEDEDGEO);
{
double value_pow_0 = pow(iLE,(model_.CFEDGELEXP));
CFEDGE_p = (((model_.CFEDGEL)*value_pow_0)*(1.0+((model_.CFEDGEW)*iWE)));
}
CFDEDGE_p = (model_.CFDEDGEO);
CFBEDGE_p = (model_.CFBEDGEO);
FNTEDGE_p = (model_.FNTEDGEO);
NFAEDGE_p = ((iWE_edge*iLE)*(model_.NFAEDGELW));
NFBEDGE_p = ((iWE_edge*iLE)*(model_.NFBEDGELW));
NFCEDGE_p = ((iWE_edge*iLE)*(model_.NFCEDGELW));
EFEDGE_p = (model_.EFEDGEO);
}
KVTHOWE = ((((model_.KVTHOWEO)+((model_.KVTHOWEL)*iLE))+((model_.KVTHOWEW)*iWE))+(((model_.KVTHOWELW)*iLE)*iWE));
KUOWE = ((((model_.KUOWEO)+((model_.KUOWEL)*iLE))+((model_.KUOWEW)*iWE))+(((model_.KUOWELW)*iLE)*iWE));
if (((model_.SWGEO_i)==2))
{
iLEWE = (iLE*iWE);
iiLE = (LE/1.0e-6);
iiWE = (WE/1.0e-6);
iiLEWE = (iiLE*iiWE);
iiiLEWE = (iiWE/iiLE);
iiLEcv = (LEcv/1.0e-6);
iiWEcv = (WEcv/1.0e-6);
iiLEWEcv = (iiLEcv*iiWEcv);
iLEcv = (1.0e-6/LEcv);
iiiLEWEcv = (iiWEcv/iiLEcv);
iiLcv = (Lcv/1.0e-6);
iiWcv = (Wcv/1.0e-6);
iiLWcv = (iiLcv*iiWcv);
iLcv = (1.0e-6/Lcv);
iiiLWcv = (iiWcv/iiLcv);
VFB_p = ((((model_.POVFB)+(iLE*(model_.PLVFB)))+(iWE*(model_.PWVFB)))+(iLEWE*(model_.PLWVFB)));
STVFB_p = ((((model_.POSTVFB)+(iLE*(model_.PLSTVFB)))+(iWE*(model_.PWSTVFB)))+(iLEWE*(model_.PLWSTVFB)));
TOX_p = (model_.POTOX);
EPSROX_p = (model_.POEPSROX);
NEFF_p = ((((model_.PONEFF)+(iLE*(model_.PLNEFF)))+(iWE*(model_.PWNEFF)))+(iLEWE*(model_.PLWNEFF)));
FACNEFFAC_p = ((((model_.POFACNEFFAC)+(iLE*(model_.PLFACNEFFAC)))+(iWE*(model_.PWFACNEFFAC)))+(iLEWE*(model_.PLWFACNEFFAC)));
GFACNUD_p = ((((model_.POGFACNUD)+((model_.PLGFACNUD)*iLE))+((model_.PWGFACNUD)*iWE))+(((model_.PLWGFACNUD)*iLE)*iWE));
VSBNUD_p = (model_.POVSBNUD);
DVSBNUD_p = (model_.PODVSBNUD);
VNSUB_p = (model_.POVNSUB);
NSLP_p = (model_.PONSLP);
DNSUB_p = (model_.PODNSUB);
DPHIB_p = ((((model_.PODPHIB)+(iLE*(model_.PLDPHIB)))+(iWE*(model_.PWDPHIB)))+(iLEWE*(model_.PLWDPHIB)));
DELVTAC_p = ((((model_.PODELVTAC)+(iLE*(model_.PLDELVTAC)))+(iWE*(model_.PWDELVTAC)))+(iLEWE*(model_.PLWDELVTAC)));
NP_p = ((((model_.PONP)+(iLE*(model_.PLNP)))+(iWE*(model_.PWNP)))+(iLEWE*(model_.PLWNP)));
CT_p = ((((model_.POCT)+(iLE*(model_.PLCT)))+(iWE*(model_.PWCT)))+(iLEWE*(model_.PLWCT)));
TOXOV_p = (model_.POTOXOV);
TOXOVD_p = (model_.POTOXOVD);
NOV_p = ((((model_.PONOV)+(iLE*(model_.PLNOV)))+(iWE*(model_.PWNOV)))+(iLEWE*(model_.PLWNOV)));
NOVD_p = ((((model_.PONOVD)+(iLE*(model_.PLNOVD)))+(iWE*(model_.PWNOVD)))+(iLEWE*(model_.PLWNOVD)));
CF_p = ((((model_.POCF)+(iLE*(model_.PLCF)))+(iWE*(model_.PWCF)))+(iLEWE*(model_.PLWCF)));
CFD_p = (model_.POCFD);
CFB_p = (model_.POCFB);
PSCE_p = ((((model_.POPSCE)+(iLE*(model_.PLPSCE)))+(iWE*(model_.PWPSCE)))+(iLEWE*(model_.PLWPSCE)));
PSCEB_p = (model_.POPSCEB);
PSCED_p = (model_.POPSCED);
BETN_p = ((iiWE*iLE)*((((model_.POBETN)+(iLE*(model_.PLBETN)))+(iWE*(model_.PWBETN)))+(iLEWE*(model_.PLWBETN))));
STBET_p = ((((model_.POSTBET)+(iLE*(model_.PLSTBET)))+(iWE*(model_.PWSTBET)))+(iLEWE*(model_.PLWSTBET)));
MUE_p = ((((model_.POMUE)+(iLE*(model_.PLMUE)))+(iWE*(model_.PWMUE)))+(iLEWE*(model_.PLWMUE)));
STMUE_p = (model_.POSTMUE);
THEMU_p = (model_.POTHEMU);
STTHEMU_p = (model_.POSTTHEMU);
CS_p = ((((model_.POCS)+(iLE*(model_.PLCS)))+(iWE*(model_.PWCS)))+(iLEWE*(model_.PLWCS)));
STCS_p = (model_.POSTCS);
XCOR_p = ((((model_.POXCOR)+(iLE*(model_.PLXCOR)))+(iWE*(model_.PWXCOR)))+(iLEWE*(model_.PLWXCOR)));
STXCOR_p = (model_.POSTXCOR);
FETA_p = (model_.POFETA);
RS_p = ((((model_.PORS)+(iLE*(model_.PLRS)))+(iWE*(model_.PWRS)))+(iLEWE*(model_.PLWRS)));
STRS_p = (model_.POSTRS);
RSB_p = (model_.PORSB);
RSG_p = (model_.PORSG);
THESAT_p = ((((model_.POTHESAT)+(iLE*(model_.PLTHESAT)))+(iWE*(model_.PWTHESAT)))+(iLEWE*(model_.PLWTHESAT)));
STTHESAT_p = ((((model_.POSTTHESAT)+(iLE*(model_.PLSTTHESAT)))+(iWE*(model_.PWSTTHESAT)))+(iLEWE*(model_.PLWSTTHESAT)));
THESATB_p = ((((model_.POTHESATB)+(iLE*(model_.PLTHESATB)))+(iWE*(model_.PWTHESATB)))+(iLEWE*(model_.PLWTHESATB)));
THESATG_p = ((((model_.POTHESATG)+(iLE*(model_.PLTHESATG)))+(iWE*(model_.PWTHESATG)))+(iLEWE*(model_.PLWTHESATG)));
AX_p = ((((model_.POAX)+(iLE*(model_.PLAX)))+(iWE*(model_.PWAX)))+(iLEWE*(model_.PLWAX)));
ALP_p = ((((model_.POALP)+(iLE*(model_.PLALP)))+(iWE*(model_.PWALP)))+(iLEWE*(model_.PLWALP)));
ALP1_p = ((((model_.POALP1)+(iLE*(model_.PLALP1)))+(iWE*(model_.PWALP1)))+(iLEWE*(model_.PLWALP1)));
ALP2_p = ((((model_.POALP2)+(iLE*(model_.PLALP2)))+(iWE*(model_.PWALP2)))+(iLEWE*(model_.PLWALP2)));
VP_p = (model_.POVP);
A1_p = ((((model_.POA1)+(iLE*(model_.PLA1)))+(iWE*(model_.PWA1)))+(iLEWE*(model_.PLWA1)));
A2_p = (model_.POA2);
STA2_p = (model_.POSTA2);
A3_p = ((((model_.POA3)+(iLE*(model_.PLA3)))+(iWE*(model_.PWA3)))+(iLEWE*(model_.PLWA3)));
A4_p = ((((model_.POA4)+(iLE*(model_.PLA4)))+(iWE*(model_.PWA4)))+(iLEWE*(model_.PLWA4)));
GCO_p = (model_.POGCO);
IGINV_p = ((((model_.POIGINV)+(iiLE*(model_.PLIGINV)))+(iiWE*(model_.PWIGINV)))+(iiLEWE*(model_.PLWIGINV)));
IGOV_p = ((((model_.POIGOV)+(iLE*(model_.PLIGOV)))+(iiWE*(model_.PWIGOV)))+(iiiLEWE*(model_.PLWIGOV)));
IGOVD_p = ((((model_.POIGOVD)+(iLE*(model_.PLIGOVD)))+(iiWE*(model_.PWIGOVD)))+(iiiLEWE*(model_.PLWIGOVD)));
STIG_p = (model_.POSTIG);
GC2_p = (model_.POGC2);
GC3_p = (model_.POGC3);
CHIB_p = (model_.POCHIB);
AGIDL_p = ((((model_.POAGIDL)+(iLE*(model_.PLAGIDL)))+(iiWE*(model_.PWAGIDL)))+(iiiLEWE*(model_.PLWAGIDL)));
AGIDLD_p = ((((model_.POAGIDLD)+(iLE*(model_.PLAGIDLD)))+(iiWE*(model_.PWAGIDLD)))+(iiiLEWE*(model_.PLWAGIDLD)));
BGIDL_p = (model_.POBGIDL);
BGIDLD_p = (model_.POBGIDLD);
STBGIDL_p = (model_.POSTBGIDL);
STBGIDLD_p = (model_.POSTBGIDLD);
CGIDL_p = (model_.POCGIDL);
CGIDLD_p = (model_.POCGIDLD);
COX_p = ((((model_.POCOX)+(iiLEcv*(model_.PLCOX)))+(iiWEcv*(model_.PWCOX)))+(iiLEWEcv*(model_.PLWCOX)));
CGOV_p = ((((model_.POCGOV)+(iLEcv*(model_.PLCGOV)))+(iiWEcv*(model_.PWCGOV)))+(iiiLEWEcv*(model_.PLWCGOV)));
CGOVD_p = ((((model_.POCGOVD)+(iLEcv*(model_.PLCGOVD)))+(iiWEcv*(model_.PWCGOVD)))+(iiiLEWEcv*(model_.PLWCGOVD)));
CGBOV_p = ((((model_.POCGBOV)+(iiLcv*(model_.PLCGBOV)))+(iiWcv*(model_.PWCGBOV)))+(iiLWcv*(model_.PLWCGBOV)));
CFR_p = ((((model_.POCFR)+(iLcv*(model_.PLCFR)))+(iiWcv*(model_.PWCFR)))+(iiiLWcv*(model_.PLWCFR)));
CFRD_p = ((((model_.POCFRD)+(iLcv*(model_.PLCFRD)))+(iiWcv*(model_.PWCFRD)))+(iiiLWcv*(model_.PLWCFRD)));
FNT_p = (model_.POFNT);
FNTEXC_p = ((iLE*iLE)*((((model_.POFNTEXC)+(iLE*(model_.PLFNTEXC)))+(iWE*(model_.PWFNTEXC)))+(iLEWE*(model_.PLWFNTEXC))));
NFA_p = ((((model_.PONFA)+(iLE*(model_.PLNFA)))+(iWE*(model_.PWNFA)))+(iLEWE*(model_.PLWNFA)));
NFB_p = ((((model_.PONFB)+(iLE*(model_.PLNFB)))+(iWE*(model_.PWNFB)))+(iLEWE*(model_.PLWNFB)));
NFC_p = ((((model_.PONFC)+(iLE*(model_.PLNFC)))+(iWE*(model_.PWNFC)))+(iLEWE*(model_.PLWNFC)));
EF_p = (model_.POEF);
VFBEDGE_p = (model_.POVFBEDGE);
STVFBEDGE_p = ((((model_.POSTVFBEDGE)+(iLE*(model_.PLSTVFBEDGE)))+(iWE*(model_.PWSTVFBEDGE)))+(iLEWE*(model_.PLWSTVFBEDGE)));
DPHIBEDGE_p = ((((model_.PODPHIBEDGE)+(iLE*(model_.PLDPHIBEDGE)))+(iWE*(model_.PWDPHIBEDGE)))+(iLEWE*(model_.PLWDPHIBEDGE)));
NEFFEDGE_p = ((((model_.PONEFFEDGE)+(iLE*(model_.PLNEFFEDGE)))+(iWE*(model_.PWNEFFEDGE)))+(iLEWE*(model_.PLWNEFFEDGE)));
CTEDGE_p = ((((model_.POCTEDGE)+(iLE*(model_.PLCTEDGE)))+(iWE*(model_.PWCTEDGE)))+(iLEWE*(model_.PLWCTEDGE)));
BETNEDGE_p = (iLE*((((model_.POBETNEDGE)+(iLE*(model_.PLBETNEDGE)))+(iWE*(model_.PWBETNEDGE)))+(iLEWE*(model_.PLWBETNEDGE))));
STBETEDGE_p = ((((model_.POSTBETEDGE)+(iLE*(model_.PLSTBETEDGE)))+(iWE*(model_.PWSTBETEDGE)))+(iLEWE*(model_.PLWSTBETEDGE)));
PSCEEDGE_p = ((((model_.POPSCEEDGE)+(iLE*(model_.PLPSCEEDGE)))+(iWE*(model_.PWPSCEEDGE)))+(iLEWE*(model_.PLWPSCEEDGE)));
PSCEBEDGE_p = (model_.POPSCEBEDGE);
PSCEDEDGE_p = (model_.POPSCEDEDGE);
CFEDGE_p = ((((model_.POCFEDGE)+(iLE*(model_.PLCFEDGE)))+(iWE*(model_.PWCFEDGE)))+(iLEWE*(model_.PLWCFEDGE)));
CFDEDGE_p = (model_.POCFDEDGE);
CFBEDGE_p = (model_.POCFBEDGE);
FNTEDGE_p = (model_.POFNTEDGE);
NFAEDGE_p = ((((model_.PONFAEDGE)+(iLE*(model_.PLNFAEDGE)))+(iWE*(model_.PWNFAEDGE)))+(iLEWE*(model_.PLWNFAEDGE)));
NFBEDGE_p = ((((model_.PONFBEDGE)+(iLE*(model_.PLNFBEDGE)))+(iWE*(model_.PWNFBEDGE)))+(iLEWE*(model_.PLWNFBEDGE)));
NFCEDGE_p = ((((model_.PONFCEDGE)+(iLE*(model_.PLNFCEDGE)))+(iWE*(model_.PWNFCEDGE)))+(iLEWE*(model_.PLWNFCEDGE)));
EFEDGE_p = (model_.POEFEDGE);
KVTHOWE = ((((model_.POKVTHOWE)+(iLE*(model_.PLKVTHOWE)))+(iWE*(model_.PWKVTHOWE)))+(iLEWE*(model_.PLWKVTHOWE)));
KUOWE = ((((model_.POKUOWE)+(iLE*(model_.PLKUOWE)))+(iWE*(model_.PWKUOWE)))+(iLEWE*(model_.PLWKUOWE)));
}
if ((((model_.SWGEO_i)==1)||((model_.SWGEO_i)==2)))
{
RG_p = (((((model_.RSHG_i)*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+(((model_.RINT_i)+(model_.RVPOLY_i))/(W_f*L_f)))+(NF_i*(model_.RGO)));
if (((model_.SWJUNASYM)==0))
{
(model_.RSHD_i) = (model_.RSH_i);
}
RSE_p = (NRS*(model_.RSH_i));
RDE_p = (NRD*(model_.RSHD_i));
RWELL_p = (NF_i*(model_.RWELLO));
RBULK_p = (NF_i*(model_.RBULKO));
RJUNS_p = (NF_i*(model_.RJUNSO));
RJUND_p = (NF_i*(model_.RJUNDO));
tmpa = 0.0;
tmpb = 0.0;
loop = 0.0;
if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
{
while ((loop<(NF_i-0.5)))
{
tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
loop = (loop+1.0);
}
Invsa = (tmpa*invNF);
Invsb = (tmpb*invNF);
Invsaref = (1.0/((model_.SAREF_i)+(0.5*L_i)));
Invsbref = (1.0/((model_.SBREF_i)+(0.5*L_i)));
Lx = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
Wx = ((((W_i+delWOD)+(model_.WLOD))>1.0e-9)?((W_i+delWOD)+(model_.WLOD)):1.0e-9);
{
double value_pow_0 = pow(Lx,(model_.LLODKUO_i));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODKUO_i));
tempw = (1.0/value_pow_0);
}
Kstressu0 = ((((1.0+((model_.LKUO)*templ))+((model_.WKUO)*tempw))+(((model_.PKUO)*templ)*tempw))*(1.0+((model_.TKUO)*((model_.rTa)-1.0))));
rhobeta = (((model_.KUO)*(Invsa+Invsb))/Kstressu0);
rhobetaref = (((model_.KUO)*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,(model_.LLODVTH_i));
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,(model_.WLODVTH_i));
tempw = (1.0/value_pow_0);
}
Kstressvth0 = (((1.0+((model_.LKVTHO)*templ))+((model_.WKVTHO)*tempw))+(((model_.PKVTHO)*templ)*tempw));
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+((model_.KVSAT_i)*rhobetaref)))/((1.0+rhobetaref)*(1.0+((model_.KVSAT_i)*rhobeta))));
VFB_p = (VFB_p+(((model_.KVTHO)*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
CF_p = (CF_p+(((model_.STETAO)*temp0)/value_pow_0));
}
BETNEDGE_p = ((BETNEDGE_p*(1.0+rhobeta))/(1.0+rhobetaref));
VFBEDGE_p = (VFBEDGE_p+(((model_.KVTHO)*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,(model_.LODETAO_i));
CFEDGE_p = (CFEDGE_p+(((model_.STETAO)*temp0)/value_pow_0));
}
}
if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
{
if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
{
temp0 = (SC_i+W_i);
temp00 = (1.0/(model_.SCREF_i));
SCA_i = (((model_.SCREF_i)*(model_.SCREF_i))/(SC_i*temp0));
{
double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
double value_exp_1 = exp((((-10.0)*temp0)*temp00));
SCB_i = (((((0.1*SC_i)+(0.01*(model_.SCREF_i)))*value_exp_0)-(((0.1*temp0)+(0.01*(model_.SCREF_i)))*value_exp_1))/W_i);
}
{
double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
double value_exp_1 = exp((((-20.0)*temp0)*temp00));
SCC_i = (((((0.05*SC_i)+(0.0025*(model_.SCREF_i)))*value_exp_0)-(((0.05*temp0)+(0.0025*(model_.SCREF_i)))*value_exp_1))/W_i);
}
}
temp0 = ((SCA_i+((model_.WEB_i)*SCB_i))+((model_.WEC_i)*SCC_i));
VFB_p = (VFB_p+(KVTHOWE*temp0));
BETN_p = (BETN_p*(1.0+(KUOWE*temp0)));
VFBEDGE_p = (VFBEDGE_p+(KVTHOWE*temp0));
BETNEDGE_p = (BETNEDGE_p*(1.0+(KUOWE*temp0)));
}
}
VFB_i = VFB_p;
STVFB_i = STVFB_p;
TOX_i = ((TOX_p>1.0e-10)?TOX_p:1.0e-10);
EPSROX_i = ((EPSROX_p>1.0)?EPSROX_p:1.0);
NEFF_i = ((NEFF_p>1.0e20)?((NEFF_p<1.0e26)?NEFF_p:1.0e26):1.0e20);
FACNEFFAC_i = ((FACNEFFAC_p>0.0)?FACNEFFAC_p:0.0);
GFACNUD_i = ((GFACNUD_p>0.01)?GFACNUD_p:0.01);
VSBNUD_i = ((VSBNUD_p>0.0)?VSBNUD_p:0.0);
DVSBNUD_i = ((DVSBNUD_p>0.1)?DVSBNUD_p:0.1);
VNSUB_i = VNSUB_p;
NSLP_i = ((NSLP_p>1.0e-3)?NSLP_p:1.0e-3);
DNSUB_i = ((DNSUB_p>0.0)?((DNSUB_p<1.0)?DNSUB_p:1.0):0.0);
DPHIB_i = DPHIB_p;
DELVTAC_i = DELVTAC_p;
NP_i = ((NP_p>0.0)?NP_p:0.0);
CT_i = ((CT_p>0.0)?CT_p:0.0);
TOXOV_i = ((TOXOV_p>1.0e-10)?TOXOV_p:1.0e-10);
TOXOVD_i = ((TOXOVD_p>1.0e-10)?TOXOVD_p:1.0e-10);
NOV_i = ((NOV_p>1.0e20)?((NOV_p<1.0e27)?NOV_p:1.0e27):1.0e20);
NOVD_i = ((NOVD_p>1.0e20)?((NOVD_p<1.0e27)?NOVD_p:1.0e27):1.0e20);
CF_i = ((CF_p>0.0)?CF_p:0.0);
CFD_i = ((CFD_p>0.0)?CFD_p:0.0);
CFB_i = ((CFB_p>0.0)?((CFB_p<1.0)?CFB_p:1.0):0.0);
PSCE_i = ((PSCE_p>0.0)?PSCE_p:0.0);
PSCEB_i = ((PSCEB_p>0.0)?((PSCEB_p<1.0)?PSCEB_p:1.0):0.0);
PSCED_i = ((PSCED_p>0.0)?PSCED_p:0.0);
BETN_i = ((BETN_p>0.0)?BETN_p:0.0);
STBET_i = STBET_p;
MUE_i = ((MUE_p>0.0)?MUE_p:0.0);
STMUE_i = STMUE_p;
THEMU_i = ((THEMU_p>0.0)?THEMU_p:0.0);
STTHEMU_i = STTHEMU_p;
CS_i = ((CS_p>0.0)?CS_p:0.0);
STCS_i = STCS_p;
XCOR_i = ((XCOR_p>0.0)?XCOR_p:0.0);
STXCOR_i = STXCOR_p;
FETA_i = ((FETA_p>0.0)?FETA_p:0.0);
RS_i = ((RS_p>0.0)?RS_p:0.0);
STRS_i = STRS_p;
RSB_i = ((RSB_p>(-0.5))?((RSB_p<1.0)?RSB_p:1.0):(-0.5));
RSG_i = ((RSG_p>(-0.5))?RSG_p:(-0.5));
THESAT_i = ((THESAT_p>0.0)?THESAT_p:0.0);
STTHESAT_i = STTHESAT_p;
THESATB_i = ((THESATB_p>(-0.5))?((THESATB_p<1.0)?THESATB_p:1.0):(-0.5));
THESATG_i = ((THESATG_p>(-0.5))?THESATG_p:(-0.5));
AX_i = ((AX_p>2.0)?AX_p:2.0);
ALP_i = ((ALP_p>0.0)?ALP_p:0.0);
ALP1_i = ((ALP1_p>0.0)?ALP1_p:0.0);
ALP2_i = ((ALP2_p>0.0)?ALP2_p:0.0);
VP_i = ((VP_p>1.0e-10)?VP_p:1.0e-10);
A1_i = ((A1_p>0.0)?A1_p:0.0);
A2_i = ((A2_p>0.0)?A2_p:0.0);
STA2_i = STA2_p;
A3_i = ((A3_p>0.0)?A3_p:0.0);
A4_i = ((A4_p>0.0)?A4_p:0.0);
GCO_i = ((GCO_p>(-10.0))?((GCO_p<10.0)?GCO_p:10.0):(-10.0));
IGINV_i = ((IGINV_p>0.0)?IGINV_p:0.0);
IGOV_i = ((IGOV_p>0.0)?IGOV_p:0.0);
IGOVD_i = ((IGOVD_p>0.0)?IGOVD_p:0.0);
STIG_i = STIG_p;
GC2_i = ((GC2_p>0.0)?((GC2_p<10.0)?GC2_p:10.0):0.0);
GC3_i = ((GC3_p>(-10.0))?((GC3_p<10.0)?GC3_p:10.0):(-10.0));
CHIB_i = ((CHIB_p>1.0)?CHIB_p:1.0);
AGIDL_i = ((AGIDL_p>0.0)?AGIDL_p:0.0);
AGIDLD_i = ((AGIDLD_p>0.0)?AGIDLD_p:0.0);
BGIDL_i = ((BGIDL_p>0.0)?BGIDL_p:0.0);
BGIDLD_i = ((BGIDLD_p>0.0)?BGIDLD_p:0.0);
STBGIDL_i = STBGIDL_p;
STBGIDLD_i = STBGIDLD_p;
CGIDL_i = CGIDL_p;
CGIDLD_i = CGIDLD_p;
COX_i = ((COX_p>0.0)?COX_p:0.0);
CGOV_i = ((CGOV_p>0.0)?CGOV_p:0.0);
CGOVD_i = ((CGOVD_p>0.0)?CGOVD_p:0.0);
CGBOV_i = ((CGBOV_p>0.0)?CGBOV_p:0.0);
CFR_i = ((CFR_p>0.0)?CFR_p:0.0);
CFRD_i = ((CFRD_p>0.0)?CFRD_p:0.0);
FNT_i = ((FNT_p>0.0)?FNT_p:0.0);
FNTEXC_i = ((FNTEXC_p>0.0)?FNTEXC_p:0.0);
NFA_i = ((NFA_p>0.0)?NFA_p:0.0);
NFB_i = ((NFB_p>0.0)?NFB_p:0.0);
NFC_i = ((NFC_p>0.0)?NFC_p:0.0);
EF_i = ((EF_p>0.0)?EF_p:0.0);
VFBEDGE_i = VFBEDGE_p;
STVFBEDGE_i = STVFBEDGE_p;
DPHIBEDGE_i = DPHIBEDGE_p;
NEFFEDGE_i = ((NEFFEDGE_p>1.0e20)?((NEFFEDGE_p<1.0e26)?NEFFEDGE_p:1.0e26):1.0e20);
CTEDGE_i = ((CTEDGE_p>0.0)?CTEDGE_p:0.0);
BETNEDGE_i = ((BETNEDGE_p>0.0)?BETNEDGE_p:0.0);
STBETEDGE_i = STBETEDGE_p;
PSCEEDGE_i = ((PSCEEDGE_p>0.0)?PSCEEDGE_p:0.0);
PSCEBEDGE_i = ((PSCEBEDGE_p>0.0)?((PSCEBEDGE_p<1.0)?PSCEBEDGE_p:1.0):0.0);
PSCEDEDGE_i = ((PSCEDEDGE_p>0.0)?PSCEDEDGE_p:0.0);
CFEDGE_i = ((CFEDGE_p>0.0)?CFEDGE_p:0.0);
CFDEDGE_i = ((CFDEDGE_p>0.0)?CFDEDGE_p:0.0);
CFBEDGE_i = ((CFBEDGE_p>0.0)?((CFBEDGE_p<1.0)?CFBEDGE_p:1.0):0.0);
FNTEDGE_i = ((FNTEDGE_p>0.0)?FNTEDGE_p:0.0);
NFAEDGE_i = ((NFAEDGE_p>0.0)?NFAEDGE_p:0.0);
NFBEDGE_i = ((NFBEDGE_p>0.0)?NFBEDGE_p:0.0);
NFCEDGE_i = ((NFCEDGE_p>0.0)?NFCEDGE_p:0.0);
EFEDGE_i = ((EFEDGE_p>0.0)?EFEDGE_p:0.0);
RG_i = ((RG_p>0.0)?RG_p:0.0);
RSE_i = ((RSE_p>0.0)?RSE_p:0.0);
RDE_i = ((RDE_p>0.0)?RDE_p:0.0);
RBULK_i = ((RBULK_p>0.0)?RBULK_p:0.0);
RJUNS_i = ((RJUNS_p>0.0)?RJUNS_p:0.0);
RJUND_i = ((RJUND_p>0.0)?RJUND_p:0.0);
RWELL_i = ((RWELL_p>0.0)?RWELL_p:0.0);
MULT_i = (((MULT*NF_i)>0.0)?(MULT*NF_i):0.0);
FACTUO_i = ((FACTUO>0.0)?FACTUO:0.0);
DELVTO_i = DELVTO;
FACTUOEDGE_i = ((FACTUOEDGE>0.0)?FACTUOEDGE:0.0);
DELVTOEDGE_i = DELVTOEDGE;
if (((model_.SWJUNASYM_i)==0))
{
TOXOVD_i = TOXOV_i;
NOVD_i = NOV_i;
AGIDLD_i = AGIDL_i;
BGIDLD_i = BGIDL_i;
STBGIDLD_i = STBGIDL_i;
CGIDLD_i = CGIDL_i;
IGOVD_i = IGOV_i;
CGOVD_i = CGOV_i;
CFRD_i = CFR_i;
}
EPSOX = (8.8541878176E-12*EPSROX_i);
CoxPrime = (EPSOX/TOX_i);
tox_sq = (TOX_i*TOX_i);
Cox_over_q = (CoxPrime/1.6021918E-19);
NEFFAC_i = (FACNEFFAC_i*NEFF_i);
NEFFAC_i = ((NEFFAC_i>1.0e20)?((NEFFAC_i<1.0e26)?NEFFAC_i:1.0e26):1.0e20);
qq = 0.0;
if (((model_.QMC_i)>0.0))
{
{
double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
qq = (((0.4*5.951993)*(model_.QMC_i))*value_pow_0);
}
if (((model_.CHNL_TYPE)==(-1)))
{
qq = ((7.448711/5.951993)*qq);
}
}
E_eff0 = ((1.0e-8*CoxPrime)/(model_.EPSSI));
eta_mu = (0.5*FETA_i);
eta_mu1 = 0.5;
if (((model_.CHNL_TYPE)==(-1)))
{
eta_mu = (3.3333333333333333e-01*FETA_i);
eta_mu1 = 3.3333333333333333e-01;
}
inv_AX = (1.0/AX_i);
inv_VP = (1.0/VP_i);
CoxovPrime = (EPSOX/TOXOV_i);
CoxovPrime_d = (EPSOX/TOXOVD_i);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOV_i)*(model_.EPSSI))*(model_.inv_phita)));
GOV_s = (value_sqrt_0/CoxovPrime);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NOVD_i)*(model_.EPSSI))*(model_.inv_phita)));
GOV_d = (value_sqrt_0/CoxovPrime_d);
}
GOV2_s = (GOV_s*GOV_s);
GOV2_d = (GOV_d*GOV_d);
inv_GOV = (1.0/GOV_s);
SP_OV_eps = ((3.1*GOV_s)+8.5);
SP_OV_eps2_s = (SP_OV_eps*SP_OV_eps);
SP_OV_delta = (0.5*SP_OV_eps);
if ((inv_GOV<0.06))
{
SP_OV_a_s = (64.0*inv_GOV);
}
else
{
if ((inv_GOV<=0.45))
{
SP_OV_a_s = ((22.0*inv_GOV)+3.0);
}
else
{
if ((inv_GOV<=1.6))
{
SP_OV_a_s = (((-7.2)*inv_GOV)+15.5);
}
else
{
SP_OV_a_s = GOV_s;
}
}
}
{
double value_sqrt_0 = sqrt(((SP_OV_delta+(GOV2_s*0.25))+SP_OV_a_s));
SP_OV_delta1_s = ((SP_OV_delta+(GOV2_s*0.5))-(GOV_s*value_sqrt_0));
}
inv_GOV = (1.0/GOV_d);
SP_OV_eps = ((3.1*GOV_d)+8.5);
SP_OV_eps2_d = (SP_OV_eps*SP_OV_eps);
SP_OV_delta = (0.5*SP_OV_eps);
if ((inv_GOV<0.06))
{
SP_OV_a_d = (64.0*inv_GOV);
}
else
{
if ((inv_GOV<=0.45))
{
SP_OV_a_d = ((22.0*inv_GOV)+3.0);
}
else
{
if ((inv_GOV<=1.6))
{
SP_OV_a_d = (((-7.2)*inv_GOV)+15.5);
}
else
{
SP_OV_a_d = GOV_d;
}
}
}
{
double value_sqrt_0 = sqrt(((SP_OV_delta+(GOV2_d*0.25))+SP_OV_a_d));
SP_OV_delta1_d = ((SP_OV_delta+(GOV2_d*0.5))-(GOV_d*value_sqrt_0));
}
phit0 = ((model_.phit)*(1.0+(CT_i*(model_.rTn))));
{
double value_pow_0 = pow((model_.phibFac),(-0.75));
double value_log_1 = log(((NEFF_i*value_pow_0)*4.0e-26));
phib_dc = (((model_.Eg)+DPHIB_i)+((2.0*(model_.phit))*value_log_1));
}
phib_dc = ((phib_dc>5.0E-2)?phib_dc:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFF_i)*(model_.EPSSI))*(model_.inv_phit)));
G_0_dc = (value_sqrt_0/CoxPrime);
}
kp = 0.0;
np = 0.0;
if ((NP_i>0.0))
{
arg2max = (8.0e7/tox_sq);
np = ((NP_i>arg2max)?NP_i:arg2max);
np = ((5.0e24>np)?5.0e24:np);
kp = ((((2.0*CoxPrime)*CoxPrime)*(model_.phit))/((1.6021918E-19*np)*(model_.EPSSI)));
}
qlim2 = ((100.0*(model_.phit))*(model_.phit));
if (((model_.QMC_i)>0.0))
{
{
double value_sqrt_0 = sqrt(((((model_.phit)*G_0_dc)*G_0_dc)*phib_dc));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
dphibq = ((0.75*qq)*value_pow_0);
}
phib_dc = (phib_dc+dphibq);
G_0_dc = (G_0_dc*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
{
double value_sqrt_0 = sqrt(phib_dc);
sqrt_phib_dc = value_sqrt_0;
}
phix_dc = (0.95*phib_dc);
aphi_dc = ((0.0025*phib_dc)*phib_dc);
bphi_dc = aphi_dc;
{
double value_sqrt_0 = sqrt(bphi_dc);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((phix_dc-phix2))*((phix_dc-phix2)))+aphi_dc));
phix1_dc = (0.5*((phix_dc-phix2)-value_sqrt_0));
}
alpha_b = (0.5*(phib_dc+(model_.Eg)));
{
double value_sqrt_0 = sqrt((VSBNUD_i+phib_dc));
us1 = (value_sqrt_0-sqrt_phib_dc);
}
{
double value_sqrt_0 = sqrt(((VSBNUD_i+DVSBNUD_i)+phib_dc));
us21 = ((value_sqrt_0-sqrt_phib_dc)-us1);
}
{
double value_pow_0 = pow((model_.phibFac),(-0.75));
double value_log_1 = log(((NEFFAC_i*value_pow_0)*4.0e-26));
phib_ac = ((((model_.Eg)+DPHIB_i)+DELVTAC_i)+((2.0*(model_.phit))*value_log_1));
}
phib_ac = ((phib_ac>5.0E-2)?phib_ac:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFAC_i)*(model_.EPSSI))*(model_.inv_phit)));
G_0_ac = (value_sqrt_0/CoxPrime);
}
if (((model_.QMC_i)>0.0))
{
{
double value_sqrt_0 = sqrt(((((model_.phit)*G_0_ac)*G_0_ac)*phib_ac));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
dphibq = ((0.75*qq)*value_pow_0);
}
phib_ac = (phib_ac+dphibq);
G_0_ac = (G_0_ac*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
phix_ac = (0.95*phib_ac);
aphi_ac = ((0.0025*phib_ac)*phib_ac);
bphi_ac = aphi_ac;
{
double value_sqrt_0 = sqrt(bphi_ac);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((phix_ac-phix2))*((phix_ac-phix2)))+aphi_ac));
phix1_ac = (0.5*((phix_ac-phix2)-value_sqrt_0));
}
VFB_T = ((VFB_i+(STVFB_i*(model_.delT)))+DELVTO_i);
{
double value_exp_0 = exp((STBET_i*(model_.ln_rTn)));
tf_bet = value_exp_0;
}
BETN_T = (BETN_i*tf_bet);
BET_i = ((FACTUO_i*BETN_T)*CoxPrime);
{
double value_exp_0 = exp((STTHEMU_i*(model_.ln_rTn)));
THEMU_T = (THEMU_i*value_exp_0);
}
{
double value_exp_0 = exp((STMUE_i*(model_.ln_rTn)));
tf_mue = value_exp_0;
}
MUE_T = (MUE_i*tf_mue);
{
double value_exp_0 = exp((STCS_i*(model_.ln_rTn)));
tf_cs = value_exp_0;
}
CS_T = (CS_i*tf_cs);
{
double value_exp_0 = exp((STXCOR_i*(model_.ln_rTn)));
tf_xcor = value_exp_0;
}
XCOR_T = (XCOR_i*tf_xcor);
{
double value_exp_0 = exp((STRS_i*(model_.ln_rTn)));
tf_ther = value_exp_0;
}
RS_T = (RS_i*tf_ther);
THER_i = ((2.0*BET_i)*RS_T);
{
double value_exp_0 = exp((STTHESAT_i*(model_.ln_rTn)));
tf_thesat = value_exp_0;
}
THESAT_T = (THESAT_i*tf_thesat);
{
double value_exp_0 = exp(((-STA2_i)*(model_.ln_rTn)));
A2_T = (A2_i*value_exp_0);
}
nt = (((FNT_i*4.0)*1.3806505E-23)*(model_.TKD));
Sfl_prefac = ((((model_.phit)*(model_.phit))*BET_i)/Cox_over_q);
if ((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0.0)))
{
VFBEDGE_T = ((VFBEDGE_i+(STVFBEDGE_i*(model_.delT)))+DELVTOEDGE_i);
{
double value_exp_0 = exp((STBETEDGE_i*(model_.ln_rTn)));
tf_betedge = value_exp_0;
}
BETNEDGE_T = (BETNEDGE_i*tf_betedge);
BETEDGE_i = ((FACTUOEDGE_i*BETNEDGE_T)*CoxPrime);
phit0edge = ((model_.phit)*(1.0+(CTEDGE_i*(model_.rTn))));
{
double value_pow_0 = pow((model_.phibFac),(-0.75));
double value_log_1 = log(((NEFFEDGE_i*value_pow_0)*4.0e-26));
phibedge = (((model_.Eg)+DPHIBEDGE_i)+((2.0*phit0edge)*value_log_1));
}
phibedge = ((phibedge>5.0E-2)?phibedge:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFEDGE_i)*(model_.EPSSI))*(model_.inv_phit)));
Gfedge = (value_sqrt_0/CoxPrime);
}
Gfedge2 = (Gfedge*Gfedge);
{
double value_log_0 = log(Gfedge2);
lnGfedge2 = value_log_0;
}
phixedge = (0.95*phibedge);
aphiedge = ((0.0025*phibedge)*phibedge);
bphiedge = aphiedge;
{
double value_sqrt_0 = sqrt(bphiedge);
phix2edge = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((phixedge-phix2edge))*((phixedge-phix2edge)))+aphiedge));
phix1edge = (0.5*((phixedge-phix2edge)-value_sqrt_0));
}
Sfl_prefac_edge = ((((model_.phit)*(model_.phit))*BETEDGE_i)/Cox_over_q);
ntedge = (((FNTEDGE_i*4.0)*1.3806505E-23)*(model_.TKD));
}
else
{
VFBEDGE_T = 0.0;
tf_betedge = 1.0;
BETNEDGE_T = 0.0;
BETEDGE_i = 0.0;
phit0edge = (model_.phit);
phibedge = 0.0;
Gfedge = 1.0;
Gfedge2 = 1.0;
lnGfedge2 = 0.0;
phixedge = 0.0;
aphiedge = 0.0;
bphiedge = 0.0;
phix2edge = 0.0;
phix1edge = 0.0;
Sfl_prefac_edge = 0.0;
ntedge = 1.0;
}
inv_CHIB = (1.0/CHIB_i);
{
double value_sqrt_0 = sqrt((((2.0*1.6021918E-19)*9.1093826E-31)*CHIB_i));
B_fact = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
}
BCH = (B_fact*TOX_i);
BOV = (B_fact*TOXOV_i);
BOV_d = (B_fact*TOXOVD_i);
GCQ = 0.0;
if ((GC3_i<0))
{
GCQ = (((-0.495)*GC2_i)/GC3_i);
}
{
double value_pow_0 = pow((model_.rTa),STIG_i);
tf_ig = value_pow_0;
}
IGINV_i = (IGINV_i*tf_ig);
IGOV_i = (IGOV_i*tf_ig);
IGOVD_i = (IGOVD_i*tf_ig);
AGIDLs = ((AGIDL_i*4.0e-18)/(TOXOV_i*TOXOV_i));
AGIDLDs = ((AGIDLD_i*4.0e-18)/(TOXOVD_i*TOXOVD_i));
B_fact = (((1.0+(STBGIDL_i*(model_.delTa)))>0.0)?(1.0+(STBGIDL_i*(model_.delTa))):0.0);
BGIDL_T = (BGIDL_i*B_fact);
BGIDLs = ((BGIDL_T*TOXOV_i)*5.0e8);
B_fact = (((1.0+(STBGIDLD_i*(model_.delTa)))>0.0)?(1.0+(STBGIDLD_i*(model_.delTa))):0.0);
BGIDLD_T = (BGIDLD_i*B_fact);
BGIDLDs = ((BGIDLD_T*TOXOVD_i)*5.0e8);
fac_exc = ((9.1093826E-31*1.0e9)*FNTEXC_i);
if ((RG_i>0.0))
{
ggate = (1.0/RG_i);
}
else
{
ggate = 0.0;
}
if ((RSE_i>0.0))
{
gsource = (1.0/RSE_i);
}
else
{
gsource = 0.0;
}
if ((RDE_i>0.0))
{
gdrain = (1.0/RDE_i);
}
else
{
gdrain = 0.0;
}
if ((RBULK_i>0.0))
{
gbulk = (1.0/RBULK_i);
}
else
{
gbulk = 0.0;
}
if ((RJUNS_i>0.0))
{
gjuns = (1.0/RJUNS_i);
}
else
{
gjuns = 0.0;
}
if ((RJUND_i>0.0))
{
gjund = (1.0/RJUND_i);
}
else
{
gjund = 0.0;
}
if ((RWELL_i>0.0))
{
gwell = (1.0/RWELL_i);
}
else
{
gwell = 0.0;
}
ABS_i = 0.0;
LSS_i = 0.0;
LGS_i = 0.0;
ABD_i = 0.0;
LSD_i = 0.0;
LGD_i = 0.0;
jwcorr = 0.0;
jww = WE;
if (((model_.SWGEO_i)==0))
{
jww = ((JW_i>0.0)?JW_i:0.0);
}
if (((model_.SWJUNCAP_i)==3))
{
jwcorr = 1.0;
}
ABS_i = (ABSOURCE_i*invNF);
LSS_i = (LSSOURCE_i*invNF);
LGS_i = (LGSOURCE_i*invNF);
ABD_i = (ABDRAIN_i*invNF);
LSD_i = (LSDRAIN_i*invNF);
LGD_i = (LGDRAIN_i*invNF);
if ((((model_.SWJUNCAP_i)==2)||((model_.SWJUNCAP_i)==3)))
{
ABS_i = (AS_i*invNF);
LSS_i = ((PS_i*invNF)-(jwcorr*jww));
LGS_i = jww;
ABD_i = (AD_i*invNF);
LSD_i = ((PD_i*invNF)-(jwcorr*jww));
LGD_i = jww;
}
if (((((model_.SWJUNCAP_i)==1)||((model_.SWJUNCAP_i)==2))||((model_.SWJUNCAP_i)==3)))
{
ABSOURCE_i = ((ABS_i>0.0)?ABS_i:0.0);
LSSOURCE_i = ((LSS_i>0.0)?LSS_i:0.0);
LGSOURCE_i = ((LGS_i>0.0)?LGS_i:0.0);
ABDRAIN_i = ((ABD_i>0.0)?ABD_i:0.0);
LSDRAIN_i = ((LSD_i>0.0)?LSD_i:0.0);
LGDRAIN_i = ((LGD_i>0.0)?LGD_i:0.0);
}
else
{
ABSOURCE_i = 0.0;
LSSOURCE_i = 0.0;
LGSOURCE_i = 0.0;
ABDRAIN_i = 0.0;
LSDRAIN_i = 0.0;
LGDRAIN_i = 0.0;
}
vbimin_s = 0.0;
vbimin_d = 0.0;
vfmin_s = 0.0;
vfmin_d = 0.0;
vch_s = 0.0;
vch_d = 0.0;
vbbtlim_s = 0.0;
vbbtlim_d = 0.0;
VMAX_s = 0.0;
VMAX_d = 0.0;
exp_VMAX_over_phitd_s = 0.0;
exp_VMAX_over_phitd_d = 0.0;
ISATFOR1_s = 0.0;
ISATFOR1_d = 0.0;
MFOR1_s = 1.0;
MFOR1_d = 1.0;
ISATFOR2_s = 0.0;
ISATFOR2_d = 0.0;
MFOR2_s = 1.0;
MFOR2_d = 1.0;
ISATREV_s = 0.0;
ISATREV_d = 0.0;
MREV_s = 1.0;
MREV_d = 1.0;
m0flag_s = 0.0;
m0flag_d = 0.0;
xhighf1_s = 0.0;
xhighf1_d = 0.0;
expxhf1_s = 0.0;
expxhf1_d = 0.0;
xhighf2_s = 0.0;
xhighf2_d = 0.0;
expxhf2_s = 0.0;
expxhf2_d = 0.0;
xhighr_s = 0.0;
xhighr_d = 0.0;
expxhr_s = 0.0;
expxhr_d = 0.0;
zflagbot_s = 1.0;
zflagbot_d = 1.0;
zflagsti_s = 1.0;
zflagsti_d = 1.0;
zflaggat_s = 1.0;
zflaggat_d = 1.0;
m0_rev = 0.0;
mcor_rev = 0.0;
I1_cor = 0.0;
I2_cor = 0.0;
I3_cor = 0.0;
I4_cor = 0.0;
I5_cor = 0.0;
tt0 = 0.0;
tt1 = 0.0;
tt2 = 0.0;
zfrac = 0.0;
alphaje = 0.0;
if (((model_.SWJUNCAP_i)>0))
{
if ((((model_.idsatbot)*ABSOURCE_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot)*ABSOURCE_i))+1.0));
vmaxbot = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxbot = 1.0e8;
}
if ((((model_.idsatsti)*LSSOURCE_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti)*LSSOURCE_i))+1.0));
vmaxsti = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxsti = 1.0e8;
}
if ((((model_.idsatgat)*LGSOURCE_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat)*LGSOURCE_i))+1.0));
vmaxgat = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxgat = 1.0e8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
VMAX_s = value_min_1;
}
if ((fabs((VMAX_s*(model_.phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((VMAX_s*(model_.phitdinv)));
exp_VMAX_over_phitd_s = value_exp_0;
}
}
else
{
if (((VMAX_s*(model_.phitdinv))<0.0))
{
exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_s*(model_.phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_s*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
vbibot2 = (model_.vbibot);
vbisti2 = (model_.vbisti);
vbigat2 = (model_.vbigat);
pbot2 = (model_.PBOT_i);
psti2 = (model_.PSTI_i);
pgat2 = (model_.PGAT_i);
vbibot2r = (model_.VBIRBOT_i);
vbisti2r = (model_.VBIRSTI_i);
vbigat2r = (model_.VBIRGAT_i);
if ((ABSOURCE_i==0.0))
{
vbibot2 = ((model_.vbisti)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PSTI_i),(model_.PGAT_i));
pbot2 = (0.9*value_min_0);
}
vbibot2r = ((model_.VBIRSTI_i)+(model_.VBIRGAT_i));
}
if ((LSSOURCE_i==0.0))
{
vbisti2 = ((model_.vbibot)+(model_.vbigat));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PGAT_i));
psti2 = (0.9*value_min_0);
}
vbisti2r = ((model_.VBIRBOT_i)+(model_.VBIRGAT_i));
}
if ((LGSOURCE_i==0.0))
{
vbigat2 = ((model_.vbibot)+(model_.vbisti));
{
double value_min_0 = std::min((model_.PBOT_i),(model_.PSTI_i));
pgat2 = (0.9*value_min_0);
}
vbigat2r = ((model_.VBIRBOT_i)+(model_.VBIRSTI_i));
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
vbimin_s = value_min_1;
}
vch_s = (vbimin_s*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
pmax = value_max_1;
}
{
double value_pow_0 = pow(2.0,((-1.0)/pmax));
vfmin_s = (vbimin_s*(1.0-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
vbbtlim_s = (value_min_1-5.0e-2);
}
if ((((model_.idsatbot_d)*ABDRAIN_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatbot_d)*ABDRAIN_i))+1.0));
vmaxbot = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxbot = 1.0e8;
}
if ((((model_.idsatsti_d)*LSDRAIN_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatsti_d)*LSDRAIN_i))+1.0));
vmaxsti = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxsti = 1.0e8;
}
if ((((model_.idsatgat_d)*LGDRAIN_i)>0.0))
{
{
double value_log_0 = log((((model_.IMAX_i)/((model_.idsatgat_d)*LGDRAIN_i))+1.0));
vmaxgat = ((model_.phitd)*value_log_0);
}
}
else
{
vmaxgat = 1.0e8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
VMAX_d = value_min_1;
}
if ((fabs((VMAX_d*(model_.phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((VMAX_d*(model_.phitdinv)));
exp_VMAX_over_phitd_d = value_exp_0;
}
}
else
{
if (((VMAX_d*(model_.phitdinv))<0.0))
{
exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(VMAX_d*(model_.phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*(1.0+(((VMAX_d*(model_.phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
vbibot2 = (model_.vbibot_d);
vbisti2 = (model_.vbisti_d);
vbigat2 = (model_.vbigat_d);
pbot2 = (model_.PBOTD_i);
psti2 = (model_.PSTID_i);
pgat2 = (model_.PGATD_i);
vbibot2r = (model_.VBIRBOTD_i);
vbisti2r = (model_.VBIRSTID_i);
vbigat2r = (model_.VBIRGATD_i);
if ((ABDRAIN_i==0.0))
{
vbibot2 = ((model_.vbisti_d)+(model_.vbigat_d));
{
double value_min_0 = std::min((model_.PSTID_i),(model_.PGATD_i));
pbot2 = (0.9*value_min_0);
}
vbibot2r = ((model_.VBIRSTID_i)+(model_.VBIRGATD_i));
}
if ((LSDRAIN_i==0.0))
{
vbisti2 = ((model_.vbibot_d)+(model_.vbigat_d));
{
double value_min_0 = std::min((model_.PBOTD_i),(model_.PGATD_i));
psti2 = (0.9*value_min_0);
}
vbisti2r = ((model_.VBIRBOTD_i)+(model_.VBIRGATD_i));
}
if ((LGDRAIN_i==0.0))
{
vbigat2 = ((model_.vbibot_d)+(model_.vbisti_d));
{
double value_min_0 = std::min((model_.PBOTD_i),(model_.PSTID_i));
pgat2 = (0.9*value_min_0);
}
vbigat2r = ((model_.VBIRBOTD_i)+(model_.VBIRSTID_i));
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
vbimin_d = value_min_1;
}
vch_d = (vbimin_d*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
pmax = value_max_1;
}
{
double value_pow_0 = pow(2.0,((-1.0)/pmax));
vfmin_d = (vbimin_d*(1.0-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
vbbtlim_d = (value_min_1-5.0e-2);
}
if (((model_.SWJUNEXP_i)==1))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double terfc=0.0;
double erfcpos=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double h2=0.0;
double h2d=0.0;
double h3=0.0;
double h4=0.0;
double h5=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double idmult=0.0;
double vj=0.0;
double z=0.0;
double zinv=0.0;
double two_psistar=0.0;
double vjlim=0.0;
double vjsrh=0.0;
double vbbt=0.0;
double vav=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double id=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double vbi_minus_vjsrh=0.0;
double wsrhstep=0.0;
double dwsrh=0.0;
double wsrh=0.0;
double wdep=0.0;
double asrh=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double btat=0.0;
double twoatatoverthreebtat=0.0;
double umaxbeforelimiting=0.0;
double umax=0.0;
double sqrtumax=0.0;
double umaxpoweronepointfive=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double wtat=0.0;
double ktat=0.0;
double ltat=0.0;
double mtat=0.0;
double xerfc=0.0;
double erfctimesexpmtat=0.0;
double gammamax=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double Fmaxr=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ijunbot=0.0;
double ijunsti=0.0;
double ijungat=0.0;
double qjunbot=0.0;
double qjunsti=0.0;
double qjungat=0.0;
//End of Block-local variables
ysq = 0.0;
terfc = 0.0;
erfcpos = 0.0;
h1 = 0.0;
h2 = 0.0;
h2d = 0.0;
h3 = 0.0;
h4 = 0.0;
h5 = 0.0;
idmult = 0.0;
vj = 0.0;
z = 0.0;
zinv = 0.0;
two_psistar = 0.0;
vjlim = 0.0;
vjsrh = 0.0;
vbbt = 0.0;
vav = 0.0;
tmp = 0.0;
id = 0.0;
isrh = 0.0;
vbi_minus_vjsrh = 0.0;
wsrhstep = 0.0;
dwsrh = 0.0;
wsrh = 0.0;
wdep = 0.0;
asrh = 0.0;
itat = 0.0;
btat = 0.0;
twoatatoverthreebtat = 0.0;
umaxbeforelimiting = 0.0;
umax = 0.0;
sqrtumax = 0.0;
umaxpoweronepointfive = 0.0;
wgamma = 0.0;
wtat = 0.0;
ktat = 0.0;
ltat = 0.0;
mtat = 0.0;
xerfc = 0.0;
erfctimesexpmtat = 0.0;
gammamax = 0.0;
ibbt = 0.0;
Fmaxr = 0.0;
fbreakdown = 0.0;
qjunbot = 0.0;
qjunsti = 0.0;
qjungat = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
V1 = ((-FRACNA)*(model_.VJUNREF_i));
V2 = ((-FRACNB)*(model_.VJUNREF_i));
V3 = ((-FRACI)*(model_.VJUNREF_i));
V4 = 0.1;
V5 = 0.2;
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V1+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V1*vfmin_s)/(h3+h5)));
if ((V1<VMAX_s))
{
if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V1-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V1>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-vbbtlim_s)*(V1-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V1+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V1-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V1-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V1-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I1 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V2+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V2*vfmin_s)/(h3+h5)));
if ((V2<VMAX_s))
{
if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V2-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V2>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-vbbtlim_s)*(V2-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V2+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V2-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V2-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V2-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I2 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V3+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V3*vfmin_s)/(h3+h5)));
if ((V3<VMAX_s))
{
if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V3-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V3>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-vbbtlim_s)*(V3-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V3+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V3-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V3-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V3-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I3 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V4+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V4*vfmin_s)/(h3+h5)));
if ((V4<VMAX_s))
{
if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V4-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V4>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-vbbtlim_s)*(V4-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V4+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V4-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V4-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V4-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I4 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);
h2d = (V5+(vch_s*h2));
h3 = (vfmin_s+h2d);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V5*vfmin_s)/(h3+h5)));
if ((V5<VMAX_s))
{
if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V5-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V5>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-vbbtlim_s)*(V5-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V5+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(V5-vj)));
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot)*tmp);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(V5-vj)));
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti)*tmp);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTI_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(V5-vj)));
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat)*tmp);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGAT_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I5 = (((ABSOURCE_i*ijunbot)+(LSSOURCE_i*ijunsti))+(LGSOURCE_i*ijungat));
ISATFOR1_s = (((ABSOURCE_i*(model_.idsatbot))+(LSSOURCE_i*(model_.idsatsti)))+(LGSOURCE_i*(model_.idsatgat)));
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_s));
I4_cor = (I4-(ISATFOR1_s*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_s));
I5_cor = (I5-(ISATFOR1_s*(value_exp_0-1.0)));
}
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
if (((I4>0.0)&&(I5>0.0)))
{
if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
{
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
MFOR2_s = (((model_.phitd)*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_s));
ISATFOR2_s = (I4_cor/(value_exp_0-1.0));
}
}
}
{
double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_s));
I1_cor = ((I1-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_s));
I2_cor = ((I2-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_s));
double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_s));
I3_cor = ((I3-(ISATFOR1_s*(value_exp_0-1.0)))-(ISATFOR2_s*(value_exp_1-1.0)));
}
if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
{
if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
{
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
}
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
tt1 = (((model_.phitd)*(alphaje-1.0))*(value_pow_0-1.0));
}
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
mcor_rev = (tt1/tt2);
MREV_s = (m0_rev+mcor_rev);
if ((fabs(((V3*(model_.phitdinv))*MREV_s))<1.0e-6))
{
m0flag_s = 1.0;
ISATREV_s = (I3_cor*((1.0/V3)+((0.5*(model_.phitdinv))*MREV_s)));
MREV_s = (((((-0.5)*I3_cor)*MREV_s)*(model_.phitdinv))/V3);
}
else
{
m0flag_s = 0.0;
{
double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_s));
ISATREV_s = ((-I3_cor)/(value_exp_0-1.0));
}
}
}
}
}
zfrac = ((model_.FJUNQ_i)*(((ABSOURCE_i*(model_.cjobot))+(LSSOURCE_i*(model_.cjosti)))+(LGSOURCE_i*(model_.cjogat))));
if (((ABSOURCE_i*(model_.cjobot))<=zfrac))
{
zflagbot_s = 0.0;
}
if (((LSSOURCE_i*(model_.cjosti))<=zfrac))
{
zflagsti_s = 0.0;
}
if (((LGSOURCE_i*(model_.cjogat))<=zfrac))
{
zflaggat_s = 0.0;
}
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_s+1.0e-21)));
xhighf1_s = value_log_0;
}
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_s+1.0e-21)));
xhighf2_s = value_log_0;
}
{
double value_fabs_0 = fabs(ISATREV_s);
double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1.0e-21)));
xhighr_s = value_log_1;
}
}
{
double value_min_0 = std::min(xhighf1_s,static_cast<double>(2.3025850929940458e+02));
xhighf1_s = value_min_0;
}
{
double value_exp_0 = exp(xhighf1_s);
expxhf1_s = value_exp_0;
}
{
double value_min_0 = std::min(xhighf2_s,static_cast<double>(2.3025850929940458e+02));
xhighf2_s = value_min_0;
}
{
double value_exp_0 = exp(xhighf2_s);
expxhf2_s = value_exp_0;
}
{
double value_min_0 = std::min(xhighr_s,static_cast<double>(2.3025850929940458e+02));
xhighr_s = value_min_0;
}
{
double value_exp_0 = exp(xhighr_s);
expxhr_s = value_exp_0;
}
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
V1 = ((-FRACNA)*(model_.VJUNREFD_i));
V2 = ((-FRACNB)*(model_.VJUNREFD_i));
V3 = ((-FRACI)*(model_.VJUNREFD_i));
V4 = 0.1;
V5 = 0.2;
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V1+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V1*vfmin_d)/(h3+h5)));
if ((V1<VMAX_d))
{
if ((fabs((0.5*(V1*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V1-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V1>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V1)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-vbbtlim_d)*(V1-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V1+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V1-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V1-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V1-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I1 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V2+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V2*vfmin_d)/(h3+h5)));
if ((V2<VMAX_d))
{
if ((fabs((0.5*(V2*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V2-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V2>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V2)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-vbbtlim_d)*(V2-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V2+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V2-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V2-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V2-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I2 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V3+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V3*vfmin_d)/(h3+h5)));
if ((V3<VMAX_d))
{
if ((fabs((0.5*(V3*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V3-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V3>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V3)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-vbbtlim_d)*(V3-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V3+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V3-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V3-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V3-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I3 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V4+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V4*vfmin_d)/(h3+h5)));
if ((V4<VMAX_d))
{
if ((fabs((0.5*(V4*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V4-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V4>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V4)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-vbbtlim_d)*(V4-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V4+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V4-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V4-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V4-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I4 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
vbbt = 0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);
h2d = (V5+(vch_d*h2));
h3 = (vfmin_d+h2d);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
h5 = value_sqrt_0;
}
vj = (2.0*((V5*vfmin_d)/(h3+h5)));
if ((V5<VMAX_d))
{
if ((fabs((0.5*(V5*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*(model_.phitdinv))));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*(model_.phitdinv)))<0.0))
{
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{
zinv = (1.0e100*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
idmult = (zinv*zinv);
}
else
{
idmult = ((1.0+((V5-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
z = (1.0/zinv);
if ((V5>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
two_psistar = ((-V5)+(2.0*((model_.phitd)*value_log_1)));
}
}
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-vbbtlim_d)*(V5-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
vbbt = (0.5*((V5+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{
ijunbot = 0.0;
qjunbot = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
tmp = value_pow_0;
}
}
qjunbot = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(V5-vj)));
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrbot_d)*tmp);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTBOTD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{
ijunsti = 0.0;
qjunsti = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
tmp = value_pow_0;
}
}
qjunsti = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(V5-vj)));
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrsti_d)*tmp);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTSTID_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{
ijungat = 0.0;
qjungat = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
tmp = value_pow_0;
}
}
qjungat = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(V5-vj)));
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{
isrh = 0.0;
}
else
{
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
wdep = ((model_.wdepnulrgat_d)*tmp);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{
itat = 0.0;
}
else
{
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
sqrtumax = value_sqrt_1;
}
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
wgamma = value_pow_0;
}
}
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
ktat = value_sqrt_0;
}
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));
xerfc = ((ltat-1.0)*ktat);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
tmp = value_exp_0;
}
}
else
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
tmp = value_pow_0;
}
}
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
ibbt = ((model_.CBBTGATD_i)*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
tmp = value_pow_1;
}
}
fbreakdown = (1.0/(1.0-tmp));
}
else
{
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
I5 = (((ABDRAIN_i*ijunbot)+(LSDRAIN_i*ijunsti))+(LGDRAIN_i*ijungat));
ISATFOR1_d = (((ABDRAIN_i*(model_.idsatbot_d))+(LSDRAIN_i*(model_.idsatsti_d)))+(LGDRAIN_i*(model_.idsatgat_d)));
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR1_d));
I4_cor = (I4-(ISATFOR1_d*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*(model_.phitdinv))*MFOR1_d));
I5_cor = (I5-(ISATFOR1_d*(value_exp_0-1.0)));
}
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
if (((I4>0.0)&&(I5>0.0)))
{
if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
{
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
MFOR2_d = (((model_.phitd)*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*(model_.phitdinv))*MFOR2_d));
ISATFOR2_d = (I4_cor/(value_exp_0-1.0));
}
}
}
{
double value_exp_0 = exp(((V1*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V1*(model_.phitdinv))*MFOR2_d));
I1_cor = ((I1-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V2*(model_.phitdinv))*MFOR2_d));
I2_cor = ((I2-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*(model_.phitdinv))*MFOR1_d));
double value_exp_1 = exp(((V3*(model_.phitdinv))*MFOR2_d));
I3_cor = ((I3-(ISATFOR1_d*(value_exp_0-1.0)))-(ISATFOR2_d*(value_exp_1-1.0)));
}
if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
{
if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
{
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
m0_rev = (((-(model_.phitd))*value_log_0)/(V1-V2));
}
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
tt1 = (((model_.phitd)*(alphaje-1.0))*(value_pow_0-1.0));
}
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
mcor_rev = (tt1/tt2);
MREV_d = (m0_rev+mcor_rev);
if ((fabs(((V3*(model_.phitdinv))*MREV_d))<1.0e-6))
{
m0flag_d = 1.0;
ISATREV_d = (I3_cor*((1.0/V3)+((0.5*(model_.phitdinv))*MREV_d)));
MREV_d = (((((-0.5)*I3_cor)*MREV_d)*(model_.phitdinv))/V3);
}
else
{
m0flag_d = 0.0;
{
double value_exp_0 = exp((((-V3)*(model_.phitdinv))*MREV_d));
ISATREV_d = ((-I3_cor)/(value_exp_0-1.0));
}
}
}
}
}
zfrac = ((model_.FJUNQD_i)*(((ABDRAIN_i*(model_.cjobot_d))+(LSDRAIN_i*(model_.cjosti_d)))+(LGDRAIN_i*(model_.cjogat_d))));
if (((ABDRAIN_i*(model_.cjobot_d))<=zfrac))
{
zflagbot_d = 0.0;
}
if (((LSDRAIN_i*(model_.cjosti_d))<=zfrac))
{
zflagsti_d = 0.0;
}
if (((LGDRAIN_i*(model_.cjogat_d))<=zfrac))
{
zflaggat_d = 0.0;
}
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR1_d+1.0e-21)));
xhighf1_d = value_log_0;
}
{
double value_log_0 = log(((0.5*(model_.IMAX_i))/(ISATFOR2_d+1.0e-21)));
xhighf2_d = value_log_0;
}
{
double value_fabs_0 = fabs(ISATREV_d);
double value_log_1 = log(((0.5*(model_.IMAX_i))/(value_fabs_0+1.0e-21)));
xhighr_d = value_log_1;
}
}
{
double value_min_0 = std::min(xhighf1_d,static_cast<double>(2.3025850929940458e+02));
xhighf1_d = value_min_0;
}
{
double value_exp_0 = exp(xhighf1_d);
expxhf1_d = value_exp_0;
}
{
double value_min_0 = std::min(xhighf2_d,static_cast<double>(2.3025850929940458e+02));
xhighf2_d = value_min_0;
}
{
double value_exp_0 = exp(xhighf2_d);
expxhf2_d = value_exp_0;
}
{
double value_min_0 = std::min(xhighr_d,static_cast<double>(2.3025850929940458e+02));
xhighr_d = value_min_0;
}
{
double value_exp_0 = exp(xhighr_d);
expxhr_d = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
}
// End block initial_instance


  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::Instance
// Purpose       : "instance block" constructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------

Instance::Instance(
  const Configuration & configuration,
  const InstanceBlock & instance_block,
  Model &               model,
  const FactoryBlock &  factory_block)
  : DeviceInstance(instance_block, configuration.getInstanceParameters(), factory_block),
    model_(model),
    L(1.0e-5),
    W(1.0e-5),
    SA(0.0),
    SB(0.0),
    SD(0.0),
    SCA(0.0),
    SCB(0.0),
    SCC(0.0),
    SC(0.0),
    NF(1.0),
    NGCON(1.0),
    XGW(1.0e-7),
    NRS(0.0),
    NRD(0.0),
    JW(1.0e-6),
    DELVTO(0.0),
    FACTUO(1.0),
    DELVTOEDGE(0.0),
    FACTUOEDGE(1.0),
    ABSOURCE(1.0e-12),
    LSSOURCE(1.0e-6),
    LGSOURCE(1.0e-6),
    ABDRAIN(1.0e-12),
    LSDRAIN(1.0e-6),
    LGDRAIN(1.0e-6),
    AS(1.0e-12),
    PS(1.0e-6),
    AD(1.0e-12),
    PD(1.0e-6),
    MULT(1.0),
    MULT_i(0.0),
    STVFB_i(0.0),
    TOX_i(0.0),
    EPSROX_i(0.0),
    NEFF_i(0.0),
    FACNEFFAC_i(0.0),
    GFACNUD_i(0.0),
    VSBNUD_i(0.0),
    DVSBNUD_i(0.0),
    VNSUB_i(0.0),
    NSLP_i(0.0),
    DNSUB_i(0.0),
    DPHIB_i(0.0),
    DELVTAC_i(0.0),
    NP_i(0.0),
    CT_i(0.0),
    TOXOV_i(0.0),
    TOXOVD_i(0.0),
    NOV_i(0.0),
    NOVD_i(0.0),
    CF_i(0.0),
    CFD_i(0.0),
    CFB_i(0.0),
    PSCE_i(0.0),
    PSCEB_i(0.0),
    PSCED_i(0.0),
    STBET_i(0.0),
    STMUE_i(0.0),
    STTHEMU_i(0.0),
    STCS_i(0.0),
    STXCOR_i(0.0),
    FETA_i(0.0),
    STRS_i(0.0),
    RSB_i(0.0),
    RSG_i(0.0),
    STTHESAT_i(0.0),
    THESATB_i(0.0),
    THESATG_i(0.0),
    AX_i(0.0),
    ALP_i(0.0),
    ALP1_i(0.0),
    ALP2_i(0.0),
    VP_i(0.0),
    A1_i(0.0),
    STA2_i(0.0),
    A3_i(0.0),
    A4_i(0.0),
    GCO_i(0.0),
    IGINV_i(0.0),
    IGOV_i(0.0),
    IGOVD_i(0.0),
    STIG_i(0.0),
    GC2_i(0.0),
    GC3_i(0.0),
    CHIB_i(0.0),
    AGIDL_i(0.0),
    AGIDLD_i(0.0),
    STBGIDL_i(0.0),
    STBGIDLD_i(0.0),
    CGIDL_i(0.0),
    CGIDLD_i(0.0),
    COX_i(0.0),
    CGOV_i(0.0),
    CGOVD_i(0.0),
    CGBOV_i(0.0),
    CFR_i(0.0),
    CFRD_i(0.0),
    FNT_i(0.0),
    FNTEXC_i(0.0),
    NFA_i(0.0),
    NFB_i(0.0),
    NFC_i(0.0),
    EF_i(0.0),
    STVFBEDGE_i(0.0),
    DPHIBEDGE_i(0.0),
    NEFFEDGE_i(0.0),
    CTEDGE_i(0.0),
    BETNEDGE_i(0.0),
    STBETEDGE_i(0.0),
    PSCEEDGE_i(0.0),
    PSCEBEDGE_i(0.0),
    PSCEDEDGE_i(0.0),
    CFEDGE_i(0.0),
    CFDEDGE_i(0.0),
    CFBEDGE_i(0.0),
    FNTEDGE_i(0.0),
    NFAEDGE_i(0.0),
    NFBEDGE_i(0.0),
    NFCEDGE_i(0.0),
    EFEDGE_i(0.0),
    RG_i(0.0),
    RSE_i(0.0),
    RDE_i(0.0),
    RBULK_i(0.0),
    RJUNS_i(0.0),
    RJUND_i(0.0),
    RWELL_i(0.0),
    LE(0.0),
    WE(0.0),
    ABSOURCE_i(0.0),
    LSSOURCE_i(0.0),
    LGSOURCE_i(0.0),
    zflagbot_s(0.0),
    zflagsti_s(0.0),
    zflaggat_s(0.0),
    VMAX_s(0.0),
    exp_VMAX_over_phitd_s(0.0),
    vbimin_s(0.0),
    vch_s(0.0),
    vfmin_s(0.0),
    vbbtlim_s(0.0),
    xhighf1_s(0.0),
    expxhf1_s(0.0),
    xhighf2_s(0.0),
    expxhf2_s(0.0),
    xhighr_s(0.0),
    expxhr_s(0.0),
    m0flag_s(0.0),
    ISATFOR1_s(0.0),
    MFOR1_s(0.0),
    ISATFOR2_s(0.0),
    MFOR2_s(0.0),
    ISATREV_s(0.0),
    MREV_s(0.0),
    ABDRAIN_i(0.0),
    LSDRAIN_i(0.0),
    LGDRAIN_i(0.0),
    zflagbot_d(0.0),
    zflagsti_d(0.0),
    zflaggat_d(0.0),
    VMAX_d(0.0),
    exp_VMAX_over_phitd_d(0.0),
    vbimin_d(0.0),
    vch_d(0.0),
    vfmin_d(0.0),
    vbbtlim_d(0.0),
    xhighf1_d(0.0),
    expxhf1_d(0.0),
    xhighf2_d(0.0),
    expxhf2_d(0.0),
    xhighr_d(0.0),
    expxhr_d(0.0),
    m0flag_d(0.0),
    ISATFOR1_d(0.0),
    MFOR1_d(0.0),
    ISATFOR2_d(0.0),
    MFOR2_d(0.0),
    ISATREV_d(0.0),
    MREV_d(0.0),
    VFB_T(0.0),
    BETN_T(0.0),
    MUE_T(0.0),
    THEMU_T(0.0),
    CS_T(0.0),
    XCOR_T(0.0),
    RS_T(0.0),
    BGIDL_T(0.0),
    BGIDLD_T(0.0),
    A2_T(0.0),
    VFBEDGE_T(0.0),
    BETNEDGE_T(0.0),
    phit0(0.0),
    BET_i(0.0),
    BETEDGE_i(0.0),
    nt(0.0),
    THESAT_T(0.0),
    Sfl_prefac(0.0),
    phit0edge(0.0),
    Gfedge2(0.0),
    lnGfedge2(0.0),
    Sfl_prefac_edge(0.0),
    ntedge(0.0),
    phib_dc(0.0),
    G_0_dc(0.0),
    kp(0.0),
    qlim2(0.0),
    sqrt_phib_dc(0.0),
    phix_dc(0.0),
    aphi_dc(0.0),
    bphi_dc(0.0),
    phix1_dc(0.0),
    alpha_b(0.0),
    us1(0.0),
    us21(0.0),
    phib_ac(0.0),
    G_0_ac(0.0),
    phix_ac(0.0),
    aphi_ac(0.0),
    bphi_ac(0.0),
    phix1_ac(0.0),
    THER_i(0.0),
    phibedge(0.0),
    Gfedge(0.0),
    phixedge(0.0),
    aphiedge(0.0),
    bphiedge(0.0),
    phix1edge(0.0),
    Cox_over_q(0.0),
    qq(0.0),
    E_eff0(0.0),
    eta_mu(0.0),
    eta_mu1(0.0),
    inv_AX(0.0),
    inv_VP(0.0),
    GOV_s(0.0),
    GOV_d(0.0),
    GOV2_s(0.0),
    GOV2_d(0.0),
    SP_OV_eps2_s(0.0),
    SP_OV_a_s(0.0),
    SP_OV_delta1_s(0.0),
    SP_OV_eps2_d(0.0),
    SP_OV_a_d(0.0),
    SP_OV_delta1_d(0.0),
    inv_CHIB(0.0),
    BCH(0.0),
    BOV(0.0),
    BOV_d(0.0),
    GCQ(0.0),
    AGIDLs(0.0),
    AGIDLDs(0.0),
    BGIDLs(0.0),
    BGIDLDs(0.0),
    fac_exc(0.0),
    ggate(0.0),
    gsource(0.0),
    gdrain(0.0),
    gbulk(0.0),
    gjuns(0.0),
    gjund(0.0),
    gwell(0.0),
    Sfl(0.0),
    sqid(0.0),
    mig(0.0),
d_mig_dV_DI_SI(0.0),
d_mig_dV_SI_BP(0.0),
d_mig_dV_GP_SI(0.0),
    CGeff(0.0),
d_CGeff_dV_DI_SI(0.0),
d_CGeff_dV_GP_SI(0.0),
d_CGeff_dV_SI_BP(0.0),
    c_igid(0.0),
    shot_igcsx(0.0),
    shot_igcdx(0.0),
    shot_igsov(0.0),
    shot_igdov(0.0),
    shot_iavl(0.0),
    jnoisex_s(0.0),
    jnoisex_d(0.0),
    ctype(0.0),
    sdint(0.0),
    ise(0.0),
    ige(0.0),
    ide(0.0),
    ibe(0.0),
    ids(0.0),
    idb(0.0),
    isb(0.0),
    igs(0.0),
    igd(0.0),
    igb(0.0),
    idedge(0.0),
    igcs(0.0),
    igcd(0.0),
    iavl(0.0),
    igisl(0.0),
    igidl(0.0),
    ijs(0.0),
    ijsbot(0.0),
    ijsgat(0.0),
    ijssti(0.0),
    ijd(0.0),
    ijdbot(0.0),
    ijdgat(0.0),
    ijdsti(0.0),
    vds(0.0),
    vgs(0.0),
    vsb(0.0),
    vto(0.0),
    vts(0.0),
    vth(0.0),
    vgt(0.0),
    vdss(0.0),
    vsat(0.0),
    gm(0.0),
    gmb(0.0),
    gds(0.0),
    gjs(0.0),
    gjd(0.0),
    cdd(0.0),
    cdg(0.0),
    cds(0.0),
    cdb(0.0),
    cgd(0.0),
    cgg(0.0),
    cgs(0.0),
    cgb(0.0),
    csd(0.0),
    csg(0.0),
    css(0.0),
    csb(0.0),
    cbd(0.0),
    cbg(0.0),
    cbs(0.0),
    cbb(0.0),
    cgsol(0.0),
    cgdol(0.0),
    cjs(0.0),
    cjsbot(0.0),
    cjsgat(0.0),
    cjssti(0.0),
    cjd(0.0),
    cjdbot(0.0),
    cjdgat(0.0),
    cjdsti(0.0),
    weff(0.0),
    leff(0.0),
    u(0.0),
    rout(0.0),
    vearly(0.0),
    beff(0.0),
    fug(0.0),
    rg(0.0),
    sfl(0.0),
    sqrtsff(0.0),
    sqrtsfw(0.0),
    sid(0.0),
    sig(0.0),
    cigid(0.0),
    fknee(0.0),
    sigs(0.0),
    sigd(0.0),
    siavl(0.0),
    ssi(0.0),
    sdi(0.0),
    sfledge(0.0),
    sidedge(0.0),
    lp_vfb(0.0),
    lp_stvfb(0.0),
    lp_tox(0.0),
    lp_epsrox(0.0),
    lp_neff(0.0),
    lp_facneffac(0.0),
    lp_gfacnud(0.0),
    lp_vsbnud(0.0),
    lp_dvsbnud(0.0),
    lp_vnsub(0.0),
    lp_nslp(0.0),
    lp_dnsub(0.0),
    lp_dphib(0.0),
    lp_delvtac(0.0),
    lp_np(0.0),
    lp_ct(0.0),
    lp_toxov(0.0),
    lp_toxovd(0.0),
    lp_nov(0.0),
    lp_novd(0.0),
    lp_cf(0.0),
    lp_cfd(0.0),
    lp_cfb(0.0),
    lp_psce(0.0),
    lp_psceb(0.0),
    lp_psced(0.0),
    lp_betn(0.0),
    lp_stbet(0.0),
    lp_mue(0.0),
    lp_stmue(0.0),
    lp_themu(0.0),
    lp_stthemu(0.0),
    lp_cs(0.0),
    lp_stcs(0.0),
    lp_xcor(0.0),
    lp_stxcor(0.0),
    lp_feta(0.0),
    lp_rs(0.0),
    lp_strs(0.0),
    lp_rsb(0.0),
    lp_rsg(0.0),
    lp_thesat(0.0),
    lp_stthesat(0.0),
    lp_thesatb(0.0),
    lp_thesatg(0.0),
    lp_ax(0.0),
    lp_alp(0.0),
    lp_alp1(0.0),
    lp_alp2(0.0),
    lp_vp(0.0),
    lp_a1(0.0),
    lp_a2(0.0),
    lp_sta2(0.0),
    lp_a3(0.0),
    lp_a4(0.0),
    lp_gco(0.0),
    lp_iginv(0.0),
    lp_igov(0.0),
    lp_igovd(0.0),
    lp_stig(0.0),
    lp_gc2(0.0),
    lp_gc3(0.0),
    lp_chib(0.0),
    lp_agidl(0.0),
    lp_agidld(0.0),
    lp_bgidl(0.0),
    lp_bgidld(0.0),
    lp_stbgidl(0.0),
    lp_stbgidld(0.0),
    lp_cgidl(0.0),
    lp_cgidld(0.0),
    lp_cox(0.0),
    lp_cgov(0.0),
    lp_cgovd(0.0),
    lp_cgbov(0.0),
    lp_cfr(0.0),
    lp_cfrd(0.0),
    lp_fnt(0.0),
    lp_fntexc(0.0),
    lp_nfa(0.0),
    lp_nfb(0.0),
    lp_nfc(0.0),
    lp_ef(0.0),
    lp_vfbedge(0.0),
    lp_stvfbedge(0.0),
    lp_dphibedge(0.0),
    lp_neffedge(0.0),
    lp_ctedge(0.0),
    lp_betnedge(0.0),
    lp_stbetedge(0.0),
    lp_psceedge(0.0),
    lp_pscebedge(0.0),
    lp_pscededge(0.0),
    lp_cfedge(0.0),
    lp_cfdedge(0.0),
    lp_cfbedge(0.0),
    lp_fntedge(0.0),
    lp_nfaedge(0.0),
    lp_nfbedge(0.0),
    lp_nfcedge(0.0),
    lp_efedge(0.0),
    lp_rg(0.0),
    lp_rse(0.0),
    lp_rde(0.0),
    lp_rbulk(0.0),
    lp_rwell(0.0),
    lp_rjuns(0.0),
    lp_rjund(0.0),
    tk(0.0),
    cjosbot(0.0),
    cjossti(0.0),
    cjosgat(0.0),
    vbisbot(0.0),
    vbissti(0.0),
    vbisgat(0.0),
    idsatsbot(0.0),
    idsatssti(0.0),
    idsatsgat(0.0),
    cjosbotd(0.0),
    cjosstid(0.0),
    cjosgatd(0.0),
    vbisbotd(0.0),
    vbisstid(0.0),
    vbisgatd(0.0),
    idsatsbotd(0.0),
    idsatsstid(0.0),
    idsatsgatd(0.0),
    li_D(-1),
    li_G(-1),
    li_S(-1),
    li_B(-1),
    li_NOI(-1),
    li_NOI2(-1),
    li_GP(-1),
    li_SI(-1),
    li_DI(-1),
    li_BP(-1),
    li_BI(-1),
    li_BS(-1),
    li_BD(-1),
    li_branch_iD(-1),
    li_branch_iG(-1),
    li_branch_iS(-1),
    li_branch_iB(-1),
    f_DI_Equ_SI_Node_Ptr(0),
    f_DI_Equ_BP_Node_Ptr(0),
    f_BP_Equ_SI_Node_Ptr(0),
    f_BP_Equ_BP_Node_Ptr(0),
    f_DI_Equ_GP_Node_Ptr(0),
    f_BP_Equ_GP_Node_Ptr(0),
    f_DI_Equ_DI_Node_Ptr(0),
    f_BP_Equ_DI_Node_Ptr(0),
    f_SI_Equ_SI_Node_Ptr(0),
    f_SI_Equ_BP_Node_Ptr(0),
    f_SI_Equ_GP_Node_Ptr(0),
    f_SI_Equ_DI_Node_Ptr(0),
    f_GP_Equ_SI_Node_Ptr(0),
    f_GP_Equ_BP_Node_Ptr(0),
    f_GP_Equ_DI_Node_Ptr(0),
    f_GP_Equ_GP_Node_Ptr(0),
    f_BS_Equ_SI_Node_Ptr(0),
    f_BS_Equ_BS_Node_Ptr(0),
    f_SI_Equ_BS_Node_Ptr(0),
    f_BS_Equ_DI_Node_Ptr(0),
    f_BS_Equ_BD_Node_Ptr(0),
    f_SI_Equ_BD_Node_Ptr(0),
    f_BD_Equ_SI_Node_Ptr(0),
    f_BD_Equ_BS_Node_Ptr(0),
    f_DI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_DI_Node_Ptr(0),
    f_BD_Equ_BD_Node_Ptr(0),
    f_DI_Equ_BD_Node_Ptr(0),
    f_G_Equ_G_Node_Ptr(0),
    f_G_Equ_GP_Node_Ptr(0),
    f_GP_Equ_G_Node_Ptr(0),
    f_S_Equ_S_Node_Ptr(0),
    f_S_Equ_SI_Node_Ptr(0),
    f_SI_Equ_S_Node_Ptr(0),
    f_D_Equ_D_Node_Ptr(0),
    f_D_Equ_DI_Node_Ptr(0),
    f_DI_Equ_D_Node_Ptr(0),
    f_BP_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BP_Node_Ptr(0),
    f_BI_Equ_BI_Node_Ptr(0),
    f_BS_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BS_Node_Ptr(0),
    f_BD_Equ_BI_Node_Ptr(0),
    f_BI_Equ_BD_Node_Ptr(0),
    f_B_Equ_B_Node_Ptr(0),
    f_B_Equ_BI_Node_Ptr(0),
    f_BI_Equ_B_Node_Ptr(0),
    f_NOI2_Equ_NOI2_Node_Ptr(0),
    f_NOI2_Equ_GP_Node_Ptr(0),
    f_NOI2_Equ_SI_Node_Ptr(0),
    f_NOI2_Equ_BP_Node_Ptr(0),
    f_NOI2_Equ_DI_Node_Ptr(0),
    f_NOI_Equ_SI_Node_Ptr(0),
    f_NOI_Equ_BP_Node_Ptr(0),
    f_NOI_Equ_GP_Node_Ptr(0),
    f_NOI_Equ_DI_Node_Ptr(0),
    f_NOI_Equ_NOI2_Node_Ptr(0),
    f_NOI_Equ_NOI_Node_Ptr(0),
    f_GP_Equ_NOI_Node_Ptr(0),
    f_SI_Equ_NOI_Node_Ptr(0),
    f_DI_Equ_NOI_Node_Ptr(0),
    f_DI_Equ_NOI2_Node_Ptr(0),
    f_SI_Equ_NOI2_Node_Ptr(0),
    f_BS_Equ_BP_Node_Ptr(0),
    f_BS_Equ_GP_Node_Ptr(0),
    f_BD_Equ_BP_Node_Ptr(0),
    f_BD_Equ_GP_Node_Ptr(0),
    q_DI_Equ_SI_Node_Ptr(0),
    q_DI_Equ_BP_Node_Ptr(0),
    q_BP_Equ_SI_Node_Ptr(0),
    q_BP_Equ_BP_Node_Ptr(0),
    q_DI_Equ_GP_Node_Ptr(0),
    q_BP_Equ_GP_Node_Ptr(0),
    q_DI_Equ_DI_Node_Ptr(0),
    q_BP_Equ_DI_Node_Ptr(0),
    q_SI_Equ_SI_Node_Ptr(0),
    q_SI_Equ_BP_Node_Ptr(0),
    q_SI_Equ_GP_Node_Ptr(0),
    q_SI_Equ_DI_Node_Ptr(0),
    q_GP_Equ_SI_Node_Ptr(0),
    q_GP_Equ_BP_Node_Ptr(0),
    q_GP_Equ_DI_Node_Ptr(0),
    q_GP_Equ_GP_Node_Ptr(0),
    q_BS_Equ_SI_Node_Ptr(0),
    q_BS_Equ_BS_Node_Ptr(0),
    q_SI_Equ_BS_Node_Ptr(0),
    q_BS_Equ_DI_Node_Ptr(0),
    q_BS_Equ_BD_Node_Ptr(0),
    q_SI_Equ_BD_Node_Ptr(0),
    q_BD_Equ_SI_Node_Ptr(0),
    q_BD_Equ_BS_Node_Ptr(0),
    q_DI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_DI_Node_Ptr(0),
    q_BD_Equ_BD_Node_Ptr(0),
    q_DI_Equ_BD_Node_Ptr(0),
    q_G_Equ_G_Node_Ptr(0),
    q_G_Equ_GP_Node_Ptr(0),
    q_GP_Equ_G_Node_Ptr(0),
    q_S_Equ_S_Node_Ptr(0),
    q_S_Equ_SI_Node_Ptr(0),
    q_SI_Equ_S_Node_Ptr(0),
    q_D_Equ_D_Node_Ptr(0),
    q_D_Equ_DI_Node_Ptr(0),
    q_DI_Equ_D_Node_Ptr(0),
    q_BP_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BP_Node_Ptr(0),
    q_BI_Equ_BI_Node_Ptr(0),
    q_BS_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BS_Node_Ptr(0),
    q_BD_Equ_BI_Node_Ptr(0),
    q_BI_Equ_BD_Node_Ptr(0),
    q_B_Equ_B_Node_Ptr(0),
    q_B_Equ_BI_Node_Ptr(0),
    q_BI_Equ_B_Node_Ptr(0),
    q_NOI2_Equ_NOI2_Node_Ptr(0),
    q_NOI2_Equ_GP_Node_Ptr(0),
    q_NOI2_Equ_SI_Node_Ptr(0),
    q_NOI2_Equ_BP_Node_Ptr(0),
    q_NOI2_Equ_DI_Node_Ptr(0),
    q_NOI_Equ_SI_Node_Ptr(0),
    q_NOI_Equ_BP_Node_Ptr(0),
    q_NOI_Equ_GP_Node_Ptr(0),
    q_NOI_Equ_DI_Node_Ptr(0),
    q_NOI_Equ_NOI2_Node_Ptr(0),
    q_NOI_Equ_NOI_Node_Ptr(0),
    q_GP_Equ_NOI_Node_Ptr(0),
    q_SI_Equ_NOI_Node_Ptr(0),
    q_DI_Equ_NOI_Node_Ptr(0),
    q_DI_Equ_NOI2_Node_Ptr(0),
    q_SI_Equ_NOI2_Node_Ptr(0),
    q_BS_Equ_BP_Node_Ptr(0),
    q_BS_Equ_GP_Node_Ptr(0),
    q_BD_Equ_BP_Node_Ptr(0),
    q_BD_Equ_GP_Node_Ptr(0),
    A_DI_Equ_SI_NodeOffset(-1),
    A_DI_Equ_BP_NodeOffset(-1),
    A_BP_Equ_SI_NodeOffset(-1),
    A_BP_Equ_BP_NodeOffset(-1),
    A_DI_Equ_GP_NodeOffset(-1),
    A_BP_Equ_GP_NodeOffset(-1),
    A_DI_Equ_DI_NodeOffset(-1),
    A_BP_Equ_DI_NodeOffset(-1),
    A_SI_Equ_SI_NodeOffset(-1),
    A_SI_Equ_BP_NodeOffset(-1),
    A_SI_Equ_GP_NodeOffset(-1),
    A_SI_Equ_DI_NodeOffset(-1),
    A_GP_Equ_SI_NodeOffset(-1),
    A_GP_Equ_BP_NodeOffset(-1),
    A_GP_Equ_DI_NodeOffset(-1),
    A_GP_Equ_GP_NodeOffset(-1),
    A_BS_Equ_SI_NodeOffset(-1),
    A_BS_Equ_BS_NodeOffset(-1),
    A_SI_Equ_BS_NodeOffset(-1),
    A_BS_Equ_DI_NodeOffset(-1),
    A_BS_Equ_BD_NodeOffset(-1),
    A_SI_Equ_BD_NodeOffset(-1),
    A_BD_Equ_SI_NodeOffset(-1),
    A_BD_Equ_BS_NodeOffset(-1),
    A_DI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_DI_NodeOffset(-1),
    A_BD_Equ_BD_NodeOffset(-1),
    A_DI_Equ_BD_NodeOffset(-1),
    A_G_Equ_G_NodeOffset(-1),
    A_G_Equ_GP_NodeOffset(-1),
    A_GP_Equ_G_NodeOffset(-1),
    A_S_Equ_S_NodeOffset(-1),
    A_S_Equ_SI_NodeOffset(-1),
    A_SI_Equ_S_NodeOffset(-1),
    A_D_Equ_D_NodeOffset(-1),
    A_D_Equ_DI_NodeOffset(-1),
    A_DI_Equ_D_NodeOffset(-1),
    A_BP_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BP_NodeOffset(-1),
    A_BI_Equ_BI_NodeOffset(-1),
    A_BS_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BS_NodeOffset(-1),
    A_BD_Equ_BI_NodeOffset(-1),
    A_BI_Equ_BD_NodeOffset(-1),
    A_B_Equ_B_NodeOffset(-1),
    A_B_Equ_BI_NodeOffset(-1),
    A_BI_Equ_B_NodeOffset(-1),
    A_NOI2_Equ_NOI2_NodeOffset(-1),
    A_NOI2_Equ_GP_NodeOffset(-1),
    A_NOI2_Equ_SI_NodeOffset(-1),
    A_NOI2_Equ_BP_NodeOffset(-1),
    A_NOI2_Equ_DI_NodeOffset(-1),
    A_NOI_Equ_SI_NodeOffset(-1),
    A_NOI_Equ_BP_NodeOffset(-1),
    A_NOI_Equ_GP_NodeOffset(-1),
    A_NOI_Equ_DI_NodeOffset(-1),
    A_NOI_Equ_NOI2_NodeOffset(-1),
    A_NOI_Equ_NOI_NodeOffset(-1),
    A_GP_Equ_NOI_NodeOffset(-1),
    A_SI_Equ_NOI_NodeOffset(-1),
    A_DI_Equ_NOI_NodeOffset(-1),
    A_DI_Equ_NOI2_NodeOffset(-1),
    A_SI_Equ_NOI2_NodeOffset(-1),
    A_BS_Equ_BP_NodeOffset(-1),
    A_BS_Equ_GP_NodeOffset(-1),
    A_BD_Equ_BP_NodeOffset(-1),
    A_BD_Equ_GP_NodeOffset(-1),
    li_store_ctype(-1),
    li_store_sdint(-1),
    li_store_ise(-1),
    li_store_ige(-1),
    li_store_ide(-1),
    li_store_ibe(-1),
    li_store_ids(-1),
    li_store_idb(-1),
    li_store_isb(-1),
    li_store_igs(-1),
    li_store_igd(-1),
    li_store_igb(-1),
    li_store_idedge(-1),
    li_store_igcs(-1),
    li_store_igcd(-1),
    li_store_iavl(-1),
    li_store_igisl(-1),
    li_store_igidl(-1),
    li_store_ijs(-1),
    li_store_ijsbot(-1),
    li_store_ijsgat(-1),
    li_store_ijssti(-1),
    li_store_ijd(-1),
    li_store_ijdbot(-1),
    li_store_ijdgat(-1),
    li_store_ijdsti(-1),
    li_store_vds(-1),
    li_store_vgs(-1),
    li_store_vsb(-1),
    li_store_vto(-1),
    li_store_vts(-1),
    li_store_vth(-1),
    li_store_vgt(-1),
    li_store_vdss(-1),
    li_store_vsat(-1),
    li_store_gm(-1),
    li_store_gmb(-1),
    li_store_gds(-1),
    li_store_gjs(-1),
    li_store_gjd(-1),
    li_store_cdd(-1),
    li_store_cdg(-1),
    li_store_cds(-1),
    li_store_cdb(-1),
    li_store_cgd(-1),
    li_store_cgg(-1),
    li_store_cgs(-1),
    li_store_cgb(-1),
    li_store_csd(-1),
    li_store_csg(-1),
    li_store_css(-1),
    li_store_csb(-1),
    li_store_cbd(-1),
    li_store_cbg(-1),
    li_store_cbs(-1),
    li_store_cbb(-1),
    li_store_cgsol(-1),
    li_store_cgdol(-1),
    li_store_cjs(-1),
    li_store_cjsbot(-1),
    li_store_cjsgat(-1),
    li_store_cjssti(-1),
    li_store_cjd(-1),
    li_store_cjdbot(-1),
    li_store_cjdgat(-1),
    li_store_cjdsti(-1),
    li_store_weff(-1),
    li_store_leff(-1),
    li_store_u(-1),
    li_store_rout(-1),
    li_store_vearly(-1),
    li_store_beff(-1),
    li_store_fug(-1),
    li_store_rg(-1),
    li_store_sfl(-1),
    li_store_sqrtsff(-1),
    li_store_sqrtsfw(-1),
    li_store_sid(-1),
    li_store_sig(-1),
    li_store_cigid(-1),
    li_store_fknee(-1),
    li_store_sigs(-1),
    li_store_sigd(-1),
    li_store_siavl(-1),
    li_store_ssi(-1),
    li_store_sdi(-1),
    li_store_sfledge(-1),
    li_store_sidedge(-1),
    li_store_lp_vfb(-1),
    li_store_lp_stvfb(-1),
    li_store_lp_tox(-1),
    li_store_lp_epsrox(-1),
    li_store_lp_neff(-1),
    li_store_lp_facneffac(-1),
    li_store_lp_gfacnud(-1),
    li_store_lp_vsbnud(-1),
    li_store_lp_dvsbnud(-1),
    li_store_lp_vnsub(-1),
    li_store_lp_nslp(-1),
    li_store_lp_dnsub(-1),
    li_store_lp_dphib(-1),
    li_store_lp_delvtac(-1),
    li_store_lp_np(-1),
    li_store_lp_ct(-1),
    li_store_lp_toxov(-1),
    li_store_lp_toxovd(-1),
    li_store_lp_nov(-1),
    li_store_lp_novd(-1),
    li_store_lp_cf(-1),
    li_store_lp_cfd(-1),
    li_store_lp_cfb(-1),
    li_store_lp_psce(-1),
    li_store_lp_psceb(-1),
    li_store_lp_psced(-1),
    li_store_lp_betn(-1),
    li_store_lp_stbet(-1),
    li_store_lp_mue(-1),
    li_store_lp_stmue(-1),
    li_store_lp_themu(-1),
    li_store_lp_stthemu(-1),
    li_store_lp_cs(-1),
    li_store_lp_stcs(-1),
    li_store_lp_xcor(-1),
    li_store_lp_stxcor(-1),
    li_store_lp_feta(-1),
    li_store_lp_rs(-1),
    li_store_lp_strs(-1),
    li_store_lp_rsb(-1),
    li_store_lp_rsg(-1),
    li_store_lp_thesat(-1),
    li_store_lp_stthesat(-1),
    li_store_lp_thesatb(-1),
    li_store_lp_thesatg(-1),
    li_store_lp_ax(-1),
    li_store_lp_alp(-1),
    li_store_lp_alp1(-1),
    li_store_lp_alp2(-1),
    li_store_lp_vp(-1),
    li_store_lp_a1(-1),
    li_store_lp_a2(-1),
    li_store_lp_sta2(-1),
    li_store_lp_a3(-1),
    li_store_lp_a4(-1),
    li_store_lp_gco(-1),
    li_store_lp_iginv(-1),
    li_store_lp_igov(-1),
    li_store_lp_igovd(-1),
    li_store_lp_stig(-1),
    li_store_lp_gc2(-1),
    li_store_lp_gc3(-1),
    li_store_lp_chib(-1),
    li_store_lp_agidl(-1),
    li_store_lp_agidld(-1),
    li_store_lp_bgidl(-1),
    li_store_lp_bgidld(-1),
    li_store_lp_stbgidl(-1),
    li_store_lp_stbgidld(-1),
    li_store_lp_cgidl(-1),
    li_store_lp_cgidld(-1),
    li_store_lp_cox(-1),
    li_store_lp_cgov(-1),
    li_store_lp_cgovd(-1),
    li_store_lp_cgbov(-1),
    li_store_lp_cfr(-1),
    li_store_lp_cfrd(-1),
    li_store_lp_fnt(-1),
    li_store_lp_fntexc(-1),
    li_store_lp_nfa(-1),
    li_store_lp_nfb(-1),
    li_store_lp_nfc(-1),
    li_store_lp_ef(-1),
    li_store_lp_vfbedge(-1),
    li_store_lp_stvfbedge(-1),
    li_store_lp_dphibedge(-1),
    li_store_lp_neffedge(-1),
    li_store_lp_ctedge(-1),
    li_store_lp_betnedge(-1),
    li_store_lp_stbetedge(-1),
    li_store_lp_psceedge(-1),
    li_store_lp_pscebedge(-1),
    li_store_lp_pscededge(-1),
    li_store_lp_cfedge(-1),
    li_store_lp_cfdedge(-1),
    li_store_lp_cfbedge(-1),
    li_store_lp_fntedge(-1),
    li_store_lp_nfaedge(-1),
    li_store_lp_nfbedge(-1),
    li_store_lp_nfcedge(-1),
    li_store_lp_efedge(-1),
    li_store_lp_rg(-1),
    li_store_lp_rse(-1),
    li_store_lp_rde(-1),
    li_store_lp_rbulk(-1),
    li_store_lp_rwell(-1),
    li_store_lp_rjuns(-1),
    li_store_lp_rjund(-1),
    li_store_tk(-1),
    li_store_cjosbot(-1),
    li_store_cjossti(-1),
    li_store_cjosgat(-1),
    li_store_vbisbot(-1),
    li_store_vbissti(-1),
    li_store_vbisgat(-1),
    li_store_idsatsbot(-1),
    li_store_idsatssti(-1),
    li_store_idsatsgat(-1),
    li_store_cjosbotd(-1),
    li_store_cjosstid(-1),
    li_store_cjosgatd(-1),
    li_store_vbisbotd(-1),
    li_store_vbisstid(-1),
    li_store_vbisgatd(-1),
    li_store_idsatsbotd(-1),
    li_store_idsatsstid(-1),
    li_store_idsatsgatd(-1),
    collapseNode_GP(false),
    collapseNode_SI(false),
    collapseNode_DI(false),
    collapseNode_BP(false),
    collapseNode_BI(false),
    collapseNode_BS(false),
    collapseNode_BD(false),
    admsTemperature(getDeviceOptions().temp.getImmutableValue<double>())

{
    numIntVars = 9 + 0;
    numExtVars = 4;

  // Right now, we only have store for limited probes and output vars...
  setNumStoreVars(0+215);

  // Do not allocate "branch" (lead current) vectors by default
  setNumBranchDataVars(0);
  numBranchDataVarsIfAllocated = 4;

  leadCurrentF.resize(4);
  leadCurrentQ.resize(4);

  // Set up jacobian stamp:
  // Create a vector of the non-zero elements of the stamp
PairVector jacobianElements;
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_D,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_G,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_S,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_B,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_NOI,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_NOI2,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
    jacobianElements.push_back(IntPair(admsNodeID_GP,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_S));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_SI,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_D));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_NOI));
    jacobianElements.push_back(IntPair(admsNodeID_DI,admsNodeID_NOI2));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BS,admsNodeID_GP));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_SI));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BS));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_DI));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BD));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_BP));
    jacobianElements.push_back(IntPair(admsNodeID_BD,admsNodeID_GP));



  setDefaultParams();
  setParams(instance_block.params);

  // Real bogosity here...
  if (!given("XYCEADMSINSTTEMP"))
    admsInstTemp=getDeviceOptions().temp.getImmutableValue<double>();

  //calculate any parameters specified as expressions
  updateDependentParameters();

  // calculate dependent (i.e. computed params) and check for errors.
  processParams();

  PairVector collapsedNodes;
  collapseNodes();

  if (collapseNode_GP)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_GP,admsNodeID_G));
  }
  if (collapseNode_SI)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_SI,admsNodeID_S));
  }
  if (collapseNode_DI)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_DI,admsNodeID_D));
  }
  if (collapseNode_BP)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BP,admsNodeID_BI));
  }
  if (collapseNode_BI)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BI,admsNodeID_B));
  }
  if (collapseNode_BS)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BS,admsNodeID_BI));
  }
  if (collapseNode_BD)
  {
  collapsedNodes.push_back(IntPair(admsNodeID_BD,admsNodeID_BI));
  }

// Now generate the jacstamp from what we already have.
// This jacstamp will have all the correct node mapping.  map will be the nodal mapping of original
// node IDs to row/column ids in the reduced (non-sparse) representation of the jacobian.
// (for devices that have no collapsibles, this will be static, so check that it hasn't already
// been filled in)
if (jacStamp.empty())
{
int originalSize = 13+0;
computeJacStampAndMaps(jacobianElements,collapsedNodes,jacStamp,nodeMap,pairToJacStampMap,originalSize);
}

}

//-----------------------------------------------------------------------------
// Function      : Instance::collapseNodes
// Purpose       : function to handle collapsing of nodes
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::collapseNodes()
{
collapseNode_GP = false;
collapseNode_SI = false;
collapseNode_DI = false;
collapseNode_BP = false;
collapseNode_BI = false;
collapseNode_BS = false;
collapseNode_BD = false;
// begin block named evaluateblock

// begin block named loadStatic

if (!((RG_i>0.0)))
{

collapseNode_GP = true;

}

if (!((RSE_i>0.0)))
{

collapseNode_SI = true;

}

if (!((RDE_i>0.0)))
{

collapseNode_DI = true;

}

if (!((RBULK_i>0.0)))
{

collapseNode_BP = true;

}

if (!((RJUNS_i>0.0)))
{

collapseNode_BS = true;

}

if (!((RJUND_i>0.0)))
{

collapseNode_BD = true;

}

if (!((RWELL_i>0.0)))
{

collapseNode_BI = true;

}

// end block  named loadStatic

// end block  named evaluateblock


  if (collapseNode_GP)
  {
    numIntVars--;
  }
  if (collapseNode_SI)
  {
    numIntVars--;
  }
  if (collapseNode_DI)
  {
    numIntVars--;
  }
  if (collapseNode_BP)
  {
    numIntVars--;
  }
  if (collapseNode_BI)
  {
    numIntVars--;
  }
  if (collapseNode_BS)
  {
    numIntVars--;
  }
  if (collapseNode_BD)
  {
    numIntVars--;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::~Instance
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
Instance::~Instance()
{
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerLIDs
// Purpose       : function for registering, and setting up, local IDs.
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerLIDs( const LocalIdVector & intLIDVecRef,
                             const LocalIdVector & extLIDVecRef)
{
  AssertLIDs(intLIDVecRef.size() == numIntVars);
  AssertLIDs(extLIDVecRef.size() == numExtVars);

  LocalIdVector localLIDVec;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << std::endl << section_divider << std::endl
                 << "In ADMSPSP103VA::Instance::register LIDs\n\n"
                 << "name             = " << getName() << std::endl
                 << "number of internal variables: " << numIntVars << std::endl
                 << "number of external variables: " << numExtVars << std::endl;
  }

  // copy over the global ID lists into a local array.
  // The end result of this is an array of LIDs corresponding to all the
  // nodes we actually have, in the order that topology thinks of them
  intLIDVec = intLIDVecRef;
  extLIDVec = extLIDVecRef;
  localLIDVec.resize(numExtVars+numIntVars);
  for (int localNodeIndex=0;localNodeIndex<numExtVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=extLIDVec[localNodeIndex];
  }
  for (int localNodeIndex=numExtVars;localNodeIndex<numExtVars+numIntVars;++localNodeIndex)
  {
    localLIDVec[localNodeIndex]=intLIDVec[localNodeIndex-numExtVars];
    }

  // Now pull the LIDs for each of our nodes out of the local array.
  // Use the node mapping created by createJacStampAndMaps to handle
  // all the node collapse complications.
  li_D = localLIDVec[nodeMap[admsNodeID_D]];
  li_G = localLIDVec[nodeMap[admsNodeID_G]];
  li_S = localLIDVec[nodeMap[admsNodeID_S]];
  li_B = localLIDVec[nodeMap[admsNodeID_B]];
  li_NOI = localLIDVec[nodeMap[admsNodeID_NOI]];
  li_NOI2 = localLIDVec[nodeMap[admsNodeID_NOI2]];
  li_GP = localLIDVec[nodeMap[admsNodeID_GP]];
  li_SI = localLIDVec[nodeMap[admsNodeID_SI]];
  li_DI = localLIDVec[nodeMap[admsNodeID_DI]];
  li_BP = localLIDVec[nodeMap[admsNodeID_BP]];
  li_BI = localLIDVec[nodeMap[admsNodeID_BI]];
  li_BS = localLIDVec[nodeMap[admsNodeID_BS]];
  li_BD = localLIDVec[nodeMap[admsNodeID_BD]];


  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS))
  {
    Xyce::dout() << "\nSolution and RHS variables:\n";
      Xyce::dout() << "\nli_D = " << li_D << std::endl;
      Xyce::dout() << "\nli_G = " << li_G << std::endl;
      Xyce::dout() << "\nli_S = " << li_S << std::endl;
      Xyce::dout() << "\nli_B = " << li_B << std::endl;
      Xyce::dout() << "\nli_NOI = " << li_NOI << std::endl;
      Xyce::dout() << "\nli_NOI2 = " << li_NOI2 << std::endl;
      Xyce::dout() << "\nli_GP = " << li_GP << std::endl;
      Xyce::dout() << "\nli_SI = " << li_SI << std::endl;
      Xyce::dout() << "\nli_DI = " << li_DI << std::endl;
      Xyce::dout() << "\nli_BP = " << li_BP << std::endl;
      Xyce::dout() << "\nli_BI = " << li_BI << std::endl;
      Xyce::dout() << "\nli_BS = " << li_BS << std::endl;
      Xyce::dout() << "\nli_BD = " << li_BD << std::endl;

    Xyce::dout() << "\nEnd of ADMSPSP103VA::Instance::register LIDs\n";
    Xyce::dout() << section_divider << std::endl;
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadNodeSymbols
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::loadNodeSymbols(Util::SymbolTable &symbol_table) const
{
    addInternalNode(symbol_table, li_NOI, getName(), "NOI");
    addInternalNode(symbol_table, li_NOI2, getName(), "NOI2");
    if (!collapseNode_GP)
    {
    addInternalNode(symbol_table, li_GP, getName(), "GP");
    }
    if (!collapseNode_SI)
    {
    addInternalNode(symbol_table, li_SI, getName(), "SI");
    }
    if (!collapseNode_DI)
    {
    addInternalNode(symbol_table, li_DI, getName(), "DI");
    }
    if (!collapseNode_BP)
    {
    addInternalNode(symbol_table, li_BP, getName(), "BP");
    }
    if (!collapseNode_BI)
    {
    addInternalNode(symbol_table, li_BI, getName(), "BI");
    }
    if (!collapseNode_BS)
    {
    addInternalNode(symbol_table, li_BS, getName(), "BS");
    }
    if (!collapseNode_BD)
    {
    addInternalNode(symbol_table, li_BD, getName(), "BD");
    }
    addStoreNode(symbol_table, li_store_ctype, getName().getEncodedName() + ":ctype");
    addStoreNode(symbol_table, li_store_sdint, getName().getEncodedName() + ":sdint");
    addStoreNode(symbol_table, li_store_ise, getName().getEncodedName() + ":ise");
    addStoreNode(symbol_table, li_store_ige, getName().getEncodedName() + ":ige");
    addStoreNode(symbol_table, li_store_ide, getName().getEncodedName() + ":ide");
    addStoreNode(symbol_table, li_store_ibe, getName().getEncodedName() + ":ibe");
    addStoreNode(symbol_table, li_store_ids, getName().getEncodedName() + ":ids");
    addStoreNode(symbol_table, li_store_idb, getName().getEncodedName() + ":idb");
    addStoreNode(symbol_table, li_store_isb, getName().getEncodedName() + ":isb");
    addStoreNode(symbol_table, li_store_igs, getName().getEncodedName() + ":igs");
    addStoreNode(symbol_table, li_store_igd, getName().getEncodedName() + ":igd");
    addStoreNode(symbol_table, li_store_igb, getName().getEncodedName() + ":igb");
    addStoreNode(symbol_table, li_store_idedge, getName().getEncodedName() + ":idedge");
    addStoreNode(symbol_table, li_store_igcs, getName().getEncodedName() + ":igcs");
    addStoreNode(symbol_table, li_store_igcd, getName().getEncodedName() + ":igcd");
    addStoreNode(symbol_table, li_store_iavl, getName().getEncodedName() + ":iavl");
    addStoreNode(symbol_table, li_store_igisl, getName().getEncodedName() + ":igisl");
    addStoreNode(symbol_table, li_store_igidl, getName().getEncodedName() + ":igidl");
    addStoreNode(symbol_table, li_store_ijs, getName().getEncodedName() + ":ijs");
    addStoreNode(symbol_table, li_store_ijsbot, getName().getEncodedName() + ":ijsbot");
    addStoreNode(symbol_table, li_store_ijsgat, getName().getEncodedName() + ":ijsgat");
    addStoreNode(symbol_table, li_store_ijssti, getName().getEncodedName() + ":ijssti");
    addStoreNode(symbol_table, li_store_ijd, getName().getEncodedName() + ":ijd");
    addStoreNode(symbol_table, li_store_ijdbot, getName().getEncodedName() + ":ijdbot");
    addStoreNode(symbol_table, li_store_ijdgat, getName().getEncodedName() + ":ijdgat");
    addStoreNode(symbol_table, li_store_ijdsti, getName().getEncodedName() + ":ijdsti");
    addStoreNode(symbol_table, li_store_vds, getName().getEncodedName() + ":vds");
    addStoreNode(symbol_table, li_store_vgs, getName().getEncodedName() + ":vgs");
    addStoreNode(symbol_table, li_store_vsb, getName().getEncodedName() + ":vsb");
    addStoreNode(symbol_table, li_store_vto, getName().getEncodedName() + ":vto");
    addStoreNode(symbol_table, li_store_vts, getName().getEncodedName() + ":vts");
    addStoreNode(symbol_table, li_store_vth, getName().getEncodedName() + ":vth");
    addStoreNode(symbol_table, li_store_vgt, getName().getEncodedName() + ":vgt");
    addStoreNode(symbol_table, li_store_vdss, getName().getEncodedName() + ":vdss");
    addStoreNode(symbol_table, li_store_vsat, getName().getEncodedName() + ":vsat");
    addStoreNode(symbol_table, li_store_gm, getName().getEncodedName() + ":gm");
    addStoreNode(symbol_table, li_store_gmb, getName().getEncodedName() + ":gmb");
    addStoreNode(symbol_table, li_store_gds, getName().getEncodedName() + ":gds");
    addStoreNode(symbol_table, li_store_gjs, getName().getEncodedName() + ":gjs");
    addStoreNode(symbol_table, li_store_gjd, getName().getEncodedName() + ":gjd");
    addStoreNode(symbol_table, li_store_cdd, getName().getEncodedName() + ":cdd");
    addStoreNode(symbol_table, li_store_cdg, getName().getEncodedName() + ":cdg");
    addStoreNode(symbol_table, li_store_cds, getName().getEncodedName() + ":cds");
    addStoreNode(symbol_table, li_store_cdb, getName().getEncodedName() + ":cdb");
    addStoreNode(symbol_table, li_store_cgd, getName().getEncodedName() + ":cgd");
    addStoreNode(symbol_table, li_store_cgg, getName().getEncodedName() + ":cgg");
    addStoreNode(symbol_table, li_store_cgs, getName().getEncodedName() + ":cgs");
    addStoreNode(symbol_table, li_store_cgb, getName().getEncodedName() + ":cgb");
    addStoreNode(symbol_table, li_store_csd, getName().getEncodedName() + ":csd");
    addStoreNode(symbol_table, li_store_csg, getName().getEncodedName() + ":csg");
    addStoreNode(symbol_table, li_store_css, getName().getEncodedName() + ":css");
    addStoreNode(symbol_table, li_store_csb, getName().getEncodedName() + ":csb");
    addStoreNode(symbol_table, li_store_cbd, getName().getEncodedName() + ":cbd");
    addStoreNode(symbol_table, li_store_cbg, getName().getEncodedName() + ":cbg");
    addStoreNode(symbol_table, li_store_cbs, getName().getEncodedName() + ":cbs");
    addStoreNode(symbol_table, li_store_cbb, getName().getEncodedName() + ":cbb");
    addStoreNode(symbol_table, li_store_cgsol, getName().getEncodedName() + ":cgsol");
    addStoreNode(symbol_table, li_store_cgdol, getName().getEncodedName() + ":cgdol");
    addStoreNode(symbol_table, li_store_cjs, getName().getEncodedName() + ":cjs");
    addStoreNode(symbol_table, li_store_cjsbot, getName().getEncodedName() + ":cjsbot");
    addStoreNode(symbol_table, li_store_cjsgat, getName().getEncodedName() + ":cjsgat");
    addStoreNode(symbol_table, li_store_cjssti, getName().getEncodedName() + ":cjssti");
    addStoreNode(symbol_table, li_store_cjd, getName().getEncodedName() + ":cjd");
    addStoreNode(symbol_table, li_store_cjdbot, getName().getEncodedName() + ":cjdbot");
    addStoreNode(symbol_table, li_store_cjdgat, getName().getEncodedName() + ":cjdgat");
    addStoreNode(symbol_table, li_store_cjdsti, getName().getEncodedName() + ":cjdsti");
    addStoreNode(symbol_table, li_store_weff, getName().getEncodedName() + ":weff");
    addStoreNode(symbol_table, li_store_leff, getName().getEncodedName() + ":leff");
    addStoreNode(symbol_table, li_store_u, getName().getEncodedName() + ":u");
    addStoreNode(symbol_table, li_store_rout, getName().getEncodedName() + ":rout");
    addStoreNode(symbol_table, li_store_vearly, getName().getEncodedName() + ":vearly");
    addStoreNode(symbol_table, li_store_beff, getName().getEncodedName() + ":beff");
    addStoreNode(symbol_table, li_store_fug, getName().getEncodedName() + ":fug");
    addStoreNode(symbol_table, li_store_rg, getName().getEncodedName() + ":rg");
    addStoreNode(symbol_table, li_store_sfl, getName().getEncodedName() + ":sfl");
    addStoreNode(symbol_table, li_store_sqrtsff, getName().getEncodedName() + ":sqrtsff");
    addStoreNode(symbol_table, li_store_sqrtsfw, getName().getEncodedName() + ":sqrtsfw");
    addStoreNode(symbol_table, li_store_sid, getName().getEncodedName() + ":sid");
    addStoreNode(symbol_table, li_store_sig, getName().getEncodedName() + ":sig");
    addStoreNode(symbol_table, li_store_cigid, getName().getEncodedName() + ":cigid");
    addStoreNode(symbol_table, li_store_fknee, getName().getEncodedName() + ":fknee");
    addStoreNode(symbol_table, li_store_sigs, getName().getEncodedName() + ":sigs");
    addStoreNode(symbol_table, li_store_sigd, getName().getEncodedName() + ":sigd");
    addStoreNode(symbol_table, li_store_siavl, getName().getEncodedName() + ":siavl");
    addStoreNode(symbol_table, li_store_ssi, getName().getEncodedName() + ":ssi");
    addStoreNode(symbol_table, li_store_sdi, getName().getEncodedName() + ":sdi");
    addStoreNode(symbol_table, li_store_sfledge, getName().getEncodedName() + ":sfledge");
    addStoreNode(symbol_table, li_store_sidedge, getName().getEncodedName() + ":sidedge");
    addStoreNode(symbol_table, li_store_lp_vfb, getName().getEncodedName() + ":lp_vfb");
    addStoreNode(symbol_table, li_store_lp_stvfb, getName().getEncodedName() + ":lp_stvfb");
    addStoreNode(symbol_table, li_store_lp_tox, getName().getEncodedName() + ":lp_tox");
    addStoreNode(symbol_table, li_store_lp_epsrox, getName().getEncodedName() + ":lp_epsrox");
    addStoreNode(symbol_table, li_store_lp_neff, getName().getEncodedName() + ":lp_neff");
    addStoreNode(symbol_table, li_store_lp_facneffac, getName().getEncodedName() + ":lp_facneffac");
    addStoreNode(symbol_table, li_store_lp_gfacnud, getName().getEncodedName() + ":lp_gfacnud");
    addStoreNode(symbol_table, li_store_lp_vsbnud, getName().getEncodedName() + ":lp_vsbnud");
    addStoreNode(symbol_table, li_store_lp_dvsbnud, getName().getEncodedName() + ":lp_dvsbnud");
    addStoreNode(symbol_table, li_store_lp_vnsub, getName().getEncodedName() + ":lp_vnsub");
    addStoreNode(symbol_table, li_store_lp_nslp, getName().getEncodedName() + ":lp_nslp");
    addStoreNode(symbol_table, li_store_lp_dnsub, getName().getEncodedName() + ":lp_dnsub");
    addStoreNode(symbol_table, li_store_lp_dphib, getName().getEncodedName() + ":lp_dphib");
    addStoreNode(symbol_table, li_store_lp_delvtac, getName().getEncodedName() + ":lp_delvtac");
    addStoreNode(symbol_table, li_store_lp_np, getName().getEncodedName() + ":lp_np");
    addStoreNode(symbol_table, li_store_lp_ct, getName().getEncodedName() + ":lp_ct");
    addStoreNode(symbol_table, li_store_lp_toxov, getName().getEncodedName() + ":lp_toxov");
    addStoreNode(symbol_table, li_store_lp_toxovd, getName().getEncodedName() + ":lp_toxovd");
    addStoreNode(symbol_table, li_store_lp_nov, getName().getEncodedName() + ":lp_nov");
    addStoreNode(symbol_table, li_store_lp_novd, getName().getEncodedName() + ":lp_novd");
    addStoreNode(symbol_table, li_store_lp_cf, getName().getEncodedName() + ":lp_cf");
    addStoreNode(symbol_table, li_store_lp_cfd, getName().getEncodedName() + ":lp_cfd");
    addStoreNode(symbol_table, li_store_lp_cfb, getName().getEncodedName() + ":lp_cfb");
    addStoreNode(symbol_table, li_store_lp_psce, getName().getEncodedName() + ":lp_psce");
    addStoreNode(symbol_table, li_store_lp_psceb, getName().getEncodedName() + ":lp_psceb");
    addStoreNode(symbol_table, li_store_lp_psced, getName().getEncodedName() + ":lp_psced");
    addStoreNode(symbol_table, li_store_lp_betn, getName().getEncodedName() + ":lp_betn");
    addStoreNode(symbol_table, li_store_lp_stbet, getName().getEncodedName() + ":lp_stbet");
    addStoreNode(symbol_table, li_store_lp_mue, getName().getEncodedName() + ":lp_mue");
    addStoreNode(symbol_table, li_store_lp_stmue, getName().getEncodedName() + ":lp_stmue");
    addStoreNode(symbol_table, li_store_lp_themu, getName().getEncodedName() + ":lp_themu");
    addStoreNode(symbol_table, li_store_lp_stthemu, getName().getEncodedName() + ":lp_stthemu");
    addStoreNode(symbol_table, li_store_lp_cs, getName().getEncodedName() + ":lp_cs");
    addStoreNode(symbol_table, li_store_lp_stcs, getName().getEncodedName() + ":lp_stcs");
    addStoreNode(symbol_table, li_store_lp_xcor, getName().getEncodedName() + ":lp_xcor");
    addStoreNode(symbol_table, li_store_lp_stxcor, getName().getEncodedName() + ":lp_stxcor");
    addStoreNode(symbol_table, li_store_lp_feta, getName().getEncodedName() + ":lp_feta");
    addStoreNode(symbol_table, li_store_lp_rs, getName().getEncodedName() + ":lp_rs");
    addStoreNode(symbol_table, li_store_lp_strs, getName().getEncodedName() + ":lp_strs");
    addStoreNode(symbol_table, li_store_lp_rsb, getName().getEncodedName() + ":lp_rsb");
    addStoreNode(symbol_table, li_store_lp_rsg, getName().getEncodedName() + ":lp_rsg");
    addStoreNode(symbol_table, li_store_lp_thesat, getName().getEncodedName() + ":lp_thesat");
    addStoreNode(symbol_table, li_store_lp_stthesat, getName().getEncodedName() + ":lp_stthesat");
    addStoreNode(symbol_table, li_store_lp_thesatb, getName().getEncodedName() + ":lp_thesatb");
    addStoreNode(symbol_table, li_store_lp_thesatg, getName().getEncodedName() + ":lp_thesatg");
    addStoreNode(symbol_table, li_store_lp_ax, getName().getEncodedName() + ":lp_ax");
    addStoreNode(symbol_table, li_store_lp_alp, getName().getEncodedName() + ":lp_alp");
    addStoreNode(symbol_table, li_store_lp_alp1, getName().getEncodedName() + ":lp_alp1");
    addStoreNode(symbol_table, li_store_lp_alp2, getName().getEncodedName() + ":lp_alp2");
    addStoreNode(symbol_table, li_store_lp_vp, getName().getEncodedName() + ":lp_vp");
    addStoreNode(symbol_table, li_store_lp_a1, getName().getEncodedName() + ":lp_a1");
    addStoreNode(symbol_table, li_store_lp_a2, getName().getEncodedName() + ":lp_a2");
    addStoreNode(symbol_table, li_store_lp_sta2, getName().getEncodedName() + ":lp_sta2");
    addStoreNode(symbol_table, li_store_lp_a3, getName().getEncodedName() + ":lp_a3");
    addStoreNode(symbol_table, li_store_lp_a4, getName().getEncodedName() + ":lp_a4");
    addStoreNode(symbol_table, li_store_lp_gco, getName().getEncodedName() + ":lp_gco");
    addStoreNode(symbol_table, li_store_lp_iginv, getName().getEncodedName() + ":lp_iginv");
    addStoreNode(symbol_table, li_store_lp_igov, getName().getEncodedName() + ":lp_igov");
    addStoreNode(symbol_table, li_store_lp_igovd, getName().getEncodedName() + ":lp_igovd");
    addStoreNode(symbol_table, li_store_lp_stig, getName().getEncodedName() + ":lp_stig");
    addStoreNode(symbol_table, li_store_lp_gc2, getName().getEncodedName() + ":lp_gc2");
    addStoreNode(symbol_table, li_store_lp_gc3, getName().getEncodedName() + ":lp_gc3");
    addStoreNode(symbol_table, li_store_lp_chib, getName().getEncodedName() + ":lp_chib");
    addStoreNode(symbol_table, li_store_lp_agidl, getName().getEncodedName() + ":lp_agidl");
    addStoreNode(symbol_table, li_store_lp_agidld, getName().getEncodedName() + ":lp_agidld");
    addStoreNode(symbol_table, li_store_lp_bgidl, getName().getEncodedName() + ":lp_bgidl");
    addStoreNode(symbol_table, li_store_lp_bgidld, getName().getEncodedName() + ":lp_bgidld");
    addStoreNode(symbol_table, li_store_lp_stbgidl, getName().getEncodedName() + ":lp_stbgidl");
    addStoreNode(symbol_table, li_store_lp_stbgidld, getName().getEncodedName() + ":lp_stbgidld");
    addStoreNode(symbol_table, li_store_lp_cgidl, getName().getEncodedName() + ":lp_cgidl");
    addStoreNode(symbol_table, li_store_lp_cgidld, getName().getEncodedName() + ":lp_cgidld");
    addStoreNode(symbol_table, li_store_lp_cox, getName().getEncodedName() + ":lp_cox");
    addStoreNode(symbol_table, li_store_lp_cgov, getName().getEncodedName() + ":lp_cgov");
    addStoreNode(symbol_table, li_store_lp_cgovd, getName().getEncodedName() + ":lp_cgovd");
    addStoreNode(symbol_table, li_store_lp_cgbov, getName().getEncodedName() + ":lp_cgbov");
    addStoreNode(symbol_table, li_store_lp_cfr, getName().getEncodedName() + ":lp_cfr");
    addStoreNode(symbol_table, li_store_lp_cfrd, getName().getEncodedName() + ":lp_cfrd");
    addStoreNode(symbol_table, li_store_lp_fnt, getName().getEncodedName() + ":lp_fnt");
    addStoreNode(symbol_table, li_store_lp_fntexc, getName().getEncodedName() + ":lp_fntexc");
    addStoreNode(symbol_table, li_store_lp_nfa, getName().getEncodedName() + ":lp_nfa");
    addStoreNode(symbol_table, li_store_lp_nfb, getName().getEncodedName() + ":lp_nfb");
    addStoreNode(symbol_table, li_store_lp_nfc, getName().getEncodedName() + ":lp_nfc");
    addStoreNode(symbol_table, li_store_lp_ef, getName().getEncodedName() + ":lp_ef");
    addStoreNode(symbol_table, li_store_lp_vfbedge, getName().getEncodedName() + ":lp_vfbedge");
    addStoreNode(symbol_table, li_store_lp_stvfbedge, getName().getEncodedName() + ":lp_stvfbedge");
    addStoreNode(symbol_table, li_store_lp_dphibedge, getName().getEncodedName() + ":lp_dphibedge");
    addStoreNode(symbol_table, li_store_lp_neffedge, getName().getEncodedName() + ":lp_neffedge");
    addStoreNode(symbol_table, li_store_lp_ctedge, getName().getEncodedName() + ":lp_ctedge");
    addStoreNode(symbol_table, li_store_lp_betnedge, getName().getEncodedName() + ":lp_betnedge");
    addStoreNode(symbol_table, li_store_lp_stbetedge, getName().getEncodedName() + ":lp_stbetedge");
    addStoreNode(symbol_table, li_store_lp_psceedge, getName().getEncodedName() + ":lp_psceedge");
    addStoreNode(symbol_table, li_store_lp_pscebedge, getName().getEncodedName() + ":lp_pscebedge");
    addStoreNode(symbol_table, li_store_lp_pscededge, getName().getEncodedName() + ":lp_pscededge");
    addStoreNode(symbol_table, li_store_lp_cfedge, getName().getEncodedName() + ":lp_cfedge");
    addStoreNode(symbol_table, li_store_lp_cfdedge, getName().getEncodedName() + ":lp_cfdedge");
    addStoreNode(symbol_table, li_store_lp_cfbedge, getName().getEncodedName() + ":lp_cfbedge");
    addStoreNode(symbol_table, li_store_lp_fntedge, getName().getEncodedName() + ":lp_fntedge");
    addStoreNode(symbol_table, li_store_lp_nfaedge, getName().getEncodedName() + ":lp_nfaedge");
    addStoreNode(symbol_table, li_store_lp_nfbedge, getName().getEncodedName() + ":lp_nfbedge");
    addStoreNode(symbol_table, li_store_lp_nfcedge, getName().getEncodedName() + ":lp_nfcedge");
    addStoreNode(symbol_table, li_store_lp_efedge, getName().getEncodedName() + ":lp_efedge");
    addStoreNode(symbol_table, li_store_lp_rg, getName().getEncodedName() + ":lp_rg");
    addStoreNode(symbol_table, li_store_lp_rse, getName().getEncodedName() + ":lp_rse");
    addStoreNode(symbol_table, li_store_lp_rde, getName().getEncodedName() + ":lp_rde");
    addStoreNode(symbol_table, li_store_lp_rbulk, getName().getEncodedName() + ":lp_rbulk");
    addStoreNode(symbol_table, li_store_lp_rwell, getName().getEncodedName() + ":lp_rwell");
    addStoreNode(symbol_table, li_store_lp_rjuns, getName().getEncodedName() + ":lp_rjuns");
    addStoreNode(symbol_table, li_store_lp_rjund, getName().getEncodedName() + ":lp_rjund");
    addStoreNode(symbol_table, li_store_tk, getName().getEncodedName() + ":tk");
    addStoreNode(symbol_table, li_store_cjosbot, getName().getEncodedName() + ":cjosbot");
    addStoreNode(symbol_table, li_store_cjossti, getName().getEncodedName() + ":cjossti");
    addStoreNode(symbol_table, li_store_cjosgat, getName().getEncodedName() + ":cjosgat");
    addStoreNode(symbol_table, li_store_vbisbot, getName().getEncodedName() + ":vbisbot");
    addStoreNode(symbol_table, li_store_vbissti, getName().getEncodedName() + ":vbissti");
    addStoreNode(symbol_table, li_store_vbisgat, getName().getEncodedName() + ":vbisgat");
    addStoreNode(symbol_table, li_store_idsatsbot, getName().getEncodedName() + ":idsatsbot");
    addStoreNode(symbol_table, li_store_idsatssti, getName().getEncodedName() + ":idsatssti");
    addStoreNode(symbol_table, li_store_idsatsgat, getName().getEncodedName() + ":idsatsgat");
    addStoreNode(symbol_table, li_store_cjosbotd, getName().getEncodedName() + ":cjosbotd");
    addStoreNode(symbol_table, li_store_cjosstid, getName().getEncodedName() + ":cjosstid");
    addStoreNode(symbol_table, li_store_cjosgatd, getName().getEncodedName() + ":cjosgatd");
    addStoreNode(symbol_table, li_store_vbisbotd, getName().getEncodedName() + ":vbisbotd");
    addStoreNode(symbol_table, li_store_vbisstid, getName().getEncodedName() + ":vbisstid");
    addStoreNode(symbol_table, li_store_vbisgatd, getName().getEncodedName() + ":vbisgatd");
    addStoreNode(symbol_table, li_store_idsatsbotd, getName().getEncodedName() + ":idsatsbotd");
    addStoreNode(symbol_table, li_store_idsatsstid, getName().getEncodedName() + ":idsatsstid");
    addStoreNode(symbol_table, li_store_idsatsgatd, getName().getEncodedName() + ":idsatsgatd");

  if (loadLeadCurrent)
  {
    addBranchDataNode( symbol_table, li_branch_iD, getName(), "BRANCH_DD");
    addBranchDataNode( symbol_table, li_branch_iG, getName(), "BRANCH_DG");
    addBranchDataNode( symbol_table, li_branch_iS, getName(), "BRANCH_DS");
    addBranchDataNode( symbol_table, li_branch_iB, getName(), "BRANCH_D4");


  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerStoreLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerStoreLIDs( const LocalIdVector & stoLIDVecRef)
{
  AssertLIDs(stoLIDVecRef.size() == getNumStoreVars());

  int numSto = stoLIDVecRef.size();
  if (numSto > 0)
  {
    int i=0;
    stoLIDVec = stoLIDVecRef;

      li_store_ctype= stoLIDVec[i++];
      li_store_sdint= stoLIDVec[i++];
      li_store_ise= stoLIDVec[i++];
      li_store_ige= stoLIDVec[i++];
      li_store_ide= stoLIDVec[i++];
      li_store_ibe= stoLIDVec[i++];
      li_store_ids= stoLIDVec[i++];
      li_store_idb= stoLIDVec[i++];
      li_store_isb= stoLIDVec[i++];
      li_store_igs= stoLIDVec[i++];
      li_store_igd= stoLIDVec[i++];
      li_store_igb= stoLIDVec[i++];
      li_store_idedge= stoLIDVec[i++];
      li_store_igcs= stoLIDVec[i++];
      li_store_igcd= stoLIDVec[i++];
      li_store_iavl= stoLIDVec[i++];
      li_store_igisl= stoLIDVec[i++];
      li_store_igidl= stoLIDVec[i++];
      li_store_ijs= stoLIDVec[i++];
      li_store_ijsbot= stoLIDVec[i++];
      li_store_ijsgat= stoLIDVec[i++];
      li_store_ijssti= stoLIDVec[i++];
      li_store_ijd= stoLIDVec[i++];
      li_store_ijdbot= stoLIDVec[i++];
      li_store_ijdgat= stoLIDVec[i++];
      li_store_ijdsti= stoLIDVec[i++];
      li_store_vds= stoLIDVec[i++];
      li_store_vgs= stoLIDVec[i++];
      li_store_vsb= stoLIDVec[i++];
      li_store_vto= stoLIDVec[i++];
      li_store_vts= stoLIDVec[i++];
      li_store_vth= stoLIDVec[i++];
      li_store_vgt= stoLIDVec[i++];
      li_store_vdss= stoLIDVec[i++];
      li_store_vsat= stoLIDVec[i++];
      li_store_gm= stoLIDVec[i++];
      li_store_gmb= stoLIDVec[i++];
      li_store_gds= stoLIDVec[i++];
      li_store_gjs= stoLIDVec[i++];
      li_store_gjd= stoLIDVec[i++];
      li_store_cdd= stoLIDVec[i++];
      li_store_cdg= stoLIDVec[i++];
      li_store_cds= stoLIDVec[i++];
      li_store_cdb= stoLIDVec[i++];
      li_store_cgd= stoLIDVec[i++];
      li_store_cgg= stoLIDVec[i++];
      li_store_cgs= stoLIDVec[i++];
      li_store_cgb= stoLIDVec[i++];
      li_store_csd= stoLIDVec[i++];
      li_store_csg= stoLIDVec[i++];
      li_store_css= stoLIDVec[i++];
      li_store_csb= stoLIDVec[i++];
      li_store_cbd= stoLIDVec[i++];
      li_store_cbg= stoLIDVec[i++];
      li_store_cbs= stoLIDVec[i++];
      li_store_cbb= stoLIDVec[i++];
      li_store_cgsol= stoLIDVec[i++];
      li_store_cgdol= stoLIDVec[i++];
      li_store_cjs= stoLIDVec[i++];
      li_store_cjsbot= stoLIDVec[i++];
      li_store_cjsgat= stoLIDVec[i++];
      li_store_cjssti= stoLIDVec[i++];
      li_store_cjd= stoLIDVec[i++];
      li_store_cjdbot= stoLIDVec[i++];
      li_store_cjdgat= stoLIDVec[i++];
      li_store_cjdsti= stoLIDVec[i++];
      li_store_weff= stoLIDVec[i++];
      li_store_leff= stoLIDVec[i++];
      li_store_u= stoLIDVec[i++];
      li_store_rout= stoLIDVec[i++];
      li_store_vearly= stoLIDVec[i++];
      li_store_beff= stoLIDVec[i++];
      li_store_fug= stoLIDVec[i++];
      li_store_rg= stoLIDVec[i++];
      li_store_sfl= stoLIDVec[i++];
      li_store_sqrtsff= stoLIDVec[i++];
      li_store_sqrtsfw= stoLIDVec[i++];
      li_store_sid= stoLIDVec[i++];
      li_store_sig= stoLIDVec[i++];
      li_store_cigid= stoLIDVec[i++];
      li_store_fknee= stoLIDVec[i++];
      li_store_sigs= stoLIDVec[i++];
      li_store_sigd= stoLIDVec[i++];
      li_store_siavl= stoLIDVec[i++];
      li_store_ssi= stoLIDVec[i++];
      li_store_sdi= stoLIDVec[i++];
      li_store_sfledge= stoLIDVec[i++];
      li_store_sidedge= stoLIDVec[i++];
      li_store_lp_vfb= stoLIDVec[i++];
      li_store_lp_stvfb= stoLIDVec[i++];
      li_store_lp_tox= stoLIDVec[i++];
      li_store_lp_epsrox= stoLIDVec[i++];
      li_store_lp_neff= stoLIDVec[i++];
      li_store_lp_facneffac= stoLIDVec[i++];
      li_store_lp_gfacnud= stoLIDVec[i++];
      li_store_lp_vsbnud= stoLIDVec[i++];
      li_store_lp_dvsbnud= stoLIDVec[i++];
      li_store_lp_vnsub= stoLIDVec[i++];
      li_store_lp_nslp= stoLIDVec[i++];
      li_store_lp_dnsub= stoLIDVec[i++];
      li_store_lp_dphib= stoLIDVec[i++];
      li_store_lp_delvtac= stoLIDVec[i++];
      li_store_lp_np= stoLIDVec[i++];
      li_store_lp_ct= stoLIDVec[i++];
      li_store_lp_toxov= stoLIDVec[i++];
      li_store_lp_toxovd= stoLIDVec[i++];
      li_store_lp_nov= stoLIDVec[i++];
      li_store_lp_novd= stoLIDVec[i++];
      li_store_lp_cf= stoLIDVec[i++];
      li_store_lp_cfd= stoLIDVec[i++];
      li_store_lp_cfb= stoLIDVec[i++];
      li_store_lp_psce= stoLIDVec[i++];
      li_store_lp_psceb= stoLIDVec[i++];
      li_store_lp_psced= stoLIDVec[i++];
      li_store_lp_betn= stoLIDVec[i++];
      li_store_lp_stbet= stoLIDVec[i++];
      li_store_lp_mue= stoLIDVec[i++];
      li_store_lp_stmue= stoLIDVec[i++];
      li_store_lp_themu= stoLIDVec[i++];
      li_store_lp_stthemu= stoLIDVec[i++];
      li_store_lp_cs= stoLIDVec[i++];
      li_store_lp_stcs= stoLIDVec[i++];
      li_store_lp_xcor= stoLIDVec[i++];
      li_store_lp_stxcor= stoLIDVec[i++];
      li_store_lp_feta= stoLIDVec[i++];
      li_store_lp_rs= stoLIDVec[i++];
      li_store_lp_strs= stoLIDVec[i++];
      li_store_lp_rsb= stoLIDVec[i++];
      li_store_lp_rsg= stoLIDVec[i++];
      li_store_lp_thesat= stoLIDVec[i++];
      li_store_lp_stthesat= stoLIDVec[i++];
      li_store_lp_thesatb= stoLIDVec[i++];
      li_store_lp_thesatg= stoLIDVec[i++];
      li_store_lp_ax= stoLIDVec[i++];
      li_store_lp_alp= stoLIDVec[i++];
      li_store_lp_alp1= stoLIDVec[i++];
      li_store_lp_alp2= stoLIDVec[i++];
      li_store_lp_vp= stoLIDVec[i++];
      li_store_lp_a1= stoLIDVec[i++];
      li_store_lp_a2= stoLIDVec[i++];
      li_store_lp_sta2= stoLIDVec[i++];
      li_store_lp_a3= stoLIDVec[i++];
      li_store_lp_a4= stoLIDVec[i++];
      li_store_lp_gco= stoLIDVec[i++];
      li_store_lp_iginv= stoLIDVec[i++];
      li_store_lp_igov= stoLIDVec[i++];
      li_store_lp_igovd= stoLIDVec[i++];
      li_store_lp_stig= stoLIDVec[i++];
      li_store_lp_gc2= stoLIDVec[i++];
      li_store_lp_gc3= stoLIDVec[i++];
      li_store_lp_chib= stoLIDVec[i++];
      li_store_lp_agidl= stoLIDVec[i++];
      li_store_lp_agidld= stoLIDVec[i++];
      li_store_lp_bgidl= stoLIDVec[i++];
      li_store_lp_bgidld= stoLIDVec[i++];
      li_store_lp_stbgidl= stoLIDVec[i++];
      li_store_lp_stbgidld= stoLIDVec[i++];
      li_store_lp_cgidl= stoLIDVec[i++];
      li_store_lp_cgidld= stoLIDVec[i++];
      li_store_lp_cox= stoLIDVec[i++];
      li_store_lp_cgov= stoLIDVec[i++];
      li_store_lp_cgovd= stoLIDVec[i++];
      li_store_lp_cgbov= stoLIDVec[i++];
      li_store_lp_cfr= stoLIDVec[i++];
      li_store_lp_cfrd= stoLIDVec[i++];
      li_store_lp_fnt= stoLIDVec[i++];
      li_store_lp_fntexc= stoLIDVec[i++];
      li_store_lp_nfa= stoLIDVec[i++];
      li_store_lp_nfb= stoLIDVec[i++];
      li_store_lp_nfc= stoLIDVec[i++];
      li_store_lp_ef= stoLIDVec[i++];
      li_store_lp_vfbedge= stoLIDVec[i++];
      li_store_lp_stvfbedge= stoLIDVec[i++];
      li_store_lp_dphibedge= stoLIDVec[i++];
      li_store_lp_neffedge= stoLIDVec[i++];
      li_store_lp_ctedge= stoLIDVec[i++];
      li_store_lp_betnedge= stoLIDVec[i++];
      li_store_lp_stbetedge= stoLIDVec[i++];
      li_store_lp_psceedge= stoLIDVec[i++];
      li_store_lp_pscebedge= stoLIDVec[i++];
      li_store_lp_pscededge= stoLIDVec[i++];
      li_store_lp_cfedge= stoLIDVec[i++];
      li_store_lp_cfdedge= stoLIDVec[i++];
      li_store_lp_cfbedge= stoLIDVec[i++];
      li_store_lp_fntedge= stoLIDVec[i++];
      li_store_lp_nfaedge= stoLIDVec[i++];
      li_store_lp_nfbedge= stoLIDVec[i++];
      li_store_lp_nfcedge= stoLIDVec[i++];
      li_store_lp_efedge= stoLIDVec[i++];
      li_store_lp_rg= stoLIDVec[i++];
      li_store_lp_rse= stoLIDVec[i++];
      li_store_lp_rde= stoLIDVec[i++];
      li_store_lp_rbulk= stoLIDVec[i++];
      li_store_lp_rwell= stoLIDVec[i++];
      li_store_lp_rjuns= stoLIDVec[i++];
      li_store_lp_rjund= stoLIDVec[i++];
      li_store_tk= stoLIDVec[i++];
      li_store_cjosbot= stoLIDVec[i++];
      li_store_cjossti= stoLIDVec[i++];
      li_store_cjosgat= stoLIDVec[i++];
      li_store_vbisbot= stoLIDVec[i++];
      li_store_vbissti= stoLIDVec[i++];
      li_store_vbisgat= stoLIDVec[i++];
      li_store_idsatsbot= stoLIDVec[i++];
      li_store_idsatssti= stoLIDVec[i++];
      li_store_idsatsgat= stoLIDVec[i++];
      li_store_cjosbotd= stoLIDVec[i++];
      li_store_cjosstid= stoLIDVec[i++];
      li_store_cjosgatd= stoLIDVec[i++];
      li_store_vbisbotd= stoLIDVec[i++];
      li_store_vbisstid= stoLIDVec[i++];
      li_store_vbisgatd= stoLIDVec[i++];
      li_store_idsatsbotd= stoLIDVec[i++];
      li_store_idsatsstid= stoLIDVec[i++];
      li_store_idsatsgatd= stoLIDVec[i++];
  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerBranchDataLIDs
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : Eric Keiter, SNL
// Creation Date : 12/09/11
//-----------------------------------------------------------------------------
void Instance::registerBranchDataLIDs(const std::vector<int> & branchLIDVecRef)
{
  AssertLIDs(branchLIDVecRef.size() == getNumBranchDataVars());

  if (loadLeadCurrent)
  {
    int i = 0;
    li_branch_iD = branchLIDVecRef[i++];
    li_branch_iG = branchLIDVecRef[i++];
    li_branch_iS = branchLIDVecRef[i++];
    li_branch_iB = branchLIDVecRef[i++];

  }
}

//-----------------------------------------------------------------------------
// Function      : Instance::jacobianStamp
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
const JacobianStamp & Instance::jacobianStamp() const
{
    return jacStamp;
}

//-----------------------------------------------------------------------------
// Function      : Instance::registerJacLIDs
// Purpose       : Create Offset variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::registerJacLIDs( const JacobianStamp & jacLIDVec)
{
  DeviceInstance::registerJacLIDs(jacLIDVec);  IntPair jacLoc;
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_D)];
    A_D_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_D,admsNodeID_DI)];
    A_D_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_G)];
    A_G_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_G,admsNodeID_GP)];
    A_G_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_S)];
    A_S_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_S,admsNodeID_SI)];
    A_S_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_B)];
    A_B_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_B,admsNodeID_BI)];
    A_B_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_SI)];
    A_NOI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_BP)];
    A_NOI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_GP)];
    A_NOI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_DI)];
    A_NOI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI2)];
    A_NOI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI,admsNodeID_NOI)];
    A_NOI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_NOI2)];
    A_NOI2_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_GP)];
    A_NOI2_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_SI)];
    A_NOI2_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_BP)];
    A_NOI2_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_NOI2,admsNodeID_DI)];
    A_NOI2_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_SI)];
    A_GP_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_BP)];
    A_GP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_DI)];
    A_GP_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_GP)];
    A_GP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_G)];
    A_GP_Equ_G_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_GP,admsNodeID_NOI)];
    A_GP_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_SI)];
    A_SI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BP)];
    A_SI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_GP)];
    A_SI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_DI)];
    A_SI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BS)];
    A_SI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_BD)];
    A_SI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_S)];
    A_SI_Equ_S_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_NOI)];
    A_SI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_SI,admsNodeID_NOI2)];
    A_SI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_SI)];
    A_DI_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BP)];
    A_DI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_GP)];
    A_DI_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_DI)];
    A_DI_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BS)];
    A_DI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_BD)];
    A_DI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_D)];
    A_DI_Equ_D_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_NOI)];
    A_DI_Equ_NOI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_DI,admsNodeID_NOI2)];
    A_DI_Equ_NOI2_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_SI)];
    A_BP_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BP)];
    A_BP_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_GP)];
    A_BP_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_DI)];
    A_BP_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BP,admsNodeID_BI)];
    A_BP_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BP)];
    A_BI_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BI)];
    A_BI_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BS)];
    A_BI_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_BD)];
    A_BI_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BI,admsNodeID_B)];
    A_BI_Equ_B_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_SI)];
    A_BS_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BS)];
    A_BS_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_DI)];
    A_BS_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BD)];
    A_BS_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BI)];
    A_BS_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_BP)];
    A_BS_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BS,admsNodeID_GP)];
    A_BS_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_SI)];
    A_BD_Equ_SI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BS)];
    A_BD_Equ_BS_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_DI)];
    A_BD_Equ_DI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BD)];
    A_BD_Equ_BD_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BI)];
    A_BD_Equ_BI_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_BP)];
    A_BD_Equ_BP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];
    jacLoc = pairToJacStampMap[IntPair(admsNodeID_BD,admsNodeID_GP)];
    A_BD_Equ_GP_NodeOffset = jacLIDVec[jacLoc.first][jacLoc.second];


}

//-----------------------------------------------------------------------------
// Function      : Instance::setupPointers
// Purpose       : Create pointer variables used for referencing jacobian
//                 elements
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupPointers( )
{

  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);
    f_D_Equ_D_Node_Ptr = &(dFdx[li_D][A_D_Equ_D_NodeOffset]);
    q_D_Equ_D_Node_Ptr = &(dQdx[li_D][A_D_Equ_D_NodeOffset]);
    f_D_Equ_DI_Node_Ptr = &(dFdx[li_D][A_D_Equ_DI_NodeOffset]);
    q_D_Equ_DI_Node_Ptr = &(dQdx[li_D][A_D_Equ_DI_NodeOffset]);
    f_G_Equ_G_Node_Ptr = &(dFdx[li_G][A_G_Equ_G_NodeOffset]);
    q_G_Equ_G_Node_Ptr = &(dQdx[li_G][A_G_Equ_G_NodeOffset]);
    f_G_Equ_GP_Node_Ptr = &(dFdx[li_G][A_G_Equ_GP_NodeOffset]);
    q_G_Equ_GP_Node_Ptr = &(dQdx[li_G][A_G_Equ_GP_NodeOffset]);
    f_S_Equ_S_Node_Ptr = &(dFdx[li_S][A_S_Equ_S_NodeOffset]);
    q_S_Equ_S_Node_Ptr = &(dQdx[li_S][A_S_Equ_S_NodeOffset]);
    f_S_Equ_SI_Node_Ptr = &(dFdx[li_S][A_S_Equ_SI_NodeOffset]);
    q_S_Equ_SI_Node_Ptr = &(dQdx[li_S][A_S_Equ_SI_NodeOffset]);
    f_B_Equ_B_Node_Ptr = &(dFdx[li_B][A_B_Equ_B_NodeOffset]);
    q_B_Equ_B_Node_Ptr = &(dQdx[li_B][A_B_Equ_B_NodeOffset]);
    f_B_Equ_BI_Node_Ptr = &(dFdx[li_B][A_B_Equ_BI_NodeOffset]);
    q_B_Equ_BI_Node_Ptr = &(dQdx[li_B][A_B_Equ_BI_NodeOffset]);
    f_NOI_Equ_SI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_SI_NodeOffset]);
    q_NOI_Equ_SI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_SI_NodeOffset]);
    f_NOI_Equ_BP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
    q_NOI_Equ_BP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset]);
    f_NOI_Equ_GP_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
    q_NOI_Equ_GP_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset]);
    f_NOI_Equ_DI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_DI_NodeOffset]);
    q_NOI_Equ_DI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_DI_NodeOffset]);
    f_NOI_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
    q_NOI_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset]);
    f_NOI_Equ_NOI_Node_Ptr = &(dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
    q_NOI_Equ_NOI_Node_Ptr = &(dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset]);
    f_NOI2_Equ_NOI2_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
    q_NOI2_Equ_NOI2_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset]);
    f_NOI2_Equ_GP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
    q_NOI2_Equ_GP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset]);
    f_NOI2_Equ_SI_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset]);
    q_NOI2_Equ_SI_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset]);
    f_NOI2_Equ_BP_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
    q_NOI2_Equ_BP_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset]);
    f_NOI2_Equ_DI_Node_Ptr = &(dFdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset]);
    q_NOI2_Equ_DI_Node_Ptr = &(dQdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset]);
    f_GP_Equ_SI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_SI_NodeOffset]);
    q_GP_Equ_SI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_SI_NodeOffset]);
    f_GP_Equ_BP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_BP_NodeOffset]);
    q_GP_Equ_BP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_BP_NodeOffset]);
    f_GP_Equ_DI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_DI_NodeOffset]);
    q_GP_Equ_DI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_DI_NodeOffset]);
    f_GP_Equ_GP_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_GP_NodeOffset]);
    q_GP_Equ_GP_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_GP_NodeOffset]);
    f_GP_Equ_G_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_G_NodeOffset]);
    q_GP_Equ_G_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_G_NodeOffset]);
    f_GP_Equ_NOI_Node_Ptr = &(dFdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
    q_GP_Equ_NOI_Node_Ptr = &(dQdx[li_GP][A_GP_Equ_NOI_NodeOffset]);
    f_SI_Equ_SI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_SI_NodeOffset]);
    q_SI_Equ_SI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_SI_NodeOffset]);
    f_SI_Equ_BP_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BP_NodeOffset]);
    q_SI_Equ_BP_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BP_NodeOffset]);
    f_SI_Equ_GP_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_GP_NodeOffset]);
    q_SI_Equ_GP_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_GP_NodeOffset]);
    f_SI_Equ_DI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_DI_NodeOffset]);
    q_SI_Equ_DI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_DI_NodeOffset]);
    f_SI_Equ_BS_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BS_NodeOffset]);
    q_SI_Equ_BS_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BS_NodeOffset]);
    f_SI_Equ_BD_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_BD_NodeOffset]);
    q_SI_Equ_BD_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_BD_NodeOffset]);
    f_SI_Equ_S_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_S_NodeOffset]);
    q_SI_Equ_S_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_S_NodeOffset]);
    f_SI_Equ_NOI_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_NOI_NodeOffset]);
    q_SI_Equ_NOI_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_NOI_NodeOffset]);
    f_SI_Equ_NOI2_Node_Ptr = &(dFdx[li_SI][A_SI_Equ_NOI2_NodeOffset]);
    q_SI_Equ_NOI2_Node_Ptr = &(dQdx[li_SI][A_SI_Equ_NOI2_NodeOffset]);
    f_DI_Equ_SI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_SI_NodeOffset]);
    q_DI_Equ_SI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_SI_NodeOffset]);
    f_DI_Equ_BP_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BP_NodeOffset]);
    q_DI_Equ_BP_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BP_NodeOffset]);
    f_DI_Equ_GP_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_GP_NodeOffset]);
    q_DI_Equ_GP_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_GP_NodeOffset]);
    f_DI_Equ_DI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_DI_NodeOffset]);
    q_DI_Equ_DI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_DI_NodeOffset]);
    f_DI_Equ_BS_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BS_NodeOffset]);
    q_DI_Equ_BS_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BS_NodeOffset]);
    f_DI_Equ_BD_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_BD_NodeOffset]);
    q_DI_Equ_BD_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_BD_NodeOffset]);
    f_DI_Equ_D_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_D_NodeOffset]);
    q_DI_Equ_D_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_D_NodeOffset]);
    f_DI_Equ_NOI_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_NOI_NodeOffset]);
    q_DI_Equ_NOI_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_NOI_NodeOffset]);
    f_DI_Equ_NOI2_Node_Ptr = &(dFdx[li_DI][A_DI_Equ_NOI2_NodeOffset]);
    q_DI_Equ_NOI2_Node_Ptr = &(dQdx[li_DI][A_DI_Equ_NOI2_NodeOffset]);
    f_BP_Equ_SI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_SI_NodeOffset]);
    q_BP_Equ_SI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_SI_NodeOffset]);
    f_BP_Equ_BP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BP_NodeOffset]);
    q_BP_Equ_BP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BP_NodeOffset]);
    f_BP_Equ_GP_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_GP_NodeOffset]);
    q_BP_Equ_GP_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_GP_NodeOffset]);
    f_BP_Equ_DI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_DI_NodeOffset]);
    q_BP_Equ_DI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_DI_NodeOffset]);
    f_BP_Equ_BI_Node_Ptr = &(dFdx[li_BP][A_BP_Equ_BI_NodeOffset]);
    q_BP_Equ_BI_Node_Ptr = &(dQdx[li_BP][A_BP_Equ_BI_NodeOffset]);
    f_BI_Equ_BP_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BP_NodeOffset]);
    q_BI_Equ_BP_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BP_NodeOffset]);
    f_BI_Equ_BI_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BI_NodeOffset]);
    q_BI_Equ_BI_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BI_NodeOffset]);
    f_BI_Equ_BS_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BS_NodeOffset]);
    q_BI_Equ_BS_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BS_NodeOffset]);
    f_BI_Equ_BD_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_BD_NodeOffset]);
    q_BI_Equ_BD_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_BD_NodeOffset]);
    f_BI_Equ_B_Node_Ptr = &(dFdx[li_BI][A_BI_Equ_B_NodeOffset]);
    q_BI_Equ_B_Node_Ptr = &(dQdx[li_BI][A_BI_Equ_B_NodeOffset]);
    f_BS_Equ_SI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_SI_NodeOffset]);
    q_BS_Equ_SI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_SI_NodeOffset]);
    f_BS_Equ_BS_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BS_NodeOffset]);
    q_BS_Equ_BS_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BS_NodeOffset]);
    f_BS_Equ_DI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_DI_NodeOffset]);
    q_BS_Equ_DI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_DI_NodeOffset]);
    f_BS_Equ_BD_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BD_NodeOffset]);
    q_BS_Equ_BD_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BD_NodeOffset]);
    f_BS_Equ_BI_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BI_NodeOffset]);
    q_BS_Equ_BI_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BI_NodeOffset]);
    f_BS_Equ_BP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_BP_NodeOffset]);
    q_BS_Equ_BP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_BP_NodeOffset]);
    f_BS_Equ_GP_Node_Ptr = &(dFdx[li_BS][A_BS_Equ_GP_NodeOffset]);
    q_BS_Equ_GP_Node_Ptr = &(dQdx[li_BS][A_BS_Equ_GP_NodeOffset]);
    f_BD_Equ_SI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_SI_NodeOffset]);
    q_BD_Equ_SI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_SI_NodeOffset]);
    f_BD_Equ_BS_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BS_NodeOffset]);
    q_BD_Equ_BS_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BS_NodeOffset]);
    f_BD_Equ_DI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_DI_NodeOffset]);
    q_BD_Equ_DI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_DI_NodeOffset]);
    f_BD_Equ_BD_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BD_NodeOffset]);
    q_BD_Equ_BD_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BD_NodeOffset]);
    f_BD_Equ_BI_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BI_NodeOffset]);
    q_BD_Equ_BI_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BI_NodeOffset]);
    f_BD_Equ_BP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_BP_NodeOffset]);
    q_BD_Equ_BP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_BP_NodeOffset]);
    f_BD_Equ_GP_Node_Ptr = &(dFdx[li_BD][A_BD_Equ_GP_NodeOffset]);
    q_BD_Equ_GP_Node_Ptr = &(dQdx[li_BD][A_BD_Equ_GP_NodeOffset]);


}

// RHS load functions

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEFVector
// Purpose       : load F vector (static contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEFVector()
{

  bool bsuccess=true;
(*extData.daeFVectorPtr)[li_D] += staticContributions[admsNodeID_D];
(*extData.daeFVectorPtr)[li_G] += staticContributions[admsNodeID_G];
(*extData.daeFVectorPtr)[li_S] += staticContributions[admsNodeID_S];
(*extData.daeFVectorPtr)[li_B] += staticContributions[admsNodeID_B];
(*extData.daeFVectorPtr)[li_NOI] += staticContributions[admsNodeID_NOI];
(*extData.daeFVectorPtr)[li_NOI2] += staticContributions[admsNodeID_NOI2];
(*extData.daeFVectorPtr)[li_GP] += staticContributions[admsNodeID_GP];
(*extData.daeFVectorPtr)[li_SI] += staticContributions[admsNodeID_SI];
(*extData.daeFVectorPtr)[li_DI] += staticContributions[admsNodeID_DI];
(*extData.daeFVectorPtr)[li_BP] += staticContributions[admsNodeID_BP];
(*extData.daeFVectorPtr)[li_BI] += staticContributions[admsNodeID_BI];
(*extData.daeFVectorPtr)[li_BS] += staticContributions[admsNodeID_BS];
(*extData.daeFVectorPtr)[li_BD] += staticContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadF = extData.nextLeadCurrFCompRawPtr;
    leadF[li_branch_iD] = leadCurrentF[admsNodeID_D];
    leadF[li_branch_iG] = leadCurrentF[admsNodeID_G];
    leadF[li_branch_iS] = leadCurrentF[admsNodeID_S];
    leadF[li_branch_iB] = leadCurrentF[admsNodeID_B];



    // here we have to do special things for BJTs, MOSFETs and 2-terminal
    // devices for power computation.

        double * solVec = extData.nextSolVectorRawPtr;
        double * junctionV = extData.nextJunctionVCompRawPtr;
        junctionV[li_branch_iD] = solVec[li_D] - solVec[li_S];
        junctionV[li_branch_iG] = solVec[li_G] - solVec[li_S];

  }
  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEQVector
// Purpose       : load Q vector (dynamic contributions) for one instance for
//                 NEW DAE formulation
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEQVector()
{
(*extData.daeQVectorPtr)[li_D] += dynamicContributions[admsNodeID_D];
(*extData.daeQVectorPtr)[li_G] += dynamicContributions[admsNodeID_G];
(*extData.daeQVectorPtr)[li_S] += dynamicContributions[admsNodeID_S];
(*extData.daeQVectorPtr)[li_B] += dynamicContributions[admsNodeID_B];
(*extData.daeQVectorPtr)[li_NOI] += dynamicContributions[admsNodeID_NOI];
(*extData.daeQVectorPtr)[li_NOI2] += dynamicContributions[admsNodeID_NOI2];
(*extData.daeQVectorPtr)[li_GP] += dynamicContributions[admsNodeID_GP];
(*extData.daeQVectorPtr)[li_SI] += dynamicContributions[admsNodeID_SI];
(*extData.daeQVectorPtr)[li_DI] += dynamicContributions[admsNodeID_DI];
(*extData.daeQVectorPtr)[li_BP] += dynamicContributions[admsNodeID_BP];
(*extData.daeQVectorPtr)[li_BI] += dynamicContributions[admsNodeID_BI];
(*extData.daeQVectorPtr)[li_BS] += dynamicContributions[admsNodeID_BS];
(*extData.daeQVectorPtr)[li_BD] += dynamicContributions[admsNodeID_BD];


  if (loadLeadCurrent)
  {
    double * leadQ = extData.nextLeadCurrQCompRawPtr;
    leadQ[li_branch_iD] = leadCurrentQ[admsNodeID_D];
    leadQ[li_branch_iG] = leadCurrentQ[admsNodeID_G];
    leadQ[li_branch_iS] = leadCurrentQ[admsNodeID_S];
    leadQ[li_branch_iB] = leadCurrentQ[admsNodeID_B];


  }
  return true;
}


//-----------------------------------------------------------------------------
// Function      : Instance::updatePrimaryState
// Purpose       :
// Special Notes : In this initial implementation, does little more than
//                 call updateIntermediateVars()
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updatePrimaryState()
{
  bool bsuccess = true;

  bsuccess = updateIntermediateVars();

  // if old DAE were implemented, we'd save dynamic contributions as state
  // here.

  double * stoVec = extData.nextStoVectorRawPtr;
  // Also need to save limited voltage drops and output vars
  // This formulation assumes that we have *always* written the
  // limited voltages back into the probeVars[] array.

  stoVec[li_store_ctype] = ctype;
  stoVec[li_store_sdint] = sdint;
  stoVec[li_store_ise] = ise;
  stoVec[li_store_ige] = ige;
  stoVec[li_store_ide] = ide;
  stoVec[li_store_ibe] = ibe;
  stoVec[li_store_ids] = ids;
  stoVec[li_store_idb] = idb;
  stoVec[li_store_isb] = isb;
  stoVec[li_store_igs] = igs;
  stoVec[li_store_igd] = igd;
  stoVec[li_store_igb] = igb;
  stoVec[li_store_idedge] = idedge;
  stoVec[li_store_igcs] = igcs;
  stoVec[li_store_igcd] = igcd;
  stoVec[li_store_iavl] = iavl;
  stoVec[li_store_igisl] = igisl;
  stoVec[li_store_igidl] = igidl;
  stoVec[li_store_ijs] = ijs;
  stoVec[li_store_ijsbot] = ijsbot;
  stoVec[li_store_ijsgat] = ijsgat;
  stoVec[li_store_ijssti] = ijssti;
  stoVec[li_store_ijd] = ijd;
  stoVec[li_store_ijdbot] = ijdbot;
  stoVec[li_store_ijdgat] = ijdgat;
  stoVec[li_store_ijdsti] = ijdsti;
  stoVec[li_store_vds] = vds;
  stoVec[li_store_vgs] = vgs;
  stoVec[li_store_vsb] = vsb;
  stoVec[li_store_vto] = vto;
  stoVec[li_store_vts] = vts;
  stoVec[li_store_vth] = vth;
  stoVec[li_store_vgt] = vgt;
  stoVec[li_store_vdss] = vdss;
  stoVec[li_store_vsat] = vsat;
  stoVec[li_store_gm] = gm;
  stoVec[li_store_gmb] = gmb;
  stoVec[li_store_gds] = gds;
  stoVec[li_store_gjs] = gjs;
  stoVec[li_store_gjd] = gjd;
  stoVec[li_store_cdd] = cdd;
  stoVec[li_store_cdg] = cdg;
  stoVec[li_store_cds] = cds;
  stoVec[li_store_cdb] = cdb;
  stoVec[li_store_cgd] = cgd;
  stoVec[li_store_cgg] = cgg;
  stoVec[li_store_cgs] = cgs;
  stoVec[li_store_cgb] = cgb;
  stoVec[li_store_csd] = csd;
  stoVec[li_store_csg] = csg;
  stoVec[li_store_css] = css;
  stoVec[li_store_csb] = csb;
  stoVec[li_store_cbd] = cbd;
  stoVec[li_store_cbg] = cbg;
  stoVec[li_store_cbs] = cbs;
  stoVec[li_store_cbb] = cbb;
  stoVec[li_store_cgsol] = cgsol;
  stoVec[li_store_cgdol] = cgdol;
  stoVec[li_store_cjs] = cjs;
  stoVec[li_store_cjsbot] = cjsbot;
  stoVec[li_store_cjsgat] = cjsgat;
  stoVec[li_store_cjssti] = cjssti;
  stoVec[li_store_cjd] = cjd;
  stoVec[li_store_cjdbot] = cjdbot;
  stoVec[li_store_cjdgat] = cjdgat;
  stoVec[li_store_cjdsti] = cjdsti;
  stoVec[li_store_weff] = weff;
  stoVec[li_store_leff] = leff;
  stoVec[li_store_u] = u;
  stoVec[li_store_rout] = rout;
  stoVec[li_store_vearly] = vearly;
  stoVec[li_store_beff] = beff;
  stoVec[li_store_fug] = fug;
  stoVec[li_store_rg] = rg;
  stoVec[li_store_sfl] = sfl;
  stoVec[li_store_sqrtsff] = sqrtsff;
  stoVec[li_store_sqrtsfw] = sqrtsfw;
  stoVec[li_store_sid] = sid;
  stoVec[li_store_sig] = sig;
  stoVec[li_store_cigid] = cigid;
  stoVec[li_store_fknee] = fknee;
  stoVec[li_store_sigs] = sigs;
  stoVec[li_store_sigd] = sigd;
  stoVec[li_store_siavl] = siavl;
  stoVec[li_store_ssi] = ssi;
  stoVec[li_store_sdi] = sdi;
  stoVec[li_store_sfledge] = sfledge;
  stoVec[li_store_sidedge] = sidedge;
  stoVec[li_store_lp_vfb] = lp_vfb;
  stoVec[li_store_lp_stvfb] = lp_stvfb;
  stoVec[li_store_lp_tox] = lp_tox;
  stoVec[li_store_lp_epsrox] = lp_epsrox;
  stoVec[li_store_lp_neff] = lp_neff;
  stoVec[li_store_lp_facneffac] = lp_facneffac;
  stoVec[li_store_lp_gfacnud] = lp_gfacnud;
  stoVec[li_store_lp_vsbnud] = lp_vsbnud;
  stoVec[li_store_lp_dvsbnud] = lp_dvsbnud;
  stoVec[li_store_lp_vnsub] = lp_vnsub;
  stoVec[li_store_lp_nslp] = lp_nslp;
  stoVec[li_store_lp_dnsub] = lp_dnsub;
  stoVec[li_store_lp_dphib] = lp_dphib;
  stoVec[li_store_lp_delvtac] = lp_delvtac;
  stoVec[li_store_lp_np] = lp_np;
  stoVec[li_store_lp_ct] = lp_ct;
  stoVec[li_store_lp_toxov] = lp_toxov;
  stoVec[li_store_lp_toxovd] = lp_toxovd;
  stoVec[li_store_lp_nov] = lp_nov;
  stoVec[li_store_lp_novd] = lp_novd;
  stoVec[li_store_lp_cf] = lp_cf;
  stoVec[li_store_lp_cfd] = lp_cfd;
  stoVec[li_store_lp_cfb] = lp_cfb;
  stoVec[li_store_lp_psce] = lp_psce;
  stoVec[li_store_lp_psceb] = lp_psceb;
  stoVec[li_store_lp_psced] = lp_psced;
  stoVec[li_store_lp_betn] = lp_betn;
  stoVec[li_store_lp_stbet] = lp_stbet;
  stoVec[li_store_lp_mue] = lp_mue;
  stoVec[li_store_lp_stmue] = lp_stmue;
  stoVec[li_store_lp_themu] = lp_themu;
  stoVec[li_store_lp_stthemu] = lp_stthemu;
  stoVec[li_store_lp_cs] = lp_cs;
  stoVec[li_store_lp_stcs] = lp_stcs;
  stoVec[li_store_lp_xcor] = lp_xcor;
  stoVec[li_store_lp_stxcor] = lp_stxcor;
  stoVec[li_store_lp_feta] = lp_feta;
  stoVec[li_store_lp_rs] = lp_rs;
  stoVec[li_store_lp_strs] = lp_strs;
  stoVec[li_store_lp_rsb] = lp_rsb;
  stoVec[li_store_lp_rsg] = lp_rsg;
  stoVec[li_store_lp_thesat] = lp_thesat;
  stoVec[li_store_lp_stthesat] = lp_stthesat;
  stoVec[li_store_lp_thesatb] = lp_thesatb;
  stoVec[li_store_lp_thesatg] = lp_thesatg;
  stoVec[li_store_lp_ax] = lp_ax;
  stoVec[li_store_lp_alp] = lp_alp;
  stoVec[li_store_lp_alp1] = lp_alp1;
  stoVec[li_store_lp_alp2] = lp_alp2;
  stoVec[li_store_lp_vp] = lp_vp;
  stoVec[li_store_lp_a1] = lp_a1;
  stoVec[li_store_lp_a2] = lp_a2;
  stoVec[li_store_lp_sta2] = lp_sta2;
  stoVec[li_store_lp_a3] = lp_a3;
  stoVec[li_store_lp_a4] = lp_a4;
  stoVec[li_store_lp_gco] = lp_gco;
  stoVec[li_store_lp_iginv] = lp_iginv;
  stoVec[li_store_lp_igov] = lp_igov;
  stoVec[li_store_lp_igovd] = lp_igovd;
  stoVec[li_store_lp_stig] = lp_stig;
  stoVec[li_store_lp_gc2] = lp_gc2;
  stoVec[li_store_lp_gc3] = lp_gc3;
  stoVec[li_store_lp_chib] = lp_chib;
  stoVec[li_store_lp_agidl] = lp_agidl;
  stoVec[li_store_lp_agidld] = lp_agidld;
  stoVec[li_store_lp_bgidl] = lp_bgidl;
  stoVec[li_store_lp_bgidld] = lp_bgidld;
  stoVec[li_store_lp_stbgidl] = lp_stbgidl;
  stoVec[li_store_lp_stbgidld] = lp_stbgidld;
  stoVec[li_store_lp_cgidl] = lp_cgidl;
  stoVec[li_store_lp_cgidld] = lp_cgidld;
  stoVec[li_store_lp_cox] = lp_cox;
  stoVec[li_store_lp_cgov] = lp_cgov;
  stoVec[li_store_lp_cgovd] = lp_cgovd;
  stoVec[li_store_lp_cgbov] = lp_cgbov;
  stoVec[li_store_lp_cfr] = lp_cfr;
  stoVec[li_store_lp_cfrd] = lp_cfrd;
  stoVec[li_store_lp_fnt] = lp_fnt;
  stoVec[li_store_lp_fntexc] = lp_fntexc;
  stoVec[li_store_lp_nfa] = lp_nfa;
  stoVec[li_store_lp_nfb] = lp_nfb;
  stoVec[li_store_lp_nfc] = lp_nfc;
  stoVec[li_store_lp_ef] = lp_ef;
  stoVec[li_store_lp_vfbedge] = lp_vfbedge;
  stoVec[li_store_lp_stvfbedge] = lp_stvfbedge;
  stoVec[li_store_lp_dphibedge] = lp_dphibedge;
  stoVec[li_store_lp_neffedge] = lp_neffedge;
  stoVec[li_store_lp_ctedge] = lp_ctedge;
  stoVec[li_store_lp_betnedge] = lp_betnedge;
  stoVec[li_store_lp_stbetedge] = lp_stbetedge;
  stoVec[li_store_lp_psceedge] = lp_psceedge;
  stoVec[li_store_lp_pscebedge] = lp_pscebedge;
  stoVec[li_store_lp_pscededge] = lp_pscededge;
  stoVec[li_store_lp_cfedge] = lp_cfedge;
  stoVec[li_store_lp_cfdedge] = lp_cfdedge;
  stoVec[li_store_lp_cfbedge] = lp_cfbedge;
  stoVec[li_store_lp_fntedge] = lp_fntedge;
  stoVec[li_store_lp_nfaedge] = lp_nfaedge;
  stoVec[li_store_lp_nfbedge] = lp_nfbedge;
  stoVec[li_store_lp_nfcedge] = lp_nfcedge;
  stoVec[li_store_lp_efedge] = lp_efedge;
  stoVec[li_store_lp_rg] = lp_rg;
  stoVec[li_store_lp_rse] = lp_rse;
  stoVec[li_store_lp_rde] = lp_rde;
  stoVec[li_store_lp_rbulk] = lp_rbulk;
  stoVec[li_store_lp_rwell] = lp_rwell;
  stoVec[li_store_lp_rjuns] = lp_rjuns;
  stoVec[li_store_lp_rjund] = lp_rjund;
  stoVec[li_store_tk] = tk;
  stoVec[li_store_cjosbot] = cjosbot;
  stoVec[li_store_cjossti] = cjossti;
  stoVec[li_store_cjosgat] = cjosgat;
  stoVec[li_store_vbisbot] = vbisbot;
  stoVec[li_store_vbissti] = vbissti;
  stoVec[li_store_vbisgat] = vbisgat;
  stoVec[li_store_idsatsbot] = idsatsbot;
  stoVec[li_store_idsatssti] = idsatssti;
  stoVec[li_store_idsatsgat] = idsatsgat;
  stoVec[li_store_cjosbotd] = cjosbotd;
  stoVec[li_store_cjosstid] = cjosstid;
  stoVec[li_store_cjosgatd] = cjosgatd;
  stoVec[li_store_vbisbotd] = vbisbotd;
  stoVec[li_store_vbisstid] = vbisstid;
  stoVec[li_store_vbisgatd] = vbisgatd;
  stoVec[li_store_idsatsbotd] = idsatsbotd;
  stoVec[li_store_idsatsstid] = idsatsstid;
  stoVec[li_store_idsatsgatd] = idsatsgatd;

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateSecondaryState
// Purpose       :
// Special Notes : In this initial implementation, does nothing
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateSecondaryState()
{
  bool bsuccess = true;

  // were old DAE implemented, we'd pull dynamic contribution derivatives
  // out of state.

  return bsuccess;
}

//-----------------------------------------------------------------------------
// Function      : Instance::updateIntermediateVars
// Purpose       : update intermediate variables for one PSP103VA instance
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateIntermediateVars()
{

  bool bsuccess=true;
  Linear::Vector * solVectorPtr = extData.nextSolVectorPtr;

  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << std::endl << subsection_divider << std::endl;
    Xyce::dout() << "  In ADMSPSP103VA::Instance::updateIntermediateVars\n\n";
    Xyce::dout() << "  name = " << getName() << std::endl;
  }

  // Local variables
  double vth_i=0.0;
  double vts_i=0.0;
  double facvsb=0.0;
  double facvsb0=0.0;
  double P_D=0.0;
  double delVsat=0.0;
     double d_delVsat_dV_DI_SI=0.0;
     double d_delVsat_dV_GP_SI=0.0;
     double d_delVsat_dV_SI_BP=0.0;
  double Q_EDGE_errq=0.0;
     double d_Q_EDGE_errq_dV_DI_SI=0.0;
     double d_Q_EDGE_errq_dV_SI_BP=0.0;
     double d_Q_EDGE_errq_dV_GP_SI=0.0;
  double Q_EDGE_sqerr=0.0;
     double d_Q_EDGE_sqerr_dV_DI_SI=0.0;
     double d_Q_EDGE_sqerr_dV_SI_BP=0.0;
     double d_Q_EDGE_sqerr_dV_GP_SI=0.0;
  double Q_EDGE_d0p=0.0;
     double d_Q_EDGE_d0p_dV_DI_SI=0.0;
     double d_Q_EDGE_d0p_dV_SI_BP=0.0;
     double d_Q_EDGE_d0p_dV_GP_SI=0.0;
  double Q_EDGE_d0=0.0;
     double d_Q_EDGE_d0_dV_DI_SI=0.0;
     double d_Q_EDGE_d0_dV_SI_BP=0.0;
     double d_Q_EDGE_d0_dV_GP_SI=0.0;
  double Q_EDGE_exp_x=0.0;
     double d_Q_EDGE_exp_x_dV_DI_SI=0.0;
     double d_Q_EDGE_exp_x_dV_SI_BP=0.0;
     double d_Q_EDGE_exp_x_dV_GP_SI=0.0;
  double Q_EDGE_qi0=0.0;
     double d_Q_EDGE_qi0_dV_DI_SI=0.0;
     double d_Q_EDGE_qi0_dV_SI_BP=0.0;
     double d_Q_EDGE_qi0_dV_GP_SI=0.0;
  double Q_EDGE_qi0si=0.0;
     double d_Q_EDGE_qi0si_dV_DI_SI=0.0;
     double d_Q_EDGE_qi0si_dV_SI_BP=0.0;
     double d_Q_EDGE_qi0si_dV_GP_SI=0.0;
  double Q_EDGE_xgt0e=0.0;
     double d_Q_EDGE_xgt0e_dV_DI_SI=0.0;
     double d_Q_EDGE_xgt0e_dV_SI_BP=0.0;
     double d_Q_EDGE_xgt0e_dV_GP_SI=0.0;
  double Q_EDGE_xgt0=0.0;
     double d_Q_EDGE_xgt0_dV_DI_SI=0.0;
     double d_Q_EDGE_xgt0_dV_SI_BP=0.0;
     double d_Q_EDGE_xgt0_dV_GP_SI=0.0;
  double Q_EDGE_xgt=0.0;
     double d_Q_EDGE_xgt_dV_DI_SI=0.0;
     double d_Q_EDGE_xgt_dV_SI_BP=0.0;
     double d_Q_EDGE_xgt_dV_GP_SI=0.0;
  double Q_EDGE_n_inv=0.0;
     double d_Q_EDGE_n_inv_dV_DI_SI=0.0;
     double d_Q_EDGE_n_inv_dV_SI_BP=0.0;
     double d_Q_EDGE_n_inv_dV_GP_SI=0.0;
  double Q_EDGE_n=0.0;
     double d_Q_EDGE_n_dV_DI_SI=0.0;
     double d_Q_EDGE_n_dV_SI_BP=0.0;
     double d_Q_EDGE_n_dV_GP_SI=0.0;
  double Q_EDGE_xth=0.0;
     double d_Q_EDGE_xth_dV_DI_SI=0.0;
     double d_Q_EDGE_xth_dV_SI_BP=0.0;
     double d_Q_EDGE_xth_dV_GP_SI=0.0;
  double Q_EDGE_xth0=0.0;
     double d_Q_EDGE_xth0_dV_DI_SI=0.0;
     double d_Q_EDGE_xth0_dV_SI_BP=0.0;
     double d_Q_EDGE_xth0_dV_GP_SI=0.0;
  double Q_EDGE_xsth=0.0;
     double d_Q_EDGE_xsth_dV_DI_SI=0.0;
     double d_Q_EDGE_xsth_dV_SI_BP=0.0;
     double d_Q_EDGE_xsth_dV_GP_SI=0.0;
  double Vtovs=0.0;
     double d_Vtovs_dV_GP_SI=0.0;
     double d_Vtovs_dV_SI_BP=0.0;
  double Vtovd=0.0;
     double d_Vtovd_dV_GP_SI=0.0;
     double d_Vtovd_dV_DI_SI=0.0;
     double d_Vtovd_dV_SI_BP=0.0;
  double Igisl=0.0;
     double d_Igisl_dV_SI_BP=0.0;
     double d_Igisl_dV_GP_SI=0.0;
     double d_Igisl_dV_DI_SI=0.0;
  double Igidl=0.0;
     double d_Igidl_dV_DI_SI=0.0;
     double d_Igidl_dV_SI_BP=0.0;
     double d_Igidl_dV_GP_SI=0.0;
  double Sg=0.0;
     double d_Sg_dV_DI_SI=0.0;
     double d_Sg_dV_GP_SI=0.0;
     double d_Sg_dV_SI_BP=0.0;
  double igcd_h=0.0;
     double d_igcd_h_dV_DI_SI=0.0;
     double d_igcd_h_dV_GP_SI=0.0;
     double d_igcd_h_dV_SI_BP=0.0;
  double igc=0.0;
     double d_igc_dV_DI_SI=0.0;
     double d_igc_dV_GP_SI=0.0;
     double d_igc_dV_SI_BP=0.0;
  double xsq=0.0;
     double d_xsq_dV_DI_SI=0.0;
     double d_xsq_dV_GP_SI=0.0;
     double d_xsq_dV_SI_BP=0.0;
  double inv_ex=0.0;
     double d_inv_ex_dV_DI_SI=0.0;
     double d_inv_ex_dV_GP_SI=0.0;
     double d_inv_ex_dV_SI_BP=0.0;
  double ex=0.0;
     double d_ex_dV_DI_SI=0.0;
     double d_ex_dV_GP_SI=0.0;
     double d_ex_dV_SI_BP=0.0;
  double inv_x=0.0;
     double d_inv_x_dV_DI_SI=0.0;
     double d_inv_x_dV_GP_SI=0.0;
     double d_inv_x_dV_SI_BP=0.0;
  double Ag=0.0;
     double d_Ag_dV_GP_SI=0.0;
     double d_Ag_dV_DI_SI=0.0;
     double d_Ag_dV_SI_BP=0.0;
  double Bg=0.0;
     double d_Bg_dV_GP_SI=0.0;
     double d_Bg_dV_DI_SI=0.0;
     double d_Bg_dV_SI_BP=0.0;
  double u0_div_H=0.0;
     double d_u0_div_H_dV_GP_SI=0.0;
     double d_u0_div_H_dV_DI_SI=0.0;
     double d_u0_div_H_dV_SI_BP=0.0;
  double x=0.0;
     double d_x_dV_DI_SI=0.0;
     double d_x_dV_GP_SI=0.0;
     double d_x_dV_SI_BP=0.0;
  double u0=0.0;
     double d_u0_dV_GP_SI=0.0;
     double d_u0_dV_DI_SI=0.0;
     double d_u0_dV_SI_BP=0.0;
  double Igc0=0.0;
     double d_Igc0_dV_GP_SI=0.0;
     double d_Igc0_dV_DI_SI=0.0;
     double d_Igc0_dV_SI_BP=0.0;
  double Dgate=0.0;
     double d_Dgate_dV_DI_SI=0.0;
     double d_Dgate_dV_GP_SI=0.0;
     double d_Dgate_dV_SI_BP=0.0;
  double Dsi=0.0;
     double d_Dsi_dV_DI_SI=0.0;
     double d_Dsi_dV_GP_SI=0.0;
     double d_Dsi_dV_SI_BP=0.0;
  double arg1=0.0;
     double d_arg1_dV_DI_SI=0.0;
     double d_arg1_dV_GP_SI=0.0;
     double d_arg1_dV_SI_BP=0.0;
  double psi_t=0.0;
     double d_psi_t_dV_DI_SI=0.0;
     double d_psi_t_dV_GP_SI=0.0;
     double d_psi_t_dV_SI_BP=0.0;
  double arg2mina=0.0;
     double d_arg2mina_dV_DI_SI=0.0;
     double d_arg2mina_dV_GP_SI=0.0;
     double d_arg2mina_dV_SI_BP=0.0;
  double Dch=0.0;
     double d_Dch_dV_DI_SI=0.0;
     double d_Dch_dV_SI_BP=0.0;
  double Vm=0.0;
     double d_Vm_dV_DI_SI=0.0;
     double d_Vm_dV_SI_BP=0.0;
     double d_Vm_dV_GP_SI=0.0;
  double Fs=0.0;
     double d_Fs_dV_DI_SI=0.0;
     double d_Fs_dV_SI_BP=0.0;
     double d_Fs_dV_GP_SI=0.0;
  double tme2=0.0;
     double d_tme2_dV_DI_SI=0.0;
     double d_tme2_dV_SI_BP=0.0;
     double d_tme2_dV_GP_SI=0.0;
  double tme1=0.0;
  double Fs3=0.0;
     double d_Fs3_dV_DI_SI=0.0;
     double d_Fs3_dV_GP_SI=0.0;
  double Fs2=0.0;
  double Fs1=0.0;
     double d_Fs1_dV_DI_SI=0.0;
     double d_Fs1_dV_GP_SI=0.0;
  double TP=0.0;
     double d_TP_dV_GP_SI=0.0;
     double d_TP_dV_DI_SI=0.0;
     double d_TP_dV_SI_BP=0.0;
  double zg=0.0;
     double d_zg_dV_SI_BP=0.0;
     double d_zg_dV_DI_SI=0.0;
     double d_zg_dV_GP_SI=0.0;
  double Igb=0.0;
     double d_Igb_dV_GP_SI=0.0;
     double d_Igb_dV_DI_SI=0.0;
     double d_Igb_dV_SI_BP=0.0;
  double Igc=0.0;
     double d_Igc_dV_GP_SI=0.0;
     double d_Igc_dV_DI_SI=0.0;
     double d_Igc_dV_SI_BP=0.0;
  double SP_OV_xg=0.0;
     double d_SP_OV_xg_dV_DI_SI=0.0;
     double d_SP_OV_xg_dV_GP_SI=0.0;
  double Vsbstar_dc=0.0;
     double d_Vsbstar_dc_dV_DI_SI=0.0;
     double d_Vsbstar_dc_dV_SI_BP=0.0;
  double Vsbstar_dc_tmp=0.0;
     double d_Vsbstar_dc_tmp_dV_DI_SI=0.0;
     double d_Vsbstar_dc_tmp_dV_SI_BP=0.0;
  double Vmb=0.0;
     double d_Vmb_dV_DI_SI=0.0;
     double d_Vmb_dV_SI_BP=0.0;
  double us=0.0;
     double d_us_dV_DI_SI=0.0;
     double d_us_dV_SI_BP=0.0;
  double usnew=0.0;
     double d_usnew_dV_DI_SI=0.0;
     double d_usnew_dV_SI_BP=0.0;
  double Vmbnew=0.0;
     double d_Vmbnew_dV_DI_SI=0.0;
     double d_Vmbnew_dV_SI_BP=0.0;
  double Vgbstar=0.0;
     double d_Vgbstar_dV_DI_SI=0.0;
     double d_Vgbstar_dV_GP_SI=0.0;
     double d_Vgbstar_dV_SI_BP=0.0;
  double Vgb1=0.0;
     double d_Vgb1_dV_DI_SI=0.0;
     double d_Vgb1_dV_GP_SI=0.0;
     double d_Vgb1_dV_SI_BP=0.0;
  double Vdsp=0.0;
     double d_Vdsp_dV_DI_SI=0.0;
  double delVg=0.0;
     double d_delVg_dV_GP_SI=0.0;
     double d_delVg_dV_DI_SI=0.0;
     double d_delVg_dV_SI_BP=0.0;
  double nu=0.0;
     double d_nu_dV_DI_SI=0.0;
     double d_nu_dV_GP_SI=0.0;
     double d_nu_dV_SI_BP=0.0;
  double mutau=0.0;
     double d_mutau_dV_DI_SI=0.0;
     double d_mutau_dV_GP_SI=0.0;
     double d_mutau_dV_SI_BP=0.0;
  double Vdsat_lim=0.0;
     double d_Vdsat_lim_dV_GP_SI=0.0;
     double d_Vdsat_lim_dV_DI_SI=0.0;
     double d_Vdsat_lim_dV_SI_BP=0.0;
  double Vdsat=0.0;
     double d_Vdsat_dV_GP_SI=0.0;
     double d_Vdsat_dV_DI_SI=0.0;
     double d_Vdsat_dV_SI_BP=0.0;
  double qeff1_dc=0.0;
     double d_qeff1_dc_dV_DI_SI=0.0;
     double d_qeff1_dc_dV_GP_SI=0.0;
     double d_qeff1_dc_dV_SI_BP=0.0;
  double Voxm_dc=0.0;
     double d_Voxm_dc_dV_DI_SI=0.0;
     double d_Voxm_dc_dV_GP_SI=0.0;
     double d_Voxm_dc_dV_SI_BP=0.0;
  double GdL_dc=0.0;
     double d_GdL_dc_dV_DI_SI=0.0;
     double d_GdL_dc_dV_GP_SI=0.0;
     double d_GdL_dc_dV_SI_BP=0.0;
  double eta_p_dc=0.0;
     double d_eta_p_dc_dV_DI_SI=0.0;
     double d_eta_p_dc_dV_GP_SI=0.0;
     double d_eta_p_dc_dV_SI_BP=0.0;
  double Gvsat_dc=0.0;
     double d_Gvsat_dc_dV_DI_SI=0.0;
     double d_Gvsat_dc_dV_GP_SI=0.0;
     double d_Gvsat_dc_dV_SI_BP=0.0;
  double Gmob_dL_dc=0.0;
     double d_Gmob_dL_dc_dV_DI_SI=0.0;
     double d_Gmob_dL_dc_dV_GP_SI=0.0;
     double d_Gmob_dL_dc_dV_SI_BP=0.0;
  double x_ds_dc=0.0;
     double d_x_ds_dc_dV_DI_SI=0.0;
     double d_x_ds_dc_dV_GP_SI=0.0;
     double d_x_ds_dc_dV_SI_BP=0.0;
  double x_m_dc=0.0;
     double d_x_m_dc_dV_DI_SI=0.0;
     double d_x_m_dc_dV_GP_SI=0.0;
     double d_x_m_dc_dV_SI_BP=0.0;
  double Gf_dc=0.0;
  double Vdsat_dc=0.0;
  double Udse_dc=0.0;
     double d_Udse_dc_dV_GP_SI=0.0;
     double d_Udse_dc_dV_SI_BP=0.0;
     double d_Udse_dc_dV_DI_SI=0.0;
  double Vdsx=0.0;
     double d_Vdsx_dV_DI_SI=0.0;
  double Vdb=0.0;
     double d_Vdb_dV_DI_SI=0.0;
     double d_Vdb_dV_SI_BP=0.0;
  double xgd_ov=0.0;
     double d_xgd_ov_dV_GP_SI=0.0;
     double d_xgd_ov_dV_DI_SI=0.0;
  double xgs_ov=0.0;
     double d_xgs_ov_dV_GP_SI=0.0;
  double VgdPrime=0.0;
     double d_VgdPrime_dV_GP_SI=0.0;
     double d_VgdPrime_dV_DI_SI=0.0;
  double VdbPrime=0.0;
     double d_VdbPrime_dV_DI_SI=0.0;
     double d_VdbPrime_dV_SI_BP=0.0;
  double VsbPrime=0.0;
     double d_VsbPrime_dV_SI_BP=0.0;
  double VgsPrime=0.0;
     double d_VgsPrime_dV_GP_SI=0.0;
  double Vjun_d=0.0;
     double d_Vjun_d_dV_DI_BD=0.0;
  double Vjun_s=0.0;
     double d_Vjun_s_dV_SI_BS=0.0;
  double Vsb=0.0;
     double d_Vsb_dV_DI_SI=0.0;
     double d_Vsb_dV_SI_BP=0.0;
  double Vds=0.0;
     double d_Vds_dV_DI_SI=0.0;
  double Vgs=0.0;
     double d_Vgs_dV_DI_SI=0.0;
     double d_Vgs_dV_GP_SI=0.0;
  double Vovd=0.0;
     double d_Vovd_dV_GP_SI=0.0;
     double d_Vovd_dV_DI_SI=0.0;
  double Vovs=0.0;
     double d_Vovs_dV_GP_SI=0.0;
  double xd_ov=0.0;
     double d_xd_ov_dV_DI_SI=0.0;
     double d_xd_ov_dV_GP_SI=0.0;
  double xs_ov=0.0;
     double d_xs_ov_dV_GP_SI=0.0;
  double QCLM=0.0;
     double d_QCLM_dV_DI_SI=0.0;
     double d_QCLM_dV_GP_SI=0.0;
     double d_QCLM_dV_SI_BP=0.0;
  double Qfgd=0.0;
     double d_Qfgd_dV_GP_SI=0.0;
     double d_Qfgd_dV_DI_SI=0.0;
  double Qfgs=0.0;
     double d_Qfgs_dV_GP_SI=0.0;
  double Qgb_ov=0.0;
     double d_Qgb_ov_dV_DI_SI=0.0;
     double d_Qgb_ov_dV_GP_SI=0.0;
     double d_Qgb_ov_dV_SI_BP=0.0;
  double Qgd_ov=0.0;
     double d_Qgd_ov_dV_GP_SI=0.0;
     double d_Qgd_ov_dV_DI_SI=0.0;
  double Qgs_ov=0.0;
     double d_Qgs_ov_dV_GP_SI=0.0;
  double Qb=0.0;
     double d_Qb_dV_DI_SI=0.0;
     double d_Qb_dV_GP_SI=0.0;
     double d_Qb_dV_SI_BP=0.0;
  double Qd=0.0;
     double d_Qd_dV_DI_SI=0.0;
     double d_Qd_dV_GP_SI=0.0;
     double d_Qd_dV_SI_BP=0.0;
  double Qg=0.0;
     double d_Qg_dV_DI_SI=0.0;
     double d_Qg_dV_GP_SI=0.0;
     double d_Qg_dV_SI_BP=0.0;
  double QB=0.0;
     double d_QB_dV_DI_SI=0.0;
     double d_QB_dV_GP_SI=0.0;
     double d_QB_dV_SI_BP=0.0;
  double QD=0.0;
     double d_QD_dV_DI_SI=0.0;
     double d_QD_dV_GP_SI=0.0;
     double d_QD_dV_SI_BP=0.0;
  double QI=0.0;
     double d_QI_dV_DI_SI=0.0;
     double d_QI_dV_GP_SI=0.0;
     double d_QI_dV_SI_BP=0.0;
  double QG=0.0;
     double d_QG_dV_DI_SI=0.0;
     double d_QG_dV_GP_SI=0.0;
     double d_QG_dV_SI_BP=0.0;
  double Fj2=0.0;
     double d_Fj2_dV_DI_SI=0.0;
     double d_Fj2_dV_GP_SI=0.0;
     double d_Fj2_dV_SI_BP=0.0;
  double Fj=0.0;
     double d_Fj_dV_DI_SI=0.0;
     double d_Fj_dV_GP_SI=0.0;
     double d_Fj_dV_SI_BP=0.0;
  double Vgb=0.0;
     double d_Vgb_dV_DI_SI=0.0;
     double d_Vgb_dV_GP_SI=0.0;
     double d_Vgb_dV_SI_BP=0.0;
  double Vsbstar_ac=0.0;
     double d_Vsbstar_ac_dV_DI_SI=0.0;
     double d_Vsbstar_ac_dV_SI_BP=0.0;
     double d_Vsbstar_ac_dV_GP_SI=0.0;
  double xg_ac=0.0;
     double d_xg_ac_dV_DI_SI=0.0;
     double d_xg_ac_dV_GP_SI=0.0;
     double d_xg_ac_dV_SI_BP=0.0;
  double qeff1_ac=0.0;
     double d_qeff1_ac_dV_DI_SI=0.0;
     double d_qeff1_ac_dV_GP_SI=0.0;
     double d_qeff1_ac_dV_SI_BP=0.0;
  double Voxm_ac=0.0;
     double d_Voxm_ac_dV_DI_SI=0.0;
     double d_Voxm_ac_dV_GP_SI=0.0;
     double d_Voxm_ac_dV_SI_BP=0.0;
  double alpha_ac=0.0;
     double d_alpha_ac_dV_DI_SI=0.0;
     double d_alpha_ac_dV_GP_SI=0.0;
     double d_alpha_ac_dV_SI_BP=0.0;
  double dps_ac=0.0;
     double d_dps_ac_dV_DI_SI=0.0;
     double d_dps_ac_dV_GP_SI=0.0;
     double d_dps_ac_dV_SI_BP=0.0;
  double qim_ac=0.0;
     double d_qim_ac_dV_GP_SI=0.0;
     double d_qim_ac_dV_DI_SI=0.0;
     double d_qim_ac_dV_SI_BP=0.0;
  double GdL_ac=0.0;
     double d_GdL_ac_dV_DI_SI=0.0;
     double d_GdL_ac_dV_GP_SI=0.0;
     double d_GdL_ac_dV_SI_BP=0.0;
  double H_ac=0.0;
     double d_H_ac_dV_GP_SI=0.0;
     double d_H_ac_dV_DI_SI=0.0;
     double d_H_ac_dV_SI_BP=0.0;
  double rwellnoise=0.0;
  double rjundnoise=0.0;
  double rjunsnoise=0.0;
  double rbulknoise=0.0;
  double rdrainnoise=0.0;
  double rsourcenoise=0.0;
  double rgatenoise=0.0;
  double h1=0.0;
  double h2=0.0;
  double h2d=0.0;
     double d_h2d_dV_DI_BD=0.0;
     double d_h2d_dV_SI_BS=0.0;
  double h3=0.0;
     double d_h3_dV_DI_BD=0.0;
     double d_h3_dV_SI_BS=0.0;
  double h4=0.0;
     double d_h4_dV_DI_BD=0.0;
     double d_h4_dV_SI_BS=0.0;
  double h5=0.0;
     double d_h5_dV_DI_BD=0.0;
     double d_h5_dV_SI_BS=0.0;
  double ijunrev=0.0;
     double d_ijunrev_dV_DI_BD=0.0;
     double d_ijunrev_dV_SI_BS=0.0;
  double ijunfor2=0.0;
     double d_ijunfor2_dV_DI_BD=0.0;
     double d_ijunfor2_dV_SI_BS=0.0;
  double ijunfor1=0.0;
     double d_ijunfor1_dV_DI_BD=0.0;
     double d_ijunfor1_dV_SI_BS=0.0;
  double tm1=0.0;
     double d_tm1_dV_DI_BD=0.0;
     double d_tm1_dV_SI_BS=0.0;
  double tm0=0.0;
     double d_tm0_dV_DI_BD=0.0;
     double d_tm0_dV_SI_BS=0.0;
  double fbreakdown=0.0;
     double d_fbreakdown_dV_SI_BS=0.0;
     double d_fbreakdown_dV_DI_BD=0.0;
  double ibbt=0.0;
     double d_ibbt_dV_SI_BS=0.0;
     double d_ibbt_dV_DI_BD=0.0;
  double Fmaxr=0.0;
     double d_Fmaxr_dV_SI_BS=0.0;
     double d_Fmaxr_dV_DI_BD=0.0;
  double itat=0.0;
     double d_itat_dV_SI_BS=0.0;
     double d_itat_dV_DI_BD=0.0;
  double gammamax=0.0;
     double d_gammamax_dV_SI_BS=0.0;
     double d_gammamax_dV_DI_BD=0.0;
  double erfctimesexpmtat=0.0;
     double d_erfctimesexpmtat_dV_SI_BS=0.0;
     double d_erfctimesexpmtat_dV_DI_BD=0.0;
  double erfcpos=0.0;
     double d_erfcpos_dV_SI_BS=0.0;
     double d_erfcpos_dV_DI_BD=0.0;
  double terfc=0.0;
     double d_terfc_dV_SI_BS=0.0;
     double d_terfc_dV_DI_BD=0.0;
  double ysq=0.0;
     double d_ysq_dV_SI_BS=0.0;
     double d_ysq_dV_DI_BD=0.0;
  double xerfc=0.0;
     double d_xerfc_dV_SI_BS=0.0;
     double d_xerfc_dV_DI_BD=0.0;
  double mtat=0.0;
     double d_mtat_dV_SI_BS=0.0;
     double d_mtat_dV_DI_BD=0.0;
  double ltat=0.0;
     double d_ltat_dV_SI_BS=0.0;
     double d_ltat_dV_DI_BD=0.0;
  double ktat=0.0;
     double d_ktat_dV_SI_BS=0.0;
     double d_ktat_dV_DI_BD=0.0;
  double wtat=0.0;
     double d_wtat_dV_SI_BS=0.0;
     double d_wtat_dV_DI_BD=0.0;
  double wgamma=0.0;
     double d_wgamma_dV_SI_BS=0.0;
     double d_wgamma_dV_DI_BD=0.0;
  double umaxpoweronepointfive=0.0;
     double d_umaxpoweronepointfive_dV_SI_BS=0.0;
     double d_umaxpoweronepointfive_dV_DI_BD=0.0;
  double sqrtumax=0.0;
     double d_sqrtumax_dV_SI_BS=0.0;
     double d_sqrtumax_dV_DI_BD=0.0;
  double umax=0.0;
     double d_umax_dV_SI_BS=0.0;
     double d_umax_dV_DI_BD=0.0;
  double umaxbeforelimiting=0.0;
     double d_umaxbeforelimiting_dV_SI_BS=0.0;
     double d_umaxbeforelimiting_dV_DI_BD=0.0;
  double twoatatoverthreebtat=0.0;
     double d_twoatatoverthreebtat_dV_SI_BS=0.0;
     double d_twoatatoverthreebtat_dV_DI_BD=0.0;
  double btat=0.0;
     double d_btat_dV_SI_BS=0.0;
     double d_btat_dV_DI_BD=0.0;
  double isrh=0.0;
     double d_isrh_dV_SI_BS=0.0;
     double d_isrh_dV_DI_BD=0.0;
  double asrh=0.0;
     double d_asrh_dV_SI_BS=0.0;
     double d_asrh_dV_DI_BD=0.0;
  double wdep=0.0;
     double d_wdep_dV_SI_BS=0.0;
     double d_wdep_dV_DI_BD=0.0;
  double wsrh=0.0;
     double d_wsrh_dV_DI_BD=0.0;
     double d_wsrh_dV_SI_BS=0.0;
  double dwsrh=0.0;
     double d_dwsrh_dV_DI_BD=0.0;
     double d_dwsrh_dV_SI_BS=0.0;
  double wsrhstep=0.0;
     double d_wsrhstep_dV_DI_BD=0.0;
     double d_wsrhstep_dV_SI_BS=0.0;
  double vbi_minus_vjsrh=0.0;
     double d_vbi_minus_vjsrh_dV_DI_BD=0.0;
     double d_vbi_minus_vjsrh_dV_SI_BS=0.0;
  double id=0.0;
     double d_id_dV_DI_BD=0.0;
     double d_id_dV_SI_BS=0.0;
  double tmp=0.0;
     double d_tmp_dV_SI_BS=0.0;
     double d_tmp_dV_DI_BD=0.0;
  double vav=0.0;
     double d_vav_dV_DI_BD=0.0;
     double d_vav_dV_SI_BS=0.0;
  double vjsrh=0.0;
     double d_vjsrh_dV_DI_BD=0.0;
     double d_vjsrh_dV_SI_BS=0.0;
  double vjlim=0.0;
     double d_vjlim_dV_DI_BD=0.0;
     double d_vjlim_dV_SI_BS=0.0;
  double z=0.0;
     double d_z_dV_DI_BD=0.0;
     double d_z_dV_SI_BS=0.0;
  double idmult=0.0;
     double d_idmult_dV_DI_BD=0.0;
     double d_idmult_dV_SI_BS=0.0;
  double zinv=0.0;
     double d_zinv_dV_DI_BD=0.0;
     double d_zinv_dV_SI_BS=0.0;
  double vj=0.0;
     double d_vj_dV_SI_BS=0.0;
     double d_vj_dV_DI_BD=0.0;
  double two_psistar=0.0;
     double d_two_psistar_dV_DI_BD=0.0;
     double d_two_psistar_dV_SI_BS=0.0;
  double vbbt=0.0;
     double d_vbbt_dV_DI_BD=0.0;
     double d_vbbt_dV_SI_BS=0.0;
  double Qs=0.0;
     double d_Qs_dV_DI_SI=0.0;
     double d_Qs_dV_GP_SI=0.0;
     double d_Qs_dV_SI_BP=0.0;
  double g_idealedge=0.0;
  double lcinv2edge=0.0;
  double lcedge=0.0;
  double redge=0.0;
  double t2edge=0.0;
  double sqt2edge=0.0;
  double t1edge=0.0;
  double H0edge=0.0;
  double Delta_N1edge=0.0;
  double Nm1edge=0.0;
  double N1edge=0.0;
  double anoisedge=0.0;
  double shot_igd=0.0;
  double shot_igs=0.0;
  double gfac=0.0;
     double d_gfac_dV_DI_SI=0.0;
     double d_gfac_dV_GP_SI=0.0;
     double d_gfac_dV_SI_BP=0.0;
  double Gvsat_exc=0.0;
     double d_Gvsat_exc_dV_DI_SI=0.0;
     double d_Gvsat_exc_dV_GP_SI=0.0;
     double d_Gvsat_exc_dV_SI_BP=0.0;
  double zsat_exc=0.0;
     double d_zsat_exc_dV_DI_SI=0.0;
     double d_zsat_exc_dV_SI_BP=0.0;
     double d_zsat_exc_dV_GP_SI=0.0;
  double thesat1_exc=0.0;
     double d_thesat1_exc_dV_DI_SI=0.0;
     double d_thesat1_exc_dV_SI_BP=0.0;
     double d_thesat1_exc_dV_GP_SI=0.0;
  double temp_exc=0.0;
     double d_temp_exc_dV_DI_SI=0.0;
     double d_temp_exc_dV_SI_BP=0.0;
     double d_temp_exc_dV_GP_SI=0.0;
  double wsat_exc=0.0;
     double d_wsat_exc_dV_DI_SI=0.0;
     double d_wsat_exc_dV_SI_BP=0.0;
     double d_wsat_exc_dV_GP_SI=0.0;
  double temp2_exc=0.0;
     double d_temp2_exc_dV_DI_SI=0.0;
     double d_temp2_exc_dV_SI_BP=0.0;
     double d_temp2_exc_dV_GP_SI=0.0;
  double g_ideal=0.0;
     double d_g_ideal_dV_DI_SI=0.0;
     double d_g_ideal_dV_GP_SI=0.0;
     double d_g_ideal_dV_SI_BP=0.0;
  double lcinv2=0.0;
     double d_lcinv2_dV_DI_SI=0.0;
     double d_lcinv2_dV_SI_BP=0.0;
     double d_lcinv2_dV_GP_SI=0.0;
  double lc=0.0;
     double d_lc_dV_DI_SI=0.0;
     double d_lc_dV_SI_BP=0.0;
     double d_lc_dV_GP_SI=0.0;
  double r=0.0;
     double d_r_dV_DI_SI=0.0;
     double d_r_dV_SI_BP=0.0;
     double d_r_dV_GP_SI=0.0;
  double t2=0.0;
     double d_t2_dV_DI_SI=0.0;
     double d_t2_dV_GP_SI=0.0;
     double d_t2_dV_SI_BP=0.0;
  double sqt2=0.0;
     double d_sqt2_dV_DI_SI=0.0;
     double d_sqt2_dV_GP_SI=0.0;
     double d_sqt2_dV_SI_BP=0.0;
  double t1=0.0;
     double d_t1_dV_DI_SI=0.0;
     double d_t1_dV_SI_BP=0.0;
     double d_t1_dV_GP_SI=0.0;
  double Delta_N1=0.0;
  double Nm1=0.0;
  double N1=0.0;
  double sqig=0.0;
  double migid=0.0;
     double d_migid_dV_DI_SI=0.0;
     double d_migid_dV_SI_BP=0.0;
     double d_migid_dV_GP_SI=0.0;
  double mid=0.0;
  double Sidexc=0.0;
     double d_Sidexc_dV_DI_SI=0.0;
     double d_Sidexc_dV_GP_SI=0.0;
     double d_Sidexc_dV_SI_BP=0.0;
  double ids_i=0.0;
     double d_ids_i_dV_DI_SI=0.0;
     double d_ids_i_dV_GP_SI=0.0;
     double d_ids_i_dV_SI_BP=0.0;
     double d_ids_i_dV_DI_BD=0.0;
     double d_ids_i_dV_SI_BS=0.0;
  double sig1k=0.0;
  double ib=0.0;
  double ig=0.0;
  double is=0.0;
  double id_op=0.0;


  // set the sizes of the Fad arrays:

  if (probeVars.size() != (20))
  {
    probeVars.resize(20);
    d_probeVars.resize(20);
    for (int i=0;i<20;i++)
    {
      d_probeVars[i].resize(20);
      for (int j=0;j<20;j++)
        d_probeVars[i][j]=0.0;
    }
    staticContributions.resize(13+0);
    d_staticContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_staticContributions[i].resize(20);
    dynamicContributions.resize(13+0);
    d_dynamicContributions.resize(13+0);
    for (int i=0;i<13+0;i++)
      d_dynamicContributions[i].resize(20);
  }

    noiseContribsPower.resize(16);
    noiseContribsExponent.resize(16);

  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
     staticContributions[i]=0;
     for (int j=0;j<20;j++)
        d_staticContributions[i][j] = 0.0;
     dynamicContributions[i]=0;
     for (int j=0;j<20;j++)
        d_dynamicContributions[i][j] = 0.0;
  }

  // extract solution variables and set as Fad independent variables.
probeVars[admsProbeID_V_DI_GND] = (*solVectorPtr)[li_DI];
d_probeVars[admsProbeID_V_DI_GND][admsProbeID_V_DI_GND] = 1.0;
probeVars[admsProbeID_V_BS_GND] = (*solVectorPtr)[li_BS];
d_probeVars[admsProbeID_V_BS_GND][admsProbeID_V_BS_GND] = 1.0;
probeVars[admsProbeID_V_BD_GND] = (*solVectorPtr)[li_BD];
d_probeVars[admsProbeID_V_BD_GND][admsProbeID_V_BD_GND] = 1.0;
probeVars[admsProbeID_V_SI_GND] = (*solVectorPtr)[li_SI];
d_probeVars[admsProbeID_V_SI_GND][admsProbeID_V_SI_GND] = 1.0;
probeVars[admsProbeID_V_BP_GND] = (*solVectorPtr)[li_BP];
d_probeVars[admsProbeID_V_BP_GND][admsProbeID_V_BP_GND] = 1.0;
probeVars[admsProbeID_V_GP_GND] = (*solVectorPtr)[li_GP];
d_probeVars[admsProbeID_V_GP_GND][admsProbeID_V_GP_GND] = 1.0;
probeVars[admsProbeID_V_NOI_GND] = (*solVectorPtr)[li_NOI];
d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND] = 1.0;
probeVars[admsProbeID_V_NOI2_GND] = (*solVectorPtr)[li_NOI2];
d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND] = 1.0;
probeVars[admsProbeID_V_B_BI] = (*solVectorPtr)[li_B] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI] = 1.0;
probeVars[admsProbeID_V_BD_BI] = (*solVectorPtr)[li_BD] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI] = 1.0;
probeVars[admsProbeID_V_BS_BI] = (*solVectorPtr)[li_BS] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI] = 1.0;
probeVars[admsProbeID_V_BP_BI] = (*solVectorPtr)[li_BP] - (*solVectorPtr)[li_BI];
d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI] = 1.0;
probeVars[admsProbeID_V_D_DI] = (*solVectorPtr)[li_D] - (*solVectorPtr)[li_DI];
d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI] = 1.0;
probeVars[admsProbeID_V_S_SI] = (*solVectorPtr)[li_S] - (*solVectorPtr)[li_SI];
d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI] = 1.0;
probeVars[admsProbeID_V_G_GP] = (*solVectorPtr)[li_G] - (*solVectorPtr)[li_GP];
d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP] = 1.0;
probeVars[admsProbeID_V_DI_BD] = (*solVectorPtr)[li_DI] - (*solVectorPtr)[li_BD];
d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD] = 1.0;
probeVars[admsProbeID_V_SI_BS] = (*solVectorPtr)[li_SI] - (*solVectorPtr)[li_BS];
d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS] = 1.0;
probeVars[admsProbeID_V_SI_BP] = (*solVectorPtr)[li_SI] - (*solVectorPtr)[li_BP];
d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP] = 1.0;
probeVars[admsProbeID_V_DI_SI] = (*solVectorPtr)[li_DI] - (*solVectorPtr)[li_SI];
d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI] = 1.0;
probeVars[admsProbeID_V_GP_SI] = (*solVectorPtr)[li_GP] - (*solVectorPtr)[li_SI];
d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI] = 1.0;
// -- code converted from analog/code block
//Begin block evaluateblock
{
//Block-local variables for block evaluateblock
double sigVds=0.0;
double dphit1=0.0;
     double d_dphit1_dV_GP_SI=0.0;
     double d_dphit1_dV_DI_SI=0.0;
     double d_dphit1_dV_SI_BP=0.0;
double phit1=0.0;
     double d_phit1_dV_GP_SI=0.0;
     double d_phit1_dV_DI_SI=0.0;
     double d_phit1_dV_SI_BP=0.0;
double inv_phit1=0.0;
     double d_inv_phit1_dV_GP_SI=0.0;
     double d_inv_phit1_dV_DI_SI=0.0;
     double d_inv_phit1_dV_SI_BP=0.0;
double xg_dc=0.0;
     double d_xg_dc_dV_DI_SI=0.0;
     double d_xg_dc_dV_GP_SI=0.0;
     double d_xg_dc_dV_SI_BP=0.0;
double alpha_dc=0.0;
     double d_alpha_dc_dV_DI_SI=0.0;
     double d_alpha_dc_dV_GP_SI=0.0;
     double d_alpha_dc_dV_SI_BP=0.0;
double dps_dc=0.0;
     double d_dps_dc_dV_DI_SI=0.0;
     double d_dps_dc_dV_GP_SI=0.0;
     double d_dps_dc_dV_SI_BP=0.0;
double qim_dc=0.0;
     double d_qim_dc_dV_DI_SI=0.0;
     double d_qim_dc_dV_SI_BP=0.0;
     double d_qim_dc_dV_GP_SI=0.0;
double qim1_dc=0.0;
     double d_qim1_dc_dV_DI_SI=0.0;
     double d_qim1_dc_dV_SI_BP=0.0;
     double d_qim1_dc_dV_GP_SI=0.0;
double H_dc=0.0;
     double d_H_dc_dV_GP_SI=0.0;
     double d_H_dc_dV_DI_SI=0.0;
     double d_H_dc_dV_SI_BP=0.0;
double FdL_dc=0.0;
     double d_FdL_dc_dV_DI_SI=0.0;
     double d_FdL_dc_dV_GP_SI=0.0;
     double d_FdL_dc_dV_SI_BP=0.0;
double Gvsatinv_dc=0.0;
     double d_Gvsatinv_dc_dV_DI_SI=0.0;
     double d_Gvsatinv_dc_dV_GP_SI=0.0;
     double d_Gvsatinv_dc_dV_SI_BP=0.0;
double Ids=0.0;
     double d_Ids_dV_DI_SI=0.0;
     double d_Ids_dV_GP_SI=0.0;
     double d_Ids_dV_SI_BP=0.0;
double Iimpact=0.0;
     double d_Iimpact_dV_DI_SI=0.0;
     double d_Iimpact_dV_GP_SI=0.0;
     double d_Iimpact_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double mavl=0.0;
     double d_mavl_dV_DI_SI=0.0;
     double d_mavl_dV_GP_SI=0.0;
     double d_mavl_dV_SI_BP=0.0;
double Igdov=0.0;
     double d_Igdov_dV_GP_SI=0.0;
     double d_Igdov_dV_DI_SI=0.0;
     double d_Igdov_dV_SI_BP=0.0;
double Igsov=0.0;
     double d_Igsov_dV_GP_SI=0.0;
     double d_Igsov_dV_DI_SI=0.0;
     double d_Igsov_dV_SI_BP=0.0;
double Igcd=0.0;
     double d_Igcd_dV_GP_SI=0.0;
     double d_Igcd_dV_DI_SI=0.0;
     double d_Igcd_dV_SI_BP=0.0;
double Igcs=0.0;
     double d_Igcs_dV_GP_SI=0.0;
     double d_Igcs_dV_DI_SI=0.0;
     double d_Igcs_dV_SI_BP=0.0;
double eta_p_ac=0.0;
     double d_eta_p_ac_dV_DI_SI=0.0;
     double d_eta_p_ac_dV_GP_SI=0.0;
     double d_eta_p_ac_dV_SI_BP=0.0;
double Gvsat_ac=0.0;
     double d_Gvsat_ac_dV_DI_SI=0.0;
     double d_Gvsat_ac_dV_GP_SI=0.0;
     double d_Gvsat_ac_dV_SI_BP=0.0;
double Gmob_dL_ac=0.0;
     double d_Gmob_dL_ac_dV_DI_SI=0.0;
     double d_Gmob_dL_ac_dV_GP_SI=0.0;
     double d_Gmob_dL_ac_dV_SI_BP=0.0;
double H0=0.0;
     double d_H0_dV_DI_SI=0.0;
     double d_H0_dV_SI_BP=0.0;
     double d_H0_dV_GP_SI=0.0;
double COX_qm=0.0;
     double d_COX_qm_dV_DI_SI=0.0;
     double d_COX_qm_dV_GP_SI=0.0;
     double d_COX_qm_dV_SI_BP=0.0;
double ijun_s=0.0;
     double d_ijun_s_dV_DI_BD=0.0;
     double d_ijun_s_dV_SI_BS=0.0;
double ijunbot_s=0.0;
     double d_ijunbot_s_dV_SI_BS=0.0;
     double d_ijunbot_s_dV_DI_BD=0.0;
double ijunsti_s=0.0;
     double d_ijunsti_s_dV_SI_BS=0.0;
     double d_ijunsti_s_dV_DI_BD=0.0;
double ijungat_s=0.0;
     double d_ijungat_s_dV_SI_BS=0.0;
     double d_ijungat_s_dV_DI_BD=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_d=0.0;
     double d_ijun_d_dV_DI_BD=0.0;
     double d_ijun_d_dV_SI_BS=0.0;
double ijunbot_d=0.0;
     double d_ijunbot_d_dV_DI_BD=0.0;
     double d_ijunbot_d_dV_SI_BS=0.0;
double ijunsti_d=0.0;
     double d_ijunsti_d_dV_DI_BD=0.0;
     double d_ijunsti_d_dV_SI_BS=0.0;
double ijungat_d=0.0;
     double d_ijungat_d_dV_DI_BD=0.0;
     double d_ijungat_d_dV_SI_BS=0.0;
double qjun_s=0.0;
     double d_qjun_s_dV_DI_BD=0.0;
     double d_qjun_s_dV_SI_BS=0.0;
double qjunbot_s=0.0;
     double d_qjunbot_s_dV_DI_BD=0.0;
     double d_qjunbot_s_dV_SI_BS=0.0;
double qjunsti_s=0.0;
     double d_qjunsti_s_dV_DI_BD=0.0;
     double d_qjunsti_s_dV_SI_BS=0.0;
double qjungat_s=0.0;
     double d_qjungat_s_dV_DI_BD=0.0;
     double d_qjungat_s_dV_SI_BS=0.0;
double qjun_d=0.0;
     double d_qjun_d_dV_DI_BD=0.0;
     double d_qjun_d_dV_SI_BS=0.0;
double qjunbot_d=0.0;
     double d_qjunbot_d_dV_DI_BD=0.0;
     double d_qjunbot_d_dV_SI_BS=0.0;
double qjunsti_d=0.0;
     double d_qjunsti_d_dV_DI_BD=0.0;
     double d_qjunsti_d_dV_SI_BS=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjungat_d=0.0;
     double d_qjungat_d_dV_DI_BD=0.0;
     double d_qjungat_d_dV_SI_BS=0.0;
double jnoise_s=0.0;
double jnoise_d=0.0;
double Gmob_dc=0.0;
     double d_Gmob_dc_dV_DI_SI=0.0;
     double d_Gmob_dc_dV_GP_SI=0.0;
     double d_Gmob_dc_dV_SI_BP=0.0;
double xitsb_dc=0.0;
     double d_xitsb_dc_dV_DI_SI=0.0;
     double d_xitsb_dc_dV_SI_BP=0.0;
double Vdse_dc=0.0;
     double d_Vdse_dc_dV_GP_SI=0.0;
     double d_Vdse_dc_dV_SI_BP=0.0;
     double d_Vdse_dc_dV_DI_SI=0.0;
double Vsbstaredge=0.0;
     double d_Vsbstaredge_dV_DI_SI=0.0;
     double d_Vsbstaredge_dV_SI_BP=0.0;
     double d_Vsbstaredge_dV_GP_SI=0.0;
double Vsbxedge=0.0;
     double d_Vsbxedge_dV_DI_SI=0.0;
     double d_Vsbxedge_dV_SI_BP=0.0;
     double d_Vsbxedge_dV_GP_SI=0.0;
double dphit1edge=0.0;
     double d_dphit1edge_dV_DI_SI=0.0;
     double d_dphit1edge_dV_SI_BP=0.0;
     double d_dphit1edge_dV_GP_SI=0.0;
double phit1edge=0.0;
     double d_phit1edge_dV_DI_SI=0.0;
     double d_phit1edge_dV_SI_BP=0.0;
     double d_phit1edge_dV_GP_SI=0.0;
double inv_phit1edge=0.0;
     double d_inv_phit1edge_dV_DI_SI=0.0;
     double d_inv_phit1edge_dV_SI_BP=0.0;
     double d_inv_phit1edge_dV_GP_SI=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double Vdspedge=0.0;
     double d_Vdspedge_dV_DI_SI=0.0;
double delVgedge=0.0;
     double d_delVgedge_dV_DI_SI=0.0;
     double d_delVgedge_dV_SI_BP=0.0;
     double d_delVgedge_dV_GP_SI=0.0;
double xgedge=0.0;
     double d_xgedge_dV_DI_SI=0.0;
     double d_xgedge_dV_SI_BP=0.0;
     double d_xgedge_dV_GP_SI=0.0;
double xbedge=0.0;
     double d_xbedge_dV_DI_SI=0.0;
     double d_xbedge_dV_SI_BP=0.0;
     double d_xbedge_dV_GP_SI=0.0;
double dxthedge=0.0;
     double d_dxthedge_dV_DI_SI=0.0;
     double d_dxthedge_dV_SI_BP=0.0;
     double d_dxthedge_dV_GP_SI=0.0;
double xnedge_s=0.0;
     double d_xnedge_s_dV_DI_SI=0.0;
     double d_xnedge_s_dV_SI_BP=0.0;
     double d_xnedge_s_dV_GP_SI=0.0;
double qseffedge=0.0;
     double d_qseffedge_dV_DI_SI=0.0;
     double d_qseffedge_dV_SI_BP=0.0;
     double d_qseffedge_dV_GP_SI=0.0;
double xnedge_d=0.0;
     double d_xnedge_d_dV_DI_SI=0.0;
     double d_xnedge_d_dV_SI_BP=0.0;
     double d_xnedge_d_dV_GP_SI=0.0;
double qdseffedge=0.0;
     double d_qdseffedge_dV_DI_SI=0.0;
     double d_qdseffedge_dV_SI_BP=0.0;
     double d_qdseffedge_dV_GP_SI=0.0;
double qdeffedge=0.0;
     double d_qdeffedge_dV_DI_SI=0.0;
     double d_qdeffedge_dV_SI_BP=0.0;
     double d_qdeffedge_dV_GP_SI=0.0;
double qmeffedge=0.0;
     double d_qmeffedge_dV_DI_SI=0.0;
     double d_qmeffedge_dV_SI_BP=0.0;
     double d_qmeffedge_dV_GP_SI=0.0;
double dsqredge=0.0;
     double d_dsqredge_dV_DI_SI=0.0;
     double d_dsqredge_dV_SI_BP=0.0;
     double d_dsqredge_dV_GP_SI=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double alphabmedge=0.0;
     double d_alphabmedge_dV_DI_SI=0.0;
     double d_alphabmedge_dV_SI_BP=0.0;
     double d_alphabmedge_dV_GP_SI=0.0;
double Idsedge=0.0;
     double d_Idsedge_dV_DI_SI=0.0;
     double d_Idsedge_dV_SI_BP=0.0;
     double d_Idsedge_dV_GP_SI=0.0;
double Sfledge=0.0;
double midedge=0.0;
double sqidedge=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double temp=0.0;
     double d_temp_dV_GP_SI=0.0;
     double d_temp_dV_DI_SI=0.0;
     double d_temp_dV_SI_BP=0.0;
double temp1=0.0;
     double d_temp1_dV_GP_SI=0.0;
     double d_temp1_dV_DI_SI=0.0;
     double d_temp1_dV_SI_BP=0.0;
double temp2=0.0;
     double d_temp2_dV_DI_SI=0.0;
     double d_temp2_dV_GP_SI=0.0;
     double d_temp2_dV_SI_BP=0.0;
//End of Block-local variables
//Begin block evaluateStatic
{

d_temp_dV_GP_SI = d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
temp = 0.0;

d_temp1_dV_GP_SI = d_temp1_dV_DI_SI = d_temp1_dV_SI_BP =  0.0;
temp1 = 0.0;

d_temp2_dV_DI_SI = d_temp2_dV_GP_SI = d_temp2_dV_SI_BP =  0.0;
temp2 = 0.0;

d_QCLM_dV_DI_SI = d_QCLM_dV_GP_SI = d_QCLM_dV_SI_BP =  0.0;
QCLM = 0.0;

d_xs_ov_dV_GP_SI =  0.0;
xs_ov = 0.0;

d_xd_ov_dV_DI_SI = d_xd_ov_dV_GP_SI =  0.0;
xd_ov = 0.0;

d_Vovs_dV_GP_SI =  0.0;
Vovs = 0.0;

d_Vovd_dV_GP_SI = d_Vovd_dV_DI_SI =  0.0;
Vovd = 0.0;

d_Iimpact_dV_DI_SI = d_Iimpact_dV_GP_SI = d_Iimpact_dV_SI_BP =  0.0;
Iimpact = 0.0;

d_mavl_dV_DI_SI = d_mavl_dV_GP_SI = d_mavl_dV_SI_BP =  0.0;
mavl = 0.0;
if (((model_.CHNL_TYPE)==(+1)))
{

d_Vgs_dV_DI_SI =  0.0;
d_Vgs_dV_GP_SI = d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI];
Vgs = (probeVars[admsProbeID_V_GP_SI]);

d_Vds_dV_DI_SI = d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI];
Vds = (probeVars[admsProbeID_V_DI_SI]);

d_Vsb_dV_DI_SI =  0.0;
d_Vsb_dV_SI_BP = d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP];
Vsb = (probeVars[admsProbeID_V_SI_BP]);

d_Vjun_s_dV_SI_BS = (-d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS]);
Vjun_s = (-(probeVars[admsProbeID_V_SI_BS]));

d_Vjun_d_dV_DI_BD = (-d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD]);
Vjun_d = (-(probeVars[admsProbeID_V_DI_BD]));
}
else
{

d_Vgs_dV_DI_SI =  0.0;
d_Vgs_dV_GP_SI = (-d_probeVars[admsProbeID_V_GP_SI][admsProbeID_V_GP_SI]);
Vgs = (-(probeVars[admsProbeID_V_GP_SI]));

d_Vds_dV_DI_SI = (-d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI]);
Vds = (-(probeVars[admsProbeID_V_DI_SI]));

d_Vsb_dV_DI_SI =  0.0;
d_Vsb_dV_SI_BP = (-d_probeVars[admsProbeID_V_SI_BP][admsProbeID_V_SI_BP]);
Vsb = (-(probeVars[admsProbeID_V_SI_BP]));

d_Vjun_s_dV_SI_BS = d_probeVars[admsProbeID_V_SI_BS][admsProbeID_V_SI_BS];
Vjun_s = (probeVars[admsProbeID_V_SI_BS]);

d_Vjun_d_dV_DI_BD = d_probeVars[admsProbeID_V_DI_BD][admsProbeID_V_DI_BD];
Vjun_d = (probeVars[admsProbeID_V_DI_BD]);
}

d_VgsPrime_dV_GP_SI = d_Vgs_dV_GP_SI;
VgsPrime = Vgs;

d_VsbPrime_dV_SI_BP = d_Vsb_dV_SI_BP;
VsbPrime = Vsb;

d_VdbPrime_dV_SI_BP = d_Vsb_dV_SI_BP;
d_VdbPrime_dV_DI_SI = (d_Vds_dV_DI_SI+d_Vsb_dV_DI_SI);
VdbPrime = (Vds+Vsb);

d_VgdPrime_dV_DI_SI = (d_Vgs_dV_DI_SI-d_Vds_dV_DI_SI);
d_VgdPrime_dV_GP_SI = d_Vgs_dV_GP_SI;
VgdPrime = (Vgs-Vds);

d_xgs_ov_dV_GP_SI = (-d_VgsPrime_dV_GP_SI)*(model_.inv_phita);
xgs_ov = ((-VgsPrime)*(model_.inv_phita));

d_xgd_ov_dV_DI_SI = (-d_VgdPrime_dV_DI_SI)*(model_.inv_phita);
d_xgd_ov_dV_GP_SI = (-d_VgdPrime_dV_GP_SI)*(model_.inv_phita);
xgd_ov = ((-VgdPrime)*(model_.inv_phita));
sigVds = 1.0;
if ((Vds<0.0))
{
sigVds = (-1.0);

d_Vgs_dV_DI_SI = (d_Vgs_dV_DI_SI-d_Vds_dV_DI_SI);
Vgs = (Vgs-Vds);

d_Vsb_dV_DI_SI = (d_Vsb_dV_DI_SI+d_Vds_dV_DI_SI);
Vsb = (Vsb+Vds);

d_Vds_dV_DI_SI = (-d_Vds_dV_DI_SI);
Vds = (-Vds);
}

d_Vdb_dV_SI_BP = d_Vsb_dV_SI_BP;
d_Vdb_dV_DI_SI = (d_Vds_dV_DI_SI+d_Vsb_dV_DI_SI);
Vdb = (Vds+Vsb);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsx_dV_DI_SI = (((value_sqrt_0+0.1)*(Vds*d_Vds_dV_DI_SI+d_Vds_dV_DI_SI*Vds)-(Vds*Vds)*(deriv_sqrt_0_d0*((Vds*d_Vds_dV_DI_SI+d_Vds_dV_DI_SI*Vds))))/(value_sqrt_0+0.1)/(value_sqrt_0+0.1));
Vdsx = ((Vds*Vds)/(value_sqrt_0+0.1));
}
//Begin block SPcalc_dc
{
//Block-local variables for block SPcalc_dc
double phib=0.0;
double G_0=0.0;
double Vsbstar=0.0;
     double d_Vsbstar_dV_DI_SI=0.0;
     double d_Vsbstar_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double Vsbx=0.0;
     double d_Vsbx_dV_DI_SI=0.0;
     double d_Vsbx_dV_SI_BP=0.0;
double xg=0.0;
     double d_xg_dV_DI_SI=0.0;
     double d_xg_dV_GP_SI=0.0;
     double d_xg_dV_SI_BP=0.0;
double Dnsub=0.0;
     double d_Dnsub_dV_DI_SI=0.0;
     double d_Dnsub_dV_GP_SI=0.0;
     double d_Dnsub_dV_SI_BP=0.0;
double Gf=0.0;
     double d_Gf_dV_DI_SI=0.0;
     double d_Gf_dV_GP_SI=0.0;
     double d_Gf_dV_SI_BP=0.0;
double Gf2=0.0;
     double d_Gf2_dV_DI_SI=0.0;
     double d_Gf2_dV_GP_SI=0.0;
     double d_Gf2_dV_SI_BP=0.0;
double inv_Gf2=0.0;
     double d_inv_Gf2_dV_DI_SI=0.0;
     double d_inv_Gf2_dV_GP_SI=0.0;
     double d_inv_Gf2_dV_SI_BP=0.0;
double xi=0.0;
     double d_xi_dV_DI_SI=0.0;
     double d_xi_dV_GP_SI=0.0;
     double d_xi_dV_SI_BP=0.0;
double inv_xi=0.0;
     double d_inv_xi_dV_DI_SI=0.0;
     double d_inv_xi_dV_GP_SI=0.0;
     double d_inv_xi_dV_SI_BP=0.0;
double Ux=0.0;
     double d_Ux_dV_DI_SI=0.0;
     double d_Ux_dV_SI_BP=0.0;
double xn_s=0.0;
     double d_xn_s_dV_DI_SI=0.0;
     double d_xn_s_dV_SI_BP=0.0;
double delta_ns=0.0;
     double d_delta_ns_dV_DI_SI=0.0;
     double d_delta_ns_dV_SI_BP=0.0;
double margin=0.0;
     double d_margin_dV_DI_SI=0.0;
     double d_margin_dV_GP_SI=0.0;
     double d_margin_dV_SI_BP=0.0;
double x_s=0.0;
     double d_x_s_dV_DI_SI=0.0;
     double d_x_s_dV_GP_SI=0.0;
     double d_x_s_dV_SI_BP=0.0;
double delta_1s=0.0;
     double d_delta_1s_dV_DI_SI=0.0;
     double d_delta_1s_dV_GP_SI=0.0;
     double d_delta_1s_dV_SI_BP=0.0;
double xi0s=0.0;
     double d_xi0s_dV_DI_SI=0.0;
     double d_xi0s_dV_GP_SI=0.0;
     double d_xi0s_dV_SI_BP=0.0;
double xi1s=0.0;
     double d_xi1s_dV_DI_SI=0.0;
     double d_xi1s_dV_GP_SI=0.0;
     double d_xi1s_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double xi2s=0.0;
     double d_xi2s_dV_GP_SI=0.0;
     double d_xi2s_dV_DI_SI=0.0;
     double d_xi2s_dV_SI_BP=0.0;
double Es=0.0;
     double d_Es_dV_DI_SI=0.0;
     double d_Es_dV_GP_SI=0.0;
     double d_Es_dV_SI_BP=0.0;
double Ds=0.0;
     double d_Ds_dV_DI_SI=0.0;
     double d_Ds_dV_GP_SI=0.0;
     double d_Ds_dV_SI_BP=0.0;
double Ps=0.0;
     double d_Ps_dV_DI_SI=0.0;
     double d_Ps_dV_GP_SI=0.0;
     double d_Ps_dV_SI_BP=0.0;
double Rxcor=0.0;
     double d_Rxcor_dV_DI_SI=0.0;
     double d_Rxcor_dV_SI_BP=0.0;
double xgs=0.0;
     double d_xgs_dV_DI_SI=0.0;
     double d_xgs_dV_GP_SI=0.0;
     double d_xgs_dV_SI_BP=0.0;
double qis=0.0;
     double d_qis_dV_DI_SI=0.0;
     double d_qis_dV_GP_SI=0.0;
     double d_qis_dV_SI_BP=0.0;
double qbs=0.0;
     double d_qbs_dV_DI_SI=0.0;
     double d_qbs_dV_GP_SI=0.0;
     double d_qbs_dV_SI_BP=0.0;
double rhob=0.0;
     double d_rhob_dV_DI_SI=0.0;
     double d_rhob_dV_SI_BP=0.0;
double GR=0.0;
     double d_GR_dV_DI_SI=0.0;
     double d_GR_dV_SI_BP=0.0;
     double d_GR_dV_GP_SI=0.0;
double Eeffm=0.0;
     double d_Eeffm_dV_DI_SI=0.0;
     double d_Eeffm_dV_GP_SI=0.0;
     double d_Eeffm_dV_SI_BP=0.0;
double Mutmp=0.0;
     double d_Mutmp_dV_DI_SI=0.0;
     double d_Mutmp_dV_GP_SI=0.0;
     double d_Mutmp_dV_SI_BP=0.0;
double Gmob=0.0;
     double d_Gmob_dV_DI_SI=0.0;
     double d_Gmob_dV_GP_SI=0.0;
     double d_Gmob_dV_SI_BP=0.0;
double xitsb=0.0;
     double d_xitsb_dV_DI_SI=0.0;
     double d_xitsb_dV_SI_BP=0.0;
double wsat=0.0;
     double d_wsat_dV_DI_SI=0.0;
     double d_wsat_dV_GP_SI=0.0;
     double d_wsat_dV_SI_BP=0.0;
double thesat1=0.0;
     double d_thesat1_dV_GP_SI=0.0;
     double d_thesat1_dV_DI_SI=0.0;
     double d_thesat1_dV_SI_BP=0.0;
double phi_inf=0.0;
     double d_phi_inf_dV_DI_SI=0.0;
     double d_phi_inf_dV_GP_SI=0.0;
     double d_phi_inf_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double ysat=0.0;
     double d_ysat_dV_GP_SI=0.0;
     double d_ysat_dV_DI_SI=0.0;
     double d_ysat_dV_SI_BP=0.0;
double za=0.0;
     double d_za_dV_GP_SI=0.0;
     double d_za_dV_DI_SI=0.0;
     double d_za_dV_SI_BP=0.0;
double Phi_0=0.0;
     double d_Phi_0_dV_DI_SI=0.0;
     double d_Phi_0_dV_GP_SI=0.0;
     double d_Phi_0_dV_SI_BP=0.0;
double asat=0.0;
     double d_asat_dV_DI_SI=0.0;
     double d_asat_dV_GP_SI=0.0;
     double d_asat_dV_SI_BP=0.0;
double Phi_2=0.0;
     double d_Phi_2_dV_DI_SI=0.0;
     double d_Phi_2_dV_GP_SI=0.0;
     double d_Phi_2_dV_SI_BP=0.0;
double Phi_0_2=0.0;
     double d_Phi_0_2_dV_DI_SI=0.0;
     double d_Phi_0_2_dV_GP_SI=0.0;
     double d_Phi_0_2_dV_SI_BP=0.0;
double Phi0_Phi2=0.0;
     double d_Phi0_Phi2_dV_DI_SI=0.0;
     double d_Phi0_Phi2_dV_GP_SI=0.0;
     double d_Phi0_Phi2_dV_SI_BP=0.0;
double Phi_sat=0.0;
     double d_Phi_sat_dV_DI_SI=0.0;
     double d_Phi_sat_dV_GP_SI=0.0;
     double d_Phi_sat_dV_SI_BP=0.0;
double Vdse=0.0;
     double d_Vdse_dV_GP_SI=0.0;
     double d_Vdse_dV_SI_BP=0.0;
     double d_Vdse_dV_DI_SI=0.0;
double Udse=0.0;
     double d_Udse_dV_GP_SI=0.0;
     double d_Udse_dV_SI_BP=0.0;
     double d_Udse_dV_DI_SI=0.0;
double xn_d=0.0;
     double d_xn_d_dV_DI_SI=0.0;
     double d_xn_d_dV_SI_BP=0.0;
     double d_xn_d_dV_GP_SI=0.0;
double k_ds=0.0;
     double d_k_ds_dV_GP_SI=0.0;
     double d_k_ds_dV_SI_BP=0.0;
     double d_k_ds_dV_DI_SI=0.0;
double delta_nd=0.0;
     double d_delta_nd_dV_DI_SI=0.0;
     double d_delta_nd_dV_SI_BP=0.0;
     double d_delta_nd_dV_GP_SI=0.0;
double x_d=0.0;
     double d_x_d_dV_DI_SI=0.0;
     double d_x_d_dV_GP_SI=0.0;
     double d_x_d_dV_SI_BP=0.0;
double x_ds=0.0;
     double d_x_ds_dV_DI_SI=0.0;
     double d_x_ds_dV_GP_SI=0.0;
     double d_x_ds_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double pC=0.0;
     double d_pC_dV_DI_SI=0.0;
     double d_pC_dV_GP_SI=0.0;
     double d_pC_dV_SI_BP=0.0;
double qC=0.0;
     double d_qC_dV_DI_SI=0.0;
     double d_qC_dV_GP_SI=0.0;
     double d_qC_dV_SI_BP=0.0;
double dps=0.0;
     double d_dps_dV_DI_SI=0.0;
     double d_dps_dV_GP_SI=0.0;
     double d_dps_dV_SI_BP=0.0;
double xi0d=0.0;
     double d_xi0d_dV_DI_SI=0.0;
     double d_xi0d_dV_GP_SI=0.0;
     double d_xi0d_dV_SI_BP=0.0;
double Ed=0.0;
     double d_Ed_dV_DI_SI=0.0;
     double d_Ed_dV_GP_SI=0.0;
     double d_Ed_dV_SI_BP=0.0;
double Dd=0.0;
     double d_Dd_dV_DI_SI=0.0;
     double d_Dd_dV_GP_SI=0.0;
     double d_Dd_dV_SI_BP=0.0;
double x_m=0.0;
     double d_x_m_dV_DI_SI=0.0;
     double d_x_m_dV_GP_SI=0.0;
     double d_x_m_dV_SI_BP=0.0;
double Em=0.0;
     double d_Em_dV_DI_SI=0.0;
     double d_Em_dV_GP_SI=0.0;
     double d_Em_dV_SI_BP=0.0;
double D_bar=0.0;
     double d_D_bar_dV_DI_SI=0.0;
     double d_D_bar_dV_GP_SI=0.0;
     double d_D_bar_dV_SI_BP=0.0;
double Dm=0.0;
     double d_Dm_dV_DI_SI=0.0;
     double d_Dm_dV_GP_SI=0.0;
     double d_Dm_dV_SI_BP=0.0;
double Pm=0.0;
     double d_Pm_dV_DI_SI=0.0;
     double d_Pm_dV_GP_SI=0.0;
     double d_Pm_dV_SI_BP=0.0;
double xgm=0.0;
     double d_xgm_dV_DI_SI=0.0;
     double d_xgm_dV_GP_SI=0.0;
     double d_xgm_dV_SI_BP=0.0;
double eta_p=0.0;
     double d_eta_p_dV_DI_SI=0.0;
     double d_eta_p_dV_GP_SI=0.0;
     double d_eta_p_dV_SI_BP=0.0;
double sqm=0.0;
     double d_sqm_dV_DI_SI=0.0;
     double d_sqm_dV_GP_SI=0.0;
     double d_sqm_dV_SI_BP=0.0;
double alpha=0.0;
     double d_alpha_dV_DI_SI=0.0;
     double d_alpha_dV_GP_SI=0.0;
     double d_alpha_dV_SI_BP=0.0;
double d0=0.0;
     double d_d0_dV_DI_SI=0.0;
     double d_d0_dV_GP_SI=0.0;
     double d_d0_dV_SI_BP=0.0;
double x_pm=0.0;
     double d_x_pm_dV_GP_SI=0.0;
     double d_x_pm_dV_DI_SI=0.0;
     double d_x_pm_dV_SI_BP=0.0;
double p_pd=0.0;
     double d_p_pd_dV_DI_SI=0.0;
     double d_p_pd_dV_GP_SI=0.0;
     double d_p_pd_dV_SI_BP=0.0;
double q_pd=0.0;
     double d_q_pd_dV_GP_SI=0.0;
     double d_q_pd_dV_DI_SI=0.0;
     double d_q_pd_dV_SI_BP=0.0;
double xi_pd=0.0;
     double d_xi_pd_dV_DI_SI=0.0;
     double d_xi_pd_dV_GP_SI=0.0;
     double d_xi_pd_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double u_pd=0.0;
     double d_u_pd_dV_GP_SI=0.0;
     double d_u_pd_dV_DI_SI=0.0;
     double d_u_pd_dV_SI_BP=0.0;
double km=0.0;
     double d_km_dV_GP_SI=0.0;
     double d_km_dV_DI_SI=0.0;
     double d_km_dV_SI_BP=0.0;
double km0=0.0;
     double d_km0_dV_DI_SI=0.0;
     double d_km0_dV_GP_SI=0.0;
     double d_km0_dV_SI_BP=0.0;
double qim=0.0;
     double d_qim_dV_DI_SI=0.0;
     double d_qim_dV_SI_BP=0.0;
     double d_qim_dV_GP_SI=0.0;
double qim1=0.0;
     double d_qim1_dV_DI_SI=0.0;
     double d_qim1_dV_SI_BP=0.0;
     double d_qim1_dV_GP_SI=0.0;
double qbm=0.0;
     double d_qbm_dV_DI_SI=0.0;
     double d_qbm_dV_GP_SI=0.0;
     double d_qbm_dV_SI_BP=0.0;
double qeff=0.0;
     double d_qeff_dV_DI_SI=0.0;
     double d_qeff_dV_GP_SI=0.0;
     double d_qeff_dV_SI_BP=0.0;
double qeff1=0.0;
     double d_qeff1_dV_DI_SI=0.0;
     double d_qeff1_dV_GP_SI=0.0;
     double d_qeff1_dV_SI_BP=0.0;
double s1=0.0;
     double d_s1_dV_DI_SI=0.0;
     double d_s1_dV_GP_SI=0.0;
     double d_s1_dV_SI_BP=0.0;
double dL=0.0;
     double d_dL_dV_DI_SI=0.0;
     double d_dL_dV_GP_SI=0.0;
     double d_dL_dV_SI_BP=0.0;
double GdL=0.0;
     double d_GdL_dV_DI_SI=0.0;
     double d_GdL_dV_GP_SI=0.0;
     double d_GdL_dV_SI_BP=0.0;
double Gmob_dL=0.0;
     double d_Gmob_dL_dV_DI_SI=0.0;
     double d_Gmob_dL_dV_GP_SI=0.0;
     double d_Gmob_dL_dV_SI_BP=0.0;
double zsat=0.0;
     double d_zsat_dV_GP_SI=0.0;
     double d_zsat_dV_DI_SI=0.0;
     double d_zsat_dV_SI_BP=0.0;
double Gvsat=0.0;
     double d_Gvsat_dV_DI_SI=0.0;
     double d_Gvsat_dV_GP_SI=0.0;
     double d_Gvsat_dV_SI_BP=0.0;
double Gvsatinv=0.0;
     double d_Gvsatinv_dV_DI_SI=0.0;
     double d_Gvsatinv_dV_GP_SI=0.0;
     double d_Gvsatinv_dV_SI_BP=0.0;
double Voxm=0.0;
     double d_Voxm_dV_DI_SI=0.0;
     double d_Voxm_dV_GP_SI=0.0;
     double d_Voxm_dV_SI_BP=0.0;
double alpha1=0.0;
     double d_alpha1_dV_DI_SI=0.0;
     double d_alpha1_dV_GP_SI=0.0;
     double d_alpha1_dV_SI_BP=0.0;
double H=0.0;
     double d_H_dV_GP_SI=0.0;
     double d_H_dV_DI_SI=0.0;
     double d_H_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_temp=0.0;
     double d_SP_S_temp_dV_DI_SI=0.0;
     double d_SP_S_temp_dV_GP_SI=0.0;
     double d_SP_S_temp_dV_SI_BP=0.0;
double SP_S_temp1=0.0;
     double d_SP_S_temp1_dV_DI_SI=0.0;
     double d_SP_S_temp1_dV_GP_SI=0.0;
     double d_SP_S_temp1_dV_SI_BP=0.0;
double SP_S_temp2=0.0;
     double d_SP_S_temp2_dV_DI_SI=0.0;
     double d_SP_S_temp2_dV_GP_SI=0.0;
     double d_SP_S_temp2_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_yg=0.0;
     double d_SP_S_yg_dV_DI_SI=0.0;
     double d_SP_S_yg_dV_GP_SI=0.0;
     double d_SP_S_yg_dV_SI_BP=0.0;
double SP_S_ysub=0.0;
     double d_SP_S_ysub_dV_DI_SI=0.0;
     double d_SP_S_ysub_dV_GP_SI=0.0;
     double d_SP_S_ysub_dV_SI_BP=0.0;
double SP_S_eta=0.0;
     double d_SP_S_eta_dV_DI_SI=0.0;
     double d_SP_S_eta_dV_GP_SI=0.0;
     double d_SP_S_eta_dV_SI_BP=0.0;
double SP_S_a=0.0;
     double d_SP_S_a_dV_DI_SI=0.0;
     double d_SP_S_a_dV_GP_SI=0.0;
     double d_SP_S_a_dV_SI_BP=0.0;
double SP_S_c=0.0;
     double d_SP_S_c_dV_DI_SI=0.0;
     double d_SP_S_c_dV_GP_SI=0.0;
     double d_SP_S_c_dV_SI_BP=0.0;
double SP_S_tau=0.0;
     double d_SP_S_tau_dV_DI_SI=0.0;
     double d_SP_S_tau_dV_GP_SI=0.0;
     double d_SP_S_tau_dV_SI_BP=0.0;
double SP_S_y0=0.0;
     double d_SP_S_y0_dV_DI_SI=0.0;
     double d_SP_S_y0_dV_GP_SI=0.0;
     double d_SP_S_y0_dV_SI_BP=0.0;
double SP_S_delta0=0.0;
     double d_SP_S_delta0_dV_DI_SI=0.0;
     double d_SP_S_delta0_dV_GP_SI=0.0;
     double d_SP_S_delta0_dV_SI_BP=0.0;
double SP_S_delta1=0.0;
     double d_SP_S_delta1_dV_DI_SI=0.0;
     double d_SP_S_delta1_dV_GP_SI=0.0;
     double d_SP_S_delta1_dV_SI_BP=0.0;
double SP_S_xi0=0.0;
     double d_SP_S_xi0_dV_DI_SI=0.0;
     double d_SP_S_xi0_dV_GP_SI=0.0;
     double d_SP_S_xi0_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_xi1=0.0;
     double d_SP_S_xi1_dV_DI_SI=0.0;
     double d_SP_S_xi1_dV_GP_SI=0.0;
     double d_SP_S_xi1_dV_SI_BP=0.0;
double SP_S_xi2=0.0;
     double d_SP_S_xi2_dV_DI_SI=0.0;
     double d_SP_S_xi2_dV_GP_SI=0.0;
     double d_SP_S_xi2_dV_SI_BP=0.0;
double SP_S_pC=0.0;
     double d_SP_S_pC_dV_DI_SI=0.0;
     double d_SP_S_pC_dV_GP_SI=0.0;
     double d_SP_S_pC_dV_SI_BP=0.0;
double SP_S_qC=0.0;
     double d_SP_S_qC_dV_DI_SI=0.0;
     double d_SP_S_qC_dV_GP_SI=0.0;
     double d_SP_S_qC_dV_SI_BP=0.0;
double SP_xg1=0.0;
     double d_SP_xg1_dV_DI_SI=0.0;
     double d_SP_xg1_dV_GP_SI=0.0;
     double d_SP_xg1_dV_SI_BP=0.0;
double SP_S_A_fac=0.0;
     double d_SP_S_A_fac_dV_DI_SI=0.0;
     double d_SP_S_A_fac_dV_GP_SI=0.0;
     double d_SP_S_A_fac_dV_SI_BP=0.0;
double SP_S_xbar=0.0;
     double d_SP_S_xbar_dV_DI_SI=0.0;
     double d_SP_S_xbar_dV_GP_SI=0.0;
     double d_SP_S_xbar_dV_SI_BP=0.0;
double SP_S_w=0.0;
     double d_SP_S_w_dV_DI_SI=0.0;
     double d_SP_S_w_dV_GP_SI=0.0;
     double d_SP_S_w_dV_SI_BP=0.0;
double SP_S_x1=0.0;
     double d_SP_S_x1_dV_DI_SI=0.0;
     double d_SP_S_x1_dV_GP_SI=0.0;
     double d_SP_S_x1_dV_SI_BP=0.0;
double SP_S_bx=0.0;
     double d_SP_S_bx_dV_GP_SI=0.0;
     double d_SP_S_bx_dV_DI_SI=0.0;
     double d_SP_S_bx_dV_SI_BP=0.0;
double SP_S_b=0.0;
     double d_SP_S_b_dV_DI_SI=0.0;
     double d_SP_S_b_dV_GP_SI=0.0;
     double d_SP_S_b_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_x0=0.0;
     double d_SP_S_x0_dV_DI_SI=0.0;
     double d_SP_S_x0_dV_GP_SI=0.0;
     double d_SP_S_x0_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double FdL=0.0;
     double d_FdL_dV_DI_SI=0.0;
     double d_FdL_dV_GP_SI=0.0;
     double d_FdL_dV_SI_BP=0.0;
double qim1_1=0.0;
     double d_qim1_1_dV_DI_SI=0.0;
     double d_qim1_1_dV_SI_BP=0.0;
     double d_qim1_1_dV_GP_SI=0.0;
double r1=0.0;
     double d_r1_dV_DI_SI=0.0;
     double d_r1_dV_SI_BP=0.0;
     double d_r1_dV_GP_SI=0.0;
double r2=0.0;
     double d_r2_dV_DI_SI=0.0;
     double d_r2_dV_SI_BP=0.0;
     double d_r2_dV_GP_SI=0.0;
double s2=0.0;
     double d_s2_dV_DI_SI=0.0;
double dL1=0.0;
     double d_dL1_dV_DI_SI=0.0;
     double d_dL1_dV_GP_SI=0.0;
     double d_dL1_dV_SI_BP=0.0;
//End of Block-local variables
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_GP_SI =  0.0;
d_temp_dV_SI_BP = 0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)+(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))));
d_temp_dV_DI_SI = 0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)+(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))));
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix_dc);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+aphi_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vsbstar_dc_dV_SI_BP = (d_Vsb_dV_SI_BP-0.5*(d_temp_dV_SI_BP-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_SI_BP+d_temp_dV_SI_BP*(temp))))));
d_Vsbstar_dc_dV_DI_SI = (d_Vsb_dV_DI_SI-0.5*(d_temp_dV_DI_SI-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_DI_SI+d_temp_dV_DI_SI*(temp))))));
Vsbstar_dc = ((Vsb-(0.5*(temp-value_sqrt_0)))+phix1_dc);
}

d_Vsbstar_dc_tmp_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
d_Vsbstar_dc_tmp_dV_DI_SI = d_Vsbstar_dc_dV_DI_SI;
Vsbstar_dc_tmp = Vsbstar_dc;
if ((((model_.SWNUD_i)!=0)&&(GFACNUD_i!=1.0)))
{

d_Vmb_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
d_Vmb_dV_DI_SI = (d_Vsbstar_dc_dV_DI_SI+0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI));
Vmb = (Vsbstar_dc+(0.5*(Vds-Vdsx)));
{
double value_sqrt_0 = sqrt((Vmb+phib_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_us_dV_SI_BP = (deriv_sqrt_0_d0*(d_Vmb_dV_SI_BP));
d_us_dV_DI_SI = (deriv_sqrt_0_d0*(d_Vmb_dV_DI_SI));
us = (value_sqrt_0-sqrt_phib_dc);
}

d_temp_dV_GP_SI =  0.0;
d_temp_dV_SI_BP = (2.0*d_us_dV_SI_BP/us21);
d_temp_dV_DI_SI = (2.0*d_us_dV_DI_SI/us21);
temp = (((2.0*(us-us1))/us21)-1.0);
{
double value_sqrt_0 = sqrt(((temp*temp)+0.4804530139182));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_usnew_dV_SI_BP = (d_us_dV_SI_BP-((0.25*(1.0-GFACNUD_i))*us21)*(d_temp_dV_SI_BP+(deriv_sqrt_0_d0*((temp*d_temp_dV_SI_BP+d_temp_dV_SI_BP*temp)))));
d_usnew_dV_DI_SI = (d_us_dV_DI_SI-((0.25*(1.0-GFACNUD_i))*us21)*(d_temp_dV_DI_SI+(deriv_sqrt_0_d0*((temp*d_temp_dV_DI_SI+d_temp_dV_DI_SI*temp)))));
usnew = (us-(((0.25*(1.0-GFACNUD_i))*us21)*(temp+value_sqrt_0)));
}

d_Vmbnew_dV_SI_BP = ((usnew*d_usnew_dV_SI_BP+d_usnew_dV_SI_BP*usnew)+(2.0*sqrt_phib_dc)*d_usnew_dV_SI_BP);
d_Vmbnew_dV_DI_SI = ((usnew*d_usnew_dV_DI_SI+d_usnew_dV_DI_SI*usnew)+(2.0*sqrt_phib_dc)*d_usnew_dV_DI_SI);
Vmbnew = ((usnew*usnew)+((2.0*sqrt_phib_dc)*usnew));

d_Vsbstar_dc_dV_SI_BP = d_Vmbnew_dV_SI_BP;
d_Vsbstar_dc_dV_DI_SI = (d_Vmbnew_dV_DI_SI-0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI));
Vsbstar_dc = (Vmbnew-(0.5*(Vds-Vdsx)));
}
phib = phib_dc;
G_0 = G_0_dc;

d_Vsbstar_dV_SI_BP = d_Vsbstar_dc_dV_SI_BP;
d_Vsbstar_dV_DI_SI = d_Vsbstar_dc_dV_DI_SI;
Vsbstar = Vsbstar_dc;

d_FdL_dV_DI_SI = d_FdL_dV_GP_SI = d_FdL_dV_SI_BP =  0.0;
FdL = 1.0;

d_alpha_dV_DI_SI = d_alpha_dV_GP_SI = d_alpha_dV_SI_BP =  0.0;
alpha = 0.0;

d_GdL_dV_DI_SI = d_GdL_dV_GP_SI = d_GdL_dV_SI_BP =  0.0;
GdL = 1.0;

d_dL_dV_DI_SI = d_dL_dV_GP_SI = d_dL_dV_SI_BP =  0.0;
dL = 0.0;

d_qbm_dV_DI_SI = d_qbm_dV_GP_SI = d_qbm_dV_SI_BP =  0.0;
qbm = 0.0;

d_dps_dV_DI_SI = d_dps_dV_GP_SI = d_dps_dV_SI_BP =  0.0;
dps = 0.0;

d_qim_dV_DI_SI = d_qim_dV_SI_BP = d_qim_dV_GP_SI =  0.0;
qim = 0.0;

d_qim1_dV_DI_SI = d_qim1_dV_SI_BP = d_qim1_dV_GP_SI =  0.0;
qim1 = 0.0;

d_H_dV_GP_SI = d_H_dV_DI_SI = d_H_dV_SI_BP =  0.0;
H = 1.0;

d_s1_dV_DI_SI = d_s1_dV_GP_SI = d_s1_dV_SI_BP =  0.0;
s1 = 0.0;

d_eta_p_dV_DI_SI = d_eta_p_dV_GP_SI = d_eta_p_dV_SI_BP =  0.0;
eta_p = 1.0;

d_Gvsat_dV_DI_SI = d_Gvsat_dV_GP_SI = d_Gvsat_dV_SI_BP =  0.0;
Gvsat = 1.0;

d_Gvsatinv_dV_DI_SI = d_Gvsatinv_dV_GP_SI = d_Gvsatinv_dV_SI_BP =  0.0;
Gvsatinv = 1.0;

d_SP_S_x1_dV_DI_SI = d_SP_S_x1_dV_GP_SI = d_SP_S_x1_dV_SI_BP =  0.0;
SP_S_x1 = 0.0;

d_x_s_dV_DI_SI = d_x_s_dV_GP_SI = d_x_s_dV_SI_BP =  0.0;
x_s = 0.0;

d_sqm_dV_DI_SI = d_sqm_dV_GP_SI = d_sqm_dV_SI_BP =  0.0;
sqm = 0.0;

d_xitsb_dV_DI_SI = d_xitsb_dV_SI_BP =  0.0;
xitsb = 0.0;

d_rhob_dV_DI_SI = d_rhob_dV_SI_BP =  0.0;
rhob = 0.0;

d_Gmob_dV_DI_SI = d_Gmob_dV_GP_SI = d_Gmob_dV_SI_BP =  0.0;
Gmob = 1.0;

d_Gmob_dL_dV_DI_SI = d_Gmob_dL_dV_GP_SI = d_Gmob_dL_dV_SI_BP =  0.0;
Gmob_dL = 1.0;

d_Udse_dV_GP_SI = d_Udse_dV_SI_BP = d_Udse_dV_DI_SI =  0.0;
Udse = 0.0;

d_thesat1_dV_GP_SI = d_thesat1_dV_DI_SI = d_thesat1_dV_SI_BP =  0.0;
thesat1 = 0.0;

d_xgm_dV_DI_SI = d_xgm_dV_GP_SI = d_xgm_dV_SI_BP =  0.0;
xgm = 0.0;

d_Vgbstar_dV_SI_BP = d_Vsbstar_dV_SI_BP;
d_Vgbstar_dV_GP_SI = d_Vgs_dV_GP_SI;
d_Vgbstar_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsbstar_dV_DI_SI);
Vgbstar = (Vgs+Vsbstar);

d_Vgb1_dV_SI_BP = d_Vgbstar_dV_SI_BP;
d_Vgb1_dV_GP_SI = d_Vgbstar_dV_GP_SI;
d_Vgb1_dV_DI_SI = d_Vgbstar_dV_DI_SI;
Vgb1 = (Vgbstar-VFB_T);

d_Vsbx_dV_SI_BP = d_Vsbstar_dV_SI_BP;
d_Vsbx_dV_DI_SI = (d_Vsbstar_dV_DI_SI+0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI));
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
if ((CFD_i<1.0e-10))
{

d_Vdsp_dV_DI_SI = d_Vdsx_dV_DI_SI;
Vdsp = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(CFD_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsp_dV_DI_SI = (2.0*(deriv_sqrt_0_d0*(CFD_i*d_Vdsx_dV_DI_SI))/CFD_i);
Vdsp = ((2.0*(value_sqrt_0-1.0))/CFD_i);
}
}

d_delVg_dV_GP_SI =  0.0;
d_delVg_dV_SI_BP = (CF_i*Vdsp)*CFB_i*d_Vsbx_dV_SI_BP;
d_delVg_dV_DI_SI = ((CF_i*Vdsp)*CFB_i*d_Vsbx_dV_DI_SI+CF_i*d_Vdsp_dV_DI_SI*(1.0+(CFB_i*Vsbx)));
delVg = ((CF_i*Vdsp)*(1.0+(CFB_i*Vsbx)));

d_dphit1_dV_GP_SI =  0.0;
d_dphit1_dV_SI_BP = (PSCE_i*(1.0+(PSCED_i*Vdsx)))*PSCEB_i*d_Vsbx_dV_SI_BP;
d_dphit1_dV_DI_SI = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*PSCEB_i*d_Vsbx_dV_DI_SI+PSCE_i*PSCED_i*d_Vdsx_dV_DI_SI*(1.0+(PSCEB_i*Vsbx)));
dphit1 = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(1.0+(PSCEB_i*Vsbx)));

d_phit1_dV_GP_SI =  0.0;
d_phit1_dV_SI_BP = phit0*d_dphit1_dV_SI_BP;
d_phit1_dV_DI_SI = phit0*d_dphit1_dV_DI_SI;
phit1 = (phit0*(1.0+dphit1));

d_inv_phit1_dV_GP_SI =  0.0;
d_inv_phit1_dV_SI_BP = (-d_phit1_dV_SI_BP/phit1/phit1);
d_inv_phit1_dV_DI_SI = (-d_phit1_dV_DI_SI/phit1/phit1);
inv_phit1 = (1.0/phit1);

d_Vgb1_dV_SI_BP = (d_Vgb1_dV_SI_BP+d_delVg_dV_SI_BP);
d_Vgb1_dV_GP_SI = (d_Vgb1_dV_GP_SI+d_delVg_dV_GP_SI);
d_Vgb1_dV_DI_SI = (d_Vgb1_dV_DI_SI+d_delVg_dV_DI_SI);
Vgb1 = (Vgb1+delVg);

d_xg_dV_SI_BP = (Vgb1*d_inv_phit1_dV_SI_BP+d_Vgb1_dV_SI_BP*inv_phit1);
d_xg_dV_GP_SI = (Vgb1*d_inv_phit1_dV_GP_SI+d_Vgb1_dV_GP_SI*inv_phit1);
d_xg_dV_DI_SI = (Vgb1*d_inv_phit1_dV_DI_SI+d_Vgb1_dV_DI_SI*inv_phit1);
xg = (Vgb1*inv_phit1);
if ((DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dnsub_dV_SI_BP = (DNSUB_i*0.5)*(d_Vsb_dV_SI_BP+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_SI_BP)+(-d_Vsb_dV_SI_BP)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_GP_SI = (DNSUB_i*0.5)*(d_Vgs_dV_GP_SI+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_SI)+(-d_Vgs_dV_GP_SI)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_DI_SI = (DNSUB_i*0.5)*((d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI)+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))+(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))*(-((Vgs+Vsb)-VNSUB_i))))));
Dnsub = ((DNSUB_i*0.5)*(((Vgs+Vsb)-VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gf_dV_SI_BP = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_SI_BP));
d_Gf_dV_GP_SI = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_SI));
d_Gf_dV_DI_SI = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_DI_SI));
Gf = (G_0*value_sqrt_0);
}
}
else
{

d_Gf_dV_DI_SI = d_Gf_dV_GP_SI = d_Gf_dV_SI_BP =  0.0;
Gf = G_0;
}

d_Gf2_dV_SI_BP = (Gf*d_Gf_dV_SI_BP+d_Gf_dV_SI_BP*Gf);
d_Gf2_dV_GP_SI = (Gf*d_Gf_dV_GP_SI+d_Gf_dV_GP_SI*Gf);
d_Gf2_dV_DI_SI = (Gf*d_Gf_dV_DI_SI+d_Gf_dV_DI_SI*Gf);
Gf2 = (Gf*Gf);

d_inv_Gf2_dV_SI_BP = (-d_Gf2_dV_SI_BP/Gf2/Gf2);
d_inv_Gf2_dV_GP_SI = (-d_Gf2_dV_GP_SI/Gf2/Gf2);
d_inv_Gf2_dV_DI_SI = (-d_Gf2_dV_DI_SI/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);

d_xi_dV_SI_BP = d_Gf_dV_SI_BP*7.0710678118654746e-01;
d_xi_dV_GP_SI = d_Gf_dV_GP_SI*7.0710678118654746e-01;
d_xi_dV_DI_SI = d_Gf_dV_DI_SI*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));

d_inv_xi_dV_SI_BP = (-d_xi_dV_SI_BP/xi/xi);
d_inv_xi_dV_GP_SI = (-d_xi_dV_GP_SI/xi/xi);
d_inv_xi_dV_DI_SI = (-d_xi_dV_DI_SI/xi/xi);
inv_xi = (1.0/xi);

d_Ux_dV_SI_BP = (Vsbstar*d_inv_phit1_dV_SI_BP+d_Vsbstar_dV_SI_BP*inv_phit1);
d_Ux_dV_DI_SI = (Vsbstar*d_inv_phit1_dV_DI_SI+d_Vsbstar_dV_DI_SI*inv_phit1);
Ux = (Vsbstar*inv_phit1);

d_xn_s_dV_SI_BP = (phib*d_inv_phit1_dV_SI_BP+d_Ux_dV_SI_BP);
d_xn_s_dV_DI_SI = (phib*d_inv_phit1_dV_DI_SI+d_Ux_dV_DI_SI);
xn_s = ((phib*inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_ns_dV_SI_BP = (deriv_exp_0_d0*((-d_xn_s_dV_SI_BP)));
d_delta_ns_dV_DI_SI = (deriv_exp_0_d0*((-d_xn_s_dV_DI_SI)));
delta_ns = value_exp_0;
}
}
else
{

d_delta_ns_dV_SI_BP = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_SI_BP*3.3333333333333333e-01+d_xn_s_dV_SI_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_SI_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_delta_ns_dV_DI_SI = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_DI_SI*3.3333333333333333e-01+d_xn_s_dV_DI_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_DI_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_margin_dV_SI_BP = 1.0e-5*d_xi_dV_SI_BP;
d_margin_dV_GP_SI = 1.0e-5*d_xi_dV_GP_SI;
d_margin_dV_DI_SI = 1.0e-5*d_xi_dV_DI_SI;
margin = (1.0e-5*xi);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_SI_BP = (inv_xi*d_inv_xi_dV_SI_BP+d_inv_xi_dV_SI_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_SI = (inv_xi*d_inv_xi_dV_GP_SI+d_inv_xi_dV_GP_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_DI_SI = (inv_xi*d_inv_xi_dV_DI_SI+d_inv_xi_dV_DI_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_s_dV_SI_BP = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_SI_BP+((xg*(1.0-delta_ns))*d_Gf_dV_SI_BP+(xg*(-d_delta_ns_dV_SI_BP)+d_xg_dV_SI_BP*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_GP_SI = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_SI+((xg*(1.0-delta_ns))*d_Gf_dV_GP_SI+d_xg_dV_GP_SI*(1.0-delta_ns)*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_DI_SI = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_DI_SI+((xg*(1.0-delta_ns))*d_Gf_dV_DI_SI+(xg*(-d_delta_ns_dV_DI_SI)+d_xg_dV_DI_SI*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{

d_SP_S_yg_dV_SI_BP = (-d_xg_dV_SI_BP);
d_SP_S_yg_dV_GP_SI = (-d_xg_dV_GP_SI);
d_SP_S_yg_dV_DI_SI = (-d_xg_dV_DI_SI);
SP_S_yg = (-xg);

d_SP_S_ysub_dV_SI_BP = 1.25*(SP_S_yg*d_inv_xi_dV_SI_BP+d_SP_S_yg_dV_SI_BP*inv_xi);
d_SP_S_ysub_dV_GP_SI = 1.25*(SP_S_yg*d_inv_xi_dV_GP_SI+d_SP_S_yg_dV_GP_SI*inv_xi);
d_SP_S_ysub_dV_DI_SI = 1.25*(SP_S_yg*d_inv_xi_dV_DI_SI+d_SP_S_yg_dV_DI_SI*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_eta_dV_SI_BP = 0.5*(d_SP_S_ysub_dV_SI_BP-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_SI_BP+d_SP_S_ysub_dV_SI_BP*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_GP_SI = 0.5*(d_SP_S_ysub_dV_GP_SI-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_SI+d_SP_S_ysub_dV_GP_SI*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_DI_SI = 0.5*(d_SP_S_ysub_dV_DI_SI-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_DI_SI+d_SP_S_ysub_dV_DI_SI*(SP_S_ysub-6.0)))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}

d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (SP_S_yg-SP_S_eta);

d_SP_S_a_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)+(Gf2*d_SP_S_eta_dV_SI_BP+d_Gf2_dV_SI_BP*(SP_S_eta+1.0)));
d_SP_S_a_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)+(Gf2*d_SP_S_eta_dV_GP_SI+d_Gf2_dV_GP_SI*(SP_S_eta+1.0)));
d_SP_S_a_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)+(Gf2*d_SP_S_eta_dV_DI_SI+d_Gf2_dV_DI_SI*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP-d_Gf2_dV_SI_BP);
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI-d_Gf2_dV_GP_SI);
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI-d_Gf2_dV_DI_SI);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

d_SP_S_tau_dV_SI_BP = ((-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_SI_BP+d_SP_S_a_dV_SI_BP*inv_Gf2))));
d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_GP_SI+d_SP_S_a_dV_GP_SI*inv_Gf2))));
d_SP_S_tau_dV_DI_SI = ((-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_DI_SI+d_SP_S_a_dV_DI_SI*inv_Gf2))));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-d_SP_S_a_dV_SI_BP)+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-d_SP_S_a_dV_GP_SI)+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-d_SP_S_a_dV_DI_SI)+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

d_SP_S_y0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_SI_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_GP_SI)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_DI_SI)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}
}
else
{

d_SP_S_delta0_dV_SI_BP = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_y0_dV_SI_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_SI_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_GP_SI = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_y0_dV_GP_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_GP_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_DI_SI = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_y0_dV_DI_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_DI_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_temp_dV_SI_BP = (-(SP_S_y0*d_SP_S_y0_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_y0*d_SP_S_y0_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_y0*d_SP_S_y0_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_SI_BP+(SP_S_y0*d_SP_S_y0_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_SI+(SP_S_y0*d_SP_S_y0_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_DI_SI+(SP_S_y0*d_SP_S_y0_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_y0*d_SP_S_temp_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_y0*d_SP_S_temp_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_y0*d_SP_S_temp_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_y0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_y0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_y0_dV_DI_SI);
SP_S_temp = (SP_S_yg-SP_S_y0);

d_SP_S_temp1_dV_GP_SI = delta_ns*d_SP_S_delta1_dV_GP_SI;
d_SP_S_temp1_dV_SI_BP = (delta_ns*d_SP_S_delta1_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_delta1);
d_SP_S_temp1_dV_DI_SI = (delta_ns*d_SP_S_delta1_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((d_SP_S_delta0_dV_SI_BP-d_SP_S_temp1_dV_SI_BP)+(delta_ns*(-d_SP_S_xi1_dV_SI_BP)+d_delta_ns_dV_SI_BP*(1.0-SP_S_xi1)))+d_Gf2_dV_SI_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((d_SP_S_delta0_dV_GP_SI-d_SP_S_temp1_dV_GP_SI)+delta_ns*(-d_SP_S_xi1_dV_GP_SI))+d_Gf2_dV_GP_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((d_SP_S_delta0_dV_DI_SI-d_SP_S_temp1_dV_DI_SI)+(delta_ns*(-d_SP_S_xi1_dV_DI_SI)+d_delta_ns_dV_DI_SI*(1.0-SP_S_xi1)))+d_Gf2_dV_DI_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_SI_BP-d_SP_S_y0_dV_SI_BP)+d_SP_S_temp1_dV_SI_BP)+(delta_ns*(d_SP_S_y0_dV_SI_BP-d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_GP_SI-d_SP_S_y0_dV_GP_SI)+d_SP_S_temp1_dV_GP_SI)+delta_ns*(d_SP_S_y0_dV_GP_SI-d_SP_S_xi0_dV_GP_SI))+d_Gf2_dV_GP_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_DI_SI-d_SP_S_y0_dV_DI_SI)+d_SP_S_temp1_dV_DI_SI)+(delta_ns*(d_SP_S_y0_dV_DI_SI-d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta0_dV_SI_BP+d_SP_S_temp1_dV_SI_BP)-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta0_dV_GP_SI+d_SP_S_temp1_dV_GP_SI)-delta_ns*d_SP_S_xi2_dV_GP_SI)+d_Gf2_dV_GP_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta0_dV_DI_SI+d_SP_S_temp1_dV_DI_SI)-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_SI_BP = ((-d_SP_S_y0_dV_SI_BP)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_SI = ((-d_SP_S_y0_dV_GP_SI)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_DI_SI = ((-d_SP_S_y0_dV_DI_SI)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{

d_SP_xg1_dV_SI_BP = (-d_Gf_dV_SI_BP*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_GP_SI = (-d_Gf_dV_GP_SI*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_DI_SI = (-d_Gf_dV_DI_SI*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));

d_SP_S_A_fac_dV_SI_BP = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_SI_BP+((xi*1.25)*d_SP_xg1_dV_SI_BP+d_xi_dV_SI_BP*1.25*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_GP_SI = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_SI+((xi*1.25)*d_SP_xg1_dV_GP_SI+d_xi_dV_GP_SI*1.25*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_DI_SI = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_DI_SI+((xi*1.25)*d_SP_xg1_dV_DI_SI+d_xi_dV_DI_SI*1.25*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);

d_SP_S_xbar_dV_SI_BP = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_SI_BP+d_SP_S_A_fac_dV_SI_BP*xg)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_GP_SI = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_GP_SI+d_SP_S_A_fac_dV_GP_SI*xg)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_DI_SI = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_DI_SI+d_SP_S_A_fac_dV_DI_SI*xg)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_SI_BP)));
d_SP_S_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_SI)));
d_SP_S_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_DI_SI)));
SP_S_temp = value_exp_0;
}
}
else
{

d_SP_S_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_SI_BP))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_GP_SI))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_DI_SI))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}

d_SP_S_w_dV_SI_BP = (-d_SP_S_temp_dV_SI_BP);
d_SP_S_w_dV_GP_SI = (-d_SP_S_temp_dV_GP_SI);
d_SP_S_w_dV_DI_SI = (-d_SP_S_temp_dV_DI_SI);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_x1_dV_SI_BP = ((d_xg_dV_SI_BP+d_Gf2_dV_SI_BP*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_SI_BP+d_Gf2_dV_SI_BP*0.25)-d_SP_S_w_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0));
d_SP_S_x1_dV_GP_SI = ((d_xg_dV_GP_SI+d_Gf2_dV_GP_SI*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_SI+d_Gf2_dV_GP_SI*0.25)-d_SP_S_w_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0));
d_SP_S_x1_dV_DI_SI = ((d_xg_dV_DI_SI+d_Gf2_dV_DI_SI*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_DI_SI+d_Gf2_dV_DI_SI*0.25)-d_SP_S_w_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}

d_SP_S_bx_dV_GP_SI =  0.0;
d_SP_S_bx_dV_SI_BP = d_xn_s_dV_SI_BP;
d_SP_S_bx_dV_DI_SI = d_xn_s_dV_DI_SI;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_SI_BP = (0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)+(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_SI_BP+d_SP_S_bx_dV_SI_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_SI = (0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)+(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_SI+d_SP_S_bx_dV_GP_SI*SP_S_bx)))));
d_SP_S_eta_dV_DI_SI = (0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)+(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_DI_SI+d_SP_S_bx_dV_DI_SI*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_SI_BP = (-(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_SI = (-(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_DI_SI = (-(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_DI_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_temp2_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_temp2_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_temp2_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP+(8.0*d_SP_S_temp2_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI+(8.0*d_SP_S_temp2_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI+(8.0*d_SP_S_temp2_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_SI_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_SI_BP+d_SP_S_eta_dV_SI_BP)-(delta_ns*(d_SP_S_eta_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_SI+d_SP_S_eta_dV_GP_SI)-delta_ns*(d_SP_S_eta_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))+d_Gf2_dV_GP_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_DI_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_DI_SI+d_SP_S_eta_dV_DI_SI)-(delta_ns*(d_SP_S_eta_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_SI_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_SI_BP-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_GP_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_SI-delta_ns*d_SP_S_xi2_dV_GP_SI)+d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_DI_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_DI_SI-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((-d_SP_S_temp1_dV_SI_BP)-(delta_ns*d_SP_S_xi1_dV_SI_BP+d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((-d_SP_S_temp1_dV_GP_SI)-delta_ns*d_SP_S_xi1_dV_GP_SI)+d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((-d_SP_S_temp1_dV_DI_SI)-(delta_ns*d_SP_S_xi1_dV_DI_SI+d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
d_SP_S_tau_dV_SI_BP = ((d_xn_s_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_DI_SI = ((d_xn_s_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_GP_SI = delta_ns*d_SP_S_delta0_dV_GP_SI;
d_SP_S_delta0_dV_SI_BP = (delta_ns*d_SP_S_delta0_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_delta0);
d_SP_S_delta0_dV_DI_SI = (delta_ns*d_SP_S_delta0_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_s_dV_SI_BP)));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_s_dV_DI_SI)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_GP_SI = (-delta_ns*d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_ns_dV_SI_BP-delta_ns*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_ns_dV_DI_SI-delta_ns*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_GP_SI = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01+(-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_SI_BP = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01+(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_DI_SI = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01+(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_SI_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_DI_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_SI_BP = (-(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_temp_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_temp_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_temp_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_ns*d_SP_S_xi1_dV_SI_BP+d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-delta_ns*d_SP_S_xi1_dV_GP_SI)+d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_ns*d_SP_S_xi1_dV_DI_SI+d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_ns*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-delta_ns*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI))+d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_ns*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-delta_ns*d_SP_S_xi2_dV_GP_SI)+d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}

d_x_d_dV_SI_BP = d_x_s_dV_SI_BP;
d_x_d_dV_GP_SI = d_x_s_dV_GP_SI;
d_x_d_dV_DI_SI = d_x_s_dV_DI_SI;
x_d = x_s;

d_x_m_dV_SI_BP = d_x_s_dV_SI_BP;
d_x_m_dV_GP_SI = d_x_s_dV_GP_SI;
d_x_m_dV_DI_SI = d_x_s_dV_DI_SI;
x_m = x_s;

d_x_ds_dV_DI_SI = d_x_ds_dV_GP_SI = d_x_ds_dV_SI_BP =  0.0;
x_ds = 0.0;

d_Vdsat_lim_dV_GP_SI =  0.0;
d_Vdsat_lim_dV_SI_BP = 3.912023005*d_phit1_dV_SI_BP;
d_Vdsat_lim_dV_DI_SI = 3.912023005*d_phit1_dV_DI_SI;
Vdsat_lim = (3.912023005*phit1);
if ((xg<=0.0))
{

d_qis_dV_DI_SI = d_qis_dV_GP_SI = d_qis_dV_SI_BP =  0.0;
qis = 0.0;

d_xgm_dV_SI_BP = (d_xg_dV_SI_BP-d_x_s_dV_SI_BP);
d_xgm_dV_GP_SI = (d_xg_dV_GP_SI-d_x_s_dV_GP_SI);
d_xgm_dV_DI_SI = (d_xg_dV_DI_SI-d_x_s_dV_DI_SI);
xgm = (xg-x_s);

d_Voxm_dV_SI_BP = (xgm*d_phit1_dV_SI_BP+d_xgm_dV_SI_BP*phit1);
d_Voxm_dV_GP_SI = (xgm*d_phit1_dV_GP_SI+d_xgm_dV_GP_SI*phit1);
d_Voxm_dV_DI_SI = (xgm*d_phit1_dV_DI_SI+d_xgm_dV_DI_SI*phit1);
Voxm = (xgm*phit1);

d_qeff1_dV_SI_BP = d_Voxm_dV_SI_BP;
d_qeff1_dV_GP_SI = d_Voxm_dV_GP_SI;
d_qeff1_dV_DI_SI = d_Voxm_dV_DI_SI;
qeff1 = Voxm;

d_Vdsat_dV_GP_SI =  0.0;
d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
Vdsat = Vdsat_lim;

d_Vdse_dV_GP_SI = d_Vdse_dV_SI_BP =  0.0;
d_Vdse_dV_DI_SI = d_Vds_dV_DI_SI;
Vdse = Vds;
}
else
{

d_delta_1s_dV_DI_SI = d_delta_1s_dV_GP_SI = d_delta_1s_dV_SI_BP =  0.0;
delta_1s = 0.0;

d_temp_dV_SI_BP = (-(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_GP_SI = (-(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_DI_SI = (-(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));

d_xi0s_dV_SI_BP = ((x_s*x_s)*d_temp_dV_SI_BP+(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)*temp);
d_xi0s_dV_GP_SI = ((x_s*x_s)*d_temp_dV_GP_SI+(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)*temp);
d_xi0s_dV_DI_SI = ((x_s*x_s)*d_temp_dV_DI_SI+(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)*temp);
xi0s = ((x_s*x_s)*temp);

d_xi1s_dV_SI_BP = 4.0*((x_s*temp)*d_temp_dV_SI_BP+(x_s*d_temp_dV_SI_BP+d_x_s_dV_SI_BP*temp)*temp);
d_xi1s_dV_GP_SI = 4.0*((x_s*temp)*d_temp_dV_GP_SI+(x_s*d_temp_dV_GP_SI+d_x_s_dV_GP_SI*temp)*temp);
d_xi1s_dV_DI_SI = 4.0*((x_s*temp)*d_temp_dV_DI_SI+(x_s*d_temp_dV_DI_SI+d_x_s_dV_DI_SI*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));

d_xi2s_dV_SI_BP = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_SI_BP+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_SI_BP+(8.0*d_temp_dV_SI_BP-12.0*d_xi0s_dV_SI_BP)*temp)*temp);
d_xi2s_dV_DI_SI = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_DI_SI+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_DI_SI+(8.0*d_temp_dV_DI_SI-12.0*d_xi0s_dV_DI_SI)*temp)*temp);
d_xi2s_dV_GP_SI = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_SI+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_SI+(8.0*d_temp_dV_GP_SI-12.0*d_xi0s_dV_GP_SI)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*(d_x_s_dV_SI_BP));
d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*(d_x_s_dV_DI_SI));
delta_1s = value_exp_0;
}

d_Es_dV_SI_BP = (-d_delta_1s_dV_SI_BP/delta_1s/delta_1s);
d_Es_dV_GP_SI = (-d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
d_Es_dV_DI_SI = (-d_delta_1s_dV_DI_SI/delta_1s/delta_1s);
Es = (1.0/delta_1s);

d_delta_1s_dV_GP_SI = delta_ns*d_delta_1s_dV_GP_SI;
d_delta_1s_dV_SI_BP = (delta_ns*d_delta_1s_dV_SI_BP+d_delta_ns_dV_SI_BP*delta_1s);
d_delta_1s_dV_DI_SI = (delta_ns*d_delta_1s_dV_DI_SI+d_delta_ns_dV_DI_SI*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*((d_x_s_dV_SI_BP-d_xn_s_dV_SI_BP)));
d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*((d_x_s_dV_DI_SI-d_xn_s_dV_DI_SI)));
delta_1s = value_exp_0;
}

d_Es_dV_GP_SI = (-delta_ns*d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
d_Es_dV_SI_BP = ((delta_1s*d_delta_ns_dV_SI_BP-delta_ns*d_delta_1s_dV_SI_BP)/delta_1s/delta_1s);
d_Es_dV_DI_SI = ((delta_1s*d_delta_ns_dV_DI_SI-delta_ns*d_delta_1s_dV_DI_SI)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{

d_delta_1s_dV_GP_SI = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(-d_x_s_dV_GP_SI)*3.3333333333333333e-01+(-d_x_s_dV_GP_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_x_s_dV_GP_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_SI_BP = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*3.3333333333333333e-01+(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_DI_SI = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*3.3333333333333333e-01+(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Es_dV_SI_BP = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_SI_BP*3.3333333333333333e-01+d_x_s_dV_SI_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_SI_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_GP_SI = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_GP_SI*3.3333333333333333e-01+d_x_s_dV_GP_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_GP_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_DI_SI = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_DI_SI*3.3333333333333333e-01+d_x_s_dV_DI_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_DI_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Ds_dV_SI_BP = (d_delta_1s_dV_SI_BP-(delta_ns*(d_x_s_dV_SI_BP+d_xi0s_dV_SI_BP)+d_delta_ns_dV_SI_BP*((x_s+1.0)+xi0s)));
d_Ds_dV_GP_SI = (d_delta_1s_dV_GP_SI-delta_ns*(d_x_s_dV_GP_SI+d_xi0s_dV_GP_SI));
d_Ds_dV_DI_SI = (d_delta_1s_dV_DI_SI-(delta_ns*(d_x_s_dV_DI_SI+d_xi0s_dV_DI_SI)+d_delta_ns_dV_DI_SI*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{

d_Ps_dV_SI_BP = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_SI_BP)+d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_GP_SI = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_SI)+d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_DI_SI = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_DI_SI)+d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

d_Ds_dV_GP_SI = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_GP_SI+(((delta_ns*x_s)*x_s)*d_x_s_dV_GP_SI+((delta_ns*x_s)*d_x_s_dV_GP_SI+delta_ns*d_x_s_dV_GP_SI*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_SI_BP = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_SI_BP+(((delta_ns*x_s)*x_s)*d_x_s_dV_SI_BP+((delta_ns*x_s)*d_x_s_dV_SI_BP+(delta_ns*d_x_s_dV_SI_BP+d_delta_ns_dV_SI_BP*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_DI_SI = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_DI_SI+(((delta_ns*x_s)*x_s)*d_x_s_dV_DI_SI+((delta_ns*x_s)*d_x_s_dV_DI_SI+(delta_ns*d_x_s_dV_DI_SI+d_delta_ns_dV_DI_SI*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_SI_BP)+d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))));
d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_SI)+d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))));
d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_DI_SI)+d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))));
temp = value_sqrt_0;
}

d_sqm_dV_SI_BP = 7.0710678118654746e-01*(x_s*d_temp_dV_SI_BP+d_x_s_dV_SI_BP*temp);
d_sqm_dV_GP_SI = 7.0710678118654746e-01*(x_s*d_temp_dV_GP_SI+d_x_s_dV_GP_SI*temp);
d_sqm_dV_DI_SI = 7.0710678118654746e-01*(x_s*d_temp_dV_DI_SI+d_x_s_dV_DI_SI*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));

d_alpha_dV_SI_BP = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_SI_BP)+1.6666666666666667e-01*(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s))+d_Gf_dV_SI_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_SI_BP)/temp/temp);
d_alpha_dV_GP_SI = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_GP_SI)+1.6666666666666667e-01*(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s))+d_Gf_dV_GP_SI*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_SI)/temp/temp);
d_alpha_dV_DI_SI = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_DI_SI)+1.6666666666666667e-01*(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s))+d_Gf_dV_DI_SI*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_DI_SI)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{

d_Ps_dV_SI_BP = (d_x_s_dV_SI_BP+d_Es_dV_SI_BP);
d_Ps_dV_GP_SI = (d_x_s_dV_GP_SI+d_Es_dV_GP_SI);
d_Ps_dV_DI_SI = (d_x_s_dV_DI_SI+d_Es_dV_DI_SI);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Ps_dV_SI_BP));
d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Ps_dV_GP_SI));
d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Ps_dV_DI_SI));
sqm = value_sqrt_0;
}

d_alpha_dV_SI_BP = 0.5*((sqm*(Gf*(-d_Es_dV_SI_BP)+d_Gf_dV_SI_BP*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_SI_BP)/sqm/sqm);
d_alpha_dV_GP_SI = 0.5*((sqm*(Gf*(-d_Es_dV_GP_SI)+d_Gf_dV_GP_SI*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_GP_SI)/sqm/sqm);
d_alpha_dV_DI_SI = 0.5*((sqm*(Gf*(-d_Es_dV_DI_SI)+d_Gf_dV_DI_SI*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_DI_SI)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}

d_Em_dV_SI_BP = d_Es_dV_SI_BP;
d_Em_dV_GP_SI = d_Es_dV_GP_SI;
d_Em_dV_DI_SI = d_Es_dV_DI_SI;
Em = Es;

d_Ed_dV_SI_BP = d_Em_dV_SI_BP;
d_Ed_dV_GP_SI = d_Em_dV_GP_SI;
d_Ed_dV_DI_SI = d_Em_dV_DI_SI;
Ed = Em;

d_Dm_dV_SI_BP = d_Ds_dV_SI_BP;
d_Dm_dV_GP_SI = d_Ds_dV_GP_SI;
d_Dm_dV_DI_SI = d_Ds_dV_DI_SI;
Dm = Ds;

d_Dd_dV_SI_BP = d_Dm_dV_SI_BP;
d_Dd_dV_GP_SI = d_Dm_dV_GP_SI;
d_Dd_dV_DI_SI = d_Dm_dV_DI_SI;
Dd = Dm;

d_Rxcor_dV_SI_BP = (((1.0+(XCOR_T*Vsbx))*(0.2*XCOR_T)*d_Vsbx_dV_SI_BP-(1.0+((0.2*XCOR_T)*Vsbx))*XCOR_T*d_Vsbx_dV_SI_BP)/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
d_Rxcor_dV_DI_SI = (((1.0+(XCOR_T*Vsbx))*(0.2*XCOR_T)*d_Vsbx_dV_DI_SI-(1.0+((0.2*XCOR_T)*Vsbx))*XCOR_T*d_Vsbx_dV_DI_SI)/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
Rxcor = ((1.0+((0.2*XCOR_T)*Vsbx))/(1.0+(XCOR_T*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgs_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_SI_BP+d_Ds_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgs_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_SI+d_Ds_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgs_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_DI_SI+d_Ds_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}

d_qis_dV_SI_BP = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_SI_BP+(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_SI_BP+(Gf*d_sqm_dV_SI_BP+d_Gf_dV_SI_BP*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_GP_SI = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_GP_SI+(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_SI+(Gf*d_sqm_dV_GP_SI+d_Gf_dV_GP_SI*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_DI_SI = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_DI_SI+(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_DI_SI+(Gf*d_sqm_dV_DI_SI+d_Gf_dV_DI_SI*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

d_qbs_dV_SI_BP = ((sqm*Gf)*d_phit1_dV_SI_BP+(sqm*d_Gf_dV_SI_BP+d_sqm_dV_SI_BP*Gf)*phit1);
d_qbs_dV_GP_SI = ((sqm*Gf)*d_phit1_dV_GP_SI+(sqm*d_Gf_dV_GP_SI+d_sqm_dV_GP_SI*Gf)*phit1);
d_qbs_dV_DI_SI = ((sqm*Gf)*d_phit1_dV_DI_SI+(sqm*d_Gf_dV_DI_SI+d_sqm_dV_DI_SI*Gf)*phit1);
qbs = ((sqm*Gf)*phit1);
if ((RSB_i<0.0))
{

d_rhob_dV_SI_BP = (-(-RSB_i*d_Vsbx_dV_SI_BP)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
d_rhob_dV_DI_SI = (-(-RSB_i*d_Vsbx_dV_DI_SI)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
rhob = (1.0/(1.0-(RSB_i*Vsbx)));
}
else
{

d_rhob_dV_SI_BP = RSB_i*d_Vsbx_dV_SI_BP;
d_rhob_dV_DI_SI = RSB_i*d_Vsbx_dV_DI_SI;
rhob = (1.0+(RSB_i*Vsbx));
}
if ((RSG_i<0.0))
{

d_temp_dV_SI_BP = (-RSG_i*d_qis_dV_SI_BP);
d_temp_dV_GP_SI = (-RSG_i*d_qis_dV_GP_SI);
d_temp_dV_DI_SI = (-RSG_i*d_qis_dV_DI_SI);
temp = (1.0-(RSG_i*qis));
}
else
{

d_temp_dV_SI_BP = (-RSG_i*d_qis_dV_SI_BP/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_GP_SI = (-RSG_i*d_qis_dV_GP_SI/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_DI_SI = (-RSG_i*d_qis_dV_DI_SI/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
temp = (1.0/(1.0+(RSG_i*qis)));
}

d_GR_dV_GP_SI = THER_i*((rhob*temp)*d_qis_dV_GP_SI+rhob*d_temp_dV_GP_SI*qis);
d_GR_dV_SI_BP = THER_i*((rhob*temp)*d_qis_dV_SI_BP+(rhob*d_temp_dV_SI_BP+d_rhob_dV_SI_BP*temp)*qis);
d_GR_dV_DI_SI = THER_i*((rhob*temp)*d_qis_dV_DI_SI+(rhob*d_temp_dV_DI_SI+d_rhob_dV_DI_SI*temp)*qis);
GR = (THER_i*((rhob*temp)*qis));

d_Eeffm_dV_SI_BP = E_eff0*(d_qbs_dV_SI_BP+eta_mu*d_qis_dV_SI_BP);
d_Eeffm_dV_GP_SI = E_eff0*(d_qbs_dV_GP_SI+eta_mu*d_qis_dV_GP_SI);
d_Eeffm_dV_DI_SI = E_eff0*(d_qbs_dV_DI_SI+eta_mu*d_qis_dV_DI_SI);
Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_SI_BP*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_SI_BP-Ps*(d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_SI*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_SI-Ps*(d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_DI_SI*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_DI_SI-Ps*(d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
Mutmp = (value_pow_0+(CS_T*(Ps/((Ps+Ds)+1.0e-14))));
}

d_Gmob_dV_SI_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP+(d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor);
d_Gmob_dV_GP_SI = (d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor;
d_Gmob_dV_DI_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI+(d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((THESATB_i<0.0))
{

d_xitsb_dV_SI_BP = (-(-THESATB_i*d_Vsbx_dV_SI_BP)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
d_xitsb_dV_DI_SI = (-(-THESATB_i*d_Vsbx_dV_DI_SI)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
}
else
{

d_xitsb_dV_SI_BP = THESATB_i*d_Vsbx_dV_SI_BP;
d_xitsb_dV_DI_SI = THESATB_i*d_Vsbx_dV_DI_SI;
xitsb = (1.0+(THESATB_i*Vsbx));
}

d_temp2_dV_SI_BP = (qis*d_xitsb_dV_SI_BP+d_qis_dV_SI_BP*xitsb);
d_temp2_dV_GP_SI = d_qis_dV_GP_SI*xitsb;
d_temp2_dV_DI_SI = (qis*d_xitsb_dV_DI_SI+d_qis_dV_DI_SI*xitsb);
temp2 = (qis*xitsb);

d_wsat_dV_SI_BP = 100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_SI = 100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_DI_SI = 100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((THESATG_i<0.0))
{

d_temp_dV_SI_BP = (-(-THESATG_i*d_wsat_dV_SI_BP)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_GP_SI = (-(-THESATG_i*d_wsat_dV_GP_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_DI_SI = (-(-THESATG_i*d_wsat_dV_DI_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
temp = (1.0/(1.0-(THESATG_i*wsat)));
}
else
{

d_temp_dV_SI_BP = THESATG_i*d_wsat_dV_SI_BP;
d_temp_dV_GP_SI = THESATG_i*d_wsat_dV_GP_SI;
d_temp_dV_DI_SI = THESATG_i*d_wsat_dV_DI_SI;
temp = (1.0+(THESATG_i*wsat));
}

d_thesat1_dV_SI_BP = THESAT_T*((Gmob*d_temp_dV_SI_BP-temp*d_Gmob_dV_SI_BP)/Gmob/Gmob);
d_thesat1_dV_DI_SI = THESAT_T*((Gmob*d_temp_dV_DI_SI-temp*d_Gmob_dV_DI_SI)/Gmob/Gmob);
d_thesat1_dV_GP_SI = THESAT_T*((Gmob*d_temp_dV_GP_SI-temp*d_Gmob_dV_GP_SI)/Gmob/Gmob);
thesat1 = (THESAT_T*(temp/Gmob));

d_phi_inf_dV_SI_BP = (((alpha*d_qis_dV_SI_BP-qis*d_alpha_dV_SI_BP)/alpha/alpha)+d_phit1_dV_SI_BP);
d_phi_inf_dV_GP_SI = (((alpha*d_qis_dV_GP_SI-qis*d_alpha_dV_GP_SI)/alpha/alpha)+d_phit1_dV_GP_SI);
d_phi_inf_dV_DI_SI = (((alpha*d_qis_dV_DI_SI-qis*d_alpha_dV_DI_SI)/alpha/alpha)+d_phit1_dV_DI_SI);
phi_inf = ((qis/alpha)+phit1);

d_ysat_dV_SI_BP = (thesat1*d_phi_inf_dV_SI_BP+d_thesat1_dV_SI_BP*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_DI_SI = (thesat1*d_phi_inf_dV_DI_SI+d_thesat1_dV_DI_SI*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_GP_SI = (thesat1*d_phi_inf_dV_GP_SI+d_thesat1_dV_GP_SI*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if (((model_.CHNL_TYPE)==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ysat_dV_SI_BP = ((value_sqrt_0*d_ysat_dV_SI_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_DI_SI = ((value_sqrt_0*d_ysat_dV_DI_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_GP_SI = ((value_sqrt_0*d_ysat_dV_GP_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_za_dV_SI_BP = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_SI_BP))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_DI_SI = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_DI_SI))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_GP_SI = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_GP_SI))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}

d_temp1_dV_SI_BP = (za*d_ysat_dV_SI_BP+d_za_dV_SI_BP*ysat);
d_temp1_dV_DI_SI = (za*d_ysat_dV_DI_SI+d_za_dV_DI_SI*ysat);
d_temp1_dV_GP_SI = (za*d_ysat_dV_GP_SI+d_za_dV_GP_SI*ysat);
temp1 = (za*ysat);

d_Phi_0_dV_SI_BP = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_SI_BP+d_temp1_dV_SI_BP*za))+d_temp1_dV_SI_BP*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_SI_BP+(temp1*d_temp1_dV_SI_BP+d_temp1_dV_SI_BP*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_SI_BP+d_phi_inf_dV_SI_BP*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_GP_SI = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_GP_SI+d_temp1_dV_GP_SI*za))+d_temp1_dV_GP_SI*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_GP_SI+(temp1*d_temp1_dV_GP_SI+d_temp1_dV_GP_SI*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_GP_SI+d_phi_inf_dV_GP_SI*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_DI_SI = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_DI_SI+d_temp1_dV_DI_SI*za))+d_temp1_dV_DI_SI*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_DI_SI+(temp1*d_temp1_dV_DI_SI+d_temp1_dV_DI_SI*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_DI_SI+d_phi_inf_dV_DI_SI*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

d_asat_dV_SI_BP = (d_xgs_dV_SI_BP+0.5*d_Gf2_dV_SI_BP);
d_asat_dV_GP_SI = (d_xgs_dV_GP_SI+0.5*d_Gf2_dV_GP_SI);
d_asat_dV_DI_SI = (d_xgs_dV_DI_SI+0.5*d_Gf2_dV_DI_SI);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_2_dV_SI_BP = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_SI_BP+(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_SI_BP+(deriv_sqrt_0_d0*(((asat*d_asat_dV_SI_BP+d_asat_dV_SI_BP*asat)-(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_GP_SI = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_GP_SI+(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_GP_SI+(deriv_sqrt_0_d0*(((asat*d_asat_dV_GP_SI+d_asat_dV_GP_SI*asat)-(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_DI_SI = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_DI_SI+(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_DI_SI+(deriv_sqrt_0_d0*(((asat*d_asat_dV_DI_SI+d_asat_dV_DI_SI*asat)-(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
}

d_Phi_0_2_dV_SI_BP = (d_Phi_0_dV_SI_BP+d_Phi_2_dV_SI_BP);
d_Phi_0_2_dV_GP_SI = (d_Phi_0_dV_GP_SI+d_Phi_2_dV_GP_SI);
d_Phi_0_2_dV_DI_SI = (d_Phi_0_dV_DI_SI+d_Phi_2_dV_DI_SI);
Phi_0_2 = (Phi_0+Phi_2);

d_Phi0_Phi2_dV_SI_BP = 2.0*(Phi_0*d_Phi_2_dV_SI_BP+d_Phi_0_dV_SI_BP*Phi_2);
d_Phi0_Phi2_dV_GP_SI = 2.0*(Phi_0*d_Phi_2_dV_GP_SI+d_Phi_0_dV_GP_SI*Phi_2);
d_Phi0_Phi2_dV_DI_SI = 2.0*(Phi_0*d_Phi_2_dV_DI_SI+d_Phi_0_dV_DI_SI*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_sat_dV_SI_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_SI_BP-Phi0_Phi2*(d_Phi_0_2_dV_SI_BP+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_SI_BP+d_Phi_0_2_dV_SI_BP*Phi_0_2)-1.98*d_Phi0_Phi2_dV_SI_BP)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_GP_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_SI-Phi0_Phi2*(d_Phi_0_2_dV_GP_SI+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_GP_SI+d_Phi_0_2_dV_GP_SI*Phi_0_2)-1.98*d_Phi0_Phi2_dV_GP_SI)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_DI_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_DI_SI-Phi0_Phi2*(d_Phi_0_2_dV_DI_SI+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_DI_SI+d_Phi_0_2_dV_DI_SI*Phi_0_2)-1.98*d_Phi0_Phi2_dV_DI_SI)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

d_Vdsat_dV_SI_BP = (d_Phi_sat_dV_SI_BP-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_SI_BP+(Phi_sat*(d_Phi_sat_dV_SI_BP-((2.0*asat)*d_phit1_dV_SI_BP+2.0*d_asat_dV_SI_BP*phit1))+d_Phi_sat_dV_SI_BP*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_SI_BP+(phit1*d_phit1_dV_SI_BP+d_phit1_dV_SI_BP*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_SI_BP*value_log_0));
d_Vdsat_dV_GP_SI = (d_Phi_sat_dV_GP_SI-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_SI+(Phi_sat*(d_Phi_sat_dV_GP_SI-((2.0*asat)*d_phit1_dV_GP_SI+2.0*d_asat_dV_GP_SI*phit1))+d_Phi_sat_dV_GP_SI*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_GP_SI+(phit1*d_phit1_dV_GP_SI+d_phit1_dV_GP_SI*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_GP_SI*value_log_0));
d_Vdsat_dV_DI_SI = (d_Phi_sat_dV_DI_SI-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_DI_SI+(Phi_sat*(d_Phi_sat_dV_DI_SI-((2.0*asat)*d_phit1_dV_DI_SI+2.0*d_asat_dV_DI_SI*phit1))+d_Phi_sat_dV_DI_SI*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_DI_SI+(phit1*d_phit1_dV_DI_SI+d_phit1_dV_DI_SI*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_DI_SI*value_log_0));
Vdsat = (Phi_sat-(phit1*value_log_0));
}
}
else
{

d_Vdsat_dV_GP_SI =  0.0;
d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
Vdsat = Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_SI_BP/Vdsat/Vdsat)));
d_temp_dV_GP_SI = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_SI/Vdsat/Vdsat)));
d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_DI_SI-Vds*d_Vdsat_dV_DI_SI)/Vdsat/Vdsat)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

d_Vdse_dV_SI_BP = Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP));
d_Vdse_dV_GP_SI = Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI));
d_Vdse_dV_DI_SI = (Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI))+d_Vds_dV_DI_SI*value_pow_0);
Vdse = (Vds*value_pow_0);
}

d_Udse_dV_DI_SI = (Vdse*d_inv_phit1_dV_DI_SI+d_Vdse_dV_DI_SI*inv_phit1);
d_Udse_dV_SI_BP = (Vdse*d_inv_phit1_dV_SI_BP+d_Vdse_dV_SI_BP*inv_phit1);
d_Udse_dV_GP_SI = (Vdse*d_inv_phit1_dV_GP_SI+d_Vdse_dV_GP_SI*inv_phit1);
Udse = (Vdse*inv_phit1);

d_xn_d_dV_GP_SI = d_Udse_dV_GP_SI;
d_xn_d_dV_SI_BP = (d_xn_s_dV_SI_BP+d_Udse_dV_SI_BP);
d_xn_d_dV_DI_SI = (d_xn_s_dV_DI_SI+d_Udse_dV_DI_SI);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;

d_k_ds_dV_DI_SI = (deriv_exp_0_d0*((-d_Udse_dV_DI_SI)));
d_k_ds_dV_SI_BP = (deriv_exp_0_d0*((-d_Udse_dV_SI_BP)));
d_k_ds_dV_GP_SI = (deriv_exp_0_d0*((-d_Udse_dV_GP_SI)));
k_ds = value_exp_0;
}
}
else
{

d_k_ds_dV_DI_SI = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_DI_SI*3.3333333333333333e-01+d_Udse_dV_DI_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_DI_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_SI_BP = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_SI_BP*3.3333333333333333e-01+d_Udse_dV_SI_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_SI_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_GP_SI = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_GP_SI*3.3333333333333333e-01+d_Udse_dV_GP_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_GP_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_delta_nd_dV_GP_SI = delta_ns*d_k_ds_dV_GP_SI;
d_delta_nd_dV_SI_BP = (delta_ns*d_k_ds_dV_SI_BP+d_delta_ns_dV_SI_BP*k_ds);
d_delta_nd_dV_DI_SI = (delta_ns*d_k_ds_dV_DI_SI+d_delta_ns_dV_DI_SI*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_SI_BP = (inv_xi*d_inv_xi_dV_SI_BP+d_inv_xi_dV_SI_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_SI = (inv_xi*d_inv_xi_dV_GP_SI+d_inv_xi_dV_GP_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_DI_SI = (inv_xi*d_inv_xi_dV_DI_SI+d_inv_xi_dV_DI_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_d_dV_SI_BP = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_SI_BP+((xg*(1.0-delta_nd))*d_Gf_dV_SI_BP+(xg*(-d_delta_nd_dV_SI_BP)+d_xg_dV_SI_BP*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_GP_SI = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_SI+((xg*(1.0-delta_nd))*d_Gf_dV_GP_SI+(xg*(-d_delta_nd_dV_GP_SI)+d_xg_dV_GP_SI*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_DI_SI = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_DI_SI+((xg*(1.0-delta_nd))*d_Gf_dV_DI_SI+(xg*(-d_delta_nd_dV_DI_SI)+d_xg_dV_DI_SI*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{

d_SP_S_bx_dV_GP_SI = d_xn_d_dV_GP_SI;
d_SP_S_bx_dV_SI_BP = d_xn_d_dV_SI_BP;
d_SP_S_bx_dV_DI_SI = d_xn_d_dV_DI_SI;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_SI_BP = (0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)+(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_SI_BP+d_SP_S_bx_dV_SI_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_SI = (0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)+(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_SI+d_SP_S_bx_dV_GP_SI*SP_S_bx)))));
d_SP_S_eta_dV_DI_SI = (0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)+(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_DI_SI+d_SP_S_bx_dV_DI_SI*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_SI_BP = (-(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_SI = (-(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_DI_SI = (-(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_DI_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_temp2_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_temp2_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_temp2_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP+(8.0*d_SP_S_temp2_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI+(8.0*d_SP_S_temp2_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI+(8.0*d_SP_S_temp2_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_SI_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_SI_BP+d_SP_S_eta_dV_SI_BP)-(delta_nd*(d_SP_S_eta_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_nd_dV_SI_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_SI+d_SP_S_eta_dV_GP_SI)-(delta_nd*(d_SP_S_eta_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_nd_dV_GP_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_DI_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_DI_SI+d_SP_S_eta_dV_DI_SI)-(delta_nd*(d_SP_S_eta_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_nd_dV_DI_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_SI_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_SI_BP-(delta_nd*d_SP_S_xi2_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_GP_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_SI-(delta_nd*d_SP_S_xi2_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_DI_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_DI_SI-(delta_nd*d_SP_S_xi2_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((-d_SP_S_temp1_dV_SI_BP)-(delta_nd*d_SP_S_xi1_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((-d_SP_S_temp1_dV_GP_SI)-(delta_nd*d_SP_S_xi1_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((-d_SP_S_temp1_dV_DI_SI)-(delta_nd*d_SP_S_xi1_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_GP_SI = ((d_xn_d_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
d_SP_S_tau_dV_SI_BP = ((d_xn_d_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_DI_SI = ((d_xn_d_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_GP_SI = (delta_nd*d_SP_S_delta0_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_delta0);
d_SP_S_delta0_dV_SI_BP = (delta_nd*d_SP_S_delta0_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_delta0);
d_SP_S_delta0_dV_DI_SI = (delta_nd*d_SP_S_delta0_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_d_dV_SI_BP)));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_d_dV_GP_SI)));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_d_dV_DI_SI)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_nd_dV_GP_SI-delta_nd*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_nd_dV_SI_BP-delta_nd*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_nd_dV_DI_SI-delta_nd*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_GP_SI = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01+(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_SI_BP = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01+(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_DI_SI = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01+(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_SI_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_DI_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_SI_BP = (-(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_temp_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_temp_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_temp_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_nd*d_SP_S_xi1_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_nd*d_SP_S_xi1_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_nd*d_SP_S_xi1_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_nd*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_nd_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_nd*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_nd_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_nd*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_nd_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-(delta_nd*d_SP_S_xi2_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-(delta_nd*d_SP_S_xi2_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-(delta_nd*d_SP_S_xi2_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_d_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}

d_x_ds_dV_SI_BP = (d_x_d_dV_SI_BP-d_x_s_dV_SI_BP);
d_x_ds_dV_GP_SI = (d_x_d_dV_GP_SI-d_x_s_dV_GP_SI);
d_x_ds_dV_DI_SI = (d_x_d_dV_DI_SI-d_x_s_dV_DI_SI);
x_ds = (x_d-x_s);
if ((x_ds<1.0e-10))
{

d_pC_dV_SI_BP = (2.0*(d_xg_dV_SI_BP-d_x_s_dV_SI_BP)+(Gf2*(((-d_Es_dV_SI_BP)+(delta_1s*d_k_ds_dV_SI_BP+d_delta_1s_dV_SI_BP*k_ds))-(delta_nd*d_xi1s_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+xi1s)))+d_Gf2_dV_SI_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_GP_SI = (2.0*(d_xg_dV_GP_SI-d_x_s_dV_GP_SI)+(Gf2*(((-d_Es_dV_GP_SI)+(delta_1s*d_k_ds_dV_GP_SI+d_delta_1s_dV_GP_SI*k_ds))-(delta_nd*d_xi1s_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+xi1s)))+d_Gf2_dV_GP_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_DI_SI = (2.0*(d_xg_dV_DI_SI-d_x_s_dV_DI_SI)+(Gf2*(((-d_Es_dV_DI_SI)+(delta_1s*d_k_ds_dV_DI_SI+d_delta_1s_dV_DI_SI*k_ds))-(delta_nd*d_xi1s_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+xi1s)))+d_Gf2_dV_DI_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

d_qC_dV_SI_BP = ((Gf2*(1.0-k_ds))*d_Ds_dV_SI_BP+(Gf2*(-d_k_ds_dV_SI_BP)+d_Gf2_dV_SI_BP*(1.0-k_ds))*Ds);
d_qC_dV_GP_SI = ((Gf2*(1.0-k_ds))*d_Ds_dV_GP_SI+(Gf2*(-d_k_ds_dV_GP_SI)+d_Gf2_dV_GP_SI*(1.0-k_ds))*Ds);
d_qC_dV_DI_SI = ((Gf2*(1.0-k_ds))*d_Ds_dV_DI_SI+(Gf2*(-d_k_ds_dV_DI_SI)+d_Gf2_dV_DI_SI*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);

d_temp_dV_SI_BP = (-(Gf2*((d_Es_dV_SI_BP+(delta_1s*d_k_ds_dV_SI_BP+d_delta_1s_dV_SI_BP*k_ds))-(delta_nd*d_xi2s_dV_SI_BP+d_delta_nd_dV_SI_BP*xi2s))+d_Gf2_dV_SI_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_GP_SI = (-(Gf2*((d_Es_dV_GP_SI+(delta_1s*d_k_ds_dV_GP_SI+d_delta_1s_dV_GP_SI*k_ds))-(delta_nd*d_xi2s_dV_GP_SI+d_delta_nd_dV_GP_SI*xi2s))+d_Gf2_dV_GP_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_DI_SI = (-(Gf2*((d_Es_dV_DI_SI+(delta_1s*d_k_ds_dV_DI_SI+d_delta_1s_dV_DI_SI*k_ds))-(delta_nd*d_xi2s_dV_DI_SI+d_delta_nd_dV_DI_SI*xi2s))+d_Gf2_dV_DI_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

d_temp_dV_SI_BP = ((pC*d_pC_dV_SI_BP+d_pC_dV_SI_BP*pC)-2.0*(temp*d_qC_dV_SI_BP+d_temp_dV_SI_BP*qC));
d_temp_dV_GP_SI = ((pC*d_pC_dV_GP_SI+d_pC_dV_GP_SI*pC)-2.0*(temp*d_qC_dV_GP_SI+d_temp_dV_GP_SI*qC));
d_temp_dV_DI_SI = ((pC*d_pC_dV_DI_SI+d_pC_dV_DI_SI*pC)-2.0*(temp*d_qC_dV_DI_SI+d_temp_dV_DI_SI*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_ds_dV_SI_BP = 2.0*(((pC+value_sqrt_0)*d_qC_dV_SI_BP-qC*(d_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_temp_dV_SI_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_GP_SI = 2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_SI-qC*(d_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_temp_dV_GP_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_DI_SI = 2.0*(((pC+value_sqrt_0)*d_qC_dV_DI_SI-qC*(d_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_temp_dV_DI_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}

d_x_d_dV_SI_BP = (d_x_s_dV_SI_BP+d_x_ds_dV_SI_BP);
d_x_d_dV_GP_SI = (d_x_s_dV_GP_SI+d_x_ds_dV_GP_SI);
d_x_d_dV_DI_SI = (d_x_s_dV_DI_SI+d_x_ds_dV_DI_SI);
x_d = (x_s+x_ds);
}

d_dps_dV_SI_BP = (x_ds*d_phit1_dV_SI_BP+d_x_ds_dV_SI_BP*phit1);
d_dps_dV_GP_SI = (x_ds*d_phit1_dV_GP_SI+d_x_ds_dV_GP_SI*phit1);
d_dps_dV_DI_SI = (x_ds*d_phit1_dV_DI_SI+d_x_ds_dV_DI_SI*phit1);
dps = (x_ds*phit1);

d_xi0d_dV_SI_BP = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_SI_BP+d_x_d_dV_SI_BP*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_SI_BP+d_x_d_dV_SI_BP*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_GP_SI = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_GP_SI+d_x_d_dV_GP_SI*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_GP_SI+d_x_d_dV_GP_SI*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_DI_SI = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_DI_SI+d_x_d_dV_DI_SI*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_DI_SI+d_x_d_dV_DI_SI*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;

d_Ed_dV_SI_BP = (deriv_exp_0_d0*((-d_x_d_dV_SI_BP)));
d_Ed_dV_GP_SI = (deriv_exp_0_d0*((-d_x_d_dV_GP_SI)));
d_Ed_dV_DI_SI = (deriv_exp_0_d0*((-d_x_d_dV_DI_SI)));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{

d_Dd_dV_GP_SI = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_GP_SI+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_SI+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_SI+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_SI+1.6666666666666667e-01*d_delta_nd_dV_GP_SI*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_SI_BP = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_SI_BP+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_SI_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_SI_BP+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_SI_BP+1.6666666666666667e-01*d_delta_nd_dV_SI_BP*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_DI_SI = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_DI_SI+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_DI_SI+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_DI_SI+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_DI_SI+1.6666666666666667e-01*d_delta_nd_dV_DI_SI*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{

d_Dd_dV_GP_SI = (delta_nd*(((-d_Ed_dV_GP_SI/Ed/Ed)-d_x_d_dV_GP_SI)-d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_SI_BP = (delta_nd*(((-d_Ed_dV_SI_BP/Ed/Ed)-d_x_d_dV_SI_BP)-d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_DI_SI = (delta_nd*(((-d_Ed_dV_DI_SI/Ed/Ed)-d_x_d_dV_DI_SI)-d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_d_dV_SI_BP-d_xn_d_dV_SI_BP)));
d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_d_dV_GP_SI-d_xn_d_dV_GP_SI)));
d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_d_dV_DI_SI-d_xn_d_dV_DI_SI)));
temp = value_exp_0;
}

d_Ed_dV_GP_SI = ((temp*d_delta_nd_dV_GP_SI-delta_nd*d_temp_dV_GP_SI)/temp/temp);
d_Ed_dV_SI_BP = ((temp*d_delta_nd_dV_SI_BP-delta_nd*d_temp_dV_SI_BP)/temp/temp);
d_Ed_dV_DI_SI = ((temp*d_delta_nd_dV_DI_SI-delta_nd*d_temp_dV_DI_SI)/temp/temp);
Ed = (delta_nd/temp);

d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-(delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-(delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-(delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{

d_Ed_dV_SI_BP = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_SI_BP*3.3333333333333333e-01+d_x_d_dV_SI_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_SI_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_GP_SI = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_GP_SI*3.3333333333333333e-01+d_x_d_dV_GP_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_GP_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_DI_SI = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_DI_SI*3.3333333333333333e-01+d_x_d_dV_DI_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_DI_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_temp_dV_GP_SI = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*3.3333333333333333e-01+(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_SI_BP = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*3.3333333333333333e-01+(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*3.3333333333333333e-01+(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-(delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-(delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-(delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}

d_x_m_dV_SI_BP = 0.5*(d_x_s_dV_SI_BP+d_x_d_dV_SI_BP);
d_x_m_dV_GP_SI = 0.5*(d_x_s_dV_GP_SI+d_x_d_dV_GP_SI);
d_x_m_dV_DI_SI = 0.5*(d_x_s_dV_DI_SI+d_x_d_dV_DI_SI);
x_m = (0.5*(x_s+x_d));

d_Em_dV_DI_SI = d_Em_dV_GP_SI = d_Em_dV_SI_BP =  0.0;
Em = 0.0;

d_temp_dV_SI_BP = (Ed*d_Es_dV_SI_BP+d_Ed_dV_SI_BP*Es);
d_temp_dV_GP_SI = (Ed*d_Es_dV_GP_SI+d_Ed_dV_GP_SI*Es);
d_temp_dV_DI_SI = (Ed*d_Es_dV_DI_SI+d_Ed_dV_DI_SI*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Em_dV_SI_BP = (deriv_sqrt_0_d0*(d_temp_dV_SI_BP));
d_Em_dV_DI_SI = (deriv_sqrt_0_d0*(d_temp_dV_DI_SI));
d_Em_dV_GP_SI = (deriv_sqrt_0_d0*(d_temp_dV_GP_SI));
Em = value_sqrt_0;
}
}

d_D_bar_dV_SI_BP = 0.5*(d_Ds_dV_SI_BP+d_Dd_dV_SI_BP);
d_D_bar_dV_GP_SI = 0.5*(d_Ds_dV_GP_SI+d_Dd_dV_GP_SI);
d_D_bar_dV_DI_SI = 0.5*(d_Ds_dV_DI_SI+d_Dd_dV_DI_SI);
D_bar = (0.5*(Ds+Dd));

d_Dm_dV_SI_BP = (d_D_bar_dV_SI_BP+0.125*((x_ds*x_ds)*(d_Em_dV_SI_BP-2.0*d_inv_Gf2_dV_SI_BP)+(x_ds*d_x_ds_dV_SI_BP+d_x_ds_dV_SI_BP*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_GP_SI = (d_D_bar_dV_GP_SI+0.125*((x_ds*x_ds)*(d_Em_dV_GP_SI-2.0*d_inv_Gf2_dV_GP_SI)+(x_ds*d_x_ds_dV_GP_SI+d_x_ds_dV_GP_SI*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_DI_SI = (d_D_bar_dV_DI_SI+0.125*((x_ds*x_ds)*(d_Em_dV_DI_SI-2.0*d_inv_Gf2_dV_DI_SI)+(x_ds*d_x_ds_dV_DI_SI+d_x_ds_dV_DI_SI*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{

d_Pm_dV_SI_BP = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_SI_BP)+d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_SI_BP+d_x_m_dV_SI_BP*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_GP_SI = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_SI)+d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_GP_SI+d_x_m_dV_GP_SI*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_DI_SI = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_DI_SI)+d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_DI_SI+d_x_m_dV_DI_SI*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_SI_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_SI))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_DI_SI))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_SI_BP)+d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))));
d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_SI)+d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))));
d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_DI_SI)+d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))));
temp = value_sqrt_0;
}

d_sqm_dV_SI_BP = 7.0710678118654746e-01*(x_m*d_temp_dV_SI_BP+d_x_m_dV_SI_BP*temp);
d_sqm_dV_GP_SI = 7.0710678118654746e-01*(x_m*d_temp_dV_GP_SI+d_x_m_dV_GP_SI*temp);
d_sqm_dV_DI_SI = 7.0710678118654746e-01*(x_m*d_temp_dV_DI_SI+d_x_m_dV_DI_SI*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));

d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_SI_BP)+1.6666666666666667e-01*(x_m*d_x_m_dV_SI_BP+d_x_m_dV_SI_BP*x_m))+d_Gf_dV_SI_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_SI_BP)/temp/temp));
d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_GP_SI)+1.6666666666666667e-01*(x_m*d_x_m_dV_GP_SI+d_x_m_dV_GP_SI*x_m))+d_Gf_dV_GP_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_SI)/temp/temp));
d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_DI_SI)+1.6666666666666667e-01*(x_m*d_x_m_dV_DI_SI+d_x_m_dV_DI_SI*x_m))+d_Gf_dV_DI_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_DI_SI)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{

d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{

d_d0_dV_SI_BP = ((-d_Em_dV_SI_BP)+2.0*(xgm*d_inv_Gf2_dV_SI_BP+d_xgm_dV_SI_BP*inv_Gf2));
d_d0_dV_GP_SI = ((-d_Em_dV_GP_SI)+2.0*(xgm*d_inv_Gf2_dV_GP_SI+d_xgm_dV_GP_SI*inv_Gf2));
d_d0_dV_DI_SI = ((-d_Em_dV_DI_SI)+2.0*(xgm*d_inv_Gf2_dV_DI_SI+d_xgm_dV_DI_SI*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_SI_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_SI))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_DI_SI))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}

d_temp_dV_SI_BP = (((eta_p+1.0)*d_eta_p_dV_SI_BP-eta_p*d_eta_p_dV_SI_BP)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_GP_SI = (((eta_p+1.0)*d_eta_p_dV_GP_SI-eta_p*d_eta_p_dV_GP_SI)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_DI_SI = (((eta_p+1.0)*d_eta_p_dV_DI_SI-eta_p*d_eta_p_dV_DI_SI)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));

d_x_pm_dV_SI_BP = kp*(((temp*temp)*Gf2)*d_Dm_dV_SI_BP+((temp*temp)*d_Gf2_dV_SI_BP+(temp*d_temp_dV_SI_BP+d_temp_dV_SI_BP*temp)*Gf2)*Dm);
d_x_pm_dV_DI_SI = kp*(((temp*temp)*Gf2)*d_Dm_dV_DI_SI+((temp*temp)*d_Gf2_dV_DI_SI+(temp*d_temp_dV_DI_SI+d_temp_dV_DI_SI*temp)*Gf2)*Dm);
d_x_pm_dV_GP_SI = kp*(((temp*temp)*Gf2)*d_Dm_dV_GP_SI+((temp*temp)*d_Gf2_dV_GP_SI+(temp*d_temp_dV_GP_SI+d_temp_dV_GP_SI*temp)*Gf2)*Dm);
x_pm = (kp*(((temp*temp)*Gf2)*Dm));

d_p_pd_dV_SI_BP = (2.0*(d_xgm_dV_SI_BP-d_x_pm_dV_SI_BP)+(Gf2*((-d_Em_dV_SI_BP)+d_Dm_dV_SI_BP)+d_Gf2_dV_SI_BP*((1.0-Em)+Dm)));
d_p_pd_dV_GP_SI = (2.0*(d_xgm_dV_GP_SI-d_x_pm_dV_GP_SI)+(Gf2*((-d_Em_dV_GP_SI)+d_Dm_dV_GP_SI)+d_Gf2_dV_GP_SI*((1.0-Em)+Dm)));
d_p_pd_dV_DI_SI = (2.0*(d_xgm_dV_DI_SI-d_x_pm_dV_DI_SI)+(Gf2*((-d_Em_dV_DI_SI)+d_Dm_dV_DI_SI)+d_Gf2_dV_DI_SI*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

d_q_pd_dV_SI_BP = (x_pm*(d_x_pm_dV_SI_BP-2.0*d_xgm_dV_SI_BP)+d_x_pm_dV_SI_BP*(x_pm-(2.0*xgm)));
d_q_pd_dV_DI_SI = (x_pm*(d_x_pm_dV_DI_SI-2.0*d_xgm_dV_DI_SI)+d_x_pm_dV_DI_SI*(x_pm-(2.0*xgm)));
d_q_pd_dV_GP_SI = (x_pm*(d_x_pm_dV_GP_SI-2.0*d_xgm_dV_GP_SI)+d_x_pm_dV_GP_SI*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));

d_xi_pd_dV_SI_BP = (-0.5*(Gf2*(d_Em_dV_SI_BP+d_Dm_dV_SI_BP)+d_Gf2_dV_SI_BP*(Em+Dm)));
d_xi_pd_dV_GP_SI = (-0.5*(Gf2*(d_Em_dV_GP_SI+d_Dm_dV_GP_SI)+d_Gf2_dV_GP_SI*(Em+Dm)));
d_xi_pd_dV_DI_SI = (-0.5*(Gf2*(d_Em_dV_DI_SI+d_Dm_dV_DI_SI)+d_Gf2_dV_DI_SI*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

d_u_pd_dV_SI_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_SI_BP+d_q_pd_dV_SI_BP*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_SI_BP+d_p_pd_dV_SI_BP*p_pd)-(xi_pd*d_q_pd_dV_SI_BP+d_xi_pd_dV_SI_BP*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_DI_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_DI_SI+d_q_pd_dV_DI_SI*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_DI_SI+d_p_pd_dV_DI_SI*p_pd)-(xi_pd*d_q_pd_dV_DI_SI+d_xi_pd_dV_DI_SI*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_GP_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_GP_SI+d_q_pd_dV_GP_SI*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_GP_SI+d_p_pd_dV_GP_SI*p_pd)-(xi_pd*d_q_pd_dV_GP_SI+d_xi_pd_dV_GP_SI*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

d_x_m_dV_SI_BP = (d_x_m_dV_SI_BP+d_u_pd_dV_SI_BP);
d_x_m_dV_GP_SI = (d_x_m_dV_GP_SI+d_u_pd_dV_GP_SI);
d_x_m_dV_DI_SI = (d_x_m_dV_DI_SI+d_u_pd_dV_DI_SI);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;

d_km_dV_SI_BP = (deriv_exp_0_d0*(d_u_pd_dV_SI_BP));
d_km_dV_DI_SI = (deriv_exp_0_d0*(d_u_pd_dV_DI_SI));
d_km_dV_GP_SI = (deriv_exp_0_d0*(d_u_pd_dV_GP_SI));
km = value_exp_0;
}

d_Em_dV_SI_BP = ((km*d_Em_dV_SI_BP-Em*d_km_dV_SI_BP)/km/km);
d_Em_dV_GP_SI = ((km*d_Em_dV_GP_SI-Em*d_km_dV_GP_SI)/km/km);
d_Em_dV_DI_SI = ((km*d_Em_dV_DI_SI-Em*d_km_dV_DI_SI)/km/km);
Em = (Em/km);

d_Dm_dV_SI_BP = (Dm*d_km_dV_SI_BP+d_Dm_dV_SI_BP*km);
d_Dm_dV_GP_SI = (Dm*d_km_dV_GP_SI+d_Dm_dV_GP_SI*km);
d_Dm_dV_DI_SI = (Dm*d_km_dV_DI_SI+d_Dm_dV_DI_SI*km);
Dm = (Dm*km);

d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}

d_km0_dV_SI_BP = ((-d_Em_dV_SI_BP)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_SI_BP+(xgm*d_eta_p_dV_SI_BP+d_xgm_dV_SI_BP*eta_p)*inv_Gf2));
d_km0_dV_GP_SI = ((-d_Em_dV_GP_SI)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_GP_SI+(xgm*d_eta_p_dV_GP_SI+d_xgm_dV_GP_SI*eta_p)*inv_Gf2));
d_km0_dV_DI_SI = ((-d_Em_dV_DI_SI)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_DI_SI+(xgm*d_eta_p_dV_DI_SI+d_xgm_dV_DI_SI*eta_p)*inv_Gf2));
km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

d_x_ds_dV_SI_BP = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_SI_BP+d_D_bar_dV_SI_BP)+(x_ds*d_km_dV_SI_BP+d_x_ds_dV_SI_BP*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_SI_BP+(km*d_D_bar_dV_SI_BP+d_km_dV_SI_BP*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
d_x_ds_dV_GP_SI = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_GP_SI+d_D_bar_dV_GP_SI)+(x_ds*d_km_dV_GP_SI+d_x_ds_dV_GP_SI*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_GP_SI+(km*d_D_bar_dV_GP_SI+d_km_dV_GP_SI*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
d_x_ds_dV_DI_SI = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_DI_SI+d_D_bar_dV_DI_SI)+(x_ds*d_km_dV_DI_SI+d_x_ds_dV_DI_SI*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_DI_SI+(km*d_D_bar_dV_DI_SI+d_km_dV_DI_SI*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));

d_dps_dV_SI_BP = (x_ds*d_phit1_dV_SI_BP+d_x_ds_dV_SI_BP*phit1);
d_dps_dV_GP_SI = (x_ds*d_phit1_dV_GP_SI+d_x_ds_dV_GP_SI*phit1);
d_dps_dV_DI_SI = (x_ds*d_phit1_dV_DI_SI+d_x_ds_dV_DI_SI*phit1);
dps = (x_ds*phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Pm_dV_SI_BP));
d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Pm_dV_GP_SI));
d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Pm_dV_DI_SI));
sqm = value_sqrt_0;
}

d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+0.5*((sqm*(Gf*(-d_Em_dV_SI_BP)+d_Gf_dV_SI_BP*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_SI_BP)/sqm/sqm));
d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+0.5*((sqm*(Gf*(-d_Em_dV_GP_SI)+d_Gf_dV_GP_SI*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_GP_SI)/sqm/sqm));
d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+0.5*((sqm*(Gf*(-d_Em_dV_DI_SI)+d_Gf_dV_DI_SI*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_DI_SI)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}

d_qim_dV_GP_SI = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_GP_SI+d_Gf2_dV_GP_SI*Dm)-(Gf2*Dm)*(d_xgm_dV_GP_SI+(Gf*d_sqm_dV_GP_SI+d_Gf_dV_GP_SI*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_GP_SI*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim_dV_SI_BP = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_SI_BP+d_Gf2_dV_SI_BP*Dm)-(Gf2*Dm)*(d_xgm_dV_SI_BP+(Gf*d_sqm_dV_SI_BP+d_Gf_dV_SI_BP*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_SI_BP*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim_dV_DI_SI = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_DI_SI+d_Gf2_dV_DI_SI*Dm)-(Gf2*Dm)*(d_xgm_dV_DI_SI+(Gf*d_sqm_dV_DI_SI+d_Gf_dV_DI_SI*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_DI_SI*((Gf2*Dm)/(xgm+(Gf*sqm))));
qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

d_qim1_dV_GP_SI = (d_qim_dV_GP_SI+(phit1*d_alpha_dV_GP_SI+d_phit1_dV_GP_SI*alpha));
d_qim1_dV_SI_BP = (d_qim_dV_SI_BP+(phit1*d_alpha_dV_SI_BP+d_phit1_dV_SI_BP*alpha));
d_qim1_dV_DI_SI = (d_qim_dV_DI_SI+(phit1*d_alpha_dV_DI_SI+d_phit1_dV_DI_SI*alpha));
qim1 = (qim+(phit1*alpha));

d_qbm_dV_SI_BP = ((sqm*Gf)*d_phit1_dV_SI_BP+(sqm*d_Gf_dV_SI_BP+d_sqm_dV_SI_BP*Gf)*phit1);
d_qbm_dV_GP_SI = ((sqm*Gf)*d_phit1_dV_GP_SI+(sqm*d_Gf_dV_GP_SI+d_sqm_dV_GP_SI*Gf)*phit1);
d_qbm_dV_DI_SI = ((sqm*Gf)*d_phit1_dV_DI_SI+(sqm*d_Gf_dV_DI_SI+d_sqm_dV_DI_SI*Gf)*phit1);
qbm = ((sqm*Gf)*phit1);
if ((RSG_i<0.0))
{

d_temp_dV_GP_SI = (-RSG_i*d_qim_dV_GP_SI);
d_temp_dV_SI_BP = (-RSG_i*d_qim_dV_SI_BP);
d_temp_dV_DI_SI = (-RSG_i*d_qim_dV_DI_SI);
temp = (1.0-(RSG_i*qim));
}
else
{

d_temp_dV_GP_SI = (-RSG_i*d_qim_dV_GP_SI/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_SI_BP = (-RSG_i*d_qim_dV_SI_BP/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_DI_SI = (-RSG_i*d_qim_dV_DI_SI/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
temp = (1.0/(1.0+(RSG_i*qim)));
}

d_GR_dV_GP_SI = THER_i*((rhob*temp)*d_qim_dV_GP_SI+rhob*d_temp_dV_GP_SI*qim);
d_GR_dV_SI_BP = THER_i*((rhob*temp)*d_qim_dV_SI_BP+(rhob*d_temp_dV_SI_BP+d_rhob_dV_SI_BP*temp)*qim);
d_GR_dV_DI_SI = THER_i*((rhob*temp)*d_qim_dV_DI_SI+(rhob*d_temp_dV_DI_SI+d_rhob_dV_DI_SI*temp)*qim);
GR = (THER_i*((rhob*temp)*qim));

d_qeff_dV_SI_BP = (d_qbm_dV_SI_BP+eta_mu*d_qim_dV_SI_BP);
d_qeff_dV_GP_SI = (d_qbm_dV_GP_SI+eta_mu*d_qim_dV_GP_SI);
d_qeff_dV_DI_SI = (d_qbm_dV_DI_SI+eta_mu*d_qim_dV_DI_SI);
qeff = (qbm+(eta_mu*qim));

d_qeff1_dV_SI_BP = (d_qbm_dV_SI_BP+eta_mu1*d_qim_dV_SI_BP);
d_qeff1_dV_GP_SI = (d_qbm_dV_GP_SI+eta_mu1*d_qim_dV_GP_SI);
d_qeff1_dV_DI_SI = (d_qbm_dV_DI_SI+eta_mu1*d_qim_dV_DI_SI);
qeff1 = (qbm+(eta_mu1*qim));

d_Eeffm_dV_SI_BP = E_eff0*d_qeff_dV_SI_BP;
d_Eeffm_dV_GP_SI = E_eff0*d_qeff_dV_GP_SI;
d_Eeffm_dV_DI_SI = E_eff0*d_qeff_dV_DI_SI;
Eeffm = (E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_SI_BP*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_SI_BP-Pm*(d_Pm_dV_SI_BP+d_Dm_dV_SI_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_SI*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_SI-Pm*(d_Pm_dV_GP_SI+d_Dm_dV_GP_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_DI_SI*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_DI_SI-Pm*(d_Pm_dV_DI_SI+d_Dm_dV_DI_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
Mutmp = (value_pow_0+(CS_T*(Pm/((Pm+Dm)+1.0e-14))));
}

d_Gmob_dV_SI_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP+(d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor);
d_Gmob_dV_GP_SI = (d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor;
d_Gmob_dV_DI_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI+(d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
{
double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

d_s1_dV_SI_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_SI_BP)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_SI_BP-d_dps_dV_SI_BP)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_s1_dV_GP_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_GP_SI)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_GP_SI-d_dps_dV_GP_SI)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_s1_dV_DI_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(d_Vds_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
s1 = value_log_0;
}

d_dL_dV_SI_BP = ALP_i*d_s1_dV_SI_BP;
d_dL_dV_GP_SI = ALP_i*d_s1_dV_GP_SI;
d_dL_dV_DI_SI = ALP_i*d_s1_dV_DI_SI;
dL = (ALP_i*s1);

d_GdL_dV_SI_BP = (-(d_dL_dV_SI_BP+(dL*d_dL_dV_SI_BP+d_dL_dV_SI_BP*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_GP_SI = (-(d_dL_dV_GP_SI+(dL*d_dL_dV_GP_SI+d_dL_dV_GP_SI*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_DI_SI = (-(d_dL_dV_DI_SI+(dL*d_dL_dV_DI_SI+d_dL_dV_DI_SI*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));

d_temp2_dV_GP_SI = d_qim_dV_GP_SI*xitsb;
d_temp2_dV_SI_BP = (qim*d_xitsb_dV_SI_BP+d_qim_dV_SI_BP*xitsb);
d_temp2_dV_DI_SI = (qim*d_xitsb_dV_DI_SI+d_qim_dV_DI_SI*xitsb);
temp2 = (qim*xitsb);

d_wsat_dV_SI_BP = 100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_SI = 100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_DI_SI = 100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));

d_Gmob_dL_dV_SI_BP = (Gmob*d_GdL_dV_SI_BP+d_Gmob_dV_SI_BP*GdL);
d_Gmob_dL_dV_GP_SI = (Gmob*d_GdL_dV_GP_SI+d_Gmob_dV_GP_SI*GdL);
d_Gmob_dL_dV_DI_SI = (Gmob*d_GdL_dV_DI_SI+d_Gmob_dV_DI_SI*GdL);
Gmob_dL = (Gmob*GdL);
if ((THESATG_i<0.0))
{

d_temp_dV_SI_BP = (-(-THESATG_i*d_wsat_dV_SI_BP)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_GP_SI = (-(-THESATG_i*d_wsat_dV_GP_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_DI_SI = (-(-THESATG_i*d_wsat_dV_DI_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
temp = (1.0/(1.0-(THESATG_i*wsat)));
}
else
{

d_temp_dV_SI_BP = THESATG_i*d_wsat_dV_SI_BP;
d_temp_dV_GP_SI = THESATG_i*d_wsat_dV_GP_SI;
d_temp_dV_DI_SI = THESATG_i*d_wsat_dV_DI_SI;
temp = (1.0+(THESATG_i*wsat));
}

d_thesat1_dV_SI_BP = THESAT_T*((Gmob_dL*d_temp_dV_SI_BP-temp*d_Gmob_dL_dV_SI_BP)/Gmob_dL/Gmob_dL);
d_thesat1_dV_DI_SI = THESAT_T*((Gmob_dL*d_temp_dV_DI_SI-temp*d_Gmob_dL_dV_DI_SI)/Gmob_dL/Gmob_dL);
d_thesat1_dV_GP_SI = THESAT_T*((Gmob_dL*d_temp_dV_GP_SI-temp*d_Gmob_dL_dV_GP_SI)/Gmob_dL/Gmob_dL);
thesat1 = (THESAT_T*(temp/Gmob_dL));

d_zsat_dV_SI_BP = (((thesat1*thesat1)*dps)*d_dps_dV_SI_BP+((thesat1*thesat1)*d_dps_dV_SI_BP+(thesat1*d_thesat1_dV_SI_BP+d_thesat1_dV_SI_BP*thesat1)*dps)*dps);
d_zsat_dV_DI_SI = (((thesat1*thesat1)*dps)*d_dps_dV_DI_SI+((thesat1*thesat1)*d_dps_dV_DI_SI+(thesat1*d_thesat1_dV_DI_SI+d_thesat1_dV_DI_SI*thesat1)*dps)*dps);
d_zsat_dV_GP_SI = (((thesat1*thesat1)*dps)*d_dps_dV_GP_SI+((thesat1*thesat1)*d_dps_dV_GP_SI+(thesat1*d_thesat1_dV_GP_SI+d_thesat1_dV_GP_SI*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if (((model_.CHNL_TYPE)==(-1)))
{

d_zsat_dV_SI_BP = (((1.0+(thesat1*dps))*d_zsat_dV_SI_BP-zsat*(thesat1*d_dps_dV_SI_BP+d_thesat1_dV_SI_BP*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_DI_SI = (((1.0+(thesat1*dps))*d_zsat_dV_DI_SI-zsat*(thesat1*d_dps_dV_DI_SI+d_thesat1_dV_DI_SI*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_GP_SI = (((1.0+(thesat1*dps))*d_zsat_dV_GP_SI-zsat*(thesat1*d_dps_dV_GP_SI+d_thesat1_dV_GP_SI*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gvsat_dV_SI_BP = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_SI_BP))+d_Gmob_dL_dV_SI_BP*(1.0+value_sqrt_0));
d_Gvsat_dV_GP_SI = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_GP_SI))+d_Gmob_dL_dV_GP_SI*(1.0+value_sqrt_0));
d_Gvsat_dV_DI_SI = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_DI_SI))+d_Gmob_dL_dV_DI_SI*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}

d_Gvsatinv_dV_SI_BP = (-d_Gvsat_dV_SI_BP/Gvsat/Gvsat);
d_Gvsatinv_dV_GP_SI = (-d_Gvsat_dV_GP_SI/Gvsat/Gvsat);
d_Gvsatinv_dV_DI_SI = (-d_Gvsat_dV_DI_SI/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);

d_Voxm_dV_SI_BP = (xgm*d_phit1_dV_SI_BP+d_xgm_dV_SI_BP*phit1);
d_Voxm_dV_GP_SI = (xgm*d_phit1_dV_GP_SI+d_xgm_dV_GP_SI*phit1);
d_Voxm_dV_DI_SI = (xgm*d_phit1_dV_DI_SI+d_xgm_dV_DI_SI*phit1);
Voxm = (xgm*phit1);

d_temp_dV_SI_BP = (Gmob_dL*d_Gvsatinv_dV_SI_BP+d_Gmob_dL_dV_SI_BP*Gvsatinv);
d_temp_dV_GP_SI = (Gmob_dL*d_Gvsatinv_dV_GP_SI+d_Gmob_dL_dV_GP_SI*Gvsatinv);
d_temp_dV_DI_SI = (Gmob_dL*d_Gvsatinv_dV_DI_SI+d_Gmob_dL_dV_DI_SI*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);

d_alpha1_dV_SI_BP = (alpha*0.5*((zsat*temp)*d_temp_dV_SI_BP+(zsat*d_temp_dV_SI_BP+d_zsat_dV_SI_BP*temp)*temp)+d_alpha_dV_SI_BP*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_GP_SI = (alpha*0.5*((zsat*temp)*d_temp_dV_GP_SI+(zsat*d_temp_dV_GP_SI+d_zsat_dV_GP_SI*temp)*temp)+d_alpha_dV_GP_SI*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_DI_SI = (alpha*0.5*((zsat*temp)*d_temp_dV_DI_SI+(zsat*d_temp_dV_DI_SI+d_zsat_dV_DI_SI*temp)*temp)+d_alpha_dV_DI_SI*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

d_H_dV_SI_BP = ((alpha1*(temp*d_qim1_dV_SI_BP+d_temp_dV_SI_BP*qim1)-(temp*qim1)*d_alpha1_dV_SI_BP)/alpha1/alpha1);
d_H_dV_DI_SI = ((alpha1*(temp*d_qim1_dV_DI_SI+d_temp_dV_DI_SI*qim1)-(temp*qim1)*d_alpha1_dV_DI_SI)/alpha1/alpha1);
d_H_dV_GP_SI = ((alpha1*(temp*d_qim1_dV_GP_SI+d_temp_dV_GP_SI*qim1)-(temp*qim1)*d_alpha1_dV_GP_SI)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
}
if ((xg>0.0))
{

d_qim1_1_dV_GP_SI = (-d_qim1_dV_GP_SI/qim1/qim1);
d_qim1_1_dV_SI_BP = (-d_qim1_dV_SI_BP/qim1/qim1);
d_qim1_1_dV_DI_SI = (-d_qim1_dV_DI_SI/qim1/qim1);
qim1_1 = (1.0/qim1);

d_r1_dV_GP_SI = (qim*d_qim1_1_dV_GP_SI+d_qim_dV_GP_SI*qim1_1);
d_r1_dV_SI_BP = (qim*d_qim1_1_dV_SI_BP+d_qim_dV_SI_BP*qim1_1);
d_r1_dV_DI_SI = (qim*d_qim1_1_dV_DI_SI+d_qim_dV_DI_SI*qim1_1);
r1 = (qim*qim1_1);

d_r2_dV_GP_SI = (phit1*(alpha*d_qim1_1_dV_GP_SI+d_alpha_dV_GP_SI*qim1_1)+d_phit1_dV_GP_SI*(alpha*qim1_1));
d_r2_dV_SI_BP = (phit1*(alpha*d_qim1_1_dV_SI_BP+d_alpha_dV_SI_BP*qim1_1)+d_phit1_dV_SI_BP*(alpha*qim1_1));
d_r2_dV_DI_SI = (phit1*(alpha*d_qim1_1_dV_DI_SI+d_alpha_dV_DI_SI*qim1_1)+d_phit1_dV_DI_SI*(alpha*qim1_1));
r2 = (phit1*(alpha*qim1_1));
{
double value_log_0 = log((1.0+(Vdsx*inv_VP)));
double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*inv_VP)));

d_s2_dV_DI_SI = (deriv_log_0_d0*(d_Vdsx_dV_DI_SI*inv_VP));
s2 = value_log_0;
}

d_dL1_dV_SI_BP = ((d_dL_dV_SI_BP+ALP1_i*((qim1_1*r1)*d_s1_dV_SI_BP+(qim1_1*d_r1_dV_SI_BP+d_qim1_1_dV_SI_BP*r1)*s1))+ALP2_i*((qbm*r2)*d_r2_dV_SI_BP+(qbm*d_r2_dV_SI_BP+d_qbm_dV_SI_BP*r2)*r2)*s2);
d_dL1_dV_GP_SI = ((d_dL_dV_GP_SI+ALP1_i*((qim1_1*r1)*d_s1_dV_GP_SI+(qim1_1*d_r1_dV_GP_SI+d_qim1_1_dV_GP_SI*r1)*s1))+ALP2_i*((qbm*r2)*d_r2_dV_GP_SI+(qbm*d_r2_dV_GP_SI+d_qbm_dV_GP_SI*r2)*r2)*s2);
d_dL1_dV_DI_SI = ((d_dL_dV_DI_SI+ALP1_i*((qim1_1*r1)*d_s1_dV_DI_SI+(qim1_1*d_r1_dV_DI_SI+d_qim1_1_dV_DI_SI*r1)*s1))+ALP2_i*(((qbm*r2)*r2)*d_s2_dV_DI_SI+((qbm*r2)*d_r2_dV_DI_SI+(qbm*d_r2_dV_DI_SI+d_qbm_dV_DI_SI*r2)*r2)*s2));
dL1 = ((dL+(ALP1_i*((qim1_1*r1)*s1)))+(ALP2_i*(((qbm*r2)*r2)*s2)));

d_FdL_dV_SI_BP = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_SI_BP+(d_dL1_dV_SI_BP+(dL1*d_dL1_dV_SI_BP+d_dL1_dV_SI_BP*dL1))*GdL);
d_FdL_dV_GP_SI = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_GP_SI+(d_dL1_dV_GP_SI+(dL1*d_dL1_dV_GP_SI+d_dL1_dV_GP_SI*dL1))*GdL);
d_FdL_dV_DI_SI = (((1.0+dL1)+(dL1*dL1))*d_GdL_dV_DI_SI+(d_dL1_dV_DI_SI+(dL1*d_dL1_dV_DI_SI+d_dL1_dV_DI_SI*dL1))*GdL);
FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
}

d_xg_dc_dV_SI_BP = d_xg_dV_SI_BP;
d_xg_dc_dV_GP_SI = d_xg_dV_GP_SI;
d_xg_dc_dV_DI_SI = d_xg_dV_DI_SI;
xg_dc = xg;

d_qeff1_dc_dV_SI_BP = d_qeff1_dV_SI_BP;
d_qeff1_dc_dV_GP_SI = d_qeff1_dV_GP_SI;
d_qeff1_dc_dV_DI_SI = d_qeff1_dV_DI_SI;
qeff1_dc = qeff1;

d_Voxm_dc_dV_SI_BP = d_Voxm_dV_SI_BP;
d_Voxm_dc_dV_GP_SI = d_Voxm_dV_GP_SI;
d_Voxm_dc_dV_DI_SI = d_Voxm_dV_DI_SI;
Voxm_dc = Voxm;

d_alpha_dc_dV_SI_BP = d_alpha_dV_SI_BP;
d_alpha_dc_dV_GP_SI = d_alpha_dV_GP_SI;
d_alpha_dc_dV_DI_SI = d_alpha_dV_DI_SI;
alpha_dc = alpha;

d_dps_dc_dV_SI_BP = d_dps_dV_SI_BP;
d_dps_dc_dV_GP_SI = d_dps_dV_GP_SI;
d_dps_dc_dV_DI_SI = d_dps_dV_DI_SI;
dps_dc = dps;

d_qim_dc_dV_GP_SI = d_qim_dV_GP_SI;
d_qim_dc_dV_SI_BP = d_qim_dV_SI_BP;
d_qim_dc_dV_DI_SI = d_qim_dV_DI_SI;
qim_dc = qim;

d_qim1_dc_dV_GP_SI = d_qim1_dV_GP_SI;
d_qim1_dc_dV_SI_BP = d_qim1_dV_SI_BP;
d_qim1_dc_dV_DI_SI = d_qim1_dV_DI_SI;
qim1_dc = qim1;

d_GdL_dc_dV_SI_BP = d_GdL_dV_SI_BP;
d_GdL_dc_dV_GP_SI = d_GdL_dV_GP_SI;
d_GdL_dc_dV_DI_SI = d_GdL_dV_DI_SI;
GdL_dc = GdL;

d_FdL_dc_dV_SI_BP = d_FdL_dV_SI_BP;
d_FdL_dc_dV_GP_SI = d_FdL_dV_GP_SI;
d_FdL_dc_dV_DI_SI = d_FdL_dV_DI_SI;
FdL_dc = FdL;

d_H_dc_dV_SI_BP = d_H_dV_SI_BP;
d_H_dc_dV_DI_SI = d_H_dV_DI_SI;
d_H_dc_dV_GP_SI = d_H_dV_GP_SI;
H_dc = H;

d_eta_p_dc_dV_SI_BP = d_eta_p_dV_SI_BP;
d_eta_p_dc_dV_GP_SI = d_eta_p_dV_GP_SI;
d_eta_p_dc_dV_DI_SI = d_eta_p_dV_DI_SI;
eta_p_dc = eta_p;

d_Gvsat_dc_dV_SI_BP = d_Gvsat_dV_SI_BP;
d_Gvsat_dc_dV_GP_SI = d_Gvsat_dV_GP_SI;
d_Gvsat_dc_dV_DI_SI = d_Gvsat_dV_DI_SI;
Gvsat_dc = Gvsat;

d_Gvsatinv_dc_dV_SI_BP = d_Gvsatinv_dV_SI_BP;
d_Gvsatinv_dc_dV_GP_SI = d_Gvsatinv_dV_GP_SI;
d_Gvsatinv_dc_dV_DI_SI = d_Gvsatinv_dV_DI_SI;
Gvsatinv_dc = Gvsatinv;

d_Gmob_dL_dc_dV_SI_BP = d_Gmob_dL_dV_SI_BP;
d_Gmob_dL_dc_dV_GP_SI = d_Gmob_dL_dV_GP_SI;
d_Gmob_dL_dc_dV_DI_SI = d_Gmob_dL_dV_DI_SI;
Gmob_dL_dc = Gmob_dL;

d_x_ds_dc_dV_SI_BP = d_x_ds_dV_SI_BP;
d_x_ds_dc_dV_GP_SI = d_x_ds_dV_GP_SI;
d_x_ds_dc_dV_DI_SI = d_x_ds_dV_DI_SI;
x_ds_dc = x_ds;

d_x_m_dc_dV_SI_BP = d_x_m_dV_SI_BP;
d_x_m_dc_dV_GP_SI = d_x_m_dV_GP_SI;
d_x_m_dc_dV_DI_SI = d_x_m_dV_DI_SI;
x_m_dc = x_m;
Gf_dc = Gf;
Vdsat_dc = Vdsat;

d_Udse_dc_dV_DI_SI = d_Udse_dV_DI_SI;
d_Udse_dc_dV_SI_BP = d_Udse_dV_SI_BP;
d_Udse_dc_dV_GP_SI = d_Udse_dV_GP_SI;
Udse_dc = Udse;

d_Gmob_dc_dV_SI_BP = d_Gmob_dV_SI_BP;
d_Gmob_dc_dV_GP_SI = d_Gmob_dV_GP_SI;
d_Gmob_dc_dV_DI_SI = d_Gmob_dV_DI_SI;
Gmob_dc = Gmob;

d_xitsb_dc_dV_SI_BP = d_xitsb_dV_SI_BP;
d_xitsb_dc_dV_DI_SI = d_xitsb_dV_DI_SI;
xitsb_dc = xitsb;

d_Vdse_dc_dV_DI_SI = d_Vdse_dV_DI_SI;
d_Vdse_dc_dV_SI_BP = d_Vdse_dV_SI_BP;
d_Vdse_dc_dV_GP_SI = d_Vdse_dV_GP_SI;
Vdse_dc = Vdse;
}
// End block SPcalc_dc
if ((xg_dc<=0))
{

d_Ids_dV_DI_SI = d_Ids_dV_GP_SI = d_Ids_dV_SI_BP =  0.0;
Ids = 0.0;
}
else
{

d_Ids_dV_SI_BP = BET_i*(((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_SI_BP+((FdL_dc*qim1_dc)*d_dps_dc_dV_SI_BP+(FdL_dc*d_qim1_dc_dV_SI_BP+d_FdL_dc_dV_SI_BP*qim1_dc)*dps_dc)*Gvsatinv_dc);
d_Ids_dV_GP_SI = BET_i*(((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_GP_SI+((FdL_dc*qim1_dc)*d_dps_dc_dV_GP_SI+(FdL_dc*d_qim1_dc_dV_GP_SI+d_FdL_dc_dV_GP_SI*qim1_dc)*dps_dc)*Gvsatinv_dc);
d_Ids_dV_DI_SI = BET_i*(((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dV_DI_SI+((FdL_dc*qim1_dc)*d_dps_dc_dV_DI_SI+(FdL_dc*d_qim1_dc_dV_DI_SI+d_FdL_dc_dV_DI_SI*qim1_dc)*dps_dc)*Gvsatinv_dc);
Ids = (BET_i*(((FdL_dc*qim1_dc)*dps_dc)*Gvsatinv_dc));
}
if (((((((model_.SWIGATE_i)!=0)&&((IGOV_i>0.0)||(IGOVD_i>0.0)))||(((model_.SWGIDL_i)!=0)&&((AGIDL_i>0.0)||(AGIDLD_i>0.0))))||(CGOV_i>0.0))||(CGOVD_i>0.0)))
{
{
double value_sqrt_0 = sqrt(((xgs_ov*xgs_ov)+SP_OV_eps2_s));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_xg_dV_DI_SI =  0.0;
d_SP_OV_xg_dV_GP_SI = 0.5*(d_xgs_ov_dV_GP_SI+(deriv_sqrt_0_d0*((xgs_ov*d_xgs_ov_dV_GP_SI+d_xgs_ov_dV_GP_SI*xgs_ov))));
SP_OV_xg = (0.5*(xgs_ov+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((SP_OV_xg+(GOV2_s*0.25))+SP_OV_a_s));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xs_ov_dV_GP_SI = ((-d_SP_OV_xg_dV_GP_SI)+GOV_s*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_GP_SI)));
xs_ov = ((((-SP_OV_xg)-(GOV2_s*0.5))+(GOV_s*value_sqrt_0))+SP_OV_delta1_s);
}
{
double value_sqrt_0 = sqrt(((xgd_ov*xgd_ov)+SP_OV_eps2_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_OV_xg_dV_DI_SI = 0.5*(d_xgd_ov_dV_DI_SI+(deriv_sqrt_0_d0*((xgd_ov*d_xgd_ov_dV_DI_SI+d_xgd_ov_dV_DI_SI*xgd_ov))));
d_SP_OV_xg_dV_GP_SI = 0.5*(d_xgd_ov_dV_GP_SI+(deriv_sqrt_0_d0*((xgd_ov*d_xgd_ov_dV_GP_SI+d_xgd_ov_dV_GP_SI*xgd_ov))));
SP_OV_xg = (0.5*(xgd_ov+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((SP_OV_xg+(GOV2_d*0.25))+SP_OV_a_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xd_ov_dV_GP_SI = ((-d_SP_OV_xg_dV_GP_SI)+GOV_d*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_GP_SI)));
d_xd_ov_dV_DI_SI = ((-d_SP_OV_xg_dV_DI_SI)+GOV_d*(deriv_sqrt_0_d0*(d_SP_OV_xg_dV_DI_SI)));
xd_ov = ((((-SP_OV_xg)-(GOV2_d*0.5))+(GOV_d*value_sqrt_0))+SP_OV_delta1_d);
}

d_Vovs_dV_GP_SI = (-(model_.phita))*(d_xgs_ov_dV_GP_SI+d_xs_ov_dV_GP_SI);
Vovs = ((-(model_.phita))*(xgs_ov+xs_ov));

d_Vovd_dV_DI_SI = (-(model_.phita))*(d_xgd_ov_dV_DI_SI+d_xd_ov_dV_DI_SI);
d_Vovd_dV_GP_SI = (-(model_.phita))*(d_xgd_ov_dV_GP_SI+d_xd_ov_dV_GP_SI);
Vovd = ((-(model_.phita))*(xgd_ov+xd_ov));
}

d_Igsov_dV_GP_SI = d_Igsov_dV_DI_SI = d_Igsov_dV_SI_BP =  0.0;
Igsov = 0.0;

d_Igdov_dV_GP_SI = d_Igdov_dV_DI_SI = d_Igdov_dV_SI_BP =  0.0;
Igdov = 0.0;

d_Igc_dV_GP_SI = d_Igc_dV_DI_SI = d_Igc_dV_SI_BP =  0.0;
Igc = 0.0;

d_Igb_dV_GP_SI = d_Igb_dV_DI_SI = d_Igb_dV_SI_BP =  0.0;
Igb = 0.0;

d_Igcs_dV_GP_SI = d_Igcs_dV_DI_SI = d_Igcs_dV_SI_BP =  0.0;
Igcs = 0.0;

d_Igcd_dV_GP_SI = d_Igcd_dV_DI_SI = d_Igcd_dV_SI_BP =  0.0;
Igcd = 0.0;
if (((model_.SWIGATE_i)!=0))
{
if ((IGOV_i>0.0))
{
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_SI_BP = d_zg_dV_DI_SI =  0.0;
d_zg_dV_GP_SI = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_GP_SI+d_Vovs_dV_GP_SI*Vovs)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_SI_BP = d_zg_dV_DI_SI =  0.0;
d_zg_dV_GP_SI = 0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
d_temp_dV_GP_SI = BOV*(zg*GC3_i*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)));
temp = (BOV*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0.0))
{

d_TP_dV_SI_BP = (temp*0.5*(temp*d_temp_dV_SI_BP*3.3333333333333333e-01+d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_DI_SI = (temp*0.5*(temp*d_temp_dV_DI_SI*3.3333333333333333e-01+d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_SI = (temp*0.5*(temp*d_temp_dV_GP_SI*3.3333333333333333e-01+d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
TP = value_exp_0;
}
}
else
{

d_TP_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_SI_BP)*3.3333333333333333e-01+(-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_DI_SI)*3.3333333333333333e-01+(-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_SI)*3.3333333333333333e-01+(-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}

d_Fs1_dV_DI_SI =  0.0;
d_Fs1_dV_GP_SI = d_xs_ov_dV_GP_SI;
Fs1 = (3.0+xs_ov);
Fs2 = ((-3.0)-GCO_i);

d_Fs3_dV_DI_SI =  0.0;
d_Fs3_dV_GP_SI = 30.0*d_VgsPrime_dV_GP_SI;
Fs3 = (30.0*VgsPrime);
tme1 = (4.0-0.9);

d_tme2_dV_DI_SI = d_tme2_dV_SI_BP =  0.0;
d_tme2_dV_GP_SI = (d_Fs1_dV_GP_SI+d_Fs3_dV_GP_SI);
tme2 = (Fs1+Fs3);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_DI_SI = d_temp_dV_SI_BP =  0.0;
d_temp_dV_GP_SI = (2.0/tme1)*(d_tme2_dV_GP_SI-(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_GP_SI+d_tme2_dV_GP_SI*tme2)-((tme1*Fs1)*d_Fs3_dV_GP_SI+tme1*d_Fs1_dV_GP_SI*Fs3)))));
temp = ((2.0/tme1)*(tme2-value_sqrt_0));
}
tme1 = (4.0-0.3);

d_tme2_dV_SI_BP = d_temp_dV_SI_BP;
d_tme2_dV_DI_SI = d_temp_dV_DI_SI;
d_tme2_dV_GP_SI = d_temp_dV_GP_SI;
tme2 = (Fs2+temp);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Fs_dV_GP_SI = (2.0/tme1)*(d_tme2_dV_GP_SI+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_GP_SI+d_tme2_dV_GP_SI*tme2)-(tme1*Fs2)*d_temp_dV_GP_SI))));
d_Fs_dV_SI_BP = (2.0/tme1)*(d_tme2_dV_SI_BP+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_SI_BP+d_tme2_dV_SI_BP*tme2)-(tme1*Fs2)*d_temp_dV_SI_BP))));
d_Fs_dV_DI_SI = (2.0/tme1)*(d_tme2_dV_DI_SI+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_DI_SI+d_tme2_dV_DI_SI*tme2)-(tme1*Fs2)*d_temp_dV_DI_SI))));
Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
}

d_Igsov_dV_SI_BP = IGOV_i*(TP*d_Fs_dV_SI_BP+d_TP_dV_SI_BP*Fs);
d_Igsov_dV_DI_SI = IGOV_i*(TP*d_Fs_dV_DI_SI+d_TP_dV_DI_SI*Fs);
d_Igsov_dV_GP_SI = IGOV_i*(TP*d_Fs_dV_GP_SI+d_TP_dV_GP_SI*Fs);
Igsov = (IGOV_i*(TP*Fs));
}
if ((IGOVD_i>0.0))
{
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_SI_BP =  0.0;
d_zg_dV_DI_SI = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_DI_SI+d_Vovd_dV_DI_SI*Vovd)))*inv_CHIB;
d_zg_dV_GP_SI = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_GP_SI+d_Vovd_dV_GP_SI*Vovd)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_SI_BP =  0.0;
d_zg_dV_GP_SI = 0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(zg-GCQ)))));
d_zg_dV_DI_SI = 0.5*(d_zg_dV_DI_SI-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_DI_SI+d_zg_dV_DI_SI*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_temp_dV_SI_BP =  0.0;
d_temp_dV_GP_SI = BOV_d*(zg*GC3_i*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)));
d_temp_dV_DI_SI = BOV_d*(zg*GC3_i*d_zg_dV_DI_SI+d_zg_dV_DI_SI*(GC2_i+(GC3_i*zg)));
temp = (BOV_d*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0.0))
{

d_TP_dV_SI_BP = (temp*0.5*(temp*d_temp_dV_SI_BP*3.3333333333333333e-01+d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_DI_SI = (temp*0.5*(temp*d_temp_dV_DI_SI*3.3333333333333333e-01+d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_SI = (temp*0.5*(temp*d_temp_dV_GP_SI*3.3333333333333333e-01+d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
TP = value_exp_0;
}
}
else
{

d_TP_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_SI_BP)*3.3333333333333333e-01+(-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_DI_SI)*3.3333333333333333e-01+(-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_SI)*3.3333333333333333e-01+(-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}

d_Fs1_dV_GP_SI = d_xd_ov_dV_GP_SI;
d_Fs1_dV_DI_SI = d_xd_ov_dV_DI_SI;
Fs1 = (3.0+xd_ov);
Fs2 = ((-3.0)-GCO_i);

d_Fs3_dV_DI_SI = 30.0*d_VgdPrime_dV_DI_SI;
d_Fs3_dV_GP_SI = 30.0*d_VgdPrime_dV_GP_SI;
Fs3 = (30.0*VgdPrime);
tme1 = (4.0-0.9);

d_tme2_dV_SI_BP =  0.0;
d_tme2_dV_GP_SI = (d_Fs1_dV_GP_SI+d_Fs3_dV_GP_SI);
d_tme2_dV_DI_SI = (d_Fs1_dV_DI_SI+d_Fs3_dV_DI_SI);
tme2 = (Fs1+Fs3);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_GP_SI = (2.0/tme1)*(d_tme2_dV_GP_SI-(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_GP_SI+d_tme2_dV_GP_SI*tme2)-((tme1*Fs1)*d_Fs3_dV_GP_SI+tme1*d_Fs1_dV_GP_SI*Fs3)))));
d_temp_dV_SI_BP = (2.0/tme1)*(d_tme2_dV_SI_BP-(deriv_sqrt_0_d0*((tme2*d_tme2_dV_SI_BP+d_tme2_dV_SI_BP*tme2))));
d_temp_dV_DI_SI = (2.0/tme1)*(d_tme2_dV_DI_SI-(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_DI_SI+d_tme2_dV_DI_SI*tme2)-((tme1*Fs1)*d_Fs3_dV_DI_SI+tme1*d_Fs1_dV_DI_SI*Fs3)))));
temp = ((2.0/tme1)*(tme2-value_sqrt_0));
}
tme1 = (4.0-0.3);

d_tme2_dV_SI_BP = d_temp_dV_SI_BP;
d_tme2_dV_DI_SI = d_temp_dV_DI_SI;
d_tme2_dV_GP_SI = d_temp_dV_GP_SI;
tme2 = (Fs2+temp);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Fs_dV_GP_SI = (2.0/tme1)*(d_tme2_dV_GP_SI+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_GP_SI+d_tme2_dV_GP_SI*tme2)-(tme1*Fs2)*d_temp_dV_GP_SI))));
d_Fs_dV_SI_BP = (2.0/tme1)*(d_tme2_dV_SI_BP+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_SI_BP+d_tme2_dV_SI_BP*tme2)-(tme1*Fs2)*d_temp_dV_SI_BP))));
d_Fs_dV_DI_SI = (2.0/tme1)*(d_tme2_dV_DI_SI+(deriv_sqrt_0_d0*(((tme2*d_tme2_dV_DI_SI+d_tme2_dV_DI_SI*tme2)-(tme1*Fs2)*d_temp_dV_DI_SI))));
Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
}

d_Igdov_dV_SI_BP = IGOVD_i*(TP*d_Fs_dV_SI_BP+d_TP_dV_SI_BP*Fs);
d_Igdov_dV_DI_SI = IGOVD_i*(TP*d_Fs_dV_DI_SI+d_TP_dV_DI_SI*Fs);
d_Igdov_dV_GP_SI = IGOVD_i*(TP*d_Fs_dV_GP_SI+d_TP_dV_GP_SI*Fs);
Igdov = (IGOVD_i*(TP*Fs));
}
if ((IGINV_i>0.0))
{
if ((xg_dc<=0.0))
{
{
double value_pow_0 = pow((Vds/Vdsat_lim),AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat_lim) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat_lim)));

d_temp_dV_GP_SI =  0.0;
d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_lim_dV_SI_BP/Vdsat_lim/Vdsat_lim)));
d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat_lim*d_Vds_dV_DI_SI-Vds*d_Vdsat_lim_dV_DI_SI)/Vdsat_lim/Vdsat_lim)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

d_Udse_dc_dV_SI_BP = ((Vds*value_pow_0)*d_inv_phit1_dV_SI_BP+Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP))*inv_phit1);
d_Udse_dc_dV_GP_SI = ((Vds*value_pow_0)*d_inv_phit1_dV_GP_SI+Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI))*inv_phit1);
d_Udse_dc_dV_DI_SI = ((Vds*value_pow_0)*d_inv_phit1_dV_DI_SI+(Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI))+d_Vds_dV_DI_SI*value_pow_0)*inv_phit1);
Udse_dc = ((Vds*value_pow_0)*inv_phit1);
}
}
if (((x_ds_dc-Udse_dc)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_ds_dc-Udse_dc));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP)));
d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI)));
d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI)));
temp = value_exp_0;
}
}
else
{

d_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*3.3333333333333333e-01+(-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))+(-(d_x_ds_dc_dV_SI_BP-d_Udse_dc_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
d_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*3.3333333333333333e-01+(-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))+(-(d_x_ds_dc_dV_GP_SI-d_Udse_dc_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*3.3333333333333333e-01+(-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))+(-(d_x_ds_dc_dV_DI_SI-d_Udse_dc_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
}
{
double value_log_0 = log((0.5*(1.0+temp)));
double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));

d_Vm_dV_GP_SI = (phit1*(0.5*d_x_ds_dc_dV_GP_SI-(deriv_log_0_d0*(0.5*d_temp_dV_GP_SI)))+d_phit1_dV_GP_SI*((0.5*x_ds_dc)-value_log_0));
d_Vm_dV_SI_BP = (d_Vsbstar_dc_dV_SI_BP+(phit1*(0.5*d_x_ds_dc_dV_SI_BP-(deriv_log_0_d0*(0.5*d_temp_dV_SI_BP)))+d_phit1_dV_SI_BP*((0.5*x_ds_dc)-value_log_0)));
d_Vm_dV_DI_SI = (d_Vsbstar_dc_dV_DI_SI+(phit1*(0.5*d_x_ds_dc_dV_DI_SI-(deriv_log_0_d0*(0.5*d_temp_dV_DI_SI)))+d_phit1_dV_DI_SI*((0.5*x_ds_dc)-value_log_0)));
Vm = (Vsbstar_dc+(phit1*((0.5*x_ds_dc)-value_log_0)));
}

d_Dch_dV_SI_BP = GCO_i*d_phit1_dV_SI_BP;
d_Dch_dV_DI_SI = GCO_i*d_phit1_dV_DI_SI;
Dch = (GCO_i*phit1);

d_arg2mina_dV_SI_BP = (d_Voxm_dc_dV_SI_BP+d_Dch_dV_SI_BP);
d_arg2mina_dV_GP_SI = d_Voxm_dc_dV_GP_SI;
d_arg2mina_dV_DI_SI = (d_Voxm_dc_dV_DI_SI+d_Dch_dV_DI_SI);
arg2mina = (Voxm_dc+Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_psi_t_dV_SI_BP = 0.5*(d_arg2mina_dV_SI_BP-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_SI_BP)+(-d_arg2mina_dV_SI_BP)*(-arg2mina)))));
d_psi_t_dV_GP_SI = 0.5*(d_arg2mina_dV_GP_SI-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_GP_SI)+(-d_arg2mina_dV_GP_SI)*(-arg2mina)))));
d_psi_t_dV_DI_SI = 0.5*(d_arg2mina_dV_DI_SI-(deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dV_DI_SI)+(-d_arg2mina_dV_DI_SI)*(-arg2mina)))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm_dc*Voxm_dc)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_SI_BP = (deriv_sqrt_0_d0*((Voxm_dc*d_Voxm_dc_dV_SI_BP+d_Voxm_dc_dV_SI_BP*Voxm_dc)))*inv_CHIB;
d_zg_dV_GP_SI = (deriv_sqrt_0_d0*((Voxm_dc*d_Voxm_dc_dV_GP_SI+d_Voxm_dc_dV_GP_SI*Voxm_dc)))*inv_CHIB;
d_zg_dV_DI_SI = (deriv_sqrt_0_d0*((Voxm_dc*d_Voxm_dc_dV_DI_SI+d_Voxm_dc_dV_DI_SI*Voxm_dc)))*inv_CHIB;
zg = (value_sqrt_0*inv_CHIB);
}
if ((GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-GCQ)*(zg-GCQ))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zg_dV_GP_SI = 0.5*(d_zg_dV_GP_SI-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(zg-GCQ)))));
d_zg_dV_DI_SI = 0.5*(d_zg_dV_DI_SI-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_DI_SI+d_zg_dV_DI_SI*(zg-GCQ)))));
d_zg_dV_SI_BP = 0.5*(d_zg_dV_SI_BP-(deriv_sqrt_0_d0*(((zg-GCQ)*d_zg_dV_SI_BP+d_zg_dV_SI_BP*(zg-GCQ)))));
zg = (0.5*((zg+GCQ)-value_sqrt_0));
}
}

d_arg1_dV_SI_BP = (d_x_m_dc_dV_SI_BP+(((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_SI_BP+(d_psi_t_dV_SI_BP-d_Vm_dV_SI_BP)*inv_phit1));
d_arg1_dV_GP_SI = (d_x_m_dc_dV_GP_SI+(((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_GP_SI+(d_psi_t_dV_GP_SI-d_Vm_dV_GP_SI)*inv_phit1));
d_arg1_dV_DI_SI = (d_x_m_dc_dV_DI_SI+(((psi_t-alpha_b)-Vm)*d_inv_phit1_dV_DI_SI+(d_psi_t_dV_DI_SI-d_Vm_dV_DI_SI)*inv_phit1));
arg1 = (x_m_dc+(((psi_t-alpha_b)-Vm)*inv_phit1));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_Dsi_dV_SI_BP = (deriv_exp_0_d0*(d_arg1_dV_SI_BP));
d_Dsi_dV_GP_SI = (deriv_exp_0_d0*(d_arg1_dV_GP_SI));
d_Dsi_dV_DI_SI = (deriv_exp_0_d0*(d_arg1_dV_DI_SI));
Dsi = value_exp_0;
}
}
else
{
if ((arg1<0.0))
{

d_Dsi_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_SI_BP)*3.3333333333333333e-01+(-d_arg1_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_SI)*3.3333333333333333e-01+(-d_arg1_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_Dsi_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_DI_SI)*3.3333333333333333e-01+(-d_arg1_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_Dsi_dV_SI_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_SI_BP*3.3333333333333333e-01+d_arg1_dV_SI_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_SI_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_GP_SI = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_SI*3.3333333333333333e-01+d_arg1_dV_GP_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Dsi_dV_DI_SI = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_DI_SI*3.3333333333333333e-01+d_arg1_dV_DI_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_DI_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_arg1_dV_SI_BP = ((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_SI_BP+(-(d_Vsbstar_dc_dV_SI_BP-d_Vm_dV_SI_BP))*inv_phit1);
d_arg1_dV_GP_SI = ((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_GP_SI+(-(d_Vgs_dV_GP_SI-d_Vm_dV_GP_SI))*inv_phit1);
d_arg1_dV_DI_SI = ((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dV_DI_SI+(-((d_Vgs_dV_DI_SI+d_Vsbstar_dc_dV_DI_SI)-d_Vm_dV_DI_SI))*inv_phit1);
arg1 = ((-((Vgs+Vsbstar_dc)-Vm))*inv_phit1);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_SI_BP = (deriv_exp_0_d0*(d_arg1_dV_SI_BP));
d_temp_dV_GP_SI = (deriv_exp_0_d0*(d_arg1_dV_GP_SI));
d_temp_dV_DI_SI = (deriv_exp_0_d0*(d_arg1_dV_DI_SI));
temp = value_exp_0;
}
}
else
{
if ((arg1<0.0))
{

d_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_SI_BP)*3.3333333333333333e-01+(-d_arg1_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_GP_SI)*3.3333333333333333e-01+(-d_arg1_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dV_DI_SI)*3.3333333333333333e-01+(-d_arg1_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_SI_BP = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_SI_BP*3.3333333333333333e-01+d_arg1_dV_SI_BP*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_SI_BP*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_GP_SI = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_GP_SI*3.3333333333333333e-01+d_arg1_dV_GP_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_GP_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_DI_SI = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dV_DI_SI*3.3333333333333333e-01+d_arg1_dV_DI_SI*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dV_DI_SI*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Dgate_dV_SI_BP = (Dsi*d_temp_dV_SI_BP+d_Dsi_dV_SI_BP*temp);
d_Dgate_dV_GP_SI = (Dsi*d_temp_dV_GP_SI+d_Dsi_dV_GP_SI*temp);
d_Dgate_dV_DI_SI = (Dsi*d_temp_dV_DI_SI+d_Dsi_dV_DI_SI*temp);
Dgate = (Dsi*temp);

d_temp_dV_GP_SI = BCH*(zg*GC3_i*d_zg_dV_GP_SI+d_zg_dV_GP_SI*(GC2_i+(GC3_i*zg)));
d_temp_dV_DI_SI = BCH*(zg*GC3_i*d_zg_dV_DI_SI+d_zg_dV_DI_SI*(GC2_i+(GC3_i*zg)));
d_temp_dV_SI_BP = BCH*(zg*GC3_i*d_zg_dV_SI_BP+d_zg_dV_SI_BP*(GC2_i+(GC3_i*zg)));
temp = (BCH*((-1.5)+(zg*(GC2_i+(GC3_i*zg)))));
if ((temp>0))
{

d_TP_dV_SI_BP = (temp*0.5*(temp*d_temp_dV_SI_BP*3.3333333333333333e-01+d_temp_dV_SI_BP*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_SI_BP*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_DI_SI = (temp*0.5*(temp*d_temp_dV_DI_SI*3.3333333333333333e-01+d_temp_dV_DI_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_DI_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
d_TP_dV_GP_SI = (temp*0.5*(temp*d_temp_dV_GP_SI*3.3333333333333333e-01+d_temp_dV_GP_SI*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dV_GP_SI*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_TP_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
d_TP_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
d_TP_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
TP = value_exp_0;
}
}
else
{

d_TP_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_SI_BP)*3.3333333333333333e-01+(-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_DI_SI)*3.3333333333333333e-01+(-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_TP_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_SI)*3.3333333333333333e-01+(-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));

d_Igc0_dV_SI_BP = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_SI_BP-(1.0+Dsi)*d_Dgate_dV_SI_BP)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_SI_BP*value_log_0);
d_Igc0_dV_DI_SI = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_DI_SI-(1.0+Dsi)*d_Dgate_dV_DI_SI)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_DI_SI*value_log_0);
d_Igc0_dV_GP_SI = IGINV_i*(TP*(deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dV_GP_SI-(1.0+Dsi)*d_Dgate_dV_GP_SI)/(1.0+Dgate)/(1.0+Dgate))))+d_TP_dV_GP_SI*value_log_0);
Igc0 = (IGINV_i*(TP*value_log_0));
}
if (((xg_dc<=0.0)||((GC2_i==0.0)&&(GC3_i==0.0))))
{

d_igc_dV_DI_SI = d_igc_dV_GP_SI = d_igc_dV_SI_BP =  0.0;
igc = 1.0;

d_igcd_h_dV_DI_SI = d_igcd_h_dV_GP_SI = d_igcd_h_dV_SI_BP =  0.0;
igcd_h = 0.5;
}
else
{

d_temp_dV_GP_SI = (2.0*GC3_i)*d_zg_dV_GP_SI;
d_temp_dV_DI_SI = (2.0*GC3_i)*d_zg_dV_DI_SI;
d_temp_dV_SI_BP = (2.0*GC3_i)*d_zg_dV_SI_BP;
temp = (GC2_i+((2.0*GC3_i)*zg));

d_u0_dV_SI_BP = (-CHIB_i*d_temp_dV_SI_BP*BCH/(temp*BCH)/(temp*BCH));
d_u0_dV_DI_SI = (-CHIB_i*d_temp_dV_DI_SI*BCH/(temp*BCH)/(temp*BCH));
d_u0_dV_GP_SI = (-CHIB_i*d_temp_dV_GP_SI*BCH/(temp*BCH)/(temp*BCH));
u0 = (CHIB_i/(temp*BCH));

d_x_dV_SI_BP = 0.5*((u0*d_dps_dc_dV_SI_BP-dps_dc*d_u0_dV_SI_BP)/u0/u0);
d_x_dV_GP_SI = 0.5*((u0*d_dps_dc_dV_GP_SI-dps_dc*d_u0_dV_GP_SI)/u0/u0);
d_x_dV_DI_SI = 0.5*((u0*d_dps_dc_dV_DI_SI-dps_dc*d_u0_dV_DI_SI)/u0/u0);
x = (0.5*(dps_dc/u0));

d_u0_div_H_dV_SI_BP = ((H_dc*d_u0_dV_SI_BP-u0*d_H_dc_dV_SI_BP)/H_dc/H_dc);
d_u0_div_H_dV_DI_SI = ((H_dc*d_u0_dV_DI_SI-u0*d_H_dc_dV_DI_SI)/H_dc/H_dc);
d_u0_div_H_dV_GP_SI = ((H_dc*d_u0_dV_GP_SI-u0*d_H_dc_dV_GP_SI)/H_dc/H_dc);
u0_div_H = (u0/H_dc);

d_Bg_dV_SI_BP = (u0_div_H*(-d_u0_div_H_dV_SI_BP)+d_u0_div_H_dV_SI_BP*(1.0-u0_div_H))*0.5;
d_Bg_dV_DI_SI = (u0_div_H*(-d_u0_div_H_dV_DI_SI)+d_u0_div_H_dV_DI_SI*(1.0-u0_div_H))*0.5;
d_Bg_dV_GP_SI = (u0_div_H*(-d_u0_div_H_dV_GP_SI)+d_u0_div_H_dV_GP_SI*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);

d_Ag_dV_SI_BP = (-3.0*d_Bg_dV_SI_BP);
d_Ag_dV_DI_SI = (-3.0*d_Bg_dV_DI_SI);
d_Ag_dV_GP_SI = (-3.0*d_Bg_dV_GP_SI);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{

d_xsq_dV_SI_BP = (x*d_x_dV_SI_BP+d_x_dV_SI_BP*x);
d_xsq_dV_GP_SI = (x*d_x_dV_GP_SI+d_x_dV_GP_SI*x);
d_xsq_dV_DI_SI = (x*d_x_dV_DI_SI+d_x_dV_DI_SI*x);
xsq = (x*x);

d_igc_dV_SI_BP = (xsq*(d_u0_div_H_dV_SI_BP*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_SI_BP+d_xsq_dV_SI_BP*(0.05+(0.2*u0_div_H))))+d_xsq_dV_SI_BP*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
d_igc_dV_GP_SI = (xsq*(d_u0_div_H_dV_GP_SI*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_GP_SI+d_xsq_dV_GP_SI*(0.05+(0.2*u0_div_H))))+d_xsq_dV_GP_SI*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
d_igc_dV_DI_SI = (xsq*(d_u0_div_H_dV_DI_SI*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dV_DI_SI+d_xsq_dV_DI_SI*(0.05+(0.2*u0_div_H))))+d_xsq_dV_DI_SI*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));

d_igcd_h_dV_SI_BP = (0.5*d_igc_dV_SI_BP-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_SI_BP+0.0285714285714*(xsq*d_Bg_dV_SI_BP+d_xsq_dV_SI_BP*(0.125+Bg)))+d_xsq_dV_SI_BP*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_SI_BP*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
d_igcd_h_dV_GP_SI = (0.5*d_igc_dV_GP_SI-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_GP_SI+0.0285714285714*(xsq*d_Bg_dV_GP_SI+d_xsq_dV_GP_SI*(0.125+Bg)))+d_xsq_dV_GP_SI*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_GP_SI*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
d_igcd_h_dV_DI_SI = (0.5*d_igc_dV_DI_SI-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dV_DI_SI+0.0285714285714*(xsq*d_Bg_dV_DI_SI+d_xsq_dV_DI_SI*(0.125+Bg)))+d_xsq_dV_DI_SI*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dV_DI_SI*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
}
else
{

d_inv_x_dV_SI_BP = (-d_x_dV_SI_BP/x/x);
d_inv_x_dV_GP_SI = (-d_x_dV_GP_SI/x/x);
d_inv_x_dV_DI_SI = (-d_x_dV_DI_SI/x/x);
inv_x = (1.0/x);
if ((fabs(x)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;

d_ex_dV_SI_BP = (deriv_exp_0_d0*(d_x_dV_SI_BP));
d_ex_dV_GP_SI = (deriv_exp_0_d0*(d_x_dV_GP_SI));
d_ex_dV_DI_SI = (deriv_exp_0_d0*(d_x_dV_DI_SI));
ex = value_exp_0;
}
}
else
{
if ((x<0.0))
{

d_ex_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_SI_BP)*3.3333333333333333e-01+(-d_x_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
d_ex_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_GP_SI)*3.3333333333333333e-01+(-d_x_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
d_ex_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dV_DI_SI)*3.3333333333333333e-01+(-d_x_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
}
else
{

d_ex_dV_SI_BP = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_SI_BP*3.3333333333333333e-01+d_x_dV_SI_BP*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_SI_BP*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_ex_dV_GP_SI = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_GP_SI*3.3333333333333333e-01+d_x_dV_GP_SI*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_GP_SI*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_ex_dV_DI_SI = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dV_DI_SI*3.3333333333333333e-01+d_x_dV_DI_SI*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dV_DI_SI*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_inv_ex_dV_SI_BP = (-d_ex_dV_SI_BP/ex/ex);
d_inv_ex_dV_GP_SI = (-d_ex_dV_GP_SI/ex/ex);
d_inv_ex_dV_DI_SI = (-d_ex_dV_DI_SI/ex/ex);
inv_ex = (1.0/ex);

d_temp_dV_SI_BP = (d_ex_dV_SI_BP-d_inv_ex_dV_SI_BP);
d_temp_dV_GP_SI = (d_ex_dV_GP_SI-d_inv_ex_dV_GP_SI);
d_temp_dV_DI_SI = (d_ex_dV_DI_SI-d_inv_ex_dV_DI_SI);
temp = (ex-inv_ex);

d_temp2_dV_SI_BP = (d_ex_dV_SI_BP+d_inv_ex_dV_SI_BP);
d_temp2_dV_GP_SI = (d_ex_dV_GP_SI+d_inv_ex_dV_GP_SI);
d_temp2_dV_DI_SI = (d_ex_dV_DI_SI+d_inv_ex_dV_DI_SI);
temp2 = (ex+inv_ex);

d_igc_dV_SI_BP = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_SI_BP+((1.0-u0_div_H)*d_temp_dV_SI_BP+(-d_u0_div_H_dV_SI_BP)*temp)*inv_x)+(u0_div_H*d_temp2_dV_SI_BP+d_u0_div_H_dV_SI_BP*temp2));
d_igc_dV_DI_SI = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_DI_SI+((1.0-u0_div_H)*d_temp_dV_DI_SI+(-d_u0_div_H_dV_DI_SI)*temp)*inv_x)+(u0_div_H*d_temp2_dV_DI_SI+d_u0_div_H_dV_DI_SI*temp2));
d_igc_dV_GP_SI = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dV_GP_SI+((1.0-u0_div_H)*d_temp_dV_GP_SI+(-d_u0_div_H_dV_GP_SI)*temp)*inv_x)+(u0_div_H*d_temp2_dV_GP_SI+d_u0_div_H_dV_GP_SI*temp2));
igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));

d_igcd_h_dV_SI_BP = 0.5*((d_igc_dV_SI_BP-(temp*(d_Bg_dV_SI_BP-((Ag*inv_x)*d_inv_x_dV_SI_BP+(Ag*d_inv_x_dV_SI_BP+d_Ag_dV_SI_BP*inv_x)*inv_x))+d_temp_dV_SI_BP*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_SI_BP+(Ag*d_temp2_dV_SI_BP+d_Ag_dV_SI_BP*temp2)*inv_x));
d_igcd_h_dV_GP_SI = 0.5*((d_igc_dV_GP_SI-(temp*(d_Bg_dV_GP_SI-((Ag*inv_x)*d_inv_x_dV_GP_SI+(Ag*d_inv_x_dV_GP_SI+d_Ag_dV_GP_SI*inv_x)*inv_x))+d_temp_dV_GP_SI*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_GP_SI+(Ag*d_temp2_dV_GP_SI+d_Ag_dV_GP_SI*temp2)*inv_x));
d_igcd_h_dV_DI_SI = 0.5*((d_igc_dV_DI_SI-(temp*(d_Bg_dV_DI_SI-((Ag*inv_x)*d_inv_x_dV_DI_SI+(Ag*d_inv_x_dV_DI_SI+d_Ag_dV_DI_SI*inv_x)*inv_x))+d_temp_dV_DI_SI*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dV_DI_SI+(Ag*d_temp2_dV_DI_SI+d_Ag_dV_DI_SI*temp2)*inv_x));
igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
}
}
{
double value_sqrt_0 = sqrt(((xg_dc*xg_dc)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Sg_dV_SI_BP = 0.5*((value_sqrt_0*d_xg_dc_dV_SI_BP-xg_dc*(deriv_sqrt_0_d0*((xg_dc*d_xg_dc_dV_SI_BP+d_xg_dc_dV_SI_BP*xg_dc))))/value_sqrt_0/value_sqrt_0);
d_Sg_dV_GP_SI = 0.5*((value_sqrt_0*d_xg_dc_dV_GP_SI-xg_dc*(deriv_sqrt_0_d0*((xg_dc*d_xg_dc_dV_GP_SI+d_xg_dc_dV_GP_SI*xg_dc))))/value_sqrt_0/value_sqrt_0);
d_Sg_dV_DI_SI = 0.5*((value_sqrt_0*d_xg_dc_dV_DI_SI-xg_dc*(deriv_sqrt_0_d0*((xg_dc*d_xg_dc_dV_DI_SI+d_xg_dc_dV_DI_SI*xg_dc))))/value_sqrt_0/value_sqrt_0);
Sg = (0.5*(1.0+(xg_dc/value_sqrt_0)));
}

d_Igc_dV_SI_BP = ((Igc0*igc)*d_Sg_dV_SI_BP+(Igc0*d_igc_dV_SI_BP+d_Igc0_dV_SI_BP*igc)*Sg);
d_Igc_dV_DI_SI = ((Igc0*igc)*d_Sg_dV_DI_SI+(Igc0*d_igc_dV_DI_SI+d_Igc0_dV_DI_SI*igc)*Sg);
d_Igc_dV_GP_SI = ((Igc0*igc)*d_Sg_dV_GP_SI+(Igc0*d_igc_dV_GP_SI+d_Igc0_dV_GP_SI*igc)*Sg);
Igc = ((Igc0*igc)*Sg);

d_Igcd_dV_SI_BP = ((Igc0*igcd_h)*d_Sg_dV_SI_BP+(Igc0*d_igcd_h_dV_SI_BP+d_Igc0_dV_SI_BP*igcd_h)*Sg);
d_Igcd_dV_DI_SI = ((Igc0*igcd_h)*d_Sg_dV_DI_SI+(Igc0*d_igcd_h_dV_DI_SI+d_Igc0_dV_DI_SI*igcd_h)*Sg);
d_Igcd_dV_GP_SI = ((Igc0*igcd_h)*d_Sg_dV_GP_SI+(Igc0*d_igcd_h_dV_GP_SI+d_Igc0_dV_GP_SI*igcd_h)*Sg);
Igcd = ((Igc0*igcd_h)*Sg);

d_Igcs_dV_SI_BP = (d_Igc_dV_SI_BP-d_Igcd_dV_SI_BP);
d_Igcs_dV_DI_SI = (d_Igc_dV_DI_SI-d_Igcd_dV_DI_SI);
d_Igcs_dV_GP_SI = (d_Igc_dV_GP_SI-d_Igcd_dV_GP_SI);
Igcs = (Igc-Igcd);

d_Igb_dV_SI_BP = ((Igc0*igc)*(-d_Sg_dV_SI_BP)+(Igc0*d_igc_dV_SI_BP+d_Igc0_dV_SI_BP*igc)*(1.0-Sg));
d_Igb_dV_DI_SI = ((Igc0*igc)*(-d_Sg_dV_DI_SI)+(Igc0*d_igc_dV_DI_SI+d_Igc0_dV_DI_SI*igc)*(1.0-Sg));
d_Igb_dV_GP_SI = ((Igc0*igc)*(-d_Sg_dV_GP_SI)+(Igc0*d_igc_dV_GP_SI+d_Igc0_dV_GP_SI*igc)*(1.0-Sg));
Igb = ((Igc0*igc)*(1.0-Sg));
}
}

d_Igidl_dV_DI_SI = d_Igidl_dV_SI_BP = d_Igidl_dV_GP_SI =  0.0;
Igidl = 0.0;

d_Igisl_dV_SI_BP = d_Igisl_dV_GP_SI = d_Igisl_dV_DI_SI =  0.0;
Igisl = 0.0;
if (((model_.SWGIDL_i)!=0))
{
if (((AGIDLD_i>0)&&(Vovd<0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+((CGIDLD_i*CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovd_dV_SI_BP = (deriv_sqrt_0_d0*((CGIDLD_i*CGIDLD_i)*(VdbPrime*d_VdbPrime_dV_SI_BP+d_VdbPrime_dV_SI_BP*VdbPrime)));
d_Vtovd_dV_DI_SI = (deriv_sqrt_0_d0*(((Vovd*d_Vovd_dV_DI_SI+d_Vovd_dV_DI_SI*Vovd)+(CGIDLD_i*CGIDLD_i)*(VdbPrime*d_VdbPrime_dV_DI_SI+d_VdbPrime_dV_DI_SI*VdbPrime))));
d_Vtovd_dV_GP_SI = (deriv_sqrt_0_d0*((Vovd*d_Vovd_dV_GP_SI+d_Vovd_dV_GP_SI*Vovd)));
Vtovd = value_sqrt_0;
}

d_temp_dV_SI_BP = (-(-BGIDLDs)*d_Vtovd_dV_SI_BP/Vtovd/Vtovd);
d_temp_dV_DI_SI = (-(-BGIDLDs)*d_Vtovd_dV_DI_SI/Vtovd/Vtovd);
d_temp_dV_GP_SI = (-(-BGIDLDs)*d_Vtovd_dV_GP_SI/Vtovd/Vtovd);
temp = ((-BGIDLDs)/Vtovd);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
d_temp2_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
d_temp2_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_SI_BP)*3.3333333333333333e-01+(-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_DI_SI)*3.3333333333333333e-01+(-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_SI)*3.3333333333333333e-01+(-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}

d_Igidl_dV_GP_SI = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_GP_SI+((VdbPrime*Vovd)*d_Vtovd_dV_GP_SI+VdbPrime*d_Vovd_dV_GP_SI*Vtovd)*temp2);
d_Igidl_dV_SI_BP = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_SI_BP+((VdbPrime*Vovd)*d_Vtovd_dV_SI_BP+d_VdbPrime_dV_SI_BP*Vovd*Vtovd)*temp2);
d_Igidl_dV_DI_SI = (-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dV_DI_SI+((VdbPrime*Vovd)*d_Vtovd_dV_DI_SI+(VdbPrime*d_Vovd_dV_DI_SI+d_VdbPrime_dV_DI_SI*Vovd)*Vtovd)*temp2);
Igidl = ((-AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
}
if (((AGIDL_i>0)&&(Vovs<0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+((CGIDL_i*CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vtovs_dV_SI_BP = (deriv_sqrt_0_d0*((CGIDL_i*CGIDL_i)*(VsbPrime*d_VsbPrime_dV_SI_BP+d_VsbPrime_dV_SI_BP*VsbPrime)));
d_Vtovs_dV_GP_SI = (deriv_sqrt_0_d0*((Vovs*d_Vovs_dV_GP_SI+d_Vovs_dV_GP_SI*Vovs)));
Vtovs = value_sqrt_0;
}

d_temp_dV_DI_SI =  0.0;
d_temp_dV_SI_BP = (-(-BGIDLs)*d_Vtovs_dV_SI_BP/Vtovs/Vtovs);
d_temp_dV_GP_SI = (-(-BGIDLs)*d_Vtovs_dV_GP_SI/Vtovs/Vtovs);
temp = ((-BGIDLs)/Vtovs);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;

d_temp2_dV_SI_BP = (deriv_exp_0_d0*(d_temp_dV_SI_BP));
d_temp2_dV_DI_SI = (deriv_exp_0_d0*(d_temp_dV_DI_SI));
d_temp2_dV_GP_SI = (deriv_exp_0_d0*(d_temp_dV_GP_SI));
temp2 = value_exp_0;
}
}
else
{

d_temp2_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_SI_BP)*3.3333333333333333e-01+(-d_temp_dV_SI_BP)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_SI_BP)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_DI_SI)*3.3333333333333333e-01+(-d_temp_dV_DI_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_DI_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
d_temp2_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dV_GP_SI)*3.3333333333333333e-01+(-d_temp_dV_GP_SI)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dV_GP_SI)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}

d_Igisl_dV_DI_SI = (-AGIDLs)*((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_DI_SI;
d_Igisl_dV_GP_SI = (-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_GP_SI+((VsbPrime*Vovs)*d_Vtovs_dV_GP_SI+VsbPrime*d_Vovs_dV_GP_SI*Vtovs)*temp2);
d_Igisl_dV_SI_BP = (-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dV_SI_BP+((VsbPrime*Vovs)*d_Vtovs_dV_SI_BP+d_VsbPrime_dV_SI_BP*Vovs*Vtovs)*temp2);
Igisl = ((-AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
}
}

d_xgedge_dV_DI_SI = d_xgedge_dV_SI_BP = d_xgedge_dV_GP_SI =  0.0;
xgedge = 0.0;

d_qdseffedge_dV_DI_SI = d_qdseffedge_dV_SI_BP = d_qdseffedge_dV_GP_SI =  0.0;
qdseffedge = 0.0;

d_qmeffedge_dV_DI_SI = d_qmeffedge_dV_SI_BP = d_qmeffedge_dV_GP_SI =  0.0;
qmeffedge = 0.0;

d_dsqredge_dV_DI_SI = d_dsqredge_dV_SI_BP = d_dsqredge_dV_GP_SI =  0.0;
dsqredge = 1.0e-40;

d_alphabmedge_dV_DI_SI = d_alphabmedge_dV_SI_BP = d_alphabmedge_dV_GP_SI =  0.0;
alphabmedge = 1.0;

d_Idsedge_dV_DI_SI = d_Idsedge_dV_SI_BP = d_Idsedge_dV_GP_SI =  0.0;
Idsedge = 0.0;
if ((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0)))
{
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphiedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_GP_SI =  0.0;
d_temp_dV_SI_BP = 0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)+(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))));
d_temp_dV_DI_SI = 0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)+(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))));
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phixedge);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+aphiedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vsbstaredge_dV_GP_SI = (-0.5*(d_temp_dV_GP_SI-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_GP_SI+d_temp_dV_GP_SI*(temp))))));
d_Vsbstaredge_dV_SI_BP = (d_Vsb_dV_SI_BP-0.5*(d_temp_dV_SI_BP-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_SI_BP+d_temp_dV_SI_BP*(temp))))));
d_Vsbstaredge_dV_DI_SI = (d_Vsb_dV_DI_SI-0.5*(d_temp_dV_DI_SI-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_DI_SI+d_temp_dV_DI_SI*(temp))))));
Vsbstaredge = ((Vsb-(0.5*(temp-value_sqrt_0)))+phix1edge);
}

d_Vsbxedge_dV_GP_SI = d_Vsbstaredge_dV_GP_SI;
d_Vsbxedge_dV_SI_BP = d_Vsbstaredge_dV_SI_BP;
d_Vsbxedge_dV_DI_SI = (d_Vsbstaredge_dV_DI_SI+0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI));
Vsbxedge = (Vsbstaredge+(0.5*(Vds-Vdsx)));

d_dphit1edge_dV_GP_SI = (PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*PSCEBEDGE_i*d_Vsbxedge_dV_GP_SI;
d_dphit1edge_dV_SI_BP = (PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*PSCEBEDGE_i*d_Vsbxedge_dV_SI_BP;
d_dphit1edge_dV_DI_SI = ((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*PSCEBEDGE_i*d_Vsbxedge_dV_DI_SI+PSCEEDGE_i*PSCEDEDGE_i*d_Vdsx_dV_DI_SI*(1.0+(PSCEBEDGE_i*Vsbxedge)));
dphit1edge = ((PSCEEDGE_i*(1+(PSCEDEDGE_i*Vdsx)))*(1.0+(PSCEBEDGE_i*Vsbxedge)));

d_phit1edge_dV_GP_SI = phit0edge*d_dphit1edge_dV_GP_SI;
d_phit1edge_dV_SI_BP = phit0edge*d_dphit1edge_dV_SI_BP;
d_phit1edge_dV_DI_SI = phit0edge*d_dphit1edge_dV_DI_SI;
phit1edge = (phit0edge*(1.0+dphit1edge));

d_inv_phit1edge_dV_GP_SI = (-d_phit1edge_dV_GP_SI/phit1edge/phit1edge);
d_inv_phit1edge_dV_SI_BP = (-d_phit1edge_dV_SI_BP/phit1edge/phit1edge);
d_inv_phit1edge_dV_DI_SI = (-d_phit1edge_dV_DI_SI/phit1edge/phit1edge);
inv_phit1edge = (1.0/phit1edge);
if ((CFDEDGE_i<0.05))
{

d_Vdspedge_dV_DI_SI = d_Vdsx_dV_DI_SI;
Vdspedge = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(CFDEDGE_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdspedge_dV_DI_SI = (2.0*(deriv_sqrt_0_d0*(CFDEDGE_i*d_Vdsx_dV_DI_SI))/CFDEDGE_i);
Vdspedge = ((2.0*(value_sqrt_0-1.0))/CFDEDGE_i);
}
}

d_delVgedge_dV_GP_SI = (CFEDGE_i*Vdspedge)*CFBEDGE_i*d_Vsbxedge_dV_GP_SI;
d_delVgedge_dV_SI_BP = (CFEDGE_i*Vdspedge)*CFBEDGE_i*d_Vsbxedge_dV_SI_BP;
d_delVgedge_dV_DI_SI = ((CFEDGE_i*Vdspedge)*CFBEDGE_i*d_Vsbxedge_dV_DI_SI+CFEDGE_i*d_Vdspedge_dV_DI_SI*(1+(CFBEDGE_i*Vsbxedge)));
delVgedge = ((CFEDGE_i*Vdspedge)*(1+(CFBEDGE_i*Vsbxedge)));

d_xgedge_dV_GP_SI = (inv_phit1edge*((d_Vgs_dV_GP_SI+d_Vsbstaredge_dV_GP_SI)+d_delVgedge_dV_GP_SI)+d_inv_phit1edge_dV_GP_SI*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T));
d_xgedge_dV_SI_BP = (inv_phit1edge*(d_Vsbstaredge_dV_SI_BP+d_delVgedge_dV_SI_BP)+d_inv_phit1edge_dV_SI_BP*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T));
d_xgedge_dV_DI_SI = (inv_phit1edge*((d_Vgs_dV_DI_SI+d_Vsbstaredge_dV_DI_SI)+d_delVgedge_dV_DI_SI)+d_inv_phit1edge_dV_DI_SI*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T));
xgedge = (inv_phit1edge*(((Vgs+Vsbstaredge)+delVgedge)-VFBEDGE_T));

d_xbedge_dV_GP_SI = d_inv_phit1edge_dV_GP_SI*phibedge;
d_xbedge_dV_SI_BP = d_inv_phit1edge_dV_SI_BP*phibedge;
d_xbedge_dV_DI_SI = d_inv_phit1edge_dV_DI_SI*phibedge;
xbedge = (inv_phit1edge*phibedge);
{
double value_sqrt_0 = sqrt(xbedge);
double value_log_1 = log(((xbedge/Gfedge)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((xbedge/Gfedge)+value_sqrt_0));

d_dxthedge_dV_GP_SI = 2.0*(deriv_log_1_d0*(((d_xbedge_dV_GP_SI/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_GP_SI)))));
d_dxthedge_dV_SI_BP = 2.0*(deriv_log_1_d0*(((d_xbedge_dV_SI_BP/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_SI_BP)))));
d_dxthedge_dV_DI_SI = 2.0*(deriv_log_1_d0*(((d_xbedge_dV_DI_SI/Gfedge)+(deriv_sqrt_0_d0*(d_xbedge_dV_DI_SI)))));
dxthedge = (2.0*value_log_1);
}

d_xnedge_s_dV_GP_SI = (inv_phit1edge*d_Vsbstaredge_dV_GP_SI+d_inv_phit1edge_dV_GP_SI*Vsbstaredge);
d_xnedge_s_dV_SI_BP = (inv_phit1edge*d_Vsbstaredge_dV_SI_BP+d_inv_phit1edge_dV_SI_BP*Vsbstaredge);
d_xnedge_s_dV_DI_SI = (inv_phit1edge*d_Vsbstaredge_dV_DI_SI+d_inv_phit1edge_dV_DI_SI*Vsbstaredge);
xnedge_s = (inv_phit1edge*Vsbstaredge);

d_Q_EDGE_xsth_dV_GP_SI = (d_xbedge_dV_GP_SI+d_xnedge_s_dV_GP_SI);
d_Q_EDGE_xsth_dV_SI_BP = (d_xbedge_dV_SI_BP+d_xnedge_s_dV_SI_BP);
d_Q_EDGE_xsth_dV_DI_SI = (d_xbedge_dV_DI_SI+d_xnedge_s_dV_DI_SI);
Q_EDGE_xsth = (xbedge+xnedge_s);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_xth0_dV_GP_SI = (d_Q_EDGE_xsth_dV_GP_SI+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI)));
d_Q_EDGE_xth0_dV_SI_BP = (d_Q_EDGE_xsth_dV_SI_BP+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP)));
d_Q_EDGE_xth0_dV_DI_SI = (d_Q_EDGE_xsth_dV_DI_SI+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI)));
Q_EDGE_xth0 = (Q_EDGE_xsth+(Gfedge*value_sqrt_0));
}

d_Q_EDGE_xth_dV_GP_SI = (d_Q_EDGE_xth0_dV_GP_SI+d_dxthedge_dV_GP_SI);
d_Q_EDGE_xth_dV_SI_BP = (d_Q_EDGE_xth0_dV_SI_BP+d_dxthedge_dV_SI_BP);
d_Q_EDGE_xth_dV_DI_SI = (d_Q_EDGE_xth0_dV_DI_SI+d_dxthedge_dV_DI_SI);
Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_n_dV_GP_SI = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_Q_EDGE_n_dV_SI_BP = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_Q_EDGE_n_dV_DI_SI = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
Q_EDGE_n = (1.0+(Gfedge/(2.0*value_sqrt_0)));
}

d_Q_EDGE_n_inv_dV_GP_SI = (-d_Q_EDGE_n_dV_GP_SI/Q_EDGE_n/Q_EDGE_n);
d_Q_EDGE_n_inv_dV_SI_BP = (-d_Q_EDGE_n_dV_SI_BP/Q_EDGE_n/Q_EDGE_n);
d_Q_EDGE_n_inv_dV_DI_SI = (-d_Q_EDGE_n_dV_DI_SI/Q_EDGE_n/Q_EDGE_n);
Q_EDGE_n_inv = (1.0/Q_EDGE_n);

d_Q_EDGE_xgt_dV_GP_SI = (d_xgedge_dV_GP_SI-d_Q_EDGE_xth_dV_GP_SI);
d_Q_EDGE_xgt_dV_SI_BP = (d_xgedge_dV_SI_BP-d_Q_EDGE_xth_dV_SI_BP);
d_Q_EDGE_xgt_dV_DI_SI = (d_xgedge_dV_DI_SI-d_Q_EDGE_xth_dV_DI_SI);
Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
if ((Q_EDGE_xgt>(-12.0)))
{

d_Q_EDGE_xgt0_dV_GP_SI = d_Q_EDGE_xgt_dV_GP_SI;
d_Q_EDGE_xgt0_dV_SI_BP = d_Q_EDGE_xgt_dV_SI_BP;
d_Q_EDGE_xgt0_dV_DI_SI = d_Q_EDGE_xgt_dV_DI_SI;
Q_EDGE_xgt0 = ((Q_EDGE_xgt+lnGfedge2)-1.0);
{
double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_xgt0e_dV_GP_SI = 0.5*(d_Q_EDGE_xgt0_dV_GP_SI+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_GP_SI+d_Q_EDGE_xgt0_dV_GP_SI*Q_EDGE_xgt0))));
d_Q_EDGE_xgt0e_dV_SI_BP = 0.5*(d_Q_EDGE_xgt0_dV_SI_BP+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_SI_BP+d_Q_EDGE_xgt0_dV_SI_BP*Q_EDGE_xgt0))));
d_Q_EDGE_xgt0e_dV_DI_SI = 0.5*(d_Q_EDGE_xgt0_dV_DI_SI+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_DI_SI+d_Q_EDGE_xgt0_dV_DI_SI*Q_EDGE_xgt0))));
Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
}
{
double value_log_0 = log(Q_EDGE_xgt0e);
double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);

d_Q_EDGE_qi0si_dV_GP_SI = (d_Q_EDGE_xgt_dV_GP_SI-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_GP_SI))+d_Q_EDGE_n_dV_GP_SI*value_log_0));
d_Q_EDGE_qi0si_dV_SI_BP = (d_Q_EDGE_xgt_dV_SI_BP-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_SI_BP))+d_Q_EDGE_n_dV_SI_BP*value_log_0));
d_Q_EDGE_qi0si_dV_DI_SI = (d_Q_EDGE_xgt_dV_DI_SI-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_DI_SI))+d_Q_EDGE_n_dV_DI_SI*value_log_0));
Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+lnGfedge2);
}
{
double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_qi0_dV_GP_SI = 0.5*(d_Q_EDGE_qi0si_dV_GP_SI+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_GP_SI+d_Q_EDGE_qi0si_dV_GP_SI*Q_EDGE_qi0si))));
d_Q_EDGE_qi0_dV_SI_BP = 0.5*(d_Q_EDGE_qi0si_dV_SI_BP+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_SI_BP+d_Q_EDGE_qi0si_dV_SI_BP*Q_EDGE_qi0si))));
d_Q_EDGE_qi0_dV_DI_SI = 0.5*(d_Q_EDGE_qi0si_dV_DI_SI+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_DI_SI+d_Q_EDGE_qi0si_dV_DI_SI*Q_EDGE_qi0si))));
Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
}
if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
double  deriv_exp_0_d0 = value_exp_0;

d_Q_EDGE_exp_x_dV_GP_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)));
d_Q_EDGE_exp_x_dV_SI_BP = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)));
d_Q_EDGE_exp_x_dV_DI_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)));
Q_EDGE_exp_x = value_exp_0;
}
}
else
{

d_Q_EDGE_exp_x_dV_GP_SI = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Q_EDGE_exp_x_dV_SI_BP = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Q_EDGE_exp_x_dV_DI_SI = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}

d_Q_EDGE_d0_dV_GP_SI = Gfedge2*d_Q_EDGE_exp_x_dV_GP_SI;
d_Q_EDGE_d0_dV_SI_BP = Gfedge2*d_Q_EDGE_exp_x_dV_SI_BP;
d_Q_EDGE_d0_dV_DI_SI = Gfedge2*d_Q_EDGE_exp_x_dV_DI_SI;
Q_EDGE_d0 = (Gfedge2*Q_EDGE_exp_x);
{
double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);

d_Q_EDGE_d0p_dV_GP_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_GP_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_GP_SI)));
d_Q_EDGE_d0p_dV_SI_BP = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_SI_BP))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_SI_BP)));
d_Q_EDGE_d0p_dV_DI_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_DI_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_DI_SI)));
Q_EDGE_d0p = value_pow_0;
}

d_Q_EDGE_sqerr_dV_GP_SI = ((Q_EDGE_n*d_Q_EDGE_n_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_GP_SI+(2.0*(d_Q_EDGE_qi0_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI)-d_Q_EDGE_d0p_dV_GP_SI)*Q_EDGE_d0p));
d_Q_EDGE_sqerr_dV_SI_BP = ((Q_EDGE_n*d_Q_EDGE_n_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_SI_BP+(2.0*(d_Q_EDGE_qi0_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP)-d_Q_EDGE_d0p_dV_SI_BP)*Q_EDGE_d0p));
d_Q_EDGE_sqerr_dV_DI_SI = ((Q_EDGE_n*d_Q_EDGE_n_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_DI_SI+(2.0*(d_Q_EDGE_qi0_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI)-d_Q_EDGE_d0p_dV_DI_SI)*Q_EDGE_d0p));
Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
{
double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_errq_dV_GP_SI = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_GP_SI))-d_Q_EDGE_n_dV_GP_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_GP_SI)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_GP_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
d_Q_EDGE_errq_dV_SI_BP = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_SI_BP))-d_Q_EDGE_n_dV_SI_BP)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_SI_BP)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_SI_BP*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
d_Q_EDGE_errq_dV_DI_SI = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_DI_SI))-d_Q_EDGE_n_dV_DI_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_DI_SI)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_DI_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
}

d_qseffedge_dV_GP_SI = (d_Q_EDGE_qi0_dV_GP_SI-d_Q_EDGE_errq_dV_GP_SI);
d_qseffedge_dV_SI_BP = (d_Q_EDGE_qi0_dV_SI_BP-d_Q_EDGE_errq_dV_SI_BP);
d_qseffedge_dV_DI_SI = (d_Q_EDGE_qi0_dV_DI_SI-d_Q_EDGE_errq_dV_DI_SI);
qseffedge = (Q_EDGE_qi0-Q_EDGE_errq);
}
else
{
if (((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2))>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)));
double  deriv_exp_0_d0 = value_exp_0;

d_qseffedge_dV_GP_SI = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))));
d_qseffedge_dV_SI_BP = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))));
d_qseffedge_dV_DI_SI = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))));
qseffedge = value_exp_0;
}
}
else
{

d_qseffedge_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
d_qseffedge_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
d_qseffedge_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
qseffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
}
}

d_xnedge_d_dV_GP_SI = (inv_phit1edge*(d_Vdse_dc_dV_GP_SI+d_Vsbstaredge_dV_GP_SI)+d_inv_phit1edge_dV_GP_SI*(Vdse_dc+Vsbstaredge));
d_xnedge_d_dV_SI_BP = (inv_phit1edge*(d_Vdse_dc_dV_SI_BP+d_Vsbstaredge_dV_SI_BP)+d_inv_phit1edge_dV_SI_BP*(Vdse_dc+Vsbstaredge));
d_xnedge_d_dV_DI_SI = (inv_phit1edge*(d_Vdse_dc_dV_DI_SI+d_Vsbstaredge_dV_DI_SI)+d_inv_phit1edge_dV_DI_SI*(Vdse_dc+Vsbstaredge));
xnedge_d = (inv_phit1edge*(Vdse_dc+Vsbstaredge));
if (((qseffedge<1.0e-3)&(Vdse_dc<1.0e-6)))
{
if ((((-xnedge_d)+xnedge_s)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-xnedge_d)+xnedge_s));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_GP_SI = (deriv_exp_0_d0*(((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI)));
d_temp_dV_SI_BP = (deriv_exp_0_d0*(((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP)));
d_temp_dV_DI_SI = (deriv_exp_0_d0*(((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI)));
temp = value_exp_0;
}
}
else
{

d_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*3.3333333333333333e-01+(-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))+(-((-d_xnedge_d_dV_GP_SI)+d_xnedge_s_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
d_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*3.3333333333333333e-01+(-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))+(-((-d_xnedge_d_dV_SI_BP)+d_xnedge_s_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*3.3333333333333333e-01+(-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))+(-((-d_xnedge_d_dV_DI_SI)+d_xnedge_s_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
}

d_qdseffedge_dV_GP_SI = (qseffedge*d_temp_dV_GP_SI+d_qseffedge_dV_GP_SI*(temp-1.0));
d_qdseffedge_dV_SI_BP = (qseffedge*d_temp_dV_SI_BP+d_qseffedge_dV_SI_BP*(temp-1.0));
d_qdseffedge_dV_DI_SI = (qseffedge*d_temp_dV_DI_SI+d_qseffedge_dV_DI_SI*(temp-1.0));
qdseffedge = (qseffedge*(temp-1.0));

d_qdeffedge_dV_GP_SI = (d_qdseffedge_dV_GP_SI+d_qseffedge_dV_GP_SI);
d_qdeffedge_dV_SI_BP = (d_qdseffedge_dV_SI_BP+d_qseffedge_dV_SI_BP);
d_qdeffedge_dV_DI_SI = (d_qdseffedge_dV_DI_SI+d_qseffedge_dV_DI_SI);
qdeffedge = (qdseffedge+qseffedge);
}
else
{

d_Q_EDGE_xsth_dV_GP_SI = (d_xbedge_dV_GP_SI+d_xnedge_d_dV_GP_SI);
d_Q_EDGE_xsth_dV_SI_BP = (d_xbedge_dV_SI_BP+d_xnedge_d_dV_SI_BP);
d_Q_EDGE_xsth_dV_DI_SI = (d_xbedge_dV_DI_SI+d_xnedge_d_dV_DI_SI);
Q_EDGE_xsth = (xbedge+xnedge_d);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_xth0_dV_GP_SI = (d_Q_EDGE_xsth_dV_GP_SI+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI)));
d_Q_EDGE_xth0_dV_SI_BP = (d_Q_EDGE_xsth_dV_SI_BP+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP)));
d_Q_EDGE_xth0_dV_DI_SI = (d_Q_EDGE_xsth_dV_DI_SI+Gfedge*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI)));
Q_EDGE_xth0 = (Q_EDGE_xsth+(Gfedge*value_sqrt_0));
}

d_Q_EDGE_xth_dV_GP_SI = (d_Q_EDGE_xth0_dV_GP_SI+d_dxthedge_dV_GP_SI);
d_Q_EDGE_xth_dV_SI_BP = (d_Q_EDGE_xth0_dV_SI_BP+d_dxthedge_dV_SI_BP);
d_Q_EDGE_xth_dV_DI_SI = (d_Q_EDGE_xth0_dV_DI_SI+d_dxthedge_dV_DI_SI);
Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_n_dV_GP_SI = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_GP_SI))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_Q_EDGE_n_dV_SI_BP = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_SI_BP))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
d_Q_EDGE_n_dV_DI_SI = (-Gfedge*2.0*(deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dV_DI_SI))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
Q_EDGE_n = (1.0+(Gfedge/(2.0*value_sqrt_0)));
}

d_Q_EDGE_n_inv_dV_GP_SI = (-d_Q_EDGE_n_dV_GP_SI/Q_EDGE_n/Q_EDGE_n);
d_Q_EDGE_n_inv_dV_SI_BP = (-d_Q_EDGE_n_dV_SI_BP/Q_EDGE_n/Q_EDGE_n);
d_Q_EDGE_n_inv_dV_DI_SI = (-d_Q_EDGE_n_dV_DI_SI/Q_EDGE_n/Q_EDGE_n);
Q_EDGE_n_inv = (1.0/Q_EDGE_n);

d_Q_EDGE_xgt_dV_GP_SI = (d_xgedge_dV_GP_SI-d_Q_EDGE_xth_dV_GP_SI);
d_Q_EDGE_xgt_dV_SI_BP = (d_xgedge_dV_SI_BP-d_Q_EDGE_xth_dV_SI_BP);
d_Q_EDGE_xgt_dV_DI_SI = (d_xgedge_dV_DI_SI-d_Q_EDGE_xth_dV_DI_SI);
Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
if ((Q_EDGE_xgt>(-12.0)))
{

d_Q_EDGE_xgt0_dV_GP_SI = d_Q_EDGE_xgt_dV_GP_SI;
d_Q_EDGE_xgt0_dV_SI_BP = d_Q_EDGE_xgt_dV_SI_BP;
d_Q_EDGE_xgt0_dV_DI_SI = d_Q_EDGE_xgt_dV_DI_SI;
Q_EDGE_xgt0 = ((Q_EDGE_xgt+lnGfedge2)-1.0);
{
double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_xgt0e_dV_GP_SI = 0.5*(d_Q_EDGE_xgt0_dV_GP_SI+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_GP_SI+d_Q_EDGE_xgt0_dV_GP_SI*Q_EDGE_xgt0))));
d_Q_EDGE_xgt0e_dV_SI_BP = 0.5*(d_Q_EDGE_xgt0_dV_SI_BP+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_SI_BP+d_Q_EDGE_xgt0_dV_SI_BP*Q_EDGE_xgt0))));
d_Q_EDGE_xgt0e_dV_DI_SI = 0.5*(d_Q_EDGE_xgt0_dV_DI_SI+(deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dV_DI_SI+d_Q_EDGE_xgt0_dV_DI_SI*Q_EDGE_xgt0))));
Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
}
{
double value_log_0 = log(Q_EDGE_xgt0e);
double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);

d_Q_EDGE_qi0si_dV_GP_SI = (d_Q_EDGE_xgt_dV_GP_SI-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_GP_SI))+d_Q_EDGE_n_dV_GP_SI*value_log_0));
d_Q_EDGE_qi0si_dV_SI_BP = (d_Q_EDGE_xgt_dV_SI_BP-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_SI_BP))+d_Q_EDGE_n_dV_SI_BP*value_log_0));
d_Q_EDGE_qi0si_dV_DI_SI = (d_Q_EDGE_xgt_dV_DI_SI-(Q_EDGE_n*(deriv_log_0_d0*(d_Q_EDGE_xgt0e_dV_DI_SI))+d_Q_EDGE_n_dV_DI_SI*value_log_0));
Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+lnGfedge2);
}
{
double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_qi0_dV_GP_SI = 0.5*(d_Q_EDGE_qi0si_dV_GP_SI+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_GP_SI+d_Q_EDGE_qi0si_dV_GP_SI*Q_EDGE_qi0si))));
d_Q_EDGE_qi0_dV_SI_BP = 0.5*(d_Q_EDGE_qi0si_dV_SI_BP+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_SI_BP+d_Q_EDGE_qi0si_dV_SI_BP*Q_EDGE_qi0si))));
d_Q_EDGE_qi0_dV_DI_SI = 0.5*(d_Q_EDGE_qi0si_dV_DI_SI+(deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dV_DI_SI+d_Q_EDGE_qi0si_dV_DI_SI*Q_EDGE_qi0si))));
Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
}
if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
double  deriv_exp_0_d0 = value_exp_0;

d_Q_EDGE_exp_x_dV_GP_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)));
d_Q_EDGE_exp_x_dV_SI_BP = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)));
d_Q_EDGE_exp_x_dV_DI_SI = (deriv_exp_0_d0*((d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)));
Q_EDGE_exp_x = value_exp_0;
}
}
else
{

d_Q_EDGE_exp_x_dV_GP_SI = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_GP_SI-d_Q_EDGE_qi0_dV_GP_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Q_EDGE_exp_x_dV_SI_BP = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_SI_BP-d_Q_EDGE_qi0_dV_SI_BP)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_Q_EDGE_exp_x_dV_DI_SI = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dV_DI_SI-d_Q_EDGE_qi0_dV_DI_SI)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}

d_Q_EDGE_d0_dV_GP_SI = Gfedge2*d_Q_EDGE_exp_x_dV_GP_SI;
d_Q_EDGE_d0_dV_SI_BP = Gfedge2*d_Q_EDGE_exp_x_dV_SI_BP;
d_Q_EDGE_d0_dV_DI_SI = Gfedge2*d_Q_EDGE_exp_x_dV_DI_SI;
Q_EDGE_d0 = (Gfedge2*Q_EDGE_exp_x);
{
double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);

d_Q_EDGE_d0p_dV_GP_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_GP_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_GP_SI)));
d_Q_EDGE_d0p_dV_SI_BP = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_SI_BP))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_SI_BP)));
d_Q_EDGE_d0p_dV_DI_SI = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dV_DI_SI))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dV_DI_SI)));
Q_EDGE_d0p = value_pow_0;
}

d_Q_EDGE_sqerr_dV_GP_SI = ((Q_EDGE_n*d_Q_EDGE_n_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_GP_SI+(2.0*(d_Q_EDGE_qi0_dV_GP_SI+d_Q_EDGE_n_dV_GP_SI)-d_Q_EDGE_d0p_dV_GP_SI)*Q_EDGE_d0p));
d_Q_EDGE_sqerr_dV_SI_BP = ((Q_EDGE_n*d_Q_EDGE_n_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_SI_BP+(2.0*(d_Q_EDGE_qi0_dV_SI_BP+d_Q_EDGE_n_dV_SI_BP)-d_Q_EDGE_d0p_dV_SI_BP)*Q_EDGE_d0p));
d_Q_EDGE_sqerr_dV_DI_SI = ((Q_EDGE_n*d_Q_EDGE_n_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dV_DI_SI+(2.0*(d_Q_EDGE_qi0_dV_DI_SI+d_Q_EDGE_n_dV_DI_SI)-d_Q_EDGE_d0p_dV_DI_SI)*Q_EDGE_d0p));
Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
{
double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Q_EDGE_errq_dV_GP_SI = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_GP_SI))-d_Q_EDGE_n_dV_GP_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_GP_SI)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_GP_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
d_Q_EDGE_errq_dV_SI_BP = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_SI_BP))-d_Q_EDGE_n_dV_SI_BP)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_SI_BP)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_SI_BP*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
d_Q_EDGE_errq_dV_DI_SI = (Q_EDGE_n*((Q_EDGE_d0p*((deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dV_DI_SI))-d_Q_EDGE_n_dV_DI_SI)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dV_DI_SI)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dV_DI_SI*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
}

d_qdeffedge_dV_GP_SI = (d_Q_EDGE_qi0_dV_GP_SI-d_Q_EDGE_errq_dV_GP_SI);
d_qdeffedge_dV_SI_BP = (d_Q_EDGE_qi0_dV_SI_BP-d_Q_EDGE_errq_dV_SI_BP);
d_qdeffedge_dV_DI_SI = (d_Q_EDGE_qi0_dV_DI_SI-d_Q_EDGE_errq_dV_DI_SI);
qdeffedge = (Q_EDGE_qi0-Q_EDGE_errq);
}
else
{
if (((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2))>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)));
double  deriv_exp_0_d0 = value_exp_0;

d_qdeffedge_dV_GP_SI = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2))));
d_qdeffedge_dV_SI_BP = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2))));
d_qdeffedge_dV_DI_SI = (deriv_exp_0_d0*((Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2))));
qdeffedge = value_exp_0;
}
}
else
{

d_qdeffedge_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_GP_SI+d_Q_EDGE_n_inv_dV_GP_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
d_qdeffedge_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_SI_BP+d_Q_EDGE_n_inv_dV_SI_BP*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
d_qdeffedge_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*d_Q_EDGE_xgt_dV_DI_SI+d_Q_EDGE_n_inv_dV_DI_SI*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
qdeffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+lnGfedge2)))*3.3333333333333333e-01))))))));
}
}

d_qdseffedge_dV_GP_SI = (d_qdeffedge_dV_GP_SI-d_qseffedge_dV_GP_SI);
d_qdseffedge_dV_SI_BP = (d_qdeffedge_dV_SI_BP-d_qseffedge_dV_SI_BP);
d_qdseffedge_dV_DI_SI = (d_qdeffedge_dV_DI_SI-d_qseffedge_dV_DI_SI);
qdseffedge = (qdeffedge-qseffedge);
}

d_qmeffedge_dV_GP_SI = 0.5*(d_qdeffedge_dV_GP_SI+d_qseffedge_dV_GP_SI);
d_qmeffedge_dV_SI_BP = 0.5*(d_qdeffedge_dV_SI_BP+d_qseffedge_dV_SI_BP);
d_qmeffedge_dV_DI_SI = 0.5*(d_qdeffedge_dV_DI_SI+d_qseffedge_dV_DI_SI);
qmeffedge = (0.5*(qdeffedge+qseffedge));
{
double value_max_0 = std::max((xgedge-qmeffedge),static_cast<double>(1.0e-40));
double  deriv_max_0_d0 = (((xgedge-qmeffedge)>=1.0e-40)?1.0:0.0);

d_dsqredge_dV_GP_SI = (deriv_max_0_d0*((d_xgedge_dV_GP_SI-d_qmeffedge_dV_GP_SI)));
d_dsqredge_dV_SI_BP = (deriv_max_0_d0*((d_xgedge_dV_SI_BP-d_qmeffedge_dV_SI_BP)));
d_dsqredge_dV_DI_SI = (deriv_max_0_d0*((d_xgedge_dV_DI_SI-d_qmeffedge_dV_DI_SI)));
dsqredge = value_max_0;
}
{
double value_sqrt_0 = sqrt((dsqredge+(0.25*Gfedge2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_alphabmedge_dV_GP_SI = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_GP_SI))/value_sqrt_0/value_sqrt_0));
d_alphabmedge_dV_SI_BP = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_SI_BP))/value_sqrt_0/value_sqrt_0));
d_alphabmedge_dV_DI_SI = (-(-(0.5*Gfedge)*(deriv_sqrt_0_d0*(d_dsqredge_dV_DI_SI))/value_sqrt_0/value_sqrt_0));
alphabmedge = (1.0-((0.5*Gfedge)/value_sqrt_0));
}

d_Idsedge_dV_GP_SI = ((Gmob_dc*(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_GP_SI+((((-BETEDGE_i)*phit1edge)*phit1edge)*(alphabmedge*d_qmeffedge_dV_GP_SI+d_alphabmedge_dV_GP_SI*qmeffedge)+(((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_GP_SI+(-BETEDGE_i)*d_phit1edge_dV_GP_SI*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_GP_SI)/Gmob_dc/Gmob_dc);
d_Idsedge_dV_SI_BP = ((Gmob_dc*(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_SI_BP+((((-BETEDGE_i)*phit1edge)*phit1edge)*(alphabmedge*d_qmeffedge_dV_SI_BP+d_alphabmedge_dV_SI_BP*qmeffedge)+(((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_SI_BP+(-BETEDGE_i)*d_phit1edge_dV_SI_BP*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_SI_BP)/Gmob_dc/Gmob_dc);
d_Idsedge_dV_DI_SI = ((Gmob_dc*(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dV_DI_SI+((((-BETEDGE_i)*phit1edge)*phit1edge)*(alphabmedge*d_qmeffedge_dV_DI_SI+d_alphabmedge_dV_DI_SI*qmeffedge)+(((-BETEDGE_i)*phit1edge)*d_phit1edge_dV_DI_SI+(-BETEDGE_i)*d_phit1edge_dV_DI_SI*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)-(((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dV_DI_SI)/Gmob_dc/Gmob_dc);
Idsedge = ((((((-BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)/Gmob_dc);
}
if (((xg_dc>0)&&((model_.SWIMPACT_i)!=0)))
{

d_delVsat_dV_SI_BP = (-A3_i*d_dps_dc_dV_SI_BP);
d_delVsat_dV_GP_SI = (-A3_i*d_dps_dc_dV_GP_SI);
d_delVsat_dV_DI_SI = (d_Vds_dV_DI_SI-A3_i*d_dps_dc_dV_DI_SI);
delVsat = (Vds-(A3_i*dps_dc));
if ((delVsat>0))
{
{
double value_sqrt_0 = sqrt((phib_dc+Vsbstar_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp2_dV_GP_SI = A2_T*(-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_GP_SI/(delVsat+1.0e-30)/(delVsat+1.0e-30));
d_temp2_dV_SI_BP = A2_T*(((delVsat+1.0e-30)*A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dc_dV_SI_BP))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_SI_BP)/(delVsat+1.0e-30)/(delVsat+1.0e-30));
d_temp2_dV_DI_SI = A2_T*(((delVsat+1.0e-30)*A4_i*(deriv_sqrt_0_d0*(d_Vsbstar_dc_dV_DI_SI))-(1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))*d_delVsat_dV_DI_SI)/(delVsat+1.0e-30)/(delVsat+1.0e-30));
temp2 = (A2_T*((1.0+(A4_i*(value_sqrt_0-sqrt_phib_dc)))/(delVsat+1.0e-30)));
}
if ((fabs((-temp2))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-temp2));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_temp2_dV_SI_BP)));
d_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_temp2_dV_GP_SI)));
d_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_temp2_dV_DI_SI)));
temp = value_exp_0;
}
}
else
{
if (((-temp2)<0.0))
{

d_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_SI_BP))*3.3333333333333333e-01+(-(-d_temp2_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
d_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_GP_SI))*3.3333333333333333e-01+(-(-d_temp2_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dV_DI_SI))*3.3333333333333333e-01+(-(-d_temp2_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
}
else
{

d_temp_dV_SI_BP = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_SI_BP)*3.3333333333333333e-01+(-d_temp2_dV_SI_BP)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_SI_BP)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_GP_SI = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_GP_SI)*3.3333333333333333e-01+(-d_temp2_dV_GP_SI)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_GP_SI)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_temp_dV_DI_SI = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dV_DI_SI)*3.3333333333333333e-01+(-d_temp2_dV_DI_SI)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dV_DI_SI)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_mavl_dV_SI_BP = A1_i*(delVsat*d_temp_dV_SI_BP+d_delVsat_dV_SI_BP*temp);
d_mavl_dV_GP_SI = A1_i*(delVsat*d_temp_dV_GP_SI+d_delVsat_dV_GP_SI*temp);
d_mavl_dV_DI_SI = A1_i*(delVsat*d_temp_dV_DI_SI+d_delVsat_dV_DI_SI*temp);
mavl = (A1_i*(delVsat*temp));

d_Iimpact_dV_SI_BP = (mavl*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP)+d_mavl_dV_SI_BP*(Ids+Idsedge));
d_Iimpact_dV_GP_SI = (mavl*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI)+d_mavl_dV_GP_SI*(Ids+Idsedge));
d_Iimpact_dV_DI_SI = (mavl*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI)+d_mavl_dV_DI_SI*(Ids+Idsedge));
Iimpact = (mavl*(Ids+Idsedge));
}
}
P_D = (1.0+(0.25*(Gf_dc*kp)));
facvsb0 = (phib_dc+(2.0*phit1));
facvsb = (Vsbstar_dc+facvsb0);
{
double value_sqrt_0 = sqrt((phit1*facvsb));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vts_i = (((VFB_T+(P_D*facvsb))-Vsbstar_dc)+(Gf_dc*value_sqrt_0));
}
vth_i = (vts_i-delVg);
}
// End block evaluateStatic
//Begin block evaluateDynamic
{
//Begin block SPcalc_ac
{
//Block-local variables for block SPcalc_ac
double phib=0.0;
double G_0=0.0;
double Vsbstar=0.0;
     double d_Vsbstar_dV_DI_SI=0.0;
     double d_Vsbstar_dV_SI_BP=0.0;
     double d_Vsbstar_dV_GP_SI=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double Vsbx=0.0;
     double d_Vsbx_dV_DI_SI=0.0;
     double d_Vsbx_dV_SI_BP=0.0;
     double d_Vsbx_dV_GP_SI=0.0;
double xg=0.0;
     double d_xg_dV_DI_SI=0.0;
     double d_xg_dV_GP_SI=0.0;
     double d_xg_dV_SI_BP=0.0;
double Dnsub=0.0;
     double d_Dnsub_dV_DI_SI=0.0;
     double d_Dnsub_dV_GP_SI=0.0;
     double d_Dnsub_dV_SI_BP=0.0;
double Gf=0.0;
     double d_Gf_dV_DI_SI=0.0;
     double d_Gf_dV_GP_SI=0.0;
     double d_Gf_dV_SI_BP=0.0;
double Gf2=0.0;
     double d_Gf2_dV_DI_SI=0.0;
     double d_Gf2_dV_GP_SI=0.0;
     double d_Gf2_dV_SI_BP=0.0;
double inv_Gf2=0.0;
     double d_inv_Gf2_dV_DI_SI=0.0;
     double d_inv_Gf2_dV_GP_SI=0.0;
     double d_inv_Gf2_dV_SI_BP=0.0;
double xi=0.0;
     double d_xi_dV_DI_SI=0.0;
     double d_xi_dV_GP_SI=0.0;
     double d_xi_dV_SI_BP=0.0;
double inv_xi=0.0;
     double d_inv_xi_dV_DI_SI=0.0;
     double d_inv_xi_dV_GP_SI=0.0;
     double d_inv_xi_dV_SI_BP=0.0;
double Ux=0.0;
     double d_Ux_dV_DI_SI=0.0;
     double d_Ux_dV_SI_BP=0.0;
     double d_Ux_dV_GP_SI=0.0;
double xn_s=0.0;
     double d_xn_s_dV_GP_SI=0.0;
     double d_xn_s_dV_DI_SI=0.0;
     double d_xn_s_dV_SI_BP=0.0;
double delta_ns=0.0;
     double d_delta_ns_dV_GP_SI=0.0;
     double d_delta_ns_dV_DI_SI=0.0;
     double d_delta_ns_dV_SI_BP=0.0;
double margin=0.0;
     double d_margin_dV_DI_SI=0.0;
     double d_margin_dV_GP_SI=0.0;
     double d_margin_dV_SI_BP=0.0;
double x_s=0.0;
     double d_x_s_dV_DI_SI=0.0;
     double d_x_s_dV_GP_SI=0.0;
     double d_x_s_dV_SI_BP=0.0;
double delta_1s=0.0;
     double d_delta_1s_dV_DI_SI=0.0;
     double d_delta_1s_dV_GP_SI=0.0;
     double d_delta_1s_dV_SI_BP=0.0;
double xi0s=0.0;
     double d_xi0s_dV_DI_SI=0.0;
     double d_xi0s_dV_GP_SI=0.0;
     double d_xi0s_dV_SI_BP=0.0;
double xi1s=0.0;
     double d_xi1s_dV_DI_SI=0.0;
     double d_xi1s_dV_GP_SI=0.0;
     double d_xi1s_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double xi2s=0.0;
     double d_xi2s_dV_GP_SI=0.0;
     double d_xi2s_dV_DI_SI=0.0;
     double d_xi2s_dV_SI_BP=0.0;
double Es=0.0;
     double d_Es_dV_DI_SI=0.0;
     double d_Es_dV_GP_SI=0.0;
     double d_Es_dV_SI_BP=0.0;
double Ds=0.0;
     double d_Ds_dV_DI_SI=0.0;
     double d_Ds_dV_GP_SI=0.0;
     double d_Ds_dV_SI_BP=0.0;
double Ps=0.0;
     double d_Ps_dV_DI_SI=0.0;
     double d_Ps_dV_GP_SI=0.0;
     double d_Ps_dV_SI_BP=0.0;
double Rxcor=0.0;
     double d_Rxcor_dV_DI_SI=0.0;
     double d_Rxcor_dV_SI_BP=0.0;
     double d_Rxcor_dV_GP_SI=0.0;
double xgs=0.0;
     double d_xgs_dV_DI_SI=0.0;
     double d_xgs_dV_GP_SI=0.0;
     double d_xgs_dV_SI_BP=0.0;
double qis=0.0;
     double d_qis_dV_DI_SI=0.0;
     double d_qis_dV_GP_SI=0.0;
     double d_qis_dV_SI_BP=0.0;
double qbs=0.0;
     double d_qbs_dV_DI_SI=0.0;
     double d_qbs_dV_GP_SI=0.0;
     double d_qbs_dV_SI_BP=0.0;
double rhob=0.0;
     double d_rhob_dV_DI_SI=0.0;
     double d_rhob_dV_SI_BP=0.0;
     double d_rhob_dV_GP_SI=0.0;
double GR=0.0;
     double d_GR_dV_DI_SI=0.0;
     double d_GR_dV_SI_BP=0.0;
     double d_GR_dV_GP_SI=0.0;
double Eeffm=0.0;
     double d_Eeffm_dV_DI_SI=0.0;
     double d_Eeffm_dV_GP_SI=0.0;
     double d_Eeffm_dV_SI_BP=0.0;
double Mutmp=0.0;
     double d_Mutmp_dV_DI_SI=0.0;
     double d_Mutmp_dV_GP_SI=0.0;
     double d_Mutmp_dV_SI_BP=0.0;
double Gmob=0.0;
     double d_Gmob_dV_DI_SI=0.0;
     double d_Gmob_dV_GP_SI=0.0;
     double d_Gmob_dV_SI_BP=0.0;
double xitsb=0.0;
     double d_xitsb_dV_DI_SI=0.0;
     double d_xitsb_dV_SI_BP=0.0;
     double d_xitsb_dV_GP_SI=0.0;
double wsat=0.0;
     double d_wsat_dV_DI_SI=0.0;
     double d_wsat_dV_GP_SI=0.0;
     double d_wsat_dV_SI_BP=0.0;
double thesat1=0.0;
     double d_thesat1_dV_GP_SI=0.0;
     double d_thesat1_dV_DI_SI=0.0;
     double d_thesat1_dV_SI_BP=0.0;
double phi_inf=0.0;
     double d_phi_inf_dV_DI_SI=0.0;
     double d_phi_inf_dV_GP_SI=0.0;
     double d_phi_inf_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double ysat=0.0;
     double d_ysat_dV_GP_SI=0.0;
     double d_ysat_dV_DI_SI=0.0;
     double d_ysat_dV_SI_BP=0.0;
double za=0.0;
     double d_za_dV_GP_SI=0.0;
     double d_za_dV_DI_SI=0.0;
     double d_za_dV_SI_BP=0.0;
double Phi_0=0.0;
     double d_Phi_0_dV_DI_SI=0.0;
     double d_Phi_0_dV_GP_SI=0.0;
     double d_Phi_0_dV_SI_BP=0.0;
double asat=0.0;
     double d_asat_dV_DI_SI=0.0;
     double d_asat_dV_GP_SI=0.0;
     double d_asat_dV_SI_BP=0.0;
double Phi_2=0.0;
     double d_Phi_2_dV_DI_SI=0.0;
     double d_Phi_2_dV_GP_SI=0.0;
     double d_Phi_2_dV_SI_BP=0.0;
double Phi_0_2=0.0;
     double d_Phi_0_2_dV_DI_SI=0.0;
     double d_Phi_0_2_dV_GP_SI=0.0;
     double d_Phi_0_2_dV_SI_BP=0.0;
double Phi0_Phi2=0.0;
     double d_Phi0_Phi2_dV_DI_SI=0.0;
     double d_Phi0_Phi2_dV_GP_SI=0.0;
     double d_Phi0_Phi2_dV_SI_BP=0.0;
double Phi_sat=0.0;
     double d_Phi_sat_dV_DI_SI=0.0;
     double d_Phi_sat_dV_GP_SI=0.0;
     double d_Phi_sat_dV_SI_BP=0.0;
double Vdse=0.0;
     double d_Vdse_dV_GP_SI=0.0;
     double d_Vdse_dV_SI_BP=0.0;
     double d_Vdse_dV_DI_SI=0.0;
double Udse=0.0;
     double d_Udse_dV_GP_SI=0.0;
     double d_Udse_dV_SI_BP=0.0;
     double d_Udse_dV_DI_SI=0.0;
double xn_d=0.0;
     double d_xn_d_dV_GP_SI=0.0;
     double d_xn_d_dV_DI_SI=0.0;
     double d_xn_d_dV_SI_BP=0.0;
double k_ds=0.0;
     double d_k_ds_dV_GP_SI=0.0;
     double d_k_ds_dV_SI_BP=0.0;
     double d_k_ds_dV_DI_SI=0.0;
double delta_nd=0.0;
     double d_delta_nd_dV_GP_SI=0.0;
     double d_delta_nd_dV_DI_SI=0.0;
     double d_delta_nd_dV_SI_BP=0.0;
double x_d=0.0;
     double d_x_d_dV_DI_SI=0.0;
     double d_x_d_dV_GP_SI=0.0;
     double d_x_d_dV_SI_BP=0.0;
double x_ds=0.0;
     double d_x_ds_dV_DI_SI=0.0;
     double d_x_ds_dV_GP_SI=0.0;
     double d_x_ds_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double pC=0.0;
     double d_pC_dV_DI_SI=0.0;
     double d_pC_dV_GP_SI=0.0;
     double d_pC_dV_SI_BP=0.0;
double qC=0.0;
     double d_qC_dV_DI_SI=0.0;
     double d_qC_dV_GP_SI=0.0;
     double d_qC_dV_SI_BP=0.0;
double dps=0.0;
     double d_dps_dV_DI_SI=0.0;
     double d_dps_dV_GP_SI=0.0;
     double d_dps_dV_SI_BP=0.0;
double xi0d=0.0;
     double d_xi0d_dV_DI_SI=0.0;
     double d_xi0d_dV_GP_SI=0.0;
     double d_xi0d_dV_SI_BP=0.0;
double Ed=0.0;
     double d_Ed_dV_DI_SI=0.0;
     double d_Ed_dV_GP_SI=0.0;
     double d_Ed_dV_SI_BP=0.0;
double Dd=0.0;
     double d_Dd_dV_DI_SI=0.0;
     double d_Dd_dV_GP_SI=0.0;
     double d_Dd_dV_SI_BP=0.0;
double x_m=0.0;
     double d_x_m_dV_DI_SI=0.0;
     double d_x_m_dV_GP_SI=0.0;
     double d_x_m_dV_SI_BP=0.0;
double Em=0.0;
     double d_Em_dV_DI_SI=0.0;
     double d_Em_dV_GP_SI=0.0;
     double d_Em_dV_SI_BP=0.0;
double D_bar=0.0;
     double d_D_bar_dV_DI_SI=0.0;
     double d_D_bar_dV_GP_SI=0.0;
     double d_D_bar_dV_SI_BP=0.0;
double Dm=0.0;
     double d_Dm_dV_DI_SI=0.0;
     double d_Dm_dV_GP_SI=0.0;
     double d_Dm_dV_SI_BP=0.0;
double Pm=0.0;
     double d_Pm_dV_DI_SI=0.0;
     double d_Pm_dV_GP_SI=0.0;
     double d_Pm_dV_SI_BP=0.0;
double xgm=0.0;
     double d_xgm_dV_DI_SI=0.0;
     double d_xgm_dV_GP_SI=0.0;
     double d_xgm_dV_SI_BP=0.0;
double eta_p=0.0;
     double d_eta_p_dV_DI_SI=0.0;
     double d_eta_p_dV_GP_SI=0.0;
     double d_eta_p_dV_SI_BP=0.0;
double sqm=0.0;
     double d_sqm_dV_DI_SI=0.0;
     double d_sqm_dV_GP_SI=0.0;
     double d_sqm_dV_SI_BP=0.0;
double alpha=0.0;
     double d_alpha_dV_DI_SI=0.0;
     double d_alpha_dV_GP_SI=0.0;
     double d_alpha_dV_SI_BP=0.0;
double d0=0.0;
     double d_d0_dV_DI_SI=0.0;
     double d_d0_dV_GP_SI=0.0;
     double d_d0_dV_SI_BP=0.0;
double x_pm=0.0;
     double d_x_pm_dV_GP_SI=0.0;
     double d_x_pm_dV_DI_SI=0.0;
     double d_x_pm_dV_SI_BP=0.0;
double p_pd=0.0;
     double d_p_pd_dV_DI_SI=0.0;
     double d_p_pd_dV_GP_SI=0.0;
     double d_p_pd_dV_SI_BP=0.0;
double q_pd=0.0;
     double d_q_pd_dV_GP_SI=0.0;
     double d_q_pd_dV_DI_SI=0.0;
     double d_q_pd_dV_SI_BP=0.0;
double xi_pd=0.0;
     double d_xi_pd_dV_DI_SI=0.0;
     double d_xi_pd_dV_GP_SI=0.0;
     double d_xi_pd_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double u_pd=0.0;
     double d_u_pd_dV_GP_SI=0.0;
     double d_u_pd_dV_DI_SI=0.0;
     double d_u_pd_dV_SI_BP=0.0;
double km=0.0;
     double d_km_dV_GP_SI=0.0;
     double d_km_dV_DI_SI=0.0;
     double d_km_dV_SI_BP=0.0;
double km0=0.0;
     double d_km0_dV_DI_SI=0.0;
     double d_km0_dV_GP_SI=0.0;
     double d_km0_dV_SI_BP=0.0;
double qim=0.0;
     double d_qim_dV_GP_SI=0.0;
     double d_qim_dV_DI_SI=0.0;
     double d_qim_dV_SI_BP=0.0;
double qim1=0.0;
     double d_qim1_dV_GP_SI=0.0;
     double d_qim1_dV_DI_SI=0.0;
     double d_qim1_dV_SI_BP=0.0;
double qbm=0.0;
     double d_qbm_dV_DI_SI=0.0;
     double d_qbm_dV_GP_SI=0.0;
     double d_qbm_dV_SI_BP=0.0;
double qeff=0.0;
     double d_qeff_dV_DI_SI=0.0;
     double d_qeff_dV_GP_SI=0.0;
     double d_qeff_dV_SI_BP=0.0;
double qeff1=0.0;
     double d_qeff1_dV_DI_SI=0.0;
     double d_qeff1_dV_GP_SI=0.0;
     double d_qeff1_dV_SI_BP=0.0;
double s1=0.0;
     double d_s1_dV_DI_SI=0.0;
     double d_s1_dV_GP_SI=0.0;
     double d_s1_dV_SI_BP=0.0;
double dL=0.0;
     double d_dL_dV_DI_SI=0.0;
     double d_dL_dV_GP_SI=0.0;
     double d_dL_dV_SI_BP=0.0;
double GdL=0.0;
     double d_GdL_dV_DI_SI=0.0;
     double d_GdL_dV_GP_SI=0.0;
     double d_GdL_dV_SI_BP=0.0;
double Gmob_dL=0.0;
     double d_Gmob_dL_dV_DI_SI=0.0;
     double d_Gmob_dL_dV_GP_SI=0.0;
     double d_Gmob_dL_dV_SI_BP=0.0;
double zsat=0.0;
     double d_zsat_dV_GP_SI=0.0;
     double d_zsat_dV_DI_SI=0.0;
     double d_zsat_dV_SI_BP=0.0;
double Gvsat=0.0;
     double d_Gvsat_dV_DI_SI=0.0;
     double d_Gvsat_dV_GP_SI=0.0;
     double d_Gvsat_dV_SI_BP=0.0;
double Gvsatinv=0.0;
     double d_Gvsatinv_dV_DI_SI=0.0;
     double d_Gvsatinv_dV_GP_SI=0.0;
     double d_Gvsatinv_dV_SI_BP=0.0;
double Voxm=0.0;
     double d_Voxm_dV_DI_SI=0.0;
     double d_Voxm_dV_GP_SI=0.0;
     double d_Voxm_dV_SI_BP=0.0;
double alpha1=0.0;
     double d_alpha1_dV_DI_SI=0.0;
     double d_alpha1_dV_GP_SI=0.0;
     double d_alpha1_dV_SI_BP=0.0;
double H=0.0;
     double d_H_dV_GP_SI=0.0;
     double d_H_dV_DI_SI=0.0;
     double d_H_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_temp=0.0;
     double d_SP_S_temp_dV_DI_SI=0.0;
     double d_SP_S_temp_dV_GP_SI=0.0;
     double d_SP_S_temp_dV_SI_BP=0.0;
double SP_S_temp1=0.0;
     double d_SP_S_temp1_dV_DI_SI=0.0;
     double d_SP_S_temp1_dV_GP_SI=0.0;
     double d_SP_S_temp1_dV_SI_BP=0.0;
double SP_S_temp2=0.0;
     double d_SP_S_temp2_dV_DI_SI=0.0;
     double d_SP_S_temp2_dV_GP_SI=0.0;
     double d_SP_S_temp2_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_yg=0.0;
     double d_SP_S_yg_dV_DI_SI=0.0;
     double d_SP_S_yg_dV_GP_SI=0.0;
     double d_SP_S_yg_dV_SI_BP=0.0;
double SP_S_ysub=0.0;
     double d_SP_S_ysub_dV_DI_SI=0.0;
     double d_SP_S_ysub_dV_GP_SI=0.0;
     double d_SP_S_ysub_dV_SI_BP=0.0;
double SP_S_eta=0.0;
     double d_SP_S_eta_dV_DI_SI=0.0;
     double d_SP_S_eta_dV_GP_SI=0.0;
     double d_SP_S_eta_dV_SI_BP=0.0;
double SP_S_a=0.0;
     double d_SP_S_a_dV_DI_SI=0.0;
     double d_SP_S_a_dV_GP_SI=0.0;
     double d_SP_S_a_dV_SI_BP=0.0;
double SP_S_c=0.0;
     double d_SP_S_c_dV_DI_SI=0.0;
     double d_SP_S_c_dV_GP_SI=0.0;
     double d_SP_S_c_dV_SI_BP=0.0;
double SP_S_tau=0.0;
     double d_SP_S_tau_dV_DI_SI=0.0;
     double d_SP_S_tau_dV_GP_SI=0.0;
     double d_SP_S_tau_dV_SI_BP=0.0;
double SP_S_y0=0.0;
     double d_SP_S_y0_dV_DI_SI=0.0;
     double d_SP_S_y0_dV_GP_SI=0.0;
     double d_SP_S_y0_dV_SI_BP=0.0;
double SP_S_delta0=0.0;
     double d_SP_S_delta0_dV_DI_SI=0.0;
     double d_SP_S_delta0_dV_GP_SI=0.0;
     double d_SP_S_delta0_dV_SI_BP=0.0;
double SP_S_delta1=0.0;
     double d_SP_S_delta1_dV_DI_SI=0.0;
     double d_SP_S_delta1_dV_GP_SI=0.0;
     double d_SP_S_delta1_dV_SI_BP=0.0;
double SP_S_xi0=0.0;
     double d_SP_S_xi0_dV_DI_SI=0.0;
     double d_SP_S_xi0_dV_GP_SI=0.0;
     double d_SP_S_xi0_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_xi1=0.0;
     double d_SP_S_xi1_dV_DI_SI=0.0;
     double d_SP_S_xi1_dV_GP_SI=0.0;
     double d_SP_S_xi1_dV_SI_BP=0.0;
double SP_S_xi2=0.0;
     double d_SP_S_xi2_dV_DI_SI=0.0;
     double d_SP_S_xi2_dV_GP_SI=0.0;
     double d_SP_S_xi2_dV_SI_BP=0.0;
double SP_S_pC=0.0;
     double d_SP_S_pC_dV_DI_SI=0.0;
     double d_SP_S_pC_dV_GP_SI=0.0;
     double d_SP_S_pC_dV_SI_BP=0.0;
double SP_S_qC=0.0;
     double d_SP_S_qC_dV_DI_SI=0.0;
     double d_SP_S_qC_dV_GP_SI=0.0;
     double d_SP_S_qC_dV_SI_BP=0.0;
double SP_xg1=0.0;
     double d_SP_xg1_dV_DI_SI=0.0;
     double d_SP_xg1_dV_GP_SI=0.0;
     double d_SP_xg1_dV_SI_BP=0.0;
double SP_S_A_fac=0.0;
     double d_SP_S_A_fac_dV_DI_SI=0.0;
     double d_SP_S_A_fac_dV_GP_SI=0.0;
     double d_SP_S_A_fac_dV_SI_BP=0.0;
double SP_S_xbar=0.0;
     double d_SP_S_xbar_dV_DI_SI=0.0;
     double d_SP_S_xbar_dV_GP_SI=0.0;
     double d_SP_S_xbar_dV_SI_BP=0.0;
double SP_S_w=0.0;
     double d_SP_S_w_dV_DI_SI=0.0;
     double d_SP_S_w_dV_GP_SI=0.0;
     double d_SP_S_w_dV_SI_BP=0.0;
double SP_S_x1=0.0;
     double d_SP_S_x1_dV_DI_SI=0.0;
     double d_SP_S_x1_dV_GP_SI=0.0;
     double d_SP_S_x1_dV_SI_BP=0.0;
double SP_S_bx=0.0;
     double d_SP_S_bx_dV_GP_SI=0.0;
     double d_SP_S_bx_dV_DI_SI=0.0;
     double d_SP_S_bx_dV_SI_BP=0.0;
double SP_S_b=0.0;
     double d_SP_S_b_dV_DI_SI=0.0;
     double d_SP_S_b_dV_GP_SI=0.0;
     double d_SP_S_b_dV_SI_BP=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_x0=0.0;
     double d_SP_S_x0_dV_DI_SI=0.0;
     double d_SP_S_x0_dV_GP_SI=0.0;
     double d_SP_S_x0_dV_SI_BP=0.0;
//End of Block-local variables
if ((((model_.SWNUD_i)==1)||((model_.SWDELVTAC_i)!=0)))
{
if (((model_.SWDELVTAC_i)!=0))
{
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+bphi_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_GP_SI =  0.0;
d_temp_dV_SI_BP = 0.5*((d_Vdb_dV_SI_BP+d_Vsb_dV_SI_BP)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)+(d_Vdb_dV_SI_BP-d_Vsb_dV_SI_BP)*(Vdb-Vsb)))));
d_temp_dV_DI_SI = 0.5*((d_Vdb_dV_DI_SI+d_Vsb_dV_DI_SI)-(deriv_sqrt_0_d0*(((Vdb-Vsb)*(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)+(d_Vdb_dV_DI_SI-d_Vsb_dV_DI_SI)*(Vdb-Vsb)))));
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+phix_ac);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+aphi_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vsbstar_ac_dV_GP_SI = (-0.5*(d_temp_dV_GP_SI-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_GP_SI+d_temp_dV_GP_SI*(temp))))));
d_Vsbstar_ac_dV_SI_BP = (d_Vsb_dV_SI_BP-0.5*(d_temp_dV_SI_BP-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_SI_BP+d_temp_dV_SI_BP*(temp))))));
d_Vsbstar_ac_dV_DI_SI = (d_Vsb_dV_DI_SI-0.5*(d_temp_dV_DI_SI-(deriv_sqrt_0_d0*(((temp)*d_temp_dV_DI_SI+d_temp_dV_DI_SI*(temp))))));
Vsbstar_ac = ((Vsb-(0.5*(temp-value_sqrt_0)))+phix1_ac);
}

d_Vsbstar_dV_GP_SI = d_Vsbstar_ac_dV_GP_SI;
d_Vsbstar_dV_SI_BP = d_Vsbstar_ac_dV_SI_BP;
d_Vsbstar_dV_DI_SI = d_Vsbstar_ac_dV_DI_SI;
Vsbstar = Vsbstar_ac;
phib = phib_ac;
G_0 = G_0_ac;
}
else
{

d_Vsbstar_dV_GP_SI =  0.0;
d_Vsbstar_dV_SI_BP = d_Vsbstar_dc_tmp_dV_SI_BP;
d_Vsbstar_dV_DI_SI = d_Vsbstar_dc_tmp_dV_DI_SI;
Vsbstar = Vsbstar_dc_tmp;
phib = phib_dc;
G_0 = G_0_dc;
}

d_alpha_dV_DI_SI = d_alpha_dV_GP_SI = d_alpha_dV_SI_BP =  0.0;
alpha = 0.0;

d_GdL_dV_DI_SI = d_GdL_dV_GP_SI = d_GdL_dV_SI_BP =  0.0;
GdL = 1.0;

d_dL_dV_DI_SI = d_dL_dV_GP_SI = d_dL_dV_SI_BP =  0.0;
dL = 0.0;

d_qbm_dV_DI_SI = d_qbm_dV_GP_SI = d_qbm_dV_SI_BP =  0.0;
qbm = 0.0;

d_dps_dV_DI_SI = d_dps_dV_GP_SI = d_dps_dV_SI_BP =  0.0;
dps = 0.0;

d_qim_dV_GP_SI = d_qim_dV_DI_SI = d_qim_dV_SI_BP =  0.0;
qim = 0.0;

d_qim1_dV_GP_SI = d_qim1_dV_DI_SI = d_qim1_dV_SI_BP =  0.0;
qim1 = 0.0;

d_H_dV_GP_SI = d_H_dV_DI_SI = d_H_dV_SI_BP =  0.0;
H = 1.0;

d_s1_dV_DI_SI = d_s1_dV_GP_SI = d_s1_dV_SI_BP =  0.0;
s1 = 0.0;

d_eta_p_dV_DI_SI = d_eta_p_dV_GP_SI = d_eta_p_dV_SI_BP =  0.0;
eta_p = 1.0;

d_Gvsat_dV_DI_SI = d_Gvsat_dV_GP_SI = d_Gvsat_dV_SI_BP =  0.0;
Gvsat = 1.0;

d_Gvsatinv_dV_DI_SI = d_Gvsatinv_dV_GP_SI = d_Gvsatinv_dV_SI_BP =  0.0;
Gvsatinv = 1.0;

d_SP_S_x1_dV_DI_SI = d_SP_S_x1_dV_GP_SI = d_SP_S_x1_dV_SI_BP =  0.0;
SP_S_x1 = 0.0;

d_x_s_dV_DI_SI = d_x_s_dV_GP_SI = d_x_s_dV_SI_BP =  0.0;
x_s = 0.0;

d_sqm_dV_DI_SI = d_sqm_dV_GP_SI = d_sqm_dV_SI_BP =  0.0;
sqm = 0.0;

d_xitsb_dV_DI_SI = d_xitsb_dV_SI_BP = d_xitsb_dV_GP_SI =  0.0;
xitsb = 0.0;

d_rhob_dV_DI_SI = d_rhob_dV_SI_BP = d_rhob_dV_GP_SI =  0.0;
rhob = 0.0;

d_Gmob_dV_DI_SI = d_Gmob_dV_GP_SI = d_Gmob_dV_SI_BP =  0.0;
Gmob = 1.0;

d_Gmob_dL_dV_DI_SI = d_Gmob_dL_dV_GP_SI = d_Gmob_dL_dV_SI_BP =  0.0;
Gmob_dL = 1.0;

d_Udse_dV_GP_SI = d_Udse_dV_SI_BP = d_Udse_dV_DI_SI =  0.0;
Udse = 0.0;

d_thesat1_dV_GP_SI = d_thesat1_dV_DI_SI = d_thesat1_dV_SI_BP =  0.0;
thesat1 = 0.0;

d_xgm_dV_DI_SI = d_xgm_dV_GP_SI = d_xgm_dV_SI_BP =  0.0;
xgm = 0.0;

d_Vgbstar_dV_SI_BP = d_Vsbstar_dV_SI_BP;
d_Vgbstar_dV_GP_SI = (d_Vgs_dV_GP_SI+d_Vsbstar_dV_GP_SI);
d_Vgbstar_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsbstar_dV_DI_SI);
Vgbstar = (Vgs+Vsbstar);

d_Vgb1_dV_SI_BP = d_Vgbstar_dV_SI_BP;
d_Vgb1_dV_GP_SI = d_Vgbstar_dV_GP_SI;
d_Vgb1_dV_DI_SI = d_Vgbstar_dV_DI_SI;
Vgb1 = (Vgbstar-VFB_T);

d_Vsbx_dV_GP_SI = d_Vsbstar_dV_GP_SI;
d_Vsbx_dV_SI_BP = d_Vsbstar_dV_SI_BP;
d_Vsbx_dV_DI_SI = (d_Vsbstar_dV_DI_SI+0.5*(d_Vds_dV_DI_SI-d_Vdsx_dV_DI_SI));
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
if ((CFD_i<1.0e-10))
{

d_Vdsp_dV_DI_SI = d_Vdsx_dV_DI_SI;
Vdsp = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(CFD_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Vdsp_dV_DI_SI = (2.0*(deriv_sqrt_0_d0*(CFD_i*d_Vdsx_dV_DI_SI))/CFD_i);
Vdsp = ((2.0*(value_sqrt_0-1.0))/CFD_i);
}
}

d_delVg_dV_GP_SI = (CF_i*Vdsp)*CFB_i*d_Vsbx_dV_GP_SI;
d_delVg_dV_SI_BP = (CF_i*Vdsp)*CFB_i*d_Vsbx_dV_SI_BP;
d_delVg_dV_DI_SI = ((CF_i*Vdsp)*CFB_i*d_Vsbx_dV_DI_SI+CF_i*d_Vdsp_dV_DI_SI*(1.0+(CFB_i*Vsbx)));
delVg = ((CF_i*Vdsp)*(1.0+(CFB_i*Vsbx)));

d_dphit1_dV_GP_SI = (PSCE_i*(1.0+(PSCED_i*Vdsx)))*PSCEB_i*d_Vsbx_dV_GP_SI;
d_dphit1_dV_SI_BP = (PSCE_i*(1.0+(PSCED_i*Vdsx)))*PSCEB_i*d_Vsbx_dV_SI_BP;
d_dphit1_dV_DI_SI = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*PSCEB_i*d_Vsbx_dV_DI_SI+PSCE_i*PSCED_i*d_Vdsx_dV_DI_SI*(1.0+(PSCEB_i*Vsbx)));
dphit1 = ((PSCE_i*(1.0+(PSCED_i*Vdsx)))*(1.0+(PSCEB_i*Vsbx)));

d_phit1_dV_SI_BP = phit0*d_dphit1_dV_SI_BP;
d_phit1_dV_DI_SI = phit0*d_dphit1_dV_DI_SI;
d_phit1_dV_GP_SI = phit0*d_dphit1_dV_GP_SI;
phit1 = (phit0*(1.0+dphit1));

d_inv_phit1_dV_SI_BP = (-d_phit1_dV_SI_BP/phit1/phit1);
d_inv_phit1_dV_DI_SI = (-d_phit1_dV_DI_SI/phit1/phit1);
d_inv_phit1_dV_GP_SI = (-d_phit1_dV_GP_SI/phit1/phit1);
inv_phit1 = (1.0/phit1);

d_Vgb1_dV_SI_BP = (d_Vgb1_dV_SI_BP+d_delVg_dV_SI_BP);
d_Vgb1_dV_GP_SI = (d_Vgb1_dV_GP_SI+d_delVg_dV_GP_SI);
d_Vgb1_dV_DI_SI = (d_Vgb1_dV_DI_SI+d_delVg_dV_DI_SI);
Vgb1 = (Vgb1+delVg);

d_xg_dV_SI_BP = (Vgb1*d_inv_phit1_dV_SI_BP+d_Vgb1_dV_SI_BP*inv_phit1);
d_xg_dV_GP_SI = (Vgb1*d_inv_phit1_dV_GP_SI+d_Vgb1_dV_GP_SI*inv_phit1);
d_xg_dV_DI_SI = (Vgb1*d_inv_phit1_dV_DI_SI+d_Vgb1_dV_DI_SI*inv_phit1);
xg = (Vgb1*inv_phit1);
if ((DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-VNSUB_i))*(-((Vgs+Vsb)-VNSUB_i)))+NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Dnsub_dV_SI_BP = (DNSUB_i*0.5)*(d_Vsb_dV_SI_BP+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vsb_dV_SI_BP)+(-d_Vsb_dV_SI_BP)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_GP_SI = (DNSUB_i*0.5)*(d_Vgs_dV_GP_SI+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-d_Vgs_dV_GP_SI)+(-d_Vgs_dV_GP_SI)*(-((Vgs+Vsb)-VNSUB_i))))));
d_Dnsub_dV_DI_SI = (DNSUB_i*0.5)*((d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI)+(deriv_sqrt_0_d0*(((-((Vgs+Vsb)-VNSUB_i))*(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))+(-(d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI))*(-((Vgs+Vsb)-VNSUB_i))))));
Dnsub = ((DNSUB_i*0.5)*(((Vgs+Vsb)-VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gf_dV_SI_BP = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_SI_BP));
d_Gf_dV_GP_SI = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_GP_SI));
d_Gf_dV_DI_SI = G_0*(deriv_sqrt_0_d0*(d_Dnsub_dV_DI_SI));
Gf = (G_0*value_sqrt_0);
}
}
else
{

d_Gf_dV_DI_SI = d_Gf_dV_GP_SI = d_Gf_dV_SI_BP =  0.0;
Gf = G_0;
}

d_Gf2_dV_SI_BP = (Gf*d_Gf_dV_SI_BP+d_Gf_dV_SI_BP*Gf);
d_Gf2_dV_GP_SI = (Gf*d_Gf_dV_GP_SI+d_Gf_dV_GP_SI*Gf);
d_Gf2_dV_DI_SI = (Gf*d_Gf_dV_DI_SI+d_Gf_dV_DI_SI*Gf);
Gf2 = (Gf*Gf);

d_inv_Gf2_dV_SI_BP = (-d_Gf2_dV_SI_BP/Gf2/Gf2);
d_inv_Gf2_dV_GP_SI = (-d_Gf2_dV_GP_SI/Gf2/Gf2);
d_inv_Gf2_dV_DI_SI = (-d_Gf2_dV_DI_SI/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);

d_xi_dV_SI_BP = d_Gf_dV_SI_BP*7.0710678118654746e-01;
d_xi_dV_GP_SI = d_Gf_dV_GP_SI*7.0710678118654746e-01;
d_xi_dV_DI_SI = d_Gf_dV_DI_SI*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));

d_inv_xi_dV_SI_BP = (-d_xi_dV_SI_BP/xi/xi);
d_inv_xi_dV_GP_SI = (-d_xi_dV_GP_SI/xi/xi);
d_inv_xi_dV_DI_SI = (-d_xi_dV_DI_SI/xi/xi);
inv_xi = (1.0/xi);

d_Ux_dV_GP_SI = (Vsbstar*d_inv_phit1_dV_GP_SI+d_Vsbstar_dV_GP_SI*inv_phit1);
d_Ux_dV_SI_BP = (Vsbstar*d_inv_phit1_dV_SI_BP+d_Vsbstar_dV_SI_BP*inv_phit1);
d_Ux_dV_DI_SI = (Vsbstar*d_inv_phit1_dV_DI_SI+d_Vsbstar_dV_DI_SI*inv_phit1);
Ux = (Vsbstar*inv_phit1);

d_xn_s_dV_SI_BP = (phib*d_inv_phit1_dV_SI_BP+d_Ux_dV_SI_BP);
d_xn_s_dV_DI_SI = (phib*d_inv_phit1_dV_DI_SI+d_Ux_dV_DI_SI);
d_xn_s_dV_GP_SI = (phib*d_inv_phit1_dV_GP_SI+d_Ux_dV_GP_SI);
xn_s = ((phib*inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_ns_dV_SI_BP = (deriv_exp_0_d0*((-d_xn_s_dV_SI_BP)));
d_delta_ns_dV_DI_SI = (deriv_exp_0_d0*((-d_xn_s_dV_DI_SI)));
d_delta_ns_dV_GP_SI = (deriv_exp_0_d0*((-d_xn_s_dV_GP_SI)));
delta_ns = value_exp_0;
}
}
else
{

d_delta_ns_dV_SI_BP = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_SI_BP*3.3333333333333333e-01+d_xn_s_dV_SI_BP*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_SI_BP*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_delta_ns_dV_DI_SI = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_DI_SI*3.3333333333333333e-01+d_xn_s_dV_DI_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_DI_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_delta_ns_dV_GP_SI = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dV_GP_SI*3.3333333333333333e-01+d_xn_s_dV_GP_SI*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dV_GP_SI*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_margin_dV_SI_BP = 1.0e-5*d_xi_dV_SI_BP;
d_margin_dV_GP_SI = 1.0e-5*d_xi_dV_GP_SI;
d_margin_dV_DI_SI = 1.0e-5*d_xi_dV_DI_SI;
margin = (1.0e-5*xi);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_SI_BP = (inv_xi*d_inv_xi_dV_SI_BP+d_inv_xi_dV_SI_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_SI = (inv_xi*d_inv_xi_dV_GP_SI+d_inv_xi_dV_GP_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_DI_SI = (inv_xi*d_inv_xi_dV_DI_SI+d_inv_xi_dV_DI_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_s_dV_SI_BP = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_SI_BP+((xg*(1.0-delta_ns))*d_Gf_dV_SI_BP+(xg*(-d_delta_ns_dV_SI_BP)+d_xg_dV_SI_BP*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_GP_SI = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_GP_SI+((xg*(1.0-delta_ns))*d_Gf_dV_GP_SI+(xg*(-d_delta_ns_dV_GP_SI)+d_xg_dV_GP_SI*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
d_x_s_dV_DI_SI = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dV_DI_SI+((xg*(1.0-delta_ns))*d_Gf_dV_DI_SI+(xg*(-d_delta_ns_dV_DI_SI)+d_xg_dV_DI_SI*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{

d_SP_S_yg_dV_SI_BP = (-d_xg_dV_SI_BP);
d_SP_S_yg_dV_GP_SI = (-d_xg_dV_GP_SI);
d_SP_S_yg_dV_DI_SI = (-d_xg_dV_DI_SI);
SP_S_yg = (-xg);

d_SP_S_ysub_dV_SI_BP = 1.25*(SP_S_yg*d_inv_xi_dV_SI_BP+d_SP_S_yg_dV_SI_BP*inv_xi);
d_SP_S_ysub_dV_GP_SI = 1.25*(SP_S_yg*d_inv_xi_dV_GP_SI+d_SP_S_yg_dV_GP_SI*inv_xi);
d_SP_S_ysub_dV_DI_SI = 1.25*(SP_S_yg*d_inv_xi_dV_DI_SI+d_SP_S_yg_dV_DI_SI*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_eta_dV_SI_BP = 0.5*(d_SP_S_ysub_dV_SI_BP-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_SI_BP+d_SP_S_ysub_dV_SI_BP*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_GP_SI = 0.5*(d_SP_S_ysub_dV_GP_SI-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_GP_SI+d_SP_S_ysub_dV_GP_SI*(SP_S_ysub-6.0)))));
d_SP_S_eta_dV_DI_SI = 0.5*(d_SP_S_ysub_dV_DI_SI-(deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dV_DI_SI+d_SP_S_ysub_dV_DI_SI*(SP_S_ysub-6.0)))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}

d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (SP_S_yg-SP_S_eta);

d_SP_S_a_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)+(Gf2*d_SP_S_eta_dV_SI_BP+d_Gf2_dV_SI_BP*(SP_S_eta+1.0)));
d_SP_S_a_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)+(Gf2*d_SP_S_eta_dV_GP_SI+d_Gf2_dV_GP_SI*(SP_S_eta+1.0)));
d_SP_S_a_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)+(Gf2*d_SP_S_eta_dV_DI_SI+d_Gf2_dV_DI_SI*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP-d_Gf2_dV_SI_BP);
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI-d_Gf2_dV_GP_SI);
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI-d_Gf2_dV_DI_SI);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));

d_SP_S_tau_dV_SI_BP = ((-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_SI_BP+d_SP_S_a_dV_SI_BP*inv_Gf2))));
d_SP_S_tau_dV_GP_SI = ((-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_GP_SI+d_SP_S_a_dV_GP_SI*inv_Gf2))));
d_SP_S_tau_dV_DI_SI = ((-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dV_DI_SI+d_SP_S_a_dV_DI_SI*inv_Gf2))));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-d_SP_S_a_dV_SI_BP)+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-d_SP_S_a_dV_GP_SI)+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-d_SP_S_a_dV_DI_SI)+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));

d_SP_S_y0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_SI_BP)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_GP_SI)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
d_SP_S_y0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dV_DI_SI)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_y0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_y0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}
}
else
{

d_SP_S_delta0_dV_SI_BP = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_y0_dV_SI_BP*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_SI_BP*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_GP_SI = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_y0_dV_GP_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_GP_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_SP_S_delta0_dV_DI_SI = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_y0_dV_DI_SI*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dV_DI_SI*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_temp_dV_SI_BP = (-(SP_S_y0*d_SP_S_y0_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_y0*d_SP_S_y0_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_y0*d_SP_S_y0_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_SI_BP+(SP_S_y0*d_SP_S_y0_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_GP_SI+(SP_S_y0*d_SP_S_y0_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_y0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dV_DI_SI+(SP_S_y0*d_SP_S_y0_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_y0*d_SP_S_temp_dV_SI_BP+d_SP_S_y0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_y0*d_SP_S_temp_dV_GP_SI+d_SP_S_y0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_y0*d_SP_S_temp_dV_DI_SI+d_SP_S_y0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_SP_S_yg_dV_SI_BP-d_SP_S_y0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_SP_S_yg_dV_GP_SI-d_SP_S_y0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_SP_S_yg_dV_DI_SI-d_SP_S_y0_dV_DI_SI);
SP_S_temp = (SP_S_yg-SP_S_y0);

d_SP_S_temp1_dV_SI_BP = (delta_ns*d_SP_S_delta1_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_delta1);
d_SP_S_temp1_dV_DI_SI = (delta_ns*d_SP_S_delta1_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_delta1);
d_SP_S_temp1_dV_GP_SI = (delta_ns*d_SP_S_delta1_dV_GP_SI+d_delta_ns_dV_GP_SI*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((d_SP_S_delta0_dV_SI_BP-d_SP_S_temp1_dV_SI_BP)+(delta_ns*(-d_SP_S_xi1_dV_SI_BP)+d_delta_ns_dV_SI_BP*(1.0-SP_S_xi1)))+d_Gf2_dV_SI_BP*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((d_SP_S_delta0_dV_GP_SI-d_SP_S_temp1_dV_GP_SI)+(delta_ns*(-d_SP_S_xi1_dV_GP_SI)+d_delta_ns_dV_GP_SI*(1.0-SP_S_xi1)))+d_Gf2_dV_GP_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((d_SP_S_delta0_dV_DI_SI-d_SP_S_temp1_dV_DI_SI)+(delta_ns*(-d_SP_S_xi1_dV_DI_SI)+d_delta_ns_dV_DI_SI*(1.0-SP_S_xi1)))+d_Gf2_dV_DI_SI*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_SI_BP-d_SP_S_y0_dV_SI_BP)+d_SP_S_temp1_dV_SI_BP)+(delta_ns*(d_SP_S_y0_dV_SI_BP-d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_GP_SI-d_SP_S_y0_dV_GP_SI)+d_SP_S_temp1_dV_GP_SI)+(delta_ns*(d_SP_S_y0_dV_GP_SI-d_SP_S_xi0_dV_GP_SI)+d_delta_ns_dV_GP_SI*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_GP_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dV_DI_SI-d_SP_S_y0_dV_DI_SI)+d_SP_S_temp1_dV_DI_SI)+(delta_ns*(d_SP_S_y0_dV_DI_SI-d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta0_dV_SI_BP+d_SP_S_temp1_dV_SI_BP)-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta0_dV_GP_SI+d_SP_S_temp1_dV_GP_SI)-(delta_ns*d_SP_S_xi2_dV_GP_SI+d_delta_ns_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta0_dV_DI_SI+d_SP_S_temp1_dV_DI_SI)-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_SI_BP = ((-d_SP_S_y0_dV_SI_BP)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_SI = ((-d_SP_S_y0_dV_GP_SI)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_DI_SI = ((-d_SP_S_y0_dV_DI_SI)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{

d_SP_xg1_dV_SI_BP = (-d_Gf_dV_SI_BP*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_GP_SI = (-d_Gf_dV_GP_SI*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
d_SP_xg1_dV_DI_SI = (-d_Gf_dV_DI_SI*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));

d_SP_S_A_fac_dV_SI_BP = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_SI_BP+((xi*1.25)*d_SP_xg1_dV_SI_BP+d_xi_dV_SI_BP*1.25*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_GP_SI = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_GP_SI+((xi*1.25)*d_SP_xg1_dV_GP_SI+d_xi_dV_GP_SI*1.25*SP_xg1)*SP_xg1);
d_SP_S_A_fac_dV_DI_SI = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dV_DI_SI+((xi*1.25)*d_SP_xg1_dV_DI_SI+d_xi_dV_DI_SI*1.25*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);

d_SP_S_xbar_dV_SI_BP = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_SI_BP+d_SP_S_A_fac_dV_SI_BP*xg)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_GP_SI = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_GP_SI+d_SP_S_A_fac_dV_GP_SI*xg)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(SP_S_A_fac*xg)));
d_SP_S_xbar_dV_DI_SI = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dV_DI_SI+d_SP_S_A_fac_dV_DI_SI*xg)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_SI_BP)));
d_SP_S_temp_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_GP_SI)));
d_SP_S_temp_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_xbar_dV_DI_SI)));
SP_S_temp = value_exp_0;
}
}
else
{

d_SP_S_temp_dV_SI_BP = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_SI_BP))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_SI_BP))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_GP_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_GP_SI))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_GP_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
d_SP_S_temp_dV_DI_SI = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dV_DI_SI))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dV_DI_SI))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}

d_SP_S_w_dV_SI_BP = (-d_SP_S_temp_dV_SI_BP);
d_SP_S_w_dV_GP_SI = (-d_SP_S_temp_dV_GP_SI);
d_SP_S_w_dV_DI_SI = (-d_SP_S_temp_dV_DI_SI);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_SP_S_x1_dV_SI_BP = ((d_xg_dV_SI_BP+d_Gf2_dV_SI_BP*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_SI_BP+d_Gf2_dV_SI_BP*0.25)-d_SP_S_w_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0));
d_SP_S_x1_dV_GP_SI = ((d_xg_dV_GP_SI+d_Gf2_dV_GP_SI*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_GP_SI+d_Gf2_dV_GP_SI*0.25)-d_SP_S_w_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0));
d_SP_S_x1_dV_DI_SI = ((d_xg_dV_DI_SI+d_Gf2_dV_DI_SI*0.5)-(Gf*(deriv_sqrt_0_d0*(((d_xg_dV_DI_SI+d_Gf2_dV_DI_SI*0.25)-d_SP_S_w_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}

d_SP_S_bx_dV_SI_BP = d_xn_s_dV_SI_BP;
d_SP_S_bx_dV_DI_SI = d_xn_s_dV_DI_SI;
d_SP_S_bx_dV_GP_SI = d_xn_s_dV_GP_SI;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_SI_BP = (0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)+(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_SI_BP+d_SP_S_bx_dV_SI_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_SI = (0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)+(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_SI+d_SP_S_bx_dV_GP_SI*SP_S_bx)))));
d_SP_S_eta_dV_DI_SI = (0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)+(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_DI_SI+d_SP_S_bx_dV_DI_SI*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_SI_BP = (-(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_SI = (-(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_DI_SI = (-(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_DI_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_temp2_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_temp2_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_temp2_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP+(8.0*d_SP_S_temp2_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI+(8.0*d_SP_S_temp2_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI+(8.0*d_SP_S_temp2_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_SI_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_SI_BP+d_SP_S_eta_dV_SI_BP)-(delta_ns*(d_SP_S_eta_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_SI+d_SP_S_eta_dV_GP_SI)-(delta_ns*(d_SP_S_eta_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_ns_dV_GP_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_DI_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_DI_SI+d_SP_S_eta_dV_DI_SI)-(delta_ns*(d_SP_S_eta_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_SI_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_SI_BP-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_GP_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_SI-(delta_ns*d_SP_S_xi2_dV_GP_SI+d_delta_ns_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))));
d_SP_S_b_dV_DI_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_DI_SI-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((-d_SP_S_temp1_dV_SI_BP)-(delta_ns*d_SP_S_xi1_dV_SI_BP+d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((-d_SP_S_temp1_dV_GP_SI)-(delta_ns*d_SP_S_xi1_dV_GP_SI+d_delta_ns_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((-d_SP_S_temp1_dV_DI_SI)-(delta_ns*d_SP_S_xi1_dV_DI_SI+d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_SI_BP = ((d_xn_s_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_DI_SI = ((d_xn_s_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
d_SP_S_tau_dV_GP_SI = ((d_xn_s_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_SI_BP = (delta_ns*d_SP_S_delta0_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_delta0);
d_SP_S_delta0_dV_DI_SI = (delta_ns*d_SP_S_delta0_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_delta0);
d_SP_S_delta0_dV_GP_SI = (delta_ns*d_SP_S_delta0_dV_GP_SI+d_delta_ns_dV_GP_SI*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_s_dV_SI_BP)));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_s_dV_GP_SI)));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_s_dV_DI_SI)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_ns_dV_SI_BP-delta_ns*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_ns_dV_DI_SI-delta_ns*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_ns_dV_GP_SI-delta_ns*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_SI_BP = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01+(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_DI_SI = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01+(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_GP_SI = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01+(d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_SI_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_DI_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_SI_BP = (-(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_temp_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_temp_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_temp_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_ns*d_SP_S_xi1_dV_SI_BP+d_delta_ns_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_ns*d_SP_S_xi1_dV_GP_SI+d_delta_ns_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_ns*d_SP_S_xi1_dV_DI_SI+d_delta_ns_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_ns*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_ns_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_ns*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_ns_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_ns*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_ns_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-(delta_ns*d_SP_S_xi2_dV_SI_BP+d_delta_ns_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-(delta_ns*d_SP_S_xi2_dV_GP_SI+d_delta_ns_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-(delta_ns*d_SP_S_xi2_dV_DI_SI+d_delta_ns_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_s_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_s_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}

d_x_d_dV_SI_BP = d_x_s_dV_SI_BP;
d_x_d_dV_GP_SI = d_x_s_dV_GP_SI;
d_x_d_dV_DI_SI = d_x_s_dV_DI_SI;
x_d = x_s;

d_x_m_dV_SI_BP = d_x_s_dV_SI_BP;
d_x_m_dV_GP_SI = d_x_s_dV_GP_SI;
d_x_m_dV_DI_SI = d_x_s_dV_DI_SI;
x_m = x_s;

d_x_ds_dV_DI_SI = d_x_ds_dV_GP_SI = d_x_ds_dV_SI_BP =  0.0;
x_ds = 0.0;

d_Vdsat_lim_dV_SI_BP = 3.912023005*d_phit1_dV_SI_BP;
d_Vdsat_lim_dV_DI_SI = 3.912023005*d_phit1_dV_DI_SI;
d_Vdsat_lim_dV_GP_SI = 3.912023005*d_phit1_dV_GP_SI;
Vdsat_lim = (3.912023005*phit1);
if ((xg<=0.0))
{

d_qis_dV_DI_SI = d_qis_dV_GP_SI = d_qis_dV_SI_BP =  0.0;
qis = 0.0;

d_xgm_dV_SI_BP = (d_xg_dV_SI_BP-d_x_s_dV_SI_BP);
d_xgm_dV_GP_SI = (d_xg_dV_GP_SI-d_x_s_dV_GP_SI);
d_xgm_dV_DI_SI = (d_xg_dV_DI_SI-d_x_s_dV_DI_SI);
xgm = (xg-x_s);

d_Voxm_dV_SI_BP = (xgm*d_phit1_dV_SI_BP+d_xgm_dV_SI_BP*phit1);
d_Voxm_dV_GP_SI = (xgm*d_phit1_dV_GP_SI+d_xgm_dV_GP_SI*phit1);
d_Voxm_dV_DI_SI = (xgm*d_phit1_dV_DI_SI+d_xgm_dV_DI_SI*phit1);
Voxm = (xgm*phit1);

d_qeff1_dV_SI_BP = d_Voxm_dV_SI_BP;
d_qeff1_dV_GP_SI = d_Voxm_dV_GP_SI;
d_qeff1_dV_DI_SI = d_Voxm_dV_DI_SI;
qeff1 = Voxm;

d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
d_Vdsat_dV_GP_SI = d_Vdsat_lim_dV_GP_SI;
Vdsat = Vdsat_lim;

d_Vdse_dV_GP_SI = d_Vdse_dV_SI_BP =  0.0;
d_Vdse_dV_DI_SI = d_Vds_dV_DI_SI;
Vdse = Vds;
}
else
{

d_delta_1s_dV_DI_SI = d_delta_1s_dV_GP_SI = d_delta_1s_dV_SI_BP =  0.0;
delta_1s = 0.0;

d_temp_dV_SI_BP = (-(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_GP_SI = (-(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
d_temp_dV_DI_SI = (-(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));

d_xi0s_dV_SI_BP = ((x_s*x_s)*d_temp_dV_SI_BP+(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)*temp);
d_xi0s_dV_GP_SI = ((x_s*x_s)*d_temp_dV_GP_SI+(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)*temp);
d_xi0s_dV_DI_SI = ((x_s*x_s)*d_temp_dV_DI_SI+(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)*temp);
xi0s = ((x_s*x_s)*temp);

d_xi1s_dV_SI_BP = 4.0*((x_s*temp)*d_temp_dV_SI_BP+(x_s*d_temp_dV_SI_BP+d_x_s_dV_SI_BP*temp)*temp);
d_xi1s_dV_GP_SI = 4.0*((x_s*temp)*d_temp_dV_GP_SI+(x_s*d_temp_dV_GP_SI+d_x_s_dV_GP_SI*temp)*temp);
d_xi1s_dV_DI_SI = 4.0*((x_s*temp)*d_temp_dV_DI_SI+(x_s*d_temp_dV_DI_SI+d_x_s_dV_DI_SI*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));

d_xi2s_dV_SI_BP = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_SI_BP+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_SI_BP+(8.0*d_temp_dV_SI_BP-12.0*d_xi0s_dV_SI_BP)*temp)*temp);
d_xi2s_dV_DI_SI = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_DI_SI+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_DI_SI+(8.0*d_temp_dV_DI_SI-12.0*d_xi0s_dV_DI_SI)*temp)*temp);
d_xi2s_dV_GP_SI = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dV_GP_SI+(((8.0*temp)-(12.0*xi0s))*d_temp_dV_GP_SI+(8.0*d_temp_dV_GP_SI-12.0*d_xi0s_dV_GP_SI)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*(d_x_s_dV_SI_BP));
d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*(d_x_s_dV_GP_SI));
d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*(d_x_s_dV_DI_SI));
delta_1s = value_exp_0;
}

d_Es_dV_SI_BP = (-d_delta_1s_dV_SI_BP/delta_1s/delta_1s);
d_Es_dV_GP_SI = (-d_delta_1s_dV_GP_SI/delta_1s/delta_1s);
d_Es_dV_DI_SI = (-d_delta_1s_dV_DI_SI/delta_1s/delta_1s);
Es = (1.0/delta_1s);

d_delta_1s_dV_SI_BP = (delta_ns*d_delta_1s_dV_SI_BP+d_delta_ns_dV_SI_BP*delta_1s);
d_delta_1s_dV_DI_SI = (delta_ns*d_delta_1s_dV_DI_SI+d_delta_ns_dV_DI_SI*delta_1s);
d_delta_1s_dV_GP_SI = (delta_ns*d_delta_1s_dV_GP_SI+d_delta_ns_dV_GP_SI*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;

d_delta_1s_dV_SI_BP = (deriv_exp_0_d0*((d_x_s_dV_SI_BP-d_xn_s_dV_SI_BP)));
d_delta_1s_dV_GP_SI = (deriv_exp_0_d0*((d_x_s_dV_GP_SI-d_xn_s_dV_GP_SI)));
d_delta_1s_dV_DI_SI = (deriv_exp_0_d0*((d_x_s_dV_DI_SI-d_xn_s_dV_DI_SI)));
delta_1s = value_exp_0;
}

d_Es_dV_SI_BP = ((delta_1s*d_delta_ns_dV_SI_BP-delta_ns*d_delta_1s_dV_SI_BP)/delta_1s/delta_1s);
d_Es_dV_DI_SI = ((delta_1s*d_delta_ns_dV_DI_SI-delta_ns*d_delta_1s_dV_DI_SI)/delta_1s/delta_1s);
d_Es_dV_GP_SI = ((delta_1s*d_delta_ns_dV_GP_SI-delta_ns*d_delta_1s_dV_GP_SI)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{

d_delta_1s_dV_SI_BP = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*3.3333333333333333e-01+(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_SI_BP-d_x_s_dV_SI_BP)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_DI_SI = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*3.3333333333333333e-01+(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_DI_SI-d_x_s_dV_DI_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_delta_1s_dV_GP_SI = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*3.3333333333333333e-01+(d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dV_GP_SI-d_x_s_dV_GP_SI)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Es_dV_SI_BP = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_SI_BP*3.3333333333333333e-01+d_x_s_dV_SI_BP*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_SI_BP*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_GP_SI = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_GP_SI*3.3333333333333333e-01+d_x_s_dV_GP_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_GP_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dV_DI_SI = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dV_DI_SI*3.3333333333333333e-01+d_x_s_dV_DI_SI*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dV_DI_SI*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_Ds_dV_SI_BP = (d_delta_1s_dV_SI_BP-(delta_ns*(d_x_s_dV_SI_BP+d_xi0s_dV_SI_BP)+d_delta_ns_dV_SI_BP*((x_s+1.0)+xi0s)));
d_Ds_dV_GP_SI = (d_delta_1s_dV_GP_SI-(delta_ns*(d_x_s_dV_GP_SI+d_xi0s_dV_GP_SI)+d_delta_ns_dV_GP_SI*((x_s+1.0)+xi0s)));
d_Ds_dV_DI_SI = (d_delta_1s_dV_DI_SI-(delta_ns*(d_x_s_dV_DI_SI+d_xi0s_dV_DI_SI)+d_delta_ns_dV_DI_SI*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{

d_Ps_dV_SI_BP = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_SI_BP)+d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_GP_SI = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_SI)+d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
d_Ps_dV_DI_SI = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_DI_SI)+d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))+(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));

d_Ds_dV_SI_BP = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_SI_BP+(((delta_ns*x_s)*x_s)*d_x_s_dV_SI_BP+((delta_ns*x_s)*d_x_s_dV_SI_BP+(delta_ns*d_x_s_dV_SI_BP+d_delta_ns_dV_SI_BP*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_DI_SI = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_DI_SI+(((delta_ns*x_s)*x_s)*d_x_s_dV_DI_SI+((delta_ns*x_s)*d_x_s_dV_DI_SI+(delta_ns*d_x_s_dV_DI_SI+d_delta_ns_dV_DI_SI*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
d_Ds_dV_GP_SI = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dV_GP_SI+(((delta_ns*x_s)*x_s)*d_x_s_dV_GP_SI+((delta_ns*x_s)*d_x_s_dV_GP_SI+(delta_ns*d_x_s_dV_GP_SI+d_delta_ns_dV_GP_SI*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_SI_BP)+d_x_s_dV_SI_BP*(1.0-(0.25*x_s))))));
d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_GP_SI)+d_x_s_dV_GP_SI*(1.0-(0.25*x_s))))));
d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dV_DI_SI)+d_x_s_dV_DI_SI*(1.0-(0.25*x_s))))));
temp = value_sqrt_0;
}

d_sqm_dV_SI_BP = 7.0710678118654746e-01*(x_s*d_temp_dV_SI_BP+d_x_s_dV_SI_BP*temp);
d_sqm_dV_GP_SI = 7.0710678118654746e-01*(x_s*d_temp_dV_GP_SI+d_x_s_dV_GP_SI*temp);
d_sqm_dV_DI_SI = 7.0710678118654746e-01*(x_s*d_temp_dV_DI_SI+d_x_s_dV_DI_SI*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));

d_alpha_dV_SI_BP = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_SI_BP)+1.6666666666666667e-01*(x_s*d_x_s_dV_SI_BP+d_x_s_dV_SI_BP*x_s))+d_Gf_dV_SI_BP*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_SI_BP)/temp/temp);
d_alpha_dV_GP_SI = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_GP_SI)+1.6666666666666667e-01*(x_s*d_x_s_dV_GP_SI+d_x_s_dV_GP_SI*x_s))+d_Gf_dV_GP_SI*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_GP_SI)/temp/temp);
d_alpha_dV_DI_SI = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dV_DI_SI)+1.6666666666666667e-01*(x_s*d_x_s_dV_DI_SI+d_x_s_dV_DI_SI*x_s))+d_Gf_dV_DI_SI*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dV_DI_SI)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{

d_Ps_dV_SI_BP = (d_x_s_dV_SI_BP+d_Es_dV_SI_BP);
d_Ps_dV_GP_SI = (d_x_s_dV_GP_SI+d_Es_dV_GP_SI);
d_Ps_dV_DI_SI = (d_x_s_dV_DI_SI+d_Es_dV_DI_SI);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Ps_dV_SI_BP));
d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Ps_dV_GP_SI));
d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Ps_dV_DI_SI));
sqm = value_sqrt_0;
}

d_alpha_dV_SI_BP = 0.5*((sqm*(Gf*(-d_Es_dV_SI_BP)+d_Gf_dV_SI_BP*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_SI_BP)/sqm/sqm);
d_alpha_dV_GP_SI = 0.5*((sqm*(Gf*(-d_Es_dV_GP_SI)+d_Gf_dV_GP_SI*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_GP_SI)/sqm/sqm);
d_alpha_dV_DI_SI = 0.5*((sqm*(Gf*(-d_Es_dV_DI_SI)+d_Gf_dV_DI_SI*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dV_DI_SI)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}

d_Em_dV_SI_BP = d_Es_dV_SI_BP;
d_Em_dV_GP_SI = d_Es_dV_GP_SI;
d_Em_dV_DI_SI = d_Es_dV_DI_SI;
Em = Es;

d_Ed_dV_SI_BP = d_Em_dV_SI_BP;
d_Ed_dV_GP_SI = d_Em_dV_GP_SI;
d_Ed_dV_DI_SI = d_Em_dV_DI_SI;
Ed = Em;

d_Dm_dV_SI_BP = d_Ds_dV_SI_BP;
d_Dm_dV_GP_SI = d_Ds_dV_GP_SI;
d_Dm_dV_DI_SI = d_Ds_dV_DI_SI;
Dm = Ds;

d_Dd_dV_SI_BP = d_Dm_dV_SI_BP;
d_Dd_dV_GP_SI = d_Dm_dV_GP_SI;
d_Dd_dV_DI_SI = d_Dm_dV_DI_SI;
Dd = Dm;

d_Rxcor_dV_GP_SI = (((1.0+(XCOR_T*Vsbx))*(0.2*XCOR_T)*d_Vsbx_dV_GP_SI-(1.0+((0.2*XCOR_T)*Vsbx))*XCOR_T*d_Vsbx_dV_GP_SI)/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
d_Rxcor_dV_SI_BP = (((1.0+(XCOR_T*Vsbx))*(0.2*XCOR_T)*d_Vsbx_dV_SI_BP-(1.0+((0.2*XCOR_T)*Vsbx))*XCOR_T*d_Vsbx_dV_SI_BP)/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
d_Rxcor_dV_DI_SI = (((1.0+(XCOR_T*Vsbx))*(0.2*XCOR_T)*d_Vsbx_dV_DI_SI-(1.0+((0.2*XCOR_T)*Vsbx))*XCOR_T*d_Vsbx_dV_DI_SI)/(1.0+(XCOR_T*Vsbx))/(1.0+(XCOR_T*Vsbx)));
Rxcor = ((1.0+((0.2*XCOR_T)*Vsbx))/(1.0+(XCOR_T*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgs_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_SI_BP+d_Ds_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgs_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_GP_SI+d_Ds_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgs_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Ps_dV_DI_SI+d_Ds_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}

d_qis_dV_SI_BP = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_SI_BP+(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_SI_BP+(Gf*d_sqm_dV_SI_BP+d_Gf_dV_SI_BP*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_GP_SI = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_GP_SI+(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_GP_SI+(Gf*d_sqm_dV_GP_SI+d_Gf_dV_GP_SI*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
d_qis_dV_DI_SI = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dV_DI_SI+(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dV_DI_SI+(Gf*d_sqm_dV_DI_SI+d_Gf_dV_DI_SI*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));

d_qbs_dV_SI_BP = ((sqm*Gf)*d_phit1_dV_SI_BP+(sqm*d_Gf_dV_SI_BP+d_sqm_dV_SI_BP*Gf)*phit1);
d_qbs_dV_GP_SI = ((sqm*Gf)*d_phit1_dV_GP_SI+(sqm*d_Gf_dV_GP_SI+d_sqm_dV_GP_SI*Gf)*phit1);
d_qbs_dV_DI_SI = ((sqm*Gf)*d_phit1_dV_DI_SI+(sqm*d_Gf_dV_DI_SI+d_sqm_dV_DI_SI*Gf)*phit1);
qbs = ((sqm*Gf)*phit1);
if ((RSB_i<0.0))
{

d_rhob_dV_GP_SI = (-(-RSB_i*d_Vsbx_dV_GP_SI)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
d_rhob_dV_SI_BP = (-(-RSB_i*d_Vsbx_dV_SI_BP)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
d_rhob_dV_DI_SI = (-(-RSB_i*d_Vsbx_dV_DI_SI)/(1.0-(RSB_i*Vsbx))/(1.0-(RSB_i*Vsbx)));
rhob = (1.0/(1.0-(RSB_i*Vsbx)));
}
else
{

d_rhob_dV_GP_SI = RSB_i*d_Vsbx_dV_GP_SI;
d_rhob_dV_SI_BP = RSB_i*d_Vsbx_dV_SI_BP;
d_rhob_dV_DI_SI = RSB_i*d_Vsbx_dV_DI_SI;
rhob = (1.0+(RSB_i*Vsbx));
}
if ((RSG_i<0.0))
{

d_temp_dV_SI_BP = (-RSG_i*d_qis_dV_SI_BP);
d_temp_dV_GP_SI = (-RSG_i*d_qis_dV_GP_SI);
d_temp_dV_DI_SI = (-RSG_i*d_qis_dV_DI_SI);
temp = (1.0-(RSG_i*qis));
}
else
{

d_temp_dV_SI_BP = (-RSG_i*d_qis_dV_SI_BP/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_GP_SI = (-RSG_i*d_qis_dV_GP_SI/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
d_temp_dV_DI_SI = (-RSG_i*d_qis_dV_DI_SI/(1.0+(RSG_i*qis))/(1.0+(RSG_i*qis)));
temp = (1.0/(1.0+(RSG_i*qis)));
}

d_GR_dV_GP_SI = THER_i*((rhob*temp)*d_qis_dV_GP_SI+(rhob*d_temp_dV_GP_SI+d_rhob_dV_GP_SI*temp)*qis);
d_GR_dV_SI_BP = THER_i*((rhob*temp)*d_qis_dV_SI_BP+(rhob*d_temp_dV_SI_BP+d_rhob_dV_SI_BP*temp)*qis);
d_GR_dV_DI_SI = THER_i*((rhob*temp)*d_qis_dV_DI_SI+(rhob*d_temp_dV_DI_SI+d_rhob_dV_DI_SI*temp)*qis);
GR = (THER_i*((rhob*temp)*qis));

d_Eeffm_dV_SI_BP = E_eff0*(d_qbs_dV_SI_BP+eta_mu*d_qis_dV_SI_BP);
d_Eeffm_dV_GP_SI = E_eff0*(d_qbs_dV_GP_SI+eta_mu*d_qis_dV_GP_SI);
d_Eeffm_dV_DI_SI = E_eff0*(d_qbs_dV_DI_SI+eta_mu*d_qis_dV_DI_SI);
Eeffm = (E_eff0*(qbs+(eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_SI_BP*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_SI_BP-Ps*(d_Ps_dV_SI_BP+d_Ds_dV_SI_BP))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_SI*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_GP_SI-Ps*(d_Ps_dV_GP_SI+d_Ds_dV_GP_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_DI_SI*MUE_T))+CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dV_DI_SI-Ps*(d_Ps_dV_DI_SI+d_Ds_dV_DI_SI))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14)));
Mutmp = (value_pow_0+(CS_T*(Ps/((Ps+Ds)+1.0e-14))));
}

d_Gmob_dV_SI_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP+(d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor);
d_Gmob_dV_GP_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_GP_SI+(d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor);
d_Gmob_dV_DI_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI+(d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((THESATB_i<0.0))
{

d_xitsb_dV_GP_SI = (-(-THESATB_i*d_Vsbx_dV_GP_SI)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
d_xitsb_dV_SI_BP = (-(-THESATB_i*d_Vsbx_dV_SI_BP)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
d_xitsb_dV_DI_SI = (-(-THESATB_i*d_Vsbx_dV_DI_SI)/(1.0-(THESATB_i*Vsbx))/(1.0-(THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(THESATB_i*Vsbx)));
}
else
{

d_xitsb_dV_GP_SI = THESATB_i*d_Vsbx_dV_GP_SI;
d_xitsb_dV_SI_BP = THESATB_i*d_Vsbx_dV_SI_BP;
d_xitsb_dV_DI_SI = THESATB_i*d_Vsbx_dV_DI_SI;
xitsb = (1.0+(THESATB_i*Vsbx));
}

d_temp2_dV_SI_BP = (qis*d_xitsb_dV_SI_BP+d_qis_dV_SI_BP*xitsb);
d_temp2_dV_GP_SI = (qis*d_xitsb_dV_GP_SI+d_qis_dV_GP_SI*xitsb);
d_temp2_dV_DI_SI = (qis*d_xitsb_dV_DI_SI+d_qis_dV_DI_SI*xitsb);
temp2 = (qis*xitsb);

d_wsat_dV_SI_BP = 100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_SI = 100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_DI_SI = 100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((THESATG_i<0.0))
{

d_temp_dV_SI_BP = (-(-THESATG_i*d_wsat_dV_SI_BP)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_GP_SI = (-(-THESATG_i*d_wsat_dV_GP_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_DI_SI = (-(-THESATG_i*d_wsat_dV_DI_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
temp = (1.0/(1.0-(THESATG_i*wsat)));
}
else
{

d_temp_dV_SI_BP = THESATG_i*d_wsat_dV_SI_BP;
d_temp_dV_GP_SI = THESATG_i*d_wsat_dV_GP_SI;
d_temp_dV_DI_SI = THESATG_i*d_wsat_dV_DI_SI;
temp = (1.0+(THESATG_i*wsat));
}

d_thesat1_dV_SI_BP = THESAT_T*((Gmob*d_temp_dV_SI_BP-temp*d_Gmob_dV_SI_BP)/Gmob/Gmob);
d_thesat1_dV_DI_SI = THESAT_T*((Gmob*d_temp_dV_DI_SI-temp*d_Gmob_dV_DI_SI)/Gmob/Gmob);
d_thesat1_dV_GP_SI = THESAT_T*((Gmob*d_temp_dV_GP_SI-temp*d_Gmob_dV_GP_SI)/Gmob/Gmob);
thesat1 = (THESAT_T*(temp/Gmob));

d_phi_inf_dV_SI_BP = (((alpha*d_qis_dV_SI_BP-qis*d_alpha_dV_SI_BP)/alpha/alpha)+d_phit1_dV_SI_BP);
d_phi_inf_dV_GP_SI = (((alpha*d_qis_dV_GP_SI-qis*d_alpha_dV_GP_SI)/alpha/alpha)+d_phit1_dV_GP_SI);
d_phi_inf_dV_DI_SI = (((alpha*d_qis_dV_DI_SI-qis*d_alpha_dV_DI_SI)/alpha/alpha)+d_phit1_dV_DI_SI);
phi_inf = ((qis/alpha)+phit1);

d_ysat_dV_SI_BP = (thesat1*d_phi_inf_dV_SI_BP+d_thesat1_dV_SI_BP*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_DI_SI = (thesat1*d_phi_inf_dV_DI_SI+d_thesat1_dV_DI_SI*phi_inf)*7.0710678118654746e-01;
d_ysat_dV_GP_SI = (thesat1*d_phi_inf_dV_GP_SI+d_thesat1_dV_GP_SI*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if (((model_.CHNL_TYPE)==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ysat_dV_SI_BP = ((value_sqrt_0*d_ysat_dV_SI_BP-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_SI_BP)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_DI_SI = ((value_sqrt_0*d_ysat_dV_DI_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_DI_SI)))/value_sqrt_0/value_sqrt_0);
d_ysat_dV_GP_SI = ((value_sqrt_0*d_ysat_dV_GP_SI-ysat*(deriv_sqrt_0_d0*(d_ysat_dV_GP_SI)))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_za_dV_SI_BP = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_SI_BP))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_DI_SI = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_DI_SI))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
d_za_dV_GP_SI = (-2.0*(deriv_sqrt_0_d0*(4.0*d_ysat_dV_GP_SI))/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}

d_temp1_dV_SI_BP = (za*d_ysat_dV_SI_BP+d_za_dV_SI_BP*ysat);
d_temp1_dV_DI_SI = (za*d_ysat_dV_DI_SI+d_za_dV_DI_SI*ysat);
d_temp1_dV_GP_SI = (za*d_ysat_dV_GP_SI+d_za_dV_GP_SI*ysat);
temp1 = (za*ysat);

d_Phi_0_dV_SI_BP = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_SI_BP+d_temp1_dV_SI_BP*za))+d_temp1_dV_SI_BP*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_SI_BP+(temp1*d_temp1_dV_SI_BP+d_temp1_dV_SI_BP*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_SI_BP+d_phi_inf_dV_SI_BP*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_GP_SI = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_GP_SI+d_temp1_dV_GP_SI*za))+d_temp1_dV_GP_SI*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_GP_SI+(temp1*d_temp1_dV_GP_SI+d_temp1_dV_GP_SI*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_GP_SI+d_phi_inf_dV_GP_SI*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_Phi_0_dV_DI_SI = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dV_DI_SI+d_temp1_dV_DI_SI*za))+d_temp1_dV_DI_SI*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dV_DI_SI+(temp1*d_temp1_dV_DI_SI+d_temp1_dV_DI_SI*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dV_DI_SI+d_phi_inf_dV_DI_SI*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));

d_asat_dV_SI_BP = (d_xgs_dV_SI_BP+0.5*d_Gf2_dV_SI_BP);
d_asat_dV_GP_SI = (d_xgs_dV_GP_SI+0.5*d_Gf2_dV_GP_SI);
d_asat_dV_DI_SI = (d_xgs_dV_DI_SI+0.5*d_Gf2_dV_DI_SI);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_2_dV_SI_BP = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_SI_BP+(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_SI_BP+(deriv_sqrt_0_d0*(((asat*d_asat_dV_SI_BP+d_asat_dV_SI_BP*asat)-(Gf2*d_Ds_dV_SI_BP+d_Gf2_dV_SI_BP*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_GP_SI = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_GP_SI+(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_GP_SI+(deriv_sqrt_0_d0*(((asat*d_asat_dV_GP_SI+d_asat_dV_GP_SI*asat)-(Gf2*d_Ds_dV_GP_SI+d_Gf2_dV_GP_SI*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
d_Phi_2_dV_DI_SI = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dV_DI_SI+(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dV_DI_SI+(deriv_sqrt_0_d0*(((asat*d_asat_dV_DI_SI+d_asat_dV_DI_SI*asat)-(Gf2*d_Ds_dV_DI_SI+d_Gf2_dV_DI_SI*Ds)*0.98)))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
}

d_Phi_0_2_dV_SI_BP = (d_Phi_0_dV_SI_BP+d_Phi_2_dV_SI_BP);
d_Phi_0_2_dV_GP_SI = (d_Phi_0_dV_GP_SI+d_Phi_2_dV_GP_SI);
d_Phi_0_2_dV_DI_SI = (d_Phi_0_dV_DI_SI+d_Phi_2_dV_DI_SI);
Phi_0_2 = (Phi_0+Phi_2);

d_Phi0_Phi2_dV_SI_BP = 2.0*(Phi_0*d_Phi_2_dV_SI_BP+d_Phi_0_dV_SI_BP*Phi_2);
d_Phi0_Phi2_dV_GP_SI = 2.0*(Phi_0*d_Phi_2_dV_GP_SI+d_Phi_0_dV_GP_SI*Phi_2);
d_Phi0_Phi2_dV_DI_SI = 2.0*(Phi_0*d_Phi_2_dV_DI_SI+d_Phi_0_dV_DI_SI*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Phi_sat_dV_SI_BP = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_SI_BP-Phi0_Phi2*(d_Phi_0_2_dV_SI_BP+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_SI_BP+d_Phi_0_2_dV_SI_BP*Phi_0_2)-1.98*d_Phi0_Phi2_dV_SI_BP)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_GP_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_GP_SI-Phi0_Phi2*(d_Phi_0_2_dV_GP_SI+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_GP_SI+d_Phi_0_2_dV_GP_SI*Phi_0_2)-1.98*d_Phi0_Phi2_dV_GP_SI)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
d_Phi_sat_dV_DI_SI = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dV_DI_SI-Phi0_Phi2*(d_Phi_0_2_dV_DI_SI+(deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dV_DI_SI+d_Phi_0_2_dV_DI_SI*Phi_0_2)-1.98*d_Phi0_Phi2_dV_DI_SI)))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));

d_Vdsat_dV_SI_BP = (d_Phi_sat_dV_SI_BP-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_SI_BP+(Phi_sat*(d_Phi_sat_dV_SI_BP-((2.0*asat)*d_phit1_dV_SI_BP+2.0*d_asat_dV_SI_BP*phit1))+d_Phi_sat_dV_SI_BP*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_SI_BP+(phit1*d_phit1_dV_SI_BP+d_phit1_dV_SI_BP*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_SI_BP*value_log_0));
d_Vdsat_dV_GP_SI = (d_Phi_sat_dV_GP_SI-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_GP_SI+(Phi_sat*(d_Phi_sat_dV_GP_SI-((2.0*asat)*d_phit1_dV_GP_SI+2.0*d_asat_dV_GP_SI*phit1))+d_Phi_sat_dV_GP_SI*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_GP_SI+(phit1*d_phit1_dV_GP_SI+d_phit1_dV_GP_SI*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_GP_SI*value_log_0));
d_Vdsat_dV_DI_SI = (d_Phi_sat_dV_DI_SI-(phit1*(deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dV_DI_SI+(Phi_sat*(d_Phi_sat_dV_DI_SI-((2.0*asat)*d_phit1_dV_DI_SI+2.0*d_asat_dV_DI_SI*phit1))+d_Phi_sat_dV_DI_SI*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dV_DI_SI+(phit1*d_phit1_dV_DI_SI+d_phit1_dV_DI_SI*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds))))+d_phit1_dV_DI_SI*value_log_0));
Vdsat = (Phi_sat-(phit1*value_log_0));
}
}
else
{

d_Vdsat_dV_SI_BP = d_Vdsat_lim_dV_SI_BP;
d_Vdsat_dV_DI_SI = d_Vdsat_lim_dV_DI_SI;
d_Vdsat_dV_GP_SI = d_Vdsat_lim_dV_GP_SI;
Vdsat = Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*AX_i/(Vds/Vdsat)));

d_temp_dV_SI_BP = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_SI_BP/Vdsat/Vdsat)));
d_temp_dV_GP_SI = (deriv_pow_0_d0*((-Vds*d_Vdsat_dV_GP_SI/Vdsat/Vdsat)));
d_temp_dV_DI_SI = (deriv_pow_0_d0*(((Vdsat*d_Vds_dV_DI_SI-Vds*d_Vdsat_dV_DI_SI)/Vdsat/Vdsat)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-inv_AX)/(1.0+temp)));

d_Vdse_dV_SI_BP = Vds*(deriv_pow_0_d0*(d_temp_dV_SI_BP));
d_Vdse_dV_GP_SI = Vds*(deriv_pow_0_d0*(d_temp_dV_GP_SI));
d_Vdse_dV_DI_SI = (Vds*(deriv_pow_0_d0*(d_temp_dV_DI_SI))+d_Vds_dV_DI_SI*value_pow_0);
Vdse = (Vds*value_pow_0);
}

d_Udse_dV_DI_SI = (Vdse*d_inv_phit1_dV_DI_SI+d_Vdse_dV_DI_SI*inv_phit1);
d_Udse_dV_SI_BP = (Vdse*d_inv_phit1_dV_SI_BP+d_Vdse_dV_SI_BP*inv_phit1);
d_Udse_dV_GP_SI = (Vdse*d_inv_phit1_dV_GP_SI+d_Vdse_dV_GP_SI*inv_phit1);
Udse = (Vdse*inv_phit1);

d_xn_d_dV_SI_BP = (d_xn_s_dV_SI_BP+d_Udse_dV_SI_BP);
d_xn_d_dV_DI_SI = (d_xn_s_dV_DI_SI+d_Udse_dV_DI_SI);
d_xn_d_dV_GP_SI = (d_xn_s_dV_GP_SI+d_Udse_dV_GP_SI);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;

d_k_ds_dV_DI_SI = (deriv_exp_0_d0*((-d_Udse_dV_DI_SI)));
d_k_ds_dV_SI_BP = (deriv_exp_0_d0*((-d_Udse_dV_SI_BP)));
d_k_ds_dV_GP_SI = (deriv_exp_0_d0*((-d_Udse_dV_GP_SI)));
k_ds = value_exp_0;
}
}
else
{

d_k_ds_dV_DI_SI = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_DI_SI*3.3333333333333333e-01+d_Udse_dV_DI_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_DI_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_SI_BP = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_SI_BP*3.3333333333333333e-01+d_Udse_dV_SI_BP*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_SI_BP*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
d_k_ds_dV_GP_SI = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dV_GP_SI*3.3333333333333333e-01+d_Udse_dV_GP_SI*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dV_GP_SI*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}

d_delta_nd_dV_SI_BP = (delta_ns*d_k_ds_dV_SI_BP+d_delta_ns_dV_SI_BP*k_ds);
d_delta_nd_dV_DI_SI = (delta_ns*d_k_ds_dV_DI_SI+d_delta_ns_dV_DI_SI*k_ds);
d_delta_nd_dV_GP_SI = (delta_ns*d_k_ds_dV_GP_SI+d_delta_ns_dV_GP_SI*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{

d_SP_S_temp1_dV_SI_BP = (inv_xi*d_inv_xi_dV_SI_BP+d_inv_xi_dV_SI_BP*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_GP_SI = (inv_xi*d_inv_xi_dV_GP_SI+d_inv_xi_dV_GP_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
d_SP_S_temp1_dV_DI_SI = (inv_xi*d_inv_xi_dV_DI_SI+d_inv_xi_dV_DI_SI*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);

d_x_d_dV_SI_BP = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_SI_BP+((xg*(1.0-delta_nd))*d_Gf_dV_SI_BP+(xg*(-d_delta_nd_dV_SI_BP)+d_xg_dV_SI_BP*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_SI_BP+d_xg_dV_SI_BP*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_GP_SI = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_GP_SI+((xg*(1.0-delta_nd))*d_Gf_dV_GP_SI+(xg*(-d_delta_nd_dV_GP_SI)+d_xg_dV_GP_SI*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_GP_SI+d_xg_dV_GP_SI*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
d_x_d_dV_DI_SI = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dV_DI_SI+((xg*(1.0-delta_nd))*d_Gf_dV_DI_SI+(xg*(-d_delta_nd_dV_DI_SI)+d_xg_dV_DI_SI*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dV_DI_SI+d_xg_dV_DI_SI*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{

d_SP_S_bx_dV_SI_BP = d_xn_d_dV_SI_BP;
d_SP_S_bx_dV_DI_SI = d_xn_d_dV_DI_SI;
d_SP_S_bx_dV_GP_SI = d_xn_d_dV_GP_SI;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_SP_S_eta_dV_SI_BP = (0.5*((d_SP_S_x1_dV_SI_BP+d_SP_S_bx_dV_SI_BP)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)+(d_SP_S_x1_dV_SI_BP-d_SP_S_bx_dV_SI_BP)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_SI_BP-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_SI_BP+d_SP_S_bx_dV_SI_BP*SP_S_bx)))));
d_SP_S_eta_dV_GP_SI = (0.5*((d_SP_S_x1_dV_GP_SI+d_SP_S_bx_dV_GP_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)+(d_SP_S_x1_dV_GP_SI-d_SP_S_bx_dV_GP_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_GP_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_GP_SI+d_SP_S_bx_dV_GP_SI*SP_S_bx)))));
d_SP_S_eta_dV_DI_SI = (0.5*((d_SP_S_x1_dV_DI_SI+d_SP_S_bx_dV_DI_SI)-(deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)+(d_SP_S_x1_dV_DI_SI-d_SP_S_bx_dV_DI_SI)*(SP_S_x1-SP_S_bx)))))-0.5*(d_SP_S_bx_dV_DI_SI-(deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dV_DI_SI+d_SP_S_bx_dV_DI_SI*SP_S_bx)))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_eta_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_eta_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_eta_dV_DI_SI);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_temp1_dV_SI_BP = (deriv_exp_0_d0*((-d_SP_S_eta_dV_SI_BP)));
d_SP_S_temp1_dV_GP_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_GP_SI)));
d_SP_S_temp1_dV_DI_SI = (deriv_exp_0_d0*((-d_SP_S_eta_dV_DI_SI)));
SP_S_temp1 = value_exp_0;
}

d_SP_S_temp2_dV_SI_BP = (-(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_GP_SI = (-(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_temp2_dV_DI_SI = (-(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_eta_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_GP_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_eta_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_eta)*SP_S_temp2);
d_SP_S_xi0_dV_DI_SI = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_eta_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(SP_S_eta*d_SP_S_temp2_dV_SI_BP+d_SP_S_eta_dV_SI_BP*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(SP_S_eta*d_SP_S_temp2_dV_GP_SI+d_SP_S_eta_dV_GP_SI*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(SP_S_eta*d_SP_S_temp2_dV_DI_SI+d_SP_S_eta_dV_DI_SI*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_SI_BP+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_SI_BP+(8.0*d_SP_S_temp2_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_GP_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_GP_SI+(8.0*d_SP_S_temp2_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp2)*SP_S_temp2);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dV_DI_SI+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dV_DI_SI+(8.0*d_SP_S_temp2_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);

d_SP_S_a_dV_SI_BP = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_SI_BP+d_SP_S_eta_dV_SI_BP)-(delta_nd*(d_SP_S_eta_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_nd_dV_SI_BP*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_GP_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_GP_SI+d_SP_S_eta_dV_GP_SI)-(delta_nd*(d_SP_S_eta_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_nd_dV_GP_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
d_SP_S_a_dV_DI_SI = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*((d_SP_S_temp1_dV_DI_SI+d_SP_S_eta_dV_DI_SI)-(delta_nd*(d_SP_S_eta_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_nd_dV_DI_SI*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}

d_SP_S_b_dV_SI_BP = (-0.5*(Gf2*(d_SP_S_temp1_dV_SI_BP-(delta_nd*d_SP_S_xi2_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_GP_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_GP_SI-(delta_nd*d_SP_S_xi2_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))));
d_SP_S_b_dV_DI_SI = (-0.5*(Gf2*(d_SP_S_temp1_dV_DI_SI-(delta_nd*d_SP_S_xi2_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));

d_SP_S_c_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*((-d_SP_S_temp1_dV_SI_BP)-(delta_nd*d_SP_S_xi1_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*((-d_SP_S_temp1_dV_GP_SI)-(delta_nd*d_SP_S_xi1_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_c_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*((-d_SP_S_temp1_dV_DI_SI)-(delta_nd*d_SP_S_xi1_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));

d_SP_S_tau_dV_SI_BP = ((d_xn_d_dV_SI_BP-d_SP_S_eta_dV_SI_BP)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_SI_BP-SP_S_a*d_Gf2_dV_SI_BP)/Gf2/Gf2))));
d_SP_S_tau_dV_DI_SI = ((d_xn_d_dV_DI_SI-d_SP_S_eta_dV_DI_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_DI_SI-SP_S_a*d_Gf2_dV_DI_SI)/Gf2/Gf2))));
d_SP_S_tau_dV_GP_SI = ((d_xn_d_dV_GP_SI-d_SP_S_eta_dV_GP_SI)+(deriv_log_0_d0*(((Gf2*d_SP_S_a_dV_GP_SI-SP_S_a*d_Gf2_dV_GP_SI)/Gf2/Gf2))));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}

d_nu_dV_SI_BP = (d_SP_S_a_dV_SI_BP+d_SP_S_c_dV_SI_BP);
d_nu_dV_GP_SI = (d_SP_S_a_dV_GP_SI+d_SP_S_c_dV_GP_SI);
d_nu_dV_DI_SI = (d_SP_S_a_dV_DI_SI+d_SP_S_c_dV_DI_SI);
nu = (SP_S_a+SP_S_c);

d_mutau_dV_SI_BP = ((nu*d_nu_dV_SI_BP+d_nu_dV_SI_BP*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+d_SP_S_tau_dV_SI_BP*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_GP_SI = ((nu*d_nu_dV_GP_SI+d_nu_dV_GP_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+d_SP_S_tau_dV_GP_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_mutau_dV_DI_SI = ((nu*d_nu_dV_DI_SI+d_nu_dV_DI_SI*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+d_SP_S_tau_dV_DI_SI*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));

d_SP_S_x0_dV_SI_BP = (d_SP_S_eta_dV_SI_BP+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_SI_BP+(SP_S_a*d_nu_dV_SI_BP+d_SP_S_a_dV_SI_BP*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_SI_BP+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_SI_BP+d_SP_S_c_dV_SI_BP*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_SI_BP+d_SP_S_a_dV_SI_BP*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_SI_BP+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_SI_BP+((nu/mutau)*d_SP_S_tau_dV_SI_BP+((mutau*d_nu_dV_SI_BP-nu*d_mutau_dV_SI_BP)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_GP_SI = (d_SP_S_eta_dV_GP_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_GP_SI+(SP_S_a*d_nu_dV_GP_SI+d_SP_S_a_dV_GP_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_GP_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_GP_SI+d_SP_S_c_dV_GP_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_GP_SI+d_SP_S_a_dV_GP_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_GP_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_GP_SI+((nu/mutau)*d_SP_S_tau_dV_GP_SI+((mutau*d_nu_dV_GP_SI-nu*d_mutau_dV_GP_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
d_SP_S_x0_dV_DI_SI = (d_SP_S_eta_dV_DI_SI+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dV_DI_SI+(SP_S_a*d_nu_dV_DI_SI+d_SP_S_a_dV_DI_SI*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dV_DI_SI+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dV_DI_SI+d_SP_S_c_dV_DI_SI*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dV_DI_SI+d_SP_S_a_dV_DI_SI*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dV_DI_SI+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dV_DI_SI+((nu/mutau)*d_SP_S_tau_dV_DI_SI+((mutau*d_nu_dV_DI_SI-nu*d_mutau_dV_DI_SI)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*(d_SP_S_x0_dV_SI_BP));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_GP_SI));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*(d_SP_S_x0_dV_DI_SI));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = (-d_SP_S_delta0_dV_SI_BP/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = (-d_SP_S_delta0_dV_GP_SI/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = (-d_SP_S_delta0_dV_DI_SI/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);

d_SP_S_delta0_dV_SI_BP = (delta_nd*d_SP_S_delta0_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_delta0);
d_SP_S_delta0_dV_DI_SI = (delta_nd*d_SP_S_delta0_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_delta0);
d_SP_S_delta0_dV_GP_SI = (delta_nd*d_SP_S_delta0_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_SP_S_delta0_dV_SI_BP = (deriv_exp_0_d0*((d_SP_S_x0_dV_SI_BP-d_xn_d_dV_SI_BP)));
d_SP_S_delta0_dV_GP_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_GP_SI-d_xn_d_dV_GP_SI)));
d_SP_S_delta0_dV_DI_SI = (deriv_exp_0_d0*((d_SP_S_x0_dV_DI_SI-d_xn_d_dV_DI_SI)));
SP_S_delta0 = value_exp_0;
}

d_SP_S_delta1_dV_SI_BP = ((SP_S_delta0*d_delta_nd_dV_SI_BP-delta_nd*d_SP_S_delta0_dV_SI_BP)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_DI_SI = ((SP_S_delta0*d_delta_nd_dV_DI_SI-delta_nd*d_SP_S_delta0_dV_DI_SI)/SP_S_delta0/SP_S_delta0);
d_SP_S_delta1_dV_GP_SI = ((SP_S_delta0*d_delta_nd_dV_GP_SI-delta_nd*d_SP_S_delta0_dV_GP_SI)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{

d_SP_S_delta0_dV_SI_BP = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*3.3333333333333333e-01+(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_SI_BP-d_SP_S_x0_dV_SI_BP)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_DI_SI = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*3.3333333333333333e-01+(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_DI_SI-d_SP_S_x0_dV_DI_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta0_dV_GP_SI = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*3.3333333333333333e-01+(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_SI-d_SP_S_x0_dV_GP_SI)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_SP_S_delta1_dV_SI_BP = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_SI_BP*3.3333333333333333e-01+d_SP_S_x0_dV_SI_BP*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_SI_BP*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_GP_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_GP_SI*3.3333333333333333e-01+d_SP_S_x0_dV_GP_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_GP_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dV_DI_SI = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dV_DI_SI*3.3333333333333333e-01+d_SP_S_x0_dV_DI_SI*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dV_DI_SI*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_SP_S_temp_dV_SI_BP = (-(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_GP_SI = (-(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_temp_dV_DI_SI = (-(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));

d_SP_S_xi0_dV_SI_BP = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_x0_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_GP_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_x0_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_x0)*SP_S_temp);
d_SP_S_xi0_dV_DI_SI = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_x0_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);

d_SP_S_xi1_dV_SI_BP = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(SP_S_x0*d_SP_S_temp_dV_SI_BP+d_SP_S_x0_dV_SI_BP*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_GP_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(SP_S_x0*d_SP_S_temp_dV_GP_SI+d_SP_S_x0_dV_GP_SI*SP_S_temp)*SP_S_temp);
d_SP_S_xi1_dV_DI_SI = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(SP_S_x0*d_SP_S_temp_dV_DI_SI+d_SP_S_x0_dV_DI_SI*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));

d_SP_S_xi2_dV_SI_BP = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_SI_BP+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_SI_BP+(8.0*d_SP_S_temp_dV_SI_BP-12.0*d_SP_S_xi0_dV_SI_BP)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_GP_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_GP_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_GP_SI+(8.0*d_SP_S_temp_dV_GP_SI-12.0*d_SP_S_xi0_dV_GP_SI)*SP_S_temp)*SP_S_temp);
d_SP_S_xi2_dV_DI_SI = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dV_DI_SI+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dV_DI_SI+(8.0*d_SP_S_temp_dV_DI_SI-12.0*d_SP_S_xi0_dV_DI_SI)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);

d_SP_S_temp_dV_SI_BP = (d_xg_dV_SI_BP-d_SP_S_x0_dV_SI_BP);
d_SP_S_temp_dV_GP_SI = (d_xg_dV_GP_SI-d_SP_S_x0_dV_GP_SI);
d_SP_S_temp_dV_DI_SI = (d_xg_dV_DI_SI-d_SP_S_x0_dV_DI_SI);
SP_S_temp = (xg-SP_S_x0);

d_SP_S_pC_dV_SI_BP = (2.0*d_SP_S_temp_dV_SI_BP+(Gf2*(((-d_SP_S_delta1_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_nd*d_SP_S_xi1_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+SP_S_xi1)))+d_Gf2_dV_SI_BP*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_GP_SI = (2.0*d_SP_S_temp_dV_GP_SI+(Gf2*(((-d_SP_S_delta1_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_nd*d_SP_S_xi1_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_GP_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_pC_dV_DI_SI = (2.0*d_SP_S_temp_dV_DI_SI+(Gf2*(((-d_SP_S_delta1_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_nd*d_SP_S_xi1_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+SP_S_xi1)))+d_Gf2_dV_DI_SI*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));

d_SP_S_qC_dV_SI_BP = ((SP_S_temp*d_SP_S_temp_dV_SI_BP+d_SP_S_temp_dV_SI_BP*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_SI_BP+d_SP_S_x0_dV_SI_BP)+d_SP_S_delta0_dV_SI_BP)-(delta_nd*(d_SP_S_x0_dV_SI_BP+d_SP_S_xi0_dV_SI_BP)+d_delta_nd_dV_SI_BP*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_SI_BP*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_GP_SI = ((SP_S_temp*d_SP_S_temp_dV_GP_SI+d_SP_S_temp_dV_GP_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_GP_SI+d_SP_S_x0_dV_GP_SI)+d_SP_S_delta0_dV_GP_SI)-(delta_nd*(d_SP_S_x0_dV_GP_SI+d_SP_S_xi0_dV_GP_SI)+d_delta_nd_dV_GP_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_GP_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_qC_dV_DI_SI = ((SP_S_temp*d_SP_S_temp_dV_DI_SI+d_SP_S_temp_dV_DI_SI*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dV_DI_SI+d_SP_S_x0_dV_DI_SI)+d_SP_S_delta0_dV_DI_SI)-(delta_nd*(d_SP_S_x0_dV_DI_SI+d_SP_S_xi0_dV_DI_SI)+d_delta_nd_dV_DI_SI*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dV_DI_SI*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));

d_SP_S_temp_dV_SI_BP = (-(Gf2*((d_SP_S_delta1_dV_SI_BP+d_SP_S_delta0_dV_SI_BP)-(delta_nd*d_SP_S_xi2_dV_SI_BP+d_delta_nd_dV_SI_BP*SP_S_xi2))+d_Gf2_dV_SI_BP*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_GP_SI = (-(Gf2*((d_SP_S_delta1_dV_GP_SI+d_SP_S_delta0_dV_GP_SI)-(delta_nd*d_SP_S_xi2_dV_GP_SI+d_delta_nd_dV_GP_SI*SP_S_xi2))+d_Gf2_dV_GP_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dV_DI_SI = (-(Gf2*((d_SP_S_delta1_dV_DI_SI+d_SP_S_delta0_dV_DI_SI)-(delta_nd*d_SP_S_xi2_dV_DI_SI+d_delta_nd_dV_DI_SI*SP_S_xi2))+d_Gf2_dV_DI_SI*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));

d_SP_S_temp_dV_SI_BP = ((SP_S_pC*d_SP_S_pC_dV_SI_BP+d_SP_S_pC_dV_SI_BP*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_SI_BP+d_SP_S_qC_dV_SI_BP*SP_S_temp));
d_SP_S_temp_dV_GP_SI = ((SP_S_pC*d_SP_S_pC_dV_GP_SI+d_SP_S_pC_dV_GP_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_GP_SI+d_SP_S_qC_dV_GP_SI*SP_S_temp));
d_SP_S_temp_dV_DI_SI = ((SP_S_pC*d_SP_S_pC_dV_DI_SI+d_SP_S_pC_dV_DI_SI*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dV_DI_SI+d_SP_S_qC_dV_DI_SI*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_d_dV_SI_BP = (d_SP_S_x0_dV_SI_BP+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_SI_BP-SP_S_qC*(d_SP_S_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_SI_BP))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_GP_SI = (d_SP_S_x0_dV_GP_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_GP_SI-SP_S_qC*(d_SP_S_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_GP_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
d_x_d_dV_DI_SI = (d_SP_S_x0_dV_DI_SI+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dV_DI_SI-SP_S_qC*(d_SP_S_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_SP_S_temp_dV_DI_SI))))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}

d_x_ds_dV_SI_BP = (d_x_d_dV_SI_BP-d_x_s_dV_SI_BP);
d_x_ds_dV_GP_SI = (d_x_d_dV_GP_SI-d_x_s_dV_GP_SI);
d_x_ds_dV_DI_SI = (d_x_d_dV_DI_SI-d_x_s_dV_DI_SI);
x_ds = (x_d-x_s);
if ((x_ds<1.0e-10))
{

d_pC_dV_SI_BP = (2.0*(d_xg_dV_SI_BP-d_x_s_dV_SI_BP)+(Gf2*(((-d_Es_dV_SI_BP)+(delta_1s*d_k_ds_dV_SI_BP+d_delta_1s_dV_SI_BP*k_ds))-(delta_nd*d_xi1s_dV_SI_BP+d_delta_nd_dV_SI_BP*(1.0+xi1s)))+d_Gf2_dV_SI_BP*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_GP_SI = (2.0*(d_xg_dV_GP_SI-d_x_s_dV_GP_SI)+(Gf2*(((-d_Es_dV_GP_SI)+(delta_1s*d_k_ds_dV_GP_SI+d_delta_1s_dV_GP_SI*k_ds))-(delta_nd*d_xi1s_dV_GP_SI+d_delta_nd_dV_GP_SI*(1.0+xi1s)))+d_Gf2_dV_GP_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_pC_dV_DI_SI = (2.0*(d_xg_dV_DI_SI-d_x_s_dV_DI_SI)+(Gf2*(((-d_Es_dV_DI_SI)+(delta_1s*d_k_ds_dV_DI_SI+d_delta_1s_dV_DI_SI*k_ds))-(delta_nd*d_xi1s_dV_DI_SI+d_delta_nd_dV_DI_SI*(1.0+xi1s)))+d_Gf2_dV_DI_SI*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));

d_qC_dV_SI_BP = ((Gf2*(1.0-k_ds))*d_Ds_dV_SI_BP+(Gf2*(-d_k_ds_dV_SI_BP)+d_Gf2_dV_SI_BP*(1.0-k_ds))*Ds);
d_qC_dV_GP_SI = ((Gf2*(1.0-k_ds))*d_Ds_dV_GP_SI+(Gf2*(-d_k_ds_dV_GP_SI)+d_Gf2_dV_GP_SI*(1.0-k_ds))*Ds);
d_qC_dV_DI_SI = ((Gf2*(1.0-k_ds))*d_Ds_dV_DI_SI+(Gf2*(-d_k_ds_dV_DI_SI)+d_Gf2_dV_DI_SI*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);

d_temp_dV_SI_BP = (-(Gf2*((d_Es_dV_SI_BP+(delta_1s*d_k_ds_dV_SI_BP+d_delta_1s_dV_SI_BP*k_ds))-(delta_nd*d_xi2s_dV_SI_BP+d_delta_nd_dV_SI_BP*xi2s))+d_Gf2_dV_SI_BP*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_GP_SI = (-(Gf2*((d_Es_dV_GP_SI+(delta_1s*d_k_ds_dV_GP_SI+d_delta_1s_dV_GP_SI*k_ds))-(delta_nd*d_xi2s_dV_GP_SI+d_delta_nd_dV_GP_SI*xi2s))+d_Gf2_dV_GP_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dV_DI_SI = (-(Gf2*((d_Es_dV_DI_SI+(delta_1s*d_k_ds_dV_DI_SI+d_delta_1s_dV_DI_SI*k_ds))-(delta_nd*d_xi2s_dV_DI_SI+d_delta_nd_dV_DI_SI*xi2s))+d_Gf2_dV_DI_SI*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));

d_temp_dV_SI_BP = ((pC*d_pC_dV_SI_BP+d_pC_dV_SI_BP*pC)-2.0*(temp*d_qC_dV_SI_BP+d_temp_dV_SI_BP*qC));
d_temp_dV_GP_SI = ((pC*d_pC_dV_GP_SI+d_pC_dV_GP_SI*pC)-2.0*(temp*d_qC_dV_GP_SI+d_temp_dV_GP_SI*qC));
d_temp_dV_DI_SI = ((pC*d_pC_dV_DI_SI+d_pC_dV_DI_SI*pC)-2.0*(temp*d_qC_dV_DI_SI+d_temp_dV_DI_SI*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_x_ds_dV_SI_BP = 2.0*(((pC+value_sqrt_0)*d_qC_dV_SI_BP-qC*(d_pC_dV_SI_BP+(deriv_sqrt_0_d0*(d_temp_dV_SI_BP))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_GP_SI = 2.0*(((pC+value_sqrt_0)*d_qC_dV_GP_SI-qC*(d_pC_dV_GP_SI+(deriv_sqrt_0_d0*(d_temp_dV_GP_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
d_x_ds_dV_DI_SI = 2.0*(((pC+value_sqrt_0)*d_qC_dV_DI_SI-qC*(d_pC_dV_DI_SI+(deriv_sqrt_0_d0*(d_temp_dV_DI_SI))))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}

d_x_d_dV_SI_BP = (d_x_s_dV_SI_BP+d_x_ds_dV_SI_BP);
d_x_d_dV_GP_SI = (d_x_s_dV_GP_SI+d_x_ds_dV_GP_SI);
d_x_d_dV_DI_SI = (d_x_s_dV_DI_SI+d_x_ds_dV_DI_SI);
x_d = (x_s+x_ds);
}

d_dps_dV_SI_BP = (x_ds*d_phit1_dV_SI_BP+d_x_ds_dV_SI_BP*phit1);
d_dps_dV_GP_SI = (x_ds*d_phit1_dV_GP_SI+d_x_ds_dV_GP_SI*phit1);
d_dps_dV_DI_SI = (x_ds*d_phit1_dV_DI_SI+d_x_ds_dV_DI_SI*phit1);
dps = (x_ds*phit1);

d_xi0d_dV_SI_BP = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_SI_BP+d_x_d_dV_SI_BP*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_SI_BP+d_x_d_dV_SI_BP*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_GP_SI = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_GP_SI+d_x_d_dV_GP_SI*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_GP_SI+d_x_d_dV_GP_SI*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
d_xi0d_dV_DI_SI = (((2.0+(x_d*x_d))*(x_d*d_x_d_dV_DI_SI+d_x_d_dV_DI_SI*x_d)-(x_d*x_d)*(x_d*d_x_d_dV_DI_SI+d_x_d_dV_DI_SI*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;

d_Ed_dV_SI_BP = (deriv_exp_0_d0*((-d_x_d_dV_SI_BP)));
d_Ed_dV_GP_SI = (deriv_exp_0_d0*((-d_x_d_dV_GP_SI)));
d_Ed_dV_DI_SI = (deriv_exp_0_d0*((-d_x_d_dV_DI_SI)));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{

d_Dd_dV_SI_BP = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_SI_BP+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_SI_BP+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_SI_BP+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_SI_BP+1.6666666666666667e-01*d_delta_nd_dV_SI_BP*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_DI_SI = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_DI_SI+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_DI_SI+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_DI_SI+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_DI_SI+1.6666666666666667e-01*d_delta_nd_dV_DI_SI*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
d_Dd_dV_GP_SI = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dV_GP_SI+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dV_GP_SI+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dV_GP_SI+((1.6666666666666667e-01*delta_nd)*d_x_d_dV_GP_SI+1.6666666666666667e-01*d_delta_nd_dV_GP_SI*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{

d_Dd_dV_SI_BP = (delta_nd*(((-d_Ed_dV_SI_BP/Ed/Ed)-d_x_d_dV_SI_BP)-d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_DI_SI = (delta_nd*(((-d_Ed_dV_DI_SI/Ed/Ed)-d_x_d_dV_DI_SI)-d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((((1.0/Ed)-x_d)-1.0)-xi0d));
d_Dd_dV_GP_SI = (delta_nd*(((-d_Ed_dV_GP_SI/Ed/Ed)-d_x_d_dV_GP_SI)-d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;

d_temp_dV_SI_BP = (deriv_exp_0_d0*((d_x_d_dV_SI_BP-d_xn_d_dV_SI_BP)));
d_temp_dV_GP_SI = (deriv_exp_0_d0*((d_x_d_dV_GP_SI-d_xn_d_dV_GP_SI)));
d_temp_dV_DI_SI = (deriv_exp_0_d0*((d_x_d_dV_DI_SI-d_xn_d_dV_DI_SI)));
temp = value_exp_0;
}

d_Ed_dV_SI_BP = ((temp*d_delta_nd_dV_SI_BP-delta_nd*d_temp_dV_SI_BP)/temp/temp);
d_Ed_dV_DI_SI = ((temp*d_delta_nd_dV_DI_SI-delta_nd*d_temp_dV_DI_SI)/temp/temp);
d_Ed_dV_GP_SI = ((temp*d_delta_nd_dV_GP_SI-delta_nd*d_temp_dV_GP_SI)/temp/temp);
Ed = (delta_nd/temp);

d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-(delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-(delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-(delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{

d_Ed_dV_SI_BP = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_SI_BP*3.3333333333333333e-01+d_x_d_dV_SI_BP*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_SI_BP*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_GP_SI = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_GP_SI*3.3333333333333333e-01+d_x_d_dV_GP_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_GP_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Ed_dV_DI_SI = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dV_DI_SI*3.3333333333333333e-01+d_x_d_dV_DI_SI*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dV_DI_SI*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_temp_dV_SI_BP = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*3.3333333333333333e-01+(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_SI_BP-d_x_d_dV_SI_BP)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_DI_SI = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*3.3333333333333333e-01+(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_DI_SI-d_x_d_dV_DI_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dV_GP_SI = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*3.3333333333333333e-01+(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dV_GP_SI-d_x_d_dV_GP_SI)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));

d_Dd_dV_SI_BP = (d_temp_dV_SI_BP-(delta_nd*(d_x_d_dV_SI_BP+d_xi0d_dV_SI_BP)+d_delta_nd_dV_SI_BP*((x_d+1.0)+xi0d)));
d_Dd_dV_DI_SI = (d_temp_dV_DI_SI-(delta_nd*(d_x_d_dV_DI_SI+d_xi0d_dV_DI_SI)+d_delta_nd_dV_DI_SI*((x_d+1.0)+xi0d)));
d_Dd_dV_GP_SI = (d_temp_dV_GP_SI-(delta_nd*(d_x_d_dV_GP_SI+d_xi0d_dV_GP_SI)+d_delta_nd_dV_GP_SI*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}

d_x_m_dV_SI_BP = 0.5*(d_x_s_dV_SI_BP+d_x_d_dV_SI_BP);
d_x_m_dV_GP_SI = 0.5*(d_x_s_dV_GP_SI+d_x_d_dV_GP_SI);
d_x_m_dV_DI_SI = 0.5*(d_x_s_dV_DI_SI+d_x_d_dV_DI_SI);
x_m = (0.5*(x_s+x_d));

d_Em_dV_DI_SI = d_Em_dV_GP_SI = d_Em_dV_SI_BP =  0.0;
Em = 0.0;

d_temp_dV_SI_BP = (Ed*d_Es_dV_SI_BP+d_Ed_dV_SI_BP*Es);
d_temp_dV_GP_SI = (Ed*d_Es_dV_GP_SI+d_Ed_dV_GP_SI*Es);
d_temp_dV_DI_SI = (Ed*d_Es_dV_DI_SI+d_Ed_dV_DI_SI*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Em_dV_SI_BP = (deriv_sqrt_0_d0*(d_temp_dV_SI_BP));
d_Em_dV_DI_SI = (deriv_sqrt_0_d0*(d_temp_dV_DI_SI));
d_Em_dV_GP_SI = (deriv_sqrt_0_d0*(d_temp_dV_GP_SI));
Em = value_sqrt_0;
}
}

d_D_bar_dV_SI_BP = 0.5*(d_Ds_dV_SI_BP+d_Dd_dV_SI_BP);
d_D_bar_dV_GP_SI = 0.5*(d_Ds_dV_GP_SI+d_Dd_dV_GP_SI);
d_D_bar_dV_DI_SI = 0.5*(d_Ds_dV_DI_SI+d_Dd_dV_DI_SI);
D_bar = (0.5*(Ds+Dd));

d_Dm_dV_SI_BP = (d_D_bar_dV_SI_BP+0.125*((x_ds*x_ds)*(d_Em_dV_SI_BP-2.0*d_inv_Gf2_dV_SI_BP)+(x_ds*d_x_ds_dV_SI_BP+d_x_ds_dV_SI_BP*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_GP_SI = (d_D_bar_dV_GP_SI+0.125*((x_ds*x_ds)*(d_Em_dV_GP_SI-2.0*d_inv_Gf2_dV_GP_SI)+(x_ds*d_x_ds_dV_GP_SI+d_x_ds_dV_GP_SI*x_ds)*(Em-(2.0*inv_Gf2))));
d_Dm_dV_DI_SI = (d_D_bar_dV_DI_SI+0.125*((x_ds*x_ds)*(d_Em_dV_DI_SI-2.0*d_inv_Gf2_dV_DI_SI)+(x_ds*d_x_ds_dV_DI_SI+d_x_ds_dV_DI_SI*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{

d_Pm_dV_SI_BP = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_SI_BP)+d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_SI_BP+d_x_m_dV_SI_BP*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_GP_SI = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_SI)+d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_GP_SI+d_x_m_dV_GP_SI*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
d_Pm_dV_DI_SI = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_DI_SI)+d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))+(x_m*d_x_m_dV_DI_SI+d_x_m_dV_DI_SI*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_SI_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_SI))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_DI_SI))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_temp_dV_SI_BP = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_SI_BP)+d_x_m_dV_SI_BP*(1.0-(0.25*x_m))))));
d_temp_dV_GP_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_GP_SI)+d_x_m_dV_GP_SI*(1.0-(0.25*x_m))))));
d_temp_dV_DI_SI = (deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dV_DI_SI)+d_x_m_dV_DI_SI*(1.0-(0.25*x_m))))));
temp = value_sqrt_0;
}

d_sqm_dV_SI_BP = 7.0710678118654746e-01*(x_m*d_temp_dV_SI_BP+d_x_m_dV_SI_BP*temp);
d_sqm_dV_GP_SI = 7.0710678118654746e-01*(x_m*d_temp_dV_GP_SI+d_x_m_dV_GP_SI*temp);
d_sqm_dV_DI_SI = 7.0710678118654746e-01*(x_m*d_temp_dV_DI_SI+d_x_m_dV_DI_SI*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));

d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_SI_BP)+1.6666666666666667e-01*(x_m*d_x_m_dV_SI_BP+d_x_m_dV_SI_BP*x_m))+d_Gf_dV_SI_BP*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_SI_BP)/temp/temp));
d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_GP_SI)+1.6666666666666667e-01*(x_m*d_x_m_dV_GP_SI+d_x_m_dV_GP_SI*x_m))+d_Gf_dV_GP_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_GP_SI)/temp/temp));
d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dV_DI_SI)+1.6666666666666667e-01*(x_m*d_x_m_dV_DI_SI+d_x_m_dV_DI_SI*x_m))+d_Gf_dV_DI_SI*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dV_DI_SI)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{

d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((kp>0.0))
{

d_d0_dV_SI_BP = ((-d_Em_dV_SI_BP)+2.0*(xgm*d_inv_Gf2_dV_SI_BP+d_xgm_dV_SI_BP*inv_Gf2));
d_d0_dV_GP_SI = ((-d_Em_dV_GP_SI)+2.0*(xgm*d_inv_Gf2_dV_GP_SI+d_xgm_dV_GP_SI*inv_Gf2));
d_d0_dV_DI_SI = ((-d_Em_dV_DI_SI)+2.0*(xgm*d_inv_Gf2_dV_DI_SI+d_xgm_dV_DI_SI*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_eta_p_dV_SI_BP = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_SI_BP))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_GP_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_GP_SI))/value_sqrt_0/value_sqrt_0);
d_eta_p_dV_DI_SI = (-(deriv_sqrt_0_d0*(kp*d_xgm_dV_DI_SI))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}

d_temp_dV_SI_BP = (((eta_p+1.0)*d_eta_p_dV_SI_BP-eta_p*d_eta_p_dV_SI_BP)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_GP_SI = (((eta_p+1.0)*d_eta_p_dV_GP_SI-eta_p*d_eta_p_dV_GP_SI)/(eta_p+1.0)/(eta_p+1.0));
d_temp_dV_DI_SI = (((eta_p+1.0)*d_eta_p_dV_DI_SI-eta_p*d_eta_p_dV_DI_SI)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));

d_x_pm_dV_SI_BP = kp*(((temp*temp)*Gf2)*d_Dm_dV_SI_BP+((temp*temp)*d_Gf2_dV_SI_BP+(temp*d_temp_dV_SI_BP+d_temp_dV_SI_BP*temp)*Gf2)*Dm);
d_x_pm_dV_DI_SI = kp*(((temp*temp)*Gf2)*d_Dm_dV_DI_SI+((temp*temp)*d_Gf2_dV_DI_SI+(temp*d_temp_dV_DI_SI+d_temp_dV_DI_SI*temp)*Gf2)*Dm);
d_x_pm_dV_GP_SI = kp*(((temp*temp)*Gf2)*d_Dm_dV_GP_SI+((temp*temp)*d_Gf2_dV_GP_SI+(temp*d_temp_dV_GP_SI+d_temp_dV_GP_SI*temp)*Gf2)*Dm);
x_pm = (kp*(((temp*temp)*Gf2)*Dm));

d_p_pd_dV_SI_BP = (2.0*(d_xgm_dV_SI_BP-d_x_pm_dV_SI_BP)+(Gf2*((-d_Em_dV_SI_BP)+d_Dm_dV_SI_BP)+d_Gf2_dV_SI_BP*((1.0-Em)+Dm)));
d_p_pd_dV_GP_SI = (2.0*(d_xgm_dV_GP_SI-d_x_pm_dV_GP_SI)+(Gf2*((-d_Em_dV_GP_SI)+d_Dm_dV_GP_SI)+d_Gf2_dV_GP_SI*((1.0-Em)+Dm)));
d_p_pd_dV_DI_SI = (2.0*(d_xgm_dV_DI_SI-d_x_pm_dV_DI_SI)+(Gf2*((-d_Em_dV_DI_SI)+d_Dm_dV_DI_SI)+d_Gf2_dV_DI_SI*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));

d_q_pd_dV_SI_BP = (x_pm*(d_x_pm_dV_SI_BP-2.0*d_xgm_dV_SI_BP)+d_x_pm_dV_SI_BP*(x_pm-(2.0*xgm)));
d_q_pd_dV_DI_SI = (x_pm*(d_x_pm_dV_DI_SI-2.0*d_xgm_dV_DI_SI)+d_x_pm_dV_DI_SI*(x_pm-(2.0*xgm)));
d_q_pd_dV_GP_SI = (x_pm*(d_x_pm_dV_GP_SI-2.0*d_xgm_dV_GP_SI)+d_x_pm_dV_GP_SI*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));

d_xi_pd_dV_SI_BP = (-0.5*(Gf2*(d_Em_dV_SI_BP+d_Dm_dV_SI_BP)+d_Gf2_dV_SI_BP*(Em+Dm)));
d_xi_pd_dV_GP_SI = (-0.5*(Gf2*(d_Em_dV_GP_SI+d_Dm_dV_GP_SI)+d_Gf2_dV_GP_SI*(Em+Dm)));
d_xi_pd_dV_DI_SI = (-0.5*(Gf2*(d_Em_dV_DI_SI+d_Dm_dV_DI_SI)+d_Gf2_dV_DI_SI*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));

d_u_pd_dV_SI_BP = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_SI_BP+d_q_pd_dV_SI_BP*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_SI_BP+d_p_pd_dV_SI_BP*p_pd)-(xi_pd*d_q_pd_dV_SI_BP+d_xi_pd_dV_SI_BP*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_DI_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_DI_SI+d_q_pd_dV_DI_SI*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_DI_SI+d_p_pd_dV_DI_SI*p_pd)-(xi_pd*d_q_pd_dV_DI_SI+d_xi_pd_dV_DI_SI*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
d_u_pd_dV_GP_SI = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dV_GP_SI+d_q_pd_dV_GP_SI*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dV_GP_SI+d_p_pd_dV_GP_SI*p_pd)-(xi_pd*d_q_pd_dV_GP_SI+d_xi_pd_dV_GP_SI*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));

d_x_m_dV_SI_BP = (d_x_m_dV_SI_BP+d_u_pd_dV_SI_BP);
d_x_m_dV_GP_SI = (d_x_m_dV_GP_SI+d_u_pd_dV_GP_SI);
d_x_m_dV_DI_SI = (d_x_m_dV_DI_SI+d_u_pd_dV_DI_SI);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;

d_km_dV_SI_BP = (deriv_exp_0_d0*(d_u_pd_dV_SI_BP));
d_km_dV_DI_SI = (deriv_exp_0_d0*(d_u_pd_dV_DI_SI));
d_km_dV_GP_SI = (deriv_exp_0_d0*(d_u_pd_dV_GP_SI));
km = value_exp_0;
}

d_Em_dV_SI_BP = ((km*d_Em_dV_SI_BP-Em*d_km_dV_SI_BP)/km/km);
d_Em_dV_GP_SI = ((km*d_Em_dV_GP_SI-Em*d_km_dV_GP_SI)/km/km);
d_Em_dV_DI_SI = ((km*d_Em_dV_DI_SI-Em*d_km_dV_DI_SI)/km/km);
Em = (Em/km);

d_Dm_dV_SI_BP = (Dm*d_km_dV_SI_BP+d_Dm_dV_SI_BP*km);
d_Dm_dV_GP_SI = (Dm*d_km_dV_GP_SI+d_Dm_dV_GP_SI*km);
d_Dm_dV_DI_SI = (Dm*d_km_dV_DI_SI+d_Dm_dV_DI_SI*km);
Dm = (Dm*km);

d_Pm_dV_SI_BP = (d_x_m_dV_SI_BP+d_Em_dV_SI_BP);
d_Pm_dV_GP_SI = (d_x_m_dV_GP_SI+d_Em_dV_GP_SI);
d_Pm_dV_DI_SI = (d_x_m_dV_DI_SI+d_Em_dV_DI_SI);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_xgm_dV_SI_BP = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_SI_BP+d_Pm_dV_SI_BP)))+d_Gf_dV_SI_BP*value_sqrt_0);
d_xgm_dV_GP_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_GP_SI+d_Pm_dV_GP_SI)))+d_Gf_dV_GP_SI*value_sqrt_0);
d_xgm_dV_DI_SI = (Gf*(deriv_sqrt_0_d0*((d_Dm_dV_DI_SI+d_Pm_dV_DI_SI)))+d_Gf_dV_DI_SI*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}

d_km0_dV_SI_BP = ((-d_Em_dV_SI_BP)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_SI_BP+(xgm*d_eta_p_dV_SI_BP+d_xgm_dV_SI_BP*eta_p)*inv_Gf2));
d_km0_dV_GP_SI = ((-d_Em_dV_GP_SI)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_GP_SI+(xgm*d_eta_p_dV_GP_SI+d_xgm_dV_GP_SI*eta_p)*inv_Gf2));
d_km0_dV_DI_SI = ((-d_Em_dV_DI_SI)+2.0*((xgm*eta_p)*d_inv_Gf2_dV_DI_SI+(xgm*d_eta_p_dV_DI_SI+d_xgm_dV_DI_SI*eta_p)*inv_Gf2));
km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));

d_x_ds_dV_SI_BP = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_SI_BP+d_D_bar_dV_SI_BP)+(x_ds*d_km_dV_SI_BP+d_x_ds_dV_SI_BP*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_SI_BP+(km*d_D_bar_dV_SI_BP+d_km_dV_SI_BP*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
d_x_ds_dV_GP_SI = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_GP_SI+d_D_bar_dV_GP_SI)+(x_ds*d_km_dV_GP_SI+d_x_ds_dV_GP_SI*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_GP_SI+(km*d_D_bar_dV_GP_SI+d_km_dV_GP_SI*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
d_x_ds_dV_DI_SI = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dV_DI_SI+d_D_bar_dV_DI_SI)+(x_ds*d_km_dV_DI_SI+d_x_ds_dV_DI_SI*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dV_DI_SI+(km*d_D_bar_dV_DI_SI+d_km_dV_DI_SI*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));

d_dps_dV_SI_BP = (x_ds*d_phit1_dV_SI_BP+d_x_ds_dV_SI_BP*phit1);
d_dps_dV_GP_SI = (x_ds*d_phit1_dV_GP_SI+d_x_ds_dV_GP_SI*phit1);
d_dps_dV_DI_SI = (x_ds*d_phit1_dV_DI_SI+d_x_ds_dV_DI_SI*phit1);
dps = (x_ds*phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_sqm_dV_SI_BP = (deriv_sqrt_0_d0*(d_Pm_dV_SI_BP));
d_sqm_dV_GP_SI = (deriv_sqrt_0_d0*(d_Pm_dV_GP_SI));
d_sqm_dV_DI_SI = (deriv_sqrt_0_d0*(d_Pm_dV_DI_SI));
sqm = value_sqrt_0;
}

d_alpha_dV_SI_BP = (d_eta_p_dV_SI_BP+0.5*((sqm*(Gf*(-d_Em_dV_SI_BP)+d_Gf_dV_SI_BP*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_SI_BP)/sqm/sqm));
d_alpha_dV_GP_SI = (d_eta_p_dV_GP_SI+0.5*((sqm*(Gf*(-d_Em_dV_GP_SI)+d_Gf_dV_GP_SI*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_GP_SI)/sqm/sqm));
d_alpha_dV_DI_SI = (d_eta_p_dV_DI_SI+0.5*((sqm*(Gf*(-d_Em_dV_DI_SI)+d_Gf_dV_DI_SI*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dV_DI_SI)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}

d_qim_dV_SI_BP = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_SI_BP+d_Gf2_dV_SI_BP*Dm)-(Gf2*Dm)*(d_xgm_dV_SI_BP+(Gf*d_sqm_dV_SI_BP+d_Gf_dV_SI_BP*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_SI_BP*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim_dV_DI_SI = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_DI_SI+d_Gf2_dV_DI_SI*Dm)-(Gf2*Dm)*(d_xgm_dV_DI_SI+(Gf*d_sqm_dV_DI_SI+d_Gf_dV_DI_SI*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_DI_SI*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim_dV_GP_SI = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dV_GP_SI+d_Gf2_dV_GP_SI*Dm)-(Gf2*Dm)*(d_xgm_dV_GP_SI+(Gf*d_sqm_dV_GP_SI+d_Gf_dV_GP_SI*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dV_GP_SI*((Gf2*Dm)/(xgm+(Gf*sqm))));
qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));

d_qim1_dV_SI_BP = (d_qim_dV_SI_BP+(phit1*d_alpha_dV_SI_BP+d_phit1_dV_SI_BP*alpha));
d_qim1_dV_DI_SI = (d_qim_dV_DI_SI+(phit1*d_alpha_dV_DI_SI+d_phit1_dV_DI_SI*alpha));
d_qim1_dV_GP_SI = (d_qim_dV_GP_SI+(phit1*d_alpha_dV_GP_SI+d_phit1_dV_GP_SI*alpha));
qim1 = (qim+(phit1*alpha));

d_qbm_dV_SI_BP = ((sqm*Gf)*d_phit1_dV_SI_BP+(sqm*d_Gf_dV_SI_BP+d_sqm_dV_SI_BP*Gf)*phit1);
d_qbm_dV_GP_SI = ((sqm*Gf)*d_phit1_dV_GP_SI+(sqm*d_Gf_dV_GP_SI+d_sqm_dV_GP_SI*Gf)*phit1);
d_qbm_dV_DI_SI = ((sqm*Gf)*d_phit1_dV_DI_SI+(sqm*d_Gf_dV_DI_SI+d_sqm_dV_DI_SI*Gf)*phit1);
qbm = ((sqm*Gf)*phit1);
if ((RSG_i<0.0))
{

d_temp_dV_SI_BP = (-RSG_i*d_qim_dV_SI_BP);
d_temp_dV_DI_SI = (-RSG_i*d_qim_dV_DI_SI);
d_temp_dV_GP_SI = (-RSG_i*d_qim_dV_GP_SI);
temp = (1.0-(RSG_i*qim));
}
else
{

d_temp_dV_SI_BP = (-RSG_i*d_qim_dV_SI_BP/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_DI_SI = (-RSG_i*d_qim_dV_DI_SI/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
d_temp_dV_GP_SI = (-RSG_i*d_qim_dV_GP_SI/(1.0+(RSG_i*qim))/(1.0+(RSG_i*qim)));
temp = (1.0/(1.0+(RSG_i*qim)));
}

d_GR_dV_GP_SI = THER_i*((rhob*temp)*d_qim_dV_GP_SI+(rhob*d_temp_dV_GP_SI+d_rhob_dV_GP_SI*temp)*qim);
d_GR_dV_SI_BP = THER_i*((rhob*temp)*d_qim_dV_SI_BP+(rhob*d_temp_dV_SI_BP+d_rhob_dV_SI_BP*temp)*qim);
d_GR_dV_DI_SI = THER_i*((rhob*temp)*d_qim_dV_DI_SI+(rhob*d_temp_dV_DI_SI+d_rhob_dV_DI_SI*temp)*qim);
GR = (THER_i*((rhob*temp)*qim));

d_qeff_dV_SI_BP = (d_qbm_dV_SI_BP+eta_mu*d_qim_dV_SI_BP);
d_qeff_dV_GP_SI = (d_qbm_dV_GP_SI+eta_mu*d_qim_dV_GP_SI);
d_qeff_dV_DI_SI = (d_qbm_dV_DI_SI+eta_mu*d_qim_dV_DI_SI);
qeff = (qbm+(eta_mu*qim));

d_qeff1_dV_SI_BP = (d_qbm_dV_SI_BP+eta_mu1*d_qim_dV_SI_BP);
d_qeff1_dV_GP_SI = (d_qbm_dV_GP_SI+eta_mu1*d_qim_dV_GP_SI);
d_qeff1_dV_DI_SI = (d_qbm_dV_DI_SI+eta_mu1*d_qim_dV_DI_SI);
qeff1 = (qbm+(eta_mu1*qim));

d_Eeffm_dV_SI_BP = E_eff0*d_qeff_dV_SI_BP;
d_Eeffm_dV_GP_SI = E_eff0*d_qeff_dV_GP_SI;
d_Eeffm_dV_DI_SI = E_eff0*d_qeff_dV_DI_SI;
Eeffm = (E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*MUE_T),THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*MUE_T) == 0.0)?0.0:(value_pow_0*THEMU_T/(Eeffm*MUE_T)));

d_Mutmp_dV_SI_BP = ((deriv_pow_0_d0*(d_Eeffm_dV_SI_BP*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_SI_BP-Pm*(d_Pm_dV_SI_BP+d_Dm_dV_SI_BP))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_GP_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_GP_SI*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_GP_SI-Pm*(d_Pm_dV_GP_SI+d_Dm_dV_GP_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
d_Mutmp_dV_DI_SI = ((deriv_pow_0_d0*(d_Eeffm_dV_DI_SI*MUE_T))+CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dV_DI_SI-Pm*(d_Pm_dV_DI_SI+d_Dm_dV_DI_SI))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14)));
Mutmp = (value_pow_0+(CS_T*(Pm/((Pm+Dm)+1.0e-14))));
}

d_Gmob_dV_SI_BP = (((1.0+Mutmp)+GR)*d_Rxcor_dV_SI_BP+(d_Mutmp_dV_SI_BP+d_GR_dV_SI_BP)*Rxcor);
d_Gmob_dV_GP_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_GP_SI+(d_Mutmp_dV_GP_SI+d_GR_dV_GP_SI)*Rxcor);
d_Gmob_dV_DI_SI = (((1.0+Mutmp)+GR)*d_Rxcor_dV_DI_SI+(d_Mutmp_dV_DI_SI+d_GR_dV_DI_SI)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
{
double value_log_0 = log(((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP))));

d_s1_dV_SI_BP = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_SI_BP)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_SI_BP-d_dps_dV_SI_BP)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_s1_dV_GP_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(-d_dps_dV_GP_SI)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_GP_SI-d_dps_dV_GP_SI)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
d_s1_dV_DI_SI = (deriv_log_0_d0*((((1.0+((Vdse-dps)*inv_VP))*(d_Vds_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP-(1.0+((Vds-dps)*inv_VP))*(d_Vdse_dV_DI_SI-d_dps_dV_DI_SI)*inv_VP)/(1.0+((Vdse-dps)*inv_VP))/(1.0+((Vdse-dps)*inv_VP)))));
s1 = value_log_0;
}

d_dL_dV_SI_BP = ALP_i*d_s1_dV_SI_BP;
d_dL_dV_GP_SI = ALP_i*d_s1_dV_GP_SI;
d_dL_dV_DI_SI = ALP_i*d_s1_dV_DI_SI;
dL = (ALP_i*s1);

d_GdL_dV_SI_BP = (-(d_dL_dV_SI_BP+(dL*d_dL_dV_SI_BP+d_dL_dV_SI_BP*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_GP_SI = (-(d_dL_dV_GP_SI+(dL*d_dL_dV_GP_SI+d_dL_dV_GP_SI*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
d_GdL_dV_DI_SI = (-(d_dL_dV_DI_SI+(dL*d_dL_dV_DI_SI+d_dL_dV_DI_SI*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));

d_temp2_dV_SI_BP = (qim*d_xitsb_dV_SI_BP+d_qim_dV_SI_BP*xitsb);
d_temp2_dV_DI_SI = (qim*d_xitsb_dV_DI_SI+d_qim_dV_DI_SI*xitsb);
d_temp2_dV_GP_SI = (qim*d_xitsb_dV_GP_SI+d_qim_dV_GP_SI*xitsb);
temp2 = (qim*xitsb);

d_wsat_dV_SI_BP = 100.0*(((100.0+temp2)*d_temp2_dV_SI_BP-temp2*d_temp2_dV_SI_BP)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_GP_SI = 100.0*(((100.0+temp2)*d_temp2_dV_GP_SI-temp2*d_temp2_dV_GP_SI)/(100.0+temp2)/(100.0+temp2));
d_wsat_dV_DI_SI = 100.0*(((100.0+temp2)*d_temp2_dV_DI_SI-temp2*d_temp2_dV_DI_SI)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));

d_Gmob_dL_dV_SI_BP = (Gmob*d_GdL_dV_SI_BP+d_Gmob_dV_SI_BP*GdL);
d_Gmob_dL_dV_GP_SI = (Gmob*d_GdL_dV_GP_SI+d_Gmob_dV_GP_SI*GdL);
d_Gmob_dL_dV_DI_SI = (Gmob*d_GdL_dV_DI_SI+d_Gmob_dV_DI_SI*GdL);
Gmob_dL = (Gmob*GdL);
if ((THESATG_i<0.0))
{

d_temp_dV_SI_BP = (-(-THESATG_i*d_wsat_dV_SI_BP)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_GP_SI = (-(-THESATG_i*d_wsat_dV_GP_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
d_temp_dV_DI_SI = (-(-THESATG_i*d_wsat_dV_DI_SI)/(1.0-(THESATG_i*wsat))/(1.0-(THESATG_i*wsat)));
temp = (1.0/(1.0-(THESATG_i*wsat)));
}
else
{

d_temp_dV_SI_BP = THESATG_i*d_wsat_dV_SI_BP;
d_temp_dV_GP_SI = THESATG_i*d_wsat_dV_GP_SI;
d_temp_dV_DI_SI = THESATG_i*d_wsat_dV_DI_SI;
temp = (1.0+(THESATG_i*wsat));
}

d_thesat1_dV_SI_BP = THESAT_T*((Gmob_dL*d_temp_dV_SI_BP-temp*d_Gmob_dL_dV_SI_BP)/Gmob_dL/Gmob_dL);
d_thesat1_dV_DI_SI = THESAT_T*((Gmob_dL*d_temp_dV_DI_SI-temp*d_Gmob_dL_dV_DI_SI)/Gmob_dL/Gmob_dL);
d_thesat1_dV_GP_SI = THESAT_T*((Gmob_dL*d_temp_dV_GP_SI-temp*d_Gmob_dL_dV_GP_SI)/Gmob_dL/Gmob_dL);
thesat1 = (THESAT_T*(temp/Gmob_dL));

d_zsat_dV_SI_BP = (((thesat1*thesat1)*dps)*d_dps_dV_SI_BP+((thesat1*thesat1)*d_dps_dV_SI_BP+(thesat1*d_thesat1_dV_SI_BP+d_thesat1_dV_SI_BP*thesat1)*dps)*dps);
d_zsat_dV_DI_SI = (((thesat1*thesat1)*dps)*d_dps_dV_DI_SI+((thesat1*thesat1)*d_dps_dV_DI_SI+(thesat1*d_thesat1_dV_DI_SI+d_thesat1_dV_DI_SI*thesat1)*dps)*dps);
d_zsat_dV_GP_SI = (((thesat1*thesat1)*dps)*d_dps_dV_GP_SI+((thesat1*thesat1)*d_dps_dV_GP_SI+(thesat1*d_thesat1_dV_GP_SI+d_thesat1_dV_GP_SI*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if (((model_.CHNL_TYPE)==(-1)))
{

d_zsat_dV_SI_BP = (((1.0+(thesat1*dps))*d_zsat_dV_SI_BP-zsat*(thesat1*d_dps_dV_SI_BP+d_thesat1_dV_SI_BP*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_DI_SI = (((1.0+(thesat1*dps))*d_zsat_dV_DI_SI-zsat*(thesat1*d_dps_dV_DI_SI+d_thesat1_dV_DI_SI*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
d_zsat_dV_GP_SI = (((1.0+(thesat1*dps))*d_zsat_dV_GP_SI-zsat*(thesat1*d_dps_dV_GP_SI+d_thesat1_dV_GP_SI*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gvsat_dV_SI_BP = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_SI_BP))+d_Gmob_dL_dV_SI_BP*(1.0+value_sqrt_0));
d_Gvsat_dV_GP_SI = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_GP_SI))+d_Gmob_dL_dV_GP_SI*(1.0+value_sqrt_0));
d_Gvsat_dV_DI_SI = 0.5*(Gmob_dL*(deriv_sqrt_0_d0*(2.0*d_zsat_dV_DI_SI))+d_Gmob_dL_dV_DI_SI*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}

d_Gvsatinv_dV_SI_BP = (-d_Gvsat_dV_SI_BP/Gvsat/Gvsat);
d_Gvsatinv_dV_GP_SI = (-d_Gvsat_dV_GP_SI/Gvsat/Gvsat);
d_Gvsatinv_dV_DI_SI = (-d_Gvsat_dV_DI_SI/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);

d_Voxm_dV_SI_BP = (xgm*d_phit1_dV_SI_BP+d_xgm_dV_SI_BP*phit1);
d_Voxm_dV_GP_SI = (xgm*d_phit1_dV_GP_SI+d_xgm_dV_GP_SI*phit1);
d_Voxm_dV_DI_SI = (xgm*d_phit1_dV_DI_SI+d_xgm_dV_DI_SI*phit1);
Voxm = (xgm*phit1);

d_temp_dV_SI_BP = (Gmob_dL*d_Gvsatinv_dV_SI_BP+d_Gmob_dL_dV_SI_BP*Gvsatinv);
d_temp_dV_GP_SI = (Gmob_dL*d_Gvsatinv_dV_GP_SI+d_Gmob_dL_dV_GP_SI*Gvsatinv);
d_temp_dV_DI_SI = (Gmob_dL*d_Gvsatinv_dV_DI_SI+d_Gmob_dL_dV_DI_SI*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);

d_alpha1_dV_SI_BP = (alpha*0.5*((zsat*temp)*d_temp_dV_SI_BP+(zsat*d_temp_dV_SI_BP+d_zsat_dV_SI_BP*temp)*temp)+d_alpha_dV_SI_BP*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_GP_SI = (alpha*0.5*((zsat*temp)*d_temp_dV_GP_SI+(zsat*d_temp_dV_GP_SI+d_zsat_dV_GP_SI*temp)*temp)+d_alpha_dV_GP_SI*(1.0+(0.5*((zsat*temp)*temp))));
d_alpha1_dV_DI_SI = (alpha*0.5*((zsat*temp)*d_temp_dV_DI_SI+(zsat*d_temp_dV_DI_SI+d_zsat_dV_DI_SI*temp)*temp)+d_alpha_dV_DI_SI*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));

d_H_dV_SI_BP = ((alpha1*(temp*d_qim1_dV_SI_BP+d_temp_dV_SI_BP*qim1)-(temp*qim1)*d_alpha1_dV_SI_BP)/alpha1/alpha1);
d_H_dV_DI_SI = ((alpha1*(temp*d_qim1_dV_DI_SI+d_temp_dV_DI_SI*qim1)-(temp*qim1)*d_alpha1_dV_DI_SI)/alpha1/alpha1);
d_H_dV_GP_SI = ((alpha1*(temp*d_qim1_dV_GP_SI+d_temp_dV_GP_SI*qim1)-(temp*qim1)*d_alpha1_dV_GP_SI)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
}

d_xg_ac_dV_SI_BP = d_xg_dV_SI_BP;
d_xg_ac_dV_GP_SI = d_xg_dV_GP_SI;
d_xg_ac_dV_DI_SI = d_xg_dV_DI_SI;
xg_ac = xg;

d_qeff1_ac_dV_SI_BP = d_qeff1_dV_SI_BP;
d_qeff1_ac_dV_GP_SI = d_qeff1_dV_GP_SI;
d_qeff1_ac_dV_DI_SI = d_qeff1_dV_DI_SI;
qeff1_ac = qeff1;

d_Voxm_ac_dV_SI_BP = d_Voxm_dV_SI_BP;
d_Voxm_ac_dV_GP_SI = d_Voxm_dV_GP_SI;
d_Voxm_ac_dV_DI_SI = d_Voxm_dV_DI_SI;
Voxm_ac = Voxm;

d_alpha_ac_dV_SI_BP = d_alpha_dV_SI_BP;
d_alpha_ac_dV_GP_SI = d_alpha_dV_GP_SI;
d_alpha_ac_dV_DI_SI = d_alpha_dV_DI_SI;
alpha_ac = alpha;

d_dps_ac_dV_SI_BP = d_dps_dV_SI_BP;
d_dps_ac_dV_GP_SI = d_dps_dV_GP_SI;
d_dps_ac_dV_DI_SI = d_dps_dV_DI_SI;
dps_ac = dps;

d_qim_ac_dV_SI_BP = d_qim_dV_SI_BP;
d_qim_ac_dV_DI_SI = d_qim_dV_DI_SI;
d_qim_ac_dV_GP_SI = d_qim_dV_GP_SI;
qim_ac = qim;

d_GdL_ac_dV_SI_BP = d_GdL_dV_SI_BP;
d_GdL_ac_dV_GP_SI = d_GdL_dV_GP_SI;
d_GdL_ac_dV_DI_SI = d_GdL_dV_DI_SI;
GdL_ac = GdL;

d_H_ac_dV_SI_BP = d_H_dV_SI_BP;
d_H_ac_dV_DI_SI = d_H_dV_DI_SI;
d_H_ac_dV_GP_SI = d_H_dV_GP_SI;
H_ac = H;

d_eta_p_ac_dV_SI_BP = d_eta_p_dV_SI_BP;
d_eta_p_ac_dV_GP_SI = d_eta_p_dV_GP_SI;
d_eta_p_ac_dV_DI_SI = d_eta_p_dV_DI_SI;
eta_p_ac = eta_p;

d_Gvsat_ac_dV_SI_BP = d_Gvsat_dV_SI_BP;
d_Gvsat_ac_dV_GP_SI = d_Gvsat_dV_GP_SI;
d_Gvsat_ac_dV_DI_SI = d_Gvsat_dV_DI_SI;
Gvsat_ac = Gvsat;

d_Gmob_dL_ac_dV_SI_BP = d_Gmob_dL_dV_SI_BP;
d_Gmob_dL_ac_dV_GP_SI = d_Gmob_dL_dV_GP_SI;
d_Gmob_dL_ac_dV_DI_SI = d_Gmob_dL_dV_DI_SI;
Gmob_dL_ac = Gmob_dL;
}
else
{

d_xg_ac_dV_SI_BP = d_xg_dc_dV_SI_BP;
d_xg_ac_dV_GP_SI = d_xg_dc_dV_GP_SI;
d_xg_ac_dV_DI_SI = d_xg_dc_dV_DI_SI;
xg_ac = xg_dc;

d_qeff1_ac_dV_SI_BP = d_qeff1_dc_dV_SI_BP;
d_qeff1_ac_dV_GP_SI = d_qeff1_dc_dV_GP_SI;
d_qeff1_ac_dV_DI_SI = d_qeff1_dc_dV_DI_SI;
qeff1_ac = qeff1_dc;

d_Voxm_ac_dV_SI_BP = d_Voxm_dc_dV_SI_BP;
d_Voxm_ac_dV_GP_SI = d_Voxm_dc_dV_GP_SI;
d_Voxm_ac_dV_DI_SI = d_Voxm_dc_dV_DI_SI;
Voxm_ac = Voxm_dc;

d_alpha_ac_dV_SI_BP = d_alpha_dc_dV_SI_BP;
d_alpha_ac_dV_GP_SI = d_alpha_dc_dV_GP_SI;
d_alpha_ac_dV_DI_SI = d_alpha_dc_dV_DI_SI;
alpha_ac = alpha_dc;

d_dps_ac_dV_SI_BP = d_dps_dc_dV_SI_BP;
d_dps_ac_dV_GP_SI = d_dps_dc_dV_GP_SI;
d_dps_ac_dV_DI_SI = d_dps_dc_dV_DI_SI;
dps_ac = dps_dc;

d_qim_ac_dV_GP_SI = d_qim_dc_dV_GP_SI;
d_qim_ac_dV_SI_BP = d_qim_dc_dV_SI_BP;
d_qim_ac_dV_DI_SI = d_qim_dc_dV_DI_SI;
qim_ac = qim_dc;

d_GdL_ac_dV_SI_BP = d_GdL_dc_dV_SI_BP;
d_GdL_ac_dV_GP_SI = d_GdL_dc_dV_GP_SI;
d_GdL_ac_dV_DI_SI = d_GdL_dc_dV_DI_SI;
GdL_ac = GdL_dc;

d_H_ac_dV_SI_BP = d_H_dc_dV_SI_BP;
d_H_ac_dV_DI_SI = d_H_dc_dV_DI_SI;
d_H_ac_dV_GP_SI = d_H_dc_dV_GP_SI;
H_ac = H_dc;

d_eta_p_ac_dV_SI_BP = d_eta_p_dc_dV_SI_BP;
d_eta_p_ac_dV_GP_SI = d_eta_p_dc_dV_GP_SI;
d_eta_p_ac_dV_DI_SI = d_eta_p_dc_dV_DI_SI;
eta_p_ac = eta_p_dc;

d_Gvsat_ac_dV_SI_BP = d_Gvsat_dc_dV_SI_BP;
d_Gvsat_ac_dV_GP_SI = d_Gvsat_dc_dV_GP_SI;
d_Gvsat_ac_dV_DI_SI = d_Gvsat_dc_dV_DI_SI;
Gvsat_ac = Gvsat_dc;

d_Gmob_dL_ac_dV_SI_BP = d_Gmob_dL_dc_dV_SI_BP;
d_Gmob_dL_ac_dV_GP_SI = d_Gmob_dL_dc_dV_GP_SI;
d_Gmob_dL_ac_dV_DI_SI = d_Gmob_dL_dc_dV_DI_SI;
Gmob_dL_ac = Gmob_dL_dc;
}
}
// End block SPcalc_ac

d_Vgb_dV_SI_BP = d_Vsb_dV_SI_BP;
d_Vgb_dV_GP_SI = d_Vgs_dV_GP_SI;
d_Vgb_dV_DI_SI = (d_Vgs_dV_DI_SI+d_Vsb_dV_DI_SI);
Vgb = (Vgs+Vsb);

d_COX_qm_dV_DI_SI = d_COX_qm_dV_GP_SI = d_COX_qm_dV_SI_BP =  0.0;
COX_qm = COX_i;
if ((qq>0.0))
{
{
double value_pow_0 = pow(((qeff1_ac*qeff1_ac)+qlim2),((-1.0)*1.6666666666666667e-01));
double  deriv_pow_0_d0 = ((((qeff1_ac*qeff1_ac)+qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff1_ac*qeff1_ac)+qlim2)));

d_COX_qm_dV_SI_BP = (-COX_i*qq*(deriv_pow_0_d0*((qeff1_ac*d_qeff1_ac_dV_SI_BP+d_qeff1_ac_dV_SI_BP*qeff1_ac)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
d_COX_qm_dV_GP_SI = (-COX_i*qq*(deriv_pow_0_d0*((qeff1_ac*d_qeff1_ac_dV_GP_SI+d_qeff1_ac_dV_GP_SI*qeff1_ac)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
d_COX_qm_dV_DI_SI = (-COX_i*qq*(deriv_pow_0_d0*((qeff1_ac*d_qeff1_ac_dV_DI_SI+d_qeff1_ac_dV_DI_SI*qeff1_ac)))/(1.0+(qq*value_pow_0))/(1.0+(qq*value_pow_0)));
COX_qm = (COX_i/(1.0+(qq*value_pow_0)));
}
}
if ((xg_ac<=0.0))
{

d_QG_dV_SI_BP = d_Voxm_ac_dV_SI_BP;
d_QG_dV_GP_SI = d_Voxm_ac_dV_GP_SI;
d_QG_dV_DI_SI = d_Voxm_ac_dV_DI_SI;
QG = Voxm_ac;

d_QI_dV_DI_SI = d_QI_dV_GP_SI = d_QI_dV_SI_BP =  0.0;
QI = 0.0;

d_QD_dV_DI_SI = d_QD_dV_GP_SI = d_QD_dV_SI_BP =  0.0;
QD = 0.0;

d_QB_dV_SI_BP = d_QG_dV_SI_BP;
d_QB_dV_GP_SI = d_QG_dV_GP_SI;
d_QB_dV_DI_SI = d_QG_dV_DI_SI;
QB = QG;
}
else
{

d_Fj_dV_SI_BP = 0.5*((H_ac*d_dps_ac_dV_SI_BP-dps_ac*d_H_ac_dV_SI_BP)/H_ac/H_ac);
d_Fj_dV_GP_SI = 0.5*((H_ac*d_dps_ac_dV_GP_SI-dps_ac*d_H_ac_dV_GP_SI)/H_ac/H_ac);
d_Fj_dV_DI_SI = 0.5*((H_ac*d_dps_ac_dV_DI_SI-dps_ac*d_H_ac_dV_DI_SI)/H_ac/H_ac);
Fj = (0.5*(dps_ac/H_ac));

d_Fj2_dV_SI_BP = (Fj*d_Fj_dV_SI_BP+d_Fj_dV_SI_BP*Fj);
d_Fj2_dV_GP_SI = (Fj*d_Fj_dV_GP_SI+d_Fj_dV_GP_SI*Fj);
d_Fj2_dV_DI_SI = (Fj*d_Fj_dV_DI_SI+d_Fj_dV_DI_SI*Fj);
Fj2 = (Fj*Fj);

d_QCLM_dV_SI_BP = ((1.0-GdL_ac)*(d_qim_ac_dV_SI_BP-0.5*(alpha_ac*d_dps_ac_dV_SI_BP+d_alpha_ac_dV_SI_BP*dps_ac))+(-d_GdL_ac_dV_SI_BP)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
d_QCLM_dV_GP_SI = ((1.0-GdL_ac)*(d_qim_ac_dV_GP_SI-0.5*(alpha_ac*d_dps_ac_dV_GP_SI+d_alpha_ac_dV_GP_SI*dps_ac))+(-d_GdL_ac_dV_GP_SI)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
d_QCLM_dV_DI_SI = ((1.0-GdL_ac)*(d_qim_ac_dV_DI_SI-0.5*(alpha_ac*d_dps_ac_dV_DI_SI+d_alpha_ac_dV_DI_SI*dps_ac))+(-d_GdL_ac_dV_DI_SI)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
QCLM = ((1.0-GdL_ac)*(qim_ac-(0.5*(alpha_ac*dps_ac))));

d_QG_dV_SI_BP = (d_Voxm_ac_dV_SI_BP+0.5*((eta_p_ac*dps_ac)*((Fj*d_GdL_ac_dV_SI_BP+d_Fj_dV_SI_BP*GdL_ac)*3.3333333333333333e-01+d_GdL_ac_dV_SI_BP)+(eta_p_ac*d_dps_ac_dV_SI_BP+d_eta_p_ac_dV_SI_BP*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)));
d_QG_dV_GP_SI = (d_Voxm_ac_dV_GP_SI+0.5*((eta_p_ac*dps_ac)*((Fj*d_GdL_ac_dV_GP_SI+d_Fj_dV_GP_SI*GdL_ac)*3.3333333333333333e-01+d_GdL_ac_dV_GP_SI)+(eta_p_ac*d_dps_ac_dV_GP_SI+d_eta_p_ac_dV_GP_SI*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)));
d_QG_dV_DI_SI = (d_Voxm_ac_dV_DI_SI+0.5*((eta_p_ac*dps_ac)*((Fj*d_GdL_ac_dV_DI_SI+d_Fj_dV_DI_SI*GdL_ac)*3.3333333333333333e-01+d_GdL_ac_dV_DI_SI)+(eta_p_ac*d_dps_ac_dV_DI_SI+d_eta_p_ac_dV_DI_SI*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)));
QG = (Voxm_ac+(0.5*((eta_p_ac*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac))));

d_temp_dV_SI_BP = (alpha_ac*d_dps_ac_dV_SI_BP+d_alpha_ac_dV_SI_BP*dps_ac)*1.6666666666666667e-01;
d_temp_dV_GP_SI = (alpha_ac*d_dps_ac_dV_GP_SI+d_alpha_ac_dV_GP_SI*dps_ac)*1.6666666666666667e-01;
d_temp_dV_DI_SI = (alpha_ac*d_dps_ac_dV_DI_SI+d_alpha_ac_dV_DI_SI*dps_ac)*1.6666666666666667e-01;
temp = ((alpha_ac*dps_ac)*1.6666666666666667e-01);

d_QI_dV_SI_BP = ((GdL_ac*(d_qim_ac_dV_SI_BP+(temp*d_Fj_dV_SI_BP+d_temp_dV_SI_BP*Fj))+d_GdL_ac_dV_SI_BP*(qim_ac+(temp*Fj)))+d_QCLM_dV_SI_BP);
d_QI_dV_GP_SI = ((GdL_ac*(d_qim_ac_dV_GP_SI+(temp*d_Fj_dV_GP_SI+d_temp_dV_GP_SI*Fj))+d_GdL_ac_dV_GP_SI*(qim_ac+(temp*Fj)))+d_QCLM_dV_GP_SI);
d_QI_dV_DI_SI = ((GdL_ac*(d_qim_ac_dV_DI_SI+(temp*d_Fj_dV_DI_SI+d_temp_dV_DI_SI*Fj))+d_GdL_ac_dV_DI_SI*(qim_ac+(temp*Fj)))+d_QCLM_dV_DI_SI);
QI = ((GdL_ac*(qim_ac+(temp*Fj)))+QCLM);

d_QD_dV_SI_BP = 0.5*(((GdL_ac*GdL_ac)*(d_qim_ac_dV_SI_BP-(temp*((-d_Fj_dV_SI_BP)-0.2*d_Fj2_dV_SI_BP)+d_temp_dV_SI_BP*((1.0-Fj)-(0.2*Fj2))))+(GdL_ac*d_GdL_ac_dV_SI_BP+d_GdL_ac_dV_SI_BP*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_ac_dV_SI_BP+d_QCLM_dV_SI_BP*(1.0+GdL_ac)));
d_QD_dV_GP_SI = 0.5*(((GdL_ac*GdL_ac)*(d_qim_ac_dV_GP_SI-(temp*((-d_Fj_dV_GP_SI)-0.2*d_Fj2_dV_GP_SI)+d_temp_dV_GP_SI*((1.0-Fj)-(0.2*Fj2))))+(GdL_ac*d_GdL_ac_dV_GP_SI+d_GdL_ac_dV_GP_SI*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_ac_dV_GP_SI+d_QCLM_dV_GP_SI*(1.0+GdL_ac)));
d_QD_dV_DI_SI = 0.5*(((GdL_ac*GdL_ac)*(d_qim_ac_dV_DI_SI-(temp*((-d_Fj_dV_DI_SI)-0.2*d_Fj2_dV_DI_SI)+d_temp_dV_DI_SI*((1.0-Fj)-(0.2*Fj2))))+(GdL_ac*d_GdL_ac_dV_DI_SI+d_GdL_ac_dV_DI_SI*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_ac_dV_DI_SI+d_QCLM_dV_DI_SI*(1.0+GdL_ac)));
QD = (0.5*(((GdL_ac*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL_ac))));

d_QB_dV_SI_BP = (d_QG_dV_SI_BP-d_QI_dV_SI_BP);
d_QB_dV_GP_SI = (d_QG_dV_GP_SI-d_QI_dV_GP_SI);
d_QB_dV_DI_SI = (d_QG_dV_DI_SI-d_QI_dV_DI_SI);
QB = (QG-QI);
}

d_Qg_dV_SI_BP = (QG*d_COX_qm_dV_SI_BP+d_QG_dV_SI_BP*COX_qm);
d_Qg_dV_GP_SI = (QG*d_COX_qm_dV_GP_SI+d_QG_dV_GP_SI*COX_qm);
d_Qg_dV_DI_SI = (QG*d_COX_qm_dV_DI_SI+d_QG_dV_DI_SI*COX_qm);
Qg = (QG*COX_qm);

d_Qd_dV_SI_BP = ((-QD)*d_COX_qm_dV_SI_BP+(-d_QD_dV_SI_BP)*COX_qm);
d_Qd_dV_GP_SI = ((-QD)*d_COX_qm_dV_GP_SI+(-d_QD_dV_GP_SI)*COX_qm);
d_Qd_dV_DI_SI = ((-QD)*d_COX_qm_dV_DI_SI+(-d_QD_dV_DI_SI)*COX_qm);
Qd = ((-QD)*COX_qm);

d_Qb_dV_SI_BP = ((-QB)*d_COX_qm_dV_SI_BP+(-d_QB_dV_SI_BP)*COX_qm);
d_Qb_dV_GP_SI = ((-QB)*d_COX_qm_dV_GP_SI+(-d_QB_dV_GP_SI)*COX_qm);
d_Qb_dV_DI_SI = ((-QB)*d_COX_qm_dV_DI_SI+(-d_QB_dV_DI_SI)*COX_qm);
Qb = ((-QB)*COX_qm);

d_Qgs_ov_dV_GP_SI = CGOV_i*d_Vovs_dV_GP_SI;
Qgs_ov = (CGOV_i*Vovs);

d_Qgd_ov_dV_DI_SI = CGOVD_i*d_Vovd_dV_DI_SI;
d_Qgd_ov_dV_GP_SI = CGOVD_i*d_Vovd_dV_GP_SI;
Qgd_ov = (CGOVD_i*Vovd);

d_Qgb_ov_dV_SI_BP = CGBOV_i*d_Vgb_dV_SI_BP;
d_Qgb_ov_dV_GP_SI = CGBOV_i*d_Vgb_dV_GP_SI;
d_Qgb_ov_dV_DI_SI = CGBOV_i*d_Vgb_dV_DI_SI;
Qgb_ov = (CGBOV_i*Vgb);

d_Qfgs_dV_GP_SI = CFR_i*d_VgsPrime_dV_GP_SI;
Qfgs = (CFR_i*VgsPrime);

d_Qfgd_dV_DI_SI = CFRD_i*d_VgdPrime_dV_DI_SI;
d_Qfgd_dV_GP_SI = CFRD_i*d_VgdPrime_dV_GP_SI;
Qfgd = (CFRD_i*VgdPrime);
}
// End block evaluateDynamic
//Begin block evaluateStaticDynamic
{

d_ijun_s_dV_DI_BD = d_ijun_s_dV_SI_BS =  0.0;
ijun_s = 0.0;

d_ijunbot_s_dV_SI_BS = d_ijunbot_s_dV_DI_BD =  0.0;
ijunbot_s = 0.0;

d_ijunsti_s_dV_SI_BS = d_ijunsti_s_dV_DI_BD =  0.0;
ijunsti_s = 0.0;

d_ijungat_s_dV_SI_BS = d_ijungat_s_dV_DI_BD =  0.0;
ijungat_s = 0.0;

d_ijun_d_dV_DI_BD = d_ijun_d_dV_SI_BS =  0.0;
ijun_d = 0.0;

d_ijunbot_d_dV_DI_BD = d_ijunbot_d_dV_SI_BS =  0.0;
ijunbot_d = 0.0;

d_ijunsti_d_dV_DI_BD = d_ijunsti_d_dV_SI_BS =  0.0;
ijunsti_d = 0.0;

d_ijungat_d_dV_DI_BD = d_ijungat_d_dV_SI_BS =  0.0;
ijungat_d = 0.0;

d_qjun_s_dV_DI_BD = d_qjun_s_dV_SI_BS =  0.0;
qjun_s = 0.0;

d_qjunbot_s_dV_DI_BD = d_qjunbot_s_dV_SI_BS =  0.0;
qjunbot_s = 0.0;

d_qjunsti_s_dV_DI_BD = d_qjunsti_s_dV_SI_BS =  0.0;
qjunsti_s = 0.0;

d_qjungat_s_dV_DI_BD = d_qjungat_s_dV_SI_BS =  0.0;
qjungat_s = 0.0;

d_qjun_d_dV_DI_BD = d_qjun_d_dV_SI_BS =  0.0;
qjun_d = 0.0;

d_qjunbot_d_dV_DI_BD = d_qjunbot_d_dV_SI_BS =  0.0;
qjunbot_d = 0.0;

d_qjunsti_d_dV_DI_BD = d_qjunsti_d_dV_SI_BS =  0.0;
qjunsti_d = 0.0;

d_qjungat_d_dV_DI_BD = d_qjungat_d_dV_SI_BS =  0.0;
qjungat_d = 0.0;
if (((model_.SWJUNCAP_i)>0))
{
if (((model_.SWJUNEXP_i)==1))
{

d_tm0_dV_DI_BD =  0.0;
d_tm0_dV_SI_BS = d_Vjun_s_dV_SI_BS*(model_.phitdinv)*MFOR1_s;
tm0 = ((Vjun_s*(model_.phitdinv))*MFOR1_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_DI_BD =  0.0;
d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_s)?expxhf1_s*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_s)?(expxhf1_s*((tm0-xhighf1_s)+1.0)):value_exp_0));
}

d_ijunfor1_dV_DI_BD =  0.0;
d_ijunfor1_dV_SI_BS = ISATFOR1_s*d_tm1_dV_SI_BS;
ijunfor1 = (ISATFOR1_s*(tm1-1.0));

d_tm0_dV_DI_BD =  0.0;
d_tm0_dV_SI_BS = d_Vjun_s_dV_SI_BS*(model_.phitdinv)*MFOR2_s;
tm0 = ((Vjun_s*(model_.phitdinv))*MFOR2_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_DI_BD =  0.0;
d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_s)?expxhf2_s*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_s)?(expxhf2_s*((tm0-xhighf2_s)+1.0)):value_exp_0));
}

d_ijunfor2_dV_DI_BD =  0.0;
d_ijunfor2_dV_SI_BS = ISATFOR2_s*d_tm1_dV_SI_BS;
ijunfor2 = (ISATFOR2_s*(tm1-1.0));

d_ijunrev_dV_DI_BD = d_ijunrev_dV_SI_BS =  0.0;
ijunrev = 0.0;
if ((m0flag_s>0.0))
{

d_ijunrev_dV_DI_BD =  0.0;
d_ijunrev_dV_SI_BS = (Vjun_s*d_Vjun_s_dV_SI_BS*MREV_s+d_Vjun_s_dV_SI_BS*(ISATREV_s+(Vjun_s*MREV_s)));
ijunrev = (Vjun_s*(ISATREV_s+(Vjun_s*MREV_s)));
}
else
{

d_tm0_dV_DI_BD =  0.0;
d_tm0_dV_SI_BS = (-d_Vjun_s_dV_SI_BS)*(model_.phitdinv)*MREV_s;
tm0 = (((-Vjun_s)*(model_.phitdinv))*MREV_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_DI_BD =  0.0;
d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_s)?expxhr_s*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_s)?(expxhr_s*((tm0-xhighr_s)+1.0)):value_exp_0));
}

d_ijunrev_dV_DI_BD =  0.0;
d_ijunrev_dV_SI_BS = (-ISATREV_s)*d_tm1_dV_SI_BS;
ijunrev = ((-ISATREV_s)*(tm1-1.0));
}

d_ijun_s_dV_DI_BD =  0.0;
d_ijun_s_dV_SI_BS = ((d_ijunfor1_dV_SI_BS+d_ijunfor2_dV_SI_BS)+d_ijunrev_dV_SI_BS);
ijun_s = ((ijunfor1+ijunfor2)+ijunrev);

d_tm0_dV_SI_BS =  0.0;
d_tm0_dV_DI_BD = d_Vjun_d_dV_DI_BD*(model_.phitdinv)*MFOR1_d;
tm0 = ((Vjun_d*(model_.phitdinv))*MFOR1_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?expxhf1_d*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?expxhf1_d*d_tm0_dV_DI_BD:(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf1_d)?(expxhf1_d*((tm0-xhighf1_d)+1.0)):value_exp_0));
}

d_ijunfor1_dV_SI_BS = ISATFOR1_d*d_tm1_dV_SI_BS;
d_ijunfor1_dV_DI_BD = ISATFOR1_d*d_tm1_dV_DI_BD;
ijunfor1 = (ISATFOR1_d*(tm1-1.0));

d_tm0_dV_SI_BS =  0.0;
d_tm0_dV_DI_BD = d_Vjun_d_dV_DI_BD*(model_.phitdinv)*MFOR2_d;
tm0 = ((Vjun_d*(model_.phitdinv))*MFOR2_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?expxhf2_d*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?expxhf2_d*d_tm0_dV_DI_BD:(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighf2_d)?(expxhf2_d*((tm0-xhighf2_d)+1.0)):value_exp_0));
}

d_ijunfor2_dV_SI_BS = ISATFOR2_d*d_tm1_dV_SI_BS;
d_ijunfor2_dV_DI_BD = ISATFOR2_d*d_tm1_dV_DI_BD;
ijunfor2 = (ISATFOR2_d*(tm1-1.0));

d_ijunrev_dV_DI_BD = d_ijunrev_dV_SI_BS =  0.0;
ijunrev = 0.0;
if ((m0flag_d>0.0))
{

d_ijunrev_dV_SI_BS =  0.0;
d_ijunrev_dV_DI_BD = (Vjun_d*d_Vjun_d_dV_DI_BD*MREV_d+d_Vjun_d_dV_DI_BD*(ISATREV_d+(Vjun_d*MREV_d)));
ijunrev = (Vjun_d*(ISATREV_d+(Vjun_d*MREV_d)));
}
else
{

d_tm0_dV_SI_BS =  0.0;
d_tm0_dV_DI_BD = (-d_Vjun_d_dV_DI_BD)*(model_.phitdinv)*MREV_d;
tm0 = (((-Vjun_d)*(model_.phitdinv))*MREV_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;

d_tm1_dV_SI_BS = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_SI_BS)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?expxhr_d*d_tm0_dV_SI_BS:(deriv_exp_0_d0*(d_tm0_dV_SI_BS))));
d_tm1_dV_DI_BD = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dV_DI_BD)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?expxhr_d*d_tm0_dV_DI_BD:(deriv_exp_0_d0*(d_tm0_dV_DI_BD))));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>xhighr_d)?(expxhr_d*((tm0-xhighr_d)+1.0)):value_exp_0));
}

d_ijunrev_dV_SI_BS = (-ISATREV_d)*d_tm1_dV_SI_BS;
d_ijunrev_dV_DI_BD = (-ISATREV_d)*d_tm1_dV_DI_BD;
ijunrev = ((-ISATREV_d)*(tm1-1.0));
}

d_ijun_d_dV_SI_BS = ((d_ijunfor1_dV_SI_BS+d_ijunfor2_dV_SI_BS)+d_ijunrev_dV_SI_BS);
d_ijun_d_dV_DI_BD = ((d_ijunfor1_dV_DI_BD+d_ijunfor2_dV_DI_BD)+d_ijunrev_dV_DI_BD);
ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
//Begin block evaluateDynamic
{
//Block-local variables for block evaluateDynamic
double tmpv=0.0;
     double d_tmpv_dV_DI_BD=0.0;
     double d_tmpv_dV_SI_BS=0.0;
double vjv=0.0;
     double d_vjv_dV_DI_BD=0.0;
     double d_vjv_dV_SI_BS=0.0;
//End of Block-local variables

d_tmpv_dV_DI_BD = d_tmpv_dV_SI_BS =  0.0;
tmpv = 0.0;

d_vjv_dV_DI_BD = d_vjv_dV_SI_BS =  0.0;
vjv = 0.0;
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);

d_h2d_dV_DI_BD =  0.0;
d_h2d_dV_SI_BS = d_Vjun_s_dV_SI_BS;
h2d = (Vjun_s+(vch_s*h2));

d_h3_dV_DI_BD =  0.0;
d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
h3 = (vfmin_s+h2d);

d_h4_dV_DI_BD =  0.0;
d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_DI_BD =  0.0;
d_h5_dV_SI_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_SI_BS+d_h4_dV_SI_BS*h4)));
h5 = value_sqrt_0;
}

d_vjv_dV_DI_BD =  0.0;
d_vjv_dV_SI_BS = 2.0*(((h3+h5)*d_Vjun_s_dV_SI_BS*vfmin_s-(Vjun_s*vfmin_s)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
if ((zflagbot_s>0.5))
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvbot))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1.0-(vjv*(model_.vbiinvbot)))));

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvbot))));
tmpv = value_pow_0;
}
}

d_qjunbot_s_dV_DI_BD =  0.0;
d_qjunbot_s_dV_SI_BS = ((model_.qprefbot)*(-d_tmpv_dV_SI_BS)+(model_.qpref2bot)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS));
qjunbot_s = (((model_.qprefbot)*(1.0-tmpv))+((model_.qpref2bot)*(Vjun_s-vjv)));
}
if ((zflagsti_s>0.5))
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvsti))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1.0-(vjv*(model_.vbiinvsti)))));

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvsti))));
tmpv = value_pow_0;
}
}

d_qjunsti_s_dV_DI_BD =  0.0;
d_qjunsti_s_dV_SI_BS = ((model_.qprefsti)*(-d_tmpv_dV_SI_BS)+(model_.qpref2sti)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS));
qjunsti_s = (((model_.qprefsti)*(1.0-tmpv))+((model_.qpref2sti)*(Vjun_s-vjv)));
}
if ((zflaggat_s>0.5))
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvgat))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1.0-(vjv*(model_.vbiinvgat)))));

d_tmpv_dV_DI_BD =  0.0;
d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvgat))));
tmpv = value_pow_0;
}
}

d_qjungat_s_dV_DI_BD =  0.0;
d_qjungat_s_dV_SI_BS = ((model_.qprefgat)*(-d_tmpv_dV_SI_BS)+(model_.qpref2gat)*(d_Vjun_s_dV_SI_BS-d_vjv_dV_SI_BS));
qjungat_s = (((model_.qprefgat)*(1.0-tmpv))+((model_.qpref2gat)*(Vjun_s-vjv)));
}

d_tmpv_dV_DI_BD = d_tmpv_dV_SI_BS =  0.0;
tmpv = 0.0;

d_vjv_dV_DI_BD = d_vjv_dV_SI_BS =  0.0;
vjv = 0.0;
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);

d_h2d_dV_SI_BS =  0.0;
d_h2d_dV_DI_BD = d_Vjun_d_dV_DI_BD;
h2d = (Vjun_d+(vch_d*h2));

d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
h3 = (vfmin_d+h2d);

d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_SI_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_SI_BS+d_h4_dV_SI_BS*h4)));
d_h5_dV_DI_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_DI_BD+d_h4_dV_DI_BD*h4)));
h5 = value_sqrt_0;
}

d_vjv_dV_SI_BS = 2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS)/(h3+h5)/(h3+h5));
d_vjv_dV_DI_BD = 2.0*(((h3+h5)*d_Vjun_d_dV_DI_BD*vfmin_d-(Vjun_d*vfmin_d)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
if ((zflagbot_d>0.5))
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvbot_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvbot_d))));
d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvbot_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1.0-(vjv*(model_.vbiinvbot_d)))));

d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvbot_d))));
d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvbot_d))));
tmpv = value_pow_0;
}
}

d_qjunbot_d_dV_SI_BS = ((model_.qprefbot_d)*(-d_tmpv_dV_SI_BS)+(model_.qpref2bot_d)*(-d_vjv_dV_SI_BS));
d_qjunbot_d_dV_DI_BD = ((model_.qprefbot_d)*(-d_tmpv_dV_DI_BD)+(model_.qpref2bot_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD));
qjunbot_d = (((model_.qprefbot_d)*(1.0-tmpv))+((model_.qpref2bot_d)*(Vjun_d-vjv)));
}
if ((zflagsti_d>0.5))
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvsti_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvsti_d))));
d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvsti_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1.0-(vjv*(model_.vbiinvsti_d)))));

d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvsti_d))));
d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvsti_d))));
tmpv = value_pow_0;
}
}

d_qjunsti_d_dV_SI_BS = ((model_.qprefsti_d)*(-d_tmpv_dV_SI_BS)+(model_.qpref2sti_d)*(-d_vjv_dV_SI_BS));
d_qjunsti_d_dV_DI_BD = ((model_.qprefsti_d)*(-d_tmpv_dV_DI_BD)+(model_.qpref2sti_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD));
qjunsti_d = (((model_.qprefsti_d)*(1.0-tmpv))+((model_.qpref2sti_d)*(Vjun_d-vjv)));
}
if ((zflaggat_d>0.5))
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*(model_.vbiinvgat_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmpv_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvgat_d))));
d_tmpv_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvgat_d))));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0-(vjv*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1.0-(vjv*(model_.vbiinvgat_d)))));

d_tmpv_dV_SI_BS = (deriv_pow_0_d0*((-d_vjv_dV_SI_BS*(model_.vbiinvgat_d))));
d_tmpv_dV_DI_BD = (deriv_pow_0_d0*((-d_vjv_dV_DI_BD*(model_.vbiinvgat_d))));
tmpv = value_pow_0;
}
}

d_qjungat_d_dV_SI_BS = ((model_.qprefgat_d)*(-d_tmpv_dV_SI_BS)+(model_.qpref2gat_d)*(-d_vjv_dV_SI_BS));
d_qjungat_d_dV_DI_BD = ((model_.qprefgat_d)*(-d_tmpv_dV_DI_BD)+(model_.qpref2gat_d)*(d_Vjun_d_dV_DI_BD-d_vjv_dV_DI_BD));
qjungat_d = (((model_.qprefgat_d)*(1.0-tmpv))+((model_.qpref2gat_d)*(Vjun_d-vjv)));
}
}
// End block evaluateDynamic
}
else
{

d_vbbt_dV_DI_BD = d_vbbt_dV_SI_BS =  0.0;
vbbt = 0.0;

d_two_psistar_dV_DI_BD = d_two_psistar_dV_SI_BS =  0.0;
two_psistar = 0.0;
if ((!(((ABSOURCE_i==0.0)&&(LSSOURCE_i==0.0))&&(LGSOURCE_i==0.0))))
{
h1 = ((4.0*vch_s)*vch_s);
h2 = (vch_s/vfmin_s);

d_h2d_dV_DI_BD =  0.0;
d_h2d_dV_SI_BS = d_Vjun_s_dV_SI_BS;
h2d = (Vjun_s+(vch_s*h2));

d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
h3 = (vfmin_s+h2d);

d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
h4 = (vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_SI_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_SI_BS+d_h4_dV_SI_BS*h4)));
d_h5_dV_DI_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_DI_BD+d_h4_dV_DI_BD*h4)));
h5 = value_sqrt_0;
}

d_vj_dV_DI_BD = 2.0*(-(Vjun_s*vfmin_s)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD)/(h3+h5)/(h3+h5));
d_vj_dV_SI_BS = 2.0*(((h3+h5)*d_Vjun_s_dV_SI_BS*vfmin_s-(Vjun_s*vfmin_s)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_s*vfmin_s)/(h3+h5)));
if ((Vjun_s<VMAX_s))
{
if ((fabs((0.5*(Vjun_s*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_s*(model_.phitdinv))));
double  deriv_exp_0_d0 = value_exp_0;

d_zinv_dV_DI_BD =  0.0;
d_zinv_dV_SI_BS = (deriv_exp_0_d0*(0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv)));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_s*(model_.phitdinv)))<0.0))
{

d_zinv_dV_DI_BD =  0.0;
d_zinv_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(-0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv))*3.3333333333333333e-01+(-0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))+(-0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{

d_zinv_dV_DI_BD =  0.0;
d_zinv_dV_SI_BS = 1.0e100*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv)*3.3333333333333333e-01+0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*d_Vjun_s_dV_SI_BS*(model_.phitdinv)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_idmult_dV_DI_BD =  0.0;
d_idmult_dV_SI_BS = (zinv*d_zinv_dV_SI_BS+d_zinv_dV_SI_BS*zinv);
idmult = (zinv*zinv);
}
else
{

d_idmult_dV_DI_BD =  0.0;
d_idmult_dV_SI_BS = d_Vjun_s_dV_SI_BS*(model_.phitdinv)*exp_VMAX_over_phitd_s;
idmult = ((1.0+((Vjun_s-VMAX_s)*(model_.phitdinv)))*exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zinv_dV_DI_BD =  0.0;
d_zinv_dV_SI_BS = (deriv_sqrt_0_d0*(d_idmult_dV_SI_BS));
zinv = value_sqrt_0;
}
}

d_idmult_dV_DI_BD =  0.0;
idmult = (idmult-1.0);

d_z_dV_DI_BD =  0.0;
d_z_dV_SI_BS = (-d_zinv_dV_SI_BS/zinv/zinv);
z = (1.0/zinv);
if ((Vjun_s>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

d_two_psistar_dV_DI_BD =  0.0;
d_two_psistar_dV_SI_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_SI_BS+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_SI_BS+d_z_dV_SI_BS*(z+3.0)))))));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));

d_two_psistar_dV_DI_BD =  0.0;
d_two_psistar_dV_SI_BS = ((-d_Vjun_s_dV_SI_BS)+2.0*(model_.phitd)*(deriv_log_1_d0*((2.0*d_zinv_dV_SI_BS+(deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dV_SI_BS+d_zinv_dV_SI_BS*(1.0+(3.0*zinv)))))))));
two_psistar = ((-Vjun_s)+(2.0*((model_.phitd)*value_log_1)));
}
}

d_vjlim_dV_DI_BD =  0.0;
d_vjlim_dV_SI_BS = (-d_two_psistar_dV_SI_BS);
vjlim = (vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vjsrh_dV_DI_BD =  0.0;
d_vjsrh_dV_SI_BS = 0.5*((d_Vjun_s_dV_SI_BS+d_vjlim_dV_SI_BS)-(deriv_sqrt_0_d0*(((Vjun_s-vjlim)*(d_Vjun_s_dV_SI_BS-d_vjlim_dV_SI_BS)+(d_Vjun_s_dV_SI_BS-d_vjlim_dV_SI_BS)*(Vjun_s-vjlim)))));
vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s-vbbtlim_s)*(Vjun_s-vbbtlim_s))+((4.0*(model_.phitr))*(model_.phitr))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vbbt_dV_DI_BD =  0.0;
d_vbbt_dV_SI_BS = 0.5*(d_Vjun_s_dV_SI_BS-(deriv_sqrt_0_d0*(((Vjun_s-vbbtlim_s)*d_Vjun_s_dV_SI_BS+d_Vjun_s_dV_SI_BS*(Vjun_s-vbbtlim_s)))));
vbbt = (0.5*((Vjun_s+vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vav_dV_DI_BD =  0.0;
d_vav_dV_SI_BS = 0.5*(d_Vjun_s_dV_SI_BS-(deriv_sqrt_0_d0*(((Vjun_s)*d_Vjun_s_dV_SI_BS+d_Vjun_s_dV_SI_BS*(Vjun_s)))));
vav = (0.5*(Vjun_s-value_sqrt_0));
}
}
if ((ABSOURCE_i==0.0))
{

d_ijunbot_s_dV_SI_BS = d_ijunbot_s_dV_DI_BD =  0.0;
ijunbot_s = 0.0;

d_qjunbot_s_dV_DI_BD = d_qjunbot_s_dV_SI_BS =  0.0;
qjunbot_s = 0.0;
}
else
{
if (((model_.one_minus_PBOT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvbot))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvbot))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot))),(model_.one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvbot))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT)/(1.0-(vj*(model_.vbiinvbot)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvbot))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvbot))));
tmp = value_pow_0;
}
}

d_qjunbot_s_dV_DI_BD = ((model_.qprefbot)*(-d_tmp_dV_DI_BD)+(model_.qpref2bot)*(-d_vj_dV_DI_BD));
d_qjunbot_s_dV_SI_BS = ((model_.qprefbot)*(-d_tmp_dV_SI_BS)+(model_.qpref2bot)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS));
qjunbot_s = (((model_.qprefbot)*(1.0-tmp))+((model_.qpref2bot)*(Vjun_s-vj)));

d_id_dV_DI_BD =  0.0;
d_id_dV_SI_BS = (model_.idsatbot)*d_idmult_dV_SI_BS;
id = ((model_.idsatbot)*idmult);
if ((((model_.CSRHBOT_i)==0.0)&&((model_.CTATBOT_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
vbi_minus_vjsrh = ((model_.vbibot)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_DI_BD =  0.0;
d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOT_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_DI_BD =  0.0;
d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOT_i))));
}
}

d_wsrh_dV_DI_BD =  0.0;
d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrbot)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrbot)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrbot)*tmp);

d_asrh_dV_DI_BD = (model_.ftdbot)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
d_asrh_dV_SI_BS = (model_.ftdbot)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
asrh = ((model_.ftdbot)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHBOT_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHBOT_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHBOT_i)*(asrh*wsrh));
}
if (((model_.CTATBOT_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartbot)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PBOT)-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartbot)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PBOT)-(wdep*(model_.one_minus_PBOT))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartbot)*((wdep*(model_.one_minus_PBOT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatbot))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOT_i))*(model_.one_over_one_minus_PBOT))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatbot)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatbot)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatbot)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatbot)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatbot)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatbot)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatbot)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatbot)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatbot)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATBOT_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATBOT_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATBOT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOT_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PBOT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)),(model_.PBOT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv)) == 0.0)?0.0:(value_pow_0*(model_.PBOT_i)/(((model_.VBIRBOT_i)-vbbt)*(model_.VBIRBOTinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PBOT)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvbot)-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_DI_BD)/tmp/tmp);
d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PBOT)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvbot)-(((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))*d_tmp_dV_SI_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PBOT)*((((model_.VBIRBOT_i)-vbbt)*(model_.wdepnulrinvbot))/tmp));
if ((fabs(((-(model_.fbbtbot))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_DI_BD = (model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD+Vjun_s*d_Fmaxr_dV_DI_BD*Fmaxr)*tmp);
d_ibbt_dV_SI_BS = (model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS+(Vjun_s*d_Fmaxr_dV_SI_BS+d_Vjun_s_dV_SI_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTBOT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOT_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOT_i))))
{
if (((model_.PBRBOT_i)==4.0))
{

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*d_vav_dV_SI_BS*(model_.VBRinvbot)+(((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*d_vav_dV_SI_BS*(model_.VBRinvbot)+((vav*(model_.VBRinvbot))*d_vav_dV_SI_BS*(model_.VBRinvbot)+d_vav_dV_SI_BS*(model_.VBRinvbot)*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
tmp = ((((vav*(model_.VBRinvbot))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)))*(vav*(model_.VBRinvbot)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOT_i)/value_fabs_0));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvbot)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_DI_BD =  0.0;
d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopebot);
fbreakdown = ((model_.fstopbot)+((vav+((model_.alphaav)*(model_.VBRBOT_i)))*(model_.slopebot)));
}
}

d_ijunbot_s_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
d_ijunbot_s_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSSOURCE_i==0.0))
{

d_ijunsti_s_dV_SI_BS = d_ijunsti_s_dV_DI_BD =  0.0;
ijunsti_s = 0.0;

d_qjunsti_s_dV_DI_BD = d_qjunsti_s_dV_SI_BS =  0.0;
qjunsti_s = 0.0;
}
else
{
if (((model_.one_minus_PSTI)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvsti))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvsti))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti))),(model_.one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvsti))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI)/(1.0-(vj*(model_.vbiinvsti)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvsti))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvsti))));
tmp = value_pow_0;
}
}

d_qjunsti_s_dV_DI_BD = ((model_.qprefsti)*(-d_tmp_dV_DI_BD)+(model_.qpref2sti)*(-d_vj_dV_DI_BD));
d_qjunsti_s_dV_SI_BS = ((model_.qprefsti)*(-d_tmp_dV_SI_BS)+(model_.qpref2sti)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS));
qjunsti_s = (((model_.qprefsti)*(1.0-tmp))+((model_.qpref2sti)*(Vjun_s-vj)));

d_id_dV_DI_BD =  0.0;
d_id_dV_SI_BS = (model_.idsatsti)*d_idmult_dV_SI_BS;
id = ((model_.idsatsti)*idmult);
if ((((model_.CSRHSTI_i)==0.0)&&((model_.CTATSTI_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
vbi_minus_vjsrh = ((model_.vbisti)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_DI_BD =  0.0;
d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTI_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_DI_BD =  0.0;
d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTI_i))));
}
}

d_wsrh_dV_DI_BD =  0.0;
d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrsti)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrsti)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrsti)*tmp);

d_asrh_dV_DI_BD = (model_.ftdsti)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
d_asrh_dV_SI_BS = (model_.ftdsti)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
asrh = ((model_.ftdsti)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHSTI_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHSTI_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHSTI_i)*(asrh*wsrh));
}
if (((model_.CTATSTI_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartsti)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PSTI)-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartsti)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PSTI)-(wdep*(model_.one_minus_PSTI))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartsti)*((wdep*(model_.one_minus_PSTI))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatsti))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTI_i))*(model_.one_over_one_minus_PSTI))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatsti)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatsti)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatsti)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatsti)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatsti)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatsti)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatsti)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatsti)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatsti)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATSTI_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATSTI_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATSTI_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTI_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PSTI_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)),(model_.PSTI_i));
double  deriv_pow_0_d0 = (((((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv)) == 0.0)?0.0:(value_pow_0*(model_.PSTI_i)/(((model_.VBIRSTI_i)-vbbt)*(model_.VBIRSTIinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PSTI)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvsti)-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_DI_BD)/tmp/tmp);
d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PSTI)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvsti)-(((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))*d_tmp_dV_SI_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PSTI)*((((model_.VBIRSTI_i)-vbbt)*(model_.wdepnulrinvsti))/tmp));
if ((fabs(((-(model_.fbbtsti))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_DI_BD = (model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD+Vjun_s*d_Fmaxr_dV_DI_BD*Fmaxr)*tmp);
d_ibbt_dV_SI_BS = (model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS+(Vjun_s*d_Fmaxr_dV_SI_BS+d_Vjun_s_dV_SI_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTSTI_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTI_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTI_i))))
{
if (((model_.PBRSTI_i)==4.0))
{

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*d_vav_dV_SI_BS*(model_.VBRinvsti)+(((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*d_vav_dV_SI_BS*(model_.VBRinvsti)+((vav*(model_.VBRinvsti))*d_vav_dV_SI_BS*(model_.VBRinvsti)+d_vav_dV_SI_BS*(model_.VBRinvsti)*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
tmp = ((((vav*(model_.VBRinvsti))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)))*(vav*(model_.VBRinvsti)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTI_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTI_i)/value_fabs_0));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvsti)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_DI_BD =  0.0;
d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopesti);
fbreakdown = ((model_.fstopsti)+((vav+((model_.alphaav)*(model_.VBRSTI_i)))*(model_.slopesti)));
}
}

d_ijunsti_s_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
d_ijunsti_s_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGSOURCE_i==0.0))
{

d_ijungat_s_dV_SI_BS = d_ijungat_s_dV_DI_BD =  0.0;
ijungat_s = 0.0;

d_qjungat_s_dV_DI_BD = d_qjungat_s_dV_SI_BS =  0.0;
qjungat_s = 0.0;
}
else
{
if (((model_.one_minus_PGAT)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvgat))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvgat))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat))),(model_.one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvgat))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT)/(1.0-(vj*(model_.vbiinvgat)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvgat))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvgat))));
tmp = value_pow_0;
}
}

d_qjungat_s_dV_DI_BD = ((model_.qprefgat)*(-d_tmp_dV_DI_BD)+(model_.qpref2gat)*(-d_vj_dV_DI_BD));
d_qjungat_s_dV_SI_BS = ((model_.qprefgat)*(-d_tmp_dV_SI_BS)+(model_.qpref2gat)*(d_Vjun_s_dV_SI_BS-d_vj_dV_SI_BS));
qjungat_s = (((model_.qprefgat)*(1.0-tmp))+((model_.qpref2gat)*(Vjun_s-vj)));

d_id_dV_DI_BD =  0.0;
d_id_dV_SI_BS = (model_.idsatgat)*d_idmult_dV_SI_BS;
id = ((model_.idsatgat)*idmult);
if ((((model_.CSRHGAT_i)==0.0)&&((model_.CTATGAT_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_DI_BD =  0.0;
d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
vbi_minus_vjsrh = ((model_.vbigat)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_DI_BD =  0.0;
d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGAT_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_DI_BD =  0.0;
d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGAT_i))));
}
}

d_wsrh_dV_DI_BD =  0.0;
d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
wsrh = (wsrhstep+dwsrh);
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrgat)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrgat)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrgat)*tmp);

d_asrh_dV_DI_BD = (model_.ftdgat)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
d_asrh_dV_SI_BS = (model_.ftdgat)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
asrh = ((model_.ftdgat)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHGAT_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHGAT_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHGAT_i)*(asrh*wsrh));
}
if (((model_.CTATGAT_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartgat)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PGAT)-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartgat)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PGAT)-(wdep*(model_.one_minus_PGAT))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartgat)*((wdep*(model_.one_minus_PGAT))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatgat))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGAT_i))*(model_.one_over_one_minus_PGAT))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatgat)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatgat)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatgat)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatgat)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatgat)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatgat)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatgat)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatgat)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatgat)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATGAT_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATGAT_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATGAT_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGAT_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PGAT_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)),(model_.PGAT_i));
double  deriv_pow_0_d0 = (((((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv)) == 0.0)?0.0:(value_pow_0*(model_.PGAT_i)/(((model_.VBIRGAT_i)-vbbt)*(model_.VBIRGATinv))));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PGAT)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvgat)-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_DI_BD)/tmp/tmp);
d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PGAT)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvgat)-(((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))*d_tmp_dV_SI_BS)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PGAT)*((((model_.VBIRGAT_i)-vbbt)*(model_.wdepnulrinvgat))/tmp));
if ((fabs(((-(model_.fbbtgat))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_DI_BD = (model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_s*Fmaxr)*d_Fmaxr_dV_DI_BD+Vjun_s*d_Fmaxr_dV_DI_BD*Fmaxr)*tmp);
d_ibbt_dV_SI_BS = (model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_s*Fmaxr)*d_Fmaxr_dV_SI_BS+(Vjun_s*d_Fmaxr_dV_SI_BS+d_Vjun_s_dV_SI_BS*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTGAT_i)*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGAT_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGAT_i))))
{
if (((model_.PBRGAT_i)==4.0))
{

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*d_vav_dV_SI_BS*(model_.VBRinvgat)+(((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*d_vav_dV_SI_BS*(model_.VBRinvgat)+((vav*(model_.VBRinvgat))*d_vav_dV_SI_BS*(model_.VBRinvgat)+d_vav_dV_SI_BS*(model_.VBRinvgat)*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
tmp = ((((vav*(model_.VBRinvgat))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)))*(vav*(model_.VBRinvgat)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGAT_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGAT_i)/value_fabs_0));

d_tmp_dV_DI_BD =  0.0;
d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvgat)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_DI_BD =  0.0;
d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopegat);
fbreakdown = ((model_.fstopgat)+((vav+((model_.alphaav)*(model_.VBRGAT_i)))*(model_.slopegat)));
}
}

d_ijungat_s_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
d_ijungat_s_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}

d_ijun_s_dV_DI_BD = ((ABSOURCE_i*d_ijunbot_s_dV_DI_BD+LSSOURCE_i*d_ijunsti_s_dV_DI_BD)+LGSOURCE_i*d_ijungat_s_dV_DI_BD);
d_ijun_s_dV_SI_BS = ((ABSOURCE_i*d_ijunbot_s_dV_SI_BS+LSSOURCE_i*d_ijunsti_s_dV_SI_BS)+LGSOURCE_i*d_ijungat_s_dV_SI_BS);
ijun_s = (((ABSOURCE_i*ijunbot_s)+(LSSOURCE_i*ijunsti_s))+(LGSOURCE_i*ijungat_s));

d_vbbt_dV_DI_BD = d_vbbt_dV_SI_BS =  0.0;
vbbt = 0.0;

d_two_psistar_dV_DI_BD = d_two_psistar_dV_SI_BS =  0.0;
two_psistar = 0.0;
if ((!(((ABDRAIN_i==0.0)&&(LSDRAIN_i==0.0))&&(LGDRAIN_i==0.0))))
{
h1 = ((4.0*vch_d)*vch_d);
h2 = (vch_d/vfmin_d);

d_h2d_dV_SI_BS =  0.0;
d_h2d_dV_DI_BD = d_Vjun_d_dV_DI_BD;
h2d = (Vjun_d+(vch_d*h2));

d_h3_dV_SI_BS = d_h2d_dV_SI_BS;
d_h3_dV_DI_BD = d_h2d_dV_DI_BD;
h3 = (vfmin_d+h2d);

d_h4_dV_SI_BS = (-d_h2d_dV_SI_BS);
d_h4_dV_DI_BD = (-d_h2d_dV_DI_BD);
h4 = (vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_h5_dV_SI_BS = (deriv_sqrt_0_d0*((h4*d_h4_dV_SI_BS+d_h4_dV_SI_BS*h4)));
d_h5_dV_DI_BD = (deriv_sqrt_0_d0*((h4*d_h4_dV_DI_BD+d_h4_dV_DI_BD*h4)));
h5 = value_sqrt_0;
}

d_vj_dV_SI_BS = 2.0*(-(Vjun_d*vfmin_d)*(d_h3_dV_SI_BS+d_h5_dV_SI_BS)/(h3+h5)/(h3+h5));
d_vj_dV_DI_BD = 2.0*(((h3+h5)*d_Vjun_d_dV_DI_BD*vfmin_d-(Vjun_d*vfmin_d)*(d_h3_dV_DI_BD+d_h5_dV_DI_BD))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_d*vfmin_d)/(h3+h5)));
if ((Vjun_d<VMAX_d))
{
if ((fabs((0.5*(Vjun_d*(model_.phitdinv))))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_d*(model_.phitdinv))));
double  deriv_exp_0_d0 = value_exp_0;

d_zinv_dV_SI_BS =  0.0;
d_zinv_dV_DI_BD = (deriv_exp_0_d0*(0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv)));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_d*(model_.phitdinv)))<0.0))
{

d_zinv_dV_SI_BS =  0.0;
d_zinv_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(-0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv))*3.3333333333333333e-01+(-0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))+(-0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*(model_.phitdinv))))*3.3333333333333333e-01))))))));
}
else
{

d_zinv_dV_SI_BS =  0.0;
d_zinv_dV_DI_BD = 1.0e100*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv)*3.3333333333333333e-01+0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*d_Vjun_d_dV_DI_BD*(model_.phitdinv)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*(model_.phitdinv)))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_idmult_dV_SI_BS = (zinv*d_zinv_dV_SI_BS+d_zinv_dV_SI_BS*zinv);
d_idmult_dV_DI_BD = (zinv*d_zinv_dV_DI_BD+d_zinv_dV_DI_BD*zinv);
idmult = (zinv*zinv);
}
else
{

d_idmult_dV_SI_BS =  0.0;
d_idmult_dV_DI_BD = d_Vjun_d_dV_DI_BD*(model_.phitdinv)*exp_VMAX_over_phitd_d;
idmult = ((1.0+((Vjun_d-VMAX_d)*(model_.phitdinv)))*exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_zinv_dV_SI_BS = (deriv_sqrt_0_d0*(d_idmult_dV_SI_BS));
d_zinv_dV_DI_BD = (deriv_sqrt_0_d0*(d_idmult_dV_DI_BD));
zinv = value_sqrt_0;
}
}

idmult = (idmult-1.0);

d_z_dV_SI_BS = (-d_zinv_dV_SI_BS/zinv/zinv);
d_z_dV_DI_BD = (-d_zinv_dV_DI_BD/zinv/zinv);
z = (1.0/zinv);
if ((Vjun_d>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));

d_two_psistar_dV_SI_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_SI_BS+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_SI_BS+d_z_dV_SI_BS*(z+3.0)))))));
d_two_psistar_dV_DI_BD = 2.0*(model_.phitd)*(deriv_log_1_d0*((d_z_dV_DI_BD+(deriv_sqrt_0_d0*(((z+1.0)*d_z_dV_DI_BD+d_z_dV_DI_BD*(z+3.0)))))));
two_psistar = (2.0*((model_.phitd)*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));

d_two_psistar_dV_SI_BS = 2.0*(model_.phitd)*(deriv_log_1_d0*((2.0*d_zinv_dV_SI_BS+(deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dV_SI_BS+d_zinv_dV_SI_BS*(1.0+(3.0*zinv))))))));
d_two_psistar_dV_DI_BD = ((-d_Vjun_d_dV_DI_BD)+2.0*(model_.phitd)*(deriv_log_1_d0*((2.0*d_zinv_dV_DI_BD+(deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dV_DI_BD+d_zinv_dV_DI_BD*(1.0+(3.0*zinv)))))))));
two_psistar = ((-Vjun_d)+(2.0*((model_.phitd)*value_log_1)));
}
}

d_vjlim_dV_SI_BS = (-d_two_psistar_dV_SI_BS);
d_vjlim_dV_DI_BD = (-d_two_psistar_dV_DI_BD);
vjlim = (vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4.0*(model_.phitd))*(model_.phitd))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vjsrh_dV_SI_BS = 0.5*(d_vjlim_dV_SI_BS-(deriv_sqrt_0_d0*(((Vjun_d-vjlim)*(-d_vjlim_dV_SI_BS)+(-d_vjlim_dV_SI_BS)*(Vjun_d-vjlim)))));
d_vjsrh_dV_DI_BD = 0.5*((d_Vjun_d_dV_DI_BD+d_vjlim_dV_DI_BD)-(deriv_sqrt_0_d0*(((Vjun_d-vjlim)*(d_Vjun_d_dV_DI_BD-d_vjlim_dV_DI_BD)+(d_Vjun_d_dV_DI_BD-d_vjlim_dV_DI_BD)*(Vjun_d-vjlim)))));
vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d-vbbtlim_d)*(Vjun_d-vbbtlim_d))+((4.0*(model_.phitr))*(model_.phitr))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vbbt_dV_SI_BS =  0.0;
d_vbbt_dV_DI_BD = 0.5*(d_Vjun_d_dV_DI_BD-(deriv_sqrt_0_d0*(((Vjun_d-vbbtlim_d)*d_Vjun_d_dV_DI_BD+d_Vjun_d_dV_DI_BD*(Vjun_d-vbbtlim_d)))));
vbbt = (0.5*((Vjun_d+vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_vav_dV_SI_BS =  0.0;
d_vav_dV_DI_BD = 0.5*(d_Vjun_d_dV_DI_BD-(deriv_sqrt_0_d0*(((Vjun_d)*d_Vjun_d_dV_DI_BD+d_Vjun_d_dV_DI_BD*(Vjun_d)))));
vav = (0.5*(Vjun_d-value_sqrt_0));
}
}
if ((ABDRAIN_i==0.0))
{

d_ijunbot_d_dV_DI_BD = d_ijunbot_d_dV_SI_BS =  0.0;
ijunbot_d = 0.0;

d_qjunbot_d_dV_DI_BD = d_qjunbot_d_dV_SI_BS =  0.0;
qjunbot_d = 0.0;
}
else
{
if (((model_.one_minus_PBOT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvbot_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvbot_d))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvbot_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvbot_d))),(model_.one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvbot_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PBOT_d)/(1.0-(vj*(model_.vbiinvbot_d)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvbot_d))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvbot_d))));
tmp = value_pow_0;
}
}

d_qjunbot_d_dV_DI_BD = ((model_.qprefbot_d)*(-d_tmp_dV_DI_BD)+(model_.qpref2bot_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD));
d_qjunbot_d_dV_SI_BS = ((model_.qprefbot_d)*(-d_tmp_dV_SI_BS)+(model_.qpref2bot_d)*(-d_vj_dV_SI_BS));
qjunbot_d = (((model_.qprefbot_d)*(1.0-tmp))+((model_.qpref2bot_d)*(Vjun_d-vj)));

d_id_dV_SI_BS = (model_.idsatbot_d)*d_idmult_dV_SI_BS;
d_id_dV_DI_BD = (model_.idsatbot_d)*d_idmult_dV_DI_BD;
id = ((model_.idsatbot_d)*idmult);
if ((((model_.CSRHBOTD_i)==0.0)&&((model_.CTATBOTD_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
vbi_minus_vjsrh = ((model_.vbibot_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PBOTD_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PBOTD_i)));
d_dwsrh_dV_DI_BD = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD))+(wsrhstep*d_wsrhstep_dV_DI_BD+d_wsrhstep_dV_DI_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PBOTD_i))));
}
}

d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(vbi_minus_vjsrh*(model_.VBIRBOTinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRBOTinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRBOTinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrbot_d)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrbot_d)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrbot_d)*tmp);

d_asrh_dV_SI_BS = (model_.ftdbot_d)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
d_asrh_dV_DI_BD = (model_.ftdbot_d)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
asrh = ((model_.ftdbot_d)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHBOTD_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHBOTD_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHBOTD_i)*(asrh*wsrh));
}
if (((model_.CTATBOTD_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartbot_d)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PBOT_d)-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartbot_d)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PBOT_d)-(wdep*(model_.one_minus_PBOT_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartbot_d)*((wdep*(model_.one_minus_PBOT_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatbot_d))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatbot_d))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PBOTD_i))*(model_.one_over_one_minus_PBOT_d))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatbot_d)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatbot_d)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatbot_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatbot_d)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatbot_d)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatbot_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatbot_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatbot_d)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatbot_d)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatbot_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatbot_d)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATBOTD_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATBOTD_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATBOTD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTBOTD_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PBOTD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRBOTinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)),(model_.PBOTD_i));
double  deriv_pow_0_d0 = (((((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PBOTD_i)/(((model_.VBIRBOTD_i)-vbbt)*(model_.VBIRBOTinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRBOTinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRBOTinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PBOT_d)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvbot_d)-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_SI_BS)/tmp/tmp);
d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PBOT_d)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvbot_d)-(((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))*d_tmp_dV_DI_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PBOT_d)*((((model_.VBIRBOTD_i)-vbbt)*(model_.wdepnulrinvbot_d))/tmp));
if ((fabs(((-(model_.fbbtbot_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtbot_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtbot_d))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtbot_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtbot_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtbot_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_SI_BS = (model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS+Vjun_d*d_Fmaxr_dV_SI_BS*Fmaxr)*tmp);
d_ibbt_dV_DI_BD = (model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD+(Vjun_d*d_Fmaxr_dV_DI_BD+d_Vjun_d_dV_DI_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTBOTD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRBOTD_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRBOTD_i))))
{
if (((model_.PBRBOTD_i)==4.0))
{

d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*d_vav_dV_SI_BS*(model_.VBRinvbot_d)+(((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*d_vav_dV_SI_BS*(model_.VBRinvbot_d)+((vav*(model_.VBRinvbot_d))*d_vav_dV_SI_BS*(model_.VBRinvbot_d)+d_vav_dV_SI_BS*(model_.VBRinvbot_d)*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
d_tmp_dV_DI_BD = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*d_vav_dV_DI_BD*(model_.VBRinvbot_d)+(((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*d_vav_dV_DI_BD*(model_.VBRinvbot_d)+((vav*(model_.VBRinvbot_d))*d_vav_dV_DI_BD*(model_.VBRinvbot_d)+d_vav_dV_DI_BD*(model_.VBRinvbot_d)*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
tmp = ((((vav*(model_.VBRinvbot_d))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)))*(vav*(model_.VBRinvbot_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvbot_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRBOTD_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvbot_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRBOTD_i)/value_fabs_0));

d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvbot_d)))));
d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_DI_BD*(model_.VBRinvbot_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopebot_d);
d_fbreakdown_dV_DI_BD = d_vav_dV_DI_BD*(model_.slopebot_d);
fbreakdown = ((model_.fstopbot_d)+((vav+((model_.alphaav)*(model_.VBRBOTD_i)))*(model_.slopebot_d)));
}
}

d_ijunbot_d_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
d_ijunbot_d_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LSDRAIN_i==0.0))
{

d_ijunsti_d_dV_DI_BD = d_ijunsti_d_dV_SI_BS =  0.0;
ijunsti_d = 0.0;

d_qjunsti_d_dV_DI_BD = d_qjunsti_d_dV_SI_BS =  0.0;
qjunsti_d = 0.0;
}
else
{
if (((model_.one_minus_PSTI_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvsti_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvsti_d))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvsti_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvsti_d))),(model_.one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvsti_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PSTI_d)/(1.0-(vj*(model_.vbiinvsti_d)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvsti_d))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvsti_d))));
tmp = value_pow_0;
}
}

d_qjunsti_d_dV_DI_BD = ((model_.qprefsti_d)*(-d_tmp_dV_DI_BD)+(model_.qpref2sti_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD));
d_qjunsti_d_dV_SI_BS = ((model_.qprefsti_d)*(-d_tmp_dV_SI_BS)+(model_.qpref2sti_d)*(-d_vj_dV_SI_BS));
qjunsti_d = (((model_.qprefsti_d)*(1.0-tmp))+((model_.qpref2sti_d)*(Vjun_d-vj)));

d_id_dV_SI_BS = (model_.idsatsti_d)*d_idmult_dV_SI_BS;
d_id_dV_DI_BD = (model_.idsatsti_d)*d_idmult_dV_DI_BD;
id = ((model_.idsatsti_d)*idmult);
if ((((model_.CSRHSTID_i)==0.0)&&((model_.CTATSTID_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
vbi_minus_vjsrh = ((model_.vbisti_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PSTID_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PSTID_i)));
d_dwsrh_dV_DI_BD = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD))+(wsrhstep*d_wsrhstep_dV_DI_BD+d_wsrhstep_dV_DI_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PSTID_i))));
}
}

d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(vbi_minus_vjsrh*(model_.VBIRSTIinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRSTIinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRSTIinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrsti_d)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrsti_d)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrsti_d)*tmp);

d_asrh_dV_SI_BS = (model_.ftdsti_d)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
d_asrh_dV_DI_BD = (model_.ftdsti_d)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
asrh = ((model_.ftdsti_d)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHSTID_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHSTID_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHSTID_i)*(asrh*wsrh));
}
if (((model_.CTATSTID_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartsti_d)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PSTI_d)-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartsti_d)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PSTI_d)-(wdep*(model_.one_minus_PSTI_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartsti_d)*((wdep*(model_.one_minus_PSTI_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatsti_d))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatsti_d))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PSTID_i))*(model_.one_over_one_minus_PSTI_d))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatsti_d)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatsti_d)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatsti_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatsti_d)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatsti_d)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatsti_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatsti_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatsti_d)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatsti_d)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatsti_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatsti_d)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATSTID_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATSTID_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATSTID_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTSTID_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PSTID_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRSTIinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)),(model_.PSTID_i));
double  deriv_pow_0_d0 = (((((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PSTID_i)/(((model_.VBIRSTID_i)-vbbt)*(model_.VBIRSTIinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRSTIinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRSTIinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PSTI_d)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvsti_d)-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_SI_BS)/tmp/tmp);
d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PSTI_d)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvsti_d)-(((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))*d_tmp_dV_DI_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PSTI_d)*((((model_.VBIRSTID_i)-vbbt)*(model_.wdepnulrinvsti_d))/tmp));
if ((fabs(((-(model_.fbbtsti_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtsti_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtsti_d))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtsti_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtsti_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtsti_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_SI_BS = (model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS+Vjun_d*d_Fmaxr_dV_SI_BS*Fmaxr)*tmp);
d_ibbt_dV_DI_BD = (model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD+(Vjun_d*d_Fmaxr_dV_DI_BD+d_Vjun_d_dV_DI_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTSTID_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRSTID_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRSTID_i))))
{
if (((model_.PBRSTID_i)==4.0))
{

d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*d_vav_dV_SI_BS*(model_.VBRinvsti_d)+(((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*d_vav_dV_SI_BS*(model_.VBRinvsti_d)+((vav*(model_.VBRinvsti_d))*d_vav_dV_SI_BS*(model_.VBRinvsti_d)+d_vav_dV_SI_BS*(model_.VBRinvsti_d)*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
d_tmp_dV_DI_BD = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*d_vav_dV_DI_BD*(model_.VBRinvsti_d)+(((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*d_vav_dV_DI_BD*(model_.VBRinvsti_d)+((vav*(model_.VBRinvsti_d))*d_vav_dV_DI_BD*(model_.VBRinvsti_d)+d_vav_dV_DI_BD*(model_.VBRinvsti_d)*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
tmp = ((((vav*(model_.VBRinvsti_d))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)))*(vav*(model_.VBRinvsti_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvsti_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRSTID_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvsti_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRSTID_i)/value_fabs_0));

d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvsti_d)))));
d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_DI_BD*(model_.VBRinvsti_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopesti_d);
d_fbreakdown_dV_DI_BD = d_vav_dV_DI_BD*(model_.slopesti_d);
fbreakdown = ((model_.fstopsti_d)+((vav+((model_.alphaav)*(model_.VBRSTID_i)))*(model_.slopesti_d)));
}
}

d_ijunsti_d_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
d_ijunsti_d_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((LGDRAIN_i==0.0))
{

d_ijungat_d_dV_DI_BD = d_ijungat_d_dV_SI_BS =  0.0;
ijungat_d = 0.0;

d_qjungat_d_dV_DI_BD = d_qjungat_d_dV_SI_BS =  0.0;
qjungat_d = 0.0;
}
else
{
if (((model_.one_minus_PGAT_d)==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*(model_.vbiinvgat_d))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvgat_d))));
d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvgat_d))));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*(model_.vbiinvgat_d))),(model_.one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0-(vj*(model_.vbiinvgat_d))) == 0.0)?0.0:(value_pow_0*(model_.one_minus_PGAT_d)/(1.0-(vj*(model_.vbiinvgat_d)))));

d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vj_dV_DI_BD*(model_.vbiinvgat_d))));
d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vj_dV_SI_BS*(model_.vbiinvgat_d))));
tmp = value_pow_0;
}
}

d_qjungat_d_dV_DI_BD = ((model_.qprefgat_d)*(-d_tmp_dV_DI_BD)+(model_.qpref2gat_d)*(d_Vjun_d_dV_DI_BD-d_vj_dV_DI_BD));
d_qjungat_d_dV_SI_BS = ((model_.qprefgat_d)*(-d_tmp_dV_SI_BS)+(model_.qpref2gat_d)*(-d_vj_dV_SI_BS));
qjungat_d = (((model_.qprefgat_d)*(1.0-tmp))+((model_.qpref2gat_d)*(Vjun_d-vj)));

d_id_dV_SI_BS = (model_.idsatgat_d)*d_idmult_dV_SI_BS;
d_id_dV_DI_BD = (model_.idsatgat_d)*d_idmult_dV_DI_BD;
id = ((model_.idsatgat_d)*idmult);
if ((((model_.CSRHGATD_i)==0.0)&&((model_.CTATGATD_i)==0.0)))
{

d_isrh_dV_SI_BS = d_isrh_dV_DI_BD =  0.0;
isrh = 0.0;
}
else
{

d_vbi_minus_vjsrh_dV_SI_BS = (-d_vjsrh_dV_SI_BS);
d_vbi_minus_vjsrh_dV_DI_BD = (-d_vjsrh_dV_DI_BD);
vbi_minus_vjsrh = ((model_.vbigat_d)-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_wsrhstep_dV_SI_BS = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_SI_BS-two_psistar*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
d_wsrhstep_dV_DI_BD = (-(deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dV_DI_BD-two_psistar*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh)))));
wsrhstep = (1.0-value_sqrt_0);
}
if (((model_.PGATD_i)==0.5))
{

d_dwsrh_dV_DI_BD = d_dwsrh_dV_SI_BS =  0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);

d_dwsrh_dV_SI_BS = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_SI_BS))+(wsrhstep*d_wsrhstep_dV_SI_BS+d_wsrhstep_dV_SI_BS*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_SI_BS))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_SI_BS)*(1.0-(2.0*(model_.PGATD_i)));
d_dwsrh_dV_DI_BD = ((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*(deriv_log_0_d0*(d_wsrhstep_dV_DI_BD))+(wsrhstep*d_wsrhstep_dV_DI_BD+d_wsrhstep_dV_DI_BD*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dV_DI_BD))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dV_DI_BD)*(1.0-(2.0*(model_.PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*(model_.PGATD_i))));
}
}

d_wsrh_dV_SI_BS = (d_wsrhstep_dV_SI_BS+d_dwsrh_dV_SI_BS);
d_wsrh_dV_DI_BD = (d_wsrhstep_dV_DI_BD+d_dwsrh_dV_DI_BD);
wsrh = (wsrhstep+dwsrh);
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*(model_.VBIRGATinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*(model_.VBIRGATinv_d)),(model_.PGATD_i));
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(vbi_minus_vjsrh*(model_.VBIRGATinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_SI_BS*(model_.VBIRGATinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*(d_vbi_minus_vjsrh_dV_DI_BD*(model_.VBIRGATinv_d)));
tmp = value_pow_0;
}
}

d_wdep_dV_DI_BD = (model_.wdepnulrgat_d)*d_tmp_dV_DI_BD;
d_wdep_dV_SI_BS = (model_.wdepnulrgat_d)*d_tmp_dV_SI_BS;
wdep = ((model_.wdepnulrgat_d)*tmp);

d_asrh_dV_SI_BS = (model_.ftdgat_d)*((zinv-1.0)*d_wdep_dV_SI_BS+d_zinv_dV_SI_BS*wdep);
d_asrh_dV_DI_BD = (model_.ftdgat_d)*((zinv-1.0)*d_wdep_dV_DI_BD+d_zinv_dV_DI_BD*wdep);
asrh = ((model_.ftdgat_d)*((zinv-1.0)*wdep));

d_isrh_dV_DI_BD = (model_.CSRHGATD_i)*(asrh*d_wsrh_dV_DI_BD+d_asrh_dV_DI_BD*wsrh);
d_isrh_dV_SI_BS = (model_.CSRHGATD_i)*(asrh*d_wsrh_dV_SI_BS+d_asrh_dV_SI_BS*wsrh);
isrh = ((model_.CSRHGATD_i)*(asrh*wsrh));
}
if (((model_.CTATGATD_i)==0.0))
{

d_itat_dV_SI_BS = d_itat_dV_DI_BD =  0.0;
itat = 0.0;
}
else
{

d_btat_dV_DI_BD = (model_.btatpartgat_d)*((vbi_minus_vjsrh*d_wdep_dV_DI_BD*(model_.one_minus_PGAT_d)-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_DI_BD)/vbi_minus_vjsrh/vbi_minus_vjsrh);
d_btat_dV_SI_BS = (model_.btatpartgat_d)*((vbi_minus_vjsrh*d_wdep_dV_SI_BS*(model_.one_minus_PGAT_d)-(wdep*(model_.one_minus_PGAT_d))*d_vbi_minus_vjsrh_dV_SI_BS)/vbi_minus_vjsrh/vbi_minus_vjsrh);
btat = ((model_.btatpartgat_d)*((wdep*(model_.one_minus_PGAT_d))/vbi_minus_vjsrh));

d_twoatatoverthreebtat_dV_DI_BD = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_DI_BD/btat/btat);
d_twoatatoverthreebtat_dV_SI_BS = (-(0.666666666666667*(model_.atatgat_d))*d_btat_dV_SI_BS/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*(model_.atatgat_d))/btat);

d_umaxbeforelimiting_dV_DI_BD = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*twoatatoverthreebtat);
d_umaxbeforelimiting_dV_SI_BS = (twoatatoverthreebtat*d_twoatatoverthreebtat_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_umax_dV_DI_BD = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_DI_BD+d_umaxbeforelimiting_dV_DI_BD*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
d_umax_dV_SI_BS = (deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dV_SI_BS+d_umaxbeforelimiting_dV_SI_BS*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0))));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);

d_sqrtumax_dV_DI_BD = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_DI_BD))));
d_sqrtumax_dV_SI_BS = (deriv_sqrt_1_d0*((deriv_fabs_0_d0*(d_umax_dV_SI_BS))));
sqrtumax = value_sqrt_1;
}

d_umaxpoweronepointfive_dV_DI_BD = (umax*d_sqrtumax_dV_DI_BD+d_umax_dV_DI_BD*sqrtumax);
d_umaxpoweronepointfive_dV_SI_BS = (umax*d_sqrtumax_dV_SI_BS+d_umax_dV_SI_BS*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))==(-1.0)))
{

d_wgamma_dV_DI_BD = (-(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (-(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d)));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-(model_.PGATD_i))*(model_.one_over_one_minus_PGAT_d))/(1.0+(btat*umaxpoweronepointfive))));

d_wgamma_dV_DI_BD = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive)));
d_wgamma_dV_SI_BS = (deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive)));
wgamma = value_pow_0;
}
}

d_wtat_dV_SI_BS = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_SI_BS+d_wsrh_dV_SI_BS*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_SI_BS+d_wgamma_dV_SI_BS))/(wsrh+wgamma)/(wsrh+wgamma));
d_wtat_dV_DI_BD = (((wsrh+wgamma)*(wsrh*d_wgamma_dV_DI_BD+d_wsrh_dV_DI_BD*wgamma)-(wsrh*wgamma)*(d_wsrh_dV_DI_BD+d_wgamma_dV_DI_BD))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_ktat_dV_DI_BD = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_DI_BD-btat*d_sqrtumax_dV_DI_BD)/sqrtumax/sqrtumax)));
d_ktat_dV_SI_BS = (deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dV_SI_BS-btat*d_sqrtumax_dV_SI_BS)/sqrtumax/sqrtumax)));
ktat = value_sqrt_0;
}

d_ltat_dV_DI_BD = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_DI_BD+d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-d_umax_dV_DI_BD);
d_ltat_dV_SI_BS = (2.0*(twoatatoverthreebtat*d_sqrtumax_dV_SI_BS+d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-d_umax_dV_SI_BS);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);

d_mtat_dV_DI_BD = (((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_DI_BD+(model_.atatgat_d)*d_twoatatoverthreebtat_dV_DI_BD*sqrtumax)-(model_.atatgat_d)*d_umax_dV_DI_BD)+0.5*(btat*d_umaxpoweronepointfive_dV_DI_BD+d_btat_dV_DI_BD*umaxpoweronepointfive));
d_mtat_dV_SI_BS = (((((model_.atatgat_d)*twoatatoverthreebtat)*d_sqrtumax_dV_SI_BS+(model_.atatgat_d)*d_twoatatoverthreebtat_dV_SI_BS*sqrtumax)-(model_.atatgat_d)*d_umax_dV_SI_BS)+0.5*(btat*d_umaxpoweronepointfive_dV_SI_BS+d_btat_dV_SI_BS*umaxpoweronepointfive));
mtat = (((((model_.atatgat_d)*twoatatoverthreebtat)*sqrtumax)-((model_.atatgat_d)*umax))+(0.5*(btat*umaxpoweronepointfive)));

d_xerfc_dV_DI_BD = ((ltat-1.0)*d_ktat_dV_DI_BD+d_ltat_dV_DI_BD*ktat);
d_xerfc_dV_SI_BS = ((ltat-1.0)*d_ktat_dV_SI_BS+d_ltat_dV_SI_BS*ktat);
xerfc = ((ltat-1.0)*ktat);

d_ysq_dV_DI_BD = (xerfc*d_xerfc_dV_DI_BD+d_xerfc_dV_DI_BD*xerfc);
d_ysq_dV_SI_BS = (xerfc*d_xerfc_dV_SI_BS+d_xerfc_dV_SI_BS*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{

d_terfc_dV_DI_BD = (-(model_.perfc)*d_xerfc_dV_DI_BD/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(model_.perfc)*d_xerfc_dV_SI_BS/(1.0+((model_.perfc)*xerfc))/(1.0+((model_.perfc)*xerfc)));
terfc = (1.0/(1.0+((model_.perfc)*xerfc)));
}
else
{

d_terfc_dV_DI_BD = (-(-(model_.perfc)*d_xerfc_dV_DI_BD)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
d_terfc_dV_SI_BS = (-(-(model_.perfc)*d_xerfc_dV_SI_BS)/(1.0-((model_.perfc)*xerfc))/(1.0-((model_.perfc)*xerfc)));
terfc = (1.0/(1.0-((model_.perfc)*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS)));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*3.3333333333333333e-01+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_DI_BD)+d_mtat_dV_DI_BD))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*3.3333333333333333e-01+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dV_SI_BS)+d_mtat_dV_SI_BS))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}

d_erfcpos_dV_DI_BD = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_DI_BD+((0.29214664*d_terfc_dV_DI_BD+(model_.berfc)*(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_DI_BD+(terfc*d_terfc_dV_DI_BD+d_terfc_dV_DI_BD*terfc)*terfc))*tmp);
d_erfcpos_dV_SI_BS = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*d_tmp_dV_SI_BS+((0.29214664*d_terfc_dV_SI_BS+(model_.berfc)*(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc))+(model_.cerfc)*((terfc*terfc)*d_terfc_dV_SI_BS+(terfc*d_terfc_dV_SI_BS+d_terfc_dV_SI_BS*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+((model_.berfc)*(terfc*terfc)))+((model_.cerfc)*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{

d_erfctimesexpmtat_dV_DI_BD = d_erfcpos_dV_DI_BD;
d_erfctimesexpmtat_dV_SI_BS = d_erfcpos_dV_SI_BS;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*(d_mtat_dV_DI_BD));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*(d_mtat_dV_SI_BS));
tmp = value_exp_0;
}
}
else
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_DI_BD)*3.3333333333333333e-01+(-d_mtat_dV_DI_BD)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_DI_BD)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dV_SI_BS)*3.3333333333333333e-01+(-d_mtat_dV_SI_BS)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dV_SI_BS)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}

d_erfctimesexpmtat_dV_DI_BD = (2.0*d_tmp_dV_DI_BD-d_erfcpos_dV_DI_BD);
d_erfctimesexpmtat_dV_SI_BS = (2.0*d_tmp_dV_SI_BS-d_erfcpos_dV_SI_BS);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}

d_gammamax_dV_DI_BD = (1.77245385090551603*0.5)*((ktat*(model_.atatgat_d)*d_erfctimesexpmtat_dV_DI_BD-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_DI_BD)/ktat/ktat);
d_gammamax_dV_SI_BS = (1.77245385090551603*0.5)*((ktat*(model_.atatgat_d)*d_erfctimesexpmtat_dV_SI_BS-((model_.atatgat_d)*erfctimesexpmtat)*d_ktat_dV_SI_BS)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*(((model_.atatgat_d)*erfctimesexpmtat)/ktat));

d_itat_dV_DI_BD = (model_.CTATGATD_i)*((asrh*gammamax)*d_wtat_dV_DI_BD+(asrh*d_gammamax_dV_DI_BD+d_asrh_dV_DI_BD*gammamax)*wtat);
d_itat_dV_SI_BS = (model_.CTATGATD_i)*((asrh*gammamax)*d_wtat_dV_SI_BS+(asrh*d_gammamax_dV_SI_BS+d_asrh_dV_SI_BS*gammamax)*wtat);
itat = ((model_.CTATGATD_i)*((asrh*gammamax)*wtat));
}
if (((model_.CBBTGATD_i)==0.0))
{

d_ibbt_dV_SI_BS = d_ibbt_dV_DI_BD =  0.0;
ibbt = 0.0;
}
else
{
if (((model_.PGATD_i)==0.5))
{
{
double value_sqrt_0 = sqrt((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_tmp_dV_SI_BS = (deriv_sqrt_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv_d)));
d_tmp_dV_DI_BD = (deriv_sqrt_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRGATinv_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)),(model_.PGATD_i));
double  deriv_pow_0_d0 = (((((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d)) == 0.0)?0.0:(value_pow_0*(model_.PGATD_i)/(((model_.VBIRGATD_i)-vbbt)*(model_.VBIRGATinv_d))));

d_tmp_dV_SI_BS = (deriv_pow_0_d0*((-d_vbbt_dV_SI_BS)*(model_.VBIRGATinv_d)));
d_tmp_dV_DI_BD = (deriv_pow_0_d0*((-d_vbbt_dV_DI_BD)*(model_.VBIRGATinv_d)));
tmp = value_pow_0;
}
}

d_Fmaxr_dV_SI_BS = (model_.one_over_one_minus_PGAT_d)*((tmp*(-d_vbbt_dV_SI_BS)*(model_.wdepnulrinvgat_d)-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_SI_BS)/tmp/tmp);
d_Fmaxr_dV_DI_BD = (model_.one_over_one_minus_PGAT_d)*((tmp*(-d_vbbt_dV_DI_BD)*(model_.wdepnulrinvgat_d)-(((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))*d_tmp_dV_DI_BD)/tmp/tmp);
Fmaxr = ((model_.one_over_one_minus_PGAT_d)*((((model_.VBIRGATD_i)-vbbt)*(model_.wdepnulrinvgat_d))/tmp));
if ((fabs(((-(model_.fbbtgat_d))/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-(model_.fbbtgat_d))/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;

d_tmp_dV_DI_BD = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)));
d_tmp_dV_SI_BS = (deriv_exp_0_d0*((-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)));
tmp = value_exp_0;
}
}
else
{
if ((((-(model_.fbbtgat_d))/Fmaxr)<0.0))
{

d_tmp_dV_DI_BD = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
d_tmp_dV_SI_BS = (-1.0e-100*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))+(-(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-(model_.fbbtgat_d))/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{

d_tmp_dV_DI_BD = 1.0e100*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_DI_BD/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
d_tmp_dV_SI_BS = 1.0e100*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*3.3333333333333333e-01+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-(-(model_.fbbtgat_d))*d_Fmaxr_dV_SI_BS/Fmaxr/Fmaxr)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-(model_.fbbtgat_d))/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}

d_ibbt_dV_SI_BS = (model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_SI_BS+((Vjun_d*Fmaxr)*d_Fmaxr_dV_SI_BS+Vjun_d*d_Fmaxr_dV_SI_BS*Fmaxr)*tmp);
d_ibbt_dV_DI_BD = (model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dV_DI_BD+((Vjun_d*Fmaxr)*d_Fmaxr_dV_DI_BD+(Vjun_d*d_Fmaxr_dV_DI_BD+d_Vjun_d_dV_DI_BD*Fmaxr)*Fmaxr)*tmp);
ibbt = ((model_.CBBTGATD_i)*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if (((model_.VBRGATD_i)>1.0e3))
{

d_fbreakdown_dV_SI_BS = d_fbreakdown_dV_DI_BD =  0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-(model_.alphaav))*(model_.VBRGATD_i))))
{
if (((model_.PBRGATD_i)==4.0))
{

d_tmp_dV_SI_BS = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*d_vav_dV_SI_BS*(model_.VBRinvgat_d)+(((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*d_vav_dV_SI_BS*(model_.VBRinvgat_d)+((vav*(model_.VBRinvgat_d))*d_vav_dV_SI_BS*(model_.VBRinvgat_d)+d_vav_dV_SI_BS*(model_.VBRinvgat_d)*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
d_tmp_dV_DI_BD = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*d_vav_dV_DI_BD*(model_.VBRinvgat_d)+(((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*d_vav_dV_DI_BD*(model_.VBRinvgat_d)+((vav*(model_.VBRinvgat_d))*d_vav_dV_DI_BD*(model_.VBRinvgat_d)+d_vav_dV_DI_BD*(model_.VBRinvgat_d)*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
tmp = ((((vav*(model_.VBRinvgat_d))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)))*(vav*(model_.VBRinvgat_d)));
}
else
{
{
double value_fabs_0 = fabs((vav*(model_.VBRinvgat_d)));
double value_pow_1 = pow(value_fabs_0,(model_.PBRGATD_i));
double  deriv_fabs_0_d0 = ((((vav*(model_.VBRinvgat_d)))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*(model_.PBRGATD_i)/value_fabs_0));

d_tmp_dV_SI_BS = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_SI_BS*(model_.VBRinvgat_d)))));
d_tmp_dV_DI_BD = (deriv_pow_1_d0*((deriv_fabs_0_d0*(d_vav_dV_DI_BD*(model_.VBRinvgat_d)))));
tmp = value_pow_1;
}
}

d_fbreakdown_dV_DI_BD = (-(-d_tmp_dV_DI_BD)/(1.0-tmp)/(1.0-tmp));
d_fbreakdown_dV_SI_BS = (-(-d_tmp_dV_SI_BS)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{

d_fbreakdown_dV_SI_BS = d_vav_dV_SI_BS*(model_.slopegat_d);
d_fbreakdown_dV_DI_BD = d_vav_dV_DI_BD*(model_.slopegat_d);
fbreakdown = ((model_.fstopgat_d)+((vav+((model_.alphaav)*(model_.VBRGATD_i)))*(model_.slopegat_d)));
}
}

d_ijungat_d_dV_SI_BS = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_SI_BS+(((d_id_dV_SI_BS+d_isrh_dV_SI_BS)+d_itat_dV_SI_BS)+d_ibbt_dV_SI_BS)*fbreakdown);
d_ijungat_d_dV_DI_BD = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dV_DI_BD+(((d_id_dV_DI_BD+d_isrh_dV_DI_BD)+d_itat_dV_DI_BD)+d_ibbt_dV_DI_BD)*fbreakdown);
ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}

d_ijun_d_dV_SI_BS = ((ABDRAIN_i*d_ijunbot_d_dV_SI_BS+LSDRAIN_i*d_ijunsti_d_dV_SI_BS)+LGDRAIN_i*d_ijungat_d_dV_SI_BS);
d_ijun_d_dV_DI_BD = ((ABDRAIN_i*d_ijunbot_d_dV_DI_BD+LSDRAIN_i*d_ijunsti_d_dV_DI_BD)+LGDRAIN_i*d_ijungat_d_dV_DI_BD);
ijun_d = (((ABDRAIN_i*ijunbot_d)+(LSDRAIN_i*ijunsti_d))+(LGDRAIN_i*ijungat_d));
}
}
rgatenoise = ((model_.nt0)*ggate);
rsourcenoise = ((model_.nt0)*gsource);
rdrainnoise = ((model_.nt0)*gdrain);
rbulknoise = ((model_.nt0)*gbulk);
rjunsnoise = ((model_.nt0)*gjuns);
rjundnoise = ((model_.nt0)*gjund);
rwellnoise = ((model_.nt0)*gwell);
}
// End block evaluateStaticDynamic
//Begin block loadStatic
{
if ((sigVds>0.0))
{
// I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP;
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI;
// I(DI,SI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP);
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI);
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI);
staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP);
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI);
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI);
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI;
staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP;
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI;
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI;
staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI;
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI;
}
else
{
// I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP;
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Iimpact);
d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_SI_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_GP_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Iimpact_dV_DI_SI;
// I(SI,DI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP);
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI);
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI);
staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*(Ids+Idsedge));
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP);
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI);
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*(d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI);
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI;
staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcs);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_SI_BP;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_DI_SI;
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcs_dV_GP_SI;
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI;
staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igcd);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_SI_BP;
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_DI_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igcd_dV_GP_SI;
}
// I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igb);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_SI;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igb);
d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_SI_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_DI_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igb_dV_GP_SI;
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igsov))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igsov);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_SI;
staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*Igsov);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_SI_BP;
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_DI_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igsov_dV_GP_SI;
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igdov))
staticContributions[admsNodeID_GP] += (((model_.CHNL_TYPE)*MULT_i)*Igdov);
d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_SI_BP;
d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_DI_SI;
d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_SI;
staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*Igdov);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_SI_BP;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_DI_SI;
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igdov_dV_GP_SI;
// I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
staticContributions[admsNodeID_SI] += (((model_.CHNL_TYPE)*MULT_i)*Igisl);
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_DI_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_SI;
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_SI_BP;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igisl);
d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_DI_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_GP_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igisl_dV_SI_BP;
// I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
staticContributions[admsNodeID_DI] += (((model_.CHNL_TYPE)*MULT_i)*Igidl);
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_SI;
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_SI_BP;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_DI_SI;
staticContributions[admsNodeID_BP] -= (((model_.CHNL_TYPE)*MULT_i)*Igidl);
d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_GP_SI;
d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_SI_BP;
d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= ((model_.CHNL_TYPE)*MULT_i)*d_Igidl_dV_DI_SI;
// I(BS,SI) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
staticContributions[admsNodeID_BS] += (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_SI_BS;
d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_DI_BD;
staticContributions[admsNodeID_SI] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_s);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_SI_BS;
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_s_dV_DI_BD;
// I(BD,DI) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
staticContributions[admsNodeID_BD] += (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_SI_BS;
d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD] += ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_DI_BD;
staticContributions[admsNodeID_DI] -= (((model_.CHNL_TYPE)*MULT_i)*ijun_d);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_SI_BS;
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] -= ((model_.CHNL_TYPE)*MULT_i)*d_ijun_d_dV_DI_BD;
if ((RG_i>0.0))
{
// I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
staticContributions[admsNodeID_G] += ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] += (MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP];
staticContributions[admsNodeID_GP] -= ((MULT_i*ggate)*(probeVars[admsProbeID_V_G_GP]));
d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] -= (MULT_i*ggate)*d_probeVars[admsProbeID_V_G_GP][admsProbeID_V_G_GP];
// I(G,GP) <+ (white_noise((MULT_i*rgatenoise),"rgate"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[0]= (MULT_i*rgatenoise);
}
}
else
{
// V(G,GP) <+ (0.0)
// do nothing at all
}
if ((RSE_i>0.0))
{
// I(S,SI) <+ (((MULT_i*gsource)*V(S,SI)))
staticContributions[admsNodeID_S] += ((MULT_i*gsource)*(probeVars[admsProbeID_V_S_SI]));
d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI] += (MULT_i*gsource)*d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI];
staticContributions[admsNodeID_SI] -= ((MULT_i*gsource)*(probeVars[admsProbeID_V_S_SI]));
d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] -= (MULT_i*gsource)*d_probeVars[admsProbeID_V_S_SI][admsProbeID_V_S_SI];
// I(S,SI) <+ (white_noise((MULT_i*rsourcenoise),"rsource"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[1]= (MULT_i*rsourcenoise);
}
}
else
{
// V(S,SI) <+ (0.0)
// do nothing at all
}
if ((RDE_i>0.0))
{
// I(D,DI) <+ (((MULT_i*gdrain)*V(D,DI)))
staticContributions[admsNodeID_D] += ((MULT_i*gdrain)*(probeVars[admsProbeID_V_D_DI]));
d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI] += (MULT_i*gdrain)*d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI];
staticContributions[admsNodeID_DI] -= ((MULT_i*gdrain)*(probeVars[admsProbeID_V_D_DI]));
d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] -= (MULT_i*gdrain)*d_probeVars[admsProbeID_V_D_DI][admsProbeID_V_D_DI];
// I(D,DI) <+ (white_noise((MULT_i*rdrainnoise),"rdrain"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[2]= (MULT_i*rdrainnoise);
}
}
else
{
// V(D,DI) <+ (0.0)
// do nothing at all
}
if ((RBULK_i>0.0))
{
// I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
staticContributions[admsNodeID_BP] += ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] += (MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gbulk)*(probeVars[admsProbeID_V_BP_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] -= (MULT_i*gbulk)*d_probeVars[admsProbeID_V_BP_BI][admsProbeID_V_BP_BI];
// I(BP,BI) <+ (white_noise((MULT_i*rbulknoise),"rbulk"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[3]= (MULT_i*rbulknoise);
}
}
else
{
// V(BP,BI) <+ (0.0)
// do nothing at all
}
if ((RJUNS_i>0.0))
{
// I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
staticContributions[admsNodeID_BS] += ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] += (MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gjuns)*(probeVars[admsProbeID_V_BS_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -= (MULT_i*gjuns)*d_probeVars[admsProbeID_V_BS_BI][admsProbeID_V_BS_BI];
// I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise),"rjuns"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[4]= (MULT_i*rjunsnoise);
}
}
else
{
// V(BS,BI) <+ (0.0)
// do nothing at all
}
if ((RJUND_i>0.0))
{
// I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
staticContributions[admsNodeID_BD] += ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] += (MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gjund)*(probeVars[admsProbeID_V_BD_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -= (MULT_i*gjund)*d_probeVars[admsProbeID_V_BD_BI][admsProbeID_V_BD_BI];
// I(BD,BI) <+ (white_noise((MULT_i*rjundnoise),"rjund"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[5]= (MULT_i*rjundnoise);
}
}
else
{
// V(BD,BI) <+ (0.0)
// do nothing at all
}
if ((RWELL_i>0.0))
{
// I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
staticContributions[admsNodeID_B] += ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] += (MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI];
staticContributions[admsNodeID_BI] -= ((MULT_i*gwell)*(probeVars[admsProbeID_V_B_BI]));
d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -= (MULT_i*gwell)*d_probeVars[admsProbeID_V_B_BI][admsProbeID_V_B_BI];
// I(B,BI) <+ (white_noise((MULT_i*rwellnoise),"rwell"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[6]= (MULT_i*rwellnoise);
}
}
else
{
// V(B,BI) <+ (0.0)
// do nothing at all
}
// I(DI,SI) <+ ((1E-15*V(DI,SI)))
staticContributions[admsNodeID_DI] += (1E-15*(probeVars[admsProbeID_V_DI_SI]));
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += 1E-15*d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI];
staticContributions[admsNodeID_SI] -= (1E-15*(probeVars[admsProbeID_V_DI_SI]));
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= 1E-15*d_probeVars[admsProbeID_V_DI_SI][admsProbeID_V_DI_SI];
}
// End block loadStatic
//Begin block loadStaticDynamic
{
}
// End block loadStaticDynamic
//Begin block loadDynamic
{
//Block-local variables for block loadDynamic
double temp=0.0;
     double d_temp_dV_DI_SI=0.0;
     double d_temp_dV_GP_SI=0.0;
     double d_temp_dV_SI_BP=0.0;
//End of Block-local variables

d_Qs_dV_SI_BP = (-((d_Qg_dV_SI_BP+d_Qb_dV_SI_BP)+d_Qd_dV_SI_BP));
d_Qs_dV_GP_SI = (-((d_Qg_dV_GP_SI+d_Qb_dV_GP_SI)+d_Qd_dV_GP_SI));
d_Qs_dV_DI_SI = (-((d_Qg_dV_DI_SI+d_Qb_dV_DI_SI)+d_Qd_dV_DI_SI));
Qs = (-((Qg+Qb)+Qd));

d_Qfgs_dV_GP_SI = (d_Qfgs_dV_GP_SI+d_Qgs_ov_dV_GP_SI);
Qfgs = (Qfgs+Qgs_ov);

d_Qfgd_dV_DI_SI = (d_Qfgd_dV_DI_SI+d_Qgd_ov_dV_DI_SI);
d_Qfgd_dV_GP_SI = (d_Qfgd_dV_GP_SI+d_Qgd_ov_dV_GP_SI);
Qfgd = (Qfgd+Qgd_ov);

d_qjun_s_dV_SI_BS = ((ABSOURCE_i*d_qjunbot_s_dV_SI_BS+LSSOURCE_i*d_qjunsti_s_dV_SI_BS)+LGSOURCE_i*d_qjungat_s_dV_SI_BS);
d_qjun_s_dV_DI_BD = ((ABSOURCE_i*d_qjunbot_s_dV_DI_BD+LSSOURCE_i*d_qjunsti_s_dV_DI_BD)+LGSOURCE_i*d_qjungat_s_dV_DI_BD);
qjun_s = (((ABSOURCE_i*qjunbot_s)+(LSSOURCE_i*qjunsti_s))+(LGSOURCE_i*qjungat_s));

d_qjun_d_dV_SI_BS = ((ABDRAIN_i*d_qjunbot_d_dV_SI_BS+LSDRAIN_i*d_qjunsti_d_dV_SI_BS)+LGDRAIN_i*d_qjungat_d_dV_SI_BS);
d_qjun_d_dV_DI_BD = ((ABDRAIN_i*d_qjunbot_d_dV_DI_BD+LSDRAIN_i*d_qjunsti_d_dV_DI_BD)+LGDRAIN_i*d_qjungat_d_dV_DI_BD);
qjun_d = (((ABDRAIN_i*qjunbot_d)+(LSDRAIN_i*qjunsti_d))+(LGDRAIN_i*qjungat_d));
if ((sigVds<0.0))
{

d_temp_dV_SI_BP = d_Qd_dV_SI_BP;
d_temp_dV_GP_SI = d_Qd_dV_GP_SI;
d_temp_dV_DI_SI = d_Qd_dV_DI_SI;
temp = Qd;

d_Qd_dV_SI_BP = d_Qs_dV_SI_BP;
d_Qd_dV_GP_SI = d_Qs_dV_GP_SI;
d_Qd_dV_DI_SI = d_Qs_dV_DI_SI;
Qd = Qs;

d_Qs_dV_SI_BP = d_temp_dV_SI_BP;
d_Qs_dV_GP_SI = d_temp_dV_GP_SI;
d_Qs_dV_DI_SI = d_temp_dV_DI_SI;
Qs = temp;
}
// I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qg));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_SI_BP);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_SI);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_DI_SI);
dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qg));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_SI_BP);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_GP_SI);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qg_dV_DI_SI);
// I(BP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
dynamicContributions[admsNodeID_BP] += ((((model_.CHNL_TYPE)*MULT_i)*Qb));
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_SI_BP);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_SI);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_DI_SI);
dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qb));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_SI_BP);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_GP_SI);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qb_dV_DI_SI);
// I(DI,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
dynamicContributions[admsNodeID_DI] += ((((model_.CHNL_TYPE)*MULT_i)*Qd));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_SI_BP);
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_SI);
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_DI_SI);
dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qd));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_SI_BP);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_GP_SI);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qd_dV_DI_SI);
// I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_SI);
dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgs));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgs_dV_GP_SI);
// I(GP,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_DI_SI);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_SI);
dynamicContributions[admsNodeID_DI] -= ((((model_.CHNL_TYPE)*MULT_i)*Qfgd));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_DI_SI);
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qfgd_dV_GP_SI);
// I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
dynamicContributions[admsNodeID_GP] += ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_SI_BP);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_SI);
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_DI_SI);
dynamicContributions[admsNodeID_BP] -= ((((model_.CHNL_TYPE)*MULT_i)*Qgb_ov));
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_SI_BP);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_GP_SI);
d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -= (((model_.CHNL_TYPE)*MULT_i)*d_Qgb_ov_dV_DI_SI);
// I(BS,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
dynamicContributions[admsNodeID_BS] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_SI_BS);
d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_DI_BD);
dynamicContributions[admsNodeID_SI] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_s));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_SI_BS);
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_s_dV_DI_BD);
// I(BD,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
dynamicContributions[admsNodeID_BD] += ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_SI_BS);
d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD] += (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_DI_BD);
dynamicContributions[admsNodeID_DI] -= ((((model_.CHNL_TYPE)*MULT_i)*qjun_d));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_SI_BS);
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] -= (((model_.CHNL_TYPE)*MULT_i)*d_qjun_d_dV_DI_BD);
}
// End block loadDynamic
//Begin block noise
{
//Block-local variables for block noise
double sf=0.0;
     double d_sf_dV_DI_SI=0.0;
     double d_sf_dV_GP_SI=0.0;
     double d_sf_dV_SI_BP=0.0;
//End of Block-local variables
Sfl = 0.0;

d_Sidexc_dV_DI_SI = d_Sidexc_dV_GP_SI = d_Sidexc_dV_SI_BP =  0.0;
Sidexc = 0.0;
mid = 0.0;

d_mig_dV_DI_SI = d_mig_dV_SI_BP = d_mig_dV_GP_SI =  0.0;
mig = 1.0e-40;

d_migid_dV_DI_SI = d_migid_dV_SI_BP = d_migid_dV_GP_SI =  0.0;
migid = 0.0;
c_igid = 0.0;

d_CGeff_dV_SI_BP = (COX_qm*d_eta_p_ac_dV_SI_BP+d_COX_qm_dV_SI_BP*eta_p_ac);
d_CGeff_dV_GP_SI = (COX_qm*d_eta_p_ac_dV_GP_SI+d_COX_qm_dV_GP_SI*eta_p_ac);
d_CGeff_dV_DI_SI = (COX_qm*d_eta_p_ac_dV_DI_SI+d_COX_qm_dV_DI_SI*eta_p_ac);
CGeff = (COX_qm*eta_p_ac);
sqid = 0.0;
sqig = 0.0;
Sfledge = 0.0;
midedge = 0.0;
sqidedge = 0.0;
if ((((xg_dc>0.0)&&(MULT_i>0.0))&&(BET_i>0.0)))
{
N1 = ((Cox_over_q*alpha_dc)*(model_.phit));
Nm1 = (Cox_over_q*qim1_dc);
Delta_N1 = ((Cox_over_q*alpha_dc)*dps_dc);
{
double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
Sfl = (((NFA_i-(NFB_i*N1))+(NFC_i*(N1*N1)))*value_log_0);
}
Sfl = (Sfl+((NFB_i+(NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
Sfl = ((((Sfl_prefac*Ids)*Gvsatinv_dc)*Sfl)/N1);
Sfl = ((Sfl>0.0)?Sfl:0.0);

d_H0_dV_GP_SI = ((alpha_dc*d_qim1_dc_dV_GP_SI-qim1_dc*d_alpha_dc_dV_GP_SI)/alpha_dc/alpha_dc);
d_H0_dV_SI_BP = ((alpha_dc*d_qim1_dc_dV_SI_BP-qim1_dc*d_alpha_dc_dV_SI_BP)/alpha_dc/alpha_dc);
d_H0_dV_DI_SI = ((alpha_dc*d_qim1_dc_dV_DI_SI-qim1_dc*d_alpha_dc_dV_DI_SI)/alpha_dc/alpha_dc);
H0 = (qim1_dc/alpha_dc);

d_t1_dV_GP_SI = ((qim1_dc*d_qim_dc_dV_GP_SI-qim_dc*d_qim1_dc_dV_GP_SI)/qim1_dc/qim1_dc);
d_t1_dV_SI_BP = ((qim1_dc*d_qim_dc_dV_SI_BP-qim_dc*d_qim1_dc_dV_SI_BP)/qim1_dc/qim1_dc);
d_t1_dV_DI_SI = ((qim1_dc*d_qim_dc_dV_DI_SI-qim_dc*d_qim1_dc_dV_DI_SI)/qim1_dc/qim1_dc);
t1 = (qim_dc/qim1_dc);

d_sqt2_dV_SI_BP = (0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_SI_BP-dps_dc*d_H0_dV_SI_BP)/H0/H0);
d_sqt2_dV_GP_SI = (0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_GP_SI-dps_dc*d_H0_dV_GP_SI)/H0/H0);
d_sqt2_dV_DI_SI = (0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dV_DI_SI-dps_dc*d_H0_dV_DI_SI)/H0/H0);
sqt2 = ((0.5*1.6666666666666667e-01)*(dps_dc/H0));

d_t2_dV_SI_BP = (sqt2*d_sqt2_dV_SI_BP+d_sqt2_dV_SI_BP*sqt2);
d_t2_dV_GP_SI = (sqt2*d_sqt2_dV_GP_SI+d_sqt2_dV_GP_SI*sqt2);
d_t2_dV_DI_SI = (sqt2*d_sqt2_dV_DI_SI+d_sqt2_dV_DI_SI*sqt2);
t2 = (sqt2*sqt2);

d_r_dV_GP_SI = ((H_dc*d_H0_dV_GP_SI-H0*d_H_dc_dV_GP_SI)/H_dc/H_dc);
d_r_dV_SI_BP = ((H_dc*d_H0_dV_SI_BP-H0*d_H_dc_dV_SI_BP)/H_dc/H_dc);
d_r_dV_DI_SI = ((H_dc*d_H0_dV_DI_SI-H0*d_H_dc_dV_DI_SI)/H_dc/H_dc);
r = ((H0/H_dc)-1.0);

d_lc_dV_GP_SI = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-12.0*(r*d_t2_dV_GP_SI+d_r_dV_GP_SI*t2)):0.0);
d_lc_dV_SI_BP = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-12.0*(r*d_t2_dV_SI_BP+d_r_dV_SI_BP*t2)):0.0);
d_lc_dV_DI_SI = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-12.0*(r*d_t2_dV_DI_SI+d_r_dV_DI_SI*t2)):0.0);
lc = (((1.0-(12.0*(r*t2)))>1.0e-20)?(1.0-(12.0*(r*t2))):1.0e-20);

d_lcinv2_dV_GP_SI = (-(lc*d_lc_dV_GP_SI+d_lc_dV_GP_SI*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_SI_BP = (-(lc*d_lc_dV_SI_BP+d_lc_dV_SI_BP*lc)/(lc*lc)/(lc*lc));
d_lcinv2_dV_DI_SI = (-(lc*d_lc_dV_DI_SI+d_lc_dV_DI_SI*lc)/(lc*lc)/(lc*lc));
lcinv2 = (1.0/(lc*lc));

d_g_ideal_dV_SI_BP = BET_i*((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_SI_BP+(FdL_dc*d_qim1_dc_dV_SI_BP+d_FdL_dc_dV_SI_BP*qim1_dc)*Gvsatinv_dc);
d_g_ideal_dV_GP_SI = BET_i*((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_GP_SI+(FdL_dc*d_qim1_dc_dV_GP_SI+d_FdL_dc_dV_GP_SI*qim1_dc)*Gvsatinv_dc);
d_g_ideal_dV_DI_SI = BET_i*((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dV_DI_SI+(FdL_dc*d_qim1_dc_dV_DI_SI+d_FdL_dc_dV_DI_SI*qim1_dc)*Gvsatinv_dc);
g_ideal = (BET_i*((FdL_dc*qim1_dc)*Gvsatinv_dc));
mid = ((t1+(12.0*t2))-(24.0*(((1.0+t1)*t2)*r)));
mid = ((mid>1.0e-40)?mid:1.0e-40);
mid = ((g_ideal*lcinv2)*mid);
if ((FNTEXC_i>0.0))
{

d_temp2_exc_dV_GP_SI = d_qim_dc_dV_GP_SI*xitsb_dc;
d_temp2_exc_dV_SI_BP = (qim_dc*d_xitsb_dc_dV_SI_BP+d_qim_dc_dV_SI_BP*xitsb_dc);
d_temp2_exc_dV_DI_SI = (qim_dc*d_xitsb_dc_dV_DI_SI+d_qim_dc_dV_DI_SI*xitsb_dc);
temp2_exc = (qim_dc*xitsb_dc);

d_wsat_exc_dV_GP_SI = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_GP_SI-temp2_exc*d_temp2_exc_dV_GP_SI)/(100.0+temp2_exc)/(100.0+temp2_exc));
d_wsat_exc_dV_SI_BP = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_SI_BP-temp2_exc*d_temp2_exc_dV_SI_BP)/(100.0+temp2_exc)/(100.0+temp2_exc));
d_wsat_exc_dV_DI_SI = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dV_DI_SI-temp2_exc*d_temp2_exc_dV_DI_SI)/(100.0+temp2_exc)/(100.0+temp2_exc));
wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
if ((THESATG_i<0))
{

d_temp_exc_dV_GP_SI = (-(-THESATG_i*d_wsat_exc_dV_GP_SI)/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
d_temp_exc_dV_SI_BP = (-(-THESATG_i*d_wsat_exc_dV_SI_BP)/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
d_temp_exc_dV_DI_SI = (-(-THESATG_i*d_wsat_exc_dV_DI_SI)/(1.0-(THESATG_i*wsat_exc))/(1.0-(THESATG_i*wsat_exc)));
temp_exc = (1.0/(1.0-(THESATG_i*wsat_exc)));
}
else
{

d_temp_exc_dV_GP_SI = THESATG_i*d_wsat_exc_dV_GP_SI;
d_temp_exc_dV_SI_BP = THESATG_i*d_wsat_exc_dV_SI_BP;
d_temp_exc_dV_DI_SI = THESATG_i*d_wsat_exc_dV_DI_SI;
temp_exc = (1.0+(THESATG_i*wsat_exc));
}

d_thesat1_exc_dV_GP_SI = THESAT_T*((Gmob_dc*d_temp_exc_dV_GP_SI-temp_exc*d_Gmob_dc_dV_GP_SI)/Gmob_dc/Gmob_dc);
d_thesat1_exc_dV_SI_BP = THESAT_T*((Gmob_dc*d_temp_exc_dV_SI_BP-temp_exc*d_Gmob_dc_dV_SI_BP)/Gmob_dc/Gmob_dc);
d_thesat1_exc_dV_DI_SI = THESAT_T*((Gmob_dc*d_temp_exc_dV_DI_SI-temp_exc*d_Gmob_dc_dV_DI_SI)/Gmob_dc/Gmob_dc);
thesat1_exc = (THESAT_T*(temp_exc/Gmob_dc));

d_zsat_exc_dV_GP_SI = (((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_GP_SI+((thesat1_exc*thesat1_exc)*d_dps_dc_dV_GP_SI+(thesat1_exc*d_thesat1_exc_dV_GP_SI+d_thesat1_exc_dV_GP_SI*thesat1_exc)*dps_dc)*dps_dc);
d_zsat_exc_dV_SI_BP = (((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_SI_BP+((thesat1_exc*thesat1_exc)*d_dps_dc_dV_SI_BP+(thesat1_exc*d_thesat1_exc_dV_SI_BP+d_thesat1_exc_dV_SI_BP*thesat1_exc)*dps_dc)*dps_dc);
d_zsat_exc_dV_DI_SI = (((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dV_DI_SI+((thesat1_exc*thesat1_exc)*d_dps_dc_dV_DI_SI+(thesat1_exc*d_thesat1_exc_dV_DI_SI+d_thesat1_exc_dV_DI_SI*thesat1_exc)*dps_dc)*dps_dc);
zsat_exc = (((thesat1_exc*thesat1_exc)*dps_dc)*dps_dc);
if (((model_.CHNL_TYPE)==(-1)))
{

d_zsat_exc_dV_GP_SI = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_GP_SI-zsat_exc*(thesat1_exc*d_dps_dc_dV_GP_SI+d_thesat1_exc_dV_GP_SI*dps_dc))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
d_zsat_exc_dV_SI_BP = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_SI_BP-zsat_exc*(thesat1_exc*d_dps_dc_dV_SI_BP+d_thesat1_exc_dV_SI_BP*dps_dc))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
d_zsat_exc_dV_DI_SI = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dV_DI_SI-zsat_exc*(thesat1_exc*d_dps_dc_dV_DI_SI+d_thesat1_exc_dV_DI_SI*dps_dc))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps_dc)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);

d_Gvsat_exc_dV_SI_BP = 0.5*(Gmob_dc*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_SI_BP))+d_Gmob_dc_dV_SI_BP*(1.0+value_sqrt_0));
d_Gvsat_exc_dV_GP_SI = 0.5*(Gmob_dc*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_GP_SI))+d_Gmob_dc_dV_GP_SI*(1.0+value_sqrt_0));
d_Gvsat_exc_dV_DI_SI = 0.5*(Gmob_dc*(deriv_sqrt_0_d0*(2.0*d_zsat_exc_dV_DI_SI))+d_Gmob_dc_dV_DI_SI*(1.0+value_sqrt_0));
Gvsat_exc = (0.5*(Gmob_dc*(1.0+value_sqrt_0)));
}

d_gfac_dV_SI_BP = (((Gvsat_exc*lc)*d_Gmob_dc_dV_SI_BP-Gmob_dc*(Gvsat_exc*d_lc_dV_SI_BP+d_Gvsat_exc_dV_SI_BP*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
d_gfac_dV_GP_SI = (((Gvsat_exc*lc)*d_Gmob_dc_dV_GP_SI-Gmob_dc*(Gvsat_exc*d_lc_dV_GP_SI+d_Gvsat_exc_dV_GP_SI*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
d_gfac_dV_DI_SI = (((Gvsat_exc*lc)*d_Gmob_dc_dV_DI_SI-Gmob_dc*(Gvsat_exc*d_lc_dV_DI_SI+d_Gvsat_exc_dV_DI_SI*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac = (Gmob_dc/(Gvsat_exc*lc));

d_Sidexc_dV_SI_BP = ((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_SI_BP+(((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_SI_BP+((fac_exc*Ids)*d_Vdse_dc_dV_SI_BP+fac_exc*d_Ids_dV_SI_BP*Vdse_dc)*gfac)*gfac);
d_Sidexc_dV_GP_SI = ((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_GP_SI+(((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_GP_SI+((fac_exc*Ids)*d_Vdse_dc_dV_GP_SI+fac_exc*d_Ids_dV_GP_SI*Vdse_dc)*gfac)*gfac);
d_Sidexc_dV_DI_SI = ((((fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dV_DI_SI+(((fac_exc*Ids)*Vdse_dc)*d_gfac_dV_DI_SI+((fac_exc*Ids)*d_Vdse_dc_dV_DI_SI+fac_exc*d_Ids_dV_DI_SI*Vdse_dc)*gfac)*gfac);
Sidexc = ((((fac_exc*Ids)*Vdse_dc)*gfac)*gfac);
mid = (mid+(Sidexc/(model_.nt0)));
}
{
double value_sqrt_0 = sqrt((nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqid = value_sqrt_0;
}
if (((model_.SWIGN_i)==1))
{

d_mig_dV_GP_SI = (((d_t1_dV_GP_SI/12.0)-(t2*(d_t1_dV_GP_SI-12.0*d_t2_dV_GP_SI)+d_t2_dV_GP_SI*((t1+0.2)-(12.0*t2))))-1.6*((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_GP_SI+(t2*(d_t1_dV_GP_SI-12.0*d_t2_dV_GP_SI)+d_t2_dV_GP_SI*((t1+1.0)-(12.0*t2)))*r));
d_mig_dV_SI_BP = (((d_t1_dV_SI_BP/12.0)-(t2*(d_t1_dV_SI_BP-12.0*d_t2_dV_SI_BP)+d_t2_dV_SI_BP*((t1+0.2)-(12.0*t2))))-1.6*((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_SI_BP+(t2*(d_t1_dV_SI_BP-12.0*d_t2_dV_SI_BP)+d_t2_dV_SI_BP*((t1+1.0)-(12.0*t2)))*r));
d_mig_dV_DI_SI = (((d_t1_dV_DI_SI/12.0)-(t2*(d_t1_dV_DI_SI-12.0*d_t2_dV_DI_SI)+d_t2_dV_DI_SI*((t1+0.2)-(12.0*t2))))-1.6*((t2*((t1+1.0)-(12.0*t2)))*d_r_dV_DI_SI+(t2*(d_t1_dV_DI_SI-12.0*d_t2_dV_DI_SI)+d_t2_dV_DI_SI*((t1+1.0)-(12.0*t2)))*r));
mig = (((t1/12.0)-(t2*((t1+0.2)-(12.0*t2))))-(1.6*((t2*((t1+1.0)-(12.0*t2)))*r)));

d_mig_dV_GP_SI = ((mig>1.0e-40)?d_mig_dV_GP_SI:0.0);
d_mig_dV_SI_BP = ((mig>1.0e-40)?d_mig_dV_SI_BP:0.0);
d_mig_dV_DI_SI = ((mig>1.0e-40)?d_mig_dV_DI_SI:0.0);
mig = ((mig>1.0e-40)?mig:1.0e-40);

d_mig_dV_GP_SI = ((lcinv2/g_ideal)*d_mig_dV_GP_SI+((g_ideal*d_lcinv2_dV_GP_SI-lcinv2*d_g_ideal_dV_GP_SI)/g_ideal/g_ideal)*mig);
d_mig_dV_SI_BP = ((lcinv2/g_ideal)*d_mig_dV_SI_BP+((g_ideal*d_lcinv2_dV_SI_BP-lcinv2*d_g_ideal_dV_SI_BP)/g_ideal/g_ideal)*mig);
d_mig_dV_DI_SI = ((lcinv2/g_ideal)*d_mig_dV_DI_SI+((g_ideal*d_lcinv2_dV_DI_SI-lcinv2*d_g_ideal_dV_DI_SI)/g_ideal/g_ideal)*mig);
mig = ((lcinv2/g_ideal)*mig);

d_migid_dV_GP_SI = ((lcinv2*sqt2)*((-12.0*d_t2_dV_GP_SI)-(((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_GP_SI+((d_t1_dV_GP_SI+19.2*d_t2_dV_GP_SI)-12.0*(t1*d_t2_dV_GP_SI+d_t1_dV_GP_SI*t2))*r))+(lcinv2*d_sqt2_dV_GP_SI+d_lcinv2_dV_GP_SI*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
d_migid_dV_SI_BP = ((lcinv2*sqt2)*((-12.0*d_t2_dV_SI_BP)-(((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_SI_BP+((d_t1_dV_SI_BP+19.2*d_t2_dV_SI_BP)-12.0*(t1*d_t2_dV_SI_BP+d_t1_dV_SI_BP*t2))*r))+(lcinv2*d_sqt2_dV_SI_BP+d_lcinv2_dV_SI_BP*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
d_migid_dV_DI_SI = ((lcinv2*sqt2)*((-12.0*d_t2_dV_DI_SI)-(((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dV_DI_SI+((d_t1_dV_DI_SI+19.2*d_t2_dV_DI_SI)-12.0*(t1*d_t2_dV_DI_SI+d_t1_dV_DI_SI*t2))*r))+(lcinv2*d_sqt2_dV_DI_SI+d_lcinv2_dV_DI_SI*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
migid = ((lcinv2*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));

d_CGeff_dV_SI_BP = (((Gmob_dL_ac*Gmob_dL_ac)*(((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_SI_BP+((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_SI_BP+(Gvsat_ac*d_Gvsat_ac_dV_SI_BP+d_Gvsat_ac_dV_SI_BP*Gvsat_ac)*COX_qm)*eta_p_ac)-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*(Gmob_dL_ac*d_Gmob_dL_ac_dV_SI_BP+d_Gmob_dL_ac_dV_SI_BP*Gmob_dL_ac))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
d_CGeff_dV_GP_SI = (((Gmob_dL_ac*Gmob_dL_ac)*(((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_GP_SI+((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_GP_SI+(Gvsat_ac*d_Gvsat_ac_dV_GP_SI+d_Gvsat_ac_dV_GP_SI*Gvsat_ac)*COX_qm)*eta_p_ac)-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*(Gmob_dL_ac*d_Gmob_dL_ac_dV_GP_SI+d_Gmob_dL_ac_dV_GP_SI*Gmob_dL_ac))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
d_CGeff_dV_DI_SI = (((Gmob_dL_ac*Gmob_dL_ac)*(((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dV_DI_SI+((Gvsat_ac*Gvsat_ac)*d_COX_qm_dV_DI_SI+(Gvsat_ac*d_Gvsat_ac_dV_DI_SI+d_Gvsat_ac_dV_DI_SI*Gvsat_ac)*COX_qm)*eta_p_ac)-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*(Gmob_dL_ac*d_Gmob_dL_ac_dV_DI_SI+d_Gmob_dL_ac_dV_DI_SI*Gmob_dL_ac))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
CGeff = ((((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)/(Gmob_dL_ac*Gmob_dL_ac));
if ((FNTEXC_i>0.0))
{

d_mig_dV_GP_SI = (d_mig_dV_GP_SI+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12.0*d_t2_dV_GP_SI+d_Sidexc_dV_GP_SI*(1.0+(12.0*t2)))-(Sidexc*(1.0+(12.0*t2)))*((12.0*g_ideal)*d_g_ideal_dV_GP_SI+12.0*d_g_ideal_dV_GP_SI*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
d_mig_dV_SI_BP = (d_mig_dV_SI_BP+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12.0*d_t2_dV_SI_BP+d_Sidexc_dV_SI_BP*(1.0+(12.0*t2)))-(Sidexc*(1.0+(12.0*t2)))*((12.0*g_ideal)*d_g_ideal_dV_SI_BP+12.0*d_g_ideal_dV_SI_BP*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
d_mig_dV_DI_SI = (d_mig_dV_DI_SI+(((((12.0*g_ideal)*g_ideal)*(model_.nt0))*(Sidexc*12.0*d_t2_dV_DI_SI+d_Sidexc_dV_DI_SI*(1.0+(12.0*t2)))-(Sidexc*(1.0+(12.0*t2)))*((12.0*g_ideal)*d_g_ideal_dV_DI_SI+12.0*d_g_ideal_dV_DI_SI*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));
mig = (mig+((Sidexc*(1.0+(12.0*t2)))/(((12.0*g_ideal)*g_ideal)*(model_.nt0))));

d_migid_dV_GP_SI = (d_migid_dV_GP_SI-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_GP_SI+(Sidexc*d_sqt2_dV_GP_SI+d_Sidexc_dV_GP_SI*sqt2)*(1.0+r))-((Sidexc*sqt2)*(1.0+r))*d_g_ideal_dV_GP_SI*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
d_migid_dV_SI_BP = (d_migid_dV_SI_BP-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_SI_BP+(Sidexc*d_sqt2_dV_SI_BP+d_Sidexc_dV_SI_BP*sqt2)*(1.0+r))-((Sidexc*sqt2)*(1.0+r))*d_g_ideal_dV_SI_BP*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
d_migid_dV_DI_SI = (d_migid_dV_DI_SI-(((g_ideal*(model_.nt0))*((Sidexc*sqt2)*d_r_dV_DI_SI+(Sidexc*d_sqt2_dV_DI_SI+d_Sidexc_dV_DI_SI*sqt2)*(1.0+r))-((Sidexc*sqt2)*(1.0+r))*d_g_ideal_dV_DI_SI*(model_.nt0))/(g_ideal*(model_.nt0))/(g_ideal*(model_.nt0))));
migid = (migid-(((Sidexc*sqt2)*(1.0+r))/(g_ideal*(model_.nt0))));
}
{
double value_sqrt_0 = sqrt((nt/mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqig = value_sqrt_0;
}
if ((sqid==0))
{
c_igid = 0.0;
}
else
{
c_igid = ((migid*sqig)/sqid);
}
c_igid = ((c_igid>0.0)?((c_igid<1.0)?c_igid:1.0):0.0);
}
}
{
double value_fabs_0 = fabs(Igcs);
double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));
shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igcd);
double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));
shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igsov);
double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));
shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igdov);
double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));
shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Iimpact);
double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));
shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
}
{
double value_fabs_0 = fabs(ijun_s);
double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));
jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(ijun_d);
double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));
jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
}
if ((sigVds>0.0))
{
shot_igs = (shot_igcsx+shot_igsov);
shot_igd = (shot_igcdx+shot_igdov);
jnoise_s = jnoisex_s;
jnoise_d = (jnoisex_d+shot_iavl);
}
else
{
shot_igs = (shot_igcdx+shot_igsov);
shot_igd = (shot_igcsx+shot_igdov);
jnoise_s = (jnoisex_s+shot_iavl);
jnoise_d = jnoisex_d;
}
if (((((model_.SWEDGE_i)!=0.0)&&(BETNEDGE_i>0))&&(xgedge>0)))
{

d_temp1_dV_GP_SI = (4.0*d_dsqredge_dV_GP_SI/Gfedge2);
d_temp1_dV_SI_BP = (4.0*d_dsqredge_dV_SI_BP/Gfedge2);
d_temp1_dV_DI_SI = (4.0*d_dsqredge_dV_DI_SI/Gfedge2);
temp1 = ((4.0*dsqredge)/Gfedge2);
{
double value_sqrt_0 = sqrt((temp1+1.0));
double value_sqrt_1 = sqrt((temp1+1.1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
anoisedge = (value_sqrt_0/(value_sqrt_1-1.0));
}

d_temp1_dV_GP_SI = d_temp1_dV_DI_SI = d_temp1_dV_SI_BP =  0.0;
temp1 = (Cox_over_q*(model_.phit));
N1edge = (temp1*anoisedge);
Nm1edge = (temp1*(qmeffedge+anoisedge));
Delta_N1edge = ((((-temp1)*anoisedge)*alphabmedge)*qdseffedge);
{
double value_log_0 = log(((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
double  deriv_log_0_d0 = (1.0/((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
Sfledge = ((NFAEDGE_i-((NFBEDGE_i-(NFCEDGE_i*N1edge))*N1edge))*value_log_0);
}
Sfledge = (Sfledge+((NFBEDGE_i+(NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*Delta_N1edge));
Sfledge = ((((Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)/N1edge);
Sfledge = ((Sfledge>0.0)?Sfledge:0.0);
H0edge = (((model_.phit)*(qmeffedge+anoisedge))/anoisedge);
t1edge = (((phit1/(model_.phit))*qmeffedge)/(qmeffedge+anoisedge));
sqt2edge = ((((((-0.5)*1.6666666666666667e-01)*(model_.phit))*alphabmedge)*qdseffedge)/H0edge);
t2edge = (sqt2edge*sqt2edge);
redge = ((((anoisedge/alpha_dc)*H0edge)/H_dc)-1.0);
lcedge = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(1.0-(12.0*(redge*t2edge))):1.0e-20);
lcinv2edge = (1.0/(lcedge*lcedge));
g_idealedge = ((((BETEDGE_i*(model_.phit))*(qmeffedge+anoisedge))*FdL_dc)*Gvsatinv_dc);
midedge = ((t1edge+(12.0*t2edge))-(24.0*(((1.0+t1edge)*t2edge)*redge)));
midedge = ((midedge>1.0e-40)?midedge:1.0e-40);
midedge = ((g_idealedge*lcinv2edge)*midedge);
{
double value_sqrt_0 = sqrt((ntedge*midedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqidedge = value_sqrt_0;
}
}

d_sf_dV_SI_BP = ((1.0e+6*CGeff)*d_mig_dV_SI_BP+1.0e+6*d_CGeff_dV_SI_BP*mig);
d_sf_dV_GP_SI = ((1.0e+6*CGeff)*d_mig_dV_GP_SI+1.0e+6*d_CGeff_dV_GP_SI*mig);
d_sf_dV_DI_SI = ((1.0e+6*CGeff)*d_mig_dV_DI_SI+1.0e+6*d_CGeff_dV_DI_SI*mig);
sf = ((1.0e+6*CGeff)*mig);
// I(NOI2,GND) <+ (V(NOI2,GND))
staticContributions[admsNodeID_NOI2] += (probeVars[admsProbeID_V_NOI2_GND]);
d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] += d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND];
// I(NOI2,GND) <+ (white_noise((((nt/mig)*sf)*sf),"igig"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[7]= (((nt/mig)*sf)*sf);
}
// I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
staticContributions[admsNodeID_NOI] += ((-(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI/sf/sf);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] += ((-d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND])/sf);
// I(NOI,GND) <+ ((V(NOI,GND)/mig))
staticContributions[admsNodeID_NOI] += ((probeVars[admsProbeID_V_NOI_GND])/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_GP_SI/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_SI_BP/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += (-(probeVars[admsProbeID_V_NOI_GND])*d_mig_dV_DI_SI/mig/mig);
d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]/mig);
// I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
dynamicContributions[admsNodeID_NOI] += ((CGeff*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] += (CGeff*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]);
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] += (d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] += (d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] += (d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND]));
// I(GP,SI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
{
double value_sqrt_0 = sqrt(MULT_i);
dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (-(((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (-((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (-((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (-((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND])));
dynamicContributions[admsNodeID_SI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] -= (-(((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND])));
}
// I(GP,DI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
{
double value_sqrt_0 = sqrt(MULT_i);
dynamicContributions[admsNodeID_GP] += (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] += (-(((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] += (-((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] += (-((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] += (-((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND])));
dynamicContributions[admsNodeID_DI] -= (-((((value_sqrt_0*0.5)*CGeff)*(probeVars[admsProbeID_V_NOI_GND]))));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] -= (-(((value_sqrt_0*0.5)*CGeff)*d_probeVars[admsProbeID_V_NOI_GND][admsProbeID_V_NOI_GND]));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_SI_BP*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_GP_SI*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -= (-((value_sqrt_0*0.5)*d_CGeff_dV_DI_SI*(probeVars[admsProbeID_V_NOI_GND])));
}
// I(DI,SI) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
{
double value_sqrt_0 = sqrt(MULT_i);
staticContributions[admsNodeID_DI] += ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] += (((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND]/sf);
d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_GP_SI*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI)/sf/sf);
d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_SI_BP*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP)/sf/sf);
d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] += ((sf*(sigVds*value_sqrt_0)*d_migid_dV_DI_SI*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI)/sf/sf);
staticContributions[admsNodeID_SI] -= ((((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))/sf);
d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] -= (((sigVds*value_sqrt_0)*migid)*d_probeVars[admsProbeID_V_NOI2_GND][admsProbeID_V_NOI2_GND]/sf);
d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_GP_SI*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_GP_SI)/sf/sf);
d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_SI_BP*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_SI_BP)/sf/sf);
d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -= ((sf*(sigVds*value_sqrt_0)*d_migid_dV_DI_SI*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dV_DI_SI)/sf/sf);
}
// I(DI,SI) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[8]= (((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid)));
}
// I(DI,SI) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[9]= (MULT_i*Sfl);
  noiseContribsExponent[9]= EF_i;
}
// I(GP,SI) <+ (white_noise((MULT_i*shot_igs),"igs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[10]= (MULT_i*shot_igs);
}
// I(GP,DI) <+ (white_noise((MULT_i*shot_igd),"igd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[11]= (MULT_i*shot_igd);
}
// I(BS,SI) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[12]= (MULT_i*jnoise_s);
}
// I(BD,DI) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[13]= (MULT_i*jnoise_d);
}
// I(DI,SI) <+ (flicker_noise((MULT_i*Sfledge),EFEDGE_i,"flicker"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[14]= (MULT_i*Sfledge);
  noiseContribsExponent[14]= EFEDGE_i;
}
// I(DI,SI) <+ (white_noise(((MULT_i*sqidedge)*sqidedge),"ididedge"))
if (getSolverState().noiseFlag)
{
  noiseContribsPower[15]= ((MULT_i*sqidedge)*sqidedge);
}
}
// End block noise
//Begin block OPinfo
{
id_op = (((Ids+Idsedge)+Iimpact)-Igcd);
is = (((-Ids)-Idsedge)-Igcs);
ig = ((((Igcs+Igcd)+Igsov)+Igdov)+Igb);
ib = ((((-Iimpact)-Igb)-Igidl)-Igisl);
sig1k = ((2.0e3*3.1415926535897931)*CGeff);
sig1k = ((sig1k*sig1k)*mig);
sdint = sigVds;
ctype = (model_.CHNL_TYPE);
if ((sigVds<0.0))
{
ise = (MULT_i*(((is-Igdov)+Igidl)-ijun_d));
ige = (MULT_i*ig);
ide = (MULT_i*(((id_op-Igsov)+Igisl)-ijun_s));
ibe = (MULT_i*((ib+ijun_s)+ijun_d));
ids = (MULT_i*Ids);
idb = (MULT_i*((Iimpact+Igisl)-ijun_s));
isb = (MULT_i*(Igidl-ijun_d));
igs = (MULT_i*(Igcs+Igdov));
igd = (MULT_i*(Igcd+Igsov));
igb = (MULT_i*Igb);
idedge = (MULT_i*Idsedge);
igcs = (MULT_i*Igcs);
igcd = (MULT_i*Igcd);
iavl = (MULT_i*Iimpact);
igisl = (MULT_i*Igidl);
igidl = (MULT_i*Igisl);
if (((model_.SWJUNEXP_i)==1))
{
ijsbot = 0.0;
ijsgat = 0.0;
ijssti = 0.0;
ijdbot = 0.0;
ijdgat = 0.0;
ijdsti = 0.0;
idsatsbot = 0.0;
idsatssti = 0.0;
idsatsgat = 0.0;
idsatsbotd = 0.0;
idsatsstid = 0.0;
idsatsgatd = 0.0;
}
else
{
ijsbot = ((MULT_i*ABDRAIN_i)*ijunbot_d);
ijsgat = ((MULT_i*LGDRAIN_i)*ijungat_d);
ijssti = ((MULT_i*LSDRAIN_i)*ijunsti_d);
ijdbot = ((MULT_i*ABSOURCE_i)*ijunbot_s);
ijdgat = ((MULT_i*LGSOURCE_i)*ijungat_s);
ijdsti = ((MULT_i*LSSOURCE_i)*ijunsti_s);
idsatsbot = ((MULT_i*ABSOURCE_i)*(model_.idsatbot));
idsatssti = ((MULT_i*LSSOURCE_i)*(model_.idsatsti));
idsatsgat = ((MULT_i*LGSOURCE_i)*(model_.idsatgat));
idsatsbotd = ((MULT_i*ABDRAIN_i)*(model_.idsatbot_d));
idsatsstid = ((MULT_i*LSDRAIN_i)*(model_.idsatsti_d));
idsatsgatd = ((MULT_i*LGDRAIN_i)*(model_.idsatgat_d));
}
ijs = (MULT_i*ijun_d);
ijd = (MULT_i*ijun_s);
vds = Vds;
vgs = Vgs;
vsb = Vsb;
{
double value_sqrt_0 = sqrt((phit1*facvsb0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vto = ((VFB_T+(P_D*facvsb0))+(Gf_dc*value_sqrt_0));
}
vts = vts_i;
vth = vth_i;
vgt = (vgs-vth);
vdss = Vdsat_dc;
vsat = (Vds-vdss);

d_ids_i_dV_SI_BS = (-d_ijun_s_dV_SI_BS);
d_ids_i_dV_DI_BD = (-d_ijun_s_dV_DI_BD);
d_ids_i_dV_SI_BP = (((((d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP)+d_Iimpact_dV_SI_BP)+d_Igisl_dV_SI_BP)-d_Igcd_dV_SI_BP)-d_Igsov_dV_SI_BP);
d_ids_i_dV_GP_SI = (((((d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI)+d_Iimpact_dV_GP_SI)+d_Igisl_dV_GP_SI)-d_Igcd_dV_GP_SI)-d_Igsov_dV_GP_SI);
d_ids_i_dV_DI_SI = (((((d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI)+d_Iimpact_dV_DI_SI)+d_Igisl_dV_DI_SI)-d_Igcd_dV_DI_SI)-d_Igsov_dV_DI_SI);
ids_i = ((((((Ids+Idsedge)+Iimpact)+Igisl)-Igcd)-Igsov)-ijun_s);
gm = (((model_.CHNL_TYPE)*MULT_i)*(+d_ids_i_dV_GP_SI));
gmb = (((model_.CHNL_TYPE)*MULT_i)*(-d_ids_i_dV_SI_BP));
gds = (((model_.CHNL_TYPE)*MULT_i)*(+d_ids_i_dV_SI_BS+d_ids_i_dV_SI_BP-d_ids_i_dV_GP_SI-d_ids_i_dV_DI_SI));
gjs = (MULT_i*(-d_ijun_d_dV_DI_BD));
gjd = (MULT_i*(-d_ijun_s_dV_SI_BS));
css = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qd_dV_DI_SI));
csg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qd_dV_GP_SI));
csb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qd_dV_SI_BP));
csd = ((css-csg)-csb);
cgs = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qg_dV_DI_SI));
cgg = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qg_dV_GP_SI));
cgb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qg_dV_SI_BP));
cgd = ((cgg-cgs)-cgb);
cds = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_DI_SI));
cdg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_GP_SI));
cdb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qs_dV_SI_BP));
cdd = ((cdg+cds)+cdb);
cbs = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_DI_SI));
cbg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_GP_SI));
cbb = (((model_.CHNL_TYPE)*MULT_i)*(-d_Qb_dV_SI_BP));
cbd = ((cbb-cbs)-cbg);
cgsol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgd_dV_GP_SI));
cgdol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgs_dV_GP_SI));
cjsbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABDRAIN_i)*(+d_qjunbot_d_dV_DI_BD));
cjsgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGDRAIN_i)*(+d_qjungat_d_dV_DI_BD));
cjssti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSDRAIN_i)*(+d_qjunsti_d_dV_DI_BD));
cjs = ((cjsbot+cjsgat)+cjssti);
cjdbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABSOURCE_i)*(+d_qjunbot_s_dV_SI_BS));
cjdgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGSOURCE_i)*(+d_qjungat_s_dV_SI_BS));
cjdsti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSSOURCE_i)*(+d_qjunsti_s_dV_SI_BS));
cjd = ((cjdbot+cjdgat)+cjdsti);
}
else
{
ise = (MULT_i*(((is-Igsov)+Igisl)-ijun_s));
ige = (MULT_i*ig);
ide = (MULT_i*(((id_op-Igdov)+Igidl)-ijun_d));
ibe = (MULT_i*((ib+ijun_s)+ijun_d));
ids = (MULT_i*Ids);
idb = (MULT_i*((Iimpact+Igidl)-ijun_d));
isb = (MULT_i*(Igisl-ijun_s));
igs = (MULT_i*(Igcs+Igsov));
igd = (MULT_i*(Igcd+Igdov));
igb = (MULT_i*Igb);
idedge = (MULT_i*Idsedge);
igcs = (MULT_i*Igcs);
igcd = (MULT_i*Igcd);
iavl = (MULT_i*Iimpact);
igisl = (MULT_i*Igisl);
igidl = (MULT_i*Igidl);
if (((model_.SWJUNEXP_i)==1))
{
ijsbot = 0.0;
ijsgat = 0.0;
ijssti = 0.0;
ijdbot = 0.0;
ijdgat = 0.0;
ijdsti = 0.0;
idsatsbot = 0.0;
idsatssti = 0.0;
idsatsgat = 0.0;
idsatsbotd = 0.0;
idsatsstid = 0.0;
idsatsgatd = 0.0;
}
else
{
ijsbot = ((MULT_i*ABSOURCE_i)*ijunbot_s);
ijsgat = ((MULT_i*LGSOURCE_i)*ijungat_s);
ijssti = ((MULT_i*LSSOURCE_i)*ijunsti_s);
ijdbot = ((MULT_i*ABDRAIN_i)*ijunbot_d);
ijdgat = ((MULT_i*LGDRAIN_i)*ijungat_d);
ijdsti = ((MULT_i*LSDRAIN_i)*ijunsti_d);
idsatsbot = ((MULT_i*ABSOURCE_i)*(model_.idsatbot));
idsatssti = ((MULT_i*LSSOURCE_i)*(model_.idsatsti));
idsatsgat = ((MULT_i*LGSOURCE_i)*(model_.idsatgat));
idsatsbotd = ((MULT_i*ABDRAIN_i)*(model_.idsatbot_d));
idsatsstid = ((MULT_i*LSDRAIN_i)*(model_.idsatsti_d));
idsatsgatd = ((MULT_i*LGDRAIN_i)*(model_.idsatgat_d));
}
ijs = (MULT_i*ijun_s);
ijd = (MULT_i*ijun_d);
vds = Vds;
vgs = Vgs;
vsb = Vsb;
{
double value_sqrt_0 = sqrt((phit1*facvsb0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vto = ((VFB_T+(P_D*facvsb0))+(Gf_dc*value_sqrt_0));
}
vts = vts_i;
vth = vth_i;
vgt = (vgs-vth);
vdss = Vdsat_dc;
vsat = (Vds-vdss);

d_ids_i_dV_SI_BS = (-d_ijun_d_dV_SI_BS);
d_ids_i_dV_DI_BD = (-d_ijun_d_dV_DI_BD);
d_ids_i_dV_SI_BP = (((((d_Ids_dV_SI_BP+d_Idsedge_dV_SI_BP)+d_Iimpact_dV_SI_BP)+d_Igidl_dV_SI_BP)-d_Igcd_dV_SI_BP)-d_Igdov_dV_SI_BP);
d_ids_i_dV_GP_SI = (((((d_Ids_dV_GP_SI+d_Idsedge_dV_GP_SI)+d_Iimpact_dV_GP_SI)+d_Igidl_dV_GP_SI)-d_Igcd_dV_GP_SI)-d_Igdov_dV_GP_SI);
d_ids_i_dV_DI_SI = (((((d_Ids_dV_DI_SI+d_Idsedge_dV_DI_SI)+d_Iimpact_dV_DI_SI)+d_Igidl_dV_DI_SI)-d_Igcd_dV_DI_SI)-d_Igdov_dV_DI_SI);
ids_i = ((((((Ids+Idsedge)+Iimpact)+Igidl)-Igcd)-Igdov)-ijun_d);
gm = (((model_.CHNL_TYPE)*MULT_i)*(+d_ids_i_dV_GP_SI));
gmb = (((model_.CHNL_TYPE)*MULT_i)*(-d_ids_i_dV_SI_BP));
gds = (((model_.CHNL_TYPE)*MULT_i)*(+d_ids_i_dV_DI_BD+d_ids_i_dV_DI_SI));
gjs = ((-MULT_i)*(+d_ijun_s_dV_SI_BS));
gjd = ((-MULT_i)*(+d_ijun_d_dV_DI_BD));
cdd = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qd_dV_DI_SI));
cdg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qd_dV_GP_SI));
cdb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qd_dV_SI_BP));
cds = ((cdd-cdg)-cdb);
cgd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qg_dV_DI_SI));
cgg = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qg_dV_GP_SI));
cgb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qg_dV_SI_BP));
cgs = ((cgg-cgd)-cgb);
csd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_DI_SI));
csg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qs_dV_GP_SI));
csb = (((-(model_.CHNL_TYPE))*MULT_i)*(-d_Qs_dV_SI_BP));
css = ((csg+csd)+csb);
cbd = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_DI_SI));
cbg = (((-(model_.CHNL_TYPE))*MULT_i)*(+d_Qb_dV_GP_SI));
cbb = (((model_.CHNL_TYPE)*MULT_i)*(-d_Qb_dV_SI_BP));
cbs = ((cbb-cbd)-cbg);
cgsol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgs_dV_GP_SI));
cgdol = (((model_.CHNL_TYPE)*MULT_i)*(+d_Qfgd_dV_GP_SI));
cjsbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABSOURCE_i)*(+d_qjunbot_s_dV_SI_BS));
cjsgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGSOURCE_i)*(+d_qjungat_s_dV_SI_BS));
cjssti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSSOURCE_i)*(+d_qjunsti_s_dV_SI_BS));
cjs = ((cjsbot+cjsgat)+cjssti);
cjdbot = ((((-MULT_i)*(model_.CHNL_TYPE))*ABDRAIN_i)*(+d_qjunbot_d_dV_DI_BD));
cjdgat = ((((-MULT_i)*(model_.CHNL_TYPE))*LGDRAIN_i)*(+d_qjungat_d_dV_DI_BD));
cjdsti = ((((-MULT_i)*(model_.CHNL_TYPE))*LSDRAIN_i)*(+d_qjunsti_d_dV_DI_BD));
cjd = ((cjdbot+cjdgat)+cjdsti);
}
weff = WE;
leff = LE;
if ((fabs(gds)<1.0e-18))
{
u = 0.0;
rout = 0.0;
vearly = 0.0;
}
else
{
u = (gm/gds);
rout = (1.0/gds);
vearly = (ide/gds);
}
if ((fabs(vgt)<1.0e-12))
{
beff = 0.0;
}
else
{
{
double value_fabs_0 = fabs(ide);
double  deriv_fabs_0_d0 = (((ide)>=0)?(+1.0):(-1.0));
beff = ((2.0*value_fabs_0)/(vgt*vgt));
}
}
if ((fabs(((cgg+cgsol)+cgdol))<1.0e-30))
{
fug = 0.0;
}
else
{
fug = (gm/((2.0*3.1415926535897931)*((cgg+cgsol)+cgdol)));
}
rg = (RG_i/MULT_i);
sfl = (MULT_i*Sfl);
if ((fabs(gm)<1.0e-18))
{
sqrtsff = 0.0;
sqrtsfw = 0.0;
}
else
{
{
double value_sqrt_0 = sqrt(((MULT_i*Sfl)/1000.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
sqrtsff = (value_sqrt_0/gm);
}
{
double value_sqrt_0 = sqrt(MULT_i);
sqrtsfw = ((value_sqrt_0*sqid)/gm);
}
}
sid = ((MULT_i*sqid)*sqid);
sig = (((MULT_i*nt)*sig1k)/(1.0+(sig1k*mig)));
cigid = c_igid;
if ((sid==0.0))
{
fknee = 0.0;
}
else
{
fknee = (sfl/sid);
}
siavl = (MULT_i*shot_iavl);
if ((sigVds<0.0))
{
sigs = (MULT_i*(shot_igcsx+shot_igdov));
sigd = (MULT_i*(shot_igcdx+shot_igsov));
ssi = (MULT_i*jnoisex_d);
sdi = (MULT_i*jnoisex_s);
}
else
{
sigs = (MULT_i*(shot_igcsx+shot_igsov));
sigd = (MULT_i*(shot_igcdx+shot_igdov));
ssi = (MULT_i*jnoisex_s);
sdi = (MULT_i*jnoisex_d);
}
sfledge = (MULT_i*Sfledge);
sidedge = (MULT_i*sqidedge);
lp_vfb = VFB_T;
lp_stvfb = STVFB_i;
lp_tox = TOX_i;
lp_epsrox = EPSROX_i;
lp_neff = NEFF_i;
lp_facneffac = FACNEFFAC_i;
lp_gfacnud = GFACNUD_i;
lp_vsbnud = VSBNUD_i;
lp_dvsbnud = DVSBNUD_i;
lp_vnsub = VNSUB_i;
lp_nslp = NSLP_i;
lp_dnsub = DNSUB_i;
lp_dphib = DPHIB_i;
lp_delvtac = DELVTAC_i;
lp_np = NP_i;
lp_ct = CT_i;
lp_toxov = TOXOV_i;
lp_toxovd = TOXOVD_i;
lp_nov = NOV_i;
lp_novd = NOVD_i;
lp_cf = CF_i;
lp_cfd = CFD_i;
lp_cfb = CFB_i;
lp_psce = PSCE_i;
lp_psceb = PSCEB_i;
lp_psced = PSCED_i;
lp_betn = BETN_T;
lp_stbet = STBET_i;
lp_mue = MUE_T;
lp_stmue = STMUE_i;
lp_themu = THEMU_T;
lp_stthemu = STTHEMU_i;
lp_cs = CS_T;
lp_stcs = STCS_i;
lp_xcor = XCOR_T;
lp_stxcor = STXCOR_i;
lp_feta = FETA_i;
lp_rs = RS_T;
lp_strs = STRS_i;
lp_rsb = RSB_i;
lp_rsg = RSG_i;
lp_thesat = THESAT_T;
lp_stthesat = STTHESAT_i;
lp_thesatb = THESATB_i;
lp_thesatg = THESATG_i;
lp_ax = AX_i;
lp_alp = ALP_i;
lp_alp1 = ALP1_i;
lp_alp2 = ALP2_i;
lp_vp = VP_i;
lp_a1 = A1_i;
lp_a2 = A2_T;
lp_sta2 = STA2_i;
lp_a3 = A3_i;
lp_a4 = A4_i;
lp_gco = GCO_i;
lp_iginv = IGINV_i;
lp_igov = IGOV_i;
lp_igovd = IGOVD_i;
lp_stig = STIG_i;
lp_gc2 = GC2_i;
lp_gc3 = GC3_i;
lp_chib = CHIB_i;
lp_agidl = AGIDL_i;
lp_agidld = AGIDLD_i;
lp_bgidl = BGIDL_T;
lp_bgidld = BGIDLD_T;
lp_stbgidl = STBGIDL_i;
lp_stbgidld = STBGIDLD_i;
lp_cgidl = CGIDL_i;
lp_cgidld = CGIDLD_i;
lp_cox = COX_i;
lp_cgov = CGOV_i;
lp_cgovd = CGOVD_i;
lp_cgbov = CGBOV_i;
lp_cfr = CFR_i;
lp_cfrd = CFRD_i;
lp_fnt = FNT_i;
lp_fntexc = FNTEXC_i;
lp_nfa = NFA_i;
lp_nfb = NFB_i;
lp_nfc = NFC_i;
lp_ef = EF_i;
lp_vfbedge = VFBEDGE_T;
lp_stvfbedge = STVFBEDGE_i;
lp_dphibedge = DPHIBEDGE_i;
lp_neffedge = NEFFEDGE_i;
lp_ctedge = CTEDGE_i;
lp_betnedge = BETNEDGE_T;
lp_stbetedge = STBETEDGE_i;
lp_psceedge = PSCEEDGE_i;
lp_pscebedge = PSCEBEDGE_i;
lp_pscededge = PSCEDEDGE_i;
lp_cfedge = CFEDGE_i;
lp_cfdedge = CFDEDGE_i;
lp_cfbedge = CFBEDGE_i;
lp_fntedge = FNTEDGE_i;
lp_nfaedge = NFAEDGE_i;
lp_nfbedge = NFBEDGE_i;
lp_nfcedge = NFCEDGE_i;
lp_efedge = EFEDGE_i;
lp_rg = RG_i;
lp_rse = RSE_i;
lp_rde = RDE_i;
lp_rbulk = RBULK_i;
lp_rwell = RWELL_i;
lp_rjuns = RJUNS_i;
lp_rjund = RJUND_i;
tk = (model_.TKD);
cjosbot = ((MULT_i*ABSOURCE_i)*(model_.cjobot));
cjossti = ((MULT_i*LSSOURCE_i)*(model_.cjosti));
cjosgat = ((MULT_i*LGSOURCE_i)*(model_.cjogat));
vbisbot = (model_.vbibot);
vbissti = (model_.vbisti);
vbisgat = (model_.vbigat);
cjosbotd = ((MULT_i*ABDRAIN_i)*(model_.cjobot_d));
cjosstid = ((MULT_i*LSDRAIN_i)*(model_.cjosti_d));
cjosgatd = ((MULT_i*LGDRAIN_i)*(model_.cjogat_d));
vbisbotd = (model_.vbibot_d);
vbisstid = (model_.vbisti_d);
vbisgatd = (model_.vbigat_d);
}
// End block OPinfo
}
// End block evaluateblock


  // -- endcode converted from analog/code block
  if (DEBUG_DEVICE && isActive(Diag::DEVICE_PARAMETERS) && getSolverState().debugTimeFlag)
  {
    Xyce::dout() << " probeVars[admsProbeID_V_DI_GND] =  "
         <<probeVars[admsProbeID_V_DI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_GND] =  "
         <<probeVars[admsProbeID_V_BS_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_GND] =  "
         <<probeVars[admsProbeID_V_BD_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_SI_GND] =  "
         <<probeVars[admsProbeID_V_SI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_GND] =  "
         <<probeVars[admsProbeID_V_BP_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_GND] =  "
         <<probeVars[admsProbeID_V_GP_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI_GND] =  "
         <<probeVars[admsProbeID_V_NOI_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_NOI2_GND] =  "
         <<probeVars[admsProbeID_V_NOI2_GND] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_B_BI] =  "
         <<probeVars[admsProbeID_V_B_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BD_BI] =  "
         <<probeVars[admsProbeID_V_BD_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BS_BI] =  "
         <<probeVars[admsProbeID_V_BS_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_BP_BI] =  "
         <<probeVars[admsProbeID_V_BP_BI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_D_DI] =  "
         <<probeVars[admsProbeID_V_D_DI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_S_SI] =  "
         <<probeVars[admsProbeID_V_S_SI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_G_GP] =  "
         <<probeVars[admsProbeID_V_G_GP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_DI_BD] =  "
         <<probeVars[admsProbeID_V_DI_BD] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_SI_BS] =  "
         <<probeVars[admsProbeID_V_SI_BS] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_SI_BP] =  "
         <<probeVars[admsProbeID_V_SI_BP] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_DI_SI] =  "
         <<probeVars[admsProbeID_V_DI_SI] << std::endl;
    Xyce::dout() << " probeVars[admsProbeID_V_GP_SI] =  "
         <<probeVars[admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_D] =  "
         <<staticContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_D].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_D][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_D] =  "
         <<dynamicContributions[admsNodeID_D] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_D].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_D][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_G] =  "
         <<staticContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_G].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_G][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_G] =  "
         <<dynamicContributions[admsNodeID_G] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_G].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_G][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_S] =  "
         <<staticContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_S].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_S][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_S] =  "
         <<dynamicContributions[admsNodeID_S] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_S].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_S][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_B] =  "
         <<staticContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_B].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_B][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_B] =  "
         <<dynamicContributions[admsNodeID_B] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_B].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_B][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI] =  "
         <<staticContributions[admsNodeID_NOI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI] =  "
         <<dynamicContributions[admsNodeID_NOI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_NOI2] =  "
         <<staticContributions[admsNodeID_NOI2] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_NOI2] =  "
         <<dynamicContributions[admsNodeID_NOI2] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_NOI2].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_GP] =  "
         <<staticContributions[admsNodeID_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_GP].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_GP] =  "
         <<dynamicContributions[admsNodeID_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_GP].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_SI] =  "
         <<staticContributions[admsNodeID_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_SI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_SI] =  "
         <<dynamicContributions[admsNodeID_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_SI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_DI] =  "
         <<staticContributions[admsNodeID_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_DI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_DI] =  "
         <<dynamicContributions[admsNodeID_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_DI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BP] =  "
         <<staticContributions[admsNodeID_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BP].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BP] =  "
         <<dynamicContributions[admsNodeID_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BP].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BI] =  "
         <<staticContributions[admsNodeID_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BI].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BI] =  "
         <<dynamicContributions[admsNodeID_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BI].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BI][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BS] =  "
         <<staticContributions[admsNodeID_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BS].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BS] =  "
         <<dynamicContributions[admsNodeID_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BS].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BS][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " staticContributions[admsNodeID_BD] =  "
         <<staticContributions[admsNodeID_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_DI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_SI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_D_DI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_S_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_DI_BD) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BS) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BP) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_DI_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    staticContributions[admsNodeID_BD].dx(admsProbeID_V_GP_SI) =  " <<d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] << std::endl;
    Xyce::dout() << " dynamicContributions[admsNodeID_BD] =  "
         <<dynamicContributions[admsNodeID_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_DI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_SI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_NOI2_GND) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_NOI2_GND] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_B_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_B_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BD_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BD_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BS_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BS_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_BP_BI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_BP_BI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_D_DI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_D_DI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_S_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_S_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_G_GP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_G_GP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_DI_BD) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BS) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_SI_BP) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BP] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_DI_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_SI] << std::endl;
      Xyce::dout() << "    dynamicContributions[admsNodeID_BD].dx(admsProbeID_V_GP_SI) =  " <<d_dynamicContributions[admsNodeID_BD][admsProbeID_V_GP_SI] << std::endl;

    if (!origFlag)
      Xyce::dout() << "This step was limited by this device." << std::endl;
  }


  if (loadLeadCurrent)
  {
    // If needed, we must now copy all the data from staticContributions
    // and dynamicContributionsinto the lead current F vector
    // Must make sure all collapsed node contributions get summed into the
    // external nodes properly.
    for ( int unmappedNode=0; unmappedNode < 4 ; unmappedNode++)
    {
      leadCurrentF[unmappedNode] = 0.0;
      leadCurrentQ[unmappedNode] = 0.0;
    }
    for ( int unmappedNode=0; unmappedNode < 13; unmappedNode++)
    {
      if (nodeMap[unmappedNode] < 4 && nodeMap[unmappedNode] != -1 )
      {
        leadCurrentF[nodeMap[unmappedNode]] += staticContributions[unmappedNode];
        leadCurrentQ[nodeMap[unmappedNode]] += dynamicContributions[unmappedNode];
      }
    }
  }
  return true;
}

//-----------------------------------------------------------------------------
// Function      : Instance::getNumNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
int Instance::getNumNoiseSources () const
{
return 16;
}

//-----------------------------------------------------------------------------
// Function      : Instance::setupNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::setupNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{
int numSources=getNumNoiseSources();
noiseData.numSources = numSources;
noiseData.resize(numSources);

noiseData.deviceName = getName().getEncodedName();
std::string theNoiseName;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_G_GP")+std::string("_")+std::string("rgate");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[0]=theNoiseName;
noiseData.li_Pos[0]=li_G;
noiseData.li_Neg[0]=li_GP;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_S_SI")+std::string("_")+std::string("rsource");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[1]=theNoiseName;
noiseData.li_Pos[1]=li_S;
noiseData.li_Neg[1]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_D_DI")+std::string("_")+std::string("rdrain");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[2]=theNoiseName;
noiseData.li_Pos[2]=li_D;
noiseData.li_Neg[2]=li_DI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BP_BI")+std::string("_")+std::string("rbulk");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[3]=theNoiseName;
noiseData.li_Pos[3]=li_BP;
noiseData.li_Neg[3]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_BI")+std::string("_")+std::string("rjuns");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[4]=theNoiseName;
noiseData.li_Pos[4]=li_BS;
noiseData.li_Neg[4]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_BI")+std::string("_")+std::string("rjund");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[5]=theNoiseName;
noiseData.li_Pos[5]=li_BD;
noiseData.li_Neg[5]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_B_BI")+std::string("_")+std::string("rwell");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[6]=theNoiseName;
noiseData.li_Pos[6]=li_B;
noiseData.li_Neg[6]=li_BI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_NOI2_GND")+std::string("_")+std::string("igig");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[7]=theNoiseName;
noiseData.li_Pos[7]=li_NOI2;
noiseData.li_Neg[7]=-1;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_DI_SI")+std::string("_")+std::string("idid");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[8]=theNoiseName;
noiseData.li_Pos[8]=li_DI;
noiseData.li_Neg[8]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_DI_SI")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[9]=theNoiseName;
noiseData.li_Pos[9]=li_DI;
noiseData.li_Neg[9]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_SI")+std::string("_")+std::string("igs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[10]=theNoiseName;
noiseData.li_Pos[10]=li_GP;
noiseData.li_Neg[10]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_GP_DI")+std::string("_")+std::string("igd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[11]=theNoiseName;
noiseData.li_Pos[11]=li_GP;
noiseData.li_Neg[11]=li_DI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BS_SI")+std::string("_")+std::string("ibs");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[12]=theNoiseName;
noiseData.li_Pos[12]=li_BS;
noiseData.li_Neg[12]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_BD_DI")+std::string("_")+std::string("ibd");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[13]=theNoiseName;
noiseData.li_Pos[13]=li_BD;
noiseData.li_Neg[13]=li_DI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_flicker_DI_SI")+std::string("_")+std::string("flicker");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[14]=theNoiseName;
noiseData.li_Pos[14]=li_DI;
noiseData.li_Neg[14]=li_SI;
theNoiseName = std::string("noise_")+getName().getEncodedName()+std::string("_white_DI_SI")+std::string("_")+std::string("ididedge");
std::replace(theNoiseName.begin(), theNoiseName.end(), ' ', '_');
noiseData.noiseNames[15]=theNoiseName;
noiseData.li_Pos[15]=li_DI;
noiseData.li_Neg[15]=li_SI;


}
//-----------------------------------------------------------------------------
// Function      : Instance::getNoiseSources
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void Instance::getNoiseSources (Xyce::Analysis::NoiseData & noiseData)
{noiseData.noiseDens[0] = noiseContribsPower[0];
noiseData.lnNoiseDens[0] = std::log(std::max(noiseData.noiseDens[0],N_MINLOG));
noiseData.noiseDens[1] = noiseContribsPower[1];
noiseData.lnNoiseDens[1] = std::log(std::max(noiseData.noiseDens[1],N_MINLOG));
noiseData.noiseDens[2] = noiseContribsPower[2];
noiseData.lnNoiseDens[2] = std::log(std::max(noiseData.noiseDens[2],N_MINLOG));
noiseData.noiseDens[3] = noiseContribsPower[3];
noiseData.lnNoiseDens[3] = std::log(std::max(noiseData.noiseDens[3],N_MINLOG));
noiseData.noiseDens[4] = noiseContribsPower[4];
noiseData.lnNoiseDens[4] = std::log(std::max(noiseData.noiseDens[4],N_MINLOG));
noiseData.noiseDens[5] = noiseContribsPower[5];
noiseData.lnNoiseDens[5] = std::log(std::max(noiseData.noiseDens[5],N_MINLOG));
noiseData.noiseDens[6] = noiseContribsPower[6];
noiseData.lnNoiseDens[6] = std::log(std::max(noiseData.noiseDens[6],N_MINLOG));
noiseData.noiseDens[7] = noiseContribsPower[7];
noiseData.lnNoiseDens[7] = std::log(std::max(noiseData.noiseDens[7],N_MINLOG));
noiseData.noiseDens[8] = noiseContribsPower[8];
noiseData.lnNoiseDens[8] = std::log(std::max(noiseData.noiseDens[8],N_MINLOG));
noiseData.noiseDens[9] = noiseContribsPower[9];

      noiseData.noiseDens[9] /= pow(noiseData.freq,noiseContribsExponent[9]);noiseData.lnNoiseDens[9] = std::log(std::max(noiseData.noiseDens[9],N_MINLOG));
noiseData.noiseDens[10] = noiseContribsPower[10];
noiseData.lnNoiseDens[10] = std::log(std::max(noiseData.noiseDens[10],N_MINLOG));
noiseData.noiseDens[11] = noiseContribsPower[11];
noiseData.lnNoiseDens[11] = std::log(std::max(noiseData.noiseDens[11],N_MINLOG));
noiseData.noiseDens[12] = noiseContribsPower[12];
noiseData.lnNoiseDens[12] = std::log(std::max(noiseData.noiseDens[12],N_MINLOG));
noiseData.noiseDens[13] = noiseContribsPower[13];
noiseData.lnNoiseDens[13] = std::log(std::max(noiseData.noiseDens[13],N_MINLOG));
noiseData.noiseDens[14] = noiseContribsPower[14];

      noiseData.noiseDens[14] /= pow(noiseData.freq,noiseContribsExponent[14]);noiseData.lnNoiseDens[14] = std::log(std::max(noiseData.noiseDens[14],N_MINLOG));
noiseData.noiseDens[15] = noiseContribsPower[15];
noiseData.lnNoiseDens[15] = std::log(std::max(noiseData.noiseDens[15],N_MINLOG));

}

//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdFdx
// Purpose       :
// Special Notes : Load the dFdx ("static jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdFdx()
{
  bool bsuccess = true;
  Linear::Matrix & dFdx = *(extData.dFdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*f_DI_Equ_SI_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*f_DI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*f_BP_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*f_BP_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*f_DI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  (*f_BP_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  (*f_DI_Equ_DI_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  (*f_BP_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  (*f_SI_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*f_SI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*f_SI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  (*f_SI_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  (*f_GP_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] -d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*f_GP_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*f_GP_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  (*f_GP_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  (*f_BS_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*f_BS_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*f_SI_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  (*f_BS_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*f_BS_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*f_SI_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  (*f_BD_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*f_BD_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*f_DI_Equ_BS_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  (*f_BD_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*f_BD_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*f_DI_Equ_BD_Node_Ptr) +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  (*f_G_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_G_Equ_GP_Node_Ptr) +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  (*f_GP_Equ_G_Node_Ptr) +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  (*f_S_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  (*f_S_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  (*f_SI_Equ_S_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI];
  (*f_D_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  (*f_D_Equ_DI_Node_Ptr) +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  (*f_DI_Equ_D_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI];
  (*f_BP_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BI_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  (*f_BS_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  (*f_BI_Equ_BS_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  (*f_BD_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  (*f_BI_Equ_BD_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  (*f_B_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_B_Equ_BI_Node_Ptr) +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  (*f_BI_Equ_B_Node_Ptr) +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  (*f_NOI2_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  (*f_NOI2_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  (*f_NOI2_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  (*f_NOI2_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP];
  (*f_NOI2_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI];
  (*f_NOI_Equ_SI_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*f_NOI_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*f_NOI_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  (*f_NOI_Equ_DI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  (*f_NOI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  (*f_NOI_Equ_NOI_Node_Ptr) +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*f_DI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND];
  (*f_SI_Equ_NOI2_Node_Ptr) +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND];
  (*f_BS_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP];
  (*f_BS_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI];
  (*f_BD_Equ_BP_Node_Ptr) +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP];
  (*f_BD_Equ_GP_Node_Ptr) +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI];

#else
  //use the offsets instead of pointers
  dFdx[li_DI][A_DI_Equ_SI_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dFdx[li_DI][A_DI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dFdx[li_BP][A_BP_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dFdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI] -d_staticContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dFdx[li_DI][A_DI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  dFdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  dFdx[li_DI][A_DI_Equ_DI_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  dFdx[li_BP][A_BP_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  dFdx[li_SI][A_SI_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dFdx[li_SI][A_SI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dFdx[li_SI][A_SI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  dFdx[li_SI][A_SI_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  dFdx[li_GP][A_GP_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI] -d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dFdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dFdx[li_GP][A_GP_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  dFdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP] +d_staticContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  dFdx[li_BS][A_BS_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dFdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dFdx[li_SI][A_SI_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  dFdx[li_BS][A_BS_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dFdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dFdx[li_SI][A_SI_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  dFdx[li_BD][A_BD_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP] +d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dFdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dFdx[li_DI][A_DI_Equ_BS_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  dFdx[li_BD][A_BD_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dFdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dFdx[li_DI][A_DI_Equ_BD_NodeOffset] +=  -d_staticContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  dFdx[li_G][A_G_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_G][A_G_Equ_GP_NodeOffset] +=  -d_staticContributions[admsNodeID_G][admsProbeID_V_G_GP];
  dFdx[li_GP][A_GP_Equ_G_NodeOffset] +=  +d_staticContributions[admsNodeID_GP][admsProbeID_V_G_GP];
  dFdx[li_S][A_S_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  dFdx[li_S][A_S_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_S][admsProbeID_V_S_SI];
  dFdx[li_SI][A_SI_Equ_S_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_S_SI];
  dFdx[li_D][A_D_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  dFdx[li_D][A_D_Equ_DI_NodeOffset] +=  -d_staticContributions[admsNodeID_D][admsProbeID_V_D_DI];
  dFdx[li_DI][A_DI_Equ_D_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_D_DI];
  dFdx[li_BP][A_BP_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BP][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BP_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BI][A_BI_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI] -d_staticContributions[admsNodeID_BI][admsProbeID_V_BP_BI];
  dFdx[li_BS][A_BS_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_BS_BI];
  dFdx[li_BI][A_BI_Equ_BS_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BS_BI];
  dFdx[li_BD][A_BD_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_BD_BI];
  dFdx[li_BI][A_BI_Equ_BD_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_BD_BI];
  dFdx[li_B][A_B_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_B][A_B_Equ_BI_NodeOffset] +=  -d_staticContributions[admsNodeID_B][admsProbeID_V_B_BI];
  dFdx[li_BI][A_BI_Equ_B_NodeOffset] +=  +d_staticContributions[admsNodeID_BI][admsProbeID_V_B_BI];
  dFdx[li_NOI2][A_NOI2_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI2][A_NOI2_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  dFdx[li_NOI2][A_NOI2_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI] +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP] -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_GP_SI];
  dFdx[li_NOI2][A_NOI2_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI2][admsProbeID_V_SI_BP];
  dFdx[li_NOI2][A_NOI2_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI2][admsProbeID_V_DI_SI];
  dFdx[li_NOI][A_NOI_Equ_SI_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dFdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dFdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  dFdx[li_NOI][A_NOI_Equ_DI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  dFdx[li_NOI][A_NOI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI2_GND];
  dFdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_staticContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dFdx[li_DI][A_DI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_DI][admsProbeID_V_NOI2_GND];
  dFdx[li_SI][A_SI_Equ_NOI2_NodeOffset] +=  +d_staticContributions[admsNodeID_SI][admsProbeID_V_NOI2_GND];
  dFdx[li_BS][A_BS_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BS][admsProbeID_V_SI_BP];
  dFdx[li_BS][A_BS_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BS][admsProbeID_V_GP_SI];
  dFdx[li_BD][A_BD_Equ_BP_NodeOffset] +=  -d_staticContributions[admsNodeID_BD][admsProbeID_V_SI_BP];
  dFdx[li_BD][A_BD_Equ_GP_NodeOffset] +=  +d_staticContributions[admsNodeID_BD][admsProbeID_V_GP_SI];

#endif

  return bsuccess;
}


//-----------------------------------------------------------------------------
// Function      : Instance::loadDAEdQdx
// Purpose       :
// Special Notes : Load the dQdx ("dynamic jacobian") matrix
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::loadDAEdQdx()
{
  bool bsuccess = true;
  Linear::Matrix & dQdx = *(extData.dQdxMatrixPtr);

#ifndef Xyce_NONPOINTER_MATRIX_LOAD
  (*q_DI_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*q_DI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  (*q_BP_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*q_BP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  (*q_DI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  (*q_BP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  (*q_DI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  (*q_BP_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  (*q_SI_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*q_SI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  (*q_SI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  (*q_SI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  (*q_GP_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*q_GP_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  (*q_GP_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  (*q_GP_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  (*q_BS_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*q_BS_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  (*q_SI_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  (*q_BS_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*q_BS_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  (*q_SI_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  (*q_BD_Equ_SI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*q_BD_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  (*q_DI_Equ_BS_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  (*q_BD_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*q_BD_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  (*q_DI_Equ_BD_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  (*q_NOI_Equ_SI_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*q_NOI_Equ_BP_Node_Ptr) +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  (*q_NOI_Equ_GP_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  (*q_NOI_Equ_DI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  (*q_NOI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  (*q_GP_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  (*q_SI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND];
  (*q_DI_Equ_NOI_Node_Ptr) +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND];

#else
  //use the offsets instead of pointers
  dQdx[li_DI][A_DI_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dQdx[li_DI][A_DI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BP];
  dQdx[li_BP][A_BP_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dQdx[li_BP][A_BP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BP][admsProbeID_V_SI_BP];
  dQdx[li_DI][A_DI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_GP_SI];
  dQdx[li_BP][A_BP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_GP_SI];
  dQdx[li_DI][A_DI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_SI];
  dQdx[li_BP][A_BP_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BP][admsProbeID_V_DI_SI];
  dQdx[li_SI][A_SI_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dQdx[li_SI][A_SI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BP];
  dQdx[li_SI][A_SI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_GP_SI];
  dQdx[li_SI][A_SI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD] +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_SI];
  dQdx[li_GP][A_GP_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dQdx[li_GP][A_GP_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_GP][admsProbeID_V_SI_BP];
  dQdx[li_GP][A_GP_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_DI_SI];
  dQdx[li_GP][A_GP_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_GP_SI];
  dQdx[li_BS][A_BS_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dQdx[li_BS][A_BS_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_SI_BS];
  dQdx[li_SI][A_SI_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_SI_BS];
  dQdx[li_BS][A_BS_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dQdx[li_BS][A_BS_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BS][admsProbeID_V_DI_BD];
  dQdx[li_SI][A_SI_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_SI][admsProbeID_V_DI_BD];
  dQdx[li_BD][A_BD_Equ_SI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dQdx[li_BD][A_BD_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_SI_BS];
  dQdx[li_DI][A_DI_Equ_BS_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_SI_BS];
  dQdx[li_BD][A_BD_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dQdx[li_BD][A_BD_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_BD][admsProbeID_V_DI_BD];
  dQdx[li_DI][A_DI_Equ_BD_NodeOffset] +=  -d_dynamicContributions[admsNodeID_DI][admsProbeID_V_DI_BD];
  dQdx[li_NOI][A_NOI_Equ_SI_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI] -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI] +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dQdx[li_NOI][A_NOI_Equ_BP_NodeOffset] +=  -d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_SI_BP];
  dQdx[li_NOI][A_NOI_Equ_GP_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_GP_SI];
  dQdx[li_NOI][A_NOI_Equ_DI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_DI_SI];
  dQdx[li_NOI][A_NOI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_NOI][admsProbeID_V_NOI_GND];
  dQdx[li_GP][A_GP_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_GP][admsProbeID_V_NOI_GND];
  dQdx[li_SI][A_SI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_SI][admsProbeID_V_NOI_GND];
  dQdx[li_DI][A_DI_Equ_NOI_NodeOffset] +=  +d_dynamicContributions[admsNodeID_DI][admsProbeID_V_NOI_GND];


#endif
  return bsuccess;
}




//-----------------------------------------------------------------------------
// Function      : Instance::updateTemperature
// Purpose       : Set temperature and update any parameters that depend on it
// Special Notes : In Xyce ADMS, we'll simply copy the temperature, which is
//                 in Kelvin, to our "admsTemperature" variable, which needs
//                 to be in Celsius.
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Instance::updateTemperature(const double & temperatureTemp)
{

  admsTemperature = temperatureTemp;
  adms_vt_nom = adms_vt(temperatureTemp);

  return true;
}

// Class Model
//-----------------------------------------------------------------------------
// Function      : Model::processParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
bool Model::processParams()
{

  // Set any non-constant parameter defaults:
  // Set any parameters that were not given and whose defaults depend on other
  // parameters:

// set internal model type based on model card type
if (getType() == "pmos" || getType() == "PMOS")
    TYPE = -1;



  // Now we need to check that any parameters are within their ranges as
  // specified in the verilog:

//    Parameter TYPE : [ (-1), 1 ]] 0, 0 [
  if ( (!((TYPE >=(-1) && TYPE <=1 )) || (TYPE >0 && TYPE <0 )) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TYPE value " << TYPE << " out of range [ (-1), 1 ] or  ] 0, 0 [";
  }

//    Parameter TR : [ (-273.0),  (+inf) [
  if ( (!((TR >=(-273.0)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TR value " << TR << " out of range [ (-273.0),  (+inf) [";
  }

//    Parameter SWGEO : [ 0, 2 ]
  if ( (!((SWGEO >=0 && SWGEO <=2 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWGEO value " << SWGEO << " out of range [ 0, 2 ]";
  }

//    Parameter SWIGATE : [ 0, 1 ]
  if ( (!((SWIGATE >=0 && SWIGATE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIGATE value " << SWIGATE << " out of range [ 0, 1 ]";
  }

//    Parameter SWIMPACT : [ 0, 1 ]
  if ( (!((SWIMPACT >=0 && SWIMPACT <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIMPACT value " << SWIMPACT << " out of range [ 0, 1 ]";
  }

//    Parameter SWGIDL : [ 0, 1 ]
  if ( (!((SWGIDL >=0 && SWGIDL <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWGIDL value " << SWGIDL << " out of range [ 0, 1 ]";
  }

//    Parameter SWJUNCAP : [ 0, 3 ]
  if ( (!((SWJUNCAP >=0 && SWJUNCAP <=3 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNCAP value " << SWJUNCAP << " out of range [ 0, 3 ]";
  }

//    Parameter SWJUNASYM : [ 0, 1 ]
  if ( (!((SWJUNASYM >=0 && SWJUNASYM <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNASYM value " << SWJUNASYM << " out of range [ 0, 1 ]";
  }

//    Parameter SWNUD : [ 0, 2 ]
  if ( (!((SWNUD >=0 && SWNUD <=2 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWNUD value " << SWNUD << " out of range [ 0, 2 ]";
  }

//    Parameter SWEDGE : [ 0, 1 ]
  if ( (!((SWEDGE >=0 && SWEDGE <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWEDGE value " << SWEDGE << " out of range [ 0, 1 ]";
  }

//    Parameter SWDELVTAC : [ 0, 1 ]
  if ( (!((SWDELVTAC >=0 && SWDELVTAC <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWDELVTAC value " << SWDELVTAC << " out of range [ 0, 1 ]";
  }

//    Parameter SWIGN : [ 0, 1 ]
  if ( (!((SWIGN >=0 && SWIGN <=1 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWIGN value " << SWIGN << " out of range [ 0, 1 ]";
  }

//    Parameter QMC : [ 0,  (+inf) [
  if ( (!((QMC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter QMC value " << QMC << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOX : [ 1.0e-10,  (+inf) [
  if ( (!((TOX >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOX value " << TOX << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter EPSROX : [ 1.0,  (+inf) [
  if ( (!((EPSROX >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EPSROX value " << EPSROX << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NEFF : [ 1.0e20, 1.0e26 ]
  if ( (!((NEFF >=1.0e20 && NEFF <=1.0e26 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NEFF value " << NEFF << " out of range [ 1.0e20, 1.0e26 ]";
  }

//    Parameter FACNEFFAC : [ 0,  (+inf) [
  if ( (!((FACNEFFAC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FACNEFFAC value " << FACNEFFAC << " out of range [ 0,  (+inf) [";
  }

//    Parameter GFACNUD : [ 0.01,  (+inf) [
  if ( (!((GFACNUD >=0.01))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GFACNUD value " << GFACNUD << " out of range [ 0.01,  (+inf) [";
  }

//    Parameter VSBNUD : [ 0,  (+inf) [
  if ( (!((VSBNUD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VSBNUD value " << VSBNUD << " out of range [ 0,  (+inf) [";
  }

//    Parameter DVSBNUD : [ 0.1,  (+inf) [
  if ( (!((DVSBNUD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter DVSBNUD value " << DVSBNUD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter NSLP : [ 1.0e-3,  (+inf) [
  if ( (!((NSLP >=1.0e-3))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSLP value " << NSLP << " out of range [ 1.0e-3,  (+inf) [";
  }

//    Parameter DNSUB : [ 0.0, 1.0 ]
  if ( (!((DNSUB >=0.0 && DNSUB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter DNSUB value " << DNSUB << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter NP : [ 0,  (+inf) [
  if ( (!((NP >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NP value " << NP << " out of range [ 0,  (+inf) [";
  }

//    Parameter CT : [ 0,  (+inf) [
  if ( (!((CT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CT value " << CT << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOXOV : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOV >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOV value " << TOXOV << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter TOXOVD : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVD >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVD value " << TOXOVD << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter NOV : [ 1.0e23, 1.0e27 ]
  if ( (!((NOV >=1.0e23 && NOV <=1.0e27 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NOV value " << NOV << " out of range [ 1.0e23, 1.0e27 ]";
  }

//    Parameter NOVD : [ 1.0e23, 1.0e27 ]
  if ( (!((NOVD >=1.0e23 && NOVD <=1.0e27 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NOVD value " << NOVD << " out of range [ 1.0e23, 1.0e27 ]";
  }

//    Parameter CF : [ 0,  (+inf) [
  if ( (!((CF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CF value " << CF << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFD : [ 0,  (+inf) [
  if ( (!((CFD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFD value " << CFD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFB : [ 0.0, 1.0 ]
  if ( (!((CFB >=0.0 && CFB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFB value " << CFB << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter PSCE : [ 0,  (+inf) [
  if ( (!((PSCE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCE value " << PSCE << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSCEB : [ 0.0, 1.0 ]
  if ( (!((PSCEB >=0.0 && PSCEB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEB value " << PSCEB << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter PSCED : [ 0,  (+inf) [
  if ( (!((PSCED >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCED value " << PSCED << " out of range [ 0,  (+inf) [";
  }

//    Parameter BETN : [ 0,  (+inf) [
  if ( (!((BETN >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BETN value " << BETN << " out of range [ 0,  (+inf) [";
  }

//    Parameter MUE : [ 0,  (+inf) [
  if ( (!((MUE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MUE value " << MUE << " out of range [ 0,  (+inf) [";
  }

//    Parameter THEMU : [ 0,  (+inf) [
  if ( (!((THEMU >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THEMU value " << THEMU << " out of range [ 0,  (+inf) [";
  }

//    Parameter CS : [ 0,  (+inf) [
  if ( (!((CS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CS value " << CS << " out of range [ 0,  (+inf) [";
  }

//    Parameter XCOR : [ 0,  (+inf) [
  if ( (!((XCOR >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XCOR value " << XCOR << " out of range [ 0,  (+inf) [";
  }

//    Parameter FETA : [ 0,  (+inf) [
  if ( (!((FETA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FETA value " << FETA << " out of range [ 0,  (+inf) [";
  }

//    Parameter RS : [ 0,  (+inf) [
  if ( (!((RS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RS value " << RS << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSB : [ (-0.5), 1.0 ]
  if ( (!((RSB >=(-0.5) && RSB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSB value " << RSB << " out of range [ (-0.5), 1.0 ]";
  }

//    Parameter RSG : [ (-0.5),  (+inf) [
  if ( (!((RSG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSG value " << RSG << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter THESAT : [ 0,  (+inf) [
  if ( (!((THESAT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESAT value " << THESAT << " out of range [ 0,  (+inf) [";
  }

//    Parameter THESATB : [ (-0.5), 1.0 ]
  if ( (!((THESATB >=(-0.5) && THESATB <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESATB value " << THESATB << " out of range [ (-0.5), 1.0 ]";
  }

//    Parameter THESATG : [ (-0.5),  (+inf) [
  if ( (!((THESATG >=(-0.5)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter THESATG value " << THESATG << " out of range [ (-0.5),  (+inf) [";
  }

//    Parameter AX : [ 2.0,  (+inf) [
  if ( (!((AX >=2.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AX value " << AX << " out of range [ 2.0,  (+inf) [";
  }

//    Parameter ALP : [ 0,  (+inf) [
  if ( (!((ALP >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP value " << ALP << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP1 : [ 0,  (+inf) [
  if ( (!((ALP1 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP1 value " << ALP1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP2 : [ 0,  (+inf) [
  if ( (!((ALP2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP2 value " << ALP2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter VP : [ 1.0e-10,  (+inf) [
  if ( (!((VP >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VP value " << VP << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter A1 : [ 0,  (+inf) [
  if ( (!((A1 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A1 value " << A1 << " out of range [ 0,  (+inf) [";
  }

//    Parameter A2 : [ 0,  (+inf) [
  if ( (!((A2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A2 value " << A2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter A3 : [ 0,  (+inf) [
  if ( (!((A3 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A3 value " << A3 << " out of range [ 0,  (+inf) [";
  }

//    Parameter A4 : [ 0,  (+inf) [
  if ( (!((A4 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter A4 value " << A4 << " out of range [ 0,  (+inf) [";
  }

//    Parameter GCO : [ (-10.0), 10.0 ]
  if ( (!((GCO >=(-10.0) && GCO <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GCO value " << GCO << " out of range [ (-10.0), 10.0 ]";
  }

//    Parameter IGINV : [ 0,  (+inf) [
  if ( (!((IGINV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGINV value " << IGINV << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOV : [ 0,  (+inf) [
  if ( (!((IGOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGOV value " << IGOV << " out of range [ 0,  (+inf) [";
  }

//    Parameter IGOVD : [ 0,  (+inf) [
  if ( (!((IGOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IGOVD value " << IGOVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter GC2 : [ 0.0, 10.0 ]
  if ( (!((GC2 >=0.0 && GC2 <=10.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GC2 value " << GC2 << " out of range [ 0.0, 10.0 ]";
  }

//    Parameter GC3 : [ (-2.0), 2.0 ]
  if ( (!((GC3 >=(-2.0) && GC3 <=2.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter GC3 value " << GC3 << " out of range [ (-2.0), 2.0 ]";
  }

//    Parameter CHIB : [ 1.0,  (+inf) [
  if ( (!((CHIB >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CHIB value " << CHIB << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter AGIDL : [ 0,  (+inf) [
  if ( (!((AGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AGIDL value " << AGIDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter AGIDLD : [ 0,  (+inf) [
  if ( (!((AGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AGIDLD value " << AGIDLD << " out of range [ 0,  (+inf) [";
  }

//    Parameter BGIDL : [ 0,  (+inf) [
  if ( (!((BGIDL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BGIDL value " << BGIDL << " out of range [ 0,  (+inf) [";
  }

//    Parameter BGIDLD : [ 0,  (+inf) [
  if ( (!((BGIDLD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BGIDLD value " << BGIDLD << " out of range [ 0,  (+inf) [";
  }

//    Parameter COX : [ 0,  (+inf) [
  if ( (!((COX >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter COX value " << COX << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGOV : [ 0,  (+inf) [
  if ( (!((CGOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGOV value " << CGOV << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGOVD : [ 0,  (+inf) [
  if ( (!((CGOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGOVD value " << CGOVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CGBOV : [ 0,  (+inf) [
  if ( (!((CGBOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CGBOV value " << CGBOV << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFR : [ 0,  (+inf) [
  if ( (!((CFR >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFR value " << CFR << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFRD : [ 0,  (+inf) [
  if ( (!((CFRD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFRD value " << CFRD << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNT : [ 0,  (+inf) [
  if ( (!((FNT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNT value " << FNT << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNTEXC : [ 0,  (+inf) [
  if ( (!((FNTEXC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEXC value " << FNTEXC << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFA : [ 0,  (+inf) [
  if ( (!((NFA >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFA value " << NFA << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFB : [ 0,  (+inf) [
  if ( (!((NFB >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFB value " << NFB << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFC : [ 0,  (+inf) [
  if ( (!((NFC >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFC value " << NFC << " out of range [ 0,  (+inf) [";
  }

//    Parameter EF : [ 0,  (+inf) [
  if ( (!((EF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EF value " << EF << " out of range [ 0,  (+inf) [";
  }

//    Parameter NEFFEDGE : [ 1.0e20, 1.0e26 ]
  if ( (!((NEFFEDGE >=1.0e20 && NEFFEDGE <=1.0e26 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NEFFEDGE value " << NEFFEDGE << " out of range [ 1.0e20, 1.0e26 ]";
  }

//    Parameter CTEDGE : [ 0,  (+inf) [
  if ( (!((CTEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTEDGE value " << CTEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter BETNEDGE : [ 0,  (+inf) [
  if ( (!((BETNEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter BETNEDGE value " << BETNEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSCEEDGE : [ 0,  (+inf) [
  if ( (!((PSCEEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEEDGE value " << PSCEEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSCEBEDGE : [ 0.0, 1.0 ]
  if ( (!((PSCEBEDGE >=0.0 && PSCEBEDGE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBEDGE value " << PSCEBEDGE << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter PSCEDEDGE : [ 0,  (+inf) [
  if ( (!((PSCEDEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDEDGE value " << PSCEDEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFEDGE : [ 0,  (+inf) [
  if ( (!((CFEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFEDGE value " << CFEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFDEDGE : [ 0,  (+inf) [
  if ( (!((CFDEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDEDGE value " << CFDEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFBEDGE : [ 0.0, 1.0 ]
  if ( (!((CFBEDGE >=0.0 && CFBEDGE <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFBEDGE value " << CFBEDGE << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter FNTEDGE : [ 0,  (+inf) [
  if ( (!((FNTEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEDGE value " << FNTEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFAEDGE : [ 0,  (+inf) [
  if ( (!((NFAEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFAEDGE value " << NFAEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFBEDGE : [ 0,  (+inf) [
  if ( (!((NFBEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFBEDGE value " << NFBEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter NFCEDGE : [ 0,  (+inf) [
  if ( (!((NFCEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NFCEDGE value " << NFCEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter EFEDGE : [ 0,  (+inf) [
  if ( (!((EFEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EFEDGE value " << EFEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter RG : [ 0,  (+inf) [
  if ( (!((RG >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RG value " << RG << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSE : [ 0,  (+inf) [
  if ( (!((RSE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSE value " << RSE << " out of range [ 0,  (+inf) [";
  }

//    Parameter RDE : [ 0,  (+inf) [
  if ( (!((RDE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RDE value " << RDE << " out of range [ 0,  (+inf) [";
  }

//    Parameter RBULK : [ 0,  (+inf) [
  if ( (!((RBULK >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RBULK value " << RBULK << " out of range [ 0,  (+inf) [";
  }

//    Parameter RWELL : [ 0,  (+inf) [
  if ( (!((RWELL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RWELL value " << RWELL << " out of range [ 0,  (+inf) [";
  }

//    Parameter RJUNS : [ 0,  (+inf) [
  if ( (!((RJUNS >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RJUNS value " << RJUNS << " out of range [ 0,  (+inf) [";
  }

//    Parameter RJUND : [ 0,  (+inf) [
  if ( (!((RJUND >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RJUND value " << RJUND << " out of range [ 0,  (+inf) [";
  }

//    Parameter TOXO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXO value " << TOXO << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter EPSROXO : [ 1.0,  (+inf) [
  if ( (!((EPSROXO >=1.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter EPSROXO value " << EPSROXO << " out of range [ 1.0,  (+inf) [";
  }

//    Parameter NSUBO : [ 1.0e20,  (+inf) [
  if ( (!((NSUBO >=1.0e20))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSUBO value " << NSUBO << " out of range [ 1.0e20,  (+inf) [";
  }

//    Parameter WSEG : [ 1.0e-10,  (+inf) [
  if ( (!((WSEG >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WSEG value " << WSEG << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter NPCK : [ 0,  (+inf) [
  if ( (!((NPCK >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NPCK value " << NPCK << " out of range [ 0,  (+inf) [";
  }

//    Parameter WSEGP : [ 1.0e-10,  (+inf) [
  if ( (!((WSEGP >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WSEGP value " << WSEGP << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter LPCK : [ 1.0e-10,  (+inf) [
  if ( (!((LPCK >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LPCK value " << LPCK << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter TOXOVO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVO value " << TOXOVO << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter TOXOVDO : [ 1.0e-10,  (+inf) [
  if ( (!((TOXOVDO >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TOXOVDO value " << TOXOVDO << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter LOV : [ 0,  (+inf) [
  if ( (!((LOV >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LOV value " << LOV << " out of range [ 0,  (+inf) [";
  }

//    Parameter LOVD : [ 0,  (+inf) [
  if ( (!((LOVD >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LOVD value " << LOVD << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFDO : [ 0,  (+inf) [
  if ( (!((CFDO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDO value " << CFDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter PSCEBO : [ 0.0, 1.0 ]
  if ( (!((PSCEBO >=0.0 && PSCEBO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBO value " << PSCEBO << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter PSCEDO : [ 0,  (+inf) [
  if ( (!((PSCEDO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDO value " << PSCEDO << " out of range [ 0,  (+inf) [";
  }

//    Parameter UO : [ 0,  (+inf) [
  if ( (!((UO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter UO value " << UO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LP1 : [ 1.0e-10,  (+inf) [
  if ( (!((LP1 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LP1 value " << LP1 << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter LP2 : [ 1.0e-10,  (+inf) [
  if ( (!((LP2 >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LP2 value " << LP2 << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter WBET : [ 1.0e-10,  (+inf) [
  if ( (!((WBET >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WBET value " << WBET << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter AXL : [ 0,  (+inf) [
  if ( (!((AXL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter AXL value " << AXL << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP1L2 : [ 0,  (+inf) [
  if ( (!((ALP1L2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP1L2 value " << ALP1L2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter ALP2L2 : [ 0,  (+inf) [
  if ( (!((ALP2L2 >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter ALP2L2 value " << ALP2L2 << " out of range [ 0,  (+inf) [";
  }

//    Parameter FNTEXCL : [ 0,  (+inf) [
  if ( (!((FNTEXCL >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FNTEXCL value " << FNTEXCL << " out of range [ 0,  (+inf) [";
  }

//    Parameter WEDGE : [ 0,  (+inf) [
  if ( (!((WEDGE >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WEDGE value " << WEDGE << " out of range [ 0,  (+inf) [";
  }

//    Parameter WEDGEW : [ 0,  (+inf) [
  if ( (!((WEDGEW >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WEDGEW value " << WEDGEW << " out of range [ 0,  (+inf) [";
  }

//    Parameter NSUBEDGEO : [ 1.0e20,  (+inf) [
  if ( (!((NSUBEDGEO >=1.0e20))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter NSUBEDGEO value " << NSUBEDGEO << " out of range [ 1.0e20,  (+inf) [";
  }

//    Parameter LPEDGE : [ 1.0e-10,  (+inf) [
  if ( (!((LPEDGE >=1.0e-10))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LPEDGE value " << LPEDGE << " out of range [ 1.0e-10,  (+inf) [";
  }

//    Parameter PSCEBEDGEO : [ 0.0, 1.0 ]
  if ( (!((PSCEBEDGEO >=0.0 && PSCEBEDGEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEBEDGEO value " << PSCEBEDGEO << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter PSCEDEDGEO : [ 0,  (+inf) [
  if ( (!((PSCEDEDGEO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSCEDEDGEO value " << PSCEDEDGEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFDEDGEO : [ 0,  (+inf) [
  if ( (!((CFDEDGEO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFDEDGEO value " << CFDEDGEO << " out of range [ 0,  (+inf) [";
  }

//    Parameter CFBEDGEO : [ 0.0, 1.0 ]
  if ( (!((CFBEDGEO >=0.0 && CFBEDGEO <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CFBEDGEO value " << CFBEDGEO << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter RINT : [ 0,  (+inf) [
  if ( (!((RINT >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RINT value " << RINT << " out of range [ 0,  (+inf) [";
  }

//    Parameter RVPOLY : [ 0,  (+inf) [
  if ( (!((RVPOLY >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RVPOLY value " << RVPOLY << " out of range [ 0,  (+inf) [";
  }

//    Parameter RSHG : [ 0,  (+inf) [
  if ( (!((RSHG >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter RSHG value " << RSHG << " out of range [ 0,  (+inf) [";
  }

//    Parameter SAREF : [ 1.0e-9,  (+inf) [
  if ( (!((SAREF >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SAREF value " << SAREF << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter SBREF : [ 1.0e-9,  (+inf) [
  if ( (!((SBREF >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SBREF value " << SBREF << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter KVSAT : [ (-1.0), 1.0 ]
  if ( (!((KVSAT >=(-1.0) && KVSAT <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter KVSAT value " << KVSAT << " out of range [ (-1.0), 1.0 ]";
  }

//    Parameter LLODKUO : [ 0,  (+inf) [
  if ( (!((LLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LLODKUO value " << LLODKUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter WLODKUO : [ 0,  (+inf) [
  if ( (!((WLODKUO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WLODKUO value " << WLODKUO << " out of range [ 0,  (+inf) [";
  }

//    Parameter LLODVTH : [ 0,  (+inf) [
  if ( (!((LLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LLODVTH value " << LLODVTH << " out of range [ 0,  (+inf) [";
  }

//    Parameter WLODVTH : [ 0,  (+inf) [
  if ( (!((WLODVTH >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter WLODVTH value " << WLODVTH << " out of range [ 0,  (+inf) [";
  }

//    Parameter LODETAO : [ 0,  (+inf) [
  if ( (!((LODETAO >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter LODETAO value " << LODETAO << " out of range [ 0,  (+inf) [";
  }

//    Parameter SCREF : [ 0,  (+inf) [
  if ( (!((SCREF >=0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SCREF value " << SCREF << " out of range [ 0,  (+inf) [";
  }

//    Parameter IMAX : [ 1.0e-12,  (+inf) [
  if ( (!((IMAX >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IMAX value " << IMAX << " out of range [ 1.0e-12,  (+inf) [";
  }

//    Parameter TRJ : [ (-2.5e2),  (+inf) [
  if ( (!((TRJ >=(-2.5e2)))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter TRJ value " << TRJ << " out of range [ (-2.5e2),  (+inf) [";
  }

//    Parameter FREV : [ 1.0e1, 1.0e10 ]
  if ( (!((FREV >=1.0e1 && FREV <=1.0e10 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FREV value " << FREV << " out of range [ 1.0e1, 1.0e10 ]";
  }

//    Parameter CJORBOT : [ 1.0e-12,  (+inf) [
  if ( (!((CJORBOT >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORBOT value " << CJORBOT << " out of range [ 1.0e-12,  (+inf) [";
  }

//    Parameter CJORSTI : [ 1.0e-18,  (+inf) [
  if ( (!((CJORSTI >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORSTI value " << CJORSTI << " out of range [ 1.0e-18,  (+inf) [";
  }

//    Parameter CJORGAT : [ 1.0e-18,  (+inf) [
  if ( (!((CJORGAT >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORGAT value " << CJORGAT << " out of range [ 1.0e-18,  (+inf) [";
  }

//    Parameter VBIRBOT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRBOT >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRBOT value " << VBIRBOT << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter VBIRSTI : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRSTI >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRSTI value " << VBIRSTI << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter VBIRGAT : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRGAT >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRGAT value " << VBIRGAT << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter PBOT : [ 5.0e-2, 0.95 ]
  if ( (!((PBOT >=5.0e-2 && PBOT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBOT value " << PBOT << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter PSTI : [ 5.0e-2, 0.95 ]
  if ( (!((PSTI >=5.0e-2 && PSTI <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSTI value " << PSTI << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter PGAT : [ 5.0e-2, 0.95 ]
  if ( (!((PGAT >=5.0e-2 && PGAT <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PGAT value " << PGAT << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter IDSATRBOT : [ 0.0,  (+inf) [
  if ( (!((IDSATRBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRBOT value " << IDSATRBOT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter IDSATRSTI : [ 0.0,  (+inf) [
  if ( (!((IDSATRSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRSTI value " << IDSATRSTI << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter IDSATRGAT : [ 0.0,  (+inf) [
  if ( (!((IDSATRGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRGAT value " << IDSATRGAT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHBOT : [ 0.0,  (+inf) [
  if ( (!((CSRHBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHBOT value " << CSRHBOT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHSTI : [ 0.0,  (+inf) [
  if ( (!((CSRHSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHSTI value " << CSRHSTI << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHGAT : [ 0.0,  (+inf) [
  if ( (!((CSRHGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHGAT value " << CSRHGAT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter XJUNSTI : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNSTI >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNSTI value " << XJUNSTI << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter XJUNGAT : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNGAT >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNGAT value " << XJUNGAT << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter CTATBOT : [ 0.0,  (+inf) [
  if ( (!((CTATBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATBOT value " << CTATBOT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CTATSTI : [ 0.0,  (+inf) [
  if ( (!((CTATSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATSTI value " << CTATSTI << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CTATGAT : [ 0.0,  (+inf) [
  if ( (!((CTATGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATGAT value " << CTATGAT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter MEFFTATBOT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATBOT >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATBOT value " << MEFFTATBOT << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter MEFFTATSTI : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATSTI >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATSTI value " << MEFFTATSTI << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter MEFFTATGAT : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATGAT >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATGAT value " << MEFFTATGAT << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter CBBTBOT : [ 0.0,  (+inf) [
  if ( (!((CBBTBOT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTBOT value " << CBBTBOT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CBBTSTI : [ 0.0,  (+inf) [
  if ( (!((CBBTSTI >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTSTI value " << CBBTSTI << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CBBTGAT : [ 0.0,  (+inf) [
  if ( (!((CBBTGAT >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTGAT value " << CBBTGAT << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter VBRBOT : [ 0.1,  (+inf) [
  if ( (!((VBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRBOT value " << VBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRSTI : [ 0.1,  (+inf) [
  if ( (!((VBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRSTI value " << VBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRGAT : [ 0.1,  (+inf) [
  if ( (!((VBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRGAT value " << VBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRBOT : [ 0.1,  (+inf) [
  if ( (!((PBRBOT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRBOT value " << PBRBOT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRSTI : [ 0.1,  (+inf) [
  if ( (!((PBRSTI >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRSTI value " << PBRSTI << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRGAT : [ 0.1,  (+inf) [
  if ( (!((PBRGAT >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRGAT value " << PBRGAT << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter CJORBOTD : [ 1.0e-12,  (+inf) [
  if ( (!((CJORBOTD >=1.0e-12))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORBOTD value " << CJORBOTD << " out of range [ 1.0e-12,  (+inf) [";
  }

//    Parameter CJORSTID : [ 1.0e-18,  (+inf) [
  if ( (!((CJORSTID >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORSTID value " << CJORSTID << " out of range [ 1.0e-18,  (+inf) [";
  }

//    Parameter CJORGATD : [ 1.0e-18,  (+inf) [
  if ( (!((CJORGATD >=1.0e-18))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CJORGATD value " << CJORGATD << " out of range [ 1.0e-18,  (+inf) [";
  }

//    Parameter VBIRBOTD : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRBOTD >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRBOTD value " << VBIRBOTD << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter VBIRSTID : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRSTID >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRSTID value " << VBIRSTID << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter VBIRGATD : [ 5.0e-2,  (+inf) [
  if ( (!((VBIRGATD >=5.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBIRGATD value " << VBIRGATD << " out of range [ 5.0e-2,  (+inf) [";
  }

//    Parameter PBOTD : [ 5.0e-2, 0.95 ]
  if ( (!((PBOTD >=5.0e-2 && PBOTD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBOTD value " << PBOTD << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter PSTID : [ 5.0e-2, 0.95 ]
  if ( (!((PSTID >=5.0e-2 && PSTID <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PSTID value " << PSTID << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter PGATD : [ 5.0e-2, 0.95 ]
  if ( (!((PGATD >=5.0e-2 && PGATD <=0.95 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PGATD value " << PGATD << " out of range [ 5.0e-2, 0.95 ]";
  }

//    Parameter IDSATRBOTD : [ 0.0,  (+inf) [
  if ( (!((IDSATRBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRBOTD value " << IDSATRBOTD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter IDSATRSTID : [ 0.0,  (+inf) [
  if ( (!((IDSATRSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRSTID value " << IDSATRSTID << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter IDSATRGATD : [ 0.0,  (+inf) [
  if ( (!((IDSATRGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter IDSATRGATD value " << IDSATRGATD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHBOTD : [ 0.0,  (+inf) [
  if ( (!((CSRHBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHBOTD value " << CSRHBOTD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHSTID : [ 0.0,  (+inf) [
  if ( (!((CSRHSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHSTID value " << CSRHSTID << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CSRHGATD : [ 0.0,  (+inf) [
  if ( (!((CSRHGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CSRHGATD value " << CSRHGATD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter XJUNSTID : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNSTID >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNSTID value " << XJUNSTID << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter XJUNGATD : [ 1.0e-9,  (+inf) [
  if ( (!((XJUNGATD >=1.0e-9))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter XJUNGATD value " << XJUNGATD << " out of range [ 1.0e-9,  (+inf) [";
  }

//    Parameter CTATBOTD : [ 0.0,  (+inf) [
  if ( (!((CTATBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATBOTD value " << CTATBOTD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CTATSTID : [ 0.0,  (+inf) [
  if ( (!((CTATSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATSTID value " << CTATSTID << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CTATGATD : [ 0.0,  (+inf) [
  if ( (!((CTATGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CTATGATD value " << CTATGATD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter MEFFTATBOTD : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATBOTD >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATBOTD value " << MEFFTATBOTD << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter MEFFTATSTID : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATSTID >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATSTID value " << MEFFTATSTID << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter MEFFTATGATD : [ 1.0e-2,  (+inf) [
  if ( (!((MEFFTATGATD >=1.0e-2))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter MEFFTATGATD value " << MEFFTATGATD << " out of range [ 1.0e-2,  (+inf) [";
  }

//    Parameter CBBTBOTD : [ 0.0,  (+inf) [
  if ( (!((CBBTBOTD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTBOTD value " << CBBTBOTD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CBBTSTID : [ 0.0,  (+inf) [
  if ( (!((CBBTSTID >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTSTID value " << CBBTSTID << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter CBBTGATD : [ 0.0,  (+inf) [
  if ( (!((CBBTGATD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter CBBTGATD value " << CBBTGATD << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter VBRBOTD : [ 0.1,  (+inf) [
  if ( (!((VBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRBOTD value " << VBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRSTID : [ 0.1,  (+inf) [
  if ( (!((VBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRSTID value " << VBRSTID << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter VBRGATD : [ 0.1,  (+inf) [
  if ( (!((VBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VBRGATD value " << VBRGATD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRBOTD : [ 0.1,  (+inf) [
  if ( (!((PBRBOTD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRBOTD value " << PBRBOTD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRSTID : [ 0.1,  (+inf) [
  if ( (!((PBRSTID >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRSTID value " << PBRSTID << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter PBRGATD : [ 0.1,  (+inf) [
  if ( (!((PBRGATD >=0.1))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter PBRGATD value " << PBRGATD << " out of range [ 0.1,  (+inf) [";
  }

//    Parameter SWJUNEXP : [ 0.0, 1.0 ]
  if ( (!((SWJUNEXP >=0.0 && SWJUNEXP <=1.0 ))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter SWJUNEXP value " << SWJUNEXP << " out of range [ 0.0, 1.0 ]";
  }

//    Parameter VJUNREF : [ 0.5,  (+inf) [
  if ( (!((VJUNREF >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VJUNREF value " << VJUNREF << " out of range [ 0.5,  (+inf) [";
  }

//    Parameter FJUNQ : [ 0.0,  (+inf) [
  if ( (!((FJUNQ >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FJUNQ value " << FJUNQ << " out of range [ 0.0,  (+inf) [";
  }

//    Parameter VJUNREFD : [ 0.5,  (+inf) [
  if ( (!((VJUNREFD >=0.5))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter VJUNREFD value " << VJUNREFD << " out of range [ 0.5,  (+inf) [";
  }

//    Parameter FJUNQD : [ 0.0,  (+inf) [
  if ( (!((FJUNQD >=0.0))) )
  {
    UserWarning(*this) << "ADMSPSP103VA: Parameter FJUNQD value " << FJUNQD << " out of range [ 0.0,  (+inf) [";
  }

  // and of course, this routine is where we should put the initial_model
  // stuff
  double deltaEgat_d=0.0;
  double deltaEsti_d=0.0;
  double deltaEbot_d=0.0;
  double ubigat_d=0.0;
  double ubisti_d=0.0;
  double ubibot_d=0.0;
  double phigdgat_d=0.0;
  double phigdsti_d=0.0;
  double phigdbot_d=0.0;
  double phigrgat_d=0.0;
  double phigrsti_d=0.0;
  double phigrbot_d=0.0;
  double deltaEgat=0.0;
  double deltaEsti=0.0;
  double deltaEbot=0.0;
  double ubigat=0.0;
  double ubisti=0.0;
  double ubibot=0.0;
  double phigdgat=0.0;
  double phigdsti=0.0;
  double phigdbot=0.0;
  double deltaphigd=0.0;
  double phigrgat=0.0;
  double phigrsti=0.0;
  double phigrbot=0.0;
  double deltaphigr=0.0;
  double phitrinv=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
  double tkd=0.0;
  double tkr=0.0;
  double STFBBTGATD_i=0.0;
  double STFBBTSTID_i=0.0;
  double STFBBTBOTD_i=0.0;
  double FBBTRGATD_i=0.0;
  double FBBTRSTID_i=0.0;
  double FBBTRBOTD_i=0.0;
  double MEFFTATGATD_i=0.0;
  double MEFFTATSTID_i=0.0;
  double MEFFTATBOTD_i=0.0;
  double XJUNGATD_i=0.0;
  double XJUNSTID_i=0.0;
  double IDSATRGATD_i=0.0;
  double IDSATRSTID_i=0.0;
  double IDSATRBOTD_i=0.0;
  double PHIGGATD_i=0.0;
  double PHIGSTID_i=0.0;
  double PHIGBOTD_i=0.0;
  double CJORGATD_i=0.0;
  double CJORSTID_i=0.0;
  double CJORBOTD_i=0.0;
  double STFBBTGAT_i=0.0;
  double STFBBTSTI_i=0.0;
  double STFBBTBOT_i=0.0;
  double FBBTRGAT_i=0.0;
  double FBBTRSTI_i=0.0;
  double FBBTRBOT_i=0.0;
  double MEFFTATGAT_i=0.0;
  double MEFFTATSTI_i=0.0;
  double MEFFTATBOT_i=0.0;
  double XJUNGAT_i=0.0;
  double XJUNSTI_i=0.0;
  double IDSATRGAT_i=0.0;
  double IDSATRSTI_i=0.0;
  double IDSATRBOT_i=0.0;
  double PHIGGAT_i=0.0;
  double PHIGSTI_i=0.0;
  double PHIGBOT_i=0.0;
  double CJORGAT_i=0.0;
  double CJORSTI_i=0.0;
  double CJORBOT_i=0.0;
  double FREV_i=0.0;
  double TRJ_i=0.0;
  double TKD_sq=0.0;
  double TKA=0.0;
  double TKR=0.0;
  double TR_i=0.0;
//Begin block initial_model
{
if ((TYPE>=0))
{
CHNL_TYPE = (+1);
}
else
{
CHNL_TYPE = (-1);
}
EPSSI = (8.8541878176E-12*11.8);
{
double value_floor_0 = floor((((SWGEO>0.0)?((SWGEO<2.0)?SWGEO:2.0):0.0)+0.5));
SWGEO_i = floor((((SWGEO>0.0)?((SWGEO<2.0)?SWGEO:2.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWIGATE>0.0)?((SWIGATE<1.0)?SWIGATE:1.0):0.0)+0.5));
SWIGATE_i = floor((((SWIGATE>0.0)?((SWIGATE<1.0)?SWIGATE:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWIMPACT>0.0)?((SWIMPACT<1.0)?SWIMPACT:1.0):0.0)+0.5));
SWIMPACT_i = floor((((SWIMPACT>0.0)?((SWIMPACT<1.0)?SWIMPACT:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWGIDL>0.0)?((SWGIDL<1.0)?SWGIDL:1.0):0.0)+0.5));
SWGIDL_i = floor((((SWGIDL>0.0)?((SWGIDL<1.0)?SWGIDL:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWJUNCAP>0.0)?((SWJUNCAP<3.0)?SWJUNCAP:3.0):0.0)+0.5));
SWJUNCAP_i = floor((((SWJUNCAP>0.0)?((SWJUNCAP<3.0)?SWJUNCAP:3.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWJUNASYM>0.0)?((SWJUNASYM<1.0)?SWJUNASYM:1.0):0.0)+0.5));
SWJUNASYM_i = floor((((SWJUNASYM>0.0)?((SWJUNASYM<1.0)?SWJUNASYM:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWNUD>0.0)?((SWNUD<2.0)?SWNUD:2.0):0.0)+0.5));
SWNUD_i = floor((((SWNUD>0.0)?((SWNUD<2.0)?SWNUD:2.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWEDGE>0.0)?((SWEDGE<1.0)?SWEDGE:1.0):0.0)+0.5));
SWEDGE_i = floor((((SWEDGE>0.0)?((SWEDGE<1.0)?SWEDGE:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWDELVTAC>0.0)?((SWDELVTAC<1.0)?SWDELVTAC:1.0):0.0)+0.5));
SWDELVTAC_i = floor((((SWDELVTAC>0.0)?((SWDELVTAC<1.0)?SWDELVTAC:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((SWIGN>0.0)?((SWIGN<1.0)?SWIGN:1.0):0.0)+0.5));
SWIGN_i = floor((((SWIGN>0.0)?((SWIGN<1.0)?SWIGN:1.0):0.0)+0.5));
}
QMC_i = ((QMC>0.0)?QMC:0.0);
TOXO_i = ((TOXO>1.0e-10)?TOXO:1.0e-10);
EPSROXO_i = ((EPSROXO>1.0)?EPSROXO:1.0);
NSUBO_i = ((NSUBO>1.0e20)?NSUBO:1.0e20);
WSEG_i = ((WSEG>1.0e-10)?WSEG:1.0e-10);
NPCK_i = ((NPCK>0.0)?NPCK:0.0);
WSEGP_i = ((WSEGP>1.0e-10)?WSEGP:1.0e-10);
LPCK_i = ((LPCK>1.0e-10)?LPCK:1.0e-10);
TOXOVO_i = ((TOXOVO>1.0e-10)?TOXOVO:1.0e-10);
TOXOVDO_i = ((TOXOVDO>1.0e-10)?TOXOVDO:1.0e-10);
LOV_i = ((LOV>0.0)?LOV:0.0);
LOVD_i = ((LOVD>0.0)?LOVD:0.0);
LP1_i = ((LP1>1.0e-10)?LP1:1.0e-10);
LP2_i = ((LP2>1.0e-10)?LP2:1.0e-10);
WBET_i = ((WBET>1.0e-10)?WBET:1.0e-10);
AXL_i = ((AXL>0.0)?AXL:0.0);
ALP1L2_i = ((ALP1L2>0.0)?ALP1L2:0.0);
ALP2L2_i = ((ALP2L2>0.0)?ALP2L2:0.0);
SAREF_i = ((SAREF>1.0e-9)?SAREF:1.0e-9);
SBREF_i = ((SBREF>1.0e-9)?SBREF:1.0e-9);
KVSAT_i = ((KVSAT>(-1.0))?((KVSAT<1.0)?KVSAT:1.0):(-1.0));
LLODKUO_i = ((LLODKUO>0.0)?LLODKUO:0.0);
WLODKUO_i = ((WLODKUO>0.0)?WLODKUO:0.0);
LLODVTH_i = ((LLODVTH>0.0)?LLODVTH:0.0);
WLODVTH_i = ((WLODVTH>0.0)?WLODVTH:0.0);
LODETAO_i = ((LODETAO>0.0)?LODETAO:0.0);
SCREF_i = ((SCREF>0.0)?SCREF:0.0);
WEB_i = WEB;
WEC_i = WEC;
RSHG_i = ((RSHG>0.0)?RSHG:0.0);
RSH_i = ((RSH>0.0)?RSH:0.0);
RSHD_i = ((RSHD>0.0)?RSHD:0.0);
RINT_i = ((RINT>0.0)?RINT:0.0);
RVPOLY_i = ((RVPOLY>0.0)?RVPOLY:0.0);
NSUBEDGEO_i = ((NSUBEDGEO>1.0e20)?NSUBEDGEO:1.0e20);
LPEDGE_i = ((LPEDGE>1.0e-10)?LPEDGE:1.0e-10);
TR_i = ((TR>(-273.0))?TR:(-273.0));
TKR = (273.15+TR_i);
TKA = (admsModTemp+DTA);
rTa = (TKA/TKR);
delTa = (TKA-TKR);
phita = ((TKA*1.3806505E-23)/1.6021918E-19);
inv_phita = (1.0/phita);
TKD = TKA;
TKD_sq = (TKD*TKD);
delT = (TKD-TKR);
rTn = (TKR/TKD);
{
double value_log_0 = log(rTn);
ln_rTn = value_log_0;
}
phit = ((TKD*1.3806505E-23)/1.6021918E-19);
inv_phit = (1.0/phit);
Eg = ((1.179-(9.025e-5*TKD))-(3.05e-7*TKD_sq));
phibFac = ((((1.045+(4.5e-4*TKD))*((0.523+(1.4e-3*TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
phibFac = ((phibFac>1.0E-3)?phibFac:1.0E-3);
nt0 = ((4.0*1.3806505E-23)*TKD);
TRJ_i = ((TRJ>(-2.5e2))?TRJ:(-2.5e2));
IMAX_i = ((IMAX>1.0e-12)?IMAX:1.0e-12);
FREV_i = ((FREV>1.0e1)?((FREV<1.0e10)?FREV:1.0e10):1.0e1);
CJORBOT_i = ((CJORBOT>1.0e-12)?CJORBOT:1.0e-12);
CJORSTI_i = ((CJORSTI>1.0e-18)?CJORSTI:1.0e-18);
CJORGAT_i = ((CJORGAT>1.0e-18)?CJORGAT:1.0e-18);
VBIRBOT_i = ((VBIRBOT>5.0e-2)?VBIRBOT:5.0e-2);
VBIRSTI_i = ((VBIRSTI>5.0e-2)?VBIRSTI:5.0e-2);
VBIRGAT_i = ((VBIRGAT>5.0e-2)?VBIRGAT:5.0e-2);
PBOT_i = ((PBOT>5.0e-2)?((PBOT<0.95)?PBOT:0.95):5.0e-2);
PSTI_i = ((PSTI>5.0e-2)?((PSTI<0.95)?PSTI:0.95):5.0e-2);
PGAT_i = ((PGAT>5.0e-2)?((PGAT<0.95)?PGAT:0.95):5.0e-2);
PHIGBOT_i = PHIGBOT;
PHIGSTI_i = PHIGSTI;
PHIGGAT_i = PHIGGAT;
IDSATRBOT_i = ((IDSATRBOT>0.0)?IDSATRBOT:0.0);
IDSATRSTI_i = ((IDSATRSTI>0.0)?IDSATRSTI:0.0);
IDSATRGAT_i = ((IDSATRGAT>0.0)?IDSATRGAT:0.0);
CSRHBOT_i = ((CSRHBOT>0.0)?CSRHBOT:0.0);
CSRHSTI_i = ((CSRHSTI>0.0)?CSRHSTI:0.0);
CSRHGAT_i = ((CSRHGAT>0.0)?CSRHGAT:0.0);
XJUNSTI_i = ((XJUNSTI>1.0e-9)?XJUNSTI:1.0e-9);
XJUNGAT_i = ((XJUNGAT>1.0e-9)?XJUNGAT:1.0e-9);
CTATBOT_i = ((CTATBOT>0.0)?CTATBOT:0.0);
CTATSTI_i = ((CTATSTI>0.0)?CTATSTI:0.0);
CTATGAT_i = ((CTATGAT>0.0)?CTATGAT:0.0);
MEFFTATBOT_i = ((MEFFTATBOT>1.0e-2)?MEFFTATBOT:1.0e-2);
MEFFTATSTI_i = ((MEFFTATSTI>1.0e-2)?MEFFTATSTI:1.0e-2);
MEFFTATGAT_i = ((MEFFTATGAT>1.0e-2)?MEFFTATGAT:1.0e-2);
CBBTBOT_i = ((CBBTBOT>0.0)?CBBTBOT:0.0);
CBBTSTI_i = ((CBBTSTI>0.0)?CBBTSTI:0.0);
CBBTGAT_i = ((CBBTGAT>0.0)?CBBTGAT:0.0);
FBBTRBOT_i = FBBTRBOT;
FBBTRSTI_i = FBBTRSTI;
FBBTRGAT_i = FBBTRGAT;
STFBBTBOT_i = STFBBTBOT;
STFBBTSTI_i = STFBBTSTI;
STFBBTGAT_i = STFBBTGAT;
VBRBOT_i = ((VBRBOT>0.1)?VBRBOT:0.1);
VBRSTI_i = ((VBRSTI>0.1)?VBRSTI:0.1);
VBRGAT_i = ((VBRGAT>0.1)?VBRGAT:0.1);
PBRBOT_i = ((PBRBOT>0.1)?PBRBOT:0.1);
PBRSTI_i = ((PBRSTI>0.1)?PBRSTI:0.1);
PBRGAT_i = ((PBRGAT>0.1)?PBRGAT:0.1);
SWJUNEXP_i = 0.0;
if ((SWJUNEXP>0.5))
{
SWJUNEXP_i = 1.0;
}
else
{
SWJUNEXP_i = 0.0;
}
VJUNREF_i = ((VJUNREF>0.5)?VJUNREF:0.5);
FJUNQ_i = ((FJUNQ>0.0)?FJUNQ:0.0);
if ((SWJUNASYM==0.0))
{
CJORBOTD_i = CJORBOT_i;
CJORSTID_i = CJORSTI_i;
CJORGATD_i = CJORGAT_i;
VBIRBOTD_i = VBIRBOT_i;
VBIRSTID_i = VBIRSTI_i;
VBIRGATD_i = VBIRGAT_i;
PBOTD_i = PBOT_i;
PSTID_i = PSTI_i;
PGATD_i = PGAT_i;
PHIGBOTD_i = PHIGBOT_i;
PHIGSTID_i = PHIGSTI_i;
PHIGGATD_i = PHIGGAT_i;
IDSATRBOTD_i = IDSATRBOT_i;
IDSATRSTID_i = IDSATRSTI_i;
IDSATRGATD_i = IDSATRGAT_i;
CSRHBOTD_i = CSRHBOT_i;
CSRHSTID_i = CSRHSTI_i;
CSRHGATD_i = CSRHGAT_i;
XJUNSTID_i = XJUNSTI_i;
XJUNGATD_i = XJUNGAT_i;
CTATBOTD_i = CTATBOT_i;
CTATSTID_i = CTATSTI_i;
CTATGATD_i = CTATGAT_i;
MEFFTATBOTD_i = MEFFTATBOT_i;
MEFFTATSTID_i = MEFFTATSTI_i;
MEFFTATGATD_i = MEFFTATGAT_i;
CBBTBOTD_i = CBBTBOT_i;
CBBTSTID_i = CBBTSTI_i;
CBBTGATD_i = CBBTGAT_i;
FBBTRBOTD_i = FBBTRBOT_i;
FBBTRSTID_i = FBBTRSTI_i;
FBBTRGATD_i = FBBTRGAT_i;
STFBBTBOTD_i = STFBBTBOT_i;
STFBBTSTID_i = STFBBTSTI_i;
STFBBTGATD_i = STFBBTGAT_i;
VBRBOTD_i = VBRBOT_i;
VBRSTID_i = VBRSTI_i;
VBRGATD_i = VBRGAT_i;
PBRBOTD_i = PBRBOT_i;
PBRSTID_i = PBRSTI_i;
PBRGATD_i = PBRGAT_i;
VJUNREFD_i = VJUNREF_i;
FJUNQD_i = FJUNQ_i;
}
else
{
CJORBOTD_i = ((CJORBOTD>1.0e-12)?CJORBOTD:1.0e-12);
CJORSTID_i = ((CJORSTID>1.0e-18)?CJORSTID:1.0e-18);
CJORGATD_i = ((CJORGATD>1.0e-18)?CJORGATD:1.0e-18);
VBIRBOTD_i = ((VBIRBOTD>5.0e-2)?VBIRBOTD:5.0e-2);
VBIRSTID_i = ((VBIRSTID>5.0e-2)?VBIRSTID:5.0e-2);
VBIRGATD_i = ((VBIRGATD>5.0e-2)?VBIRGATD:5.0e-2);
PBOTD_i = ((PBOTD>5.0e-2)?((PBOTD<0.95)?PBOTD:0.95):5.0e-2);
PSTID_i = ((PSTID>5.0e-2)?((PSTID<0.95)?PSTID:0.95):5.0e-2);
PGATD_i = ((PGATD>5.0e-2)?((PGATD<0.95)?PGATD:0.95):5.0e-2);
PHIGBOTD_i = PHIGBOTD;
PHIGSTID_i = PHIGSTID;
PHIGGATD_i = PHIGGATD;
IDSATRBOTD_i = ((IDSATRBOTD>0.0)?IDSATRBOTD:0.0);
IDSATRSTID_i = ((IDSATRSTID>0.0)?IDSATRSTID:0.0);
IDSATRGATD_i = ((IDSATRGATD>0.0)?IDSATRGATD:0.0);
CSRHBOTD_i = ((CSRHBOTD>0.0)?CSRHBOTD:0.0);
CSRHSTID_i = ((CSRHSTID>0.0)?CSRHSTID:0.0);
CSRHGATD_i = ((CSRHGATD>0.0)?CSRHGATD:0.0);
XJUNSTID_i = ((XJUNSTID>1.0e-9)?XJUNSTID:1.0e-9);
XJUNGATD_i = ((XJUNGATD>1.0e-9)?XJUNGATD:1.0e-9);
CTATBOTD_i = ((CTATBOTD>0.0)?CTATBOTD:0.0);
CTATSTID_i = ((CTATSTID>0.0)?CTATSTID:0.0);
CTATGATD_i = ((CTATGATD>0.0)?CTATGATD:0.0);
MEFFTATBOTD_i = ((MEFFTATBOTD>1.0e-2)?MEFFTATBOTD:1.0e-2);
MEFFTATSTID_i = ((MEFFTATSTID>1.0e-2)?MEFFTATSTID:1.0e-2);
MEFFTATGATD_i = ((MEFFTATGATD>1.0e-2)?MEFFTATGATD:1.0e-2);
CBBTBOTD_i = ((CBBTBOTD>0.0)?CBBTBOTD:0.0);
CBBTSTID_i = ((CBBTSTID>0.0)?CBBTSTID:0.0);
CBBTGATD_i = ((CBBTGATD>0.0)?CBBTGATD:0.0);
FBBTRBOTD_i = FBBTRBOTD;
FBBTRSTID_i = FBBTRSTID;
FBBTRGATD_i = FBBTRGATD;
STFBBTBOTD_i = STFBBTBOTD;
STFBBTSTID_i = STFBBTSTID;
STFBBTGATD_i = STFBBTGATD;
VBRBOTD_i = ((VBRBOTD>0.1)?VBRBOTD:0.1);
VBRSTID_i = ((VBRSTID>0.1)?VBRSTID:0.1);
VBRGATD_i = ((VBRGATD>0.1)?VBRGATD:0.1);
PBRBOTD_i = ((PBRBOTD>0.1)?PBRBOTD:0.1);
PBRSTID_i = ((PBRSTID>0.1)?PBRSTID:0.1);
PBRGATD_i = ((PBRGATD>0.1)?PBRGATD:0.1);
VJUNREFD_i = ((VJUNREFD>0.5)?VJUNREFD:0.5);
FJUNQD_i = ((FJUNQD>0.0)?FJUNQD:0.0);
}
tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsModTemp+DTA),(273.15+(-2.5e2)));
tkd = value_max_0;
}
auxt = (tkd/tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
phitr = (KBOL_over_QELE*tkr);
phitrinv = (1.0/phitr);
phitd = (KBOL_over_QELE*tkd);
phitdinv = (1.0/phitd);
deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
phigrbot = (PHIGBOT_i+deltaphigr);
phigrsti = (PHIGSTI_i+deltaphigr);
phigrgat = (PHIGGAT_i+deltaphigr);
deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
phigdbot = (PHIGBOT_i+deltaphigd);
phigdsti = (PHIGSTI_i+deltaphigd);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*phitdinv))));
ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*phitdinv))));
ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*phitdinv))));
ftdgat = (value_pow_0*value_exp_1);
}
idsatbot = ((IDSATRBOT_i*ftdbot)*ftdbot);
idsatsti = ((IDSATRSTI_i*ftdsti)*ftdsti);
idsatgat = ((IDSATRGAT_i*ftdgat)*ftdgat);
{
double value_log_0 = log(ftdbot);
ubibot = ((VBIRBOT_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdsti);
ubisti = ((VBIRSTI_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdgat);
ubigat = ((VBIRGAT_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_exp_0 = exp(((5.0e-2-ubibot)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbibot = (ubibot+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubisti)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbisti = (ubisti+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubigat)*phitdinv));
double value_log_1 = log((1+value_exp_0));
vbigat = (ubigat+(phitd*value_log_1));
}
vbiinvbot = (1.0/vbibot);
vbiinvsti = (1.0/vbisti);
vbiinvgat = (1.0/vbigat);
one_minus_PBOT = (1.0-PBOT_i);
one_minus_PSTI = (1.0-PSTI_i);
one_minus_PGAT = (1.0-PGAT_i);
one_over_one_minus_PBOT = (1.0/one_minus_PBOT);
one_over_one_minus_PSTI = (1.0/one_minus_PSTI);
one_over_one_minus_PGAT = (1.0/one_minus_PGAT);
{
double value_pow_0 = pow((VBIRBOT_i*vbiinvbot),PBOT_i);
cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRSTI_i*vbiinvsti),PSTI_i);
cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRGAT_i*vbiinvgat),PGAT_i);
cjogat = (CJORGAT_i*value_pow_0);
}
qprefbot = ((cjobot*vbibot)*one_over_one_minus_PBOT);
qprefsti = ((cjosti*vbisti)*one_over_one_minus_PSTI);
qprefgat = ((cjogat*vbigat)*one_over_one_minus_PGAT);
qpref2bot = (2.0*cjobot);
qpref2sti = (2.0*cjosti);
qpref2gat = (2.0*cjogat);
wdepnulrbot = (EPSSI/CJORBOT_i);
wdepnulrsti = ((XJUNSTI_i*EPSSI)/CJORSTI_i);
wdepnulrgat = ((XJUNGAT_i*EPSSI)/CJORGAT_i);
wdepnulrinvbot = (1.0/wdepnulrbot);
wdepnulrinvsti = (1.0/wdepnulrsti);
wdepnulrinvgat = (1.0/wdepnulrgat);
VBIRBOTinv = (1.0/VBIRBOT_i);
VBIRSTIinv = (1.0/VBIRSTI_i);
VBIRGATinv = (1.0/VBIRGAT_i);
perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(perfc,(-2.0));
berfc = (((((-5.0)*0.29214664)+6.0)-value_pow_0)/3.0);
}
cerfc = ((1.0-0.29214664)-berfc);
{
double value_max_0 = std::max((0.5*phigdbot),phitd);
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),phitd);
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),phitd);
deltaEgat = value_max_0;
}
atatbot = (deltaEbot*phitdinv);
atatsti = (deltaEsti*phitdinv);
atatgat = (deltaEgat*phitdinv);
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
btatpartbot = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
btatpartsti = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
btatpartgat = (value_sqrt_0/(3.0*1.05457168E-34));
}
fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
fbbtbot = ((fbbtbot>0.0)?fbbtbot:0.0);
fbbtsti = ((fbbtsti>0.0)?fbbtsti:0.0);
fbbtgat = ((fbbtgat>0.0)?fbbtgat:0.0);
alphaav = (1.0-(1.0/FREV_i));
{
double value_pow_0 = pow(alphaav,PBRBOT_i);
fstopbot = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRSTI_i);
fstopsti = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRGAT_i);
fstopgat = (1.0/(1.0-value_pow_0));
}
VBRinvbot = (1.0/VBRBOT_i);
VBRinvsti = (1.0/VBRSTI_i);
VBRinvgat = (1.0/VBRGAT_i);
{
double value_pow_0 = pow(alphaav,(PBRBOT_i-1.0));
slopebot = (((-((fstopbot*fstopbot)*value_pow_0))*PBRBOT_i)*VBRinvbot);
}
{
double value_pow_0 = pow(alphaav,(PBRSTI_i-1.0));
slopesti = (((-((fstopsti*fstopsti)*value_pow_0))*PBRSTI_i)*VBRinvsti);
}
{
double value_pow_0 = pow(alphaav,(PBRGAT_i-1.0));
slopegat = (((-((fstopgat*fstopgat)*value_pow_0))*PBRGAT_i)*VBRinvgat);
}
phigrbot_d = (PHIGBOTD_i+deltaphigr);
phigrsti_d = (PHIGSTID_i+deltaphigr);
phigrgat_d = (PHIGGATD_i+deltaphigr);
phigdbot_d = (PHIGBOTD_i+deltaphigd);
phigdsti_d = (PHIGSTID_i+deltaphigd);
phigdgat_d = (PHIGGATD_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*phitdinv))));
ftdbot_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*phitdinv))));
ftdsti_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*phitdinv))));
ftdgat_d = (value_pow_0*value_exp_1);
}
idsatbot_d = ((IDSATRBOTD_i*ftdbot_d)*ftdbot_d);
idsatsti_d = ((IDSATRSTID_i*ftdsti_d)*ftdsti_d);
idsatgat_d = ((IDSATRGATD_i*ftdgat_d)*ftdgat_d);
{
double value_log_0 = log(ftdbot_d);
ubibot_d = ((VBIRBOTD_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdsti_d);
ubisti_d = ((VBIRSTID_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_log_0 = log(ftdgat_d);
ubigat_d = ((VBIRGATD_i*auxt)-((2.0*phitd)*value_log_0));
}
{
double value_exp_0 = exp(((5.0e-2-ubibot_d)*phitdinv));
double value_log_1 = log((1.0+value_exp_0));
vbibot_d = (ubibot_d+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubisti_d)*phitdinv));
double value_log_1 = log((1.0+value_exp_0));
vbisti_d = (ubisti_d+(phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubigat_d)*phitdinv));
double value_log_1 = log((1.0+value_exp_0));
vbigat_d = (ubigat_d+(phitd*value_log_1));
}
vbiinvbot_d = (1.0/vbibot_d);
vbiinvsti_d = (1.0/vbisti_d);
vbiinvgat_d = (1.0/vbigat_d);
one_minus_PBOT_d = (1.0-PBOTD_i);
one_minus_PSTI_d = (1.0-PSTID_i);
one_minus_PGAT_d = (1.0-PGATD_i);
one_over_one_minus_PBOT_d = (1.0/one_minus_PBOT_d);
one_over_one_minus_PSTI_d = (1.0/one_minus_PSTI_d);
one_over_one_minus_PGAT_d = (1.0/one_minus_PGAT_d);
{
double value_pow_0 = pow((VBIRBOTD_i*vbiinvbot_d),PBOTD_i);
cjobot_d = (CJORBOTD_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRSTID_i*vbiinvsti_d),PSTID_i);
cjosti_d = (CJORSTID_i*value_pow_0);
}
{
double value_pow_0 = pow((VBIRGATD_i*vbiinvgat_d),PGATD_i);
cjogat_d = (CJORGATD_i*value_pow_0);
}
qprefbot_d = ((cjobot_d*vbibot_d)*one_over_one_minus_PBOT_d);
qprefsti_d = ((cjosti_d*vbisti_d)*one_over_one_minus_PSTI_d);
qprefgat_d = ((cjogat_d*vbigat_d)*one_over_one_minus_PGAT_d);
qpref2bot_d = (2.0*cjobot_d);
qpref2sti_d = (2.0*cjosti_d);
qpref2gat_d = (2.0*cjogat_d);
wdepnulrbot_d = (EPSSI/CJORBOTD_i);
wdepnulrsti_d = ((XJUNSTID_i*EPSSI)/CJORSTID_i);
wdepnulrgat_d = ((XJUNGATD_i*EPSSI)/CJORGATD_i);
wdepnulrinvbot_d = (1.0/wdepnulrbot_d);
wdepnulrinvsti_d = (1.0/wdepnulrsti_d);
wdepnulrinvgat_d = (1.0/wdepnulrgat_d);
VBIRBOTinv_d = (1.0/VBIRBOTD_i);
VBIRSTIinv_d = (1.0/VBIRSTID_i);
VBIRGATinv_d = (1.0/VBIRGATD_i);
{
double value_max_0 = std::max((0.5*phigdbot_d),phitd);
deltaEbot_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti_d),phitd);
deltaEsti_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat_d),phitd);
deltaEgat_d = value_max_0;
}
atatbot_d = (deltaEbot_d*phitdinv);
atatsti_d = (deltaEsti_d*phitdinv);
atatgat_d = (deltaEgat_d*phitdinv);
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
btatpartbot_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
btatpartsti_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
btatpartgat_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
fbbtbot_d = (FBBTRBOTD_i*(1.0+(STFBBTBOTD_i*(tkd-tkr))));
fbbtsti_d = (FBBTRSTID_i*(1.0+(STFBBTSTID_i*(tkd-tkr))));
fbbtgat_d = (FBBTRGATD_i*(1.0+(STFBBTGATD_i*(tkd-tkr))));
fbbtbot_d = ((fbbtbot_d>0.0)?fbbtbot_d:0.0);
fbbtsti_d = ((fbbtsti_d>0.0)?fbbtsti_d:0.0);
fbbtgat_d = ((fbbtgat_d>0.0)?fbbtgat_d:0.0);
{
double value_pow_0 = pow(alphaav,PBRBOTD_i);
fstopbot_d = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRSTID_i);
fstopsti_d = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(alphaav,PBRGATD_i);
fstopgat_d = (1.0/(1.0-value_pow_0));
}
VBRinvbot_d = (1.0/VBRBOTD_i);
VBRinvsti_d = (1.0/VBRSTID_i);
VBRinvgat_d = (1.0/VBRGATD_i);
{
double value_pow_0 = pow(alphaav,(PBRBOTD_i-1.0));
slopebot_d = (((-((fstopbot_d*fstopbot_d)*value_pow_0))*PBRBOTD_i)*VBRinvbot_d);
}
{
double value_pow_0 = pow(alphaav,(PBRSTID_i-1.0));
slopesti_d = (((-((fstopsti_d*fstopsti_d)*value_pow_0))*PBRSTID_i)*VBRinvsti_d);
}
{
double value_pow_0 = pow(alphaav,(PBRGATD_i-1.0));
slopegat_d = (((-((fstopgat_d*fstopgat_d)*value_pow_0))*PBRGATD_i)*VBRinvgat_d);
}
}
// End block initial_model


  return true;
}
//----------------------------------------------------------------------------
// Function      : Model::processInstanceParams
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//----------------------------------------------------------------------------
bool Model::processInstanceParams()
{

  std::vector<Instance*>::iterator iter;
  std::vector<Instance*>::iterator first = instanceContainer.begin();
  std::vector<Instance*>::iterator last  = instanceContainer.end();

  for (iter=first; iter!=last; ++iter)
  {
    (*iter)->processParams();
  }

  return true;
}

//-----------------------------------------------------------------------------
// Function      : Model::Model
// Purpose       : model block constructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::Model(
  const Configuration & configuration,
  const ModelBlock &    model_block,
  const FactoryBlock &  factory_block)
  : DeviceModel(model_block, configuration.getModelParameters(), factory_block),
    LEVEL(103),
    TYPE(1),
    TR(21.0),
    SWGEO(1),
    SWIGATE(0),
    SWIMPACT(0),
    SWGIDL(0),
    SWJUNCAP(0),
    SWJUNASYM(0),
    SWNUD(0),
    SWEDGE(0),
    SWDELVTAC(0),
    SWIGN(1),
    QMC(1.0),
    VFB((-1.0)),
    STVFB(5.0e-4),
    TOX(2.0e-09),
    EPSROX(3.9),
    NEFF(5.0e23),
    FACNEFFAC(1.0),
    GFACNUD(1.0),
    VSBNUD(0.0),
    DVSBNUD(1.0),
    VNSUB(0.0),
    NSLP(0.05),
    DNSUB(0.0),
    DPHIB(0.0),
    DELVTAC(0.0),
    NP(1.0e26),
    CT(0.0),
    TOXOV(2.0e-09),
    TOXOVD(2.0e-09),
    NOV(5.0e25),
    NOVD(5.0e25),
    CF(0.0),
    CFD(0.0),
    CFB(0.0),
    PSCE(0.0),
    PSCEB(0.0),
    PSCED(0.0),
    BETN(7.0e-2),
    STBET(1.0),
    MUE(0.5),
    STMUE(0.0),
    THEMU(1.5),
    STTHEMU(1.5),
    CS(0.0),
    STCS(0.0),
    XCOR(0.0),
    STXCOR(0.0),
    FETA(1.0),
    RS(30.0),
    STRS(1.0),
    RSB(0.0),
    RSG(0.0),
    THESAT(1.0),
    STTHESAT(1.0),
    THESATB(0.0),
    THESATG(0.0),
    AX(3.0),
    ALP(0.01),
    ALP1(0.0),
    ALP2(0.0),
    VP(0.05),
    A1(1.0),
    A2(10.0),
    STA2(0.0),
    A3(1.0),
    A4(0.0),
    GCO(0.0),
    IGINV(0.0),
    IGOV(0.0),
    IGOVD(0.0),
    STIG(2.0),
    GC2(0.375),
    GC3(0.063),
    CHIB(3.1),
    AGIDL(0.0),
    AGIDLD(0.0),
    BGIDL(41.0),
    BGIDLD(41.0),
    STBGIDL(0.0),
    STBGIDLD(0.0),
    CGIDL(0.0),
    CGIDLD(0.0),
    COX(1.0e-14),
    CGOV(1.0e-15),
    CGOVD(1.0e-15),
    CGBOV(0.0),
    CFR(0.0),
    CFRD(0.0),
    FNT(1.0),
    FNTEXC(0.0),
    NFA(8.0e22),
    NFB(3.0e07),
    NFC(0.0),
    EF(1.0),
    VFBEDGE((-1.0)),
    STVFBEDGE(5.0e-4),
    DPHIBEDGE(0.0),
    NEFFEDGE(5.0e23),
    CTEDGE(0.0),
    BETNEDGE(5.0e-4),
    STBETEDGE(1.0),
    PSCEEDGE(0.0),
    PSCEBEDGE(0.0),
    PSCEDEDGE(0.0),
    CFEDGE(0.0),
    CFDEDGE(0.0),
    CFBEDGE(0.0),
    FNTEDGE(1.0),
    NFAEDGE(8.0e22),
    NFBEDGE(3.0e07),
    NFCEDGE(0.0),
    EFEDGE(1.0),
    RG(0.0),
    RSE(0.0),
    RDE(0.0),
    RBULK(0.0),
    RWELL(0.0),
    RJUNS(0.0),
    RJUND(0.0),
    POVFB((-1.0)),
    PLVFB(0.0),
    PWVFB(0.0),
    PLWVFB(0.0),
    POSTVFB(5.0e-4),
    PLSTVFB(0.0),
    PWSTVFB(0.0),
    PLWSTVFB(0.0),
    POTOX(2.0e-9),
    POEPSROX(3.9),
    PONEFF(5.0e23),
    PLNEFF(0.0),
    PWNEFF(0.0),
    PLWNEFF(0.0),
    POFACNEFFAC(1.0),
    PLFACNEFFAC(0.0),
    PWFACNEFFAC(0.0),
    PLWFACNEFFAC(0.0),
    POGFACNUD(1.0),
    PLGFACNUD(0.0),
    PWGFACNUD(0.0),
    PLWGFACNUD(0.0),
    POVSBNUD(0.0),
    PODVSBNUD(1.0),
    POVNSUB(0.0),
    PONSLP(0.05),
    PODNSUB(0.0),
    PODPHIB(0.0),
    PLDPHIB(0.0),
    PWDPHIB(0.0),
    PLWDPHIB(0.0),
    PODELVTAC(0.0),
    PLDELVTAC(0.0),
    PWDELVTAC(0.0),
    PLWDELVTAC(0.0),
    PONP(1.0e26),
    PLNP(0.0),
    PWNP(0.0),
    PLWNP(0.0),
    POCT(0.0),
    PLCT(0.0),
    PWCT(0.0),
    PLWCT(0.0),
    POTOXOV(2.0e-09),
    POTOXOVD(2.0e-09),
    PONOV(5.0e25),
    PLNOV(0.0),
    PWNOV(0.0),
    PLWNOV(0.0),
    PONOVD(5.0e25),
    PLNOVD(0.0),
    PWNOVD(0.0),
    PLWNOVD(0.0),
    POCF(0.0),
    PLCF(0.0),
    PWCF(0.0),
    PLWCF(0.0),
    POCFD(0.0),
    POCFB(0.0),
    POPSCE(0.0),
    PLPSCE(0.0),
    PWPSCE(0.0),
    PLWPSCE(0.0),
    POPSCEB(0.0),
    POPSCED(0.0),
    POBETN(7.0e-2),
    PLBETN(0.0),
    PWBETN(0.0),
    PLWBETN(0.0),
    POSTBET(1.0),
    PLSTBET(0.0),
    PWSTBET(0.0),
    PLWSTBET(0.0),
    POMUE(0.5),
    PLMUE(0.0),
    PWMUE(0.0),
    PLWMUE(0.0),
    POSTMUE(0.0),
    POTHEMU(1.5),
    POSTTHEMU(1.5),
    POCS(0.0),
    PLCS(0.0),
    PWCS(0.0),
    PLWCS(0.0),
    POSTCS(0.0),
    POXCOR(0.0),
    PLXCOR(0.0),
    PWXCOR(0.0),
    PLWXCOR(0.0),
    POSTXCOR(0.0),
    POFETA(1.0),
    PORS(30.0),
    PLRS(0.0),
    PWRS(0.0),
    PLWRS(0.0),
    POSTRS(1.0),
    PORSB(0.0),
    PORSG(0.0),
    POTHESAT(1.0),
    PLTHESAT(0.0),
    PWTHESAT(0.0),
    PLWTHESAT(0.0),
    POSTTHESAT(1.0),
    PLSTTHESAT(0.0),
    PWSTTHESAT(0.0),
    PLWSTTHESAT(0.0),
    POTHESATB(0.0),
    PLTHESATB(0.0),
    PWTHESATB(0.0),
    PLWTHESATB(0.0),
    POTHESATG(0.0),
    PLTHESATG(0.0),
    PWTHESATG(0.0),
    PLWTHESATG(0.0),
    POAX(3.0),
    PLAX(0.0),
    PWAX(0.0),
    PLWAX(0.0),
    POALP(1.0e-2),
    PLALP(0.0),
    PWALP(0.0),
    PLWALP(0.0),
    POALP1(0.0),
    PLALP1(0.0),
    PWALP1(0.0),
    PLWALP1(0.0),
    POALP2(0.0),
    PLALP2(0.0),
    PWALP2(0.0),
    PLWALP2(0.0),
    POVP(0.05),
    POA1(1.0),
    PLA1(0.0),
    PWA1(0.0),
    PLWA1(0.0),
    POA2(10.0),
    POSTA2(0.0),
    POA3(1.0),
    PLA3(0.0),
    PWA3(0.0),
    PLWA3(0.0),
    POA4(0.0),
    PLA4(0.0),
    PWA4(0.0),
    PLWA4(0.0),
    POGCO(0.0),
    POIGINV(0.0),
    PLIGINV(0.0),
    PWIGINV(0.0),
    PLWIGINV(0.0),
    POIGOV(0.0),
    PLIGOV(0.0),
    PWIGOV(0.0),
    PLWIGOV(0.0),
    POIGOVD(0.0),
    PLIGOVD(0.0),
    PWIGOVD(0.0),
    PLWIGOVD(0.0),
    POSTIG(2.0),
    POGC2(0.375),
    POGC3(0.063),
    POCHIB(3.1),
    POAGIDL(0.0),
    PLAGIDL(0.0),
    PWAGIDL(0.0),
    PLWAGIDL(0.0),
    POAGIDLD(0.0),
    PLAGIDLD(0.0),
    PWAGIDLD(0.0),
    PLWAGIDLD(0.0),
    POBGIDL(41.0),
    POBGIDLD(41.0),
    POSTBGIDL(0.0),
    POSTBGIDLD(0.0),
    POCGIDL(0.0),
    POCGIDLD(0.0),
    POCOX(1.0e-14),
    PLCOX(0.0),
    PWCOX(0.0),
    PLWCOX(0.0),
    POCGOV(1.0e-15),
    PLCGOV(0.0),
    PWCGOV(0.0),
    PLWCGOV(0.0),
    POCGOVD(1.0e-15),
    PLCGOVD(0.0),
    PWCGOVD(0.0),
    PLWCGOVD(0.0),
    POCGBOV(0.0),
    PLCGBOV(0.0),
    PWCGBOV(0.0),
    PLWCGBOV(0.0),
    POCFR(0.0),
    PLCFR(0.0),
    PWCFR(0.0),
    PLWCFR(0.0),
    POCFRD(0.0),
    PLCFRD(0.0),
    PWCFRD(0.0),
    PLWCFRD(0.0),
    POFNT(1.0),
    POFNTEXC(0.0),
    PLFNTEXC(0.0),
    PWFNTEXC(0.0),
    PLWFNTEXC(0.0),
    PONFA(8.0e22),
    PLNFA(0.0),
    PWNFA(0.0),
    PLWNFA(0.0),
    PONFB(3.0e7),
    PLNFB(0.0),
    PWNFB(0.0),
    PLWNFB(0.0),
    PONFC(0.0),
    PLNFC(0.0),
    PWNFC(0.0),
    PLWNFC(0.0),
    POEF(1.0),
    POVFBEDGE((-1.0)),
    POSTVFBEDGE(0.0),
    PLSTVFBEDGE(0.0),
    PWSTVFBEDGE(0.0),
    PLWSTVFBEDGE(0.0),
    PODPHIBEDGE(0.0),
    PLDPHIBEDGE(0.0),
    PWDPHIBEDGE(0.0),
    PLWDPHIBEDGE(0.0),
    PONEFFEDGE(5.0e23),
    PLNEFFEDGE(0.0),
    PWNEFFEDGE(0.0),
    PLWNEFFEDGE(0.0),
    POCTEDGE(0.0),
    PLCTEDGE(0.0),
    PWCTEDGE(0.0),
    PLWCTEDGE(0.0),
    POBETNEDGE(5.0e-4),
    PLBETNEDGE(0.0),
    PWBETNEDGE(0.0),
    PLWBETNEDGE(0.0),
    POSTBETEDGE(1.0),
    PLSTBETEDGE(0.0),
    PWSTBETEDGE(0.0),
    PLWSTBETEDGE(0.0),
    POPSCEEDGE(0.0),
    PLPSCEEDGE(0.0),
    PWPSCEEDGE(0.0),
    PLWPSCEEDGE(0.0),
    POPSCEBEDGE(0.0),
    POPSCEDEDGE(0.0),
    POCFEDGE(0.0),
    PLCFEDGE(0.0),
    PWCFEDGE(0.0),
    PLWCFEDGE(0.0),
    POCFDEDGE(0.0),
    POCFBEDGE(0.0),
    POFNTEDGE(1.0),
    PONFAEDGE(8.0e22),
    PLNFAEDGE(0.0),
    PWNFAEDGE(0.0),
    PLWNFAEDGE(0.0),
    PONFBEDGE(3.0e7),
    PLNFBEDGE(0.0),
    PWNFBEDGE(0.0),
    PLWNFBEDGE(0.0),
    PONFCEDGE(0.0),
    PLNFCEDGE(0.0),
    PWNFCEDGE(0.0),
    PLWNFCEDGE(0.0),
    POEFEDGE(1.0),
    POKVTHOWE(0.0),
    PLKVTHOWE(0.0),
    PWKVTHOWE(0.0),
    PLWKVTHOWE(0.0),
    POKUOWE(0.0),
    PLKUOWE(0.0),
    PWKUOWE(0.0),
    PLWKUOWE(0.0),
    LMIN(0),
    LMAX(1.0),
    WMIN(0.0),
    WMAX(1.0),
    LVARO(0.0),
    LVARL(0.0),
    LVARW(0.0),
    LAP(0.0),
    WVARO(0.0),
    WVARL(0.0),
    WVARW(0.0),
    WOT(0.0),
    DLQ(0.0),
    DWQ(0.0),
    VFBO((-1.0)),
    VFBL(0.0),
    VFBW(0.0),
    VFBLW(0.0),
    STVFBO(5.0e-4),
    STVFBL(0.0),
    STVFBW(0.0),
    STVFBLW(0.0),
    TOXO(2.0e-9),
    EPSROXO(3.9),
    NSUBO(3.0e23),
    NSUBW(0.0),
    WSEG(1.0e-8),
    NPCK(1.0e24),
    NPCKW(0.0),
    WSEGP(1.0e-8),
    LPCK(1.0e-8),
    LPCKW(0.0),
    FOL1(0.0),
    FOL2(0.0),
    FACNEFFACO(1.0),
    FACNEFFACL(0.0),
    FACNEFFACW(0.0),
    FACNEFFACLW(0.0),
    GFACNUDO(1.0),
    GFACNUDL(0.0),
    GFACNUDLEXP(1.0),
    GFACNUDW(0.0),
    GFACNUDLW(0.0),
    VSBNUDO(0.0),
    DVSBNUDO(1.0),
    VNSUBO(0.0),
    NSLPO(0.05),
    DNSUBO(0.0),
    DPHIBO(0.0),
    DPHIBL(0.0),
    DPHIBLEXP(1.0),
    DPHIBW(0.0),
    DPHIBLW(0.0),
    DELVTACO(0.0),
    DELVTACL(0.0),
    DELVTACLEXP(1.0),
    DELVTACW(0.0),
    DELVTACLW(0.0),
    NPO(1.0e26),
    NPL(0.0),
    CTO(0.0),
    CTL(0.0),
    CTLEXP(1.0),
    CTW(0.0),
    CTLW(0.0),
    TOXOVO(2.0e-9),
    TOXOVDO(2.0e-9),
    LOV(0.0),
    LOVD(0.0),
    NOVO(5e25),
    NOVDO(5e25),
    CFL(0.0),
    CFLEXP(2.0),
    CFW(0.0),
    CFDO(0.0),
    CFBO(0.0),
    PSCEL(0.0),
    PSCELEXP(2.0),
    PSCEW(0.0),
    PSCEBO(0.0),
    PSCEDO(0.0),
    UO(5.0e-2),
    FBET1(0.0),
    FBET1W(0.0),
    LP1(1.0e-8),
    LP1W(0.0),
    FBET2(0.0),
    LP2(1.0e-8),
    BETW1(0.0),
    BETW2(0.0),
    WBET(1.0e-9),
    STBETO(1.0),
    STBETL(0.0),
    STBETW(0.0),
    STBETLW(0.0),
    MUEO(0.5),
    MUEW(0.0),
    STMUEO(0.0),
    THEMUO(1.5),
    STTHEMUO(1.5),
    CSO(0.0),
    CSL(0.0),
    CSLEXP(1.0),
    CSW(0.0),
    CSLW(0.0),
    STCSO(0.0),
    XCORO(0.0),
    XCORL(0.0),
    XCORW(0.0),
    XCORLW(0.0),
    STXCORO(0.0),
    FETAO(1.0),
    RSW1(50.0),
    RSW2(0.0),
    STRSO(1.0),
    RSBO(0.0),
    RSGO(0.0),
    THESATO(0.0),
    THESATL(0.05),
    THESATLEXP(1.0),
    THESATW(0.0),
    THESATLW(0.0),
    STTHESATO(1.0),
    STTHESATL(0.0),
    STTHESATW(0.0),
    STTHESATLW(0.0),
    THESATBO(0.0),
    THESATGO(0.0),
    AXO(18.0),
    AXL(0.4),
    ALPL(5.0e-4),
    ALPLEXP(1.0),
    ALPW(0.0),
    ALP1L1(0.0),
    ALP1LEXP(0.5),
    ALP1L2(0.0),
    ALP1W(0.0),
    ALP2L1(0.0),
    ALP2LEXP(0.5),
    ALP2L2(0.0),
    ALP2W(0.0),
    VPO(0.05),
    A1O(1.0),
    A1L(0.0),
    A1W(0.0),
    A2O(10.0),
    STA2O(0.0),
    A3O(1.0),
    A3L(0.0),
    A3W(0.0),
    A4O(0.0),
    A4L(0.0),
    A4W(0.0),
    GCOO(0.0),
    IGINVLW(0.0),
    IGOVW(0.0),
    IGOVDW(0.0),
    STIGO(2.0),
    GC2O(0.375),
    GC3O(0.063),
    CHIBO(3.1),
    AGIDLW(0.0),
    AGIDLDW(0.0),
    BGIDLO(41.0),
    BGIDLDO(41.0),
    STBGIDLO(0.0),
    STBGIDLDO(0.0),
    CGIDLO(0.0),
    CGIDLDO(0.0),
    CGBOVL(0.0),
    CFRW(0.0),
    CFRDW(0.0),
    FNTO(1.0),
    FNTEXCL(0.0),
    NFALW(8.0e22),
    NFBLW(3.0e7),
    NFCLW(0.0),
    EFO(1.0),
    LINTNOI(0.0),
    ALPNOI(2.0),
    WEDGE(1.0e-8),
    WEDGEW(0.0),
    VFBEDGEO((-1.0)),
    STVFBEDGEO(5.0e-4),
    STVFBEDGEL(0.0),
    STVFBEDGEW(0.0),
    STVFBEDGELW(0.0),
    DPHIBEDGEO(0.0),
    DPHIBEDGEL(0.0),
    DPHIBEDGELEXP(1.0),
    DPHIBEDGEW(0.0),
    DPHIBEDGELW(0.0),
    NSUBEDGEO(5.0e23),
    NSUBEDGEL(0.0),
    NSUBEDGEW(0.0),
    NSUBEDGELW(0.0),
    CTEDGEO(0.0),
    CTEDGEL(0.0),
    CTEDGELEXP(1.0),
    FBETEDGE(0.0),
    LPEDGE(1.0e-8),
    BETEDGEW(0.0),
    STBETEDGEO(1.0),
    STBETEDGEL(0.0),
    STBETEDGEW(0.0),
    STBETEDGELW(0.0),
    PSCEEDGEL(0.0),
    PSCEEDGELEXP(2.0),
    PSCEEDGEW(0.0),
    PSCEBEDGEO(0.0),
    PSCEDEDGEO(0.0),
    CFEDGEL(0.0),
    CFEDGELEXP(2.0),
    CFEDGEW(0.0),
    CFDEDGEO(0.0),
    CFBEDGEO(0.0),
    FNTEDGEO(1.0),
    NFAEDGELW(8.0e22),
    NFBEDGELW(3.0e7),
    NFCEDGELW(0.0),
    EFEDGEO(1.0),
    KVTHOWEO(0.0),
    KVTHOWEL(0.0),
    KVTHOWEW(0.0),
    KVTHOWELW(0.0),
    KUOWEO(0.0),
    KUOWEL(0.0),
    KUOWEW(0.0),
    KUOWELW(0.0),
    RGO(0.0),
    RINT(0.0),
    RVPOLY(0.0),
    RSHG(0.0),
    DLSIL(0.0),
    RSH(0.0),
    RSHD(0.0),
    RBULKO(0.0),
    RWELLO(0.0),
    RJUNSO(0.0),
    RJUNDO(0.0),
    SAREF(1.0e-6),
    SBREF(1.0e-6),
    WLOD(0.0),
    KUO(0.0),
    KVSAT(0.0),
    TKUO(0.0),
    LKUO(0.0),
    WKUO(0.0),
    PKUO(0.0),
    LLODKUO(0.0),
    WLODKUO(0.0),
    KVTHO(0.0),
    LKVTHO(0.0),
    WKVTHO(0.0),
    PKVTHO(0.0),
    LLODVTH(0.0),
    WLODVTH(0.0),
    STETAO(0.0),
    LODETAO(1.0),
    SCREF(1.0e-6),
    WEB(0.0),
    WEC(0.0),
    IMAX(1000.0),
    TRJ(21.0),
    FREV(1.0e3),
    CJORBOT(1.0e-3),
    CJORSTI(1.0e-9),
    CJORGAT(1.0e-9),
    VBIRBOT(1.0),
    VBIRSTI(1.0),
    VBIRGAT(1.0),
    PBOT(0.5),
    PSTI(0.5),
    PGAT(0.5),
    PHIGBOT(1.16),
    PHIGSTI(1.16),
    PHIGGAT(1.16),
    IDSATRBOT(1.0e-12),
    IDSATRSTI(1.0e-18),
    IDSATRGAT(1.0e-18),
    CSRHBOT(1.0e2),
    CSRHSTI(1.0e-4),
    CSRHGAT(1.0e-4),
    XJUNSTI(1.0e-7),
    XJUNGAT(1.0e-7),
    CTATBOT(1.0e2),
    CTATSTI(1.0e-4),
    CTATGAT(1.0e-4),
    MEFFTATBOT(0.25),
    MEFFTATSTI(0.25),
    MEFFTATGAT(0.25),
    CBBTBOT(1.0e-12),
    CBBTSTI(1.0e-18),
    CBBTGAT(1.0e-18),
    FBBTRBOT(1.0e9),
    FBBTRSTI(1.0e9),
    FBBTRGAT(1.0e9),
    STFBBTBOT((-1.0e-3)),
    STFBBTSTI((-1.0e-3)),
    STFBBTGAT((-1.0e-3)),
    VBRBOT(10.0),
    VBRSTI(10.0),
    VBRGAT(10.0),
    PBRBOT(4.0),
    PBRSTI(4.0),
    PBRGAT(4.0),
    CJORBOTD(1.0e-3),
    CJORSTID(1.0e-9),
    CJORGATD(1.0e-9),
    VBIRBOTD(1.0),
    VBIRSTID(1.0),
    VBIRGATD(1.0),
    PBOTD(0.5),
    PSTID(0.5),
    PGATD(0.5),
    PHIGBOTD(1.16),
    PHIGSTID(1.16),
    PHIGGATD(1.16),
    IDSATRBOTD(1.0e-12),
    IDSATRSTID(1.0e-18),
    IDSATRGATD(1.0e-18),
    CSRHBOTD(1.0e2),
    CSRHSTID(1.0e-4),
    CSRHGATD(1.0e-4),
    XJUNSTID(1.0e-7),
    XJUNGATD(1.0e-7),
    CTATBOTD(1.0e2),
    CTATSTID(1.0e-4),
    CTATGATD(1.0e-4),
    MEFFTATBOTD(0.25),
    MEFFTATSTID(0.25),
    MEFFTATGATD(0.25),
    CBBTBOTD(1.0e-12),
    CBBTSTID(1.0e-18),
    CBBTGATD(1.0e-18),
    FBBTRBOTD(1.0e9),
    FBBTRSTID(1.0e9),
    FBBTRGATD(1.0e9),
    STFBBTBOTD((-1.0e-3)),
    STFBBTSTID((-1.0e-3)),
    STFBBTGATD((-1.0e-3)),
    VBRBOTD(10.0),
    VBRSTID(10.0),
    VBRGATD(10.0),
    PBRBOTD(4.0),
    PBRSTID(4.0),
    PBRGATD(4.0),
    SWJUNEXP(0.0),
    VJUNREF(2.5),
    FJUNQ(0.03),
    VJUNREFD(2.5),
    FJUNQD(0.03),
    DTA(0.0),
    CHNL_TYPE(0),
    SWGEO_i(0),
    SWIGATE_i(0),
    SWIMPACT_i(0),
    SWGIDL_i(0),
    SWJUNCAP_i(0),
    SWJUNASYM_i(0),
    SWNUD_i(0),
    SWEDGE_i(0),
    SWDELVTAC_i(0),
    SWIGN_i(0),
    TOXO_i(0.0),
    EPSROXO_i(0.0),
    NSUBO_i(0.0),
    WSEG_i(0.0),
    NPCK_i(0.0),
    WSEGP_i(0.0),
    LPCK_i(0.0),
    TOXOVO_i(0.0),
    TOXOVDO_i(0.0),
    LOV_i(0.0),
    LOVD_i(0.0),
    LP1_i(0.0),
    LP2_i(0.0),
    WBET_i(0.0),
    AXL_i(0.0),
    ALP1L2_i(0.0),
    ALP2L2_i(0.0),
    SAREF_i(0.0),
    SBREF_i(0.0),
    KVSAT_i(0.0),
    LLODKUO_i(0.0),
    WLODKUO_i(0.0),
    LLODVTH_i(0.0),
    WLODVTH_i(0.0),
    LODETAO_i(0.0),
    SCREF_i(0.0),
    WEB_i(0.0),
    WEC_i(0.0),
    RSHG_i(0.0),
    RSH_i(0.0),
    RSHD_i(0.0),
    RINT_i(0.0),
    RVPOLY_i(0.0),
    NSUBEDGEO_i(0.0),
    LPEDGE_i(0.0),
    QMC_i(0.0),
    rTa(0.0),
    delTa(0.0),
    phita(0.0),
    inv_phita(0.0),
    TKD(0.0),
    delT(0.0),
    rTn(0.0),
    ln_rTn(0.0),
    inv_phit(0.0),
    Eg(0.0),
    phibFac(0.0),
    IMAX_i(0.0),
    VBIRBOT_i(0.0),
    VBIRSTI_i(0.0),
    VBIRGAT_i(0.0),
    PBOT_i(0.0),
    PSTI_i(0.0),
    PGAT_i(0.0),
    CSRHBOT_i(0.0),
    CSRHSTI_i(0.0),
    CSRHGAT_i(0.0),
    CTATBOT_i(0.0),
    CTATSTI_i(0.0),
    CTATGAT_i(0.0),
    CBBTBOT_i(0.0),
    CBBTSTI_i(0.0),
    CBBTGAT_i(0.0),
    VBRBOT_i(0.0),
    VBRSTI_i(0.0),
    VBRGAT_i(0.0),
    PBRBOT_i(0.0),
    PBRSTI_i(0.0),
    PBRGAT_i(0.0),
    SWJUNEXP_i(0.0),
    VJUNREF_i(0.0),
    FJUNQ_i(0.0),
    phitr(0.0),
    phitd(0.0),
    phitdinv(0.0),
    perfc(0.0),
    berfc(0.0),
    cerfc(0.0),
    ftdbot(0.0),
    ftdsti(0.0),
    ftdgat(0.0),
    idsatbot(0.0),
    idsatsti(0.0),
    idsatgat(0.0),
    vbibot(0.0),
    vbisti(0.0),
    vbigat(0.0),
    vbiinvbot(0.0),
    vbiinvsti(0.0),
    vbiinvgat(0.0),
    one_minus_PBOT(0.0),
    one_minus_PSTI(0.0),
    one_minus_PGAT(0.0),
    one_over_one_minus_PBOT(0.0),
    one_over_one_minus_PSTI(0.0),
    one_over_one_minus_PGAT(0.0),
    cjobot(0.0),
    cjosti(0.0),
    cjogat(0.0),
    qprefbot(0.0),
    qprefsti(0.0),
    qprefgat(0.0),
    qpref2bot(0.0),
    qpref2sti(0.0),
    qpref2gat(0.0),
    wdepnulrbot(0.0),
    wdepnulrsti(0.0),
    wdepnulrgat(0.0),
    wdepnulrinvbot(0.0),
    wdepnulrinvsti(0.0),
    wdepnulrinvgat(0.0),
    VBIRBOTinv(0.0),
    VBIRSTIinv(0.0),
    VBIRGATinv(0.0),
    atatbot(0.0),
    atatsti(0.0),
    atatgat(0.0),
    btatpartbot(0.0),
    btatpartsti(0.0),
    btatpartgat(0.0),
    fbbtbot(0.0),
    fbbtsti(0.0),
    fbbtgat(0.0),
    alphaav(0.0),
    fstopbot(0.0),
    fstopsti(0.0),
    fstopgat(0.0),
    VBRinvbot(0.0),
    VBRinvsti(0.0),
    VBRinvgat(0.0),
    slopebot(0.0),
    slopesti(0.0),
    slopegat(0.0),
    VBIRBOTD_i(0.0),
    VBIRSTID_i(0.0),
    VBIRGATD_i(0.0),
    PBOTD_i(0.0),
    PSTID_i(0.0),
    PGATD_i(0.0),
    CSRHBOTD_i(0.0),
    CSRHSTID_i(0.0),
    CSRHGATD_i(0.0),
    CTATBOTD_i(0.0),
    CTATSTID_i(0.0),
    CTATGATD_i(0.0),
    CBBTBOTD_i(0.0),
    CBBTSTID_i(0.0),
    CBBTGATD_i(0.0),
    VBRBOTD_i(0.0),
    VBRSTID_i(0.0),
    VBRGATD_i(0.0),
    PBRBOTD_i(0.0),
    PBRSTID_i(0.0),
    PBRGATD_i(0.0),
    VJUNREFD_i(0.0),
    FJUNQD_i(0.0),
    ftdbot_d(0.0),
    ftdsti_d(0.0),
    ftdgat_d(0.0),
    idsatbot_d(0.0),
    idsatsti_d(0.0),
    idsatgat_d(0.0),
    vbibot_d(0.0),
    vbisti_d(0.0),
    vbigat_d(0.0),
    vbiinvbot_d(0.0),
    vbiinvsti_d(0.0),
    vbiinvgat_d(0.0),
    one_minus_PBOT_d(0.0),
    one_minus_PSTI_d(0.0),
    one_minus_PGAT_d(0.0),
    one_over_one_minus_PBOT_d(0.0),
    one_over_one_minus_PSTI_d(0.0),
    one_over_one_minus_PGAT_d(0.0),
    cjobot_d(0.0),
    cjosti_d(0.0),
    cjogat_d(0.0),
    qprefbot_d(0.0),
    qprefsti_d(0.0),
    qprefgat_d(0.0),
    qpref2bot_d(0.0),
    qpref2sti_d(0.0),
    qpref2gat_d(0.0),
    wdepnulrbot_d(0.0),
    wdepnulrsti_d(0.0),
    wdepnulrgat_d(0.0),
    wdepnulrinvbot_d(0.0),
    wdepnulrinvsti_d(0.0),
    wdepnulrinvgat_d(0.0),
    VBIRBOTinv_d(0.0),
    VBIRSTIinv_d(0.0),
    VBIRGATinv_d(0.0),
    atatbot_d(0.0),
    atatsti_d(0.0),
    atatgat_d(0.0),
    btatpartbot_d(0.0),
    btatpartsti_d(0.0),
    btatpartgat_d(0.0),
    fbbtbot_d(0.0),
    fbbtsti_d(0.0),
    fbbtgat_d(0.0),
    fstopbot_d(0.0),
    fstopsti_d(0.0),
    fstopgat_d(0.0),
    VBRinvbot_d(0.0),
    VBRinvsti_d(0.0),
    VBRinvgat_d(0.0),
    slopebot_d(0.0),
    slopesti_d(0.0),
    slopegat_d(0.0),
    phit(0.0),
    nt0(0.0),
    EPSSI(0.0)
{
  // Set params to constant default values (from parTable):
  setDefaultParams();

  // Set params according to .model line and constant defaults from metadata:
  setModParams(model_block.params);

  if (!given("XYCEADMSMODTEMP"))
    admsModTemp=getDeviceOptions().temp.getImmutableValue<double>();

  // Calculate any parameters specified as expressions:

  updateDependentParameters();

  // calculate dependent (ie computed) params and check for errors:
  processParams();
}

//-----------------------------------------------------------------------------
// Function      : Model::~Model
// Purpose       : destructor
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
Model::~Model()
{
  std::vector<Instance*>::iterator iterI;
  std::vector<Instance*>::iterator firstI = instanceContainer.begin ();
  std::vector<Instance*>::iterator lastI  = instanceContainer.end ();

  // loop over instances:
  for (iterI = firstI; iterI != lastI; ++iterI)
  {
    delete (*iterI);
  }
}

//-----------------------------------------------------------------------------
// Function      : Model::printOutInstances
// Purpose       : debugging tool.
// Special Notes :
// Scope         : public
// Creator       :
// Creation Date :
//-----------------------------------------------------------------------------
std::ostream &Model::printOutInstances(std::ostream &os) const
{
  std::vector<Instance*>::const_iterator iter;
  std::vector<Instance*>::const_iterator first = instanceContainer.begin();
  std::vector<Instance*>::const_iterator last  = instanceContainer.end();

  int i;
  os << std::endl;
  os << "    name     model name  Parameters" << std::endl;
  for (i=0, iter=first; iter!=last; ++iter, ++i)
  {
    os << "  " << i << ": " << (*iter)->getName() << "      ";
    os << getName();

    os << std::endl;
      os << "L  =  " << (*iter)->L << std::endl;
      os << "W  =  " << (*iter)->W << std::endl;
      os << "SA  =  " << (*iter)->SA << std::endl;
      os << "SB  =  " << (*iter)->SB << std::endl;
      os << "SD  =  " << (*iter)->SD << std::endl;
      os << "SCA  =  " << (*iter)->SCA << std::endl;
      os << "SCB  =  " << (*iter)->SCB << std::endl;
      os << "SCC  =  " << (*iter)->SCC << std::endl;
      os << "SC  =  " << (*iter)->SC << std::endl;
      os << "NF  =  " << (*iter)->NF << std::endl;
      os << "NGCON  =  " << (*iter)->NGCON << std::endl;
      os << "XGW  =  " << (*iter)->XGW << std::endl;
      os << "NRS  =  " << (*iter)->NRS << std::endl;
      os << "NRD  =  " << (*iter)->NRD << std::endl;
      os << "JW  =  " << (*iter)->JW << std::endl;
      os << "DELVTO  =  " << (*iter)->DELVTO << std::endl;
      os << "FACTUO  =  " << (*iter)->FACTUO << std::endl;
      os << "DELVTOEDGE  =  " << (*iter)->DELVTOEDGE << std::endl;
      os << "FACTUOEDGE  =  " << (*iter)->FACTUOEDGE << std::endl;
      os << "ABSOURCE  =  " << (*iter)->ABSOURCE << std::endl;
      os << "LSSOURCE  =  " << (*iter)->LSSOURCE << std::endl;
      os << "LGSOURCE  =  " << (*iter)->LGSOURCE << std::endl;
      os << "ABDRAIN  =  " << (*iter)->ABDRAIN << std::endl;
      os << "LSDRAIN  =  " << (*iter)->LSDRAIN << std::endl;
      os << "LGDRAIN  =  " << (*iter)->LGDRAIN << std::endl;
      os << "AS  =  " << (*iter)->AS << std::endl;
      os << "PS  =  " << (*iter)->PS << std::endl;
      os << "AD  =  " << (*iter)->AD << std::endl;
      os << "PD  =  " << (*iter)->PD << std::endl;
      os << "MULT  =  " << (*iter)->MULT << std::endl;
    os << std::endl;
  }

  os << std::endl;

  return os;
}

//-----------------------------------------------------------------------------
// Function      : Model::forEachInstance
// Purpose       :
// Special Notes :
// Scope         : public
// Creator       : David Baur
// Creation Date : 2/4/2014
//-----------------------------------------------------------------------------
/// Apply a device instance "op" to all instances associated with this
/// model
///
/// @param[in] op Operator to apply to all instances.
///
///
void Model::forEachInstance(DeviceInstanceOp &op) const
{
  for (std::vector<Instance *>::const_iterator it = instanceContainer.begin(); it != instanceContainer.end(); ++it)
    op(*it);
}

Device *Traits::factory(const Configuration &configuration, const FactoryBlock &factory_block)
{
  return new DeviceMaster<Traits>(configuration, factory_block, factory_block.solverState_, factory_block.deviceOptions_);
}

void
registerDevice(const DeviceCountMap& deviceMap, const std::set<int>& levelSet)
{
if (deviceMap.empty() ||
((deviceMap.find("M") != deviceMap.end() && (levelSet.find(103)!=levelSet.end()))))
{
MOSFET1::registerDevice();
  Config<Traits>::addConfiguration()
    .registerDevice("m", 103)
    .registerModelType("nmos", 103)
    .registerModelType("pmos", 103);
}
}


#ifdef Xyce_ADMS_SENSITIVITIES
//-----------------------------------------------------------------------------
// Function      : evaluateInitialInstance
// Purpose       : Evaluate the statements in the initial_instance block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialInstance(
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, const Instance & theInstance)
{
  double I5=0.0;
double d_I5_dX=0.0;
  double I4=0.0;
double d_I4_dX=0.0;
  double I3=0.0;
double d_I3_dX=0.0;
  double I2=0.0;
double d_I2_dX=0.0;
  double I1=0.0;
double d_I1_dX=0.0;
  double V5=0.0;
  double V4=0.0;
  double V3=0.0;
double d_V3_dX=0.0;
  double V2=0.0;
double d_V2_dX=0.0;
  double V1=0.0;
double d_V1_dX=0.0;
  double FRACI=0.0;
  double FRACNB=0.0;
  double FRACNA=0.0;
  double pmax=0.0;
double d_pmax_dX=0.0;
  double vbigat2r=0.0;
double d_vbigat2r_dX=0.0;
  double vbisti2r=0.0;
double d_vbisti2r_dX=0.0;
  double vbibot2r=0.0;
double d_vbibot2r_dX=0.0;
  double pgat2=0.0;
double d_pgat2_dX=0.0;
  double psti2=0.0;
double d_psti2_dX=0.0;
  double pbot2=0.0;
double d_pbot2_dX=0.0;
  double vbigat2=0.0;
double d_vbigat2_dX=0.0;
  double vbisti2=0.0;
double d_vbisti2_dX=0.0;
  double vbibot2=0.0;
double d_vbibot2_dX=0.0;
  double vmaxgat=0.0;
double d_vmaxgat_dX=0.0;
  double vmaxsti=0.0;
double d_vmaxsti_dX=0.0;
  double vmaxbot=0.0;
double d_vmaxbot_dX=0.0;
  double alphaje=0.0;
double d_alphaje_dX=0.0;
  double zfrac=0.0;
double d_zfrac_dX=0.0;
  double tt2=0.0;
double d_tt2_dX=0.0;
  double tt1=0.0;
double d_tt1_dX=0.0;
  double tt0=0.0;
double d_tt0_dX=0.0;
  double I5_cor=0.0;
double d_I5_cor_dX=0.0;
  double I4_cor=0.0;
double d_I4_cor_dX=0.0;
  double I3_cor=0.0;
double d_I3_cor_dX=0.0;
  double I2_cor=0.0;
double d_I2_cor_dX=0.0;
  double I1_cor=0.0;
double d_I1_cor_dX=0.0;
  double mcor_rev=0.0;
double d_mcor_rev_dX=0.0;
  double m0_rev=0.0;
double d_m0_rev_dX=0.0;
  double jww=0.0;
double d_jww_dX=0.0;
  double jwcorr=0.0;
  double LGD_i=0.0;
double d_LGD_i_dX=0.0;
  double LSD_i=0.0;
double d_LSD_i_dX=0.0;
  double ABD_i=0.0;
double d_ABD_i_dX=0.0;
  double LGS_i=0.0;
double d_LGS_i_dX=0.0;
  double LSS_i=0.0;
double d_LSS_i_dX=0.0;
  double ABS_i=0.0;
double d_ABS_i_dX=0.0;
  double tf_ig=0.0;
double d_tf_ig_dX=0.0;
  double B_fact=0.0;
double d_B_fact_dX=0.0;
  double phix2edge=0.0;
double d_phix2edge_dX=0.0;
  double tf_betedge=0.0;
double d_tf_betedge_dX=0.0;
  double tf_thesat=0.0;
double d_tf_thesat_dX=0.0;
  double tf_ther=0.0;
double d_tf_ther_dX=0.0;
  double tf_xcor=0.0;
double d_tf_xcor_dX=0.0;
  double tf_cs=0.0;
double d_tf_cs_dX=0.0;
  double tf_mue=0.0;
double d_tf_mue_dX=0.0;
  double tf_bet=0.0;
double d_tf_bet_dX=0.0;
  double phix2=0.0;
double d_phix2_dX=0.0;
  double dphibq=0.0;
double d_dphibq_dX=0.0;
  double qb0=0.0;
double d_qb0_dX=0.0;
  double arg2max=0.0;
double d_arg2max_dX=0.0;
  double np=0.0;
double d_np_dX=0.0;
  double SP_OV_delta=0.0;
double d_SP_OV_delta_dX=0.0;
  double SP_OV_eps=0.0;
double d_SP_OV_eps_dX=0.0;
  double inv_GOV=0.0;
double d_inv_GOV_dX=0.0;
  double CoxovPrime_d=0.0;
double d_CoxovPrime_d_dX=0.0;
  double CoxovPrime=0.0;
double d_CoxovPrime_dX=0.0;
  double NEFFAC_i=0.0;
double d_NEFFAC_i_dX=0.0;
  double tox_sq=0.0;
double d_tox_sq_dX=0.0;
  double CoxPrime=0.0;
double d_CoxPrime_dX=0.0;
  double EPSOX=0.0;
double d_EPSOX_dX=0.0;
  double DELVTOEDGE_i=0.0;
double d_DELVTOEDGE_i_dX=0.0;
  double FACTUOEDGE_i=0.0;
double d_FACTUOEDGE_i_dX=0.0;
  double DELVTO_i=0.0;
double d_DELVTO_i_dX=0.0;
  double FACTUO_i=0.0;
double d_FACTUO_i_dX=0.0;
  double VFBEDGE_i=0.0;
double d_VFBEDGE_i_dX=0.0;
  double BGIDLD_i=0.0;
double d_BGIDLD_i_dX=0.0;
  double BGIDL_i=0.0;
double d_BGIDL_i_dX=0.0;
  double A2_i=0.0;
double d_A2_i_dX=0.0;
  double THESAT_i=0.0;
double d_THESAT_i_dX=0.0;
  double RS_i=0.0;
double d_RS_i_dX=0.0;
  double XCOR_i=0.0;
double d_XCOR_i_dX=0.0;
  double CS_i=0.0;
double d_CS_i_dX=0.0;
  double THEMU_i=0.0;
double d_THEMU_i_dX=0.0;
  double MUE_i=0.0;
double d_MUE_i_dX=0.0;
  double BETN_i=0.0;
double d_BETN_i_dX=0.0;
  double VFB_i=0.0;
double d_VFB_i_dX=0.0;
  double temp00=0.0;
double d_temp00_dX=0.0;
  double Kstressvth0=0.0;
double d_Kstressvth0_dX=0.0;
  double rhobetaref=0.0;
double d_rhobetaref_dX=0.0;
  double rhobeta=0.0;
double d_rhobeta_dX=0.0;
  double Kstressu0=0.0;
double d_Kstressu0_dX=0.0;
  double tempw=0.0;
double d_tempw_dX=0.0;
  double templ=0.0;
double d_templ_dX=0.0;
  double Wx=0.0;
double d_Wx_dX=0.0;
  double Lx=0.0;
double d_Lx_dX=0.0;
  double Invsbref=0.0;
double d_Invsbref_dX=0.0;
  double Invsaref=0.0;
double d_Invsaref_dX=0.0;
  double Invsb=0.0;
double d_Invsb_dX=0.0;
  double Invsa=0.0;
double d_Invsa_dX=0.0;
  double loop=0.0;
  double tmpb=0.0;
double d_tmpb_dX=0.0;
  double tmpa=0.0;
double d_tmpa_dX=0.0;
  double iiiLWcv=0.0;
double d_iiiLWcv_dX=0.0;
  double iLcv=0.0;
double d_iLcv_dX=0.0;
  double iiLWcv=0.0;
double d_iiLWcv_dX=0.0;
  double iiWcv=0.0;
double d_iiWcv_dX=0.0;
  double iiLcv=0.0;
double d_iiLcv_dX=0.0;
  double iiiLEWEcv=0.0;
double d_iiiLEWEcv_dX=0.0;
  double iLEcv=0.0;
double d_iLEcv_dX=0.0;
  double iiLEWEcv=0.0;
double d_iiLEWEcv_dX=0.0;
  double iiWEcv=0.0;
double d_iiWEcv_dX=0.0;
  double iiLEcv=0.0;
double d_iiLEcv_dX=0.0;
  double iiiLEWE=0.0;
double d_iiiLEWE_dX=0.0;
  double iiLEWE=0.0;
double d_iiLEWE_dX=0.0;
  double iiWE=0.0;
double d_iiWE_dX=0.0;
  double iiLE=0.0;
double d_iiLE_dX=0.0;
  double iLEWE=0.0;
double d_iLEWE_dX=0.0;
  double KUOWE=0.0;
double d_KUOWE_dX=0.0;
  double KVTHOWE=0.0;
double d_KVTHOWE_dX=0.0;
  double GPE_edge=0.0;
double d_GPE_edge_dX=0.0;
  double iWE_edge=0.0;
double d_iWE_edge_dX=0.0;
  double WE_edge=0.0;
double d_WE_edge_dX=0.0;
  double Lred=0.0;
double d_Lred_dX=0.0;
  double Lnoi=0.0;
double d_Lnoi_dX=0.0;
  double temp0=0.0;
double d_temp0_dX=0.0;
  double tmpx=0.0;
double d_tmpx_dX=0.0;
  double GWE=0.0;
double d_GWE_dX=0.0;
  double GPE=0.0;
double d_GPE_dX=0.0;
  double LP1e=0.0;
double d_LP1e_dX=0.0;
  double FBET1e=0.0;
double d_FBET1e_dX=0.0;
  double NSUB=0.0;
double d_NSUB_dX=0.0;
  double BB=0.0;
double d_BB_dX=0.0;
  double AA=0.0;
  double LPCKe=0.0;
double d_LPCKe_dX=0.0;
  double NPCKe=0.0;
double d_NPCKe_dX=0.0;
  double NSUB0e=0.0;
double d_NSUB0e_dX=0.0;
  double RJUND_p=0.0;
double d_RJUND_p_dX=0.0;
  double RJUNS_p=0.0;
double d_RJUNS_p_dX=0.0;
  double RBULK_p=0.0;
double d_RBULK_p_dX=0.0;
  double RWELL_p=0.0;
double d_RWELL_p_dX=0.0;
  double RDE_p=0.0;
double d_RDE_p_dX=0.0;
  double RSE_p=0.0;
double d_RSE_p_dX=0.0;
  double RG_p=0.0;
double d_RG_p_dX=0.0;
  double EFEDGE_p=0.0;
double d_EFEDGE_p_dX=0.0;
  double NFCEDGE_p=0.0;
double d_NFCEDGE_p_dX=0.0;
  double NFBEDGE_p=0.0;
double d_NFBEDGE_p_dX=0.0;
  double NFAEDGE_p=0.0;
double d_NFAEDGE_p_dX=0.0;
  double FNTEDGE_p=0.0;
double d_FNTEDGE_p_dX=0.0;
  double CFBEDGE_p=0.0;
double d_CFBEDGE_p_dX=0.0;
  double CFDEDGE_p=0.0;
double d_CFDEDGE_p_dX=0.0;
  double CFEDGE_p=0.0;
double d_CFEDGE_p_dX=0.0;
  double PSCEDEDGE_p=0.0;
double d_PSCEDEDGE_p_dX=0.0;
  double PSCEBEDGE_p=0.0;
double d_PSCEBEDGE_p_dX=0.0;
  double PSCEEDGE_p=0.0;
double d_PSCEEDGE_p_dX=0.0;
  double STBETEDGE_p=0.0;
double d_STBETEDGE_p_dX=0.0;
  double BETNEDGE_p=0.0;
double d_BETNEDGE_p_dX=0.0;
  double CTEDGE_p=0.0;
double d_CTEDGE_p_dX=0.0;
  double NEFFEDGE_p=0.0;
double d_NEFFEDGE_p_dX=0.0;
  double DPHIBEDGE_p=0.0;
double d_DPHIBEDGE_p_dX=0.0;
  double STVFBEDGE_p=0.0;
double d_STVFBEDGE_p_dX=0.0;
  double VFBEDGE_p=0.0;
double d_VFBEDGE_p_dX=0.0;
  double EF_p=0.0;
double d_EF_p_dX=0.0;
  double NFC_p=0.0;
double d_NFC_p_dX=0.0;
  double NFB_p=0.0;
double d_NFB_p_dX=0.0;
  double NFA_p=0.0;
double d_NFA_p_dX=0.0;
  double FNTEXC_p=0.0;
double d_FNTEXC_p_dX=0.0;
  double FNT_p=0.0;
double d_FNT_p_dX=0.0;
  double CFRD_p=0.0;
double d_CFRD_p_dX=0.0;
  double CFR_p=0.0;
double d_CFR_p_dX=0.0;
  double CGBOV_p=0.0;
double d_CGBOV_p_dX=0.0;
  double CGOVD_p=0.0;
double d_CGOVD_p_dX=0.0;
  double CGOV_p=0.0;
double d_CGOV_p_dX=0.0;
  double COX_p=0.0;
double d_COX_p_dX=0.0;
  double CGIDLD_p=0.0;
double d_CGIDLD_p_dX=0.0;
  double CGIDL_p=0.0;
double d_CGIDL_p_dX=0.0;
  double STBGIDLD_p=0.0;
double d_STBGIDLD_p_dX=0.0;
  double STBGIDL_p=0.0;
double d_STBGIDL_p_dX=0.0;
  double BGIDLD_p=0.0;
double d_BGIDLD_p_dX=0.0;
  double BGIDL_p=0.0;
double d_BGIDL_p_dX=0.0;
  double AGIDLD_p=0.0;
double d_AGIDLD_p_dX=0.0;
  double AGIDL_p=0.0;
double d_AGIDL_p_dX=0.0;
  double CHIB_p=0.0;
double d_CHIB_p_dX=0.0;
  double GC3_p=0.0;
double d_GC3_p_dX=0.0;
  double GC2_p=0.0;
double d_GC2_p_dX=0.0;
  double STIG_p=0.0;
double d_STIG_p_dX=0.0;
  double IGOVD_p=0.0;
double d_IGOVD_p_dX=0.0;
  double IGOV_p=0.0;
double d_IGOV_p_dX=0.0;
  double IGINV_p=0.0;
double d_IGINV_p_dX=0.0;
  double GCO_p=0.0;
double d_GCO_p_dX=0.0;
  double A4_p=0.0;
double d_A4_p_dX=0.0;
  double A3_p=0.0;
double d_A3_p_dX=0.0;
  double STA2_p=0.0;
double d_STA2_p_dX=0.0;
  double A2_p=0.0;
double d_A2_p_dX=0.0;
  double A1_p=0.0;
double d_A1_p_dX=0.0;
  double VP_p=0.0;
double d_VP_p_dX=0.0;
  double ALP2_p=0.0;
double d_ALP2_p_dX=0.0;
  double ALP1_p=0.0;
double d_ALP1_p_dX=0.0;
  double ALP_p=0.0;
double d_ALP_p_dX=0.0;
  double AX_p=0.0;
double d_AX_p_dX=0.0;
  double THESATG_p=0.0;
double d_THESATG_p_dX=0.0;
  double THESATB_p=0.0;
double d_THESATB_p_dX=0.0;
  double STTHESAT_p=0.0;
double d_STTHESAT_p_dX=0.0;
  double THESAT_p=0.0;
double d_THESAT_p_dX=0.0;
  double RSG_p=0.0;
double d_RSG_p_dX=0.0;
  double RSB_p=0.0;
double d_RSB_p_dX=0.0;
  double STRS_p=0.0;
double d_STRS_p_dX=0.0;
  double RS_p=0.0;
double d_RS_p_dX=0.0;
  double FETA_p=0.0;
double d_FETA_p_dX=0.0;
  double STXCOR_p=0.0;
double d_STXCOR_p_dX=0.0;
  double XCOR_p=0.0;
double d_XCOR_p_dX=0.0;
  double STCS_p=0.0;
double d_STCS_p_dX=0.0;
  double CS_p=0.0;
double d_CS_p_dX=0.0;
  double STTHEMU_p=0.0;
double d_STTHEMU_p_dX=0.0;
  double THEMU_p=0.0;
double d_THEMU_p_dX=0.0;
  double STMUE_p=0.0;
double d_STMUE_p_dX=0.0;
  double MUE_p=0.0;
double d_MUE_p_dX=0.0;
  double STBET_p=0.0;
double d_STBET_p_dX=0.0;
  double BETN_p=0.0;
double d_BETN_p_dX=0.0;
  double CFB_p=0.0;
double d_CFB_p_dX=0.0;
  double CFD_p=0.0;
double d_CFD_p_dX=0.0;
  double CF_p=0.0;
double d_CF_p_dX=0.0;
  double PSCEB_p=0.0;
double d_PSCEB_p_dX=0.0;
  double PSCED_p=0.0;
double d_PSCED_p_dX=0.0;
  double PSCE_p=0.0;
double d_PSCE_p_dX=0.0;
  double NOVD_p=0.0;
double d_NOVD_p_dX=0.0;
  double NOV_p=0.0;
double d_NOV_p_dX=0.0;
  double TOXOVD_p=0.0;
double d_TOXOVD_p_dX=0.0;
  double TOXOV_p=0.0;
double d_TOXOV_p_dX=0.0;
  double CT_p=0.0;
double d_CT_p_dX=0.0;
  double NP_p=0.0;
double d_NP_p_dX=0.0;
  double DELVTAC_p=0.0;
double d_DELVTAC_p_dX=0.0;
  double DPHIB_p=0.0;
double d_DPHIB_p_dX=0.0;
  double DNSUB_p=0.0;
double d_DNSUB_p_dX=0.0;
  double NSLP_p=0.0;
double d_NSLP_p_dX=0.0;
  double VNSUB_p=0.0;
double d_VNSUB_p_dX=0.0;
  double DVSBNUD_p=0.0;
double d_DVSBNUD_p_dX=0.0;
  double VSBNUD_p=0.0;
double d_VSBNUD_p_dX=0.0;
  double GFACNUD_p=0.0;
double d_GFACNUD_p_dX=0.0;
  double FACNEFFAC_p=0.0;
double d_FACNEFFAC_p_dX=0.0;
  double NEFF_p=0.0;
double d_NEFF_p_dX=0.0;
  double EPSROX_p=0.0;
double d_EPSROX_p_dX=0.0;
  double TOX_p=0.0;
double d_TOX_p_dX=0.0;
  double STVFB_p=0.0;
double d_STVFB_p_dX=0.0;
  double VFB_p=0.0;
double d_VFB_p_dX=0.0;
  double XGWE=0.0;
double d_XGWE_dX=0.0;
  double W_f=0.0;
double d_W_f_dX=0.0;
  double L_slif=0.0;
double d_L_slif_dX=0.0;
  double L_f=0.0;
double d_L_f_dX=0.0;
  double iWE=0.0;
double d_iWE_dX=0.0;
  double iLE=0.0;
double d_iLE_dX=0.0;
  double Wcv=0.0;
double d_Wcv_dX=0.0;
  double Lcv=0.0;
double d_Lcv_dX=0.0;
  double WEcv=0.0;
double d_WEcv_dX=0.0;
  double LEcv=0.0;
double d_LEcv_dX=0.0;
  double delWOD=0.0;
double d_delWOD_dX=0.0;
  double delLPS=0.0;
double d_delLPS_dX=0.0;
  double iW=0.0;
double d_iW_dX=0.0;
  double iL=0.0;
double d_iL_dX=0.0;
  double NGCON_i=0.0;
double d_NGCON_i_dX=0.0;
  double SCC_i=0.0;
double d_SCC_i_dX=0.0;
  double SCB_i=0.0;
double d_SCB_i_dX=0.0;
  double SCA_i=0.0;
double d_SCA_i_dX=0.0;
  double JW_i=0.0;
double d_JW_i_dX=0.0;
  double PD_i=0.0;
double d_PD_i_dX=0.0;
  double AD_i=0.0;
double d_AD_i_dX=0.0;
  double PS_i=0.0;
double d_PS_i_dX=0.0;
  double AS_i=0.0;
double d_AS_i_dX=0.0;
  double XGW_i=0.0;
double d_XGW_i_dX=0.0;
  double SC_i=0.0;
double d_SC_i_dX=0.0;
  double SD_i=0.0;
double d_SD_i_dX=0.0;
  double SB_i=0.0;
double d_SB_i_dX=0.0;
  double SA_i=0.0;
double d_SA_i_dX=0.0;
  double W_i=0.0;
double d_W_i_dX=0.0;
  double L_i=0.0;
double d_L_i_dX=0.0;
  double invNF=0.0;
double d_invNF_dX=0.0;
  double NF_i=0.0;
double d_NF_i_dX=0.0;
//Begin block initial_instance
{
//Block-local variables for block initial_instance
double Invsa=0.0;
double d_Invsa_dX=0.0;
double Invsb=0.0;
double d_Invsb_dX=0.0;
double Invsaref=0.0;
double d_Invsaref_dX=0.0;
double Invsbref=0.0;
double d_Invsbref_dX=0.0;
double Kstressu0=0.0;
double d_Kstressu0_dX=0.0;
double rhobeta=0.0;
double d_rhobeta_dX=0.0;
double rhobetaref=0.0;
double d_rhobetaref_dX=0.0;
double Kstressvth0=0.0;
double d_Kstressvth0_dX=0.0;
//End of Block-local variables
//Block-local variables for block initial_instance
double temp0=0.0;
double d_temp0_dX=0.0;
double temp00=0.0;
double d_temp00_dX=0.0;
double templ=0.0;
double d_templ_dX=0.0;
double tempw=0.0;
double d_tempw_dX=0.0;
double Lx=0.0;
double d_Lx_dX=0.0;
double Wx=0.0;
double d_Wx_dX=0.0;
double loop=0.0;
double tmpa=0.0;
double d_tmpa_dX=0.0;
double tmpb=0.0;
double d_tmpb_dX=0.0;
//End of Block-local variables
d_NF_i_dX = 0.0;
NF_i = 1.0;
d_invNF_dX = 0.0;
invNF = 1.0;
instanceStruct.d_instanceVar_LE_dX = 0.0;
instanceStruct.instanceVar_LE = 0.0;
instanceStruct.d_instanceVar_WE_dX = 0.0;
instanceStruct.instanceVar_WE = 0.0;
d_L_i_dX = instanceStruct.d_instancePar_L_dX;
L_i = instanceStruct.instancePar_L;
d_W_i_dX = instanceStruct.d_instancePar_W_dX;
W_i = instanceStruct.instancePar_W;
d_SA_i_dX = instanceStruct.d_instancePar_SA_dX;
SA_i = instanceStruct.instancePar_SA;
d_SB_i_dX = instanceStruct.d_instancePar_SB_dX;
SB_i = instanceStruct.instancePar_SB;
d_SD_i_dX = instanceStruct.d_instancePar_SD_dX;
SD_i = instanceStruct.instancePar_SD;
d_SC_i_dX = instanceStruct.d_instancePar_SC_dX;
SC_i = instanceStruct.instancePar_SC;
d_XGW_i_dX = instanceStruct.d_instancePar_XGW_dX;
XGW_i = instanceStruct.instancePar_XGW;
instanceStruct.d_instanceVar_ABSOURCE_i_dX = instanceStruct.d_instancePar_ABSOURCE_dX;
instanceStruct.instanceVar_ABSOURCE_i = instanceStruct.instancePar_ABSOURCE;
instanceStruct.d_instanceVar_LSSOURCE_i_dX = instanceStruct.d_instancePar_LSSOURCE_dX;
instanceStruct.instanceVar_LSSOURCE_i = instanceStruct.instancePar_LSSOURCE;
instanceStruct.d_instanceVar_LGSOURCE_i_dX = instanceStruct.d_instancePar_LGSOURCE_dX;
instanceStruct.instanceVar_LGSOURCE_i = instanceStruct.instancePar_LGSOURCE;
instanceStruct.d_instanceVar_ABDRAIN_i_dX = instanceStruct.d_instancePar_ABDRAIN_dX;
instanceStruct.instanceVar_ABDRAIN_i = instanceStruct.instancePar_ABDRAIN;
instanceStruct.d_instanceVar_LSDRAIN_i_dX = instanceStruct.d_instancePar_LSDRAIN_dX;
instanceStruct.instanceVar_LSDRAIN_i = instanceStruct.instancePar_LSDRAIN;
instanceStruct.d_instanceVar_LGDRAIN_i_dX = instanceStruct.d_instancePar_LGDRAIN_dX;
instanceStruct.instanceVar_LGDRAIN_i = instanceStruct.instancePar_LGDRAIN;
d_AS_i_dX = instanceStruct.d_instancePar_AS_dX;
AS_i = instanceStruct.instancePar_AS;
d_PS_i_dX = instanceStruct.d_instancePar_PS_dX;
PS_i = instanceStruct.instancePar_PS;
d_AD_i_dX = instanceStruct.d_instancePar_AD_dX;
AD_i = instanceStruct.instancePar_AD;
d_PD_i_dX = instanceStruct.d_instancePar_PD_dX;
PD_i = instanceStruct.instancePar_PD;
d_JW_i_dX = instanceStruct.d_instancePar_JW_dX;
JW_i = instanceStruct.instancePar_JW;
if (((modelStruct.modelVar_SWGEO_i==1)||(modelStruct.modelVar_SWGEO_i==2)))
{
d_NF_i_dX = ((instanceStruct.instancePar_NF>1.0)?instanceStruct.d_instancePar_NF_dX:0.0);
NF_i = ((instanceStruct.instancePar_NF>1.0)?instanceStruct.instancePar_NF:1.0);
{
double value_floor_0 = floor((NF_i+0.5));
d_NF_i_dX = 0.0;
NF_i = floor((NF_i+0.5));
}
d_invNF_dX = (-d_NF_i_dX/NF_i/NF_i);
invNF = (1.0/NF_i);
}
d_L_i_dX = ((L_i>1.0e-9)?d_L_i_dX:0.0);
L_i = ((L_i>1.0e-9)?L_i:1.0e-9);
d_W_i_dX = (((W_i*invNF)>1.0e-9)?(W_i*d_invNF_dX+d_W_i_dX*invNF):0.0);
W_i = (((W_i*invNF)>1.0e-9)?(W_i*invNF):1.0e-9);
d_SCA_i_dX = ((instanceStruct.instancePar_SCA>0.0)?instanceStruct.d_instancePar_SCA_dX:0.0);
SCA_i = ((instanceStruct.instancePar_SCA>0.0)?instanceStruct.instancePar_SCA:0.0);
d_SCB_i_dX = ((instanceStruct.instancePar_SCB>0.0)?instanceStruct.d_instancePar_SCB_dX:0.0);
SCB_i = ((instanceStruct.instancePar_SCB>0.0)?instanceStruct.instancePar_SCB:0.0);
d_SCC_i_dX = ((instanceStruct.instancePar_SCC>0.0)?instanceStruct.d_instancePar_SCC_dX:0.0);
SCC_i = ((instanceStruct.instancePar_SCC>0.0)?instanceStruct.instancePar_SCC:0.0);
d_NGCON_i_dX = 0.0;
NGCON_i = ((instanceStruct.instancePar_NGCON<1.5)?1.0:2.0);
d_iL_dX = (-1.0e-6*d_L_i_dX/L_i/L_i);
iL = (1.0e-6/L_i);
d_iW_dX = (-1.0e-6*d_W_i_dX/W_i/W_i);
iW = (1.0e-6/W_i);
d_delLPS_dX = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(modelStruct.modelPar_LVARW*d_iW_dX+modelStruct.d_modelPar_LVARW_dX*iW)+(modelStruct.modelPar_LVARO*(modelStruct.modelPar_LVARL*d_iL_dX+modelStruct.d_modelPar_LVARL_dX*iL)+modelStruct.d_modelPar_LVARO_dX*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
delLPS = ((modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)))*(1.0+(modelStruct.modelPar_LVARW*iW)));
d_delWOD_dX = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARL*iL)))*(modelStruct.modelPar_WVARW*d_iW_dX+modelStruct.d_modelPar_WVARW_dX*iW)+(modelStruct.modelPar_WVARO*(modelStruct.modelPar_WVARL*d_iL_dX+modelStruct.d_modelPar_WVARL_dX*iL)+modelStruct.d_modelPar_WVARO_dX*(1.0+(modelStruct.modelPar_WVARL*iL)))*(1.0+(modelStruct.modelPar_WVARW*iW)));
delWOD = ((modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARL*iL)))*(1.0+(modelStruct.modelPar_WVARW*iW)));
if ((modelStruct.modelVar_SWGEO_i==2))
{
d_delLPS_dX = (modelStruct.modelPar_LVARO*(modelStruct.modelPar_LVARL*d_iL_dX+modelStruct.d_modelPar_LVARL_dX*iL)+modelStruct.d_modelPar_LVARO_dX*(1.0+(modelStruct.modelPar_LVARL*iL)));
delLPS = (modelStruct.modelPar_LVARO*(1.0+(modelStruct.modelPar_LVARL*iL)));
d_delWOD_dX = (modelStruct.modelPar_WVARO*(modelStruct.modelPar_WVARW*d_iW_dX+modelStruct.d_modelPar_WVARW_dX*iW)+modelStruct.d_modelPar_WVARO_dX*(1.0+(modelStruct.modelPar_WVARW*iW)));
delWOD = (modelStruct.modelPar_WVARO*(1.0+(modelStruct.modelPar_WVARW*iW)));
}
instanceStruct.d_instanceVar_LE_dX = ((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))>1.0e-9)?((d_L_i_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX):0.0);
instanceStruct.instanceVar_LE = ((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))>1.0e-9)?((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP)):1.0e-9);
instanceStruct.d_instanceVar_WE_dX = ((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))>1.0e-9)?((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX):0.0);
instanceStruct.instanceVar_WE = ((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))>1.0e-9)?((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT)):1.0e-9);
d_LEcv_dX = (((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ)>1.0e-9)?(((d_L_i_dX+d_delLPS_dX)-2.0*modelStruct.d_modelPar_LAP_dX)+modelStruct.d_modelPar_DLQ_dX):0.0);
LEcv = (((((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ)>1.0e-9)?(((L_i+delLPS)-(2.0*modelStruct.modelPar_LAP))+modelStruct.modelPar_DLQ):1.0e-9);
d_WEcv_dX = (((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ)>1.0e-9)?(((d_W_i_dX+d_delWOD_dX)-2.0*modelStruct.d_modelPar_WOT_dX)+modelStruct.d_modelPar_DWQ_dX):0.0);
WEcv = (((((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ)>1.0e-9)?(((W_i+delWOD)-(2.0*modelStruct.modelPar_WOT))+modelStruct.modelPar_DWQ):1.0e-9);
d_Lcv_dX = ((((L_i+delLPS)+modelStruct.modelPar_DLQ)>1.0e-9)?((d_L_i_dX+d_delLPS_dX)+modelStruct.d_modelPar_DLQ_dX):0.0);
Lcv = ((((L_i+delLPS)+modelStruct.modelPar_DLQ)>1.0e-9)?((L_i+delLPS)+modelStruct.modelPar_DLQ):1.0e-9);
d_Wcv_dX = ((((W_i+delWOD)+modelStruct.modelPar_DWQ)>1.0e-9)?((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_DWQ_dX):0.0);
Wcv = ((((W_i+delWOD)+modelStruct.modelPar_DWQ)>1.0e-9)?((W_i+delWOD)+modelStruct.modelPar_DWQ):1.0e-9);
d_iLE_dX = (-1.0e-6*instanceStruct.d_instanceVar_LE_dX/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE);
iLE = (1.0e-6/instanceStruct.instanceVar_LE);
d_iWE_dX = (-1.0e-6*instanceStruct.d_instanceVar_WE_dX/instanceStruct.instanceVar_WE/instanceStruct.instanceVar_WE);
iWE = (1.0e-6/instanceStruct.instanceVar_WE);
d_L_f_dX = (((L_i+delLPS)>1.0e-9)?(d_L_i_dX+d_delLPS_dX):0.0);
L_f = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
d_L_slif_dX = (((L_f+modelStruct.modelPar_DLSIL)>1.0e-9)?(d_L_f_dX+modelStruct.d_modelPar_DLSIL_dX):0.0);
L_slif = (((L_f+modelStruct.modelPar_DLSIL)>1.0e-9)?(L_f+modelStruct.modelPar_DLSIL):1.0e-9);
d_W_f_dX = (((W_i+delWOD)>1.0e-9)?(d_W_i_dX+d_delWOD_dX):0.0);
W_f = (((W_i+delWOD)>1.0e-9)?(W_i+delWOD):1.0e-9);
d_XGWE_dX = (((XGW_i-(0.5*delWOD))>1.0e-9)?(d_XGW_i_dX-0.5*d_delWOD_dX):0.0);
XGWE = (((XGW_i-(0.5*delWOD))>1.0e-9)?(XGW_i-(0.5*delWOD)):1.0e-9);
d_VFB_p_dX = modelStruct.d_modelPar_VFB_dX;
VFB_p = modelStruct.modelPar_VFB;
d_STVFB_p_dX = modelStruct.d_modelPar_STVFB_dX;
STVFB_p = modelStruct.modelPar_STVFB;
d_TOX_p_dX = modelStruct.d_modelPar_TOX_dX;
TOX_p = modelStruct.modelPar_TOX;
d_EPSROX_p_dX = modelStruct.d_modelPar_EPSROX_dX;
EPSROX_p = modelStruct.modelPar_EPSROX;
d_NEFF_p_dX = modelStruct.d_modelPar_NEFF_dX;
NEFF_p = modelStruct.modelPar_NEFF;
d_FACNEFFAC_p_dX = modelStruct.d_modelPar_FACNEFFAC_dX;
FACNEFFAC_p = modelStruct.modelPar_FACNEFFAC;
d_GFACNUD_p_dX = modelStruct.d_modelPar_GFACNUD_dX;
GFACNUD_p = modelStruct.modelPar_GFACNUD;
d_VSBNUD_p_dX = modelStruct.d_modelPar_VSBNUD_dX;
VSBNUD_p = modelStruct.modelPar_VSBNUD;
d_DVSBNUD_p_dX = modelStruct.d_modelPar_DVSBNUD_dX;
DVSBNUD_p = modelStruct.modelPar_DVSBNUD;
d_VNSUB_p_dX = modelStruct.d_modelPar_VNSUB_dX;
VNSUB_p = modelStruct.modelPar_VNSUB;
d_NSLP_p_dX = modelStruct.d_modelPar_NSLP_dX;
NSLP_p = modelStruct.modelPar_NSLP;
d_DNSUB_p_dX = modelStruct.d_modelPar_DNSUB_dX;
DNSUB_p = modelStruct.modelPar_DNSUB;
d_DPHIB_p_dX = modelStruct.d_modelPar_DPHIB_dX;
DPHIB_p = modelStruct.modelPar_DPHIB;
d_DELVTAC_p_dX = modelStruct.d_modelPar_DELVTAC_dX;
DELVTAC_p = modelStruct.modelPar_DELVTAC;
d_NP_p_dX = modelStruct.d_modelPar_NP_dX;
NP_p = modelStruct.modelPar_NP;
d_CT_p_dX = modelStruct.d_modelPar_CT_dX;
CT_p = modelStruct.modelPar_CT;
d_TOXOV_p_dX = modelStruct.d_modelPar_TOXOV_dX;
TOXOV_p = modelStruct.modelPar_TOXOV;
d_TOXOVD_p_dX = modelStruct.d_modelPar_TOXOVD_dX;
TOXOVD_p = modelStruct.modelPar_TOXOVD;
d_NOV_p_dX = modelStruct.d_modelPar_NOV_dX;
NOV_p = modelStruct.modelPar_NOV;
d_NOVD_p_dX = modelStruct.d_modelPar_NOVD_dX;
NOVD_p = modelStruct.modelPar_NOVD;
d_PSCE_p_dX = modelStruct.d_modelPar_PSCE_dX;
PSCE_p = modelStruct.modelPar_PSCE;
d_PSCED_p_dX = modelStruct.d_modelPar_PSCED_dX;
PSCED_p = modelStruct.modelPar_PSCED;
d_PSCEB_p_dX = modelStruct.d_modelPar_PSCEB_dX;
PSCEB_p = modelStruct.modelPar_PSCEB;
d_CF_p_dX = modelStruct.d_modelPar_CF_dX;
CF_p = modelStruct.modelPar_CF;
d_CFD_p_dX = modelStruct.d_modelPar_CFD_dX;
CFD_p = modelStruct.modelPar_CFD;
d_CFB_p_dX = modelStruct.d_modelPar_CFB_dX;
CFB_p = modelStruct.modelPar_CFB;
d_BETN_p_dX = modelStruct.d_modelPar_BETN_dX;
BETN_p = modelStruct.modelPar_BETN;
d_STBET_p_dX = modelStruct.d_modelPar_STBET_dX;
STBET_p = modelStruct.modelPar_STBET;
d_MUE_p_dX = modelStruct.d_modelPar_MUE_dX;
MUE_p = modelStruct.modelPar_MUE;
d_STMUE_p_dX = modelStruct.d_modelPar_STMUE_dX;
STMUE_p = modelStruct.modelPar_STMUE;
d_THEMU_p_dX = modelStruct.d_modelPar_THEMU_dX;
THEMU_p = modelStruct.modelPar_THEMU;
d_STTHEMU_p_dX = modelStruct.d_modelPar_STTHEMU_dX;
STTHEMU_p = modelStruct.modelPar_STTHEMU;
d_CS_p_dX = modelStruct.d_modelPar_CS_dX;
CS_p = modelStruct.modelPar_CS;
d_STCS_p_dX = modelStruct.d_modelPar_STCS_dX;
STCS_p = modelStruct.modelPar_STCS;
d_XCOR_p_dX = modelStruct.d_modelPar_XCOR_dX;
XCOR_p = modelStruct.modelPar_XCOR;
d_STXCOR_p_dX = modelStruct.d_modelPar_STXCOR_dX;
STXCOR_p = modelStruct.modelPar_STXCOR;
d_FETA_p_dX = modelStruct.d_modelPar_FETA_dX;
FETA_p = modelStruct.modelPar_FETA;
d_RS_p_dX = modelStruct.d_modelPar_RS_dX;
RS_p = modelStruct.modelPar_RS;
d_STRS_p_dX = modelStruct.d_modelPar_STRS_dX;
STRS_p = modelStruct.modelPar_STRS;
d_RSB_p_dX = modelStruct.d_modelPar_RSB_dX;
RSB_p = modelStruct.modelPar_RSB;
d_RSG_p_dX = modelStruct.d_modelPar_RSG_dX;
RSG_p = modelStruct.modelPar_RSG;
d_THESAT_p_dX = modelStruct.d_modelPar_THESAT_dX;
THESAT_p = modelStruct.modelPar_THESAT;
d_STTHESAT_p_dX = modelStruct.d_modelPar_STTHESAT_dX;
STTHESAT_p = modelStruct.modelPar_STTHESAT;
d_THESATB_p_dX = modelStruct.d_modelPar_THESATB_dX;
THESATB_p = modelStruct.modelPar_THESATB;
d_THESATG_p_dX = modelStruct.d_modelPar_THESATG_dX;
THESATG_p = modelStruct.modelPar_THESATG;
d_AX_p_dX = modelStruct.d_modelPar_AX_dX;
AX_p = modelStruct.modelPar_AX;
d_ALP_p_dX = modelStruct.d_modelPar_ALP_dX;
ALP_p = modelStruct.modelPar_ALP;
d_ALP1_p_dX = modelStruct.d_modelPar_ALP1_dX;
ALP1_p = modelStruct.modelPar_ALP1;
d_ALP2_p_dX = modelStruct.d_modelPar_ALP2_dX;
ALP2_p = modelStruct.modelPar_ALP2;
d_VP_p_dX = modelStruct.d_modelPar_VP_dX;
VP_p = modelStruct.modelPar_VP;
d_A1_p_dX = modelStruct.d_modelPar_A1_dX;
A1_p = modelStruct.modelPar_A1;
d_A2_p_dX = modelStruct.d_modelPar_A2_dX;
A2_p = modelStruct.modelPar_A2;
d_STA2_p_dX = modelStruct.d_modelPar_STA2_dX;
STA2_p = modelStruct.modelPar_STA2;
d_A3_p_dX = modelStruct.d_modelPar_A3_dX;
A3_p = modelStruct.modelPar_A3;
d_A4_p_dX = modelStruct.d_modelPar_A4_dX;
A4_p = modelStruct.modelPar_A4;
d_GCO_p_dX = modelStruct.d_modelPar_GCO_dX;
GCO_p = modelStruct.modelPar_GCO;
d_IGINV_p_dX = modelStruct.d_modelPar_IGINV_dX;
IGINV_p = modelStruct.modelPar_IGINV;
d_IGOV_p_dX = modelStruct.d_modelPar_IGOV_dX;
IGOV_p = modelStruct.modelPar_IGOV;
d_IGOVD_p_dX = modelStruct.d_modelPar_IGOVD_dX;
IGOVD_p = modelStruct.modelPar_IGOVD;
d_STIG_p_dX = modelStruct.d_modelPar_STIG_dX;
STIG_p = modelStruct.modelPar_STIG;
d_GC2_p_dX = modelStruct.d_modelPar_GC2_dX;
GC2_p = modelStruct.modelPar_GC2;
d_GC3_p_dX = modelStruct.d_modelPar_GC3_dX;
GC3_p = modelStruct.modelPar_GC3;
d_CHIB_p_dX = modelStruct.d_modelPar_CHIB_dX;
CHIB_p = modelStruct.modelPar_CHIB;
d_AGIDL_p_dX = modelStruct.d_modelPar_AGIDL_dX;
AGIDL_p = modelStruct.modelPar_AGIDL;
d_AGIDLD_p_dX = modelStruct.d_modelPar_AGIDLD_dX;
AGIDLD_p = modelStruct.modelPar_AGIDLD;
d_BGIDL_p_dX = modelStruct.d_modelPar_BGIDL_dX;
BGIDL_p = modelStruct.modelPar_BGIDL;
d_BGIDLD_p_dX = modelStruct.d_modelPar_BGIDLD_dX;
BGIDLD_p = modelStruct.modelPar_BGIDLD;
d_STBGIDL_p_dX = modelStruct.d_modelPar_STBGIDL_dX;
STBGIDL_p = modelStruct.modelPar_STBGIDL;
d_STBGIDLD_p_dX = modelStruct.d_modelPar_STBGIDLD_dX;
STBGIDLD_p = modelStruct.modelPar_STBGIDLD;
d_CGIDL_p_dX = modelStruct.d_modelPar_CGIDL_dX;
CGIDL_p = modelStruct.modelPar_CGIDL;
d_CGIDLD_p_dX = modelStruct.d_modelPar_CGIDLD_dX;
CGIDLD_p = modelStruct.modelPar_CGIDLD;
d_COX_p_dX = modelStruct.d_modelPar_COX_dX;
COX_p = modelStruct.modelPar_COX;
d_CGOV_p_dX = modelStruct.d_modelPar_CGOV_dX;
CGOV_p = modelStruct.modelPar_CGOV;
d_CGOVD_p_dX = modelStruct.d_modelPar_CGOVD_dX;
CGOVD_p = modelStruct.modelPar_CGOVD;
d_CGBOV_p_dX = modelStruct.d_modelPar_CGBOV_dX;
CGBOV_p = modelStruct.modelPar_CGBOV;
d_CFR_p_dX = modelStruct.d_modelPar_CFR_dX;
CFR_p = modelStruct.modelPar_CFR;
d_CFRD_p_dX = modelStruct.d_modelPar_CFRD_dX;
CFRD_p = modelStruct.modelPar_CFRD;
d_FNT_p_dX = modelStruct.d_modelPar_FNT_dX;
FNT_p = modelStruct.modelPar_FNT;
d_FNTEXC_p_dX = modelStruct.d_modelPar_FNTEXC_dX;
FNTEXC_p = modelStruct.modelPar_FNTEXC;
d_NFA_p_dX = modelStruct.d_modelPar_NFA_dX;
NFA_p = modelStruct.modelPar_NFA;
d_NFB_p_dX = modelStruct.d_modelPar_NFB_dX;
NFB_p = modelStruct.modelPar_NFB;
d_NFC_p_dX = modelStruct.d_modelPar_NFC_dX;
NFC_p = modelStruct.modelPar_NFC;
d_EF_p_dX = modelStruct.d_modelPar_EF_dX;
EF_p = modelStruct.modelPar_EF;
d_VFBEDGE_p_dX = modelStruct.d_modelPar_VFBEDGE_dX;
VFBEDGE_p = modelStruct.modelPar_VFBEDGE;
d_STVFBEDGE_p_dX = modelStruct.d_modelPar_STVFBEDGE_dX;
STVFBEDGE_p = modelStruct.modelPar_STVFBEDGE;
d_DPHIBEDGE_p_dX = modelStruct.d_modelPar_DPHIBEDGE_dX;
DPHIBEDGE_p = modelStruct.modelPar_DPHIBEDGE;
d_NEFFEDGE_p_dX = modelStruct.d_modelPar_NEFFEDGE_dX;
NEFFEDGE_p = modelStruct.modelPar_NEFFEDGE;
d_CTEDGE_p_dX = modelStruct.d_modelPar_CTEDGE_dX;
CTEDGE_p = modelStruct.modelPar_CTEDGE;
d_BETNEDGE_p_dX = modelStruct.d_modelPar_BETNEDGE_dX;
BETNEDGE_p = modelStruct.modelPar_BETNEDGE;
d_STBETEDGE_p_dX = modelStruct.d_modelPar_STBETEDGE_dX;
STBETEDGE_p = modelStruct.modelPar_STBETEDGE;
d_PSCEEDGE_p_dX = modelStruct.d_modelPar_PSCEEDGE_dX;
PSCEEDGE_p = modelStruct.modelPar_PSCEEDGE;
d_PSCEBEDGE_p_dX = modelStruct.d_modelPar_PSCEBEDGE_dX;
PSCEBEDGE_p = modelStruct.modelPar_PSCEBEDGE;
d_PSCEDEDGE_p_dX = modelStruct.d_modelPar_PSCEDEDGE_dX;
PSCEDEDGE_p = modelStruct.modelPar_PSCEDEDGE;
d_CFEDGE_p_dX = modelStruct.d_modelPar_CFEDGE_dX;
CFEDGE_p = modelStruct.modelPar_CFEDGE;
d_CFDEDGE_p_dX = modelStruct.d_modelPar_CFDEDGE_dX;
CFDEDGE_p = modelStruct.modelPar_CFDEDGE;
d_CFBEDGE_p_dX = modelStruct.d_modelPar_CFBEDGE_dX;
CFBEDGE_p = modelStruct.modelPar_CFBEDGE;
d_FNTEDGE_p_dX = modelStruct.d_modelPar_FNTEDGE_dX;
FNTEDGE_p = modelStruct.modelPar_FNTEDGE;
d_NFAEDGE_p_dX = modelStruct.d_modelPar_NFAEDGE_dX;
NFAEDGE_p = modelStruct.modelPar_NFAEDGE;
d_NFBEDGE_p_dX = modelStruct.d_modelPar_NFBEDGE_dX;
NFBEDGE_p = modelStruct.modelPar_NFBEDGE;
d_NFCEDGE_p_dX = modelStruct.d_modelPar_NFCEDGE_dX;
NFCEDGE_p = modelStruct.modelPar_NFCEDGE;
d_EFEDGE_p_dX = modelStruct.d_modelPar_EFEDGE_dX;
EFEDGE_p = modelStruct.modelPar_EFEDGE;
d_RG_p_dX = modelStruct.d_modelPar_RG_dX;
RG_p = modelStruct.modelPar_RG;
d_RSE_p_dX = modelStruct.d_modelPar_RSE_dX;
RSE_p = modelStruct.modelPar_RSE;
d_RDE_p_dX = modelStruct.d_modelPar_RDE_dX;
RDE_p = modelStruct.modelPar_RDE;
d_RWELL_p_dX = modelStruct.d_modelPar_RWELL_dX;
RWELL_p = modelStruct.modelPar_RWELL;
d_RBULK_p_dX = modelStruct.d_modelPar_RBULK_dX;
RBULK_p = modelStruct.modelPar_RBULK;
d_RJUNS_p_dX = modelStruct.d_modelPar_RJUNS_dX;
RJUNS_p = modelStruct.modelPar_RJUNS;
d_RJUND_p_dX = modelStruct.d_modelPar_RJUND_dX;
RJUND_p = modelStruct.modelPar_RJUND;
if ((modelStruct.modelVar_SWGEO_i==1))
{
d_VFB_p_dX = (((modelStruct.d_modelPar_VFBO_dX+(modelStruct.modelPar_VFBL*d_iLE_dX+modelStruct.d_modelPar_VFBL_dX*iLE))+(modelStruct.modelPar_VFBW*d_iWE_dX+modelStruct.d_modelPar_VFBW_dX*iWE))+((modelStruct.modelPar_VFBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_VFBLW*d_iLE_dX+modelStruct.d_modelPar_VFBLW_dX*iLE)*iWE));
VFB_p = (((modelStruct.modelPar_VFBO+(modelStruct.modelPar_VFBL*iLE))+(modelStruct.modelPar_VFBW*iWE))+((modelStruct.modelPar_VFBLW*iLE)*iWE));
d_STVFB_p_dX = (((modelStruct.d_modelPar_STVFBO_dX+(modelStruct.modelPar_STVFBL*d_iLE_dX+modelStruct.d_modelPar_STVFBL_dX*iLE))+(modelStruct.modelPar_STVFBW*d_iWE_dX+modelStruct.d_modelPar_STVFBW_dX*iWE))+((modelStruct.modelPar_STVFBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STVFBLW*d_iLE_dX+modelStruct.d_modelPar_STVFBLW_dX*iLE)*iWE));
STVFB_p = (((modelStruct.modelPar_STVFBO+(modelStruct.modelPar_STVFBL*iLE))+(modelStruct.modelPar_STVFBW*iWE))+((modelStruct.modelPar_STVFBLW*iLE)*iWE));
d_TOX_p_dX = modelStruct.d_modelPar_TOXO_dX;
TOX_p = modelStruct.modelPar_TOXO;
d_EPSROX_p_dX = modelStruct.d_modelPar_EPSROXO_dX;
EPSROX_p = modelStruct.modelPar_EPSROXO;
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEG_i)));
d_NSUB0e_dX = (modelStruct.modelVar_NSUBO_i*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0e-03)?((modelStruct.modelPar_NSUBW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEG_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEG_i_dX)/modelStruct.modelVar_WSEG_i/modelStruct.modelVar_WSEG_i))+(modelStruct.modelPar_NSUBW*d_iWE_dX+modelStruct.d_modelPar_NSUBW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_NSUBO_i_dX*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_1)):1.0e-03));
NSUB0e = (modelStruct.modelVar_NSUBO_i*(((1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_NSUBW*iWE)*value_log_1)):1.0e-03));
}
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
d_NPCKe_dX = (modelStruct.modelVar_NPCK_i*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0e-03)?((modelStruct.modelPar_NPCKW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEGP_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEGP_i_dX)/modelStruct.modelVar_WSEGP_i/modelStruct.modelVar_WSEGP_i))+(modelStruct.modelPar_NPCKW*d_iWE_dX+modelStruct.d_modelPar_NPCKW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_NPCK_i_dX*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_1)):1.0e-03));
NPCKe = (modelStruct.modelVar_NPCK_i*(((1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_NPCKW*iWE)*value_log_1)):1.0e-03));
}
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double value_log_1 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
double  deriv_log_1_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WSEGP_i)));
d_LPCKe_dX = (modelStruct.modelVar_LPCK_i*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0e-03)?((modelStruct.modelPar_LPCKW*iWE)*deriv_log_1_d0*(((modelStruct.modelVar_WSEGP_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WSEGP_i_dX)/modelStruct.modelVar_WSEGP_i/modelStruct.modelVar_WSEGP_i))+(modelStruct.modelPar_LPCKW*d_iWE_dX+modelStruct.d_modelPar_LPCKW_dX*iWE)*value_log_1):0.0)+modelStruct.d_modelVar_LPCK_i_dX*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_1)):1.0e-03));
LPCKe = (modelStruct.modelVar_LPCK_i*(((1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_0))>1.0e-03)?(1.0+((modelStruct.modelPar_LPCKW*iWE)*value_log_1)):1.0e-03));
}
if ((instanceStruct.instanceVar_LE>(2.0*LPCKe)))
{
AA = 7.5e10;
{
double value_sqrt_0 = sqrt((NSUB0e+(0.5*NPCKe)));
double value_sqrt_1 = sqrt(NSUB0e);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_BB_dX = (deriv_sqrt_0_d0*((d_NSUB0e_dX+0.5*d_NPCKe_dX))-deriv_sqrt_1_d0*(d_NSUB0e_dX));
BB = (value_sqrt_0-value_sqrt_1);
}
{
double value_sqrt_0 = sqrt(NSUB0e);
double value_exp_1 = exp((BB/AA));
double value_log_2 = log((1.0+(((2.0*LPCKe)/instanceStruct.instanceVar_LE)*(value_exp_1-1.0))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_exp_1_d0 = value_exp_1;
double  deriv_log_2_d0 = (1.0/(1.0+(((2.0*LPCKe)/instanceStruct.instanceVar_LE)*(value_exp_1-1.0))));
d_NSUB_dX = (deriv_sqrt_0_d0*(d_NSUB0e_dX)+AA*deriv_log_2_d0*((((2.0*LPCKe)/instanceStruct.instanceVar_LE)*deriv_exp_1_d0*((d_BB_dX/AA))+((instanceStruct.instanceVar_LE*2.0*d_LPCKe_dX-(2.0*LPCKe)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(value_exp_1-1.0))));
NSUB = (value_sqrt_0+(AA*value_log_2));
}
d_NSUB_dX = (NSUB*d_NSUB_dX+d_NSUB_dX*NSUB);
NSUB = (NSUB*NSUB);
}
else
{
if ((instanceStruct.instanceVar_LE>=LPCKe))
{
d_NSUB_dX = (d_NSUB0e_dX+((instanceStruct.instanceVar_LE*(NPCKe*d_LPCKe_dX+d_NPCKe_dX*LPCKe)-(NPCKe*LPCKe)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE));
NSUB = (NSUB0e+((NPCKe*LPCKe)/instanceStruct.instanceVar_LE));
}
else
{
d_NSUB_dX = (d_NSUB0e_dX+(NPCKe*(-((LPCKe*instanceStruct.d_instanceVar_LE_dX-instanceStruct.instanceVar_LE*d_LPCKe_dX)/LPCKe/LPCKe))+d_NPCKe_dX*(2.0-(instanceStruct.instanceVar_LE/LPCKe))));
NSUB = (NSUB0e+(NPCKe*(2.0-(instanceStruct.instanceVar_LE/LPCKe))));
}
}
d_NEFF_p_dX = (NSUB*((-(modelStruct.modelPar_FOL1*d_iLE_dX+modelStruct.d_modelPar_FOL1_dX*iLE))-((modelStruct.modelPar_FOL2*iLE)*d_iLE_dX+(modelStruct.modelPar_FOL2*d_iLE_dX+modelStruct.d_modelPar_FOL2_dX*iLE)*iLE))+d_NSUB_dX*((1.0-(modelStruct.modelPar_FOL1*iLE))-((modelStruct.modelPar_FOL2*iLE)*iLE)));
NEFF_p = (NSUB*((1.0-(modelStruct.modelPar_FOL1*iLE))-((modelStruct.modelPar_FOL2*iLE)*iLE)));
d_FACNEFFAC_p_dX = (((modelStruct.d_modelPar_FACNEFFACO_dX+(modelStruct.modelPar_FACNEFFACL*d_iLE_dX+modelStruct.d_modelPar_FACNEFFACL_dX*iLE))+(modelStruct.modelPar_FACNEFFACW*d_iWE_dX+modelStruct.d_modelPar_FACNEFFACW_dX*iWE))+((modelStruct.modelPar_FACNEFFACLW*iLE)*d_iWE_dX+(modelStruct.modelPar_FACNEFFACLW*d_iLE_dX+modelStruct.d_modelPar_FACNEFFACLW_dX*iLE)*iWE));
FACNEFFAC_p = (((modelStruct.modelPar_FACNEFFACO+(modelStruct.modelPar_FACNEFFACL*iLE))+(modelStruct.modelPar_FACNEFFACW*iWE))+((modelStruct.modelPar_FACNEFFACLW*iLE)*iWE));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_GFACNUDLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_GFACNUDLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_GFACNUD_p_dX = (((modelStruct.d_modelPar_GFACNUDO_dX+(modelStruct.modelPar_GFACNUDL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_GFACNUDLEXP_dX)))+modelStruct.d_modelPar_GFACNUDL_dX*value_pow_0))+(modelStruct.modelPar_GFACNUDW*d_iWE_dX+modelStruct.d_modelPar_GFACNUDW_dX*iWE))+((modelStruct.modelPar_GFACNUDLW*iLE)*d_iWE_dX+(modelStruct.modelPar_GFACNUDLW*d_iLE_dX+modelStruct.d_modelPar_GFACNUDLW_dX*iLE)*iWE));
GFACNUD_p = (((modelStruct.modelPar_GFACNUDO+(modelStruct.modelPar_GFACNUDL*value_pow_0))+(modelStruct.modelPar_GFACNUDW*iWE))+((modelStruct.modelPar_GFACNUDLW*iLE)*iWE));
}
d_VSBNUD_p_dX = modelStruct.d_modelPar_VSBNUDO_dX;
VSBNUD_p = modelStruct.modelPar_VSBNUDO;
d_DVSBNUD_p_dX = modelStruct.d_modelPar_DVSBNUDO_dX;
DVSBNUD_p = modelStruct.modelPar_DVSBNUDO;
d_VNSUB_p_dX = modelStruct.d_modelPar_VNSUBO_dX;
VNSUB_p = modelStruct.modelPar_VNSUBO;
d_NSLP_p_dX = modelStruct.d_modelPar_NSLPO_dX;
NSLP_p = modelStruct.modelPar_NSLPO;
d_DNSUB_p_dX = modelStruct.d_modelPar_DNSUBO_dX;
DNSUB_p = modelStruct.modelPar_DNSUBO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_DPHIBLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DPHIBLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_DPHIB_p_dX = (((modelStruct.d_modelPar_DPHIBO_dX+(modelStruct.modelPar_DPHIBL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DPHIBLEXP_dX)))+modelStruct.d_modelPar_DPHIBL_dX*value_pow_0))+(modelStruct.modelPar_DPHIBW*d_iWE_dX+modelStruct.d_modelPar_DPHIBW_dX*iWE))+((modelStruct.modelPar_DPHIBLW*iLE)*d_iWE_dX+(modelStruct.modelPar_DPHIBLW*d_iLE_dX+modelStruct.d_modelPar_DPHIBLW_dX*iLE)*iWE));
DPHIB_p = (((modelStruct.modelPar_DPHIBO+(modelStruct.modelPar_DPHIBL*value_pow_0))+(modelStruct.modelPar_DPHIBW*iWE))+((modelStruct.modelPar_DPHIBLW*iLE)*iWE));
}
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_DELVTACLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DELVTACLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_DELVTAC_p_dX = (((modelStruct.d_modelPar_DELVTACO_dX+(modelStruct.modelPar_DELVTACL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DELVTACLEXP_dX)))+modelStruct.d_modelPar_DELVTACL_dX*value_pow_0))+(modelStruct.modelPar_DELVTACW*d_iWE_dX+modelStruct.d_modelPar_DELVTACW_dX*iWE))+((modelStruct.modelPar_DELVTACLW*iLE)*d_iWE_dX+(modelStruct.modelPar_DELVTACLW*d_iLE_dX+modelStruct.d_modelPar_DELVTACLW_dX*iLE)*iWE));
DELVTAC_p = (((modelStruct.modelPar_DELVTACO+(modelStruct.modelPar_DELVTACL*value_pow_0))+(modelStruct.modelPar_DELVTACW*iWE))+((modelStruct.modelPar_DELVTACLW*iLE)*iWE));
}
d_NP_p_dX = (modelStruct.modelPar_NPO*((1.0e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?0.0:(modelStruct.modelPar_NPL*d_iLE_dX+modelStruct.d_modelPar_NPL_dX*iLE))+modelStruct.d_modelPar_NPO_dX*((1.0e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?1.0e-6:(1.0+(modelStruct.modelPar_NPL*iLE))));
NP_p = (modelStruct.modelPar_NPO*((1.0e-6>(1.0+(modelStruct.modelPar_NPL*iLE)))?1.0e-6:(1.0+(modelStruct.modelPar_NPL*iLE))));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CTLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CTLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CT_p_dX = (((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*((modelStruct.modelPar_CTLW*iLE)*d_iWE_dX+(modelStruct.modelPar_CTLW*d_iLE_dX+modelStruct.d_modelPar_CTLW_dX*iLE)*iWE)+((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(modelStruct.modelPar_CTW*d_iWE_dX+modelStruct.d_modelPar_CTW_dX*iWE)+(modelStruct.d_modelPar_CTO_dX+(modelStruct.modelPar_CTL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CTLEXP_dX)))+modelStruct.d_modelPar_CTL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*(1.0+((modelStruct.modelPar_CTLW*iLE)*iWE)));
CT_p = (((modelStruct.modelPar_CTO+(modelStruct.modelPar_CTL*value_pow_0))*(1.0+(modelStruct.modelPar_CTW*iWE)))*(1.0+((modelStruct.modelPar_CTLW*iLE)*iWE)));
}
d_TOXOV_p_dX = modelStruct.d_modelPar_TOXOVO_dX;
TOXOV_p = modelStruct.modelPar_TOXOVO;
d_TOXOVD_p_dX = modelStruct.d_modelPar_TOXOVDO_dX;
TOXOVD_p = modelStruct.modelPar_TOXOVDO;
d_NOV_p_dX = modelStruct.d_modelPar_NOVO_dX;
NOV_p = modelStruct.modelPar_NOVO;
d_NOVD_p_dX = modelStruct.d_modelPar_NOVDO_dX;
NOVD_p = modelStruct.modelPar_NOVDO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CFLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CFLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CF_p_dX = ((modelStruct.modelPar_CFL*value_pow_0)*(modelStruct.modelPar_CFW*d_iWE_dX+modelStruct.d_modelPar_CFW_dX*iWE)+(modelStruct.modelPar_CFL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CFLEXP_dX)))+modelStruct.d_modelPar_CFL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE)));
CF_p = ((modelStruct.modelPar_CFL*value_pow_0)*(1.0+(modelStruct.modelPar_CFW*iWE)));
}
d_CFD_p_dX = modelStruct.d_modelPar_CFDO_dX;
CFD_p = modelStruct.modelPar_CFDO;
d_CFB_p_dX = modelStruct.d_modelPar_CFBO_dX;
CFB_p = modelStruct.modelPar_CFBO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_PSCELEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PSCELEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_PSCE_p_dX = ((modelStruct.modelPar_PSCEL*value_pow_0)*(modelStruct.modelPar_PSCEW*d_iWE_dX+modelStruct.d_modelPar_PSCEW_dX*iWE)+(modelStruct.modelPar_PSCEL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PSCELEXP_dX)))+modelStruct.d_modelPar_PSCEL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEW*iWE)));
PSCE_p = ((modelStruct.modelPar_PSCEL*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEW*iWE)));
}
d_PSCED_p_dX = modelStruct.d_modelPar_PSCEDO_dX;
PSCED_p = modelStruct.modelPar_PSCEDO;
d_PSCEB_p_dX = modelStruct.d_modelPar_PSCEBO_dX;
PSCEB_p = modelStruct.modelPar_PSCEBO;
d_FBET1e_dX = (modelStruct.modelPar_FBET1*(modelStruct.modelPar_FBET1W*d_iWE_dX+modelStruct.d_modelPar_FBET1W_dX*iWE)+modelStruct.d_modelPar_FBET1_dX*(1.0+(modelStruct.modelPar_FBET1W*iWE)));
FBET1e = (modelStruct.modelPar_FBET1*(1.0+(modelStruct.modelPar_FBET1W*iWE)));
d_LP1e_dX = (modelStruct.modelVar_LP1_i*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0e-03)?(modelStruct.modelPar_LP1W*d_iWE_dX+modelStruct.d_modelPar_LP1W_dX*iWE):0.0)+modelStruct.d_modelVar_LP1_i_dX*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0e-03)?(1.0+(modelStruct.modelPar_LP1W*iWE)):1.0e-03));
LP1e = (modelStruct.modelVar_LP1_i*(((1.0+(modelStruct.modelPar_LP1W*iWE))>1.0e-03)?(1.0+(modelStruct.modelPar_LP1W*iWE)):1.0e-03));
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_LE)/LP1e));
double value_exp_1 = exp(((-instanceStruct.instanceVar_LE)/modelStruct.modelVar_LP2_i));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_GPE_dX = ((((FBET1e*LP1e)/instanceStruct.instanceVar_LE)*(-deriv_exp_0_d0*(((LP1e*(-instanceStruct.d_instanceVar_LE_dX)-(-instanceStruct.instanceVar_LE)*d_LP1e_dX)/LP1e/LP1e)))+((instanceStruct.instanceVar_LE*(FBET1e*d_LP1e_dX+d_FBET1e_dX*LP1e)-(FBET1e*LP1e)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(1.0-value_exp_0))+(((modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)/instanceStruct.instanceVar_LE)*(-deriv_exp_1_d0*(((modelStruct.modelVar_LP2_i*(-instanceStruct.d_instanceVar_LE_dX)-(-instanceStruct.instanceVar_LE)*modelStruct.d_modelVar_LP2_i_dX)/modelStruct.modelVar_LP2_i/modelStruct.modelVar_LP2_i)))+((instanceStruct.instanceVar_LE*(modelStruct.modelPar_FBET2*modelStruct.d_modelVar_LP2_i_dX+modelStruct.d_modelPar_FBET2_dX*modelStruct.modelVar_LP2_i)-(modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(1.0-value_exp_1)));
GPE = ((1.0+(((FBET1e*LP1e)/instanceStruct.instanceVar_LE)*(1.0-value_exp_0)))+(((modelStruct.modelPar_FBET2*modelStruct.modelVar_LP2_i)/instanceStruct.instanceVar_LE)*(1.0-value_exp_1)));
}
d_GPE_dX = ((GPE>1.0e-15)?d_GPE_dX:0.0);
GPE = ((GPE>1.0e-15)?GPE:1.0e-15);
{
double value_log_0 = log((1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WBET_i)));
double  deriv_log_0_d0 = (1.0/(1.0+(instanceStruct.instanceVar_WE/modelStruct.modelVar_WBET_i)));
d_GWE_dX = ((modelStruct.modelPar_BETW1*d_iWE_dX+modelStruct.d_modelPar_BETW1_dX*iWE)+((modelStruct.modelPar_BETW2*iWE)*deriv_log_0_d0*(((modelStruct.modelVar_WBET_i*instanceStruct.d_instanceVar_WE_dX-instanceStruct.instanceVar_WE*modelStruct.d_modelVar_WBET_i_dX)/modelStruct.modelVar_WBET_i/modelStruct.modelVar_WBET_i))+(modelStruct.modelPar_BETW2*d_iWE_dX+modelStruct.d_modelPar_BETW2_dX*iWE)*value_log_0));
GWE = ((1.0+(modelStruct.modelPar_BETW1*iWE))+((modelStruct.modelPar_BETW2*iWE)*value_log_0));
}
d_BETN_p_dX = (((modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)/(GPE*instanceStruct.instanceVar_LE))*d_GWE_dX+(((GPE*instanceStruct.instanceVar_LE)*(modelStruct.modelPar_UO*instanceStruct.d_instanceVar_WE_dX+modelStruct.d_modelPar_UO_dX*instanceStruct.instanceVar_WE)-(modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)*(GPE*instanceStruct.d_instanceVar_LE_dX+d_GPE_dX*instanceStruct.instanceVar_LE))/(GPE*instanceStruct.instanceVar_LE)/(GPE*instanceStruct.instanceVar_LE))*GWE);
BETN_p = (((modelStruct.modelPar_UO*instanceStruct.instanceVar_WE)/(GPE*instanceStruct.instanceVar_LE))*GWE);
d_STBET_p_dX = (((modelStruct.d_modelPar_STBETO_dX+(modelStruct.modelPar_STBETL*d_iLE_dX+modelStruct.d_modelPar_STBETL_dX*iLE))+(modelStruct.modelPar_STBETW*d_iWE_dX+modelStruct.d_modelPar_STBETW_dX*iWE))+((modelStruct.modelPar_STBETLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STBETLW*d_iLE_dX+modelStruct.d_modelPar_STBETLW_dX*iLE)*iWE));
STBET_p = (((modelStruct.modelPar_STBETO+(modelStruct.modelPar_STBETL*iLE))+(modelStruct.modelPar_STBETW*iWE))+((modelStruct.modelPar_STBETLW*iLE)*iWE));
d_MUE_p_dX = (modelStruct.modelPar_MUEO*(modelStruct.modelPar_MUEW*d_iWE_dX+modelStruct.d_modelPar_MUEW_dX*iWE)+modelStruct.d_modelPar_MUEO_dX*(1.0+(modelStruct.modelPar_MUEW*iWE)));
MUE_p = (modelStruct.modelPar_MUEO*(1.0+(modelStruct.modelPar_MUEW*iWE)));
d_STMUE_p_dX = modelStruct.d_modelPar_STMUEO_dX;
STMUE_p = modelStruct.modelPar_STMUEO;
d_THEMU_p_dX = modelStruct.d_modelPar_THEMUO_dX;
THEMU_p = modelStruct.modelPar_THEMUO;
d_STTHEMU_p_dX = modelStruct.d_modelPar_STTHEMUO_dX;
STTHEMU_p = modelStruct.modelPar_STTHEMUO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CSLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CSLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CS_p_dX = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*((modelStruct.modelPar_CSLW*iLE)*d_iWE_dX+(modelStruct.modelPar_CSLW*d_iLE_dX+modelStruct.d_modelPar_CSLW_dX*iLE)*iWE)+((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(modelStruct.modelPar_CSW*d_iWE_dX+modelStruct.d_modelPar_CSW_dX*iWE)+(modelStruct.d_modelPar_CSO_dX+(modelStruct.modelPar_CSL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CSLEXP_dX)))+modelStruct.d_modelPar_CSL_dX*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+((modelStruct.modelPar_CSLW*iLE)*iWE)));
CS_p = (((modelStruct.modelPar_CSO+(modelStruct.modelPar_CSL*value_pow_0))*(1.0+(modelStruct.modelPar_CSW*iWE)))*(1.0+((modelStruct.modelPar_CSLW*iLE)*iWE)));
}
d_STCS_p_dX = modelStruct.d_modelPar_STCSO_dX;
STCS_p = modelStruct.modelPar_STCSO;
d_XCOR_p_dX = (((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*((modelStruct.modelPar_XCORLW*iLE)*d_iWE_dX+(modelStruct.modelPar_XCORLW*d_iLE_dX+modelStruct.d_modelPar_XCORLW_dX*iLE)*iWE)+((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(modelStruct.modelPar_XCORW*d_iWE_dX+modelStruct.d_modelPar_XCORW_dX*iWE)+(modelStruct.modelPar_XCORO*(modelStruct.modelPar_XCORL*d_iLE_dX+modelStruct.d_modelPar_XCORL_dX*iLE)+modelStruct.d_modelPar_XCORO_dX*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+((modelStruct.modelPar_XCORLW*iLE)*iWE)));
XCOR_p = (((modelStruct.modelPar_XCORO*(1.0+(modelStruct.modelPar_XCORL*iLE)))*(1.0+(modelStruct.modelPar_XCORW*iWE)))*(1.0+((modelStruct.modelPar_XCORLW*iLE)*iWE)));
d_STXCOR_p_dX = modelStruct.d_modelPar_STXCORO_dX;
STXCOR_p = modelStruct.modelPar_STXCORO;
d_FETA_p_dX = modelStruct.d_modelPar_FETAO_dX;
FETA_p = modelStruct.modelPar_FETAO;
d_RS_p_dX = ((modelStruct.modelPar_RSW1*iWE)*(modelStruct.modelPar_RSW2*d_iWE_dX+modelStruct.d_modelPar_RSW2_dX*iWE)+(modelStruct.modelPar_RSW1*d_iWE_dX+modelStruct.d_modelPar_RSW1_dX*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
RS_p = ((modelStruct.modelPar_RSW1*iWE)*(1.0+(modelStruct.modelPar_RSW2*iWE)));
d_STRS_p_dX = modelStruct.d_modelPar_STRSO_dX;
STRS_p = modelStruct.modelPar_STRSO;
d_RSB_p_dX = modelStruct.d_modelPar_RSBO_dX;
RSB_p = modelStruct.modelPar_RSBO;
d_RSG_p_dX = modelStruct.d_modelPar_RSGO_dX;
RSG_p = modelStruct.modelPar_RSGO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_THESATLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_THESATLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_THESAT_p_dX = (((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*((modelStruct.modelPar_THESATLW*iLE)*d_iWE_dX+(modelStruct.modelPar_THESATLW*d_iLE_dX+modelStruct.d_modelPar_THESATLW_dX*iLE)*iWE)+((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(modelStruct.modelPar_THESATW*d_iWE_dX+modelStruct.d_modelPar_THESATW_dX*iWE)+(modelStruct.d_modelPar_THESATO_dX+(((modelStruct.modelPar_THESATL*GWE)/GPE)*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_THESATLEXP_dX)))+((GPE*(modelStruct.modelPar_THESATL*d_GWE_dX+modelStruct.d_modelPar_THESATL_dX*GWE)-(modelStruct.modelPar_THESATL*GWE)*d_GPE_dX)/GPE/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+((modelStruct.modelPar_THESATLW*iLE)*iWE)));
THESAT_p = (((modelStruct.modelPar_THESATO+(((modelStruct.modelPar_THESATL*GWE)/GPE)*value_pow_0))*(1.0+(modelStruct.modelPar_THESATW*iWE)))*(1.0+((modelStruct.modelPar_THESATLW*iLE)*iWE)));
}
d_STTHESAT_p_dX = (((modelStruct.d_modelPar_STTHESATO_dX+(modelStruct.modelPar_STTHESATL*d_iLE_dX+modelStruct.d_modelPar_STTHESATL_dX*iLE))+(modelStruct.modelPar_STTHESATW*d_iWE_dX+modelStruct.d_modelPar_STTHESATW_dX*iWE))+((modelStruct.modelPar_STTHESATLW*iLE)*d_iWE_dX+(modelStruct.modelPar_STTHESATLW*d_iLE_dX+modelStruct.d_modelPar_STTHESATLW_dX*iLE)*iWE));
STTHESAT_p = (((modelStruct.modelPar_STTHESATO+(modelStruct.modelPar_STTHESATL*iLE))+(modelStruct.modelPar_STTHESATW*iWE))+((modelStruct.modelPar_STTHESATLW*iLE)*iWE));
d_THESATB_p_dX = modelStruct.d_modelPar_THESATBO_dX;
THESATB_p = modelStruct.modelPar_THESATBO;
d_THESATG_p_dX = modelStruct.d_modelPar_THESATGO_dX;
THESATG_p = modelStruct.modelPar_THESATGO;
d_AX_p_dX = (((1.0+(modelStruct.modelVar_AXL_i*iLE))*modelStruct.d_modelPar_AXO_dX-modelStruct.modelPar_AXO*(modelStruct.modelVar_AXL_i*d_iLE_dX+modelStruct.d_modelVar_AXL_i_dX*iLE))/(1.0+(modelStruct.modelVar_AXL_i*iLE))/(1.0+(modelStruct.modelVar_AXL_i*iLE)));
AX_p = (modelStruct.modelPar_AXO/(1.0+(modelStruct.modelVar_AXL_i*iLE)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALPLEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPLEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_ALP_p_dX = ((modelStruct.modelPar_ALPL*value_pow_0)*(modelStruct.modelPar_ALPW*d_iWE_dX+modelStruct.d_modelPar_ALPW_dX*iWE)+(modelStruct.modelPar_ALPL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPLEXP_dX)))+modelStruct.d_modelPar_ALPL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)));
ALP_p = ((modelStruct.modelPar_ALPL*value_pow_0)*(1.0+(modelStruct.modelPar_ALPW*iWE)));
}
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALP1LEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALP1LEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_tmpx_dX = ((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALP1LEXP_dX)));
tmpx = value_pow_0;
}
d_ALP1_p_dX = (((1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx))*((modelStruct.modelPar_ALP1L1*tmpx)*(modelStruct.modelPar_ALP1W*d_iWE_dX+modelStruct.d_modelPar_ALP1W_dX*iWE)+(modelStruct.modelPar_ALP1L1*d_tmpx_dX+modelStruct.d_modelPar_ALP1L1_dX*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))-((modelStruct.modelPar_ALP1L1*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))*((modelStruct.modelVar_ALP1L2_i*iLE)*d_tmpx_dX+(modelStruct.modelVar_ALP1L2_i*d_iLE_dX+modelStruct.d_modelVar_ALP1L2_i_dX*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx)));
ALP1_p = (((modelStruct.modelPar_ALP1L1*tmpx)*(1.0+(modelStruct.modelPar_ALP1W*iWE)))/(1.0+((modelStruct.modelVar_ALP1L2_i*iLE)*tmpx)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_ALP2LEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALP2LEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_tmpx_dX = ((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALP2LEXP_dX)));
tmpx = value_pow_0;
}
d_ALP2_p_dX = (((1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx))*((modelStruct.modelPar_ALP2L1*tmpx)*(modelStruct.modelPar_ALP2W*d_iWE_dX+modelStruct.d_modelPar_ALP2W_dX*iWE)+(modelStruct.modelPar_ALP2L1*d_tmpx_dX+modelStruct.d_modelPar_ALP2L1_dX*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))-((modelStruct.modelPar_ALP2L1*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))*((modelStruct.modelVar_ALP2L2_i*iLE)*d_tmpx_dX+(modelStruct.modelVar_ALP2L2_i*d_iLE_dX+modelStruct.d_modelVar_ALP2L2_i_dX*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx)));
ALP2_p = (((modelStruct.modelPar_ALP2L1*tmpx)*(1.0+(modelStruct.modelPar_ALP2W*iWE)))/(1.0+((modelStruct.modelVar_ALP2L2_i*iLE)*tmpx)));
d_VP_p_dX = modelStruct.d_modelPar_VPO_dX;
VP_p = modelStruct.modelPar_VPO;
d_A1_p_dX = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(modelStruct.modelPar_A1W*d_iWE_dX+modelStruct.d_modelPar_A1W_dX*iWE)+(modelStruct.modelPar_A1O*(modelStruct.modelPar_A1L*d_iLE_dX+modelStruct.d_modelPar_A1L_dX*iLE)+modelStruct.d_modelPar_A1O_dX*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
A1_p = ((modelStruct.modelPar_A1O*(1.0+(modelStruct.modelPar_A1L*iLE)))*(1.0+(modelStruct.modelPar_A1W*iWE)));
d_A2_p_dX = modelStruct.d_modelPar_A2O_dX;
A2_p = modelStruct.modelPar_A2O;
d_STA2_p_dX = modelStruct.d_modelPar_STA2O_dX;
STA2_p = modelStruct.modelPar_STA2O;
d_A3_p_dX = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(modelStruct.modelPar_A3W*d_iWE_dX+modelStruct.d_modelPar_A3W_dX*iWE)+(modelStruct.modelPar_A3O*(modelStruct.modelPar_A3L*d_iLE_dX+modelStruct.d_modelPar_A3L_dX*iLE)+modelStruct.d_modelPar_A3O_dX*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
A3_p = ((modelStruct.modelPar_A3O*(1.0+(modelStruct.modelPar_A3L*iLE)))*(1.0+(modelStruct.modelPar_A3W*iWE)));
d_A4_p_dX = ((modelStruct.modelPar_A4O*(1.0+(modelStruct.modelPar_A4L*iLE)))*(modelStruct.modelPar_A4W*d_iWE_dX+modelStruct.d_modelPar_A4W_dX*iWE)+(modelStruct.modelPar_A4O*(modelStruct.modelPar_A4L*d_iLE_dX+modelStruct.d_modelPar_A4L_dX*iLE)+modelStruct.d_modelPar_A4O_dX*(1.0+(modelStruct.modelPar_A4L*iLE)))*(1.0+(modelStruct.modelPar_A4W*iWE)));
A4_p = ((modelStruct.modelPar_A4O*(1.0+(modelStruct.modelPar_A4L*iLE)))*(1.0+(modelStruct.modelPar_A4W*iWE)));
d_GCO_p_dX = modelStruct.d_modelPar_GCOO_dX;
GCO_p = modelStruct.modelPar_GCOO;
d_IGINV_p_dX = (((iWE*iLE)*modelStruct.d_modelPar_IGINVLW_dX-modelStruct.modelPar_IGINVLW*(iWE*d_iLE_dX+d_iWE_dX*iLE))/(iWE*iLE)/(iWE*iLE));
IGINV_p = (modelStruct.modelPar_IGINVLW/(iWE*iLE));
d_IGOV_p_dX = (((1.0e-6*iWE)*(modelStruct.modelPar_IGOVW*modelStruct.d_modelVar_LOV_i_dX+modelStruct.d_modelPar_IGOVW_dX*modelStruct.modelVar_LOV_i)-(modelStruct.modelPar_IGOVW*modelStruct.modelVar_LOV_i)*1.0e-6*d_iWE_dX)/(1.0e-6*iWE)/(1.0e-6*iWE));
IGOV_p = ((modelStruct.modelPar_IGOVW*modelStruct.modelVar_LOV_i)/(1.0e-6*iWE));
d_IGOVD_p_dX = (((1.0e-6*iWE)*(modelStruct.modelPar_IGOVDW*modelStruct.d_modelVar_LOVD_i_dX+modelStruct.d_modelPar_IGOVDW_dX*modelStruct.modelVar_LOVD_i)-(modelStruct.modelPar_IGOVDW*modelStruct.modelVar_LOVD_i)*1.0e-6*d_iWE_dX)/(1.0e-6*iWE)/(1.0e-6*iWE));
IGOVD_p = ((modelStruct.modelPar_IGOVDW*modelStruct.modelVar_LOVD_i)/(1.0e-6*iWE));
d_STIG_p_dX = modelStruct.d_modelPar_STIGO_dX;
STIG_p = modelStruct.modelPar_STIGO;
d_GC2_p_dX = modelStruct.d_modelPar_GC2O_dX;
GC2_p = modelStruct.modelPar_GC2O;
d_GC3_p_dX = modelStruct.d_modelPar_GC3O_dX;
GC3_p = modelStruct.modelPar_GC3O;
d_CHIB_p_dX = modelStruct.d_modelPar_CHIBO_dX;
CHIB_p = modelStruct.modelPar_CHIBO;
d_AGIDL_p_dX = (((1.0e-6*iWE)*(modelStruct.modelPar_AGIDLW*modelStruct.d_modelVar_LOV_i_dX+modelStruct.d_modelPar_AGIDLW_dX*modelStruct.modelVar_LOV_i)-(modelStruct.modelPar_AGIDLW*modelStruct.modelVar_LOV_i)*1.0e-6*d_iWE_dX)/(1.0e-6*iWE)/(1.0e-6*iWE));
AGIDL_p = ((modelStruct.modelPar_AGIDLW*modelStruct.modelVar_LOV_i)/(1.0e-6*iWE));
d_AGIDLD_p_dX = (((1.0e-6*iWE)*(modelStruct.modelPar_AGIDLDW*modelStruct.d_modelVar_LOVD_i_dX+modelStruct.d_modelPar_AGIDLDW_dX*modelStruct.modelVar_LOVD_i)-(modelStruct.modelPar_AGIDLDW*modelStruct.modelVar_LOVD_i)*1.0e-6*d_iWE_dX)/(1.0e-6*iWE)/(1.0e-6*iWE));
AGIDLD_p = ((modelStruct.modelPar_AGIDLDW*modelStruct.modelVar_LOVD_i)/(1.0e-6*iWE));
d_BGIDL_p_dX = modelStruct.d_modelPar_BGIDLO_dX;
BGIDL_p = modelStruct.modelPar_BGIDLO;
d_BGIDLD_p_dX = modelStruct.d_modelPar_BGIDLDO_dX;
BGIDLD_p = modelStruct.modelPar_BGIDLDO;
d_STBGIDL_p_dX = modelStruct.d_modelPar_STBGIDLO_dX;
STBGIDL_p = modelStruct.modelPar_STBGIDLO;
d_STBGIDLD_p_dX = modelStruct.d_modelPar_STBGIDLDO_dX;
STBGIDLD_p = modelStruct.modelPar_STBGIDLDO;
d_CGIDL_p_dX = modelStruct.d_modelPar_CGIDLO_dX;
CGIDL_p = modelStruct.modelPar_CGIDLO;
d_CGIDLD_p_dX = modelStruct.d_modelPar_CGIDLDO_dX;
CGIDLD_p = modelStruct.modelPar_CGIDLDO;
d_COX_p_dX = ((modelStruct.modelVar_TOXO_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*d_LEcv_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROXO_i_dX*WEcv)*LEcv)-(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*LEcv)*modelStruct.d_modelVar_TOXO_i_dX)/modelStruct.modelVar_TOXO_i/modelStruct.modelVar_TOXO_i);
COX_p = ((((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*LEcv)/modelStruct.modelVar_TOXO_i);
d_CGOV_p_dX = ((modelStruct.modelVar_TOXOVO_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.d_modelVar_LOV_i_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROXO_i_dX*WEcv)*modelStruct.modelVar_LOV_i)-(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.modelVar_LOV_i)*modelStruct.d_modelVar_TOXOVO_i_dX)/modelStruct.modelVar_TOXOVO_i/modelStruct.modelVar_TOXOVO_i);
CGOV_p = ((((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.modelVar_LOV_i)/modelStruct.modelVar_TOXOVO_i);
d_CGOVD_p_dX = ((modelStruct.modelVar_TOXOVDO_i*(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.d_modelVar_LOVD_i_dX+((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*d_WEcv_dX+8.8541878176E-12*modelStruct.d_modelVar_EPSROXO_i_dX*WEcv)*modelStruct.modelVar_LOVD_i)-(((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.modelVar_LOVD_i)*modelStruct.d_modelVar_TOXOVDO_i_dX)/modelStruct.modelVar_TOXOVDO_i/modelStruct.modelVar_TOXOVDO_i);
CGOVD_p = ((((8.8541878176E-12*modelStruct.modelVar_EPSROXO_i)*WEcv)*modelStruct.modelVar_LOVD_i)/modelStruct.modelVar_TOXOVDO_i);
d_CGBOV_p_dX = ((modelStruct.modelPar_CGBOVL*d_Lcv_dX+modelStruct.d_modelPar_CGBOVL_dX*Lcv)/1.0e-6);
CGBOV_p = ((modelStruct.modelPar_CGBOVL*Lcv)/1.0e-6);
d_CFR_p_dX = ((modelStruct.modelPar_CFRW*d_Wcv_dX+modelStruct.d_modelPar_CFRW_dX*Wcv)/1.0e-6);
CFR_p = ((modelStruct.modelPar_CFRW*Wcv)/1.0e-6);
d_CFRD_p_dX = ((modelStruct.modelPar_CFRDW*d_Wcv_dX+modelStruct.d_modelPar_CFRDW_dX*Wcv)/1.0e-6);
CFRD_p = ((modelStruct.modelPar_CFRDW*Wcv)/1.0e-6);
d_temp0_dX = (-(((2.0*modelStruct.modelPar_LINTNOI)*d_iLE_dX+2.0*modelStruct.d_modelPar_LINTNOI_dX*iLE)/1.0e-6));
temp0 = (1.0-(((2.0*modelStruct.modelPar_LINTNOI)*iLE)/1.0e-6));
d_Lnoi_dX = ((temp0>1.0e-3)?d_temp0_dX:0.0);
Lnoi = ((temp0>1.0e-3)?temp0:1.0e-3);
{
double value_pow_0 = pow(Lnoi,modelStruct.modelPar_ALPNOI);
double  deriv_pow_0_d0 = ((Lnoi == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_ALPNOI/Lnoi));
double  deriv_pow_0_d1 = (Lnoi == 0.0)?0.0:(log(Lnoi)*value_pow_0);
d_Lred_dX = (-((deriv_pow_0_d0*(d_Lnoi_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_ALPNOI_dX)))/value_pow_0/value_pow_0);
Lred = (1.0/value_pow_0);
}
d_FNT_p_dX = modelStruct.d_modelPar_FNTO_dX;
FNT_p = modelStruct.modelPar_FNTO;
d_FNTEXC_p_dX = ((((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*d_iWE_dX+(((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*d_iWE_dX+((modelStruct.modelPar_FNTEXCL*BETN_p)*d_BETN_p_dX+(modelStruct.modelPar_FNTEXCL*d_BETN_p_dX+modelStruct.d_modelPar_FNTEXCL_dX*BETN_p)*BETN_p)*iWE)*iWE);
FNTEXC_p = ((((modelStruct.modelPar_FNTEXCL*BETN_p)*BETN_p)*iWE)*iWE);
d_NFA_p_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFALW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFALW);
NFA_p = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFALW);
d_NFB_p_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFBLW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFBLW);
NFB_p = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFBLW);
d_NFC_p_dX = (((Lred*iWE)*iLE)*modelStruct.d_modelPar_NFCLW_dX+((Lred*iWE)*d_iLE_dX+(Lred*d_iWE_dX+d_Lred_dX*iWE)*iLE)*modelStruct.modelPar_NFCLW);
NFC_p = (((Lred*iWE)*iLE)*modelStruct.modelPar_NFCLW);
d_EF_p_dX = modelStruct.d_modelPar_EFO_dX;
EF_p = modelStruct.modelPar_EFO;
d_WE_edge_dX = (2.0*modelStruct.d_modelPar_WEDGE_dX+(modelStruct.modelPar_WEDGEW*instanceStruct.d_instanceVar_WE_dX+modelStruct.d_modelPar_WEDGEW_dX*instanceStruct.instanceVar_WE));
WE_edge = ((2.0*modelStruct.modelPar_WEDGE)+(modelStruct.modelPar_WEDGEW*instanceStruct.instanceVar_WE));
d_iWE_edge_dX = (-1.0e-6*d_WE_edge_dX/WE_edge/WE_edge);
iWE_edge = (1.0e-6/WE_edge);
d_VFBEDGE_p_dX = modelStruct.d_modelPar_VFBEDGEO_dX;
VFBEDGE_p = modelStruct.modelPar_VFBEDGEO;
d_STVFBEDGE_p_dX = (((modelStruct.d_modelPar_STVFBEDGEO_dX+(modelStruct.modelPar_STVFBEDGEL*d_iLE_dX+modelStruct.d_modelPar_STVFBEDGEL_dX*iLE))+(modelStruct.modelPar_STVFBEDGEW*d_iWE_dX+modelStruct.d_modelPar_STVFBEDGEW_dX*iWE))+((modelStruct.modelPar_STVFBEDGELW*iLE)*d_iWE_dX+(modelStruct.modelPar_STVFBEDGELW*d_iLE_dX+modelStruct.d_modelPar_STVFBEDGELW_dX*iLE)*iWE));
STVFBEDGE_p = (((modelStruct.modelPar_STVFBEDGEO+(modelStruct.modelPar_STVFBEDGEL*iLE))+(modelStruct.modelPar_STVFBEDGEW*iWE))+((modelStruct.modelPar_STVFBEDGELW*iLE)*iWE));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_DPHIBEDGELEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_DPHIBEDGELEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_DPHIBEDGE_p_dX = (((modelStruct.d_modelPar_DPHIBEDGEO_dX+(modelStruct.modelPar_DPHIBEDGEL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_DPHIBEDGELEXP_dX)))+modelStruct.d_modelPar_DPHIBEDGEL_dX*value_pow_0))+(modelStruct.modelPar_DPHIBEDGEW*d_iWE_dX+modelStruct.d_modelPar_DPHIBEDGEW_dX*iWE))+((modelStruct.modelPar_DPHIBEDGELW*iLE)*d_iWE_dX+(modelStruct.modelPar_DPHIBEDGELW*d_iLE_dX+modelStruct.d_modelPar_DPHIBEDGELW_dX*iLE)*iWE));
DPHIBEDGE_p = (((modelStruct.modelPar_DPHIBEDGEO+(modelStruct.modelPar_DPHIBEDGEL*value_pow_0))+(modelStruct.modelPar_DPHIBEDGEW*iWE))+((modelStruct.modelPar_DPHIBEDGELW*iLE)*iWE));
}
d_NEFFEDGE_p_dX = (((modelStruct.modelVar_NSUBEDGEO_i*(1.0+(modelStruct.modelPar_NSUBEDGEL*iLE)))*(1.0+(modelStruct.modelPar_NSUBEDGEW*iWE)))*((modelStruct.modelPar_NSUBEDGELW*iLE)*d_iWE_dX+(modelStruct.modelPar_NSUBEDGELW*d_iLE_dX+modelStruct.d_modelPar_NSUBEDGELW_dX*iLE)*iWE)+((modelStruct.modelVar_NSUBEDGEO_i*(1.0+(modelStruct.modelPar_NSUBEDGEL*iLE)))*(modelStruct.modelPar_NSUBEDGEW*d_iWE_dX+modelStruct.d_modelPar_NSUBEDGEW_dX*iWE)+(modelStruct.modelVar_NSUBEDGEO_i*(modelStruct.modelPar_NSUBEDGEL*d_iLE_dX+modelStruct.d_modelPar_NSUBEDGEL_dX*iLE)+modelStruct.d_modelVar_NSUBEDGEO_i_dX*(1.0+(modelStruct.modelPar_NSUBEDGEL*iLE)))*(1.0+(modelStruct.modelPar_NSUBEDGEW*iWE)))*(1.0+((modelStruct.modelPar_NSUBEDGELW*iLE)*iWE)));
NEFFEDGE_p = (((modelStruct.modelVar_NSUBEDGEO_i*(1.0+(modelStruct.modelPar_NSUBEDGEL*iLE)))*(1.0+(modelStruct.modelPar_NSUBEDGEW*iWE)))*(1.0+((modelStruct.modelPar_NSUBEDGELW*iLE)*iWE)));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CTEDGELEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CTEDGELEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CTEDGE_p_dX = (modelStruct.d_modelPar_CTEDGEO_dX+(modelStruct.modelPar_CTEDGEL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CTEDGELEXP_dX)))+modelStruct.d_modelPar_CTEDGEL_dX*value_pow_0));
CTEDGE_p = (modelStruct.modelPar_CTEDGEO+(modelStruct.modelPar_CTEDGEL*value_pow_0));
}
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_LE)/modelStruct.modelVar_LPEDGE_i));
double  deriv_exp_0_d0 = value_exp_0;
d_GPE_edge_dX = (((modelStruct.modelPar_FBETEDGE*modelStruct.modelVar_LPEDGE_i)/instanceStruct.instanceVar_LE)*(-deriv_exp_0_d0*(((modelStruct.modelVar_LPEDGE_i*(-instanceStruct.d_instanceVar_LE_dX)-(-instanceStruct.instanceVar_LE)*modelStruct.d_modelVar_LPEDGE_i_dX)/modelStruct.modelVar_LPEDGE_i/modelStruct.modelVar_LPEDGE_i)))+((instanceStruct.instanceVar_LE*(modelStruct.modelPar_FBETEDGE*modelStruct.d_modelVar_LPEDGE_i_dX+modelStruct.d_modelPar_FBETEDGE_dX*modelStruct.modelVar_LPEDGE_i)-(modelStruct.modelPar_FBETEDGE*modelStruct.modelVar_LPEDGE_i)*instanceStruct.d_instanceVar_LE_dX)/instanceStruct.instanceVar_LE/instanceStruct.instanceVar_LE)*(1.0-value_exp_0));
GPE_edge = (1.0+(((modelStruct.modelPar_FBETEDGE*modelStruct.modelVar_LPEDGE_i)/instanceStruct.instanceVar_LE)*(1.0-value_exp_0)));
}
d_GPE_edge_dX = ((GPE_edge>1.0e-15)?d_GPE_edge_dX:0.0);
GPE_edge = ((GPE_edge>1.0e-15)?GPE_edge:1.0e-15);
d_BETNEDGE_p_dX = (((modelStruct.modelPar_UO*WE_edge)/(GPE_edge*instanceStruct.instanceVar_LE))*(modelStruct.modelPar_BETEDGEW*d_iWE_dX+modelStruct.d_modelPar_BETEDGEW_dX*iWE)+(((GPE_edge*instanceStruct.instanceVar_LE)*(modelStruct.modelPar_UO*d_WE_edge_dX+modelStruct.d_modelPar_UO_dX*WE_edge)-(modelStruct.modelPar_UO*WE_edge)*(GPE_edge*instanceStruct.d_instanceVar_LE_dX+d_GPE_edge_dX*instanceStruct.instanceVar_LE))/(GPE_edge*instanceStruct.instanceVar_LE)/(GPE_edge*instanceStruct.instanceVar_LE))*(1.0+(modelStruct.modelPar_BETEDGEW*iWE)));
BETNEDGE_p = (((modelStruct.modelPar_UO*WE_edge)/(GPE_edge*instanceStruct.instanceVar_LE))*(1.0+(modelStruct.modelPar_BETEDGEW*iWE)));
d_STBETEDGE_p_dX = (((modelStruct.d_modelPar_STBETEDGEO_dX+(modelStruct.modelPar_STBETEDGEL*d_iLE_dX+modelStruct.d_modelPar_STBETEDGEL_dX*iLE))+(modelStruct.modelPar_STBETEDGEW*d_iWE_dX+modelStruct.d_modelPar_STBETEDGEW_dX*iWE))+((modelStruct.modelPar_STBETEDGELW*iLE)*d_iWE_dX+(modelStruct.modelPar_STBETEDGELW*d_iLE_dX+modelStruct.d_modelPar_STBETEDGELW_dX*iLE)*iWE));
STBETEDGE_p = (((modelStruct.modelPar_STBETEDGEO+(modelStruct.modelPar_STBETEDGEL*iLE))+(modelStruct.modelPar_STBETEDGEW*iWE))+((modelStruct.modelPar_STBETEDGELW*iLE)*iWE));
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_PSCEEDGELEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_PSCEEDGELEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_PSCEEDGE_p_dX = ((modelStruct.modelPar_PSCEEDGEL*value_pow_0)*(modelStruct.modelPar_PSCEEDGEW*d_iWE_dX+modelStruct.d_modelPar_PSCEEDGEW_dX*iWE)+(modelStruct.modelPar_PSCEEDGEL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_PSCEEDGELEXP_dX)))+modelStruct.d_modelPar_PSCEEDGEL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEEDGEW*iWE)));
PSCEEDGE_p = ((modelStruct.modelPar_PSCEEDGEL*value_pow_0)*(1.0+(modelStruct.modelPar_PSCEEDGEW*iWE)));
}
d_PSCEBEDGE_p_dX = modelStruct.d_modelPar_PSCEBEDGEO_dX;
PSCEBEDGE_p = modelStruct.modelPar_PSCEBEDGEO;
d_PSCEDEDGE_p_dX = modelStruct.d_modelPar_PSCEDEDGEO_dX;
PSCEDEDGE_p = modelStruct.modelPar_PSCEDEDGEO;
{
double value_pow_0 = pow(iLE,modelStruct.modelPar_CFEDGELEXP);
double  deriv_pow_0_d0 = ((iLE == 0.0)?0.0:(value_pow_0*modelStruct.modelPar_CFEDGELEXP/iLE));
double  deriv_pow_0_d1 = (iLE == 0.0)?0.0:(log(iLE)*value_pow_0);
d_CFEDGE_p_dX = ((modelStruct.modelPar_CFEDGEL*value_pow_0)*(modelStruct.modelPar_CFEDGEW*d_iWE_dX+modelStruct.d_modelPar_CFEDGEW_dX*iWE)+(modelStruct.modelPar_CFEDGEL*((deriv_pow_0_d0*(d_iLE_dX))+(deriv_pow_0_d1*(modelStruct.d_modelPar_CFEDGELEXP_dX)))+modelStruct.d_modelPar_CFEDGEL_dX*value_pow_0)*(1.0+(modelStruct.modelPar_CFEDGEW*iWE)));
CFEDGE_p = ((modelStruct.modelPar_CFEDGEL*value_pow_0)*(1.0+(modelStruct.modelPar_CFEDGEW*iWE)));
}
d_CFDEDGE_p_dX = modelStruct.d_modelPar_CFDEDGEO_dX;
CFDEDGE_p = modelStruct.modelPar_CFDEDGEO;
d_CFBEDGE_p_dX = modelStruct.d_modelPar_CFBEDGEO_dX;
CFBEDGE_p = modelStruct.modelPar_CFBEDGEO;
d_FNTEDGE_p_dX = modelStruct.d_modelPar_FNTEDGEO_dX;
FNTEDGE_p = modelStruct.modelPar_FNTEDGEO;
d_NFAEDGE_p_dX = ((iWE_edge*iLE)*modelStruct.d_modelPar_NFAEDGELW_dX+(iWE_edge*d_iLE_dX+d_iWE_edge_dX*iLE)*modelStruct.modelPar_NFAEDGELW);
NFAEDGE_p = ((iWE_edge*iLE)*modelStruct.modelPar_NFAEDGELW);
d_NFBEDGE_p_dX = ((iWE_edge*iLE)*modelStruct.d_modelPar_NFBEDGELW_dX+(iWE_edge*d_iLE_dX+d_iWE_edge_dX*iLE)*modelStruct.modelPar_NFBEDGELW);
NFBEDGE_p = ((iWE_edge*iLE)*modelStruct.modelPar_NFBEDGELW);
d_NFCEDGE_p_dX = ((iWE_edge*iLE)*modelStruct.d_modelPar_NFCEDGELW_dX+(iWE_edge*d_iLE_dX+d_iWE_edge_dX*iLE)*modelStruct.modelPar_NFCEDGELW);
NFCEDGE_p = ((iWE_edge*iLE)*modelStruct.modelPar_NFCEDGELW);
d_EFEDGE_p_dX = modelStruct.d_modelPar_EFEDGEO_dX;
EFEDGE_p = modelStruct.modelPar_EFEDGEO;
}
d_KVTHOWE_dX = (((modelStruct.d_modelPar_KVTHOWEO_dX+(modelStruct.modelPar_KVTHOWEL*d_iLE_dX+modelStruct.d_modelPar_KVTHOWEL_dX*iLE))+(modelStruct.modelPar_KVTHOWEW*d_iWE_dX+modelStruct.d_modelPar_KVTHOWEW_dX*iWE))+((modelStruct.modelPar_KVTHOWELW*iLE)*d_iWE_dX+(modelStruct.modelPar_KVTHOWELW*d_iLE_dX+modelStruct.d_modelPar_KVTHOWELW_dX*iLE)*iWE));
KVTHOWE = (((modelStruct.modelPar_KVTHOWEO+(modelStruct.modelPar_KVTHOWEL*iLE))+(modelStruct.modelPar_KVTHOWEW*iWE))+((modelStruct.modelPar_KVTHOWELW*iLE)*iWE));
d_KUOWE_dX = (((modelStruct.d_modelPar_KUOWEO_dX+(modelStruct.modelPar_KUOWEL*d_iLE_dX+modelStruct.d_modelPar_KUOWEL_dX*iLE))+(modelStruct.modelPar_KUOWEW*d_iWE_dX+modelStruct.d_modelPar_KUOWEW_dX*iWE))+((modelStruct.modelPar_KUOWELW*iLE)*d_iWE_dX+(modelStruct.modelPar_KUOWELW*d_iLE_dX+modelStruct.d_modelPar_KUOWELW_dX*iLE)*iWE));
KUOWE = (((modelStruct.modelPar_KUOWEO+(modelStruct.modelPar_KUOWEL*iLE))+(modelStruct.modelPar_KUOWEW*iWE))+((modelStruct.modelPar_KUOWELW*iLE)*iWE));
if ((modelStruct.modelVar_SWGEO_i==2))
{
d_iLEWE_dX = (iLE*d_iWE_dX+d_iLE_dX*iWE);
iLEWE = (iLE*iWE);
d_iiLE_dX = (instanceStruct.d_instanceVar_LE_dX/1.0e-6);
iiLE = (instanceStruct.instanceVar_LE/1.0e-6);
d_iiWE_dX = (instanceStruct.d_instanceVar_WE_dX/1.0e-6);
iiWE = (instanceStruct.instanceVar_WE/1.0e-6);
d_iiLEWE_dX = (iiLE*d_iiWE_dX+d_iiLE_dX*iiWE);
iiLEWE = (iiLE*iiWE);
d_iiiLEWE_dX = ((iiLE*d_iiWE_dX-iiWE*d_iiLE_dX)/iiLE/iiLE);
iiiLEWE = (iiWE/iiLE);
d_iiLEcv_dX = (d_LEcv_dX/1.0e-6);
iiLEcv = (LEcv/1.0e-6);
d_iiWEcv_dX = (d_WEcv_dX/1.0e-6);
iiWEcv = (WEcv/1.0e-6);
d_iiLEWEcv_dX = (iiLEcv*d_iiWEcv_dX+d_iiLEcv_dX*iiWEcv);
iiLEWEcv = (iiLEcv*iiWEcv);
d_iLEcv_dX = (-1.0e-6*d_LEcv_dX/LEcv/LEcv);
iLEcv = (1.0e-6/LEcv);
d_iiiLEWEcv_dX = ((iiLEcv*d_iiWEcv_dX-iiWEcv*d_iiLEcv_dX)/iiLEcv/iiLEcv);
iiiLEWEcv = (iiWEcv/iiLEcv);
d_iiLcv_dX = (d_Lcv_dX/1.0e-6);
iiLcv = (Lcv/1.0e-6);
d_iiWcv_dX = (d_Wcv_dX/1.0e-6);
iiWcv = (Wcv/1.0e-6);
d_iiLWcv_dX = (iiLcv*d_iiWcv_dX+d_iiLcv_dX*iiWcv);
iiLWcv = (iiLcv*iiWcv);
d_iLcv_dX = (-1.0e-6*d_Lcv_dX/Lcv/Lcv);
iLcv = (1.0e-6/Lcv);
d_iiiLWcv_dX = ((iiLcv*d_iiWcv_dX-iiWcv*d_iiLcv_dX)/iiLcv/iiLcv);
iiiLWcv = (iiWcv/iiLcv);
d_VFB_p_dX = (((modelStruct.d_modelPar_POVFB_dX+(iLE*modelStruct.d_modelPar_PLVFB_dX+d_iLE_dX*modelStruct.modelPar_PLVFB))+(iWE*modelStruct.d_modelPar_PWVFB_dX+d_iWE_dX*modelStruct.modelPar_PWVFB))+(iLEWE*modelStruct.d_modelPar_PLWVFB_dX+d_iLEWE_dX*modelStruct.modelPar_PLWVFB));
VFB_p = (((modelStruct.modelPar_POVFB+(iLE*modelStruct.modelPar_PLVFB))+(iWE*modelStruct.modelPar_PWVFB))+(iLEWE*modelStruct.modelPar_PLWVFB));
d_STVFB_p_dX = (((modelStruct.d_modelPar_POSTVFB_dX+(iLE*modelStruct.d_modelPar_PLSTVFB_dX+d_iLE_dX*modelStruct.modelPar_PLSTVFB))+(iWE*modelStruct.d_modelPar_PWSTVFB_dX+d_iWE_dX*modelStruct.modelPar_PWSTVFB))+(iLEWE*modelStruct.d_modelPar_PLWSTVFB_dX+d_iLEWE_dX*modelStruct.modelPar_PLWSTVFB));
STVFB_p = (((modelStruct.modelPar_POSTVFB+(iLE*modelStruct.modelPar_PLSTVFB))+(iWE*modelStruct.modelPar_PWSTVFB))+(iLEWE*modelStruct.modelPar_PLWSTVFB));
d_TOX_p_dX = modelStruct.d_modelPar_POTOX_dX;
TOX_p = modelStruct.modelPar_POTOX;
d_EPSROX_p_dX = modelStruct.d_modelPar_POEPSROX_dX;
EPSROX_p = modelStruct.modelPar_POEPSROX;
d_NEFF_p_dX = (((modelStruct.d_modelPar_PONEFF_dX+(iLE*modelStruct.d_modelPar_PLNEFF_dX+d_iLE_dX*modelStruct.modelPar_PLNEFF))+(iWE*modelStruct.d_modelPar_PWNEFF_dX+d_iWE_dX*modelStruct.modelPar_PWNEFF))+(iLEWE*modelStruct.d_modelPar_PLWNEFF_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNEFF));
NEFF_p = (((modelStruct.modelPar_PONEFF+(iLE*modelStruct.modelPar_PLNEFF))+(iWE*modelStruct.modelPar_PWNEFF))+(iLEWE*modelStruct.modelPar_PLWNEFF));
d_FACNEFFAC_p_dX = (((modelStruct.d_modelPar_POFACNEFFAC_dX+(iLE*modelStruct.d_modelPar_PLFACNEFFAC_dX+d_iLE_dX*modelStruct.modelPar_PLFACNEFFAC))+(iWE*modelStruct.d_modelPar_PWFACNEFFAC_dX+d_iWE_dX*modelStruct.modelPar_PWFACNEFFAC))+(iLEWE*modelStruct.d_modelPar_PLWFACNEFFAC_dX+d_iLEWE_dX*modelStruct.modelPar_PLWFACNEFFAC));
FACNEFFAC_p = (((modelStruct.modelPar_POFACNEFFAC+(iLE*modelStruct.modelPar_PLFACNEFFAC))+(iWE*modelStruct.modelPar_PWFACNEFFAC))+(iLEWE*modelStruct.modelPar_PLWFACNEFFAC));
d_GFACNUD_p_dX = (((modelStruct.d_modelPar_POGFACNUD_dX+(modelStruct.modelPar_PLGFACNUD*d_iLE_dX+modelStruct.d_modelPar_PLGFACNUD_dX*iLE))+(modelStruct.modelPar_PWGFACNUD*d_iWE_dX+modelStruct.d_modelPar_PWGFACNUD_dX*iWE))+((modelStruct.modelPar_PLWGFACNUD*iLE)*d_iWE_dX+(modelStruct.modelPar_PLWGFACNUD*d_iLE_dX+modelStruct.d_modelPar_PLWGFACNUD_dX*iLE)*iWE));
GFACNUD_p = (((modelStruct.modelPar_POGFACNUD+(modelStruct.modelPar_PLGFACNUD*iLE))+(modelStruct.modelPar_PWGFACNUD*iWE))+((modelStruct.modelPar_PLWGFACNUD*iLE)*iWE));
d_VSBNUD_p_dX = modelStruct.d_modelPar_POVSBNUD_dX;
VSBNUD_p = modelStruct.modelPar_POVSBNUD;
d_DVSBNUD_p_dX = modelStruct.d_modelPar_PODVSBNUD_dX;
DVSBNUD_p = modelStruct.modelPar_PODVSBNUD;
d_VNSUB_p_dX = modelStruct.d_modelPar_POVNSUB_dX;
VNSUB_p = modelStruct.modelPar_POVNSUB;
d_NSLP_p_dX = modelStruct.d_modelPar_PONSLP_dX;
NSLP_p = modelStruct.modelPar_PONSLP;
d_DNSUB_p_dX = modelStruct.d_modelPar_PODNSUB_dX;
DNSUB_p = modelStruct.modelPar_PODNSUB;
d_DPHIB_p_dX = (((modelStruct.d_modelPar_PODPHIB_dX+(iLE*modelStruct.d_modelPar_PLDPHIB_dX+d_iLE_dX*modelStruct.modelPar_PLDPHIB))+(iWE*modelStruct.d_modelPar_PWDPHIB_dX+d_iWE_dX*modelStruct.modelPar_PWDPHIB))+(iLEWE*modelStruct.d_modelPar_PLWDPHIB_dX+d_iLEWE_dX*modelStruct.modelPar_PLWDPHIB));
DPHIB_p = (((modelStruct.modelPar_PODPHIB+(iLE*modelStruct.modelPar_PLDPHIB))+(iWE*modelStruct.modelPar_PWDPHIB))+(iLEWE*modelStruct.modelPar_PLWDPHIB));
d_DELVTAC_p_dX = (((modelStruct.d_modelPar_PODELVTAC_dX+(iLE*modelStruct.d_modelPar_PLDELVTAC_dX+d_iLE_dX*modelStruct.modelPar_PLDELVTAC))+(iWE*modelStruct.d_modelPar_PWDELVTAC_dX+d_iWE_dX*modelStruct.modelPar_PWDELVTAC))+(iLEWE*modelStruct.d_modelPar_PLWDELVTAC_dX+d_iLEWE_dX*modelStruct.modelPar_PLWDELVTAC));
DELVTAC_p = (((modelStruct.modelPar_PODELVTAC+(iLE*modelStruct.modelPar_PLDELVTAC))+(iWE*modelStruct.modelPar_PWDELVTAC))+(iLEWE*modelStruct.modelPar_PLWDELVTAC));
d_NP_p_dX = (((modelStruct.d_modelPar_PONP_dX+(iLE*modelStruct.d_modelPar_PLNP_dX+d_iLE_dX*modelStruct.modelPar_PLNP))+(iWE*modelStruct.d_modelPar_PWNP_dX+d_iWE_dX*modelStruct.modelPar_PWNP))+(iLEWE*modelStruct.d_modelPar_PLWNP_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNP));
NP_p = (((modelStruct.modelPar_PONP+(iLE*modelStruct.modelPar_PLNP))+(iWE*modelStruct.modelPar_PWNP))+(iLEWE*modelStruct.modelPar_PLWNP));
d_CT_p_dX = (((modelStruct.d_modelPar_POCT_dX+(iLE*modelStruct.d_modelPar_PLCT_dX+d_iLE_dX*modelStruct.modelPar_PLCT))+(iWE*modelStruct.d_modelPar_PWCT_dX+d_iWE_dX*modelStruct.modelPar_PWCT))+(iLEWE*modelStruct.d_modelPar_PLWCT_dX+d_iLEWE_dX*modelStruct.modelPar_PLWCT));
CT_p = (((modelStruct.modelPar_POCT+(iLE*modelStruct.modelPar_PLCT))+(iWE*modelStruct.modelPar_PWCT))+(iLEWE*modelStruct.modelPar_PLWCT));
d_TOXOV_p_dX = modelStruct.d_modelPar_POTOXOV_dX;
TOXOV_p = modelStruct.modelPar_POTOXOV;
d_TOXOVD_p_dX = modelStruct.d_modelPar_POTOXOVD_dX;
TOXOVD_p = modelStruct.modelPar_POTOXOVD;
d_NOV_p_dX = (((modelStruct.d_modelPar_PONOV_dX+(iLE*modelStruct.d_modelPar_PLNOV_dX+d_iLE_dX*modelStruct.modelPar_PLNOV))+(iWE*modelStruct.d_modelPar_PWNOV_dX+d_iWE_dX*modelStruct.modelPar_PWNOV))+(iLEWE*modelStruct.d_modelPar_PLWNOV_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNOV));
NOV_p = (((modelStruct.modelPar_PONOV+(iLE*modelStruct.modelPar_PLNOV))+(iWE*modelStruct.modelPar_PWNOV))+(iLEWE*modelStruct.modelPar_PLWNOV));
d_NOVD_p_dX = (((modelStruct.d_modelPar_PONOVD_dX+(iLE*modelStruct.d_modelPar_PLNOVD_dX+d_iLE_dX*modelStruct.modelPar_PLNOVD))+(iWE*modelStruct.d_modelPar_PWNOVD_dX+d_iWE_dX*modelStruct.modelPar_PWNOVD))+(iLEWE*modelStruct.d_modelPar_PLWNOVD_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNOVD));
NOVD_p = (((modelStruct.modelPar_PONOVD+(iLE*modelStruct.modelPar_PLNOVD))+(iWE*modelStruct.modelPar_PWNOVD))+(iLEWE*modelStruct.modelPar_PLWNOVD));
d_CF_p_dX = (((modelStruct.d_modelPar_POCF_dX+(iLE*modelStruct.d_modelPar_PLCF_dX+d_iLE_dX*modelStruct.modelPar_PLCF))+(iWE*modelStruct.d_modelPar_PWCF_dX+d_iWE_dX*modelStruct.modelPar_PWCF))+(iLEWE*modelStruct.d_modelPar_PLWCF_dX+d_iLEWE_dX*modelStruct.modelPar_PLWCF));
CF_p = (((modelStruct.modelPar_POCF+(iLE*modelStruct.modelPar_PLCF))+(iWE*modelStruct.modelPar_PWCF))+(iLEWE*modelStruct.modelPar_PLWCF));
d_CFD_p_dX = modelStruct.d_modelPar_POCFD_dX;
CFD_p = modelStruct.modelPar_POCFD;
d_CFB_p_dX = modelStruct.d_modelPar_POCFB_dX;
CFB_p = modelStruct.modelPar_POCFB;
d_PSCE_p_dX = (((modelStruct.d_modelPar_POPSCE_dX+(iLE*modelStruct.d_modelPar_PLPSCE_dX+d_iLE_dX*modelStruct.modelPar_PLPSCE))+(iWE*modelStruct.d_modelPar_PWPSCE_dX+d_iWE_dX*modelStruct.modelPar_PWPSCE))+(iLEWE*modelStruct.d_modelPar_PLWPSCE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWPSCE));
PSCE_p = (((modelStruct.modelPar_POPSCE+(iLE*modelStruct.modelPar_PLPSCE))+(iWE*modelStruct.modelPar_PWPSCE))+(iLEWE*modelStruct.modelPar_PLWPSCE));
d_PSCEB_p_dX = modelStruct.d_modelPar_POPSCEB_dX;
PSCEB_p = modelStruct.modelPar_POPSCEB;
d_PSCED_p_dX = modelStruct.d_modelPar_POPSCED_dX;
PSCED_p = modelStruct.modelPar_POPSCED;
d_BETN_p_dX = ((iiWE*iLE)*(((modelStruct.d_modelPar_POBETN_dX+(iLE*modelStruct.d_modelPar_PLBETN_dX+d_iLE_dX*modelStruct.modelPar_PLBETN))+(iWE*modelStruct.d_modelPar_PWBETN_dX+d_iWE_dX*modelStruct.modelPar_PWBETN))+(iLEWE*modelStruct.d_modelPar_PLWBETN_dX+d_iLEWE_dX*modelStruct.modelPar_PLWBETN))+(iiWE*d_iLE_dX+d_iiWE_dX*iLE)*(((modelStruct.modelPar_POBETN+(iLE*modelStruct.modelPar_PLBETN))+(iWE*modelStruct.modelPar_PWBETN))+(iLEWE*modelStruct.modelPar_PLWBETN)));
BETN_p = ((iiWE*iLE)*(((modelStruct.modelPar_POBETN+(iLE*modelStruct.modelPar_PLBETN))+(iWE*modelStruct.modelPar_PWBETN))+(iLEWE*modelStruct.modelPar_PLWBETN)));
d_STBET_p_dX = (((modelStruct.d_modelPar_POSTBET_dX+(iLE*modelStruct.d_modelPar_PLSTBET_dX+d_iLE_dX*modelStruct.modelPar_PLSTBET))+(iWE*modelStruct.d_modelPar_PWSTBET_dX+d_iWE_dX*modelStruct.modelPar_PWSTBET))+(iLEWE*modelStruct.d_modelPar_PLWSTBET_dX+d_iLEWE_dX*modelStruct.modelPar_PLWSTBET));
STBET_p = (((modelStruct.modelPar_POSTBET+(iLE*modelStruct.modelPar_PLSTBET))+(iWE*modelStruct.modelPar_PWSTBET))+(iLEWE*modelStruct.modelPar_PLWSTBET));
d_MUE_p_dX = (((modelStruct.d_modelPar_POMUE_dX+(iLE*modelStruct.d_modelPar_PLMUE_dX+d_iLE_dX*modelStruct.modelPar_PLMUE))+(iWE*modelStruct.d_modelPar_PWMUE_dX+d_iWE_dX*modelStruct.modelPar_PWMUE))+(iLEWE*modelStruct.d_modelPar_PLWMUE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWMUE));
MUE_p = (((modelStruct.modelPar_POMUE+(iLE*modelStruct.modelPar_PLMUE))+(iWE*modelStruct.modelPar_PWMUE))+(iLEWE*modelStruct.modelPar_PLWMUE));
d_STMUE_p_dX = modelStruct.d_modelPar_POSTMUE_dX;
STMUE_p = modelStruct.modelPar_POSTMUE;
d_THEMU_p_dX = modelStruct.d_modelPar_POTHEMU_dX;
THEMU_p = modelStruct.modelPar_POTHEMU;
d_STTHEMU_p_dX = modelStruct.d_modelPar_POSTTHEMU_dX;
STTHEMU_p = modelStruct.modelPar_POSTTHEMU;
d_CS_p_dX = (((modelStruct.d_modelPar_POCS_dX+(iLE*modelStruct.d_modelPar_PLCS_dX+d_iLE_dX*modelStruct.modelPar_PLCS))+(iWE*modelStruct.d_modelPar_PWCS_dX+d_iWE_dX*modelStruct.modelPar_PWCS))+(iLEWE*modelStruct.d_modelPar_PLWCS_dX+d_iLEWE_dX*modelStruct.modelPar_PLWCS));
CS_p = (((modelStruct.modelPar_POCS+(iLE*modelStruct.modelPar_PLCS))+(iWE*modelStruct.modelPar_PWCS))+(iLEWE*modelStruct.modelPar_PLWCS));
d_STCS_p_dX = modelStruct.d_modelPar_POSTCS_dX;
STCS_p = modelStruct.modelPar_POSTCS;
d_XCOR_p_dX = (((modelStruct.d_modelPar_POXCOR_dX+(iLE*modelStruct.d_modelPar_PLXCOR_dX+d_iLE_dX*modelStruct.modelPar_PLXCOR))+(iWE*modelStruct.d_modelPar_PWXCOR_dX+d_iWE_dX*modelStruct.modelPar_PWXCOR))+(iLEWE*modelStruct.d_modelPar_PLWXCOR_dX+d_iLEWE_dX*modelStruct.modelPar_PLWXCOR));
XCOR_p = (((modelStruct.modelPar_POXCOR+(iLE*modelStruct.modelPar_PLXCOR))+(iWE*modelStruct.modelPar_PWXCOR))+(iLEWE*modelStruct.modelPar_PLWXCOR));
d_STXCOR_p_dX = modelStruct.d_modelPar_POSTXCOR_dX;
STXCOR_p = modelStruct.modelPar_POSTXCOR;
d_FETA_p_dX = modelStruct.d_modelPar_POFETA_dX;
FETA_p = modelStruct.modelPar_POFETA;
d_RS_p_dX = (((modelStruct.d_modelPar_PORS_dX+(iLE*modelStruct.d_modelPar_PLRS_dX+d_iLE_dX*modelStruct.modelPar_PLRS))+(iWE*modelStruct.d_modelPar_PWRS_dX+d_iWE_dX*modelStruct.modelPar_PWRS))+(iLEWE*modelStruct.d_modelPar_PLWRS_dX+d_iLEWE_dX*modelStruct.modelPar_PLWRS));
RS_p = (((modelStruct.modelPar_PORS+(iLE*modelStruct.modelPar_PLRS))+(iWE*modelStruct.modelPar_PWRS))+(iLEWE*modelStruct.modelPar_PLWRS));
d_STRS_p_dX = modelStruct.d_modelPar_POSTRS_dX;
STRS_p = modelStruct.modelPar_POSTRS;
d_RSB_p_dX = modelStruct.d_modelPar_PORSB_dX;
RSB_p = modelStruct.modelPar_PORSB;
d_RSG_p_dX = modelStruct.d_modelPar_PORSG_dX;
RSG_p = modelStruct.modelPar_PORSG;
d_THESAT_p_dX = (((modelStruct.d_modelPar_POTHESAT_dX+(iLE*modelStruct.d_modelPar_PLTHESAT_dX+d_iLE_dX*modelStruct.modelPar_PLTHESAT))+(iWE*modelStruct.d_modelPar_PWTHESAT_dX+d_iWE_dX*modelStruct.modelPar_PWTHESAT))+(iLEWE*modelStruct.d_modelPar_PLWTHESAT_dX+d_iLEWE_dX*modelStruct.modelPar_PLWTHESAT));
THESAT_p = (((modelStruct.modelPar_POTHESAT+(iLE*modelStruct.modelPar_PLTHESAT))+(iWE*modelStruct.modelPar_PWTHESAT))+(iLEWE*modelStruct.modelPar_PLWTHESAT));
d_STTHESAT_p_dX = (((modelStruct.d_modelPar_POSTTHESAT_dX+(iLE*modelStruct.d_modelPar_PLSTTHESAT_dX+d_iLE_dX*modelStruct.modelPar_PLSTTHESAT))+(iWE*modelStruct.d_modelPar_PWSTTHESAT_dX+d_iWE_dX*modelStruct.modelPar_PWSTTHESAT))+(iLEWE*modelStruct.d_modelPar_PLWSTTHESAT_dX+d_iLEWE_dX*modelStruct.modelPar_PLWSTTHESAT));
STTHESAT_p = (((modelStruct.modelPar_POSTTHESAT+(iLE*modelStruct.modelPar_PLSTTHESAT))+(iWE*modelStruct.modelPar_PWSTTHESAT))+(iLEWE*modelStruct.modelPar_PLWSTTHESAT));
d_THESATB_p_dX = (((modelStruct.d_modelPar_POTHESATB_dX+(iLE*modelStruct.d_modelPar_PLTHESATB_dX+d_iLE_dX*modelStruct.modelPar_PLTHESATB))+(iWE*modelStruct.d_modelPar_PWTHESATB_dX+d_iWE_dX*modelStruct.modelPar_PWTHESATB))+(iLEWE*modelStruct.d_modelPar_PLWTHESATB_dX+d_iLEWE_dX*modelStruct.modelPar_PLWTHESATB));
THESATB_p = (((modelStruct.modelPar_POTHESATB+(iLE*modelStruct.modelPar_PLTHESATB))+(iWE*modelStruct.modelPar_PWTHESATB))+(iLEWE*modelStruct.modelPar_PLWTHESATB));
d_THESATG_p_dX = (((modelStruct.d_modelPar_POTHESATG_dX+(iLE*modelStruct.d_modelPar_PLTHESATG_dX+d_iLE_dX*modelStruct.modelPar_PLTHESATG))+(iWE*modelStruct.d_modelPar_PWTHESATG_dX+d_iWE_dX*modelStruct.modelPar_PWTHESATG))+(iLEWE*modelStruct.d_modelPar_PLWTHESATG_dX+d_iLEWE_dX*modelStruct.modelPar_PLWTHESATG));
THESATG_p = (((modelStruct.modelPar_POTHESATG+(iLE*modelStruct.modelPar_PLTHESATG))+(iWE*modelStruct.modelPar_PWTHESATG))+(iLEWE*modelStruct.modelPar_PLWTHESATG));
d_AX_p_dX = (((modelStruct.d_modelPar_POAX_dX+(iLE*modelStruct.d_modelPar_PLAX_dX+d_iLE_dX*modelStruct.modelPar_PLAX))+(iWE*modelStruct.d_modelPar_PWAX_dX+d_iWE_dX*modelStruct.modelPar_PWAX))+(iLEWE*modelStruct.d_modelPar_PLWAX_dX+d_iLEWE_dX*modelStruct.modelPar_PLWAX));
AX_p = (((modelStruct.modelPar_POAX+(iLE*modelStruct.modelPar_PLAX))+(iWE*modelStruct.modelPar_PWAX))+(iLEWE*modelStruct.modelPar_PLWAX));
d_ALP_p_dX = (((modelStruct.d_modelPar_POALP_dX+(iLE*modelStruct.d_modelPar_PLALP_dX+d_iLE_dX*modelStruct.modelPar_PLALP))+(iWE*modelStruct.d_modelPar_PWALP_dX+d_iWE_dX*modelStruct.modelPar_PWALP))+(iLEWE*modelStruct.d_modelPar_PLWALP_dX+d_iLEWE_dX*modelStruct.modelPar_PLWALP));
ALP_p = (((modelStruct.modelPar_POALP+(iLE*modelStruct.modelPar_PLALP))+(iWE*modelStruct.modelPar_PWALP))+(iLEWE*modelStruct.modelPar_PLWALP));
d_ALP1_p_dX = (((modelStruct.d_modelPar_POALP1_dX+(iLE*modelStruct.d_modelPar_PLALP1_dX+d_iLE_dX*modelStruct.modelPar_PLALP1))+(iWE*modelStruct.d_modelPar_PWALP1_dX+d_iWE_dX*modelStruct.modelPar_PWALP1))+(iLEWE*modelStruct.d_modelPar_PLWALP1_dX+d_iLEWE_dX*modelStruct.modelPar_PLWALP1));
ALP1_p = (((modelStruct.modelPar_POALP1+(iLE*modelStruct.modelPar_PLALP1))+(iWE*modelStruct.modelPar_PWALP1))+(iLEWE*modelStruct.modelPar_PLWALP1));
d_ALP2_p_dX = (((modelStruct.d_modelPar_POALP2_dX+(iLE*modelStruct.d_modelPar_PLALP2_dX+d_iLE_dX*modelStruct.modelPar_PLALP2))+(iWE*modelStruct.d_modelPar_PWALP2_dX+d_iWE_dX*modelStruct.modelPar_PWALP2))+(iLEWE*modelStruct.d_modelPar_PLWALP2_dX+d_iLEWE_dX*modelStruct.modelPar_PLWALP2));
ALP2_p = (((modelStruct.modelPar_POALP2+(iLE*modelStruct.modelPar_PLALP2))+(iWE*modelStruct.modelPar_PWALP2))+(iLEWE*modelStruct.modelPar_PLWALP2));
d_VP_p_dX = modelStruct.d_modelPar_POVP_dX;
VP_p = modelStruct.modelPar_POVP;
d_A1_p_dX = (((modelStruct.d_modelPar_POA1_dX+(iLE*modelStruct.d_modelPar_PLA1_dX+d_iLE_dX*modelStruct.modelPar_PLA1))+(iWE*modelStruct.d_modelPar_PWA1_dX+d_iWE_dX*modelStruct.modelPar_PWA1))+(iLEWE*modelStruct.d_modelPar_PLWA1_dX+d_iLEWE_dX*modelStruct.modelPar_PLWA1));
A1_p = (((modelStruct.modelPar_POA1+(iLE*modelStruct.modelPar_PLA1))+(iWE*modelStruct.modelPar_PWA1))+(iLEWE*modelStruct.modelPar_PLWA1));
d_A2_p_dX = modelStruct.d_modelPar_POA2_dX;
A2_p = modelStruct.modelPar_POA2;
d_STA2_p_dX = modelStruct.d_modelPar_POSTA2_dX;
STA2_p = modelStruct.modelPar_POSTA2;
d_A3_p_dX = (((modelStruct.d_modelPar_POA3_dX+(iLE*modelStruct.d_modelPar_PLA3_dX+d_iLE_dX*modelStruct.modelPar_PLA3))+(iWE*modelStruct.d_modelPar_PWA3_dX+d_iWE_dX*modelStruct.modelPar_PWA3))+(iLEWE*modelStruct.d_modelPar_PLWA3_dX+d_iLEWE_dX*modelStruct.modelPar_PLWA3));
A3_p = (((modelStruct.modelPar_POA3+(iLE*modelStruct.modelPar_PLA3))+(iWE*modelStruct.modelPar_PWA3))+(iLEWE*modelStruct.modelPar_PLWA3));
d_A4_p_dX = (((modelStruct.d_modelPar_POA4_dX+(iLE*modelStruct.d_modelPar_PLA4_dX+d_iLE_dX*modelStruct.modelPar_PLA4))+(iWE*modelStruct.d_modelPar_PWA4_dX+d_iWE_dX*modelStruct.modelPar_PWA4))+(iLEWE*modelStruct.d_modelPar_PLWA4_dX+d_iLEWE_dX*modelStruct.modelPar_PLWA4));
A4_p = (((modelStruct.modelPar_POA4+(iLE*modelStruct.modelPar_PLA4))+(iWE*modelStruct.modelPar_PWA4))+(iLEWE*modelStruct.modelPar_PLWA4));
d_GCO_p_dX = modelStruct.d_modelPar_POGCO_dX;
GCO_p = modelStruct.modelPar_POGCO;
d_IGINV_p_dX = (((modelStruct.d_modelPar_POIGINV_dX+(iiLE*modelStruct.d_modelPar_PLIGINV_dX+d_iiLE_dX*modelStruct.modelPar_PLIGINV))+(iiWE*modelStruct.d_modelPar_PWIGINV_dX+d_iiWE_dX*modelStruct.modelPar_PWIGINV))+(iiLEWE*modelStruct.d_modelPar_PLWIGINV_dX+d_iiLEWE_dX*modelStruct.modelPar_PLWIGINV));
IGINV_p = (((modelStruct.modelPar_POIGINV+(iiLE*modelStruct.modelPar_PLIGINV))+(iiWE*modelStruct.modelPar_PWIGINV))+(iiLEWE*modelStruct.modelPar_PLWIGINV));
d_IGOV_p_dX = (((modelStruct.d_modelPar_POIGOV_dX+(iLE*modelStruct.d_modelPar_PLIGOV_dX+d_iLE_dX*modelStruct.modelPar_PLIGOV))+(iiWE*modelStruct.d_modelPar_PWIGOV_dX+d_iiWE_dX*modelStruct.modelPar_PWIGOV))+(iiiLEWE*modelStruct.d_modelPar_PLWIGOV_dX+d_iiiLEWE_dX*modelStruct.modelPar_PLWIGOV));
IGOV_p = (((modelStruct.modelPar_POIGOV+(iLE*modelStruct.modelPar_PLIGOV))+(iiWE*modelStruct.modelPar_PWIGOV))+(iiiLEWE*modelStruct.modelPar_PLWIGOV));
d_IGOVD_p_dX = (((modelStruct.d_modelPar_POIGOVD_dX+(iLE*modelStruct.d_modelPar_PLIGOVD_dX+d_iLE_dX*modelStruct.modelPar_PLIGOVD))+(iiWE*modelStruct.d_modelPar_PWIGOVD_dX+d_iiWE_dX*modelStruct.modelPar_PWIGOVD))+(iiiLEWE*modelStruct.d_modelPar_PLWIGOVD_dX+d_iiiLEWE_dX*modelStruct.modelPar_PLWIGOVD));
IGOVD_p = (((modelStruct.modelPar_POIGOVD+(iLE*modelStruct.modelPar_PLIGOVD))+(iiWE*modelStruct.modelPar_PWIGOVD))+(iiiLEWE*modelStruct.modelPar_PLWIGOVD));
d_STIG_p_dX = modelStruct.d_modelPar_POSTIG_dX;
STIG_p = modelStruct.modelPar_POSTIG;
d_GC2_p_dX = modelStruct.d_modelPar_POGC2_dX;
GC2_p = modelStruct.modelPar_POGC2;
d_GC3_p_dX = modelStruct.d_modelPar_POGC3_dX;
GC3_p = modelStruct.modelPar_POGC3;
d_CHIB_p_dX = modelStruct.d_modelPar_POCHIB_dX;
CHIB_p = modelStruct.modelPar_POCHIB;
d_AGIDL_p_dX = (((modelStruct.d_modelPar_POAGIDL_dX+(iLE*modelStruct.d_modelPar_PLAGIDL_dX+d_iLE_dX*modelStruct.modelPar_PLAGIDL))+(iiWE*modelStruct.d_modelPar_PWAGIDL_dX+d_iiWE_dX*modelStruct.modelPar_PWAGIDL))+(iiiLEWE*modelStruct.d_modelPar_PLWAGIDL_dX+d_iiiLEWE_dX*modelStruct.modelPar_PLWAGIDL));
AGIDL_p = (((modelStruct.modelPar_POAGIDL+(iLE*modelStruct.modelPar_PLAGIDL))+(iiWE*modelStruct.modelPar_PWAGIDL))+(iiiLEWE*modelStruct.modelPar_PLWAGIDL));
d_AGIDLD_p_dX = (((modelStruct.d_modelPar_POAGIDLD_dX+(iLE*modelStruct.d_modelPar_PLAGIDLD_dX+d_iLE_dX*modelStruct.modelPar_PLAGIDLD))+(iiWE*modelStruct.d_modelPar_PWAGIDLD_dX+d_iiWE_dX*modelStruct.modelPar_PWAGIDLD))+(iiiLEWE*modelStruct.d_modelPar_PLWAGIDLD_dX+d_iiiLEWE_dX*modelStruct.modelPar_PLWAGIDLD));
AGIDLD_p = (((modelStruct.modelPar_POAGIDLD+(iLE*modelStruct.modelPar_PLAGIDLD))+(iiWE*modelStruct.modelPar_PWAGIDLD))+(iiiLEWE*modelStruct.modelPar_PLWAGIDLD));
d_BGIDL_p_dX = modelStruct.d_modelPar_POBGIDL_dX;
BGIDL_p = modelStruct.modelPar_POBGIDL;
d_BGIDLD_p_dX = modelStruct.d_modelPar_POBGIDLD_dX;
BGIDLD_p = modelStruct.modelPar_POBGIDLD;
d_STBGIDL_p_dX = modelStruct.d_modelPar_POSTBGIDL_dX;
STBGIDL_p = modelStruct.modelPar_POSTBGIDL;
d_STBGIDLD_p_dX = modelStruct.d_modelPar_POSTBGIDLD_dX;
STBGIDLD_p = modelStruct.modelPar_POSTBGIDLD;
d_CGIDL_p_dX = modelStruct.d_modelPar_POCGIDL_dX;
CGIDL_p = modelStruct.modelPar_POCGIDL;
d_CGIDLD_p_dX = modelStruct.d_modelPar_POCGIDLD_dX;
CGIDLD_p = modelStruct.modelPar_POCGIDLD;
d_COX_p_dX = (((modelStruct.d_modelPar_POCOX_dX+(iiLEcv*modelStruct.d_modelPar_PLCOX_dX+d_iiLEcv_dX*modelStruct.modelPar_PLCOX))+(iiWEcv*modelStruct.d_modelPar_PWCOX_dX+d_iiWEcv_dX*modelStruct.modelPar_PWCOX))+(iiLEWEcv*modelStruct.d_modelPar_PLWCOX_dX+d_iiLEWEcv_dX*modelStruct.modelPar_PLWCOX));
COX_p = (((modelStruct.modelPar_POCOX+(iiLEcv*modelStruct.modelPar_PLCOX))+(iiWEcv*modelStruct.modelPar_PWCOX))+(iiLEWEcv*modelStruct.modelPar_PLWCOX));
d_CGOV_p_dX = (((modelStruct.d_modelPar_POCGOV_dX+(iLEcv*modelStruct.d_modelPar_PLCGOV_dX+d_iLEcv_dX*modelStruct.modelPar_PLCGOV))+(iiWEcv*modelStruct.d_modelPar_PWCGOV_dX+d_iiWEcv_dX*modelStruct.modelPar_PWCGOV))+(iiiLEWEcv*modelStruct.d_modelPar_PLWCGOV_dX+d_iiiLEWEcv_dX*modelStruct.modelPar_PLWCGOV));
CGOV_p = (((modelStruct.modelPar_POCGOV+(iLEcv*modelStruct.modelPar_PLCGOV))+(iiWEcv*modelStruct.modelPar_PWCGOV))+(iiiLEWEcv*modelStruct.modelPar_PLWCGOV));
d_CGOVD_p_dX = (((modelStruct.d_modelPar_POCGOVD_dX+(iLEcv*modelStruct.d_modelPar_PLCGOVD_dX+d_iLEcv_dX*modelStruct.modelPar_PLCGOVD))+(iiWEcv*modelStruct.d_modelPar_PWCGOVD_dX+d_iiWEcv_dX*modelStruct.modelPar_PWCGOVD))+(iiiLEWEcv*modelStruct.d_modelPar_PLWCGOVD_dX+d_iiiLEWEcv_dX*modelStruct.modelPar_PLWCGOVD));
CGOVD_p = (((modelStruct.modelPar_POCGOVD+(iLEcv*modelStruct.modelPar_PLCGOVD))+(iiWEcv*modelStruct.modelPar_PWCGOVD))+(iiiLEWEcv*modelStruct.modelPar_PLWCGOVD));
d_CGBOV_p_dX = (((modelStruct.d_modelPar_POCGBOV_dX+(iiLcv*modelStruct.d_modelPar_PLCGBOV_dX+d_iiLcv_dX*modelStruct.modelPar_PLCGBOV))+(iiWcv*modelStruct.d_modelPar_PWCGBOV_dX+d_iiWcv_dX*modelStruct.modelPar_PWCGBOV))+(iiLWcv*modelStruct.d_modelPar_PLWCGBOV_dX+d_iiLWcv_dX*modelStruct.modelPar_PLWCGBOV));
CGBOV_p = (((modelStruct.modelPar_POCGBOV+(iiLcv*modelStruct.modelPar_PLCGBOV))+(iiWcv*modelStruct.modelPar_PWCGBOV))+(iiLWcv*modelStruct.modelPar_PLWCGBOV));
d_CFR_p_dX = (((modelStruct.d_modelPar_POCFR_dX+(iLcv*modelStruct.d_modelPar_PLCFR_dX+d_iLcv_dX*modelStruct.modelPar_PLCFR))+(iiWcv*modelStruct.d_modelPar_PWCFR_dX+d_iiWcv_dX*modelStruct.modelPar_PWCFR))+(iiiLWcv*modelStruct.d_modelPar_PLWCFR_dX+d_iiiLWcv_dX*modelStruct.modelPar_PLWCFR));
CFR_p = (((modelStruct.modelPar_POCFR+(iLcv*modelStruct.modelPar_PLCFR))+(iiWcv*modelStruct.modelPar_PWCFR))+(iiiLWcv*modelStruct.modelPar_PLWCFR));
d_CFRD_p_dX = (((modelStruct.d_modelPar_POCFRD_dX+(iLcv*modelStruct.d_modelPar_PLCFRD_dX+d_iLcv_dX*modelStruct.modelPar_PLCFRD))+(iiWcv*modelStruct.d_modelPar_PWCFRD_dX+d_iiWcv_dX*modelStruct.modelPar_PWCFRD))+(iiiLWcv*modelStruct.d_modelPar_PLWCFRD_dX+d_iiiLWcv_dX*modelStruct.modelPar_PLWCFRD));
CFRD_p = (((modelStruct.modelPar_POCFRD+(iLcv*modelStruct.modelPar_PLCFRD))+(iiWcv*modelStruct.modelPar_PWCFRD))+(iiiLWcv*modelStruct.modelPar_PLWCFRD));
d_FNT_p_dX = modelStruct.d_modelPar_POFNT_dX;
FNT_p = modelStruct.modelPar_POFNT;
d_FNTEXC_p_dX = ((iLE*iLE)*(((modelStruct.d_modelPar_POFNTEXC_dX+(iLE*modelStruct.d_modelPar_PLFNTEXC_dX+d_iLE_dX*modelStruct.modelPar_PLFNTEXC))+(iWE*modelStruct.d_modelPar_PWFNTEXC_dX+d_iWE_dX*modelStruct.modelPar_PWFNTEXC))+(iLEWE*modelStruct.d_modelPar_PLWFNTEXC_dX+d_iLEWE_dX*modelStruct.modelPar_PLWFNTEXC))+(iLE*d_iLE_dX+d_iLE_dX*iLE)*(((modelStruct.modelPar_POFNTEXC+(iLE*modelStruct.modelPar_PLFNTEXC))+(iWE*modelStruct.modelPar_PWFNTEXC))+(iLEWE*modelStruct.modelPar_PLWFNTEXC)));
FNTEXC_p = ((iLE*iLE)*(((modelStruct.modelPar_POFNTEXC+(iLE*modelStruct.modelPar_PLFNTEXC))+(iWE*modelStruct.modelPar_PWFNTEXC))+(iLEWE*modelStruct.modelPar_PLWFNTEXC)));
d_NFA_p_dX = (((modelStruct.d_modelPar_PONFA_dX+(iLE*modelStruct.d_modelPar_PLNFA_dX+d_iLE_dX*modelStruct.modelPar_PLNFA))+(iWE*modelStruct.d_modelPar_PWNFA_dX+d_iWE_dX*modelStruct.modelPar_PWNFA))+(iLEWE*modelStruct.d_modelPar_PLWNFA_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFA));
NFA_p = (((modelStruct.modelPar_PONFA+(iLE*modelStruct.modelPar_PLNFA))+(iWE*modelStruct.modelPar_PWNFA))+(iLEWE*modelStruct.modelPar_PLWNFA));
d_NFB_p_dX = (((modelStruct.d_modelPar_PONFB_dX+(iLE*modelStruct.d_modelPar_PLNFB_dX+d_iLE_dX*modelStruct.modelPar_PLNFB))+(iWE*modelStruct.d_modelPar_PWNFB_dX+d_iWE_dX*modelStruct.modelPar_PWNFB))+(iLEWE*modelStruct.d_modelPar_PLWNFB_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFB));
NFB_p = (((modelStruct.modelPar_PONFB+(iLE*modelStruct.modelPar_PLNFB))+(iWE*modelStruct.modelPar_PWNFB))+(iLEWE*modelStruct.modelPar_PLWNFB));
d_NFC_p_dX = (((modelStruct.d_modelPar_PONFC_dX+(iLE*modelStruct.d_modelPar_PLNFC_dX+d_iLE_dX*modelStruct.modelPar_PLNFC))+(iWE*modelStruct.d_modelPar_PWNFC_dX+d_iWE_dX*modelStruct.modelPar_PWNFC))+(iLEWE*modelStruct.d_modelPar_PLWNFC_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFC));
NFC_p = (((modelStruct.modelPar_PONFC+(iLE*modelStruct.modelPar_PLNFC))+(iWE*modelStruct.modelPar_PWNFC))+(iLEWE*modelStruct.modelPar_PLWNFC));
d_EF_p_dX = modelStruct.d_modelPar_POEF_dX;
EF_p = modelStruct.modelPar_POEF;
d_VFBEDGE_p_dX = modelStruct.d_modelPar_POVFBEDGE_dX;
VFBEDGE_p = modelStruct.modelPar_POVFBEDGE;
d_STVFBEDGE_p_dX = (((modelStruct.d_modelPar_POSTVFBEDGE_dX+(iLE*modelStruct.d_modelPar_PLSTVFBEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLSTVFBEDGE))+(iWE*modelStruct.d_modelPar_PWSTVFBEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWSTVFBEDGE))+(iLEWE*modelStruct.d_modelPar_PLWSTVFBEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWSTVFBEDGE));
STVFBEDGE_p = (((modelStruct.modelPar_POSTVFBEDGE+(iLE*modelStruct.modelPar_PLSTVFBEDGE))+(iWE*modelStruct.modelPar_PWSTVFBEDGE))+(iLEWE*modelStruct.modelPar_PLWSTVFBEDGE));
d_DPHIBEDGE_p_dX = (((modelStruct.d_modelPar_PODPHIBEDGE_dX+(iLE*modelStruct.d_modelPar_PLDPHIBEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLDPHIBEDGE))+(iWE*modelStruct.d_modelPar_PWDPHIBEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWDPHIBEDGE))+(iLEWE*modelStruct.d_modelPar_PLWDPHIBEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWDPHIBEDGE));
DPHIBEDGE_p = (((modelStruct.modelPar_PODPHIBEDGE+(iLE*modelStruct.modelPar_PLDPHIBEDGE))+(iWE*modelStruct.modelPar_PWDPHIBEDGE))+(iLEWE*modelStruct.modelPar_PLWDPHIBEDGE));
d_NEFFEDGE_p_dX = (((modelStruct.d_modelPar_PONEFFEDGE_dX+(iLE*modelStruct.d_modelPar_PLNEFFEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLNEFFEDGE))+(iWE*modelStruct.d_modelPar_PWNEFFEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWNEFFEDGE))+(iLEWE*modelStruct.d_modelPar_PLWNEFFEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNEFFEDGE));
NEFFEDGE_p = (((modelStruct.modelPar_PONEFFEDGE+(iLE*modelStruct.modelPar_PLNEFFEDGE))+(iWE*modelStruct.modelPar_PWNEFFEDGE))+(iLEWE*modelStruct.modelPar_PLWNEFFEDGE));
d_CTEDGE_p_dX = (((modelStruct.d_modelPar_POCTEDGE_dX+(iLE*modelStruct.d_modelPar_PLCTEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLCTEDGE))+(iWE*modelStruct.d_modelPar_PWCTEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWCTEDGE))+(iLEWE*modelStruct.d_modelPar_PLWCTEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWCTEDGE));
CTEDGE_p = (((modelStruct.modelPar_POCTEDGE+(iLE*modelStruct.modelPar_PLCTEDGE))+(iWE*modelStruct.modelPar_PWCTEDGE))+(iLEWE*modelStruct.modelPar_PLWCTEDGE));
d_BETNEDGE_p_dX = (iLE*(((modelStruct.d_modelPar_POBETNEDGE_dX+(iLE*modelStruct.d_modelPar_PLBETNEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLBETNEDGE))+(iWE*modelStruct.d_modelPar_PWBETNEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWBETNEDGE))+(iLEWE*modelStruct.d_modelPar_PLWBETNEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWBETNEDGE))+d_iLE_dX*(((modelStruct.modelPar_POBETNEDGE+(iLE*modelStruct.modelPar_PLBETNEDGE))+(iWE*modelStruct.modelPar_PWBETNEDGE))+(iLEWE*modelStruct.modelPar_PLWBETNEDGE)));
BETNEDGE_p = (iLE*(((modelStruct.modelPar_POBETNEDGE+(iLE*modelStruct.modelPar_PLBETNEDGE))+(iWE*modelStruct.modelPar_PWBETNEDGE))+(iLEWE*modelStruct.modelPar_PLWBETNEDGE)));
d_STBETEDGE_p_dX = (((modelStruct.d_modelPar_POSTBETEDGE_dX+(iLE*modelStruct.d_modelPar_PLSTBETEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLSTBETEDGE))+(iWE*modelStruct.d_modelPar_PWSTBETEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWSTBETEDGE))+(iLEWE*modelStruct.d_modelPar_PLWSTBETEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWSTBETEDGE));
STBETEDGE_p = (((modelStruct.modelPar_POSTBETEDGE+(iLE*modelStruct.modelPar_PLSTBETEDGE))+(iWE*modelStruct.modelPar_PWSTBETEDGE))+(iLEWE*modelStruct.modelPar_PLWSTBETEDGE));
d_PSCEEDGE_p_dX = (((modelStruct.d_modelPar_POPSCEEDGE_dX+(iLE*modelStruct.d_modelPar_PLPSCEEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLPSCEEDGE))+(iWE*modelStruct.d_modelPar_PWPSCEEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWPSCEEDGE))+(iLEWE*modelStruct.d_modelPar_PLWPSCEEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWPSCEEDGE));
PSCEEDGE_p = (((modelStruct.modelPar_POPSCEEDGE+(iLE*modelStruct.modelPar_PLPSCEEDGE))+(iWE*modelStruct.modelPar_PWPSCEEDGE))+(iLEWE*modelStruct.modelPar_PLWPSCEEDGE));
d_PSCEBEDGE_p_dX = modelStruct.d_modelPar_POPSCEBEDGE_dX;
PSCEBEDGE_p = modelStruct.modelPar_POPSCEBEDGE;
d_PSCEDEDGE_p_dX = modelStruct.d_modelPar_POPSCEDEDGE_dX;
PSCEDEDGE_p = modelStruct.modelPar_POPSCEDEDGE;
d_CFEDGE_p_dX = (((modelStruct.d_modelPar_POCFEDGE_dX+(iLE*modelStruct.d_modelPar_PLCFEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLCFEDGE))+(iWE*modelStruct.d_modelPar_PWCFEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWCFEDGE))+(iLEWE*modelStruct.d_modelPar_PLWCFEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWCFEDGE));
CFEDGE_p = (((modelStruct.modelPar_POCFEDGE+(iLE*modelStruct.modelPar_PLCFEDGE))+(iWE*modelStruct.modelPar_PWCFEDGE))+(iLEWE*modelStruct.modelPar_PLWCFEDGE));
d_CFDEDGE_p_dX = modelStruct.d_modelPar_POCFDEDGE_dX;
CFDEDGE_p = modelStruct.modelPar_POCFDEDGE;
d_CFBEDGE_p_dX = modelStruct.d_modelPar_POCFBEDGE_dX;
CFBEDGE_p = modelStruct.modelPar_POCFBEDGE;
d_FNTEDGE_p_dX = modelStruct.d_modelPar_POFNTEDGE_dX;
FNTEDGE_p = modelStruct.modelPar_POFNTEDGE;
d_NFAEDGE_p_dX = (((modelStruct.d_modelPar_PONFAEDGE_dX+(iLE*modelStruct.d_modelPar_PLNFAEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLNFAEDGE))+(iWE*modelStruct.d_modelPar_PWNFAEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWNFAEDGE))+(iLEWE*modelStruct.d_modelPar_PLWNFAEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFAEDGE));
NFAEDGE_p = (((modelStruct.modelPar_PONFAEDGE+(iLE*modelStruct.modelPar_PLNFAEDGE))+(iWE*modelStruct.modelPar_PWNFAEDGE))+(iLEWE*modelStruct.modelPar_PLWNFAEDGE));
d_NFBEDGE_p_dX = (((modelStruct.d_modelPar_PONFBEDGE_dX+(iLE*modelStruct.d_modelPar_PLNFBEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLNFBEDGE))+(iWE*modelStruct.d_modelPar_PWNFBEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWNFBEDGE))+(iLEWE*modelStruct.d_modelPar_PLWNFBEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFBEDGE));
NFBEDGE_p = (((modelStruct.modelPar_PONFBEDGE+(iLE*modelStruct.modelPar_PLNFBEDGE))+(iWE*modelStruct.modelPar_PWNFBEDGE))+(iLEWE*modelStruct.modelPar_PLWNFBEDGE));
d_NFCEDGE_p_dX = (((modelStruct.d_modelPar_PONFCEDGE_dX+(iLE*modelStruct.d_modelPar_PLNFCEDGE_dX+d_iLE_dX*modelStruct.modelPar_PLNFCEDGE))+(iWE*modelStruct.d_modelPar_PWNFCEDGE_dX+d_iWE_dX*modelStruct.modelPar_PWNFCEDGE))+(iLEWE*modelStruct.d_modelPar_PLWNFCEDGE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWNFCEDGE));
NFCEDGE_p = (((modelStruct.modelPar_PONFCEDGE+(iLE*modelStruct.modelPar_PLNFCEDGE))+(iWE*modelStruct.modelPar_PWNFCEDGE))+(iLEWE*modelStruct.modelPar_PLWNFCEDGE));
d_EFEDGE_p_dX = modelStruct.d_modelPar_POEFEDGE_dX;
EFEDGE_p = modelStruct.modelPar_POEFEDGE;
d_KVTHOWE_dX = (((modelStruct.d_modelPar_POKVTHOWE_dX+(iLE*modelStruct.d_modelPar_PLKVTHOWE_dX+d_iLE_dX*modelStruct.modelPar_PLKVTHOWE))+(iWE*modelStruct.d_modelPar_PWKVTHOWE_dX+d_iWE_dX*modelStruct.modelPar_PWKVTHOWE))+(iLEWE*modelStruct.d_modelPar_PLWKVTHOWE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWKVTHOWE));
KVTHOWE = (((modelStruct.modelPar_POKVTHOWE+(iLE*modelStruct.modelPar_PLKVTHOWE))+(iWE*modelStruct.modelPar_PWKVTHOWE))+(iLEWE*modelStruct.modelPar_PLWKVTHOWE));
d_KUOWE_dX = (((modelStruct.d_modelPar_POKUOWE_dX+(iLE*modelStruct.d_modelPar_PLKUOWE_dX+d_iLE_dX*modelStruct.modelPar_PLKUOWE))+(iWE*modelStruct.d_modelPar_PWKUOWE_dX+d_iWE_dX*modelStruct.modelPar_PWKUOWE))+(iLEWE*modelStruct.d_modelPar_PLWKUOWE_dX+d_iLEWE_dX*modelStruct.modelPar_PLWKUOWE));
KUOWE = (((modelStruct.modelPar_POKUOWE+(iLE*modelStruct.modelPar_PLKUOWE))+(iWE*modelStruct.modelPar_PWKUOWE))+(iLEWE*modelStruct.modelPar_PLWKUOWE));
}
if (((modelStruct.modelVar_SWGEO_i==1)||(modelStruct.modelVar_SWGEO_i==2)))
{
d_RG_p_dX = (((((NGCON_i*L_slif)*(modelStruct.modelVar_RSHG_i*(((NGCON_i*3.3333333333333333e-01*d_W_f_dX-(3.3333333333333333e-01*W_f)*d_NGCON_i_dX)/NGCON_i/NGCON_i)+d_XGWE_dX)+modelStruct.d_modelVar_RSHG_i_dX*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))-(modelStruct.modelVar_RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))*(NGCON_i*d_L_slif_dX+d_NGCON_i_dX*L_slif))/(NGCON_i*L_slif)/(NGCON_i*L_slif))+(((W_f*L_f)*(modelStruct.d_modelVar_RINT_i_dX+modelStruct.d_modelVar_RVPOLY_i_dX)-(modelStruct.modelVar_RINT_i+modelStruct.modelVar_RVPOLY_i)*(W_f*d_L_f_dX+d_W_f_dX*L_f))/(W_f*L_f)/(W_f*L_f)))+(NF_i*modelStruct.d_modelPar_RGO_dX+d_NF_i_dX*modelStruct.modelPar_RGO));
RG_p = ((((modelStruct.modelVar_RSHG_i*(((3.3333333333333333e-01*W_f)/NGCON_i)+XGWE))/(NGCON_i*L_slif))+((modelStruct.modelVar_RINT_i+modelStruct.modelVar_RVPOLY_i)/(W_f*L_f)))+(NF_i*modelStruct.modelPar_RGO));
if ((modelStruct.modelPar_SWJUNASYM==0))
{
modelStruct.d_modelVar_RSHD_i_dX = modelStruct.d_modelVar_RSH_i_dX;
modelStruct.modelVar_RSHD_i = modelStruct.modelVar_RSH_i;
}
d_RSE_p_dX = (instanceStruct.instancePar_NRS*modelStruct.d_modelVar_RSH_i_dX+instanceStruct.d_instancePar_NRS_dX*modelStruct.modelVar_RSH_i);
RSE_p = (instanceStruct.instancePar_NRS*modelStruct.modelVar_RSH_i);
d_RDE_p_dX = (instanceStruct.instancePar_NRD*modelStruct.d_modelVar_RSHD_i_dX+instanceStruct.d_instancePar_NRD_dX*modelStruct.modelVar_RSHD_i);
RDE_p = (instanceStruct.instancePar_NRD*modelStruct.modelVar_RSHD_i);
d_RWELL_p_dX = (NF_i*modelStruct.d_modelPar_RWELLO_dX+d_NF_i_dX*modelStruct.modelPar_RWELLO);
RWELL_p = (NF_i*modelStruct.modelPar_RWELLO);
d_RBULK_p_dX = (NF_i*modelStruct.d_modelPar_RBULKO_dX+d_NF_i_dX*modelStruct.modelPar_RBULKO);
RBULK_p = (NF_i*modelStruct.modelPar_RBULKO);
d_RJUNS_p_dX = (NF_i*modelStruct.d_modelPar_RJUNSO_dX+d_NF_i_dX*modelStruct.modelPar_RJUNSO);
RJUNS_p = (NF_i*modelStruct.modelPar_RJUNSO);
d_RJUND_p_dX = (NF_i*modelStruct.d_modelPar_RJUNDO_dX+d_NF_i_dX*modelStruct.modelPar_RJUNDO);
RJUND_p = (NF_i*modelStruct.modelPar_RJUNDO);
d_tmpa_dX = 0.0;
tmpa = 0.0;
d_tmpb_dX = 0.0;
tmpb = 0.0;
loop = 0.0;
if ((((SA_i>0.0)&&(SB_i>0.0))&&((NF_i==1.0)||((NF_i>1.0)&&(SD_i>0.0)))))
{
while ((loop<(NF_i-0.5)))
{
d_tmpa_dX = (d_tmpa_dX+(-((d_SA_i_dX+0.5*d_L_i_dX)+loop*(d_SD_i_dX+d_L_i_dX))/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpa = (tmpa+(1.0/((SA_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
d_tmpb_dX = (d_tmpb_dX+(-((d_SB_i_dX+0.5*d_L_i_dX)+loop*(d_SD_i_dX+d_L_i_dX))/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
tmpb = (tmpb+(1.0/((SB_i+(0.5*L_i))+(loop*(SD_i+L_i)))));
loop = (loop+1.0);
}
d_Invsa_dX = (tmpa*d_invNF_dX+d_tmpa_dX*invNF);
Invsa = (tmpa*invNF);
d_Invsb_dX = (tmpb*d_invNF_dX+d_tmpb_dX*invNF);
Invsb = (tmpb*invNF);
d_Invsaref_dX = (-(modelStruct.d_modelVar_SAREF_i_dX+0.5*d_L_i_dX)/(modelStruct.modelVar_SAREF_i+(0.5*L_i))/(modelStruct.modelVar_SAREF_i+(0.5*L_i)));
Invsaref = (1.0/(modelStruct.modelVar_SAREF_i+(0.5*L_i)));
d_Invsbref_dX = (-(modelStruct.d_modelVar_SBREF_i_dX+0.5*d_L_i_dX)/(modelStruct.modelVar_SBREF_i+(0.5*L_i))/(modelStruct.modelVar_SBREF_i+(0.5*L_i)));
Invsbref = (1.0/(modelStruct.modelVar_SBREF_i+(0.5*L_i)));
d_Lx_dX = (((L_i+delLPS)>1.0e-9)?(d_L_i_dX+d_delLPS_dX):0.0);
Lx = (((L_i+delLPS)>1.0e-9)?(L_i+delLPS):1.0e-9);
d_Wx_dX = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>1.0e-9)?((d_W_i_dX+d_delWOD_dX)+modelStruct.d_modelPar_WLOD_dX):0.0);
Wx = ((((W_i+delWOD)+modelStruct.modelPar_WLOD)>1.0e-9)?((W_i+delWOD)+modelStruct.modelPar_WLOD):1.0e-9);
{
double value_pow_0 = pow(Lx,modelStruct.modelVar_LLODKUO_i);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LLODKUO_i/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LLODKUO_i_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelVar_WLODKUO_i);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_WLODKUO_i/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_WLODKUO_i_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
d_Kstressu0_dX = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(modelStruct.modelPar_TKUO*modelStruct.d_modelVar_rTa_dX+modelStruct.d_modelPar_TKUO_dX*(modelStruct.modelVar_rTa-1.0))+(((modelStruct.modelPar_LKUO*d_templ_dX+modelStruct.d_modelPar_LKUO_dX*templ)+(modelStruct.modelPar_WKUO*d_tempw_dX+modelStruct.d_modelPar_WKUO_dX*tempw))+((modelStruct.modelPar_PKUO*templ)*d_tempw_dX+(modelStruct.modelPar_PKUO*d_templ_dX+modelStruct.d_modelPar_PKUO_dX*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(modelStruct.modelVar_rTa-1.0))));
Kstressu0 = ((((1.0+(modelStruct.modelPar_LKUO*templ))+(modelStruct.modelPar_WKUO*tempw))+((modelStruct.modelPar_PKUO*templ)*tempw))*(1.0+(modelStruct.modelPar_TKUO*(modelStruct.modelVar_rTa-1.0))));
d_rhobeta_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsa_dX+d_Invsb_dX)+modelStruct.d_modelPar_KUO_dX*(Invsa+Invsb))-(modelStruct.modelPar_KUO*(Invsa+Invsb))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobeta = ((modelStruct.modelPar_KUO*(Invsa+Invsb))/Kstressu0);
d_rhobetaref_dX = ((Kstressu0*(modelStruct.modelPar_KUO*(d_Invsaref_dX+d_Invsbref_dX)+modelStruct.d_modelPar_KUO_dX*(Invsaref+Invsbref))-(modelStruct.modelPar_KUO*(Invsaref+Invsbref))*d_Kstressu0_dX)/Kstressu0/Kstressu0);
rhobetaref = ((modelStruct.modelPar_KUO*(Invsaref+Invsbref))/Kstressu0);
{
double value_pow_0 = pow(Lx,modelStruct.modelVar_LLODVTH_i);
double  deriv_pow_0_d0 = ((Lx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LLODVTH_i/Lx));
double  deriv_pow_0_d1 = (Lx == 0.0)?0.0:(log(Lx)*value_pow_0);
d_templ_dX = (-((deriv_pow_0_d0*(d_Lx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LLODVTH_i_dX)))/value_pow_0/value_pow_0);
templ = (1.0/value_pow_0);
}
{
double value_pow_0 = pow(Wx,modelStruct.modelVar_WLODVTH_i);
double  deriv_pow_0_d0 = ((Wx == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_WLODVTH_i/Wx));
double  deriv_pow_0_d1 = (Wx == 0.0)?0.0:(log(Wx)*value_pow_0);
d_tempw_dX = (-((deriv_pow_0_d0*(d_Wx_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_WLODVTH_i_dX)))/value_pow_0/value_pow_0);
tempw = (1.0/value_pow_0);
}
d_Kstressvth0_dX = (((modelStruct.modelPar_LKVTHO*d_templ_dX+modelStruct.d_modelPar_LKVTHO_dX*templ)+(modelStruct.modelPar_WKVTHO*d_tempw_dX+modelStruct.d_modelPar_WKVTHO_dX*tempw))+((modelStruct.modelPar_PKVTHO*templ)*d_tempw_dX+(modelStruct.modelPar_PKVTHO*d_templ_dX+modelStruct.d_modelPar_PKVTHO_dX*templ)*tempw));
Kstressvth0 = (((1.0+(modelStruct.modelPar_LKVTHO*templ))+(modelStruct.modelPar_WKVTHO*tempw))+((modelStruct.modelPar_PKVTHO*templ)*tempw));
d_temp0_dX = (((d_Invsa_dX+d_Invsb_dX)-d_Invsaref_dX)-d_Invsbref_dX);
temp0 = (((Invsa+Invsb)-Invsaref)-Invsbref);
d_BETN_p_dX = (((1.0+rhobetaref)*(BETN_p*d_rhobeta_dX+d_BETN_p_dX*(1.0+rhobeta))-(BETN_p*(1.0+rhobeta))*d_rhobetaref_dX)/(1.0+rhobetaref)/(1.0+rhobetaref));
BETN_p = ((BETN_p*(1.0+rhobeta))/(1.0+rhobetaref));
d_THESAT_p_dX = ((((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta)))*((THESAT_p*(1.0+rhobeta))*(modelStruct.modelVar_KVSAT_i*d_rhobetaref_dX+modelStruct.d_modelVar_KVSAT_i_dX*rhobetaref)+(THESAT_p*d_rhobeta_dX+d_THESAT_p_dX*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))-((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))*((1.0+rhobetaref)*(modelStruct.modelVar_KVSAT_i*d_rhobeta_dX+modelStruct.d_modelVar_KVSAT_i_dX*rhobeta)+d_rhobetaref_dX*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))));
THESAT_p = (((THESAT_p*(1.0+rhobeta))*(1.0+(modelStruct.modelVar_KVSAT_i*rhobetaref)))/((1.0+rhobetaref)*(1.0+(modelStruct.modelVar_KVSAT_i*rhobeta))));
d_VFB_p_dX = (d_VFB_p_dX+((Kstressvth0*(modelStruct.modelPar_KVTHO*d_temp0_dX+modelStruct.d_modelPar_KVTHO_dX*temp0)-(modelStruct.modelPar_KVTHO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
VFB_p = (VFB_p+((modelStruct.modelPar_KVTHO*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,modelStruct.modelVar_LODETAO_i);
double  deriv_pow_0_d0 = ((Kstressvth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LODETAO_i/Kstressvth0));
double  deriv_pow_0_d1 = (Kstressvth0 == 0.0)?0.0:(log(Kstressvth0)*value_pow_0);
d_CF_p_dX = (d_CF_p_dX+((value_pow_0*(modelStruct.modelPar_STETAO*d_temp0_dX+modelStruct.d_modelPar_STETAO_dX*temp0)-(modelStruct.modelPar_STETAO*temp0)*((deriv_pow_0_d0*(d_Kstressvth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LODETAO_i_dX))))/value_pow_0/value_pow_0));
CF_p = (CF_p+((modelStruct.modelPar_STETAO*temp0)/value_pow_0));
}
d_BETNEDGE_p_dX = (((1.0+rhobetaref)*(BETNEDGE_p*d_rhobeta_dX+d_BETNEDGE_p_dX*(1.0+rhobeta))-(BETNEDGE_p*(1.0+rhobeta))*d_rhobetaref_dX)/(1.0+rhobetaref)/(1.0+rhobetaref));
BETNEDGE_p = ((BETNEDGE_p*(1.0+rhobeta))/(1.0+rhobetaref));
d_VFBEDGE_p_dX = (d_VFBEDGE_p_dX+((Kstressvth0*(modelStruct.modelPar_KVTHO*d_temp0_dX+modelStruct.d_modelPar_KVTHO_dX*temp0)-(modelStruct.modelPar_KVTHO*temp0)*d_Kstressvth0_dX)/Kstressvth0/Kstressvth0));
VFBEDGE_p = (VFBEDGE_p+((modelStruct.modelPar_KVTHO*temp0)/Kstressvth0));
{
double value_pow_0 = pow(Kstressvth0,modelStruct.modelVar_LODETAO_i);
double  deriv_pow_0_d0 = ((Kstressvth0 == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_LODETAO_i/Kstressvth0));
double  deriv_pow_0_d1 = (Kstressvth0 == 0.0)?0.0:(log(Kstressvth0)*value_pow_0);
d_CFEDGE_p_dX = (d_CFEDGE_p_dX+((value_pow_0*(modelStruct.modelPar_STETAO*d_temp0_dX+modelStruct.d_modelPar_STETAO_dX*temp0)-(modelStruct.modelPar_STETAO*temp0)*((deriv_pow_0_d0*(d_Kstressvth0_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_LODETAO_i_dX))))/value_pow_0/value_pow_0));
CFEDGE_p = (CFEDGE_p+((modelStruct.modelPar_STETAO*temp0)/value_pow_0));
}
}
if (((((SCA_i>0.0)||(SCB_i>0.0))||(SCC_i>0.0))||(SC_i>0.0)))
{
if ((((SCA_i==0.0)&&(SCB_i==0.0))&&(SCC_i==0.0)))
{
d_temp0_dX = (d_SC_i_dX+d_W_i_dX);
temp0 = (SC_i+W_i);
d_temp00_dX = (-modelStruct.d_modelVar_SCREF_i_dX/modelStruct.modelVar_SCREF_i/modelStruct.modelVar_SCREF_i);
temp00 = (1.0/modelStruct.modelVar_SCREF_i);
d_SCA_i_dX = (((SC_i*temp0)*(modelStruct.modelVar_SCREF_i*modelStruct.d_modelVar_SCREF_i_dX+modelStruct.d_modelVar_SCREF_i_dX*modelStruct.modelVar_SCREF_i)-(modelStruct.modelVar_SCREF_i*modelStruct.modelVar_SCREF_i)*(SC_i*d_temp0_dX+d_SC_i_dX*temp0))/(SC_i*temp0)/(SC_i*temp0));
SCA_i = ((modelStruct.modelVar_SCREF_i*modelStruct.modelVar_SCREF_i)/(SC_i*temp0));
{
double value_exp_0 = exp((((-10.0)*SC_i)*temp00));
double value_exp_1 = exp((((-10.0)*temp0)*temp00));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_SCB_i_dX = ((W_i*((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*deriv_exp_0_d0*((((-10.0)*SC_i)*d_temp00_dX+(-10.0)*d_SC_i_dX*temp00))+(0.1*d_SC_i_dX+0.01*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*deriv_exp_1_d0*((((-10.0)*temp0)*d_temp00_dX+(-10.0)*d_temp0_dX*temp00))+(0.1*d_temp0_dX+0.01*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_1))-((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_1))*d_W_i_dX)/W_i/W_i);
SCB_i = (((((0.1*SC_i)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.1*temp0)+(0.01*modelStruct.modelVar_SCREF_i))*value_exp_1))/W_i);
}
{
double value_exp_0 = exp((((-20.0)*SC_i)*temp00));
double value_exp_1 = exp((((-20.0)*temp0)*temp00));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_SCC_i_dX = ((W_i*((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*deriv_exp_0_d0*((((-20.0)*SC_i)*d_temp00_dX+(-20.0)*d_SC_i_dX*temp00))+(0.05*d_SC_i_dX+0.0025*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*deriv_exp_1_d0*((((-20.0)*temp0)*d_temp00_dX+(-20.0)*d_temp0_dX*temp00))+(0.05*d_temp0_dX+0.0025*modelStruct.d_modelVar_SCREF_i_dX)*value_exp_1))-((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_1))*d_W_i_dX)/W_i/W_i);
SCC_i = (((((0.05*SC_i)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_0)-(((0.05*temp0)+(0.0025*modelStruct.modelVar_SCREF_i))*value_exp_1))/W_i);
}
}
d_temp0_dX = ((d_SCA_i_dX+(modelStruct.modelVar_WEB_i*d_SCB_i_dX+modelStruct.d_modelVar_WEB_i_dX*SCB_i))+(modelStruct.modelVar_WEC_i*d_SCC_i_dX+modelStruct.d_modelVar_WEC_i_dX*SCC_i));
temp0 = ((SCA_i+(modelStruct.modelVar_WEB_i*SCB_i))+(modelStruct.modelVar_WEC_i*SCC_i));
d_VFB_p_dX = (d_VFB_p_dX+(KVTHOWE*d_temp0_dX+d_KVTHOWE_dX*temp0));
VFB_p = (VFB_p+(KVTHOWE*temp0));
d_BETN_p_dX = (BETN_p*(KUOWE*d_temp0_dX+d_KUOWE_dX*temp0)+d_BETN_p_dX*(1.0+(KUOWE*temp0)));
BETN_p = (BETN_p*(1.0+(KUOWE*temp0)));
d_VFBEDGE_p_dX = (d_VFBEDGE_p_dX+(KVTHOWE*d_temp0_dX+d_KVTHOWE_dX*temp0));
VFBEDGE_p = (VFBEDGE_p+(KVTHOWE*temp0));
d_BETNEDGE_p_dX = (BETNEDGE_p*(KUOWE*d_temp0_dX+d_KUOWE_dX*temp0)+d_BETNEDGE_p_dX*(1.0+(KUOWE*temp0)));
BETNEDGE_p = (BETNEDGE_p*(1.0+(KUOWE*temp0)));
}
}
d_VFB_i_dX = d_VFB_p_dX;
VFB_i = VFB_p;
instanceStruct.d_instanceVar_STVFB_i_dX = d_STVFB_p_dX;
instanceStruct.instanceVar_STVFB_i = STVFB_p;
instanceStruct.d_instanceVar_TOX_i_dX = ((TOX_p>1.0e-10)?d_TOX_p_dX:0.0);
instanceStruct.instanceVar_TOX_i = ((TOX_p>1.0e-10)?TOX_p:1.0e-10);
instanceStruct.d_instanceVar_EPSROX_i_dX = ((EPSROX_p>1.0)?d_EPSROX_p_dX:0.0);
instanceStruct.instanceVar_EPSROX_i = ((EPSROX_p>1.0)?EPSROX_p:1.0);
instanceStruct.d_instanceVar_NEFF_i_dX = ((NEFF_p>1.0e20)?((NEFF_p<1.0e26)?d_NEFF_p_dX:0.0):0.0);
instanceStruct.instanceVar_NEFF_i = ((NEFF_p>1.0e20)?((NEFF_p<1.0e26)?NEFF_p:1.0e26):1.0e20);
instanceStruct.d_instanceVar_FACNEFFAC_i_dX = ((FACNEFFAC_p>0.0)?d_FACNEFFAC_p_dX:0.0);
instanceStruct.instanceVar_FACNEFFAC_i = ((FACNEFFAC_p>0.0)?FACNEFFAC_p:0.0);
instanceStruct.d_instanceVar_GFACNUD_i_dX = ((GFACNUD_p>0.01)?d_GFACNUD_p_dX:0.0);
instanceStruct.instanceVar_GFACNUD_i = ((GFACNUD_p>0.01)?GFACNUD_p:0.01);
instanceStruct.d_instanceVar_VSBNUD_i_dX = ((VSBNUD_p>0.0)?d_VSBNUD_p_dX:0.0);
instanceStruct.instanceVar_VSBNUD_i = ((VSBNUD_p>0.0)?VSBNUD_p:0.0);
instanceStruct.d_instanceVar_DVSBNUD_i_dX = ((DVSBNUD_p>0.1)?d_DVSBNUD_p_dX:0.0);
instanceStruct.instanceVar_DVSBNUD_i = ((DVSBNUD_p>0.1)?DVSBNUD_p:0.1);
instanceStruct.d_instanceVar_VNSUB_i_dX = d_VNSUB_p_dX;
instanceStruct.instanceVar_VNSUB_i = VNSUB_p;
instanceStruct.d_instanceVar_NSLP_i_dX = ((NSLP_p>1.0e-3)?d_NSLP_p_dX:0.0);
instanceStruct.instanceVar_NSLP_i = ((NSLP_p>1.0e-3)?NSLP_p:1.0e-3);
instanceStruct.d_instanceVar_DNSUB_i_dX = ((DNSUB_p>0.0)?((DNSUB_p<1.0)?d_DNSUB_p_dX:0.0):0.0);
instanceStruct.instanceVar_DNSUB_i = ((DNSUB_p>0.0)?((DNSUB_p<1.0)?DNSUB_p:1.0):0.0);
instanceStruct.d_instanceVar_DPHIB_i_dX = d_DPHIB_p_dX;
instanceStruct.instanceVar_DPHIB_i = DPHIB_p;
instanceStruct.d_instanceVar_DELVTAC_i_dX = d_DELVTAC_p_dX;
instanceStruct.instanceVar_DELVTAC_i = DELVTAC_p;
instanceStruct.d_instanceVar_NP_i_dX = ((NP_p>0.0)?d_NP_p_dX:0.0);
instanceStruct.instanceVar_NP_i = ((NP_p>0.0)?NP_p:0.0);
instanceStruct.d_instanceVar_CT_i_dX = ((CT_p>0.0)?d_CT_p_dX:0.0);
instanceStruct.instanceVar_CT_i = ((CT_p>0.0)?CT_p:0.0);
instanceStruct.d_instanceVar_TOXOV_i_dX = ((TOXOV_p>1.0e-10)?d_TOXOV_p_dX:0.0);
instanceStruct.instanceVar_TOXOV_i = ((TOXOV_p>1.0e-10)?TOXOV_p:1.0e-10);
instanceStruct.d_instanceVar_TOXOVD_i_dX = ((TOXOVD_p>1.0e-10)?d_TOXOVD_p_dX:0.0);
instanceStruct.instanceVar_TOXOVD_i = ((TOXOVD_p>1.0e-10)?TOXOVD_p:1.0e-10);
instanceStruct.d_instanceVar_NOV_i_dX = ((NOV_p>1.0e20)?((NOV_p<1.0e27)?d_NOV_p_dX:0.0):0.0);
instanceStruct.instanceVar_NOV_i = ((NOV_p>1.0e20)?((NOV_p<1.0e27)?NOV_p:1.0e27):1.0e20);
instanceStruct.d_instanceVar_NOVD_i_dX = ((NOVD_p>1.0e20)?((NOVD_p<1.0e27)?d_NOVD_p_dX:0.0):0.0);
instanceStruct.instanceVar_NOVD_i = ((NOVD_p>1.0e20)?((NOVD_p<1.0e27)?NOVD_p:1.0e27):1.0e20);
instanceStruct.d_instanceVar_CF_i_dX = ((CF_p>0.0)?d_CF_p_dX:0.0);
instanceStruct.instanceVar_CF_i = ((CF_p>0.0)?CF_p:0.0);
instanceStruct.d_instanceVar_CFD_i_dX = ((CFD_p>0.0)?d_CFD_p_dX:0.0);
instanceStruct.instanceVar_CFD_i = ((CFD_p>0.0)?CFD_p:0.0);
instanceStruct.d_instanceVar_CFB_i_dX = ((CFB_p>0.0)?((CFB_p<1.0)?d_CFB_p_dX:0.0):0.0);
instanceStruct.instanceVar_CFB_i = ((CFB_p>0.0)?((CFB_p<1.0)?CFB_p:1.0):0.0);
instanceStruct.d_instanceVar_PSCE_i_dX = ((PSCE_p>0.0)?d_PSCE_p_dX:0.0);
instanceStruct.instanceVar_PSCE_i = ((PSCE_p>0.0)?PSCE_p:0.0);
instanceStruct.d_instanceVar_PSCEB_i_dX = ((PSCEB_p>0.0)?((PSCEB_p<1.0)?d_PSCEB_p_dX:0.0):0.0);
instanceStruct.instanceVar_PSCEB_i = ((PSCEB_p>0.0)?((PSCEB_p<1.0)?PSCEB_p:1.0):0.0);
instanceStruct.d_instanceVar_PSCED_i_dX = ((PSCED_p>0.0)?d_PSCED_p_dX:0.0);
instanceStruct.instanceVar_PSCED_i = ((PSCED_p>0.0)?PSCED_p:0.0);
d_BETN_i_dX = ((BETN_p>0.0)?d_BETN_p_dX:0.0);
BETN_i = ((BETN_p>0.0)?BETN_p:0.0);
instanceStruct.d_instanceVar_STBET_i_dX = d_STBET_p_dX;
instanceStruct.instanceVar_STBET_i = STBET_p;
d_MUE_i_dX = ((MUE_p>0.0)?d_MUE_p_dX:0.0);
MUE_i = ((MUE_p>0.0)?MUE_p:0.0);
instanceStruct.d_instanceVar_STMUE_i_dX = d_STMUE_p_dX;
instanceStruct.instanceVar_STMUE_i = STMUE_p;
d_THEMU_i_dX = ((THEMU_p>0.0)?d_THEMU_p_dX:0.0);
THEMU_i = ((THEMU_p>0.0)?THEMU_p:0.0);
instanceStruct.d_instanceVar_STTHEMU_i_dX = d_STTHEMU_p_dX;
instanceStruct.instanceVar_STTHEMU_i = STTHEMU_p;
d_CS_i_dX = ((CS_p>0.0)?d_CS_p_dX:0.0);
CS_i = ((CS_p>0.0)?CS_p:0.0);
instanceStruct.d_instanceVar_STCS_i_dX = d_STCS_p_dX;
instanceStruct.instanceVar_STCS_i = STCS_p;
d_XCOR_i_dX = ((XCOR_p>0.0)?d_XCOR_p_dX:0.0);
XCOR_i = ((XCOR_p>0.0)?XCOR_p:0.0);
instanceStruct.d_instanceVar_STXCOR_i_dX = d_STXCOR_p_dX;
instanceStruct.instanceVar_STXCOR_i = STXCOR_p;
instanceStruct.d_instanceVar_FETA_i_dX = ((FETA_p>0.0)?d_FETA_p_dX:0.0);
instanceStruct.instanceVar_FETA_i = ((FETA_p>0.0)?FETA_p:0.0);
d_RS_i_dX = ((RS_p>0.0)?d_RS_p_dX:0.0);
RS_i = ((RS_p>0.0)?RS_p:0.0);
instanceStruct.d_instanceVar_STRS_i_dX = d_STRS_p_dX;
instanceStruct.instanceVar_STRS_i = STRS_p;
instanceStruct.d_instanceVar_RSB_i_dX = ((RSB_p>(-0.5))?((RSB_p<1.0)?d_RSB_p_dX:0.0):0.0);
instanceStruct.instanceVar_RSB_i = ((RSB_p>(-0.5))?((RSB_p<1.0)?RSB_p:1.0):(-0.5));
instanceStruct.d_instanceVar_RSG_i_dX = ((RSG_p>(-0.5))?d_RSG_p_dX:0.0);
instanceStruct.instanceVar_RSG_i = ((RSG_p>(-0.5))?RSG_p:(-0.5));
d_THESAT_i_dX = ((THESAT_p>0.0)?d_THESAT_p_dX:0.0);
THESAT_i = ((THESAT_p>0.0)?THESAT_p:0.0);
instanceStruct.d_instanceVar_STTHESAT_i_dX = d_STTHESAT_p_dX;
instanceStruct.instanceVar_STTHESAT_i = STTHESAT_p;
instanceStruct.d_instanceVar_THESATB_i_dX = ((THESATB_p>(-0.5))?((THESATB_p<1.0)?d_THESATB_p_dX:0.0):0.0);
instanceStruct.instanceVar_THESATB_i = ((THESATB_p>(-0.5))?((THESATB_p<1.0)?THESATB_p:1.0):(-0.5));
instanceStruct.d_instanceVar_THESATG_i_dX = ((THESATG_p>(-0.5))?d_THESATG_p_dX:0.0);
instanceStruct.instanceVar_THESATG_i = ((THESATG_p>(-0.5))?THESATG_p:(-0.5));
instanceStruct.d_instanceVar_AX_i_dX = ((AX_p>2.0)?d_AX_p_dX:0.0);
instanceStruct.instanceVar_AX_i = ((AX_p>2.0)?AX_p:2.0);
instanceStruct.d_instanceVar_ALP_i_dX = ((ALP_p>0.0)?d_ALP_p_dX:0.0);
instanceStruct.instanceVar_ALP_i = ((ALP_p>0.0)?ALP_p:0.0);
instanceStruct.d_instanceVar_ALP1_i_dX = ((ALP1_p>0.0)?d_ALP1_p_dX:0.0);
instanceStruct.instanceVar_ALP1_i = ((ALP1_p>0.0)?ALP1_p:0.0);
instanceStruct.d_instanceVar_ALP2_i_dX = ((ALP2_p>0.0)?d_ALP2_p_dX:0.0);
instanceStruct.instanceVar_ALP2_i = ((ALP2_p>0.0)?ALP2_p:0.0);
instanceStruct.d_instanceVar_VP_i_dX = ((VP_p>1.0e-10)?d_VP_p_dX:0.0);
instanceStruct.instanceVar_VP_i = ((VP_p>1.0e-10)?VP_p:1.0e-10);
instanceStruct.d_instanceVar_A1_i_dX = ((A1_p>0.0)?d_A1_p_dX:0.0);
instanceStruct.instanceVar_A1_i = ((A1_p>0.0)?A1_p:0.0);
d_A2_i_dX = ((A2_p>0.0)?d_A2_p_dX:0.0);
A2_i = ((A2_p>0.0)?A2_p:0.0);
instanceStruct.d_instanceVar_STA2_i_dX = d_STA2_p_dX;
instanceStruct.instanceVar_STA2_i = STA2_p;
instanceStruct.d_instanceVar_A3_i_dX = ((A3_p>0.0)?d_A3_p_dX:0.0);
instanceStruct.instanceVar_A3_i = ((A3_p>0.0)?A3_p:0.0);
instanceStruct.d_instanceVar_A4_i_dX = ((A4_p>0.0)?d_A4_p_dX:0.0);
instanceStruct.instanceVar_A4_i = ((A4_p>0.0)?A4_p:0.0);
instanceStruct.d_instanceVar_GCO_i_dX = ((GCO_p>(-10.0))?((GCO_p<10.0)?d_GCO_p_dX:0.0):0.0);
instanceStruct.instanceVar_GCO_i = ((GCO_p>(-10.0))?((GCO_p<10.0)?GCO_p:10.0):(-10.0));
instanceStruct.d_instanceVar_IGINV_i_dX = ((IGINV_p>0.0)?d_IGINV_p_dX:0.0);
instanceStruct.instanceVar_IGINV_i = ((IGINV_p>0.0)?IGINV_p:0.0);
instanceStruct.d_instanceVar_IGOV_i_dX = ((IGOV_p>0.0)?d_IGOV_p_dX:0.0);
instanceStruct.instanceVar_IGOV_i = ((IGOV_p>0.0)?IGOV_p:0.0);
instanceStruct.d_instanceVar_IGOVD_i_dX = ((IGOVD_p>0.0)?d_IGOVD_p_dX:0.0);
instanceStruct.instanceVar_IGOVD_i = ((IGOVD_p>0.0)?IGOVD_p:0.0);
instanceStruct.d_instanceVar_STIG_i_dX = d_STIG_p_dX;
instanceStruct.instanceVar_STIG_i = STIG_p;
instanceStruct.d_instanceVar_GC2_i_dX = ((GC2_p>0.0)?((GC2_p<10.0)?d_GC2_p_dX:0.0):0.0);
instanceStruct.instanceVar_GC2_i = ((GC2_p>0.0)?((GC2_p<10.0)?GC2_p:10.0):0.0);
instanceStruct.d_instanceVar_GC3_i_dX = ((GC3_p>(-10.0))?((GC3_p<10.0)?d_GC3_p_dX:0.0):0.0);
instanceStruct.instanceVar_GC3_i = ((GC3_p>(-10.0))?((GC3_p<10.0)?GC3_p:10.0):(-10.0));
instanceStruct.d_instanceVar_CHIB_i_dX = ((CHIB_p>1.0)?d_CHIB_p_dX:0.0);
instanceStruct.instanceVar_CHIB_i = ((CHIB_p>1.0)?CHIB_p:1.0);
instanceStruct.d_instanceVar_AGIDL_i_dX = ((AGIDL_p>0.0)?d_AGIDL_p_dX:0.0);
instanceStruct.instanceVar_AGIDL_i = ((AGIDL_p>0.0)?AGIDL_p:0.0);
instanceStruct.d_instanceVar_AGIDLD_i_dX = ((AGIDLD_p>0.0)?d_AGIDLD_p_dX:0.0);
instanceStruct.instanceVar_AGIDLD_i = ((AGIDLD_p>0.0)?AGIDLD_p:0.0);
d_BGIDL_i_dX = ((BGIDL_p>0.0)?d_BGIDL_p_dX:0.0);
BGIDL_i = ((BGIDL_p>0.0)?BGIDL_p:0.0);
d_BGIDLD_i_dX = ((BGIDLD_p>0.0)?d_BGIDLD_p_dX:0.0);
BGIDLD_i = ((BGIDLD_p>0.0)?BGIDLD_p:0.0);
instanceStruct.d_instanceVar_STBGIDL_i_dX = d_STBGIDL_p_dX;
instanceStruct.instanceVar_STBGIDL_i = STBGIDL_p;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = d_STBGIDLD_p_dX;
instanceStruct.instanceVar_STBGIDLD_i = STBGIDLD_p;
instanceStruct.d_instanceVar_CGIDL_i_dX = d_CGIDL_p_dX;
instanceStruct.instanceVar_CGIDL_i = CGIDL_p;
instanceStruct.d_instanceVar_CGIDLD_i_dX = d_CGIDLD_p_dX;
instanceStruct.instanceVar_CGIDLD_i = CGIDLD_p;
instanceStruct.d_instanceVar_COX_i_dX = ((COX_p>0.0)?d_COX_p_dX:0.0);
instanceStruct.instanceVar_COX_i = ((COX_p>0.0)?COX_p:0.0);
instanceStruct.d_instanceVar_CGOV_i_dX = ((CGOV_p>0.0)?d_CGOV_p_dX:0.0);
instanceStruct.instanceVar_CGOV_i = ((CGOV_p>0.0)?CGOV_p:0.0);
instanceStruct.d_instanceVar_CGOVD_i_dX = ((CGOVD_p>0.0)?d_CGOVD_p_dX:0.0);
instanceStruct.instanceVar_CGOVD_i = ((CGOVD_p>0.0)?CGOVD_p:0.0);
instanceStruct.d_instanceVar_CGBOV_i_dX = ((CGBOV_p>0.0)?d_CGBOV_p_dX:0.0);
instanceStruct.instanceVar_CGBOV_i = ((CGBOV_p>0.0)?CGBOV_p:0.0);
instanceStruct.d_instanceVar_CFR_i_dX = ((CFR_p>0.0)?d_CFR_p_dX:0.0);
instanceStruct.instanceVar_CFR_i = ((CFR_p>0.0)?CFR_p:0.0);
instanceStruct.d_instanceVar_CFRD_i_dX = ((CFRD_p>0.0)?d_CFRD_p_dX:0.0);
instanceStruct.instanceVar_CFRD_i = ((CFRD_p>0.0)?CFRD_p:0.0);
instanceStruct.d_instanceVar_FNT_i_dX = ((FNT_p>0.0)?d_FNT_p_dX:0.0);
instanceStruct.instanceVar_FNT_i = ((FNT_p>0.0)?FNT_p:0.0);
instanceStruct.d_instanceVar_FNTEXC_i_dX = ((FNTEXC_p>0.0)?d_FNTEXC_p_dX:0.0);
instanceStruct.instanceVar_FNTEXC_i = ((FNTEXC_p>0.0)?FNTEXC_p:0.0);
instanceStruct.d_instanceVar_NFA_i_dX = ((NFA_p>0.0)?d_NFA_p_dX:0.0);
instanceStruct.instanceVar_NFA_i = ((NFA_p>0.0)?NFA_p:0.0);
instanceStruct.d_instanceVar_NFB_i_dX = ((NFB_p>0.0)?d_NFB_p_dX:0.0);
instanceStruct.instanceVar_NFB_i = ((NFB_p>0.0)?NFB_p:0.0);
instanceStruct.d_instanceVar_NFC_i_dX = ((NFC_p>0.0)?d_NFC_p_dX:0.0);
instanceStruct.instanceVar_NFC_i = ((NFC_p>0.0)?NFC_p:0.0);
instanceStruct.d_instanceVar_EF_i_dX = ((EF_p>0.0)?d_EF_p_dX:0.0);
instanceStruct.instanceVar_EF_i = ((EF_p>0.0)?EF_p:0.0);
d_VFBEDGE_i_dX = d_VFBEDGE_p_dX;
VFBEDGE_i = VFBEDGE_p;
instanceStruct.d_instanceVar_STVFBEDGE_i_dX = d_STVFBEDGE_p_dX;
instanceStruct.instanceVar_STVFBEDGE_i = STVFBEDGE_p;
instanceStruct.d_instanceVar_DPHIBEDGE_i_dX = d_DPHIBEDGE_p_dX;
instanceStruct.instanceVar_DPHIBEDGE_i = DPHIBEDGE_p;
instanceStruct.d_instanceVar_NEFFEDGE_i_dX = ((NEFFEDGE_p>1.0e20)?((NEFFEDGE_p<1.0e26)?d_NEFFEDGE_p_dX:0.0):0.0);
instanceStruct.instanceVar_NEFFEDGE_i = ((NEFFEDGE_p>1.0e20)?((NEFFEDGE_p<1.0e26)?NEFFEDGE_p:1.0e26):1.0e20);
instanceStruct.d_instanceVar_CTEDGE_i_dX = ((CTEDGE_p>0.0)?d_CTEDGE_p_dX:0.0);
instanceStruct.instanceVar_CTEDGE_i = ((CTEDGE_p>0.0)?CTEDGE_p:0.0);
instanceStruct.d_instanceVar_BETNEDGE_i_dX = ((BETNEDGE_p>0.0)?d_BETNEDGE_p_dX:0.0);
instanceStruct.instanceVar_BETNEDGE_i = ((BETNEDGE_p>0.0)?BETNEDGE_p:0.0);
instanceStruct.d_instanceVar_STBETEDGE_i_dX = d_STBETEDGE_p_dX;
instanceStruct.instanceVar_STBETEDGE_i = STBETEDGE_p;
instanceStruct.d_instanceVar_PSCEEDGE_i_dX = ((PSCEEDGE_p>0.0)?d_PSCEEDGE_p_dX:0.0);
instanceStruct.instanceVar_PSCEEDGE_i = ((PSCEEDGE_p>0.0)?PSCEEDGE_p:0.0);
instanceStruct.d_instanceVar_PSCEBEDGE_i_dX = ((PSCEBEDGE_p>0.0)?((PSCEBEDGE_p<1.0)?d_PSCEBEDGE_p_dX:0.0):0.0);
instanceStruct.instanceVar_PSCEBEDGE_i = ((PSCEBEDGE_p>0.0)?((PSCEBEDGE_p<1.0)?PSCEBEDGE_p:1.0):0.0);
instanceStruct.d_instanceVar_PSCEDEDGE_i_dX = ((PSCEDEDGE_p>0.0)?d_PSCEDEDGE_p_dX:0.0);
instanceStruct.instanceVar_PSCEDEDGE_i = ((PSCEDEDGE_p>0.0)?PSCEDEDGE_p:0.0);
instanceStruct.d_instanceVar_CFEDGE_i_dX = ((CFEDGE_p>0.0)?d_CFEDGE_p_dX:0.0);
instanceStruct.instanceVar_CFEDGE_i = ((CFEDGE_p>0.0)?CFEDGE_p:0.0);
instanceStruct.d_instanceVar_CFDEDGE_i_dX = ((CFDEDGE_p>0.0)?d_CFDEDGE_p_dX:0.0);
instanceStruct.instanceVar_CFDEDGE_i = ((CFDEDGE_p>0.0)?CFDEDGE_p:0.0);
instanceStruct.d_instanceVar_CFBEDGE_i_dX = ((CFBEDGE_p>0.0)?((CFBEDGE_p<1.0)?d_CFBEDGE_p_dX:0.0):0.0);
instanceStruct.instanceVar_CFBEDGE_i = ((CFBEDGE_p>0.0)?((CFBEDGE_p<1.0)?CFBEDGE_p:1.0):0.0);
instanceStruct.d_instanceVar_FNTEDGE_i_dX = ((FNTEDGE_p>0.0)?d_FNTEDGE_p_dX:0.0);
instanceStruct.instanceVar_FNTEDGE_i = ((FNTEDGE_p>0.0)?FNTEDGE_p:0.0);
instanceStruct.d_instanceVar_NFAEDGE_i_dX = ((NFAEDGE_p>0.0)?d_NFAEDGE_p_dX:0.0);
instanceStruct.instanceVar_NFAEDGE_i = ((NFAEDGE_p>0.0)?NFAEDGE_p:0.0);
instanceStruct.d_instanceVar_NFBEDGE_i_dX = ((NFBEDGE_p>0.0)?d_NFBEDGE_p_dX:0.0);
instanceStruct.instanceVar_NFBEDGE_i = ((NFBEDGE_p>0.0)?NFBEDGE_p:0.0);
instanceStruct.d_instanceVar_NFCEDGE_i_dX = ((NFCEDGE_p>0.0)?d_NFCEDGE_p_dX:0.0);
instanceStruct.instanceVar_NFCEDGE_i = ((NFCEDGE_p>0.0)?NFCEDGE_p:0.0);
instanceStruct.d_instanceVar_EFEDGE_i_dX = ((EFEDGE_p>0.0)?d_EFEDGE_p_dX:0.0);
instanceStruct.instanceVar_EFEDGE_i = ((EFEDGE_p>0.0)?EFEDGE_p:0.0);
instanceStruct.d_instanceVar_RG_i_dX = ((RG_p>0.0)?d_RG_p_dX:0.0);
instanceStruct.instanceVar_RG_i = ((RG_p>0.0)?RG_p:0.0);
instanceStruct.d_instanceVar_RSE_i_dX = ((RSE_p>0.0)?d_RSE_p_dX:0.0);
instanceStruct.instanceVar_RSE_i = ((RSE_p>0.0)?RSE_p:0.0);
instanceStruct.d_instanceVar_RDE_i_dX = ((RDE_p>0.0)?d_RDE_p_dX:0.0);
instanceStruct.instanceVar_RDE_i = ((RDE_p>0.0)?RDE_p:0.0);
instanceStruct.d_instanceVar_RBULK_i_dX = ((RBULK_p>0.0)?d_RBULK_p_dX:0.0);
instanceStruct.instanceVar_RBULK_i = ((RBULK_p>0.0)?RBULK_p:0.0);
instanceStruct.d_instanceVar_RJUNS_i_dX = ((RJUNS_p>0.0)?d_RJUNS_p_dX:0.0);
instanceStruct.instanceVar_RJUNS_i = ((RJUNS_p>0.0)?RJUNS_p:0.0);
instanceStruct.d_instanceVar_RJUND_i_dX = ((RJUND_p>0.0)?d_RJUND_p_dX:0.0);
instanceStruct.instanceVar_RJUND_i = ((RJUND_p>0.0)?RJUND_p:0.0);
instanceStruct.d_instanceVar_RWELL_i_dX = ((RWELL_p>0.0)?d_RWELL_p_dX:0.0);
instanceStruct.instanceVar_RWELL_i = ((RWELL_p>0.0)?RWELL_p:0.0);
instanceStruct.d_instanceVar_MULT_i_dX = (((instanceStruct.instancePar_MULT*NF_i)>0.0)?(instanceStruct.instancePar_MULT*d_NF_i_dX+instanceStruct.d_instancePar_MULT_dX*NF_i):0.0);
instanceStruct.instanceVar_MULT_i = (((instanceStruct.instancePar_MULT*NF_i)>0.0)?(instanceStruct.instancePar_MULT*NF_i):0.0);
d_FACTUO_i_dX = ((instanceStruct.instancePar_FACTUO>0.0)?instanceStruct.d_instancePar_FACTUO_dX:0.0);
FACTUO_i = ((instanceStruct.instancePar_FACTUO>0.0)?instanceStruct.instancePar_FACTUO:0.0);
d_DELVTO_i_dX = instanceStruct.d_instancePar_DELVTO_dX;
DELVTO_i = instanceStruct.instancePar_DELVTO;
d_FACTUOEDGE_i_dX = ((instanceStruct.instancePar_FACTUOEDGE>0.0)?instanceStruct.d_instancePar_FACTUOEDGE_dX:0.0);
FACTUOEDGE_i = ((instanceStruct.instancePar_FACTUOEDGE>0.0)?instanceStruct.instancePar_FACTUOEDGE:0.0);
d_DELVTOEDGE_i_dX = instanceStruct.d_instancePar_DELVTOEDGE_dX;
DELVTOEDGE_i = instanceStruct.instancePar_DELVTOEDGE;
if ((modelStruct.modelVar_SWJUNASYM_i==0))
{
instanceStruct.d_instanceVar_TOXOVD_i_dX = instanceStruct.d_instanceVar_TOXOV_i_dX;
instanceStruct.instanceVar_TOXOVD_i = instanceStruct.instanceVar_TOXOV_i;
instanceStruct.d_instanceVar_NOVD_i_dX = instanceStruct.d_instanceVar_NOV_i_dX;
instanceStruct.instanceVar_NOVD_i = instanceStruct.instanceVar_NOV_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX = instanceStruct.d_instanceVar_AGIDL_i_dX;
instanceStruct.instanceVar_AGIDLD_i = instanceStruct.instanceVar_AGIDL_i;
d_BGIDLD_i_dX = d_BGIDL_i_dX;
BGIDLD_i = BGIDL_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX = instanceStruct.d_instanceVar_STBGIDL_i_dX;
instanceStruct.instanceVar_STBGIDLD_i = instanceStruct.instanceVar_STBGIDL_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX = instanceStruct.d_instanceVar_CGIDL_i_dX;
instanceStruct.instanceVar_CGIDLD_i = instanceStruct.instanceVar_CGIDL_i;
instanceStruct.d_instanceVar_IGOVD_i_dX = instanceStruct.d_instanceVar_IGOV_i_dX;
instanceStruct.instanceVar_IGOVD_i = instanceStruct.instanceVar_IGOV_i;
instanceStruct.d_instanceVar_CGOVD_i_dX = instanceStruct.d_instanceVar_CGOV_i_dX;
instanceStruct.instanceVar_CGOVD_i = instanceStruct.instanceVar_CGOV_i;
instanceStruct.d_instanceVar_CFRD_i_dX = instanceStruct.d_instanceVar_CFR_i_dX;
instanceStruct.instanceVar_CFRD_i = instanceStruct.instanceVar_CFR_i;
}
d_EPSOX_dX = 8.8541878176E-12*instanceStruct.d_instanceVar_EPSROX_i_dX;
EPSOX = (8.8541878176E-12*instanceStruct.instanceVar_EPSROX_i);
d_CoxPrime_dX = ((instanceStruct.instanceVar_TOX_i*d_EPSOX_dX-EPSOX*instanceStruct.d_instanceVar_TOX_i_dX)/instanceStruct.instanceVar_TOX_i/instanceStruct.instanceVar_TOX_i);
CoxPrime = (EPSOX/instanceStruct.instanceVar_TOX_i);
d_tox_sq_dX = (instanceStruct.instanceVar_TOX_i*instanceStruct.d_instanceVar_TOX_i_dX+instanceStruct.d_instanceVar_TOX_i_dX*instanceStruct.instanceVar_TOX_i);
tox_sq = (instanceStruct.instanceVar_TOX_i*instanceStruct.instanceVar_TOX_i);
instanceStruct.d_instanceVar_Cox_over_q_dX = (d_CoxPrime_dX/1.6021918E-19);
instanceStruct.instanceVar_Cox_over_q = (CoxPrime/1.6021918E-19);
d_NEFFAC_i_dX = (instanceStruct.instanceVar_FACNEFFAC_i*instanceStruct.d_instanceVar_NEFF_i_dX+instanceStruct.d_instanceVar_FACNEFFAC_i_dX*instanceStruct.instanceVar_NEFF_i);
NEFFAC_i = (instanceStruct.instanceVar_FACNEFFAC_i*instanceStruct.instanceVar_NEFF_i);
d_NEFFAC_i_dX = ((NEFFAC_i>1.0e20)?((NEFFAC_i<1.0e26)?d_NEFFAC_i_dX:0.0):0.0);
NEFFAC_i = ((NEFFAC_i>1.0e20)?((NEFFAC_i<1.0e26)?NEFFAC_i:1.0e26):1.0e20);
instanceStruct.d_instanceVar_qq_dX = 0.0;
instanceStruct.instanceVar_qq = 0.0;
if ((modelStruct.modelVar_QMC_i>0.0))
{
{
double value_pow_0 = pow(CoxPrime,6.6666666666666667e-01);
double  deriv_pow_0_d0 = ((CoxPrime == 0.0)?0.0:(value_pow_0*6.6666666666666667e-01/CoxPrime));
instanceStruct.d_instanceVar_qq_dX = (((0.4*5.951993)*modelStruct.modelVar_QMC_i)*(deriv_pow_0_d0*(d_CoxPrime_dX))+(0.4*5.951993)*modelStruct.d_modelVar_QMC_i_dX*value_pow_0);
instanceStruct.instanceVar_qq = (((0.4*5.951993)*modelStruct.modelVar_QMC_i)*value_pow_0);
}
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
instanceStruct.d_instanceVar_qq_dX = (7.448711/5.951993)*instanceStruct.d_instanceVar_qq_dX;
instanceStruct.instanceVar_qq = ((7.448711/5.951993)*instanceStruct.instanceVar_qq);
}
}
instanceStruct.d_instanceVar_E_eff0_dX = (1.0e-8*d_CoxPrime_dX/modelStruct.modelVar_EPSSI);
instanceStruct.instanceVar_E_eff0 = ((1.0e-8*CoxPrime)/modelStruct.modelVar_EPSSI);
instanceStruct.d_instanceVar_eta_mu_dX = 0.5*instanceStruct.d_instanceVar_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (0.5*instanceStruct.instanceVar_FETA_i);
instanceStruct.instanceVar_eta_mu1 = 0.5;
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
instanceStruct.d_instanceVar_eta_mu_dX = 3.3333333333333333e-01*instanceStruct.d_instanceVar_FETA_i_dX;
instanceStruct.instanceVar_eta_mu = (3.3333333333333333e-01*instanceStruct.instanceVar_FETA_i);
instanceStruct.instanceVar_eta_mu1 = 3.3333333333333333e-01;
}
instanceStruct.d_instanceVar_inv_AX_dX = (-instanceStruct.d_instanceVar_AX_i_dX/instanceStruct.instanceVar_AX_i/instanceStruct.instanceVar_AX_i);
instanceStruct.instanceVar_inv_AX = (1.0/instanceStruct.instanceVar_AX_i);
instanceStruct.d_instanceVar_inv_VP_dX = (-instanceStruct.d_instanceVar_VP_i_dX/instanceStruct.instanceVar_VP_i/instanceStruct.instanceVar_VP_i);
instanceStruct.instanceVar_inv_VP = (1.0/instanceStruct.instanceVar_VP_i);
d_CoxovPrime_dX = ((instanceStruct.instanceVar_TOXOV_i*d_EPSOX_dX-EPSOX*instanceStruct.d_instanceVar_TOXOV_i_dX)/instanceStruct.instanceVar_TOXOV_i/instanceStruct.instanceVar_TOXOV_i);
CoxovPrime = (EPSOX/instanceStruct.instanceVar_TOXOV_i);
d_CoxovPrime_d_dX = ((instanceStruct.instanceVar_TOXOVD_i*d_EPSOX_dX-EPSOX*instanceStruct.d_instanceVar_TOXOVD_i_dX)/instanceStruct.instanceVar_TOXOVD_i/instanceStruct.instanceVar_TOXOVD_i);
CoxovPrime_d = (EPSOX/instanceStruct.instanceVar_TOXOVD_i);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOV_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phita));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_GOV_s_dX = ((CoxovPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOV_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phita_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NOV_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phita))-value_sqrt_0*d_CoxovPrime_dX)/CoxovPrime/CoxovPrime);
instanceStruct.instanceVar_GOV_s = (value_sqrt_0/CoxovPrime);
}
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOVD_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phita));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_GOV_d_dX = ((CoxovPrime_d*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NOVD_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phita_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NOVD_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phita))-value_sqrt_0*d_CoxovPrime_d_dX)/CoxovPrime_d/CoxovPrime_d);
instanceStruct.instanceVar_GOV_d = (value_sqrt_0/CoxovPrime_d);
}
instanceStruct.d_instanceVar_GOV2_s_dX = (instanceStruct.instanceVar_GOV_s*instanceStruct.d_instanceVar_GOV_s_dX+instanceStruct.d_instanceVar_GOV_s_dX*instanceStruct.instanceVar_GOV_s);
instanceStruct.instanceVar_GOV2_s = (instanceStruct.instanceVar_GOV_s*instanceStruct.instanceVar_GOV_s);
instanceStruct.d_instanceVar_GOV2_d_dX = (instanceStruct.instanceVar_GOV_d*instanceStruct.d_instanceVar_GOV_d_dX+instanceStruct.d_instanceVar_GOV_d_dX*instanceStruct.instanceVar_GOV_d);
instanceStruct.instanceVar_GOV2_d = (instanceStruct.instanceVar_GOV_d*instanceStruct.instanceVar_GOV_d);
d_inv_GOV_dX = (-instanceStruct.d_instanceVar_GOV_s_dX/instanceStruct.instanceVar_GOV_s/instanceStruct.instanceVar_GOV_s);
inv_GOV = (1.0/instanceStruct.instanceVar_GOV_s);
d_SP_OV_eps_dX = 3.1*instanceStruct.d_instanceVar_GOV_s_dX;
SP_OV_eps = ((3.1*instanceStruct.instanceVar_GOV_s)+8.5);
instanceStruct.d_instanceVar_SP_OV_eps2_s_dX = (SP_OV_eps*d_SP_OV_eps_dX+d_SP_OV_eps_dX*SP_OV_eps);
instanceStruct.instanceVar_SP_OV_eps2_s = (SP_OV_eps*SP_OV_eps);
d_SP_OV_delta_dX = 0.5*d_SP_OV_eps_dX;
SP_OV_delta = (0.5*SP_OV_eps);
if ((inv_GOV<0.06))
{
instanceStruct.d_instanceVar_SP_OV_a_s_dX = 64.0*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_s = (64.0*inv_GOV);
}
else
{
if ((inv_GOV<=0.45))
{
instanceStruct.d_instanceVar_SP_OV_a_s_dX = 22.0*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_s = ((22.0*inv_GOV)+3.0);
}
else
{
if ((inv_GOV<=1.6))
{
instanceStruct.d_instanceVar_SP_OV_a_s_dX = (-7.2)*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_s = (((-7.2)*inv_GOV)+15.5);
}
else
{
instanceStruct.d_instanceVar_SP_OV_a_s_dX = instanceStruct.d_instanceVar_GOV_s_dX;
instanceStruct.instanceVar_SP_OV_a_s = instanceStruct.instanceVar_GOV_s;
}
}
}
{
double value_sqrt_0 = sqrt(((SP_OV_delta+(instanceStruct.instanceVar_GOV2_s*0.25))+instanceStruct.instanceVar_SP_OV_a_s));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_SP_OV_delta1_s_dX = ((d_SP_OV_delta_dX+instanceStruct.d_instanceVar_GOV2_s_dX*0.5)-(instanceStruct.instanceVar_GOV_s*deriv_sqrt_0_d0*(((d_SP_OV_delta_dX+instanceStruct.d_instanceVar_GOV2_s_dX*0.25)+instanceStruct.d_instanceVar_SP_OV_a_s_dX))+instanceStruct.d_instanceVar_GOV_s_dX*value_sqrt_0));
instanceStruct.instanceVar_SP_OV_delta1_s = ((SP_OV_delta+(instanceStruct.instanceVar_GOV2_s*0.5))-(instanceStruct.instanceVar_GOV_s*value_sqrt_0));
}
d_inv_GOV_dX = (-instanceStruct.d_instanceVar_GOV_d_dX/instanceStruct.instanceVar_GOV_d/instanceStruct.instanceVar_GOV_d);
inv_GOV = (1.0/instanceStruct.instanceVar_GOV_d);
d_SP_OV_eps_dX = 3.1*instanceStruct.d_instanceVar_GOV_d_dX;
SP_OV_eps = ((3.1*instanceStruct.instanceVar_GOV_d)+8.5);
instanceStruct.d_instanceVar_SP_OV_eps2_d_dX = (SP_OV_eps*d_SP_OV_eps_dX+d_SP_OV_eps_dX*SP_OV_eps);
instanceStruct.instanceVar_SP_OV_eps2_d = (SP_OV_eps*SP_OV_eps);
d_SP_OV_delta_dX = 0.5*d_SP_OV_eps_dX;
SP_OV_delta = (0.5*SP_OV_eps);
if ((inv_GOV<0.06))
{
instanceStruct.d_instanceVar_SP_OV_a_d_dX = 64.0*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_d = (64.0*inv_GOV);
}
else
{
if ((inv_GOV<=0.45))
{
instanceStruct.d_instanceVar_SP_OV_a_d_dX = 22.0*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_d = ((22.0*inv_GOV)+3.0);
}
else
{
if ((inv_GOV<=1.6))
{
instanceStruct.d_instanceVar_SP_OV_a_d_dX = (-7.2)*d_inv_GOV_dX;
instanceStruct.instanceVar_SP_OV_a_d = (((-7.2)*inv_GOV)+15.5);
}
else
{
instanceStruct.d_instanceVar_SP_OV_a_d_dX = instanceStruct.d_instanceVar_GOV_d_dX;
instanceStruct.instanceVar_SP_OV_a_d = instanceStruct.instanceVar_GOV_d;
}
}
}
{
double value_sqrt_0 = sqrt(((SP_OV_delta+(instanceStruct.instanceVar_GOV2_d*0.25))+instanceStruct.instanceVar_SP_OV_a_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_SP_OV_delta1_d_dX = ((d_SP_OV_delta_dX+instanceStruct.d_instanceVar_GOV2_d_dX*0.5)-(instanceStruct.instanceVar_GOV_d*deriv_sqrt_0_d0*(((d_SP_OV_delta_dX+instanceStruct.d_instanceVar_GOV2_d_dX*0.25)+instanceStruct.d_instanceVar_SP_OV_a_d_dX))+instanceStruct.d_instanceVar_GOV_d_dX*value_sqrt_0));
instanceStruct.instanceVar_SP_OV_delta1_d = ((SP_OV_delta+(instanceStruct.instanceVar_GOV2_d*0.5))-(instanceStruct.instanceVar_GOV_d*value_sqrt_0));
}
instanceStruct.d_instanceVar_phit0_dX = (modelStruct.modelVar_phit*(instanceStruct.instanceVar_CT_i*modelStruct.d_modelVar_rTn_dX+instanceStruct.d_instanceVar_CT_i_dX*modelStruct.modelVar_rTn)+modelStruct.d_modelVar_phit_dX*(1.0+(instanceStruct.instanceVar_CT_i*modelStruct.modelVar_rTn)));
instanceStruct.instanceVar_phit0 = (modelStruct.modelVar_phit*(1.0+(instanceStruct.instanceVar_CT_i*modelStruct.modelVar_rTn)));
{
double value_pow_0 = pow(modelStruct.modelVar_phibFac,(-0.75));
double value_log_1 = log(((instanceStruct.instanceVar_NEFF_i*value_pow_0)*4.0e-26));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_phibFac == 0.0)?0.0:(value_pow_0*(-0.75)/modelStruct.modelVar_phibFac));
double  deriv_log_1_d0 = (1.0/((instanceStruct.instanceVar_NEFF_i*value_pow_0)*4.0e-26));
instanceStruct.d_instanceVar_phib_dc_dX = ((modelStruct.d_modelVar_Eg_dX+instanceStruct.d_instanceVar_DPHIB_i_dX)+((2.0*modelStruct.modelVar_phit)*deriv_log_1_d0*((instanceStruct.instanceVar_NEFF_i*(deriv_pow_0_d0*(modelStruct.d_modelVar_phibFac_dX))+instanceStruct.d_instanceVar_NEFF_i_dX*value_pow_0)*4.0e-26)+2.0*modelStruct.d_modelVar_phit_dX*value_log_1));
instanceStruct.instanceVar_phib_dc = ((modelStruct.modelVar_Eg+instanceStruct.instanceVar_DPHIB_i)+((2.0*modelStruct.modelVar_phit)*value_log_1));
}
instanceStruct.d_instanceVar_phib_dc_dX = ((instanceStruct.instanceVar_phib_dc>5.0E-2)?instanceStruct.d_instanceVar_phib_dc_dX:0.0);
instanceStruct.instanceVar_phib_dc = ((instanceStruct.instanceVar_phib_dc>5.0E-2)?instanceStruct.instanceVar_phib_dc:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFF_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_G_0_dc_dX = ((CoxPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFF_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NEFF_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxPrime_dX)/CoxPrime/CoxPrime);
instanceStruct.instanceVar_G_0_dc = (value_sqrt_0/CoxPrime);
}
instanceStruct.d_instanceVar_kp_dX = 0.0;
instanceStruct.instanceVar_kp = 0.0;
d_np_dX = 0.0;
np = 0.0;
if ((instanceStruct.instanceVar_NP_i>0.0))
{
d_arg2max_dX = (-8.0e7*d_tox_sq_dX/tox_sq/tox_sq);
arg2max = (8.0e7/tox_sq);
d_np_dX = ((instanceStruct.instanceVar_NP_i>arg2max)?instanceStruct.d_instanceVar_NP_i_dX:d_arg2max_dX);
np = ((instanceStruct.instanceVar_NP_i>arg2max)?instanceStruct.instanceVar_NP_i:arg2max);
d_np_dX = ((5.0e24>np)?0.0:d_np_dX);
np = ((5.0e24>np)?5.0e24:np);
instanceStruct.d_instanceVar_kp_dX = ((((1.6021918E-19*np)*modelStruct.modelVar_EPSSI)*(((2.0*CoxPrime)*CoxPrime)*modelStruct.d_modelVar_phit_dX+((2.0*CoxPrime)*d_CoxPrime_dX+2.0*d_CoxPrime_dX*CoxPrime)*modelStruct.modelVar_phit)-(((2.0*CoxPrime)*CoxPrime)*modelStruct.modelVar_phit)*1.6021918E-19*d_np_dX*modelStruct.modelVar_EPSSI)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI));
instanceStruct.instanceVar_kp = ((((2.0*CoxPrime)*CoxPrime)*modelStruct.modelVar_phit)/((1.6021918E-19*np)*modelStruct.modelVar_EPSSI));
}
instanceStruct.d_instanceVar_qlim2_dX = ((100.0*modelStruct.modelVar_phit)*modelStruct.d_modelVar_phit_dX+100.0*modelStruct.d_modelVar_phit_dX*modelStruct.modelVar_phit);
instanceStruct.instanceVar_qlim2 = ((100.0*modelStruct.modelVar_phit)*modelStruct.modelVar_phit);
if ((modelStruct.modelVar_QMC_i>0.0))
{
{
double value_sqrt_0 = sqrt((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_dc)*instanceStruct.instanceVar_G_0_dc)*instanceStruct.instanceVar_phib_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qb0_dX = deriv_sqrt_0_d0*((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_dc)*instanceStruct.instanceVar_G_0_dc)*instanceStruct.d_instanceVar_phib_dc_dX+((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_dc)*instanceStruct.d_instanceVar_G_0_dc_dX+(modelStruct.modelVar_phit*instanceStruct.d_instanceVar_G_0_dc_dX+modelStruct.d_modelVar_phit_dX*instanceStruct.instanceVar_G_0_dc)*instanceStruct.instanceVar_G_0_dc)*instanceStruct.instanceVar_phib_dc));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
double  deriv_pow_0_d0 = ((qb0 == 0.0)?0.0:(value_pow_0*6.6666666666666667e-01/qb0));
d_dphibq_dX = ((0.75*instanceStruct.instanceVar_qq)*(deriv_pow_0_d0*(d_qb0_dX))+0.75*instanceStruct.d_instanceVar_qq_dX*value_pow_0);
dphibq = ((0.75*instanceStruct.instanceVar_qq)*value_pow_0);
}
instanceStruct.d_instanceVar_phib_dc_dX = (instanceStruct.d_instanceVar_phib_dc_dX+d_dphibq_dX);
instanceStruct.instanceVar_phib_dc = (instanceStruct.instanceVar_phib_dc+dphibq);
instanceStruct.d_instanceVar_G_0_dc_dX = (instanceStruct.instanceVar_G_0_dc*((qb0*(2.0*6.6666666666666667e-01)*d_dphibq_dX-((2.0*6.6666666666666667e-01)*dphibq)*d_qb0_dX)/qb0/qb0)+instanceStruct.d_instanceVar_G_0_dc_dX*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
instanceStruct.instanceVar_G_0_dc = (instanceStruct.instanceVar_G_0_dc*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_phib_dc);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_sqrt_phib_dc_dX = deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_phib_dc_dX);
instanceStruct.instanceVar_sqrt_phib_dc = value_sqrt_0;
}
instanceStruct.d_instanceVar_phix_dc_dX = 0.95*instanceStruct.d_instanceVar_phib_dc_dX;
instanceStruct.instanceVar_phix_dc = (0.95*instanceStruct.instanceVar_phib_dc);
instanceStruct.d_instanceVar_aphi_dc_dX = ((0.0025*instanceStruct.instanceVar_phib_dc)*instanceStruct.d_instanceVar_phib_dc_dX+0.0025*instanceStruct.d_instanceVar_phib_dc_dX*instanceStruct.instanceVar_phib_dc);
instanceStruct.instanceVar_aphi_dc = ((0.0025*instanceStruct.instanceVar_phib_dc)*instanceStruct.instanceVar_phib_dc);
instanceStruct.d_instanceVar_bphi_dc_dX = instanceStruct.d_instanceVar_aphi_dc_dX;
instanceStruct.instanceVar_bphi_dc = instanceStruct.instanceVar_aphi_dc;
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_bphi_dc);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_phix2_dX = 0.5*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_dc_dX);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((instanceStruct.instanceVar_phix_dc-phix2))*((instanceStruct.instanceVar_phix_dc-phix2)))+instanceStruct.instanceVar_aphi_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_phix1_dc_dX = 0.5*((instanceStruct.d_instanceVar_phix_dc_dX-d_phix2_dX)-deriv_sqrt_0_d0*(((((instanceStruct.instanceVar_phix_dc-phix2))*(instanceStruct.d_instanceVar_phix_dc_dX-d_phix2_dX)+(instanceStruct.d_instanceVar_phix_dc_dX-d_phix2_dX)*((instanceStruct.instanceVar_phix_dc-phix2)))+instanceStruct.d_instanceVar_aphi_dc_dX)));
instanceStruct.instanceVar_phix1_dc = (0.5*((instanceStruct.instanceVar_phix_dc-phix2)-value_sqrt_0));
}
instanceStruct.d_instanceVar_alpha_b_dX = 0.5*(instanceStruct.d_instanceVar_phib_dc_dX+modelStruct.d_modelVar_Eg_dX);
instanceStruct.instanceVar_alpha_b = (0.5*(instanceStruct.instanceVar_phib_dc+modelStruct.modelVar_Eg));
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_VSBNUD_i+instanceStruct.instanceVar_phib_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_us1_dX = (deriv_sqrt_0_d0*((instanceStruct.d_instanceVar_VSBNUD_i_dX+instanceStruct.d_instanceVar_phib_dc_dX))-instanceStruct.d_instanceVar_sqrt_phib_dc_dX);
instanceStruct.instanceVar_us1 = (value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc);
}
{
double value_sqrt_0 = sqrt(((instanceStruct.instanceVar_VSBNUD_i+instanceStruct.instanceVar_DVSBNUD_i)+instanceStruct.instanceVar_phib_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_us21_dX = ((deriv_sqrt_0_d0*(((instanceStruct.d_instanceVar_VSBNUD_i_dX+instanceStruct.d_instanceVar_DVSBNUD_i_dX)+instanceStruct.d_instanceVar_phib_dc_dX))-instanceStruct.d_instanceVar_sqrt_phib_dc_dX)-instanceStruct.d_instanceVar_us1_dX);
instanceStruct.instanceVar_us21 = ((value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc)-instanceStruct.instanceVar_us1);
}
{
double value_pow_0 = pow(modelStruct.modelVar_phibFac,(-0.75));
double value_log_1 = log(((NEFFAC_i*value_pow_0)*4.0e-26));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_phibFac == 0.0)?0.0:(value_pow_0*(-0.75)/modelStruct.modelVar_phibFac));
double  deriv_log_1_d0 = (1.0/((NEFFAC_i*value_pow_0)*4.0e-26));
instanceStruct.d_instanceVar_phib_ac_dX = (((modelStruct.d_modelVar_Eg_dX+instanceStruct.d_instanceVar_DPHIB_i_dX)+instanceStruct.d_instanceVar_DELVTAC_i_dX)+((2.0*modelStruct.modelVar_phit)*deriv_log_1_d0*((NEFFAC_i*(deriv_pow_0_d0*(modelStruct.d_modelVar_phibFac_dX))+d_NEFFAC_i_dX*value_pow_0)*4.0e-26)+2.0*modelStruct.d_modelVar_phit_dX*value_log_1));
instanceStruct.instanceVar_phib_ac = (((modelStruct.modelVar_Eg+instanceStruct.instanceVar_DPHIB_i)+instanceStruct.instanceVar_DELVTAC_i)+((2.0*modelStruct.modelVar_phit)*value_log_1));
}
instanceStruct.d_instanceVar_phib_ac_dX = ((instanceStruct.instanceVar_phib_ac>5.0E-2)?instanceStruct.d_instanceVar_phib_ac_dX:0.0);
instanceStruct.instanceVar_phib_ac = ((instanceStruct.instanceVar_phib_ac>5.0E-2)?instanceStruct.instanceVar_phib_ac:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*NEFFAC_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_G_0_ac_dX = ((CoxPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*NEFFAC_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*d_NEFFAC_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxPrime_dX)/CoxPrime/CoxPrime);
instanceStruct.instanceVar_G_0_ac = (value_sqrt_0/CoxPrime);
}
if ((modelStruct.modelVar_QMC_i>0.0))
{
{
double value_sqrt_0 = sqrt((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_ac)*instanceStruct.instanceVar_G_0_ac)*instanceStruct.instanceVar_phib_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_qb0_dX = deriv_sqrt_0_d0*((((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_ac)*instanceStruct.instanceVar_G_0_ac)*instanceStruct.d_instanceVar_phib_ac_dX+((modelStruct.modelVar_phit*instanceStruct.instanceVar_G_0_ac)*instanceStruct.d_instanceVar_G_0_ac_dX+(modelStruct.modelVar_phit*instanceStruct.d_instanceVar_G_0_ac_dX+modelStruct.d_modelVar_phit_dX*instanceStruct.instanceVar_G_0_ac)*instanceStruct.instanceVar_G_0_ac)*instanceStruct.instanceVar_phib_ac));
qb0 = value_sqrt_0;
}
{
double value_pow_0 = pow(qb0,6.6666666666666667e-01);
double  deriv_pow_0_d0 = ((qb0 == 0.0)?0.0:(value_pow_0*6.6666666666666667e-01/qb0));
d_dphibq_dX = ((0.75*instanceStruct.instanceVar_qq)*(deriv_pow_0_d0*(d_qb0_dX))+0.75*instanceStruct.d_instanceVar_qq_dX*value_pow_0);
dphibq = ((0.75*instanceStruct.instanceVar_qq)*value_pow_0);
}
instanceStruct.d_instanceVar_phib_ac_dX = (instanceStruct.d_instanceVar_phib_ac_dX+d_dphibq_dX);
instanceStruct.instanceVar_phib_ac = (instanceStruct.instanceVar_phib_ac+dphibq);
instanceStruct.d_instanceVar_G_0_ac_dX = (instanceStruct.instanceVar_G_0_ac*((qb0*(2.0*6.6666666666666667e-01)*d_dphibq_dX-((2.0*6.6666666666666667e-01)*dphibq)*d_qb0_dX)/qb0/qb0)+instanceStruct.d_instanceVar_G_0_ac_dX*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
instanceStruct.instanceVar_G_0_ac = (instanceStruct.instanceVar_G_0_ac*(1.0+(((2.0*6.6666666666666667e-01)*dphibq)/qb0)));
}
instanceStruct.d_instanceVar_phix_ac_dX = 0.95*instanceStruct.d_instanceVar_phib_ac_dX;
instanceStruct.instanceVar_phix_ac = (0.95*instanceStruct.instanceVar_phib_ac);
instanceStruct.d_instanceVar_aphi_ac_dX = ((0.0025*instanceStruct.instanceVar_phib_ac)*instanceStruct.d_instanceVar_phib_ac_dX+0.0025*instanceStruct.d_instanceVar_phib_ac_dX*instanceStruct.instanceVar_phib_ac);
instanceStruct.instanceVar_aphi_ac = ((0.0025*instanceStruct.instanceVar_phib_ac)*instanceStruct.instanceVar_phib_ac);
instanceStruct.d_instanceVar_bphi_ac_dX = instanceStruct.d_instanceVar_aphi_ac_dX;
instanceStruct.instanceVar_bphi_ac = instanceStruct.instanceVar_aphi_ac;
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_bphi_ac);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_phix2_dX = 0.5*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_ac_dX);
phix2 = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((instanceStruct.instanceVar_phix_ac-phix2))*((instanceStruct.instanceVar_phix_ac-phix2)))+instanceStruct.instanceVar_aphi_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_phix1_ac_dX = 0.5*((instanceStruct.d_instanceVar_phix_ac_dX-d_phix2_dX)-deriv_sqrt_0_d0*(((((instanceStruct.instanceVar_phix_ac-phix2))*(instanceStruct.d_instanceVar_phix_ac_dX-d_phix2_dX)+(instanceStruct.d_instanceVar_phix_ac_dX-d_phix2_dX)*((instanceStruct.instanceVar_phix_ac-phix2)))+instanceStruct.d_instanceVar_aphi_ac_dX)));
instanceStruct.instanceVar_phix1_ac = (0.5*((instanceStruct.instanceVar_phix_ac-phix2)-value_sqrt_0));
}
instanceStruct.d_instanceVar_VFB_T_dX = ((d_VFB_i_dX+(instanceStruct.instanceVar_STVFB_i*modelStruct.d_modelVar_delT_dX+instanceStruct.d_instanceVar_STVFB_i_dX*modelStruct.modelVar_delT))+d_DELVTO_i_dX);
instanceStruct.instanceVar_VFB_T = ((VFB_i+(instanceStruct.instanceVar_STVFB_i*modelStruct.modelVar_delT))+DELVTO_i);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STBET_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_bet_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STBET_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STBET_i_dX*modelStruct.modelVar_ln_rTn));
tf_bet = value_exp_0;
}
instanceStruct.d_instanceVar_BETN_T_dX = (BETN_i*d_tf_bet_dX+d_BETN_i_dX*tf_bet);
instanceStruct.instanceVar_BETN_T = (BETN_i*tf_bet);
instanceStruct.d_instanceVar_BET_i_dX = ((FACTUO_i*instanceStruct.instanceVar_BETN_T)*d_CoxPrime_dX+(FACTUO_i*instanceStruct.d_instanceVar_BETN_T_dX+d_FACTUO_i_dX*instanceStruct.instanceVar_BETN_T)*CoxPrime);
instanceStruct.instanceVar_BET_i = ((FACTUO_i*instanceStruct.instanceVar_BETN_T)*CoxPrime);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHEMU_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_THEMU_T_dX = (THEMU_i*deriv_exp_0_d0*((instanceStruct.instanceVar_STTHEMU_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STTHEMU_i_dX*modelStruct.modelVar_ln_rTn))+d_THEMU_i_dX*value_exp_0);
instanceStruct.instanceVar_THEMU_T = (THEMU_i*value_exp_0);
}
{
double value_exp_0 = exp((instanceStruct.instanceVar_STMUE_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_mue_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STMUE_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STMUE_i_dX*modelStruct.modelVar_ln_rTn));
tf_mue = value_exp_0;
}
instanceStruct.d_instanceVar_MUE_T_dX = (MUE_i*d_tf_mue_dX+d_MUE_i_dX*tf_mue);
instanceStruct.instanceVar_MUE_T = (MUE_i*tf_mue);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STCS_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_cs_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STCS_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STCS_i_dX*modelStruct.modelVar_ln_rTn));
tf_cs = value_exp_0;
}
instanceStruct.d_instanceVar_CS_T_dX = (CS_i*d_tf_cs_dX+d_CS_i_dX*tf_cs);
instanceStruct.instanceVar_CS_T = (CS_i*tf_cs);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STXCOR_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_xcor_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STXCOR_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STXCOR_i_dX*modelStruct.modelVar_ln_rTn));
tf_xcor = value_exp_0;
}
instanceStruct.d_instanceVar_XCOR_T_dX = (XCOR_i*d_tf_xcor_dX+d_XCOR_i_dX*tf_xcor);
instanceStruct.instanceVar_XCOR_T = (XCOR_i*tf_xcor);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STRS_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_ther_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STRS_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STRS_i_dX*modelStruct.modelVar_ln_rTn));
tf_ther = value_exp_0;
}
instanceStruct.d_instanceVar_RS_T_dX = (RS_i*d_tf_ther_dX+d_RS_i_dX*tf_ther);
instanceStruct.instanceVar_RS_T = (RS_i*tf_ther);
instanceStruct.d_instanceVar_THER_i_dX = ((2.0*instanceStruct.instanceVar_BET_i)*instanceStruct.d_instanceVar_RS_T_dX+2.0*instanceStruct.d_instanceVar_BET_i_dX*instanceStruct.instanceVar_RS_T);
instanceStruct.instanceVar_THER_i = ((2.0*instanceStruct.instanceVar_BET_i)*instanceStruct.instanceVar_RS_T);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STTHESAT_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_thesat_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STTHESAT_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STTHESAT_i_dX*modelStruct.modelVar_ln_rTn));
tf_thesat = value_exp_0;
}
instanceStruct.d_instanceVar_THESAT_T_dX = (THESAT_i*d_tf_thesat_dX+d_THESAT_i_dX*tf_thesat);
instanceStruct.instanceVar_THESAT_T = (THESAT_i*tf_thesat);
{
double value_exp_0 = exp(((-instanceStruct.instanceVar_STA2_i)*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_A2_T_dX = (A2_i*deriv_exp_0_d0*(((-instanceStruct.instanceVar_STA2_i)*modelStruct.d_modelVar_ln_rTn_dX+(-instanceStruct.d_instanceVar_STA2_i_dX)*modelStruct.modelVar_ln_rTn))+d_A2_i_dX*value_exp_0);
instanceStruct.instanceVar_A2_T = (A2_i*value_exp_0);
}
instanceStruct.d_instanceVar_nt_dX = (((instanceStruct.instanceVar_FNT_i*4.0)*1.3806505E-23)*modelStruct.d_modelVar_TKD_dX+instanceStruct.d_instanceVar_FNT_i_dX*4.0*1.3806505E-23*modelStruct.modelVar_TKD);
instanceStruct.instanceVar_nt = (((instanceStruct.instanceVar_FNT_i*4.0)*1.3806505E-23)*modelStruct.modelVar_TKD);
instanceStruct.d_instanceVar_Sfl_prefac_dX = ((instanceStruct.instanceVar_Cox_over_q*((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.d_instanceVar_BET_i_dX+(modelStruct.modelVar_phit*modelStruct.d_modelVar_phit_dX+modelStruct.d_modelVar_phit_dX*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)-((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)*instanceStruct.d_instanceVar_Cox_over_q_dX)/instanceStruct.instanceVar_Cox_over_q/instanceStruct.instanceVar_Cox_over_q);
instanceStruct.instanceVar_Sfl_prefac = (((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BET_i)/instanceStruct.instanceVar_Cox_over_q);
if (((modelStruct.modelVar_SWEDGE_i!=0.0)&&(instanceStruct.instanceVar_BETNEDGE_i>0.0)))
{
instanceStruct.d_instanceVar_VFBEDGE_T_dX = ((d_VFBEDGE_i_dX+(instanceStruct.instanceVar_STVFBEDGE_i*modelStruct.d_modelVar_delT_dX+instanceStruct.d_instanceVar_STVFBEDGE_i_dX*modelStruct.modelVar_delT))+d_DELVTOEDGE_i_dX);
instanceStruct.instanceVar_VFBEDGE_T = ((VFBEDGE_i+(instanceStruct.instanceVar_STVFBEDGE_i*modelStruct.modelVar_delT))+DELVTOEDGE_i);
{
double value_exp_0 = exp((instanceStruct.instanceVar_STBETEDGE_i*modelStruct.modelVar_ln_rTn));
double  deriv_exp_0_d0 = value_exp_0;
d_tf_betedge_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_STBETEDGE_i*modelStruct.d_modelVar_ln_rTn_dX+instanceStruct.d_instanceVar_STBETEDGE_i_dX*modelStruct.modelVar_ln_rTn));
tf_betedge = value_exp_0;
}
instanceStruct.d_instanceVar_BETNEDGE_T_dX = (instanceStruct.instanceVar_BETNEDGE_i*d_tf_betedge_dX+instanceStruct.d_instanceVar_BETNEDGE_i_dX*tf_betedge);
instanceStruct.instanceVar_BETNEDGE_T = (instanceStruct.instanceVar_BETNEDGE_i*tf_betedge);
instanceStruct.d_instanceVar_BETEDGE_i_dX = ((FACTUOEDGE_i*instanceStruct.instanceVar_BETNEDGE_T)*d_CoxPrime_dX+(FACTUOEDGE_i*instanceStruct.d_instanceVar_BETNEDGE_T_dX+d_FACTUOEDGE_i_dX*instanceStruct.instanceVar_BETNEDGE_T)*CoxPrime);
instanceStruct.instanceVar_BETEDGE_i = ((FACTUOEDGE_i*instanceStruct.instanceVar_BETNEDGE_T)*CoxPrime);
instanceStruct.d_instanceVar_phit0edge_dX = (modelStruct.modelVar_phit*(instanceStruct.instanceVar_CTEDGE_i*modelStruct.d_modelVar_rTn_dX+instanceStruct.d_instanceVar_CTEDGE_i_dX*modelStruct.modelVar_rTn)+modelStruct.d_modelVar_phit_dX*(1.0+(instanceStruct.instanceVar_CTEDGE_i*modelStruct.modelVar_rTn)));
instanceStruct.instanceVar_phit0edge = (modelStruct.modelVar_phit*(1.0+(instanceStruct.instanceVar_CTEDGE_i*modelStruct.modelVar_rTn)));
{
double value_pow_0 = pow(modelStruct.modelVar_phibFac,(-0.75));
double value_log_1 = log(((instanceStruct.instanceVar_NEFFEDGE_i*value_pow_0)*4.0e-26));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_phibFac == 0.0)?0.0:(value_pow_0*(-0.75)/modelStruct.modelVar_phibFac));
double  deriv_log_1_d0 = (1.0/((instanceStruct.instanceVar_NEFFEDGE_i*value_pow_0)*4.0e-26));
instanceStruct.d_instanceVar_phibedge_dX = ((modelStruct.d_modelVar_Eg_dX+instanceStruct.d_instanceVar_DPHIBEDGE_i_dX)+((2.0*instanceStruct.instanceVar_phit0edge)*deriv_log_1_d0*((instanceStruct.instanceVar_NEFFEDGE_i*(deriv_pow_0_d0*(modelStruct.d_modelVar_phibFac_dX))+instanceStruct.d_instanceVar_NEFFEDGE_i_dX*value_pow_0)*4.0e-26)+2.0*instanceStruct.d_instanceVar_phit0edge_dX*value_log_1));
instanceStruct.instanceVar_phibedge = ((modelStruct.modelVar_Eg+instanceStruct.instanceVar_DPHIBEDGE_i)+((2.0*instanceStruct.instanceVar_phit0edge)*value_log_1));
}
instanceStruct.d_instanceVar_phibedge_dX = ((instanceStruct.instanceVar_phibedge>5.0E-2)?instanceStruct.d_instanceVar_phibedge_dX:0.0);
instanceStruct.instanceVar_phibedge = ((instanceStruct.instanceVar_phibedge>5.0E-2)?instanceStruct.instanceVar_phibedge:5.0E-2);
{
double value_sqrt_0 = sqrt(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFFEDGE_i)*modelStruct.modelVar_EPSSI)*modelStruct.modelVar_inv_phit));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_Gfedge_dX = ((CoxPrime*deriv_sqrt_0_d0*(((((2.0*1.6021918E-19)*instanceStruct.instanceVar_NEFFEDGE_i)*modelStruct.modelVar_EPSSI)*modelStruct.d_modelVar_inv_phit_dX+(2.0*1.6021918E-19)*instanceStruct.d_instanceVar_NEFFEDGE_i_dX*modelStruct.modelVar_EPSSI*modelStruct.modelVar_inv_phit))-value_sqrt_0*d_CoxPrime_dX)/CoxPrime/CoxPrime);
instanceStruct.instanceVar_Gfedge = (value_sqrt_0/CoxPrime);
}
instanceStruct.d_instanceVar_Gfedge2_dX = (instanceStruct.instanceVar_Gfedge*instanceStruct.d_instanceVar_Gfedge_dX+instanceStruct.d_instanceVar_Gfedge_dX*instanceStruct.instanceVar_Gfedge);
instanceStruct.instanceVar_Gfedge2 = (instanceStruct.instanceVar_Gfedge*instanceStruct.instanceVar_Gfedge);
{
double value_log_0 = log(instanceStruct.instanceVar_Gfedge2);
double  deriv_log_0_d0 = (1.0/instanceStruct.instanceVar_Gfedge2);
instanceStruct.d_instanceVar_lnGfedge2_dX = deriv_log_0_d0*(instanceStruct.d_instanceVar_Gfedge2_dX);
instanceStruct.instanceVar_lnGfedge2 = value_log_0;
}
instanceStruct.d_instanceVar_phixedge_dX = 0.95*instanceStruct.d_instanceVar_phibedge_dX;
instanceStruct.instanceVar_phixedge = (0.95*instanceStruct.instanceVar_phibedge);
instanceStruct.d_instanceVar_aphiedge_dX = ((0.0025*instanceStruct.instanceVar_phibedge)*instanceStruct.d_instanceVar_phibedge_dX+0.0025*instanceStruct.d_instanceVar_phibedge_dX*instanceStruct.instanceVar_phibedge);
instanceStruct.instanceVar_aphiedge = ((0.0025*instanceStruct.instanceVar_phibedge)*instanceStruct.instanceVar_phibedge);
instanceStruct.d_instanceVar_bphiedge_dX = instanceStruct.d_instanceVar_aphiedge_dX;
instanceStruct.instanceVar_bphiedge = instanceStruct.instanceVar_aphiedge;
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_bphiedge);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_phix2edge_dX = 0.5*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphiedge_dX);
phix2edge = (0.5*value_sqrt_0);
}
{
double value_sqrt_0 = sqrt(((((instanceStruct.instanceVar_phixedge-phix2edge))*((instanceStruct.instanceVar_phixedge-phix2edge)))+instanceStruct.instanceVar_aphiedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_phix1edge_dX = 0.5*((instanceStruct.d_instanceVar_phixedge_dX-d_phix2edge_dX)-deriv_sqrt_0_d0*(((((instanceStruct.instanceVar_phixedge-phix2edge))*(instanceStruct.d_instanceVar_phixedge_dX-d_phix2edge_dX)+(instanceStruct.d_instanceVar_phixedge_dX-d_phix2edge_dX)*((instanceStruct.instanceVar_phixedge-phix2edge)))+instanceStruct.d_instanceVar_aphiedge_dX)));
instanceStruct.instanceVar_phix1edge = (0.5*((instanceStruct.instanceVar_phixedge-phix2edge)-value_sqrt_0));
}
instanceStruct.d_instanceVar_Sfl_prefac_edge_dX = ((instanceStruct.instanceVar_Cox_over_q*((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.d_instanceVar_BETEDGE_i_dX+(modelStruct.modelVar_phit*modelStruct.d_modelVar_phit_dX+modelStruct.d_modelVar_phit_dX*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BETEDGE_i)-((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BETEDGE_i)*instanceStruct.d_instanceVar_Cox_over_q_dX)/instanceStruct.instanceVar_Cox_over_q/instanceStruct.instanceVar_Cox_over_q);
instanceStruct.instanceVar_Sfl_prefac_edge = (((modelStruct.modelVar_phit*modelStruct.modelVar_phit)*instanceStruct.instanceVar_BETEDGE_i)/instanceStruct.instanceVar_Cox_over_q);
instanceStruct.d_instanceVar_ntedge_dX = (((instanceStruct.instanceVar_FNTEDGE_i*4.0)*1.3806505E-23)*modelStruct.d_modelVar_TKD_dX+instanceStruct.d_instanceVar_FNTEDGE_i_dX*4.0*1.3806505E-23*modelStruct.modelVar_TKD);
instanceStruct.instanceVar_ntedge = (((instanceStruct.instanceVar_FNTEDGE_i*4.0)*1.3806505E-23)*modelStruct.modelVar_TKD);
}
else
{
instanceStruct.d_instanceVar_VFBEDGE_T_dX = 0.0;
instanceStruct.instanceVar_VFBEDGE_T = 0.0;
d_tf_betedge_dX = 0.0;
tf_betedge = 1.0;
instanceStruct.d_instanceVar_BETNEDGE_T_dX = 0.0;
instanceStruct.instanceVar_BETNEDGE_T = 0.0;
instanceStruct.d_instanceVar_BETEDGE_i_dX = 0.0;
instanceStruct.instanceVar_BETEDGE_i = 0.0;
instanceStruct.d_instanceVar_phit0edge_dX = modelStruct.d_modelVar_phit_dX;
instanceStruct.instanceVar_phit0edge = modelStruct.modelVar_phit;
instanceStruct.d_instanceVar_phibedge_dX = 0.0;
instanceStruct.instanceVar_phibedge = 0.0;
instanceStruct.d_instanceVar_Gfedge_dX = 0.0;
instanceStruct.instanceVar_Gfedge = 1.0;
instanceStruct.d_instanceVar_Gfedge2_dX = 0.0;
instanceStruct.instanceVar_Gfedge2 = 1.0;
instanceStruct.d_instanceVar_lnGfedge2_dX = 0.0;
instanceStruct.instanceVar_lnGfedge2 = 0.0;
instanceStruct.d_instanceVar_phixedge_dX = 0.0;
instanceStruct.instanceVar_phixedge = 0.0;
instanceStruct.d_instanceVar_aphiedge_dX = 0.0;
instanceStruct.instanceVar_aphiedge = 0.0;
instanceStruct.d_instanceVar_bphiedge_dX = 0.0;
instanceStruct.instanceVar_bphiedge = 0.0;
d_phix2edge_dX = 0.0;
phix2edge = 0.0;
instanceStruct.d_instanceVar_phix1edge_dX = 0.0;
instanceStruct.instanceVar_phix1edge = 0.0;
instanceStruct.d_instanceVar_Sfl_prefac_edge_dX = 0.0;
instanceStruct.instanceVar_Sfl_prefac_edge = 0.0;
instanceStruct.d_instanceVar_ntedge_dX = 0.0;
instanceStruct.instanceVar_ntedge = 1.0;
}
instanceStruct.d_instanceVar_inv_CHIB_dX = (-instanceStruct.d_instanceVar_CHIB_i_dX/instanceStruct.instanceVar_CHIB_i/instanceStruct.instanceVar_CHIB_i);
instanceStruct.instanceVar_inv_CHIB = (1.0/instanceStruct.instanceVar_CHIB_i);
{
double value_sqrt_0 = sqrt((((2.0*1.6021918E-19)*9.1093826E-31)*instanceStruct.instanceVar_CHIB_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_B_fact_dX = ((4.0*3.3333333333333333e-01)*deriv_sqrt_0_d0*(((2.0*1.6021918E-19)*9.1093826E-31)*instanceStruct.d_instanceVar_CHIB_i_dX)/1.05457168E-34);
B_fact = (((4.0*3.3333333333333333e-01)*value_sqrt_0)/1.05457168E-34);
}
instanceStruct.d_instanceVar_BCH_dX = (B_fact*instanceStruct.d_instanceVar_TOX_i_dX+d_B_fact_dX*instanceStruct.instanceVar_TOX_i);
instanceStruct.instanceVar_BCH = (B_fact*instanceStruct.instanceVar_TOX_i);
instanceStruct.d_instanceVar_BOV_dX = (B_fact*instanceStruct.d_instanceVar_TOXOV_i_dX+d_B_fact_dX*instanceStruct.instanceVar_TOXOV_i);
instanceStruct.instanceVar_BOV = (B_fact*instanceStruct.instanceVar_TOXOV_i);
instanceStruct.d_instanceVar_BOV_d_dX = (B_fact*instanceStruct.d_instanceVar_TOXOVD_i_dX+d_B_fact_dX*instanceStruct.instanceVar_TOXOVD_i);
instanceStruct.instanceVar_BOV_d = (B_fact*instanceStruct.instanceVar_TOXOVD_i);
instanceStruct.d_instanceVar_GCQ_dX = 0.0;
instanceStruct.instanceVar_GCQ = 0.0;
if ((instanceStruct.instanceVar_GC3_i<0))
{
instanceStruct.d_instanceVar_GCQ_dX = ((instanceStruct.instanceVar_GC3_i*(-0.495)*instanceStruct.d_instanceVar_GC2_i_dX-((-0.495)*instanceStruct.instanceVar_GC2_i)*instanceStruct.d_instanceVar_GC3_i_dX)/instanceStruct.instanceVar_GC3_i/instanceStruct.instanceVar_GC3_i);
instanceStruct.instanceVar_GCQ = (((-0.495)*instanceStruct.instanceVar_GC2_i)/instanceStruct.instanceVar_GC3_i);
}
{
double value_pow_0 = pow(modelStruct.modelVar_rTa,instanceStruct.instanceVar_STIG_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_rTa == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_STIG_i/modelStruct.modelVar_rTa));
double  deriv_pow_0_d1 = (modelStruct.modelVar_rTa == 0.0)?0.0:(log(modelStruct.modelVar_rTa)*value_pow_0);
d_tf_ig_dX = ((deriv_pow_0_d0*(modelStruct.d_modelVar_rTa_dX))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_STIG_i_dX)));
tf_ig = value_pow_0;
}
instanceStruct.d_instanceVar_IGINV_i_dX = (instanceStruct.instanceVar_IGINV_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGINV_i_dX*tf_ig);
instanceStruct.instanceVar_IGINV_i = (instanceStruct.instanceVar_IGINV_i*tf_ig);
instanceStruct.d_instanceVar_IGOV_i_dX = (instanceStruct.instanceVar_IGOV_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGOV_i_dX*tf_ig);
instanceStruct.instanceVar_IGOV_i = (instanceStruct.instanceVar_IGOV_i*tf_ig);
instanceStruct.d_instanceVar_IGOVD_i_dX = (instanceStruct.instanceVar_IGOVD_i*d_tf_ig_dX+instanceStruct.d_instanceVar_IGOVD_i_dX*tf_ig);
instanceStruct.instanceVar_IGOVD_i = (instanceStruct.instanceVar_IGOVD_i*tf_ig);
instanceStruct.d_instanceVar_AGIDLs_dX = (((instanceStruct.instanceVar_TOXOV_i*instanceStruct.instanceVar_TOXOV_i)*instanceStruct.d_instanceVar_AGIDL_i_dX*4.0e-18-(instanceStruct.instanceVar_AGIDL_i*4.0e-18)*(instanceStruct.instanceVar_TOXOV_i*instanceStruct.d_instanceVar_TOXOV_i_dX+instanceStruct.d_instanceVar_TOXOV_i_dX*instanceStruct.instanceVar_TOXOV_i))/(instanceStruct.instanceVar_TOXOV_i*instanceStruct.instanceVar_TOXOV_i)/(instanceStruct.instanceVar_TOXOV_i*instanceStruct.instanceVar_TOXOV_i));
instanceStruct.instanceVar_AGIDLs = ((instanceStruct.instanceVar_AGIDL_i*4.0e-18)/(instanceStruct.instanceVar_TOXOV_i*instanceStruct.instanceVar_TOXOV_i));
instanceStruct.d_instanceVar_AGIDLDs_dX = (((instanceStruct.instanceVar_TOXOVD_i*instanceStruct.instanceVar_TOXOVD_i)*instanceStruct.d_instanceVar_AGIDLD_i_dX*4.0e-18-(instanceStruct.instanceVar_AGIDLD_i*4.0e-18)*(instanceStruct.instanceVar_TOXOVD_i*instanceStruct.d_instanceVar_TOXOVD_i_dX+instanceStruct.d_instanceVar_TOXOVD_i_dX*instanceStruct.instanceVar_TOXOVD_i))/(instanceStruct.instanceVar_TOXOVD_i*instanceStruct.instanceVar_TOXOVD_i)/(instanceStruct.instanceVar_TOXOVD_i*instanceStruct.instanceVar_TOXOVD_i));
instanceStruct.instanceVar_AGIDLDs = ((instanceStruct.instanceVar_AGIDLD_i*4.0e-18)/(instanceStruct.instanceVar_TOXOVD_i*instanceStruct.instanceVar_TOXOVD_i));
d_B_fact_dX = (((1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_delTa))>0.0)?(instanceStruct.instanceVar_STBGIDL_i*modelStruct.d_modelVar_delTa_dX+instanceStruct.d_instanceVar_STBGIDL_i_dX*modelStruct.modelVar_delTa):0.0);
B_fact = (((1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_delTa))>0.0)?(1.0+(instanceStruct.instanceVar_STBGIDL_i*modelStruct.modelVar_delTa)):0.0);
instanceStruct.d_instanceVar_BGIDL_T_dX = (BGIDL_i*d_B_fact_dX+d_BGIDL_i_dX*B_fact);
instanceStruct.instanceVar_BGIDL_T = (BGIDL_i*B_fact);
instanceStruct.d_instanceVar_BGIDLs_dX = (instanceStruct.instanceVar_BGIDL_T*instanceStruct.d_instanceVar_TOXOV_i_dX+instanceStruct.d_instanceVar_BGIDL_T_dX*instanceStruct.instanceVar_TOXOV_i)*5.0e8;
instanceStruct.instanceVar_BGIDLs = ((instanceStruct.instanceVar_BGIDL_T*instanceStruct.instanceVar_TOXOV_i)*5.0e8);
d_B_fact_dX = (((1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_delTa))>0.0)?(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.d_modelVar_delTa_dX+instanceStruct.d_instanceVar_STBGIDLD_i_dX*modelStruct.modelVar_delTa):0.0);
B_fact = (((1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_delTa))>0.0)?(1.0+(instanceStruct.instanceVar_STBGIDLD_i*modelStruct.modelVar_delTa)):0.0);
instanceStruct.d_instanceVar_BGIDLD_T_dX = (BGIDLD_i*d_B_fact_dX+d_BGIDLD_i_dX*B_fact);
instanceStruct.instanceVar_BGIDLD_T = (BGIDLD_i*B_fact);
instanceStruct.d_instanceVar_BGIDLDs_dX = (instanceStruct.instanceVar_BGIDLD_T*instanceStruct.d_instanceVar_TOXOVD_i_dX+instanceStruct.d_instanceVar_BGIDLD_T_dX*instanceStruct.instanceVar_TOXOVD_i)*5.0e8;
instanceStruct.instanceVar_BGIDLDs = ((instanceStruct.instanceVar_BGIDLD_T*instanceStruct.instanceVar_TOXOVD_i)*5.0e8);
instanceStruct.d_instanceVar_fac_exc_dX = (9.1093826E-31*1.0e9)*instanceStruct.d_instanceVar_FNTEXC_i_dX;
instanceStruct.instanceVar_fac_exc = ((9.1093826E-31*1.0e9)*instanceStruct.instanceVar_FNTEXC_i);
if ((instanceStruct.instanceVar_RG_i>0.0))
{
instanceStruct.d_instanceVar_ggate_dX = (-instanceStruct.d_instanceVar_RG_i_dX/instanceStruct.instanceVar_RG_i/instanceStruct.instanceVar_RG_i);
instanceStruct.instanceVar_ggate = (1.0/instanceStruct.instanceVar_RG_i);
}
else
{
instanceStruct.d_instanceVar_ggate_dX = 0.0;
instanceStruct.instanceVar_ggate = 0.0;
}
if ((instanceStruct.instanceVar_RSE_i>0.0))
{
instanceStruct.d_instanceVar_gsource_dX = (-instanceStruct.d_instanceVar_RSE_i_dX/instanceStruct.instanceVar_RSE_i/instanceStruct.instanceVar_RSE_i);
instanceStruct.instanceVar_gsource = (1.0/instanceStruct.instanceVar_RSE_i);
}
else
{
instanceStruct.d_instanceVar_gsource_dX = 0.0;
instanceStruct.instanceVar_gsource = 0.0;
}
if ((instanceStruct.instanceVar_RDE_i>0.0))
{
instanceStruct.d_instanceVar_gdrain_dX = (-instanceStruct.d_instanceVar_RDE_i_dX/instanceStruct.instanceVar_RDE_i/instanceStruct.instanceVar_RDE_i);
instanceStruct.instanceVar_gdrain = (1.0/instanceStruct.instanceVar_RDE_i);
}
else
{
instanceStruct.d_instanceVar_gdrain_dX = 0.0;
instanceStruct.instanceVar_gdrain = 0.0;
}
if ((instanceStruct.instanceVar_RBULK_i>0.0))
{
instanceStruct.d_instanceVar_gbulk_dX = (-instanceStruct.d_instanceVar_RBULK_i_dX/instanceStruct.instanceVar_RBULK_i/instanceStruct.instanceVar_RBULK_i);
instanceStruct.instanceVar_gbulk = (1.0/instanceStruct.instanceVar_RBULK_i);
}
else
{
instanceStruct.d_instanceVar_gbulk_dX = 0.0;
instanceStruct.instanceVar_gbulk = 0.0;
}
if ((instanceStruct.instanceVar_RJUNS_i>0.0))
{
instanceStruct.d_instanceVar_gjuns_dX = (-instanceStruct.d_instanceVar_RJUNS_i_dX/instanceStruct.instanceVar_RJUNS_i/instanceStruct.instanceVar_RJUNS_i);
instanceStruct.instanceVar_gjuns = (1.0/instanceStruct.instanceVar_RJUNS_i);
}
else
{
instanceStruct.d_instanceVar_gjuns_dX = 0.0;
instanceStruct.instanceVar_gjuns = 0.0;
}
if ((instanceStruct.instanceVar_RJUND_i>0.0))
{
instanceStruct.d_instanceVar_gjund_dX = (-instanceStruct.d_instanceVar_RJUND_i_dX/instanceStruct.instanceVar_RJUND_i/instanceStruct.instanceVar_RJUND_i);
instanceStruct.instanceVar_gjund = (1.0/instanceStruct.instanceVar_RJUND_i);
}
else
{
instanceStruct.d_instanceVar_gjund_dX = 0.0;
instanceStruct.instanceVar_gjund = 0.0;
}
if ((instanceStruct.instanceVar_RWELL_i>0.0))
{
instanceStruct.d_instanceVar_gwell_dX = (-instanceStruct.d_instanceVar_RWELL_i_dX/instanceStruct.instanceVar_RWELL_i/instanceStruct.instanceVar_RWELL_i);
instanceStruct.instanceVar_gwell = (1.0/instanceStruct.instanceVar_RWELL_i);
}
else
{
instanceStruct.d_instanceVar_gwell_dX = 0.0;
instanceStruct.instanceVar_gwell = 0.0;
}
d_ABS_i_dX = 0.0;
ABS_i = 0.0;
d_LSS_i_dX = 0.0;
LSS_i = 0.0;
d_LGS_i_dX = 0.0;
LGS_i = 0.0;
d_ABD_i_dX = 0.0;
ABD_i = 0.0;
d_LSD_i_dX = 0.0;
LSD_i = 0.0;
d_LGD_i_dX = 0.0;
LGD_i = 0.0;
jwcorr = 0.0;
d_jww_dX = instanceStruct.d_instanceVar_WE_dX;
jww = instanceStruct.instanceVar_WE;
if ((modelStruct.modelVar_SWGEO_i==0))
{
d_jww_dX = ((JW_i>0.0)?d_JW_i_dX:0.0);
jww = ((JW_i>0.0)?JW_i:0.0);
}
if ((modelStruct.modelVar_SWJUNCAP_i==3))
{
jwcorr = 1.0;
}
d_ABS_i_dX = (instanceStruct.instanceVar_ABSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*invNF);
ABS_i = (instanceStruct.instanceVar_ABSOURCE_i*invNF);
d_LSS_i_dX = (instanceStruct.instanceVar_LSSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*invNF);
LSS_i = (instanceStruct.instanceVar_LSSOURCE_i*invNF);
d_LGS_i_dX = (instanceStruct.instanceVar_LGSOURCE_i*d_invNF_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*invNF);
LGS_i = (instanceStruct.instanceVar_LGSOURCE_i*invNF);
d_ABD_i_dX = (instanceStruct.instanceVar_ABDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*invNF);
ABD_i = (instanceStruct.instanceVar_ABDRAIN_i*invNF);
d_LSD_i_dX = (instanceStruct.instanceVar_LSDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*invNF);
LSD_i = (instanceStruct.instanceVar_LSDRAIN_i*invNF);
d_LGD_i_dX = (instanceStruct.instanceVar_LGDRAIN_i*d_invNF_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*invNF);
LGD_i = (instanceStruct.instanceVar_LGDRAIN_i*invNF);
if (((modelStruct.modelVar_SWJUNCAP_i==2)||(modelStruct.modelVar_SWJUNCAP_i==3)))
{
d_ABS_i_dX = (AS_i*d_invNF_dX+d_AS_i_dX*invNF);
ABS_i = (AS_i*invNF);
d_LSS_i_dX = ((PS_i*d_invNF_dX+d_PS_i_dX*invNF)-jwcorr*d_jww_dX);
LSS_i = ((PS_i*invNF)-(jwcorr*jww));
d_LGS_i_dX = d_jww_dX;
LGS_i = jww;
d_ABD_i_dX = (AD_i*d_invNF_dX+d_AD_i_dX*invNF);
ABD_i = (AD_i*invNF);
d_LSD_i_dX = ((PD_i*d_invNF_dX+d_PD_i_dX*invNF)-jwcorr*d_jww_dX);
LSD_i = ((PD_i*invNF)-(jwcorr*jww));
d_LGD_i_dX = d_jww_dX;
LGD_i = jww;
}
if ((((modelStruct.modelVar_SWJUNCAP_i==1)||(modelStruct.modelVar_SWJUNCAP_i==2))||(modelStruct.modelVar_SWJUNCAP_i==3)))
{
instanceStruct.d_instanceVar_ABSOURCE_i_dX = ((ABS_i>0.0)?d_ABS_i_dX:0.0);
instanceStruct.instanceVar_ABSOURCE_i = ((ABS_i>0.0)?ABS_i:0.0);
instanceStruct.d_instanceVar_LSSOURCE_i_dX = ((LSS_i>0.0)?d_LSS_i_dX:0.0);
instanceStruct.instanceVar_LSSOURCE_i = ((LSS_i>0.0)?LSS_i:0.0);
instanceStruct.d_instanceVar_LGSOURCE_i_dX = ((LGS_i>0.0)?d_LGS_i_dX:0.0);
instanceStruct.instanceVar_LGSOURCE_i = ((LGS_i>0.0)?LGS_i:0.0);
instanceStruct.d_instanceVar_ABDRAIN_i_dX = ((ABD_i>0.0)?d_ABD_i_dX:0.0);
instanceStruct.instanceVar_ABDRAIN_i = ((ABD_i>0.0)?ABD_i:0.0);
instanceStruct.d_instanceVar_LSDRAIN_i_dX = ((LSD_i>0.0)?d_LSD_i_dX:0.0);
instanceStruct.instanceVar_LSDRAIN_i = ((LSD_i>0.0)?LSD_i:0.0);
instanceStruct.d_instanceVar_LGDRAIN_i_dX = ((LGD_i>0.0)?d_LGD_i_dX:0.0);
instanceStruct.instanceVar_LGDRAIN_i = ((LGD_i>0.0)?LGD_i:0.0);
}
else
{
instanceStruct.d_instanceVar_ABSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_ABSOURCE_i = 0.0;
instanceStruct.d_instanceVar_LSSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_LSSOURCE_i = 0.0;
instanceStruct.d_instanceVar_LGSOURCE_i_dX = 0.0;
instanceStruct.instanceVar_LGSOURCE_i = 0.0;
instanceStruct.d_instanceVar_ABDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_ABDRAIN_i = 0.0;
instanceStruct.d_instanceVar_LSDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_LSDRAIN_i = 0.0;
instanceStruct.d_instanceVar_LGDRAIN_i_dX = 0.0;
instanceStruct.instanceVar_LGDRAIN_i = 0.0;
}
instanceStruct.d_instanceVar_vbimin_s_dX = 0.0;
instanceStruct.instanceVar_vbimin_s = 0.0;
instanceStruct.d_instanceVar_vbimin_d_dX = 0.0;
instanceStruct.instanceVar_vbimin_d = 0.0;
instanceStruct.d_instanceVar_vfmin_s_dX = 0.0;
instanceStruct.instanceVar_vfmin_s = 0.0;
instanceStruct.d_instanceVar_vfmin_d_dX = 0.0;
instanceStruct.instanceVar_vfmin_d = 0.0;
instanceStruct.d_instanceVar_vch_s_dX = 0.0;
instanceStruct.instanceVar_vch_s = 0.0;
instanceStruct.d_instanceVar_vch_d_dX = 0.0;
instanceStruct.instanceVar_vch_d = 0.0;
instanceStruct.d_instanceVar_vbbtlim_s_dX = 0.0;
instanceStruct.instanceVar_vbbtlim_s = 0.0;
instanceStruct.d_instanceVar_vbbtlim_d_dX = 0.0;
instanceStruct.instanceVar_vbbtlim_d = 0.0;
instanceStruct.d_instanceVar_VMAX_s_dX = 0.0;
instanceStruct.instanceVar_VMAX_s = 0.0;
instanceStruct.d_instanceVar_VMAX_d_dX = 0.0;
instanceStruct.instanceVar_VMAX_d = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = 0.0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = 0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = 0.0;
instanceStruct.d_instanceVar_ISATFOR1_s_dX = 0.0;
instanceStruct.instanceVar_ISATFOR1_s = 0.0;
instanceStruct.d_instanceVar_ISATFOR1_d_dX = 0.0;
instanceStruct.instanceVar_ISATFOR1_d = 0.0;
instanceStruct.instanceVar_MFOR1_s = 1.0;
instanceStruct.instanceVar_MFOR1_d = 1.0;
instanceStruct.d_instanceVar_ISATFOR2_s_dX = 0.0;
instanceStruct.instanceVar_ISATFOR2_s = 0.0;
instanceStruct.d_instanceVar_ISATFOR2_d_dX = 0.0;
instanceStruct.instanceVar_ISATFOR2_d = 0.0;
instanceStruct.d_instanceVar_MFOR2_s_dX = 0.0;
instanceStruct.instanceVar_MFOR2_s = 1.0;
instanceStruct.d_instanceVar_MFOR2_d_dX = 0.0;
instanceStruct.instanceVar_MFOR2_d = 1.0;
instanceStruct.d_instanceVar_ISATREV_s_dX = 0.0;
instanceStruct.instanceVar_ISATREV_s = 0.0;
instanceStruct.d_instanceVar_ISATREV_d_dX = 0.0;
instanceStruct.instanceVar_ISATREV_d = 0.0;
instanceStruct.d_instanceVar_MREV_s_dX = 0.0;
instanceStruct.instanceVar_MREV_s = 1.0;
instanceStruct.d_instanceVar_MREV_d_dX = 0.0;
instanceStruct.instanceVar_MREV_d = 1.0;
instanceStruct.instanceVar_m0flag_s = 0.0;
instanceStruct.instanceVar_m0flag_d = 0.0;
instanceStruct.d_instanceVar_xhighf1_s_dX = 0.0;
instanceStruct.instanceVar_xhighf1_s = 0.0;
instanceStruct.d_instanceVar_xhighf1_d_dX = 0.0;
instanceStruct.instanceVar_xhighf1_d = 0.0;
instanceStruct.d_instanceVar_expxhf1_s_dX = 0.0;
instanceStruct.instanceVar_expxhf1_s = 0.0;
instanceStruct.d_instanceVar_expxhf1_d_dX = 0.0;
instanceStruct.instanceVar_expxhf1_d = 0.0;
instanceStruct.d_instanceVar_xhighf2_s_dX = 0.0;
instanceStruct.instanceVar_xhighf2_s = 0.0;
instanceStruct.d_instanceVar_xhighf2_d_dX = 0.0;
instanceStruct.instanceVar_xhighf2_d = 0.0;
instanceStruct.d_instanceVar_expxhf2_s_dX = 0.0;
instanceStruct.instanceVar_expxhf2_s = 0.0;
instanceStruct.d_instanceVar_expxhf2_d_dX = 0.0;
instanceStruct.instanceVar_expxhf2_d = 0.0;
instanceStruct.d_instanceVar_xhighr_s_dX = 0.0;
instanceStruct.instanceVar_xhighr_s = 0.0;
instanceStruct.d_instanceVar_xhighr_d_dX = 0.0;
instanceStruct.instanceVar_xhighr_d = 0.0;
instanceStruct.d_instanceVar_expxhr_s_dX = 0.0;
instanceStruct.instanceVar_expxhr_s = 0.0;
instanceStruct.d_instanceVar_expxhr_d_dX = 0.0;
instanceStruct.instanceVar_expxhr_d = 0.0;
instanceStruct.instanceVar_zflagbot_s = 1.0;
instanceStruct.instanceVar_zflagbot_d = 1.0;
instanceStruct.instanceVar_zflagsti_s = 1.0;
instanceStruct.instanceVar_zflagsti_d = 1.0;
instanceStruct.instanceVar_zflaggat_s = 1.0;
instanceStruct.instanceVar_zflaggat_d = 1.0;
d_m0_rev_dX = 0.0;
m0_rev = 0.0;
d_mcor_rev_dX = 0.0;
mcor_rev = 0.0;
d_I1_cor_dX = 0.0;
I1_cor = 0.0;
d_I2_cor_dX = 0.0;
I2_cor = 0.0;
d_I3_cor_dX = 0.0;
I3_cor = 0.0;
d_I4_cor_dX = 0.0;
I4_cor = 0.0;
d_I5_cor_dX = 0.0;
I5_cor = 0.0;
d_tt0_dX = 0.0;
tt0 = 0.0;
d_tt1_dX = 0.0;
tt1 = 0.0;
d_tt2_dX = 0.0;
tt2 = 0.0;
d_zfrac_dX = 0.0;
zfrac = 0.0;
d_alphaje_dX = 0.0;
alphaje = 0.0;
if ((modelStruct.modelVar_SWJUNCAP_i>0))
{
if (((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i))+1.0));
d_vmaxbot_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatbot*instanceStruct.d_instanceVar_ABSOURCE_i_dX+modelStruct.d_modelVar_idsatbot_dX*instanceStruct.instanceVar_ABSOURCE_i))/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)/(modelStruct.modelVar_idsatbot*instanceStruct.instanceVar_ABSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxbot = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxbot_dX = 0.0;
vmaxbot = 1.0e8;
}
if (((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i))+1.0));
d_vmaxsti_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatsti*instanceStruct.d_instanceVar_LSSOURCE_i_dX+modelStruct.d_modelVar_idsatsti_dX*instanceStruct.instanceVar_LSSOURCE_i))/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)/(modelStruct.modelVar_idsatsti*instanceStruct.instanceVar_LSSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxsti = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxsti_dX = 0.0;
vmaxsti = 1.0e8;
}
if (((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i))+1.0));
d_vmaxgat_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatgat*instanceStruct.d_instanceVar_LGSOURCE_i_dX+modelStruct.d_modelVar_idsatgat_dX*instanceStruct.instanceVar_LGSOURCE_i))/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)/(modelStruct.modelVar_idsatgat*instanceStruct.instanceVar_LGSOURCE_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxgat = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxgat_dX = 0.0;
vmaxgat = 1.0e8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
double  deriv_min_0_d0 = ((vmaxbot<=vmaxsti)?1.0:0.0);
double  deriv_min_0_d1 = ((vmaxbot<=vmaxsti)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vmaxgat)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vmaxgat)?0.0:1.0);
instanceStruct.d_instanceVar_VMAX_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vmaxbot_dX))+(deriv_min_0_d1*(d_vmaxsti_dX)))))+(deriv_min_1_d1*(d_vmaxgat_dX)));
instanceStruct.instanceVar_VMAX_s = value_min_1;
}
if ((fabs((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = value_exp_0;
}
}
else
{
if (((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)<0.0))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))+(-(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX = 1.0e100*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(instanceStruct.instanceVar_VMAX_s*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_s_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_s = (1.0e100*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_s*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_vbibot2_dX = modelStruct.d_modelVar_vbibot_dX;
vbibot2 = modelStruct.modelVar_vbibot;
d_vbisti2_dX = modelStruct.d_modelVar_vbisti_dX;
vbisti2 = modelStruct.modelVar_vbisti;
d_vbigat2_dX = modelStruct.d_modelVar_vbigat_dX;
vbigat2 = modelStruct.modelVar_vbigat;
d_pbot2_dX = modelStruct.d_modelVar_PBOT_i_dX;
pbot2 = modelStruct.modelVar_PBOT_i;
d_psti2_dX = modelStruct.d_modelVar_PSTI_i_dX;
psti2 = modelStruct.modelVar_PSTI_i;
d_pgat2_dX = modelStruct.d_modelVar_PGAT_i_dX;
pgat2 = modelStruct.modelVar_PGAT_i;
d_vbibot2r_dX = modelStruct.d_modelVar_VBIRBOT_i_dX;
vbibot2r = modelStruct.modelVar_VBIRBOT_i;
d_vbisti2r_dX = modelStruct.d_modelVar_VBIRSTI_i_dX;
vbisti2r = modelStruct.modelVar_VBIRSTI_i;
d_vbigat2r_dX = modelStruct.d_modelVar_VBIRGAT_i_dX;
vbigat2r = modelStruct.modelVar_VBIRGAT_i;
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_vbibot2_dX = (modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_vbigat_dX);
vbibot2 = (modelStruct.modelVar_vbisti+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PSTI_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PSTI_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_pbot2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PSTI_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
pbot2 = (0.9*value_min_0);
}
d_vbibot2r_dX = (modelStruct.d_modelVar_VBIRSTI_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbibot2r = (modelStruct.modelVar_VBIRSTI_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_vbisti2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbigat_dX);
vbisti2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbigat);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PGAT_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PGAT_i)?0.0:1.0);
d_psti2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
psti2 = (0.9*value_min_0);
}
d_vbisti2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRGAT_i_dX);
vbisti2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRGAT_i);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_vbigat2_dX = (modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_vbisti_dX);
vbigat2 = (modelStruct.modelVar_vbibot+modelStruct.modelVar_vbisti);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOT_i,modelStruct.modelVar_PSTI_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOT_i<=modelStruct.modelVar_PSTI_i)?0.0:1.0);
d_pgat2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOT_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
pgat2 = (0.9*value_min_0);
}
d_vbigat2r_dX = (modelStruct.d_modelVar_VBIRBOT_i_dX+modelStruct.d_modelVar_VBIRSTI_i_dX);
vbigat2r = (modelStruct.modelVar_VBIRBOT_i+modelStruct.modelVar_VBIRSTI_i);
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
double  deriv_min_0_d0 = ((vbibot2<=vbisti2)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2<=vbisti2)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2)?0.0:1.0);
instanceStruct.d_instanceVar_vbimin_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2_dX))+(deriv_min_0_d1*(d_vbisti2_dX)))))+(deriv_min_1_d1*(d_vbigat2_dX)));
instanceStruct.instanceVar_vbimin_s = value_min_1;
}
instanceStruct.d_instanceVar_vch_s_dX = instanceStruct.d_instanceVar_vbimin_s_dX*0.1;
instanceStruct.instanceVar_vch_s = (instanceStruct.instanceVar_vbimin_s*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
double  deriv_max_0_d0 = ((pbot2>=psti2)?1.0:0.0);
double  deriv_max_0_d1 = ((pbot2>=psti2)?0.0:1.0);
double  deriv_max_1_d0 = ((value_max_0>=pgat2)?1.0:0.0);
double  deriv_max_1_d1 = ((value_max_0>=pgat2)?0.0:1.0);
d_pmax_dX = ((deriv_max_1_d0*(((deriv_max_0_d0*(d_pbot2_dX))+(deriv_max_0_d1*(d_psti2_dX)))))+(deriv_max_1_d1*(d_pgat2_dX)));
pmax = value_max_1;
}
{
double value_pow_0 = pow(2.0,((-1.0)/pmax));
double  deriv_pow_0_d1 = (2.0 == 0.0)?0.0:(log(2.0)*value_pow_0);
instanceStruct.d_instanceVar_vfmin_s_dX = (instanceStruct.instanceVar_vbimin_s*(-(deriv_pow_0_d1*((-(-1.0)*d_pmax_dX/pmax/pmax))))+instanceStruct.d_instanceVar_vbimin_s_dX*(1.0-value_pow_0));
instanceStruct.instanceVar_vfmin_s = (instanceStruct.instanceVar_vbimin_s*(1.0-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
double  deriv_min_0_d0 = ((vbibot2r<=vbisti2r)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2r<=vbisti2r)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2r)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2r)?0.0:1.0);
instanceStruct.d_instanceVar_vbbtlim_s_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2r_dX))+(deriv_min_0_d1*(d_vbisti2r_dX)))))+(deriv_min_1_d1*(d_vbigat2r_dX)));
instanceStruct.instanceVar_vbbtlim_s = (value_min_1-5.0e-2);
}
if (((modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i))+1.0));
d_vmaxbot_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatbot_d*instanceStruct.d_instanceVar_ABDRAIN_i_dX+modelStruct.d_modelVar_idsatbot_d_dX*instanceStruct.instanceVar_ABDRAIN_i))/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)/(modelStruct.modelVar_idsatbot_d*instanceStruct.instanceVar_ABDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxbot = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxbot_dX = 0.0;
vmaxbot = 1.0e8;
}
if (((modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i))+1.0));
d_vmaxsti_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatsti_d*instanceStruct.d_instanceVar_LSDRAIN_i_dX+modelStruct.d_modelVar_idsatsti_d_dX*instanceStruct.instanceVar_LSDRAIN_i))/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)/(modelStruct.modelVar_idsatsti_d*instanceStruct.instanceVar_LSDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxsti = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxsti_dX = 0.0;
vmaxsti = 1.0e8;
}
if (((modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)>0.0))
{
{
double value_log_0 = log(((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i))+1.0));
double  deriv_log_0_d0 = (1.0/((modelStruct.modelVar_IMAX_i/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i))+1.0));
d_vmaxgat_dX = (modelStruct.modelVar_phitd*deriv_log_0_d0*((((modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)*modelStruct.d_modelVar_IMAX_i_dX-modelStruct.modelVar_IMAX_i*(modelStruct.modelVar_idsatgat_d*instanceStruct.d_instanceVar_LGDRAIN_i_dX+modelStruct.d_modelVar_idsatgat_d_dX*instanceStruct.instanceVar_LGDRAIN_i))/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)/(modelStruct.modelVar_idsatgat_d*instanceStruct.instanceVar_LGDRAIN_i)))+modelStruct.d_modelVar_phitd_dX*value_log_0);
vmaxgat = (modelStruct.modelVar_phitd*value_log_0);
}
}
else
{
d_vmaxgat_dX = 0.0;
vmaxgat = 1.0e8;
}
{
double value_min_0 = std::min(vmaxbot,vmaxsti);
double value_min_1 = std::min(value_min_0,vmaxgat);
double  deriv_min_0_d0 = ((vmaxbot<=vmaxsti)?1.0:0.0);
double  deriv_min_0_d1 = ((vmaxbot<=vmaxsti)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vmaxgat)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vmaxgat)?0.0:1.0);
instanceStruct.d_instanceVar_VMAX_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vmaxbot_dX))+(deriv_min_0_d1*(d_vmaxsti_dX)))))+(deriv_min_1_d1*(d_vmaxgat_dX)));
instanceStruct.instanceVar_VMAX_d = value_min_1;
}
if ((fabs((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = deriv_exp_0_d0*((instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = value_exp_0;
}
}
else
{
if (((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)<0.0))
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))+(-(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01))))))));
}
else
{
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX = 1.0e100*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(instanceStruct.instanceVar_VMAX_d*modelStruct.d_modelVar_phitdinv_dX+instanceStruct.d_instanceVar_VMAX_d_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
instanceStruct.instanceVar_exp_VMAX_over_phitd_d = (1.0e100*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(0.5*(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*(1.0+(((instanceStruct.instanceVar_VMAX_d*modelStruct.modelVar_phitdinv)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_vbibot2_dX = modelStruct.d_modelVar_vbibot_d_dX;
vbibot2 = modelStruct.modelVar_vbibot_d;
d_vbisti2_dX = modelStruct.d_modelVar_vbisti_d_dX;
vbisti2 = modelStruct.modelVar_vbisti_d;
d_vbigat2_dX = modelStruct.d_modelVar_vbigat_d_dX;
vbigat2 = modelStruct.modelVar_vbigat_d;
d_pbot2_dX = modelStruct.d_modelVar_PBOTD_i_dX;
pbot2 = modelStruct.modelVar_PBOTD_i;
d_psti2_dX = modelStruct.d_modelVar_PSTID_i_dX;
psti2 = modelStruct.modelVar_PSTID_i;
d_pgat2_dX = modelStruct.d_modelVar_PGATD_i_dX;
pgat2 = modelStruct.modelVar_PGATD_i;
d_vbibot2r_dX = modelStruct.d_modelVar_VBIRBOTD_i_dX;
vbibot2r = modelStruct.modelVar_VBIRBOTD_i;
d_vbisti2r_dX = modelStruct.d_modelVar_VBIRSTID_i_dX;
vbisti2r = modelStruct.modelVar_VBIRSTID_i;
d_vbigat2r_dX = modelStruct.d_modelVar_VBIRGATD_i_dX;
vbigat2r = modelStruct.modelVar_VBIRGATD_i;
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_vbibot2_dX = (modelStruct.d_modelVar_vbisti_d_dX+modelStruct.d_modelVar_vbigat_d_dX);
vbibot2 = (modelStruct.modelVar_vbisti_d+modelStruct.modelVar_vbigat_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PSTID_i,modelStruct.modelVar_PGATD_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PSTID_i<=modelStruct.modelVar_PGATD_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PSTID_i<=modelStruct.modelVar_PGATD_i)?0.0:1.0);
d_pbot2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PSTID_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
pbot2 = (0.9*value_min_0);
}
d_vbibot2r_dX = (modelStruct.d_modelVar_VBIRSTID_i_dX+modelStruct.d_modelVar_VBIRGATD_i_dX);
vbibot2r = (modelStruct.modelVar_VBIRSTID_i+modelStruct.modelVar_VBIRGATD_i);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_vbisti2_dX = (modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_vbigat_d_dX);
vbisti2 = (modelStruct.modelVar_vbibot_d+modelStruct.modelVar_vbigat_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOTD_i,modelStruct.modelVar_PGATD_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PGATD_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PGATD_i)?0.0:1.0);
d_psti2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOTD_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
psti2 = (0.9*value_min_0);
}
d_vbisti2r_dX = (modelStruct.d_modelVar_VBIRBOTD_i_dX+modelStruct.d_modelVar_VBIRGATD_i_dX);
vbisti2r = (modelStruct.modelVar_VBIRBOTD_i+modelStruct.modelVar_VBIRGATD_i);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_vbigat2_dX = (modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_vbisti_d_dX);
vbigat2 = (modelStruct.modelVar_vbibot_d+modelStruct.modelVar_vbisti_d);
{
double value_min_0 = std::min(modelStruct.modelVar_PBOTD_i,modelStruct.modelVar_PSTID_i);
double  deriv_min_0_d0 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PSTID_i)?1.0:0.0);
double  deriv_min_0_d1 = ((modelStruct.modelVar_PBOTD_i<=modelStruct.modelVar_PSTID_i)?0.0:1.0);
d_pgat2_dX = 0.9*((deriv_min_0_d0*(modelStruct.d_modelVar_PBOTD_i_dX))+(deriv_min_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
pgat2 = (0.9*value_min_0);
}
d_vbigat2r_dX = (modelStruct.d_modelVar_VBIRBOTD_i_dX+modelStruct.d_modelVar_VBIRSTID_i_dX);
vbigat2r = (modelStruct.modelVar_VBIRBOTD_i+modelStruct.modelVar_VBIRSTID_i);
}
{
double value_min_0 = std::min(vbibot2,vbisti2);
double value_min_1 = std::min(value_min_0,vbigat2);
double  deriv_min_0_d0 = ((vbibot2<=vbisti2)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2<=vbisti2)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2)?0.0:1.0);
instanceStruct.d_instanceVar_vbimin_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2_dX))+(deriv_min_0_d1*(d_vbisti2_dX)))))+(deriv_min_1_d1*(d_vbigat2_dX)));
instanceStruct.instanceVar_vbimin_d = value_min_1;
}
instanceStruct.d_instanceVar_vch_d_dX = instanceStruct.d_instanceVar_vbimin_d_dX*0.1;
instanceStruct.instanceVar_vch_d = (instanceStruct.instanceVar_vbimin_d*0.1);
{
double value_max_0 = std::max(pbot2,psti2);
double value_max_1 = std::max(value_max_0,pgat2);
double  deriv_max_0_d0 = ((pbot2>=psti2)?1.0:0.0);
double  deriv_max_0_d1 = ((pbot2>=psti2)?0.0:1.0);
double  deriv_max_1_d0 = ((value_max_0>=pgat2)?1.0:0.0);
double  deriv_max_1_d1 = ((value_max_0>=pgat2)?0.0:1.0);
d_pmax_dX = ((deriv_max_1_d0*(((deriv_max_0_d0*(d_pbot2_dX))+(deriv_max_0_d1*(d_psti2_dX)))))+(deriv_max_1_d1*(d_pgat2_dX)));
pmax = value_max_1;
}
{
double value_pow_0 = pow(2.0,((-1.0)/pmax));
double  deriv_pow_0_d1 = (2.0 == 0.0)?0.0:(log(2.0)*value_pow_0);
instanceStruct.d_instanceVar_vfmin_d_dX = (instanceStruct.instanceVar_vbimin_d*(-(deriv_pow_0_d1*((-(-1.0)*d_pmax_dX/pmax/pmax))))+instanceStruct.d_instanceVar_vbimin_d_dX*(1.0-value_pow_0));
instanceStruct.instanceVar_vfmin_d = (instanceStruct.instanceVar_vbimin_d*(1.0-value_pow_0));
}
{
double value_min_0 = std::min(vbibot2r,vbisti2r);
double value_min_1 = std::min(value_min_0,vbigat2r);
double  deriv_min_0_d0 = ((vbibot2r<=vbisti2r)?1.0:0.0);
double  deriv_min_0_d1 = ((vbibot2r<=vbisti2r)?0.0:1.0);
double  deriv_min_1_d0 = ((value_min_0<=vbigat2r)?1.0:0.0);
double  deriv_min_1_d1 = ((value_min_0<=vbigat2r)?0.0:1.0);
instanceStruct.d_instanceVar_vbbtlim_d_dX = ((deriv_min_1_d0*(((deriv_min_0_d0*(d_vbibot2r_dX))+(deriv_min_0_d1*(d_vbisti2r_dX)))))+(deriv_min_1_d1*(d_vbigat2r_dX)));
instanceStruct.instanceVar_vbbtlim_d = (value_min_1-5.0e-2);
}
if ((modelStruct.modelVar_SWJUNEXP_i==1))
//Begin block JUNCAPexpressInit
{
//Block-local variables for block JUNCAPexpressInit
double ysq=0.0;
double d_ysq_dX=0.0;
double terfc=0.0;
double d_terfc_dX=0.0;
double erfcpos=0.0;
double d_erfcpos_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double h1=0.0;
double d_h1_dX=0.0;
double h2=0.0;
double d_h2_dX=0.0;
double h2d=0.0;
double d_h2d_dX=0.0;
double h3=0.0;
double d_h3_dX=0.0;
double h4=0.0;
double d_h4_dX=0.0;
double h5=0.0;
double d_h5_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double idmult=0.0;
double d_idmult_dX=0.0;
double vj=0.0;
double d_vj_dX=0.0;
double z=0.0;
double d_z_dX=0.0;
double zinv=0.0;
double d_zinv_dX=0.0;
double two_psistar=0.0;
double d_two_psistar_dX=0.0;
double vjlim=0.0;
double d_vjlim_dX=0.0;
double vjsrh=0.0;
double d_vjsrh_dX=0.0;
double vbbt=0.0;
double d_vbbt_dX=0.0;
double vav=0.0;
double d_vav_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double tmp=0.0;
double d_tmp_dX=0.0;
double id=0.0;
double d_id_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double isrh=0.0;
double d_isrh_dX=0.0;
double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
double dwsrh=0.0;
double d_dwsrh_dX=0.0;
double wsrh=0.0;
double d_wsrh_dX=0.0;
double wdep=0.0;
double d_wdep_dX=0.0;
double asrh=0.0;
double d_asrh_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double itat=0.0;
double d_itat_dX=0.0;
double btat=0.0;
double d_btat_dX=0.0;
double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
double umax=0.0;
double d_umax_dX=0.0;
double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double wgamma=0.0;
double d_wgamma_dX=0.0;
double wtat=0.0;
double d_wtat_dX=0.0;
double ktat=0.0;
double d_ktat_dX=0.0;
double ltat=0.0;
double d_ltat_dX=0.0;
double mtat=0.0;
double d_mtat_dX=0.0;
double xerfc=0.0;
double d_xerfc_dX=0.0;
double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
double gammamax=0.0;
double d_gammamax_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ibbt=0.0;
double d_ibbt_dX=0.0;
double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
//End of Block-local variables
//Block-local variables for block JUNCAPexpressInit
double ijunbot=0.0;
double d_ijunbot_dX=0.0;
double ijunsti=0.0;
double d_ijunsti_dX=0.0;
double ijungat=0.0;
double d_ijungat_dX=0.0;
double qjunbot=0.0;
double d_qjunbot_dX=0.0;
double qjunsti=0.0;
double d_qjunsti_dX=0.0;
double qjungat=0.0;
double d_qjungat_dX=0.0;
//End of Block-local variables
d_ysq_dX = 0.0;
ysq = 0.0;
d_terfc_dX = 0.0;
terfc = 0.0;
d_erfcpos_dX = 0.0;
erfcpos = 0.0;
d_h1_dX = 0.0;
h1 = 0.0;
d_h2_dX = 0.0;
h2 = 0.0;
d_h2d_dX = 0.0;
h2d = 0.0;
d_h3_dX = 0.0;
h3 = 0.0;
d_h4_dX = 0.0;
h4 = 0.0;
d_h5_dX = 0.0;
h5 = 0.0;
d_idmult_dX = 0.0;
idmult = 0.0;
d_vj_dX = 0.0;
vj = 0.0;
d_z_dX = 0.0;
z = 0.0;
d_zinv_dX = 0.0;
zinv = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
d_vjlim_dX = 0.0;
vjlim = 0.0;
d_vjsrh_dX = 0.0;
vjsrh = 0.0;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_vav_dX = 0.0;
vav = 0.0;
d_tmp_dX = 0.0;
tmp = 0.0;
d_id_dX = 0.0;
id = 0.0;
d_isrh_dX = 0.0;
isrh = 0.0;
d_vbi_minus_vjsrh_dX = 0.0;
vbi_minus_vjsrh = 0.0;
d_wsrhstep_dX = 0.0;
wsrhstep = 0.0;
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
d_wsrh_dX = 0.0;
wsrh = 0.0;
d_wdep_dX = 0.0;
wdep = 0.0;
d_asrh_dX = 0.0;
asrh = 0.0;
d_itat_dX = 0.0;
itat = 0.0;
d_btat_dX = 0.0;
btat = 0.0;
d_twoatatoverthreebtat_dX = 0.0;
twoatatoverthreebtat = 0.0;
d_umaxbeforelimiting_dX = 0.0;
umaxbeforelimiting = 0.0;
d_umax_dX = 0.0;
umax = 0.0;
d_sqrtumax_dX = 0.0;
sqrtumax = 0.0;
d_umaxpoweronepointfive_dX = 0.0;
umaxpoweronepointfive = 0.0;
d_wgamma_dX = 0.0;
wgamma = 0.0;
d_wtat_dX = 0.0;
wtat = 0.0;
d_ktat_dX = 0.0;
ktat = 0.0;
d_ltat_dX = 0.0;
ltat = 0.0;
d_mtat_dX = 0.0;
mtat = 0.0;
d_xerfc_dX = 0.0;
xerfc = 0.0;
d_erfctimesexpmtat_dX = 0.0;
erfctimesexpmtat = 0.0;
d_gammamax_dX = 0.0;
gammamax = 0.0;
d_ibbt_dX = 0.0;
ibbt = 0.0;
d_Fmaxr_dX = 0.0;
Fmaxr = 0.0;
d_fbreakdown_dX = 0.0;
fbreakdown = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
d_V1_dX = (-FRACNA)*modelStruct.d_modelVar_VJUNREF_i_dX;
V1 = ((-FRACNA)*modelStruct.modelVar_VJUNREF_i);
d_V2_dX = (-FRACNB)*modelStruct.d_modelVar_VJUNREF_i_dX;
V2 = ((-FRACNB)*modelStruct.modelVar_VJUNREF_i);
d_V3_dX = (-FRACI)*modelStruct.d_modelVar_VJUNREF_i_dX;
V3 = ((-FRACI)*modelStruct.modelVar_VJUNREF_i);
V4 = 0.1;
V5 = 0.2;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V1_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V1+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V1*instanceStruct.d_instanceVar_vfmin_s_dX+d_V1_dX*instanceStruct.instanceVar_vfmin_s)-(V1*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V1*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V1<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V1*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((V1-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V1>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V1_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V1)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V1_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V1-vjlim)*(d_V1_dX-d_vjlim_dX)+(d_V1_dX-d_vjlim_dX)*(V1-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-instanceStruct.instanceVar_vbbtlim_s)*(V1-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V1_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V1-instanceStruct.instanceVar_vbbtlim_s)*(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V1-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V1+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V1_dX-deriv_sqrt_0_d0*(((V1)*d_V1_dX+d_V1_dX*(V1))));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V1-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V1-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V1-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I1_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I1 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V2_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V2+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V2*instanceStruct.d_instanceVar_vfmin_s_dX+d_V2_dX*instanceStruct.instanceVar_vfmin_s)-(V2*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V2*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V2<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V2*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((V2-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V2>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V2_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V2)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V2_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V2-vjlim)*(d_V2_dX-d_vjlim_dX)+(d_V2_dX-d_vjlim_dX)*(V2-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-instanceStruct.instanceVar_vbbtlim_s)*(V2-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V2_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V2-instanceStruct.instanceVar_vbbtlim_s)*(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V2-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V2+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V2_dX-deriv_sqrt_0_d0*(((V2)*d_V2_dX+d_V2_dX*(V2))));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V2-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V2-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V2-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I2_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I2 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (d_V3_dX+(instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2));
h2d = (V3+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V3*instanceStruct.d_instanceVar_vfmin_s_dX+d_V3_dX*instanceStruct.instanceVar_vfmin_s)-(V3*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V3*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V3<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V3*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((V3-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V3>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V3_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V3)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V3_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V3-vjlim)*(d_V3_dX-d_vjlim_dX)+(d_V3_dX-d_vjlim_dX)*(V3-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-instanceStruct.instanceVar_vbbtlim_s)*(V3-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V3_dX+instanceStruct.d_instanceVar_vbbtlim_s_dX)-deriv_sqrt_0_d0*((((V3-instanceStruct.instanceVar_vbbtlim_s)*(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V3-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V3+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V3_dX-deriv_sqrt_0_d0*(((V3)*d_V3_dX+d_V3_dX*(V3))));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V3-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V3-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V3-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I3_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I3 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (V4+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V4*instanceStruct.d_instanceVar_vfmin_s_dX-(V4*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V4*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V4<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V4*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V4*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V4*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((V4-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V4>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V4)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V4-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V4-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-instanceStruct.instanceVar_vbbtlim_s)*(V4-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((V4-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V4-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V4+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
d_vav_dX = 0.0;
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V4-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V4-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V4-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I4_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I4 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (V5+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V5*instanceStruct.d_instanceVar_vfmin_s_dX-(V5*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V5*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((V5<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(V5*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V5*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V5*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((V5-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V5>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V5)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V5-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V5-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-instanceStruct.instanceVar_vbbtlim_s)*(V5-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((V5-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(V5-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V5+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
d_vav_dX = 0.0;
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(V5-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)+(vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(V5-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)+(vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(V5-vj)));
qjungat = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)+(vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I5_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat));
I5 = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat));
instanceStruct.d_instanceVar_ISATFOR1_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.d_modelVar_idsatbot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.d_modelVar_idsatsti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.d_modelVar_idsatgat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*modelStruct.modelVar_idsatgat));
instanceStruct.instanceVar_ISATFOR1_s = (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_idsatbot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_idsatsti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_idsatgat));
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double  deriv_exp_0_d0 = value_exp_0;
d_I4_cor_dX = (d_I4_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*(V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)));
I4_cor = (I4-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double  deriv_exp_0_d0 = value_exp_0;
d_I5_cor_dX = (d_I5_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*(V5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)));
I5_cor = (I5-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)));
}
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
if (((I4>0.0)&&(I5>0.0)))
{
if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
{
d_alphaje_dX = ((I5_cor*d_I4_cor_dX-I4_cor*d_I5_cor_dX)/I5_cor/I5_cor);
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
instanceStruct.d_instanceVar_MFOR2_s_dX = ((modelStruct.modelVar_phitd*deriv_log_0_d0*(d_alphaje_dX)+modelStruct.d_modelVar_phitd_dX*value_log_0)/(V4-V5));
instanceStruct.instanceVar_MFOR2_s = ((modelStruct.modelVar_phitd*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATFOR2_s_dX = (((value_exp_0-1.0)*d_I4_cor_dX-I4_cor*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_s)))/(value_exp_0-1.0)/(value_exp_0-1.0));
instanceStruct.instanceVar_ISATFOR2_s = (I4_cor/(value_exp_0-1.0));
}
}
}
{
double value_exp_0 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I1_cor_dX = ((d_I1_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I1_cor = ((I1-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I2_cor_dX = ((d_I2_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I2_cor = ((I2-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s));
double value_exp_1 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I3_cor_dX = ((d_I3_dX-(instanceStruct.instanceVar_ISATFOR1_s*deriv_exp_0_d0*((V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s)+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*deriv_exp_1_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s))+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(value_exp_1-1.0)));
I3_cor = ((I3-(instanceStruct.instanceVar_ISATFOR1_s*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_s*(value_exp_1-1.0)));
}
if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
{
if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
{
d_alphaje_dX = ((I2_cor*d_I1_cor_dX-I1_cor*d_I2_cor_dX)/I2_cor/I2_cor);
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
d_m0_rev_dX = (((V1-V2)*((-modelStruct.modelVar_phitd)*deriv_log_0_d0*(d_alphaje_dX)+(-modelStruct.d_modelVar_phitd_dX)*value_log_0)-((-modelStruct.modelVar_phitd)*value_log_0)*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
m0_rev = (((-modelStruct.modelVar_phitd)*value_log_0)/(V1-V2));
}
d_tt0_dX = (((V2-V1)*d_V2_dX-V2*(d_V2_dX-d_V1_dX))/(V2-V1)/(V2-V1));
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt1_dX = ((modelStruct.modelVar_phitd*(alphaje-1.0))*((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))+(modelStruct.modelVar_phitd*d_alphaje_dX+modelStruct.d_modelVar_phitd_dX*(alphaje-1.0))*(value_pow_0-1.0));
tt1 = ((modelStruct.modelVar_phitd*(alphaje-1.0))*(value_pow_0-1.0));
}
d_tt0_dX = (((V1-V2)*d_V1_dX-V1*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt2_dX = (((value_pow_0*(d_V2_dX-d_V1_dX)+((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))*(V2-V1))+(alphaje*d_V1_dX+d_alphaje_dX*V1))-d_V2_dX);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
d_mcor_rev_dX = ((tt2*d_tt1_dX-tt1*d_tt2_dX)/tt2/tt2);
mcor_rev = (tt1/tt2);
instanceStruct.d_instanceVar_MREV_s_dX = (d_m0_rev_dX+d_mcor_rev_dX);
instanceStruct.instanceVar_MREV_s = (m0_rev+mcor_rev);
if ((fabs(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s))<1.0e-6))
{
instanceStruct.instanceVar_m0flag_s = 1.0;
instanceStruct.d_instanceVar_ISATREV_s_dX = (I3_cor*((-d_V3_dX/V3/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+0.5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_s))+d_I3_cor_dX*((1.0/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)));
instanceStruct.instanceVar_ISATREV_s = (I3_cor*((1.0/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)));
instanceStruct.d_instanceVar_MREV_s_dX = ((V3*((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.d_modelVar_phitdinv_dX+(((-0.5)*I3_cor)*instanceStruct.d_instanceVar_MREV_s_dX+(-0.5)*d_I3_cor_dX*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)-((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)*d_V3_dX)/V3/V3);
instanceStruct.instanceVar_MREV_s = (((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_s)*modelStruct.modelVar_phitdinv)/V3);
}
else
{
instanceStruct.instanceVar_m0flag_s = 0.0;
{
double value_exp_0 = exp((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATREV_s_dX = (((value_exp_0-1.0)*(-d_I3_cor_dX)-(-I3_cor)*deriv_exp_0_d0*((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+((-V3)*modelStruct.d_modelVar_phitdinv_dX+(-d_V3_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s)))/(value_exp_0-1.0)/(value_exp_0-1.0));
instanceStruct.instanceVar_ISATREV_s = ((-I3_cor)/(value_exp_0-1.0));
}
}
}
}
}
d_zfrac_dX = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.d_modelVar_cjobot_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.d_modelVar_cjosti_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.d_modelVar_cjogat_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*modelStruct.modelVar_cjogat))+modelStruct.d_modelVar_FJUNQ_i_dX*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)));
zfrac = (modelStruct.modelVar_FJUNQ_i*(((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)+(instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti))+(instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)));
if (((instanceStruct.instanceVar_ABSOURCE_i*modelStruct.modelVar_cjobot)<=zfrac))
{
instanceStruct.instanceVar_zflagbot_s = 0.0;
}
if (((instanceStruct.instanceVar_LSSOURCE_i*modelStruct.modelVar_cjosti)<=zfrac))
{
instanceStruct.instanceVar_zflagsti_s = 0.0;
}
if (((instanceStruct.instanceVar_LGSOURCE_i*modelStruct.modelVar_cjogat)<=zfrac))
{
instanceStruct.instanceVar_zflaggat_s = 0.0;
}
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_s+1.0e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_s+1.0e-21)));
instanceStruct.d_instanceVar_xhighf1_s_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR1_s+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR1_s_dX)/(instanceStruct.instanceVar_ISATFOR1_s+1.0e-21)/(instanceStruct.instanceVar_ISATFOR1_s+1.0e-21)));
instanceStruct.instanceVar_xhighf1_s = value_log_0;
}
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_s+1.0e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_s+1.0e-21)));
instanceStruct.d_instanceVar_xhighf2_s_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR2_s+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR2_s_dX)/(instanceStruct.instanceVar_ISATFOR2_s+1.0e-21)/(instanceStruct.instanceVar_ISATFOR2_s+1.0e-21)));
instanceStruct.instanceVar_xhighf2_s = value_log_0;
}
{
double value_fabs_0 = fabs(instanceStruct.instanceVar_ISATREV_s);
double value_log_1 = log(((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
double  deriv_fabs_0_d0 = (((instanceStruct.instanceVar_ISATREV_s)>=0)?(+1.0):(-1.0));
double  deriv_log_1_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
instanceStruct.d_instanceVar_xhighr_s_dX = deriv_log_1_d0*((((value_fabs_0+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*deriv_fabs_0_d0*(instanceStruct.d_instanceVar_ISATREV_s_dX))/(value_fabs_0+1.0e-21)/(value_fabs_0+1.0e-21)));
instanceStruct.instanceVar_xhighr_s = value_log_1;
}
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf1_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf1_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf1_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf1_s_dX));
instanceStruct.instanceVar_xhighf1_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf1_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf1_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf1_s_dX);
instanceStruct.instanceVar_expxhf1_s = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf2_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf2_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf2_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf2_s_dX));
instanceStruct.instanceVar_xhighf2_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf2_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf2_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf2_s_dX);
instanceStruct.instanceVar_expxhf2_s = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighr_s,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighr_s<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighr_s_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighr_s_dX));
instanceStruct.instanceVar_xhighr_s = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighr_s);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhr_s_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighr_s_dX);
instanceStruct.instanceVar_expxhr_s = value_exp_0;
}
FRACNA = 0.4;
FRACNB = 0.65;
FRACI = 0.8;
d_V1_dX = (-FRACNA)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V1 = ((-FRACNA)*modelStruct.modelVar_VJUNREFD_i);
d_V2_dX = (-FRACNB)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V2 = ((-FRACNB)*modelStruct.modelVar_VJUNREFD_i);
d_V3_dX = (-FRACI)*modelStruct.d_modelVar_VJUNREFD_i_dX;
V3 = ((-FRACI)*modelStruct.modelVar_VJUNREFD_i);
V4 = 0.1;
V5 = 0.2;
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V1_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V1+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V1*instanceStruct.d_instanceVar_vfmin_d_dX+d_V1_dX*instanceStruct.instanceVar_vfmin_d)-(V1*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V1*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V1<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V1*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V1*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V1*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V1*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V1*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V1_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((V1-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V1>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V1_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V1)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V1-vjlim)*(V1-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V1_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V1-vjlim)*(d_V1_dX-d_vjlim_dX)+(d_V1_dX-d_vjlim_dX)*(V1-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V1+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1-instanceStruct.instanceVar_vbbtlim_d)*(V1-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V1_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V1-instanceStruct.instanceVar_vbbtlim_d)*(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V1_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V1-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V1+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V1)*(V1))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V1_dX-deriv_sqrt_0_d0*(((V1)*d_V1_dX+d_V1_dX*(V1))));
vav = (0.5*(V1-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V1-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V1-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V1_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V1-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(V1-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*d_tmp_dX+((V1*Fmaxr)*d_Fmaxr_dX+(V1*d_Fmaxr_dX+d_V1_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V1*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V1*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I1_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I1 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V2_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V2+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V2*instanceStruct.d_instanceVar_vfmin_d_dX+d_V2_dX*instanceStruct.instanceVar_vfmin_d)-(V2*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V2*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V2<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V2*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V2*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V2*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V2*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V2*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V2_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((V2-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V2>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V2_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V2)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V2-vjlim)*(V2-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V2_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V2-vjlim)*(d_V2_dX-d_vjlim_dX)+(d_V2_dX-d_vjlim_dX)*(V2-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V2+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2-instanceStruct.instanceVar_vbbtlim_d)*(V2-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V2_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V2-instanceStruct.instanceVar_vbbtlim_d)*(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V2_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V2-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V2+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V2)*(V2))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V2_dX-deriv_sqrt_0_d0*(((V2)*d_V2_dX+d_V2_dX*(V2))));
vav = (0.5*(V2-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V2-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V2-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V2_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V2-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(V2-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*d_tmp_dX+((V2*Fmaxr)*d_Fmaxr_dX+(V2*d_Fmaxr_dX+d_V2_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V2*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V2*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I2_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I2 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (d_V3_dX+(instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2));
h2d = (V3+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*(V3*instanceStruct.d_instanceVar_vfmin_d_dX+d_V3_dX*instanceStruct.instanceVar_vfmin_d)-(V3*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V3*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V3<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V3*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V3*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv));
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V3*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*3.3333333333333333e-01+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V3*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*3.3333333333333333e-01+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V3*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(d_V3_dX-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((V3-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V3>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = ((-d_V3_dX)+2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1));
two_psistar = ((-V3)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V3-vjlim)*(V3-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*((d_V3_dX+d_vjlim_dX)-deriv_sqrt_0_d0*((((V3-vjlim)*(d_V3_dX-d_vjlim_dX)+(d_V3_dX-d_vjlim_dX)*(V3-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V3+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3-instanceStruct.instanceVar_vbbtlim_d)*(V3-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*((d_V3_dX+instanceStruct.d_instanceVar_vbbtlim_d_dX)-deriv_sqrt_0_d0*((((V3-instanceStruct.instanceVar_vbbtlim_d)*(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(d_V3_dX-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V3-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V3+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V3)*(V3))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vav_dX = 0.5*(d_V3_dX-deriv_sqrt_0_d0*(((V3)*d_V3_dX+d_V3_dX*(V3))));
vav = (0.5*(V3-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V3-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V3-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(d_V3_dX-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V3-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(V3-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*d_tmp_dX+((V3*Fmaxr)*d_Fmaxr_dX+(V3*d_Fmaxr_dX+d_V3_dX*Fmaxr)*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V3*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V3*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I3_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I3 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (V4+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V4*instanceStruct.d_instanceVar_vfmin_d_dX-(V4*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V4*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V4<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V4*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V4*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V4*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V4*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V4*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V4*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V4*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V4*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V4*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((V4-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V4>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V4)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V4-vjlim)*(V4-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V4-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V4-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V4+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4-instanceStruct.instanceVar_vbbtlim_d)*(V4-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((V4-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V4-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V4+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V4)*(V4))+((4.0*1.0e-6)*1.0e-6)));
d_vav_dX = 0.0;
vav = (0.5*(V4-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V4-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V4-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V4-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(V4-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*d_tmp_dX+((V4*Fmaxr)*d_Fmaxr_dX+V4*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V4*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V4*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I4_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I4 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (V5+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*V5*instanceStruct.d_instanceVar_vfmin_d_dX-(V5*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((V5*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((V5<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(V5*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(V5*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*V5*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(V5*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*V5*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(V5*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*V5*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*V5*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(V5*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((V5-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((V5>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-V5)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((V5-vjlim)*(V5-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((V5-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(V5-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((V5+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5-instanceStruct.instanceVar_vbbtlim_d)*(V5-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((V5-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(V5-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((V5+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((V5)*(V5))+((4.0*1.0e-6)*1.0e-6)));
d_vav_dX = 0.0;
vav = (0.5*(V5-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_dX = 0.0;
ijunbot = 0.0;
d_qjunbot_dX = 0.0;
qjunbot = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(V5-vj)));
qjunbot = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)+(vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvbot_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvbot_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_dX = 0.0;
ijunsti = 0.0;
d_qjunsti_dX = 0.0;
qjunsti = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(V5-vj)));
qjunsti = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)+(vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvsti_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvsti_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_dX = 0.0;
ijungat = 0.0;
d_qjungat_dX = 0.0;
qjungat = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(V5-vj)));
qjungat = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(V5-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*d_tmp_dX+((V5*Fmaxr)*d_Fmaxr_dX+V5*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((V5*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((V5*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)+(vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*((vav*modelStruct.d_modelVar_VBRinvgat_d_dX+d_vav_dX*modelStruct.modelVar_VBRinvgat_d))))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(d_vav_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_I5_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat));
I5 = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat));
instanceStruct.d_instanceVar_ISATFOR1_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.d_modelVar_idsatbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*modelStruct.modelVar_idsatbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.d_modelVar_idsatsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*modelStruct.modelVar_idsatsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.d_modelVar_idsatgat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*modelStruct.modelVar_idsatgat_d));
instanceStruct.instanceVar_ISATFOR1_d = (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_idsatbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_idsatsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_idsatgat_d));
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double  deriv_exp_0_d0 = value_exp_0;
d_I4_cor_dX = (d_I4_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*(V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)));
I4_cor = (I4-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
}
{
double value_exp_0 = exp(((V5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double  deriv_exp_0_d0 = value_exp_0;
d_I5_cor_dX = (d_I5_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*(V5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)));
I5_cor = (I5-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)));
}
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
if (((I4>0.0)&&(I5>0.0)))
{
if ((((((I4_cor/I4)>1.0e-3)||((I5_cor/I5)>1.0e-3))&&(I4_cor>0.0))&&(I5_cor>0.0)))
{
d_alphaje_dX = ((I5_cor*d_I4_cor_dX-I4_cor*d_I5_cor_dX)/I5_cor/I5_cor);
alphaje = (I4_cor/I5_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
instanceStruct.d_instanceVar_MFOR2_d_dX = ((modelStruct.modelVar_phitd*deriv_log_0_d0*(d_alphaje_dX)+modelStruct.d_modelVar_phitd_dX*value_log_0)/(V4-V5));
instanceStruct.instanceVar_MFOR2_d = ((modelStruct.modelVar_phitd*value_log_0)/(V4-V5));
}
{
double value_exp_0 = exp(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATFOR2_d_dX = (((value_exp_0-1.0)*d_I4_cor_dX-I4_cor*deriv_exp_0_d0*(((V4*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+V4*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_d)))/(value_exp_0-1.0)/(value_exp_0-1.0));
instanceStruct.instanceVar_ISATFOR2_d = (I4_cor/(value_exp_0-1.0));
}
}
}
{
double value_exp_0 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I1_cor_dX = ((d_I1_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V1*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V1*modelStruct.d_modelVar_phitdinv_dX+d_V1_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I1_cor = ((I1-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I2_cor_dX = ((d_I2_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V2*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V2*modelStruct.d_modelVar_phitdinv_dX+d_V2_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I2_cor = ((I2-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
{
double value_exp_0 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d));
double value_exp_1 = exp(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_exp_1_d0 = value_exp_1;
d_I3_cor_dX = ((d_I3_dX-(instanceStruct.instanceVar_ISATFOR1_d*deriv_exp_0_d0*((V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d)+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*deriv_exp_1_d0*(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+(V3*modelStruct.d_modelVar_phitdinv_dX+d_V3_dX*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d))+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(value_exp_1-1.0)));
I3_cor = ((I3-(instanceStruct.instanceVar_ISATFOR1_d*(value_exp_0-1.0)))-(instanceStruct.instanceVar_ISATFOR2_d*(value_exp_1-1.0)));
}
if ((((I1<0.0)&&(I2<0.0))&&(I3<0.0)))
{
if ((((((((I1_cor/I1)>1.0e-3)||((I2_cor/I2)>1.0e-3))||((I3_cor/I3)>1.0e-3))&&(I1_cor<0.0))&&(I2_cor<0.0))&&(I3_cor<0.0)))
{
d_alphaje_dX = ((I2_cor*d_I1_cor_dX-I1_cor*d_I2_cor_dX)/I2_cor/I2_cor);
alphaje = (I1_cor/I2_cor);
{
double value_log_0 = log(alphaje);
double  deriv_log_0_d0 = (1.0/alphaje);
d_m0_rev_dX = (((V1-V2)*((-modelStruct.modelVar_phitd)*deriv_log_0_d0*(d_alphaje_dX)+(-modelStruct.d_modelVar_phitd_dX)*value_log_0)-((-modelStruct.modelVar_phitd)*value_log_0)*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
m0_rev = (((-modelStruct.modelVar_phitd)*value_log_0)/(V1-V2));
}
d_tt0_dX = (((V2-V1)*d_V2_dX-V2*(d_V2_dX-d_V1_dX))/(V2-V1)/(V2-V1));
tt0 = (V2/(V2-V1));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt1_dX = ((modelStruct.modelVar_phitd*(alphaje-1.0))*((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))+(modelStruct.modelVar_phitd*d_alphaje_dX+modelStruct.d_modelVar_phitd_dX*(alphaje-1.0))*(value_pow_0-1.0));
tt1 = ((modelStruct.modelVar_phitd*(alphaje-1.0))*(value_pow_0-1.0));
}
d_tt0_dX = (((V1-V2)*d_V1_dX-V1*(d_V1_dX-d_V2_dX))/(V1-V2)/(V1-V2));
tt0 = (V1/(V1-V2));
{
double value_pow_0 = pow(alphaje,tt0);
double  deriv_pow_0_d0 = ((alphaje == 0.0)?0.0:(value_pow_0*tt0/alphaje));
double  deriv_pow_0_d1 = (alphaje == 0.0)?0.0:(log(alphaje)*value_pow_0);
d_tt2_dX = (((value_pow_0*(d_V2_dX-d_V1_dX)+((deriv_pow_0_d0*(d_alphaje_dX))+(deriv_pow_0_d1*(d_tt0_dX)))*(V2-V1))+(alphaje*d_V1_dX+d_alphaje_dX*V1))-d_V2_dX);
tt2 = (((value_pow_0*(V2-V1))+(alphaje*V1))-V2);
}
d_mcor_rev_dX = ((tt2*d_tt1_dX-tt1*d_tt2_dX)/tt2/tt2);
mcor_rev = (tt1/tt2);
instanceStruct.d_instanceVar_MREV_d_dX = (d_m0_rev_dX+d_mcor_rev_dX);
instanceStruct.instanceVar_MREV_d = (m0_rev+mcor_rev);
if ((fabs(((V3*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d))<1.0e-6))
{
instanceStruct.instanceVar_m0flag_d = 1.0;
instanceStruct.d_instanceVar_ISATREV_d_dX = (I3_cor*((-d_V3_dX/V3/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+0.5*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_d))+d_I3_cor_dX*((1.0/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)));
instanceStruct.instanceVar_ISATREV_d = (I3_cor*((1.0/V3)+((0.5*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)));
instanceStruct.d_instanceVar_MREV_d_dX = ((V3*((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.d_modelVar_phitdinv_dX+(((-0.5)*I3_cor)*instanceStruct.d_instanceVar_MREV_d_dX+(-0.5)*d_I3_cor_dX*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)-((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)*d_V3_dX)/V3/V3);
instanceStruct.instanceVar_MREV_d = (((((-0.5)*I3_cor)*instanceStruct.instanceVar_MREV_d)*modelStruct.modelVar_phitdinv)/V3);
}
else
{
instanceStruct.instanceVar_m0flag_d = 0.0;
{
double value_exp_0 = exp((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d));
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_ISATREV_d_dX = (((value_exp_0-1.0)*(-d_I3_cor_dX)-(-I3_cor)*deriv_exp_0_d0*((((-V3)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+((-V3)*modelStruct.d_modelVar_phitdinv_dX+(-d_V3_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d)))/(value_exp_0-1.0)/(value_exp_0-1.0));
instanceStruct.instanceVar_ISATREV_d = ((-I3_cor)/(value_exp_0-1.0));
}
}
}
}
}
d_zfrac_dX = (modelStruct.modelVar_FJUNQD_i*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.d_modelVar_cjobot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.d_modelVar_cjosti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.d_modelVar_cjogat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*modelStruct.modelVar_cjogat_d))+modelStruct.d_modelVar_FJUNQD_i_dX*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)));
zfrac = (modelStruct.modelVar_FJUNQD_i*(((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)+(instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d))+(instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)));
if (((instanceStruct.instanceVar_ABDRAIN_i*modelStruct.modelVar_cjobot_d)<=zfrac))
{
instanceStruct.instanceVar_zflagbot_d = 0.0;
}
if (((instanceStruct.instanceVar_LSDRAIN_i*modelStruct.modelVar_cjosti_d)<=zfrac))
{
instanceStruct.instanceVar_zflagsti_d = 0.0;
}
if (((instanceStruct.instanceVar_LGDRAIN_i*modelStruct.modelVar_cjogat_d)<=zfrac))
{
instanceStruct.instanceVar_zflaggat_d = 0.0;
}
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_d+1.0e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR1_d+1.0e-21)));
instanceStruct.d_instanceVar_xhighf1_d_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR1_d+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR1_d_dX)/(instanceStruct.instanceVar_ISATFOR1_d+1.0e-21)/(instanceStruct.instanceVar_ISATFOR1_d+1.0e-21)));
instanceStruct.instanceVar_xhighf1_d = value_log_0;
}
{
double value_log_0 = log(((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_d+1.0e-21)));
double  deriv_log_0_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(instanceStruct.instanceVar_ISATFOR2_d+1.0e-21)));
instanceStruct.d_instanceVar_xhighf2_d_dX = deriv_log_0_d0*((((instanceStruct.instanceVar_ISATFOR2_d+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*instanceStruct.d_instanceVar_ISATFOR2_d_dX)/(instanceStruct.instanceVar_ISATFOR2_d+1.0e-21)/(instanceStruct.instanceVar_ISATFOR2_d+1.0e-21)));
instanceStruct.instanceVar_xhighf2_d = value_log_0;
}
{
double value_fabs_0 = fabs(instanceStruct.instanceVar_ISATREV_d);
double value_log_1 = log(((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
double  deriv_fabs_0_d0 = (((instanceStruct.instanceVar_ISATREV_d)>=0)?(+1.0):(-1.0));
double  deriv_log_1_d0 = (1.0/((0.5*modelStruct.modelVar_IMAX_i)/(value_fabs_0+1.0e-21)));
instanceStruct.d_instanceVar_xhighr_d_dX = deriv_log_1_d0*((((value_fabs_0+1.0e-21)*0.5*modelStruct.d_modelVar_IMAX_i_dX-(0.5*modelStruct.modelVar_IMAX_i)*deriv_fabs_0_d0*(instanceStruct.d_instanceVar_ISATREV_d_dX))/(value_fabs_0+1.0e-21)/(value_fabs_0+1.0e-21)));
instanceStruct.instanceVar_xhighr_d = value_log_1;
}
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf1_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf1_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf1_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf1_d_dX));
instanceStruct.instanceVar_xhighf1_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf1_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf1_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf1_d_dX);
instanceStruct.instanceVar_expxhf1_d = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighf2_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighf2_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighf2_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighf2_d_dX));
instanceStruct.instanceVar_xhighf2_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighf2_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhf2_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighf2_d_dX);
instanceStruct.instanceVar_expxhf2_d = value_exp_0;
}
{
double value_min_0 = std::min(instanceStruct.instanceVar_xhighr_d,static_cast<double>(2.3025850929940458e+02));
double  deriv_min_0_d0 = ((instanceStruct.instanceVar_xhighr_d<=2.3025850929940458e+02)?1.0:0.0);
instanceStruct.d_instanceVar_xhighr_d_dX = (deriv_min_0_d0*(instanceStruct.d_instanceVar_xhighr_d_dX));
instanceStruct.instanceVar_xhighr_d = value_min_0;
}
{
double value_exp_0 = exp(instanceStruct.instanceVar_xhighr_d);
double  deriv_exp_0_d0 = value_exp_0;
instanceStruct.d_instanceVar_expxhr_d_dX = deriv_exp_0_d0*(instanceStruct.d_instanceVar_xhighr_d_dX);
instanceStruct.instanceVar_expxhr_d = value_exp_0;
}
}
// End block JUNCAPexpressInit
}
}
// End block initial_instance
}



//-----------------------------------------------------------------------------
// Function      : evaluateInitialModel
// Purpose       : Evaluate the statements in the initial_model block
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateInitialModel(
modelSensStruct & modelStruct,
 double admsTemperature, double ADMSgmin_arg, const Instance & theInstance)
{
  double deltaEgat_d=0.0;
double d_deltaEgat_d_dX=0.0;
  double deltaEsti_d=0.0;
double d_deltaEsti_d_dX=0.0;
  double deltaEbot_d=0.0;
double d_deltaEbot_d_dX=0.0;
  double ubigat_d=0.0;
double d_ubigat_d_dX=0.0;
  double ubisti_d=0.0;
double d_ubisti_d_dX=0.0;
  double ubibot_d=0.0;
double d_ubibot_d_dX=0.0;
  double phigdgat_d=0.0;
double d_phigdgat_d_dX=0.0;
  double phigdsti_d=0.0;
double d_phigdsti_d_dX=0.0;
  double phigdbot_d=0.0;
double d_phigdbot_d_dX=0.0;
  double phigrgat_d=0.0;
double d_phigrgat_d_dX=0.0;
  double phigrsti_d=0.0;
double d_phigrsti_d_dX=0.0;
  double phigrbot_d=0.0;
double d_phigrbot_d_dX=0.0;
  double deltaEgat=0.0;
double d_deltaEgat_dX=0.0;
  double deltaEsti=0.0;
double d_deltaEsti_dX=0.0;
  double deltaEbot=0.0;
double d_deltaEbot_dX=0.0;
  double ubigat=0.0;
double d_ubigat_dX=0.0;
  double ubisti=0.0;
double d_ubisti_dX=0.0;
  double ubibot=0.0;
double d_ubibot_dX=0.0;
  double phigdgat=0.0;
double d_phigdgat_dX=0.0;
  double phigdsti=0.0;
double d_phigdsti_dX=0.0;
  double phigdbot=0.0;
double d_phigdbot_dX=0.0;
  double deltaphigd=0.0;
double d_deltaphigd_dX=0.0;
  double phigrgat=0.0;
double d_phigrgat_dX=0.0;
  double phigrsti=0.0;
double d_phigrsti_dX=0.0;
  double phigrbot=0.0;
double d_phigrbot_dX=0.0;
  double deltaphigr=0.0;
double d_deltaphigr_dX=0.0;
  double phitrinv=0.0;
double d_phitrinv_dX=0.0;
  double KBOL_over_QELE=0.0;
  double auxt=0.0;
double d_auxt_dX=0.0;
  double tkd=0.0;
double d_tkd_dX=0.0;
  double tkr=0.0;
double d_tkr_dX=0.0;
  double STFBBTGATD_i=0.0;
double d_STFBBTGATD_i_dX=0.0;
  double STFBBTSTID_i=0.0;
double d_STFBBTSTID_i_dX=0.0;
  double STFBBTBOTD_i=0.0;
double d_STFBBTBOTD_i_dX=0.0;
  double FBBTRGATD_i=0.0;
double d_FBBTRGATD_i_dX=0.0;
  double FBBTRSTID_i=0.0;
double d_FBBTRSTID_i_dX=0.0;
  double FBBTRBOTD_i=0.0;
double d_FBBTRBOTD_i_dX=0.0;
  double MEFFTATGATD_i=0.0;
double d_MEFFTATGATD_i_dX=0.0;
  double MEFFTATSTID_i=0.0;
double d_MEFFTATSTID_i_dX=0.0;
  double MEFFTATBOTD_i=0.0;
double d_MEFFTATBOTD_i_dX=0.0;
  double XJUNGATD_i=0.0;
double d_XJUNGATD_i_dX=0.0;
  double XJUNSTID_i=0.0;
double d_XJUNSTID_i_dX=0.0;
  double IDSATRGATD_i=0.0;
double d_IDSATRGATD_i_dX=0.0;
  double IDSATRSTID_i=0.0;
double d_IDSATRSTID_i_dX=0.0;
  double IDSATRBOTD_i=0.0;
double d_IDSATRBOTD_i_dX=0.0;
  double PHIGGATD_i=0.0;
double d_PHIGGATD_i_dX=0.0;
  double PHIGSTID_i=0.0;
double d_PHIGSTID_i_dX=0.0;
  double PHIGBOTD_i=0.0;
double d_PHIGBOTD_i_dX=0.0;
  double CJORGATD_i=0.0;
double d_CJORGATD_i_dX=0.0;
  double CJORSTID_i=0.0;
double d_CJORSTID_i_dX=0.0;
  double CJORBOTD_i=0.0;
double d_CJORBOTD_i_dX=0.0;
  double STFBBTGAT_i=0.0;
double d_STFBBTGAT_i_dX=0.0;
  double STFBBTSTI_i=0.0;
double d_STFBBTSTI_i_dX=0.0;
  double STFBBTBOT_i=0.0;
double d_STFBBTBOT_i_dX=0.0;
  double FBBTRGAT_i=0.0;
double d_FBBTRGAT_i_dX=0.0;
  double FBBTRSTI_i=0.0;
double d_FBBTRSTI_i_dX=0.0;
  double FBBTRBOT_i=0.0;
double d_FBBTRBOT_i_dX=0.0;
  double MEFFTATGAT_i=0.0;
double d_MEFFTATGAT_i_dX=0.0;
  double MEFFTATSTI_i=0.0;
double d_MEFFTATSTI_i_dX=0.0;
  double MEFFTATBOT_i=0.0;
double d_MEFFTATBOT_i_dX=0.0;
  double XJUNGAT_i=0.0;
double d_XJUNGAT_i_dX=0.0;
  double XJUNSTI_i=0.0;
double d_XJUNSTI_i_dX=0.0;
  double IDSATRGAT_i=0.0;
double d_IDSATRGAT_i_dX=0.0;
  double IDSATRSTI_i=0.0;
double d_IDSATRSTI_i_dX=0.0;
  double IDSATRBOT_i=0.0;
double d_IDSATRBOT_i_dX=0.0;
  double PHIGGAT_i=0.0;
double d_PHIGGAT_i_dX=0.0;
  double PHIGSTI_i=0.0;
double d_PHIGSTI_i_dX=0.0;
  double PHIGBOT_i=0.0;
double d_PHIGBOT_i_dX=0.0;
  double CJORGAT_i=0.0;
double d_CJORGAT_i_dX=0.0;
  double CJORSTI_i=0.0;
double d_CJORSTI_i_dX=0.0;
  double CJORBOT_i=0.0;
double d_CJORBOT_i_dX=0.0;
  double FREV_i=0.0;
double d_FREV_i_dX=0.0;
  double TRJ_i=0.0;
double d_TRJ_i_dX=0.0;
  double TKD_sq=0.0;
double d_TKD_sq_dX=0.0;
  double TKA=0.0;
double d_TKA_dX=0.0;
  double TKR=0.0;
double d_TKR_dX=0.0;
  double TR_i=0.0;
double d_TR_i_dX=0.0;
//Begin block initial_model
{
if ((modelStruct.modelPar_TYPE>=0))
{
modelStruct.modelVar_CHNL_TYPE = (+1);
}
else
{
modelStruct.modelVar_CHNL_TYPE = (-1);
}
modelStruct.modelVar_EPSSI = (8.8541878176E-12*11.8);
{
double value_floor_0 = floor((((modelStruct.modelPar_SWGEO>0.0)?((modelStruct.modelPar_SWGEO<2.0)?modelStruct.modelPar_SWGEO:2.0):0.0)+0.5));
modelStruct.modelVar_SWGEO_i = floor((((modelStruct.modelPar_SWGEO>0.0)?((modelStruct.modelPar_SWGEO<2.0)?modelStruct.modelPar_SWGEO:2.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWIGATE>0.0)?((modelStruct.modelPar_SWIGATE<1.0)?modelStruct.modelPar_SWIGATE:1.0):0.0)+0.5));
modelStruct.modelVar_SWIGATE_i = floor((((modelStruct.modelPar_SWIGATE>0.0)?((modelStruct.modelPar_SWIGATE<1.0)?modelStruct.modelPar_SWIGATE:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWIMPACT>0.0)?((modelStruct.modelPar_SWIMPACT<1.0)?modelStruct.modelPar_SWIMPACT:1.0):0.0)+0.5));
modelStruct.modelVar_SWIMPACT_i = floor((((modelStruct.modelPar_SWIMPACT>0.0)?((modelStruct.modelPar_SWIMPACT<1.0)?modelStruct.modelPar_SWIMPACT:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWGIDL>0.0)?((modelStruct.modelPar_SWGIDL<1.0)?modelStruct.modelPar_SWGIDL:1.0):0.0)+0.5));
modelStruct.modelVar_SWGIDL_i = floor((((modelStruct.modelPar_SWGIDL>0.0)?((modelStruct.modelPar_SWGIDL<1.0)?modelStruct.modelPar_SWGIDL:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWJUNCAP>0.0)?((modelStruct.modelPar_SWJUNCAP<3.0)?modelStruct.modelPar_SWJUNCAP:3.0):0.0)+0.5));
modelStruct.modelVar_SWJUNCAP_i = floor((((modelStruct.modelPar_SWJUNCAP>0.0)?((modelStruct.modelPar_SWJUNCAP<3.0)?modelStruct.modelPar_SWJUNCAP:3.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWJUNASYM>0.0)?((modelStruct.modelPar_SWJUNASYM<1.0)?modelStruct.modelPar_SWJUNASYM:1.0):0.0)+0.5));
modelStruct.modelVar_SWJUNASYM_i = floor((((modelStruct.modelPar_SWJUNASYM>0.0)?((modelStruct.modelPar_SWJUNASYM<1.0)?modelStruct.modelPar_SWJUNASYM:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWNUD>0.0)?((modelStruct.modelPar_SWNUD<2.0)?modelStruct.modelPar_SWNUD:2.0):0.0)+0.5));
modelStruct.modelVar_SWNUD_i = floor((((modelStruct.modelPar_SWNUD>0.0)?((modelStruct.modelPar_SWNUD<2.0)?modelStruct.modelPar_SWNUD:2.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWEDGE>0.0)?((modelStruct.modelPar_SWEDGE<1.0)?modelStruct.modelPar_SWEDGE:1.0):0.0)+0.5));
modelStruct.modelVar_SWEDGE_i = floor((((modelStruct.modelPar_SWEDGE>0.0)?((modelStruct.modelPar_SWEDGE<1.0)?modelStruct.modelPar_SWEDGE:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWDELVTAC>0.0)?((modelStruct.modelPar_SWDELVTAC<1.0)?modelStruct.modelPar_SWDELVTAC:1.0):0.0)+0.5));
modelStruct.modelVar_SWDELVTAC_i = floor((((modelStruct.modelPar_SWDELVTAC>0.0)?((modelStruct.modelPar_SWDELVTAC<1.0)?modelStruct.modelPar_SWDELVTAC:1.0):0.0)+0.5));
}
{
double value_floor_0 = floor((((modelStruct.modelPar_SWIGN>0.0)?((modelStruct.modelPar_SWIGN<1.0)?modelStruct.modelPar_SWIGN:1.0):0.0)+0.5));
modelStruct.modelVar_SWIGN_i = floor((((modelStruct.modelPar_SWIGN>0.0)?((modelStruct.modelPar_SWIGN<1.0)?modelStruct.modelPar_SWIGN:1.0):0.0)+0.5));
}
modelStruct.d_modelVar_QMC_i_dX = ((modelStruct.modelPar_QMC>0.0)?modelStruct.d_modelPar_QMC_dX:0.0);
modelStruct.modelVar_QMC_i = ((modelStruct.modelPar_QMC>0.0)?modelStruct.modelPar_QMC:0.0);
modelStruct.d_modelVar_TOXO_i_dX = ((modelStruct.modelPar_TOXO>1.0e-10)?modelStruct.d_modelPar_TOXO_dX:0.0);
modelStruct.modelVar_TOXO_i = ((modelStruct.modelPar_TOXO>1.0e-10)?modelStruct.modelPar_TOXO:1.0e-10);
modelStruct.d_modelVar_EPSROXO_i_dX = ((modelStruct.modelPar_EPSROXO>1.0)?modelStruct.d_modelPar_EPSROXO_dX:0.0);
modelStruct.modelVar_EPSROXO_i = ((modelStruct.modelPar_EPSROXO>1.0)?modelStruct.modelPar_EPSROXO:1.0);
modelStruct.d_modelVar_NSUBO_i_dX = ((modelStruct.modelPar_NSUBO>1.0e20)?modelStruct.d_modelPar_NSUBO_dX:0.0);
modelStruct.modelVar_NSUBO_i = ((modelStruct.modelPar_NSUBO>1.0e20)?modelStruct.modelPar_NSUBO:1.0e20);
modelStruct.d_modelVar_WSEG_i_dX = ((modelStruct.modelPar_WSEG>1.0e-10)?modelStruct.d_modelPar_WSEG_dX:0.0);
modelStruct.modelVar_WSEG_i = ((modelStruct.modelPar_WSEG>1.0e-10)?modelStruct.modelPar_WSEG:1.0e-10);
modelStruct.d_modelVar_NPCK_i_dX = ((modelStruct.modelPar_NPCK>0.0)?modelStruct.d_modelPar_NPCK_dX:0.0);
modelStruct.modelVar_NPCK_i = ((modelStruct.modelPar_NPCK>0.0)?modelStruct.modelPar_NPCK:0.0);
modelStruct.d_modelVar_WSEGP_i_dX = ((modelStruct.modelPar_WSEGP>1.0e-10)?modelStruct.d_modelPar_WSEGP_dX:0.0);
modelStruct.modelVar_WSEGP_i = ((modelStruct.modelPar_WSEGP>1.0e-10)?modelStruct.modelPar_WSEGP:1.0e-10);
modelStruct.d_modelVar_LPCK_i_dX = ((modelStruct.modelPar_LPCK>1.0e-10)?modelStruct.d_modelPar_LPCK_dX:0.0);
modelStruct.modelVar_LPCK_i = ((modelStruct.modelPar_LPCK>1.0e-10)?modelStruct.modelPar_LPCK:1.0e-10);
modelStruct.d_modelVar_TOXOVO_i_dX = ((modelStruct.modelPar_TOXOVO>1.0e-10)?modelStruct.d_modelPar_TOXOVO_dX:0.0);
modelStruct.modelVar_TOXOVO_i = ((modelStruct.modelPar_TOXOVO>1.0e-10)?modelStruct.modelPar_TOXOVO:1.0e-10);
modelStruct.d_modelVar_TOXOVDO_i_dX = ((modelStruct.modelPar_TOXOVDO>1.0e-10)?modelStruct.d_modelPar_TOXOVDO_dX:0.0);
modelStruct.modelVar_TOXOVDO_i = ((modelStruct.modelPar_TOXOVDO>1.0e-10)?modelStruct.modelPar_TOXOVDO:1.0e-10);
modelStruct.d_modelVar_LOV_i_dX = ((modelStruct.modelPar_LOV>0.0)?modelStruct.d_modelPar_LOV_dX:0.0);
modelStruct.modelVar_LOV_i = ((modelStruct.modelPar_LOV>0.0)?modelStruct.modelPar_LOV:0.0);
modelStruct.d_modelVar_LOVD_i_dX = ((modelStruct.modelPar_LOVD>0.0)?modelStruct.d_modelPar_LOVD_dX:0.0);
modelStruct.modelVar_LOVD_i = ((modelStruct.modelPar_LOVD>0.0)?modelStruct.modelPar_LOVD:0.0);
modelStruct.d_modelVar_LP1_i_dX = ((modelStruct.modelPar_LP1>1.0e-10)?modelStruct.d_modelPar_LP1_dX:0.0);
modelStruct.modelVar_LP1_i = ((modelStruct.modelPar_LP1>1.0e-10)?modelStruct.modelPar_LP1:1.0e-10);
modelStruct.d_modelVar_LP2_i_dX = ((modelStruct.modelPar_LP2>1.0e-10)?modelStruct.d_modelPar_LP2_dX:0.0);
modelStruct.modelVar_LP2_i = ((modelStruct.modelPar_LP2>1.0e-10)?modelStruct.modelPar_LP2:1.0e-10);
modelStruct.d_modelVar_WBET_i_dX = ((modelStruct.modelPar_WBET>1.0e-10)?modelStruct.d_modelPar_WBET_dX:0.0);
modelStruct.modelVar_WBET_i = ((modelStruct.modelPar_WBET>1.0e-10)?modelStruct.modelPar_WBET:1.0e-10);
modelStruct.d_modelVar_AXL_i_dX = ((modelStruct.modelPar_AXL>0.0)?modelStruct.d_modelPar_AXL_dX:0.0);
modelStruct.modelVar_AXL_i = ((modelStruct.modelPar_AXL>0.0)?modelStruct.modelPar_AXL:0.0);
modelStruct.d_modelVar_ALP1L2_i_dX = ((modelStruct.modelPar_ALP1L2>0.0)?modelStruct.d_modelPar_ALP1L2_dX:0.0);
modelStruct.modelVar_ALP1L2_i = ((modelStruct.modelPar_ALP1L2>0.0)?modelStruct.modelPar_ALP1L2:0.0);
modelStruct.d_modelVar_ALP2L2_i_dX = ((modelStruct.modelPar_ALP2L2>0.0)?modelStruct.d_modelPar_ALP2L2_dX:0.0);
modelStruct.modelVar_ALP2L2_i = ((modelStruct.modelPar_ALP2L2>0.0)?modelStruct.modelPar_ALP2L2:0.0);
modelStruct.d_modelVar_SAREF_i_dX = ((modelStruct.modelPar_SAREF>1.0e-9)?modelStruct.d_modelPar_SAREF_dX:0.0);
modelStruct.modelVar_SAREF_i = ((modelStruct.modelPar_SAREF>1.0e-9)?modelStruct.modelPar_SAREF:1.0e-9);
modelStruct.d_modelVar_SBREF_i_dX = ((modelStruct.modelPar_SBREF>1.0e-9)?modelStruct.d_modelPar_SBREF_dX:0.0);
modelStruct.modelVar_SBREF_i = ((modelStruct.modelPar_SBREF>1.0e-9)?modelStruct.modelPar_SBREF:1.0e-9);
modelStruct.d_modelVar_KVSAT_i_dX = ((modelStruct.modelPar_KVSAT>(-1.0))?((modelStruct.modelPar_KVSAT<1.0)?modelStruct.d_modelPar_KVSAT_dX:0.0):0.0);
modelStruct.modelVar_KVSAT_i = ((modelStruct.modelPar_KVSAT>(-1.0))?((modelStruct.modelPar_KVSAT<1.0)?modelStruct.modelPar_KVSAT:1.0):(-1.0));
modelStruct.d_modelVar_LLODKUO_i_dX = ((modelStruct.modelPar_LLODKUO>0.0)?modelStruct.d_modelPar_LLODKUO_dX:0.0);
modelStruct.modelVar_LLODKUO_i = ((modelStruct.modelPar_LLODKUO>0.0)?modelStruct.modelPar_LLODKUO:0.0);
modelStruct.d_modelVar_WLODKUO_i_dX = ((modelStruct.modelPar_WLODKUO>0.0)?modelStruct.d_modelPar_WLODKUO_dX:0.0);
modelStruct.modelVar_WLODKUO_i = ((modelStruct.modelPar_WLODKUO>0.0)?modelStruct.modelPar_WLODKUO:0.0);
modelStruct.d_modelVar_LLODVTH_i_dX = ((modelStruct.modelPar_LLODVTH>0.0)?modelStruct.d_modelPar_LLODVTH_dX:0.0);
modelStruct.modelVar_LLODVTH_i = ((modelStruct.modelPar_LLODVTH>0.0)?modelStruct.modelPar_LLODVTH:0.0);
modelStruct.d_modelVar_WLODVTH_i_dX = ((modelStruct.modelPar_WLODVTH>0.0)?modelStruct.d_modelPar_WLODVTH_dX:0.0);
modelStruct.modelVar_WLODVTH_i = ((modelStruct.modelPar_WLODVTH>0.0)?modelStruct.modelPar_WLODVTH:0.0);
modelStruct.d_modelVar_LODETAO_i_dX = ((modelStruct.modelPar_LODETAO>0.0)?modelStruct.d_modelPar_LODETAO_dX:0.0);
modelStruct.modelVar_LODETAO_i = ((modelStruct.modelPar_LODETAO>0.0)?modelStruct.modelPar_LODETAO:0.0);
modelStruct.d_modelVar_SCREF_i_dX = ((modelStruct.modelPar_SCREF>0.0)?modelStruct.d_modelPar_SCREF_dX:0.0);
modelStruct.modelVar_SCREF_i = ((modelStruct.modelPar_SCREF>0.0)?modelStruct.modelPar_SCREF:0.0);
modelStruct.d_modelVar_WEB_i_dX = modelStruct.d_modelPar_WEB_dX;
modelStruct.modelVar_WEB_i = modelStruct.modelPar_WEB;
modelStruct.d_modelVar_WEC_i_dX = modelStruct.d_modelPar_WEC_dX;
modelStruct.modelVar_WEC_i = modelStruct.modelPar_WEC;
modelStruct.d_modelVar_RSHG_i_dX = ((modelStruct.modelPar_RSHG>0.0)?modelStruct.d_modelPar_RSHG_dX:0.0);
modelStruct.modelVar_RSHG_i = ((modelStruct.modelPar_RSHG>0.0)?modelStruct.modelPar_RSHG:0.0);
modelStruct.d_modelVar_RSH_i_dX = ((modelStruct.modelPar_RSH>0.0)?modelStruct.d_modelPar_RSH_dX:0.0);
modelStruct.modelVar_RSH_i = ((modelStruct.modelPar_RSH>0.0)?modelStruct.modelPar_RSH:0.0);
modelStruct.d_modelVar_RSHD_i_dX = ((modelStruct.modelPar_RSHD>0.0)?modelStruct.d_modelPar_RSHD_dX:0.0);
modelStruct.modelVar_RSHD_i = ((modelStruct.modelPar_RSHD>0.0)?modelStruct.modelPar_RSHD:0.0);
modelStruct.d_modelVar_RINT_i_dX = ((modelStruct.modelPar_RINT>0.0)?modelStruct.d_modelPar_RINT_dX:0.0);
modelStruct.modelVar_RINT_i = ((modelStruct.modelPar_RINT>0.0)?modelStruct.modelPar_RINT:0.0);
modelStruct.d_modelVar_RVPOLY_i_dX = ((modelStruct.modelPar_RVPOLY>0.0)?modelStruct.d_modelPar_RVPOLY_dX:0.0);
modelStruct.modelVar_RVPOLY_i = ((modelStruct.modelPar_RVPOLY>0.0)?modelStruct.modelPar_RVPOLY:0.0);
modelStruct.d_modelVar_NSUBEDGEO_i_dX = ((modelStruct.modelPar_NSUBEDGEO>1.0e20)?modelStruct.d_modelPar_NSUBEDGEO_dX:0.0);
modelStruct.modelVar_NSUBEDGEO_i = ((modelStruct.modelPar_NSUBEDGEO>1.0e20)?modelStruct.modelPar_NSUBEDGEO:1.0e20);
modelStruct.d_modelVar_LPEDGE_i_dX = ((modelStruct.modelPar_LPEDGE>1.0e-10)?modelStruct.d_modelPar_LPEDGE_dX:0.0);
modelStruct.modelVar_LPEDGE_i = ((modelStruct.modelPar_LPEDGE>1.0e-10)?modelStruct.modelPar_LPEDGE:1.0e-10);
d_TR_i_dX = ((modelStruct.modelPar_TR>(-273.0))?modelStruct.d_modelPar_TR_dX:0.0);
TR_i = ((modelStruct.modelPar_TR>(-273.0))?modelStruct.modelPar_TR:(-273.0));
d_TKR_dX = d_TR_i_dX;
TKR = (273.15+TR_i);
d_TKA_dX = modelStruct.d_modelPar_DTA_dX;
TKA = (admsTemperature+modelStruct.modelPar_DTA);
modelStruct.d_modelVar_rTa_dX = ((TKR*d_TKA_dX-TKA*d_TKR_dX)/TKR/TKR);
modelStruct.modelVar_rTa = (TKA/TKR);
modelStruct.d_modelVar_delTa_dX = (d_TKA_dX-d_TKR_dX);
modelStruct.modelVar_delTa = (TKA-TKR);
modelStruct.d_modelVar_phita_dX = (d_TKA_dX*1.3806505E-23/1.6021918E-19);
modelStruct.modelVar_phita = ((TKA*1.3806505E-23)/1.6021918E-19);
modelStruct.d_modelVar_inv_phita_dX = (-modelStruct.d_modelVar_phita_dX/modelStruct.modelVar_phita/modelStruct.modelVar_phita);
modelStruct.modelVar_inv_phita = (1.0/modelStruct.modelVar_phita);
modelStruct.d_modelVar_TKD_dX = d_TKA_dX;
modelStruct.modelVar_TKD = TKA;
d_TKD_sq_dX = (modelStruct.modelVar_TKD*modelStruct.d_modelVar_TKD_dX+modelStruct.d_modelVar_TKD_dX*modelStruct.modelVar_TKD);
TKD_sq = (modelStruct.modelVar_TKD*modelStruct.modelVar_TKD);
modelStruct.d_modelVar_delT_dX = (modelStruct.d_modelVar_TKD_dX-d_TKR_dX);
modelStruct.modelVar_delT = (modelStruct.modelVar_TKD-TKR);
modelStruct.d_modelVar_rTn_dX = ((modelStruct.modelVar_TKD*d_TKR_dX-TKR*modelStruct.d_modelVar_TKD_dX)/modelStruct.modelVar_TKD/modelStruct.modelVar_TKD);
modelStruct.modelVar_rTn = (TKR/modelStruct.modelVar_TKD);
{
double value_log_0 = log(modelStruct.modelVar_rTn);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_rTn);
modelStruct.d_modelVar_ln_rTn_dX = deriv_log_0_d0*(modelStruct.d_modelVar_rTn_dX);
modelStruct.modelVar_ln_rTn = value_log_0;
}
modelStruct.d_modelVar_phit_dX = (modelStruct.d_modelVar_TKD_dX*1.3806505E-23/1.6021918E-19);
modelStruct.modelVar_phit = ((modelStruct.modelVar_TKD*1.3806505E-23)/1.6021918E-19);
modelStruct.d_modelVar_inv_phit_dX = (-modelStruct.d_modelVar_phit_dX/modelStruct.modelVar_phit/modelStruct.modelVar_phit);
modelStruct.modelVar_inv_phit = (1.0/modelStruct.modelVar_phit);
modelStruct.d_modelVar_Eg_dX = ((-9.025e-5*modelStruct.d_modelVar_TKD_dX)-3.05e-7*d_TKD_sq_dX);
modelStruct.modelVar_Eg = ((1.179-(9.025e-5*modelStruct.modelVar_TKD))-(3.05e-7*TKD_sq));
modelStruct.d_modelVar_phibFac_dX = ((((1.045+(4.5e-4*modelStruct.modelVar_TKD))*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*d_TKD_sq_dX+((1.045+(4.5e-4*modelStruct.modelVar_TKD))*(1.4e-3*modelStruct.d_modelVar_TKD_dX-1.48e-6*d_TKD_sq_dX)+4.5e-4*modelStruct.d_modelVar_TKD_dX*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
modelStruct.modelVar_phibFac = ((((1.045+(4.5e-4*modelStruct.modelVar_TKD))*((0.523+(1.4e-3*modelStruct.modelVar_TKD))-(1.48e-6*TKD_sq)))*TKD_sq)/9.0E4);
modelStruct.d_modelVar_phibFac_dX = ((modelStruct.modelVar_phibFac>1.0E-3)?modelStruct.d_modelVar_phibFac_dX:0.0);
modelStruct.modelVar_phibFac = ((modelStruct.modelVar_phibFac>1.0E-3)?modelStruct.modelVar_phibFac:1.0E-3);
modelStruct.d_modelVar_nt0_dX = (4.0*1.3806505E-23)*modelStruct.d_modelVar_TKD_dX;
modelStruct.modelVar_nt0 = ((4.0*1.3806505E-23)*modelStruct.modelVar_TKD);
d_TRJ_i_dX = ((modelStruct.modelPar_TRJ>(-2.5e2))?modelStruct.d_modelPar_TRJ_dX:0.0);
TRJ_i = ((modelStruct.modelPar_TRJ>(-2.5e2))?modelStruct.modelPar_TRJ:(-2.5e2));
modelStruct.d_modelVar_IMAX_i_dX = ((modelStruct.modelPar_IMAX>1.0e-12)?modelStruct.d_modelPar_IMAX_dX:0.0);
modelStruct.modelVar_IMAX_i = ((modelStruct.modelPar_IMAX>1.0e-12)?modelStruct.modelPar_IMAX:1.0e-12);
d_FREV_i_dX = ((modelStruct.modelPar_FREV>1.0e1)?((modelStruct.modelPar_FREV<1.0e10)?modelStruct.d_modelPar_FREV_dX:0.0):0.0);
FREV_i = ((modelStruct.modelPar_FREV>1.0e1)?((modelStruct.modelPar_FREV<1.0e10)?modelStruct.modelPar_FREV:1.0e10):1.0e1);
d_CJORBOT_i_dX = ((modelStruct.modelPar_CJORBOT>1.0e-12)?modelStruct.d_modelPar_CJORBOT_dX:0.0);
CJORBOT_i = ((modelStruct.modelPar_CJORBOT>1.0e-12)?modelStruct.modelPar_CJORBOT:1.0e-12);
d_CJORSTI_i_dX = ((modelStruct.modelPar_CJORSTI>1.0e-18)?modelStruct.d_modelPar_CJORSTI_dX:0.0);
CJORSTI_i = ((modelStruct.modelPar_CJORSTI>1.0e-18)?modelStruct.modelPar_CJORSTI:1.0e-18);
d_CJORGAT_i_dX = ((modelStruct.modelPar_CJORGAT>1.0e-18)?modelStruct.d_modelPar_CJORGAT_dX:0.0);
CJORGAT_i = ((modelStruct.modelPar_CJORGAT>1.0e-18)?modelStruct.modelPar_CJORGAT:1.0e-18);
modelStruct.d_modelVar_VBIRBOT_i_dX = ((modelStruct.modelPar_VBIRBOT>5.0e-2)?modelStruct.d_modelPar_VBIRBOT_dX:0.0);
modelStruct.modelVar_VBIRBOT_i = ((modelStruct.modelPar_VBIRBOT>5.0e-2)?modelStruct.modelPar_VBIRBOT:5.0e-2);
modelStruct.d_modelVar_VBIRSTI_i_dX = ((modelStruct.modelPar_VBIRSTI>5.0e-2)?modelStruct.d_modelPar_VBIRSTI_dX:0.0);
modelStruct.modelVar_VBIRSTI_i = ((modelStruct.modelPar_VBIRSTI>5.0e-2)?modelStruct.modelPar_VBIRSTI:5.0e-2);
modelStruct.d_modelVar_VBIRGAT_i_dX = ((modelStruct.modelPar_VBIRGAT>5.0e-2)?modelStruct.d_modelPar_VBIRGAT_dX:0.0);
modelStruct.modelVar_VBIRGAT_i = ((modelStruct.modelPar_VBIRGAT>5.0e-2)?modelStruct.modelPar_VBIRGAT:5.0e-2);
modelStruct.d_modelVar_PBOT_i_dX = ((modelStruct.modelPar_PBOT>5.0e-2)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.d_modelPar_PBOT_dX:0.0):0.0);
modelStruct.modelVar_PBOT_i = ((modelStruct.modelPar_PBOT>5.0e-2)?((modelStruct.modelPar_PBOT<0.95)?modelStruct.modelPar_PBOT:0.95):5.0e-2);
modelStruct.d_modelVar_PSTI_i_dX = ((modelStruct.modelPar_PSTI>5.0e-2)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.d_modelPar_PSTI_dX:0.0):0.0);
modelStruct.modelVar_PSTI_i = ((modelStruct.modelPar_PSTI>5.0e-2)?((modelStruct.modelPar_PSTI<0.95)?modelStruct.modelPar_PSTI:0.95):5.0e-2);
modelStruct.d_modelVar_PGAT_i_dX = ((modelStruct.modelPar_PGAT>5.0e-2)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.d_modelPar_PGAT_dX:0.0):0.0);
modelStruct.modelVar_PGAT_i = ((modelStruct.modelPar_PGAT>5.0e-2)?((modelStruct.modelPar_PGAT<0.95)?modelStruct.modelPar_PGAT:0.95):5.0e-2);
d_PHIGBOT_i_dX = modelStruct.d_modelPar_PHIGBOT_dX;
PHIGBOT_i = modelStruct.modelPar_PHIGBOT;
d_PHIGSTI_i_dX = modelStruct.d_modelPar_PHIGSTI_dX;
PHIGSTI_i = modelStruct.modelPar_PHIGSTI;
d_PHIGGAT_i_dX = modelStruct.d_modelPar_PHIGGAT_dX;
PHIGGAT_i = modelStruct.modelPar_PHIGGAT;
d_IDSATRBOT_i_dX = ((modelStruct.modelPar_IDSATRBOT>0.0)?modelStruct.d_modelPar_IDSATRBOT_dX:0.0);
IDSATRBOT_i = ((modelStruct.modelPar_IDSATRBOT>0.0)?modelStruct.modelPar_IDSATRBOT:0.0);
d_IDSATRSTI_i_dX = ((modelStruct.modelPar_IDSATRSTI>0.0)?modelStruct.d_modelPar_IDSATRSTI_dX:0.0);
IDSATRSTI_i = ((modelStruct.modelPar_IDSATRSTI>0.0)?modelStruct.modelPar_IDSATRSTI:0.0);
d_IDSATRGAT_i_dX = ((modelStruct.modelPar_IDSATRGAT>0.0)?modelStruct.d_modelPar_IDSATRGAT_dX:0.0);
IDSATRGAT_i = ((modelStruct.modelPar_IDSATRGAT>0.0)?modelStruct.modelPar_IDSATRGAT:0.0);
modelStruct.d_modelVar_CSRHBOT_i_dX = ((modelStruct.modelPar_CSRHBOT>0.0)?modelStruct.d_modelPar_CSRHBOT_dX:0.0);
modelStruct.modelVar_CSRHBOT_i = ((modelStruct.modelPar_CSRHBOT>0.0)?modelStruct.modelPar_CSRHBOT:0.0);
modelStruct.d_modelVar_CSRHSTI_i_dX = ((modelStruct.modelPar_CSRHSTI>0.0)?modelStruct.d_modelPar_CSRHSTI_dX:0.0);
modelStruct.modelVar_CSRHSTI_i = ((modelStruct.modelPar_CSRHSTI>0.0)?modelStruct.modelPar_CSRHSTI:0.0);
modelStruct.d_modelVar_CSRHGAT_i_dX = ((modelStruct.modelPar_CSRHGAT>0.0)?modelStruct.d_modelPar_CSRHGAT_dX:0.0);
modelStruct.modelVar_CSRHGAT_i = ((modelStruct.modelPar_CSRHGAT>0.0)?modelStruct.modelPar_CSRHGAT:0.0);
d_XJUNSTI_i_dX = ((modelStruct.modelPar_XJUNSTI>1.0e-9)?modelStruct.d_modelPar_XJUNSTI_dX:0.0);
XJUNSTI_i = ((modelStruct.modelPar_XJUNSTI>1.0e-9)?modelStruct.modelPar_XJUNSTI:1.0e-9);
d_XJUNGAT_i_dX = ((modelStruct.modelPar_XJUNGAT>1.0e-9)?modelStruct.d_modelPar_XJUNGAT_dX:0.0);
XJUNGAT_i = ((modelStruct.modelPar_XJUNGAT>1.0e-9)?modelStruct.modelPar_XJUNGAT:1.0e-9);
modelStruct.d_modelVar_CTATBOT_i_dX = ((modelStruct.modelPar_CTATBOT>0.0)?modelStruct.d_modelPar_CTATBOT_dX:0.0);
modelStruct.modelVar_CTATBOT_i = ((modelStruct.modelPar_CTATBOT>0.0)?modelStruct.modelPar_CTATBOT:0.0);
modelStruct.d_modelVar_CTATSTI_i_dX = ((modelStruct.modelPar_CTATSTI>0.0)?modelStruct.d_modelPar_CTATSTI_dX:0.0);
modelStruct.modelVar_CTATSTI_i = ((modelStruct.modelPar_CTATSTI>0.0)?modelStruct.modelPar_CTATSTI:0.0);
modelStruct.d_modelVar_CTATGAT_i_dX = ((modelStruct.modelPar_CTATGAT>0.0)?modelStruct.d_modelPar_CTATGAT_dX:0.0);
modelStruct.modelVar_CTATGAT_i = ((modelStruct.modelPar_CTATGAT>0.0)?modelStruct.modelPar_CTATGAT:0.0);
d_MEFFTATBOT_i_dX = ((modelStruct.modelPar_MEFFTATBOT>1.0e-2)?modelStruct.d_modelPar_MEFFTATBOT_dX:0.0);
MEFFTATBOT_i = ((modelStruct.modelPar_MEFFTATBOT>1.0e-2)?modelStruct.modelPar_MEFFTATBOT:1.0e-2);
d_MEFFTATSTI_i_dX = ((modelStruct.modelPar_MEFFTATSTI>1.0e-2)?modelStruct.d_modelPar_MEFFTATSTI_dX:0.0);
MEFFTATSTI_i = ((modelStruct.modelPar_MEFFTATSTI>1.0e-2)?modelStruct.modelPar_MEFFTATSTI:1.0e-2);
d_MEFFTATGAT_i_dX = ((modelStruct.modelPar_MEFFTATGAT>1.0e-2)?modelStruct.d_modelPar_MEFFTATGAT_dX:0.0);
MEFFTATGAT_i = ((modelStruct.modelPar_MEFFTATGAT>1.0e-2)?modelStruct.modelPar_MEFFTATGAT:1.0e-2);
modelStruct.d_modelVar_CBBTBOT_i_dX = ((modelStruct.modelPar_CBBTBOT>0.0)?modelStruct.d_modelPar_CBBTBOT_dX:0.0);
modelStruct.modelVar_CBBTBOT_i = ((modelStruct.modelPar_CBBTBOT>0.0)?modelStruct.modelPar_CBBTBOT:0.0);
modelStruct.d_modelVar_CBBTSTI_i_dX = ((modelStruct.modelPar_CBBTSTI>0.0)?modelStruct.d_modelPar_CBBTSTI_dX:0.0);
modelStruct.modelVar_CBBTSTI_i = ((modelStruct.modelPar_CBBTSTI>0.0)?modelStruct.modelPar_CBBTSTI:0.0);
modelStruct.d_modelVar_CBBTGAT_i_dX = ((modelStruct.modelPar_CBBTGAT>0.0)?modelStruct.d_modelPar_CBBTGAT_dX:0.0);
modelStruct.modelVar_CBBTGAT_i = ((modelStruct.modelPar_CBBTGAT>0.0)?modelStruct.modelPar_CBBTGAT:0.0);
d_FBBTRBOT_i_dX = modelStruct.d_modelPar_FBBTRBOT_dX;
FBBTRBOT_i = modelStruct.modelPar_FBBTRBOT;
d_FBBTRSTI_i_dX = modelStruct.d_modelPar_FBBTRSTI_dX;
FBBTRSTI_i = modelStruct.modelPar_FBBTRSTI;
d_FBBTRGAT_i_dX = modelStruct.d_modelPar_FBBTRGAT_dX;
FBBTRGAT_i = modelStruct.modelPar_FBBTRGAT;
d_STFBBTBOT_i_dX = modelStruct.d_modelPar_STFBBTBOT_dX;
STFBBTBOT_i = modelStruct.modelPar_STFBBTBOT;
d_STFBBTSTI_i_dX = modelStruct.d_modelPar_STFBBTSTI_dX;
STFBBTSTI_i = modelStruct.modelPar_STFBBTSTI;
d_STFBBTGAT_i_dX = modelStruct.d_modelPar_STFBBTGAT_dX;
STFBBTGAT_i = modelStruct.modelPar_STFBBTGAT;
modelStruct.d_modelVar_VBRBOT_i_dX = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.d_modelPar_VBRBOT_dX:0.0);
modelStruct.modelVar_VBRBOT_i = ((modelStruct.modelPar_VBRBOT>0.1)?modelStruct.modelPar_VBRBOT:0.1);
modelStruct.d_modelVar_VBRSTI_i_dX = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.d_modelPar_VBRSTI_dX:0.0);
modelStruct.modelVar_VBRSTI_i = ((modelStruct.modelPar_VBRSTI>0.1)?modelStruct.modelPar_VBRSTI:0.1);
modelStruct.d_modelVar_VBRGAT_i_dX = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.d_modelPar_VBRGAT_dX:0.0);
modelStruct.modelVar_VBRGAT_i = ((modelStruct.modelPar_VBRGAT>0.1)?modelStruct.modelPar_VBRGAT:0.1);
modelStruct.d_modelVar_PBRBOT_i_dX = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.d_modelPar_PBRBOT_dX:0.0);
modelStruct.modelVar_PBRBOT_i = ((modelStruct.modelPar_PBRBOT>0.1)?modelStruct.modelPar_PBRBOT:0.1);
modelStruct.d_modelVar_PBRSTI_i_dX = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.d_modelPar_PBRSTI_dX:0.0);
modelStruct.modelVar_PBRSTI_i = ((modelStruct.modelPar_PBRSTI>0.1)?modelStruct.modelPar_PBRSTI:0.1);
modelStruct.d_modelVar_PBRGAT_i_dX = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.d_modelPar_PBRGAT_dX:0.0);
modelStruct.modelVar_PBRGAT_i = ((modelStruct.modelPar_PBRGAT>0.1)?modelStruct.modelPar_PBRGAT:0.1);
modelStruct.modelVar_SWJUNEXP_i = 0.0;
if ((modelStruct.modelPar_SWJUNEXP>0.5))
{
modelStruct.modelVar_SWJUNEXP_i = 1.0;
}
else
{
modelStruct.modelVar_SWJUNEXP_i = 0.0;
}
modelStruct.d_modelVar_VJUNREF_i_dX = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.d_modelPar_VJUNREF_dX:0.0);
modelStruct.modelVar_VJUNREF_i = ((modelStruct.modelPar_VJUNREF>0.5)?modelStruct.modelPar_VJUNREF:0.5);
modelStruct.d_modelVar_FJUNQ_i_dX = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.d_modelPar_FJUNQ_dX:0.0);
modelStruct.modelVar_FJUNQ_i = ((modelStruct.modelPar_FJUNQ>0.0)?modelStruct.modelPar_FJUNQ:0.0);
if ((modelStruct.modelPar_SWJUNASYM==0.0))
{
d_CJORBOTD_i_dX = d_CJORBOT_i_dX;
CJORBOTD_i = CJORBOT_i;
d_CJORSTID_i_dX = d_CJORSTI_i_dX;
CJORSTID_i = CJORSTI_i;
d_CJORGATD_i_dX = d_CJORGAT_i_dX;
CJORGATD_i = CJORGAT_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX = modelStruct.d_modelVar_VBIRBOT_i_dX;
modelStruct.modelVar_VBIRBOTD_i = modelStruct.modelVar_VBIRBOT_i;
modelStruct.d_modelVar_VBIRSTID_i_dX = modelStruct.d_modelVar_VBIRSTI_i_dX;
modelStruct.modelVar_VBIRSTID_i = modelStruct.modelVar_VBIRSTI_i;
modelStruct.d_modelVar_VBIRGATD_i_dX = modelStruct.d_modelVar_VBIRGAT_i_dX;
modelStruct.modelVar_VBIRGATD_i = modelStruct.modelVar_VBIRGAT_i;
modelStruct.d_modelVar_PBOTD_i_dX = modelStruct.d_modelVar_PBOT_i_dX;
modelStruct.modelVar_PBOTD_i = modelStruct.modelVar_PBOT_i;
modelStruct.d_modelVar_PSTID_i_dX = modelStruct.d_modelVar_PSTI_i_dX;
modelStruct.modelVar_PSTID_i = modelStruct.modelVar_PSTI_i;
modelStruct.d_modelVar_PGATD_i_dX = modelStruct.d_modelVar_PGAT_i_dX;
modelStruct.modelVar_PGATD_i = modelStruct.modelVar_PGAT_i;
d_PHIGBOTD_i_dX = d_PHIGBOT_i_dX;
PHIGBOTD_i = PHIGBOT_i;
d_PHIGSTID_i_dX = d_PHIGSTI_i_dX;
PHIGSTID_i = PHIGSTI_i;
d_PHIGGATD_i_dX = d_PHIGGAT_i_dX;
PHIGGATD_i = PHIGGAT_i;
d_IDSATRBOTD_i_dX = d_IDSATRBOT_i_dX;
IDSATRBOTD_i = IDSATRBOT_i;
d_IDSATRSTID_i_dX = d_IDSATRSTI_i_dX;
IDSATRSTID_i = IDSATRSTI_i;
d_IDSATRGATD_i_dX = d_IDSATRGAT_i_dX;
IDSATRGATD_i = IDSATRGAT_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX = modelStruct.d_modelVar_CSRHBOT_i_dX;
modelStruct.modelVar_CSRHBOTD_i = modelStruct.modelVar_CSRHBOT_i;
modelStruct.d_modelVar_CSRHSTID_i_dX = modelStruct.d_modelVar_CSRHSTI_i_dX;
modelStruct.modelVar_CSRHSTID_i = modelStruct.modelVar_CSRHSTI_i;
modelStruct.d_modelVar_CSRHGATD_i_dX = modelStruct.d_modelVar_CSRHGAT_i_dX;
modelStruct.modelVar_CSRHGATD_i = modelStruct.modelVar_CSRHGAT_i;
d_XJUNSTID_i_dX = d_XJUNSTI_i_dX;
XJUNSTID_i = XJUNSTI_i;
d_XJUNGATD_i_dX = d_XJUNGAT_i_dX;
XJUNGATD_i = XJUNGAT_i;
modelStruct.d_modelVar_CTATBOTD_i_dX = modelStruct.d_modelVar_CTATBOT_i_dX;
modelStruct.modelVar_CTATBOTD_i = modelStruct.modelVar_CTATBOT_i;
modelStruct.d_modelVar_CTATSTID_i_dX = modelStruct.d_modelVar_CTATSTI_i_dX;
modelStruct.modelVar_CTATSTID_i = modelStruct.modelVar_CTATSTI_i;
modelStruct.d_modelVar_CTATGATD_i_dX = modelStruct.d_modelVar_CTATGAT_i_dX;
modelStruct.modelVar_CTATGATD_i = modelStruct.modelVar_CTATGAT_i;
d_MEFFTATBOTD_i_dX = d_MEFFTATBOT_i_dX;
MEFFTATBOTD_i = MEFFTATBOT_i;
d_MEFFTATSTID_i_dX = d_MEFFTATSTI_i_dX;
MEFFTATSTID_i = MEFFTATSTI_i;
d_MEFFTATGATD_i_dX = d_MEFFTATGAT_i_dX;
MEFFTATGATD_i = MEFFTATGAT_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX = modelStruct.d_modelVar_CBBTBOT_i_dX;
modelStruct.modelVar_CBBTBOTD_i = modelStruct.modelVar_CBBTBOT_i;
modelStruct.d_modelVar_CBBTSTID_i_dX = modelStruct.d_modelVar_CBBTSTI_i_dX;
modelStruct.modelVar_CBBTSTID_i = modelStruct.modelVar_CBBTSTI_i;
modelStruct.d_modelVar_CBBTGATD_i_dX = modelStruct.d_modelVar_CBBTGAT_i_dX;
modelStruct.modelVar_CBBTGATD_i = modelStruct.modelVar_CBBTGAT_i;
d_FBBTRBOTD_i_dX = d_FBBTRBOT_i_dX;
FBBTRBOTD_i = FBBTRBOT_i;
d_FBBTRSTID_i_dX = d_FBBTRSTI_i_dX;
FBBTRSTID_i = FBBTRSTI_i;
d_FBBTRGATD_i_dX = d_FBBTRGAT_i_dX;
FBBTRGATD_i = FBBTRGAT_i;
d_STFBBTBOTD_i_dX = d_STFBBTBOT_i_dX;
STFBBTBOTD_i = STFBBTBOT_i;
d_STFBBTSTID_i_dX = d_STFBBTSTI_i_dX;
STFBBTSTID_i = STFBBTSTI_i;
d_STFBBTGATD_i_dX = d_STFBBTGAT_i_dX;
STFBBTGATD_i = STFBBTGAT_i;
modelStruct.d_modelVar_VBRBOTD_i_dX = modelStruct.d_modelVar_VBRBOT_i_dX;
modelStruct.modelVar_VBRBOTD_i = modelStruct.modelVar_VBRBOT_i;
modelStruct.d_modelVar_VBRSTID_i_dX = modelStruct.d_modelVar_VBRSTI_i_dX;
modelStruct.modelVar_VBRSTID_i = modelStruct.modelVar_VBRSTI_i;
modelStruct.d_modelVar_VBRGATD_i_dX = modelStruct.d_modelVar_VBRGAT_i_dX;
modelStruct.modelVar_VBRGATD_i = modelStruct.modelVar_VBRGAT_i;
modelStruct.d_modelVar_PBRBOTD_i_dX = modelStruct.d_modelVar_PBRBOT_i_dX;
modelStruct.modelVar_PBRBOTD_i = modelStruct.modelVar_PBRBOT_i;
modelStruct.d_modelVar_PBRSTID_i_dX = modelStruct.d_modelVar_PBRSTI_i_dX;
modelStruct.modelVar_PBRSTID_i = modelStruct.modelVar_PBRSTI_i;
modelStruct.d_modelVar_PBRGATD_i_dX = modelStruct.d_modelVar_PBRGAT_i_dX;
modelStruct.modelVar_PBRGATD_i = modelStruct.modelVar_PBRGAT_i;
modelStruct.d_modelVar_VJUNREFD_i_dX = modelStruct.d_modelVar_VJUNREF_i_dX;
modelStruct.modelVar_VJUNREFD_i = modelStruct.modelVar_VJUNREF_i;
modelStruct.d_modelVar_FJUNQD_i_dX = modelStruct.d_modelVar_FJUNQ_i_dX;
modelStruct.modelVar_FJUNQD_i = modelStruct.modelVar_FJUNQ_i;
}
else
{
d_CJORBOTD_i_dX = ((modelStruct.modelPar_CJORBOTD>1.0e-12)?modelStruct.d_modelPar_CJORBOTD_dX:0.0);
CJORBOTD_i = ((modelStruct.modelPar_CJORBOTD>1.0e-12)?modelStruct.modelPar_CJORBOTD:1.0e-12);
d_CJORSTID_i_dX = ((modelStruct.modelPar_CJORSTID>1.0e-18)?modelStruct.d_modelPar_CJORSTID_dX:0.0);
CJORSTID_i = ((modelStruct.modelPar_CJORSTID>1.0e-18)?modelStruct.modelPar_CJORSTID:1.0e-18);
d_CJORGATD_i_dX = ((modelStruct.modelPar_CJORGATD>1.0e-18)?modelStruct.d_modelPar_CJORGATD_dX:0.0);
CJORGATD_i = ((modelStruct.modelPar_CJORGATD>1.0e-18)?modelStruct.modelPar_CJORGATD:1.0e-18);
modelStruct.d_modelVar_VBIRBOTD_i_dX = ((modelStruct.modelPar_VBIRBOTD>5.0e-2)?modelStruct.d_modelPar_VBIRBOTD_dX:0.0);
modelStruct.modelVar_VBIRBOTD_i = ((modelStruct.modelPar_VBIRBOTD>5.0e-2)?modelStruct.modelPar_VBIRBOTD:5.0e-2);
modelStruct.d_modelVar_VBIRSTID_i_dX = ((modelStruct.modelPar_VBIRSTID>5.0e-2)?modelStruct.d_modelPar_VBIRSTID_dX:0.0);
modelStruct.modelVar_VBIRSTID_i = ((modelStruct.modelPar_VBIRSTID>5.0e-2)?modelStruct.modelPar_VBIRSTID:5.0e-2);
modelStruct.d_modelVar_VBIRGATD_i_dX = ((modelStruct.modelPar_VBIRGATD>5.0e-2)?modelStruct.d_modelPar_VBIRGATD_dX:0.0);
modelStruct.modelVar_VBIRGATD_i = ((modelStruct.modelPar_VBIRGATD>5.0e-2)?modelStruct.modelPar_VBIRGATD:5.0e-2);
modelStruct.d_modelVar_PBOTD_i_dX = ((modelStruct.modelPar_PBOTD>5.0e-2)?((modelStruct.modelPar_PBOTD<0.95)?modelStruct.d_modelPar_PBOTD_dX:0.0):0.0);
modelStruct.modelVar_PBOTD_i = ((modelStruct.modelPar_PBOTD>5.0e-2)?((modelStruct.modelPar_PBOTD<0.95)?modelStruct.modelPar_PBOTD:0.95):5.0e-2);
modelStruct.d_modelVar_PSTID_i_dX = ((modelStruct.modelPar_PSTID>5.0e-2)?((modelStruct.modelPar_PSTID<0.95)?modelStruct.d_modelPar_PSTID_dX:0.0):0.0);
modelStruct.modelVar_PSTID_i = ((modelStruct.modelPar_PSTID>5.0e-2)?((modelStruct.modelPar_PSTID<0.95)?modelStruct.modelPar_PSTID:0.95):5.0e-2);
modelStruct.d_modelVar_PGATD_i_dX = ((modelStruct.modelPar_PGATD>5.0e-2)?((modelStruct.modelPar_PGATD<0.95)?modelStruct.d_modelPar_PGATD_dX:0.0):0.0);
modelStruct.modelVar_PGATD_i = ((modelStruct.modelPar_PGATD>5.0e-2)?((modelStruct.modelPar_PGATD<0.95)?modelStruct.modelPar_PGATD:0.95):5.0e-2);
d_PHIGBOTD_i_dX = modelStruct.d_modelPar_PHIGBOTD_dX;
PHIGBOTD_i = modelStruct.modelPar_PHIGBOTD;
d_PHIGSTID_i_dX = modelStruct.d_modelPar_PHIGSTID_dX;
PHIGSTID_i = modelStruct.modelPar_PHIGSTID;
d_PHIGGATD_i_dX = modelStruct.d_modelPar_PHIGGATD_dX;
PHIGGATD_i = modelStruct.modelPar_PHIGGATD;
d_IDSATRBOTD_i_dX = ((modelStruct.modelPar_IDSATRBOTD>0.0)?modelStruct.d_modelPar_IDSATRBOTD_dX:0.0);
IDSATRBOTD_i = ((modelStruct.modelPar_IDSATRBOTD>0.0)?modelStruct.modelPar_IDSATRBOTD:0.0);
d_IDSATRSTID_i_dX = ((modelStruct.modelPar_IDSATRSTID>0.0)?modelStruct.d_modelPar_IDSATRSTID_dX:0.0);
IDSATRSTID_i = ((modelStruct.modelPar_IDSATRSTID>0.0)?modelStruct.modelPar_IDSATRSTID:0.0);
d_IDSATRGATD_i_dX = ((modelStruct.modelPar_IDSATRGATD>0.0)?modelStruct.d_modelPar_IDSATRGATD_dX:0.0);
IDSATRGATD_i = ((modelStruct.modelPar_IDSATRGATD>0.0)?modelStruct.modelPar_IDSATRGATD:0.0);
modelStruct.d_modelVar_CSRHBOTD_i_dX = ((modelStruct.modelPar_CSRHBOTD>0.0)?modelStruct.d_modelPar_CSRHBOTD_dX:0.0);
modelStruct.modelVar_CSRHBOTD_i = ((modelStruct.modelPar_CSRHBOTD>0.0)?modelStruct.modelPar_CSRHBOTD:0.0);
modelStruct.d_modelVar_CSRHSTID_i_dX = ((modelStruct.modelPar_CSRHSTID>0.0)?modelStruct.d_modelPar_CSRHSTID_dX:0.0);
modelStruct.modelVar_CSRHSTID_i = ((modelStruct.modelPar_CSRHSTID>0.0)?modelStruct.modelPar_CSRHSTID:0.0);
modelStruct.d_modelVar_CSRHGATD_i_dX = ((modelStruct.modelPar_CSRHGATD>0.0)?modelStruct.d_modelPar_CSRHGATD_dX:0.0);
modelStruct.modelVar_CSRHGATD_i = ((modelStruct.modelPar_CSRHGATD>0.0)?modelStruct.modelPar_CSRHGATD:0.0);
d_XJUNSTID_i_dX = ((modelStruct.modelPar_XJUNSTID>1.0e-9)?modelStruct.d_modelPar_XJUNSTID_dX:0.0);
XJUNSTID_i = ((modelStruct.modelPar_XJUNSTID>1.0e-9)?modelStruct.modelPar_XJUNSTID:1.0e-9);
d_XJUNGATD_i_dX = ((modelStruct.modelPar_XJUNGATD>1.0e-9)?modelStruct.d_modelPar_XJUNGATD_dX:0.0);
XJUNGATD_i = ((modelStruct.modelPar_XJUNGATD>1.0e-9)?modelStruct.modelPar_XJUNGATD:1.0e-9);
modelStruct.d_modelVar_CTATBOTD_i_dX = ((modelStruct.modelPar_CTATBOTD>0.0)?modelStruct.d_modelPar_CTATBOTD_dX:0.0);
modelStruct.modelVar_CTATBOTD_i = ((modelStruct.modelPar_CTATBOTD>0.0)?modelStruct.modelPar_CTATBOTD:0.0);
modelStruct.d_modelVar_CTATSTID_i_dX = ((modelStruct.modelPar_CTATSTID>0.0)?modelStruct.d_modelPar_CTATSTID_dX:0.0);
modelStruct.modelVar_CTATSTID_i = ((modelStruct.modelPar_CTATSTID>0.0)?modelStruct.modelPar_CTATSTID:0.0);
modelStruct.d_modelVar_CTATGATD_i_dX = ((modelStruct.modelPar_CTATGATD>0.0)?modelStruct.d_modelPar_CTATGATD_dX:0.0);
modelStruct.modelVar_CTATGATD_i = ((modelStruct.modelPar_CTATGATD>0.0)?modelStruct.modelPar_CTATGATD:0.0);
d_MEFFTATBOTD_i_dX = ((modelStruct.modelPar_MEFFTATBOTD>1.0e-2)?modelStruct.d_modelPar_MEFFTATBOTD_dX:0.0);
MEFFTATBOTD_i = ((modelStruct.modelPar_MEFFTATBOTD>1.0e-2)?modelStruct.modelPar_MEFFTATBOTD:1.0e-2);
d_MEFFTATSTID_i_dX = ((modelStruct.modelPar_MEFFTATSTID>1.0e-2)?modelStruct.d_modelPar_MEFFTATSTID_dX:0.0);
MEFFTATSTID_i = ((modelStruct.modelPar_MEFFTATSTID>1.0e-2)?modelStruct.modelPar_MEFFTATSTID:1.0e-2);
d_MEFFTATGATD_i_dX = ((modelStruct.modelPar_MEFFTATGATD>1.0e-2)?modelStruct.d_modelPar_MEFFTATGATD_dX:0.0);
MEFFTATGATD_i = ((modelStruct.modelPar_MEFFTATGATD>1.0e-2)?modelStruct.modelPar_MEFFTATGATD:1.0e-2);
modelStruct.d_modelVar_CBBTBOTD_i_dX = ((modelStruct.modelPar_CBBTBOTD>0.0)?modelStruct.d_modelPar_CBBTBOTD_dX:0.0);
modelStruct.modelVar_CBBTBOTD_i = ((modelStruct.modelPar_CBBTBOTD>0.0)?modelStruct.modelPar_CBBTBOTD:0.0);
modelStruct.d_modelVar_CBBTSTID_i_dX = ((modelStruct.modelPar_CBBTSTID>0.0)?modelStruct.d_modelPar_CBBTSTID_dX:0.0);
modelStruct.modelVar_CBBTSTID_i = ((modelStruct.modelPar_CBBTSTID>0.0)?modelStruct.modelPar_CBBTSTID:0.0);
modelStruct.d_modelVar_CBBTGATD_i_dX = ((modelStruct.modelPar_CBBTGATD>0.0)?modelStruct.d_modelPar_CBBTGATD_dX:0.0);
modelStruct.modelVar_CBBTGATD_i = ((modelStruct.modelPar_CBBTGATD>0.0)?modelStruct.modelPar_CBBTGATD:0.0);
d_FBBTRBOTD_i_dX = modelStruct.d_modelPar_FBBTRBOTD_dX;
FBBTRBOTD_i = modelStruct.modelPar_FBBTRBOTD;
d_FBBTRSTID_i_dX = modelStruct.d_modelPar_FBBTRSTID_dX;
FBBTRSTID_i = modelStruct.modelPar_FBBTRSTID;
d_FBBTRGATD_i_dX = modelStruct.d_modelPar_FBBTRGATD_dX;
FBBTRGATD_i = modelStruct.modelPar_FBBTRGATD;
d_STFBBTBOTD_i_dX = modelStruct.d_modelPar_STFBBTBOTD_dX;
STFBBTBOTD_i = modelStruct.modelPar_STFBBTBOTD;
d_STFBBTSTID_i_dX = modelStruct.d_modelPar_STFBBTSTID_dX;
STFBBTSTID_i = modelStruct.modelPar_STFBBTSTID;
d_STFBBTGATD_i_dX = modelStruct.d_modelPar_STFBBTGATD_dX;
STFBBTGATD_i = modelStruct.modelPar_STFBBTGATD;
modelStruct.d_modelVar_VBRBOTD_i_dX = ((modelStruct.modelPar_VBRBOTD>0.1)?modelStruct.d_modelPar_VBRBOTD_dX:0.0);
modelStruct.modelVar_VBRBOTD_i = ((modelStruct.modelPar_VBRBOTD>0.1)?modelStruct.modelPar_VBRBOTD:0.1);
modelStruct.d_modelVar_VBRSTID_i_dX = ((modelStruct.modelPar_VBRSTID>0.1)?modelStruct.d_modelPar_VBRSTID_dX:0.0);
modelStruct.modelVar_VBRSTID_i = ((modelStruct.modelPar_VBRSTID>0.1)?modelStruct.modelPar_VBRSTID:0.1);
modelStruct.d_modelVar_VBRGATD_i_dX = ((modelStruct.modelPar_VBRGATD>0.1)?modelStruct.d_modelPar_VBRGATD_dX:0.0);
modelStruct.modelVar_VBRGATD_i = ((modelStruct.modelPar_VBRGATD>0.1)?modelStruct.modelPar_VBRGATD:0.1);
modelStruct.d_modelVar_PBRBOTD_i_dX = ((modelStruct.modelPar_PBRBOTD>0.1)?modelStruct.d_modelPar_PBRBOTD_dX:0.0);
modelStruct.modelVar_PBRBOTD_i = ((modelStruct.modelPar_PBRBOTD>0.1)?modelStruct.modelPar_PBRBOTD:0.1);
modelStruct.d_modelVar_PBRSTID_i_dX = ((modelStruct.modelPar_PBRSTID>0.1)?modelStruct.d_modelPar_PBRSTID_dX:0.0);
modelStruct.modelVar_PBRSTID_i = ((modelStruct.modelPar_PBRSTID>0.1)?modelStruct.modelPar_PBRSTID:0.1);
modelStruct.d_modelVar_PBRGATD_i_dX = ((modelStruct.modelPar_PBRGATD>0.1)?modelStruct.d_modelPar_PBRGATD_dX:0.0);
modelStruct.modelVar_PBRGATD_i = ((modelStruct.modelPar_PBRGATD>0.1)?modelStruct.modelPar_PBRGATD:0.1);
modelStruct.d_modelVar_VJUNREFD_i_dX = ((modelStruct.modelPar_VJUNREFD>0.5)?modelStruct.d_modelPar_VJUNREFD_dX:0.0);
modelStruct.modelVar_VJUNREFD_i = ((modelStruct.modelPar_VJUNREFD>0.5)?modelStruct.modelPar_VJUNREFD:0.5);
modelStruct.d_modelVar_FJUNQD_i_dX = ((modelStruct.modelPar_FJUNQD>0.0)?modelStruct.d_modelPar_FJUNQD_dX:0.0);
modelStruct.modelVar_FJUNQD_i = ((modelStruct.modelPar_FJUNQD>0.0)?modelStruct.modelPar_FJUNQD:0.0);
}
d_tkr_dX = d_TRJ_i_dX;
tkr = (273.15+TRJ_i);
{
double value_max_0 = std::max((admsTemperature+modelStruct.modelPar_DTA),(273.15+(-2.5e2)));
double  deriv_max_0_d0 = (((admsTemperature+modelStruct.modelPar_DTA)>=(273.15+(-2.5e2)))?1.0:0.0);
d_tkd_dX = (deriv_max_0_d0*(modelStruct.d_modelPar_DTA_dX));
tkd = value_max_0;
}
d_auxt_dX = ((tkr*d_tkd_dX-tkd*d_tkr_dX)/tkr/tkr);
auxt = (tkd/tkr);
KBOL_over_QELE = (1.3806505E-23/1.6021918E-19);
modelStruct.d_modelVar_phitr_dX = KBOL_over_QELE*d_tkr_dX;
modelStruct.modelVar_phitr = (KBOL_over_QELE*tkr);
d_phitrinv_dX = (-modelStruct.d_modelVar_phitr_dX/modelStruct.modelVar_phitr/modelStruct.modelVar_phitr);
phitrinv = (1.0/modelStruct.modelVar_phitr);
modelStruct.d_modelVar_phitd_dX = KBOL_over_QELE*d_tkd_dX;
modelStruct.modelVar_phitd = (KBOL_over_QELE*tkd);
modelStruct.d_modelVar_phitdinv_dX = (-modelStruct.d_modelVar_phitd_dX/modelStruct.modelVar_phitd/modelStruct.modelVar_phitd);
modelStruct.modelVar_phitdinv = (1.0/modelStruct.modelVar_phitd);
d_deltaphigr_dX = (((1108.0+tkr)*(-((7.02e-4*tkr)*d_tkr_dX+7.02e-4*d_tkr_dX*tkr))-(-((7.02e-4*tkr)*tkr))*d_tkr_dX)/(1108.0+tkr)/(1108.0+tkr));
deltaphigr = ((-((7.02e-4*tkr)*tkr))/(1108.0+tkr));
d_phigrbot_dX = (d_PHIGBOT_i_dX+d_deltaphigr_dX);
phigrbot = (PHIGBOT_i+deltaphigr);
d_phigrsti_dX = (d_PHIGSTI_i_dX+d_deltaphigr_dX);
phigrsti = (PHIGSTI_i+deltaphigr);
d_phigrgat_dX = (d_PHIGGAT_i_dX+d_deltaphigr_dX);
phigrgat = (PHIGGAT_i+deltaphigr);
d_deltaphigd_dX = (((1108.0+tkd)*(-((7.02e-4*tkd)*d_tkd_dX+7.02e-4*d_tkd_dX*tkd))-(-((7.02e-4*tkd)*tkd))*d_tkd_dX)/(1108.0+tkd)/(1108.0+tkd));
deltaphigd = ((-((7.02e-4*tkd)*tkd))/(1108.0+tkd));
d_phigdbot_dX = (d_PHIGBOT_i_dX+d_deltaphigd_dX);
phigdbot = (PHIGBOT_i+deltaphigd);
d_phigdsti_dX = (d_PHIGSTI_i_dX+d_deltaphigd_dX);
phigdsti = (PHIGSTI_i+deltaphigd);
d_phigdgat_dX = (d_PHIGGAT_i_dX+d_deltaphigd_dX);
phigdgat = (PHIGGAT_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot*phitrinv)-(phigdbot*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdbot_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrbot*d_phitrinv_dX+d_phigrbot_dX*phitrinv)-(phigdbot*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdbot = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti*phitrinv)-(phigdsti*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdsti_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrsti*d_phitrinv_dX+d_phigrsti_dX*phitrinv)-(phigdsti*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdsti = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat*phitrinv)-(phigdgat*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdgat_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrgat*d_phitrinv_dX+d_phigrgat_dX*phitrinv)-(phigdgat*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdgat = (value_pow_0*value_exp_1);
}
modelStruct.d_modelVar_idsatbot_dX = ((IDSATRBOT_i*modelStruct.modelVar_ftdbot)*modelStruct.d_modelVar_ftdbot_dX+(IDSATRBOT_i*modelStruct.d_modelVar_ftdbot_dX+d_IDSATRBOT_i_dX*modelStruct.modelVar_ftdbot)*modelStruct.modelVar_ftdbot);
modelStruct.modelVar_idsatbot = ((IDSATRBOT_i*modelStruct.modelVar_ftdbot)*modelStruct.modelVar_ftdbot);
modelStruct.d_modelVar_idsatsti_dX = ((IDSATRSTI_i*modelStruct.modelVar_ftdsti)*modelStruct.d_modelVar_ftdsti_dX+(IDSATRSTI_i*modelStruct.d_modelVar_ftdsti_dX+d_IDSATRSTI_i_dX*modelStruct.modelVar_ftdsti)*modelStruct.modelVar_ftdsti);
modelStruct.modelVar_idsatsti = ((IDSATRSTI_i*modelStruct.modelVar_ftdsti)*modelStruct.modelVar_ftdsti);
modelStruct.d_modelVar_idsatgat_dX = ((IDSATRGAT_i*modelStruct.modelVar_ftdgat)*modelStruct.d_modelVar_ftdgat_dX+(IDSATRGAT_i*modelStruct.d_modelVar_ftdgat_dX+d_IDSATRGAT_i_dX*modelStruct.modelVar_ftdgat)*modelStruct.modelVar_ftdgat);
modelStruct.modelVar_idsatgat = ((IDSATRGAT_i*modelStruct.modelVar_ftdgat)*modelStruct.modelVar_ftdgat);
{
double value_log_0 = log(modelStruct.modelVar_ftdbot);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdbot);
d_ubibot_dX = ((modelStruct.modelVar_VBIRBOT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdbot_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubibot = ((modelStruct.modelVar_VBIRBOT_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdsti);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdsti);
d_ubisti_dX = ((modelStruct.modelVar_VBIRSTI_i*d_auxt_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdsti_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubisti = ((modelStruct.modelVar_VBIRSTI_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdgat);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdgat);
d_ubigat_dX = ((modelStruct.modelVar_VBIRGAT_i*d_auxt_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdgat_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubigat = ((modelStruct.modelVar_VBIRGAT_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_exp_0 = exp(((5.0e-2-ubibot)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbibot_dX = (d_ubibot_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubibot)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubibot_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbibot = (ubibot+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubisti)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbisti_dX = (d_ubisti_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubisti)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubisti_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbisti = (ubisti+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubigat)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1+value_exp_0));
modelStruct.d_modelVar_vbigat_dX = (d_ubigat_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubigat)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubigat_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbigat = (ubigat+(modelStruct.modelVar_phitd*value_log_1));
}
modelStruct.d_modelVar_vbiinvbot_dX = (-modelStruct.d_modelVar_vbibot_dX/modelStruct.modelVar_vbibot/modelStruct.modelVar_vbibot);
modelStruct.modelVar_vbiinvbot = (1.0/modelStruct.modelVar_vbibot);
modelStruct.d_modelVar_vbiinvsti_dX = (-modelStruct.d_modelVar_vbisti_dX/modelStruct.modelVar_vbisti/modelStruct.modelVar_vbisti);
modelStruct.modelVar_vbiinvsti = (1.0/modelStruct.modelVar_vbisti);
modelStruct.d_modelVar_vbiinvgat_dX = (-modelStruct.d_modelVar_vbigat_dX/modelStruct.modelVar_vbigat/modelStruct.modelVar_vbigat);
modelStruct.modelVar_vbiinvgat = (1.0/modelStruct.modelVar_vbigat);
modelStruct.d_modelVar_one_minus_PBOT_dX = (-modelStruct.d_modelVar_PBOT_i_dX);
modelStruct.modelVar_one_minus_PBOT = (1.0-modelStruct.modelVar_PBOT_i);
modelStruct.d_modelVar_one_minus_PSTI_dX = (-modelStruct.d_modelVar_PSTI_i_dX);
modelStruct.modelVar_one_minus_PSTI = (1.0-modelStruct.modelVar_PSTI_i);
modelStruct.d_modelVar_one_minus_PGAT_dX = (-modelStruct.d_modelVar_PGAT_i_dX);
modelStruct.modelVar_one_minus_PGAT = (1.0-modelStruct.modelVar_PGAT_i);
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX = (-modelStruct.d_modelVar_one_minus_PBOT_dX/modelStruct.modelVar_one_minus_PBOT/modelStruct.modelVar_one_minus_PBOT);
modelStruct.modelVar_one_over_one_minus_PBOT = (1.0/modelStruct.modelVar_one_minus_PBOT);
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX = (-modelStruct.d_modelVar_one_minus_PSTI_dX/modelStruct.modelVar_one_minus_PSTI/modelStruct.modelVar_one_minus_PSTI);
modelStruct.modelVar_one_over_one_minus_PSTI = (1.0/modelStruct.modelVar_one_minus_PSTI);
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX = (-modelStruct.d_modelVar_one_minus_PGAT_dX/modelStruct.modelVar_one_minus_PGAT/modelStruct.modelVar_one_minus_PGAT);
modelStruct.modelVar_one_over_one_minus_PGAT = (1.0/modelStruct.modelVar_one_minus_PGAT);
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRBOT_i*modelStruct.modelVar_vbiinvbot))*value_pow_0);
modelStruct.d_modelVar_cjobot_dX = (CJORBOT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRBOT_i*modelStruct.d_modelVar_vbiinvbot_dX+modelStruct.d_modelVar_VBIRBOT_i_dX*modelStruct.modelVar_vbiinvbot)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)))+d_CJORBOT_i_dX*value_pow_0);
modelStruct.modelVar_cjobot = (CJORBOT_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRSTI_i*modelStruct.modelVar_vbiinvsti))*value_pow_0);
modelStruct.d_modelVar_cjosti_dX = (CJORSTI_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRSTI_i*modelStruct.d_modelVar_vbiinvsti_dX+modelStruct.d_modelVar_VBIRSTI_i_dX*modelStruct.modelVar_vbiinvsti)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)))+d_CJORSTI_i_dX*value_pow_0);
modelStruct.modelVar_cjosti = (CJORSTI_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRGAT_i*modelStruct.modelVar_vbiinvgat))*value_pow_0);
modelStruct.d_modelVar_cjogat_dX = (CJORGAT_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRGAT_i*modelStruct.d_modelVar_vbiinvgat_dX+modelStruct.d_modelVar_VBIRGAT_i_dX*modelStruct.modelVar_vbiinvgat)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)))+d_CJORGAT_i_dX*value_pow_0);
modelStruct.modelVar_cjogat = (CJORGAT_i*value_pow_0);
}
modelStruct.d_modelVar_qprefbot_dX = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(modelStruct.modelVar_cjobot*modelStruct.d_modelVar_vbibot_dX+modelStruct.d_modelVar_cjobot_dX*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.modelVar_qprefbot = ((modelStruct.modelVar_cjobot*modelStruct.modelVar_vbibot)*modelStruct.modelVar_one_over_one_minus_PBOT);
modelStruct.d_modelVar_qprefsti_dX = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(modelStruct.modelVar_cjosti*modelStruct.d_modelVar_vbisti_dX+modelStruct.d_modelVar_cjosti_dX*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.modelVar_qprefsti = ((modelStruct.modelVar_cjosti*modelStruct.modelVar_vbisti)*modelStruct.modelVar_one_over_one_minus_PSTI);
modelStruct.d_modelVar_qprefgat_dX = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(modelStruct.modelVar_cjogat*modelStruct.d_modelVar_vbigat_dX+modelStruct.d_modelVar_cjogat_dX*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.modelVar_qprefgat = ((modelStruct.modelVar_cjogat*modelStruct.modelVar_vbigat)*modelStruct.modelVar_one_over_one_minus_PGAT);
modelStruct.d_modelVar_qpref2bot_dX = 2.0*modelStruct.d_modelVar_cjobot_dX;
modelStruct.modelVar_qpref2bot = (2.0*modelStruct.modelVar_cjobot);
modelStruct.d_modelVar_qpref2sti_dX = 2.0*modelStruct.d_modelVar_cjosti_dX;
modelStruct.modelVar_qpref2sti = (2.0*modelStruct.modelVar_cjosti);
modelStruct.d_modelVar_qpref2gat_dX = 2.0*modelStruct.d_modelVar_cjogat_dX;
modelStruct.modelVar_qpref2gat = (2.0*modelStruct.modelVar_cjogat);
modelStruct.d_modelVar_wdepnulrbot_dX = (-modelStruct.modelVar_EPSSI*d_CJORBOT_i_dX/CJORBOT_i/CJORBOT_i);
modelStruct.modelVar_wdepnulrbot = (modelStruct.modelVar_EPSSI/CJORBOT_i);
modelStruct.d_modelVar_wdepnulrsti_dX = ((CJORSTI_i*d_XJUNSTI_i_dX*modelStruct.modelVar_EPSSI-(XJUNSTI_i*modelStruct.modelVar_EPSSI)*d_CJORSTI_i_dX)/CJORSTI_i/CJORSTI_i);
modelStruct.modelVar_wdepnulrsti = ((XJUNSTI_i*modelStruct.modelVar_EPSSI)/CJORSTI_i);
modelStruct.d_modelVar_wdepnulrgat_dX = ((CJORGAT_i*d_XJUNGAT_i_dX*modelStruct.modelVar_EPSSI-(XJUNGAT_i*modelStruct.modelVar_EPSSI)*d_CJORGAT_i_dX)/CJORGAT_i/CJORGAT_i);
modelStruct.modelVar_wdepnulrgat = ((XJUNGAT_i*modelStruct.modelVar_EPSSI)/CJORGAT_i);
modelStruct.d_modelVar_wdepnulrinvbot_dX = (-modelStruct.d_modelVar_wdepnulrbot_dX/modelStruct.modelVar_wdepnulrbot/modelStruct.modelVar_wdepnulrbot);
modelStruct.modelVar_wdepnulrinvbot = (1.0/modelStruct.modelVar_wdepnulrbot);
modelStruct.d_modelVar_wdepnulrinvsti_dX = (-modelStruct.d_modelVar_wdepnulrsti_dX/modelStruct.modelVar_wdepnulrsti/modelStruct.modelVar_wdepnulrsti);
modelStruct.modelVar_wdepnulrinvsti = (1.0/modelStruct.modelVar_wdepnulrsti);
modelStruct.d_modelVar_wdepnulrinvgat_dX = (-modelStruct.d_modelVar_wdepnulrgat_dX/modelStruct.modelVar_wdepnulrgat/modelStruct.modelVar_wdepnulrgat);
modelStruct.modelVar_wdepnulrinvgat = (1.0/modelStruct.modelVar_wdepnulrgat);
modelStruct.d_modelVar_VBIRBOTinv_dX = (-modelStruct.d_modelVar_VBIRBOT_i_dX/modelStruct.modelVar_VBIRBOT_i/modelStruct.modelVar_VBIRBOT_i);
modelStruct.modelVar_VBIRBOTinv = (1.0/modelStruct.modelVar_VBIRBOT_i);
modelStruct.d_modelVar_VBIRSTIinv_dX = (-modelStruct.d_modelVar_VBIRSTI_i_dX/modelStruct.modelVar_VBIRSTI_i/modelStruct.modelVar_VBIRSTI_i);
modelStruct.modelVar_VBIRSTIinv = (1.0/modelStruct.modelVar_VBIRSTI_i);
modelStruct.d_modelVar_VBIRGATinv_dX = (-modelStruct.d_modelVar_VBIRGAT_i_dX/modelStruct.modelVar_VBIRGAT_i/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_VBIRGATinv = (1.0/modelStruct.modelVar_VBIRGAT_i);
modelStruct.modelVar_perfc = (1.77245385090551603*0.29214664);
{
double value_pow_0 = pow(modelStruct.modelVar_perfc,(-2.0));
modelStruct.modelVar_berfc = (((((-5.0)*0.29214664)+6.0)-value_pow_0)/3.0);
}
modelStruct.modelVar_cerfc = ((1.0-0.29214664)-modelStruct.modelVar_berfc);
{
double value_max_0 = std::max((0.5*phigdbot),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdbot)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEbot_dX = ((deriv_max_0_d0*(0.5*d_phigdbot_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEbot = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdsti)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEsti_dX = ((deriv_max_0_d0*(0.5*d_phigdsti_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEsti = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdgat)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEgat_dX = ((deriv_max_0_d0*(0.5*d_phigdgat_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEgat = value_max_0;
}
modelStruct.d_modelVar_atatbot_dX = (deltaEbot*modelStruct.d_modelVar_phitdinv_dX+d_deltaEbot_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatbot = (deltaEbot*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatsti_dX = (deltaEsti*modelStruct.d_modelVar_phitdinv_dX+d_deltaEsti_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatsti = (deltaEsti*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatgat_dX = (deltaEgat*modelStruct.d_modelVar_phitdinv_dX+d_deltaEgat_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatgat = (deltaEgat*modelStruct.modelVar_phitdinv);
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*deltaEbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartbot_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATBOT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot*deltaEbot)*d_deltaEbot_dX+(deltaEbot*d_deltaEbot_dX+d_deltaEbot_dX*deltaEbot)*deltaEbot)+32.0*d_MEFFTATBOT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEbot*deltaEbot)*deltaEbot)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartbot = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*deltaEsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartsti_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATSTI_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti*deltaEsti)*d_deltaEsti_dX+(deltaEsti*d_deltaEsti_dX+d_deltaEsti_dX*deltaEsti)*deltaEsti)+32.0*d_MEFFTATSTI_i_dX*9.1093826E-31*1.6021918E-19*((deltaEsti*deltaEsti)*deltaEsti)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartsti = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*deltaEgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartgat_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATGAT_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat*deltaEgat)*d_deltaEgat_dX+(deltaEgat*d_deltaEgat_dX+d_deltaEgat_dX*deltaEgat)*deltaEgat)+32.0*d_MEFFTATGAT_i_dX*9.1093826E-31*1.6021918E-19*((deltaEgat*deltaEgat)*deltaEgat)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartgat = (value_sqrt_0/(3.0*1.05457168E-34));
}
modelStruct.d_modelVar_fbbtbot_dX = (FBBTRBOT_i*(STFBBTBOT_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTBOT_i_dX*(tkd-tkr))+d_FBBTRBOT_i_dX*(1.0+(STFBBTBOT_i*(tkd-tkr))));
modelStruct.modelVar_fbbtbot = (FBBTRBOT_i*(1.0+(STFBBTBOT_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtsti_dX = (FBBTRSTI_i*(STFBBTSTI_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTSTI_i_dX*(tkd-tkr))+d_FBBTRSTI_i_dX*(1.0+(STFBBTSTI_i*(tkd-tkr))));
modelStruct.modelVar_fbbtsti = (FBBTRSTI_i*(1.0+(STFBBTSTI_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtgat_dX = (FBBTRGAT_i*(STFBBTGAT_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTGAT_i_dX*(tkd-tkr))+d_FBBTRGAT_i_dX*(1.0+(STFBBTGAT_i*(tkd-tkr))));
modelStruct.modelVar_fbbtgat = (FBBTRGAT_i*(1.0+(STFBBTGAT_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtbot_dX = ((modelStruct.modelVar_fbbtbot>0.0)?modelStruct.d_modelVar_fbbtbot_dX:0.0);
modelStruct.modelVar_fbbtbot = ((modelStruct.modelVar_fbbtbot>0.0)?modelStruct.modelVar_fbbtbot:0.0);
modelStruct.d_modelVar_fbbtsti_dX = ((modelStruct.modelVar_fbbtsti>0.0)?modelStruct.d_modelVar_fbbtsti_dX:0.0);
modelStruct.modelVar_fbbtsti = ((modelStruct.modelVar_fbbtsti>0.0)?modelStruct.modelVar_fbbtsti:0.0);
modelStruct.d_modelVar_fbbtgat_dX = ((modelStruct.modelVar_fbbtgat>0.0)?modelStruct.d_modelVar_fbbtgat_dX:0.0);
modelStruct.modelVar_fbbtgat = ((modelStruct.modelVar_fbbtgat>0.0)?modelStruct.modelVar_fbbtgat:0.0);
modelStruct.d_modelVar_alphaav_dX = (-(-d_FREV_i_dX/FREV_i/FREV_i));
modelStruct.modelVar_alphaav = (1.0-(1.0/FREV_i));
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRBOT_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRBOT_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopbot_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopbot = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRSTI_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRSTI_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopsti_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopsti = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRGAT_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRGAT_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopgat_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopgat = (1.0/(1.0-value_pow_0));
}
modelStruct.d_modelVar_VBRinvbot_dX = (-modelStruct.d_modelVar_VBRBOT_i_dX/modelStruct.modelVar_VBRBOT_i/modelStruct.modelVar_VBRBOT_i);
modelStruct.modelVar_VBRinvbot = (1.0/modelStruct.modelVar_VBRBOT_i);
modelStruct.d_modelVar_VBRinvsti_dX = (-modelStruct.d_modelVar_VBRSTI_i_dX/modelStruct.modelVar_VBRSTI_i/modelStruct.modelVar_VBRSTI_i);
modelStruct.modelVar_VBRinvsti = (1.0/modelStruct.modelVar_VBRSTI_i);
modelStruct.d_modelVar_VBRinvgat_dX = (-modelStruct.d_modelVar_VBRGAT_i_dX/modelStruct.modelVar_VBRGAT_i/modelStruct.modelVar_VBRGAT_i);
modelStruct.modelVar_VBRinvgat = (1.0/modelStruct.modelVar_VBRGAT_i);
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRBOT_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRBOT_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopebot_dX = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.d_modelVar_VBRinvbot_dX+((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.d_modelVar_PBRBOT_i_dX+(-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)))+(modelStruct.modelVar_fstopbot*modelStruct.d_modelVar_fstopbot_dX+modelStruct.d_modelVar_fstopbot_dX*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
modelStruct.modelVar_slopebot = (((-((modelStruct.modelVar_fstopbot*modelStruct.modelVar_fstopbot)*value_pow_0))*modelStruct.modelVar_PBRBOT_i)*modelStruct.modelVar_VBRinvbot);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRSTI_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRSTI_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopesti_dX = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.d_modelVar_VBRinvsti_dX+((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.d_modelVar_PBRSTI_i_dX+(-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)))+(modelStruct.modelVar_fstopsti*modelStruct.d_modelVar_fstopsti_dX+modelStruct.d_modelVar_fstopsti_dX*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
modelStruct.modelVar_slopesti = (((-((modelStruct.modelVar_fstopsti*modelStruct.modelVar_fstopsti)*value_pow_0))*modelStruct.modelVar_PBRSTI_i)*modelStruct.modelVar_VBRinvsti);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRGAT_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRGAT_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopegat_dX = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.d_modelVar_VBRinvgat_dX+((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.d_modelVar_PBRGAT_i_dX+(-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)))+(modelStruct.modelVar_fstopgat*modelStruct.d_modelVar_fstopgat_dX+modelStruct.d_modelVar_fstopgat_dX*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
modelStruct.modelVar_slopegat = (((-((modelStruct.modelVar_fstopgat*modelStruct.modelVar_fstopgat)*value_pow_0))*modelStruct.modelVar_PBRGAT_i)*modelStruct.modelVar_VBRinvgat);
}
d_phigrbot_d_dX = (d_PHIGBOTD_i_dX+d_deltaphigr_dX);
phigrbot_d = (PHIGBOTD_i+deltaphigr);
d_phigrsti_d_dX = (d_PHIGSTID_i_dX+d_deltaphigr_dX);
phigrsti_d = (PHIGSTID_i+deltaphigr);
d_phigrgat_d_dX = (d_PHIGGATD_i_dX+d_deltaphigr_dX);
phigrgat_d = (PHIGGATD_i+deltaphigr);
d_phigdbot_d_dX = (d_PHIGBOTD_i_dX+d_deltaphigd_dX);
phigdbot_d = (PHIGBOTD_i+deltaphigd);
d_phigdsti_d_dX = (d_PHIGSTID_i_dX+d_deltaphigd_dX);
phigdsti_d = (PHIGSTID_i+deltaphigd);
d_phigdgat_d_dX = (d_PHIGGATD_i_dX+d_deltaphigd_dX);
phigdgat_d = (PHIGGATD_i+deltaphigd);
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrbot_d*phitrinv)-(phigdbot_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdbot_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrbot_d*d_phitrinv_dX+d_phigrbot_d_dX*phitrinv)-(phigdbot_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdbot_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdbot_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrsti_d*phitrinv)-(phigdsti_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdsti_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrsti_d*d_phitrinv_dX+d_phigrsti_d_dX*phitrinv)-(phigdsti_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdsti_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdsti_d = (value_pow_0*value_exp_1);
}
{
double value_pow_0 = pow(auxt,1.5);
double value_exp_1 = exp((0.5*((phigrgat_d*phitrinv)-(phigdgat_d*modelStruct.modelVar_phitdinv))));
double  deriv_pow_0_d0 = ((auxt == 0.0)?0.0:(value_pow_0*1.5/auxt));
double  deriv_exp_1_d0 = value_exp_1;
modelStruct.d_modelVar_ftdgat_d_dX = (value_pow_0*deriv_exp_1_d0*(0.5*((phigrgat_d*d_phitrinv_dX+d_phigrgat_d_dX*phitrinv)-(phigdgat_d*modelStruct.d_modelVar_phitdinv_dX+d_phigdgat_d_dX*modelStruct.modelVar_phitdinv)))+(deriv_pow_0_d0*(d_auxt_dX))*value_exp_1);
modelStruct.modelVar_ftdgat_d = (value_pow_0*value_exp_1);
}
modelStruct.d_modelVar_idsatbot_d_dX = ((IDSATRBOTD_i*modelStruct.modelVar_ftdbot_d)*modelStruct.d_modelVar_ftdbot_d_dX+(IDSATRBOTD_i*modelStruct.d_modelVar_ftdbot_d_dX+d_IDSATRBOTD_i_dX*modelStruct.modelVar_ftdbot_d)*modelStruct.modelVar_ftdbot_d);
modelStruct.modelVar_idsatbot_d = ((IDSATRBOTD_i*modelStruct.modelVar_ftdbot_d)*modelStruct.modelVar_ftdbot_d);
modelStruct.d_modelVar_idsatsti_d_dX = ((IDSATRSTID_i*modelStruct.modelVar_ftdsti_d)*modelStruct.d_modelVar_ftdsti_d_dX+(IDSATRSTID_i*modelStruct.d_modelVar_ftdsti_d_dX+d_IDSATRSTID_i_dX*modelStruct.modelVar_ftdsti_d)*modelStruct.modelVar_ftdsti_d);
modelStruct.modelVar_idsatsti_d = ((IDSATRSTID_i*modelStruct.modelVar_ftdsti_d)*modelStruct.modelVar_ftdsti_d);
modelStruct.d_modelVar_idsatgat_d_dX = ((IDSATRGATD_i*modelStruct.modelVar_ftdgat_d)*modelStruct.d_modelVar_ftdgat_d_dX+(IDSATRGATD_i*modelStruct.d_modelVar_ftdgat_d_dX+d_IDSATRGATD_i_dX*modelStruct.modelVar_ftdgat_d)*modelStruct.modelVar_ftdgat_d);
modelStruct.modelVar_idsatgat_d = ((IDSATRGATD_i*modelStruct.modelVar_ftdgat_d)*modelStruct.modelVar_ftdgat_d);
{
double value_log_0 = log(modelStruct.modelVar_ftdbot_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdbot_d);
d_ubibot_d_dX = ((modelStruct.modelVar_VBIRBOTD_i*d_auxt_dX+modelStruct.d_modelVar_VBIRBOTD_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdbot_d_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubibot_d = ((modelStruct.modelVar_VBIRBOTD_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdsti_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdsti_d);
d_ubisti_d_dX = ((modelStruct.modelVar_VBIRSTID_i*d_auxt_dX+modelStruct.d_modelVar_VBIRSTID_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdsti_d_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubisti_d = ((modelStruct.modelVar_VBIRSTID_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_log_0 = log(modelStruct.modelVar_ftdgat_d);
double  deriv_log_0_d0 = (1.0/modelStruct.modelVar_ftdgat_d);
d_ubigat_d_dX = ((modelStruct.modelVar_VBIRGATD_i*d_auxt_dX+modelStruct.d_modelVar_VBIRGATD_i_dX*auxt)-((2.0*modelStruct.modelVar_phitd)*deriv_log_0_d0*(modelStruct.d_modelVar_ftdgat_d_dX)+2.0*modelStruct.d_modelVar_phitd_dX*value_log_0));
ubigat_d = ((modelStruct.modelVar_VBIRGATD_i*auxt)-((2.0*modelStruct.modelVar_phitd)*value_log_0));
}
{
double value_exp_0 = exp(((5.0e-2-ubibot_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
modelStruct.d_modelVar_vbibot_d_dX = (d_ubibot_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubibot_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubibot_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbibot_d = (ubibot_d+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubisti_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
modelStruct.d_modelVar_vbisti_d_dX = (d_ubisti_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubisti_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubisti_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbisti_d = (ubisti_d+(modelStruct.modelVar_phitd*value_log_1));
}
{
double value_exp_0 = exp(((5.0e-2-ubigat_d)*modelStruct.modelVar_phitdinv));
double value_log_1 = log((1.0+value_exp_0));
double  deriv_exp_0_d0 = value_exp_0;
double  deriv_log_1_d0 = (1.0/(1.0+value_exp_0));
modelStruct.d_modelVar_vbigat_d_dX = (d_ubigat_d_dX+(modelStruct.modelVar_phitd*deriv_log_1_d0*(deriv_exp_0_d0*(((5.0e-2-ubigat_d)*modelStruct.d_modelVar_phitdinv_dX+(-d_ubigat_d_dX)*modelStruct.modelVar_phitdinv)))+modelStruct.d_modelVar_phitd_dX*value_log_1));
modelStruct.modelVar_vbigat_d = (ubigat_d+(modelStruct.modelVar_phitd*value_log_1));
}
modelStruct.d_modelVar_vbiinvbot_d_dX = (-modelStruct.d_modelVar_vbibot_d_dX/modelStruct.modelVar_vbibot_d/modelStruct.modelVar_vbibot_d);
modelStruct.modelVar_vbiinvbot_d = (1.0/modelStruct.modelVar_vbibot_d);
modelStruct.d_modelVar_vbiinvsti_d_dX = (-modelStruct.d_modelVar_vbisti_d_dX/modelStruct.modelVar_vbisti_d/modelStruct.modelVar_vbisti_d);
modelStruct.modelVar_vbiinvsti_d = (1.0/modelStruct.modelVar_vbisti_d);
modelStruct.d_modelVar_vbiinvgat_d_dX = (-modelStruct.d_modelVar_vbigat_d_dX/modelStruct.modelVar_vbigat_d/modelStruct.modelVar_vbigat_d);
modelStruct.modelVar_vbiinvgat_d = (1.0/modelStruct.modelVar_vbigat_d);
modelStruct.d_modelVar_one_minus_PBOT_d_dX = (-modelStruct.d_modelVar_PBOTD_i_dX);
modelStruct.modelVar_one_minus_PBOT_d = (1.0-modelStruct.modelVar_PBOTD_i);
modelStruct.d_modelVar_one_minus_PSTI_d_dX = (-modelStruct.d_modelVar_PSTID_i_dX);
modelStruct.modelVar_one_minus_PSTI_d = (1.0-modelStruct.modelVar_PSTID_i);
modelStruct.d_modelVar_one_minus_PGAT_d_dX = (-modelStruct.d_modelVar_PGATD_i_dX);
modelStruct.modelVar_one_minus_PGAT_d = (1.0-modelStruct.modelVar_PGATD_i);
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX = (-modelStruct.d_modelVar_one_minus_PBOT_d_dX/modelStruct.modelVar_one_minus_PBOT_d/modelStruct.modelVar_one_minus_PBOT_d);
modelStruct.modelVar_one_over_one_minus_PBOT_d = (1.0/modelStruct.modelVar_one_minus_PBOT_d);
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX = (-modelStruct.d_modelVar_one_minus_PSTI_d_dX/modelStruct.modelVar_one_minus_PSTI_d/modelStruct.modelVar_one_minus_PSTI_d);
modelStruct.modelVar_one_over_one_minus_PSTI_d = (1.0/modelStruct.modelVar_one_minus_PSTI_d);
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX = (-modelStruct.d_modelVar_one_minus_PGAT_d_dX/modelStruct.modelVar_one_minus_PGAT_d/modelStruct.modelVar_one_minus_PGAT_d);
modelStruct.modelVar_one_over_one_minus_PGAT_d = (1.0/modelStruct.modelVar_one_minus_PGAT_d);
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRBOTD_i*modelStruct.modelVar_vbiinvbot_d))*value_pow_0);
modelStruct.d_modelVar_cjobot_d_dX = (CJORBOTD_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRBOTD_i*modelStruct.d_modelVar_vbiinvbot_d_dX+modelStruct.d_modelVar_VBIRBOTD_i_dX*modelStruct.modelVar_vbiinvbot_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)))+d_CJORBOTD_i_dX*value_pow_0);
modelStruct.modelVar_cjobot_d = (CJORBOTD_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRSTID_i*modelStruct.modelVar_vbiinvsti_d))*value_pow_0);
modelStruct.d_modelVar_cjosti_d_dX = (CJORSTID_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRSTID_i*modelStruct.d_modelVar_vbiinvsti_d_dX+modelStruct.d_modelVar_VBIRSTID_i_dX*modelStruct.modelVar_vbiinvsti_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)))+d_CJORSTID_i_dX*value_pow_0);
modelStruct.modelVar_cjosti_d = (CJORSTID_i*value_pow_0);
}
{
double value_pow_0 = pow((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_pow_0_d1 = ((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d) == 0.0)?0.0:(log((modelStruct.modelVar_VBIRGATD_i*modelStruct.modelVar_vbiinvgat_d))*value_pow_0);
modelStruct.d_modelVar_cjogat_d_dX = (CJORGATD_i*((deriv_pow_0_d0*((modelStruct.modelVar_VBIRGATD_i*modelStruct.d_modelVar_vbiinvgat_d_dX+modelStruct.d_modelVar_VBIRGATD_i_dX*modelStruct.modelVar_vbiinvgat_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)))+d_CJORGATD_i_dX*value_pow_0);
modelStruct.modelVar_cjogat_d = (CJORGATD_i*value_pow_0);
}
modelStruct.d_modelVar_qprefbot_d_dX = ((modelStruct.modelVar_cjobot_d*modelStruct.modelVar_vbibot_d)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(modelStruct.modelVar_cjobot_d*modelStruct.d_modelVar_vbibot_d_dX+modelStruct.d_modelVar_cjobot_d_dX*modelStruct.modelVar_vbibot_d)*modelStruct.modelVar_one_over_one_minus_PBOT_d);
modelStruct.modelVar_qprefbot_d = ((modelStruct.modelVar_cjobot_d*modelStruct.modelVar_vbibot_d)*modelStruct.modelVar_one_over_one_minus_PBOT_d);
modelStruct.d_modelVar_qprefsti_d_dX = ((modelStruct.modelVar_cjosti_d*modelStruct.modelVar_vbisti_d)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(modelStruct.modelVar_cjosti_d*modelStruct.d_modelVar_vbisti_d_dX+modelStruct.d_modelVar_cjosti_d_dX*modelStruct.modelVar_vbisti_d)*modelStruct.modelVar_one_over_one_minus_PSTI_d);
modelStruct.modelVar_qprefsti_d = ((modelStruct.modelVar_cjosti_d*modelStruct.modelVar_vbisti_d)*modelStruct.modelVar_one_over_one_minus_PSTI_d);
modelStruct.d_modelVar_qprefgat_d_dX = ((modelStruct.modelVar_cjogat_d*modelStruct.modelVar_vbigat_d)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(modelStruct.modelVar_cjogat_d*modelStruct.d_modelVar_vbigat_d_dX+modelStruct.d_modelVar_cjogat_d_dX*modelStruct.modelVar_vbigat_d)*modelStruct.modelVar_one_over_one_minus_PGAT_d);
modelStruct.modelVar_qprefgat_d = ((modelStruct.modelVar_cjogat_d*modelStruct.modelVar_vbigat_d)*modelStruct.modelVar_one_over_one_minus_PGAT_d);
modelStruct.d_modelVar_qpref2bot_d_dX = 2.0*modelStruct.d_modelVar_cjobot_d_dX;
modelStruct.modelVar_qpref2bot_d = (2.0*modelStruct.modelVar_cjobot_d);
modelStruct.d_modelVar_qpref2sti_d_dX = 2.0*modelStruct.d_modelVar_cjosti_d_dX;
modelStruct.modelVar_qpref2sti_d = (2.0*modelStruct.modelVar_cjosti_d);
modelStruct.d_modelVar_qpref2gat_d_dX = 2.0*modelStruct.d_modelVar_cjogat_d_dX;
modelStruct.modelVar_qpref2gat_d = (2.0*modelStruct.modelVar_cjogat_d);
modelStruct.d_modelVar_wdepnulrbot_d_dX = (-modelStruct.modelVar_EPSSI*d_CJORBOTD_i_dX/CJORBOTD_i/CJORBOTD_i);
modelStruct.modelVar_wdepnulrbot_d = (modelStruct.modelVar_EPSSI/CJORBOTD_i);
modelStruct.d_modelVar_wdepnulrsti_d_dX = ((CJORSTID_i*d_XJUNSTID_i_dX*modelStruct.modelVar_EPSSI-(XJUNSTID_i*modelStruct.modelVar_EPSSI)*d_CJORSTID_i_dX)/CJORSTID_i/CJORSTID_i);
modelStruct.modelVar_wdepnulrsti_d = ((XJUNSTID_i*modelStruct.modelVar_EPSSI)/CJORSTID_i);
modelStruct.d_modelVar_wdepnulrgat_d_dX = ((CJORGATD_i*d_XJUNGATD_i_dX*modelStruct.modelVar_EPSSI-(XJUNGATD_i*modelStruct.modelVar_EPSSI)*d_CJORGATD_i_dX)/CJORGATD_i/CJORGATD_i);
modelStruct.modelVar_wdepnulrgat_d = ((XJUNGATD_i*modelStruct.modelVar_EPSSI)/CJORGATD_i);
modelStruct.d_modelVar_wdepnulrinvbot_d_dX = (-modelStruct.d_modelVar_wdepnulrbot_d_dX/modelStruct.modelVar_wdepnulrbot_d/modelStruct.modelVar_wdepnulrbot_d);
modelStruct.modelVar_wdepnulrinvbot_d = (1.0/modelStruct.modelVar_wdepnulrbot_d);
modelStruct.d_modelVar_wdepnulrinvsti_d_dX = (-modelStruct.d_modelVar_wdepnulrsti_d_dX/modelStruct.modelVar_wdepnulrsti_d/modelStruct.modelVar_wdepnulrsti_d);
modelStruct.modelVar_wdepnulrinvsti_d = (1.0/modelStruct.modelVar_wdepnulrsti_d);
modelStruct.d_modelVar_wdepnulrinvgat_d_dX = (-modelStruct.d_modelVar_wdepnulrgat_d_dX/modelStruct.modelVar_wdepnulrgat_d/modelStruct.modelVar_wdepnulrgat_d);
modelStruct.modelVar_wdepnulrinvgat_d = (1.0/modelStruct.modelVar_wdepnulrgat_d);
modelStruct.d_modelVar_VBIRBOTinv_d_dX = (-modelStruct.d_modelVar_VBIRBOTD_i_dX/modelStruct.modelVar_VBIRBOTD_i/modelStruct.modelVar_VBIRBOTD_i);
modelStruct.modelVar_VBIRBOTinv_d = (1.0/modelStruct.modelVar_VBIRBOTD_i);
modelStruct.d_modelVar_VBIRSTIinv_d_dX = (-modelStruct.d_modelVar_VBIRSTID_i_dX/modelStruct.modelVar_VBIRSTID_i/modelStruct.modelVar_VBIRSTID_i);
modelStruct.modelVar_VBIRSTIinv_d = (1.0/modelStruct.modelVar_VBIRSTID_i);
modelStruct.d_modelVar_VBIRGATinv_d_dX = (-modelStruct.d_modelVar_VBIRGATD_i_dX/modelStruct.modelVar_VBIRGATD_i/modelStruct.modelVar_VBIRGATD_i);
modelStruct.modelVar_VBIRGATinv_d = (1.0/modelStruct.modelVar_VBIRGATD_i);
{
double value_max_0 = std::max((0.5*phigdbot_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdbot_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdbot_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEbot_d_dX = ((deriv_max_0_d0*(0.5*d_phigdbot_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEbot_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdsti_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdsti_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdsti_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEsti_d_dX = ((deriv_max_0_d0*(0.5*d_phigdsti_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEsti_d = value_max_0;
}
{
double value_max_0 = std::max((0.5*phigdgat_d),modelStruct.modelVar_phitd);
double  deriv_max_0_d0 = (((0.5*phigdgat_d)>=modelStruct.modelVar_phitd)?1.0:0.0);
double  deriv_max_0_d1 = (((0.5*phigdgat_d)>=modelStruct.modelVar_phitd)?0.0:1.0);
d_deltaEgat_d_dX = ((deriv_max_0_d0*(0.5*d_phigdgat_d_dX))+(deriv_max_0_d1*(modelStruct.d_modelVar_phitd_dX)));
deltaEgat_d = value_max_0;
}
modelStruct.d_modelVar_atatbot_d_dX = (deltaEbot_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEbot_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatbot_d = (deltaEbot_d*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatsti_d_dX = (deltaEsti_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEsti_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatsti_d = (deltaEsti_d*modelStruct.modelVar_phitdinv);
modelStruct.d_modelVar_atatgat_d_dX = (deltaEgat_d*modelStruct.d_modelVar_phitdinv_dX+d_deltaEgat_d_dX*modelStruct.modelVar_phitdinv);
modelStruct.modelVar_atatgat_d = (deltaEgat_d*modelStruct.modelVar_phitdinv);
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartbot_d_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATBOTD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEbot_d*deltaEbot_d)*d_deltaEbot_d_dX+(deltaEbot_d*d_deltaEbot_d_dX+d_deltaEbot_d_dX*deltaEbot_d)*deltaEbot_d)+32.0*d_MEFFTATBOTD_i_dX*9.1093826E-31*1.6021918E-19*((deltaEbot_d*deltaEbot_d)*deltaEbot_d)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartbot_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartsti_d_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATSTID_i)*9.1093826E-31)*1.6021918E-19)*((deltaEsti_d*deltaEsti_d)*d_deltaEsti_d_dX+(deltaEsti_d*d_deltaEsti_d_dX+d_deltaEsti_d_dX*deltaEsti_d)*deltaEsti_d)+32.0*d_MEFFTATSTID_i_dX*9.1093826E-31*1.6021918E-19*((deltaEsti_d*deltaEsti_d)*deltaEsti_d)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartsti_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
{
double value_sqrt_0 = sqrt(((((32.0*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
modelStruct.d_modelVar_btatpartgat_d_dX = (deriv_sqrt_0_d0*(((((32.0*MEFFTATGATD_i)*9.1093826E-31)*1.6021918E-19)*((deltaEgat_d*deltaEgat_d)*d_deltaEgat_d_dX+(deltaEgat_d*d_deltaEgat_d_dX+d_deltaEgat_d_dX*deltaEgat_d)*deltaEgat_d)+32.0*d_MEFFTATGATD_i_dX*9.1093826E-31*1.6021918E-19*((deltaEgat_d*deltaEgat_d)*deltaEgat_d)))/(3.0*1.05457168E-34));
modelStruct.modelVar_btatpartgat_d = (value_sqrt_0/(3.0*1.05457168E-34));
}
modelStruct.d_modelVar_fbbtbot_d_dX = (FBBTRBOTD_i*(STFBBTBOTD_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTBOTD_i_dX*(tkd-tkr))+d_FBBTRBOTD_i_dX*(1.0+(STFBBTBOTD_i*(tkd-tkr))));
modelStruct.modelVar_fbbtbot_d = (FBBTRBOTD_i*(1.0+(STFBBTBOTD_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtsti_d_dX = (FBBTRSTID_i*(STFBBTSTID_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTSTID_i_dX*(tkd-tkr))+d_FBBTRSTID_i_dX*(1.0+(STFBBTSTID_i*(tkd-tkr))));
modelStruct.modelVar_fbbtsti_d = (FBBTRSTID_i*(1.0+(STFBBTSTID_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtgat_d_dX = (FBBTRGATD_i*(STFBBTGATD_i*(d_tkd_dX-d_tkr_dX)+d_STFBBTGATD_i_dX*(tkd-tkr))+d_FBBTRGATD_i_dX*(1.0+(STFBBTGATD_i*(tkd-tkr))));
modelStruct.modelVar_fbbtgat_d = (FBBTRGATD_i*(1.0+(STFBBTGATD_i*(tkd-tkr))));
modelStruct.d_modelVar_fbbtbot_d_dX = ((modelStruct.modelVar_fbbtbot_d>0.0)?modelStruct.d_modelVar_fbbtbot_d_dX:0.0);
modelStruct.modelVar_fbbtbot_d = ((modelStruct.modelVar_fbbtbot_d>0.0)?modelStruct.modelVar_fbbtbot_d:0.0);
modelStruct.d_modelVar_fbbtsti_d_dX = ((modelStruct.modelVar_fbbtsti_d>0.0)?modelStruct.d_modelVar_fbbtsti_d_dX:0.0);
modelStruct.modelVar_fbbtsti_d = ((modelStruct.modelVar_fbbtsti_d>0.0)?modelStruct.modelVar_fbbtsti_d:0.0);
modelStruct.d_modelVar_fbbtgat_d_dX = ((modelStruct.modelVar_fbbtgat_d>0.0)?modelStruct.d_modelVar_fbbtgat_d_dX:0.0);
modelStruct.modelVar_fbbtgat_d = ((modelStruct.modelVar_fbbtgat_d>0.0)?modelStruct.modelVar_fbbtgat_d:0.0);
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRBOTD_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRBOTD_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopbot_d_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopbot_d = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRSTID_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRSTID_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopsti_d_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTID_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopsti_d = (1.0/(1.0-value_pow_0));
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,modelStruct.modelVar_PBRGATD_i);
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBRGATD_i/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_fstopgat_d_dX = (-(-((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGATD_i_dX))))/(1.0-value_pow_0)/(1.0-value_pow_0));
modelStruct.modelVar_fstopgat_d = (1.0/(1.0-value_pow_0));
}
modelStruct.d_modelVar_VBRinvbot_d_dX = (-modelStruct.d_modelVar_VBRBOTD_i_dX/modelStruct.modelVar_VBRBOTD_i/modelStruct.modelVar_VBRBOTD_i);
modelStruct.modelVar_VBRinvbot_d = (1.0/modelStruct.modelVar_VBRBOTD_i);
modelStruct.d_modelVar_VBRinvsti_d_dX = (-modelStruct.d_modelVar_VBRSTID_i_dX/modelStruct.modelVar_VBRSTID_i/modelStruct.modelVar_VBRSTID_i);
modelStruct.modelVar_VBRinvsti_d = (1.0/modelStruct.modelVar_VBRSTID_i);
modelStruct.d_modelVar_VBRinvgat_d_dX = (-modelStruct.d_modelVar_VBRGATD_i_dX/modelStruct.modelVar_VBRGATD_i/modelStruct.modelVar_VBRGATD_i);
modelStruct.modelVar_VBRinvgat_d = (1.0/modelStruct.modelVar_VBRGATD_i);
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRBOTD_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRBOTD_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopebot_d_dX = (((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.d_modelVar_VBRinvbot_d_dX+((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.d_modelVar_PBRBOTD_i_dX+(-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)))+(modelStruct.modelVar_fstopbot_d*modelStruct.d_modelVar_fstopbot_d_dX+modelStruct.d_modelVar_fstopbot_d_dX*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.modelVar_VBRinvbot_d);
modelStruct.modelVar_slopebot_d = (((-((modelStruct.modelVar_fstopbot_d*modelStruct.modelVar_fstopbot_d)*value_pow_0))*modelStruct.modelVar_PBRBOTD_i)*modelStruct.modelVar_VBRinvbot_d);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRSTID_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRSTID_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopesti_d_dX = (((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.d_modelVar_VBRinvsti_d_dX+((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.d_modelVar_PBRSTID_i_dX+(-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)))+(modelStruct.modelVar_fstopsti_d*modelStruct.d_modelVar_fstopsti_d_dX+modelStruct.d_modelVar_fstopsti_d_dX*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.modelVar_VBRinvsti_d);
modelStruct.modelVar_slopesti_d = (((-((modelStruct.modelVar_fstopsti_d*modelStruct.modelVar_fstopsti_d)*value_pow_0))*modelStruct.modelVar_PBRSTID_i)*modelStruct.modelVar_VBRinvsti_d);
}
{
double value_pow_0 = pow(modelStruct.modelVar_alphaav,(modelStruct.modelVar_PBRGATD_i-1.0));
double  deriv_pow_0_d0 = ((modelStruct.modelVar_alphaav == 0.0)?0.0:(value_pow_0*(modelStruct.modelVar_PBRGATD_i-1.0)/modelStruct.modelVar_alphaav));
double  deriv_pow_0_d1 = (modelStruct.modelVar_alphaav == 0.0)?0.0:(log(modelStruct.modelVar_alphaav)*value_pow_0);
modelStruct.d_modelVar_slopegat_d_dX = (((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.d_modelVar_VBRinvgat_d_dX+((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.d_modelVar_PBRGATD_i_dX+(-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*((deriv_pow_0_d0*(modelStruct.d_modelVar_alphaav_dX))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)))+(modelStruct.modelVar_fstopgat_d*modelStruct.d_modelVar_fstopgat_d_dX+modelStruct.d_modelVar_fstopgat_d_dX*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.modelVar_VBRinvgat_d);
modelStruct.modelVar_slopegat_d = (((-((modelStruct.modelVar_fstopgat_d*modelStruct.modelVar_fstopgat_d)*value_pow_0))*modelStruct.modelVar_PBRGATD_i)*modelStruct.modelVar_VBRinvgat_d);
}
}
// End block initial_model
}



//-----------------------------------------------------------------------------
// Function      : evaluateModelEquations
// Purpose       : Evaluate the main module block.  Similar to
//                 updateIntermediateVars, but takes all instance and model
//                 parameters and variables as arguments instead of using
//                 the ones stored in the objects.
// Special Notes : specific for sensitivity use
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
void evaluateModelEquations(
std::vector <double> & probeVars,
// probe constants
const int admsProbeID_V_DI_GND,
const int admsProbeID_V_BS_GND,
const int admsProbeID_V_BD_GND,
const int admsProbeID_V_SI_GND,
const int admsProbeID_V_BP_GND,
const int admsProbeID_V_GP_GND,
const int admsProbeID_V_NOI_GND,
const int admsProbeID_V_NOI2_GND,
const int admsProbeID_V_B_BI,
const int admsProbeID_V_BD_BI,
const int admsProbeID_V_BS_BI,
const int admsProbeID_V_BP_BI,
const int admsProbeID_V_D_DI,
const int admsProbeID_V_S_SI,
const int admsProbeID_V_G_GP,
const int admsProbeID_V_DI_BD,
const int admsProbeID_V_SI_BS,
const int admsProbeID_V_SI_BP,
const int admsProbeID_V_DI_SI,
const int admsProbeID_V_GP_SI,
// node constants
const int admsNodeID_D,
const int admsNodeID_G,
const int admsNodeID_S,
const int admsNodeID_B,
const int admsNodeID_NOI,
const int admsNodeID_NOI2,
const int admsNodeID_GP,
const int admsNodeID_SI,
const int admsNodeID_DI,
const int admsNodeID_BP,
const int admsNodeID_BI,
const int admsNodeID_BS,
const int admsNodeID_BD,
instanceSensStruct & instanceStruct,
modelSensStruct & modelStruct,
// basic variables
 double admsTemperature, double adms_vt_nom, double ADMSgmin_arg, std::vector <double> & d_staticContributions_dX, std::vector <double> & d_dynamicContributions_dX, const Instance & theInstance)
{

  // Local variables
  double vth_i=0.0;
double d_vth_i_dX=0.0;
  double vts_i=0.0;
double d_vts_i_dX=0.0;
  double facvsb=0.0;
double d_facvsb_dX=0.0;
  double facvsb0=0.0;
double d_facvsb0_dX=0.0;
  double P_D=0.0;
double d_P_D_dX=0.0;
  double delVsat=0.0;
double d_delVsat_dX=0.0;
  double Q_EDGE_errq=0.0;
double d_Q_EDGE_errq_dX=0.0;
  double Q_EDGE_sqerr=0.0;
double d_Q_EDGE_sqerr_dX=0.0;
  double Q_EDGE_d0p=0.0;
double d_Q_EDGE_d0p_dX=0.0;
  double Q_EDGE_d0=0.0;
double d_Q_EDGE_d0_dX=0.0;
  double Q_EDGE_exp_x=0.0;
double d_Q_EDGE_exp_x_dX=0.0;
  double Q_EDGE_qi0=0.0;
double d_Q_EDGE_qi0_dX=0.0;
  double Q_EDGE_qi0si=0.0;
double d_Q_EDGE_qi0si_dX=0.0;
  double Q_EDGE_xgt0e=0.0;
double d_Q_EDGE_xgt0e_dX=0.0;
  double Q_EDGE_xgt0=0.0;
double d_Q_EDGE_xgt0_dX=0.0;
  double Q_EDGE_xgt=0.0;
double d_Q_EDGE_xgt_dX=0.0;
  double Q_EDGE_n_inv=0.0;
double d_Q_EDGE_n_inv_dX=0.0;
  double Q_EDGE_n=0.0;
double d_Q_EDGE_n_dX=0.0;
  double Q_EDGE_xth=0.0;
double d_Q_EDGE_xth_dX=0.0;
  double Q_EDGE_xth0=0.0;
double d_Q_EDGE_xth0_dX=0.0;
  double Q_EDGE_xsth=0.0;
double d_Q_EDGE_xsth_dX=0.0;
  double Vtovs=0.0;
double d_Vtovs_dX=0.0;
  double Vtovd=0.0;
double d_Vtovd_dX=0.0;
  double Igisl=0.0;
double d_Igisl_dX=0.0;
  double Igidl=0.0;
double d_Igidl_dX=0.0;
  double Sg=0.0;
double d_Sg_dX=0.0;
  double igcd_h=0.0;
double d_igcd_h_dX=0.0;
  double igc=0.0;
double d_igc_dX=0.0;
  double xsq=0.0;
double d_xsq_dX=0.0;
  double inv_ex=0.0;
double d_inv_ex_dX=0.0;
  double ex=0.0;
double d_ex_dX=0.0;
  double inv_x=0.0;
double d_inv_x_dX=0.0;
  double Ag=0.0;
double d_Ag_dX=0.0;
  double Bg=0.0;
double d_Bg_dX=0.0;
  double u0_div_H=0.0;
double d_u0_div_H_dX=0.0;
  double x=0.0;
double d_x_dX=0.0;
  double u0=0.0;
double d_u0_dX=0.0;
  double Igc0=0.0;
double d_Igc0_dX=0.0;
  double Dgate=0.0;
double d_Dgate_dX=0.0;
  double Dsi=0.0;
double d_Dsi_dX=0.0;
  double arg1=0.0;
double d_arg1_dX=0.0;
  double psi_t=0.0;
double d_psi_t_dX=0.0;
  double arg2mina=0.0;
double d_arg2mina_dX=0.0;
  double Dch=0.0;
double d_Dch_dX=0.0;
  double Vm=0.0;
double d_Vm_dX=0.0;
  double Fs=0.0;
double d_Fs_dX=0.0;
  double tme2=0.0;
double d_tme2_dX=0.0;
  double tme1=0.0;
  double Fs3=0.0;
  double Fs2=0.0;
double d_Fs2_dX=0.0;
  double Fs1=0.0;
double d_Fs1_dX=0.0;
  double TP=0.0;
double d_TP_dX=0.0;
  double zg=0.0;
double d_zg_dX=0.0;
  double Igb=0.0;
double d_Igb_dX=0.0;
  double Igc=0.0;
double d_Igc_dX=0.0;
  double SP_OV_xg=0.0;
double d_SP_OV_xg_dX=0.0;
  double Vsbstar_dc=0.0;
double d_Vsbstar_dc_dX=0.0;
  double Vsbstar_dc_tmp=0.0;
double d_Vsbstar_dc_tmp_dX=0.0;
  double Vmb=0.0;
double d_Vmb_dX=0.0;
  double us=0.0;
double d_us_dX=0.0;
  double usnew=0.0;
double d_usnew_dX=0.0;
  double Vmbnew=0.0;
double d_Vmbnew_dX=0.0;
  double Vgbstar=0.0;
double d_Vgbstar_dX=0.0;
  double Vgb1=0.0;
double d_Vgb1_dX=0.0;
  double Vdsp=0.0;
double d_Vdsp_dX=0.0;
  double delVg=0.0;
double d_delVg_dX=0.0;
  double nu=0.0;
double d_nu_dX=0.0;
  double mutau=0.0;
double d_mutau_dX=0.0;
  double Vdsat_lim=0.0;
double d_Vdsat_lim_dX=0.0;
  double Vdsat=0.0;
double d_Vdsat_dX=0.0;
  double qeff1_dc=0.0;
double d_qeff1_dc_dX=0.0;
  double Voxm_dc=0.0;
double d_Voxm_dc_dX=0.0;
  double GdL_dc=0.0;
double d_GdL_dc_dX=0.0;
  double eta_p_dc=0.0;
double d_eta_p_dc_dX=0.0;
  double Gvsat_dc=0.0;
double d_Gvsat_dc_dX=0.0;
  double Gmob_dL_dc=0.0;
double d_Gmob_dL_dc_dX=0.0;
  double x_ds_dc=0.0;
double d_x_ds_dc_dX=0.0;
  double x_m_dc=0.0;
double d_x_m_dc_dX=0.0;
  double Gf_dc=0.0;
double d_Gf_dc_dX=0.0;
  double Vdsat_dc=0.0;
double d_Vdsat_dc_dX=0.0;
  double Udse_dc=0.0;
double d_Udse_dc_dX=0.0;
  double Vdsx=0.0;
  double Vdb=0.0;
  double xgd_ov=0.0;
double d_xgd_ov_dX=0.0;
  double xgs_ov=0.0;
double d_xgs_ov_dX=0.0;
  double VgdPrime=0.0;
  double VdbPrime=0.0;
  double VsbPrime=0.0;
  double VgsPrime=0.0;
  double Vjun_d=0.0;
  double Vjun_s=0.0;
  double Vsb=0.0;
  double Vds=0.0;
  double Vgs=0.0;
  double Vovd=0.0;
double d_Vovd_dX=0.0;
  double Vovs=0.0;
double d_Vovs_dX=0.0;
  double xd_ov=0.0;
double d_xd_ov_dX=0.0;
  double xs_ov=0.0;
double d_xs_ov_dX=0.0;
  double QCLM=0.0;
double d_QCLM_dX=0.0;
  double Qfgd=0.0;
double d_Qfgd_dX=0.0;
  double Qfgs=0.0;
double d_Qfgs_dX=0.0;
  double Qgb_ov=0.0;
double d_Qgb_ov_dX=0.0;
  double Qgd_ov=0.0;
double d_Qgd_ov_dX=0.0;
  double Qgs_ov=0.0;
double d_Qgs_ov_dX=0.0;
  double Qb=0.0;
double d_Qb_dX=0.0;
  double Qd=0.0;
double d_Qd_dX=0.0;
  double Qg=0.0;
double d_Qg_dX=0.0;
  double QB=0.0;
double d_QB_dX=0.0;
  double QD=0.0;
double d_QD_dX=0.0;
  double QI=0.0;
double d_QI_dX=0.0;
  double QG=0.0;
double d_QG_dX=0.0;
  double Fj2=0.0;
double d_Fj2_dX=0.0;
  double Fj=0.0;
double d_Fj_dX=0.0;
  double Vgb=0.0;
  double Vsbstar_ac=0.0;
double d_Vsbstar_ac_dX=0.0;
  double xg_ac=0.0;
double d_xg_ac_dX=0.0;
  double qeff1_ac=0.0;
double d_qeff1_ac_dX=0.0;
  double Voxm_ac=0.0;
double d_Voxm_ac_dX=0.0;
  double alpha_ac=0.0;
double d_alpha_ac_dX=0.0;
  double dps_ac=0.0;
double d_dps_ac_dX=0.0;
  double qim_ac=0.0;
double d_qim_ac_dX=0.0;
  double GdL_ac=0.0;
double d_GdL_ac_dX=0.0;
  double H_ac=0.0;
double d_H_ac_dX=0.0;
  double rwellnoise=0.0;
double d_rwellnoise_dX=0.0;
  double rjundnoise=0.0;
double d_rjundnoise_dX=0.0;
  double rjunsnoise=0.0;
double d_rjunsnoise_dX=0.0;
  double rbulknoise=0.0;
double d_rbulknoise_dX=0.0;
  double rdrainnoise=0.0;
double d_rdrainnoise_dX=0.0;
  double rsourcenoise=0.0;
double d_rsourcenoise_dX=0.0;
  double rgatenoise=0.0;
double d_rgatenoise_dX=0.0;
  double h1=0.0;
double d_h1_dX=0.0;
  double h2=0.0;
double d_h2_dX=0.0;
  double h2d=0.0;
double d_h2d_dX=0.0;
  double h3=0.0;
double d_h3_dX=0.0;
  double h4=0.0;
double d_h4_dX=0.0;
  double h5=0.0;
double d_h5_dX=0.0;
  double ijunrev=0.0;
double d_ijunrev_dX=0.0;
  double ijunfor2=0.0;
double d_ijunfor2_dX=0.0;
  double ijunfor1=0.0;
double d_ijunfor1_dX=0.0;
  double tm1=0.0;
double d_tm1_dX=0.0;
  double tm0=0.0;
double d_tm0_dX=0.0;
  double fbreakdown=0.0;
double d_fbreakdown_dX=0.0;
  double ibbt=0.0;
double d_ibbt_dX=0.0;
  double Fmaxr=0.0;
double d_Fmaxr_dX=0.0;
  double itat=0.0;
double d_itat_dX=0.0;
  double gammamax=0.0;
double d_gammamax_dX=0.0;
  double erfctimesexpmtat=0.0;
double d_erfctimesexpmtat_dX=0.0;
  double erfcpos=0.0;
double d_erfcpos_dX=0.0;
  double terfc=0.0;
double d_terfc_dX=0.0;
  double ysq=0.0;
double d_ysq_dX=0.0;
  double xerfc=0.0;
double d_xerfc_dX=0.0;
  double mtat=0.0;
double d_mtat_dX=0.0;
  double ltat=0.0;
double d_ltat_dX=0.0;
  double ktat=0.0;
double d_ktat_dX=0.0;
  double wtat=0.0;
double d_wtat_dX=0.0;
  double wgamma=0.0;
double d_wgamma_dX=0.0;
  double umaxpoweronepointfive=0.0;
double d_umaxpoweronepointfive_dX=0.0;
  double sqrtumax=0.0;
double d_sqrtumax_dX=0.0;
  double umax=0.0;
double d_umax_dX=0.0;
  double umaxbeforelimiting=0.0;
double d_umaxbeforelimiting_dX=0.0;
  double twoatatoverthreebtat=0.0;
double d_twoatatoverthreebtat_dX=0.0;
  double btat=0.0;
double d_btat_dX=0.0;
  double isrh=0.0;
double d_isrh_dX=0.0;
  double asrh=0.0;
double d_asrh_dX=0.0;
  double wdep=0.0;
double d_wdep_dX=0.0;
  double wsrh=0.0;
double d_wsrh_dX=0.0;
  double dwsrh=0.0;
double d_dwsrh_dX=0.0;
  double wsrhstep=0.0;
double d_wsrhstep_dX=0.0;
  double vbi_minus_vjsrh=0.0;
double d_vbi_minus_vjsrh_dX=0.0;
  double id=0.0;
double d_id_dX=0.0;
  double tmp=0.0;
double d_tmp_dX=0.0;
  double vav=0.0;
  double vjsrh=0.0;
double d_vjsrh_dX=0.0;
  double vjlim=0.0;
double d_vjlim_dX=0.0;
  double z=0.0;
double d_z_dX=0.0;
  double idmult=0.0;
double d_idmult_dX=0.0;
  double zinv=0.0;
double d_zinv_dX=0.0;
  double vj=0.0;
double d_vj_dX=0.0;
  double two_psistar=0.0;
double d_two_psistar_dX=0.0;
  double vbbt=0.0;
double d_vbbt_dX=0.0;
  double Qs=0.0;
double d_Qs_dX=0.0;
  double g_idealedge=0.0;
double d_g_idealedge_dX=0.0;
  double lcinv2edge=0.0;
double d_lcinv2edge_dX=0.0;
  double lcedge=0.0;
double d_lcedge_dX=0.0;
  double redge=0.0;
double d_redge_dX=0.0;
  double t2edge=0.0;
double d_t2edge_dX=0.0;
  double sqt2edge=0.0;
double d_sqt2edge_dX=0.0;
  double t1edge=0.0;
double d_t1edge_dX=0.0;
  double H0edge=0.0;
double d_H0edge_dX=0.0;
  double Delta_N1edge=0.0;
double d_Delta_N1edge_dX=0.0;
  double Nm1edge=0.0;
double d_Nm1edge_dX=0.0;
  double N1edge=0.0;
double d_N1edge_dX=0.0;
  double anoisedge=0.0;
double d_anoisedge_dX=0.0;
  double shot_igd=0.0;
double d_shot_igd_dX=0.0;
  double shot_igs=0.0;
double d_shot_igs_dX=0.0;
  double gfac=0.0;
double d_gfac_dX=0.0;
  double Gvsat_exc=0.0;
double d_Gvsat_exc_dX=0.0;
  double zsat_exc=0.0;
double d_zsat_exc_dX=0.0;
  double thesat1_exc=0.0;
double d_thesat1_exc_dX=0.0;
  double temp_exc=0.0;
double d_temp_exc_dX=0.0;
  double wsat_exc=0.0;
double d_wsat_exc_dX=0.0;
  double temp2_exc=0.0;
double d_temp2_exc_dX=0.0;
  double g_ideal=0.0;
double d_g_ideal_dX=0.0;
  double lcinv2=0.0;
double d_lcinv2_dX=0.0;
  double lc=0.0;
double d_lc_dX=0.0;
  double r=0.0;
double d_r_dX=0.0;
  double t2=0.0;
double d_t2_dX=0.0;
  double sqt2=0.0;
double d_sqt2_dX=0.0;
  double t1=0.0;
double d_t1_dX=0.0;
  double Delta_N1=0.0;
double d_Delta_N1_dX=0.0;
  double Nm1=0.0;
double d_Nm1_dX=0.0;
  double N1=0.0;
double d_N1_dX=0.0;
  double sqig=0.0;
double d_sqig_dX=0.0;
  double migid=0.0;
double d_migid_dX=0.0;
  double mid=0.0;
double d_mid_dX=0.0;
  double Sidexc=0.0;
double d_Sidexc_dX=0.0;
  double ids_i=0.0;
double d_ids_i_dX=0.0;
  double sig1k=0.0;
double d_sig1k_dX=0.0;
  double ib=0.0;
double d_ib_dX=0.0;
  double ig=0.0;
double d_ig_dX=0.0;
  double is=0.0;
double d_is_dX=0.0;
  double id_op=0.0;
double d_id_op_dX=0.0;


  // -- code converted from analog/code block
//Begin block evaluateblock
{
//Block-local variables for block evaluateblock
double sigVds=0.0;
double dphit1=0.0;
double d_dphit1_dX=0.0;
double phit1=0.0;
double d_phit1_dX=0.0;
double inv_phit1=0.0;
double d_inv_phit1_dX=0.0;
double xg_dc=0.0;
double d_xg_dc_dX=0.0;
double alpha_dc=0.0;
double d_alpha_dc_dX=0.0;
double dps_dc=0.0;
double d_dps_dc_dX=0.0;
double qim_dc=0.0;
double d_qim_dc_dX=0.0;
double qim1_dc=0.0;
double d_qim1_dc_dX=0.0;
double H_dc=0.0;
double d_H_dc_dX=0.0;
double FdL_dc=0.0;
double d_FdL_dc_dX=0.0;
double Gvsatinv_dc=0.0;
double d_Gvsatinv_dc_dX=0.0;
double Ids=0.0;
double d_Ids_dX=0.0;
double Iimpact=0.0;
double d_Iimpact_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double mavl=0.0;
double d_mavl_dX=0.0;
double Igdov=0.0;
double d_Igdov_dX=0.0;
double Igsov=0.0;
double d_Igsov_dX=0.0;
double Igcd=0.0;
double d_Igcd_dX=0.0;
double Igcs=0.0;
double d_Igcs_dX=0.0;
double eta_p_ac=0.0;
double d_eta_p_ac_dX=0.0;
double Gvsat_ac=0.0;
double d_Gvsat_ac_dX=0.0;
double Gmob_dL_ac=0.0;
double d_Gmob_dL_ac_dX=0.0;
double H0=0.0;
double d_H0_dX=0.0;
double COX_qm=0.0;
double d_COX_qm_dX=0.0;
double ijun_s=0.0;
double d_ijun_s_dX=0.0;
double ijunbot_s=0.0;
double d_ijunbot_s_dX=0.0;
double ijunsti_s=0.0;
double d_ijunsti_s_dX=0.0;
double ijungat_s=0.0;
double d_ijungat_s_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double ijun_d=0.0;
double d_ijun_d_dX=0.0;
double ijunbot_d=0.0;
double d_ijunbot_d_dX=0.0;
double ijunsti_d=0.0;
double d_ijunsti_d_dX=0.0;
double ijungat_d=0.0;
double d_ijungat_d_dX=0.0;
double qjun_s=0.0;
double d_qjun_s_dX=0.0;
double qjunbot_s=0.0;
double d_qjunbot_s_dX=0.0;
double qjunsti_s=0.0;
double d_qjunsti_s_dX=0.0;
double qjungat_s=0.0;
double d_qjungat_s_dX=0.0;
double qjun_d=0.0;
double d_qjun_d_dX=0.0;
double qjunbot_d=0.0;
double d_qjunbot_d_dX=0.0;
double qjunsti_d=0.0;
double d_qjunsti_d_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double qjungat_d=0.0;
double d_qjungat_d_dX=0.0;
double jnoise_s=0.0;
double d_jnoise_s_dX=0.0;
double jnoise_d=0.0;
double d_jnoise_d_dX=0.0;
double Gmob_dc=0.0;
double d_Gmob_dc_dX=0.0;
double xitsb_dc=0.0;
double d_xitsb_dc_dX=0.0;
double Vdse_dc=0.0;
double d_Vdse_dc_dX=0.0;
double Vsbstaredge=0.0;
double d_Vsbstaredge_dX=0.0;
double Vsbxedge=0.0;
double d_Vsbxedge_dX=0.0;
double dphit1edge=0.0;
double d_dphit1edge_dX=0.0;
double phit1edge=0.0;
double d_phit1edge_dX=0.0;
double inv_phit1edge=0.0;
double d_inv_phit1edge_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double Vdspedge=0.0;
double d_Vdspedge_dX=0.0;
double delVgedge=0.0;
double d_delVgedge_dX=0.0;
double xgedge=0.0;
double d_xgedge_dX=0.0;
double xbedge=0.0;
double d_xbedge_dX=0.0;
double dxthedge=0.0;
double d_dxthedge_dX=0.0;
double xnedge_s=0.0;
double d_xnedge_s_dX=0.0;
double qseffedge=0.0;
double d_qseffedge_dX=0.0;
double xnedge_d=0.0;
double d_xnedge_d_dX=0.0;
double qdseffedge=0.0;
double d_qdseffedge_dX=0.0;
double qdeffedge=0.0;
double d_qdeffedge_dX=0.0;
double qmeffedge=0.0;
double d_qmeffedge_dX=0.0;
double dsqredge=0.0;
double d_dsqredge_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double alphabmedge=0.0;
double d_alphabmedge_dX=0.0;
double Idsedge=0.0;
double d_Idsedge_dX=0.0;
double Sfledge=0.0;
double d_Sfledge_dX=0.0;
double midedge=0.0;
double d_midedge_dX=0.0;
double sqidedge=0.0;
double d_sqidedge_dX=0.0;
//End of Block-local variables
//Block-local variables for block evaluateblock
double temp=0.0;
double d_temp_dX=0.0;
double temp1=0.0;
double d_temp1_dX=0.0;
double temp2=0.0;
double d_temp2_dX=0.0;
//End of Block-local variables
//Begin block evaluateStatic
{
d_temp_dX = 0.0;
temp = 0.0;
d_temp1_dX = 0.0;
temp1 = 0.0;
d_temp2_dX = 0.0;
temp2 = 0.0;
d_QCLM_dX = 0.0;
QCLM = 0.0;
d_xs_ov_dX = 0.0;
xs_ov = 0.0;
d_xd_ov_dX = 0.0;
xd_ov = 0.0;
d_Vovs_dX = 0.0;
Vovs = 0.0;
d_Vovd_dX = 0.0;
Vovd = 0.0;
d_Iimpact_dX = 0.0;
Iimpact = 0.0;
d_mavl_dX = 0.0;
mavl = 0.0;
if ((modelStruct.modelVar_CHNL_TYPE==(+1)))
{
Vgs = (probeVars[admsProbeID_V_GP_SI]);
Vds = (probeVars[admsProbeID_V_DI_SI]);
Vsb = (probeVars[admsProbeID_V_SI_BP]);
Vjun_s = (-(probeVars[admsProbeID_V_SI_BS]));
Vjun_d = (-(probeVars[admsProbeID_V_DI_BD]));
}
else
{
Vgs = (-(probeVars[admsProbeID_V_GP_SI]));
Vds = (-(probeVars[admsProbeID_V_DI_SI]));
Vsb = (-(probeVars[admsProbeID_V_SI_BP]));
Vjun_s = (probeVars[admsProbeID_V_SI_BS]);
Vjun_d = (probeVars[admsProbeID_V_DI_BD]);
}
VgsPrime = Vgs;
VsbPrime = Vsb;
VdbPrime = (Vds+Vsb);
VgdPrime = (Vgs-Vds);
d_xgs_ov_dX = (-VgsPrime)*modelStruct.d_modelVar_inv_phita_dX;
xgs_ov = ((-VgsPrime)*modelStruct.modelVar_inv_phita);
d_xgd_ov_dX = (-VgdPrime)*modelStruct.d_modelVar_inv_phita_dX;
xgd_ov = ((-VgdPrime)*modelStruct.modelVar_inv_phita);
sigVds = 1.0;
if ((Vds<0.0))
{
sigVds = (-1.0);
Vgs = (Vgs-Vds);
Vsb = (Vsb+Vds);
Vds = (-Vds);
}
Vdb = (Vds+Vsb);
{
double value_sqrt_0 = sqrt(((Vds*Vds)+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
Vdsx = ((Vds*Vds)/(value_sqrt_0+0.1));
}
//Begin block SPcalc_dc
{
//Block-local variables for block SPcalc_dc
double phib=0.0;
double d_phib_dX=0.0;
double G_0=0.0;
double d_G_0_dX=0.0;
double Vsbstar=0.0;
double d_Vsbstar_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double Vsbx=0.0;
double d_Vsbx_dX=0.0;
double xg=0.0;
double d_xg_dX=0.0;
double Dnsub=0.0;
double d_Dnsub_dX=0.0;
double Gf=0.0;
double d_Gf_dX=0.0;
double Gf2=0.0;
double d_Gf2_dX=0.0;
double inv_Gf2=0.0;
double d_inv_Gf2_dX=0.0;
double xi=0.0;
double d_xi_dX=0.0;
double inv_xi=0.0;
double d_inv_xi_dX=0.0;
double Ux=0.0;
double d_Ux_dX=0.0;
double xn_s=0.0;
double d_xn_s_dX=0.0;
double delta_ns=0.0;
double d_delta_ns_dX=0.0;
double margin=0.0;
double d_margin_dX=0.0;
double x_s=0.0;
double d_x_s_dX=0.0;
double delta_1s=0.0;
double d_delta_1s_dX=0.0;
double xi0s=0.0;
double d_xi0s_dX=0.0;
double xi1s=0.0;
double d_xi1s_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double xi2s=0.0;
double d_xi2s_dX=0.0;
double Es=0.0;
double d_Es_dX=0.0;
double Ds=0.0;
double d_Ds_dX=0.0;
double Ps=0.0;
double d_Ps_dX=0.0;
double Rxcor=0.0;
double d_Rxcor_dX=0.0;
double xgs=0.0;
double d_xgs_dX=0.0;
double qis=0.0;
double d_qis_dX=0.0;
double qbs=0.0;
double d_qbs_dX=0.0;
double rhob=0.0;
double d_rhob_dX=0.0;
double GR=0.0;
double d_GR_dX=0.0;
double Eeffm=0.0;
double d_Eeffm_dX=0.0;
double Mutmp=0.0;
double d_Mutmp_dX=0.0;
double Gmob=0.0;
double d_Gmob_dX=0.0;
double xitsb=0.0;
double d_xitsb_dX=0.0;
double wsat=0.0;
double d_wsat_dX=0.0;
double thesat1=0.0;
double d_thesat1_dX=0.0;
double phi_inf=0.0;
double d_phi_inf_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double ysat=0.0;
double d_ysat_dX=0.0;
double za=0.0;
double d_za_dX=0.0;
double Phi_0=0.0;
double d_Phi_0_dX=0.0;
double asat=0.0;
double d_asat_dX=0.0;
double Phi_2=0.0;
double d_Phi_2_dX=0.0;
double Phi_0_2=0.0;
double d_Phi_0_2_dX=0.0;
double Phi0_Phi2=0.0;
double d_Phi0_Phi2_dX=0.0;
double Phi_sat=0.0;
double d_Phi_sat_dX=0.0;
double Vdse=0.0;
double d_Vdse_dX=0.0;
double Udse=0.0;
double d_Udse_dX=0.0;
double xn_d=0.0;
double d_xn_d_dX=0.0;
double k_ds=0.0;
double d_k_ds_dX=0.0;
double delta_nd=0.0;
double d_delta_nd_dX=0.0;
double x_d=0.0;
double d_x_d_dX=0.0;
double x_ds=0.0;
double d_x_ds_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double pC=0.0;
double d_pC_dX=0.0;
double qC=0.0;
double d_qC_dX=0.0;
double dps=0.0;
double d_dps_dX=0.0;
double xi0d=0.0;
double d_xi0d_dX=0.0;
double Ed=0.0;
double d_Ed_dX=0.0;
double Dd=0.0;
double d_Dd_dX=0.0;
double x_m=0.0;
double d_x_m_dX=0.0;
double Em=0.0;
double d_Em_dX=0.0;
double D_bar=0.0;
double d_D_bar_dX=0.0;
double Dm=0.0;
double d_Dm_dX=0.0;
double Pm=0.0;
double d_Pm_dX=0.0;
double xgm=0.0;
double d_xgm_dX=0.0;
double eta_p=0.0;
double d_eta_p_dX=0.0;
double sqm=0.0;
double d_sqm_dX=0.0;
double alpha=0.0;
double d_alpha_dX=0.0;
double d0=0.0;
double d_d0_dX=0.0;
double x_pm=0.0;
double d_x_pm_dX=0.0;
double p_pd=0.0;
double d_p_pd_dX=0.0;
double q_pd=0.0;
double d_q_pd_dX=0.0;
double xi_pd=0.0;
double d_xi_pd_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double u_pd=0.0;
double d_u_pd_dX=0.0;
double km=0.0;
double d_km_dX=0.0;
double km0=0.0;
double d_km0_dX=0.0;
double qim=0.0;
double d_qim_dX=0.0;
double qim1=0.0;
double d_qim1_dX=0.0;
double qbm=0.0;
double d_qbm_dX=0.0;
double qeff=0.0;
double d_qeff_dX=0.0;
double qeff1=0.0;
double d_qeff1_dX=0.0;
double s1=0.0;
double d_s1_dX=0.0;
double dL=0.0;
double d_dL_dX=0.0;
double GdL=0.0;
double d_GdL_dX=0.0;
double Gmob_dL=0.0;
double d_Gmob_dL_dX=0.0;
double zsat=0.0;
double d_zsat_dX=0.0;
double Gvsat=0.0;
double d_Gvsat_dX=0.0;
double Gvsatinv=0.0;
double d_Gvsatinv_dX=0.0;
double Voxm=0.0;
double d_Voxm_dX=0.0;
double alpha1=0.0;
double d_alpha1_dX=0.0;
double H=0.0;
double d_H_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_temp=0.0;
double d_SP_S_temp_dX=0.0;
double SP_S_temp1=0.0;
double d_SP_S_temp1_dX=0.0;
double SP_S_temp2=0.0;
double d_SP_S_temp2_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_yg=0.0;
double d_SP_S_yg_dX=0.0;
double SP_S_ysub=0.0;
double d_SP_S_ysub_dX=0.0;
double SP_S_eta=0.0;
double d_SP_S_eta_dX=0.0;
double SP_S_a=0.0;
double d_SP_S_a_dX=0.0;
double SP_S_c=0.0;
double d_SP_S_c_dX=0.0;
double SP_S_tau=0.0;
double d_SP_S_tau_dX=0.0;
double SP_S_y0=0.0;
double d_SP_S_y0_dX=0.0;
double SP_S_delta0=0.0;
double d_SP_S_delta0_dX=0.0;
double SP_S_delta1=0.0;
double d_SP_S_delta1_dX=0.0;
double SP_S_xi0=0.0;
double d_SP_S_xi0_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_xi1=0.0;
double d_SP_S_xi1_dX=0.0;
double SP_S_xi2=0.0;
double d_SP_S_xi2_dX=0.0;
double SP_S_pC=0.0;
double d_SP_S_pC_dX=0.0;
double SP_S_qC=0.0;
double d_SP_S_qC_dX=0.0;
double SP_xg1=0.0;
double d_SP_xg1_dX=0.0;
double SP_S_A_fac=0.0;
double d_SP_S_A_fac_dX=0.0;
double SP_S_xbar=0.0;
double d_SP_S_xbar_dX=0.0;
double SP_S_w=0.0;
double d_SP_S_w_dX=0.0;
double SP_S_x1=0.0;
double d_SP_S_x1_dX=0.0;
double SP_S_bx=0.0;
double d_SP_S_bx_dX=0.0;
double SP_S_b=0.0;
double d_SP_S_b_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double SP_S_x0=0.0;
double d_SP_S_x0_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_dc
double FdL=0.0;
double d_FdL_dX=0.0;
double qim1_1=0.0;
double d_qim1_1_dX=0.0;
double r1=0.0;
double d_r1_dX=0.0;
double r2=0.0;
double d_r2_dX=0.0;
double s2=0.0;
double d_s2_dX=0.0;
double dL1=0.0;
double d_dL1_dX=0.0;
//End of Block-local variables
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceStruct.instanceVar_bphi_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (0.5*(-deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_dc_dX))+instanceStruct.d_instanceVar_phix_dc_dX);
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceStruct.instanceVar_phix_dc);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+instanceStruct.instanceVar_aphi_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vsbstar_dc_dX = ((-0.5*(d_temp_dX-deriv_sqrt_0_d0*((((temp)*d_temp_dX+d_temp_dX*(temp))+instanceStruct.d_instanceVar_aphi_dc_dX))))+instanceStruct.d_instanceVar_phix1_dc_dX);
Vsbstar_dc = ((Vsb-(0.5*(temp-value_sqrt_0)))+instanceStruct.instanceVar_phix1_dc);
}
d_Vsbstar_dc_tmp_dX = d_Vsbstar_dc_dX;
Vsbstar_dc_tmp = Vsbstar_dc;
if (((modelStruct.modelVar_SWNUD_i!=0)&&(instanceStruct.instanceVar_GFACNUD_i!=1.0)))
{
d_Vmb_dX = d_Vsbstar_dc_dX;
Vmb = (Vsbstar_dc+(0.5*(Vds-Vdsx)));
{
double value_sqrt_0 = sqrt((Vmb+instanceStruct.instanceVar_phib_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_us_dX = (deriv_sqrt_0_d0*((d_Vmb_dX+instanceStruct.d_instanceVar_phib_dc_dX))-instanceStruct.d_instanceVar_sqrt_phib_dc_dX);
us = (value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc);
}
d_temp_dX = ((instanceStruct.instanceVar_us21*2.0*(d_us_dX-instanceStruct.d_instanceVar_us1_dX)-(2.0*(us-instanceStruct.instanceVar_us1))*instanceStruct.d_instanceVar_us21_dX)/instanceStruct.instanceVar_us21/instanceStruct.instanceVar_us21);
temp = (((2.0*(us-instanceStruct.instanceVar_us1))/instanceStruct.instanceVar_us21)-1.0);
{
double value_sqrt_0 = sqrt(((temp*temp)+0.4804530139182));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_usnew_dX = (d_us_dX-(((0.25*(1.0-instanceStruct.instanceVar_GFACNUD_i))*instanceStruct.instanceVar_us21)*(d_temp_dX+deriv_sqrt_0_d0*((temp*d_temp_dX+d_temp_dX*temp)))+((0.25*(1.0-instanceStruct.instanceVar_GFACNUD_i))*instanceStruct.d_instanceVar_us21_dX+0.25*(-instanceStruct.d_instanceVar_GFACNUD_i_dX)*instanceStruct.instanceVar_us21)*(temp+value_sqrt_0)));
usnew = (us-(((0.25*(1.0-instanceStruct.instanceVar_GFACNUD_i))*instanceStruct.instanceVar_us21)*(temp+value_sqrt_0)));
}
d_Vmbnew_dX = ((usnew*d_usnew_dX+d_usnew_dX*usnew)+((2.0*instanceStruct.instanceVar_sqrt_phib_dc)*d_usnew_dX+2.0*instanceStruct.d_instanceVar_sqrt_phib_dc_dX*usnew));
Vmbnew = ((usnew*usnew)+((2.0*instanceStruct.instanceVar_sqrt_phib_dc)*usnew));
d_Vsbstar_dc_dX = d_Vmbnew_dX;
Vsbstar_dc = (Vmbnew-(0.5*(Vds-Vdsx)));
}
d_phib_dX = instanceStruct.d_instanceVar_phib_dc_dX;
phib = instanceStruct.instanceVar_phib_dc;
d_G_0_dX = instanceStruct.d_instanceVar_G_0_dc_dX;
G_0 = instanceStruct.instanceVar_G_0_dc;
d_Vsbstar_dX = d_Vsbstar_dc_dX;
Vsbstar = Vsbstar_dc;
d_FdL_dX = 0.0;
FdL = 1.0;
d_alpha_dX = 0.0;
alpha = 0.0;
d_GdL_dX = 0.0;
GdL = 1.0;
d_dL_dX = 0.0;
dL = 0.0;
d_qbm_dX = 0.0;
qbm = 0.0;
d_dps_dX = 0.0;
dps = 0.0;
d_qim_dX = 0.0;
qim = 0.0;
d_qim1_dX = 0.0;
qim1 = 0.0;
d_H_dX = 0.0;
H = 1.0;
d_s1_dX = 0.0;
s1 = 0.0;
d_eta_p_dX = 0.0;
eta_p = 1.0;
d_Gvsat_dX = 0.0;
Gvsat = 1.0;
d_Gvsatinv_dX = 0.0;
Gvsatinv = 1.0;
d_SP_S_x1_dX = 0.0;
SP_S_x1 = 0.0;
d_x_s_dX = 0.0;
x_s = 0.0;
d_sqm_dX = 0.0;
sqm = 0.0;
d_xitsb_dX = 0.0;
xitsb = 0.0;
d_rhob_dX = 0.0;
rhob = 0.0;
d_Gmob_dX = 0.0;
Gmob = 1.0;
d_Gmob_dL_dX = 0.0;
Gmob_dL = 1.0;
d_Udse_dX = 0.0;
Udse = 0.0;
d_thesat1_dX = 0.0;
thesat1 = 0.0;
d_xgm_dX = 0.0;
xgm = 0.0;
d_Vgbstar_dX = d_Vsbstar_dX;
Vgbstar = (Vgs+Vsbstar);
d_Vgb1_dX = (d_Vgbstar_dX-instanceStruct.d_instanceVar_VFB_T_dX);
Vgb1 = (Vgbstar-instanceStruct.instanceVar_VFB_T);
d_Vsbx_dX = d_Vsbstar_dX;
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
if ((instanceStruct.instanceVar_CFD_i<1.0e-10))
{
d_Vdsp_dX = 0.0;
Vdsp = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_CFD_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdsp_dX = ((instanceStruct.instanceVar_CFD_i*2.0*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_CFD_i_dX*Vdsx)-(2.0*(value_sqrt_0-1.0))*instanceStruct.d_instanceVar_CFD_i_dX)/instanceStruct.instanceVar_CFD_i/instanceStruct.instanceVar_CFD_i);
Vdsp = ((2.0*(value_sqrt_0-1.0))/instanceStruct.instanceVar_CFD_i);
}
}
d_delVg_dX = ((instanceStruct.instanceVar_CF_i*Vdsp)*(instanceStruct.instanceVar_CFB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_CFB_i_dX*Vsbx)+(instanceStruct.instanceVar_CF_i*d_Vdsp_dX+instanceStruct.d_instanceVar_CF_i_dX*Vdsp)*(1.0+(instanceStruct.instanceVar_CFB_i*Vsbx)));
delVg = ((instanceStruct.instanceVar_CF_i*Vdsp)*(1.0+(instanceStruct.instanceVar_CFB_i*Vsbx)));
d_dphit1_dX = ((instanceStruct.instanceVar_PSCE_i*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(instanceStruct.instanceVar_PSCEB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_PSCEB_i_dX*Vsbx)+(instanceStruct.instanceVar_PSCE_i*instanceStruct.d_instanceVar_PSCED_i_dX*Vdsx+instanceStruct.d_instanceVar_PSCE_i_dX*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEB_i*Vsbx)));
dphit1 = ((instanceStruct.instanceVar_PSCE_i*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEB_i*Vsbx)));
d_phit1_dX = (instanceStruct.instanceVar_phit0*d_dphit1_dX+instanceStruct.d_instanceVar_phit0_dX*(1.0+dphit1));
phit1 = (instanceStruct.instanceVar_phit0*(1.0+dphit1));
d_inv_phit1_dX = (-d_phit1_dX/phit1/phit1);
inv_phit1 = (1.0/phit1);
d_Vgb1_dX = (d_Vgb1_dX+d_delVg_dX);
Vgb1 = (Vgb1+delVg);
d_xg_dX = (Vgb1*d_inv_phit1_dX+d_Vgb1_dX*inv_phit1);
xg = (Vgb1*inv_phit1);
if ((instanceStruct.instanceVar_DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.instanceVar_NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dnsub_dX = ((instanceStruct.instanceVar_DNSUB_i*0.5)*((-instanceStruct.d_instanceVar_VNSUB_i_dX)+deriv_sqrt_0_d0*((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))+(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.d_instanceVar_NSLP_i_dX)))+instanceStruct.d_instanceVar_DNSUB_i_dX*0.5*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
Dnsub = ((instanceStruct.instanceVar_DNSUB_i*0.5)*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gf_dX = (G_0*deriv_sqrt_0_d0*(d_Dnsub_dX)+d_G_0_dX*value_sqrt_0);
Gf = (G_0*value_sqrt_0);
}
}
else
{
d_Gf_dX = d_G_0_dX;
Gf = G_0;
}
d_Gf2_dX = (Gf*d_Gf_dX+d_Gf_dX*Gf);
Gf2 = (Gf*Gf);
d_inv_Gf2_dX = (-d_Gf2_dX/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);
d_xi_dX = d_Gf_dX*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));
d_inv_xi_dX = (-d_xi_dX/xi/xi);
inv_xi = (1.0/xi);
d_Ux_dX = (Vsbstar*d_inv_phit1_dX+d_Vsbstar_dX*inv_phit1);
Ux = (Vsbstar*inv_phit1);
d_xn_s_dX = ((phib*d_inv_phit1_dX+d_phib_dX*inv_phit1)+d_Ux_dX);
xn_s = ((phib*inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_ns_dX = deriv_exp_0_d0*((-d_xn_s_dX));
delta_ns = value_exp_0;
}
}
else
{
d_delta_ns_dX = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dX*3.3333333333333333e-01+d_xn_s_dX*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dX*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_margin_dX = 1.0e-5*d_xi_dX;
margin = (1.0e-5*xi);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_s_dX = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_ns))*d_Gf_dX+(xg*(-d_delta_ns_dX)+d_xg_dX*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{
d_SP_S_yg_dX = (-d_xg_dX);
SP_S_yg = (-xg);
d_SP_S_ysub_dX = 1.25*(SP_S_yg*d_inv_xi_dX+d_SP_S_yg_dX*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_eta_dX = 0.5*(d_SP_S_ysub_dX-deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dX+d_SP_S_ysub_dX*(SP_S_ysub-6.0))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_eta_dX);
SP_S_temp = (SP_S_yg-SP_S_eta);
d_SP_S_a_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)+(Gf2*d_SP_S_eta_dX+d_Gf2_dX*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX-d_Gf2_dX);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));
d_SP_S_tau_dX = ((-d_SP_S_eta_dX)+deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dX+d_SP_S_a_dX*inv_Gf2)));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-d_SP_S_a_dX)+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_SP_S_y0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dX)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_y0_dX);
SP_S_delta0 = value_exp_0;
}
}
else
{
d_SP_S_delta0_dX = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dX*3.3333333333333333e-01+d_SP_S_y0_dX*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dX*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_temp_dX = (-(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_xi0_dX = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_temp_dX+d_SP_S_y0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_y0_dX);
SP_S_temp = (SP_S_yg-SP_S_y0);
d_SP_S_temp1_dX = (delta_ns*d_SP_S_delta1_dX+d_delta_ns_dX*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*((d_SP_S_delta0_dX-d_SP_S_temp1_dX)+(delta_ns*(-d_SP_S_xi1_dX)+d_delta_ns_dX*(1.0-SP_S_xi1)))+d_Gf2_dX*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dX-d_SP_S_y0_dX)+d_SP_S_temp1_dX)+(delta_ns*(d_SP_S_y0_dX-d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta0_dX+d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = ((-d_SP_S_y0_dX)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{
d_SP_xg1_dX = (-d_Gf_dX*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));
d_SP_S_A_fac_dX = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dX+((xi*1.25)*d_SP_xg1_dX+d_xi_dX*1.25*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);
d_SP_S_xbar_dX = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dX+d_SP_S_A_fac_dX*xg)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp_dX = deriv_exp_0_d0*((-d_SP_S_xbar_dX));
SP_S_temp = value_exp_0;
}
}
else
{
d_SP_S_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dX))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}
d_SP_S_w_dX = (-d_SP_S_temp_dX);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_x1_dX = ((d_xg_dX+d_Gf2_dX*0.5)-(Gf*deriv_sqrt_0_d0*(((d_xg_dX+d_Gf2_dX*0.25)-d_SP_S_w_dX))+d_Gf_dX*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}
d_SP_S_bx_dX = d_xn_s_dX;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_ns*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_s_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_ns*d_SP_S_delta0_dX+d_delta_ns_dX*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_s_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_ns_dX-delta_ns*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_ns*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}
d_x_d_dX = d_x_s_dX;
x_d = x_s;
d_x_m_dX = d_x_s_dX;
x_m = x_s;
d_x_ds_dX = 0.0;
x_ds = 0.0;
d_Vdsat_lim_dX = 3.912023005*d_phit1_dX;
Vdsat_lim = (3.912023005*phit1);
if ((xg<=0.0))
{
d_qis_dX = 0.0;
qis = 0.0;
d_xgm_dX = (d_xg_dX-d_x_s_dX);
xgm = (xg-x_s);
d_Voxm_dX = (xgm*d_phit1_dX+d_xgm_dX*phit1);
Voxm = (xgm*phit1);
d_qeff1_dX = d_Voxm_dX;
qeff1 = Voxm;
d_Vdsat_dX = d_Vdsat_lim_dX;
Vdsat = Vdsat_lim;
d_Vdse_dX = 0.0;
Vdse = Vds;
}
else
{
d_delta_1s_dX = 0.0;
delta_1s = 0.0;
d_temp_dX = (-(x_s*d_x_s_dX+d_x_s_dX*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));
d_xi0s_dX = ((x_s*x_s)*d_temp_dX+(x_s*d_x_s_dX+d_x_s_dX*x_s)*temp);
xi0s = ((x_s*x_s)*temp);
d_xi1s_dX = 4.0*((x_s*temp)*d_temp_dX+(x_s*d_temp_dX+d_x_s_dX*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));
d_xi2s_dX = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dX+(((8.0*temp)-(12.0*xi0s))*d_temp_dX+(8.0*d_temp_dX-12.0*d_xi0s_dX)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*(d_x_s_dX);
delta_1s = value_exp_0;
}
d_Es_dX = (-d_delta_1s_dX/delta_1s/delta_1s);
Es = (1.0/delta_1s);
d_delta_1s_dX = (delta_ns*d_delta_1s_dX+d_delta_ns_dX*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*((d_x_s_dX-d_xn_s_dX));
delta_1s = value_exp_0;
}
d_Es_dX = ((delta_1s*d_delta_ns_dX-delta_ns*d_delta_1s_dX)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{
d_delta_1s_dX = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dX-d_x_s_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_x_s_dX)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_x_s_dX)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dX = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dX*3.3333333333333333e-01+d_x_s_dX*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dX*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Ds_dX = (d_delta_1s_dX-(delta_ns*(d_x_s_dX+d_xi0s_dX)+d_delta_ns_dX*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{
d_Ps_dX = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s))))+(x_s*d_x_s_dX+d_x_s_dX*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
d_Ds_dX = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dX+(((delta_ns*x_s)*x_s)*d_x_s_dX+((delta_ns*x_s)*d_x_s_dX+(delta_ns*d_x_s_dX+d_delta_ns_dX*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_s*d_temp_dX+d_x_s_dX*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));
d_alpha_dX = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dX)+1.6666666666666667e-01*(x_s*d_x_s_dX+d_x_s_dX*x_s))+d_Gf_dX*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dX)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{
d_Ps_dX = (d_x_s_dX+d_Es_dX);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Ps_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = 0.5*((sqm*(Gf*(-d_Es_dX)+d_Gf_dX*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dX)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}
d_Em_dX = d_Es_dX;
Em = Es;
d_Ed_dX = d_Em_dX;
Ed = Em;
d_Dm_dX = d_Ds_dX;
Dm = Ds;
d_Dd_dX = d_Dm_dX;
Dd = Dm;
d_Rxcor_dX = (((1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx))*((0.2*instanceStruct.instanceVar_XCOR_T)*d_Vsbx_dX+0.2*instanceStruct.d_instanceVar_XCOR_T_dX*Vsbx)-(1.0+((0.2*instanceStruct.instanceVar_XCOR_T)*Vsbx))*(instanceStruct.instanceVar_XCOR_T*d_Vsbx_dX+instanceStruct.d_instanceVar_XCOR_T_dX*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx)));
Rxcor = ((1.0+((0.2*instanceStruct.instanceVar_XCOR_T)*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgs_dX = (Gf*deriv_sqrt_0_d0*((d_Ps_dX+d_Ds_dX))+d_Gf_dX*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}
d_qis_dX = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));
d_qbs_dX = ((sqm*Gf)*d_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*phit1);
qbs = ((sqm*Gf)*phit1);
if ((instanceStruct.instanceVar_RSB_i<0.0))
{
d_rhob_dX = (-(-(instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
rhob = (1.0/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
}
else
{
d_rhob_dX = (instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx);
rhob = (1.0+(instanceStruct.instanceVar_RSB_i*Vsbx));
}
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qis));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis)/(1.0+(instanceStruct.instanceVar_RSG_i*qis))/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qis_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qis)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qis));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qis));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*(d_qbs_dX+(instanceStruct.instanceVar_eta_mu*d_qis_dX+instanceStruct.d_instanceVar_eta_mu_dX*qis))+instanceStruct.d_instanceVar_E_eff0_dX*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
Eeffm = (instanceStruct.instanceVar_E_eff0*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_T),instanceStruct.instanceVar_THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_T/(Eeffm*instanceStruct.instanceVar_MUE_T)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_T))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_T_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_T)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_T_dX)))+(instanceStruct.instanceVar_CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dX-Ps*(d_Ps_dX+d_Ds_dX))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+instanceStruct.d_instanceVar_CS_T_dX*(Ps/((Ps+Ds)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_T*(Ps/((Ps+Ds)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((instanceStruct.instanceVar_THESATB_i<0.0))
{
d_xitsb_dX = (-(-(instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
}
else
{
d_xitsb_dX = (instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx);
xitsb = (1.0+(instanceStruct.instanceVar_THESATB_i*Vsbx));
}
d_temp2_dX = (qis*d_xitsb_dX+d_qis_dX*xitsb);
temp2 = (qis*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((instanceStruct.instanceVar_THESATG_i<0.0))
{
d_temp_dX = (-(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1.0/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1.0+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_T*((Gmob*d_temp_dX-temp*d_Gmob_dX)/Gmob/Gmob)+instanceStruct.d_instanceVar_THESAT_T_dX*(temp/Gmob));
thesat1 = (instanceStruct.instanceVar_THESAT_T*(temp/Gmob));
d_phi_inf_dX = (((alpha*d_qis_dX-qis*d_alpha_dX)/alpha/alpha)+d_phit1_dX);
phi_inf = ((qis/alpha)+phit1);
d_ysat_dX = (thesat1*d_phi_inf_dX+d_thesat1_dX*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ysat_dX = ((value_sqrt_0*d_ysat_dX-ysat*deriv_sqrt_0_d0*(d_ysat_dX))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_za_dX = (-2.0*deriv_sqrt_0_d0*(4.0*d_ysat_dX)/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}
d_temp1_dX = (za*d_ysat_dX+d_za_dX*ysat);
temp1 = (za*ysat);
d_Phi_0_dX = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dX+d_temp1_dX*za))+d_temp1_dX*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dX+(temp1*d_temp1_dX+d_temp1_dX*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dX+d_phi_inf_dX*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_asat_dX = (d_xgs_dX+0.5*d_Gf2_dX);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_2_dX = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dX+deriv_sqrt_0_d0*(((asat*d_asat_dX+d_asat_dX*asat)-(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*0.98))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
}
d_Phi_0_2_dX = (d_Phi_0_dX+d_Phi_2_dX);
Phi_0_2 = (Phi_0+Phi_2);
d_Phi0_Phi2_dX = 2.0*(Phi_0*d_Phi_2_dX+d_Phi_0_dX*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_sat_dX = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dX-Phi0_Phi2*(d_Phi_0_2_dX+deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dX+d_Phi_0_2_dX*Phi_0_2)-1.98*d_Phi0_Phi2_dX))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
d_Vdsat_dX = (d_Phi_sat_dX-(phit1*deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dX+(Phi_sat*(d_Phi_sat_dX-((2.0*asat)*d_phit1_dX+2.0*d_asat_dX*phit1))+d_Phi_sat_dX*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dX+(phit1*d_phit1_dX+d_phit1_dX*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))+d_phit1_dX*value_log_0));
Vdsat = (Phi_sat-(phit1*value_log_0));
}
}
else
{
d_Vdsat_dX = d_Vdsat_lim_dX;
Vdsat = Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),instanceStruct.instanceVar_AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_AX_i/(Vds/Vdsat)));
double  deriv_pow_0_d1 = ((Vds/Vdsat) == 0.0)?0.0:(log((Vds/Vdsat))*value_pow_0);
d_temp_dX = ((deriv_pow_0_d0*((-Vds*d_Vdsat_dX/Vdsat/Vdsat)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_AX_i_dX)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-instanceStruct.instanceVar_inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_inv_AX)/(1.0+temp)));
double  deriv_pow_0_d1 = ((1.0+temp) == 0.0)?0.0:(log((1.0+temp))*value_pow_0);
d_Vdse_dX = Vds*((deriv_pow_0_d0*(d_temp_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_inv_AX_dX))));
Vdse = (Vds*value_pow_0);
}
d_Udse_dX = (Vdse*d_inv_phit1_dX+d_Vdse_dX*inv_phit1);
Udse = (Vdse*inv_phit1);
d_xn_d_dX = (d_xn_s_dX+d_Udse_dX);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;
d_k_ds_dX = deriv_exp_0_d0*((-d_Udse_dX));
k_ds = value_exp_0;
}
}
else
{
d_k_ds_dX = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dX*3.3333333333333333e-01+d_Udse_dX*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dX*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_delta_nd_dX = (delta_ns*d_k_ds_dX+d_delta_ns_dX*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_d_dX = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_nd))*d_Gf_dX+(xg*(-d_delta_nd_dX)+d_xg_dX*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{
d_SP_S_bx_dX = d_xn_d_dX;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_nd*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_d_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_nd*d_SP_S_delta0_dX+d_delta_nd_dX*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_d_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_nd_dX-delta_nd*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_nd*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_d_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
d_x_ds_dX = (d_x_d_dX-d_x_s_dX);
x_ds = (x_d-x_s);
if ((x_ds<1.0e-10))
{
d_pC_dX = (2.0*(d_xg_dX-d_x_s_dX)+(Gf2*(((-d_Es_dX)+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi1s_dX+d_delta_nd_dX*(1.0+xi1s)))+d_Gf2_dX*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_qC_dX = ((Gf2*(1.0-k_ds))*d_Ds_dX+(Gf2*(-d_k_ds_dX)+d_Gf2_dX*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);
d_temp_dX = (-(Gf2*((d_Es_dX+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi2s_dX+d_delta_nd_dX*xi2s))+d_Gf2_dX*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dX = ((pC*d_pC_dX+d_pC_dX*pC)-2.0*(temp*d_qC_dX+d_temp_dX*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_ds_dX = 2.0*(((pC+value_sqrt_0)*d_qC_dX-qC*(d_pC_dX+deriv_sqrt_0_d0*(d_temp_dX)))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}
d_x_d_dX = (d_x_s_dX+d_x_ds_dX);
x_d = (x_s+x_ds);
}
d_dps_dX = (x_ds*d_phit1_dX+d_x_ds_dX*phit1);
dps = (x_ds*phit1);
d_xi0d_dX = (((2.0+(x_d*x_d))*(x_d*d_x_d_dX+d_x_d_dX*x_d)-(x_d*x_d)*(x_d*d_x_d_dX+d_x_d_dX*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;
d_Ed_dX = deriv_exp_0_d0*((-d_x_d_dX));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{
d_Dd_dX = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dX+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dX+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dX+((1.6666666666666667e-01*delta_nd)*d_x_d_dX+1.6666666666666667e-01*d_delta_nd_dX*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{
d_Dd_dX = (delta_nd*(((-d_Ed_dX/Ed/Ed)-d_x_d_dX)-d_xi0d_dX)+d_delta_nd_dX*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((d_x_d_dX-d_xn_d_dX));
temp = value_exp_0;
}
d_Ed_dX = ((temp*d_delta_nd_dX-delta_nd*d_temp_dX)/temp/temp);
Ed = (delta_nd/temp);
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{
d_Ed_dX = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dX*3.3333333333333333e-01+d_x_d_dX*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dX*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dX = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dX-d_x_d_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_x_d_dX)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_x_d_dX)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}
d_x_m_dX = 0.5*(d_x_s_dX+d_x_d_dX);
x_m = (0.5*(x_s+x_d));
d_Em_dX = 0.0;
Em = 0.0;
d_temp_dX = (Ed*d_Es_dX+d_Ed_dX*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Em_dX = deriv_sqrt_0_d0*(d_temp_dX);
Em = value_sqrt_0;
}
}
d_D_bar_dX = 0.5*(d_Ds_dX+d_Dd_dX);
D_bar = (0.5*(Ds+Dd));
d_Dm_dX = (d_D_bar_dX+0.125*((x_ds*x_ds)*(d_Em_dX-2.0*d_inv_Gf2_dX)+(x_ds*d_x_ds_dX+d_x_ds_dX*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{
d_Pm_dX = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m))))+(x_m*d_x_m_dX+d_x_m_dX*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_m*d_temp_dX+d_x_m_dX*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));
d_alpha_dX = (d_eta_p_dX+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dX)+1.6666666666666667e-01*(x_m*d_x_m_dX+d_x_m_dX*x_m))+d_Gf_dX*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dX)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
d_d0_dX = ((-d_Em_dX)+2.0*(xgm*d_inv_Gf2_dX+d_xgm_dX*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
d_temp_dX = (((eta_p+1.0)*d_eta_p_dX-eta_p*d_eta_p_dX)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));
d_x_pm_dX = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*d_Dm_dX+((temp*temp)*d_Gf2_dX+(temp*d_temp_dX+d_temp_dX*temp)*Gf2)*Dm)+instanceStruct.d_instanceVar_kp_dX*(((temp*temp)*Gf2)*Dm));
x_pm = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*Dm));
d_p_pd_dX = (2.0*(d_xgm_dX-d_x_pm_dX)+(Gf2*((-d_Em_dX)+d_Dm_dX)+d_Gf2_dX*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
d_q_pd_dX = (x_pm*(d_x_pm_dX-2.0*d_xgm_dX)+d_x_pm_dX*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));
d_xi_pd_dX = (-0.5*(Gf2*(d_Em_dX+d_Dm_dX)+d_Gf2_dX*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
d_u_pd_dX = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dX+d_q_pd_dX*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dX+d_p_pd_dX*p_pd)-(xi_pd*d_q_pd_dX+d_xi_pd_dX*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
d_x_m_dX = (d_x_m_dX+d_u_pd_dX);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;
d_km_dX = deriv_exp_0_d0*(d_u_pd_dX);
km = value_exp_0;
}
d_Em_dX = ((km*d_Em_dX-Em*d_km_dX)/km/km);
Em = (Em/km);
d_Dm_dX = (Dm*d_km_dX+d_Dm_dX*km);
Dm = (Dm*km);
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
d_km0_dX = ((-d_Em_dX)+2.0*((xgm*eta_p)*d_inv_Gf2_dX+(xgm*d_eta_p_dX+d_xgm_dX*eta_p)*inv_Gf2));
km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
d_x_ds_dX = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dX+d_D_bar_dX)+(x_ds*d_km_dX+d_x_ds_dX*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dX+(km*d_D_bar_dX+d_km_dX*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));
d_dps_dX = (x_ds*d_phit1_dX+d_x_ds_dX*phit1);
dps = (x_ds*phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Pm_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = (d_eta_p_dX+0.5*((sqm*(Gf*(-d_Em_dX)+d_Gf_dX*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dX)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}
d_qim_dX = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dX+d_Gf2_dX*Dm)-(Gf2*Dm)*(d_xgm_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dX*((Gf2*Dm)/(xgm+(Gf*sqm))));
qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim1_dX = (d_qim_dX+(phit1*d_alpha_dX+d_phit1_dX*alpha));
qim1 = (qim+(phit1*alpha));
d_qbm_dX = ((sqm*Gf)*d_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*phit1);
qbm = ((sqm*Gf)*phit1);
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qim));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim)/(1.0+(instanceStruct.instanceVar_RSG_i*qim))/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qim_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qim)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qim));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qim));
d_qeff_dX = (d_qbm_dX+(instanceStruct.instanceVar_eta_mu*d_qim_dX+instanceStruct.d_instanceVar_eta_mu_dX*qim));
qeff = (qbm+(instanceStruct.instanceVar_eta_mu*qim));
d_qeff1_dX = (d_qbm_dX+instanceStruct.instanceVar_eta_mu1*d_qim_dX);
qeff1 = (qbm+(instanceStruct.instanceVar_eta_mu1*qim));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*d_qeff_dX+instanceStruct.d_instanceVar_E_eff0_dX*qeff);
Eeffm = (instanceStruct.instanceVar_E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_T),instanceStruct.instanceVar_THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_T/(Eeffm*instanceStruct.instanceVar_MUE_T)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_T))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_T_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_T)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_T_dX)))+(instanceStruct.instanceVar_CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dX-Pm*(d_Pm_dX+d_Dm_dX))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+instanceStruct.d_instanceVar_CS_T_dX*(Pm/((Pm+Dm)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_T*(Pm/((Pm+Dm)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
{
double value_log_0 = log(((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
d_s1_dX = deriv_log_0_d0*((((1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))*((Vds-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(-d_dps_dX)*instanceStruct.instanceVar_inv_VP)-(1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))*((Vdse-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(d_Vdse_dX-d_dps_dX)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
s1 = value_log_0;
}
d_dL_dX = (instanceStruct.instanceVar_ALP_i*d_s1_dX+instanceStruct.d_instanceVar_ALP_i_dX*s1);
dL = (instanceStruct.instanceVar_ALP_i*s1);
d_GdL_dX = (-(d_dL_dX+(dL*d_dL_dX+d_dL_dX*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));
d_temp2_dX = (qim*d_xitsb_dX+d_qim_dX*xitsb);
temp2 = (qim*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
d_Gmob_dL_dX = (Gmob*d_GdL_dX+d_Gmob_dX*GdL);
Gmob_dL = (Gmob*GdL);
if ((instanceStruct.instanceVar_THESATG_i<0.0))
{
d_temp_dX = (-(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1.0/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1.0+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_T*((Gmob_dL*d_temp_dX-temp*d_Gmob_dL_dX)/Gmob_dL/Gmob_dL)+instanceStruct.d_instanceVar_THESAT_T_dX*(temp/Gmob_dL));
thesat1 = (instanceStruct.instanceVar_THESAT_T*(temp/Gmob_dL));
d_zsat_dX = (((thesat1*thesat1)*dps)*d_dps_dX+((thesat1*thesat1)*d_dps_dX+(thesat1*d_thesat1_dX+d_thesat1_dX*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
d_zsat_dX = (((1.0+(thesat1*dps))*d_zsat_dX-zsat*(thesat1*d_dps_dX+d_thesat1_dX*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gvsat_dX = 0.5*(Gmob_dL*deriv_sqrt_0_d0*(2.0*d_zsat_dX)+d_Gmob_dL_dX*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}
d_Gvsatinv_dX = (-d_Gvsat_dX/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);
d_Voxm_dX = (xgm*d_phit1_dX+d_xgm_dX*phit1);
Voxm = (xgm*phit1);
d_temp_dX = (Gmob_dL*d_Gvsatinv_dX+d_Gmob_dL_dX*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);
d_alpha1_dX = (alpha*0.5*((zsat*temp)*d_temp_dX+(zsat*d_temp_dX+d_zsat_dX*temp)*temp)+d_alpha_dX*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
d_H_dX = ((alpha1*(temp*d_qim1_dX+d_temp_dX*qim1)-(temp*qim1)*d_alpha1_dX)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
}
if ((xg>0.0))
{
d_qim1_1_dX = (-d_qim1_dX/qim1/qim1);
qim1_1 = (1.0/qim1);
d_r1_dX = (qim*d_qim1_1_dX+d_qim_dX*qim1_1);
r1 = (qim*qim1_1);
d_r2_dX = (phit1*(alpha*d_qim1_1_dX+d_alpha_dX*qim1_1)+d_phit1_dX*(alpha*qim1_1));
r2 = (phit1*(alpha*qim1_1));
{
double value_log_0 = log((1.0+(Vdsx*instanceStruct.instanceVar_inv_VP)));
double  deriv_log_0_d0 = (1.0/(1.0+(Vdsx*instanceStruct.instanceVar_inv_VP)));
d_s2_dX = deriv_log_0_d0*(Vdsx*instanceStruct.d_instanceVar_inv_VP_dX);
s2 = value_log_0;
}
d_dL1_dX = ((d_dL_dX+(instanceStruct.instanceVar_ALP1_i*((qim1_1*r1)*d_s1_dX+(qim1_1*d_r1_dX+d_qim1_1_dX*r1)*s1)+instanceStruct.d_instanceVar_ALP1_i_dX*((qim1_1*r1)*s1)))+(instanceStruct.instanceVar_ALP2_i*(((qbm*r2)*r2)*d_s2_dX+((qbm*r2)*d_r2_dX+(qbm*d_r2_dX+d_qbm_dX*r2)*r2)*s2)+instanceStruct.d_instanceVar_ALP2_i_dX*(((qbm*r2)*r2)*s2)));
dL1 = ((dL+(instanceStruct.instanceVar_ALP1_i*((qim1_1*r1)*s1)))+(instanceStruct.instanceVar_ALP2_i*(((qbm*r2)*r2)*s2)));
d_FdL_dX = (((1.0+dL1)+(dL1*dL1))*d_GdL_dX+(d_dL1_dX+(dL1*d_dL1_dX+d_dL1_dX*dL1))*GdL);
FdL = (((1.0+dL1)+(dL1*dL1))*GdL);
}
d_xg_dc_dX = d_xg_dX;
xg_dc = xg;
d_qeff1_dc_dX = d_qeff1_dX;
qeff1_dc = qeff1;
d_Voxm_dc_dX = d_Voxm_dX;
Voxm_dc = Voxm;
d_alpha_dc_dX = d_alpha_dX;
alpha_dc = alpha;
d_dps_dc_dX = d_dps_dX;
dps_dc = dps;
d_qim_dc_dX = d_qim_dX;
qim_dc = qim;
d_qim1_dc_dX = d_qim1_dX;
qim1_dc = qim1;
d_GdL_dc_dX = d_GdL_dX;
GdL_dc = GdL;
d_FdL_dc_dX = d_FdL_dX;
FdL_dc = FdL;
d_H_dc_dX = d_H_dX;
H_dc = H;
d_eta_p_dc_dX = d_eta_p_dX;
eta_p_dc = eta_p;
d_Gvsat_dc_dX = d_Gvsat_dX;
Gvsat_dc = Gvsat;
d_Gvsatinv_dc_dX = d_Gvsatinv_dX;
Gvsatinv_dc = Gvsatinv;
d_Gmob_dL_dc_dX = d_Gmob_dL_dX;
Gmob_dL_dc = Gmob_dL;
d_x_ds_dc_dX = d_x_ds_dX;
x_ds_dc = x_ds;
d_x_m_dc_dX = d_x_m_dX;
x_m_dc = x_m;
d_Gf_dc_dX = d_Gf_dX;
Gf_dc = Gf;
d_Vdsat_dc_dX = d_Vdsat_dX;
Vdsat_dc = Vdsat;
d_Udse_dc_dX = d_Udse_dX;
Udse_dc = Udse;
d_Gmob_dc_dX = d_Gmob_dX;
Gmob_dc = Gmob;
d_xitsb_dc_dX = d_xitsb_dX;
xitsb_dc = xitsb;
d_Vdse_dc_dX = d_Vdse_dX;
Vdse_dc = Vdse;
}
// End block SPcalc_dc
if ((xg_dc<=0))
{
d_Ids_dX = 0.0;
Ids = 0.0;
}
else
{
d_Ids_dX = (instanceStruct.instanceVar_BET_i*(((FdL_dc*qim1_dc)*dps_dc)*d_Gvsatinv_dc_dX+((FdL_dc*qim1_dc)*d_dps_dc_dX+(FdL_dc*d_qim1_dc_dX+d_FdL_dc_dX*qim1_dc)*dps_dc)*Gvsatinv_dc)+instanceStruct.d_instanceVar_BET_i_dX*(((FdL_dc*qim1_dc)*dps_dc)*Gvsatinv_dc));
Ids = (instanceStruct.instanceVar_BET_i*(((FdL_dc*qim1_dc)*dps_dc)*Gvsatinv_dc));
}
if ((((((modelStruct.modelVar_SWIGATE_i!=0)&&((instanceStruct.instanceVar_IGOV_i>0.0)||(instanceStruct.instanceVar_IGOVD_i>0.0)))||((modelStruct.modelVar_SWGIDL_i!=0)&&((instanceStruct.instanceVar_AGIDL_i>0.0)||(instanceStruct.instanceVar_AGIDLD_i>0.0))))||(instanceStruct.instanceVar_CGOV_i>0.0))||(instanceStruct.instanceVar_CGOVD_i>0.0)))
{
{
double value_sqrt_0 = sqrt(((xgs_ov*xgs_ov)+instanceStruct.instanceVar_SP_OV_eps2_s));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_xg_dX = 0.5*(d_xgs_ov_dX+deriv_sqrt_0_d0*(((xgs_ov*d_xgs_ov_dX+d_xgs_ov_dX*xgs_ov)+instanceStruct.d_instanceVar_SP_OV_eps2_s_dX)));
SP_OV_xg = (0.5*(xgs_ov+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((SP_OV_xg+(instanceStruct.instanceVar_GOV2_s*0.25))+instanceStruct.instanceVar_SP_OV_a_s));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xs_ov_dX = ((((-d_SP_OV_xg_dX)-instanceStruct.d_instanceVar_GOV2_s_dX*0.5)+(instanceStruct.instanceVar_GOV_s*deriv_sqrt_0_d0*(((d_SP_OV_xg_dX+instanceStruct.d_instanceVar_GOV2_s_dX*0.25)+instanceStruct.d_instanceVar_SP_OV_a_s_dX))+instanceStruct.d_instanceVar_GOV_s_dX*value_sqrt_0))+instanceStruct.d_instanceVar_SP_OV_delta1_s_dX);
xs_ov = ((((-SP_OV_xg)-(instanceStruct.instanceVar_GOV2_s*0.5))+(instanceStruct.instanceVar_GOV_s*value_sqrt_0))+instanceStruct.instanceVar_SP_OV_delta1_s);
}
{
double value_sqrt_0 = sqrt(((xgd_ov*xgd_ov)+instanceStruct.instanceVar_SP_OV_eps2_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_OV_xg_dX = 0.5*(d_xgd_ov_dX+deriv_sqrt_0_d0*(((xgd_ov*d_xgd_ov_dX+d_xgd_ov_dX*xgd_ov)+instanceStruct.d_instanceVar_SP_OV_eps2_d_dX)));
SP_OV_xg = (0.5*(xgd_ov+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((SP_OV_xg+(instanceStruct.instanceVar_GOV2_d*0.25))+instanceStruct.instanceVar_SP_OV_a_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xd_ov_dX = ((((-d_SP_OV_xg_dX)-instanceStruct.d_instanceVar_GOV2_d_dX*0.5)+(instanceStruct.instanceVar_GOV_d*deriv_sqrt_0_d0*(((d_SP_OV_xg_dX+instanceStruct.d_instanceVar_GOV2_d_dX*0.25)+instanceStruct.d_instanceVar_SP_OV_a_d_dX))+instanceStruct.d_instanceVar_GOV_d_dX*value_sqrt_0))+instanceStruct.d_instanceVar_SP_OV_delta1_d_dX);
xd_ov = ((((-SP_OV_xg)-(instanceStruct.instanceVar_GOV2_d*0.5))+(instanceStruct.instanceVar_GOV_d*value_sqrt_0))+instanceStruct.instanceVar_SP_OV_delta1_d);
}
d_Vovs_dX = ((-modelStruct.modelVar_phita)*(d_xgs_ov_dX+d_xs_ov_dX)+(-modelStruct.d_modelVar_phita_dX)*(xgs_ov+xs_ov));
Vovs = ((-modelStruct.modelVar_phita)*(xgs_ov+xs_ov));
d_Vovd_dX = ((-modelStruct.modelVar_phita)*(d_xgd_ov_dX+d_xd_ov_dX)+(-modelStruct.d_modelVar_phita_dX)*(xgd_ov+xd_ov));
Vovd = ((-modelStruct.modelVar_phita)*(xgd_ov+xd_ov));
}
d_Igsov_dX = 0.0;
Igsov = 0.0;
d_Igdov_dX = 0.0;
Igdov = 0.0;
d_Igc_dX = 0.0;
Igc = 0.0;
d_Igb_dX = 0.0;
Igb = 0.0;
d_Igcs_dX = 0.0;
Igcs = 0.0;
d_Igcd_dX = 0.0;
Igcd = 0.0;
if ((modelStruct.modelVar_SWIGATE_i!=0))
{
if ((instanceStruct.instanceVar_IGOV_i>0.0))
{
{
double value_sqrt_0 = sqrt(((Vovs*Vovs)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_temp_dX = (instanceStruct.instanceVar_BOV*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BOV_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BOV*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0.0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
d_Fs1_dX = d_xs_ov_dX;
Fs1 = (3.0+xs_ov);
d_Fs2_dX = (-instanceStruct.d_instanceVar_GCO_i_dX);
Fs2 = ((-3.0)-instanceStruct.instanceVar_GCO_i);
Fs3 = (30.0*VgsPrime);
tme1 = (4.0-0.9);
d_tme2_dX = d_Fs1_dX;
tme2 = (Fs1+Fs3);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (2.0/tme1)*(d_tme2_dX-deriv_sqrt_0_d0*(((tme2*d_tme2_dX+d_tme2_dX*tme2)-tme1*d_Fs1_dX*Fs3)));
temp = ((2.0/tme1)*(tme2-value_sqrt_0));
}
tme1 = (4.0-0.3);
d_tme2_dX = (d_Fs2_dX+d_temp_dX);
tme2 = (Fs2+temp);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Fs_dX = (2.0/tme1)*(d_tme2_dX+deriv_sqrt_0_d0*(((tme2*d_tme2_dX+d_tme2_dX*tme2)-((tme1*Fs2)*d_temp_dX+tme1*d_Fs2_dX*temp))));
Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
}
d_Igsov_dX = (instanceStruct.instanceVar_IGOV_i*(TP*d_Fs_dX+d_TP_dX*Fs)+instanceStruct.d_instanceVar_IGOV_i_dX*(TP*Fs));
Igsov = (instanceStruct.instanceVar_IGOV_i*(TP*Fs));
}
if ((instanceStruct.instanceVar_IGOVD_i>0.0))
{
{
double value_sqrt_0 = sqrt(((Vovd*Vovd)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_temp_dX = (instanceStruct.instanceVar_BOV_d*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BOV_d_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BOV_d*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0.0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
d_Fs1_dX = d_xd_ov_dX;
Fs1 = (3.0+xd_ov);
d_Fs2_dX = (-instanceStruct.d_instanceVar_GCO_i_dX);
Fs2 = ((-3.0)-instanceStruct.instanceVar_GCO_i);
Fs3 = (30.0*VgdPrime);
tme1 = (4.0-0.9);
d_tme2_dX = d_Fs1_dX;
tme2 = (Fs1+Fs3);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs1)*Fs3)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (2.0/tme1)*(d_tme2_dX-deriv_sqrt_0_d0*(((tme2*d_tme2_dX+d_tme2_dX*tme2)-tme1*d_Fs1_dX*Fs3)));
temp = ((2.0/tme1)*(tme2-value_sqrt_0));
}
tme1 = (4.0-0.3);
d_tme2_dX = (d_Fs2_dX+d_temp_dX);
tme2 = (Fs2+temp);
{
double value_sqrt_0 = sqrt(((tme2*tme2)-((tme1*Fs2)*temp)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Fs_dX = (2.0/tme1)*(d_tme2_dX+deriv_sqrt_0_d0*(((tme2*d_tme2_dX+d_tme2_dX*tme2)-((tme1*Fs2)*d_temp_dX+tme1*d_Fs2_dX*temp))));
Fs = ((2.0/tme1)*(tme2+value_sqrt_0));
}
d_Igdov_dX = (instanceStruct.instanceVar_IGOVD_i*(TP*d_Fs_dX+d_TP_dX*Fs)+instanceStruct.d_instanceVar_IGOVD_i_dX*(TP*Fs));
Igdov = (instanceStruct.instanceVar_IGOVD_i*(TP*Fs));
}
if ((instanceStruct.instanceVar_IGINV_i>0.0))
{
if ((xg_dc<=0.0))
{
{
double value_pow_0 = pow((Vds/Vdsat_lim),instanceStruct.instanceVar_AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat_lim) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_AX_i/(Vds/Vdsat_lim)));
double  deriv_pow_0_d1 = ((Vds/Vdsat_lim) == 0.0)?0.0:(log((Vds/Vdsat_lim))*value_pow_0);
d_temp_dX = ((deriv_pow_0_d0*((-Vds*d_Vdsat_lim_dX/Vdsat_lim/Vdsat_lim)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_AX_i_dX)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-instanceStruct.instanceVar_inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_inv_AX)/(1.0+temp)));
double  deriv_pow_0_d1 = ((1.0+temp) == 0.0)?0.0:(log((1.0+temp))*value_pow_0);
d_Udse_dc_dX = ((Vds*value_pow_0)*d_inv_phit1_dX+Vds*((deriv_pow_0_d0*(d_temp_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_inv_AX_dX))))*inv_phit1);
Udse_dc = ((Vds*value_pow_0)*inv_phit1);
}
}
if (((x_ds_dc-Udse_dc)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_ds_dc-Udse_dc));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((d_x_ds_dc_dX-d_Udse_dc_dX));
temp = value_exp_0;
}
}
else
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(-(d_x_ds_dc_dX-d_Udse_dc_dX))*3.3333333333333333e-01+(-(d_x_ds_dc_dX-d_Udse_dc_dX))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))+(-(d_x_ds_dc_dX-d_Udse_dc_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(0.5*(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*(1.0+(((-2.3025850929940458e+02)-(x_ds_dc-Udse_dc))*3.3333333333333333e-01))))))));
}
{
double value_log_0 = log((0.5*(1.0+temp)));
double  deriv_log_0_d0 = (1.0/(0.5*(1.0+temp)));
d_Vm_dX = (d_Vsbstar_dc_dX+(phit1*(0.5*d_x_ds_dc_dX-deriv_log_0_d0*(0.5*d_temp_dX))+d_phit1_dX*((0.5*x_ds_dc)-value_log_0)));
Vm = (Vsbstar_dc+(phit1*((0.5*x_ds_dc)-value_log_0)));
}
d_Dch_dX = (instanceStruct.instanceVar_GCO_i*d_phit1_dX+instanceStruct.d_instanceVar_GCO_i_dX*phit1);
Dch = (instanceStruct.instanceVar_GCO_i*phit1);
d_arg2mina_dX = (d_Voxm_dc_dX+d_Dch_dX);
arg2mina = (Voxm_dc+Dch);
{
double value_sqrt_0 = sqrt((((-arg2mina)*(-arg2mina))+0.01));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_psi_t_dX = 0.5*(d_arg2mina_dX-deriv_sqrt_0_d0*(((-arg2mina)*(-d_arg2mina_dX)+(-d_arg2mina_dX)*(-arg2mina))));
psi_t = (0.5*(arg2mina-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt(((Voxm_dc*Voxm_dc)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = (value_sqrt_0*instanceStruct.d_instanceVar_inv_CHIB_dX+deriv_sqrt_0_d0*((Voxm_dc*d_Voxm_dc_dX+d_Voxm_dc_dX*Voxm_dc))*instanceStruct.instanceVar_inv_CHIB);
zg = (value_sqrt_0*instanceStruct.instanceVar_inv_CHIB);
}
if ((instanceStruct.instanceVar_GC3_i<0.0))
{
{
double value_sqrt_0 = sqrt((((zg-instanceStruct.instanceVar_GCQ)*(zg-instanceStruct.instanceVar_GCQ))+1.0e-06));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zg_dX = 0.5*((d_zg_dX+instanceStruct.d_instanceVar_GCQ_dX)-deriv_sqrt_0_d0*(((zg-instanceStruct.instanceVar_GCQ)*(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)+(d_zg_dX-instanceStruct.d_instanceVar_GCQ_dX)*(zg-instanceStruct.instanceVar_GCQ))));
zg = (0.5*((zg+instanceStruct.instanceVar_GCQ)-value_sqrt_0));
}
}
d_arg1_dX = (d_x_m_dc_dX+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*d_inv_phit1_dX+((d_psi_t_dX-instanceStruct.d_instanceVar_alpha_b_dX)-d_Vm_dX)*inv_phit1));
arg1 = (x_m_dc+(((psi_t-instanceStruct.instanceVar_alpha_b)-Vm)*inv_phit1));
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_Dsi_dX = deriv_exp_0_d0*(d_arg1_dX);
Dsi = value_exp_0;
}
}
else
{
if ((arg1<0.0))
{
d_Dsi_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
Dsi = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_Dsi_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Dsi = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_arg1_dX = ((-((Vgs+Vsbstar_dc)-Vm))*d_inv_phit1_dX+(-(d_Vsbstar_dc_dX-d_Vm_dX))*inv_phit1);
arg1 = ((-((Vgs+Vsbstar_dc)-Vm))*inv_phit1);
if ((fabs(arg1)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(arg1);
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*(d_arg1_dX);
temp = value_exp_0;
}
}
else
{
if ((arg1<0.0))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-arg1)*0.5*(((-2.3025850929940458e+02)-arg1)*(-d_arg1_dX)*3.3333333333333333e-01+(-d_arg1_dX)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))+(-d_arg1_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-arg1)*(1.0+(0.5*(((-2.3025850929940458e+02)-arg1)*(1.0+(((-2.3025850929940458e+02)-arg1)*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*((arg1-2.3025850929940458e+02)*0.5*((arg1-2.3025850929940458e+02)*d_arg1_dX*3.3333333333333333e-01+d_arg1_dX*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_arg1_dX*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+((arg1-2.3025850929940458e+02)*(1.0+(0.5*((arg1-2.3025850929940458e+02)*(1.0+((arg1-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Dgate_dX = (Dsi*d_temp_dX+d_Dsi_dX*temp);
Dgate = (Dsi*temp);
d_temp_dX = (instanceStruct.instanceVar_BCH*(zg*(instanceStruct.d_instanceVar_GC2_i_dX+(instanceStruct.instanceVar_GC3_i*d_zg_dX+instanceStruct.d_instanceVar_GC3_i_dX*zg))+d_zg_dX*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))+instanceStruct.d_instanceVar_BCH_dX*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
temp = (instanceStruct.instanceVar_BCH*((-1.5)+(zg*(instanceStruct.instanceVar_GC2_i+(instanceStruct.instanceVar_GC3_i*zg)))));
if ((temp>0))
{
d_TP_dX = (temp*0.5*(temp*d_temp_dX*3.3333333333333333e-01+d_temp_dX*(1.0+(temp*3.3333333333333333e-01)))+d_temp_dX*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01))))));
TP = (1.0+(temp*(1.0+(0.5*(temp*(1.0+(temp*3.3333333333333333e-01)))))));
}
else
{
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_TP_dX = deriv_exp_0_d0*(d_temp_dX);
TP = value_exp_0;
}
}
else
{
d_TP_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
TP = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
}
{
double value_log_0 = log(((1.0+Dsi)/(1.0+Dgate)));
double  deriv_log_0_d0 = (1.0/((1.0+Dsi)/(1.0+Dgate)));
d_Igc0_dX = (instanceStruct.instanceVar_IGINV_i*(TP*deriv_log_0_d0*((((1.0+Dgate)*d_Dsi_dX-(1.0+Dsi)*d_Dgate_dX)/(1.0+Dgate)/(1.0+Dgate)))+d_TP_dX*value_log_0)+instanceStruct.d_instanceVar_IGINV_i_dX*(TP*value_log_0));
Igc0 = (instanceStruct.instanceVar_IGINV_i*(TP*value_log_0));
}
if (((xg_dc<=0.0)||((instanceStruct.instanceVar_GC2_i==0.0)&&(instanceStruct.instanceVar_GC3_i==0.0))))
{
d_igc_dX = 0.0;
igc = 1.0;
d_igcd_h_dX = 0.0;
igcd_h = 0.5;
}
else
{
d_temp_dX = (instanceStruct.d_instanceVar_GC2_i_dX+((2.0*instanceStruct.instanceVar_GC3_i)*d_zg_dX+2.0*instanceStruct.d_instanceVar_GC3_i_dX*zg));
temp = (instanceStruct.instanceVar_GC2_i+((2.0*instanceStruct.instanceVar_GC3_i)*zg));
d_u0_dX = (((temp*instanceStruct.instanceVar_BCH)*instanceStruct.d_instanceVar_CHIB_i_dX-instanceStruct.instanceVar_CHIB_i*(temp*instanceStruct.d_instanceVar_BCH_dX+d_temp_dX*instanceStruct.instanceVar_BCH))/(temp*instanceStruct.instanceVar_BCH)/(temp*instanceStruct.instanceVar_BCH));
u0 = (instanceStruct.instanceVar_CHIB_i/(temp*instanceStruct.instanceVar_BCH));
d_x_dX = 0.5*((u0*d_dps_dc_dX-dps_dc*d_u0_dX)/u0/u0);
x = (0.5*(dps_dc/u0));
d_u0_div_H_dX = ((H_dc*d_u0_dX-u0*d_H_dc_dX)/H_dc/H_dc);
u0_div_H = (u0/H_dc);
d_Bg_dX = (u0_div_H*(-d_u0_div_H_dX)+d_u0_div_H_dX*(1.0-u0_div_H))*0.5;
Bg = ((u0_div_H*(1.0-u0_div_H))*0.5);
d_Ag_dX = (-3.0*d_Bg_dX);
Ag = (0.5-(3.0*Bg));
if ((x<1.0e-3))
{
d_xsq_dX = (x*d_x_dX+d_x_dX*x);
xsq = (x*x);
d_igc_dX = (xsq*(d_u0_div_H_dX*3.3333333333333333e-01+1.6666666666666667e-01*(xsq*0.2*d_u0_div_H_dX+d_xsq_dX*(0.05+(0.2*u0_div_H))))+d_xsq_dX*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H))))));
igc = (1.0+(xsq*((1.6666666666666667e-01+(u0_div_H*3.3333333333333333e-01))+(1.6666666666666667e-01*(xsq*(0.05+(0.2*u0_div_H)))))));
d_igcd_h_dX = (0.5*d_igc_dX-1.6666666666666667e-01*(x*(xsq*(0.4*d_Bg_dX+0.0285714285714*(xsq*d_Bg_dX+d_xsq_dX*(0.125+Bg)))+d_xsq_dX*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))+d_x_dX*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg))))))));
igcd_h = ((0.5*igc)-(1.6666666666666667e-01*(x*(1.0+(xsq*((0.4*(Bg+0.25))+(0.0285714285714*(xsq*(0.125+Bg)))))))));
}
else
{
d_inv_x_dX = (-d_x_dX/x/x);
inv_x = (1.0/x);
if ((fabs(x)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x);
double  deriv_exp_0_d0 = value_exp_0;
d_ex_dX = deriv_exp_0_d0*(d_x_dX);
ex = value_exp_0;
}
}
else
{
if ((x<0.0))
{
d_ex_dX = (-1.0e-100*(((-2.3025850929940458e+02)-x)*0.5*(((-2.3025850929940458e+02)-x)*(-d_x_dX)*3.3333333333333333e-01+(-d_x_dX)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))+(-d_x_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
ex = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-x)*(1.0+(0.5*(((-2.3025850929940458e+02)-x)*(1.0+(((-2.3025850929940458e+02)-x)*3.3333333333333333e-01))))))));
}
else
{
d_ex_dX = 1.0e100*((x-2.3025850929940458e+02)*0.5*((x-2.3025850929940458e+02)*d_x_dX*3.3333333333333333e-01+d_x_dX*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_dX*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))));
ex = (1.0e100*(1.0+((x-2.3025850929940458e+02)*(1.0+(0.5*((x-2.3025850929940458e+02)*(1.0+((x-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_inv_ex_dX = (-d_ex_dX/ex/ex);
inv_ex = (1.0/ex);
d_temp_dX = (d_ex_dX-d_inv_ex_dX);
temp = (ex-inv_ex);
d_temp2_dX = (d_ex_dX+d_inv_ex_dX);
temp2 = (ex+inv_ex);
d_igc_dX = 0.5*((((1.0-u0_div_H)*temp)*d_inv_x_dX+((1.0-u0_div_H)*d_temp_dX+(-d_u0_div_H_dX)*temp)*inv_x)+(u0_div_H*d_temp2_dX+d_u0_div_H_dX*temp2));
igc = (0.5*((((1.0-u0_div_H)*temp)*inv_x)+(u0_div_H*temp2)));
d_igcd_h_dX = 0.5*((d_igc_dX-(temp*(d_Bg_dX-((Ag*inv_x)*d_inv_x_dX+(Ag*d_inv_x_dX+d_Ag_dX*inv_x)*inv_x))+d_temp_dX*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*d_inv_x_dX+(Ag*d_temp2_dX+d_Ag_dX*temp2)*inv_x));
igcd_h = (0.5*((igc-(temp*(Bg-((Ag*inv_x)*inv_x))))-((Ag*temp2)*inv_x)));
}
}
{
double value_sqrt_0 = sqrt(((xg_dc*xg_dc)+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Sg_dX = 0.5*((value_sqrt_0*d_xg_dc_dX-xg_dc*deriv_sqrt_0_d0*((xg_dc*d_xg_dc_dX+d_xg_dc_dX*xg_dc)))/value_sqrt_0/value_sqrt_0);
Sg = (0.5*(1.0+(xg_dc/value_sqrt_0)));
}
d_Igc_dX = ((Igc0*igc)*d_Sg_dX+(Igc0*d_igc_dX+d_Igc0_dX*igc)*Sg);
Igc = ((Igc0*igc)*Sg);
d_Igcd_dX = ((Igc0*igcd_h)*d_Sg_dX+(Igc0*d_igcd_h_dX+d_Igc0_dX*igcd_h)*Sg);
Igcd = ((Igc0*igcd_h)*Sg);
d_Igcs_dX = (d_Igc_dX-d_Igcd_dX);
Igcs = (Igc-Igcd);
d_Igb_dX = ((Igc0*igc)*(-d_Sg_dX)+(Igc0*d_igc_dX+d_Igc0_dX*igc)*(1.0-Sg));
Igb = ((Igc0*igc)*(1.0-Sg));
}
}
d_Igidl_dX = 0.0;
Igidl = 0.0;
d_Igisl_dX = 0.0;
Igisl = 0.0;
if ((modelStruct.modelVar_SWGIDL_i!=0))
{
if (((instanceStruct.instanceVar_AGIDLD_i>0)&&(Vovd<0)))
{
{
double value_sqrt_0 = sqrt((((Vovd*Vovd)+((instanceStruct.instanceVar_CGIDLD_i*instanceStruct.instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovd_dX = deriv_sqrt_0_d0*(((Vovd*d_Vovd_dX+d_Vovd_dX*Vovd)+(instanceStruct.instanceVar_CGIDLD_i*instanceStruct.d_instanceVar_CGIDLD_i_dX+instanceStruct.d_instanceVar_CGIDLD_i_dX*instanceStruct.instanceVar_CGIDLD_i)*(VdbPrime*VdbPrime)));
Vtovd = value_sqrt_0;
}
d_temp_dX = ((Vtovd*(-instanceStruct.d_instanceVar_BGIDLDs_dX)-(-instanceStruct.instanceVar_BGIDLDs)*d_Vtovd_dX)/Vtovd/Vtovd);
temp = ((-instanceStruct.instanceVar_BGIDLDs)/Vtovd);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_temp2_dX = deriv_exp_0_d0*(d_temp_dX);
temp2 = value_exp_0;
}
}
else
{
d_temp2_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
d_Igidl_dX = ((-instanceStruct.instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*d_temp2_dX+((VdbPrime*Vovd)*d_Vtovd_dX+VdbPrime*d_Vovd_dX*Vtovd)*temp2)+(-instanceStruct.d_instanceVar_AGIDLDs_dX)*(((VdbPrime*Vovd)*Vtovd)*temp2));
Igidl = ((-instanceStruct.instanceVar_AGIDLDs)*(((VdbPrime*Vovd)*Vtovd)*temp2));
}
if (((instanceStruct.instanceVar_AGIDL_i>0)&&(Vovs<0)))
{
{
double value_sqrt_0 = sqrt((((Vovs*Vovs)+((instanceStruct.instanceVar_CGIDL_i*instanceStruct.instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)))+1.0e-6));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vtovs_dX = deriv_sqrt_0_d0*(((Vovs*d_Vovs_dX+d_Vovs_dX*Vovs)+(instanceStruct.instanceVar_CGIDL_i*instanceStruct.d_instanceVar_CGIDL_i_dX+instanceStruct.d_instanceVar_CGIDL_i_dX*instanceStruct.instanceVar_CGIDL_i)*(VsbPrime*VsbPrime)));
Vtovs = value_sqrt_0;
}
d_temp_dX = ((Vtovs*(-instanceStruct.d_instanceVar_BGIDLs_dX)-(-instanceStruct.instanceVar_BGIDLs)*d_Vtovs_dX)/Vtovs/Vtovs);
temp = ((-instanceStruct.instanceVar_BGIDLs)/Vtovs);
if ((temp>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(temp);
double  deriv_exp_0_d0 = value_exp_0;
d_temp2_dX = deriv_exp_0_d0*(d_temp_dX);
temp2 = value_exp_0;
}
}
else
{
d_temp2_dX = (-1.0e-100*(((-2.3025850929940458e+02)-temp)*0.5*(((-2.3025850929940458e+02)-temp)*(-d_temp_dX)*3.3333333333333333e-01+(-d_temp_dX)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))+(-d_temp_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
temp2 = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-temp)*(1.0+(0.5*(((-2.3025850929940458e+02)-temp)*(1.0+(((-2.3025850929940458e+02)-temp)*3.3333333333333333e-01))))))));
}
d_Igisl_dX = ((-instanceStruct.instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*d_temp2_dX+((VsbPrime*Vovs)*d_Vtovs_dX+VsbPrime*d_Vovs_dX*Vtovs)*temp2)+(-instanceStruct.d_instanceVar_AGIDLs_dX)*(((VsbPrime*Vovs)*Vtovs)*temp2));
Igisl = ((-instanceStruct.instanceVar_AGIDLs)*(((VsbPrime*Vovs)*Vtovs)*temp2));
}
}
d_xgedge_dX = 0.0;
xgedge = 0.0;
d_qdseffedge_dX = 0.0;
qdseffedge = 0.0;
d_qmeffedge_dX = 0.0;
qmeffedge = 0.0;
d_dsqredge_dX = 0.0;
dsqredge = 1.0e-40;
d_alphabmedge_dX = 0.0;
alphabmedge = 1.0;
d_Idsedge_dX = 0.0;
Idsedge = 0.0;
if (((modelStruct.modelVar_SWEDGE_i!=0.0)&&(instanceStruct.instanceVar_BETNEDGE_i>0)))
{
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceStruct.instanceVar_bphiedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (0.5*(-deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphiedge_dX))+instanceStruct.d_instanceVar_phixedge_dX);
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceStruct.instanceVar_phixedge);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+instanceStruct.instanceVar_aphiedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vsbstaredge_dX = ((-0.5*(d_temp_dX-deriv_sqrt_0_d0*((((temp)*d_temp_dX+d_temp_dX*(temp))+instanceStruct.d_instanceVar_aphiedge_dX))))+instanceStruct.d_instanceVar_phix1edge_dX);
Vsbstaredge = ((Vsb-(0.5*(temp-value_sqrt_0)))+instanceStruct.instanceVar_phix1edge);
}
d_Vsbxedge_dX = d_Vsbstaredge_dX;
Vsbxedge = (Vsbstaredge+(0.5*(Vds-Vdsx)));
d_dphit1edge_dX = ((instanceStruct.instanceVar_PSCEEDGE_i*(1+(instanceStruct.instanceVar_PSCEDEDGE_i*Vdsx)))*(instanceStruct.instanceVar_PSCEBEDGE_i*d_Vsbxedge_dX+instanceStruct.d_instanceVar_PSCEBEDGE_i_dX*Vsbxedge)+(instanceStruct.instanceVar_PSCEEDGE_i*instanceStruct.d_instanceVar_PSCEDEDGE_i_dX*Vdsx+instanceStruct.d_instanceVar_PSCEEDGE_i_dX*(1+(instanceStruct.instanceVar_PSCEDEDGE_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEBEDGE_i*Vsbxedge)));
dphit1edge = ((instanceStruct.instanceVar_PSCEEDGE_i*(1+(instanceStruct.instanceVar_PSCEDEDGE_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEBEDGE_i*Vsbxedge)));
d_phit1edge_dX = (instanceStruct.instanceVar_phit0edge*d_dphit1edge_dX+instanceStruct.d_instanceVar_phit0edge_dX*(1.0+dphit1edge));
phit1edge = (instanceStruct.instanceVar_phit0edge*(1.0+dphit1edge));
d_inv_phit1edge_dX = (-d_phit1edge_dX/phit1edge/phit1edge);
inv_phit1edge = (1.0/phit1edge);
if ((instanceStruct.instanceVar_CFDEDGE_i<0.05))
{
d_Vdspedge_dX = 0.0;
Vdspedge = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_CFDEDGE_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdspedge_dX = ((instanceStruct.instanceVar_CFDEDGE_i*2.0*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_CFDEDGE_i_dX*Vdsx)-(2.0*(value_sqrt_0-1.0))*instanceStruct.d_instanceVar_CFDEDGE_i_dX)/instanceStruct.instanceVar_CFDEDGE_i/instanceStruct.instanceVar_CFDEDGE_i);
Vdspedge = ((2.0*(value_sqrt_0-1.0))/instanceStruct.instanceVar_CFDEDGE_i);
}
}
d_delVgedge_dX = ((instanceStruct.instanceVar_CFEDGE_i*Vdspedge)*(instanceStruct.instanceVar_CFBEDGE_i*d_Vsbxedge_dX+instanceStruct.d_instanceVar_CFBEDGE_i_dX*Vsbxedge)+(instanceStruct.instanceVar_CFEDGE_i*d_Vdspedge_dX+instanceStruct.d_instanceVar_CFEDGE_i_dX*Vdspedge)*(1+(instanceStruct.instanceVar_CFBEDGE_i*Vsbxedge)));
delVgedge = ((instanceStruct.instanceVar_CFEDGE_i*Vdspedge)*(1+(instanceStruct.instanceVar_CFBEDGE_i*Vsbxedge)));
d_xgedge_dX = (inv_phit1edge*((d_Vsbstaredge_dX+d_delVgedge_dX)-instanceStruct.d_instanceVar_VFBEDGE_T_dX)+d_inv_phit1edge_dX*(((Vgs+Vsbstaredge)+delVgedge)-instanceStruct.instanceVar_VFBEDGE_T));
xgedge = (inv_phit1edge*(((Vgs+Vsbstaredge)+delVgedge)-instanceStruct.instanceVar_VFBEDGE_T));
d_xbedge_dX = (inv_phit1edge*instanceStruct.d_instanceVar_phibedge_dX+d_inv_phit1edge_dX*instanceStruct.instanceVar_phibedge);
xbedge = (inv_phit1edge*instanceStruct.instanceVar_phibedge);
{
double value_sqrt_0 = sqrt(xbedge);
double value_log_1 = log(((xbedge/instanceStruct.instanceVar_Gfedge)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((xbedge/instanceStruct.instanceVar_Gfedge)+value_sqrt_0));
d_dxthedge_dX = 2.0*deriv_log_1_d0*((((instanceStruct.instanceVar_Gfedge*d_xbedge_dX-xbedge*instanceStruct.d_instanceVar_Gfedge_dX)/instanceStruct.instanceVar_Gfedge/instanceStruct.instanceVar_Gfedge)+deriv_sqrt_0_d0*(d_xbedge_dX)));
dxthedge = (2.0*value_log_1);
}
d_xnedge_s_dX = (inv_phit1edge*d_Vsbstaredge_dX+d_inv_phit1edge_dX*Vsbstaredge);
xnedge_s = (inv_phit1edge*Vsbstaredge);
d_Q_EDGE_xsth_dX = (d_xbedge_dX+d_xnedge_s_dX);
Q_EDGE_xsth = (xbedge+xnedge_s);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_xth0_dX = (d_Q_EDGE_xsth_dX+(instanceStruct.instanceVar_Gfedge*deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dX)+instanceStruct.d_instanceVar_Gfedge_dX*value_sqrt_0));
Q_EDGE_xth0 = (Q_EDGE_xsth+(instanceStruct.instanceVar_Gfedge*value_sqrt_0));
}
d_Q_EDGE_xth_dX = (d_Q_EDGE_xth0_dX+d_dxthedge_dX);
Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_n_dX = (((2.0*value_sqrt_0)*instanceStruct.d_instanceVar_Gfedge_dX-instanceStruct.instanceVar_Gfedge*2.0*deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dX))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
Q_EDGE_n = (1.0+(instanceStruct.instanceVar_Gfedge/(2.0*value_sqrt_0)));
}
d_Q_EDGE_n_inv_dX = (-d_Q_EDGE_n_dX/Q_EDGE_n/Q_EDGE_n);
Q_EDGE_n_inv = (1.0/Q_EDGE_n);
d_Q_EDGE_xgt_dX = (d_xgedge_dX-d_Q_EDGE_xth_dX);
Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
if ((Q_EDGE_xgt>(-12.0)))
{
d_Q_EDGE_xgt0_dX = (d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX);
Q_EDGE_xgt0 = ((Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)-1.0);
{
double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_xgt0e_dX = 0.5*(d_Q_EDGE_xgt0_dX+deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dX+d_Q_EDGE_xgt0_dX*Q_EDGE_xgt0)));
Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
}
{
double value_log_0 = log(Q_EDGE_xgt0e);
double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);
d_Q_EDGE_qi0si_dX = ((d_Q_EDGE_xgt_dX-(Q_EDGE_n*deriv_log_0_d0*(d_Q_EDGE_xgt0e_dX)+d_Q_EDGE_n_dX*value_log_0))+instanceStruct.d_instanceVar_lnGfedge2_dX);
Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+instanceStruct.instanceVar_lnGfedge2);
}
{
double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_qi0_dX = 0.5*(d_Q_EDGE_qi0si_dX+deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dX+d_Q_EDGE_qi0si_dX*Q_EDGE_qi0si)));
Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
}
if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
double  deriv_exp_0_d0 = value_exp_0;
d_Q_EDGE_exp_x_dX = deriv_exp_0_d0*((d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX));
Q_EDGE_exp_x = value_exp_0;
}
}
else
{
d_Q_EDGE_exp_x_dX = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
d_Q_EDGE_d0_dX = (instanceStruct.instanceVar_Gfedge2*d_Q_EDGE_exp_x_dX+instanceStruct.d_instanceVar_Gfedge2_dX*Q_EDGE_exp_x);
Q_EDGE_d0 = (instanceStruct.instanceVar_Gfedge2*Q_EDGE_exp_x);
{
double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);
d_Q_EDGE_d0p_dX = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dX))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dX)));
Q_EDGE_d0p = value_pow_0;
}
d_Q_EDGE_sqerr_dX = ((Q_EDGE_n*d_Q_EDGE_n_dX+d_Q_EDGE_n_dX*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dX+(2.0*(d_Q_EDGE_qi0_dX+d_Q_EDGE_n_dX)-d_Q_EDGE_d0p_dX)*Q_EDGE_d0p));
Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
{
double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_errq_dX = (Q_EDGE_n*((Q_EDGE_d0p*(deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dX)-d_Q_EDGE_n_dX)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dX)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dX*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
}
d_qseffedge_dX = (d_Q_EDGE_qi0_dX-d_Q_EDGE_errq_dX);
qseffedge = (Q_EDGE_qi0-Q_EDGE_errq);
}
else
{
if (((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2))>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)));
double  deriv_exp_0_d0 = value_exp_0;
d_qseffedge_dX = deriv_exp_0_d0*((Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)));
qseffedge = value_exp_0;
}
}
else
{
d_qseffedge_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
qseffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
}
}
d_xnedge_d_dX = (inv_phit1edge*(d_Vdse_dc_dX+d_Vsbstaredge_dX)+d_inv_phit1edge_dX*(Vdse_dc+Vsbstaredge));
xnedge_d = (inv_phit1edge*(Vdse_dc+Vsbstaredge));
if (((qseffedge<1.0e-3)&(Vdse_dc<1.0e-6)))
{
if ((((-xnedge_d)+xnedge_s)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-xnedge_d)+xnedge_s));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*(((-d_xnedge_d_dX)+d_xnedge_s_dX));
temp = value_exp_0;
}
}
else
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(-((-d_xnedge_d_dX)+d_xnedge_s_dX))*3.3333333333333333e-01+(-((-d_xnedge_d_dX)+d_xnedge_s_dX))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))+(-((-d_xnedge_d_dX)+d_xnedge_s_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*(1.0+(((-2.3025850929940458e+02)-((-xnedge_d)+xnedge_s))*3.3333333333333333e-01))))))));
}
d_qdseffedge_dX = (qseffedge*d_temp_dX+d_qseffedge_dX*(temp-1.0));
qdseffedge = (qseffedge*(temp-1.0));
d_qdeffedge_dX = (d_qdseffedge_dX+d_qseffedge_dX);
qdeffedge = (qdseffedge+qseffedge);
}
else
{
d_Q_EDGE_xsth_dX = (d_xbedge_dX+d_xnedge_d_dX);
Q_EDGE_xsth = (xbedge+xnedge_d);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_xth0_dX = (d_Q_EDGE_xsth_dX+(instanceStruct.instanceVar_Gfedge*deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dX)+instanceStruct.d_instanceVar_Gfedge_dX*value_sqrt_0));
Q_EDGE_xth0 = (Q_EDGE_xsth+(instanceStruct.instanceVar_Gfedge*value_sqrt_0));
}
d_Q_EDGE_xth_dX = (d_Q_EDGE_xth0_dX+d_dxthedge_dX);
Q_EDGE_xth = (Q_EDGE_xth0+dxthedge);
{
double value_sqrt_0 = sqrt(Q_EDGE_xsth);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_n_dX = (((2.0*value_sqrt_0)*instanceStruct.d_instanceVar_Gfedge_dX-instanceStruct.instanceVar_Gfedge*2.0*deriv_sqrt_0_d0*(d_Q_EDGE_xsth_dX))/(2.0*value_sqrt_0)/(2.0*value_sqrt_0));
Q_EDGE_n = (1.0+(instanceStruct.instanceVar_Gfedge/(2.0*value_sqrt_0)));
}
d_Q_EDGE_n_inv_dX = (-d_Q_EDGE_n_dX/Q_EDGE_n/Q_EDGE_n);
Q_EDGE_n_inv = (1.0/Q_EDGE_n);
d_Q_EDGE_xgt_dX = (d_xgedge_dX-d_Q_EDGE_xth_dX);
Q_EDGE_xgt = (xgedge-Q_EDGE_xth);
if ((Q_EDGE_xgt>(-12.0)))
{
d_Q_EDGE_xgt0_dX = (d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX);
Q_EDGE_xgt0 = ((Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)-1.0);
{
double value_sqrt_0 = sqrt(((Q_EDGE_xgt0*Q_EDGE_xgt0)+10.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_xgt0e_dX = 0.5*(d_Q_EDGE_xgt0_dX+deriv_sqrt_0_d0*((Q_EDGE_xgt0*d_Q_EDGE_xgt0_dX+d_Q_EDGE_xgt0_dX*Q_EDGE_xgt0)));
Q_EDGE_xgt0e = (0.5*(Q_EDGE_xgt0+value_sqrt_0));
}
{
double value_log_0 = log(Q_EDGE_xgt0e);
double  deriv_log_0_d0 = (1.0/Q_EDGE_xgt0e);
d_Q_EDGE_qi0si_dX = ((d_Q_EDGE_xgt_dX-(Q_EDGE_n*deriv_log_0_d0*(d_Q_EDGE_xgt0e_dX)+d_Q_EDGE_n_dX*value_log_0))+instanceStruct.d_instanceVar_lnGfedge2_dX);
Q_EDGE_qi0si = ((Q_EDGE_xgt-(Q_EDGE_n*value_log_0))+instanceStruct.instanceVar_lnGfedge2);
}
{
double value_sqrt_0 = sqrt(((Q_EDGE_qi0si*Q_EDGE_qi0si)+2.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_qi0_dX = 0.5*(d_Q_EDGE_qi0si_dX+deriv_sqrt_0_d0*((Q_EDGE_qi0si*d_Q_EDGE_qi0si_dX+d_Q_EDGE_qi0si_dX*Q_EDGE_qi0si)));
Q_EDGE_qi0 = (0.5*(Q_EDGE_qi0si+value_sqrt_0));
}
if (((Q_EDGE_xgt-Q_EDGE_qi0)<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((Q_EDGE_xgt-Q_EDGE_qi0));
double  deriv_exp_0_d0 = value_exp_0;
d_Q_EDGE_exp_x_dX = deriv_exp_0_d0*((d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX));
Q_EDGE_exp_x = value_exp_0;
}
}
else
{
d_Q_EDGE_exp_x_dX = 1.0e100*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*3.3333333333333333e-01+(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_Q_EDGE_xgt_dX-d_Q_EDGE_qi0_dX)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
Q_EDGE_exp_x = (1.0e100*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(0.5*(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*(1.0+(((Q_EDGE_xgt-Q_EDGE_qi0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
d_Q_EDGE_d0_dX = (instanceStruct.instanceVar_Gfedge2*d_Q_EDGE_exp_x_dX+instanceStruct.d_instanceVar_Gfedge2_dX*Q_EDGE_exp_x);
Q_EDGE_d0 = (instanceStruct.instanceVar_Gfedge2*Q_EDGE_exp_x);
{
double value_pow_0 = pow(Q_EDGE_d0,Q_EDGE_n_inv);
double  deriv_pow_0_d0 = ((Q_EDGE_d0 == 0.0)?0.0:(value_pow_0*Q_EDGE_n_inv/Q_EDGE_d0));
double  deriv_pow_0_d1 = (Q_EDGE_d0 == 0.0)?0.0:(log(Q_EDGE_d0)*value_pow_0);
d_Q_EDGE_d0p_dX = ((deriv_pow_0_d0*(d_Q_EDGE_d0_dX))+(deriv_pow_0_d1*(d_Q_EDGE_n_inv_dX)));
Q_EDGE_d0p = value_pow_0;
}
d_Q_EDGE_sqerr_dX = ((Q_EDGE_n*d_Q_EDGE_n_dX+d_Q_EDGE_n_dX*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*d_Q_EDGE_d0p_dX+(2.0*(d_Q_EDGE_qi0_dX+d_Q_EDGE_n_dX)-d_Q_EDGE_d0p_dX)*Q_EDGE_d0p));
Q_EDGE_sqerr = ((Q_EDGE_n*Q_EDGE_n)+(((2.0*(Q_EDGE_qi0+Q_EDGE_n))-Q_EDGE_d0p)*Q_EDGE_d0p));
{
double value_sqrt_0 = sqrt(Q_EDGE_sqerr);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Q_EDGE_errq_dX = (Q_EDGE_n*((Q_EDGE_d0p*(deriv_sqrt_0_d0*(d_Q_EDGE_sqerr_dX)-d_Q_EDGE_n_dX)-(value_sqrt_0-Q_EDGE_n)*d_Q_EDGE_d0p_dX)/Q_EDGE_d0p/Q_EDGE_d0p)+d_Q_EDGE_n_dX*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
Q_EDGE_errq = (Q_EDGE_n*(((value_sqrt_0-Q_EDGE_n)/Q_EDGE_d0p)-1.0));
}
d_qdeffedge_dX = (d_Q_EDGE_qi0_dX-d_Q_EDGE_errq_dX);
qdeffedge = (Q_EDGE_qi0-Q_EDGE_errq);
}
else
{
if (((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2))>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)));
double  deriv_exp_0_d0 = value_exp_0;
d_qdeffedge_dX = deriv_exp_0_d0*((Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)));
qdeffedge = value_exp_0;
}
}
else
{
d_qdeffedge_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01+(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01)))+(-(Q_EDGE_n_inv*(d_Q_EDGE_xgt_dX+instanceStruct.d_instanceVar_lnGfedge2_dX)+d_Q_EDGE_n_inv_dX*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
qdeffedge = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*(1.0+(((-2.3025850929940458e+02)-(Q_EDGE_n_inv*(Q_EDGE_xgt+instanceStruct.instanceVar_lnGfedge2)))*3.3333333333333333e-01))))))));
}
}
d_qdseffedge_dX = (d_qdeffedge_dX-d_qseffedge_dX);
qdseffedge = (qdeffedge-qseffedge);
}
d_qmeffedge_dX = 0.5*(d_qdeffedge_dX+d_qseffedge_dX);
qmeffedge = (0.5*(qdeffedge+qseffedge));
{
double value_max_0 = std::max((xgedge-qmeffedge),static_cast<double>(1.0e-40));
double  deriv_max_0_d0 = (((xgedge-qmeffedge)>=1.0e-40)?1.0:0.0);
d_dsqredge_dX = (deriv_max_0_d0*((d_xgedge_dX-d_qmeffedge_dX)));
dsqredge = value_max_0;
}
{
double value_sqrt_0 = sqrt((dsqredge+(0.25*instanceStruct.instanceVar_Gfedge2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_alphabmedge_dX = (-((value_sqrt_0*0.5*instanceStruct.d_instanceVar_Gfedge_dX-(0.5*instanceStruct.instanceVar_Gfedge)*deriv_sqrt_0_d0*((d_dsqredge_dX+0.25*instanceStruct.d_instanceVar_Gfedge2_dX)))/value_sqrt_0/value_sqrt_0));
alphabmedge = (1.0-((0.5*instanceStruct.instanceVar_Gfedge)/value_sqrt_0));
}
d_Idsedge_dX = ((Gmob_dc*(((((-instanceStruct.instanceVar_BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*d_qdseffedge_dX+((((-instanceStruct.instanceVar_BETEDGE_i)*phit1edge)*phit1edge)*(alphabmedge*d_qmeffedge_dX+d_alphabmedge_dX*qmeffedge)+(((-instanceStruct.instanceVar_BETEDGE_i)*phit1edge)*d_phit1edge_dX+((-instanceStruct.instanceVar_BETEDGE_i)*d_phit1edge_dX+(-instanceStruct.d_instanceVar_BETEDGE_i_dX)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)-(((((-instanceStruct.instanceVar_BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)*d_Gmob_dc_dX)/Gmob_dc/Gmob_dc);
Idsedge = ((((((-instanceStruct.instanceVar_BETEDGE_i)*phit1edge)*phit1edge)*((alphabmedge*qmeffedge)+1.0))*qdseffedge)/Gmob_dc);
}
if (((xg_dc>0)&&(modelStruct.modelVar_SWIMPACT_i!=0)))
{
d_delVsat_dX = (-(instanceStruct.instanceVar_A3_i*d_dps_dc_dX+instanceStruct.d_instanceVar_A3_i_dX*dps_dc));
delVsat = (Vds-(instanceStruct.instanceVar_A3_i*dps_dc));
if ((delVsat>0))
{
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_phib_dc+Vsbstar_dc));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp2_dX = (instanceStruct.instanceVar_A2_T*(((delVsat+1.0e-30)*(instanceStruct.instanceVar_A4_i*(deriv_sqrt_0_d0*((instanceStruct.d_instanceVar_phib_dc_dX+d_Vsbstar_dc_dX))-instanceStruct.d_instanceVar_sqrt_phib_dc_dX)+instanceStruct.d_instanceVar_A4_i_dX*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc))-(1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc)))*d_delVsat_dX)/(delVsat+1.0e-30)/(delVsat+1.0e-30))+instanceStruct.d_instanceVar_A2_T_dX*((1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc)))/(delVsat+1.0e-30)));
temp2 = (instanceStruct.instanceVar_A2_T*((1.0+(instanceStruct.instanceVar_A4_i*(value_sqrt_0-instanceStruct.instanceVar_sqrt_phib_dc)))/(delVsat+1.0e-30)));
}
if ((fabs((-temp2))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-temp2));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((-d_temp2_dX));
temp = value_exp_0;
}
}
else
{
if (((-temp2)<0.0))
{
d_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-temp2))*0.5*(((-2.3025850929940458e+02)-(-temp2))*(-(-d_temp2_dX))*3.3333333333333333e-01+(-(-d_temp2_dX))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))+(-(-d_temp2_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-temp2))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-temp2))*(1.0+(((-2.3025850929940458e+02)-(-temp2))*3.3333333333333333e-01))))))));
}
else
{
d_temp_dX = 1.0e100*(((-temp2)-2.3025850929940458e+02)*0.5*(((-temp2)-2.3025850929940458e+02)*(-d_temp2_dX)*3.3333333333333333e-01+(-d_temp2_dX)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(-d_temp2_dX)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
temp = (1.0e100*(1.0+(((-temp2)-2.3025850929940458e+02)*(1.0+(0.5*(((-temp2)-2.3025850929940458e+02)*(1.0+(((-temp2)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_mavl_dX = (instanceStruct.instanceVar_A1_i*(delVsat*d_temp_dX+d_delVsat_dX*temp)+instanceStruct.d_instanceVar_A1_i_dX*(delVsat*temp));
mavl = (instanceStruct.instanceVar_A1_i*(delVsat*temp));
d_Iimpact_dX = (mavl*(d_Ids_dX+d_Idsedge_dX)+d_mavl_dX*(Ids+Idsedge));
Iimpact = (mavl*(Ids+Idsedge));
}
}
d_P_D_dX = 0.25*(Gf_dc*instanceStruct.d_instanceVar_kp_dX+d_Gf_dc_dX*instanceStruct.instanceVar_kp);
P_D = (1.0+(0.25*(Gf_dc*instanceStruct.instanceVar_kp)));
d_facvsb0_dX = (instanceStruct.d_instanceVar_phib_dc_dX+2.0*d_phit1_dX);
facvsb0 = (instanceStruct.instanceVar_phib_dc+(2.0*phit1));
d_facvsb_dX = (d_Vsbstar_dc_dX+d_facvsb0_dX);
facvsb = (Vsbstar_dc+facvsb0);
{
double value_sqrt_0 = sqrt((phit1*facvsb));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vts_i_dX = (((instanceStruct.d_instanceVar_VFB_T_dX+(P_D*d_facvsb_dX+d_P_D_dX*facvsb))-d_Vsbstar_dc_dX)+(Gf_dc*deriv_sqrt_0_d0*((phit1*d_facvsb_dX+d_phit1_dX*facvsb))+d_Gf_dc_dX*value_sqrt_0));
vts_i = (((instanceStruct.instanceVar_VFB_T+(P_D*facvsb))-Vsbstar_dc)+(Gf_dc*value_sqrt_0));
}
d_vth_i_dX = (d_vts_i_dX-d_delVg_dX);
vth_i = (vts_i-delVg);
}
// End block evaluateStatic
//Begin block evaluateDynamic
{
//Begin block SPcalc_ac
{
//Block-local variables for block SPcalc_ac
double phib=0.0;
double d_phib_dX=0.0;
double G_0=0.0;
double d_G_0_dX=0.0;
double Vsbstar=0.0;
double d_Vsbstar_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double Vsbx=0.0;
double d_Vsbx_dX=0.0;
double xg=0.0;
double d_xg_dX=0.0;
double Dnsub=0.0;
double d_Dnsub_dX=0.0;
double Gf=0.0;
double d_Gf_dX=0.0;
double Gf2=0.0;
double d_Gf2_dX=0.0;
double inv_Gf2=0.0;
double d_inv_Gf2_dX=0.0;
double xi=0.0;
double d_xi_dX=0.0;
double inv_xi=0.0;
double d_inv_xi_dX=0.0;
double Ux=0.0;
double d_Ux_dX=0.0;
double xn_s=0.0;
double d_xn_s_dX=0.0;
double delta_ns=0.0;
double d_delta_ns_dX=0.0;
double margin=0.0;
double d_margin_dX=0.0;
double x_s=0.0;
double d_x_s_dX=0.0;
double delta_1s=0.0;
double d_delta_1s_dX=0.0;
double xi0s=0.0;
double d_xi0s_dX=0.0;
double xi1s=0.0;
double d_xi1s_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double xi2s=0.0;
double d_xi2s_dX=0.0;
double Es=0.0;
double d_Es_dX=0.0;
double Ds=0.0;
double d_Ds_dX=0.0;
double Ps=0.0;
double d_Ps_dX=0.0;
double Rxcor=0.0;
double d_Rxcor_dX=0.0;
double xgs=0.0;
double d_xgs_dX=0.0;
double qis=0.0;
double d_qis_dX=0.0;
double qbs=0.0;
double d_qbs_dX=0.0;
double rhob=0.0;
double d_rhob_dX=0.0;
double GR=0.0;
double d_GR_dX=0.0;
double Eeffm=0.0;
double d_Eeffm_dX=0.0;
double Mutmp=0.0;
double d_Mutmp_dX=0.0;
double Gmob=0.0;
double d_Gmob_dX=0.0;
double xitsb=0.0;
double d_xitsb_dX=0.0;
double wsat=0.0;
double d_wsat_dX=0.0;
double thesat1=0.0;
double d_thesat1_dX=0.0;
double phi_inf=0.0;
double d_phi_inf_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double ysat=0.0;
double d_ysat_dX=0.0;
double za=0.0;
double d_za_dX=0.0;
double Phi_0=0.0;
double d_Phi_0_dX=0.0;
double asat=0.0;
double d_asat_dX=0.0;
double Phi_2=0.0;
double d_Phi_2_dX=0.0;
double Phi_0_2=0.0;
double d_Phi_0_2_dX=0.0;
double Phi0_Phi2=0.0;
double d_Phi0_Phi2_dX=0.0;
double Phi_sat=0.0;
double d_Phi_sat_dX=0.0;
double Vdse=0.0;
double d_Vdse_dX=0.0;
double Udse=0.0;
double d_Udse_dX=0.0;
double xn_d=0.0;
double d_xn_d_dX=0.0;
double k_ds=0.0;
double d_k_ds_dX=0.0;
double delta_nd=0.0;
double d_delta_nd_dX=0.0;
double x_d=0.0;
double d_x_d_dX=0.0;
double x_ds=0.0;
double d_x_ds_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double pC=0.0;
double d_pC_dX=0.0;
double qC=0.0;
double d_qC_dX=0.0;
double dps=0.0;
double d_dps_dX=0.0;
double xi0d=0.0;
double d_xi0d_dX=0.0;
double Ed=0.0;
double d_Ed_dX=0.0;
double Dd=0.0;
double d_Dd_dX=0.0;
double x_m=0.0;
double d_x_m_dX=0.0;
double Em=0.0;
double d_Em_dX=0.0;
double D_bar=0.0;
double d_D_bar_dX=0.0;
double Dm=0.0;
double d_Dm_dX=0.0;
double Pm=0.0;
double d_Pm_dX=0.0;
double xgm=0.0;
double d_xgm_dX=0.0;
double eta_p=0.0;
double d_eta_p_dX=0.0;
double sqm=0.0;
double d_sqm_dX=0.0;
double alpha=0.0;
double d_alpha_dX=0.0;
double d0=0.0;
double d_d0_dX=0.0;
double x_pm=0.0;
double d_x_pm_dX=0.0;
double p_pd=0.0;
double d_p_pd_dX=0.0;
double q_pd=0.0;
double d_q_pd_dX=0.0;
double xi_pd=0.0;
double d_xi_pd_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double u_pd=0.0;
double d_u_pd_dX=0.0;
double km=0.0;
double d_km_dX=0.0;
double km0=0.0;
double d_km0_dX=0.0;
double qim=0.0;
double d_qim_dX=0.0;
double qim1=0.0;
double d_qim1_dX=0.0;
double qbm=0.0;
double d_qbm_dX=0.0;
double qeff=0.0;
double d_qeff_dX=0.0;
double qeff1=0.0;
double d_qeff1_dX=0.0;
double s1=0.0;
double d_s1_dX=0.0;
double dL=0.0;
double d_dL_dX=0.0;
double GdL=0.0;
double d_GdL_dX=0.0;
double Gmob_dL=0.0;
double d_Gmob_dL_dX=0.0;
double zsat=0.0;
double d_zsat_dX=0.0;
double Gvsat=0.0;
double d_Gvsat_dX=0.0;
double Gvsatinv=0.0;
double d_Gvsatinv_dX=0.0;
double Voxm=0.0;
double d_Voxm_dX=0.0;
double alpha1=0.0;
double d_alpha1_dX=0.0;
double H=0.0;
double d_H_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_temp=0.0;
double d_SP_S_temp_dX=0.0;
double SP_S_temp1=0.0;
double d_SP_S_temp1_dX=0.0;
double SP_S_temp2=0.0;
double d_SP_S_temp2_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_yg=0.0;
double d_SP_S_yg_dX=0.0;
double SP_S_ysub=0.0;
double d_SP_S_ysub_dX=0.0;
double SP_S_eta=0.0;
double d_SP_S_eta_dX=0.0;
double SP_S_a=0.0;
double d_SP_S_a_dX=0.0;
double SP_S_c=0.0;
double d_SP_S_c_dX=0.0;
double SP_S_tau=0.0;
double d_SP_S_tau_dX=0.0;
double SP_S_y0=0.0;
double d_SP_S_y0_dX=0.0;
double SP_S_delta0=0.0;
double d_SP_S_delta0_dX=0.0;
double SP_S_delta1=0.0;
double d_SP_S_delta1_dX=0.0;
double SP_S_xi0=0.0;
double d_SP_S_xi0_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_xi1=0.0;
double d_SP_S_xi1_dX=0.0;
double SP_S_xi2=0.0;
double d_SP_S_xi2_dX=0.0;
double SP_S_pC=0.0;
double d_SP_S_pC_dX=0.0;
double SP_S_qC=0.0;
double d_SP_S_qC_dX=0.0;
double SP_xg1=0.0;
double d_SP_xg1_dX=0.0;
double SP_S_A_fac=0.0;
double d_SP_S_A_fac_dX=0.0;
double SP_S_xbar=0.0;
double d_SP_S_xbar_dX=0.0;
double SP_S_w=0.0;
double d_SP_S_w_dX=0.0;
double SP_S_x1=0.0;
double d_SP_S_x1_dX=0.0;
double SP_S_bx=0.0;
double d_SP_S_bx_dX=0.0;
double SP_S_b=0.0;
double d_SP_S_b_dX=0.0;
//End of Block-local variables
//Block-local variables for block SPcalc_ac
double SP_S_x0=0.0;
double d_SP_S_x0_dX=0.0;
//End of Block-local variables
if (((modelStruct.modelVar_SWNUD_i==1)||(modelStruct.modelVar_SWDELVTAC_i!=0)))
{
if ((modelStruct.modelVar_SWDELVTAC_i!=0))
{
{
double value_sqrt_0 = sqrt((((Vdb-Vsb)*(Vdb-Vsb))+instanceStruct.instanceVar_bphi_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = (0.5*(-deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_bphi_ac_dX))+instanceStruct.d_instanceVar_phix_ac_dX);
temp = ((0.5*((Vdb+Vsb)-value_sqrt_0))+instanceStruct.instanceVar_phix_ac);
}
{
double value_sqrt_0 = sqrt((((temp)*(temp))+instanceStruct.instanceVar_aphi_ac));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vsbstar_ac_dX = ((-0.5*(d_temp_dX-deriv_sqrt_0_d0*((((temp)*d_temp_dX+d_temp_dX*(temp))+instanceStruct.d_instanceVar_aphi_ac_dX))))+instanceStruct.d_instanceVar_phix1_ac_dX);
Vsbstar_ac = ((Vsb-(0.5*(temp-value_sqrt_0)))+instanceStruct.instanceVar_phix1_ac);
}
d_Vsbstar_dX = d_Vsbstar_ac_dX;
Vsbstar = Vsbstar_ac;
d_phib_dX = instanceStruct.d_instanceVar_phib_ac_dX;
phib = instanceStruct.instanceVar_phib_ac;
d_G_0_dX = instanceStruct.d_instanceVar_G_0_ac_dX;
G_0 = instanceStruct.instanceVar_G_0_ac;
}
else
{
d_Vsbstar_dX = d_Vsbstar_dc_tmp_dX;
Vsbstar = Vsbstar_dc_tmp;
d_phib_dX = instanceStruct.d_instanceVar_phib_dc_dX;
phib = instanceStruct.instanceVar_phib_dc;
d_G_0_dX = instanceStruct.d_instanceVar_G_0_dc_dX;
G_0 = instanceStruct.instanceVar_G_0_dc;
}
d_alpha_dX = 0.0;
alpha = 0.0;
d_GdL_dX = 0.0;
GdL = 1.0;
d_dL_dX = 0.0;
dL = 0.0;
d_qbm_dX = 0.0;
qbm = 0.0;
d_dps_dX = 0.0;
dps = 0.0;
d_qim_dX = 0.0;
qim = 0.0;
d_qim1_dX = 0.0;
qim1 = 0.0;
d_H_dX = 0.0;
H = 1.0;
d_s1_dX = 0.0;
s1 = 0.0;
d_eta_p_dX = 0.0;
eta_p = 1.0;
d_Gvsat_dX = 0.0;
Gvsat = 1.0;
d_Gvsatinv_dX = 0.0;
Gvsatinv = 1.0;
d_SP_S_x1_dX = 0.0;
SP_S_x1 = 0.0;
d_x_s_dX = 0.0;
x_s = 0.0;
d_sqm_dX = 0.0;
sqm = 0.0;
d_xitsb_dX = 0.0;
xitsb = 0.0;
d_rhob_dX = 0.0;
rhob = 0.0;
d_Gmob_dX = 0.0;
Gmob = 1.0;
d_Gmob_dL_dX = 0.0;
Gmob_dL = 1.0;
d_Udse_dX = 0.0;
Udse = 0.0;
d_thesat1_dX = 0.0;
thesat1 = 0.0;
d_xgm_dX = 0.0;
xgm = 0.0;
d_Vgbstar_dX = d_Vsbstar_dX;
Vgbstar = (Vgs+Vsbstar);
d_Vgb1_dX = (d_Vgbstar_dX-instanceStruct.d_instanceVar_VFB_T_dX);
Vgb1 = (Vgbstar-instanceStruct.instanceVar_VFB_T);
d_Vsbx_dX = d_Vsbstar_dX;
Vsbx = (Vsbstar+(0.5*(Vds-Vdsx)));
if ((instanceStruct.instanceVar_CFD_i<1.0e-10))
{
d_Vdsp_dX = 0.0;
Vdsp = Vdsx;
}
else
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_CFD_i*Vdsx)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Vdsp_dX = ((instanceStruct.instanceVar_CFD_i*2.0*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_CFD_i_dX*Vdsx)-(2.0*(value_sqrt_0-1.0))*instanceStruct.d_instanceVar_CFD_i_dX)/instanceStruct.instanceVar_CFD_i/instanceStruct.instanceVar_CFD_i);
Vdsp = ((2.0*(value_sqrt_0-1.0))/instanceStruct.instanceVar_CFD_i);
}
}
d_delVg_dX = ((instanceStruct.instanceVar_CF_i*Vdsp)*(instanceStruct.instanceVar_CFB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_CFB_i_dX*Vsbx)+(instanceStruct.instanceVar_CF_i*d_Vdsp_dX+instanceStruct.d_instanceVar_CF_i_dX*Vdsp)*(1.0+(instanceStruct.instanceVar_CFB_i*Vsbx)));
delVg = ((instanceStruct.instanceVar_CF_i*Vdsp)*(1.0+(instanceStruct.instanceVar_CFB_i*Vsbx)));
d_dphit1_dX = ((instanceStruct.instanceVar_PSCE_i*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(instanceStruct.instanceVar_PSCEB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_PSCEB_i_dX*Vsbx)+(instanceStruct.instanceVar_PSCE_i*instanceStruct.d_instanceVar_PSCED_i_dX*Vdsx+instanceStruct.d_instanceVar_PSCE_i_dX*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEB_i*Vsbx)));
dphit1 = ((instanceStruct.instanceVar_PSCE_i*(1.0+(instanceStruct.instanceVar_PSCED_i*Vdsx)))*(1.0+(instanceStruct.instanceVar_PSCEB_i*Vsbx)));
d_phit1_dX = (instanceStruct.instanceVar_phit0*d_dphit1_dX+instanceStruct.d_instanceVar_phit0_dX*(1.0+dphit1));
phit1 = (instanceStruct.instanceVar_phit0*(1.0+dphit1));
d_inv_phit1_dX = (-d_phit1_dX/phit1/phit1);
inv_phit1 = (1.0/phit1);
d_Vgb1_dX = (d_Vgb1_dX+d_delVg_dX);
Vgb1 = (Vgb1+delVg);
d_xg_dX = (Vgb1*d_inv_phit1_dX+d_Vgb1_dX*inv_phit1);
xg = (Vgb1*inv_phit1);
if ((instanceStruct.instanceVar_DNSUB_i>0.0))
{
{
double value_sqrt_0 = sqrt((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.instanceVar_NSLP_i));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Dnsub_dX = ((instanceStruct.instanceVar_DNSUB_i*0.5)*((-instanceStruct.d_instanceVar_VNSUB_i_dX)+deriv_sqrt_0_d0*((((-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i))*(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))+(-(-instanceStruct.d_instanceVar_VNSUB_i_dX))*(-((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)))+instanceStruct.d_instanceVar_NSLP_i_dX)))+instanceStruct.d_instanceVar_DNSUB_i_dX*0.5*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
Dnsub = ((instanceStruct.instanceVar_DNSUB_i*0.5)*(((Vgs+Vsb)-instanceStruct.instanceVar_VNSUB_i)+value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((1.0+Dnsub));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gf_dX = (G_0*deriv_sqrt_0_d0*(d_Dnsub_dX)+d_G_0_dX*value_sqrt_0);
Gf = (G_0*value_sqrt_0);
}
}
else
{
d_Gf_dX = d_G_0_dX;
Gf = G_0;
}
d_Gf2_dX = (Gf*d_Gf_dX+d_Gf_dX*Gf);
Gf2 = (Gf*Gf);
d_inv_Gf2_dX = (-d_Gf2_dX/Gf2/Gf2);
inv_Gf2 = (1.0/Gf2);
d_xi_dX = d_Gf_dX*7.0710678118654746e-01;
xi = (1.0+(Gf*7.0710678118654746e-01));
d_inv_xi_dX = (-d_xi_dX/xi/xi);
inv_xi = (1.0/xi);
d_Ux_dX = (Vsbstar*d_inv_phit1_dX+d_Vsbstar_dX*inv_phit1);
Ux = (Vsbstar*inv_phit1);
d_xn_s_dX = ((phib*d_inv_phit1_dX+d_phib_dX*inv_phit1)+d_Ux_dX);
xn_s = ((phib*inv_phit1)+Ux);
if ((xn_s<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_ns_dX = deriv_exp_0_d0*((-d_xn_s_dX));
delta_ns = value_exp_0;
}
}
else
{
d_delta_ns_dX = (-1.0e-200*((xn_s-4.6051701859880916e+02)*0.5*((xn_s-4.6051701859880916e+02)*d_xn_s_dX*3.3333333333333333e-01+d_xn_s_dX*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_xn_s_dX*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
delta_ns = (1.0e-200/(1.0+((xn_s-4.6051701859880916e+02)*(1.0+(0.5*((xn_s-4.6051701859880916e+02)*(1.0+((xn_s-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_margin_dX = 1.0e-5*d_xi_dX;
margin = (1.0e-5*xi);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_s_dX = ((xg*inv_xi)*(((xg*(1.0-delta_ns))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_ns))*d_Gf_dX+(xg*(-d_delta_ns_dX)+d_xg_dX*(1.0-delta_ns))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
x_s = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_ns))*Gf)*SP_S_temp1)));
}
else
{
if ((xg<(-margin)))
{
d_SP_S_yg_dX = (-d_xg_dX);
SP_S_yg = (-xg);
d_SP_S_ysub_dX = 1.25*(SP_S_yg*d_inv_xi_dX+d_SP_S_yg_dX*inv_xi);
SP_S_ysub = (1.25*(SP_S_yg*inv_xi));
{
double value_sqrt_0 = sqrt((((SP_S_ysub-6.0)*(SP_S_ysub-6.0))+64.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_eta_dX = 0.5*(d_SP_S_ysub_dX-deriv_sqrt_0_d0*(((SP_S_ysub-6.0)*d_SP_S_ysub_dX+d_SP_S_ysub_dX*(SP_S_ysub-6.0))));
SP_S_eta = (0.5*((SP_S_ysub+10)-value_sqrt_0));
}
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_eta_dX);
SP_S_temp = (SP_S_yg-SP_S_eta);
d_SP_S_a_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)+(Gf2*d_SP_S_eta_dX+d_Gf2_dX*(SP_S_eta+1.0)));
SP_S_a = ((SP_S_temp*SP_S_temp)+(Gf2*(SP_S_eta+1.0)));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX-d_Gf2_dX);
SP_S_c = ((2.0*SP_S_temp)-Gf2);
{
double value_log_0 = log((SP_S_a*inv_Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a*inv_Gf2));
d_SP_S_tau_dX = ((-d_SP_S_eta_dX)+deriv_log_0_d0*((SP_S_a*d_inv_Gf2_dX+d_SP_S_a_dX*inv_Gf2)));
SP_S_tau = ((-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-d_SP_S_a_dX)+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-SP_S_a)));
d_SP_S_y0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-d_SP_S_a_dX)+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
SP_S_y0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-SP_S_a)))));
if ((SP_S_y0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_y0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_y0_dX);
SP_S_delta0 = value_exp_0;
}
}
else
{
d_SP_S_delta0_dX = 1.0e100*((SP_S_y0-2.3025850929940458e+02)*0.5*((SP_S_y0-2.3025850929940458e+02)*d_SP_S_y0_dX*3.3333333333333333e-01+d_SP_S_y0_dX*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_y0_dX*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))));
SP_S_delta0 = (1.0e100*(1.0+((SP_S_y0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_y0-2.3025850929940458e+02)*(1.0+((SP_S_y0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_temp_dX = (-(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)/(2.0+(SP_S_y0*SP_S_y0))/(2.0+(SP_S_y0*SP_S_y0)));
SP_S_temp = (1.0/(2.0+(SP_S_y0*SP_S_y0)));
d_SP_S_xi0_dX = ((SP_S_y0*SP_S_y0)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_y0_dX+d_SP_S_y0_dX*SP_S_y0)*SP_S_temp);
SP_S_xi0 = ((SP_S_y0*SP_S_y0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_y0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_y0*d_SP_S_temp_dX+d_SP_S_y0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_y0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_SP_S_yg_dX-d_SP_S_y0_dX);
SP_S_temp = (SP_S_yg-SP_S_y0);
d_SP_S_temp1_dX = (delta_ns*d_SP_S_delta1_dX+d_delta_ns_dX*SP_S_delta1);
SP_S_temp1 = (delta_ns*SP_S_delta1);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*((d_SP_S_delta0_dX-d_SP_S_temp1_dX)+(delta_ns*(-d_SP_S_xi1_dX)+d_delta_ns_dX*(1.0-SP_S_xi1)))+d_Gf2_dX*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((SP_S_delta0-1.0)-SP_S_temp1)+(delta_ns*(1.0-SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta0_dX-d_SP_S_y0_dX)+d_SP_S_temp1_dX)+(delta_ns*(d_SP_S_y0_dX-d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_y0-1.0)-SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta0-SP_S_y0)-1.0)+SP_S_temp1)+(delta_ns*((SP_S_y0-1.0)-SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta0_dX+d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta0+SP_S_temp1)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = ((-d_SP_S_y0_dX)-2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = ((-SP_S_y0)-(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
else
{
d_SP_xg1_dX = (-d_Gf_dX*7.324648775608221e-001/(1.25+(Gf*7.324648775608221e-001))/(1.25+(Gf*7.324648775608221e-001)));
SP_xg1 = (1.0/(1.25+(Gf*7.324648775608221e-001)));
d_SP_S_A_fac_dX = ((((xi*1.25)*SP_xg1)-1.0)*d_SP_xg1_dX+((xi*1.25)*d_SP_xg1_dX+d_xi_dX*1.25*SP_xg1)*SP_xg1);
SP_S_A_fac = ((((xi*1.25)*SP_xg1)-1.0)*SP_xg1);
d_SP_S_xbar_dX = ((xg*inv_xi)*(SP_S_A_fac*d_xg_dX+d_SP_S_A_fac_dX*xg)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(SP_S_A_fac*xg)));
SP_S_xbar = ((xg*inv_xi)*(1.0+(SP_S_A_fac*xg)));
if (((-SP_S_xbar)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((-SP_S_xbar));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp_dX = deriv_exp_0_d0*((-d_SP_S_xbar_dX));
SP_S_temp = value_exp_0;
}
}
else
{
d_SP_S_temp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(-SP_S_xbar))*0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(-(-d_SP_S_xbar_dX))*3.3333333333333333e-01+(-(-d_SP_S_xbar_dX))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))+(-(-d_SP_S_xbar_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
SP_S_temp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(0.5*(((-2.3025850929940458e+02)-(-SP_S_xbar))*(1.0+(((-2.3025850929940458e+02)-(-SP_S_xbar))*3.3333333333333333e-01))))))));
}
d_SP_S_w_dX = (-d_SP_S_temp_dX);
SP_S_w = (1.0-SP_S_temp);
{
double value_sqrt_0 = sqrt(((xg+(Gf2*0.25))-SP_S_w));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_SP_S_x1_dX = ((d_xg_dX+d_Gf2_dX*0.5)-(Gf*deriv_sqrt_0_d0*(((d_xg_dX+d_Gf2_dX*0.25)-d_SP_S_w_dX))+d_Gf_dX*value_sqrt_0));
SP_S_x1 = ((xg+(Gf2*0.5))-(Gf*value_sqrt_0));
}
d_SP_S_bx_dX = d_xn_s_dX;
SP_S_bx = (xn_s+3.0);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_ns*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_ns*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_ns*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_ns*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_ns*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_s_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_s-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_ns*d_SP_S_delta0_dX+d_delta_ns_dX*SP_S_delta0);
SP_S_delta0 = (delta_ns*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_s_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_ns_dX-delta_ns*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_ns/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(d_xn_s_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_s-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi1_dX+d_delta_ns_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_ns*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_ns*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_ns_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_ns*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_ns*d_SP_S_xi2_dX+d_delta_ns_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_ns*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_s_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_s = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
}
d_x_d_dX = d_x_s_dX;
x_d = x_s;
d_x_m_dX = d_x_s_dX;
x_m = x_s;
d_x_ds_dX = 0.0;
x_ds = 0.0;
d_Vdsat_lim_dX = 3.912023005*d_phit1_dX;
Vdsat_lim = (3.912023005*phit1);
if ((xg<=0.0))
{
d_qis_dX = 0.0;
qis = 0.0;
d_xgm_dX = (d_xg_dX-d_x_s_dX);
xgm = (xg-x_s);
d_Voxm_dX = (xgm*d_phit1_dX+d_xgm_dX*phit1);
Voxm = (xgm*phit1);
d_qeff1_dX = d_Voxm_dX;
qeff1 = Voxm;
d_Vdsat_dX = d_Vdsat_lim_dX;
Vdsat = Vdsat_lim;
d_Vdse_dX = 0.0;
Vdse = Vds;
}
else
{
d_delta_1s_dX = 0.0;
delta_1s = 0.0;
d_temp_dX = (-(x_s*d_x_s_dX+d_x_s_dX*x_s)/(2.0+(x_s*x_s))/(2.0+(x_s*x_s)));
temp = (1.0/(2.0+(x_s*x_s)));
d_xi0s_dX = ((x_s*x_s)*d_temp_dX+(x_s*d_x_s_dX+d_x_s_dX*x_s)*temp);
xi0s = ((x_s*x_s)*temp);
d_xi1s_dX = 4.0*((x_s*temp)*d_temp_dX+(x_s*d_temp_dX+d_x_s_dX*temp)*temp);
xi1s = (4.0*((x_s*temp)*temp));
d_xi2s_dX = ((((8.0*temp)-(12.0*xi0s))*temp)*d_temp_dX+(((8.0*temp)-(12.0*xi0s))*d_temp_dX+(8.0*d_temp_dX-12.0*d_xi0s_dX)*temp)*temp);
xi2s = ((((8.0*temp)-(12.0*xi0s))*temp)*temp);
if ((x_s<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(x_s);
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*(d_x_s_dX);
delta_1s = value_exp_0;
}
d_Es_dX = (-d_delta_1s_dX/delta_1s/delta_1s);
Es = (1.0/delta_1s);
d_delta_1s_dX = (delta_ns*d_delta_1s_dX+d_delta_ns_dX*delta_1s);
delta_1s = (delta_ns*delta_1s);
}
else
{
if ((x_s>(xn_s-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_s-xn_s));
double  deriv_exp_0_d0 = value_exp_0;
d_delta_1s_dX = deriv_exp_0_d0*((d_x_s_dX-d_xn_s_dX));
delta_1s = value_exp_0;
}
d_Es_dX = ((delta_1s*d_delta_ns_dX-delta_ns*d_delta_1s_dX)/delta_1s/delta_1s);
Es = (delta_ns/delta_1s);
}
else
{
d_delta_1s_dX = (-1.0e-100*(((xn_s-x_s)-2.3025850929940458e+02)*0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(d_xn_s_dX-d_x_s_dX)*3.3333333333333333e-01+(d_xn_s_dX-d_x_s_dX)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_s_dX-d_x_s_dX)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
delta_1s = (1.0e-100/(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_s-x_s)-2.3025850929940458e+02)*(1.0+(((xn_s-x_s)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Es_dX = (-1.0e-100*((x_s-2.3025850929940458e+02)*0.5*((x_s-2.3025850929940458e+02)*d_x_s_dX*3.3333333333333333e-01+d_x_s_dX*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_s_dX*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Es = (1.0e-100/(1.0+((x_s-2.3025850929940458e+02)*(1.0+(0.5*((x_s-2.3025850929940458e+02)*(1.0+((x_s-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_Ds_dX = (d_delta_1s_dX-(delta_ns*(d_x_s_dX+d_xi0s_dX)+d_delta_ns_dX*((x_s+1.0)+xi0s)));
Ds = (delta_1s-(delta_ns*((x_s+1.0)+xi0s)));
if ((x_s<1.0e-5))
{
d_Ps_dX = 0.5*((x_s*x_s)*(-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s))))+(x_s*d_x_s_dX+d_x_s_dX*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
Ps = (0.5*((x_s*x_s)*(1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s)))))));
d_Ds_dX = 1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*1.75*d_x_s_dX+(((delta_ns*x_s)*x_s)*d_x_s_dX+((delta_ns*x_s)*d_x_s_dX+(delta_ns*d_x_s_dX+d_delta_ns_dX*x_s)*x_s)*x_s)*(1.0+(1.75*x_s)));
Ds = (1.6666666666666667e-01*((((delta_ns*x_s)*x_s)*x_s)*(1.0+(1.75*x_s))));
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_s*(1.0-(0.25*x_s))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_s*(-0.25*d_x_s_dX)+d_x_s_dX*(1.0-(0.25*x_s)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_s*d_temp_dX+d_x_s_dX*temp);
sqm = (7.0710678118654746e-01*(x_s*temp));
d_alpha_dX = ((temp*((Gf*7.0710678118654746e-01)*((-0.5*d_x_s_dX)+1.6666666666666667e-01*(x_s*d_x_s_dX+d_x_s_dX*x_s))+d_Gf_dX*7.0710678118654746e-01*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))-((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))*d_temp_dX)/temp/temp);
alpha = (1.0+(((Gf*7.0710678118654746e-01)*((1.0-(0.5*x_s))+(1.6666666666666667e-01*(x_s*x_s))))/temp));
}
else
{
d_Ps_dX = (d_x_s_dX+d_Es_dX);
Ps = ((x_s-1.0)+Es);
{
double value_sqrt_0 = sqrt(Ps);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Ps_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = 0.5*((sqm*(Gf*(-d_Es_dX)+d_Gf_dX*(1.0-Es))-(Gf*(1.0-Es))*d_sqm_dX)/sqm/sqm);
alpha = (1.0+(0.5*((Gf*(1.0-Es))/sqm)));
}
d_Em_dX = d_Es_dX;
Em = Es;
d_Ed_dX = d_Em_dX;
Ed = Em;
d_Dm_dX = d_Ds_dX;
Dm = Ds;
d_Dd_dX = d_Dm_dX;
Dd = Dm;
d_Rxcor_dX = (((1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx))*((0.2*instanceStruct.instanceVar_XCOR_T)*d_Vsbx_dX+0.2*instanceStruct.d_instanceVar_XCOR_T_dX*Vsbx)-(1.0+((0.2*instanceStruct.instanceVar_XCOR_T)*Vsbx))*(instanceStruct.instanceVar_XCOR_T*d_Vsbx_dX+instanceStruct.d_instanceVar_XCOR_T_dX*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx)));
Rxcor = ((1.0+((0.2*instanceStruct.instanceVar_XCOR_T)*Vsbx))/(1.0+(instanceStruct.instanceVar_XCOR_T*Vsbx)));
if ((Ds>1.0e-100))
{
{
double value_sqrt_0 = sqrt((Ps+Ds));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgs_dX = (Gf*deriv_sqrt_0_d0*((d_Ps_dX+d_Ds_dX))+d_Gf_dX*value_sqrt_0);
xgs = (Gf*value_sqrt_0);
}
d_qis_dX = (((xgs+(Gf*sqm))*((Gf2*Ds)*d_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_xgs_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgs+(Gf*sqm))/(xgs+(Gf*sqm)));
qis = (((Gf2*Ds)*phit1)/(xgs+(Gf*sqm)));
d_qbs_dX = ((sqm*Gf)*d_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*phit1);
qbs = ((sqm*Gf)*phit1);
if ((instanceStruct.instanceVar_RSB_i<0.0))
{
d_rhob_dX = (-(-(instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
rhob = (1.0/(1.0-(instanceStruct.instanceVar_RSB_i*Vsbx)));
}
else
{
d_rhob_dX = (instanceStruct.instanceVar_RSB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_RSB_i_dX*Vsbx);
rhob = (1.0+(instanceStruct.instanceVar_RSB_i*Vsbx));
}
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qis));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qis_dX+instanceStruct.d_instanceVar_RSG_i_dX*qis)/(1.0+(instanceStruct.instanceVar_RSG_i*qis))/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qis)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qis_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qis)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qis));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qis));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*(d_qbs_dX+(instanceStruct.instanceVar_eta_mu*d_qis_dX+instanceStruct.d_instanceVar_eta_mu_dX*qis))+instanceStruct.d_instanceVar_E_eff0_dX*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
Eeffm = (instanceStruct.instanceVar_E_eff0*(qbs+(instanceStruct.instanceVar_eta_mu*qis)));
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_T),instanceStruct.instanceVar_THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_T/(Eeffm*instanceStruct.instanceVar_MUE_T)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_T))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_T_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_T)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_T_dX)))+(instanceStruct.instanceVar_CS_T*((((Ps+Ds)+1.0e-14)*d_Ps_dX-Ps*(d_Ps_dX+d_Ds_dX))/((Ps+Ds)+1.0e-14)/((Ps+Ds)+1.0e-14))+instanceStruct.d_instanceVar_CS_T_dX*(Ps/((Ps+Ds)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_T*(Ps/((Ps+Ds)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
if ((instanceStruct.instanceVar_THESATB_i<0.0))
{
d_xitsb_dX = (-(-(instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx))/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
xitsb = (1.0/(1.0-(instanceStruct.instanceVar_THESATB_i*Vsbx)));
}
else
{
d_xitsb_dX = (instanceStruct.instanceVar_THESATB_i*d_Vsbx_dX+instanceStruct.d_instanceVar_THESATB_i_dX*Vsbx);
xitsb = (1.0+(instanceStruct.instanceVar_THESATB_i*Vsbx));
}
d_temp2_dX = (qis*d_xitsb_dX+d_qis_dX*xitsb);
temp2 = (qis*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
if ((instanceStruct.instanceVar_THESATG_i<0.0))
{
d_temp_dX = (-(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1.0/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1.0+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_T*((Gmob*d_temp_dX-temp*d_Gmob_dX)/Gmob/Gmob)+instanceStruct.d_instanceVar_THESAT_T_dX*(temp/Gmob));
thesat1 = (instanceStruct.instanceVar_THESAT_T*(temp/Gmob));
d_phi_inf_dX = (((alpha*d_qis_dX-qis*d_alpha_dX)/alpha/alpha)+d_phit1_dX);
phi_inf = ((qis/alpha)+phit1);
d_ysat_dX = (thesat1*d_phi_inf_dX+d_thesat1_dX*phi_inf)*7.0710678118654746e-01;
ysat = ((thesat1*phi_inf)*7.0710678118654746e-01);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
{
double value_sqrt_0 = sqrt((1.0+ysat));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ysat_dX = ((value_sqrt_0*d_ysat_dX-ysat*deriv_sqrt_0_d0*(d_ysat_dX))/value_sqrt_0/value_sqrt_0);
ysat = (ysat/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0+(4.0*ysat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_za_dX = (-2.0*deriv_sqrt_0_d0*(4.0*d_ysat_dX)/(1.0+value_sqrt_0)/(1.0+value_sqrt_0));
za = (2.0/(1.0+value_sqrt_0));
}
d_temp1_dX = (za*d_ysat_dX+d_za_dX*ysat);
temp1 = (za*ysat);
d_Phi_0_dX = ((phi_inf*za)*0.86*(((1.0+(4.0*((temp1*temp1)*za)))*(temp1*(-(temp1*d_za_dX+d_temp1_dX*za))+d_temp1_dX*(1.0-(temp1*za)))-(temp1*(1.0-(temp1*za)))*4.0*((temp1*temp1)*d_za_dX+(temp1*d_temp1_dX+d_temp1_dX*temp1)*za))/(1.0+(4.0*((temp1*temp1)*za)))/(1.0+(4.0*((temp1*temp1)*za))))+(phi_inf*d_za_dX+d_phi_inf_dX*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
Phi_0 = ((phi_inf*za)*(1.0+(0.86*((temp1*(1.0-(temp1*za)))/(1.0+(4.0*((temp1*temp1)*za)))))));
d_asat_dX = (d_xgs_dX+0.5*d_Gf2_dX);
asat = (xgs+(0.5*Gf2));
{
double value_sqrt_0 = sqrt(((asat*asat)-((Gf2*Ds)*0.98)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_2_dX = 0.98*(((asat+value_sqrt_0)*((Gf2*Ds)*d_phit1_dX+(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*phit1)-((Gf2*Ds)*phit1)*(d_asat_dX+deriv_sqrt_0_d0*(((asat*d_asat_dX+d_asat_dX*asat)-(Gf2*d_Ds_dX+d_Gf2_dX*Ds)*0.98))))/(asat+value_sqrt_0)/(asat+value_sqrt_0));
Phi_2 = (0.98*(((Gf2*Ds)*phit1)/(asat+value_sqrt_0)));
}
d_Phi_0_2_dX = (d_Phi_0_dX+d_Phi_2_dX);
Phi_0_2 = (Phi_0+Phi_2);
d_Phi0_Phi2_dX = 2.0*(Phi_0*d_Phi_2_dX+d_Phi_0_dX*Phi_2);
Phi0_Phi2 = (2.0*(Phi_0*Phi_2));
{
double value_sqrt_0 = sqrt(((Phi_0_2*Phi_0_2)-(1.98*Phi0_Phi2)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Phi_sat_dX = (((Phi_0_2+value_sqrt_0)*d_Phi0_Phi2_dX-Phi0_Phi2*(d_Phi_0_2_dX+deriv_sqrt_0_d0*(((Phi_0_2*d_Phi_0_2_dX+d_Phi_0_2_dX*Phi_0_2)-1.98*d_Phi0_Phi2_dX))))/(Phi_0_2+value_sqrt_0)/(Phi_0_2+value_sqrt_0));
Phi_sat = (Phi0_Phi2/(Phi_0_2+value_sqrt_0));
}
{
double value_log_0 = log((1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
double  deriv_log_0_d0 = (1.0/(1.0+(((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)/((phit1*phit1)*Ds))));
d_Vdsat_dX = (d_Phi_sat_dX-(phit1*deriv_log_0_d0*(((((phit1*phit1)*Ds)*((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*d_inv_Gf2_dX+(Phi_sat*(d_Phi_sat_dX-((2.0*asat)*d_phit1_dX+2.0*d_asat_dX*phit1))+d_Phi_sat_dX*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)-((Phi_sat*(Phi_sat-((2.0*asat)*phit1)))*inv_Gf2)*((phit1*phit1)*d_Ds_dX+(phit1*d_phit1_dX+d_phit1_dX*phit1)*Ds))/((phit1*phit1)*Ds)/((phit1*phit1)*Ds)))+d_phit1_dX*value_log_0));
Vdsat = (Phi_sat-(phit1*value_log_0));
}
}
else
{
d_Vdsat_dX = d_Vdsat_lim_dX;
Vdsat = Vdsat_lim;
}
{
double value_pow_0 = pow((Vds/Vdsat),instanceStruct.instanceVar_AX_i);
double  deriv_pow_0_d0 = (((Vds/Vdsat) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_AX_i/(Vds/Vdsat)));
double  deriv_pow_0_d1 = ((Vds/Vdsat) == 0.0)?0.0:(log((Vds/Vdsat))*value_pow_0);
d_temp_dX = ((deriv_pow_0_d0*((-Vds*d_Vdsat_dX/Vdsat/Vdsat)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_AX_i_dX)));
temp = value_pow_0;
}
{
double value_pow_0 = pow((1.0+temp),(-instanceStruct.instanceVar_inv_AX));
double  deriv_pow_0_d0 = (((1.0+temp) == 0.0)?0.0:(value_pow_0*(-instanceStruct.instanceVar_inv_AX)/(1.0+temp)));
double  deriv_pow_0_d1 = ((1.0+temp) == 0.0)?0.0:(log((1.0+temp))*value_pow_0);
d_Vdse_dX = Vds*((deriv_pow_0_d0*(d_temp_dX))+(deriv_pow_0_d1*((-instanceStruct.d_instanceVar_inv_AX_dX))));
Vdse = (Vds*value_pow_0);
}
d_Udse_dX = (Vdse*d_inv_phit1_dX+d_Vdse_dX*inv_phit1);
Udse = (Vdse*inv_phit1);
d_xn_d_dX = (d_xn_s_dX+d_Udse_dX);
xn_d = (xn_s+Udse);
if ((Udse<4.6051701859880916e+02))
{
{
double value_exp_0 = exp((-Udse));
double  deriv_exp_0_d0 = value_exp_0;
d_k_ds_dX = deriv_exp_0_d0*((-d_Udse_dX));
k_ds = value_exp_0;
}
}
else
{
d_k_ds_dX = (-1.0e-200*((Udse-4.6051701859880916e+02)*0.5*((Udse-4.6051701859880916e+02)*d_Udse_dX*3.3333333333333333e-01+d_Udse_dX*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))+d_Udse_dX*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01)))))))/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
k_ds = (1.0e-200/(1.0+((Udse-4.6051701859880916e+02)*(1.0+(0.5*((Udse-4.6051701859880916e+02)*(1.0+((Udse-4.6051701859880916e+02)*3.3333333333333333e-01))))))));
}
d_delta_nd_dX = (delta_ns*d_k_ds_dX+d_delta_ns_dX*k_ds);
delta_nd = (delta_ns*k_ds);
if ((fabs(xg)<=margin))
{
d_SP_S_temp1_dX = (inv_xi*d_inv_xi_dX+d_inv_xi_dX*inv_xi)*1.6666666666666667e-01*7.0710678118654746e-01;
SP_S_temp1 = (((inv_xi*inv_xi)*1.6666666666666667e-01)*7.0710678118654746e-01);
d_x_d_dX = ((xg*inv_xi)*(((xg*(1.0-delta_nd))*Gf)*d_SP_S_temp1_dX+((xg*(1.0-delta_nd))*d_Gf_dX+(xg*(-d_delta_nd_dX)+d_xg_dX*(1.0-delta_nd))*Gf)*SP_S_temp1)+(xg*d_inv_xi_dX+d_xg_dX*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
x_d = ((xg*inv_xi)*(1.0+(((xg*(1.0-delta_nd))*Gf)*SP_S_temp1)));
}
else
{
d_SP_S_bx_dX = d_xn_d_dX;
SP_S_bx = (xn_d+3);
{
double value_sqrt_0 = sqrt((((SP_S_x1-SP_S_bx)*(SP_S_x1-SP_S_bx))+5.0));
double value_sqrt_1 = sqrt(((SP_S_bx*SP_S_bx)+5.0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_SP_S_eta_dX = (0.5*((d_SP_S_x1_dX+d_SP_S_bx_dX)-deriv_sqrt_0_d0*(((SP_S_x1-SP_S_bx)*(d_SP_S_x1_dX-d_SP_S_bx_dX)+(d_SP_S_x1_dX-d_SP_S_bx_dX)*(SP_S_x1-SP_S_bx))))-0.5*(d_SP_S_bx_dX-deriv_sqrt_1_d0*((SP_S_bx*d_SP_S_bx_dX+d_SP_S_bx_dX*SP_S_bx))));
SP_S_eta = ((0.5*((SP_S_x1+SP_S_bx)-value_sqrt_0))-(0.5*(SP_S_bx-value_sqrt_1)));
}
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_eta_dX);
SP_S_temp = (xg-SP_S_eta);
{
double value_exp_0 = exp((-SP_S_eta));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_temp1_dX = deriv_exp_0_d0*((-d_SP_S_eta_dX));
SP_S_temp1 = value_exp_0;
}
d_SP_S_temp2_dX = (-(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)/(2.0+(SP_S_eta*SP_S_eta))/(2.0+(SP_S_eta*SP_S_eta)));
SP_S_temp2 = (1.0/(2.0+(SP_S_eta*SP_S_eta)));
d_SP_S_xi0_dX = ((SP_S_eta*SP_S_eta)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_eta_dX+d_SP_S_eta_dX*SP_S_eta)*SP_S_temp2);
SP_S_xi0 = ((SP_S_eta*SP_S_eta)*SP_S_temp2);
d_SP_S_xi1_dX = 4.0*((SP_S_eta*SP_S_temp2)*d_SP_S_temp2_dX+(SP_S_eta*d_SP_S_temp2_dX+d_SP_S_eta_dX*SP_S_temp2)*SP_S_temp2);
SP_S_xi1 = (4.0*((SP_S_eta*SP_S_temp2)*SP_S_temp2));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*d_SP_S_temp2_dX+(((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*d_SP_S_temp2_dX+(8.0*d_SP_S_temp2_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp2)*SP_S_temp2);
SP_S_xi2 = ((((8.0*SP_S_temp2)-(12.0*SP_S_xi0))*SP_S_temp2)*SP_S_temp2);
{
double value_max_0 = std::max(static_cast<double>(1.0e-40),((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))));
double  deriv_max_0_d1 = ((1.0e-40>=((SP_S_temp*SP_S_temp)-(Gf2*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0))))))?0.0:1.0);
d_SP_S_a_dX = (deriv_max_0_d1*(((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*((d_SP_S_temp1_dX+d_SP_S_eta_dX)-(delta_nd*(d_SP_S_eta_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_eta+1.0)+SP_S_xi0)))+d_Gf2_dX*(((SP_S_temp1+SP_S_eta)-1.0)-(delta_nd*((SP_S_eta+1.0)+SP_S_xi0)))))));
SP_S_a = value_max_0;
}
d_SP_S_b_dX = (-0.5*(Gf2*(d_SP_S_temp1_dX-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*(SP_S_temp1-(delta_nd*SP_S_xi2))));
SP_S_b = (1.0-(0.5*(Gf2*(SP_S_temp1-(delta_nd*SP_S_xi2)))));
d_SP_S_c_dX = (2.0*d_SP_S_temp_dX+(Gf2*((-d_SP_S_temp1_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_c = ((2.0*SP_S_temp)+(Gf2*((1.0-SP_S_temp1)-(delta_nd*(1.0+SP_S_xi1)))));
{
double value_log_0 = log((SP_S_a/Gf2));
double  deriv_log_0_d0 = (1.0/(SP_S_a/Gf2));
d_SP_S_tau_dX = ((d_xn_d_dX-d_SP_S_eta_dX)+deriv_log_0_d0*(((Gf2*d_SP_S_a_dX-SP_S_a*d_Gf2_dX)/Gf2/Gf2)));
SP_S_tau = ((xn_d-SP_S_eta)+value_log_0);
}
d_nu_dX = (d_SP_S_a_dX+d_SP_S_c_dX);
nu = (SP_S_a+SP_S_c);
d_mutau_dX = ((nu*d_nu_dX+d_nu_dX*nu)+(SP_S_tau*(0.5*(SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+d_SP_S_tau_dX*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
mutau = ((nu*nu)+(SP_S_tau*((0.5*(SP_S_c*SP_S_c))-(SP_S_a*SP_S_b))));
d_SP_S_x0_dX = (d_SP_S_eta_dX+(((mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))*((SP_S_a*nu)*d_SP_S_tau_dX+(SP_S_a*d_nu_dX+d_SP_S_a_dX*nu)*SP_S_tau)-((SP_S_a*nu)*SP_S_tau)*(d_mutau_dX+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*((SP_S_c*d_SP_S_c_dX+d_SP_S_c_dX*SP_S_c)*3.3333333333333333e-01-(SP_S_a*d_SP_S_b_dX+d_SP_S_a_dX*SP_S_b))+((((nu/mutau)*SP_S_tau)*SP_S_tau)*d_SP_S_c_dX+(((nu/mutau)*SP_S_tau)*d_SP_S_tau_dX+((nu/mutau)*d_SP_S_tau_dX+((mutau*d_nu_dX-nu*d_mutau_dX)/mutau/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b)))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
SP_S_x0 = (SP_S_eta+(((SP_S_a*nu)*SP_S_tau)/(mutau+(((((nu/mutau)*SP_S_tau)*SP_S_tau)*SP_S_c)*(((SP_S_c*SP_S_c)*3.3333333333333333e-01)-(SP_S_a*SP_S_b))))));
if ((SP_S_x0<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(SP_S_x0);
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*(d_SP_S_x0_dX);
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = (-d_SP_S_delta0_dX/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (1.0/SP_S_delta0);
d_SP_S_delta0_dX = (delta_nd*d_SP_S_delta0_dX+d_delta_nd_dX*SP_S_delta0);
SP_S_delta0 = (delta_nd*SP_S_delta0);
}
else
{
if ((SP_S_x0>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((SP_S_x0-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_SP_S_delta0_dX = deriv_exp_0_d0*((d_SP_S_x0_dX-d_xn_d_dX));
SP_S_delta0 = value_exp_0;
}
d_SP_S_delta1_dX = ((SP_S_delta0*d_delta_nd_dX-delta_nd*d_SP_S_delta0_dX)/SP_S_delta0/SP_S_delta0);
SP_S_delta1 = (delta_nd/SP_S_delta0);
}
else
{
d_SP_S_delta0_dX = (-1.0e-100*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(d_xn_d_dX-d_SP_S_x0_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_SP_S_x0_dX)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta0 = (1.0e-100/(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-SP_S_x0)-2.3025850929940458e+02)*(1.0+(((xn_d-SP_S_x0)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_SP_S_delta1_dX = (-1.0e-100*((SP_S_x0-2.3025850929940458e+02)*0.5*((SP_S_x0-2.3025850929940458e+02)*d_SP_S_x0_dX*3.3333333333333333e-01+d_SP_S_x0_dX*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_SP_S_x0_dX*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
SP_S_delta1 = (1.0e-100/(1.0+((SP_S_x0-2.3025850929940458e+02)*(1.0+(0.5*((SP_S_x0-2.3025850929940458e+02)*(1.0+((SP_S_x0-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_SP_S_temp_dX = (-(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)/(2.0+(SP_S_x0*SP_S_x0))/(2.0+(SP_S_x0*SP_S_x0)));
SP_S_temp = (1.0/(2.0+(SP_S_x0*SP_S_x0)));
d_SP_S_xi0_dX = ((SP_S_x0*SP_S_x0)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_x0_dX+d_SP_S_x0_dX*SP_S_x0)*SP_S_temp);
SP_S_xi0 = ((SP_S_x0*SP_S_x0)*SP_S_temp);
d_SP_S_xi1_dX = 4.0*((SP_S_x0*SP_S_temp)*d_SP_S_temp_dX+(SP_S_x0*d_SP_S_temp_dX+d_SP_S_x0_dX*SP_S_temp)*SP_S_temp);
SP_S_xi1 = (4.0*((SP_S_x0*SP_S_temp)*SP_S_temp));
d_SP_S_xi2_dX = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*d_SP_S_temp_dX+(((8.0*SP_S_temp)-(12.0*SP_S_xi0))*d_SP_S_temp_dX+(8.0*d_SP_S_temp_dX-12.0*d_SP_S_xi0_dX)*SP_S_temp)*SP_S_temp);
SP_S_xi2 = ((((8.0*SP_S_temp)-(12.0*SP_S_xi0))*SP_S_temp)*SP_S_temp);
d_SP_S_temp_dX = (d_xg_dX-d_SP_S_x0_dX);
SP_S_temp = (xg-SP_S_x0);
d_SP_S_pC_dX = (2.0*d_SP_S_temp_dX+(Gf2*(((-d_SP_S_delta1_dX)+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi1_dX+d_delta_nd_dX*(1.0+SP_S_xi1)))+d_Gf2_dX*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
SP_S_pC = ((2.0*SP_S_temp)+(Gf2*(((1.0-SP_S_delta1)+SP_S_delta0)-(delta_nd*(1.0+SP_S_xi1)))));
d_SP_S_qC_dX = ((SP_S_temp*d_SP_S_temp_dX+d_SP_S_temp_dX*SP_S_temp)-(Gf2*(((d_SP_S_delta1_dX+d_SP_S_x0_dX)+d_SP_S_delta0_dX)-(delta_nd*(d_SP_S_x0_dX+d_SP_S_xi0_dX)+d_delta_nd_dX*((SP_S_x0+1.0)+SP_S_xi0)))+d_Gf2_dX*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
SP_S_qC = ((SP_S_temp*SP_S_temp)-(Gf2*((((SP_S_delta1+SP_S_x0)-1.0)+SP_S_delta0)-(delta_nd*((SP_S_x0+1.0)+SP_S_xi0)))));
d_SP_S_temp_dX = (-(Gf2*((d_SP_S_delta1_dX+d_SP_S_delta0_dX)-(delta_nd*d_SP_S_xi2_dX+d_delta_nd_dX*SP_S_xi2))+d_Gf2_dX*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
SP_S_temp = (2.0-(Gf2*((SP_S_delta1+SP_S_delta0)-(delta_nd*SP_S_xi2))));
d_SP_S_temp_dX = ((SP_S_pC*d_SP_S_pC_dX+d_SP_S_pC_dX*SP_S_pC)-2.0*(SP_S_qC*d_SP_S_temp_dX+d_SP_S_qC_dX*SP_S_temp));
SP_S_temp = ((SP_S_pC*SP_S_pC)-(2.0*(SP_S_qC*SP_S_temp)));
{
double value_sqrt_0 = sqrt(SP_S_temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_d_dX = (d_SP_S_x0_dX+2.0*(((SP_S_pC+value_sqrt_0)*d_SP_S_qC_dX-SP_S_qC*(d_SP_S_pC_dX+deriv_sqrt_0_d0*(d_SP_S_temp_dX)))/(SP_S_pC+value_sqrt_0)/(SP_S_pC+value_sqrt_0)));
x_d = (SP_S_x0+(2.0*(SP_S_qC/(SP_S_pC+value_sqrt_0))));
}
}
d_x_ds_dX = (d_x_d_dX-d_x_s_dX);
x_ds = (x_d-x_s);
if ((x_ds<1.0e-10))
{
d_pC_dX = (2.0*(d_xg_dX-d_x_s_dX)+(Gf2*(((-d_Es_dX)+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi1s_dX+d_delta_nd_dX*(1.0+xi1s)))+d_Gf2_dX*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
pC = ((2.0*(xg-x_s))+(Gf2*(((1.0-Es)+(delta_1s*k_ds))-(delta_nd*(1.0+xi1s)))));
d_qC_dX = ((Gf2*(1.0-k_ds))*d_Ds_dX+(Gf2*(-d_k_ds_dX)+d_Gf2_dX*(1.0-k_ds))*Ds);
qC = ((Gf2*(1.0-k_ds))*Ds);
d_temp_dX = (-(Gf2*((d_Es_dX+(delta_1s*d_k_ds_dX+d_delta_1s_dX*k_ds))-(delta_nd*d_xi2s_dX+d_delta_nd_dX*xi2s))+d_Gf2_dX*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
temp = (2.0-(Gf2*((Es+(delta_1s*k_ds))-(delta_nd*xi2s))));
d_temp_dX = ((pC*d_pC_dX+d_pC_dX*pC)-2.0*(temp*d_qC_dX+d_temp_dX*qC));
temp = ((pC*pC)-(2.0*(temp*qC)));
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_x_ds_dX = 2.0*(((pC+value_sqrt_0)*d_qC_dX-qC*(d_pC_dX+deriv_sqrt_0_d0*(d_temp_dX)))/(pC+value_sqrt_0)/(pC+value_sqrt_0));
x_ds = (2.0*(qC/(pC+value_sqrt_0)));
}
d_x_d_dX = (d_x_s_dX+d_x_ds_dX);
x_d = (x_s+x_ds);
}
d_dps_dX = (x_ds*d_phit1_dX+d_x_ds_dX*phit1);
dps = (x_ds*phit1);
d_xi0d_dX = (((2.0+(x_d*x_d))*(x_d*d_x_d_dX+d_x_d_dX*x_d)-(x_d*x_d)*(x_d*d_x_d_dX+d_x_d_dX*x_d))/(2.0+(x_d*x_d))/(2.0+(x_d*x_d)));
xi0d = ((x_d*x_d)/(2.0+(x_d*x_d)));
if ((x_d<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((-x_d));
double  deriv_exp_0_d0 = value_exp_0;
d_Ed_dX = deriv_exp_0_d0*((-d_x_d_dX));
Ed = value_exp_0;
}
if ((x_d<1.0e-5))
{
d_Dd_dX = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*1.75*d_x_d_dX+((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*d_x_d_dX+(((1.6666666666666667e-01*delta_nd)*x_d)*d_x_d_dX+((1.6666666666666667e-01*delta_nd)*d_x_d_dX+1.6666666666666667e-01*d_delta_nd_dX*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
Dd = (((((1.6666666666666667e-01*delta_nd)*x_d)*x_d)*x_d)*(1.0+(1.75*x_d)));
}
else
{
d_Dd_dX = (delta_nd*(((-d_Ed_dX/Ed/Ed)-d_x_d_dX)-d_xi0d_dX)+d_delta_nd_dX*((((1.0/Ed)-x_d)-1.0)-xi0d));
Dd = (delta_nd*((((1.0/Ed)-x_d)-1.0)-xi0d));
}
}
else
{
if ((x_d>(xn_d-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp((x_d-xn_d));
double  deriv_exp_0_d0 = value_exp_0;
d_temp_dX = deriv_exp_0_d0*((d_x_d_dX-d_xn_d_dX));
temp = value_exp_0;
}
d_Ed_dX = ((temp*d_delta_nd_dX-delta_nd*d_temp_dX)/temp/temp);
Ed = (delta_nd/temp);
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
else
{
d_Ed_dX = (-1.0e-100*((x_d-2.3025850929940458e+02)*0.5*((x_d-2.3025850929940458e+02)*d_x_d_dX*3.3333333333333333e-01+d_x_d_dX*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))+d_x_d_dX*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
Ed = (1.0e-100/(1.0+((x_d-2.3025850929940458e+02)*(1.0+(0.5*((x_d-2.3025850929940458e+02)*(1.0+((x_d-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_temp_dX = (-1.0e-100*(((xn_d-x_d)-2.3025850929940458e+02)*0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(d_xn_d_dX-d_x_d_dX)*3.3333333333333333e-01+(d_xn_d_dX-d_x_d_dX)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))+(d_xn_d_dX-d_x_d_dX)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01)))))))/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
temp = (1.0e-100/(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(0.5*(((xn_d-x_d)-2.3025850929940458e+02)*(1.0+(((xn_d-x_d)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
d_Dd_dX = (d_temp_dX-(delta_nd*(d_x_d_dX+d_xi0d_dX)+d_delta_nd_dX*((x_d+1.0)+xi0d)));
Dd = (temp-(delta_nd*((x_d+1.0)+xi0d)));
}
}
d_x_m_dX = 0.5*(d_x_s_dX+d_x_d_dX);
x_m = (0.5*(x_s+x_d));
d_Em_dX = 0.0;
Em = 0.0;
d_temp_dX = (Ed*d_Es_dX+d_Ed_dX*Es);
temp = (Ed*Es);
if ((temp>0.0))
{
{
double value_sqrt_0 = sqrt(temp);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Em_dX = deriv_sqrt_0_d0*(d_temp_dX);
Em = value_sqrt_0;
}
}
d_D_bar_dX = 0.5*(d_Ds_dX+d_Dd_dX);
D_bar = (0.5*(Ds+Dd));
d_Dm_dX = (d_D_bar_dX+0.125*((x_ds*x_ds)*(d_Em_dX-2.0*d_inv_Gf2_dX)+(x_ds*d_x_ds_dX+d_x_ds_dX*x_ds)*(Em-(2.0*inv_Gf2))));
Dm = (D_bar+(0.125*((x_ds*x_ds)*(Em-(2.0*inv_Gf2)))));
if ((x_m<1.0e-5))
{
d_Pm_dX = 0.5*((x_m*x_m)*(-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m))))+(x_m*d_x_m_dX+d_x_m_dX*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
Pm = (0.5*((x_m*x_m)*(1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m)))))));
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
}
{
double value_sqrt_0 = sqrt((1.0-(3.3333333333333333e-01*(x_m*(1.0-(0.25*x_m))))));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_temp_dX = deriv_sqrt_0_d0*((-3.3333333333333333e-01*(x_m*(-0.25*d_x_m_dX)+d_x_m_dX*(1.0-(0.25*x_m)))));
temp = value_sqrt_0;
}
d_sqm_dX = 7.0710678118654746e-01*(x_m*d_temp_dX+d_x_m_dX*temp);
sqm = (7.0710678118654746e-01*(x_m*temp));
d_alpha_dX = (d_eta_p_dX+7.0710678118654746e-01*((temp*(Gf*((-0.5*d_x_m_dX)+1.6666666666666667e-01*(x_m*d_x_m_dX+d_x_m_dX*x_m))+d_Gf_dX*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))-(Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))*d_temp_dX)/temp/temp));
alpha = (eta_p+(7.0710678118654746e-01*((Gf*((1.0-(0.5*x_m))+(1.6666666666666667e-01*(x_m*x_m))))/temp)));
}
else
{
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
if ((instanceStruct.instanceVar_kp>0.0))
{
d_d0_dX = ((-d_Em_dX)+2.0*(xgm*d_inv_Gf2_dX+d_xgm_dX*inv_Gf2));
d0 = ((1.0-Em)+(2.0*(xgm*inv_Gf2)));
{
double value_sqrt_0 = sqrt((1.0+(instanceStruct.instanceVar_kp*xgm)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_eta_p_dX = (-deriv_sqrt_0_d0*((instanceStruct.instanceVar_kp*d_xgm_dX+instanceStruct.d_instanceVar_kp_dX*xgm))/value_sqrt_0/value_sqrt_0);
eta_p = (1.0/value_sqrt_0);
}
d_temp_dX = (((eta_p+1.0)*d_eta_p_dX-eta_p*d_eta_p_dX)/(eta_p+1.0)/(eta_p+1.0));
temp = (eta_p/(eta_p+1.0));
d_x_pm_dX = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*d_Dm_dX+((temp*temp)*d_Gf2_dX+(temp*d_temp_dX+d_temp_dX*temp)*Gf2)*Dm)+instanceStruct.d_instanceVar_kp_dX*(((temp*temp)*Gf2)*Dm));
x_pm = (instanceStruct.instanceVar_kp*(((temp*temp)*Gf2)*Dm));
d_p_pd_dX = (2.0*(d_xgm_dX-d_x_pm_dX)+(Gf2*((-d_Em_dX)+d_Dm_dX)+d_Gf2_dX*((1.0-Em)+Dm)));
p_pd = ((2.0*(xgm-x_pm))+(Gf2*((1.0-Em)+Dm)));
d_q_pd_dX = (x_pm*(d_x_pm_dX-2.0*d_xgm_dX)+d_x_pm_dX*(x_pm-(2.0*xgm)));
q_pd = (x_pm*(x_pm-(2.0*xgm)));
d_xi_pd_dX = (-0.5*(Gf2*(d_Em_dX+d_Dm_dX)+d_Gf2_dX*(Em+Dm)));
xi_pd = (1.0-(0.5*(Gf2*(Em+Dm))));
d_u_pd_dX = ((((p_pd*p_pd)-(xi_pd*q_pd))*(q_pd*d_p_pd_dX+d_q_pd_dX*p_pd)-(q_pd*p_pd)*((p_pd*d_p_pd_dX+d_p_pd_dX*p_pd)-(xi_pd*d_q_pd_dX+d_xi_pd_dX*q_pd)))/((p_pd*p_pd)-(xi_pd*q_pd))/((p_pd*p_pd)-(xi_pd*q_pd)));
u_pd = ((q_pd*p_pd)/((p_pd*p_pd)-(xi_pd*q_pd)));
d_x_m_dX = (d_x_m_dX+d_u_pd_dX);
x_m = (x_m+u_pd);
{
double value_exp_0 = exp(u_pd);
double  deriv_exp_0_d0 = value_exp_0;
d_km_dX = deriv_exp_0_d0*(d_u_pd_dX);
km = value_exp_0;
}
d_Em_dX = ((km*d_Em_dX-Em*d_km_dX)/km/km);
Em = (Em/km);
d_Dm_dX = (Dm*d_km_dX+d_Dm_dX*km);
Dm = (Dm*km);
d_Pm_dX = (d_x_m_dX+d_Em_dX);
Pm = ((x_m-1.0)+Em);
{
double value_sqrt_0 = sqrt((Dm+Pm));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_xgm_dX = (Gf*deriv_sqrt_0_d0*((d_Dm_dX+d_Pm_dX))+d_Gf_dX*value_sqrt_0);
xgm = (Gf*value_sqrt_0);
}
d_km0_dX = ((-d_Em_dX)+2.0*((xgm*eta_p)*d_inv_Gf2_dX+(xgm*d_eta_p_dX+d_xgm_dX*eta_p)*inv_Gf2));
km0 = ((1.0-Em)+(2.0*((xgm*eta_p)*inv_Gf2)));
d_x_ds_dX = (((km0+(km*D_bar))*((x_ds*km)*(d_d0_dX+d_D_bar_dX)+(x_ds*d_km_dX+d_x_ds_dX*km)*(d0+D_bar))-((x_ds*km)*(d0+D_bar))*(d_km0_dX+(km*d_D_bar_dX+d_km_dX*D_bar)))/(km0+(km*D_bar))/(km0+(km*D_bar)));
x_ds = (((x_ds*km)*(d0+D_bar))/(km0+(km*D_bar)));
d_dps_dX = (x_ds*d_phit1_dX+d_x_ds_dX*phit1);
dps = (x_ds*phit1);
}
{
double value_sqrt_0 = sqrt(Pm);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqm_dX = deriv_sqrt_0_d0*(d_Pm_dX);
sqm = value_sqrt_0;
}
d_alpha_dX = (d_eta_p_dX+0.5*((sqm*(Gf*(-d_Em_dX)+d_Gf_dX*(1.0-Em))-(Gf*(1.0-Em))*d_sqm_dX)/sqm/sqm));
alpha = (eta_p+(0.5*((Gf*(1.0-Em))/sqm)));
}
d_qim_dX = (phit1*(((xgm+(Gf*sqm))*(Gf2*d_Dm_dX+d_Gf2_dX*Dm)-(Gf2*Dm)*(d_xgm_dX+(Gf*d_sqm_dX+d_Gf_dX*sqm)))/(xgm+(Gf*sqm))/(xgm+(Gf*sqm)))+d_phit1_dX*((Gf2*Dm)/(xgm+(Gf*sqm))));
qim = (phit1*((Gf2*Dm)/(xgm+(Gf*sqm))));
d_qim1_dX = (d_qim_dX+(phit1*d_alpha_dX+d_phit1_dX*alpha));
qim1 = (qim+(phit1*alpha));
d_qbm_dX = ((sqm*Gf)*d_phit1_dX+(sqm*d_Gf_dX+d_sqm_dX*Gf)*phit1);
qbm = ((sqm*Gf)*phit1);
if ((instanceStruct.instanceVar_RSG_i<0.0))
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim));
temp = (1.0-(instanceStruct.instanceVar_RSG_i*qim));
}
else
{
d_temp_dX = (-(instanceStruct.instanceVar_RSG_i*d_qim_dX+instanceStruct.d_instanceVar_RSG_i_dX*qim)/(1.0+(instanceStruct.instanceVar_RSG_i*qim))/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
temp = (1.0/(1.0+(instanceStruct.instanceVar_RSG_i*qim)));
}
d_GR_dX = (instanceStruct.instanceVar_THER_i*((rhob*temp)*d_qim_dX+(rhob*d_temp_dX+d_rhob_dX*temp)*qim)+instanceStruct.d_instanceVar_THER_i_dX*((rhob*temp)*qim));
GR = (instanceStruct.instanceVar_THER_i*((rhob*temp)*qim));
d_qeff_dX = (d_qbm_dX+(instanceStruct.instanceVar_eta_mu*d_qim_dX+instanceStruct.d_instanceVar_eta_mu_dX*qim));
qeff = (qbm+(instanceStruct.instanceVar_eta_mu*qim));
d_qeff1_dX = (d_qbm_dX+instanceStruct.instanceVar_eta_mu1*d_qim_dX);
qeff1 = (qbm+(instanceStruct.instanceVar_eta_mu1*qim));
d_Eeffm_dX = (instanceStruct.instanceVar_E_eff0*d_qeff_dX+instanceStruct.d_instanceVar_E_eff0_dX*qeff);
Eeffm = (instanceStruct.instanceVar_E_eff0*qeff);
{
double value_pow_0 = pow((Eeffm*instanceStruct.instanceVar_MUE_T),instanceStruct.instanceVar_THEMU_T);
double  deriv_pow_0_d0 = (((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(value_pow_0*instanceStruct.instanceVar_THEMU_T/(Eeffm*instanceStruct.instanceVar_MUE_T)));
double  deriv_pow_0_d1 = ((Eeffm*instanceStruct.instanceVar_MUE_T) == 0.0)?0.0:(log((Eeffm*instanceStruct.instanceVar_MUE_T))*value_pow_0);
d_Mutmp_dX = (((deriv_pow_0_d0*((Eeffm*instanceStruct.d_instanceVar_MUE_T_dX+d_Eeffm_dX*instanceStruct.instanceVar_MUE_T)))+(deriv_pow_0_d1*(instanceStruct.d_instanceVar_THEMU_T_dX)))+(instanceStruct.instanceVar_CS_T*((((Pm+Dm)+1.0e-14)*d_Pm_dX-Pm*(d_Pm_dX+d_Dm_dX))/((Pm+Dm)+1.0e-14)/((Pm+Dm)+1.0e-14))+instanceStruct.d_instanceVar_CS_T_dX*(Pm/((Pm+Dm)+1.0e-14))));
Mutmp = (value_pow_0+(instanceStruct.instanceVar_CS_T*(Pm/((Pm+Dm)+1.0e-14))));
}
d_Gmob_dX = (((1.0+Mutmp)+GR)*d_Rxcor_dX+(d_Mutmp_dX+d_GR_dX)*Rxcor);
Gmob = (((1.0+Mutmp)+GR)*Rxcor);
{
double value_log_0 = log(((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
double  deriv_log_0_d0 = (1.0/((1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
d_s1_dX = deriv_log_0_d0*((((1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))*((Vds-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(-d_dps_dX)*instanceStruct.instanceVar_inv_VP)-(1.0+((Vds-dps)*instanceStruct.instanceVar_inv_VP))*((Vdse-dps)*instanceStruct.d_instanceVar_inv_VP_dX+(d_Vdse_dX-d_dps_dX)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))/(1.0+((Vdse-dps)*instanceStruct.instanceVar_inv_VP))));
s1 = value_log_0;
}
d_dL_dX = (instanceStruct.instanceVar_ALP_i*d_s1_dX+instanceStruct.d_instanceVar_ALP_i_dX*s1);
dL = (instanceStruct.instanceVar_ALP_i*s1);
d_GdL_dX = (-(d_dL_dX+(dL*d_dL_dX+d_dL_dX*dL))/((1.0+dL)+(dL*dL))/((1.0+dL)+(dL*dL)));
GdL = (1.0/((1.0+dL)+(dL*dL)));
d_temp2_dX = (qim*d_xitsb_dX+d_qim_dX*xitsb);
temp2 = (qim*xitsb);
d_wsat_dX = 100.0*(((100.0+temp2)*d_temp2_dX-temp2*d_temp2_dX)/(100.0+temp2)/(100.0+temp2));
wsat = (100.0*(temp2/(100.0+temp2)));
d_Gmob_dL_dX = (Gmob*d_GdL_dX+d_Gmob_dX*GdL);
Gmob_dL = (Gmob*GdL);
if ((instanceStruct.instanceVar_THESATG_i<0.0))
{
d_temp_dX = (-(-(instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
temp = (1.0/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat)));
}
else
{
d_temp_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat);
temp = (1.0+(instanceStruct.instanceVar_THESATG_i*wsat));
}
d_thesat1_dX = (instanceStruct.instanceVar_THESAT_T*((Gmob_dL*d_temp_dX-temp*d_Gmob_dL_dX)/Gmob_dL/Gmob_dL)+instanceStruct.d_instanceVar_THESAT_T_dX*(temp/Gmob_dL));
thesat1 = (instanceStruct.instanceVar_THESAT_T*(temp/Gmob_dL));
d_zsat_dX = (((thesat1*thesat1)*dps)*d_dps_dX+((thesat1*thesat1)*d_dps_dX+(thesat1*d_thesat1_dX+d_thesat1_dX*thesat1)*dps)*dps);
zsat = (((thesat1*thesat1)*dps)*dps);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
d_zsat_dX = (((1.0+(thesat1*dps))*d_zsat_dX-zsat*(thesat1*d_dps_dX+d_thesat1_dX*dps))/(1.0+(thesat1*dps))/(1.0+(thesat1*dps)));
zsat = (zsat/(1.0+(thesat1*dps)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gvsat_dX = 0.5*(Gmob_dL*deriv_sqrt_0_d0*(2.0*d_zsat_dX)+d_Gmob_dL_dX*(1.0+value_sqrt_0));
Gvsat = (0.5*(Gmob_dL*(1.0+value_sqrt_0)));
}
d_Gvsatinv_dX = (-d_Gvsat_dX/Gvsat/Gvsat);
Gvsatinv = (1.0/Gvsat);
d_Voxm_dX = (xgm*d_phit1_dX+d_xgm_dX*phit1);
Voxm = (xgm*phit1);
d_temp_dX = (Gmob_dL*d_Gvsatinv_dX+d_Gmob_dL_dX*Gvsatinv);
temp = (Gmob_dL*Gvsatinv);
d_alpha1_dX = (alpha*0.5*((zsat*temp)*d_temp_dX+(zsat*d_temp_dX+d_zsat_dX*temp)*temp)+d_alpha_dX*(1.0+(0.5*((zsat*temp)*temp))));
alpha1 = (alpha*(1.0+(0.5*((zsat*temp)*temp))));
d_H_dX = ((alpha1*(temp*d_qim1_dX+d_temp_dX*qim1)-(temp*qim1)*d_alpha1_dX)/alpha1/alpha1);
H = ((temp*qim1)/alpha1);
}
d_xg_ac_dX = d_xg_dX;
xg_ac = xg;
d_qeff1_ac_dX = d_qeff1_dX;
qeff1_ac = qeff1;
d_Voxm_ac_dX = d_Voxm_dX;
Voxm_ac = Voxm;
d_alpha_ac_dX = d_alpha_dX;
alpha_ac = alpha;
d_dps_ac_dX = d_dps_dX;
dps_ac = dps;
d_qim_ac_dX = d_qim_dX;
qim_ac = qim;
d_GdL_ac_dX = d_GdL_dX;
GdL_ac = GdL;
d_H_ac_dX = d_H_dX;
H_ac = H;
d_eta_p_ac_dX = d_eta_p_dX;
eta_p_ac = eta_p;
d_Gvsat_ac_dX = d_Gvsat_dX;
Gvsat_ac = Gvsat;
d_Gmob_dL_ac_dX = d_Gmob_dL_dX;
Gmob_dL_ac = Gmob_dL;
}
else
{
d_xg_ac_dX = d_xg_dc_dX;
xg_ac = xg_dc;
d_qeff1_ac_dX = d_qeff1_dc_dX;
qeff1_ac = qeff1_dc;
d_Voxm_ac_dX = d_Voxm_dc_dX;
Voxm_ac = Voxm_dc;
d_alpha_ac_dX = d_alpha_dc_dX;
alpha_ac = alpha_dc;
d_dps_ac_dX = d_dps_dc_dX;
dps_ac = dps_dc;
d_qim_ac_dX = d_qim_dc_dX;
qim_ac = qim_dc;
d_GdL_ac_dX = d_GdL_dc_dX;
GdL_ac = GdL_dc;
d_H_ac_dX = d_H_dc_dX;
H_ac = H_dc;
d_eta_p_ac_dX = d_eta_p_dc_dX;
eta_p_ac = eta_p_dc;
d_Gvsat_ac_dX = d_Gvsat_dc_dX;
Gvsat_ac = Gvsat_dc;
d_Gmob_dL_ac_dX = d_Gmob_dL_dc_dX;
Gmob_dL_ac = Gmob_dL_dc;
}
}
// End block SPcalc_ac
Vgb = (Vgs+Vsb);
d_COX_qm_dX = instanceStruct.d_instanceVar_COX_i_dX;
COX_qm = instanceStruct.instanceVar_COX_i;
if ((instanceStruct.instanceVar_qq>0.0))
{
{
double value_pow_0 = pow(((qeff1_ac*qeff1_ac)+instanceStruct.instanceVar_qlim2),((-1.0)*1.6666666666666667e-01));
double  deriv_pow_0_d0 = ((((qeff1_ac*qeff1_ac)+instanceStruct.instanceVar_qlim2) == 0.0)?0.0:(value_pow_0*((-1.0)*1.6666666666666667e-01)/((qeff1_ac*qeff1_ac)+instanceStruct.instanceVar_qlim2)));
d_COX_qm_dX = (((1.0+(instanceStruct.instanceVar_qq*value_pow_0))*instanceStruct.d_instanceVar_COX_i_dX-instanceStruct.instanceVar_COX_i*(instanceStruct.instanceVar_qq*(deriv_pow_0_d0*(((qeff1_ac*d_qeff1_ac_dX+d_qeff1_ac_dX*qeff1_ac)+instanceStruct.d_instanceVar_qlim2_dX)))+instanceStruct.d_instanceVar_qq_dX*value_pow_0))/(1.0+(instanceStruct.instanceVar_qq*value_pow_0))/(1.0+(instanceStruct.instanceVar_qq*value_pow_0)));
COX_qm = (instanceStruct.instanceVar_COX_i/(1.0+(instanceStruct.instanceVar_qq*value_pow_0)));
}
}
if ((xg_ac<=0.0))
{
d_QG_dX = d_Voxm_ac_dX;
QG = Voxm_ac;
d_QI_dX = 0.0;
QI = 0.0;
d_QD_dX = 0.0;
QD = 0.0;
d_QB_dX = d_QG_dX;
QB = QG;
}
else
{
d_Fj_dX = 0.5*((H_ac*d_dps_ac_dX-dps_ac*d_H_ac_dX)/H_ac/H_ac);
Fj = (0.5*(dps_ac/H_ac));
d_Fj2_dX = (Fj*d_Fj_dX+d_Fj_dX*Fj);
Fj2 = (Fj*Fj);
d_QCLM_dX = ((1.0-GdL_ac)*(d_qim_ac_dX-0.5*(alpha_ac*d_dps_ac_dX+d_alpha_ac_dX*dps_ac))+(-d_GdL_ac_dX)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
QCLM = ((1.0-GdL_ac)*(qim_ac-(0.5*(alpha_ac*dps_ac))));
d_QG_dX = (d_Voxm_ac_dX+0.5*((eta_p_ac*dps_ac)*((Fj*d_GdL_ac_dX+d_Fj_dX*GdL_ac)*3.3333333333333333e-01+d_GdL_ac_dX)+(eta_p_ac*d_dps_ac_dX+d_eta_p_ac_dX*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac)));
QG = (Voxm_ac+(0.5*((eta_p_ac*dps_ac)*((((Fj*GdL_ac)*3.3333333333333333e-01)-1.0)+GdL_ac))));
d_temp_dX = (alpha_ac*d_dps_ac_dX+d_alpha_ac_dX*dps_ac)*1.6666666666666667e-01;
temp = ((alpha_ac*dps_ac)*1.6666666666666667e-01);
d_QI_dX = ((GdL_ac*(d_qim_ac_dX+(temp*d_Fj_dX+d_temp_dX*Fj))+d_GdL_ac_dX*(qim_ac+(temp*Fj)))+d_QCLM_dX);
QI = ((GdL_ac*(qim_ac+(temp*Fj)))+QCLM);
d_QD_dX = 0.5*(((GdL_ac*GdL_ac)*(d_qim_ac_dX-(temp*((-d_Fj_dX)-0.2*d_Fj2_dX)+d_temp_dX*((1.0-Fj)-(0.2*Fj2))))+(GdL_ac*d_GdL_ac_dX+d_GdL_ac_dX*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*d_GdL_ac_dX+d_QCLM_dX*(1.0+GdL_ac)));
QD = (0.5*(((GdL_ac*GdL_ac)*(qim_ac-(temp*((1.0-Fj)-(0.2*Fj2)))))+(QCLM*(1.0+GdL_ac))));
d_QB_dX = (d_QG_dX-d_QI_dX);
QB = (QG-QI);
}
d_Qg_dX = (QG*d_COX_qm_dX+d_QG_dX*COX_qm);
Qg = (QG*COX_qm);
d_Qd_dX = ((-QD)*d_COX_qm_dX+(-d_QD_dX)*COX_qm);
Qd = ((-QD)*COX_qm);
d_Qb_dX = ((-QB)*d_COX_qm_dX+(-d_QB_dX)*COX_qm);
Qb = ((-QB)*COX_qm);
d_Qgs_ov_dX = (instanceStruct.instanceVar_CGOV_i*d_Vovs_dX+instanceStruct.d_instanceVar_CGOV_i_dX*Vovs);
Qgs_ov = (instanceStruct.instanceVar_CGOV_i*Vovs);
d_Qgd_ov_dX = (instanceStruct.instanceVar_CGOVD_i*d_Vovd_dX+instanceStruct.d_instanceVar_CGOVD_i_dX*Vovd);
Qgd_ov = (instanceStruct.instanceVar_CGOVD_i*Vovd);
d_Qgb_ov_dX = instanceStruct.d_instanceVar_CGBOV_i_dX*Vgb;
Qgb_ov = (instanceStruct.instanceVar_CGBOV_i*Vgb);
d_Qfgs_dX = instanceStruct.d_instanceVar_CFR_i_dX*VgsPrime;
Qfgs = (instanceStruct.instanceVar_CFR_i*VgsPrime);
d_Qfgd_dX = instanceStruct.d_instanceVar_CFRD_i_dX*VgdPrime;
Qfgd = (instanceStruct.instanceVar_CFRD_i*VgdPrime);
}
// End block evaluateDynamic
//Begin block evaluateStaticDynamic
{
d_ijun_s_dX = 0.0;
ijun_s = 0.0;
d_ijunbot_s_dX = 0.0;
ijunbot_s = 0.0;
d_ijunsti_s_dX = 0.0;
ijunsti_s = 0.0;
d_ijungat_s_dX = 0.0;
ijungat_s = 0.0;
d_ijun_d_dX = 0.0;
ijun_d = 0.0;
d_ijunbot_d_dX = 0.0;
ijunbot_d = 0.0;
d_ijunsti_d_dX = 0.0;
ijunsti_d = 0.0;
d_ijungat_d_dX = 0.0;
ijungat_d = 0.0;
d_qjun_s_dX = 0.0;
qjun_s = 0.0;
d_qjunbot_s_dX = 0.0;
qjunbot_s = 0.0;
d_qjunsti_s_dX = 0.0;
qjunsti_s = 0.0;
d_qjungat_s_dX = 0.0;
qjungat_s = 0.0;
d_qjun_d_dX = 0.0;
qjun_d = 0.0;
d_qjunbot_d_dX = 0.0;
qjunbot_d = 0.0;
d_qjunsti_d_dX = 0.0;
qjunsti_d = 0.0;
d_qjungat_d_dX = 0.0;
qjungat_d = 0.0;
if ((modelStruct.modelVar_SWJUNCAP_i>0))
{
if ((modelStruct.modelVar_SWJUNEXP_i==1))
{
d_tm0_dX = Vjun_s*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_s;
tm0 = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf1_s)?(instanceStruct.instanceVar_expxhf1_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf1_s_dX)+instanceStruct.d_instanceVar_expxhf1_s_dX*((tm0-instanceStruct.instanceVar_xhighf1_s)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf1_s)?(instanceStruct.instanceVar_expxhf1_s*((tm0-instanceStruct.instanceVar_xhighf1_s)+1.0)):value_exp_0));
}
d_ijunfor1_dX = (instanceStruct.instanceVar_ISATFOR1_s*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR1_s_dX*(tm1-1.0));
ijunfor1 = (instanceStruct.instanceVar_ISATFOR1_s*(tm1-1.0));
d_tm0_dX = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_s_dX+Vjun_s*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_s);
tm0 = ((Vjun_s*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf2_s)?(instanceStruct.instanceVar_expxhf2_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf2_s_dX)+instanceStruct.d_instanceVar_expxhf2_s_dX*((tm0-instanceStruct.instanceVar_xhighf2_s)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf2_s)?(instanceStruct.instanceVar_expxhf2_s*((tm0-instanceStruct.instanceVar_xhighf2_s)+1.0)):value_exp_0));
}
d_ijunfor2_dX = (instanceStruct.instanceVar_ISATFOR2_s*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR2_s_dX*(tm1-1.0));
ijunfor2 = (instanceStruct.instanceVar_ISATFOR2_s*(tm1-1.0));
d_ijunrev_dX = 0.0;
ijunrev = 0.0;
if ((instanceStruct.instanceVar_m0flag_s>0.0))
{
d_ijunrev_dX = Vjun_s*(instanceStruct.d_instanceVar_ISATREV_s_dX+Vjun_s*instanceStruct.d_instanceVar_MREV_s_dX);
ijunrev = (Vjun_s*(instanceStruct.instanceVar_ISATREV_s+(Vjun_s*instanceStruct.instanceVar_MREV_s)));
}
else
{
d_tm0_dX = (((-Vjun_s)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_s_dX+(-Vjun_s)*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_s);
tm0 = (((-Vjun_s)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_s);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighr_s)?(instanceStruct.instanceVar_expxhr_s*(d_tm0_dX-instanceStruct.d_instanceVar_xhighr_s_dX)+instanceStruct.d_instanceVar_expxhr_s_dX*((tm0-instanceStruct.instanceVar_xhighr_s)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighr_s)?(instanceStruct.instanceVar_expxhr_s*((tm0-instanceStruct.instanceVar_xhighr_s)+1.0)):value_exp_0));
}
d_ijunrev_dX = ((-instanceStruct.instanceVar_ISATREV_s)*d_tm1_dX+(-instanceStruct.d_instanceVar_ISATREV_s_dX)*(tm1-1.0));
ijunrev = ((-instanceStruct.instanceVar_ISATREV_s)*(tm1-1.0));
}
d_ijun_s_dX = ((d_ijunfor1_dX+d_ijunfor2_dX)+d_ijunrev_dX);
ijun_s = ((ijunfor1+ijunfor2)+ijunrev);
d_tm0_dX = Vjun_d*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR1_d;
tm0 = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR1_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf1_d)?(instanceStruct.instanceVar_expxhf1_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf1_d_dX)+instanceStruct.d_instanceVar_expxhf1_d_dX*((tm0-instanceStruct.instanceVar_xhighf1_d)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf1_d)?(instanceStruct.instanceVar_expxhf1_d*((tm0-instanceStruct.instanceVar_xhighf1_d)+1.0)):value_exp_0));
}
d_ijunfor1_dX = (instanceStruct.instanceVar_ISATFOR1_d*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR1_d_dX*(tm1-1.0));
ijunfor1 = (instanceStruct.instanceVar_ISATFOR1_d*(tm1-1.0));
d_tm0_dX = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MFOR2_d_dX+Vjun_d*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MFOR2_d);
tm0 = ((Vjun_d*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MFOR2_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf2_d)?(instanceStruct.instanceVar_expxhf2_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighf2_d_dX)+instanceStruct.d_instanceVar_expxhf2_d_dX*((tm0-instanceStruct.instanceVar_xhighf2_d)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighf2_d)?(instanceStruct.instanceVar_expxhf2_d*((tm0-instanceStruct.instanceVar_xhighf2_d)+1.0)):value_exp_0));
}
d_ijunfor2_dX = (instanceStruct.instanceVar_ISATFOR2_d*d_tm1_dX+instanceStruct.d_instanceVar_ISATFOR2_d_dX*(tm1-1.0));
ijunfor2 = (instanceStruct.instanceVar_ISATFOR2_d*(tm1-1.0));
d_ijunrev_dX = 0.0;
ijunrev = 0.0;
if ((instanceStruct.instanceVar_m0flag_d>0.0))
{
d_ijunrev_dX = Vjun_d*(instanceStruct.d_instanceVar_ISATREV_d_dX+Vjun_d*instanceStruct.d_instanceVar_MREV_d_dX);
ijunrev = (Vjun_d*(instanceStruct.instanceVar_ISATREV_d+(Vjun_d*instanceStruct.instanceVar_MREV_d)));
}
else
{
d_tm0_dX = (((-Vjun_d)*modelStruct.modelVar_phitdinv)*instanceStruct.d_instanceVar_MREV_d_dX+(-Vjun_d)*modelStruct.d_modelVar_phitdinv_dX*instanceStruct.instanceVar_MREV_d);
tm0 = (((-Vjun_d)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_MREV_d);
{
double value_exp_0 = exp(tm0);
double  deriv_exp_0_d0 = value_exp_0;
d_tm1_dX = ((tm0<(-2.3025850929940458e+02))?(-1.0e-100*(-d_tm0_dX)/(((-2.3025850929940458e+02)-tm0)+1.0)/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighr_d)?(instanceStruct.instanceVar_expxhr_d*(d_tm0_dX-instanceStruct.d_instanceVar_xhighr_d_dX)+instanceStruct.d_instanceVar_expxhr_d_dX*((tm0-instanceStruct.instanceVar_xhighr_d)+1.0)):deriv_exp_0_d0*(d_tm0_dX)));
tm1 = ((tm0<(-2.3025850929940458e+02))?(1.0e-100/(((-2.3025850929940458e+02)-tm0)+1.0)):((tm0>instanceStruct.instanceVar_xhighr_d)?(instanceStruct.instanceVar_expxhr_d*((tm0-instanceStruct.instanceVar_xhighr_d)+1.0)):value_exp_0));
}
d_ijunrev_dX = ((-instanceStruct.instanceVar_ISATREV_d)*d_tm1_dX+(-instanceStruct.d_instanceVar_ISATREV_d_dX)*(tm1-1.0));
ijunrev = ((-instanceStruct.instanceVar_ISATREV_d)*(tm1-1.0));
}
d_ijun_d_dX = ((d_ijunfor1_dX+d_ijunfor2_dX)+d_ijunrev_dX);
ijun_d = ((ijunfor1+ijunfor2)+ijunrev);
//Begin block evaluateDynamic
{
//Block-local variables for block evaluateDynamic
double tmpv=0.0;
double d_tmpv_dX=0.0;
double vjv=0.0;
double d_vjv_dX=0.0;
//End of Block-local variables
d_tmpv_dX = 0.0;
tmpv = 0.0;
d_vjv_dX = 0.0;
vjv = 0.0;
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (Vjun_s+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vjv_dX = 2.0*(((h3+h5)*Vjun_s*instanceStruct.d_instanceVar_vfmin_s_dX-(Vjun_s*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_s*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((instanceStruct.instanceVar_zflagbot_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vjv*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmpv = value_pow_0;
}
}
d_qjunbot_s_dX = ((modelStruct.modelVar_qprefbot*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2bot*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2bot_dX*(Vjun_s-vjv)));
qjunbot_s = ((modelStruct.modelVar_qprefbot*(1.0-tmpv))+(modelStruct.modelVar_qpref2bot*(Vjun_s-vjv)));
}
if ((instanceStruct.instanceVar_zflagsti_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vjv*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmpv = value_pow_0;
}
}
d_qjunsti_s_dX = ((modelStruct.modelVar_qprefsti*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2sti*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2sti_dX*(Vjun_s-vjv)));
qjunsti_s = ((modelStruct.modelVar_qprefsti*(1.0-tmpv))+(modelStruct.modelVar_qpref2sti*(Vjun_s-vjv)));
}
if ((instanceStruct.instanceVar_zflaggat_s>0.5))
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vjv*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmpv = value_pow_0;
}
}
d_qjungat_s_dX = ((modelStruct.modelVar_qprefgat*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2gat*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2gat_dX*(Vjun_s-vjv)));
qjungat_s = ((modelStruct.modelVar_qprefgat*(1.0-tmpv))+(modelStruct.modelVar_qpref2gat*(Vjun_s-vjv)));
}
d_tmpv_dX = 0.0;
tmpv = 0.0;
d_vjv_dX = 0.0;
vjv = 0.0;
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (Vjun_d+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vjv_dX = 2.0*(((h3+h5)*Vjun_d*instanceStruct.d_instanceVar_vfmin_d_dX-(Vjun_d*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vjv = (2.0*((Vjun_d*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((instanceStruct.instanceVar_zflagbot_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vjv*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmpv = value_pow_0;
}
}
d_qjunbot_d_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2bot_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(Vjun_d-vjv)));
qjunbot_d = ((modelStruct.modelVar_qprefbot_d*(1.0-tmpv))+(modelStruct.modelVar_qpref2bot_d*(Vjun_d-vjv)));
}
if ((instanceStruct.instanceVar_zflagsti_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vjv*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmpv = value_pow_0;
}
}
d_qjunsti_d_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2sti_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(Vjun_d-vjv)));
qjunsti_d = ((modelStruct.modelVar_qprefsti_d*(1.0-tmpv))+(modelStruct.modelVar_qpref2sti_d*(Vjun_d-vjv)));
}
if ((instanceStruct.instanceVar_zflaggat_d>0.5))
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vjv*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmpv_dX = deriv_sqrt_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat_d)));
tmpv = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vjv*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vjv*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vjv*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vjv*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vjv*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmpv_dX = ((deriv_pow_0_d0*((-(vjv*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vjv_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmpv = value_pow_0;
}
}
d_qjungat_d_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmpv_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmpv))+(modelStruct.modelVar_qpref2gat_d*(-d_vjv_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(Vjun_d-vjv)));
qjungat_d = ((modelStruct.modelVar_qprefgat_d*(1.0-tmpv))+(modelStruct.modelVar_qpref2gat_d*(Vjun_d-vjv)));
}
}
// End block evaluateDynamic
}
else
{
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABSOURCE_i==0.0)&&(instanceStruct.instanceVar_LSSOURCE_i==0.0))&&(instanceStruct.instanceVar_LGSOURCE_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.d_instanceVar_vch_s_dX+4.0*instanceStruct.d_instanceVar_vch_s_dX*instanceStruct.instanceVar_vch_s);
h1 = ((4.0*instanceStruct.instanceVar_vch_s)*instanceStruct.instanceVar_vch_s);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_s*instanceStruct.d_instanceVar_vch_s_dX-instanceStruct.instanceVar_vch_s*instanceStruct.d_instanceVar_vfmin_s_dX)/instanceStruct.instanceVar_vfmin_s/instanceStruct.instanceVar_vfmin_s);
h2 = (instanceStruct.instanceVar_vch_s/instanceStruct.instanceVar_vfmin_s);
d_h2d_dX = (instanceStruct.instanceVar_vch_s*d_h2_dX+instanceStruct.d_instanceVar_vch_s_dX*h2);
h2d = (Vjun_s+(instanceStruct.instanceVar_vch_s*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_s_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_s+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_s_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_s-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*Vjun_s*instanceStruct.d_instanceVar_vfmin_s_dX-(Vjun_s*instanceStruct.instanceVar_vfmin_s)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_s*instanceStruct.instanceVar_vfmin_s)/(h3+h5)));
if ((Vjun_s<instanceStruct.instanceVar_VMAX_s))
{
if ((fabs((0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_s*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_s*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*Vjun_s*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_s*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_s_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
idmult = ((1.0+((Vjun_s-instanceStruct.instanceVar_VMAX_s)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_s);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((Vjun_s>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-Vjun_s)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_s_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_s-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_s-vjlim)*(Vjun_s-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((Vjun_s-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(Vjun_s-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((Vjun_s+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s-instanceStruct.instanceVar_vbbtlim_s)*(Vjun_s-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_s_dX-deriv_sqrt_0_d0*((((Vjun_s-instanceStruct.instanceVar_vbbtlim_s)*(-instanceStruct.d_instanceVar_vbbtlim_s_dX)+(-instanceStruct.d_instanceVar_vbbtlim_s_dX)*(Vjun_s-instanceStruct.instanceVar_vbbtlim_s))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((Vjun_s+instanceStruct.instanceVar_vbbtlim_s)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_s)*(Vjun_s))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vav = (0.5*(Vjun_s-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABSOURCE_i==0.0))
{
d_ijunbot_s_dX = 0.0;
ijunbot_s = 0.0;
d_qjunbot_s_dX = 0.0;
qjunbot_s = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot)),modelStruct.modelVar_one_minus_PBOT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT/(1.0-(vj*modelStruct.modelVar_vbiinvbot))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_s_dX = ((modelStruct.modelVar_qprefbot*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_dX*(Vjun_s-vj)));
qjunbot_s = ((modelStruct.modelVar_qprefbot*(1.0-tmp))+(modelStruct.modelVar_qpref2bot*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot*d_idmult_dX+modelStruct.d_modelVar_idsatbot_dX*idmult);
id = (modelStruct.modelVar_idsatbot*idmult);
if (((modelStruct.modelVar_CSRHBOT_i==0.0)&&(modelStruct.modelVar_CTATBOT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT)-(wdep*modelStruct.modelVar_one_minus_PBOT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_dX*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot*((wdep*modelStruct.modelVar_one_minus_PBOT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_dX-(0.666666666666667*modelStruct.modelVar_atatbot)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOT_i)*modelStruct.modelVar_one_over_one_minus_PBOT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOT_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_dX+(-modelStruct.d_modelVar_PBOT_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*d_umax_dX+modelStruct.d_modelVar_atatbot_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv),modelStruct.modelVar_PBOT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOT_i/((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_VBIRBOTinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT*((tmp*((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_dX+(modelStruct.d_modelVar_VBIRBOT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot)-((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_dX*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT*(((modelStruct.modelVar_VBIRBOT_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_dX)-(-modelStruct.modelVar_fbbtbot)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOT_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOT_i)))
{
if ((modelStruct.modelVar_PBRBOT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*vav*modelStruct.d_modelVar_VBRinvbot_dX+(((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*vav*modelStruct.d_modelVar_VBRinvbot_dX+((vav*modelStruct.modelVar_VBRinvbot)*vav*modelStruct.d_modelVar_VBRinvbot_dX+vav*modelStruct.d_modelVar_VBRinvbot_dX*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot)*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot))*(vav*modelStruct.modelVar_VBRinvbot));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.d_modelVar_slopebot_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOT_i)*modelStruct.modelVar_slopebot));
fbreakdown = (modelStruct.modelVar_fstopbot+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOT_i))*modelStruct.modelVar_slopebot));
}
}
d_ijunbot_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSSOURCE_i==0.0))
{
d_ijunsti_s_dX = 0.0;
ijunsti_s = 0.0;
d_qjunsti_s_dX = 0.0;
qjunsti_s = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti)),modelStruct.modelVar_one_minus_PSTI);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI/(1.0-(vj*modelStruct.modelVar_vbiinvsti))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_s_dX = ((modelStruct.modelVar_qprefsti*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_dX*(Vjun_s-vj)));
qjunsti_s = ((modelStruct.modelVar_qprefsti*(1.0-tmp))+(modelStruct.modelVar_qpref2sti*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti*d_idmult_dX+modelStruct.d_modelVar_idsatsti_dX*idmult);
id = (modelStruct.modelVar_idsatsti*idmult);
if (((modelStruct.modelVar_CSRHSTI_i==0.0)&&(modelStruct.modelVar_CTATSTI_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTI_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTI_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTI_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTI_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTI_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTI_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTI_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI)-(wdep*modelStruct.modelVar_one_minus_PSTI)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_dX*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti*((wdep*modelStruct.modelVar_one_minus_PSTI)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_dX-(0.666666666666667*modelStruct.modelVar_atatsti)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTI_i)*modelStruct.modelVar_one_over_one_minus_PSTI)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTI_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_dX+(-modelStruct.d_modelVar_PSTI_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*d_umax_dX+modelStruct.d_modelVar_atatsti_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTI_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTI_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTI_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTI_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv),modelStruct.modelVar_PSTI_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTI_i/((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_VBIRSTIinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTI_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI*((tmp*((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_dX+(modelStruct.d_modelVar_VBIRSTI_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti)-((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_dX*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI*(((modelStruct.modelVar_VBIRSTI_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_dX)-(-modelStruct.modelVar_fbbtsti)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTI_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTI_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTI_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTI_i)))
{
if ((modelStruct.modelVar_PBRSTI_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*vav*modelStruct.d_modelVar_VBRinvsti_dX+(((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*vav*modelStruct.d_modelVar_VBRinvsti_dX+((vav*modelStruct.modelVar_VBRinvsti)*vav*modelStruct.d_modelVar_VBRinvsti_dX+vav*modelStruct.d_modelVar_VBRinvsti_dX*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti)*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti))*(vav*modelStruct.modelVar_VBRinvsti));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTI_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTI_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTI_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.d_modelVar_slopesti_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTI_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTI_i)*modelStruct.modelVar_slopesti));
fbreakdown = (modelStruct.modelVar_fstopsti+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTI_i))*modelStruct.modelVar_slopesti));
}
}
d_ijunsti_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGSOURCE_i==0.0))
{
d_ijungat_s_dX = 0.0;
ijungat_s = 0.0;
d_qjungat_s_dX = 0.0;
qjungat_s = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat)),modelStruct.modelVar_one_minus_PGAT);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT/(1.0-(vj*modelStruct.modelVar_vbiinvgat))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_dX)));
tmp = value_pow_0;
}
}
d_qjungat_s_dX = ((modelStruct.modelVar_qprefgat*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_dX*(Vjun_s-vj)));
qjungat_s = ((modelStruct.modelVar_qprefgat*(1.0-tmp))+(modelStruct.modelVar_qpref2gat*(Vjun_s-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat*d_idmult_dX+modelStruct.d_modelVar_idsatgat_dX*idmult);
id = (modelStruct.modelVar_idsatgat*idmult);
if (((modelStruct.modelVar_CSRHGAT_i==0.0)&&(modelStruct.modelVar_CTATGAT_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGAT_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGAT_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGAT_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGAT_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGAT_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGAT_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGAT_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT)-(wdep*modelStruct.modelVar_one_minus_PGAT)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_dX*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat*((wdep*modelStruct.modelVar_one_minus_PGAT)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_dX-(0.666666666666667*modelStruct.modelVar_atatgat)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGAT_i)*modelStruct.modelVar_one_over_one_minus_PGAT)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGAT_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_dX+(-modelStruct.d_modelVar_PGAT_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*d_umax_dX+modelStruct.d_modelVar_atatgat_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGAT_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGAT_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGAT_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGAT_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv),modelStruct.modelVar_PGAT_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGAT_i/((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_VBIRGATinv))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGAT_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT*((tmp*((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_dX+(modelStruct.d_modelVar_VBIRGAT_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat)-((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_dX*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT*(((modelStruct.modelVar_VBIRGAT_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_dX)-(-modelStruct.modelVar_fbbtgat)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_s*Fmaxr)*d_Fmaxr_dX+Vjun_s*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGAT_i_dX*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGAT_i*(((Vjun_s*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGAT_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGAT_i)))
{
if ((modelStruct.modelVar_PBRGAT_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*vav*modelStruct.d_modelVar_VBRinvgat_dX+(((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*vav*modelStruct.d_modelVar_VBRinvgat_dX+((vav*modelStruct.modelVar_VBRinvgat)*vav*modelStruct.d_modelVar_VBRinvgat_dX+vav*modelStruct.d_modelVar_VBRinvgat_dX*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat)*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat))*(vav*modelStruct.modelVar_VBRinvgat));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGAT_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGAT_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGAT_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.d_modelVar_slopegat_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGAT_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGAT_i)*modelStruct.modelVar_slopegat));
fbreakdown = (modelStruct.modelVar_fstopgat+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGAT_i))*modelStruct.modelVar_slopegat));
}
}
d_ijungat_s_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat_s = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_ijun_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_ijunbot_s_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*ijunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*d_ijunsti_s_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*ijunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*d_ijungat_s_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*ijungat_s));
ijun_s = (((instanceStruct.instanceVar_ABSOURCE_i*ijunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*ijunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*ijungat_s));
d_vbbt_dX = 0.0;
vbbt = 0.0;
d_two_psistar_dX = 0.0;
two_psistar = 0.0;
if ((!(((instanceStruct.instanceVar_ABDRAIN_i==0.0)&&(instanceStruct.instanceVar_LSDRAIN_i==0.0))&&(instanceStruct.instanceVar_LGDRAIN_i==0.0))))
{
d_h1_dX = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.d_instanceVar_vch_d_dX+4.0*instanceStruct.d_instanceVar_vch_d_dX*instanceStruct.instanceVar_vch_d);
h1 = ((4.0*instanceStruct.instanceVar_vch_d)*instanceStruct.instanceVar_vch_d);
d_h2_dX = ((instanceStruct.instanceVar_vfmin_d*instanceStruct.d_instanceVar_vch_d_dX-instanceStruct.instanceVar_vch_d*instanceStruct.d_instanceVar_vfmin_d_dX)/instanceStruct.instanceVar_vfmin_d/instanceStruct.instanceVar_vfmin_d);
h2 = (instanceStruct.instanceVar_vch_d/instanceStruct.instanceVar_vfmin_d);
d_h2d_dX = (instanceStruct.instanceVar_vch_d*d_h2_dX+instanceStruct.d_instanceVar_vch_d_dX*h2);
h2d = (Vjun_d+(instanceStruct.instanceVar_vch_d*h2));
d_h3_dX = (instanceStruct.d_instanceVar_vfmin_d_dX+d_h2d_dX);
h3 = (instanceStruct.instanceVar_vfmin_d+h2d);
d_h4_dX = (instanceStruct.d_instanceVar_vfmin_d_dX-d_h2d_dX);
h4 = (instanceStruct.instanceVar_vfmin_d-h2d);
{
double value_sqrt_0 = sqrt(((h4*h4)+h1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_h5_dX = deriv_sqrt_0_d0*(((h4*d_h4_dX+d_h4_dX*h4)+d_h1_dX));
h5 = value_sqrt_0;
}
d_vj_dX = 2.0*(((h3+h5)*Vjun_d*instanceStruct.d_instanceVar_vfmin_d_dX-(Vjun_d*instanceStruct.instanceVar_vfmin_d)*(d_h3_dX+d_h5_dX))/(h3+h5)/(h3+h5));
vj = (2.0*((Vjun_d*instanceStruct.instanceVar_vfmin_d)/(h3+h5)));
if ((Vjun_d<instanceStruct.instanceVar_VMAX_d))
{
if ((fabs((0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp((0.5*(Vjun_d*modelStruct.modelVar_phitdinv)));
double  deriv_exp_0_d0 = value_exp_0;
d_zinv_dX = deriv_exp_0_d0*(0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX);
zinv = value_exp_0;
}
}
else
{
if (((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))<0.0))
{
d_zinv_dX = (-1.0e-100*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*3.3333333333333333e-01+(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))+(-0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
zinv = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(0.5*(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*(1.0+(((-2.3025850929940458e+02)-(0.5*(Vjun_d*modelStruct.modelVar_phitdinv)))*3.3333333333333333e-01))))))));
}
else
{
d_zinv_dX = 1.0e100*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*3.3333333333333333e-01+0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01)))+0.5*Vjun_d*modelStruct.d_modelVar_phitdinv_dX*(1.0+(0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))));
zinv = (1.0e100*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(0.5*(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*(1.0+(((0.5*(Vjun_d*modelStruct.modelVar_phitdinv))-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_idmult_dX = (zinv*d_zinv_dX+d_zinv_dX*zinv);
idmult = (zinv*zinv);
}
else
{
d_idmult_dX = ((1.0+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.d_modelVar_phitdinv_dX+(-instanceStruct.d_instanceVar_VMAX_d_dX)*modelStruct.modelVar_phitdinv)*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
idmult = ((1.0+((Vjun_d-instanceStruct.instanceVar_VMAX_d)*modelStruct.modelVar_phitdinv))*instanceStruct.instanceVar_exp_VMAX_over_phitd_d);
{
double value_sqrt_0 = sqrt(idmult);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_zinv_dX = deriv_sqrt_0_d0*(d_idmult_dX);
zinv = value_sqrt_0;
}
}
idmult = (idmult-1.0);
d_z_dX = (-d_zinv_dX/zinv/zinv);
z = (1.0/zinv);
if ((Vjun_d>0.0))
{
{
double value_sqrt_0 = sqrt(((z+1.0)*(z+3.0)));
double value_log_1 = log(((2.0+z)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/((2.0+z)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((d_z_dX+deriv_sqrt_0_d0*(((z+1.0)*d_z_dX+d_z_dX*(z+3.0)))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = (2.0*(modelStruct.modelVar_phitd*value_log_1));
}
}
else
{
{
double value_sqrt_0 = sqrt(((1.0+zinv)*(1.0+(3.0*zinv))));
double value_log_1 = log((((2.0*zinv)+1.0)+value_sqrt_0));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_log_1_d0 = (1.0/(((2.0*zinv)+1.0)+value_sqrt_0));
d_two_psistar_dX = 2.0*(modelStruct.modelVar_phitd*deriv_log_1_d0*((2.0*d_zinv_dX+deriv_sqrt_0_d0*(((1.0+zinv)*3.0*d_zinv_dX+d_zinv_dX*(1.0+(3.0*zinv))))))+modelStruct.d_modelVar_phitd_dX*value_log_1);
two_psistar = ((-Vjun_d)+(2.0*(modelStruct.modelVar_phitd*value_log_1)));
}
}
d_vjlim_dX = (instanceStruct.d_instanceVar_vbimin_d_dX-d_two_psistar_dX);
vjlim = (instanceStruct.instanceVar_vbimin_d-two_psistar);
{
double value_sqrt_0 = sqrt((((Vjun_d-vjlim)*(Vjun_d-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.modelVar_phitd)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vjsrh_dX = 0.5*(d_vjlim_dX-deriv_sqrt_0_d0*((((Vjun_d-vjlim)*(-d_vjlim_dX)+(-d_vjlim_dX)*(Vjun_d-vjlim))+((4.0*modelStruct.modelVar_phitd)*modelStruct.d_modelVar_phitd_dX+4.0*modelStruct.d_modelVar_phitd_dX*modelStruct.modelVar_phitd))));
vjsrh = (0.5*((Vjun_d+vjlim)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d-instanceStruct.instanceVar_vbbtlim_d)*(Vjun_d-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.modelVar_phitr)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_vbbt_dX = 0.5*(instanceStruct.d_instanceVar_vbbtlim_d_dX-deriv_sqrt_0_d0*((((Vjun_d-instanceStruct.instanceVar_vbbtlim_d)*(-instanceStruct.d_instanceVar_vbbtlim_d_dX)+(-instanceStruct.d_instanceVar_vbbtlim_d_dX)*(Vjun_d-instanceStruct.instanceVar_vbbtlim_d))+((4.0*modelStruct.modelVar_phitr)*modelStruct.d_modelVar_phitr_dX+4.0*modelStruct.d_modelVar_phitr_dX*modelStruct.modelVar_phitr))));
vbbt = (0.5*((Vjun_d+instanceStruct.instanceVar_vbbtlim_d)-value_sqrt_0));
}
{
double value_sqrt_0 = sqrt((((Vjun_d)*(Vjun_d))+((4.0*1.0e-6)*1.0e-6)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
vav = (0.5*(Vjun_d-value_sqrt_0));
}
}
if ((instanceStruct.instanceVar_ABDRAIN_i==0.0))
{
d_ijunbot_d_dX = 0.0;
ijunbot_d = 0.0;
d_qjunbot_d_dX = 0.0;
qjunbot_d = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PBOT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)),modelStruct.modelVar_one_minus_PBOT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PBOT_d/(1.0-(vj*modelStruct.modelVar_vbiinvbot_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvbot_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvbot_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvbot_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PBOT_d_dX)));
tmp = value_pow_0;
}
}
d_qjunbot_d_dX = ((modelStruct.modelVar_qprefbot_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefbot_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2bot_d_dX*(Vjun_d-vj)));
qjunbot_d = ((modelStruct.modelVar_qprefbot_d*(1.0-tmp))+(modelStruct.modelVar_qpref2bot_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatbot_d*d_idmult_dX+modelStruct.d_modelVar_idsatbot_d_dX*idmult);
id = (modelStruct.modelVar_idsatbot_d*idmult);
if (((modelStruct.modelVar_CSRHBOTD_i==0.0)&&(modelStruct.modelVar_CTATBOTD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbibot_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbibot_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PBOTD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PBOTD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRBOTinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrbot_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrbot_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrbot_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdbot_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdbot_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHBOTD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHBOTD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHBOTD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATBOTD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartbot_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PBOT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PBOT_d)-(wdep*modelStruct.modelVar_one_minus_PBOT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartbot_d_dX*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartbot_d*((wdep*modelStruct.modelVar_one_minus_PBOT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatbot_d_dX-(0.666666666666667*modelStruct.modelVar_atatbot_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatbot_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PBOTD_i)*modelStruct.modelVar_one_over_one_minus_PBOT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PBOTD_i)*modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX+(-modelStruct.d_modelVar_PBOTD_i_dX)*modelStruct.modelVar_one_over_one_minus_PBOT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatbot_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatbot_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*d_umax_dX+modelStruct.d_modelVar_atatbot_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatbot_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatbot_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatbot_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatbot_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatbot_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatbot_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATBOTD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATBOTD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTBOTD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PBOTD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d),modelStruct.modelVar_PBOTD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PBOTD_i/((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_VBIRBOTinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_VBIRBOTinv_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRBOTinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PBOTD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PBOT_d*((tmp*((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvbot_d_dX+(modelStruct.d_modelVar_VBIRBOTD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvbot_d)-((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PBOT_d*(((modelStruct.modelVar_VBIRBOTD_i-vbbt)*modelStruct.modelVar_wdepnulrinvbot_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtbot_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtbot_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtbot_d_dX)-(-modelStruct.modelVar_fbbtbot_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtbot_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTBOTD_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTBOTD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRBOTD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRBOTD_i)))
{
if ((modelStruct.modelVar_PBRBOTD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*vav*modelStruct.d_modelVar_VBRinvbot_d_dX+(((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*vav*modelStruct.d_modelVar_VBRinvbot_d_dX+((vav*modelStruct.modelVar_VBRinvbot_d)*vav*modelStruct.d_modelVar_VBRinvbot_d_dX+vav*modelStruct.d_modelVar_VBRinvbot_d_dX*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvbot_d)*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d))*(vav*modelStruct.modelVar_VBRinvbot_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvbot_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRBOTD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvbot_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRBOTD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvbot_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRBOTD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopbot_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.d_modelVar_slopebot_d_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRBOTD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRBOTD_i)*modelStruct.modelVar_slopebot_d));
fbreakdown = (modelStruct.modelVar_fstopbot_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRBOTD_i))*modelStruct.modelVar_slopebot_d));
}
}
d_ijunbot_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunbot_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LSDRAIN_i==0.0))
{
d_ijunsti_d_dX = 0.0;
ijunsti_d = 0.0;
d_qjunsti_d_dX = 0.0;
qjunsti_d = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PSTI_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)),modelStruct.modelVar_one_minus_PSTI_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PSTI_d/(1.0-(vj*modelStruct.modelVar_vbiinvsti_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvsti_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvsti_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvsti_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PSTI_d_dX)));
tmp = value_pow_0;
}
}
d_qjunsti_d_dX = ((modelStruct.modelVar_qprefsti_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefsti_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2sti_d_dX*(Vjun_d-vj)));
qjunsti_d = ((modelStruct.modelVar_qprefsti_d*(1.0-tmp))+(modelStruct.modelVar_qpref2sti_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatsti_d*d_idmult_dX+modelStruct.d_modelVar_idsatsti_d_dX*idmult);
id = (modelStruct.modelVar_idsatsti_d*idmult);
if (((modelStruct.modelVar_CSRHSTID_i==0.0)&&(modelStruct.modelVar_CTATSTID_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbisti_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbisti_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PSTID_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PSTID_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PSTID_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRSTIinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrsti_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrsti_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrsti_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdsti_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdsti_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHSTID_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHSTID_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHSTID_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATSTID_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartsti_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PSTI_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PSTI_d)-(wdep*modelStruct.modelVar_one_minus_PSTI_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartsti_d_dX*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartsti_d*((wdep*modelStruct.modelVar_one_minus_PSTI_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatsti_d_dX-(0.666666666666667*modelStruct.modelVar_atatsti_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatsti_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PSTID_i)*modelStruct.modelVar_one_over_one_minus_PSTI_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PSTID_i)*modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX+(-modelStruct.d_modelVar_PSTID_i_dX)*modelStruct.modelVar_one_over_one_minus_PSTI_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatsti_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatsti_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*d_umax_dX+modelStruct.d_modelVar_atatsti_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatsti_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatsti_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatsti_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatsti_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatsti_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatsti_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATSTID_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATSTID_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTSTID_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PSTID_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d),modelStruct.modelVar_PSTID_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PSTID_i/((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_VBIRSTIinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_VBIRSTIinv_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRSTIinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PSTID_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PSTI_d*((tmp*((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvsti_d_dX+(modelStruct.d_modelVar_VBIRSTID_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvsti_d)-((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PSTI_d*(((modelStruct.modelVar_VBIRSTID_i-vbbt)*modelStruct.modelVar_wdepnulrinvsti_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtsti_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtsti_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtsti_d_dX)-(-modelStruct.modelVar_fbbtsti_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtsti_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTSTID_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTSTID_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRSTID_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRSTID_i)))
{
if ((modelStruct.modelVar_PBRSTID_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*vav*modelStruct.d_modelVar_VBRinvsti_d_dX+(((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*vav*modelStruct.d_modelVar_VBRinvsti_d_dX+((vav*modelStruct.modelVar_VBRinvsti_d)*vav*modelStruct.d_modelVar_VBRinvsti_d_dX+vav*modelStruct.d_modelVar_VBRinvsti_d_dX*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvsti_d)*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d))*(vav*modelStruct.modelVar_VBRinvsti_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvsti_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRSTID_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvsti_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRSTID_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvsti_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRSTID_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopsti_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.d_modelVar_slopesti_d_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRSTID_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRSTID_i)*modelStruct.modelVar_slopesti_d));
fbreakdown = (modelStruct.modelVar_fstopsti_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRSTID_i))*modelStruct.modelVar_slopesti_d));
}
}
d_ijunsti_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijunsti_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
if ((instanceStruct.instanceVar_LGDRAIN_i==0.0))
{
d_ijungat_d_dX = 0.0;
ijungat_d = 0.0;
d_qjungat_d_dX = 0.0;
qjungat_d = 0.0;
}
else
{
if ((modelStruct.modelVar_one_minus_PGAT_d==0.5))
{
{
double value_sqrt_0 = sqrt((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d)));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)),modelStruct.modelVar_one_minus_PGAT_d);
double  deriv_pow_0_d0 = (((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_one_minus_PGAT_d/(1.0-(vj*modelStruct.modelVar_vbiinvgat_d))));
double  deriv_pow_0_d1 = ((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)) == 0.0)?0.0:(log((1.0-(vj*modelStruct.modelVar_vbiinvgat_d)))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((-(vj*modelStruct.d_modelVar_vbiinvgat_d_dX+d_vj_dX*modelStruct.modelVar_vbiinvgat_d))))+(deriv_pow_0_d1*(modelStruct.d_modelVar_one_minus_PGAT_d_dX)));
tmp = value_pow_0;
}
}
d_qjungat_d_dX = ((modelStruct.modelVar_qprefgat_d*(-d_tmp_dX)+modelStruct.d_modelVar_qprefgat_d_dX*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(-d_vj_dX)+modelStruct.d_modelVar_qpref2gat_d_dX*(Vjun_d-vj)));
qjungat_d = ((modelStruct.modelVar_qprefgat_d*(1.0-tmp))+(modelStruct.modelVar_qpref2gat_d*(Vjun_d-vj)));
d_id_dX = (modelStruct.modelVar_idsatgat_d*d_idmult_dX+modelStruct.d_modelVar_idsatgat_d_dX*idmult);
id = (modelStruct.modelVar_idsatgat_d*idmult);
if (((modelStruct.modelVar_CSRHGATD_i==0.0)&&(modelStruct.modelVar_CTATGATD_i==0.0)))
{
d_isrh_dX = 0.0;
isrh = 0.0;
}
else
{
d_vbi_minus_vjsrh_dX = (modelStruct.d_modelVar_vbigat_d_dX-d_vjsrh_dX);
vbi_minus_vjsrh = (modelStruct.modelVar_vbigat_d-vjsrh);
{
double value_sqrt_0 = sqrt((1.0-(two_psistar/vbi_minus_vjsrh)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_wsrhstep_dX = (-deriv_sqrt_0_d0*((-((vbi_minus_vjsrh*d_two_psistar_dX-two_psistar*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh))));
wsrhstep = (1.0-value_sqrt_0);
}
if ((modelStruct.modelVar_PGATD_i==0.5))
{
d_dwsrh_dX = 0.0;
dwsrh = 0.0;
}
else
{
{
double value_log_0 = log(wsrhstep);
double  deriv_log_0_d0 = (1.0/wsrhstep);
d_dwsrh_dX = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(-2.0*modelStruct.d_modelVar_PGATD_i_dX)+((((1.0-wsrhstep)*((wsrhstep*wsrhstep)*deriv_log_0_d0*(d_wsrhstep_dX)+(wsrhstep*d_wsrhstep_dX+d_wsrhstep_dX*wsrhstep)*value_log_0)-((wsrhstep*wsrhstep)*value_log_0)*(-d_wsrhstep_dX))/(1.0-wsrhstep)/(1.0-wsrhstep))+d_wsrhstep_dX)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
dwsrh = (((((wsrhstep*wsrhstep)*value_log_0)/(1.0-wsrhstep))+wsrhstep)*(1.0-(2.0*modelStruct.modelVar_PGATD_i)));
}
}
d_wsrh_dX = (d_wsrhstep_dX+d_dwsrh_dX);
wsrh = (wsrhstep+dwsrh);
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = (((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/(vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = ((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log((vbi_minus_vjsrh*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*((vbi_minus_vjsrh*modelStruct.d_modelVar_VBIRGATinv_d_dX+d_vbi_minus_vjsrh_dX*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_wdep_dX = (modelStruct.modelVar_wdepnulrgat_d*d_tmp_dX+modelStruct.d_modelVar_wdepnulrgat_d_dX*tmp);
wdep = (modelStruct.modelVar_wdepnulrgat_d*tmp);
d_asrh_dX = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*d_wdep_dX+d_zinv_dX*wdep)+modelStruct.d_modelVar_ftdgat_d_dX*((zinv-1.0)*wdep));
asrh = (modelStruct.modelVar_ftdgat_d*((zinv-1.0)*wdep));
d_isrh_dX = (modelStruct.modelVar_CSRHGATD_i*(asrh*d_wsrh_dX+d_asrh_dX*wsrh)+modelStruct.d_modelVar_CSRHGATD_i_dX*(asrh*wsrh));
isrh = (modelStruct.modelVar_CSRHGATD_i*(asrh*wsrh));
}
if ((modelStruct.modelVar_CTATGATD_i==0.0))
{
d_itat_dX = 0.0;
itat = 0.0;
}
else
{
d_btat_dX = (modelStruct.modelVar_btatpartgat_d*((vbi_minus_vjsrh*(wdep*modelStruct.d_modelVar_one_minus_PGAT_d_dX+d_wdep_dX*modelStruct.modelVar_one_minus_PGAT_d)-(wdep*modelStruct.modelVar_one_minus_PGAT_d)*d_vbi_minus_vjsrh_dX)/vbi_minus_vjsrh/vbi_minus_vjsrh)+modelStruct.d_modelVar_btatpartgat_d_dX*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
btat = (modelStruct.modelVar_btatpartgat_d*((wdep*modelStruct.modelVar_one_minus_PGAT_d)/vbi_minus_vjsrh));
d_twoatatoverthreebtat_dX = ((btat*0.666666666666667*modelStruct.d_modelVar_atatgat_d_dX-(0.666666666666667*modelStruct.modelVar_atatgat_d)*d_btat_dX)/btat/btat);
twoatatoverthreebtat = ((0.666666666666667*modelStruct.modelVar_atatgat_d)/btat);
d_umaxbeforelimiting_dX = (twoatatoverthreebtat*d_twoatatoverthreebtat_dX+d_twoatatoverthreebtat_dX*twoatatoverthreebtat);
umaxbeforelimiting = (twoatatoverthreebtat*twoatatoverthreebtat);
{
double value_sqrt_0 = sqrt(((umaxbeforelimiting*umaxbeforelimiting)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_umax_dX = deriv_sqrt_0_d0*(((((umaxbeforelimiting*umaxbeforelimiting)+1.0)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting)-(umaxbeforelimiting*umaxbeforelimiting)*(umaxbeforelimiting*d_umaxbeforelimiting_dX+d_umaxbeforelimiting_dX*umaxbeforelimiting))/((umaxbeforelimiting*umaxbeforelimiting)+1.0)/((umaxbeforelimiting*umaxbeforelimiting)+1.0)));
umax = value_sqrt_0;
}
{
double value_fabs_0 = fabs(umax);
double value_sqrt_1 = sqrt(value_fabs_0);
double  deriv_fabs_0_d0 = (((umax)>=0)?(+1.0):(-1.0));
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_sqrtumax_dX = deriv_sqrt_1_d0*(deriv_fabs_0_d0*(d_umax_dX));
sqrtumax = value_sqrt_1;
}
d_umaxpoweronepointfive_dX = (umax*d_sqrtumax_dX+d_umax_dX*sqrtumax);
umaxpoweronepointfive = (umax*sqrtumax);
if ((((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)==(-1.0)))
{
d_wgamma_dX = (-(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)/(1.0+(btat*umaxpoweronepointfive))/(1.0+(btat*umaxpoweronepointfive)));
wgamma = (1.0/(1.0+(btat*umaxpoweronepointfive)));
}
else
{
{
double value_pow_0 = pow((1.0+(btat*umaxpoweronepointfive)),((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d));
double  deriv_pow_0_d0 = (((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(value_pow_0*((-modelStruct.modelVar_PGATD_i)*modelStruct.modelVar_one_over_one_minus_PGAT_d)/(1.0+(btat*umaxpoweronepointfive))));
double  deriv_pow_0_d1 = ((1.0+(btat*umaxpoweronepointfive)) == 0.0)?0.0:(log((1.0+(btat*umaxpoweronepointfive)))*value_pow_0);
d_wgamma_dX = ((deriv_pow_0_d0*((btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive)))+(deriv_pow_0_d1*(((-modelStruct.modelVar_PGATD_i)*modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX+(-modelStruct.d_modelVar_PGATD_i_dX)*modelStruct.modelVar_one_over_one_minus_PGAT_d))));
wgamma = value_pow_0;
}
}
d_wtat_dX = (((wsrh+wgamma)*(wsrh*d_wgamma_dX+d_wsrh_dX*wgamma)-(wsrh*wgamma)*(d_wsrh_dX+d_wgamma_dX))/(wsrh+wgamma)/(wsrh+wgamma));
wtat = ((wsrh*wgamma)/(wsrh+wgamma));
{
double value_sqrt_0 = sqrt((0.375*(btat/sqrtumax)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_ktat_dX = deriv_sqrt_0_d0*(0.375*((sqrtumax*d_btat_dX-btat*d_sqrtumax_dX)/sqrtumax/sqrtumax));
ktat = value_sqrt_0;
}
d_ltat_dX = (2.0*(twoatatoverthreebtat*d_sqrtumax_dX+d_twoatatoverthreebtat_dX*sqrtumax)-d_umax_dX);
ltat = ((2.0*(twoatatoverthreebtat*sqrtumax))-umax);
d_mtat_dX = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*d_sqrtumax_dX+(modelStruct.modelVar_atatgat_d*d_twoatatoverthreebtat_dX+modelStruct.d_modelVar_atatgat_d_dX*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*d_umax_dX+modelStruct.d_modelVar_atatgat_d_dX*umax))+0.5*(btat*d_umaxpoweronepointfive_dX+d_btat_dX*umaxpoweronepointfive));
mtat = ((((modelStruct.modelVar_atatgat_d*twoatatoverthreebtat)*sqrtumax)-(modelStruct.modelVar_atatgat_d*umax))+(0.5*(btat*umaxpoweronepointfive)));
d_xerfc_dX = ((ltat-1.0)*d_ktat_dX+d_ltat_dX*ktat);
xerfc = ((ltat-1.0)*ktat);
d_ysq_dX = (xerfc*d_xerfc_dX+d_xerfc_dX*xerfc);
ysq = (xerfc*xerfc);
if ((xerfc>0.0))
{
d_terfc_dX = (-modelStruct.modelVar_perfc*d_xerfc_dX/(1.0+(modelStruct.modelVar_perfc*xerfc))/(1.0+(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0+(modelStruct.modelVar_perfc*xerfc)));
}
else
{
d_terfc_dX = (-(-modelStruct.modelVar_perfc*d_xerfc_dX)/(1.0-(modelStruct.modelVar_perfc*xerfc))/(1.0-(modelStruct.modelVar_perfc*xerfc)));
terfc = (1.0/(1.0-(modelStruct.modelVar_perfc*xerfc)));
}
if ((((-ysq)+mtat)>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(((-ysq)+mtat));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((-d_ysq_dX)+d_mtat_dX));
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-ysq)+mtat))*0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(-((-d_ysq_dX)+d_mtat_dX))*3.3333333333333333e-01+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))+(-((-d_ysq_dX)+d_mtat_dX))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-ysq)+mtat))*(1.0+(((-2.3025850929940458e+02)-((-ysq)+mtat))*3.3333333333333333e-01))))))));
}
d_erfcpos_dX = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*d_tmp_dX+((0.29214664*d_terfc_dX+modelStruct.modelVar_berfc*(terfc*d_terfc_dX+d_terfc_dX*terfc))+modelStruct.modelVar_cerfc*((terfc*terfc)*d_terfc_dX+(terfc*d_terfc_dX+d_terfc_dX*terfc)*terfc))*tmp);
erfcpos = ((((0.29214664*terfc)+(modelStruct.modelVar_berfc*(terfc*terfc)))+(modelStruct.modelVar_cerfc*((terfc*terfc)*terfc)))*tmp);
if ((xerfc>0.0))
{
d_erfctimesexpmtat_dX = d_erfcpos_dX;
erfctimesexpmtat = erfcpos;
}
else
{
if ((mtat>(-2.3025850929940458e+02)))
{
{
double value_exp_0 = exp(mtat);
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(d_mtat_dX);
tmp = value_exp_0;
}
}
else
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-mtat)*0.5*(((-2.3025850929940458e+02)-mtat)*(-d_mtat_dX)*3.3333333333333333e-01+(-d_mtat_dX)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))+(-d_mtat_dX)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-mtat)*(1.0+(0.5*(((-2.3025850929940458e+02)-mtat)*(1.0+(((-2.3025850929940458e+02)-mtat)*3.3333333333333333e-01))))))));
}
d_erfctimesexpmtat_dX = (2.0*d_tmp_dX-d_erfcpos_dX);
erfctimesexpmtat = ((2.0*tmp)-erfcpos);
}
d_gammamax_dX = (1.77245385090551603*0.5)*((ktat*(modelStruct.modelVar_atatgat_d*d_erfctimesexpmtat_dX+modelStruct.d_modelVar_atatgat_d_dX*erfctimesexpmtat)-(modelStruct.modelVar_atatgat_d*erfctimesexpmtat)*d_ktat_dX)/ktat/ktat);
gammamax = ((1.77245385090551603*0.5)*((modelStruct.modelVar_atatgat_d*erfctimesexpmtat)/ktat));
d_itat_dX = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*d_wtat_dX+(asrh*d_gammamax_dX+d_asrh_dX*gammamax)*wtat)+modelStruct.d_modelVar_CTATGATD_i_dX*((asrh*gammamax)*wtat));
itat = (modelStruct.modelVar_CTATGATD_i*((asrh*gammamax)*wtat));
}
if ((modelStruct.modelVar_CBBTGATD_i==0.0))
{
d_ibbt_dX = 0.0;
ibbt = 0.0;
}
else
{
if ((modelStruct.modelVar_PGATD_i==0.5))
{
{
double value_sqrt_0 = sqrt(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_tmp_dX = deriv_sqrt_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d));
tmp = value_sqrt_0;
}
}
else
{
{
double value_pow_0 = pow(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d),modelStruct.modelVar_PGATD_i);
double  deriv_pow_0_d0 = ((((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(value_pow_0*modelStruct.modelVar_PGATD_i/((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d)));
double  deriv_pow_0_d1 = (((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d) == 0.0)?0.0:(log(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_VBIRGATinv_d))*value_pow_0);
d_tmp_dX = ((deriv_pow_0_d0*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_VBIRGATinv_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_VBIRGATinv_d)))+(deriv_pow_0_d1*(modelStruct.d_modelVar_PGATD_i_dX)));
tmp = value_pow_0;
}
}
d_Fmaxr_dX = (modelStruct.modelVar_one_over_one_minus_PGAT_d*((tmp*((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.d_modelVar_wdepnulrinvgat_d_dX+(modelStruct.d_modelVar_VBIRGATD_i_dX-d_vbbt_dX)*modelStruct.modelVar_wdepnulrinvgat_d)-((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)*d_tmp_dX)/tmp/tmp)+modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
Fmaxr = (modelStruct.modelVar_one_over_one_minus_PGAT_d*(((modelStruct.modelVar_VBIRGATD_i-vbbt)*modelStruct.modelVar_wdepnulrinvgat_d)/tmp));
if ((fabs(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))<2.3025850929940458e+02))
{
{
double value_exp_0 = exp(((-modelStruct.modelVar_fbbtgat_d)/Fmaxr));
double  deriv_exp_0_d0 = value_exp_0;
d_tmp_dX = deriv_exp_0_d0*(((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr));
tmp = value_exp_0;
}
}
else
{
if ((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)<0.0))
{
d_tmp_dX = (-1.0e-100*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*3.3333333333333333e-01+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))+(-((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01)))))))/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
tmp = (1.0e-100/(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(0.5*(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*(1.0+(((-2.3025850929940458e+02)-((-modelStruct.modelVar_fbbtgat_d)/Fmaxr))*3.3333333333333333e-01))))))));
}
else
{
d_tmp_dX = 1.0e100*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*3.3333333333333333e-01+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01)))+((Fmaxr*(-modelStruct.d_modelVar_fbbtgat_d_dX)-(-modelStruct.modelVar_fbbtgat_d)*d_Fmaxr_dX)/Fmaxr/Fmaxr)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))));
tmp = (1.0e100*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+(0.5*((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*(1.0+((((-modelStruct.modelVar_fbbtgat_d)/Fmaxr)-2.3025850929940458e+02)*3.3333333333333333e-01))))))));
}
}
d_ibbt_dX = (modelStruct.modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*d_tmp_dX+((Vjun_d*Fmaxr)*d_Fmaxr_dX+Vjun_d*d_Fmaxr_dX*Fmaxr)*tmp)+modelStruct.d_modelVar_CBBTGATD_i_dX*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
ibbt = (modelStruct.modelVar_CBBTGATD_i*(((Vjun_d*Fmaxr)*Fmaxr)*tmp));
}
if ((modelStruct.modelVar_VBRGATD_i>1.0e3))
{
d_fbreakdown_dX = 0.0;
fbreakdown = 1.0;
}
else
{
if ((vav>((-modelStruct.modelVar_alphaav)*modelStruct.modelVar_VBRGATD_i)))
{
if ((modelStruct.modelVar_PBRGATD_i==4.0))
{
d_tmp_dX = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*vav*modelStruct.d_modelVar_VBRinvgat_d_dX+(((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*vav*modelStruct.d_modelVar_VBRinvgat_d_dX+((vav*modelStruct.modelVar_VBRinvgat_d)*vav*modelStruct.d_modelVar_VBRinvgat_d_dX+vav*modelStruct.d_modelVar_VBRinvgat_d_dX*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
tmp = ((((vav*modelStruct.modelVar_VBRinvgat_d)*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d))*(vav*modelStruct.modelVar_VBRinvgat_d));
}
else
{
{
double value_fabs_0 = fabs((vav*modelStruct.modelVar_VBRinvgat_d));
double value_pow_1 = pow(value_fabs_0,modelStruct.modelVar_PBRGATD_i);
double  deriv_fabs_0_d0 = ((((vav*modelStruct.modelVar_VBRinvgat_d))>=0)?(+1.0):(-1.0));
double  deriv_pow_1_d0 = ((value_fabs_0 == 0.0)?0.0:(value_pow_1*modelStruct.modelVar_PBRGATD_i/value_fabs_0));
double  deriv_pow_1_d1 = (value_fabs_0 == 0.0)?0.0:(log(value_fabs_0)*value_pow_1);
d_tmp_dX = ((deriv_pow_1_d0*(deriv_fabs_0_d0*(vav*modelStruct.d_modelVar_VBRinvgat_d_dX)))+(deriv_pow_1_d1*(modelStruct.d_modelVar_PBRGATD_i_dX)));
tmp = value_pow_1;
}
}
d_fbreakdown_dX = (-(-d_tmp_dX)/(1.0-tmp)/(1.0-tmp));
fbreakdown = (1.0/(1.0-tmp));
}
else
{
d_fbreakdown_dX = (modelStruct.d_modelVar_fstopgat_d_dX+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.d_modelVar_slopegat_d_dX+(modelStruct.modelVar_alphaav*modelStruct.d_modelVar_VBRGATD_i_dX+modelStruct.d_modelVar_alphaav_dX*modelStruct.modelVar_VBRGATD_i)*modelStruct.modelVar_slopegat_d));
fbreakdown = (modelStruct.modelVar_fstopgat_d+((vav+(modelStruct.modelVar_alphaav*modelStruct.modelVar_VBRGATD_i))*modelStruct.modelVar_slopegat_d));
}
}
d_ijungat_d_dX = ((((id+isrh)+itat)+ibbt)*d_fbreakdown_dX+(((d_id_dX+d_isrh_dX)+d_itat_dX)+d_ibbt_dX)*fbreakdown);
ijungat_d = ((((id+isrh)+itat)+ibbt)*fbreakdown);
}
d_ijun_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_ijunbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*ijunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*d_ijunsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*ijunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*d_ijungat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*ijungat_d));
ijun_d = (((instanceStruct.instanceVar_ABDRAIN_i*ijunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*ijunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*ijungat_d));
}
}
d_rgatenoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_ggate_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_ggate);
rgatenoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_ggate);
d_rsourcenoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gsource_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gsource);
rsourcenoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gsource);
d_rdrainnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gdrain_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gdrain);
rdrainnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gdrain);
d_rbulknoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gbulk_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gbulk);
rbulknoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gbulk);
d_rjunsnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gjuns_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gjuns);
rjunsnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gjuns);
d_rjundnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gjund_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gjund);
rjundnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gjund);
d_rwellnoise_dX = (modelStruct.modelVar_nt0*instanceStruct.d_instanceVar_gwell_dX+modelStruct.d_modelVar_nt0_dX*instanceStruct.instanceVar_gwell);
rwellnoise = (modelStruct.modelVar_nt0*instanceStruct.instanceVar_gwell);
}
// End block evaluateStaticDynamic
//Begin block loadStatic
{
if ((sigVds>0.0))
{
// I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
d_staticContributions_dX[admsNodeID_DI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
// I(DI,SI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
d_staticContributions_dX[admsNodeID_DI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*(d_Ids_dX+d_Idsedge_dX)+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*(Ids+Idsedge));
d_staticContributions_dX[(admsNodeID_SI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*(d_Ids_dX+d_Idsedge_dX)+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*(Ids+Idsedge));
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
d_staticContributions_dX[(admsNodeID_SI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
d_staticContributions_dX[(admsNodeID_DI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
}
else
{
// I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Iimpact))
d_staticContributions_dX[admsNodeID_SI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Iimpact_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Iimpact);
// I(SI,DI) <+ (((CHNL_TYPE*MULT_i)*(Ids+Idsedge)))
d_staticContributions_dX[admsNodeID_SI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*(d_Ids_dX+d_Idsedge_dX)+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*(Ids+Idsedge));
d_staticContributions_dX[(admsNodeID_DI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*(d_Ids_dX+d_Idsedge_dX)+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*(Ids+Idsedge));
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igcs))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
d_staticContributions_dX[(admsNodeID_DI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcs);
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igcd))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
d_staticContributions_dX[(admsNodeID_SI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igcd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igcd);
}
// I(GP,BP) <+ (((CHNL_TYPE*MULT_i)*Igb))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igb);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igb);
// I(GP,SI) <+ (((CHNL_TYPE*MULT_i)*Igsov))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igsov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igsov);
d_staticContributions_dX[(admsNodeID_SI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igsov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igsov);
// I(GP,DI) <+ (((CHNL_TYPE*MULT_i)*Igdov))
d_staticContributions_dX[admsNodeID_GP]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igdov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igdov);
d_staticContributions_dX[(admsNodeID_DI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igdov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igdov);
// I(SI,BP) <+ (((CHNL_TYPE*MULT_i)*Igisl))
d_staticContributions_dX[admsNodeID_SI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igisl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igisl);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igisl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igisl);
// I(DI,BP) <+ (((CHNL_TYPE*MULT_i)*Igidl))
d_staticContributions_dX[admsNodeID_DI]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igidl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igidl);
d_staticContributions_dX[(admsNodeID_BP)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Igidl_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Igidl);
// I(BS,SI) <+ (((CHNL_TYPE*MULT_i)*ijun_s))
d_staticContributions_dX[admsNodeID_BS]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_s);
d_staticContributions_dX[(admsNodeID_SI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_s);
// I(BD,DI) <+ (((CHNL_TYPE*MULT_i)*ijun_d))
d_staticContributions_dX[admsNodeID_BD]+= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_d);
d_staticContributions_dX[(admsNodeID_DI)]-= ((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_ijun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*ijun_d);
if ((instanceStruct.instanceVar_RG_i>0.0))
{
// I(G,GP) <+ (((MULT_i*ggate)*V(G,GP)))
d_staticContributions_dX[admsNodeID_G]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_ggate_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]);
d_staticContributions_dX[(admsNodeID_GP)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_ggate_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_ggate)*(probeVars[admsProbeID_V_G_GP]);
// I(G,GP) <+ (white_noise((MULT_i*rgatenoise),"rgate"))
}
else
{
// V(G,GP) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RSE_i>0.0))
{
// I(S,SI) <+ (((MULT_i*gsource)*V(S,SI)))
d_staticContributions_dX[admsNodeID_S]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gsource_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gsource)*(probeVars[admsProbeID_V_S_SI]);
d_staticContributions_dX[(admsNodeID_SI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gsource_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gsource)*(probeVars[admsProbeID_V_S_SI]);
// I(S,SI) <+ (white_noise((MULT_i*rsourcenoise),"rsource"))
}
else
{
// V(S,SI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RDE_i>0.0))
{
// I(D,DI) <+ (((MULT_i*gdrain)*V(D,DI)))
d_staticContributions_dX[admsNodeID_D]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gdrain_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gdrain)*(probeVars[admsProbeID_V_D_DI]);
d_staticContributions_dX[(admsNodeID_DI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gdrain_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gdrain)*(probeVars[admsProbeID_V_D_DI]);
// I(D,DI) <+ (white_noise((MULT_i*rdrainnoise),"rdrain"))
}
else
{
// V(D,DI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RBULK_i>0.0))
{
// I(BP,BI) <+ (((MULT_i*gbulk)*V(BP,BI)))
d_staticContributions_dX[admsNodeID_BP]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gbulk_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gbulk_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gbulk)*(probeVars[admsProbeID_V_BP_BI]);
// I(BP,BI) <+ (white_noise((MULT_i*rbulknoise),"rbulk"))
}
else
{
// V(BP,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RJUNS_i>0.0))
{
// I(BS,BI) <+ (((MULT_i*gjuns)*V(BS,BI)))
d_staticContributions_dX[admsNodeID_BS]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjuns_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjuns_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjuns)*(probeVars[admsProbeID_V_BS_BI]);
// I(BS,BI) <+ (white_noise((MULT_i*rjunsnoise),"rjuns"))
}
else
{
// V(BS,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RJUND_i>0.0))
{
// I(BD,BI) <+ (((MULT_i*gjund)*V(BD,BI)))
d_staticContributions_dX[admsNodeID_BD]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjund_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gjund_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gjund)*(probeVars[admsProbeID_V_BD_BI]);
// I(BD,BI) <+ (white_noise((MULT_i*rjundnoise),"rjund"))
}
else
{
// V(BD,BI) <+ (0.0)
// do nothing at all
}
if ((instanceStruct.instanceVar_RWELL_i>0.0))
{
// I(B,BI) <+ (((MULT_i*gwell)*V(B,BI)))
d_staticContributions_dX[admsNodeID_B]+= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gwell_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]);
d_staticContributions_dX[(admsNodeID_BI)]-= (instanceStruct.instanceVar_MULT_i*instanceStruct.d_instanceVar_gwell_dX+instanceStruct.d_instanceVar_MULT_i_dX*instanceStruct.instanceVar_gwell)*(probeVars[admsProbeID_V_B_BI]);
// I(B,BI) <+ (white_noise((MULT_i*rwellnoise),"rwell"))
}
else
{
// V(B,BI) <+ (0.0)
// do nothing at all
}
// I(DI,SI) <+ ((1E-15*V(DI,SI)))
d_staticContributions_dX[admsNodeID_DI]+= 0.0;
d_staticContributions_dX[(admsNodeID_SI)]-= 0.0;
}
// End block loadStatic
//Begin block loadStaticDynamic
{
}
// End block loadStaticDynamic
//Begin block loadDynamic
{
//Block-local variables for block loadDynamic
double temp=0.0;
double d_temp_dX=0.0;
//End of Block-local variables
d_Qs_dX = (-((d_Qg_dX+d_Qb_dX)+d_Qd_dX));
Qs = (-((Qg+Qb)+Qd));
d_Qfgs_dX = (d_Qfgs_dX+d_Qgs_ov_dX);
Qfgs = (Qfgs+Qgs_ov);
d_Qfgd_dX = (d_Qfgd_dX+d_Qgd_ov_dX);
Qfgd = (Qfgd+Qgd_ov);
d_qjun_s_dX = (((instanceStruct.instanceVar_ABSOURCE_i*d_qjunbot_s_dX+instanceStruct.d_instanceVar_ABSOURCE_i_dX*qjunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*d_qjunsti_s_dX+instanceStruct.d_instanceVar_LSSOURCE_i_dX*qjunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*d_qjungat_s_dX+instanceStruct.d_instanceVar_LGSOURCE_i_dX*qjungat_s));
qjun_s = (((instanceStruct.instanceVar_ABSOURCE_i*qjunbot_s)+(instanceStruct.instanceVar_LSSOURCE_i*qjunsti_s))+(instanceStruct.instanceVar_LGSOURCE_i*qjungat_s));
d_qjun_d_dX = (((instanceStruct.instanceVar_ABDRAIN_i*d_qjunbot_d_dX+instanceStruct.d_instanceVar_ABDRAIN_i_dX*qjunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*d_qjunsti_d_dX+instanceStruct.d_instanceVar_LSDRAIN_i_dX*qjunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*d_qjungat_d_dX+instanceStruct.d_instanceVar_LGDRAIN_i_dX*qjungat_d));
qjun_d = (((instanceStruct.instanceVar_ABDRAIN_i*qjunbot_d)+(instanceStruct.instanceVar_LSDRAIN_i*qjunsti_d))+(instanceStruct.instanceVar_LGDRAIN_i*qjungat_d));
if ((sigVds<0.0))
{
d_temp_dX = d_Qd_dX;
temp = Qd;
d_Qd_dX = d_Qs_dX;
Qd = Qs;
d_Qs_dX = d_temp_dX;
Qs = temp;
}
// I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qg)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qg_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qg));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qg_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qg));
// I(BP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qb)))
d_dynamicContributions_dX[admsNodeID_BP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qb));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qb_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qb));
// I(DI,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qd)))
d_dynamicContributions_dX[admsNodeID_DI]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qd));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qd));
// I(GP,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgs)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgs));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgs_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgs));
// I(GP,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*Qfgd)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgd));
d_dynamicContributions_dX[(admsNodeID_DI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qfgd_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qfgd));
// I(GP,BP) <+ (ddt(((CHNL_TYPE*MULT_i)*Qgb_ov)))
d_dynamicContributions_dX[admsNodeID_GP]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qgb_ov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qgb_ov));
d_dynamicContributions_dX[(admsNodeID_BP)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_Qgb_ov_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*Qgb_ov));
// I(BS,SI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_s)))
d_dynamicContributions_dX[admsNodeID_BS]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_s));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_s_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_s));
// I(BD,DI) <+ (ddt(((CHNL_TYPE*MULT_i)*qjun_d)))
d_dynamicContributions_dX[admsNodeID_BD]+= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_d));
d_dynamicContributions_dX[(admsNodeID_DI)]-= (((modelStruct.modelVar_CHNL_TYPE*instanceStruct.instanceVar_MULT_i)*d_qjun_d_dX+modelStruct.modelVar_CHNL_TYPE*instanceStruct.d_instanceVar_MULT_i_dX*qjun_d));
}
// End block loadDynamic
//Begin block noise
{
//Block-local variables for block noise
double sf=0.0;
double d_sf_dX=0.0;
//End of Block-local variables
instanceStruct.d_instanceVar_Sfl_dX = 0.0;
instanceStruct.instanceVar_Sfl = 0.0;
d_Sidexc_dX = 0.0;
Sidexc = 0.0;
d_mid_dX = 0.0;
mid = 0.0;
instanceStruct.d_instanceVar_mig_dX = 0.0;
instanceStruct.instanceVar_mig = 1.0e-40;
d_migid_dX = 0.0;
migid = 0.0;
instanceStruct.d_instanceVar_c_igid_dX = 0.0;
instanceStruct.instanceVar_c_igid = 0.0;
instanceStruct.d_instanceVar_CGeff_dX = (COX_qm*d_eta_p_ac_dX+d_COX_qm_dX*eta_p_ac);
instanceStruct.instanceVar_CGeff = (COX_qm*eta_p_ac);
instanceStruct.d_instanceVar_sqid_dX = 0.0;
instanceStruct.instanceVar_sqid = 0.0;
d_sqig_dX = 0.0;
sqig = 0.0;
d_Sfledge_dX = 0.0;
Sfledge = 0.0;
d_midedge_dX = 0.0;
midedge = 0.0;
d_sqidedge_dX = 0.0;
sqidedge = 0.0;
if ((((xg_dc>0.0)&&(instanceStruct.instanceVar_MULT_i>0.0))&&(instanceStruct.instanceVar_BET_i>0.0)))
{
d_N1_dX = ((instanceStruct.instanceVar_Cox_over_q*alpha_dc)*modelStruct.d_modelVar_phit_dX+(instanceStruct.instanceVar_Cox_over_q*d_alpha_dc_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*alpha_dc)*modelStruct.modelVar_phit);
N1 = ((instanceStruct.instanceVar_Cox_over_q*alpha_dc)*modelStruct.modelVar_phit);
d_Nm1_dX = (instanceStruct.instanceVar_Cox_over_q*d_qim1_dc_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*qim1_dc);
Nm1 = (instanceStruct.instanceVar_Cox_over_q*qim1_dc);
d_Delta_N1_dX = ((instanceStruct.instanceVar_Cox_over_q*alpha_dc)*d_dps_dc_dX+(instanceStruct.instanceVar_Cox_over_q*d_alpha_dc_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*alpha_dc)*dps_dc);
Delta_N1 = ((instanceStruct.instanceVar_Cox_over_q*alpha_dc)*dps_dc);
{
double value_log_0 = log(((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
double  deriv_log_0_d0 = (1.0/((Nm1+(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))));
instanceStruct.d_instanceVar_Sfl_dX = (((instanceStruct.instanceVar_NFA_i-(instanceStruct.instanceVar_NFB_i*N1))+(instanceStruct.instanceVar_NFC_i*(N1*N1)))*deriv_log_0_d0*((((Nm1-(0.5*Delta_N1))*(d_Nm1_dX+0.5*d_Delta_N1_dX)-(Nm1+(0.5*Delta_N1))*(d_Nm1_dX-0.5*d_Delta_N1_dX))/(Nm1-(0.5*Delta_N1))/(Nm1-(0.5*Delta_N1))))+((instanceStruct.d_instanceVar_NFA_i_dX-(instanceStruct.instanceVar_NFB_i*d_N1_dX+instanceStruct.d_instanceVar_NFB_i_dX*N1))+(instanceStruct.instanceVar_NFC_i*(N1*d_N1_dX+d_N1_dX*N1)+instanceStruct.d_instanceVar_NFC_i_dX*(N1*N1)))*value_log_0);
instanceStruct.instanceVar_Sfl = (((instanceStruct.instanceVar_NFA_i-(instanceStruct.instanceVar_NFB_i*N1))+(instanceStruct.instanceVar_NFC_i*(N1*N1)))*value_log_0);
}
instanceStruct.d_instanceVar_Sfl_dX = (instanceStruct.d_instanceVar_Sfl_dX+((instanceStruct.instanceVar_NFB_i+(instanceStruct.instanceVar_NFC_i*(Nm1-(2.0*N1))))*d_Delta_N1_dX+(instanceStruct.d_instanceVar_NFB_i_dX+(instanceStruct.instanceVar_NFC_i*(d_Nm1_dX-2.0*d_N1_dX)+instanceStruct.d_instanceVar_NFC_i_dX*(Nm1-(2.0*N1))))*Delta_N1));
instanceStruct.instanceVar_Sfl = (instanceStruct.instanceVar_Sfl+((instanceStruct.instanceVar_NFB_i+(instanceStruct.instanceVar_NFC_i*(Nm1-(2.0*N1))))*Delta_N1));
instanceStruct.d_instanceVar_Sfl_dX = ((N1*(((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv_dc)*instanceStruct.d_instanceVar_Sfl_dX+((instanceStruct.instanceVar_Sfl_prefac*Ids)*d_Gvsatinv_dc_dX+(instanceStruct.instanceVar_Sfl_prefac*d_Ids_dX+instanceStruct.d_instanceVar_Sfl_prefac_dX*Ids)*Gvsatinv_dc)*instanceStruct.instanceVar_Sfl)-(((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv_dc)*instanceStruct.instanceVar_Sfl)*d_N1_dX)/N1/N1);
instanceStruct.instanceVar_Sfl = ((((instanceStruct.instanceVar_Sfl_prefac*Ids)*Gvsatinv_dc)*instanceStruct.instanceVar_Sfl)/N1);
instanceStruct.d_instanceVar_Sfl_dX = ((instanceStruct.instanceVar_Sfl>0.0)?instanceStruct.d_instanceVar_Sfl_dX:0.0);
instanceStruct.instanceVar_Sfl = ((instanceStruct.instanceVar_Sfl>0.0)?instanceStruct.instanceVar_Sfl:0.0);
d_H0_dX = ((alpha_dc*d_qim1_dc_dX-qim1_dc*d_alpha_dc_dX)/alpha_dc/alpha_dc);
H0 = (qim1_dc/alpha_dc);
d_t1_dX = ((qim1_dc*d_qim_dc_dX-qim_dc*d_qim1_dc_dX)/qim1_dc/qim1_dc);
t1 = (qim_dc/qim1_dc);
d_sqt2_dX = (0.5*1.6666666666666667e-01)*((H0*d_dps_dc_dX-dps_dc*d_H0_dX)/H0/H0);
sqt2 = ((0.5*1.6666666666666667e-01)*(dps_dc/H0));
d_t2_dX = (sqt2*d_sqt2_dX+d_sqt2_dX*sqt2);
t2 = (sqt2*sqt2);
d_r_dX = ((H_dc*d_H0_dX-H0*d_H_dc_dX)/H_dc/H_dc);
r = ((H0/H_dc)-1.0);
d_lc_dX = (((1.0-(12.0*(r*t2)))>1.0e-20)?(-12.0*(r*d_t2_dX+d_r_dX*t2)):0.0);
lc = (((1.0-(12.0*(r*t2)))>1.0e-20)?(1.0-(12.0*(r*t2))):1.0e-20);
d_lcinv2_dX = (-(lc*d_lc_dX+d_lc_dX*lc)/(lc*lc)/(lc*lc));
lcinv2 = (1.0/(lc*lc));
d_g_ideal_dX = (instanceStruct.instanceVar_BET_i*((FdL_dc*qim1_dc)*d_Gvsatinv_dc_dX+(FdL_dc*d_qim1_dc_dX+d_FdL_dc_dX*qim1_dc)*Gvsatinv_dc)+instanceStruct.d_instanceVar_BET_i_dX*((FdL_dc*qim1_dc)*Gvsatinv_dc));
g_ideal = (instanceStruct.instanceVar_BET_i*((FdL_dc*qim1_dc)*Gvsatinv_dc));
d_mid_dX = ((d_t1_dX+12.0*d_t2_dX)-24.0*(((1.0+t1)*t2)*d_r_dX+((1.0+t1)*d_t2_dX+d_t1_dX*t2)*r));
mid = ((t1+(12.0*t2))-(24.0*(((1.0+t1)*t2)*r)));
d_mid_dX = ((mid>1.0e-40)?d_mid_dX:0.0);
mid = ((mid>1.0e-40)?mid:1.0e-40);
d_mid_dX = ((g_ideal*lcinv2)*d_mid_dX+(g_ideal*d_lcinv2_dX+d_g_ideal_dX*lcinv2)*mid);
mid = ((g_ideal*lcinv2)*mid);
if ((instanceStruct.instanceVar_FNTEXC_i>0.0))
{
d_temp2_exc_dX = (qim_dc*d_xitsb_dc_dX+d_qim_dc_dX*xitsb_dc);
temp2_exc = (qim_dc*xitsb_dc);
d_wsat_exc_dX = 100.0*(((100.0+temp2_exc)*d_temp2_exc_dX-temp2_exc*d_temp2_exc_dX)/(100.0+temp2_exc)/(100.0+temp2_exc));
wsat_exc = (100.0*(temp2_exc/(100.0+temp2_exc)));
if ((instanceStruct.instanceVar_THESATG_i<0))
{
d_temp_exc_dX = (-(-(instanceStruct.instanceVar_THESATG_i*d_wsat_exc_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat_exc))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat_exc))/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat_exc)));
temp_exc = (1.0/(1.0-(instanceStruct.instanceVar_THESATG_i*wsat_exc)));
}
else
{
d_temp_exc_dX = (instanceStruct.instanceVar_THESATG_i*d_wsat_exc_dX+instanceStruct.d_instanceVar_THESATG_i_dX*wsat_exc);
temp_exc = (1.0+(instanceStruct.instanceVar_THESATG_i*wsat_exc));
}
d_thesat1_exc_dX = (instanceStruct.instanceVar_THESAT_T*((Gmob_dc*d_temp_exc_dX-temp_exc*d_Gmob_dc_dX)/Gmob_dc/Gmob_dc)+instanceStruct.d_instanceVar_THESAT_T_dX*(temp_exc/Gmob_dc));
thesat1_exc = (instanceStruct.instanceVar_THESAT_T*(temp_exc/Gmob_dc));
d_zsat_exc_dX = (((thesat1_exc*thesat1_exc)*dps_dc)*d_dps_dc_dX+((thesat1_exc*thesat1_exc)*d_dps_dc_dX+(thesat1_exc*d_thesat1_exc_dX+d_thesat1_exc_dX*thesat1_exc)*dps_dc)*dps_dc);
zsat_exc = (((thesat1_exc*thesat1_exc)*dps_dc)*dps_dc);
if ((modelStruct.modelVar_CHNL_TYPE==(-1)))
{
d_zsat_exc_dX = (((1.0+(thesat1_exc*dps_dc))*d_zsat_exc_dX-zsat_exc*(thesat1_exc*d_dps_dc_dX+d_thesat1_exc_dX*dps_dc))/(1.0+(thesat1_exc*dps_dc))/(1.0+(thesat1_exc*dps_dc)));
zsat_exc = (zsat_exc/(1.0+(thesat1_exc*dps_dc)));
}
{
double value_sqrt_0 = sqrt((1.0+(2.0*zsat_exc)));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_Gvsat_exc_dX = 0.5*(Gmob_dc*deriv_sqrt_0_d0*(2.0*d_zsat_exc_dX)+d_Gmob_dc_dX*(1.0+value_sqrt_0));
Gvsat_exc = (0.5*(Gmob_dc*(1.0+value_sqrt_0)));
}
d_gfac_dX = (((Gvsat_exc*lc)*d_Gmob_dc_dX-Gmob_dc*(Gvsat_exc*d_lc_dX+d_Gvsat_exc_dX*lc))/(Gvsat_exc*lc)/(Gvsat_exc*lc));
gfac = (Gmob_dc/(Gvsat_exc*lc));
d_Sidexc_dX = ((((instanceStruct.instanceVar_fac_exc*Ids)*Vdse_dc)*gfac)*d_gfac_dX+(((instanceStruct.instanceVar_fac_exc*Ids)*Vdse_dc)*d_gfac_dX+((instanceStruct.instanceVar_fac_exc*Ids)*d_Vdse_dc_dX+(instanceStruct.instanceVar_fac_exc*d_Ids_dX+instanceStruct.d_instanceVar_fac_exc_dX*Ids)*Vdse_dc)*gfac)*gfac);
Sidexc = ((((instanceStruct.instanceVar_fac_exc*Ids)*Vdse_dc)*gfac)*gfac);
d_mid_dX = (d_mid_dX+((modelStruct.modelVar_nt0*d_Sidexc_dX-Sidexc*modelStruct.d_modelVar_nt0_dX)/modelStruct.modelVar_nt0/modelStruct.modelVar_nt0));
mid = (mid+(Sidexc/modelStruct.modelVar_nt0));
}
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_nt*mid));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
instanceStruct.d_instanceVar_sqid_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_nt*d_mid_dX+instanceStruct.d_instanceVar_nt_dX*mid));
instanceStruct.instanceVar_sqid = value_sqrt_0;
}
if ((modelStruct.modelVar_SWIGN_i==1))
{
instanceStruct.d_instanceVar_mig_dX = (((d_t1_dX/12.0)-(t2*(d_t1_dX-12.0*d_t2_dX)+d_t2_dX*((t1+0.2)-(12.0*t2))))-1.6*((t2*((t1+1.0)-(12.0*t2)))*d_r_dX+(t2*(d_t1_dX-12.0*d_t2_dX)+d_t2_dX*((t1+1.0)-(12.0*t2)))*r));
instanceStruct.instanceVar_mig = (((t1/12.0)-(t2*((t1+0.2)-(12.0*t2))))-(1.6*((t2*((t1+1.0)-(12.0*t2)))*r)));
instanceStruct.d_instanceVar_mig_dX = ((instanceStruct.instanceVar_mig>1.0e-40)?instanceStruct.d_instanceVar_mig_dX:0.0);
instanceStruct.instanceVar_mig = ((instanceStruct.instanceVar_mig>1.0e-40)?instanceStruct.instanceVar_mig:1.0e-40);
instanceStruct.d_instanceVar_mig_dX = ((lcinv2/g_ideal)*instanceStruct.d_instanceVar_mig_dX+((g_ideal*d_lcinv2_dX-lcinv2*d_g_ideal_dX)/g_ideal/g_ideal)*instanceStruct.instanceVar_mig);
instanceStruct.instanceVar_mig = ((lcinv2/g_ideal)*instanceStruct.instanceVar_mig);
d_migid_dX = ((lcinv2*sqt2)*((-12.0*d_t2_dX)-(((t1+(19.2*t2))-(12.0*(t1*t2)))*d_r_dX+((d_t1_dX+19.2*d_t2_dX)-12.0*(t1*d_t2_dX+d_t1_dX*t2))*r))+(lcinv2*d_sqt2_dX+d_lcinv2_dX*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
migid = ((lcinv2*sqt2)*((1.0-(12.0*t2))-(((t1+(19.2*t2))-(12.0*(t1*t2)))*r)));
instanceStruct.d_instanceVar_CGeff_dX = (((Gmob_dL_ac*Gmob_dL_ac)*(((Gvsat_ac*Gvsat_ac)*COX_qm)*d_eta_p_ac_dX+((Gvsat_ac*Gvsat_ac)*d_COX_qm_dX+(Gvsat_ac*d_Gvsat_ac_dX+d_Gvsat_ac_dX*Gvsat_ac)*COX_qm)*eta_p_ac)-(((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)*(Gmob_dL_ac*d_Gmob_dL_ac_dX+d_Gmob_dL_ac_dX*Gmob_dL_ac))/(Gmob_dL_ac*Gmob_dL_ac)/(Gmob_dL_ac*Gmob_dL_ac));
instanceStruct.instanceVar_CGeff = ((((Gvsat_ac*Gvsat_ac)*COX_qm)*eta_p_ac)/(Gmob_dL_ac*Gmob_dL_ac));
if ((instanceStruct.instanceVar_FNTEXC_i>0.0))
{
instanceStruct.d_instanceVar_mig_dX = (instanceStruct.d_instanceVar_mig_dX+(((((12.0*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)*(Sidexc*12.0*d_t2_dX+d_Sidexc_dX*(1.0+(12.0*t2)))-(Sidexc*(1.0+(12.0*t2)))*(((12.0*g_ideal)*g_ideal)*modelStruct.d_modelVar_nt0_dX+((12.0*g_ideal)*d_g_ideal_dX+12.0*d_g_ideal_dX*g_ideal)*modelStruct.modelVar_nt0))/(((12.0*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)/(((12.0*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)));
instanceStruct.instanceVar_mig = (instanceStruct.instanceVar_mig+((Sidexc*(1.0+(12.0*t2)))/(((12.0*g_ideal)*g_ideal)*modelStruct.modelVar_nt0)));
d_migid_dX = (d_migid_dX-(((g_ideal*modelStruct.modelVar_nt0)*((Sidexc*sqt2)*d_r_dX+(Sidexc*d_sqt2_dX+d_Sidexc_dX*sqt2)*(1.0+r))-((Sidexc*sqt2)*(1.0+r))*(g_ideal*modelStruct.d_modelVar_nt0_dX+d_g_ideal_dX*modelStruct.modelVar_nt0))/(g_ideal*modelStruct.modelVar_nt0)/(g_ideal*modelStruct.modelVar_nt0)));
migid = (migid-(((Sidexc*sqt2)*(1.0+r))/(g_ideal*modelStruct.modelVar_nt0)));
}
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_nt/instanceStruct.instanceVar_mig));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqig_dX = deriv_sqrt_0_d0*(((instanceStruct.instanceVar_mig*instanceStruct.d_instanceVar_nt_dX-instanceStruct.instanceVar_nt*instanceStruct.d_instanceVar_mig_dX)/instanceStruct.instanceVar_mig/instanceStruct.instanceVar_mig));
sqig = value_sqrt_0;
}
if ((instanceStruct.instanceVar_sqid==0))
{
instanceStruct.d_instanceVar_c_igid_dX = 0.0;
instanceStruct.instanceVar_c_igid = 0.0;
}
else
{
instanceStruct.d_instanceVar_c_igid_dX = ((instanceStruct.instanceVar_sqid*(migid*d_sqig_dX+d_migid_dX*sqig)-(migid*sqig)*instanceStruct.d_instanceVar_sqid_dX)/instanceStruct.instanceVar_sqid/instanceStruct.instanceVar_sqid);
instanceStruct.instanceVar_c_igid = ((migid*sqig)/instanceStruct.instanceVar_sqid);
}
instanceStruct.d_instanceVar_c_igid_dX = ((instanceStruct.instanceVar_c_igid>0.0)?((instanceStruct.instanceVar_c_igid<1.0)?instanceStruct.d_instanceVar_c_igid_dX:0.0):0.0);
instanceStruct.instanceVar_c_igid = ((instanceStruct.instanceVar_c_igid>0.0)?((instanceStruct.instanceVar_c_igid<1.0)?instanceStruct.instanceVar_c_igid:1.0):0.0);
}
}
{
double value_fabs_0 = fabs(Igcs);
double  deriv_fabs_0_d0 = (((Igcs)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igcsx_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igcs_dX);
instanceStruct.instanceVar_shot_igcsx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igcd);
double  deriv_fabs_0_d0 = (((Igcd)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igcdx_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igcd_dX);
instanceStruct.instanceVar_shot_igcdx = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igsov);
double  deriv_fabs_0_d0 = (((Igsov)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igsov_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igsov_dX);
instanceStruct.instanceVar_shot_igsov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Igdov);
double  deriv_fabs_0_d0 = (((Igdov)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_igdov_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_Igdov_dX);
instanceStruct.instanceVar_shot_igdov = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(Iimpact);
double  deriv_fabs_0_d0 = (((Iimpact)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_shot_iavl_dX = (2.0*1.6021918E-19)*((mavl+1)*deriv_fabs_0_d0*(d_Iimpact_dX)+d_mavl_dX*value_fabs_0);
instanceStruct.instanceVar_shot_iavl = ((2.0*1.6021918E-19)*((mavl+1)*value_fabs_0));
}
{
double value_fabs_0 = fabs(ijun_s);
double  deriv_fabs_0_d0 = (((ijun_s)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_jnoisex_s_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_ijun_s_dX);
instanceStruct.instanceVar_jnoisex_s = ((2.0*1.6021918E-19)*value_fabs_0);
}
{
double value_fabs_0 = fabs(ijun_d);
double  deriv_fabs_0_d0 = (((ijun_d)>=0)?(+1.0):(-1.0));
instanceStruct.d_instanceVar_jnoisex_d_dX = (2.0*1.6021918E-19)*deriv_fabs_0_d0*(d_ijun_d_dX);
instanceStruct.instanceVar_jnoisex_d = ((2.0*1.6021918E-19)*value_fabs_0);
}
if ((sigVds>0.0))
{
d_shot_igs_dX = (instanceStruct.d_instanceVar_shot_igcsx_dX+instanceStruct.d_instanceVar_shot_igsov_dX);
shot_igs = (instanceStruct.instanceVar_shot_igcsx+instanceStruct.instanceVar_shot_igsov);
d_shot_igd_dX = (instanceStruct.d_instanceVar_shot_igcdx_dX+instanceStruct.d_instanceVar_shot_igdov_dX);
shot_igd = (instanceStruct.instanceVar_shot_igcdx+instanceStruct.instanceVar_shot_igdov);
d_jnoise_s_dX = instanceStruct.d_instanceVar_jnoisex_s_dX;
jnoise_s = instanceStruct.instanceVar_jnoisex_s;
d_jnoise_d_dX = (instanceStruct.d_instanceVar_jnoisex_d_dX+instanceStruct.d_instanceVar_shot_iavl_dX);
jnoise_d = (instanceStruct.instanceVar_jnoisex_d+instanceStruct.instanceVar_shot_iavl);
}
else
{
d_shot_igs_dX = (instanceStruct.d_instanceVar_shot_igcdx_dX+instanceStruct.d_instanceVar_shot_igsov_dX);
shot_igs = (instanceStruct.instanceVar_shot_igcdx+instanceStruct.instanceVar_shot_igsov);
d_shot_igd_dX = (instanceStruct.d_instanceVar_shot_igcsx_dX+instanceStruct.d_instanceVar_shot_igdov_dX);
shot_igd = (instanceStruct.instanceVar_shot_igcsx+instanceStruct.instanceVar_shot_igdov);
d_jnoise_s_dX = (instanceStruct.d_instanceVar_jnoisex_s_dX+instanceStruct.d_instanceVar_shot_iavl_dX);
jnoise_s = (instanceStruct.instanceVar_jnoisex_s+instanceStruct.instanceVar_shot_iavl);
d_jnoise_d_dX = instanceStruct.d_instanceVar_jnoisex_d_dX;
jnoise_d = instanceStruct.instanceVar_jnoisex_d;
}
if ((((modelStruct.modelVar_SWEDGE_i!=0.0)&&(instanceStruct.instanceVar_BETNEDGE_i>0))&&(xgedge>0)))
{
d_temp1_dX = ((instanceStruct.instanceVar_Gfedge2*4.0*d_dsqredge_dX-(4.0*dsqredge)*instanceStruct.d_instanceVar_Gfedge2_dX)/instanceStruct.instanceVar_Gfedge2/instanceStruct.instanceVar_Gfedge2);
temp1 = ((4.0*dsqredge)/instanceStruct.instanceVar_Gfedge2);
{
double value_sqrt_0 = sqrt((temp1+1.0));
double value_sqrt_1 = sqrt((temp1+1.1));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
double  deriv_sqrt_1_d0 = (0.5/value_sqrt_1);
d_anoisedge_dX = (((value_sqrt_1-1.0)*deriv_sqrt_0_d0*(d_temp1_dX)-value_sqrt_0*deriv_sqrt_1_d0*(d_temp1_dX))/(value_sqrt_1-1.0)/(value_sqrt_1-1.0));
anoisedge = (value_sqrt_0/(value_sqrt_1-1.0));
}
d_temp1_dX = (instanceStruct.instanceVar_Cox_over_q*modelStruct.d_modelVar_phit_dX+instanceStruct.d_instanceVar_Cox_over_q_dX*modelStruct.modelVar_phit);
temp1 = (instanceStruct.instanceVar_Cox_over_q*modelStruct.modelVar_phit);
d_N1edge_dX = (temp1*d_anoisedge_dX+d_temp1_dX*anoisedge);
N1edge = (temp1*anoisedge);
d_Nm1edge_dX = (temp1*(d_qmeffedge_dX+d_anoisedge_dX)+d_temp1_dX*(qmeffedge+anoisedge));
Nm1edge = (temp1*(qmeffedge+anoisedge));
d_Delta_N1edge_dX = ((((-temp1)*anoisedge)*alphabmedge)*d_qdseffedge_dX+(((-temp1)*anoisedge)*d_alphabmedge_dX+((-temp1)*d_anoisedge_dX+(-d_temp1_dX)*anoisedge)*alphabmedge)*qdseffedge);
Delta_N1edge = ((((-temp1)*anoisedge)*alphabmedge)*qdseffedge);
{
double value_log_0 = log(((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
double  deriv_log_0_d0 = (1.0/((Nm1edge+(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))));
d_Sfledge_dX = ((instanceStruct.instanceVar_NFAEDGE_i-((instanceStruct.instanceVar_NFBEDGE_i-(instanceStruct.instanceVar_NFCEDGE_i*N1edge))*N1edge))*deriv_log_0_d0*((((Nm1edge-(0.5*Delta_N1edge))*(d_Nm1edge_dX+0.5*d_Delta_N1edge_dX)-(Nm1edge+(0.5*Delta_N1edge))*(d_Nm1edge_dX-0.5*d_Delta_N1edge_dX))/(Nm1edge-(0.5*Delta_N1edge))/(Nm1edge-(0.5*Delta_N1edge))))+(instanceStruct.d_instanceVar_NFAEDGE_i_dX-((instanceStruct.instanceVar_NFBEDGE_i-(instanceStruct.instanceVar_NFCEDGE_i*N1edge))*d_N1edge_dX+(instanceStruct.d_instanceVar_NFBEDGE_i_dX-(instanceStruct.instanceVar_NFCEDGE_i*d_N1edge_dX+instanceStruct.d_instanceVar_NFCEDGE_i_dX*N1edge))*N1edge))*value_log_0);
Sfledge = ((instanceStruct.instanceVar_NFAEDGE_i-((instanceStruct.instanceVar_NFBEDGE_i-(instanceStruct.instanceVar_NFCEDGE_i*N1edge))*N1edge))*value_log_0);
}
d_Sfledge_dX = (d_Sfledge_dX+((instanceStruct.instanceVar_NFBEDGE_i+(instanceStruct.instanceVar_NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*d_Delta_N1edge_dX+(instanceStruct.d_instanceVar_NFBEDGE_i_dX+(instanceStruct.instanceVar_NFCEDGE_i*(d_Nm1edge_dX-2.0*d_N1edge_dX)+instanceStruct.d_instanceVar_NFCEDGE_i_dX*(Nm1edge-(2.0*N1edge))))*Delta_N1edge));
Sfledge = (Sfledge+((instanceStruct.instanceVar_NFBEDGE_i+(instanceStruct.instanceVar_NFCEDGE_i*(Nm1edge-(2.0*N1edge))))*Delta_N1edge));
d_Sfledge_dX = ((N1edge*(((instanceStruct.instanceVar_Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*d_Sfledge_dX+((instanceStruct.instanceVar_Sfl_prefac_edge*Idsedge)*d_Gvsatinv_dc_dX+(instanceStruct.instanceVar_Sfl_prefac_edge*d_Idsedge_dX+instanceStruct.d_instanceVar_Sfl_prefac_edge_dX*Idsedge)*Gvsatinv_dc)*Sfledge)-(((instanceStruct.instanceVar_Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)*d_N1edge_dX)/N1edge/N1edge);
Sfledge = ((((instanceStruct.instanceVar_Sfl_prefac_edge*Idsedge)*Gvsatinv_dc)*Sfledge)/N1edge);
d_Sfledge_dX = ((Sfledge>0.0)?d_Sfledge_dX:0.0);
Sfledge = ((Sfledge>0.0)?Sfledge:0.0);
d_H0edge_dX = ((anoisedge*(modelStruct.modelVar_phit*(d_qmeffedge_dX+d_anoisedge_dX)+modelStruct.d_modelVar_phit_dX*(qmeffedge+anoisedge))-(modelStruct.modelVar_phit*(qmeffedge+anoisedge))*d_anoisedge_dX)/anoisedge/anoisedge);
H0edge = ((modelStruct.modelVar_phit*(qmeffedge+anoisedge))/anoisedge);
d_t1edge_dX = (((qmeffedge+anoisedge)*((phit1/modelStruct.modelVar_phit)*d_qmeffedge_dX+((modelStruct.modelVar_phit*d_phit1_dX-phit1*modelStruct.d_modelVar_phit_dX)/modelStruct.modelVar_phit/modelStruct.modelVar_phit)*qmeffedge)-((phit1/modelStruct.modelVar_phit)*qmeffedge)*(d_qmeffedge_dX+d_anoisedge_dX))/(qmeffedge+anoisedge)/(qmeffedge+anoisedge));
t1edge = (((phit1/modelStruct.modelVar_phit)*qmeffedge)/(qmeffedge+anoisedge));
d_sqt2edge_dX = ((H0edge*(((((-0.5)*1.6666666666666667e-01)*modelStruct.modelVar_phit)*alphabmedge)*d_qdseffedge_dX+((((-0.5)*1.6666666666666667e-01)*modelStruct.modelVar_phit)*d_alphabmedge_dX+((-0.5)*1.6666666666666667e-01)*modelStruct.d_modelVar_phit_dX*alphabmedge)*qdseffedge)-(((((-0.5)*1.6666666666666667e-01)*modelStruct.modelVar_phit)*alphabmedge)*qdseffedge)*d_H0edge_dX)/H0edge/H0edge);
sqt2edge = ((((((-0.5)*1.6666666666666667e-01)*modelStruct.modelVar_phit)*alphabmedge)*qdseffedge)/H0edge);
d_t2edge_dX = (sqt2edge*d_sqt2edge_dX+d_sqt2edge_dX*sqt2edge);
t2edge = (sqt2edge*sqt2edge);
d_redge_dX = ((H_dc*((anoisedge/alpha_dc)*d_H0edge_dX+((alpha_dc*d_anoisedge_dX-anoisedge*d_alpha_dc_dX)/alpha_dc/alpha_dc)*H0edge)-((anoisedge/alpha_dc)*H0edge)*d_H_dc_dX)/H_dc/H_dc);
redge = ((((anoisedge/alpha_dc)*H0edge)/H_dc)-1.0);
d_lcedge_dX = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(-12.0*(redge*d_t2edge_dX+d_redge_dX*t2edge)):0.0);
lcedge = (((1.0-(12.0*(redge*t2edge)))>1.0e-20)?(1.0-(12.0*(redge*t2edge))):1.0e-20);
d_lcinv2edge_dX = (-(lcedge*d_lcedge_dX+d_lcedge_dX*lcedge)/(lcedge*lcedge)/(lcedge*lcedge));
lcinv2edge = (1.0/(lcedge*lcedge));
d_g_idealedge_dX = ((((instanceStruct.instanceVar_BETEDGE_i*modelStruct.modelVar_phit)*(qmeffedge+anoisedge))*FdL_dc)*d_Gvsatinv_dc_dX+(((instanceStruct.instanceVar_BETEDGE_i*modelStruct.modelVar_phit)*(qmeffedge+anoisedge))*d_FdL_dc_dX+((instanceStruct.instanceVar_BETEDGE_i*modelStruct.modelVar_phit)*(d_qmeffedge_dX+d_anoisedge_dX)+(instanceStruct.instanceVar_BETEDGE_i*modelStruct.d_modelVar_phit_dX+instanceStruct.d_instanceVar_BETEDGE_i_dX*modelStruct.modelVar_phit)*(qmeffedge+anoisedge))*FdL_dc)*Gvsatinv_dc);
g_idealedge = ((((instanceStruct.instanceVar_BETEDGE_i*modelStruct.modelVar_phit)*(qmeffedge+anoisedge))*FdL_dc)*Gvsatinv_dc);
d_midedge_dX = ((d_t1edge_dX+12.0*d_t2edge_dX)-24.0*(((1.0+t1edge)*t2edge)*d_redge_dX+((1.0+t1edge)*d_t2edge_dX+d_t1edge_dX*t2edge)*redge));
midedge = ((t1edge+(12.0*t2edge))-(24.0*(((1.0+t1edge)*t2edge)*redge)));
d_midedge_dX = ((midedge>1.0e-40)?d_midedge_dX:0.0);
midedge = ((midedge>1.0e-40)?midedge:1.0e-40);
d_midedge_dX = ((g_idealedge*lcinv2edge)*d_midedge_dX+(g_idealedge*d_lcinv2edge_dX+d_g_idealedge_dX*lcinv2edge)*midedge);
midedge = ((g_idealedge*lcinv2edge)*midedge);
{
double value_sqrt_0 = sqrt((instanceStruct.instanceVar_ntedge*midedge));
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_sqidedge_dX = deriv_sqrt_0_d0*((instanceStruct.instanceVar_ntedge*d_midedge_dX+instanceStruct.d_instanceVar_ntedge_dX*midedge));
sqidedge = value_sqrt_0;
}
}
d_sf_dX = ((1.0e+6*instanceStruct.instanceVar_CGeff)*instanceStruct.d_instanceVar_mig_dX+1.0e+6*instanceStruct.d_instanceVar_CGeff_dX*instanceStruct.instanceVar_mig);
sf = ((1.0e+6*instanceStruct.instanceVar_CGeff)*instanceStruct.instanceVar_mig);
// I(NOI2,GND) <+ (V(NOI2,GND))
d_staticContributions_dX[admsNodeID_NOI2]+= 0.0;
// I(NOI2,GND) <+ (white_noise((((nt/mig)*sf)*sf),"igig"))
// I(NOI,GND) <+ (((-V(NOI2,GND))/sf))
d_staticContributions_dX[admsNodeID_NOI]+= (-(-(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX/sf/sf);
// I(NOI,GND) <+ ((V(NOI,GND)/mig))
d_staticContributions_dX[admsNodeID_NOI]+= (-(probeVars[admsProbeID_V_NOI_GND])*instanceStruct.d_instanceVar_mig_dX/instanceStruct.instanceVar_mig/instanceStruct.instanceVar_mig);
// I(NOI,GND) <+ (ddt((CGeff*V(NOI,GND))))
d_dynamicContributions_dX[admsNodeID_NOI]+= (instanceStruct.d_instanceVar_CGeff_dX*(probeVars[admsProbeID_V_NOI_GND]));
// I(GP,SI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dynamicContributions_dX[admsNodeID_GP]+= (-(((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions_dX[(admsNodeID_SI)]-= (-(((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
}
// I(GP,DI) <+ ((-ddt((((sqrt(MULT_i)*0.5)*CGeff)*V(NOI,GND)))))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_dynamicContributions_dX[admsNodeID_GP]+= (-(((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
d_dynamicContributions_dX[(admsNodeID_DI)]-= (-(((value_sqrt_0*0.5)*instanceStruct.d_instanceVar_CGeff_dX+deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*0.5*instanceStruct.instanceVar_CGeff)*(probeVars[admsProbeID_V_NOI_GND])));
}
// I(DI,SI) <+ (((((sigVds*sqrt(MULT_i))*migid)*V(NOI2,GND))/sf))
{
double value_sqrt_0 = sqrt(instanceStruct.instanceVar_MULT_i);
double  deriv_sqrt_0_d0 = (0.5/value_sqrt_0);
d_staticContributions_dX[admsNodeID_DI]+= ((sf*((sigVds*value_sqrt_0)*d_migid_dX+sigVds*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*migid)*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX)/sf/sf);
d_staticContributions_dX[(admsNodeID_SI)]-= ((sf*((sigVds*value_sqrt_0)*d_migid_dX+sigVds*deriv_sqrt_0_d0*(instanceStruct.d_instanceVar_MULT_i_dX)*migid)*(probeVars[admsProbeID_V_NOI2_GND])-(((sigVds*value_sqrt_0)*migid)*(probeVars[admsProbeID_V_NOI2_GND]))*d_sf_dX)/sf/sf);
}
// I(DI,SI) <+ (white_noise((((MULT_i*sqid)*sqid)*(1.0-(c_igid*c_igid))),"idid"))
// I(DI,SI) <+ (flicker_noise((MULT_i*Sfl),EF_i,"flicker"))
// I(GP,SI) <+ (white_noise((MULT_i*shot_igs),"igs"))
// I(GP,DI) <+ (white_noise((MULT_i*shot_igd),"igd"))
// I(BS,SI) <+ (white_noise((MULT_i*jnoise_s),"ibs"))
// I(BD,DI) <+ (white_noise((MULT_i*jnoise_d),"ibd"))
// I(DI,SI) <+ (flicker_noise((MULT_i*Sfledge),EFEDGE_i,"flicker"))
// I(DI,SI) <+ (white_noise(((MULT_i*sqidedge)*sqidedge),"ididedge"))
}
// End block noise
//Begin block OPinfo
{
d_id_op_dX = (((d_Ids_dX+d_Idsedge_dX)+d_Iimpact_dX)-d_Igcd_dX);
id_op = (((Ids+Idsedge)+Iimpact)-Igcd);
d_is_dX = (((-d_Ids_dX)-d_Idsedge_dX)-d_Igcs_dX);
is = (((-Ids)-Idsedge)-Igcs);
d_ig_dX = ((((d_Igcs_dX+d_Igcd_dX)+d_Igsov_dX)+d_Igdov_dX)+d_Igb_dX);
ig = ((((Igcs+Igcd)+Igsov)+Igdov)+Igb);
d_ib_dX = ((((-d_Iimpact_dX)-d_Igb_dX)-d_Igidl_dX)-d_Igisl_dX);
ib = ((((-Iimpact)-Igb)-Igidl)-Igisl);
d_sig1k_dX = (2.0e3*3.1415926535897931)*instanceStruct.d_instanceVar_CGeff_dX;
sig1k = ((2.0e3*3.1415926535897931)*instanceStruct.instanceVar_CGeff);
d_sig1k_dX = ((sig1k*sig1k)*instanceStruct.d_instanceVar_mig_dX+(sig1k*d_sig1k_dX+d_sig1k_dX*sig1k)*instanceStruct.instanceVar_mig);
sig1k = ((sig1k*sig1k)*instanceStruct.instanceVar_mig);
if ((sigVds<0.0))
{
if ((modelStruct.modelVar_SWJUNEXP_i==1))
{
}
else
{
}
d_ids_i_dX = ((((((d_Ids_dX+d_Idsedge_dX)+d_Iimpact_dX)+d_Igisl_dX)-d_Igcd_dX)-d_Igsov_dX)-d_ijun_s_dX);
ids_i = ((((((Ids+Idsedge)+Iimpact)+Igisl)-Igcd)-Igsov)-ijun_s);
}
else
{
if ((modelStruct.modelVar_SWJUNEXP_i==1))
{
}
else
{
}
d_ids_i_dX = ((((((d_Ids_dX+d_Idsedge_dX)+d_Iimpact_dX)+d_Igidl_dX)-d_Igcd_dX)-d_Igdov_dX)-d_ijun_d_dX);
ids_i = ((((((Ids+Idsedge)+Iimpact)+Igidl)-Igcd)-Igdov)-ijun_d);
}
if ((fabs(1.0)<1.0e-18))
{
}
else
{
}
if ((fabs(1.0)<1.0e-12))
{
}
else
{
}
if ((fabs(((1.0+1.0)+1.0))<1.0e-30))
{
}
else
{
}
if ((fabs(1.0)<1.0e-18))
{
}
else
{
}
if ((1.0==0.0))
{
}
else
{
}
if ((sigVds<0.0))
{
}
else
{
}
}
// End block OPinfo
}
// End block evaluateblock
}



//-----------------------------------------------------------------------------
// Function      : InstanceSensitivity::operator()
// Purpose       : return sensitivity for a single instance parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity of a device instance's outputs to a specified instance
/// parameter
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void InstanceSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Instance & in = *(dynamic_cast<const Instance *> (e1));
const Model & mod =in.model_;

dfdp.resize(13+0);
dqdp.resize(13+0);
Findices.resize(13+0);
Qindices.resize(13+0);

std::vector <double> probeVars(20);
std::vector <double> d_staticContributions_dX(13+0);
std::vector <double> d_dynamicContributions_dX(13+0);


// initialize contributions to zero (automatically sets derivatives to zero)
for (int i=0; i < 13+0 ; ++i)
{
   d_staticContributions_dX[i]=0;
   d_dynamicContributions_dX[i]=0;
}

// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

//reals
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modelStruct.modelPar_STVFB=mod.STVFB;
modelStruct.d_modelPar_STVFB_dX=0.0;
modelStruct.modelPar_given_STVFB=mod.given("STVFB");
modelStruct.modelPar_TOX=mod.TOX;
modelStruct.d_modelPar_TOX_dX=0.0;
modelStruct.modelPar_given_TOX=mod.given("TOX");
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modelStruct.modelPar_NEFF=mod.NEFF;
modelStruct.d_modelPar_NEFF_dX=0.0;
modelStruct.modelPar_given_NEFF=mod.given("NEFF");
modelStruct.modelPar_FACNEFFAC=mod.FACNEFFAC;
modelStruct.d_modelPar_FACNEFFAC_dX=0.0;
modelStruct.modelPar_given_FACNEFFAC=mod.given("FACNEFFAC");
modelStruct.modelPar_GFACNUD=mod.GFACNUD;
modelStruct.d_modelPar_GFACNUD_dX=0.0;
modelStruct.modelPar_given_GFACNUD=mod.given("GFACNUD");
modelStruct.modelPar_VSBNUD=mod.VSBNUD;
modelStruct.d_modelPar_VSBNUD_dX=0.0;
modelStruct.modelPar_given_VSBNUD=mod.given("VSBNUD");
modelStruct.modelPar_DVSBNUD=mod.DVSBNUD;
modelStruct.d_modelPar_DVSBNUD_dX=0.0;
modelStruct.modelPar_given_DVSBNUD=mod.given("DVSBNUD");
modelStruct.modelPar_VNSUB=mod.VNSUB;
modelStruct.d_modelPar_VNSUB_dX=0.0;
modelStruct.modelPar_given_VNSUB=mod.given("VNSUB");
modelStruct.modelPar_NSLP=mod.NSLP;
modelStruct.d_modelPar_NSLP_dX=0.0;
modelStruct.modelPar_given_NSLP=mod.given("NSLP");
modelStruct.modelPar_DNSUB=mod.DNSUB;
modelStruct.d_modelPar_DNSUB_dX=0.0;
modelStruct.modelPar_given_DNSUB=mod.given("DNSUB");
modelStruct.modelPar_DPHIB=mod.DPHIB;
modelStruct.d_modelPar_DPHIB_dX=0.0;
modelStruct.modelPar_given_DPHIB=mod.given("DPHIB");
modelStruct.modelPar_DELVTAC=mod.DELVTAC;
modelStruct.d_modelPar_DELVTAC_dX=0.0;
modelStruct.modelPar_given_DELVTAC=mod.given("DELVTAC");
modelStruct.modelPar_NP=mod.NP;
modelStruct.d_modelPar_NP_dX=0.0;
modelStruct.modelPar_given_NP=mod.given("NP");
modelStruct.modelPar_CT=mod.CT;
modelStruct.d_modelPar_CT_dX=0.0;
modelStruct.modelPar_given_CT=mod.given("CT");
modelStruct.modelPar_TOXOV=mod.TOXOV;
modelStruct.d_modelPar_TOXOV_dX=0.0;
modelStruct.modelPar_given_TOXOV=mod.given("TOXOV");
modelStruct.modelPar_TOXOVD=mod.TOXOVD;
modelStruct.d_modelPar_TOXOVD_dX=0.0;
modelStruct.modelPar_given_TOXOVD=mod.given("TOXOVD");
modelStruct.modelPar_NOV=mod.NOV;
modelStruct.d_modelPar_NOV_dX=0.0;
modelStruct.modelPar_given_NOV=mod.given("NOV");
modelStruct.modelPar_NOVD=mod.NOVD;
modelStruct.d_modelPar_NOVD_dX=0.0;
modelStruct.modelPar_given_NOVD=mod.given("NOVD");
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modelStruct.modelPar_CFB=mod.CFB;
modelStruct.d_modelPar_CFB_dX=0.0;
modelStruct.modelPar_given_CFB=mod.given("CFB");
modelStruct.modelPar_PSCE=mod.PSCE;
modelStruct.d_modelPar_PSCE_dX=0.0;
modelStruct.modelPar_given_PSCE=mod.given("PSCE");
modelStruct.modelPar_PSCEB=mod.PSCEB;
modelStruct.d_modelPar_PSCEB_dX=0.0;
modelStruct.modelPar_given_PSCEB=mod.given("PSCEB");
modelStruct.modelPar_PSCED=mod.PSCED;
modelStruct.d_modelPar_PSCED_dX=0.0;
modelStruct.modelPar_given_PSCED=mod.given("PSCED");
modelStruct.modelPar_BETN=mod.BETN;
modelStruct.d_modelPar_BETN_dX=0.0;
modelStruct.modelPar_given_BETN=mod.given("BETN");
modelStruct.modelPar_STBET=mod.STBET;
modelStruct.d_modelPar_STBET_dX=0.0;
modelStruct.modelPar_given_STBET=mod.given("STBET");
modelStruct.modelPar_MUE=mod.MUE;
modelStruct.d_modelPar_MUE_dX=0.0;
modelStruct.modelPar_given_MUE=mod.given("MUE");
modelStruct.modelPar_STMUE=mod.STMUE;
modelStruct.d_modelPar_STMUE_dX=0.0;
modelStruct.modelPar_given_STMUE=mod.given("STMUE");
modelStruct.modelPar_THEMU=mod.THEMU;
modelStruct.d_modelPar_THEMU_dX=0.0;
modelStruct.modelPar_given_THEMU=mod.given("THEMU");
modelStruct.modelPar_STTHEMU=mod.STTHEMU;
modelStruct.d_modelPar_STTHEMU_dX=0.0;
modelStruct.modelPar_given_STTHEMU=mod.given("STTHEMU");
modelStruct.modelPar_CS=mod.CS;
modelStruct.d_modelPar_CS_dX=0.0;
modelStruct.modelPar_given_CS=mod.given("CS");
modelStruct.modelPar_STCS=mod.STCS;
modelStruct.d_modelPar_STCS_dX=0.0;
modelStruct.modelPar_given_STCS=mod.given("STCS");
modelStruct.modelPar_XCOR=mod.XCOR;
modelStruct.d_modelPar_XCOR_dX=0.0;
modelStruct.modelPar_given_XCOR=mod.given("XCOR");
modelStruct.modelPar_STXCOR=mod.STXCOR;
modelStruct.d_modelPar_STXCOR_dX=0.0;
modelStruct.modelPar_given_STXCOR=mod.given("STXCOR");
modelStruct.modelPar_FETA=mod.FETA;
modelStruct.d_modelPar_FETA_dX=0.0;
modelStruct.modelPar_given_FETA=mod.given("FETA");
modelStruct.modelPar_RS=mod.RS;
modelStruct.d_modelPar_RS_dX=0.0;
modelStruct.modelPar_given_RS=mod.given("RS");
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modelStruct.modelPar_RSB=mod.RSB;
modelStruct.d_modelPar_RSB_dX=0.0;
modelStruct.modelPar_given_RSB=mod.given("RSB");
modelStruct.modelPar_RSG=mod.RSG;
modelStruct.d_modelPar_RSG_dX=0.0;
modelStruct.modelPar_given_RSG=mod.given("RSG");
modelStruct.modelPar_THESAT=mod.THESAT;
modelStruct.d_modelPar_THESAT_dX=0.0;
modelStruct.modelPar_given_THESAT=mod.given("THESAT");
modelStruct.modelPar_STTHESAT=mod.STTHESAT;
modelStruct.d_modelPar_STTHESAT_dX=0.0;
modelStruct.modelPar_given_STTHESAT=mod.given("STTHESAT");
modelStruct.modelPar_THESATB=mod.THESATB;
modelStruct.d_modelPar_THESATB_dX=0.0;
modelStruct.modelPar_given_THESATB=mod.given("THESATB");
modelStruct.modelPar_THESATG=mod.THESATG;
modelStruct.d_modelPar_THESATG_dX=0.0;
modelStruct.modelPar_given_THESATG=mod.given("THESATG");
modelStruct.modelPar_AX=mod.AX;
modelStruct.d_modelPar_AX_dX=0.0;
modelStruct.modelPar_given_AX=mod.given("AX");
modelStruct.modelPar_ALP=mod.ALP;
modelStruct.d_modelPar_ALP_dX=0.0;
modelStruct.modelPar_given_ALP=mod.given("ALP");
modelStruct.modelPar_ALP1=mod.ALP1;
modelStruct.d_modelPar_ALP1_dX=0.0;
modelStruct.modelPar_given_ALP1=mod.given("ALP1");
modelStruct.modelPar_ALP2=mod.ALP2;
modelStruct.d_modelPar_ALP2_dX=0.0;
modelStruct.modelPar_given_ALP2=mod.given("ALP2");
modelStruct.modelPar_VP=mod.VP;
modelStruct.d_modelPar_VP_dX=0.0;
modelStruct.modelPar_given_VP=mod.given("VP");
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modelStruct.modelPar_STA2=mod.STA2;
modelStruct.d_modelPar_STA2_dX=0.0;
modelStruct.modelPar_given_STA2=mod.given("STA2");
modelStruct.modelPar_A3=mod.A3;
modelStruct.d_modelPar_A3_dX=0.0;
modelStruct.modelPar_given_A3=mod.given("A3");
modelStruct.modelPar_A4=mod.A4;
modelStruct.d_modelPar_A4_dX=0.0;
modelStruct.modelPar_given_A4=mod.given("A4");
modelStruct.modelPar_GCO=mod.GCO;
modelStruct.d_modelPar_GCO_dX=0.0;
modelStruct.modelPar_given_GCO=mod.given("GCO");
modelStruct.modelPar_IGINV=mod.IGINV;
modelStruct.d_modelPar_IGINV_dX=0.0;
modelStruct.modelPar_given_IGINV=mod.given("IGINV");
modelStruct.modelPar_IGOV=mod.IGOV;
modelStruct.d_modelPar_IGOV_dX=0.0;
modelStruct.modelPar_given_IGOV=mod.given("IGOV");
modelStruct.modelPar_IGOVD=mod.IGOVD;
modelStruct.d_modelPar_IGOVD_dX=0.0;
modelStruct.modelPar_given_IGOVD=mod.given("IGOVD");
modelStruct.modelPar_STIG=mod.STIG;
modelStruct.d_modelPar_STIG_dX=0.0;
modelStruct.modelPar_given_STIG=mod.given("STIG");
modelStruct.modelPar_GC2=mod.GC2;
modelStruct.d_modelPar_GC2_dX=0.0;
modelStruct.modelPar_given_GC2=mod.given("GC2");
modelStruct.modelPar_GC3=mod.GC3;
modelStruct.d_modelPar_GC3_dX=0.0;
modelStruct.modelPar_given_GC3=mod.given("GC3");
modelStruct.modelPar_CHIB=mod.CHIB;
modelStruct.d_modelPar_CHIB_dX=0.0;
modelStruct.modelPar_given_CHIB=mod.given("CHIB");
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modelStruct.modelPar_AGIDLD=mod.AGIDLD;
modelStruct.d_modelPar_AGIDLD_dX=0.0;
modelStruct.modelPar_given_AGIDLD=mod.given("AGIDLD");
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modelStruct.modelPar_BGIDLD=mod.BGIDLD;
modelStruct.d_modelPar_BGIDLD_dX=0.0;
modelStruct.modelPar_given_BGIDLD=mod.given("BGIDLD");
modelStruct.modelPar_STBGIDL=mod.STBGIDL;
modelStruct.d_modelPar_STBGIDL_dX=0.0;
modelStruct.modelPar_given_STBGIDL=mod.given("STBGIDL");
modelStruct.modelPar_STBGIDLD=mod.STBGIDLD;
modelStruct.d_modelPar_STBGIDLD_dX=0.0;
modelStruct.modelPar_given_STBGIDLD=mod.given("STBGIDLD");
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modelStruct.modelPar_CGIDLD=mod.CGIDLD;
modelStruct.d_modelPar_CGIDLD_dX=0.0;
modelStruct.modelPar_given_CGIDLD=mod.given("CGIDLD");
modelStruct.modelPar_COX=mod.COX;
modelStruct.d_modelPar_COX_dX=0.0;
modelStruct.modelPar_given_COX=mod.given("COX");
modelStruct.modelPar_CGOV=mod.CGOV;
modelStruct.d_modelPar_CGOV_dX=0.0;
modelStruct.modelPar_given_CGOV=mod.given("CGOV");
modelStruct.modelPar_CGOVD=mod.CGOVD;
modelStruct.d_modelPar_CGOVD_dX=0.0;
modelStruct.modelPar_given_CGOVD=mod.given("CGOVD");
modelStruct.modelPar_CGBOV=mod.CGBOV;
modelStruct.d_modelPar_CGBOV_dX=0.0;
modelStruct.modelPar_given_CGBOV=mod.given("CGBOV");
modelStruct.modelPar_CFR=mod.CFR;
modelStruct.d_modelPar_CFR_dX=0.0;
modelStruct.modelPar_given_CFR=mod.given("CFR");
modelStruct.modelPar_CFRD=mod.CFRD;
modelStruct.d_modelPar_CFRD_dX=0.0;
modelStruct.modelPar_given_CFRD=mod.given("CFRD");
modelStruct.modelPar_FNT=mod.FNT;
modelStruct.d_modelPar_FNT_dX=0.0;
modelStruct.modelPar_given_FNT=mod.given("FNT");
modelStruct.modelPar_FNTEXC=mod.FNTEXC;
modelStruct.d_modelPar_FNTEXC_dX=0.0;
modelStruct.modelPar_given_FNTEXC=mod.given("FNTEXC");
modelStruct.modelPar_NFA=mod.NFA;
modelStruct.d_modelPar_NFA_dX=0.0;
modelStruct.modelPar_given_NFA=mod.given("NFA");
modelStruct.modelPar_NFB=mod.NFB;
modelStruct.d_modelPar_NFB_dX=0.0;
modelStruct.modelPar_given_NFB=mod.given("NFB");
modelStruct.modelPar_NFC=mod.NFC;
modelStruct.d_modelPar_NFC_dX=0.0;
modelStruct.modelPar_given_NFC=mod.given("NFC");
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modelStruct.modelPar_VFBEDGE=mod.VFBEDGE;
modelStruct.d_modelPar_VFBEDGE_dX=0.0;
modelStruct.modelPar_given_VFBEDGE=mod.given("VFBEDGE");
modelStruct.modelPar_STVFBEDGE=mod.STVFBEDGE;
modelStruct.d_modelPar_STVFBEDGE_dX=0.0;
modelStruct.modelPar_given_STVFBEDGE=mod.given("STVFBEDGE");
modelStruct.modelPar_DPHIBEDGE=mod.DPHIBEDGE;
modelStruct.d_modelPar_DPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGE=mod.given("DPHIBEDGE");
modelStruct.modelPar_NEFFEDGE=mod.NEFFEDGE;
modelStruct.d_modelPar_NEFFEDGE_dX=0.0;
modelStruct.modelPar_given_NEFFEDGE=mod.given("NEFFEDGE");
modelStruct.modelPar_CTEDGE=mod.CTEDGE;
modelStruct.d_modelPar_CTEDGE_dX=0.0;
modelStruct.modelPar_given_CTEDGE=mod.given("CTEDGE");
modelStruct.modelPar_BETNEDGE=mod.BETNEDGE;
modelStruct.d_modelPar_BETNEDGE_dX=0.0;
modelStruct.modelPar_given_BETNEDGE=mod.given("BETNEDGE");
modelStruct.modelPar_STBETEDGE=mod.STBETEDGE;
modelStruct.d_modelPar_STBETEDGE_dX=0.0;
modelStruct.modelPar_given_STBETEDGE=mod.given("STBETEDGE");
modelStruct.modelPar_PSCEEDGE=mod.PSCEEDGE;
modelStruct.d_modelPar_PSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEEDGE=mod.given("PSCEEDGE");
modelStruct.modelPar_PSCEBEDGE=mod.PSCEBEDGE;
modelStruct.d_modelPar_PSCEBEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEBEDGE=mod.given("PSCEBEDGE");
modelStruct.modelPar_PSCEDEDGE=mod.PSCEDEDGE;
modelStruct.d_modelPar_PSCEDEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEDEDGE=mod.given("PSCEDEDGE");
modelStruct.modelPar_CFEDGE=mod.CFEDGE;
modelStruct.d_modelPar_CFEDGE_dX=0.0;
modelStruct.modelPar_given_CFEDGE=mod.given("CFEDGE");
modelStruct.modelPar_CFDEDGE=mod.CFDEDGE;
modelStruct.d_modelPar_CFDEDGE_dX=0.0;
modelStruct.modelPar_given_CFDEDGE=mod.given("CFDEDGE");
modelStruct.modelPar_CFBEDGE=mod.CFBEDGE;
modelStruct.d_modelPar_CFBEDGE_dX=0.0;
modelStruct.modelPar_given_CFBEDGE=mod.given("CFBEDGE");
modelStruct.modelPar_FNTEDGE=mod.FNTEDGE;
modelStruct.d_modelPar_FNTEDGE_dX=0.0;
modelStruct.modelPar_given_FNTEDGE=mod.given("FNTEDGE");
modelStruct.modelPar_NFAEDGE=mod.NFAEDGE;
modelStruct.d_modelPar_NFAEDGE_dX=0.0;
modelStruct.modelPar_given_NFAEDGE=mod.given("NFAEDGE");
modelStruct.modelPar_NFBEDGE=mod.NFBEDGE;
modelStruct.d_modelPar_NFBEDGE_dX=0.0;
modelStruct.modelPar_given_NFBEDGE=mod.given("NFBEDGE");
modelStruct.modelPar_NFCEDGE=mod.NFCEDGE;
modelStruct.d_modelPar_NFCEDGE_dX=0.0;
modelStruct.modelPar_given_NFCEDGE=mod.given("NFCEDGE");
modelStruct.modelPar_EFEDGE=mod.EFEDGE;
modelStruct.d_modelPar_EFEDGE_dX=0.0;
modelStruct.modelPar_given_EFEDGE=mod.given("EFEDGE");
modelStruct.modelPar_RG=mod.RG;
modelStruct.d_modelPar_RG_dX=0.0;
modelStruct.modelPar_given_RG=mod.given("RG");
modelStruct.modelPar_RSE=mod.RSE;
modelStruct.d_modelPar_RSE_dX=0.0;
modelStruct.modelPar_given_RSE=mod.given("RSE");
modelStruct.modelPar_RDE=mod.RDE;
modelStruct.d_modelPar_RDE_dX=0.0;
modelStruct.modelPar_given_RDE=mod.given("RDE");
modelStruct.modelPar_RBULK=mod.RBULK;
modelStruct.d_modelPar_RBULK_dX=0.0;
modelStruct.modelPar_given_RBULK=mod.given("RBULK");
modelStruct.modelPar_RWELL=mod.RWELL;
modelStruct.d_modelPar_RWELL_dX=0.0;
modelStruct.modelPar_given_RWELL=mod.given("RWELL");
modelStruct.modelPar_RJUNS=mod.RJUNS;
modelStruct.d_modelPar_RJUNS_dX=0.0;
modelStruct.modelPar_given_RJUNS=mod.given("RJUNS");
modelStruct.modelPar_RJUND=mod.RJUND;
modelStruct.d_modelPar_RJUND_dX=0.0;
modelStruct.modelPar_given_RJUND=mod.given("RJUND");
modelStruct.modelPar_POVFB=mod.POVFB;
modelStruct.d_modelPar_POVFB_dX=0.0;
modelStruct.modelPar_given_POVFB=mod.given("POVFB");
modelStruct.modelPar_PLVFB=mod.PLVFB;
modelStruct.d_modelPar_PLVFB_dX=0.0;
modelStruct.modelPar_given_PLVFB=mod.given("PLVFB");
modelStruct.modelPar_PWVFB=mod.PWVFB;
modelStruct.d_modelPar_PWVFB_dX=0.0;
modelStruct.modelPar_given_PWVFB=mod.given("PWVFB");
modelStruct.modelPar_PLWVFB=mod.PLWVFB;
modelStruct.d_modelPar_PLWVFB_dX=0.0;
modelStruct.modelPar_given_PLWVFB=mod.given("PLWVFB");
modelStruct.modelPar_POSTVFB=mod.POSTVFB;
modelStruct.d_modelPar_POSTVFB_dX=0.0;
modelStruct.modelPar_given_POSTVFB=mod.given("POSTVFB");
modelStruct.modelPar_PLSTVFB=mod.PLSTVFB;
modelStruct.d_modelPar_PLSTVFB_dX=0.0;
modelStruct.modelPar_given_PLSTVFB=mod.given("PLSTVFB");
modelStruct.modelPar_PWSTVFB=mod.PWSTVFB;
modelStruct.d_modelPar_PWSTVFB_dX=0.0;
modelStruct.modelPar_given_PWSTVFB=mod.given("PWSTVFB");
modelStruct.modelPar_PLWSTVFB=mod.PLWSTVFB;
modelStruct.d_modelPar_PLWSTVFB_dX=0.0;
modelStruct.modelPar_given_PLWSTVFB=mod.given("PLWSTVFB");
modelStruct.modelPar_POTOX=mod.POTOX;
modelStruct.d_modelPar_POTOX_dX=0.0;
modelStruct.modelPar_given_POTOX=mod.given("POTOX");
modelStruct.modelPar_POEPSROX=mod.POEPSROX;
modelStruct.d_modelPar_POEPSROX_dX=0.0;
modelStruct.modelPar_given_POEPSROX=mod.given("POEPSROX");
modelStruct.modelPar_PONEFF=mod.PONEFF;
modelStruct.d_modelPar_PONEFF_dX=0.0;
modelStruct.modelPar_given_PONEFF=mod.given("PONEFF");
modelStruct.modelPar_PLNEFF=mod.PLNEFF;
modelStruct.d_modelPar_PLNEFF_dX=0.0;
modelStruct.modelPar_given_PLNEFF=mod.given("PLNEFF");
modelStruct.modelPar_PWNEFF=mod.PWNEFF;
modelStruct.d_modelPar_PWNEFF_dX=0.0;
modelStruct.modelPar_given_PWNEFF=mod.given("PWNEFF");
modelStruct.modelPar_PLWNEFF=mod.PLWNEFF;
modelStruct.d_modelPar_PLWNEFF_dX=0.0;
modelStruct.modelPar_given_PLWNEFF=mod.given("PLWNEFF");
modelStruct.modelPar_POFACNEFFAC=mod.POFACNEFFAC;
modelStruct.d_modelPar_POFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_POFACNEFFAC=mod.given("POFACNEFFAC");
modelStruct.modelPar_PLFACNEFFAC=mod.PLFACNEFFAC;
modelStruct.d_modelPar_PLFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PLFACNEFFAC=mod.given("PLFACNEFFAC");
modelStruct.modelPar_PWFACNEFFAC=mod.PWFACNEFFAC;
modelStruct.d_modelPar_PWFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PWFACNEFFAC=mod.given("PWFACNEFFAC");
modelStruct.modelPar_PLWFACNEFFAC=mod.PLWFACNEFFAC;
modelStruct.d_modelPar_PLWFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PLWFACNEFFAC=mod.given("PLWFACNEFFAC");
modelStruct.modelPar_POGFACNUD=mod.POGFACNUD;
modelStruct.d_modelPar_POGFACNUD_dX=0.0;
modelStruct.modelPar_given_POGFACNUD=mod.given("POGFACNUD");
modelStruct.modelPar_PLGFACNUD=mod.PLGFACNUD;
modelStruct.d_modelPar_PLGFACNUD_dX=0.0;
modelStruct.modelPar_given_PLGFACNUD=mod.given("PLGFACNUD");
modelStruct.modelPar_PWGFACNUD=mod.PWGFACNUD;
modelStruct.d_modelPar_PWGFACNUD_dX=0.0;
modelStruct.modelPar_given_PWGFACNUD=mod.given("PWGFACNUD");
modelStruct.modelPar_PLWGFACNUD=mod.PLWGFACNUD;
modelStruct.d_modelPar_PLWGFACNUD_dX=0.0;
modelStruct.modelPar_given_PLWGFACNUD=mod.given("PLWGFACNUD");
modelStruct.modelPar_POVSBNUD=mod.POVSBNUD;
modelStruct.d_modelPar_POVSBNUD_dX=0.0;
modelStruct.modelPar_given_POVSBNUD=mod.given("POVSBNUD");
modelStruct.modelPar_PODVSBNUD=mod.PODVSBNUD;
modelStruct.d_modelPar_PODVSBNUD_dX=0.0;
modelStruct.modelPar_given_PODVSBNUD=mod.given("PODVSBNUD");
modelStruct.modelPar_POVNSUB=mod.POVNSUB;
modelStruct.d_modelPar_POVNSUB_dX=0.0;
modelStruct.modelPar_given_POVNSUB=mod.given("POVNSUB");
modelStruct.modelPar_PONSLP=mod.PONSLP;
modelStruct.d_modelPar_PONSLP_dX=0.0;
modelStruct.modelPar_given_PONSLP=mod.given("PONSLP");
modelStruct.modelPar_PODNSUB=mod.PODNSUB;
modelStruct.d_modelPar_PODNSUB_dX=0.0;
modelStruct.modelPar_given_PODNSUB=mod.given("PODNSUB");
modelStruct.modelPar_PODPHIB=mod.PODPHIB;
modelStruct.d_modelPar_PODPHIB_dX=0.0;
modelStruct.modelPar_given_PODPHIB=mod.given("PODPHIB");
modelStruct.modelPar_PLDPHIB=mod.PLDPHIB;
modelStruct.d_modelPar_PLDPHIB_dX=0.0;
modelStruct.modelPar_given_PLDPHIB=mod.given("PLDPHIB");
modelStruct.modelPar_PWDPHIB=mod.PWDPHIB;
modelStruct.d_modelPar_PWDPHIB_dX=0.0;
modelStruct.modelPar_given_PWDPHIB=mod.given("PWDPHIB");
modelStruct.modelPar_PLWDPHIB=mod.PLWDPHIB;
modelStruct.d_modelPar_PLWDPHIB_dX=0.0;
modelStruct.modelPar_given_PLWDPHIB=mod.given("PLWDPHIB");
modelStruct.modelPar_PODELVTAC=mod.PODELVTAC;
modelStruct.d_modelPar_PODELVTAC_dX=0.0;
modelStruct.modelPar_given_PODELVTAC=mod.given("PODELVTAC");
modelStruct.modelPar_PLDELVTAC=mod.PLDELVTAC;
modelStruct.d_modelPar_PLDELVTAC_dX=0.0;
modelStruct.modelPar_given_PLDELVTAC=mod.given("PLDELVTAC");
modelStruct.modelPar_PWDELVTAC=mod.PWDELVTAC;
modelStruct.d_modelPar_PWDELVTAC_dX=0.0;
modelStruct.modelPar_given_PWDELVTAC=mod.given("PWDELVTAC");
modelStruct.modelPar_PLWDELVTAC=mod.PLWDELVTAC;
modelStruct.d_modelPar_PLWDELVTAC_dX=0.0;
modelStruct.modelPar_given_PLWDELVTAC=mod.given("PLWDELVTAC");
modelStruct.modelPar_PONP=mod.PONP;
modelStruct.d_modelPar_PONP_dX=0.0;
modelStruct.modelPar_given_PONP=mod.given("PONP");
modelStruct.modelPar_PLNP=mod.PLNP;
modelStruct.d_modelPar_PLNP_dX=0.0;
modelStruct.modelPar_given_PLNP=mod.given("PLNP");
modelStruct.modelPar_PWNP=mod.PWNP;
modelStruct.d_modelPar_PWNP_dX=0.0;
modelStruct.modelPar_given_PWNP=mod.given("PWNP");
modelStruct.modelPar_PLWNP=mod.PLWNP;
modelStruct.d_modelPar_PLWNP_dX=0.0;
modelStruct.modelPar_given_PLWNP=mod.given("PLWNP");
modelStruct.modelPar_POCT=mod.POCT;
modelStruct.d_modelPar_POCT_dX=0.0;
modelStruct.modelPar_given_POCT=mod.given("POCT");
modelStruct.modelPar_PLCT=mod.PLCT;
modelStruct.d_modelPar_PLCT_dX=0.0;
modelStruct.modelPar_given_PLCT=mod.given("PLCT");
modelStruct.modelPar_PWCT=mod.PWCT;
modelStruct.d_modelPar_PWCT_dX=0.0;
modelStruct.modelPar_given_PWCT=mod.given("PWCT");
modelStruct.modelPar_PLWCT=mod.PLWCT;
modelStruct.d_modelPar_PLWCT_dX=0.0;
modelStruct.modelPar_given_PLWCT=mod.given("PLWCT");
modelStruct.modelPar_POTOXOV=mod.POTOXOV;
modelStruct.d_modelPar_POTOXOV_dX=0.0;
modelStruct.modelPar_given_POTOXOV=mod.given("POTOXOV");
modelStruct.modelPar_POTOXOVD=mod.POTOXOVD;
modelStruct.d_modelPar_POTOXOVD_dX=0.0;
modelStruct.modelPar_given_POTOXOVD=mod.given("POTOXOVD");
modelStruct.modelPar_PONOV=mod.PONOV;
modelStruct.d_modelPar_PONOV_dX=0.0;
modelStruct.modelPar_given_PONOV=mod.given("PONOV");
modelStruct.modelPar_PLNOV=mod.PLNOV;
modelStruct.d_modelPar_PLNOV_dX=0.0;
modelStruct.modelPar_given_PLNOV=mod.given("PLNOV");
modelStruct.modelPar_PWNOV=mod.PWNOV;
modelStruct.d_modelPar_PWNOV_dX=0.0;
modelStruct.modelPar_given_PWNOV=mod.given("PWNOV");
modelStruct.modelPar_PLWNOV=mod.PLWNOV;
modelStruct.d_modelPar_PLWNOV_dX=0.0;
modelStruct.modelPar_given_PLWNOV=mod.given("PLWNOV");
modelStruct.modelPar_PONOVD=mod.PONOVD;
modelStruct.d_modelPar_PONOVD_dX=0.0;
modelStruct.modelPar_given_PONOVD=mod.given("PONOVD");
modelStruct.modelPar_PLNOVD=mod.PLNOVD;
modelStruct.d_modelPar_PLNOVD_dX=0.0;
modelStruct.modelPar_given_PLNOVD=mod.given("PLNOVD");
modelStruct.modelPar_PWNOVD=mod.PWNOVD;
modelStruct.d_modelPar_PWNOVD_dX=0.0;
modelStruct.modelPar_given_PWNOVD=mod.given("PWNOVD");
modelStruct.modelPar_PLWNOVD=mod.PLWNOVD;
modelStruct.d_modelPar_PLWNOVD_dX=0.0;
modelStruct.modelPar_given_PLWNOVD=mod.given("PLWNOVD");
modelStruct.modelPar_POCF=mod.POCF;
modelStruct.d_modelPar_POCF_dX=0.0;
modelStruct.modelPar_given_POCF=mod.given("POCF");
modelStruct.modelPar_PLCF=mod.PLCF;
modelStruct.d_modelPar_PLCF_dX=0.0;
modelStruct.modelPar_given_PLCF=mod.given("PLCF");
modelStruct.modelPar_PWCF=mod.PWCF;
modelStruct.d_modelPar_PWCF_dX=0.0;
modelStruct.modelPar_given_PWCF=mod.given("PWCF");
modelStruct.modelPar_PLWCF=mod.PLWCF;
modelStruct.d_modelPar_PLWCF_dX=0.0;
modelStruct.modelPar_given_PLWCF=mod.given("PLWCF");
modelStruct.modelPar_POCFD=mod.POCFD;
modelStruct.d_modelPar_POCFD_dX=0.0;
modelStruct.modelPar_given_POCFD=mod.given("POCFD");
modelStruct.modelPar_POCFB=mod.POCFB;
modelStruct.d_modelPar_POCFB_dX=0.0;
modelStruct.modelPar_given_POCFB=mod.given("POCFB");
modelStruct.modelPar_POPSCE=mod.POPSCE;
modelStruct.d_modelPar_POPSCE_dX=0.0;
modelStruct.modelPar_given_POPSCE=mod.given("POPSCE");
modelStruct.modelPar_PLPSCE=mod.PLPSCE;
modelStruct.d_modelPar_PLPSCE_dX=0.0;
modelStruct.modelPar_given_PLPSCE=mod.given("PLPSCE");
modelStruct.modelPar_PWPSCE=mod.PWPSCE;
modelStruct.d_modelPar_PWPSCE_dX=0.0;
modelStruct.modelPar_given_PWPSCE=mod.given("PWPSCE");
modelStruct.modelPar_PLWPSCE=mod.PLWPSCE;
modelStruct.d_modelPar_PLWPSCE_dX=0.0;
modelStruct.modelPar_given_PLWPSCE=mod.given("PLWPSCE");
modelStruct.modelPar_POPSCEB=mod.POPSCEB;
modelStruct.d_modelPar_POPSCEB_dX=0.0;
modelStruct.modelPar_given_POPSCEB=mod.given("POPSCEB");
modelStruct.modelPar_POPSCED=mod.POPSCED;
modelStruct.d_modelPar_POPSCED_dX=0.0;
modelStruct.modelPar_given_POPSCED=mod.given("POPSCED");
modelStruct.modelPar_POBETN=mod.POBETN;
modelStruct.d_modelPar_POBETN_dX=0.0;
modelStruct.modelPar_given_POBETN=mod.given("POBETN");
modelStruct.modelPar_PLBETN=mod.PLBETN;
modelStruct.d_modelPar_PLBETN_dX=0.0;
modelStruct.modelPar_given_PLBETN=mod.given("PLBETN");
modelStruct.modelPar_PWBETN=mod.PWBETN;
modelStruct.d_modelPar_PWBETN_dX=0.0;
modelStruct.modelPar_given_PWBETN=mod.given("PWBETN");
modelStruct.modelPar_PLWBETN=mod.PLWBETN;
modelStruct.d_modelPar_PLWBETN_dX=0.0;
modelStruct.modelPar_given_PLWBETN=mod.given("PLWBETN");
modelStruct.modelPar_POSTBET=mod.POSTBET;
modelStruct.d_modelPar_POSTBET_dX=0.0;
modelStruct.modelPar_given_POSTBET=mod.given("POSTBET");
modelStruct.modelPar_PLSTBET=mod.PLSTBET;
modelStruct.d_modelPar_PLSTBET_dX=0.0;
modelStruct.modelPar_given_PLSTBET=mod.given("PLSTBET");
modelStruct.modelPar_PWSTBET=mod.PWSTBET;
modelStruct.d_modelPar_PWSTBET_dX=0.0;
modelStruct.modelPar_given_PWSTBET=mod.given("PWSTBET");
modelStruct.modelPar_PLWSTBET=mod.PLWSTBET;
modelStruct.d_modelPar_PLWSTBET_dX=0.0;
modelStruct.modelPar_given_PLWSTBET=mod.given("PLWSTBET");
modelStruct.modelPar_POMUE=mod.POMUE;
modelStruct.d_modelPar_POMUE_dX=0.0;
modelStruct.modelPar_given_POMUE=mod.given("POMUE");
modelStruct.modelPar_PLMUE=mod.PLMUE;
modelStruct.d_modelPar_PLMUE_dX=0.0;
modelStruct.modelPar_given_PLMUE=mod.given("PLMUE");
modelStruct.modelPar_PWMUE=mod.PWMUE;
modelStruct.d_modelPar_PWMUE_dX=0.0;
modelStruct.modelPar_given_PWMUE=mod.given("PWMUE");
modelStruct.modelPar_PLWMUE=mod.PLWMUE;
modelStruct.d_modelPar_PLWMUE_dX=0.0;
modelStruct.modelPar_given_PLWMUE=mod.given("PLWMUE");
modelStruct.modelPar_POSTMUE=mod.POSTMUE;
modelStruct.d_modelPar_POSTMUE_dX=0.0;
modelStruct.modelPar_given_POSTMUE=mod.given("POSTMUE");
modelStruct.modelPar_POTHEMU=mod.POTHEMU;
modelStruct.d_modelPar_POTHEMU_dX=0.0;
modelStruct.modelPar_given_POTHEMU=mod.given("POTHEMU");
modelStruct.modelPar_POSTTHEMU=mod.POSTTHEMU;
modelStruct.d_modelPar_POSTTHEMU_dX=0.0;
modelStruct.modelPar_given_POSTTHEMU=mod.given("POSTTHEMU");
modelStruct.modelPar_POCS=mod.POCS;
modelStruct.d_modelPar_POCS_dX=0.0;
modelStruct.modelPar_given_POCS=mod.given("POCS");
modelStruct.modelPar_PLCS=mod.PLCS;
modelStruct.d_modelPar_PLCS_dX=0.0;
modelStruct.modelPar_given_PLCS=mod.given("PLCS");
modelStruct.modelPar_PWCS=mod.PWCS;
modelStruct.d_modelPar_PWCS_dX=0.0;
modelStruct.modelPar_given_PWCS=mod.given("PWCS");
modelStruct.modelPar_PLWCS=mod.PLWCS;
modelStruct.d_modelPar_PLWCS_dX=0.0;
modelStruct.modelPar_given_PLWCS=mod.given("PLWCS");
modelStruct.modelPar_POSTCS=mod.POSTCS;
modelStruct.d_modelPar_POSTCS_dX=0.0;
modelStruct.modelPar_given_POSTCS=mod.given("POSTCS");
modelStruct.modelPar_POXCOR=mod.POXCOR;
modelStruct.d_modelPar_POXCOR_dX=0.0;
modelStruct.modelPar_given_POXCOR=mod.given("POXCOR");
modelStruct.modelPar_PLXCOR=mod.PLXCOR;
modelStruct.d_modelPar_PLXCOR_dX=0.0;
modelStruct.modelPar_given_PLXCOR=mod.given("PLXCOR");
modelStruct.modelPar_PWXCOR=mod.PWXCOR;
modelStruct.d_modelPar_PWXCOR_dX=0.0;
modelStruct.modelPar_given_PWXCOR=mod.given("PWXCOR");
modelStruct.modelPar_PLWXCOR=mod.PLWXCOR;
modelStruct.d_modelPar_PLWXCOR_dX=0.0;
modelStruct.modelPar_given_PLWXCOR=mod.given("PLWXCOR");
modelStruct.modelPar_POSTXCOR=mod.POSTXCOR;
modelStruct.d_modelPar_POSTXCOR_dX=0.0;
modelStruct.modelPar_given_POSTXCOR=mod.given("POSTXCOR");
modelStruct.modelPar_POFETA=mod.POFETA;
modelStruct.d_modelPar_POFETA_dX=0.0;
modelStruct.modelPar_given_POFETA=mod.given("POFETA");
modelStruct.modelPar_PORS=mod.PORS;
modelStruct.d_modelPar_PORS_dX=0.0;
modelStruct.modelPar_given_PORS=mod.given("PORS");
modelStruct.modelPar_PLRS=mod.PLRS;
modelStruct.d_modelPar_PLRS_dX=0.0;
modelStruct.modelPar_given_PLRS=mod.given("PLRS");
modelStruct.modelPar_PWRS=mod.PWRS;
modelStruct.d_modelPar_PWRS_dX=0.0;
modelStruct.modelPar_given_PWRS=mod.given("PWRS");
modelStruct.modelPar_PLWRS=mod.PLWRS;
modelStruct.d_modelPar_PLWRS_dX=0.0;
modelStruct.modelPar_given_PLWRS=mod.given("PLWRS");
modelStruct.modelPar_POSTRS=mod.POSTRS;
modelStruct.d_modelPar_POSTRS_dX=0.0;
modelStruct.modelPar_given_POSTRS=mod.given("POSTRS");
modelStruct.modelPar_PORSB=mod.PORSB;
modelStruct.d_modelPar_PORSB_dX=0.0;
modelStruct.modelPar_given_PORSB=mod.given("PORSB");
modelStruct.modelPar_PORSG=mod.PORSG;
modelStruct.d_modelPar_PORSG_dX=0.0;
modelStruct.modelPar_given_PORSG=mod.given("PORSG");
modelStruct.modelPar_POTHESAT=mod.POTHESAT;
modelStruct.d_modelPar_POTHESAT_dX=0.0;
modelStruct.modelPar_given_POTHESAT=mod.given("POTHESAT");
modelStruct.modelPar_PLTHESAT=mod.PLTHESAT;
modelStruct.d_modelPar_PLTHESAT_dX=0.0;
modelStruct.modelPar_given_PLTHESAT=mod.given("PLTHESAT");
modelStruct.modelPar_PWTHESAT=mod.PWTHESAT;
modelStruct.d_modelPar_PWTHESAT_dX=0.0;
modelStruct.modelPar_given_PWTHESAT=mod.given("PWTHESAT");
modelStruct.modelPar_PLWTHESAT=mod.PLWTHESAT;
modelStruct.d_modelPar_PLWTHESAT_dX=0.0;
modelStruct.modelPar_given_PLWTHESAT=mod.given("PLWTHESAT");
modelStruct.modelPar_POSTTHESAT=mod.POSTTHESAT;
modelStruct.d_modelPar_POSTTHESAT_dX=0.0;
modelStruct.modelPar_given_POSTTHESAT=mod.given("POSTTHESAT");
modelStruct.modelPar_PLSTTHESAT=mod.PLSTTHESAT;
modelStruct.d_modelPar_PLSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PLSTTHESAT=mod.given("PLSTTHESAT");
modelStruct.modelPar_PWSTTHESAT=mod.PWSTTHESAT;
modelStruct.d_modelPar_PWSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PWSTTHESAT=mod.given("PWSTTHESAT");
modelStruct.modelPar_PLWSTTHESAT=mod.PLWSTTHESAT;
modelStruct.d_modelPar_PLWSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PLWSTTHESAT=mod.given("PLWSTTHESAT");
modelStruct.modelPar_POTHESATB=mod.POTHESATB;
modelStruct.d_modelPar_POTHESATB_dX=0.0;
modelStruct.modelPar_given_POTHESATB=mod.given("POTHESATB");
modelStruct.modelPar_PLTHESATB=mod.PLTHESATB;
modelStruct.d_modelPar_PLTHESATB_dX=0.0;
modelStruct.modelPar_given_PLTHESATB=mod.given("PLTHESATB");
modelStruct.modelPar_PWTHESATB=mod.PWTHESATB;
modelStruct.d_modelPar_PWTHESATB_dX=0.0;
modelStruct.modelPar_given_PWTHESATB=mod.given("PWTHESATB");
modelStruct.modelPar_PLWTHESATB=mod.PLWTHESATB;
modelStruct.d_modelPar_PLWTHESATB_dX=0.0;
modelStruct.modelPar_given_PLWTHESATB=mod.given("PLWTHESATB");
modelStruct.modelPar_POTHESATG=mod.POTHESATG;
modelStruct.d_modelPar_POTHESATG_dX=0.0;
modelStruct.modelPar_given_POTHESATG=mod.given("POTHESATG");
modelStruct.modelPar_PLTHESATG=mod.PLTHESATG;
modelStruct.d_modelPar_PLTHESATG_dX=0.0;
modelStruct.modelPar_given_PLTHESATG=mod.given("PLTHESATG");
modelStruct.modelPar_PWTHESATG=mod.PWTHESATG;
modelStruct.d_modelPar_PWTHESATG_dX=0.0;
modelStruct.modelPar_given_PWTHESATG=mod.given("PWTHESATG");
modelStruct.modelPar_PLWTHESATG=mod.PLWTHESATG;
modelStruct.d_modelPar_PLWTHESATG_dX=0.0;
modelStruct.modelPar_given_PLWTHESATG=mod.given("PLWTHESATG");
modelStruct.modelPar_POAX=mod.POAX;
modelStruct.d_modelPar_POAX_dX=0.0;
modelStruct.modelPar_given_POAX=mod.given("POAX");
modelStruct.modelPar_PLAX=mod.PLAX;
modelStruct.d_modelPar_PLAX_dX=0.0;
modelStruct.modelPar_given_PLAX=mod.given("PLAX");
modelStruct.modelPar_PWAX=mod.PWAX;
modelStruct.d_modelPar_PWAX_dX=0.0;
modelStruct.modelPar_given_PWAX=mod.given("PWAX");
modelStruct.modelPar_PLWAX=mod.PLWAX;
modelStruct.d_modelPar_PLWAX_dX=0.0;
modelStruct.modelPar_given_PLWAX=mod.given("PLWAX");
modelStruct.modelPar_POALP=mod.POALP;
modelStruct.d_modelPar_POALP_dX=0.0;
modelStruct.modelPar_given_POALP=mod.given("POALP");
modelStruct.modelPar_PLALP=mod.PLALP;
modelStruct.d_modelPar_PLALP_dX=0.0;
modelStruct.modelPar_given_PLALP=mod.given("PLALP");
modelStruct.modelPar_PWALP=mod.PWALP;
modelStruct.d_modelPar_PWALP_dX=0.0;
modelStruct.modelPar_given_PWALP=mod.given("PWALP");
modelStruct.modelPar_PLWALP=mod.PLWALP;
modelStruct.d_modelPar_PLWALP_dX=0.0;
modelStruct.modelPar_given_PLWALP=mod.given("PLWALP");
modelStruct.modelPar_POALP1=mod.POALP1;
modelStruct.d_modelPar_POALP1_dX=0.0;
modelStruct.modelPar_given_POALP1=mod.given("POALP1");
modelStruct.modelPar_PLALP1=mod.PLALP1;
modelStruct.d_modelPar_PLALP1_dX=0.0;
modelStruct.modelPar_given_PLALP1=mod.given("PLALP1");
modelStruct.modelPar_PWALP1=mod.PWALP1;
modelStruct.d_modelPar_PWALP1_dX=0.0;
modelStruct.modelPar_given_PWALP1=mod.given("PWALP1");
modelStruct.modelPar_PLWALP1=mod.PLWALP1;
modelStruct.d_modelPar_PLWALP1_dX=0.0;
modelStruct.modelPar_given_PLWALP1=mod.given("PLWALP1");
modelStruct.modelPar_POALP2=mod.POALP2;
modelStruct.d_modelPar_POALP2_dX=0.0;
modelStruct.modelPar_given_POALP2=mod.given("POALP2");
modelStruct.modelPar_PLALP2=mod.PLALP2;
modelStruct.d_modelPar_PLALP2_dX=0.0;
modelStruct.modelPar_given_PLALP2=mod.given("PLALP2");
modelStruct.modelPar_PWALP2=mod.PWALP2;
modelStruct.d_modelPar_PWALP2_dX=0.0;
modelStruct.modelPar_given_PWALP2=mod.given("PWALP2");
modelStruct.modelPar_PLWALP2=mod.PLWALP2;
modelStruct.d_modelPar_PLWALP2_dX=0.0;
modelStruct.modelPar_given_PLWALP2=mod.given("PLWALP2");
modelStruct.modelPar_POVP=mod.POVP;
modelStruct.d_modelPar_POVP_dX=0.0;
modelStruct.modelPar_given_POVP=mod.given("POVP");
modelStruct.modelPar_POA1=mod.POA1;
modelStruct.d_modelPar_POA1_dX=0.0;
modelStruct.modelPar_given_POA1=mod.given("POA1");
modelStruct.modelPar_PLA1=mod.PLA1;
modelStruct.d_modelPar_PLA1_dX=0.0;
modelStruct.modelPar_given_PLA1=mod.given("PLA1");
modelStruct.modelPar_PWA1=mod.PWA1;
modelStruct.d_modelPar_PWA1_dX=0.0;
modelStruct.modelPar_given_PWA1=mod.given("PWA1");
modelStruct.modelPar_PLWA1=mod.PLWA1;
modelStruct.d_modelPar_PLWA1_dX=0.0;
modelStruct.modelPar_given_PLWA1=mod.given("PLWA1");
modelStruct.modelPar_POA2=mod.POA2;
modelStruct.d_modelPar_POA2_dX=0.0;
modelStruct.modelPar_given_POA2=mod.given("POA2");
modelStruct.modelPar_POSTA2=mod.POSTA2;
modelStruct.d_modelPar_POSTA2_dX=0.0;
modelStruct.modelPar_given_POSTA2=mod.given("POSTA2");
modelStruct.modelPar_POA3=mod.POA3;
modelStruct.d_modelPar_POA3_dX=0.0;
modelStruct.modelPar_given_POA3=mod.given("POA3");
modelStruct.modelPar_PLA3=mod.PLA3;
modelStruct.d_modelPar_PLA3_dX=0.0;
modelStruct.modelPar_given_PLA3=mod.given("PLA3");
modelStruct.modelPar_PWA3=mod.PWA3;
modelStruct.d_modelPar_PWA3_dX=0.0;
modelStruct.modelPar_given_PWA3=mod.given("PWA3");
modelStruct.modelPar_PLWA3=mod.PLWA3;
modelStruct.d_modelPar_PLWA3_dX=0.0;
modelStruct.modelPar_given_PLWA3=mod.given("PLWA3");
modelStruct.modelPar_POA4=mod.POA4;
modelStruct.d_modelPar_POA4_dX=0.0;
modelStruct.modelPar_given_POA4=mod.given("POA4");
modelStruct.modelPar_PLA4=mod.PLA4;
modelStruct.d_modelPar_PLA4_dX=0.0;
modelStruct.modelPar_given_PLA4=mod.given("PLA4");
modelStruct.modelPar_PWA4=mod.PWA4;
modelStruct.d_modelPar_PWA4_dX=0.0;
modelStruct.modelPar_given_PWA4=mod.given("PWA4");
modelStruct.modelPar_PLWA4=mod.PLWA4;
modelStruct.d_modelPar_PLWA4_dX=0.0;
modelStruct.modelPar_given_PLWA4=mod.given("PLWA4");
modelStruct.modelPar_POGCO=mod.POGCO;
modelStruct.d_modelPar_POGCO_dX=0.0;
modelStruct.modelPar_given_POGCO=mod.given("POGCO");
modelStruct.modelPar_POIGINV=mod.POIGINV;
modelStruct.d_modelPar_POIGINV_dX=0.0;
modelStruct.modelPar_given_POIGINV=mod.given("POIGINV");
modelStruct.modelPar_PLIGINV=mod.PLIGINV;
modelStruct.d_modelPar_PLIGINV_dX=0.0;
modelStruct.modelPar_given_PLIGINV=mod.given("PLIGINV");
modelStruct.modelPar_PWIGINV=mod.PWIGINV;
modelStruct.d_modelPar_PWIGINV_dX=0.0;
modelStruct.modelPar_given_PWIGINV=mod.given("PWIGINV");
modelStruct.modelPar_PLWIGINV=mod.PLWIGINV;
modelStruct.d_modelPar_PLWIGINV_dX=0.0;
modelStruct.modelPar_given_PLWIGINV=mod.given("PLWIGINV");
modelStruct.modelPar_POIGOV=mod.POIGOV;
modelStruct.d_modelPar_POIGOV_dX=0.0;
modelStruct.modelPar_given_POIGOV=mod.given("POIGOV");
modelStruct.modelPar_PLIGOV=mod.PLIGOV;
modelStruct.d_modelPar_PLIGOV_dX=0.0;
modelStruct.modelPar_given_PLIGOV=mod.given("PLIGOV");
modelStruct.modelPar_PWIGOV=mod.PWIGOV;
modelStruct.d_modelPar_PWIGOV_dX=0.0;
modelStruct.modelPar_given_PWIGOV=mod.given("PWIGOV");
modelStruct.modelPar_PLWIGOV=mod.PLWIGOV;
modelStruct.d_modelPar_PLWIGOV_dX=0.0;
modelStruct.modelPar_given_PLWIGOV=mod.given("PLWIGOV");
modelStruct.modelPar_POIGOVD=mod.POIGOVD;
modelStruct.d_modelPar_POIGOVD_dX=0.0;
modelStruct.modelPar_given_POIGOVD=mod.given("POIGOVD");
modelStruct.modelPar_PLIGOVD=mod.PLIGOVD;
modelStruct.d_modelPar_PLIGOVD_dX=0.0;
modelStruct.modelPar_given_PLIGOVD=mod.given("PLIGOVD");
modelStruct.modelPar_PWIGOVD=mod.PWIGOVD;
modelStruct.d_modelPar_PWIGOVD_dX=0.0;
modelStruct.modelPar_given_PWIGOVD=mod.given("PWIGOVD");
modelStruct.modelPar_PLWIGOVD=mod.PLWIGOVD;
modelStruct.d_modelPar_PLWIGOVD_dX=0.0;
modelStruct.modelPar_given_PLWIGOVD=mod.given("PLWIGOVD");
modelStruct.modelPar_POSTIG=mod.POSTIG;
modelStruct.d_modelPar_POSTIG_dX=0.0;
modelStruct.modelPar_given_POSTIG=mod.given("POSTIG");
modelStruct.modelPar_POGC2=mod.POGC2;
modelStruct.d_modelPar_POGC2_dX=0.0;
modelStruct.modelPar_given_POGC2=mod.given("POGC2");
modelStruct.modelPar_POGC3=mod.POGC3;
modelStruct.d_modelPar_POGC3_dX=0.0;
modelStruct.modelPar_given_POGC3=mod.given("POGC3");
modelStruct.modelPar_POCHIB=mod.POCHIB;
modelStruct.d_modelPar_POCHIB_dX=0.0;
modelStruct.modelPar_given_POCHIB=mod.given("POCHIB");
modelStruct.modelPar_POAGIDL=mod.POAGIDL;
modelStruct.d_modelPar_POAGIDL_dX=0.0;
modelStruct.modelPar_given_POAGIDL=mod.given("POAGIDL");
modelStruct.modelPar_PLAGIDL=mod.PLAGIDL;
modelStruct.d_modelPar_PLAGIDL_dX=0.0;
modelStruct.modelPar_given_PLAGIDL=mod.given("PLAGIDL");
modelStruct.modelPar_PWAGIDL=mod.PWAGIDL;
modelStruct.d_modelPar_PWAGIDL_dX=0.0;
modelStruct.modelPar_given_PWAGIDL=mod.given("PWAGIDL");
modelStruct.modelPar_PLWAGIDL=mod.PLWAGIDL;
modelStruct.d_modelPar_PLWAGIDL_dX=0.0;
modelStruct.modelPar_given_PLWAGIDL=mod.given("PLWAGIDL");
modelStruct.modelPar_POAGIDLD=mod.POAGIDLD;
modelStruct.d_modelPar_POAGIDLD_dX=0.0;
modelStruct.modelPar_given_POAGIDLD=mod.given("POAGIDLD");
modelStruct.modelPar_PLAGIDLD=mod.PLAGIDLD;
modelStruct.d_modelPar_PLAGIDLD_dX=0.0;
modelStruct.modelPar_given_PLAGIDLD=mod.given("PLAGIDLD");
modelStruct.modelPar_PWAGIDLD=mod.PWAGIDLD;
modelStruct.d_modelPar_PWAGIDLD_dX=0.0;
modelStruct.modelPar_given_PWAGIDLD=mod.given("PWAGIDLD");
modelStruct.modelPar_PLWAGIDLD=mod.PLWAGIDLD;
modelStruct.d_modelPar_PLWAGIDLD_dX=0.0;
modelStruct.modelPar_given_PLWAGIDLD=mod.given("PLWAGIDLD");
modelStruct.modelPar_POBGIDL=mod.POBGIDL;
modelStruct.d_modelPar_POBGIDL_dX=0.0;
modelStruct.modelPar_given_POBGIDL=mod.given("POBGIDL");
modelStruct.modelPar_POBGIDLD=mod.POBGIDLD;
modelStruct.d_modelPar_POBGIDLD_dX=0.0;
modelStruct.modelPar_given_POBGIDLD=mod.given("POBGIDLD");
modelStruct.modelPar_POSTBGIDL=mod.POSTBGIDL;
modelStruct.d_modelPar_POSTBGIDL_dX=0.0;
modelStruct.modelPar_given_POSTBGIDL=mod.given("POSTBGIDL");
modelStruct.modelPar_POSTBGIDLD=mod.POSTBGIDLD;
modelStruct.d_modelPar_POSTBGIDLD_dX=0.0;
modelStruct.modelPar_given_POSTBGIDLD=mod.given("POSTBGIDLD");
modelStruct.modelPar_POCGIDL=mod.POCGIDL;
modelStruct.d_modelPar_POCGIDL_dX=0.0;
modelStruct.modelPar_given_POCGIDL=mod.given("POCGIDL");
modelStruct.modelPar_POCGIDLD=mod.POCGIDLD;
modelStruct.d_modelPar_POCGIDLD_dX=0.0;
modelStruct.modelPar_given_POCGIDLD=mod.given("POCGIDLD");
modelStruct.modelPar_POCOX=mod.POCOX;
modelStruct.d_modelPar_POCOX_dX=0.0;
modelStruct.modelPar_given_POCOX=mod.given("POCOX");
modelStruct.modelPar_PLCOX=mod.PLCOX;
modelStruct.d_modelPar_PLCOX_dX=0.0;
modelStruct.modelPar_given_PLCOX=mod.given("PLCOX");
modelStruct.modelPar_PWCOX=mod.PWCOX;
modelStruct.d_modelPar_PWCOX_dX=0.0;
modelStruct.modelPar_given_PWCOX=mod.given("PWCOX");
modelStruct.modelPar_PLWCOX=mod.PLWCOX;
modelStruct.d_modelPar_PLWCOX_dX=0.0;
modelStruct.modelPar_given_PLWCOX=mod.given("PLWCOX");
modelStruct.modelPar_POCGOV=mod.POCGOV;
modelStruct.d_modelPar_POCGOV_dX=0.0;
modelStruct.modelPar_given_POCGOV=mod.given("POCGOV");
modelStruct.modelPar_PLCGOV=mod.PLCGOV;
modelStruct.d_modelPar_PLCGOV_dX=0.0;
modelStruct.modelPar_given_PLCGOV=mod.given("PLCGOV");
modelStruct.modelPar_PWCGOV=mod.PWCGOV;
modelStruct.d_modelPar_PWCGOV_dX=0.0;
modelStruct.modelPar_given_PWCGOV=mod.given("PWCGOV");
modelStruct.modelPar_PLWCGOV=mod.PLWCGOV;
modelStruct.d_modelPar_PLWCGOV_dX=0.0;
modelStruct.modelPar_given_PLWCGOV=mod.given("PLWCGOV");
modelStruct.modelPar_POCGOVD=mod.POCGOVD;
modelStruct.d_modelPar_POCGOVD_dX=0.0;
modelStruct.modelPar_given_POCGOVD=mod.given("POCGOVD");
modelStruct.modelPar_PLCGOVD=mod.PLCGOVD;
modelStruct.d_modelPar_PLCGOVD_dX=0.0;
modelStruct.modelPar_given_PLCGOVD=mod.given("PLCGOVD");
modelStruct.modelPar_PWCGOVD=mod.PWCGOVD;
modelStruct.d_modelPar_PWCGOVD_dX=0.0;
modelStruct.modelPar_given_PWCGOVD=mod.given("PWCGOVD");
modelStruct.modelPar_PLWCGOVD=mod.PLWCGOVD;
modelStruct.d_modelPar_PLWCGOVD_dX=0.0;
modelStruct.modelPar_given_PLWCGOVD=mod.given("PLWCGOVD");
modelStruct.modelPar_POCGBOV=mod.POCGBOV;
modelStruct.d_modelPar_POCGBOV_dX=0.0;
modelStruct.modelPar_given_POCGBOV=mod.given("POCGBOV");
modelStruct.modelPar_PLCGBOV=mod.PLCGBOV;
modelStruct.d_modelPar_PLCGBOV_dX=0.0;
modelStruct.modelPar_given_PLCGBOV=mod.given("PLCGBOV");
modelStruct.modelPar_PWCGBOV=mod.PWCGBOV;
modelStruct.d_modelPar_PWCGBOV_dX=0.0;
modelStruct.modelPar_given_PWCGBOV=mod.given("PWCGBOV");
modelStruct.modelPar_PLWCGBOV=mod.PLWCGBOV;
modelStruct.d_modelPar_PLWCGBOV_dX=0.0;
modelStruct.modelPar_given_PLWCGBOV=mod.given("PLWCGBOV");
modelStruct.modelPar_POCFR=mod.POCFR;
modelStruct.d_modelPar_POCFR_dX=0.0;
modelStruct.modelPar_given_POCFR=mod.given("POCFR");
modelStruct.modelPar_PLCFR=mod.PLCFR;
modelStruct.d_modelPar_PLCFR_dX=0.0;
modelStruct.modelPar_given_PLCFR=mod.given("PLCFR");
modelStruct.modelPar_PWCFR=mod.PWCFR;
modelStruct.d_modelPar_PWCFR_dX=0.0;
modelStruct.modelPar_given_PWCFR=mod.given("PWCFR");
modelStruct.modelPar_PLWCFR=mod.PLWCFR;
modelStruct.d_modelPar_PLWCFR_dX=0.0;
modelStruct.modelPar_given_PLWCFR=mod.given("PLWCFR");
modelStruct.modelPar_POCFRD=mod.POCFRD;
modelStruct.d_modelPar_POCFRD_dX=0.0;
modelStruct.modelPar_given_POCFRD=mod.given("POCFRD");
modelStruct.modelPar_PLCFRD=mod.PLCFRD;
modelStruct.d_modelPar_PLCFRD_dX=0.0;
modelStruct.modelPar_given_PLCFRD=mod.given("PLCFRD");
modelStruct.modelPar_PWCFRD=mod.PWCFRD;
modelStruct.d_modelPar_PWCFRD_dX=0.0;
modelStruct.modelPar_given_PWCFRD=mod.given("PWCFRD");
modelStruct.modelPar_PLWCFRD=mod.PLWCFRD;
modelStruct.d_modelPar_PLWCFRD_dX=0.0;
modelStruct.modelPar_given_PLWCFRD=mod.given("PLWCFRD");
modelStruct.modelPar_POFNT=mod.POFNT;
modelStruct.d_modelPar_POFNT_dX=0.0;
modelStruct.modelPar_given_POFNT=mod.given("POFNT");
modelStruct.modelPar_POFNTEXC=mod.POFNTEXC;
modelStruct.d_modelPar_POFNTEXC_dX=0.0;
modelStruct.modelPar_given_POFNTEXC=mod.given("POFNTEXC");
modelStruct.modelPar_PLFNTEXC=mod.PLFNTEXC;
modelStruct.d_modelPar_PLFNTEXC_dX=0.0;
modelStruct.modelPar_given_PLFNTEXC=mod.given("PLFNTEXC");
modelStruct.modelPar_PWFNTEXC=mod.PWFNTEXC;
modelStruct.d_modelPar_PWFNTEXC_dX=0.0;
modelStruct.modelPar_given_PWFNTEXC=mod.given("PWFNTEXC");
modelStruct.modelPar_PLWFNTEXC=mod.PLWFNTEXC;
modelStruct.d_modelPar_PLWFNTEXC_dX=0.0;
modelStruct.modelPar_given_PLWFNTEXC=mod.given("PLWFNTEXC");
modelStruct.modelPar_PONFA=mod.PONFA;
modelStruct.d_modelPar_PONFA_dX=0.0;
modelStruct.modelPar_given_PONFA=mod.given("PONFA");
modelStruct.modelPar_PLNFA=mod.PLNFA;
modelStruct.d_modelPar_PLNFA_dX=0.0;
modelStruct.modelPar_given_PLNFA=mod.given("PLNFA");
modelStruct.modelPar_PWNFA=mod.PWNFA;
modelStruct.d_modelPar_PWNFA_dX=0.0;
modelStruct.modelPar_given_PWNFA=mod.given("PWNFA");
modelStruct.modelPar_PLWNFA=mod.PLWNFA;
modelStruct.d_modelPar_PLWNFA_dX=0.0;
modelStruct.modelPar_given_PLWNFA=mod.given("PLWNFA");
modelStruct.modelPar_PONFB=mod.PONFB;
modelStruct.d_modelPar_PONFB_dX=0.0;
modelStruct.modelPar_given_PONFB=mod.given("PONFB");
modelStruct.modelPar_PLNFB=mod.PLNFB;
modelStruct.d_modelPar_PLNFB_dX=0.0;
modelStruct.modelPar_given_PLNFB=mod.given("PLNFB");
modelStruct.modelPar_PWNFB=mod.PWNFB;
modelStruct.d_modelPar_PWNFB_dX=0.0;
modelStruct.modelPar_given_PWNFB=mod.given("PWNFB");
modelStruct.modelPar_PLWNFB=mod.PLWNFB;
modelStruct.d_modelPar_PLWNFB_dX=0.0;
modelStruct.modelPar_given_PLWNFB=mod.given("PLWNFB");
modelStruct.modelPar_PONFC=mod.PONFC;
modelStruct.d_modelPar_PONFC_dX=0.0;
modelStruct.modelPar_given_PONFC=mod.given("PONFC");
modelStruct.modelPar_PLNFC=mod.PLNFC;
modelStruct.d_modelPar_PLNFC_dX=0.0;
modelStruct.modelPar_given_PLNFC=mod.given("PLNFC");
modelStruct.modelPar_PWNFC=mod.PWNFC;
modelStruct.d_modelPar_PWNFC_dX=0.0;
modelStruct.modelPar_given_PWNFC=mod.given("PWNFC");
modelStruct.modelPar_PLWNFC=mod.PLWNFC;
modelStruct.d_modelPar_PLWNFC_dX=0.0;
modelStruct.modelPar_given_PLWNFC=mod.given("PLWNFC");
modelStruct.modelPar_POEF=mod.POEF;
modelStruct.d_modelPar_POEF_dX=0.0;
modelStruct.modelPar_given_POEF=mod.given("POEF");
modelStruct.modelPar_POVFBEDGE=mod.POVFBEDGE;
modelStruct.d_modelPar_POVFBEDGE_dX=0.0;
modelStruct.modelPar_given_POVFBEDGE=mod.given("POVFBEDGE");
modelStruct.modelPar_POSTVFBEDGE=mod.POSTVFBEDGE;
modelStruct.d_modelPar_POSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_POSTVFBEDGE=mod.given("POSTVFBEDGE");
modelStruct.modelPar_PLSTVFBEDGE=mod.PLSTVFBEDGE;
modelStruct.d_modelPar_PLSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLSTVFBEDGE=mod.given("PLSTVFBEDGE");
modelStruct.modelPar_PWSTVFBEDGE=mod.PWSTVFBEDGE;
modelStruct.d_modelPar_PWSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PWSTVFBEDGE=mod.given("PWSTVFBEDGE");
modelStruct.modelPar_PLWSTVFBEDGE=mod.PLWSTVFBEDGE;
modelStruct.d_modelPar_PLWSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWSTVFBEDGE=mod.given("PLWSTVFBEDGE");
modelStruct.modelPar_PODPHIBEDGE=mod.PODPHIBEDGE;
modelStruct.d_modelPar_PODPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PODPHIBEDGE=mod.given("PODPHIBEDGE");
modelStruct.modelPar_PLDPHIBEDGE=mod.PLDPHIBEDGE;
modelStruct.d_modelPar_PLDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PLDPHIBEDGE=mod.given("PLDPHIBEDGE");
modelStruct.modelPar_PWDPHIBEDGE=mod.PWDPHIBEDGE;
modelStruct.d_modelPar_PWDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PWDPHIBEDGE=mod.given("PWDPHIBEDGE");
modelStruct.modelPar_PLWDPHIBEDGE=mod.PLWDPHIBEDGE;
modelStruct.d_modelPar_PLWDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWDPHIBEDGE=mod.given("PLWDPHIBEDGE");
modelStruct.modelPar_PONEFFEDGE=mod.PONEFFEDGE;
modelStruct.d_modelPar_PONEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PONEFFEDGE=mod.given("PONEFFEDGE");
modelStruct.modelPar_PLNEFFEDGE=mod.PLNEFFEDGE;
modelStruct.d_modelPar_PLNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PLNEFFEDGE=mod.given("PLNEFFEDGE");
modelStruct.modelPar_PWNEFFEDGE=mod.PWNEFFEDGE;
modelStruct.d_modelPar_PWNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PWNEFFEDGE=mod.given("PWNEFFEDGE");
modelStruct.modelPar_PLWNEFFEDGE=mod.PLWNEFFEDGE;
modelStruct.d_modelPar_PLWNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNEFFEDGE=mod.given("PLWNEFFEDGE");
modelStruct.modelPar_POCTEDGE=mod.POCTEDGE;
modelStruct.d_modelPar_POCTEDGE_dX=0.0;
modelStruct.modelPar_given_POCTEDGE=mod.given("POCTEDGE");
modelStruct.modelPar_PLCTEDGE=mod.PLCTEDGE;
modelStruct.d_modelPar_PLCTEDGE_dX=0.0;
modelStruct.modelPar_given_PLCTEDGE=mod.given("PLCTEDGE");
modelStruct.modelPar_PWCTEDGE=mod.PWCTEDGE;
modelStruct.d_modelPar_PWCTEDGE_dX=0.0;
modelStruct.modelPar_given_PWCTEDGE=mod.given("PWCTEDGE");
modelStruct.modelPar_PLWCTEDGE=mod.PLWCTEDGE;
modelStruct.d_modelPar_PLWCTEDGE_dX=0.0;
modelStruct.modelPar_given_PLWCTEDGE=mod.given("PLWCTEDGE");
modelStruct.modelPar_POBETNEDGE=mod.POBETNEDGE;
modelStruct.d_modelPar_POBETNEDGE_dX=0.0;
modelStruct.modelPar_given_POBETNEDGE=mod.given("POBETNEDGE");
modelStruct.modelPar_PLBETNEDGE=mod.PLBETNEDGE;
modelStruct.d_modelPar_PLBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PLBETNEDGE=mod.given("PLBETNEDGE");
modelStruct.modelPar_PWBETNEDGE=mod.PWBETNEDGE;
modelStruct.d_modelPar_PWBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PWBETNEDGE=mod.given("PWBETNEDGE");
modelStruct.modelPar_PLWBETNEDGE=mod.PLWBETNEDGE;
modelStruct.d_modelPar_PLWBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PLWBETNEDGE=mod.given("PLWBETNEDGE");
modelStruct.modelPar_POSTBETEDGE=mod.POSTBETEDGE;
modelStruct.d_modelPar_POSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_POSTBETEDGE=mod.given("POSTBETEDGE");
modelStruct.modelPar_PLSTBETEDGE=mod.PLSTBETEDGE;
modelStruct.d_modelPar_PLSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PLSTBETEDGE=mod.given("PLSTBETEDGE");
modelStruct.modelPar_PWSTBETEDGE=mod.PWSTBETEDGE;
modelStruct.d_modelPar_PWSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PWSTBETEDGE=mod.given("PWSTBETEDGE");
modelStruct.modelPar_PLWSTBETEDGE=mod.PLWSTBETEDGE;
modelStruct.d_modelPar_PLWSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PLWSTBETEDGE=mod.given("PLWSTBETEDGE");
modelStruct.modelPar_POPSCEEDGE=mod.POPSCEEDGE;
modelStruct.d_modelPar_POPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEEDGE=mod.given("POPSCEEDGE");
modelStruct.modelPar_PLPSCEEDGE=mod.PLPSCEEDGE;
modelStruct.d_modelPar_PLPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PLPSCEEDGE=mod.given("PLPSCEEDGE");
modelStruct.modelPar_PWPSCEEDGE=mod.PWPSCEEDGE;
modelStruct.d_modelPar_PWPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PWPSCEEDGE=mod.given("PWPSCEEDGE");
modelStruct.modelPar_PLWPSCEEDGE=mod.PLWPSCEEDGE;
modelStruct.d_modelPar_PLWPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PLWPSCEEDGE=mod.given("PLWPSCEEDGE");
modelStruct.modelPar_POPSCEBEDGE=mod.POPSCEBEDGE;
modelStruct.d_modelPar_POPSCEBEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEBEDGE=mod.given("POPSCEBEDGE");
modelStruct.modelPar_POPSCEDEDGE=mod.POPSCEDEDGE;
modelStruct.d_modelPar_POPSCEDEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEDEDGE=mod.given("POPSCEDEDGE");
modelStruct.modelPar_POCFEDGE=mod.POCFEDGE;
modelStruct.d_modelPar_POCFEDGE_dX=0.0;
modelStruct.modelPar_given_POCFEDGE=mod.given("POCFEDGE");
modelStruct.modelPar_PLCFEDGE=mod.PLCFEDGE;
modelStruct.d_modelPar_PLCFEDGE_dX=0.0;
modelStruct.modelPar_given_PLCFEDGE=mod.given("PLCFEDGE");
modelStruct.modelPar_PWCFEDGE=mod.PWCFEDGE;
modelStruct.d_modelPar_PWCFEDGE_dX=0.0;
modelStruct.modelPar_given_PWCFEDGE=mod.given("PWCFEDGE");
modelStruct.modelPar_PLWCFEDGE=mod.PLWCFEDGE;
modelStruct.d_modelPar_PLWCFEDGE_dX=0.0;
modelStruct.modelPar_given_PLWCFEDGE=mod.given("PLWCFEDGE");
modelStruct.modelPar_POCFDEDGE=mod.POCFDEDGE;
modelStruct.d_modelPar_POCFDEDGE_dX=0.0;
modelStruct.modelPar_given_POCFDEDGE=mod.given("POCFDEDGE");
modelStruct.modelPar_POCFBEDGE=mod.POCFBEDGE;
modelStruct.d_modelPar_POCFBEDGE_dX=0.0;
modelStruct.modelPar_given_POCFBEDGE=mod.given("POCFBEDGE");
modelStruct.modelPar_POFNTEDGE=mod.POFNTEDGE;
modelStruct.d_modelPar_POFNTEDGE_dX=0.0;
modelStruct.modelPar_given_POFNTEDGE=mod.given("POFNTEDGE");
modelStruct.modelPar_PONFAEDGE=mod.PONFAEDGE;
modelStruct.d_modelPar_PONFAEDGE_dX=0.0;
modelStruct.modelPar_given_PONFAEDGE=mod.given("PONFAEDGE");
modelStruct.modelPar_PLNFAEDGE=mod.PLNFAEDGE;
modelStruct.d_modelPar_PLNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFAEDGE=mod.given("PLNFAEDGE");
modelStruct.modelPar_PWNFAEDGE=mod.PWNFAEDGE;
modelStruct.d_modelPar_PWNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFAEDGE=mod.given("PWNFAEDGE");
modelStruct.modelPar_PLWNFAEDGE=mod.PLWNFAEDGE;
modelStruct.d_modelPar_PLWNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFAEDGE=mod.given("PLWNFAEDGE");
modelStruct.modelPar_PONFBEDGE=mod.PONFBEDGE;
modelStruct.d_modelPar_PONFBEDGE_dX=0.0;
modelStruct.modelPar_given_PONFBEDGE=mod.given("PONFBEDGE");
modelStruct.modelPar_PLNFBEDGE=mod.PLNFBEDGE;
modelStruct.d_modelPar_PLNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFBEDGE=mod.given("PLNFBEDGE");
modelStruct.modelPar_PWNFBEDGE=mod.PWNFBEDGE;
modelStruct.d_modelPar_PWNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFBEDGE=mod.given("PWNFBEDGE");
modelStruct.modelPar_PLWNFBEDGE=mod.PLWNFBEDGE;
modelStruct.d_modelPar_PLWNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFBEDGE=mod.given("PLWNFBEDGE");
modelStruct.modelPar_PONFCEDGE=mod.PONFCEDGE;
modelStruct.d_modelPar_PONFCEDGE_dX=0.0;
modelStruct.modelPar_given_PONFCEDGE=mod.given("PONFCEDGE");
modelStruct.modelPar_PLNFCEDGE=mod.PLNFCEDGE;
modelStruct.d_modelPar_PLNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFCEDGE=mod.given("PLNFCEDGE");
modelStruct.modelPar_PWNFCEDGE=mod.PWNFCEDGE;
modelStruct.d_modelPar_PWNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFCEDGE=mod.given("PWNFCEDGE");
modelStruct.modelPar_PLWNFCEDGE=mod.PLWNFCEDGE;
modelStruct.d_modelPar_PLWNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFCEDGE=mod.given("PLWNFCEDGE");
modelStruct.modelPar_POEFEDGE=mod.POEFEDGE;
modelStruct.d_modelPar_POEFEDGE_dX=0.0;
modelStruct.modelPar_given_POEFEDGE=mod.given("POEFEDGE");
modelStruct.modelPar_POKVTHOWE=mod.POKVTHOWE;
modelStruct.d_modelPar_POKVTHOWE_dX=0.0;
modelStruct.modelPar_given_POKVTHOWE=mod.given("POKVTHOWE");
modelStruct.modelPar_PLKVTHOWE=mod.PLKVTHOWE;
modelStruct.d_modelPar_PLKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PLKVTHOWE=mod.given("PLKVTHOWE");
modelStruct.modelPar_PWKVTHOWE=mod.PWKVTHOWE;
modelStruct.d_modelPar_PWKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PWKVTHOWE=mod.given("PWKVTHOWE");
modelStruct.modelPar_PLWKVTHOWE=mod.PLWKVTHOWE;
modelStruct.d_modelPar_PLWKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PLWKVTHOWE=mod.given("PLWKVTHOWE");
modelStruct.modelPar_POKUOWE=mod.POKUOWE;
modelStruct.d_modelPar_POKUOWE_dX=0.0;
modelStruct.modelPar_given_POKUOWE=mod.given("POKUOWE");
modelStruct.modelPar_PLKUOWE=mod.PLKUOWE;
modelStruct.d_modelPar_PLKUOWE_dX=0.0;
modelStruct.modelPar_given_PLKUOWE=mod.given("PLKUOWE");
modelStruct.modelPar_PWKUOWE=mod.PWKUOWE;
modelStruct.d_modelPar_PWKUOWE_dX=0.0;
modelStruct.modelPar_given_PWKUOWE=mod.given("PWKUOWE");
modelStruct.modelPar_PLWKUOWE=mod.PLWKUOWE;
modelStruct.d_modelPar_PLWKUOWE_dX=0.0;
modelStruct.modelPar_given_PLWKUOWE=mod.given("PLWKUOWE");
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modelStruct.modelPar_TOXO=mod.TOXO;
modelStruct.d_modelPar_TOXO_dX=0.0;
modelStruct.modelPar_given_TOXO=mod.given("TOXO");
modelStruct.modelPar_EPSROXO=mod.EPSROXO;
modelStruct.d_modelPar_EPSROXO_dX=0.0;
modelStruct.modelPar_given_EPSROXO=mod.given("EPSROXO");
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modelStruct.modelPar_NSUBW=mod.NSUBW;
modelStruct.d_modelPar_NSUBW_dX=0.0;
modelStruct.modelPar_given_NSUBW=mod.given("NSUBW");
modelStruct.modelPar_WSEG=mod.WSEG;
modelStruct.d_modelPar_WSEG_dX=0.0;
modelStruct.modelPar_given_WSEG=mod.given("WSEG");
modelStruct.modelPar_NPCK=mod.NPCK;
modelStruct.d_modelPar_NPCK_dX=0.0;
modelStruct.modelPar_given_NPCK=mod.given("NPCK");
modelStruct.modelPar_NPCKW=mod.NPCKW;
modelStruct.d_modelPar_NPCKW_dX=0.0;
modelStruct.modelPar_given_NPCKW=mod.given("NPCKW");
modelStruct.modelPar_WSEGP=mod.WSEGP;
modelStruct.d_modelPar_WSEGP_dX=0.0;
modelStruct.modelPar_given_WSEGP=mod.given("WSEGP");
modelStruct.modelPar_LPCK=mod.LPCK;
modelStruct.d_modelPar_LPCK_dX=0.0;
modelStruct.modelPar_given_LPCK=mod.given("LPCK");
modelStruct.modelPar_LPCKW=mod.LPCKW;
modelStruct.d_modelPar_LPCKW_dX=0.0;
modelStruct.modelPar_given_LPCKW=mod.given("LPCKW");
modelStruct.modelPar_FOL1=mod.FOL1;
modelStruct.d_modelPar_FOL1_dX=0.0;
modelStruct.modelPar_given_FOL1=mod.given("FOL1");
modelStruct.modelPar_FOL2=mod.FOL2;
modelStruct.d_modelPar_FOL2_dX=0.0;
modelStruct.modelPar_given_FOL2=mod.given("FOL2");
modelStruct.modelPar_FACNEFFACO=mod.FACNEFFACO;
modelStruct.d_modelPar_FACNEFFACO_dX=0.0;
modelStruct.modelPar_given_FACNEFFACO=mod.given("FACNEFFACO");
modelStruct.modelPar_FACNEFFACL=mod.FACNEFFACL;
modelStruct.d_modelPar_FACNEFFACL_dX=0.0;
modelStruct.modelPar_given_FACNEFFACL=mod.given("FACNEFFACL");
modelStruct.modelPar_FACNEFFACW=mod.FACNEFFACW;
modelStruct.d_modelPar_FACNEFFACW_dX=0.0;
modelStruct.modelPar_given_FACNEFFACW=mod.given("FACNEFFACW");
modelStruct.modelPar_FACNEFFACLW=mod.FACNEFFACLW;
modelStruct.d_modelPar_FACNEFFACLW_dX=0.0;
modelStruct.modelPar_given_FACNEFFACLW=mod.given("FACNEFFACLW");
modelStruct.modelPar_GFACNUDO=mod.GFACNUDO;
modelStruct.d_modelPar_GFACNUDO_dX=0.0;
modelStruct.modelPar_given_GFACNUDO=mod.given("GFACNUDO");
modelStruct.modelPar_GFACNUDL=mod.GFACNUDL;
modelStruct.d_modelPar_GFACNUDL_dX=0.0;
modelStruct.modelPar_given_GFACNUDL=mod.given("GFACNUDL");
modelStruct.modelPar_GFACNUDLEXP=mod.GFACNUDLEXP;
modelStruct.d_modelPar_GFACNUDLEXP_dX=0.0;
modelStruct.modelPar_given_GFACNUDLEXP=mod.given("GFACNUDLEXP");
modelStruct.modelPar_GFACNUDW=mod.GFACNUDW;
modelStruct.d_modelPar_GFACNUDW_dX=0.0;
modelStruct.modelPar_given_GFACNUDW=mod.given("GFACNUDW");
modelStruct.modelPar_GFACNUDLW=mod.GFACNUDLW;
modelStruct.d_modelPar_GFACNUDLW_dX=0.0;
modelStruct.modelPar_given_GFACNUDLW=mod.given("GFACNUDLW");
modelStruct.modelPar_VSBNUDO=mod.VSBNUDO;
modelStruct.d_modelPar_VSBNUDO_dX=0.0;
modelStruct.modelPar_given_VSBNUDO=mod.given("VSBNUDO");
modelStruct.modelPar_DVSBNUDO=mod.DVSBNUDO;
modelStruct.d_modelPar_DVSBNUDO_dX=0.0;
modelStruct.modelPar_given_DVSBNUDO=mod.given("DVSBNUDO");
modelStruct.modelPar_VNSUBO=mod.VNSUBO;
modelStruct.d_modelPar_VNSUBO_dX=0.0;
modelStruct.modelPar_given_VNSUBO=mod.given("VNSUBO");
modelStruct.modelPar_NSLPO=mod.NSLPO;
modelStruct.d_modelPar_NSLPO_dX=0.0;
modelStruct.modelPar_given_NSLPO=mod.given("NSLPO");
modelStruct.modelPar_DNSUBO=mod.DNSUBO;
modelStruct.d_modelPar_DNSUBO_dX=0.0;
modelStruct.modelPar_given_DNSUBO=mod.given("DNSUBO");
modelStruct.modelPar_DPHIBO=mod.DPHIBO;
modelStruct.d_modelPar_DPHIBO_dX=0.0;
modelStruct.modelPar_given_DPHIBO=mod.given("DPHIBO");
modelStruct.modelPar_DPHIBL=mod.DPHIBL;
modelStruct.d_modelPar_DPHIBL_dX=0.0;
modelStruct.modelPar_given_DPHIBL=mod.given("DPHIBL");
modelStruct.modelPar_DPHIBLEXP=mod.DPHIBLEXP;
modelStruct.d_modelPar_DPHIBLEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
modelStruct.modelPar_DPHIBW=mod.DPHIBW;
modelStruct.d_modelPar_DPHIBW_dX=0.0;
modelStruct.modelPar_given_DPHIBW=mod.given("DPHIBW");
modelStruct.modelPar_DPHIBLW=mod.DPHIBLW;
modelStruct.d_modelPar_DPHIBLW_dX=0.0;
modelStruct.modelPar_given_DPHIBLW=mod.given("DPHIBLW");
modelStruct.modelPar_DELVTACO=mod.DELVTACO;
modelStruct.d_modelPar_DELVTACO_dX=0.0;
modelStruct.modelPar_given_DELVTACO=mod.given("DELVTACO");
modelStruct.modelPar_DELVTACL=mod.DELVTACL;
modelStruct.d_modelPar_DELVTACL_dX=0.0;
modelStruct.modelPar_given_DELVTACL=mod.given("DELVTACL");
modelStruct.modelPar_DELVTACLEXP=mod.DELVTACLEXP;
modelStruct.d_modelPar_DELVTACLEXP_dX=0.0;
modelStruct.modelPar_given_DELVTACLEXP=mod.given("DELVTACLEXP");
modelStruct.modelPar_DELVTACW=mod.DELVTACW;
modelStruct.d_modelPar_DELVTACW_dX=0.0;
modelStruct.modelPar_given_DELVTACW=mod.given("DELVTACW");
modelStruct.modelPar_DELVTACLW=mod.DELVTACLW;
modelStruct.d_modelPar_DELVTACLW_dX=0.0;
modelStruct.modelPar_given_DELVTACLW=mod.given("DELVTACLW");
modelStruct.modelPar_NPO=mod.NPO;
modelStruct.d_modelPar_NPO_dX=0.0;
modelStruct.modelPar_given_NPO=mod.given("NPO");
modelStruct.modelPar_NPL=mod.NPL;
modelStruct.d_modelPar_NPL_dX=0.0;
modelStruct.modelPar_given_NPL=mod.given("NPL");
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modelStruct.modelPar_CTL=mod.CTL;
modelStruct.d_modelPar_CTL_dX=0.0;
modelStruct.modelPar_given_CTL=mod.given("CTL");
modelStruct.modelPar_CTLEXP=mod.CTLEXP;
modelStruct.d_modelPar_CTLEXP_dX=0.0;
modelStruct.modelPar_given_CTLEXP=mod.given("CTLEXP");
modelStruct.modelPar_CTW=mod.CTW;
modelStruct.d_modelPar_CTW_dX=0.0;
modelStruct.modelPar_given_CTW=mod.given("CTW");
modelStruct.modelPar_CTLW=mod.CTLW;
modelStruct.d_modelPar_CTLW_dX=0.0;
modelStruct.modelPar_given_CTLW=mod.given("CTLW");
modelStruct.modelPar_TOXOVO=mod.TOXOVO;
modelStruct.d_modelPar_TOXOVO_dX=0.0;
modelStruct.modelPar_given_TOXOVO=mod.given("TOXOVO");
modelStruct.modelPar_TOXOVDO=mod.TOXOVDO;
modelStruct.d_modelPar_TOXOVDO_dX=0.0;
modelStruct.modelPar_given_TOXOVDO=mod.given("TOXOVDO");
modelStruct.modelPar_LOV=mod.LOV;
modelStruct.d_modelPar_LOV_dX=0.0;
modelStruct.modelPar_given_LOV=mod.given("LOV");
modelStruct.modelPar_LOVD=mod.LOVD;
modelStruct.d_modelPar_LOVD_dX=0.0;
modelStruct.modelPar_given_LOVD=mod.given("LOVD");
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modelStruct.modelPar_CFDO=mod.CFDO;
modelStruct.d_modelPar_CFDO_dX=0.0;
modelStruct.modelPar_given_CFDO=mod.given("CFDO");
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modelStruct.modelPar_PSCEL=mod.PSCEL;
modelStruct.d_modelPar_PSCEL_dX=0.0;
modelStruct.modelPar_given_PSCEL=mod.given("PSCEL");
modelStruct.modelPar_PSCELEXP=mod.PSCELEXP;
modelStruct.d_modelPar_PSCELEXP_dX=0.0;
modelStruct.modelPar_given_PSCELEXP=mod.given("PSCELEXP");
modelStruct.modelPar_PSCEW=mod.PSCEW;
modelStruct.d_modelPar_PSCEW_dX=0.0;
modelStruct.modelPar_given_PSCEW=mod.given("PSCEW");
modelStruct.modelPar_PSCEBO=mod.PSCEBO;
modelStruct.d_modelPar_PSCEBO_dX=0.0;
modelStruct.modelPar_given_PSCEBO=mod.given("PSCEBO");
modelStruct.modelPar_PSCEDO=mod.PSCEDO;
modelStruct.d_modelPar_PSCEDO_dX=0.0;
modelStruct.modelPar_given_PSCEDO=mod.given("PSCEDO");
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modelStruct.modelPar_MUEW=mod.MUEW;
modelStruct.d_modelPar_MUEW_dX=0.0;
modelStruct.modelPar_given_MUEW=mod.given("MUEW");
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modelStruct.modelPar_ALPL=mod.ALPL;
modelStruct.d_modelPar_ALPL_dX=0.0;
modelStruct.modelPar_given_ALPL=mod.given("ALPL");
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modelStruct.modelPar_ALP2L1=mod.ALP2L1;
modelStruct.d_modelPar_ALP2L1_dX=0.0;
modelStruct.modelPar_given_ALP2L1=mod.given("ALP2L1");
modelStruct.modelPar_ALP2LEXP=mod.ALP2LEXP;
modelStruct.d_modelPar_ALP2LEXP_dX=0.0;
modelStruct.modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
modelStruct.modelPar_ALP2L2=mod.ALP2L2;
modelStruct.d_modelPar_ALP2L2_dX=0.0;
modelStruct.modelPar_given_ALP2L2=mod.given("ALP2L2");
modelStruct.modelPar_ALP2W=mod.ALP2W;
modelStruct.d_modelPar_ALP2W_dX=0.0;
modelStruct.modelPar_given_ALP2W=mod.given("ALP2W");
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modelStruct.modelPar_A4O=mod.A4O;
modelStruct.d_modelPar_A4O_dX=0.0;
modelStruct.modelPar_given_A4O=mod.given("A4O");
modelStruct.modelPar_A4L=mod.A4L;
modelStruct.d_modelPar_A4L_dX=0.0;
modelStruct.modelPar_given_A4L=mod.given("A4L");
modelStruct.modelPar_A4W=mod.A4W;
modelStruct.d_modelPar_A4W_dX=0.0;
modelStruct.modelPar_given_A4W=mod.given("A4W");
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modelStruct.modelPar_IGOVW=mod.IGOVW;
modelStruct.d_modelPar_IGOVW_dX=0.0;
modelStruct.modelPar_given_IGOVW=mod.given("IGOVW");
modelStruct.modelPar_IGOVDW=mod.IGOVDW;
modelStruct.d_modelPar_IGOVDW_dX=0.0;
modelStruct.modelPar_given_IGOVDW=mod.given("IGOVDW");
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modelStruct.modelPar_GC2O=mod.GC2O;
modelStruct.d_modelPar_GC2O_dX=0.0;
modelStruct.modelPar_given_GC2O=mod.given("GC2O");
modelStruct.modelPar_GC3O=mod.GC3O;
modelStruct.d_modelPar_GC3O_dX=0.0;
modelStruct.modelPar_given_GC3O=mod.given("GC3O");
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modelStruct.modelPar_ALPNOI=mod.ALPNOI;
modelStruct.d_modelPar_ALPNOI_dX=0.0;
modelStruct.modelPar_given_ALPNOI=mod.given("ALPNOI");
modelStruct.modelPar_WEDGE=mod.WEDGE;
modelStruct.d_modelPar_WEDGE_dX=0.0;
modelStruct.modelPar_given_WEDGE=mod.given("WEDGE");
modelStruct.modelPar_WEDGEW=mod.WEDGEW;
modelStruct.d_modelPar_WEDGEW_dX=0.0;
modelStruct.modelPar_given_WEDGEW=mod.given("WEDGEW");
modelStruct.modelPar_VFBEDGEO=mod.VFBEDGEO;
modelStruct.d_modelPar_VFBEDGEO_dX=0.0;
modelStruct.modelPar_given_VFBEDGEO=mod.given("VFBEDGEO");
modelStruct.modelPar_STVFBEDGEO=mod.STVFBEDGEO;
modelStruct.d_modelPar_STVFBEDGEO_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEO=mod.given("STVFBEDGEO");
modelStruct.modelPar_STVFBEDGEL=mod.STVFBEDGEL;
modelStruct.d_modelPar_STVFBEDGEL_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEL=mod.given("STVFBEDGEL");
modelStruct.modelPar_STVFBEDGEW=mod.STVFBEDGEW;
modelStruct.d_modelPar_STVFBEDGEW_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEW=mod.given("STVFBEDGEW");
modelStruct.modelPar_STVFBEDGELW=mod.STVFBEDGELW;
modelStruct.d_modelPar_STVFBEDGELW_dX=0.0;
modelStruct.modelPar_given_STVFBEDGELW=mod.given("STVFBEDGELW");
modelStruct.modelPar_DPHIBEDGEO=mod.DPHIBEDGEO;
modelStruct.d_modelPar_DPHIBEDGEO_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEO=mod.given("DPHIBEDGEO");
modelStruct.modelPar_DPHIBEDGEL=mod.DPHIBEDGEL;
modelStruct.d_modelPar_DPHIBEDGEL_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEL=mod.given("DPHIBEDGEL");
modelStruct.modelPar_DPHIBEDGELEXP=mod.DPHIBEDGELEXP;
modelStruct.d_modelPar_DPHIBEDGELEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGELEXP=mod.given("DPHIBEDGELEXP");
modelStruct.modelPar_DPHIBEDGEW=mod.DPHIBEDGEW;
modelStruct.d_modelPar_DPHIBEDGEW_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEW=mod.given("DPHIBEDGEW");
modelStruct.modelPar_DPHIBEDGELW=mod.DPHIBEDGELW;
modelStruct.d_modelPar_DPHIBEDGELW_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGELW=mod.given("DPHIBEDGELW");
modelStruct.modelPar_NSUBEDGEO=mod.NSUBEDGEO;
modelStruct.d_modelPar_NSUBEDGEO_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEO=mod.given("NSUBEDGEO");
modelStruct.modelPar_NSUBEDGEL=mod.NSUBEDGEL;
modelStruct.d_modelPar_NSUBEDGEL_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEL=mod.given("NSUBEDGEL");
modelStruct.modelPar_NSUBEDGEW=mod.NSUBEDGEW;
modelStruct.d_modelPar_NSUBEDGEW_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEW=mod.given("NSUBEDGEW");
modelStruct.modelPar_NSUBEDGELW=mod.NSUBEDGELW;
modelStruct.d_modelPar_NSUBEDGELW_dX=0.0;
modelStruct.modelPar_given_NSUBEDGELW=mod.given("NSUBEDGELW");
modelStruct.modelPar_CTEDGEO=mod.CTEDGEO;
modelStruct.d_modelPar_CTEDGEO_dX=0.0;
modelStruct.modelPar_given_CTEDGEO=mod.given("CTEDGEO");
modelStruct.modelPar_CTEDGEL=mod.CTEDGEL;
modelStruct.d_modelPar_CTEDGEL_dX=0.0;
modelStruct.modelPar_given_CTEDGEL=mod.given("CTEDGEL");
modelStruct.modelPar_CTEDGELEXP=mod.CTEDGELEXP;
modelStruct.d_modelPar_CTEDGELEXP_dX=0.0;
modelStruct.modelPar_given_CTEDGELEXP=mod.given("CTEDGELEXP");
modelStruct.modelPar_FBETEDGE=mod.FBETEDGE;
modelStruct.d_modelPar_FBETEDGE_dX=0.0;
modelStruct.modelPar_given_FBETEDGE=mod.given("FBETEDGE");
modelStruct.modelPar_LPEDGE=mod.LPEDGE;
modelStruct.d_modelPar_LPEDGE_dX=0.0;
modelStruct.modelPar_given_LPEDGE=mod.given("LPEDGE");
modelStruct.modelPar_BETEDGEW=mod.BETEDGEW;
modelStruct.d_modelPar_BETEDGEW_dX=0.0;
modelStruct.modelPar_given_BETEDGEW=mod.given("BETEDGEW");
modelStruct.modelPar_STBETEDGEO=mod.STBETEDGEO;
modelStruct.d_modelPar_STBETEDGEO_dX=0.0;
modelStruct.modelPar_given_STBETEDGEO=mod.given("STBETEDGEO");
modelStruct.modelPar_STBETEDGEL=mod.STBETEDGEL;
modelStruct.d_modelPar_STBETEDGEL_dX=0.0;
modelStruct.modelPar_given_STBETEDGEL=mod.given("STBETEDGEL");
modelStruct.modelPar_STBETEDGEW=mod.STBETEDGEW;
modelStruct.d_modelPar_STBETEDGEW_dX=0.0;
modelStruct.modelPar_given_STBETEDGEW=mod.given("STBETEDGEW");
modelStruct.modelPar_STBETEDGELW=mod.STBETEDGELW;
modelStruct.d_modelPar_STBETEDGELW_dX=0.0;
modelStruct.modelPar_given_STBETEDGELW=mod.given("STBETEDGELW");
modelStruct.modelPar_PSCEEDGEL=mod.PSCEEDGEL;
modelStruct.d_modelPar_PSCEEDGEL_dX=0.0;
modelStruct.modelPar_given_PSCEEDGEL=mod.given("PSCEEDGEL");
modelStruct.modelPar_PSCEEDGELEXP=mod.PSCEEDGELEXP;
modelStruct.d_modelPar_PSCEEDGELEXP_dX=0.0;
modelStruct.modelPar_given_PSCEEDGELEXP=mod.given("PSCEEDGELEXP");
modelStruct.modelPar_PSCEEDGEW=mod.PSCEEDGEW;
modelStruct.d_modelPar_PSCEEDGEW_dX=0.0;
modelStruct.modelPar_given_PSCEEDGEW=mod.given("PSCEEDGEW");
modelStruct.modelPar_PSCEBEDGEO=mod.PSCEBEDGEO;
modelStruct.d_modelPar_PSCEBEDGEO_dX=0.0;
modelStruct.modelPar_given_PSCEBEDGEO=mod.given("PSCEBEDGEO");
modelStruct.modelPar_PSCEDEDGEO=mod.PSCEDEDGEO;
modelStruct.d_modelPar_PSCEDEDGEO_dX=0.0;
modelStruct.modelPar_given_PSCEDEDGEO=mod.given("PSCEDEDGEO");
modelStruct.modelPar_CFEDGEL=mod.CFEDGEL;
modelStruct.d_modelPar_CFEDGEL_dX=0.0;
modelStruct.modelPar_given_CFEDGEL=mod.given("CFEDGEL");
modelStruct.modelPar_CFEDGELEXP=mod.CFEDGELEXP;
modelStruct.d_modelPar_CFEDGELEXP_dX=0.0;
modelStruct.modelPar_given_CFEDGELEXP=mod.given("CFEDGELEXP");
modelStruct.modelPar_CFEDGEW=mod.CFEDGEW;
modelStruct.d_modelPar_CFEDGEW_dX=0.0;
modelStruct.modelPar_given_CFEDGEW=mod.given("CFEDGEW");
modelStruct.modelPar_CFDEDGEO=mod.CFDEDGEO;
modelStruct.d_modelPar_CFDEDGEO_dX=0.0;
modelStruct.modelPar_given_CFDEDGEO=mod.given("CFDEDGEO");
modelStruct.modelPar_CFBEDGEO=mod.CFBEDGEO;
modelStruct.d_modelPar_CFBEDGEO_dX=0.0;
modelStruct.modelPar_given_CFBEDGEO=mod.given("CFBEDGEO");
modelStruct.modelPar_FNTEDGEO=mod.FNTEDGEO;
modelStruct.d_modelPar_FNTEDGEO_dX=0.0;
modelStruct.modelPar_given_FNTEDGEO=mod.given("FNTEDGEO");
modelStruct.modelPar_NFAEDGELW=mod.NFAEDGELW;
modelStruct.d_modelPar_NFAEDGELW_dX=0.0;
modelStruct.modelPar_given_NFAEDGELW=mod.given("NFAEDGELW");
modelStruct.modelPar_NFBEDGELW=mod.NFBEDGELW;
modelStruct.d_modelPar_NFBEDGELW_dX=0.0;
modelStruct.modelPar_given_NFBEDGELW=mod.given("NFBEDGELW");
modelStruct.modelPar_NFCEDGELW=mod.NFCEDGELW;
modelStruct.d_modelPar_NFCEDGELW_dX=0.0;
modelStruct.modelPar_given_NFCEDGELW=mod.given("NFCEDGELW");
modelStruct.modelPar_EFEDGEO=mod.EFEDGEO;
modelStruct.d_modelPar_EFEDGEO_dX=0.0;
modelStruct.modelPar_given_EFEDGEO=mod.given("EFEDGEO");
modelStruct.modelPar_KVTHOWEO=mod.KVTHOWEO;
modelStruct.d_modelPar_KVTHOWEO_dX=0.0;
modelStruct.modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
modelStruct.modelPar_KVTHOWEL=mod.KVTHOWEL;
modelStruct.d_modelPar_KVTHOWEL_dX=0.0;
modelStruct.modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
modelStruct.modelPar_KVTHOWEW=mod.KVTHOWEW;
modelStruct.d_modelPar_KVTHOWEW_dX=0.0;
modelStruct.modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
modelStruct.modelPar_KVTHOWELW=mod.KVTHOWELW;
modelStruct.d_modelPar_KVTHOWELW_dX=0.0;
modelStruct.modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
modelStruct.modelPar_KUOWEO=mod.KUOWEO;
modelStruct.d_modelPar_KUOWEO_dX=0.0;
modelStruct.modelPar_given_KUOWEO=mod.given("KUOWEO");
modelStruct.modelPar_KUOWEL=mod.KUOWEL;
modelStruct.d_modelPar_KUOWEL_dX=0.0;
modelStruct.modelPar_given_KUOWEL=mod.given("KUOWEL");
modelStruct.modelPar_KUOWEW=mod.KUOWEW;
modelStruct.d_modelPar_KUOWEW_dX=0.0;
modelStruct.modelPar_given_KUOWEW=mod.given("KUOWEW");
modelStruct.modelPar_KUOWELW=mod.KUOWELW;
modelStruct.d_modelPar_KUOWELW_dX=0.0;
modelStruct.modelPar_given_KUOWELW=mod.given("KUOWELW");
modelStruct.modelPar_RGO=mod.RGO;
modelStruct.d_modelPar_RGO_dX=0.0;
modelStruct.modelPar_given_RGO=mod.given("RGO");
modelStruct.modelPar_RINT=mod.RINT;
modelStruct.d_modelPar_RINT_dX=0.0;
modelStruct.modelPar_given_RINT=mod.given("RINT");
modelStruct.modelPar_RVPOLY=mod.RVPOLY;
modelStruct.d_modelPar_RVPOLY_dX=0.0;
modelStruct.modelPar_given_RVPOLY=mod.given("RVPOLY");
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modelStruct.modelPar_DLSIL=mod.DLSIL;
modelStruct.d_modelPar_DLSIL_dX=0.0;
modelStruct.modelPar_given_DLSIL=mod.given("DLSIL");
modelStruct.modelPar_RSH=mod.RSH;
modelStruct.d_modelPar_RSH_dX=0.0;
modelStruct.modelPar_given_RSH=mod.given("RSH");
modelStruct.modelPar_RSHD=mod.RSHD;
modelStruct.d_modelPar_RSHD_dX=0.0;
modelStruct.modelPar_given_RSHD=mod.given("RSHD");
modelStruct.modelPar_RBULKO=mod.RBULKO;
modelStruct.d_modelPar_RBULKO_dX=0.0;
modelStruct.modelPar_given_RBULKO=mod.given("RBULKO");
modelStruct.modelPar_RWELLO=mod.RWELLO;
modelStruct.d_modelPar_RWELLO_dX=0.0;
modelStruct.modelPar_given_RWELLO=mod.given("RWELLO");
modelStruct.modelPar_RJUNSO=mod.RJUNSO;
modelStruct.d_modelPar_RJUNSO_dX=0.0;
modelStruct.modelPar_given_RJUNSO=mod.given("RJUNSO");
modelStruct.modelPar_RJUNDO=mod.RJUNDO;
modelStruct.d_modelPar_RJUNDO_dX=0.0;
modelStruct.modelPar_given_RJUNDO=mod.given("RJUNDO");
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modelStruct.modelPar_FREV=mod.FREV;
modelStruct.d_modelPar_FREV_dX=0.0;
modelStruct.modelPar_given_FREV=mod.given("FREV");
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modelStruct.modelPar_CJORBOTD=mod.CJORBOTD;
modelStruct.d_modelPar_CJORBOTD_dX=0.0;
modelStruct.modelPar_given_CJORBOTD=mod.given("CJORBOTD");
modelStruct.modelPar_CJORSTID=mod.CJORSTID;
modelStruct.d_modelPar_CJORSTID_dX=0.0;
modelStruct.modelPar_given_CJORSTID=mod.given("CJORSTID");
modelStruct.modelPar_CJORGATD=mod.CJORGATD;
modelStruct.d_modelPar_CJORGATD_dX=0.0;
modelStruct.modelPar_given_CJORGATD=mod.given("CJORGATD");
modelStruct.modelPar_VBIRBOTD=mod.VBIRBOTD;
modelStruct.d_modelPar_VBIRBOTD_dX=0.0;
modelStruct.modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
modelStruct.modelPar_VBIRSTID=mod.VBIRSTID;
modelStruct.d_modelPar_VBIRSTID_dX=0.0;
modelStruct.modelPar_given_VBIRSTID=mod.given("VBIRSTID");
modelStruct.modelPar_VBIRGATD=mod.VBIRGATD;
modelStruct.d_modelPar_VBIRGATD_dX=0.0;
modelStruct.modelPar_given_VBIRGATD=mod.given("VBIRGATD");
modelStruct.modelPar_PBOTD=mod.PBOTD;
modelStruct.d_modelPar_PBOTD_dX=0.0;
modelStruct.modelPar_given_PBOTD=mod.given("PBOTD");
modelStruct.modelPar_PSTID=mod.PSTID;
modelStruct.d_modelPar_PSTID_dX=0.0;
modelStruct.modelPar_given_PSTID=mod.given("PSTID");
modelStruct.modelPar_PGATD=mod.PGATD;
modelStruct.d_modelPar_PGATD_dX=0.0;
modelStruct.modelPar_given_PGATD=mod.given("PGATD");
modelStruct.modelPar_PHIGBOTD=mod.PHIGBOTD;
modelStruct.d_modelPar_PHIGBOTD_dX=0.0;
modelStruct.modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
modelStruct.modelPar_PHIGSTID=mod.PHIGSTID;
modelStruct.d_modelPar_PHIGSTID_dX=0.0;
modelStruct.modelPar_given_PHIGSTID=mod.given("PHIGSTID");
modelStruct.modelPar_PHIGGATD=mod.PHIGGATD;
modelStruct.d_modelPar_PHIGGATD_dX=0.0;
modelStruct.modelPar_given_PHIGGATD=mod.given("PHIGGATD");
modelStruct.modelPar_IDSATRBOTD=mod.IDSATRBOTD;
modelStruct.d_modelPar_IDSATRBOTD_dX=0.0;
modelStruct.modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
modelStruct.modelPar_IDSATRSTID=mod.IDSATRSTID;
modelStruct.d_modelPar_IDSATRSTID_dX=0.0;
modelStruct.modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
modelStruct.modelPar_IDSATRGATD=mod.IDSATRGATD;
modelStruct.d_modelPar_IDSATRGATD_dX=0.0;
modelStruct.modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
modelStruct.modelPar_CSRHBOTD=mod.CSRHBOTD;
modelStruct.d_modelPar_CSRHBOTD_dX=0.0;
modelStruct.modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
modelStruct.modelPar_CSRHSTID=mod.CSRHSTID;
modelStruct.d_modelPar_CSRHSTID_dX=0.0;
modelStruct.modelPar_given_CSRHSTID=mod.given("CSRHSTID");
modelStruct.modelPar_CSRHGATD=mod.CSRHGATD;
modelStruct.d_modelPar_CSRHGATD_dX=0.0;
modelStruct.modelPar_given_CSRHGATD=mod.given("CSRHGATD");
modelStruct.modelPar_XJUNSTID=mod.XJUNSTID;
modelStruct.d_modelPar_XJUNSTID_dX=0.0;
modelStruct.modelPar_given_XJUNSTID=mod.given("XJUNSTID");
modelStruct.modelPar_XJUNGATD=mod.XJUNGATD;
modelStruct.d_modelPar_XJUNGATD_dX=0.0;
modelStruct.modelPar_given_XJUNGATD=mod.given("XJUNGATD");
modelStruct.modelPar_CTATBOTD=mod.CTATBOTD;
modelStruct.d_modelPar_CTATBOTD_dX=0.0;
modelStruct.modelPar_given_CTATBOTD=mod.given("CTATBOTD");
modelStruct.modelPar_CTATSTID=mod.CTATSTID;
modelStruct.d_modelPar_CTATSTID_dX=0.0;
modelStruct.modelPar_given_CTATSTID=mod.given("CTATSTID");
modelStruct.modelPar_CTATGATD=mod.CTATGATD;
modelStruct.d_modelPar_CTATGATD_dX=0.0;
modelStruct.modelPar_given_CTATGATD=mod.given("CTATGATD");
modelStruct.modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
modelStruct.d_modelPar_MEFFTATBOTD_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
modelStruct.modelPar_MEFFTATSTID=mod.MEFFTATSTID;
modelStruct.d_modelPar_MEFFTATSTID_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
modelStruct.modelPar_MEFFTATGATD=mod.MEFFTATGATD;
modelStruct.d_modelPar_MEFFTATGATD_dX=0.0;
modelStruct.modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
modelStruct.modelPar_CBBTBOTD=mod.CBBTBOTD;
modelStruct.d_modelPar_CBBTBOTD_dX=0.0;
modelStruct.modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
modelStruct.modelPar_CBBTSTID=mod.CBBTSTID;
modelStruct.d_modelPar_CBBTSTID_dX=0.0;
modelStruct.modelPar_given_CBBTSTID=mod.given("CBBTSTID");
modelStruct.modelPar_CBBTGATD=mod.CBBTGATD;
modelStruct.d_modelPar_CBBTGATD_dX=0.0;
modelStruct.modelPar_given_CBBTGATD=mod.given("CBBTGATD");
modelStruct.modelPar_FBBTRBOTD=mod.FBBTRBOTD;
modelStruct.d_modelPar_FBBTRBOTD_dX=0.0;
modelStruct.modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
modelStruct.modelPar_FBBTRSTID=mod.FBBTRSTID;
modelStruct.d_modelPar_FBBTRSTID_dX=0.0;
modelStruct.modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
modelStruct.modelPar_FBBTRGATD=mod.FBBTRGATD;
modelStruct.d_modelPar_FBBTRGATD_dX=0.0;
modelStruct.modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
modelStruct.modelPar_STFBBTBOTD=mod.STFBBTBOTD;
modelStruct.d_modelPar_STFBBTBOTD_dX=0.0;
modelStruct.modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
modelStruct.modelPar_STFBBTSTID=mod.STFBBTSTID;
modelStruct.d_modelPar_STFBBTSTID_dX=0.0;
modelStruct.modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
modelStruct.modelPar_STFBBTGATD=mod.STFBBTGATD;
modelStruct.d_modelPar_STFBBTGATD_dX=0.0;
modelStruct.modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
modelStruct.modelPar_VBRBOTD=mod.VBRBOTD;
modelStruct.d_modelPar_VBRBOTD_dX=0.0;
modelStruct.modelPar_given_VBRBOTD=mod.given("VBRBOTD");
modelStruct.modelPar_VBRSTID=mod.VBRSTID;
modelStruct.d_modelPar_VBRSTID_dX=0.0;
modelStruct.modelPar_given_VBRSTID=mod.given("VBRSTID");
modelStruct.modelPar_VBRGATD=mod.VBRGATD;
modelStruct.d_modelPar_VBRGATD_dX=0.0;
modelStruct.modelPar_given_VBRGATD=mod.given("VBRGATD");
modelStruct.modelPar_PBRBOTD=mod.PBRBOTD;
modelStruct.d_modelPar_PBRBOTD_dX=0.0;
modelStruct.modelPar_given_PBRBOTD=mod.given("PBRBOTD");
modelStruct.modelPar_PBRSTID=mod.PBRSTID;
modelStruct.d_modelPar_PBRSTID_dX=0.0;
modelStruct.modelPar_given_PBRSTID=mod.given("PBRSTID");
modelStruct.modelPar_PBRGATD=mod.PBRGATD;
modelStruct.d_modelPar_PBRGATD_dX=0.0;
modelStruct.modelPar_given_PBRGATD=mod.given("PBRGATD");
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modelStruct.modelPar_VJUNREFD=mod.VJUNREFD;
modelStruct.d_modelPar_VJUNREFD_dX=0.0;
modelStruct.modelPar_given_VJUNREFD=mod.given("VJUNREFD");
modelStruct.modelPar_FJUNQD=mod.FJUNQD;
modelStruct.d_modelPar_FJUNQD_dX=0.0;
modelStruct.modelPar_given_FJUNQD=mod.given("FJUNQD");
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_LEVEL=mod.LEVEL;
modelStruct.modelPar_given_LEVEL=mod.given("LEVEL");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_SWGEO=mod.SWGEO;
modelStruct.modelPar_given_SWGEO=mod.given("SWGEO");
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modelStruct.modelPar_SWJUNCAP=mod.SWJUNCAP;
modelStruct.modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modelStruct.modelPar_SWNUD=mod.SWNUD;
modelStruct.modelPar_given_SWNUD=mod.given("SWNUD");
modelStruct.modelPar_SWEDGE=mod.SWEDGE;
modelStruct.modelPar_given_SWEDGE=mod.given("SWEDGE");
modelStruct.modelPar_SWDELVTAC=mod.SWDELVTAC;
modelStruct.modelPar_given_SWDELVTAC=mod.given("SWDELVTAC");
modelStruct.modelPar_SWIGN=mod.SWIGN;
modelStruct.modelPar_given_SWIGN=mod.given("SWIGN");



// Copy out all the instance parameters (doubles) into local struct
// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> inParamMap;
instanceSensStruct instanceStruct;
// reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
inParamMap["L"] = &(instanceStruct.d_instancePar_L_dX);
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
inParamMap["W"] = &(instanceStruct.d_instancePar_W_dX);
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
inParamMap["SA"] = &(instanceStruct.d_instancePar_SA_dX);
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
inParamMap["SB"] = &(instanceStruct.d_instancePar_SB_dX);
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
inParamMap["SD"] = &(instanceStruct.d_instancePar_SD_dX);
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.d_instancePar_SCA_dX=0.0;
instanceStruct.instancePar_given_SCA=in.given("SCA");
inParamMap["SCA"] = &(instanceStruct.d_instancePar_SCA_dX);
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.d_instancePar_SCB_dX=0.0;
instanceStruct.instancePar_given_SCB=in.given("SCB");
inParamMap["SCB"] = &(instanceStruct.d_instancePar_SCB_dX);
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.d_instancePar_SCC_dX=0.0;
instanceStruct.instancePar_given_SCC=in.given("SCC");
inParamMap["SCC"] = &(instanceStruct.d_instancePar_SCC_dX);
instanceStruct.instancePar_SC=in.SC;
instanceStruct.d_instancePar_SC_dX=0.0;
instanceStruct.instancePar_given_SC=in.given("SC");
inParamMap["SC"] = &(instanceStruct.d_instancePar_SC_dX);
instanceStruct.instancePar_NF=in.NF;
instanceStruct.d_instancePar_NF_dX=0.0;
instanceStruct.instancePar_given_NF=in.given("NF");
inParamMap["NF"] = &(instanceStruct.d_instancePar_NF_dX);
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.d_instancePar_NGCON_dX=0.0;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
inParamMap["NGCON"] = &(instanceStruct.d_instancePar_NGCON_dX);
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");
inParamMap["XGW"] = &(instanceStruct.d_instancePar_XGW_dX);
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
inParamMap["NRS"] = &(instanceStruct.d_instancePar_NRS_dX);
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
inParamMap["NRD"] = &(instanceStruct.d_instancePar_NRD_dX);
instanceStruct.instancePar_JW=in.JW;
instanceStruct.d_instancePar_JW_dX=0.0;
instanceStruct.instancePar_given_JW=in.given("JW");
inParamMap["JW"] = &(instanceStruct.d_instancePar_JW_dX);
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
inParamMap["DELVTO"] = &(instanceStruct.d_instancePar_DELVTO_dX);
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");
inParamMap["FACTUO"] = &(instanceStruct.d_instancePar_FACTUO_dX);
instanceStruct.instancePar_DELVTOEDGE=in.DELVTOEDGE;
instanceStruct.d_instancePar_DELVTOEDGE_dX=0.0;
instanceStruct.instancePar_given_DELVTOEDGE=in.given("DELVTOEDGE");
inParamMap["DELVTOEDGE"] = &(instanceStruct.d_instancePar_DELVTOEDGE_dX);
instanceStruct.instancePar_FACTUOEDGE=in.FACTUOEDGE;
instanceStruct.d_instancePar_FACTUOEDGE_dX=0.0;
instanceStruct.instancePar_given_FACTUOEDGE=in.given("FACTUOEDGE");
inParamMap["FACTUOEDGE"] = &(instanceStruct.d_instancePar_FACTUOEDGE_dX);
instanceStruct.instancePar_ABSOURCE=in.ABSOURCE;
instanceStruct.d_instancePar_ABSOURCE_dX=0.0;
instanceStruct.instancePar_given_ABSOURCE=in.given("ABSOURCE");
inParamMap["ABSOURCE"] = &(instanceStruct.d_instancePar_ABSOURCE_dX);
instanceStruct.instancePar_LSSOURCE=in.LSSOURCE;
instanceStruct.d_instancePar_LSSOURCE_dX=0.0;
instanceStruct.instancePar_given_LSSOURCE=in.given("LSSOURCE");
inParamMap["LSSOURCE"] = &(instanceStruct.d_instancePar_LSSOURCE_dX);
instanceStruct.instancePar_LGSOURCE=in.LGSOURCE;
instanceStruct.d_instancePar_LGSOURCE_dX=0.0;
instanceStruct.instancePar_given_LGSOURCE=in.given("LGSOURCE");
inParamMap["LGSOURCE"] = &(instanceStruct.d_instancePar_LGSOURCE_dX);
instanceStruct.instancePar_ABDRAIN=in.ABDRAIN;
instanceStruct.d_instancePar_ABDRAIN_dX=0.0;
instanceStruct.instancePar_given_ABDRAIN=in.given("ABDRAIN");
inParamMap["ABDRAIN"] = &(instanceStruct.d_instancePar_ABDRAIN_dX);
instanceStruct.instancePar_LSDRAIN=in.LSDRAIN;
instanceStruct.d_instancePar_LSDRAIN_dX=0.0;
instanceStruct.instancePar_given_LSDRAIN=in.given("LSDRAIN");
inParamMap["LSDRAIN"] = &(instanceStruct.d_instancePar_LSDRAIN_dX);
instanceStruct.instancePar_LGDRAIN=in.LGDRAIN;
instanceStruct.d_instancePar_LGDRAIN_dX=0.0;
instanceStruct.instancePar_given_LGDRAIN=in.given("LGDRAIN");
inParamMap["LGDRAIN"] = &(instanceStruct.d_instancePar_LGDRAIN_dX);
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
inParamMap["AS"] = &(instanceStruct.d_instancePar_AS_dX);
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
inParamMap["PS"] = &(instanceStruct.d_instancePar_PS_dX);
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
inParamMap["AD"] = &(instanceStruct.d_instancePar_AD_dX);
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
inParamMap["PD"] = &(instanceStruct.d_instancePar_PD_dX);
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");
inParamMap["MULT"] = &(instanceStruct.d_instancePar_MULT_dX);


// Copy all the real hidden instance params into local struct



// Copy all the non-real instance params into vars of their appropriate type:


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check the name first, otherwise segfault on invalid name!
*(inParamMap[name])=1.0;

//make local copies of all instance vars
//reals
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_TOX_i=in.TOX_i;
instanceStruct.d_instanceVar_TOX_i_dX=0.0;
instanceStruct.instanceVar_EPSROX_i=in.EPSROX_i;
instanceStruct.d_instanceVar_EPSROX_i_dX=0.0;
instanceStruct.instanceVar_NEFF_i=in.NEFF_i;
instanceStruct.d_instanceVar_NEFF_i_dX=0.0;
instanceStruct.instanceVar_FACNEFFAC_i=in.FACNEFFAC_i;
instanceStruct.d_instanceVar_FACNEFFAC_i_dX=0.0;
instanceStruct.instanceVar_GFACNUD_i=in.GFACNUD_i;
instanceStruct.d_instanceVar_GFACNUD_i_dX=0.0;
instanceStruct.instanceVar_VSBNUD_i=in.VSBNUD_i;
instanceStruct.d_instanceVar_VSBNUD_i_dX=0.0;
instanceStruct.instanceVar_DVSBNUD_i=in.DVSBNUD_i;
instanceStruct.d_instanceVar_DVSBNUD_i_dX=0.0;
instanceStruct.instanceVar_VNSUB_i=in.VNSUB_i;
instanceStruct.d_instanceVar_VNSUB_i_dX=0.0;
instanceStruct.instanceVar_NSLP_i=in.NSLP_i;
instanceStruct.d_instanceVar_NSLP_i_dX=0.0;
instanceStruct.instanceVar_DNSUB_i=in.DNSUB_i;
instanceStruct.d_instanceVar_DNSUB_i_dX=0.0;
instanceStruct.instanceVar_DPHIB_i=in.DPHIB_i;
instanceStruct.d_instanceVar_DPHIB_i_dX=0.0;
instanceStruct.instanceVar_DELVTAC_i=in.DELVTAC_i;
instanceStruct.d_instanceVar_DELVTAC_i_dX=0.0;
instanceStruct.instanceVar_NP_i=in.NP_i;
instanceStruct.d_instanceVar_NP_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_TOXOV_i=in.TOXOV_i;
instanceStruct.d_instanceVar_TOXOV_i_dX=0.0;
instanceStruct.instanceVar_TOXOVD_i=in.TOXOVD_i;
instanceStruct.d_instanceVar_TOXOVD_i_dX=0.0;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CFD_i=in.CFD_i;
instanceStruct.d_instanceVar_CFD_i_dX=0.0;
instanceStruct.instanceVar_CFB_i=in.CFB_i;
instanceStruct.d_instanceVar_CFB_i_dX=0.0;
instanceStruct.instanceVar_PSCE_i=in.PSCE_i;
instanceStruct.d_instanceVar_PSCE_i_dX=0.0;
instanceStruct.instanceVar_PSCEB_i=in.PSCEB_i;
instanceStruct.d_instanceVar_PSCEB_i_dX=0.0;
instanceStruct.instanceVar_PSCED_i=in.PSCED_i;
instanceStruct.d_instanceVar_PSCED_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_FETA_i=in.FETA_i;
instanceStruct.d_instanceVar_FETA_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_THESATB_i=in.THESATB_i;
instanceStruct.d_instanceVar_THESATB_i_dX=0.0;
instanceStruct.instanceVar_THESATG_i=in.THESATG_i;
instanceStruct.d_instanceVar_THESATG_i_dX=0.0;
instanceStruct.instanceVar_AX_i=in.AX_i;
instanceStruct.d_instanceVar_AX_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALP2_i=in.ALP2_i;
instanceStruct.d_instanceVar_ALP2_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_A4_i=in.A4_i;
instanceStruct.d_instanceVar_A4_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOV_i=in.IGOV_i;
instanceStruct.d_instanceVar_IGOV_i_dX=0.0;
instanceStruct.instanceVar_IGOVD_i=in.IGOVD_i;
instanceStruct.d_instanceVar_IGOVD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_GC2_i=in.GC2_i;
instanceStruct.d_instanceVar_GC2_i_dX=0.0;
instanceStruct.instanceVar_GC3_i=in.GC3_i;
instanceStruct.d_instanceVar_GC3_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_COX_i=in.COX_i;
instanceStruct.d_instanceVar_COX_i_dX=0.0;
instanceStruct.instanceVar_CGOV_i=in.CGOV_i;
instanceStruct.d_instanceVar_CGOV_i_dX=0.0;
instanceStruct.instanceVar_CGOVD_i=in.CGOVD_i;
instanceStruct.d_instanceVar_CGOVD_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_STVFBEDGE_i=in.STVFBEDGE_i;
instanceStruct.d_instanceVar_STVFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_DPHIBEDGE_i=in.DPHIBEDGE_i;
instanceStruct.d_instanceVar_DPHIBEDGE_i_dX=0.0;
instanceStruct.instanceVar_NEFFEDGE_i=in.NEFFEDGE_i;
instanceStruct.d_instanceVar_NEFFEDGE_i_dX=0.0;
instanceStruct.instanceVar_CTEDGE_i=in.CTEDGE_i;
instanceStruct.d_instanceVar_CTEDGE_i_dX=0.0;
instanceStruct.instanceVar_BETNEDGE_i=in.BETNEDGE_i;
instanceStruct.d_instanceVar_BETNEDGE_i_dX=0.0;
instanceStruct.instanceVar_STBETEDGE_i=in.STBETEDGE_i;
instanceStruct.d_instanceVar_STBETEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEEDGE_i=in.PSCEEDGE_i;
instanceStruct.d_instanceVar_PSCEEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEBEDGE_i=in.PSCEBEDGE_i;
instanceStruct.d_instanceVar_PSCEBEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEDEDGE_i=in.PSCEDEDGE_i;
instanceStruct.d_instanceVar_PSCEDEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFEDGE_i=in.CFEDGE_i;
instanceStruct.d_instanceVar_CFEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFDEDGE_i=in.CFDEDGE_i;
instanceStruct.d_instanceVar_CFDEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFBEDGE_i=in.CFBEDGE_i;
instanceStruct.d_instanceVar_CFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_FNTEDGE_i=in.FNTEDGE_i;
instanceStruct.d_instanceVar_FNTEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFAEDGE_i=in.NFAEDGE_i;
instanceStruct.d_instanceVar_NFAEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFBEDGE_i=in.NFBEDGE_i;
instanceStruct.d_instanceVar_NFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFCEDGE_i=in.NFCEDGE_i;
instanceStruct.d_instanceVar_NFCEDGE_i_dX=0.0;
instanceStruct.instanceVar_EFEDGE_i=in.EFEDGE_i;
instanceStruct.d_instanceVar_EFEDGE_i_dX=0.0;
instanceStruct.instanceVar_RG_i=in.RG_i;
instanceStruct.d_instanceVar_RG_i_dX=0.0;
instanceStruct.instanceVar_RSE_i=in.RSE_i;
instanceStruct.d_instanceVar_RSE_i_dX=0.0;
instanceStruct.instanceVar_RDE_i=in.RDE_i;
instanceStruct.d_instanceVar_RDE_i_dX=0.0;
instanceStruct.instanceVar_RBULK_i=in.RBULK_i;
instanceStruct.d_instanceVar_RBULK_i_dX=0.0;
instanceStruct.instanceVar_RJUNS_i=in.RJUNS_i;
instanceStruct.d_instanceVar_RJUNS_i_dX=0.0;
instanceStruct.instanceVar_RJUND_i=in.RJUND_i;
instanceStruct.d_instanceVar_RJUND_i_dX=0.0;
instanceStruct.instanceVar_RWELL_i=in.RWELL_i;
instanceStruct.d_instanceVar_RWELL_i_dX=0.0;
instanceStruct.instanceVar_LE=in.LE;
instanceStruct.d_instanceVar_LE_dX=0.0;
instanceStruct.instanceVar_WE=in.WE;
instanceStruct.d_instanceVar_WE_dX=0.0;
instanceStruct.instanceVar_ABSOURCE_i=in.ABSOURCE_i;
instanceStruct.d_instanceVar_ABSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LSSOURCE_i=in.LSSOURCE_i;
instanceStruct.d_instanceVar_LSSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LGSOURCE_i=in.LGSOURCE_i;
instanceStruct.d_instanceVar_LGSOURCE_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_s=in.zflagbot_s;
instanceStruct.instanceVar_zflagsti_s=in.zflagsti_s;
instanceStruct.instanceVar_zflaggat_s=in.zflaggat_s;
instanceStruct.instanceVar_VMAX_s=in.VMAX_s;
instanceStruct.d_instanceVar_VMAX_s_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX=0.0;
instanceStruct.instanceVar_vbimin_s=in.vbimin_s;
instanceStruct.d_instanceVar_vbimin_s_dX=0.0;
instanceStruct.instanceVar_vch_s=in.vch_s;
instanceStruct.d_instanceVar_vch_s_dX=0.0;
instanceStruct.instanceVar_vfmin_s=in.vfmin_s;
instanceStruct.d_instanceVar_vfmin_s_dX=0.0;
instanceStruct.instanceVar_vbbtlim_s=in.vbbtlim_s;
instanceStruct.d_instanceVar_vbbtlim_s_dX=0.0;
instanceStruct.instanceVar_xhighf1_s=in.xhighf1_s;
instanceStruct.d_instanceVar_xhighf1_s_dX=0.0;
instanceStruct.instanceVar_expxhf1_s=in.expxhf1_s;
instanceStruct.d_instanceVar_expxhf1_s_dX=0.0;
instanceStruct.instanceVar_xhighf2_s=in.xhighf2_s;
instanceStruct.d_instanceVar_xhighf2_s_dX=0.0;
instanceStruct.instanceVar_expxhf2_s=in.expxhf2_s;
instanceStruct.d_instanceVar_expxhf2_s_dX=0.0;
instanceStruct.instanceVar_xhighr_s=in.xhighr_s;
instanceStruct.d_instanceVar_xhighr_s_dX=0.0;
instanceStruct.instanceVar_expxhr_s=in.expxhr_s;
instanceStruct.d_instanceVar_expxhr_s_dX=0.0;
instanceStruct.instanceVar_m0flag_s=in.m0flag_s;
instanceStruct.instanceVar_ISATFOR1_s=in.ISATFOR1_s;
instanceStruct.d_instanceVar_ISATFOR1_s_dX=0.0;
instanceStruct.instanceVar_MFOR1_s=in.MFOR1_s;
instanceStruct.instanceVar_ISATFOR2_s=in.ISATFOR2_s;
instanceStruct.d_instanceVar_ISATFOR2_s_dX=0.0;
instanceStruct.instanceVar_MFOR2_s=in.MFOR2_s;
instanceStruct.d_instanceVar_MFOR2_s_dX=0.0;
instanceStruct.instanceVar_ISATREV_s=in.ISATREV_s;
instanceStruct.d_instanceVar_ISATREV_s_dX=0.0;
instanceStruct.instanceVar_MREV_s=in.MREV_s;
instanceStruct.d_instanceVar_MREV_s_dX=0.0;
instanceStruct.instanceVar_ABDRAIN_i=in.ABDRAIN_i;
instanceStruct.d_instanceVar_ABDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LSDRAIN_i=in.LSDRAIN_i;
instanceStruct.d_instanceVar_LSDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LGDRAIN_i=in.LGDRAIN_i;
instanceStruct.d_instanceVar_LGDRAIN_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_d=in.zflagbot_d;
instanceStruct.instanceVar_zflagsti_d=in.zflagsti_d;
instanceStruct.instanceVar_zflaggat_d=in.zflaggat_d;
instanceStruct.instanceVar_VMAX_d=in.VMAX_d;
instanceStruct.d_instanceVar_VMAX_d_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX=0.0;
instanceStruct.instanceVar_vbimin_d=in.vbimin_d;
instanceStruct.d_instanceVar_vbimin_d_dX=0.0;
instanceStruct.instanceVar_vch_d=in.vch_d;
instanceStruct.d_instanceVar_vch_d_dX=0.0;
instanceStruct.instanceVar_vfmin_d=in.vfmin_d;
instanceStruct.d_instanceVar_vfmin_d_dX=0.0;
instanceStruct.instanceVar_vbbtlim_d=in.vbbtlim_d;
instanceStruct.d_instanceVar_vbbtlim_d_dX=0.0;
instanceStruct.instanceVar_xhighf1_d=in.xhighf1_d;
instanceStruct.d_instanceVar_xhighf1_d_dX=0.0;
instanceStruct.instanceVar_expxhf1_d=in.expxhf1_d;
instanceStruct.d_instanceVar_expxhf1_d_dX=0.0;
instanceStruct.instanceVar_xhighf2_d=in.xhighf2_d;
instanceStruct.d_instanceVar_xhighf2_d_dX=0.0;
instanceStruct.instanceVar_expxhf2_d=in.expxhf2_d;
instanceStruct.d_instanceVar_expxhf2_d_dX=0.0;
instanceStruct.instanceVar_xhighr_d=in.xhighr_d;
instanceStruct.d_instanceVar_xhighr_d_dX=0.0;
instanceStruct.instanceVar_expxhr_d=in.expxhr_d;
instanceStruct.d_instanceVar_expxhr_d_dX=0.0;
instanceStruct.instanceVar_m0flag_d=in.m0flag_d;
instanceStruct.instanceVar_ISATFOR1_d=in.ISATFOR1_d;
instanceStruct.d_instanceVar_ISATFOR1_d_dX=0.0;
instanceStruct.instanceVar_MFOR1_d=in.MFOR1_d;
instanceStruct.instanceVar_ISATFOR2_d=in.ISATFOR2_d;
instanceStruct.d_instanceVar_ISATFOR2_d_dX=0.0;
instanceStruct.instanceVar_MFOR2_d=in.MFOR2_d;
instanceStruct.d_instanceVar_MFOR2_d_dX=0.0;
instanceStruct.instanceVar_ISATREV_d=in.ISATREV_d;
instanceStruct.d_instanceVar_ISATREV_d_dX=0.0;
instanceStruct.instanceVar_MREV_d=in.MREV_d;
instanceStruct.d_instanceVar_MREV_d_dX=0.0;
instanceStruct.instanceVar_VFB_T=in.VFB_T;
instanceStruct.d_instanceVar_VFB_T_dX=0.0;
instanceStruct.instanceVar_BETN_T=in.BETN_T;
instanceStruct.d_instanceVar_BETN_T_dX=0.0;
instanceStruct.instanceVar_MUE_T=in.MUE_T;
instanceStruct.d_instanceVar_MUE_T_dX=0.0;
instanceStruct.instanceVar_THEMU_T=in.THEMU_T;
instanceStruct.d_instanceVar_THEMU_T_dX=0.0;
instanceStruct.instanceVar_CS_T=in.CS_T;
instanceStruct.d_instanceVar_CS_T_dX=0.0;
instanceStruct.instanceVar_XCOR_T=in.XCOR_T;
instanceStruct.d_instanceVar_XCOR_T_dX=0.0;
instanceStruct.instanceVar_RS_T=in.RS_T;
instanceStruct.d_instanceVar_RS_T_dX=0.0;
instanceStruct.instanceVar_BGIDL_T=in.BGIDL_T;
instanceStruct.d_instanceVar_BGIDL_T_dX=0.0;
instanceStruct.instanceVar_BGIDLD_T=in.BGIDLD_T;
instanceStruct.d_instanceVar_BGIDLD_T_dX=0.0;
instanceStruct.instanceVar_A2_T=in.A2_T;
instanceStruct.d_instanceVar_A2_T_dX=0.0;
instanceStruct.instanceVar_VFBEDGE_T=in.VFBEDGE_T;
instanceStruct.d_instanceVar_VFBEDGE_T_dX=0.0;
instanceStruct.instanceVar_BETNEDGE_T=in.BETNEDGE_T;
instanceStruct.d_instanceVar_BETNEDGE_T_dX=0.0;
instanceStruct.instanceVar_phit0=in.phit0;
instanceStruct.d_instanceVar_phit0_dX=0.0;
instanceStruct.instanceVar_BET_i=in.BET_i;
instanceStruct.d_instanceVar_BET_i_dX=0.0;
instanceStruct.instanceVar_BETEDGE_i=in.BETEDGE_i;
instanceStruct.d_instanceVar_BETEDGE_i_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_THESAT_T=in.THESAT_T;
instanceStruct.d_instanceVar_THESAT_T_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac=in.Sfl_prefac;
instanceStruct.d_instanceVar_Sfl_prefac_dX=0.0;
instanceStruct.instanceVar_phit0edge=in.phit0edge;
instanceStruct.d_instanceVar_phit0edge_dX=0.0;
instanceStruct.instanceVar_Gfedge2=in.Gfedge2;
instanceStruct.d_instanceVar_Gfedge2_dX=0.0;
instanceStruct.instanceVar_lnGfedge2=in.lnGfedge2;
instanceStruct.d_instanceVar_lnGfedge2_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac_edge=in.Sfl_prefac_edge;
instanceStruct.d_instanceVar_Sfl_prefac_edge_dX=0.0;
instanceStruct.instanceVar_ntedge=in.ntedge;
instanceStruct.d_instanceVar_ntedge_dX=0.0;
instanceStruct.instanceVar_phib_dc=in.phib_dc;
instanceStruct.d_instanceVar_phib_dc_dX=0.0;
instanceStruct.instanceVar_G_0_dc=in.G_0_dc;
instanceStruct.d_instanceVar_G_0_dc_dX=0.0;
instanceStruct.instanceVar_kp=in.kp;
instanceStruct.d_instanceVar_kp_dX=0.0;
instanceStruct.instanceVar_qlim2=in.qlim2;
instanceStruct.d_instanceVar_qlim2_dX=0.0;
instanceStruct.instanceVar_sqrt_phib_dc=in.sqrt_phib_dc;
instanceStruct.d_instanceVar_sqrt_phib_dc_dX=0.0;
instanceStruct.instanceVar_phix_dc=in.phix_dc;
instanceStruct.d_instanceVar_phix_dc_dX=0.0;
instanceStruct.instanceVar_aphi_dc=in.aphi_dc;
instanceStruct.d_instanceVar_aphi_dc_dX=0.0;
instanceStruct.instanceVar_bphi_dc=in.bphi_dc;
instanceStruct.d_instanceVar_bphi_dc_dX=0.0;
instanceStruct.instanceVar_phix1_dc=in.phix1_dc;
instanceStruct.d_instanceVar_phix1_dc_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_us1=in.us1;
instanceStruct.d_instanceVar_us1_dX=0.0;
instanceStruct.instanceVar_us21=in.us21;
instanceStruct.d_instanceVar_us21_dX=0.0;
instanceStruct.instanceVar_phib_ac=in.phib_ac;
instanceStruct.d_instanceVar_phib_ac_dX=0.0;
instanceStruct.instanceVar_G_0_ac=in.G_0_ac;
instanceStruct.d_instanceVar_G_0_ac_dX=0.0;
instanceStruct.instanceVar_phix_ac=in.phix_ac;
instanceStruct.d_instanceVar_phix_ac_dX=0.0;
instanceStruct.instanceVar_aphi_ac=in.aphi_ac;
instanceStruct.d_instanceVar_aphi_ac_dX=0.0;
instanceStruct.instanceVar_bphi_ac=in.bphi_ac;
instanceStruct.d_instanceVar_bphi_ac_dX=0.0;
instanceStruct.instanceVar_phix1_ac=in.phix1_ac;
instanceStruct.d_instanceVar_phix1_ac_dX=0.0;
instanceStruct.instanceVar_THER_i=in.THER_i;
instanceStruct.d_instanceVar_THER_i_dX=0.0;
instanceStruct.instanceVar_phibedge=in.phibedge;
instanceStruct.d_instanceVar_phibedge_dX=0.0;
instanceStruct.instanceVar_Gfedge=in.Gfedge;
instanceStruct.d_instanceVar_Gfedge_dX=0.0;
instanceStruct.instanceVar_phixedge=in.phixedge;
instanceStruct.d_instanceVar_phixedge_dX=0.0;
instanceStruct.instanceVar_aphiedge=in.aphiedge;
instanceStruct.d_instanceVar_aphiedge_dX=0.0;
instanceStruct.instanceVar_bphiedge=in.bphiedge;
instanceStruct.d_instanceVar_bphiedge_dX=0.0;
instanceStruct.instanceVar_phix1edge=in.phix1edge;
instanceStruct.d_instanceVar_phix1edge_dX=0.0;
instanceStruct.instanceVar_Cox_over_q=in.Cox_over_q;
instanceStruct.d_instanceVar_Cox_over_q_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_E_eff0=in.E_eff0;
instanceStruct.d_instanceVar_E_eff0_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_eta_mu1=in.eta_mu1;
instanceStruct.instanceVar_inv_AX=in.inv_AX;
instanceStruct.d_instanceVar_inv_AX_dX=0.0;
instanceStruct.instanceVar_inv_VP=in.inv_VP;
instanceStruct.d_instanceVar_inv_VP_dX=0.0;
instanceStruct.instanceVar_GOV_s=in.GOV_s;
instanceStruct.d_instanceVar_GOV_s_dX=0.0;
instanceStruct.instanceVar_GOV_d=in.GOV_d;
instanceStruct.d_instanceVar_GOV_d_dX=0.0;
instanceStruct.instanceVar_GOV2_s=in.GOV2_s;
instanceStruct.d_instanceVar_GOV2_s_dX=0.0;
instanceStruct.instanceVar_GOV2_d=in.GOV2_d;
instanceStruct.d_instanceVar_GOV2_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_eps2_s=in.SP_OV_eps2_s;
instanceStruct.d_instanceVar_SP_OV_eps2_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_a_s=in.SP_OV_a_s;
instanceStruct.d_instanceVar_SP_OV_a_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_delta1_s=in.SP_OV_delta1_s;
instanceStruct.d_instanceVar_SP_OV_delta1_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_eps2_d=in.SP_OV_eps2_d;
instanceStruct.d_instanceVar_SP_OV_eps2_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_a_d=in.SP_OV_a_d;
instanceStruct.d_instanceVar_SP_OV_a_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_delta1_d=in.SP_OV_delta1_d;
instanceStruct.d_instanceVar_SP_OV_delta1_d_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_BOV_d=in.BOV_d;
instanceStruct.d_instanceVar_BOV_d_dX=0.0;
instanceStruct.instanceVar_GCQ=in.GCQ;
instanceStruct.d_instanceVar_GCQ_dX=0.0;
instanceStruct.instanceVar_AGIDLs=in.AGIDLs;
instanceStruct.d_instanceVar_AGIDLs_dX=0.0;
instanceStruct.instanceVar_AGIDLDs=in.AGIDLDs;
instanceStruct.d_instanceVar_AGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDLs=in.BGIDLs;
instanceStruct.d_instanceVar_BGIDLs_dX=0.0;
instanceStruct.instanceVar_BGIDLDs=in.BGIDLDs;
instanceStruct.d_instanceVar_BGIDLDs_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_ggate=in.ggate;
instanceStruct.d_instanceVar_ggate_dX=0.0;
instanceStruct.instanceVar_gsource=in.gsource;
instanceStruct.d_instanceVar_gsource_dX=0.0;
instanceStruct.instanceVar_gdrain=in.gdrain;
instanceStruct.d_instanceVar_gdrain_dX=0.0;
instanceStruct.instanceVar_gbulk=in.gbulk;
instanceStruct.d_instanceVar_gbulk_dX=0.0;
instanceStruct.instanceVar_gjuns=in.gjuns;
instanceStruct.d_instanceVar_gjuns_dX=0.0;
instanceStruct.instanceVar_gjund=in.gjund;
instanceStruct.d_instanceVar_gjund_dX=0.0;
instanceStruct.instanceVar_gwell=in.gwell;
instanceStruct.d_instanceVar_gwell_dX=0.0;
instanceStruct.instanceVar_Sfl=in.Sfl;
instanceStruct.d_instanceVar_Sfl_dX=0.0;
instanceStruct.instanceVar_sqid=in.sqid;
instanceStruct.d_instanceVar_sqid_dX=0.0;
instanceStruct.instanceVar_mig=in.mig;
instanceStruct.d_instanceVar_mig_dX=0.0;
instanceStruct.instanceVar_CGeff=in.CGeff;
instanceStruct.d_instanceVar_CGeff_dX=0.0;
instanceStruct.instanceVar_c_igid=in.c_igid;
instanceStruct.d_instanceVar_c_igid_dX=0.0;
instanceStruct.instanceVar_shot_igcsx=in.shot_igcsx;
instanceStruct.d_instanceVar_shot_igcsx_dX=0.0;
instanceStruct.instanceVar_shot_igcdx=in.shot_igcdx;
instanceStruct.d_instanceVar_shot_igcdx_dX=0.0;
instanceStruct.instanceVar_shot_igsov=in.shot_igsov;
instanceStruct.d_instanceVar_shot_igsov_dX=0.0;
instanceStruct.instanceVar_shot_igdov=in.shot_igdov;
instanceStruct.d_instanceVar_shot_igdov_dX=0.0;
instanceStruct.instanceVar_shot_iavl=in.shot_iavl;
instanceStruct.d_instanceVar_shot_iavl_dX=0.0;
instanceStruct.instanceVar_jnoisex_s=in.jnoisex_s;
instanceStruct.d_instanceVar_jnoisex_s_dX=0.0;
instanceStruct.instanceVar_jnoisex_d=in.jnoisex_d;
instanceStruct.d_instanceVar_jnoisex_d_dX=0.0;


//non-reals


//make local copies of all model vars
//reals
modelStruct.modelVar_TOXO_i=mod.TOXO_i;
modelStruct.d_modelVar_TOXO_i_dX=0.0;
modelStruct.modelVar_EPSROXO_i=mod.EPSROXO_i;
modelStruct.d_modelVar_EPSROXO_i_dX=0.0;
modelStruct.modelVar_NSUBO_i=mod.NSUBO_i;
modelStruct.d_modelVar_NSUBO_i_dX=0.0;
modelStruct.modelVar_WSEG_i=mod.WSEG_i;
modelStruct.d_modelVar_WSEG_i_dX=0.0;
modelStruct.modelVar_NPCK_i=mod.NPCK_i;
modelStruct.d_modelVar_NPCK_i_dX=0.0;
modelStruct.modelVar_WSEGP_i=mod.WSEGP_i;
modelStruct.d_modelVar_WSEGP_i_dX=0.0;
modelStruct.modelVar_LPCK_i=mod.LPCK_i;
modelStruct.d_modelVar_LPCK_i_dX=0.0;
modelStruct.modelVar_TOXOVO_i=mod.TOXOVO_i;
modelStruct.d_modelVar_TOXOVO_i_dX=0.0;
modelStruct.modelVar_TOXOVDO_i=mod.TOXOVDO_i;
modelStruct.d_modelVar_TOXOVDO_i_dX=0.0;
modelStruct.modelVar_LOV_i=mod.LOV_i;
modelStruct.d_modelVar_LOV_i_dX=0.0;
modelStruct.modelVar_LOVD_i=mod.LOVD_i;
modelStruct.d_modelVar_LOVD_i_dX=0.0;
modelStruct.modelVar_LP1_i=mod.LP1_i;
modelStruct.d_modelVar_LP1_i_dX=0.0;
modelStruct.modelVar_LP2_i=mod.LP2_i;
modelStruct.d_modelVar_LP2_i_dX=0.0;
modelStruct.modelVar_WBET_i=mod.WBET_i;
modelStruct.d_modelVar_WBET_i_dX=0.0;
modelStruct.modelVar_AXL_i=mod.AXL_i;
modelStruct.d_modelVar_AXL_i_dX=0.0;
modelStruct.modelVar_ALP1L2_i=mod.ALP1L2_i;
modelStruct.d_modelVar_ALP1L2_i_dX=0.0;
modelStruct.modelVar_ALP2L2_i=mod.ALP2L2_i;
modelStruct.d_modelVar_ALP2L2_i_dX=0.0;
modelStruct.modelVar_SAREF_i=mod.SAREF_i;
modelStruct.d_modelVar_SAREF_i_dX=0.0;
modelStruct.modelVar_SBREF_i=mod.SBREF_i;
modelStruct.d_modelVar_SBREF_i_dX=0.0;
modelStruct.modelVar_KVSAT_i=mod.KVSAT_i;
modelStruct.d_modelVar_KVSAT_i_dX=0.0;
modelStruct.modelVar_LLODKUO_i=mod.LLODKUO_i;
modelStruct.d_modelVar_LLODKUO_i_dX=0.0;
modelStruct.modelVar_WLODKUO_i=mod.WLODKUO_i;
modelStruct.d_modelVar_WLODKUO_i_dX=0.0;
modelStruct.modelVar_LLODVTH_i=mod.LLODVTH_i;
modelStruct.d_modelVar_LLODVTH_i_dX=0.0;
modelStruct.modelVar_WLODVTH_i=mod.WLODVTH_i;
modelStruct.d_modelVar_WLODVTH_i_dX=0.0;
modelStruct.modelVar_LODETAO_i=mod.LODETAO_i;
modelStruct.d_modelVar_LODETAO_i_dX=0.0;
modelStruct.modelVar_SCREF_i=mod.SCREF_i;
modelStruct.d_modelVar_SCREF_i_dX=0.0;
modelStruct.modelVar_WEB_i=mod.WEB_i;
modelStruct.d_modelVar_WEB_i_dX=0.0;
modelStruct.modelVar_WEC_i=mod.WEC_i;
modelStruct.d_modelVar_WEC_i_dX=0.0;
modelStruct.modelVar_RSHG_i=mod.RSHG_i;
modelStruct.d_modelVar_RSHG_i_dX=0.0;
modelStruct.modelVar_RSH_i=mod.RSH_i;
modelStruct.d_modelVar_RSH_i_dX=0.0;
modelStruct.modelVar_RSHD_i=mod.RSHD_i;
modelStruct.d_modelVar_RSHD_i_dX=0.0;
modelStruct.modelVar_RINT_i=mod.RINT_i;
modelStruct.d_modelVar_RINT_i_dX=0.0;
modelStruct.modelVar_RVPOLY_i=mod.RVPOLY_i;
modelStruct.d_modelVar_RVPOLY_i_dX=0.0;
modelStruct.modelVar_NSUBEDGEO_i=mod.NSUBEDGEO_i;
modelStruct.d_modelVar_NSUBEDGEO_i_dX=0.0;
modelStruct.modelVar_LPEDGE_i=mod.LPEDGE_i;
modelStruct.d_modelVar_LPEDGE_i_dX=0.0;
modelStruct.modelVar_QMC_i=mod.QMC_i;
modelStruct.d_modelVar_QMC_i_dX=0.0;
modelStruct.modelVar_rTa=mod.rTa;
modelStruct.d_modelVar_rTa_dX=0.0;
modelStruct.modelVar_delTa=mod.delTa;
modelStruct.d_modelVar_delTa_dX=0.0;
modelStruct.modelVar_phita=mod.phita;
modelStruct.d_modelVar_phita_dX=0.0;
modelStruct.modelVar_inv_phita=mod.inv_phita;
modelStruct.d_modelVar_inv_phita_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.d_modelVar_TKD_dX=0.0;
modelStruct.modelVar_delT=mod.delT;
modelStruct.d_modelVar_delT_dX=0.0;
modelStruct.modelVar_rTn=mod.rTn;
modelStruct.d_modelVar_rTn_dX=0.0;
modelStruct.modelVar_ln_rTn=mod.ln_rTn;
modelStruct.d_modelVar_ln_rTn_dX=0.0;
modelStruct.modelVar_inv_phit=mod.inv_phit;
modelStruct.d_modelVar_inv_phit_dX=0.0;
modelStruct.modelVar_Eg=mod.Eg;
modelStruct.d_modelVar_Eg_dX=0.0;
modelStruct.modelVar_phibFac=mod.phibFac;
modelStruct.d_modelVar_phibFac_dX=0.0;
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_alphaav=mod.alphaav;
modelStruct.d_modelVar_alphaav_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX=0.0;
modelStruct.modelVar_VBIRSTID_i=mod.VBIRSTID_i;
modelStruct.d_modelVar_VBIRSTID_i_dX=0.0;
modelStruct.modelVar_VBIRGATD_i=mod.VBIRGATD_i;
modelStruct.d_modelVar_VBIRGATD_i_dX=0.0;
modelStruct.modelVar_PBOTD_i=mod.PBOTD_i;
modelStruct.d_modelVar_PBOTD_i_dX=0.0;
modelStruct.modelVar_PSTID_i=mod.PSTID_i;
modelStruct.d_modelVar_PSTID_i_dX=0.0;
modelStruct.modelVar_PGATD_i=mod.PGATD_i;
modelStruct.d_modelVar_PGATD_i_dX=0.0;
modelStruct.modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX=0.0;
modelStruct.modelVar_CSRHSTID_i=mod.CSRHSTID_i;
modelStruct.d_modelVar_CSRHSTID_i_dX=0.0;
modelStruct.modelVar_CSRHGATD_i=mod.CSRHGATD_i;
modelStruct.d_modelVar_CSRHGATD_i_dX=0.0;
modelStruct.modelVar_CTATBOTD_i=mod.CTATBOTD_i;
modelStruct.d_modelVar_CTATBOTD_i_dX=0.0;
modelStruct.modelVar_CTATSTID_i=mod.CTATSTID_i;
modelStruct.d_modelVar_CTATSTID_i_dX=0.0;
modelStruct.modelVar_CTATGATD_i=mod.CTATGATD_i;
modelStruct.d_modelVar_CTATGATD_i_dX=0.0;
modelStruct.modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX=0.0;
modelStruct.modelVar_CBBTSTID_i=mod.CBBTSTID_i;
modelStruct.d_modelVar_CBBTSTID_i_dX=0.0;
modelStruct.modelVar_CBBTGATD_i=mod.CBBTGATD_i;
modelStruct.d_modelVar_CBBTGATD_i_dX=0.0;
modelStruct.modelVar_VBRBOTD_i=mod.VBRBOTD_i;
modelStruct.d_modelVar_VBRBOTD_i_dX=0.0;
modelStruct.modelVar_VBRSTID_i=mod.VBRSTID_i;
modelStruct.d_modelVar_VBRSTID_i_dX=0.0;
modelStruct.modelVar_VBRGATD_i=mod.VBRGATD_i;
modelStruct.d_modelVar_VBRGATD_i_dX=0.0;
modelStruct.modelVar_PBRBOTD_i=mod.PBRBOTD_i;
modelStruct.d_modelVar_PBRBOTD_i_dX=0.0;
modelStruct.modelVar_PBRSTID_i=mod.PBRSTID_i;
modelStruct.d_modelVar_PBRSTID_i_dX=0.0;
modelStruct.modelVar_PBRGATD_i=mod.PBRGATD_i;
modelStruct.d_modelVar_PBRGATD_i_dX=0.0;
modelStruct.modelVar_VJUNREFD_i=mod.VJUNREFD_i;
modelStruct.d_modelVar_VJUNREFD_i_dX=0.0;
modelStruct.modelVar_FJUNQD_i=mod.FJUNQD_i;
modelStruct.d_modelVar_FJUNQD_i_dX=0.0;
modelStruct.modelVar_ftdbot_d=mod.ftdbot_d;
modelStruct.d_modelVar_ftdbot_d_dX=0.0;
modelStruct.modelVar_ftdsti_d=mod.ftdsti_d;
modelStruct.d_modelVar_ftdsti_d_dX=0.0;
modelStruct.modelVar_ftdgat_d=mod.ftdgat_d;
modelStruct.d_modelVar_ftdgat_d_dX=0.0;
modelStruct.modelVar_idsatbot_d=mod.idsatbot_d;
modelStruct.d_modelVar_idsatbot_d_dX=0.0;
modelStruct.modelVar_idsatsti_d=mod.idsatsti_d;
modelStruct.d_modelVar_idsatsti_d_dX=0.0;
modelStruct.modelVar_idsatgat_d=mod.idsatgat_d;
modelStruct.d_modelVar_idsatgat_d_dX=0.0;
modelStruct.modelVar_vbibot_d=mod.vbibot_d;
modelStruct.d_modelVar_vbibot_d_dX=0.0;
modelStruct.modelVar_vbisti_d=mod.vbisti_d;
modelStruct.d_modelVar_vbisti_d_dX=0.0;
modelStruct.modelVar_vbigat_d=mod.vbigat_d;
modelStruct.d_modelVar_vbigat_d_dX=0.0;
modelStruct.modelVar_vbiinvbot_d=mod.vbiinvbot_d;
modelStruct.d_modelVar_vbiinvbot_d_dX=0.0;
modelStruct.modelVar_vbiinvsti_d=mod.vbiinvsti_d;
modelStruct.d_modelVar_vbiinvsti_d_dX=0.0;
modelStruct.modelVar_vbiinvgat_d=mod.vbiinvgat_d;
modelStruct.d_modelVar_vbiinvgat_d_dX=0.0;
modelStruct.modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
modelStruct.d_modelVar_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
modelStruct.d_modelVar_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
modelStruct.d_modelVar_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_cjobot_d=mod.cjobot_d;
modelStruct.d_modelVar_cjobot_d_dX=0.0;
modelStruct.modelVar_cjosti_d=mod.cjosti_d;
modelStruct.d_modelVar_cjosti_d_dX=0.0;
modelStruct.modelVar_cjogat_d=mod.cjogat_d;
modelStruct.d_modelVar_cjogat_d_dX=0.0;
modelStruct.modelVar_qprefbot_d=mod.qprefbot_d;
modelStruct.d_modelVar_qprefbot_d_dX=0.0;
modelStruct.modelVar_qprefsti_d=mod.qprefsti_d;
modelStruct.d_modelVar_qprefsti_d_dX=0.0;
modelStruct.modelVar_qprefgat_d=mod.qprefgat_d;
modelStruct.d_modelVar_qprefgat_d_dX=0.0;
modelStruct.modelVar_qpref2bot_d=mod.qpref2bot_d;
modelStruct.d_modelVar_qpref2bot_d_dX=0.0;
modelStruct.modelVar_qpref2sti_d=mod.qpref2sti_d;
modelStruct.d_modelVar_qpref2sti_d_dX=0.0;
modelStruct.modelVar_qpref2gat_d=mod.qpref2gat_d;
modelStruct.d_modelVar_qpref2gat_d_dX=0.0;
modelStruct.modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
modelStruct.d_modelVar_wdepnulrbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
modelStruct.d_modelVar_wdepnulrsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
modelStruct.d_modelVar_wdepnulrgat_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
modelStruct.d_modelVar_wdepnulrinvbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
modelStruct.d_modelVar_wdepnulrinvsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
modelStruct.d_modelVar_wdepnulrinvgat_d_dX=0.0;
modelStruct.modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
modelStruct.d_modelVar_VBIRBOTinv_d_dX=0.0;
modelStruct.modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
modelStruct.d_modelVar_VBIRSTIinv_d_dX=0.0;
modelStruct.modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
modelStruct.d_modelVar_VBIRGATinv_d_dX=0.0;
modelStruct.modelVar_atatbot_d=mod.atatbot_d;
modelStruct.d_modelVar_atatbot_d_dX=0.0;
modelStruct.modelVar_atatsti_d=mod.atatsti_d;
modelStruct.d_modelVar_atatsti_d_dX=0.0;
modelStruct.modelVar_atatgat_d=mod.atatgat_d;
modelStruct.d_modelVar_atatgat_d_dX=0.0;
modelStruct.modelVar_btatpartbot_d=mod.btatpartbot_d;
modelStruct.d_modelVar_btatpartbot_d_dX=0.0;
modelStruct.modelVar_btatpartsti_d=mod.btatpartsti_d;
modelStruct.d_modelVar_btatpartsti_d_dX=0.0;
modelStruct.modelVar_btatpartgat_d=mod.btatpartgat_d;
modelStruct.d_modelVar_btatpartgat_d_dX=0.0;
modelStruct.modelVar_fbbtbot_d=mod.fbbtbot_d;
modelStruct.d_modelVar_fbbtbot_d_dX=0.0;
modelStruct.modelVar_fbbtsti_d=mod.fbbtsti_d;
modelStruct.d_modelVar_fbbtsti_d_dX=0.0;
modelStruct.modelVar_fbbtgat_d=mod.fbbtgat_d;
modelStruct.d_modelVar_fbbtgat_d_dX=0.0;
modelStruct.modelVar_fstopbot_d=mod.fstopbot_d;
modelStruct.d_modelVar_fstopbot_d_dX=0.0;
modelStruct.modelVar_fstopsti_d=mod.fstopsti_d;
modelStruct.d_modelVar_fstopsti_d_dX=0.0;
modelStruct.modelVar_fstopgat_d=mod.fstopgat_d;
modelStruct.d_modelVar_fstopgat_d_dX=0.0;
modelStruct.modelVar_VBRinvbot_d=mod.VBRinvbot_d;
modelStruct.d_modelVar_VBRinvbot_d_dX=0.0;
modelStruct.modelVar_VBRinvsti_d=mod.VBRinvsti_d;
modelStruct.d_modelVar_VBRinvsti_d_dX=0.0;
modelStruct.modelVar_VBRinvgat_d=mod.VBRinvgat_d;
modelStruct.d_modelVar_VBRinvgat_d_dX=0.0;
modelStruct.modelVar_slopebot_d=mod.slopebot_d;
modelStruct.d_modelVar_slopebot_d_dX=0.0;
modelStruct.modelVar_slopesti_d=mod.slopesti_d;
modelStruct.d_modelVar_slopesti_d_dX=0.0;
modelStruct.modelVar_slopegat_d=mod.slopegat_d;
modelStruct.d_modelVar_slopegat_d_dX=0.0;
modelStruct.modelVar_phit=mod.phit;
modelStruct.d_modelVar_phit_dX=0.0;
modelStruct.modelVar_nt0=mod.nt0;
modelStruct.d_modelVar_nt0_dX=0.0;
modelStruct.modelVar_EPSSI=mod.EPSSI;


// non-reals
modelStruct.modelVar_CHNL_TYPE=mod.CHNL_TYPE;
modelStruct.modelVar_SWGEO_i=mod.SWGEO_i;
modelStruct.modelVar_SWIGATE_i=mod.SWIGATE_i;
modelStruct.modelVar_SWIMPACT_i=mod.SWIMPACT_i;
modelStruct.modelVar_SWGIDL_i=mod.SWGIDL_i;
modelStruct.modelVar_SWJUNCAP_i=mod.SWJUNCAP_i;
modelStruct.modelVar_SWJUNASYM_i=mod.SWJUNASYM_i;
modelStruct.modelVar_SWNUD_i=mod.SWNUD_i;
modelStruct.modelVar_SWEDGE_i=mod.SWEDGE_i;
modelStruct.modelVar_SWDELVTAC_i=mod.SWDELVTAC_i;
modelStruct.modelVar_SWIGN_i=mod.SWIGN_i;



Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

// extract solution variables
probeVars[in.admsProbeID_V_DI_GND] = (*solVectorPtr)[in.li_DI];
probeVars[in.admsProbeID_V_BS_GND] = (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_BD_GND] = (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_SI_GND] = (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_BP_GND] = (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_GP_GND] = (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP]- (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_D_DI] = (*solVectorPtr)[in.li_D]- (*solVectorPtr)[in.li_DI];
probeVars[in.admsProbeID_V_S_SI] = (*solVectorPtr)[in.li_S]- (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G]- (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_DI_BD] = (*solVectorPtr)[in.li_DI]- (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_SI_BS] = (*solVectorPtr)[in.li_SI]- (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_SI_BP] = (*solVectorPtr)[in.li_SI]- (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_DI_SI] = (*solVectorPtr)[in.li_DI]- (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_GP_SI] = (*solVectorPtr)[in.li_GP]- (*solVectorPtr)[in.li_SI];



  // Need to use processParams-like function to process the
  // initial_model and initial_instance blocks with the LOCAL copies of
  // instance and model vars, and local copies of instance and model
  // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature,in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.
evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_DI_GND,
in.admsProbeID_V_BS_GND,
in.admsProbeID_V_BD_GND,
in.admsProbeID_V_SI_GND,
in.admsProbeID_V_BP_GND,
in.admsProbeID_V_GP_GND,
in.admsProbeID_V_NOI_GND,
in.admsProbeID_V_NOI2_GND,
in.admsProbeID_V_B_BI,
in.admsProbeID_V_BD_BI,
in.admsProbeID_V_BS_BI,
in.admsProbeID_V_BP_BI,
in.admsProbeID_V_D_DI,
in.admsProbeID_V_S_SI,
in.admsProbeID_V_G_GP,
in.admsProbeID_V_DI_BD,
in.admsProbeID_V_SI_BS,
in.admsProbeID_V_SI_BP,
in.admsProbeID_V_DI_SI,
in.admsProbeID_V_GP_SI,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_NOI,
in.admsNodeID_NOI2,
in.admsNodeID_GP,
in.admsNodeID_SI,
in.admsNodeID_DI,
in.admsNodeID_BP,
in.admsNodeID_BI,
in.admsNodeID_BS,
in.admsNodeID_BD,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


// We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D] = in.li_D;
    Qindices[in.admsNodeID_D] = in.li_D;
    dfdp[in.admsNodeID_G] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G] = in.li_G;
    Qindices[in.admsNodeID_G] = in.li_G;
    dfdp[in.admsNodeID_S] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S] = in.li_S;
    Qindices[in.admsNodeID_S] = in.li_S;
    dfdp[in.admsNodeID_B] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B] = in.li_B;
    Qindices[in.admsNodeID_B] = in.li_B;
    dfdp[in.admsNodeID_NOI] += d_staticContributions_dX[in.admsNodeID_NOI];
    dqdp[in.admsNodeID_NOI] += d_dynamicContributions_dX[in.admsNodeID_NOI];
    Findices[in.admsNodeID_NOI] = in.li_NOI;
    Qindices[in.admsNodeID_NOI] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2] += d_staticContributions_dX[in.admsNodeID_NOI2];
    dqdp[in.admsNodeID_NOI2] += d_dynamicContributions_dX[in.admsNodeID_NOI2];
    Findices[in.admsNodeID_NOI2] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2] = in.li_NOI2;
    dfdp[in.admsNodeID_GP] += d_staticContributions_dX[in.admsNodeID_GP];
    dqdp[in.admsNodeID_GP] += d_dynamicContributions_dX[in.admsNodeID_GP];
    Findices[in.admsNodeID_GP] = in.li_GP;
    Qindices[in.admsNodeID_GP] = in.li_GP;
    dfdp[in.admsNodeID_SI] += d_staticContributions_dX[in.admsNodeID_SI];
    dqdp[in.admsNodeID_SI] += d_dynamicContributions_dX[in.admsNodeID_SI];
    Findices[in.admsNodeID_SI] = in.li_SI;
    Qindices[in.admsNodeID_SI] = in.li_SI;
    dfdp[in.admsNodeID_DI] += d_staticContributions_dX[in.admsNodeID_DI];
    dqdp[in.admsNodeID_DI] += d_dynamicContributions_dX[in.admsNodeID_DI];
    Findices[in.admsNodeID_DI] = in.li_DI;
    Qindices[in.admsNodeID_DI] = in.li_DI;
    dfdp[in.admsNodeID_BP] += d_staticContributions_dX[in.admsNodeID_BP];
    dqdp[in.admsNodeID_BP] += d_dynamicContributions_dX[in.admsNodeID_BP];
    Findices[in.admsNodeID_BP] = in.li_BP;
    Qindices[in.admsNodeID_BP] = in.li_BP;
    dfdp[in.admsNodeID_BI] += d_staticContributions_dX[in.admsNodeID_BI];
    dqdp[in.admsNodeID_BI] += d_dynamicContributions_dX[in.admsNodeID_BI];
    Findices[in.admsNodeID_BI] = in.li_BI;
    Qindices[in.admsNodeID_BI] = in.li_BI;
    dfdp[in.admsNodeID_BS] += d_staticContributions_dX[in.admsNodeID_BS];
    dqdp[in.admsNodeID_BS] += d_dynamicContributions_dX[in.admsNodeID_BS];
    Findices[in.admsNodeID_BS] = in.li_BS;
    Qindices[in.admsNodeID_BS] = in.li_BS;
    dfdp[in.admsNodeID_BD] += d_staticContributions_dX[in.admsNodeID_BD];
    dqdp[in.admsNodeID_BD] += d_dynamicContributions_dX[in.admsNodeID_BD];
    Findices[in.admsNodeID_BD] = in.li_BD;
    Qindices[in.admsNodeID_BD] = in.li_BD;


}

//-----------------------------------------------------------------------------
// Function      : ModelSensitivity::operator()
// Purpose       : return sensitivity for a single model parameter
// Special Notes :
// Scope         : public
// Creator       : admsXml
// Creation Date :
//-----------------------------------------------------------------------------
/// Compute sensitivity to a specified model
/// parameter of all device instances of that model's outputs
///
///
/// @param[in] entity  The device entity that owns the parameter
/// @param[in] name    The unadorned parameter name specific to the entity
/// @param[out] dfdp   The derivative of the F vector with respect to the parameter
/// @param[out] dqdp   The derivative of the Q vector with respect to the parameter
/// @param[out] dbdp   The derivative of the B vector with respect to the parameter
/// @param[out] Findices   The indices into the F vector corresponding to the elements of dfdp
/// @param[out] Qindices   The indices into the Q vector corresponding to the elements of dfdp
/// @param[out] Bindices   The indices into the B vector corresponding to the elements of dfdp
///
///
void ModelSensitivity::operator()
(
const ParameterBase &entity,
const std::string &name,
std::vector<double> & dfdp,
std::vector<double> & dqdp,
std::vector<double> & dbdp,
std::vector<int> & Findices,
std::vector<int> & Qindices,
std::vector<int> & Bindices
) const
{
const ParameterBase * e1 = &entity;
const Model & mod = *(dynamic_cast<const Model *> (e1));
int sizeInstance = mod.instanceContainer.size();

dfdp.resize((13+0)*sizeInstance);
dqdp.resize((13+0)*sizeInstance);
Findices.resize((13+0)*sizeInstance);
Qindices.resize((13+0)*sizeInstance);

std::vector <double> probeVars(20);
std::vector <double> d_staticContributions_dX(13+0);
std::vector <double> d_dynamicContributions_dX(13+0);


// Copy out all the model parameters (doubles) into local structure
modelSensStruct modelStruct;

// Keep a map so we can set the right one to the independent variable
// We do this solely to avoid a big ugly "if/else" block just to find the
// one parameter we're doing sensitivities on.
unordered_map <std::string,double*,HashNoCase,EqualNoCase> modParamMap;

// reals
modelStruct.modelPar_TR=mod.TR;
modelStruct.d_modelPar_TR_dX=0.0;
modelStruct.modelPar_given_TR=mod.given("TR");
modParamMap["TR"] = &(modelStruct.d_modelPar_TR_dX);
modelStruct.modelPar_QMC=mod.QMC;
modelStruct.d_modelPar_QMC_dX=0.0;
modelStruct.modelPar_given_QMC=mod.given("QMC");
modParamMap["QMC"] = &(modelStruct.d_modelPar_QMC_dX);
modelStruct.modelPar_VFB=mod.VFB;
modelStruct.d_modelPar_VFB_dX=0.0;
modelStruct.modelPar_given_VFB=mod.given("VFB");
modParamMap["VFB"] = &(modelStruct.d_modelPar_VFB_dX);
modelStruct.modelPar_STVFB=mod.STVFB;
modelStruct.d_modelPar_STVFB_dX=0.0;
modelStruct.modelPar_given_STVFB=mod.given("STVFB");
modParamMap["STVFB"] = &(modelStruct.d_modelPar_STVFB_dX);
modelStruct.modelPar_TOX=mod.TOX;
modelStruct.d_modelPar_TOX_dX=0.0;
modelStruct.modelPar_given_TOX=mod.given("TOX");
modParamMap["TOX"] = &(modelStruct.d_modelPar_TOX_dX);
modelStruct.modelPar_EPSROX=mod.EPSROX;
modelStruct.d_modelPar_EPSROX_dX=0.0;
modelStruct.modelPar_given_EPSROX=mod.given("EPSROX");
modParamMap["EPSROX"] = &(modelStruct.d_modelPar_EPSROX_dX);
modelStruct.modelPar_NEFF=mod.NEFF;
modelStruct.d_modelPar_NEFF_dX=0.0;
modelStruct.modelPar_given_NEFF=mod.given("NEFF");
modParamMap["NEFF"] = &(modelStruct.d_modelPar_NEFF_dX);
modelStruct.modelPar_FACNEFFAC=mod.FACNEFFAC;
modelStruct.d_modelPar_FACNEFFAC_dX=0.0;
modelStruct.modelPar_given_FACNEFFAC=mod.given("FACNEFFAC");
modParamMap["FACNEFFAC"] = &(modelStruct.d_modelPar_FACNEFFAC_dX);
modelStruct.modelPar_GFACNUD=mod.GFACNUD;
modelStruct.d_modelPar_GFACNUD_dX=0.0;
modelStruct.modelPar_given_GFACNUD=mod.given("GFACNUD");
modParamMap["GFACNUD"] = &(modelStruct.d_modelPar_GFACNUD_dX);
modelStruct.modelPar_VSBNUD=mod.VSBNUD;
modelStruct.d_modelPar_VSBNUD_dX=0.0;
modelStruct.modelPar_given_VSBNUD=mod.given("VSBNUD");
modParamMap["VSBNUD"] = &(modelStruct.d_modelPar_VSBNUD_dX);
modelStruct.modelPar_DVSBNUD=mod.DVSBNUD;
modelStruct.d_modelPar_DVSBNUD_dX=0.0;
modelStruct.modelPar_given_DVSBNUD=mod.given("DVSBNUD");
modParamMap["DVSBNUD"] = &(modelStruct.d_modelPar_DVSBNUD_dX);
modelStruct.modelPar_VNSUB=mod.VNSUB;
modelStruct.d_modelPar_VNSUB_dX=0.0;
modelStruct.modelPar_given_VNSUB=mod.given("VNSUB");
modParamMap["VNSUB"] = &(modelStruct.d_modelPar_VNSUB_dX);
modelStruct.modelPar_NSLP=mod.NSLP;
modelStruct.d_modelPar_NSLP_dX=0.0;
modelStruct.modelPar_given_NSLP=mod.given("NSLP");
modParamMap["NSLP"] = &(modelStruct.d_modelPar_NSLP_dX);
modelStruct.modelPar_DNSUB=mod.DNSUB;
modelStruct.d_modelPar_DNSUB_dX=0.0;
modelStruct.modelPar_given_DNSUB=mod.given("DNSUB");
modParamMap["DNSUB"] = &(modelStruct.d_modelPar_DNSUB_dX);
modelStruct.modelPar_DPHIB=mod.DPHIB;
modelStruct.d_modelPar_DPHIB_dX=0.0;
modelStruct.modelPar_given_DPHIB=mod.given("DPHIB");
modParamMap["DPHIB"] = &(modelStruct.d_modelPar_DPHIB_dX);
modelStruct.modelPar_DELVTAC=mod.DELVTAC;
modelStruct.d_modelPar_DELVTAC_dX=0.0;
modelStruct.modelPar_given_DELVTAC=mod.given("DELVTAC");
modParamMap["DELVTAC"] = &(modelStruct.d_modelPar_DELVTAC_dX);
modelStruct.modelPar_NP=mod.NP;
modelStruct.d_modelPar_NP_dX=0.0;
modelStruct.modelPar_given_NP=mod.given("NP");
modParamMap["NP"] = &(modelStruct.d_modelPar_NP_dX);
modelStruct.modelPar_CT=mod.CT;
modelStruct.d_modelPar_CT_dX=0.0;
modelStruct.modelPar_given_CT=mod.given("CT");
modParamMap["CT"] = &(modelStruct.d_modelPar_CT_dX);
modelStruct.modelPar_TOXOV=mod.TOXOV;
modelStruct.d_modelPar_TOXOV_dX=0.0;
modelStruct.modelPar_given_TOXOV=mod.given("TOXOV");
modParamMap["TOXOV"] = &(modelStruct.d_modelPar_TOXOV_dX);
modelStruct.modelPar_TOXOVD=mod.TOXOVD;
modelStruct.d_modelPar_TOXOVD_dX=0.0;
modelStruct.modelPar_given_TOXOVD=mod.given("TOXOVD");
modParamMap["TOXOVD"] = &(modelStruct.d_modelPar_TOXOVD_dX);
modelStruct.modelPar_NOV=mod.NOV;
modelStruct.d_modelPar_NOV_dX=0.0;
modelStruct.modelPar_given_NOV=mod.given("NOV");
modParamMap["NOV"] = &(modelStruct.d_modelPar_NOV_dX);
modelStruct.modelPar_NOVD=mod.NOVD;
modelStruct.d_modelPar_NOVD_dX=0.0;
modelStruct.modelPar_given_NOVD=mod.given("NOVD");
modParamMap["NOVD"] = &(modelStruct.d_modelPar_NOVD_dX);
modelStruct.modelPar_CF=mod.CF;
modelStruct.d_modelPar_CF_dX=0.0;
modelStruct.modelPar_given_CF=mod.given("CF");
modParamMap["CF"] = &(modelStruct.d_modelPar_CF_dX);
modelStruct.modelPar_CFD=mod.CFD;
modelStruct.d_modelPar_CFD_dX=0.0;
modelStruct.modelPar_given_CFD=mod.given("CFD");
modParamMap["CFD"] = &(modelStruct.d_modelPar_CFD_dX);
modelStruct.modelPar_CFB=mod.CFB;
modelStruct.d_modelPar_CFB_dX=0.0;
modelStruct.modelPar_given_CFB=mod.given("CFB");
modParamMap["CFB"] = &(modelStruct.d_modelPar_CFB_dX);
modelStruct.modelPar_PSCE=mod.PSCE;
modelStruct.d_modelPar_PSCE_dX=0.0;
modelStruct.modelPar_given_PSCE=mod.given("PSCE");
modParamMap["PSCE"] = &(modelStruct.d_modelPar_PSCE_dX);
modelStruct.modelPar_PSCEB=mod.PSCEB;
modelStruct.d_modelPar_PSCEB_dX=0.0;
modelStruct.modelPar_given_PSCEB=mod.given("PSCEB");
modParamMap["PSCEB"] = &(modelStruct.d_modelPar_PSCEB_dX);
modelStruct.modelPar_PSCED=mod.PSCED;
modelStruct.d_modelPar_PSCED_dX=0.0;
modelStruct.modelPar_given_PSCED=mod.given("PSCED");
modParamMap["PSCED"] = &(modelStruct.d_modelPar_PSCED_dX);
modelStruct.modelPar_BETN=mod.BETN;
modelStruct.d_modelPar_BETN_dX=0.0;
modelStruct.modelPar_given_BETN=mod.given("BETN");
modParamMap["BETN"] = &(modelStruct.d_modelPar_BETN_dX);
modelStruct.modelPar_STBET=mod.STBET;
modelStruct.d_modelPar_STBET_dX=0.0;
modelStruct.modelPar_given_STBET=mod.given("STBET");
modParamMap["STBET"] = &(modelStruct.d_modelPar_STBET_dX);
modelStruct.modelPar_MUE=mod.MUE;
modelStruct.d_modelPar_MUE_dX=0.0;
modelStruct.modelPar_given_MUE=mod.given("MUE");
modParamMap["MUE"] = &(modelStruct.d_modelPar_MUE_dX);
modelStruct.modelPar_STMUE=mod.STMUE;
modelStruct.d_modelPar_STMUE_dX=0.0;
modelStruct.modelPar_given_STMUE=mod.given("STMUE");
modParamMap["STMUE"] = &(modelStruct.d_modelPar_STMUE_dX);
modelStruct.modelPar_THEMU=mod.THEMU;
modelStruct.d_modelPar_THEMU_dX=0.0;
modelStruct.modelPar_given_THEMU=mod.given("THEMU");
modParamMap["THEMU"] = &(modelStruct.d_modelPar_THEMU_dX);
modelStruct.modelPar_STTHEMU=mod.STTHEMU;
modelStruct.d_modelPar_STTHEMU_dX=0.0;
modelStruct.modelPar_given_STTHEMU=mod.given("STTHEMU");
modParamMap["STTHEMU"] = &(modelStruct.d_modelPar_STTHEMU_dX);
modelStruct.modelPar_CS=mod.CS;
modelStruct.d_modelPar_CS_dX=0.0;
modelStruct.modelPar_given_CS=mod.given("CS");
modParamMap["CS"] = &(modelStruct.d_modelPar_CS_dX);
modelStruct.modelPar_STCS=mod.STCS;
modelStruct.d_modelPar_STCS_dX=0.0;
modelStruct.modelPar_given_STCS=mod.given("STCS");
modParamMap["STCS"] = &(modelStruct.d_modelPar_STCS_dX);
modelStruct.modelPar_XCOR=mod.XCOR;
modelStruct.d_modelPar_XCOR_dX=0.0;
modelStruct.modelPar_given_XCOR=mod.given("XCOR");
modParamMap["XCOR"] = &(modelStruct.d_modelPar_XCOR_dX);
modelStruct.modelPar_STXCOR=mod.STXCOR;
modelStruct.d_modelPar_STXCOR_dX=0.0;
modelStruct.modelPar_given_STXCOR=mod.given("STXCOR");
modParamMap["STXCOR"] = &(modelStruct.d_modelPar_STXCOR_dX);
modelStruct.modelPar_FETA=mod.FETA;
modelStruct.d_modelPar_FETA_dX=0.0;
modelStruct.modelPar_given_FETA=mod.given("FETA");
modParamMap["FETA"] = &(modelStruct.d_modelPar_FETA_dX);
modelStruct.modelPar_RS=mod.RS;
modelStruct.d_modelPar_RS_dX=0.0;
modelStruct.modelPar_given_RS=mod.given("RS");
modParamMap["RS"] = &(modelStruct.d_modelPar_RS_dX);
modelStruct.modelPar_STRS=mod.STRS;
modelStruct.d_modelPar_STRS_dX=0.0;
modelStruct.modelPar_given_STRS=mod.given("STRS");
modParamMap["STRS"] = &(modelStruct.d_modelPar_STRS_dX);
modelStruct.modelPar_RSB=mod.RSB;
modelStruct.d_modelPar_RSB_dX=0.0;
modelStruct.modelPar_given_RSB=mod.given("RSB");
modParamMap["RSB"] = &(modelStruct.d_modelPar_RSB_dX);
modelStruct.modelPar_RSG=mod.RSG;
modelStruct.d_modelPar_RSG_dX=0.0;
modelStruct.modelPar_given_RSG=mod.given("RSG");
modParamMap["RSG"] = &(modelStruct.d_modelPar_RSG_dX);
modelStruct.modelPar_THESAT=mod.THESAT;
modelStruct.d_modelPar_THESAT_dX=0.0;
modelStruct.modelPar_given_THESAT=mod.given("THESAT");
modParamMap["THESAT"] = &(modelStruct.d_modelPar_THESAT_dX);
modelStruct.modelPar_STTHESAT=mod.STTHESAT;
modelStruct.d_modelPar_STTHESAT_dX=0.0;
modelStruct.modelPar_given_STTHESAT=mod.given("STTHESAT");
modParamMap["STTHESAT"] = &(modelStruct.d_modelPar_STTHESAT_dX);
modelStruct.modelPar_THESATB=mod.THESATB;
modelStruct.d_modelPar_THESATB_dX=0.0;
modelStruct.modelPar_given_THESATB=mod.given("THESATB");
modParamMap["THESATB"] = &(modelStruct.d_modelPar_THESATB_dX);
modelStruct.modelPar_THESATG=mod.THESATG;
modelStruct.d_modelPar_THESATG_dX=0.0;
modelStruct.modelPar_given_THESATG=mod.given("THESATG");
modParamMap["THESATG"] = &(modelStruct.d_modelPar_THESATG_dX);
modelStruct.modelPar_AX=mod.AX;
modelStruct.d_modelPar_AX_dX=0.0;
modelStruct.modelPar_given_AX=mod.given("AX");
modParamMap["AX"] = &(modelStruct.d_modelPar_AX_dX);
modelStruct.modelPar_ALP=mod.ALP;
modelStruct.d_modelPar_ALP_dX=0.0;
modelStruct.modelPar_given_ALP=mod.given("ALP");
modParamMap["ALP"] = &(modelStruct.d_modelPar_ALP_dX);
modelStruct.modelPar_ALP1=mod.ALP1;
modelStruct.d_modelPar_ALP1_dX=0.0;
modelStruct.modelPar_given_ALP1=mod.given("ALP1");
modParamMap["ALP1"] = &(modelStruct.d_modelPar_ALP1_dX);
modelStruct.modelPar_ALP2=mod.ALP2;
modelStruct.d_modelPar_ALP2_dX=0.0;
modelStruct.modelPar_given_ALP2=mod.given("ALP2");
modParamMap["ALP2"] = &(modelStruct.d_modelPar_ALP2_dX);
modelStruct.modelPar_VP=mod.VP;
modelStruct.d_modelPar_VP_dX=0.0;
modelStruct.modelPar_given_VP=mod.given("VP");
modParamMap["VP"] = &(modelStruct.d_modelPar_VP_dX);
modelStruct.modelPar_A1=mod.A1;
modelStruct.d_modelPar_A1_dX=0.0;
modelStruct.modelPar_given_A1=mod.given("A1");
modParamMap["A1"] = &(modelStruct.d_modelPar_A1_dX);
modelStruct.modelPar_A2=mod.A2;
modelStruct.d_modelPar_A2_dX=0.0;
modelStruct.modelPar_given_A2=mod.given("A2");
modParamMap["A2"] = &(modelStruct.d_modelPar_A2_dX);
modelStruct.modelPar_STA2=mod.STA2;
modelStruct.d_modelPar_STA2_dX=0.0;
modelStruct.modelPar_given_STA2=mod.given("STA2");
modParamMap["STA2"] = &(modelStruct.d_modelPar_STA2_dX);
modelStruct.modelPar_A3=mod.A3;
modelStruct.d_modelPar_A3_dX=0.0;
modelStruct.modelPar_given_A3=mod.given("A3");
modParamMap["A3"] = &(modelStruct.d_modelPar_A3_dX);
modelStruct.modelPar_A4=mod.A4;
modelStruct.d_modelPar_A4_dX=0.0;
modelStruct.modelPar_given_A4=mod.given("A4");
modParamMap["A4"] = &(modelStruct.d_modelPar_A4_dX);
modelStruct.modelPar_GCO=mod.GCO;
modelStruct.d_modelPar_GCO_dX=0.0;
modelStruct.modelPar_given_GCO=mod.given("GCO");
modParamMap["GCO"] = &(modelStruct.d_modelPar_GCO_dX);
modelStruct.modelPar_IGINV=mod.IGINV;
modelStruct.d_modelPar_IGINV_dX=0.0;
modelStruct.modelPar_given_IGINV=mod.given("IGINV");
modParamMap["IGINV"] = &(modelStruct.d_modelPar_IGINV_dX);
modelStruct.modelPar_IGOV=mod.IGOV;
modelStruct.d_modelPar_IGOV_dX=0.0;
modelStruct.modelPar_given_IGOV=mod.given("IGOV");
modParamMap["IGOV"] = &(modelStruct.d_modelPar_IGOV_dX);
modelStruct.modelPar_IGOVD=mod.IGOVD;
modelStruct.d_modelPar_IGOVD_dX=0.0;
modelStruct.modelPar_given_IGOVD=mod.given("IGOVD");
modParamMap["IGOVD"] = &(modelStruct.d_modelPar_IGOVD_dX);
modelStruct.modelPar_STIG=mod.STIG;
modelStruct.d_modelPar_STIG_dX=0.0;
modelStruct.modelPar_given_STIG=mod.given("STIG");
modParamMap["STIG"] = &(modelStruct.d_modelPar_STIG_dX);
modelStruct.modelPar_GC2=mod.GC2;
modelStruct.d_modelPar_GC2_dX=0.0;
modelStruct.modelPar_given_GC2=mod.given("GC2");
modParamMap["GC2"] = &(modelStruct.d_modelPar_GC2_dX);
modelStruct.modelPar_GC3=mod.GC3;
modelStruct.d_modelPar_GC3_dX=0.0;
modelStruct.modelPar_given_GC3=mod.given("GC3");
modParamMap["GC3"] = &(modelStruct.d_modelPar_GC3_dX);
modelStruct.modelPar_CHIB=mod.CHIB;
modelStruct.d_modelPar_CHIB_dX=0.0;
modelStruct.modelPar_given_CHIB=mod.given("CHIB");
modParamMap["CHIB"] = &(modelStruct.d_modelPar_CHIB_dX);
modelStruct.modelPar_AGIDL=mod.AGIDL;
modelStruct.d_modelPar_AGIDL_dX=0.0;
modelStruct.modelPar_given_AGIDL=mod.given("AGIDL");
modParamMap["AGIDL"] = &(modelStruct.d_modelPar_AGIDL_dX);
modelStruct.modelPar_AGIDLD=mod.AGIDLD;
modelStruct.d_modelPar_AGIDLD_dX=0.0;
modelStruct.modelPar_given_AGIDLD=mod.given("AGIDLD");
modParamMap["AGIDLD"] = &(modelStruct.d_modelPar_AGIDLD_dX);
modelStruct.modelPar_BGIDL=mod.BGIDL;
modelStruct.d_modelPar_BGIDL_dX=0.0;
modelStruct.modelPar_given_BGIDL=mod.given("BGIDL");
modParamMap["BGIDL"] = &(modelStruct.d_modelPar_BGIDL_dX);
modelStruct.modelPar_BGIDLD=mod.BGIDLD;
modelStruct.d_modelPar_BGIDLD_dX=0.0;
modelStruct.modelPar_given_BGIDLD=mod.given("BGIDLD");
modParamMap["BGIDLD"] = &(modelStruct.d_modelPar_BGIDLD_dX);
modelStruct.modelPar_STBGIDL=mod.STBGIDL;
modelStruct.d_modelPar_STBGIDL_dX=0.0;
modelStruct.modelPar_given_STBGIDL=mod.given("STBGIDL");
modParamMap["STBGIDL"] = &(modelStruct.d_modelPar_STBGIDL_dX);
modelStruct.modelPar_STBGIDLD=mod.STBGIDLD;
modelStruct.d_modelPar_STBGIDLD_dX=0.0;
modelStruct.modelPar_given_STBGIDLD=mod.given("STBGIDLD");
modParamMap["STBGIDLD"] = &(modelStruct.d_modelPar_STBGIDLD_dX);
modelStruct.modelPar_CGIDL=mod.CGIDL;
modelStruct.d_modelPar_CGIDL_dX=0.0;
modelStruct.modelPar_given_CGIDL=mod.given("CGIDL");
modParamMap["CGIDL"] = &(modelStruct.d_modelPar_CGIDL_dX);
modelStruct.modelPar_CGIDLD=mod.CGIDLD;
modelStruct.d_modelPar_CGIDLD_dX=0.0;
modelStruct.modelPar_given_CGIDLD=mod.given("CGIDLD");
modParamMap["CGIDLD"] = &(modelStruct.d_modelPar_CGIDLD_dX);
modelStruct.modelPar_COX=mod.COX;
modelStruct.d_modelPar_COX_dX=0.0;
modelStruct.modelPar_given_COX=mod.given("COX");
modParamMap["COX"] = &(modelStruct.d_modelPar_COX_dX);
modelStruct.modelPar_CGOV=mod.CGOV;
modelStruct.d_modelPar_CGOV_dX=0.0;
modelStruct.modelPar_given_CGOV=mod.given("CGOV");
modParamMap["CGOV"] = &(modelStruct.d_modelPar_CGOV_dX);
modelStruct.modelPar_CGOVD=mod.CGOVD;
modelStruct.d_modelPar_CGOVD_dX=0.0;
modelStruct.modelPar_given_CGOVD=mod.given("CGOVD");
modParamMap["CGOVD"] = &(modelStruct.d_modelPar_CGOVD_dX);
modelStruct.modelPar_CGBOV=mod.CGBOV;
modelStruct.d_modelPar_CGBOV_dX=0.0;
modelStruct.modelPar_given_CGBOV=mod.given("CGBOV");
modParamMap["CGBOV"] = &(modelStruct.d_modelPar_CGBOV_dX);
modelStruct.modelPar_CFR=mod.CFR;
modelStruct.d_modelPar_CFR_dX=0.0;
modelStruct.modelPar_given_CFR=mod.given("CFR");
modParamMap["CFR"] = &(modelStruct.d_modelPar_CFR_dX);
modelStruct.modelPar_CFRD=mod.CFRD;
modelStruct.d_modelPar_CFRD_dX=0.0;
modelStruct.modelPar_given_CFRD=mod.given("CFRD");
modParamMap["CFRD"] = &(modelStruct.d_modelPar_CFRD_dX);
modelStruct.modelPar_FNT=mod.FNT;
modelStruct.d_modelPar_FNT_dX=0.0;
modelStruct.modelPar_given_FNT=mod.given("FNT");
modParamMap["FNT"] = &(modelStruct.d_modelPar_FNT_dX);
modelStruct.modelPar_FNTEXC=mod.FNTEXC;
modelStruct.d_modelPar_FNTEXC_dX=0.0;
modelStruct.modelPar_given_FNTEXC=mod.given("FNTEXC");
modParamMap["FNTEXC"] = &(modelStruct.d_modelPar_FNTEXC_dX);
modelStruct.modelPar_NFA=mod.NFA;
modelStruct.d_modelPar_NFA_dX=0.0;
modelStruct.modelPar_given_NFA=mod.given("NFA");
modParamMap["NFA"] = &(modelStruct.d_modelPar_NFA_dX);
modelStruct.modelPar_NFB=mod.NFB;
modelStruct.d_modelPar_NFB_dX=0.0;
modelStruct.modelPar_given_NFB=mod.given("NFB");
modParamMap["NFB"] = &(modelStruct.d_modelPar_NFB_dX);
modelStruct.modelPar_NFC=mod.NFC;
modelStruct.d_modelPar_NFC_dX=0.0;
modelStruct.modelPar_given_NFC=mod.given("NFC");
modParamMap["NFC"] = &(modelStruct.d_modelPar_NFC_dX);
modelStruct.modelPar_EF=mod.EF;
modelStruct.d_modelPar_EF_dX=0.0;
modelStruct.modelPar_given_EF=mod.given("EF");
modParamMap["EF"] = &(modelStruct.d_modelPar_EF_dX);
modelStruct.modelPar_VFBEDGE=mod.VFBEDGE;
modelStruct.d_modelPar_VFBEDGE_dX=0.0;
modelStruct.modelPar_given_VFBEDGE=mod.given("VFBEDGE");
modParamMap["VFBEDGE"] = &(modelStruct.d_modelPar_VFBEDGE_dX);
modelStruct.modelPar_STVFBEDGE=mod.STVFBEDGE;
modelStruct.d_modelPar_STVFBEDGE_dX=0.0;
modelStruct.modelPar_given_STVFBEDGE=mod.given("STVFBEDGE");
modParamMap["STVFBEDGE"] = &(modelStruct.d_modelPar_STVFBEDGE_dX);
modelStruct.modelPar_DPHIBEDGE=mod.DPHIBEDGE;
modelStruct.d_modelPar_DPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGE=mod.given("DPHIBEDGE");
modParamMap["DPHIBEDGE"] = &(modelStruct.d_modelPar_DPHIBEDGE_dX);
modelStruct.modelPar_NEFFEDGE=mod.NEFFEDGE;
modelStruct.d_modelPar_NEFFEDGE_dX=0.0;
modelStruct.modelPar_given_NEFFEDGE=mod.given("NEFFEDGE");
modParamMap["NEFFEDGE"] = &(modelStruct.d_modelPar_NEFFEDGE_dX);
modelStruct.modelPar_CTEDGE=mod.CTEDGE;
modelStruct.d_modelPar_CTEDGE_dX=0.0;
modelStruct.modelPar_given_CTEDGE=mod.given("CTEDGE");
modParamMap["CTEDGE"] = &(modelStruct.d_modelPar_CTEDGE_dX);
modelStruct.modelPar_BETNEDGE=mod.BETNEDGE;
modelStruct.d_modelPar_BETNEDGE_dX=0.0;
modelStruct.modelPar_given_BETNEDGE=mod.given("BETNEDGE");
modParamMap["BETNEDGE"] = &(modelStruct.d_modelPar_BETNEDGE_dX);
modelStruct.modelPar_STBETEDGE=mod.STBETEDGE;
modelStruct.d_modelPar_STBETEDGE_dX=0.0;
modelStruct.modelPar_given_STBETEDGE=mod.given("STBETEDGE");
modParamMap["STBETEDGE"] = &(modelStruct.d_modelPar_STBETEDGE_dX);
modelStruct.modelPar_PSCEEDGE=mod.PSCEEDGE;
modelStruct.d_modelPar_PSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEEDGE=mod.given("PSCEEDGE");
modParamMap["PSCEEDGE"] = &(modelStruct.d_modelPar_PSCEEDGE_dX);
modelStruct.modelPar_PSCEBEDGE=mod.PSCEBEDGE;
modelStruct.d_modelPar_PSCEBEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEBEDGE=mod.given("PSCEBEDGE");
modParamMap["PSCEBEDGE"] = &(modelStruct.d_modelPar_PSCEBEDGE_dX);
modelStruct.modelPar_PSCEDEDGE=mod.PSCEDEDGE;
modelStruct.d_modelPar_PSCEDEDGE_dX=0.0;
modelStruct.modelPar_given_PSCEDEDGE=mod.given("PSCEDEDGE");
modParamMap["PSCEDEDGE"] = &(modelStruct.d_modelPar_PSCEDEDGE_dX);
modelStruct.modelPar_CFEDGE=mod.CFEDGE;
modelStruct.d_modelPar_CFEDGE_dX=0.0;
modelStruct.modelPar_given_CFEDGE=mod.given("CFEDGE");
modParamMap["CFEDGE"] = &(modelStruct.d_modelPar_CFEDGE_dX);
modelStruct.modelPar_CFDEDGE=mod.CFDEDGE;
modelStruct.d_modelPar_CFDEDGE_dX=0.0;
modelStruct.modelPar_given_CFDEDGE=mod.given("CFDEDGE");
modParamMap["CFDEDGE"] = &(modelStruct.d_modelPar_CFDEDGE_dX);
modelStruct.modelPar_CFBEDGE=mod.CFBEDGE;
modelStruct.d_modelPar_CFBEDGE_dX=0.0;
modelStruct.modelPar_given_CFBEDGE=mod.given("CFBEDGE");
modParamMap["CFBEDGE"] = &(modelStruct.d_modelPar_CFBEDGE_dX);
modelStruct.modelPar_FNTEDGE=mod.FNTEDGE;
modelStruct.d_modelPar_FNTEDGE_dX=0.0;
modelStruct.modelPar_given_FNTEDGE=mod.given("FNTEDGE");
modParamMap["FNTEDGE"] = &(modelStruct.d_modelPar_FNTEDGE_dX);
modelStruct.modelPar_NFAEDGE=mod.NFAEDGE;
modelStruct.d_modelPar_NFAEDGE_dX=0.0;
modelStruct.modelPar_given_NFAEDGE=mod.given("NFAEDGE");
modParamMap["NFAEDGE"] = &(modelStruct.d_modelPar_NFAEDGE_dX);
modelStruct.modelPar_NFBEDGE=mod.NFBEDGE;
modelStruct.d_modelPar_NFBEDGE_dX=0.0;
modelStruct.modelPar_given_NFBEDGE=mod.given("NFBEDGE");
modParamMap["NFBEDGE"] = &(modelStruct.d_modelPar_NFBEDGE_dX);
modelStruct.modelPar_NFCEDGE=mod.NFCEDGE;
modelStruct.d_modelPar_NFCEDGE_dX=0.0;
modelStruct.modelPar_given_NFCEDGE=mod.given("NFCEDGE");
modParamMap["NFCEDGE"] = &(modelStruct.d_modelPar_NFCEDGE_dX);
modelStruct.modelPar_EFEDGE=mod.EFEDGE;
modelStruct.d_modelPar_EFEDGE_dX=0.0;
modelStruct.modelPar_given_EFEDGE=mod.given("EFEDGE");
modParamMap["EFEDGE"] = &(modelStruct.d_modelPar_EFEDGE_dX);
modelStruct.modelPar_RG=mod.RG;
modelStruct.d_modelPar_RG_dX=0.0;
modelStruct.modelPar_given_RG=mod.given("RG");
modParamMap["RG"] = &(modelStruct.d_modelPar_RG_dX);
modelStruct.modelPar_RSE=mod.RSE;
modelStruct.d_modelPar_RSE_dX=0.0;
modelStruct.modelPar_given_RSE=mod.given("RSE");
modParamMap["RSE"] = &(modelStruct.d_modelPar_RSE_dX);
modelStruct.modelPar_RDE=mod.RDE;
modelStruct.d_modelPar_RDE_dX=0.0;
modelStruct.modelPar_given_RDE=mod.given("RDE");
modParamMap["RDE"] = &(modelStruct.d_modelPar_RDE_dX);
modelStruct.modelPar_RBULK=mod.RBULK;
modelStruct.d_modelPar_RBULK_dX=0.0;
modelStruct.modelPar_given_RBULK=mod.given("RBULK");
modParamMap["RBULK"] = &(modelStruct.d_modelPar_RBULK_dX);
modelStruct.modelPar_RWELL=mod.RWELL;
modelStruct.d_modelPar_RWELL_dX=0.0;
modelStruct.modelPar_given_RWELL=mod.given("RWELL");
modParamMap["RWELL"] = &(modelStruct.d_modelPar_RWELL_dX);
modelStruct.modelPar_RJUNS=mod.RJUNS;
modelStruct.d_modelPar_RJUNS_dX=0.0;
modelStruct.modelPar_given_RJUNS=mod.given("RJUNS");
modParamMap["RJUNS"] = &(modelStruct.d_modelPar_RJUNS_dX);
modelStruct.modelPar_RJUND=mod.RJUND;
modelStruct.d_modelPar_RJUND_dX=0.0;
modelStruct.modelPar_given_RJUND=mod.given("RJUND");
modParamMap["RJUND"] = &(modelStruct.d_modelPar_RJUND_dX);
modelStruct.modelPar_POVFB=mod.POVFB;
modelStruct.d_modelPar_POVFB_dX=0.0;
modelStruct.modelPar_given_POVFB=mod.given("POVFB");
modParamMap["POVFB"] = &(modelStruct.d_modelPar_POVFB_dX);
modelStruct.modelPar_PLVFB=mod.PLVFB;
modelStruct.d_modelPar_PLVFB_dX=0.0;
modelStruct.modelPar_given_PLVFB=mod.given("PLVFB");
modParamMap["PLVFB"] = &(modelStruct.d_modelPar_PLVFB_dX);
modelStruct.modelPar_PWVFB=mod.PWVFB;
modelStruct.d_modelPar_PWVFB_dX=0.0;
modelStruct.modelPar_given_PWVFB=mod.given("PWVFB");
modParamMap["PWVFB"] = &(modelStruct.d_modelPar_PWVFB_dX);
modelStruct.modelPar_PLWVFB=mod.PLWVFB;
modelStruct.d_modelPar_PLWVFB_dX=0.0;
modelStruct.modelPar_given_PLWVFB=mod.given("PLWVFB");
modParamMap["PLWVFB"] = &(modelStruct.d_modelPar_PLWVFB_dX);
modelStruct.modelPar_POSTVFB=mod.POSTVFB;
modelStruct.d_modelPar_POSTVFB_dX=0.0;
modelStruct.modelPar_given_POSTVFB=mod.given("POSTVFB");
modParamMap["POSTVFB"] = &(modelStruct.d_modelPar_POSTVFB_dX);
modelStruct.modelPar_PLSTVFB=mod.PLSTVFB;
modelStruct.d_modelPar_PLSTVFB_dX=0.0;
modelStruct.modelPar_given_PLSTVFB=mod.given("PLSTVFB");
modParamMap["PLSTVFB"] = &(modelStruct.d_modelPar_PLSTVFB_dX);
modelStruct.modelPar_PWSTVFB=mod.PWSTVFB;
modelStruct.d_modelPar_PWSTVFB_dX=0.0;
modelStruct.modelPar_given_PWSTVFB=mod.given("PWSTVFB");
modParamMap["PWSTVFB"] = &(modelStruct.d_modelPar_PWSTVFB_dX);
modelStruct.modelPar_PLWSTVFB=mod.PLWSTVFB;
modelStruct.d_modelPar_PLWSTVFB_dX=0.0;
modelStruct.modelPar_given_PLWSTVFB=mod.given("PLWSTVFB");
modParamMap["PLWSTVFB"] = &(modelStruct.d_modelPar_PLWSTVFB_dX);
modelStruct.modelPar_POTOX=mod.POTOX;
modelStruct.d_modelPar_POTOX_dX=0.0;
modelStruct.modelPar_given_POTOX=mod.given("POTOX");
modParamMap["POTOX"] = &(modelStruct.d_modelPar_POTOX_dX);
modelStruct.modelPar_POEPSROX=mod.POEPSROX;
modelStruct.d_modelPar_POEPSROX_dX=0.0;
modelStruct.modelPar_given_POEPSROX=mod.given("POEPSROX");
modParamMap["POEPSROX"] = &(modelStruct.d_modelPar_POEPSROX_dX);
modelStruct.modelPar_PONEFF=mod.PONEFF;
modelStruct.d_modelPar_PONEFF_dX=0.0;
modelStruct.modelPar_given_PONEFF=mod.given("PONEFF");
modParamMap["PONEFF"] = &(modelStruct.d_modelPar_PONEFF_dX);
modelStruct.modelPar_PLNEFF=mod.PLNEFF;
modelStruct.d_modelPar_PLNEFF_dX=0.0;
modelStruct.modelPar_given_PLNEFF=mod.given("PLNEFF");
modParamMap["PLNEFF"] = &(modelStruct.d_modelPar_PLNEFF_dX);
modelStruct.modelPar_PWNEFF=mod.PWNEFF;
modelStruct.d_modelPar_PWNEFF_dX=0.0;
modelStruct.modelPar_given_PWNEFF=mod.given("PWNEFF");
modParamMap["PWNEFF"] = &(modelStruct.d_modelPar_PWNEFF_dX);
modelStruct.modelPar_PLWNEFF=mod.PLWNEFF;
modelStruct.d_modelPar_PLWNEFF_dX=0.0;
modelStruct.modelPar_given_PLWNEFF=mod.given("PLWNEFF");
modParamMap["PLWNEFF"] = &(modelStruct.d_modelPar_PLWNEFF_dX);
modelStruct.modelPar_POFACNEFFAC=mod.POFACNEFFAC;
modelStruct.d_modelPar_POFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_POFACNEFFAC=mod.given("POFACNEFFAC");
modParamMap["POFACNEFFAC"] = &(modelStruct.d_modelPar_POFACNEFFAC_dX);
modelStruct.modelPar_PLFACNEFFAC=mod.PLFACNEFFAC;
modelStruct.d_modelPar_PLFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PLFACNEFFAC=mod.given("PLFACNEFFAC");
modParamMap["PLFACNEFFAC"] = &(modelStruct.d_modelPar_PLFACNEFFAC_dX);
modelStruct.modelPar_PWFACNEFFAC=mod.PWFACNEFFAC;
modelStruct.d_modelPar_PWFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PWFACNEFFAC=mod.given("PWFACNEFFAC");
modParamMap["PWFACNEFFAC"] = &(modelStruct.d_modelPar_PWFACNEFFAC_dX);
modelStruct.modelPar_PLWFACNEFFAC=mod.PLWFACNEFFAC;
modelStruct.d_modelPar_PLWFACNEFFAC_dX=0.0;
modelStruct.modelPar_given_PLWFACNEFFAC=mod.given("PLWFACNEFFAC");
modParamMap["PLWFACNEFFAC"] = &(modelStruct.d_modelPar_PLWFACNEFFAC_dX);
modelStruct.modelPar_POGFACNUD=mod.POGFACNUD;
modelStruct.d_modelPar_POGFACNUD_dX=0.0;
modelStruct.modelPar_given_POGFACNUD=mod.given("POGFACNUD");
modParamMap["POGFACNUD"] = &(modelStruct.d_modelPar_POGFACNUD_dX);
modelStruct.modelPar_PLGFACNUD=mod.PLGFACNUD;
modelStruct.d_modelPar_PLGFACNUD_dX=0.0;
modelStruct.modelPar_given_PLGFACNUD=mod.given("PLGFACNUD");
modParamMap["PLGFACNUD"] = &(modelStruct.d_modelPar_PLGFACNUD_dX);
modelStruct.modelPar_PWGFACNUD=mod.PWGFACNUD;
modelStruct.d_modelPar_PWGFACNUD_dX=0.0;
modelStruct.modelPar_given_PWGFACNUD=mod.given("PWGFACNUD");
modParamMap["PWGFACNUD"] = &(modelStruct.d_modelPar_PWGFACNUD_dX);
modelStruct.modelPar_PLWGFACNUD=mod.PLWGFACNUD;
modelStruct.d_modelPar_PLWGFACNUD_dX=0.0;
modelStruct.modelPar_given_PLWGFACNUD=mod.given("PLWGFACNUD");
modParamMap["PLWGFACNUD"] = &(modelStruct.d_modelPar_PLWGFACNUD_dX);
modelStruct.modelPar_POVSBNUD=mod.POVSBNUD;
modelStruct.d_modelPar_POVSBNUD_dX=0.0;
modelStruct.modelPar_given_POVSBNUD=mod.given("POVSBNUD");
modParamMap["POVSBNUD"] = &(modelStruct.d_modelPar_POVSBNUD_dX);
modelStruct.modelPar_PODVSBNUD=mod.PODVSBNUD;
modelStruct.d_modelPar_PODVSBNUD_dX=0.0;
modelStruct.modelPar_given_PODVSBNUD=mod.given("PODVSBNUD");
modParamMap["PODVSBNUD"] = &(modelStruct.d_modelPar_PODVSBNUD_dX);
modelStruct.modelPar_POVNSUB=mod.POVNSUB;
modelStruct.d_modelPar_POVNSUB_dX=0.0;
modelStruct.modelPar_given_POVNSUB=mod.given("POVNSUB");
modParamMap["POVNSUB"] = &(modelStruct.d_modelPar_POVNSUB_dX);
modelStruct.modelPar_PONSLP=mod.PONSLP;
modelStruct.d_modelPar_PONSLP_dX=0.0;
modelStruct.modelPar_given_PONSLP=mod.given("PONSLP");
modParamMap["PONSLP"] = &(modelStruct.d_modelPar_PONSLP_dX);
modelStruct.modelPar_PODNSUB=mod.PODNSUB;
modelStruct.d_modelPar_PODNSUB_dX=0.0;
modelStruct.modelPar_given_PODNSUB=mod.given("PODNSUB");
modParamMap["PODNSUB"] = &(modelStruct.d_modelPar_PODNSUB_dX);
modelStruct.modelPar_PODPHIB=mod.PODPHIB;
modelStruct.d_modelPar_PODPHIB_dX=0.0;
modelStruct.modelPar_given_PODPHIB=mod.given("PODPHIB");
modParamMap["PODPHIB"] = &(modelStruct.d_modelPar_PODPHIB_dX);
modelStruct.modelPar_PLDPHIB=mod.PLDPHIB;
modelStruct.d_modelPar_PLDPHIB_dX=0.0;
modelStruct.modelPar_given_PLDPHIB=mod.given("PLDPHIB");
modParamMap["PLDPHIB"] = &(modelStruct.d_modelPar_PLDPHIB_dX);
modelStruct.modelPar_PWDPHIB=mod.PWDPHIB;
modelStruct.d_modelPar_PWDPHIB_dX=0.0;
modelStruct.modelPar_given_PWDPHIB=mod.given("PWDPHIB");
modParamMap["PWDPHIB"] = &(modelStruct.d_modelPar_PWDPHIB_dX);
modelStruct.modelPar_PLWDPHIB=mod.PLWDPHIB;
modelStruct.d_modelPar_PLWDPHIB_dX=0.0;
modelStruct.modelPar_given_PLWDPHIB=mod.given("PLWDPHIB");
modParamMap["PLWDPHIB"] = &(modelStruct.d_modelPar_PLWDPHIB_dX);
modelStruct.modelPar_PODELVTAC=mod.PODELVTAC;
modelStruct.d_modelPar_PODELVTAC_dX=0.0;
modelStruct.modelPar_given_PODELVTAC=mod.given("PODELVTAC");
modParamMap["PODELVTAC"] = &(modelStruct.d_modelPar_PODELVTAC_dX);
modelStruct.modelPar_PLDELVTAC=mod.PLDELVTAC;
modelStruct.d_modelPar_PLDELVTAC_dX=0.0;
modelStruct.modelPar_given_PLDELVTAC=mod.given("PLDELVTAC");
modParamMap["PLDELVTAC"] = &(modelStruct.d_modelPar_PLDELVTAC_dX);
modelStruct.modelPar_PWDELVTAC=mod.PWDELVTAC;
modelStruct.d_modelPar_PWDELVTAC_dX=0.0;
modelStruct.modelPar_given_PWDELVTAC=mod.given("PWDELVTAC");
modParamMap["PWDELVTAC"] = &(modelStruct.d_modelPar_PWDELVTAC_dX);
modelStruct.modelPar_PLWDELVTAC=mod.PLWDELVTAC;
modelStruct.d_modelPar_PLWDELVTAC_dX=0.0;
modelStruct.modelPar_given_PLWDELVTAC=mod.given("PLWDELVTAC");
modParamMap["PLWDELVTAC"] = &(modelStruct.d_modelPar_PLWDELVTAC_dX);
modelStruct.modelPar_PONP=mod.PONP;
modelStruct.d_modelPar_PONP_dX=0.0;
modelStruct.modelPar_given_PONP=mod.given("PONP");
modParamMap["PONP"] = &(modelStruct.d_modelPar_PONP_dX);
modelStruct.modelPar_PLNP=mod.PLNP;
modelStruct.d_modelPar_PLNP_dX=0.0;
modelStruct.modelPar_given_PLNP=mod.given("PLNP");
modParamMap["PLNP"] = &(modelStruct.d_modelPar_PLNP_dX);
modelStruct.modelPar_PWNP=mod.PWNP;
modelStruct.d_modelPar_PWNP_dX=0.0;
modelStruct.modelPar_given_PWNP=mod.given("PWNP");
modParamMap["PWNP"] = &(modelStruct.d_modelPar_PWNP_dX);
modelStruct.modelPar_PLWNP=mod.PLWNP;
modelStruct.d_modelPar_PLWNP_dX=0.0;
modelStruct.modelPar_given_PLWNP=mod.given("PLWNP");
modParamMap["PLWNP"] = &(modelStruct.d_modelPar_PLWNP_dX);
modelStruct.modelPar_POCT=mod.POCT;
modelStruct.d_modelPar_POCT_dX=0.0;
modelStruct.modelPar_given_POCT=mod.given("POCT");
modParamMap["POCT"] = &(modelStruct.d_modelPar_POCT_dX);
modelStruct.modelPar_PLCT=mod.PLCT;
modelStruct.d_modelPar_PLCT_dX=0.0;
modelStruct.modelPar_given_PLCT=mod.given("PLCT");
modParamMap["PLCT"] = &(modelStruct.d_modelPar_PLCT_dX);
modelStruct.modelPar_PWCT=mod.PWCT;
modelStruct.d_modelPar_PWCT_dX=0.0;
modelStruct.modelPar_given_PWCT=mod.given("PWCT");
modParamMap["PWCT"] = &(modelStruct.d_modelPar_PWCT_dX);
modelStruct.modelPar_PLWCT=mod.PLWCT;
modelStruct.d_modelPar_PLWCT_dX=0.0;
modelStruct.modelPar_given_PLWCT=mod.given("PLWCT");
modParamMap["PLWCT"] = &(modelStruct.d_modelPar_PLWCT_dX);
modelStruct.modelPar_POTOXOV=mod.POTOXOV;
modelStruct.d_modelPar_POTOXOV_dX=0.0;
modelStruct.modelPar_given_POTOXOV=mod.given("POTOXOV");
modParamMap["POTOXOV"] = &(modelStruct.d_modelPar_POTOXOV_dX);
modelStruct.modelPar_POTOXOVD=mod.POTOXOVD;
modelStruct.d_modelPar_POTOXOVD_dX=0.0;
modelStruct.modelPar_given_POTOXOVD=mod.given("POTOXOVD");
modParamMap["POTOXOVD"] = &(modelStruct.d_modelPar_POTOXOVD_dX);
modelStruct.modelPar_PONOV=mod.PONOV;
modelStruct.d_modelPar_PONOV_dX=0.0;
modelStruct.modelPar_given_PONOV=mod.given("PONOV");
modParamMap["PONOV"] = &(modelStruct.d_modelPar_PONOV_dX);
modelStruct.modelPar_PLNOV=mod.PLNOV;
modelStruct.d_modelPar_PLNOV_dX=0.0;
modelStruct.modelPar_given_PLNOV=mod.given("PLNOV");
modParamMap["PLNOV"] = &(modelStruct.d_modelPar_PLNOV_dX);
modelStruct.modelPar_PWNOV=mod.PWNOV;
modelStruct.d_modelPar_PWNOV_dX=0.0;
modelStruct.modelPar_given_PWNOV=mod.given("PWNOV");
modParamMap["PWNOV"] = &(modelStruct.d_modelPar_PWNOV_dX);
modelStruct.modelPar_PLWNOV=mod.PLWNOV;
modelStruct.d_modelPar_PLWNOV_dX=0.0;
modelStruct.modelPar_given_PLWNOV=mod.given("PLWNOV");
modParamMap["PLWNOV"] = &(modelStruct.d_modelPar_PLWNOV_dX);
modelStruct.modelPar_PONOVD=mod.PONOVD;
modelStruct.d_modelPar_PONOVD_dX=0.0;
modelStruct.modelPar_given_PONOVD=mod.given("PONOVD");
modParamMap["PONOVD"] = &(modelStruct.d_modelPar_PONOVD_dX);
modelStruct.modelPar_PLNOVD=mod.PLNOVD;
modelStruct.d_modelPar_PLNOVD_dX=0.0;
modelStruct.modelPar_given_PLNOVD=mod.given("PLNOVD");
modParamMap["PLNOVD"] = &(modelStruct.d_modelPar_PLNOVD_dX);
modelStruct.modelPar_PWNOVD=mod.PWNOVD;
modelStruct.d_modelPar_PWNOVD_dX=0.0;
modelStruct.modelPar_given_PWNOVD=mod.given("PWNOVD");
modParamMap["PWNOVD"] = &(modelStruct.d_modelPar_PWNOVD_dX);
modelStruct.modelPar_PLWNOVD=mod.PLWNOVD;
modelStruct.d_modelPar_PLWNOVD_dX=0.0;
modelStruct.modelPar_given_PLWNOVD=mod.given("PLWNOVD");
modParamMap["PLWNOVD"] = &(modelStruct.d_modelPar_PLWNOVD_dX);
modelStruct.modelPar_POCF=mod.POCF;
modelStruct.d_modelPar_POCF_dX=0.0;
modelStruct.modelPar_given_POCF=mod.given("POCF");
modParamMap["POCF"] = &(modelStruct.d_modelPar_POCF_dX);
modelStruct.modelPar_PLCF=mod.PLCF;
modelStruct.d_modelPar_PLCF_dX=0.0;
modelStruct.modelPar_given_PLCF=mod.given("PLCF");
modParamMap["PLCF"] = &(modelStruct.d_modelPar_PLCF_dX);
modelStruct.modelPar_PWCF=mod.PWCF;
modelStruct.d_modelPar_PWCF_dX=0.0;
modelStruct.modelPar_given_PWCF=mod.given("PWCF");
modParamMap["PWCF"] = &(modelStruct.d_modelPar_PWCF_dX);
modelStruct.modelPar_PLWCF=mod.PLWCF;
modelStruct.d_modelPar_PLWCF_dX=0.0;
modelStruct.modelPar_given_PLWCF=mod.given("PLWCF");
modParamMap["PLWCF"] = &(modelStruct.d_modelPar_PLWCF_dX);
modelStruct.modelPar_POCFD=mod.POCFD;
modelStruct.d_modelPar_POCFD_dX=0.0;
modelStruct.modelPar_given_POCFD=mod.given("POCFD");
modParamMap["POCFD"] = &(modelStruct.d_modelPar_POCFD_dX);
modelStruct.modelPar_POCFB=mod.POCFB;
modelStruct.d_modelPar_POCFB_dX=0.0;
modelStruct.modelPar_given_POCFB=mod.given("POCFB");
modParamMap["POCFB"] = &(modelStruct.d_modelPar_POCFB_dX);
modelStruct.modelPar_POPSCE=mod.POPSCE;
modelStruct.d_modelPar_POPSCE_dX=0.0;
modelStruct.modelPar_given_POPSCE=mod.given("POPSCE");
modParamMap["POPSCE"] = &(modelStruct.d_modelPar_POPSCE_dX);
modelStruct.modelPar_PLPSCE=mod.PLPSCE;
modelStruct.d_modelPar_PLPSCE_dX=0.0;
modelStruct.modelPar_given_PLPSCE=mod.given("PLPSCE");
modParamMap["PLPSCE"] = &(modelStruct.d_modelPar_PLPSCE_dX);
modelStruct.modelPar_PWPSCE=mod.PWPSCE;
modelStruct.d_modelPar_PWPSCE_dX=0.0;
modelStruct.modelPar_given_PWPSCE=mod.given("PWPSCE");
modParamMap["PWPSCE"] = &(modelStruct.d_modelPar_PWPSCE_dX);
modelStruct.modelPar_PLWPSCE=mod.PLWPSCE;
modelStruct.d_modelPar_PLWPSCE_dX=0.0;
modelStruct.modelPar_given_PLWPSCE=mod.given("PLWPSCE");
modParamMap["PLWPSCE"] = &(modelStruct.d_modelPar_PLWPSCE_dX);
modelStruct.modelPar_POPSCEB=mod.POPSCEB;
modelStruct.d_modelPar_POPSCEB_dX=0.0;
modelStruct.modelPar_given_POPSCEB=mod.given("POPSCEB");
modParamMap["POPSCEB"] = &(modelStruct.d_modelPar_POPSCEB_dX);
modelStruct.modelPar_POPSCED=mod.POPSCED;
modelStruct.d_modelPar_POPSCED_dX=0.0;
modelStruct.modelPar_given_POPSCED=mod.given("POPSCED");
modParamMap["POPSCED"] = &(modelStruct.d_modelPar_POPSCED_dX);
modelStruct.modelPar_POBETN=mod.POBETN;
modelStruct.d_modelPar_POBETN_dX=0.0;
modelStruct.modelPar_given_POBETN=mod.given("POBETN");
modParamMap["POBETN"] = &(modelStruct.d_modelPar_POBETN_dX);
modelStruct.modelPar_PLBETN=mod.PLBETN;
modelStruct.d_modelPar_PLBETN_dX=0.0;
modelStruct.modelPar_given_PLBETN=mod.given("PLBETN");
modParamMap["PLBETN"] = &(modelStruct.d_modelPar_PLBETN_dX);
modelStruct.modelPar_PWBETN=mod.PWBETN;
modelStruct.d_modelPar_PWBETN_dX=0.0;
modelStruct.modelPar_given_PWBETN=mod.given("PWBETN");
modParamMap["PWBETN"] = &(modelStruct.d_modelPar_PWBETN_dX);
modelStruct.modelPar_PLWBETN=mod.PLWBETN;
modelStruct.d_modelPar_PLWBETN_dX=0.0;
modelStruct.modelPar_given_PLWBETN=mod.given("PLWBETN");
modParamMap["PLWBETN"] = &(modelStruct.d_modelPar_PLWBETN_dX);
modelStruct.modelPar_POSTBET=mod.POSTBET;
modelStruct.d_modelPar_POSTBET_dX=0.0;
modelStruct.modelPar_given_POSTBET=mod.given("POSTBET");
modParamMap["POSTBET"] = &(modelStruct.d_modelPar_POSTBET_dX);
modelStruct.modelPar_PLSTBET=mod.PLSTBET;
modelStruct.d_modelPar_PLSTBET_dX=0.0;
modelStruct.modelPar_given_PLSTBET=mod.given("PLSTBET");
modParamMap["PLSTBET"] = &(modelStruct.d_modelPar_PLSTBET_dX);
modelStruct.modelPar_PWSTBET=mod.PWSTBET;
modelStruct.d_modelPar_PWSTBET_dX=0.0;
modelStruct.modelPar_given_PWSTBET=mod.given("PWSTBET");
modParamMap["PWSTBET"] = &(modelStruct.d_modelPar_PWSTBET_dX);
modelStruct.modelPar_PLWSTBET=mod.PLWSTBET;
modelStruct.d_modelPar_PLWSTBET_dX=0.0;
modelStruct.modelPar_given_PLWSTBET=mod.given("PLWSTBET");
modParamMap["PLWSTBET"] = &(modelStruct.d_modelPar_PLWSTBET_dX);
modelStruct.modelPar_POMUE=mod.POMUE;
modelStruct.d_modelPar_POMUE_dX=0.0;
modelStruct.modelPar_given_POMUE=mod.given("POMUE");
modParamMap["POMUE"] = &(modelStruct.d_modelPar_POMUE_dX);
modelStruct.modelPar_PLMUE=mod.PLMUE;
modelStruct.d_modelPar_PLMUE_dX=0.0;
modelStruct.modelPar_given_PLMUE=mod.given("PLMUE");
modParamMap["PLMUE"] = &(modelStruct.d_modelPar_PLMUE_dX);
modelStruct.modelPar_PWMUE=mod.PWMUE;
modelStruct.d_modelPar_PWMUE_dX=0.0;
modelStruct.modelPar_given_PWMUE=mod.given("PWMUE");
modParamMap["PWMUE"] = &(modelStruct.d_modelPar_PWMUE_dX);
modelStruct.modelPar_PLWMUE=mod.PLWMUE;
modelStruct.d_modelPar_PLWMUE_dX=0.0;
modelStruct.modelPar_given_PLWMUE=mod.given("PLWMUE");
modParamMap["PLWMUE"] = &(modelStruct.d_modelPar_PLWMUE_dX);
modelStruct.modelPar_POSTMUE=mod.POSTMUE;
modelStruct.d_modelPar_POSTMUE_dX=0.0;
modelStruct.modelPar_given_POSTMUE=mod.given("POSTMUE");
modParamMap["POSTMUE"] = &(modelStruct.d_modelPar_POSTMUE_dX);
modelStruct.modelPar_POTHEMU=mod.POTHEMU;
modelStruct.d_modelPar_POTHEMU_dX=0.0;
modelStruct.modelPar_given_POTHEMU=mod.given("POTHEMU");
modParamMap["POTHEMU"] = &(modelStruct.d_modelPar_POTHEMU_dX);
modelStruct.modelPar_POSTTHEMU=mod.POSTTHEMU;
modelStruct.d_modelPar_POSTTHEMU_dX=0.0;
modelStruct.modelPar_given_POSTTHEMU=mod.given("POSTTHEMU");
modParamMap["POSTTHEMU"] = &(modelStruct.d_modelPar_POSTTHEMU_dX);
modelStruct.modelPar_POCS=mod.POCS;
modelStruct.d_modelPar_POCS_dX=0.0;
modelStruct.modelPar_given_POCS=mod.given("POCS");
modParamMap["POCS"] = &(modelStruct.d_modelPar_POCS_dX);
modelStruct.modelPar_PLCS=mod.PLCS;
modelStruct.d_modelPar_PLCS_dX=0.0;
modelStruct.modelPar_given_PLCS=mod.given("PLCS");
modParamMap["PLCS"] = &(modelStruct.d_modelPar_PLCS_dX);
modelStruct.modelPar_PWCS=mod.PWCS;
modelStruct.d_modelPar_PWCS_dX=0.0;
modelStruct.modelPar_given_PWCS=mod.given("PWCS");
modParamMap["PWCS"] = &(modelStruct.d_modelPar_PWCS_dX);
modelStruct.modelPar_PLWCS=mod.PLWCS;
modelStruct.d_modelPar_PLWCS_dX=0.0;
modelStruct.modelPar_given_PLWCS=mod.given("PLWCS");
modParamMap["PLWCS"] = &(modelStruct.d_modelPar_PLWCS_dX);
modelStruct.modelPar_POSTCS=mod.POSTCS;
modelStruct.d_modelPar_POSTCS_dX=0.0;
modelStruct.modelPar_given_POSTCS=mod.given("POSTCS");
modParamMap["POSTCS"] = &(modelStruct.d_modelPar_POSTCS_dX);
modelStruct.modelPar_POXCOR=mod.POXCOR;
modelStruct.d_modelPar_POXCOR_dX=0.0;
modelStruct.modelPar_given_POXCOR=mod.given("POXCOR");
modParamMap["POXCOR"] = &(modelStruct.d_modelPar_POXCOR_dX);
modelStruct.modelPar_PLXCOR=mod.PLXCOR;
modelStruct.d_modelPar_PLXCOR_dX=0.0;
modelStruct.modelPar_given_PLXCOR=mod.given("PLXCOR");
modParamMap["PLXCOR"] = &(modelStruct.d_modelPar_PLXCOR_dX);
modelStruct.modelPar_PWXCOR=mod.PWXCOR;
modelStruct.d_modelPar_PWXCOR_dX=0.0;
modelStruct.modelPar_given_PWXCOR=mod.given("PWXCOR");
modParamMap["PWXCOR"] = &(modelStruct.d_modelPar_PWXCOR_dX);
modelStruct.modelPar_PLWXCOR=mod.PLWXCOR;
modelStruct.d_modelPar_PLWXCOR_dX=0.0;
modelStruct.modelPar_given_PLWXCOR=mod.given("PLWXCOR");
modParamMap["PLWXCOR"] = &(modelStruct.d_modelPar_PLWXCOR_dX);
modelStruct.modelPar_POSTXCOR=mod.POSTXCOR;
modelStruct.d_modelPar_POSTXCOR_dX=0.0;
modelStruct.modelPar_given_POSTXCOR=mod.given("POSTXCOR");
modParamMap["POSTXCOR"] = &(modelStruct.d_modelPar_POSTXCOR_dX);
modelStruct.modelPar_POFETA=mod.POFETA;
modelStruct.d_modelPar_POFETA_dX=0.0;
modelStruct.modelPar_given_POFETA=mod.given("POFETA");
modParamMap["POFETA"] = &(modelStruct.d_modelPar_POFETA_dX);
modelStruct.modelPar_PORS=mod.PORS;
modelStruct.d_modelPar_PORS_dX=0.0;
modelStruct.modelPar_given_PORS=mod.given("PORS");
modParamMap["PORS"] = &(modelStruct.d_modelPar_PORS_dX);
modelStruct.modelPar_PLRS=mod.PLRS;
modelStruct.d_modelPar_PLRS_dX=0.0;
modelStruct.modelPar_given_PLRS=mod.given("PLRS");
modParamMap["PLRS"] = &(modelStruct.d_modelPar_PLRS_dX);
modelStruct.modelPar_PWRS=mod.PWRS;
modelStruct.d_modelPar_PWRS_dX=0.0;
modelStruct.modelPar_given_PWRS=mod.given("PWRS");
modParamMap["PWRS"] = &(modelStruct.d_modelPar_PWRS_dX);
modelStruct.modelPar_PLWRS=mod.PLWRS;
modelStruct.d_modelPar_PLWRS_dX=0.0;
modelStruct.modelPar_given_PLWRS=mod.given("PLWRS");
modParamMap["PLWRS"] = &(modelStruct.d_modelPar_PLWRS_dX);
modelStruct.modelPar_POSTRS=mod.POSTRS;
modelStruct.d_modelPar_POSTRS_dX=0.0;
modelStruct.modelPar_given_POSTRS=mod.given("POSTRS");
modParamMap["POSTRS"] = &(modelStruct.d_modelPar_POSTRS_dX);
modelStruct.modelPar_PORSB=mod.PORSB;
modelStruct.d_modelPar_PORSB_dX=0.0;
modelStruct.modelPar_given_PORSB=mod.given("PORSB");
modParamMap["PORSB"] = &(modelStruct.d_modelPar_PORSB_dX);
modelStruct.modelPar_PORSG=mod.PORSG;
modelStruct.d_modelPar_PORSG_dX=0.0;
modelStruct.modelPar_given_PORSG=mod.given("PORSG");
modParamMap["PORSG"] = &(modelStruct.d_modelPar_PORSG_dX);
modelStruct.modelPar_POTHESAT=mod.POTHESAT;
modelStruct.d_modelPar_POTHESAT_dX=0.0;
modelStruct.modelPar_given_POTHESAT=mod.given("POTHESAT");
modParamMap["POTHESAT"] = &(modelStruct.d_modelPar_POTHESAT_dX);
modelStruct.modelPar_PLTHESAT=mod.PLTHESAT;
modelStruct.d_modelPar_PLTHESAT_dX=0.0;
modelStruct.modelPar_given_PLTHESAT=mod.given("PLTHESAT");
modParamMap["PLTHESAT"] = &(modelStruct.d_modelPar_PLTHESAT_dX);
modelStruct.modelPar_PWTHESAT=mod.PWTHESAT;
modelStruct.d_modelPar_PWTHESAT_dX=0.0;
modelStruct.modelPar_given_PWTHESAT=mod.given("PWTHESAT");
modParamMap["PWTHESAT"] = &(modelStruct.d_modelPar_PWTHESAT_dX);
modelStruct.modelPar_PLWTHESAT=mod.PLWTHESAT;
modelStruct.d_modelPar_PLWTHESAT_dX=0.0;
modelStruct.modelPar_given_PLWTHESAT=mod.given("PLWTHESAT");
modParamMap["PLWTHESAT"] = &(modelStruct.d_modelPar_PLWTHESAT_dX);
modelStruct.modelPar_POSTTHESAT=mod.POSTTHESAT;
modelStruct.d_modelPar_POSTTHESAT_dX=0.0;
modelStruct.modelPar_given_POSTTHESAT=mod.given("POSTTHESAT");
modParamMap["POSTTHESAT"] = &(modelStruct.d_modelPar_POSTTHESAT_dX);
modelStruct.modelPar_PLSTTHESAT=mod.PLSTTHESAT;
modelStruct.d_modelPar_PLSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PLSTTHESAT=mod.given("PLSTTHESAT");
modParamMap["PLSTTHESAT"] = &(modelStruct.d_modelPar_PLSTTHESAT_dX);
modelStruct.modelPar_PWSTTHESAT=mod.PWSTTHESAT;
modelStruct.d_modelPar_PWSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PWSTTHESAT=mod.given("PWSTTHESAT");
modParamMap["PWSTTHESAT"] = &(modelStruct.d_modelPar_PWSTTHESAT_dX);
modelStruct.modelPar_PLWSTTHESAT=mod.PLWSTTHESAT;
modelStruct.d_modelPar_PLWSTTHESAT_dX=0.0;
modelStruct.modelPar_given_PLWSTTHESAT=mod.given("PLWSTTHESAT");
modParamMap["PLWSTTHESAT"] = &(modelStruct.d_modelPar_PLWSTTHESAT_dX);
modelStruct.modelPar_POTHESATB=mod.POTHESATB;
modelStruct.d_modelPar_POTHESATB_dX=0.0;
modelStruct.modelPar_given_POTHESATB=mod.given("POTHESATB");
modParamMap["POTHESATB"] = &(modelStruct.d_modelPar_POTHESATB_dX);
modelStruct.modelPar_PLTHESATB=mod.PLTHESATB;
modelStruct.d_modelPar_PLTHESATB_dX=0.0;
modelStruct.modelPar_given_PLTHESATB=mod.given("PLTHESATB");
modParamMap["PLTHESATB"] = &(modelStruct.d_modelPar_PLTHESATB_dX);
modelStruct.modelPar_PWTHESATB=mod.PWTHESATB;
modelStruct.d_modelPar_PWTHESATB_dX=0.0;
modelStruct.modelPar_given_PWTHESATB=mod.given("PWTHESATB");
modParamMap["PWTHESATB"] = &(modelStruct.d_modelPar_PWTHESATB_dX);
modelStruct.modelPar_PLWTHESATB=mod.PLWTHESATB;
modelStruct.d_modelPar_PLWTHESATB_dX=0.0;
modelStruct.modelPar_given_PLWTHESATB=mod.given("PLWTHESATB");
modParamMap["PLWTHESATB"] = &(modelStruct.d_modelPar_PLWTHESATB_dX);
modelStruct.modelPar_POTHESATG=mod.POTHESATG;
modelStruct.d_modelPar_POTHESATG_dX=0.0;
modelStruct.modelPar_given_POTHESATG=mod.given("POTHESATG");
modParamMap["POTHESATG"] = &(modelStruct.d_modelPar_POTHESATG_dX);
modelStruct.modelPar_PLTHESATG=mod.PLTHESATG;
modelStruct.d_modelPar_PLTHESATG_dX=0.0;
modelStruct.modelPar_given_PLTHESATG=mod.given("PLTHESATG");
modParamMap["PLTHESATG"] = &(modelStruct.d_modelPar_PLTHESATG_dX);
modelStruct.modelPar_PWTHESATG=mod.PWTHESATG;
modelStruct.d_modelPar_PWTHESATG_dX=0.0;
modelStruct.modelPar_given_PWTHESATG=mod.given("PWTHESATG");
modParamMap["PWTHESATG"] = &(modelStruct.d_modelPar_PWTHESATG_dX);
modelStruct.modelPar_PLWTHESATG=mod.PLWTHESATG;
modelStruct.d_modelPar_PLWTHESATG_dX=0.0;
modelStruct.modelPar_given_PLWTHESATG=mod.given("PLWTHESATG");
modParamMap["PLWTHESATG"] = &(modelStruct.d_modelPar_PLWTHESATG_dX);
modelStruct.modelPar_POAX=mod.POAX;
modelStruct.d_modelPar_POAX_dX=0.0;
modelStruct.modelPar_given_POAX=mod.given("POAX");
modParamMap["POAX"] = &(modelStruct.d_modelPar_POAX_dX);
modelStruct.modelPar_PLAX=mod.PLAX;
modelStruct.d_modelPar_PLAX_dX=0.0;
modelStruct.modelPar_given_PLAX=mod.given("PLAX");
modParamMap["PLAX"] = &(modelStruct.d_modelPar_PLAX_dX);
modelStruct.modelPar_PWAX=mod.PWAX;
modelStruct.d_modelPar_PWAX_dX=0.0;
modelStruct.modelPar_given_PWAX=mod.given("PWAX");
modParamMap["PWAX"] = &(modelStruct.d_modelPar_PWAX_dX);
modelStruct.modelPar_PLWAX=mod.PLWAX;
modelStruct.d_modelPar_PLWAX_dX=0.0;
modelStruct.modelPar_given_PLWAX=mod.given("PLWAX");
modParamMap["PLWAX"] = &(modelStruct.d_modelPar_PLWAX_dX);
modelStruct.modelPar_POALP=mod.POALP;
modelStruct.d_modelPar_POALP_dX=0.0;
modelStruct.modelPar_given_POALP=mod.given("POALP");
modParamMap["POALP"] = &(modelStruct.d_modelPar_POALP_dX);
modelStruct.modelPar_PLALP=mod.PLALP;
modelStruct.d_modelPar_PLALP_dX=0.0;
modelStruct.modelPar_given_PLALP=mod.given("PLALP");
modParamMap["PLALP"] = &(modelStruct.d_modelPar_PLALP_dX);
modelStruct.modelPar_PWALP=mod.PWALP;
modelStruct.d_modelPar_PWALP_dX=0.0;
modelStruct.modelPar_given_PWALP=mod.given("PWALP");
modParamMap["PWALP"] = &(modelStruct.d_modelPar_PWALP_dX);
modelStruct.modelPar_PLWALP=mod.PLWALP;
modelStruct.d_modelPar_PLWALP_dX=0.0;
modelStruct.modelPar_given_PLWALP=mod.given("PLWALP");
modParamMap["PLWALP"] = &(modelStruct.d_modelPar_PLWALP_dX);
modelStruct.modelPar_POALP1=mod.POALP1;
modelStruct.d_modelPar_POALP1_dX=0.0;
modelStruct.modelPar_given_POALP1=mod.given("POALP1");
modParamMap["POALP1"] = &(modelStruct.d_modelPar_POALP1_dX);
modelStruct.modelPar_PLALP1=mod.PLALP1;
modelStruct.d_modelPar_PLALP1_dX=0.0;
modelStruct.modelPar_given_PLALP1=mod.given("PLALP1");
modParamMap["PLALP1"] = &(modelStruct.d_modelPar_PLALP1_dX);
modelStruct.modelPar_PWALP1=mod.PWALP1;
modelStruct.d_modelPar_PWALP1_dX=0.0;
modelStruct.modelPar_given_PWALP1=mod.given("PWALP1");
modParamMap["PWALP1"] = &(modelStruct.d_modelPar_PWALP1_dX);
modelStruct.modelPar_PLWALP1=mod.PLWALP1;
modelStruct.d_modelPar_PLWALP1_dX=0.0;
modelStruct.modelPar_given_PLWALP1=mod.given("PLWALP1");
modParamMap["PLWALP1"] = &(modelStruct.d_modelPar_PLWALP1_dX);
modelStruct.modelPar_POALP2=mod.POALP2;
modelStruct.d_modelPar_POALP2_dX=0.0;
modelStruct.modelPar_given_POALP2=mod.given("POALP2");
modParamMap["POALP2"] = &(modelStruct.d_modelPar_POALP2_dX);
modelStruct.modelPar_PLALP2=mod.PLALP2;
modelStruct.d_modelPar_PLALP2_dX=0.0;
modelStruct.modelPar_given_PLALP2=mod.given("PLALP2");
modParamMap["PLALP2"] = &(modelStruct.d_modelPar_PLALP2_dX);
modelStruct.modelPar_PWALP2=mod.PWALP2;
modelStruct.d_modelPar_PWALP2_dX=0.0;
modelStruct.modelPar_given_PWALP2=mod.given("PWALP2");
modParamMap["PWALP2"] = &(modelStruct.d_modelPar_PWALP2_dX);
modelStruct.modelPar_PLWALP2=mod.PLWALP2;
modelStruct.d_modelPar_PLWALP2_dX=0.0;
modelStruct.modelPar_given_PLWALP2=mod.given("PLWALP2");
modParamMap["PLWALP2"] = &(modelStruct.d_modelPar_PLWALP2_dX);
modelStruct.modelPar_POVP=mod.POVP;
modelStruct.d_modelPar_POVP_dX=0.0;
modelStruct.modelPar_given_POVP=mod.given("POVP");
modParamMap["POVP"] = &(modelStruct.d_modelPar_POVP_dX);
modelStruct.modelPar_POA1=mod.POA1;
modelStruct.d_modelPar_POA1_dX=0.0;
modelStruct.modelPar_given_POA1=mod.given("POA1");
modParamMap["POA1"] = &(modelStruct.d_modelPar_POA1_dX);
modelStruct.modelPar_PLA1=mod.PLA1;
modelStruct.d_modelPar_PLA1_dX=0.0;
modelStruct.modelPar_given_PLA1=mod.given("PLA1");
modParamMap["PLA1"] = &(modelStruct.d_modelPar_PLA1_dX);
modelStruct.modelPar_PWA1=mod.PWA1;
modelStruct.d_modelPar_PWA1_dX=0.0;
modelStruct.modelPar_given_PWA1=mod.given("PWA1");
modParamMap["PWA1"] = &(modelStruct.d_modelPar_PWA1_dX);
modelStruct.modelPar_PLWA1=mod.PLWA1;
modelStruct.d_modelPar_PLWA1_dX=0.0;
modelStruct.modelPar_given_PLWA1=mod.given("PLWA1");
modParamMap["PLWA1"] = &(modelStruct.d_modelPar_PLWA1_dX);
modelStruct.modelPar_POA2=mod.POA2;
modelStruct.d_modelPar_POA2_dX=0.0;
modelStruct.modelPar_given_POA2=mod.given("POA2");
modParamMap["POA2"] = &(modelStruct.d_modelPar_POA2_dX);
modelStruct.modelPar_POSTA2=mod.POSTA2;
modelStruct.d_modelPar_POSTA2_dX=0.0;
modelStruct.modelPar_given_POSTA2=mod.given("POSTA2");
modParamMap["POSTA2"] = &(modelStruct.d_modelPar_POSTA2_dX);
modelStruct.modelPar_POA3=mod.POA3;
modelStruct.d_modelPar_POA3_dX=0.0;
modelStruct.modelPar_given_POA3=mod.given("POA3");
modParamMap["POA3"] = &(modelStruct.d_modelPar_POA3_dX);
modelStruct.modelPar_PLA3=mod.PLA3;
modelStruct.d_modelPar_PLA3_dX=0.0;
modelStruct.modelPar_given_PLA3=mod.given("PLA3");
modParamMap["PLA3"] = &(modelStruct.d_modelPar_PLA3_dX);
modelStruct.modelPar_PWA3=mod.PWA3;
modelStruct.d_modelPar_PWA3_dX=0.0;
modelStruct.modelPar_given_PWA3=mod.given("PWA3");
modParamMap["PWA3"] = &(modelStruct.d_modelPar_PWA3_dX);
modelStruct.modelPar_PLWA3=mod.PLWA3;
modelStruct.d_modelPar_PLWA3_dX=0.0;
modelStruct.modelPar_given_PLWA3=mod.given("PLWA3");
modParamMap["PLWA3"] = &(modelStruct.d_modelPar_PLWA3_dX);
modelStruct.modelPar_POA4=mod.POA4;
modelStruct.d_modelPar_POA4_dX=0.0;
modelStruct.modelPar_given_POA4=mod.given("POA4");
modParamMap["POA4"] = &(modelStruct.d_modelPar_POA4_dX);
modelStruct.modelPar_PLA4=mod.PLA4;
modelStruct.d_modelPar_PLA4_dX=0.0;
modelStruct.modelPar_given_PLA4=mod.given("PLA4");
modParamMap["PLA4"] = &(modelStruct.d_modelPar_PLA4_dX);
modelStruct.modelPar_PWA4=mod.PWA4;
modelStruct.d_modelPar_PWA4_dX=0.0;
modelStruct.modelPar_given_PWA4=mod.given("PWA4");
modParamMap["PWA4"] = &(modelStruct.d_modelPar_PWA4_dX);
modelStruct.modelPar_PLWA4=mod.PLWA4;
modelStruct.d_modelPar_PLWA4_dX=0.0;
modelStruct.modelPar_given_PLWA4=mod.given("PLWA4");
modParamMap["PLWA4"] = &(modelStruct.d_modelPar_PLWA4_dX);
modelStruct.modelPar_POGCO=mod.POGCO;
modelStruct.d_modelPar_POGCO_dX=0.0;
modelStruct.modelPar_given_POGCO=mod.given("POGCO");
modParamMap["POGCO"] = &(modelStruct.d_modelPar_POGCO_dX);
modelStruct.modelPar_POIGINV=mod.POIGINV;
modelStruct.d_modelPar_POIGINV_dX=0.0;
modelStruct.modelPar_given_POIGINV=mod.given("POIGINV");
modParamMap["POIGINV"] = &(modelStruct.d_modelPar_POIGINV_dX);
modelStruct.modelPar_PLIGINV=mod.PLIGINV;
modelStruct.d_modelPar_PLIGINV_dX=0.0;
modelStruct.modelPar_given_PLIGINV=mod.given("PLIGINV");
modParamMap["PLIGINV"] = &(modelStruct.d_modelPar_PLIGINV_dX);
modelStruct.modelPar_PWIGINV=mod.PWIGINV;
modelStruct.d_modelPar_PWIGINV_dX=0.0;
modelStruct.modelPar_given_PWIGINV=mod.given("PWIGINV");
modParamMap["PWIGINV"] = &(modelStruct.d_modelPar_PWIGINV_dX);
modelStruct.modelPar_PLWIGINV=mod.PLWIGINV;
modelStruct.d_modelPar_PLWIGINV_dX=0.0;
modelStruct.modelPar_given_PLWIGINV=mod.given("PLWIGINV");
modParamMap["PLWIGINV"] = &(modelStruct.d_modelPar_PLWIGINV_dX);
modelStruct.modelPar_POIGOV=mod.POIGOV;
modelStruct.d_modelPar_POIGOV_dX=0.0;
modelStruct.modelPar_given_POIGOV=mod.given("POIGOV");
modParamMap["POIGOV"] = &(modelStruct.d_modelPar_POIGOV_dX);
modelStruct.modelPar_PLIGOV=mod.PLIGOV;
modelStruct.d_modelPar_PLIGOV_dX=0.0;
modelStruct.modelPar_given_PLIGOV=mod.given("PLIGOV");
modParamMap["PLIGOV"] = &(modelStruct.d_modelPar_PLIGOV_dX);
modelStruct.modelPar_PWIGOV=mod.PWIGOV;
modelStruct.d_modelPar_PWIGOV_dX=0.0;
modelStruct.modelPar_given_PWIGOV=mod.given("PWIGOV");
modParamMap["PWIGOV"] = &(modelStruct.d_modelPar_PWIGOV_dX);
modelStruct.modelPar_PLWIGOV=mod.PLWIGOV;
modelStruct.d_modelPar_PLWIGOV_dX=0.0;
modelStruct.modelPar_given_PLWIGOV=mod.given("PLWIGOV");
modParamMap["PLWIGOV"] = &(modelStruct.d_modelPar_PLWIGOV_dX);
modelStruct.modelPar_POIGOVD=mod.POIGOVD;
modelStruct.d_modelPar_POIGOVD_dX=0.0;
modelStruct.modelPar_given_POIGOVD=mod.given("POIGOVD");
modParamMap["POIGOVD"] = &(modelStruct.d_modelPar_POIGOVD_dX);
modelStruct.modelPar_PLIGOVD=mod.PLIGOVD;
modelStruct.d_modelPar_PLIGOVD_dX=0.0;
modelStruct.modelPar_given_PLIGOVD=mod.given("PLIGOVD");
modParamMap["PLIGOVD"] = &(modelStruct.d_modelPar_PLIGOVD_dX);
modelStruct.modelPar_PWIGOVD=mod.PWIGOVD;
modelStruct.d_modelPar_PWIGOVD_dX=0.0;
modelStruct.modelPar_given_PWIGOVD=mod.given("PWIGOVD");
modParamMap["PWIGOVD"] = &(modelStruct.d_modelPar_PWIGOVD_dX);
modelStruct.modelPar_PLWIGOVD=mod.PLWIGOVD;
modelStruct.d_modelPar_PLWIGOVD_dX=0.0;
modelStruct.modelPar_given_PLWIGOVD=mod.given("PLWIGOVD");
modParamMap["PLWIGOVD"] = &(modelStruct.d_modelPar_PLWIGOVD_dX);
modelStruct.modelPar_POSTIG=mod.POSTIG;
modelStruct.d_modelPar_POSTIG_dX=0.0;
modelStruct.modelPar_given_POSTIG=mod.given("POSTIG");
modParamMap["POSTIG"] = &(modelStruct.d_modelPar_POSTIG_dX);
modelStruct.modelPar_POGC2=mod.POGC2;
modelStruct.d_modelPar_POGC2_dX=0.0;
modelStruct.modelPar_given_POGC2=mod.given("POGC2");
modParamMap["POGC2"] = &(modelStruct.d_modelPar_POGC2_dX);
modelStruct.modelPar_POGC3=mod.POGC3;
modelStruct.d_modelPar_POGC3_dX=0.0;
modelStruct.modelPar_given_POGC3=mod.given("POGC3");
modParamMap["POGC3"] = &(modelStruct.d_modelPar_POGC3_dX);
modelStruct.modelPar_POCHIB=mod.POCHIB;
modelStruct.d_modelPar_POCHIB_dX=0.0;
modelStruct.modelPar_given_POCHIB=mod.given("POCHIB");
modParamMap["POCHIB"] = &(modelStruct.d_modelPar_POCHIB_dX);
modelStruct.modelPar_POAGIDL=mod.POAGIDL;
modelStruct.d_modelPar_POAGIDL_dX=0.0;
modelStruct.modelPar_given_POAGIDL=mod.given("POAGIDL");
modParamMap["POAGIDL"] = &(modelStruct.d_modelPar_POAGIDL_dX);
modelStruct.modelPar_PLAGIDL=mod.PLAGIDL;
modelStruct.d_modelPar_PLAGIDL_dX=0.0;
modelStruct.modelPar_given_PLAGIDL=mod.given("PLAGIDL");
modParamMap["PLAGIDL"] = &(modelStruct.d_modelPar_PLAGIDL_dX);
modelStruct.modelPar_PWAGIDL=mod.PWAGIDL;
modelStruct.d_modelPar_PWAGIDL_dX=0.0;
modelStruct.modelPar_given_PWAGIDL=mod.given("PWAGIDL");
modParamMap["PWAGIDL"] = &(modelStruct.d_modelPar_PWAGIDL_dX);
modelStruct.modelPar_PLWAGIDL=mod.PLWAGIDL;
modelStruct.d_modelPar_PLWAGIDL_dX=0.0;
modelStruct.modelPar_given_PLWAGIDL=mod.given("PLWAGIDL");
modParamMap["PLWAGIDL"] = &(modelStruct.d_modelPar_PLWAGIDL_dX);
modelStruct.modelPar_POAGIDLD=mod.POAGIDLD;
modelStruct.d_modelPar_POAGIDLD_dX=0.0;
modelStruct.modelPar_given_POAGIDLD=mod.given("POAGIDLD");
modParamMap["POAGIDLD"] = &(modelStruct.d_modelPar_POAGIDLD_dX);
modelStruct.modelPar_PLAGIDLD=mod.PLAGIDLD;
modelStruct.d_modelPar_PLAGIDLD_dX=0.0;
modelStruct.modelPar_given_PLAGIDLD=mod.given("PLAGIDLD");
modParamMap["PLAGIDLD"] = &(modelStruct.d_modelPar_PLAGIDLD_dX);
modelStruct.modelPar_PWAGIDLD=mod.PWAGIDLD;
modelStruct.d_modelPar_PWAGIDLD_dX=0.0;
modelStruct.modelPar_given_PWAGIDLD=mod.given("PWAGIDLD");
modParamMap["PWAGIDLD"] = &(modelStruct.d_modelPar_PWAGIDLD_dX);
modelStruct.modelPar_PLWAGIDLD=mod.PLWAGIDLD;
modelStruct.d_modelPar_PLWAGIDLD_dX=0.0;
modelStruct.modelPar_given_PLWAGIDLD=mod.given("PLWAGIDLD");
modParamMap["PLWAGIDLD"] = &(modelStruct.d_modelPar_PLWAGIDLD_dX);
modelStruct.modelPar_POBGIDL=mod.POBGIDL;
modelStruct.d_modelPar_POBGIDL_dX=0.0;
modelStruct.modelPar_given_POBGIDL=mod.given("POBGIDL");
modParamMap["POBGIDL"] = &(modelStruct.d_modelPar_POBGIDL_dX);
modelStruct.modelPar_POBGIDLD=mod.POBGIDLD;
modelStruct.d_modelPar_POBGIDLD_dX=0.0;
modelStruct.modelPar_given_POBGIDLD=mod.given("POBGIDLD");
modParamMap["POBGIDLD"] = &(modelStruct.d_modelPar_POBGIDLD_dX);
modelStruct.modelPar_POSTBGIDL=mod.POSTBGIDL;
modelStruct.d_modelPar_POSTBGIDL_dX=0.0;
modelStruct.modelPar_given_POSTBGIDL=mod.given("POSTBGIDL");
modParamMap["POSTBGIDL"] = &(modelStruct.d_modelPar_POSTBGIDL_dX);
modelStruct.modelPar_POSTBGIDLD=mod.POSTBGIDLD;
modelStruct.d_modelPar_POSTBGIDLD_dX=0.0;
modelStruct.modelPar_given_POSTBGIDLD=mod.given("POSTBGIDLD");
modParamMap["POSTBGIDLD"] = &(modelStruct.d_modelPar_POSTBGIDLD_dX);
modelStruct.modelPar_POCGIDL=mod.POCGIDL;
modelStruct.d_modelPar_POCGIDL_dX=0.0;
modelStruct.modelPar_given_POCGIDL=mod.given("POCGIDL");
modParamMap["POCGIDL"] = &(modelStruct.d_modelPar_POCGIDL_dX);
modelStruct.modelPar_POCGIDLD=mod.POCGIDLD;
modelStruct.d_modelPar_POCGIDLD_dX=0.0;
modelStruct.modelPar_given_POCGIDLD=mod.given("POCGIDLD");
modParamMap["POCGIDLD"] = &(modelStruct.d_modelPar_POCGIDLD_dX);
modelStruct.modelPar_POCOX=mod.POCOX;
modelStruct.d_modelPar_POCOX_dX=0.0;
modelStruct.modelPar_given_POCOX=mod.given("POCOX");
modParamMap["POCOX"] = &(modelStruct.d_modelPar_POCOX_dX);
modelStruct.modelPar_PLCOX=mod.PLCOX;
modelStruct.d_modelPar_PLCOX_dX=0.0;
modelStruct.modelPar_given_PLCOX=mod.given("PLCOX");
modParamMap["PLCOX"] = &(modelStruct.d_modelPar_PLCOX_dX);
modelStruct.modelPar_PWCOX=mod.PWCOX;
modelStruct.d_modelPar_PWCOX_dX=0.0;
modelStruct.modelPar_given_PWCOX=mod.given("PWCOX");
modParamMap["PWCOX"] = &(modelStruct.d_modelPar_PWCOX_dX);
modelStruct.modelPar_PLWCOX=mod.PLWCOX;
modelStruct.d_modelPar_PLWCOX_dX=0.0;
modelStruct.modelPar_given_PLWCOX=mod.given("PLWCOX");
modParamMap["PLWCOX"] = &(modelStruct.d_modelPar_PLWCOX_dX);
modelStruct.modelPar_POCGOV=mod.POCGOV;
modelStruct.d_modelPar_POCGOV_dX=0.0;
modelStruct.modelPar_given_POCGOV=mod.given("POCGOV");
modParamMap["POCGOV"] = &(modelStruct.d_modelPar_POCGOV_dX);
modelStruct.modelPar_PLCGOV=mod.PLCGOV;
modelStruct.d_modelPar_PLCGOV_dX=0.0;
modelStruct.modelPar_given_PLCGOV=mod.given("PLCGOV");
modParamMap["PLCGOV"] = &(modelStruct.d_modelPar_PLCGOV_dX);
modelStruct.modelPar_PWCGOV=mod.PWCGOV;
modelStruct.d_modelPar_PWCGOV_dX=0.0;
modelStruct.modelPar_given_PWCGOV=mod.given("PWCGOV");
modParamMap["PWCGOV"] = &(modelStruct.d_modelPar_PWCGOV_dX);
modelStruct.modelPar_PLWCGOV=mod.PLWCGOV;
modelStruct.d_modelPar_PLWCGOV_dX=0.0;
modelStruct.modelPar_given_PLWCGOV=mod.given("PLWCGOV");
modParamMap["PLWCGOV"] = &(modelStruct.d_modelPar_PLWCGOV_dX);
modelStruct.modelPar_POCGOVD=mod.POCGOVD;
modelStruct.d_modelPar_POCGOVD_dX=0.0;
modelStruct.modelPar_given_POCGOVD=mod.given("POCGOVD");
modParamMap["POCGOVD"] = &(modelStruct.d_modelPar_POCGOVD_dX);
modelStruct.modelPar_PLCGOVD=mod.PLCGOVD;
modelStruct.d_modelPar_PLCGOVD_dX=0.0;
modelStruct.modelPar_given_PLCGOVD=mod.given("PLCGOVD");
modParamMap["PLCGOVD"] = &(modelStruct.d_modelPar_PLCGOVD_dX);
modelStruct.modelPar_PWCGOVD=mod.PWCGOVD;
modelStruct.d_modelPar_PWCGOVD_dX=0.0;
modelStruct.modelPar_given_PWCGOVD=mod.given("PWCGOVD");
modParamMap["PWCGOVD"] = &(modelStruct.d_modelPar_PWCGOVD_dX);
modelStruct.modelPar_PLWCGOVD=mod.PLWCGOVD;
modelStruct.d_modelPar_PLWCGOVD_dX=0.0;
modelStruct.modelPar_given_PLWCGOVD=mod.given("PLWCGOVD");
modParamMap["PLWCGOVD"] = &(modelStruct.d_modelPar_PLWCGOVD_dX);
modelStruct.modelPar_POCGBOV=mod.POCGBOV;
modelStruct.d_modelPar_POCGBOV_dX=0.0;
modelStruct.modelPar_given_POCGBOV=mod.given("POCGBOV");
modParamMap["POCGBOV"] = &(modelStruct.d_modelPar_POCGBOV_dX);
modelStruct.modelPar_PLCGBOV=mod.PLCGBOV;
modelStruct.d_modelPar_PLCGBOV_dX=0.0;
modelStruct.modelPar_given_PLCGBOV=mod.given("PLCGBOV");
modParamMap["PLCGBOV"] = &(modelStruct.d_modelPar_PLCGBOV_dX);
modelStruct.modelPar_PWCGBOV=mod.PWCGBOV;
modelStruct.d_modelPar_PWCGBOV_dX=0.0;
modelStruct.modelPar_given_PWCGBOV=mod.given("PWCGBOV");
modParamMap["PWCGBOV"] = &(modelStruct.d_modelPar_PWCGBOV_dX);
modelStruct.modelPar_PLWCGBOV=mod.PLWCGBOV;
modelStruct.d_modelPar_PLWCGBOV_dX=0.0;
modelStruct.modelPar_given_PLWCGBOV=mod.given("PLWCGBOV");
modParamMap["PLWCGBOV"] = &(modelStruct.d_modelPar_PLWCGBOV_dX);
modelStruct.modelPar_POCFR=mod.POCFR;
modelStruct.d_modelPar_POCFR_dX=0.0;
modelStruct.modelPar_given_POCFR=mod.given("POCFR");
modParamMap["POCFR"] = &(modelStruct.d_modelPar_POCFR_dX);
modelStruct.modelPar_PLCFR=mod.PLCFR;
modelStruct.d_modelPar_PLCFR_dX=0.0;
modelStruct.modelPar_given_PLCFR=mod.given("PLCFR");
modParamMap["PLCFR"] = &(modelStruct.d_modelPar_PLCFR_dX);
modelStruct.modelPar_PWCFR=mod.PWCFR;
modelStruct.d_modelPar_PWCFR_dX=0.0;
modelStruct.modelPar_given_PWCFR=mod.given("PWCFR");
modParamMap["PWCFR"] = &(modelStruct.d_modelPar_PWCFR_dX);
modelStruct.modelPar_PLWCFR=mod.PLWCFR;
modelStruct.d_modelPar_PLWCFR_dX=0.0;
modelStruct.modelPar_given_PLWCFR=mod.given("PLWCFR");
modParamMap["PLWCFR"] = &(modelStruct.d_modelPar_PLWCFR_dX);
modelStruct.modelPar_POCFRD=mod.POCFRD;
modelStruct.d_modelPar_POCFRD_dX=0.0;
modelStruct.modelPar_given_POCFRD=mod.given("POCFRD");
modParamMap["POCFRD"] = &(modelStruct.d_modelPar_POCFRD_dX);
modelStruct.modelPar_PLCFRD=mod.PLCFRD;
modelStruct.d_modelPar_PLCFRD_dX=0.0;
modelStruct.modelPar_given_PLCFRD=mod.given("PLCFRD");
modParamMap["PLCFRD"] = &(modelStruct.d_modelPar_PLCFRD_dX);
modelStruct.modelPar_PWCFRD=mod.PWCFRD;
modelStruct.d_modelPar_PWCFRD_dX=0.0;
modelStruct.modelPar_given_PWCFRD=mod.given("PWCFRD");
modParamMap["PWCFRD"] = &(modelStruct.d_modelPar_PWCFRD_dX);
modelStruct.modelPar_PLWCFRD=mod.PLWCFRD;
modelStruct.d_modelPar_PLWCFRD_dX=0.0;
modelStruct.modelPar_given_PLWCFRD=mod.given("PLWCFRD");
modParamMap["PLWCFRD"] = &(modelStruct.d_modelPar_PLWCFRD_dX);
modelStruct.modelPar_POFNT=mod.POFNT;
modelStruct.d_modelPar_POFNT_dX=0.0;
modelStruct.modelPar_given_POFNT=mod.given("POFNT");
modParamMap["POFNT"] = &(modelStruct.d_modelPar_POFNT_dX);
modelStruct.modelPar_POFNTEXC=mod.POFNTEXC;
modelStruct.d_modelPar_POFNTEXC_dX=0.0;
modelStruct.modelPar_given_POFNTEXC=mod.given("POFNTEXC");
modParamMap["POFNTEXC"] = &(modelStruct.d_modelPar_POFNTEXC_dX);
modelStruct.modelPar_PLFNTEXC=mod.PLFNTEXC;
modelStruct.d_modelPar_PLFNTEXC_dX=0.0;
modelStruct.modelPar_given_PLFNTEXC=mod.given("PLFNTEXC");
modParamMap["PLFNTEXC"] = &(modelStruct.d_modelPar_PLFNTEXC_dX);
modelStruct.modelPar_PWFNTEXC=mod.PWFNTEXC;
modelStruct.d_modelPar_PWFNTEXC_dX=0.0;
modelStruct.modelPar_given_PWFNTEXC=mod.given("PWFNTEXC");
modParamMap["PWFNTEXC"] = &(modelStruct.d_modelPar_PWFNTEXC_dX);
modelStruct.modelPar_PLWFNTEXC=mod.PLWFNTEXC;
modelStruct.d_modelPar_PLWFNTEXC_dX=0.0;
modelStruct.modelPar_given_PLWFNTEXC=mod.given("PLWFNTEXC");
modParamMap["PLWFNTEXC"] = &(modelStruct.d_modelPar_PLWFNTEXC_dX);
modelStruct.modelPar_PONFA=mod.PONFA;
modelStruct.d_modelPar_PONFA_dX=0.0;
modelStruct.modelPar_given_PONFA=mod.given("PONFA");
modParamMap["PONFA"] = &(modelStruct.d_modelPar_PONFA_dX);
modelStruct.modelPar_PLNFA=mod.PLNFA;
modelStruct.d_modelPar_PLNFA_dX=0.0;
modelStruct.modelPar_given_PLNFA=mod.given("PLNFA");
modParamMap["PLNFA"] = &(modelStruct.d_modelPar_PLNFA_dX);
modelStruct.modelPar_PWNFA=mod.PWNFA;
modelStruct.d_modelPar_PWNFA_dX=0.0;
modelStruct.modelPar_given_PWNFA=mod.given("PWNFA");
modParamMap["PWNFA"] = &(modelStruct.d_modelPar_PWNFA_dX);
modelStruct.modelPar_PLWNFA=mod.PLWNFA;
modelStruct.d_modelPar_PLWNFA_dX=0.0;
modelStruct.modelPar_given_PLWNFA=mod.given("PLWNFA");
modParamMap["PLWNFA"] = &(modelStruct.d_modelPar_PLWNFA_dX);
modelStruct.modelPar_PONFB=mod.PONFB;
modelStruct.d_modelPar_PONFB_dX=0.0;
modelStruct.modelPar_given_PONFB=mod.given("PONFB");
modParamMap["PONFB"] = &(modelStruct.d_modelPar_PONFB_dX);
modelStruct.modelPar_PLNFB=mod.PLNFB;
modelStruct.d_modelPar_PLNFB_dX=0.0;
modelStruct.modelPar_given_PLNFB=mod.given("PLNFB");
modParamMap["PLNFB"] = &(modelStruct.d_modelPar_PLNFB_dX);
modelStruct.modelPar_PWNFB=mod.PWNFB;
modelStruct.d_modelPar_PWNFB_dX=0.0;
modelStruct.modelPar_given_PWNFB=mod.given("PWNFB");
modParamMap["PWNFB"] = &(modelStruct.d_modelPar_PWNFB_dX);
modelStruct.modelPar_PLWNFB=mod.PLWNFB;
modelStruct.d_modelPar_PLWNFB_dX=0.0;
modelStruct.modelPar_given_PLWNFB=mod.given("PLWNFB");
modParamMap["PLWNFB"] = &(modelStruct.d_modelPar_PLWNFB_dX);
modelStruct.modelPar_PONFC=mod.PONFC;
modelStruct.d_modelPar_PONFC_dX=0.0;
modelStruct.modelPar_given_PONFC=mod.given("PONFC");
modParamMap["PONFC"] = &(modelStruct.d_modelPar_PONFC_dX);
modelStruct.modelPar_PLNFC=mod.PLNFC;
modelStruct.d_modelPar_PLNFC_dX=0.0;
modelStruct.modelPar_given_PLNFC=mod.given("PLNFC");
modParamMap["PLNFC"] = &(modelStruct.d_modelPar_PLNFC_dX);
modelStruct.modelPar_PWNFC=mod.PWNFC;
modelStruct.d_modelPar_PWNFC_dX=0.0;
modelStruct.modelPar_given_PWNFC=mod.given("PWNFC");
modParamMap["PWNFC"] = &(modelStruct.d_modelPar_PWNFC_dX);
modelStruct.modelPar_PLWNFC=mod.PLWNFC;
modelStruct.d_modelPar_PLWNFC_dX=0.0;
modelStruct.modelPar_given_PLWNFC=mod.given("PLWNFC");
modParamMap["PLWNFC"] = &(modelStruct.d_modelPar_PLWNFC_dX);
modelStruct.modelPar_POEF=mod.POEF;
modelStruct.d_modelPar_POEF_dX=0.0;
modelStruct.modelPar_given_POEF=mod.given("POEF");
modParamMap["POEF"] = &(modelStruct.d_modelPar_POEF_dX);
modelStruct.modelPar_POVFBEDGE=mod.POVFBEDGE;
modelStruct.d_modelPar_POVFBEDGE_dX=0.0;
modelStruct.modelPar_given_POVFBEDGE=mod.given("POVFBEDGE");
modParamMap["POVFBEDGE"] = &(modelStruct.d_modelPar_POVFBEDGE_dX);
modelStruct.modelPar_POSTVFBEDGE=mod.POSTVFBEDGE;
modelStruct.d_modelPar_POSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_POSTVFBEDGE=mod.given("POSTVFBEDGE");
modParamMap["POSTVFBEDGE"] = &(modelStruct.d_modelPar_POSTVFBEDGE_dX);
modelStruct.modelPar_PLSTVFBEDGE=mod.PLSTVFBEDGE;
modelStruct.d_modelPar_PLSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLSTVFBEDGE=mod.given("PLSTVFBEDGE");
modParamMap["PLSTVFBEDGE"] = &(modelStruct.d_modelPar_PLSTVFBEDGE_dX);
modelStruct.modelPar_PWSTVFBEDGE=mod.PWSTVFBEDGE;
modelStruct.d_modelPar_PWSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PWSTVFBEDGE=mod.given("PWSTVFBEDGE");
modParamMap["PWSTVFBEDGE"] = &(modelStruct.d_modelPar_PWSTVFBEDGE_dX);
modelStruct.modelPar_PLWSTVFBEDGE=mod.PLWSTVFBEDGE;
modelStruct.d_modelPar_PLWSTVFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWSTVFBEDGE=mod.given("PLWSTVFBEDGE");
modParamMap["PLWSTVFBEDGE"] = &(modelStruct.d_modelPar_PLWSTVFBEDGE_dX);
modelStruct.modelPar_PODPHIBEDGE=mod.PODPHIBEDGE;
modelStruct.d_modelPar_PODPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PODPHIBEDGE=mod.given("PODPHIBEDGE");
modParamMap["PODPHIBEDGE"] = &(modelStruct.d_modelPar_PODPHIBEDGE_dX);
modelStruct.modelPar_PLDPHIBEDGE=mod.PLDPHIBEDGE;
modelStruct.d_modelPar_PLDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PLDPHIBEDGE=mod.given("PLDPHIBEDGE");
modParamMap["PLDPHIBEDGE"] = &(modelStruct.d_modelPar_PLDPHIBEDGE_dX);
modelStruct.modelPar_PWDPHIBEDGE=mod.PWDPHIBEDGE;
modelStruct.d_modelPar_PWDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PWDPHIBEDGE=mod.given("PWDPHIBEDGE");
modParamMap["PWDPHIBEDGE"] = &(modelStruct.d_modelPar_PWDPHIBEDGE_dX);
modelStruct.modelPar_PLWDPHIBEDGE=mod.PLWDPHIBEDGE;
modelStruct.d_modelPar_PLWDPHIBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWDPHIBEDGE=mod.given("PLWDPHIBEDGE");
modParamMap["PLWDPHIBEDGE"] = &(modelStruct.d_modelPar_PLWDPHIBEDGE_dX);
modelStruct.modelPar_PONEFFEDGE=mod.PONEFFEDGE;
modelStruct.d_modelPar_PONEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PONEFFEDGE=mod.given("PONEFFEDGE");
modParamMap["PONEFFEDGE"] = &(modelStruct.d_modelPar_PONEFFEDGE_dX);
modelStruct.modelPar_PLNEFFEDGE=mod.PLNEFFEDGE;
modelStruct.d_modelPar_PLNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PLNEFFEDGE=mod.given("PLNEFFEDGE");
modParamMap["PLNEFFEDGE"] = &(modelStruct.d_modelPar_PLNEFFEDGE_dX);
modelStruct.modelPar_PWNEFFEDGE=mod.PWNEFFEDGE;
modelStruct.d_modelPar_PWNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PWNEFFEDGE=mod.given("PWNEFFEDGE");
modParamMap["PWNEFFEDGE"] = &(modelStruct.d_modelPar_PWNEFFEDGE_dX);
modelStruct.modelPar_PLWNEFFEDGE=mod.PLWNEFFEDGE;
modelStruct.d_modelPar_PLWNEFFEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNEFFEDGE=mod.given("PLWNEFFEDGE");
modParamMap["PLWNEFFEDGE"] = &(modelStruct.d_modelPar_PLWNEFFEDGE_dX);
modelStruct.modelPar_POCTEDGE=mod.POCTEDGE;
modelStruct.d_modelPar_POCTEDGE_dX=0.0;
modelStruct.modelPar_given_POCTEDGE=mod.given("POCTEDGE");
modParamMap["POCTEDGE"] = &(modelStruct.d_modelPar_POCTEDGE_dX);
modelStruct.modelPar_PLCTEDGE=mod.PLCTEDGE;
modelStruct.d_modelPar_PLCTEDGE_dX=0.0;
modelStruct.modelPar_given_PLCTEDGE=mod.given("PLCTEDGE");
modParamMap["PLCTEDGE"] = &(modelStruct.d_modelPar_PLCTEDGE_dX);
modelStruct.modelPar_PWCTEDGE=mod.PWCTEDGE;
modelStruct.d_modelPar_PWCTEDGE_dX=0.0;
modelStruct.modelPar_given_PWCTEDGE=mod.given("PWCTEDGE");
modParamMap["PWCTEDGE"] = &(modelStruct.d_modelPar_PWCTEDGE_dX);
modelStruct.modelPar_PLWCTEDGE=mod.PLWCTEDGE;
modelStruct.d_modelPar_PLWCTEDGE_dX=0.0;
modelStruct.modelPar_given_PLWCTEDGE=mod.given("PLWCTEDGE");
modParamMap["PLWCTEDGE"] = &(modelStruct.d_modelPar_PLWCTEDGE_dX);
modelStruct.modelPar_POBETNEDGE=mod.POBETNEDGE;
modelStruct.d_modelPar_POBETNEDGE_dX=0.0;
modelStruct.modelPar_given_POBETNEDGE=mod.given("POBETNEDGE");
modParamMap["POBETNEDGE"] = &(modelStruct.d_modelPar_POBETNEDGE_dX);
modelStruct.modelPar_PLBETNEDGE=mod.PLBETNEDGE;
modelStruct.d_modelPar_PLBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PLBETNEDGE=mod.given("PLBETNEDGE");
modParamMap["PLBETNEDGE"] = &(modelStruct.d_modelPar_PLBETNEDGE_dX);
modelStruct.modelPar_PWBETNEDGE=mod.PWBETNEDGE;
modelStruct.d_modelPar_PWBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PWBETNEDGE=mod.given("PWBETNEDGE");
modParamMap["PWBETNEDGE"] = &(modelStruct.d_modelPar_PWBETNEDGE_dX);
modelStruct.modelPar_PLWBETNEDGE=mod.PLWBETNEDGE;
modelStruct.d_modelPar_PLWBETNEDGE_dX=0.0;
modelStruct.modelPar_given_PLWBETNEDGE=mod.given("PLWBETNEDGE");
modParamMap["PLWBETNEDGE"] = &(modelStruct.d_modelPar_PLWBETNEDGE_dX);
modelStruct.modelPar_POSTBETEDGE=mod.POSTBETEDGE;
modelStruct.d_modelPar_POSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_POSTBETEDGE=mod.given("POSTBETEDGE");
modParamMap["POSTBETEDGE"] = &(modelStruct.d_modelPar_POSTBETEDGE_dX);
modelStruct.modelPar_PLSTBETEDGE=mod.PLSTBETEDGE;
modelStruct.d_modelPar_PLSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PLSTBETEDGE=mod.given("PLSTBETEDGE");
modParamMap["PLSTBETEDGE"] = &(modelStruct.d_modelPar_PLSTBETEDGE_dX);
modelStruct.modelPar_PWSTBETEDGE=mod.PWSTBETEDGE;
modelStruct.d_modelPar_PWSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PWSTBETEDGE=mod.given("PWSTBETEDGE");
modParamMap["PWSTBETEDGE"] = &(modelStruct.d_modelPar_PWSTBETEDGE_dX);
modelStruct.modelPar_PLWSTBETEDGE=mod.PLWSTBETEDGE;
modelStruct.d_modelPar_PLWSTBETEDGE_dX=0.0;
modelStruct.modelPar_given_PLWSTBETEDGE=mod.given("PLWSTBETEDGE");
modParamMap["PLWSTBETEDGE"] = &(modelStruct.d_modelPar_PLWSTBETEDGE_dX);
modelStruct.modelPar_POPSCEEDGE=mod.POPSCEEDGE;
modelStruct.d_modelPar_POPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEEDGE=mod.given("POPSCEEDGE");
modParamMap["POPSCEEDGE"] = &(modelStruct.d_modelPar_POPSCEEDGE_dX);
modelStruct.modelPar_PLPSCEEDGE=mod.PLPSCEEDGE;
modelStruct.d_modelPar_PLPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PLPSCEEDGE=mod.given("PLPSCEEDGE");
modParamMap["PLPSCEEDGE"] = &(modelStruct.d_modelPar_PLPSCEEDGE_dX);
modelStruct.modelPar_PWPSCEEDGE=mod.PWPSCEEDGE;
modelStruct.d_modelPar_PWPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PWPSCEEDGE=mod.given("PWPSCEEDGE");
modParamMap["PWPSCEEDGE"] = &(modelStruct.d_modelPar_PWPSCEEDGE_dX);
modelStruct.modelPar_PLWPSCEEDGE=mod.PLWPSCEEDGE;
modelStruct.d_modelPar_PLWPSCEEDGE_dX=0.0;
modelStruct.modelPar_given_PLWPSCEEDGE=mod.given("PLWPSCEEDGE");
modParamMap["PLWPSCEEDGE"] = &(modelStruct.d_modelPar_PLWPSCEEDGE_dX);
modelStruct.modelPar_POPSCEBEDGE=mod.POPSCEBEDGE;
modelStruct.d_modelPar_POPSCEBEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEBEDGE=mod.given("POPSCEBEDGE");
modParamMap["POPSCEBEDGE"] = &(modelStruct.d_modelPar_POPSCEBEDGE_dX);
modelStruct.modelPar_POPSCEDEDGE=mod.POPSCEDEDGE;
modelStruct.d_modelPar_POPSCEDEDGE_dX=0.0;
modelStruct.modelPar_given_POPSCEDEDGE=mod.given("POPSCEDEDGE");
modParamMap["POPSCEDEDGE"] = &(modelStruct.d_modelPar_POPSCEDEDGE_dX);
modelStruct.modelPar_POCFEDGE=mod.POCFEDGE;
modelStruct.d_modelPar_POCFEDGE_dX=0.0;
modelStruct.modelPar_given_POCFEDGE=mod.given("POCFEDGE");
modParamMap["POCFEDGE"] = &(modelStruct.d_modelPar_POCFEDGE_dX);
modelStruct.modelPar_PLCFEDGE=mod.PLCFEDGE;
modelStruct.d_modelPar_PLCFEDGE_dX=0.0;
modelStruct.modelPar_given_PLCFEDGE=mod.given("PLCFEDGE");
modParamMap["PLCFEDGE"] = &(modelStruct.d_modelPar_PLCFEDGE_dX);
modelStruct.modelPar_PWCFEDGE=mod.PWCFEDGE;
modelStruct.d_modelPar_PWCFEDGE_dX=0.0;
modelStruct.modelPar_given_PWCFEDGE=mod.given("PWCFEDGE");
modParamMap["PWCFEDGE"] = &(modelStruct.d_modelPar_PWCFEDGE_dX);
modelStruct.modelPar_PLWCFEDGE=mod.PLWCFEDGE;
modelStruct.d_modelPar_PLWCFEDGE_dX=0.0;
modelStruct.modelPar_given_PLWCFEDGE=mod.given("PLWCFEDGE");
modParamMap["PLWCFEDGE"] = &(modelStruct.d_modelPar_PLWCFEDGE_dX);
modelStruct.modelPar_POCFDEDGE=mod.POCFDEDGE;
modelStruct.d_modelPar_POCFDEDGE_dX=0.0;
modelStruct.modelPar_given_POCFDEDGE=mod.given("POCFDEDGE");
modParamMap["POCFDEDGE"] = &(modelStruct.d_modelPar_POCFDEDGE_dX);
modelStruct.modelPar_POCFBEDGE=mod.POCFBEDGE;
modelStruct.d_modelPar_POCFBEDGE_dX=0.0;
modelStruct.modelPar_given_POCFBEDGE=mod.given("POCFBEDGE");
modParamMap["POCFBEDGE"] = &(modelStruct.d_modelPar_POCFBEDGE_dX);
modelStruct.modelPar_POFNTEDGE=mod.POFNTEDGE;
modelStruct.d_modelPar_POFNTEDGE_dX=0.0;
modelStruct.modelPar_given_POFNTEDGE=mod.given("POFNTEDGE");
modParamMap["POFNTEDGE"] = &(modelStruct.d_modelPar_POFNTEDGE_dX);
modelStruct.modelPar_PONFAEDGE=mod.PONFAEDGE;
modelStruct.d_modelPar_PONFAEDGE_dX=0.0;
modelStruct.modelPar_given_PONFAEDGE=mod.given("PONFAEDGE");
modParamMap["PONFAEDGE"] = &(modelStruct.d_modelPar_PONFAEDGE_dX);
modelStruct.modelPar_PLNFAEDGE=mod.PLNFAEDGE;
modelStruct.d_modelPar_PLNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFAEDGE=mod.given("PLNFAEDGE");
modParamMap["PLNFAEDGE"] = &(modelStruct.d_modelPar_PLNFAEDGE_dX);
modelStruct.modelPar_PWNFAEDGE=mod.PWNFAEDGE;
modelStruct.d_modelPar_PWNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFAEDGE=mod.given("PWNFAEDGE");
modParamMap["PWNFAEDGE"] = &(modelStruct.d_modelPar_PWNFAEDGE_dX);
modelStruct.modelPar_PLWNFAEDGE=mod.PLWNFAEDGE;
modelStruct.d_modelPar_PLWNFAEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFAEDGE=mod.given("PLWNFAEDGE");
modParamMap["PLWNFAEDGE"] = &(modelStruct.d_modelPar_PLWNFAEDGE_dX);
modelStruct.modelPar_PONFBEDGE=mod.PONFBEDGE;
modelStruct.d_modelPar_PONFBEDGE_dX=0.0;
modelStruct.modelPar_given_PONFBEDGE=mod.given("PONFBEDGE");
modParamMap["PONFBEDGE"] = &(modelStruct.d_modelPar_PONFBEDGE_dX);
modelStruct.modelPar_PLNFBEDGE=mod.PLNFBEDGE;
modelStruct.d_modelPar_PLNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFBEDGE=mod.given("PLNFBEDGE");
modParamMap["PLNFBEDGE"] = &(modelStruct.d_modelPar_PLNFBEDGE_dX);
modelStruct.modelPar_PWNFBEDGE=mod.PWNFBEDGE;
modelStruct.d_modelPar_PWNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFBEDGE=mod.given("PWNFBEDGE");
modParamMap["PWNFBEDGE"] = &(modelStruct.d_modelPar_PWNFBEDGE_dX);
modelStruct.modelPar_PLWNFBEDGE=mod.PLWNFBEDGE;
modelStruct.d_modelPar_PLWNFBEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFBEDGE=mod.given("PLWNFBEDGE");
modParamMap["PLWNFBEDGE"] = &(modelStruct.d_modelPar_PLWNFBEDGE_dX);
modelStruct.modelPar_PONFCEDGE=mod.PONFCEDGE;
modelStruct.d_modelPar_PONFCEDGE_dX=0.0;
modelStruct.modelPar_given_PONFCEDGE=mod.given("PONFCEDGE");
modParamMap["PONFCEDGE"] = &(modelStruct.d_modelPar_PONFCEDGE_dX);
modelStruct.modelPar_PLNFCEDGE=mod.PLNFCEDGE;
modelStruct.d_modelPar_PLNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PLNFCEDGE=mod.given("PLNFCEDGE");
modParamMap["PLNFCEDGE"] = &(modelStruct.d_modelPar_PLNFCEDGE_dX);
modelStruct.modelPar_PWNFCEDGE=mod.PWNFCEDGE;
modelStruct.d_modelPar_PWNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PWNFCEDGE=mod.given("PWNFCEDGE");
modParamMap["PWNFCEDGE"] = &(modelStruct.d_modelPar_PWNFCEDGE_dX);
modelStruct.modelPar_PLWNFCEDGE=mod.PLWNFCEDGE;
modelStruct.d_modelPar_PLWNFCEDGE_dX=0.0;
modelStruct.modelPar_given_PLWNFCEDGE=mod.given("PLWNFCEDGE");
modParamMap["PLWNFCEDGE"] = &(modelStruct.d_modelPar_PLWNFCEDGE_dX);
modelStruct.modelPar_POEFEDGE=mod.POEFEDGE;
modelStruct.d_modelPar_POEFEDGE_dX=0.0;
modelStruct.modelPar_given_POEFEDGE=mod.given("POEFEDGE");
modParamMap["POEFEDGE"] = &(modelStruct.d_modelPar_POEFEDGE_dX);
modelStruct.modelPar_POKVTHOWE=mod.POKVTHOWE;
modelStruct.d_modelPar_POKVTHOWE_dX=0.0;
modelStruct.modelPar_given_POKVTHOWE=mod.given("POKVTHOWE");
modParamMap["POKVTHOWE"] = &(modelStruct.d_modelPar_POKVTHOWE_dX);
modelStruct.modelPar_PLKVTHOWE=mod.PLKVTHOWE;
modelStruct.d_modelPar_PLKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PLKVTHOWE=mod.given("PLKVTHOWE");
modParamMap["PLKVTHOWE"] = &(modelStruct.d_modelPar_PLKVTHOWE_dX);
modelStruct.modelPar_PWKVTHOWE=mod.PWKVTHOWE;
modelStruct.d_modelPar_PWKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PWKVTHOWE=mod.given("PWKVTHOWE");
modParamMap["PWKVTHOWE"] = &(modelStruct.d_modelPar_PWKVTHOWE_dX);
modelStruct.modelPar_PLWKVTHOWE=mod.PLWKVTHOWE;
modelStruct.d_modelPar_PLWKVTHOWE_dX=0.0;
modelStruct.modelPar_given_PLWKVTHOWE=mod.given("PLWKVTHOWE");
modParamMap["PLWKVTHOWE"] = &(modelStruct.d_modelPar_PLWKVTHOWE_dX);
modelStruct.modelPar_POKUOWE=mod.POKUOWE;
modelStruct.d_modelPar_POKUOWE_dX=0.0;
modelStruct.modelPar_given_POKUOWE=mod.given("POKUOWE");
modParamMap["POKUOWE"] = &(modelStruct.d_modelPar_POKUOWE_dX);
modelStruct.modelPar_PLKUOWE=mod.PLKUOWE;
modelStruct.d_modelPar_PLKUOWE_dX=0.0;
modelStruct.modelPar_given_PLKUOWE=mod.given("PLKUOWE");
modParamMap["PLKUOWE"] = &(modelStruct.d_modelPar_PLKUOWE_dX);
modelStruct.modelPar_PWKUOWE=mod.PWKUOWE;
modelStruct.d_modelPar_PWKUOWE_dX=0.0;
modelStruct.modelPar_given_PWKUOWE=mod.given("PWKUOWE");
modParamMap["PWKUOWE"] = &(modelStruct.d_modelPar_PWKUOWE_dX);
modelStruct.modelPar_PLWKUOWE=mod.PLWKUOWE;
modelStruct.d_modelPar_PLWKUOWE_dX=0.0;
modelStruct.modelPar_given_PLWKUOWE=mod.given("PLWKUOWE");
modParamMap["PLWKUOWE"] = &(modelStruct.d_modelPar_PLWKUOWE_dX);
modelStruct.modelPar_LMIN=mod.LMIN;
modelStruct.d_modelPar_LMIN_dX=0.0;
modelStruct.modelPar_given_LMIN=mod.given("LMIN");
modParamMap["LMIN"] = &(modelStruct.d_modelPar_LMIN_dX);
modelStruct.modelPar_LMAX=mod.LMAX;
modelStruct.d_modelPar_LMAX_dX=0.0;
modelStruct.modelPar_given_LMAX=mod.given("LMAX");
modParamMap["LMAX"] = &(modelStruct.d_modelPar_LMAX_dX);
modelStruct.modelPar_WMIN=mod.WMIN;
modelStruct.d_modelPar_WMIN_dX=0.0;
modelStruct.modelPar_given_WMIN=mod.given("WMIN");
modParamMap["WMIN"] = &(modelStruct.d_modelPar_WMIN_dX);
modelStruct.modelPar_WMAX=mod.WMAX;
modelStruct.d_modelPar_WMAX_dX=0.0;
modelStruct.modelPar_given_WMAX=mod.given("WMAX");
modParamMap["WMAX"] = &(modelStruct.d_modelPar_WMAX_dX);
modelStruct.modelPar_LVARO=mod.LVARO;
modelStruct.d_modelPar_LVARO_dX=0.0;
modelStruct.modelPar_given_LVARO=mod.given("LVARO");
modParamMap["LVARO"] = &(modelStruct.d_modelPar_LVARO_dX);
modelStruct.modelPar_LVARL=mod.LVARL;
modelStruct.d_modelPar_LVARL_dX=0.0;
modelStruct.modelPar_given_LVARL=mod.given("LVARL");
modParamMap["LVARL"] = &(modelStruct.d_modelPar_LVARL_dX);
modelStruct.modelPar_LVARW=mod.LVARW;
modelStruct.d_modelPar_LVARW_dX=0.0;
modelStruct.modelPar_given_LVARW=mod.given("LVARW");
modParamMap["LVARW"] = &(modelStruct.d_modelPar_LVARW_dX);
modelStruct.modelPar_LAP=mod.LAP;
modelStruct.d_modelPar_LAP_dX=0.0;
modelStruct.modelPar_given_LAP=mod.given("LAP");
modParamMap["LAP"] = &(modelStruct.d_modelPar_LAP_dX);
modelStruct.modelPar_WVARO=mod.WVARO;
modelStruct.d_modelPar_WVARO_dX=0.0;
modelStruct.modelPar_given_WVARO=mod.given("WVARO");
modParamMap["WVARO"] = &(modelStruct.d_modelPar_WVARO_dX);
modelStruct.modelPar_WVARL=mod.WVARL;
modelStruct.d_modelPar_WVARL_dX=0.0;
modelStruct.modelPar_given_WVARL=mod.given("WVARL");
modParamMap["WVARL"] = &(modelStruct.d_modelPar_WVARL_dX);
modelStruct.modelPar_WVARW=mod.WVARW;
modelStruct.d_modelPar_WVARW_dX=0.0;
modelStruct.modelPar_given_WVARW=mod.given("WVARW");
modParamMap["WVARW"] = &(modelStruct.d_modelPar_WVARW_dX);
modelStruct.modelPar_WOT=mod.WOT;
modelStruct.d_modelPar_WOT_dX=0.0;
modelStruct.modelPar_given_WOT=mod.given("WOT");
modParamMap["WOT"] = &(modelStruct.d_modelPar_WOT_dX);
modelStruct.modelPar_DLQ=mod.DLQ;
modelStruct.d_modelPar_DLQ_dX=0.0;
modelStruct.modelPar_given_DLQ=mod.given("DLQ");
modParamMap["DLQ"] = &(modelStruct.d_modelPar_DLQ_dX);
modelStruct.modelPar_DWQ=mod.DWQ;
modelStruct.d_modelPar_DWQ_dX=0.0;
modelStruct.modelPar_given_DWQ=mod.given("DWQ");
modParamMap["DWQ"] = &(modelStruct.d_modelPar_DWQ_dX);
modelStruct.modelPar_VFBO=mod.VFBO;
modelStruct.d_modelPar_VFBO_dX=0.0;
modelStruct.modelPar_given_VFBO=mod.given("VFBO");
modParamMap["VFBO"] = &(modelStruct.d_modelPar_VFBO_dX);
modelStruct.modelPar_VFBL=mod.VFBL;
modelStruct.d_modelPar_VFBL_dX=0.0;
modelStruct.modelPar_given_VFBL=mod.given("VFBL");
modParamMap["VFBL"] = &(modelStruct.d_modelPar_VFBL_dX);
modelStruct.modelPar_VFBW=mod.VFBW;
modelStruct.d_modelPar_VFBW_dX=0.0;
modelStruct.modelPar_given_VFBW=mod.given("VFBW");
modParamMap["VFBW"] = &(modelStruct.d_modelPar_VFBW_dX);
modelStruct.modelPar_VFBLW=mod.VFBLW;
modelStruct.d_modelPar_VFBLW_dX=0.0;
modelStruct.modelPar_given_VFBLW=mod.given("VFBLW");
modParamMap["VFBLW"] = &(modelStruct.d_modelPar_VFBLW_dX);
modelStruct.modelPar_STVFBO=mod.STVFBO;
modelStruct.d_modelPar_STVFBO_dX=0.0;
modelStruct.modelPar_given_STVFBO=mod.given("STVFBO");
modParamMap["STVFBO"] = &(modelStruct.d_modelPar_STVFBO_dX);
modelStruct.modelPar_STVFBL=mod.STVFBL;
modelStruct.d_modelPar_STVFBL_dX=0.0;
modelStruct.modelPar_given_STVFBL=mod.given("STVFBL");
modParamMap["STVFBL"] = &(modelStruct.d_modelPar_STVFBL_dX);
modelStruct.modelPar_STVFBW=mod.STVFBW;
modelStruct.d_modelPar_STVFBW_dX=0.0;
modelStruct.modelPar_given_STVFBW=mod.given("STVFBW");
modParamMap["STVFBW"] = &(modelStruct.d_modelPar_STVFBW_dX);
modelStruct.modelPar_STVFBLW=mod.STVFBLW;
modelStruct.d_modelPar_STVFBLW_dX=0.0;
modelStruct.modelPar_given_STVFBLW=mod.given("STVFBLW");
modParamMap["STVFBLW"] = &(modelStruct.d_modelPar_STVFBLW_dX);
modelStruct.modelPar_TOXO=mod.TOXO;
modelStruct.d_modelPar_TOXO_dX=0.0;
modelStruct.modelPar_given_TOXO=mod.given("TOXO");
modParamMap["TOXO"] = &(modelStruct.d_modelPar_TOXO_dX);
modelStruct.modelPar_EPSROXO=mod.EPSROXO;
modelStruct.d_modelPar_EPSROXO_dX=0.0;
modelStruct.modelPar_given_EPSROXO=mod.given("EPSROXO");
modParamMap["EPSROXO"] = &(modelStruct.d_modelPar_EPSROXO_dX);
modelStruct.modelPar_NSUBO=mod.NSUBO;
modelStruct.d_modelPar_NSUBO_dX=0.0;
modelStruct.modelPar_given_NSUBO=mod.given("NSUBO");
modParamMap["NSUBO"] = &(modelStruct.d_modelPar_NSUBO_dX);
modelStruct.modelPar_NSUBW=mod.NSUBW;
modelStruct.d_modelPar_NSUBW_dX=0.0;
modelStruct.modelPar_given_NSUBW=mod.given("NSUBW");
modParamMap["NSUBW"] = &(modelStruct.d_modelPar_NSUBW_dX);
modelStruct.modelPar_WSEG=mod.WSEG;
modelStruct.d_modelPar_WSEG_dX=0.0;
modelStruct.modelPar_given_WSEG=mod.given("WSEG");
modParamMap["WSEG"] = &(modelStruct.d_modelPar_WSEG_dX);
modelStruct.modelPar_NPCK=mod.NPCK;
modelStruct.d_modelPar_NPCK_dX=0.0;
modelStruct.modelPar_given_NPCK=mod.given("NPCK");
modParamMap["NPCK"] = &(modelStruct.d_modelPar_NPCK_dX);
modelStruct.modelPar_NPCKW=mod.NPCKW;
modelStruct.d_modelPar_NPCKW_dX=0.0;
modelStruct.modelPar_given_NPCKW=mod.given("NPCKW");
modParamMap["NPCKW"] = &(modelStruct.d_modelPar_NPCKW_dX);
modelStruct.modelPar_WSEGP=mod.WSEGP;
modelStruct.d_modelPar_WSEGP_dX=0.0;
modelStruct.modelPar_given_WSEGP=mod.given("WSEGP");
modParamMap["WSEGP"] = &(modelStruct.d_modelPar_WSEGP_dX);
modelStruct.modelPar_LPCK=mod.LPCK;
modelStruct.d_modelPar_LPCK_dX=0.0;
modelStruct.modelPar_given_LPCK=mod.given("LPCK");
modParamMap["LPCK"] = &(modelStruct.d_modelPar_LPCK_dX);
modelStruct.modelPar_LPCKW=mod.LPCKW;
modelStruct.d_modelPar_LPCKW_dX=0.0;
modelStruct.modelPar_given_LPCKW=mod.given("LPCKW");
modParamMap["LPCKW"] = &(modelStruct.d_modelPar_LPCKW_dX);
modelStruct.modelPar_FOL1=mod.FOL1;
modelStruct.d_modelPar_FOL1_dX=0.0;
modelStruct.modelPar_given_FOL1=mod.given("FOL1");
modParamMap["FOL1"] = &(modelStruct.d_modelPar_FOL1_dX);
modelStruct.modelPar_FOL2=mod.FOL2;
modelStruct.d_modelPar_FOL2_dX=0.0;
modelStruct.modelPar_given_FOL2=mod.given("FOL2");
modParamMap["FOL2"] = &(modelStruct.d_modelPar_FOL2_dX);
modelStruct.modelPar_FACNEFFACO=mod.FACNEFFACO;
modelStruct.d_modelPar_FACNEFFACO_dX=0.0;
modelStruct.modelPar_given_FACNEFFACO=mod.given("FACNEFFACO");
modParamMap["FACNEFFACO"] = &(modelStruct.d_modelPar_FACNEFFACO_dX);
modelStruct.modelPar_FACNEFFACL=mod.FACNEFFACL;
modelStruct.d_modelPar_FACNEFFACL_dX=0.0;
modelStruct.modelPar_given_FACNEFFACL=mod.given("FACNEFFACL");
modParamMap["FACNEFFACL"] = &(modelStruct.d_modelPar_FACNEFFACL_dX);
modelStruct.modelPar_FACNEFFACW=mod.FACNEFFACW;
modelStruct.d_modelPar_FACNEFFACW_dX=0.0;
modelStruct.modelPar_given_FACNEFFACW=mod.given("FACNEFFACW");
modParamMap["FACNEFFACW"] = &(modelStruct.d_modelPar_FACNEFFACW_dX);
modelStruct.modelPar_FACNEFFACLW=mod.FACNEFFACLW;
modelStruct.d_modelPar_FACNEFFACLW_dX=0.0;
modelStruct.modelPar_given_FACNEFFACLW=mod.given("FACNEFFACLW");
modParamMap["FACNEFFACLW"] = &(modelStruct.d_modelPar_FACNEFFACLW_dX);
modelStruct.modelPar_GFACNUDO=mod.GFACNUDO;
modelStruct.d_modelPar_GFACNUDO_dX=0.0;
modelStruct.modelPar_given_GFACNUDO=mod.given("GFACNUDO");
modParamMap["GFACNUDO"] = &(modelStruct.d_modelPar_GFACNUDO_dX);
modelStruct.modelPar_GFACNUDL=mod.GFACNUDL;
modelStruct.d_modelPar_GFACNUDL_dX=0.0;
modelStruct.modelPar_given_GFACNUDL=mod.given("GFACNUDL");
modParamMap["GFACNUDL"] = &(modelStruct.d_modelPar_GFACNUDL_dX);
modelStruct.modelPar_GFACNUDLEXP=mod.GFACNUDLEXP;
modelStruct.d_modelPar_GFACNUDLEXP_dX=0.0;
modelStruct.modelPar_given_GFACNUDLEXP=mod.given("GFACNUDLEXP");
modParamMap["GFACNUDLEXP"] = &(modelStruct.d_modelPar_GFACNUDLEXP_dX);
modelStruct.modelPar_GFACNUDW=mod.GFACNUDW;
modelStruct.d_modelPar_GFACNUDW_dX=0.0;
modelStruct.modelPar_given_GFACNUDW=mod.given("GFACNUDW");
modParamMap["GFACNUDW"] = &(modelStruct.d_modelPar_GFACNUDW_dX);
modelStruct.modelPar_GFACNUDLW=mod.GFACNUDLW;
modelStruct.d_modelPar_GFACNUDLW_dX=0.0;
modelStruct.modelPar_given_GFACNUDLW=mod.given("GFACNUDLW");
modParamMap["GFACNUDLW"] = &(modelStruct.d_modelPar_GFACNUDLW_dX);
modelStruct.modelPar_VSBNUDO=mod.VSBNUDO;
modelStruct.d_modelPar_VSBNUDO_dX=0.0;
modelStruct.modelPar_given_VSBNUDO=mod.given("VSBNUDO");
modParamMap["VSBNUDO"] = &(modelStruct.d_modelPar_VSBNUDO_dX);
modelStruct.modelPar_DVSBNUDO=mod.DVSBNUDO;
modelStruct.d_modelPar_DVSBNUDO_dX=0.0;
modelStruct.modelPar_given_DVSBNUDO=mod.given("DVSBNUDO");
modParamMap["DVSBNUDO"] = &(modelStruct.d_modelPar_DVSBNUDO_dX);
modelStruct.modelPar_VNSUBO=mod.VNSUBO;
modelStruct.d_modelPar_VNSUBO_dX=0.0;
modelStruct.modelPar_given_VNSUBO=mod.given("VNSUBO");
modParamMap["VNSUBO"] = &(modelStruct.d_modelPar_VNSUBO_dX);
modelStruct.modelPar_NSLPO=mod.NSLPO;
modelStruct.d_modelPar_NSLPO_dX=0.0;
modelStruct.modelPar_given_NSLPO=mod.given("NSLPO");
modParamMap["NSLPO"] = &(modelStruct.d_modelPar_NSLPO_dX);
modelStruct.modelPar_DNSUBO=mod.DNSUBO;
modelStruct.d_modelPar_DNSUBO_dX=0.0;
modelStruct.modelPar_given_DNSUBO=mod.given("DNSUBO");
modParamMap["DNSUBO"] = &(modelStruct.d_modelPar_DNSUBO_dX);
modelStruct.modelPar_DPHIBO=mod.DPHIBO;
modelStruct.d_modelPar_DPHIBO_dX=0.0;
modelStruct.modelPar_given_DPHIBO=mod.given("DPHIBO");
modParamMap["DPHIBO"] = &(modelStruct.d_modelPar_DPHIBO_dX);
modelStruct.modelPar_DPHIBL=mod.DPHIBL;
modelStruct.d_modelPar_DPHIBL_dX=0.0;
modelStruct.modelPar_given_DPHIBL=mod.given("DPHIBL");
modParamMap["DPHIBL"] = &(modelStruct.d_modelPar_DPHIBL_dX);
modelStruct.modelPar_DPHIBLEXP=mod.DPHIBLEXP;
modelStruct.d_modelPar_DPHIBLEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBLEXP=mod.given("DPHIBLEXP");
modParamMap["DPHIBLEXP"] = &(modelStruct.d_modelPar_DPHIBLEXP_dX);
modelStruct.modelPar_DPHIBW=mod.DPHIBW;
modelStruct.d_modelPar_DPHIBW_dX=0.0;
modelStruct.modelPar_given_DPHIBW=mod.given("DPHIBW");
modParamMap["DPHIBW"] = &(modelStruct.d_modelPar_DPHIBW_dX);
modelStruct.modelPar_DPHIBLW=mod.DPHIBLW;
modelStruct.d_modelPar_DPHIBLW_dX=0.0;
modelStruct.modelPar_given_DPHIBLW=mod.given("DPHIBLW");
modParamMap["DPHIBLW"] = &(modelStruct.d_modelPar_DPHIBLW_dX);
modelStruct.modelPar_DELVTACO=mod.DELVTACO;
modelStruct.d_modelPar_DELVTACO_dX=0.0;
modelStruct.modelPar_given_DELVTACO=mod.given("DELVTACO");
modParamMap["DELVTACO"] = &(modelStruct.d_modelPar_DELVTACO_dX);
modelStruct.modelPar_DELVTACL=mod.DELVTACL;
modelStruct.d_modelPar_DELVTACL_dX=0.0;
modelStruct.modelPar_given_DELVTACL=mod.given("DELVTACL");
modParamMap["DELVTACL"] = &(modelStruct.d_modelPar_DELVTACL_dX);
modelStruct.modelPar_DELVTACLEXP=mod.DELVTACLEXP;
modelStruct.d_modelPar_DELVTACLEXP_dX=0.0;
modelStruct.modelPar_given_DELVTACLEXP=mod.given("DELVTACLEXP");
modParamMap["DELVTACLEXP"] = &(modelStruct.d_modelPar_DELVTACLEXP_dX);
modelStruct.modelPar_DELVTACW=mod.DELVTACW;
modelStruct.d_modelPar_DELVTACW_dX=0.0;
modelStruct.modelPar_given_DELVTACW=mod.given("DELVTACW");
modParamMap["DELVTACW"] = &(modelStruct.d_modelPar_DELVTACW_dX);
modelStruct.modelPar_DELVTACLW=mod.DELVTACLW;
modelStruct.d_modelPar_DELVTACLW_dX=0.0;
modelStruct.modelPar_given_DELVTACLW=mod.given("DELVTACLW");
modParamMap["DELVTACLW"] = &(modelStruct.d_modelPar_DELVTACLW_dX);
modelStruct.modelPar_NPO=mod.NPO;
modelStruct.d_modelPar_NPO_dX=0.0;
modelStruct.modelPar_given_NPO=mod.given("NPO");
modParamMap["NPO"] = &(modelStruct.d_modelPar_NPO_dX);
modelStruct.modelPar_NPL=mod.NPL;
modelStruct.d_modelPar_NPL_dX=0.0;
modelStruct.modelPar_given_NPL=mod.given("NPL");
modParamMap["NPL"] = &(modelStruct.d_modelPar_NPL_dX);
modelStruct.modelPar_CTO=mod.CTO;
modelStruct.d_modelPar_CTO_dX=0.0;
modelStruct.modelPar_given_CTO=mod.given("CTO");
modParamMap["CTO"] = &(modelStruct.d_modelPar_CTO_dX);
modelStruct.modelPar_CTL=mod.CTL;
modelStruct.d_modelPar_CTL_dX=0.0;
modelStruct.modelPar_given_CTL=mod.given("CTL");
modParamMap["CTL"] = &(modelStruct.d_modelPar_CTL_dX);
modelStruct.modelPar_CTLEXP=mod.CTLEXP;
modelStruct.d_modelPar_CTLEXP_dX=0.0;
modelStruct.modelPar_given_CTLEXP=mod.given("CTLEXP");
modParamMap["CTLEXP"] = &(modelStruct.d_modelPar_CTLEXP_dX);
modelStruct.modelPar_CTW=mod.CTW;
modelStruct.d_modelPar_CTW_dX=0.0;
modelStruct.modelPar_given_CTW=mod.given("CTW");
modParamMap["CTW"] = &(modelStruct.d_modelPar_CTW_dX);
modelStruct.modelPar_CTLW=mod.CTLW;
modelStruct.d_modelPar_CTLW_dX=0.0;
modelStruct.modelPar_given_CTLW=mod.given("CTLW");
modParamMap["CTLW"] = &(modelStruct.d_modelPar_CTLW_dX);
modelStruct.modelPar_TOXOVO=mod.TOXOVO;
modelStruct.d_modelPar_TOXOVO_dX=0.0;
modelStruct.modelPar_given_TOXOVO=mod.given("TOXOVO");
modParamMap["TOXOVO"] = &(modelStruct.d_modelPar_TOXOVO_dX);
modelStruct.modelPar_TOXOVDO=mod.TOXOVDO;
modelStruct.d_modelPar_TOXOVDO_dX=0.0;
modelStruct.modelPar_given_TOXOVDO=mod.given("TOXOVDO");
modParamMap["TOXOVDO"] = &(modelStruct.d_modelPar_TOXOVDO_dX);
modelStruct.modelPar_LOV=mod.LOV;
modelStruct.d_modelPar_LOV_dX=0.0;
modelStruct.modelPar_given_LOV=mod.given("LOV");
modParamMap["LOV"] = &(modelStruct.d_modelPar_LOV_dX);
modelStruct.modelPar_LOVD=mod.LOVD;
modelStruct.d_modelPar_LOVD_dX=0.0;
modelStruct.modelPar_given_LOVD=mod.given("LOVD");
modParamMap["LOVD"] = &(modelStruct.d_modelPar_LOVD_dX);
modelStruct.modelPar_NOVO=mod.NOVO;
modelStruct.d_modelPar_NOVO_dX=0.0;
modelStruct.modelPar_given_NOVO=mod.given("NOVO");
modParamMap["NOVO"] = &(modelStruct.d_modelPar_NOVO_dX);
modelStruct.modelPar_NOVDO=mod.NOVDO;
modelStruct.d_modelPar_NOVDO_dX=0.0;
modelStruct.modelPar_given_NOVDO=mod.given("NOVDO");
modParamMap["NOVDO"] = &(modelStruct.d_modelPar_NOVDO_dX);
modelStruct.modelPar_CFL=mod.CFL;
modelStruct.d_modelPar_CFL_dX=0.0;
modelStruct.modelPar_given_CFL=mod.given("CFL");
modParamMap["CFL"] = &(modelStruct.d_modelPar_CFL_dX);
modelStruct.modelPar_CFLEXP=mod.CFLEXP;
modelStruct.d_modelPar_CFLEXP_dX=0.0;
modelStruct.modelPar_given_CFLEXP=mod.given("CFLEXP");
modParamMap["CFLEXP"] = &(modelStruct.d_modelPar_CFLEXP_dX);
modelStruct.modelPar_CFW=mod.CFW;
modelStruct.d_modelPar_CFW_dX=0.0;
modelStruct.modelPar_given_CFW=mod.given("CFW");
modParamMap["CFW"] = &(modelStruct.d_modelPar_CFW_dX);
modelStruct.modelPar_CFDO=mod.CFDO;
modelStruct.d_modelPar_CFDO_dX=0.0;
modelStruct.modelPar_given_CFDO=mod.given("CFDO");
modParamMap["CFDO"] = &(modelStruct.d_modelPar_CFDO_dX);
modelStruct.modelPar_CFBO=mod.CFBO;
modelStruct.d_modelPar_CFBO_dX=0.0;
modelStruct.modelPar_given_CFBO=mod.given("CFBO");
modParamMap["CFBO"] = &(modelStruct.d_modelPar_CFBO_dX);
modelStruct.modelPar_PSCEL=mod.PSCEL;
modelStruct.d_modelPar_PSCEL_dX=0.0;
modelStruct.modelPar_given_PSCEL=mod.given("PSCEL");
modParamMap["PSCEL"] = &(modelStruct.d_modelPar_PSCEL_dX);
modelStruct.modelPar_PSCELEXP=mod.PSCELEXP;
modelStruct.d_modelPar_PSCELEXP_dX=0.0;
modelStruct.modelPar_given_PSCELEXP=mod.given("PSCELEXP");
modParamMap["PSCELEXP"] = &(modelStruct.d_modelPar_PSCELEXP_dX);
modelStruct.modelPar_PSCEW=mod.PSCEW;
modelStruct.d_modelPar_PSCEW_dX=0.0;
modelStruct.modelPar_given_PSCEW=mod.given("PSCEW");
modParamMap["PSCEW"] = &(modelStruct.d_modelPar_PSCEW_dX);
modelStruct.modelPar_PSCEBO=mod.PSCEBO;
modelStruct.d_modelPar_PSCEBO_dX=0.0;
modelStruct.modelPar_given_PSCEBO=mod.given("PSCEBO");
modParamMap["PSCEBO"] = &(modelStruct.d_modelPar_PSCEBO_dX);
modelStruct.modelPar_PSCEDO=mod.PSCEDO;
modelStruct.d_modelPar_PSCEDO_dX=0.0;
modelStruct.modelPar_given_PSCEDO=mod.given("PSCEDO");
modParamMap["PSCEDO"] = &(modelStruct.d_modelPar_PSCEDO_dX);
modelStruct.modelPar_UO=mod.UO;
modelStruct.d_modelPar_UO_dX=0.0;
modelStruct.modelPar_given_UO=mod.given("UO");
modParamMap["UO"] = &(modelStruct.d_modelPar_UO_dX);
modelStruct.modelPar_FBET1=mod.FBET1;
modelStruct.d_modelPar_FBET1_dX=0.0;
modelStruct.modelPar_given_FBET1=mod.given("FBET1");
modParamMap["FBET1"] = &(modelStruct.d_modelPar_FBET1_dX);
modelStruct.modelPar_FBET1W=mod.FBET1W;
modelStruct.d_modelPar_FBET1W_dX=0.0;
modelStruct.modelPar_given_FBET1W=mod.given("FBET1W");
modParamMap["FBET1W"] = &(modelStruct.d_modelPar_FBET1W_dX);
modelStruct.modelPar_LP1=mod.LP1;
modelStruct.d_modelPar_LP1_dX=0.0;
modelStruct.modelPar_given_LP1=mod.given("LP1");
modParamMap["LP1"] = &(modelStruct.d_modelPar_LP1_dX);
modelStruct.modelPar_LP1W=mod.LP1W;
modelStruct.d_modelPar_LP1W_dX=0.0;
modelStruct.modelPar_given_LP1W=mod.given("LP1W");
modParamMap["LP1W"] = &(modelStruct.d_modelPar_LP1W_dX);
modelStruct.modelPar_FBET2=mod.FBET2;
modelStruct.d_modelPar_FBET2_dX=0.0;
modelStruct.modelPar_given_FBET2=mod.given("FBET2");
modParamMap["FBET2"] = &(modelStruct.d_modelPar_FBET2_dX);
modelStruct.modelPar_LP2=mod.LP2;
modelStruct.d_modelPar_LP2_dX=0.0;
modelStruct.modelPar_given_LP2=mod.given("LP2");
modParamMap["LP2"] = &(modelStruct.d_modelPar_LP2_dX);
modelStruct.modelPar_BETW1=mod.BETW1;
modelStruct.d_modelPar_BETW1_dX=0.0;
modelStruct.modelPar_given_BETW1=mod.given("BETW1");
modParamMap["BETW1"] = &(modelStruct.d_modelPar_BETW1_dX);
modelStruct.modelPar_BETW2=mod.BETW2;
modelStruct.d_modelPar_BETW2_dX=0.0;
modelStruct.modelPar_given_BETW2=mod.given("BETW2");
modParamMap["BETW2"] = &(modelStruct.d_modelPar_BETW2_dX);
modelStruct.modelPar_WBET=mod.WBET;
modelStruct.d_modelPar_WBET_dX=0.0;
modelStruct.modelPar_given_WBET=mod.given("WBET");
modParamMap["WBET"] = &(modelStruct.d_modelPar_WBET_dX);
modelStruct.modelPar_STBETO=mod.STBETO;
modelStruct.d_modelPar_STBETO_dX=0.0;
modelStruct.modelPar_given_STBETO=mod.given("STBETO");
modParamMap["STBETO"] = &(modelStruct.d_modelPar_STBETO_dX);
modelStruct.modelPar_STBETL=mod.STBETL;
modelStruct.d_modelPar_STBETL_dX=0.0;
modelStruct.modelPar_given_STBETL=mod.given("STBETL");
modParamMap["STBETL"] = &(modelStruct.d_modelPar_STBETL_dX);
modelStruct.modelPar_STBETW=mod.STBETW;
modelStruct.d_modelPar_STBETW_dX=0.0;
modelStruct.modelPar_given_STBETW=mod.given("STBETW");
modParamMap["STBETW"] = &(modelStruct.d_modelPar_STBETW_dX);
modelStruct.modelPar_STBETLW=mod.STBETLW;
modelStruct.d_modelPar_STBETLW_dX=0.0;
modelStruct.modelPar_given_STBETLW=mod.given("STBETLW");
modParamMap["STBETLW"] = &(modelStruct.d_modelPar_STBETLW_dX);
modelStruct.modelPar_MUEO=mod.MUEO;
modelStruct.d_modelPar_MUEO_dX=0.0;
modelStruct.modelPar_given_MUEO=mod.given("MUEO");
modParamMap["MUEO"] = &(modelStruct.d_modelPar_MUEO_dX);
modelStruct.modelPar_MUEW=mod.MUEW;
modelStruct.d_modelPar_MUEW_dX=0.0;
modelStruct.modelPar_given_MUEW=mod.given("MUEW");
modParamMap["MUEW"] = &(modelStruct.d_modelPar_MUEW_dX);
modelStruct.modelPar_STMUEO=mod.STMUEO;
modelStruct.d_modelPar_STMUEO_dX=0.0;
modelStruct.modelPar_given_STMUEO=mod.given("STMUEO");
modParamMap["STMUEO"] = &(modelStruct.d_modelPar_STMUEO_dX);
modelStruct.modelPar_THEMUO=mod.THEMUO;
modelStruct.d_modelPar_THEMUO_dX=0.0;
modelStruct.modelPar_given_THEMUO=mod.given("THEMUO");
modParamMap["THEMUO"] = &(modelStruct.d_modelPar_THEMUO_dX);
modelStruct.modelPar_STTHEMUO=mod.STTHEMUO;
modelStruct.d_modelPar_STTHEMUO_dX=0.0;
modelStruct.modelPar_given_STTHEMUO=mod.given("STTHEMUO");
modParamMap["STTHEMUO"] = &(modelStruct.d_modelPar_STTHEMUO_dX);
modelStruct.modelPar_CSO=mod.CSO;
modelStruct.d_modelPar_CSO_dX=0.0;
modelStruct.modelPar_given_CSO=mod.given("CSO");
modParamMap["CSO"] = &(modelStruct.d_modelPar_CSO_dX);
modelStruct.modelPar_CSL=mod.CSL;
modelStruct.d_modelPar_CSL_dX=0.0;
modelStruct.modelPar_given_CSL=mod.given("CSL");
modParamMap["CSL"] = &(modelStruct.d_modelPar_CSL_dX);
modelStruct.modelPar_CSLEXP=mod.CSLEXP;
modelStruct.d_modelPar_CSLEXP_dX=0.0;
modelStruct.modelPar_given_CSLEXP=mod.given("CSLEXP");
modParamMap["CSLEXP"] = &(modelStruct.d_modelPar_CSLEXP_dX);
modelStruct.modelPar_CSW=mod.CSW;
modelStruct.d_modelPar_CSW_dX=0.0;
modelStruct.modelPar_given_CSW=mod.given("CSW");
modParamMap["CSW"] = &(modelStruct.d_modelPar_CSW_dX);
modelStruct.modelPar_CSLW=mod.CSLW;
modelStruct.d_modelPar_CSLW_dX=0.0;
modelStruct.modelPar_given_CSLW=mod.given("CSLW");
modParamMap["CSLW"] = &(modelStruct.d_modelPar_CSLW_dX);
modelStruct.modelPar_STCSO=mod.STCSO;
modelStruct.d_modelPar_STCSO_dX=0.0;
modelStruct.modelPar_given_STCSO=mod.given("STCSO");
modParamMap["STCSO"] = &(modelStruct.d_modelPar_STCSO_dX);
modelStruct.modelPar_XCORO=mod.XCORO;
modelStruct.d_modelPar_XCORO_dX=0.0;
modelStruct.modelPar_given_XCORO=mod.given("XCORO");
modParamMap["XCORO"] = &(modelStruct.d_modelPar_XCORO_dX);
modelStruct.modelPar_XCORL=mod.XCORL;
modelStruct.d_modelPar_XCORL_dX=0.0;
modelStruct.modelPar_given_XCORL=mod.given("XCORL");
modParamMap["XCORL"] = &(modelStruct.d_modelPar_XCORL_dX);
modelStruct.modelPar_XCORW=mod.XCORW;
modelStruct.d_modelPar_XCORW_dX=0.0;
modelStruct.modelPar_given_XCORW=mod.given("XCORW");
modParamMap["XCORW"] = &(modelStruct.d_modelPar_XCORW_dX);
modelStruct.modelPar_XCORLW=mod.XCORLW;
modelStruct.d_modelPar_XCORLW_dX=0.0;
modelStruct.modelPar_given_XCORLW=mod.given("XCORLW");
modParamMap["XCORLW"] = &(modelStruct.d_modelPar_XCORLW_dX);
modelStruct.modelPar_STXCORO=mod.STXCORO;
modelStruct.d_modelPar_STXCORO_dX=0.0;
modelStruct.modelPar_given_STXCORO=mod.given("STXCORO");
modParamMap["STXCORO"] = &(modelStruct.d_modelPar_STXCORO_dX);
modelStruct.modelPar_FETAO=mod.FETAO;
modelStruct.d_modelPar_FETAO_dX=0.0;
modelStruct.modelPar_given_FETAO=mod.given("FETAO");
modParamMap["FETAO"] = &(modelStruct.d_modelPar_FETAO_dX);
modelStruct.modelPar_RSW1=mod.RSW1;
modelStruct.d_modelPar_RSW1_dX=0.0;
modelStruct.modelPar_given_RSW1=mod.given("RSW1");
modParamMap["RSW1"] = &(modelStruct.d_modelPar_RSW1_dX);
modelStruct.modelPar_RSW2=mod.RSW2;
modelStruct.d_modelPar_RSW2_dX=0.0;
modelStruct.modelPar_given_RSW2=mod.given("RSW2");
modParamMap["RSW2"] = &(modelStruct.d_modelPar_RSW2_dX);
modelStruct.modelPar_STRSO=mod.STRSO;
modelStruct.d_modelPar_STRSO_dX=0.0;
modelStruct.modelPar_given_STRSO=mod.given("STRSO");
modParamMap["STRSO"] = &(modelStruct.d_modelPar_STRSO_dX);
modelStruct.modelPar_RSBO=mod.RSBO;
modelStruct.d_modelPar_RSBO_dX=0.0;
modelStruct.modelPar_given_RSBO=mod.given("RSBO");
modParamMap["RSBO"] = &(modelStruct.d_modelPar_RSBO_dX);
modelStruct.modelPar_RSGO=mod.RSGO;
modelStruct.d_modelPar_RSGO_dX=0.0;
modelStruct.modelPar_given_RSGO=mod.given("RSGO");
modParamMap["RSGO"] = &(modelStruct.d_modelPar_RSGO_dX);
modelStruct.modelPar_THESATO=mod.THESATO;
modelStruct.d_modelPar_THESATO_dX=0.0;
modelStruct.modelPar_given_THESATO=mod.given("THESATO");
modParamMap["THESATO"] = &(modelStruct.d_modelPar_THESATO_dX);
modelStruct.modelPar_THESATL=mod.THESATL;
modelStruct.d_modelPar_THESATL_dX=0.0;
modelStruct.modelPar_given_THESATL=mod.given("THESATL");
modParamMap["THESATL"] = &(modelStruct.d_modelPar_THESATL_dX);
modelStruct.modelPar_THESATLEXP=mod.THESATLEXP;
modelStruct.d_modelPar_THESATLEXP_dX=0.0;
modelStruct.modelPar_given_THESATLEXP=mod.given("THESATLEXP");
modParamMap["THESATLEXP"] = &(modelStruct.d_modelPar_THESATLEXP_dX);
modelStruct.modelPar_THESATW=mod.THESATW;
modelStruct.d_modelPar_THESATW_dX=0.0;
modelStruct.modelPar_given_THESATW=mod.given("THESATW");
modParamMap["THESATW"] = &(modelStruct.d_modelPar_THESATW_dX);
modelStruct.modelPar_THESATLW=mod.THESATLW;
modelStruct.d_modelPar_THESATLW_dX=0.0;
modelStruct.modelPar_given_THESATLW=mod.given("THESATLW");
modParamMap["THESATLW"] = &(modelStruct.d_modelPar_THESATLW_dX);
modelStruct.modelPar_STTHESATO=mod.STTHESATO;
modelStruct.d_modelPar_STTHESATO_dX=0.0;
modelStruct.modelPar_given_STTHESATO=mod.given("STTHESATO");
modParamMap["STTHESATO"] = &(modelStruct.d_modelPar_STTHESATO_dX);
modelStruct.modelPar_STTHESATL=mod.STTHESATL;
modelStruct.d_modelPar_STTHESATL_dX=0.0;
modelStruct.modelPar_given_STTHESATL=mod.given("STTHESATL");
modParamMap["STTHESATL"] = &(modelStruct.d_modelPar_STTHESATL_dX);
modelStruct.modelPar_STTHESATW=mod.STTHESATW;
modelStruct.d_modelPar_STTHESATW_dX=0.0;
modelStruct.modelPar_given_STTHESATW=mod.given("STTHESATW");
modParamMap["STTHESATW"] = &(modelStruct.d_modelPar_STTHESATW_dX);
modelStruct.modelPar_STTHESATLW=mod.STTHESATLW;
modelStruct.d_modelPar_STTHESATLW_dX=0.0;
modelStruct.modelPar_given_STTHESATLW=mod.given("STTHESATLW");
modParamMap["STTHESATLW"] = &(modelStruct.d_modelPar_STTHESATLW_dX);
modelStruct.modelPar_THESATBO=mod.THESATBO;
modelStruct.d_modelPar_THESATBO_dX=0.0;
modelStruct.modelPar_given_THESATBO=mod.given("THESATBO");
modParamMap["THESATBO"] = &(modelStruct.d_modelPar_THESATBO_dX);
modelStruct.modelPar_THESATGO=mod.THESATGO;
modelStruct.d_modelPar_THESATGO_dX=0.0;
modelStruct.modelPar_given_THESATGO=mod.given("THESATGO");
modParamMap["THESATGO"] = &(modelStruct.d_modelPar_THESATGO_dX);
modelStruct.modelPar_AXO=mod.AXO;
modelStruct.d_modelPar_AXO_dX=0.0;
modelStruct.modelPar_given_AXO=mod.given("AXO");
modParamMap["AXO"] = &(modelStruct.d_modelPar_AXO_dX);
modelStruct.modelPar_AXL=mod.AXL;
modelStruct.d_modelPar_AXL_dX=0.0;
modelStruct.modelPar_given_AXL=mod.given("AXL");
modParamMap["AXL"] = &(modelStruct.d_modelPar_AXL_dX);
modelStruct.modelPar_ALPL=mod.ALPL;
modelStruct.d_modelPar_ALPL_dX=0.0;
modelStruct.modelPar_given_ALPL=mod.given("ALPL");
modParamMap["ALPL"] = &(modelStruct.d_modelPar_ALPL_dX);
modelStruct.modelPar_ALPLEXP=mod.ALPLEXP;
modelStruct.d_modelPar_ALPLEXP_dX=0.0;
modelStruct.modelPar_given_ALPLEXP=mod.given("ALPLEXP");
modParamMap["ALPLEXP"] = &(modelStruct.d_modelPar_ALPLEXP_dX);
modelStruct.modelPar_ALPW=mod.ALPW;
modelStruct.d_modelPar_ALPW_dX=0.0;
modelStruct.modelPar_given_ALPW=mod.given("ALPW");
modParamMap["ALPW"] = &(modelStruct.d_modelPar_ALPW_dX);
modelStruct.modelPar_ALP1L1=mod.ALP1L1;
modelStruct.d_modelPar_ALP1L1_dX=0.0;
modelStruct.modelPar_given_ALP1L1=mod.given("ALP1L1");
modParamMap["ALP1L1"] = &(modelStruct.d_modelPar_ALP1L1_dX);
modelStruct.modelPar_ALP1LEXP=mod.ALP1LEXP;
modelStruct.d_modelPar_ALP1LEXP_dX=0.0;
modelStruct.modelPar_given_ALP1LEXP=mod.given("ALP1LEXP");
modParamMap["ALP1LEXP"] = &(modelStruct.d_modelPar_ALP1LEXP_dX);
modelStruct.modelPar_ALP1L2=mod.ALP1L2;
modelStruct.d_modelPar_ALP1L2_dX=0.0;
modelStruct.modelPar_given_ALP1L2=mod.given("ALP1L2");
modParamMap["ALP1L2"] = &(modelStruct.d_modelPar_ALP1L2_dX);
modelStruct.modelPar_ALP1W=mod.ALP1W;
modelStruct.d_modelPar_ALP1W_dX=0.0;
modelStruct.modelPar_given_ALP1W=mod.given("ALP1W");
modParamMap["ALP1W"] = &(modelStruct.d_modelPar_ALP1W_dX);
modelStruct.modelPar_ALP2L1=mod.ALP2L1;
modelStruct.d_modelPar_ALP2L1_dX=0.0;
modelStruct.modelPar_given_ALP2L1=mod.given("ALP2L1");
modParamMap["ALP2L1"] = &(modelStruct.d_modelPar_ALP2L1_dX);
modelStruct.modelPar_ALP2LEXP=mod.ALP2LEXP;
modelStruct.d_modelPar_ALP2LEXP_dX=0.0;
modelStruct.modelPar_given_ALP2LEXP=mod.given("ALP2LEXP");
modParamMap["ALP2LEXP"] = &(modelStruct.d_modelPar_ALP2LEXP_dX);
modelStruct.modelPar_ALP2L2=mod.ALP2L2;
modelStruct.d_modelPar_ALP2L2_dX=0.0;
modelStruct.modelPar_given_ALP2L2=mod.given("ALP2L2");
modParamMap["ALP2L2"] = &(modelStruct.d_modelPar_ALP2L2_dX);
modelStruct.modelPar_ALP2W=mod.ALP2W;
modelStruct.d_modelPar_ALP2W_dX=0.0;
modelStruct.modelPar_given_ALP2W=mod.given("ALP2W");
modParamMap["ALP2W"] = &(modelStruct.d_modelPar_ALP2W_dX);
modelStruct.modelPar_VPO=mod.VPO;
modelStruct.d_modelPar_VPO_dX=0.0;
modelStruct.modelPar_given_VPO=mod.given("VPO");
modParamMap["VPO"] = &(modelStruct.d_modelPar_VPO_dX);
modelStruct.modelPar_A1O=mod.A1O;
modelStruct.d_modelPar_A1O_dX=0.0;
modelStruct.modelPar_given_A1O=mod.given("A1O");
modParamMap["A1O"] = &(modelStruct.d_modelPar_A1O_dX);
modelStruct.modelPar_A1L=mod.A1L;
modelStruct.d_modelPar_A1L_dX=0.0;
modelStruct.modelPar_given_A1L=mod.given("A1L");
modParamMap["A1L"] = &(modelStruct.d_modelPar_A1L_dX);
modelStruct.modelPar_A1W=mod.A1W;
modelStruct.d_modelPar_A1W_dX=0.0;
modelStruct.modelPar_given_A1W=mod.given("A1W");
modParamMap["A1W"] = &(modelStruct.d_modelPar_A1W_dX);
modelStruct.modelPar_A2O=mod.A2O;
modelStruct.d_modelPar_A2O_dX=0.0;
modelStruct.modelPar_given_A2O=mod.given("A2O");
modParamMap["A2O"] = &(modelStruct.d_modelPar_A2O_dX);
modelStruct.modelPar_STA2O=mod.STA2O;
modelStruct.d_modelPar_STA2O_dX=0.0;
modelStruct.modelPar_given_STA2O=mod.given("STA2O");
modParamMap["STA2O"] = &(modelStruct.d_modelPar_STA2O_dX);
modelStruct.modelPar_A3O=mod.A3O;
modelStruct.d_modelPar_A3O_dX=0.0;
modelStruct.modelPar_given_A3O=mod.given("A3O");
modParamMap["A3O"] = &(modelStruct.d_modelPar_A3O_dX);
modelStruct.modelPar_A3L=mod.A3L;
modelStruct.d_modelPar_A3L_dX=0.0;
modelStruct.modelPar_given_A3L=mod.given("A3L");
modParamMap["A3L"] = &(modelStruct.d_modelPar_A3L_dX);
modelStruct.modelPar_A3W=mod.A3W;
modelStruct.d_modelPar_A3W_dX=0.0;
modelStruct.modelPar_given_A3W=mod.given("A3W");
modParamMap["A3W"] = &(modelStruct.d_modelPar_A3W_dX);
modelStruct.modelPar_A4O=mod.A4O;
modelStruct.d_modelPar_A4O_dX=0.0;
modelStruct.modelPar_given_A4O=mod.given("A4O");
modParamMap["A4O"] = &(modelStruct.d_modelPar_A4O_dX);
modelStruct.modelPar_A4L=mod.A4L;
modelStruct.d_modelPar_A4L_dX=0.0;
modelStruct.modelPar_given_A4L=mod.given("A4L");
modParamMap["A4L"] = &(modelStruct.d_modelPar_A4L_dX);
modelStruct.modelPar_A4W=mod.A4W;
modelStruct.d_modelPar_A4W_dX=0.0;
modelStruct.modelPar_given_A4W=mod.given("A4W");
modParamMap["A4W"] = &(modelStruct.d_modelPar_A4W_dX);
modelStruct.modelPar_GCOO=mod.GCOO;
modelStruct.d_modelPar_GCOO_dX=0.0;
modelStruct.modelPar_given_GCOO=mod.given("GCOO");
modParamMap["GCOO"] = &(modelStruct.d_modelPar_GCOO_dX);
modelStruct.modelPar_IGINVLW=mod.IGINVLW;
modelStruct.d_modelPar_IGINVLW_dX=0.0;
modelStruct.modelPar_given_IGINVLW=mod.given("IGINVLW");
modParamMap["IGINVLW"] = &(modelStruct.d_modelPar_IGINVLW_dX);
modelStruct.modelPar_IGOVW=mod.IGOVW;
modelStruct.d_modelPar_IGOVW_dX=0.0;
modelStruct.modelPar_given_IGOVW=mod.given("IGOVW");
modParamMap["IGOVW"] = &(modelStruct.d_modelPar_IGOVW_dX);
modelStruct.modelPar_IGOVDW=mod.IGOVDW;
modelStruct.d_modelPar_IGOVDW_dX=0.0;
modelStruct.modelPar_given_IGOVDW=mod.given("IGOVDW");
modParamMap["IGOVDW"] = &(modelStruct.d_modelPar_IGOVDW_dX);
modelStruct.modelPar_STIGO=mod.STIGO;
modelStruct.d_modelPar_STIGO_dX=0.0;
modelStruct.modelPar_given_STIGO=mod.given("STIGO");
modParamMap["STIGO"] = &(modelStruct.d_modelPar_STIGO_dX);
modelStruct.modelPar_GC2O=mod.GC2O;
modelStruct.d_modelPar_GC2O_dX=0.0;
modelStruct.modelPar_given_GC2O=mod.given("GC2O");
modParamMap["GC2O"] = &(modelStruct.d_modelPar_GC2O_dX);
modelStruct.modelPar_GC3O=mod.GC3O;
modelStruct.d_modelPar_GC3O_dX=0.0;
modelStruct.modelPar_given_GC3O=mod.given("GC3O");
modParamMap["GC3O"] = &(modelStruct.d_modelPar_GC3O_dX);
modelStruct.modelPar_CHIBO=mod.CHIBO;
modelStruct.d_modelPar_CHIBO_dX=0.0;
modelStruct.modelPar_given_CHIBO=mod.given("CHIBO");
modParamMap["CHIBO"] = &(modelStruct.d_modelPar_CHIBO_dX);
modelStruct.modelPar_AGIDLW=mod.AGIDLW;
modelStruct.d_modelPar_AGIDLW_dX=0.0;
modelStruct.modelPar_given_AGIDLW=mod.given("AGIDLW");
modParamMap["AGIDLW"] = &(modelStruct.d_modelPar_AGIDLW_dX);
modelStruct.modelPar_AGIDLDW=mod.AGIDLDW;
modelStruct.d_modelPar_AGIDLDW_dX=0.0;
modelStruct.modelPar_given_AGIDLDW=mod.given("AGIDLDW");
modParamMap["AGIDLDW"] = &(modelStruct.d_modelPar_AGIDLDW_dX);
modelStruct.modelPar_BGIDLO=mod.BGIDLO;
modelStruct.d_modelPar_BGIDLO_dX=0.0;
modelStruct.modelPar_given_BGIDLO=mod.given("BGIDLO");
modParamMap["BGIDLO"] = &(modelStruct.d_modelPar_BGIDLO_dX);
modelStruct.modelPar_BGIDLDO=mod.BGIDLDO;
modelStruct.d_modelPar_BGIDLDO_dX=0.0;
modelStruct.modelPar_given_BGIDLDO=mod.given("BGIDLDO");
modParamMap["BGIDLDO"] = &(modelStruct.d_modelPar_BGIDLDO_dX);
modelStruct.modelPar_STBGIDLO=mod.STBGIDLO;
modelStruct.d_modelPar_STBGIDLO_dX=0.0;
modelStruct.modelPar_given_STBGIDLO=mod.given("STBGIDLO");
modParamMap["STBGIDLO"] = &(modelStruct.d_modelPar_STBGIDLO_dX);
modelStruct.modelPar_STBGIDLDO=mod.STBGIDLDO;
modelStruct.d_modelPar_STBGIDLDO_dX=0.0;
modelStruct.modelPar_given_STBGIDLDO=mod.given("STBGIDLDO");
modParamMap["STBGIDLDO"] = &(modelStruct.d_modelPar_STBGIDLDO_dX);
modelStruct.modelPar_CGIDLO=mod.CGIDLO;
modelStruct.d_modelPar_CGIDLO_dX=0.0;
modelStruct.modelPar_given_CGIDLO=mod.given("CGIDLO");
modParamMap["CGIDLO"] = &(modelStruct.d_modelPar_CGIDLO_dX);
modelStruct.modelPar_CGIDLDO=mod.CGIDLDO;
modelStruct.d_modelPar_CGIDLDO_dX=0.0;
modelStruct.modelPar_given_CGIDLDO=mod.given("CGIDLDO");
modParamMap["CGIDLDO"] = &(modelStruct.d_modelPar_CGIDLDO_dX);
modelStruct.modelPar_CGBOVL=mod.CGBOVL;
modelStruct.d_modelPar_CGBOVL_dX=0.0;
modelStruct.modelPar_given_CGBOVL=mod.given("CGBOVL");
modParamMap["CGBOVL"] = &(modelStruct.d_modelPar_CGBOVL_dX);
modelStruct.modelPar_CFRW=mod.CFRW;
modelStruct.d_modelPar_CFRW_dX=0.0;
modelStruct.modelPar_given_CFRW=mod.given("CFRW");
modParamMap["CFRW"] = &(modelStruct.d_modelPar_CFRW_dX);
modelStruct.modelPar_CFRDW=mod.CFRDW;
modelStruct.d_modelPar_CFRDW_dX=0.0;
modelStruct.modelPar_given_CFRDW=mod.given("CFRDW");
modParamMap["CFRDW"] = &(modelStruct.d_modelPar_CFRDW_dX);
modelStruct.modelPar_FNTO=mod.FNTO;
modelStruct.d_modelPar_FNTO_dX=0.0;
modelStruct.modelPar_given_FNTO=mod.given("FNTO");
modParamMap["FNTO"] = &(modelStruct.d_modelPar_FNTO_dX);
modelStruct.modelPar_FNTEXCL=mod.FNTEXCL;
modelStruct.d_modelPar_FNTEXCL_dX=0.0;
modelStruct.modelPar_given_FNTEXCL=mod.given("FNTEXCL");
modParamMap["FNTEXCL"] = &(modelStruct.d_modelPar_FNTEXCL_dX);
modelStruct.modelPar_NFALW=mod.NFALW;
modelStruct.d_modelPar_NFALW_dX=0.0;
modelStruct.modelPar_given_NFALW=mod.given("NFALW");
modParamMap["NFALW"] = &(modelStruct.d_modelPar_NFALW_dX);
modelStruct.modelPar_NFBLW=mod.NFBLW;
modelStruct.d_modelPar_NFBLW_dX=0.0;
modelStruct.modelPar_given_NFBLW=mod.given("NFBLW");
modParamMap["NFBLW"] = &(modelStruct.d_modelPar_NFBLW_dX);
modelStruct.modelPar_NFCLW=mod.NFCLW;
modelStruct.d_modelPar_NFCLW_dX=0.0;
modelStruct.modelPar_given_NFCLW=mod.given("NFCLW");
modParamMap["NFCLW"] = &(modelStruct.d_modelPar_NFCLW_dX);
modelStruct.modelPar_EFO=mod.EFO;
modelStruct.d_modelPar_EFO_dX=0.0;
modelStruct.modelPar_given_EFO=mod.given("EFO");
modParamMap["EFO"] = &(modelStruct.d_modelPar_EFO_dX);
modelStruct.modelPar_LINTNOI=mod.LINTNOI;
modelStruct.d_modelPar_LINTNOI_dX=0.0;
modelStruct.modelPar_given_LINTNOI=mod.given("LINTNOI");
modParamMap["LINTNOI"] = &(modelStruct.d_modelPar_LINTNOI_dX);
modelStruct.modelPar_ALPNOI=mod.ALPNOI;
modelStruct.d_modelPar_ALPNOI_dX=0.0;
modelStruct.modelPar_given_ALPNOI=mod.given("ALPNOI");
modParamMap["ALPNOI"] = &(modelStruct.d_modelPar_ALPNOI_dX);
modelStruct.modelPar_WEDGE=mod.WEDGE;
modelStruct.d_modelPar_WEDGE_dX=0.0;
modelStruct.modelPar_given_WEDGE=mod.given("WEDGE");
modParamMap["WEDGE"] = &(modelStruct.d_modelPar_WEDGE_dX);
modelStruct.modelPar_WEDGEW=mod.WEDGEW;
modelStruct.d_modelPar_WEDGEW_dX=0.0;
modelStruct.modelPar_given_WEDGEW=mod.given("WEDGEW");
modParamMap["WEDGEW"] = &(modelStruct.d_modelPar_WEDGEW_dX);
modelStruct.modelPar_VFBEDGEO=mod.VFBEDGEO;
modelStruct.d_modelPar_VFBEDGEO_dX=0.0;
modelStruct.modelPar_given_VFBEDGEO=mod.given("VFBEDGEO");
modParamMap["VFBEDGEO"] = &(modelStruct.d_modelPar_VFBEDGEO_dX);
modelStruct.modelPar_STVFBEDGEO=mod.STVFBEDGEO;
modelStruct.d_modelPar_STVFBEDGEO_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEO=mod.given("STVFBEDGEO");
modParamMap["STVFBEDGEO"] = &(modelStruct.d_modelPar_STVFBEDGEO_dX);
modelStruct.modelPar_STVFBEDGEL=mod.STVFBEDGEL;
modelStruct.d_modelPar_STVFBEDGEL_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEL=mod.given("STVFBEDGEL");
modParamMap["STVFBEDGEL"] = &(modelStruct.d_modelPar_STVFBEDGEL_dX);
modelStruct.modelPar_STVFBEDGEW=mod.STVFBEDGEW;
modelStruct.d_modelPar_STVFBEDGEW_dX=0.0;
modelStruct.modelPar_given_STVFBEDGEW=mod.given("STVFBEDGEW");
modParamMap["STVFBEDGEW"] = &(modelStruct.d_modelPar_STVFBEDGEW_dX);
modelStruct.modelPar_STVFBEDGELW=mod.STVFBEDGELW;
modelStruct.d_modelPar_STVFBEDGELW_dX=0.0;
modelStruct.modelPar_given_STVFBEDGELW=mod.given("STVFBEDGELW");
modParamMap["STVFBEDGELW"] = &(modelStruct.d_modelPar_STVFBEDGELW_dX);
modelStruct.modelPar_DPHIBEDGEO=mod.DPHIBEDGEO;
modelStruct.d_modelPar_DPHIBEDGEO_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEO=mod.given("DPHIBEDGEO");
modParamMap["DPHIBEDGEO"] = &(modelStruct.d_modelPar_DPHIBEDGEO_dX);
modelStruct.modelPar_DPHIBEDGEL=mod.DPHIBEDGEL;
modelStruct.d_modelPar_DPHIBEDGEL_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEL=mod.given("DPHIBEDGEL");
modParamMap["DPHIBEDGEL"] = &(modelStruct.d_modelPar_DPHIBEDGEL_dX);
modelStruct.modelPar_DPHIBEDGELEXP=mod.DPHIBEDGELEXP;
modelStruct.d_modelPar_DPHIBEDGELEXP_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGELEXP=mod.given("DPHIBEDGELEXP");
modParamMap["DPHIBEDGELEXP"] = &(modelStruct.d_modelPar_DPHIBEDGELEXP_dX);
modelStruct.modelPar_DPHIBEDGEW=mod.DPHIBEDGEW;
modelStruct.d_modelPar_DPHIBEDGEW_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGEW=mod.given("DPHIBEDGEW");
modParamMap["DPHIBEDGEW"] = &(modelStruct.d_modelPar_DPHIBEDGEW_dX);
modelStruct.modelPar_DPHIBEDGELW=mod.DPHIBEDGELW;
modelStruct.d_modelPar_DPHIBEDGELW_dX=0.0;
modelStruct.modelPar_given_DPHIBEDGELW=mod.given("DPHIBEDGELW");
modParamMap["DPHIBEDGELW"] = &(modelStruct.d_modelPar_DPHIBEDGELW_dX);
modelStruct.modelPar_NSUBEDGEO=mod.NSUBEDGEO;
modelStruct.d_modelPar_NSUBEDGEO_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEO=mod.given("NSUBEDGEO");
modParamMap["NSUBEDGEO"] = &(modelStruct.d_modelPar_NSUBEDGEO_dX);
modelStruct.modelPar_NSUBEDGEL=mod.NSUBEDGEL;
modelStruct.d_modelPar_NSUBEDGEL_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEL=mod.given("NSUBEDGEL");
modParamMap["NSUBEDGEL"] = &(modelStruct.d_modelPar_NSUBEDGEL_dX);
modelStruct.modelPar_NSUBEDGEW=mod.NSUBEDGEW;
modelStruct.d_modelPar_NSUBEDGEW_dX=0.0;
modelStruct.modelPar_given_NSUBEDGEW=mod.given("NSUBEDGEW");
modParamMap["NSUBEDGEW"] = &(modelStruct.d_modelPar_NSUBEDGEW_dX);
modelStruct.modelPar_NSUBEDGELW=mod.NSUBEDGELW;
modelStruct.d_modelPar_NSUBEDGELW_dX=0.0;
modelStruct.modelPar_given_NSUBEDGELW=mod.given("NSUBEDGELW");
modParamMap["NSUBEDGELW"] = &(modelStruct.d_modelPar_NSUBEDGELW_dX);
modelStruct.modelPar_CTEDGEO=mod.CTEDGEO;
modelStruct.d_modelPar_CTEDGEO_dX=0.0;
modelStruct.modelPar_given_CTEDGEO=mod.given("CTEDGEO");
modParamMap["CTEDGEO"] = &(modelStruct.d_modelPar_CTEDGEO_dX);
modelStruct.modelPar_CTEDGEL=mod.CTEDGEL;
modelStruct.d_modelPar_CTEDGEL_dX=0.0;
modelStruct.modelPar_given_CTEDGEL=mod.given("CTEDGEL");
modParamMap["CTEDGEL"] = &(modelStruct.d_modelPar_CTEDGEL_dX);
modelStruct.modelPar_CTEDGELEXP=mod.CTEDGELEXP;
modelStruct.d_modelPar_CTEDGELEXP_dX=0.0;
modelStruct.modelPar_given_CTEDGELEXP=mod.given("CTEDGELEXP");
modParamMap["CTEDGELEXP"] = &(modelStruct.d_modelPar_CTEDGELEXP_dX);
modelStruct.modelPar_FBETEDGE=mod.FBETEDGE;
modelStruct.d_modelPar_FBETEDGE_dX=0.0;
modelStruct.modelPar_given_FBETEDGE=mod.given("FBETEDGE");
modParamMap["FBETEDGE"] = &(modelStruct.d_modelPar_FBETEDGE_dX);
modelStruct.modelPar_LPEDGE=mod.LPEDGE;
modelStruct.d_modelPar_LPEDGE_dX=0.0;
modelStruct.modelPar_given_LPEDGE=mod.given("LPEDGE");
modParamMap["LPEDGE"] = &(modelStruct.d_modelPar_LPEDGE_dX);
modelStruct.modelPar_BETEDGEW=mod.BETEDGEW;
modelStruct.d_modelPar_BETEDGEW_dX=0.0;
modelStruct.modelPar_given_BETEDGEW=mod.given("BETEDGEW");
modParamMap["BETEDGEW"] = &(modelStruct.d_modelPar_BETEDGEW_dX);
modelStruct.modelPar_STBETEDGEO=mod.STBETEDGEO;
modelStruct.d_modelPar_STBETEDGEO_dX=0.0;
modelStruct.modelPar_given_STBETEDGEO=mod.given("STBETEDGEO");
modParamMap["STBETEDGEO"] = &(modelStruct.d_modelPar_STBETEDGEO_dX);
modelStruct.modelPar_STBETEDGEL=mod.STBETEDGEL;
modelStruct.d_modelPar_STBETEDGEL_dX=0.0;
modelStruct.modelPar_given_STBETEDGEL=mod.given("STBETEDGEL");
modParamMap["STBETEDGEL"] = &(modelStruct.d_modelPar_STBETEDGEL_dX);
modelStruct.modelPar_STBETEDGEW=mod.STBETEDGEW;
modelStruct.d_modelPar_STBETEDGEW_dX=0.0;
modelStruct.modelPar_given_STBETEDGEW=mod.given("STBETEDGEW");
modParamMap["STBETEDGEW"] = &(modelStruct.d_modelPar_STBETEDGEW_dX);
modelStruct.modelPar_STBETEDGELW=mod.STBETEDGELW;
modelStruct.d_modelPar_STBETEDGELW_dX=0.0;
modelStruct.modelPar_given_STBETEDGELW=mod.given("STBETEDGELW");
modParamMap["STBETEDGELW"] = &(modelStruct.d_modelPar_STBETEDGELW_dX);
modelStruct.modelPar_PSCEEDGEL=mod.PSCEEDGEL;
modelStruct.d_modelPar_PSCEEDGEL_dX=0.0;
modelStruct.modelPar_given_PSCEEDGEL=mod.given("PSCEEDGEL");
modParamMap["PSCEEDGEL"] = &(modelStruct.d_modelPar_PSCEEDGEL_dX);
modelStruct.modelPar_PSCEEDGELEXP=mod.PSCEEDGELEXP;
modelStruct.d_modelPar_PSCEEDGELEXP_dX=0.0;
modelStruct.modelPar_given_PSCEEDGELEXP=mod.given("PSCEEDGELEXP");
modParamMap["PSCEEDGELEXP"] = &(modelStruct.d_modelPar_PSCEEDGELEXP_dX);
modelStruct.modelPar_PSCEEDGEW=mod.PSCEEDGEW;
modelStruct.d_modelPar_PSCEEDGEW_dX=0.0;
modelStruct.modelPar_given_PSCEEDGEW=mod.given("PSCEEDGEW");
modParamMap["PSCEEDGEW"] = &(modelStruct.d_modelPar_PSCEEDGEW_dX);
modelStruct.modelPar_PSCEBEDGEO=mod.PSCEBEDGEO;
modelStruct.d_modelPar_PSCEBEDGEO_dX=0.0;
modelStruct.modelPar_given_PSCEBEDGEO=mod.given("PSCEBEDGEO");
modParamMap["PSCEBEDGEO"] = &(modelStruct.d_modelPar_PSCEBEDGEO_dX);
modelStruct.modelPar_PSCEDEDGEO=mod.PSCEDEDGEO;
modelStruct.d_modelPar_PSCEDEDGEO_dX=0.0;
modelStruct.modelPar_given_PSCEDEDGEO=mod.given("PSCEDEDGEO");
modParamMap["PSCEDEDGEO"] = &(modelStruct.d_modelPar_PSCEDEDGEO_dX);
modelStruct.modelPar_CFEDGEL=mod.CFEDGEL;
modelStruct.d_modelPar_CFEDGEL_dX=0.0;
modelStruct.modelPar_given_CFEDGEL=mod.given("CFEDGEL");
modParamMap["CFEDGEL"] = &(modelStruct.d_modelPar_CFEDGEL_dX);
modelStruct.modelPar_CFEDGELEXP=mod.CFEDGELEXP;
modelStruct.d_modelPar_CFEDGELEXP_dX=0.0;
modelStruct.modelPar_given_CFEDGELEXP=mod.given("CFEDGELEXP");
modParamMap["CFEDGELEXP"] = &(modelStruct.d_modelPar_CFEDGELEXP_dX);
modelStruct.modelPar_CFEDGEW=mod.CFEDGEW;
modelStruct.d_modelPar_CFEDGEW_dX=0.0;
modelStruct.modelPar_given_CFEDGEW=mod.given("CFEDGEW");
modParamMap["CFEDGEW"] = &(modelStruct.d_modelPar_CFEDGEW_dX);
modelStruct.modelPar_CFDEDGEO=mod.CFDEDGEO;
modelStruct.d_modelPar_CFDEDGEO_dX=0.0;
modelStruct.modelPar_given_CFDEDGEO=mod.given("CFDEDGEO");
modParamMap["CFDEDGEO"] = &(modelStruct.d_modelPar_CFDEDGEO_dX);
modelStruct.modelPar_CFBEDGEO=mod.CFBEDGEO;
modelStruct.d_modelPar_CFBEDGEO_dX=0.0;
modelStruct.modelPar_given_CFBEDGEO=mod.given("CFBEDGEO");
modParamMap["CFBEDGEO"] = &(modelStruct.d_modelPar_CFBEDGEO_dX);
modelStruct.modelPar_FNTEDGEO=mod.FNTEDGEO;
modelStruct.d_modelPar_FNTEDGEO_dX=0.0;
modelStruct.modelPar_given_FNTEDGEO=mod.given("FNTEDGEO");
modParamMap["FNTEDGEO"] = &(modelStruct.d_modelPar_FNTEDGEO_dX);
modelStruct.modelPar_NFAEDGELW=mod.NFAEDGELW;
modelStruct.d_modelPar_NFAEDGELW_dX=0.0;
modelStruct.modelPar_given_NFAEDGELW=mod.given("NFAEDGELW");
modParamMap["NFAEDGELW"] = &(modelStruct.d_modelPar_NFAEDGELW_dX);
modelStruct.modelPar_NFBEDGELW=mod.NFBEDGELW;
modelStruct.d_modelPar_NFBEDGELW_dX=0.0;
modelStruct.modelPar_given_NFBEDGELW=mod.given("NFBEDGELW");
modParamMap["NFBEDGELW"] = &(modelStruct.d_modelPar_NFBEDGELW_dX);
modelStruct.modelPar_NFCEDGELW=mod.NFCEDGELW;
modelStruct.d_modelPar_NFCEDGELW_dX=0.0;
modelStruct.modelPar_given_NFCEDGELW=mod.given("NFCEDGELW");
modParamMap["NFCEDGELW"] = &(modelStruct.d_modelPar_NFCEDGELW_dX);
modelStruct.modelPar_EFEDGEO=mod.EFEDGEO;
modelStruct.d_modelPar_EFEDGEO_dX=0.0;
modelStruct.modelPar_given_EFEDGEO=mod.given("EFEDGEO");
modParamMap["EFEDGEO"] = &(modelStruct.d_modelPar_EFEDGEO_dX);
modelStruct.modelPar_KVTHOWEO=mod.KVTHOWEO;
modelStruct.d_modelPar_KVTHOWEO_dX=0.0;
modelStruct.modelPar_given_KVTHOWEO=mod.given("KVTHOWEO");
modParamMap["KVTHOWEO"] = &(modelStruct.d_modelPar_KVTHOWEO_dX);
modelStruct.modelPar_KVTHOWEL=mod.KVTHOWEL;
modelStruct.d_modelPar_KVTHOWEL_dX=0.0;
modelStruct.modelPar_given_KVTHOWEL=mod.given("KVTHOWEL");
modParamMap["KVTHOWEL"] = &(modelStruct.d_modelPar_KVTHOWEL_dX);
modelStruct.modelPar_KVTHOWEW=mod.KVTHOWEW;
modelStruct.d_modelPar_KVTHOWEW_dX=0.0;
modelStruct.modelPar_given_KVTHOWEW=mod.given("KVTHOWEW");
modParamMap["KVTHOWEW"] = &(modelStruct.d_modelPar_KVTHOWEW_dX);
modelStruct.modelPar_KVTHOWELW=mod.KVTHOWELW;
modelStruct.d_modelPar_KVTHOWELW_dX=0.0;
modelStruct.modelPar_given_KVTHOWELW=mod.given("KVTHOWELW");
modParamMap["KVTHOWELW"] = &(modelStruct.d_modelPar_KVTHOWELW_dX);
modelStruct.modelPar_KUOWEO=mod.KUOWEO;
modelStruct.d_modelPar_KUOWEO_dX=0.0;
modelStruct.modelPar_given_KUOWEO=mod.given("KUOWEO");
modParamMap["KUOWEO"] = &(modelStruct.d_modelPar_KUOWEO_dX);
modelStruct.modelPar_KUOWEL=mod.KUOWEL;
modelStruct.d_modelPar_KUOWEL_dX=0.0;
modelStruct.modelPar_given_KUOWEL=mod.given("KUOWEL");
modParamMap["KUOWEL"] = &(modelStruct.d_modelPar_KUOWEL_dX);
modelStruct.modelPar_KUOWEW=mod.KUOWEW;
modelStruct.d_modelPar_KUOWEW_dX=0.0;
modelStruct.modelPar_given_KUOWEW=mod.given("KUOWEW");
modParamMap["KUOWEW"] = &(modelStruct.d_modelPar_KUOWEW_dX);
modelStruct.modelPar_KUOWELW=mod.KUOWELW;
modelStruct.d_modelPar_KUOWELW_dX=0.0;
modelStruct.modelPar_given_KUOWELW=mod.given("KUOWELW");
modParamMap["KUOWELW"] = &(modelStruct.d_modelPar_KUOWELW_dX);
modelStruct.modelPar_RGO=mod.RGO;
modelStruct.d_modelPar_RGO_dX=0.0;
modelStruct.modelPar_given_RGO=mod.given("RGO");
modParamMap["RGO"] = &(modelStruct.d_modelPar_RGO_dX);
modelStruct.modelPar_RINT=mod.RINT;
modelStruct.d_modelPar_RINT_dX=0.0;
modelStruct.modelPar_given_RINT=mod.given("RINT");
modParamMap["RINT"] = &(modelStruct.d_modelPar_RINT_dX);
modelStruct.modelPar_RVPOLY=mod.RVPOLY;
modelStruct.d_modelPar_RVPOLY_dX=0.0;
modelStruct.modelPar_given_RVPOLY=mod.given("RVPOLY");
modParamMap["RVPOLY"] = &(modelStruct.d_modelPar_RVPOLY_dX);
modelStruct.modelPar_RSHG=mod.RSHG;
modelStruct.d_modelPar_RSHG_dX=0.0;
modelStruct.modelPar_given_RSHG=mod.given("RSHG");
modParamMap["RSHG"] = &(modelStruct.d_modelPar_RSHG_dX);
modelStruct.modelPar_DLSIL=mod.DLSIL;
modelStruct.d_modelPar_DLSIL_dX=0.0;
modelStruct.modelPar_given_DLSIL=mod.given("DLSIL");
modParamMap["DLSIL"] = &(modelStruct.d_modelPar_DLSIL_dX);
modelStruct.modelPar_RSH=mod.RSH;
modelStruct.d_modelPar_RSH_dX=0.0;
modelStruct.modelPar_given_RSH=mod.given("RSH");
modParamMap["RSH"] = &(modelStruct.d_modelPar_RSH_dX);
modelStruct.modelPar_RSHD=mod.RSHD;
modelStruct.d_modelPar_RSHD_dX=0.0;
modelStruct.modelPar_given_RSHD=mod.given("RSHD");
modParamMap["RSHD"] = &(modelStruct.d_modelPar_RSHD_dX);
modelStruct.modelPar_RBULKO=mod.RBULKO;
modelStruct.d_modelPar_RBULKO_dX=0.0;
modelStruct.modelPar_given_RBULKO=mod.given("RBULKO");
modParamMap["RBULKO"] = &(modelStruct.d_modelPar_RBULKO_dX);
modelStruct.modelPar_RWELLO=mod.RWELLO;
modelStruct.d_modelPar_RWELLO_dX=0.0;
modelStruct.modelPar_given_RWELLO=mod.given("RWELLO");
modParamMap["RWELLO"] = &(modelStruct.d_modelPar_RWELLO_dX);
modelStruct.modelPar_RJUNSO=mod.RJUNSO;
modelStruct.d_modelPar_RJUNSO_dX=0.0;
modelStruct.modelPar_given_RJUNSO=mod.given("RJUNSO");
modParamMap["RJUNSO"] = &(modelStruct.d_modelPar_RJUNSO_dX);
modelStruct.modelPar_RJUNDO=mod.RJUNDO;
modelStruct.d_modelPar_RJUNDO_dX=0.0;
modelStruct.modelPar_given_RJUNDO=mod.given("RJUNDO");
modParamMap["RJUNDO"] = &(modelStruct.d_modelPar_RJUNDO_dX);
modelStruct.modelPar_SAREF=mod.SAREF;
modelStruct.d_modelPar_SAREF_dX=0.0;
modelStruct.modelPar_given_SAREF=mod.given("SAREF");
modParamMap["SAREF"] = &(modelStruct.d_modelPar_SAREF_dX);
modelStruct.modelPar_SBREF=mod.SBREF;
modelStruct.d_modelPar_SBREF_dX=0.0;
modelStruct.modelPar_given_SBREF=mod.given("SBREF");
modParamMap["SBREF"] = &(modelStruct.d_modelPar_SBREF_dX);
modelStruct.modelPar_WLOD=mod.WLOD;
modelStruct.d_modelPar_WLOD_dX=0.0;
modelStruct.modelPar_given_WLOD=mod.given("WLOD");
modParamMap["WLOD"] = &(modelStruct.d_modelPar_WLOD_dX);
modelStruct.modelPar_KUO=mod.KUO;
modelStruct.d_modelPar_KUO_dX=0.0;
modelStruct.modelPar_given_KUO=mod.given("KUO");
modParamMap["KUO"] = &(modelStruct.d_modelPar_KUO_dX);
modelStruct.modelPar_KVSAT=mod.KVSAT;
modelStruct.d_modelPar_KVSAT_dX=0.0;
modelStruct.modelPar_given_KVSAT=mod.given("KVSAT");
modParamMap["KVSAT"] = &(modelStruct.d_modelPar_KVSAT_dX);
modelStruct.modelPar_TKUO=mod.TKUO;
modelStruct.d_modelPar_TKUO_dX=0.0;
modelStruct.modelPar_given_TKUO=mod.given("TKUO");
modParamMap["TKUO"] = &(modelStruct.d_modelPar_TKUO_dX);
modelStruct.modelPar_LKUO=mod.LKUO;
modelStruct.d_modelPar_LKUO_dX=0.0;
modelStruct.modelPar_given_LKUO=mod.given("LKUO");
modParamMap["LKUO"] = &(modelStruct.d_modelPar_LKUO_dX);
modelStruct.modelPar_WKUO=mod.WKUO;
modelStruct.d_modelPar_WKUO_dX=0.0;
modelStruct.modelPar_given_WKUO=mod.given("WKUO");
modParamMap["WKUO"] = &(modelStruct.d_modelPar_WKUO_dX);
modelStruct.modelPar_PKUO=mod.PKUO;
modelStruct.d_modelPar_PKUO_dX=0.0;
modelStruct.modelPar_given_PKUO=mod.given("PKUO");
modParamMap["PKUO"] = &(modelStruct.d_modelPar_PKUO_dX);
modelStruct.modelPar_LLODKUO=mod.LLODKUO;
modelStruct.d_modelPar_LLODKUO_dX=0.0;
modelStruct.modelPar_given_LLODKUO=mod.given("LLODKUO");
modParamMap["LLODKUO"] = &(modelStruct.d_modelPar_LLODKUO_dX);
modelStruct.modelPar_WLODKUO=mod.WLODKUO;
modelStruct.d_modelPar_WLODKUO_dX=0.0;
modelStruct.modelPar_given_WLODKUO=mod.given("WLODKUO");
modParamMap["WLODKUO"] = &(modelStruct.d_modelPar_WLODKUO_dX);
modelStruct.modelPar_KVTHO=mod.KVTHO;
modelStruct.d_modelPar_KVTHO_dX=0.0;
modelStruct.modelPar_given_KVTHO=mod.given("KVTHO");
modParamMap["KVTHO"] = &(modelStruct.d_modelPar_KVTHO_dX);
modelStruct.modelPar_LKVTHO=mod.LKVTHO;
modelStruct.d_modelPar_LKVTHO_dX=0.0;
modelStruct.modelPar_given_LKVTHO=mod.given("LKVTHO");
modParamMap["LKVTHO"] = &(modelStruct.d_modelPar_LKVTHO_dX);
modelStruct.modelPar_WKVTHO=mod.WKVTHO;
modelStruct.d_modelPar_WKVTHO_dX=0.0;
modelStruct.modelPar_given_WKVTHO=mod.given("WKVTHO");
modParamMap["WKVTHO"] = &(modelStruct.d_modelPar_WKVTHO_dX);
modelStruct.modelPar_PKVTHO=mod.PKVTHO;
modelStruct.d_modelPar_PKVTHO_dX=0.0;
modelStruct.modelPar_given_PKVTHO=mod.given("PKVTHO");
modParamMap["PKVTHO"] = &(modelStruct.d_modelPar_PKVTHO_dX);
modelStruct.modelPar_LLODVTH=mod.LLODVTH;
modelStruct.d_modelPar_LLODVTH_dX=0.0;
modelStruct.modelPar_given_LLODVTH=mod.given("LLODVTH");
modParamMap["LLODVTH"] = &(modelStruct.d_modelPar_LLODVTH_dX);
modelStruct.modelPar_WLODVTH=mod.WLODVTH;
modelStruct.d_modelPar_WLODVTH_dX=0.0;
modelStruct.modelPar_given_WLODVTH=mod.given("WLODVTH");
modParamMap["WLODVTH"] = &(modelStruct.d_modelPar_WLODVTH_dX);
modelStruct.modelPar_STETAO=mod.STETAO;
modelStruct.d_modelPar_STETAO_dX=0.0;
modelStruct.modelPar_given_STETAO=mod.given("STETAO");
modParamMap["STETAO"] = &(modelStruct.d_modelPar_STETAO_dX);
modelStruct.modelPar_LODETAO=mod.LODETAO;
modelStruct.d_modelPar_LODETAO_dX=0.0;
modelStruct.modelPar_given_LODETAO=mod.given("LODETAO");
modParamMap["LODETAO"] = &(modelStruct.d_modelPar_LODETAO_dX);
modelStruct.modelPar_SCREF=mod.SCREF;
modelStruct.d_modelPar_SCREF_dX=0.0;
modelStruct.modelPar_given_SCREF=mod.given("SCREF");
modParamMap["SCREF"] = &(modelStruct.d_modelPar_SCREF_dX);
modelStruct.modelPar_WEB=mod.WEB;
modelStruct.d_modelPar_WEB_dX=0.0;
modelStruct.modelPar_given_WEB=mod.given("WEB");
modParamMap["WEB"] = &(modelStruct.d_modelPar_WEB_dX);
modelStruct.modelPar_WEC=mod.WEC;
modelStruct.d_modelPar_WEC_dX=0.0;
modelStruct.modelPar_given_WEC=mod.given("WEC");
modParamMap["WEC"] = &(modelStruct.d_modelPar_WEC_dX);
modelStruct.modelPar_IMAX=mod.IMAX;
modelStruct.d_modelPar_IMAX_dX=0.0;
modelStruct.modelPar_given_IMAX=mod.given("IMAX");
modParamMap["IMAX"] = &(modelStruct.d_modelPar_IMAX_dX);
modelStruct.modelPar_TRJ=mod.TRJ;
modelStruct.d_modelPar_TRJ_dX=0.0;
modelStruct.modelPar_given_TRJ=mod.given("TRJ");
modParamMap["TRJ"] = &(modelStruct.d_modelPar_TRJ_dX);
modelStruct.modelPar_FREV=mod.FREV;
modelStruct.d_modelPar_FREV_dX=0.0;
modelStruct.modelPar_given_FREV=mod.given("FREV");
modParamMap["FREV"] = &(modelStruct.d_modelPar_FREV_dX);
modelStruct.modelPar_CJORBOT=mod.CJORBOT;
modelStruct.d_modelPar_CJORBOT_dX=0.0;
modelStruct.modelPar_given_CJORBOT=mod.given("CJORBOT");
modParamMap["CJORBOT"] = &(modelStruct.d_modelPar_CJORBOT_dX);
modelStruct.modelPar_CJORSTI=mod.CJORSTI;
modelStruct.d_modelPar_CJORSTI_dX=0.0;
modelStruct.modelPar_given_CJORSTI=mod.given("CJORSTI");
modParamMap["CJORSTI"] = &(modelStruct.d_modelPar_CJORSTI_dX);
modelStruct.modelPar_CJORGAT=mod.CJORGAT;
modelStruct.d_modelPar_CJORGAT_dX=0.0;
modelStruct.modelPar_given_CJORGAT=mod.given("CJORGAT");
modParamMap["CJORGAT"] = &(modelStruct.d_modelPar_CJORGAT_dX);
modelStruct.modelPar_VBIRBOT=mod.VBIRBOT;
modelStruct.d_modelPar_VBIRBOT_dX=0.0;
modelStruct.modelPar_given_VBIRBOT=mod.given("VBIRBOT");
modParamMap["VBIRBOT"] = &(modelStruct.d_modelPar_VBIRBOT_dX);
modelStruct.modelPar_VBIRSTI=mod.VBIRSTI;
modelStruct.d_modelPar_VBIRSTI_dX=0.0;
modelStruct.modelPar_given_VBIRSTI=mod.given("VBIRSTI");
modParamMap["VBIRSTI"] = &(modelStruct.d_modelPar_VBIRSTI_dX);
modelStruct.modelPar_VBIRGAT=mod.VBIRGAT;
modelStruct.d_modelPar_VBIRGAT_dX=0.0;
modelStruct.modelPar_given_VBIRGAT=mod.given("VBIRGAT");
modParamMap["VBIRGAT"] = &(modelStruct.d_modelPar_VBIRGAT_dX);
modelStruct.modelPar_PBOT=mod.PBOT;
modelStruct.d_modelPar_PBOT_dX=0.0;
modelStruct.modelPar_given_PBOT=mod.given("PBOT");
modParamMap["PBOT"] = &(modelStruct.d_modelPar_PBOT_dX);
modelStruct.modelPar_PSTI=mod.PSTI;
modelStruct.d_modelPar_PSTI_dX=0.0;
modelStruct.modelPar_given_PSTI=mod.given("PSTI");
modParamMap["PSTI"] = &(modelStruct.d_modelPar_PSTI_dX);
modelStruct.modelPar_PGAT=mod.PGAT;
modelStruct.d_modelPar_PGAT_dX=0.0;
modelStruct.modelPar_given_PGAT=mod.given("PGAT");
modParamMap["PGAT"] = &(modelStruct.d_modelPar_PGAT_dX);
modelStruct.modelPar_PHIGBOT=mod.PHIGBOT;
modelStruct.d_modelPar_PHIGBOT_dX=0.0;
modelStruct.modelPar_given_PHIGBOT=mod.given("PHIGBOT");
modParamMap["PHIGBOT"] = &(modelStruct.d_modelPar_PHIGBOT_dX);
modelStruct.modelPar_PHIGSTI=mod.PHIGSTI;
modelStruct.d_modelPar_PHIGSTI_dX=0.0;
modelStruct.modelPar_given_PHIGSTI=mod.given("PHIGSTI");
modParamMap["PHIGSTI"] = &(modelStruct.d_modelPar_PHIGSTI_dX);
modelStruct.modelPar_PHIGGAT=mod.PHIGGAT;
modelStruct.d_modelPar_PHIGGAT_dX=0.0;
modelStruct.modelPar_given_PHIGGAT=mod.given("PHIGGAT");
modParamMap["PHIGGAT"] = &(modelStruct.d_modelPar_PHIGGAT_dX);
modelStruct.modelPar_IDSATRBOT=mod.IDSATRBOT;
modelStruct.d_modelPar_IDSATRBOT_dX=0.0;
modelStruct.modelPar_given_IDSATRBOT=mod.given("IDSATRBOT");
modParamMap["IDSATRBOT"] = &(modelStruct.d_modelPar_IDSATRBOT_dX);
modelStruct.modelPar_IDSATRSTI=mod.IDSATRSTI;
modelStruct.d_modelPar_IDSATRSTI_dX=0.0;
modelStruct.modelPar_given_IDSATRSTI=mod.given("IDSATRSTI");
modParamMap["IDSATRSTI"] = &(modelStruct.d_modelPar_IDSATRSTI_dX);
modelStruct.modelPar_IDSATRGAT=mod.IDSATRGAT;
modelStruct.d_modelPar_IDSATRGAT_dX=0.0;
modelStruct.modelPar_given_IDSATRGAT=mod.given("IDSATRGAT");
modParamMap["IDSATRGAT"] = &(modelStruct.d_modelPar_IDSATRGAT_dX);
modelStruct.modelPar_CSRHBOT=mod.CSRHBOT;
modelStruct.d_modelPar_CSRHBOT_dX=0.0;
modelStruct.modelPar_given_CSRHBOT=mod.given("CSRHBOT");
modParamMap["CSRHBOT"] = &(modelStruct.d_modelPar_CSRHBOT_dX);
modelStruct.modelPar_CSRHSTI=mod.CSRHSTI;
modelStruct.d_modelPar_CSRHSTI_dX=0.0;
modelStruct.modelPar_given_CSRHSTI=mod.given("CSRHSTI");
modParamMap["CSRHSTI"] = &(modelStruct.d_modelPar_CSRHSTI_dX);
modelStruct.modelPar_CSRHGAT=mod.CSRHGAT;
modelStruct.d_modelPar_CSRHGAT_dX=0.0;
modelStruct.modelPar_given_CSRHGAT=mod.given("CSRHGAT");
modParamMap["CSRHGAT"] = &(modelStruct.d_modelPar_CSRHGAT_dX);
modelStruct.modelPar_XJUNSTI=mod.XJUNSTI;
modelStruct.d_modelPar_XJUNSTI_dX=0.0;
modelStruct.modelPar_given_XJUNSTI=mod.given("XJUNSTI");
modParamMap["XJUNSTI"] = &(modelStruct.d_modelPar_XJUNSTI_dX);
modelStruct.modelPar_XJUNGAT=mod.XJUNGAT;
modelStruct.d_modelPar_XJUNGAT_dX=0.0;
modelStruct.modelPar_given_XJUNGAT=mod.given("XJUNGAT");
modParamMap["XJUNGAT"] = &(modelStruct.d_modelPar_XJUNGAT_dX);
modelStruct.modelPar_CTATBOT=mod.CTATBOT;
modelStruct.d_modelPar_CTATBOT_dX=0.0;
modelStruct.modelPar_given_CTATBOT=mod.given("CTATBOT");
modParamMap["CTATBOT"] = &(modelStruct.d_modelPar_CTATBOT_dX);
modelStruct.modelPar_CTATSTI=mod.CTATSTI;
modelStruct.d_modelPar_CTATSTI_dX=0.0;
modelStruct.modelPar_given_CTATSTI=mod.given("CTATSTI");
modParamMap["CTATSTI"] = &(modelStruct.d_modelPar_CTATSTI_dX);
modelStruct.modelPar_CTATGAT=mod.CTATGAT;
modelStruct.d_modelPar_CTATGAT_dX=0.0;
modelStruct.modelPar_given_CTATGAT=mod.given("CTATGAT");
modParamMap["CTATGAT"] = &(modelStruct.d_modelPar_CTATGAT_dX);
modelStruct.modelPar_MEFFTATBOT=mod.MEFFTATBOT;
modelStruct.d_modelPar_MEFFTATBOT_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOT=mod.given("MEFFTATBOT");
modParamMap["MEFFTATBOT"] = &(modelStruct.d_modelPar_MEFFTATBOT_dX);
modelStruct.modelPar_MEFFTATSTI=mod.MEFFTATSTI;
modelStruct.d_modelPar_MEFFTATSTI_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTI=mod.given("MEFFTATSTI");
modParamMap["MEFFTATSTI"] = &(modelStruct.d_modelPar_MEFFTATSTI_dX);
modelStruct.modelPar_MEFFTATGAT=mod.MEFFTATGAT;
modelStruct.d_modelPar_MEFFTATGAT_dX=0.0;
modelStruct.modelPar_given_MEFFTATGAT=mod.given("MEFFTATGAT");
modParamMap["MEFFTATGAT"] = &(modelStruct.d_modelPar_MEFFTATGAT_dX);
modelStruct.modelPar_CBBTBOT=mod.CBBTBOT;
modelStruct.d_modelPar_CBBTBOT_dX=0.0;
modelStruct.modelPar_given_CBBTBOT=mod.given("CBBTBOT");
modParamMap["CBBTBOT"] = &(modelStruct.d_modelPar_CBBTBOT_dX);
modelStruct.modelPar_CBBTSTI=mod.CBBTSTI;
modelStruct.d_modelPar_CBBTSTI_dX=0.0;
modelStruct.modelPar_given_CBBTSTI=mod.given("CBBTSTI");
modParamMap["CBBTSTI"] = &(modelStruct.d_modelPar_CBBTSTI_dX);
modelStruct.modelPar_CBBTGAT=mod.CBBTGAT;
modelStruct.d_modelPar_CBBTGAT_dX=0.0;
modelStruct.modelPar_given_CBBTGAT=mod.given("CBBTGAT");
modParamMap["CBBTGAT"] = &(modelStruct.d_modelPar_CBBTGAT_dX);
modelStruct.modelPar_FBBTRBOT=mod.FBBTRBOT;
modelStruct.d_modelPar_FBBTRBOT_dX=0.0;
modelStruct.modelPar_given_FBBTRBOT=mod.given("FBBTRBOT");
modParamMap["FBBTRBOT"] = &(modelStruct.d_modelPar_FBBTRBOT_dX);
modelStruct.modelPar_FBBTRSTI=mod.FBBTRSTI;
modelStruct.d_modelPar_FBBTRSTI_dX=0.0;
modelStruct.modelPar_given_FBBTRSTI=mod.given("FBBTRSTI");
modParamMap["FBBTRSTI"] = &(modelStruct.d_modelPar_FBBTRSTI_dX);
modelStruct.modelPar_FBBTRGAT=mod.FBBTRGAT;
modelStruct.d_modelPar_FBBTRGAT_dX=0.0;
modelStruct.modelPar_given_FBBTRGAT=mod.given("FBBTRGAT");
modParamMap["FBBTRGAT"] = &(modelStruct.d_modelPar_FBBTRGAT_dX);
modelStruct.modelPar_STFBBTBOT=mod.STFBBTBOT;
modelStruct.d_modelPar_STFBBTBOT_dX=0.0;
modelStruct.modelPar_given_STFBBTBOT=mod.given("STFBBTBOT");
modParamMap["STFBBTBOT"] = &(modelStruct.d_modelPar_STFBBTBOT_dX);
modelStruct.modelPar_STFBBTSTI=mod.STFBBTSTI;
modelStruct.d_modelPar_STFBBTSTI_dX=0.0;
modelStruct.modelPar_given_STFBBTSTI=mod.given("STFBBTSTI");
modParamMap["STFBBTSTI"] = &(modelStruct.d_modelPar_STFBBTSTI_dX);
modelStruct.modelPar_STFBBTGAT=mod.STFBBTGAT;
modelStruct.d_modelPar_STFBBTGAT_dX=0.0;
modelStruct.modelPar_given_STFBBTGAT=mod.given("STFBBTGAT");
modParamMap["STFBBTGAT"] = &(modelStruct.d_modelPar_STFBBTGAT_dX);
modelStruct.modelPar_VBRBOT=mod.VBRBOT;
modelStruct.d_modelPar_VBRBOT_dX=0.0;
modelStruct.modelPar_given_VBRBOT=mod.given("VBRBOT");
modParamMap["VBRBOT"] = &(modelStruct.d_modelPar_VBRBOT_dX);
modelStruct.modelPar_VBRSTI=mod.VBRSTI;
modelStruct.d_modelPar_VBRSTI_dX=0.0;
modelStruct.modelPar_given_VBRSTI=mod.given("VBRSTI");
modParamMap["VBRSTI"] = &(modelStruct.d_modelPar_VBRSTI_dX);
modelStruct.modelPar_VBRGAT=mod.VBRGAT;
modelStruct.d_modelPar_VBRGAT_dX=0.0;
modelStruct.modelPar_given_VBRGAT=mod.given("VBRGAT");
modParamMap["VBRGAT"] = &(modelStruct.d_modelPar_VBRGAT_dX);
modelStruct.modelPar_PBRBOT=mod.PBRBOT;
modelStruct.d_modelPar_PBRBOT_dX=0.0;
modelStruct.modelPar_given_PBRBOT=mod.given("PBRBOT");
modParamMap["PBRBOT"] = &(modelStruct.d_modelPar_PBRBOT_dX);
modelStruct.modelPar_PBRSTI=mod.PBRSTI;
modelStruct.d_modelPar_PBRSTI_dX=0.0;
modelStruct.modelPar_given_PBRSTI=mod.given("PBRSTI");
modParamMap["PBRSTI"] = &(modelStruct.d_modelPar_PBRSTI_dX);
modelStruct.modelPar_PBRGAT=mod.PBRGAT;
modelStruct.d_modelPar_PBRGAT_dX=0.0;
modelStruct.modelPar_given_PBRGAT=mod.given("PBRGAT");
modParamMap["PBRGAT"] = &(modelStruct.d_modelPar_PBRGAT_dX);
modelStruct.modelPar_CJORBOTD=mod.CJORBOTD;
modelStruct.d_modelPar_CJORBOTD_dX=0.0;
modelStruct.modelPar_given_CJORBOTD=mod.given("CJORBOTD");
modParamMap["CJORBOTD"] = &(modelStruct.d_modelPar_CJORBOTD_dX);
modelStruct.modelPar_CJORSTID=mod.CJORSTID;
modelStruct.d_modelPar_CJORSTID_dX=0.0;
modelStruct.modelPar_given_CJORSTID=mod.given("CJORSTID");
modParamMap["CJORSTID"] = &(modelStruct.d_modelPar_CJORSTID_dX);
modelStruct.modelPar_CJORGATD=mod.CJORGATD;
modelStruct.d_modelPar_CJORGATD_dX=0.0;
modelStruct.modelPar_given_CJORGATD=mod.given("CJORGATD");
modParamMap["CJORGATD"] = &(modelStruct.d_modelPar_CJORGATD_dX);
modelStruct.modelPar_VBIRBOTD=mod.VBIRBOTD;
modelStruct.d_modelPar_VBIRBOTD_dX=0.0;
modelStruct.modelPar_given_VBIRBOTD=mod.given("VBIRBOTD");
modParamMap["VBIRBOTD"] = &(modelStruct.d_modelPar_VBIRBOTD_dX);
modelStruct.modelPar_VBIRSTID=mod.VBIRSTID;
modelStruct.d_modelPar_VBIRSTID_dX=0.0;
modelStruct.modelPar_given_VBIRSTID=mod.given("VBIRSTID");
modParamMap["VBIRSTID"] = &(modelStruct.d_modelPar_VBIRSTID_dX);
modelStruct.modelPar_VBIRGATD=mod.VBIRGATD;
modelStruct.d_modelPar_VBIRGATD_dX=0.0;
modelStruct.modelPar_given_VBIRGATD=mod.given("VBIRGATD");
modParamMap["VBIRGATD"] = &(modelStruct.d_modelPar_VBIRGATD_dX);
modelStruct.modelPar_PBOTD=mod.PBOTD;
modelStruct.d_modelPar_PBOTD_dX=0.0;
modelStruct.modelPar_given_PBOTD=mod.given("PBOTD");
modParamMap["PBOTD"] = &(modelStruct.d_modelPar_PBOTD_dX);
modelStruct.modelPar_PSTID=mod.PSTID;
modelStruct.d_modelPar_PSTID_dX=0.0;
modelStruct.modelPar_given_PSTID=mod.given("PSTID");
modParamMap["PSTID"] = &(modelStruct.d_modelPar_PSTID_dX);
modelStruct.modelPar_PGATD=mod.PGATD;
modelStruct.d_modelPar_PGATD_dX=0.0;
modelStruct.modelPar_given_PGATD=mod.given("PGATD");
modParamMap["PGATD"] = &(modelStruct.d_modelPar_PGATD_dX);
modelStruct.modelPar_PHIGBOTD=mod.PHIGBOTD;
modelStruct.d_modelPar_PHIGBOTD_dX=0.0;
modelStruct.modelPar_given_PHIGBOTD=mod.given("PHIGBOTD");
modParamMap["PHIGBOTD"] = &(modelStruct.d_modelPar_PHIGBOTD_dX);
modelStruct.modelPar_PHIGSTID=mod.PHIGSTID;
modelStruct.d_modelPar_PHIGSTID_dX=0.0;
modelStruct.modelPar_given_PHIGSTID=mod.given("PHIGSTID");
modParamMap["PHIGSTID"] = &(modelStruct.d_modelPar_PHIGSTID_dX);
modelStruct.modelPar_PHIGGATD=mod.PHIGGATD;
modelStruct.d_modelPar_PHIGGATD_dX=0.0;
modelStruct.modelPar_given_PHIGGATD=mod.given("PHIGGATD");
modParamMap["PHIGGATD"] = &(modelStruct.d_modelPar_PHIGGATD_dX);
modelStruct.modelPar_IDSATRBOTD=mod.IDSATRBOTD;
modelStruct.d_modelPar_IDSATRBOTD_dX=0.0;
modelStruct.modelPar_given_IDSATRBOTD=mod.given("IDSATRBOTD");
modParamMap["IDSATRBOTD"] = &(modelStruct.d_modelPar_IDSATRBOTD_dX);
modelStruct.modelPar_IDSATRSTID=mod.IDSATRSTID;
modelStruct.d_modelPar_IDSATRSTID_dX=0.0;
modelStruct.modelPar_given_IDSATRSTID=mod.given("IDSATRSTID");
modParamMap["IDSATRSTID"] = &(modelStruct.d_modelPar_IDSATRSTID_dX);
modelStruct.modelPar_IDSATRGATD=mod.IDSATRGATD;
modelStruct.d_modelPar_IDSATRGATD_dX=0.0;
modelStruct.modelPar_given_IDSATRGATD=mod.given("IDSATRGATD");
modParamMap["IDSATRGATD"] = &(modelStruct.d_modelPar_IDSATRGATD_dX);
modelStruct.modelPar_CSRHBOTD=mod.CSRHBOTD;
modelStruct.d_modelPar_CSRHBOTD_dX=0.0;
modelStruct.modelPar_given_CSRHBOTD=mod.given("CSRHBOTD");
modParamMap["CSRHBOTD"] = &(modelStruct.d_modelPar_CSRHBOTD_dX);
modelStruct.modelPar_CSRHSTID=mod.CSRHSTID;
modelStruct.d_modelPar_CSRHSTID_dX=0.0;
modelStruct.modelPar_given_CSRHSTID=mod.given("CSRHSTID");
modParamMap["CSRHSTID"] = &(modelStruct.d_modelPar_CSRHSTID_dX);
modelStruct.modelPar_CSRHGATD=mod.CSRHGATD;
modelStruct.d_modelPar_CSRHGATD_dX=0.0;
modelStruct.modelPar_given_CSRHGATD=mod.given("CSRHGATD");
modParamMap["CSRHGATD"] = &(modelStruct.d_modelPar_CSRHGATD_dX);
modelStruct.modelPar_XJUNSTID=mod.XJUNSTID;
modelStruct.d_modelPar_XJUNSTID_dX=0.0;
modelStruct.modelPar_given_XJUNSTID=mod.given("XJUNSTID");
modParamMap["XJUNSTID"] = &(modelStruct.d_modelPar_XJUNSTID_dX);
modelStruct.modelPar_XJUNGATD=mod.XJUNGATD;
modelStruct.d_modelPar_XJUNGATD_dX=0.0;
modelStruct.modelPar_given_XJUNGATD=mod.given("XJUNGATD");
modParamMap["XJUNGATD"] = &(modelStruct.d_modelPar_XJUNGATD_dX);
modelStruct.modelPar_CTATBOTD=mod.CTATBOTD;
modelStruct.d_modelPar_CTATBOTD_dX=0.0;
modelStruct.modelPar_given_CTATBOTD=mod.given("CTATBOTD");
modParamMap["CTATBOTD"] = &(modelStruct.d_modelPar_CTATBOTD_dX);
modelStruct.modelPar_CTATSTID=mod.CTATSTID;
modelStruct.d_modelPar_CTATSTID_dX=0.0;
modelStruct.modelPar_given_CTATSTID=mod.given("CTATSTID");
modParamMap["CTATSTID"] = &(modelStruct.d_modelPar_CTATSTID_dX);
modelStruct.modelPar_CTATGATD=mod.CTATGATD;
modelStruct.d_modelPar_CTATGATD_dX=0.0;
modelStruct.modelPar_given_CTATGATD=mod.given("CTATGATD");
modParamMap["CTATGATD"] = &(modelStruct.d_modelPar_CTATGATD_dX);
modelStruct.modelPar_MEFFTATBOTD=mod.MEFFTATBOTD;
modelStruct.d_modelPar_MEFFTATBOTD_dX=0.0;
modelStruct.modelPar_given_MEFFTATBOTD=mod.given("MEFFTATBOTD");
modParamMap["MEFFTATBOTD"] = &(modelStruct.d_modelPar_MEFFTATBOTD_dX);
modelStruct.modelPar_MEFFTATSTID=mod.MEFFTATSTID;
modelStruct.d_modelPar_MEFFTATSTID_dX=0.0;
modelStruct.modelPar_given_MEFFTATSTID=mod.given("MEFFTATSTID");
modParamMap["MEFFTATSTID"] = &(modelStruct.d_modelPar_MEFFTATSTID_dX);
modelStruct.modelPar_MEFFTATGATD=mod.MEFFTATGATD;
modelStruct.d_modelPar_MEFFTATGATD_dX=0.0;
modelStruct.modelPar_given_MEFFTATGATD=mod.given("MEFFTATGATD");
modParamMap["MEFFTATGATD"] = &(modelStruct.d_modelPar_MEFFTATGATD_dX);
modelStruct.modelPar_CBBTBOTD=mod.CBBTBOTD;
modelStruct.d_modelPar_CBBTBOTD_dX=0.0;
modelStruct.modelPar_given_CBBTBOTD=mod.given("CBBTBOTD");
modParamMap["CBBTBOTD"] = &(modelStruct.d_modelPar_CBBTBOTD_dX);
modelStruct.modelPar_CBBTSTID=mod.CBBTSTID;
modelStruct.d_modelPar_CBBTSTID_dX=0.0;
modelStruct.modelPar_given_CBBTSTID=mod.given("CBBTSTID");
modParamMap["CBBTSTID"] = &(modelStruct.d_modelPar_CBBTSTID_dX);
modelStruct.modelPar_CBBTGATD=mod.CBBTGATD;
modelStruct.d_modelPar_CBBTGATD_dX=0.0;
modelStruct.modelPar_given_CBBTGATD=mod.given("CBBTGATD");
modParamMap["CBBTGATD"] = &(modelStruct.d_modelPar_CBBTGATD_dX);
modelStruct.modelPar_FBBTRBOTD=mod.FBBTRBOTD;
modelStruct.d_modelPar_FBBTRBOTD_dX=0.0;
modelStruct.modelPar_given_FBBTRBOTD=mod.given("FBBTRBOTD");
modParamMap["FBBTRBOTD"] = &(modelStruct.d_modelPar_FBBTRBOTD_dX);
modelStruct.modelPar_FBBTRSTID=mod.FBBTRSTID;
modelStruct.d_modelPar_FBBTRSTID_dX=0.0;
modelStruct.modelPar_given_FBBTRSTID=mod.given("FBBTRSTID");
modParamMap["FBBTRSTID"] = &(modelStruct.d_modelPar_FBBTRSTID_dX);
modelStruct.modelPar_FBBTRGATD=mod.FBBTRGATD;
modelStruct.d_modelPar_FBBTRGATD_dX=0.0;
modelStruct.modelPar_given_FBBTRGATD=mod.given("FBBTRGATD");
modParamMap["FBBTRGATD"] = &(modelStruct.d_modelPar_FBBTRGATD_dX);
modelStruct.modelPar_STFBBTBOTD=mod.STFBBTBOTD;
modelStruct.d_modelPar_STFBBTBOTD_dX=0.0;
modelStruct.modelPar_given_STFBBTBOTD=mod.given("STFBBTBOTD");
modParamMap["STFBBTBOTD"] = &(modelStruct.d_modelPar_STFBBTBOTD_dX);
modelStruct.modelPar_STFBBTSTID=mod.STFBBTSTID;
modelStruct.d_modelPar_STFBBTSTID_dX=0.0;
modelStruct.modelPar_given_STFBBTSTID=mod.given("STFBBTSTID");
modParamMap["STFBBTSTID"] = &(modelStruct.d_modelPar_STFBBTSTID_dX);
modelStruct.modelPar_STFBBTGATD=mod.STFBBTGATD;
modelStruct.d_modelPar_STFBBTGATD_dX=0.0;
modelStruct.modelPar_given_STFBBTGATD=mod.given("STFBBTGATD");
modParamMap["STFBBTGATD"] = &(modelStruct.d_modelPar_STFBBTGATD_dX);
modelStruct.modelPar_VBRBOTD=mod.VBRBOTD;
modelStruct.d_modelPar_VBRBOTD_dX=0.0;
modelStruct.modelPar_given_VBRBOTD=mod.given("VBRBOTD");
modParamMap["VBRBOTD"] = &(modelStruct.d_modelPar_VBRBOTD_dX);
modelStruct.modelPar_VBRSTID=mod.VBRSTID;
modelStruct.d_modelPar_VBRSTID_dX=0.0;
modelStruct.modelPar_given_VBRSTID=mod.given("VBRSTID");
modParamMap["VBRSTID"] = &(modelStruct.d_modelPar_VBRSTID_dX);
modelStruct.modelPar_VBRGATD=mod.VBRGATD;
modelStruct.d_modelPar_VBRGATD_dX=0.0;
modelStruct.modelPar_given_VBRGATD=mod.given("VBRGATD");
modParamMap["VBRGATD"] = &(modelStruct.d_modelPar_VBRGATD_dX);
modelStruct.modelPar_PBRBOTD=mod.PBRBOTD;
modelStruct.d_modelPar_PBRBOTD_dX=0.0;
modelStruct.modelPar_given_PBRBOTD=mod.given("PBRBOTD");
modParamMap["PBRBOTD"] = &(modelStruct.d_modelPar_PBRBOTD_dX);
modelStruct.modelPar_PBRSTID=mod.PBRSTID;
modelStruct.d_modelPar_PBRSTID_dX=0.0;
modelStruct.modelPar_given_PBRSTID=mod.given("PBRSTID");
modParamMap["PBRSTID"] = &(modelStruct.d_modelPar_PBRSTID_dX);
modelStruct.modelPar_PBRGATD=mod.PBRGATD;
modelStruct.d_modelPar_PBRGATD_dX=0.0;
modelStruct.modelPar_given_PBRGATD=mod.given("PBRGATD");
modParamMap["PBRGATD"] = &(modelStruct.d_modelPar_PBRGATD_dX);
modelStruct.modelPar_SWJUNEXP=mod.SWJUNEXP;
modelStruct.d_modelPar_SWJUNEXP_dX=0.0;
modelStruct.modelPar_given_SWJUNEXP=mod.given("SWJUNEXP");
modParamMap["SWJUNEXP"] = &(modelStruct.d_modelPar_SWJUNEXP_dX);
modelStruct.modelPar_VJUNREF=mod.VJUNREF;
modelStruct.d_modelPar_VJUNREF_dX=0.0;
modelStruct.modelPar_given_VJUNREF=mod.given("VJUNREF");
modParamMap["VJUNREF"] = &(modelStruct.d_modelPar_VJUNREF_dX);
modelStruct.modelPar_FJUNQ=mod.FJUNQ;
modelStruct.d_modelPar_FJUNQ_dX=0.0;
modelStruct.modelPar_given_FJUNQ=mod.given("FJUNQ");
modParamMap["FJUNQ"] = &(modelStruct.d_modelPar_FJUNQ_dX);
modelStruct.modelPar_VJUNREFD=mod.VJUNREFD;
modelStruct.d_modelPar_VJUNREFD_dX=0.0;
modelStruct.modelPar_given_VJUNREFD=mod.given("VJUNREFD");
modParamMap["VJUNREFD"] = &(modelStruct.d_modelPar_VJUNREFD_dX);
modelStruct.modelPar_FJUNQD=mod.FJUNQD;
modelStruct.d_modelPar_FJUNQD_dX=0.0;
modelStruct.modelPar_given_FJUNQD=mod.given("FJUNQD");
modParamMap["FJUNQD"] = &(modelStruct.d_modelPar_FJUNQD_dX);
modelStruct.modelPar_DTA=mod.DTA;
modelStruct.d_modelPar_DTA_dX=0.0;
modelStruct.modelPar_given_DTA=mod.given("DTA");
modParamMap["DTA"] = &(modelStruct.d_modelPar_DTA_dX);


// hidden reals


// non-reals (including hiddens)
modelStruct.modelPar_LEVEL=mod.LEVEL;
modelStruct.modelPar_given_LEVEL=mod.given("LEVEL");
modelStruct.modelPar_TYPE=mod.TYPE;
modelStruct.modelPar_given_TYPE=mod.given("TYPE");
modelStruct.modelPar_SWGEO=mod.SWGEO;
modelStruct.modelPar_given_SWGEO=mod.given("SWGEO");
modelStruct.modelPar_SWIGATE=mod.SWIGATE;
modelStruct.modelPar_given_SWIGATE=mod.given("SWIGATE");
modelStruct.modelPar_SWIMPACT=mod.SWIMPACT;
modelStruct.modelPar_given_SWIMPACT=mod.given("SWIMPACT");
modelStruct.modelPar_SWGIDL=mod.SWGIDL;
modelStruct.modelPar_given_SWGIDL=mod.given("SWGIDL");
modelStruct.modelPar_SWJUNCAP=mod.SWJUNCAP;
modelStruct.modelPar_given_SWJUNCAP=mod.given("SWJUNCAP");
modelStruct.modelPar_SWJUNASYM=mod.SWJUNASYM;
modelStruct.modelPar_given_SWJUNASYM=mod.given("SWJUNASYM");
modelStruct.modelPar_SWNUD=mod.SWNUD;
modelStruct.modelPar_given_SWNUD=mod.given("SWNUD");
modelStruct.modelPar_SWEDGE=mod.SWEDGE;
modelStruct.modelPar_given_SWEDGE=mod.given("SWEDGE");
modelStruct.modelPar_SWDELVTAC=mod.SWDELVTAC;
modelStruct.modelPar_given_SWDELVTAC=mod.given("SWDELVTAC");
modelStruct.modelPar_SWIGN=mod.SWIGN;
modelStruct.modelPar_given_SWIGN=mod.given("SWIGN");


// Set the one parameter whose name was passed in to be the independent
// variable for differentiation purposes.  Since we stored variable pointers, this
// makes sure that that ONE variable gets set right.
// FIXME: make this check name for presence first!  Segfault on invalid.
*(modParamMap[name])=1.0;

//make local copies of all model vars
//reals
modelStruct.modelVar_TOXO_i=mod.TOXO_i;
modelStruct.d_modelVar_TOXO_i_dX=0.0;
modelStruct.modelVar_EPSROXO_i=mod.EPSROXO_i;
modelStruct.d_modelVar_EPSROXO_i_dX=0.0;
modelStruct.modelVar_NSUBO_i=mod.NSUBO_i;
modelStruct.d_modelVar_NSUBO_i_dX=0.0;
modelStruct.modelVar_WSEG_i=mod.WSEG_i;
modelStruct.d_modelVar_WSEG_i_dX=0.0;
modelStruct.modelVar_NPCK_i=mod.NPCK_i;
modelStruct.d_modelVar_NPCK_i_dX=0.0;
modelStruct.modelVar_WSEGP_i=mod.WSEGP_i;
modelStruct.d_modelVar_WSEGP_i_dX=0.0;
modelStruct.modelVar_LPCK_i=mod.LPCK_i;
modelStruct.d_modelVar_LPCK_i_dX=0.0;
modelStruct.modelVar_TOXOVO_i=mod.TOXOVO_i;
modelStruct.d_modelVar_TOXOVO_i_dX=0.0;
modelStruct.modelVar_TOXOVDO_i=mod.TOXOVDO_i;
modelStruct.d_modelVar_TOXOVDO_i_dX=0.0;
modelStruct.modelVar_LOV_i=mod.LOV_i;
modelStruct.d_modelVar_LOV_i_dX=0.0;
modelStruct.modelVar_LOVD_i=mod.LOVD_i;
modelStruct.d_modelVar_LOVD_i_dX=0.0;
modelStruct.modelVar_LP1_i=mod.LP1_i;
modelStruct.d_modelVar_LP1_i_dX=0.0;
modelStruct.modelVar_LP2_i=mod.LP2_i;
modelStruct.d_modelVar_LP2_i_dX=0.0;
modelStruct.modelVar_WBET_i=mod.WBET_i;
modelStruct.d_modelVar_WBET_i_dX=0.0;
modelStruct.modelVar_AXL_i=mod.AXL_i;
modelStruct.d_modelVar_AXL_i_dX=0.0;
modelStruct.modelVar_ALP1L2_i=mod.ALP1L2_i;
modelStruct.d_modelVar_ALP1L2_i_dX=0.0;
modelStruct.modelVar_ALP2L2_i=mod.ALP2L2_i;
modelStruct.d_modelVar_ALP2L2_i_dX=0.0;
modelStruct.modelVar_SAREF_i=mod.SAREF_i;
modelStruct.d_modelVar_SAREF_i_dX=0.0;
modelStruct.modelVar_SBREF_i=mod.SBREF_i;
modelStruct.d_modelVar_SBREF_i_dX=0.0;
modelStruct.modelVar_KVSAT_i=mod.KVSAT_i;
modelStruct.d_modelVar_KVSAT_i_dX=0.0;
modelStruct.modelVar_LLODKUO_i=mod.LLODKUO_i;
modelStruct.d_modelVar_LLODKUO_i_dX=0.0;
modelStruct.modelVar_WLODKUO_i=mod.WLODKUO_i;
modelStruct.d_modelVar_WLODKUO_i_dX=0.0;
modelStruct.modelVar_LLODVTH_i=mod.LLODVTH_i;
modelStruct.d_modelVar_LLODVTH_i_dX=0.0;
modelStruct.modelVar_WLODVTH_i=mod.WLODVTH_i;
modelStruct.d_modelVar_WLODVTH_i_dX=0.0;
modelStruct.modelVar_LODETAO_i=mod.LODETAO_i;
modelStruct.d_modelVar_LODETAO_i_dX=0.0;
modelStruct.modelVar_SCREF_i=mod.SCREF_i;
modelStruct.d_modelVar_SCREF_i_dX=0.0;
modelStruct.modelVar_WEB_i=mod.WEB_i;
modelStruct.d_modelVar_WEB_i_dX=0.0;
modelStruct.modelVar_WEC_i=mod.WEC_i;
modelStruct.d_modelVar_WEC_i_dX=0.0;
modelStruct.modelVar_RSHG_i=mod.RSHG_i;
modelStruct.d_modelVar_RSHG_i_dX=0.0;
modelStruct.modelVar_RSH_i=mod.RSH_i;
modelStruct.d_modelVar_RSH_i_dX=0.0;
modelStruct.modelVar_RSHD_i=mod.RSHD_i;
modelStruct.d_modelVar_RSHD_i_dX=0.0;
modelStruct.modelVar_RINT_i=mod.RINT_i;
modelStruct.d_modelVar_RINT_i_dX=0.0;
modelStruct.modelVar_RVPOLY_i=mod.RVPOLY_i;
modelStruct.d_modelVar_RVPOLY_i_dX=0.0;
modelStruct.modelVar_NSUBEDGEO_i=mod.NSUBEDGEO_i;
modelStruct.d_modelVar_NSUBEDGEO_i_dX=0.0;
modelStruct.modelVar_LPEDGE_i=mod.LPEDGE_i;
modelStruct.d_modelVar_LPEDGE_i_dX=0.0;
modelStruct.modelVar_QMC_i=mod.QMC_i;
modelStruct.d_modelVar_QMC_i_dX=0.0;
modelStruct.modelVar_rTa=mod.rTa;
modelStruct.d_modelVar_rTa_dX=0.0;
modelStruct.modelVar_delTa=mod.delTa;
modelStruct.d_modelVar_delTa_dX=0.0;
modelStruct.modelVar_phita=mod.phita;
modelStruct.d_modelVar_phita_dX=0.0;
modelStruct.modelVar_inv_phita=mod.inv_phita;
modelStruct.d_modelVar_inv_phita_dX=0.0;
modelStruct.modelVar_TKD=mod.TKD;
modelStruct.d_modelVar_TKD_dX=0.0;
modelStruct.modelVar_delT=mod.delT;
modelStruct.d_modelVar_delT_dX=0.0;
modelStruct.modelVar_rTn=mod.rTn;
modelStruct.d_modelVar_rTn_dX=0.0;
modelStruct.modelVar_ln_rTn=mod.ln_rTn;
modelStruct.d_modelVar_ln_rTn_dX=0.0;
modelStruct.modelVar_inv_phit=mod.inv_phit;
modelStruct.d_modelVar_inv_phit_dX=0.0;
modelStruct.modelVar_Eg=mod.Eg;
modelStruct.d_modelVar_Eg_dX=0.0;
modelStruct.modelVar_phibFac=mod.phibFac;
modelStruct.d_modelVar_phibFac_dX=0.0;
modelStruct.modelVar_IMAX_i=mod.IMAX_i;
modelStruct.d_modelVar_IMAX_i_dX=0.0;
modelStruct.modelVar_VBIRBOT_i=mod.VBIRBOT_i;
modelStruct.d_modelVar_VBIRBOT_i_dX=0.0;
modelStruct.modelVar_VBIRSTI_i=mod.VBIRSTI_i;
modelStruct.d_modelVar_VBIRSTI_i_dX=0.0;
modelStruct.modelVar_VBIRGAT_i=mod.VBIRGAT_i;
modelStruct.d_modelVar_VBIRGAT_i_dX=0.0;
modelStruct.modelVar_PBOT_i=mod.PBOT_i;
modelStruct.d_modelVar_PBOT_i_dX=0.0;
modelStruct.modelVar_PSTI_i=mod.PSTI_i;
modelStruct.d_modelVar_PSTI_i_dX=0.0;
modelStruct.modelVar_PGAT_i=mod.PGAT_i;
modelStruct.d_modelVar_PGAT_i_dX=0.0;
modelStruct.modelVar_CSRHBOT_i=mod.CSRHBOT_i;
modelStruct.d_modelVar_CSRHBOT_i_dX=0.0;
modelStruct.modelVar_CSRHSTI_i=mod.CSRHSTI_i;
modelStruct.d_modelVar_CSRHSTI_i_dX=0.0;
modelStruct.modelVar_CSRHGAT_i=mod.CSRHGAT_i;
modelStruct.d_modelVar_CSRHGAT_i_dX=0.0;
modelStruct.modelVar_CTATBOT_i=mod.CTATBOT_i;
modelStruct.d_modelVar_CTATBOT_i_dX=0.0;
modelStruct.modelVar_CTATSTI_i=mod.CTATSTI_i;
modelStruct.d_modelVar_CTATSTI_i_dX=0.0;
modelStruct.modelVar_CTATGAT_i=mod.CTATGAT_i;
modelStruct.d_modelVar_CTATGAT_i_dX=0.0;
modelStruct.modelVar_CBBTBOT_i=mod.CBBTBOT_i;
modelStruct.d_modelVar_CBBTBOT_i_dX=0.0;
modelStruct.modelVar_CBBTSTI_i=mod.CBBTSTI_i;
modelStruct.d_modelVar_CBBTSTI_i_dX=0.0;
modelStruct.modelVar_CBBTGAT_i=mod.CBBTGAT_i;
modelStruct.d_modelVar_CBBTGAT_i_dX=0.0;
modelStruct.modelVar_VBRBOT_i=mod.VBRBOT_i;
modelStruct.d_modelVar_VBRBOT_i_dX=0.0;
modelStruct.modelVar_VBRSTI_i=mod.VBRSTI_i;
modelStruct.d_modelVar_VBRSTI_i_dX=0.0;
modelStruct.modelVar_VBRGAT_i=mod.VBRGAT_i;
modelStruct.d_modelVar_VBRGAT_i_dX=0.0;
modelStruct.modelVar_PBRBOT_i=mod.PBRBOT_i;
modelStruct.d_modelVar_PBRBOT_i_dX=0.0;
modelStruct.modelVar_PBRSTI_i=mod.PBRSTI_i;
modelStruct.d_modelVar_PBRSTI_i_dX=0.0;
modelStruct.modelVar_PBRGAT_i=mod.PBRGAT_i;
modelStruct.d_modelVar_PBRGAT_i_dX=0.0;
modelStruct.modelVar_SWJUNEXP_i=mod.SWJUNEXP_i;
modelStruct.modelVar_VJUNREF_i=mod.VJUNREF_i;
modelStruct.d_modelVar_VJUNREF_i_dX=0.0;
modelStruct.modelVar_FJUNQ_i=mod.FJUNQ_i;
modelStruct.d_modelVar_FJUNQ_i_dX=0.0;
modelStruct.modelVar_phitr=mod.phitr;
modelStruct.d_modelVar_phitr_dX=0.0;
modelStruct.modelVar_phitd=mod.phitd;
modelStruct.d_modelVar_phitd_dX=0.0;
modelStruct.modelVar_phitdinv=mod.phitdinv;
modelStruct.d_modelVar_phitdinv_dX=0.0;
modelStruct.modelVar_perfc=mod.perfc;
modelStruct.modelVar_berfc=mod.berfc;
modelStruct.modelVar_cerfc=mod.cerfc;
modelStruct.modelVar_ftdbot=mod.ftdbot;
modelStruct.d_modelVar_ftdbot_dX=0.0;
modelStruct.modelVar_ftdsti=mod.ftdsti;
modelStruct.d_modelVar_ftdsti_dX=0.0;
modelStruct.modelVar_ftdgat=mod.ftdgat;
modelStruct.d_modelVar_ftdgat_dX=0.0;
modelStruct.modelVar_idsatbot=mod.idsatbot;
modelStruct.d_modelVar_idsatbot_dX=0.0;
modelStruct.modelVar_idsatsti=mod.idsatsti;
modelStruct.d_modelVar_idsatsti_dX=0.0;
modelStruct.modelVar_idsatgat=mod.idsatgat;
modelStruct.d_modelVar_idsatgat_dX=0.0;
modelStruct.modelVar_vbibot=mod.vbibot;
modelStruct.d_modelVar_vbibot_dX=0.0;
modelStruct.modelVar_vbisti=mod.vbisti;
modelStruct.d_modelVar_vbisti_dX=0.0;
modelStruct.modelVar_vbigat=mod.vbigat;
modelStruct.d_modelVar_vbigat_dX=0.0;
modelStruct.modelVar_vbiinvbot=mod.vbiinvbot;
modelStruct.d_modelVar_vbiinvbot_dX=0.0;
modelStruct.modelVar_vbiinvsti=mod.vbiinvsti;
modelStruct.d_modelVar_vbiinvsti_dX=0.0;
modelStruct.modelVar_vbiinvgat=mod.vbiinvgat;
modelStruct.d_modelVar_vbiinvgat_dX=0.0;
modelStruct.modelVar_one_minus_PBOT=mod.one_minus_PBOT;
modelStruct.d_modelVar_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_minus_PSTI=mod.one_minus_PSTI;
modelStruct.d_modelVar_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_minus_PGAT=mod.one_minus_PGAT;
modelStruct.d_modelVar_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT=mod.one_over_one_minus_PBOT;
modelStruct.d_modelVar_one_over_one_minus_PBOT_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI=mod.one_over_one_minus_PSTI;
modelStruct.d_modelVar_one_over_one_minus_PSTI_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT=mod.one_over_one_minus_PGAT;
modelStruct.d_modelVar_one_over_one_minus_PGAT_dX=0.0;
modelStruct.modelVar_cjobot=mod.cjobot;
modelStruct.d_modelVar_cjobot_dX=0.0;
modelStruct.modelVar_cjosti=mod.cjosti;
modelStruct.d_modelVar_cjosti_dX=0.0;
modelStruct.modelVar_cjogat=mod.cjogat;
modelStruct.d_modelVar_cjogat_dX=0.0;
modelStruct.modelVar_qprefbot=mod.qprefbot;
modelStruct.d_modelVar_qprefbot_dX=0.0;
modelStruct.modelVar_qprefsti=mod.qprefsti;
modelStruct.d_modelVar_qprefsti_dX=0.0;
modelStruct.modelVar_qprefgat=mod.qprefgat;
modelStruct.d_modelVar_qprefgat_dX=0.0;
modelStruct.modelVar_qpref2bot=mod.qpref2bot;
modelStruct.d_modelVar_qpref2bot_dX=0.0;
modelStruct.modelVar_qpref2sti=mod.qpref2sti;
modelStruct.d_modelVar_qpref2sti_dX=0.0;
modelStruct.modelVar_qpref2gat=mod.qpref2gat;
modelStruct.d_modelVar_qpref2gat_dX=0.0;
modelStruct.modelVar_wdepnulrbot=mod.wdepnulrbot;
modelStruct.d_modelVar_wdepnulrbot_dX=0.0;
modelStruct.modelVar_wdepnulrsti=mod.wdepnulrsti;
modelStruct.d_modelVar_wdepnulrsti_dX=0.0;
modelStruct.modelVar_wdepnulrgat=mod.wdepnulrgat;
modelStruct.d_modelVar_wdepnulrgat_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot=mod.wdepnulrinvbot;
modelStruct.d_modelVar_wdepnulrinvbot_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti=mod.wdepnulrinvsti;
modelStruct.d_modelVar_wdepnulrinvsti_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat=mod.wdepnulrinvgat;
modelStruct.d_modelVar_wdepnulrinvgat_dX=0.0;
modelStruct.modelVar_VBIRBOTinv=mod.VBIRBOTinv;
modelStruct.d_modelVar_VBIRBOTinv_dX=0.0;
modelStruct.modelVar_VBIRSTIinv=mod.VBIRSTIinv;
modelStruct.d_modelVar_VBIRSTIinv_dX=0.0;
modelStruct.modelVar_VBIRGATinv=mod.VBIRGATinv;
modelStruct.d_modelVar_VBIRGATinv_dX=0.0;
modelStruct.modelVar_atatbot=mod.atatbot;
modelStruct.d_modelVar_atatbot_dX=0.0;
modelStruct.modelVar_atatsti=mod.atatsti;
modelStruct.d_modelVar_atatsti_dX=0.0;
modelStruct.modelVar_atatgat=mod.atatgat;
modelStruct.d_modelVar_atatgat_dX=0.0;
modelStruct.modelVar_btatpartbot=mod.btatpartbot;
modelStruct.d_modelVar_btatpartbot_dX=0.0;
modelStruct.modelVar_btatpartsti=mod.btatpartsti;
modelStruct.d_modelVar_btatpartsti_dX=0.0;
modelStruct.modelVar_btatpartgat=mod.btatpartgat;
modelStruct.d_modelVar_btatpartgat_dX=0.0;
modelStruct.modelVar_fbbtbot=mod.fbbtbot;
modelStruct.d_modelVar_fbbtbot_dX=0.0;
modelStruct.modelVar_fbbtsti=mod.fbbtsti;
modelStruct.d_modelVar_fbbtsti_dX=0.0;
modelStruct.modelVar_fbbtgat=mod.fbbtgat;
modelStruct.d_modelVar_fbbtgat_dX=0.0;
modelStruct.modelVar_alphaav=mod.alphaav;
modelStruct.d_modelVar_alphaav_dX=0.0;
modelStruct.modelVar_fstopbot=mod.fstopbot;
modelStruct.d_modelVar_fstopbot_dX=0.0;
modelStruct.modelVar_fstopsti=mod.fstopsti;
modelStruct.d_modelVar_fstopsti_dX=0.0;
modelStruct.modelVar_fstopgat=mod.fstopgat;
modelStruct.d_modelVar_fstopgat_dX=0.0;
modelStruct.modelVar_VBRinvbot=mod.VBRinvbot;
modelStruct.d_modelVar_VBRinvbot_dX=0.0;
modelStruct.modelVar_VBRinvsti=mod.VBRinvsti;
modelStruct.d_modelVar_VBRinvsti_dX=0.0;
modelStruct.modelVar_VBRinvgat=mod.VBRinvgat;
modelStruct.d_modelVar_VBRinvgat_dX=0.0;
modelStruct.modelVar_slopebot=mod.slopebot;
modelStruct.d_modelVar_slopebot_dX=0.0;
modelStruct.modelVar_slopesti=mod.slopesti;
modelStruct.d_modelVar_slopesti_dX=0.0;
modelStruct.modelVar_slopegat=mod.slopegat;
modelStruct.d_modelVar_slopegat_dX=0.0;
modelStruct.modelVar_VBIRBOTD_i=mod.VBIRBOTD_i;
modelStruct.d_modelVar_VBIRBOTD_i_dX=0.0;
modelStruct.modelVar_VBIRSTID_i=mod.VBIRSTID_i;
modelStruct.d_modelVar_VBIRSTID_i_dX=0.0;
modelStruct.modelVar_VBIRGATD_i=mod.VBIRGATD_i;
modelStruct.d_modelVar_VBIRGATD_i_dX=0.0;
modelStruct.modelVar_PBOTD_i=mod.PBOTD_i;
modelStruct.d_modelVar_PBOTD_i_dX=0.0;
modelStruct.modelVar_PSTID_i=mod.PSTID_i;
modelStruct.d_modelVar_PSTID_i_dX=0.0;
modelStruct.modelVar_PGATD_i=mod.PGATD_i;
modelStruct.d_modelVar_PGATD_i_dX=0.0;
modelStruct.modelVar_CSRHBOTD_i=mod.CSRHBOTD_i;
modelStruct.d_modelVar_CSRHBOTD_i_dX=0.0;
modelStruct.modelVar_CSRHSTID_i=mod.CSRHSTID_i;
modelStruct.d_modelVar_CSRHSTID_i_dX=0.0;
modelStruct.modelVar_CSRHGATD_i=mod.CSRHGATD_i;
modelStruct.d_modelVar_CSRHGATD_i_dX=0.0;
modelStruct.modelVar_CTATBOTD_i=mod.CTATBOTD_i;
modelStruct.d_modelVar_CTATBOTD_i_dX=0.0;
modelStruct.modelVar_CTATSTID_i=mod.CTATSTID_i;
modelStruct.d_modelVar_CTATSTID_i_dX=0.0;
modelStruct.modelVar_CTATGATD_i=mod.CTATGATD_i;
modelStruct.d_modelVar_CTATGATD_i_dX=0.0;
modelStruct.modelVar_CBBTBOTD_i=mod.CBBTBOTD_i;
modelStruct.d_modelVar_CBBTBOTD_i_dX=0.0;
modelStruct.modelVar_CBBTSTID_i=mod.CBBTSTID_i;
modelStruct.d_modelVar_CBBTSTID_i_dX=0.0;
modelStruct.modelVar_CBBTGATD_i=mod.CBBTGATD_i;
modelStruct.d_modelVar_CBBTGATD_i_dX=0.0;
modelStruct.modelVar_VBRBOTD_i=mod.VBRBOTD_i;
modelStruct.d_modelVar_VBRBOTD_i_dX=0.0;
modelStruct.modelVar_VBRSTID_i=mod.VBRSTID_i;
modelStruct.d_modelVar_VBRSTID_i_dX=0.0;
modelStruct.modelVar_VBRGATD_i=mod.VBRGATD_i;
modelStruct.d_modelVar_VBRGATD_i_dX=0.0;
modelStruct.modelVar_PBRBOTD_i=mod.PBRBOTD_i;
modelStruct.d_modelVar_PBRBOTD_i_dX=0.0;
modelStruct.modelVar_PBRSTID_i=mod.PBRSTID_i;
modelStruct.d_modelVar_PBRSTID_i_dX=0.0;
modelStruct.modelVar_PBRGATD_i=mod.PBRGATD_i;
modelStruct.d_modelVar_PBRGATD_i_dX=0.0;
modelStruct.modelVar_VJUNREFD_i=mod.VJUNREFD_i;
modelStruct.d_modelVar_VJUNREFD_i_dX=0.0;
modelStruct.modelVar_FJUNQD_i=mod.FJUNQD_i;
modelStruct.d_modelVar_FJUNQD_i_dX=0.0;
modelStruct.modelVar_ftdbot_d=mod.ftdbot_d;
modelStruct.d_modelVar_ftdbot_d_dX=0.0;
modelStruct.modelVar_ftdsti_d=mod.ftdsti_d;
modelStruct.d_modelVar_ftdsti_d_dX=0.0;
modelStruct.modelVar_ftdgat_d=mod.ftdgat_d;
modelStruct.d_modelVar_ftdgat_d_dX=0.0;
modelStruct.modelVar_idsatbot_d=mod.idsatbot_d;
modelStruct.d_modelVar_idsatbot_d_dX=0.0;
modelStruct.modelVar_idsatsti_d=mod.idsatsti_d;
modelStruct.d_modelVar_idsatsti_d_dX=0.0;
modelStruct.modelVar_idsatgat_d=mod.idsatgat_d;
modelStruct.d_modelVar_idsatgat_d_dX=0.0;
modelStruct.modelVar_vbibot_d=mod.vbibot_d;
modelStruct.d_modelVar_vbibot_d_dX=0.0;
modelStruct.modelVar_vbisti_d=mod.vbisti_d;
modelStruct.d_modelVar_vbisti_d_dX=0.0;
modelStruct.modelVar_vbigat_d=mod.vbigat_d;
modelStruct.d_modelVar_vbigat_d_dX=0.0;
modelStruct.modelVar_vbiinvbot_d=mod.vbiinvbot_d;
modelStruct.d_modelVar_vbiinvbot_d_dX=0.0;
modelStruct.modelVar_vbiinvsti_d=mod.vbiinvsti_d;
modelStruct.d_modelVar_vbiinvsti_d_dX=0.0;
modelStruct.modelVar_vbiinvgat_d=mod.vbiinvgat_d;
modelStruct.d_modelVar_vbiinvgat_d_dX=0.0;
modelStruct.modelVar_one_minus_PBOT_d=mod.one_minus_PBOT_d;
modelStruct.d_modelVar_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_minus_PSTI_d=mod.one_minus_PSTI_d;
modelStruct.d_modelVar_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_minus_PGAT_d=mod.one_minus_PGAT_d;
modelStruct.d_modelVar_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PBOT_d=mod.one_over_one_minus_PBOT_d;
modelStruct.d_modelVar_one_over_one_minus_PBOT_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PSTI_d=mod.one_over_one_minus_PSTI_d;
modelStruct.d_modelVar_one_over_one_minus_PSTI_d_dX=0.0;
modelStruct.modelVar_one_over_one_minus_PGAT_d=mod.one_over_one_minus_PGAT_d;
modelStruct.d_modelVar_one_over_one_minus_PGAT_d_dX=0.0;
modelStruct.modelVar_cjobot_d=mod.cjobot_d;
modelStruct.d_modelVar_cjobot_d_dX=0.0;
modelStruct.modelVar_cjosti_d=mod.cjosti_d;
modelStruct.d_modelVar_cjosti_d_dX=0.0;
modelStruct.modelVar_cjogat_d=mod.cjogat_d;
modelStruct.d_modelVar_cjogat_d_dX=0.0;
modelStruct.modelVar_qprefbot_d=mod.qprefbot_d;
modelStruct.d_modelVar_qprefbot_d_dX=0.0;
modelStruct.modelVar_qprefsti_d=mod.qprefsti_d;
modelStruct.d_modelVar_qprefsti_d_dX=0.0;
modelStruct.modelVar_qprefgat_d=mod.qprefgat_d;
modelStruct.d_modelVar_qprefgat_d_dX=0.0;
modelStruct.modelVar_qpref2bot_d=mod.qpref2bot_d;
modelStruct.d_modelVar_qpref2bot_d_dX=0.0;
modelStruct.modelVar_qpref2sti_d=mod.qpref2sti_d;
modelStruct.d_modelVar_qpref2sti_d_dX=0.0;
modelStruct.modelVar_qpref2gat_d=mod.qpref2gat_d;
modelStruct.d_modelVar_qpref2gat_d_dX=0.0;
modelStruct.modelVar_wdepnulrbot_d=mod.wdepnulrbot_d;
modelStruct.d_modelVar_wdepnulrbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrsti_d=mod.wdepnulrsti_d;
modelStruct.d_modelVar_wdepnulrsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrgat_d=mod.wdepnulrgat_d;
modelStruct.d_modelVar_wdepnulrgat_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvbot_d=mod.wdepnulrinvbot_d;
modelStruct.d_modelVar_wdepnulrinvbot_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvsti_d=mod.wdepnulrinvsti_d;
modelStruct.d_modelVar_wdepnulrinvsti_d_dX=0.0;
modelStruct.modelVar_wdepnulrinvgat_d=mod.wdepnulrinvgat_d;
modelStruct.d_modelVar_wdepnulrinvgat_d_dX=0.0;
modelStruct.modelVar_VBIRBOTinv_d=mod.VBIRBOTinv_d;
modelStruct.d_modelVar_VBIRBOTinv_d_dX=0.0;
modelStruct.modelVar_VBIRSTIinv_d=mod.VBIRSTIinv_d;
modelStruct.d_modelVar_VBIRSTIinv_d_dX=0.0;
modelStruct.modelVar_VBIRGATinv_d=mod.VBIRGATinv_d;
modelStruct.d_modelVar_VBIRGATinv_d_dX=0.0;
modelStruct.modelVar_atatbot_d=mod.atatbot_d;
modelStruct.d_modelVar_atatbot_d_dX=0.0;
modelStruct.modelVar_atatsti_d=mod.atatsti_d;
modelStruct.d_modelVar_atatsti_d_dX=0.0;
modelStruct.modelVar_atatgat_d=mod.atatgat_d;
modelStruct.d_modelVar_atatgat_d_dX=0.0;
modelStruct.modelVar_btatpartbot_d=mod.btatpartbot_d;
modelStruct.d_modelVar_btatpartbot_d_dX=0.0;
modelStruct.modelVar_btatpartsti_d=mod.btatpartsti_d;
modelStruct.d_modelVar_btatpartsti_d_dX=0.0;
modelStruct.modelVar_btatpartgat_d=mod.btatpartgat_d;
modelStruct.d_modelVar_btatpartgat_d_dX=0.0;
modelStruct.modelVar_fbbtbot_d=mod.fbbtbot_d;
modelStruct.d_modelVar_fbbtbot_d_dX=0.0;
modelStruct.modelVar_fbbtsti_d=mod.fbbtsti_d;
modelStruct.d_modelVar_fbbtsti_d_dX=0.0;
modelStruct.modelVar_fbbtgat_d=mod.fbbtgat_d;
modelStruct.d_modelVar_fbbtgat_d_dX=0.0;
modelStruct.modelVar_fstopbot_d=mod.fstopbot_d;
modelStruct.d_modelVar_fstopbot_d_dX=0.0;
modelStruct.modelVar_fstopsti_d=mod.fstopsti_d;
modelStruct.d_modelVar_fstopsti_d_dX=0.0;
modelStruct.modelVar_fstopgat_d=mod.fstopgat_d;
modelStruct.d_modelVar_fstopgat_d_dX=0.0;
modelStruct.modelVar_VBRinvbot_d=mod.VBRinvbot_d;
modelStruct.d_modelVar_VBRinvbot_d_dX=0.0;
modelStruct.modelVar_VBRinvsti_d=mod.VBRinvsti_d;
modelStruct.d_modelVar_VBRinvsti_d_dX=0.0;
modelStruct.modelVar_VBRinvgat_d=mod.VBRinvgat_d;
modelStruct.d_modelVar_VBRinvgat_d_dX=0.0;
modelStruct.modelVar_slopebot_d=mod.slopebot_d;
modelStruct.d_modelVar_slopebot_d_dX=0.0;
modelStruct.modelVar_slopesti_d=mod.slopesti_d;
modelStruct.d_modelVar_slopesti_d_dX=0.0;
modelStruct.modelVar_slopegat_d=mod.slopegat_d;
modelStruct.d_modelVar_slopegat_d_dX=0.0;
modelStruct.modelVar_phit=mod.phit;
modelStruct.d_modelVar_phit_dX=0.0;
modelStruct.modelVar_nt0=mod.nt0;
modelStruct.d_modelVar_nt0_dX=0.0;
modelStruct.modelVar_EPSSI=mod.EPSSI;


// non-reals
modelStruct.modelVar_CHNL_TYPE=mod.CHNL_TYPE;
modelStruct.modelVar_SWGEO_i=mod.SWGEO_i;
modelStruct.modelVar_SWIGATE_i=mod.SWIGATE_i;
modelStruct.modelVar_SWIMPACT_i=mod.SWIMPACT_i;
modelStruct.modelVar_SWGIDL_i=mod.SWGIDL_i;
modelStruct.modelVar_SWJUNCAP_i=mod.SWJUNCAP_i;
modelStruct.modelVar_SWJUNASYM_i=mod.SWJUNASYM_i;
modelStruct.modelVar_SWNUD_i=mod.SWNUD_i;
modelStruct.modelVar_SWEDGE_i=mod.SWEDGE_i;
modelStruct.modelVar_SWDELVTAC_i=mod.SWDELVTAC_i;
modelStruct.modelVar_SWIGN_i=mod.SWIGN_i;



// Now loop over all instances and do the deed
int inst=0;
for (std::vector<Instance*>::const_iterator in_it=mod.instanceContainer.begin(); in_it != mod.instanceContainer.end(); ++in_it,++inst)
{

  Instance & in=*(*in_it);
  // initialize contributions to zero (automatically sets derivatives to zero)
  for (int i=0; i < 13+0 ; ++i)
  {
  d_staticContributions_dX[i]=0;
  d_dynamicContributions_dX[i]=0;
  }



  // Copy out all the instance parameters (doubles) into local struct
 instanceSensStruct instanceStruct;

 // reals
instanceStruct.instancePar_L=in.L;
instanceStruct.d_instancePar_L_dX=0.0;
instanceStruct.instancePar_given_L=in.given("L");
instanceStruct.instancePar_W=in.W;
instanceStruct.d_instancePar_W_dX=0.0;
instanceStruct.instancePar_given_W=in.given("W");
instanceStruct.instancePar_SA=in.SA;
instanceStruct.d_instancePar_SA_dX=0.0;
instanceStruct.instancePar_given_SA=in.given("SA");
instanceStruct.instancePar_SB=in.SB;
instanceStruct.d_instancePar_SB_dX=0.0;
instanceStruct.instancePar_given_SB=in.given("SB");
instanceStruct.instancePar_SD=in.SD;
instanceStruct.d_instancePar_SD_dX=0.0;
instanceStruct.instancePar_given_SD=in.given("SD");
instanceStruct.instancePar_SCA=in.SCA;
instanceStruct.d_instancePar_SCA_dX=0.0;
instanceStruct.instancePar_given_SCA=in.given("SCA");
instanceStruct.instancePar_SCB=in.SCB;
instanceStruct.d_instancePar_SCB_dX=0.0;
instanceStruct.instancePar_given_SCB=in.given("SCB");
instanceStruct.instancePar_SCC=in.SCC;
instanceStruct.d_instancePar_SCC_dX=0.0;
instanceStruct.instancePar_given_SCC=in.given("SCC");
instanceStruct.instancePar_SC=in.SC;
instanceStruct.d_instancePar_SC_dX=0.0;
instanceStruct.instancePar_given_SC=in.given("SC");
instanceStruct.instancePar_NF=in.NF;
instanceStruct.d_instancePar_NF_dX=0.0;
instanceStruct.instancePar_given_NF=in.given("NF");
instanceStruct.instancePar_NGCON=in.NGCON;
instanceStruct.d_instancePar_NGCON_dX=0.0;
instanceStruct.instancePar_given_NGCON=in.given("NGCON");
instanceStruct.instancePar_XGW=in.XGW;
instanceStruct.d_instancePar_XGW_dX=0.0;
instanceStruct.instancePar_given_XGW=in.given("XGW");
instanceStruct.instancePar_NRS=in.NRS;
instanceStruct.d_instancePar_NRS_dX=0.0;
instanceStruct.instancePar_given_NRS=in.given("NRS");
instanceStruct.instancePar_NRD=in.NRD;
instanceStruct.d_instancePar_NRD_dX=0.0;
instanceStruct.instancePar_given_NRD=in.given("NRD");
instanceStruct.instancePar_JW=in.JW;
instanceStruct.d_instancePar_JW_dX=0.0;
instanceStruct.instancePar_given_JW=in.given("JW");
instanceStruct.instancePar_DELVTO=in.DELVTO;
instanceStruct.d_instancePar_DELVTO_dX=0.0;
instanceStruct.instancePar_given_DELVTO=in.given("DELVTO");
instanceStruct.instancePar_FACTUO=in.FACTUO;
instanceStruct.d_instancePar_FACTUO_dX=0.0;
instanceStruct.instancePar_given_FACTUO=in.given("FACTUO");
instanceStruct.instancePar_DELVTOEDGE=in.DELVTOEDGE;
instanceStruct.d_instancePar_DELVTOEDGE_dX=0.0;
instanceStruct.instancePar_given_DELVTOEDGE=in.given("DELVTOEDGE");
instanceStruct.instancePar_FACTUOEDGE=in.FACTUOEDGE;
instanceStruct.d_instancePar_FACTUOEDGE_dX=0.0;
instanceStruct.instancePar_given_FACTUOEDGE=in.given("FACTUOEDGE");
instanceStruct.instancePar_ABSOURCE=in.ABSOURCE;
instanceStruct.d_instancePar_ABSOURCE_dX=0.0;
instanceStruct.instancePar_given_ABSOURCE=in.given("ABSOURCE");
instanceStruct.instancePar_LSSOURCE=in.LSSOURCE;
instanceStruct.d_instancePar_LSSOURCE_dX=0.0;
instanceStruct.instancePar_given_LSSOURCE=in.given("LSSOURCE");
instanceStruct.instancePar_LGSOURCE=in.LGSOURCE;
instanceStruct.d_instancePar_LGSOURCE_dX=0.0;
instanceStruct.instancePar_given_LGSOURCE=in.given("LGSOURCE");
instanceStruct.instancePar_ABDRAIN=in.ABDRAIN;
instanceStruct.d_instancePar_ABDRAIN_dX=0.0;
instanceStruct.instancePar_given_ABDRAIN=in.given("ABDRAIN");
instanceStruct.instancePar_LSDRAIN=in.LSDRAIN;
instanceStruct.d_instancePar_LSDRAIN_dX=0.0;
instanceStruct.instancePar_given_LSDRAIN=in.given("LSDRAIN");
instanceStruct.instancePar_LGDRAIN=in.LGDRAIN;
instanceStruct.d_instancePar_LGDRAIN_dX=0.0;
instanceStruct.instancePar_given_LGDRAIN=in.given("LGDRAIN");
instanceStruct.instancePar_AS=in.AS;
instanceStruct.d_instancePar_AS_dX=0.0;
instanceStruct.instancePar_given_AS=in.given("AS");
instanceStruct.instancePar_PS=in.PS;
instanceStruct.d_instancePar_PS_dX=0.0;
instanceStruct.instancePar_given_PS=in.given("PS");
instanceStruct.instancePar_AD=in.AD;
instanceStruct.d_instancePar_AD_dX=0.0;
instanceStruct.instancePar_given_AD=in.given("AD");
instanceStruct.instancePar_PD=in.PD;
instanceStruct.d_instancePar_PD_dX=0.0;
instanceStruct.instancePar_given_PD=in.given("PD");
instanceStruct.instancePar_MULT=in.MULT;
instanceStruct.d_instancePar_MULT_dX=0.0;
instanceStruct.instancePar_given_MULT=in.given("MULT");


  // real hidden instance


  // Copy all the non-real instance params into vars of their appropriate type:




  // If there are any instance parameters that were not given, and have
  // corresponding model params, copy the model param into the instance.
  // This was already done by the instance constructor, but we do it again
  // because now we're propagating derivatives, and the user could be trying
  // to get sensitivity to the model parameter.


  //make local copies of all instance vars
  //reals
instanceStruct.instanceVar_MULT_i=in.MULT_i;
instanceStruct.d_instanceVar_MULT_i_dX=0.0;
instanceStruct.instanceVar_STVFB_i=in.STVFB_i;
instanceStruct.d_instanceVar_STVFB_i_dX=0.0;
instanceStruct.instanceVar_TOX_i=in.TOX_i;
instanceStruct.d_instanceVar_TOX_i_dX=0.0;
instanceStruct.instanceVar_EPSROX_i=in.EPSROX_i;
instanceStruct.d_instanceVar_EPSROX_i_dX=0.0;
instanceStruct.instanceVar_NEFF_i=in.NEFF_i;
instanceStruct.d_instanceVar_NEFF_i_dX=0.0;
instanceStruct.instanceVar_FACNEFFAC_i=in.FACNEFFAC_i;
instanceStruct.d_instanceVar_FACNEFFAC_i_dX=0.0;
instanceStruct.instanceVar_GFACNUD_i=in.GFACNUD_i;
instanceStruct.d_instanceVar_GFACNUD_i_dX=0.0;
instanceStruct.instanceVar_VSBNUD_i=in.VSBNUD_i;
instanceStruct.d_instanceVar_VSBNUD_i_dX=0.0;
instanceStruct.instanceVar_DVSBNUD_i=in.DVSBNUD_i;
instanceStruct.d_instanceVar_DVSBNUD_i_dX=0.0;
instanceStruct.instanceVar_VNSUB_i=in.VNSUB_i;
instanceStruct.d_instanceVar_VNSUB_i_dX=0.0;
instanceStruct.instanceVar_NSLP_i=in.NSLP_i;
instanceStruct.d_instanceVar_NSLP_i_dX=0.0;
instanceStruct.instanceVar_DNSUB_i=in.DNSUB_i;
instanceStruct.d_instanceVar_DNSUB_i_dX=0.0;
instanceStruct.instanceVar_DPHIB_i=in.DPHIB_i;
instanceStruct.d_instanceVar_DPHIB_i_dX=0.0;
instanceStruct.instanceVar_DELVTAC_i=in.DELVTAC_i;
instanceStruct.d_instanceVar_DELVTAC_i_dX=0.0;
instanceStruct.instanceVar_NP_i=in.NP_i;
instanceStruct.d_instanceVar_NP_i_dX=0.0;
instanceStruct.instanceVar_CT_i=in.CT_i;
instanceStruct.d_instanceVar_CT_i_dX=0.0;
instanceStruct.instanceVar_TOXOV_i=in.TOXOV_i;
instanceStruct.d_instanceVar_TOXOV_i_dX=0.0;
instanceStruct.instanceVar_TOXOVD_i=in.TOXOVD_i;
instanceStruct.d_instanceVar_TOXOVD_i_dX=0.0;
instanceStruct.instanceVar_NOV_i=in.NOV_i;
instanceStruct.d_instanceVar_NOV_i_dX=0.0;
instanceStruct.instanceVar_NOVD_i=in.NOVD_i;
instanceStruct.d_instanceVar_NOVD_i_dX=0.0;
instanceStruct.instanceVar_CF_i=in.CF_i;
instanceStruct.d_instanceVar_CF_i_dX=0.0;
instanceStruct.instanceVar_CFD_i=in.CFD_i;
instanceStruct.d_instanceVar_CFD_i_dX=0.0;
instanceStruct.instanceVar_CFB_i=in.CFB_i;
instanceStruct.d_instanceVar_CFB_i_dX=0.0;
instanceStruct.instanceVar_PSCE_i=in.PSCE_i;
instanceStruct.d_instanceVar_PSCE_i_dX=0.0;
instanceStruct.instanceVar_PSCEB_i=in.PSCEB_i;
instanceStruct.d_instanceVar_PSCEB_i_dX=0.0;
instanceStruct.instanceVar_PSCED_i=in.PSCED_i;
instanceStruct.d_instanceVar_PSCED_i_dX=0.0;
instanceStruct.instanceVar_STBET_i=in.STBET_i;
instanceStruct.d_instanceVar_STBET_i_dX=0.0;
instanceStruct.instanceVar_STMUE_i=in.STMUE_i;
instanceStruct.d_instanceVar_STMUE_i_dX=0.0;
instanceStruct.instanceVar_STTHEMU_i=in.STTHEMU_i;
instanceStruct.d_instanceVar_STTHEMU_i_dX=0.0;
instanceStruct.instanceVar_STCS_i=in.STCS_i;
instanceStruct.d_instanceVar_STCS_i_dX=0.0;
instanceStruct.instanceVar_STXCOR_i=in.STXCOR_i;
instanceStruct.d_instanceVar_STXCOR_i_dX=0.0;
instanceStruct.instanceVar_FETA_i=in.FETA_i;
instanceStruct.d_instanceVar_FETA_i_dX=0.0;
instanceStruct.instanceVar_STRS_i=in.STRS_i;
instanceStruct.d_instanceVar_STRS_i_dX=0.0;
instanceStruct.instanceVar_RSB_i=in.RSB_i;
instanceStruct.d_instanceVar_RSB_i_dX=0.0;
instanceStruct.instanceVar_RSG_i=in.RSG_i;
instanceStruct.d_instanceVar_RSG_i_dX=0.0;
instanceStruct.instanceVar_STTHESAT_i=in.STTHESAT_i;
instanceStruct.d_instanceVar_STTHESAT_i_dX=0.0;
instanceStruct.instanceVar_THESATB_i=in.THESATB_i;
instanceStruct.d_instanceVar_THESATB_i_dX=0.0;
instanceStruct.instanceVar_THESATG_i=in.THESATG_i;
instanceStruct.d_instanceVar_THESATG_i_dX=0.0;
instanceStruct.instanceVar_AX_i=in.AX_i;
instanceStruct.d_instanceVar_AX_i_dX=0.0;
instanceStruct.instanceVar_ALP_i=in.ALP_i;
instanceStruct.d_instanceVar_ALP_i_dX=0.0;
instanceStruct.instanceVar_ALP1_i=in.ALP1_i;
instanceStruct.d_instanceVar_ALP1_i_dX=0.0;
instanceStruct.instanceVar_ALP2_i=in.ALP2_i;
instanceStruct.d_instanceVar_ALP2_i_dX=0.0;
instanceStruct.instanceVar_VP_i=in.VP_i;
instanceStruct.d_instanceVar_VP_i_dX=0.0;
instanceStruct.instanceVar_A1_i=in.A1_i;
instanceStruct.d_instanceVar_A1_i_dX=0.0;
instanceStruct.instanceVar_STA2_i=in.STA2_i;
instanceStruct.d_instanceVar_STA2_i_dX=0.0;
instanceStruct.instanceVar_A3_i=in.A3_i;
instanceStruct.d_instanceVar_A3_i_dX=0.0;
instanceStruct.instanceVar_A4_i=in.A4_i;
instanceStruct.d_instanceVar_A4_i_dX=0.0;
instanceStruct.instanceVar_GCO_i=in.GCO_i;
instanceStruct.d_instanceVar_GCO_i_dX=0.0;
instanceStruct.instanceVar_IGINV_i=in.IGINV_i;
instanceStruct.d_instanceVar_IGINV_i_dX=0.0;
instanceStruct.instanceVar_IGOV_i=in.IGOV_i;
instanceStruct.d_instanceVar_IGOV_i_dX=0.0;
instanceStruct.instanceVar_IGOVD_i=in.IGOVD_i;
instanceStruct.d_instanceVar_IGOVD_i_dX=0.0;
instanceStruct.instanceVar_STIG_i=in.STIG_i;
instanceStruct.d_instanceVar_STIG_i_dX=0.0;
instanceStruct.instanceVar_GC2_i=in.GC2_i;
instanceStruct.d_instanceVar_GC2_i_dX=0.0;
instanceStruct.instanceVar_GC3_i=in.GC3_i;
instanceStruct.d_instanceVar_GC3_i_dX=0.0;
instanceStruct.instanceVar_CHIB_i=in.CHIB_i;
instanceStruct.d_instanceVar_CHIB_i_dX=0.0;
instanceStruct.instanceVar_AGIDL_i=in.AGIDL_i;
instanceStruct.d_instanceVar_AGIDL_i_dX=0.0;
instanceStruct.instanceVar_AGIDLD_i=in.AGIDLD_i;
instanceStruct.d_instanceVar_AGIDLD_i_dX=0.0;
instanceStruct.instanceVar_STBGIDL_i=in.STBGIDL_i;
instanceStruct.d_instanceVar_STBGIDL_i_dX=0.0;
instanceStruct.instanceVar_STBGIDLD_i=in.STBGIDLD_i;
instanceStruct.d_instanceVar_STBGIDLD_i_dX=0.0;
instanceStruct.instanceVar_CGIDL_i=in.CGIDL_i;
instanceStruct.d_instanceVar_CGIDL_i_dX=0.0;
instanceStruct.instanceVar_CGIDLD_i=in.CGIDLD_i;
instanceStruct.d_instanceVar_CGIDLD_i_dX=0.0;
instanceStruct.instanceVar_COX_i=in.COX_i;
instanceStruct.d_instanceVar_COX_i_dX=0.0;
instanceStruct.instanceVar_CGOV_i=in.CGOV_i;
instanceStruct.d_instanceVar_CGOV_i_dX=0.0;
instanceStruct.instanceVar_CGOVD_i=in.CGOVD_i;
instanceStruct.d_instanceVar_CGOVD_i_dX=0.0;
instanceStruct.instanceVar_CGBOV_i=in.CGBOV_i;
instanceStruct.d_instanceVar_CGBOV_i_dX=0.0;
instanceStruct.instanceVar_CFR_i=in.CFR_i;
instanceStruct.d_instanceVar_CFR_i_dX=0.0;
instanceStruct.instanceVar_CFRD_i=in.CFRD_i;
instanceStruct.d_instanceVar_CFRD_i_dX=0.0;
instanceStruct.instanceVar_FNT_i=in.FNT_i;
instanceStruct.d_instanceVar_FNT_i_dX=0.0;
instanceStruct.instanceVar_FNTEXC_i=in.FNTEXC_i;
instanceStruct.d_instanceVar_FNTEXC_i_dX=0.0;
instanceStruct.instanceVar_NFA_i=in.NFA_i;
instanceStruct.d_instanceVar_NFA_i_dX=0.0;
instanceStruct.instanceVar_NFB_i=in.NFB_i;
instanceStruct.d_instanceVar_NFB_i_dX=0.0;
instanceStruct.instanceVar_NFC_i=in.NFC_i;
instanceStruct.d_instanceVar_NFC_i_dX=0.0;
instanceStruct.instanceVar_EF_i=in.EF_i;
instanceStruct.d_instanceVar_EF_i_dX=0.0;
instanceStruct.instanceVar_STVFBEDGE_i=in.STVFBEDGE_i;
instanceStruct.d_instanceVar_STVFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_DPHIBEDGE_i=in.DPHIBEDGE_i;
instanceStruct.d_instanceVar_DPHIBEDGE_i_dX=0.0;
instanceStruct.instanceVar_NEFFEDGE_i=in.NEFFEDGE_i;
instanceStruct.d_instanceVar_NEFFEDGE_i_dX=0.0;
instanceStruct.instanceVar_CTEDGE_i=in.CTEDGE_i;
instanceStruct.d_instanceVar_CTEDGE_i_dX=0.0;
instanceStruct.instanceVar_BETNEDGE_i=in.BETNEDGE_i;
instanceStruct.d_instanceVar_BETNEDGE_i_dX=0.0;
instanceStruct.instanceVar_STBETEDGE_i=in.STBETEDGE_i;
instanceStruct.d_instanceVar_STBETEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEEDGE_i=in.PSCEEDGE_i;
instanceStruct.d_instanceVar_PSCEEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEBEDGE_i=in.PSCEBEDGE_i;
instanceStruct.d_instanceVar_PSCEBEDGE_i_dX=0.0;
instanceStruct.instanceVar_PSCEDEDGE_i=in.PSCEDEDGE_i;
instanceStruct.d_instanceVar_PSCEDEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFEDGE_i=in.CFEDGE_i;
instanceStruct.d_instanceVar_CFEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFDEDGE_i=in.CFDEDGE_i;
instanceStruct.d_instanceVar_CFDEDGE_i_dX=0.0;
instanceStruct.instanceVar_CFBEDGE_i=in.CFBEDGE_i;
instanceStruct.d_instanceVar_CFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_FNTEDGE_i=in.FNTEDGE_i;
instanceStruct.d_instanceVar_FNTEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFAEDGE_i=in.NFAEDGE_i;
instanceStruct.d_instanceVar_NFAEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFBEDGE_i=in.NFBEDGE_i;
instanceStruct.d_instanceVar_NFBEDGE_i_dX=0.0;
instanceStruct.instanceVar_NFCEDGE_i=in.NFCEDGE_i;
instanceStruct.d_instanceVar_NFCEDGE_i_dX=0.0;
instanceStruct.instanceVar_EFEDGE_i=in.EFEDGE_i;
instanceStruct.d_instanceVar_EFEDGE_i_dX=0.0;
instanceStruct.instanceVar_RG_i=in.RG_i;
instanceStruct.d_instanceVar_RG_i_dX=0.0;
instanceStruct.instanceVar_RSE_i=in.RSE_i;
instanceStruct.d_instanceVar_RSE_i_dX=0.0;
instanceStruct.instanceVar_RDE_i=in.RDE_i;
instanceStruct.d_instanceVar_RDE_i_dX=0.0;
instanceStruct.instanceVar_RBULK_i=in.RBULK_i;
instanceStruct.d_instanceVar_RBULK_i_dX=0.0;
instanceStruct.instanceVar_RJUNS_i=in.RJUNS_i;
instanceStruct.d_instanceVar_RJUNS_i_dX=0.0;
instanceStruct.instanceVar_RJUND_i=in.RJUND_i;
instanceStruct.d_instanceVar_RJUND_i_dX=0.0;
instanceStruct.instanceVar_RWELL_i=in.RWELL_i;
instanceStruct.d_instanceVar_RWELL_i_dX=0.0;
instanceStruct.instanceVar_LE=in.LE;
instanceStruct.d_instanceVar_LE_dX=0.0;
instanceStruct.instanceVar_WE=in.WE;
instanceStruct.d_instanceVar_WE_dX=0.0;
instanceStruct.instanceVar_ABSOURCE_i=in.ABSOURCE_i;
instanceStruct.d_instanceVar_ABSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LSSOURCE_i=in.LSSOURCE_i;
instanceStruct.d_instanceVar_LSSOURCE_i_dX=0.0;
instanceStruct.instanceVar_LGSOURCE_i=in.LGSOURCE_i;
instanceStruct.d_instanceVar_LGSOURCE_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_s=in.zflagbot_s;
instanceStruct.instanceVar_zflagsti_s=in.zflagsti_s;
instanceStruct.instanceVar_zflaggat_s=in.zflaggat_s;
instanceStruct.instanceVar_VMAX_s=in.VMAX_s;
instanceStruct.d_instanceVar_VMAX_s_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_s=in.exp_VMAX_over_phitd_s;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_s_dX=0.0;
instanceStruct.instanceVar_vbimin_s=in.vbimin_s;
instanceStruct.d_instanceVar_vbimin_s_dX=0.0;
instanceStruct.instanceVar_vch_s=in.vch_s;
instanceStruct.d_instanceVar_vch_s_dX=0.0;
instanceStruct.instanceVar_vfmin_s=in.vfmin_s;
instanceStruct.d_instanceVar_vfmin_s_dX=0.0;
instanceStruct.instanceVar_vbbtlim_s=in.vbbtlim_s;
instanceStruct.d_instanceVar_vbbtlim_s_dX=0.0;
instanceStruct.instanceVar_xhighf1_s=in.xhighf1_s;
instanceStruct.d_instanceVar_xhighf1_s_dX=0.0;
instanceStruct.instanceVar_expxhf1_s=in.expxhf1_s;
instanceStruct.d_instanceVar_expxhf1_s_dX=0.0;
instanceStruct.instanceVar_xhighf2_s=in.xhighf2_s;
instanceStruct.d_instanceVar_xhighf2_s_dX=0.0;
instanceStruct.instanceVar_expxhf2_s=in.expxhf2_s;
instanceStruct.d_instanceVar_expxhf2_s_dX=0.0;
instanceStruct.instanceVar_xhighr_s=in.xhighr_s;
instanceStruct.d_instanceVar_xhighr_s_dX=0.0;
instanceStruct.instanceVar_expxhr_s=in.expxhr_s;
instanceStruct.d_instanceVar_expxhr_s_dX=0.0;
instanceStruct.instanceVar_m0flag_s=in.m0flag_s;
instanceStruct.instanceVar_ISATFOR1_s=in.ISATFOR1_s;
instanceStruct.d_instanceVar_ISATFOR1_s_dX=0.0;
instanceStruct.instanceVar_MFOR1_s=in.MFOR1_s;
instanceStruct.instanceVar_ISATFOR2_s=in.ISATFOR2_s;
instanceStruct.d_instanceVar_ISATFOR2_s_dX=0.0;
instanceStruct.instanceVar_MFOR2_s=in.MFOR2_s;
instanceStruct.d_instanceVar_MFOR2_s_dX=0.0;
instanceStruct.instanceVar_ISATREV_s=in.ISATREV_s;
instanceStruct.d_instanceVar_ISATREV_s_dX=0.0;
instanceStruct.instanceVar_MREV_s=in.MREV_s;
instanceStruct.d_instanceVar_MREV_s_dX=0.0;
instanceStruct.instanceVar_ABDRAIN_i=in.ABDRAIN_i;
instanceStruct.d_instanceVar_ABDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LSDRAIN_i=in.LSDRAIN_i;
instanceStruct.d_instanceVar_LSDRAIN_i_dX=0.0;
instanceStruct.instanceVar_LGDRAIN_i=in.LGDRAIN_i;
instanceStruct.d_instanceVar_LGDRAIN_i_dX=0.0;
instanceStruct.instanceVar_zflagbot_d=in.zflagbot_d;
instanceStruct.instanceVar_zflagsti_d=in.zflagsti_d;
instanceStruct.instanceVar_zflaggat_d=in.zflaggat_d;
instanceStruct.instanceVar_VMAX_d=in.VMAX_d;
instanceStruct.d_instanceVar_VMAX_d_dX=0.0;
instanceStruct.instanceVar_exp_VMAX_over_phitd_d=in.exp_VMAX_over_phitd_d;
instanceStruct.d_instanceVar_exp_VMAX_over_phitd_d_dX=0.0;
instanceStruct.instanceVar_vbimin_d=in.vbimin_d;
instanceStruct.d_instanceVar_vbimin_d_dX=0.0;
instanceStruct.instanceVar_vch_d=in.vch_d;
instanceStruct.d_instanceVar_vch_d_dX=0.0;
instanceStruct.instanceVar_vfmin_d=in.vfmin_d;
instanceStruct.d_instanceVar_vfmin_d_dX=0.0;
instanceStruct.instanceVar_vbbtlim_d=in.vbbtlim_d;
instanceStruct.d_instanceVar_vbbtlim_d_dX=0.0;
instanceStruct.instanceVar_xhighf1_d=in.xhighf1_d;
instanceStruct.d_instanceVar_xhighf1_d_dX=0.0;
instanceStruct.instanceVar_expxhf1_d=in.expxhf1_d;
instanceStruct.d_instanceVar_expxhf1_d_dX=0.0;
instanceStruct.instanceVar_xhighf2_d=in.xhighf2_d;
instanceStruct.d_instanceVar_xhighf2_d_dX=0.0;
instanceStruct.instanceVar_expxhf2_d=in.expxhf2_d;
instanceStruct.d_instanceVar_expxhf2_d_dX=0.0;
instanceStruct.instanceVar_xhighr_d=in.xhighr_d;
instanceStruct.d_instanceVar_xhighr_d_dX=0.0;
instanceStruct.instanceVar_expxhr_d=in.expxhr_d;
instanceStruct.d_instanceVar_expxhr_d_dX=0.0;
instanceStruct.instanceVar_m0flag_d=in.m0flag_d;
instanceStruct.instanceVar_ISATFOR1_d=in.ISATFOR1_d;
instanceStruct.d_instanceVar_ISATFOR1_d_dX=0.0;
instanceStruct.instanceVar_MFOR1_d=in.MFOR1_d;
instanceStruct.instanceVar_ISATFOR2_d=in.ISATFOR2_d;
instanceStruct.d_instanceVar_ISATFOR2_d_dX=0.0;
instanceStruct.instanceVar_MFOR2_d=in.MFOR2_d;
instanceStruct.d_instanceVar_MFOR2_d_dX=0.0;
instanceStruct.instanceVar_ISATREV_d=in.ISATREV_d;
instanceStruct.d_instanceVar_ISATREV_d_dX=0.0;
instanceStruct.instanceVar_MREV_d=in.MREV_d;
instanceStruct.d_instanceVar_MREV_d_dX=0.0;
instanceStruct.instanceVar_VFB_T=in.VFB_T;
instanceStruct.d_instanceVar_VFB_T_dX=0.0;
instanceStruct.instanceVar_BETN_T=in.BETN_T;
instanceStruct.d_instanceVar_BETN_T_dX=0.0;
instanceStruct.instanceVar_MUE_T=in.MUE_T;
instanceStruct.d_instanceVar_MUE_T_dX=0.0;
instanceStruct.instanceVar_THEMU_T=in.THEMU_T;
instanceStruct.d_instanceVar_THEMU_T_dX=0.0;
instanceStruct.instanceVar_CS_T=in.CS_T;
instanceStruct.d_instanceVar_CS_T_dX=0.0;
instanceStruct.instanceVar_XCOR_T=in.XCOR_T;
instanceStruct.d_instanceVar_XCOR_T_dX=0.0;
instanceStruct.instanceVar_RS_T=in.RS_T;
instanceStruct.d_instanceVar_RS_T_dX=0.0;
instanceStruct.instanceVar_BGIDL_T=in.BGIDL_T;
instanceStruct.d_instanceVar_BGIDL_T_dX=0.0;
instanceStruct.instanceVar_BGIDLD_T=in.BGIDLD_T;
instanceStruct.d_instanceVar_BGIDLD_T_dX=0.0;
instanceStruct.instanceVar_A2_T=in.A2_T;
instanceStruct.d_instanceVar_A2_T_dX=0.0;
instanceStruct.instanceVar_VFBEDGE_T=in.VFBEDGE_T;
instanceStruct.d_instanceVar_VFBEDGE_T_dX=0.0;
instanceStruct.instanceVar_BETNEDGE_T=in.BETNEDGE_T;
instanceStruct.d_instanceVar_BETNEDGE_T_dX=0.0;
instanceStruct.instanceVar_phit0=in.phit0;
instanceStruct.d_instanceVar_phit0_dX=0.0;
instanceStruct.instanceVar_BET_i=in.BET_i;
instanceStruct.d_instanceVar_BET_i_dX=0.0;
instanceStruct.instanceVar_BETEDGE_i=in.BETEDGE_i;
instanceStruct.d_instanceVar_BETEDGE_i_dX=0.0;
instanceStruct.instanceVar_nt=in.nt;
instanceStruct.d_instanceVar_nt_dX=0.0;
instanceStruct.instanceVar_THESAT_T=in.THESAT_T;
instanceStruct.d_instanceVar_THESAT_T_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac=in.Sfl_prefac;
instanceStruct.d_instanceVar_Sfl_prefac_dX=0.0;
instanceStruct.instanceVar_phit0edge=in.phit0edge;
instanceStruct.d_instanceVar_phit0edge_dX=0.0;
instanceStruct.instanceVar_Gfedge2=in.Gfedge2;
instanceStruct.d_instanceVar_Gfedge2_dX=0.0;
instanceStruct.instanceVar_lnGfedge2=in.lnGfedge2;
instanceStruct.d_instanceVar_lnGfedge2_dX=0.0;
instanceStruct.instanceVar_Sfl_prefac_edge=in.Sfl_prefac_edge;
instanceStruct.d_instanceVar_Sfl_prefac_edge_dX=0.0;
instanceStruct.instanceVar_ntedge=in.ntedge;
instanceStruct.d_instanceVar_ntedge_dX=0.0;
instanceStruct.instanceVar_phib_dc=in.phib_dc;
instanceStruct.d_instanceVar_phib_dc_dX=0.0;
instanceStruct.instanceVar_G_0_dc=in.G_0_dc;
instanceStruct.d_instanceVar_G_0_dc_dX=0.0;
instanceStruct.instanceVar_kp=in.kp;
instanceStruct.d_instanceVar_kp_dX=0.0;
instanceStruct.instanceVar_qlim2=in.qlim2;
instanceStruct.d_instanceVar_qlim2_dX=0.0;
instanceStruct.instanceVar_sqrt_phib_dc=in.sqrt_phib_dc;
instanceStruct.d_instanceVar_sqrt_phib_dc_dX=0.0;
instanceStruct.instanceVar_phix_dc=in.phix_dc;
instanceStruct.d_instanceVar_phix_dc_dX=0.0;
instanceStruct.instanceVar_aphi_dc=in.aphi_dc;
instanceStruct.d_instanceVar_aphi_dc_dX=0.0;
instanceStruct.instanceVar_bphi_dc=in.bphi_dc;
instanceStruct.d_instanceVar_bphi_dc_dX=0.0;
instanceStruct.instanceVar_phix1_dc=in.phix1_dc;
instanceStruct.d_instanceVar_phix1_dc_dX=0.0;
instanceStruct.instanceVar_alpha_b=in.alpha_b;
instanceStruct.d_instanceVar_alpha_b_dX=0.0;
instanceStruct.instanceVar_us1=in.us1;
instanceStruct.d_instanceVar_us1_dX=0.0;
instanceStruct.instanceVar_us21=in.us21;
instanceStruct.d_instanceVar_us21_dX=0.0;
instanceStruct.instanceVar_phib_ac=in.phib_ac;
instanceStruct.d_instanceVar_phib_ac_dX=0.0;
instanceStruct.instanceVar_G_0_ac=in.G_0_ac;
instanceStruct.d_instanceVar_G_0_ac_dX=0.0;
instanceStruct.instanceVar_phix_ac=in.phix_ac;
instanceStruct.d_instanceVar_phix_ac_dX=0.0;
instanceStruct.instanceVar_aphi_ac=in.aphi_ac;
instanceStruct.d_instanceVar_aphi_ac_dX=0.0;
instanceStruct.instanceVar_bphi_ac=in.bphi_ac;
instanceStruct.d_instanceVar_bphi_ac_dX=0.0;
instanceStruct.instanceVar_phix1_ac=in.phix1_ac;
instanceStruct.d_instanceVar_phix1_ac_dX=0.0;
instanceStruct.instanceVar_THER_i=in.THER_i;
instanceStruct.d_instanceVar_THER_i_dX=0.0;
instanceStruct.instanceVar_phibedge=in.phibedge;
instanceStruct.d_instanceVar_phibedge_dX=0.0;
instanceStruct.instanceVar_Gfedge=in.Gfedge;
instanceStruct.d_instanceVar_Gfedge_dX=0.0;
instanceStruct.instanceVar_phixedge=in.phixedge;
instanceStruct.d_instanceVar_phixedge_dX=0.0;
instanceStruct.instanceVar_aphiedge=in.aphiedge;
instanceStruct.d_instanceVar_aphiedge_dX=0.0;
instanceStruct.instanceVar_bphiedge=in.bphiedge;
instanceStruct.d_instanceVar_bphiedge_dX=0.0;
instanceStruct.instanceVar_phix1edge=in.phix1edge;
instanceStruct.d_instanceVar_phix1edge_dX=0.0;
instanceStruct.instanceVar_Cox_over_q=in.Cox_over_q;
instanceStruct.d_instanceVar_Cox_over_q_dX=0.0;
instanceStruct.instanceVar_qq=in.qq;
instanceStruct.d_instanceVar_qq_dX=0.0;
instanceStruct.instanceVar_E_eff0=in.E_eff0;
instanceStruct.d_instanceVar_E_eff0_dX=0.0;
instanceStruct.instanceVar_eta_mu=in.eta_mu;
instanceStruct.d_instanceVar_eta_mu_dX=0.0;
instanceStruct.instanceVar_eta_mu1=in.eta_mu1;
instanceStruct.instanceVar_inv_AX=in.inv_AX;
instanceStruct.d_instanceVar_inv_AX_dX=0.0;
instanceStruct.instanceVar_inv_VP=in.inv_VP;
instanceStruct.d_instanceVar_inv_VP_dX=0.0;
instanceStruct.instanceVar_GOV_s=in.GOV_s;
instanceStruct.d_instanceVar_GOV_s_dX=0.0;
instanceStruct.instanceVar_GOV_d=in.GOV_d;
instanceStruct.d_instanceVar_GOV_d_dX=0.0;
instanceStruct.instanceVar_GOV2_s=in.GOV2_s;
instanceStruct.d_instanceVar_GOV2_s_dX=0.0;
instanceStruct.instanceVar_GOV2_d=in.GOV2_d;
instanceStruct.d_instanceVar_GOV2_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_eps2_s=in.SP_OV_eps2_s;
instanceStruct.d_instanceVar_SP_OV_eps2_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_a_s=in.SP_OV_a_s;
instanceStruct.d_instanceVar_SP_OV_a_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_delta1_s=in.SP_OV_delta1_s;
instanceStruct.d_instanceVar_SP_OV_delta1_s_dX=0.0;
instanceStruct.instanceVar_SP_OV_eps2_d=in.SP_OV_eps2_d;
instanceStruct.d_instanceVar_SP_OV_eps2_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_a_d=in.SP_OV_a_d;
instanceStruct.d_instanceVar_SP_OV_a_d_dX=0.0;
instanceStruct.instanceVar_SP_OV_delta1_d=in.SP_OV_delta1_d;
instanceStruct.d_instanceVar_SP_OV_delta1_d_dX=0.0;
instanceStruct.instanceVar_inv_CHIB=in.inv_CHIB;
instanceStruct.d_instanceVar_inv_CHIB_dX=0.0;
instanceStruct.instanceVar_BCH=in.BCH;
instanceStruct.d_instanceVar_BCH_dX=0.0;
instanceStruct.instanceVar_BOV=in.BOV;
instanceStruct.d_instanceVar_BOV_dX=0.0;
instanceStruct.instanceVar_BOV_d=in.BOV_d;
instanceStruct.d_instanceVar_BOV_d_dX=0.0;
instanceStruct.instanceVar_GCQ=in.GCQ;
instanceStruct.d_instanceVar_GCQ_dX=0.0;
instanceStruct.instanceVar_AGIDLs=in.AGIDLs;
instanceStruct.d_instanceVar_AGIDLs_dX=0.0;
instanceStruct.instanceVar_AGIDLDs=in.AGIDLDs;
instanceStruct.d_instanceVar_AGIDLDs_dX=0.0;
instanceStruct.instanceVar_BGIDLs=in.BGIDLs;
instanceStruct.d_instanceVar_BGIDLs_dX=0.0;
instanceStruct.instanceVar_BGIDLDs=in.BGIDLDs;
instanceStruct.d_instanceVar_BGIDLDs_dX=0.0;
instanceStruct.instanceVar_fac_exc=in.fac_exc;
instanceStruct.d_instanceVar_fac_exc_dX=0.0;
instanceStruct.instanceVar_ggate=in.ggate;
instanceStruct.d_instanceVar_ggate_dX=0.0;
instanceStruct.instanceVar_gsource=in.gsource;
instanceStruct.d_instanceVar_gsource_dX=0.0;
instanceStruct.instanceVar_gdrain=in.gdrain;
instanceStruct.d_instanceVar_gdrain_dX=0.0;
instanceStruct.instanceVar_gbulk=in.gbulk;
instanceStruct.d_instanceVar_gbulk_dX=0.0;
instanceStruct.instanceVar_gjuns=in.gjuns;
instanceStruct.d_instanceVar_gjuns_dX=0.0;
instanceStruct.instanceVar_gjund=in.gjund;
instanceStruct.d_instanceVar_gjund_dX=0.0;
instanceStruct.instanceVar_gwell=in.gwell;
instanceStruct.d_instanceVar_gwell_dX=0.0;
instanceStruct.instanceVar_Sfl=in.Sfl;
instanceStruct.d_instanceVar_Sfl_dX=0.0;
instanceStruct.instanceVar_sqid=in.sqid;
instanceStruct.d_instanceVar_sqid_dX=0.0;
instanceStruct.instanceVar_mig=in.mig;
instanceStruct.d_instanceVar_mig_dX=0.0;
instanceStruct.instanceVar_CGeff=in.CGeff;
instanceStruct.d_instanceVar_CGeff_dX=0.0;
instanceStruct.instanceVar_c_igid=in.c_igid;
instanceStruct.d_instanceVar_c_igid_dX=0.0;
instanceStruct.instanceVar_shot_igcsx=in.shot_igcsx;
instanceStruct.d_instanceVar_shot_igcsx_dX=0.0;
instanceStruct.instanceVar_shot_igcdx=in.shot_igcdx;
instanceStruct.d_instanceVar_shot_igcdx_dX=0.0;
instanceStruct.instanceVar_shot_igsov=in.shot_igsov;
instanceStruct.d_instanceVar_shot_igsov_dX=0.0;
instanceStruct.instanceVar_shot_igdov=in.shot_igdov;
instanceStruct.d_instanceVar_shot_igdov_dX=0.0;
instanceStruct.instanceVar_shot_iavl=in.shot_iavl;
instanceStruct.d_instanceVar_shot_iavl_dX=0.0;
instanceStruct.instanceVar_jnoisex_s=in.jnoisex_s;
instanceStruct.d_instanceVar_jnoisex_s_dX=0.0;
instanceStruct.instanceVar_jnoisex_d=in.jnoisex_d;
instanceStruct.d_instanceVar_jnoisex_d_dX=0.0;


  //non-reals



  Linear::Vector * solVectorPtr = in.extData.nextSolVectorPtr;

  // extract solution variables
probeVars[in.admsProbeID_V_DI_GND] = (*solVectorPtr)[in.li_DI];
probeVars[in.admsProbeID_V_BS_GND] = (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_BD_GND] = (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_SI_GND] = (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_BP_GND] = (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_GP_GND] = (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_NOI_GND] = (*solVectorPtr)[in.li_NOI];
probeVars[in.admsProbeID_V_NOI2_GND] = (*solVectorPtr)[in.li_NOI2];
probeVars[in.admsProbeID_V_B_BI] = (*solVectorPtr)[in.li_B] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BD_BI] = (*solVectorPtr)[in.li_BD] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BS_BI] = (*solVectorPtr)[in.li_BS] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_BP_BI] = (*solVectorPtr)[in.li_BP] - (*solVectorPtr)[in.li_BI];
probeVars[in.admsProbeID_V_D_DI] = (*solVectorPtr)[in.li_D] - (*solVectorPtr)[in.li_DI];
probeVars[in.admsProbeID_V_S_SI] = (*solVectorPtr)[in.li_S] - (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_G_GP] = (*solVectorPtr)[in.li_G] - (*solVectorPtr)[in.li_GP];
probeVars[in.admsProbeID_V_DI_BD] = (*solVectorPtr)[in.li_DI] - (*solVectorPtr)[in.li_BD];
probeVars[in.admsProbeID_V_SI_BS] = (*solVectorPtr)[in.li_SI] - (*solVectorPtr)[in.li_BS];
probeVars[in.admsProbeID_V_SI_BP] = (*solVectorPtr)[in.li_SI] - (*solVectorPtr)[in.li_BP];
probeVars[in.admsProbeID_V_DI_SI] = (*solVectorPtr)[in.li_DI] - (*solVectorPtr)[in.li_SI];
probeVars[in.admsProbeID_V_GP_SI] = (*solVectorPtr)[in.li_GP] - (*solVectorPtr)[in.li_SI];



    // Need to use processParams-like function to process the
    // initial_model block with the LOCAL copies of
    //  model vars, and local copies of model
    // params.
evaluateInitialModel(
modelStruct,
 mod.admsModTemp,in.getDeviceOptions().gmin,in);
evaluateInitialInstance(
instanceStruct,
modelStruct,
in.admsTemperature, in.adms_vt_nom,in.getDeviceOptions().gmin,in);


// Now call  the function that does the heavy lifting.

evaluateModelEquations(
probeVars,
// probe constants
in.admsProbeID_V_DI_GND,
in.admsProbeID_V_BS_GND,
in.admsProbeID_V_BD_GND,
in.admsProbeID_V_SI_GND,
in.admsProbeID_V_BP_GND,
in.admsProbeID_V_GP_GND,
in.admsProbeID_V_NOI_GND,
in.admsProbeID_V_NOI2_GND,
in.admsProbeID_V_B_BI,
in.admsProbeID_V_BD_BI,
in.admsProbeID_V_BS_BI,
in.admsProbeID_V_BP_BI,
in.admsProbeID_V_D_DI,
in.admsProbeID_V_S_SI,
in.admsProbeID_V_G_GP,
in.admsProbeID_V_DI_BD,
in.admsProbeID_V_SI_BS,
in.admsProbeID_V_SI_BP,
in.admsProbeID_V_DI_SI,
in.admsProbeID_V_GP_SI,

// node constants
in.admsNodeID_D,
in.admsNodeID_G,
in.admsNodeID_S,
in.admsNodeID_B,
in.admsNodeID_NOI,
in.admsNodeID_NOI2,
in.admsNodeID_GP,
in.admsNodeID_SI,
in.admsNodeID_DI,
in.admsNodeID_BP,
in.admsNodeID_BI,
in.admsNodeID_BS,
in.admsNodeID_BD,
instanceStruct,
modelStruct,
 in.admsTemperature,
 in.adms_vt_nom,
 in.getDeviceOptions().gmin,
 d_staticContributions_dX,
 d_dynamicContributions_dX,
 in);


  // We now have the F and Q vector stuff, populate the dependencies:

    dfdp[in.admsNodeID_D+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_D];
    dqdp[in.admsNodeID_D+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_D];
    Findices[in.admsNodeID_D+inst*(13+0)] = in.li_D;
    Qindices[in.admsNodeID_D+inst*(13+0)] = in.li_D;
    dfdp[in.admsNodeID_G+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_G];
    dqdp[in.admsNodeID_G+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_G];
    Findices[in.admsNodeID_G+inst*(13+0)] = in.li_G;
    Qindices[in.admsNodeID_G+inst*(13+0)] = in.li_G;
    dfdp[in.admsNodeID_S+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_S];
    dqdp[in.admsNodeID_S+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_S];
    Findices[in.admsNodeID_S+inst*(13+0)] = in.li_S;
    Qindices[in.admsNodeID_S+inst*(13+0)] = in.li_S;
    dfdp[in.admsNodeID_B+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_B];
    dqdp[in.admsNodeID_B+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_B];
    Findices[in.admsNodeID_B+inst*(13+0)] = in.li_B;
    Qindices[in.admsNodeID_B+inst*(13+0)] = in.li_B;
    dfdp[in.admsNodeID_NOI+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_NOI];
    dqdp[in.admsNodeID_NOI+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_NOI];
    Findices[in.admsNodeID_NOI+inst*(13+0)] = in.li_NOI;
    Qindices[in.admsNodeID_NOI+inst*(13+0)] = in.li_NOI;
    dfdp[in.admsNodeID_NOI2+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_NOI2];
    dqdp[in.admsNodeID_NOI2+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_NOI2];
    Findices[in.admsNodeID_NOI2+inst*(13+0)] = in.li_NOI2;
    Qindices[in.admsNodeID_NOI2+inst*(13+0)] = in.li_NOI2;
    dfdp[in.admsNodeID_GP+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_GP];
    dqdp[in.admsNodeID_GP+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_GP];
    Findices[in.admsNodeID_GP+inst*(13+0)] = in.li_GP;
    Qindices[in.admsNodeID_GP+inst*(13+0)] = in.li_GP;
    dfdp[in.admsNodeID_SI+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_SI];
    dqdp[in.admsNodeID_SI+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_SI];
    Findices[in.admsNodeID_SI+inst*(13+0)] = in.li_SI;
    Qindices[in.admsNodeID_SI+inst*(13+0)] = in.li_SI;
    dfdp[in.admsNodeID_DI+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_DI];
    dqdp[in.admsNodeID_DI+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_DI];
    Findices[in.admsNodeID_DI+inst*(13+0)] = in.li_DI;
    Qindices[in.admsNodeID_DI+inst*(13+0)] = in.li_DI;
    dfdp[in.admsNodeID_BP+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_BP];
    dqdp[in.admsNodeID_BP+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_BP];
    Findices[in.admsNodeID_BP+inst*(13+0)] = in.li_BP;
    Qindices[in.admsNodeID_BP+inst*(13+0)] = in.li_BP;
    dfdp[in.admsNodeID_BI+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_BI];
    dqdp[in.admsNodeID_BI+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_BI];
    Findices[in.admsNodeID_BI+inst*(13+0)] = in.li_BI;
    Qindices[in.admsNodeID_BI+inst*(13+0)] = in.li_BI;
    dfdp[in.admsNodeID_BS+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_BS];
    dqdp[in.admsNodeID_BS+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_BS];
    Findices[in.admsNodeID_BS+inst*(13+0)] = in.li_BS;
    Qindices[in.admsNodeID_BS+inst*(13+0)] = in.li_BS;
    dfdp[in.admsNodeID_BD+inst*(13+0)] += d_staticContributions_dX[in.admsNodeID_BD];
    dqdp[in.admsNodeID_BD+inst*(13+0)] += d_dynamicContributions_dX[in.admsNodeID_BD];
    Findices[in.admsNodeID_BD+inst*(13+0)] = in.li_BD;
    Qindices[in.admsNodeID_BD+inst*(13+0)] = in.li_BD;
}

}

#endif // Xyce_ADMS_SENSITIVITIES

} // namespace ADMSPSP103VA
} // namespace Device
} // namespace Xyce
